/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var K=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/objects","vs/editor/common/core/lineRange","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ee=function(V){for(var t=[],S=0,k=V.length;S<k;S++)t[S]=K[V[S]];return t};const xe=this,We=typeof global=="object"?global:{};var he;(function(V){V.global=xe;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof V.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}V.Environment=t})(he||(he={}));var he;(function(V){class t{constructor(u,L,d){this.type=u,this.detail=L,this.timestamp=d}}V.LoaderEvent=t;class S{constructor(u){this._events=[new t(1,"",u)]}record(u,L){this._events.push(new t(u,L,V.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}V.LoaderEventRecorder=S;class k{record(u,L){}getEvents(){return[]}}k.INSTANCE=new k,V.NullLoaderEventRecorder=k})(he||(he={}));var he;(function(V){class t{static fileUriToFilePath(k,i){if(i=decodeURI(i).replace(/%23/g,"#"),k){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(k,i){return k.length>=i.length&&k.substr(0,i.length)===i}static endsWith(k,i){return k.length>=i.length&&k.substr(k.length-i.length)===i}static containsQueryString(k){return/^[^\#]*\?/gi.test(k)}static isAbsolutePath(k){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(k)}static forEachProperty(k,i){if(k){let u;for(u in k)k.hasOwnProperty(u)&&i(u,k[u])}}static isEmpty(k){let i=!0;return t.forEachProperty(k,()=>{i=!1}),i}static recursiveClone(k){if(!k||typeof k!="object"||k instanceof RegExp||!Array.isArray(k)&&Object.getPrototypeOf(k)!==Object.prototype)return k;let i=Array.isArray(k)?[]:{};return t.forEachProperty(k,(u,L)=>{L&&typeof L=="object"?i[u]=t.recursiveClone(L):i[u]=L}),i}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(k){return t.startsWith(k,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=V.global.performance&&typeof V.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?V.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,V.Utilities=t})(he||(he={}));var he;(function(V){function t(i){if(i instanceof Error)return i;const u=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(u.stack=i.stack),u}V.ensureError=t;class S{static validateConfigurationOptions(u){function L(d){if(d.phase==="loading"){console.error('Loading "'+d.moduleId+'" failed'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}if(d.phase==="factory"){console.error('The factory function of "'+d.moduleId+'" has thrown an exception'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}}if(u=u||{},typeof u.baseUrl!="string"&&(u.baseUrl=""),typeof u.isBuild!="boolean"&&(u.isBuild=!1),typeof u.paths!="object"&&(u.paths={}),typeof u.config!="object"&&(u.config={}),typeof u.catchError>"u"&&(u.catchError=!1),typeof u.recordStats>"u"&&(u.recordStats=!1),typeof u.urlArgs!="string"&&(u.urlArgs=""),typeof u.onError!="function"&&(u.onError=L),Array.isArray(u.ignoreDuplicateModules)||(u.ignoreDuplicateModules=[]),u.baseUrl.length>0&&(V.Utilities.endsWith(u.baseUrl,"/")||(u.baseUrl+="/")),typeof u.cspNonce!="string"&&(u.cspNonce=""),typeof u.preferScriptTags>"u"&&(u.preferScriptTags=!1),u.nodeCachedData&&typeof u.nodeCachedData=="object"&&(typeof u.nodeCachedData.seed!="string"&&(u.nodeCachedData.seed="seed"),(typeof u.nodeCachedData.writeDelay!="number"||u.nodeCachedData.writeDelay<0)&&(u.nodeCachedData.writeDelay=1e3*7),!u.nodeCachedData.path||typeof u.nodeCachedData.path!="string")){const d=t(new Error("INVALID cached data configuration, 'path' MUST be set"));d.phase="configuration",u.onError(d),u.nodeCachedData=void 0}return u}static mergeConfigurationOptions(u=null,L=null){let d=V.Utilities.recursiveClone(L||{});return V.Utilities.forEachProperty(u,(a,s)=>{a==="ignoreDuplicateModules"&&typeof d.ignoreDuplicateModules<"u"?d.ignoreDuplicateModules=d.ignoreDuplicateModules.concat(s):a==="paths"&&typeof d.paths<"u"?V.Utilities.forEachProperty(s,(c,E)=>d.paths[c]=E):a==="config"&&typeof d.config<"u"?V.Utilities.forEachProperty(s,(c,E)=>d.config[c]=E):d[a]=V.Utilities.recursiveClone(s)}),S.validateConfigurationOptions(d)}}V.ConfigurationOptionsUtil=S;class k{constructor(u,L){if(this._env=u,this.options=S.mergeConfigurationOptions(L),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let d=this.options.nodeRequire.main.filename,a=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let u=0;u<this.options.ignoreDuplicateModules.length;u++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[u]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],V.Utilities.forEachProperty(this.options.paths,(u,L)=>{Array.isArray(L)?this.sortedPathsRules.push({from:u,to:L}):this.sortedPathsRules.push({from:u,to:[L]})}),this.sortedPathsRules.sort((u,L)=>L.from.length-u.from.length)}cloneAndMerge(u){return new k(this._env,S.mergeConfigurationOptions(u,this.options))}getOptionsLiteral(){return this.options}_applyPaths(u){let L;for(let d=0,a=this.sortedPathsRules.length;d<a;d++)if(L=this.sortedPathsRules[d],V.Utilities.startsWith(u,L.from)){let s=[];for(let c=0,E=L.to.length;c<E;c++)s.push(L.to[c]+u.substr(L.from.length));return s}return[u]}_addUrlArgsToUrl(u){return V.Utilities.containsQueryString(u)?u+"&"+this.options.urlArgs:u+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(u){return this.options.urlArgs?this._addUrlArgsToUrl(u):u}_addUrlArgsIfNecessaryToUrls(u){if(this.options.urlArgs)for(let L=0,d=u.length;L<d;L++)u[L]=this._addUrlArgsToUrl(u[L]);return u}moduleIdToPaths(u){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(u))return this.isBuild()?["empty:"]:["node|"+u];let L=u,d;if(!V.Utilities.endsWith(L,".js")&&!V.Utilities.isAbsolutePath(L)){d=this._applyPaths(L);for(let a=0,s=d.length;a<s;a++)this.isBuild()&&d[a]==="empty:"||(V.Utilities.isAbsolutePath(d[a])||(d[a]=this.options.baseUrl+d[a]),!V.Utilities.endsWith(d[a],".js")&&!V.Utilities.containsQueryString(d[a])&&(d[a]=d[a]+".js"))}else!V.Utilities.endsWith(L,".js")&&!V.Utilities.containsQueryString(L)&&(L=L+".js"),d=[L];return this._addUrlArgsIfNecessaryToUrls(d)}requireToUrl(u){let L=u;return V.Utilities.isAbsolutePath(L)||(L=this._applyPaths(L)[0],V.Utilities.isAbsolutePath(L)||(L=this.options.baseUrl+L)),this._addUrlArgsIfNecessaryToUrl(L)}isBuild(){return this.options.isBuild}shouldInvokeFactory(u){return!!(!this.options.isBuild||V.Utilities.isAnonymousModule(u)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[u])}isDuplicateMessageIgnoredFor(u){return this.ignoreDuplicateModulesMap.hasOwnProperty(u)}getConfigForModule(u){if(this.options.config)return this.options.config[u]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(u){this.options.onError(u)}}V.Configuration=k})(he||(he={}));var he;(function(V){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,c,E,o){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new S:this._scriptLoader=new u(this._env)}else this._env.isNode?this._scriptLoader=new u(this._env):this._scriptLoader=new S;let h={callback:E,errorback:o};if(this._callbackMap.hasOwnProperty(c)){this._callbackMap[c].push(h);return}this._callbackMap[c]=[h],this._scriptLoader.load(s,c,()=>this.triggerCallback(c),e=>this.triggerErrorback(c,e))}triggerCallback(s){let c=this._callbackMap[s];delete this._callbackMap[s];for(let E=0;E<c.length;E++)c[E].callback()}triggerErrorback(s,c){let E=this._callbackMap[s];delete this._callbackMap[s];for(let o=0;o<E.length;o++)E[o].errorback(c)}}class S{attachListeners(s,c,E){let o=()=>{s.removeEventListener("load",h),s.removeEventListener("error",e)},h=N=>{o(),c()},e=N=>{o(),E(N)};s.addEventListener("load",h),s.addEventListener("error",e)}load(s,c,E,o){if(/^node\|/.test(c)){let h=s.getConfig().getOptionsLiteral(),e=L(s.getRecorder(),h.nodeRequire||V.global.nodeRequire),N=c.split("|"),R=null;try{R=e(N[1])}catch(y){o(y);return}s.enqueueDefineAnonymousModule([],()=>R),E()}else{let h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript"),this.attachListeners(h,E,o);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(c=e.createScriptURL(c)),h.setAttribute("src",c);const{cspNonce:N}=s.getConfig().getOptionsLiteral();N&&h.setAttribute("nonce",N),document.getElementsByTagName("head")[0].appendChild(h)}}}function k(a){const{trustedTypesPolicy:s}=a.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=k(s)),this._cachedCanUseEval}load(s,c,E,o){if(/^node\|/.test(c)){const h=s.getConfig().getOptionsLiteral(),e=L(s.getRecorder(),h.nodeRequire||V.global.nodeRequire),N=c.split("|");let R=null;try{R=e(N[1])}catch(y){o(y);return}s.enqueueDefineAnonymousModule([],function(){return R}),E()}else{const{trustedTypesPolicy:h}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(c).then(N=>{if(N.status!==200)throw new Error(N.statusText);return N.text()}).then(N=>{N=`${N}
//# sourceURL=${c}`,(h?self.eval(h.createScript("",N)):new Function(N)).call(self),E()}).then(void 0,o);return}try{h&&(c=h.createScriptURL(c)),importScripts(c),E()}catch(N){o(N)}}}}class u{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,c){const{nodeCachedData:E}=c.getConfig().getOptionsLiteral();if(!E||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const o=this,h=s("module");function e(N){const R=N.constructor;let y=function(M){try{return N.require(M)}finally{}};return y.resolve=function(M,g){return R._resolveFilename(M,N,!1,g)},y.resolve.paths=function(M){return R._resolveLookupPaths(M,N)},y.main=process.mainModule,y.extensions=R._extensions,y.cache=R._cache,y}h.prototype._compile=function(N,R){const y=h.wrap(N.replace(/^#!.*/,"")),b=c.getRecorder(),M=o._getCachedDataPath(E,R),g={filename:R};let m;try{const p=o._fs.readFileSync(M);m=p.slice(0,16),g.cachedData=p.slice(16),b.record(60,M)}catch{b.record(61,M)}const r=new o._vm.Script(y,g),l=r.runInThisContext(g),A=o._path.dirname(R),f=e(this),v=[this.exports,f,this,R,A,process,We,Buffer],w=l.apply(this.exports,v);return o._handleCachedData(r,y,M,!g.cachedData,c),o._verifyCachedData(r,y,M,m,c),w}}load(s,c,E,o){const h=s.getConfig().getOptionsLiteral(),e=L(s.getRecorder(),h.nodeRequire||V.global.nodeRequire),N=h.nodeInstrumenter||function(y){return y};this._init(e),this._initNodeRequire(e,s);let R=s.getRecorder();if(/^node\|/.test(c)){let y=c.split("|"),b=null;try{b=e(y[1])}catch(M){o(M);return}s.enqueueDefineAnonymousModule([],()=>b),E()}else{c=V.Utilities.fileUriToFilePath(this._env.isWindows,c);const y=this._path.normalize(c),b=this._getElectronRendererScriptPathOrUri(y),M=!!h.nodeCachedData,g=M?this._getCachedDataPath(h.nodeCachedData,c):void 0;this._readSourceAndCachedData(y,g,R,(m,r,l,A)=>{if(m){o(m);return}let f;r.charCodeAt(0)===u._BOM?f=u._PREFIX+r.substring(1)+u._SUFFIX:f=u._PREFIX+r+u._SUFFIX,f=N(f,y);const v={filename:b,cachedData:l},w=this._createAndEvalScript(s,f,v,E,o);this._handleCachedData(w,f,g,M&&!l,s),this._verifyCachedData(w,f,g,A,s)})}}_createAndEvalScript(s,c,E,o,h){const e=s.getRecorder();e.record(31,E.filename);const N=new this._vm.Script(c,E),R=N.runInThisContext(E),y=s.getGlobalAMDDefineFunc();let b=!1;const M=function(){return b=!0,y.apply(null,arguments)};return M.amd=y.amd,R.call(V.global,s.getGlobalAMDRequireFunc(),M,E.filename,this._path.dirname(E.filename)),e.record(32,E.filename),b?o():h(new Error(`Didn't receive define call in ${E.filename}!`)),N}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let c=s.match(/^([a-z])\:(.*)/i);return c?`file:///${(c[1].toUpperCase()+":"+c[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,c){const E=this._crypto.createHash("md5").update(c,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),o=this._path.basename(c).replace(/\.js$/,"");return this._path.join(s.path,`${o}-${E}.code`)}_handleCachedData(s,c,E,o,h){s.cachedDataRejected?this._fs.unlink(E,e=>{h.getRecorder().record(62,E),this._createAndWriteCachedData(s,c,E,h),e&&h.getConfig().onError(e)}):o&&this._createAndWriteCachedData(s,c,E,h)}_createAndWriteCachedData(s,c,E,o){let h=Math.ceil(o.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,N=0,R;const y=()=>{setTimeout(()=>{R||(R=this._crypto.createHash("md5").update(c,"utf8").digest());const b=s.createCachedData();if(!(b.length===0||b.length===e||N>=5)){if(b.length<e){y();return}e=b.length,this._fs.writeFile(E,Buffer.concat([R,b]),M=>{M&&o.getConfig().onError(M),o.getRecorder().record(63,E),y()})}},h*Math.pow(4,N++))};y()}_readSourceAndCachedData(s,c,E,o){if(!c)this._fs.readFile(s,{encoding:"utf8"},o);else{let h,e,N,R=2;const y=b=>{b?o(b):--R===0&&o(void 0,h,e,N)};this._fs.readFile(s,{encoding:"utf8"},(b,M)=>{h=M,y(b)}),this._fs.readFile(c,(b,M)=>{!b&&M&&M.length>0?(N=M.slice(0,16),e=M.slice(16),E.record(60,c)):E.record(61,c),y()})}}_verifyCachedData(s,c,E,o,h){o&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(c,"utf8").digest();o.equals(e)||(h.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${E}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(E,N=>{N&&h.getConfig().onError(N)}))},Math.ceil(5e3*(1+Math.random()))))}}u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`;function L(a,s){if(s.__$__isRecorded)return s;const c=function(o){a.record(33,o);try{return s(o)}finally{a.record(34,o)}};return c.__$__isRecorded=!0,c}V.ensureRecordedNodeRequire=L;function d(a){return new t(a)}V.createScriptLoader=d})(he||(he={}));var he;(function(V){class t{constructor(a){let s=a.lastIndexOf("/");s!==-1?this.fromModulePath=a.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(a){let s=a,c;for(c=/\/\.\//;c.test(s);)s=s.replace(c,"/");for(s=s.replace(/^\.\//g,""),c=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;c.test(s);)s=s.replace(c,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(a){let s=a;return V.Utilities.isAbsolutePath(s)||(V.Utilities.startsWith(s,"./")||V.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),V.ModuleIdResolver=t;class S{constructor(a,s,c,E,o,h){this.id=a,this.strId=s,this.dependencies=c,this._callback=E,this._errorback=o,this.moduleIdResolver=h,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,s){try{return{returnedValue:a.apply(V.global,s),producedError:null}}catch(c){return{returnedValue:null,producedError:c}}}static _invokeFactory(a,s,c,E){return a.shouldInvokeFactory(s)?a.shouldCatchError()?this._safeInvokeFunction(c,E):{returnedValue:c.apply(V.global,E),producedError:null}:{returnedValue:null,producedError:null}}complete(a,s,c,E){this._isComplete=!0;let o=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let h=S._invokeFactory(s,this.strId,this._callback,c);o=h.producedError,a.record(22,this.strId),!o&&typeof h.returnedValue<"u"&&(!this.exportsPassedIn||V.Utilities.isEmpty(this.exports))&&(this.exports=h.returnedValue)}else this.exports=this._callback;if(o){let h=V.ensureError(o);h.phase="factory",h.moduleId=this.strId,h.neededBy=E(this.id),this.error=h,s.onError(h)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}V.Module=S;class k{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let s=this._strModuleIdToIntModuleId.get(a);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(a,s),this._intModuleIdToStrModuleId[s]=a),s}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class i{constructor(a){this.id=a}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),V.RegularDependency=i;class u{constructor(a,s,c){this.id=a,this.pluginId=s,this.pluginParam=c}}V.PluginDependency=u;class L{constructor(a,s,c,E,o=0){this._env=a,this._scriptLoader=s,this._loaderAvailableTimestamp=o,this._defineFunc=c,this._requireFunc=E,this._moduleIdProvider=new k,this._config=new V.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new L(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,s){let c=h=>h.replace(/\\/g,"/"),E=c(a),o=s.split(/\n/);for(let h=0;h<o.length;h++){let e=o[h].match(/(.*):(\d+):(\d+)\)?$/);if(e){let N=e[1],R=e[2],y=e[3],b=Math.max(N.lastIndexOf(" ")+1,N.lastIndexOf("(")+1);if(N=N.substr(b),N=c(N),N===E){let M={line:parseInt(R,10),col:parseInt(y,10)};return M.line===1&&(M.col-=53),M}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],s=0;for(let c=0,E=this._modules2.length;c<E;c++){let o=this._modules2[c];if(!o)continue;let h=this._buildInfoPath[o.id]||null,e=this._buildInfoDefineStack[o.id]||null,N=this._buildInfoDependencies[o.id];a[s++]={id:o.strId,path:h,defineLocation:h&&e?L._findRelevantLocationInStack(h,e):null,dependencies:N,shim:null,exports:o.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new V.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=V.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let c=null;this._config.isBuild()&&(c=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:c,dependencies:a,callback:s}}defineModule(a,s,c,E,o,h=new t(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let N=new S(e,a,this._normalizeDependencies(s,h),c,E,h);this._modules2[e]=N,this._config.isBuild()&&(this._buildInfoDefineStack[e]=o,this._buildInfoDependencies[e]=(N.dependencies||[]).map(R=>this._moduleIdProvider.getStrModuleId(R.id))),this._resolve(N)}_normalizeDependency(a,s){if(a==="exports")return i.EXPORTS;if(a==="module")return i.MODULE;if(a==="require")return i.REQUIRE;let c=a.indexOf("!");if(c>=0){let E=s.resolveModule(a.substr(0,c)),o=s.resolveModule(a.substr(c+1)),h=this._moduleIdProvider.getModuleId(E+"!"+o),e=this._moduleIdProvider.getModuleId(E);return new u(h,e,o)}return new i(this._moduleIdProvider.getModuleId(s.resolveModule(a)))}_normalizeDependencies(a,s){let c=[],E=0;for(let o=0,h=a.length;o<h;o++)c[E++]=this._normalizeDependency(a[o],s);return c}_relativeRequire(a,s,c,E){if(typeof s=="string")return this.synchronousRequire(s,a);this.defineModule(V.Utilities.generateAnonymousModule(),s,c,E,null,a)}synchronousRequire(a,s=new t(a)){let c=this._normalizeDependency(a,s),E=this._modules2[c.id];if(!E)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!E.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(E.error)throw E.error;return E.exports}configure(a,s){let c=this._config.shouldRecordStats();s?this._config=new V.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!c&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),s.dependencies,s.callback,null,s.stack)}}_createLoadError(a,s){let c=this._moduleIdProvider.getStrModuleId(a),E=(this._inverseDependencies2[a]||[]).map(h=>this._moduleIdProvider.getStrModuleId(h));const o=V.ensureError(s);return o.phase="loading",o.moduleId=c,o.neededBy=E,o}_onLoadError(a,s){const c=this._createLoadError(a,s);this._modules2[a]||(this._modules2[a]=new S(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let E=[];for(let e=0,N=this._moduleIdProvider.getMaxModuleId();e<N;e++)E[e]=!1;let o=!1,h=[];for(h.push(a),E[a]=!0;h.length>0;){let e=h.shift(),N=this._modules2[e];N&&(o=N.onDependencyError(c)||o);let R=this._inverseDependencies2[e];if(R)for(let y=0,b=R.length;y<b;y++){let M=R[y];E[M]||(h.push(M),E[M]=!0)}}o||this._config.onError(c)}_hasDependencyPath(a,s){let c=this._modules2[a];if(!c)return!1;let E=[];for(let h=0,e=this._moduleIdProvider.getMaxModuleId();h<e;h++)E[h]=!1;let o=[];for(o.push(c),E[a]=!0;o.length>0;){let e=o.shift().dependencies;if(e)for(let N=0,R=e.length;N<R;N++){let y=e[N];if(y.id===s)return!0;let b=this._modules2[y.id];b&&!E[y.id]&&(E[y.id]=!0,o.push(b))}}return!1}_findCyclePath(a,s,c){if(a===s||c===50)return[a];let E=this._modules2[a];if(!E)return null;let o=E.dependencies;if(o)for(let h=0,e=o.length;h<e;h++){let N=this._findCyclePath(o[h].id,s,c+1);if(N!==null)return N.push(a),N}return null}_createRequire(a){let s=(c,E,o)=>this._relativeRequire(a,c,E,o);return s.toUrl=c=>this._config.requireToUrl(a.resolveModule(c)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(c,E=!1)=>{this.configure(c,E)},s.__$__nodeRequire=V.global.nodeRequire,s}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let s=this._moduleIdProvider.getStrModuleId(a),c=this._config.moduleIdToPaths(s),E=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||E.test(s))&&c.push("node|"+s);let o=-1,h=e=>{if(o++,o>=c.length)this._onLoadError(a,e);else{let N=c[o],R=this.getRecorder();if(this._config.isBuild()&&N==="empty:"){this._buildInfoPath[a]=N,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}R.record(10,N),this._scriptLoader.load(this,N,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=N),R.record(11,N),this._onLoad(a)},y=>{R.record(12,N),h(y)})}};h(null)}_loadPluginDependency(a,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let c=E=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],E,null,null)};c.error=E=>{this._config.onError(this._createLoadError(s.id,E))},a.load(s.pluginParam,this._createRequire(t.ROOT),c,this._config.getOptionsLiteral())}_resolve(a){let s=a.dependencies;if(s)for(let c=0,E=s.length;c<E;c++){let o=s[c];if(o===i.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(o===i.MODULE){a.unresolvedDependenciesCount--;continue}if(o===i.REQUIRE){a.unresolvedDependenciesCount--;continue}let h=this._modules2[o.id];if(h&&h.isComplete()){if(h.error){a.onDependencyError(h.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(o.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(o.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(o.id,a.id,0)||[];e.reverse(),e.push(o.id),console.warn(e.map(N=>this._moduleIdProvider.getStrModuleId(N)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[o.id]=this._inverseDependencies2[o.id]||[],this._inverseDependencies2[o.id].push(a.id),o instanceof u){let e=this._modules2[o.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,o);continue}let N=this._inversePluginDependencies2.get(o.pluginId);N||(N=[],this._inversePluginDependencies2.set(o.pluginId,N)),N.push(o),this._loadModule(o.pluginId);continue}this._loadModule(o.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let s=this.getRecorder();if(a.isComplete())return;let c=a.dependencies,E=[];if(c)for(let N=0,R=c.length;N<R;N++){let y=c[N];if(y===i.EXPORTS){E[N]=a.exports;continue}if(y===i.MODULE){E[N]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(y===i.REQUIRE){E[N]=this._createRequire(a.moduleIdResolver);continue}let b=this._modules2[y.id];if(b){E[N]=b.exports;continue}E[N]=null}const o=N=>(this._inverseDependencies2[N]||[]).map(R=>this._moduleIdProvider.getStrModuleId(R));a.complete(s,this._config,E,o);let h=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,h)for(let N=0,R=h.length;N<R;N++){let y=h[N],b=this._modules2[y];b.unresolvedDependenciesCount--,b.unresolvedDependenciesCount===0&&this._onModuleComplete(b)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let N=0,R=e.length;N<R;N++)this._loadPluginDependency(a.exports,e[N])}}}V.ModuleManager=L})(he||(he={}));var J,he;(function(V){const t=new V.Environment;let S=null;const k=function(d,a,s){typeof d!="string"&&(s=a,a=d,d=null),(typeof a!="object"||!Array.isArray(a))&&(s=a,a=null),a||(a=["require","exports","module"]),d?S.defineModule(d,a,s,null,null):S.enqueueDefineAnonymousModule(a,s)};k.amd={jQuery:!0};const i=function(d,a=!1){S.configure(d,a)},u=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return S.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){S.defineModule(V.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};u.config=i,u.getConfig=function(){return S.getConfig().getOptionsLiteral()},u.reset=function(){S=S.reset()},u.getBuildInfo=function(){return S.getBuildInfo()},u.getStats=function(){return S.getLoaderEvents()},u.define=k;function L(){if(typeof V.global.require<"u"||typeof require<"u"){const d=V.global.require||require;if(typeof d=="function"&&typeof d.resolve=="function"){const a=V.ensureRecordedNodeRequire(S.getRecorder(),d);V.global.nodeRequire=a,u.nodeRequire=a,u.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=u:(t.isElectronRenderer||(V.global.define=k),V.global.require=u)}V.init=L,(typeof V.global.define!="function"||!V.global.define.amd)&&(S=new V.ModuleManager(t,V.createScriptLoader(t),k,u,V.Utilities.getHighPerformanceTimestamp()),typeof V.global.require<"u"&&typeof V.global.require!="function"&&u.config(V.global.require),J=function(){return k.apply(null,arguments)},J.amd=k.amd,typeof doNotInitLoader>"u"&&L())})(he||(he={})),J(K[58],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function S(d,a,s,c){if(c=c||{},(c["vs/css"]||{}).disabled){s({});return}const o=a.toUrl(d+".css");k(d,o,()=>{s({})},h=>{typeof s.error=="function"&&s.error("Could not find "+o+".")})}t.load=S;function k(d,a,s,c){if(i(d,a)){s();return}u(d,a,s,c)}function i(d,a){const s=document.getElementsByTagName("link");for(let c=0,E=s.length;c<E;c++){const o=s[c].getAttribute("data-name"),h=s[c].getAttribute("href");if(o===d||h===a)return!0}return!1}function u(d,a,s,c){const E=document.createElement("link");E.setAttribute("rel","stylesheet"),E.setAttribute("type","text/css"),E.setAttribute("data-name",d),L(d,E,s,c),E.setAttribute("href",a),(document.head||document.getElementsByTagName("head")[0]).appendChild(E)}function L(d,a,s,c){const E=()=>{a.removeEventListener("load",o),a.removeEventListener("error",h)},o=e=>{E(),s()},h=e=>{E(),c(e)};a.addEventListener("load",o),a.addEventListener("error",h)}}),J("vs/nls",["require","exports"],function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let S=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const k="i-default";function i(e,N){let R;return N.length===0?R=e:R=e.replace(/\{(\d+)\}/g,(y,b)=>{const M=b[0],g=N[M];let m=y;return typeof g=="string"?m=g:(typeof g=="number"||typeof g=="boolean"||g===void 0||g===null)&&(m=String(g)),m}),S&&(R="\uFF3B"+R.replace(/[aouei]/g,"$&$&")+"\uFF3D"),R}function u(e,N){let R=e[N];return R||(R=e["*"],R)?R:null}function L(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function d(e,N,R){const y=L(e)+L(N)+"vscode/"+L(R),b=await fetch(y);if(b.ok)return await b.json();throw new Error(`${b.status} - ${b.statusText}`)}function a(e){return function(N,R){const y=Array.prototype.slice.call(arguments,2);return i(e[N],y)}}function s(e,N,...R){return i(N,R)}t.localize=s;function c(e){}t.getConfiguredDefaultLocale=c;function E(e){S=e}t.setPseudoTranslation=E;function o(e,N){return{localize:a(N[e]),getConfiguredDefaultLocale:N.getConfiguredDefaultLocale??(R=>{})}}t.create=o;function h(e,N,R,y){const b=y["vs/nls"]??{};if(!e||e.length===0)return R({localize:s,getConfiguredDefaultLocale:()=>b.availableLanguages?.["*"]});const M=b.availableLanguages?u(b.availableLanguages,e):null,g=M===null||M===k;let m=".nls";g||(m=m+"."+M);const r=l=>{Array.isArray(l)?l.localize=a(l):l.localize=a(l[e]),l.getConfiguredDefaultLocale=()=>b.availableLanguages?.["*"],R(l)};typeof b.loadBundle=="function"?b.loadBundle(e,M,(l,A)=>{l?N([e+".nls"],r):r(A)}):b.translationServiceUrl&&!g?(async()=>{try{const l=await d(b.translationServiceUrl,M,e);return r(l)}catch(l){if(!M.includes("-"))return console.error(l),N([e+".nls"],r);try{const A=M.split("-")[0],f=await d(b.translationServiceUrl,A,e);return b.availableLanguages??={},b.availableLanguages["*"]=A,r(f)}catch(A){return console.error(A),N([e+".nls"],r)}}})():N([e+m],r,l=>{if(m===".nls"){console.error("Failed trying to load default language strings",l);return}console.error(`Failed to load message bundle for language ${M}. Falling back to the default language:`,l),N([e+".nls"],r)})}t.load=h}),function(){const V=globalThis.MonacoEnvironment,t=V&&V.baseUrl?V.baseUrl:"../../../";function S(c,E){if(V?.createTrustedTypesPolicy)try{return V.createTrustedTypesPolicy(c,E)}catch(o){console.warn(o);return}try{return self.trustedTypes?.createPolicy(c,E)}catch(o){console.warn(o);return}}const k=S("amdLoader",{createScriptURL:c=>c,createScript:(c,...E)=>{const o=E.slice(0,-1).join(","),h=E.pop().toString();return`(function anonymous(${o}) { ${h}
})`}});function i(){try{return(k?globalThis.eval(k.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function u(){return new Promise((c,E)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return c();const o=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(o)&&o.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(o).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${o}`,(k?globalThis.eval(k.createScript("",e)):new Function(e)).call(globalThis),c()}).then(void 0,E);return}k?importScripts(k.createScriptURL(o)):importScripts(o),c()})}function L(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:k,amdModulesPattern:/^vs\//})}function d(c){u().then(()=>{L(),require([c],function(E){setTimeout(function(){const o=E.create((h,e)=>{globalThis.postMessage(h,e)},null);for(globalThis.onmessage=h=>o.onmessage(h.data,h.ports);s.length>0;){const h=s.shift();o.onmessage(h.data,h.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&L();let a=!0;const s=[];globalThis.onmessage=c=>{if(!a){s.push(c);return}a=!1,d(c.data)}}(),J(K[27],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function S(d,a){const s=Math.pow(10,a);return Math.round(d*s)/s}class k{constructor(a,s,c,E=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,c))|0,this.a=S(Math.max(Math.min(1,E),0),3)}static equals(a,s){return a.r===s.r&&a.g===s.g&&a.b===s.b&&a.a===s.a}}t.RGBA=k;class i{constructor(a,s,c,E){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=S(Math.max(Math.min(1,s),0),3),this.l=S(Math.max(Math.min(1,c),0),3),this.a=S(Math.max(Math.min(1,E),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.l===s.l&&a.a===s.a}static fromRGBA(a){const s=a.r/255,c=a.g/255,E=a.b/255,o=a.a,h=Math.max(s,c,E),e=Math.min(s,c,E);let N=0,R=0;const y=(e+h)/2,b=h-e;if(b>0){switch(R=Math.min(y<=.5?b/(2*y):b/(2-2*y),1),h){case s:N=(c-E)/b+(c<E?6:0);break;case c:N=(E-s)/b+2;break;case E:N=(s-c)/b+4;break}N*=60,N=Math.round(N)}return new i(N,R,y,o)}static _hue2rgb(a,s,c){return c<0&&(c+=1),c>1&&(c-=1),c<1/6?a+(s-a)*6*c:c<1/2?s:c<2/3?a+(s-a)*(2/3-c)*6:a}static toRGBA(a){const s=a.h/360,{s:c,l:E,a:o}=a;let h,e,N;if(c===0)h=e=N=E;else{const R=E<.5?E*(1+c):E+c-E*c,y=2*E-R;h=i._hue2rgb(y,R,s+1/3),e=i._hue2rgb(y,R,s),N=i._hue2rgb(y,R,s-1/3)}return new k(Math.round(h*255),Math.round(e*255),Math.round(N*255),o)}}t.HSLA=i;class u{constructor(a,s,c,E){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=S(Math.max(Math.min(1,s),0),3),this.v=S(Math.max(Math.min(1,c),0),3),this.a=S(Math.max(Math.min(1,E),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.v===s.v&&a.a===s.a}static fromRGBA(a){const s=a.r/255,c=a.g/255,E=a.b/255,o=Math.max(s,c,E),h=Math.min(s,c,E),e=o-h,N=o===0?0:e/o;let R;return e===0?R=0:o===s?R=((c-E)/e%6+6)%6:o===c?R=(E-s)/e+2:R=(s-c)/e+4,new u(Math.round(R*60),N,o,a.a)}static toRGBA(a){const{h:s,s:c,v:E,a:o}=a,h=E*c,e=h*(1-Math.abs(s/60%2-1)),N=E-h;let[R,y,b]=[0,0,0];return s<60?(R=h,y=e):s<120?(R=e,y=h):s<180?(y=h,b=e):s<240?(y=e,b=h):s<300?(R=e,b=h):s<=360&&(R=h,b=e),R=Math.round((R+N)*255),y=Math.round((y+N)*255),b=Math.round((b+N)*255),new k(R,y,b,o)}}t.HSVA=u;class L{static fromHex(a){return L.Format.CSS.parseHex(a)||L.red}static equals(a,s){return!a&&!s?!0:!a||!s?!1:a.equals(s)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:u.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof k)this.rgba=a;else if(a instanceof i)this._hsla=a,this.rgba=i.toRGBA(a);else if(a instanceof u)this._hsva=a,this.rgba=u.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&k.equals(this.rgba,a.rgba)&&i.equals(this.hsla,a.hsla)&&u.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=L._relativeLuminanceForComponent(this.rgba.r),s=L._relativeLuminanceForComponent(this.rgba.g),c=L._relativeLuminanceForComponent(this.rgba.b),E=.2126*a+.7152*s+.0722*c;return S(E,4)}static _relativeLuminanceForComponent(a){const s=a/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(a){const s=this.getRelativeLuminance(),c=a.getRelativeLuminance();return s>c?(s+.05)/(c+.05):(c+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const s=this.getRelativeLuminance(),c=a.getRelativeLuminance();return s>c}isDarkerThan(a){const s=this.getRelativeLuminance(),c=a.getRelativeLuminance();return s<c}lighten(a){return new L(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new L(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:s,g:c,b:E,a:o}=this.rgba;return new L(new k(s,c,E,o*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new L(new k(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const s=a.rgba,c=this.rgba.a,E=s.a,o=c+E*(1-c);if(o<1e-6)return L.transparent;const h=this.rgba.r*c/o+s.r*E*(1-c)/o,e=this.rgba.g*c/o+s.g*E*(1-c)/o,N=this.rgba.b*c/o+s.b*E*(1-c)/o;return new L(new k(h,e,N,o))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:s,g:c,b:E,a:o}=this.rgba;return new L(new k(a.rgba.r-o*(a.rgba.r-s),a.rgba.g-o*(a.rgba.g-c),a.rgba.b-o*(a.rgba.b-E),1))}flatten(...a){const s=a.reduceRight((c,E)=>L._flatten(E,c));return L._flatten(this,s)}static _flatten(a,s){const c=1-a.rgba.a;return new L(new k(c*s.rgba.r+a.rgba.a*a.rgba.r,c*s.rgba.g+a.rgba.a*a.rgba.g,c*s.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this._toString||(this._toString=L.Format.CSS.format(this)),this._toString}static getLighterColor(a,s,c){if(a.isLighterThan(s))return a;c=c||.5;const E=a.getRelativeLuminance(),o=s.getRelativeLuminance();return c=c*(o-E)/o,a.lighten(c)}static getDarkerColor(a,s,c){if(a.isDarkerThan(s))return a;c=c||.5;const E=a.getRelativeLuminance(),o=s.getRelativeLuminance();return c=c*(E-o)/E,a.darken(c)}}t.Color=L,L.white=new L(new k(255,255,255,1)),L.black=new L(new k(0,0,0,1)),L.red=new L(new k(255,0,0,1)),L.blue=new L(new k(0,0,255,1)),L.green=new L(new k(0,255,0,1)),L.cyan=new L(new k(0,255,255,1)),L.lightgrey=new L(new k(211,211,211,1)),L.transparent=new L(new k(0,0,0,0)),function(d){let a;(function(s){let c;(function(E){function o(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:d.Format.CSS.formatRGBA(r)}E.formatRGB=o;function h(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}E.formatRGBA=h;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:d.Format.CSS.formatHSLA(r)}E.formatHSL=e;function N(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}E.formatHSLA=N;function R(r){const l=r.toString(16);return l.length!==2?"0"+l:l}function y(r){return`#${R(r.rgba.r)}${R(r.rgba.g)}${R(r.rgba.b)}`}E.formatHex=y;function b(r,l=!1){return l&&r.rgba.a===1?d.Format.CSS.formatHex(r):`#${R(r.rgba.r)}${R(r.rgba.g)}${R(r.rgba.b)}${R(Math.round(r.rgba.a*255))}`}E.formatHexA=b;function M(r){return r.isOpaque()?d.Format.CSS.formatHex(r):d.Format.CSS.formatRGBA(r)}E.format=M;function g(r){const l=r.length;if(l===0||r.charCodeAt(0)!==35)return null;if(l===7){const A=16*m(r.charCodeAt(1))+m(r.charCodeAt(2)),f=16*m(r.charCodeAt(3))+m(r.charCodeAt(4)),v=16*m(r.charCodeAt(5))+m(r.charCodeAt(6));return new d(new k(A,f,v,1))}if(l===9){const A=16*m(r.charCodeAt(1))+m(r.charCodeAt(2)),f=16*m(r.charCodeAt(3))+m(r.charCodeAt(4)),v=16*m(r.charCodeAt(5))+m(r.charCodeAt(6)),w=16*m(r.charCodeAt(7))+m(r.charCodeAt(8));return new d(new k(A,f,v,w/255))}if(l===4){const A=m(r.charCodeAt(1)),f=m(r.charCodeAt(2)),v=m(r.charCodeAt(3));return new d(new k(16*A+A,16*f+f,16*v+v))}if(l===5){const A=m(r.charCodeAt(1)),f=m(r.charCodeAt(2)),v=m(r.charCodeAt(3)),w=m(r.charCodeAt(4));return new d(new k(16*A+A,16*f+f,16*v+v,(16*w+w)/255))}return null}E.parseHex=g;function m(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(c=s.CSS||(s.CSS={}))})(a=d.Format||(d.Format={}))}(L||(t.Color=L={}))}),J(K[28],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class S{constructor(i,u,L,d){this.originalStart=i,this.originalLength=u,this.modifiedStart=L,this.modifiedLength=d}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=S}),J(K[3],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(l){setTimeout(()=>{throw l.stack?g.isErrorNoTelemetry(l)?new g(l.message+`

`+l.stack):new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.listeners.push(l),()=>{this._removeListener(l)}}emit(l){this.listeners.forEach(A=>{A(l)})}_removeListener(l){this.listeners.splice(this.listeners.indexOf(l),1)}setUnexpectedErrorHandler(l){this.unexpectedErrorHandler=l}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(l){this.unexpectedErrorHandler(l),this.emit(l)}onUnexpectedExternalError(l){this.unexpectedErrorHandler(l)}}t.ErrorHandler=S,t.errorHandler=new S;function k(r){t.errorHandler.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=k;function i(r){if(!r||typeof r!="object")return!1;const l=r;return l.code==="EPIPE"&&l.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function u(r){s(r)||t.errorHandler.onUnexpectedError(r)}t.onUnexpectedError=u;function L(r){s(r)||t.errorHandler.onUnexpectedExternalError(r)}t.onUnexpectedExternalError=L;function d(r){if(r instanceof Error){const{name:l,message:A}=r,f=r.stacktrace||r.stack;return{$isError:!0,name:l,message:A,stack:f,noTelemetry:g.isErrorNoTelemetry(r)}}return r}t.transformErrorForSerialization=d;const a="Canceled";function s(r){return r instanceof c?!0:r instanceof Error&&r.name===a&&r.message===a}t.isCancellationError=s;class c extends Error{constructor(){super(a),this.name=this.message}}t.CancellationError=c;function E(){const r=new Error(a);return r.name=r.message,r}t.canceled=E;function o(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}t.illegalArgument=o;function h(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}t.illegalState=h;function e(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function N(r){const l=new Error(`${r} has been disposed`);return l.name="DISPOSED",l}t.disposed=N;function R(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.getErrorMessage=R;class y extends Error{constructor(l){super("NotImplemented"),l&&(this.message=l)}}t.NotImplementedError=y;class b extends Error{constructor(l){super("NotSupported"),l&&(this.message=l)}}t.NotSupportedError=b;class M extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=M;class g extends Error{constructor(l){super(l),this.name="CodeExpectedError"}static fromError(l){if(l instanceof g)return l;const A=new g;return A.message=l.message,A.stack=l.stack,A}static isErrorNoTelemetry(l){return l.name==="CodeExpectedError"}}t.ErrorNoTelemetry=g;class m extends Error{constructor(l){super(l||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}t.BugIndicatingError=m}),J(K[29],ee([0,1,3]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function k(U,O=0){return U[U.length-(1+O)]}t.tail=k;function i(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}t.tail2=i;function u(U,O,B=(x,H)=>x===H){if(U===O)return!0;if(!U||!O||U.length!==O.length)return!1;for(let x=0,H=U.length;x<H;x++)if(!B(U[x],O[x]))return!1;return!0}t.equals=u;function L(U,O){const B=U.length-1;O<B&&(U[O]=U[B]),U.pop()}t.removeFastWithoutKeepingOrder=L;function d(U,O,B){return a(U.length,x=>B(U[x],O))}t.binarySearch=d;function a(U,O){let B=0,x=U-1;for(;B<=x;){const H=(B+x)/2|0,Y=O(H);if(Y<0)B=H+1;else if(Y>0)x=H-1;else return H}return-(B+1)}t.binarySearch2=a;function s(U,O){let B=0,x=U.length;if(x===0)return 0;for(;B<x;){const H=Math.floor((B+x)/2);O(U[H])?x=H:B=H+1}return B}t.findFirstInSorted=s;function c(U,O,B){if(U=U|0,U>=O.length)throw new TypeError("invalid index");const x=O[Math.floor(O.length*Math.random())],H=[],Y=[],te=[];for(const re of O){const ue=B(re,x);ue<0?H.push(re):ue>0?Y.push(re):te.push(re)}return U<H.length?c(U,H,B):U<H.length+te.length?te[0]:c(U-(H.length+te.length),Y,B)}t.quickSelect=c;function E(U,O){const B=[];let x;for(const H of U.slice(0).sort(O))!x||O(x[0],H)!==0?(x=[H],B.push(x)):x.push(H);return B}t.groupBy=E;function o(U,O,B){const x=[];function H(re,ue,fe){if(ue===0&&fe.length===0)return;const ve=x[x.length-1];ve&&ve.start+ve.deleteCount===re?(ve.deleteCount+=ue,ve.toInsert.push(...fe)):x.push({start:re,deleteCount:ue,toInsert:fe})}let Y=0,te=0;for(;;){if(Y===U.length){H(Y,0,O.slice(te));break}if(te===O.length){H(Y,U.length-Y,[]);break}const re=U[Y],ue=O[te],fe=B(re,ue);fe===0?(Y+=1,te+=1):fe<0?(H(Y,1,[]),Y+=1):fe>0&&(H(Y,0,[ue]),te+=1)}return x}t.sortedDiff=o;function h(U,O,B){const x=o(U,O,B),H=[],Y=[];for(const te of x)H.push(...U.slice(te.start,te.start+te.deleteCount)),Y.push(...te.toInsert);return{removed:H,added:Y}}t.delta=h;function e(U,O,B){if(B===0)return[];const x=U.slice(0,B).sort(O);return R(U,O,x,B,U.length),x}t.top=e;function N(U,O,B,x,H){return B===0?Promise.resolve([]):new Promise((Y,te)=>{(async()=>{const re=U.length,ue=U.slice(0,B).sort(O);for(let fe=B,ve=Math.min(B+x,re);fe<re;fe=ve,ve=Math.min(ve+x,re)){if(fe>B&&await new Promise(De=>setTimeout(De)),H&&H.isCancellationRequested)throw new S.CancellationError;R(U,O,ue,fe,ve)}return ue})().then(Y,te)})}t.topAsync=N;function R(U,O,B,x,H){for(const Y=B.length;x<H;x++){const te=U[x];if(O(te,B[Y-1])<0){B.pop();const re=s(B,ue=>O(te,ue)<0);B.splice(re,0,te)}}}function y(U){return U.filter(O=>!!O)}t.coalesce=y;function b(U){let O=0;for(let B=0;B<U.length;B++)U[B]&&(U[O]=U[B],O+=1);U.length=O}t.coalesceInPlace=b;function M(U,O,B){U.splice(B,0,U.splice(O,1)[0])}t.move=M;function g(U){return!Array.isArray(U)||U.length===0}t.isFalsyOrEmpty=g;function m(U){return Array.isArray(U)&&U.length>0}t.isNonEmptyArray=m;function r(U,O=B=>B){const B=new Set;return U.filter(x=>{const H=O(x);return B.has(H)?!1:(B.add(H),!0)})}t.distinct=r;function l(U){const O=new Set;return B=>{const x=U(B);return O.has(x)?!1:(O.add(x),!0)}}t.uniqueFilter=l;function A(U,O){const B=f(U,O);if(B!==-1)return U[B]}t.findLast=A;function f(U,O){for(let B=U.length-1;B>=0;B--){const x=U[B];if(O(x))return B}return-1}t.lastIndex=f;function v(U,O){return U.length>0?U[0]:O}t.firstOrDefault=v;function w(U,O){return U.length>0?U[U.length-1]:O}t.lastOrDefault=w;function p(U,O,B=(x,H)=>x===H){let x=0;for(let H=0,Y=Math.min(U.length,O.length);H<Y&&B(U[H],O[H]);H++)x++;return x}t.commonPrefixLength=p;function D(U){return[].concat(...U)}t.flatten=D;function F(U,O){let B=typeof O=="number"?U:0;typeof O=="number"?B=U:(B=0,O=U);const x=[];if(B<=O)for(let H=B;H<O;H++)x.push(H);else for(let H=B;H>O;H--)x.push(H);return x}t.range=F;function P(U,O,B){return U.reduce((x,H)=>(x[O(H)]=B?B(H):H,x),Object.create(null))}t.index=P;function _(U,O){return U.push(O),()=>I(U,O)}t.insert=_;function I(U,O){const B=U.indexOf(O);if(B>-1)return U.splice(B,1),O}t.remove=I;function C(U,O,B){const x=U.slice(0,O),H=U.slice(O);return x.concat(B,H)}t.arrayInsert=C;function q(U,O){let B;if(typeof O=="number"){let x=O;B=()=>{const H=Math.sin(x++)*179426549;return H-Math.floor(H)}}else B=Math.random;for(let x=U.length-1;x>0;x-=1){const H=Math.floor(B()*(x+1)),Y=U[x];U[x]=U[H],U[H]=Y}}t.shuffle=q;function j(U,O){const B=U.indexOf(O);B>-1&&(U.splice(B,1),U.unshift(O))}t.pushToStart=j;function G(U,O){const B=U.indexOf(O);B>-1&&(U.splice(B,1),U.push(O))}t.pushToEnd=G;function X(U,O){for(const B of O)U.push(B)}t.pushMany=X;function $(U,O){return Array.isArray(U)?U.map(O):O(U)}t.mapArrayOrNot=$;function ne(U){return Array.isArray(U)?U:[U]}t.asArray=ne;function n(U){return U[Math.floor(Math.random()*U.length)]}t.getRandomElement=n;function de(U,O){for(const B of U){const x=O(B);if(x!==void 0)return x}}t.mapFind=de;function _e(U,O,B){const x=oe(U,O),H=U.length,Y=B.length;U.length=H+Y;for(let te=H-1;te>=x;te--)U[te+Y]=U[te];for(let te=0;te<Y;te++)U[te+x]=B[te]}t.insertInto=_e;function me(U,O,B,x){const H=oe(U,O),Y=U.splice(H,B);return _e(U,H,x),Y}t.splice=me;function oe(U,O){return O<0?Math.max(O+U.length,0):Math.min(O,U.length)}var Le;(function(U){function O(H){return H<0}U.isLessThan=O;function B(H){return H>0}U.isGreaterThan=B;function x(H){return H===0}U.isNeitherLessOrGreaterThan=x,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(Le||(t.CompareResult=Le={}));function pe(U,O){return(B,x)=>O(U(B),U(x))}t.compareBy=pe;function Ne(...U){return(O,B)=>{for(const x of U){const H=x(O,B);if(!Le.isNeitherLessOrGreaterThan(H))return H}return Le.neitherLessOrGreaterThan}}t.tieBreakComparators=Ne;const ye=(U,O)=>U-O;t.numberComparator=ye;function Ae(U,O){if(U.length===0)return;let B=U[0];for(let x=1;x<U.length;x++){const H=U[x];O(H,B)>0&&(B=H)}return B}t.findMaxBy=Ae;function ae(U,O){if(U.length===0)return;let B=U[0];for(let x=1;x<U.length;x++){const H=U[x];O(H,B)>=0&&(B=H)}return B}t.findLastMaxBy=ae;function le(U,O){return Ae(U,(B,x)=>-O(B,x))}t.findMinBy=le;class se{constructor(O){this.items=O,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(O){let B=this.firstIdx;for(;B<this.items.length&&O(this.items[B]);)B++;const x=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,x}takeFromEndWhile(O){let B=this.lastIdx;for(;B>=0&&O(this.items[B]);)B--;const x=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,x}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const O=this.items[this.firstIdx];return this.firstIdx++,O}removeLast(){const O=this.items[this.lastIdx];return this.lastIdx--,O}takeCount(O){const B=this.items.slice(this.firstIdx,this.firstIdx+O);return this.firstIdx+=O,B}}t.ArrayQueue=se;class ge{constructor(O){this.iterate=O}forEach(O){this.iterate(B=>(O(B),!0))}toArray(){const O=[];return this.iterate(B=>(O.push(B),!0)),O}filter(O){return new ge(B=>this.iterate(x=>O(x)?B(x):!0))}map(O){return new ge(B=>this.iterate(x=>B(O(x))))}some(O){let B=!1;return this.iterate(x=>(B=O(x),!B)),B}findFirst(O){let B;return this.iterate(x=>O(x)?(B=x,!1):!0),B}findLast(O){let B;return this.iterate(x=>(O(x)&&(B=x),!0)),B}findLastMaxBy(O){let B,x=!0;return this.iterate(H=>((x||Le.isGreaterThan(O(H,B)))&&(x=!1,B=H),!0)),B}}t.CallbackIterable=ge,ge.empty=new ge(U=>{})}),J(K[10],ee([0,1,3]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function k(a,s){if(!a)throw new Error(s?`Assertion failed (${s})`:"Assertion Failed")}t.ok=k;function i(a,s="Unreachable"){throw new Error(s)}t.assertNever=i;function u(a){if(!a)throw new S.BugIndicatingError("Assertion Failed")}t.assert=u;function L(a){if(!a()){debugger;a(),(0,S.onUnexpectedError)(new S.BugIndicatingError("Assertion Failed"))}}t.assertFn=L;function d(a,s){let c=0;for(;c<a.length-1;){const E=a[c],o=a[c+1];if(!s(E,o))return!1;c++}return!0}t.checkAdjacentItems=d}),J(K[15],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function S(k){const i=this;let u=!1,L;return function(){return u||(u=!0,L=k.apply(i,arguments)),L}}t.once=S}),J(K[16],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var S;(function(k){function i(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}k.is=i;const u=Object.freeze([]);function L(){return u}k.empty=L;function*d(g){yield g}k.single=d;function a(g){return i(g)?g:d(g)}k.wrap=a;function s(g){return g||u}k.from=s;function c(g){return!g||g[Symbol.iterator]().next().done===!0}k.isEmpty=c;function E(g){return g[Symbol.iterator]().next().value}k.first=E;function o(g,m){for(const r of g)if(m(r))return!0;return!1}k.some=o;function h(g,m){for(const r of g)if(m(r))return r}k.find=h;function*e(g,m){for(const r of g)m(r)&&(yield r)}k.filter=e;function*N(g,m){let r=0;for(const l of g)yield m(l,r++)}k.map=N;function*R(...g){for(const m of g)for(const r of m)yield r}k.concat=R;function y(g,m,r){let l=r;for(const A of g)l=m(l,A);return l}k.reduce=y;function*b(g,m,r=g.length){for(m<0&&(m+=g.length),r<0?r+=g.length:r>g.length&&(r=g.length);m<r;m++)yield g[m]}k.slice=b;function M(g,m=Number.POSITIVE_INFINITY){const r=[];if(m===0)return[r,g];const l=g[Symbol.iterator]();for(let A=0;A<m;A++){const f=l.next();if(f.done)return[r,k.empty()];r.push(f.value)}return[r,{[Symbol.iterator](){return l}}]}k.consume=M})(S||(t.Iterable=S={}))}),J(K[30],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var S;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(S||(t.KeyCode=S={}));var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(k||(t.ScanCode=k={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(N,R){this._keyCodeToStr[N]=R,this._strToKeyCode[R.toLowerCase()]=N}keyCodeToStr(N){return this._keyCodeToStr[N]}strToKeyCode(N){return this._strToKeyCode[N.toLowerCase()]||0}}const u=new i,L=new i,d=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const a=[],s=Object.create(null),c=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>c[e]||0,toEnum:e=>s[e]||0,toString:e=>a[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",N=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],R=[],y=[];for(const b of N){const[M,g,m,r,l,A,f,v,w]=b;if(y[g]||(y[g]=!0,a[g]=m,s[m]=g,c[m.toLowerCase()]=g,M&&(t.IMMUTABLE_CODE_TO_KEY_CODE[g]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[r]=g))),!R[r]){if(R[r]=!0,!l)throw new Error(`String representation missing for key code ${r} around scan code ${m}`);u.define(r,l),L.define(r,v||l),d.define(r,w||v||l)}A&&(t.EVENT_KEY_CODE_MAP[A]=r),f&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[f]=r)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var E;(function(e){function N(m){return u.keyCodeToStr(m)}e.toString=N;function R(m){return u.strToKeyCode(m)}e.fromString=R;function y(m){return L.keyCodeToStr(m)}e.toUserSettingsUS=y;function b(m){return d.keyCodeToStr(m)}e.toUserSettingsGeneral=b;function M(m){return L.strToKeyCode(m)||d.strToKeyCode(m)}e.fromUserSettings=M;function g(m){if(m>=98&&m<=113)return null;switch(m){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return u.keyCodeToStr(m)}e.toElectronAccelerator=g})(E||(t.KeyCodeUtils=E={}));var o;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(o||(t.KeyMod=o={}));function h(e,N){const R=(N&65535)<<16>>>0;return(e|R)>>>0}t.KeyChord=h}),J(K[31],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class S{constructor(i){this.executor=i,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=S}),J(K[7],ee([0,1,15,16]),function(V,t,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let u=null;function L(w){u=w}if(t.setDisposableTracker=L,i){const w="__is_disposable_tracked__";L(new class{trackDisposable(p){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{p[w]||console.log(D)},3e3)}setParent(p,D){if(p&&p!==b.None)try{p[w]=!0}catch{}}markAsDisposed(p){if(p&&p!==b.None)try{p[w]=!0}catch{}}markAsSingleton(p){}})}function d(w){return u?.trackDisposable(w),w}function a(w){u?.markAsDisposed(w)}function s(w,p){u?.setParent(w,p)}function c(w,p){if(u)for(const D of w)u.setParent(D,p)}function E(w){return u?.markAsSingleton(w),w}t.markAsSingleton=E;function o(w){return typeof w.dispose=="function"&&w.dispose.length===0}t.isDisposable=o;function h(w){if(k.Iterable.is(w)){const p=[];for(const D of w)if(D)try{D.dispose()}catch(F){p.push(F)}if(p.length===1)throw p[0];if(p.length>1)throw new AggregateError(p,"Encountered errors while disposing of store");return Array.isArray(w)?[]:w}else if(w)return w.dispose(),w}t.dispose=h;function e(w){for(const p of w)o(p)&&p.dispose();return[]}t.disposeIfDisposable=e;function N(...w){const p=R(()=>h(w));return c(w,p),p}t.combinedDisposable=N;function R(w){const p=d({dispose:(0,S.once)(()=>{a(p),w()})});return p}t.toDisposable=R;class y{constructor(){this._toDispose=new Set,this._isDisposed=!1,d(this)}dispose(){this._isDisposed||(a(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{h(this._toDispose)}finally{this._toDispose.clear()}}add(p){if(!p)return p;if(p===this)throw new Error("Cannot register a disposable on itself!");return s(p,this),this._isDisposed?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(p),p}}t.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new y,d(this),s(this._store,this)}dispose(){a(this),this._store.dispose()}_register(p){if(p===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(p)}}t.Disposable=b,b.None=Object.freeze({dispose(){}});class M{constructor(){this._isDisposed=!1,d(this)}get value(){return this._isDisposed?void 0:this._value}set value(p){this._isDisposed||p===this._value||(this._value?.dispose(),p&&s(p,this),this._value=p)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,a(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const p=this._value;return this._value=void 0,p&&s(p,null),p}}t.MutableDisposable=M;class g{constructor(p){this._disposable=p,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=g;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,d(this)}set(p){let D=p;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,a(this))},this}}t.SafeDisposable=m;class r{constructor(){this.references=new Map}acquire(p,...D){let F=this.references.get(p);F||(F={counter:0,object:this.createReferencedObject(p,...D)},this.references.set(p,F));const{object:P}=F,_=(0,S.once)(()=>{--F.counter===0&&(this.destroyReferencedObject(p,F.object),this.references.delete(p))});return F.counter++,{object:P,dispose:_}}}t.ReferenceCollection=r;class l{constructor(p){this.referenceCollection=p}async acquire(p,...D){const F=this.referenceCollection.acquire(p,...D);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(P){throw F.dispose(),P}}}t.AsyncReferenceCollection=l;class A{constructor(p){this.object=p}dispose(){}}t.ImmortalReference=A;function f(w){const p=new y;try{w(p)}finally{p.dispose()}}t.disposeOnReturn=f;class v{constructor(){this._store=new Map,this._isDisposed=!1,d(this)}dispose(){a(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{h(this._store.values())}finally{this._store.clear()}}has(p){return this._store.has(p)}get(p){return this._store.get(p)}set(p,D,F=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this._store.get(p)?.dispose(),this._store.set(p,D)}deleteAndDispose(p){this._store.get(p)?.dispose(),this._store.delete(p)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=v}),J(K[17],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class S{constructor(u){this.element=u,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class k{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){let u=this._first;for(;u!==S.Undefined;){const L=u.next;u.prev=S.Undefined,u.next=S.Undefined,u=L}this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(u){return this._insert(u,!1)}push(u){return this._insert(u,!0)}_insert(u,L){const d=new S(u);if(this._first===S.Undefined)this._first=d,this._last=d;else if(L){const s=this._last;this._last=d,d.prev=s,s.next=d}else{const s=this._first;this._first=d,d.next=s,s.prev=d}this._size+=1;let a=!1;return()=>{a||(a=!0,this._remove(d))}}shift(){if(this._first!==S.Undefined){const u=this._first.element;return this._remove(this._first),u}}pop(){if(this._last!==S.Undefined){const u=this._last.element;return this._remove(this._last),u}}_remove(u){if(u.prev!==S.Undefined&&u.next!==S.Undefined){const L=u.prev;L.next=u.next,u.next.prev=L}else u.prev===S.Undefined&&u.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):u.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):u.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let u=this._first;for(;u!==S.Undefined;)yield u.element,u=u.next}}t.LinkedList=k}),J(K[18],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const S=globalThis.performance&&typeof globalThis.performance.now=="function";class k{static create(u){return new k(u)}constructor(u){this._now=S&&u===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=k}),J(K[8],ee([0,1,3,15,7,17,18]),function(V,t,S,k,i,u,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const d=!1,a=!1;var s;(function(D){D.None=()=>i.Disposable.None;function F(U){if(a){const{onDidAddListener:O}=U,B=e.create();let x=0;U.onDidAddListener=()=>{++x===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),B.print()),O?.()}}}function P(U,O){return ne(U,()=>{},0,void 0,!0,void 0,O)}D.defer=P;function _(U){return(O,B=null,x)=>{let H=!1,Y;return Y=U(te=>{if(!H)return Y?Y.dispose():H=!0,O.call(B,te)},null,x),H&&Y.dispose(),Y}}D.once=_;function I(U,O,B){return $((x,H=null,Y)=>U(te=>x.call(H,O(te)),null,Y),B)}D.map=I;function C(U,O,B){return $((x,H=null,Y)=>U(te=>{O(te),x.call(H,te)},null,Y),B)}D.forEach=C;function q(U,O,B){return $((x,H=null,Y)=>U(te=>O(te)&&x.call(H,te),null,Y),B)}D.filter=q;function j(U){return U}D.signal=j;function G(...U){return(O,B=null,x)=>(0,i.combinedDisposable)(...U.map(H=>H(Y=>O.call(B,Y),null,x)))}D.any=G;function X(U,O,B,x){let H=B;return I(U,Y=>(H=O(H,Y),H),x)}D.reduce=X;function $(U,O){let B;const x={onWillAddFirstListener(){B=U(H.fire,H)},onDidRemoveLastListener(){B?.dispose()}};O||F(x);const H=new M(x);return O?.add(H),H.event}function ne(U,O,B=100,x=!1,H=!1,Y,te){let re,ue,fe,ve=0,De;const Te={leakWarningThreshold:Y,onWillAddFirstListener(){re=U(Ue=>{ve++,ue=O(ue,Ue),x&&!fe&&(Se.fire(ue),ue=void 0),De=()=>{const Ie=ue;ue=void 0,fe=void 0,(!x||ve>1)&&Se.fire(Ie),ve=0},typeof B=="number"?(clearTimeout(fe),fe=setTimeout(De,B)):fe===void 0&&(fe=0,queueMicrotask(De))})},onWillRemoveListener(){H&&ve>0&&De?.()},onDidRemoveLastListener(){De=void 0,re.dispose()}};te||F(Te);const Se=new M(Te);return te?.add(Se),Se.event}D.debounce=ne;function n(U,O=0,B){return D.debounce(U,(x,H)=>x?(x.push(H),x):[H],O,void 0,!0,void 0,B)}D.accumulate=n;function de(U,O=(x,H)=>x===H,B){let x=!0,H;return q(U,Y=>{const te=x||!O(Y,H);return x=!1,H=Y,te},B)}D.latch=de;function _e(U,O,B){return[D.filter(U,O,B),D.filter(U,x=>!O(x),B)]}D.split=_e;function me(U,O=!1,B=[]){let x=B.slice(),H=U(re=>{x?x.push(re):te.fire(re)});const Y=()=>{x?.forEach(re=>te.fire(re)),x=null},te=new M({onWillAddFirstListener(){H||(H=U(re=>te.fire(re)))},onDidAddFirstListener(){x&&(O?setTimeout(Y):Y())},onDidRemoveLastListener(){H&&H.dispose(),H=null}});return te.event}D.buffer=me;class oe{constructor(O){this.event=O,this.disposables=new i.DisposableStore}map(O){return new oe(I(this.event,O,this.disposables))}forEach(O){return new oe(C(this.event,O,this.disposables))}filter(O){return new oe(q(this.event,O,this.disposables))}reduce(O,B){return new oe(X(this.event,O,B,this.disposables))}latch(){return new oe(de(this.event,void 0,this.disposables))}debounce(O,B=100,x=!1,H=!1,Y){return new oe(ne(this.event,O,B,x,H,Y,this.disposables))}on(O,B,x){return this.event(O,B,x)}once(O,B,x){return _(this.event)(O,B,x)}dispose(){this.disposables.dispose()}}function Le(U){return new oe(U)}D.chain=Le;function pe(U,O,B=x=>x){const x=(...re)=>te.fire(B(...re)),H=()=>U.on(O,x),Y=()=>U.removeListener(O,x),te=new M({onWillAddFirstListener:H,onDidRemoveLastListener:Y});return te.event}D.fromNodeEventEmitter=pe;function Ne(U,O,B=x=>x){const x=(...re)=>te.fire(B(...re)),H=()=>U.addEventListener(O,x),Y=()=>U.removeEventListener(O,x),te=new M({onWillAddFirstListener:H,onDidRemoveLastListener:Y});return te.event}D.fromDOMEventEmitter=Ne;function ye(U){return new Promise(O=>_(U)(O))}D.toPromise=ye;function Ae(U,O){return O(void 0),U(B=>O(B))}D.runAndSubscribe=Ae;function ae(U,O){let B=null;function x(Y){B?.dispose(),B=new i.DisposableStore,O(Y,B)}x(void 0);const H=U(Y=>x(Y));return(0,i.toDisposable)(()=>{H.dispose(),B?.dispose()})}D.runAndSubscribeWithStore=ae;class le{constructor(O,B){this._observable=O,this._counter=0,this._hasChanged=!1;const x={onWillAddFirstListener:()=>{O.addObserver(this)},onDidRemoveLastListener:()=>{O.removeObserver(this)}};B||F(x),this.emitter=new M(x),B&&B.add(this.emitter)}beginUpdate(O){this._counter++}handlePossibleChange(O){}handleChange(O,B){this._hasChanged=!0}endUpdate(O){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function se(U,O){return new le(U,O).emitter.event}D.fromObservable=se;function ge(U){return O=>{let B=0,x=!1;const H={beginUpdate(){B++},endUpdate(){B--,B===0&&(U.reportChanges(),x&&(x=!1,O()))},handlePossibleChange(){},handleChange(){x=!0}};return U.addObserver(H),{dispose(){U.removeObserver(H)}}}}D.fromObservableLight=ge})(s||(t.Event=s={}));class c{constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${c._idPool++}`,c.all.add(this)}start(F){this._stopWatch=new L.StopWatch,this.listenerCount=F}stop(){if(this._stopWatch){const F=this._stopWatch.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=c,c.all=new Set,c._idPool=0;let E=-1;function o(D){const F=E;return E=D,{dispose(){E=F}}}t.setGlobalLeakWarningThreshold=o;class h{constructor(F,P=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=P,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(F,P){const _=this.threshold;if(_<=0||P<_)return;this._stacks||(this._stacks=new Map);const I=this._stacks.get(F.value)||0;if(this._stacks.set(F.value,I+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=_*.5;let C,q=0;for(const[j,G]of this._stacks)(!C||q<G)&&(C=j,q=G);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${q}):`),console.warn(C)}return()=>{const C=this._stacks.get(F.value)||0;this._stacks.set(F.value,C-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let N=0;class R{constructor(F){this.value=F,this.id=N++}}const y=2,b=(D,F)=>{if(D instanceof R)F(D);else for(let P=0;P<D.length;P++){const _=D[P];_&&F(_)}};class M{constructor(F){this._size=0,this._options=F,this._leakageMon=E>0||this._options?.leakWarningThreshold?new h(this._options?.leakWarningThreshold??E):void 0,this._perfMon=this._options?._profName?new c(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(d){const F=this._listeners;queueMicrotask(()=>{b(F,P=>P.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(F,P,_)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;if(this._disposed)return i.Disposable.None;P&&(F=F.bind(P));const I=new R(F);let C,q;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(I.stack=e.create(),C=this._leakageMon.check(I.stack,this._size+1)),d&&(I.stack=q??e.create()),this._listeners?this._listeners instanceof R?(this._deliveryQueue??=new m,this._listeners=[this._listeners,I]):this._listeners.push(I):(this._options?.onWillAddFirstListener?.(this),this._listeners=I,this._options?.onDidAddFirstListener?.(this)),this._size++;const j=(0,i.toDisposable)(()=>{C?.(),this._removeListener(I)});return _ instanceof i.DisposableStore?_.add(j):Array.isArray(_)&&_.push(j),j},this._event}_removeListener(F){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const P=this._listeners,_=P.indexOf(F);if(_===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,P[_]=void 0;const I=this._deliveryQueue.current===this;if(this._size*y<=P.length){let C=0;for(let q=0;q<P.length;q++)P[q]?P[C++]=P[q]:I&&(this._deliveryQueue.end--,C<this._deliveryQueue.i&&this._deliveryQueue.i--);P.length=C}}_deliver(F,P){if(!F)return;const _=this._options?.onListenerError||S.onUnexpectedError;if(!_){F.value(P);return}try{F.value(P)}catch(I){_(I)}}_deliverQueue(F){const P=F.current._listeners;for(;F.i<F.end;)this._deliver(P[F.i++],F.value);F.reset()}fire(F){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof R)this._deliver(this._listeners,F);else{const P=this._deliveryQueue;P.enqueue(this,F,this._listeners.length),this._deliverQueue(P)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=M;const g=()=>new m;t.createEventDeliveryQueue=g;class m{constructor(){this.i=-1,this.end=0}enqueue(F,P,_){this.i=0,this.end=_,this.current=F,this.value=P}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends M{async fireAsync(F,P,_){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new u.LinkedList),b(this._listeners,I=>this._asyncDeliveryQueue.push([I.value,F]));this._asyncDeliveryQueue.size>0&&!P.isCancellationRequested;){const[I,C]=this._asyncDeliveryQueue.shift(),q=[],j={...C,token:P,waitUntil:G=>{if(Object.isFrozen(q))throw new Error("waitUntil can NOT be called asynchronous");_&&(G=_(G,I)),q.push(G)}};try{I(j)}catch(G){(0,S.onUnexpectedError)(G);continue}Object.freeze(q),await Promise.allSettled(q).then(G=>{for(const X of G)X.status==="rejected"&&(0,S.onUnexpectedError)(X.reason)})}}}t.AsyncEmitter=r;class l extends M{get isPaused(){return this._isPaused!==0}constructor(F){super(F),this._isPaused=0,this._eventQueue=new u.LinkedList,this._mergeFn=F?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const F=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(F))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(F){this._size&&(this._isPaused!==0?this._eventQueue.push(F):super.fire(F))}}t.PauseableEmitter=l;class A extends l{constructor(F){super(F),this._delay=F.delay??100}fire(F){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(F)}}t.DebounceEmitter=A;class f extends M{constructor(F){super(F),this._queuedEvents=[],this._mergeFn=F?.merge}fire(F){this.hasListeners()&&(this._queuedEvents.push(F),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(P=>super.fire(P)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=f;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new M({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(F){const P={event:F,listener:null};this.events.push(P),this.hasListeners&&this.hook(P);const _=()=>{this.hasListeners&&this.unhook(P);const I=this.events.indexOf(P);this.events.splice(I,1)};return(0,i.toDisposable)((0,k.once)(_))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(F=>this.hook(F))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(F=>this.unhook(F))}hook(F){F.listener=F.event(P=>this.emitter.fire(P))}unhook(F){F.listener&&F.listener.dispose(),F.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=v;class w{constructor(){this.buffers=[]}wrapEvent(F){return(P,_,I)=>F(C=>{const q=this.buffers[this.buffers.length-1];q?q.push(()=>P.call(_,C)):P.call(_,C)},void 0,I)}bufferEvents(F){const P=[];this.buffers.push(P);const _=F();return this.buffers.pop(),P.forEach(I=>I()),_}}t.EventBufferer=w;class p{constructor(){this.listening=!1,this.inputEvent=s.None,this.inputEventListener=i.Disposable.None,this.emitter=new M({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(F){this.inputEvent=F,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=F(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=p}),J(K[19],ee([0,1,8]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const k=Object.freeze(function(d,a){const s=setTimeout(d.bind(a),0);return{dispose(){clearTimeout(s)}}});var i;(function(d){function a(s){return s===d.None||s===d.Cancelled||s instanceof u?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}d.isCancellationToken=a,d.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),d.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(i||(t.CancellationToken=i={}));class u{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(a){this._token=void 0,this._parentListener=void 0,this._parentListener=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new u),this._token}cancel(){this._token?this._token instanceof u&&this._token.cancel():this._token=i.Cancelled}dispose(a=!1){a&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof u&&this._token.dispose():this._token=i.None}}t.CancellationTokenSource=L}),J(K[32],ee([0,1,19]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class k{constructor(d){this.task=d,this.result=null}get(){if(this.result)return this.result;const d=new S.CancellationTokenSource,a=this.task(d.token);return this.result={promise:a,dispose:()=>{this.result=null,d.cancel(),d.dispose()}},this.result}}t.Cache=k;class i{constructor(d){this.fn=d,this.lastCache=void 0,this.lastArgKey=void 0}get(d){const a=JSON.stringify(d);return this.lastArgKey!==a&&(this.lastArgKey=a,this.lastCache=this.fn(d)),this.lastCache}}t.LRUCachedFunction=i;class u{get cachedValues(){return this._map}constructor(d){this.fn=d,this._map=new Map}get(d){if(this._map.has(d))return this._map.get(d);const a=this.fn(d);return this._map.set(d,a),a}}t.CachedFunction=u}),J(K[5],ee([0,1,32,31]),function(V,t,S,k){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function u(T){return!T||typeof T!="string"?!0:T.trim().length===0}t.isFalsyOrWhitespace=u;const L=/{(\d+)}/g;function d(T,...W){return W.length===0?T:T.replace(L,function(z,Q){const Z=parseInt(Q,10);return isNaN(Z)||Z<0||Z>=W.length?z:W[Z]})}t.format=d;const a=/{([^}]+)}/g;function s(T,W){return T.replace(a,(z,Q)=>W[Q]??z)}t.format2=s;function c(T){return T.replace(/[<>&]/g,function(W){switch(W){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return W}})}t.escape=c;function E(T){return T.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=E;function o(T,W){let z=0;const Q=W.charCodeAt(0);for(let Z=T.length-1;Z>=0;Z--)T.charCodeAt(Z)===Q&&z++;return z}t.count=o;function h(T,W,z="\u2026"){return T.length<=W?T:`${T.substr(0,W)}${z}`}t.truncate=h;function e(T,W=" "){const z=N(T,W);return R(z,W)}t.trim=e;function N(T,W){if(!T||!W)return T;const z=W.length;if(z===0||T.length===0)return T;let Q=0;for(;T.indexOf(W,Q)===Q;)Q=Q+z;return T.substring(Q)}t.ltrim=N;function R(T,W){if(!T||!W)return T;const z=W.length,Q=T.length;if(z===0||Q===0)return T;let Z=Q,ie=-1;for(;ie=T.lastIndexOf(W,Z-1),!(ie===-1||ie+z!==Z);){if(ie===0)return"";Z=ie}return T.substring(0,Z)}t.rtrim=R;function y(T){return T.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=y;function b(T){return T.replace(/\*/g,"")}t.stripWildcards=b;function M(T,W,z={}){if(!T)throw new Error("Cannot create regex from empty string");W||(T=E(T)),z.wholeWord&&(/\B/.test(T.charAt(0))||(T="\\b"+T),/\B/.test(T.charAt(T.length-1))||(T=T+"\\b"));let Q="";return z.global&&(Q+="g"),z.matchCase||(Q+="i"),z.multiline&&(Q+="m"),z.unicode&&(Q+="u"),new RegExp(T,Q)}t.createRegExp=M;function g(T){return T.source==="^"||T.source==="^$"||T.source==="$"||T.source==="^\\s*$"?!1:!!(T.exec("")&&T.lastIndex===0)}t.regExpLeadsToEndlessLoop=g;function m(T){return!!T.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=m;function r(T){return(T.global?"g":"")+(T.ignoreCase?"i":"")+(T.multiline?"m":"")+(T.unicode?"u":"")}t.regExpFlags=r;function l(T){return T.split(/\r\n|\r|\n/)}t.splitLines=l;function A(T){for(let W=0,z=T.length;W<z;W++){const Q=T.charCodeAt(W);if(Q!==32&&Q!==9)return W}return-1}t.firstNonWhitespaceIndex=A;function f(T,W=0,z=T.length){for(let Q=W;Q<z;Q++){const Z=T.charCodeAt(Q);if(Z!==32&&Z!==9)return T.substring(W,Q)}return T.substring(W,z)}t.getLeadingWhitespace=f;function v(T,W=T.length-1){for(let z=W;z>=0;z--){const Q=T.charCodeAt(z);if(Q!==32&&Q!==9)return z}return-1}t.lastNonWhitespaceIndex=v;function w(T,W,z){const Q=[];let Z=0;for(const ie of T.matchAll(W)){if(Q.push(T.slice(Z,ie.index)),ie.index===void 0)throw new Error("match.index should be defined");Z=ie.index+ie[0].length,Q.push(z(ie[0],...ie.slice(1),ie.index,T,ie.groups))}return Q.push(T.slice(Z)),Promise.all(Q).then(ie=>ie.join(""))}t.replaceAsync=w;function p(T,W){return T<W?-1:T>W?1:0}t.compare=p;function D(T,W,z=0,Q=T.length,Z=0,ie=W.length){for(;z<Q&&Z<ie;z++,Z++){const Re=T.charCodeAt(z),ce=W.charCodeAt(Z);if(Re<ce)return-1;if(Re>ce)return 1}const be=Q-z,Pe=ie-Z;return be<Pe?-1:be>Pe?1:0}t.compareSubstring=D;function F(T,W){return P(T,W,0,T.length,0,W.length)}t.compareIgnoreCase=F;function P(T,W,z=0,Q=T.length,Z=0,ie=W.length){for(;z<Q&&Z<ie;z++,Z++){let Re=T.charCodeAt(z),ce=W.charCodeAt(Z);if(Re===ce)continue;if(Re>=128||ce>=128)return D(T.toLowerCase(),W.toLowerCase(),z,Q,Z,ie);I(Re)&&(Re-=32),I(ce)&&(ce-=32);const we=Re-ce;if(we!==0)return we}const be=Q-z,Pe=ie-Z;return be<Pe?-1:be>Pe?1:0}t.compareSubstringIgnoreCase=P;function _(T){return T>=48&&T<=57}t.isAsciiDigit=_;function I(T){return T>=97&&T<=122}t.isLowerAsciiLetter=I;function C(T){return T>=65&&T<=90}t.isUpperAsciiLetter=C;function q(T,W){return T.length===W.length&&P(T,W)===0}t.equalsIgnoreCase=q;function j(T,W){const z=W.length;return W.length>T.length?!1:P(T,W,0,z)===0}t.startsWithIgnoreCase=j;function G(T,W){const z=Math.min(T.length,W.length);let Q;for(Q=0;Q<z;Q++)if(T.charCodeAt(Q)!==W.charCodeAt(Q))return Q;return z}t.commonPrefixLength=G;function X(T,W){const z=Math.min(T.length,W.length);let Q;const Z=T.length-1,ie=W.length-1;for(Q=0;Q<z;Q++)if(T.charCodeAt(Z-Q)!==W.charCodeAt(ie-Q))return Q;return z}t.commonSuffixLength=X;function $(T){return 55296<=T&&T<=56319}t.isHighSurrogate=$;function ne(T){return 56320<=T&&T<=57343}t.isLowSurrogate=ne;function n(T,W){return(T-55296<<10)+(W-56320)+65536}t.computeCodePoint=n;function de(T,W,z){const Q=T.charCodeAt(z);if($(Q)&&z+1<W){const Z=T.charCodeAt(z+1);if(ne(Z))return n(Q,Z)}return Q}t.getNextCodePoint=de;function _e(T,W){const z=T.charCodeAt(W-1);if(ne(z)&&W>1){const Q=T.charCodeAt(W-2);if($(Q))return n(Q,z)}return z}class me{get offset(){return this._offset}constructor(W,z=0){this._str=W,this._len=W.length,this._offset=z}setOffset(W){this._offset=W}prevCodePoint(){const W=_e(this._str,this._offset);return this._offset-=W>=65536?2:1,W}nextCodePoint(){const W=de(this._str,this._len,this._offset);return this._offset+=W>=65536?2:1,W}eol(){return this._offset>=this._len}}t.CodePointIterator=me;class oe{get offset(){return this._iterator.offset}constructor(W,z=0){this._iterator=new me(W,z)}nextGraphemeLength(){const W=Fe.getInstance(),z=this._iterator,Q=z.offset;let Z=W.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const ie=z.offset,be=W.getGraphemeBreakType(z.nextCodePoint());if(Ie(Z,be)){z.setOffset(ie);break}Z=be}return z.offset-Q}prevGraphemeLength(){const W=Fe.getInstance(),z=this._iterator,Q=z.offset;let Z=W.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const ie=z.offset,be=W.getGraphemeBreakType(z.prevCodePoint());if(Ie(be,Z)){z.setOffset(ie);break}Z=be}return Q-z.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=oe;function Le(T,W){return new oe(T,W).nextGraphemeLength()}t.nextCharLength=Le;function pe(T,W){return new oe(T,W).prevGraphemeLength()}t.prevCharLength=pe;function Ne(T,W){W>0&&ne(T.charCodeAt(W))&&W--;const z=W+Le(T,W);return[z-pe(T,z),z]}t.getCharContainingOffset=Ne;function ye(T){const W=new oe(T);let z=0;for(;!W.eol();)z++,W.nextGraphemeLength();return z}t.charCount=ye;let Ae;function ae(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function le(T){return Ae||(Ae=ae()),Ae.test(T)}t.containsRTL=le;const se=/^[\t\n\r\x20-\x7E]*$/;function ge(T){return se.test(T)}t.isBasicASCII=ge,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function U(T){return t.UNUSUAL_LINE_TERMINATORS.test(T)}t.containsUnusualLineTerminators=U;function O(T){return T>=11904&&T<=55215||T>=63744&&T<=64255||T>=65281&&T<=65374}t.isFullWidthCharacter=O;function B(T){return T>=127462&&T<=127487||T===8986||T===8987||T===9200||T===9203||T>=9728&&T<=10175||T===11088||T===11093||T>=127744&&T<=128591||T>=128640&&T<=128764||T>=128992&&T<=129008||T>=129280&&T<=129535||T>=129648&&T<=129782}t.isEmojiImprecise=B;function x(T,W){if(T.length<W)return T;const z=/\b/g;let Q=0;for(;z.test(T)&&!(T.length-z.lastIndex<W);)Q=z.lastIndex,z.lastIndex+=1;return T.substring(Q).replace(/^\s/,"")}t.lcut=x;const H=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Y=/\x1b\].*?\x07/g;function te(T){return T&&(T=T.replace(H,"").replace(Y,"")),T}t.removeAnsiEscapeCodes=te,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function re(T){return!!(T&&T.length>0&&T.charCodeAt(0)===65279)}t.startsWithUTF8BOM=re;function ue(T){return re(T)?T.substr(1):T}t.stripUTF8BOM=ue;function fe(T,W){if(!T||!W||T.length<W.length)return!1;const z=W.length,Q=T.toLowerCase();let Z=0,ie=-1;for(;Z<z;){const be=Q.indexOf(W[Z],ie+1);if(be<0)return!1;ie=be,Z++}return!0}t.fuzzyContains=fe;function ve(T,W=!1){return T?(W&&(T=T.replace(/\\./g,"")),T.toLowerCase()!==T):!1}t.containsUppercaseCharacter=ve;function De(T){return T.charAt(0).toUpperCase()+T.slice(1)}t.uppercaseFirstLetter=De;function Te(T,W=1){if(W===0)return"";let z=-1;do z=T.indexOf(`
`,z+1),W--;while(W>0&&z>=0);return z===-1?T:(T[z-1]==="\r"&&z--,T.substr(0,z))}t.getNLines=Te;function Se(T){return T=T%(2*26),T<26?String.fromCharCode(97+T):String.fromCharCode(65+T-26)}t.singleLetterHash=Se;function Ue(T){return Fe.getInstance().getGraphemeBreakType(T)}t.getGraphemeBreakType=Ue;function Ie(T,W){return T===0?W!==5&&W!==7:T===2&&W===3?!1:T===4||T===2||T===3||W===4||W===2||W===3?!0:!(T===8&&(W===8||W===9||W===11||W===12)||(T===11||T===9)&&(W===9||W===10)||(T===12||T===10)&&W===10||W===5||W===13||W===7||T===1||T===13&&W===14||T===6&&W===6)}var Be;(function(T){T[T.Other=0]="Other",T[T.Prepend=1]="Prepend",T[T.CR=2]="CR",T[T.LF=3]="LF",T[T.Control=4]="Control",T[T.Extend=5]="Extend",T[T.Regional_Indicator=6]="Regional_Indicator",T[T.SpacingMark=7]="SpacingMark",T[T.L=8]="L",T[T.V=9]="V",T[T.T=10]="T",T[T.LV=11]="LV",T[T.LVT=12]="LVT",T[T.ZWJ=13]="ZWJ",T[T.Extended_Pictographic=14]="Extended_Pictographic"})(Be||(t.GraphemeBreakType=Be={}));class Fe{static getInstance(){return Fe._INSTANCE||(Fe._INSTANCE=new Fe),Fe._INSTANCE}constructor(){this._data=Ve()}getGraphemeBreakType(W){if(W<32)return W===10?3:W===13?2:4;if(W<127)return 0;const z=this._data,Q=z.length/3;let Z=1;for(;Z<=Q;)if(W<z[3*Z])Z=2*Z;else if(W>z[3*Z+1])Z=2*Z+1;else return z[3*Z+2];return 0}}Fe._INSTANCE=null;function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(T,W){if(T===0)return 0;const z=ze(T,W);if(z!==void 0)return z;const Q=new me(W,T);return Q.prevCodePoint(),Q.offset}t.getLeftDeleteOffset=He;function ze(T,W){const z=new me(W,T);let Q=z.prevCodePoint();for(;je(Q)||Q===65039||Q===8419;){if(z.offset===0)return;Q=z.prevCodePoint()}if(!B(Q))return;let Z=z.offset;return Z>0&&z.prevCodePoint()===8205&&(Z=z.offset),Z}function je(T){return 127995<=T&&T<=127999}var qe;(function(T){T[T.zwj=8205]="zwj",T[T.emojiVariantSelector=65039]="emojiVariantSelector",T[T.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),t.noBreakWhitespace="\xA0";class Ee{static getInstance(W){return Ee.cache.get(Array.from(W))}static getLocales(){return Ee._locales.value}constructor(W){this.confusableDictionary=W}isAmbiguous(W){return this.confusableDictionary.has(W)}getPrimaryConfusable(W){return this.confusableDictionary.get(W)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=Ee,i=Ee,Ee.ambiguousCharacterData=new k.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ee.cache=new S.LRUCachedFunction(T=>{function W(ce){const we=new Map;for(let Me=0;Me<ce.length;Me+=2)we.set(ce[Me],ce[Me+1]);return we}function z(ce,we){const Me=new Map(ce);for(const[Ce,Oe]of we)Me.set(Ce,Oe);return Me}function Q(ce,we){if(!ce)return we;const Me=new Map;for(const[Ce,Oe]of ce)we.has(Ce)&&Me.set(Ce,Oe);return Me}const Z=i.ambiguousCharacterData.value;let ie=T.filter(ce=>!ce.startsWith("_")&&ce in Z);ie.length===0&&(ie=["_default"]);let be;for(const ce of ie){const we=W(Z[ce]);be=Q(be,we)}const Pe=W(Z._common),Re=z(Pe,be);return new Ee(Re)}),Ee._locales=new k.Lazy(()=>Object.keys(Ee.ambiguousCharacterData.value).filter(T=>!T.startsWith("_")));class ke{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ke.getRawData())),this._data}static isInvisibleCharacter(W){return ke.getData().has(W)}static get codePoints(){return ke.getData()}}t.InvisibleCharacters=ke,ke._data=void 0}),J(K[33],ee([0,1,5]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function k(y){return i(y,0)}t.hash=k;function i(y,b){switch(typeof y){case"object":return y===null?u(349,b):Array.isArray(y)?a(y,b):s(y,b);case"string":return d(y,b);case"boolean":return L(y,b);case"number":return u(y,b);case"undefined":return u(937,b);default:return u(617,b)}}t.doHash=i;function u(y,b){return(b<<5)-b+y|0}t.numberHash=u;function L(y,b){return u(y?433:863,b)}function d(y,b){b=u(149417,b);for(let M=0,g=y.length;M<g;M++)b=u(y.charCodeAt(M),b);return b}t.stringHash=d;function a(y,b){return b=u(104579,b),y.reduce((M,g)=>i(g,M),b)}function s(y,b){return b=u(181387,b),Object.keys(y).sort().reduce((M,g)=>(M=d(g,M),i(y[g],M)),b)}class c{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=i(b,this._value),this._value}}t.Hasher=c;var E;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function o(y,b,M=32){const g=M-b,m=~((1<<g)-1);return(y<<b|(m&y)>>>g)>>>0}function h(y,b=0,M=y.byteLength,g=0){for(let m=0;m<M;m++)y[b+m]=g}function e(y,b,M="0"){for(;y.length<b;)y=M+y;return y}function N(y,b=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(M=>M.toString(16).padStart(2,"0")).join(""):e((y>>>0).toString(16),b/4)}t.toHexString=N;class R{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const M=b.length;if(M===0)return;const g=this._buff;let m=this._buffLen,r=this._leftoverHighSurrogate,l,A;for(r!==0?(l=r,A=-1,r=0):(l=b.charCodeAt(0),A=0);;){let f=l;if(S.isHighSurrogate(l))if(A+1<M){const v=b.charCodeAt(A+1);S.isLowSurrogate(v)?(A++,f=S.computeCodePoint(l,v)):f=65533}else{r=l;break}else S.isLowSurrogate(l)&&(f=65533);if(m=this._push(g,m,f),A++,A<M)l=b.charCodeAt(A);else break}this._buffLen=m,this._leftoverHighSurrogate=r}_push(b,M,g){return g<128?b[M++]=g:g<2048?(b[M++]=192|(g&1984)>>>6,b[M++]=128|(g&63)>>>0):g<65536?(b[M++]=224|(g&61440)>>>12,b[M++]=128|(g&4032)>>>6,b[M++]=128|(g&63)>>>0):(b[M++]=240|(g&1835008)>>>18,b[M++]=128|(g&258048)>>>12,b[M++]=128|(g&4032)>>>6,b[M++]=128|(g&63)>>>0),M>=64&&(this._step(),M-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),M}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),N(this._h0)+N(this._h1)+N(this._h2)+N(this._h3)+N(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=R._bigBlock32,M=this._buffDV;for(let p=0;p<64;p+=4)b.setUint32(p,M.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)b.setUint32(p,o(b.getUint32(p-12,!1)^b.getUint32(p-32,!1)^b.getUint32(p-56,!1)^b.getUint32(p-64,!1),1),!1);let g=this._h0,m=this._h1,r=this._h2,l=this._h3,A=this._h4,f,v,w;for(let p=0;p<80;p++)p<20?(f=m&r|~m&l,v=1518500249):p<40?(f=m^r^l,v=1859775393):p<60?(f=m&r|m&l|r&l,v=2400959708):(f=m^r^l,v=3395469782),w=o(g,5)+f+A+v+b.getUint32(p*4,!1)&4294967295,A=l,l=r,r=o(m,30),m=g,g=w;this._h0=this._h0+g&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+A&4294967295}}t.StringSHA1=R,R._bigBlock32=new DataView(new ArrayBuffer(320))}),J(K[20],ee([0,1,28,33]),function(V,t,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(o){this.source=o}getElements(){const o=this.source,h=new Int32Array(o.length);for(let e=0,N=o.length;e<N;e++)h[e]=o.charCodeAt(e);return h}}t.StringDiffSequence=i;function u(E,o,h){return new c(new i(E),new i(o)).ComputeDiff(h).changes}t.stringDiff=u;class L{static Assert(o,h){if(!o)throw new Error(h)}}class d{static Copy(o,h,e,N,R){for(let y=0;y<R;y++)e[N+y]=o[h+y]}static Copy2(o,h,e,N,R){for(let y=0;y<R;y++)e[N+y]=o[h+y]}}var a;(function(E){E[E.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class s{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new S.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(o,h){this.m_originalStart=Math.min(this.m_originalStart,o),this.m_modifiedStart=Math.min(this.m_modifiedStart,h),this.m_originalCount++}AddModifiedElement(o,h){this.m_originalStart=Math.min(this.m_originalStart,o),this.m_modifiedStart=Math.min(this.m_modifiedStart,h),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class c{constructor(o,h,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=o,this._modifiedSequence=h;const[N,R,y]=c._getElements(o),[b,M,g]=c._getElements(h);this._hasStrings=y&&g,this._originalStringElements=N,this._originalElementsOrHash=R,this._modifiedStringElements=b,this._modifiedElementsOrHash=M,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(o){return o.length>0&&typeof o[0]=="string"}static _getElements(o){const h=o.getElements();if(c._isStringArray(h)){const e=new Int32Array(h.length);for(let N=0,R=h.length;N<R;N++)e[N]=(0,k.stringHash)(h[N],0);return[h,e,!0]}return h instanceof Int32Array?[[],h,!1]:[[],new Int32Array(h),!1]}ElementsAreEqual(o,h){return this._originalElementsOrHash[o]!==this._modifiedElementsOrHash[h]?!1:this._hasStrings?this._originalStringElements[o]===this._modifiedStringElements[h]:!0}ElementsAreStrictEqual(o,h){if(!this.ElementsAreEqual(o,h))return!1;const e=c._getStrictElement(this._originalSequence,o),N=c._getStrictElement(this._modifiedSequence,h);return e===N}static _getStrictElement(o,h){return typeof o.getStrictElement=="function"?o.getStrictElement(h):null}OriginalElementsAreEqual(o,h){return this._originalElementsOrHash[o]!==this._originalElementsOrHash[h]?!1:this._hasStrings?this._originalStringElements[o]===this._originalStringElements[h]:!0}ModifiedElementsAreEqual(o,h){return this._modifiedElementsOrHash[o]!==this._modifiedElementsOrHash[h]?!1:this._hasStrings?this._modifiedStringElements[o]===this._modifiedStringElements[h]:!0}ComputeDiff(o){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,o)}_ComputeDiff(o,h,e,N,R){const y=[!1];let b=this.ComputeDiffRecursive(o,h,e,N,y);return R&&(b=this.PrettifyChanges(b)),{quitEarly:y[0],changes:b}}ComputeDiffRecursive(o,h,e,N,R){for(R[0]=!1;o<=h&&e<=N&&this.ElementsAreEqual(o,e);)o++,e++;for(;h>=o&&N>=e&&this.ElementsAreEqual(h,N);)h--,N--;if(o>h||e>N){let r;return e<=N?(L.Assert(o===h+1,"originalStart should only be one more than originalEnd"),r=[new S.DiffChange(o,0,e,N-e+1)]):o<=h?(L.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),r=[new S.DiffChange(o,h-o+1,e,0)]):(L.Assert(o===h+1,"originalStart should only be one more than originalEnd"),L.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const y=[0],b=[0],M=this.ComputeRecursionPoint(o,h,e,N,y,b,R),g=y[0],m=b[0];if(M!==null)return M;if(!R[0]){const r=this.ComputeDiffRecursive(o,g,e,m,R);let l=[];return R[0]?l=[new S.DiffChange(g+1,h-(g+1)+1,m+1,N-(m+1)+1)]:l=this.ComputeDiffRecursive(g+1,h,m+1,N,R),this.ConcatenateChanges(r,l)}return[new S.DiffChange(o,h-o+1,e,N-e+1)]}WALKTRACE(o,h,e,N,R,y,b,M,g,m,r,l,A,f,v,w,p,D){let F=null,P=null,_=new s,I=h,C=e,q=A[0]-w[0]-N,j=-1073741824,G=this.m_forwardHistory.length-1;do{const X=q+o;X===I||X<C&&g[X-1]<g[X+1]?(r=g[X+1],f=r-q-N,r<j&&_.MarkNextChange(),j=r,_.AddModifiedElement(r+1,f),q=X+1-o):(r=g[X-1]+1,f=r-q-N,r<j&&_.MarkNextChange(),j=r-1,_.AddOriginalElement(r,f+1),q=X-1-o),G>=0&&(g=this.m_forwardHistory[G],o=g[0],I=1,C=g.length-1)}while(--G>=-1);if(F=_.getReverseChanges(),D[0]){let X=A[0]+1,$=w[0]+1;if(F!==null&&F.length>0){const ne=F[F.length-1];X=Math.max(X,ne.getOriginalEnd()),$=Math.max($,ne.getModifiedEnd())}P=[new S.DiffChange(X,l-X+1,$,v-$+1)]}else{_=new s,I=y,C=b,q=A[0]-w[0]-M,j=1073741824,G=p?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const X=q+R;X===I||X<C&&m[X-1]>=m[X+1]?(r=m[X+1]-1,f=r-q-M,r>j&&_.MarkNextChange(),j=r+1,_.AddOriginalElement(r+1,f+1),q=X+1-R):(r=m[X-1],f=r-q-M,r>j&&_.MarkNextChange(),j=r,_.AddModifiedElement(r+1,f+1),q=X-1-R),G>=0&&(m=this.m_reverseHistory[G],R=m[0],I=1,C=m.length-1)}while(--G>=-1);P=_.getChanges()}return this.ConcatenateChanges(F,P)}ComputeRecursionPoint(o,h,e,N,R,y,b){let M=0,g=0,m=0,r=0,l=0,A=0;o--,e--,R[0]=0,y[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const f=h-o+(N-e),v=f+1,w=new Int32Array(v),p=new Int32Array(v),D=N-e,F=h-o,P=o-e,_=h-N,C=(F-D)%2===0;w[D]=o,p[F]=h,b[0]=!1;for(let q=1;q<=f/2+1;q++){let j=0,G=0;m=this.ClipDiagonalBound(D-q,q,D,v),r=this.ClipDiagonalBound(D+q,q,D,v);for(let $=m;$<=r;$+=2){$===m||$<r&&w[$-1]<w[$+1]?M=w[$+1]:M=w[$-1]+1,g=M-($-D)-P;const ne=M;for(;M<h&&g<N&&this.ElementsAreEqual(M+1,g+1);)M++,g++;if(w[$]=M,M+g>j+G&&(j=M,G=g),!C&&Math.abs($-F)<=q-1&&M>=p[$])return R[0]=M,y[0]=g,ne<=p[$]&&1447>0&&q<=1447+1?this.WALKTRACE(D,m,r,P,F,l,A,_,w,p,M,h,R,g,N,y,C,b):null}const X=(j-o+(G-e)-q)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(j,X))return b[0]=!0,R[0]=j,y[0]=G,X>0&&1447>0&&q<=1447+1?this.WALKTRACE(D,m,r,P,F,l,A,_,w,p,M,h,R,g,N,y,C,b):(o++,e++,[new S.DiffChange(o,h-o+1,e,N-e+1)]);l=this.ClipDiagonalBound(F-q,q,F,v),A=this.ClipDiagonalBound(F+q,q,F,v);for(let $=l;$<=A;$+=2){$===l||$<A&&p[$-1]>=p[$+1]?M=p[$+1]-1:M=p[$-1],g=M-($-F)-_;const ne=M;for(;M>o&&g>e&&this.ElementsAreEqual(M,g);)M--,g--;if(p[$]=M,C&&Math.abs($-D)<=q&&M<=w[$])return R[0]=M,y[0]=g,ne>=w[$]&&1447>0&&q<=1447+1?this.WALKTRACE(D,m,r,P,F,l,A,_,w,p,M,h,R,g,N,y,C,b):null}if(q<=1447){let $=new Int32Array(r-m+2);$[0]=D-m+1,d.Copy2(w,m,$,1,r-m+1),this.m_forwardHistory.push($),$=new Int32Array(A-l+2),$[0]=F-l+1,d.Copy2(p,l,$,1,A-l+1),this.m_reverseHistory.push($)}}return this.WALKTRACE(D,m,r,P,F,l,A,_,w,p,M,h,R,g,N,y,C,b)}PrettifyChanges(o){for(let h=0;h<o.length;h++){const e=o[h],N=h<o.length-1?o[h+1].originalStart:this._originalElementsOrHash.length,R=h<o.length-1?o[h+1].modifiedStart:this._modifiedElementsOrHash.length,y=e.originalLength>0,b=e.modifiedLength>0;for(;e.originalStart+e.originalLength<N&&e.modifiedStart+e.modifiedLength<R&&(!y||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!b||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const g=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!g)break;e.originalStart++,e.modifiedStart++}const M=[null];if(h<o.length-1&&this.ChangesOverlap(o[h],o[h+1],M)){o[h]=M[0],o.splice(h+1,1),h--;continue}}for(let h=o.length-1;h>=0;h--){const e=o[h];let N=0,R=0;if(h>0){const r=o[h-1];N=r.originalStart+r.originalLength,R=r.modifiedStart+r.modifiedLength}const y=e.originalLength>0,b=e.modifiedLength>0;let M=0,g=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const l=e.originalStart-r,A=e.modifiedStart-r;if(l<N||A<R||y&&!this.OriginalElementsAreEqual(l,l+e.originalLength)||b&&!this.ModifiedElementsAreEqual(A,A+e.modifiedLength))break;const v=(l===N&&A===R?5:0)+this._boundaryScore(l,e.originalLength,A,e.modifiedLength);v>g&&(g=v,M=r)}e.originalStart-=M,e.modifiedStart-=M;const m=[null];if(h>0&&this.ChangesOverlap(o[h-1],o[h],m)){o[h-1]=m[0],o.splice(h,1),h++;continue}}if(this._hasStrings)for(let h=1,e=o.length;h<e;h++){const N=o[h-1],R=o[h],y=R.originalStart-N.originalStart-N.originalLength,b=N.originalStart,M=R.originalStart+R.originalLength,g=M-b,m=N.modifiedStart,r=R.modifiedStart+R.modifiedLength,l=r-m;if(y<5&&g<20&&l<20){const A=this._findBetterContiguousSequence(b,g,m,l,y);if(A){const[f,v]=A;(f!==N.originalStart+N.originalLength||v!==N.modifiedStart+N.modifiedLength)&&(N.originalLength=f-N.originalStart,N.modifiedLength=v-N.modifiedStart,R.originalStart=f+y,R.modifiedStart=v+y,R.originalLength=M-R.originalStart,R.modifiedLength=r-R.modifiedStart)}}}return o}_findBetterContiguousSequence(o,h,e,N,R){if(h<R||N<R)return null;const y=o+h-R+1,b=e+N-R+1;let M=0,g=0,m=0;for(let r=o;r<y;r++)for(let l=e;l<b;l++){const A=this._contiguousSequenceScore(r,l,R);A>0&&A>M&&(M=A,g=r,m=l)}return M>0?[g,m]:null}_contiguousSequenceScore(o,h,e){let N=0;for(let R=0;R<e;R++){if(!this.ElementsAreEqual(o+R,h+R))return 0;N+=this._originalStringElements[o+R].length}return N}_OriginalIsBoundary(o){return o<=0||o>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[o])}_OriginalRegionIsBoundary(o,h){if(this._OriginalIsBoundary(o)||this._OriginalIsBoundary(o-1))return!0;if(h>0){const e=o+h;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(o){return o<=0||o>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[o])}_ModifiedRegionIsBoundary(o,h){if(this._ModifiedIsBoundary(o)||this._ModifiedIsBoundary(o-1))return!0;if(h>0){const e=o+h;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(o,h,e,N){const R=this._OriginalRegionIsBoundary(o,h)?1:0,y=this._ModifiedRegionIsBoundary(e,N)?1:0;return R+y}ConcatenateChanges(o,h){const e=[];if(o.length===0||h.length===0)return h.length>0?h:o;if(this.ChangesOverlap(o[o.length-1],h[0],e)){const N=new Array(o.length+h.length-1);return d.Copy(o,0,N,0,o.length-1),N[o.length-1]=e[0],d.Copy(h,1,N,o.length,h.length-1),N}else{const N=new Array(o.length+h.length);return d.Copy(o,0,N,0,o.length),d.Copy(h,0,N,o.length,h.length),N}}ChangesOverlap(o,h,e){if(L.Assert(o.originalStart<=h.originalStart,"Left change is not less than or equal to right change"),L.Assert(o.modifiedStart<=h.modifiedStart,"Left change is not less than or equal to right change"),o.originalStart+o.originalLength>=h.originalStart||o.modifiedStart+o.modifiedLength>=h.modifiedStart){const N=o.originalStart;let R=o.originalLength;const y=o.modifiedStart;let b=o.modifiedLength;return o.originalStart+o.originalLength>=h.originalStart&&(R=h.originalStart+h.originalLength-o.originalStart),o.modifiedStart+o.modifiedLength>=h.modifiedStart&&(b=h.modifiedStart+h.modifiedLength-o.modifiedStart),e[0]=new S.DiffChange(N,R,y,b),!0}else return e[0]=null,!1}ClipDiagonalBound(o,h,e,N){if(o>=0&&o<N)return o;const R=e,y=N-e-1,b=h%2===0;if(o<0){const M=R%2===0;return b===M?0:1}else{const M=y%2===0;return b===M?N-1:N-2}}}t.LcsDiff=c}),J(K[21],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function S(l){return typeof l=="string"}t.isString=S;function k(l){return Array.isArray(l)&&l.every(A=>S(A))}t.isStringArray=k;function i(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}t.isObject=i;function u(l){const A=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof A}t.isTypedArray=u;function L(l){return typeof l=="number"&&!isNaN(l)}t.isNumber=L;function d(l){return!!l&&typeof l[Symbol.iterator]=="function"}t.isIterable=d;function a(l){return l===!0||l===!1}t.isBoolean=a;function s(l){return typeof l>"u"}t.isUndefined=s;function c(l){return!E(l)}t.isDefined=c;function E(l){return s(l)||l===null}t.isUndefinedOrNull=E;function o(l,A){if(!l)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}t.assertType=o;function h(l){if(E(l))throw new Error("Assertion Failed: argument is undefined or null");return l}t.assertIsDefined=h;function e(...l){const A=[];for(let f=0;f<l.length;f++){const v=l[f];if(E(v))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);A.push(v)}return A}t.assertAllDefined=e;const N=Object.prototype.hasOwnProperty;function R(l){if(!i(l))return!1;for(const A in l)if(N.call(l,A))return!1;return!0}t.isEmptyObject=R;function y(l){return typeof l=="function"}t.isFunction=y;function b(...l){return l.length>0&&l.every(y)}t.areFunctions=b;function M(l,A){const f=Math.min(l.length,A.length);for(let v=0;v<f;v++)g(l[v],A[v])}t.validateConstraints=M;function g(l,A){if(S(A)){if(typeof l!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(y(A)){try{if(l instanceof A)return}catch{}if(!E(l)&&l.constructor===A||A.length===1&&A.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=g;function m(l){return l===null?void 0:l}t.withNullAsUndefined=m;function r(l){return typeof l>"u"?null:l}t.withUndefinedAsNull=r}),J(K[34],ee([0,1,21]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const k=Object.create(null);function i(d,a){if((0,S.isString)(a)){const s=k[a];if(s===void 0)throw new Error(`${d} references an unknown codicon: ${a}`);a=s}return k[d]=a,{id:d}}function u(){return k}t.getCodiconFontCharacters=u;function L(){return Object.values(t.Codicon)}t.getAllCodicons=L,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),J(K[11],ee([0,1,21]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function k(y){if(!y||typeof y!="object"||y instanceof RegExp)return y;const b=Array.isArray(y)?[]:{};return Object.entries(y).forEach(([M,g])=>{b[M]=g&&typeof g=="object"?k(g):g}),b}t.deepClone=k;function i(y){if(!y||typeof y!="object")return y;const b=[y];for(;b.length>0;){const M=b.shift();Object.freeze(M);for(const g in M)if(u.call(M,g)){const m=M[g];typeof m=="object"&&!Object.isFrozen(m)&&!(0,S.isTypedArray)(m)&&b.push(m)}}return y}t.deepFreeze=i;const u=Object.prototype.hasOwnProperty;function L(y,b){return d(y,b,new Set)}t.cloneAndChange=L;function d(y,b,M){if((0,S.isUndefinedOrNull)(y))return y;const g=b(y);if(typeof g<"u")return g;if(Array.isArray(y)){const m=[];for(const r of y)m.push(d(r,b,M));return m}if((0,S.isObject)(y)){if(M.has(y))throw new Error("Cannot clone recursive data-structure");M.add(y);const m={};for(const r in y)u.call(y,r)&&(m[r]=d(y[r],b,M));return M.delete(y),m}return y}function a(y,b,M=!0){return(0,S.isObject)(y)?((0,S.isObject)(b)&&Object.keys(b).forEach(g=>{g in y?M&&((0,S.isObject)(y[g])&&(0,S.isObject)(b[g])?a(y[g],b[g],M):y[g]=b[g]):y[g]=b[g]}),y):b}t.mixin=a;function s(y,b){if(y===b)return!0;if(y==null||b===null||b===void 0||typeof y!=typeof b||typeof y!="object"||Array.isArray(y)!==Array.isArray(b))return!1;let M,g;if(Array.isArray(y)){if(y.length!==b.length)return!1;for(M=0;M<y.length;M++)if(!s(y[M],b[M]))return!1}else{const m=[];for(g in y)m.push(g);m.sort();const r=[];for(g in b)r.push(g);if(r.sort(),!s(m,r))return!1;for(M=0;M<m.length;M++)if(!s(y[m[M]],b[m[M]]))return!1}return!0}t.equals=s;function c(y){const b=new Set;return JSON.stringify(y,(M,g)=>{if((0,S.isObject)(g)||Array.isArray(g)){if(b.has(g))return"[Circular]";b.add(g)}return g})}t.safeStringify=c;function E(y,b){const M=Object.create(null);return!y||!b||Object.keys(b).forEach(m=>{const r=y[m],l=b[m];s(r,l)||(M[m]=l)}),M}t.distinct=E;function o(y,b){const M=b.toLowerCase(),g=Object.keys(y).find(m=>m.toLowerCase()===M);return g?y[g]:y[b]}t.getCaseInsensitive=o;function h(y,b){const M=Object.create(null);for(const[g,m]of Object.entries(y))b(g,m)&&(M[g]=m);return M}t.filter=h;function e(y){let b=[],M=Object.getPrototypeOf(y);for(;Object.prototype!==M;)b=b.concat(Object.getOwnPropertyNames(M)),M=Object.getPrototypeOf(M);return b}t.getAllPropertyNames=e;function N(y){const b=[];for(const M of e(y))typeof y[M]=="function"&&b.push(M);return b}t.getAllMethodNames=N;function R(y,b){const M=m=>function(){const r=Array.prototype.slice.call(arguments,0);return b(m,r)},g={};for(const m of y)g[m]=M(m);return g}t.createProxyObject=R}),J(K[22],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var S;(function(u){u[u.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",u[u.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",u[u.MAX_UINT_8=255]="MAX_UINT_8",u[u.MAX_UINT_16=65535]="MAX_UINT_16",u[u.MAX_UINT_32=4294967295]="MAX_UINT_32",u[u.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(S||(t.Constants=S={}));function k(u){return u<0?0:u>255?255:u|0}t.toUint8=k;function i(u){return u<0?0:u>4294967295?4294967295:u|0}t.toUint32=i}),J(K[23],ee([0,1,22]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class k{constructor(d){const a=(0,S.toUint8)(d);this._defaultValue=a,this._asciiMap=k._createAsciiMap(a),this._map=new Map}static _createAsciiMap(d){const a=new Uint8Array(256);return a.fill(d),a}set(d,a){const s=(0,S.toUint8)(a);d>=0&&d<256?this._asciiMap[d]=s:this._map.set(d,s)}get(d){return d>=0&&d<256?this._asciiMap[d]:this._map.get(d)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}t.CharacterClassifier=k;var i;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(i||(i={}));class u{constructor(){this._actual=new k(0)}add(d){this._actual.set(d,1)}has(d){return this._actual.get(d)===1}clear(){return this._actual.clear()}}t.CharacterSet=u}),J(K[6],ee([0,1,3]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRange=void 0;class k{static addRange(u,L){let d=0;for(;d<L.length&&L[d].endExclusive<u.start;)d++;let a=d;for(;a<L.length&&L[a].start<=u.endExclusive;)a++;if(d===a)L.splice(d,0,u);else{const s=Math.min(u.start,L[d].start),c=Math.max(u.endExclusive,L[a-1].endExclusive);L.splice(d,a-d,new k(s,c))}}static tryCreate(u,L){if(!(u>L))return new k(u,L)}constructor(u,L){if(this.start=u,this.endExclusive=L,u>L)throw new S.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(u){return new k(this.start+u,this.endExclusive+u)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(u){return this.start===u.start&&this.endExclusive===u.endExclusive}containsRange(u){return this.start<=u.start&&u.endExclusive<=this.endExclusive}contains(u){return this.start<=u&&u<this.endExclusive}join(u){return new k(Math.min(this.start,u.start),Math.max(this.endExclusive,u.endExclusive))}intersect(u){const L=Math.max(this.start,u.start),d=Math.min(this.endExclusive,u.endExclusive);if(L<=d)return new k(L,d)}}t.OffsetRange=k}),J(K[4],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class S{constructor(i,u){this.lineNumber=i,this.column=u}with(i=this.lineNumber,u=this.column){return i===this.lineNumber&&u===this.column?this:new S(i,u)}delta(i=0,u=0){return this.with(this.lineNumber+i,this.column+u)}equals(i){return S.equals(this,i)}static equals(i,u){return!i&&!u?!0:!!i&&!!u&&i.lineNumber===u.lineNumber&&i.column===u.column}isBefore(i){return S.isBefore(this,i)}static isBefore(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<u.column}isBeforeOrEqual(i){return S.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<=u.column}static compare(i,u){const L=i.lineNumber|0,d=u.lineNumber|0;if(L===d){const a=i.column|0,s=u.column|0;return a-s}return L-d}clone(){return new S(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new S(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}t.Position=S}),J(K[2],ee([0,1,4]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class k{constructor(u,L,d,a){u>d||u===d&&L>a?(this.startLineNumber=d,this.startColumn=a,this.endLineNumber=u,this.endColumn=L):(this.startLineNumber=u,this.startColumn=L,this.endLineNumber=d,this.endColumn=a)}isEmpty(){return k.isEmpty(this)}static isEmpty(u){return u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn}containsPosition(u){return k.containsPosition(this,u)}static containsPosition(u,L){return!(L.lineNumber<u.startLineNumber||L.lineNumber>u.endLineNumber||L.lineNumber===u.startLineNumber&&L.column<u.startColumn||L.lineNumber===u.endLineNumber&&L.column>u.endColumn)}static strictContainsPosition(u,L){return!(L.lineNumber<u.startLineNumber||L.lineNumber>u.endLineNumber||L.lineNumber===u.startLineNumber&&L.column<=u.startColumn||L.lineNumber===u.endLineNumber&&L.column>=u.endColumn)}containsRange(u){return k.containsRange(this,u)}static containsRange(u,L){return!(L.startLineNumber<u.startLineNumber||L.endLineNumber<u.startLineNumber||L.startLineNumber>u.endLineNumber||L.endLineNumber>u.endLineNumber||L.startLineNumber===u.startLineNumber&&L.startColumn<u.startColumn||L.endLineNumber===u.endLineNumber&&L.endColumn>u.endColumn)}strictContainsRange(u){return k.strictContainsRange(this,u)}static strictContainsRange(u,L){return!(L.startLineNumber<u.startLineNumber||L.endLineNumber<u.startLineNumber||L.startLineNumber>u.endLineNumber||L.endLineNumber>u.endLineNumber||L.startLineNumber===u.startLineNumber&&L.startColumn<=u.startColumn||L.endLineNumber===u.endLineNumber&&L.endColumn>=u.endColumn)}plusRange(u){return k.plusRange(this,u)}static plusRange(u,L){let d,a,s,c;return L.startLineNumber<u.startLineNumber?(d=L.startLineNumber,a=L.startColumn):L.startLineNumber===u.startLineNumber?(d=L.startLineNumber,a=Math.min(L.startColumn,u.startColumn)):(d=u.startLineNumber,a=u.startColumn),L.endLineNumber>u.endLineNumber?(s=L.endLineNumber,c=L.endColumn):L.endLineNumber===u.endLineNumber?(s=L.endLineNumber,c=Math.max(L.endColumn,u.endColumn)):(s=u.endLineNumber,c=u.endColumn),new k(d,a,s,c)}intersectRanges(u){return k.intersectRanges(this,u)}static intersectRanges(u,L){let d=u.startLineNumber,a=u.startColumn,s=u.endLineNumber,c=u.endColumn;const E=L.startLineNumber,o=L.startColumn,h=L.endLineNumber,e=L.endColumn;return d<E?(d=E,a=o):d===E&&(a=Math.max(a,o)),s>h?(s=h,c=e):s===h&&(c=Math.min(c,e)),d>s||d===s&&a>c?null:new k(d,a,s,c)}equalsRange(u){return k.equalsRange(this,u)}static equalsRange(u,L){return!u&&!L?!0:!!u&&!!L&&u.startLineNumber===L.startLineNumber&&u.startColumn===L.startColumn&&u.endLineNumber===L.endLineNumber&&u.endColumn===L.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(u){return new S.Position(u.endLineNumber,u.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(u){return new S.Position(u.startLineNumber,u.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(u,L){return new k(this.startLineNumber,this.startColumn,u,L)}setStartPosition(u,L){return new k(u,L,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(u){return new k(u.startLineNumber,u.startColumn,u.startLineNumber,u.startColumn)}collapseToEnd(){return k.collapseToEnd(this)}static collapseToEnd(u){return new k(u.endLineNumber,u.endColumn,u.endLineNumber,u.endColumn)}delta(u){return new k(this.startLineNumber+u,this.startColumn,this.endLineNumber+u,this.endColumn)}static fromPositions(u,L=u){return new k(u.lineNumber,u.column,L.lineNumber,L.column)}static lift(u){return u?new k(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):null}static isIRange(u){return u&&typeof u.startLineNumber=="number"&&typeof u.startColumn=="number"&&typeof u.endLineNumber=="number"&&typeof u.endColumn=="number"}static areIntersectingOrTouching(u,L){return!(u.endLineNumber<L.startLineNumber||u.endLineNumber===L.startLineNumber&&u.endColumn<L.startColumn||L.endLineNumber<u.startLineNumber||L.endLineNumber===u.startLineNumber&&L.endColumn<u.startColumn)}static areIntersecting(u,L){return!(u.endLineNumber<L.startLineNumber||u.endLineNumber===L.startLineNumber&&u.endColumn<=L.startColumn||L.endLineNumber<u.startLineNumber||L.endLineNumber===u.startLineNumber&&L.endColumn<=u.startColumn)}static compareRangesUsingStarts(u,L){if(u&&L){const s=u.startLineNumber|0,c=L.startLineNumber|0;if(s===c){const E=u.startColumn|0,o=L.startColumn|0;if(E===o){const h=u.endLineNumber|0,e=L.endLineNumber|0;if(h===e){const N=u.endColumn|0,R=L.endColumn|0;return N-R}return h-e}return E-o}return s-c}return(u?1:0)-(L?1:0)}static compareRangesUsingEnds(u,L){return u.endLineNumber===L.endLineNumber?u.endColumn===L.endColumn?u.startLineNumber===L.startLineNumber?u.startColumn-L.startColumn:u.startLineNumber-L.startLineNumber:u.endColumn-L.endColumn:u.endLineNumber-L.endLineNumber}static spansMultipleLines(u){return u.endLineNumber>u.startLineNumber}toJSON(){return this}}t.Range=k}),J(K[12],ee([0,1,3,2]),function(V,t,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRange=void 0;class i{static fromRange(L){return new i(L.startLineNumber,L.endLineNumber)}static subtract(L,d){return d?L.startLineNumber<d.startLineNumber&&d.endLineNumberExclusive<L.endLineNumberExclusive?[new i(L.startLineNumber,d.startLineNumber),new i(d.endLineNumberExclusive,L.endLineNumberExclusive)]:d.startLineNumber<=L.startLineNumber&&L.endLineNumberExclusive<=d.endLineNumberExclusive?[]:d.endLineNumberExclusive<L.endLineNumberExclusive?[new i(Math.max(d.endLineNumberExclusive,L.startLineNumber),L.endLineNumberExclusive)]:[new i(L.startLineNumber,Math.min(d.startLineNumber,L.endLineNumberExclusive))]:[L]}static joinMany(L){if(L.length===0)return[];let d=L[0];for(let a=1;a<L.length;a++)d=this.join(d,L[a]);return d}static join(L,d){if(L.length===0)return d;if(d.length===0)return L;const a=[];let s=0,c=0,E=null;for(;s<L.length||c<d.length;){let o=null;if(s<L.length&&c<d.length){const h=L[s],e=d[c];h.startLineNumber<e.startLineNumber?(o=h,s++):(o=e,c++)}else s<L.length?(o=L[s],s++):(o=d[c],c++);E===null?E=o:E.endLineNumberExclusive>=o.startLineNumber?E=new i(E.startLineNumber,Math.max(E.endLineNumberExclusive,o.endLineNumberExclusive)):(a.push(E),E=o)}return E!==null&&a.push(E),a}static ofLength(L,d){return new i(L,L+d)}static deserialize(L){return new i(L[0],L[1])}constructor(L,d){if(L>d)throw new S.BugIndicatingError(`startLineNumber ${L} cannot be after endLineNumberExclusive ${d}`);this.startLineNumber=L,this.endLineNumberExclusive=d}contains(L){return this.startLineNumber<=L&&L<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(L){return new i(this.startLineNumber+L,this.endLineNumberExclusive+L)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(L){return new i(Math.min(this.startLineNumber,L.startLineNumber),Math.max(this.endLineNumberExclusive,L.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(L){const d=Math.max(this.startLineNumber,L.startLineNumber),a=Math.min(this.endLineNumberExclusive,L.endLineNumberExclusive);if(d<=a)return new i(d,a)}intersectsStrict(L){return this.startLineNumber<L.endLineNumberExclusive&&L.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(L){return this.startLineNumber<=L.endLineNumberExclusive&&L.startLineNumber<=this.endLineNumberExclusive}equals(L){return this.startLineNumber===L.startLineNumber&&this.endLineNumberExclusive===L.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new k.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new k.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(L){const d=[];for(let a=this.startLineNumber;a<this.endLineNumberExclusive;a++)d.push(L(a));return d}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(L){return this.startLineNumber<=L&&L<this.endLineNumberExclusive}}t.LineRange=i}),J(K[35],ee([0,1,4,2]),function(V,t,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var i;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(i||(t.SelectionDirection=i={}));class u extends k.Range{constructor(d,a,s,c){super(d,a,s,c),this.selectionStartLineNumber=d,this.selectionStartColumn=a,this.positionLineNumber=s,this.positionColumn=c}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return u.selectionsEqual(this,d)}static selectionsEqual(d,a){return d.selectionStartLineNumber===a.selectionStartLineNumber&&d.selectionStartColumn===a.selectionStartColumn&&d.positionLineNumber===a.positionLineNumber&&d.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(d,a){return this.getDirection()===0?new u(this.startLineNumber,this.startColumn,d,a):new u(d,a,this.startLineNumber,this.startColumn)}getPosition(){return new S.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new S.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,a){return this.getDirection()===0?new u(d,a,this.endLineNumber,this.endColumn):new u(this.endLineNumber,this.endColumn,d,a)}static fromPositions(d,a=d){return new u(d.lineNumber,d.column,a.lineNumber,a.column)}static fromRange(d,a){return a===0?new u(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new u(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new u(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,a){if(d&&!a||!d&&a)return!1;if(!d&&!a)return!0;if(d.length!==a.length)return!1;for(let s=0,c=d.length;s<c;s++)if(!this.selectionsEqual(d[s],a[s]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,a,s,c,E){return E===0?new u(d,a,s,c):new u(s,c,d,a)}}t.Selection=u}),J(K[36],ee([0,1,23]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=t.WordCharacterClass=void 0;var k;(function(L){L[L.Regular=0]="Regular",L[L.Whitespace=1]="Whitespace",L[L.WordSeparator=2]="WordSeparator"})(k||(t.WordCharacterClass=k={}));class i extends S.CharacterClassifier{constructor(d){super(0);for(let a=0,s=d.length;a<s;a++)this.set(d.charCodeAt(a),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=i;function u(L){const d={};return a=>(d.hasOwnProperty(a)||(d[a]=L(a)),d[a])}t.getMapForWordSeparators=u(L=>new i(L))}),J(K[24],ee([0,1,16,7,17]),function(V,t,S,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.setDefaultGetWordAtTextConfig=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function u(E=""){let o="(-?\\d*\\.\\d\\w*)|([^";for(const h of t.USUAL_WORD_SEPARATORS)E.indexOf(h)>=0||(o+="\\"+h);return o+="\\s]+)",new RegExp(o,"g")}t.DEFAULT_WORD_REGEXP=u();function L(E){let o=t.DEFAULT_WORD_REGEXP;if(E&&E instanceof RegExp)if(E.global)o=E;else{let h="g";E.ignoreCase&&(h+="i"),E.multiline&&(h+="m"),E.unicode&&(h+="u"),o=new RegExp(E.source,h)}return o.lastIndex=0,o}t.ensureValidWordDefinition=L;const d=new i.LinkedList;d.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(E){const o=d.unshift(E);return(0,k.toDisposable)(o)}t.setDefaultGetWordAtTextConfig=a;function s(E,o,h,e,N){if(N||(N=S.Iterable.first(d)),h.length>N.maxLen){let g=E-N.maxLen/2;return g<0?g=0:e+=g,h=h.substring(g,E+N.maxLen/2),s(E,o,h,e,N)}const R=Date.now(),y=E-1-e;let b=-1,M=null;for(let g=1;!(Date.now()-R>=N.timeBudget);g++){const m=y-N.windowSize*g;o.lastIndex=Math.max(0,m);const r=c(o,h,y,b);if(!r&&M||(M=r,m<=0))break;b=m}if(M){const g={word:M[0],startColumn:e+1+M.index,endColumn:e+1+M.index+M[0].length};return o.lastIndex=0,g}return null}t.getWordAtText=s;function c(E,o,h,e){let N;for(;N=E.exec(o);){const R=N.index||0;if(R<=h&&E.lastIndex>=h)return N;if(e>0&&R>e)return null}return null}}),J(K[9],ee([0,1,3,6]),function(V,t,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DateTimeout=t.InfiniteTimeout=t.SequenceDiff=t.DiffAlgorithmResult=void 0;class i{static trivial(s,c){return new i([new u(new k.OffsetRange(0,s.length),new k.OffsetRange(0,c.length))],!1)}static trivialTimedOut(s,c){return new i([new u(new k.OffsetRange(0,s.length),new k.OffsetRange(0,c.length))],!0)}constructor(s,c){this.diffs=s,this.hitTimeout=c}}t.DiffAlgorithmResult=i;class u{constructor(s,c){this.seq1Range=s,this.seq2Range=c}reverse(){return new u(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(s){return new u(this.seq1Range.join(s.seq1Range),this.seq2Range.join(s.seq2Range))}delta(s){return s===0?this:new u(this.seq1Range.delta(s),this.seq2Range.delta(s))}}t.SequenceDiff=u;class L{isValid(){return!0}}t.InfiniteTimeout=L,L.instance=new L;class d{constructor(s){if(this.timeout=s,this.startTime=Date.now(),this.valid=!0,s<=0)throw new S.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}disable(){this.timeout=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.valid=!0}}t.DateTimeout=d}),J(K[37],ee([0,1,6,9]),function(V,t,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shiftSequenceDiffs=t.joinSequenceDiffs=t.smoothenSequenceDiffs=t.optimizeSequenceDiffs=void 0;function i(s,c,E){let o=E;return o=L(s,c,o),o=d(s,c,o),o}t.optimizeSequenceDiffs=i;function u(s,c,E){const o=[];for(const h of E){const e=o[o.length-1];if(!e){o.push(h);continue}h.seq1Range.start-e.seq1Range.endExclusive<=2||h.seq2Range.start-e.seq2Range.endExclusive<=2?o[o.length-1]=new k.SequenceDiff(e.seq1Range.join(h.seq1Range),e.seq2Range.join(h.seq2Range)):o.push(h)}return o}t.smoothenSequenceDiffs=u;function L(s,c,E){const o=[];E.length>0&&o.push(E[0]);for(let e=1;e<E.length;e++){const N=E[e-1];let R=E[e];if(R.seq1Range.isEmpty||R.seq2Range.isEmpty){const y=R.seq1Range.start-N.seq1Range.endExclusive;let b;for(b=1;b<=y&&!(s.getElement(R.seq1Range.start-b)!==s.getElement(R.seq1Range.endExclusive-b)||c.getElement(R.seq2Range.start-b)!==c.getElement(R.seq2Range.endExclusive-b));b++);if(b--,b===y){o[o.length-1]=new k.SequenceDiff(new S.OffsetRange(N.seq1Range.start,R.seq1Range.endExclusive-y),new S.OffsetRange(N.seq2Range.start,R.seq2Range.endExclusive-y));continue}R=R.delta(-b)}o.push(R)}const h=[];for(let e=0;e<o.length-1;e++){const N=o[e+1];let R=o[e];if(R.seq1Range.isEmpty||R.seq2Range.isEmpty){const y=N.seq1Range.start-R.seq1Range.endExclusive;let b;for(b=0;b<y&&!(s.getElement(R.seq1Range.start+b)!==s.getElement(R.seq1Range.endExclusive+b)||c.getElement(R.seq2Range.start+b)!==c.getElement(R.seq2Range.endExclusive+b));b++);if(b===y){o[e+1]=new k.SequenceDiff(new S.OffsetRange(R.seq1Range.start+y,N.seq1Range.endExclusive),new S.OffsetRange(R.seq2Range.start+y,N.seq2Range.endExclusive));continue}b>0&&(R=R.delta(b))}h.push(R)}return o.length>0&&h.push(o[o.length-1]),h}t.joinSequenceDiffs=L;function d(s,c,E){if(!s.getBoundaryScore||!c.getBoundaryScore)return E;for(let o=0;o<E.length;o++){const h=o>0?E[o-1]:void 0,e=E[o],N=o+1<E.length?E[o+1]:void 0,R=new S.OffsetRange(h?h.seq1Range.start+1:0,N?N.seq1Range.endExclusive-1:s.length),y=new S.OffsetRange(h?h.seq2Range.start+1:0,N?N.seq2Range.endExclusive-1:c.length);e.seq1Range.isEmpty?E[o]=a(e,s,c,R,y):e.seq2Range.isEmpty&&(E[o]=a(e.reverse(),c,s,y,R).reverse())}return E}t.shiftSequenceDiffs=d;function a(s,c,E,o,h){let N=1;for(;s.seq1Range.start-N>=o.start&&s.seq2Range.start-N>=h.start&&E.getElement(s.seq2Range.start-N)===E.getElement(s.seq2Range.endExclusive-N)&&N<100;)N++;N--;let R=0;for(;s.seq1Range.start+R<o.endExclusive&&s.seq2Range.endExclusive+R<h.endExclusive&&E.getElement(s.seq2Range.start+R)===E.getElement(s.seq2Range.endExclusive+R)&&R<100;)R++;if(N===0&&R===0)return s;let y=0,b=-1;for(let M=-N;M<=R;M++){const g=s.seq2Range.start+M,m=s.seq2Range.endExclusive+M,r=s.seq1Range.start+M,l=c.getBoundaryScore(r)+E.getBoundaryScore(g)+E.getBoundaryScore(m);l>b&&(b=l,y=M)}return s.delta(y)}}),J(K[38],ee([0,1,6,9]),function(V,t,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class i{compute(s,c,E=k.InfiniteTimeout.instance){if(s.length===0||c.length===0)return k.DiffAlgorithmResult.trivial(s,c);function o(m,r){for(;m<s.length&&r<c.length&&s.getElement(m)===c.getElement(r);)m++,r++;return m}let h=0;const e=new L;e.set(0,o(0,0));const N=new d;N.set(0,e.get(0)===0?null:new u(null,0,0,e.get(0)));let R=0;e:for(;;){if(h++,!E.isValid())return k.DiffAlgorithmResult.trivialTimedOut(s,c);const m=-Math.min(h,c.length+h%2),r=Math.min(h,s.length+h%2);for(R=m;R<=r;R+=2){const l=R===r?-1:e.get(R+1),A=R===m?-1:e.get(R-1)+1,f=Math.min(Math.max(l,A),s.length),v=f-R;if(f>s.length||v>c.length)continue;const w=o(f,v);e.set(R,w);const p=f===l?N.get(R+1):N.get(R-1);if(N.set(R,w!==f?new u(p,f,v,w-f):p),e.get(R)===s.length&&e.get(R)-R===c.length)break e}}let y=N.get(R);const b=[];let M=s.length,g=c.length;for(;;){const m=y?y.x+y.length:0,r=y?y.y+y.length:0;if((m!==M||r!==g)&&b.push(new k.SequenceDiff(new S.OffsetRange(m,M),new S.OffsetRange(r,g))),!y)break;M=y.x,g=y.y,y=y.prev}return b.reverse(),new k.DiffAlgorithmResult(b,!1)}}t.MyersDiffAlgorithm=i;class u{constructor(s,c,E,o){this.prev=s,this.x=c,this.y=E,this.length=o}}class L{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,c){if(s<0){if(s=-s-1,s>=this.negativeArr.length){const E=this.negativeArr;this.negativeArr=new Int32Array(E.length*2),this.negativeArr.set(E)}this.negativeArr[s]=c}else{if(s>=this.positiveArr.length){const E=this.positiveArr;this.positiveArr=new Int32Array(E.length*2),this.positiveArr.set(E)}this.positiveArr[s]=c}}}class d{constructor(){this.positiveArr=[],this.negativeArr=[]}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,c){s<0?(s=-s-1,this.negativeArr[s]=c):this.positiveArr[s]=c}}}),J(K[39],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Array2D=void 0;class S{constructor(i,u){this.width=i,this.height=u,this.array=[],this.array=new Array(i*u)}get(i,u){return this.array[i+u*this.width]}set(i,u,L){this.array[i+u*this.width]=L}}t.Array2D=S}),J(K[40],ee([0,1,6,9,39]),function(V,t,S,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class u{compute(d,a,s=k.InfiniteTimeout.instance,c){if(d.length===0||a.length===0)return k.DiffAlgorithmResult.trivial(d,a);const E=new i.Array2D(d.length,a.length),o=new i.Array2D(d.length,a.length),h=new i.Array2D(d.length,a.length);for(let g=0;g<d.length;g++)for(let m=0;m<a.length;m++){if(!s.isValid())return k.DiffAlgorithmResult.trivialTimedOut(d,a);const r=g===0?0:E.get(g-1,m),l=m===0?0:E.get(g,m-1);let A;d.getElement(g)===a.getElement(m)?(g===0||m===0?A=0:A=E.get(g-1,m-1),g>0&&m>0&&o.get(g-1,m-1)===3&&(A+=h.get(g-1,m-1)),A+=c?c(g,m):1):A=-1;const f=Math.max(r,l,A);if(f===A){const v=g>0&&m>0?h.get(g-1,m-1):0;h.set(g,m,v+1),o.set(g,m,3)}else f===r?(h.set(g,m,0),o.set(g,m,1)):f===l&&(h.set(g,m,0),o.set(g,m,2));E.set(g,m,f)}const e=[];let N=d.length,R=a.length;function y(g,m){(g+1!==N||m+1!==R)&&e.push(new k.SequenceDiff(new S.OffsetRange(g+1,N),new S.OffsetRange(m+1,R))),N=g,R=m}let b=d.length-1,M=a.length-1;for(;b>=0&&M>=0;)o.get(b,M)===3?(y(b,M),b--,M--):o.get(b,M)===1?b--:M--;return y(-1,-1),e.reverse(),new k.DiffAlgorithmResult(e,!1)}}t.DynamicProgrammingDiffing=u}),J(K[25],ee([0,1,12]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MovedText=t.SimpleLineRangeMapping=t.RangeMapping=t.LineRangeMapping=t.LinesDiff=void 0;class k{constructor(s,c,E){this.changes=s,this.moves=c,this.hitTimeout=E}}t.LinesDiff=k;class i{static inverse(s,c,E){const o=[];let h=1,e=1;for(const R of s){const y=new i(new S.LineRange(h,R.originalRange.startLineNumber),new S.LineRange(e,R.modifiedRange.startLineNumber),void 0);y.modifiedRange.isEmpty||o.push(y),h=R.originalRange.endLineNumberExclusive,e=R.modifiedRange.endLineNumberExclusive}const N=new i(new S.LineRange(h,c+1),new S.LineRange(e,E+1),void 0);return N.modifiedRange.isEmpty||o.push(N),o}constructor(s,c,E){this.originalRange=s,this.modifiedRange=c,this.innerChanges=E}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}get changedLineCount(){return Math.max(this.originalRange.length,this.modifiedRange.length)}flip(){return new i(this.modifiedRange,this.originalRange,this.innerChanges?.map(s=>s.flip()))}}t.LineRangeMapping=i;class u{constructor(s,c){this.originalRange=s,this.modifiedRange=c}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new u(this.modifiedRange,this.originalRange)}}t.RangeMapping=u;class L{constructor(s,c){this.originalRange=s,this.modifiedRange=c}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new L(this.modifiedRange,this.originalRange)}}t.SimpleLineRangeMapping=L;class d{constructor(s,c){this.lineRangeMapping=s,this.changes=c}flip(){return new d(this.lineRangeMapping.flip(),this.changes.map(s=>s.flip()))}}t.MovedText=d}),J(K[26],ee([0,1,20,25,5,2,10,12]),function(V,t,S,k,i,u,L,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.SmartLinesDiffComputer=void 0;const a=3;class s{computeDiff(m,r,l){const f=new R(m,r,{maxComputationTime:l.maxComputationTimeMs,shouldIgnoreTrimWhitespace:l.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),v=[];let w=null;for(const p of f.changes){let D;p.originalEndLineNumber===0?D=new d.LineRange(p.originalStartLineNumber+1,p.originalStartLineNumber+1):D=new d.LineRange(p.originalStartLineNumber,p.originalEndLineNumber+1);let F;p.modifiedEndLineNumber===0?F=new d.LineRange(p.modifiedStartLineNumber+1,p.modifiedStartLineNumber+1):F=new d.LineRange(p.modifiedStartLineNumber,p.modifiedEndLineNumber+1);let P=new k.LineRangeMapping(D,F,p.charChanges?.map(_=>new k.RangeMapping(new u.Range(_.originalStartLineNumber,_.originalStartColumn,_.originalEndLineNumber,_.originalEndColumn),new u.Range(_.modifiedStartLineNumber,_.modifiedStartColumn,_.modifiedEndLineNumber,_.modifiedEndColumn))));w&&(w.modifiedRange.endLineNumberExclusive===P.modifiedRange.startLineNumber||w.originalRange.endLineNumberExclusive===P.originalRange.startLineNumber)&&(P=new k.LineRangeMapping(w.originalRange.join(P.originalRange),w.modifiedRange.join(P.modifiedRange),w.innerChanges&&P.innerChanges?w.innerChanges.concat(P.innerChanges):void 0),v.pop()),v.push(P),w=P}return(0,L.assertFn)(()=>(0,L.checkAdjacentItems)(v,(p,D)=>D.originalRange.startLineNumber-p.originalRange.endLineNumberExclusive===D.modifiedRange.startLineNumber-p.modifiedRange.endLineNumberExclusive&&p.originalRange.endLineNumberExclusive<D.originalRange.startLineNumber&&p.modifiedRange.endLineNumberExclusive<D.modifiedRange.startLineNumber)),new k.LinesDiff(v,[],f.quitEarly)}}t.SmartLinesDiffComputer=s;function c(g,m,r,l){return new S.LcsDiff(g,m,r).ComputeDiff(l)}class E{constructor(m){const r=[],l=[];for(let A=0,f=m.length;A<f;A++)r[A]=y(m[A],1),l[A]=b(m[A],1);this.lines=m,this._startColumns=r,this._endColumns=l}getElements(){const m=[];for(let r=0,l=this.lines.length;r<l;r++)m[r]=this.lines[r].substring(this._startColumns[r]-1,this._endColumns[r]-1);return m}getStrictElement(m){return this.lines[m]}getStartLineNumber(m){return m+1}getEndLineNumber(m){return m+1}createCharSequence(m,r,l){const A=[],f=[],v=[];let w=0;for(let p=r;p<=l;p++){const D=this.lines[p],F=m?this._startColumns[p]:1,P=m?this._endColumns[p]:D.length+1;for(let _=F;_<P;_++)A[w]=D.charCodeAt(_-1),f[w]=p+1,v[w]=_,w++;!m&&p<l&&(A[w]=10,f[w]=p+1,v[w]=D.length+1,w++)}return new o(A,f,v)}}class o{constructor(m,r,l){this._charCodes=m,this._lineNumbers=r,this._columns=l}toString(){return"["+this._charCodes.map((m,r)=>(m===10?"\\n":String.fromCharCode(m))+`-(${this._lineNumbers[r]},${this._columns[r]})`).join(", ")+"]"}_assertIndex(m,r){if(m<0||m>=r.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(m){return m>0&&m===this._lineNumbers.length?this.getEndLineNumber(m-1):(this._assertIndex(m,this._lineNumbers),this._lineNumbers[m])}getEndLineNumber(m){return m===-1?this.getStartLineNumber(m+1):(this._assertIndex(m,this._lineNumbers),this._charCodes[m]===10?this._lineNumbers[m]+1:this._lineNumbers[m])}getStartColumn(m){return m>0&&m===this._columns.length?this.getEndColumn(m-1):(this._assertIndex(m,this._columns),this._columns[m])}getEndColumn(m){return m===-1?this.getStartColumn(m+1):(this._assertIndex(m,this._columns),this._charCodes[m]===10?1:this._columns[m]+1)}}class h{constructor(m,r,l,A,f,v,w,p){this.originalStartLineNumber=m,this.originalStartColumn=r,this.originalEndLineNumber=l,this.originalEndColumn=A,this.modifiedStartLineNumber=f,this.modifiedStartColumn=v,this.modifiedEndLineNumber=w,this.modifiedEndColumn=p}static createFromDiffChange(m,r,l){const A=r.getStartLineNumber(m.originalStart),f=r.getStartColumn(m.originalStart),v=r.getEndLineNumber(m.originalStart+m.originalLength-1),w=r.getEndColumn(m.originalStart+m.originalLength-1),p=l.getStartLineNumber(m.modifiedStart),D=l.getStartColumn(m.modifiedStart),F=l.getEndLineNumber(m.modifiedStart+m.modifiedLength-1),P=l.getEndColumn(m.modifiedStart+m.modifiedLength-1);return new h(A,f,v,w,p,D,F,P)}}function e(g){if(g.length<=1)return g;const m=[g[0]];let r=m[0];for(let l=1,A=g.length;l<A;l++){const f=g[l],v=f.originalStart-(r.originalStart+r.originalLength),w=f.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(v,w)<a?(r.originalLength=f.originalStart+f.originalLength-r.originalStart,r.modifiedLength=f.modifiedStart+f.modifiedLength-r.modifiedStart):(m.push(f),r=f)}return m}class N{constructor(m,r,l,A,f){this.originalStartLineNumber=m,this.originalEndLineNumber=r,this.modifiedStartLineNumber=l,this.modifiedEndLineNumber=A,this.charChanges=f}static createFromDiffResult(m,r,l,A,f,v,w){let p,D,F,P,_;if(r.originalLength===0?(p=l.getStartLineNumber(r.originalStart)-1,D=0):(p=l.getStartLineNumber(r.originalStart),D=l.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(F=A.getStartLineNumber(r.modifiedStart)-1,P=0):(F=A.getStartLineNumber(r.modifiedStart),P=A.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),v&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&f()){const I=l.createCharSequence(m,r.originalStart,r.originalStart+r.originalLength-1),C=A.createCharSequence(m,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(I.getElements().length>0&&C.getElements().length>0){let q=c(I,C,f,!0).changes;w&&(q=e(q)),_=[];for(let j=0,G=q.length;j<G;j++)_.push(h.createFromDiffChange(q[j],I,C))}}return new N(p,D,F,P,_)}}class R{constructor(m,r,l){this.shouldComputeCharChanges=l.shouldComputeCharChanges,this.shouldPostProcessCharChanges=l.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=l.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=l.shouldMakePrettyDiff,this.originalLines=m,this.modifiedLines=r,this.original=new E(m),this.modified=new E(r),this.continueLineDiff=M(l.maxComputationTime),this.continueCharDiff=M(l.maxComputationTime===0?0:Math.min(l.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const m=c(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),r=m.changes,l=m.quitEarly;if(this.shouldIgnoreTrimWhitespace){const w=[];for(let p=0,D=r.length;p<D;p++)w.push(N.createFromDiffResult(this.shouldIgnoreTrimWhitespace,r[p],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:l,changes:w}}const A=[];let f=0,v=0;for(let w=-1,p=r.length;w<p;w++){const D=w+1<p?r[w+1]:null,F=D?D.originalStart:this.originalLines.length,P=D?D.modifiedStart:this.modifiedLines.length;for(;f<F&&v<P;){const _=this.originalLines[f],I=this.modifiedLines[v];if(_!==I){{let C=y(_,1),q=y(I,1);for(;C>1&&q>1;){const j=_.charCodeAt(C-2),G=I.charCodeAt(q-2);if(j!==G)break;C--,q--}(C>1||q>1)&&this._pushTrimWhitespaceCharChange(A,f+1,1,C,v+1,1,q)}{let C=b(_,1),q=b(I,1);const j=_.length+1,G=I.length+1;for(;C<j&&q<G;){const X=_.charCodeAt(C-1),$=_.charCodeAt(q-1);if(X!==$)break;C++,q++}(C<j||q<G)&&this._pushTrimWhitespaceCharChange(A,f+1,C,j,v+1,q,G)}}f++,v++}D&&(A.push(N.createFromDiffResult(this.shouldIgnoreTrimWhitespace,D,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),f+=D.originalLength,v+=D.modifiedLength)}return{quitEarly:l,changes:A}}_pushTrimWhitespaceCharChange(m,r,l,A,f,v,w){if(this._mergeTrimWhitespaceCharChange(m,r,l,A,f,v,w))return;let p;this.shouldComputeCharChanges&&(p=[new h(r,l,r,A,f,v,f,w)]),m.push(new N(r,r,f,f,p))}_mergeTrimWhitespaceCharChange(m,r,l,A,f,v,w){const p=m.length;if(p===0)return!1;const D=m[p-1];return D.originalEndLineNumber===0||D.modifiedEndLineNumber===0?!1:D.originalEndLineNumber===r&&D.modifiedEndLineNumber===f?(this.shouldComputeCharChanges&&D.charChanges&&D.charChanges.push(new h(r,l,r,A,f,v,f,w)),!0):D.originalEndLineNumber+1===r&&D.modifiedEndLineNumber+1===f?(D.originalEndLineNumber=r,D.modifiedEndLineNumber=f,this.shouldComputeCharChanges&&D.charChanges&&D.charChanges.push(new h(r,l,r,A,f,v,f,w)),!0):!1}}t.DiffComputer=R;function y(g,m){const r=i.firstNonWhitespaceIndex(g);return r===-1?m:r+1}function b(g,m){const r=i.lastNonWhitespaceIndex(g);return r===-1?m:r+2}function M(g){if(g===0)return()=>!0;const m=Date.now();return()=>Date.now()-m<g}}),J(K[41],ee([0,1,10,12,6,4,2,9,40,37,38,25]),function(V,t,S,k,i,u,L,d,a,s,c,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=t.getLineRangeMapping=t.lineRangeMappingFromRangeMappings=t.StandardLinesDiffComputer=void 0;class o{constructor(){this.dynamicProgrammingDiffing=new a.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new c.MyersDiffAlgorithm}computeDiff(P,_,I){const C=I.maxComputationTimeMs===0?d.InfiniteTimeout.instance:new d.DateTimeout(I.maxComputationTimeMs),q=!I.ignoreTrimWhitespace,j=new Map;function G(ae){let le=j.get(ae);return le===void 0&&(le=j.size,j.set(ae,le)),le}const X=P.map(ae=>G(ae.trim())),$=_.map(ae=>G(ae.trim())),ne=new b(X,P),n=new b($,_),de=(()=>ne.length+n.length<1500?this.dynamicProgrammingDiffing.compute(ne,n,C,(ae,le)=>P[ae]===_[le]?_[le].length===0?.1:1+Math.log(1+_[le].length):.99):this.myersDiffingAlgorithm.compute(ne,n))();let _e=de.diffs,me=de.hitTimeout;_e=(0,s.optimizeSequenceDiffs)(ne,n,_e);const oe=[],Le=ae=>{if(q)for(let le=0;le<ae;le++){const se=pe+le,ge=Ne+le;if(P[se]!==_[ge]){const U=this.refineDiff(P,_,new d.SequenceDiff(new i.OffsetRange(se,se+1),new i.OffsetRange(ge,ge+1)),C,q);for(const O of U.mappings)oe.push(O);U.hitTimeout&&(me=!0)}}};let pe=0,Ne=0;for(const ae of _e){(0,S.assertFn)(()=>ae.seq1Range.start-pe===ae.seq2Range.start-Ne);const le=ae.seq1Range.start-pe;Le(le),pe=ae.seq1Range.endExclusive,Ne=ae.seq2Range.endExclusive;const se=this.refineDiff(P,_,ae,C,q);se.hitTimeout&&(me=!0);for(const ge of se.mappings)oe.push(ge)}Le(P.length-pe);const ye=N(oe,P,_),Ae=[];if(I.computeMoves){const ae=ye.filter(se=>se.modifiedRange.isEmpty&&se.originalRange.length>=3).map(se=>new D(se.originalRange,P)),le=new Set(ye.filter(se=>se.originalRange.isEmpty&&se.modifiedRange.length>=3).map(se=>new D(se.modifiedRange,_)));for(const se of ae){let ge=-1,U;for(const O of le){const B=se.computeSimilarity(O);B>ge&&(ge=B,U=O)}if(ge>.9&&U){const O=this.refineDiff(P,_,new d.SequenceDiff(new i.OffsetRange(se.range.startLineNumber-1,se.range.endLineNumberExclusive-1),new i.OffsetRange(U.range.startLineNumber-1,U.range.endLineNumberExclusive-1)),C,q),B=N(O.mappings,P,_,!0);le.delete(U),Ae.push(new E.MovedText(new E.SimpleLineRangeMapping(se.range,U.range),B))}}}return new E.LinesDiff(ye,Ae,me)}refineDiff(P,_,I,C,q){const j=new g(P,I.seq1Range,q),G=new g(_,I.seq2Range,q),X=j.length+G.length<500?this.dynamicProgrammingDiffing.compute(j,G,C):this.myersDiffingAlgorithm.compute(j,G,C);let $=X.diffs;return $=(0,s.optimizeSequenceDiffs)(j,G,$),$=h(j,G,$),$=(0,s.smoothenSequenceDiffs)(j,G,$),{mappings:$.map(n=>new E.RangeMapping(j.translateRange(n.seq1Range),G.translateRange(n.seq2Range))),hitTimeout:X.hitTimeout}}}t.StandardLinesDiffComputer=o;function h(F,P,_){const I=[];let C;function q(){if(!C)return;const G=C.s1Range.length-C.deleted,X=C.s2Range.length-C.added;Math.max(C.deleted,C.added)+(C.count-1)>G&&I.push(new d.SequenceDiff(C.s1Range,C.s2Range)),C=void 0}for(const G of _){let X=function(_e,me){if(!C||!C.s1Range.containsRange(_e)||!C.s2Range.containsRange(me))if(C&&!(C.s1Range.endExclusive<_e.start&&C.s2Range.endExclusive<me.start)){const pe=i.OffsetRange.tryCreate(C.s1Range.endExclusive,_e.start),Ne=i.OffsetRange.tryCreate(C.s2Range.endExclusive,me.start);C.deleted+=pe?.length??0,C.added+=Ne?.length??0,C.s1Range=C.s1Range.join(_e),C.s2Range=C.s2Range.join(me)}else q(),C={added:0,deleted:0,count:0,s1Range:_e,s2Range:me};const oe=_e.intersect(G.seq1Range),Le=me.intersect(G.seq2Range);C.count++,C.deleted+=oe?.length??0,C.added+=Le?.length??0};const $=F.findWordContaining(G.seq1Range.start-1),ne=P.findWordContaining(G.seq2Range.start-1),n=F.findWordContaining(G.seq1Range.endExclusive),de=P.findWordContaining(G.seq2Range.endExclusive);$&&n&&ne&&de&&$.equals(n)&&ne.equals(de)?X($,ne):($&&ne&&X($,ne),n&&de&&X(n,de))}return q(),e(_,I)}function e(F,P){const _=[];for(;F.length>0||P.length>0;){const I=F[0],C=P[0];let q;I&&(!C||I.seq1Range.start<C.seq1Range.start)?q=F.shift():q=P.shift(),_.length>0&&_[_.length-1].seq1Range.endExclusive>=q.seq1Range.start?_[_.length-1]=_[_.length-1].join(q):_.push(q)}return _}function N(F,P,_,I=!1){const C=[];for(const q of y(F.map(j=>R(j,P,_)),(j,G)=>j.originalRange.overlapOrTouch(G.originalRange)||j.modifiedRange.overlapOrTouch(G.modifiedRange))){const j=q[0],G=q[q.length-1];C.push(new E.LineRangeMapping(j.originalRange.join(G.originalRange),j.modifiedRange.join(G.modifiedRange),q.map(X=>X.innerChanges[0])))}return(0,S.assertFn)(()=>!I&&C.length>0&&C[0].originalRange.startLineNumber!==C[0].modifiedRange.startLineNumber?!1:(0,S.checkAdjacentItems)(C,(q,j)=>j.originalRange.startLineNumber-q.originalRange.endLineNumberExclusive===j.modifiedRange.startLineNumber-q.modifiedRange.endLineNumberExclusive&&q.originalRange.endLineNumberExclusive<j.originalRange.startLineNumber&&q.modifiedRange.endLineNumberExclusive<j.modifiedRange.startLineNumber)),C}t.lineRangeMappingFromRangeMappings=N;function R(F,P,_){let I=0,C=0;F.modifiedRange.endColumn===1&&F.originalRange.endColumn===1&&F.originalRange.startLineNumber+I<=F.originalRange.endLineNumber&&F.modifiedRange.startLineNumber+I<=F.modifiedRange.endLineNumber&&(C=-1),F.modifiedRange.startColumn-1>=_[F.modifiedRange.startLineNumber-1].length&&F.originalRange.startColumn-1>=P[F.originalRange.startLineNumber-1].length&&F.originalRange.startLineNumber<=F.originalRange.endLineNumber+C&&F.modifiedRange.startLineNumber<=F.modifiedRange.endLineNumber+C&&(I=1);const q=new k.LineRange(F.originalRange.startLineNumber+I,F.originalRange.endLineNumber+1+C),j=new k.LineRange(F.modifiedRange.startLineNumber+I,F.modifiedRange.endLineNumber+1+C);return new E.LineRangeMapping(q,j,[F])}t.getLineRangeMapping=R;function*y(F,P){let _,I;for(const C of F)I!==void 0&&P(I,C)?_.push(C):(_&&(yield _),_=[C]),I=C;_&&(yield _)}class b{constructor(P,_){this.trimmedHash=P,this.lines=_}getElement(P){return this.trimmedHash[P]}get length(){return this.trimmedHash.length}getBoundaryScore(P){const _=P===0?0:M(this.lines[P-1]),I=P===this.lines.length?0:M(this.lines[P]);return 1e3-(_+I)}}t.LineSequence=b;function M(F){let P=0;for(;P<F.length&&(F.charCodeAt(P)===32||F.charCodeAt(P)===9);)P++;return P}class g{constructor(P,_,I){this.lines=P,this.considerWhitespaceChanges=I,this.elements=[],this.firstCharOffsetByLineMinusOne=[],this.offsetByLine=[];let C=!1;_.start>0&&_.endExclusive>=P.length&&(_=new i.OffsetRange(_.start-1,_.endExclusive),C=!0),this.lineRange=_;for(let q=this.lineRange.start;q<this.lineRange.endExclusive;q++){let j=P[q],G=0;if(C)G=j.length,j="",C=!1;else if(!I){const X=j.trimStart();G=j.length-X.length,j=X.trimEnd()}this.offsetByLine.push(G);for(let X=0;X<j.length;X++)this.elements.push(j.charCodeAt(X));q<P.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLineMinusOne[q-this.lineRange.start]=this.elements.length)}this.offsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return[...this.elements].map(P=>String.fromCharCode(P)).join("")}getElement(P){return this.elements[P]}get length(){return this.elements.length}getBoundaryScore(P){const _=f(P>0?this.elements[P-1]:-1),I=f(P<this.elements.length?this.elements[P]:-1);if(_===6&&I===7)return 0;let C=0;return _!==I&&(C+=10,I===1&&(C+=1)),C+=A(_),C+=A(I),C}translateOffset(P){if(this.lineRange.isEmpty)return new u.Position(this.lineRange.start+1,1);let _=0,I=this.firstCharOffsetByLineMinusOne.length;for(;_<I;){const q=Math.floor((_+I)/2);this.firstCharOffsetByLineMinusOne[q]>P?I=q:_=q+1}const C=_===0?0:this.firstCharOffsetByLineMinusOne[_-1];return new u.Position(this.lineRange.start+_+1,P-C+1+this.offsetByLine[_])}translateRange(P){return L.Range.fromPositions(this.translateOffset(P.start),this.translateOffset(P.endExclusive))}findWordContaining(P){if(P<0||P>=this.elements.length||!m(this.elements[P]))return;let _=P;for(;_>0&&m(this.elements[_-1]);)_--;let I=P;for(;I<this.elements.length&&m(this.elements[I]);)I++;return new i.OffsetRange(_,I)}}function m(F){return F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57}var r;(function(F){F[F.WordLower=0]="WordLower",F[F.WordUpper=1]="WordUpper",F[F.WordNumber=2]="WordNumber",F[F.End=3]="End",F[F.Other=4]="Other",F[F.Space=5]="Space",F[F.LineBreakCR=6]="LineBreakCR",F[F.LineBreakLF=7]="LineBreakLF"})(r||(r={}));const l={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function A(F){return l[F]}function f(F){return F===10?7:F===13?6:v(F)?5:F>=97&&F<=122?0:F>=65&&F<=90?1:F>=48&&F<=57?2:F===-1?3:4}function v(F){return F===32||F===9}const w=new Map;function p(F){let P=w.get(F);return P===void 0&&(P=w.size,w.set(F,P)),P}class D{constructor(P,_){this.range=P,this.lines=_,this.histogram=[];let I=0;for(let C=P.startLineNumber-1;C<P.endLineNumberExclusive-1;C++){const q=_[C];for(let G=0;G<q.length;G++){I++;const X=q[G],$=p(X);this.histogram[$]=(this.histogram[$]||0)+1}I++;const j=p(`
`);this.histogram[j]=(this.histogram[j]||0)+1}this.totalCount=I}computeSimilarity(P){let _=0;const I=Math.max(this.histogram.length,P.histogram.length);for(let C=0;C<I;C++)_+=Math.abs((this.histogram[C]??0)-(P.histogram[C]??0));return 1-_/(this.totalCount+P.totalCount)}}}),J(K[42],ee([0,1,26,41]),function(V,t,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={getLegacy:()=>new S.SmartLinesDiffComputer,getAdvanced:()=>new k.StandardLinesDiffComputer}}),J(K[43],ee([0,1,27]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeDefaultDocumentColors=void 0;function k(o){const h=[];for(const e of o){const N=Number(e);(N||N===0&&e.replace(/\s/g,"")!=="")&&h.push(N)}return h}function i(o,h,e,N){return{red:o/255,blue:e/255,green:h/255,alpha:N}}function u(o,h){const e=h.index,N=h[0].length;if(!e)return;const R=o.positionAt(e);return{startLineNumber:R.lineNumber,startColumn:R.column,endLineNumber:R.lineNumber,endColumn:R.column+N}}function L(o,h){if(!o)return;const e=S.Color.Format.CSS.parseHex(h);if(e)return{range:o,color:i(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function d(o,h,e){if(!o||h.length!==1)return;const R=h[0].values(),y=k(R);return{range:o,color:i(y[0],y[1],y[2],e?y[3]:1)}}function a(o,h,e){if(!o||h.length!==1)return;const R=h[0].values(),y=k(R),b=new S.Color(new S.HSLA(y[0],y[1]/100,y[2]/100,e?y[3]:1));return{range:o,color:i(b.rgba.r,b.rgba.g,b.rgba.b,b.rgba.a)}}function s(o,h){return typeof o=="string"?[...o.matchAll(h)]:o.findMatches(h)}function c(o){const h=[],N=s(o,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(N.length>0)for(const R of N){const y=R.filter(m=>m!==void 0),b=y[1],M=y[2];if(!M)continue;let g;if(b==="rgb"){const m=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;g=d(u(o,R),s(M,m),!1)}else if(b==="rgba"){const m=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;g=d(u(o,R),s(M,m),!0)}else if(b==="hsl"){const m=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;g=a(u(o,R),s(M,m),!1)}else if(b==="hsla"){const m=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;g=a(u(o,R),s(M,m),!0)}else b==="#"&&(g=L(u(o,R),b+M));g&&h.push(g)}return h}function E(o){return!o||typeof o.getValue!="function"||typeof o.positionAt!="function"?[]:c(o)}t.computeDefaultDocumentColors=E}),J(K[44],ee([0,1,23]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.State=void 0;var k;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(k||(t.State=k={}));class i{constructor(e,N,R){const y=new Uint8Array(e*N);for(let b=0,M=e*N;b<M;b++)y[b]=R;this._data=y,this.rows=e,this.cols=N}get(e,N){return this._data[e*this.cols+N]}set(e,N,R){this._data[e*this.cols+N]=R}}class u{constructor(e){let N=0,R=0;for(let b=0,M=e.length;b<M;b++){const[g,m,r]=e[b];m>N&&(N=m),g>R&&(R=g),r>R&&(R=r)}N++,R++;const y=new i(R,N,0);for(let b=0,M=e.length;b<M;b++){const[g,m,r]=e[b];y.set(g,m,r)}this._states=y,this._maxCharCode=N}nextState(e,N){return N<0||N>=this._maxCharCode?0:this._states.get(e,N)}}t.StateMachine=u;let L=null;function d(){return L===null&&(L=new u([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var a;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let s=null;function c(){if(s===null){s=new S.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let N=0;N<h.length;N++)s.set(h.charCodeAt(N),1);const e=".,;:";for(let N=0;N<e.length;N++)s.set(e.charCodeAt(N),2)}return s}class E{static _createLink(e,N,R,y,b){let M=b-1;do{const g=N.charCodeAt(M);if(e.get(g)!==2)break;M--}while(M>y);if(y>0){const g=N.charCodeAt(y-1),m=N.charCodeAt(M);(g===40&&m===41||g===91&&m===93||g===123&&m===125)&&M--}return{range:{startLineNumber:R,startColumn:y+1,endLineNumber:R,endColumn:M+2},url:N.substring(y,M+1)}}static computeLinks(e,N=d()){const R=c(),y=[];for(let b=1,M=e.getLineCount();b<=M;b++){const g=e.getLineContent(b),m=g.length;let r=0,l=0,A=0,f=1,v=!1,w=!1,p=!1,D=!1;for(;r<m;){let F=!1;const P=g.charCodeAt(r);if(f===13){let _;switch(P){case 40:v=!0,_=0;break;case 41:_=v?0:1;break;case 91:p=!0,w=!0,_=0;break;case 93:p=!1,_=w?0:1;break;case 123:D=!0,_=0;break;case 125:_=D?0:1;break;case 39:case 34:case 96:A===P?_=1:A===39||A===34||A===96?_=0:_=1;break;case 42:_=A===42?1:0;break;case 124:_=A===124?1:0;break;case 32:_=p?0:1;break;default:_=R.get(P)}_===1&&(y.push(E._createLink(R,g,b,l,r)),F=!0)}else if(f===12){let _;P===91?(w=!0,_=0):_=R.get(P),_===1?F=!0:f=13}else f=N.nextState(f,P),f===0&&(F=!0);F&&(f=1,v=!1,w=!1,D=!1,l=r+1,A=P),r++}f===13&&y.push(E._createLink(R,g,b,l,m))}return y}}t.LinkComputer=E;function o(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:E.computeLinks(h)}t.computeLinks=o}),J(K[45],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class S{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,u,L,d,a){if(i&&u){const s=this.doNavigateValueSet(u,a);if(s)return{range:i,value:s}}if(L&&d){const s=this.doNavigateValueSet(d,a);if(s)return{range:L,value:s}}return null}doNavigateValueSet(i,u){const L=this.numberReplace(i,u);return L!==null?L:this.textReplace(i,u)}numberReplace(i,u){const L=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let d=Number(i);const a=parseFloat(i);return!isNaN(d)&&!isNaN(a)&&d===a?d===0&&!u?null:(d=Math.floor(d*L),d+=u?L:-L,String(d/L)):null}textReplace(i,u){return this.valueSetsReplace(this._defaultValueSet,i,u)}valueSetsReplace(i,u,L){let d=null;for(let a=0,s=i.length;d===null&&a<s;a++)d=this.valueSetReplace(i[a],u,L);return d}valueSetReplace(i,u,L){let d=i.indexOf(u);return d>=0?(d+=L?1:-1,d<0?d=i.length-1:d%=i.length,i[d]):null}}t.BasicInplaceReplace=S,S.INSTANCE=new S}),J(K[46],ee([0,1,11]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.isITextSnapshot=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var k;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(k||(t.OverviewRulerLane=k={}));var i;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(i||(t.GlyphMarginLane=i={}));var u;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(u||(t.MinimapPosition=u={}));var L;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(L||(t.InjectedTextCursorStops=L={}));var d;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(d||(t.EndOfLinePreference=d={}));var a;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(a||(t.DefaultEndOfLine=a={}));var s;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class c{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),m.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,m.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!m.insertSpaces,this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=!!m.trimAutoWhitespace,this.bracketPairColorizationOptions=m.bracketPairColorizationOptions}equals(m){return this.tabSize===m.tabSize&&this._indentSizeIsTabSize===m._indentSizeIsTabSize&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace&&(0,S.equals)(this.bracketPairColorizationOptions,m.bracketPairColorizationOptions)}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}t.TextModelResolvedOptions=c;class E{constructor(m,r){this._findMatchBrand=void 0,this.range=m,this.matches=r}}t.FindMatch=E;var o;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(o||(t.TrackedRangeStickiness=o={}));function h(g){return g&&typeof g.read=="function"}t.isITextSnapshot=h;var e;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None",g[g.LeftOfInjectedText=3]="LeftOfInjectedText",g[g.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var N;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(N||(t.ModelConstants=N={}));class R{constructor(m,r,l,A,f,v){this.identifier=m,this.range=r,this.text=l,this.forceMoveMarkers=A,this.isAutoWhitespaceEdit=f,this._isTracked=v}}t.ValidAnnotatedEditOperation=R;class y{constructor(m,r,l){this.regex=m,this.wordSeparators=r,this.simpleSearch=l}}t.SearchData=y;class b{constructor(m,r,l){this.reverseEdits=m,this.changes=r,this.trimAutoWhitespaceLineNumbers=l}}t.ApplyEditsResult=b;function M(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}t.shouldSynchronizeModel=M}),J(K[47],ee([0,1,29,22]),function(V,t,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class i{constructor(a){this.values=a,this.prefixSum=new Uint32Array(a.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(a,s){a=(0,k.toUint32)(a);const c=this.values,E=this.prefixSum,o=s.length;return o===0?!1:(this.values=new Uint32Array(c.length+o),this.values.set(c.subarray(0,a),0),this.values.set(c.subarray(a),a+o),this.values.set(s,a),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(E.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(a,s){return a=(0,k.toUint32)(a),s=(0,k.toUint32)(s),this.values[a]===s?!1:(this.values[a]=s,a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),!0)}removeValues(a,s){a=(0,k.toUint32)(a),s=(0,k.toUint32)(s);const c=this.values,E=this.prefixSum;if(a>=c.length)return!1;const o=c.length-a;return s>=o&&(s=o),s===0?!1:(this.values=new Uint32Array(c.length-s),this.values.set(c.subarray(0,a),0),this.values.set(c.subarray(a+s),a),this.prefixSum=new Uint32Array(this.values.length),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(E.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(a){return a<0?0:(a=(0,k.toUint32)(a),this._getPrefixSum(a))}_getPrefixSum(a){if(a<=this.prefixSumValidIndex[0])return this.prefixSum[a];let s=this.prefixSumValidIndex[0]+1;s===0&&(this.prefixSum[0]=this.values[0],s++),a>=this.values.length&&(a=this.values.length-1);for(let c=s;c<=a;c++)this.prefixSum[c]=this.prefixSum[c-1]+this.values[c];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],a),this.prefixSum[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let s=0,c=this.values.length-1,E=0,o=0,h=0;for(;s<=c;)if(E=s+(c-s)/2|0,o=this.prefixSum[E],h=o-this.values[E],a<h)c=E-1;else if(a>=o)s=E+1;else break;return new L(E,a-h)}}t.PrefixSumComputer=i;class u{constructor(a){this._values=a,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(a){return this._ensureValid(),a===0?0:this._prefixSum[a-1]}getIndexOf(a){this._ensureValid();const s=this._indexBySum[a],c=s>0?this._prefixSum[s-1]:0;return new L(s,a-c)}removeValues(a,s){this._values.splice(a,s),this._invalidate(a)}insertValues(a,s){this._values=(0,S.arrayInsert)(this._values,a,s),this._invalidate(a)}_invalidate(a){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,a-1)}_ensureValid(){if(!this._isValid){for(let a=this._validEndIndex+1,s=this._values.length;a<s;a++){const c=this._values[a],E=a>0?this._prefixSum[a-1]:0;this._prefixSum[a]=E+c;for(let o=0;o<c;o++)this._indexBySum[E+o]=a}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(a,s){this._values[a]!==s&&(this._values[a]=s,this._invalidate(a))}}t.ConstantTimePrefixSumComputer=u;class L{constructor(a,s){this.index=a,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=s}}t.PrefixSumIndexOfResult=L}),J(K[48],ee([0,1,5,4,47]),function(V,t,S,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class u{constructor(d,a,s,c){this._uri=d,this._lines=a,this._eol=s,this._versionId=c,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(d){d.eol&&d.eol!==this._eol&&(this._eol=d.eol,this._lineStarts=null);const a=d.changes;for(const s of a)this._acceptDeleteRange(s.range),this._acceptInsertText(new k.Position(s.range.startLineNumber,s.range.startColumn),s.text);this._versionId=d.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const d=this._eol.length,a=this._lines.length,s=new Uint32Array(a);for(let c=0;c<a;c++)s[c]=this._lines[c].length+d;this._lineStarts=new i.PrefixSumComputer(s)}}_setLineText(d,a){this._lines[d]=a,this._lineStarts&&this._lineStarts.setValue(d,this._lines[d].length+this._eol.length)}_acceptDeleteRange(d){if(d.startLineNumber===d.endLineNumber){if(d.startColumn===d.endColumn)return;this._setLineText(d.startLineNumber-1,this._lines[d.startLineNumber-1].substring(0,d.startColumn-1)+this._lines[d.startLineNumber-1].substring(d.endColumn-1));return}this._setLineText(d.startLineNumber-1,this._lines[d.startLineNumber-1].substring(0,d.startColumn-1)+this._lines[d.endLineNumber-1].substring(d.endColumn-1)),this._lines.splice(d.startLineNumber,d.endLineNumber-d.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(d.startLineNumber,d.endLineNumber-d.startLineNumber)}_acceptInsertText(d,a){if(a.length===0)return;const s=(0,S.splitLines)(a);if(s.length===1){this._setLineText(d.lineNumber-1,this._lines[d.lineNumber-1].substring(0,d.column-1)+s[0]+this._lines[d.lineNumber-1].substring(d.column-1));return}s[s.length-1]+=this._lines[d.lineNumber-1].substring(d.column-1),this._setLineText(d.lineNumber-1,this._lines[d.lineNumber-1].substring(0,d.column-1)+s[0]);const c=new Uint32Array(s.length-1);for(let E=1;E<s.length;E++)this._lines.splice(d.lineNumber+E-1,0,s[E]),c[E-1]=s[E].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(d.lineNumber,c)}}t.MirrorTextModel=u}),J(K[49],ee([0,1,5,36,4,2,46]),function(V,t,S,k,i,u,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0;const d=999;class a{constructor(b,M,g,m){this.searchString=b,this.isRegex=M,this.matchCase=g,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=s(this.searchString):b=this.searchString.indexOf(`
`)>=0;let M=null;try{M=S.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!M)return null;let g=!this.isRegex&&!b;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new L.SearchData(M,this.wordSeparators?(0,k.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}t.SearchParams=a;function s(y){if(!y||y.length===0)return!1;for(let b=0,M=y.length;b<M;b++){const g=y.charCodeAt(b);if(g===10)return!0;if(g===92){if(b++,b>=M)break;const m=y.charCodeAt(b);if(m===110||m===114||m===87)return!0}}return!1}t.isMultilineRegexSource=s;function c(y,b,M){if(!M)return new L.FindMatch(y,null);const g=[];for(let m=0,r=b.length;m<r;m++)g[m]=b[m];return new L.FindMatch(y,g)}t.createFindMatch=c;class E{constructor(b){const M=[];let g=0;for(let m=0,r=b.length;m<r;m++)b.charCodeAt(m)===10&&(M[g++]=m);this._lineFeedsOffsets=M}findLineFeedCountBeforeOffset(b){const M=this._lineFeedsOffsets;let g=0,m=M.length-1;if(m===-1||b<=M[0])return 0;for(;g<m;){const r=g+((m-g)/2>>0);M[r]>=b?m=r-1:M[r+1]>=b?(g=r,m=r):g=r+1}return g+1}}class o{static findMatches(b,M,g,m,r){const l=M.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(b,g,new R(l.wordSeparators,l.regex),m,r):this._doFindMatchesLineByLine(b,g,l,m,r):[]}static _getMultilineMatchRange(b,M,g,m,r,l){let A,f=0;m?(f=m.findLineFeedCountBeforeOffset(r),A=M+r+f):A=M+r;let v;if(m){const F=m.findLineFeedCountBeforeOffset(r+l.length)-f;v=A+l.length+F}else v=A+l.length;const w=b.getPositionAt(A),p=b.getPositionAt(v);return new u.Range(w.lineNumber,w.column,p.lineNumber,p.column)}static _doFindMatchesMultiline(b,M,g,m,r){const l=b.getOffsetAt(M.getStartPosition()),A=b.getValueInRange(M,1),f=b.getEOL()===`\r
`?new E(A):null,v=[];let w=0,p;for(g.reset(0);p=g.next(A);)if(v[w++]=c(this._getMultilineMatchRange(b,l,A,f,p.index,p[0]),p,m),w>=r)return v;return v}static _doFindMatchesLineByLine(b,M,g,m,r){const l=[];let A=0;if(M.startLineNumber===M.endLineNumber){const v=b.getLineContent(M.startLineNumber).substring(M.startColumn-1,M.endColumn-1);return A=this._findMatchesInLine(g,v,M.startLineNumber,M.startColumn-1,A,l,m,r),l}const f=b.getLineContent(M.startLineNumber).substring(M.startColumn-1);A=this._findMatchesInLine(g,f,M.startLineNumber,M.startColumn-1,A,l,m,r);for(let v=M.startLineNumber+1;v<M.endLineNumber&&A<r;v++)A=this._findMatchesInLine(g,b.getLineContent(v),v,0,A,l,m,r);if(A<r){const v=b.getLineContent(M.endLineNumber).substring(0,M.endColumn-1);A=this._findMatchesInLine(g,v,M.endLineNumber,0,A,l,m,r)}return l}static _findMatchesInLine(b,M,g,m,r,l,A,f){const v=b.wordSeparators;if(!A&&b.simpleSearch){const D=b.simpleSearch,F=D.length,P=M.length;let _=-F;for(;(_=M.indexOf(D,_+F))!==-1;)if((!v||N(v,M,P,_,F))&&(l[r++]=new L.FindMatch(new u.Range(g,_+1+m,g,_+1+F+m),null),r>=f))return r;return r}const w=new R(b.wordSeparators,b.regex);let p;w.reset(0);do if(p=w.next(M),p&&(l[r++]=c(new u.Range(g,p.index+1+m,g,p.index+1+p[0].length+m),p,A),r>=f))return r;while(p);return r}static findNextMatch(b,M,g,m){const r=M.parseSearchRequest();if(!r)return null;const l=new R(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(b,g,l,m):this._doFindNextMatchLineByLine(b,g,l,m)}static _doFindNextMatchMultiline(b,M,g,m){const r=new i.Position(M.lineNumber,1),l=b.getOffsetAt(r),A=b.getLineCount(),f=b.getValueInRange(new u.Range(r.lineNumber,r.column,A,b.getLineMaxColumn(A)),1),v=b.getEOL()===`\r
`?new E(f):null;g.reset(M.column-1);const w=g.next(f);return w?c(this._getMultilineMatchRange(b,l,f,v,w.index,w[0]),w,m):M.lineNumber!==1||M.column!==1?this._doFindNextMatchMultiline(b,new i.Position(1,1),g,m):null}static _doFindNextMatchLineByLine(b,M,g,m){const r=b.getLineCount(),l=M.lineNumber,A=b.getLineContent(l),f=this._findFirstMatchInLine(g,A,l,M.column,m);if(f)return f;for(let v=1;v<=r;v++){const w=(l+v-1)%r,p=b.getLineContent(w+1),D=this._findFirstMatchInLine(g,p,w+1,1,m);if(D)return D}return null}static _findFirstMatchInLine(b,M,g,m,r){b.reset(m-1);const l=b.next(M);return l?c(new u.Range(g,l.index+1,g,l.index+1+l[0].length),l,r):null}static findPreviousMatch(b,M,g,m){const r=M.parseSearchRequest();if(!r)return null;const l=new R(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(b,g,l,m):this._doFindPreviousMatchLineByLine(b,g,l,m)}static _doFindPreviousMatchMultiline(b,M,g,m){const r=this._doFindMatchesMultiline(b,new u.Range(1,1,M.lineNumber,M.column),g,m,10*d);if(r.length>0)return r[r.length-1];const l=b.getLineCount();return M.lineNumber!==l||M.column!==b.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(b,new i.Position(l,b.getLineMaxColumn(l)),g,m):null}static _doFindPreviousMatchLineByLine(b,M,g,m){const r=b.getLineCount(),l=M.lineNumber,A=b.getLineContent(l).substring(0,M.column-1),f=this._findLastMatchInLine(g,A,l,m);if(f)return f;for(let v=1;v<=r;v++){const w=(r+l-v-1)%r,p=b.getLineContent(w+1),D=this._findLastMatchInLine(g,p,w+1,m);if(D)return D}return null}static _findLastMatchInLine(b,M,g,m){let r=null,l;for(b.reset(0);l=b.next(M);)r=c(new u.Range(g,l.index+1,g,l.index+1+l[0].length),l,m);return r}}t.TextModelSearch=o;function h(y,b,M,g,m){if(g===0)return!0;const r=b.charCodeAt(g-1);if(y.get(r)!==0||r===13||r===10)return!0;if(m>0){const l=b.charCodeAt(g);if(y.get(l)!==0)return!0}return!1}function e(y,b,M,g,m){if(g+m===M)return!0;const r=b.charCodeAt(g+m);if(y.get(r)!==0||r===13||r===10)return!0;if(m>0){const l=b.charCodeAt(g+m-1);if(y.get(l)!==0)return!0}return!1}function N(y,b,M,g,m){return h(y,b,M,g,m)&&e(y,b,M,g,m)}t.isValidMatch=N;class R{constructor(b,M){this._wordSeparators=b,this._searchRegex=M,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(b){this._searchRegex.lastIndex=b,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(b){const M=b.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===M||(g=this._searchRegex.exec(b),!g))return null;const m=g.index,r=g[0].length;if(m===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){S.getNextCodePoint(b,M,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=m,this._prevMatchLength=r,!this._wordSeparators||N(this._wordSeparators,b,M,m,r))return g}while(g);return null}}t.Searcher=R}),J(K[50],ee([0,1,2,49,5,10,24]),function(V,t,S,k,i,u,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class d{static computeUnicodeHighlights(e,N,R){const y=R?R.startLineNumber:1,b=R?R.endLineNumber:e.getLineCount(),M=new c(N),g=M.getCandidateCodePoints();let m;g==="allNonBasicAscii"?m=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):m=new RegExp(`${a(Array.from(g))}`,"g");const r=new k.Searcher(null,m),l=[];let A=!1,f,v=0,w=0,p=0;e:for(let D=y,F=b;D<=F;D++){const P=e.getLineContent(D),_=P.length;r.reset(0);do if(f=r.next(P),f){let I=f.index,C=f.index+f[0].length;if(I>0){const X=P.charCodeAt(I-1);i.isHighSurrogate(X)&&I--}if(C+1<_){const X=P.charCodeAt(C-1);i.isHighSurrogate(X)&&C++}const q=P.substring(I,C);let j=(0,L.getWordAtText)(I+1,L.DEFAULT_WORD_REGEXP,P,0);j&&j.endColumn<=I+1&&(j=null);const G=M.shouldHighlightNonBasicASCII(q,j?j.word:null);if(G!==0){G===3?v++:G===2?w++:G===1?p++:(0,u.assertNever)(G);const X=1e3;if(l.length>=X){A=!0;break e}l.push(new S.Range(D,I+1,D,C+1))}}while(f)}return{ranges:l,hasMore:A,ambiguousCharacterCount:v,invisibleCharacterCount:w,nonBasicAsciiCharacterCount:p}}static computeUnicodeHighlightReason(e,N){const R=new c(N);switch(R.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const b=e.codePointAt(0),M=R.ambiguousCharacters.getPrimaryConfusable(b),g=i.AmbiguousCharacters.getLocales().filter(m=>!i.AmbiguousCharacters.getInstance(new Set([...N.allowedLocales,m])).isAmbiguous(b));return{kind:0,confusableWith:String.fromCodePoint(M),notAmbiguousInLocales:g}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=d;function a(h,e){return`[${i.escapeRegExpCharacters(h.map(R=>String.fromCodePoint(R)).join(""))}]`}var s;(function(h){h[h.Ambiguous=0]="Ambiguous",h[h.Invisible=1]="Invisible",h[h.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class c{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const N of i.InvisibleCharacters.codePoints)E(String.fromCodePoint(N))||e.add(N);if(this.options.ambiguousCharacters)for(const N of this.ambiguousCharacters.getConfusableCodePoints())e.add(N);for(const N of this.allowedCodePoints)e.delete(N);return e}shouldHighlightNonBasicASCII(e,N){const R=e.codePointAt(0);if(this.allowedCodePoints.has(R))return 0;if(this.options.nonBasicASCII)return 1;let y=!1,b=!1;if(N)for(const M of N){const g=M.codePointAt(0),m=i.isBasicASCII(M);y=y||m,!m&&!this.ambiguousCharacters.isAmbiguous(g)&&!i.InvisibleCharacters.isInvisibleCharacter(g)&&(b=!0)}return!y&&b?0:this.options.invisibleCharacters&&!E(e)&&i.InvisibleCharacters.isInvisibleCharacter(R)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(R)?3:0}}function E(h){return h===" "||h===`
`||h==="	"}var o;(function(h){h[h.None=0]="None",h[h.NonBasicASCII=1]="NonBasicASCII",h[h.Invisible=2]="Invisible",h[h.Ambiguous=3]="Ambiguous"})(o||(o={}))}),J(K[51],ee([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var S;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(S||(t.AccessibilitySupport=S={}));var k;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(k||(t.CodeActionTriggerType=k={}));var i;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(i||(t.CompletionItemInsertTextRule=i={}));var u;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(u||(t.CompletionItemKind=u={}));var L;(function(n){n[n.Deprecated=1]="Deprecated"})(L||(t.CompletionItemTag=L={}));var d;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(t.CompletionTriggerKind=d={}));var a;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(a||(t.ContentWidgetPositionPreference=a={}));var s;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var c;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(c||(t.DefaultEndOfLine=c={}));var E;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(E||(t.DocumentHighlightKind=E={}));var o;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(o||(t.EditorAutoIndentStrategy=o={}));var h;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=7]="autoClosingDelete",n[n.autoClosingOvertype=8]="autoClosingOvertype",n[n.autoClosingQuotes=9]="autoClosingQuotes",n[n.autoIndent=10]="autoIndent",n[n.automaticLayout=11]="automaticLayout",n[n.autoSurround=12]="autoSurround",n[n.bracketPairColorization=13]="bracketPairColorization",n[n.guides=14]="guides",n[n.codeLens=15]="codeLens",n[n.codeLensFontFamily=16]="codeLensFontFamily",n[n.codeLensFontSize=17]="codeLensFontSize",n[n.colorDecorators=18]="colorDecorators",n[n.colorDecoratorsLimit=19]="colorDecoratorsLimit",n[n.columnSelection=20]="columnSelection",n[n.comments=21]="comments",n[n.contextmenu=22]="contextmenu",n[n.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",n[n.cursorBlinking=24]="cursorBlinking",n[n.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",n[n.cursorStyle=26]="cursorStyle",n[n.cursorSurroundingLines=27]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",n[n.cursorWidth=29]="cursorWidth",n[n.disableLayerHinting=30]="disableLayerHinting",n[n.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",n[n.domReadOnly=32]="domReadOnly",n[n.dragAndDrop=33]="dragAndDrop",n[n.dropIntoEditor=34]="dropIntoEditor",n[n.emptySelectionClipboard=35]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",n[n.extraEditorClassName=37]="extraEditorClassName",n[n.fastScrollSensitivity=38]="fastScrollSensitivity",n[n.find=39]="find",n[n.fixedOverflowWidgets=40]="fixedOverflowWidgets",n[n.folding=41]="folding",n[n.foldingStrategy=42]="foldingStrategy",n[n.foldingHighlight=43]="foldingHighlight",n[n.foldingImportsByDefault=44]="foldingImportsByDefault",n[n.foldingMaximumRegions=45]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=47]="fontFamily",n[n.fontInfo=48]="fontInfo",n[n.fontLigatures=49]="fontLigatures",n[n.fontSize=50]="fontSize",n[n.fontWeight=51]="fontWeight",n[n.fontVariations=52]="fontVariations",n[n.formatOnPaste=53]="formatOnPaste",n[n.formatOnType=54]="formatOnType",n[n.glyphMargin=55]="glyphMargin",n[n.gotoLocation=56]="gotoLocation",n[n.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",n[n.hover=58]="hover",n[n.inDiffEditor=59]="inDiffEditor",n[n.inlineSuggest=60]="inlineSuggest",n[n.letterSpacing=61]="letterSpacing",n[n.lightbulb=62]="lightbulb",n[n.lineDecorationsWidth=63]="lineDecorationsWidth",n[n.lineHeight=64]="lineHeight",n[n.lineNumbers=65]="lineNumbers",n[n.lineNumbersMinChars=66]="lineNumbersMinChars",n[n.linkedEditing=67]="linkedEditing",n[n.links=68]="links",n[n.matchBrackets=69]="matchBrackets",n[n.minimap=70]="minimap",n[n.mouseStyle=71]="mouseStyle",n[n.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=73]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",n[n.multiCursorModifier=75]="multiCursorModifier",n[n.multiCursorPaste=76]="multiCursorPaste",n[n.multiCursorLimit=77]="multiCursorLimit",n[n.occurrencesHighlight=78]="occurrencesHighlight",n[n.overviewRulerBorder=79]="overviewRulerBorder",n[n.overviewRulerLanes=80]="overviewRulerLanes",n[n.padding=81]="padding",n[n.pasteAs=82]="pasteAs",n[n.parameterHints=83]="parameterHints",n[n.peekWidgetDefaultFocus=84]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=85]="definitionLinkOpensInPeek",n[n.quickSuggestions=86]="quickSuggestions",n[n.quickSuggestionsDelay=87]="quickSuggestionsDelay",n[n.readOnly=88]="readOnly",n[n.readOnlyMessage=89]="readOnlyMessage",n[n.renameOnType=90]="renameOnType",n[n.renderControlCharacters=91]="renderControlCharacters",n[n.renderFinalNewline=92]="renderFinalNewline",n[n.renderLineHighlight=93]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=94]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=95]="renderValidationDecorations",n[n.renderWhitespace=96]="renderWhitespace",n[n.revealHorizontalRightPadding=97]="revealHorizontalRightPadding",n[n.roundedSelection=98]="roundedSelection",n[n.rulers=99]="rulers",n[n.scrollbar=100]="scrollbar",n[n.scrollBeyondLastColumn=101]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=102]="scrollBeyondLastLine",n[n.scrollPredominantAxis=103]="scrollPredominantAxis",n[n.selectionClipboard=104]="selectionClipboard",n[n.selectionHighlight=105]="selectionHighlight",n[n.selectOnLineNumbers=106]="selectOnLineNumbers",n[n.showFoldingControls=107]="showFoldingControls",n[n.showUnused=108]="showUnused",n[n.snippetSuggestions=109]="snippetSuggestions",n[n.smartSelect=110]="smartSelect",n[n.smoothScrolling=111]="smoothScrolling",n[n.stickyScroll=112]="stickyScroll",n[n.stickyTabStops=113]="stickyTabStops",n[n.stopRenderingLineAfter=114]="stopRenderingLineAfter",n[n.suggest=115]="suggest",n[n.suggestFontSize=116]="suggestFontSize",n[n.suggestLineHeight=117]="suggestLineHeight",n[n.suggestOnTriggerCharacters=118]="suggestOnTriggerCharacters",n[n.suggestSelection=119]="suggestSelection",n[n.tabCompletion=120]="tabCompletion",n[n.tabIndex=121]="tabIndex",n[n.unicodeHighlighting=122]="unicodeHighlighting",n[n.unusualLineTerminators=123]="unusualLineTerminators",n[n.useShadowDOM=124]="useShadowDOM",n[n.useTabStops=125]="useTabStops",n[n.wordBreak=126]="wordBreak",n[n.wordSeparators=127]="wordSeparators",n[n.wordWrap=128]="wordWrap",n[n.wordWrapBreakAfterCharacters=129]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=130]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=131]="wordWrapColumn",n[n.wordWrapOverride1=132]="wordWrapOverride1",n[n.wordWrapOverride2=133]="wordWrapOverride2",n[n.wrappingIndent=134]="wrappingIndent",n[n.wrappingStrategy=135]="wrappingStrategy",n[n.showDeprecated=136]="showDeprecated",n[n.inlayHints=137]="inlayHints",n[n.editorClassName=138]="editorClassName",n[n.pixelRatio=139]="pixelRatio",n[n.tabFocusMode=140]="tabFocusMode",n[n.layoutInfo=141]="layoutInfo",n[n.wrappingInfo=142]="wrappingInfo",n[n.defaultColorDecorators=143]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=144]="colorDecoratorsActivatedOn"})(h||(t.EditorOption=h={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var N;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(N||(t.EndOfLineSequence=N={}));var R;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(R||(t.GlyphMarginLane=R={}));var y;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(y||(t.IndentAction=y={}));var b;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(b||(t.InjectedTextCursorStops=b={}));var M;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(M||(t.InlayHintKind=M={}));var g;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(g||(t.InlineCompletionTriggerKind=g={}));var m;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(m||(t.KeyCode=m={}));var r;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(r||(t.MarkerSeverity=r={}));var l;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(l||(t.MarkerTag=l={}));var A;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(A||(t.MinimapPosition=A={}));var f;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(f||(t.MouseTargetType=f={}));var v;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(v||(t.OverlayWidgetPositionPreference=v={}));var w;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(w||(t.OverviewRulerLane=w={}));var p;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(p||(t.PositionAffinity=p={}));var D;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(D||(t.RenderLineNumbersType=D={}));var F;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(F||(t.RenderMinimap=F={}));var P;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(P||(t.ScrollType=P={}));var _;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(_||(t.ScrollbarVisibility=_={}));var I;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(I||(t.SelectionDirection=I={}));var C;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(C||(t.SignatureHelpTriggerKind=C={}));var q;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(q||(t.SymbolKind=q={}));var j;(function(n){n[n.Deprecated=1]="Deprecated"})(j||(t.SymbolTag=j={}));var G;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(G||(t.TextEditorCursorBlinkingStyle=G={}));var X;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(X||(t.TextEditorCursorStyle=X={}));var $;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})($||(t.TrackedRangeStickiness=$={}));var ne;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(ne||(t.WrappingIndent=ne={}))}),J(K[52],ee([0,1,8,7]),function(V,t,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class i{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(d){this._onDidChange.fire({changedLanguages:d,changedColorMap:!1})}register(d,a){return this._tokenizationSupports.set(d,a),this.handleChange([d]),(0,k.toDisposable)(()=>{this._tokenizationSupports.get(d)===a&&(this._tokenizationSupports.delete(d),this.handleChange([d]))})}get(d){return this._tokenizationSupports.get(d)||null}registerFactory(d,a){this._factories.get(d)?.dispose();const s=new u(this,d,a);return this._factories.set(d,s),(0,k.toDisposable)(()=>{const c=this._factories.get(d);!c||c!==s||(this._factories.delete(d),c.dispose())})}async getOrCreate(d){const a=this.get(d);if(a)return a;const s=this._factories.get(d);return!s||s.isResolved?null:(await s.resolve(),this.get(d))}isResolved(d){if(this.get(d))return!0;const s=this._factories.get(d);return!!(!s||s.isResolved)}setColorMap(d){this._colorMap=d,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}t.TokenizationRegistry=i;class u extends k.Disposable{get isResolved(){return this._isResolved}constructor(d,a,s){super(),this._registry=d,this._languageId=a,this._factory=s,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const d=await this._factory.tokenizationSupport;this._isResolved=!0,d&&!this._isDisposed&&this._register(this._registry.register(this._languageId,d))}}}),J(K[53],ee([59,60]),function(V,t){return V.create("vs/base/common/platform",t)}),J(K[13],ee([0,1,53]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let k=!1,i=!1,u=!1,L=!1,d=!1,a=!1,s=!1,c=!1,E=!1,o=!1,h,e=t.LANGUAGE_DEFAULT,N=t.LANGUAGE_DEFAULT,R,y;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let b;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?b=t.globals.vscode.process:typeof process<"u"&&(b=process);const M=typeof b?.versions?.electron=="string",g=M&&b?.type==="renderer";if(typeof navigator=="object"&&!g)y=navigator.userAgent,k=y.indexOf("Windows")>=0,i=y.indexOf("Macintosh")>=0,c=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,u=y.indexOf("Linux")>=0,o=y?.indexOf("Mobi")>=0,a=!0,h=S.getConfiguredDefaultLocale(S.localize(0,null))||t.LANGUAGE_DEFAULT,e=h,N=navigator.language;else if(typeof b=="object"){k=b.platform==="win32",i=b.platform==="darwin",u=b.platform==="linux",L=u&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,s=M,E=!!b.env.CI||!!b.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const D=b.env.VSCODE_NLS_CONFIG;if(D)try{const F=JSON.parse(D),P=F.availableLanguages["*"];h=F.locale,N=F.osLocale,e=P||t.LANGUAGE_DEFAULT,R=F._translationsConfigFile}catch{}d=!0}else console.error("Unable to resolve platform.");var m;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(m||(t.Platform=m={}));function r(D){switch(D){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=r;let l=0;i?l=1:k?l=3:u&&(l=2),t.isWindows=k,t.isMacintosh=i,t.isLinux=u,t.isLinuxSnap=L,t.isNative=d,t.isElectron=s,t.isWeb=a,t.isWebWorker=a&&typeof t.globals.importScripts=="function",t.isIOS=c,t.isMobile=o,t.isCI=E,t.platform=l,t.userAgent=y,t.language=e;var A;(function(D){function F(){return t.language}D.value=F;function P(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}D.isDefaultVariant=P;function _(){return t.language==="en"}D.isDefault=_})(A||(t.Language=A={})),t.locale=h,t.platformLocale=N,t.translationsConfigFile=R,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const D=[];t.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let _=0,I=D.length;_<I;_++){const C=D[_];if(C.id===P.data.vscodeScheduleAsyncWork){D.splice(_,1),C.callback();return}}});let F=0;return P=>{const _=++F;D.push({id:_,callback:P}),t.globals.postMessage({vscodeScheduleAsyncWork:_},"*")}}return D=>setTimeout(D)})();var f;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(f||(t.OperatingSystem=f={})),t.OS=i||c?2:k?1:3;let v=!0,w=!1;function p(){if(!w){w=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,v=new Uint16Array(D.buffer)[0]===(2<<8)+1}return v}t.isLittleEndian=p,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),J(K[54],ee([0,1,13]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let k;if(typeof S.globals.vscode<"u"&&typeof S.globals.vscode.process<"u"){const i=S.globals.vscode.process;k={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?k={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:k={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=k.cwd,t.env=k.env,t.platform=k.platform,t.arch=k.arch}),J(K[55],ee([0,1,54]),function(V,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const k=65,i=97,u=90,L=122,d=46,a=47,s=92,c=58,E=63;class o extends Error{constructor(l,A,f){let v;typeof A=="string"&&A.indexOf("not ")===0?(v="must not be",A=A.replace(/^not /,"")):v="must be";const w=l.indexOf(".")!==-1?"property":"argument";let p=`The "${l}" ${w} ${v} of type ${A}`;p+=`. Received type ${typeof f}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function h(r,l){if(r===null||typeof r!="object")throw new o(l,"Object",r)}function e(r,l){if(typeof r!="string")throw new o(l,"string",r)}const N=S.platform==="win32";function R(r){return r===a||r===s}function y(r){return r===a}function b(r){return r>=k&&r<=u||r>=i&&r<=L}function M(r,l,A,f){let v="",w=0,p=-1,D=0,F=0;for(let P=0;P<=r.length;++P){if(P<r.length)F=r.charCodeAt(P);else{if(f(F))break;F=a}if(f(F)){if(!(p===P-1||D===1))if(D===2){if(v.length<2||w!==2||v.charCodeAt(v.length-1)!==d||v.charCodeAt(v.length-2)!==d){if(v.length>2){const _=v.lastIndexOf(A);_===-1?(v="",w=0):(v=v.slice(0,_),w=v.length-1-v.lastIndexOf(A)),p=P,D=0;continue}else if(v.length!==0){v="",w=0,p=P,D=0;continue}}l&&(v+=v.length>0?`${A}..`:"..",w=2)}else v.length>0?v+=`${A}${r.slice(p+1,P)}`:v=r.slice(p+1,P),w=P-p-1;p=P,D=0}else F===d&&D!==-1?++D:D=-1}return v}function g(r,l){h(l,"pathObject");const A=l.dir||l.root,f=l.base||`${l.name||""}${l.ext||""}`;return A?A===l.root?`${A}${f}`:`${A}${r}${f}`:f}t.win32={resolve(...r){let l="",A="",f=!1;for(let v=r.length-1;v>=-1;v--){let w;if(v>=0){if(w=r[v],e(w,"path"),w.length===0)continue}else l.length===0?w=S.cwd():(w=S.env[`=${l}`]||S.cwd(),(w===void 0||w.slice(0,2).toLowerCase()!==l.toLowerCase()&&w.charCodeAt(2)===s)&&(w=`${l}\\`));const p=w.length;let D=0,F="",P=!1;const _=w.charCodeAt(0);if(p===1)R(_)&&(D=1,P=!0);else if(R(_))if(P=!0,R(w.charCodeAt(1))){let I=2,C=I;for(;I<p&&!R(w.charCodeAt(I));)I++;if(I<p&&I!==C){const q=w.slice(C,I);for(C=I;I<p&&R(w.charCodeAt(I));)I++;if(I<p&&I!==C){for(C=I;I<p&&!R(w.charCodeAt(I));)I++;(I===p||I!==C)&&(F=`\\\\${q}\\${w.slice(C,I)}`,D=I)}}}else D=1;else b(_)&&w.charCodeAt(1)===c&&(F=w.slice(0,2),D=2,p>2&&R(w.charCodeAt(2))&&(P=!0,D=3));if(F.length>0)if(l.length>0){if(F.toLowerCase()!==l.toLowerCase())continue}else l=F;if(f){if(l.length>0)break}else if(A=`${w.slice(D)}\\${A}`,f=P,P&&l.length>0)break}return A=M(A,!f,"\\",R),f?`${l}\\${A}`:`${l}${A}`||"."},normalize(r){e(r,"path");const l=r.length;if(l===0)return".";let A=0,f,v=!1;const w=r.charCodeAt(0);if(l===1)return y(w)?"\\":r;if(R(w))if(v=!0,R(r.charCodeAt(1))){let D=2,F=D;for(;D<l&&!R(r.charCodeAt(D));)D++;if(D<l&&D!==F){const P=r.slice(F,D);for(F=D;D<l&&R(r.charCodeAt(D));)D++;if(D<l&&D!==F){for(F=D;D<l&&!R(r.charCodeAt(D));)D++;if(D===l)return`\\\\${P}\\${r.slice(F)}\\`;D!==F&&(f=`\\\\${P}\\${r.slice(F,D)}`,A=D)}}}else A=1;else b(w)&&r.charCodeAt(1)===c&&(f=r.slice(0,2),A=2,l>2&&R(r.charCodeAt(2))&&(v=!0,A=3));let p=A<l?M(r.slice(A),!v,"\\",R):"";return p.length===0&&!v&&(p="."),p.length>0&&R(r.charCodeAt(l-1))&&(p+="\\"),f===void 0?v?`\\${p}`:p:v?`${f}\\${p}`:`${f}${p}`},isAbsolute(r){e(r,"path");const l=r.length;if(l===0)return!1;const A=r.charCodeAt(0);return R(A)||l>2&&b(A)&&r.charCodeAt(1)===c&&R(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let l,A;for(let w=0;w<r.length;++w){const p=r[w];e(p,"path"),p.length>0&&(l===void 0?l=A=p:l+=`\\${p}`)}if(l===void 0)return".";let f=!0,v=0;if(typeof A=="string"&&R(A.charCodeAt(0))){++v;const w=A.length;w>1&&R(A.charCodeAt(1))&&(++v,w>2&&(R(A.charCodeAt(2))?++v:f=!1))}if(f){for(;v<l.length&&R(l.charCodeAt(v));)v++;v>=2&&(l=`\\${l.slice(v)}`)}return t.win32.normalize(l)},relative(r,l){if(e(r,"from"),e(l,"to"),r===l)return"";const A=t.win32.resolve(r),f=t.win32.resolve(l);if(A===f||(r=A.toLowerCase(),l=f.toLowerCase(),r===l))return"";let v=0;for(;v<r.length&&r.charCodeAt(v)===s;)v++;let w=r.length;for(;w-1>v&&r.charCodeAt(w-1)===s;)w--;const p=w-v;let D=0;for(;D<l.length&&l.charCodeAt(D)===s;)D++;let F=l.length;for(;F-1>D&&l.charCodeAt(F-1)===s;)F--;const P=F-D,_=p<P?p:P;let I=-1,C=0;for(;C<_;C++){const j=r.charCodeAt(v+C);if(j!==l.charCodeAt(D+C))break;j===s&&(I=C)}if(C!==_){if(I===-1)return f}else{if(P>_){if(l.charCodeAt(D+C)===s)return f.slice(D+C+1);if(C===2)return f.slice(D+C)}p>_&&(r.charCodeAt(v+C)===s?I=C:C===2&&(I=3)),I===-1&&(I=0)}let q="";for(C=v+I+1;C<=w;++C)(C===w||r.charCodeAt(C)===s)&&(q+=q.length===0?"..":"\\..");return D+=I,q.length>0?`${q}${f.slice(D,F)}`:(f.charCodeAt(D)===s&&++D,f.slice(D,F))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const l=t.win32.resolve(r);if(l.length<=2)return r;if(l.charCodeAt(0)===s){if(l.charCodeAt(1)===s){const A=l.charCodeAt(2);if(A!==E&&A!==d)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(b(l.charCodeAt(0))&&l.charCodeAt(1)===c&&l.charCodeAt(2)===s)return`\\\\?\\${l}`;return r},dirname(r){e(r,"path");const l=r.length;if(l===0)return".";let A=-1,f=0;const v=r.charCodeAt(0);if(l===1)return R(v)?r:".";if(R(v)){if(A=f=1,R(r.charCodeAt(1))){let D=2,F=D;for(;D<l&&!R(r.charCodeAt(D));)D++;if(D<l&&D!==F){for(F=D;D<l&&R(r.charCodeAt(D));)D++;if(D<l&&D!==F){for(F=D;D<l&&!R(r.charCodeAt(D));)D++;if(D===l)return r;D!==F&&(A=f=D+1)}}}}else b(v)&&r.charCodeAt(1)===c&&(A=l>2&&R(r.charCodeAt(2))?3:2,f=A);let w=-1,p=!0;for(let D=l-1;D>=f;--D)if(R(r.charCodeAt(D))){if(!p){w=D;break}}else p=!1;if(w===-1){if(A===-1)return".";w=A}return r.slice(0,w)},basename(r,l){l!==void 0&&e(l,"ext"),e(r,"path");let A=0,f=-1,v=!0,w;if(r.length>=2&&b(r.charCodeAt(0))&&r.charCodeAt(1)===c&&(A=2),l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let p=l.length-1,D=-1;for(w=r.length-1;w>=A;--w){const F=r.charCodeAt(w);if(R(F)){if(!v){A=w+1;break}}else D===-1&&(v=!1,D=w+1),p>=0&&(F===l.charCodeAt(p)?--p===-1&&(f=w):(p=-1,f=D))}return A===f?f=D:f===-1&&(f=r.length),r.slice(A,f)}for(w=r.length-1;w>=A;--w)if(R(r.charCodeAt(w))){if(!v){A=w+1;break}}else f===-1&&(v=!1,f=w+1);return f===-1?"":r.slice(A,f)},extname(r){e(r,"path");let l=0,A=-1,f=0,v=-1,w=!0,p=0;r.length>=2&&r.charCodeAt(1)===c&&b(r.charCodeAt(0))&&(l=f=2);for(let D=r.length-1;D>=l;--D){const F=r.charCodeAt(D);if(R(F)){if(!w){f=D+1;break}continue}v===-1&&(w=!1,v=D+1),F===d?A===-1?A=D:p!==1&&(p=1):A!==-1&&(p=-1)}return A===-1||v===-1||p===0||p===1&&A===v-1&&A===f+1?"":r.slice(A,v)},format:g.bind(null,"\\"),parse(r){e(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const A=r.length;let f=0,v=r.charCodeAt(0);if(A===1)return R(v)?(l.root=l.dir=r,l):(l.base=l.name=r,l);if(R(v)){if(f=1,R(r.charCodeAt(1))){let I=2,C=I;for(;I<A&&!R(r.charCodeAt(I));)I++;if(I<A&&I!==C){for(C=I;I<A&&R(r.charCodeAt(I));)I++;if(I<A&&I!==C){for(C=I;I<A&&!R(r.charCodeAt(I));)I++;I===A?f=I:I!==C&&(f=I+1)}}}}else if(b(v)&&r.charCodeAt(1)===c){if(A<=2)return l.root=l.dir=r,l;if(f=2,R(r.charCodeAt(2))){if(A===3)return l.root=l.dir=r,l;f=3}}f>0&&(l.root=r.slice(0,f));let w=-1,p=f,D=-1,F=!0,P=r.length-1,_=0;for(;P>=f;--P){if(v=r.charCodeAt(P),R(v)){if(!F){p=P+1;break}continue}D===-1&&(F=!1,D=P+1),v===d?w===-1?w=P:_!==1&&(_=1):w!==-1&&(_=-1)}return D!==-1&&(w===-1||_===0||_===1&&w===D-1&&w===p+1?l.base=l.name=r.slice(p,D):(l.name=r.slice(p,w),l.base=r.slice(p,D),l.ext=r.slice(w,D))),p>0&&p!==f?l.dir=r.slice(0,p-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const m=(()=>{if(N){const r=/\\/g;return()=>{const l=S.cwd().replace(r,"/");return l.slice(l.indexOf("/"))}}return()=>S.cwd()})();t.posix={resolve(...r){let l="",A=!1;for(let f=r.length-1;f>=-1&&!A;f--){const v=f>=0?r[f]:m();e(v,"path"),v.length!==0&&(l=`${v}/${l}`,A=v.charCodeAt(0)===a)}return l=M(l,!A,"/",y),A?`/${l}`:l.length>0?l:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===a,A=r.charCodeAt(r.length-1)===a;return r=M(r,!l,"/",y),r.length===0?l?"/":A?"./":".":(A&&(r+="/"),l?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===a},join(...r){if(r.length===0)return".";let l;for(let A=0;A<r.length;++A){const f=r[A];e(f,"path"),f.length>0&&(l===void 0?l=f:l+=`/${f}`)}return l===void 0?".":t.posix.normalize(l)},relative(r,l){if(e(r,"from"),e(l,"to"),r===l||(r=t.posix.resolve(r),l=t.posix.resolve(l),r===l))return"";const A=1,f=r.length,v=f-A,w=1,p=l.length-w,D=v<p?v:p;let F=-1,P=0;for(;P<D;P++){const I=r.charCodeAt(A+P);if(I!==l.charCodeAt(w+P))break;I===a&&(F=P)}if(P===D)if(p>D){if(l.charCodeAt(w+P)===a)return l.slice(w+P+1);if(P===0)return l.slice(w+P)}else v>D&&(r.charCodeAt(A+P)===a?F=P:P===0&&(F=0));let _="";for(P=A+F+1;P<=f;++P)(P===f||r.charCodeAt(P)===a)&&(_+=_.length===0?"..":"/..");return`${_}${l.slice(w+F)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===a;let A=-1,f=!0;for(let v=r.length-1;v>=1;--v)if(r.charCodeAt(v)===a){if(!f){A=v;break}}else f=!1;return A===-1?l?"/":".":l&&A===1?"//":r.slice(0,A)},basename(r,l){l!==void 0&&e(l,"ext"),e(r,"path");let A=0,f=-1,v=!0,w;if(l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let p=l.length-1,D=-1;for(w=r.length-1;w>=0;--w){const F=r.charCodeAt(w);if(F===a){if(!v){A=w+1;break}}else D===-1&&(v=!1,D=w+1),p>=0&&(F===l.charCodeAt(p)?--p===-1&&(f=w):(p=-1,f=D))}return A===f?f=D:f===-1&&(f=r.length),r.slice(A,f)}for(w=r.length-1;w>=0;--w)if(r.charCodeAt(w)===a){if(!v){A=w+1;break}}else f===-1&&(v=!1,f=w+1);return f===-1?"":r.slice(A,f)},extname(r){e(r,"path");let l=-1,A=0,f=-1,v=!0,w=0;for(let p=r.length-1;p>=0;--p){const D=r.charCodeAt(p);if(D===a){if(!v){A=p+1;break}continue}f===-1&&(v=!1,f=p+1),D===d?l===-1?l=p:w!==1&&(w=1):l!==-1&&(w=-1)}return l===-1||f===-1||w===0||w===1&&l===f-1&&l===A+1?"":r.slice(l,f)},format:g.bind(null,"/"),parse(r){e(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const A=r.charCodeAt(0)===a;let f;A?(l.root="/",f=1):f=0;let v=-1,w=0,p=-1,D=!0,F=r.length-1,P=0;for(;F>=f;--F){const _=r.charCodeAt(F);if(_===a){if(!D){w=F+1;break}continue}p===-1&&(D=!1,p=F+1),_===d?v===-1?v=F:P!==1&&(P=1):v!==-1&&(P=-1)}if(p!==-1){const _=w===0&&A?1:w;v===-1||P===0||P===1&&v===p-1&&v===w+1?l.base=l.name=r.slice(_,p):(l.name=r.slice(_,v),l.base=r.slice(_,p),l.ext=r.slice(v,p))}return w>0?l.dir=r.slice(0,w-1):A&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=N?t.win32.normalize:t.posix.normalize,t.isAbsolute=N?t.win32.isAbsolute:t.posix.isAbsolute,t.join=N?t.win32.join:t.posix.join,t.resolve=N?t.win32.resolve:t.posix.resolve,t.relative=N?t.win32.relative:t.posix.relative,t.dirname=N?t.win32.dirname:t.posix.dirname,t.basename=N?t.win32.basename:t.posix.basename,t.extname=N?t.win32.extname:t.posix.extname,t.format=N?t.win32.format:t.posix.format,t.parse=N?t.win32.parse:t.posix.parse,t.toNamespacedPath=N?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=N?t.win32.sep:t.posix.sep,t.delimiter=N?t.win32.delimiter:t.posix.delimiter}),J(K[14],ee([0,1,55,13]),function(V,t,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.isUriComponents=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,u=/^\//,L=/^\/\//;function d(f,v){if(!f.scheme&&v)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${f.authority}", path: "${f.path}", query: "${f.query}", fragment: "${f.fragment}"}`);if(f.scheme&&!i.test(f.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(f.path){if(f.authority){if(!u.test(f.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(f.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(f,v){return!f&&!v?"file":f}function s(f,v){switch(f){case"https":case"http":case"file":v?v[0]!==E&&(v=E+v):v=E;break}return v}const c="",E="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(v){return v instanceof h?!0:v?typeof v.authority=="string"&&typeof v.fragment=="string"&&typeof v.path=="string"&&typeof v.query=="string"&&typeof v.scheme=="string"&&typeof v.fsPath=="string"&&typeof v.with=="function"&&typeof v.toString=="function":!1}constructor(v,w,p,D,F,P=!1){typeof v=="object"?(this.scheme=v.scheme||c,this.authority=v.authority||c,this.path=v.path||c,this.query=v.query||c,this.fragment=v.fragment||c):(this.scheme=a(v,P),this.authority=w||c,this.path=s(this.scheme,p||c),this.query=D||c,this.fragment=F||c,d(this,P))}get fsPath(){return g(this,!1)}with(v){if(!v)return this;let{scheme:w,authority:p,path:D,query:F,fragment:P}=v;return w===void 0?w=this.scheme:w===null&&(w=c),p===void 0?p=this.authority:p===null&&(p=c),D===void 0?D=this.path:D===null&&(D=c),F===void 0?F=this.query:F===null&&(F=c),P===void 0?P=this.fragment:P===null&&(P=c),w===this.scheme&&p===this.authority&&D===this.path&&F===this.query&&P===this.fragment?this:new R(w,p,D,F,P)}static parse(v,w=!1){const p=o.exec(v);return p?new R(p[2]||c,A(p[4]||c),A(p[5]||c),A(p[7]||c),A(p[9]||c),w):new R(c,c,c,c,c)}static file(v){let w=c;if(k.isWindows&&(v=v.replace(/\\/g,E)),v[0]===E&&v[1]===E){const p=v.indexOf(E,2);p===-1?(w=v.substring(2),v=E):(w=v.substring(2,p),v=v.substring(p)||E)}return new R("file",w,v,c,c)}static from(v,w){return new R(v.scheme,v.authority,v.path,v.query,v.fragment,w)}static joinPath(v,...w){if(!v.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return k.isWindows&&v.scheme==="file"?p=h.file(S.win32.join(g(v,!0),...w)).path:p=S.posix.join(v.path,...w),v.with({path:p})}toString(v=!1){return m(this,v)}toJSON(){return this}static revive(v){if(v){if(v instanceof h)return v;{const w=new R(v);return w._formatted=v.external??null,w._fsPath=v._sep===N?v.fsPath??null:null,w}}else return v}}t.URI=h;function e(f){return!f||typeof f!="object"?!1:typeof f.scheme=="string"&&(typeof f.authority=="string"||typeof f.authority>"u")&&(typeof f.path=="string"||typeof f.path>"u")&&(typeof f.query=="string"||typeof f.query>"u")&&(typeof f.fragment=="string"||typeof f.fragment>"u")}t.isUriComponents=e;const N=k.isWindows?1:void 0;class R extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(v=!1){return v?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const v={$mid:1};return this._fsPath&&(v.fsPath=this._fsPath,v._sep=N),this._formatted&&(v.external=this._formatted),this.path&&(v.path=this.path),this.scheme&&(v.scheme=this.scheme),this.authority&&(v.authority=this.authority),this.query&&(v.query=this.query),this.fragment&&(v.fragment=this.fragment),v}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(f,v,w){let p,D=-1;for(let F=0;F<f.length;F++){const P=f.charCodeAt(F);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||v&&P===47||w&&P===91||w&&P===93||w&&P===58)D!==-1&&(p+=encodeURIComponent(f.substring(D,F)),D=-1),p!==void 0&&(p+=f.charAt(F));else{p===void 0&&(p=f.substr(0,F));const _=y[P];_!==void 0?(D!==-1&&(p+=encodeURIComponent(f.substring(D,F)),D=-1),p+=_):D===-1&&(D=F)}}return D!==-1&&(p+=encodeURIComponent(f.substring(D))),p!==void 0?p:f}function M(f){let v;for(let w=0;w<f.length;w++){const p=f.charCodeAt(w);p===35||p===63?(v===void 0&&(v=f.substr(0,w)),v+=y[p]):v!==void 0&&(v+=f[w])}return v!==void 0?v:f}function g(f,v){let w;return f.authority&&f.path.length>1&&f.scheme==="file"?w=`//${f.authority}${f.path}`:f.path.charCodeAt(0)===47&&(f.path.charCodeAt(1)>=65&&f.path.charCodeAt(1)<=90||f.path.charCodeAt(1)>=97&&f.path.charCodeAt(1)<=122)&&f.path.charCodeAt(2)===58?v?w=f.path.substr(1):w=f.path[1].toLowerCase()+f.path.substr(2):w=f.path,k.isWindows&&(w=w.replace(/\//g,"\\")),w}t.uriToFsPath=g;function m(f,v){const w=v?M:b;let p="",{scheme:D,authority:F,path:P,query:_,fragment:I}=f;if(D&&(p+=D,p+=":"),(F||D==="file")&&(p+=E,p+=E),F){let C=F.indexOf("@");if(C!==-1){const q=F.substr(0,C);F=F.substr(C+1),C=q.lastIndexOf(":"),C===-1?p+=w(q,!1,!1):(p+=w(q.substr(0,C),!1,!1),p+=":",p+=w(q.substr(C+1),!1,!0)),p+="@"}F=F.toLowerCase(),C=F.lastIndexOf(":"),C===-1?p+=w(F,!1,!0):(p+=w(F.substr(0,C),!1,!0),p+=F.substr(C))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const C=P.charCodeAt(1);C>=65&&C<=90&&(P=`/${String.fromCharCode(C+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const C=P.charCodeAt(0);C>=65&&C<=90&&(P=`${String.fromCharCode(C+32)}:${P.substr(2)}`)}p+=w(P,!0,!1)}return _&&(p+="?",p+=w(_,!1,!1)),I&&(p+="#",p+=v?I:b(I,!1,!1)),p}function r(f){try{return decodeURIComponent(f)}catch{return f.length>3?f.substr(0,3)+r(f.substr(3)):f}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function A(f){return f.match(l)?f.replace(l,v=>r(v)):f}}),J(K[61],ee([0,1,3,8,7,11,13,5]),function(V,t,S,k,i,u,L,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const a="$initialize";let s=!1;function c(A){L.isWeb&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(A.message))}t.logOnceWebWorkerWarning=c;var E;(function(A){A[A.Request=0]="Request",A[A.Reply=1]="Reply",A[A.SubscribeEvent=2]="SubscribeEvent",A[A.Event=3]="Event",A[A.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class o{constructor(f,v,w,p){this.vsWorker=f,this.req=v,this.method=w,this.args=p,this.type=0}}class h{constructor(f,v,w,p){this.vsWorker=f,this.seq=v,this.res=w,this.err=p,this.type=1}}class e{constructor(f,v,w,p){this.vsWorker=f,this.req=v,this.eventName=w,this.arg=p,this.type=2}}class N{constructor(f,v,w){this.vsWorker=f,this.req=v,this.event=w,this.type=3}}class R{constructor(f,v){this.vsWorker=f,this.req=v,this.type=4}}class y{constructor(f){this._workerId=-1,this._handler=f,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(f){this._workerId=f}sendMessage(f,v){const w=String(++this._lastSentReq);return new Promise((p,D)=>{this._pendingReplies[w]={resolve:p,reject:D},this._send(new o(this._workerId,w,f,v))})}listen(f,v){let w=null;const p=new k.Emitter({onWillAddFirstListener:()=>{w=String(++this._lastSentReq),this._pendingEmitters.set(w,p),this._send(new e(this._workerId,w,f,v))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(w),this._send(new R(this._workerId,w)),w=null}});return p.event}handleMessage(f){!f||!f.vsWorker||this._workerId!==-1&&f.vsWorker!==this._workerId||this._handleMessage(f)}_handleMessage(f){switch(f.type){case 1:return this._handleReplyMessage(f);case 0:return this._handleRequestMessage(f);case 2:return this._handleSubscribeEventMessage(f);case 3:return this._handleEventMessage(f);case 4:return this._handleUnsubscribeEventMessage(f)}}_handleReplyMessage(f){if(!this._pendingReplies[f.seq]){console.warn("Got reply to unknown seq");return}const v=this._pendingReplies[f.seq];if(delete this._pendingReplies[f.seq],f.err){let w=f.err;f.err.$isError&&(w=new Error,w.name=f.err.name,w.message=f.err.message,w.stack=f.err.stack),v.reject(w);return}v.resolve(f.res)}_handleRequestMessage(f){const v=f.req;this._handler.handleMessage(f.method,f.args).then(p=>{this._send(new h(this._workerId,v,p,void 0))},p=>{p.detail instanceof Error&&(p.detail=(0,S.transformErrorForSerialization)(p.detail)),this._send(new h(this._workerId,v,void 0,(0,S.transformErrorForSerialization)(p)))})}_handleSubscribeEventMessage(f){const v=f.req,w=this._handler.handleEvent(f.eventName,f.arg)(p=>{this._send(new N(this._workerId,v,p))});this._pendingEvents.set(v,w)}_handleEventMessage(f){if(!this._pendingEmitters.has(f.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(f.req).fire(f.event)}_handleUnsubscribeEventMessage(f){if(!this._pendingEvents.has(f.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(f.req).dispose(),this._pendingEvents.delete(f.req)}_send(f){const v=[];if(f.type===0)for(let w=0;w<f.args.length;w++)f.args[w]instanceof ArrayBuffer&&v.push(f.args[w]);else f.type===1&&f.res instanceof ArrayBuffer&&v.push(f.res);this._handler.sendMessage(f,v)}}class b extends i.Disposable{constructor(f,v,w){super();let p=null;this._worker=this._register(f.create("vs/base/common/worker/simpleWorker",C=>{this._protocol.handleMessage(C)},C=>{p?.(C)})),this._protocol=new y({sendMessage:(C,q)=>{this._worker.postMessage(C,q)},handleMessage:(C,q)=>{if(typeof w[C]!="function")return Promise.reject(new Error("Missing method "+C+" on main thread host."));try{return Promise.resolve(w[C].apply(w,q))}catch(j){return Promise.reject(j)}},handleEvent:(C,q)=>{if(g(C)){const j=w[C].call(w,q);if(typeof j!="function")throw new Error(`Missing dynamic event ${C} on main thread host.`);return j}if(M(C)){const j=w[C];if(typeof j!="function")throw new Error(`Missing event ${C} on main thread host.`);return j}throw new Error(`Malformed event name ${C}`)}}),this._protocol.setWorkerId(this._worker.getId());let D=null;const F=globalThis.require;typeof F<"u"&&typeof F.getConfig=="function"?D=F.getConfig():typeof globalThis.requirejs<"u"&&(D=globalThis.requirejs.s.contexts._.config);const P=(0,u.getAllMethodNames)(w);this._onModuleLoaded=this._protocol.sendMessage(a,[this._worker.getId(),JSON.parse(JSON.stringify(D)),v,P]);const _=(C,q)=>this._request(C,q),I=(C,q)=>this._protocol.listen(C,q);this._lazyProxy=new Promise((C,q)=>{p=q,this._onModuleLoaded.then(j=>{C(m(j,_,I))},j=>{q(j),this._onError("Worker failed to load "+v,j)})})}getProxyObject(){return this._lazyProxy}_request(f,v){return new Promise((w,p)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(f,v).then(w,p)},p)})}_onError(f,v){console.error(f),console.info(v)}}t.SimpleWorkerClient=b;function M(A){return A[0]==="o"&&A[1]==="n"&&d.isUpperAsciiLetter(A.charCodeAt(2))}function g(A){return/^onDynamic/.test(A)&&d.isUpperAsciiLetter(A.charCodeAt(9))}function m(A,f,v){const w=F=>function(){const P=Array.prototype.slice.call(arguments,0);return f(F,P)},p=F=>function(P){return v(F,P)},D={};for(const F of A){if(g(F)){D[F]=p(F);continue}if(M(F)){D[F]=v(F,void 0);continue}D[F]=w(F)}return D}class r{constructor(f,v){this._requestHandlerFactory=v,this._requestHandler=null,this._protocol=new y({sendMessage:(w,p)=>{f(w,p)},handleMessage:(w,p)=>this._handleMessage(w,p),handleEvent:(w,p)=>this._handleEvent(w,p)})}onmessage(f){this._protocol.handleMessage(f)}_handleMessage(f,v){if(f===a)return this.initialize(v[0],v[1],v[2],v[3]);if(!this._requestHandler||typeof this._requestHandler[f]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+f));try{return Promise.resolve(this._requestHandler[f].apply(this._requestHandler,v))}catch(w){return Promise.reject(w)}}_handleEvent(f,v){if(!this._requestHandler)throw new Error("Missing requestHandler");if(g(f)){const w=this._requestHandler[f].call(this._requestHandler,v);if(typeof w!="function")throw new Error(`Missing dynamic event ${f} on request handler.`);return w}if(M(f)){const w=this._requestHandler[f];if(typeof w!="function")throw new Error(`Missing event ${f} on request handler.`);return w}throw new Error(`Malformed event name ${f}`)}initialize(f,v,w,p){this._protocol.setWorkerId(f);const P=m(p,(_,I)=>this._protocol.sendMessage(_,I),(_,I)=>this._protocol.listen(_,I));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(P),Promise.resolve((0,u.getAllMethodNames)(this._requestHandler))):(v&&(typeof v.baseUrl<"u"&&delete v.baseUrl,typeof v.paths<"u"&&typeof v.paths.vs<"u"&&delete v.paths.vs,typeof v.trustedTypesPolicy!==void 0&&delete v.trustedTypesPolicy,v.catchError=!0,globalThis.require.config(v)),new Promise((_,I)=>{(globalThis.require||V)([w],q=>{if(this._requestHandler=q.create(P),!this._requestHandler){I(new Error("No RequestHandler!"));return}_((0,u.getAllMethodNames)(this._requestHandler))},I)}))}}t.SimpleWorkerServer=r;function l(A){return new r(A,null)}t.create=l}),J(K[56],ee([0,1,34,14,2,52]),function(V,t,S,k,i,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.LazyTokenizationSupport=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.FoldingRangeKind=t.SymbolKinds=t.SymbolTag=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.SelectedSuggestionInfo=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0;class L{constructor(I,C,q){this.offset=I,this.type=C,this.language=q,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=L;class d{constructor(I,C){this.tokens=I,this.endState=C,this._tokenizationResultBrand=void 0}}t.TokenizationResult=d;class a{constructor(I,C){this.tokens=I,this.endState=C,this._encodedTokenizationResultBrand=void 0}}t.EncodedTokenizationResult=a;var s;(function(_){_[_.Method=0]="Method",_[_.Function=1]="Function",_[_.Constructor=2]="Constructor",_[_.Field=3]="Field",_[_.Variable=4]="Variable",_[_.Class=5]="Class",_[_.Struct=6]="Struct",_[_.Interface=7]="Interface",_[_.Module=8]="Module",_[_.Property=9]="Property",_[_.Event=10]="Event",_[_.Operator=11]="Operator",_[_.Unit=12]="Unit",_[_.Value=13]="Value",_[_.Constant=14]="Constant",_[_.Enum=15]="Enum",_[_.EnumMember=16]="EnumMember",_[_.Keyword=17]="Keyword",_[_.Text=18]="Text",_[_.Color=19]="Color",_[_.File=20]="File",_[_.Reference=21]="Reference",_[_.Customcolor=22]="Customcolor",_[_.Folder=23]="Folder",_[_.TypeParameter=24]="TypeParameter",_[_.User=25]="User",_[_.Issue=26]="Issue",_[_.Snippet=27]="Snippet"})(s||(t.CompletionItemKind=s={}));var c;(function(_){const I=new Map;I.set(0,S.Codicon.symbolMethod),I.set(1,S.Codicon.symbolFunction),I.set(2,S.Codicon.symbolConstructor),I.set(3,S.Codicon.symbolField),I.set(4,S.Codicon.symbolVariable),I.set(5,S.Codicon.symbolClass),I.set(6,S.Codicon.symbolStruct),I.set(7,S.Codicon.symbolInterface),I.set(8,S.Codicon.symbolModule),I.set(9,S.Codicon.symbolProperty),I.set(10,S.Codicon.symbolEvent),I.set(11,S.Codicon.symbolOperator),I.set(12,S.Codicon.symbolUnit),I.set(13,S.Codicon.symbolValue),I.set(15,S.Codicon.symbolEnum),I.set(14,S.Codicon.symbolConstant),I.set(15,S.Codicon.symbolEnum),I.set(16,S.Codicon.symbolEnumMember),I.set(17,S.Codicon.symbolKeyword),I.set(27,S.Codicon.symbolSnippet),I.set(18,S.Codicon.symbolText),I.set(19,S.Codicon.symbolColor),I.set(20,S.Codicon.symbolFile),I.set(21,S.Codicon.symbolReference),I.set(22,S.Codicon.symbolCustomColor),I.set(23,S.Codicon.symbolFolder),I.set(24,S.Codicon.symbolTypeParameter),I.set(25,S.Codicon.account),I.set(26,S.Codicon.issues);function C(G){let X=I.get(G);return X||(console.info("No codicon found for CompletionItemKind "+G),X=S.Codicon.symbolProperty),X}_.toIcon=C;const q=new Map;q.set("method",0),q.set("function",1),q.set("constructor",2),q.set("field",3),q.set("variable",4),q.set("class",5),q.set("struct",6),q.set("interface",7),q.set("module",8),q.set("property",9),q.set("event",10),q.set("operator",11),q.set("unit",12),q.set("value",13),q.set("constant",14),q.set("enum",15),q.set("enum-member",16),q.set("enumMember",16),q.set("keyword",17),q.set("snippet",27),q.set("text",18),q.set("color",19),q.set("file",20),q.set("reference",21),q.set("customcolor",22),q.set("folder",23),q.set("type-parameter",24),q.set("typeParameter",24),q.set("account",25),q.set("issue",26);function j(G,X){let $=q.get(G);return typeof $>"u"&&!X&&($=9),$}_.fromString=j})(c||(t.CompletionItemKinds=c={}));var E;(function(_){_[_.Deprecated=1]="Deprecated"})(E||(t.CompletionItemTag=E={}));var o;(function(_){_[_.None=0]="None",_[_.KeepWhitespace=1]="KeepWhitespace",_[_.InsertAsSnippet=4]="InsertAsSnippet"})(o||(t.CompletionItemInsertTextRule=o={}));var h;(function(_){_[_.Invoke=0]="Invoke",_[_.TriggerCharacter=1]="TriggerCharacter",_[_.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(t.CompletionTriggerKind=h={}));var e;(function(_){_[_.Automatic=0]="Automatic",_[_.Explicit=1]="Explicit"})(e||(t.InlineCompletionTriggerKind=e={}));class N{constructor(I,C,q,j){this.range=I,this.text=C,this.completionKind=q,this.isSnippetText=j}equals(I){return i.Range.lift(this.range).equalsRange(I.range)&&this.text===I.text&&this.completionKind===I.completionKind&&this.isSnippetText===I.isSnippetText}}t.SelectedSuggestionInfo=N;var R;(function(_){_[_.Invoke=1]="Invoke",_[_.Auto=2]="Auto"})(R||(t.CodeActionTriggerType=R={}));var y;(function(_){_[_.Invoke=1]="Invoke",_[_.TriggerCharacter=2]="TriggerCharacter",_[_.ContentChange=3]="ContentChange"})(y||(t.SignatureHelpTriggerKind=y={}));var b;(function(_){_[_.Text=0]="Text",_[_.Read=1]="Read",_[_.Write=2]="Write"})(b||(t.DocumentHighlightKind=b={}));function M(_){return _&&k.URI.isUri(_.uri)&&i.Range.isIRange(_.range)&&(i.Range.isIRange(_.originSelectionRange)||i.Range.isIRange(_.targetSelectionRange))}t.isLocationLink=M;var g;(function(_){_[_.File=0]="File",_[_.Module=1]="Module",_[_.Namespace=2]="Namespace",_[_.Package=3]="Package",_[_.Class=4]="Class",_[_.Method=5]="Method",_[_.Property=6]="Property",_[_.Field=7]="Field",_[_.Constructor=8]="Constructor",_[_.Enum=9]="Enum",_[_.Interface=10]="Interface",_[_.Function=11]="Function",_[_.Variable=12]="Variable",_[_.Constant=13]="Constant",_[_.String=14]="String",_[_.Number=15]="Number",_[_.Boolean=16]="Boolean",_[_.Array=17]="Array",_[_.Object=18]="Object",_[_.Key=19]="Key",_[_.Null=20]="Null",_[_.EnumMember=21]="EnumMember",_[_.Struct=22]="Struct",_[_.Event=23]="Event",_[_.Operator=24]="Operator",_[_.TypeParameter=25]="TypeParameter"})(g||(t.SymbolKind=g={}));var m;(function(_){_[_.Deprecated=1]="Deprecated"})(m||(t.SymbolTag=m={}));var r;(function(_){const I=new Map;I.set(0,S.Codicon.symbolFile),I.set(1,S.Codicon.symbolModule),I.set(2,S.Codicon.symbolNamespace),I.set(3,S.Codicon.symbolPackage),I.set(4,S.Codicon.symbolClass),I.set(5,S.Codicon.symbolMethod),I.set(6,S.Codicon.symbolProperty),I.set(7,S.Codicon.symbolField),I.set(8,S.Codicon.symbolConstructor),I.set(9,S.Codicon.symbolEnum),I.set(10,S.Codicon.symbolInterface),I.set(11,S.Codicon.symbolFunction),I.set(12,S.Codicon.symbolVariable),I.set(13,S.Codicon.symbolConstant),I.set(14,S.Codicon.symbolString),I.set(15,S.Codicon.symbolNumber),I.set(16,S.Codicon.symbolBoolean),I.set(17,S.Codicon.symbolArray),I.set(18,S.Codicon.symbolObject),I.set(19,S.Codicon.symbolKey),I.set(20,S.Codicon.symbolNull),I.set(21,S.Codicon.symbolEnumMember),I.set(22,S.Codicon.symbolStruct),I.set(23,S.Codicon.symbolEvent),I.set(24,S.Codicon.symbolOperator),I.set(25,S.Codicon.symbolTypeParameter);function C(q){let j=I.get(q);return j||(console.info("No codicon found for SymbolKind "+q),j=S.Codicon.symbolProperty),j}_.toIcon=C})(r||(t.SymbolKinds=r={}));class l{static fromValue(I){switch(I){case"comment":return l.Comment;case"imports":return l.Imports;case"region":return l.Region}return new l(I)}constructor(I){this.value=I}}t.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var A;(function(_){function I(C){return!C||typeof C!="object"?!1:typeof C.id=="string"&&typeof C.title=="string"}_.is=I})(A||(t.Command=A={}));var f;(function(_){_[_.Collapsed=0]="Collapsed",_[_.Expanded=1]="Expanded"})(f||(t.CommentThreadCollapsibleState=f={}));var v;(function(_){_[_.Unresolved=0]="Unresolved",_[_.Resolved=1]="Resolved"})(v||(t.CommentThreadState=v={}));var w;(function(_){_[_.Editing=0]="Editing",_[_.Preview=1]="Preview"})(w||(t.CommentMode=w={}));var p;(function(_){_[_.Published=0]="Published",_[_.Draft=1]="Draft"})(p||(t.CommentState=p={}));var D;(function(_){_[_.Type=1]="Type",_[_.Parameter=2]="Parameter"})(D||(t.InlayHintKind=D={}));class F{constructor(I){this.createSupport=I,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(I=>{I&&I.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}t.LazyTokenizationSupport=F,t.TokenizationRegistry=new u.TokenizationRegistry;var P;(function(_){_[_.None=0]="None",_[_.Option=1]="Option",_[_.Default=2]="Default",_[_.Preferred=3]="Preferred"})(P||(t.ExternalUriOpenerPriority=P={}))}),J(K[57],ee([0,1,19,8,30,14,4,2,35,56,51]),function(V,t,S,k,i,u,L,d,a,s,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class E{static chord(e,N){return(0,i.KeyChord)(e,N)}}t.KeyMod=E,E.CtrlCmd=2048,E.Shift=1024,E.Alt=512,E.WinCtrl=256;function o(){return{editor:void 0,languages:void 0,CancellationTokenSource:S.CancellationTokenSource,Emitter:k.Emitter,KeyCode:c.KeyCode,KeyMod:E,Position:L.Position,Range:d.Range,Selection:a.Selection,SelectionDirection:c.SelectionDirection,MarkerSeverity:c.MarkerSeverity,MarkerTag:c.MarkerTag,Uri:u.URI,Token:s.Token}}t.createMonacoBaseAPI=o}),J(K[62],ee([0,1,20,14,4,2,48,24,44,45,57,18,50,26,42,11,3,43]),function(V,t,S,k,i,u,L,d,a,s,c,E,o,h,e,N,R,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class b extends L.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(r){const l=[];for(let A=0;A<this._lines.length;A++){const f=this._lines[A],v=this.offsetAt(new i.Position(A+1,1)),w=f.matchAll(r);for(const p of w)(p.index||p.index===0)&&(p.index=p.index+v),l.push(p)}return l}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(r){return this._lines[r-1]}getWordAtPosition(r,l){const A=(0,d.getWordAtText)(r.column,(0,d.ensureValidWordDefinition)(l),this._lines[r.lineNumber-1],0);return A?new u.Range(r.lineNumber,A.startColumn,r.lineNumber,A.endColumn):null}getWordUntilPosition(r,l){const A=this.getWordAtPosition(r,l);return A?{word:this._lines[r.lineNumber-1].substring(A.startColumn-1,r.column-1),startColumn:A.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const l=this._lines,A=this._wordenize.bind(this);let f=0,v="",w=0,p=[];return{*[Symbol.iterator](){for(;;)if(w<p.length){const D=v.substring(p[w].start,p[w].end);w+=1,yield D}else if(f<l.length)v=l[f],p=A(v,r),w=0,f+=1;else break}}}getLineWords(r,l){const A=this._lines[r-1],f=this._wordenize(A,l),v=[];for(const w of f)v.push({word:A.substring(w.start,w.end),startColumn:w.start+1,endColumn:w.end+1});return v}_wordenize(r,l){const A=[];let f;for(l.lastIndex=0;(f=l.exec(r))&&f[0].length!==0;)A.push({start:f.index,end:f.index+f[0].length});return A}getValueInRange(r){if(r=this._validateRange(r),r.startLineNumber===r.endLineNumber)return this._lines[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const l=this._eol,A=r.startLineNumber-1,f=r.endLineNumber-1,v=[];v.push(this._lines[A].substring(r.startColumn-1));for(let w=A+1;w<f;w++)v.push(this._lines[w]);return v.push(this._lines[f].substring(0,r.endColumn-1)),v.join(l)}offsetAt(r){return r=this._validatePosition(r),this._ensureLineStarts(),this._lineStarts.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this._ensureLineStarts();const l=this._lineStarts.getIndexOf(r),A=this._lines[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,A)}}_validateRange(r){const l=this._validatePosition({lineNumber:r.startLineNumber,column:r.startColumn}),A=this._validatePosition({lineNumber:r.endLineNumber,column:r.endColumn});return l.lineNumber!==r.startLineNumber||l.column!==r.startColumn||A.lineNumber!==r.endLineNumber||A.column!==r.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:A.lineNumber,endColumn:A.column}:r}_validatePosition(r){if(!i.Position.isIPosition(r))throw new Error("bad position");let{lineNumber:l,column:A}=r,f=!1;if(l<1)l=1,A=1,f=!0;else if(l>this._lines.length)l=this._lines.length,A=this._lines[l-1].length+1,f=!0;else{const v=this._lines[l-1].length+1;A<1?(A=1,f=!0):A>v&&(A=v,f=!0)}return f?{lineNumber:l,column:A}:r}}class M{constructor(r,l){this._host=r,this._models=Object.create(null),this._foreignModuleFactory=l,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(r){return this._models[r]}_getModels(){const r=[];return Object.keys(this._models).forEach(l=>r.push(this._models[l])),r}acceptNewModel(r){this._models[r.url]=new b(k.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,l){if(!this._models[r])return;this._models[r].onEvents(l)}acceptRemovedModel(r){this._models[r]&&delete this._models[r]}async computeUnicodeHighlights(r,l,A){const f=this._getModel(r);return f?o.UnicodeTextModelHighlighter.computeUnicodeHighlights(f,l,A):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(r,l,A,f){const v=this._getModel(r),w=this._getModel(l);return!v||!w?null:M.computeDiff(v,w,A,f)}static computeDiff(r,l,A,f){const v=f==="advanced"?e.linesDiffComputers.getAdvanced():e.linesDiffComputers.getLegacy(),w=r.getLinesContent(),p=l.getLinesContent(),D=v.computeDiff(w,p,A),F=D.changes.length>0?!1:this._modelsAreIdentical(r,l);function P(_){return _.map(I=>[I.originalRange.startLineNumber,I.originalRange.endLineNumberExclusive,I.modifiedRange.startLineNumber,I.modifiedRange.endLineNumberExclusive,I.innerChanges?.map(C=>[C.originalRange.startLineNumber,C.originalRange.startColumn,C.originalRange.endLineNumber,C.originalRange.endColumn,C.modifiedRange.startLineNumber,C.modifiedRange.startColumn,C.modifiedRange.endLineNumber,C.modifiedRange.endColumn])])}return{identical:F,quitEarly:D.hitTimeout,changes:P(D.changes),moves:D.moves.map(_=>[_.lineRangeMapping.originalRange.startLineNumber,_.lineRangeMapping.originalRange.endLineNumberExclusive,_.lineRangeMapping.modifiedRange.startLineNumber,_.lineRangeMapping.modifiedRange.endLineNumberExclusive,P(_.changes)])}}static _modelsAreIdentical(r,l){const A=r.getLineCount(),f=l.getLineCount();if(A!==f)return!1;for(let v=1;v<=A;v++){const w=r.getLineContent(v),p=l.getLineContent(v);if(w!==p)return!1}return!0}async computeDirtyDiff(r,l,A){const f=this._getModel(r),v=this._getModel(l);if(!f||!v)return null;const w=f.getLinesContent(),p=v.getLinesContent();return new h.DiffComputer(w,p,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:A,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(r,l,A){const f=this._getModel(r);if(!f)return l;const v=[];let w;l=l.slice(0).sort((p,D)=>{if(p.range&&D.range)return u.Range.compareRangesUsingStarts(p.range,D.range);const F=p.range?0:1,P=D.range?0:1;return F-P});for(let{range:p,text:D,eol:F}of l){if(typeof F=="number"&&(w=F),u.Range.isEmpty(p)&&!D)continue;const P=f.getValueInRange(p);if(D=D.replace(/\r\n|\n|\r/g,f.eol),P===D)continue;if(Math.max(D.length,P.length)>M._diffLimit){v.push({range:p,text:D});continue}const _=(0,S.stringDiff)(P,D,A),I=f.offsetAt(u.Range.lift(p).getStartPosition());for(const C of _){const q=f.positionAt(I+C.originalStart),j=f.positionAt(I+C.originalStart+C.originalLength),G={text:D.substr(C.modifiedStart,C.modifiedLength),range:{startLineNumber:q.lineNumber,startColumn:q.column,endLineNumber:j.lineNumber,endColumn:j.column}};f.getValueInRange(G.range)!==G.text&&v.push(G)}}return typeof w=="number"&&v.push({eol:w,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),v}async computeHumanReadableDiff(r,l,A){const f=this._getModel(r);if(!f)return l;const v=[];let w;l=l.slice(0).sort((p,D)=>{if(p.range&&D.range)return u.Range.compareRangesUsingStarts(p.range,D.range);const F=p.range?0:1,P=D.range?0:1;return F-P});for(let{range:p,text:D,eol:F}of l){let j=function(X,$){return new i.Position(X.lineNumber+$.lineNumber-1,$.lineNumber===1?X.column+$.column-1:$.column)},G=function(X,$){const ne=[];for(let n=$.startLineNumber;n<=$.endLineNumber;n++){const de=X[n-1];n===$.startLineNumber&&n===$.endLineNumber?ne.push(de.substring($.startColumn-1,$.endColumn-1)):n===$.startLineNumber?ne.push(de.substring($.startColumn-1)):n===$.endLineNumber?ne.push(de.substring(0,$.endColumn-1)):ne.push(de)}return ne};if(typeof F=="number"&&(w=F),u.Range.isEmpty(p)&&!D)continue;const P=f.getValueInRange(p);if(D=D.replace(/\r\n|\n|\r/g,f.eol),P===D)continue;if(Math.max(D.length,P.length)>M._diffLimit){v.push({range:p,text:D});continue}const _=P.split(/\r\n|\n|\r/),I=D.split(/\r\n|\n|\r/),C=e.linesDiffComputers.getAdvanced().computeDiff(_,I,A),q=u.Range.lift(p).getStartPosition();for(const X of C.changes)if(X.innerChanges)for(const $ of X.innerChanges)v.push({range:u.Range.fromPositions(j(q,$.originalRange.getStartPosition()),j(q,$.originalRange.getEndPosition())),text:G(I,$.modifiedRange).join(f.eol)});else throw new R.BugIndicatingError("The experimental diff algorithm always produces inner changes")}return typeof w=="number"&&v.push({eol:w,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),v}async computeLinks(r){const l=this._getModel(r);return l?(0,a.computeLinks)(l):null}async computeDefaultDocumentColors(r){const l=this._getModel(r);return l?(0,y.computeDefaultDocumentColors)(l):null}async textualSuggest(r,l,A,f){const v=new E.StopWatch,w=new RegExp(A,f),p=new Set;e:for(const D of r){const F=this._getModel(D);if(F){for(const P of F.words(w))if(!(P===l||!isNaN(Number(P)))&&(p.add(P),p.size>M._suggestionsLimit))break e}}return{words:Array.from(p),duration:v.elapsed()}}async computeWordRanges(r,l,A,f){const v=this._getModel(r);if(!v)return Object.create(null);const w=new RegExp(A,f),p=Object.create(null);for(let D=l.startLineNumber;D<l.endLineNumber;D++){const F=v.getLineWords(D,w);for(const P of F){if(!isNaN(Number(P.word)))continue;let _=p[P.word];_||(_=[],p[P.word]=_),_.push({startLineNumber:D,startColumn:P.startColumn,endLineNumber:D,endColumn:P.endColumn})}}return p}async navigateValueSet(r,l,A,f,v){const w=this._getModel(r);if(!w)return null;const p=new RegExp(f,v);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const D=w.getValueInRange(l),F=w.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},p);if(!F)return null;const P=w.getValueInRange(F);return s.BasicInplaceReplace.INSTANCE.navigateValueSet(l,D,F,P,A)}loadForeignModule(r,l,A){const f=(p,D)=>this._host.fhr(p,D),w={host:(0,N.createProxyObject)(A,f),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(w,l),Promise.resolve((0,N.getAllMethodNames)(this._foreignModule))):new Promise((p,D)=>{V([r],F=>{this._foreignModule=F.create(w,l),p((0,N.getAllMethodNames)(this._foreignModule))},D)})}fmr(r,l){if(!this._foreignModule||typeof this._foreignModule[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this._foreignModule[r].apply(this._foreignModule,l))}catch(A){return Promise.reject(A)}}}t.EditorSimpleWorker=M,M._diffLimit=1e5,M._suggestionsLimit=1e4;function g(m){return new M(m,null)}t.create=g,typeof importScripts=="function"&&(globalThis.monaco=(0,c.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9d3b0fa210fb4535589e8296483a5b43fe5e660a/core/vs/base/worker/workerMain.js.map
