/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/product/common/productService","vs/base/common/arrays","vs/base/common/strings","vs/platform/telemetry/common/telemetry","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/node/state","vs/base/common/map","vs/base/common/process","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/severity","vs/base/common/codicons","crypto","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/parts/ipc/node/ipc.net","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],te=function(j){for(var e=[],P=0,L=j.length;P<L;P++)e[P]=ee[j[P]];return e};define(ee[133],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function P(I,h){const l=Math.pow(10,h);return Math.round(I*l)/l}class L{constructor(h,l,m,f=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,m))|0,this.a=P(Math.max(Math.min(1,f),0),3)}static equals(h,l){return h.r===l.r&&h.g===l.g&&h.b===l.b&&h.a===l.a}}e.RGBA=L;class s{constructor(h,l,m,f){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.l=P(Math.max(Math.min(1,m),0),3),this.a=P(Math.max(Math.min(1,f),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.l===l.l&&h.a===l.a}static fromRGBA(h){const l=h.r/255,m=h.g/255,f=h.b/255,S=h.a,d=Math.max(l,m,f),y=Math.min(l,m,f);let v=0,o=0;const g=(y+d)/2,a=d-y;if(a>0){switch(o=Math.min(g<=.5?a/(2*g):a/(2-2*g),1),d){case l:v=(m-f)/a+(m<f?6:0);break;case m:v=(f-l)/a+2;break;case f:v=(l-m)/a+4;break}v*=60,v=Math.round(v)}return new s(v,o,g,S)}static _hue2rgb(h,l,m){return m<0&&(m+=1),m>1&&(m-=1),m<1/6?h+(l-h)*6*m:m<1/2?l:m<2/3?h+(l-h)*(2/3-m)*6:h}static toRGBA(h){const l=h.h/360,{s:m,l:f,a:S}=h;let d,y,v;if(m===0)d=y=v=f;else{const o=f<.5?f*(1+m):f+m-f*m,g=2*f-o;d=s._hue2rgb(g,o,l+1/3),y=s._hue2rgb(g,o,l),v=s._hue2rgb(g,o,l-1/3)}return new L(Math.round(d*255),Math.round(y*255),Math.round(v*255),S)}}e.HSLA=s;class A{constructor(h,l,m,f){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.v=P(Math.max(Math.min(1,m),0),3),this.a=P(Math.max(Math.min(1,f),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.v===l.v&&h.a===l.a}static fromRGBA(h){const l=h.r/255,m=h.g/255,f=h.b/255,S=Math.max(l,m,f),d=Math.min(l,m,f),y=S-d,v=S===0?0:y/S;let o;return y===0?o=0:S===l?o=((m-f)/y%6+6)%6:S===m?o=(f-l)/y+2:o=(l-m)/y+4,new A(Math.round(o*60),v,S,h.a)}static toRGBA(h){const{h:l,s:m,v:f,a:S}=h,d=f*m,y=d*(1-Math.abs(l/60%2-1)),v=f-d;let[o,g,a]=[0,0,0];return l<60?(o=d,g=y):l<120?(o=y,g=d):l<180?(g=d,a=y):l<240?(g=y,a=d):l<300?(o=y,a=d):l<=360&&(o=d,a=y),o=Math.round((o+v)*255),g=Math.round((g+v)*255),a=Math.round((a+v)*255),new L(o,g,a,S)}}e.HSVA=A;class R{static fromHex(h){return R.Format.CSS.parseHex(h)||R.red}static equals(h,l){return!h&&!l?!0:!h||!l?!1:h.equals(l)}get hsla(){return this._hsla?this._hsla:s.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:A.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof L)this.rgba=h;else if(h instanceof s)this._hsla=h,this.rgba=s.toRGBA(h);else if(h instanceof A)this._hsva=h,this.rgba=A.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&L.equals(this.rgba,h.rgba)&&s.equals(this.hsla,h.hsla)&&A.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=R._relativeLuminanceForComponent(this.rgba.r),l=R._relativeLuminanceForComponent(this.rgba.g),m=R._relativeLuminanceForComponent(this.rgba.b),f=.2126*h+.7152*l+.0722*m;return P(f,4)}static _relativeLuminanceForComponent(h){const l=h/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(h){const l=this.getRelativeLuminance(),m=h.getRelativeLuminance();return l>m?(l+.05)/(m+.05):(m+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const l=this.getRelativeLuminance(),m=h.getRelativeLuminance();return l>m}isDarkerThan(h){const l=this.getRelativeLuminance(),m=h.getRelativeLuminance();return l<m}lighten(h){return new R(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new R(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:l,g:m,b:f,a:S}=this.rgba;return new R(new L(l,m,f,S*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new R(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const l=h.rgba,m=this.rgba.a,f=l.a,S=m+f*(1-m);if(S<1e-6)return R.transparent;const d=this.rgba.r*m/S+l.r*f*(1-m)/S,y=this.rgba.g*m/S+l.g*f*(1-m)/S,v=this.rgba.b*m/S+l.b*f*(1-m)/S;return new R(new L(d,y,v,S))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:l,g:m,b:f,a:S}=this.rgba;return new R(new L(h.rgba.r-S*(h.rgba.r-l),h.rgba.g-S*(h.rgba.g-m),h.rgba.b-S*(h.rgba.b-f),1))}flatten(...h){const l=h.reduceRight((m,f)=>R._flatten(f,m));return R._flatten(this,l)}static _flatten(h,l){const m=1-h.rgba.a;return new R(new L(m*l.rgba.r+h.rgba.a*h.rgba.r,m*l.rgba.g+h.rgba.a*h.rgba.g,m*l.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this._toString||(this._toString=R.Format.CSS.format(this)),this._toString}static getLighterColor(h,l,m){if(h.isLighterThan(l))return h;m=m||.5;const f=h.getRelativeLuminance(),S=l.getRelativeLuminance();return m=m*(S-f)/S,h.lighten(m)}static getDarkerColor(h,l,m){if(h.isDarkerThan(l))return h;m=m||.5;const f=h.getRelativeLuminance(),S=l.getRelativeLuminance();return m=m*(f-S)/f,h.darken(m)}}e.Color=R,R.white=new R(new L(255,255,255,1)),R.black=new R(new L(0,0,0,1)),R.red=new R(new L(255,0,0,1)),R.blue=new R(new L(0,0,255,1)),R.green=new R(new L(0,255,0,1)),R.cyan=new R(new L(0,255,255,1)),R.lightgrey=new R(new L(211,211,211,1)),R.transparent=new R(new L(0,0,0,0)),function(I){let h;(function(l){let m;(function(f){function S(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:I.Format.CSS.formatRGBA(t)}f.formatRGB=S;function d(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}f.formatRGBA=d;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:I.Format.CSS.formatHSLA(t)}f.formatHSL=y;function v(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}f.formatHSLA=v;function o(t){const u=t.toString(16);return u.length!==2?"0"+u:u}function g(t){return`#${o(t.rgba.r)}${o(t.rgba.g)}${o(t.rgba.b)}`}f.formatHex=g;function a(t,u=!1){return u&&t.rgba.a===1?I.Format.CSS.formatHex(t):`#${o(t.rgba.r)}${o(t.rgba.g)}${o(t.rgba.b)}${o(Math.round(t.rgba.a*255))}`}f.formatHexA=a;function b(t){return t.isOpaque()?I.Format.CSS.formatHex(t):I.Format.CSS.formatRGBA(t)}f.format=b;function E(t){const u=t.length;if(u===0||t.charCodeAt(0)!==35)return null;if(u===7){const r=16*w(t.charCodeAt(1))+w(t.charCodeAt(2)),i=16*w(t.charCodeAt(3))+w(t.charCodeAt(4)),n=16*w(t.charCodeAt(5))+w(t.charCodeAt(6));return new I(new L(r,i,n,1))}if(u===9){const r=16*w(t.charCodeAt(1))+w(t.charCodeAt(2)),i=16*w(t.charCodeAt(3))+w(t.charCodeAt(4)),n=16*w(t.charCodeAt(5))+w(t.charCodeAt(6)),c=16*w(t.charCodeAt(7))+w(t.charCodeAt(8));return new I(new L(r,i,n,c/255))}if(u===4){const r=w(t.charCodeAt(1)),i=w(t.charCodeAt(2)),n=w(t.charCodeAt(3));return new I(new L(16*r+r,16*i+i,16*n+n))}if(u===5){const r=w(t.charCodeAt(1)),i=w(t.charCodeAt(2)),n=w(t.charCodeAt(3)),c=w(t.charCodeAt(4));return new I(new L(16*r+r,16*i+i,16*n+n,(16*c+c)/255))}return null}f.parseHex=E;function w(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(m=l.CSS||(l.CSS={}))})(h=I.Format||(I.Format={}))}(R||(e.Color=R={}))}),define(ee[55],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function P(R){return(I,h,l)=>{let m=null,f=null;if(typeof l.value=="function"?(m="value",f=l.value):typeof l.get=="function"&&(m="get",f=l.get),!f)throw new Error("not supported");l[m]=R(f,h)}}function L(R,I,h){let l=null,m=null;if(typeof h.value=="function"?(l="value",m=h.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(l="get",m=h.get),!m)throw new Error("not supported");const f=`$memoize$${I}`;h[l]=function(...S){return this.hasOwnProperty(f)||Object.defineProperty(this,f,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,S)}),this[f]}}e.memoize=L;function s(R,I,h){return P((l,m)=>{const f=`$debounce$${m}`,S=`$debounce$result$${m}`;return function(...d){this[S]||(this[S]=h?h():void 0),clearTimeout(this[f]),I&&(this[S]=I(this[S],...d),d=[this[S]]),this[f]=setTimeout(()=>{l.apply(this,d),this[S]=h?h():void 0},R)}})}e.debounce=s;function A(R,I,h){return P((l,m)=>{const f=`$throttle$timer$${m}`,S=`$throttle$result$${m}`,d=`$throttle$lastRun$${m}`,y=`$throttle$pending$${m}`;return function(...v){if(this[S]||(this[S]=h?h():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),I&&(this[S]=I(this[S],...v)),this[y])return;const o=this[d]+R;o<=Date.now()?(this[d]=Date.now(),l.apply(this,[this[S]]),this[S]=h?h():void 0):(this[y]=!0,this[f]=setTimeout(()=>{this[y]=!1,this[d]=Date.now(),l.apply(this,[this[S]]),this[S]=h?h():void 0},o-Date.now()))}})}e.throttle=A}),define(ee[13],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class P{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(u){setTimeout(()=>{throw u.stack?E.isErrorNoTelemetry(u)?new E(u.message+`

`+u.stack):new Error(u.message+`

`+u.stack):u},0)}}addListener(u){return this.listeners.push(u),()=>{this._removeListener(u)}}emit(u){this.listeners.forEach(r=>{r(u)})}_removeListener(u){this.listeners.splice(this.listeners.indexOf(u),1)}setUnexpectedErrorHandler(u){this.unexpectedErrorHandler=u}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(u){this.unexpectedErrorHandler(u),this.emit(u)}onUnexpectedExternalError(u){this.unexpectedErrorHandler(u)}}e.ErrorHandler=P,e.errorHandler=new P;function L(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=L;function s(t){if(!t||typeof t!="object")return!1;const u=t;return u.code==="EPIPE"&&u.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=s;function A(t){l(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=A;function R(t){l(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=R;function I(t){if(t instanceof Error){const{name:u,message:r}=t,i=t.stacktrace||t.stack;return{$isError:!0,name:u,message:r,stack:i,noTelemetry:E.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=I;const h="Canceled";function l(t){return t instanceof m?!0:t instanceof Error&&t.name===h&&t.message===h}e.isCancellationError=l;class m extends Error{constructor(){super(h),this.name=this.message}}e.CancellationError=m;function f(){const t=new Error(h);return t.name=t.message,t}e.canceled=f;function S(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=S;function d(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=d;function y(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function v(t){const u=new Error(`${t} has been disposed`);return u.name="DISPOSED",u}e.disposed=v;function o(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=o;class g extends Error{constructor(u){super("NotImplemented"),u&&(this.message=u)}}e.NotImplementedError=g;class a extends Error{constructor(u){super("NotSupported"),u&&(this.message=u)}}e.NotSupportedError=a;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class E extends Error{constructor(u){super(u),this.name="CodeExpectedError"}static fromError(u){if(u instanceof E)return u;const r=new E;return r.message=u.message,r.stack=u.stack,r}static isErrorNoTelemetry(u){return u.name==="CodeExpectedError"}}e.ErrorNoTelemetry=E;class w extends Error{constructor(u){super(u||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype)}}e.BugIndicatingError=w}),define(ee[24],te([0,1,13]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L(z,$=0){return z[z.length-(1+$)]}e.tail=L;function s(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=s;function A(z,$,K=(re,ce)=>re===ce){if(z===$)return!0;if(!z||!$||z.length!==$.length)return!1;for(let re=0,ce=z.length;re<ce;re++)if(!K(z[re],$[re]))return!1;return!0}e.equals=A;function R(z,$){const K=z.length-1;$<K&&(z[$]=z[K]),z.pop()}e.removeFastWithoutKeepingOrder=R;function I(z,$,K){return h(z.length,re=>K(z[re],$))}e.binarySearch=I;function h(z,$){let K=0,re=z-1;for(;K<=re;){const ce=(K+re)/2|0,ge=$(ce);if(ge<0)K=ce+1;else if(ge>0)re=ce-1;else return ce}return-(K+1)}e.binarySearch2=h;function l(z,$){let K=0,re=z.length;if(re===0)return 0;for(;K<re;){const ce=Math.floor((K+re)/2);$(z[ce])?re=ce:K=ce+1}return K}e.findFirstInSorted=l;function m(z,$,K){if(z=z|0,z>=$.length)throw new TypeError("invalid index");const re=$[Math.floor($.length*Math.random())],ce=[],ge=[],ke=[];for(const Re of $){const Le=K(Re,re);Le<0?ce.push(Re):Le>0?ge.push(Re):ke.push(Re)}return z<ce.length?m(z,ce,K):z<ce.length+ke.length?ke[0]:m(z-(ce.length+ke.length),ge,K)}e.quickSelect=m;function f(z,$){const K=[];let re;for(const ce of z.slice(0).sort($))!re||$(re[0],ce)!==0?(re=[ce],K.push(re)):re.push(ce);return K}e.groupBy=f;function S(z,$,K){const re=[];function ce(Re,Le,Oe){if(Le===0&&Oe.length===0)return;const ye=re[re.length-1];ye&&ye.start+ye.deleteCount===Re?(ye.deleteCount+=Le,ye.toInsert.push(...Oe)):re.push({start:Re,deleteCount:Le,toInsert:Oe})}let ge=0,ke=0;for(;;){if(ge===z.length){ce(ge,0,$.slice(ke));break}if(ke===$.length){ce(ge,z.length-ge,[]);break}const Re=z[ge],Le=$[ke],Oe=K(Re,Le);Oe===0?(ge+=1,ke+=1):Oe<0?(ce(ge,1,[]),ge+=1):Oe>0&&(ce(ge,0,[Le]),ke+=1)}return re}e.sortedDiff=S;function d(z,$,K){const re=S(z,$,K),ce=[],ge=[];for(const ke of re)ce.push(...z.slice(ke.start,ke.start+ke.deleteCount)),ge.push(...ke.toInsert);return{removed:ce,added:ge}}e.delta=d;function y(z,$,K){if(K===0)return[];const re=z.slice(0,K).sort($);return o(z,$,re,K,z.length),re}e.top=y;function v(z,$,K,re,ce){return K===0?Promise.resolve([]):new Promise((ge,ke)=>{(async()=>{const Re=z.length,Le=z.slice(0,K).sort($);for(let Oe=K,ye=Math.min(K+re,Re);Oe<Re;Oe=ye,ye=Math.min(ye+re,Re)){if(Oe>K&&await new Promise(we=>setTimeout(we)),ce&&ce.isCancellationRequested)throw new P.CancellationError;o(z,$,Le,Oe,ye)}return Le})().then(ge,ke)})}e.topAsync=v;function o(z,$,K,re,ce){for(const ge=K.length;re<ce;re++){const ke=z[re];if($(ke,K[ge-1])<0){K.pop();const Re=l(K,Le=>$(ke,Le)<0);K.splice(Re,0,ke)}}}function g(z){return z.filter($=>!!$)}e.coalesce=g;function a(z){let $=0;for(let K=0;K<z.length;K++)z[K]&&(z[$]=z[K],$+=1);z.length=$}e.coalesceInPlace=a;function b(z,$,K){z.splice(K,0,z.splice($,1)[0])}e.move=b;function E(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=E;function w(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=w;function t(z,$=K=>K){const K=new Set;return z.filter(re=>{const ce=$(re);return K.has(ce)?!1:(K.add(ce),!0)})}e.distinct=t;function u(z){const $=new Set;return K=>{const re=z(K);return $.has(re)?!1:($.add(re),!0)}}e.uniqueFilter=u;function r(z,$){const K=i(z,$);if(K!==-1)return z[K]}e.findLast=r;function i(z,$){for(let K=z.length-1;K>=0;K--){const re=z[K];if($(re))return K}return-1}e.lastIndex=i;function n(z,$){return z.length>0?z[0]:$}e.firstOrDefault=n;function c(z,$){return z.length>0?z[z.length-1]:$}e.lastOrDefault=c;function p(z,$,K=(re,ce)=>re===ce){let re=0;for(let ce=0,ge=Math.min(z.length,$.length);ce<ge&&K(z[ce],$[ce]);ce++)re++;return re}e.commonPrefixLength=p;function D(z){return[].concat(...z)}e.flatten=D;function k(z,$){let K=typeof $=="number"?z:0;typeof $=="number"?K=z:(K=0,$=z);const re=[];if(K<=$)for(let ce=K;ce<$;ce++)re.push(ce);else for(let ce=K;ce>$;ce--)re.push(ce);return re}e.range=k;function C(z,$,K){return z.reduce((re,ce)=>(re[$(ce)]=K?K(ce):ce,re),Object.create(null))}e.index=C;function _(z,$){return z.push($),()=>T(z,$)}e.insert=_;function T(z,$){const K=z.indexOf($);if(K>-1)return z.splice(K,1),$}e.remove=T;function U(z,$,K){const re=z.slice(0,$),ce=z.slice($);return re.concat(K,ce)}e.arrayInsert=U;function q(z,$){let K;if(typeof $=="number"){let re=$;K=()=>{const ce=Math.sin(re++)*179426549;return ce-Math.floor(ce)}}else K=Math.random;for(let re=z.length-1;re>0;re-=1){const ce=Math.floor(K()*(re+1)),ge=z[re];z[re]=z[ce],z[ce]=ge}}e.shuffle=q;function se(z,$){const K=z.indexOf($);K>-1&&(z.splice(K,1),z.unshift($))}e.pushToStart=se;function ie(z,$){const K=z.indexOf($);K>-1&&(z.splice(K,1),z.push($))}e.pushToEnd=ie;function ne(z,$){for(const K of $)z.push(K)}e.pushMany=ne;function ue(z,$){return Array.isArray(z)?z.map($):$(z)}e.mapArrayOrNot=ue;function le(z){return Array.isArray(z)?z:[z]}e.asArray=le;function G(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=G;function Q(z,$){for(const K of z){const re=$(K);if(re!==void 0)return re}}e.mapFind=Q;function F(z,$,K){const re=B(z,$),ce=z.length,ge=K.length;z.length=ce+ge;for(let ke=ce-1;ke>=re;ke--)z[ke+ge]=z[ke];for(let ke=0;ke<ge;ke++)z[ke+re]=K[ke]}e.insertInto=F;function N(z,$,K,re){const ce=B(z,$),ge=z.splice(ce,K);return F(z,ce,re),ge}e.splice=N;function B(z,$){return $<0?Math.max($+z.length,0):Math.min($,z.length)}var V;(function(z){function $(ce){return ce<0}z.isLessThan=$;function K(ce){return ce>0}z.isGreaterThan=K;function re(ce){return ce===0}z.isNeitherLessOrGreaterThan=re,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function Y(z,$){return(K,re)=>$(z(K),z(re))}e.compareBy=Y;function ae(...z){return($,K)=>{for(const re of z){const ce=re($,K);if(!V.isNeitherLessOrGreaterThan(ce))return ce}return V.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const oe=(z,$)=>z-$;e.numberComparator=oe;function O(z,$){if(z.length===0)return;let K=z[0];for(let re=1;re<z.length;re++){const ce=z[re];$(ce,K)>0&&(K=ce)}return K}e.findMaxBy=O;function M(z,$){if(z.length===0)return;let K=z[0];for(let re=1;re<z.length;re++){const ce=z[re];$(ce,K)>=0&&(K=ce)}return K}e.findLastMaxBy=M;function W(z,$){return O(z,(K,re)=>-$(K,re))}e.findMinBy=W;class H{constructor($){this.items=$,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile($){let K=this.firstIdx;for(;K<this.items.length&&$(this.items[K]);)K++;const re=K===this.firstIdx?null:this.items.slice(this.firstIdx,K);return this.firstIdx=K,re}takeFromEndWhile($){let K=this.lastIdx;for(;K>=0&&$(this.items[K]);)K--;const re=K===this.lastIdx?null:this.items.slice(K+1,this.lastIdx+1);return this.lastIdx=K,re}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const $=this.items[this.firstIdx];return this.firstIdx++,$}removeLast(){const $=this.items[this.lastIdx];return this.lastIdx--,$}takeCount($){const K=this.items.slice(this.firstIdx,this.firstIdx+$);return this.firstIdx+=$,K}}e.ArrayQueue=H;class x{constructor($){this.iterate=$}forEach($){this.iterate(K=>($(K),!0))}toArray(){const $=[];return this.iterate(K=>($.push(K),!0)),$}filter($){return new x(K=>this.iterate(re=>$(re)?K(re):!0))}map($){return new x(K=>this.iterate(re=>K($(re))))}some($){let K=!1;return this.iterate(re=>(K=$(re),!K)),K}findFirst($){let K;return this.iterate(re=>$(re)?(K=re,!1):!0),K}findLast($){let K;return this.iterate(re=>($(re)&&(K=re),!0)),K}findLastMaxBy($){let K,re=!0;return this.iterate(ce=>((re||V.isGreaterThan($(ce,K)))&&(re=!1,K=ce),!0)),K}}e.CallbackIterable=x,x.empty=new x(z=>{})}),define(ee[134],te([0,1,13]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(h,l){if(!h)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=L;function s(h,l="Unreachable"){throw new Error(l)}e.assertNever=s;function A(h){if(!h)throw new P.BugIndicatingError("Assertion Failed")}e.assert=A;function R(h){if(!h()){debugger;h(),(0,P.onUnexpectedError)(new P.BugIndicatingError("Assertion Failed"))}}e.assertFn=R;function I(h,l){let m=0;for(;m<h.length-1;){const f=h[m],S=h[m+1];if(!l(f,S))return!1;m++}return!0}e.checkAdjacentItems=I}),define(ee[49],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function P(L){const s=this;let A=!1,R;return function(){return A||(A=!0,R=L.apply(s,arguments)),R}}e.once=P}),define(ee[68],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(L){function s(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}L.is=s;const A=Object.freeze([]);function R(){return A}L.empty=R;function*I(E){yield E}L.single=I;function h(E){return s(E)?E:I(E)}L.wrap=h;function l(E){return E||A}L.from=l;function m(E){return!E||E[Symbol.iterator]().next().done===!0}L.isEmpty=m;function f(E){return E[Symbol.iterator]().next().value}L.first=f;function S(E,w){for(const t of E)if(w(t))return!0;return!1}L.some=S;function d(E,w){for(const t of E)if(w(t))return t}L.find=d;function*y(E,w){for(const t of E)w(t)&&(yield t)}L.filter=y;function*v(E,w){let t=0;for(const u of E)yield w(u,t++)}L.map=v;function*o(...E){for(const w of E)for(const t of w)yield t}L.concat=o;function g(E,w,t){let u=t;for(const r of E)u=w(u,r);return u}L.reduce=g;function*a(E,w,t=E.length){for(w<0&&(w+=E.length),t<0?t+=E.length:t>E.length&&(t=E.length);w<t;w++)yield E[w]}L.slice=a;function b(E,w=Number.POSITIVE_INFINITY){const t=[];if(w===0)return[t,E];const u=E[Symbol.iterator]();for(let r=0;r<w;r++){const i=u.next();if(i.done)return[t,L.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return u}}]}L.consume=b})(P||(e.Iterable=P={}))}),define(ee[45],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function R(t,u=!1){let r=0;const i=t.length;let n="",c=0,p=16,D=0;function k(ie){let ne=0,ue=0;for(;ne<ie;){const le=t.charCodeAt(r);if(le>=48&&le<=57)ue=ue*16+le-48;else if(le>=65&&le<=70)ue=ue*16+le-65+10;else if(le>=97&&le<=102)ue=ue*16+le-97+10;else break;r++,ne++}return ne<ie&&(ue=-1),ue}function C(ie){r=ie,n="",c=0,p=16,D=0}function _(){const ie=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&l(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&l(t.charCodeAt(r)))for(r++;r<t.length&&l(t.charCodeAt(r));)r++;else return D=3,t.substring(ie,r);let ne=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&l(t.charCodeAt(r))){for(r++;r<t.length&&l(t.charCodeAt(r));)r++;ne=r}else D=3;return t.substring(ie,ne)}function T(){let ie="",ne=r;for(;;){if(r>=i){ie+=t.substring(ne,r),D=2;break}const ue=t.charCodeAt(r);if(ue===34){ie+=t.substring(ne,r),r++;break}if(ue===92){if(ie+=t.substring(ne,r),r++,r>=i){D=2;break}switch(t.charCodeAt(r++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const G=k(4);G>=0?ie+=String.fromCharCode(G):D=4;break}default:D=5}ne=r;continue}if(ue>=0&&ue<=31)if(h(ue)){ie+=t.substring(ne,r),D=2;break}else D=6;r++}return ie}function U(){if(n="",D=0,c=r,r>=i)return c=i,p=17;let ie=t.charCodeAt(r);if(I(ie)){do r++,n+=String.fromCharCode(ie),ie=t.charCodeAt(r);while(I(ie));return p=15}if(h(ie))return r++,n+=String.fromCharCode(ie),ie===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),p=14;switch(ie){case 123:return r++,p=1;case 125:return r++,p=2;case 91:return r++,p=3;case 93:return r++,p=4;case 58:return r++,p=6;case 44:return r++,p=5;case 34:return r++,n=T(),p=10;case 47:{const ne=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!h(t.charCodeAt(r));)r++;return n=t.substring(ne,r),p=12}if(t.charCodeAt(r+1)===42){r+=2;const ue=i-1;let le=!1;for(;r<ue;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,le=!0;break}r++}return le||(r++,D=1),n=t.substring(ne,r),p=13}return n+=String.fromCharCode(ie),r++,p=16}case 45:if(n+=String.fromCharCode(ie),r++,r===i||!l(t.charCodeAt(r)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=_(),p=11;default:for(;r<i&&q(ie);)r++,ie=t.charCodeAt(r);if(c!==r){switch(n=t.substring(c,r),n){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return n+=String.fromCharCode(ie),r++,p=16}}function q(ie){if(I(ie)||h(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let ie;do ie=U();while(ie>=12&&ie<=15);return ie}return{setPosition:C,getPosition:()=>r,scan:u?se:U,getToken:()=>p,getTokenValue:()=>n,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>D}}e.createScanner=R;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var m;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(m||(m={}));function f(t,u){const r=[],i=new Object;let n;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function D(k,C,_,T){c.value=k,c.offset=C,c.length=_,c.type=T,c.colonOffset=void 0,n=c}try{b(t,{onObjectBegin:(k,C)=>{if(u<=k)throw i;n=void 0,p=u>k,r.push("")},onObjectProperty:(k,C,_)=>{if(u<C||(D(k,C,_,"property"),r[r.length-1]=k,u<=C+_))throw i},onObjectEnd:(k,C)=>{if(u<=k)throw i;n=void 0,r.pop()},onArrayBegin:(k,C)=>{if(u<=k)throw i;n=void 0,r.push(0)},onArrayEnd:(k,C)=>{if(u<=k)throw i;n=void 0,r.pop()},onLiteralValue:(k,C,_)=>{if(u<C||(D(k,C,_,w(k)),u<=C+_))throw i},onSeparator:(k,C,_)=>{if(u<=C)throw i;if(k===":"&&n&&n.type==="property")n.colonOffset=C,p=!1,n=void 0;else if(k===","){const T=r[r.length-1];typeof T=="number"?r[r.length-1]=T+1:(p=!0,r[r.length-1]=""),n=void 0}}})}catch(k){if(k!==i)throw k}return{path:r,previousNode:n,isAtPropertyKey:p,matches:k=>{let C=0;for(let _=0;C<k.length&&_<r.length;_++)if(k[C]===r[_]||k[C]==="*")C++;else if(k[C]!=="**")return!1;return C===k.length}}}e.getLocation=f;function S(t,u=[],r=A.DEFAULT){let i=null,n=[];const c=[];function p(k){Array.isArray(n)?n.push(k):i!==null&&(n[i]=k)}return b(t,{onObjectBegin:()=>{const k={};p(k),c.push(n),n=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{n=c.pop()},onArrayBegin:()=>{const k=[];p(k),c.push(n),n=k,i=null},onArrayEnd:()=>{n=c.pop()},onLiteralValue:p,onError:(k,C,_)=>{u.push({error:k,offset:C,length:_})}},r),n[0]}e.parse=S;function d(t,u=[],r=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(k){i.type==="property"&&(i.length=k-i.offset,i=i.parent)}function c(k){return i.children.push(k),k}b(t,{onObjectBegin:k=>{i=c({type:"object",offset:k,length:-1,parent:i,children:[]})},onObjectProperty:(k,C,_)=>{i=c({type:"property",offset:C,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:k,offset:C,length:_,parent:i})},onObjectEnd:(k,C)=>{i.length=k+C-i.offset,i=i.parent,n(k+C)},onArrayBegin:(k,C)=>{i=c({type:"array",offset:k,length:-1,parent:i,children:[]})},onArrayEnd:(k,C)=>{i.length=k+C-i.offset,i=i.parent,n(k+C)},onLiteralValue:(k,C,_)=>{c({type:w(k),offset:C,length:_,parent:i,value:k}),n(C+_)},onSeparator:(k,C,_)=>{i.type==="property"&&(k===":"?i.colonOffset=C:k===","&&n(C))},onError:(k,C,_)=>{u.push({error:k,offset:C,length:_})}},r);const D=i.children[0];return D&&delete D.parent,D}e.parseTree=d;function y(t,u){if(!t)return;let r=t;for(const i of u)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===i){r=c.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.findNodeAtLocation=y;function v(t){if(!t.parent||!t.parent.children)return[];const u=v(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;u.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&u.push(r)}return u}e.getNodePath=v;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const u=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(u[r.children[0].value]=o(i))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=o;function g(t,u,r=!1){return u>=t.offset&&u<t.offset+t.length||r&&u===t.offset+t.length}e.contains=g;function a(t,u,r=!1){if(g(t,u,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=u;n++){const c=a(i[n],u,r);if(c)return c}return t}}e.findNodeAtOffset=a;function b(t,u,r=A.DEFAULT){const i=R(t,!1);function n(Y){return Y?()=>Y(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(Y){return Y?ae=>Y(ae,i.getTokenOffset(),i.getTokenLength()):()=>!0}const p=n(u.onObjectBegin),D=c(u.onObjectProperty),k=n(u.onObjectEnd),C=n(u.onArrayBegin),_=n(u.onArrayEnd),T=c(u.onLiteralValue),U=c(u.onSeparator),q=n(u.onComment),se=c(u.onError),ie=r&&r.disallowComments,ne=r&&r.allowTrailingComma;function ue(){for(;;){const Y=i.scan();switch(i.getTokenError()){case 4:le(14);break;case 5:le(15);break;case 3:le(13);break;case 1:ie||le(11);break;case 2:le(12);break;case 6:le(16);break}switch(Y){case 12:case 13:ie?le(10):q();break;case 16:le(1);break;case 15:case 14:break;default:return Y}}}function le(Y,ae=[],oe=[]){if(se(Y),ae.length+oe.length>0){let O=i.getToken();for(;O!==17;){if(ae.indexOf(O)!==-1){ue();break}else if(oe.indexOf(O)!==-1)break;O=ue()}}}function G(Y){const ae=i.getTokenValue();return Y?T(ae):D(ae),ue(),!0}function Q(){switch(i.getToken()){case 11:{let Y=0;try{Y=JSON.parse(i.getTokenValue()),typeof Y!="number"&&(le(2),Y=0)}catch{le(2)}T(Y);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return ue(),!0}function F(){return i.getToken()!==10?(le(3,[],[2,5]),!1):(G(!1),i.getToken()===6?(U(":"),ue(),V()||le(4,[],[2,5])):le(5,[],[2,5]),!0)}function N(){p(),ue();let Y=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Y||le(4,[],[]),U(","),ue(),i.getToken()===2&&ne)break}else Y&&le(6,[],[]);F()||le(4,[],[2,5]),Y=!0}return k(),i.getToken()!==2?le(7,[2],[]):ue(),!0}function B(){C(),ue();let Y=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Y||le(4,[],[]),U(","),ue(),i.getToken()===4&&ne)break}else Y&&le(6,[],[]);V()||le(4,[],[4,5]),Y=!0}return _(),i.getToken()!==4?le(8,[4],[]):ue(),!0}function V(){switch(i.getToken()){case 3:return B();case 1:return N();case 10:return G(!0);default:return Q()}}return ue(),i.getToken()===17?r.allowEmptyContent?!0:(le(4,[],[]),!1):V()?(i.getToken()!==17&&le(9,[],[]),!0):(le(4,[],[]),!1)}e.visit=b;function E(t,u){const r=R(t),i=[];let n,c=0,p;do switch(p=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:c!==p&&i.push(t.substring(c,p)),u!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,u)),c=r.getPosition();break}while(n!==17);return i.join("")}e.stripComments=E;function w(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(ee[135],te([0,1,45]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function L(l,m,f){let S,d,y,v,o;if(m){for(v=m.offset,o=v+m.length,y=v;y>0&&!h(l,y-1);)y--;let p=o;for(;p<l.length&&!h(l,p);)p++;d=l.substring(y,p),S=R(d,f)}else d=l,S=0,y=0,v=0,o=l.length;const g=I(f,l);let a=!1,b=0,E;f.insertSpaces?E=A(" ",f.tabSize||4):E="	";const w=(0,P.createScanner)(d,!1);let t=!1;function u(){return g+A(E,S+b)}function r(){let p=w.scan();for(a=!1;p===15||p===14;)a=a||p===14,p=w.scan();return t=p===16||w.getTokenError()!==0,p}const i=[];function n(p,D,k){!t&&D<o&&k>v&&l.substring(D,k)!==p&&i.push({offset:D,length:k-D,content:p})}let c=r();if(c!==17){const p=w.getTokenOffset()+y,D=A(E,S);n(D,y,p)}for(;c!==17;){let p=w.getTokenOffset()+w.getTokenLength()+y,D=r(),k="";for(;!a&&(D===12||D===13);){const _=w.getTokenOffset()+y;n(" ",p,_),p=w.getTokenOffset()+w.getTokenLength()+y,k=D===12?u():"",D=r()}if(D===2)c!==1&&(b--,k=u());else if(D===4)c!==3&&(b--,k=u());else{switch(c){case 3:case 1:b++,k=u();break;case 5:case 12:k=u();break;case 13:a?k=u():k=" ";break;case 6:k=" ";break;case 10:if(D===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:D===12||D===13?k=" ":D!==5&&D!==17&&(t=!0);break;case 16:t=!0;break}a&&(D===12||D===13)&&(k=u())}const C=w.getTokenOffset()+y;n(k,p,C),c=D}return i}e.format=L;function s(l,m){const f=JSON.stringify(l,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?f.replace(/\r\n|\r|\n/g,m.eol):f}e.toFormattedString=s;function A(l,m){let f="";for(let S=0;S<m;S++)f+=l;return f}function R(l,m){let f=0,S=0;const d=m.tabSize||4;for(;f<l.length;){const y=l.charAt(f);if(y===" ")S++;else if(y==="	")S+=d;else break;f++}return Math.floor(S/d)}function I(l,m){for(let f=0;f<m.length;f++){const S=m.charAt(f);if(S==="\r")return f+1<m.length&&m.charAt(f+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return l&&l.eol||`
`}e.getEOL=I;function h(l,m){return`\r
`.indexOf(l.charAt(m))!==-1}e.isEOL=h}),define(ee[136],te([0,1,45,135]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function s(l,m,f){return A(l,m,void 0,f)}e.removeProperty=s;function A(l,m,f,S,d){const y=m.slice(),v=[],o=(0,P.parseTree)(l,v);let g,a;for(;y.length>0&&(a=y.pop(),g=(0,P.findNodeAtLocation)(o,y),g===void 0&&f!==void 0);)typeof a=="string"?f={[a]:f}:f=[f];if(g)if(g.type==="object"&&typeof a=="string"&&Array.isArray(g.children)){const b=(0,P.findNodeAtLocation)(g,[a]);if(b!==void 0)if(f===void 0){if(!b.parent)throw new Error("Malformed AST");const E=g.children.indexOf(b.parent);let w,t=b.parent.offset+b.parent.length;if(E>0){const u=g.children[E-1];w=u.offset+u.length}else w=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return R(l,{offset:w,length:t-w,content:""},S)}else return R(l,{offset:b.offset,length:b.length,content:JSON.stringify(f)},S);else{if(f===void 0)return[];const E=`${JSON.stringify(a)}: ${JSON.stringify(f)}`,w=d?d(g.children.map(u=>u.children[0].value)):g.children.length;let t;if(w>0){const u=g.children[w-1];t={offset:u.offset+u.length,length:0,content:","+E}}else g.children.length===0?t={offset:g.offset+1,length:0,content:E}:t={offset:g.offset+1,length:0,content:E+","};return R(l,t,S)}}else if(g.type==="array"&&typeof a=="number"&&Array.isArray(g.children))if(f!==void 0){const b=`${JSON.stringify(f)}`;let E;if(g.children.length===0||a===0)E={offset:g.offset+1,length:0,content:g.children.length===0?b:b+","};else{const w=a===-1||a>g.children.length?g.children.length:a,t=g.children[w-1];E={offset:t.offset+t.length,length:0,content:","+b}}return R(l,E,S)}else{const b=a,E=g.children[b];let w;if(g.children.length===1)w={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===b){const t=g.children[b-1],u=t.offset+t.length,r=g.offset+g.length;w={offset:u,length:r-2-u,content:""}}else w={offset:E.offset,length:g.children[b+1].offset-E.offset,content:""};return R(l,w,S)}else throw new Error(`Can not add ${typeof a!="number"?"index":"property"} to parent of type ${g.type}`);else{if(f===void 0)throw new Error("Can not delete in empty document");return R(l,{offset:o?o.offset:0,length:o?o.length:0,content:JSON.stringify(f)},S)}}e.setProperty=A;function R(l,m,f){let S=I(l,m),d=m.offset,y=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;d>0&&!(0,L.isEOL)(S,d-1);)d--;for(;y<S.length&&!(0,L.isEOL)(S,y);)y++}const v=(0,L.format)(S,{offset:d,length:y-d},f);for(let g=v.length-1;g>=0;g--){const a=v[g];S=I(S,a),d=Math.min(d,a.offset),y=Math.max(y,a.offset+a.length),y+=a.content.length-a.length}const o=l.length-(S.length-y)-d;return[{offset:d,length:o,content:S.substring(d,y)}]}e.withFormatting=R;function I(l,m){return l.substring(0,m.offset)+m.content+l.substring(m.offset+m.length)}e.applyEdit=I;function h(l,m){const f=m.slice(0).sort((d,y)=>{const v=d.offset-y.offset;return v===0?d.length-y.length:v});let S=l.length;for(let d=f.length-1;d>=0;d--){const y=f[d];if(y.offset+y.length<=S)l=I(l,y);else throw new Error("Overlapping edit");S=y.offset}return l}e.applyEdits=h}),define(ee[83],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class P{constructor(s){this.executor=s,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(s){this._error=s}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=P}),define(ee[2],te([0,1,49,68]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const s=!1;let A=null;function R(c){A=c}if(e.setDisposableTracker=R,s){const c="__is_disposable_tracked__";R(new class{trackDisposable(p){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{p[c]||console.log(D)},3e3)}setParent(p,D){if(p&&p!==a.None)try{p[c]=!0}catch{}}markAsDisposed(p){if(p&&p!==a.None)try{p[c]=!0}catch{}}markAsSingleton(p){}})}function I(c){return A?.trackDisposable(c),c}function h(c){A?.markAsDisposed(c)}function l(c,p){A?.setParent(c,p)}function m(c,p){if(A)for(const D of c)A.setParent(D,p)}function f(c){return A?.markAsSingleton(c),c}e.markAsSingleton=f;function S(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=S;function d(c){if(L.Iterable.is(c)){const p=[];for(const D of c)if(D)try{D.dispose()}catch(k){p.push(k)}if(p.length===1)throw p[0];if(p.length>1)throw new AggregateError(p,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=d;function y(c){for(const p of c)S(p)&&p.dispose();return[]}e.disposeIfDisposable=y;function v(...c){const p=o(()=>d(c));return m(c,p),p}e.combinedDisposable=v;function o(c){const p=I({dispose:(0,P.once)(()=>{h(p),c()})});return p}e.toDisposable=o;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{d(this._toDispose)}finally{this._toDispose.clear()}}add(p){if(!p)return p;if(p===this)throw new Error("Cannot register a disposable on itself!");return l(p,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(p),p}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class a{constructor(){this._store=new g,I(this),l(this._store,this)}dispose(){h(this),this._store.dispose()}_register(p){if(p===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(p)}}e.Disposable=a,a.None=Object.freeze({dispose(){}});class b{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(p){this._isDisposed||p===this._value||(this._value?.dispose(),p&&l(p,this),this._value=p)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const p=this._value;return this._value=void 0,p&&l(p,null),p}}e.MutableDisposable=b;class E{constructor(p){this._disposable=p,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=E;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(p){let D=p;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,h(this))},this}}e.SafeDisposable=w;class t{constructor(){this.references=new Map}acquire(p,...D){let k=this.references.get(p);k||(k={counter:0,object:this.createReferencedObject(p,...D)},this.references.set(p,k));const{object:C}=k,_=(0,P.once)(()=>{--k.counter===0&&(this.destroyReferencedObject(p,k.object),this.references.delete(p))});return k.counter++,{object:C,dispose:_}}}e.ReferenceCollection=t;class u{constructor(p){this.referenceCollection=p}async acquire(p,...D){const k=this.referenceCollection.acquire(p,...D);try{return{object:await k.object,dispose:()=>k.dispose()}}catch(C){throw k.dispose(),C}}}e.AsyncReferenceCollection=u;class r{constructor(p){this.object=p}dispose(){}}e.ImmortalReference=r;function i(c){const p=new g;try{c(p)}finally{p.dispose()}}e.disposeOnReturn=i;class n{constructor(){this._store=new Map,this._isDisposed=!1,I(this)}dispose(){h(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{d(this._store.values())}finally{this._store.clear()}}has(p){return this._store.has(p)}get(p){return this._store.get(p)}set(p,D,k=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),k||this._store.get(p)?.dispose(),this._store.set(p,D)}deleteAndDispose(p){this._store.get(p)?.dispose(),this._store.delete(p)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=n}),define(ee[101],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class P{constructor(A){this.element=A,this.next=P.Undefined,this.prev=P.Undefined}}P.Undefined=new P(void 0);class L{constructor(){this._first=P.Undefined,this._last=P.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===P.Undefined}clear(){let A=this._first;for(;A!==P.Undefined;){const R=A.next;A.prev=P.Undefined,A.next=P.Undefined,A=R}this._first=P.Undefined,this._last=P.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,R){const I=new P(A);if(this._first===P.Undefined)this._first=I,this._last=I;else if(R){const l=this._last;this._last=I,I.prev=l,l.next=I}else{const l=this._first;this._first=I,I.next=l,l.prev=I}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(I))}}shift(){if(this._first!==P.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==P.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==P.Undefined&&A.next!==P.Undefined){const R=A.prev;R.next=A.next,A.next.prev=R}else A.prev===P.Undefined&&A.next===P.Undefined?(this._first=P.Undefined,this._last=P.Undefined):A.next===P.Undefined?(this._last=this._last.prev,this._last.next=P.Undefined):A.prev===P.Undefined&&(this._first=this._first.next,this._first.prev=P.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==P.Undefined;)yield A.element,A=A.next}}e.LinkedList=L}),define(ee[35],te([0,1]),function(j,e){"use strict";var P,L,s;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(v,o,g){let a=v.get(o);return a===void 0&&(a=g,v.set(o,a)),a}e.getOrSet=A;function R(v){const o=[];return v.forEach((g,a)=>{o.push(`${a} => ${g}`)}),`Map(${v.size}) {${o.join(", ")}}`}e.mapToString=R;function I(v){const o=[];return v.forEach(g=>{o.push(g)}),`Set(${v.size}) {${o.join(", ")}}`}e.setToString=I;class h{constructor(o,g){this.uri=o,this.value=g}}class l{constructor(o,g){this[P]="ResourceMap",o instanceof l?(this.map=new Map(o.map),this.toKey=g??l.defaultToKey):(this.map=new Map,this.toKey=o??l.defaultToKey)}set(o,g){return this.map.set(this.toKey(o),new h(o,g)),this}get(o){return this.map.get(this.toKey(o))?.value}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,g){typeof g<"u"&&(o=o.bind(g));for(const[a,b]of this.map)o(b.value,b.uri,this)}*values(){for(const o of this.map.values())yield o.value}*keys(){for(const o of this.map.values())yield o.uri}*entries(){for(const o of this.map.values())yield[o.uri,o.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.map)yield[o.uri,o.value]}}e.ResourceMap=l,l.defaultToKey=v=>v.toString();class m{constructor(o,g){this[L]="ResourceSet",!o||typeof o=="function"?this._map=new l(o):(this._map=new l(g),o.forEach(this.add,this))}get size(){return this._map.size}add(o){return this._map.set(o,o),this}clear(){this._map.clear()}delete(o){return this._map.delete(o)}forEach(o,g){this._map.forEach((a,b)=>o.call(g,b,b,this))}has(o){return this._map.has(o)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=m;var f;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(f||(e.Touch=f={}));class S{constructor(){this[s]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(o){return this._map.has(o)}get(o,g=0){const a=this._map.get(o);if(a)return g!==0&&this.touch(a,g),a.value}set(o,g,a=0){let b=this._map.get(o);if(b)b.value=g,a!==0&&this.touch(b,a);else{switch(b={key:o,value:g,next:void 0,previous:void 0},a){case 0:this.addItemLast(b);break;case 1:this.addItemFirst(b);break;case 2:this.addItemLast(b);break;default:this.addItemLast(b);break}this._map.set(o,b),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const g=this._map.get(o);if(g)return this._map.delete(o),this.removeItem(g),this._size--,g.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}forEach(o,g){const a=this._state;let b=this._head;for(;b;){if(g?o.bind(g)(b.value,b.key,this):o(b.value,b.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const o=this,g=this._state;let a=this._head;const b={[Symbol.iterator](){return b},next(){if(o._state!==g)throw new Error("LinkedMap got modified during iteration.");if(a){const E={value:a.key,done:!1};return a=a.next,E}else return{value:void 0,done:!0}}};return b}values(){const o=this,g=this._state;let a=this._head;const b={[Symbol.iterator](){return b},next(){if(o._state!==g)throw new Error("LinkedMap got modified during iteration.");if(a){const E={value:a.value,done:!1};return a=a.next,E}else return{value:void 0,done:!0}}};return b}entries(){const o=this,g=this._state;let a=this._head;const b={[Symbol.iterator](){return b},next(){if(o._state!==g)throw new Error("LinkedMap got modified during iteration.");if(a){const E={value:[a.key,a.value],done:!1};return a=a.next,E}else return{value:void 0,done:!0}}};return b}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(o>=this.size)return;if(o===0){this.clear();return}let g=this._head,a=this.size;for(;g&&a>o;)this._map.delete(g.key),g=g.next,a--;this._head=g,this._size=a,g&&(g.previous=void 0),this._state++}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const g=o.next,a=o.previous;if(!g||!a)throw new Error("Invalid list");g.previous=a,a.next=g}o.next=void 0,o.previous=void 0,this._state++}touch(o,g){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(o===this._head)return;const a=o.next,b=o.previous;o===this._tail?(b.next=void 0,this._tail=b):(a.previous=b,b.next=a),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(g===2){if(o===this._tail)return;const a=o.next,b=o.previous;o===this._head?(a.previous=void 0,this._head=a):(a.previous=b,b.next=a),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((g,a)=>{o.push([a,g])}),o}fromJSON(o){this.clear();for(const[g,a]of o)this.set(g,a)}}e.LinkedMap=S;class d extends S{constructor(o,g=1){super(),this._limit=o,this._ratio=Math.min(Math.max(0,g),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,g=2){return super.get(o,g)}peek(o){return super.get(o,0)}set(o,g){return super.set(o,g,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d;class y{constructor(){this.map=new Map}add(o){return this.map.set(o,(this.map.get(o)||0)+1),this}delete(o){let g=this.map.get(o)||0;return g===0?!1:(g--,g===0?this.map.delete(o):this.map.set(o,g),!0)}has(o){return this.map.has(o)}}e.CounterSet=y}),define(ee[84],te([0,1,35]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new P.LRUCache(1e4);function s(l){return h(l,"NFC",L)}e.normalizeNFC=s;const A=new P.LRUCache(1e4);function R(l){return h(l,"NFD",A)}e.normalizeNFD=R;const I=/[^\u0000-\u0080]/;function h(l,m,f){if(!l)return l;const S=f.get(l);if(S)return S;let d;return I.test(l)?d=l.normalize(m):d=l,f.set(l,d),d}e.removeAccents=function(){const l=/[\u0300-\u036f]/g;return function(m){return R(m).replace(l,"")}}()}),define(ee[137],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function P(I,h,l){return Math.min(Math.max(I,h),l)}e.clamp=P;function L(I,h){return(h+I%h)%h}e.rot=L;class s{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=s;class A{constructor(){this._n=1,this._val=0}update(h){return this._val=this._val+(h-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class R{constructor(h){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(h),this._values.fill(0,0,h)}update(h){const l=this._values[this._index];return this._values[this._index]=h,this._index=(this._index+1)%this._values.length,this._sum-=l,this._sum+=h,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=R}),function(){function j(s){const A=[];typeof s=="number"&&A.push("code/timeOrigin",s);function R(h){A.push(h,Date.now())}function I(){const h=[];for(let l=0;l<A.length;l+=2)h.push({name:A[l],startTime:A[l+1]});return h}return{mark:R,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(s+R.startTime)});return A}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function P(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=P(L))}(),function(j,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var L in P)(typeof exports=="object"?exports:j)[L]=P[L]}}(typeof self<"u"?self:this,function(){return function(j){var e={};function P(L){if(e[L])return e[L].exports;var s=e[L]={i:L,l:!1,exports:{}};return j[L].call(s.exports,s,s.exports,P),s.l=!0,s.exports}return P.m=j,P.c=e,P.d=function(L,s,A){P.o(L,s)||Object.defineProperty(L,s,{enumerable:!0,get:A})},P.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},P.t=function(L,s){if(1&s&&(L=P(L)),8&s||4&s&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(P.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&s&&typeof L!="string")for(var R in L)P.d(A,R,function(I){return L[I]}.bind(null,R));return A},P.n=function(L){var s=L&&L.__esModule?function(){return L.default}:function(){return L};return P.d(s,"a",s),s},P.o=function(L,s){return Object.prototype.hasOwnProperty.call(L,s)},P.p="",P(P.s=0)}([function(j,e,P){(function(L){var s;e=j.exports=oe,s=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],h=e.src=[],l=0,m=l++;h[m]="0|[1-9]\\d*";var f=l++;h[f]="[0-9]+";var S=l++;h[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=l++;h[d]="("+h[m]+")\\.("+h[m]+")\\.("+h[m]+")";var y=l++;h[y]="("+h[f]+")\\.("+h[f]+")\\.("+h[f]+")";var v=l++;h[v]="(?:"+h[m]+"|"+h[S]+")";var o=l++;h[o]="(?:"+h[f]+"|"+h[S]+")";var g=l++;h[g]="(?:-("+h[v]+"(?:\\."+h[v]+")*))";var a=l++;h[a]="(?:-?("+h[o]+"(?:\\."+h[o]+")*))";var b=l++;h[b]="[0-9A-Za-z-]+";var E=l++;h[E]="(?:\\+("+h[b]+"(?:\\."+h[b]+")*))";var w=l++,t="v?"+h[d]+h[g]+"?"+h[E]+"?";h[w]="^"+t+"$";var u="[v=\\s]*"+h[y]+h[a]+"?"+h[E]+"?",r=l++;h[r]="^"+u+"$";var i=l++;h[i]="((?:<|>)?=?)";var n=l++;h[n]=h[f]+"|x|X|\\*";var c=l++;h[c]=h[m]+"|x|X|\\*";var p=l++;h[p]="[v=\\s]*("+h[c]+")(?:\\.("+h[c]+")(?:\\.("+h[c]+")(?:"+h[g]+")?"+h[E]+"?)?)?";var D=l++;h[D]="[v=\\s]*("+h[n]+")(?:\\.("+h[n]+")(?:\\.("+h[n]+")(?:"+h[a]+")?"+h[E]+"?)?)?";var k=l++;h[k]="^"+h[i]+"\\s*"+h[p]+"$";var C=l++;h[C]="^"+h[i]+"\\s*"+h[D]+"$";var _=l++;h[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=l++;h[T]="(?:~>?)";var U=l++;h[U]="(\\s*)"+h[T]+"\\s+",I[U]=new RegExp(h[U],"g");var q=l++;h[q]="^"+h[T]+h[p]+"$";var se=l++;h[se]="^"+h[T]+h[D]+"$";var ie=l++;h[ie]="(?:\\^)";var ne=l++;h[ne]="(\\s*)"+h[ie]+"\\s+",I[ne]=new RegExp(h[ne],"g");var ue=l++;h[ue]="^"+h[ie]+h[p]+"$";var le=l++;h[le]="^"+h[ie]+h[D]+"$";var G=l++;h[G]="^"+h[i]+"\\s*("+u+")$|^$";var Q=l++;h[Q]="^"+h[i]+"\\s*("+t+")$|^$";var F=l++;h[F]="(\\s*)"+h[i]+"\\s*("+u+"|"+h[p]+")",I[F]=new RegExp(h[F],"g");var N=l++;h[N]="^\\s*("+h[p]+")\\s+-\\s+("+h[p]+")\\s*$";var B=l++;h[B]="^\\s*("+h[D]+")\\s+-\\s+("+h[D]+")\\s*$";var V=l++;h[V]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)s(Y,h[Y]),I[Y]||(I[Y]=new RegExp(h[Y]));function ae(Z,de){if(Z instanceof oe)return Z;if(typeof Z!="string"||Z.length>A||!(de?I[r]:I[w]).test(Z))return null;try{return new oe(Z,de)}catch{return null}}function oe(Z,de){if(Z instanceof oe){if(Z.loose===de)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof oe))return new oe(Z,de);s("SemVer",Z,de),this.loose=de;var fe=Z.trim().match(de?I[r]:I[w]);if(!fe)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var De=+Ce;if(De>=0&&De<R)return De}return Ce}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=ae,e.valid=function(Z,de){var fe=ae(Z,de);return fe?fe.version:null},e.clean=function(Z,de){var fe=ae(Z.trim().replace(/^[=v]+/,""),de);return fe?fe.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(Z){return s("SemVer.compare",this.version,this.loose,Z),Z instanceof oe||(Z=new oe(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},oe.prototype.compareMain=function(Z){return Z instanceof oe||(Z=new oe(Z,this.loose)),M(this.major,Z.major)||M(this.minor,Z.minor)||M(this.patch,Z.patch)},oe.prototype.comparePre=function(Z){if(Z instanceof oe||(Z=new oe(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var de=0;do{var fe=this.prerelease[de],Ce=Z.prerelease[de];if(s("prerelease compare",de,fe,Ce),fe===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(fe===void 0)return-1;if(fe!==Ce)return M(fe,Ce)}while(++de)},oe.prototype.inc=function(Z,de){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,de,fe,Ce){typeof fe=="string"&&(Ce=fe,fe=void 0);try{return new oe(Z,fe).inc(de,Ce).version}catch{return null}},e.diff=function(Z,de){if(z(Z,de))return null;var fe=ae(Z),Ce=ae(de);if(fe.prerelease.length||Ce.prerelease.length){for(var De in fe)if((De==="major"||De==="minor"||De==="patch")&&fe[De]!==Ce[De])return"pre"+De;return"prerelease"}for(var De in fe)if((De==="major"||De==="minor"||De==="patch")&&fe[De]!==Ce[De])return De},e.compareIdentifiers=M;var O=/^[0-9]+$/;function M(Z,de){var fe=O.test(Z),Ce=O.test(de);return fe&&Ce&&(Z=+Z,de=+de),fe&&!Ce?-1:Ce&&!fe?1:Z<de?-1:Z>de?1:0}function W(Z,de,fe){return new oe(Z,fe).compare(new oe(de,fe))}function H(Z,de,fe){return W(Z,de,fe)>0}function x(Z,de,fe){return W(Z,de,fe)<0}function z(Z,de,fe){return W(Z,de,fe)===0}function $(Z,de,fe){return W(Z,de,fe)!==0}function K(Z,de,fe){return W(Z,de,fe)>=0}function re(Z,de,fe){return W(Z,de,fe)<=0}function ce(Z,de,fe,Ce){var De;switch(de){case"===":typeof Z=="object"&&(Z=Z.version),typeof fe=="object"&&(fe=fe.version),De=Z===fe;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof fe=="object"&&(fe=fe.version),De=Z!==fe;break;case"":case"=":case"==":De=z(Z,fe,Ce);break;case"!=":De=$(Z,fe,Ce);break;case">":De=H(Z,fe,Ce);break;case">=":De=K(Z,fe,Ce);break;case"<":De=x(Z,fe,Ce);break;case"<=":De=re(Z,fe,Ce);break;default:throw new TypeError("Invalid operator: "+de)}return De}function ge(Z,de){if(Z instanceof ge){if(Z.loose===de)return Z;Z=Z.value}if(!(this instanceof ge))return new ge(Z,de);s("comparator",Z,de),this.loose=de,this.parse(Z),this.semver===ke?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(Z,de){return M(de,Z)},e.major=function(Z,de){return new oe(Z,de).major},e.minor=function(Z,de){return new oe(Z,de).minor},e.patch=function(Z,de){return new oe(Z,de).patch},e.compare=W,e.compareLoose=function(Z,de){return W(Z,de,!0)},e.rcompare=function(Z,de,fe){return W(de,Z,fe)},e.sort=function(Z,de){return Z.sort(function(fe,Ce){return e.compare(fe,Ce,de)})},e.rsort=function(Z,de){return Z.sort(function(fe,Ce){return e.rcompare(fe,Ce,de)})},e.gt=H,e.lt=x,e.eq=z,e.neq=$,e.gte=K,e.lte=re,e.cmp=ce,e.Comparator=ge;var ke={};function Re(Z,de){if(Z instanceof Re)return Z.loose===de?Z:new Re(Z.raw,de);if(Z instanceof ge)return new Re(Z.value,de);if(!(this instanceof Re))return new Re(Z,de);if(this.loose=de,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Le(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function Oe(Z,de,fe,Ce,De,Te,We,He,$e,ze,qe,Be,X){return((de=Le(fe)?"":Le(Ce)?">="+fe+".0.0":Le(De)?">="+fe+"."+Ce+".0":">="+de)+" "+(He=Le($e)?"":Le(ze)?"<"+(+$e+1)+".0.0":Le(qe)?"<"+$e+"."+(+ze+1)+".0":Be?"<="+$e+"."+ze+"."+qe+"-"+Be:"<="+He)).trim()}function ye(Z,de){for(var fe=0;fe<Z.length;fe++)if(!Z[fe].test(de))return!1;if(de.prerelease.length){for(fe=0;fe<Z.length;fe++)if(s(Z[fe].semver),Z[fe].semver!==ke&&Z[fe].semver.prerelease.length>0){var Ce=Z[fe].semver;if(Ce.major===de.major&&Ce.minor===de.minor&&Ce.patch===de.patch)return!0}return!1}return!0}function we(Z,de,fe){try{de=new Re(de,fe)}catch{return!1}return de.test(Z)}function Ee(Z,de,fe,Ce){var De,Te,We,He,$e;switch(Z=new oe(Z,Ce),de=new Re(de,Ce),fe){case">":De=H,Te=re,We=x,He=">",$e=">=";break;case"<":De=x,Te=K,We=H,He="<",$e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(Z,de,Ce))return!1;for(var ze=0;ze<de.set.length;++ze){var qe=de.set[ze],Be=null,X=null;if(qe.forEach(function(he){he.semver===ke&&(he=new ge(">=0.0.0")),Be=Be||he,X=X||he,De(he.semver,Be.semver,Ce)?Be=he:We(he.semver,X.semver,Ce)&&(X=he)}),Be.operator===He||Be.operator===$e||(!X.operator||X.operator===He)&&Te(Z,X.semver)||X.operator===$e&&We(Z,X.semver))return!1}return!0}ge.prototype.parse=function(Z){var de=this.loose?I[G]:I[Q],fe=Z.match(de);if(!fe)throw new TypeError("Invalid comparator: "+Z);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new oe(fe[2],this.loose):this.semver=ke},ge.prototype.toString=function(){return this.value},ge.prototype.test=function(Z){return s("Comparator.test",Z,this.loose),this.semver===ke||(typeof Z=="string"&&(Z=new oe(Z,this.loose)),ce(Z,this.operator,this.semver,this.loose))},ge.prototype.intersects=function(Z,de){if(!(Z instanceof ge))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Re(Z.value,de),we(this.value,fe,de);if(Z.operator==="")return fe=new Re(this.value,de),we(Z.semver,fe,de);var Ce=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Te=this.semver.version===Z.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),He=ce(this.semver,"<",Z.semver,de)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),$e=ce(this.semver,">",Z.semver,de)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return Ce||De||Te&&We||He||$e},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(Z){var de=this.loose;Z=Z.trim(),s("range",Z,de);var fe=de?I[B]:I[N];Z=Z.replace(fe,Oe),s("hyphen replace",Z),Z=Z.replace(I[F],"$1$2$3"),s("comparator trim",Z,I[F]),Z=(Z=(Z=Z.replace(I[U],"$1~")).replace(I[ne],"$1^")).split(/\s+/).join(" ");var Ce=de?I[G]:I[Q],De=Z.split(" ").map(function(Te){return function(We,He){return s("comp",We),We=function($e,ze){return $e.trim().split(/\s+/).map(function(qe){return function(Be,X){s("caret",Be,X);var he=X?I[le]:I[ue];return Be.replace(he,function(me,pe,be,Ae,Ue){var Ge;return s("caret",Be,me,pe,be,Ae,Ue),Le(pe)?Ge="":Le(be)?Ge=">="+pe+".0.0 <"+(+pe+1)+".0.0":Le(Ae)?Ge=pe==="0"?">="+pe+"."+be+".0 <"+pe+"."+(+be+1)+".0":">="+pe+"."+be+".0 <"+(+pe+1)+".0.0":Ue?(s("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ge=pe==="0"?be==="0"?">="+pe+"."+be+"."+Ae+Ue+" <"+pe+"."+be+"."+(+Ae+1):">="+pe+"."+be+"."+Ae+Ue+" <"+pe+"."+(+be+1)+".0":">="+pe+"."+be+"."+Ae+Ue+" <"+(+pe+1)+".0.0"):(s("no pr"),Ge=pe==="0"?be==="0"?">="+pe+"."+be+"."+Ae+" <"+pe+"."+be+"."+(+Ae+1):">="+pe+"."+be+"."+Ae+" <"+pe+"."+(+be+1)+".0":">="+pe+"."+be+"."+Ae+" <"+(+pe+1)+".0.0"),s("caret return",Ge),Ge})}(qe,ze)}).join(" ")}(We,He),s("caret",We),We=function($e,ze){return $e.trim().split(/\s+/).map(function(qe){return function(Be,X){var he=X?I[se]:I[q];return Be.replace(he,function(me,pe,be,Ae,Ue){var Ge;return s("tilde",Be,me,pe,be,Ae,Ue),Le(pe)?Ge="":Le(be)?Ge=">="+pe+".0.0 <"+(+pe+1)+".0.0":Le(Ae)?Ge=">="+pe+"."+be+".0 <"+pe+"."+(+be+1)+".0":Ue?(s("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ge=">="+pe+"."+be+"."+Ae+Ue+" <"+pe+"."+(+be+1)+".0"):Ge=">="+pe+"."+be+"."+Ae+" <"+pe+"."+(+be+1)+".0",s("tilde return",Ge),Ge})}(qe,ze)}).join(" ")}(We,He),s("tildes",We),We=function($e,ze){return s("replaceXRanges",$e,ze),$e.split(/\s+/).map(function(qe){return function(Be,X){Be=Be.trim();var he=X?I[C]:I[k];return Be.replace(he,function(me,pe,be,Ae,Ue,Ge){s("xRange",Be,me,pe,be,Ae,Ue,Ge);var Je=Le(be),Ve=Je||Le(Ae),Ye=Ve||Le(Ue);return pe==="="&&Ye&&(pe=""),Je?me=pe===">"||pe==="<"?"<0.0.0":"*":pe&&Ye?(Ve&&(Ae=0),Ye&&(Ue=0),pe===">"?(pe=">=",Ve?(be=+be+1,Ae=0,Ue=0):Ye&&(Ae=+Ae+1,Ue=0)):pe==="<="&&(pe="<",Ve?be=+be+1:Ae=+Ae+1),me=pe+be+"."+Ae+"."+Ue):Ve?me=">="+be+".0.0 <"+(+be+1)+".0.0":Ye&&(me=">="+be+"."+Ae+".0 <"+be+"."+(+Ae+1)+".0"),s("xRange return",me),me})}(qe,ze)}).join(" ")}(We,He),s("xrange",We),We=function($e,ze){return s("replaceStars",$e,ze),$e.trim().replace(I[V],"")}(We,He),s("stars",We),We}(Te,de)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Te){return!!Te.match(Ce)})),De=De.map(function(Te){return new ge(Te,de)})},Re.prototype.intersects=function(Z,de){if(!(Z instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Ce){return Z.set.some(function(De){return De.every(function(Te){return Ce.intersects(Te,de)})})})})},e.toComparators=function(Z,de){return new Re(Z,de).set.map(function(fe){return fe.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new oe(Z,this.loose));for(var de=0;de<this.set.length;de++)if(ye(this.set[de],Z))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(Z,de,fe){var Ce=null,De=null;try{var Te=new Re(de,fe)}catch{return null}return Z.forEach(function(We){Te.test(We)&&(Ce&&De.compare(We)!==-1||(De=new oe(Ce=We,fe)))}),Ce},e.minSatisfying=function(Z,de,fe){var Ce=null,De=null;try{var Te=new Re(de,fe)}catch{return null}return Z.forEach(function(We){Te.test(We)&&(Ce&&De.compare(We)!==1||(De=new oe(Ce=We,fe)))}),Ce},e.validRange=function(Z,de){try{return new Re(Z,de).range||"*"}catch{return null}},e.ltr=function(Z,de,fe){return Ee(Z,de,"<",fe)},e.gtr=function(Z,de,fe){return Ee(Z,de,">",fe)},e.outside=Ee,e.prerelease=function(Z,de){var fe=ae(Z,de);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(Z,de,fe){return Z=new Re(Z,fe),de=new Re(de,fe),Z.intersects(de)},e.coerce=function(Z){if(Z instanceof oe)return Z;if(typeof Z!="string")return null;var de=Z.match(I[_]);return de==null?null:ae((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,P(1))},function(j,e){var P,L,s=j.exports={};function A(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function I(o){if(P===setTimeout)return setTimeout(o,0);if((P===A||!P)&&setTimeout)return P=setTimeout,setTimeout(o,0);try{return P(o,0)}catch{try{return P.call(null,o,0)}catch{return P.call(this,o,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:A}catch{P=A}try{L=typeof clearTimeout=="function"?clearTimeout:R}catch{L=R}})();var h,l=[],m=!1,f=-1;function S(){m&&h&&(m=!1,h.length?l=h.concat(l):f=-1,l.length&&d())}function d(){if(!m){var o=I(S);m=!0;for(var g=l.length;g;){for(h=l,l=[];++f<g;)h&&h[f].run();f=-1,g=l.length}h=null,m=!1,function(a){if(L===clearTimeout)return clearTimeout(a);if((L===R||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(a);try{L(a)}catch{try{return L.call(null,a)}catch{return L.call(this,a)}}}(o)}}function y(o,g){this.fun=o,this.array=g}function v(){}s.nextTick=function(o){var g=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)g[a-1]=arguments[a];l.push(new y(o,g)),l.length!==1||m||I(d)},y.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=v,s.addListener=v,s.once=v,s.off=v,s.removeListener=v,s.removeAllListeners=v,s.emit=v,s.prependListener=v,s.prependOnceListener=v,s.listeners=function(o){return[]},s.binding=function(o){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(o){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(ee[138],te([0,1]),function(j,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(I,h,l){this.level=I,this.key=h,this.value=l,this.forward=[]}}const s=void 0;class A{constructor(I,h=2**16){this.comparator=I,this[P]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(h)|0),this._header=new L(this._maxLevel,s,s)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,s,s)}has(I){return!!A._search(this,I,this.comparator)}get(I){return A._search(this,I,this.comparator)?.value}set(I,h){return A._insert(this,I,h,this.comparator)&&(this._size+=1),this}delete(I){const h=A._delete(this,I,this.comparator);return h&&(this._size-=1),h}forEach(I,h){let l=this._header.forward[0];for(;l;)I.call(h,l.value,l.key,this),l=l.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",h=this._header.forward[0];for(;h;)I+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return I}static _search(I,h,l){let m=I._header;for(let f=I._level-1;f>=0;f--)for(;m.forward[f]&&l(m.forward[f].key,h)<0;)m=m.forward[f];if(m=m.forward[0],m&&l(m.key,h)===0)return m}static _insert(I,h,l,m){const f=[];let S=I._header;for(let d=I._level-1;d>=0;d--){for(;S.forward[d]&&m(S.forward[d].key,h)<0;)S=S.forward[d];f[d]=S}if(S=S.forward[0],S&&m(S.key,h)===0)return S.value=l,!1;{const d=A._randomLevel(I);if(d>I._level){for(let y=I._level;y<d;y++)f[y]=I._header;I._level=d}S=new L(d,h,l);for(let y=0;y<d;y++)S.forward[y]=f[y].forward[y],f[y].forward[y]=S;return!0}}static _randomLevel(I,h=.5){let l=1;for(;Math.random()<h&&l<I._maxLevel;)l+=1;return l}static _delete(I,h,l){const m=[];let f=I._header;for(let S=I._level-1;S>=0;S--){for(;f.forward[S]&&l(f.forward[S].key,h)<0;)f=f.forward[S];m[S]=f}if(f=f.forward[0],!f||l(f.key,h)!==0)return!1;for(let S=0;S<I._level&&m[S].forward[S]===f;S++)m[S].forward[S]=f.forward[S];for(;I._level>0&&I._header.forward[I._level-1]===s;)I._level-=1;return!0}}e.SkipList=A}),define(ee[85],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(A){return new L(A)}constructor(A){this._now=P&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=L}),define(ee[4],te([0,1,13,49,2,101,85]),function(j,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,h=!1;var l;(function(D){D.None=()=>s.Disposable.None;function k(z){if(h){const{onDidAddListener:$}=z,K=y.create();let re=0;z.onDidAddListener=()=>{++re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),K.print()),$?.()}}}function C(z,$){return le(z,()=>{},0,void 0,!0,void 0,$)}D.defer=C;function _(z){return($,K=null,re)=>{let ce=!1,ge;return ge=z(ke=>{if(!ce)return ge?ge.dispose():ce=!0,$.call(K,ke)},null,re),ce&&ge.dispose(),ge}}D.once=_;function T(z,$,K){return ue((re,ce=null,ge)=>z(ke=>re.call(ce,$(ke)),null,ge),K)}D.map=T;function U(z,$,K){return ue((re,ce=null,ge)=>z(ke=>{$(ke),re.call(ce,ke)},null,ge),K)}D.forEach=U;function q(z,$,K){return ue((re,ce=null,ge)=>z(ke=>$(ke)&&re.call(ce,ke),null,ge),K)}D.filter=q;function se(z){return z}D.signal=se;function ie(...z){return($,K=null,re)=>(0,s.combinedDisposable)(...z.map(ce=>ce(ge=>$.call(K,ge),null,re)))}D.any=ie;function ne(z,$,K,re){let ce=K;return T(z,ge=>(ce=$(ce,ge),ce),re)}D.reduce=ne;function ue(z,$){let K;const re={onWillAddFirstListener(){K=z(ce.fire,ce)},onDidRemoveLastListener(){K?.dispose()}};$||k(re);const ce=new b(re);return $?.add(ce),ce.event}function le(z,$,K=100,re=!1,ce=!1,ge,ke){let Re,Le,Oe,ye=0,we;const Ee={leakWarningThreshold:ge,onWillAddFirstListener(){Re=z(de=>{ye++,Le=$(Le,de),re&&!Oe&&(Z.fire(Le),Le=void 0),we=()=>{const fe=Le;Le=void 0,Oe=void 0,(!re||ye>1)&&Z.fire(fe),ye=0},typeof K=="number"?(clearTimeout(Oe),Oe=setTimeout(we,K)):Oe===void 0&&(Oe=0,queueMicrotask(we))})},onWillRemoveListener(){ce&&ye>0&&we?.()},onDidRemoveLastListener(){we=void 0,Re.dispose()}};ke||k(Ee);const Z=new b(Ee);return ke?.add(Z),Z.event}D.debounce=le;function G(z,$=0,K){return D.debounce(z,(re,ce)=>re?(re.push(ce),re):[ce],$,void 0,!0,void 0,K)}D.accumulate=G;function Q(z,$=(re,ce)=>re===ce,K){let re=!0,ce;return q(z,ge=>{const ke=re||!$(ge,ce);return re=!1,ce=ge,ke},K)}D.latch=Q;function F(z,$,K){return[D.filter(z,$,K),D.filter(z,re=>!$(re),K)]}D.split=F;function N(z,$=!1,K=[]){let re=K.slice(),ce=z(Re=>{re?re.push(Re):ke.fire(Re)});const ge=()=>{re?.forEach(Re=>ke.fire(Re)),re=null},ke=new b({onWillAddFirstListener(){ce||(ce=z(Re=>ke.fire(Re)))},onDidAddFirstListener(){re&&($?setTimeout(ge):ge())},onDidRemoveLastListener(){ce&&ce.dispose(),ce=null}});return ke.event}D.buffer=N;class B{constructor($){this.event=$,this.disposables=new s.DisposableStore}map($){return new B(T(this.event,$,this.disposables))}forEach($){return new B(U(this.event,$,this.disposables))}filter($){return new B(q(this.event,$,this.disposables))}reduce($,K){return new B(ne(this.event,$,K,this.disposables))}latch(){return new B(Q(this.event,void 0,this.disposables))}debounce($,K=100,re=!1,ce=!1,ge){return new B(le(this.event,$,K,re,ce,ge,this.disposables))}on($,K,re){return this.event($,K,re)}once($,K,re){return _(this.event)($,K,re)}dispose(){this.disposables.dispose()}}function V(z){return new B(z)}D.chain=V;function Y(z,$,K=re=>re){const re=(...Re)=>ke.fire(K(...Re)),ce=()=>z.on($,re),ge=()=>z.removeListener($,re),ke=new b({onWillAddFirstListener:ce,onDidRemoveLastListener:ge});return ke.event}D.fromNodeEventEmitter=Y;function ae(z,$,K=re=>re){const re=(...Re)=>ke.fire(K(...Re)),ce=()=>z.addEventListener($,re),ge=()=>z.removeEventListener($,re),ke=new b({onWillAddFirstListener:ce,onDidRemoveLastListener:ge});return ke.event}D.fromDOMEventEmitter=ae;function oe(z){return new Promise($=>_(z)($))}D.toPromise=oe;function O(z,$){return $(void 0),z(K=>$(K))}D.runAndSubscribe=O;function M(z,$){let K=null;function re(ge){K?.dispose(),K=new s.DisposableStore,$(ge,K)}re(void 0);const ce=z(ge=>re(ge));return(0,s.toDisposable)(()=>{ce.dispose(),K?.dispose()})}D.runAndSubscribeWithStore=M;class W{constructor($,K){this._observable=$,this._counter=0,this._hasChanged=!1;const re={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};K||k(re),this.emitter=new b(re),K&&K.add(this.emitter)}beginUpdate($){this._counter++}handlePossibleChange($){}handleChange($,K){this._hasChanged=!0}endUpdate($){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function H(z,$){return new W(z,$).emitter.event}D.fromObservable=H;function x(z){return $=>{let K=0,re=!1;const ce={beginUpdate(){K++},endUpdate(){K--,K===0&&(z.reportChanges(),re&&(re=!1,$()))},handlePossibleChange(){},handleChange(){re=!0}};return z.addObserver(ce),{dispose(){z.removeObserver(ce)}}}}D.fromObservableLight=x})(l||(e.Event=l={}));class m{constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${m._idPool++}`,m.all.add(this)}start(k){this._stopWatch=new R.StopWatch,this.listenerCount=k}stop(){if(this._stopWatch){const k=this._stopWatch.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=m,m.all=new Set,m._idPool=0;let f=-1;function S(D){const k=f;return f=D,{dispose(){f=k}}}e.setGlobalLeakWarningThreshold=S;class d{constructor(k,C=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=C,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(k,C){const _=this.threshold;if(_<=0||C<_)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(k.value)||0;if(this._stacks.set(k.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=_*.5;let U,q=0;for(const[se,ie]of this._stacks)(!U||q<ie)&&(U=se,q=ie);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${q}):`),console.warn(U)}return()=>{const U=this._stacks.get(k.value)||0;this._stacks.set(k.value,U-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class o{constructor(k){this.value=k,this.id=v++}}const g=2,a=(D,k)=>{if(D instanceof o)k(D);else for(let C=0;C<D.length;C++){const _=D[C];_&&k(_)}};class b{constructor(k){this._size=0,this._options=k,this._leakageMon=f>0||this._options?.leakWarningThreshold?new d(this._options?.leakWarningThreshold??f):void 0,this._perfMon=this._options?._profName?new m(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(I){const k=this._listeners;queueMicrotask(()=>{a(k,C=>C.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(k,C,_)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.Disposable.None;if(this._disposed)return s.Disposable.None;C&&(k=k.bind(C));const T=new o(k);let U,q;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(T.stack=y.create(),U=this._leakageMon.check(T.stack,this._size+1)),I&&(T.stack=q??y.create()),this._listeners?this._listeners instanceof o?(this._deliveryQueue??=new w,this._listeners=[this._listeners,T]):this._listeners.push(T):(this._options?.onWillAddFirstListener?.(this),this._listeners=T,this._options?.onDidAddFirstListener?.(this)),this._size++;const se=(0,s.toDisposable)(()=>{U?.(),this._removeListener(T)});return _ instanceof s.DisposableStore?_.add(se):Array.isArray(_)&&_.push(se),se},this._event}_removeListener(k){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const C=this._listeners,_=C.indexOf(k);if(_===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,C[_]=void 0;const T=this._deliveryQueue.current===this;if(this._size*g<=C.length){let U=0;for(let q=0;q<C.length;q++)C[q]?C[U++]=C[q]:T&&(this._deliveryQueue.end--,U<this._deliveryQueue.i&&this._deliveryQueue.i--);C.length=U}}_deliver(k,C){if(!k)return;const _=this._options?.onListenerError||P.onUnexpectedError;if(!_){k.value(C);return}try{k.value(C)}catch(T){_(T)}}_deliverQueue(k){const C=k.current._listeners;for(;k.i<k.end;)this._deliver(C[k.i++],k.value);k.reset()}fire(k){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof o)this._deliver(this._listeners,k);else{const C=this._deliveryQueue;C.enqueue(this,k,this._listeners.length),this._deliverQueue(C)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=b;const E=()=>new w;e.createEventDeliveryQueue=E;class w{constructor(){this.i=-1,this.end=0}enqueue(k,C,_){this.i=0,this.end=_,this.current=k,this.value=C}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends b{async fireAsync(k,C,_){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList),a(this._listeners,T=>this._asyncDeliveryQueue.push([T.value,k]));this._asyncDeliveryQueue.size>0&&!C.isCancellationRequested;){const[T,U]=this._asyncDeliveryQueue.shift(),q=[],se={...U,token:C,waitUntil:ie=>{if(Object.isFrozen(q))throw new Error("waitUntil can NOT be called asynchronous");_&&(ie=_(ie,T)),q.push(ie)}};try{T(se)}catch(ie){(0,P.onUnexpectedError)(ie);continue}Object.freeze(q),await Promise.allSettled(q).then(ie=>{for(const ne of ie)ne.status==="rejected"&&(0,P.onUnexpectedError)(ne.reason)})}}}e.AsyncEmitter=t;class u extends b{get isPaused(){return this._isPaused!==0}constructor(k){super(k),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=k?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const k=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(k))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(k){this._size&&(this._isPaused!==0?this._eventQueue.push(k):super.fire(k))}}e.PauseableEmitter=u;class r extends u{constructor(k){super(k),this._delay=k.delay??100}fire(k){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(k)}}e.DebounceEmitter=r;class i extends b{constructor(k){super(k),this._queuedEvents=[],this._mergeFn=k?.merge}fire(k){this.hasListeners()&&(this._queuedEvents.push(k),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(C=>super.fire(C)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=i;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(k){const C={event:k,listener:null};this.events.push(C),this.hasListeners&&this.hook(C);const _=()=>{this.hasListeners&&this.unhook(C);const T=this.events.indexOf(C);this.events.splice(T,1)};return(0,s.toDisposable)((0,L.once)(_))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(k=>this.hook(k))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(k=>this.unhook(k))}hook(k){k.listener=k.event(C=>this.emitter.fire(C))}unhook(k){k.listener&&k.listener.dispose(),k.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class c{constructor(){this.buffers=[]}wrapEvent(k){return(C,_,T)=>k(U=>{const q=this.buffers[this.buffers.length-1];q?q.push(()=>C.call(_,U)):C.call(_,U)},void 0,T)}bufferEvents(k){const C=[];this.buffers.push(C);const _=k();return this.buffers.pop(),C.forEach(T=>T()),_}}e.EventBufferer=c;class p{constructor(){this.listening=!1,this.inputEvent=l.None,this.inputEventListener=s.Disposable.None,this.emitter=new b({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(k){this.inputEvent=k,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=k(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p}),define(ee[21],te([0,1,4]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(I,h){const l=setTimeout(I.bind(h),0);return{dispose(){clearTimeout(l)}}});var s;(function(I){function h(l){return l===I.None||l===I.Cancelled||l instanceof A?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}I.isCancellationToken=h,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(s||(e.CancellationToken=s={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new P.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=s.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=s.None}}e.CancellationTokenSource=R}),define(ee[139],te([0,1,21]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new P.CancellationTokenSource,h=this.task(I.token);return this.result={promise:h,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=L;class s{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const h=JSON.stringify(I);return this.lastArgKey!==h&&(this.lastArgKey=h,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=s;class A{get cachedValues(){return this._map}constructor(I){this.fn=I,this._map=new Map}get(I){if(this._map.has(I))return this._map.get(I);const h=this.fn(I);return this._map.set(I,h),h}}e.CachedFunction=A}),define(ee[61],te([0,1,13,2]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function s(E){const w=E;return w?typeof w.read=="function":!1}e.isReadable=s;function A(E){const w=E;return w?[w.on,w.pause,w.resume,w.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function R(E){const w=E;return w?A(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=R;function I(E,w){return new h(E,w)}e.newWriteableStream=I;class h{constructor(w,t){this.reducer=w,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w<"u"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(t=>t(w))}emitError(w){this.listeners.error.length===0?(0,P.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(t=>t(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,t){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(w,t){if(this.state.destroyed)return;let u;switch(w){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const r=u.indexOf(t);r>=0&&u.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(E,w){const t=[];let u;for(;(u=E.read())!==null;)t.push(u);return w(t)}e.consumeReadable=l;function m(E,w,t){const u=[];let r;for(;(r=E.read())!==null&&u.length<t;)u.push(r);return r===null&&u.length>0?w(u):{read:()=>{if(u.length>0)return u.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return E.read()}}}e.peekReadable=m;function f(E,w){return new Promise((t,u)=>{const r=[];S(E,{onData:i=>{w&&r.push(i)},onError:i=>{w?u(i):t(void 0)},onEnd:()=>{t(w?w(r):void 0)}})})}e.consumeStream=f;function S(E,w){let t=!1;return E.on("error",u=>{t||w.onError(u)}),E.on("end",()=>{t||w.onEnd()}),E.on("data",u=>{t||w.onData(u)}),(0,L.toDisposable)(()=>t=!0)}e.listenStream=S;function d(E,w){return new Promise((t,u)=>{const r=new L.DisposableStore,i=[],n=D=>{if(i.push(D),i.length>w)return r.dispose(),E.pause(),t({stream:E,buffer:i,ended:!1})},c=D=>u(D),p=()=>t({stream:E,buffer:i,ended:!0});r.add((0,L.toDisposable)(()=>E.removeListener("error",c))),E.on("error",c),r.add((0,L.toDisposable)(()=>E.removeListener("end",p))),E.on("end",p),r.add((0,L.toDisposable)(()=>E.removeListener("data",n))),E.on("data",n)})}e.peekStream=d;function y(E,w){const t=I(w);return t.end(E),t}e.toStream=y;function v(){const E=I(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=v;function o(E){let w=!1;return{read:()=>w?null:(w=!0,E)}}e.toReadable=o;function g(E,w,t){const u=I(t);return S(E,{onData:r=>u.write(w.data(r)),onError:r=>u.error(w.error?w.error(r):r),onEnd:()=>u.end()}),u}e.transform=g;function a(E,w,t){let u=!1;return{read:()=>{const r=w.read();return u?r:(u=!0,r!==null?t([E,r]):E)}}}e.prefixedReadable=a;function b(E,w,t){let u=!1;const r=I(t);return S(w,{onData:i=>u?r.write(i):(u=!0,r.write(t([E,i]))),onError:i=>r.error(i),onEnd:()=>{u||(u=!0,r.write(E)),r.end()}}),r}e.prefixedStream=b}),define(ee[17],te([0,1,83,61]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const s=typeof Buffer<"u",A=new P.Lazy(()=>new Uint8Array(256));let R,I;class h{static alloc(C){return s?new h(Buffer.allocUnsafe(C)):new h(new Uint8Array(C))}static wrap(C){return s&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new h(C)}static fromString(C,_){return!(_?.dontUseNodeBuffer||!1)&&s?new h(Buffer.from(C)):(R||(R=new TextEncoder),new h(R.encode(C)))}static fromByteArray(C){const _=h.alloc(C.length);for(let T=0,U=C.length;T<U;T++)_.buffer[T]=C[T];return _}static concat(C,_){if(typeof _>"u"){_=0;for(let q=0,se=C.length;q<se;q++)_+=C[q].byteLength}const T=h.alloc(_);let U=0;for(let q=0,se=C.length;q<se;q++){const ie=C[q];T.set(ie,U),U+=ie.byteLength}return T}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=h.alloc(this.byteLength);return C.set(this),C}toString(){return s?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(C,_){return new h(this.buffer.subarray(C,_))}set(C,_){if(C instanceof h)this.buffer.set(C.buffer,_);else if(C instanceof Uint8Array)this.buffer.set(C,_);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),_);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),_);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return f(this.buffer,C)}writeUInt32BE(C,_){S(this.buffer,C,_)}readUInt32LE(C){return d(this.buffer,C)}writeUInt32LE(C,_){y(this.buffer,C,_)}readUInt8(C){return v(this.buffer,C)}writeUInt8(C,_){o(this.buffer,C,_)}indexOf(C){const _=C instanceof h?C.buffer:C,T=_.byteLength,U=this.buffer,q=U.byteLength;if(T===0)return 0;if(T===1)return U.indexOf(_[0]);if(T>q)return-1;const se=A.value;se.fill(_.length);for(let le=0;le<_.length;le++)se[_[le]]=_.length-le-1;let ie=_.length-1,ne=ie,ue=-1;for(;ie<q;)if(U[ie]===_[ne]){if(ne===0){ue=ie;break}ie--,ne--}else ie+=Math.max(_.length-ne,se[U[ie]]),ne=_.length-1;return ue}}e.VSBuffer=h;function l(k,C){return k[C+0]<<0>>>0|k[C+1]<<8>>>0}e.readUInt16LE=l;function m(k,C,_){k[_+0]=C&255,C=C>>>8,k[_+1]=C&255}e.writeUInt16LE=m;function f(k,C){return k[C]*2**24+k[C+1]*2**16+k[C+2]*2**8+k[C+3]}e.readUInt32BE=f;function S(k,C,_){k[_+3]=C,C=C>>>8,k[_+2]=C,C=C>>>8,k[_+1]=C,C=C>>>8,k[_]=C}e.writeUInt32BE=S;function d(k,C){return k[C+0]<<0>>>0|k[C+1]<<8>>>0|k[C+2]<<16>>>0|k[C+3]<<24>>>0}e.readUInt32LE=d;function y(k,C,_){k[_+0]=C&255,C=C>>>8,k[_+1]=C&255,C=C>>>8,k[_+2]=C&255,C=C>>>8,k[_+3]=C&255}e.writeUInt32LE=y;function v(k,C){return k[C]}e.readUInt8=v;function o(k,C,_){k[_]=C}e.writeUInt8=o;function g(k){return L.consumeReadable(k,C=>h.concat(C))}e.readableToBuffer=g;function a(k){return L.toReadable(k)}e.bufferToReadable=a;function b(k){return L.consumeStream(k,C=>h.concat(C))}e.streamToBuffer=b;async function E(k){return k.ended?h.concat(k.buffer):h.concat([...k.buffer,await b(k.stream)])}e.bufferedStreamToBuffer=E;function w(k){return L.toStream(k,C=>h.concat(C))}e.bufferToStream=w;function t(k){return L.transform(k,{data:C=>typeof C=="string"?h.fromString(C):h.wrap(C)},C=>h.concat(C))}e.streamToBufferReadableStream=t;function u(k){return L.newWriteableStream(C=>h.concat(C),k)}e.newWriteableBufferStream=u;function r(k,C){return L.prefixedReadable(k,C,_=>h.concat(_))}e.prefixedBufferReadable=r;function i(k,C){return L.prefixedStream(k,C,_=>h.concat(_))}e.prefixedBufferStream=i;function n(k){let C=0,_=0,T=0;const U=new Uint8Array(Math.floor(k.length/4*3)),q=ie=>{switch(_){case 3:U[T++]=C|ie,_=0;break;case 2:U[T++]=C|ie>>>2,C=ie<<6,_=3;break;case 1:U[T++]=C|ie>>>4,C=ie<<4,_=2;break;default:C=ie<<2,_=1}};for(let ie=0;ie<k.length;ie++){const ne=k.charCodeAt(ie);if(ne>=65&&ne<=90)q(ne-65);else if(ne>=97&&ne<=122)q(ne-97+26);else if(ne>=48&&ne<=57)q(ne-48+52);else if(ne===43||ne===45)q(62);else if(ne===47||ne===95)q(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${k[ie]}`)}}const se=T;for(;_>0;)q(0);return h.wrap(U).slice(0,se)}e.decodeBase64=n;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:k},C=!0,_=!1){const T=_?p:c;let U="";const q=k.byteLength%3;let se=0;for(;se<k.byteLength-q;se+=3){const ie=k[se+0],ne=k[se+1],ue=k[se+2];U+=T[ie>>>2],U+=T[(ie<<4|ne>>>4)&63],U+=T[(ne<<2|ue>>>6)&63],U+=T[ue&63]}if(q===1){const ie=k[se+0];U+=T[ie>>>2],U+=T[ie<<4&63],C&&(U+="==")}else if(q===2){const ie=k[se+0],ne=k[se+1];U+=T[ie>>>2],U+=T[(ie<<4|ne>>>4)&63],U+=T[ne<<2&63],C&&(U+="=")}return U}e.encodeBase64=D}),define(ee[25],te([0,1,139,83]),function(j,e,P,L){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=A;const R=/{(\d+)}/g;function I(X,...he){return he.length===0?X:X.replace(R,function(me,pe){const be=parseInt(pe,10);return isNaN(be)||be<0||be>=he.length?me:he[be]})}e.format=I;const h=/{([^}]+)}/g;function l(X,he){return X.replace(h,(me,pe)=>he[pe]??me)}e.format2=l;function m(X){return X.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=m;function f(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function S(X,he){let me=0;const pe=he.charCodeAt(0);for(let be=X.length-1;be>=0;be--)X.charCodeAt(be)===pe&&me++;return me}e.count=S;function d(X,he,me="\u2026"){return X.length<=he?X:`${X.substr(0,he)}${me}`}e.truncate=d;function y(X,he=" "){const me=v(X,he);return o(me,he)}e.trim=y;function v(X,he){if(!X||!he)return X;const me=he.length;if(me===0||X.length===0)return X;let pe=0;for(;X.indexOf(he,pe)===pe;)pe=pe+me;return X.substring(pe)}e.ltrim=v;function o(X,he){if(!X||!he)return X;const me=he.length,pe=X.length;if(me===0||pe===0)return X;let be=pe,Ae=-1;for(;Ae=X.lastIndexOf(he,be-1),!(Ae===-1||Ae+me!==be);){if(Ae===0)return"";be=Ae}return X.substring(0,be)}e.rtrim=o;function g(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function a(X){return X.replace(/\*/g,"")}e.stripWildcards=a;function b(X,he,me={}){if(!X)throw new Error("Cannot create regex from empty string");he||(X=f(X)),me.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let pe="";return me.global&&(pe+="g"),me.matchCase||(pe+="i"),me.multiline&&(pe+="m"),me.unicode&&(pe+="u"),new RegExp(X,pe)}e.createRegExp=b;function E(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function w(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=w;function t(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=t;function u(X){return X.split(/\r\n|\r|\n/)}e.splitLines=u;function r(X){for(let he=0,me=X.length;he<me;he++){const pe=X.charCodeAt(he);if(pe!==32&&pe!==9)return he}return-1}e.firstNonWhitespaceIndex=r;function i(X,he=0,me=X.length){for(let pe=he;pe<me;pe++){const be=X.charCodeAt(pe);if(be!==32&&be!==9)return X.substring(he,pe)}return X.substring(he,me)}e.getLeadingWhitespace=i;function n(X,he=X.length-1){for(let me=he;me>=0;me--){const pe=X.charCodeAt(me);if(pe!==32&&pe!==9)return me}return-1}e.lastNonWhitespaceIndex=n;function c(X,he,me){const pe=[];let be=0;for(const Ae of X.matchAll(he)){if(pe.push(X.slice(be,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");be=Ae.index+Ae[0].length,pe.push(me(Ae[0],...Ae.slice(1),Ae.index,X,Ae.groups))}return pe.push(X.slice(be)),Promise.all(pe).then(Ae=>Ae.join(""))}e.replaceAsync=c;function p(X,he){return X<he?-1:X>he?1:0}e.compare=p;function D(X,he,me=0,pe=X.length,be=0,Ae=he.length){for(;me<pe&&be<Ae;me++,be++){const Je=X.charCodeAt(me),Ve=he.charCodeAt(be);if(Je<Ve)return-1;if(Je>Ve)return 1}const Ue=pe-me,Ge=Ae-be;return Ue<Ge?-1:Ue>Ge?1:0}e.compareSubstring=D;function k(X,he){return C(X,he,0,X.length,0,he.length)}e.compareIgnoreCase=k;function C(X,he,me=0,pe=X.length,be=0,Ae=he.length){for(;me<pe&&be<Ae;me++,be++){let Je=X.charCodeAt(me),Ve=he.charCodeAt(be);if(Je===Ve)continue;if(Je>=128||Ve>=128)return D(X.toLowerCase(),he.toLowerCase(),me,pe,be,Ae);T(Je)&&(Je-=32),T(Ve)&&(Ve-=32);const Ye=Je-Ve;if(Ye!==0)return Ye}const Ue=pe-me,Ge=Ae-be;return Ue<Ge?-1:Ue>Ge?1:0}e.compareSubstringIgnoreCase=C;function _(X){return X>=48&&X<=57}e.isAsciiDigit=_;function T(X){return X>=97&&X<=122}e.isLowerAsciiLetter=T;function U(X){return X>=65&&X<=90}e.isUpperAsciiLetter=U;function q(X,he){return X.length===he.length&&C(X,he)===0}e.equalsIgnoreCase=q;function se(X,he){const me=he.length;return he.length>X.length?!1:C(X,he,0,me)===0}e.startsWithIgnoreCase=se;function ie(X,he){const me=Math.min(X.length,he.length);let pe;for(pe=0;pe<me;pe++)if(X.charCodeAt(pe)!==he.charCodeAt(pe))return pe;return me}e.commonPrefixLength=ie;function ne(X,he){const me=Math.min(X.length,he.length);let pe;const be=X.length-1,Ae=he.length-1;for(pe=0;pe<me;pe++)if(X.charCodeAt(be-pe)!==he.charCodeAt(Ae-pe))return pe;return me}e.commonSuffixLength=ne;function ue(X){return 55296<=X&&X<=56319}e.isHighSurrogate=ue;function le(X){return 56320<=X&&X<=57343}e.isLowSurrogate=le;function G(X,he){return(X-55296<<10)+(he-56320)+65536}e.computeCodePoint=G;function Q(X,he,me){const pe=X.charCodeAt(me);if(ue(pe)&&me+1<he){const be=X.charCodeAt(me+1);if(le(be))return G(pe,be)}return pe}e.getNextCodePoint=Q;function F(X,he){const me=X.charCodeAt(he-1);if(le(me)&&he>1){const pe=X.charCodeAt(he-2);if(ue(pe))return G(pe,me)}return me}class N{get offset(){return this._offset}constructor(he,me=0){this._str=he,this._len=he.length,this._offset=me}setOffset(he){this._offset=he}prevCodePoint(){const he=F(this._str,this._offset);return this._offset-=he>=65536?2:1,he}nextCodePoint(){const he=Q(this._str,this._len,this._offset);return this._offset+=he>=65536?2:1,he}eol(){return this._offset>=this._len}}e.CodePointIterator=N;class B{get offset(){return this._iterator.offset}constructor(he,me=0){this._iterator=new N(he,me)}nextGraphemeLength(){const he=De.getInstance(),me=this._iterator,pe=me.offset;let be=he.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ae=me.offset,Ue=he.getGraphemeBreakType(me.nextCodePoint());if(fe(be,Ue)){me.setOffset(Ae);break}be=Ue}return me.offset-pe}prevGraphemeLength(){const he=De.getInstance(),me=this._iterator,pe=me.offset;let be=he.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ae=me.offset,Ue=he.getGraphemeBreakType(me.prevCodePoint());if(fe(Ue,be)){me.setOffset(Ae);break}be=Ue}return pe-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=B;function V(X,he){return new B(X,he).nextGraphemeLength()}e.nextCharLength=V;function Y(X,he){return new B(X,he).prevGraphemeLength()}e.prevCharLength=Y;function ae(X,he){he>0&&le(X.charCodeAt(he))&&he--;const me=he+V(X,he);return[me-Y(X,me),me]}e.getCharContainingOffset=ae;function oe(X){const he=new B(X);let me=0;for(;!he.eol();)me++,he.nextGraphemeLength();return me}e.charCount=oe;let O;function M(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(X){return O||(O=M()),O.test(X)}e.containsRTL=W;const H=/^[\t\n\r\x20-\x7E]*$/;function x(X){return H.test(X)}e.isBasicASCII=x,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=z;function $(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=$;function K(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=K;function re(X,he){if(X.length<he)return X;const me=/\b/g;let pe=0;for(;me.test(X)&&!(X.length-me.lastIndex<he);)pe=me.lastIndex,me.lastIndex+=1;return X.substring(pe).replace(/^\s/,"")}e.lcut=re;const ce=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ge=/\x1b\].*?\x07/g;function ke(X){return X&&(X=X.replace(ce,"").replace(ge,"")),X}e.removeAnsiEscapeCodes=ke,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function Le(X){return Re(X)?X.substr(1):X}e.stripUTF8BOM=Le;function Oe(X,he){if(!X||!he||X.length<he.length)return!1;const me=he.length,pe=X.toLowerCase();let be=0,Ae=-1;for(;be<me;){const Ue=pe.indexOf(he[be],Ae+1);if(Ue<0)return!1;Ae=Ue,be++}return!0}e.fuzzyContains=Oe;function ye(X,he=!1){return X?(he&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=ye;function we(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=we;function Ee(X,he=1){if(he===0)return"";let me=-1;do me=X.indexOf(`
`,me+1),he--;while(he>0&&me>=0);return me===-1?X:(X[me-1]==="\r"&&me--,X.substr(0,me))}e.getNLines=Ee;function Z(X){return X=X%(2*26),X<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}e.singleLetterHash=Z;function de(X){return De.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=de;function fe(X,he){return X===0?he!==5&&he!==7:X===2&&he===3?!1:X===4||X===2||X===3||he===4||he===2||he===3?!0:!(X===8&&(he===8||he===9||he===11||he===12)||(X===11||X===9)&&(he===9||he===10)||(X===12||X===10)&&he===10||he===5||he===13||he===7||X===1||X===13&&he===14||X===6&&he===6)}var Ce;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(Ce||(e.GraphemeBreakType=Ce={}));class De{static getInstance(){return De._INSTANCE||(De._INSTANCE=new De),De._INSTANCE}constructor(){this._data=Te()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const me=this._data,pe=me.length/3;let be=1;for(;be<=pe;)if(he<me[3*be])be=2*be;else if(he>me[3*be+1])be=2*be+1;else return me[3*be+2];return 0}}De._INSTANCE=null;function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(X,he){if(X===0)return 0;const me=He(X,he);if(me!==void 0)return me;const pe=new N(he,X);return pe.prevCodePoint(),pe.offset}e.getLeftDeleteOffset=We;function He(X,he){const me=new N(he,X);let pe=me.prevCodePoint();for(;$e(pe)||pe===65039||pe===8419;){if(me.offset===0)return;pe=me.prevCodePoint()}if(!K(pe))return;let be=me.offset;return be>0&&me.prevCodePoint()===8205&&(be=me.offset),be}function $e(X){return 127995<=X&&X<=127999}var ze;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class qe{static getInstance(he){return qe.cache.get(Array.from(he))}static getLocales(){return qe._locales.value}constructor(he){this.confusableDictionary=he}isAmbiguous(he){return this.confusableDictionary.has(he)}getPrimaryConfusable(he){return this.confusableDictionary.get(he)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=qe,s=qe,qe.ambiguousCharacterData=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),qe.cache=new P.LRUCachedFunction(X=>{function he(Ve){const Ye=new Map;for(let tt=0;tt<Ve.length;tt+=2)Ye.set(Ve[tt],Ve[tt+1]);return Ye}function me(Ve,Ye){const tt=new Map(Ve);for(const[ot,ct]of Ye)tt.set(ot,ct);return tt}function pe(Ve,Ye){if(!Ve)return Ye;const tt=new Map;for(const[ot,ct]of Ve)Ye.has(ot)&&tt.set(ot,ct);return tt}const be=s.ambiguousCharacterData.value;let Ae=X.filter(Ve=>!Ve.startsWith("_")&&Ve in be);Ae.length===0&&(Ae=["_default"]);let Ue;for(const Ve of Ae){const Ye=he(be[Ve]);Ue=pe(Ue,Ye)}const Ge=he(be._common),Je=me(Ge,Ue);return new qe(Je)}),qe._locales=new L.Lazy(()=>Object.keys(qe.ambiguousCharacterData.value).filter(X=>!X.startsWith("_")));class Be{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Be.getRawData())),this._data}static isInvisibleCharacter(he){return Be.getData().has(he)}static get codePoints(){return Be.getData()}}e.InvisibleCharacters=Be,Be._data=void 0}),define(ee[56],te([0,1,25]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(g){return s(g,0)}e.hash=L;function s(g,a){switch(typeof g){case"object":return g===null?A(349,a):Array.isArray(g)?h(g,a):l(g,a);case"string":return I(g,a);case"boolean":return R(g,a);case"number":return A(g,a);case"undefined":return A(937,a);default:return A(617,a)}}e.doHash=s;function A(g,a){return(a<<5)-a+g|0}e.numberHash=A;function R(g,a){return A(g?433:863,a)}function I(g,a){a=A(149417,a);for(let b=0,E=g.length;b<E;b++)a=A(g.charCodeAt(b),a);return a}e.stringHash=I;function h(g,a){return a=A(104579,a),g.reduce((b,E)=>s(E,b),a)}function l(g,a){return a=A(181387,a),Object.keys(g).sort().reduce((b,E)=>(b=I(E,b),s(g[E],b)),a)}class m{constructor(){this._value=0}get value(){return this._value}hash(a){return this._value=s(a,this._value),this._value}}e.Hasher=m;var f;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(f||(f={}));function S(g,a,b=32){const E=b-a,w=~((1<<E)-1);return(g<<a|(w&g)>>>E)>>>0}function d(g,a=0,b=g.byteLength,E=0){for(let w=0;w<b;w++)g[a+w]=E}function y(g,a,b="0"){for(;g.length<a;)g=b+g;return g}function v(g,a=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(b=>b.toString(16).padStart(2,"0")).join(""):y((g>>>0).toString(16),a/4)}e.toHexString=v;class o{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(a){const b=a.length;if(b===0)return;const E=this._buff;let w=this._buffLen,t=this._leftoverHighSurrogate,u,r;for(t!==0?(u=t,r=-1,t=0):(u=a.charCodeAt(0),r=0);;){let i=u;if(P.isHighSurrogate(u))if(r+1<b){const n=a.charCodeAt(r+1);P.isLowSurrogate(n)?(r++,i=P.computeCodePoint(u,n)):i=65533}else{t=u;break}else P.isLowSurrogate(u)&&(i=65533);if(w=this._push(E,w,i),r++,r<b)u=a.charCodeAt(r);else break}this._buffLen=w,this._leftoverHighSurrogate=t}_push(a,b,E){return E<128?a[b++]=E:E<2048?(a[b++]=192|(E&1984)>>>6,a[b++]=128|(E&63)>>>0):E<65536?(a[b++]=224|(E&61440)>>>12,a[b++]=128|(E&4032)>>>6,a[b++]=128|(E&63)>>>0):(a[b++]=240|(E&1835008)>>>18,a[b++]=128|(E&258048)>>>12,a[b++]=128|(E&4032)>>>6,a[b++]=128|(E&63)>>>0),b>=64&&(this._step(),b-=64,this._totalLen+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),b}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const a=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(a/4294967296),!1),this._buffDV.setUint32(60,a%4294967296,!1),this._step()}_step(){const a=o._bigBlock32,b=this._buffDV;for(let p=0;p<64;p+=4)a.setUint32(p,b.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)a.setUint32(p,S(a.getUint32(p-12,!1)^a.getUint32(p-32,!1)^a.getUint32(p-56,!1)^a.getUint32(p-64,!1),1),!1);let E=this._h0,w=this._h1,t=this._h2,u=this._h3,r=this._h4,i,n,c;for(let p=0;p<80;p++)p<20?(i=w&t|~w&u,n=1518500249):p<40?(i=w^t^u,n=1859775393):p<60?(i=w&t|w&u|t&u,n=2400959708):(i=w^t^u,n=3395469782),c=S(E,5)+i+r+n+a.getUint32(p*4,!1)&4294967295,r=u,u=t,t=S(w,30),w=E,E=c;this._h0=this._h0+E&4294967295,this._h1=this._h1+w&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=o,o._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ee[69],te([0,1,25]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(L||(L={})),function(s){const A="error",R="warning",I="warn",h="info",l="ignore";function m(S){return S?P.equalsIgnoreCase(A,S)?s.Error:P.equalsIgnoreCase(R,S)||P.equalsIgnoreCase(I,S)?s.Warning:P.equalsIgnoreCase(h,S)?s.Info:s.Ignore:s.Ignore}s.fromValue=m;function f(S){switch(S){case s.Error:return A;case s.Warning:return R;case s.Info:return h;default:return l}}s.toString=f}(L||(L={})),e.default=L}),define(ee[140],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ee[62],te([0,1,24,25]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class s{constructor(){this._value="",this._pos=0}reset(d){return this._value=d,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(d){const y=d.charCodeAt(0),v=this._value.charCodeAt(this._pos);return y-v}value(){return this._value[this._pos]}}e.StringIterator=s;class A{constructor(d=!0){this._caseSensitive=d}reset(d){return this._value=d,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let d=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(d)this._from++;else break;else d=!1;return this}cmp(d){return this._caseSensitive?(0,L.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class R{constructor(d=!0,y=!0){this._splitOnBackslash=d,this._caseSensitive=y}reset(d){this._from=0,this._to=0,this._value=d,this._valueLen=d.length;for(let y=d.length-1;y>=0;y--,this._valueLen--){const v=this._value.charCodeAt(y);if(!(v===47||this._splitOnBackslash&&v===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let d=!0;for(;this._to<this._valueLen;this._to++){const y=this._value.charCodeAt(this._to);if(y===47||this._splitOnBackslash&&y===92)if(d)this._from++;else break;else d=!1}return this}cmp(d){return this._caseSensitive?(0,L.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var I;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(I||(I={}));class h{constructor(d,y){this._ignorePathCasing=d,this._ignoreQueryAndFragment=y,this._states=[],this._stateIdx=0}reset(d){return this._value=d,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(d)),this._pathIterator.reset(d.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(d)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(d){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(d,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(d,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(d);if(this._states[this._stateIdx]===4)return(0,L.compare)(d,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(d,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(m||(m={}));class f{static forUris(d=()=>!1,y=()=>!1){return new f(new h(d,y))}static forPaths(d=!1){return new f(new R(void 0,!d))}static forStrings(){return new f(new s)}static forConfigKeys(){return new f(new A)}constructor(d){this._iter=d}clear(){this._root=void 0}fill(d,y){if(y){const v=y.slice(0);(0,P.shuffle)(v);for(const o of v)this.set(o,d)}else{const v=d.slice(0);(0,P.shuffle)(v);for(const o of v)this.set(o[0],o[1])}}set(d,y){const v=this._iter.reset(d);let o;this._root||(this._root=new l,this._root.segment=v.value());const g=[];for(o=this._root;;){const b=v.cmp(o.segment);if(b>0)o.left||(o.left=new l,o.left.segment=v.value()),g.push([-1,o]),o=o.left;else if(b<0)o.right||(o.right=new l,o.right.segment=v.value()),g.push([1,o]),o=o.right;else if(v.hasNext())v.next(),o.mid||(o.mid=new l,o.mid.segment=v.value()),g.push([0,o]),o=o.mid;else break}const a=o.value;o.value=y,o.key=d;for(let b=g.length-1;b>=0;b--){const E=g[b][1];E.updateHeight();const w=E.balanceFactor();if(w<-1||w>1){const t=g[b][0],u=g[b+1][0];if(t===1&&u===1)g[b][1]=E.rotateLeft();else if(t===-1&&u===-1)g[b][1]=E.rotateRight();else if(t===1&&u===-1)E.right=g[b+1][1]=g[b+1][1].rotateRight(),g[b][1]=E.rotateLeft();else if(t===-1&&u===1)E.left=g[b+1][1]=g[b+1][1].rotateLeft(),g[b][1]=E.rotateRight();else throw new Error;if(b>0)switch(g[b-1][0]){case-1:g[b-1][1].left=g[b][1];break;case 1:g[b-1][1].right=g[b][1];break;case 0:g[b-1][1].mid=g[b][1];break}else this._root=g[0][1]}}return a}get(d){return this._getNode(d)?.value}_getNode(d){const y=this._iter.reset(d);let v=this._root;for(;v;){const o=y.cmp(v.segment);if(o>0)v=v.left;else if(o<0)v=v.right;else if(y.hasNext())y.next(),v=v.mid;else break}return v}has(d){const y=this._getNode(d);return!(y?.value===void 0&&y?.mid===void 0)}delete(d){return this._delete(d,!1)}deleteSuperstr(d){return this._delete(d,!0)}_delete(d,y){const v=this._iter.reset(d),o=[];let g=this._root;for(;g;){const a=v.cmp(g.segment);if(a>0)o.push([-1,g]),g=g.left;else if(a<0)o.push([1,g]),g=g.right;else if(v.hasNext())v.next(),o.push([0,g]),g=g.mid;else break}if(g){if(y?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const a=this._min(g.right);if(a.key){const{key:b,value:E,segment:w}=a;this._delete(a.key,!1),g.key=b,g.value=E,g.segment=w}}else{const a=g.left??g.right;if(o.length>0){const[b,E]=o[o.length-1];switch(b){case-1:E.left=a;break;case 0:E.mid=a;break;case 1:E.right=a;break}}else this._root=a}for(let a=o.length-1;a>=0;a--){const b=o[a][1];b.updateHeight();const E=b.balanceFactor();if(E>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),o[a][1]=b.rotateLeft()):E<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),o[a][1]=b.rotateRight()),a>0)switch(o[a-1][0]){case-1:o[a-1][1].left=o[a][1];break;case 1:o[a-1][1].right=o[a][1];break;case 0:o[a-1][1].mid=o[a][1];break}else this._root=o[0][1]}}}_min(d){for(;d.left;)d=d.left;return d}findSubstr(d){const y=this._iter.reset(d);let v=this._root,o;for(;v;){const g=y.cmp(v.segment);if(g>0)v=v.left;else if(g<0)v=v.right;else if(y.hasNext())y.next(),o=v.value||o,v=v.mid;else break}return v&&v.value||o}findSuperstr(d){return this._findSuperstrOrElement(d,!1)}_findSuperstrOrElement(d,y){const v=this._iter.reset(d);let o=this._root;for(;o;){const g=v.cmp(o.segment);if(g>0)o=o.left;else if(g<0)o=o.right;else if(v.hasNext())v.next(),o=o.mid;else return o.mid?this._entries(o.mid):y?o.value:void 0}}hasElementOrSubtree(d){return this._findSuperstrOrElement(d,!0)!==void 0}forEach(d){for(const[y,v]of this)d(v,y)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(d){const y=[];return this._dfsEntries(d,y),y[Symbol.iterator]()}_dfsEntries(d,y){d&&(d.left&&this._dfsEntries(d.left,y),d.value&&y.push([d.key,d.value]),d.mid&&this._dfsEntries(d.mid,y),d.right&&this._dfsEntries(d.right,y))}_isBalanced(){const d=y=>{if(!y)return!0;const v=y.balanceFactor();return v<-1||v>1?!1:d(y.left)&&d(y.right)};return d(this._root)}}e.TernarySearchTree=f}),define(ee[11],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function P(u){return typeof u=="string"}e.isString=P;function L(u){return Array.isArray(u)&&u.every(r=>P(r))}e.isStringArray=L;function s(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=s;function A(u){const r=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof r}e.isTypedArray=A;function R(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=R;function I(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=I;function h(u){return u===!0||u===!1}e.isBoolean=h;function l(u){return typeof u>"u"}e.isUndefined=l;function m(u){return!f(u)}e.isDefined=m;function f(u){return l(u)||u===null}e.isUndefinedOrNull=f;function S(u,r){if(!u)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=S;function d(u){if(f(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=d;function y(...u){const r=[];for(let i=0;i<u.length;i++){const n=u[i];if(f(n))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);r.push(n)}return r}e.assertAllDefined=y;const v=Object.prototype.hasOwnProperty;function o(u){if(!s(u))return!1;for(const r in u)if(v.call(u,r))return!1;return!0}e.isEmptyObject=o;function g(u){return typeof u=="function"}e.isFunction=g;function a(...u){return u.length>0&&u.every(g)}e.areFunctions=a;function b(u,r){const i=Math.min(u.length,r.length);for(let n=0;n<i;n++)E(u[n],r[n])}e.validateConstraints=b;function E(u,r){if(P(r)){if(typeof u!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(g(r)){try{if(u instanceof r)return}catch{}if(!f(u)&&u.constructor===r||r.length===1&&r.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=E;function w(u){return u===null?void 0:u}e.withNullAsUndefined=w;function t(u){return typeof u>"u"?null:u}e.withUndefinedAsNull=t}),define(ee[70],te([0,1,11]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function s(I,h){if((0,P.isString)(h)){const l=L[h];if(l===void 0)throw new Error(`${I} references an unknown codicon: ${h}`);h=l}return L[I]=h,{id:I}}function A(){return L}e.getCodiconFontCharacters=A;function R(){return Object.values(e.Codicon)}e.getAllCodicons=R,e.Codicon={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package_:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(ee[37],te([0,1,11]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const a=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([b,E])=>{a[b]=E&&typeof E=="object"?L(E):E}),a}e.deepClone=L;function s(g){if(!g||typeof g!="object")return g;const a=[g];for(;a.length>0;){const b=a.shift();Object.freeze(b);for(const E in b)if(A.call(b,E)){const w=b[E];typeof w=="object"&&!Object.isFrozen(w)&&!(0,P.isTypedArray)(w)&&a.push(w)}}return g}e.deepFreeze=s;const A=Object.prototype.hasOwnProperty;function R(g,a){return I(g,a,new Set)}e.cloneAndChange=R;function I(g,a,b){if((0,P.isUndefinedOrNull)(g))return g;const E=a(g);if(typeof E<"u")return E;if(Array.isArray(g)){const w=[];for(const t of g)w.push(I(t,a,b));return w}if((0,P.isObject)(g)){if(b.has(g))throw new Error("Cannot clone recursive data-structure");b.add(g);const w={};for(const t in g)A.call(g,t)&&(w[t]=I(g[t],a,b));return b.delete(g),w}return g}function h(g,a,b=!0){return(0,P.isObject)(g)?((0,P.isObject)(a)&&Object.keys(a).forEach(E=>{E in g?b&&((0,P.isObject)(g[E])&&(0,P.isObject)(a[E])?h(g[E],a[E],b):g[E]=a[E]):g[E]=a[E]}),g):a}e.mixin=h;function l(g,a){if(g===a)return!0;if(g==null||a===null||a===void 0||typeof g!=typeof a||typeof g!="object"||Array.isArray(g)!==Array.isArray(a))return!1;let b,E;if(Array.isArray(g)){if(g.length!==a.length)return!1;for(b=0;b<g.length;b++)if(!l(g[b],a[b]))return!1}else{const w=[];for(E in g)w.push(E);w.sort();const t=[];for(E in a)t.push(E);if(t.sort(),!l(w,t))return!1;for(b=0;b<w.length;b++)if(!l(g[w[b]],a[w[b]]))return!1}return!0}e.equals=l;function m(g){const a=new Set;return JSON.stringify(g,(b,E)=>{if((0,P.isObject)(E)||Array.isArray(E)){if(a.has(E))return"[Circular]";a.add(E)}return E})}e.safeStringify=m;function f(g,a){const b=Object.create(null);return!g||!a||Object.keys(a).forEach(w=>{const t=g[w],u=a[w];l(t,u)||(b[w]=u)}),b}e.distinct=f;function S(g,a){const b=a.toLowerCase(),E=Object.keys(g).find(w=>w.toLowerCase()===b);return E?g[E]:g[a]}e.getCaseInsensitive=S;function d(g,a){const b=Object.create(null);for(const[E,w]of Object.entries(g))a(E,w)&&(b[E]=w);return b}e.filter=d;function y(g){let a=[],b=Object.getPrototypeOf(g);for(;Object.prototype!==b;)a=a.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return a}e.getAllPropertyNames=y;function v(g){const a=[];for(const b of y(g))typeof g[b]=="function"&&a.push(b);return a}e.getAllMethodNames=v;function o(g,a){const b=w=>function(){const t=Array.prototype.slice.call(arguments,0);return a(w,t)},E={};for(const w of g)E[w]=b(w);return E}e.createProxyObject=o}),define(ee[102],te([0,1,70]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(R){function I(h){return h&&typeof h=="object"&&typeof h.id=="string"}R.isThemeColor=I})(L||(e.ThemeColor=L={}));function s(R){return{id:R}}e.themeColorFromId=s;var A;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function h(a){const b=I.exec(a.id);if(!b)return h(P.Codicon.error);const[,E,w]=b,t=["codicon","codicon-"+E];return w&&t.push("codicon-modifier-"+w.substring(1)),t}R.asClassNameArray=h;function l(a){return h(a).join(" ")}R.asClassName=l;function m(a){return"."+h(a).join(".")}R.asCSSSelector=m;function f(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||L.isThemeColor(a.color))}R.isThemeIcon=f;const S=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function d(a){const b=S.exec(a);if(!b)return;const[,E]=b;return{id:E}}R.fromString=d;function y(a){return{id:a}}R.fromId=y;function v(a,b){let E=a.id;const w=E.lastIndexOf("~");return w!==-1&&(E=E.substring(0,w)),b&&(E=`${E}~${b}`),{id:E}}R.modify=v;function o(a){const b=a.id.lastIndexOf("~");if(b!==-1)return a.id.substring(b+1)}R.getModifier=o;function g(a,b){return a.id===b.id&&a.color?.id===b.color?.id}R.isEqual=g})(A||(e.ThemeIcon=A={}))}),define(ee[31],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(s){return P.test(s)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(I){for(let h=0;h<I.length;h++)I[h]=Math.floor(Math.random()*256);return I};const A=new Uint8Array(16),R=[];for(let I=0;I<256;I++)R.push(I.toString(16).padStart(2,"0"));return function(){s(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let h=0,l="";return l+=R[A[h++]],l+=R[A[h++]],l+=R[A[h++]],l+=R[A[h++]],l+="-",l+=R[A[h++]],l+=R[A[h++]],l+="-",l+=R[A[h++]],l+=R[A[h++]],l+="-",l+=R[A[h++]],l+=R[A[h++]],l+="-",l+=R[A[h++]],l+=R[A[h++]],l+=R[A[h++]],l+=R[A[h++]],l+=R[A[h++]],l+=R[A[h++]],l}}()}),define(ee[141],te([0,1,71,42,49]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function A(R,I){if(await new Promise((m,f)=>{const S=L.createReadStream(R),d=P.createHash("sha1");S.pipe(d);const y=(0,s.once)((v,o)=>{S.removeAllListeners(),d.removeAllListeners(),v?f(v):m(o)});S.once("error",y),S.once("end",y),d.once("error",y),d.once("data",v=>y(void 0,v.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=A}),define(ee[142],te([0,1,27]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(R){const I=R.replace(/\-/g,":").toLowerCase();return!L.has(I)}function A(){const R=(0,P.networkInterfaces)();for(const I in R){const h=R[I];if(h){for(const{mac:l}of h)if(s(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(ee[86],te([0,1,27,62,31,142]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(l){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(l)}value(){if(this._value===void 0){let l=0,m=0;const f=(0,P.networkInterfaces)();for(const S in f){const d=f[S];if(d)for(const{mac:y,internal:v}of d)v||(m+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(l+=1))}this._value=m>0?l/m:0}return this._value}};let R;async function I(l){return R||(R=(async()=>await h(l)||s.generateUuid())()),R}e.getMachineId=I;async function h(l){try{const m=await new Promise((S,d)=>{j(["crypto"],S,d)}),f=(0,A.getMac)();return m.createHash("sha256").update(f,"utf8").digest("hex")}catch(m){l(m);return}}}),define(ee[103],te([0,1,87]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(I,h,l,m=1){let f=!1;return new Promise(S=>{const d=setTimeout(()=>{if(!f)return f=!0,S(0)},l);s(I,h,m,y=>{if(!f)return f=!0,clearTimeout(d),S(y)})})}e.findFreePort=L;function s(I,h,l,m){if(h===0)return m(0);const f=new P.Socket;f.once("connect",()=>(R(f),s(I+l,h-1,l,m))),f.once("data",()=>{}),f.once("error",S=>(R(f),S.code!=="ECONNREFUSED"?s(I+l,h-1,l,m):m(I))),f.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(I,h,l,m="127.0.0.1"){let f=!1,S,d=1;const y=P.createServer({pauseOnConnect:!0});function v(o,g){f||(f=!0,y.removeAllListeners(),y.close(),S&&clearTimeout(S),g(o))}return new Promise(o=>{S=setTimeout(()=>{v(0,o)},l),y.on("listening",()=>{v(I,o)}),y.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&d<h?(I++,d++,y.listen(I,m)):v(0,o)}),y.on("close",()=>{v(0,o)}),y.listen(I,m)})}e.findFreePortFaster=A;function R(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(h){console.error(h)}}}),function(){function j(){function e(){return process.uncHostAllowlist}function P(h){const l=new Set;if(Array.isArray(h))for(const m of h)typeof m=="string"&&l.add(m);return Array.from(l)}function L(){const h=e();return h?Array.from(h):[]}function s(h){if(process.platform!=="win32")return;const l=e();if(l)if(typeof h=="string")l.add(h.toLowerCase());else for(const m of P(h))s(m)}function A(h){if(typeof h!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const f of l){if(h.indexOf(f)!==0)continue;const d=h.indexOf("\\",f.length);if(d===-1)continue;const y=h.substring(f.length,d);if(y){m=y;break}}return m}function R(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:L,addUNCHostToAllowlist:s,getUNCHost:A,disableUNCAccessRestrictions:R,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return j()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=j():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ee[143],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[144],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class P{constructor(s,A){this.sender=s,this.onMessage=A}send(s){try{this.sender.send("vscode:message",s.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=P}),define(ee[38],te([0,1,14,13]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class s{constructor(){this.mapListenerToWrapper=new WeakMap}on(R,I){const h=(l,...m)=>{this.validateEvent(R,l)&&I(l,...m)};return this.mapListenerToWrapper.set(I,h),P.ipcMain.on(R,h),this}once(R,I){return P.ipcMain.once(R,(h,...l)=>{this.validateEvent(R,h)&&I(h,...l)}),this}handle(R,I){return P.ipcMain.handle(R,(h,...l)=>this.validateEvent(R,h)?I(h,...l):Promise.reject(`Invalid channel '${R}' or sender for ipcMain.handle() usage.`)),this}removeHandler(R){return P.ipcMain.removeHandler(R),this}removeListener(R,I){const h=this.mapListenerToWrapper.get(I);return h&&(P.ipcMain.removeListener(R,h),this.mapListenerToWrapper.delete(I)),this}validateEvent(R,I){if(!R||!R.startsWith("vscode:"))return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because the channel is unknown.`),!1;const h=I.senderFrame,l=h.url;if(!l)return!0;let m="unknown";try{m=new URL(l).host}catch{return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a malformed URL '${l}'.`),!1}return m!=="vscode-app"?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a bad origin of '${m}'.`),!1):h.parent!==null?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because sender of origin '${m}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new s}),define(ee[145],te([0,1,14,38,11,143]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function R(){L.validatedIpcMain.on(A.CONTEXT_MENU_CHANNEL,(h,l,m,f,S)=>{const d=I(h,f,m);d.popup({window:(0,s.withNullAsUndefined)(P.BrowserWindow.fromWebContents(h.sender)),x:S?S.x:void 0,y:S?S.y:void 0,positioningItem:S?S.positioningItem:void 0,callback:()=>{d&&h.sender.send(A.CONTEXT_MENU_CLOSE_CHANNEL,l)}})})}e.registerContextMenuListener=R;function I(h,l,m){const f=new P.Menu;return m.forEach(S=>{let d;S.type==="separator"?d=new P.MenuItem({type:S.type}):Array.isArray(S.submenu)?d=new P.MenuItem({submenu:I(h,l,S.submenu),label:S.label}):d=new P.MenuItem({label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:S.enabled,visible:S.visible,click:(y,v,o)=>h.sender.send(l,S.id,o)}),f.append(d)}),f}}),define(ee[146],te([12,10]),function(j,e){return j.create("vs/base/common/date",e)}),define(ee[147],te([0,1,146]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,s=L*60,A=s*24,R=A*7,I=A*30,h=A*365;function l(f,S,d,y){typeof f!="number"&&(f=f.getTime());const v=Math.round((new Date().getTime()-f)/1e3);if(v<-30)return(0,P.localize)(0,null,l(new Date().getTime()+v*1e3,!1));if(!y&&v<30)return(0,P.localize)(1,null);let o;return v<L?(o=v,S?o===1?d?(0,P.localize)(2,null,o):(0,P.localize)(3,null,o):d?(0,P.localize)(4,null,o):(0,P.localize)(5,null,o):o===1?d?(0,P.localize)(6,null,o):(0,P.localize)(7,null,o):d?(0,P.localize)(8,null,o):(0,P.localize)(9,null,o)):v<s?(o=Math.floor(v/L),S?o===1?d?(0,P.localize)(10,null,o):(0,P.localize)(11,null,o):d?(0,P.localize)(12,null,o):(0,P.localize)(13,null,o):o===1?d?(0,P.localize)(14,null,o):(0,P.localize)(15,null,o):d?(0,P.localize)(16,null,o):(0,P.localize)(17,null,o)):v<A?(o=Math.floor(v/s),S?o===1?d?(0,P.localize)(18,null,o):(0,P.localize)(19,null,o):d?(0,P.localize)(20,null,o):(0,P.localize)(21,null,o):o===1?d?(0,P.localize)(22,null,o):(0,P.localize)(23,null,o):d?(0,P.localize)(24,null,o):(0,P.localize)(25,null,o)):v<R?(o=Math.floor(v/A),S?o===1?(0,P.localize)(26,null,o):(0,P.localize)(27,null,o):o===1?(0,P.localize)(28,null,o):(0,P.localize)(29,null,o)):v<I?(o=Math.floor(v/R),S?o===1?d?(0,P.localize)(30,null,o):(0,P.localize)(31,null,o):d?(0,P.localize)(32,null,o):(0,P.localize)(33,null,o):o===1?d?(0,P.localize)(34,null,o):(0,P.localize)(35,null,o):d?(0,P.localize)(36,null,o):(0,P.localize)(37,null,o)):v<h?(o=Math.floor(v/I),S?o===1?d?(0,P.localize)(38,null,o):(0,P.localize)(39,null,o):d?(0,P.localize)(40,null,o):(0,P.localize)(41,null,o):o===1?d?(0,P.localize)(42,null,o):(0,P.localize)(43,null,o):d?(0,P.localize)(44,null,o):(0,P.localize)(45,null,o)):(o=Math.floor(v/h),S?o===1?d?(0,P.localize)(46,null,o):(0,P.localize)(47,null,o):d?(0,P.localize)(48,null,o):(0,P.localize)(49,null,o):o===1?d?(0,P.localize)(50,null,o):(0,P.localize)(51,null,o):d?(0,P.localize)(52,null,o):(0,P.localize)(53,null,o))}e.fromNow=l;function m(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=m}),define(ee[148],te([12,10]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(ee[50],te([0,1,24,11,148]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(f,S){return S&&(f.stack||f.stacktrace)?s.localize(0,null,I(f),R(f.stack)||R(f.stacktrace)):I(f)}function R(f){return Array.isArray(f)?f.join(`
`):f}function I(f){return f.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${f.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?s.localize(1,null,f.message):f.message||s.localize(2,null)}function h(f=null,S=!1){if(!f)return s.localize(3,null);if(Array.isArray(f)){const d=P.coalesce(f),y=h(d[0],S);return d.length>1?s.localize(4,null,y,d.length):y}if(L.isString(f))return f;if(f.detail){const d=f.detail;if(d.error)return A(d.error,S);if(d.exception)return A(d.exception,S)}return f.stack?A(f,S):f.message?f.message:s.localize(5,null)}e.toErrorMessage=h;function l(f){const S=f;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=l;function m(f,S){let d;return typeof f=="string"?d=new Error(f):d=f,d.actions=S,d}e.createErrorWithActions=m}),define(ee[149],te([12,10]),function(j,e){return j.create("vs/base/common/jsonErrorMessages",e)}),define(ee[150],te([0,1,149]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(s){switch(s){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(ee[151],te([12,10]),function(j,e){return j.create("vs/base/common/platform",e)}),define(ee[3],te([0,1,151]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,s=!1,A=!1,R=!1,I=!1,h=!1,l=!1,m=!1,f=!1,S=!1,d,y=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT,o,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?a=e.globals.vscode.process:typeof process<"u"&&(a=process);const b=typeof a?.versions?.electron=="string",E=b&&a?.type==="renderer";if(typeof navigator=="object"&&!E)g=navigator.userAgent,L=g.indexOf("Windows")>=0,s=g.indexOf("Macintosh")>=0,m=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=g.indexOf("Linux")>=0,S=g?.indexOf("Mobi")>=0,h=!0,d=P.getConfiguredDefaultLocale(P.localize(0,null))||e.LANGUAGE_DEFAULT,y=d,v=navigator.language;else if(typeof a=="object"){L=a.platform==="win32",s=a.platform==="darwin",A=a.platform==="linux",R=A&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,l=b,f=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT;const D=a.env.VSCODE_NLS_CONFIG;if(D)try{const k=JSON.parse(D),C=k.availableLanguages["*"];d=k.locale,v=k.osLocale,y=C||e.LANGUAGE_DEFAULT,o=k._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var w;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(w||(e.Platform=w={}));function t(D){switch(D){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let u=0;s?u=1:L?u=3:A&&(u=2),e.isWindows=L,e.isMacintosh=s,e.isLinux=A,e.isLinuxSnap=R,e.isNative=I,e.isElectron=l,e.isWeb=h,e.isWebWorker=h&&typeof e.globals.importScripts=="function",e.isIOS=m,e.isMobile=S,e.isCI=f,e.platform=u,e.userAgent=g,e.language=y;var r;(function(D){function k(){return e.language}D.value=k;function C(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}D.isDefaultVariant=C;function _(){return e.language==="en"}D.isDefault=_})(r||(e.Language=r={})),e.locale=d,e.platformLocale=v,e.translationsConfigFile=o,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const D=[];e.globals.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let _=0,T=D.length;_<T;_++){const U=D[_];if(U.id===C.data.vscodeScheduleAsyncWork){D.splice(_,1),U.callback();return}}});let k=0;return C=>{const _=++k;D.push({id:_,callback:C}),e.globals.postMessage({vscodeScheduleAsyncWork:_},"*")}}return D=>setTimeout(D)})();var i;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=s||m?2:L?1:3;let n=!0,c=!1;function p(){if(!c){c=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,n=new Uint16Array(D.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=p,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[36],te([0,1,3]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof P.globals.vscode<"u"&&typeof P.globals.vscode.process<"u"){const s=P.globals.vscode.process;L={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(ee[9],te([0,1,36]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,s=97,A=90,R=122,I=46,h=47,l=92,m=58,f=63;class S extends Error{constructor(u,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const c=u.indexOf(".")!==-1?"property":"argument";let p=`The "${u}" ${c} ${n} of type ${r}`;p+=`. Received type ${typeof i}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function d(t,u){if(t===null||typeof t!="object")throw new S(u,"Object",t)}function y(t,u){if(typeof t!="string")throw new S(u,"string",t)}const v=P.platform==="win32";function o(t){return t===h||t===l}function g(t){return t===h}function a(t){return t>=L&&t<=A||t>=s&&t<=R}function b(t,u,r,i){let n="",c=0,p=-1,D=0,k=0;for(let C=0;C<=t.length;++C){if(C<t.length)k=t.charCodeAt(C);else{if(i(k))break;k=h}if(i(k)){if(!(p===C-1||D===1))if(D===2){if(n.length<2||c!==2||n.charCodeAt(n.length-1)!==I||n.charCodeAt(n.length-2)!==I){if(n.length>2){const _=n.lastIndexOf(r);_===-1?(n="",c=0):(n=n.slice(0,_),c=n.length-1-n.lastIndexOf(r)),p=C,D=0;continue}else if(n.length!==0){n="",c=0,p=C,D=0;continue}}u&&(n+=n.length>0?`${r}..`:"..",c=2)}else n.length>0?n+=`${r}${t.slice(p+1,C)}`:n=t.slice(p+1,C),c=C-p-1;p=C,D=0}else k===I&&D!==-1?++D:D=-1}return n}function E(t,u){d(u,"pathObject");const r=u.dir||u.root,i=u.base||`${u.name||""}${u.ext||""}`;return r?r===u.root?`${r}${i}`:`${r}${t}${i}`:i}e.win32={resolve(...t){let u="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let c;if(n>=0){if(c=t[n],y(c,"path"),c.length===0)continue}else u.length===0?c=P.cwd():(c=P.env[`=${u}`]||P.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==u.toLowerCase()&&c.charCodeAt(2)===l)&&(c=`${u}\\`));const p=c.length;let D=0,k="",C=!1;const _=c.charCodeAt(0);if(p===1)o(_)&&(D=1,C=!0);else if(o(_))if(C=!0,o(c.charCodeAt(1))){let T=2,U=T;for(;T<p&&!o(c.charCodeAt(T));)T++;if(T<p&&T!==U){const q=c.slice(U,T);for(U=T;T<p&&o(c.charCodeAt(T));)T++;if(T<p&&T!==U){for(U=T;T<p&&!o(c.charCodeAt(T));)T++;(T===p||T!==U)&&(k=`\\\\${q}\\${c.slice(U,T)}`,D=T)}}}else D=1;else a(_)&&c.charCodeAt(1)===m&&(k=c.slice(0,2),D=2,p>2&&o(c.charCodeAt(2))&&(C=!0,D=3));if(k.length>0)if(u.length>0){if(k.toLowerCase()!==u.toLowerCase())continue}else u=k;if(i){if(u.length>0)break}else if(r=`${c.slice(D)}\\${r}`,i=C,C&&u.length>0)break}return r=b(r,!i,"\\",o),i?`${u}\\${r}`:`${u}${r}`||"."},normalize(t){y(t,"path");const u=t.length;if(u===0)return".";let r=0,i,n=!1;const c=t.charCodeAt(0);if(u===1)return g(c)?"\\":t;if(o(c))if(n=!0,o(t.charCodeAt(1))){let D=2,k=D;for(;D<u&&!o(t.charCodeAt(D));)D++;if(D<u&&D!==k){const C=t.slice(k,D);for(k=D;D<u&&o(t.charCodeAt(D));)D++;if(D<u&&D!==k){for(k=D;D<u&&!o(t.charCodeAt(D));)D++;if(D===u)return`\\\\${C}\\${t.slice(k)}\\`;D!==k&&(i=`\\\\${C}\\${t.slice(k,D)}`,r=D)}}}else r=1;else a(c)&&t.charCodeAt(1)===m&&(i=t.slice(0,2),r=2,u>2&&o(t.charCodeAt(2))&&(n=!0,r=3));let p=r<u?b(t.slice(r),!n,"\\",o):"";return p.length===0&&!n&&(p="."),p.length>0&&o(t.charCodeAt(u-1))&&(p+="\\"),i===void 0?n?`\\${p}`:p:n?`${i}\\${p}`:`${i}${p}`},isAbsolute(t){y(t,"path");const u=t.length;if(u===0)return!1;const r=t.charCodeAt(0);return o(r)||u>2&&a(r)&&t.charCodeAt(1)===m&&o(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let u,r;for(let c=0;c<t.length;++c){const p=t[c];y(p,"path"),p.length>0&&(u===void 0?u=r=p:u+=`\\${p}`)}if(u===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&o(r.charCodeAt(0))){++n;const c=r.length;c>1&&o(r.charCodeAt(1))&&(++n,c>2&&(o(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<u.length&&o(u.charCodeAt(n));)n++;n>=2&&(u=`\\${u.slice(n)}`)}return e.win32.normalize(u)},relative(t,u){if(y(t,"from"),y(u,"to"),t===u)return"";const r=e.win32.resolve(t),i=e.win32.resolve(u);if(r===i||(t=r.toLowerCase(),u=i.toLowerCase(),t===u))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===l;)n++;let c=t.length;for(;c-1>n&&t.charCodeAt(c-1)===l;)c--;const p=c-n;let D=0;for(;D<u.length&&u.charCodeAt(D)===l;)D++;let k=u.length;for(;k-1>D&&u.charCodeAt(k-1)===l;)k--;const C=k-D,_=p<C?p:C;let T=-1,U=0;for(;U<_;U++){const se=t.charCodeAt(n+U);if(se!==u.charCodeAt(D+U))break;se===l&&(T=U)}if(U!==_){if(T===-1)return i}else{if(C>_){if(u.charCodeAt(D+U)===l)return i.slice(D+U+1);if(U===2)return i.slice(D+U)}p>_&&(t.charCodeAt(n+U)===l?T=U:U===2&&(T=3)),T===-1&&(T=0)}let q="";for(U=n+T+1;U<=c;++U)(U===c||t.charCodeAt(U)===l)&&(q+=q.length===0?"..":"\\..");return D+=T,q.length>0?`${q}${i.slice(D,k)}`:(i.charCodeAt(D)===l&&++D,i.slice(D,k))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const u=e.win32.resolve(t);if(u.length<=2)return t;if(u.charCodeAt(0)===l){if(u.charCodeAt(1)===l){const r=u.charCodeAt(2);if(r!==f&&r!==I)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(a(u.charCodeAt(0))&&u.charCodeAt(1)===m&&u.charCodeAt(2)===l)return`\\\\?\\${u}`;return t},dirname(t){y(t,"path");const u=t.length;if(u===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(u===1)return o(n)?t:".";if(o(n)){if(r=i=1,o(t.charCodeAt(1))){let D=2,k=D;for(;D<u&&!o(t.charCodeAt(D));)D++;if(D<u&&D!==k){for(k=D;D<u&&o(t.charCodeAt(D));)D++;if(D<u&&D!==k){for(k=D;D<u&&!o(t.charCodeAt(D));)D++;if(D===u)return t;D!==k&&(r=i=D+1)}}}}else a(n)&&t.charCodeAt(1)===m&&(r=u>2&&o(t.charCodeAt(2))?3:2,i=r);let c=-1,p=!0;for(let D=u-1;D>=i;--D)if(o(t.charCodeAt(D))){if(!p){c=D;break}}else p=!1;if(c===-1){if(r===-1)return".";c=r}return t.slice(0,c)},basename(t,u){u!==void 0&&y(u,"ext"),y(t,"path");let r=0,i=-1,n=!0,c;if(t.length>=2&&a(t.charCodeAt(0))&&t.charCodeAt(1)===m&&(r=2),u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let p=u.length-1,D=-1;for(c=t.length-1;c>=r;--c){const k=t.charCodeAt(c);if(o(k)){if(!n){r=c+1;break}}else D===-1&&(n=!1,D=c+1),p>=0&&(k===u.charCodeAt(p)?--p===-1&&(i=c):(p=-1,i=D))}return r===i?i=D:i===-1&&(i=t.length),t.slice(r,i)}for(c=t.length-1;c>=r;--c)if(o(t.charCodeAt(c))){if(!n){r=c+1;break}}else i===-1&&(n=!1,i=c+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let u=0,r=-1,i=0,n=-1,c=!0,p=0;t.length>=2&&t.charCodeAt(1)===m&&a(t.charCodeAt(0))&&(u=i=2);for(let D=t.length-1;D>=u;--D){const k=t.charCodeAt(D);if(o(k)){if(!c){i=D+1;break}continue}n===-1&&(c=!1,n=D+1),k===I?r===-1?r=D:p!==1&&(p=1):r!==-1&&(p=-1)}return r===-1||n===-1||p===0||p===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:E.bind(null,"\\"),parse(t){y(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return o(n)?(u.root=u.dir=t,u):(u.base=u.name=t,u);if(o(n)){if(i=1,o(t.charCodeAt(1))){let T=2,U=T;for(;T<r&&!o(t.charCodeAt(T));)T++;if(T<r&&T!==U){for(U=T;T<r&&o(t.charCodeAt(T));)T++;if(T<r&&T!==U){for(U=T;T<r&&!o(t.charCodeAt(T));)T++;T===r?i=T:T!==U&&(i=T+1)}}}}else if(a(n)&&t.charCodeAt(1)===m){if(r<=2)return u.root=u.dir=t,u;if(i=2,o(t.charCodeAt(2))){if(r===3)return u.root=u.dir=t,u;i=3}}i>0&&(u.root=t.slice(0,i));let c=-1,p=i,D=-1,k=!0,C=t.length-1,_=0;for(;C>=i;--C){if(n=t.charCodeAt(C),o(n)){if(!k){p=C+1;break}continue}D===-1&&(k=!1,D=C+1),n===I?c===-1?c=C:_!==1&&(_=1):c!==-1&&(_=-1)}return D!==-1&&(c===-1||_===0||_===1&&c===D-1&&c===p+1?u.base=u.name=t.slice(p,D):(u.name=t.slice(p,c),u.base=t.slice(p,D),u.ext=t.slice(c,D))),p>0&&p!==i?u.dir=t.slice(0,p-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const w=(()=>{if(v){const t=/\\/g;return()=>{const u=P.cwd().replace(t,"/");return u.slice(u.indexOf("/"))}}return()=>P.cwd()})();e.posix={resolve(...t){let u="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:w();y(n,"path"),n.length!==0&&(u=`${n}/${u}`,r=n.charCodeAt(0)===h)}return u=b(u,!r,"/",g),r?`/${u}`:u.length>0?u:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===h,r=t.charCodeAt(t.length-1)===h;return t=b(t,!u,"/",g),t.length===0?u?"/":r?"./":".":(r&&(t+="/"),u?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let u;for(let r=0;r<t.length;++r){const i=t[r];y(i,"path"),i.length>0&&(u===void 0?u=i:u+=`/${i}`)}return u===void 0?".":e.posix.normalize(u)},relative(t,u){if(y(t,"from"),y(u,"to"),t===u||(t=e.posix.resolve(t),u=e.posix.resolve(u),t===u))return"";const r=1,i=t.length,n=i-r,c=1,p=u.length-c,D=n<p?n:p;let k=-1,C=0;for(;C<D;C++){const T=t.charCodeAt(r+C);if(T!==u.charCodeAt(c+C))break;T===h&&(k=C)}if(C===D)if(p>D){if(u.charCodeAt(c+C)===h)return u.slice(c+C+1);if(C===0)return u.slice(c+C)}else n>D&&(t.charCodeAt(r+C)===h?k=C:C===0&&(k=0));let _="";for(C=r+k+1;C<=i;++C)(C===i||t.charCodeAt(C)===h)&&(_+=_.length===0?"..":"/..");return`${_}${u.slice(c+k)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===h;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===h){if(!i){r=n;break}}else i=!1;return r===-1?u?"/":".":u&&r===1?"//":t.slice(0,r)},basename(t,u){u!==void 0&&y(u,"ext"),y(t,"path");let r=0,i=-1,n=!0,c;if(u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let p=u.length-1,D=-1;for(c=t.length-1;c>=0;--c){const k=t.charCodeAt(c);if(k===h){if(!n){r=c+1;break}}else D===-1&&(n=!1,D=c+1),p>=0&&(k===u.charCodeAt(p)?--p===-1&&(i=c):(p=-1,i=D))}return r===i?i=D:i===-1&&(i=t.length),t.slice(r,i)}for(c=t.length-1;c>=0;--c)if(t.charCodeAt(c)===h){if(!n){r=c+1;break}}else i===-1&&(n=!1,i=c+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let u=-1,r=0,i=-1,n=!0,c=0;for(let p=t.length-1;p>=0;--p){const D=t.charCodeAt(p);if(D===h){if(!n){r=p+1;break}continue}i===-1&&(n=!1,i=p+1),D===I?u===-1?u=p:c!==1&&(c=1):u!==-1&&(c=-1)}return u===-1||i===-1||c===0||c===1&&u===i-1&&u===r+1?"":t.slice(u,i)},format:E.bind(null,"/"),parse(t){y(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const r=t.charCodeAt(0)===h;let i;r?(u.root="/",i=1):i=0;let n=-1,c=0,p=-1,D=!0,k=t.length-1,C=0;for(;k>=i;--k){const _=t.charCodeAt(k);if(_===h){if(!D){c=k+1;break}continue}p===-1&&(D=!1,p=k+1),_===I?n===-1?n=k:C!==1&&(C=1):n!==-1&&(C=-1)}if(p!==-1){const _=c===0&&r?1:c;n===-1||C===0||C===1&&n===p-1&&n===c+1?u.base=u.name=t.slice(_,p):(u.name=t.slice(_,n),u.base=t.slice(_,p),u.ext=t.slice(n,p))}return c>0?u.dir=t.slice(0,c-1):r&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v?e.win32.normalize:e.posix.normalize,e.isAbsolute=v?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v?e.win32.join:e.posix.join,e.resolve=v?e.win32.resolve:e.posix.resolve,e.relative=v?e.win32.relative:e.posix.relative,e.dirname=v?e.win32.dirname:e.posix.dirname,e.basename=v?e.win32.basename:e.posix.basename,e.extname=v?e.win32.extname:e.posix.extname,e.format=v?e.win32.format:e.posix.format,e.parse=v?e.win32.parse:e.posix.parse,e.toNamespacedPath=v?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v?e.win32.sep:e.posix.sep,e.delimiter=v?e.win32.delimiter:e.posix.delimiter}),define(ee[32],te([0,1,9,3,25,11]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(c){return c===47||c===92}e.isPathSeparator=R;function I(c){return c.replace(/[\\/]/g,P.posix.sep)}e.toSlashes=I;function h(c){return c.indexOf("/")===-1&&(c=I(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=h;function l(c,p=P.posix.sep){if(!c)return"";const D=c.length,k=c.charCodeAt(0);if(R(k)){if(R(c.charCodeAt(1))&&!R(c.charCodeAt(2))){let _=3;const T=_;for(;_<D&&!R(c.charCodeAt(_));_++);if(T!==_&&!R(c.charCodeAt(_+1))){for(_+=1;_<D;_++)if(R(c.charCodeAt(_)))return c.slice(0,_+1).replace(/[\\/]/g,p)}}return p}else if(g(k)&&c.charCodeAt(1)===58)return R(c.charCodeAt(2))?c.slice(0,2)+p:c.slice(0,2);let C=c.indexOf("://");if(C!==-1){for(C+=3;C<D;C++)if(R(c.charCodeAt(C)))return c.slice(0,C+1)}return""}e.getRoot=l;function m(c){if(!L.isWindows||!c||c.length<5)return!1;let p=c.charCodeAt(0);if(p!==92||(p=c.charCodeAt(1),p!==92))return!1;let D=2;const k=D;for(;D<c.length&&(p=c.charCodeAt(D),p!==92);D++);return!(k===D||(p=c.charCodeAt(D+1),isNaN(p)||p===92))}e.isUNC=m;const f=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(c,p=L.isWindows){const D=p?f:S;return!(!c||c.length===0||/^\s+$/.test(c)||(D.lastIndex=0,D.test(c))||p&&d.test(c)||c==="."||c===".."||p&&c[c.length-1]==="."||p&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=y;function v(c,p,D){const k=c===p;return!D||k?k:!c||!p?!1:(0,s.equalsIgnoreCase)(c,p)}e.isEqual=v;function o(c,p,D,k=P.sep){if(c===p)return!0;if(!c||!p||p.length>c.length)return!1;if(D){if(!(0,s.startsWithIgnoreCase)(c,p))return!1;if(p.length===c.length)return!0;let _=p.length;return p.charAt(p.length-1)===k&&_--,c.charAt(_)===k}return p.charAt(p.length-1)!==k&&(p+=k),c.indexOf(p)===0}e.isEqualOrParent=o;function g(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=g;function a(c,p){return L.isWindows&&c.endsWith(":")&&(c+=P.sep),(0,P.isAbsolute)(c)||(c=(0,P.join)(p,c)),c=(0,P.normalize)(c),L.isWindows?(c=(0,s.rtrim)(c,P.sep),c.endsWith(":")&&(c+=P.sep)):(c=(0,s.rtrim)(c,P.sep),c||(c=P.sep)),c}e.sanitizeFilePath=a;function b(c){const p=(0,P.normalize)(c);return L.isWindows?c.length>3?!1:E(p)&&(c.length===2||p.charCodeAt(2)===92):p===P.posix.sep}e.isRootOrDriveLetter=b;function E(c,p=L.isWindows){return p?g(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function w(c,p=L.isWindows){return E(c,p)?c[0]:void 0}e.getDriveLetter=w;function t(c,p,D){return p.length>c.length?-1:c===p?0:(D&&(c=c.toLowerCase(),p=p.toLowerCase()),c.indexOf(p))}e.indexOfPath=t;function u(c){const p=c.split(":");let D,k,C;for(const _ of p){const T=Number(_);(0,A.isNumber)(T)?k===void 0?k=T:C===void 0&&(C=T):D=D?[D,_].join(":"):_}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:k!==void 0?k:void 0,column:C!==void 0?C:k!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(c,p,D=8){let k="";for(let _=0;_<D;_++){let T;_===0&&L.isWindows&&!p&&(D===3||D===4)?T=i:T=r,k+=T.charAt(Math.floor(Math.random()*T.length))}let C;return p?C=`${p}-${k}`:C=k,c?(0,P.join)(c,C):C}e.randomPath=n}),define(ee[72],te([0,1,3]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(L||(e.Source=L={}));var s;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function A(I,...h){const l=h.reduce((S,d)=>(S[d]=!0,S),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(S=>!l[S]).forEach(S=>{for(let d=0;d<m.length;d++)if(S.search(m[d])!==-1){delete I[S];break}})}e.sanitizeProcessEnvironment=A;function R(I){I&&(delete I.DEBUG,P.isMacintosh&&delete I.DYLD_LIBRARY_PATH,P.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=R}),define(ee[7],te([0,1,9,3]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,A=/^\//,R=/^\/\//;function I(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,n){return!i&&!n?"file":i}function l(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==f&&(n=f+n):n=f;break}return n}const m="",f="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(n){return n instanceof d?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,c,p,D,k,C=!1){typeof n=="object"?(this.scheme=n.scheme||m,this.authority=n.authority||m,this.path=n.path||m,this.query=n.query||m,this.fragment=n.fragment||m):(this.scheme=h(n,C),this.authority=c||m,this.path=l(this.scheme,p||m),this.query=D||m,this.fragment=k||m,I(this,C))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:c,authority:p,path:D,query:k,fragment:C}=n;return c===void 0?c=this.scheme:c===null&&(c=m),p===void 0?p=this.authority:p===null&&(p=m),D===void 0?D=this.path:D===null&&(D=m),k===void 0?k=this.query:k===null&&(k=m),C===void 0?C=this.fragment:C===null&&(C=m),c===this.scheme&&p===this.authority&&D===this.path&&k===this.query&&C===this.fragment?this:new o(c,p,D,k,C)}static parse(n,c=!1){const p=S.exec(n);return p?new o(p[2]||m,r(p[4]||m),r(p[5]||m),r(p[7]||m),r(p[9]||m),c):new o(m,m,m,m,m)}static file(n){let c=m;if(L.isWindows&&(n=n.replace(/\\/g,f)),n[0]===f&&n[1]===f){const p=n.indexOf(f,2);p===-1?(c=n.substring(2),n=f):(c=n.substring(2,p),n=n.substring(p)||f)}return new o("file",c,n,m,m)}static from(n,c){return new o(n.scheme,n.authority,n.path,n.query,n.fragment,c)}static joinPath(n,...c){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return L.isWindows&&n.scheme==="file"?p=d.file(P.win32.join(E(n,!0),...c)).path:p=P.posix.join(n.path,...c),n.with({path:p})}toString(n=!1){return w(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof d)return n;{const c=new o(n);return c._formatted=n.external??null,c._fsPath=n._sep===v?n.fsPath??null:null,c}}else return n}}e.URI=d;function y(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.isUriComponents=y;const v=L.isWindows?1:void 0;class o extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=v),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(i,n,c){let p,D=-1;for(let k=0;k<i.length;k++){const C=i.charCodeAt(k);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||n&&C===47||c&&C===91||c&&C===93||c&&C===58)D!==-1&&(p+=encodeURIComponent(i.substring(D,k)),D=-1),p!==void 0&&(p+=i.charAt(k));else{p===void 0&&(p=i.substr(0,k));const _=g[C];_!==void 0?(D!==-1&&(p+=encodeURIComponent(i.substring(D,k)),D=-1),p+=_):D===-1&&(D=k)}}return D!==-1&&(p+=encodeURIComponent(i.substring(D))),p!==void 0?p:i}function b(i){let n;for(let c=0;c<i.length;c++){const p=i.charCodeAt(c);p===35||p===63?(n===void 0&&(n=i.substr(0,c)),n+=g[p]):n!==void 0&&(n+=i[c])}return n!==void 0?n:i}function E(i,n){let c;return i.authority&&i.path.length>1&&i.scheme==="file"?c=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?c=i.path.substr(1):c=i.path[1].toLowerCase()+i.path.substr(2):c=i.path,L.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=E;function w(i,n){const c=n?b:a;let p="",{scheme:D,authority:k,path:C,query:_,fragment:T}=i;if(D&&(p+=D,p+=":"),(k||D==="file")&&(p+=f,p+=f),k){let U=k.indexOf("@");if(U!==-1){const q=k.substr(0,U);k=k.substr(U+1),U=q.lastIndexOf(":"),U===-1?p+=c(q,!1,!1):(p+=c(q.substr(0,U),!1,!1),p+=":",p+=c(q.substr(U+1),!1,!0)),p+="@"}k=k.toLowerCase(),U=k.lastIndexOf(":"),U===-1?p+=c(k,!1,!0):(p+=c(k.substr(0,U),!1,!0),p+=k.substr(U))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const U=C.charCodeAt(1);U>=65&&U<=90&&(C=`/${String.fromCharCode(U+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const U=C.charCodeAt(0);U>=65&&U<=90&&(C=`${String.fromCharCode(U+32)}:${C.substr(2)}`)}p+=c(C,!0,!1)}return _&&(p+="?",p+=c(_,!1,!1)),T&&(p+="#",p+=n?T:a(T,!1,!1)),p}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(u)?i.replace(u,n=>t(n)):i}}),define(ee[152],te([0,1,7]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(l){const m=l;return m&&typeof m.type=="string"&&typeof m.severity=="string"}e.isRemoteConsoleLog=L;function s(l){const m=[];let f;try{const S=JSON.parse(l.arguments),d=S[S.length-1];d&&d.__$stack&&(S.pop(),f=d.__$stack),m.push(...S)}catch{m.push("Unable to log remote console arguments",l.arguments)}return{args:m,stack:f}}e.parse=s;function A(l){if(typeof l!="string")return A(s(l).stack);const m=l;if(m){const f=R(m),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(f||"");if(S&&S.length===4)return{uri:P.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=A;function R(l){if(!l)return l;const m=l.indexOf(`
`);return m===-1?l:l.substring(0,m)}function I(l,m){const{args:f,stack:S}=s(l),d=typeof f[0]=="string"&&f.length===1;let y=R(S);y&&(y=`(${y.trim()})`);let v=[];if(typeof f[0]=="string"?y&&d?v=[`%c[${m}] %c${f[0]} %c${y}`,h("blue"),h(""),h("grey")]:v=[`%c[${m}] %c${f[0]}`,h("blue"),h(""),...f.slice(1)]:v=[`%c[${m}]%`,h("blue"),...f],y&&!d&&v.push(y),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,v)}e.log=I;function h(l){return`color: ${l}`}}),define(ee[73],te([0,1,17,25,7]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(l){return JSON.stringify(l,I)}e.stringify=A;function R(l){let m=JSON.parse(l);return m=h(m),m}e.parse=R;function I(l,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:(0,L.regExpFlags)(m)}:m}function h(l,m=0){if(!l||m>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return s.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof P.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let f=0;f<l.length;++f)l[f]=h(l[f],m+1);else for(const f in l)Object.hasOwnProperty.call(l,f)&&(l[f]=h(l[f],m+1))}return l}e.revive=h}),define(ee[15],te([0,1,13,3,7]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}setServerRootPath(m){this._remoteResourcesPath=`${m}/${A.vscodeRemoteResource}`}set(m,f,S){this._hosts[m]=f,this._ports[m]=S}setConnectionToken(m,f){this._connectionTokens[m]=f}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(m){if(this._delegate)try{return this._delegate(m)}catch(o){return P.onUnexpectedError(o),m}const f=m.authority;let S=this._hosts[f];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const d=this._ports[f],y=this._connectionTokens[f];let v=`path=${encodeURIComponent(m.path)}`;return typeof y=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),s.URI.from({scheme:L.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${S}:${d}`,path:this._remoteResourcesPath,query:v})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class I{asBrowserUri(m){const f=this.toUri(m,j);return this.uriToBrowserUri(f)}uriToBrowserUri(m){return m.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(m):m.scheme===A.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${A.vscodeFileResource}://${I.FALLBACK_AUTHORITY}`)?m.with({scheme:A.vscodeFileResource,authority:m.authority||I.FALLBACK_AUTHORITY,query:null,fragment:null}):m}asFileUri(m){const f=this.toUri(m,j);return this.uriToFileUri(f)}uriToFileUri(m){return m.scheme===A.vscodeFileResource?m.with({scheme:A.file,authority:m.authority!==I.FALLBACK_AUTHORITY?m.authority:null,query:null,fragment:null}):m}toUri(m,f){return s.URI.isUri(m)?m:s.URI.parse(f.toUrl(m))}}I.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new I;var h;(function(l){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(m.get("3"));const f="vscode-coi";function S(y){let v;typeof y=="string"?v=new URL(y).searchParams:y instanceof URL?v=y.searchParams:s.URI.isUri(y)&&(v=new URL(y.toString(!0)).searchParams);const o=v?.get(f);if(o)return m.get(o)}l.getHeadersFromQuery=S;function d(y,v,o){if(!globalThis.crossOriginIsolated)return;const g=v&&o?"3":o?"2":"1";y instanceof URLSearchParams?y.set(f,g):y[f]=g}l.addSearchParam=d})(h||(e.COI=h={}))}),define(ee[19],te([0,1,32,15,9,3,25,7]),function(j,e,P,L,s,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(d){return(0,I.uriToFsPath)(d,!0)}e.originalFSPath=h;class l{constructor(y){this._ignorePathCasing=y}compare(y,v,o=!1){return y===v?0:(0,R.compare)(this.getComparisonKey(y,o),this.getComparisonKey(v,o))}isEqual(y,v,o=!1){return y===v?!0:!y||!v?!1:this.getComparisonKey(y,o)===this.getComparisonKey(v,o)}getComparisonKey(y,v=!1){return y.with({path:this._ignorePathCasing(y)?y.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(y){return this._ignorePathCasing(y)}isEqualOrParent(y,v,o=!1){if(y.scheme===v.scheme){if(y.scheme===L.Schemas.file)return P.isEqualOrParent(h(y),h(v),this._ignorePathCasing(y))&&y.query===v.query&&(o||y.fragment===v.fragment);if((0,e.isEqualAuthority)(y.authority,v.authority))return P.isEqualOrParent(y.path,v.path,this._ignorePathCasing(y),"/")&&y.query===v.query&&(o||y.fragment===v.fragment)}return!1}joinPath(y,...v){return I.URI.joinPath(y,...v)}basenameOrAuthority(y){return(0,e.basename)(y)||y.authority}basename(y){return s.posix.basename(y.path)}extname(y){return s.posix.extname(y.path)}dirname(y){if(y.path.length===0)return y;let v;return y.scheme===L.Schemas.file?v=I.URI.file(s.dirname(h(y))).path:(v=s.posix.dirname(y.path),y.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),v="/")),y.with({path:v})}normalizePath(y){if(!y.path.length)return y;let v;return y.scheme===L.Schemas.file?v=I.URI.file(s.normalize(h(y))).path:v=s.posix.normalize(y.path),y.with({path:v})}relativePath(y,v){if(y.scheme!==v.scheme||!(0,e.isEqualAuthority)(y.authority,v.authority))return;if(y.scheme===L.Schemas.file){const a=s.relative(h(y),h(v));return A.isWindows?P.toSlashes(a):a}let o=y.path||"/";const g=v.path||"/";if(this._ignorePathCasing(y)){let a=0;for(const b=Math.min(o.length,g.length);a<b&&!(o.charCodeAt(a)!==g.charCodeAt(a)&&o.charAt(a).toLowerCase()!==g.charAt(a).toLowerCase());a++);o=g.substr(0,a)+o.substr(a)}return s.posix.relative(o,g)}resolvePath(y,v){if(y.scheme===L.Schemas.file){const o=I.URI.file(s.resolve(h(y),v));return y.with({authority:o.authority,path:o.path})}return v=P.toPosixPath(v),y.with({path:s.posix.resolve(y.path,v)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,v){return y===v||y!==void 0&&v!==void 0&&(0,R.equalsIgnoreCase)(y,v)}hasTrailingPathSeparator(y,v=s.sep){if(y.scheme===L.Schemas.file){const o=h(y);return o.length>P.getRoot(o).length&&o[o.length-1]===v}else{const o=y.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,v=s.sep){return(0,e.hasTrailingPathSeparator)(y,v)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,v=s.sep){let o=!1;if(y.scheme===L.Schemas.file){const g=h(y);o=g!==void 0&&g.length===P.getRoot(g).length&&g[g.length-1]===v}else{v="/";const g=y.path;o=g.length===1&&g.charCodeAt(g.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(y,v)?y.with({path:y.path+"/"}):y}}e.ExtUri=l,e.extUri=new l(()=>!1),e.extUriBiasedIgnorePathCase=new l(d=>d.scheme===L.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new l(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function m(d,y){const v=[];for(let o=0;o<d.length;o++){const g=y(d[o]);d.some((a,b)=>b===o?!1:(0,e.isEqualOrParent)(g,y(a)))||v.push(d[o])}return v}e.distinctParents=m;var f;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function y(v){const o=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(b=>{const[E,w]=b.split(":");E&&w&&o.set(E,w)});const a=v.path.substring(0,v.path.indexOf(";"));return a&&o.set(d.META_DATA_MIME,a),o}d.parseMetaData=y})(f||(e.DataUri=f={}));function S(d,y,v){if(y){let o=d.path;return o&&o[0]!==s.posix.sep&&(o=s.posix.sep+o),d.with({scheme:v,authority:y,path:o})}return d.with({scheme:v})}e.toLocalResource=S}),define(ee[8],te([0,1,21,13,4,2,19,3,140]),function(j,e,P,L,s,A,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function l(O){return!!O&&typeof O.then=="function"}e.isThenable=l;function m(O){const M=new P.CancellationTokenSource,W=O(M.token),H=new Promise((x,z)=>{const $=M.token.onCancellationRequested(()=>{$.dispose(),M.dispose(),z(new L.CancellationError)});Promise.resolve(W).then(K=>{$.dispose(),M.dispose(),x(K)},K=>{$.dispose(),M.dispose(),z(K)})});return new class{cancel(){M.cancel()}then(x,z){return H.then(x,z)}catch(x){return this.then(void 0,x)}finally(x){return H.finally(x)}}}e.createCancelablePromise=m;function f(O,M,W){return new Promise((H,x)=>{const z=M.onCancellationRequested(()=>{z.dispose(),H(W)});O.then(H,x).finally(()=>z.dispose())})}e.raceCancellation=f;function S(O,M){return new Promise((W,H)=>{const x=M.onCancellationRequested(()=>{x.dispose(),H(new L.CancellationError)});O.then(W,H).finally(()=>x.dispose())})}e.raceCancellationError=S;async function d(O){let M=-1;const W=O.map((H,x)=>H.then(z=>(M=x,z)));try{return await Promise.race(W)}finally{O.forEach((H,x)=>{x!==M&&H.cancel()})}}e.raceCancellablePromises=d;function y(O,M,W){let H;const x=setTimeout(()=>{H?.(void 0),W?.()},M);return Promise.race([O.finally(()=>clearTimeout(x)),new Promise(z=>H=z)])}e.raceTimeout=y;function v(O){return new Promise((M,W)=>{const H=O();l(H)?H.then(M,W):M(H)})}e.asPromise=v;class o{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.isDisposed)throw new Error("Throttler is disposed");if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const W=()=>{if(this.queuedPromise=null,this.isDisposed)return;const H=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,H};this.queuedPromise=new Promise(H=>{this.activePromise.then(W,W).then(H)})}return new Promise((W,H)=>{this.queuedPromise.then(W,H)})}return this.activePromise=M(),new Promise((W,H)=>{this.activePromise.then(x=>{this.activePromise=null,W(x)},x=>{this.activePromise=null,H(x)})})}dispose(){this.isDisposed=!0}}e.Throttler=o;class g{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=g;class a{constructor(){this.promiseMap=new Map}queue(M,W){const x=(this.promiseMap.get(M)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(M)===x&&this.promiseMap.delete(M)});return this.promiseMap.set(M,x),x}}e.SequencerByKey=a;const b=(O,M)=>{let W=!0;const H=setTimeout(()=>{W=!1,M()},O);return{isTriggered:()=>W,dispose:()=>{clearTimeout(H),W=!1}}},E=O=>{let M=!0;return queueMicrotask(()=>{M&&(M=!1,O())}),{isTriggered:()=>M,dispose:()=>{M=!1}}};class w{constructor(M){this.defaultDelay=M,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,W=this.defaultDelay){this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((x,z)=>{this.doResolve=x,this.doReject=z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const x=this.task;return this.task=null,x()}}));const H=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=W===h.MicrotaskDelay?E(H):b(W,H),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new L.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=w;class t{constructor(M){this.delayer=new w(M),this.throttler=new o}trigger(M,W){return this.delayer.trigger(()=>this.throttler.queue(M),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=t;class u{constructor(){this._isOpen=!1,this._promise=new Promise((M,W)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class r extends u{constructor(M){super(),this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function i(O,M){return M?new Promise((W,H)=>{const x=setTimeout(()=>{z.dispose(),W()},O),z=M.onCancellationRequested(()=>{clearTimeout(x),z.dispose(),H(new L.CancellationError)})}):m(W=>i(O,W))}e.timeout=i;function n(O,M=0){const W=setTimeout(O,M);return(0,A.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=n;function c(O){const M=[];let W=0;const H=O.length;function x(){return W<H?O[W++]():null}function z($){$!=null&&M.push($);const K=x();return K?K.then(z):Promise.resolve(M)}return Promise.resolve(null).then(z)}e.sequence=c;function p(O,M=H=>!!H,W=null){let H=0;const x=O.length,z=()=>{if(H>=x)return Promise.resolve(W);const $=O[H++];return Promise.resolve($()).then(re=>M(re)?Promise.resolve(re):z())};return z()}e.first=p;function D(O,M=H=>!!H,W=null){if(O.length===0)return Promise.resolve(W);let H=O.length;const x=()=>{H=-1;for(const z of O)z.cancel?.()};return new Promise((z,$)=>{for(const K of O)K.then(re=>{--H>=0&&M(re)?(x(),z(re)):H===0&&z(W)}).catch(re=>{--H>=0&&(x(),$(re))})})}e.firstParallel=D;class k{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new s.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(M){return this._size++,new Promise((W,H)=>{this.outstandingPromises.push({factory:M,c:W,e:H}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const W=M.factory();W.then(M.c,M.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=k;class C extends k{constructor(){super(1)}}e.Queue=C;class _{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const M=new N;return this.drainers.add(M),M.p}isDrained(){for(const[,M]of this.queues)if(M.size>0)return!1;return!0}queueFor(M,W=R.extUri){const H=W.getComparisonKey(M);let x=this.queues.get(H);return x||(x=new C,s.Event.once(x.onDrained)(()=>{x?.dispose(),this.queues.delete(H),this.onDidQueueDrain()}),this.queues.set(H,x)),x}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const M of this.drainers)M.complete();this.drainers.clear()}dispose(){for(const[,M]of this.queues)M.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=_;class T{constructor(M,W){this._token=-1,typeof M=="function"&&typeof W=="number"&&this.setIfNotSet(M,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},W)}setIfNotSet(M,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},W))}}e.TimeoutTimer=T;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,W){this.cancel(),this._token=setInterval(()=>{M()},W)}}e.IntervalTimer=U;class q{constructor(M,W){this.timeoutToken=-1,this.runner=M,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=q;class se{constructor(M,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.runner=M,this.timeout=W,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(M=this.timeout){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(M/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=se;class ie extends q{constructor(M,W){super(M,W),this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner?.(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ie;class ne extends A.Disposable{constructor(M,W){super(),this.options=M,this.handler=W,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(M){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+M.length>this.options.maxBufferedWork)return!1}else if(this.pending+M.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const W of M)this.pendingWork.push(W);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ne,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=O=>{(0,I.setTimeout0)(()=>{if(M)return;const W=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let M=!1;return{dispose(){M||(M=!0)}}}:e.runWhenIdle=(O,M)=>{const W=requestIdleCallback(O,typeof M=="number"?{timeout:M}:void 0);let H=!1;return{dispose(){H||(H=!0,cancelIdleCallback(W))}}}}();class ue{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ue;async function le(O,M,W){let H;for(let x=0;x<W;x++)try{return await O()}catch(z){H=z,await i(M)}throw H}e.retry=le;class G{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(M,W,H){return this._pending={taskId:M,cancel:()=>H?.(),promise:W},W.then(()=>this.donePending(M),()=>this.donePending(M)),W}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let W,H;const x=new Promise((z,$)=>{W=z,H=$});this._next={run:M,promise:x,promiseResolve:W,promiseReject:H}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=G;class Q{constructor(M,W=()=>Date.now()){this.interval=M,this.nowFn=W,this.lastIncrementTime=0,this.value=0}increment(){const M=this.nowFn();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;var F;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(F||(F={}));class N{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((M,W)=>{this.completeCallback=M,this.errorCallback=W})}complete(M){return new Promise(W=>{this.completeCallback(M),this.outcome={outcome:0,value:M},W()})}error(M){return new Promise(W=>{this.errorCallback(M),this.outcome={outcome:1,value:M},W()})}cancel(){return this.error(new L.CancellationError)}}e.DeferredPromise=N;var B;(function(O){async function M(H){let x;const z=await Promise.all(H.map($=>$.then(K=>K,K=>{x||(x=K)})));if(typeof x<"u")throw x;return z}O.settled=M;function W(H){return new Promise(async(x,z)=>{try{await H(x,z)}catch($){z($)}})}O.withAsyncBody=W})(B||(e.Promises=B={}));var V;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(V||(V={}));class Y{static fromArray(M){return new Y(W=>{W.emitMany(M)})}static fromPromise(M){return new Y(async W=>{W.emitMany(await M)})}static fromPromises(M){return new Y(async W=>{await Promise.all(M.map(async H=>W.emitOne(await H)))})}static merge(M){return new Y(async W=>{await Promise.all(M.map(async H=>{for await(const x of H)W.emitOne(x)}))})}constructor(M){this._state=0,this._results=[],this._error=null,this._onStateChanged=new s.Emitter,queueMicrotask(async()=>{const W={emitOne:H=>this.emitOne(H),emitMany:H=>this.emitMany(H),reject:H=>this.reject(H)};try{await Promise.resolve(M(W)),this.resolve()}catch(H){this.reject(H)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}[Symbol.asyncIterator](){let M=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(M<this._results.length)return{done:!1,value:this._results[M++]};if(this._state===1)return{done:!0,value:void 0};await s.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(M,W){return new Y(async H=>{for await(const x of M)H.emitOne(W(x))})}map(M){return Y.map(this,M)}static filter(M,W){return new Y(async H=>{for await(const x of M)W(x)&&H.emitOne(x)})}filter(M){return Y.filter(this,M)}static coalesce(M){return Y.filter(M,W=>!!W)}coalesce(){return Y.coalesce(this)}static async toPromise(M){const W=[];for await(const H of M)W.push(H);return W}toPromise(){return Y.toPromise(this)}emitOne(M){this._state===0&&(this._results.push(M),this._onStateChanged.fire())}emitMany(M){this._state===0&&(this._results=this._results.concat(M),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(M){this._state===0&&(this._state=2,this._error=M,this._onStateChanged.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class ae extends Y{constructor(M,W){super(W),this._source=M}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ae;function oe(O){const M=new P.CancellationTokenSource,W=O(M.token);return new ae(M,async H=>{const x=M.token.onCancellationRequested(()=>{x.dispose(),M.dispose(),H.reject(new L.CancellationError)});try{for await(const z of W){if(M.token.isCancellationRequested)return;H.emitOne(z)}x.dispose(),M.dispose()}catch(z){x.dispose(),M.dispose(),H.reject(z)}})}e.createCancelableAsyncIterable=oe}),define(ee[104],te([0,1,24,8,32,35,9,3,25]),function(j,e,P,L,s,A,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function l(){return Object.create(null)}e.getEmptyExpression=l,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const m="[/\\\\]",f="[^/\\\\]",S=/\//g;function d(Q,F){switch(Q){case 0:return"";case 1:return`${f}*?`;default:return`(?:${m}|${f}+${m}${F?`|${m}${f}+`:""})*?`}}function y(Q,F){if(!Q)return[];const N=[];let B=!1,V=!1,Y="";for(const ae of Q){switch(ae){case F:if(!B&&!V){N.push(Y),Y="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":V=!0;break;case"]":V=!1;break}Y+=ae}return Y&&N.push(Y),N}e.splitGlobAware=y;function v(Q){if(!Q)return"";let F="";const N=y(Q,e.GLOB_SPLIT);if(N.every(B=>B===e.GLOBSTAR))F=".*";else{let B=!1;N.forEach((V,Y)=>{if(V===e.GLOBSTAR){if(B)return;F+=d(2,Y===N.length-1)}else{let ae=!1,oe="",O=!1,M="";for(const W of V){if(W!=="}"&&ae){oe+=W;continue}if(O&&(W!=="]"||!M)){let H;W==="-"?H=W:(W==="^"||W==="!")&&!M?H="^":W===e.GLOB_SPLIT?H="":H=(0,h.escapeRegExpCharacters)(W),M+=H;continue}switch(W){case"{":ae=!0;continue;case"[":O=!0;continue;case"}":{const x=`(?:${y(oe,",").map(z=>v(z)).join("|")})`;F+=x,ae=!1,oe="";break}case"]":{F+="["+M+"]",O=!1,M="";break}case"?":F+=f;continue;case"*":F+=d(1);continue;default:F+=(0,h.escapeRegExpCharacters)(W)}}Y<N.length-1&&(N[Y+1]!==e.GLOBSTAR||Y+2<N.length)&&(F+=m)}B=V===e.GLOBSTAR})}return F}const o=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),u=function(){return!1},r=function(){return null};function i(Q,F){if(!Q)return r;let N;typeof Q!="string"?N=Q.pattern:N=Q,N=N.trim();const B=`${N}_${!!F.trimForExclusions}`;let V=t.get(B);if(V)return n(V,Q);let Y;return o.test(N)?V=p(N.substr(4),N):(Y=g.exec(c(N,F)))?V=D(Y[1],N):(F.trimForExclusions?b:a).test(N)?V=k(N,F):(Y=E.exec(c(N,F)))?V=C(Y[1].substr(1),N,!0):(Y=w.exec(c(N,F)))?V=C(Y[1],N,!1):V=_(N),t.set(B,V),n(V,Q)}function n(Q,F){if(typeof F=="string")return Q;const N=function(B,V){return(0,s.isEqualOrParent)(B,F.base,!I.isLinux)?Q((0,h.ltrim)(B.substr(F.base.length),R.sep),V):null};return N.allBasenames=Q.allBasenames,N.allPaths=Q.allPaths,N.basenames=Q.basenames,N.patterns=Q.patterns,N}function c(Q,F){return F.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function p(Q,F){return function(N,B){return typeof N=="string"&&N.endsWith(Q)?F:null}}function D(Q,F){const N=`/${Q}`,B=`\\${Q}`,V=function(ae,oe){return typeof ae!="string"?null:oe?oe===Q?F:null:ae===Q||ae.endsWith(N)||ae.endsWith(B)?F:null},Y=[Q];return V.basenames=Y,V.patterns=[F],V.allBasenames=Y,V}function k(Q,F){const N=le(Q.slice(1,-1).split(",").map(oe=>i(oe,F)).filter(oe=>oe!==r),Q),B=N.length;if(!B)return r;if(B===1)return N[0];const V=function(oe,O){for(let M=0,W=N.length;M<W;M++)if(N[M](oe,O))return Q;return null},Y=N.find(oe=>!!oe.allBasenames);Y&&(V.allBasenames=Y.allBasenames);const ae=N.reduce((oe,O)=>O.allPaths?oe.concat(O.allPaths):oe,[]);return ae.length&&(V.allPaths=ae),V}function C(Q,F,N){const B=R.sep===R.posix.sep,V=B?Q:Q.replace(S,R.sep),Y=R.sep+V,ae=R.posix.sep+Q;let oe;return N?oe=function(O,M){return typeof O=="string"&&(O===V||O.endsWith(Y)||!B&&(O===Q||O.endsWith(ae)))?F:null}:oe=function(O,M){return typeof O=="string"&&(O===V||!B&&O===Q)?F:null},oe.allPaths=[(N?"*/":"./")+Q],oe}function _(Q){try{const F=new RegExp(`^${v(Q)}$`);return function(N){return F.lastIndex=0,typeof N=="string"&&F.test(N)?Q:null}}catch{return r}}function T(Q,F,N){return!Q||typeof F!="string"?!1:U(Q)(F,void 0,N)}e.match=T;function U(Q,F={}){if(!Q)return u;if(typeof Q=="string"||q(Q)){const N=i(Q,F);if(N===r)return u;const B=function(V,Y){return!!N(V,Y)};return N.allBasenames&&(B.allBasenames=N.allBasenames),N.allPaths&&(B.allPaths=N.allPaths),B}return ne(Q,F)}e.parse=U;function q(Q){const F=Q;return F?typeof F.base=="string"&&typeof F.pattern=="string":!1}e.isRelativePattern=q;function se(Q){return Q.allBasenames||[]}e.getBasenameTerms=se;function ie(Q){return Q.allPaths||[]}e.getPathTerms=ie;function ne(Q,F){const N=le(Object.getOwnPropertyNames(Q).map(oe=>ue(oe,Q[oe],F)).filter(oe=>oe!==r)),B=N.length;if(!B)return r;if(!N.some(oe=>!!oe.requiresSiblings)){if(B===1)return N[0];const oe=function(W,H){let x;for(let z=0,$=N.length;z<$;z++){const K=N[z](W,H);if(typeof K=="string")return K;(0,L.isThenable)(K)&&(x||(x=[]),x.push(K))}return x?(async()=>{for(const z of x){const $=await z;if(typeof $=="string")return $}return null})():null},O=N.find(W=>!!W.allBasenames);O&&(oe.allBasenames=O.allBasenames);const M=N.reduce((W,H)=>H.allPaths?W.concat(H.allPaths):W,[]);return M.length&&(oe.allPaths=M),oe}const V=function(oe,O,M){let W,H;for(let x=0,z=N.length;x<z;x++){const $=N[x];$.requiresSiblings&&M&&(O||(O=(0,R.basename)(oe)),W||(W=O.substr(0,O.length-(0,R.extname)(oe).length)));const K=$(oe,O,W,M);if(typeof K=="string")return K;(0,L.isThenable)(K)&&(H||(H=[]),H.push(K))}return H?(async()=>{for(const x of H){const z=await x;if(typeof z=="string")return z}return null})():null},Y=N.find(oe=>!!oe.allBasenames);Y&&(V.allBasenames=Y.allBasenames);const ae=N.reduce((oe,O)=>O.allPaths?oe.concat(O.allPaths):oe,[]);return ae.length&&(V.allPaths=ae),V}function ue(Q,F,N){if(F===!1)return r;const B=i(Q,N);if(B===r)return r;if(typeof F=="boolean")return B;if(F){const V=F.when;if(typeof V=="string"){const Y=(ae,oe,O,M)=>{if(!M||!B(ae,oe))return null;const W=V.replace("$(basename)",()=>O),H=M(W);return(0,L.isThenable)(H)?H.then(x=>x?Q:null):H?Q:null};return Y.requiresSiblings=!0,Y}}return B}function le(Q,F){const N=Q.filter(oe=>!!oe.basenames);if(N.length<2)return Q;const B=N.reduce((oe,O)=>{const M=O.basenames;return M?oe.concat(M):oe},[]);let V;if(F){V=[];for(let oe=0,O=B.length;oe<O;oe++)V.push(F)}else V=N.reduce((oe,O)=>{const M=O.patterns;return M?oe.concat(M):oe},[]);const Y=function(oe,O){if(typeof oe!="string")return null;if(!O){let W;for(W=oe.length;W>0;W--){const H=oe.charCodeAt(W-1);if(H===47||H===92)break}O=oe.substr(W)}const M=B.indexOf(O);return M!==-1?V[M]:null};Y.basenames=B,Y.patterns=V,Y.allBasenames=B;const ae=Q.filter(oe=>!oe.basenames);return ae.push(Y),ae}function G(Q,F){return(0,P.equals)(Q,F,(N,B)=>typeof N=="string"&&typeof B=="string"?N===B:typeof N!="string"&&typeof B!="string"?N.base===B.base&&N.pattern===B.pattern:!1)}e.patternsEquals=G}),define(ee[46],te([0,1,24,32,9,3,19,25]),function(j,e,P,L,s,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function h(i,n){const{os:c,tildify:p,relative:D}=n;if(D){const _=l(i,D,c);if(typeof _=="string")return _}let k=i.fsPath;if(c===1&&!A.isWindows?k=k.replace(/\//g,"\\"):c!==1&&A.isWindows&&(k=k.replace(/\\/g,"/")),c!==1&&p?.userHome){const _=p.userHome.fsPath;let T;i.scheme!==p.userHome.scheme&&i.path.startsWith(s.posix.sep)?T=p.userHome.with({path:i.path}).fsPath:T=i.fsPath,k=S(T,_,c)}return(c===1?s.win32:s.posix).normalize(m(k,c===1))}e.getPathLabel=h;function l(i,n,c){const p=c===1?s.win32:s.posix,D=c===3?R.extUri:R.extUriIgnorePathCase,k=n.getWorkspace(),C=(0,P.firstOrDefault)(k.folders);if(!C)return;i.scheme!==C.uri.scheme&&i.path.startsWith(s.posix.sep)&&(i=C.uri.with({path:i.path}));const _=n.getWorkspaceFolder(i);if(!_)return;let T;if(D.isEqual(_.uri,i)?T="":T=D.relativePath(_.uri,i)??"",T&&(T=p.normalize(T)),k.folders.length>1&&!n.noPrefix){const U=_.name?_.name:D.basenameOrAuthority(_.uri);T=T?`${U} \u2022 ${T}`:U}return T}function m(i,n=A.isWindows){return(0,L.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=m;let f=Object.create(null);function S(i,n,c=A.OS){if(c===1||!i||!n)return i;let p=f.original===n?f.normalized:void 0;p||(p=n,A.isWindows&&(p=(0,L.toSlashes)(p)),p=`${(0,I.rtrim)(p,s.posix.sep)}${s.posix.sep}`,f={original:n,normalized:p});let D=i;return A.isWindows&&(D=(0,L.toSlashes)(D)),(c===3?D.startsWith(p):(0,I.startsWithIgnoreCase)(D,p))?`~/${D.substr(p.length)}`:i}e.tildify=S;function d(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=d;const y="\u2026",v="\\\\",o="~";function g(i,n=s.sep){const c=new Array(i.length);let p=!1;for(let D=0;D<i.length;D++){const k=i[D];if(k===""){c[D]=`.${n}`;continue}if(!k){c[D]=k;continue}p=!0;let C="",_=k;_.indexOf(v)===0?(C=_.substr(0,_.indexOf(v)+v.length),_=_.substr(_.indexOf(v)+v.length)):_.indexOf(n)===0?(C=_.substr(0,_.indexOf(n)+n.length),_=_.substr(_.indexOf(n)+n.length)):_.indexOf(o)===0&&(C=_.substr(0,_.indexOf(o)+o.length),_=_.substr(_.indexOf(o)+o.length));const T=_.split(n);for(let U=1;p&&U<=T.length;U++)for(let q=T.length-U;p&&q>=0;q--){p=!1;let se=T.slice(q,q+U).join(n);for(let ie=0;!p&&ie<i.length;ie++)if(ie!==D&&i[ie]&&i[ie].indexOf(se)>-1){const ne=q+U===T.length,ue=q>0&&i[ie].indexOf(n)>-1?n+se:se,le=i[ie].endsWith(ue);p=!ne||le}if(!p){let ie="";(T[0].endsWith(":")||C!=="")&&(q===1&&(q=0,U++,se=T[0]+n+se),q>0&&(ie=T[0]+n),ie=C+ie),q>0&&(ie=ie+y+n),ie=ie+se,q+U<T.length&&(ie=ie+n+y),c[D]=ie}}p&&(c[D]=k)}return c}e.shorten=g;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function b(i,n=Object.create(null)){const c=[];let p=!1,D="";for(const k of i)if(k==="$"||p&&k==="{")D&&c.push({value:D,type:a.TEXT}),D="",p=!0;else if(k==="}"&&p){const C=n[D];if(typeof C=="string")C.length&&c.push({value:C,type:a.VARIABLE});else if(C){const _=c[c.length-1];(!_||_.type!==a.SEPARATOR)&&c.push({value:C.label,type:a.SEPARATOR})}D="",p=!1}else D+=k;return D&&!p&&c.push({value:D,type:a.TEXT}),c.filter((k,C)=>{if(k.type===a.SEPARATOR){const _=c[C-1],T=c[C+1];return[_,T].every(U=>U&&(U.type===a.VARIABLE||U.type===a.TEXT)&&U.value.length>0)}return!0}).map(k=>k.value).join("")}e.template=b;function E(i,n){return A.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function w(i,n){return A.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):A.isWindows?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function u(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const c=r(i.substring(0,n));return{name:c.name,parentPath:c.parentPath+i.substring(n)}}}return r(i)}e.splitRecentLabel=u;function r(i){const n=i.indexOf("/")!==-1?s.posix:s.win32,c=n.basename(i),p=n.dirname(i);return c.length?{name:c,parentPath:p}:{name:p,parentPath:""}}}),define(ee[153],te([0,1,17,7]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function s(f){return f.toJSON()}class A{constructor(S){this._uriTransformer=S}transformIncoming(S){const d=this._uriTransformer.transformIncoming(S);return d===S?S:s(L.URI.from(d))}transformOutgoing(S){const d=this._uriTransformer.transformOutgoing(S);return d===S?S:s(L.URI.from(d))}transformOutgoingURI(S){const d=this._uriTransformer.transformOutgoing(S);return d===S?S:L.URI.from(d)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(f){return f}transformOutgoing(f){return f}transformOutgoingURI(f){return f}transformOutgoingScheme(f){return f}};function R(f,S,d){if(!f||d>200)return null;if(typeof f=="object"){if(f instanceof L.URI)return S.transformOutgoing(f);for(const y in f)if(Object.hasOwnProperty.call(f,y)){const v=R(f[y],S,d+1);v!==null&&(f[y]=v)}}return null}function I(f,S){const d=R(f,S,0);return d===null?f:d}e.transformOutgoingURIs=I;function h(f,S,d,y){if(!f||y>200)return null;if(typeof f=="object"){if(f.$mid===1)return d?L.URI.revive(S.transformIncoming(f)):S.transformIncoming(f);if(f instanceof P.VSBuffer)return null;for(const v in f)if(Object.hasOwnProperty.call(f,v)){const o=h(f[v],S,d,y+1);o!==null&&(f[v]=o)}}return null}function l(f,S){const d=h(f,S,!1,0);return d===null?f:d}e.transformIncomingURIs=l;function m(f,S){const d=h(f,S,!0,0);return d===null?f:d}e.transformAndReviveIncomingURIs=m}),define(ee[22],te([0,1,42,27,154,8,32,84,9,3,19,7]),function(j,e,P,L,s,A,R,I,h,l,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(ne){ne[ne.UNLINK=0]="UNLINK",ne[ne.MOVE=1]="MOVE"})(S||(e.RimRafMode=S={}));async function d(ne,ue=S.UNLINK,le){if((0,R.isRootOrDriveLetter)(ne))throw new Error("rimraf - will refuse to recursively delete root");return ue===S.UNLINK?v(ne):y(ne,le)}async function y(ne,ue=(0,R.randomPath)((0,L.tmpdir)())){try{try{await P.promises.rename(ne,ue)}catch(le){return le.code==="ENOENT"?void 0:v(ne)}v(ue).catch(le=>{})}catch(le){if(le.code!=="ENOENT")throw le}}async function v(ne){return(0,s.promisify)(P.rm)(ne,{recursive:!0,force:!0,maxRetries:3})}function o(ne){if((0,R.isRootOrDriveLetter)(ne))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(ne,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=o;async function g(ne,ue){return E(await(ue?a(ne):(0,s.promisify)(P.readdir)(ne)))}async function a(ne){try{return await(0,s.promisify)(P.readdir)(ne,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const ue=[],le=await g(ne);for(const G of le){let Q=!1,F=!1,N=!1;try{const B=await e.Promises.lstat((0,h.join)(ne,G));Q=B.isFile(),F=B.isDirectory(),N=B.isSymbolicLink()}catch(B){console.warn("[node.js fs] unexpected error from lstat after readdir: ",B)}ue.push({name:G,isFile:()=>Q,isDirectory:()=>F,isSymbolicLink:()=>N})}return ue}function b(ne){return E(P.readdirSync(ne))}e.readdirSync=b;function E(ne){return ne.map(ue=>typeof ue=="string"?l.isMacintosh?(0,I.normalizeNFC)(ue):ue:(ue.name=l.isMacintosh?(0,I.normalizeNFC)(ue.name):ue.name,ue))}async function w(ne){const ue=await g(ne),le=[];for(const G of ue)await u.existsDirectory((0,h.join)(ne,G))&&le.push(G);return le}function t(ne,ue=1e3){return new Promise(le=>{let G=!1;const Q=setInterval(()=>{G||(G=!0,P.access(ne,F=>{G=!1,F&&(clearInterval(Q),le(void 0))}))},ue)})}e.whenDeleted=t;var u;(function(ne){async function ue(Q){let F;try{if(F=await e.Promises.lstat(Q),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(Q),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(l.isWindows&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Q)),symbolicLink:{dangling:!1}}}catch(B){if(B.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw B}throw N}}ne.stat=ue;async function le(Q){try{const{stat:F,symbolicLink:N}=await ne.stat(Q);return F.isFile()&&N?.dangling!==!0}catch{}return!1}ne.existsFile=le;async function G(Q){try{const{stat:F,symbolicLink:N}=await ne.stat(Q);return F.isDirectory()&&N?.dangling!==!0}catch{}return!1}ne.existsDirectory=G})(u||(e.SymlinkSupport=u={}));const r=new A.ResourceQueue;function i(ne,ue,le){return r.queueFor(f.URI.file(ne),m.extUriBiasedIgnorePathCase).queue(()=>{const G=k(le);return new Promise((Q,F)=>p(ne,ue,G,N=>N?F(N):Q()))})}let n=!0;function c(ne){n=ne}e.configureFlushOnWrite=c;function p(ne,ue,le,G){if(!n)return P.writeFile(ne,ue,{mode:le.mode,flag:le.flag},G);P.open(ne,le.flag,le.mode,(Q,F)=>{if(Q)return G(Q);P.writeFile(F,ue,N=>{if(N)return P.close(F,()=>G(N));P.fdatasync(F,B=>(B&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",B),c(!1)),P.close(F,V=>G(V))))})})}function D(ne,ue,le){const G=k(le);if(!n)return P.writeFileSync(ne,ue,{mode:G.mode,flag:G.flag});const Q=P.openSync(ne,G.flag,G.mode);try{P.writeFileSync(Q,ue);try{P.fdatasyncSync(Q)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),c(!1)}}finally{P.closeSync(Q)}}e.writeFileSync=D;function k(ne){return ne?{mode:typeof ne.mode=="number"?ne.mode:438,flag:typeof ne.flag=="string"?ne.flag:"w"}:{mode:438,flag:"w"}}async function C(ne,ue){if(ne!==ue)try{await e.Promises.rename(ne,ue)}catch(le){if(ne.toLowerCase()!==ue.toLowerCase()&&le.code==="EXDEV"||ne.endsWith("."))await _(ne,ue,{preserveSymlinks:!1}),await d(ne,S.MOVE);else throw le}}async function _(ne,ue,le){return U(ne,ue,{root:{source:ne,target:ue},options:le,handledSourcePaths:new Set})}const T=511;async function U(ne,ue,le){if(le.handledSourcePaths.has(ne))return;le.handledSourcePaths.add(ne);const{stat:G,symbolicLink:Q}=await u.stat(ne);if(Q){if(le.options.preserveSymlinks)try{return await ie(ne,ue,le)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(Q.dangling)return}return G.isDirectory()?q(ne,ue,G.mode&T,le):se(ne,ue,G.mode&T)}async function q(ne,ue,le,G){await e.Promises.mkdir(ue,{recursive:!0,mode:le});const Q=await g(ne);for(const F of Q)await U((0,h.join)(ne,F),(0,h.join)(ue,F),G)}async function se(ne,ue,le){await e.Promises.copyFile(ne,ue),await e.Promises.chmod(ue,le)}async function ie(ne,ue,le){let G=await e.Promises.readlink(ne);(0,R.isEqualOrParent)(G,le.root.source,!l.isLinux)&&(G=(0,h.join)(le.root.target,G.substr(le.root.source.length+1))),await e.Promises.symlink(G,ue)}e.Promises=new class{get access(){return(0,s.promisify)(P.access)}get stat(){return(0,s.promisify)(P.stat)}get lstat(){return(0,s.promisify)(P.lstat)}get utimes(){return(0,s.promisify)(P.utimes)}get read(){return(ne,ue,le,G,Q)=>new Promise((F,N)=>{P.read(ne,ue,le,G,Q,(B,V,Y)=>B?N(B):F({bytesRead:V,buffer:Y}))})}get readFile(){return(0,s.promisify)(P.readFile)}get write(){return(ne,ue,le,G,Q)=>new Promise((F,N)=>{P.write(ne,ue,le,G,Q,(B,V,Y)=>B?N(B):F({bytesWritten:V,buffer:Y}))})}get appendFile(){return(0,s.promisify)(P.appendFile)}get fdatasync(){return(0,s.promisify)(P.fdatasync)}get truncate(){return(0,s.promisify)(P.truncate)}get rename(){return(0,s.promisify)(P.rename)}get copyFile(){return(0,s.promisify)(P.copyFile)}get open(){return(0,s.promisify)(P.open)}get close(){return(0,s.promisify)(P.close)}get symlink(){return(0,s.promisify)(P.symlink)}get readlink(){return(0,s.promisify)(P.readlink)}get chmod(){return(0,s.promisify)(P.chmod)}get mkdir(){return(0,s.promisify)(P.mkdir)}get unlink(){return(0,s.promisify)(P.unlink)}get rmdir(){return(0,s.promisify)(P.rmdir)}get realpath(){return(0,s.promisify)(P.realpath)}async exists(ne){try{return await e.Promises.access(ne),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return w}get writeFile(){return i}get rm(){return d}get move(){return C}get copy(){return _}}}),define(ee[105],te([0,1,42,9,3,25,22]),function(j,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(S){if(s.isLinux)return S;const d=(0,L.dirname)(S);if(S===d)return S;const y=((0,L.basename)(S)||S).toLowerCase();try{const o=(0,R.readdirSync)(d).filter(g=>g.toLowerCase()===y);if(o.length===1){const g=I(d);if(g)return(0,L.join)(g,o[0])}else if(o.length>1){const g=o.indexOf(y);if(g>=0){const a=I(d);if(a)return(0,L.join)(a,o[g])}}}catch{}return null}e.realcaseSync=I;async function h(S){if(s.isLinux)return S;const d=(0,L.dirname)(S);if(S===d)return S;const y=((0,L.basename)(S)||S).toLowerCase();try{const o=(await R.Promises.readdir(d)).filter(g=>g.toLowerCase()===y);if(o.length===1){const g=await h(d);if(g)return(0,L.join)(g,o[0])}else if(o.length>1){const g=o.indexOf(y);if(g>=0){const a=await h(d);if(a)return(0,L.join)(a,o[g])}}}catch{}return null}e.realcase=h;async function l(S){try{return await R.Promises.realpath(S)}catch{const y=f(S);return await R.Promises.access(y,P.constants.R_OK),y}}e.realpath=l;function m(S){try{return P.realpathSync(S)}catch{const y=f(S);return P.accessSync(y,P.constants.R_OK),y}}e.realpathSync=m;function f(S){return(0,A.rtrim)((0,L.normalize)(S),L.sep)}}),define(ee[106],te([0,1,27,9,22]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,R=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var h;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(h||(h={}));let l;switch(process.arch){case"ia32":case"x32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class f{constructor(w,t,u){this.exePath=w,this.displayName=t,this.knownToExist=u}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await s.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:E=!1}={}){return E?l===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:E=!1,findPreview:w=!1}={}){const t=S({useAlternateBitness:E});if(!t)return null;const u=L.join(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(u))return null;let r=-1,i=null;for(const p of await s.Promises.readdir(u)){let D=-1;if(w){const C=p.indexOf("-");if(C<0)continue;const _=p.substring(0,C);if(!A.test(_)||p.substring(C+1)!=="preview")continue;D=parseInt(_,10)}else{if(!A.test(p))continue;D=parseInt(p,10)}if(D<=r)continue;const k=L.join(u,p,"pwsh.exe");await s.SymlinkSupport.existsFile(k)&&(i=k,r=D)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",c=w?" Preview":"";return new f(i,`PowerShell${c}${n}`,!0)}async function y({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const w=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(w))return null;const{pwshMsixDirRegex:t,pwshMsixName:u}=E?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(w))if(t.test(r)){const i=L.join(w,r,"pwsh.exe");return new f(i,u)}return null}function v(){const E=L.join(P.homedir(),".dotnet","tools","pwsh.exe");return new f(E,".NET Core PowerShell Global Tool")}function o(){const E=L.join(process.env.windir,l===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new f(E,"Windows PowerShell",!0)}async function*g(){let E=await d();E&&(yield E),E=await d({useAlternateBitness:!0}),E&&(yield E),E=await y(),E&&(yield E),E=v(),E&&(yield E),E=await d({findPreview:!0}),E&&(yield E),E=await y({findPreview:!0}),E&&(yield E),E=await d({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=o(),E&&(yield E)}async function*a(){for await(const E of g())await E.exists()&&(yield E)}e.enumeratePowerShellInstallations=a;async function b(){for await(const E of a())return E;return null}e.getFirstAvailablePowerShellInstallation=b}),define(ee[88],te([0,1,9,3,36,72,11,22]),function(j,e,P,L,s,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function h(f=s.env){return f.comspec||"cmd.exe"}e.getWindowsShell=h;function l(f){let S=[],d=!1;const y=function(v){if(d){S.push(v);return}(!f.send(v,g=>{if(g&&console.error(g),d=!1,S.length>0){const a=S.slice(0);S=[],a.forEach(b=>y(b))}})||L.isWindows)&&(d=!0)};return{send:y}}e.createQueuedSender=l;var m;(function(f){async function S(d,y,v){if(P.isAbsolute(d))return d;if(y===void 0&&(y=s.cwd()),P.dirname(d)!=="."||(v===void 0&&R.isString(s.env.PATH)&&(v=s.env.PATH.split(P.delimiter)),v===void 0||v.length===0))return P.join(y,d);async function g(a){if(await I.Promises.exists(a)){let b;try{b=await I.Promises.stat(a)}catch(E){E.message.startsWith("EACCES")&&(b=await I.Promises.lstat(a))}return b?!b.isDirectory():!1}return!1}for(const a of v){let b;if(P.isAbsolute(a)?b=P.join(a,d):b=P.join(y,a,d),await g(b))return b;let E=b+".com";if(await g(E)||(E=b+".exe",await g(E)))return E}return P.join(y,d)}f.findExecutable=S})(m||(e.win32=m={}))}),define(ee[107],te([0,1,47,15]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function s(R){return new Promise((I,h)=>{let l;const m=new Map;function f(d,y,v,o,g){const a=m.get(y);if(d===R||a){const b={name:S(v),cmd:v,pid:d,ppid:y,load:o,mem:g};m.set(d,b),d===R&&(l=b),a&&(a.children||(a.children=[]),a.children.push(b),a.children.length>1&&(a.children=a.children.sort((E,w)=>E.pid-w.pid)))}}function S(d){const y=/--utility-sub-type=network/i,v=/--ms-enable-electron-run-as-node/i,o=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,a=/conhost\.exe.+--headless/i,b=/--type=([a-zA-Z-]+)/;if(o.exec(d))return"electron-crash-reporter";if(g.exec(d))return"winpty-agent";if(a.exec(d))return"conpty-agent";let E=b.exec(d);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?y.exec(d)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const w=/[a-zA-Z-]+\.js/g;let t="";do E=w.exec(d),E&&(t+=E+" ");while(E);return t&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${t})`:v.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,v)=>{j(["@vscode/windows-process-tree"],y,v)}).then(y=>{y.getProcessList(R,v=>{if(!v){h(new Error(`Root process ${R} not found`));return}y.getProcessCpuUsage(v,o=>{const g=new Map;o.forEach(a=>{const b=d(a.commandLine||"");g.set(a.pid,{name:S(b),cmd:b,pid:a.pid,ppid:a.ppid,load:a.cpu||0,mem:a.memory||0})}),l=g.get(R),l?(g.forEach(a=>{const b=g.get(a.ppid);b&&(b.children||(b.children=[]),b.children.push(a))}),g.forEach(a=>{a.children&&(a.children=a.children.sort((b,E)=>b.pid-E.pid))}),I(l)):h(new Error(`Root process ${R} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let d=function(){let y=[l];const v=[];for(;y.length;){const g=y.shift();g&&(v.push(g.pid),g.children&&(y=y.concat(g.children)))}let o=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);o+=" "+v.join(" "),(0,P.exec)(o,{},(g,a,b)=>{if(g||b)h(g||new Error(b.toString()));else{const E=a.toString().split(`
`);for(let w=0;w<v.length;w++){const t=m.get(v[w]);t.load=parseFloat(E[w])}if(!l){h(new Error(`Root process ${R} not found`));return}I(l)}})};(0,P.exec)("which ps",{},(y,v,o)=>{if(y||o)if(process.platform!=="linux")h(y||new Error(o.toString()));else{const g=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(g,{},(a,b,E)=>{a||E?h(a||new Error(E.toString())):(A(b,f),d())})}else{const g=v.toString().trim(),a="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${g} ${a}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(b,E,w)=>{b||w&&!w.includes("screen size is bogus")?h(b||new Error(w.toString())):(A(E,f),process.platform==="linux"?d():l?I(l):h(new Error(`Root process ${R} not found`)))})}})}})}e.listProcesses=s;function A(R,I){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=R.toString().split(`
`);for(const m of l){const f=h.exec(m.trim());f&&f.length===6&&I(parseInt(f[1]),parseInt(f[2]),f[5],parseFloat(f[3]),parseFloat(f[4]))}}}),define(ee[155],te([0,1,27,3,106,88]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function R(f,S){return f===1?L.isWindows?m():A.getWindowsShell(S):h(f,S)}e.getSystemShell=R;let I=null;function h(f,S){if(L.isLinux&&f===2||L.isMacintosh&&f===3)return"/bin/bash";if(!I){let d;if(L.isWindows)d="/bin/bash";else{if(d=S.SHELL,!d)try{d=(0,P.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}I=d}return I}let l=null;async function m(){return l||(l=(await(0,s.getFirstAvailablePowerShellInstallation)()).exePath),l}});var Se=this&&this.__decorate||function(j,e,P,L){var s=arguments.length,A=s<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,P):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(j,e,P,L);else for(var I=j.length-1;I>=0;I--)(R=j[I])&&(A=(s<3?R(A):s>3?R(e,P,A):R(e,P))||A);return s>3&&A&&Object.defineProperty(e,P,A),A};define(ee[43],te([0,1,24,8,17,21,55,13,4,2,73,25,11]),function(j,e,P,L,s,A,R,I,h,l,m,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(d||(d={}));function y(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(v||(v={}));function o(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(g||(g={}));function a(F){let N=0;for(let B=0;;B+=7){const V=F.read(1);if(N|=(V.buffer[0]&127)<<B,!(V.buffer[0]&128))return N}}const b=r(0);function E(F,N){if(N===0){F.write(b);return}let B=0;for(let Y=N;Y!==0;Y=Y>>>7)B++;const V=s.VSBuffer.alloc(B);for(let Y=0;N!==0;Y++)V.buffer[Y]=N&127,N=N>>>7,N>0&&(V.buffer[Y]|=128);F.write(V)}class w{constructor(N){this.buffer=N,this.pos=0}read(N){const B=this.buffer.slice(this.pos,this.pos+N);return this.pos+=B.byteLength,B}}e.BufferReader=w;class t{constructor(){this.buffers=[]}get buffer(){return s.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}e.BufferWriter=t;var u;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object",F[F.Int=6]="Int"})(u||(u={}));function r(F){const N=s.VSBuffer.alloc(1);return N.writeUInt8(F,0),N}const i={Undefined:r(u.Undefined),String:r(u.String),Buffer:r(u.Buffer),VSBuffer:r(u.VSBuffer),Array:r(u.Array),Object:r(u.Object),Uint:r(u.Int)},n=typeof Buffer<"u";function c(F,N){if(typeof N>"u")F.write(i.Undefined);else if(typeof N=="string"){const B=s.VSBuffer.fromString(N);F.write(i.String),E(F,B.byteLength),F.write(B)}else if(n&&Buffer.isBuffer(N)){const B=s.VSBuffer.wrap(N);F.write(i.Buffer),E(F,B.byteLength),F.write(B)}else if(N instanceof s.VSBuffer)F.write(i.VSBuffer),E(F,N.byteLength),F.write(N);else if(Array.isArray(N)){F.write(i.Array),E(F,N.length);for(const B of N)c(F,B)}else if(typeof N=="number"&&(N|0)===N)F.write(i.Uint),E(F,N);else{const B=s.VSBuffer.fromString(JSON.stringify(N));F.write(i.Object),E(F,B.byteLength),F.write(B)}}e.serialize=c;function p(F){switch(F.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return F.read(a(F)).toString();case u.Buffer:return F.read(a(F)).buffer;case u.VSBuffer:return F.read(a(F));case u.Array:{const B=a(F),V=[];for(let Y=0;Y<B;Y++)V.push(p(F));return V}case u.Object:return JSON.parse(F.read(a(F)).toString());case u.Int:return a(F)}}e.deserialize=p;class D{constructor(N,B,V=null,Y=1e3){this.protocol=N,this.ctx=B,this.logger=V,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ae=>this.onRawMessage(ae)),this.sendResponse({type:200})}registerChannel(N,B){this.channels.set(N,B),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const B=this.send([N.type]);this.logger?.logOutgoing(B,0,1,o(N.type));return}case 201:case 202:case 204:case 203:{const B=this.send([N.type,N.id],N.data);this.logger?.logOutgoing(B,N.id,1,o(N.type),N.data);return}}}send(N,B=void 0){const V=new t;return c(V,N),c(V,B),this.sendBuffer(V.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch{return 0}}onRawMessage(N){const B=new w(N),V=p(B),Y=p(B),ae=V[0];switch(ae){case 100:return this.logger?.logIncoming(N.byteLength,V[1],1,`${y(ae)}: ${V[2]}.${V[3]}`,Y),this.onPromise({type:ae,id:V[1],channelName:V[2],name:V[3],arg:Y});case 102:return this.logger?.logIncoming(N.byteLength,V[1],1,`${y(ae)}: ${V[2]}.${V[3]}`,Y),this.onEventListen({type:ae,id:V[1],channelName:V[2],name:V[3],arg:Y});case 101:return this.logger?.logIncoming(N.byteLength,V[1],1,`${y(ae)}`),this.disposeActiveRequest({type:ae,id:V[1]});case 103:return this.logger?.logIncoming(N.byteLength,V[1],1,`${y(ae)}`),this.disposeActiveRequest({type:ae,id:V[1]})}}onPromise(N){const B=this.channels.get(N.channelName);if(!B){this.collectPendingRequest(N);return}const V=new A.CancellationTokenSource;let Y;try{Y=B.call(this.ctx,N.name,N.arg,V.token)}catch(O){Y=Promise.reject(O)}const ae=N.id;Y.then(O=>{this.sendResponse({id:ae,data:O,type:201}),this.activeRequests.delete(N.id)},O=>{O instanceof Error?this.sendResponse({id:ae,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.sendResponse({id:ae,data:O,type:203}),this.activeRequests.delete(N.id)});const oe=(0,l.toDisposable)(()=>V.cancel());this.activeRequests.set(N.id,oe)}onEventListen(N){const B=this.channels.get(N.channelName);if(!B){this.collectPendingRequest(N);return}const V=N.id,ae=B.listen(this.ctx,N.name,N.arg)(oe=>this.sendResponse({id:V,data:oe,type:204}));this.activeRequests.set(N.id,ae)}disposeActiveRequest(N){const B=this.activeRequests.get(N.id);B&&(B.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let B=this.pendingRequests.get(N.channelName);B||(B=[],this.pendingRequests.set(N.channelName,B));const V=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);B.push({request:N,timeoutTimer:V})}flushPendingRequests(N){const B=this.pendingRequests.get(N);if(B){for(const V of B)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=D;var k;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class C{constructor(N,B=null){this.protocol=N,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=B}getChannel(N){const B=this;return{call(V,Y,ae){return B.isDisposed?Promise.reject(new I.CancellationError):B.requestPromise(N,V,Y,ae)},listen(V,Y){return B.isDisposed?h.Event.None:B.requestEvent(N,V,Y)}}}requestPromise(N,B,V,Y=A.CancellationToken.None){const ae=this.lastRequestId++,O={id:ae,type:100,channelName:N,name:B,arg:V};if(Y.isCancellationRequested)return Promise.reject(new I.CancellationError);let M;return new Promise((H,x)=>{if(Y.isCancellationRequested)return x(new I.CancellationError);const z=()=>{const ce=ge=>{switch(ge.type){case 201:this.handlers.delete(ae),H(ge.data);break;case 202:{this.handlers.delete(ae);const ke=new Error(ge.data.message);ke.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,ke.name=ge.data.name,x(ke);break}case 203:this.handlers.delete(ae),x(ge.data);break}};this.handlers.set(ae,ce),this.sendRequest(O)};let $=null;this.state===g.Idle?z():($=(0,L.createCancelablePromise)(ce=>this.whenInitialized()),$.then(()=>{$=null,z()}));const K=()=>{$?($.cancel(),$=null):this.sendRequest({id:ae,type:101}),x(new I.CancellationError)},re=Y.onCancellationRequested(K);M=(0,l.combinedDisposable)((0,l.toDisposable)(K),re),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(N,B,V){const Y=this.lastRequestId++,oe={id:Y,type:102,channelName:N,name:B,arg:V};let O=null;const M=new h.Emitter({onWillAddFirstListener:()=>{O=(0,L.createCancelablePromise)(H=>this.whenInitialized()),O.then(()=>{O=null,this.activeRequests.add(M),this.sendRequest(oe)})},onDidRemoveLastListener:()=>{O?(O.cancel(),O=null):(this.activeRequests.delete(M),this.sendRequest({id:Y,type:103}))}}),W=H=>M.fire(H.data);return this.handlers.set(Y,W),M.event}sendRequest(N){switch(N.type){case 100:case 102:{const B=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger?.logOutgoing(B,N.id,0,`${y(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const B=this.send([N.type,N.id]);this.logger?.logOutgoing(B,N.id,0,y(N.type));return}}}send(N,B=void 0){const V=new t;return c(V,N),c(V,B),this.sendBuffer(V.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch{return 0}}onBuffer(N){const B=new w(N),V=p(B),Y=p(B),ae=V[0];switch(ae){case 200:return this.logger?.logIncoming(N.byteLength,0,0,o(ae)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(N.byteLength,V[1],0,o(ae),Y),this.onResponse({type:V[0],id:V[1],data:Y})}}onResponse(N){if(N.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}this.handlers.get(N.id)?.(N)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=C,Se([R.memoize],C.prototype,"onDidInitializePromise",null);class _{get connections(){const N=[];return this._connections.forEach(B=>N.push(B)),N}constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:B,onDidClientDisconnect:V})=>{h.Event.once(B.onMessage)(ae=>{const oe=new w(ae),O=p(oe),M=new D(B,O),W=new C(B);this.channels.forEach((x,z)=>M.registerChannel(z,x));const H={channelServer:M,channelClient:W,ctx:O};this._connections.add(H),this._onDidAddConnection.fire(H),V(()=>{M.dispose(),W.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)})})})}getChannel(N,B){const V=this;return{call(Y,ae,oe){let O;if((0,S.isFunction)(B)){const W=(0,P.getRandomElement)(V.connections.filter(B));O=W?Promise.resolve(W):h.Event.toPromise(h.Event.filter(V.onDidAddConnection,B))}else O=B.routeCall(V,Y,ae);const M=O.then(W=>W.channelClient.getChannel(N));return U(M).call(Y,ae,oe)},listen(Y,ae){if((0,S.isFunction)(B))return V.getMulticastEvent(N,B,Y,ae);const oe=B.routeEvent(V,Y,ae).then(O=>O.channelClient.getChannel(N));return U(oe).listen(Y,ae)}}}getMulticastEvent(N,B,V,Y){const ae=this;let oe=new l.DisposableStore;const O=new h.Emitter({onWillAddFirstListener:()=>{oe=new l.DisposableStore;const M=new h.EventMultiplexer,W=new Map,H=z=>{const K=z.channelClient.getChannel(N).listen(V,Y),re=M.add(K);W.set(z,re)},x=z=>{const $=W.get(z);$&&($.dispose(),W.delete(z))};ae.connections.filter(B).forEach(H),h.Event.filter(ae.onDidAddConnection,B)(H,void 0,oe),ae.onDidRemoveConnection(x,void 0,oe),M.event(O.fire,O,oe),oe.add(M)},onDidRemoveLastListener:()=>{oe.dispose()}});return O.event}registerChannel(N,B){this.channels.set(N,B),this._connections.forEach(V=>{V.channelServer.registerChannel(N,B)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class T{constructor(N,B,V=null){const Y=new t;c(Y,B),N.send(Y.buffer),this.channelClient=new C(N,V),this.channelServer=new D(N,B,V)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,B){this.channelServer.registerChannel(N,B)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function U(F){return{call(N,B,V){return F.then(Y=>Y.call(N,B,V))},listen(N,B){const V=new h.Relay;return F.then(Y=>V.input=Y.listen(N,B)),V.event}}}e.getDelayedChannel=U;function q(F){let N=!1;return{call(B,V,Y){return N?F.call(B,V,Y):(0,L.timeout)(0).then(()=>N=!0).then(()=>F.call(B,V,Y))},listen(B,V){if(N)return F.listen(B,V);const Y=new h.Relay;return(0,L.timeout)(0).then(()=>N=!0).then(()=>Y.input=F.listen(B,V)),Y.event}}}e.getNextTickChannel=q;class se{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const B of N.connections)if(await Promise.resolve(this.fn(B.ctx)))return Promise.resolve(B);return await h.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=se;var ie;(function(F){function N(ae,oe){const O=ae,M=oe&&oe.disableMarshalling,W=new Map;for(const H in O)V(H)&&W.set(H,h.Event.buffer(O[H],!0));return new class{listen(H,x,z){const $=W.get(x);if($)return $;if(Y(x)){const K=O[x];if(typeof K=="function")return K.call(O,z)}throw new Error(`Event not found: ${x}`)}call(H,x,z){const $=O[x];if(typeof $=="function"){if(!M&&Array.isArray(z))for(let K=0;K<z.length;K++)z[K]=(0,m.revive)(z[K]);return $.apply(O,z)}throw new Error(`Method not found: ${x}`)}}}F.fromService=N;function B(ae,oe){const O=oe&&oe.disableMarshalling;return new Proxy({},{get(M,W){if(typeof W=="string")return oe?.properties?.has(W)?oe.properties.get(W):Y(W)?function(H){return ae.listen(W,H)}:V(W)?ae.listen(W):async function(...H){let x;oe&&!(0,S.isUndefinedOrNull)(oe.context)?x=[oe.context,...H]:x=H;const z=await ae.call(W,x);return O?z:(0,m.revive)(z)};throw new Error(`Property not found: ${String(W)}`)}})}F.toService=B;function V(ae){return ae[0]==="o"&&ae[1]==="n"&&f.isUpperAsciiLetter(ae.charCodeAt(2))}function Y(ae){return/^onDynamic/.test(ae)&&f.isUpperAsciiLetter(ae.charCodeAt(9))}})(ie||(e.ProxyChannel=ie={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const N=F.toString();if(N!=="[object Object]")return N}return F}function le(F){return Array.isArray(F)?F.map(ue):ue(F)}function G(F,N,B,V,Y,ae,oe){oe=le(oe);const O=ne[Y],M=O[V%O.length];let W=[`%c[${F}]%c[${String(N).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(ae)?(W=W.concat(oe),W.push(")")):W.push(oe),console.log.apply(console,W)}class Q{constructor(N,B){this._outgoingPrefix=N,this._incomingPrefix=B,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,B,V,Y,ae){this._totalOutgoing+=N,G(this._outgoingPrefix,this._totalOutgoing,N,B,V,Y,ae)}logIncoming(N,B,V,Y,ae){this._totalIncoming+=N,G(this._incomingPrefix,this._totalIncoming,N,B,V,Y,ae)}}e.IPCLogger=Q}),define(ee[156],te([0,1,17,4,43]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(h){this.port=h,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",l=>P.VSBuffer.wrap(l.data)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=A;class R extends s.IPCClient{constructor(h,l){const m=new A(h);super(m,l),this.protocol=m}dispose(){this.protocol.disconnect()}}e.Client=R}),define(ee[108],te([0,1,17,4,2,43]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var I;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let c=0;function p(k,C){if(!n.has(k)){const _=String(++c);n.set(k,_)}return n.get(k)}function D(k,C,_,T){if(!i.enableDiagnostics)return;const U=p(k,C);if(T instanceof P.VSBuffer||T instanceof Uint8Array||T instanceof ArrayBuffer||ArrayBuffer.isView(T)){const q=P.VSBuffer.alloc(T.byteLength);q.set(T),i.records.push({timestamp:Date.now(),id:U,label:C,type:_,buff:q})}else i.records.push({timestamp:Date.now(),id:U,label:C,type:_,data:T})}i.traceSocketEvent=D})(I||(e.SocketDiagnostics=I={}));var h;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let l=null;function m(){return l||(l=P.VSBuffer.alloc(0)),l}class f{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,c){if(n===0)return m();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const C=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=n),C}if(this._chunks[0].byteLength>n){const C=this._chunks[0].slice(0,n);return c&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),C}const p=P.VSBuffer.alloc(n);let D=0,k=0;for(;n>0;){const C=this._chunks[k];if(C.byteLength>n){const _=C.slice(0,n);p.set(_,D),D+=n,c&&(this._chunks[k]=C.slice(n),this._totalLength-=n),n-=n}else p.set(C,D),D+=C.byteLength,c?(this._chunks.shift(),this._totalLength-=C.byteLength):k++,n-=C.byteLength}return p}}e.ChunkStream=f;var S;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(S||(S={}));function d(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class v{constructor(n,c,p,D){this.type=n,this.id=c,this.ack=p,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class o extends s.Disposable{constructor(n){super(),this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new f,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:d(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const p=this._state.messageType,D=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new v(p,D,k,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=P.VSBuffer.alloc(13);c.writeUInt8(n.type,0),c.writeUInt32BE(n.id,1),c.writeUInt32BE(n.ack,5),c.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:d(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(c,n.data)}_bufferAdd(n,c){const p=this._totalLength===0;return this._data.push(n,c),this._totalLength+=n.byteLength+c.byteLength,p}_bufferTake(){const n=P.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,c){this._bufferAdd(n,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class a extends s.Disposable{constructor(n){super(),this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new o(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new v(1,0,0,n))}}e.Protocol=a;class b extends A.IPCClient{static fromSocket(n,c){return new b(new a(n),c)}get onDidDispose(){return this.protocol.onDidDispose}constructor(n,c,p=null){super(n,c,p),this.protocol=n}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=b;class E{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=E;class w{constructor(n){this.data=n,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let n=0,c=this._first;for(;c;)c=c.next,n++;return n}peek(){return this._first?this._first.data:null}toArray(){const n=[];let c=0,p=this._first;for(;p;)n[c++]=p.data,p=p.next;return n}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const c=new w(n);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class u{static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}constructor(){this.lastRuns=[];const n=Date.now();for(let c=0;c<u._HISTORY_LENGTH;c++)this.lastRuns[c]=n-1e3*c;setInterval(()=>{for(let c=u._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}load(){const n=Date.now(),c=(1+u._HISTORY_LENGTH)*1e3;let p=0;for(let D=0;D<u._HISTORY_LENGTH;D++)n-this.lastRuns[D]<=c&&p++;return 1-p/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}u._HISTORY_LENGTH=10,u._INSTANCE=null;class r{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(n){this._onControlMessage=new E,this.onControlMessage=this._onControlMessage.event,this._onMessage=new E,this.onMessage=this._onMessage.event,this._onDidDispose=new E,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new E,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new E,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=n.loadEstimator??u.getInstance(),this._shouldSendKeepAlive=n.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new s.DisposableStore,this._socket=n.socket,this._socketWriter=this._socketDisposables.add(new g(this._socket)),this._socketReader=this._socketDisposables.add(new o(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.add(this._socket.onClose(c=>this._onSocketClose.fire(c))),n.initialChunk&&this._socketReader.acceptChunk(n.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new v(5,0,0,m());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new v(7,0,0,m());this._socketWriter.write(n)}sendResume(){const n=new v(8,0,0,m());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,c){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new s.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=this._socketDisposables.add(new g(this._socket)),this._socketReader=this._socketDisposables.add(new o(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.add(this._socket.onClose(p=>this._onSocketClose.fire(p))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new v(3,0,this._incomingAckId,m());this._socketWriter.write(n);const c=this._outgoingUnackMsg.toArray();for(let p=0,D=c.length;p<D;p++)this._socketWriter.write(c[p]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new v(6,0,0,m())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let p=0,D=c.length;p<D;p++)this._socketWriter.write(c[p]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const p=new v(1,c,this._incomingAckId,n);this._outgoingUnackMsg.push(p),this._isReconnecting||(this._socketWriter.write(p),this._recvAckCheck())}sendControl(n){const c=new v(2,0,0,n);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),c=Date.now()-n.writtenTime,p=Date.now()-this._socketReader.lastReadTime,D=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&p>=2e4&&D>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:p});return}const k=Math.max(2e4-c,2e4-p,2e4-D,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},k)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new v(3,0,this._incomingAckId,m());this._socketWriter.write(n)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const n=new v(9,0,this._incomingAckId,m());this._socketWriter.write(n)}}e.PersistentProtocol=r}),define(ee[157],te([0,1,38,17,4,2,43,144]),function(j,e,P,L,s,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(m,f){const S=s.Event.fromNodeEventEmitter(P.validatedIpcMain,f,(y,v)=>({event:y,message:v})),d=s.Event.filter(S,({event:y})=>y.sender.id===m);return s.Event.map(d,({message:y})=>y&&L.VSBuffer.wrap(y))}class l extends R.IPCServer{static getOnDidClientConnect(){const f=s.Event.fromNodeEventEmitter(P.validatedIpcMain,"vscode:hello",({sender:S})=>S);return s.Event.map(f,S=>{const d=S.id;l.Clients.get(d)?.dispose();const v=new s.Emitter;l.Clients.set(d,(0,A.toDisposable)(()=>v.fire()));const o=h(d,"vscode:message"),g=s.Event.any(s.Event.signal(h(d,"vscode:disconnect")),v.event);return{protocol:new I.Protocol(S,o),onDidClientDisconnect:g}})}constructor(){super(l.getOnDidClientConnect())}}e.Server=l,l.Clients=new Map}),define(ee[109],te([0,1,38,4,31,156]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class R extends A.Client{constructor(l,m){super({addEventListener:(f,S)=>l.addListener(f,S),removeEventListener:(f,S)=>l.removeListener(f,S),postMessage:f=>l.postMessage(f),start:()=>l.start(),close:()=>l.close()},m)}}e.Client=R;async function I(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,s.generateUuid)();h.webContents.send("vscode:createMessageChannel",l);const m=L.Event.fromNodeEventEmitter(P.validatedIpcMain,"vscode:createMessageChannelResult",(S,d)=>({nonce:d,port:S.ports[0]})),{port:f}=await L.Event.toPromise(L.Event.once(L.Event.filter(m,S=>S.nonce===l)));return f}e.connect=I}),define(ee[158],te([0,1,47,8,17,21,152,13,4,2,37,88,72,43]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends d.ChannelServer{constructor(g){super({send:a=>{try{process.send?.(a.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",a=>s.VSBuffer.wrap(Buffer.from(a,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.Server=y;class v{constructor(g,a){this.modulePath=g,this.options=a,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const b=a&&a.timeout?a.timeout:6e4;this.disposeDelayer=new L.Delayer(b),this.child=null,this._client=null}getChannel(g){const a=this;return{call(b,E,w){return a.requestPromise(g,b,E,w)},listen(b,E){return a.requestEvent(g,b,E)}}}requestPromise(g,a,b,E=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const w=this.getCachedChannel(g),t=(0,L.createCancelablePromise)(i=>w.call(a,b,i)),u=E.onCancellationRequested(()=>t.cancel()),r=(0,l.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{u.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(g,a,b){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let E;const w=new h.Emitter({onWillAddFirstListener:()=>{E=this.getCachedChannel(g).listen(a,b)(w.fire,w),this.activeRequests.add(E)},onDidRemoveLastListener:()=>{this.activeRequests.delete(E),E.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return w.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],a=Object.create(null);a.env={...(0,m.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(a.env={...a.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(a.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,S.removeDangerousEnvVariables)(a.env),this.child=(0,P.fork)(this.modulePath,g,a);const b=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,R.isRemoteConsoleLog)(n)){(0,R.log)(n,`IPC Library: ${this.options.serverName}`);return}b.fire(s.VSBuffer.wrap(Buffer.from(n,"base64")))});const w=this.options.useQueue?(0,f.createQueuedSender)(this.child):this.child,t=n=>this.child&&this.child.connected&&w.send(n.buffer.toString("base64")),u=b.event,r={send:t,onMessage:u};this._client=new d.ChannelClient(r);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,c)=>{process.removeListener("exit",i),this.activeRequests.forEach(p=>(0,l.dispose)(p)),this.activeRequests.clear(),n!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:c})})}return this._client}getCachedChannel(g){let a=this.channels.get(g);return a||(a=this.client.getChannel(g),this.channels.set(g,a)),a}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=v}),define(ee[110],te([0,1,8,4,2,73,11]),function(j,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var I;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function h(S){const d=S;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=h;var l;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(l||(e.StorageState=l={}));class m extends s.Disposable{constructor(d,y=Object.create(null)){super(),this.database=d,this.options=y,this._onDidChangeStorage=this._register(new L.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new P.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){this._onDidChangeStorage.pause();try{d.changed?.forEach((y,v)=>this.acceptExternal(v,y)),d.deleted?.forEach(y=>this.acceptExternal(y,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(d,y){if(this.state===l.Closed)return;let v=!1;(0,R.isUndefinedOrNull)(y)?v=this.cache.delete(d):this.cache.get(d)!==y&&(this.cache.set(d,y),v=!0),v&&this._onDidChangeStorage.fire({key:d,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,y){const v=this.cache.get(d);return(0,R.isUndefinedOrNull)(v)?y:v}getBoolean(d,y){const v=this.get(d);return(0,R.isUndefinedOrNull)(v)?y:v==="true"}getNumber(d,y){const v=this.get(d);return(0,R.isUndefinedOrNull)(v)?y:parseInt(v,10)}getObject(d,y){const v=this.get(d);return(0,R.isUndefinedOrNull)(v)?y:(0,A.parse)(v)}async set(d,y,v=!1){if(this.state===l.Closed)return;if((0,R.isUndefinedOrNull)(y))return this.delete(d,v);const o=(0,R.isObject)(y)||Array.isArray(y)?(0,A.stringify)(y):String(y);if(this.cache.get(d)!==o)return this.cache.set(d,o),this.pendingInserts.set(d,o),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire({key:d,external:v}),this.doFlush()}async delete(d,y=!1){if(!(this.state===l.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire({key:d,external:y}),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}isInMemory(){return this.options.hint===I.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class f{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert?.forEach((y,v)=>this.items.set(v,y)),d.delete?.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=f}),define(ee[159],te([0,1,8,4,35,9,22]),function(j,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{get onDidChangeItemsExternal(){return L.Event.None}constructor(m,f=Object.create(null)){this.path=m,this.options=f,this.name=(0,A.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const m=await this.whenConnected,f=new Map;return(await this.all(m,"SELECT * FROM ItemTable")).forEach(d=>f.set(d.key,d.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${f.size} rows`),f}async updateItems(m){const f=await this.whenConnected;return this.doUpdateItems(f,m)}doUpdateItems(m,f){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${f.insert?(0,s.mapToString)(f.insert):"0"}), delete(${f.delete?(0,s.setToString)(f.delete):"0"})`),this.transaction(m,()=>{const S=f.insert,d=f.delete;if(S&&S.size>0){const y=[];y.push([]);let v=0;S.forEach((o,g)=>{let a=y[v];a.length>I.MAX_HOST_PARAMETERS&&(v++,a=[],y.push(a)),a.push(g,o)}),y.forEach(o=>{this.prepare(m,`INSERT INTO ItemTable VALUES ${new Array(o.length/2).fill("(?,?)").join(",")}`,g=>g.run(o),()=>{const g=[];let a=0;return S.forEach((b,E)=>{g.push(E),a+=b.length}),`Keys: ${g.join(", ")} Length: ${a}`})})}if(d&&d.size){const y=[];y.push([]);let v=0;d.forEach(o=>{let g=y[v];g.length>I.MAX_HOST_PARAMETERS&&(v++,g=[],y.push(g)),g.push(o)}),y.forEach(o=>{this.prepare(m,`DELETE FROM ItemTable WHERE key IN (${new Array(o.length).fill("?").join(",")})`,g=>g.run(o),()=>{const g=[];return d.forEach(a=>{g.push(a)}),`Keys: ${g.join(", ")}`})})}})}async close(m){this.logger.trace(`[storage ${this.name}] close()`);const f=await this.whenConnected;return this.doClose(f,m)}doClose(m,f){return new Promise((S,d)=>{m.db.close(y=>(y&&this.handleSQLiteError(m,`[storage ${this.name}] close(): ${y}`),this.path===I.IN_MEMORY_PATH?S():!m.isErroneous&&!m.isInMemory?this.backup().then(S,v=>(this.logger.error(`[storage ${this.name}] backup(): ${v}`),S())):typeof f=="function"?R.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(v=>{const o=()=>this.doClose(v,void 0);return this.doUpdateItems(v,{insert:f()}).then(()=>o(),g=>(o(),Promise.reject(g)))})).then(S,d):d(y||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const m=this.toBackupPath(this.path);return R.Promises.copy(this.path,m,{preserveSymlinks:!1})}toBackupPath(m){return`${m}.backup`}async checkIntegrity(m){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${m})`);const f=await this.whenConnected,S=await this.get(f,m?"PRAGMA integrity_check":"PRAGMA quick_check"),d=m?S.integrity_check:S.quick_check;return f.isErroneous?`${d} (last error: ${f.lastError})`:f.isInMemory?`${d} (in-memory!)`:d}async connect(m,f=!0){this.logger.trace(`[storage ${this.name}] open(${m}, retryOnBusy: ${f})`);try{return await this.doConnect(m)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&f)return await(0,P.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(m,!1);try{await R.Promises.unlink(m);try{await R.Promises.rename(this.toBackupPath(m),m)}catch{}return await this.doConnect(m)}catch(d){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${d}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(m,f){m.isErroneous=!0,m.lastError=f,this.logger.error(f)}doConnect(m){return new Promise((f,S)=>{new Promise((d,y)=>{j(["@vscode/sqlite3"],d,y)}).then(d=>{const y={db:new(this.logger.isTracing?d.verbose().Database:d.Database)(m,v=>v?y.db&&v.code!=="SQLITE_CANTOPEN"?y.db.close(()=>S(v)):S(v):this.exec(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>f(y),o=>y.db.close(()=>S(o)))),isInMemory:m===I.IN_MEMORY_PATH};y.db.on("error",v=>this.handleSQLiteError(y,`[storage ${this.name}] Error (event): ${v}`)),this.logger.isTracing&&y.db.on("trace",v=>this.logger.trace(`[storage ${this.name}] Trace (event): ${v}`))},S)})}exec(m,f){return new Promise((S,d)=>{m.db.exec(f,y=>y?(this.handleSQLiteError(m,`[storage ${this.name}] exec(): ${y}`),d(y)):S())})}get(m,f){return new Promise((S,d)=>{m.db.get(f,(y,v)=>y?(this.handleSQLiteError(m,`[storage ${this.name}] get(): ${y}`),d(y)):S(v))})}all(m,f){return new Promise((S,d)=>{m.db.all(f,(y,v)=>y?(this.handleSQLiteError(m,`[storage ${this.name}] all(): ${y}`),d(y)):S(v))})}transaction(m,f){return new Promise((S,d)=>{m.db.serialize(()=>{m.db.run("BEGIN TRANSACTION"),f(),m.db.run("END TRANSACTION",y=>y?(this.handleSQLiteError(m,`[storage ${this.name}] transaction(): ${y}`),d(y)):S())})})}prepare(m,f,S,d){const y=m.db.prepare(f),v=o=>{this.handleSQLiteError(m,`[storage ${this.name}] prepare(): ${o} (${f}). Details: ${d()}`)};y.on("error",v),S(y),y.finalize(o=>{o&&v(o),y.removeListener("error",v)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.BUSY_OPEN_TIMEOUT=2e3,I.MAX_HOST_PARAMETERS=256;class h{constructor(m){m&&typeof m.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=m.logTrace),m&&typeof m.logError=="function"&&(this.logError=m.logError)}get isTracing(){return!!this.logTrace}trace(m){this.logTrace?.(m)}error(m){this.logError?.(m)}}h.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[160],te([12,10]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(ee[161],te([12,10]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[162],te([12,10]),function(j,e){return j.create("vs/platform/contextkey/common/contextkey",e)}),define(ee[163],te([12,10]),function(j,e){return j.create("vs/platform/contextkey/common/scanner",e)}),define(ee[164],te([12,10]),function(j,e){return j.create("vs/platform/dialogs/common/dialogs",e)}),define(ee[165],te([12,10]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[166],te([12,10]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(ee[167],te([12,10]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(ee[168],te([12,10]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[169],te([12,10]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[170],te([12,10]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[171],te([12,10]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[172],te([12,10]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[173],te([12,10]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(ee[174],te([12,10]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(ee[175],te([12,10]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(ee[176],te([12,10]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[177],te([12,10]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[178],te([12,10]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[179],te([12,10]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[180],te([12,10]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[181],te([12,10]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(ee[182],te([12,10]),function(j,e){return j.create("vs/platform/shell/node/shellEnv",e)}),define(ee[183],te([12,10]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[184],te([12,10]),function(j,e){return j.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ee[185],te([12,10]),function(j,e){return j.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ee[186],te([12,10]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[187],te([12,10]),function(j,e){return j.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[188],te([12,10]),function(j,e){return j.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[189],te([12,10]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[190],te([12,10]),function(j,e){return j.create("vs/platform/workspace/common/workspace",e)}),define(ee[191],te([12,10]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[192],te([12,10]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[193],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function P(s){return s&&s.hasOwnProperty("folderUri")}e.isFolderBackupInfo=P;function L(s){return s&&s.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=L}),define(ee[194],te([0,1,7]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function L(R){return typeof R?.backupFolder=="string"}e.isEmptyWindowBackupInfo=L;function s(R){let I=[];try{Array.isArray(R.workspaces)&&(I=R.workspaces.map(h=>({workspace:{id:h.id,configPath:P.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return I}e.deserializeWorkspaceInfos=s;function A(R){let I=[];try{Array.isArray(R.folders)&&(I=R.folders.map(h=>({folderUri:P.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return I}e.deserializeFolderInfos=A}),define(ee[195],te([0,1,13,163]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var s;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(s||(e.TokenType=s={}));function A(...l){switch(l.length){case 1:return(0,L.localize)(0,null,l[0]);case 2:return(0,L.localize)(1,null,l[0],l[1]);case 3:return(0,L.localize)(2,null,l[0],l[1],l[2]);default:return}}const R=(0,L.localize)(3,null),I=(0,L.localize)(4,null);class h{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(m){switch(m.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return m.isTripleEq?"===":"==";case 4:return m.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return m.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return m.lexeme;case 18:return m.lexeme;case 19:return m.lexeme;case 20:return"EOF";default:throw(0,P.illegalState)(`unhandled token type: ${JSON.stringify(m)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(m){return this._input=m,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const f=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:f})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const f=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:f})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(m){return this._isAtEnd()||this._input.charCodeAt(this._current)!==m?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(m){this._tokens.push({type:m,offset:this._start})}_error(m){const f=this._start,S=this._input.substring(this._start,this._current),d={type:19,offset:this._start,lexeme:S};this._errors.push({offset:f,lexeme:S,additionalInfo:m}),this._tokens.push(d)}_string(){this.stringRe.lastIndex=this._start;const m=this.stringRe.exec(this._input);if(m){this._current=this._start+m[0].length;const f=this._input.substring(this._start,this._current),S=h._keywords.get(f);S?this._addToken(S):this._tokens.push({type:17,lexeme:f,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let m=this._current,f=!1,S=!1;for(;;){if(m>=this._input.length){this._current=m,this._error(I);return}const y=this._input.charCodeAt(m);if(f)f=!1;else if(y===47&&!S){m++;break}else y===91?S=!0:y===92?f=!0:y===93&&(S=!1);m++}for(;m<this._input.length&&h._regexFlags.has(this._input.charCodeAt(m));)m++;this._current=m;const d=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:d,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=h,h._regexFlags=new Set(["i","g","s","m","y","u"].map(l=>l.charCodeAt(0))),h._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(ee[196],te([0,1,4,2]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class s{constructor(){this._onCloseEmitter=new P.Emitter,this._onReloadEmitter=new P.Emitter,this._onTerminateEmitter=new P.Emitter,this._onAttachEmitter=new P.Emitter}call(I,h,l){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(I,h,l){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=s,s.ChannelName="extensionhostdebugservice";class A extends L.Disposable{constructor(I){super(),this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,h,l){this.channel.call("attach",[I,h,l])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,h){this.channel.call("terminate",[I,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,h){return this.channel.call("openExtensionDevelopmentHostWindow",[I,h])}}e.ExtensionHostDebugChannelClient=A}),define(ee[197],te([0,1,147,55,15,9,36,19,7]),function(j,e,P,L,s,A,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,A.dirname)(s.FileAccess.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",d)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(h.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=R.env.VSCODE_PORTABLE;return d?h.URI.file((0,A.join)(d,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,A.resolve)(d):(0,A.normalize)((0,A.join)(s.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?h.URI.file((0,A.resolve)(d)):h.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,A.resolve)(d);const y=R.env.VSCODE_EXTENSIONS;if(y)return y;const v=R.env.VSCODE_PORTABLE;return v?(0,A.join)(v,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(y=>/^[^:/?#]+?:\/\//.test(y)?h.URI.parse(y):h.URI.file((0,A.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?h.URI.parse(d):h.URI.file((0,A.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const y of this.args.log||[]){const v=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);v&&v[1]&&v[2]&&d.push([v[1],v[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=R.env.VSCODE_PORTABLE;return d?h.URI.file((0,A.join)(d,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this._args}constructor(d,y,v){this._args=d,this.paths=y,this.productService=v,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=l,Se([L.memoize],l.prototype,"appRoot",null),Se([L.memoize],l.prototype,"userHome",null),Se([L.memoize],l.prototype,"userDataPath",null),Se([L.memoize],l.prototype,"appSettingsHome",null),Se([L.memoize],l.prototype,"tmpDir",null),Se([L.memoize],l.prototype,"cacheHome",null),Se([L.memoize],l.prototype,"stateResource",null),Se([L.memoize],l.prototype,"userRoamingDataHome",null),Se([L.memoize],l.prototype,"userDataSyncHome",null),Se([L.memoize],l.prototype,"sync",null),Se([L.memoize],l.prototype,"machineSettingsResource",null),Se([L.memoize],l.prototype,"workspaceStorageHome",null),Se([L.memoize],l.prototype,"localHistoryHome",null),Se([L.memoize],l.prototype,"keyboardLayoutResource",null),Se([L.memoize],l.prototype,"argvResource",null),Se([L.memoize],l.prototype,"isExtensionDevelopment",null),Se([L.memoize],l.prototype,"untitledWorkspacesHome",null),Se([L.memoize],l.prototype,"builtinExtensionsPath",null),Se([L.memoize],l.prototype,"extensionsPath",null),Se([L.memoize],l.prototype,"extensionDevelopmentLocationURI",null),Se([L.memoize],l.prototype,"extensionDevelopmentKind",null),Se([L.memoize],l.prototype,"extensionTestsLocationURI",null),Se([L.memoize],l.prototype,"debugExtensionHost",null),Se([L.memoize],l.prototype,"logLevel",null),Se([L.memoize],l.prototype,"extensionLogLevel",null),Se([L.memoize],l.prototype,"serviceMachineIdResource",null),Se([L.memoize],l.prototype,"disableTelemetry",null),Se([L.memoize],l.prototype,"disableWorkspaceTrust",null),Se([L.memoize],l.prototype,"policyFile",null);function m(S,d){return f(S["inspect-extensions"],S["inspect-brk-extensions"],5870,d,S.debugId,S.extensionEnvironment)}e.parseExtensionHostDebugPort=m;function f(S,d,y,v,o,g){const b=Number(d||S)||(v?null:y),E=b?!!d:!1;let w;if(g)try{w=JSON.parse(g)}catch{}return{port:b,break:E,debugId:o,env:w}}e.parseDebugParams=f}),define(ee[111],te([0,1,306,3,166]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(33,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(v,o,g=R){const a=v.find(c=>c.length>0&&c[0]!=="-"),b={},E=["_"],w=[],t={};let u;for(const c in o){const p=o[c];p.type==="subcommand"?c===a&&(u=p):(p.alias&&(b[c]=p.alias),p.type==="string"||p.type==="string[]"?(E.push(c),p.deprecates&&E.push(...p.deprecates)):p.type==="boolean"&&(w.push(c),p.deprecates&&w.push(...p.deprecates)),p.global&&(t[c]=p))}if(u&&a){const c=t;for(const C in u.options)c[C]=u.options[C];const p=v.filter(C=>C!==a),D=g.getSubcommandReporter?g.getSubcommandReporter(a):void 0,k=I(p,c,D);return{[a]:k,_:[]}}const r=P(v,{string:E,boolean:w,alias:b}),i={},n=r;i._=r._.map(c=>String(c)).filter(c=>c.length>0),delete n._;for(const c in o){const p=o[c];if(p.type==="subcommand")continue;p.alias&&delete n[p.alias];let D=n[c];if(p.deprecates)for(const k of p.deprecates)n.hasOwnProperty(k)&&(D||(D=n[k],D&&g.onDeprecatedOption(k,p.deprecationMessage||(0,s.localize)(36,null,c))),delete n[k]);if(typeof D<"u"){if(p.type==="string[]"){if(Array.isArray(D)||(D=[D]),!p.allowEmptyValue){const k=D.filter(C=>C.length>0);k.length!==D.length&&(g.onEmptyValue(c),D=k.length>0?k:void 0)}}else p.type==="string"&&(Array.isArray(D)?(D=D.pop(),g.onMultipleValues(c,D)):!D&&!p.allowEmptyValue&&(g.onEmptyValue(c),D=void 0));i[c]=D,p.deprecationMessage&&g.onDeprecatedOption(c,p.deprecationMessage)}delete n[c]}for(const c in n)g.onUnknownOption(c);return i}e.parseArgs=I;function h(v,o){let g="";return o.args&&(Array.isArray(o.args)?g=` <${o.args.join("> <")}>`:g=` <${o.args}>`),o.alias?`-${o.alias} --${v}${g}`:`--${v}${g}`}function l(v,o){const g=[];for(const a in v){const b=v[a],E=h(a,b);g.push([E,b.description])}return m(g,o)}e.formatOptions=l;function m(v,o){const a=v.reduce((w,t)=>Math.max(w,t[0].length),12)+2+1;if(o-a<25)return v.reduce((w,t)=>w.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const b=o-a-1,E=[];for(const w of v){const t=w[0],u=S(w[1],b),r=f(a-t.length-2);E.push("  "+t+r+u[0]);for(let i=1;i<u.length;i++)E.push(f(a)+u[i])}return E}function f(v){return" ".repeat(v)}function S(v,o){const g=[];for(;v.length;){const a=v.length<o?v.length:v.lastIndexOf(" ",o),b=v.slice(0,a).trim();v=v.slice(a),g.push(b)}return g}function d(v,o,g,a,b){const E=process.stdout.isTTY&&process.stdout.columns||80,w=b?.noInputFiles!==!0?`[${(0,s.localize)(37,null)}...]`:"",t=[`${v} ${g}`];t.push(""),t.push(`${(0,s.localize)(38,null)}: ${o} [${(0,s.localize)(39,null)}]${w}`),t.push(""),b?.noPipe!==!0&&(L.isWindows?t.push((0,s.localize)(40,null,o)):t.push((0,s.localize)(41,null,o)),t.push(""));const u={},r=[];for(const i in a){const n=a[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let c=u[n.cat];c||(u[n.cat]=c={}),c[i]=n}}for(const i in u){const n=i,c=u[n];c&&(t.push(A[n]),t.push(...l(c,E)),t.push(""))}return r.length&&(t.push((0,s.localize)(42,null)),t.push(...m(r.map(i=>[i.command,i.description]),E)),t.push("")),t.join(`
`)}e.buildHelpMessage=d;function y(v,o){return`${v||(0,s.localize)(43,null)}
${o||(0,s.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=y}),define(ee[198],te([0,1,87,196,111]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class A extends L.ExtensionHostDebugBroadcastChannel{constructor(I){super(),this.windowsMainService=I}call(I,h,l){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(l[0],l[1]):super.call(I,h,l)}async openExtensionDevelopmentHostWindow(I,h){const l=(0,s.parseArgs)(I,s.OPTIONS);l.debugRenderer=h;const m=l.extensionDevelopmentPath;if(!m)return{success:!1};const[f]=await this.windowsMainService.openExtensionDevelopmentHostWindow(m,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!h)return{success:!0};const S=f.win;if(!S)return{success:!0};const d=S.webContents.debugger;let y=d.isAttached()?1/0:0;const v=(0,P.createServer)(o=>{y++===0&&d.attach();let g=!1;const a=w=>{g||o.write(JSON.stringify(w)+"\0")},b=(w,t,u,r)=>a({method:t,params:u,sessionId:r});S.on("close",()=>{d.removeListener("message",b),o.end(),g=!0}),d.addListener("message",b);let E=Buffer.alloc(0);o.on("data",w=>{E=Buffer.concat([E,w]);for(let t=E.indexOf(0);t!==-1;t=E.indexOf(0)){let u;try{const r=E.slice(0,t).toString("utf8");E=E.slice(t+1),u=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}d.sendCommand(u.method,u.params,u.sessionId).then(r=>a({id:u.id,sessionId:u.sessionId,result:r})).catch(r=>a({id:u.id,sessionId:u.sessionId,error:{code:0,message:r.message}}))}}),o.on("error",w=>{console.error("error on cdp pipe:",w)}),o.on("close",()=>{g=!0,--y===0&&d.detach()})});return await new Promise(o=>v.listen(0,o)),S.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=A}),define(ee[63],te([0,1,307,167,111]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(f,S){const d=(b,E)=>{console.warn((0,L.localize)(0,null,b,E))},y=b=>{console.warn((0,L.localize)(1,null,b))},v=(b,E)=>{console.warn((0,L.localize)(2,null,b,E))},o=b=>({onUnknownOption:E=>{b!=="tunnel"&&console.warn((0,L.localize)(3,null,E,b))},onMultipleValues:d,onEmptyValue:y,onDeprecatedOption:v,getSubcommandReporter:b!=="tunnel"?o:void 0}),g={onUnknownOption:b=>{console.warn((0,L.localize)(4,null,b))},onMultipleValues:d,onEmptyValue:y,onDeprecatedOption:v,getSubcommandReporter:o},a=(0,s.parseArgs)(f,s.OPTIONS,S?g:void 0);return a.goto&&a._.forEach(b=>P(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,L.localize)(5,null))),a}function R(f){const S=f.findIndex(d=>!/^-/.test(d));if(S>-1)return[...f.slice(0,S),...f.slice(S+1)]}function I(f){let[,...S]=f;process.env.VSCODE_DEV&&(S=R(S)||[]);const d=!m(process.env);return A(S,d)}e.parseMainProcessArgv=I;function h(f){let[,,...S]=f;return process.env.VSCODE_DEV&&(S=R(S)||[]),A(S,!0)}e.parseCLIProcessArgv=h;function l(f,...S){const d=f.indexOf("--");return d===-1?f.push(...S):f.splice(d,0,...S),f}e.addArg=l;function m(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=m}),function(){"use strict";function j(e,P,L){function s(R,I){const h=A(R,I),l=[h];return e.isAbsolute(h)||l.unshift(L),e.resolve(...l)}function A(R,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,I);const m=R["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const f=process.env.USERPROFILE;if(typeof f!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(f,"AppData","Roaming")}break;case"darwin":l=e.join(P.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,I)}return{getUserDataPath:s}}if(typeof define=="function")define(ee[199],te([112,27,36]),function(e,P,L){return j(e,P,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=j(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[89],te([0,1,27,197,199]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends L.AbstractNativeEnvironmentService{constructor(l,m){super(l,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,s.getUserDataPath)(l,m.nameShort)},m)}}e.NativeEnvironmentService=A;function R(h,l){return(0,L.parseDebugParams)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,l,h.extensionEnvironment)}e.parsePtyHostDebugPort=R;function I(h,l){return(0,L.parseDebugParams)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,l,h.extensionEnvironment)}e.parseSharedProcessDebugPort=I}),define(ee[200],te([0,1,42,27,32]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function A(R){const I=(0,s.randomPath)((0,L.tmpdir)());try{return(0,P.writeFileSync)(I,""),R&&console.log(`Marker file for --wait created: ${I}`),I}catch(h){R&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFileSync=A}),define(ee[201],te([0,1,11,169]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function s(R,I,h){try{A(R,I,h)}catch(l){console.error(l?.message??l)}return R}e.localizeManifest=s;function A(R,I,h){const l=(m,f,S)=>{const d=m[f];if((0,P.isString)(d)){const y=d,v=y.length;if(v>1&&y[0]==="%"&&y[v-1]==="%"){const o=y.substr(1,v-2);let g=I[o];g===void 0&&h&&(g=h[o]);const a=typeof g=="string"?g:g?.message,b=h?.[o],E=typeof b=="string"?b:b?.message;if(!a){E||console.warn(`[${R.name}]: ${(0,L.localize)(0,null,o)}`);return}if(S&&(f==="title"||f==="category")&&E&&E!==a){const w={value:a,original:E};m[f]=w}else m[f]=a}}else if((0,P.isObject)(d))for(const y in d)d.hasOwnProperty(y)&&(y==="commands"?l(d,y,!0):l(d,y,S));else if(Array.isArray(d))for(let y=0;y<d.length;y++)l(d,y,S)};for(const m in R)R.hasOwnProperty(m)&&l(R,m)}}),define(ee[202],te([0,1,19,69,171,203]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function h(g){return g=g.trim(),g==="*"||R.test(g)}e.isValidVersionStr=h;function l(g){if(!h(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=g.match(R);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.parseVersion=l;function m(g){if(!g)return null;const a=g.majorBase,b=g.majorMustEqual,E=g.minorBase;let w=g.minorMustEqual;const t=g.patchBase;let u=g.patchMustEqual;g.hasCaret&&(a===0||(w=!1),u=!1);let r=0;if(g.preRelease){const i=I.exec(g.preRelease);if(i){const[,n,c,p]=i;r=Date.UTC(Number(n),Number(c)-1,Number(p))}}return{majorBase:a,majorMustEqual:b,minorBase:E,minorMustEqual:w,patchBase:t,patchMustEqual:u,isMinimum:g.hasGreaterEquals,notBefore:r}}e.normalizeVersion=m;function f(g,a,b){let E;typeof g=="string"?E=m(l(g)):E=g;let w;a instanceof Date?w=a.getTime():typeof a=="string"&&(w=new Date(a).getTime());let t;if(typeof b=="string"?t=m(l(b)):t=b,!E||!t)return!1;const u=E.majorBase,r=E.minorBase,i=E.patchBase;let n=t.majorBase,c=t.minorBase,p=t.patchBase;const D=t.notBefore;let k=t.majorMustEqual,C=t.minorMustEqual,_=t.patchMustEqual;return t.isMinimum?u>n?!0:u<n?!1:r>c?!0:r<c||w&&w<D?!1:i>=p:(u===1&&n===0&&(!k||!C||!_)&&(n=1,c=0,p=0,k=!0,C=!1,_=!1),u<n?!1:u>n?!k:r<c?!1:r>c?!C:i<p?!1:i>p?!_:!(w&&w<D))}e.isValidVersion=f;function S(g,a,b,E,w){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([L.default.Error,s.localize(0,null)]),t;if(typeof E.name!="string")return t.push([L.default.Error,s.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([L.default.Error,s.localize(2,null,"version")]),t;if(!E.engines)return t.push([L.default.Error,s.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([L.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!o(E.extensionDependencies))return t.push([L.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!o(E.activationEvents))return t.push([L.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([L.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([L.default.Warning,s.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([L.default.Error,s.localize(9,null,"main")]),t;{const i=(0,P.joinPath)(b,E.main);(0,P.isEqualOrParent)(i,b)||t.push([L.default.Warning,s.localize(10,null,i.path,b.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([L.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,P.joinPath)(b,E.browser);(0,P.isEqualOrParent)(i,b)||t.push([L.default.Warning,s.localize(12,null,i.path,b.path)])}}if(!A.valid(E.version))return t.push([L.default.Error,s.localize(13,null)]),t;const u=[];if(!d(g,a,E,w,u))for(const i of u)t.push([L.default.Error,i]);return t}e.validateExtensionManifest=S;function d(g,a,b,E,w){return E||typeof b.main>"u"&&typeof b.browser>"u"?!0:v(g,a,b.engines.vscode,w)}e.isValidExtensionVersion=d;function y(g,a,b){return g==="*"||v(a,b,g)}e.isEngineValid=y;function v(g,a,b,E=[]){const w=m(l(b));if(!w)return E.push(s.localize(14,null,b)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return E.push(s.localize(15,null,b)),!1}else if(!w.majorMustEqual)return E.push(s.localize(16,null,b)),!1;return f(g,a,w)?!0:(E.push(s.localize(17,null,g,b)),!1)}function o(g){if(!Array.isArray(g))return!1;for(let a=0,b=g.length;a<b;a++)if(typeof g[a]!="string")return!1;return!0}}),define(ee[204],te([0,1,17,31]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function s(A,R,I){let h=I&&I.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const m=(await R.readFile(A.serviceMachineIdResource)).value.toString();h=(0,L.isUUID)(m)?m:null}catch{h=null}if(!h){h=(0,L.generateUuid)();try{await R.writeFile(A.serviceMachineIdResource,P.VSBuffer.fromString(h))}catch{}}return I?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=s}),define(ee[74],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class P{constructor(s,A=[],R=!1){this.ctor=s,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=P}),define(ee[205],te([0,1,74]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var s;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function A(I,h,l){h instanceof P.SyncDescriptor||(h=new P.SyncDescriptor(h,[],!!l)),L.push([I,h])}e.registerSingleton=A;function R(){return L}e.getSingletonServiceDescriptors=R}),define(ee[206],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class P{constructor(A,R){this.key=A,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=P;class L{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const R of this._nodes.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const I=this.lookupOrInsertNode(A),h=this.lookupOrInsertNode(R);I.outgoing.set(h.key,h),h.incoming.set(I.key,I)}removeNode(A){const R=this._hashFn(A);this._nodes.delete(R);for(const I of this._nodes.values())I.outgoing.delete(R),I.incoming.delete(R)}lookupOrInsertNode(A){const R=this._hashFn(A);let I=this._nodes.get(R);return I||(I=new P(R,A),this._nodes.set(R,I)),I}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[R,I]of this._nodes)A.push(`${R}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,R]of this._nodes){const I=new Set([A]),h=this._findCycle(R,I);if(h)return h}}_findCycle(A,R){for(const[I,h]of A.outgoing){if(R.has(I))return[...R,I].join(" -> ");R.add(I);const l=this._findCycle(h,R);if(l)return l;R.delete(I)}}}e.Graph=L}),define(ee[6],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var P;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function I(h){return h[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=I})(P||(e._util=P={})),e.IInstantiationService=s("instantiationService");function L(R,I,h){I[P.DI_TARGET]===I?I[P.DI_DEPENDENCIES].push({id:R,index:h}):(I[P.DI_DEPENDENCIES]=[{id:R,index:h}],I[P.DI_TARGET]=I)}function s(R){if(P.serviceIds.has(R))return P.serviceIds.get(R);const I=function(h,l,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(I,h,m)};return I.toString=()=>R,P.serviceIds.set(R,I),I}e.createDecorator=s;function A(R){return R}e.refineServiceDecorator=A}),define(ee[64],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,P.createDecorator)("backupMainService")}),define(ee[18],te([0,1,11,7,6]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,s.createDecorator)("configurationService");function A(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof L.URI)}e.isConfigurationOverrides=A;function R(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=R;var I;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function h(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function l(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}e.isConfigured=l;function m(g,a){const b=Object.create(null);for(const E in g)f(b,E,g[E],a);return b}e.toValuesTree=m;function f(g,a,b,E){const w=a.split("."),t=w.pop();let u=g;for(let r=0;r<w.length;r++){const i=w[r];let n=u[i];switch(typeof n){case"undefined":n=u[i]=Object.create(null);break;case"object":break;default:E(`Ignoring ${a} as ${w.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}u=n}if(typeof u=="object"&&u!==null)try{u[t]=b}catch{E(`Ignoring ${a} as ${w.join(".")} is ${JSON.stringify(u)}`)}else E(`Ignoring ${a} as ${w.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=f;function S(g,a){const b=a.split(".");d(g,b)}e.removeFromValueTree=S;function d(g,a){const b=a.shift();if(a.length===0){delete g[b];return}if(Object.keys(g).indexOf(b)!==-1){const E=g[b];typeof E=="object"&&!Array.isArray(E)&&(d(E,a),Object.keys(E).length===0&&delete g[b])}}function y(g,a,b){function E(u,r){let i=u;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const w=a.split("."),t=E(g,w);return typeof t>"u"?b:t}e.getConfigurationValue=y;function v(g,a,b){Object.keys(a).forEach(E=>{E!=="__proto__"&&(E in g?P.isObject(g[E])&&P.isObject(a[E])?v(g[E],a[E],b):b&&(g[E]=a[E]):g[E]=a[E])})}e.merge=v;function o(g){return g.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=o}),define(ee[113],te([0,1,3,25,195,6,162,13]),function(j,e,P,L,s,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",P.isMacintosh),h.set("isLinux",P.isLinux),h.set("isWindows",P.isWindows),h.set("isWeb",P.isWeb),h.set("isMacNative",P.isMacintosh&&!P.isWeb),h.set("isEdge",P.isEdge),h.set("isFirefox",P.isFirefox),h.set("isChrome",P.isChrome),h.set("isSafari",P.isSafari);function l(O,M){if(h.get(O)!==void 0)throw(0,I.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(O,M)}e.setConstant=l;const m=Object.prototype.hasOwnProperty;var f;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(f||(e.ContextKeyExprType=f={}));const S={regexParsingWithErrorRecovery:!0},d=(0,R.localize)(0,null),y=(0,R.localize)(1,null),v=(0,R.localize)(2,null),o=(0,R.localize)(3,null),g=(0,R.localize)(4,null),a=(0,R.localize)(5,null),b=(0,R.localize)(6,null),E=(0,R.localize)(7,null);class w{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(M=S){this._config=M,this._scanner=new s.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(M){if(M===""){this._parsingErrors.push({message:d,offset:0,lexeme:"",additionalInfo:y});return}this._tokens=this._scanner.reset(M).scan(),this._current=0,this._parsingErrors=[];try{const W=this._expr();if(!this._isAtEnd()){const H=this._peek(),x=H.type===17?a:void 0;throw this._parsingErrors.push({message:g,offset:H.offset,lexeme:s.Scanner.getLexeme(H),additionalInfo:x}),w._parseError}return W}catch(W){if(W!==w._parseError)throw W;return}}_expr(){return this._or()}_or(){const M=[this._and()];for(;this._matchOne(16);){const W=this._and();M.push(W)}return M.length===1?M[0]:t.or(...M)}_and(){const M=[this._term()];for(;this._matchOne(15);){const W=this._term();M.push(W)}return M.length===1?M[0]:t.and(...M)}_term(){if(this._matchOne(2)){const M=this._peek();switch(M.type){case 11:return this._advance(),n.INSTANCE;case 12:return this._advance(),c.INSTANCE;case 0:{this._advance();const W=this._expr();return this._consume(1,o),W?.negate()}case 17:return this._advance(),T.create(M.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",M)}}return this._primary()}_primary(){const M=this._peek();switch(M.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const W=this._expr();return this._consume(1,o),W}case 17:{const W=M.lexeme;if(this._advance(),this._matchOne(9)){const x=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),x.type!==10)throw this._errExpectedButGot("REGEX",x);const z=x.lexeme,$=z.lastIndexOf("/"),K=$===z.length-1?void 0:this._removeFlagsGY(z.substring($+1));let re;try{re=new RegExp(z.substring(1,$),K)}catch{throw this._errExpectedButGot("REGEX",x)}return ue.create(W,re)}switch(x.type){case 10:case 19:{const z=[x.lexeme];this._advance();let $=this._peek(),K=0;for(let Re=0;Re<x.lexeme.length;Re++)x.lexeme.charCodeAt(Re)===40?K++:x.lexeme.charCodeAt(Re)===41&&K--;for(;!this._isAtEnd()&&$.type!==15&&$.type!==16;){switch($.type){case 0:K++;break;case 1:K--;break;case 10:case 18:for(let Re=0;Re<$.lexeme.length;Re++)$.lexeme.charCodeAt(Re)===40?K++:x.lexeme.charCodeAt(Re)===41&&K--}if(K<0)break;z.push(s.Scanner.getLexeme($)),this._advance(),$=this._peek()}const re=z.join(""),ce=re.lastIndexOf("/"),ge=ce===re.length-1?void 0:this._removeFlagsGY(re.substring(ce+1));let ke;try{ke=new RegExp(re.substring(1,ce),ge)}catch{throw this._errExpectedButGot("REGEX",x)}return t.regex(W,ke)}case 18:{const z=x.lexeme;this._advance();let $=null;if(!(0,L.isFalsyOrWhitespace)(z)){const K=z.indexOf("/"),re=z.lastIndexOf("/");if(K!==re&&K>=0){const ce=z.slice(K+1,re),ge=z[re+1]==="i"?"i":"";try{$=new RegExp(ce,ge)}catch{throw this._errExpectedButGot("REGEX",x)}}}if($===null)throw this._errExpectedButGot("REGEX",x);return ue.create(W,$)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,v);const x=this._value();return t.notIn(W,x)}switch(this._peek().type){case 3:{this._advance();const x=this._value();if(this._previous().type===18)return t.equals(W,x);switch(x){case"true":return t.has(W);case"false":return t.not(W);default:return t.equals(W,x)}}case 4:{this._advance();const x=this._value();if(this._previous().type===18)return t.notEquals(W,x);switch(x){case"true":return t.not(W);case"false":return t.has(W);default:return t.notEquals(W,x)}}case 5:return this._advance(),ie.create(W,this._value());case 6:return this._advance(),ne.create(W,this._value());case 7:return this._advance(),q.create(W,this._value());case 8:return this._advance(),se.create(W,this._value());case 13:return this._advance(),t.in(W,this._value());default:return t.has(W)}}case 20:throw this._parsingErrors.push({message:b,offset:M.offset,lexeme:"",additionalInfo:E}),w._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const M=this._peek();switch(M.type){case 17:case 18:return this._advance(),M.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(M){return M.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(M){return this._check(M)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(M,W){if(this._check(M))return this._advance();throw this._errExpectedButGot(W,this._peek())}_errExpectedButGot(M,W,H){const x=(0,R.localize)(8,null,M,s.Scanner.getLexeme(W)),z=W.offset,$=s.Scanner.getLexeme(W);return this._parsingErrors.push({message:x,offset:z,lexeme:$,additionalInfo:H}),w._parseError}_check(M){return this._peek().type===M}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=w,w._parseError=new Error;class t{static false(){return n.INSTANCE}static true(){return c.INSTANCE}static has(M){return p.create(M)}static equals(M,W){return D.create(M,W)}static notEquals(M,W){return _.create(M,W)}static regex(M,W){return ue.create(M,W)}static in(M,W){return k.create(M,W)}static notIn(M,W){return C.create(M,W)}static not(M){return T.create(M)}static and(...M){return Q.create(M,null,!0)}static or(...M){return F.create(M,null,!0)}static greater(M,W){return q.create(M,W)}static greaterEquals(M,W){return se.create(M,W)}static smaller(M,W){return ie.create(M,W)}static smallerEquals(M,W){return ne.create(M,W)}static deserialize(M){return M==null?void 0:this._parser.parse(M)}}e.ContextKeyExpr=t,t._parser=new w({regexParsingWithErrorRecovery:!1});function u(O){const M=new w({regexParsingWithErrorRecovery:!1});return O.map(W=>(M.parse(W),M.lexingErrors.length>0?M.lexingErrors.map(H=>({errorMessage:H.additionalInfo?(0,R.localize)(9,null,H.additionalInfo):(0,R.localize)(10,null),offset:H.offset,length:H.lexeme.length})):M.parsingErrors.length>0?M.parsingErrors.map(H=>({errorMessage:H.additionalInfo?`${H.message}. ${H.additionalInfo}`:H.message,offset:H.offset,length:H.lexeme.length})):[]))}e.validateWhenClauses=u;function r(O,M){const W=O?O.substituteConstants():void 0,H=M?M.substituteConstants():void 0;return!W&&!H?!0:!W||!H?!1:W.equals(H)}e.expressionsAreEqualWithConstantSubstitution=r;function i(O,M){return O.cmp(M)}class n{constructor(){this.type=0}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class c{constructor(){this.type=1}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=c,c.INSTANCE=new c;class p{static create(M,W=null){const H=h.get(M);return typeof H=="boolean"?H?c.INSTANCE:n.INSTANCE:new p(M,W)}constructor(M,W){this.key=M,this.negated=W,this.type=2}cmp(M){return M.type!==this.type?this.type-M.type:B(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=h.get(this.key);return typeof M=="boolean"?M?c.INSTANCE:n.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=p;class D{static create(M,W,H=null){if(typeof W=="boolean")return W?p.create(M,H):T.create(M,H);const x=h.get(M);return typeof x=="boolean"?W===(x?"true":"false")?c.INSTANCE:n.INSTANCE:new D(M,W,H)}constructor(M,W,H){this.key=M,this.value=W,this.negated=H,this.type=4}cmp(M){return M.type!==this.type?this.type-M.type:V(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){const M=h.get(this.key);if(typeof M=="boolean"){const W=M?"true":"false";return this.value===W?c.INSTANCE:n.INSTANCE}return this}evaluate(M){return M.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(M){return M.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=D;class k{static create(M,W){return new k(M,W)}constructor(M,W){this.key=M,this.valueKey=W,this.type=10,this.negated=null}cmp(M){return M.type!==this.type?this.type-M.type:V(this.key,this.valueKey,M.key,M.valueKey)}equals(M){return M.type===this.type?this.key===M.key&&this.valueKey===M.valueKey:!1}substituteConstants(){return this}evaluate(M){const W=M.getValue(this.valueKey),H=M.getValue(this.key);return Array.isArray(W)?W.includes(H):typeof H=="string"&&typeof W=="object"&&W!==null?m.call(W,H):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(M){return M.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=C.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=k;class C{static create(M,W){return new C(M,W)}constructor(M,W){this.key=M,this.valueKey=W,this.type=11,this._negated=k.create(M,W)}cmp(M){return M.type!==this.type?this.type-M.type:this._negated.cmp(M._negated)}equals(M){return M.type===this.type?this._negated.equals(M._negated):!1}substituteConstants(){return this}evaluate(M){return!this._negated.evaluate(M)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(M){return M.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=C;class _{static create(M,W,H=null){if(typeof W=="boolean")return W?T.create(M,H):p.create(M,H);const x=h.get(M);return typeof x=="boolean"?W===(x?"true":"false")?n.INSTANCE:c.INSTANCE:new _(M,W,H)}constructor(M,W,H){this.key=M,this.value=W,this.negated=H,this.type=5}cmp(M){return M.type!==this.type?this.type-M.type:V(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){const M=h.get(this.key);if(typeof M=="boolean"){const W=M?"true":"false";return this.value===W?n.INSTANCE:c.INSTANCE}return this}evaluate(M){return M.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(M){return M.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=_;class T{static create(M,W=null){const H=h.get(M);return typeof H=="boolean"?H?n.INSTANCE:c.INSTANCE:new T(M,W)}constructor(M,W){this.key=M,this.negated=W,this.type=3}cmp(M){return M.type!==this.type?this.type-M.type:B(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=h.get(this.key);return typeof M=="boolean"?M?n.INSTANCE:c.INSTANCE:this}evaluate(M){return!M.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(M){return M.mapNot(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=T;function U(O,M){if(typeof O=="string"){const W=parseFloat(O);isNaN(W)||(O=W)}return typeof O=="string"||typeof O=="number"?M(O):n.INSTANCE}class q{static create(M,W,H=null){return U(W,x=>new q(M,x,H))}constructor(M,W,H){this.key=M,this.value=W,this.negated=H,this.type=12}cmp(M){return M.type!==this.type?this.type-M.type:V(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){return this}evaluate(M){return typeof this.value=="string"?!1:parseFloat(M.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(M){return M.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ne.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=q;class se{static create(M,W,H=null){return U(W,x=>new se(M,x,H))}constructor(M,W,H){this.key=M,this.value=W,this.negated=H,this.type=13}cmp(M){return M.type!==this.type?this.type-M.type:V(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){return this}evaluate(M){return typeof this.value=="string"?!1:parseFloat(M.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(M){return M.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=ie.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=se;class ie{static create(M,W,H=null){return U(W,x=>new ie(M,x,H))}constructor(M,W,H){this.key=M,this.value=W,this.negated=H,this.type=14}cmp(M){return M.type!==this.type?this.type-M.type:V(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){return this}evaluate(M){return typeof this.value=="string"?!1:parseFloat(M.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(M){return M.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=se.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=ie;class ne{static create(M,W,H=null){return U(W,x=>new ne(M,x,H))}constructor(M,W,H){this.key=M,this.value=W,this.negated=H,this.type=15}cmp(M){return M.type!==this.type?this.type-M.type:V(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){return this}evaluate(M){return typeof this.value=="string"?!1:parseFloat(M.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(M){return M.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=q.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ne;class ue{static create(M,W){return new ue(M,W)}constructor(M,W){this.key=M,this.regexp=W,this.type=7,this.negated=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.key<M.key)return-1;if(this.key>M.key)return 1;const W=this.regexp?this.regexp.source:"",H=M.regexp?M.regexp.source:"";return W<H?-1:W>H?1:0}equals(M){if(M.type===this.type){const W=this.regexp?this.regexp.source:"",H=M.regexp?M.regexp.source:"";return this.key===M.key&&W===H}return!1}substituteConstants(){return this}evaluate(M){const W=M.getValue(this.key);return this.regexp?this.regexp.test(W):!1}serialize(){const M=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${M}`}keys(){return[this.key]}map(M){return M.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=le.create(this)),this.negated}}e.ContextKeyRegexExpr=ue;class le{static create(M){return new le(M)}constructor(M){this._actual=M,this.type=8}cmp(M){return M.type!==this.type?this.type-M.type:this._actual.cmp(M._actual)}equals(M){return M.type===this.type?this._actual.equals(M._actual):!1}substituteConstants(){return this}evaluate(M){return!this._actual.evaluate(M)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(M){return new le(this._actual.map(M))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=le;function G(O){let M=null;for(let W=0,H=O.length;W<H;W++){const x=O[W].substituteConstants();if(O[W]!==x&&M===null){M=[];for(let z=0;z<W;z++)M[z]=O[z]}M!==null&&(M[W]=x)}return M===null?O:M}class Q{static create(M,W,H){return Q._normalizeArr(M,W,H)}constructor(M,W){this.expr=M,this.negated=W,this.type=6}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let W=0,H=this.expr.length;W<H;W++){const x=i(this.expr[W],M.expr[W]);if(x!==0)return x}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let W=0,H=this.expr.length;W<H;W++)if(!this.expr[W].equals(M.expr[W]))return!1;return!0}return!1}substituteConstants(){const M=G(this.expr);return M===this.expr?this:Q.create(M,this.negated,!1)}evaluate(M){for(let W=0,H=this.expr.length;W<H;W++)if(!this.expr[W].evaluate(M))return!1;return!0}static _normalizeArr(M,W,H){const x=[];let z=!1;for(const $ of M)if($){if($.type===1){z=!0;continue}if($.type===0)return n.INSTANCE;if($.type===6){x.push(...$.expr);continue}x.push($)}if(x.length===0&&z)return c.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(i);for(let $=1;$<x.length;$++)x[$-1].equals(x[$])&&(x.splice($,1),$--);if(x.length===1)return x[0];for(;x.length>1;){const $=x[x.length-1];if($.type!==9)break;x.pop();const K=x.pop(),re=x.length===0,ce=F.create($.expr.map(ge=>Q.create([ge,K],null,H)),null,re);ce&&(x.push(ce),x.sort(i))}if(x.length===1)return x[0];if(H){for(let $=0;$<x.length;$++)for(let K=$+1;K<x.length;K++)if(x[$].negate().equals(x[K]))return n.INSTANCE;if(x.length===1)return x[0]}return new Q(x,W)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const W of this.expr)M.push(...W.keys());return M}map(M){return new Q(this.expr.map(W=>W.map(M)),null)}negate(){if(!this.negated){const M=[];for(const W of this.expr)M.push(W.negate());this.negated=F.create(M,this,!0)}return this.negated}}e.ContextKeyAndExpr=Q;class F{static create(M,W,H){return F._normalizeArr(M,W,H)}constructor(M,W){this.expr=M,this.negated=W,this.type=9}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let W=0,H=this.expr.length;W<H;W++){const x=i(this.expr[W],M.expr[W]);if(x!==0)return x}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let W=0,H=this.expr.length;W<H;W++)if(!this.expr[W].equals(M.expr[W]))return!1;return!0}return!1}substituteConstants(){const M=G(this.expr);return M===this.expr?this:F.create(M,this.negated,!1)}evaluate(M){for(let W=0,H=this.expr.length;W<H;W++)if(this.expr[W].evaluate(M))return!0;return!1}static _normalizeArr(M,W,H){let x=[],z=!1;if(M){for(let $=0,K=M.length;$<K;$++){const re=M[$];if(re){if(re.type===0){z=!0;continue}if(re.type===1)return c.INSTANCE;if(re.type===9){x=x.concat(re.expr);continue}x.push(re)}}if(x.length===0&&z)return n.INSTANCE;x.sort(i)}if(x.length!==0){if(x.length===1)return x[0];for(let $=1;$<x.length;$++)x[$-1].equals(x[$])&&(x.splice($,1),$--);if(x.length===1)return x[0];if(H){for(let $=0;$<x.length;$++)for(let K=$+1;K<x.length;K++)if(x[$].negate().equals(x[K]))return c.INSTANCE;if(x.length===1)return x[0]}return new F(x,W)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const W of this.expr)M.push(...W.keys());return M}map(M){return new F(this.expr.map(W=>W.map(M)),null)}negate(){if(!this.negated){const M=[];for(const W of this.expr)M.push(W.negate());for(;M.length>1;){const W=M.shift(),H=M.shift(),x=[];for(const z of oe(W))for(const $ of oe(H))x.push(Q.create([z,$],null,!1));M.unshift(F.create(x,null,!1))}this.negated=F.create(M,this,!0)}return this.negated}}e.ContextKeyOrExpr=F;class N extends p{static all(){return N._info.values()}constructor(M,W,H){super(M,null),this._defaultValue=W,typeof H=="object"?N._info.push({...H,key:M}):H!==!0&&N._info.push({key:M,description:H,type:W!=null?typeof W:void 0})}bindTo(M){return M.createKey(this.key,this._defaultValue)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return D.create(this.key,M)}notEqualsTo(M){return _.create(this.key,M)}}e.RawContextKey=N,N._info=[],e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function B(O,M){return O<M?-1:O>M?1:0}function V(O,M,W,H){return O<W?-1:O>W?1:M<H?-1:M>H?1:0}function Y(O,M){if(O.type===0||M.type===1)return!0;if(O.type===9)return M.type===9?ae(O.expr,M.expr):!1;if(M.type===9){for(const W of M.expr)if(Y(O,W))return!0;return!1}if(O.type===6){if(M.type===6)return ae(M.expr,O.expr);for(const W of O.expr)if(Y(W,M))return!0;return!1}return O.equals(M)}e.implies=Y;function ae(O,M){let W=0,H=0;for(;W<O.length&&H<M.length;){const x=O[W].cmp(M[H]);if(x<0)return!1;x===0&&W++,H++}return W===O.length}function oe(O){return O.type===9?O.expr:[O]}}),define(ee[75],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,P.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,P.createDecorator)("credentialsMainService");class L{constructor(){this.secretVault={}}async getPassword(A,R){return this.secretVault[A]?.[R]??null}async setPassword(A,R,I){this.secretVault[A]=this.secretVault[A]??{},this.secretVault[A][R]=I}async deletePassword(A,R){return this.secretVault[A]?.[R]?(delete this.secretVault[A][R],Object.keys(this.secretVault[A]).length===0&&delete this.secretVault[A],!0):!1}async findPassword(A){return JSON.stringify(this.secretVault[A])??null}async findCredentials(A){const R=[];for(const I of Object.keys(this.secretVault[A]||{}))R.push({account:I,password:this.secretVault[A][I]});return R}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=L}),define(ee[90],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,P.createDecorator)(e.ID);function L(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=L;class s{async getPerformanceInfo(R,I){return{}}async getSystemInfo(R,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(R,I){return""}async getWorkspaceFileExtensions(R){return{extensions:[]}}async reportWorkspaceStats(R){}}e.NullDiagnosticsService=s}),define(ee[91],te([0,1,19,69,164,6,46,3,37]),function(j,e,P,L,s,A,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,A.createDecorator)("dialogService");var l;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(l||(l={}));class m{getConfirmationButtons(o){return this.getButtons(o,l.Confirmation)}getPromptButtons(o){return this.getButtons(o,l.Prompt)}getInputButtons(o){return this.getButtons(o,l.Input)}getButtons(o,g){const a=[];switch(g){case l.Confirmation:{const b=o;b.primaryButton?a.push(b.primaryButton):a.push((0,s.localize)(0,null)),b.cancelButton?a.push(b.cancelButton):a.push((0,s.localize)(1,null));break}case l.Prompt:{const b=o;Array.isArray(b.buttons)&&b.buttons.length>0&&a.push(...b.buttons.map(E=>E.label)),b.cancelButton&&(b.cancelButton===!0?a.push((0,s.localize)(2,null)):typeof b.cancelButton=="string"?a.push(b.cancelButton):b.cancelButton.label?a.push(b.cancelButton.label):a.push((0,s.localize)(3,null))),a.length===0&&a.push((0,s.localize)(4,null));break}case l.Input:{const b=o;b.primaryButton?a.push(b.primaryButton):a.push((0,s.localize)(5,null)),b.cancelButton?a.push(b.cancelButton):a.push((0,s.localize)(6,null));break}}return a}getDialogType(o){if(typeof o=="string")return o;if(typeof o=="number")return o===L.default.Info?"info":o===L.default.Error?"error":o===L.default.Warning?"warning":"none"}async getPromptResult(o,g,a){const b=[...o.buttons??[]];return o.cancelButton&&typeof o.cancelButton!="string"&&typeof o.cancelButton!="boolean"&&b.push(o.cancelButton),{result:await b[g]?.run({checkboxChecked:a}),checkboxChecked:a}}}e.AbstractDialogHandler=m,e.IFileDialogService=(0,A.createDecorator)("fileDialogService");var f;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(f||(e.ConfirmResult=f={}));const S=10;function d(v){const o=[];return o.push(...v.slice(0,S).map(g=>typeof g=="string"?g:(0,P.basename)(g))),v.length>S&&(v.length-S===1?o.push((0,s.localize)(7,null)):o.push((0,s.localize)(8,null,v.length-S))),o.push(""),o.join(`
`)}e.getFileNamesMessage=d;function y(v,o){const g=(0,h.deepClone)(v);let a=(g.buttons??[]).map(t=>(0,R.mnemonicButtonLabel)(t)),b=(v.buttons||[]).map((t,u)=>u),E=0,w=g.cancelId??a.length-1;if(a.length>1){const t=typeof w=="number"?a[w]:void 0;if(I.isLinux||I.isMacintosh){if(typeof t=="string"&&a.length>1&&w!==1){a.splice(w,1),a.splice(1,0,t);const u=b[w];b.splice(w,1),b.splice(1,0,u),w=1}I.isLinux&&a.length>1&&(a=a.reverse(),b=b.reverse(),E=a.length-1,typeof t=="string"&&(w=E-1))}else if(I.isWindows&&typeof t=="string"&&a.length>1&&w!==a.length-1){a.splice(w,1),a.push(t);const u=b[w];b.splice(w,1),b.push(u),w=a.length-1}}return g.buttons=a,g.defaultId=E,g.cancelId=w,g.noLink=!0,g.title=g.title||o.nameLong,{options:g,buttonIndeces:b}}e.massageMessageBoxOptions=y}),define(ee[114],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isGnome=e.isKwallet=e.KnownStorageProvider=e.IEncryptionMainService=e.IEncryptionService=void 0,e.IEncryptionService=(0,P.createDecorator)("encryptionService"),e.IEncryptionMainService=(0,P.createDecorator)("encryptionMainService");var L;(function(R){R.unknown="unknown",R.basicText="basic_text",R.gnomeAny="gnome_any",R.gnomeLibsecret="gnome_libsecret",R.gnomeKeyring="gnome_keyring",R.kwallet="kwallet",R.kwallet5="kwallet5",R.kwallet6="kwallet6",R.dplib="dpapi",R.keychainAccess="keychain_access"})(L||(e.KnownStorageProvider=L={}));function s(R){return R==="kwallet"||R==="kwallet5"||R==="kwallet6"}e.isKwallet=s;function A(R){return R==="gnome_any"||R==="gnome_libsecret"||R==="gnome_keyring"}e.isGnome=A}),define(ee[33],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,P.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,P.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[115],te([0,1,168,6]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function s(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=s;function A(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function R(a,b){switch(a){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":b==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function I(a,b){return b==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function h(a,b,E){return I(b,E)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===E?!0:l(E).includes(a)}e.isTargetPlatformCompatible=h;function l(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=l;function m(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=m;var f;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(f||(e.SortBy=f={}));var S;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var d;(function(a){a.Install="install",a.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var y;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var v;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var o;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(o||(e.ExtensionSignaturetErrorCode=o={}));class g extends Error{constructor(b,E){super(b),this.code=E,this.name=E}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,P.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,P.localize)(1,null),original:"Preferences"}}),define(ee[207],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,P.createDecorator)("extensionUrlTrustService")}),define(ee[208],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,P.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[116],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,P.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,P.createDecorator)("externalTerminal")}),define(ee[209],te([0,1,47,15,9,3,72,22,88,172,116]),function(j,e,P,L,s,A,R,I,h,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const f=l.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends S{openTerminal(E,w){return this.spawnTerminal(P,E,h.getWindowsShell(),w)}spawnTerminal(E,w,t,u){const r=w.windowsExec||d.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const i=s.basename(r,".exe").toLowerCase();if(i==="cmder")return E.spawn(r,u?[u]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),i==="wt"&&n.push("-d ."),new Promise((c,p)=>{const D=o(process),k=E.spawn(t,n,{cwd:u,env:D});k.on("error",p),k.on("exit",()=>c())})}runInTerminal(E,w,t,u,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:d.getDefaultTerminalWindows();return new Promise((n,c)=>{const p=`"${w} - ${f}"`,D=`""${t.join('" "')}" & pause"`,k=Object.assign({},o(process),u);Object.keys(k).filter(q=>k[q]===null).forEach(q=>delete k[q]);const C={cwd:w,env:k,windowsVerbatimArguments:!0};let _,T;s.basename(i,".exe")==="wt"?(_=i,T=["-d",".",d.CMD,"/c",D]):(_=d.CMD,T=["/c","start",p,"/wait",i,"/c",D]),P.spawn(_,T,C).on("error",q=>{c(g(q))}),n(void 0)})}static getDefaultTerminalWindows(){if(!d._DEFAULT_TERMINAL_WINDOWS){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return d._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=d,d.CMD="cmd.exe";class y extends S{openTerminal(E,w){return this.spawnTerminal(P,E,w)}runInTerminal(E,w,t,u,r){const i=r.osxExec||m.DEFAULT_TERMINAL_OSX;return new Promise((n,c)=>{if(i===m.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const p=i===m.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",k=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${p}.scpt`).fsPath,"-t",E||f,"-w",w];for(const T of t)k.push("-a"),k.push(T);if(u){const T=Object.assign({},o(process),u);for(const U in T){const q=T[U];q===null?(k.push("-u"),k.push(U)):(k.push("-e"),k.push(`${U}=${q}`))}}let C="";const _=P.spawn(y.OSASCRIPT,k);_.on("error",T=>{c(g(T))}),_.stderr.on("data",T=>{C+=T.toString()}),_.on("exit",T=>{if(T===0)n(void 0);else if(C){const U=C.split(`
`,1);c(new Error(U[0]))}else c(new Error(l.localize(1,null,p,T)))})}else c(new Error(l.localize(2,null,i)))})}spawnTerminal(E,w,t){const u=w.osxExec||m.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const n=["-a",u];t&&n.push(t);const c=o(process),p=E.spawn("/usr/bin/open",n,{cwd:t,env:c});p.on("error",i),p.on("exit",()=>r())})}}e.MacExternalTerminalService=y,y.OSASCRIPT="/usr/bin/osascript";class v extends S{openTerminal(E,w){return this.spawnTerminal(P,E,w)}runInTerminal(E,w,t,u,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((n,c)=>{const p=[];i.then(D=>{D.indexOf("gnome-terminal")>=0?p.push("-x"):p.push("-e"),p.push("bash"),p.push("-c");const k=`${a(t)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;p.push(`''${k}''`);const C=Object.assign({},o(process),u);Object.keys(C).filter(q=>C[q]===null).forEach(q=>delete C[q]);const _={cwd:w,env:C};let T="";const U=P.spawn(D,p,_);U.on("error",q=>{c(g(q))}),U.stderr.on("data",q=>{T+=q.toString()}),U.on("exit",q=>{if(q===0)n(void 0);else if(T){const se=T.split(`
`,1);c(new Error(se[0]))}else c(new Error(l.localize(4,null,D,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!v._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)v._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const E=await I.Promises.exists("/etc/debian_version");v._DEFAULT_TERMINAL_LINUX_READY=new Promise(w=>{E?w("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?w("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?w("konsole"):process.env.COLORTERM?w(process.env.COLORTERM):process.env.TERM?w(process.env.TERM):w("xterm")})}return v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(E,w,t){const u=w.linuxExec?Promise.resolve(w.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{u.then(n=>{const c=o(process),p=E.spawn(n,[],{cwd:t,env:c});p.on("error",i),p.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=l.localize(3,null);function o(b){const E={...b.env};return(0,R.sanitizeProcessEnvironment)(E),E}function g(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(l.localize(5,null,b.path)):b}function a(b){let E="";for(const w of b)w.indexOf(" ")>=0?E+='"'+w+'"':E+=w,E+=" ";return E}}),define(ee[16],te([0,1,62,9,25,11,7,174,6,3,15]),function(j,e,P,L,s,A,R,I,h,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function f(B){return B.create===!0}e.isFileOpenForWriteOptions=f;var S;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var d;(function(B){B[B.Readonly=1]="Readonly",B[B.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var y;(function(B){B[B.None=0]="None",B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileAtomicWrite=32768]="FileAtomicWrite",B[B.FileAtomicDelete=65536]="FileAtomicDelete",B[B.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function v(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=v;function o(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=o;function g(B){return!!(B.capabilities&131072)}e.hasFileCloneCapability=g;function a(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function b(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=b;function E(B){return v(B)?!!(B.capabilities&16384):!1}e.hasFileAtomicReadCapability=E;function w(B){return v(B)?!!(B.capabilities&32768):!1}e.hasFileAtomicWriteCapability=w;function t(B){return!!(B.capabilities&65536)}e.hasFileAtomicDeleteCapability=t;function u(B){return!!(B.capabilities&2048)}e.hasReadonlyCapability=u;var r;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsStorageQuota="EntryExceedsStorageQuota",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class i extends Error{static create(V,Y){const ae=new i(V.toString(),Y);return p(ae,Y),ae}constructor(V,Y){super(V),this.code=Y}}e.FileSystemProviderError=i;function n(B,V){return i.create(B,V)}e.createFileSystemProviderError=n;function c(B){return B||n((0,I.localize)(0,null),r.Unknown)}e.ensureFileSystemProviderError=c;function p(B,V){return B.name=V?`${V} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=p;function D(B){if(!B)return r.Unknown;if(B instanceof i)return B.code;const V=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!V)return r.Unknown;switch(V[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.toFileSystemProviderErrorCode=D;function k(B){if(B instanceof se)return B.fileOperationResult;switch(D(B)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=k;var C;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class _{constructor(V,Y,ae){this.resource=V,this.operation=Y,this.target=ae}isOperation(V){return this.operation===V}}e.FileOperationEvent=_;var T;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class U{constructor(V,Y){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ae=new Map;for(const oe of V){const O=ae.get(oe.type);switch(O?O.push([oe.resource,oe]):ae.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,O]of ae)switch(oe){case 1:this.added=P.TernarySearchTree.forUris(()=>Y),this.added.fill(O);break;case 0:this.updated=P.TernarySearchTree.forUris(()=>Y),this.updated.fill(O);break;case 2:this.deleted=P.TernarySearchTree.forUris(()=>Y),this.deleted.fill(O);break}}contains(V,...Y){return this.doContains(V,{includeChildren:!1},...Y)}affects(V,...Y){return this.doContains(V,{includeChildren:!0},...Y)}doContains(V,Y,...ae){if(!V)return!1;const oe=ae.length>0;return!!((!oe||ae.includes(1))&&(this.added?.get(V)||Y.includeChildren&&this.added?.findSuperstr(V))||(!oe||ae.includes(0))&&(this.updated?.get(V)||Y.includeChildren&&this.updated?.findSuperstr(V))||(!oe||ae.includes(2))&&(this.deleted?.findSubstr(V)||Y.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=U;function q(B,V,Y){return!B||!V||B===V||V.length>B.length?!1:(V.charAt(V.length-1)!==L.sep&&(V+=L.sep),Y?(0,s.startsWithIgnoreCase)(B,V):B.indexOf(V)===0)}e.isParent=q;class se extends Error{constructor(V,Y,ae){super(V),this.fileOperationResult=Y,this.options=ae}}e.FileOperationError=se;class ie extends se{constructor(V,Y,ae,oe){super(V,Y,oe),this.fileOperationResult=Y,this.size=ae}}e.TooLargeFileOperationError=ie;class ne extends se{constructor(V,Y,ae){super(V,2,ae),this.stat=Y}}e.NotModifiedSinceFileOperationError=ne;var ue;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ue||(e.FileOperationResult=ue={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var le;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(e.FileKind=le={})),e.ETAG_DISABLED="";function G(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=G;async function Q(B,V){if(!V.hasProvider(R.URI.from({scheme:B.scheme})))return new Promise(Y=>{const ae=V.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===B.scheme&&oe.added&&(ae.dispose(),Y())})})}e.whenProviderRegistered=Q;class F{static formatSize(V){return(0,A.isNumber)(V)||(V=0),V<F.KB?(0,I.localize)(1,null,V.toFixed(0)):V<F.MB?(0,I.localize)(2,null,(V/F.KB).toFixed(2)):V<F.GB?(0,I.localize)(3,null,(V/F.MB).toFixed(2)):V<F.TB?(0,I.localize)(4,null,(V/F.GB).toFixed(2)):(0,I.localize)(5,null,(V/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;function N(B){const V=typeof B=="string"||B?.scheme===m.Schemas.vscodeRemote;return typeof B!="string"&&B?.scheme===m.Schemas.file?1024*F.MB:V?10*F.MB:l.isWeb?50*F.MB:1024*F.MB}e.getLargeFileConfirmationLimit=N}),define(ee[210],te([0,1,17,50,13,4,2,61,7,31,16]),function(j,e,P,L,s,A,R,I,h,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class f extends R.Disposable{constructor(d,y){super(),this.channel=d,this.extraCapabilities=y,this.onDidChangeCapabilities=A.Event.None,this._onDidChange=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,l.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(d){return this.channel.call("stat",[d])}readdir(d){return this.channel.call("readdir",[d])}async readFile(d,y){const{buffer:v}=await this.channel.call("readFile",[d,y]);return v}readFileStream(d,y,v){const o=(0,I.newWriteableStream)(a=>P.VSBuffer.concat(a.map(b=>P.VSBuffer.wrap(b))).buffer),g=this.channel.listen("readFileStream",[d,y])(a=>{if(a instanceof P.VSBuffer)o.write(a.buffer);else{if(a==="end")o.end();else{let b;if(a instanceof Error)b=a;else{const E=a;b=(0,m.createFileSystemProviderError)(E.message??(0,L.toErrorMessage)(E),E.code??m.FileSystemProviderErrorCode.Unknown)}o.error(b),o.end()}g.dispose()}});return v.onCancellationRequested(()=>{o.error((0,s.canceled)()),o.end(),g.dispose()}),o}writeFile(d,y,v){return this.channel.call("writeFile",[d,P.VSBuffer.wrap(y),v])}open(d,y){return this.channel.call("open",[d,y])}close(d){return this.channel.call("close",[d])}async read(d,y,v,o,g){const[a,b]=await this.channel.call("read",[d,y,g]);return v.set(a.buffer.slice(0,b),o),b}write(d,y,v,o,g){return this.channel.call("write",[d,y,P.VSBuffer.wrap(v),o,g])}mkdir(d){return this.channel.call("mkdir",[d])}delete(d,y){return this.channel.call("delete",[d,y])}rename(d,y,v){return this.channel.call("rename",[d,y,v])}copy(d,y,v){return this.channel.call("copy",[d,y,v])}cloneFile(d,y){return this.channel.call("cloneFile",[d,y])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(d=>{if(Array.isArray(d)){const y=d;this._onDidChange.fire(y.map(v=>({resource:h.URI.revive(v.resource),type:v.type})))}else{const y=d;this._onDidWatchError.fire(y)}}))}watch(d,y){const v=(0,l.generateUuid)();return this.channel.call("watch",[this.sessionId,v,d,y]),(0,R.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,v]))}}e.DiskFileSystemProviderClient=f}),define(ee[117],te([0,1,17,13,175,16]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(m,f,S,d,y,v){let o;try{await I(m,f,S,d,y,v)}catch(g){o=g}finally{o&&y.errorTransformer&&(o=y.errorTransformer(o)),typeof o<"u"&&S.error(o),S.end()}}e.readFileIntoStream=R;async function I(m,f,S,d,y,v){h(v);const o=await m.open(f,{create:!1});try{h(v);let g=0,a=0,b=y&&typeof y.length=="number"?y.length:void 0,E=P.VSBuffer.alloc(Math.min(y.bufferSize,typeof b=="number"?b:y.bufferSize)),w=y&&typeof y.position=="number"?y.position:0,t=0;do a=await m.read(o,w,E.buffer,t,E.byteLength-t),w+=a,t+=a,g+=a,typeof b=="number"&&(b-=a),t===E.byteLength&&(await S.write(d(E)),E=P.VSBuffer.alloc(Math.min(y.bufferSize,typeof b=="number"?b:y.bufferSize)),t=0);while(a>0&&(typeof b!="number"||b>0)&&h(v)&&l(g,y));if(t>0){let u=t;typeof b=="number"&&(u=Math.min(t,b)),S.write(d(E.slice(0,u)))}}catch(g){throw(0,A.ensureFileSystemProviderError)(g)}finally{await m.close(o)}}function h(m){if(m.isCancellationRequested)throw(0,L.canceled)();return!0}function l(m,f){if(typeof f?.limits?.size=="number"&&m>f.limits.size)throw(0,A.createFileSystemProviderError)((0,s.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ee[76],te([0,1,104,2,9,3,7,16]),function(j,e,P,L,s,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function h(g){return g.recursive===!0}e.isRecursiveWatchRequest=h;class l extends L.Disposable{constructor(a,b,E,w){super(),this.onFileChanges=a,this.onLogMessage=b,this.verboseLogging=E,this.options=w,this.watcherDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const a=new L.DisposableStore;this.watcherDisposables.value=a,this.watcher=this.createWatcher(a),this.watcher.setVerboseLogging(this.verboseLogging),a.add(this.watcher.onDidChangeFile(b=>this.onFileChanges(b))),a.add(this.watcher.onDidLogMessage(b=>this.onLogMessage(b))),a.add(this.watcher.onDidError(b=>this.onError(b)))}onError(a){this.options.restartOnError?this.restartCounter<l.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${a}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${a}`):this.error(a)}restart(a){this.restartCounter++,this.init(),this.watch(a)}async watch(a){this.requests=a,await this.watcher?.watch(a)}async setVerboseLogging(a){this.verboseLogging=a,await this.watcher?.setVerboseLogging(a)}error(a){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${a}`})}trace(a){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${a}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=l,l.MAX_RESTARTS=5;class m extends l{constructor(a,b,E){super(a,b,E,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=m;class f extends l{constructor(a,b,E){super(a,b,E,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=f;function S(g){return g.map(a=>({type:a.type,resource:R.URI.file(a.path)}))}e.toFileChanges=S;function d(g){const a=new o;for(const b of g)a.processEvent(b);return a.coalesce()}e.coalesceEvents=d;function y(g,a){return typeof a=="string"&&!a.startsWith(P.GLOBSTAR)&&!(0,s.isAbsolute)(a)?{base:g,pattern:a}:a}e.normalizeWatcherPattern=y;function v(g,a){const b=[];for(const E of a)b.push((0,P.parse)(y(g,E)));return b}e.parseWatcherPatterns=v;class o{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(a){return A.isLinux?a.path:a.path.toLowerCase()}processEvent(a){const b=this.mapPathToChange.get(this.toKey(a));let E=!1;if(b){const w=b.type,t=a.type;b.path!==a.path&&(a.type===2||a.type===1)?E=!0:w===1&&t===2?(this.mapPathToChange.delete(this.toKey(a)),this.coalesced.delete(b)):w===2&&t===1?b.type=0:w===1&&t===0||(b.type=t)}else E=!0;E&&(this.coalesced.add(a),this.mapPathToChange.set(this.toKey(a),a))}coalesce(){const a=[],b=[];return Array.from(this.coalesced).filter(E=>E.type!==2?(a.push(E),!1):!0).sort((E,w)=>E.path.length-w.path.length).filter(E=>b.some(w=>(0,I.isParent)(E.path,w,!A.isLinux))?!1:(b.push(E.path),!0)).concat(a)}}}),define(ee[211],te([0,1,42,8,21,32,2,84,9,3,105,22,76]),function(j,e,P,L,s,A,R,I,h,l,m,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends R.Disposable{constructor(o,g,a,b){super(),this.request=o,this.onDidFilesChange=g,this.onLogMessage=a,this.verboseLogging=b,this.throttledFileChangesEmitter=this._register(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.onDidFilesChange(E))),this.fileChangesAggregator=this._register(new L.RunOnceWorker(E=>this.handleFileChanges(E),d.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new s.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const o=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const g=await f.Promises.stat(o);this._register(await this.doWatch(o,g.isDirectory()))}catch(o){o.code!=="ENOENT"?this.error(o):this.trace(o)}}async normalizePath(o){let g=o.path;try{g=await f.Promises.realpath(o.path),o.path===g&&(g=await(0,m.realcase)(o.path)??o.path),o.path!==g&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${o.path}, real: ${g})`)}catch{}return g}async doWatch(o,g){if(l.isMacintosh&&(0,A.isEqualOrParent)(o,"/Volumes/",!0))return this.error(`Refusing to watch ${o} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const a=new s.CancellationTokenSource(this.cts.token),b=new R.DisposableStore;try{const E=(0,h.basename)(o),w=(0,P.watch)(o);b.add((0,R.toDisposable)(()=>{w.removeAllListeners(),w.close()})),this.trace(`Started watching: '${o}'`);const t=new Set;if(g)try{for(const r of await f.Promises.readdir(o))t.add(r)}catch(r){this.error(r)}const u=new Map;b.add((0,R.toDisposable)(()=>{for(const[,r]of u)r.dispose();u.clear()})),w.on("error",(r,i)=>{this.error(`Failed to watch ${o} for changes using fs.watch() (${r}, ${i})`),this.dispose()}),w.on("change",(r,i)=>{if(a.token.isCancellationRequested)return;this.trace(`[raw] ["${r}"] ${i}`);let n="";if(i&&(n=i.toString(),l.isMacintosh&&(n=(0,I.normalizeNFC)(n))),!(!n||r!=="change"&&r!=="rename"))if(g)if(r==="rename"){u.get(n)?.dispose();const c=setTimeout(async()=>{if(u.delete(n),n===E&&!await f.Promises.exists(o)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const p=await this.existsChildStrictCase((0,h.join)(o,n));if(a.token.isCancellationRequested)return;let D;p?t.has(n)?D=0:(D=1,t.add(n)):(t.delete(n),D=2),this.onFileChange({path:(0,h.join)(this.request.path,n),type:D})},d.FILE_DELETE_HANDLER_DELAY);u.set(n,(0,R.toDisposable)(()=>clearTimeout(c)))}else{let c;t.has(n)?c=0:(c=1,t.add(n)),this.onFileChange({path:(0,h.join)(this.request.path,n),type:c})}else if(r==="rename"||n!==E){const c=setTimeout(async()=>{const p=await f.Promises.exists(o);a.token.isCancellationRequested||(p?(this.onFileChange({path:this.request.path,type:0},!0),b.add(await this.doWatch(o,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},d.FILE_DELETE_HANDLER_DELAY);b.clear(),b.add((0,R.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(E){await f.Promises.exists(o)&&!a.token.isCancellationRequested&&this.error(`Failed to watch ${o} for changes using fs.watch() (${E.toString()})`)}return(0,R.toDisposable)(()=>{a.dispose(!0),b.dispose()})}onFileChange(o,g=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`),!g&&this.excludes.some(a=>a(o.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${o.path}`):!g&&this.includes&&this.includes.length>0&&!this.includes.some(a=>a(o.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${o.path}`):this.fileChangesAggregator.work(o))}handleFileChanges(o){const g=(0,S.coalesceEvents)(o);if(g.length>0){if(this.verboseLogging)for(const b of g)this.trace(`>> normalized ${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`);this.throttledFileChangesEmitter.work(g)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(o){if(l.isLinux)return f.Promises.exists(o);try{const g=(0,h.basename)(o);return(await f.Promises.readdir((0,h.dirname)(o))).some(b=>b===g)}catch(g){return this.trace(g),!1}}setVerboseLogging(o){this.verboseLogging=o}error(o){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${o}`})}warn(o){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${o}`})}trace(o){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${o}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=d,d.FILE_DELETE_HANDLER_DELAY=100,d.FILE_CHANGES_HANDLER_DELAY=75;async function y(v,o,g,a,b=512){const E=await f.Promises.open(v,"r"),w=Buffer.allocUnsafe(b),t=new s.CancellationTokenSource(a);let u,r=!1;const i={path:v,excludes:[],recursive:!1},n=new d(i,c=>{(async()=>{for(const{type:p}of c)if(p===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:D}=await f.Promises.read(E,w,0,b,null);if(!D||t.token.isCancellationRequested)break;o(w.slice(0,D))}}catch(D){u=new Error(D),t.dispose(!0)}finally{r=!1}}})()});return await n.ready,g(),new Promise((c,p)=>{t.token.onCancellationRequested(async()=>{n.dispose();try{await f.Promises.close(E)}catch(D){u=new Error(D)}u?p(u):c()})})}e.watchFileContents=y}),define(ee[212],te([0,1,4,104,2,3,211]),function(j,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends s.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new P.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=P.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(l){const m=this.normalizeRequests(l),f=m.filter(d=>{const y=this.watchers.get(d.path);return y?!(0,L.patternsEquals)(y.request.excludes,d.excludes)||!(0,L.patternsEquals)(y.request.includes,d.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:d})=>!m.find(y=>y.path===d.path&&(0,L.patternsEquals)(y.excludes,d.excludes)&&(0,L.patternsEquals)(y.includes,d.includes))).map(({request:d})=>d.path);f.length&&this.trace(`Request to start watching: ${f.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const d of S)this.stopWatching(d);for(const d of f)this.startWatching(d)}startWatching(l){const m=new R.NodeJSFileWatcherLibrary(l,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),f={request:l,instance:m};this.watchers.set(l.path,f)}async stop(){for(const[l]of this.watchers)this.stopWatching(l);this.watchers.clear()}stopWatching(l){const m=this.watchers.get(l);m&&(this.watchers.delete(l),m.instance.dispose())}normalizeRequests(l){const m=new Map;for(const f of l){const S=A.isLinux?f.path:f.path.toLowerCase();m.set(S,f)}return Array.from(m.values())}async setVerboseLogging(l){this.verboseLogging=l;for(const[,m]of this.watchers)m.instance.setVerboseLogging(l)}trace(l){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(l)})}toMessage(l,m){return m?`[File Watcher (node.js)] ${l} (path: ${m.request.path})`:`[File Watcher (node.js)] ${l}`}}e.NodeJSWatcher=I}),define(ee[213],te([0,1,76,212]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class s extends P.AbstractNonRecursiveWatcherClient{constructor(R,I,h){super(R,I,h),this.init()}createWatcher(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=s}),define(ee[214],te([0,1,15,43,158,76]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class R extends A.AbstractUniversalWatcherClient{constructor(h,l,m){super(h,l,m),this.init()}createWatcher(h){const l=h.add(new s.Client(P.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(l.onDidProcessExit(({code:m,signal:f})=>this.onError(`terminated by itself with code ${m}, signal: ${f}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=R}),define(ee[92],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class P{constructor(...s){this._entries=new Map;for(const[A,R]of s)this.set(A,R)}set(s,A){const R=this._entries.get(s);return this._entries.set(s,A),R}has(s){return this._entries.has(s)}get(s){return this._entries.get(s)}}e.ServiceCollection=P}),define(ee[215],te([0,1,8,13,2,74,206,6,92,101]),function(j,e,P,L,s,A,R,I,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const m=!1;class f extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class S{constructor(o=new h.ServiceCollection,g=!1,a,b=m){this._services=o,this._strict=g,this._parent=a,this._enableTracing=b,this._activeInstantiations=new Set,this._services.set(I.IInstantiationService,this),this._globalGraph=b?a?._globalGraph??new R.Graph(E=>E):void 0}createChild(o){return new S(o,this._strict,this,this._enableTracing)}invokeFunction(o,...g){const a=y.traceInvocation(this._enableTracing,o);let b=!1;try{return o({get:w=>{if(b)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(w,a);if(!t)throw new Error(`[invokeFunction] unknown service '${w}'`);return t}},...g)}finally{b=!0,a.stop()}}createInstance(o,...g){let a,b;return o instanceof A.SyncDescriptor?(a=y.traceCreation(this._enableTracing,o.ctor),b=this._createInstance(o.ctor,o.staticArguments.concat(g),a)):(a=y.traceCreation(this._enableTracing,o),b=this._createInstance(o,g,a)),a.stop(),b}_createInstance(o,g=[],a){const b=I._util.getServiceDependencies(o).sort((t,u)=>t.index-u.index),E=[];for(const t of b){const u=this._getOrCreateServiceInstance(t.id,a);u||this._throwIfStrict(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(u)}const w=b.length>0?b[0].index:g.length;if(g.length!==w){console.trace(`[createInstance] First service dependency of ${o.name} at position ${w+1} conflicts with ${g.length} static arguments`);const t=w-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,w)}return Reflect.construct(o,g.concat(E))}_setServiceInstance(o,g){if(this._services.get(o)instanceof A.SyncDescriptor)this._services.set(o,g);else if(this._parent)this._parent._setServiceInstance(o,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){const g=this._services.get(o);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):g}_getOrCreateServiceInstance(o,g){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(o));const a=this._getServiceInstanceOrDescriptor(o);return a instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,a,g.branch(o,!0)):(g.branch(o,!1),a)}_safeCreateAndCacheServiceInstance(o,g,a){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,g,a)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,g,a){const b=new R.Graph(t=>t.id.toString());let E=0;const w=[{id:o,desc:g,_trace:a}];for(;w.length;){const t=w.pop();if(b.lookupOrInsertNode(t),E++>1e3)throw new f(b);for(const u of I._util.getServiceDependencies(t.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(u.id);if(r||this._throwIfStrict(`[createInstance] ${o} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(u.id)),r instanceof A.SyncDescriptor){const i={id:u.id,desc:r,_trace:t._trace.branch(u.id,!0)};b.insertEdge(t,i),w.push(i)}}}for(;;){const t=b.roots();if(t.length===0){if(!b.isEmpty())throw new f(b);break}for(const{data:u}of t){if(this._getServiceInstanceOrDescriptor(u.id)instanceof A.SyncDescriptor){const i=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,i)}b.removeNode(u)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,g,a=[],b,E){if(this._services.get(o)instanceof A.SyncDescriptor)return this._createServiceInstance(o,g,a,b,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,g,a,b,E);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(o,g,a=[],b,E){if(b){const w=new S(void 0,this._strict,this,this._enableTracing);w._globalGraphImplicitDependency=String(o);const t=new Map,u=new P.IdleValue(()=>{const r=w._createInstance(g,a,E);for(const[i,n]of t){const c=r[i];if(typeof c=="function")for(const p of n)c.apply(r,p)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!u.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let p=t.get(i);return p||(p=new l.LinkedList,t.set(i,p)),(k,C,_)=>{const T=p.push([k,C,_]);return(0,s.toDisposable)(T)}}if(i in r)return r[i];const n=u.value;let c=n[i];return typeof c!="function"||(c=c.bind(n),r[i]=c),c},set(r,i,n){return u.value[i]=n,!0},getPrototypeOf(r){return g.prototype}})}else return this._createInstance(g,a,E)}_throwIfStrict(o,g){if(g&&console.warn(o),this._strict)throw new Error(o)}}e.InstantiationService=S;var d;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(d||(d={}));class y{static traceInvocation(o,g){return o?new y(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y._None}static traceCreation(o,g){return o?new y(1,g.name):y._None}constructor(o,g){this.type=o,this.name=g,this._start=Date.now(),this._dep=[]}branch(o,g){const a=new y(3,o.toString());return this._dep.push([o,g,a]),a}stop(){const o=Date.now()-this._start;y._totals+=o;let g=!1;function a(E,w){const t=[],u=new Array(E+1).join("	");for(const[r,i,n]of w._dep)if(i&&n){g=!0,t.push(`${u}CREATES -> ${r}`);const c=a(E+1,n);c&&t.push(c)}else t.push(`${u}uses -> ${r}`);return t.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(o>2||g)&&y.all.add(b.join(`
`))}}e.Trace=y,y.all=new Set,y._None=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}},y._totals=0}),define(ee[216],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IIssueMainService=e.IssueType=void 0;var L;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(L||(e.IssueType=L={})),e.IIssueMainService=(0,P.createDecorator)("issueService")}),define(ee[5],te([0,1,50,4,56,2,35,3,19,11,7,113,6]),function(j,e,P,L,s,A,R,I,h,l,m,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function d(){return new Date().toISOString()}function y(k){return(0,l.isNumber)(k)}e.isLogLevel=y;var v;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(v||(e.LogLevel=v={})),e.DEFAULT_LOG_LEVEL=v.Info;function o(k,C,_){switch(C){case v.Trace:k.trace(_);break;case v.Debug:k.debug(_);break;case v.Info:k.info(_);break;case v.Warning:k.warn(_);break;case v.Error:k.error(_);break;case v.Off:break;default:throw new Error(`Invalid log level ${C}`)}}e.log=o;function g(k,C=!1){let _="";for(let T=0;T<k.length;T++){let U=k[T];if(U instanceof Error&&(U=(0,P.toErrorMessage)(U,C)),typeof U=="object")try{U=JSON.stringify(U)}catch{}_+=(T>0?" ":"")+U}return _}class a extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(C){this.level!==C&&(this.level=C,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(C){return this.level!==v.Off&&this.level<=C}}e.AbstractLogger=a;class b extends a{constructor(C){super(),this.logAlways=C}checkLogLevel(C){return this.logAlways||super.checkLogLevel(C)}trace(C,..._){this.checkLogLevel(v.Trace)&&this.log(v.Trace,g([C,..._],!0))}debug(C,..._){this.checkLogLevel(v.Debug)&&this.log(v.Debug,g([C,..._]))}info(C,..._){this.checkLogLevel(v.Info)&&this.log(v.Info,g([C,..._]))}warn(C,..._){this.checkLogLevel(v.Warning)&&this.log(v.Warning,g([C,..._]))}error(C,..._){if(this.checkLogLevel(v.Error))if(C instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=C.stack,this.log(v.Error,g(T))}else this.log(v.Error,g([C,..._]))}flush(){}}e.AbstractMessageLogger=b;class E extends a{constructor(C=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(C),this.useColors=!I.isWindows}trace(C,..._){this.checkLogLevel(v.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,C,..._):console.log(`[main ${d()}]`,C,..._))}debug(C,..._){this.checkLogLevel(v.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,C,..._):console.log(`[main ${d()}]`,C,..._))}info(C,..._){this.checkLogLevel(v.Info)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,C,..._):console.log(`[main ${d()}]`,C,..._))}warn(C,..._){this.checkLogLevel(v.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,C,..._):console.warn(`[main ${d()}]`,C,..._))}error(C,..._){this.checkLogLevel(v.Error)&&(this.useColors?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,C,..._):console.error(`[main ${d()}]`,C,..._))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class w extends a{constructor(C=e.DEFAULT_LOG_LEVEL,_=!0){super(),this.useColors=_,this.setLevel(C)}trace(C,..._){this.checkLogLevel(v.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",C,..._):console.log(C,..._))}debug(C,..._){this.checkLogLevel(v.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",C,..._):console.log(C,..._))}info(C,..._){this.checkLogLevel(v.Info)&&(this.useColors?console.log("%c INFO","color: #33f",C,..._):console.log(C,..._))}warn(C,..._){this.checkLogLevel(v.Warning)&&(this.useColors?console.log("%c WARN","color: #993",C,..._):console.log(C,..._))}error(C,..._){this.checkLogLevel(v.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",C,..._):console.error(C,..._))}dispose(){}flush(){}}e.ConsoleLogger=w;class t extends a{constructor(C,_=e.DEFAULT_LOG_LEVEL){super(),this.adapter=C,this.setLevel(_)}trace(C,..._){this.checkLogLevel(v.Trace)&&this.adapter.log(v.Trace,[this.extractMessage(C),..._])}debug(C,..._){this.checkLogLevel(v.Debug)&&this.adapter.log(v.Debug,[this.extractMessage(C),..._])}info(C,..._){this.checkLogLevel(v.Info)&&this.adapter.log(v.Info,[this.extractMessage(C),..._])}warn(C,..._){this.checkLogLevel(v.Warning)&&this.adapter.log(v.Warning,[this.extractMessage(C),..._])}error(C,..._){this.checkLogLevel(v.Error)&&this.adapter.log(v.Error,[this.extractMessage(C),..._])}extractMessage(C){return typeof C=="string"?C:(0,P.toErrorMessage)(C,this.checkLogLevel(v.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class u extends a{constructor(C){super(),this.loggers=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const _ of this.loggers)_.setLevel(C);super.setLevel(C)}trace(C,..._){for(const T of this.loggers)T.trace(C,..._)}debug(C,..._){for(const T of this.loggers)T.debug(C,..._)}info(C,..._){for(const T of this.loggers)T.info(C,..._)}warn(C,..._){for(const T of this.loggers)T.warn(C,..._)}error(C,..._){for(const T of this.loggers)T.error(C,..._)}flush(){for(const C of this.loggers)C.flush()}dispose(){for(const C of this.loggers)C.dispose()}}e.MultiplexLogger=u;class r extends A.Disposable{constructor(C,_,T){if(super(),this.logLevel=C,this.logsHome=_,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,T)for(const U of T)this._loggers.set(U.resource,{logger:void 0,info:U})}getLoggerEntry(C){return(0,l.isString)(C)?[...this._loggers.values()].find(_=>_.info.id===C):this._loggers.get(C)}getLogger(C){return this.getLoggerEntry(C)?.logger}createLogger(C,_){const T=this.toResource(C),U=(0,l.isString)(C)?C:_?.id??(0,s.hash)(T.toString()).toString(16);let q=this._loggers.get(T)?.logger;const se=_?.logLevel==="always"?v.Trace:_?.logLevel;q||(q=this.doCreateLogger(T,se??this.getLogLevel(T)??this.logLevel,{..._,id:U}));const ie={logger:q,info:{resource:T,id:U,logLevel:se,name:_?.name,hidden:_?.hidden,extensionId:_?.extensionId,when:_?.when}};return this.registerLogger(ie.info),this._loggers.set(T,ie),q}toResource(C){return(0,l.isString)(C)?(0,h.joinPath)(this.logsHome,`${C}.log`):C}setLogLevel(C,_){if(m.URI.isUri(C)){const T=C,U=_,q=this._loggers.get(T);q&&U!==q.info.logLevel&&(q.info.logLevel=U===this.logLevel?void 0:U,q.logger?.setLevel(U),this._loggers.set(q.info.resource,q),this._onDidChangeLogLevel.fire([T,U]))}else{this.logLevel=C;for(const[T,U]of this._loggers.entries())this._loggers.get(T)?.info.logLevel===void 0&&U.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(C,_){const T=this.getLoggerEntry(C);T&&_!==!T.info.hidden&&(T.info.hidden=!_,this._loggers.set(T.info.resource,T),this._onDidChangeVisibility.fire([T.info.resource,_]))}getLogLevel(C){let _;return C&&(_=this._loggers.get(C)?.info.logLevel),_??this.logLevel}registerLogger(C){const _=this._loggers.get(C.resource);_?_.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this._loggers.set(C.resource,{info:C,logger:void 0}),this._onDidChangeLoggers.fire({added:[C],removed:[]}))}deregisterLogger(C){const _=this._loggers.get(C);_&&(_.logger&&_.logger.dispose(),this._loggers.delete(C),this._onDidChangeLoggers.fire({added:[],removed:[_.info]}))}*getRegisteredLoggers(){for(const C of this._loggers.values())yield C.info}getRegisteredLogger(C){return this._loggers.get(C)?.info}dispose(){this._loggers.forEach(C=>C.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=r;class i{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(C){}getLevel(){return v.Info}trace(C,..._){}debug(C,..._){}info(C,..._){}warn(C,..._){}error(C,..._){}critical(C,..._){}dispose(){}flush(){}}e.NullLogger=i;class n extends i{}e.NullLogService=n;function c(k){if(k.verbose)return v.Trace;if(typeof k.logLevel=="string"){const C=D(k.logLevel.toLowerCase());if(C!==void 0)return C}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function p(k){switch(k){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=p;function D(k){switch(k){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=D,e.CONTEXT_LOG_LEVEL=new f.RawContextKey("logLevel",p(v.Info))});var J=this&&this.__param||function(j,e){return function(P,L){e(P,L,j)}};define(ee[217],te([0,1,75,4,2,5,3,8]),function(j,e,P,L,s,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let h=e.BaseCredentialsMainService=class dt extends s.Disposable{constructor(m){super(),this.logService=m,this._onDidChangePassword=this._register(new L.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this._sequencer=new I.SequencerByKey}async getPassword(m,f){this.logService.trace("Going to get password from keytar:",m,f);let S;try{S=await this.withKeytar()}catch{return null}return await this._sequencer.queue(m+f,()=>this.doGetPassword(S,m,f))}async doGetPassword(m,f,S){this.logService.trace("Doing get password from keytar:",f,S);const d=await(0,I.retry)(()=>m.getPassword(f,S),50,3);if(!d)return this.logService.trace("Did not get a password from keytar for account:",S),d;let y,v;try{const o=JSON.parse(d);y=o.content,v=o.hasNextChunk}catch{}if(!y||!v)return this.logService.trace("Got password from keytar for account:",S),d;try{let o=1;for(;v;){const g=await(0,I.retry)(()=>m.getPassword(f,`${S}-${o}`),50,3),a=JSON.parse(g);y+=a.content,v=a.hasNextChunk,o++}return this.logService.trace(`Got ${o}-chunked password from keytar for account:`,S),y}catch(o){return this.logService.error(o),d}}async setPassword(m,f,S){this.logService.trace("Going to set password using keytar:",m,f);let d;try{d=await this.withKeytar()}catch(y){throw this.surfaceKeytarLoadError?.(y),y}await this._sequencer.queue(m+f,()=>this.doSetPassword(d,m,f,S)),this._onDidChangePassword.fire({service:m,account:f})}async doSetPassword(m,f,S,d){if(this.logService.trace("Doing set password from keytar:",f,S),!R.isWindows){await(0,I.retry)(()=>m.setPassword(f,S,d),50,3),this.logService.trace("Set password from keytar for account:",S);return}if(await this.doDeletePassword(m,f,S),d.length<=dt.PASSWORD_CHUNK_SIZE){await(0,I.retry)(()=>m.setPassword(f,S,d),50,3),this.logService.trace("Set password from keytar for account:",S);return}let y=0,v=0,o=!0;for(;o;){const g=d.substring(y,y+dt.PASSWORD_CHUNK_SIZE);y+=dt.PASSWORD_CHUNK_SIZE,o=d.length-y>0;const a={content:g,hasNextChunk:o};await(0,I.retry)(()=>m.setPassword(f,v?`${S}-${v}`:S,JSON.stringify(a)),50,3),v++}this.logService.trace(`Set${v?` ${v}-chunked`:""} password from keytar for account:`,S)}async deletePassword(m,f){this.logService.trace("Going to delete password using keytar:",m,f);let S;try{S=await this.withKeytar()}catch(y){throw this.surfaceKeytarLoadError?.(y),y}const d=await this._sequencer.queue(m+f,()=>this.doDeletePassword(S,m,f));return d&&this._onDidChangePassword.fire({service:m,account:f}),d}async doDeletePassword(m,f,S){this.logService.trace("Doing delete password from keytar:",f,S);const d=await m.getPassword(f,S);if(!d)return this.logService.trace("Did not get a password to delete from keytar for account:",S),!1;let y,v;try{const g=JSON.parse(d);y=g.content,v=g.hasNextChunk}catch{}let o=0;if(y&&v)try{for(o++;v;){const g=`${S}-${o}`,a=await m.getPassword(f,g);await m.deletePassword(f,g),v=JSON.parse(a).hasNextChunk,o++}}catch(g){this.logService.error(g)}return await m.deletePassword(f,S)?(this.logService.trace(`Deleted${o?` ${o}-chunked`:""} password from keytar for account:`,S),!0):(this.logService.trace(`Keytar failed to delete${o?` ${o}-chunked`:""} password for account:`,S),!1)}async findPassword(m){let f;try{f=await this.withKeytar()}catch{return null}return await f.findPassword(m)}async findCredentials(m){let f;try{f=await this.withKeytar()}catch{return[]}return await f.findCredentials(m)}clear(){return this._keytarCache instanceof P.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};h.MAX_PASSWORD_LENGTH=2500,h.PASSWORD_CHUNK_SIZE=h.MAX_PASSWORD_LENGTH-100,e.BaseCredentialsMainService=h=Se([J(0,A.ILogService)],h)}),define(ee[218],te([0,1,14,3,5]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;const A=P.safeStorage;let R=e.EncryptionMainService=class{constructor(h,l){this.machineId=h,this.logService=l,P.app.commandLine.getSwitchValue("password-store")==="basic_text"&&A.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.logService.trace("[EncryptionMainService] Encrypting value.");try{const l=JSON.stringify(A.encryptString(h));return this.logService.trace("[EncryptionMainService] Encrypted value."),l}catch(l){throw this.logService.error(l),l}}async decrypt(h){let l;try{if(l=JSON.parse(h),!l.data)return this.logService.trace("[EncryptionMainService] Unable to parse encrypted value. Attempting old decryption."),this.oldDecrypt(h)}catch(f){return this.logService.trace("[EncryptionMainService] Unable to parse encrypted value. Attempting old decryption.",f),this.oldDecrypt(h)}const m=Buffer.from(l.data);this.logService.trace("[EncryptionMainService] Decrypting value.");try{const f=A.decryptString(m);return this.logService.trace("[EncryptionMainService] Decrypted value."),f}catch(f){throw this.logService.error(f),f}}isEncryptionAvailable(){return Promise.resolve(A.isEncryptionAvailable())}getKeyStorageProvider(){if(L.isWindows)return Promise.resolve("dpapi");if(L.isMacintosh)return Promise.resolve("keychain_access");if(A.getSelectedStorageBackend)try{const h=A.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.logService.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(L.isWindows)throw new Error("Setting plain text encryption is not supported on Windows.");if(L.isMacintosh)throw new Error("Setting plain text encryption is not supported on macOS.");if(!A.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");A.setUsePlainTextEncryption(!0)}async oldDecrypt(h){let l;try{l=await new Promise((m,f)=>j(["vscode-encrypt"],m,f))}catch{return h}try{return l.decrypt(this.machineId,h)}catch(m){return this.logService.error(m),h}}};e.EncryptionMainService=R=Se([J(1,s.ILogService)],R)}),define(ee[219],te([0,1,24,8,13,4,2,9,76,5]),function(j,e,P,L,s,A,R,I,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class m extends R.Disposable{constructor(S,d){super(),this.logService=S,this.options=d,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new L.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(S,d){return d.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,d):this.watchNonRecursive(S,d)}watchUniversal(S,d){const y={path:this.toFilePath(S),excludes:d.excludes,includes:d.includes,recursive:d.recursive},v=(0,P.insert)(this.universalPathsToWatch,y);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{v(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,s.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(d=>this._onDidChangeFile.fire((0,h.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const d of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const d of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(d)&&S.includes(d.path)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,d){const y={path:this.toFilePath(S),excludes:d.excludes,includes:d.includes,recursive:!1},v=(0,P.insert)(this.nonRecursivePathsToWatch,y);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{v(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,s.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,h.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,I.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=m}),define(ee[220],te([0,1,24,8,17,21,4,56,68,2,62,15,65,19,61,173,16,117,5,13]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o,g,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let E=e.FileService=class extends l.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new R.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new R.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new R.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(t,u){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${t}`);const r=new l.DisposableStore;return this.provider.set(t,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:u}),r.add(u.onDidChangeFile(i=>this._onDidFilesChange.fire(new o.FileChangesEvent(i,!this.isPathCaseSensitive(u))))),typeof u.onDidWatchError=="function"&&r.add(u.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),r.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:t}))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:u}),this.provider.delete(t),(0,l.dispose)(r)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(r){u.push(r)}}),!this.provider.has(t)&&await L.Promises.settled(u)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,u){const r=this.provider.get(t.scheme);return!!(r&&r.capabilities&u)}listCapabilities(){return h.Iterable.map(this.provider,([t,u])=>({scheme:t,capabilities:u.capabilities}))}async withProvider(t){if(!(0,d.isAbsolutePath)(t))throw new o.FileOperationError((0,v.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const u=this.provider.get(t.scheme);if(!u){const r=new b.ErrorNoTelemetry;throw r.message=(0,v.localize)(1,null,t.toString()),r}return u}async withReadProvider(t){const u=await this.withProvider(t);if((0,o.hasOpenReadWriteCloseCapability)(u)||(0,o.hasReadWriteCapability)(u)||(0,o.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const u=await this.withProvider(t);if((0,o.hasOpenReadWriteCloseCapability)(u)||(0,o.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,u){try{return await this.doResolveFile(t,u)}catch(r){throw(0,o.toFileSystemProviderErrorCode)(r)===o.FileSystemProviderErrorCode.FileNotFound?new o.FileOperationError((0,v.localize)(2,null,this.resourceForError(t)),1):(0,o.ensureFileSystemProviderError)(r)}}async doResolveFile(t,u){const r=await this.withProvider(t),i=this.isPathCaseSensitive(r),n=u?.resolveTo,c=u?.resolveSingleChildDescendants,p=u?.resolveMetadata,D=await r.stat(t);let k;return this.toFileStat(r,t,D,void 0,!!p,(C,_)=>(k||(k=m.TernarySearchTree.forUris(()=>!i),k.set(t,!0),n&&k.fill(!0,n)),k.get(C.resource)||k.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&c?_===1:!1))}async toFileStat(t,u,r,i,n,c){const{providerExtUri:p}=this.getExtUri(t),D={resource:u,name:p.basename(u),isFile:(r.type&o.FileType.File)!==0,isDirectory:(r.type&o.FileType.Directory)!==0,isSymbolicLink:(r.type&o.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&o.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((r.permissions??0)&o.FilePermission.Locked),etag:(0,o.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(D.isDirectory&&c(D,i)){try{const k=await t.readdir(u),C=await L.Promises.settled(k.map(async([_,T])=>{try{const U=p.joinPath(u,_),q=n?await t.stat(U):{type:T};return await this.toFileStat(t,U,q,k.length,n,c)}catch(U){return this.logService.trace(U),null}}));D.children=(0,P.coalesce)(C)}catch(k){this.logService.trace(k),D.children=[]}return D}return D}async resolveAll(t){return L.Promises.settled(t.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(t){const u=await this.withProvider(t),r=await u.stat(t);return this.toFileStat(u,t,r,void 0,!0,()=>!1)}async exists(t){const u=await this.withProvider(t);try{return!!await u.stat(t)}catch{return!1}}async canCreateFile(t,u){try{await this.doValidateCreateFile(t,u)}catch(r){return r}return!0}async doValidateCreateFile(t,u){if(!u?.overwrite&&await this.exists(t))throw new o.FileOperationError((0,v.localize)(3,null,this.resourceForError(t)),3,u)}async createFile(t,u=s.VSBuffer.fromString(""),r){await this.doValidateCreateFile(t,r);const i=await this.writeFile(t,u);return this._onDidRunOperation.fire(new o.FileOperationEvent(t,0,i)),i}async writeFile(t,u,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,t,r)||await this.mkdirp(i,n.dirname(t));let p;if((0,o.hasReadWriteCapability)(i)&&!(u instanceof s.VSBuffer))if((0,y.isReadableStream)(u)){const D=await(0,y.peekStream)(u,3);D.ended?p=s.VSBuffer.concat(D.buffer):p=D}else p=(0,y.peekReadable)(u,D=>s.VSBuffer.concat(D),3);else p=u;if(!(0,o.hasOpenReadWriteCloseCapability)(i)||(0,o.hasReadWriteCapability)(i)&&p instanceof s.VSBuffer)await this.doWriteUnbuffered(i,t,r,p);else{const D=p instanceof s.VSBuffer?(0,s.bufferToReadable)(p):p;r?.atomic!==!1&&r?.atomic?.postfix?await this.doWriteBufferedAtomic(i,t,(0,d.joinPath)((0,d.dirname)(t),`${(0,d.basename)(t)}${r.atomic.postfix}`),r,D):await this.doWriteBuffered(i,t,r,D)}this._onDidRunOperation.fire(new o.FileOperationEvent(t,4))}catch(c){throw new o.FileOperationError((0,v.localize)(4,null,this.resourceForError(t),(0,o.ensureFileSystemProviderError)(c).toString()),(0,o.toFileOperationResult)(c),r)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,u,r){const i=!!r?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(u)));if(!!r?.atomic){if(!(t.capabilities&32768))throw new Error((0,v.localize)(6,null,this.resourceForError(u)));if(i)throw new Error((0,v.localize)(7,null,this.resourceForError(u)))}let c;try{c=await t.stat(u)}catch{return}if(c.type&o.FileType.Directory)throw new o.FileOperationError((0,v.localize)(8,null,this.resourceForError(u)),0,r);if(this.throwIfFileIsReadonly(u,c),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==o.ETAG_DISABLED&&typeof c.mtime=="number"&&typeof c.size=="number"&&r.mtime<c.mtime&&r.etag!==(0,o.etag)({mtime:r.mtime,size:c.size}))throw new o.FileOperationError((0,v.localize)(9,null),3,r);return c}async readFile(t,u,r){const i=await this.withReadProvider(t);return u?.atomic?this.doReadFileAtomic(i,t,u,r):this.doReadFile(i,t,u,r)}async doReadFileAtomic(t,u,r,i){return new Promise((n,c)=>{this.writeQueue.queueFor(u,this.getExtUri(t).providerExtUri).queue(async()=>{try{const p=await this.doReadFile(t,u,r,i);n(p)}catch(p){c(p)}})})}async doReadFile(t,u,r,i){const n=await this.doReadFileStream(t,u,{...r,preferUnbuffered:!0},i);return{...n,value:await(0,s.streamToBuffer)(n.value)}}async readFileStream(t,u,r){const i=await this.withReadProvider(t);return this.doReadFileStream(i,t,u,r)}async doReadFileStream(t,u,r,i){const n=new A.CancellationTokenSource(i),c=this.validateReadFile(u,r).then(D=>D,D=>{throw n.cancel(),D});let p;try{return typeof r?.etag=="string"&&r.etag!==o.ETAG_DISABLED&&await c,r?.atomic&&(0,o.hasFileAtomicReadCapability)(t)||!((0,o.hasOpenReadWriteCloseCapability)(t)||(0,o.hasFileReadStreamCapability)(t))||(0,o.hasReadWriteCapability)(t)&&r?.preferUnbuffered?p=this.readFileUnbuffered(t,u,r):(0,o.hasFileReadStreamCapability)(t)?p=this.readFileStreamed(t,u,n.token,r):p=this.readFileBuffered(t,u,n.token,r),{...await c,value:p}}catch(D){throw p&&await(0,y.consumeStream)(p),this.restoreReadError(D,u,r)}}restoreReadError(t,u,r){const i=(0,v.localize)(10,null,this.resourceForError(u),(0,o.ensureFileSystemProviderError)(t).toString());return t instanceof o.NotModifiedSinceFileOperationError?new o.NotModifiedSinceFileOperationError(i,t.stat,r):t instanceof o.TooLargeFileOperationError?new o.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new o.FileOperationError(i,(0,o.toFileOperationResult)(t),r)}readFileStreamed(t,u,r,i=Object.create(null)){const n=t.readFileStream(u,i,r);return(0,y.transform)(n,{data:c=>c instanceof s.VSBuffer?c:s.VSBuffer.wrap(c),error:c=>this.restoreReadError(c,u,i)},c=>s.VSBuffer.concat(c))}readFileBuffered(t,u,r,i=Object.create(null)){const n=(0,s.newWriteableBufferStream)();return(0,g.readFileIntoStream)(t,u,n,c=>c,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:c=>this.restoreReadError(c,u,i)},r),n}readFileUnbuffered(t,u,r){const i=(0,y.newWriteableStream)(n=>s.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,o.hasFileAtomicReadCapability)(t)?n=await t.readFile(u,{atomic:!0}):n=await t.readFile(u),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(u,n.byteLength,r),i.end(s.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(t,u){const r=await this.resolve(t,{resolveMetadata:!0});if(r.isDirectory)throw new o.FileOperationError((0,v.localize)(11,null,this.resourceForError(t)),0,u);if(typeof u?.etag=="string"&&u.etag!==o.ETAG_DISABLED&&u.etag===r.etag)throw new o.NotModifiedSinceFileOperationError((0,v.localize)(12,null),r,u);return this.validateReadFileLimits(t,r.size,u),r}validateReadFileLimits(t,u,r){if(typeof r?.limits?.size=="number"&&u>r.limits.size)throw new o.TooLargeFileOperationError((0,v.localize)(13,null,this.resourceForError(t)),7,u,r)}async canMove(t,u,r){return this.doCanMoveCopy(t,u,"move",r)}async canCopy(t,u,r){return this.doCanMoveCopy(t,u,"copy",r)}async doCanMoveCopy(t,u,r,i){if(t.toString()!==u.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(n,t,c,u,r,i)}catch(n){return n}return!0}async move(t,u,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),c=await this.doMoveCopy(i,t,n,u,"move",!!r),p=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new o.FileOperationEvent(t,c==="move"?2:3,p)),p}async copy(t,u,r){const i=await this.withReadProvider(t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),c=await this.doMoveCopy(i,t,n,u,"copy",!!r),p=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new o.FileOperationEvent(t,c==="copy"?3:2,p)),p}async doMoveCopy(t,u,r,i,n,c){if(u.toString()===i.toString())return n;const{exists:p,isSameResourceWithDifferentPathCase:D}=await this.doValidateMoveCopy(t,u,r,i,n,c);if(p&&!D&&c&&await this.del(i,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(i)),n==="copy"){if(t===r&&(0,o.hasFileFolderCopyCapability)(t))await t.copy(u,i,{overwrite:c});else{const k=await this.resolve(u);k.isDirectory?await this.doCopyFolder(t,k,r,i):await this.doCopyFile(t,u,r,i)}return n}else return t===r?(await t.rename(u,i,{overwrite:c}),n):(await this.doMoveCopy(t,u,r,i,"copy",c),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(t,u,r,i){if((0,o.hasOpenReadWriteCloseCapability)(t)&&(0,o.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(t,u,r,i);if((0,o.hasOpenReadWriteCloseCapability)(t)&&(0,o.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(t,u,r,i);if((0,o.hasReadWriteCapability)(t)&&(0,o.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(t,u,r,i);if((0,o.hasReadWriteCapability)(t)&&(0,o.hasReadWriteCapability)(r))return this.doPipeUnbuffered(t,u,r,i)}async doCopyFolder(t,u,r,i){await r.mkdir(i),Array.isArray(u.children)&&await L.Promises.settled(u.children.map(async n=>{const c=this.getExtUri(r).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(t,await this.resolve(n.resource),r,c):this.doCopyFile(t,n.resource,r,c)}))}async doValidateMoveCopy(t,u,r,i,n,c){let p=!1;if(t===r){const{providerExtUri:k,isPathCaseSensitive:C}=this.getExtUri(t);if(C||(p=k.isEqual(u,i)),p&&n==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(u),this.resourceForError(i)));if(!p&&k.isEqualOrParent(i,u))throw new Error((0,v.localize)(15,null,this.resourceForError(u),this.resourceForError(i)))}const D=await this.exists(i);if(D&&!p){if(!c)throw new o.FileOperationError((0,v.localize)(16,null,this.resourceForError(u),this.resourceForError(i)),4);if(t===r){const{providerExtUri:k}=this.getExtUri(t);if(k.isEqualOrParent(u,i))throw new Error((0,v.localize)(17,null,this.resourceForError(u),this.resourceForError(i)))}}return{exists:D,isSameResourceWithDifferentPathCase:p}}getExtUri(t){const u=this.isPathCaseSensitive(t);return{providerExtUri:u?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(u,t);const r=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new o.FileOperationEvent(t,0,r)),r}async mkdirp(t,u){const r=[],{providerExtUri:i}=this.getExtUri(t);for(;!i.isEqual(u,i.dirname(u));)try{if(!((await t.stat(u)).type&o.FileType.Directory))throw new Error((0,v.localize)(18,null,this.resourceForError(u)));break}catch(n){if((0,o.toFileSystemProviderErrorCode)(n)!==o.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(i.basename(u)),u=i.dirname(u)}for(let n=r.length-1;n>=0;n--){u=i.joinPath(u,r[n]);try{await t.mkdir(u)}catch(c){if((0,o.toFileSystemProviderErrorCode)(c)!==o.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(t,u){try{await this.doValidateDelete(t,u)}catch(r){return r}return!0}async doValidateDelete(t,u){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t),i=!!u?.useTrash;if(i&&!(r.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(t)));const n=u?.atomic;if(n&&!(r.capabilities&65536))throw new Error((0,v.localize)(20,null,this.resourceForError(t)));if(i&&n)throw new Error((0,v.localize)(21,null,this.resourceForError(t)));let c;try{c=await r.stat(t)}catch{}if(c)this.throwIfFileIsReadonly(t,c);else throw new o.FileOperationError((0,v.localize)(22,null,this.resourceForError(t)),1);if(!!!u?.recursive){const D=await this.resolve(t);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,v.localize)(23,null,this.resourceForError(t)))}return r}async del(t,u){const r=await this.doValidateDelete(t,u),i=!!u?.useTrash,n=!!u?.recursive,c=u?.atomic??!1;await r.delete(t,{recursive:n,useTrash:i,atomic:c}),this._onDidRunOperation.fire(new o.FileOperationEvent(t,1))}async cloneFile(t,u){const r=await this.withProvider(t),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);if(r===i&&this.getExtUri(r).providerExtUri.isEqual(t,u))return;if(r===i&&(0,o.hasFileCloneCapability)(r))return r.cloneFile(t,u);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(u));const n=this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri);return r===i&&(0,o.hasFileFolderCopyCapability)(r)?n.queue(()=>r.copy(t,u,{overwrite:!0})):n.queue(()=>this.doCopyFile(r,t,i,u))}watch(t,u={recursive:!1,excludes:[]}){const r=new l.DisposableStore;let i=!1,n=()=>{i=!0};return r.add((0,l.toDisposable)(()=>n())),(async()=>{try{const c=await this.doWatch(t,u);i?(0,l.dispose)(c):n=()=>(0,l.dispose)(c)}catch(c){this.logService.error(c)}})(),r}async doWatch(t,u){const r=await this.withProvider(t),i=(0,I.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(t),u]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:r.watch(t,u)},this.activeWatchers.set(i,n)),n.count+=1,(0,l.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,l.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,l.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBufferedAtomic(t,u,r,i,n){await this.doWriteBuffered(t,r,i,n);try{await t.rename(r,u,{overwrite:!0})}catch(c){try{await t.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw c}}async doWriteBuffered(t,u,r,i){return this.writeQueue.queueFor(u,this.getExtUri(t).providerExtUri).queue(async()=>{const n=await t.open(u,{create:!0,unlock:r?.unlock??!1});try{(0,y.isReadableStream)(i)||(0,y.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(t,n,i):await this.doWriteReadableBufferedQueued(t,n,i)}catch(c){throw(0,o.ensureFileSystemProviderError)(c)}finally{await t.close(n)}})}async doWriteStreamBufferedQueued(t,u,r){let i=0,n;if((0,y.isReadableBufferedStream)(r)){if(r.buffer.length>0){const c=s.VSBuffer.concat(r.buffer);await this.doWriteBuffer(t,u,c,c.byteLength,i,0),i+=c.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((c,p)=>{(0,y.listenStream)(n,{onData:async D=>{n.pause();try{await this.doWriteBuffer(t,u,D,D.byteLength,i,0)}catch(k){return p(k)}i+=D.byteLength,setTimeout(()=>n.resume())},onError:D=>p(D),onEnd:()=>c()})})}async doWriteReadableBufferedQueued(t,u,r){let i=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(t,u,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(t,u,r,i,n,c){let p=0;for(;p<i;){const D=await t.write(u,n+p,r.buffer,c+p,i-p);p+=D}}async doWriteUnbuffered(t,u,r,i){return this.writeQueue.queueFor(u,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,u,r,i))}async doWriteUnbufferedQueued(t,u,r,i){let n;i instanceof s.VSBuffer?n=i:(0,y.isReadableStream)(i)?n=await(0,s.streamToBuffer)(i):(0,y.isReadableBufferedStream)(i)?n=await(0,s.bufferedStreamToBuffer)(i):n=(0,s.readableToBuffer)(i),await t.writeFile(u,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async doPipeBuffered(t,u,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,u,r,i))}async doPipeBufferedQueued(t,u,r,i){let n,c;try{n=await t.open(u,{create:!1}),c=await r.open(i,{create:!0,unlock:!1});const p=s.VSBuffer.alloc(this.BUFFER_SIZE);let D=0,k=0,C=0;do C=await t.read(n,D,p.buffer,k,p.byteLength-k),await this.doWriteBuffer(r,c,p,C,D,k),D+=C,k+=C,k===p.byteLength&&(k=0);while(C>0)}catch(p){throw(0,o.ensureFileSystemProviderError)(p)}finally{await L.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof c=="number"?r.close(c):Promise.resolve()])}}async doPipeUnbuffered(t,u,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,u,r,i))}async doPipeUnbufferedQueued(t,u,r,i){return r.writeFile(i,await t.readFile(u),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(t,u,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,u,r,i))}async doPipeUnbufferedToBufferedQueued(t,u,r,i){const n=await r.open(i,{create:!0,unlock:!1});try{const c=await t.readFile(u);await this.doWriteBuffer(r,n,s.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,o.ensureFileSystemProviderError)(c)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(t,u,r,i){const n=await(0,s.streamToBuffer)(this.readFileBuffered(t,u,A.CancellationToken.None));await this.doWriteUnbuffered(r,i,void 0,n)}throwIfFileSystemIsReadonly(t,u){if(t.capabilities&2048)throw new o.FileOperationError((0,v.localize)(24,null,this.resourceForError(u)),6);return t}throwIfFileIsReadonly(t,u){if((u.permissions??0)&o.FilePermission.Readonly)throw new o.FileOperationError((0,v.localize)(25,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===f.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=E=Se([J(0,a.ILogService)],E)}),define(ee[93],te([0,1,42,308,8,35,17,4,32,2,9,3,19,61,22,177,16,117,219,50,214,213]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o,g,a,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(P)}catch(u){console.error(`Error enabling graceful-fs: ${(0,b.toErrorMessage)(u)}`)}})();class t extends a.AbstractDiskFileSystemProvider{constructor(r,i){super(r,i),this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new A.ResourceMap(n=>S.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,f.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:i,symbolicLink:n}=await y.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:o.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await y.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async c=>{try{let p;c.isSymbolicLink()?p=(await this.stat((0,S.joinPath)(r,c.name))).type:p=this.toType(c),n.push([c.name,p])}catch(p){this.logService.trace(p)}})),n}catch(i){throw this.toFileSystemProviderError(i)}}toType(r,i){let n;return i?.dangling?n=o.FileType.Unknown:r.isFile()?n=o.FileType.File:r.isDirectory()?n=o.FileType.Directory:n=o.FileType.Unknown,i&&(n|=o.FileType.SymbolicLink),n}async createResourceLock(r){const i=this.toFilePath(r);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.resourceLocks.get(r);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const c=new s.Barrier;return this.resourceLocks.set(r,c),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(r)===c&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(r)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),c.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),n=await this.createResourceLock(r));const c=this.toFilePath(r);return await y.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{n?.dispose()}}traceLock(r){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(r)}readFileStream(r,i,n){const c=(0,d.newWriteableStream)(p=>R.VSBuffer.concat(p.map(D=>R.VSBuffer.wrap(D))).buffer);return(0,g.readFileIntoStream)(this,r,c,p=>p.buffer,{...i,bufferSize:256*1024},n),c}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.doWriteFileAtomic(r,(0,S.joinPath)((0,S.dirname)(r),`${(0,S.basename)(r)}${n.atomic.postfix}`),i,n):this.doWriteFile(r,i,n)}async doWriteFileAtomic(r,i,n,c){await this.doWriteFile(i,n,c);try{await this.rename(i,r,{overwrite:!0})}catch(p){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw p}}async doWriteFile(r,i,n){let c;try{const p=this.toFilePath(r);if(!n.create||!n.overwrite){if(await y.Promises.exists(p)){if(!n.overwrite)throw(0,o.createFileSystemProviderError)((0,v.localize)(0,null),o.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,o.createFileSystemProviderError)((0,v.localize)(1,null),o.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(r,{create:!0,unlock:n.unlock}),await this.write(c,0,i,0,i.byteLength)}catch(p){throw await this.toFileSystemProviderWriteError(r,p)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(r){t.canFlush=r}async open(r,i){const n=this.toFilePath(r);let c;(0,o.isFileOpenForWriteOptions)(i)&&(c=await this.createResourceLock(r));let p;try{if((0,o.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:k}=await y.SymlinkSupport.stat(n);k.mode&128||await y.Promises.chmod(n,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}let D;if((0,o.isFileOpenForWriteOptions)(i)){if(f.isWindows)try{await y.Promises.truncate(n,0),D="r+"}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}D||(D="w")}else D="r";p=await y.Promises.open(n,D)}catch(D){throw c?.dispose(),(0,o.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(r,D):this.toFileSystemProviderError(D)}if(this.mapHandleToPos.set(p,0),(0,o.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(p,r),c){const D=this.mapHandleToLock.get(p);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${p} (${n})`),this.mapHandleToLock.set(p,c),D&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${p} (${n})`),D.dispose())}return p}async close(r){const i=this.mapHandleToLock.get(r);try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&t.canFlush)try{await y.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.logService.error(n)}return await y.Promises.close(r)}catch(n){throw this.toFileSystemProviderError(n)}finally{i&&(this.mapHandleToLock.get(r)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.mapHandleToLock.delete(r)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,c,p){const D=this.normalizePos(r,i);let k=null;try{k=(await y.Promises.read(r,n,c,p,D)).bytesRead}catch(C){throw this.toFileSystemProviderError(C)}finally{this.updatePos(r,D,k)}return k}normalizePos(r,i){return i===this.mapHandleToPos.get(r)?null:i}updatePos(r,i,n){const c=this.mapHandleToPos.get(r);typeof c=="number"&&(typeof i=="number"||(typeof n=="number"?this.mapHandleToPos.set(r,c+n):this.mapHandleToPos.delete(r)))}async write(r,i,n,c,p){return(0,s.retry)(()=>this.doWrite(r,i,n,c,p),100,3)}async doWrite(r,i,n,c,p){const D=this.normalizePos(r,i);let k=null;try{k=(await y.Promises.write(r,n,c,p,D)).bytesWritten}catch(C){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),C)}finally{this.updatePos(r,D,k)}return k}async mkdir(r){try{await y.Promises.mkdir(this.toFilePath(r))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(r,i){try{const n=this.toFilePath(r);if(i.recursive){let c;i?.atomic!==!1&&i.atomic.postfix&&(c=(0,m.join)((0,m.dirname)(n),`${(0,m.basename)(n)}${i.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,c)}else try{await y.Promises.unlink(n)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let p=!1;try{const{stat:D,symbolicLink:k}=await y.SymlinkSupport.stat(n);p=D.isDirectory()&&!k}catch{}if(p)await y.Promises.rmdir(n);else throw c}else throw c}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(r,i,n){const c=this.toFilePath(r),p=this.toFilePath(i);if(c!==p)try{await this.validateMoveCopy(r,i,"move",n.overwrite),await y.Promises.move(c,p)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,v.localize)(2,null,(0,m.basename)(c),(0,m.basename)((0,m.dirname)(p)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(r,i,n){const c=this.toFilePath(r),p=this.toFilePath(i);if(c!==p)try{await this.validateMoveCopy(r,i,"copy",n.overwrite),await y.Promises.copy(c,p,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,v.localize)(3,null,(0,m.basename)(c),(0,m.basename)((0,m.dirname)(p)),D.toString()))),this.toFileSystemProviderError(D)}}async validateMoveCopy(r,i,n,c){const p=this.toFilePath(r),D=this.toFilePath(i);let k=!1;if(!!(this.capabilities&1024)||(k=(0,h.isEqual)(p,D,!0)),k){if(n==="copy")throw(0,o.createFileSystemProviderError)((0,v.localize)(4,null),o.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const _=await this.statIgnoreError(r);if(!_)throw(0,o.createFileSystemProviderError)((0,v.localize)(5,null),o.FileSystemProviderErrorCode.FileNotFound);const T=await this.statIgnoreError(i);if(T){if(!c)throw(0,o.createFileSystemProviderError)((0,v.localize)(6,null),o.FileSystemProviderErrorCode.FileExists);_.type&o.FileType.File&&T.type&o.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.doCloneFile(r,i,!1)}async doCloneFile(r,i,n){const c=this.toFilePath(r),p=this.toFilePath(i),D=!!(this.capabilities&1024);if((0,h.isEqual)(c,p,!D))return;const k=new l.DisposableStore;try{const[C,_]=await Promise.all([this.createResourceLock(r),this.createResourceLock(i)]);k.add(C),k.add(_),n&&await y.Promises.mkdir((0,m.dirname)(p),{recursive:!0}),await y.Promises.copyFile(c,p)}catch(C){if(C.code==="ENOENT"&&!n)return this.doCloneFile(r,i,!0);throw this.toFileSystemProviderError(C)}finally{k.dispose()}}createUniversalWatcher(r,i,n){return new E.UniversalWatcherClient(c=>r(c),c=>i(c),n)}createNonRecursiveWatcher(r,i,n){return new w.NodeJSWatcherClient(c=>r(c),c=>i(c),n)}toFileSystemProviderError(r){if(r instanceof o.FileSystemProviderError)return r;let i=r,n;switch(r.code){case"ENOENT":n=o.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=o.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=o.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=o.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=o.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=o.FileSystemProviderErrorCode.Unknown;break;default:n=o.FileSystemProviderErrorCode.Unknown}return(0,o.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(r,i){let n=this.toFileSystemProviderError(i);if(r&&n.code===o.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await y.SymlinkSupport.stat(this.toFilePath(r));c.mode&128||(n=(0,o.createFileSystemProviderError)(i,o.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return n}}e.DiskFileSystemProvider=t,t.TRACE_LOG_RESOURCE_LOCKS=!1,t.canFlush=!0}),define(ee[221],te([0,1,4,93,2,17,61,21]),function(j,e,P,L,s,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class h extends s.Disposable{constructor(f,S){super(),this.provider=f,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(f,S,d){const y=this.getUriTransformer(f);switch(S){case"stat":return this.stat(y,d[0]);case"readdir":return this.readdir(y,d[0]);case"open":return this.open(y,d[0],d[1]);case"close":return this.close(d[0]);case"read":return this.read(d[0],d[1],d[2]);case"readFile":return this.readFile(y,d[0],d[1]);case"write":return this.write(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.writeFile(y,d[0],d[1],d[2]);case"rename":return this.rename(y,d[0],d[1],d[2]);case"copy":return this.copy(y,d[0],d[1],d[2]);case"cloneFile":return this.cloneFile(y,d[0],d[1]);case"mkdir":return this.mkdir(y,d[0]);case"delete":return this.delete(y,d[0],d[1]);case"watch":return this.watch(y,d[0],d[1],d[2],d[3]);case"unwatch":return this.unwatch(d[0],d[1])}throw new Error(`IPC Command ${S} not found`)}listen(f,S,d){const y=this.getUriTransformer(f);switch(S){case"fileChange":return this.onFileChange(y,d[0]);case"readFileStream":return this.onReadFileStream(y,d[0],d[1])}throw new Error(`Unknown event ${S}`)}stat(f,S){const d=this.transformIncoming(f,S,!0);return this.provider.stat(d)}readdir(f,S){const d=this.transformIncoming(f,S);return this.provider.readdir(d)}async readFile(f,S,d){const y=this.transformIncoming(f,S,!0),v=await this.provider.readFile(y,d);return A.VSBuffer.wrap(v)}onReadFileStream(f,S,d){const y=this.transformIncoming(f,S,!0),v=new I.CancellationTokenSource,o=new P.Emitter({onDidRemoveLastListener:()=>{v.cancel()}}),g=this.provider.readFileStream(y,d,v.token);return(0,R.listenStream)(g,{onData:a=>o.fire(A.VSBuffer.wrap(a)),onError:a=>o.fire(a),onEnd:()=>{o.fire("end"),o.dispose(),v.dispose()}}),o.event}writeFile(f,S,d,y){const v=this.transformIncoming(f,S);return this.provider.writeFile(v,d.buffer,y)}open(f,S,d){const y=this.transformIncoming(f,S,!0);return this.provider.open(y,d)}close(f){return this.provider.close(f)}async read(f,S,d){const y=A.VSBuffer.alloc(d),v=0,o=await this.provider.read(f,S,y.buffer,v,d);return[y,o]}write(f,S,d,y,v){return this.provider.write(f,S,d.buffer,y,v)}mkdir(f,S){const d=this.transformIncoming(f,S);return this.provider.mkdir(d)}delete(f,S,d){const y=this.transformIncoming(f,S);return this.provider.delete(y,d)}rename(f,S,d,y){const v=this.transformIncoming(f,S),o=this.transformIncoming(f,d);return this.provider.rename(v,o,y)}copy(f,S,d,y){const v=this.transformIncoming(f,S),o=this.transformIncoming(f,d);return this.provider.copy(v,o,y)}cloneFile(f,S,d){const y=this.transformIncoming(f,S),v=this.transformIncoming(f,d);return this.provider.cloneFile(y,v)}onFileChange(f,S){const d=new P.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(f,d))},onDidRemoveLastListener:()=>{(0,s.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return d.event}async watch(f,S,d,y,v){const o=this.sessionToWatcher.get(S);if(o){const g=this.transformIncoming(f,y),a=o.watch(d,g,v);this.watchRequests.set(S+d,a)}}async unwatch(f,S){const d=f+S,y=this.watchRequests.get(d);y&&((0,s.dispose)(y),this.watchRequests.delete(d))}dispose(){super.dispose();for(const[,f]of this.watchRequests)f.dispose();this.watchRequests.clear();for(const[,f]of this.sessionToWatcher)f.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=h;class l extends s.Disposable{constructor(f,S,d,y){super(),this.uriTransformer=f,this.logService=d,this.environmentService=y,this.watcherRequests=new Map,this.fileWatcher=this._register(new L.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(f){const S=this._register(new P.Emitter);this._register(S.event(d=>{f.fire(d.map(y=>({resource:this.uriTransformer.transformOutgoingURI(y.resource),type:y.type})))})),this._register(this.fileWatcher.onDidChangeFile(d=>S.fire(d))),this._register(this.fileWatcher.onDidWatchError(d=>f.fire(d)))}getRecursiveWatcherOptions(f){}getExtraExcludes(f){}watch(f,S,d){const y=this.getExtraExcludes(this.environmentService);return Array.isArray(y)&&(d.excludes=[...d.excludes,...y]),this.watcherRequests.set(f,this.fileWatcher.watch(S,d)),(0,s.toDisposable)(()=>{(0,s.dispose)(this.watcherRequests.get(f)),this.watcherRequests.delete(f)})}dispose(){super.dispose();for(const[,f]of this.watcherRequests)f.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=l}),define(ee[222],te([0,1,14,176,3,7,16,9,221,153]),function(j,e,P,L,s,A,R,I,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class m extends h.AbstractDiskFileSystemProviderChannel{constructor(d,y,v){super(d,y),this.environmentService=v}getUriTransformer(d){return l.DefaultURITransformer}transformIncoming(d,y){return A.URI.revive(y)}async delete(d,y,v){if(!v.useTrash)return super.delete(d,y,v);const o=this.transformIncoming(d,y),g=(0,I.normalize)(o.fsPath);try{await P.shell.trashItem(g)}catch{throw(0,R.createFileSystemProviderError)(s.isWindows?(0,L.localize)(0,null,(0,I.basename)(g)):(0,L.localize)(1,null,(0,I.basename)(g)),R.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(d,y){return new f(d,y,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=m;class f extends h.AbstractSessionFileWatcher{watch(d,y,v){if(v.recursive)throw(0,R.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",R.FileSystemProviderErrorCode.Unavailable);return super.watch(d,y,v)}}}),define(ee[223],te([0,1,5]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class L extends P.AbstractMessageLogger{constructor(A=P.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(A),this._register(this.onDidChangeLogLevel(R=>{this._logger?.setLevel(R)}))}set logger(A){this._logger=A;for(const{level:R,message:I}of this.buffer)(0,P.log)(A,R,I);this.buffer=[]}log(A,R){this._logger?(0,P.log)(this._logger,A,R):this.getLevel()<=A&&this.buffer.push({level:A,message:R})}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=L}),define(ee[224],te([0,1,7,4,5,2]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class R extends s.AbstractLoggerService{constructor(f,S,d,y,v){super(S,d,y),this.windowId=f,this.channel=v,this._register(v.listen("onDidChangeLogLevel",f)(o=>{(0,s.isLogLevel)(o)?super.setLogLevel(o):super.setLogLevel(P.URI.revive(o[0]),o[1])})),this._register(v.listen("onDidChangeVisibility",f)(([o,g])=>super.setVisibility(P.URI.revive(o),g))),this._register(v.listen("onDidChangeLoggers",f)(({added:o,removed:g})=>{for(const a of o)super.registerLogger({...a,resource:P.URI.revive(a.resource)});for(const a of g)super.deregisterLogger(a.resource)}))}createConsoleMainLogger(){return new s.AdapterLogger({log:(f,S)=>{this.channel.call("consoleLog",[f,S])}})}registerLogger(f){super.registerLogger(f),this.channel.call("registerLogger",[f,this.windowId])}deregisterLogger(f){super.deregisterLogger(f),this.channel.call("deregisterLogger",[f,this.windowId])}setLogLevel(f,S){super.setLogLevel(f,S),this.channel.call("setLogLevel",[f,S])}setVisibility(f,S){super.setVisibility(f,S),this.channel.call("setVisibility",[this.toResource(f),S])}doCreateLogger(f,S,d){return new I(this.channel,f,S,d,this.windowId)}static setLogLevel(f,S,d){return f.call("setLogLevel",[S,d])}}e.LoggerChannelClient=R;class I extends s.AbstractMessageLogger{constructor(f,S,d,y,v){super(y?.logLevel==="always"),this.channel=f,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[S,y,v]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,S){const d=[[f,S]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(f){this.channel.call("log",[this.file,f])}}class h{constructor(f,S){this.loggerService=f,this.getUriTransformer=S}listen(f,S){const d=this.getUriTransformer(f);switch(S){case"onDidChangeLoggers":return L.Event.map(this.loggerService.onDidChangeLoggers,y=>({added:[...y.added].map(v=>this.transformLogger(v,d)),removed:[...y.removed].map(v=>this.transformLogger(v,d))}));case"onDidChangeVisibility":return L.Event.map(this.loggerService.onDidChangeVisibility,y=>[d.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return L.Event.map(this.loggerService.onDidChangeLogLevel,y=>(0,s.isLogLevel)(y)?y:[d.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${S}`)}async call(f,S,d){const y=this.getUriTransformer(f);switch(S){case"setLogLevel":return(0,s.isLogLevel)(d[0])?this.loggerService.setLogLevel(d[0]):this.loggerService.setLogLevel(P.URI.revive(y.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(v=>this.transformLogger(v,y)))}throw new Error(`Call not found: ${S}`)}transformLogger(f,S){return{...f,resource:S.transformOutgoingURI(f.resource)}}}e.LoggerChannel=h;class l extends A.Disposable{constructor(f,S){super(),S.call("setLogLevel",[f.getLogLevel()]),this._register(f.onDidChangeLogLevel(d=>S.call("setLogLevel",[d]))),S.call("getRegisteredLoggers").then(d=>{for(const y of d)f.registerLogger({...y,resource:P.URI.revive(y.resource)})}),this._register(S.listen("onDidChangeVisibility")(([d,y])=>f.setVisibility(P.URI.revive(d),y))),this._register(S.listen("onDidChangeLoggers")(({added:d,removed:y})=>{for(const v of d)f.registerLogger({...v,resource:P.URI.revive(v.resource)});for(const v of y)f.deregisterLogger(v.resource)}))}}e.RemoteLoggerChannelClient=l}),define(ee[225],te([0,1,2,5]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class s extends P.Disposable{constructor(R,I=[]){super(),this.logger=new L.MultiplexLogger([R,...I]),this._register(R.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(R){this.logger.setLevel(R)}getLevel(){return this.logger.getLevel()}trace(R,...I){this.logger.trace(R,...I)}debug(R,...I){this.logger.debug(R,...I)}info(R,...I){this.logger.info(R,...I)}warn(R,...I){this.logger.warn(R,...I)}error(R,...I){this.logger.error(R,...I)}flush(){this.logger.flush()}}e.LogService=s}),define(ee[226],te([0,1,35,7,5]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class A{constructor(I){this.loggerService=I,this.loggers=new P.ResourceMap}listen(I,h,l){switch(h){case"onDidChangeLoggers":return l?this.loggerService.getOnDidChangeLoggersEvent(l):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.loggerService.getOnDidChangeLogLevelEvent(l):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.loggerService.getOnDidChangeVisibilityEvent(l):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(I,h,l){switch(h){case"createLogger":this.createLogger(L.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.log(L.URI.revive(l[0]),l[1]);case"consoleLog":return this.consoleLog(l[0],l[1]);case"setLogLevel":return(0,s.isLogLevel)(l[0])?this.loggerService.setLogLevel(l[0]):this.loggerService.setLogLevel(L.URI.revive(l[0]),l[1]);case"setVisibility":return this.loggerService.setVisibility(L.URI.revive(l[0]),l[1]);case"registerLogger":return this.loggerService.registerLogger({...l[0],resource:L.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(L.URI.revive(l[0]))}throw new Error(`Call not found: ${h}`)}createLogger(I,h,l){this.loggers.set(I,this.loggerService.createLogger(I,h,l))}consoleLog(I,h){let l=console.log;switch(I){case s.LogLevel.Error:l=console.error;break;case s.LogLevel.Warning:l=console.warn;break;case s.LogLevel.Info:l=console.info;break}l.call(console,...h)}log(I,h){const l=this.loggers.get(I);if(!l)throw new Error("Create the logger before logging");for(const[m,f]of h)(0,s.log)(l,m,f)}}e.LoggerChannel=A}),define(ee[227],te([0,1,16,5]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var s;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(s||(s={}));async function A(l,m,f,S,d){try{const y=await new Promise((o,g)=>{j(["@vscode/spdlog"],o,g)});y.setFlushOn(s.Trace);const v=await y.createAsyncRotatingLogger(l,m,f,S);return d?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(y){console.error(y)}return null}function R(l,m,f){switch(m){case L.LogLevel.Trace:l.trace(f);break;case L.LogLevel.Debug:l.debug(f);break;case L.LogLevel.Info:l.info(f);break;case L.LogLevel.Warning:l.warn(f);break;case L.LogLevel.Error:l.error(f);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function I(l,m){switch(m){case L.LogLevel.Trace:l.setLevel(s.Trace);break;case L.LogLevel.Debug:l.setLevel(s.Debug);break;case L.LogLevel.Info:l.setLevel(s.Info);break;case L.LogLevel.Warning:l.setLevel(s.Warning);break;case L.LogLevel.Error:l.setLevel(s.Error);break;case L.LogLevel.Off:l.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class h extends L.AbstractMessageLogger{constructor(m,f,S,d,y){super(),this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(m,f,S,d),this._register(this.onDidChangeLogLevel(v=>{this._logger&&I(this._logger,v)}))}async _createSpdLogLogger(m,f,S,d){const y=S?6:1,v=30/y*P.ByteSize.MB,o=await A(m,f,v,y,d);if(o){this._logger=o,I(this._logger,this.getLevel());for(const{level:g,message:a}of this.buffer)R(this._logger,g,a);this.buffer=[]}}log(m,f){this._logger?R(this._logger,m,f):this.getLevel()<=m&&this.buffer.push({level:m,message:f})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=h}),define(ee[228],te([0,1,31,5,227]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends L.AbstractLoggerService{doCreateLogger(I,h,l){return new s.SpdLogLogger((0,P.generateUuid)(),I.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,h)}}e.LoggerService=A}),define(ee[66],te([0,1,35,4,6,5,228]),function(j,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,s.refineServiceDecorator)(A.ILoggerService);class I extends R.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new P.ResourceMap}createLogger(l,m,f){f!==void 0&&this.loggerResourcesByWindow.set(this.toResource(l),f);try{return super.createLogger(l,m)}catch(S){throw this.loggerResourcesByWindow.delete(this.toResource(l)),S}}registerLogger(l,m){m!==void 0&&this.loggerResourcesByWindow.set(l.resource,m),super.registerLogger(l)}deregisterLogger(l){this.loggerResourcesByWindow.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const m=[];for(const f of super.getRegisteredLoggers())l===this.loggerResourcesByWindow.get(f.resource)&&m.push(f);return m}getOnDidChangeLogLevelEvent(l){return L.Event.filter(this.onDidChangeLogLevel,m=>(0,A.isLogLevel)(m)||this.isInterestedLoggerResource(m[0],l))}getOnDidChangeVisibilityEvent(l){return L.Event.filter(this.onDidChangeVisibility,([m])=>this.isInterestedLoggerResource(m,l))}getOnDidChangeLoggersEvent(l){return L.Event.filter(L.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter(S=>this.isInterestedLoggerResource(S.resource,l)),removed:[...m.removed].filter(S=>this.isInterestedLoggerResource(S.resource,l))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(l){for(const[m,f]of this.loggerResourcesByWindow)f===l&&this.deregisterLogger(m)}isInterestedLoggerResource(l,m){const f=this.loggerResourcesByWindow.get(l);return f===void 0||f===m}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=I}),define(ee[229],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function P(R){return R.submenu!==void 0}e.isMenubarMenuItemSubmenu=P;function L(R){return R.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function s(R){return R.uri!==void 0}e.isMenubarMenuItemRecentAction=s;function A(R){return!P(R)&&!L(R)&&!s(R)}e.isMenubarMenuItemAction=A}),define(ee[39],te([0,1,4,68,2,6]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class R extends s.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(l){const m=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...l,...this.policyDefinitions},m!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(l),L.Iterable.reduce(this.policies.entries(),(f,[S,d])=>({...f,[S]:d}),{})}getPolicyValue(l){return this.policies.get(l)}serialize(){return L.Iterable.reduce(Object.entries(this.policyDefinitions),(l,[m,f])=>({...l,[m]:{definition:f,value:this.policies.get(m)}}),{})}}e.AbstractPolicyService=R;class I{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(ee[230],te([0,1,8,4,68,11,16,5,39]),function(j,e,P,L,s,A,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(f,S){const d=[];for(const y of new Set(s.Iterable.concat(f.keys(),S.keys())))f.get(y)!==S.get(y)&&d.push(y);return d}let m=e.FilePolicyService=class extends h.AbstractPolicyService{constructor(S,d,y){super(),this.file=S,this.fileService=d,this.logService=y,this.throttledDelayer=this._register(new P.ThrottledDelayer(500));const v=L.Event.filter(d.onDidFilesChange,o=>o.affects(S));this._register(d.watch(S)),this._register(v(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const S=new Map;try{const d=await this.fileService.readFile(this.file),y=JSON.parse(d.value.toString());if(!(0,A.isObject)(y))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(y))this.policyDefinitions[v]&&S.set(v,y[v])}catch(d){d.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",d)}return S}async refresh(){const S=await this.read(),d=l(this.policies,S);this.policies=S,d.length>0&&this._onDidChange.fire(d)}};e.FilePolicyService=m=Se([J(1,R.IFileService),J(2,I.ILogService)],m)}),define(ee[231],te([0,1,4,2,39]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(h){this.service=h,this.disposables=new L.DisposableStore}listen(h,l){switch(l){case"onDidChange":return P.Event.map(this.service.onDidChange,m=>m.reduce((f,S)=>({...f,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${l}`)}call(h,l,m){switch(l){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${l}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=A;class R extends s.AbstractPolicyService{constructor(h,l){super(),this.channel=l;for(const m in h){const{definition:f,value:S}=h[m];this.policyDefinitions[m]=f,S!==void 0&&this.policies.set(m,S)}this.channel.listen("onDidChange")(m=>{for(const f in m){const S=m[f];S===null?this.policies.delete(f):this.policies.set(f,S)}this._onDidChange.fire(Object.keys(m))})}async _updatePolicyDefinitions(h){const l=await this.channel.call("updatePolicyDefinitions",h);for(const m in l)this.policies.set(m,l[m])}}e.PolicyChannelClient=R}),define(ee[232],te([0,1,39,8,309,2,5]),function(j,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let I=e.NativePolicyService=class extends P.AbstractPolicyService{constructor(l,m){super(),this.logService=l,this.productName=m,this.throttler=new L.Throttler,this.watcher=this._register(new A.MutableDisposable)}async _updatePolicyDefinitions(l){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.throttler.queue(()=>new Promise((m,f)=>{try{this.watcher.value=(0,s.createWatcher)(this.productName,l,S=>{this._onDidPolicyChange(S),m()})}catch(S){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",S),f(S)}}))}_onDidPolicyChange(l){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const m in l){const f=l[m];f===void 0?this.policies.delete(m):this.policies.set(m,f)}this._onDidChange.fire(Object.keys(l))}};e.NativePolicyService=I=Se([J(0,R.ILogService)],I)}),define(ee[77],te([0,1,3,36]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof P.globals.vscode<"u"&&typeof P.globals.vscode.context<"u"){const A=P.globals.vscode.context.configuration();if(A)s=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){s=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:A,searchUrl:R,itemUrl:I,controlUrl:h}=s.extensionsGallery||{};Object.assign(s,{extensionsGallery:{serviceUrl:L.env.VSCODE_GALLERY_SERVICE_URL||A,searchUrl:L.env.VSCODE_GALLERY_SEARCH_URL||R,itemUrl:L.env.VSCODE_GALLERY_ITEM_URL||I,controlUrl:L.env.VSCODE_GALLERY_CONTROL_URL||h}});try{const l=(...f)=>f.reduce((S,d)=>(Object.keys(d).forEach(y=>{Array.isArray(S[y])&&Array.isArray(d[y])?S[y]=d[y]:typeof S[y]=="object"&&typeof d[y]=="object"?S[y]=l(S[y],d[y]):S[y]=d[y]}),S),{}),m=globalThis._VSCODE_USER_PRODUCT_JSON||{};s=l(s,m)}catch{}if(L.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const l=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:l.version,release:l.release})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.80.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(ee[23],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,P.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[233],te([0,1,71,5,23]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let A=e.ExtensionUrlTrustService=class{constructor(I,h){this.productService=I,this.logService=h,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(I,h){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const l=/^(.*)#([^#]+)$/.exec(h);if(!l)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,m,f]=l;let S=this.trustedExtensionUrlPublicKeys.get(I);if(!S){if(S=this.productService.trustedExtensionUrlPublicKeys[I],!S||S.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.trustedExtensionUrlPublicKeys.set(I,[...S])}const d=Buffer.from(decodeURIComponent(f),"base64");if(d.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const y=d.slice(0,6),v=d.readUIntBE(0,6),o=Date.now()-v;if(o<0||o>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const g=d.slice(6),a=P.createVerify("SHA256");a.write(y),a.write(Buffer.from(m)),a.end();for(let b=0;b<S.length;b++){let E=S[b];if(E!==null){if(typeof E=="string")try{E=P.createPublicKey({key:Buffer.from(E,"base64"),format:"der",type:"spki"}),S[b]=E}catch(w){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${b+1} for ${I}:`,w),S[b]=null;continue}if(a.verify(E,g))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};e.ExtensionUrlTrustService=A=Se([J(0,s.IProductService),J(1,L.ILogService)],A)}),define(ee[234],te([0,1,8,5]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let s=e.WindowProfiler=class{constructor(R,I,h){this._window=R,this._sessionId=I,this._logService=h}async inspect(R){await this._connect();const I=this._window.webContents.debugger;await I.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,P.timeout)(R);const h=await I.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),h.profile}async _connect(){const R=this._window.webContents.debugger;R.attach(),await R.sendCommand("Profiler.enable")}async _disconnect(){const R=this._window.webContents.debugger;await R.sendCommand("Profiler.disable"),R.detach()}};e.WindowProfiler=s=Se([J(2,L.ILogService)],s)}),define(ee[78],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,P.createDecorator)("protocolMainService")}),define(ee[44],te([0,1,134,11]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class s{constructor(){this.data=new Map}add(R,I){P.ok(L.isString(R)),P.ok(L.isObject(I)),P.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,I)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new s}),define(ee[235],te([0,1,4,44]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function s(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class A{constructor(){this._onDidChangeSchema=new P.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,l){this.schemasById[s(h)]=l,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new A;L.Registry.add(e.Extensions.JSONContribution,R)}),define(ee[57],te([0,1,24,4,11,161,18,235,44]),function(j,e,P,L,s,A,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var l;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m||(e.ConfigurationScope=m={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const f=h.Registry.as(I.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,u=!0){this.registerConfigurations([t],u)}registerConfigurations(t,u=!0){const r=new Set;this.doRegisterConfigurations(t,u,r),f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(t){const u=new Set;this.doDeregisterConfigurations(t,u),f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:t,remove:u}){const r=new Set;this.doDeregisterConfigurations(u,r),this.doRegisterConfigurations(t,!1,r),f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}registerDefaultConfigurations(t){const u=new Set;this.doRegisterDefaultConfigurations(t,u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,u){const r=[];for(const{overrides:i,source:n}of t)for(const c in i)if(u.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const p=this.configurationDefaultsOverrides.get(c),D=p?.valuesSources??new Map;if(n)for(const T of Object.keys(i[c]))D.set(T,n);const k={...p?.value||{},...i[c]};this.configurationDefaultsOverrides.set(c,{source:n,value:k,valuesSources:D});const C=(0,R.getLanguageTagSettingPlainKey)(c),_={type:"object",default:k,description:A.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:k,source:s.isString(n)?void 0:n,defaultValueSource:n};r.push(...v(c)),this.configurationProperties[c]=_,this.defaultLanguageConfigurationOverridesNode.properties[c]=_}else{this.configurationDefaultsOverrides.set(c,{value:i[c],source:n});const p=this.configurationProperties[c];p&&(this.updatePropertyDefaultValue(c,p),this.updateSchema(c,p))}this.doRegisterOverrideIdentifiers(r)}deregisterDefaultConfigurations(t){const u=new Set;this.doDeregisterDefaultConfigurations(t,u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,u){for(const{overrides:r,source:i}of t)for(const n in r){const c=this.configurationDefaultsOverrides.get(n),p=s.isString(i)?i:i?.id,D=s.isString(c?.source)?c?.source:c?.source?.id;if(p===D)if(u.add(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const k=this.configurationProperties[n];k&&(this.updatePropertyDefaultValue(n,k),this.updateSchema(n,k))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let u=!1;const r=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,r),u=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,r),u=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,r),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const u of t)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,u,r){t.forEach(i=>{this.validateAndRegisterProperties(i,u,i.extensionInfo,i.restrictedProperties,void 0,r),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(t,u){const r=i=>{if(i.properties)for(const n in i.properties){u.add(n);const c=this.configurationProperties[n];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.configurationContributors.indexOf(i);n!==-1&&this.configurationContributors.splice(n,1)}}validateAndRegisterProperties(t,u=!0,r,i,n=3,c){n=s.isUndefinedOrNull(t.scope)?n:t.scope;const p=t.properties;if(p)for(const k in p){const C=p[k];if(u&&b(k,C)){delete p[k];continue}if(C.source=r,C.defaultDefaultValue=p[k].default,this.updatePropertyDefaultValue(k,C),e.OVERRIDE_PROPERTY_REGEX.test(k)?C.scope=void 0:(C.scope=s.isUndefinedOrNull(C.scope)?n:C.scope,C.restricted=s.isUndefinedOrNull(C.restricted)?!!i?.includes(k):C.restricted),p[k].hasOwnProperty("included")&&!p[k].included){this.excludedConfigurationProperties[k]=p[k],delete p[k];continue}else this.configurationProperties[k]=p[k],p[k].policy?.name&&this.policyConfigurations.set(p[k].policy.name,k);!p[k].deprecationMessage&&p[k].markdownDeprecationMessage&&(p[k].deprecationMessage=p[k].markdownDeprecationMessage),c.add(k)}const D=t.allOf;if(D)for(const k of D)this.validateAndRegisterProperties(k,u,r,i,n,c)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const u=r=>{const i=r.properties;if(i)for(const c in i)this.updateSchema(c,i[c]);r.allOf?.forEach(u)};u(t)}updateSchema(t,u){switch(e.allSettings.properties[t]=u,u.scope){case 1:e.applicationSettings.properties[t]=u;break;case 2:e.machineSettings.properties[t]=u;break;case 6:e.machineOverridableSettings.properties[t]=u;break;case 3:e.windowSettings.properties[t]=u;break;case 4:e.resourceSettings.properties[t]=u;break;case 5:e.resourceSettings.properties[t]=u,this.resourceLanguageSettingsSchema.properties[t]=u;break}}removeFromSchema(t,u){switch(delete e.allSettings.properties[t],u.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const u=`[${t}]`,r={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,r),e.allSettings.properties[u]=r,e.applicationSettings.properties[u]=r,e.machineSettings.properties[u]=r,e.machineOverridableSettings.properties[u]=r,e.windowSettings.properties[u]=r,e.resourceSettings.properties[u]=r}}registerOverridePropertyPatternKey(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,u){const r=this.configurationDefaultsOverrides.get(t);let i=r?.value,n=r?.source;s.isUndefined(i)&&(i=u.defaultDefaultValue,n=void 0),s.isUndefined(i)&&(i=g(u.type)),u.default=i,u.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",y=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(w){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let u=y.exec(w);for(;u?.length;){const r=u[1].trim();r&&t.push(r),u=y.exec(w)}}return(0,P.distinct)(t)}e.overrideIdentifiersFromKey=v;function o(w){return w.reduce((t,u)=>`${t}[${u}]`,"")}e.keyFromOverrideIdentifiers=o;function g(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const a=new S;h.Registry.add(e.Extensions.Configuration,a);function b(w,t){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?A.localize(7,null,w):a.getConfigurationProperties()[w]!==void 0?A.localize(8,null,w):t.policy?.name&&a.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,w,t.policy?.name,a.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=b;function E(){const w=[],t=a.getConfigurationProperties();for(const u of Object.keys(t))w.push([u,t[u].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=E}),define(ee[118],te([0,1,24,4,45,2,35,37,11,7,18,57,44]),function(j,e,P,L,s,A,R,I,h,l,m,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function d(u){return Object.isFrozen(u)?u:I.deepFreeze(u)}class y{constructor(r={},i=[],n=[],c){this._contents=r,this._keys=i,this._overrides=n,this.raw=c,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof y)return i;const n=new v("");return n.parseRaw(i),n.configurationModel});this._rawConfiguration=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,m.getConfigurationValue)(this.contents,r):this.contents}inspect(r,i){const n=this.rawConfiguration.getValue(r),c=i?this.rawConfiguration.getOverrideValue(r,i):void 0,p=i?this.rawConfiguration.override(i).getValue(r):n;return{value:n,override:c,merged:p}}getOverrideValue(r,i){const n=this.getContentsForOverrideIdentifer(i);return n?r?(0,m.getConfigurationValue)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return P.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return P.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=I.deepClone(this.contents),n=I.deepClone(this.overrides),c=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const D of r)if(p.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.mergeContents(i,D.contents);for(const k of D.overrides){const[C]=n.filter(_=>P.equals(_.identifiers,k.identifiers));C?(this.mergeContents(C.contents,k.contents),C.keys.push(...k.keys),C.keys=P.distinct(C.keys)):n.push(I.deepClone(k))}for(const k of D.keys)c.indexOf(k)===-1&&c.push(k)}return new y(i,c,n,p.every(D=>D instanceof y)?void 0:p)}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const c of P.distinct([...Object.keys(this.contents),...Object.keys(i)])){let p=this.contents[c];const D=i[c];D&&(typeof p=="object"&&typeof D=="object"?(p=I.deepClone(p),this.mergeContents(p,D)):p=D),n[c]=p}return new y(n,this.keys,this.overrides)}mergeContents(r,i){for(const n of Object.keys(i)){if(n in r&&h.isObject(r[n])&&h.isObject(i[n])){this.mergeContents(r[n],i[n]);continue}r[n]=I.deepClone(i[n])}}getContentsForOverrideIdentifer(r){let i=null,n=null;const c=p=>{p&&(n?this.mergeContents(n,p):n=I.deepClone(p))};for(const p of this.overrides)P.equals(p.identifiers,[r])?i=p.contents:p.identifiers.includes(r)&&c(p.contents);return c(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.updateValue(r,i,!0)}setValue(r,i){this.updateValue(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,m.removeFromValueTree)(this.contents,r),f.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>P.equals(n.identifiers,(0,f.overrideIdentifiersFromKey)(r))),1))}updateValue(r,i,n){(0,m.addToValueTree)(this.contents,r,i,c=>console.error(c)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),f.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,f.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,m.toValuesTree)(this.contents[r],c=>console.error(c))})}}e.ConfigurationModel=y;class v{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!h.isUndefinedOrNull(r)){const n=this.doParseContent(r);this.parseRaw(n,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:n,keys:c,overrides:p,restricted:D,hasExcludedProperties:k}=this.doParseRaw(r,i);this._configurationModel=new y(n,c,p,k?[r]:void 0),this._restrictedConfigurations=D||[]}doParseContent(r){let i={},n=null,c=[];const p=[],D=[];function k(_){Array.isArray(c)?c.push(_):n!==null&&(c[n]=_)}const C={onObjectBegin:()=>{const _={};k(_),p.push(c),c=_,n=null},onObjectProperty:_=>{n=_},onObjectEnd:()=>{c=p.pop()},onArrayBegin:()=>{const _=[];k(_),p.push(c),c=_,n=null},onArrayEnd:()=>{c=p.pop()},onLiteralValue:k,onError:(_,T,U)=>{D.push({error:_,offset:T,length:U})}};if(r)try{s.visit(r,C),i=c[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return i}doParseRaw(r,i){const n=S.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),c=this.filter(r,n,!0,i);r=c.raw;const p=(0,m.toValuesTree)(r,C=>console.error(`Conflict in settings file ${this._name}: ${C}`)),D=Object.keys(r),k=this.toOverrides(r,C=>console.error(`Conflict in settings file ${this._name}: ${C}`));return{contents:p,keys:D,overrides:k,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}filter(r,i,n,c){let p=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:p};const D={},k=[];for(const C in r)if(f.OVERRIDE_PROPERTY_REGEX.test(C)&&n){const _=this.filter(r[C],i,!1,c);D[C]=_.raw,p=p||_.hasExcludedProperties,k.push(..._.restricted)}else{const _=i[C],T=_?typeof _.scope<"u"?_.scope:3:void 0;_?.restricted&&k.push(C),(T===void 0||c.scopes===void 0||c.scopes.includes(T))&&!(c.skipRestricted&&_?.restricted)?D[C]=r[C]:p=!0}return{raw:D,restricted:k,hasExcludedProperties:p}}toOverrides(r,i){const n=[];for(const c of Object.keys(r))if(f.OVERRIDE_PROPERTY_REGEX.test(c)){const p={};for(const D in r[c])p[D]=r[c][D];n.push({identifiers:(0,f.overrideIdentifiersFromKey)(c),keys:Object.keys(p),contents:(0,m.toValuesTree)(p,i)})}return n}}e.ConfigurationModelParser=v;class o extends A.Disposable{constructor(r,i,n,c){super(),this.userSettingsResource=r,this.scopes=i,this.fileService=c,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.any(L.Event.filter(this.fileService.onDidFilesChange,p=>p.contains(this.userSettingsResource)),L.Event.filter(this.fileService.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&n.isEqual(p.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=o;class g{constructor(r,i,n,c,p,D,k,C,_,T,U,q,se){this.key=r,this.overrides=i,this._value=n,this.overrideIdentifiers=c,this.defaultConfiguration=p,this.policyConfiguration=D,this.applicationConfiguration=k,this.userConfiguration=C,this.localUserConfiguration=_,this.remoteUserConfiguration=T,this.workspaceConfiguration=U,this.folderConfigurationModel=q,this.memoryConfigurationModel=se}get value(){return d(this._value)}inspect(r,i,n){const c=r.inspect(i,n);return{get value(){return d(c.value)},get override(){return d(c.override)},get merged(){return d(c.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class a{constructor(r,i,n,c,p=new y,D=new y,k=new R.ResourceMap,C=new y,_=new R.ResourceMap){this._defaultConfiguration=r,this._policyConfiguration=i,this._applicationConfiguration=n,this._localUserConfiguration=c,this._remoteUserConfiguration=p,this._workspaceConfiguration=D,this._folderConfigurations=k,this._memoryConfiguration=C,this._memoryConfigurationByResource=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(r,i,n){return this.getConsolidatedConfigurationModel(r,i,n).getValue(r)}updateValue(r,i,n={}){let c;n.resource?(c=this._memoryConfigurationByResource.get(n.resource),c||(c=new y,this._memoryConfigurationByResource.set(n.resource,c))):c=this._memoryConfiguration,i===void 0?c.removeValue(r):c.setValue(r,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,n){const c=this.getConsolidatedConfigurationModel(r,i,n),p=this.getFolderConfigurationModelForResource(i.resource,n),D=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,k=new Set;for(const C of c.overrides)for(const _ of C.identifiers)c.getOverrideValue(r,_)!==void 0&&k.add(_);return new g(r,i,c.getValue(r),k.size?[...k]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this._workspaceConfiguration:void 0,p||void 0,D)}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:c,updated:p,removed:D}=w(this._defaultConfiguration,r);i=[...c,...p,...D]}for(const c of i)for(const p of(0,f.overrideIdentifiersFromKey)(c)){const D=this._defaultConfiguration.getKeysForOverrideIdentifier(p),k=r.getKeysForOverrideIdentifier(p),C=[...k.filter(_=>D.indexOf(_)===-1),...D.filter(_=>k.indexOf(_)===-1),...D.filter(_=>!I.equals(this._defaultConfiguration.override(p).getValue(_),r.override(p).getValue(_)))];n.push([p,C])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:c}=w(this._policyConfiguration,r),p=[...i,...n,...c];return p.length&&this.updatePolicyConfiguration(r),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:c,overrides:p}=w(this.applicationConfiguration,r),D=[...i,...n,...c];return D.length&&this.updateApplicationConfiguration(r),{keys:D,overrides:p}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:c,overrides:p}=w(this.localUserConfiguration,r),D=[...i,...n,...c];return D.length&&this.updateLocalUserConfiguration(r),{keys:D,overrides:p}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:c,overrides:p}=w(this.remoteUserConfiguration,r),D=[...i,...n,...c];return D.length&&this.updateRemoteUserConfiguration(r),{keys:D,overrides:p}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:c,overrides:p}=w(this.workspaceConfiguration,r),D=[...i,...n,...c];return D.length&&this.updateWorkspaceConfiguration(r),{keys:D,overrides:p}}compareAndUpdateFolderConfiguration(r,i){const n=this.folderConfigurations.get(r),{added:c,updated:p,removed:D,overrides:k}=w(n,i),C=[...c,...p,...D];return(C.length||!n)&&this.updateFolderConfiguration(r,i),{keys:C,overrides:k}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:c,removed:p,overrides:D}=w(i,void 0);return{keys:[...n,...c,...p],overrides:D}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,i,n){let c=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier&&(c=c.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(c=c.merge(this._policyConfiguration)),c}getConsolidatedConfigurationModelForResource({resource:r},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const c=i.getFolder(r);c&&(n=this.getFolderConsolidatedConfiguration(c.uri)||n);const p=this._memoryConfigurationByResource.get(r);p&&(n=n.merge(p))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(r);c?(i=n.merge(c),this._foldersConsolidatedConfigurations.set(r,i)):i=n}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:n,overrides:c,keys:p}=this._folderConfigurations.get(i);return r.push([i,{contents:n,overrides:c,keys:p}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this._workspaceConfiguration.keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(c=>i.add(c))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),n=this.parseConfigurationModel(r.policy),c=this.parseConfigurationModel(r.application),p=this.parseConfigurationModel(r.user),D=this.parseConfigurationModel(r.workspace),k=r.folders.reduce((C,_)=>(C.set(l.URI.revive(_[0]),this.parseConfigurationModel(_[1])),C),new R.ResourceMap);return new a(i,n,c,p,new y,D,k,new y,new R.ResourceMap)}static parseConfigurationModel(r){return new y(r.contents,r.keys,r.overrides)}}e.Configuration=a;function b(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const r=new Set,i=new Map;for(const c of u)c.keys.forEach(p=>r.add(p)),c.overrides.forEach(([p,D])=>{const k=(0,R.getOrSet)(i,p,new Set);D.forEach(C=>k.add(C))});const n=[];return i.forEach((c,p)=>n.push([p,[...c.values()]])),{keys:[...r.values()],overrides:n}}e.mergeChanges=b;class E{constructor(r,i,n,c){this.change=r,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=c,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const p of r.keys)this.affectedKeys.add(p);for(const[,p]of r.overrides)for(const D of p)this.affectedKeys.add(D);this._affectsConfigStr=this._marker;for(const p of this.affectedKeys)this._affectsConfigStr+=p+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=a.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){const n=this._marker+r,c=this._affectsConfigStr.indexOf(n);if(c<0)return!1;const p=c+n.length;if(p>=this._affectsConfigStr.length)return!1;const D=this._affectsConfigStr.charCodeAt(p);if(D!==this._markerCode1&&D!==this._markerCode2)return!1;if(i){const k=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,C=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!I.equals(k,C)}return!0}}e.ConfigurationChangeEvent=E;function w(u,r){const{added:i,removed:n,updated:c}=t(r?.rawConfiguration,u?.rawConfiguration),p=[],D=u?.getAllOverrideIdentifiers()||[],k=r?.getAllOverrideIdentifiers()||[];if(r){const C=k.filter(_=>!D.includes(_));for(const _ of C)p.push([_,r.getKeysForOverrideIdentifier(_)])}if(u){const C=D.filter(_=>!k.includes(_));for(const _ of C)p.push([_,u.getKeysForOverrideIdentifier(_)])}if(r&&u){for(const C of D)if(k.includes(C)){const _=t({contents:u.getOverrideValue(void 0,C)||{},keys:u.getKeysForOverrideIdentifier(C)},{contents:r.getOverrideValue(void 0,C)||{},keys:r.getKeysForOverrideIdentifier(C)});p.push([C,[..._.added,..._.removed,..._.updated]])}}return{added:i,removed:n,updated:c,overrides:p}}function t(u,r){const i=u?r?u.keys.filter(p=>r.keys.indexOf(p)===-1):[...u.keys]:[],n=r?u?r.keys.filter(p=>u.keys.indexOf(p)===-1):[...r.keys]:[],c=[];if(u&&r){for(const p of r.keys)if(u.keys.indexOf(p)!==-1){const D=(0,m.getConfigurationValue)(r.contents,p),k=(0,m.getConfigurationValue)(u.contents,p);I.equals(D,k)||c.push(p)}}return{added:i,removed:n,updated:c}}}),define(ee[236],te([0,1,24,4,2,37,11,118,57,5,39,44]),function(j,e,P,L,s,A,R,I,h,l,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class S extends s.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(f.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(({properties:o,defaultsOverrides:g})=>this.onDidUpdateConfiguration(Array.from(o),g))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(o,g){this.updateConfigurationModel(o,f.Registry.as(h.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:o})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new I.ConfigurationModel;const o=f.Registry.as(h.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(o),o)}updateConfigurationModel(o,g){const a=this.getConfigurationDefaultOverrides();for(const b of o){const E=a[b],w=g[b];E!==void 0?this._configurationModel.addValue(b,E):w?this._configurationModel.addValue(b,w.default):this._configurationModel.removeValue(b)}}}e.DefaultConfiguration=S;class d{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let y=e.PolicyConfiguration=class extends s.Disposable{get configurationModel(){return this._configurationModel}constructor(o,g,a){super(),this.defaultConfiguration=o,this.policyService=g,this.logService=a,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(o=>this.onDidChangePolicies(o))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:o})=>this.update(await this.updatePolicyDefinitions(o),!0))),this._configurationModel}async updatePolicyDefinitions(o){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",o);const g={},a=[],b=f.Registry.as(h.Extensions.Configuration).getConfigurationProperties();for(const E of o){const w=b[E];if(!w){a.push(E);continue}if(w.policy){if(w.type!=="string"&&w.type!=="number"){this.logService.warn(`Policy ${w.policy.name} has unsupported type ${w.type}`);continue}a.push(E),g[w.policy.name]={type:w.type}}}return(0,R.isEmptyObject)(g)||await this.policyService.updatePolicyDefinitions(g),a}onDidChangePolicies(o){this.logService.trace("PolicyConfiguration#onDidChangePolicies",o);const g=f.Registry.as(h.Extensions.Configuration).getPolicyConfigurations(),a=(0,P.coalesce)(o.map(b=>g.get(b)));this.update(a,!0)}update(o,g){this.logService.trace("PolicyConfiguration#update",o);const a=f.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),b=[],E=this._configurationModel.isEmpty();for(const w of o){const t=a[w]?.policy?.name;if(t){const u=this.policyService.getPolicyValue(t);(E?u!==void 0:!(0,A.equals)(this._configurationModel.getValue(w),u))&&b.push([w,u])}else this._configurationModel.getValue(w)!==void 0&&b.push([w,void 0])}if(b.length){this.logService.trace("PolicyConfiguration#changed",b);const w=this._configurationModel;this._configurationModel=new I.ConfigurationModel;for(const t of w.keys)this._configurationModel.setValue(t,w.getValue(t));for(const[t,u]of b)u===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,u);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=y=Se([J(1,m.IPolicyService),J(2,l.ILogService)],y)}),define(ee[237],te([0,1,8,4,2,19,18,118,236,39]),function(j,e,P,L,s,A,R,I,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class m extends s.Disposable{constructor(S,d,y,v){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new h.DefaultConfiguration),this.policyConfiguration=y instanceof l.NullPolicyService?new h.NullPolicyConfiguration:this._register(new h.PolicyConfiguration(this.defaultConfiguration,y,v)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,A.extUriBiasedIgnorePathCase,d)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new P.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:o,properties:g})=>this.onDidDefaultConfigurationChange(o,g))),this._register(this.policyConfiguration.onDidChangeConfiguration(o=>this.onDidPolicyConfigurationChange(o))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,d,y]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(S,d,new I.ConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(S,d){const y=typeof S=="string"?S:void 0,v=(0,R.isConfigurationOverrides)(S)?S:(0,R.isConfigurationOverrides)(d)?d:{};return this.configuration.getValue(y,v,void 0)}updateValue(S,d,y,v){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const d=this.configuration.toData(),y=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(y,d,2)}onDidDefaultConfigurationChange(S,d){const y=this.configuration.toData(),v=this.configuration.compareAndUpdateDefaultConfiguration(S,d);this.trigger(v,y,7)}onDidPolicyConfigurationChange(S){const d=this.configuration.toData(),y=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(y,d,7)}trigger(S,d,y){const v=new I.ConfigurationChangeEvent(S,{data:d},this.configuration);v.source=y,v.sourceConfig=this.getTargetConfiguration(y),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=m}),define(ee[238],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeRemoteResourceRouter=e.NODE_REMOTE_RESOURCE_CHANNEL_NAME=e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME=void 0,e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME="request",e.NODE_REMOTE_RESOURCE_CHANNEL_NAME="remoteResourceHandler";class P{async routeCall(s,A,R){if(A!==e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME)throw new Error(`Call not found: ${A}`);const I=R[0];if(I?.authority){const h=s.connections.find(l=>l.ctx===I.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(s,A){throw new Error(`Event not found: ${A}`)}}e.NodeRemoteResourceRouter=P}),define(ee[239],te([0,1,13,6]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var s;(function(m){m[m.WebSocket=0]="WebSocket",m[m.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class A{constructor(f){this.id=f,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=A;class R{constructor(f,S){this.host=f,this.port=S,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=R;var I;(function(m){m.Unknown="Unknown",m.NotAvailable="NotAvailable",m.TemporarilyNotAvailable="TemporarilyNotAvailable",m.NoResolverFound="NoResolverFound"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class h extends P.ErrorNoTelemetry{static isNotAvailable(f){return f instanceof h&&f._code===I.NotAvailable}static isTemporarilyNotAvailable(f){return f instanceof h&&f._code===I.TemporarilyNotAvailable}static isNoResolverFound(f){return f instanceof h&&f._code===I.NoResolverFound}static isHandled(f){return f instanceof h&&f.isHandled}constructor(f,S=I.Unknown,d){super(f),this._message=f,this._code=S,this._detail=d,this.isHandled=S===I.NotAvailable&&d===!0,Object.setPrototypeOf(this,h.prototype)}}e.RemoteAuthorityResolverError=h;function l(m){const f=m.indexOf("+");return f===-1?m:m.substring(0,f)}e.getRemoteAuthorityPrefix=l}),define(ee[58],te([0,1,15]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(l){return l.scheme===P.Schemas.vscodeRemote?l.authority:void 0}e.getRemoteAuthority=L;function s(l){if(!l)return;const m=l.indexOf("+");return m<0?l:l.substr(0,m)}e.getRemoteName=s;function A(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.getRemoteServerRootPath=A;function R(l){const{host:m,port:f}=h(l);if(typeof f>"u")throw new Error("Remote authority doesn't contain a port!");return{host:m,port:f}}e.parseAuthorityWithPort=R;function I(l,m){let{host:f,port:S}=h(l);return typeof S>"u"&&(S=m),{host:f,port:S}}e.parseAuthorityWithOptionalPort=I;function h(l){const m=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(m)return{host:m[1],port:parseInt(m[2],10)};const f=l.match(/^(\[[0-9a-z:]+\])$/);if(f)return{host:f[1],port:void 0};const S=l.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:l,port:void 0}}}),define(ee[119],te([0,1,25,6,58]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(R||(e.ExtensionType=R={}));var I;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.LINUX_PPC64LE="linux-ppc64le",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class h{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,g){if(typeof o>"u"||o===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof o=="string"||typeof g=="string"){const a=typeof o=="string"?o:o.value,b=typeof g=="string"?g:g.value;return P.equalsIgnoreCase(a,b)}return o._lower===g._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.ExtensionIdentifier=h;class l{get size(){return this._set.size}constructor(o){if(this._set=new Set,o)for(const g of o)this.add(g)}add(o){this._set.add(h.toKey(o))}delete(o){return this._set.delete(h.toKey(o))}has(o){return this._set.has(h.toKey(o))}}e.ExtensionIdentifierSet=l;class m{constructor(){this._map=new Map}clear(){this._map.clear()}delete(o){this._map.delete(h.toKey(o))}get(o){return this._map.get(h.toKey(o))}has(o){return this._map.has(h.toKey(o))}set(o,g){this._map.set(h.toKey(o),g)}values(){return this._map.values()}forEach(o){this._map.forEach(o)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=m;function f(v){return S(v)}e.isApplicationScopedExtension=f;function S(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function d(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function y(v,o){if(o){const g=`onResolveRemoteAuthority:${(0,s.getRemoteName)(o)}`;return!!v.activationEvents?.includes(g)}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[240],te([0,1,8,17,21,13,4,2,65,85,31,108,239,58]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var v;(function(O){O[O.Management=1]="Management",O[O.ExtensionHost=2]="ExtensionHost",O[O.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function o(O){switch(O){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(O){const M=new s.CancellationTokenSource;return setTimeout(()=>M.cancel(),O),M.token}function a(O,M){if(O.isCancellationRequested||M.isCancellationRequested)return s.CancellationToken.Cancelled;const W=new s.CancellationTokenSource;return O.onCancellationRequested(()=>W.cancel()),M.onCancellationRequested(()=>W.cancel()),W.token}class b{get didTimeout(){return this._state==="timedout"}constructor(M){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((W,H)=>{this._resolvePromise=W,this._rejectPromise=H}),M.isCancellationRequested?this._timeout():this._disposables.add(M.onCancellationRequested(()=>this._timeout()))}registerDisposable(M){this._state==="pending"?this._disposables.add(M):M.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const M=new Error("Time limit reached");return M.code="ETIMEDOUT",M.syscall="connect",M}resolve(M){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(M))}reject(M){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(M))}}function E(O,M){const W=new b(M);return W.registerDisposable(O.onControlMessage(H=>{const x=JSON.parse(H.toString()),z=N(x);z?W.reject(z):W.resolve(x)})),W.promise}function w(O,M,W,H,x,z,$,K){const re=new b(K),ce=l.StopWatch.create(!1);return O.info(`Creating a socket (${$})...`),h.mark(`code/willCreateSocket/${z}`),M.connect(W,H,x,$).then(ge=>{re.didTimeout?(h.mark(`code/didCreateSocketError/${z}`),O.info(`Creating a socket (${$}) finished after ${ce.elapsed()} ms, but this is too late and has timed out already.`),ge?.dispose()):(h.mark(`code/didCreateSocketOK/${z}`),O.info(`Creating a socket (${$}) was successful after ${ce.elapsed()} ms.`),re.resolve(ge))},ge=>{h.mark(`code/didCreateSocketError/${z}`),O.info(`Creating a socket (${$}) returned an error after ${ce.elapsed()} ms.`),O.error(ge),re.reject(ge)}),re.promise}function t(O,M){const W=new b(M);return O.then(H=>{W.didTimeout||W.resolve(H)},H=>{W.didTimeout||W.reject(H)}),W.promise}async function u(O,M,W,H){const x=ae(O,M);O.logService.trace(`${x} 1/6. invoking socketFactory.connect().`);let z;try{z=await w(O.logService,O.remoteSocketFactoryService,O.connectTo,(0,d.getRemoteServerRootPath)(O),`reconnectionToken=${O.reconnectionToken}&reconnection=${O.reconnectionProtocol?"true":"false"}`,o(M),`renderer-${o(M)}-${O.reconnectionToken}`,H)}catch(ge){throw O.logService.error(`${x} socketFactory.connect() failed or timed out. Error:`),O.logService.error(ge),ge}O.logService.trace(`${x} 2/6. socketFactory.connect() was successful.`);let $,K;O.reconnectionProtocol?(O.reconnectionProtocol.beginAcceptReconnection(z,null),$=O.reconnectionProtocol,K=!1):($=new f.PersistentProtocol({socket:z}),K=!0),O.logService.trace(`${x} 3/6. sending AuthRequest control message.`);const re=await t(O.signService.createNewMessage((0,m.generateUuid)()),H),ce={type:"auth",auth:O.connectionToken||"00000000000000000000",data:re.data};$.sendControl(L.VSBuffer.fromString(JSON.stringify(ce)));try{const ge=await E($,a(H,g(1e4)));if(ge.type!=="sign"||typeof ge.data!="string"){const Oe=new Error("Unexpected handshake message");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}if(O.logService.trace(`${x} 4/6. received SignRequest control message.`),!await t(O.signService.validate(re,ge.signedData),H)){const Oe=new Error("Refused to connect to unsupported server");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}const Re=await t(O.signService.sign(ge.data),H),Le={type:"connectionType",commit:O.commit,signedData:Re,desiredConnectionType:M};return W&&(Le.args=W),O.logService.trace(`${x} 5/6. sending ConnectionTypeRequest control message.`),$.sendControl(L.VSBuffer.fromString(JSON.stringify(Le))),{protocol:$,ownsProtocol:K}}catch(ge){throw ge&&ge.code==="ETIMEDOUT"&&(O.logService.error(`${x} the handshake timed out. Error:`),O.logService.error(ge)),ge&&ge.code==="VSCODE_CONNECTION_ERROR"&&(O.logService.error(`${x} received error control message when negotiating connection. Error:`),O.logService.error(ge)),K&&F($),ge}}async function r(O,M,W,H){const x=Date.now(),z=ae(O,M),{protocol:$,ownsProtocol:K}=await u(O,M,W,H),re=new b(H);return re.registerDisposable($.onControlMessage(ce=>{const ge=JSON.parse(ce.toString()),ke=N(ge);ke?(O.logService.error(`${z} received error control message when negotiating connection. Error:`),O.logService.error(ke),K&&F($),re.reject(ke)):(O.reconnectionProtocol?.endAcceptReconnection(),O.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${oe(x)}!`),re.resolve({protocol:$,firstMessage:ge}))})),re.promise}async function i(O,M){const{protocol:W}=await r(O,1,void 0,M);return{protocol:W}}async function n(O,M,W){const{protocol:H,firstMessage:x}=await r(O,2,M,W),z=x&&x.debugPort;return{protocol:H,debugPort:z}}async function c(O,M,W){const H=Date.now(),x=ae(O,3),{protocol:z}=await u(O,3,M,W);return O.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${oe(H)}!`),z}async function p(O,M,W){const{connectTo:H,connectionToken:x}=await O.addressProvider.getAddress();return{commit:O.commit,quality:O.quality,connectTo:H,connectionToken:x,reconnectionToken:M,reconnectionProtocol:W,remoteSocketFactoryService:O.remoteSocketFactoryService,signService:O.signService,logService:O.logService}}async function D(O,M,W){return C(O,async H=>{const{protocol:x}=await i(H,s.CancellationToken.None);return new G(O,M,W,H.reconnectionToken,x)})}e.connectRemoteAgentManagement=D;async function k(O,M){return C(O,async W=>{const{protocol:H,debugPort:x}=await n(W,M,s.CancellationToken.None);return new Q(O,M,W.reconnectionToken,H,x)})}e.connectRemoteAgentExtensionHost=k;async function C(O,M){for(let H=1;;H++)try{const x=(0,m.generateUuid)(),z=await p(O,x,null);return await M(z)}catch(x){if(H<5)O.logService.error(`[remote-connection][attempt ${H}] An error occurred in initial connection! Will retry... Error:`),O.logService.error(x);else throw O.logService.error(`[remote-connection][attempt ${H}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),O.logService.error(x),le.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled(x)),x}}async function _(O,M,W){const H=await p(O,(0,m.generateUuid)(),null);return await c(H,{host:M,port:W},s.CancellationToken.None)}e.connectRemoteAgentTunnel=_;function T(O){return(0,P.createCancelablePromise)(M=>new Promise((W,H)=>{const x=setTimeout(W,O*1e3);M.onCancellationRequested(()=>{clearTimeout(x),W()})}))}var U;(function(O){O[O.ConnectionLost=0]="ConnectionLost",O[O.ReconnectionWait=1]="ReconnectionWait",O[O.ReconnectionRunning=2]="ReconnectionRunning",O[O.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",O[O.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class q{constructor(M,W){this.reconnectionToken=M,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=q;class se{constructor(M,W,H,x){this.reconnectionToken=M,this.millisSinceLastIncomingData=W,this.durationSeconds=H,this.cancellableTimer=x,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=se;class ie{constructor(M,W,H){this.reconnectionToken=M,this.millisSinceLastIncomingData=W,this.attempt=H,this.type=2}}e.ReconnectionRunningEvent=ie;class ne{constructor(M,W,H){this.reconnectionToken=M,this.millisSinceLastIncomingData=W,this.attempt=H,this.type=4}}e.ConnectionGainEvent=ne;class ue{constructor(M,W,H,x){this.reconnectionToken=M,this.millisSinceLastIncomingData=W,this.attempt=H,this.handled=x,this.type=3}}e.ReconnectionPermanentFailureEvent=ue;class le extends I.Disposable{static triggerPermanentFailure(M,W,H){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=M,this._permanentFailureAttempt=W,this._permanentFailureHandled=H,this._instances.forEach(x=>x._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(M=>M._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(M=>M._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||le._permanentFailure}constructor(M,W,H,x,z){super(),this._connectionType=M,this._options=W,this.reconnectionToken=H,this.protocol=x,this._reconnectionFailureIsFatal=z,this._onDidStateChange=this._register(new R.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new ne(this.reconnectionToken,0,0)),this._register(x.onSocketClose($=>{const K=Y(this._connectionType,this.reconnectionToken,!0);$?$.type===0?(this._options.logService.info(`${K} received socket close event (hadError: ${$.hadError}).`),$.error&&this._options.logService.error($.error)):(this._options.logService.info(`${K} received socket close event (wasClean: ${$.wasClean}, code: ${$.code}, reason: ${$.reason}).`),$.event&&this._options.logService.error($.event)):this._options.logService.info(`${K} received socket close event.`),this._beginReconnecting()})),this._register(x.onSocketTimeout($=>{const K=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${K} received socket timeout event (unacknowledgedMsgCount: ${$.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${$.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${$.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),le._instances.push(this),this._register((0,I.toDisposable)(()=>{const $=le._instances.indexOf(this);$>=0&&le._instances.splice($,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(le._permanentFailureMillisSinceLastIncomingData,le._permanentFailureAttempt,le._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const M=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${M} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let H=-1;do{H++;const x=H<W.length?W[H]:W[W.length-1];try{if(x>0){const $=T(x);this._onDidStateChange.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x,$)),this._options.logService.info(`${M} waiting for ${x} seconds before reconnecting...`);try{await $}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${M} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1)),this._options.logService.info(`${M} resolving connection...`);const z=await p(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${M} connecting to ${z.connectTo}...`),await this._reconnect(z,g(y)),this._options.logService.info(`${M} reconnected!`),this._onDidStateChange.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${M} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(H>360){this._options.logService.error(`${M} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable(z)){this._options.logService.info(`${M} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this._options.logService.info(`${M} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((0,A.isCancellationError)(z)){this._options.logService.info(`${M} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if(z instanceof S.RemoteAuthorityResolverError){this._options.logService.error(`${M} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,S.RemoteAuthorityResolverError.isHandled(z));break}this._options.logService.error(`${M} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(M,W,H){this._reconnectionFailureIsFatal?le.triggerPermanentFailure(M,W,H):this._gotoPermanentFailure(M,W,H)}_gotoPermanentFailure(M,W,H){this._onDidStateChange.fire(new ue(this.reconnectionToken,M,W,H)),F(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=le,le._permanentFailure=!1,le._permanentFailureMillisSinceLastIncomingData=0,le._permanentFailureAttempt=0,le._permanentFailureHandled=!1,le._instances=[];class G extends le{constructor(M,W,H,x,z){super(1,M,x,z,!0),this.client=this._register(new f.Client(z,{remoteAuthority:W,clientId:H},M.ipcLogger))}async _reconnect(M,W){await i(M,W)}}e.ManagementPersistentConnection=G;class Q extends le{constructor(M,W,H,x,z){super(2,M,H,x,!1),this._startArguments=W,this.debugPort=z}async _reconnect(M,W){await n(M,this._startArguments,W)}}e.ExtensionHostPersistentConnection=Q;function F(O){try{O.acceptDisconnect();const M=O.getSocket();O.dispose(),M.dispose()}catch(M){(0,A.onUnexpectedError)(M)}}function N(O){if(O&&O.type==="error"){const M=new Error(`Connection error: ${O.reason}`);return M.code="VSCODE_CONNECTION_ERROR",M}return null}function B(O,M){for(;O.length<M;)O+=" ";return O}function V(O,M){return`[remote-connection][${B(o(O),13)}][${M.substr(0,5)}\u2026]`}function Y(O,M,W){return`${V(O,M)}[${W?"reconnect":"initial"}]`}function ae(O,M){return`${Y(M,O.reconnectionToken,!!O.reconnectionProtocol)}[${O.connectTo}]`}function oe(O){return`${Date.now()-O} ms`}}),define(ee[241],te([0,1,2,6]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,L.createDecorator)("remoteSocketFactoryService");class s{constructor(){this.factories={}}register(R,I){return this.factories[R]??=[],this.factories[R].push(I),(0,P.toDisposable)(()=>{const h=this.factories[R]?.indexOf(I);typeof h=="number"&&h>=0&&this.factories[R]?.splice(h,1)})}getSocketFactory(R){return(this.factories[R.type]||[]).find(h=>h.supports(R))}connect(R,I,h,l){const m=this.getSocketFactory(R);if(!m)throw new Error(`No socket factory found for ${R}`);return m.connect(R,I,h,l)}}e.RemoteSocketFactoryService=s}),define(ee[242],te([0,1,27,47,42,112]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let R;async function I(d=!1){return(R===void 0||d)&&(R=h()),R}e.hasWSLFeatureInstalled=I;async function h(){const d=l();if(d===void 0)return!1;if(d>=22e3){const y=f();if(y)return new Promise(v=>{L.execFile(y,["--status"],o=>v(!o))})}else{const y=S();if(y)try{if((await s.promises.stat(y)).isFile())return!0}catch{}}return!1}function l(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(d)return parseInt(d[3])}function m(d){const y=process.env.SystemRoot;if(y){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return A.join(y,v?"Sysnative":"System32",d)}}function f(){return m("wsl.exe")}function S(){return m("lxss\\LxssManager.dll")}}),define(ee[51],te([0,1,17,13,2,181,57,6,5,44]),function(j,e,P,L,s,A,R,I,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,I.createDecorator)("requestService");class m{constructor(w){this.original=w}toJSON(){if(!this.headers){const w=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?w[t]="*****":w[t]=this.original[t];this.headers=w}return this.headers}}class f extends s.Disposable{constructor(w){super(),this.counter=0,this.logger=w.createLogger("network",{name:(0,A.localize)(0,null),when:h.CONTEXT_LOG_LEVEL.isEqualTo((0,h.LogLevelToString)(h.LogLevel.Trace)).serialize()})}async logAndRequest(w,t,u){const r=`${w} #${++this.counter}: ${t.url}`;this.logger.trace(`${r} - begin`,t.type,new m(t.headers??{}));try{const i=await u();return this.logger.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${r} - error`,t.type,(0,L.getErrorMessage)(i)),i}}}e.AbstractRequestService=f;function S(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.isSuccess=S;function d(E){return E.res.statusCode===204}async function y(E){return d(E)?null:(await(0,P.streamToBuffer)(E.stream)).toString()}e.asText=y;async function v(E){if(!S(E))throw new Error("Server returned "+E.res.statusCode);return y(E)}e.asTextOrError=v;async function o(E){if(!S(E))throw new Error("Server returned "+E.res.statusCode);if(d(E))return null;const t=(await(0,P.streamToBuffer)(E.stream)).toString();try{return JSON.parse(t)}catch(u){throw u.message+=`:
`+t,u}}e.asJson=o;function g(E){b(E)}e.updateProxyConfigurationsScope=g;let a;function b(E){const w=l.Registry.as(R.Extensions.Configuration),t=a;a={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(5,null),(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null)],default:"override",description:(0,A.localize)(9,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(10,null),restricted:!0}}},w.updateConfigurations({add:[a],remove:t?[t]:[]})}b(1)}),define(ee[243],te([0,1,17,21]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class s{constructor(I){this.service=I}listen(I,h){throw new Error("Invalid listen")}call(I,h,l,m=L.CancellationToken.None){switch(h){case"request":return this.service.request(l[0],m).then(async({res:f,stream:S})=>{const d=await(0,P.streamToBuffer)(S);return[{statusCode:f.statusCode,headers:f.headers},d]});case"resolveProxy":return this.service.resolveProxy(l[0])}throw new Error("Invalid call")}}e.RequestChannel=s;class A{constructor(I){this.channel=I}async request(I,h){const[l,m]=await this.channel.call("request",[I],h);return{res:l,stream:(0,P.bufferToStream)(m)}}async resolveProxy(I){return this.channel.call("resolveProxy",[I])}}e.RequestChannelClient=A}),define(ee[244],te([0,1,245,11]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function s(R,I){return R.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:R.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function A(R,I,h={}){const l=(0,P.parse)(R),m=h.proxyUrl||s(l,I);if(!m)return null;const f=(0,P.parse)(m);if(!/^https?:$/.test(f.protocol||""))return null;const S={host:f.hostname||"",port:f.port||(f.protocol==="https"?"443":"80"),auth:f.auth,rejectUnauthorized:(0,L.isBoolean)(h.strictSSL)?h.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((d,y)=>{j(["http-proxy-agent"],d,y)}))(S):new(await new Promise((d,y)=>{j(["https-proxy-agent"],d,y)}))(S)}e.getProxyAgent=A}),define(ee[94],te([0,1,47,9,182,21,50,13,3,31,155,63,8,137]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let y;async function v(g,a,b,E){return b["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,f.isLaunchedFromCli)(E)&&!b["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,f.isLaunchedFromCli)(E)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=S.Promises.withAsyncBody(async(w,t)=>{const u=new A.CancellationTokenSource;let r=1e4;const i=g.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,d.clamp)(i,1,120)*1e3);const n=setTimeout(()=>{u.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{w(await o(a,u.token))}catch(c){!(0,I.isCancellationError)(c)&&!u.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,R.toErrorMessage)(c)))):w({})}finally{clearTimeout(n),u.dispose()}})),y)}e.getResolvedShellEnv=v;async function o(g,a){const b=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",b);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",E);const w=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(w+"({.*})"+w),u={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",u);const r=await(0,m.getSystemShell)(h.OS,u);return g.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(a.isCancellationRequested)return n(new I.CancellationError);const c=(0,L.basename)(r);let p,D;const k=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(p=`& '${process.execPath}' ${k} -p '''${w}'' + JSON.stringify(process.env) + ''${w}'''`,D=["-Login","-Command"]):c==="nu"?(p=`^'${process.execPath}' ${k} -p '"${w}" + JSON.stringify(process.env) + "${w}"'`,D=["-i","-l","-c"]):(p=`'${process.execPath}' ${k} -p '"${w}" + JSON.stringify(process.env) + "${w}"'`,c==="tcsh"||c==="csh"?D=["-ic"]:D=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),p);const C=(0,P.spawn)(r,[...D,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:u});a.onCancellationRequested(()=>(C.kill(),n(new I.CancellationError))),C.on("error",U=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(U)),n(U)});const _=[];C.stdout.on("data",U=>_.push(U));const T=[];C.stderr.on("data",U=>T.push(U)),C.on("close",(U,q)=>{const se=Buffer.concat(_).toString("utf8");g.trace("getUnixShellEnvironment#raw",se);const ie=Buffer.concat(T).toString("utf8");if(ie.trim()&&g.trace("getUnixShellEnvironment#stderr",ie),U||q)return n(new Error((0,s.localize)(2,null,U,q)));const ne=t.exec(se),ue=ne?ne[1]:"{}";try{const le=JSON.parse(ue);b?le.ELECTRON_RUN_AS_NODE=b:delete le.ELECTRON_RUN_AS_NODE,E?le.ELECTRON_NO_ATTACH_CONSOLE=E:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",le),i(le)}catch(le){g.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(le)),n(le)}})})}}),define(ee[246],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class P{constructor(){this.validators=new Map}async createNewMessage(s){try{const A=await this.getValidator();if(A){const R=String(P._nextId++);return this.validators.set(R,A),{id:R,data:A.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,A){if(!s.id)return!0;const R=this.validators.get(s.id);if(!R)return!1;this.validators.delete(s.id);try{return R.validate(A)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(s){try{return await this.signValue(s)}catch{}return s}}e.AbstractSignService=P,P._nextId=1}),define(ee[95],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,P.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[247],te([0,1,246]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L extends P.AbstractSignService{getValidator(){return this.vsda().then(A=>new A.validator)}signValue(A){return this.vsda().then(R=>new R.signer().sign(A))}vsda(){return new Promise((A,R)=>j(["vsda"],A,R))}}e.SignService=L}),define(ee[34],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,P.createDecorator)("stateReadService"),e.IStateService=(0,P.createDecorator)("stateService")}),define(ee[120],te([0,1,8,17,11,33,16,5]),function(j,e,P,L,s,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var h;(function(S){S[S.IMMEDIATE=0]="IMMEDIATE",S[S.DELAYED=1]="DELAYED"})(h||(e.SaveStrategy=h={}));class l{constructor(d,y,v,o){this.storagePath=d,this.logService=v,this.fileService=o,this.storage=Object.create(null),this.lastSavedStorageContents="",this.initializing=void 0,this.closing=void 0,this.flushDelayer=y===0?void 0:new P.ThrottledDelayer(100)}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(d){d.fileOperationResult!==1&&this.logService.error(d)}}getItem(d,y){const v=this.storage[d];return(0,s.isUndefinedOrNull)(v)?y:v}setItem(d,y){this.setItems([{key:d,data:y}])}setItems(d){let y=!1;for(const{key:v,data:o}of d)this.storage[v]!==o&&((0,s.isUndefinedOrNull)(o)?(0,s.isUndefined)(this.storage[v])||(this.storage[v]=void 0,y=!0):(this.storage[v]=o,y=!0));y&&this.save()}removeItem(d){(0,s.isUndefined)(this.storage[d])||(this.storage[d]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave()):this.doSave()}async doSave(){if(!this.initializing)return;await this.initializing;const d=JSON.stringify(this.storage,null,4);if(d!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(d),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=d}catch(y){this.logService.error(y)}}async close(){return this.closing||(this.closing=this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave(),0):this.doSave()),this.closing}}e.FileStorage=l;let m=e.StateReadonlyService=class{constructor(d,y,v,o){this.fileStorage=new l(y.stateResource,d,v,o)}async init(){await this.fileStorage.init()}getItem(d,y){return this.fileStorage.getItem(d,y)}};e.StateReadonlyService=m=Se([J(1,A.IEnvironmentService),J(2,I.ILogService),J(3,R.IFileService)],m);class f extends m{setItem(d,y){this.fileStorage.setItem(d,y)}setItems(d){this.fileStorage.setItems(d)}removeItem(d){this.fileStorage.removeItem(d)}close(){return this.fileStorage.close()}}e.StateService=f}),define(ee[121],te([0,1,3,36,31]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(h){if(P.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function R(h,l,m,f,S,d,y,v){const o=Object.create(null);o["common.machineId"]=d,o.sessionID=(0,s.generateUuid)()+Date.now(),o.commitHash=f,o.version=S,o["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,P.PlatformToString)(P.platform),o["common.nodePlatform"]=L.platform,o["common.nodeArch"]=m,o["common.product"]=v||"desktop",y&&(o["common.msftInternal"]=y);let g=0;const a=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),P.isLinuxSnap&&(o["common.snap"]="true");const b=A(l);return b&&(o["common.platformDetail"]=b),o}e.resolveCommonProperties=R;function I(h){const l=L.env.USERDNSDOMAIN;if(!l)return!1;const m=l.toLowerCase();return h.some(f=>m===f)}e.verifyMicrosoftInternalDomain=I}),define(ee[26],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,P.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,P.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var s;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(ee[248],te([0,1,27,8,45,15,9,3,7,86,22,107,90,16,23,26]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const o=new Map;async function g(t,u){const r=`${t}::${u.join(":")}`,i=o.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,p=new Map,D=2e4;function k(_,T,U,q){const se=T.substring(_.length+1);return L.Promises.withAsyncBody(async ie=>{let ne;try{ne=await m.Promises.readdir(T,{withFileTypes:!0})}catch{ie();return}if(q.count>=D){q.count+=ne.length,q.maxReached=!0,ie();return}let ue=ne.length;if(ue===0){ie();return}let le=ne;q.count+ne.length>D&&(q.maxReached=!0,ue=D-q.count,le=ne.slice(0,ue)),q.count+=ne.length;for(const G of le)if(G.isDirectory()){if(U.includes(G.name)||await k(_,(0,R.join)(T,G.name),U,q),--ue===0){ie();return}}else{const Q=G.name.lastIndexOf(".");if(Q>=0){const F=G.name.substring(Q+1);F&&c.set(F,(c.get(F)??0)+1)}for(const F of n)F.relativePathPattern?.test(se)!==!1&&F.filePattern.test(G.name)&&p.set(F.tag,(p.get(F.tag)??0)+1);if(--ue===0){ie();return}}})}const C=L.Promises.withAsyncBody(async _=>{const T={count:0,maxReached:!1};await k(t,t,u,T);const U=await E(t);_({configFiles:a(p),fileTypes:a(c),fileCount:T.count,maxFilesReached:T.maxReached,launchConfigFiles:U})});return o.set(r,C),C}e.collectWorkspaceStats=g;function a(t){return Array.from(t.entries(),([u,r])=>({name:u,count:r})).sort((u,r)=>r.count-u.count)}function b(){const t={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(P.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.virtualMachineHint.value()*100)}%`},u=P.cpus();return u&&u.length>0&&(t.cpus=`${u[0].model} (${u.length} x ${u[0].speed})`),t}e.getMachineInfo=b;async function E(t){try{const u=new Map,r=(0,R.join)(t,".vscode","launch.json"),i=await m.Promises.readFile(r),n=[],c=(0,s.parse)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.getNodeType)(c)==="object"&&c.configurations)for(const p of c.configurations){const D=p.type;D&&(u.has(D)?u.set(D,u.get(D)+1):u.set(D,1))}return a(u)}catch{return[]}}e.collectLaunchConfigs=E;let w=e.DiagnosticsService=class{constructor(u,r){this.telemetryService=u,this.productService=r}formatMachineInfo(u){const r=[];return r.push(`OS Version:       ${u.os}`),r.push(`CPUs:             ${u.cpus}`),r.push(`Memory (System):  ${u.memory}`),r.push(`VM:               ${u.vmHint}`),r.join(`
`)}formatEnvironment(u){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const i=P.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(P.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(P.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||r.push(`Load (avg):       ${P.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(l.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${u.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${u.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(u.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(u,r){return Promise.all([(0,f.listProcesses)(u.mainPID),this.formatWorkspaceMetadata(u)]).then(async i=>{let[n,c]=i,p=this.formatProcessList(u,n);return r.forEach(D=>{if((0,S.isRemoteDiagnosticError)(D))p+=`
${D.errorMessage}`,c+=`
${D.errorMessage}`;else if(p+=`

Remote: ${D.hostName}`,D.processes&&(p+=`
${this.formatProcessList(u,D.processes)}`),D.workspaceMetadata){c+=`
|  Remote: ${D.hostName}`;for(const k of Object.keys(D.workspaceMetadata)){const C=D.workspaceMetadata[k];let _=`${C.fileCount} files`;C.maxFilesReached&&(_=`more than ${_}`),c+=`|    Folder (${k}): ${_}`,c+=this.formatWorkspaceStats(C)}}}),{processInfo:p,workspaceInfo:c}})}async getSystemInfo(u,r){const{memory:i,vmHint:n,os:c,cpus:p}=b(),D={os:c,memory:i,cpus:p,vmHint:n,processArgs:`${u.mainArguments.join(" ")}`,gpuStatus:u.gpuFeatureStatus,screenReader:`${u.screenReader?"yes":"no"}`,remoteData:r};return I.isWindows||(D.load=`${P.loadavg().map(k=>Math.round(k)).join(", ")}`),I.isLinux&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(u,r){const i=[];return(0,f.listProcesses)(u.mainPID).then(async n=>(i.push(""),i.push(this.formatEnvironment(u)),i.push(""),i.push(this.formatProcessList(u,n)),u.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(u))),r.forEach(c=>{if((0,S.isRemoteDiagnosticError)(c))i.push(`
${c.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${c.hostName}`),i.push(this.formatMachineInfo(c.machineInfo)),c.processes&&i.push(this.formatProcessList(u,c.processes)),c.workspaceMetadata)for(const p of Object.keys(c.workspaceMetadata)){const D=c.workspaceMetadata[p];let k=`${D.fileCount} files`;D.maxFilesReached&&(k=`more than ${k}`),i.push(`Folder (${p}): ${k}`),i.push(this.formatWorkspaceStats(D))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(u){const r=[];let n=0;const c=(C,_)=>{const T=` ${C}(${_})`;n+T.length>60?(r.push(p),p="|                 ",n=p.length):n+=T.length,p+=T};let p="|      File types:";const D=10,k=u.fileTypes.length>D?D:u.fileTypes.length;for(let C=0;C<k;C++){const _=u.fileTypes[C];c(_.name,_.count)}if(r.push(p),u.configFiles.length>=0&&(p="|      Conf files:",n=0,u.configFiles.forEach(C=>{c(C.name,C.count)}),r.push(p)),u.launchConfigFiles.length>0){let C="|      Launch Configs:";u.launchConfigFiles.forEach(_=>{const T=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`;C+=T}),r.push(C)}return r.join(`
`)}expandGPUFeatures(u){const r=Math.max(...Object.keys(u).map(i=>i.length));return Object.keys(u).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${u[i]}`).join(`
                  `)}formatWorkspaceMetadata(u){const r=[],i=[];return u.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(c=>{const p=h.URI.revive(c);if(p.scheme===A.Schemas.file){const D=p.fsPath;i.push(g(D,["node_modules",".git"]).then(k=>{let C=`${k.fileCount} files`;k.maxFilesReached&&(C=`more than ${C}`),r.push(`|    Folder (${(0,R.basename)(D)}): ${C}`),r.push(this.formatWorkspaceStats(k))}).catch(k=>{r.push(`|      Error: Unable to collect workspace stats for folder ${D} (${k.toString()})`)}))}else r.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}formatProcessList(u,r){const i=new Map;u.windows.forEach(c=>i.set(c.pid,`window [${c.id}] (${c.title})`)),u.pidToNames.forEach(({pid:c,name:p})=>i.set(c,p));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(u.mainPID,i,n,r,0),n.join(`
`)}formatProcessItem(u,r,i,n,c){const p=c===0;let D;p?D=n.pid===u?`${this.productService.applicationName} main`:"remote agent":r.has(n.pid)?D=r.get(n.pid):D=`${"  ".repeat(c)} ${n.name}`;const k=process.platform==="win32"?n.mem:P.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(k/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(n.children)&&n.children.forEach(C=>this.formatProcessItem(u,r,i,C,c+1))}async getWorkspaceFileExtensions(u){const r=new Set;for(const{uri:i}of u.folders){const n=h.URI.revive(i);if(n.scheme!==A.Schemas.file)continue;const c=n.fsPath;try{(await g(c,["node_modules",".git"])).fileTypes.forEach(D=>r.add(D.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(u){for(const{uri:r}of u.folders){const i=h.URI.revive(r);if(i.scheme!==A.Schemas.file)continue;const n=i.fsPath;try{const c=await g(n,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":u.telemetryId,rendererSessionId:u.rendererSessionId}),c.fileTypes.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:u.rendererSessionId,type:p.name,count:p.count})}),c.launchConfigFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:u.rendererSessionId,type:p.name,count:p.count})}),c.configFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:u.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};e.DiagnosticsService=w=Se([J(0,v.ITelemetryService),J(1,y.IProductService)],w)}),define(ee[249],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class P{constructor(A){this.appenders=A}listen(A,R){throw new Error(`Event not found: ${R}`)}call(A,R,{eventName:I,data:h}){return this.appenders.forEach(l=>l.log(I,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=P;class L{constructor(A){this.channel=A}log(A,R){return this.channel.call("log",{eventName:A,data:R}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(ee[52],te([0,1,37,11,4,18,58,121,26]),function(j,e,P,L,s,A,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class l{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=l;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=m,e.NullTelemetryService=new m;class f{async publicLog(n,c,p){}async publicLogError(n,c,p){}}e.NullEndpointTelemetryService=f,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(i,n){return s.Event.debounce(n.onDidChangeConfiguration,(p,D)=>{const k=p?new Set([...p.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:k}},1e3,!0)(p=>{p.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(p.source),configurationKeys:Array.from(p.affectedKeys)})})}e.configurationTelemetry=S;function d(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=d;function y(i,n){return!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=y;function v(i){const n=i.getValue(h.TELEMETRY_SETTING_ID),c=i.getValue(h.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(h.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function o(i){const n={},c={},p={};b(i,p);for(let D in p){D=D.length>150?D.substr(D.length-149):D;const k=p[D];typeof k=="number"?c[D]=k:typeof k=="boolean"?c[D]=k?1:0:typeof k=="string"?(k.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${k.length}`),n[D]=k.substring(0,8191)):typeof k<"u"&&k!==null&&(n[D]=k)}return{properties:n,measurements:c}}e.validateTelemetryData=o;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(i){if(!i)return"none";const n=(0,R.getRemoteName)(i);return g.has(n)?n:"other"}e.cleanRemoteAuthority=a;function b(i,n,c=0,p){if(i)for(const D of Object.getOwnPropertyNames(i)){const k=i[D],C=p?p+D:D;Array.isArray(k)?n[C]=(0,P.safeStringify)(k):k instanceof Date?n[C]=k.toISOString():(0,L.isObject)(k)?c<2?b(k,n,c+1,C+"."):n[C]=(0,P.safeStringify)(k):n[C]=k}}function E(i,n){const c=i.msftInternalDomains||[],p=n.getValue("telemetry.internalTesting");return(0,I.verifyMicrosoftInternalDomain)(c)||p}e.isInternalTelemetry=E;function w(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=w;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let c=i;const p=[];for(const _ of n)for(;;){const T=_.exec(i);if(!T)break;p.push([T.index,_.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,k=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let C=0;for(c="";;){const _=k.exec(i);if(!_)break;const T=p.some(([U,q])=>_.index<q&&U<k.lastIndex);!D.test(_[0])&&!T&&(c+=i.substring(C,_.index)+"<REDACTED: user-file-path>",C=k.lastIndex)}return C<i.length&&(c+=i.substr(C)),c}function u(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of n)if(c.regex.test(i))return`<REDACTED: ${c.label}>`;return i}function r(i,n){return(0,P.cloneAndChange)(i,c=>{if(c instanceof l||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let p=c.replaceAll("%20"," ");p=t(p,n);for(const D of n)p=p.replace(D,"");return p=u(p),p}})}e.cleanData=r}),define(ee[122],te([0,1,25,115,119,3,7,13,36,52]),function(j,e,P,L,s,A,R,I,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function m(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,P.compareIgnoreCase)(r.id,i.id)===0}e.areSameExtensions=m;const f=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(i){const n=i.manifest?i.manifest.version:i.version,c=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new S(i.identifier,n,c)}static parse(i){const n=f.exec(i);return n&&n[1]&&n[2]?new S({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,c="undefined"){this.version=n,this.targetPlatform=c,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof S?m(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=S;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const i=d.exec(r);return i&&i[1]?[o(i[1]),i[2]]:[o(r),void 0]}e.getIdAndVersion=y;function v(r,i){return`${r}.${i}`}e.getExtensionId=v;function o(r){return r.toLowerCase()}e.adoptToGalleryExtensionId=o;function g(r,i){return o(v(r??s.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=g;function a(r,i){const n=[],c=p=>{for(const D of n)if(D.some(k=>m(i(k),i(p))))return D;return null};for(const p of r){const D=c(p);D?D.push(p):n.push([p])}return n}e.groupByExtension=a;function b(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function E(r){return{id:new l.TelemetryTrustedValue(r.identifier.id),name:new l.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new s.ExtensionIdentifier("pprice.better-merge");function w(r,i){const n=[],c=i.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const p=c.shift();if(p&&n.every(D=>!m(D.identifier,{id:p}))){const D=r.filter(k=>m(k.identifier,{id:p}));D.length===1&&(n.push(D[0]),c.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=w;async function t(r,i){if(!A.isLinux)return!1;let n;try{n=(await r.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){i.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(p))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(r,i){const n=await t(r,i),c=(0,L.getTargetPlatform)(n?"alpine":A.platform,h.arch);return i.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=u}),define(ee[250],te([0,1,204,52]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function s(A,R,I,h,l,m,f){const S={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${R.nameShort})`};if((0,L.supportsTelemetry)(R,I)&&(0,L.getTelemetryLevel)(h)===3){const d=await(0,P.getServiceMachineId)(I,l,m);S["X-Market-User-Id"]=d,S["VSCode-SessionId"]=f.machineId||d}return S}e.resolveMarketplaceHeaders=s}),define(ee[251],te([0,1,2,37,3,25,183,18,57,77,23,44,26,52]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=e.TelemetryService=class{constructor(g,a,b){this._configurationService=a,this._productService=b,this._experimentProperties={},this._disposables=new P.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=g.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(E),"gi")),E.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(E.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(E=>{(E.affectsConfiguration(S.TELEMETRY_SETTING_ID)||E.affectsConfiguration(S.TELEMETRY_OLD_SETTING_ID)||E.affectsConfiguration(S.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(g,a){this._experimentProperties[g]=a}_updateTelemetryLevel(){let g=(0,d.getTelemetryLevel)(this._configurationService);const a=this._productService.enabledTelemetryLevels;if(a){this._sendErrorTelemetry=this.sendErrorTelemetry?a.error:!1;const b=a.usage?3:a.error?2:0;g=Math.min(g,b)}this._telemetryLevel=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(g,a,b){this._telemetryLevel<a||(b=(0,L.mixin)(b,this._experimentProperties),b=(0,d.cleanData)(b,this._cleanupPatterns),b=(0,L.mixin)(b,this._commonProperties),this._appenders.forEach(E=>E.log(g,b)))}publicLog(g,a){this._log(g,3,a)}publicLog2(g,a){this.publicLog(g,a)}publicLogError(g,a){this._sendErrorTelemetry&&this._log(g,2,a)}publicLogError2(g,a){this.publicLogError(g,a)}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=y=Se([J(1,I.IConfigurationService),J(2,m.IProductService)],y);function v(){const o=(0,R.localize)(0,null,l.default.nameLong),g=l.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),a=s.isWeb?"":(0,R.localize)(3,null),b=(0,R.localize)(4,null),E=(0,R.localize)(5,null),w=(0,R.localize)(6,null),t=(0,R.localize)(7,null),u=`
|       | ${b} | ${E} | ${w} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,R.localize)(8,null);return`
${o} ${g} ${a}

&nbsp;

${t}
${u}

&nbsp;

${r}
`}f.Registry.as(h.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,R.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:v(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),f.Registry.as(h.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,R.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,R.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[252],te([0,1,3,86,26]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function A(R,I){let h=R.getItem(s.machineIdKey);return(typeof h!="string"||P.isMacintosh&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,L.getMachineId)(I.error.bind(I))),h}e.resolveMachineId=A}),define(ee[253],te([0,1,26,252]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function s(A,R){const I=await(0,L.resolveMachineId)(A,R);return A.setItem(P.machineIdKey,I),I}e.resolveMachineId=s}),define(ee[123],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var P;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(P||(e.EnvironmentVariableMutatorType=P={}))}),define(ee[254],te([0,1,3,123]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const s=new Map([[L.EnvironmentVariableMutatorType.Append,"APPEND"],[L.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[L.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class A{constructor(m){this.collections=m,this.map=new Map,this.descriptionMap=new Map,m.forEach((f,S)=>{this.populateDescriptionMap(f,S);const d=f.map.entries();let y=d.next();for(;!y.done;){const v=y.value[1],o=y.value[0];let g=this.map.get(o);if(g||(g=[],this.map.set(o,g)),g.length>0&&g[0].type===L.EnvironmentVariableMutatorType.Replace){y=d.next();continue}const a={extensionIdentifier:S,value:v.value,type:v.type,scope:v.scope,variable:v.variable,options:v.options};a.scope||delete a.scope,g.unshift(a),y=d.next()}})}async applyToProcessEnvironment(m,f,S){let d;P.isWindows&&(d={},Object.keys(m).forEach(y=>d[y.toLowerCase()]=y));for(const[y,v]of this.getVariableMap(f)){const o=P.isWindows&&d[y.toLowerCase()]||y;for(const g of v){const a=S?await S(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case L.EnvironmentVariableMutatorType.Append:m[o]=(m[o]||"")+a;break;case L.EnvironmentVariableMutatorType.Prepend:m[o]=a+(m[o]||"");break;case L.EnvironmentVariableMutatorType.Replace:m[o]=a;break}if(g.options?.applyAtShellIntegration??!1){const b=`VSCODE_ENV_${s.get(g.type)}`;m[b]=(m[b]?m[b]+":":"")+y+"="+this._encodeColons(a)}}}}_encodeColons(m){return m.replaceAll(":","\\x3a")}diff(m,f){const S=new Map,d=new Map,y=new Map;if(m.getVariableMap(f).forEach((v,o)=>{const g=this.getVariableMap(f).get(o),a=I(v,g);a&&S.set(o,a)}),this.getVariableMap(f).forEach((v,o)=>{const g=m.getVariableMap(f).get(o),a=I(v,g);a&&y.set(o,a)}),this.getVariableMap(f).forEach((v,o)=>{const g=m.getVariableMap(f).get(o),a=h(v,g);a&&d.set(o,a)}),!(S.size===0&&d.size===0&&y.size===0))return{added:S,changed:d,removed:y}}getVariableMap(m){const f=new Map;return this.map.forEach((S,d)=>{const y=S.filter(v=>R(v,m));y.length>0&&f.set(y[0].variable,y)}),f}getDescriptionMap(m){const f=new Map;return this.descriptionMap.forEach((S,d)=>{const y=S.filter(v=>R(v,m,!0));y.length>0&&f.set(y[0].extensionIdentifier,y[0].description)}),f}populateDescriptionMap(m,f){if(!m.descriptionMap)return;const S=m.descriptionMap.entries();let d=S.next();for(;!d.done;){const y=d.value[1],v=d.value[0];let o=this.descriptionMap.get(v);o||(o=[],this.descriptionMap.set(v,o));const g={extensionIdentifier:f,scope:y.scope,description:y.description};g.scope||delete g.scope,o.push(g),d=S.next()}}}e.MergedEnvironmentVariableCollection=A;function R(l,m,f=!1){return l.scope?!!(l.scope.workspaceFolder&&m?.workspaceFolder&&l.scope.workspaceFolder.index===m.workspaceFolder.index):f?m===l.scope:!0}function I(l,m){if(!m)return l;const f=new Set;m.forEach(d=>f.add(d.extensionIdentifier));const S=[];return l.forEach(d=>{f.has(d.extensionIdentifier)||S.push(d)}),S.length===0?void 0:S}function h(l,m){if(!m)return;const f=new Map;m.forEach(d=>f.set(d.extensionIdentifier,d));const S=[];return l.forEach(d=>{const y=f.get(d.extensionIdentifier);y&&(d.type!==y.type||d.value!==y.value||d.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&S.push(y)}),S.length===0?void 0:S}}),define(ee[255],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function P(h){return[...h.entries()]}e.serializeEnvironmentVariableCollection=P;function L(h){return h?[...h.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function s(h){return new Map(h)}e.deserializeEnvironmentVariableCollection=s;function A(h){return new Map(h??[])}e.deserializeEnvironmentDescriptionMap=A;function R(h){return Array.from(h.entries()).map(l=>[l[0],P(l[1].map),L(l[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=R;function I(h){return new Map(h.map(l=>[l[0],{map:s(l[1]),descriptionMap:A(l[2])}]))}e.deserializeEnvironmentVariableCollections=I}),define(ee[256],te([0,1,8,21,4,2,5]),function(j,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=e.RequestStore=class extends A.Disposable{constructor(l,m){super(),this._logService=m,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new s.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=l===void 0?15e3:l}createRequest(l){return new Promise((m,f)=>{const S=++this._lastRequestId;this._pendingRequests.set(S,m),this._onCreateRequest.fire({requestId:S,...l});const d=new L.CancellationTokenSource;(0,P.timeout)(this._timeout,d.token).then(()=>f(`Request ${S} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(S,[(0,A.toDisposable)(()=>d.cancel())])})}acceptReply(l,m){const f=this._pendingRequests.get(l);f?(this._pendingRequests.delete(l),(0,A.dispose)(this._pendingRequestDisposables.get(l)||[]),this._pendingRequestDisposables.delete(l),f(m)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.RequestStore=I=Se([J(1,R.ILogService)],I)}),define(ee[124],te([0,1,6,113,44]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusContextKey=void 0,e.terminalTabFocusContextKey=new L.RawContextKey("terminalTabFocusMode",!1,!0);var A;(function(w){w.DefaultProfile="terminal.integrated.defaultProfile.",w.Profiles="terminal.integrated.profiles."})(A||(e.TerminalSettingPrefix=A={}));var R;(function(w){w.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",w.AutomationProfileLinux="terminal.integrated.automationProfile.linux",w.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",w.AutomationProfileWindows="terminal.integrated.automationProfile.windows",w.ProfilesWindows="terminal.integrated.profiles.windows",w.ProfilesMacOs="terminal.integrated.profiles.osx",w.ProfilesLinux="terminal.integrated.profiles.linux",w.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",w.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",w.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",w.UseWslProfiles="terminal.integrated.useWslProfiles",w.TabsDefaultColor="terminal.integrated.tabs.defaultColor",w.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",w.TabsEnabled="terminal.integrated.tabs.enabled",w.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",w.TabsHideCondition="terminal.integrated.tabs.hideCondition",w.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",w.TabsShowActions="terminal.integrated.tabs.showActions",w.TabsLocation="terminal.integrated.tabs.location",w.TabsFocusMode="terminal.integrated.tabs.focusMode",w.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",w.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",w.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",w.CopyOnSelection="terminal.integrated.copyOnSelection",w.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",w.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",w.FontFamily="terminal.integrated.fontFamily",w.FontSize="terminal.integrated.fontSize",w.LetterSpacing="terminal.integrated.letterSpacing",w.LineHeight="terminal.integrated.lineHeight",w.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",w.TabStopWidth="terminal.integrated.tabStopWidth",w.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",w.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",w.BellDuration="terminal.integrated.bellDuration",w.FontWeight="terminal.integrated.fontWeight",w.FontWeightBold="terminal.integrated.fontWeightBold",w.CursorBlinking="terminal.integrated.cursorBlinking",w.CursorStyle="terminal.integrated.cursorStyle",w.CursorWidth="terminal.integrated.cursorWidth",w.Scrollback="terminal.integrated.scrollback",w.DetectLocale="terminal.integrated.detectLocale",w.DefaultLocation="terminal.integrated.defaultLocation",w.GpuAcceleration="terminal.integrated.gpuAcceleration",w.TerminalTitleSeparator="terminal.integrated.tabs.separator",w.TerminalTitle="terminal.integrated.tabs.title",w.TerminalDescription="terminal.integrated.tabs.description",w.RightClickBehavior="terminal.integrated.rightClickBehavior",w.Cwd="terminal.integrated.cwd",w.ConfirmOnExit="terminal.integrated.confirmOnExit",w.ConfirmOnKill="terminal.integrated.confirmOnKill",w.EnableBell="terminal.integrated.enableBell",w.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",w.AllowChords="terminal.integrated.allowChords",w.AllowMnemonics="terminal.integrated.allowMnemonics",w.TabFocusMode="terminal.integrated.tabFocusMode",w.EnvMacOs="terminal.integrated.env.osx",w.EnvLinux="terminal.integrated.env.linux",w.EnvWindows="terminal.integrated.env.windows",w.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",w.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",w.ShowExitAlert="terminal.integrated.showExitAlert",w.SplitCwd="terminal.integrated.splitCwd",w.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",w.WordSeparators="terminal.integrated.wordSeparators",w.EnableFileLinks="terminal.integrated.enableFileLinks",w.UnicodeVersion="terminal.integrated.unicodeVersion",w.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",w.LocalEchoEnabled="terminal.integrated.localEchoEnabled",w.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",w.LocalEchoStyle="terminal.integrated.localEchoStyle",w.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",w.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",w.CustomGlyphs="terminal.integrated.customGlyphs",w.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",w.InheritEnv="terminal.integrated.inheritEnv",w.ShowLinkHover="terminal.integrated.showLinkHover",w.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",w.AutoReplies="terminal.integrated.autoReplies",w.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",w.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",w.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",w.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",w.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",w.EnableImages="terminal.integrated.enableImages",w.SmoothScrolling="terminal.integrated.smoothScrolling",w.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",w.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay"})(R||(e.TerminalSettingId=R={}));var I;(function(w){w.PowerShell="pwsh",w.Bash="bash",w.Fish="fish",w.Sh="sh",w.Csh="csh",w.Ksh="ksh",w.Zsh="zsh"})(I||(e.PosixShellType=I={}));var h;(function(w){w.CommandPrompt="cmd",w.PowerShell="pwsh",w.Wsl="wsl",w.GitBash="gitbash"})(h||(e.WindowsShellType=h={}));var l;(function(w){w[w.Api=0]="Api",w[w.Process=1]="Process",w[w.Sequence=2]="Sequence",w[w.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var m;(function(w){w.LocalPty="localPty",w.PtyHost="ptyHost",w.PtyHostWindow="ptyHostWindow",w.Logger="logger",w.Heartbeat="heartbeat"})(m||(e.TerminalIpcChannels=m={})),e.IPtyService=(0,P.createDecorator)("ptyService");var f;(function(w){w.Cwd="cwd",w.InitialCwd="initialCwd",w.FixedDimensions="fixedDimensions",w.Title="title",w.ShellType="shellType",w.HasChildProcesses="hasChildProcesses",w.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",w.OverrideDimensions="overrideDimensions",w.FailedShellIntegrationActivation="failedShellIntegrationActivation",w.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(f||(e.ProcessPropertyType=f={}));var S;(function(w){w[w.BeatInterval=5e3]="BeatInterval",w[w.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",w[w.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",w[w.SecondWaitMultiplier=1]="SecondWaitMultiplier",w[w.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(S||(e.HeartbeatConstants=S={}));var d;(function(w){w[w.Panel=1]="Panel",w[w.Editor=2]="Editor"})(d||(e.TerminalLocation=d={}));var y;(function(w){w.TerminalView="view",w.Editor="editor"})(y||(e.TerminalLocationString=y={}));var v;(function(w){w[w.GraceTime=6e4]="GraceTime",w[w.ShortGraceTime=6e3]="ShortGraceTime"})(v||(e.LocalReconnectConstants=v={}));var o;(function(w){w[w.HighWatermarkChars=1e5]="HighWatermarkChars",w[w.LowWatermarkChars=5e3]="LowWatermarkChars",w[w.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var g;(function(w){w.GitBash="Git Bash",w.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var a;(function(w){w[w.Off=0]="Off",w[w.FinalTerm=1]="FinalTerm",w[w.VSCode=2]="VSCode"})(a||(e.ShellIntegrationStatus=a={}));var b;(function(w){w[w.Unknown=0]="Unknown",w[w.Shutdown=1]="Shutdown",w[w.Process=2]="Process",w[w.User=3]="User",w[w.Extension=4]="Extension"})(b||(e.TerminalExitReason=b={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(t){const u=this._sanitizeRemoteAuthority(t.remoteAuthority);if(this._backends.has(u))throw new Error(`A terminal backend with remote authority '${u}' was already registered.`);this._backends.set(u,t)}getTerminalBackend(t){return this._backends.get(this._sanitizeRemoteAuthority(t))}_sanitizeRemoteAuthority(t){return t?.toLowerCase()??""}}s.Registry.add(e.TerminalExtensions.Backend,new E),e.ILocalPtyService=(0,P.createDecorator)("localPtyService"),e.ITerminalLogService=(0,P.createDecorator)("terminalLogService")}),define(ee[257],te([0,1,70,7,185,102]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function R(S,d){const y=[{name:null,description:(0,s.localize)(0,null)}];return y.push(...S.map(v=>({name:v.profileName,description:I(v)}))),d&&y.push(...d.map(v=>({name:v.title,description:h(v)}))),{values:y.map(v=>v.name),markdownDescriptions:y.map(v=>v.description)}}e.createProfileSchemaEnums=R;function I(S){let d=`$(${A.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:P.Codicon.terminal.id}) ${S.profileName}
- path: ${S.path}`;return S.args&&(typeof S.args=="string"?d+=`
- args: "${S.args}"`:d+=`
- args: [${S.args.length===0?"":`'${S.args.join("','")}'`}]`),S.overrideName!==void 0&&(d+=`
- overrideName: ${S.overrideName}`),S.color&&(d+=`
- color: ${S.color}`),S.env&&(d+=`
- env: ${JSON.stringify(S.env)}`),d}function h(S){return`$(${A.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:P.Codicon.terminal.id}) ${S.title}
- extensionIdentifier: ${S.extensionIdentifier}`}function l(S,d){if(!S&&!d)return!0;if(typeof S=="string"&&typeof d=="string")return S===d;if(Array.isArray(S)&&Array.isArray(d)){if(S.length!==d.length)return!1;for(let y=0;y<S.length;y++)if(S[y]!==d[y])return!1;return!0}return!1}e.terminalProfileArgsMatch=l;function m(S,d){if(!S&&!d)return!0;if(!S||!d)return!1;if(A.ThemeIcon.isThemeIcon(S)&&A.ThemeIcon.isThemeIcon(d))return S.id===d.id&&S.color===d.color;if(typeof S=="object"&&"light"in S&&"dark"in S&&typeof d=="object"&&"light"in d&&"dark"in d){const y=S,v=d;if((L.URI.isUri(y.light)||f(y.light))&&(L.URI.isUri(y.dark)||f(y.dark))&&(L.URI.isUri(v.light)||f(v.light))&&(L.URI.isUri(v.dark)||f(v.dark)))return y.light.path===v.light.path&&y.dark.path===v.dark.path}if(L.URI.isUri(S)&&L.URI.isUri(d)||f(S)||f(d)){const y=S,v=d;return y.path===v.path&&y.scheme===v.scheme}return!1}e.terminalIconsEqual=m;function f(S){return S?typeof S.path=="string"&&typeof S.scheme=="string":!1}e.isUriComponents=f}),define(ee[258],te([0,1,70,3,184,57,44,257]),function(j,e,P,L,s,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,P.getAllCodicons)(),o=>o.id),markdownEnumDescriptions:Array.from((0,P.getAllCodicons)(),o=>`$(${o.id})`)};const h={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.terminalIconSchema},color:{description:(0,s.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},l={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},m={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function f(o){const g=o===2?"linux":o===1?"osx":"windows";return(0,s.localize)(7,null,(0,L.PlatformToString)(o),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const S={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:f(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...h}},{type:"null"},l]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:f(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...h}},{type:"null"},l]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:f(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...h}},{type:"null"},l]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,s.localize)(26,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){R.Registry.as(A.Extensions.Configuration).registerConfiguration(S),v()}e.registerTerminalPlatformConfiguration=d;let y;function v(o,g){const a=R.Registry.as(A.Extensions.Configuration);let b;o&&(b=(0,I.createProfileSchemaEnums)(o?.profiles,g));const E=y;y={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:o?.os===3?b?.values:void 0,markdownEnumDescriptions:o?.os===3?b?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:o?.os===2?b?.values:void 0,markdownEnumDescriptions:o?.os===2?b?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:o?.os===1?b?.values:void 0,markdownEnumDescriptions:o?.os===1?b?.markdownDescriptions:void 0}}},a.updateConfigurations({add:[y],remove:E?[E]:[]})}e.registerTerminalDefaultProfileConfiguration=v}),define(ee[259],te([0,1,27,15,37,9,3,36,25,11,22,123,255,254]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function y(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.getWindowsBuildNumber=y;async function v(i,n,c,p=I.env,D=m.Promises.exists){if(A.isAbsolute(i))return await D(i)?i:void 0;if(n===void 0&&(n=I.cwd()),A.dirname(i)!=="."){const T=A.join(n,i);return await D(T)?T:void 0}const C=(0,s.getCaseInsensitive)(p,"PATH");if(c===void 0&&(0,l.isString)(C)&&(c=C.split(A.delimiter)),c===void 0||c.length===0){const T=A.join(n,i);return await D(T)?T:void 0}for(const T of c){let U;if(A.isAbsolute(T)?U=A.join(T,i):U=A.join(n,T,i),await D(U))return U;if(R.isWindows){let q=U+".com";if(await D(q)||(q=U+".exe",await D(q)))return q}}const _=A.join(n,i);return await D(_)?_:void 0}e.findExecutable=v;function o(i,n,c,p,D){const k=R.isWindows&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||k)return;const C=i.args,_=I.platform==="win32"?A.basename(i.executable).toLowerCase():A.basename(i.executable),T=A.dirname(L.FileAccess.asFileUri("").fsPath);let U;const q={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(q.VSCODE_NONCE=n.shellIntegration.nonce),R.isWindows){if(_==="pwsh.exe"||_==="powershell.exe")return!C||u(C)?U=b.get(a.WindowsPwsh):t(C)&&(U=b.get(a.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,h.format)(U[U.length-1],T,""),{newArgs:U,envMixin:q}):void 0;p.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(_){case"bash":return!C||C.length===0?U=b.get(a.Bash):r(C)&&(q.VSCODE_SHELL_LOGIN="1",g(n,q),U=b.get(a.Bash)),U?(U=[...U],U[U.length-1]=(0,h.format)(U[U.length-1],T),{newArgs:U,envMixin:q}):void 0;case"fish":{const se=c?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ie=A.join(T,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return q.XDG_DATA_DIRS=`${se}:${ie}`,g(n,q),{newArgs:void 0,envMixin:q}}case"pwsh":return!C||u(C)?U=b.get(a.Pwsh):t(C)&&(U=b.get(a.PwshLogin)),U?(U=[...U],U[U.length-1]=(0,h.format)(U[U.length-1],T,""),{newArgs:U,envMixin:q}):void 0;case"zsh":{if(!C||C.length===0?U=b.get(a.Zsh):r(C)?(U=b.get(a.ZshLogin),g(n,q)):(C===b.get(a.Zsh)||C===b.get(a.ZshLogin))&&(U=C),!U)return;U=[...U],U[U.length-1]=(0,h.format)(U[U.length-1],T);let se;try{se=P.userInfo().username}catch{se="unknown"}const ie=A.join(P.tmpdir(),`${se}-${D.applicationName}-zsh`);q.ZDOTDIR=ie;const ne=c?.ZDOTDIR??P.homedir()??"~";q.USER_ZDOTDIR=ne;const ue=[];return ue.push({source:A.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.join(ie,".zshrc")}),ue.push({source:A.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.join(ie,".zprofile")}),ue.push({source:A.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.join(ie,".zshenv")}),ue.push({source:A.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.join(ie,".zlogin")}),{newArgs:U,envMixin:q,filesToCopy:ue}}}p.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=o;function g(i,n){if(R.isMacintosh&&i.environmentVariableCollections){const c=(0,S.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),D=new d.MergedEnvironmentVariableCollection(c).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),k=[];if(D)for(const C of D)C.type===f.EnvironmentVariableMutatorType.Prepend&&k.push(C.value);k.length>0&&(n.VSCODE_PATH_PREFIX=k.join(""))}}var a;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(a||(a={}));const b=new Map;b.set(a.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),b.set(a.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),b.set(a.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),b.set(a.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),b.set(a.Zsh,["-i"]),b.set(a.ZshLogin,["-il"]),b.set(a.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],w=["-nol","-nologo"];function t(i){return typeof i=="string"?E.includes(i.toLowerCase()):i.length===1&&E.includes(i[0].toLowerCase())||i.length===2&&(E.includes(i[0].toLowerCase())||E.includes(i[1].toLowerCase()))&&(w.includes(i[0].toLowerCase())||w.includes(i[1].toLowerCase()))}function u(i){return typeof i=="string"?w.includes(i.toLowerCase()):i.length===0||i?.length===1&&w.includes(i[0].toLowerCase())}function r(i){return i==="string"&&E.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&E.includes(i[0].toLowerCase())}}),define(ee[260],te([0,1,47,70,9,3,11,22,106,259,112]),function(j,e,P,L,s,A,R,I,h,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let f,S=!0;function d(n,c,p,D,k=process.env,C,_,T,U){return C=C||{existsFile:I.SymlinkSupport.existsFile,readFile:I.Promises.readFile},A.isWindows?y(p,C,k,_,D.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:D.getValue("terminal.integrated.profiles.windows"),typeof c=="string"?c:D.getValue("terminal.integrated.defaultProfile.windows"),U,T):u(C,_,p,n&&typeof n=="object"?{...n}:D.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof c=="string"?c:D.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),U,T,k)}e.detectAvailableProfiles=d;async function y(n,c,p,D,k,C,_,T,U){const q=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),se=`${process.env.windir}\\${q?"Sysnative":"System32"}`;let ie=!1;(0,l.getWindowsBuildNumber)()>=16299&&(ie=!0),await a(T);const ne=new Map;if(n){ne.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),ne.set("Windows PowerShell",{path:`${se}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),ne.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ne.set("Command Prompt",{path:`${se}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0}),ne.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ne.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:L.Codicon.terminalBash,isAutoDetected:!0});const le=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ne.set("Cmder",{path:`${se}\\cmd.exe`,args:["/K",le],requiresPath:process.env.CMDER_ROOT?le:{path:le,isUnsafe:!0},isAutoDetected:!0})}r(C,ne);const ue=await v(ne.entries(),_,c,p,D,U);if(n||k)try{const le=await w(`${se}\\${ie?"wsl":"bash"}.exe`,_);for(const G of le)(!C||!(G.profileName in C))&&ue.push(G)}catch{S&&(D?.info("WSL is not installed, so could not detect WSL profiles"),S=!1)}return ue}async function v(n,c,p,D=process.env,k,C){const _=[];for(const[T,U]of n)_.push(o(T,U,c,p,D,k,C));return(await Promise.all(_)).filter(T=>!!T)}async function o(n,c,p,D,k=process.env,C,_){if(c===null)return;let T,U,q;if("source"in c&&!("path"in c)){const ue=f?.get(c.source);if(!ue)return;T=ue.paths,U=c.args||ue.args,c.icon?q=g(c.icon):ue.icon&&(q=ue.icon)}else T=Array.isArray(c.path)?c.path:[c.path],U=A.isWindows||Array.isArray(c.args)?c.args:void 0,q=g(c.icon);let se;if(_){const ue=T.map(G=>typeof G=="string"?G:G.path),le=await _(ue);se=new Array(T.length);for(let G=0;G<T.length;G++)typeof T[G]=="string"?se[G]=le[G]:se[G]={path:le[G],isUnsafe:!0}}else se=T.slice();let ie;if(c.requiresPath){let ue;if((0,R.isString)(c.requiresPath)?ue=c.requiresPath:(ue=c.requiresPath.path,c.requiresPath.isUnsafe&&(ie=ue)),!await D.existsFile(ue))return}const ne=await i(n,p,se,D,k,U,c.env,c.overrideName,c.isAutoDetected,ie);if(!ne){C?.debug("Terminal profile not validated",n,T);return}return ne.isAutoDetected=c.isAutoDetected,ne.icon=q,ne.color=c.color,ne}function g(n){return typeof n=="string"?{id:n}:n}async function a(n){if(f&&!n)return;const[c,p]=await Promise.all([b(),n||E()]);f=new Map,f.set("Git Bash",{profileName:"Git Bash",paths:c,args:["--login","-i"]}),f.set("PowerShell",{profileName:"PowerShell",paths:p,icon:L.Codicon.terminalPowershell})}async function b(){const n=new Set,c=await(0,l.findExecutable)("git.exe");if(c){const k=(0,m.dirname)(c);n.add((0,m.resolve)(k,"../.."))}function p(k,C){C&&k.add(C)}p(n,process.env.ProgramW6432),p(n,process.env.ProgramFiles),p(n,process.env["ProgramFiles(X86)"]),p(n,`${process.env.LocalAppData}\\Program`);const D=[];for(const k of n)D.push(`${k}\\Git\\bin\\bash.exe`,`${k}\\Git\\usr\\bin\\bash.exe`,`${k}\\usr\\bin\\bash.exe`);return D.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),D}async function E(){const n=[];for await(const c of(0,h.enumeratePowerShellInstallations)())n.push(c.exePath);return n}async function w(n,c){const p=[],D=await new Promise((_,T)=>{P.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(U,q)=>{if(U)return T("Problem occurred when getting wsl distros");_(q)})});if(!D)return[];const k=new RegExp(/[\r?\n]/),C=D.split(k).filter(_=>_.trim().length>0&&_!=="");for(const _ of C){if(_===""||_.startsWith("docker-desktop"))continue;const T=`${_} (WSL)`,U={profileName:T,path:n,args:["-d",`${_}`],isDefault:T===c,icon:t(_),isAutoDetected:!1};p.push(U)}return p}function t(n){return n.includes("Ubuntu")?L.Codicon.terminalUbuntu:n.includes("Debian")?L.Codicon.terminalDebian:L.Codicon.terminalLinux}async function u(n,c,p,D,k,C,_,T){const U=new Map;if(p){const q=(await n.readFile("/etc/shells")).toString(),se=(C||q.split(`
`)).map(ne=>{const ue=ne.indexOf("#");return ue===-1?ne:ne.substring(0,ue)}).filter(ne=>ne.trim().length>0),ie=new Map;for(const ne of se){let ue=(0,s.basename)(ne),le=ie.get(ue)||0;le++,le>1&&(ue=`${ue} (${le})`),ie.set(ue,le),U.set(ue,{path:ne,isAutoDetected:!0})}}return r(D,U),await v(U.entries(),k,n,T,c,_)}function r(n,c){if(n)for(const[p,D]of Object.entries(n))D===null||typeof D!="object"||!("path"in D)&&!("source"in D)?c.delete(p):(D.icon=D.icon||c.get(p)?.icon,c.set(p,D))}async function i(n,c,p,D,k,C,_,T,U,q){if(p.length===0)return Promise.resolve(void 0);const se=p.shift();if(se==="")return i(n,c,p,D,k,C,_,T,U);const ie=typeof se!="string"&&se.isUnsafe,ne=typeof se=="string"?se:se.path,ue={profileName:n,path:ne,args:C,env:_,overrideName:T,isAutoDetected:U,isDefault:n===c,isUnsafePath:ie,requiresUnsafePath:q};if((0,s.basename)(ne)===ne){const G=k.PATH?k.PATH.split(s.delimiter):void 0,Q=await(0,l.findExecutable)(ne,void 0,G,void 0,D.existsFile);return Q?(ue.path=Q,ue.isFromPath=!0,ue):i(n,c,p,D,k,C)}return await D.existsFile((0,s.normalize)(ne))?ue:i(n,c,p,D,k,C,_,T,U)}}),define(ee[261],te([0,1,4,2,3,43,18,5,224,94,256,124,258,260]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var y;(function(g){g[g.MaxRestarts=5]="MaxRestarts"})(y||(y={}));let v=0,o=e.PtyHostService=class extends L.Disposable{get _connection(){return this._ensurePtyHost(),this.__connection}get _proxy(){return this._ensurePtyHost(),this.__proxy}_ensurePtyHost(){this.__connection||([this.__connection,this.__proxy]=this._startPtyHost())}constructor(a,b,E,w){super(),this._ptyHostStarter=a,this._configurationService=b,this._logService=E,this._loggerService=w,this._wasQuitRequested=!1,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new P.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new P.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new P.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new P.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new P.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new P.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new P.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new P.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new P.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new P.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new P.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new P.Emitter),this.onProcessExit=this._onProcessExit.event,(0,S.registerTerminalPlatformConfiguration)(),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new m.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),this._ptyHostStarter.onBeforeWindowConnection?P.Event.once(this._ptyHostStarter.onBeforeWindowConnection)(()=>this._ensurePtyHost()):this._ensurePtyHost(),this._ptyHostStarter.onWillShutdown?.(()=>this._wasQuitRequested=!0)}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(s.isWindows)return process.env;try{return await(0,l.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a=this._ptyHostStarter.start(v),b=a.client;this._onPtyHostStart.fire(),A.ProxyChannel.toService(b.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(!0),this._register(a.onDidProcessExit(t=>{this._onPtyHostExit.fire(t.code),!this._wasQuitRequested&&!this._isDisposed&&(this._restartCount<=y.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${t.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${t.code}, giving up`))}));const w=A.ProxyChannel.toService(b.getChannel(f.TerminalIpcChannels.PtyHost));return this._register(w.onProcessData(t=>this._onProcessData.fire(t))),this._register(w.onProcessReady(t=>this._onProcessReady.fire(t))),this._register(w.onProcessExit(t=>this._onProcessExit.fire(t))),this._register(w.onDidChangeProperty(t=>this._onDidChangeProperty.fire(t))),this._register(w.onProcessReplay(t=>this._onProcessReplay.fire(t))),this._register(w.onProcessOrphanQuestion(t=>this._onProcessOrphanQuestion.fire(t))),this._register(w.onDidRequestDetach(t=>this._onDidRequestDetach.fire(t))),this._register(new h.RemoteLoggerChannelClient(this._loggerService,b.getChannel(f.TerminalIpcChannels.Logger))),this.__connection=a,this.__proxy=w,this._register(this._configurationService.onDidChangeConfiguration(async t=>{t.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()})),this._refreshIgnoreProcessNames(),[a,w]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,b,E,w,t,u,r,i,n,c,p){const D=setTimeout(()=>this._handleUnresponsiveCreateProcess(),f.HeartbeatConstants.CreateProcessTimeout),k=await this._proxy.createProcess(a,b,E,w,t,u,r,i,n,c,p);return clearTimeout(D),v=Math.max(v,k),k}updateTitle(a,b,E){return this._proxy.updateTitle(a,b,E)}updateIcon(a,b,E,w){return this._proxy.updateIcon(a,b,E,w)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a,b){return this._proxy.detachFromProcess(a,b)}listProcesses(){return this._proxy.listProcesses()}getPerformanceMarks(){return this._proxy.getPerformanceMarks()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,b){return this._proxy.shutdown(a,b)}input(a,b){return this._proxy.input(a,b)}processBinary(a,b){return this._proxy.processBinary(a,b)}resize(a,b,E){return this._proxy.resize(a,b,E)}clearBuffer(a){return this._proxy.clearBuffer(a)}acknowledgeDataEvent(a,b){return this._proxy.acknowledgeDataEvent(a,b)}setUnicodeVersion(a,b){return this._proxy.setUnicodeVersion(a,b)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}installAutoReply(a,b){return this._proxy.installAutoReply(a,b)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(a){return this._proxy.uninstallAutoReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,b,E,w=!1){const t=await this._resolveShellEnv();return(0,d.detectAvailableProfiles)(b,E,w,this._configurationService,t,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a,b){return this._proxy.getWslPath(a,b)}getRevivedPtyNewId(a){return this._proxy.getRevivedPtyNewId(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,b){return this._proxy.requestDetachInstance(a,b)}async acceptDetachInstanceReply(a,b){return this._proxy.acceptDetachInstanceReply(a,b)}async freePortKillProcess(a){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(a)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a,b){return this._proxy.reviveTerminalProcesses(a,b)}async refreshProperty(a,b){return this._proxy.refreshProperty(a,b)}async updateProperty(a,b,E){return this._proxy.updateProperty(a,b,E)}async restartPtyHost(){this._disposePtyHost(),this._isResponsive=!0,this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._connection.store.dispose()}_handleHeartbeat(a){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),a?f.HeartbeatConstants.ConnectingBeatInterval:f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,b){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:b})}async acceptPtyHostResolvedVariables(a,b){this._resolveVariablesRequestStore.acceptReply(a,b)}};e.PtyHostService=o=Se([J(1,R.IConfigurationService),J(2,I.ILogService),J(3,I.ILoggerService)],o)}),define(ee[79],te([0,1,14,4,2,3,18,6,34]),function(j,e,P,L,s,A,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const l="#FFFFFF",m="#1E1E1E",f="#000000",S="#FFFFFF",d="theme",y="themeBackground",v="windowSplash";e.IThemeMainService=(0,I.createDecorator)("themeMainService");let o=e.ThemeMainService=class extends s.Disposable{constructor(a,b){super(),this.stateService=a,this.configurationService=b,this._onDidChangeColorScheme=this._register(new L.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,P.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(A.isWindows){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(A.isMacintosh){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(A.isLinux&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const a=this.getColorScheme();if(a.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return a.dark?f:S;let b=this.stateService.getItem(y,null);if(!b)switch(this.stateService.getItem(d,"vs-dark").split(" ")[0]){case"vs":b=l;break;case"hc-black":b=f;break;case"hc-light":b=S;break;default:b=m}return A.isMacintosh&&b.toUpperCase()===m&&(b="#171717"),b}saveWindowSplash(a,b){this.stateService.setItems([{key:d,data:b.baseTheme},{key:y,data:b.colorInfo.background},{key:v,data:b}]),typeof a=="number"&&this.updateBackgroundColor(a,b)}updateBackgroundColor(a,b){for(const E of P.BrowserWindow.getAllWindows())if(E.id===a){E.setBackgroundColor(b.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(v)}};e.ThemeMainService=o=Se([J(0,h.IStateService),J(1,R.IConfigurationService)],o)}),define(ee[125],te([0,1,4,18,6,5]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,s.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,s.createDecorator)("sharedTunnelsService");var R;(function(v){v.Http="http",v.Https="https"})(R||(e.TunnelProtocol=R={}));var I;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(I||(e.TunnelPrivacyId=I={}));var h;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(h||(e.ProvidedOnAutoForward=h={}));function l(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=l,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=m,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function f(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=f;function S(v,o,g,a){if(g===1)return!1;if(g===2&&f(o)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(b?.length===4&&parseInt(b[1])>=18)return!1}return v<1024}e.isPortPrivileged=S;class d{constructor(o,g,a){this.remoteAddress=o,this.localAddress=g,this._dispose=a,this._onDispose=new P.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=d;let y=e.AbstractTunnelService=class{constructor(o,g){this.logService=o,this.configurationService=g,this._onTunnelOpened=new P.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new P.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new P.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const o=this.configurationService.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this._tunnelProvider=o,o?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this._canElevate=o.elevation,this._privacyOptions=o.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const o=[],g=Array.from(this._tunnels.values());for(const a of g){const b=Array.from(a.values());for(const E of b){const w=await E.value;w&&o.push(w)}}return o}async dispose(){for(const o of this._tunnels.values()){for(const{value:g}of o.values())await g.then(a=>a?.dispose());o.clear()}this._tunnels.clear()}setEnvironmentTunnel(o,g,a,b,E){this.addTunnelToMap(o,g,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:g,localAddress:a,privacy:b,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,g){(f(o)||m(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const a=this.getTunnelFromMap(o,g);if(a)return++a.refcount,a.value}openTunnel(o,g,a,b,E,w=!1,t,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${a} on local port ${E}.`),!o)return;if(g||(g="localhost"),b||(b=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(a)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(o,g,a,b,E,w,t,u);return r?r.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,a);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(i);return(i.tunnelRemoteHost!==g||i.tunnelRemotePort!==a)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),t&&i.privacy!==t&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const g=this._tunnels.get(o.tunnelRemoteHost);if(g){const a=g.get(o.tunnelRemotePort);a&&(a.refcount--,await this.tryDisposeTunnel(o.tunnelRemoteHost,o.tunnelRemotePort,a))}}}}async tryDisposeTunnel(o,g,a){if(a.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${g}.`);const b=a.value.then(async E=>{E&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(o)&&this._tunnels.get(o).delete(g),b}}async closeTunnel(o,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${g} `);const a=this._tunnels.get(o);if(a&&a.has(g)){const b=a.get(g);b.refcount=0,await this.tryDisposeTunnel(o,g,b)}}addTunnelToMap(o,g,a){this._tunnels.has(o)||this._tunnels.set(o,new Map),this._tunnels.get(o).set(g,{refcount:1,value:a})}async removeEmptyTunnelFromMap(o,g){const a=this._tunnels.get(o);if(a){const b=a.get(g);(b?await b.value:void 0)||a.delete(g),a.size===0&&this._tunnels.delete(o)}}getTunnelFromMap(o,g){const a=[o];m(o)?(a.push(...e.LOCALHOST_ADDRESSES),a.push(...e.ALL_INTERFACES_ADDRESSES)):f(o)&&a.push(...e.ALL_INTERFACES_ADDRESSES);const b=a.map(E=>this._tunnels.get(E));for(const E of b){const w=E?.get(g);if(w)return w}}canTunnel(o){return!!l(o)}createWithProvider(o,g,a,b,E,w,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${a} on local port ${b}.`);const u=a;this._factoryInProgress.add(u);const r=b===void 0?a:b,i={elevationRequired:E?this.isPortPrivileged(r):!1},n={remoteAddress:{host:g,port:a},localAddressPort:b,privacy:w,public:w?w!==I.Private:void 0,protocol:t},c=o.forwardPort(n,i);return c?(this.addTunnelToMap(g,a,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),c}};e.AbstractTunnelService=y=Se([J(0,A.ILogService),J(1,L.IConfigurationService)],y)}),define(ee[262],te([0,1,87,27,103,8,2,18,5,23,240,125,95,3,241]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(E,w,t,u,r){let i;for(let n=3;n&&(i?.dispose(),i=await new o(E,w,t,u,r).waitForReady(),!(r&&s.BROWSER_RESTRICTED_PORTS[r]||!s.BROWSER_RESTRICTED_PORTS[i.tunnelLocalPort]));n--);return i}class o extends R.Disposable{constructor(w,t,u,r,i){super(),this.defaultTunnelHost=t,this.suggestedLocalPort=i,this.privacy=f.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=w,this._server=P.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(t=>{t()})}async waitForReady(){const w=this.suggestedLocalPort??this.tunnelRemotePort,t=(0,f.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let u=await(0,s.findFreePortFaster)(w,2,1e3,t),r=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),r=this._server.address(),r||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),r=this._server.address()),this.tunnelLocalPort=r.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${r.port}`,this}async _onConnection(w){w.pause();const t=(0,f.isLocalhost)(this.tunnelRemoteHost)||(0,f.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,m.connectRemoteAgentTunnel)(this._options,t,this.tunnelRemotePort),r=u.getSocket().socket,i=u.readEntireBuffer();u.dispose(),i.byteLength>0&&w.write(i.buffer),w.on("end",()=>{w.localAddress&&this._socketsDispose.delete(w.localAddress),r.end()}),w.on("close",()=>r.end()),w.on("error",()=>{w.localAddress&&this._socketsDispose.delete(w.localAddress),r.destroy()}),r.on("end",()=>w.end()),r.on("close",()=>w.end()),r.on("error",()=>{w.destroy()}),w.pipe(r),r.pipe(w),w.localAddress&&this._socketsDispose.set(w.localAddress,()=>{w.end(),r.end()})}}let g=e.BaseTunnelService=class extends f.AbstractTunnelService{constructor(w,t,u,r,i){super(t,i),this.remoteSocketFactoryService=w,this.signService=u,this.productService=r}isPortPrivileged(w){return(0,f.isPortPrivileged)(w,this.defaultTunnelHost,d.OS,L.release())}retainOrCreateTunnel(w,t,u,r,i,n,c,p){const D=this.getTunnelFromMap(t,u);if(D)return++D.refcount,D.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,t,u,i,n,c,p);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${u} on local port ${i}.`);const k={commit:this.productService.commit,quality:this.productService.quality,addressProvider:w,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},C=v(k,r,t,u,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(t,u,C),C}}};e.BaseTunnelService=g=Se([J(0,y.IRemoteSocketFactoryService),J(1,h.ILogService),J(2,S.ISignService),J(3,l.IProductService),J(4,I.IConfigurationService)],g);let a=e.TunnelService=class extends g{constructor(w,t,u,r,i){super(w,t,u,r,i)}};e.TunnelService=a=Se([J(0,y.IRemoteSocketFactoryService),J(1,h.ILogService),J(2,S.ISignService),J(3,l.IProductService),J(4,I.IConfigurationService)],a);let b=e.SharedTunnelsService=class extends R.Disposable{constructor(w,t,u,r,i){super(),this.remoteSocketFactoryService=w,this.logService=t,this.productService=u,this.signService=r,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(w,t,u,r,i,n,c,p,D){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${r} on local port ${n}.`),!this._tunnelServices.has(w)){const k=new a(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(k),this._tunnelServices.set(w,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this._tunnelServices.delete(w))})}return this._tunnelServices.get(w).openTunnel(t,u,r,i,n,c,p,D)}};e.SharedTunnelsService=b=Se([J(0,y.IRemoteSocketFactoryService),J(1,h.ILogService),J(2,l.IProductService),J(3,S.ISignService),J(4,I.IConfigurationService)],b)}),define(ee[48],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(A){A.Uninitialized="uninitialized",A.Idle="idle",A.CheckingForUpdates="checking for updates",A.AvailableForDownload="available for download",A.Downloading="downloading",A.Downloaded="downloaded",A.Updating="updating",A.Ready="ready"})(L||(e.StateType=L={}));var s;(function(A){A[A.Setup=0]="Setup",A[A.Archive=1]="Archive",A[A.Snap=2]="Snap",A[A.WindowsInstaller=3]="WindowsInstaller"})(s||(e.UpdateType=s={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(A,R)=>({type:"idle",updateType:A,error:R}),CheckingForUpdates:A=>({type:"checking for updates",explicit:A}),AvailableForDownload:A=>({type:"available for download",update:A}),Downloading:A=>({type:"downloading",update:A}),Downloaded:A=>({type:"downloaded",update:A}),Updating:A=>({type:"updating",update:A}),Ready:A=>({type:"ready",update:A})},e.IUpdateService=(0,P.createDecorator)("updateService")}),define(ee[263],te([0,1,3,186,57,44]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),A.Registry.as(s.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:P.isWindows&&!P.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[264],te([0,1,4,48]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class s{constructor(I){this.service=I}listen(I,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(I,h,l){switch(h){case"checkForUpdates":return this.service.checkForUpdates(l);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(l)}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=s;class A{get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}constructor(I){this.channel=I,this._onStateChange=new P.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(I){return this.channel.call("_applySpecificUpdate",I)}}e.UpdateChannelClient=A}),define(ee[40],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,P.createDecorator)("IUriIdentityService")}),define(ee[265],te([0,1,40,205,16,19,138,4,2]),function(j,e,P,L,s,A,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{constructor(S){this.uri=S,this.time=l._clock++}touch(){return this.time=l._clock++,this}}l._clock=0;let m=e.UriIdentityService=class{constructor(S){this._fileService=S,this._dispooables=new h.DisposableStore,this._limit=2**16;const d=new Map,y=v=>{let o=d.get(v.scheme);return o===void 0&&(o=S.hasProvider(v)&&!this._fileService.hasCapability(v,1024),d.set(v.scheme,o)),o};this._dispooables.add(I.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(v=>{d.delete(v.scheme)})),this.extUri=new A.ExtUri(y),this._canonicalUris=new R.SkipList((v,o)=>this.extUri.compare(v,o,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,A.normalizePath)(S));const d=this._canonicalUris.get(S);return d?d.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new l(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((y,v)=>y[1].time<v[1].time?1:y[1].time>v[1].time?-1:0);l._clock=0,this._canonicalUris.clear();const d=this._limit*.5;for(let y=0;y<d;y++)this._canonicalUris.set(S[y][0],S[y][1].touch())}};e.UriIdentityService=m=Se([J(0,s.IFileService)],m),(0,L.registerSingleton)(P.IUriIdentityService,m,1)}),define(ee[126],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,P.createDecorator)("urlService")}),define(ee[266],te([0,1,7]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(I){this.handler=I}listen(I,h){throw new Error(`Event not found: ${h}`)}call(I,h,l){switch(h){case"handleURL":return this.handler.handleURL(P.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=L;class s{constructor(I){this.channel=I}handleURL(I,h){return this.channel.call("handleURL",[I.toJSON(),h])}}e.URLHandlerChannelClient=s;class A{constructor(I,h){this.next=I,this.logService=h}async routeCall(I,h,l,m){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(l)&&l.length>0){const f=P.URI.revive(l[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",f.toString(!0)),f.query){const S=/\bwindowId=(\d+)/.exec(f.query);if(S){const d=S[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${d}"`,f.toString(!0));const y=new RegExp(`window:${d}`),v=I.connections.find(o=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",o.ctx),y.test(o.ctx)));if(v)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",f.toString(!0)),v;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",f.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",f.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(I,h,l,m)}routeEvent(I,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=A}),define(ee[267],te([0,1,8,2,7,23]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class R extends L.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(l,m){const f=[...this.handlers.values()];return(0,P.first)(f.map(S=>()=>S.handleURL(l,m)),void 0,!1).then(S=>S||!1)}registerHandler(l){return this.handlers.add(l),(0,L.toDisposable)(()=>this.handlers.delete(l))}}e.AbstractURLService=R;let I=e.NativeURLService=class extends R{constructor(l){super(),this.productService=l}create(l){let{authority:m,path:f,query:S,fragment:d}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&f&&f.indexOf("/")!==0&&(f=`/${f}`),s.URI.from({scheme:this.productService.urlProtocol,authority:m,path:f,query:S,fragment:d})}};e.NativeURLService=I=Se([J(0,A.IProductService)],I)}),define(ee[268],te([0,1,14,8,4,2,3,7]),function(j,e,P,L,s,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class h{constructor(m,f,S,d,y,v){if(this.urlService=f,this.logService=v,this.uris=[],this.retryCount=0,this.flushDisposable=A.Disposable.None,this.disposables=new A.DisposableStore,m&&(v.trace("ElectronURLListener initialUrisToHandle:",m.map(a=>a.originalUrl)),this.uris=m),R.isWindows){const a=d.isBuilt?[]:[`"${d.appRoot}"`];a.push("--open-url","--"),P.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,a)}const o=s.Event.map(s.Event.fromNodeEventEmitter(P.app,"open-url",(a,b)=>({event:a,url:b})),({event:a,url:b})=>(a.preventDefault(),b));this.disposables.add(o(a=>{const b=this.uriFromRawUrl(a);b&&this.urlService.open(b,{originalUrl:a})})),S.getWindows().filter(a=>a.isReady).length>0?(v.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(v.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),s.Event.once(S.onDidSignalReadyWindow)(this.flush,this,this.disposables))}uriFromRawUrl(m){try{return I.URI.parse(m)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const f of this.uris)await this.urlService.open(f.uri,{originalUrl:f.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",f.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",f.originalUrl),m.push(f));m.length!==0&&(this.uris=m,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=h}),define(ee[269],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(ee[270],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,P.createDecorator)("webviewManagerService")}),define(ee[271],te([0,1,14,2,15,7]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class R extends L.Disposable{constructor(){super();const h=this.handleWebviewRequest.bind(this);P.protocol.registerFileProtocol(s.Schemas.vscodeWebview,h)}handleWebviewRequest(h,l){try{const m=A.URI.parse(h.url),f=R.validWebviewFilePaths.get(m.path);if(typeof f=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${f}`,d=s.FileAccess.asFileUri(S);return l({path:d.fsPath,headers:{...s.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.WebviewProtocolProvider=R,R.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(ee[80],te([0,1,3]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(m){return!!m.workspaceUri}e.isWorkspaceToOpen=L;function s(m){return!!m.folderUri}e.isFolderToOpen=s;function A(m){return!!m.fileUri}e.isFileToOpen=A;function R(m){const f=I(m),S=m.getValue("window.menuBarVisibility");return S==="default"||f==="native"&&S==="compact"||P.isMacintosh&&P.isNative?"classic":S}e.getMenuBarVisibility=R;function I(m){if(P.isWeb)return"custom";const f=m.getValue("window");if(f){if(P.isMacintosh&&f.nativeTabs===!0||P.isMacintosh&&f.nativeFullScreen===!1)return"native";const y=f.titleBarStyle;if(y==="native"||y==="custom")return y}return P.isLinux?"native":"custom"}e.getTitleBarStyle=I;function h(m){if(!P.isWindows||P.isWeb||I(m)==="native")return!1;const f=m.getValue("window.experimental.windowControlsOverlay.enabled");return typeof f=="boolean"?f:!0}e.useWindowControlsOverlay=h;function l(m=0){return Math.pow(1.2,m)}e.zoomLevelToZoomFactor=l}),define(ee[127],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var P;(function(I){I[I.INITIAL=1]="INITIAL",I[I.LOAD=2]="LOAD",I[I.RELOAD=3]="RELOAD"})(P||(e.LoadReason=P={}));var L;(function(I){I[I.CLOSE=1]="CLOSE",I[I.QUIT=2]="QUIT",I[I.RELOAD=3]="RELOAD",I[I.LOAD=4]="LOAD"})(L||(e.UnloadReason=L={}));const s=function(I=1){return{width:1024,height:768,mode:I}};e.defaultWindowState=s;var A;(function(I){I[I.Maximized=0]="Maximized",I[I.Normal=1]="Normal",I[I.Minimized=2]="Minimized",I[I.Fullscreen=3]="Fullscreen"})(A||(e.WindowMode=A={}));var R;(function(I){I[I.UNRESPONSIVE=1]="UNRESPONSIVE",I[I.PROCESS_GONE=2]="PROCESS_GONE",I[I.LOAD=3]="LOAD"})(R||(e.WindowError=R={}))}),define(ee[29],te([0,1,6]),function(j,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,P.createDecorator)("windowsMainService");var L;(function(s){s[s.CLI=0]="CLI",s[s.DOCK=1]="DOCK",s[s.MENU=2]="MENU",s[s.DIALOG=3]="DIALOG",s[s.DESKTOP=4]="DESKTOP",s[s.API=5]="API"})(L||(e.OpenContext=L={}))}),define(ee[272],te([0,1,14,21,4,56,2,31,75,114,5,23,29]),function(j,e,P,L,s,A,R,I,h,l,m,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var d;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(d||(d={}));let y=e.ProxyAuthHandler=class extends R.Disposable{constructor(o,g,a,b,E){super(),this.logService=o,this.windowsMainService=g,this.credentialsService=a,this.encryptionMainService=b,this.productService=E,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=d.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const o=s.Event.fromNodeEventEmitter(P.app,"login",(g,a,b,E,w)=>({event:g,webContents:a,req:b,authInfo:E,callback:w}));this._register(o(this.onLogin,this))}async onLogin({event:o,authInfo:g,req:a,callback:b}){if(!g.isProxy)return;if(!this.pendingProxyResolve&&this.state===d.LoginDialogShown&&a.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}o.preventDefault();let E;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),E=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(g);try{E=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}b(E?.username,E?.password)}async resolveProxyCredentials(o){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const g=await this.doResolveProxyCredentials(o);if(g)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),g;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(o){this.logService.trace("auth#doResolveProxyCredentials - enter",o);const g=String((0,A.hash)({scheme:o.scheme,host:o.host,port:o.port}));let a,b;try{const u=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,g);if(u){const r=JSON.parse(await this.encryptionMainService.decrypt(u));a=r.username,b=r.password}}catch(u){this.logService.error(u)}if(this.state!==d.StoredCredentialsUsed&&typeof a=="string"&&typeof b=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=d.StoredCredentialsUsed,{username:a,password:b};const E=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!E){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${E.id} to handle proxy login`);const w={authInfo:o,username:this.sessionCredentials?.username??a,password:this.sessionCredentials?.password??b,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};E.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,w),this.state=d.LoginDialogShown;const t=await new Promise(u=>{const r=async(i,n,c)=>{if(n===w.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${E.id}`),E.win?.webContents.off("ipc-message",r),c){const p={username:c.username,password:c.password};try{if(c.remember){const D=await this.encryptionMainService.encrypt(JSON.stringify(p));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,g,D)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,g)}catch(D){this.logService.error(D)}u({username:p.username,password:p.password})}else u(void 0)};E.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=t,t}};e.ProxyAuthHandler=y=Se([J(0,m.ILogService),J(1,S.IWindowsMainService),J(2,h.ICredentialsMainService),J(3,l.IEncryptionMainService),J(4,f.IProductService)],y)}),define(ee[273],te([0,1,75,5,33,23,29,217]),function(j,e,P,L,s,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let h=e.CredentialsNativeMainService=class extends I.BaseCredentialsMainService{constructor(m,f,S,d){super(m),this.environmentMainService=f,this.productService=S,this.windowsMainService=d,this.surfaceKeytarLoadError=y=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",y.message??y)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new P.InMemoryCredentialsProvider,this._keytarCache;const m=await new Promise((f,S)=>{j(["keytar"],f,S)});return await m.findCredentials("test-keytar-loads"),this._keytarCache=m,this._keytarCache}};e.CredentialsNativeMainService=h=Se([J(0,L.ILogService),J(1,s.INativeEnvironmentService),J(2,A.IProductService),J(3,R.IWindowsMainService)],h)}),define(ee[274],te([0,1,14,24,3,7,22,18,63,6,5,126,29]),function(j,e,P,L,s,A,R,I,h,l,m,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,l.createDecorator)(e.ID);let d=e.LaunchMainService=class{constructor(v,o,g,a){this.logService=v,this.windowsMainService=o,this.urlService=g,this.configurationService=a}async start(v,o){this.logService.trace("Received data from other instance: ",v,o),s.isMacintosh&&P.app.focus({steal:!0});const g=this.parseOpenUrl(v);if(g.length){let a=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const b=(0,L.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));b&&(a=b.ready())}a.then(()=>{for(const{uri:b,originalUrl:E}of g)this.urlService.open(b,{originalUrl:E})})}else return this.startOpenWindow(v,o)}parseOpenUrl(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,L.coalesce)(v._urls.map(o=>{try{return{uri:A.URI.parse(o),originalUrl:o}}catch{return null}})):[]}async startOpenWindow(v,o){const g=(0,h.isLaunchedFromCli)(o)?0:4;let a=[];const b=v.wait&&v.waitMarkerFilePath?A.URI.file(v.waitMarkerFilePath):void 0,E=v.remote||void 0,w={context:g,cli:v,userEnv:o,waitMarkerFileURI:b,remoteAuthority:E,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,w);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let t=!1;if(v["new-window"]||v["unity-launch"]||w.forceProfile||w.forceTempProfile)t=!0;else if(v["reuse-window"])t=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.isMacintosh}if(t)a=await this.windowsMainService.open({...w,forceNewWindow:!0,forceEmpty:!0});else{const u=this.windowsMainService.getLastActiveWindow();u?(this.windowsMainService.openExistingWindow(u,w),a=[u]):a=await this.windowsMainService.open({...w,forceEmpty:!0})}}else a=await this.windowsMainService.open({...w,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(b&&a.length===1&&a[0])return Promise.race([a[0].whenClosedOrLoaded,(0,R.whenDeleted)(b.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=d=Se([J(0,m.ILogService),J(1,S.IWindowsMainService),J(2,f.IURLService),J(3,I.IConfigurationService)],d)}),define(ee[275],te([0,1,14,4,2,271,29]),function(j,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=e.WebviewMainService=class extends s.Disposable{constructor(l){super(),this.windowsMainService=l,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new A.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(l,m){let f;if(typeof l.windowId=="number"){const{windowId:S}=l,d=this.windowsMainService.getWindowById(S);if(!d?.win)throw new Error(`Invalid windowId: ${S}`);f=d.win.webContents}else{const{webContentsId:S}=l;if(f=P.webContents.fromId(S),!f)throw new Error(`Invalid webContentsId: ${S}`)}f.isDestroyed()||f.setIgnoreMenuShortcuts(m)}async findInFrame(l,m,f,S){const y=this.getFrameByName(l,m);if(typeof y.findInFrame=="function"){y.findInFrame(f,{findNext:S.findNext,forward:S.forward});const v=(o,g)=>{g.finalUpdate&&(this._onFoundInFrame.fire(g),y.removeListener("found-in-frame",v))};y.on("found-in-frame",v)}}async stopFindInFrame(l,m,f){const d=this.getFrameByName(l,m);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(f.keepSelection?"keepSelection":"clearSelection")}getFrameByName(l,m){const f=this.windowsMainService.getWindowById(l.windowId);if(!f?.win)throw new Error(`Invalid windowId: ${l}`);const S=f.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===m);if(!S)throw new Error(`Unknown frame: ${m}`);return S}};e.WebviewMainService=I=Se([J(0,R.IWindowsMainService)],I)}),define(ee[276],te([0,1,8,4,2]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends s.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:h,getActiveWindowId:l}){super(),this.disposables=this._register(new s.DisposableStore),L.Event.latch(L.Event.any(I,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,P.createCancelablePromise)(()=>l()),(async()=>{try{const f=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:f}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(ee[30],te([0,1,190,9,62,19,7,6,15]),function(j,e,P,L,s,A,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function l(i){const n=i;return typeof n?.id=="string"&&R.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=l;function m(i){return typeof i?.id=="string"&&!l(i)&&!S(i)}e.isEmptyWorkspaceIdentifier=m,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function f(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,L.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=i;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=f;function S(i){const n=i;return typeof n?.id=="string"&&R.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=S;function d(i){const n=i;if(n?.uri)return{id:n.id,uri:R.URI.revive(n.uri)};const c=i;if(c?.configPath)return{id:c.id,configPath:R.URI.revive(c.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=d;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function v(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=v;function o(i){const n=i;return!!(n&&typeof n=="object"&&R.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=o;class g{constructor(n,c,p,D,k){this._id=n,this._transient=p,this._configuration=D,this._ignorePathCasing=k,this._foldersMap=s.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=c}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=s.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class a{constructor(n,c){this.raw=c,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=a;function b(i){return new a({uri:i,index:0,name:(0,A.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(i,n){return A.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function w(i){let n;return R.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=w,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function u(i,n){return!E(i,n)&&!w(i)}e.isSavedWorkspace=u;function r(i){return(typeof i=="string"?(0,L.extname)(i):(0,A.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(ee[59],te([0,1,14,8,56,46,2,84,3,11,22,165,91,6,5,23,30]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,d.createDecorator)("dialogMainService");let g=e.DialogMainService=class{constructor(b,E){this.logService=b,this.productService=E,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(b,E){return this.doPick({...b,pickFolders:!0,pickFiles:!0,title:(0,f.localize)(0,null)},E)}pickFolder(b,E){return this.doPick({...b,pickFolders:!0,title:(0,f.localize)(1,null)},E)}pickFile(b,E){return this.doPick({...b,pickFiles:!0,title:(0,f.localize)(2,null)},E)}pickWorkspace(b,E){const w=(0,f.localize)(3,null),t=(0,A.mnemonicButtonLabel)((0,f.localize)(4,null)),u=o.WORKSPACE_FILTER;return this.doPick({...b,pickFiles:!0,title:w,filters:u,buttonLabel:t},E)}async doPick(b,E){const w={title:b.title,buttonLabel:b.buttonLabel,filters:b.filters,defaultPath:b.defaultPath};(typeof b.pickFiles=="boolean"||typeof b.pickFolders=="boolean")&&(w.properties=void 0,b.pickFiles&&b.pickFolders&&(w.properties=["multiSelections","openDirectory","openFile","createDirectory"])),w.properties||(w.properties=["multiSelections",b.pickFolders?"openDirectory":"openFile","createDirectory"]),h.isMacintosh&&w.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(w,(0,l.withNullAsUndefined)(E||P.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}getWindowDialogQueue(b){if(b){let E=this.windowDialogQueues.get(b.id);return E||(E=new L.Queue,this.windowDialogQueues.set(b.id,E)),E}else return this.noWindowDialogueQueue}showMessageBox(b,E){return this.getWindowDialogQueue(E).queue(async()=>{const{options:w,buttonIndeces:t}=(0,S.massageMessageBoxOptions)(b,this.productService);let u;return E?u=await P.dialog.showMessageBox(E,w):u=await P.dialog.showMessageBox(w),{response:t[u.response],checkboxChecked:u.checkboxChecked}})}async showSaveDialog(b,E){const w=this.acquireFileDialogLock(b,E);if(!w)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(E).queue(async()=>{let t;return E?t=await P.dialog.showSaveDialog(E,b):t=await P.dialog.showSaveDialog(b),t.filePath=this.normalizePath(t.filePath),t})}finally{(0,R.dispose)(w)}}normalizePath(b){return b&&h.isMacintosh&&(b=(0,I.normalizeNFC)(b)),b}normalizePaths(b){return b.map(E=>this.normalizePath(E))}async showOpenDialog(b,E){b.defaultPath&&(await m.Promises.exists(b.defaultPath)||(b.defaultPath=void 0));const w=this.acquireFileDialogLock(b,E);if(!w)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(E).queue(async()=>{let t;return E?t=await P.dialog.showOpenDialog(E,b):t=await P.dialog.showOpenDialog(b),t.filePaths=this.normalizePaths(t.filePaths),t})}finally{(0,R.dispose)(w)}}acquireFileDialogLock(b,E){if(!E)return R.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",b);let w=this.windowFileDialogLocks.get(E.id);w||(w=new Set,this.windowFileDialogLocks.set(E.id,w));const t=(0,s.hash)(b);if(!w.has(t))return this.logService.trace("[DialogMainService]: new file dialog lock created",b),w.add(t),(0,R.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",b),w?.delete(t),w?.size===0&&this.windowFileDialogLocks.delete(E.id)})}};e.DialogMainService=g=Se([J(0,y.ILogService),J(1,v.IProductService)],g)}),define(ee[277],te([0,1,4,2,73,30]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class R extends L.Disposable{constructor(h,l){super(),this.logService=h,this.storageMainService=l,this.onDidChangeApplicationStorageEmitter=this._register(new P.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(l.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(h,l){this._register(P.Event.debounce(h.onDidChangeStorage,(m,f)=>(m?m.push(f):m=[f],m),R.STORAGE_CHANGE_DEBOUNCE_TIME)(m=>{m.length&&l.fire(this.serializeStorageChangeEvents(m,h))}))}serializeStorageChangeEvents(h,l){const m=new Map,f=new Set;return h.forEach(S=>{const d=l.get(S.key);typeof d=="string"?m.set(S.key,d):f.add(S.key)}),{changed:Array.from(m.entries()),deleted:Array.from(f.values())}}listen(h,l,m){switch(l){case"onDidChangeStorage":{const f=m.profile?(0,s.revive)(m.profile):void 0;if(!f)return this.onDidChangeApplicationStorageEmitter.event;let S=this.mapProfileToOnDidChangeProfileStorageEmitter.get(f.id);return S||(S=this._register(new P.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(f),S),this.mapProfileToOnDidChangeProfileStorageEmitter.set(f.id,S)),S.event}}throw new Error(`Event not found: ${l}`)}async call(h,l,m){const f=m.profile?(0,s.revive)(m.profile):void 0,S=(0,A.reviveIdentifier)(m.workspace),d=await this.withStorageInitialized(f,S);switch(l){case"getItems":return Array.from(d.items.entries());case"updateItems":{const y=m;if(y.insert)for(const[v,o]of y.insert)d.set(v,o);y.delete?.forEach(v=>d.delete(v));break}case"isUsed":{const y=m.payload;if(typeof y=="string")return this.storageMainService.isUsed(y)}default:throw new Error(`Call not found: ${l}`)}}async withStorageInitialized(h,l){let m;l?m=this.storageMainService.workspaceStorage(l):h?m=this.storageMainService.profileStorage(h):m=this.storageMainService.applicationStorage;try{await m.init()}catch(f){this.logService.error(`StorageIPC#init: Unable to init ${l?"workspace":h?"profile":"application"} storage due to ${f}`)}return m}}e.StorageDatabaseChannel=R,R.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(ee[41],te([0,1,56,4,2,19,7,187,33,16,6,5,30,35,40,8,31,25,11]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function b(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&R.URI.isUri(i.location)&&R.URI.isUri(i.globalStorageHome)&&R.URI.isUri(i.settingsResource)&&R.URI.isUri(i.keybindingsResource)&&R.URI.isUri(i.tasksResource)&&R.URI.isUri(i.snippetsHome)&&R.URI.isUri(i.extensionsResource))}e.isUserDataProfile=b,e.IUserDataProfilesService=(0,m.createDecorator)("IUserDataProfilesService");function E(r,i){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:R.URI.revive(r.location).with({scheme:i}),globalStorageHome:R.URI.revive(r.globalStorageHome).with({scheme:i}),settingsResource:R.URI.revive(r.settingsResource).with({scheme:i}),keybindingsResource:R.URI.revive(r.keybindingsResource).with({scheme:i}),tasksResource:R.URI.revive(r.tasksResource).with({scheme:i}),snippetsHome:R.URI.revive(r.snippetsHome).with({scheme:i}),extensionsResource:R.URI.revive(r.extensionsResource).with({scheme:i}),cacheHome:R.URI.revive(r.cacheHome).with({scheme:i}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=E;function w(r,i,n,c,p){return{id:r,name:i,location:n,isDefault:!1,shortName:p?.shortName,globalStorageHome:(0,A.joinPath)(n,"globalStorage"),settingsResource:(0,A.joinPath)(n,"settings.json"),keybindingsResource:(0,A.joinPath)(n,"keybindings.json"),tasksResource:(0,A.joinPath)(n,"tasks.json"),snippetsHome:(0,A.joinPath)(n,"snippets"),extensionsResource:(0,A.joinPath)(n,"extensions.json"),cacheHome:(0,A.joinPath)(c,r),useDefaultFlags:p?.useDefaultFlags,isTransient:p?.transient}}e.toUserDataProfile=w;let t=e.UserDataProfilesService=class extends s.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,n,c,p){super(),this.environmentService=i,this.fileService=n,this.uriIdentityService=c,this.logService=p,this.enabled=!0,this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new L.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new L.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new L.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const i=[];if(this.enabled)try{for(const D of this.getStoredProfiles()){if(!D.name||!(0,a.isString)(D.name)||!D.location){this.logService.warn("Skipping the invalid stored profile",D.location||D.name);continue}i.push(w((0,A.basename)(D.location),D.name,D.location,this.profilesCacheHome,{shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}))}}catch(D){this.logService.error(D)}const n=new d.ResourceMap,c=new Map,p=this.createDefaultProfile();if(i.unshift({...p,extensionsResource:this.getDefaultProfileExtensionsLocation()??p.extensionsResource,isDefault:!0}),i.length)try{const D=this.getStoredProfileAssociations();if(D.workspaces)for(const[k,C]of Object.entries(D.workspaces)){const _=R.URI.parse(k),T=i.find(U=>U.id===C);T&&n.set(_,T)}if(D.emptyWindows)for(const[k,C]of Object.entries(D.emptyWindows)){const _=i.find(T=>T.id===C);_&&c.set(k,_)}}catch(D){this.logService.error(D)}this._profilesObject={profiles:i,workspaces:n,emptyWindows:c}}return this._profilesObject}createDefaultProfile(){return w("__default__profile__",(0,I.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome)}async createTransientProfile(i){const n="Temp",c=new RegExp(`${(0,g.escapeRegExpCharacters)(n)}\\s(\\d+)`);let p=0;for(const k of this.profiles){const C=c.exec(k.name),_=C?parseInt(C[1]):0;p=_>p?_:p}const D=`${n} ${p+1}`;return this.createProfile((0,P.hash)((0,o.generateUuid)()).toString(16),D,{transient:!0},i)}async createNamedProfile(i,n,c){return this.createProfile((0,P.hash)((0,o.generateUuid)()).toString(16),i,n,c)}async createProfile(i,n,c,p){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const D=await this.doCreateProfile(i,n,c);return p&&await this.setProfileForWorkspace(p,D),D}async doCreateProfile(i,n,c){if(!(0,a.isString)(n)||!n)throw new Error("Name of the profile is mandatory and must be of type `string`");let p=this.profileCreationPromises.get(n);return p||(p=(async()=>{try{const D=this.profiles.find(_=>_.name===n||_.id===i);if(D)return D;const k=w(i,n,(0,A.joinPath)(this.profilesHome,i),this.profilesCacheHome,c);await this.fileService.createFolder(k.location);const C=[];return this._onWillCreateProfile.fire({profile:k,join(_){C.push(_)}}),await v.Promises.settled(C),this.updateProfiles([k],[],[]),k}finally{this.profileCreationPromises.delete(n)}})(),this.profileCreationPromises.set(n,p)),p}async updateProfile(i,n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(p=>p.id===i.id);if(!c)throw new Error(`Profile '${i.name}' does not exist`);return c=w(c.id,n.name??c.name,c.location,this.profilesCacheHome,{shortName:n.shortName??c.shortName,transient:n.transient??c.isTransient,useDefaultFlags:n.useDefaultFlags??c.useDefaultFlags}),this.updateProfiles([],[],[c]),c}async removeProfile(i){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const n=this.profiles.find(p=>p.id===i.id);if(!n)throw new Error(`Profile '${i.name}' does not exist`);const c=[];this._onWillRemoveProfile.fire({profile:n,join(p){c.push(p)}});try{await Promise.allSettled(c)}catch(p){this.logService.error(p)}for(const p of[...this.profilesObject.emptyWindows.keys()])n.id===this.profilesObject.emptyWindows.get(p)?.id&&this.profilesObject.emptyWindows.delete(p);for(const p of[...this.profilesObject.workspaces.keys()])n.id===this.profilesObject.workspaces.get(p)?.id&&this.profilesObject.workspaces.delete(p);this.updateStoredProfileAssociations(),this.updateProfiles([],[n],[]);try{await this.fileService.del(n.cacheHome,{recursive:!0})}catch(p){(0,l.toFileOperationResult)(p)!==1&&this.logService.error(p)}}async setProfileForWorkspace(i,n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(p=>p.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);this.updateWorkspaceAssociation(i,c)}unsetWorkspace(i,n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(i,void 0,n)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(n=>n.isDirectory&&this.profiles.every(c=>!this.uriIdentityService.extUri.isEqual(c.location,n.resource))).map(n=>this.fileService.del(n.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(n=>!this.isProfileAssociatedToWorkspace(n));await Promise.allSettled(i.map(n=>this.removeProfile(n)))}getProfileForWorkspace(i){const n=this.getWorkspace(i);return R.URI.isUri(n)?this.transientProfilesObject.workspaces.get(n)??this.profilesObject.workspaces.get(n):this.transientProfilesObject.emptyWindows.get(n)??this.profilesObject.emptyWindows.get(n)}getWorkspace(i){return(0,S.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,S.isWorkspaceIdentifier)(i)?i.configPath:i.id}isProfileAssociatedToWorkspace(i){return!!([...this.transientProfilesObject.emptyWindows.values()].some(n=>this.uriIdentityService.extUri.isEqual(n.location,i.location))||[...this.transientProfilesObject.workspaces.values()].some(n=>this.uriIdentityService.extUri.isEqual(n.location,i.location))||[...this.profilesObject.emptyWindows.values()].some(n=>this.uriIdentityService.extUri.isEqual(n.location,i.location))||[...this.profilesObject.workspaces.values()].some(n=>this.uriIdentityService.extUri.isEqual(n.location,i.location)))}updateProfiles(i,n,c){const p=[...this.profiles,...i],D=[];this.transientProfilesObject.profiles=[];for(let k of p)k.isDefault||n.some(C=>k.id===C.id)||(k=c.find(C=>k.id===C.id)??k,k.isTransient?this.transientProfilesObject.profiles.push(k):D.push({location:k.location,name:k.name,shortName:k.shortName,useDefaultFlags:k.useDefaultFlags}));this.saveStoredProfiles(D),this._profilesObject=void 0,this.triggerProfilesChanges(i,n,c)}triggerProfilesChanges(i,n,c){this._onDidChangeProfiles.fire({added:i,removed:n,updated:c,all:this.profiles})}updateWorkspaceAssociation(i,n,c){c=n?.isTransient?!0:c,c||this.updateWorkspaceAssociation(i,void 0,!0);const p=this.getWorkspace(i),D=c?this.transientProfilesObject:this.profilesObject;R.URI.isUri(p)?(D.workspaces.delete(p),n&&D.workspaces.set(p,n)):(D.emptyWindows.delete(p),n&&D.emptyWindows.set(p,n)),c||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[c,p]of this.profilesObject.workspaces.entries())i[c.toString()]=p.id;const n={};for(const[c,p]of this.profilesObject.emptyWindows.entries())n[c.toString()]=p.id;this.saveStoredProfileAssociations({workspaces:i,emptyWindows:n}),this._profilesObject=void 0}migrateStoredProfileAssociations(i){const n={},c=this.createDefaultProfile();if(i.workspaces)for(const[D,k]of Object.entries(i.workspaces)){const C=R.URI.parse(k);n[D]=this.uriIdentityService.extUri.isEqual(C,c.location)?c.id:this.uriIdentityService.extUri.basename(C)}const p={};if(i.emptyWindows)for(const[D,k]of Object.entries(i.emptyWindows)){const C=R.URI.parse(k);p[D]=this.uriIdentityService.extUri.isEqual(C,c.location)?c.id:this.uriIdentityService.extUri.basename(C)}return{workspaces:n,emptyWindows:p}}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};t.PROFILES_KEY="userDataProfiles",t.PROFILE_ASSOCIATIONS_KEY="profileAssociations",e.UserDataProfilesService=t=Se([J(0,h.IEnvironmentService),J(1,l.IFileService),J(2,y.IUriIdentityService),J(3,f.ILogService)],t);class u extends t{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=u}),define(ee[81],te([0,1,8,17,2,4,35,7,115,122,16,6,5,41,40,11,13,26]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var a;(function(u){u.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",u.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(a||(e.ExtensionsProfileScanningErrorCode=a={}));class b extends Error{constructor(r,i){super(r),this.code=i}}e.ExtensionsProfileScanningError=b,e.IExtensionsProfileScannerService=(0,f.createDecorator)("IExtensionsProfileScannerService");let E=e.AbstractExtensionsProfileScannerService=class extends s.Disposable{constructor(r,i,n,c,p,D){super(),this.extensionsLocation=r,this.fileService=i,this.userDataProfilesService=n,this.uriIdentityService=c,this.telemetryService=p,this.logService=D,this._onAddExtensions=this._register(new A.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new A.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new A.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new A.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(r,i){return this.withProfileExtensions(r,void 0,i)}async addExtensionsToProfile(r,i){const n=[],c=[];try{return await this.withProfileExtensions(i,p=>{const D=[];for(const k of p)r.some(([C])=>(0,l.areSameExtensions)(C.identifier,k.identifier)&&C.manifest.version!==k.version)?n.push(k):D.push(k);for(const[k,C]of r)if(!D.some(_=>(0,l.areSameExtensions)(_.identifier,k.identifier)&&_.version===k.manifest.version)){const _={identifier:k.identifier,version:k.manifest.version,location:k.location,metadata:C};c.push(_),D.push(_)}return c.length&&this._onAddExtensions.fire({extensions:c,profileLocation:i}),n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:i}),D}),c.length&&this._onDidAddExtensions.fire({extensions:c,profileLocation:i}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:i}),c}catch(p){throw c.length&&this._onDidAddExtensions.fire({extensions:c,error:p,profileLocation:i}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:p,profileLocation:i}),p}}async updateMetadata(r,i){const n=[];return await this.withProfileExtensions(i,c=>{const p=[];for(const D of c){const k=r.find(([C])=>(0,l.areSameExtensions)(C.identifier,D.identifier)&&C.manifest.version===D.version);k&&(D.metadata={...D.metadata,...k[1]},n.push(D)),p.push(D)}return p}),n}async removeExtensionFromProfile(r,i){const n=[];this._onRemoveExtensions.fire({extensions:n,profileLocation:i});try{await this.withProfileExtensions(i,c=>{const p=[];for(const D of c)(0,l.areSameExtensions)(D.identifier,r.identifier)?n.push(D):p.push(D);return n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:i}),p}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:i})}catch(c){throw n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:c,profileLocation:i}),c}}async withProfileExtensions(r,i,n){return this.getResourceAccessQueue(r).queue(async()=>{let c=[],p;try{const D=await this.fileService.readFile(r);p=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,m.toFileOperationResult)(D)!==1)throw D;if(this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)&&(p=await this.migrateFromOldDefaultProfileExtensionsLocation()),!p&&n?.bailOutWhenFileNotFound)throw new b((0,o.getErrorMessage)(D),"ERROR_PROFILE_NOT_FOUND")}if(p){Array.isArray(p)||this.reportAndThrowInvalidConentError(r);let D=!1;for(const k of p){w(k)||this.reportAndThrowInvalidConentError(r);let C;if((0,v.isString)(k.relativeLocation)&&k.relativeLocation)C=this.resolveExtensionLocation(k.relativeLocation);else if((0,v.isString)(k.location))C=this.resolveExtensionLocation(k.location),D=!0,k.relativeLocation=k.location,k.location=C.toJSON();else{C=I.URI.revive(k.location);const _=this.toRelativePath(C);_&&(D=!0,k.relativeLocation=_)}c.push({identifier:k.identifier,location:C,version:k.version,metadata:k.metadata})}D&&await this.fileService.writeFile(r,L.VSBuffer.fromString(JSON.stringify(p)))}if(i){c=i(c);const D=c.map(k=>({identifier:k.identifier,version:k.version,location:k.location.toJSON(),relativeLocation:this.toRelativePath(k.location),metadata:k.metadata}));await this.fileService.writeFile(r,L.VSBuffer.fromString(JSON.stringify(D)))}return c})}reportAndThrowInvalidConentError(r){const i=new b(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(r){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(r),this.extensionsLocation)?this.uriIdentityService.extUri.basename(r):void 0}resolveExtensionLocation(r){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,r)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const r=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let n;try{n=(await this.fileService.readFile(r)).value.toString()}catch(p){if((0,m.toFileOperationResult)(p)===1)return;throw p}this.logService.info("Migrating extensions from old default profile location",r.toString());let c;try{const p=JSON.parse(n);Array.isArray(p)&&p.every(D=>w(D))?c=p:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",p)}catch(p){this.logService.error(p)}if(c)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(c)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",r.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(p){if((0,m.toFileOperationResult)(p)===3)this.logService.info("Migration from old default profile location to new location is done by another window",r.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw p}try{await this.fileService.del(r)}catch(p){(0,m.toFileOperationResult)(p)!==1&&this.logService.error(p)}try{await this.fileService.del(i)}catch(p){(0,m.toFileOperationResult)(p)!==1&&this.logService.error(p)}return c})()),this._migrationPromise}getResourceAccessQueue(r){let i=this.resourcesAccessQueueMap.get(r);return i||(i=new P.Queue,this.resourcesAccessQueueMap.set(r,i)),i}};e.AbstractExtensionsProfileScannerService=E=Se([J(1,m.IFileService),J(2,d.IUserDataProfilesService),J(3,y.IUriIdentityService),J(4,g.ITelemetryService),J(5,S.ILogService)],E);function w(u){return(0,v.isObject)(u)&&(0,h.isIExtensionIdentifier)(u.identifier)&&(t(u.location)||(0,v.isString)(u.location)&&u.location)&&((0,v.isUndefined)(u.relativeLocation)||(0,v.isString)(u.relativeLocation))&&u.version&&(0,v.isString)(u.version)}function t(u){return u?(0,v.isString)(u.path)&&(0,v.isString)(u.scheme):!1}}),define(ee[128],te([0,1,24,8,37,17,13,45,150,2,15,9,3,19,203,69,11,7,170,33,122,119,202,16,6,5,23,4,73,81,41,40,201]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o,g,a,b,E,w,t,u,r,i,n,c,p,D,k,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var T;(function(le){function G(Q,F){if(Q===F)return!0;const N=Object.keys(Q),B=new Set;for(const V of Object.keys(F))B.add(V);if(N.length!==B.size)return!1;for(const V of N){if(Q[V]!==F[V])return!1;B.delete(V)}return B.size===0}le.equals=G})(T||(e.Translations=T={})),e.IExtensionsScannerService=(0,r.createDecorator)("IExtensionsScannerService");let U=e.AbstractExtensionsScannerService=class extends l.Disposable{constructor(G,Q,F,N,B,V,Y,ae,oe,O,M,W){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=Q,this.extensionsControlLocation=F,this.currentProfile=N,this.userDataProfilesService=B,this.extensionsProfileScannerService=V,this.fileService=Y,this.logService=ae,this.environmentService=oe,this.productService=O,this.uriIdentityService=M,this.instantiationService=W,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ie,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ie,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(se,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,E.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(G,Q,F){const[N,B]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(Q)]),V=F?await this.scanExtensionsUnderDevelopment(G,[...N,...B]):[];return this.dedupExtensions(N,B,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const Q=[];Q.push(this.scanDefaultSystemExtensions(!!G.useCache,G.language)),Q.push(this.scanDevSystemExtensions(G.language,!!G.checkControlFile));const[F,N]=await Promise.all(Q);return this.applyScanOptions([...F,...N],0,G,!1)}async scanUserExtensions(G){const Q=G.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",Q);const F=this.uriIdentityService.extUri.isEqual(G.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,N=await this.createExtensionScannerInput(Q,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,F),B=G.useCache&&!N.devMode&&N.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let V;try{V=await B.scanExtensions(N)}catch(Y){if(Y instanceof D.ExtensionsProfileScanningError&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),V=await B.scanExtensions(N);else throw Y}return V=await this.applyScanOptions(V,1,G,!0),this.logService.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(G,Q){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const F=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(N=>N.scheme===m.Schemas.file).map(async N=>{const B=await this.createExtensionScannerInput(N,!1,1,!0,G.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(B)).map(Y=>(Y.type=Q.find(ae=>(0,E.areSameExtensions)(ae.identifier,Y.identifier))?.type??Y.type,this.extensionsScanner.validate(Y,B)))}))).flat();return this.applyScanOptions(F,"development",G,!0)}return[]}async scanExistingExtension(G,Q,F){const N=await this.createExtensionScannerInput(G,!1,Q,!0,F.language,!0,void 0),B=await this.extensionsScanner.scanExtension(N);return!B||!F.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(G,Q,F){const N=await this.createExtensionScannerInput(G,!1,Q,!0,F.language,!0,void 0),B=await this.extensionsScanner.scanOneOrMultipleExtensions(N);return this.applyScanOptions(B,Q,F,!0)}async scanMetadata(G){const Q=(0,d.joinPath)(G,"package.json"),F=(await this.fileService.readFile(Q)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(G,Q){const F=(0,d.joinPath)(G,"package.json"),N=(await this.fileService.readFile(F)).value.toString(),B=JSON.parse(N);Q.isMachineScoped=Q.isMachineScoped||void 0,Q.isBuiltin=Q.isBuiltin||void 0,B.__metadata={...B.__metadata,...Q},await this.fileService.writeFile((0,d.joinPath)(G,"package.json"),A.VSBuffer.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof D.ExtensionsProfileScanningError&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw G}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.extensionsProfileScannerService.addExtensionsToProfile(G.map(Q=>[Q,Q.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(Q){(0,u.toFileOperationResult)(Q)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.getErrorMessage)(Q))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.logService.error(G)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(G,Q,F,N){return F.includeAllVersions||(G=this.dedupExtensions(Q===0?G:void 0,Q===1?G:void 0,Q==="development"?G:void 0,await this.getTargetPlatform(),N)),F.includeInvalid||(G=G.filter(B=>B.isValid)),G.sort((B,V)=>{const Y=f.basename(B.location.fsPath),ae=f.basename(V.location.fsPath);return Y<ae?-1:Y>ae?1:0})}dedupExtensions(G,Q,F,N,B){const V=(ae,oe,O)=>{if(ae.isValid&&!oe.isValid)return!1;if(ae.isValid===oe.isValid){if(B&&y.gt(ae.manifest.version,oe.manifest.version))return this.logService.debug(`Skipping extension ${oe.location.path} with lower version ${oe.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if(y.eq(ae.manifest.version,oe.manifest.version)){if(ae.type===0)return this.logService.debug(`Skipping extension ${oe.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===N)return this.logService.debug(`Skipping extension ${oe.location.path} from different target platform ${oe.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${ae.location.path} with ${oe.location.path}.`):this.logService.debug(`Overwriting user extension ${ae.location.path} with ${oe.location.path}.`),!0},Y=new w.ExtensionIdentifierMap;return G?.forEach(ae=>{const oe=Y.get(ae.identifier.id);(!oe||V(oe,ae,!1))&&Y.set(ae.identifier.id,ae)}),Q?.forEach(ae=>{const oe=Y.get(ae.identifier.id);if(!oe&&G&&ae.type===0){this.logService.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!oe||V(oe,ae,!1))&&Y.set(ae.identifier.id,ae)}),F?.forEach(ae=>{const oe=Y.get(ae.identifier.id);(!oe||V(oe,ae,!0))&&Y.set(ae.identifier.id,ae),Y.set(ae.identifier.id,ae)}),[...Y.values()]}async scanDefaultSystemExtensions(G,Q){this.logService.trace("Started scanning system extensions");const F=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),B=await(G&&!F.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return this.logService.trace("Scanned system extensions:",B.length),B}async scanDevSystemExtensions(G,Q){const F=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!F?.length)return[];this.logService.trace("Started scanning dev system extensions");const N=Q?await this.getBuiltInExtensionControl():{},B=[],V=g.URI.file(f.normalize(f.join(m.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of F){const oe=N[ae.name]||"marketplace";switch(oe){case"disabled":break;case"marketplace":B.push((0,d.joinPath)(V,ae.name));break;default:B.push(g.URI.file(oe));break}}const Y=await Promise.all(B.map(async ae=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ae,!1,0,!0,G,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",Y.length),(0,P.coalesce)(Y)}async getBuiltInExtensionControl(){try{const G=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(G.value.toString())}catch{return{}}}async createExtensionScannerInput(G,Q,F,N,B,V,Y){const ae=await this.getTranslations(B??S.language),oe=await this.getMtime(G),O=Q&&!this.uriIdentityService.extUri.isEqual(G,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,M=O?await this.getMtime(O):void 0;return new q(G,oe,O,M,Q,Y,F,N,V,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,B,ae)}async getMtime(G){try{const Q=await this.fileService.stat(G);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.AbstractExtensionsScannerService=U=Se([J(4,k.IUserDataProfilesService),J(5,D.IExtensionsProfileScannerService),J(6,u.IFileService),J(7,i.ILogService),J(8,b.IEnvironmentService),J(9,n.IProductService),J(10,C.IUriIdentityService),J(11,r.IInstantiationService)],U);class q{constructor(G,Q,F,N,B,V,Y,ae,oe,O,M,W,H,x,z){this.location=G,this.mtime=Q,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=N,this.profile=B,this.profileScanOptions=V,this.type=Y,this.excludeObsolete=ae,this.validate=oe,this.productVersion=O,this.productDate=M,this.productCommit=W,this.devMode=H,this.language=x,this.translations=z}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,Q){return(0,d.isEqual)(G.location,Q.location)&&G.mtime===Q.mtime&&(0,d.isEqual)(G.applicationExtensionslocation,Q.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&G.profile===Q.profile&&s.equals(G.profileScanOptions,Q.profileScanOptions)&&G.type===Q.type&&G.excludeObsolete===Q.excludeObsolete&&G.validate===Q.validate&&G.productVersion===Q.productVersion&&G.productDate===Q.productDate&&G.productCommit===Q.productCommit&&G.devMode===Q.devMode&&G.language===Q.language&&T.equals(G.translations,Q.translations)}}e.ExtensionScannerInput=q;let se=class extends l.Disposable{constructor(G,Q,F,N,B){super(),this.obsoleteFile=G,this.extensionsProfileScannerService=Q,this.uriIdentityService=F,this.fileService=N,this.logService=B}async scanExtensions(G){const Q=G.profile?await this.scanExtensionsFromProfile(G):await this.scanExtensionsFromLocation(G);let F={};if(G.excludeObsolete&&G.type===1)try{const N=(await this.fileService.readFile(this.obsoleteFile)).value.toString();F=JSON.parse(N)}catch{}return(0,o.isEmptyObject)(F)?Q:Q.filter(N=>!F[E.ExtensionKey.create(N).toString()])}async scanExtensionsFromLocation(G){const Q=await this.fileService.resolve(G.location);if(!Q.children?.length)return[];const F=await Promise.all(Q.children.map(async N=>{if(!N.isDirectory||G.type===1&&(0,d.basename)(N.resource).indexOf(".")===0)return null;const B=new q(N.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(B)}));return(0,P.coalesce)(F).sort((N,B)=>N.location.path<B.location.path?-1:1)}async scanExtensionsFromProfile(G){let Q=await this.scanExtensionsFromProfileResource(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(G.location,G.applicationExtensionslocation)){Q=Q.filter(N=>!N.metadata?.isApplicationScoped);const F=await this.scanExtensionsFromProfileResource(G.applicationExtensionslocation,N=>!!N.metadata?.isBuiltin||!!N.metadata?.isApplicationScoped,G);Q.push(...F)}return Q}async scanExtensionsFromProfileResource(G,Q,F){const N=await this.extensionsProfileScannerService.scanProfileExtensions(G,F.profileScanOptions);if(!N.length)return[];const B=await Promise.all(N.map(async V=>{if(Q(V)){const Y=new q(V.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.profileScanOptions,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(Y,V.metadata)}return null}));return(0,P.coalesce)(B)}async scanOneOrMultipleExtensions(G){try{if(await this.fileService.exists((0,d.joinPath)(G.location,"package.json"))){const Q=await this.scanExtension(G);return Q?[Q]:[]}else return await this.scanExtensions(G)}catch(Q){return this.logService.error(`Error scanning extensions at ${G.location.path}:`,(0,R.getErrorMessage)(Q)),[]}}async scanExtension(G,Q){try{let F=await this.scanExtensionManifest(G.location);if(F){F.publisher||(F.publisher=w.UNDEFINED_PUBLISHER),Q=Q??F.__metadata,delete F.__metadata;const N=(0,E.getGalleryExtensionId)(F.publisher,F.name),B=Q?.id?{id:N,uuid:Q.id}:{id:N},V=Q?.isSystem?0:G.type,Y=V===0||!!Q?.isBuiltin;F=await this.translateManifest(G.location,F,q.createNlsConfiguration(G));const ae={type:V,identifier:B,manifest:F,location:G.location,isBuiltin:Y,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return G.validate?this.validate(ae,G):ae}}catch(F){G.type!==0&&this.logService.error(F)}return null}validate(G,Q){let F=!0;const N=(0,t.validateExtensionManifest)(Q.productVersion,Q.productDate,Q.location,G.manifest,G.isBuiltin);for(const[B,V]of N)B===v.default.Error&&(F=!1,this.logService.error(this.formatMessage(Q.location,V)));return G.isValid=F,G.validations=N,G}async scanExtensionManifest(G){const Q=(0,d.joinPath)(G,"package.json");let F;try{F=(await this.fileService.readFile(Q)).value.toString()}catch(B){return(0,u.toFileOperationResult)(B)!==1&&this.logService.error(this.formatMessage(G,(0,a.localize)(0,null,Q.path,B.message))),null}let N;try{N=JSON.parse(F)}catch{const V=[];(0,I.parse)(F,V);for(const Y of V)this.logService.error(this.formatMessage(G,(0,a.localize)(1,null,Q.path,Y.offset,Y.length,(0,h.getParseErrorMessage)(Y.error))));return null}return(0,I.getNodeType)(N)!=="object"?(this.logService.error(this.formatMessage(G,(0,a.localize)(2,null,Q.path))),null):N}async translateManifest(G,Q,F){const N=await this.getLocalizedMessages(G,Q,F);if(N)try{const B=[],V=await this.resolveOriginalMessageBundle(N.default,B);if(B.length>0)return B.forEach(ae=>{this.logService.error(this.formatMessage(G,(0,a.localize)(3,null,N.default?.path,(0,h.getParseErrorMessage)(ae.error))))}),Q;if((0,I.getNodeType)(N)!=="object")return this.logService.error(this.formatMessage(G,(0,a.localize)(4,null,N.default?.path))),Q;const Y=N.values||Object.create(null);return(0,_.localizeManifest)(Q,Y,V)}catch{}return Q}async getLocalizedMessages(G,Q,F){const N=(0,d.joinPath)(G,"package.nls.json"),B=(oe,O)=>{O.forEach(M=>{this.logService.error(this.formatMessage(G,(0,a.localize)(5,null,oe?.path,(0,h.getParseErrorMessage)(M.error))))})},V=oe=>{this.logService.error(this.formatMessage(G,(0,a.localize)(6,null,oe?.path)))},Y=`${Q.publisher}.${Q.name}`,ae=F.translations[Y];if(ae)try{const oe=g.URI.file(ae),O=(await this.fileService.readFile(oe)).value.toString(),M=[],W=(0,I.parse)(O,M);return M.length>0?(B(oe,M),{values:void 0,default:N}):(0,I.getNodeType)(W)!=="object"?(V(oe),{values:void 0,default:N}):{values:W.contents?W.contents.package:void 0,default:N}}catch{return{values:void 0,default:N}}else{if(!await this.fileService.exists(N))return;let O;try{O=await this.findMessageBundles(G,F)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const M=(await this.fileService.readFile(O.localized)).value.toString(),W=[],H=(0,I.parse)(M,W);return W.length>0?(B(O.localized,W),{values:void 0,default:O.original}):(0,I.getNodeType)(H)!=="object"?(V(O.localized),{values:void 0,default:O.original}):{values:H,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(G,Q){if(G)try{const F=(await this.fileService.readFile(G)).value.toString();return(0,I.parse)(F,Q)}catch{}}findMessageBundles(G,Q){return new Promise((F,N)=>{const B=V=>{const Y=(0,d.joinPath)(G,`package.nls.${V}.json`);this.fileService.exists(Y).then(ae=>{ae&&F({localized:Y,original:(0,d.joinPath)(G,"package.nls.json")});const oe=V.lastIndexOf("-");oe===-1?F({localized:(0,d.joinPath)(G,"package.nls.json"),original:null}):(V=V.substring(0,oe),B(V))})};if(Q.devMode||Q.pseudo||!Q.language)return F({localized:(0,d.joinPath)(G,"package.nls.json"),original:null});B(Q.language)})}formatMessage(G,Q){return`[${G.path}]: ${Q}`}};se=Se([J(1,D.IExtensionsProfileScannerService),J(2,C.IUriIdentityService),J(3,u.IFileService),J(4,i.ILogService)],se);let ie=class extends se{constructor(G,Q,F,N,B,V,Y){super(Q,N,B,V,Y),this.currentProfile=G,this.userDataProfilesService=F,this.cacheValidatorThrottler=this._register(new L.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(G){const Q=this.getCacheFile(G),F=await this.readExtensionCache(Q);if(this.input=G,F&&F.input&&q.equals(F.input,this.input))return this.logService.debug("Using cached extensions scan result",G.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),F.result.map(B=>(B.location=g.URI.revive(B.location),B));const N=await super.scanExtensions(G);return await this.writeExtensionCache(Q,{input:G,result:N}),N}async readExtensionCache(G){try{const Q=await this.fileService.readFile(G),F=JSON.parse(Q.value.toString());return{result:F.result,input:(0,p.revive)(F.input)}}catch(Q){this.logService.debug("Error while reading the extension cache file:",G.path,(0,R.getErrorMessage)(Q))}return null}async writeExtensionCache(G,Q){try{await this.fileService.writeFile(G,A.VSBuffer.fromString(JSON.stringify(Q)))}catch(F){this.logService.debug("Error while writing the extension cache file:",G.path,(0,R.getErrorMessage)(F))}}async validateCache(){if(!this.input)return;const G=this.getCacheFile(this.input),Q=await this.readExtensionCache(G);if(!Q)return;const F=Q.result,N=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!s.equals(N,F))try{this.logService.info("Invalidating Cache",F,N),await this.fileService.del(G),this._onDidChangeCache.fire()}catch(B){this.logService.error(B)}}getCacheFile(G){const Q=this.getProfile(G);return this.uriIdentityService.extUri.joinPath(Q.cacheHome,G.type===0?w.BUILTIN_MANIFEST_CACHE_FILE:w.USER_MANIFEST_CACHE_FILE)}getProfile(G){return G.type===0?this.userDataProfilesService.defaultProfile:G.profile?this.uriIdentityService.extUri.isEqual(G.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(Q=>this.uriIdentityService.extUri.isEqual(G.location,Q.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};ie=Se([J(2,k.IUserDataProfilesService),J(3,D.IExtensionsProfileScannerService),J(4,C.IUriIdentityService),J(5,u.IFileService),J(6,i.ILogService)],ie);function ne(le,G){const Q=(0,E.getExtensionId)(le.manifest.publisher,le.manifest.name);return{id:Q,identifier:new w.ExtensionIdentifier(Q),isBuiltin:le.type===0,isUserBuiltin:le.type===1&&le.isBuiltin,isUnderDevelopment:G,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,...le.manifest}}e.toExtensionDescription=ne;class ue extends U{constructor(G,Q,F,N,B,V,Y,ae,oe,O,M,W){super(G,Q,(0,d.joinPath)(F,".vscode-oss-dev","extensions","control.json"),N,B,V,Y,ae,oe,O,M,W),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const H=await this.fileService.readFile(g.URI.file(S.translationsConfigFile));return JSON.parse(H.value.toString())}catch{}return Object.create(null)})()}getTranslations(G){return this.translationsPromise}}e.NativeExtensionsScannerService=ue}),define(ee[278],te([0,1,5,41,40,26,81,16,33,7]),function(j,e,P,L,s,A,R,I,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let m=e.ExtensionsProfileScannerService=class extends R.AbstractExtensionsProfileScannerService{constructor(S,d,y,v,o,g){super(l.URI.file(S.extensionsPath),d,y,v,o,g)}};e.ExtensionsProfileScannerService=m=Se([J(0,h.INativeEnvironmentService),J(1,I.IFileService),J(2,L.IUserDataProfilesService),J(3,s.IUriIdentityService),J(4,A.ITelemetryService),J(5,P.ILogService)],m)}),define(ee[279],te([0,1,7,33,81,128,16,6,5,23,40,41]),function(j,e,P,L,s,A,R,I,h,l,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let S=e.ExtensionsScannerService=class extends A.NativeExtensionsScannerService{constructor(y,v,o,g,a,b,E,w){super(P.URI.file(a.builtinExtensionsPath),P.URI.file(a.extensionsPath),a.userHome,y.defaultProfile,y,v,o,g,a,b,E,w)}};e.ExtensionsScannerService=S=Se([J(0,f.IUserDataProfilesService),J(1,s.IExtensionsProfileScannerService),J(2,R.IFileService),J(3,h.ILogService),J(4,L.INativeEnvironmentService),J(5,l.IProductService),J(6,m.IUriIdentityService),J(7,I.IInstantiationService)],S)}),define(ee[280],te([0,1,14,2,15,9,3,62,7,31,38,33,5,41]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let y=e.ProtocolMainService=class extends L.Disposable{constructor(o,g,a){super(),this.environmentService=o,this.logService=a,this.validRoots=I.TernarySearchTree.forPaths(!R.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(o.appRoot),this.addValidFileRoot(o.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(o.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:o}=P.session;o.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(g,a)=>this.handleResourceRequest(g,a)),o.protocol.interceptFileProtocol(s.Schemas.file,(g,a)=>this.handleFileRequest(g,a)),this._register((0,L.toDisposable)(()=>{o.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),o.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(o){const g=(0,A.normalize)(o);return this.validRoots.get(g)?L.Disposable.None:(this.validRoots.set(g,!0),(0,L.toDisposable)(()=>this.validRoots.delete(g)))}handleFileRequest(o,g){const a=h.URI.parse(o.url);return this.logService.error(`Refused to load resource ${a.fsPath} from ${s.Schemas.file}: protocol (original URL: ${o.url})`),g({error:-3})}handleResourceRequest(o,g){const a=this.requestToNormalizedFilePath(o);let b;return this.environmentService.crossOriginIsolated&&((0,A.basename)(a)==="workbench.html"||(0,A.basename)(a)==="workbench-dev.html"?b=s.COI.CoopAndCoep:b=s.COI.getHeadersFromQuery(o.url)),this.validRoots.findSubstr(a)?g({path:a,headers:b}):this.validExtensions.has((0,A.extname)(a).toLowerCase())?g({path:a}):(this.logService.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${a} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${o.url})`),g({error:-3}))}requestToNormalizedFilePath(o){const g=h.URI.parse(o.url),a=s.FileAccess.uriToFileUri(g);return(0,A.normalize)(a.fsPath)}createIPCObjectUrl(){let o;const g=h.URI.from({scheme:"vscode",path:(0,l.generateUuid)()}),a=g.toString(),b=async()=>o;return m.validatedIpcMain.handle(a,b),this.logService.trace(`IPC Object URL: Registered new channel ${a}.`),{resource:g,update:E=>o=E,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${a}.`),m.validatedIpcMain.removeHandler(a)}}}};e.ProtocolMainService=y=Se([J(0,f.INativeEnvironmentService),J(1,d.IUserDataProfilesService),J(2,S.ILogService)],y)}),define(ee[96],te([0,1,8,4,2,65,11,110,6,41]),function(j,e,P,L,s,A,R,I,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,h.createDecorator)("storageService");var m;(function(a){a[a.NONE=0]="NONE",a[a.SHUTDOWN=1]="SHUTDOWN"})(m||(e.WillSaveStateReason=m={}));var f;(function(a){a[a.APPLICATION=-1]="APPLICATION",a[a.PROFILE=0]="PROFILE",a[a.WORKSPACE=1]="WORKSPACE"})(f||(e.StorageScope=f={}));var S;(function(a){a[a.USER=0]="USER",a[a.MACHINE=1]="MACHINE"})(S||(e.StorageTarget=S={}));function d(a){const b=a.get(e.TARGET_KEY);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}e.loadKeyTargets=d;class y extends s.Disposable{constructor(b={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super(),this.options=b,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new P.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new s.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,P.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,s.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,E){const{key:w,external:t}=E;if(w===e.TARGET_KEY){switch(b){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:b})}else this._onDidChangeValue.fire({scope:b,key:w,target:this.getKeyTargets(b)[w],external:t})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,E,w){return this.getStorage(E)?.get(b,w)}getBoolean(b,E,w){return this.getStorage(E)?.getBoolean(b,w)}getNumber(b,E,w){return this.getStorage(E)?.getNumber(b,w)}getObject(b,E,w){return this.getStorage(E)?.getObject(b,w)}storeAll(b,E){this.withPausedEmitters(()=>{for(const w of b)this.store(w.key,w.value,w.scope,w.target,E)})}store(b,E,w,t,u=!1){if((0,R.isUndefinedOrNull)(E)){this.remove(b,w,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,w,t),this.getStorage(w)?.set(b,E,u)})}remove(b,E,w=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(b,E,void 0),this.getStorage(E)?.delete(b,w)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,E){const w=[],t=this.getKeyTargets(b);for(const u of Object.keys(t))t[u]===E&&w.push(u);return w}updateKeyTarget(b,E,w,t=!1){const u=this.getKeyTargets(E);typeof w=="number"?u[b]!==w&&(u[b]=w,this.getStorage(E)?.set(e.TARGET_KEY,JSON.stringify(u),t)):typeof u[b]=="number"&&(delete u[b],this.getStorage(E)?.set(e.TARGET_KEY,JSON.stringify(u),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(b){switch(b){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(b){const E=this.getStorage(b);return E?d(E):Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=m.NONE){this._onWillSaveState.fire({reason:b});const E=this.getStorage(-1),w=this.getStorage(0),t=this.getStorage(1);switch(b){case m.NONE:await P.Promises.settled([E?.whenFlushed()??Promise.resolve(),w?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await P.Promises.settled([E?.flush(0)??Promise.resolve(),w?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const b=this.getStorage(-1)?.items??new Map,E=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return g(b,E,w,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(b,E){return this.emitWillSaveState(m.NONE),(0,l.isUserDataProfile)(b)?this.switchToProfile(b,E):this.switchToWorkspace(b,E)}canSwitchProfile(b,E){return!(b.id===E.id||v(E)&&v(b))}switchData(b,E,w){this.withPausedEmitters(()=>{const t=new Set;for(const[u,r]of b)t.add(u),E.get(u)!==r&&this.emitDidChangeValue(w,{key:u,external:!0});for(const[u]of E.items)t.has(u)||this.emitDidChangeValue(w,{key:u,external:!0})})}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;function v(a){return a.isDefault||!!a.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=v;class o extends y{constructor(){super(),this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.profileStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b))),this._register(this.applicationStorage.onDidChangeStorage(b=>this.emitDidChangeValue(-1,b)))}getStorage(b){switch(b){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(b){switch(b){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(b){return!1}}e.InMemoryStorageService=o;async function g(a,b,E,w,t,u){const r=T=>{try{return JSON.parse(T)}catch{return T}},i=new Map,n=new Map;a.forEach((T,U)=>{i.set(U,T),n.set(U,r(T))});const c=new Map,p=new Map;b.forEach((T,U)=>{c.set(U,T),p.set(U,r(T))});const D=new Map,k=new Map;E.forEach((T,U)=>{D.set(U,T),k.set(U,r(T))}),console.group(w!==t?`Storage: Application (path: ${w})`:`Storage: Application & Profile (path: ${w}, default profile)`);const C=[];if(i.forEach((T,U)=>{C.push({key:U,value:T})}),console.table(C),console.groupEnd(),console.log(n),w!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const T=[];c.forEach((U,q)=>{T.push({key:q,value:U})}),console.table(T),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${u})`);const _=[];D.forEach((T,U)=>{_.push({key:U,value:T})}),console.table(_),console.groupEnd(),console.log(k)}e.logStorage=g}),define(ee[281],te([0,1,24,8,4,2,9,85,7,22,110,159,5,96,26,30]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class o extends A.Disposable{get storage(){return this._storage}constructor(u,r){super(),this.logService=u,this.fileService=r,this._onDidChangeStorage=this._register(new s.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new s.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new m.Storage(new m.InMemoryStorageDatabase,{hint:m.StorageHint.STORAGE_IN_MEMORY}),this.initializePromise=void 0,this.whenInitPromise=new L.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=m.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===m.StorageState.None)try{const u=await this.doCreate();this._storage.dispose(),this._storage=u,this._register(u.onDidChangeStorage(i=>this._onDidChangeStorage.fire(i))),await this.doInit(u);const r=u.getBoolean(d.IS_NEW_KEY);r===void 0?u.set(d.IS_NEW_KEY,!0):r&&u.set(d.IS_NEW_KEY,!1)}catch(u){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${u}`)}finally{this.state=m.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?u=>this.logService.trace(u):void 0,logError:u=>this.logService.error(u)}}doInit(u){return u.init()}get items(){return this._storage.items}get(u,r){return this._storage.get(u,r)}set(u,r){return this._storage.set(u,r)}delete(u){return this._storage.delete(u)}async close(){const u=new I.StopWatch(!1);await this.doClose(),u.stop(),u.elapsed()>o.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(u),this._onDidCloseStorage.fire()}async logSlowClose(u){if(this.path)try{const r=(0,P.top)(Array.from(this._storage.items.entries()).map(([n,c])=>({key:n,length:c.length})),(n,c)=>c.length-n.length,5).map(n=>`${n.key}:${n.length}`).join(", "),i=(await this.fileService.stat(h.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${u.elapsed()}ms, DB size: ${i}b, Large Keys: ${r}`)}catch(r){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",r)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=m.StorageState.Closed,await this._storage.close()}}o.LOG_SLOW_CLOSE_THRESHOLD=2e3;class g extends o{get path(){if(!this.options.useInMemoryStorage)return(0,R.join)(this.profile.globalStorageHome.fsPath,g.STORAGE_NAME)}constructor(u,r,i,n){super(i,n),this.profile=u,this.options=r}async doCreate(){return new m.Storage(new f.SQLiteStorageDatabase(this.path??f.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:m.StorageHint.STORAGE_IN_MEMORY})}}g.STORAGE_NAME="state.vscdb";class a extends g{constructor(u,r,i,n){super(u,r,i,n)}}e.ProfileStorageMain=a;class b extends g{constructor(u,r,i,n){super(r.defaultProfile,u,i,n)}async doInit(u){await super.doInit(u),this.updateTelemetryState(u)}updateTelemetryState(u){u.get(y.firstSessionDateStorageKey,void 0)===void 0&&u.set(y.firstSessionDateStorageKey,new Date().toUTCString());const i=u.get(y.currentSessionDateStorageKey,void 0),n=new Date().toUTCString();u.set(y.lastSessionDateStorageKey,typeof i>"u"?null:i),u.set(y.currentSessionDateStorageKey,n)}}e.ApplicationStorageMain=b;class E extends o{get path(){if(!this.options.useInMemoryStorage)return(0,R.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,E.WORKSPACE_STORAGE_NAME)}constructor(u,r,i,n,c){super(i,c),this.workspace=u,this.options=r,this.environmentService=n}async doCreate(){const{storageFilePath:u,wasCreated:r}=await this.prepareWorkspaceStorageFolder();return new m.Storage(new f.SQLiteStorageDatabase(u,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?m.StorageHint.STORAGE_IN_MEMORY:r?m.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const u=(0,R.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),r=(0,R.join)(u,E.WORKSPACE_STORAGE_NAME);return await l.Promises.exists(u)?{storageFilePath:r,wasCreated:!1}:(await l.Promises.mkdir(u,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(u),{storageFilePath:r,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(u){let r;if((0,v.isSingleFolderWorkspaceIdentifier)(this.workspace)?r={folder:this.workspace.uri.toString()}:(0,v.isWorkspaceIdentifier)(this.workspace)&&(r={workspace:this.workspace.configPath.toString()}),r)try{const i=(0,R.join)(u,E.WORKSPACE_META_NAME);await l.Promises.exists(i)||await l.Promises.writeFile(i,JSON.stringify(r,void 0,2))}catch(i){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${i}`)}}}e.WorkspaceStorageMain=E,E.WORKSPACE_STORAGE_NAME="state.vscdb",E.WORKSPACE_META_NAME="workspace.json";class w extends o{get path(){}async doCreate(){return new m.Storage(new m.InMemoryStorageDatabase,{hint:m.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=w}),define(ee[282],te([0,1,4,2,96]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class A extends L.Disposable{constructor(I,h,l){super(),this.storageMainService=I,this.userDataProfilesService=h,this.logService=l;const m=this._register(new L.MutableDisposable);this._onDidChange=this._register(new P.Emitter({onWillAddFirstListener:()=>m.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>m.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new L.DisposableStore;return I.add(P.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(h,l)=>(h?h.push(l.key):h=[l.key],h),100)(h=>this.onDidChangeApplicationStorage(h))),I.add(P.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(h,l)=>{h||(h=new Map);let m=h.get(l.profile.id);return m||h.set(l.profile.id,m={profile:l.profile,keys:[],storage:l.storage}),m.keys.push(l.key),h},100)(h=>this.onDidChangeProfileStorage(h))),I}onDidChangeApplicationStorage(I){const h=I.includes(s.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],l=[];if(I=I.filter(m=>m!==s.TARGET_KEY),I.length){const m=(0,s.loadKeyTargets)(this.storageMainService.applicationStorage.storage);l.push({profile:this.userDataProfilesService.defaultProfile,changes:I.map(f=>({key:f,scope:0,target:m[f]}))})}this.triggerEvents(h,l)}onDidChangeProfileStorage(I){const h=[],l=new Map;for(const[m,f]of I.entries()){f.keys.includes(s.TARGET_KEY)&&h.push(f.profile);const S=f.keys.filter(d=>d!==s.TARGET_KEY);if(S.length){const d=(0,s.loadKeyTargets)(f.storage.storage);l.set(m,{profile:f.profile,changes:S.map(y=>({key:y,scope:0,target:d[y]}))})}}this.triggerEvents(h,[...l.values()])}triggerEvents(I,h){(I.length||h.length)&&this._onDidChange.fire({valueChanges:h,targetChanges:I})}listen(I,h,l){switch(h){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${h}`)}async call(I,h){throw new Error(`Call not found: ${h}`)}}e.ProfileStorageChangesListenerChannel=A}),define(ee[283],te([0,1,7,33,16,5,34,40,41,11,120]),function(j,e,P,L,s,A,R,I,h,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let f=e.UserDataProfilesReadonlyService=class ht extends h.UserDataProfilesService{constructor(v,o,g,a,b){super(g,a,o,b),this.stateReadonlyService=v,this.nativeEnvironmentService=g}getStoredProfiles(){return this.stateReadonlyService.getItem(ht.PROFILES_KEY,[]).map(o=>({...o,location:(0,l.isString)(o.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,o.location):P.URI.revive(o.location)}))}getStoredProfileAssociations(){const v=this.stateReadonlyService.getItem(ht.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(ht.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?v:this.migrateStoredProfileAssociations(v)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(P.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};f.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration",e.UserDataProfilesReadonlyService=f=Se([J(0,R.IStateReadService),J(1,I.IUriIdentityService),J(2,L.INativeEnvironmentService),J(3,s.IFileService),J(4,A.ILogService)],f);let S=e.UserDataProfilesService=class st extends f{constructor(v,o,g,a,b){super(v,o,g,a,b),this.stateService=v}saveStoredProfiles(v){v.length?this.stateService.setItem(st.PROFILES_KEY,v.map(o=>({...o,location:this.uriIdentityService.extUri.basename(o.location)}))):this.stateService.removeItem(st.PROFILES_KEY)}getStoredProfiles(){const v=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(v),this.stateService.setItem("userDataProfilesMigration",!0)),v}saveStoredProfileAssociations(v){v.emptyWindows||v.workspaces?this.stateService.setItem(st.PROFILE_ASSOCIATIONS_KEY,v):this.stateService.removeItem(st.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const v="workspaceAndProfileInfo",o=this.stateService.getItem(v,void 0);if(o){this.stateService.removeItem(v);const a=o.reduce((b,{workspace:E,profile:w})=>(b[P.URI.revive(E).toString()]=P.URI.revive(w).toString(),b),{});this.stateService.setItem(st.PROFILE_ASSOCIATIONS_KEY,{workspaces:a})}const g=super.getStoredProfileAssociations();return this.stateService.getItem(st.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(g),this.stateService.setItem(st.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),g}};e.UserDataProfilesService=S=Se([J(0,R.IStateService),J(1,I.IUriIdentityService),J(2,L.INativeEnvironmentService),J(3,s.IFileService),J(4,A.ILogService)],S);let d=e.ServerUserDataProfilesService=class extends S{constructor(v,o,g,a){super(new m.StateService(0,o,a,g),v,o,g,a)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=d=Se([J(0,I.IUriIdentityService),J(1,L.INativeEnvironmentService),J(2,s.IFileService),J(3,A.ILogService)],d)}),define(ee[53],te([0,1,33,16,6,5,40,41,283,34]),function(j,e,P,L,s,A,R,I,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,s.refineServiceDecorator)(I.IUserDataProfilesService);let m=e.UserDataProfilesMainService=class extends h.UserDataProfilesService{constructor(S,d,y,v,o){super(S,d,y,v,o)}getAssociatedEmptyWindows(){const S=[];for(const d of this.profilesObject.emptyWindows.keys())S.push({id:d});return S}};e.UserDataProfilesMainService=m=Se([J(0,l.IStateService),J(1,R.IUriIdentityService),J(2,P.INativeEnvironmentService),J(3,L.IFileService),J(4,A.ILogService)],m)}),define(ee[129],te([0,1,19,7,30]),function(j,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function A(h,l,m){for(const S of h){const d=S.openedWorkspace;if((0,s.isWorkspaceIdentifier)(d)){const y=await m(d);if(y){if(y.folders.some(v=>P.extUriBiasedIgnorePathCase.isEqualOrParent(l,v.uri)))return S}else if(P.extUriBiasedIgnorePathCase.isEqualOrParent(l,d.configPath))return S}}const f=h.filter(S=>(0,s.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqualOrParent(l,S.openedWorkspace.uri));if(f.length)return f.sort((S,d)=>-(S.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=A;function R(h,l){for(const m of h)if((0,s.isWorkspaceIdentifier)(m.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(m.openedWorkspace.configPath,l)||(0,s.isSingleFolderWorkspaceIdentifier)(m.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(m.openedWorkspace.uri,l))return m}e.findWindowOnWorkspaceOrFolder=R;function I(h,l){const m=f=>l.some(S=>P.extUriBiasedIgnorePathCase.isEqual(L.URI.file(S),L.URI.file(f)));for(const f of h)if(f.config?.extensionDevelopmentPath?.some(S=>m(S)))return f}e.findWindowOnExtensionDevelopmentPath=I}),define(ee[97],te([0,1,32,45,136,46,15,9,3,19,7,6,58,30]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,f.createDecorator)("workspacesService");function y(k){return k.hasOwnProperty("workspace")}e.isRecentWorkspace=y;function v(k){return k.hasOwnProperty("folderUri")}e.isRecentFolder=v;function o(k){return k.hasOwnProperty("fileUri")}e.isRecentFile=o;function g(k){return a(k)||b(k)}e.isStoredWorkspaceFolder=g;function a(k){const C=k;return typeof C?.path=="string"&&(!C.name||typeof C.name=="string")}function b(k){const C=k;return typeof C?.uri=="string"&&(!C.name||typeof C.name=="string")}function E(k,C,_,T,U){if(k.scheme!==T.scheme)return{name:_,uri:k.toString(!0)};let q=C?void 0:U.relativePath(T,k);if(q!==void 0)q.length===0?q=".":h.isWindows&&(q=w(q));else if(k.scheme===R.Schemas.file)q=k.fsPath,h.isWindows&&(q=w(q));else if(U.isEqualAuthority(k.authority,T.authority))q=k.path;else return{name:_,uri:k.toString(!0)};return{name:_,path:q}}e.getStoredWorkspaceFolder=E;function w(k){return k=(0,A.normalizeDriveLetter)(k),(0,P.isUNC)(k)||(k=(0,P.toSlashes)(k)),k}function t(k,C,_){const T=[],U=new Set,q=_.dirname(C);for(const se of k){let ie;if(a(se))se.path&&(ie=_.resolvePath(q,se.path));else if(b(se))try{ie=m.URI.parse(se.uri),ie.path[0]!==I.posix.sep&&(ie=ie.with({path:I.posix.sep+ie.path}))}catch(ne){console.warn(ne)}if(ie){const ne=_.getComparisonKey(ie);if(!U.has(ne)){U.add(ne);const ue=se.name||_.basenameOrAuthority(ie);T.push(new d.WorkspaceFolder({uri:ie,name:ue,index:T.length},se))}}}return T}e.toWorkspaceFolders=t;function u(k,C,_,T,U){const q=r(C,k),se=U.dirname(C),ie=U.dirname(T),ne=[];for(const Q of q.folders){const F=a(Q)?U.resolvePath(se,Q.path):m.URI.parse(Q.uri);let N;_?N=!1:N=!a(Q)||(0,I.isAbsolute)(Q.path),ne.push(E(F,N,Q.name,ie,U))}const ue={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},le=s.setProperty(k,["folders"],ne,ue);let G=s.applyEdits(k,le);return(0,l.isEqualAuthority)(q.remoteAuthority,(0,S.getRemoteAuthority)(T))&&(G=s.applyEdits(G,s.removeProperty(G,["remoteAuthority"],ue))),G}e.rewriteWorkspaceFileForNewLocation=u;function r(k,C){const _=L.parse(C);if(_&&Array.isArray(_.folders))_.folders=_.folders.filter(T=>g(T));else throw new Error(`${k} looks like an invalid workspace file.`);return _}function i(k){return k.workspace&&typeof k.workspace=="object"&&typeof k.workspace.id=="string"&&typeof k.workspace.configPath=="string"}function n(k){return typeof k.folderUri=="string"}function c(k){return typeof k.fileUri=="string"}function p(k,C){const _={workspaces:[],files:[]};if(k){const T=function(q,se){for(let ie=0;ie<q.length;ie++)try{se(q[ie],ie)}catch(ne){C.warn(`Error restoring recent entry ${JSON.stringify(q[ie])}: ${ne.toString()}. Skip entry.`)}},U=k;Array.isArray(U.entries)&&T(U.entries,q=>{const se=q.label,ie=q.remoteAuthority;i(q)?_.workspaces.push({label:se,remoteAuthority:ie,workspace:{id:q.workspace.id,configPath:m.URI.parse(q.workspace.configPath)}}):n(q)?_.workspaces.push({label:se,remoteAuthority:ie,folderUri:m.URI.parse(q.folderUri)}):c(q)&&_.files.push({label:se,remoteAuthority:ie,fileUri:m.URI.parse(q.fileUri)})})}return _}e.restoreRecentlyOpened=p;function D(k){const C={entries:[]};for(const _ of k.workspaces)v(_)?C.entries.push({folderUri:_.folderUri.toString(),label:_.label,remoteAuthority:_.remoteAuthority}):C.entries.push({workspace:{id:_.workspace.id,configPath:_.workspace.configPath.toString()},label:_.label,remoteAuthority:_.remoteAuthority});for(const _ of k.files)C.entries.push({fileUri:_.fileUri.toString(),label:_.label,remoteAuthority:_.remoteAuthority});return C}e.toStoreData=D}),define(ee[98],te([0,1,71,15,3,19]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function R(l){function m(){let f=l.scheme===L.Schemas.file?(0,A.originalFSPath)(l):l.toString();return s.isLinux||(f=f.toLowerCase()),(0,P.createHash)("md5").update(f).digest("hex")}return{id:m(),configPath:l}}e.getWorkspaceIdentifier=R;function I(l,m){function f(){if(l.scheme!==L.Schemas.file)return(0,P.createHash)("md5").update(l.toString()).digest("hex");if(!m)return;let d;return s.isLinux?d=m.ino:s.isMacintosh?d=m.birthtime.getTime():s.isWindows&&(typeof m.birthtimeMs=="number"?d=Math.floor(m.birthtimeMs):d=m.birthtime.getTime()),(0,P.createHash)("md5").update(l.fsPath).update(d?String(d):"").digest("hex")}const S=f();if(typeof S=="string")return{id:S,uri:l}}e.getSingleFolderWorkspaceIdentifier=I;function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=h}),define(ee[130],te([0,1,71,87,27,284,17,13,4,2,9,3,31,43,108]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{traceSocketEvent(C,_){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,C,_)}constructor(C,_=""){this._canWrite=!0,this.debugLabel=_,this.socket=C,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=T=>{if(this.traceSocketEvent("error",{code:T?.code,message:T?.message}),T){if(T.code==="EPIPE")return;(0,I.onUnexpectedError)(T)}},this.socket.on("error",this._errorListener),this._closeListener=T=>{this.traceSocketEvent("close",{hadError:T}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(C){const _=T=>{this.traceSocketEvent("read",T),C(R.VSBuffer.wrap(T))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(C){const _=T=>{C({type:0,hadError:T,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(C){const _=()=>{C()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(C){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",C),this.socket.write(C.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,I.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,I.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((C,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),C();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),this.traceSocketEvent("nodeDrainEnd"),C()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=v;var o;(function(k){k[k.MinHeaderByteSize=2]="MinHeaderByteSize",k[k.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(o||(o={}));var g;(function(k){k[k.PeekHeader=1]="PeekHeader",k[k.ReadHeader=2]="ReadHeader",k[k.ReadBody=3]="ReadBody",k[k.Fin=4]="Fin"})(g||(g={}));class a extends l.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(C,_){this.socket.traceSocketEvent(C,_)}constructor(C,_,T,U){super(),this._onData=this._register(new h.Emitter),this._onClose=this._register(new h.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=C,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:T?.byteLength||0,recordInflateBytes:U}),this._flowManager=this._register(new b(this,_,T,U,this._onData,(q,se)=>this._write(q,se))),this._register(this._flowManager.onError(q=>{console.error(q),(0,I.onUnexpectedError)(q),this._onClose.fire({type:0,hadError:!0,error:q})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData(q=>this._acceptChunk(q))),this._register(this.socket.onClose(async q=>{this._flowManager.isProcessingReadQueue()&&await h.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(q)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this._onData.event(C)}onClose(C){return this._onClose.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){let _=0;for(;_<C.byteLength;)this._flowManager.writeMessage(C.slice(_,Math.min(_+262144,C.byteLength))),_+=262144}_write(C,_){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",C);let T=2;C.byteLength<126?T+=0:C.byteLength<2**16?T+=2:T+=8;const U=R.VSBuffer.alloc(T);if(_?U.writeUInt8(194,0):U.writeUInt8(130,0),C.byteLength<126)U.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){U.writeUInt8(126,1);let q=1;U.writeUInt8(C.byteLength>>>8&255,++q),U.writeUInt8(C.byteLength>>>0&255,++q)}else{U.writeUInt8(127,1);let q=1;U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(C.byteLength>>>24&255,++q),U.writeUInt8(C.byteLength>>>16&255,++q),U.writeUInt8(C.byteLength>>>8&255,++q),U.writeUInt8(C.byteLength>>>0&255,++q)}this.socket.write(R.VSBuffer.concat([U,C]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(C){if(C.byteLength!==0){for(this._incomingData.acceptChunk(C);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),T=_.readUInt8(0),U=(T&128)>>>7,q=(T&64)>>>6,se=_.readUInt8(1),ie=(se&128)>>>7,ne=se&127;this._state.state=2,this._state.readLen=2+(ie?4:0)+(ne===126?2:0)+(ne===127?8:0),this._state.fin=U,this._state.firstFrameOfMessage&&(this._state.compressed=!!q),this._state.firstFrameOfMessage=!!U,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),T=_.readUInt8(1),U=(T&128)>>>7;let q=T&127,se=1;q===126?q=_.readUInt8(++se)*2**8+_.readUInt8(++se):q===127&&(q=_.readUInt8(++se)*0+_.readUInt8(++se)*0+_.readUInt8(++se)*0+_.readUInt8(++se)*0+_.readUInt8(++se)*2**24+_.readUInt8(++se)*2**16+_.readUInt8(++se)*2**8+_.readUInt8(++se));let ie=0;U&&(ie=_.readUInt8(++se)*2**24+_.readUInt8(++se)*2**16+_.readUInt8(++se)*2**8+_.readUInt8(++se)),this._state.state=3,this._state.readLen=q,this._state.mask=ie,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),t(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await h.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=a;class b extends l.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:R.VSBuffer.alloc(0)}constructor(C,_,T,U,q,se){super(),this._tracer=C,this._onData=q,this._writeFn=se,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new h.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new h.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new E(this._tracer,U,T,{windowBits:15})),this._zlibDeflateStream=this._register(new w(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(ie=>this._onError.fire(ie))),this._register(this._zlibDeflateStream.onError(ie=>this._onError.fire(ie)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(C){this._writeQueue.push(C),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const C=this._writeQueue.shift();if(this._zlibDeflateStream){const _=await this._deflateMessage(this._zlibDeflateStream,C);this._writeFn(_,!0)}else this._writeFn(C,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(C,_){return new Promise((T,U)=>{C.write(_),C.flush(q=>T(q))})}acceptFrame(C,_,T){this._readQueue.push({data:C,isCompressed:_,isLastFrameOfMessage:T}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const C=this._readQueue.shift();if(this._zlibInflateStream&&C.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,C.data,C.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(C.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(C,_,T){return new Promise((U,q)=>{C.write(_),T&&C.write(R.VSBuffer.fromByteArray([0,0,255,255])),C.flush(se=>U(se))})}}class E extends l.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.concat(this._recordedInflateBytes):R.VSBuffer.alloc(0)}constructor(C,_,T,U){super(),this._tracer=C,this._recordInflateBytes=_,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,A.createInflateRaw)(U),this._zlibInflate.on("error",q=>{this._tracer.traceSocketEvent("zlibInflateError",{message:q?.message,code:q?.code}),this._onError.fire(q)}),this._zlibInflate.on("data",q=>{this._tracer.traceSocketEvent("zlibInflateData",q),this._pendingInflateData.push(R.VSBuffer.wrap(q))}),T&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",T.buffer),this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(C){this._recordInflateBytes&&this._recordedInflateBytes.push(C.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",C),this._zlibInflate.write(C.buffer)}flush(C){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=R.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,C(_)})}}class w extends l.Disposable{constructor(C,_){super(),this._tracer=C,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,A.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",T=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:T?.message,code:T?.code}),this._onError.fire(T)}),this._zlibDeflate.on("data",T=>{this._tracer.traceSocketEvent("zlibDeflateData",T),this._pendingDeflateData.push(R.VSBuffer.wrap(T))})}write(C){this._tracer.traceSocketEvent("zlibDeflateWrite",C.buffer),this._zlibDeflate.write(C.buffer)}flush(C){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=R.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),C(_)})}}function t(k,C){if(C===0)return;const _=k.byteLength>>>2;for(let ne=0;ne<_;ne++){const ue=k.readUInt32BE(ne*4);k.writeUInt32BE(ue^C,ne*4)}const T=_*4,U=k.byteLength-T,q=C>>>24&255,se=C>>>16&255,ie=C>>>8&255;U>=1&&k.writeUInt8(k.readUInt8(T)^q,T),U>=2&&k.writeUInt8(k.readUInt8(T+1)^se,T+1),U>=3&&k.writeUInt8(k.readUInt8(T+2)^ie,T+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function r(){const k=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${k}-sock`;const C=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,s.tmpdir)(),_=(0,m.join)(C,`vscode-ipc-${k}.sock`);return n(_),_}e.createRandomIPCHandle=r;function i(k,C,_){const T=(0,P.createHash)("md5").update(k).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${_}-${C}-sock`;const U=_.substr(0,4),q=C.substr(0,6),se=T.substr(0,8);let ie;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?ie=(0,m.join)(e.XDG_RUNTIME_DIR,`vscode-${se}-${U}-${q}.sock`):ie=(0,m.join)(k,`${U}-${q}.sock`),n(ie),ie}e.createStaticIPCHandle=i;function n(k){const C=u[f.platform];typeof C=="number"&&k.length>=C&&console.warn(`WARNING: IPC handle "${k}" is longer than ${C} chars, try a shorter --user-data-dir`)}class c extends d.IPCServer{static toClientConnectionEvent(C){const _=h.Event.fromNodeEventEmitter(C,"connection");return h.Event.map(_,T=>({protocol:new y.Protocol(new v(T,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(T,"close"))}))}constructor(C){super(c.toClientConnectionEvent(C)),this.server=C}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=c;function p(k){return new Promise((C,_)=>{const T=(0,L.createServer)();T.on("error",_),T.listen(k,()=>{T.removeListener("error",_),C(new c(T))})})}e.serve=p;function D(k,C){return new Promise((_,T)=>{const U=(0,L.createConnection)(k,()=>{U.removeListener("error",T),_(y.Client.fromSocket(new v(U,`ipc-client${C}`),C))});U.once("error",T)})}e.connect=D}),define(ee[28],te([0,1,55,9,3,130,33,89,6]),function(j,e,P,L,s,A,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,h.refineServiceDecorator)(R.IEnvironmentService);class l extends I.NativeEnvironmentService{constructor(){super(...arguments),this._snapEnv={}}get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,A.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.isLinux){for(const f in process.env)if(f.endsWith("_VSCODE_SNAP_ORIG")){const S=f.slice(0,-17);if(this._snapEnv[S])continue;process.env[S]&&(this._snapEnv[S]=process.env[S]),process.env[f]?process.env[S]=process.env[f]:delete process.env[S]}}}restoreSnapExportedVariables(){if(s.isLinux)for(const f in this._snapEnv)process.env[f]=this._snapEnv[f],delete this._snapEnv[f]}}e.EnvironmentMainService=l,Se([P.memoize],l.prototype,"cachedLanguagesPath",null),Se([P.memoize],l.prototype,"backupHome",null),Se([P.memoize],l.prototype,"mainIPCHandle",null),Se([P.memoize],l.prototype,"mainLockfile",null),Se([P.memoize],l.prototype,"disableUpdates",null),Se([P.memoize],l.prototype,"disableKeytar",null),Se([P.memoize],l.prototype,"crossOriginIsolated",null),Se([P.memoize],l.prototype,"codeCachePath",null),Se([P.memoize],l.prototype,"useCodeCache",null)}),define(ee[285],te([0,1,71,32,15,9,3,19,22,194,18,28,34,16,5,193,30,98]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let a=e.BackupMainService=class St{constructor(E,w,t,u){this.environmentMainService=E,this.configurationService=w,this.logService=t,this.stateService=u,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=I.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(r,i)=>(0,L.isEqual)(r,i,!R.isLinux)}}async initialize(){const E=this.stateService.getItem(St.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(E.emptyWindows),this.workspaces=await this.validateWorkspaces((0,l.deserializeWorkspaceInfos)(E)),this.folders=await this.validateFolders((0,l.deserializeFolderInfos)(E)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(E,w){this.workspaces.some(u=>E.workspace.id===u.workspace.id)||(this.workspaces.push(E),this.storeWorkspacesMetadata());const t=(0,A.join)(this.backupHome,E.workspace.id);return w?this.moveBackupFolder(t,w).then(()=>t):t}async moveBackupFolder(E,w){if(await h.Promises.exists(E)&&await this.convertToEmptyWindowBackup(E),await h.Promises.exists(w))try{await h.Promises.rename(w,E)}catch(t){this.logService.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(E){return this.folders.some(w=>this.backupUriComparer.isEqual(E.folderUri,w.folderUri))||(this.folders.push(E),this.storeWorkspacesMetadata()),(0,A.join)(this.backupHome,this.getFolderHash(E))}registerEmptyWindowBackup(E){return this.emptyWindows.some(w=>!!w.backupFolder&&this.backupPathComparer.isEqual(w.backupFolder,E.backupFolder))||(this.emptyWindows.push(E),this.storeWorkspacesMetadata()),(0,A.join)(this.backupHome,E.backupFolder)}async validateWorkspaces(E){if(!Array.isArray(E))return[];const w=new Set,t=[];for(const u of E){const r=u.workspace;if(!(0,o.isWorkspaceIdentifier)(r))return[];if(!w.has(r.id)){w.add(r.id);const i=(0,A.join)(this.backupHome,r.id);await this.doHasBackups(i)?r.configPath.scheme!==s.Schemas.file||await h.Promises.exists(r.configPath.fsPath)?t.push(u):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return t}async validateFolders(E){if(!Array.isArray(E))return[];const w=[],t=new Set;for(const u of E){const r=u.folderUri,i=this.backupUriComparer.getComparisonKey(r);if(!t.has(i)){t.add(i);const n=(0,A.join)(this.backupHome,this.getFolderHash(u));await this.doHasBackups(n)?r.scheme!==s.Schemas.file||await h.Promises.exists(r.fsPath)?w.push(u):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return w}async validateEmptyWorkspaces(E){if(!Array.isArray(E))return[];const w=[],t=new Set;for(const u of E){const r=u.backupFolder;if(typeof r!="string")return[];if(!t.has(r)){t.add(r);const i=(0,A.join)(this.backupHome,r);await this.doHasBackups(i)?w.push(u):await this.deleteStaleBackup(i)}}return w}async deleteStaleBackup(E){try{await h.Promises.rm(E,h.RimRafMode.MOVE)}catch(w){this.logService.error(`Backup: Could not delete stale backup: ${w.toString()}`)}}prepareNewEmptyWindowBackup(){let E=(0,g.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(w=>!!w.backupFolder&&this.backupPathComparer.isEqual(w.backupFolder,E.id));)E=(0,g.createEmptyWorkspaceIdentifier)();return{backupFolder:E.id}}async convertToEmptyWindowBackup(E){const w=this.prepareNewEmptyWindowBackup(),t=(0,A.join)(this.backupHome,w.backupFolder);try{await h.Promises.rename(E,t)}catch(u){return this.logService.error(`Backup: Could not rename backup folder: ${u.toString()}`),!1}return this.emptyWindows.push(w),!0}async getDirtyWorkspaces(){const E=[];for(const w of this.workspaces)await this.hasBackups(w)&&E.push(w);for(const w of this.folders)await this.hasBackups(w)&&E.push(w);return E}hasBackups(E){let w;return(0,l.isEmptyWindowBackupInfo)(E)?w=(0,A.join)(this.backupHome,E.backupFolder):(0,v.isFolderBackupInfo)(E)?w=(0,A.join)(this.backupHome,this.getFolderHash(E)):w=(0,A.join)(this.backupHome,E.workspace.id),this.doHasBackups(w)}async doHasBackups(E){try{const w=await h.Promises.readdir(E);for(const t of w)try{if((await h.Promises.readdir((0,A.join)(E,t))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const E={workspaces:this.workspaces.map(({workspace:w,remoteAuthority:t})=>{const u={id:w.id,configURIPath:w.configPath.toString()};return t&&(u.remoteAuthority=t),u}),folders:this.folders.map(({folderUri:w,remoteAuthority:t})=>{const u={folderUri:w.toString()};return t&&(u.remoteAuthority=t),u}),emptyWindows:this.emptyWindows.map(({backupFolder:w,remoteAuthority:t})=>{const u={backupFolder:w};return t&&(u.remoteAuthority=t),u})};this.stateService.setItem(St.backupWorkspacesMetadataStorageKey,E)}getFolderHash(E){const w=E.folderUri;let t;return w.scheme===s.Schemas.file?t=R.isLinux?w.fsPath:w.fsPath.toLowerCase():t=w.toString().toLowerCase(),(0,P.createHash)("md5").update(t).digest("hex")}};a.backupWorkspacesMetadataStorageKey="backupWorkspaces",e.BackupMainService=a=Se([J(0,f.IEnvironmentMainService),J(1,m.IConfigurationService),J(2,y.ILogService),J(3,S.IStateService)],a)}),define(ee[20],te([0,1,14,38,8,4,2,3,36,11,6,5,34,28]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,m.createDecorator)("lifecycleMainService");var y;(function(g){g[g.QUIT=1]="QUIT",g[g.KILL=2]="KILL"})(y||(e.ShutdownReason=y={}));var v;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen",g[g.Eventually=4]="Eventually"})(v||(e.LifecycleMainPhase=v={}));let o=e.LifecycleMainService=class ft extends R.Disposable{get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(a,b,E){super(),this.logService=a,this.stateService=b,this.environmentMainService=E,this._onBeforeShutdown=this._register(new A.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new A.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new A.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new A.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(ft.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(ft.QUIT_AND_RESTART_KEY)}registerListeners(){const a=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),I.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};P.app.addListener("before-quit",a);const b=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!I.isMacintosh)&&P.app.quit()};P.app.addListener("window-all-closed",b),P.app.once("will-quit",E=>{this.trace("Lifecycle#app.on(will-quit) - begin"),E.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),P.app.removeListener("before-quit",a),P.app.removeListener("window-all-closed",b),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}fireOnWillShutdown(a){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const b=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this._onWillShutdown.fire({reason:a,join(w,t){b.trace(`Lifecycle#onWillShutdown - begin '${w}'`),E.push(t.finally(()=>{b.trace(`Lifecycle#onWillShutdown - end '${w}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await s.Promises.settled(E)}catch(w){this.logService.error(w)}try{await this.stateService.close()}catch(w){this.logService.error(w)}})(),this.pendingWillShutdownPromise}set phase(a){if(a<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===a)return;this.trace(`lifecycle (main): phase changed (value: ${a})`),this._phase=a;const b=this.phaseWhen.get(this._phase);b&&(b.open(),this.phaseWhen.delete(this._phase))}async when(a){if(a<=this._phase)return;let b=this.phaseWhen.get(a);b||(b=new s.Barrier,this.phaseWhen.set(a,b)),await b.wait()}registerWindow(a){const b=new R.DisposableStore;this.windowCounter++,b.add(a.onWillLoad(w=>this._onWillLoadWindow.fire({window:a,workspace:w.workspace,reason:w.reason})));const E=(0,l.assertIsDefined)(a.win);E.on("close",w=>{const t=a.id;if(this.windowToCloseRequest.has(t)){this.windowToCloseRequest.delete(t);return}this.trace(`Lifecycle#window.on('close') - window ID ${a.id}`),w.preventDefault(),this.unload(a,1).then(u=>{if(u){this.windowToCloseRequest.delete(t);return}this.windowToCloseRequest.add(t),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this._onBeforeCloseWindow.fire(a),a.close()})}),E.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${a.id}`),this.windowCounter--,b.dispose(),this.windowCounter===0&&(!I.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(a,b){await this.unload(a,3)||a.reload(b)}unload(a,b){const E=this.mapWindowIdToPendingUnload.get(a.id);if(E)return E;const w=this.doUnload(a,b).finally(()=>{this.mapWindowIdToPendingUnload.delete(a.id)});return this.mapWindowIdToPendingUnload.set(a.id,w),w}async doUnload(a,b){if(!a.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${a.id}`);const E=this._quitRequested?2:b,w=await this.onBeforeUnloadWindowInRenderer(a,E);return w?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${a.id})`),this.handleWindowUnloadVeto(w)):(await this.onWillUnloadWindowInRenderer(a,E),!1)}handleWindowUnloadVeto(a){return a?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(a){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(a),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(a,b){return new Promise(E=>{const w=this.oneTimeListenerTokenGenerator++,t=`vscode:ok${w}`,u=`vscode:cancel${w}`;L.validatedIpcMain.once(t,()=>{E(!1)}),L.validatedIpcMain.once(u,()=>{E(!0)}),a.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:u,reason:b})})}onWillUnloadWindowInRenderer(a,b){return new Promise(E=>{const t=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;L.validatedIpcMain.once(t,()=>E()),a.send("vscode:onWillUnload",{replyChannel:t,reason:b})})}quit(a){return this.trace(`Lifecycle#quit() - begin (willRestart: ${a})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(a&&this.stateService.setItem(ft.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(b=>{this.pendingQuitPromiseResolve=b,this.trace("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.pendingQuitPromise)}trace(a){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(a):this.logService.trace(a)}async relaunch(a){this.trace("Lifecycle#relaunch()");const b=process.argv.slice(1);if(a?.addArgs&&b.push(...a.addArgs),a?.removeArgs)for(const t of a.removeArgs){const u=b.indexOf(t);u>=0&&b.splice(u,1)}const E=()=>{try{if(I.isWindows){const t=(0,h.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.logService.error(t)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:b})};P.app.once("quit",E),await this.quit(!0)&&P.app.removeListener("quit",E)}async kill(a){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,s.timeout)(1e3),(async()=>{for(const b of P.BrowserWindow.getAllWindows())if(b&&!b.isDestroyed()){let E;b.webContents&&!b.webContents.isDestroyed()?E=new Promise(w=>b.once("closed",w)):E=Promise.resolve(),b.destroy(),await E}})()]),P.app.exit(a)}};o.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",e.LifecycleMainService=o=Se([J(0,f.ILogService),J(1,S.IStateService),J(2,d.IEnvironmentMainService)],o)}),define(ee[286],te([0,1,3,4,2,6,20]),function(j,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,A.createDecorator)("keyboardLayoutMainService");let I=e.KeyboardLayoutMainService=class extends s.Disposable{constructor(m){super(),this._onDidChangeKeyboardLayout=this._register(new L.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,m.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const m=await new Promise((f,S)=>{j(["native-keymap"],f,S)});this._keyboardLayoutData=h(m),P.isCI||m.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=h(m),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};e.KeyboardLayoutMainService=I=Se([J(0,R.ILifecycleMainService)],I);function h(l){const m=l.getKeyMap(),f=l.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:f}}}),define(ee[287],te([0,1,245,8,17,13,11,18,33,94,5,51,244,284]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let y=e.RequestService=class extends f.AbstractRequestService{constructor(a,b,E,w){super(w),this.configurationService=a,this.environmentService=b,this.logService=E,this.configure(),this._register(a.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const a=this.configurationService.getValue("http");this.proxyUrl=a?.proxy,this.strictSSL=!!a?.proxyStrictSSL,this.authorization=a?.proxyAuthorization}async request(a,b){const{proxyUrl:E,strictSSL:w}=this;let t;try{t=await(0,l.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(i){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,A.getErrorMessage)(i)))}const u={...process.env,...t},r=a.agent?a.agent:await(0,S.getProxyAgent)(a.url||"",u,{proxyUrl:E,strictSSL:w});return a.agent=r,a.strictSSL=w,this.authorization&&(a.headers={...a.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(a.isChromiumNetwork?"electron":"node",a,()=>o(a,b))}async resolveProxy(a){}};e.RequestService=y=Se([J(0,I.IConfigurationService),J(1,h.INativeEnvironmentService),J(2,m.ILogService),J(3,m.ILoggerService)],y);async function v(g){return((0,P.parse)(g.url).protocol==="https:"?await new Promise((E,w)=>{j(["https"],E,w)}):await new Promise((E,w)=>{j(["http"],E,w)})).request}async function o(g,a){return L.Promises.withAsyncBody(async(b,E)=>{const w=(0,P.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await v(g),u={hostname:w.hostname,port:w.port?parseInt(w.port):w.protocol==="https:"?443:80,protocol:w.protocol,path:w.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,R.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(u.auth=g.user+":"+g.password);const r=t(u,i=>{const n=(0,R.isNumber)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)o({...g,url:i.headers.location,followRedirects:n-1},a).then(b,E);else{let c=i;!g.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(c=i.pipe((0,d.createGunzip)())),b({res:i,stream:(0,s.streamToBufferReadableStream)(c)})}});r.on("error",E),g.timeout&&r.setTimeout(g.timeout),g.isChromiumNetwork&&r.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&r.write(g.data),r.end(),a.onCancellationRequested(()=>{r.abort(),E(new A.CancellationError)})})}e.nodeRequest=o}),define(ee[288],te([0,1,14,287]),function(j,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function s(R){return P.net.request}class A extends L.RequestService{request(I,h){return super.request({...I||{},getRawRequest:s,isChromiumNetwork:!0},h)}}e.RequestMainService=A}),define(ee[99],te([0,1,7,49,4,2,33,16,6,20,5,96,281,41,53,40]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,h.createDecorator)("storageMainService");let o=e.StorageMainService=class extends A.Disposable{constructor(b,E,w,t,u,r){super(),this.logService=b,this.environmentService=E,this.userDataProfilesService=w,this.lifecycleMainService=t,this.fileService=u,this.uriIdentityService=r,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new s.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(b=>{b.window.profile&&this.profileStorage(b.window.profile).init(),b.workspace&&this.workspaceStorage(b.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(b=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=b.reason,b.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.mapProfileToStorage)b.join("profileStorage",E.close());for(const[,E]of this.mapWorkspaceToStorage)b.join("workspaceStorage",E.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(b=>{b.join((async()=>{await this.fileService.exists(b.profile.globalStorageHome)||await this.fileService.createFolder(b.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(b=>{const E=this.mapProfileToStorage.get(b.profile.id);E&&b.join(E.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const b=new S.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,L.once)(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),b}profileStorage(b){if((0,f.isProfileUsingDefaultStorage)(b))return this.applicationStorage;let E=this.mapProfileToStorage.get(b.id);if(!E){this.logService.trace(`StorageMainService: creating profile storage (${b.name})`),E=this.createProfileStorage(b),this.mapProfileToStorage.set(b.id,E);const w=this._register(E.onDidChangeStorage(t=>this._onDidChangeProfileStorage.fire({...t,storage:E,profile:b})));(0,L.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${b.name})`),this.mapProfileToStorage.delete(b.id),w.dispose()})}return E}createProfileStorage(b){return this.shutdownReason===2?new S.InMemoryStorageMain(this.logService,this.fileService):new S.ProfileStorageMain(b,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(b){let E=this.mapWorkspaceToStorage.get(b.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),E=this.createWorkspaceStorage(b),this.mapWorkspaceToStorage.set(b.id,E),(0,L.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)})),E}createWorkspaceStorage(b){return this.shutdownReason===2?new S.InMemoryStorageMain(this.logService,this.fileService):new S.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(b){const E=P.URI.file(b);for(const w of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(w.path&&this.uriIdentityService.extUri.isEqualOrParent(P.URI.file(w.path),E))return!0;return!1}};e.StorageMainService=o=Se([J(0,m.ILogService),J(1,R.IEnvironmentService),J(2,y.IUserDataProfilesMainService),J(3,l.ILifecycleMainService),J(4,I.IFileService),J(5,v.IUriIdentityService)],o),e.IApplicationStorageMainService=(0,h.createDecorator)("applicationStorageMainService");let g=e.ApplicationStorageMainService=class extends f.AbstractStorageService{constructor(b,E){super(),this.userDataProfilesService=b,this.storageMainService=E,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(b){if(b===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(b){if(b===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=g=Se([J(0,d.IUserDataProfilesService),J(1,e.IStorageMainService)],g)}),define(ee[100],te([0,1,8,21,4,18,28,20,5,23,51,48]),function(j,e,P,L,s,A,R,I,h,l,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(y,v,o){return`${o.updateUrl}/api/update/${y}/${v}/${o.commit}`}e.createUpdateURL=S;let d=e.AbstractUpdateService=class{get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}constructor(v,o,g,a,b,E){this.lifecycleMainService=v,this.configurationService=o,this.environmentMainService=g,this.requestService=a,this.logService=b,this.productService=E,this._state=f.State.Uninitialized,this._onStateChange=new s.Emitter,this.onStateChange=this._onStateChange.event,v.when(3).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.configurationService.getValue("update.mode"),o=this.getProductQuality(v);if(!o){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(o),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(f.State.Idle(this.getUpdateType())),v==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,g=>this.logService.error(g))}getProductQuality(v){return v==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(v=60*60*1e3){return(0,P.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(v){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}catch(o){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(o);return}}async _applySpecificUpdate(v){}getUpdateType(){return 1}doQuitAndInstall(){}};e.AbstractUpdateService=d=Se([J(0,I.ILifecycleMainService),J(1,A.IConfigurationService),J(2,R.IEnvironmentMainService),J(3,m.IRequestService),J(4,h.ILogService),J(5,l.IProductService)],d)}),define(ee[289],te([0,1,14,55,4,2,18,28,20,5,23,51,26,48,100]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let v=e.DarwinUpdateService=class extends y.AbstractUpdateService{get onRawError(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"error",(g,a)=>a)}get onRawUpdateNotAvailable(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",(g,a,b)=>({url:a,version:b,productVersion:b}))}get onRawUpdateDownloaded(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",(g,a,b,E)=>({releaseNotes:a,version:b,productVersion:b,date:E}))}constructor(g,a,b,E,w,t,u){super(g,a,E,w,t,u),this.telemetryService=b,this.disposables=new A.DisposableStore}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(g){this.logService.error("UpdateService error:",g);const a=this.state.type==="checking for updates"&&this.state.explicit?g:void 0;this.setState(d.State.Idle(1,a))}buildUpdateFeedUrl(g){let a;this.productService.darwinUniversalAssetId?a=this.productService.darwinUniversalAssetId:a=process.arch==="x64"?"darwin":"darwin-arm64";const b=(0,y.createUpdateURL)(a,g,this.productService);try{P.autoUpdater.setFeedURL({url:b})}catch(E){this.logService.error("Failed to set update feed URL",E);return}return b}doCheckForUpdates(g){this.setState(d.State.CheckingForUpdates(g)),P.autoUpdater.checkForUpdates()}onUpdateAvailable(g){this.state.type==="checking for updates"&&this.setState(d.State.Downloading(g))}onUpdateDownloaded(g){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:g.version}),this.setState(d.State.Ready(g)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(d.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};Se([L.memoize],v.prototype,"onRawError",null),Se([L.memoize],v.prototype,"onRawUpdateNotAvailable",null),Se([L.memoize],v.prototype,"onRawUpdateAvailable",null),Se([L.memoize],v.prototype,"onRawUpdateDownloaded",null),e.DarwinUpdateService=v=Se([J(0,h.ILifecycleMainService),J(1,R.IConfigurationService),J(2,S.ITelemetryService),J(3,I.IEnvironmentMainService),J(4,f.IRequestService),J(5,l.ILogService),J(6,m.IProductService)],v)}),define(ee[290],te([0,1,47,42,8,4,9,28,20,5,26,48]),function(j,e,P,L,s,A,R,I,h,l,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}constructor(v,o,g){if(this.lifecycleMainService=v,this.logService=g,this._state=f.State.Uninitialized,this._onStateChange=new A.Emitter,this.onStateChange=this._onStateChange.event,o.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(f.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,a=>this.logService.error(a))}scheduleCheckForUpdates(v=60*60*1e3){return(0,s.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(v){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(v){}};S=Se([J(0,h.ILifecycleMainService),J(1,I.IEnvironmentMainService),J(2,l.ILogService)],S);let d=e.SnapUpdateService=class extends S{constructor(v,o,g,a,b,E){super(g,a,b),this.snap=v,this.snapRevision=o,this.telemetryService=E;const w=(0,L.watch)(R.dirname(this.snap)),t=A.Event.fromNodeEventEmitter(w,"change",(n,c)=>c),u=A.Event.filter(t,n=>n==="current"),i=A.Event.debounce(u,(n,c)=>c,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{i.dispose(),w.close()})}doCheckForUpdates(){this.setState(f.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(v=>{v?this.setState(f.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(f.State.Idle(2)))},v=>{this.logService.error(v),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(f.State.Idle(2,v.message||v))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+R.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const v=await new Promise((g,a)=>(0,L.realpath)(`${R.dirname(this.snap)}/current`,(b,E)=>b?a(b):g(E))),o=R.basename(v);return this.snapRevision!==o}isLatestVersion(){return this.isUpdateAvailable().then(void 0,v=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=d=Se([J(2,h.ILifecycleMainService),J(3,I.IEnvironmentMainService),J(4,l.ILogService),J(5,m.ITelemetryService)],d)}),define(ee[291],te([0,1,2,20,53,30,8,29]),function(j,e,P,L,s,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let h=e.UserDataProfilesHandler=class extends P.Disposable{constructor(m,f,S){super(),this.userDataProfilesService=f,this.windowsMainService=S,this._register(m.onWillLoadWindow(d=>{d.reason===2&&this.unsetProfileForWorkspace(d.window)})),this._register(m.onBeforeCloseWindow(d=>this.unsetProfileForWorkspace(d))),this._register(new R.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(m){const f=this.getWorkspace(m),S=this.userDataProfilesService.getProfileForWorkspace(f);S?.isTransient&&(this.userDataProfilesService.unsetWorkspace(f,S.isTransient),S.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(m){return m.openedWorkspace??(0,A.toWorkspaceIdentifier)(m.backupPath,m.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const m=this.userDataProfilesService.getAssociatedEmptyWindows();if(m.length===0)return;const f=this.windowsMainService.getWindows().map(S=>this.getWorkspace(S));for(const S of m)f.some(d=>d.id===S.id)||this.userDataProfilesService.unsetWorkspace(S,!1)}};e.UserDataProfilesHandler=h=Se([J(0,L.ILifecycleMainService),J(1,s.IUserDataProfilesMainService),J(2,I.IWindowsMainService)],h)}),define(ee[60],te([0,1,14,2,4,5,310,8,15,29,69,26,20,72,37,3,131]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function g(E){return typeof E.responseWindowId=="number"}let a=e.UtilityProcess=class ut extends L.Disposable{static getAll(){return Array.from(ut.all.values())}constructor(w,t,u){super(),this.logService=w,this.telemetryService=t,this.lifecycleMainService=u,this.id=String(++ut.ID_COUNTER),this._onStdout=this._register(new s.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new s.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new s.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new s.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new s.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0}log(w,t){let u;switch(this.configuration?.correlationId?u=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${w}`:u=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${w}`,t){case m.default.Error:this.logService.error(u);break;case m.default.Warning:this.logService.warn(u);break;case m.default.Info:this.logService.trace(u);break}}validateCanStart(){return this.process?(this.log("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(w){const t=this.doStart(w);return t&&w.payload&&this.postMessage(w.payload),t}doStart(w){if(!this.validateCanStart())return!1;this.configuration=w;const t=`${this.configuration.type}-${this.id}`,u=h.FileAccess.asFileUri("bootstrap-fork.js").fsPath,r=this.configuration.args??[],i=this.configuration.execArgv??[],n=this.configuration.allowLoadingUnsignedLibraries,c=this.configuration.forceAllocationsToV8Sandbox,p="pipe",D=this.createEnv(w);return this.log("creating new...",m.default.Info),this.process=P.utilityProcess.fork(u,r,{serviceName:t,env:D,execArgv:i,allowLoadingUnsignedLibraries:n,forceAllocationsToV8Sandbox:c,stdio:p}),this.registerListeners(this.process,this.configuration,t),!0}createEnv(w){const t=w.env?{...w.env}:{...(0,y.deepClone)(process.env)};t.VSCODE_AMD_ENTRYPOINT=w.entryPoint,typeof w.parentLifecycleBound=="number"&&(t.VSCODE_PARENT_PID=String(w.parentLifecycleBound)),t.VSCODE_CRASH_REPORTER_PROCESS_TYPE=w.type,v.isWindows&&((0,o.isUNCAccessRestrictionsDisabled)()?t.NODE_DISABLE_UNC_ACCESS_CHECKS="1":t.NODE_UNC_HOST_ALLOWLIST=(0,o.getUNCHostAllowlist)().join("\\")),(0,d.removeDangerousEnvVariables)(t);for(const u of Object.keys(t))t[u]=String(t[u]);return t}registerListeners(w,t,u){if(w.stdout){const r=new R.StringDecoder("utf-8");this._register(s.Event.fromNodeEventEmitter(w.stdout,"data")(i=>this._onStdout.fire(typeof i=="string"?i:r.write(i))))}if(w.stderr){const r=new R.StringDecoder("utf-8");this._register(s.Event.fromNodeEventEmitter(w.stderr,"data")(i=>this._onStderr.fire(typeof i=="string"?i:r.write(i))))}this._register(s.Event.fromNodeEventEmitter(w,"message")(r=>this._onMessage.fire(r))),this._register(s.Event.fromNodeEventEmitter(w,"spawn")(()=>{this.processPid=w.pid,typeof w.pid=="number"&&ut.all.set(w.pid,{pid:w.pid,name:g(t)?`${t.type} [${t.responseWindowId}]`:t.type}),this.log("successfully created",m.default.Info)})),this._register(s.Event.fromNodeEventEmitter(w,"exit")(r=>{this.log(`received exit event with code ${r}`,m.default.Info),this._onExit.fire({pid:this.processPid,code:r,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(s.Event.fromNodeEventEmitter(P.app,"child-process-gone",(r,i)=>({event:r,details:i}))(({details:r})=>{r.type==="Utility"&&r.name===u&&(this.log(`crashed with code ${r.exitCode} and reason '${r.reason}'`,m.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:t.type,reason:r.reason,code:r.exitCode}),this._onCrash.fire({pid:this.processPid,code:r.exitCode,reason:r.reason}),this.onDidExitOrCrashOrKill())}))}once(w,t){const u=this._register(this._onMessage.event(r=>{r===w&&(u.dispose(),t())}))}postMessage(w,t){this.process&&this.process.postMessage(w,t)}connect(w){const{port1:t,port2:u}=new P.MessageChannelMain;return this.postMessage(w,[u]),t}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",m.default.Info);const w=process;return typeof w._debugProcess=="function"?(w._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",m.default.Info),this.process.kill()?(this.log("successfully killed the process",m.default.Info),this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",m.default.Warning)}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&ut.all.delete(this.processPid),this.process=void 0}async waitForExit(w){this.process&&(this.log("waiting to exit...",m.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,I.timeout)(w)]),this.process&&(this.log(`did not exit within ${w}ms, will kill it now...`,m.default.Info),this.kill()))}};a.ID_COUNTER=0,a.all=new Map,e.UtilityProcess=a=Se([J(0,A.ILogService),J(1,f.ITelemetryService),J(2,S.ILifecycleMainService)],a);let b=e.WindowUtilityProcess=class extends a{constructor(w,t,u,r){super(w,u,r),this.windowsMainService=t}start(w){const t=this.windowsMainService.getWindowById(w.responseWindowId);if(!t?.win||t.win.isDestroyed()||t.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.doStart(w))return!1;this.registerWindowListeners(t.win,w);const r=this.connect(w.payload);return t.win.webContents.postMessage(w.responseChannel,w.responseNonce,[r]),!0}registerWindowListeners(w,t){t.windowLifecycleBound&&(this._register(s.Event.filter(this.lifecycleMainService.onWillLoadWindow,u=>u.window.win===w)(()=>this.kill())),this._register(s.Event.fromNodeEventEmitter(w,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=b=Se([J(0,A.ILogService),J(1,l.IWindowsMainService),J(2,f.ITelemetryService),J(3,S.ILifecycleMainService)],b)}),define(ee[292],te([0,1,13,5,20,8,60,29,26]),function(j,e,P,L,s,A,R,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let l=e.ExtensionHostStarter=class Mt{constructor(f,S,d,y){this._logService=f,this._lifecycleMainService=S,this._windowsMainService=d,this._telemetryService=y,this._extHosts=new Map,this._shutdown=!1,this._lifecycleMainService.onWillShutdown(v=>{this._shutdown=!0,v.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}_getExtHost(f){const S=this._extHosts.get(f);if(!S)throw new Error("Unknown extension host!");return S}onDynamicStdout(f){return this._getExtHost(f).onStdout}onDynamicStderr(f){return this._getExtHost(f).onStderr}onDynamicMessage(f){return this._getExtHost(f).onMessage}onDynamicExit(f){return this._getExtHost(f).onExit}async createExtensionHost(){if(this._shutdown)throw(0,P.canceled)();const f=String(++Mt._lastId),S=new R.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService);return this._extHosts.set(f,S),S.onExit(({pid:d,code:y,signal:v})=>{this._logService.info(`Extension host with pid ${d} exited with code: ${y}, signal: ${v}.`),setTimeout(()=>{S.dispose(),this._extHosts.delete(f)})}),{id:f}}async start(f,S){if(this._shutdown)throw(0,P.canceled)();this._getExtHost(f).start({...S,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:S.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:f})}async enableInspectPort(f){if(this._shutdown)throw(0,P.canceled)();const S=this._extHosts.get(f);return S?S.enableInspectPort():!1}async kill(f){if(this._shutdown)throw(0,P.canceled)();const S=this._extHosts.get(f);S&&S.kill()}async _killAllNow(){for(const[,f]of this._extHosts)f.kill()}async _waitForAllExit(f){const S=[];for(const[,d]of this._extHosts)S.push(d.waitForExit(f));return A.Promises.settled(S).then(()=>{})}};l._lastId=0,e.ExtensionHostStarter=l=Se([J(0,L.ILogService),J(1,s.ILifecycleMainService),J(2,I.IWindowsMainService),J(3,h.ITelemetryService)],l)}),define(ee[293],te([0,1,38,8,2,28,20,5,41,39,66,60,52,89,11]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let v=e.SharedProcess=class extends s.Disposable{constructor(g,a,b,E,w,t,u){super(),this.machineId=g,this.environmentMainService=a,this.userDataProfilesService=b,this.lifecycleMainService=E,this.logService=w,this.loggerMainService=t,this.policyService=u,this.firstWindowConnectionBarrier=new L.Barrier,this.utilityProcess=void 0,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){P.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(g,a)=>this.onWindowConnection(g,a)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(g,a){this.logService.trace("[SharedProcess] on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const b=await this.connect();if(g.sender.isDestroyed())return b.close();g.sender.postMessage("vscode:createSharedProcessMessageChannelResult",a,[b])}onWillShutdown(){this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess?.postMessage("vscode:electron-main->shared-process=exit"),this.utilityProcess=void 0}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const g=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once("vscode:shared-process->electron-main=init-done",()=>g.complete()):P.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>g.complete()),await g.p,this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createUtilityProcess();const g=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once("vscode:shared-process->electron-main=ipc-ready",()=>g.complete()):P.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>g.complete()),await g.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}createUtilityProcess(){this.utilityProcess=this._register(new f.UtilityProcess(this.logService,S.NullTelemetryService,this.lifecycleMainService));const g=(0,d.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let a;g.port&&(a=["--nolazy"],g.break?a.push(`--inspect-brk=${g.port}`):a.push(`--inspect=${g.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:a})}createSharedProcessConfiguration(){return{machineId:this.machineId,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),policiesData:this.policyService.serialize()}}async connect(){return await this.whenIpcReady,(0,y.assertIsDefined)(this.utilityProcess).connect()}};e.SharedProcess=v=Se([J(1,A.IEnvironmentMainService),J(2,h.IUserDataProfilesService),J(3,R.ILifecycleMainService),J(4,I.ILogService),J(5,m.ILoggerMainService),J(6,l.IPolicyService)],v)}),define(ee[294],te([0,1,28,89,20,5,52,60,109,38,2,4,37,18]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronPtyHostStarter=void 0;let y=e.ElectronPtyHostStarter=class{constructor(o,g,a,b,E){this._reconnectConstants=o,this._configurationService=g,this._environmentMainService=a,this._lifecycleMainService=b,this._logService=E,this.utilityProcess=void 0,this._onBeforeWindowConnection=new f.Emitter,this.onBeforeWindowConnection=this._onBeforeWindowConnection.event,this._onWillShutdown=new f.Emitter,this.onWillShutdown=this._onWillShutdown.event,this._lifecycleMainService.onWillShutdown(()=>this._onWillShutdown.fire()),l.validatedIpcMain.on("vscode:createPtyHostMessageChannel",(w,t)=>this._onWindowConnection(w,t))}start(o){this.utilityProcess=new I.UtilityProcess(this._logService,R.NullTelemetryService,this._lifecycleMainService);const g=(0,L.parsePtyHostDebugPort)(this._environmentMainService.args,this._environmentMainService.isBuilt),a=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.utilityProcess.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:a,args:["--logsPath",this._environmentMainService.logsHome.fsPath],env:this._createPtyHostConfiguration(o)});const b=this.utilityProcess.connect(),E=new h.Client(b,"ptyHost"),w=new m.DisposableStore;return w.add(E),w.add(this.utilityProcess),w.add((0,m.toDisposable)(()=>{l.validatedIpcMain.removeHandler("vscode:createPtyHostMessageChannel"),this.utilityProcess=void 0})),{client:E,store:w,onDidProcessExit:this.utilityProcess.onExit}}_createPtyHostConfiguration(o){this._environmentMainService.unsetSnapExportedVariables();const g={...(0,S.deepClone)(process.env),VSCODE_LAST_PTY_ID:String(o),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this._reconnectConstants.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this._reconnectConstants.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this._reconnectConstants.scrollback)},a=this._configurationService.getValue("terminal.integrated.developer.ptyHost.latency");a&&typeof a=="number"&&(g.VSCODE_LATENCY=String(a));const b=this._configurationService.getValue("terminal.integrated.developer.ptyHost.startupDelay");return b&&typeof b=="number"&&(g.VSCODE_STARTUP_DELAY=String(b)),this._environmentMainService.restoreSnapExportedVariables(),g}_onWindowConnection(o,g){this._onBeforeWindowConnection.fire();const a=this.utilityProcess.connect();if(o.sender.isDestroyed()){a.close();return}o.sender.postMessage("vscode:createPtyHostMessageChannelResult",g,[a])}};e.ElectronPtyHostStarter=y=Se([J(1,d.IConfigurationService),J(2,P.IEnvironmentMainService),J(3,s.ILifecycleMainService),J(4,A.ILogService)],y)}),define(ee[295],te([0,1,2,6,5,29,60,26,56,4,8,20]),function(j,e,P,L,s,A,R,I,h,l,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,L.createDecorator)("utilityProcessWorker");let S=e.UtilityProcessWorkerMainService=class extends P.Disposable{constructor(v,o,g,a){super(),this.logService=v,this.windowsMainService=o,this.telemetryService=g,this.lifecycleMainService=a,this.workers=new Map}async createWorker(v){const o=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${o})`);const g=this.hash(v);this.workers.has(g)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${o})`),this.disposeWorker(v));const a=new d(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,v);if(!a.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(g,a);const b=new m.DeferredPromise;return l.Event.once(a.onDidTerminate)(E=>{E.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.workers.delete(g),b.complete({reason:E})}),b.p}hash(v){return(0,h.hash)({moduleId:v.process.moduleId,windowId:v.reply.windowId})}async disposeWorker(v){const o=this.hash(v),g=this.workers.get(o);g&&(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),g.kill(),this.workers.delete(o))}};e.UtilityProcessWorkerMainService=S=Se([J(0,s.ILogService),J(1,A.IWindowsMainService),J(2,I.ITelemetryService),J(3,f.ILifecycleMainService)],S);let d=class extends P.Disposable{constructor(v,o,g,a,b){super(),this.logService=v,this.windowsMainService=o,this.telemetryService=g,this.lifecycleMainService=a,this.configuration=b,this._onDidTerminate=this._register(new l.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=new R.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(v=>this._onDidTerminate.fire({code:v.code,signal:v.signal}))),this._register(this.utilityProcess.onCrash(v=>this._onDidTerminate.fire({code:v.code,signal:"ECRASH"})))}spawn(){const o=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:o,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};d=Se([J(0,s.ILogService),J(1,A.IWindowsMainService),J(2,I.ITelemetryService),J(3,f.ILifecycleMainService)],d)}),define(ee[296],te([0,1,14,2,3,19,7,18,20,5,34,29,127,30]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=e.WindowsStateHandler=class yt extends L.Disposable{get state(){return this._state}constructor(E,w,t,u,r){super(),this.windowsMainService=E,this.stateService=w,this.lifecycleMainService=t,this.logService=u,this.configurationService=r,this._state=v(this.stateService.getItem(yt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){P.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(E=>this.onBeforeCloseWindow(E)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(E=>{E.newCount-E.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(E=>this.onBeforeCloseWindow(E))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const E=new Set,w={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!w.lastActiveWindow){let r=this.windowsMainService.getLastActiveWindow();(!r||r.isExtensionDevelopmentHost)&&(r=this.windowsMainService.getWindows().find(i=>!i.isExtensionDevelopmentHost)),r&&(w.lastActiveWindow=this.toWindowState(r),w.lastActiveWindow.uiState.mode===3&&E.add(w.lastActiveWindow.uiState.display))}const t=this.windowsMainService.getWindows().find(r=>r.isExtensionDevelopmentHost&&!r.isExtensionTestHost);t&&(w.lastPluginDevelopmentHostWindow=this.toWindowState(t),w.lastPluginDevelopmentHostWindow.uiState.mode===3&&(E.has(w.lastPluginDevelopmentHostWindow.uiState.display)?s.isMacintosh&&!t.win?.isSimpleFullScreen()&&(w.lastPluginDevelopmentHostWindow.uiState.mode=1):E.add(w.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(w.openedWindows=this.windowsMainService.getWindows().filter(r=>!r.isExtensionDevelopmentHost).map(r=>{const i=this.toWindowState(r);return i.uiState.mode===3&&(E.has(i.uiState.display)?s.isMacintosh&&i.windowId!==w.lastActiveWindow?.windowId&&!r.win?.isSimpleFullScreen()&&(i.uiState.mode=1):E.add(i.uiState.display)),i}));const u=g(w);this.stateService.setItem(yt.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(E){if(this.lifecycleMainService.quitRequested)return;const w=this.toWindowState(E);E.isExtensionDevelopmentHost&&!E.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=w:!E.isExtensionDevelopmentHost&&E.openedWorkspace&&this._state.openedWindows.forEach(t=>{const u=(0,d.isWorkspaceIdentifier)(E.openedWorkspace)&&t.workspace?.id===E.openedWorkspace.id,r=(0,d.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&t.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(t.folderUri,E.openedWorkspace.uri);(u||r)&&(t.uiState=w.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=w)}toWindowState(E){return{windowId:E.id,workspace:(0,d.isWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace:void 0,folderUri:(0,d.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace.uri:void 0,backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.serializeWindowState()}}getNewWindowState(E){const w=this.doGetNewWindowState(E),t=this.configurationService.getValue("window");if(w.mode===3){let u;w.hasDefaultState?u=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):u=!!(this.lifecycleMainService.wasRestarted||t?.restoreFullscreen),u||(w.mode=1)}return w}doGetNewWindowState(E){const w=this.windowsMainService.getLastActiveWindow();if(!E.extensionTestsPath){if(E.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=E.workspace;if((0,d.isWorkspaceIdentifier)(c)){const D=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===c.id).map(k=>k.uiState);if(D.length)return D[0]}if((0,d.isSingleFolderWorkspaceIdentifier)(c)){const D=this.state.openedWindows.filter(k=>k.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(k.folderUri,c.uri)).map(k=>k.uiState);if(D.length)return D[0]}else if(E.backupPath){const D=this.state.openedWindows.filter(k=>k.backupPath===E.backupPath).map(k=>k.uiState);if(D.length)return D[0]}const p=this.lastClosedState||this.state.lastActiveWindow;if(!w&&p)return p.uiState}let t;const u=P.screen.getAllDisplays();if(u.length===1)t=u[0];else{if(s.isMacintosh){const c=P.screen.getCursorScreenPoint();t=P.screen.getDisplayNearestPoint(c)}!t&&w&&(t=P.screen.getDisplayMatching(w.getBounds())),t||(t=P.screen.getPrimaryDisplay()||u[0])}let r=(0,S.defaultWindowState)();r.x=Math.round(t.bounds.x+t.bounds.width/2-r.width/2),r.y=Math.round(t.bounds.y+t.bounds.height/2-r.height/2);const i=this.configurationService.getValue("window");let n=!0;if(i?.newWindowDimensions){if(i.newWindowDimensions==="maximized")r.mode=0,n=!1;else if(i.newWindowDimensions==="fullscreen")r.mode=3,n=!1;else if((i.newWindowDimensions==="inherit"||i.newWindowDimensions==="offset")&&w){const c=w.serializeWindowState();c.mode===3?r.mode=3:r=c,n=r.mode!==3&&i.newWindowDimensions==="offset"}}return n&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(E){if(this.windowsMainService.getWindows().length===0)return E;E.x=typeof E.x=="number"?E.x:0,E.y=typeof E.y=="number"?E.y:0;const w=this.windowsMainService.getWindows().map(t=>t.getBounds());for(;w.some(t=>t.x===E.x||t.y===E.y);)E.x+=30,E.y+=30;return E}};y.windowsStateStorageKey="windowsState",e.WindowsStateHandler=y=Se([J(0,f.IWindowsMainService),J(1,m.IStateService),J(2,h.ILifecycleMainService),J(3,l.ILogService),J(4,I.IConfigurationService)],y);function v(b){const E={openedWindows:[]},w=b||{openedWindows:[]};return w.lastActiveWindow&&(E.lastActiveWindow=o(w.lastActiveWindow)),w.lastPluginDevelopmentHostWindow&&(E.lastPluginDevelopmentHostWindow=o(w.lastPluginDevelopmentHostWindow)),Array.isArray(w.openedWindows)&&(E.openedWindows=w.openedWindows.map(t=>o(t))),E}e.restoreWindowsState=v;function o(b){const E={uiState:b.uiState};return b.backupPath&&(E.backupPath=b.backupPath),b.remoteAuthority&&(E.remoteAuthority=b.remoteAuthority),b.folder&&(E.folderUri=R.URI.parse(b.folder)),b.workspaceIdentifier&&(E.workspace={id:b.workspaceIdentifier.id,configPath:R.URI.parse(b.workspaceIdentifier.configURIPath)}),E}function g(b){return{lastActiveWindow:b.lastActiveWindow&&a(b.lastActiveWindow),lastPluginDevelopmentHostWindow:b.lastPluginDevelopmentHostWindow&&a(b.lastPluginDevelopmentHostWindow),openedWindows:b.openedWindows.map(E=>a(E))}}e.getWindowsStateStoreData=g;function a(b){return{workspaceIdentifier:b.workspace&&{id:b.workspace.id,configURIPath:b.workspace.configPath.toString()},folder:b.folderUri&&b.folderUri.toString(),backupPath:b.backupPath,remoteAuthority:b.remoteAuthority,uiState:b.uiState}}}),define(ee[54],te([0,1,14,4,45,2,15,9,19,11,22,192,64,59,28,6,5,53,129,30,97,98]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o,g,a,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,v.createDecorator)("workspacesManagementMainService");let t=e.WorkspacesManagementMainService=class extends A.Disposable{constructor(r,i,n,c,p){super(),this.environmentMainService=r,this.logService=i,this.userDataProfilesMainService=n,this.backupMainService=c,this.dialogMainService=p,this._onDidDeleteUntitledWorkspace=this._register(new L.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new L.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const r=(await m.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(i=>(0,h.joinPath)(this.untitledWorkspacesHome,i,b.UNTITLED_WORKSPACE_NAME));for(const i of r){const n=(0,w.getWorkspaceIdentifier)(i),c=await this.resolveLocalWorkspace(i);c?this.untitledWorkspaces.push({workspace:n,remoteAuthority:c.remoteAuthority}):await this.deleteUntitledWorkspace(n)}}catch(r){r.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${r}).`)}}resolveLocalWorkspace(r){return this.doResolveLocalWorkspace(r,i=>m.Promises.readFile(i,"utf8"))}doResolveLocalWorkspace(r,i){if(this.isWorkspacePath(r)&&r.scheme===R.Schemas.file)try{const n=i(r.fsPath);return n instanceof Promise?n.then(c=>this.doResolveWorkspace(r,c),c=>{}):this.doResolveWorkspace(r,n)}catch{return}}isWorkspacePath(r){return(0,b.isUntitledWorkspace)(r,this.environmentMainService)||(0,b.hasWorkspaceFileExtension)(r)}doResolveWorkspace(r,i){try{const n=this.doParseStoredWorkspace(r,i),c=(0,w.getWorkspaceIdentifier)(r);return{id:c.id,configPath:c.configPath,folders:(0,E.toWorkspaceFolders)(n.folders,c.configPath,h.extUriBiasedIgnorePathCase),remoteAuthority:n.remoteAuthority,transient:n.transient}}catch(n){this.logService.warn(n.toString())}}doParseStoredWorkspace(r,i){const n=(0,s.parse)(i);if(n&&Array.isArray(n.folders))n.folders=n.folders.filter(c=>(0,E.isStoredWorkspaceFolder)(c));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return n}async createUntitledWorkspace(r,i){const{workspace:n,storedWorkspace:c}=this.newUntitledWorkspace(r,i),p=n.configPath.fsPath;return await m.Promises.mkdir((0,I.dirname)(p),{recursive:!0}),await m.Promises.writeFile(p,JSON.stringify(c,null,"	")),this.untitledWorkspaces.push({workspace:n,remoteAuthority:i}),n}newUntitledWorkspace(r=[],i){const n=(Date.now()+Math.round(Math.random()*1e3)).toString(),c=(0,h.joinPath)(this.untitledWorkspacesHome,n),p=(0,h.joinPath)(c,b.UNTITLED_WORKSPACE_NAME),D=[];for(const k of r)D.push((0,E.getStoredWorkspaceFolder)(k.uri,!0,k.name,c,h.extUriBiasedIgnorePathCase));return{workspace:(0,w.getWorkspaceIdentifier)(p),storedWorkspace:{folders:D,remoteAuthority:i}}}async getWorkspaceIdentifier(r){return(0,w.getWorkspaceIdentifier)(r)}isUntitledWorkspace(r){return(0,b.isUntitledWorkspace)(r.configPath,this.environmentMainService)}async deleteUntitledWorkspace(r){this.isUntitledWorkspace(r)&&(await this.doDeleteUntitledWorkspace(r),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(r),this._onDidDeleteUntitledWorkspace.fire(r))}async doDeleteUntitledWorkspace(r){const i=(0,h.originalFSPath)(r.configPath);try{await m.Promises.rm((0,I.dirname)(i));const n=(0,I.join)(this.environmentMainService.workspaceStorageHome.fsPath,r.id);await m.Promises.exists(n)&&await m.Promises.writeFile((0,I.join)(n,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(c=>c.workspace.id!==r.id)}catch(n){this.logService.warn(`Unable to delete untitled workspace ${i} (${n}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(r,i,n){if(!r||!r.win||!r.isReady||!await this.isValidTargetWorkspacePath(r,i,n))return;const p=await this.doEnterWorkspace(r,(0,w.getWorkspaceIdentifier)(n));if(p)return this._onDidEnterWorkspace.fire({window:r,workspace:p.workspace}),p}async isValidTargetWorkspacePath(r,i,n){return n?(0,b.isWorkspaceIdentifier)(r.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,n)?!1:(0,a.findWindowOnWorkspaceOrFolder)(i,n)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,f.localize)(0,null)],message:(0,f.localize)(1,null,(0,h.basename)(n)),detail:(0,f.localize)(2,null)},(0,l.withNullAsUndefined)(P.BrowserWindow.getFocusedWindow())),!1):!0:!0}async doEnterWorkspace(r,i){if(!r.config)return;r.focus();let n;return r.config.extensionDevelopmentPath||(r.config.backupPath?n=await this.backupMainService.registerWorkspaceBackup({workspace:i,remoteAuthority:r.remoteAuthority},r.config.backupPath):n=this.backupMainService.registerWorkspaceBackup({workspace:i,remoteAuthority:r.remoteAuthority})),(0,b.isWorkspaceIdentifier)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&await this.deleteUntitledWorkspace(r.openedWorkspace),r.config.workspace=i,r.config.backupPath=n,{workspace:i,backupPath:n}}};e.WorkspacesManagementMainService=t=Se([J(0,y.IEnvironmentMainService),J(1,o.ILogService),J(2,g.IUserDataProfilesMainService),J(3,S.IBackupMainService),J(4,d.IDialogMainService)],t)}),define(ee[132],te([0,1,14,38,21,6,29,30,54,11,5,60]),function(j,e,P,L,s,A,R,I,h,l,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,A.createDecorator)(e.ID);let S=e.DiagnosticsMainService=class{constructor(y,v,o){this.windowsMainService=y,this.workspacesManagementMainService=v,this.logService=o}async getRemoteDiagnostics(y){const v=this.windowsMainService.getWindows();return(await Promise.all(v.map(async g=>{const a=g.remoteAuthority;if(!a)return;const b=`vscode:getDiagnosticInfoResponse${g.id}`,E={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.getFolderURIs(g):void 0};return new Promise(w=>{g.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:b,args:E}),L.validatedIpcMain.once(b,(t,u)=>{u||w({hostName:a,errorMessage:`Unable to resolve connection to '${a}'.`}),w(u)}),setTimeout(()=>{w({hostName:a,errorMessage:`Connection to '${a}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const y=[];for(const o of P.BrowserWindow.getAllWindows()){const g=this.windowsMainService.getWindowById(o.id);g?y.push(await this.codeWindowToInfo(g)):y.push(this.browserWindowToInfo(o))}const v=[];for(const{pid:o,name:g}of f.UtilityProcess.getAll())v.push({pid:o,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:v,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async codeWindowToInfo(y){const v=await this.getFolderURIs(y),o=(0,l.assertIsDefined)(y.win);return this.browserWindowToInfo(o,v,y.remoteAuthority)}browserWindowToInfo(y,v=[],o){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:v,remoteAuthority:o}}async getFolderURIs(y){const v=[],o=y.openedWorkspace;if((0,I.isSingleFolderWorkspaceIdentifier)(o))v.push(o.uri);else if((0,I.isWorkspaceIdentifier)(o)){const g=await this.workspacesManagementMainService.resolveLocalWorkspace(o.configPath);g&&g.folders.forEach(b=>{v.push(b.uri)})}return v}};e.DiagnosticsMainService=S=Se([J(0,R.IWindowsMainService),J(1,h.IWorkspacesManagementMainService),J(2,m.ILogService)],S)}),define(ee[67],te([0,1,47,14,27,154,55,4,2,15,9,3,7,105,86,22,103,180,59,28,6,20,5,23,79,29,30,54,17,242,234]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o,g,a,b,E,w,t,u,r,i,n,c,p,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,E.createDecorator)("nativeHostMainService");let C=e.NativeHostMainService=class extends h.Disposable{constructor(T,U,q,se,ie,ne,ue,le){super(),this.windowsMainService=T,this.dialogMainService=U,this.lifecycleMainService=q,this.environmentMainService=se,this.logService=ie,this.productService=ne,this.themeMainService=ue,this.workspacesManagementMainService=le,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,G=>G.id),this.onDidTriggerSystemContextMenu=I.Event.filter(I.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:G,x:Q,y:F})=>({windowId:G.id,x:Q,y:F})),({windowId:G})=>!!this.windowsMainService.getWindowById(G)),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(G,Q)=>Q.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(G,Q)=>Q.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(G,Q)=>Q.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),G=>!!G),G=>G.id),I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(G,Q)=>Q.id),G=>!!this.windowsMainService.getWindowById(G))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(G,Q,F)=>F),G=>!(Array.isArray(G)&&G.length===1&&G[0]==="workArea")),I.Event.fromNodeEventEmitter(L.screen,"display-added"),I.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace??(0,n.toWorkspaceIdentifier)(U.backupPath,U.isExtensionDevelopmentHost),title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(T){return this.windowsMainService.getWindowCount()}async getActiveWindowId(T){const U=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(U)return U.id}openWindow(T,U,q){return Array.isArray(U)?this.doOpenWindow(T,U,q):this.doOpenEmptyWindow(T,U)}async doOpenWindow(T,U,q=Object.create(null)){U.length>0&&await this.windowsMainService.open({context:5,contextWindowId:T,urisToOpen:U,cli:this.environmentMainService.args,forceNewWindow:q.forceNewWindow,forceReuseWindow:q.forceReuseWindow,preferNewWindow:q.preferNewWindow,diffMode:q.diffMode,mergeMode:q.mergeMode,addMode:q.addMode,gotoLineMode:q.gotoLineMode,noRecentEntry:q.noRecentEntry,waitMarkerFileURI:q.waitMarkerFileURI,remoteAuthority:q.remoteAuthority||void 0,forceProfile:q.forceProfile,forceTempProfile:q.forceTempProfile})}async doOpenEmptyWindow(T,U){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:T},U)}async toggleFullScreen(T){this.windowById(T)?.toggleFullScreen()}async handleTitleDoubleClick(T){this.windowById(T)?.handleTitleDoubleClick()}async isMaximized(T){const U=this.windowById(T);return U?.win?U.win.isMaximized():!1}async maximizeWindow(T){const U=this.windowById(T);U?.win&&U.win.maximize()}async unmaximizeWindow(T){const U=this.windowById(T);U?.win&&U.win.unmaximize()}async minimizeWindow(T){const U=this.windowById(T);U?.win&&U.win.minimize()}async updateWindowControls(T,U){const q=this.windowById(T);q&&q.updateWindowControls(U)}async focusWindow(T,U){U&&typeof U.windowId=="number"&&(T=U.windowId),this.windowById(T)?.focus({force:U?.force??!1})}async setMinimumSize(T,U,q){const se=this.windowById(T);if(se?.win){const[ie,ne]=se.win.getSize(),[ue,le]=se.win.getMinimumSize(),[G,Q]=[U??ue,q??le],[F,N]=[Math.max(ie,G),Math.max(ne,Q)];(ue!==G||le!==Q)&&se.win.setMinimumSize(G,Q),(ie!==F||ne!==N)&&se.win.setSize(F,N)}}async saveWindowSplash(T,U){this.themeMainService.saveWindowSplash(T,U)}async installShellCommand(T){const{source:U,target:q}=await this.getShellCommandLink();try{const{symbolicLink:se}=await v.SymlinkSupport.stat(U);if(se&&!se.dangling){const ie=await(0,d.realpath)(U);if(q===ie)return}await v.Promises.unlink(U)}catch(se){if(se.code!=="ENOENT")throw se}try{await v.Promises.symlink(q,U)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:ie}=await this.showMessageBox(T,{type:"info",message:(0,g.localize)(0,null,this.productService.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(ie===0)try{const ne=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${q}' '${U}'\\" with administrator privileges"`;await(0,A.promisify)(P.exec)(ne)}catch{throw new Error((0,g.localize)(3,null,U))}}}async uninstallShellCommand(T){const{source:U}=await this.getShellCommandLink();try{await v.Promises.unlink(U)}catch(q){switch(q.code){case"EACCES":{const{response:se}=await this.showMessageBox(T,{type:"info",message:(0,g.localize)(4,null,this.productService.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(se===0)try{const ie=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,A.promisify)(P.exec)(ie)}catch{throw new Error((0,g.localize)(7,null,U))}break}case"ENOENT":break;default:throw q}}}async getShellCommandLink(){const T=(0,m.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),U=`/usr/local/bin/${this.productService.applicationName}`;if(!await v.Promises.exists(T))throw new Error((0,g.localize)(8,null,T));return{source:U,target:T}}async showMessageBox(T,U){return this.dialogMainService.showMessageBox(U,this.toBrowserWindow(T))}async showSaveDialog(T,U){return this.dialogMainService.showSaveDialog(U,this.toBrowserWindow(T))}async showOpenDialog(T,U){return this.dialogMainService.showOpenDialog(U,this.toBrowserWindow(T))}toBrowserWindow(T){const U=this.windowById(T);if(U?.win)return U.win}async pickFileFolderAndOpen(T,U){const q=await this.dialogMainService.pickFileFolder(U);q&&await this.doOpenPicked(await Promise.all(q.map(async se=>await v.SymlinkSupport.existsDirectory(se)?{folderUri:S.URI.file(se)}:{fileUri:S.URI.file(se)})),U,T)}async pickFolderAndOpen(T,U){const q=await this.dialogMainService.pickFolder(U);q&&await this.doOpenPicked(q.map(se=>({folderUri:S.URI.file(se)})),U,T)}async pickFileAndOpen(T,U){const q=await this.dialogMainService.pickFile(U);q&&await this.doOpenPicked(q.map(se=>({fileUri:S.URI.file(se)})),U,T)}async pickWorkspaceAndOpen(T,U){const q=await this.dialogMainService.pickWorkspace(U);q&&await this.doOpenPicked(q.map(se=>({workspaceUri:S.URI.file(se)})),U,T)}async doOpenPicked(T,U,q){await this.windowsMainService.open({context:3,contextWindowId:q,cli:this.environmentMainService.args,urisToOpen:T,forceNewWindow:U.forceNewWindow})}async showItemInFolder(T,U){L.shell.showItemInFolder(U)}async setRepresentedFilename(T,U){this.windowById(T)?.setRepresentedFilename(U)}async setDocumentEdited(T,U){this.windowById(T)?.setDocumentEdited(U)}async openExternal(T,U){return this.environmentMainService.unsetSnapExportedVariables(),L.shell.openExternal(U),this.environmentMainService.restoreSnapExportedVariables(),!0}moveItemToTrash(T,U){return L.shell.trashItem(U)}async isAdmin(){let T;return f.isWindows?T=(await new Promise((U,q)=>{j(["native-is-elevated"],U,q)}))():T=process.getuid()===0,T}async writeElevated(T,U,q,se){const ie=await new Promise((ne,ue)=>{j(["@vscode/sudo-prompt"],ne,ue)});return new Promise((ne,ue)=>{const le=[`"${this.cliPath}"`];se?.unlock&&le.push("--file-chmod"),le.push("--file-write",`"${U.fsPath}"`,`"${q.fsPath}"`);const G={name:this.productService.nameLong.replace("-",""),icns:f.isMacintosh&&this.environmentMainService.isBuilt?(0,m.join)((0,m.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ie.exec(le.join(" "),G,(Q,F,N)=>{F&&this.logService.trace(`[sudo-prompt] received stdout: ${F}`),N&&this.logService.trace(`[sudo-prompt] received stderr: ${N}`),Q?ue(Q):ne(void 0)})})}async isRunningUnderARM64Translation(){return f.isLinux||f.isWindows?!1:L.app.runningUnderARM64Translation}get cliPath(){return f.isWindows?this.environmentMainService.isBuilt?(0,m.join)((0,m.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,m.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):f.isLinux?this.environmentMainService.isBuilt?(0,m.join)((0,m.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,m.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,m.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,m.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return y.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return f.isWindows&&(0,D.hasWSLFeatureInstalled)()}async killProcess(T,U,q){process.kill(U,q)}async readClipboardText(T,U){return L.clipboard.readText(U)}async writeClipboardText(T,U,q){return L.clipboard.writeText(U,q)}async readClipboardFindText(T){return L.clipboard.readFindText()}async writeClipboardFindText(T,U){return L.clipboard.writeFindText(U)}async writeClipboardBuffer(T,U,q,se){return L.clipboard.writeBuffer(U,Buffer.from(q.buffer),se)}async readClipboardBuffer(T,U){return p.VSBuffer.wrap(L.clipboard.readBuffer(U))}async hasClipboard(T,U,q){return L.clipboard.has(U,q)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(T,U){this.windowById(T)?.updateTouchBar(U)}async notifyReady(T){this.windowById(T)?.setReady()}async relaunch(T,U){return this.lifecycleMainService.relaunch(U)}async reload(T,U){const q=this.windowById(T);if(q){if((0,n.isWorkspaceIdentifier)(q.openedWorkspace)){const se=q.openedWorkspace.configPath;if(se.scheme===l.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(se))?.transient)return this.openWindow(q.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(q,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(T){this.closeWindowById(T,T)}async closeWindowById(T,U){const q=this.windowById(U);if(q?.win)return q.win.close()}async quit(T){const U=this.windowsMainService.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&U.win?U.win.close():this.lifecycleMainService.quit()}async exit(T,U){await this.lifecycleMainService.kill(U)}async resolveProxy(T,U){return this.windowById(T)?.win?.webContents?.session?.resolveProxy(U)}findFreePort(T,U,q,se,ie=1){return(0,o.findFreePort)(U,q,se,ie)}async openDevTools(T,U){const q=this.windowById(T);q?.win&&q.win.webContents.openDevTools(U)}async toggleDevTools(T){const U=this.windowById(T);U?.win&&U.win.webContents.toggleDevTools()}async sendInputEvent(T,U){const q=this.windowById(T);q?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&q.win.webContents.sendInputEvent(U)}async profileRenderer(T,U,q){const se=this.windowById(T);if(!se||!se.win)throw new Error;return await new k.WindowProfiler(se.win,U,this.logService).inspect(q)}async windowsGetStringRegKey(T,U,q,se){if(!f.isWindows)return;const ie=await new Promise((ne,ue)=>{j(["@vscode/windows-registry"],ne,ue)});try{return ie.GetStringRegKey(U,q,se)}catch{return}}windowById(T){if(typeof T=="number")return this.windowsMainService.getWindowById(T)}};Se([R.memoize],C.prototype,"cliPath",null),e.NativeHostMainService=C=Se([J(0,i.IWindowsMainService),J(1,a.IDialogMainService),J(2,w.ILifecycleMainService),J(3,b.IEnvironmentMainService),J(4,t.ILogService),J(5,u.IProductService),J(6,r.IThemeMainService),J(7,c.IWorkspacesManagementMainService)],C)}),define(ee[297],te([0,1,14,38,27,2,15,3,107,178,90,132,59,28,5,67,77,23,78,80,32,11,34,60,21,7,29,8]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o,g,a,b,E,w,t,u,r,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0;const p="issue.processExplorerWindowState";let D=e.IssueMainService=class Rt{constructor(_,T,U,q,se,ie,ne,ue,le,G,Q){this.userEnv=_,this.environmentMainService=T,this.logService=U,this.diagnosticsService=q,this.diagnosticsMainService=se,this.dialogMainService=ie,this.nativeHostMainService=ne,this.protocolMainService=ue,this.productService=le,this.stateService=G,this.windowsMainService=Q,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){L.validatedIpcMain.on("vscode:listProcesses",async _=>{const T=[];try{T.push({name:(0,l.localize)(0,null),rootProcess:await(0,h.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(q=>{(0,m.isRemoteDiagnosticError)(q)?T.push({name:q.hostName,rootProcess:q}):q.processes&&T.push({name:q.hostName,rootProcess:q.processes})})}catch(U){this.logService.error(`Listing processes failed: ${U}`)}this.safeSend(_,"vscode:listProcessesResponse",T)}),L.validatedIpcMain.on("vscode:workbenchCommand",(_,T)=>{const{id:U,from:q,args:se}=T;let ie;switch(q){case"processExplorer":ie=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${q}`)}ie?.webContents.send("vscode:runAction",{id:U,from:q,args:se})}),L.validatedIpcMain.on("vscode:closeProcessExplorer",_=>{this.processExplorerWindow?.close()}),L.validatedIpcMain.on("vscode:pidToNameRequest",async _=>{const T=await this.diagnosticsMainService.getMainDiagnostics(),U=[];for(const q of T.windows)U.push([q.pid,`window [${q.id}] (${q.title})`]);for(const{pid:q,name:se}of u.UtilityProcess.getAll())U.push([q,se]);this.safeSend(_,"vscode:pidToNameResponse",U)})}async openReporter(_){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=P.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const T=new A.DisposableStore,U=T.add(this.protocolMainService.createIPCObjectUrl()),q=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(q,U,{backgroundColor:_.styles.backgroundColor,title:(0,l.localize)(1,null),zoomLevel:_.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:_,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:o.default}),this.issueReporterWindow.loadURL(R.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,T.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,T.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(_){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=P.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const T=new A.DisposableStore,U=T.add(this.protocolMainService.createIPCObjectUrl()),q=this.stateService.getItem(p,void 0),se=k(q)?q:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(se,U,{backgroundColor:_.styles.backgroundColor,title:(0,l.localize)(2,null),zoomLevel:_.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:_,product:o.default}),this.processExplorerWindow.loadURL(R.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,T.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,T.dispose())});const ie=()=>{if(!this.processExplorerWindow)return;const ne=this.processExplorerWindow.getSize(),ue=this.processExplorerWindow.getPosition();if(!ne||!ue)return;const le={width:ne[0],height:ne[1],x:ue[0],y:ue[1]};this.stateService.setItem(p,le)};this.processExplorerWindow.on("moved",ie),this.processExplorerWindow.on("resized",ie)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}async stopTracing(){if(!this.environmentMainService.args.trace)return;const _=await P.contentTracing.stopRecording(`${(0,E.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,l.localize)(3,null),detail:(0,l.localize)(4,null,_),buttons:[(0,l.localize)(5,null)]},(0,w.withNullAsUndefined)(P.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,_)}async getSystemStatus(){const[_,T]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(_,T)}async $getSystemInfo(){const[_,T]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.diagnosticsService.getSystemInfo(_,T)}async $getPerformanceInfo(){try{const[_,T]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(_,T)}catch(_){throw this.logService.warn("issueService#getPerformanceInfo ",_.message),_}}async $reloadWithExtensionsDisabled(){if(this.issueReporterParentWindow)try{await this.nativeHostMainService.reload(this.issueReporterParentWindow.id,{disableExtensions:!0})}catch(_){this.logService.error(_)}}async $showConfirmCloseDialog(){if(this.issueReporterWindow){const{response:_}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,l.localize)(6,null),buttons:[(0,l.localize)(7,null),(0,l.localize)(8,null)]},this.issueReporterWindow);_===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}async $showClipboardDialog(){if(this.issueReporterWindow){const{response:_}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,l.localize)(9,null),buttons:[(0,l.localize)(10,null),(0,l.localize)(11,null)]},this.issueReporterWindow);return _===0}return!1}async $getIssueReporterUri(_){if(!this.issueReporterParentWindow)throw new Error("Issue reporter window not available");const T=this.windowsMainService.getWindowById(this.issueReporterParentWindow.id);if(!T)throw new Error("Window not found");const U=`vscode:triggerIssueUriRequestHandlerResponse${T.id}`;return c.Promises.withAsyncBody(async(q,se)=>{const ie=new r.CancellationTokenSource;T.sendWhenReady("vscode:triggerIssueUriRequestHandler",ie.token,{replyChannel:U,extensionId:_}),L.validatedIpcMain.once(U,(ne,ue)=>{q(i.URI.parse(ue))});try{await(0,c.timeout)(5e3),ie.cancel(),se(new Error("Timed out waiting for issue reporter URI"))}finally{L.validatedIpcMain.removeHandler(U)}})}async $closeReporter(){this.issueReporterWindow?.close()}async closeProcessExplorer(){this.processExplorerWindow?.close()}focusWindow(_){_.isMinimized()&&_.restore(),_.focus()}safeSend(_,T,...U){_.sender.isDestroyed()||_.sender.send(T,...U)}createBrowserWindow(_,T,U,q){const se=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:_.width,height:_.height,minWidth:300,minHeight:200,x:_.x,y:_.y,title:U.title,backgroundColor:U.backgroundColor||Rt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:R.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${T.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,b.zoomLevelToZoomFactor)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return se.setMenuBarVisibility(!1),se}getWindowPosition(_,T,U){let q;const se=P.screen.getAllDisplays();if(se.length===1)q=se[0];else{if(I.isMacintosh){const ue=P.screen.getCursorScreenPoint();q=P.screen.getDisplayNearestPoint(ue)}!q&&_&&(q=P.screen.getDisplayMatching(_.getBounds())),q||(q=P.screen.getPrimaryDisplay()||se[0])}const ie=q.bounds,ne={width:T,height:U,x:ie.x+ie.width/2-T/2,y:ie.y+ie.height/2-U/2};return ie.width>0&&ie.height>0&&(ne.x<ie.x&&(ne.x=ie.x),ne.y<ie.y&&(ne.y=ie.y),ne.x>ie.x+ie.width&&(ne.x=ie.x),ne.y>ie.y+ie.height&&(ne.y=ie.y),ne.width>ie.width&&(ne.width=ie.width),ne.height>ie.height&&(ne.height=ie.height)),ne}};D.DEFAULT_BACKGROUND_COLOR="#1E1E1E",e.IssueMainService=D=Se([J(1,d.IEnvironmentMainService),J(2,y.ILogService),J(3,m.IDiagnosticsService),J(4,f.IDiagnosticsMainService),J(5,S.IDialogMainService),J(6,v.INativeHostMainService),J(7,a.IProtocolMainService),J(8,g.IProductService),J(9,t.IStateService),J(10,n.IWindowsMainService)],D);function k(C){return typeof C!="object"||C===null?!1:"x"in C&&"y"in C&&"width"in C&&"height"in C}}),define(ee[298],te([0,1,21,18,28,20,5,67,23,51,26,48,100]),function(j,e,P,L,s,A,R,I,h,l,m,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let d=e.LinuxUpdateService=class extends S.AbstractUpdateService{constructor(v,o,g,a,b,E,w,t){super(v,o,a,b,E,t),this.telemetryService=g,this.nativeHostMainService=w}buildUpdateFeedUrl(v){return(0,S.createUpdateURL)(`linux-${process.arch}`,v,this.productService)}doCheckForUpdates(v){this.url&&(this.setState(f.State.CheckingForUpdates(v)),this.requestService.request({url:this.url},P.CancellationToken.None).then(l.asJson).then(o=>{!o||!o.url||!o.version||!o.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v}),this.setState(f.State.Idle(1))):this.setState(f.State.AvailableForDownload(o))}).then(void 0,o=>{this.logService.error(o),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v});const g=v?o.message||o:void 0;this.setState(f.State.Idle(1,g))}))}async doDownloadUpdate(v){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):v.update.url&&this.nativeHostMainService.openExternal(void 0,v.update.url),this.setState(f.State.Idle(1))}};e.LinuxUpdateService=d=Se([J(0,A.ILifecycleMainService),J(1,L.IConfigurationService),J(2,m.ITelemetryService),J(3,s.IEnvironmentMainService),J(4,l.IRequestService),J(5,R.ILogService),J(6,I.INativeHostMainService),J(7,h.IProductService)],d)}),define(ee[299],te([0,1,47,42,27,8,21,55,9,7,141,22,18,28,16,20,5,67,23,51,26,48,100]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o,g,a,b,E,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function u(c,p=1e3){for(;!c();)await(0,A.timeout)(p)}let r;function i(){return typeof r>"u"&&(L.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?r=0:h.basename(h.normalize(h.join(process.execPath,"..","..")))==="Program Files"?r=3:r=1),r}let n=e.Win32UpdateService=class extends t.AbstractUpdateService{get cachePath(){const p=h.join((0,s.tmpdir)(),`${this.productService.applicationName}-${this.productService.quality}-${this.productService.target}-${process.arch}`);return f.Promises.mkdir(p,{recursive:!0}).then(()=>p)}constructor(p,D,k,C,_,T,U,q,se){super(p,D,C,_,T,se),this.telemetryService=k,this.fileService=U,this.nativeHostMainService=q}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(p){let D="win32";switch(process.arch!=="ia32"&&(D+=`-${process.arch}`),i()){case 1:D+="-archive";break;case 3:D+="-msi";break;default:this.productService.target==="user"&&(D+="-user")}return(0,t.createUpdateURL)(D,p,this.productService)}doCheckForUpdates(p){this.url&&(this.setState(w.State.CheckingForUpdates(p)),this.requestService.request({url:this.url},R.CancellationToken.None).then(b.asJson).then(D=>{const k=i();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!p}),this.setState(w.State.Idle(k)),Promise.resolve(null)):k===1?(this.setState(w.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(w.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(C=>f.Promises.exists(C).then(_=>{if(_)return Promise.resolve(C);const T=D.url,U=D.hash,q=`${C}.tmp`;return this.requestService.request({url:T},R.CancellationToken.None).then(se=>this.fileService.writeFile(l.URI.file(q),se.stream)).then(U?()=>(0,m.checksum)(q,D.hash):()=>{}).then(()=>f.Promises.rename(q,C)).then(()=>C)})).then(C=>{const _=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:C},_&&D.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(w.State.Downloaded(D)):this.setState(w.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!p});const k=p?D.message||D:void 0;this.setState(w.State.Idle(i(),k))}))}async doDownloadUpdate(p){p.update.url&&this.nativeHostMainService.openExternal(void 0,p.update.url),this.setState(w.State.Idle(i()))}async getUpdatePackagePath(p){const D=await this.cachePath;return h.join(D,`CodeSetup-${this.productService.quality}-${p}.exe`)}async cleanup(p=null){const D=p?T=>!new RegExp(`${this.productService.quality}-${p}\\.exe$`).test(T):()=>!0,k=await this.cachePath,_=(await f.Promises.readdir(k)).filter(D).map(async T=>{try{await f.Promises.unlink(h.join(k,T))}catch{}});await Promise.all(_)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const p=this.state.update;this.setState(w.State.Updating(p));const D=await this.cachePath;this.availableUpdate.updateFilePath=h.join(D,`CodeSetup-${this.productService.quality}-${p.version}.flag`),await f.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,P.spawn)(this.availableUpdate.packagePath,["/verysilent","/log",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(w.State.Idle(i()))});const C=`${this.productService.win32MutexName}-ready`,_=await new Promise((T,U)=>{j(["@vscode/windows-mutex"],T,U)});u(()=>_.isActive(C)).then(()=>this.setState(w.State.Ready(p)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):i()==3?(0,P.spawn)("msiexec.exe",["/i",this.availableUpdate.packagePath],{detached:!0,stdio:["ignore","ignore","ignore"]}):(0,P.spawn)(this.availableUpdate.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}async _applySpecificUpdate(p){if(this.state.type!=="idle")return;const D=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),k={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!D};this.setState(w.State.Downloading(k)),this.availableUpdate={packagePath:p},D?this.productService.target==="user"?this.doApplyUpdate():this.setState(w.State.Downloaded(k)):this.setState(w.State.Ready(k))}};Se([I.memoize],n.prototype,"cachePath",null),e.Win32UpdateService=n=Se([J(0,v.ILifecycleMainService),J(1,S.IConfigurationService),J(2,E.ITelemetryService),J(3,d.IEnvironmentMainService),J(4,b.IRequestService),J(5,o.ILogService),J(6,y.IFileService),J(7,g.INativeHostMainService),J(8,a.IProductService)],n)}),define(ee[300],te([0,1,14,8,21,50,4,2,15,9,65,3,7,188,64,18,59,28,63,16,20,5,23,78,250,99,26,102,79,80,29,30,54,127,133,39,34,53,66,24]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o,g,a,b,E,w,t,u,r,i,n,c,p,D,k,C,_,T,U,q,se,ie,ne,ue){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var le;(function(Q){Q[Q.NONE=0]="NONE",Q[Q.NAVIGATING=1]="NAVIGATING",Q[Q.READY=2]="READY"})(le||(le={}));let G=e.CodeWindow=class bt extends I.Disposable{get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const F=this.userDataProfilesService.profiles.find(N=>N.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&F?F:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,C.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(F,N,B,V,Y,ae,oe,O,M,W,H,x,z,$,K,re,ce,ge,ke,Re){super(),this.logService=N,this.loggerMainService=B,this.environmentMainService=V,this.policyService=Y,this.userDataProfilesService=ae,this.fileService=oe,this.applicationStorageMainService=O,this.storageMainService=M,this.configurationService=W,this.themeMainService=H,this.workspacesManagementMainService=x,this.backupMainService=z,this.telemetryService=$,this.dialogMainService=K,this.lifecycleMainService=re,this.productService=ce,this.protocolMainService=ge,this.windowsMainService=ke,this.stateService=Re,this._onWillLoad=this._register(new R.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new R.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new R.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new R.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new R.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Le,Oe]=this.restoreWindowState(F.state);this.windowState=Le,this.logService.trace("window#ctor: using window state",Le);const ye=this.windowState.mode===0||this.windowState.mode===3,we=this.configurationService.getValue("window"),Ee={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!ye,title:this.productService.nameLong,webPreferences:{preload:h.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,D.zoomLevelToZoomFactor)(we?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};f.isLinux?Ee.icon=(0,l.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):f.isWindows&&!this.environmentMainService.isBuilt&&(Ee.icon=(0,l.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),f.isMacintosh&&!this.useNativeFullScreen()&&(Ee.fullscreenable=!1),f.isMacintosh&&(Ee.acceptFirstMouse=!0,we?.clickThroughInactive===!1&&(Ee.acceptFirstMouse=!1));const Z=f.isMacintosh&&we?.nativeTabs===!0;Z&&(Ee.tabbingIdentifier=this.productService.nameShort);const de=(0,D.getTitleBarStyle)(this.configurationService)==="custom";if(de&&(Ee.titleBarStyle="hidden",f.isMacintosh||(Ee.frame=!1),(0,D.useWindowControlsOverlay)(this.configurationService))){const fe=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),Ce=U.Color.fromHex(fe).isDarker()?"#FFFFFF":"#000000";Ee.titleBarOverlay={height:29,color:fe,symbolColor:Ce},this.hasWindowControlOverlay=!0}if((0,m.mark)("code/willCreateCodeBrowserWindow"),this._win=new P.BrowserWindow(Ee),(0,m.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,f.isMacintosh&&de&&this._win.setSheetOffset(22),de&&(f.isWindows&&(0,D.useWindowControlsOverlay)(this.configurationService)||f.isMacintosh)){const fe=this.stateService.getItem(bt.windowControlHeightStateStorageKey);fe&&this.updateWindowControls({height:fe})}f.isWindows&&de&&this._win.hookWindowMessage(278,()=>{const[Ce,De]=this._win.getPosition(),Te=P.screen.getCursorScreenPoint(),We=Te.x-Ce,He=Te.y-De;return(()=>!(We>30&&He>=0&&He<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:We,y:He})),0}),(f.isMacintosh||f.isWindows)&&Oe&&(!Z||P.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(fe=>typeof fe=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),ye&&((0,m.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,m.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setRepresentedFilename(F){f.isMacintosh?this._win.setRepresentedFilename(F):this.representedFilename=F}getRepresentedFilename(){return f.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(F){f.isMacintosh&&this._win.setDocumentEdited(F),this.documentEdited=F}isDocumentEdited(){return f.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(F){f.isMacintosh&&F?.force&&P.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(F=>{if(this.isReady)return F(this);this.whenReadyCallbacks.push(F)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(F=>{function N(){B.dispose(),V.dispose(),F()}const B=this.onDidClose(()=>N()),V=this.onWillLoad(()=>N())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(N,B)=>this.onWindowError(2,{...B})),this._win.webContents.on("did-fail-load",(N,B,V)=>this.onWindowError(3,{reason:V,exitCode:B})),this._win.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",N=>{this._config&&(this._config.maximized=!0),P.app.emit("browser-window-maximize",N,this._win)}),this._win.on("unmaximize",N=>{this._config&&(this._config.maximized=!1),P.app.emit("browser-window-unmaximize",N,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(N=>this.onConfigurationUpdated(N))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(N=>this.onDidDeleteUntitledWorkspace(N)));const F=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:F},async(N,B)=>{const V=await this.getMarketplaceHeaders();B({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,V)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,r.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(F,N){switch(F){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:F,reason:N?.reason,code:N?.exitCode}),F){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(F===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:B,checkboxChecked:V}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,d.localize)(0,null),(0,d.localize)(1,null),(0,d.localize)(2,null)],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),checkboxLabel:this._config?.workspace?(0,d.localize)(5,null):void 0},this._win);if(B!==2){const Y=B===0;await this.destroyWindow(Y,V)}}else if(F===2){let B;N?B=(0,d.localize)(7,null,N.reason,N.exitCode??"<unknown>"):B=(0,d.localize)(6,null);const{response:V,checkboxChecked:Y}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,d.localize)(8,null):(0,d.localize)(9,null),(0,d.localize)(10,null)],message:B,detail:this._config?.workspace?(0,d.localize)(11,null):(0,d.localize)(12,null),checkboxLabel:this._config?.workspace?(0,d.localize)(13,null):void 0},this._win),ae=V===0;await this.destroyWindow(ae,Y)}break}}async destroyWindow(F,N){const B=this._config?.workspace;if(N&&B)try{const V=this.storageMainService.workspaceStorage(B);await V.init(),V.delete("memento/workbench.parts.editor"),await V.close()}catch(V){this.logService.error(V)}if(this._onDidDestroy.fire(),this._win?.destroy(),F&&this._config){let V,Y;(0,C.isSingleFolderWorkspaceIdentifier)(B)?V={folderUri:B.uri}:(0,C.isWorkspaceIdentifier)(B)?V={workspaceUri:B.configPath}:Y=!0,(0,ue.firstOrDefault)(await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:V?[V]:void 0,forceEmpty:Y,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}onDidDeleteUntitledWorkspace(F){this._config?.workspace?.id===F.id&&(this._config.workspace=void 0)}onConfigurationUpdated(F){if(!F||F.affectsConfiguration("window.menuBarVisibility")){const N=this.getMenuBarVisibility();N!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=N,this.setMenuBarVisibility(N))}if(!F||F.affectsConfiguration("http.proxy")){let N=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const B=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.currentHttpProxy||B!==this.currentNoProxy)){this.currentHttpProxy=N,this.currentNoProxy=B;const V=N||"",Y=B?`${B},<local>`:"<local>";this.logService.trace(`Setting proxy to '${V}', bypassing '${Y}'`),this._win.webContents.session.setProxy({proxyRules:V,proxyBypassRules:Y,pacScript:""})}}}addTabbedWindow(F){f.isMacintosh&&F.win&&this._win.addTabbedWindow(F.win)}load(F,N=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!N.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(F,N),this.readyState===0?this._config=F:this.pendingLoadConfig=F,this.readyState=1,this._win.loadURL(h.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const B=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:F.workspace,reason:N.isReload?3:B?2:1})}updateConfiguration(F,N){const B=(this._config??this.pendingLoadConfig)?.userEnv;if(B){const V=(0,a.isLaunchedFromCli)(B)&&!(0,a.isLaunchedFromCli)(F.userEnv),Y=this.isExtensionDevelopmentHost;(V||Y)&&(F.userEnv={...B,...F.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(F.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(F["disable-extensions"]=N.disableExtensions),F.fullscreen=this.isFullScreen,F.maximized=this._win.isMaximized(),F.partsSplash=this.themeMainService.getWindowSplash(),(0,m.mark)("code/willOpenNewWindow"),F.perfMarks=(0,m.getMarks)(),this.configObjectUrl.update(F)}async reload(F){const N=Object.assign({},this._config);N.workspace=await this.validateWorkspaceBeforeReload(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&F&&(N.verbose=F.verbose,N.debugId=F.debugId,N.extensionEnvironment=F.extensionEnvironment,N["inspect-extensions"]=F["inspect-extensions"],N["inspect-brk-extensions"]=F["inspect-brk-extensions"],N["extensions-dir"]=F["extensions-dir"]),N.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),N.isInitialStartup=!1,N.policiesData=this.policyService.serialize(),N.continueOn=this.environmentMainService.continueOn,N.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},N.logLevel=this.loggerMainService.getLogLevel(),N.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(N,{isReload:!0,disableExtensions:F?.["disable-extensions"]})}async validateWorkspaceBeforeReload(F){if((0,C.isWorkspaceIdentifier)(F.workspace)){const N=F.workspace.configPath;if(N.scheme===h.Schemas.file&&!await this.fileService.exists(N))return}else if((0,C.isSingleFolderWorkspaceIdentifier)(F.workspace)){const N=F.workspace.uri;if(N.scheme===h.Schemas.file&&!await this.fileService.exists(N))return}return F.workspace}serializeWindowState(){if(!this._win)return(0,T.defaultWindowState)();if(this.isFullScreen){let B;try{B=P.screen.getDisplayMatching(this.getBounds())}catch{}const V=(0,T.defaultWindowState)();return{mode:3,display:B?B.id:void 0,width:this.windowState.width||V.width,height:this.windowState.height||V.height,x:this.windowState.x||0,y:this.windowState.y||0}}const F=Object.create(null);let N;if(!f.isMacintosh&&this._win.isMaximized()?N=0:N=1,N===0?F.mode=0:F.mode=1,N===1||N===0){let B;N===1?B=this.getBounds():B=this._win.getNormalBounds(),F.x=B.x,F.y=B.y,F.width=B.width,F.height=B.height}return F}updateWindowControls(F){if(F.height&&this.stateService.setItem(bt.windowControlHeightStateStorageKey,F.height),f.isWindows&&this.hasWindowControlOverlay)this._win.setTitleBarOverlay({color:F.backgroundColor?.trim()===""?void 0:F.backgroundColor,symbolColor:F.foregroundColor?.trim()===""?void 0:F.foregroundColor,height:F.height?F.height-1:void 0});else if(f.isMacintosh&&F.height!==void 0){const N=(F.height-15)/2;this._win.setTrafficLightPosition({x:N,y:N})}}restoreWindowState(F){(0,m.mark)("code/willRestoreCodeWindowState");let N=!1;if(F)try{const B=P.screen.getAllDisplays();N=B.length>1,F=this.validateWindowState(F,B)}catch(B){this.logService.warn(`Unexpected error validating window state: ${B}
${B.stack}`)}return(0,m.mark)("code/didRestoreCodeWindowState"),[F||(0,T.defaultWindowState)(),N]}validateWindowState(F,N){if(this.logService.trace(`window#validateWindowState: validating window state on ${N.length} display(s)`,F),typeof F.x!="number"||typeof F.y!="number"||typeof F.width!="number"||typeof F.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(F.width<=0||F.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(N.length===1){const Y=this.getWorkingArea(N[0]);if(Y){let ae=function(){!F||typeof F.x!="number"||typeof F.y!="number"||!Y||(F.x<Y.x&&(F.x=Y.x),F.y<Y.y&&(F.y=Y.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",Y),ae(),F.width>Y.width&&(F.width=Y.width),F.height>Y.height&&(F.height=Y.height),F.x>Y.x+Y.width-128&&(F.x=Y.x+Y.width-F.width),F.y>Y.y+Y.height-128&&(F.y=Y.y+Y.height-F.height),ae()}return F}if(F.display&&F.mode===3){const Y=N.find(ae=>ae.id===F.display);if(Y&&typeof Y.bounds?.x=="number"&&typeof Y.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const ae=(0,T.defaultWindowState)(3);return ae.x=Y.bounds.x,ae.y=Y.bounds.y,ae}}let B,V;try{B=P.screen.getDisplayMatching({x:F.x,y:F.y,width:F.width,height:F.height}),V=this.getWorkingArea(B)}catch{}if(B&&V&&F.x+F.width>V.x&&F.y+F.height>V.y&&F.x<V.x+V.width&&F.y<V.y+V.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",V),F}getWorkingArea(F){if(F.workArea.width>0&&F.workArea.height>0)return F.workArea;if(F.bounds.width>0&&F.bounds.height>0)return F.bounds}getBounds(){const[F,N]=this._win.getPosition(),[B,V]=this._win.getSize();return{x:F,y:N,width:B,height:V}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(F){this.useNativeFullScreen()?this.setNativeFullScreen(F):this.setSimpleFullScreen(F),this.sendWhenReady(F?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return f.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(F){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(F)}doSetNativeFullScreen(F){f.isMacintosh&&(this.transientIsNativeFullScreen=F,this.joinNativeFullScreenTransition=new L.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,L.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(F)}setSimpleFullScreen(F){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(F),this._win.webContents.focus()}useNativeFullScreen(){const F=this.configurationService.getValue("window");return!F||typeof F.nativeFullScreen!="boolean"||F.nativeTabs?!0:F.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let F=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(F)<0&&(F="classic"),F}setMenuBarVisibility(F,N=!0){f.isMacintosh||(F==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,d.localize)(14,null)),F==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(F)}):this.doSetMenuBarVisibility(F))}doSetMenuBarVisibility(F){const N=this.isFullScreen;switch(F){case"classic":this._win.setMenuBarVisibility(!N),this._win.autoHideMenuBar=N;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(f.isMacintosh)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(F,N,...B){this.isReady?this.send(F,...B):this.ready().then(()=>{N.isCancellationRequested||this.send(F,...B)})}send(F,...N){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${F}' for window that is destroyed`);return}try{this._win.webContents.send(F,...N)}catch(B){this.logService.warn(`Error sending IPC message to channel '${F}' of window ${this._id}: ${(0,A.toErrorMessage)(B)}`)}}}updateTouchBar(F){f.isMacintosh&&this.touchBarGroups.forEach((N,B)=>{const V=F[B];N.segments=this.createTouchBarGroupSegments(V)})}createTouchBar(){if(f.isMacintosh){for(let F=0;F<10;F++){const N=this.createTouchBarGroup();this.touchBarGroups.push(N)}this._win.setTouchBar(new P.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(F=[]){const N=this.createTouchBarGroupSegments(F),B=new P.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:V=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:B.segments[V].id,from:"touchbar"})}});return B}createTouchBarGroupSegments(F=[]){return F.map(B=>{let V;B.icon&&!c.ThemeIcon.isThemeIcon(B.icon)&&B.icon?.dark?.scheme===h.Schemas.file&&(V=P.nativeImage.createFromPath(S.URI.revive(B.icon.dark).fsPath),V.isEmpty()&&(V=void 0));let Y;return typeof B.title=="string"?Y=B.title:Y=B.title.value,{id:B.id,label:V?void 0:Y,icon:V}})}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id),this._win=null}};G.windowControlHeightStateStorageKey="windowControlHeight",e.CodeWindow=G=Se([J(1,w.ILogService),J(2,ne.ILoggerMainService),J(3,g.IEnvironmentMainService),J(4,q.IPolicyService),J(5,ie.IUserDataProfilesMainService),J(6,b.IFileService),J(7,i.IApplicationStorageMainService),J(8,i.IStorageMainService),J(9,v.IConfigurationService),J(10,p.IThemeMainService),J(11,_.IWorkspacesManagementMainService),J(12,y.IBackupMainService),J(13,n.ITelemetryService),J(14,o.IDialogMainService),J(15,E.ILifecycleMainService),J(16,t.IProductService),J(17,u.IProtocolMainService),J(18,k.IWindowsMainService),J(19,se.IStateService)],G)}),define(ee[82],te([0,1,14,24,8,4,46,2,15,3,19,7,22,191,6,20,5,99,97,30,54,35]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o,g,a,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,y.createDecorator)("workspacesHistoryMainService");let t=e.WorkspacesHistoryMainService=class nt extends I.Disposable{constructor(r,i,n,c){super(),this.logService=r,this.workspacesManagementMainService=i,this.lifecycleMainService=n,this.applicationStorageMainService=c,this._onDidChangeRecentlyOpened=this._register(new A.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new s.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){let i=[],n=[];for(const p of r)if((0,a.isRecentWorkspace)(p))!this.workspacesManagementMainService.isUntitledWorkspace(p.workspace)&&!this.containsWorkspace(i,p.workspace)&&i.push(p);else if((0,a.isRecentFolder)(p))this.containsFolder(i,p.folderUri)||i.push(p);else{const D=this.containsFile(n,p.fileUri),k=p.fileUri.scheme===h.Schemas.file&&nt.COMMON_FILES_FILTER.indexOf((0,m.basename)(p.fileUri))>=0;!D&&!k&&(n.push(p),l.isWindows&&p.fileUri.scheme===h.Schemas.file&&P.app.addRecentDocument(p.fileUri.fsPath))}const c=await this.mergeEntriesFromStorage({workspaces:i,files:n});i=c.workspaces,n=c.files,i.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(i.length=nt.MAX_TOTAL_RECENT_ENTRIES),n.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(n.length=nt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:n}),this._onDidChangeRecentlyOpened.fire(),l.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(r){const i=D=>{const k=this.location(D);for(const C of r)if(m.extUriBiasedIgnorePathCase.isEqual(C,k))return!1;return!0},n=await this.getRecentlyOpened(),c=n.workspaces.filter(i),p=n.files.filter(i);(c.length!==n.workspaces.length||p.length!==n.files.length)&&(await this.saveRecentlyOpened({files:p,workspaces:c}),this._onDidChangeRecentlyOpened.fire(),l.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(r){const i=new w.ResourceMap(p=>m.extUriBiasedIgnorePathCase.getComparisonKey(p));if(r?.workspaces)for(const p of r.workspaces)i.set(this.location(p),p);const n=new w.ResourceMap(p=>m.extUriBiasedIgnorePathCase.getComparisonKey(p));if(r?.files)for(const p of r.files)n.set(this.location(p),p);const c=await this.getRecentlyOpenedFromStorage();for(const p of c.workspaces){const D=i.get(this.location(p));D?D.label=D.label??p.label:i.set(this.location(p),p)}for(const p of c.files){const D=n.get(this.location(p));D?D.label=D.label??p.label:n.set(this.location(p),p)}return{workspaces:[...i.values()],files:[...n.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let r;const i=this.applicationStorageMainService.get(nt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof i=="string")try{r=JSON.parse(i)}catch(n){this.logService.error("Unexpected error parsing opened paths list",n)}return(0,a.restoreRecentlyOpened)(r,this.logService)}async saveRecentlyOpened(r){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(nt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,a.toStoreData)(r)),-1,1)}location(r){return(0,a.isRecentFolder)(r)?r.folderUri:(0,a.isRecentFile)(r)?r.fileUri:r.workspace.configPath}containsWorkspace(r,i){return!!r.find(n=>(0,a.isRecentWorkspace)(n)&&n.workspace.id===i.id)}containsFolder(r,i){return!!r.find(n=>(0,a.isRecentFolder)(n)&&m.extUriBiasedIgnorePathCase.isEqual(n.folderUri,i))}containsFile(r,i){return!!r.find(n=>m.extUriBiasedIgnorePathCase.isEqual(n.fileUri,i))}async handleWindowsJumpList(){l.isWindows&&(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!l.isWindows)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(0,null),description:(0,d.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const i=[];for(const p of P.app.getJumpListSettings().removedItems){const D=p.args;if(D){const k=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(D);k&&i.push(f.URI.parse(k[2]))}}await this.removeRecentlyOpened(i);let n=!1;const c=(0,L.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,nt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(p=>{const D=(0,a.isRecentWorkspace)(p)?p.workspace:p.folderUri,{title:k,description:C}=this.getWindowsJumpListLabel(D,p.label);let _;return f.URI.isUri(D)?_=`--folder-uri "${D.toString()}"`:(n=!0,_=`--file-uri "${D.configPath.toString()}"`),{type:"task",title:k.substr(0,255),description:C.substr(0,255),program:process.execPath,args:_,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&r.push({type:"custom",name:n?(0,d.localize)(2,null):(0,d.localize)(3,null),items:c})}r.push({type:"recent"});try{const i=P.app.setJumpList(r);i&&i!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${i}`)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(r,i){if(i)return{title:(0,R.splitRecentLabel)(i).name,description:i};if(f.URI.isUri(r))return{title:(0,m.basename)(r),description:this.renderJumpListPathDescription(r)};if(this.workspacesManagementMainService.isUntitledWorkspace(r))return{title:(0,d.localize)(4,null),description:""};let n=(0,m.basename)(r.configPath);return n.endsWith(b.WORKSPACE_EXTENSION)&&(n=n.substr(0,n.length-b.WORKSPACE_EXTENSION.length-1)),{title:(0,d.localize)(5,null,n),description:this.renderJumpListPathDescription(r.configPath)}}renderJumpListPathDescription(r){return r.scheme==="file"?(0,R.normalizeDriveLetter)(r.fsPath):r.toString()}async updateMacOSRecentDocuments(){if(!l.isMacintosh)return;P.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),i=[];let n=0;for(let p=0;p<r.workspaces.length&&n<nt.MAX_MACOS_DOCK_RECENT_WORKSPACES;p++){const D=this.location(r.workspaces[p]);if(D.scheme===h.Schemas.file){const k=(0,m.originalFSPath)(D);await S.Promises.exists(k)&&(i.push(k),n++)}}const c=[];for(let p=0;p<r.files.length&&n<nt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;p++){const D=this.location(r.files[p]);if(D.scheme===h.Schemas.file){const k=(0,m.originalFSPath)(D);if(nt.COMMON_FILES_FILTER.includes((0,m.basename)(D))||i.includes(k))continue;await S.Promises.exists(k)&&(c.push(k),n++)}}c.reverse().forEach(p=>P.app.addRecentDocument(p)),i.reverse().forEach(p=>P.app.addRecentDocument(p))}};t.MAX_TOTAL_RECENT_ENTRIES=500,t.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",t.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,t.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,t.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,t.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],e.WorkspacesHistoryMainService=t=Se([J(0,o.ILogService),J(1,E.IWorkspacesManagementMainService),J(2,v.ILifecycleMainService),J(3,g.IApplicationStorageMainService)],t)}),define(ee[301],te([0,1,14,8,21,46,3,7,179,18,28,20,5,229,67,23,34,26,48,80,29,82]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o,g,a,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let u=e.Menubar=class Et{constructor(n,c,p,D,k,C,_,T,U,q,se){this.updateService=n,this.configurationService=c,this.windowsMainService=p,this.environmentMainService=D,this.telemetryService=k,this.workspacesHistoryMainService=C,this.stateService=_,this.lifecycleMainService=T,this.logService=U,this.nativeHostMainService=q,this.productService=se,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(R.isMacintosh||(0,b.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const n=this.stateService.getItem(Et.lastKnownMenubarStorageKey);n&&(n.menus&&(this.menubarMenus=n.menus),n.keybindings&&(this.keybindings=n.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(C,_,T)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:_?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(C,_,T)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:_?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(C,_,T)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(T),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(C,_,T)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(T),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(C,_,T)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(T),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const n=this.productService.twitterUrl;n&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(n,"openTwitterUrl"));const c=this.productService.requestFeatureUrl;c&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(c,"openUserVoiceUrl"));const p=this.productService.reportIssueUrl;p&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(p,"openReportIssues"));const D=this.productService.licenseUrl;D&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(R.language){const C=D.indexOf("?")>0?"&":"?";this.openUrl(`${D}${C}lang=${R.language}`,"openLicenseUrl")}else this.openUrl(D,"openLicenseUrl")});const k=this.productService.privacyStatementUrl;k&&D&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(k,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(n=>this.onDidChangeWindowsCount(n)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const n=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof n!="boolean"?!0:n}get currentEnableNativeTabs(){if(!R.isMacintosh)return!1;const n=this.configurationService.getValue("window.nativeTabs");return typeof n!="boolean"?!1:n}updateMenu(n,c){this.menubarMenus=n.menus,this.keybindings=n.keybindings,this.stateService.setItem(Et.lastKnownMenubarStorageKey,n),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(n){R.isMacintosh&&(n.oldCount===0&&n.newCount>0||n.oldCount>0&&n.newCount===0)&&(this.closedLastWindow=n.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){R.isMacintosh&&(this.noActiveWindow=!P.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const n=P.Menu.getApplicationMenu();if(n&&this.oldMenus.push(n),Object.keys(this.menubarMenus).length===0){P.Menu.setApplicationMenu(R.isMacintosh?new P.Menu:null);return}const c=new P.Menu;let p;if(R.isMacintosh){const k=new P.Menu;p=new P.MenuItem({label:this.productService.nameShort,submenu:k}),this.setMacApplicationMenu(k),c.append(p)}if(R.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const k=new P.Menu;k.append(new P.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),P.app.dock.setMenu(k)}if(this.shouldDrawMenu("File")){const k=new P.Menu,C=new P.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:k});this.setMenuById(k,"File"),c.append(C)}if(this.shouldDrawMenu("Edit")){const k=new P.Menu,C=new P.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:k});this.setMenuById(k,"Edit"),c.append(C)}if(this.shouldDrawMenu("Selection")){const k=new P.Menu,C=new P.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:k});this.setMenuById(k,"Selection"),c.append(C)}if(this.shouldDrawMenu("View")){const k=new P.Menu,C=new P.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:k});this.setMenuById(k,"View"),c.append(C)}if(this.shouldDrawMenu("Go")){const k=new P.Menu,C=new P.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:k});this.setMenuById(k,"Go"),c.append(C)}if(this.shouldDrawMenu("Run")){const k=new P.Menu,C=new P.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:k});this.setMenuById(k,"Run"),c.append(C)}if(this.shouldDrawMenu("Terminal")){const k=new P.Menu,C=new P.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:k});this.setMenuById(k,"Terminal"),c.append(C)}let D;if(this.shouldDrawMenu("Window")){const k=new P.Menu;D=new P.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:k,role:"window"}),this.setMacWindowMenu(k)}if(D&&c.append(D),this.shouldDrawMenu("Help")){const k=new P.Menu,C=new P.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:k,role:"help"});this.setMenuById(k,"Help"),c.append(C)}c.items&&c.items.length>0?P.Menu.setApplicationMenu(c):P.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(n){const c=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),p=this.getUpdateMenuItems();let D;if(this.shouldDrawMenu("Preferences")){const ie=new P.Menu;this.setMenuById(ie,"Preferences"),D=new P.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:ie})}const k=new P.Menu,C=new P.MenuItem({label:h.localize(12,null),role:"services",submenu:k}),_=new P.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),T=new P.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),U=new P.MenuItem({label:h.localize(15,null),role:"unhide"}),q=new P.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:async(ie,ne,ue)=>{const le=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||P.BrowserWindow.getFocusedWindow()||le?.isMinimized())&&await this.confirmBeforeQuit(ue)&&this.nativeHostMainService.quit(void 0)}})),se=[c];se.push(...p),D&&se.push(r(),D),se.push(r(),C,r(),_,T,U,r(),q),se.forEach(ie=>n.append(ie))}async confirmBeforeQuit(n){if(this.windowsMainService.getWindowCount()===0)return!0;const c=this.configurationService.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.isKeyboardEvent(n)){const{response:p}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return p===0}return!0}shouldDrawMenu(n){if(!R.isMacintosh&&(0,b.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(n){case"File":case"Help":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[n];case"Window":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[n]}}setMenu(n,c){c.forEach(p=>{if((0,d.isMenubarMenuItemSeparator)(p))n.append(r());else if((0,d.isMenubarMenuItemSubmenu)(p)){const D=new P.Menu,k=new P.MenuItem({label:this.mnemonicLabel(p.label),submenu:D});this.setMenu(D,p.submenu.items),n.append(k)}else(0,d.isMenubarMenuItemRecentAction)(p)?n.append(this.createOpenRecentMenuItem(p)):(0,d.isMenubarMenuItemAction)(p)&&(p.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(n),R.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[p.id]?n.append(new P.MenuItem(this.likeAction(p.id,{label:this.mnemonicLabel(p.label),click:this.fallbackMenuHandlers[p.id]}))):n.append(this.createMenuItem(p.label,p.id,!1,p.checked)):n.append(this.createMenuItem(p.label,p.id,p.enabled!==!1,!!p.checked)):n.append(this.createMenuItem(p.label,p.id,p.enabled!==!1,!!p.checked)))})}setMenuById(n,c){this.menubarMenus&&this.menubarMenus[c]&&this.setMenu(n,this.menubarMenus[c].items)}insertCheckForUpdatesItems(n){const c=this.getUpdateMenuItems();c.length&&(c.forEach(p=>n.append(p)),n.append(r()))}createOpenRecentMenuItem(n){const c=I.URI.revive(n.uri),p=n.id,D=p==="openRecentFile"?{fileUri:c}:p==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new P.MenuItem(this.likeAction(p,{label:n.label,click:async(k,C,_)=>{const T=this.isOptionClick(_);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[D],forceNewWindow:T,gotoLineMode:!1,remoteAuthority:n.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([c])}},!1))}isOptionClick(n){return!!(n&&(!R.isMacintosh&&(n.ctrlKey||n.shiftKey)||R.isMacintosh&&(n.metaKey||n.altKey)))}isKeyboardEvent(n){return!!(n.triggeredByAccelerator||n.altKey||n.ctrlKey||n.metaKey||n.shiftKey)}createRoleMenuItem(n,c,p){const D={label:this.mnemonicLabel(n),role:p,enabled:!0};return new P.MenuItem(this.withKeybinding(c,D))}setMacWindowMenu(n){const c=new P.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),p=new P.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),D=new P.MenuItem({label:h.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),k=this.createMenuItem(h.localize(23,null),"workbench.action.switchWindow"),C=[];this.currentEnableNativeTabs&&(C.push(r()),C.push(this.createMenuItem(h.localize(24,null),"workbench.action.newWindowTab")),C.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),C.push(this.createRoleMenuItem(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),C.push(this.createRoleMenuItem(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),C.push(this.createRoleMenuItem(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,p,r(),k,...C,r(),D].forEach(_=>n.append(_))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new P.MenuItem({label:this.mnemonicLabel(h.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.mnemonicLabel(h.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.mnemonicLabel(h.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new P.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.mnemonicLabel(h.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(n,c,p,D){const k=this.mnemonicLabel(n),C=typeof c=="function"?c:(se,ie,ne)=>{const ue=se?se.userSettingsLabel:null;let le=c;Array.isArray(c)&&(le=this.isOptionClick(ne)?c[1]:c[0]),ue&&ne.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:ue}):this.runActionInRenderer({type:"commandId",commandId:le})},_=typeof p=="boolean"?p:this.windowsMainService.getWindowCount()>0,T=typeof D=="boolean"?D:!1,U={label:k,click:C,enabled:_};T&&(U.type="checkbox",U.checked=T);let q;return typeof c=="string"?q=c:Array.isArray(c)&&(q=c[0]),R.isMacintosh&&(q==="editor.action.clipboardCutAction"?U.role="cut":q==="editor.action.clipboardCopyAction"?U.role="copy":q==="editor.action.clipboardPasteAction"&&(U.role="paste"),q==="undo"?U.click=this.makeContextAwareClickHandler(C,{inDevTools:se=>se.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):q==="redo"?U.click=this.makeContextAwareClickHandler(C,{inDevTools:se=>se.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):q==="editor.action.selectAll"&&(U.click=this.makeContextAwareClickHandler(C,{inDevTools:se=>se.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.withKeybinding(q,U))}makeContextAwareClickHandler(n,c){return(p,D,k)=>{const C=P.BrowserWindow.getFocusedWindow();if(!C)return c.inNoWindow();if(C.webContents.isDevToolsFocused()&&C.webContents.devToolsWebContents)return c.inDevTools(C.webContents.devToolsWebContents);n(p,D||C,k)}}runActionInRenderer(n){let c=P.BrowserWindow.getFocusedWindow();if(!c){const D=this.windowsMainService.getLastActiveWindow();D?.isMinimized()&&(c=D.win)}const p=c?this.windowsMainService.getWindowById(c.id):void 0;if(p){if(this.logService.trace("menubar#runActionInRenderer",n),R.isMacintosh&&!this.environmentMainService.isBuilt&&!p.isReady&&(n.type==="commandId"&&n.commandId==="workbench.action.toggleDevTools"||n.type!=="commandId"&&n.userSettingsLabel==="alt+cmd+i"))return;if(n.type==="commandId"){const D={id:n.commandId,from:"menu"};p.sendWhenReady("vscode:runAction",s.CancellationToken.None,D)}else{const D={userSettingsLabel:n.userSettingsLabel};p.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,D)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",n)}withKeybinding(n,c){const p=typeof n=="string"?this.keybindings[n]:void 0;if(p?.label){if(p.isNative!==!1)c.accelerator=p.label,c.userSettingsLabel=p.userSettingsLabel;else if(typeof c.label=="string"){const D=c.label.indexOf("[");D>=0?c.label=`${c.label.substr(0,D)} [${p.label}]`:c.label=`${c.label} [${p.label}]`}}else c.accelerator=void 0;return c}likeAction(n,c,p=!c.accelerator){p&&(c=this.withKeybinding(n,c));const D=c.click;return c.click=(k,C,_)=>{this.reportMenuActionTelemetry(n),D?.(k,C,_)},c}openUrl(n,c){this.nativeHostMainService.openExternal(void 0,n),this.reportMenuActionTelemetry(c)}reportMenuActionTelemetry(n){this.telemetryService.publicLog2("workbenchActionExecuted",{id:n,from:t})}mnemonicLabel(n){return(0,A.mnemonicMenuLabel)(n,!this.currentEnableMenuBarMnemonics)}};u.lastKnownMenubarStorageKey="lastKnownMenubarData",e.Menubar=u=Se([J(0,a.IUpdateService),J(1,l.IConfigurationService),J(2,E.IWindowsMainService),J(3,m.IEnvironmentMainService),J(4,g.ITelemetryService),J(5,w.IWorkspacesHistoryMainService),J(6,o.IStateService),J(7,f.ILifecycleMainService),J(8,S.ILogService),J(9,y.INativeHostMainService),J(10,v.IProductService)],u);function r(){return new P.MenuItem({type:"separator"})}}),define(ee[302],te([0,1,6,20,5,301]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,P.createDecorator)("menubarMainService");let R=e.MenubarMainService=class{constructor(h,l,m){this.instantiationService=h,this.lifecycleMainService=l,this.logService=m,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(A.Menubar)}async updateMenubar(h,l){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(l,h)}};e.MenubarMainService=R=Se([J(0,P.IInstantiationService),J(1,L.ILifecycleMainService),J(2,s.ILogService)],R)}),define(ee[303],te([0,1,14,22,131,27,24,21,4,32,49,46,2,15,9,65,3,36,19,11,7,189,64,18,59,28,16,6,20,5,77,78,58,34,80,300,129,296,30,98,82,54,79,39,53,66]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o,g,a,b,E,w,t,u,r,i,n,c,p,D,k,C,_,T,U,q,se,ie,ne,ue,le,G,Q,F,N,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function V(oe){return(0,ne.isWorkspaceIdentifier)(oe?.workspace)}function Y(oe){return(0,ne.isSingleFolderWorkspaceIdentifier)(oe?.workspace)}let ae=e.WindowsMainService=class at extends S.Disposable{constructor(O,M,W,H,x,z,$,K,re,ce,ge,ke,Re,Le,Oe,ye,we,Ee){super(),this.machineId=O,this.initialUserEnv=M,this.logService=W,this.loggerService=H,this.stateService=x,this.policyService=z,this.environmentMainService=$,this.userDataProfilesMainService=K,this.lifecycleMainService=re,this.backupMainService=ce,this.configurationService=ge,this.workspacesHistoryMainService=ke,this.workspacesManagementMainService=Re,this.instantiationService=Le,this.dialogMainService=Oe,this.fileService=ye,this.protocolMainService=we,this.themeMainService=Ee,this._onDidOpenWindow=this._register(new h.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new h.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new h.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new h.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new h.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ie.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(O=>this._onDidSignalReadyWindow.fire(O.window))),this._register(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const M=new S.DisposableStore;if(M.add(h.Event.any(O.onDidClose,O.onDidDestroy)(()=>M.dispose())),O.config.extensionDevelopmentPath)for(const W of O.config.extensionDevelopmentPath)M.add(this.protocolMainService.addValidFileRoot(W));O.config.extensionTestsPath&&M.add(this.protocolMainService.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,M){const W=this.environmentMainService.args,H=M?.remoteAuthority||void 0,x=!0,z=M?.forceReuseWindow,$=!z;return this.open({...O,cli:W,forceEmpty:x,forceNewWindow:$,forceReuseWindow:z,remoteAuthority:H})}openExistingWindow(O,M){O.focus(),this.handleWaitMarkerFile(M,[O])}async open(O){this.logService.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const M=[],W=[],H=[],x=[],z=[];let $,K=0;const re=await this.getPathsToOpen(O);this.logService.trace("windowsManager#open pathsToOpen",re);for(const Le of re)Y(Le)?O.addMode?M.push(Le):W.push(Le):V(Le)?H.push(Le):Le.fileUri?($||($={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Le.remoteAuthority}),$.filesToOpenOrCreate.push(Le)):Le.backupPath?z.push({backupFolder:(0,y.basename)(Le.backupPath),remoteAuthority:Le.remoteAuthority}):K++;O.diffMode&&$&&$.filesToOpenOrCreate.length>=2&&($.filesToDiff=$.filesToOpenOrCreate.slice(0,2),$.filesToOpenOrCreate=[]),O.mergeMode&&$&&$.filesToOpenOrCreate.length===4&&($.filesToMerge=$.filesToOpenOrCreate.slice(0,4),$.filesToOpenOrCreate=[],$.filesToDiff=[]),$&&O.waitMarkerFileURI&&($.filesToWait={paths:(0,R.coalesce)([...$.filesToDiff,$.filesToMerge[3],...$.filesToOpenOrCreate]),waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(x.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),H.push(...x),z.push(...this.backupMainService.getEmptyWindowBackups())):z.length=0;const{windows:ce,filesOpenedInWindow:ge}=await this.doOpen(O,H,W,z,K,$,M);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${H.length}, foldersToOpen: ${W.length}, emptyToRestore: ${z.length}, emptyToOpen: ${K})`),ce.length>1)if(ge)ge.focus();else{const Le=this.windowsStateHandler.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let Oe=!0,ye=!0;if(Le){const we=ce.filter(Ee=>this.windowsStateHandler.state.lastActiveWindow&&Ee.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Oe=!1,ye=!1)}if(Oe)for(let we=ce.length-1;we>=0;we--){const Ee=ce[we];if(!(Ee.openedWorkspace&&x.some(Z=>Ee.openedWorkspace&&Z.workspace.id===Ee.openedWorkspace.id)||Ee.backupPath&&z.some(Z=>Ee.backupPath&&Z.backupFolder===(0,y.basename)(Ee.backupPath)))){Ee.focus(),ye=!1;break}}ye&&ce[ce.length-1].focus()}const ke=$&&$.filesToDiff.length>0,Re=$&&$.filesToMerge.length>0;if(!ce.some(Le=>Le.isExtensionDevelopmentHost)&&!ke&&!Re&&!O.noRecentEntry){const Le=[];for(const Oe of re)V(Oe)&&!Oe.transient?Le.push({label:Oe.label,workspace:Oe.workspace,remoteAuthority:Oe.remoteAuthority}):Y(Oe)?Le.push({label:Oe.label,folderUri:Oe.workspace.uri,remoteAuthority:Oe.remoteAuthority}):Oe.fileUri&&Le.push({label:Oe.label,fileUri:Oe.fileUri,remoteAuthority:Oe.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Le)}return this.handleWaitMarkerFile(O,ce),ce}handleWaitMarkerFile(O,M){const W=O.waitMarkerFileURI;O.context===0&&W&&M.length===1&&M[0]&&(async()=>{await M[0].whenClosedOrLoaded;try{await this.fileService.del(W)}catch{}})()}async doOpen(O,M,W,H,x,z,$){const K=[];let re;function ce(we,Ee){K.push(we),Ee&&(re=we,z=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:ke}=this.shouldOpenNewWindow(O);if(!O.initialStartup&&$.length>0){const we=$[0].remoteAuthority,Ee=this.getLastActiveWindowForAuthority(we);Ee&&ce(this.doAddFoldersToExistingWindow(Ee,$.map(Z=>Z.workspace.uri)))}const Re=W.length+M.length+H.length;if(z&&Re===0){const we=z.filesToOpenOrCreate[0]||z.filesToDiff[0]||z.filesToMerge[3],Ee=this.getWindows().filter(de=>z&&(0,a.isEqualAuthority)(de.remoteAuthority,z.remoteAuthority));let Z;we?.fileUri&&!ke&&((O.context===4||O.context===0||O.context===1)&&(Z=await(0,se.findWindowOnFile)(Ee,we.fileUri,async de=>de.configPath.scheme===d.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(de.configPath):void 0)),Z||(Z=this.doGetLastActiveWindow(Ee))),Z?(0,ne.isWorkspaceIdentifier)(Z.openedWorkspace)?M.push({workspace:Z.openedWorkspace,remoteAuthority:Z.remoteAuthority}):(0,ne.isSingleFolderWorkspaceIdentifier)(Z.openedWorkspace)?W.push({workspace:Z.openedWorkspace,remoteAuthority:Z.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(O,Z,z),!0):ce(await this.openInBrowserWindow({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:z,forceNewWindow:!0,remoteAuthority:z.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile}),!0)}const Le=(0,R.distinct)(M,we=>we.workspace.id);if(Le.length>0){const we=(0,R.coalesce)(Le.map(Ee=>(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),Ee.workspace.configPath)));if(we.length>0){const Ee=we[0],Z=(0,a.isEqualAuthority)(z?.remoteAuthority,Ee.remoteAuthority)?z:void 0;ce(this.doOpenFilesInExistingWindow(O,Ee,Z),!!Z),ge=!0}for(const Ee of Le){if(we.some(fe=>fe.openedWorkspace&&fe.openedWorkspace.id===Ee.workspace.id))continue;const Z=Ee.remoteAuthority,de=(0,a.isEqualAuthority)(z?.remoteAuthority,Z)?z:void 0;ce(await this.doOpenFolderOrWorkspace(O,Ee,ge,de),!!de),ge=!0}}const Oe=(0,R.distinct)(W,we=>a.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(Oe.length>0){const we=(0,R.coalesce)(Oe.map(Ee=>(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),Ee.workspace.uri)));if(we.length>0){const Ee=we[0],Z=(0,a.isEqualAuthority)(z?.remoteAuthority,Ee.remoteAuthority)?z:void 0;ce(this.doOpenFilesInExistingWindow(O,Ee,Z),!!Z),ge=!0}for(const Ee of Oe){if(we.some(fe=>(0,ne.isSingleFolderWorkspaceIdentifier)(fe.openedWorkspace)&&a.extUriBiasedIgnorePathCase.isEqual(fe.openedWorkspace.uri,Ee.workspace.uri)))continue;const Z=Ee.remoteAuthority,de=(0,a.isEqualAuthority)(z?.remoteAuthority,Z)?z:void 0;ce(await this.doOpenFolderOrWorkspace(O,Ee,ge,de),!!de),ge=!0}}const ye=(0,R.distinct)(H,we=>we.backupFolder);if(ye.length>0)for(const we of ye){const Ee=we.remoteAuthority,Z=(0,a.isEqualAuthority)(z?.remoteAuthority,Ee)?z:void 0;ce(await this.doOpenEmpty(O,!0,Ee,Z,we),!!Z),ge=!0}if(K.length===0||z){z&&!x&&x++;const we=z?z.remoteAuthority:O.remoteAuthority;for(let Ee=0;Ee<x;Ee++)ce(await this.doOpenEmpty(O,ge,we,z),!!z),ge=!0}return{windows:(0,R.distinct)(K),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(O,M,W){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),M.focus();const H={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToMerge:W?.filesToMerge,filesToWait:W?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return M.sendWhenReady("vscode:openFiles",I.CancellationToken.None,H),M}doAddFoldersToExistingWindow(O,M){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:M}),O.focus();const W={foldersToAdd:M};return O.sendWhenReady("vscode:addFolders",I.CancellationToken.None,W),O}doOpenEmpty(O,M,W,H,x){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!x,remoteAuthority:W,filesToOpen:H,forceNewWindow:M});let z;return!M&&typeof O.contextWindowId=="number"&&(z=this.getWindowById(O.contextWindowId)),this.openInBrowserWindow({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:W,forceNewWindow:M,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:H,windowToUse:z,emptyWindowBackupInfo:x,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}doOpenFolderOrWorkspace(O,M,W,H,x){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:M,filesToOpen:H}),!W&&!x&&typeof O.contextWindowId=="number"&&(x=this.getWindowById(O.contextWindowId)),this.openInBrowserWindow({workspace:M.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:M.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:H,windowToUse:x,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}async getPathsToOpen(O){let M,W=!1,H=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(M=await this.doExtractPathsFromAPI(O),W=!0):O.forceEmpty?M=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(M=await this.doExtractPathsFromCLI(O.cli),M.length===0&&M.push(Object.create(null)),W=!0):(M=await this.doGetPathsFromLastSession(),M.length===0&&M.push(Object.create(null)),H=!0),!O.addMode&&W){const x=M.filter(z=>Y(z));if(x.length>1){const z=x[0].remoteAuthority;if(x.every($=>(0,a.isEqualAuthority)($.remoteAuthority,z))){const $=await this.workspacesManagementMainService.createUntitledWorkspace(x.map(K=>({uri:K.workspace.uri})));M.push({workspace:$,remoteAuthority:z}),M=M.filter(K=>!Y(K))}}}if(O.initialStartup&&!H&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const x=await this.doGetPathsFromLastSession();M.unshift(...x.filter(z=>V(z)||Y(z)||z.backupPath))}return M}async doExtractPathsFromAPI(O){const M={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority},W=await Promise.all((0,R.coalesce)(O.urisToOpen||[]).map(async H=>{const x=await this.resolveOpenable(H,M);if(x)return x.label=H.label,x;const z=this.resourceFromOpenable(H);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,w.localize)(0,null)],message:z.scheme===d.Schemas.file?(0,w.localize)(1,null):(0,w.localize)(2,null),detail:z.scheme===d.Schemas.file?(0,w.localize)(3,null,(0,f.getPathLabel)(z,{os:o.OS,tildify:this.environmentMainService})):(0,w.localize)(4,null,z.toString(!0))},(0,b.withNullAsUndefined)(P.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(W)}async doExtractPathsFromCLI(O){const M=[],W={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:O.diff&&O._.length===2||O.merge&&O._.length===4},H=O["folder-uri"];if(H){const $=await Promise.all(H.map(K=>{const re=this.cliArgToUri(K);if(re)return this.resolveOpenable({folderUri:re},W)}));M.push(...(0,R.coalesce)($))}const x=O["file-uri"];if(x){const $=await Promise.all(x.map(K=>{const re=this.cliArgToUri(K);if(re)return this.resolveOpenable((0,ne.hasWorkspaceFileExtension)(K)?{workspaceUri:re}:{fileUri:re},W)}));M.push(...(0,R.coalesce)($))}const z=await Promise.all(O._.map($=>W.remoteAuthority?this.doResolveRemotePath($,W):this.doResolveFilePath($,W)));return M.push(...(0,R.coalesce)(z)),M}cliArgToUri(O){try{const M=E.URI.parse(O);if(!M.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${O}`);return}return M.path?M:M.with({path:"/"})}catch(M){this.logService.error(`Invalid URI input string: ${O}, ${M.message}`)}}async doGetPathsFromLastSession(){const O=this.getRestoreWindowsSetting();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const M=[];O!=="one"&&M.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&M.push(this.windowsStateHandler.state.lastActiveWindow);const W=await Promise.all(M.map(async H=>{if(H.workspace){const x=await this.resolveOpenable({workspaceUri:H.workspace.configPath},{remoteAuthority:H.remoteAuthority,rejectTransientWorkspaces:!0});if(V(x))return x}else if(H.folderUri){const x=await this.resolveOpenable({folderUri:H.folderUri},{remoteAuthority:H.remoteAuthority});if(Y(x))return x}else if(O!=="folders"&&H.backupPath)return{backupPath:H.backupPath,remoteAuthority:H.remoteAuthority}}));return(0,R.coalesce)(W)}}}getRestoreWindowsSetting(){let O;return this.lifecycleMainService.wasRestarted?O="all":(O=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}async resolveOpenable(O,M=Object.create(null)){const W=this.resourceFromOpenable(O);return W.scheme===d.Schemas.file?((0,U.isFileToOpen)(O)&&(M={...M,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(W.fsPath,M)):this.doResolveRemoteOpenable(O,M)}doResolveRemoteOpenable(O,M){let W=this.resourceFromOpenable(O);const H=(0,_.getRemoteAuthority)(W)||M.remoteAuthority;if(W=(0,a.removeTrailingPathSeparator)((0,a.normalizePath)(W)),(0,U.isFileToOpen)(O)){if(M.gotoLineMode){const{path:x,line:z,column:$}=(0,l.parseLineAndColumnAware)(W.path);return{fileUri:W.with({path:x}),options:{selection:z?{startLineNumber:z,startColumn:$||1}:void 0},remoteAuthority:H}}return{fileUri:W,remoteAuthority:H}}else if((0,U.isWorkspaceToOpen)(O))return{workspace:(0,ue.getWorkspaceIdentifier)(W),remoteAuthority:H};return{workspace:(0,ue.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:H}}resourceFromOpenable(O){return(0,U.isWorkspaceToOpen)(O)?O.workspaceUri:(0,U.isFolderToOpen)(O)?O.folderUri:O.fileUri}async doResolveFilePath(O,M,W){let H,x;M.gotoLineMode&&({path:O,line:H,column:x}=(0,l.parseLineAndColumnAware)(O)),O=(0,l.sanitizeFilePath)((0,y.normalize)(O),(0,g.cwd)());try{const z=await L.Promises.stat(O);if(z.isFile()){if(!M.forceOpenWorkspaceAsFile){const $=await this.workspacesManagementMainService.resolveLocalWorkspace(E.URI.file(O));if($)return $.transient&&M.rejectTransientWorkspaces?void 0:{workspace:{id:$.id,configPath:$.configPath},type:n.FileType.File,exists:!0,remoteAuthority:$.remoteAuthority,transient:$.transient}}return{fileUri:E.URI.file(O),type:n.FileType.File,exists:!0,options:{selection:H?{startLineNumber:H,startColumn:x||1}:void 0}}}else{if(z.isDirectory())return{workspace:(0,ue.getSingleFolderWorkspaceIdentifier)(E.URI.file(O),z),type:n.FileType.Directory,exists:!0};if(!o.isWindows&&O==="/dev/null")return{fileUri:E.URI.file(O),type:n.FileType.File,exists:!0}}}catch(z){if(z.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!W)return this.onUNCHostNotAllowed(O,M);const $=E.URI.file(O);if(this.workspacesHistoryMainService.removeRecentlyOpened([$]),M.ignoreFileNotFound)return{fileUri:$,type:n.FileType.File,exists:!1}}}async onUNCHostNotAllowed(O,M){const W=E.URI.file(O),{response:H,checkboxChecked:x}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,w.localize)(5,null),(0,w.localize)(6,null),(0,w.localize)(7,null)],message:(0,w.localize)(8,null,W.authority),detail:(0,w.localize)(9,null,(0,f.getPathLabel)(W,{os:o.OS,tildify:this.environmentMainService})),checkboxLabel:(0,w.localize)(10,null,W.authority),cancelId:1});if(H===0)return(0,s.addUNCHostToAllowlist)(W.authority),x&&this._register(h.Event.once(this.onDidOpenWindow)(z=>{z.sendWhenReady("vscode:configureAllowedUNCHost",I.CancellationToken.None,W.authority)})),this.doResolveFilePath(O,M,!0);if(H===2)return P.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.onUNCHostNotAllowed(O,M)}doResolveRemotePath(O,M){const W=O.charCodeAt(0),H=M.remoteAuthority;let x,z;M.gotoLineMode&&({path:O,line:x,column:z}=(0,l.parseLineAndColumnAware)(O)),W!==47&&((0,l.isWindowsDriveLetter)(W)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,l.toSlashes)(O)),O=`/${O}`);const $=E.URI.from({scheme:d.Schemas.vscodeRemote,authority:H,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,ne.hasWorkspaceFileExtension)(O))return M.forceOpenWorkspaceAsFile?{fileUri:$,options:{selection:x?{startLineNumber:x,startColumn:z||1}:void 0},remoteAuthority:M.remoteAuthority}:{workspace:(0,ue.getWorkspaceIdentifier)($),remoteAuthority:H};if(M.gotoLineMode||y.posix.basename(O).indexOf(".")!==-1)return{fileUri:$,options:{selection:x?{startLineNumber:x,startColumn:z||1}:void 0},remoteAuthority:H}}return{workspace:(0,ue.getSingleFolderWorkspaceIdentifier)($),remoteAuthority:H}}shouldOpenNewWindow(O){const M=this.configurationService.getValue("window"),W=M?.openFoldersInNewWindow||"default",H=M?.openFilesInNewWindow||"off";let x=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(W==="on"||W==="off")&&(x=W==="on");let z=!1;return O.forceNewWindow||O.forceReuseWindow?z=!!O.forceNewWindow&&!O.forceReuseWindow:(o.isMacintosh?O.context===1&&(z=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(z=!0),!O.cli.extensionDevelopmentPath&&(H==="on"||H==="off")&&(z=H==="on")),{openFolderInNewWindow:!!x,openFilesInNewWindow:z}}async openExtensionDevelopmentHostWindow(O,M){const W=(0,se.findWindowOnExtensionDevelopmentPath)(this.getWindows(),O);if(W)return this.lifecycleMainService.reload(W,M.cli),W.focus(),[W];let H=M.cli["folder-uri"]||[],x=M.cli["file-uri"]||[],z=M.cli._;if(!z.length&&!H.length&&!x.length&&!M.cli.extensionTestsPath){const re=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ce=re?.workspace??re?.folderUri;ce&&(E.URI.isUri(ce)?ce.scheme===d.Schemas.file?z=[ce.fsPath]:H=[ce.toString()]:ce.configPath.scheme===d.Schemas.file?z=[(0,a.originalFSPath)(ce.configPath)]:x=[ce.configPath.toString()])}let $=M.remoteAuthority;for(const re of O)if(re.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ce=E.URI.parse(re),ge=(0,_.getRemoteAuthority)(ce);ge&&($?(0,a.isEqualAuthority)(ge,$)||this.logService.error("more than one extension development path authority"):$=ge)}z=z.filter(re=>{const ce=E.URI.file(re);return(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:(0,a.isEqualAuthority)((0,_.getRemoteAuthority)(ce),$)}),H=H.filter(re=>{const ce=this.cliArgToUri(re);return ce&&(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,a.isEqualAuthority)((0,_.getRemoteAuthority)(ce),$):!1}),x=x.filter(re=>{const ce=this.cliArgToUri(re);return ce&&(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,a.isEqualAuthority)((0,_.getRemoteAuthority)(ce),$):!1}),M.cli._=z,M.cli["folder-uri"]=H,M.cli["file-uri"]=x;const K={context:M.context,cli:M.cli,forceNewWindow:!0,forceEmpty:!z.length&&!H.length&&!x.length,userEnv:M.userEnv,noRecentEntry:!0,waitMarkerFileURI:M.waitMarkerFileURI,remoteAuthority:$,forceProfile:M.forceProfile,forceTempProfile:M.forceTempProfile};return this.open(K)}async openInBrowserWindow(O){const M=this.configurationService.getValue("window"),W=this.getLastActiveWindow(),H=W?.profile??this.userDataProfilesMainService.defaultProfile;let x;!O.forceNewWindow&&!O.forceNewTabbedWindow&&(x=O.windowToUse||W,x&&x.focus());const z={...this.environmentMainService.args,...O.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,y.join)(this.environmentMainService.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:H},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.initialUserEnv,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToMerge:O.filesToOpen?.filesToMerge,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.fsPath,product:k.default,isInitialStartup:O.initialStartup,perfMarks:(0,v.getMarks)(),os:{release:(0,A.release)(),hostname:(0,A.hostname)()},zoomLevel:typeof M?.zoomLevel=="number"?M.zoomLevel:void 0,autoDetectHighContrast:M?.autoDetectHighContrast??!0,autoDetectColorScheme:M?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};if(x){const $=x.config;!z.extensionDevelopmentPath&&$?.extensionDevelopmentPath&&(z.extensionDevelopmentPath=$.extensionDevelopmentPath,z.extensionDevelopmentKind=$.extensionDevelopmentKind,z["enable-proposed-api"]=$["enable-proposed-api"],z.verbose=$.verbose,z["inspect-extensions"]=$["inspect-extensions"],z["inspect-brk-extensions"]=$["inspect-brk-extensions"],z.debugId=$.debugId,z.extensionEnvironment=$.extensionEnvironment,z["extensions-dir"]=$["extensions-dir"],z["disable-extensions"]=$["disable-extensions"]),z.loggers={global:z.loggers.global,window:$?.loggers.window??z.loggers.window}}else{const $=this.windowsStateHandler.getNewWindowState(z);(0,v.mark)("code/willCreateCodeWindow");const K=x=this.instantiationService.createInstance(q.CodeWindow,{state:$,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});(0,v.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(K),at.WINDOWS.push(K),this._onDidOpenWindow.fire(K),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(K.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(K)),(0,m.once)(K.onDidClose)(()=>this.onWindowClosed(K)),(0,m.once)(K.onDidDestroy)(()=>this._onDidDestroyWindow.fire(K)),K.onDidTriggerSystemContextMenu(({x:ce,y:ge})=>this._onDidTriggerSystemContextMenu.fire({window:K,x:ce,y:ge}));const re=(0,b.assertIsDefined)(K.win?.webContents);re.removeAllListeners("devtools-reload-page"),re.on("devtools-reload-page",()=>this.lifecycleMainService.reload(K)),this.lifecycleMainService.registerWindow(K)}return z.windowId=x.id,x.isReady?this.lifecycleMainService.unload(x,4).then(async $=>{$||await this.doOpenInBrowserWindow(x,z,O,H)}):await this.doOpenInBrowserWindow(x,z,O,H),x}async doOpenInBrowserWindow(O,M,W,H){if(M.extensionDevelopmentPath||((0,ne.isWorkspaceIdentifier)(M.workspace)?M.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:M.workspace,remoteAuthority:M.remoteAuthority}):(0,ne.isSingleFolderWorkspaceIdentifier)(M.workspace)?M.backupPath=this.backupMainService.registerFolderBackup({folderUri:M.workspace.uri,remoteAuthority:M.remoteAuthority}):M.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:W.emptyWindowBackupInfo?.backupFolder??(0,ue.createEmptyWorkspaceIdentifier)().id,remoteAuthority:M.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const x=M.workspace??(0,ne.toWorkspaceIdentifier)(M.backupPath,!1),z=this.resolveProfileForBrowserWindow(W,x,H),$=z instanceof Promise?await z:z;M.profiles.profile=$,M.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(x,$)}O.load(M)}resolveProfileForBrowserWindow(O,M,W){return O.forceProfile?this.userDataProfilesMainService.profiles.find(H=>H.name===O.forceProfile)??this.userDataProfilesMainService.createNamedProfile(O.forceProfile):O.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(M)??W}onWindowClosed(O){const M=at.WINDOWS.indexOf(O);at.WINDOWS.splice(M,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const O=P.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(O){return this.doGetLastActiveWindow(this.getWindows().filter(M=>(0,a.isEqualAuthority)(M.remoteAuthority,O)))}doGetLastActiveWindow(O){const M=Math.max.apply(Math,O.map(W=>W.lastFocusTime));return O.find(W=>W.lastFocusTime===M)}sendToFocused(O,...M){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(O,I.CancellationToken.None,...M)}sendToAll(O,M,W){for(const H of this.getWindows())W&&W.indexOf(H.id)>=0||H.sendWhenReady(O,I.CancellationToken.None,M)}getWindows(){return at.WINDOWS}getWindowCount(){return at.WINDOWS.length}getWindowById(O){const M=this.getWindows().filter(W=>W.id===O);return(0,R.firstOrDefault)(M)}getWindowByWebContents(O){const M=P.BrowserWindow.fromWebContents(O);if(M)return this.getWindowById(M.id)}};ae.WINDOWS=[],e.WindowsMainService=ae=Se([J(2,D.ILogService),J(3,B.ILoggerMainService),J(4,T.IStateService),J(5,F.IPolicyService),J(6,i.IEnvironmentMainService),J(7,N.IUserDataProfilesMainService),J(8,p.ILifecycleMainService),J(9,t.IBackupMainService),J(10,u.IConfigurationService),J(11,le.IWorkspacesHistoryMainService),J(12,G.IWorkspacesManagementMainService),J(13,c.IInstantiationService),J(14,r.IDialogMainService),J(15,n.IFileService),J(16,C.IProtocolMainService),J(17,Q.IThemeMainService)],ae)}),define(ee[304],te([0,1,64,29,82,54]),function(j,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let R=e.WorkspacesMainService=class{constructor(h,l,m,f){this.workspacesManagementMainService=h,this.windowsMainService=l,this.workspacesHistoryMainService=m,this.backupMainService=f,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,l){const m=this.windowsMainService.getWindowById(h);if(m)return this.workspacesManagementMainService.enterWorkspace(m,this.windowsMainService.getWindows(),l)}createUntitledWorkspace(h,l,m){return this.workspacesManagementMainService.createUntitledWorkspace(l,m)}deleteUntitledWorkspace(h,l){return this.workspacesManagementMainService.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(h,l){return this.workspacesManagementMainService.getWorkspaceIdentifier(l)}getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(h,l){return this.workspacesHistoryMainService.addRecentlyOpened(l)}removeRecentlyOpened(h,l){return this.workspacesHistoryMainService.removeRecentlyOpened(l)}clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};e.WorkspacesMainService=R=Se([J(0,A.IWorkspacesManagementMainService),J(1,L.IWindowsMainService),J(2,s.IWorkspacesHistoryMainService),J(3,P.IBackupMainService)],R)}),define(ee[305],te([0,1,14,131,38,27,17,50,13,32,49,45,46,2,15,9,3,11,7,31,145,43,157,109,272,160,64,285,18,75,198,90,132,59,114,218,28,63,94,207,233,208,292,116,209,210,16,222,93,74,6,92,216,297,286,274,20,5,302,67,23,58,293,95,34,277,99,121,26,249,251,52,48,264,289,298,290,299,126,266,267,268,270,275,29,303,276,30,97,82,304,54,273,39,231,53,243,51,81,128,279,291,282,8,253,278,226,66,91,295,269,24,124,294,261,238,83]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o,g,a,b,E,w,t,u,r,i,n,c,p,D,k,C,_,T,U,q,se,ie,ne,ue,le,G,Q,F,N,B,V,Y,ae,oe,O,M,W,H,x,z,$,K,re,ce,ge,ke,Re,Le,Oe,ye,we,Ee,Z,de,fe,Ce,De,Te,We,He,$e,ze,qe,Be,X,he,me,pe,be,Ae,Ue,Ge,Je,Ve,Ye,tt,ot,ct,Lt,gt,At,_t,Ot,Tt,Wt,Ft,Ut,mt,Nt,Bt,zt,$t,qt,pt,Ht,Pt,vt,xt,jt,wt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let It=e.CodeApplication=class extends d.Disposable{constructor(Ie,Pe,ve,_e,Me,Ne,Ke,Xe,Fe,xe,je,Qe){super(),this.mainProcessNodeIpcServer=Ie,this.userEnv=Pe,this.mainInstantiationService=ve,this.logService=_e,this.loggerService=Me,this.environmentMainService=Ne,this.lifecycleMainService=Ke,this.configurationService=Xe,this.stateService=Fe,this.fileService=xe,this.productService=je,this.userDataProfilesMainService=Qe,this.configureSession(),this.registerListeners()}configureSession(){const Ie=Fe=>Fe?.startsWith(`${y.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((Fe,xe,je,Qe)=>Ie(Qe.requestingUrl)?je(Pe.has(xe)):je(!1)),P.session.defaultSession.setPermissionCheckHandler((Fe,xe,je,Qe)=>Ie(Qe.requestingUrl)?Pe.has(xe):!1);const ve=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),_e=Fe=>{for(let xe=Fe;xe;xe=xe.parent)if(xe.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Me=Fe=>Fe.resourceType==="xhr"||_e(Fe.frame),Ne=Fe=>{const xe=Fe.frame;if(!xe||!this.windowsMainService)return!1;const je=P.BrowserWindow.getAllWindows();for(const Qe of je)if(xe.processId===Qe.webContents.mainFrame.processId)return!0;return!1},Ke=(Fe,xe)=>{if(Fe.path!=="/index.html")return!0;const je=xe.frame;if(!je||!this.windowsMainService)return!1;for(const Qe of this.windowsMainService.getWindows())if(Qe.win&&je.processId===Qe.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((Fe,xe)=>{const je=a.URI.parse(Fe.url);return je.scheme===y.Schemas.vscodeWebview&&!Ke(je,Fe)?(this.logService.error("Blocked vscode-webview request",Fe.url),xe({cancel:!0})):je.scheme===y.Schemas.vscodeFileResource&&!Ne(Fe)?(this.logService.error("Blocked vscode-file request",Fe.url),xe({cancel:!0})):je.path.endsWith(".svg")&&!ve.has(je.scheme)?xe({cancel:!Me(Fe)}):xe({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Fe,xe)=>{const je=Fe.responseHeaders,Qe=je["content-type"]||je["Content-Type"];if(Qe&&Array.isArray(Qe)){const Ze=a.URI.parse(Fe.url);if(Ze.path.endsWith(".svg")&&ve.has(Ze.scheme))return je["Content-Type"]=["image/svg+xml"],xe({cancel:!1,responseHeaders:je});if(!Ze.path.endsWith(y.Schemas.vscodeRemoteResource)&&Qe.some(rt=>rt.toLowerCase().includes("image/svg")))return xe({cancel:!Me(Fe)})}return xe({cancel:!1})});const Xe=P.session.defaultSession;typeof Xe.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Xe.setCodeCachePath((0,v.join)(this.environmentMainService.codeCachePath,"chrome")),o.isWindows&&(this.configurationService.getValue("security.restrictUNCAccess")===!1?(0,L.disableUNCAccessRestrictions)():(0,L.addUNCHostToAllowlist)(this.configurationService.getValue("security.allowedUNCHosts")))}registerListeners(){(0,h.setUnexpectedErrorHandler)(ve=>this.onUnexpectedError(ve)),process.on("uncaughtException",ve=>(0,h.onUnexpectedError)(ve)),process.on("unhandledRejection",ve=>(0,h.onUnexpectedError)(ve)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,E.registerContextMenuListener)(),P.app.on("accessibility-support-changed",(ve,_e)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",_e)}),P.app.on("activate",async(ve,_e)=>{this.logService.trace("app#activate"),_e||await this.windowsMainService?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(ve,_e)=>{_e.on("will-navigate",Me=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Me.preventDefault()}),_e.setWindowOpenHandler(({url:Me})=>(this.nativeHostMainService?.openExternal(void 0,Me),{action:"deny"}))});let Ie=[],Pe;P.app.on("open-file",(ve,_e)=>{this.logService.trace("app#open-file: ",_e),ve.preventDefault(),Ie.push((0,Ge.hasWorkspaceFileExtension)(_e)?{workspaceUri:a.URI.file(_e)}:{fileUri:a.URI.file(_e)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:Ie,gotoLineMode:!1,preferNewWindow:!0}),Ie=[],Pe=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),s.validatedIpcMain.handle("vscode:fetchShellEnv",ve=>{const _e=this.windowsMainService?.getWindowByWebContents(ve.sender);let Me,Ne;return _e?.config?(Me=_e.config,Ne={...process.env,..._e.config.userEnv}):(Me=this.environmentMainService.args,Ne=process.env),this.resolveShellEnvironment(Me,Ne,!1)}),s.validatedIpcMain.handle("vscode:writeNlsFile",(ve,_e,Me)=>{const Ne=this.validateNlsPath([_e]);if(!Ne||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ne,R.VSBuffer.fromString(Me))}),s.validatedIpcMain.handle("vscode:readNlsFile",async(ve,..._e)=>{const Me=this.validateNlsPath(_e);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Me)).value.toString()}),s.validatedIpcMain.on("vscode:toggleDevTools",ve=>ve.sender.toggleDevTools()),s.validatedIpcMain.on("vscode:openDevTools",ve=>ve.sender.openDevTools()),s.validatedIpcMain.on("vscode:reloadWindow",ve=>ve.sender.reload())}validateNlsPath(Ie){let Pe;for(const ve of Ie)typeof ve=="string"&&(typeof Pe!="string"?Pe=ve:Pe=(0,v.join)(Pe,ve));if(!(typeof Pe!="string"||!(0,v.isAbsolute)(Pe)||!(0,l.isEqualOrParent)(Pe,this.environmentMainService.cachedLanguagesPath,!o.isLinux)))return a.URI.file(Pe)}onUnexpectedError(Ie){if(Ie){const Pe={message:`[uncaught exception in main]: ${Ie.message}`,stack:Ie.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.logService.error(`[uncaught exception in main]: ${Ie}`),Ie.stack&&this.logService.error(Ie.stack)}async startup(){this.logService.debug("Starting VSCodium"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ie=this.productService.win32AppUserModelId;o.isWindows&&Ie&&P.app.setAppUserModelId(Ie);try{o.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Fe){this.logService.error(Fe)}const Pe=new t.Server;this.lifecycleMainService.onWillShutdown(Fe=>{Fe.reason===2&&Pe.dispose()}),this.logService.trace("Resolving machine identifier...");const ve=await(0,Nt.resolveMachineId)(this.stateService,this.logService);this.logService.trace(`Resolved machine identifier: ${ve}`);const{sharedProcessReady:_e,sharedProcessClient:Me}=this.setupSharedProcess(ve),Ne=await this.initServices(ve,_e);this._register(Ne.createInstance(r.ProxyAuthHandler)),this._register(Ne.createInstance(Ft.UserDataProfilesHandler)),Ne.invokeFunction(Fe=>this.initChannels(Fe,Pe,Me));const Ke=Ne.invokeFunction(Fe=>this.setupProtocolUrlHandlers(Fe,Pe));this.setupManagedRemoteResourceUrlHandler(Pe),this.lifecycleMainService.phase=2,await Ne.invokeFunction(Fe=>this.openFirstWindow(Fe,Ke)),this.lifecycleMainService.phase=3,this.afterWindowOpen(),this._register(new mt.RunOnceScheduler(()=>{this._register((0,mt.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setupProtocolUrlHandlers(Ie,Pe){const ve=this.windowsMainService=Ie.get(be.IWindowsMainService),_e=Ie.get(qe.IURLService),Me=this.nativeHostMainService=Ie.get(ce.INativeHostMainService),Ne=this;_e.registerHandler({async handleURL(Qe,Ze){return Ne.handleProtocolUrl(ve,_e,Qe,Ze)}});const Ke=this._register(new Ue.ActiveWindowManager({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),Xe=new w.StaticRouter(Qe=>Ke.getActiveClientId().then(Ze=>Qe===Ze)),Fe=new Be.URLHandlerRouter(Xe,this.logService),xe=Pe.getChannel("urlHandler",Fe);_e.registerHandler(new Be.URLHandlerChannelClient(xe));const je=this.resolveInitialProtocolUrls();return this._register(new he.ElectronURLListener(je?.urls,_e,ve,this.environmentMainService,this.productService,this.logService)),je}setupManagedRemoteResourceUrlHandler(Ie){const Pe=()=>({statusCode:404,data:"Not found"}),ve=new Vt.Lazy(()=>Ie.getChannel(wt.NODE_REMOTE_RESOURCE_CHANNEL_NAME,new wt.NodeRemoteResourceRouter));P.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(_e,Me)=>{const Ne=a.URI.parse(_e.url);if(!Ne.authority.startsWith("window:"))return Me(Pe());ve.value.call(wt.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME,[Ne]).then(Ke=>Me({...Ke,data:Buffer.from(Ke.body,"base64")}),Ke=>{this.logService.warn("error dispatching remote resource call",Ke),Me({statusCode:500,data:String(Ke)})})})}resolveInitialProtocolUrls(){const Ie=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Ie.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ie);const Pe=global.getOpenUrls()||[];if(Pe.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Pe),Ie.length+Pe.length===0)return;const ve=[];return{urls:[...Ie,...Pe].map(Me=>{try{return{uri:a.URI.parse(Me),originalUrl:Me}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Me);return}}).filter(Me=>{if(!Me)return!1;if(this.shouldBlockURI(Me.uri))return this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Me.uri.toString(!0)),!1;const Ne=this.getWindowOpenableFromProtocolUrl(Me.uri);return Ne?(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Me.uri.toString(!0),Ne),ve.push(Ne),!1):(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Me.uri.toString(!0)),!0)}),openables:ve}}shouldBlockURI(Ie){if(Ie.authority===y.Schemas.file&&o.isWindows){const{options:Pe,buttonIndeces:ve}=(0,qt.massageMessageBoxOptions)({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,S.getPathLabel)(Ie,{os:o.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,i.localize)(3,null)},this.productService);if(ve[P.dialog.showMessageBoxSync(Pe)]===1)return!0}return!1}getWindowOpenableFromProtocolUrl(Ie){if(Ie.path){if(Ie.authority===y.Schemas.file){const Pe=a.URI.file(Ie.fsPath);return(0,Ge.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(Ie.authority===y.Schemas.vscodeRemote){const Pe=Ie.path.indexOf(v.posix.sep,1);if(Pe!==-1){const ve=Ie.path.substring(1,Pe),_e=Ie.path.substring(Pe),Me=a.URI.from({scheme:y.Schemas.vscodeRemote,authority:ve,path:_e,query:Ie.query,fragment:Ie.fragment});return(0,Ge.hasWorkspaceFileExtension)(_e)?{workspaceUri:Me}:/:[\d]+$/.test(_e)?{fileUri:Me}:{folderUri:Me}}}}}async handleProtocolUrl(Ie,Pe,ve,_e){if(this.logService.trace("app#handleProtocolUrl():",ve.toString(!0),_e),ve.scheme===this.productService.urlProtocol&&ve.path==="workspace"&&(ve=ve.with({authority:"file",path:a.URI.parse(ve.query).path,query:""})),this.shouldBlockURI(ve))return this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",ve.toString(!0)),!0;let Me=!1;const Ne=new URLSearchParams(ve.query);Ne.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",ve.toString(!0)),Ne.delete("windowId"),ve=ve.with({query:Ne.toString()}),Me=!0):o.isMacintosh&&Ie.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",ve.toString(!0)),Me=!0);const Ke=Ne.get("continueOn");Ke!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",ve.toString(!0)),Ne.delete("continueOn"),ve=ve.with({query:Ne.toString()}),this.environmentMainService.continueOn=Ke??void 0);const Xe=this.getWindowOpenableFromProtocolUrl(ve);return Xe?(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",Xe,ve.toString(!0)),(0,Pt.firstOrDefault)(await Ie.open({context:5,cli:{...this.environmentMainService.args},urisToOpen:[Xe],forceNewWindow:Me,gotoLineMode:!0}))?.focus(),!0):Me?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",ve.toString(!0)),await(0,Pt.firstOrDefault)(await Ie.open({context:5,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ke.getRemoteAuthority)(ve)}))?.ready(),Pe.open(ve,_e)):(this.logService.trace("app#handleProtocolUrl(): not handled",ve.toString(!0),_e),!1)}setupSharedProcess(Ie){const Pe=this._register(this.mainInstantiationService.createInstance(Re.SharedProcess,Ie)),ve=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Me=await Pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new u.Client(Me,"main")})();return{sharedProcessReady:(async()=>(await Pe.whenReady(),ve))(),sharedProcessClient:ve}}async initServices(Ie,Pe){const ve=new M.ServiceCollection;switch(process.platform){case"win32":ve.set(De.IUpdateService,new oe.SyncDescriptor(ze.Win32UpdateService));break;case"linux":o.isLinuxSnap?ve.set(De.IUpdateService,new oe.SyncDescriptor($e.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ve.set(De.IUpdateService,new oe.SyncDescriptor(He.LinuxUpdateService));break;case"darwin":ve.set(De.IUpdateService,new oe.SyncDescriptor(We.DarwinUpdateService));break}ve.set(be.IWindowsMainService,new oe.SyncDescriptor(Ae.WindowsMainService,[Ie,this.userEnv],!1));const _e=new T.DialogMainService(this.logService,this.productService);ve.set(T.IDialogMainService,_e),ve.set(z.ILaunchMainService,new oe.SyncDescriptor(z.LaunchMainService,void 0,!1)),ve.set(_.IDiagnosticsMainService,new oe.SyncDescriptor(_.DiagnosticsMainService,void 0,!1)),ve.set(C.IDiagnosticsService,w.ProxyChannel.toService((0,w.getDelayedChannel)(Pe.then(Fe=>Fe.getChannel("diagnostics"))))),ve.set(W.IIssueMainService,new oe.SyncDescriptor(H.IssueMainService,[this.userEnv])),ve.set(U.IEncryptionMainService,new oe.SyncDescriptor(q.EncryptionMainService,[Ie])),ve.set(x.IKeyboardLayoutMainService,new oe.SyncDescriptor(x.KeyboardLayoutMainService)),ve.set(ce.INativeHostMainService,new oe.SyncDescriptor(ce.NativeHostMainService,void 0,!1)),ve.set(D.ICredentialsMainService,new oe.SyncDescriptor(ot.CredentialsNativeMainService)),ve.set(me.IWebviewManagerService,new oe.SyncDescriptor(pe.WebviewMainService)),ve.set(re.IMenubarMainService,new oe.SyncDescriptor(re.MenubarMainService)),ve.set(ue.IExtensionUrlTrustService,new oe.SyncDescriptor(le.ExtensionUrlTrustService)),ve.set(G.IExtensionHostStarter,new oe.SyncDescriptor(Q.ExtensionHostStarter)),ve.set(we.IStorageMainService,new oe.SyncDescriptor(we.StorageMainService)),ve.set(we.IApplicationStorageMainService,new oe.SyncDescriptor(we.ApplicationStorageMainService));const Me=new xt.ElectronPtyHostStarter({graceTime:6e4,shortGraceTime:6e3,scrollback:this.configurationService.getValue("terminal.integrated.persistentSessionScrollback")??100},this.configurationService,this.environmentMainService,this.lifecycleMainService,this.logService),Ne=new jt.PtyHostService(Me,this.configurationService,this.logService,this.loggerService);ve.set(vt.ILocalPtyService,Ne),o.isWindows?ve.set(F.IExternalTerminalMainService,new oe.SyncDescriptor(N.WindowsExternalTerminalService)):o.isMacintosh?ve.set(F.IExternalTerminalMainService,new oe.SyncDescriptor(N.MacExternalTerminalService)):o.isLinux&&ve.set(F.IExternalTerminalMainService,new oe.SyncDescriptor(N.LinuxExternalTerminalService));const Ke=new c.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);ve.set(n.IBackupMainService,Ke);const Xe=new tt.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,Ke,_e);if(ve.set(tt.IWorkspacesManagementMainService,Xe),ve.set(Je.IWorkspacesService,new oe.SyncDescriptor(Ye.WorkspacesMainService,void 0,!1)),ve.set(Ve.IWorkspacesHistoryMainService,new oe.SyncDescriptor(Ve.WorkspacesHistoryMainService,void 0,!1)),ve.set(qe.IURLService,new oe.SyncDescriptor(X.NativeURLService,void 0,!1)),(0,Ce.supportsTelemetry)(this.productService,this.environmentMainService)){const Fe=(0,Ce.isInternalTelemetry)(this.productService,this.configurationService),xe=(0,w.getDelayedChannel)(Pe.then(it=>it.getChannel("telemetryAppender"))),je=new de.TelemetryAppenderClient(xe),Qe=(0,Ee.resolveCommonProperties)((0,A.release)(),(0,A.hostname)(),process.arch,this.productService.commit,this.productService.version,Ie,Fe),Ze=(0,Ce.getPiiPathsFromEnvironment)(this.environmentMainService),rt={appenders:[je],commonProperties:Qe,piiPaths:Ze,sendErrorTelemetry:!0};ve.set(Z.ITelemetryService,new oe.SyncDescriptor(fe.TelemetryService,[rt],!1))}else ve.set(Z.ITelemetryService,Ce.NullTelemetryService);return ve.set(Ot.IExtensionsProfileScannerService,new oe.SyncDescriptor(Bt.ExtensionsProfileScannerService,void 0,!0)),ve.set(Tt.IExtensionsScannerService,new oe.SyncDescriptor(Wt.ExtensionsScannerService,void 0,!0)),ve.set(pt.IUtilityProcessWorkerMainService,new oe.SyncDescriptor(pt.UtilityProcessWorkerMainService,void 0,!0)),await mt.Promises.settled([Ke.initialize(),Xe.initialize()]),this.mainInstantiationService.createChild(ve)}initChannels(Ie,Pe,ve){const _e=w.ProxyChannel.fromService(Ie.get(z.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",_e);const Me=w.ProxyChannel.fromService(Ie.get(_.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Me);const Ne=new Lt.PolicyChannel(Ie.get(ct.IPolicyService));Pe.registerChannel("policy",Ne),ve.then(et=>et.registerChannel("policy",Ne));const Ke=this.fileService.getProvider(y.Schemas.file);(0,g.assertType)(Ke instanceof ae.DiskFileSystemProvider);const Xe=new Y.DiskFileSystemProviderChannel(Ke,this.logService,this.environmentMainService);Pe.registerChannel(B.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Xe),ve.then(et=>et.registerChannel(B.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Xe));const Fe=w.ProxyChannel.fromService(Ie.get(gt.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",Fe),ve.then(et=>et.registerChannel("userDataProfiles",Fe));const xe=new At.RequestChannel(Ie.get(_t.IRequestService));ve.then(et=>et.registerChannel("request",xe));const je=new Te.UpdateChannel(Ie.get(De.IUpdateService));Pe.registerChannel("update",je);const Qe=w.ProxyChannel.fromService(Ie.get(W.IIssueMainService));Pe.registerChannel("issue",Qe);const Ze=w.ProxyChannel.fromService(Ie.get(U.IEncryptionMainService));Pe.registerChannel("encryption",Ze);const rt=w.ProxyChannel.fromService(Ie.get(D.ICredentialsMainService));Pe.registerChannel("credentials",rt);const it=w.ProxyChannel.fromService(Ie.get(Le.ISignService));Pe.registerChannel("sign",it);const lt=w.ProxyChannel.fromService(Ie.get(x.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",lt),this.nativeHostMainService=Ie.get(ce.INativeHostMainService);const Ct=w.ProxyChannel.fromService(this.nativeHostMainService);Pe.registerChannel("nativeHost",Ct),ve.then(et=>et.registerChannel("nativeHost",Ct));const Gt=w.ProxyChannel.fromService(Ie.get(Je.IWorkspacesService));Pe.registerChannel("workspaces",Gt);const Kt=w.ProxyChannel.fromService(Ie.get(re.IMenubarMainService));Pe.registerChannel("menubar",Kt);const Qt=w.ProxyChannel.fromService(Ie.get(qe.IURLService));Pe.registerChannel("url",Qt);const Yt=w.ProxyChannel.fromService(Ie.get(ue.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",Yt);const Xt=w.ProxyChannel.fromService(Ie.get(me.IWebviewManagerService));Pe.registerChannel("webview",Xt);const kt=this._register(new ye.StorageDatabaseChannel(this.logService,Ie.get(we.IStorageMainService)));Pe.registerChannel("storage",kt),ve.then(et=>et.registerChannel("storage",kt));const Jt=this._register(new Ut.ProfileStorageChangesListenerChannel(Ie.get(we.IStorageMainService),Ie.get(gt.IUserDataProfilesMainService),this.logService));ve.then(et=>et.registerChannel("profileStorageListener",Jt));const Zt=w.ProxyChannel.fromService(Ie.get(vt.ILocalPtyService));Pe.registerChannel(vt.TerminalIpcChannels.LocalPty,Zt);const ei=w.ProxyChannel.fromService(Ie.get(F.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",ei);const Dt=new zt.LoggerChannel(Ie.get($t.ILoggerMainService));Pe.registerChannel("logger",Dt),ve.then(et=>et.registerChannel("logger",Dt));const ti=new k.ElectronExtensionHostDebugBroadcastChannel(Ie.get(be.IWindowsMainService));Pe.registerChannel("extensionhostdebugservice",ti);const ii=w.ProxyChannel.fromService(Ie.get(G.IExtensionHostStarter));Pe.registerChannel(G.ipcExtensionHostStarterChannelName,ii);const ni=w.ProxyChannel.fromService(Ie.get(pt.IUtilityProcessWorkerMainService));Pe.registerChannel(Ht.ipcUtilityProcessWorkerChannelName,ni)}async openFirstWindow(Ie,Pe){const ve=this.windowsMainService=Ie.get(be.IWindowsMainService),_e=(0,ie.isLaunchedFromCli)(process.env)?0:4,Me=this.environmentMainService.args;if(Pe){if(Pe.openables.length>0)return ve.open({context:_e,cli:Me,urisToOpen:Pe.openables,gotoLineMode:!0,initialStartup:!0});if(Pe.urls.length>0)for(const it of Pe.urls){const lt=new URLSearchParams(it.uri.query);if(lt.get("windowId")==="_blank")return lt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:lt.toString()}),ve.open({context:_e,cli:Me,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ne=global.macOpenFiles,Ke=Me._.length,Xe=!!Me["folder-uri"],Fe=!!Me["file-uri"],xe=Me["skip-add-to-recently-opened"]===!0,je=Me.wait&&Me.waitMarkerFilePath?a.URI.file(Me.waitMarkerFilePath):void 0,Qe=Me.remote||void 0,Ze=Me.profile,rt=Me["profile-temp"];if(!Ke&&!Xe&&!Fe){if(Me["new-window"]||Ze||rt)return ve.open({context:_e,cli:Me,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:xe,waitMarkerFileURI:je,initialStartup:!0,remoteAuthority:Qe,forceProfile:Ze,forceTempProfile:rt});if(Ne.length)return ve.open({context:1,cli:Me,urisToOpen:Ne.map(it=>(0,Ge.hasWorkspaceFileExtension)(it)?{workspaceUri:a.URI.file(it)}:{fileUri:a.URI.file(it)}),noRecentEntry:xe,waitMarkerFileURI:je,initialStartup:!0})}return ve.open({context:_e,cli:Me,forceNewWindow:Me["new-window"]||!Ke&&Me["unity-launch"],diffMode:Me.diff,mergeMode:Me.merge,noRecentEntry:xe,waitMarkerFileURI:je,gotoLineMode:Me.goto,initialStartup:!0,remoteAuthority:Qe,forceProfile:Ze,forceTempProfile:rt})}afterWindowOpen(){this.installMutex(),P.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Ie,Pe)=>{Pe({url:Ie.url.replace(/^vscode-remote-resource:/,"http:"),method:Ie.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement(),o.isMacintosh&&P.app.runningUnderARM64Translation&&this.windowsMainService?.sendToFocused("vscode:showTranslatedBuildWarning")}async installMutex(){const Ie=this.productService.win32MutexName;if(o.isWindows&&Ie)try{const Pe=await new Promise((_e,Me)=>{j(["@vscode/windows-mutex"],_e,Me)}),ve=new Pe.Mutex(Ie);(0,m.once)(this.lifecycleMainService.onWillShutdown)(()=>ve.release())}catch(Pe){this.logService.error(Pe)}}async resolveShellEnvironment(Ie,Pe,ve){try{return await(0,ne.getResolvedShellEnv)(this.configurationService,this.logService,Ie,Pe)}catch(_e){const Me=(0,I.toErrorMessage)(_e);ve?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Me):this.logService.error(Me)}return{}}async updateCrashReporterEnablement(){try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),ve=JSON.parse((0,f.stripComments)(Pe)),Me=(0,Ce.getTelemetryLevel)(this.configurationService)>=1;if(ve["enable-crash-reporter"]===void 0){const Ne=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Me},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,b.generateUuid)()}"`,"}"],Ke=Pe.substring(0,Pe.length-2).concat(`,
`,Ne.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(Ke))}else{const Ne=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Me},`);Ne!==Pe&&await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(Ne))}}catch(Ie){this.logService.error(Ie)}}};e.CodeApplication=It=Se([J(2,O.IInstantiationService),J(3,K.ILogService),J(4,K.ILoggerService),J(5,se.IEnvironmentMainService),J(6,$.ILifecycleMainService),J(7,p.IConfigurationService),J(8,Oe.IStateService),J(9,V.IFileService),J(10,ge.IProductService),J(11,gt.IUserDataProfilesMainService)],It)}),define(ee[311],te([0,1,14,42,7,24,8,50,13,32,49,46,15,9,65,3,36,25,22,43,130,305,10,18,237,248,28,63,200,16,220,93,74,215,92,20,223,5,77,23,78,280,125,262,51,288,95,247,34,52,79,53,39,232,230,2,40,265,66,225,91,120,263]),function(j,e,P,L,s,A,R,I,h,l,m,f,S,d,y,v,o,g,a,b,E,w,t,u,r,i,n,c,p,D,k,C,_,T,U,q,se,ie,ne,ue,le,G,Q,F,N,B,V,Y,ae,oe,O,M,W,H,x,z,$,K,re,ce,ge,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Re{main(){try{this.startup()}catch(ye){console.error(ye.message),P.app.exit(1)}}async startup(){(0,h.setUnexpectedErrorHandler)(Te=>console.error(Te));const[ye,we,Ee,Z,de,fe,Ce,De]=this.createServices();try{try{await this.initServices(Ee,De,Z,de,Ce)}catch(Te){throw this.handleStartupDataDirError(Ee,Ce,Te),Te}await ye.invokeFunction(async Te=>{const We=Te.get(ie.ILogService),He=Te.get(q.ILifecycleMainService),$e=Te.get(D.IFileService),ze=Te.get(ie.ILoggerService),qe=await this.claimInstance(We,Ee,He,ye,Ce,!0);return a.Promises.writeFile(Ee.mainLockfile,String(process.pid)).catch(Be=>{We.warn(`app#startup(): Error writing main lockfile: ${Be.stack}`)}),fe.logger=ze.createLogger("main",{name:(0,t.localize)(0,null)}),(0,m.once)(He.onWillShutdown)(Be=>{$e.dispose(),Z.dispose(),Be.join("instanceLockfile",a.Promises.unlink(Ee.mainLockfile).catch(()=>{}))}),ye.createInstance(w.CodeApplication,qe,we).startup()})}catch(Te){ye.invokeFunction(this.quit,Te)}}createServices(){const ye=new U.ServiceCollection,we=new z.DisposableStore;process.once("exit",()=>we.dispose());const Ee={_serviceBrand:void 0,...ne.default};ye.set(ue.IProductService,Ee);const Z=new n.EnvironmentMainService(this.resolveArgs(),Ee),de=this.patchEnvironment(Z);ye.set(n.IEnvironmentMainService,Z);const fe=new re.LoggerMainService((0,ie.getLogLevel)(Z),Z.logsHome);ye.set(re.ILoggerMainService,fe);const Ce=new se.BufferLogger(fe.getLogLevel()),De=we.add(new ce.LogService(Ce,[new ie.ConsoleMainLogger(fe.getLogLevel())]));ye.set(ie.ILogService,De);const Te=new k.FileService(De);ye.set(D.IFileService,Te);const We=new C.DiskFileSystemProvider(De);Te.registerProvider(S.Schemas.file,We);const He=new K.UriIdentityService(Te);ye.set($.IUriIdentityService,He);const $e=new ke.StateService(1,Z,De,Te);ye.set(ae.IStateReadService,$e),ye.set(ae.IStateService,$e);const ze=new M.UserDataProfilesMainService($e,He,Z,Te,De);ye.set(M.IUserDataProfilesMainService,ze);const qe=v.isWindows&&Ee.win32RegValueName?we.add(new H.NativePolicyService(De,Ee.win32RegValueName)):Z.policyFile?we.add(new x.FilePolicyService(Z.policyFile,Te,De)):new W.NullPolicyService;ye.set(W.IPolicyService,qe);const Be=new r.ConfigurationService(ze.defaultProfile.settingsResource,Te,qe,De);return ye.set(u.IConfigurationService,Be),ye.set(q.ILifecycleMainService,new _.SyncDescriptor(q.LifecycleMainService,void 0,!1)),ye.set(N.IRequestService,new _.SyncDescriptor(B.RequestMainService,void 0,!0)),ye.set(O.IThemeMainService,new _.SyncDescriptor(O.ThemeMainService)),ye.set(V.ISignService,new _.SyncDescriptor(Y.SignService,void 0,!1)),ye.set(Q.ITunnelService,new _.SyncDescriptor(F.TunnelService)),ye.set(le.IProtocolMainService,new G.ProtocolMainService(Z,ze,De)),[new T.InstantiationService(ye,!0),de,Z,Be,$e,Ce,Ee,ze]}patchEnvironment(ye){const we={VSCODE_IPC_HOOK:ye.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ee=>{const Z=process.env[Ee];typeof Z=="string"&&(we[Ee]=Z)}),Object.assign(process.env,we),we}async initServices(ye,we,Ee,Z,de){await R.Promises.settled([Promise.all([ye.extensionsPath,ye.codeCachePath,ye.logsHome.fsPath,we.defaultProfile.globalStorageHome.fsPath,ye.workspaceStorageHome.fsPath,ye.localHistoryHome.fsPath,ye.backupHome].map(fe=>fe?a.Promises.mkdir(fe,{recursive:!0}):void 0)),Z.init(),Ee.initialize()]),we.init()}async claimInstance(ye,we,Ee,Z,de,fe){let Ce;try{(0,y.mark)("code/willStartMainServer"),Ce=await(0,E.serve)(we.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,m.once)(Ee.onWillShutdown)(()=>Ce.dispose())}catch(De){if(De.code!=="EADDRINUSE")throw this.handleStartupDataDirError(we,de,De),De;let Te;try{Te=await(0,E.connect)(we.mainIPCHandle,"main")}catch(ze){if(!fe||v.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.showStartupWarningDialog((0,t.localize)(1,null,de.nameShort),(0,t.localize)(2,null),de),ze;try{(0,L.unlinkSync)(we.mainIPCHandle)}catch(qe){throw ye.warn("Could not delete obsolete instance handle",qe),qe}return this.claimInstance(ye,we,Ee,Z,de,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const ze=`Running extension tests from the command line is currently only supported if no other instance of ${de.nameShort} is running.`;throw ye.error(ze),Te.dispose(),new Error(ze)}let We;!we.args.wait&&!we.args.status&&(We=setTimeout(()=>{this.showStartupWarningDialog((0,t.localize)(3,null,de.nameShort),(0,t.localize)(4,null),de)},1e4));const He=b.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),$e=b.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return Z.invokeFunction(async()=>{const ze=new i.DiagnosticsService(oe.NullTelemetryService,de),qe=await $e.getMainDiagnostics(),Be=await $e.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),X=await ze.getDiagnostics(qe,Be);throw console.log(X),new h.ExpectedError});throw v.isWindows&&await this.windowsAllowSetForegroundWindow(He,ye),ye.trace("Sending env to running instance..."),await He.start(we.args,process.env),Te.dispose(),We&&clearTimeout(We),new h.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw console.log((0,t.localize)(5,null,de.nameShort)),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ce}handleStartupDataDirError(ye,we,Ee){if(Ee.code==="EACCES"||Ee.code==="EPERM"){const Z=(0,A.coalesce)([ye.userDataPath,ye.extensionsPath,E.XDG_RUNTIME_DIR]).map(de=>(0,f.getPathLabel)(s.URI.file(de),{os:v.OS,tildify:ye}));this.showStartupWarningDialog((0,t.localize)(6,null),(0,t.localize)(7,null,(0,I.toErrorMessage)(Ee),Z.join(`
`)),we)}}showStartupWarningDialog(ye,we,Ee){P.dialog.showMessageBoxSync((0,ge.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ye,detail:we},Ee).options)}async windowsAllowSetForegroundWindow(ye,we){if(v.isWindows){const Ee=await ye.getMainProcessId();we.trace("Sending some foreground love to the running instance:",Ee);try{(await new Promise((Z,de)=>{j(["windows-foreground-love"],Z,de)})).allowSetForegroundWindow(Ee)}catch(Z){we.error(Z)}}}quit(ye,we){const Ee=ye.get(ie.ILogService),Z=ye.get(q.ILifecycleMainService);let de=0;we&&(we.isExpected?we.message&&Ee.trace(we.message):(de=1,we.stack?Ee.error(we.stack):Ee.error(`Startup error: ${we.toString()}`))),Z.kill(de)}resolveArgs(){const ye=this.validatePaths((0,c.parseMainProcessArgv)(process.argv));if(ye.wait&&!ye.waitMarkerFilePath){const we=(0,p.createWaitMarkerFileSync)(ye.verbose);we&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",we),ye.waitMarkerFilePath=we)}return ye}validatePaths(ye){if(ye["open-url"]&&(ye._urls=ye._,ye._=[]),!ye.remote){const we=this.doValidatePaths(ye._,ye.goto);ye._=we}return ye}doValidatePaths(ye,we){const Ee=(0,o.cwd)(),Z=ye.map(Ce=>{let De=String(Ce),Te;we&&(Te=(0,l.parseLineAndColumnAware)(De),De=Te.path),De&&(De=this.preparePath(Ee,De));const We=(0,l.sanitizeFilePath)(De,Ee),He=(0,d.basename)(We);return He&&!(0,l.isValidBasename)(He)?null:we&&Te?(Te.path=We,this.toPath(Te)):We}),de=v.isWindows||v.isMacintosh,fe=(0,A.distinct)(Z,Ce=>Ce&&de?Ce.toLowerCase():Ce||"");return(0,A.coalesce)(fe)}preparePath(ye,we){return v.isWindows&&(we=(0,g.rtrim)(we,'"')),we=(0,g.trim)((0,g.trim)(we," "),"	"),v.isWindows&&(we=(0,d.resolve)(ye,we),we=(0,g.rtrim)(we,".")),we}toPath(ye){const we=[ye.path];return typeof ye.line=="number"&&we.push(String(ye.line)),typeof ye.column=="number"&&we.push(String(ye.column)),we.join(":")}}new Re().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9d3b0fa210fb4535589e8296483a5b43fe5e660a/core/vs/code/electron-main/main.js.map
