/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/nls","vs/base/common/arrays","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/lazy","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],me=function(ee){for(var t=[],E=0,I=ee.length;E<I;E++)t[E]=ge[ee[E]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function $t(ee){if(Array.isArray(ee)){for(var t=0,E=Array(ee.length);t<ee.length;t++)E[t]=ee[t];return E}else return Array.from(ee)}var Vt=Object.hasOwnProperty,It=Object.setPrototypeOf,Kt=Object.isFrozen,qt=Object.getPrototypeOf,jt=Object.getOwnPropertyDescriptor,tt=Object.freeze,lt=Object.seal,Gt=Object.create,Nt=typeof Reflect<"u"&&Reflect,Dt=Nt.apply,Et=Nt.construct;Dt||(Dt=function(t,E,I){return t.apply(E,I)}),tt||(tt=function(t){return t}),lt||(lt=function(t){return t}),Et||(Et=function(t,E){return new(Function.prototype.bind.apply(t,[null].concat($t(E))))});var Yt=st(Array.prototype.forEach),kt=st(Array.prototype.pop),gt=st(Array.prototype.push),ct=st(String.prototype.toLowerCase),Pt=st(String.prototype.match),ut=st(String.prototype.replace),Xt=st(String.prototype.indexOf),Zt=st(String.prototype.trim),at=st(RegExp.prototype.test),Rt=Qt(TypeError);function st(ee){return function(t){for(var E=arguments.length,I=Array(E>1?E-1:0),i=1;i<E;i++)I[i-1]=arguments[i];return Dt(ee,t,I)}}function Qt(ee){return function(){for(var t=arguments.length,E=Array(t),I=0;I<t;I++)E[I]=arguments[I];return Et(ee,E)}}function Be(ee,t){It&&It(ee,null);for(var E=t.length;E--;){var I=t[E];if(typeof I=="string"){var i=ct(I);i!==I&&(Kt(t)||(t[E]=i),I=i)}ee[I]=!0}return ee}function ht(ee){var t=Gt(null),E=void 0;for(E in ee)Dt(Vt,ee,[E])&&(t[E]=ee[E]);return t}function wt(ee,t){for(;ee!==null;){var E=jt(ee,t);if(E){if(E.get)return st(E.get);if(typeof E.value=="function")return st(E.value)}ee=qt(ee)}function I(i){return console.warn("fallback value for",i),null}return I}var Mt=tt(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),St=tt(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ct=tt(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Jt=tt(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),At=tt(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),ei=tt(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ot=tt(["#text"]),Bt=tt(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Tt=tt(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),xt=tt(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=tt(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ti=lt(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ii=lt(/<%[\s\S]*|[\s\S]*%>/gm),ni=lt(/^data-[\-\w.\u00B7-\uFFFF]/),si=lt(/^aria-[\-\w]+$/),ri=lt(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),oi=lt(/^(?:\w+script|data):/i),li=lt(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),mt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(ee){return typeof ee}:function(ee){return ee&&typeof Symbol=="function"&&ee.constructor===Symbol&&ee!==Symbol.prototype?"symbol":typeof ee};function ot(ee){if(Array.isArray(ee)){for(var t=0,E=Array(ee.length);t<ee.length;t++)E[t]=ee[t];return E}else return Array.from(ee)}var ai=function(){return typeof window>"u"?null:window},ui=function(t,E){if((typeof t>"u"?"undefined":mt(t))!=="object"||typeof t.createPolicy!="function")return null;var I=null,i="data-tt-policy-suffix";E.currentScript&&E.currentScript.hasAttribute(i)&&(I=E.currentScript.getAttribute(i));var W="dompurify"+(I?"#"+I:"");try{return t.createPolicy(W,{createHTML:function(y){return y}})}catch{return console.warn("TrustedTypes policy "+W+" could not be created."),null}};function Ht(){var ee=arguments.length>0&&arguments[0]!==void 0?arguments[0]:ai(),t=function(he){return Ht(he)};if(t.version="2.3.1",t.removed=[],!ee||!ee.document||ee.document.nodeType!==9)return t.isSupported=!1,t;var E=ee.document,I=ee.document,i=ee.DocumentFragment,W=ee.HTMLTemplateElement,w=ee.Node,y=ee.Element,c=ee.NodeFilter,u=ee.NamedNodeMap,d=u===void 0?ee.NamedNodeMap||ee.MozNamedAttrMap:u,P=ee.Text,r=ee.Comment,l=ee.DOMParser,e=ee.trustedTypes,a=y.prototype,n=wt(a,"cloneNode"),h=wt(a,"nextSibling"),s=wt(a,"childNodes"),p=wt(a,"parentNode");if(typeof W=="function"){var v=I.createElement("template");v.content&&v.content.ownerDocument&&(I=v.content.ownerDocument)}var C=ui(e,E),f=C&&te?C.createHTML(""):"",D=I,M=D.implementation,R=D.createNodeIterator,g=D.createDocumentFragment,m=D.getElementsByTagName,L=E.importNode,k={};try{k=ht(I).documentMode?I.documentMode:{}}catch{}var A={};t.isSupported=typeof p=="function"&&M&&typeof M.createHTMLDocument<"u"&&k!==9;var H=ti,G=ii,ne=ni,se=si,de=oi,ue=li,re=ri,le=null,ye=Be({},[].concat(ot(Mt),ot(St),ot(Ct),ot(At),ot(Ot))),Te=null,Me=Be({},[].concat(ot(Bt),ot(Tt),ot(xt),ot(yt))),Oe=null,ce=null,ie=!0,q=!0,$=!1,V=!1,_=!1,K=!1,z=!1,o=!1,F=!1,j=!0,te=!1,S=!0,T=!0,O=!1,b={},x=null,B=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),N=null,U=Be({},["audio","video","img","source","image","track"]),Y=null,J=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),oe="http://www.w3.org/1998/Math/MathML",be="http://www.w3.org/2000/svg",De="http://www.w3.org/1999/xhtml",Le=De,Se=!1,ve=null,ke=I.createElement("form"),Ie=function(he){ve&&ve===he||((!he||(typeof he>"u"?"undefined":mt(he))!=="object")&&(he={}),he=ht(he),le="ALLOWED_TAGS"in he?Be({},he.ALLOWED_TAGS):ye,Te="ALLOWED_ATTR"in he?Be({},he.ALLOWED_ATTR):Me,Y="ADD_URI_SAFE_ATTR"in he?Be(ht(J),he.ADD_URI_SAFE_ATTR):J,N="ADD_DATA_URI_TAGS"in he?Be(ht(U),he.ADD_DATA_URI_TAGS):U,x="FORBID_CONTENTS"in he?Be({},he.FORBID_CONTENTS):B,Oe="FORBID_TAGS"in he?Be({},he.FORBID_TAGS):{},ce="FORBID_ATTR"in he?Be({},he.FORBID_ATTR):{},b="USE_PROFILES"in he?he.USE_PROFILES:!1,ie=he.ALLOW_ARIA_ATTR!==!1,q=he.ALLOW_DATA_ATTR!==!1,$=he.ALLOW_UNKNOWN_PROTOCOLS||!1,V=he.SAFE_FOR_TEMPLATES||!1,_=he.WHOLE_DOCUMENT||!1,o=he.RETURN_DOM||!1,F=he.RETURN_DOM_FRAGMENT||!1,j=he.RETURN_DOM_IMPORT!==!1,te=he.RETURN_TRUSTED_TYPE||!1,z=he.FORCE_BODY||!1,S=he.SANITIZE_DOM!==!1,T=he.KEEP_CONTENT!==!1,O=he.IN_PLACE||!1,re=he.ALLOWED_URI_REGEXP||re,Le=he.NAMESPACE||De,V&&(q=!1),F&&(o=!0),b&&(le=Be({},[].concat(ot(Ot))),Te=[],b.html===!0&&(Be(le,Mt),Be(Te,Bt)),b.svg===!0&&(Be(le,St),Be(Te,Tt),Be(Te,yt)),b.svgFilters===!0&&(Be(le,Ct),Be(Te,Tt),Be(Te,yt)),b.mathMl===!0&&(Be(le,At),Be(Te,xt),Be(Te,yt))),he.ADD_TAGS&&(le===ye&&(le=ht(le)),Be(le,he.ADD_TAGS)),he.ADD_ATTR&&(Te===Me&&(Te=ht(Te)),Be(Te,he.ADD_ATTR)),he.ADD_URI_SAFE_ATTR&&Be(Y,he.ADD_URI_SAFE_ATTR),he.FORBID_CONTENTS&&(x===B&&(x=ht(x)),Be(x,he.FORBID_CONTENTS)),T&&(le["#text"]=!0),_&&Be(le,["html","head","body"]),le.table&&(Be(le,["tbody"]),delete Oe.tbody),tt&&tt(he),ve=he)},Ke=Be({},["mi","mo","mn","ms","mtext"]),xe=Be({},["foreignobject","desc","title","annotation-xml"]),We=Be({},St);Be(We,Ct),Be(We,Jt);var Je=Be({},At);Be(Je,ei);var it=function(he){var _e=p(he);(!_e||!_e.tagName)&&(_e={namespaceURI:De,tagName:"template"});var Ne=ct(he.tagName),He=ct(_e.tagName);if(he.namespaceURI===be)return _e.namespaceURI===De?Ne==="svg":_e.namespaceURI===oe?Ne==="svg"&&(He==="annotation-xml"||Ke[He]):!!We[Ne];if(he.namespaceURI===oe)return _e.namespaceURI===De?Ne==="math":_e.namespaceURI===be?Ne==="math"&&xe[He]:!!Je[Ne];if(he.namespaceURI===De){if(_e.namespaceURI===be&&!xe[He]||_e.namespaceURI===oe&&!Ke[He])return!1;var Xe=Be({},["title","style","font","a","script"]);return!Je[Ne]&&(Xe[Ne]||!We[Ne])}return!1},Re=function(he){gt(t.removed,{element:he});try{he.parentNode.removeChild(he)}catch{try{he.outerHTML=f}catch{he.remove()}}},Ve=function(he,_e){try{gt(t.removed,{attribute:_e.getAttributeNode(he),from:_e})}catch{gt(t.removed,{attribute:null,from:_e})}if(_e.removeAttribute(he),he==="is"&&!Te[he])if(o||F)try{Re(_e)}catch{}else try{_e.setAttribute(he,"")}catch{}},X=function(he){var _e=void 0,Ne=void 0;if(z)he="<remove></remove>"+he;else{var He=Pt(he,/^[\r\n\t ]+/);Ne=He&&He[0]}var Xe=C?C.createHTML(he):he;if(Le===De)try{_e=new l().parseFromString(Xe,"text/html")}catch{}if(!_e||!_e.documentElement){_e=M.createDocument(Le,"template",null);try{_e.documentElement.innerHTML=Se?"":Xe}catch{}}var Ze=_e.body||_e.documentElement;return he&&Ne&&Ze.insertBefore(I.createTextNode(Ne),Ze.childNodes[0]||null),Le===De?m.call(_e,_?"html":"body")[0]:_?_e.documentElement:Ze},ae=function(he){return R.call(he.ownerDocument||he,he,c.SHOW_ELEMENT|c.SHOW_COMMENT|c.SHOW_TEXT,null,!1)},pe=function(he){return he instanceof P||he instanceof r?!1:typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof d)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"},we=function(he){return(typeof w>"u"?"undefined":mt(w))==="object"?he instanceof w:he&&(typeof he>"u"?"undefined":mt(he))==="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},Ee=function(he,_e,Ne){A[he]&&Yt(A[he],function(He){He.call(t,_e,Ne,ve)})},Pe=function(he){var _e=void 0;if(Ee("beforeSanitizeElements",he,null),pe(he)||Pt(he.nodeName,/[\u0080-\uFFFF]/))return Re(he),!0;var Ne=ct(he.nodeName);if(Ee("uponSanitizeElement",he,{tagName:Ne,allowedTags:le}),!we(he.firstElementChild)&&(!we(he.content)||!we(he.content.firstElementChild))&&at(/<[/\w]/g,he.innerHTML)&&at(/<[/\w]/g,he.textContent)||Ne==="select"&&at(/<template/i,he.innerHTML))return Re(he),!0;if(!le[Ne]||Oe[Ne]){if(T&&!x[Ne]){var He=p(he)||he.parentNode,Xe=s(he)||he.childNodes;if(Xe&&He)for(var Ze=Xe.length,Qe=Ze-1;Qe>=0;--Qe)He.insertBefore(n(Xe[Qe],!0),h(he))}return Re(he),!0}return he instanceof y&&!it(he)||(Ne==="noscript"||Ne==="noembed")&&at(/<\/no(script|embed)/i,he.innerHTML)?(Re(he),!0):(V&&he.nodeType===3&&(_e=he.textContent,_e=ut(_e,H," "),_e=ut(_e,G," "),he.textContent!==_e&&(gt(t.removed,{element:he.cloneNode()}),he.textContent=_e)),Ee("afterSanitizeElements",he,null),!1)},Ue=function(he,_e,Ne){if(S&&(_e==="id"||_e==="name")&&(Ne in I||Ne in ke))return!1;if(!(q&&!ce[_e]&&at(ne,_e))){if(!(ie&&at(se,_e))){if(!Te[_e]||ce[_e])return!1;if(!Y[_e]){if(!at(re,ut(Ne,ue,""))){if(!((_e==="src"||_e==="xlink:href"||_e==="href")&&he!=="script"&&Xt(Ne,"data:")===0&&N[he])){if(!($&&!at(de,ut(Ne,ue,"")))){if(Ne)return!1}}}}}}return!0},Ge=function(he){var _e=void 0,Ne=void 0,He=void 0,Xe=void 0;Ee("beforeSanitizeAttributes",he,null);var Ze=he.attributes;if(Ze){var Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:Te};for(Xe=Ze.length;Xe--;){_e=Ze[Xe];var rt=_e,dt=rt.name,pt=rt.namespaceURI;if(Ne=Zt(_e.value),He=ct(dt),Qe.attrName=He,Qe.attrValue=Ne,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,Ee("uponSanitizeAttribute",he,Qe),Ne=Qe.attrValue,!Qe.forceKeepAttr&&(Ve(dt,he),!!Qe.keepAttr)){if(at(/\/>/i,Ne)){Ve(dt,he);continue}V&&(Ne=ut(Ne,H," "),Ne=ut(Ne,G," "));var Ft=he.nodeName.toLowerCase();if(Ue(Ft,He,Ne))try{pt?he.setAttributeNS(pt,dt,Ne):he.setAttribute(dt,Ne),kt(t.removed)}catch{}}}Ee("afterSanitizeAttributes",he,null)}},et=function Ae(he){var _e=void 0,Ne=ae(he);for(Ee("beforeSanitizeShadowDOM",he,null);_e=Ne.nextNode();)Ee("uponSanitizeShadowNode",_e,null),!Pe(_e)&&(_e.content instanceof i&&Ae(_e.content),Ge(_e));Ee("afterSanitizeShadowDOM",he,null)};return t.sanitize=function(Ae,he){var _e=void 0,Ne=void 0,He=void 0,Xe=void 0,Ze=void 0;if(Se=!Ae,Se&&(Ae="<!-->"),typeof Ae!="string"&&!we(Ae)){if(typeof Ae.toString!="function")throw Rt("toString is not a function");if(Ae=Ae.toString(),typeof Ae!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(mt(ee.toStaticHTML)==="object"||typeof ee.toStaticHTML=="function"){if(typeof Ae=="string")return ee.toStaticHTML(Ae);if(we(Ae))return ee.toStaticHTML(Ae.outerHTML)}return Ae}if(K||Ie(he),t.removed=[],typeof Ae=="string"&&(O=!1),!O)if(Ae instanceof w)_e=X("<!---->"),Ne=_e.ownerDocument.importNode(Ae,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?_e=Ne:_e.appendChild(Ne);else{if(!o&&!V&&!_&&Ae.indexOf("<")===-1)return C&&te?C.createHTML(Ae):Ae;if(_e=X(Ae),!_e)return o?null:f}_e&&z&&Re(_e.firstChild);for(var Qe=ae(O?Ae:_e);He=Qe.nextNode();)He.nodeType===3&&He===Xe||Pe(He)||(He.content instanceof i&&et(He.content),Ge(He),Xe=He);if(Xe=null,O)return Ae;if(o){if(F)for(Ze=g.call(_e.ownerDocument);_e.firstChild;)Ze.appendChild(_e.firstChild);else Ze=_e;return j&&(Ze=L.call(E,Ze,!0)),Ze}var rt=_?_e.outerHTML:_e.innerHTML;return V&&(rt=ut(rt,H," "),rt=ut(rt,G," ")),C&&te?C.createHTML(rt):rt},t.setConfig=function(Ae){Ie(Ae),K=!0},t.clearConfig=function(){ve=null,K=!1},t.isValidAttribute=function(Ae,he,_e){ve||Ie({});var Ne=ct(Ae),He=ct(he);return Ue(Ne,He,_e)},t.addHook=function(Ae,he){typeof he=="function"&&(A[Ae]=A[Ae]||[],gt(A[Ae],he))},t.removeHook=function(Ae){A[Ae]&&kt(A[Ae])},t.removeHooks=function(Ae){A[Ae]&&(A[Ae]=[])},t.removeAllHooks=function(){A={}},t}var ci=Ht();define("vs/base/browser/dompurify/dompurify",function(){return ci}),define(ge[39],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class E{constructor(w){this.domNode=w,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._paddingTop="",this._paddingLeft="",this._paddingBottom="",this._paddingRight="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._fontVariationSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(w){const y=I(w);this._maxWidth!==y&&(this._maxWidth=y,this.domNode.style.maxWidth=this._maxWidth)}setWidth(w){const y=I(w);this._width!==y&&(this._width=y,this.domNode.style.width=this._width)}setHeight(w){const y=I(w);this._height!==y&&(this._height=y,this.domNode.style.height=this._height)}setTop(w){const y=I(w);this._top!==y&&(this._top=y,this.domNode.style.top=this._top)}setLeft(w){const y=I(w);this._left!==y&&(this._left=y,this.domNode.style.left=this._left)}setBottom(w){const y=I(w);this._bottom!==y&&(this._bottom=y,this.domNode.style.bottom=this._bottom)}setRight(w){const y=I(w);this._right!==y&&(this._right=y,this.domNode.style.right=this._right)}setPaddingTop(w){const y=I(w);this._paddingTop!==y&&(this._paddingTop=y,this.domNode.style.paddingTop=this._paddingTop)}setPaddingLeft(w){const y=I(w);this._paddingLeft!==y&&(this._paddingLeft=y,this.domNode.style.paddingLeft=this._paddingLeft)}setPaddingBottom(w){const y=I(w);this._paddingBottom!==y&&(this._paddingBottom=y,this.domNode.style.paddingBottom=this._paddingBottom)}setPaddingRight(w){const y=I(w);this._paddingRight!==y&&(this._paddingRight=y,this.domNode.style.paddingRight=this._paddingRight)}setFontFamily(w){this._fontFamily!==w&&(this._fontFamily=w,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(w){this._fontWeight!==w&&(this._fontWeight=w,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(w){const y=I(w);this._fontSize!==y&&(this._fontSize=y,this.domNode.style.fontSize=this._fontSize)}setFontStyle(w){this._fontStyle!==w&&(this._fontStyle=w,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(w){this._fontFeatureSettings!==w&&(this._fontFeatureSettings=w,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setFontVariationSettings(w){this._fontVariationSettings!==w&&(this._fontVariationSettings=w,this.domNode.style.fontVariationSettings=this._fontVariationSettings)}setTextDecoration(w){this._textDecoration!==w&&(this._textDecoration=w,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(w){const y=I(w);this._lineHeight!==y&&(this._lineHeight=y,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(w){const y=I(w);this._letterSpacing!==y&&(this._letterSpacing=y,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(w){this._className!==w&&(this._className=w,this.domNode.className=this._className)}toggleClassName(w,y){this.domNode.classList.toggle(w,y),this._className=this.domNode.className}setDisplay(w){this._display!==w&&(this._display=w,this.domNode.style.display=this._display)}setPosition(w){this._position!==w&&(this._position=w,this.domNode.style.position=this._position)}setVisibility(w){this._visibility!==w&&(this._visibility=w,this.domNode.style.visibility=this._visibility)}setColor(w){this._color!==w&&(this._color=w,this.domNode.style.color=this._color)}setBackgroundColor(w){this._backgroundColor!==w&&(this._backgroundColor=w,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(w){this._layerHint!==w&&(this._layerHint=w,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(w){this._boxShadow!==w&&(this._boxShadow=w,this.domNode.style.boxShadow=w)}setContain(w){this._contain!==w&&(this._contain=w,this.domNode.style.contain=this._contain)}setAttribute(w,y){this.domNode.setAttribute(w,y)}removeAttribute(w){this.domNode.removeAttribute(w)}appendChild(w){this.domNode.appendChild(w.domNode)}removeChild(w){this.domNode.removeChild(w.domNode)}}t.FastDomNode=E;function I(W){return typeof W=="number"?`${W}px`:W}function i(W){return new E(W)}t.createFastDomNode=i}),define(ge[66],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let E=!1,I=null;function i(w){if(!w.parent||w.parent===w)return null;try{const y=w.location,c=w.parent.location;if(y.origin!=="null"&&c.origin!=="null"&&y.origin!==c.origin)return E=!0,null}catch{return E=!0,null}return w.parent}class W{static getSameOriginWindowChain(){if(!I){I=[];let y=window,c;do c=i(y),c?I.push({window:y,iframeElement:y.frameElement||null}):I.push({window:y,iframeElement:null}),y=c;while(y)}return I.slice(0)}static hasDifferentOriginAncestor(){return I||this.getSameOriginWindowChain(),E}static getPositionOfChildWindowRelativeToAncestorWindow(y,c){if(!c||y===c)return{top:0,left:0};let u=0,d=0;const P=this.getSameOriginWindowChain();for(const r of P){if(u+=r.window.scrollY,d+=r.window.scrollX,r.window===c||!r.iframeElement)break;const l=r.iframeElement.getBoundingClientRect();u+=l.top,d+=l.left}return{top:u,left:d}}}t.IframeUtils=W}),define(ge[67],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var E;(function(W){W[W.Copy=0]="Copy",W[W.Move=1]="Move"})(E||(t.ListDragOverEffect=E={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class I extends Error{constructor(w,y){super(`ListError [${w}] ${y}`)}}t.ListError=I;class i{constructor(){this.cache=new WeakMap}getHeight(w){return this.cache.get(w)??this.estimateHeight(w)}setDynamicHeight(w,y){y>0&&this.cache.set(w,y)}}t.CachedListVirtualDelegate=i}),define(ge[68],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class E{constructor(i){this.spliceables=i}splice(i,W,w){this.spliceables.forEach(y=>y.splice(i,W,w))}}t.CombinedSpliceable=E}),define(ge[40],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const E=20;class I{constructor(W,w,y,c,u,d){this._scrollbarSize=Math.round(w),this._oppositeScrollbarSize=Math.round(y),this._arrowSize=Math.round(W),this._visibleSize=c,this._scrollSize=u,this._scrollPosition=d,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new I(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(W){const w=Math.round(W);return this._visibleSize!==w?(this._visibleSize=w,this._refreshComputedValues(),!0):!1}setScrollSize(W){const w=Math.round(W);return this._scrollSize!==w?(this._scrollSize=w,this._refreshComputedValues(),!0):!1}setScrollPosition(W){const w=Math.round(W);return this._scrollPosition!==w?(this._scrollPosition=w,this._refreshComputedValues(),!0):!1}setScrollbarSize(W){this._scrollbarSize=Math.round(W)}setOppositeScrollbarSize(W){this._oppositeScrollbarSize=Math.round(W)}static _computeValues(W,w,y,c,u){const d=Math.max(0,y-W),P=Math.max(0,d-2*w),r=c>0&&c>y;if(!r)return{computedAvailableSize:Math.round(d),computedIsNeeded:r,computedSliderSize:Math.round(P),computedSliderRatio:0,computedSliderPosition:0};const l=Math.round(Math.max(E,Math.floor(y*P/c))),e=(P-l)/(c-y),a=u*e;return{computedAvailableSize:Math.round(d),computedIsNeeded:r,computedSliderSize:Math.round(l),computedSliderRatio:e,computedSliderPosition:Math.round(a)}}_refreshComputedValues(){const W=I._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=W.computedAvailableSize,this._computedIsNeeded=W.computedIsNeeded,this._computedSliderSize=W.computedSliderSize,this._computedSliderRatio=W.computedSliderRatio,this._computedSliderPosition=W.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(W){if(!this._computedIsNeeded)return 0;const w=W-this._arrowSize-this._computedSliderSize/2;return Math.round(w/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(W){if(!this._computedIsNeeded)return 0;const w=W-this._arrowSize;let y=this._scrollPosition;return w<this._computedSliderPosition?y-=this._visibleSize:y+=this._visibleSize,y}getDesiredScrollPositionFromDelta(W){if(!this._computedIsNeeded)return 0;const w=this._computedSliderPosition+W;return Math.round(w/this._computedSliderRatio)}}t.ScrollbarState=I}),define(ge[24],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var E;(function(c){c[c.Hidden=0]="Hidden",c[c.Visible=1]="Visible",c[c.Recurse=2]="Recurse"})(E||(t.TreeVisibility=E={}));var I;(function(c){c[c.Expanded=0]="Expanded",c[c.Collapsed=1]="Collapsed",c[c.PreserveOrExpanded=2]="PreserveOrExpanded",c[c.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(I||(t.ObjectTreeElementCollapseState=I={}));var i;(function(c){c[c.Unknown=0]="Unknown",c[c.Twistie=1]="Twistie",c[c.Element=2]="Element",c[c.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var W;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(W||(t.TreeDragOverBubble=W={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(c=!1){return{accept:!0,bubble:0,autoExpand:c}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(c=!1){return{accept:!0,bubble:0,effect:0,autoExpand:c}}};class w extends Error{constructor(u,d){super(`TreeError [${u}] ${d}`)}}t.TreeError=w;class y{constructor(u){this.fn=u,this._map=new WeakMap}map(u){let d=this._map.get(u);return d||(d=this.fn(u),this._map.set(u,d)),d}}t.WeakMapper=y}),define(ge[69],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function E(w,y){const c=Object.create(null);for(const u of w){const d=y(u);let P=c[d];P||(P=c[d]=[]),P.push(u)}return c}t.groupBy=E;function I(w,y){const c=[],u=[];for(const d of w)y.has(d)||c.push(d);for(const d of y)w.has(d)||u.push(d);return{removed:c,added:u}}t.diffSets=I;function i(w,y){const c=[],u=[];for(const[d,P]of w)y.has(d)||c.push(P);for(const[d,P]of y)w.has(d)||u.push(P);return{removed:c,added:u}}t.diffMaps=i;class W{constructor(){this.map=new Map}add(y,c){let u=this.map.get(y);u||(u=new Set,this.map.set(y,u)),u.add(c)}delete(y,c){const u=this.map.get(y);u&&(u.delete(c),u.size===0&&this.map.delete(y))}forEach(y,c){const u=this.map.get(y);u&&u.forEach(c)}}t.SetMap=W}),define(ge[70],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function E(y,c){const u=Math.pow(10,c);return Math.round(y*u)/u}class I{constructor(c,u,d,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=E(Math.max(Math.min(1,P),0),3)}static equals(c,u){return c.r===u.r&&c.g===u.g&&c.b===u.b&&c.a===u.a}}t.RGBA=I;class i{constructor(c,u,d,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=E(Math.max(Math.min(1,u),0),3),this.l=E(Math.max(Math.min(1,d),0),3),this.a=E(Math.max(Math.min(1,P),0),3)}static equals(c,u){return c.h===u.h&&c.s===u.s&&c.l===u.l&&c.a===u.a}static fromRGBA(c){const u=c.r/255,d=c.g/255,P=c.b/255,r=c.a,l=Math.max(u,d,P),e=Math.min(u,d,P);let a=0,n=0;const h=(e+l)/2,s=l-e;if(s>0){switch(n=Math.min(h<=.5?s/(2*h):s/(2-2*h),1),l){case u:a=(d-P)/s+(d<P?6:0);break;case d:a=(P-u)/s+2;break;case P:a=(u-d)/s+4;break}a*=60,a=Math.round(a)}return new i(a,n,h,r)}static _hue2rgb(c,u,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?c+(u-c)*6*d:d<1/2?u:d<2/3?c+(u-c)*(2/3-d)*6:c}static toRGBA(c){const u=c.h/360,{s:d,l:P,a:r}=c;let l,e,a;if(d===0)l=e=a=P;else{const n=P<.5?P*(1+d):P+d-P*d,h=2*P-n;l=i._hue2rgb(h,n,u+1/3),e=i._hue2rgb(h,n,u),a=i._hue2rgb(h,n,u-1/3)}return new I(Math.round(l*255),Math.round(e*255),Math.round(a*255),r)}}t.HSLA=i;class W{constructor(c,u,d,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=E(Math.max(Math.min(1,u),0),3),this.v=E(Math.max(Math.min(1,d),0),3),this.a=E(Math.max(Math.min(1,P),0),3)}static equals(c,u){return c.h===u.h&&c.s===u.s&&c.v===u.v&&c.a===u.a}static fromRGBA(c){const u=c.r/255,d=c.g/255,P=c.b/255,r=Math.max(u,d,P),l=Math.min(u,d,P),e=r-l,a=r===0?0:e/r;let n;return e===0?n=0:r===u?n=((d-P)/e%6+6)%6:r===d?n=(P-u)/e+2:n=(u-d)/e+4,new W(Math.round(n*60),a,r,c.a)}static toRGBA(c){const{h:u,s:d,v:P,a:r}=c,l=P*d,e=l*(1-Math.abs(u/60%2-1)),a=P-l;let[n,h,s]=[0,0,0];return u<60?(n=l,h=e):u<120?(n=e,h=l):u<180?(h=l,s=e):u<240?(h=e,s=l):u<300?(n=e,s=l):u<=360&&(n=l,s=e),n=Math.round((n+a)*255),h=Math.round((h+a)*255),s=Math.round((s+a)*255),new I(n,h,s,r)}}t.HSVA=W;class w{static fromHex(c){return w.Format.CSS.parseHex(c)||w.red}static equals(c,u){return!c&&!u?!0:!c||!u?!1:c.equals(u)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:W.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof I)this.rgba=c;else if(c instanceof i)this._hsla=c,this.rgba=i.toRGBA(c);else if(c instanceof W)this._hsva=c,this.rgba=W.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&I.equals(this.rgba,c.rgba)&&i.equals(this.hsla,c.hsla)&&W.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=w._relativeLuminanceForComponent(this.rgba.r),u=w._relativeLuminanceForComponent(this.rgba.g),d=w._relativeLuminanceForComponent(this.rgba.b),P=.2126*c+.7152*u+.0722*d;return E(P,4)}static _relativeLuminanceForComponent(c){const u=c/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(c){const u=this.getRelativeLuminance(),d=c.getRelativeLuminance();return u>d?(u+.05)/(d+.05):(d+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const u=this.getRelativeLuminance(),d=c.getRelativeLuminance();return u>d}isDarkerThan(c){const u=this.getRelativeLuminance(),d=c.getRelativeLuminance();return u<d}lighten(c){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:u,g:d,b:P,a:r}=this.rgba;return new w(new I(u,d,P,r*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new I(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const u=c.rgba,d=this.rgba.a,P=u.a,r=d+P*(1-d);if(r<1e-6)return w.transparent;const l=this.rgba.r*d/r+u.r*P*(1-d)/r,e=this.rgba.g*d/r+u.g*P*(1-d)/r,a=this.rgba.b*d/r+u.b*P*(1-d)/r;return new w(new I(l,e,a,r))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:u,g:d,b:P,a:r}=this.rgba;return new w(new I(c.rgba.r-r*(c.rgba.r-u),c.rgba.g-r*(c.rgba.g-d),c.rgba.b-r*(c.rgba.b-P),1))}flatten(...c){const u=c.reduceRight((d,P)=>w._flatten(P,d));return w._flatten(this,u)}static _flatten(c,u){const d=1-c.rgba.a;return new w(new I(d*u.rgba.r+c.rgba.a*c.rgba.r,d*u.rgba.g+c.rgba.a*c.rgba.g,d*u.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this._toString||(this._toString=w.Format.CSS.format(this)),this._toString}static getLighterColor(c,u,d){if(c.isLighterThan(u))return c;d=d||.5;const P=c.getRelativeLuminance(),r=u.getRelativeLuminance();return d=d*(r-P)/r,c.lighten(d)}static getDarkerColor(c,u,d){if(c.isDarkerThan(u))return c;d=d||.5;const P=c.getRelativeLuminance(),r=u.getRelativeLuminance();return d=d*(P-r)/P,c.darken(d)}}t.Color=w,w.white=new w(new I(255,255,255,1)),w.black=new w(new I(0,0,0,1)),w.red=new w(new I(255,0,0,1)),w.blue=new w(new I(0,0,255,1)),w.green=new w(new I(0,255,0,1)),w.cyan=new w(new I(0,255,255,1)),w.lightgrey=new w(new I(211,211,211,1)),w.transparent=new w(new I(0,0,0,0)),function(y){let c;(function(u){let d;(function(P){function r(f){return f.rgba.a===1?`rgb(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b})`:y.Format.CSS.formatRGBA(f)}P.formatRGB=r;function l(f){return`rgba(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b}, ${+f.rgba.a.toFixed(2)})`}P.formatRGBA=l;function e(f){return f.hsla.a===1?`hsl(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(f)}P.formatHSL=e;function a(f){return`hsla(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%, ${f.hsla.a.toFixed(2)})`}P.formatHSLA=a;function n(f){const D=f.toString(16);return D.length!==2?"0"+D:D}function h(f){return`#${n(f.rgba.r)}${n(f.rgba.g)}${n(f.rgba.b)}`}P.formatHex=h;function s(f,D=!1){return D&&f.rgba.a===1?y.Format.CSS.formatHex(f):`#${n(f.rgba.r)}${n(f.rgba.g)}${n(f.rgba.b)}${n(Math.round(f.rgba.a*255))}`}P.formatHexA=s;function p(f){return f.isOpaque()?y.Format.CSS.formatHex(f):y.Format.CSS.formatRGBA(f)}P.format=p;function v(f){const D=f.length;if(D===0||f.charCodeAt(0)!==35)return null;if(D===7){const M=16*C(f.charCodeAt(1))+C(f.charCodeAt(2)),R=16*C(f.charCodeAt(3))+C(f.charCodeAt(4)),g=16*C(f.charCodeAt(5))+C(f.charCodeAt(6));return new y(new I(M,R,g,1))}if(D===9){const M=16*C(f.charCodeAt(1))+C(f.charCodeAt(2)),R=16*C(f.charCodeAt(3))+C(f.charCodeAt(4)),g=16*C(f.charCodeAt(5))+C(f.charCodeAt(6)),m=16*C(f.charCodeAt(7))+C(f.charCodeAt(8));return new y(new I(M,R,g,m/255))}if(D===4){const M=C(f.charCodeAt(1)),R=C(f.charCodeAt(2)),g=C(f.charCodeAt(3));return new y(new I(16*M+M,16*R+R,16*g+g))}if(D===5){const M=C(f.charCodeAt(1)),R=C(f.charCodeAt(2)),g=C(f.charCodeAt(3)),m=C(f.charCodeAt(4));return new y(new I(16*M+M,16*R+R,16*g+g,(16*m+m)/255))}return null}P.parseHex=v;function C(f){switch(f){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(d=u.CSS||(u.CSS={}))})(c=y.Format||(y.Format={}))}(w||(t.Color=w={}))}),define(ge[25],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=void 0;function E(w){return(y,c,u)=>{let d=null,P=null;if(typeof u.value=="function"?(d="value",P=u.value):typeof u.get=="function"&&(d="get",P=u.get),!P)throw new Error("not supported");u[d]=w(P,c)}}function I(w,y,c){let u=null,d=null;if(typeof c.value=="function"?(u="value",d=c.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(u="get",d=c.get),!d)throw new Error("not supported");const P=`$memoize$${y}`;c[u]=function(...r){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,r)}),this[P]}}t.memoize=I;function i(w,y,c){return E((u,d)=>{const P=`$debounce$${d}`,r=`$debounce$result$${d}`;return function(...l){this[r]||(this[r]=c?c():void 0),clearTimeout(this[P]),y&&(this[r]=y(this[r],...l),l=[this[r]]),this[P]=setTimeout(()=>{u.apply(this,l),this[r]=c?c():void 0},w)}})}t.debounce=i;function W(w,y,c){return E((u,d)=>{const P=`$throttle$timer$${d}`,r=`$throttle$result$${d}`,l=`$throttle$lastRun$${d}`,e=`$throttle$pending$${d}`;return function(...a){if(this[r]||(this[r]=c?c():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),y&&(this[r]=y(this[r],...a)),this[e])return;const n=this[l]+w;n<=Date.now()?(this[l]=Date.now(),u.apply(this,[this[r]]),this[r]=c?c():void 0):(this[e]=!0,this[P]=setTimeout(()=>{this[e]=!1,this[l]=Date.now(),u.apply(this,[this[r]]),this[r]=c?c():void 0},n-Date.now()))}})}t.throttle=W}),define(ge[71],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class E{constructor(i,W,w,y){this.originalStart=i,this.originalLength=W,this.modifiedStart=w,this.modifiedLength=y}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=E}),define(ge[7],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(D){setTimeout(()=>{throw D.stack?v.isErrorNoTelemetry(D)?new v(D.message+`

`+D.stack):new Error(D.message+`

`+D.stack):D},0)}}addListener(D){return this.listeners.push(D),()=>{this._removeListener(D)}}emit(D){this.listeners.forEach(M=>{M(D)})}_removeListener(D){this.listeners.splice(this.listeners.indexOf(D),1)}setUnexpectedErrorHandler(D){this.unexpectedErrorHandler=D}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(D){this.unexpectedErrorHandler(D),this.emit(D)}onUnexpectedExternalError(D){this.unexpectedErrorHandler(D)}}t.ErrorHandler=E,t.errorHandler=new E;function I(f){t.errorHandler.setUnexpectedErrorHandler(f)}t.setUnexpectedErrorHandler=I;function i(f){if(!f||typeof f!="object")return!1;const D=f;return D.code==="EPIPE"&&D.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function W(f){u(f)||t.errorHandler.onUnexpectedError(f)}t.onUnexpectedError=W;function w(f){u(f)||t.errorHandler.onUnexpectedExternalError(f)}t.onUnexpectedExternalError=w;function y(f){if(f instanceof Error){const{name:D,message:M}=f,R=f.stacktrace||f.stack;return{$isError:!0,name:D,message:M,stack:R,noTelemetry:v.isErrorNoTelemetry(f)}}return f}t.transformErrorForSerialization=y;const c="Canceled";function u(f){return f instanceof d?!0:f instanceof Error&&f.name===c&&f.message===c}t.isCancellationError=u;class d extends Error{constructor(){super(c),this.name=this.message}}t.CancellationError=d;function P(){const f=new Error(c);return f.name=f.message,f}t.canceled=P;function r(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}t.illegalArgument=r;function l(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}t.illegalState=l;function e(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function a(f){const D=new Error(`${f} has been disposed`);return D.name="DISPOSED",D}t.disposed=a;function n(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}t.getErrorMessage=n;class h extends Error{constructor(D){super("NotImplemented"),D&&(this.message=D)}}t.NotImplementedError=h;class s extends Error{constructor(D){super("NotSupported"),D&&(this.message=D)}}t.NotSupportedError=s;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=p;class v extends Error{constructor(D){super(D),this.name="CodeExpectedError"}static fromError(D){if(D instanceof v)return D;const M=new v;return M.message=D.message,M.stack=D.stack,M}static isErrorNoTelemetry(D){return D.name==="CodeExpectedError"}}t.ErrorNoTelemetry=v;class C extends Error{constructor(D){super(D||"An unexpected bug occurred."),Object.setPrototypeOf(this,C.prototype)}}t.BugIndicatingError=C}),define(ge[13],me([1,0,7]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function I(S,T=0){return S[S.length-(1+T)]}t.tail=I;function i(S){if(S.length===0)throw new Error("Invalid tail call");return[S.slice(0,S.length-1),S[S.length-1]]}t.tail2=i;function W(S,T,O=(b,x)=>b===x){if(S===T)return!0;if(!S||!T||S.length!==T.length)return!1;for(let b=0,x=S.length;b<x;b++)if(!O(S[b],T[b]))return!1;return!0}t.equals=W;function w(S,T){const O=S.length-1;T<O&&(S[T]=S[O]),S.pop()}t.removeFastWithoutKeepingOrder=w;function y(S,T,O){return c(S.length,b=>O(S[b],T))}t.binarySearch=y;function c(S,T){let O=0,b=S-1;for(;O<=b;){const x=(O+b)/2|0,B=T(x);if(B<0)O=x+1;else if(B>0)b=x-1;else return x}return-(O+1)}t.binarySearch2=c;function u(S,T){let O=0,b=S.length;if(b===0)return 0;for(;O<b;){const x=Math.floor((O+b)/2);T(S[x])?b=x:O=x+1}return O}t.findFirstInSorted=u;function d(S,T,O){if(S=S|0,S>=T.length)throw new TypeError("invalid index");const b=T[Math.floor(T.length*Math.random())],x=[],B=[],N=[];for(const U of T){const Y=O(U,b);Y<0?x.push(U):Y>0?B.push(U):N.push(U)}return S<x.length?d(S,x,O):S<x.length+N.length?N[0]:d(S-(x.length+N.length),B,O)}t.quickSelect=d;function P(S,T){const O=[];let b;for(const x of S.slice(0).sort(T))!b||T(b[0],x)!==0?(b=[x],O.push(b)):b.push(x);return O}t.groupBy=P;function r(S,T,O){const b=[];function x(U,Y,J){if(Y===0&&J.length===0)return;const oe=b[b.length-1];oe&&oe.start+oe.deleteCount===U?(oe.deleteCount+=Y,oe.toInsert.push(...J)):b.push({start:U,deleteCount:Y,toInsert:J})}let B=0,N=0;for(;;){if(B===S.length){x(B,0,T.slice(N));break}if(N===T.length){x(B,S.length-B,[]);break}const U=S[B],Y=T[N],J=O(U,Y);J===0?(B+=1,N+=1):J<0?(x(B,1,[]),B+=1):J>0&&(x(B,0,[Y]),N+=1)}return b}t.sortedDiff=r;function l(S,T,O){const b=r(S,T,O),x=[],B=[];for(const N of b)x.push(...S.slice(N.start,N.start+N.deleteCount)),B.push(...N.toInsert);return{removed:x,added:B}}t.delta=l;function e(S,T,O){if(O===0)return[];const b=S.slice(0,O).sort(T);return n(S,T,b,O,S.length),b}t.top=e;function a(S,T,O,b,x){return O===0?Promise.resolve([]):new Promise((B,N)=>{(async()=>{const U=S.length,Y=S.slice(0,O).sort(T);for(let J=O,oe=Math.min(O+b,U);J<U;J=oe,oe=Math.min(oe+b,U)){if(J>O&&await new Promise(be=>setTimeout(be)),x&&x.isCancellationRequested)throw new E.CancellationError;n(S,T,Y,J,oe)}return Y})().then(B,N)})}t.topAsync=a;function n(S,T,O,b,x){for(const B=O.length;b<x;b++){const N=S[b];if(T(N,O[B-1])<0){O.pop();const U=u(O,Y=>T(N,Y)<0);O.splice(U,0,N)}}}function h(S){return S.filter(T=>!!T)}t.coalesce=h;function s(S){let T=0;for(let O=0;O<S.length;O++)S[O]&&(S[T]=S[O],T+=1);S.length=T}t.coalesceInPlace=s;function p(S,T,O){S.splice(O,0,S.splice(T,1)[0])}t.move=p;function v(S){return!Array.isArray(S)||S.length===0}t.isFalsyOrEmpty=v;function C(S){return Array.isArray(S)&&S.length>0}t.isNonEmptyArray=C;function f(S,T=O=>O){const O=new Set;return S.filter(b=>{const x=T(b);return O.has(x)?!1:(O.add(x),!0)})}t.distinct=f;function D(S){const T=new Set;return O=>{const b=S(O);return T.has(b)?!1:(T.add(b),!0)}}t.uniqueFilter=D;function M(S,T){const O=R(S,T);if(O!==-1)return S[O]}t.findLast=M;function R(S,T){for(let O=S.length-1;O>=0;O--){const b=S[O];if(T(b))return O}return-1}t.lastIndex=R;function g(S,T){return S.length>0?S[0]:T}t.firstOrDefault=g;function m(S,T){return S.length>0?S[S.length-1]:T}t.lastOrDefault=m;function L(S,T,O=(b,x)=>b===x){let b=0;for(let x=0,B=Math.min(S.length,T.length);x<B&&O(S[x],T[x]);x++)b++;return b}t.commonPrefixLength=L;function k(S){return[].concat(...S)}t.flatten=k;function A(S,T){let O=typeof T=="number"?S:0;typeof T=="number"?O=S:(O=0,T=S);const b=[];if(O<=T)for(let x=O;x<T;x++)b.push(x);else for(let x=O;x>T;x--)b.push(x);return b}t.range=A;function H(S,T,O){return S.reduce((b,x)=>(b[T(x)]=O?O(x):x,b),Object.create(null))}t.index=H;function G(S,T){return S.push(T),()=>ne(S,T)}t.insert=G;function ne(S,T){const O=S.indexOf(T);if(O>-1)return S.splice(O,1),T}t.remove=ne;function se(S,T,O){const b=S.slice(0,T),x=S.slice(T);return b.concat(O,x)}t.arrayInsert=se;function de(S,T){let O;if(typeof T=="number"){let b=T;O=()=>{const x=Math.sin(b++)*179426549;return x-Math.floor(x)}}else O=Math.random;for(let b=S.length-1;b>0;b-=1){const x=Math.floor(O()*(b+1)),B=S[b];S[b]=S[x],S[x]=B}}t.shuffle=de;function ue(S,T){const O=S.indexOf(T);O>-1&&(S.splice(O,1),S.unshift(T))}t.pushToStart=ue;function re(S,T){const O=S.indexOf(T);O>-1&&(S.splice(O,1),S.push(T))}t.pushToEnd=re;function le(S,T){for(const O of T)S.push(O)}t.pushMany=le;function ye(S,T){return Array.isArray(S)?S.map(T):T(S)}t.mapArrayOrNot=ye;function Te(S){return Array.isArray(S)?S:[S]}t.asArray=Te;function Me(S){return S[Math.floor(Math.random()*S.length)]}t.getRandomElement=Me;function Oe(S,T){for(const O of S){const b=T(O);if(b!==void 0)return b}}t.mapFind=Oe;function ce(S,T,O){const b=q(S,T),x=S.length,B=O.length;S.length=x+B;for(let N=x-1;N>=b;N--)S[N+B]=S[N];for(let N=0;N<B;N++)S[N+b]=O[N]}t.insertInto=ce;function ie(S,T,O,b){const x=q(S,T),B=S.splice(x,O);return ce(S,x,b),B}t.splice=ie;function q(S,T){return T<0?Math.max(T+S.length,0):Math.min(T,S.length)}var $;(function(S){function T(x){return x<0}S.isLessThan=T;function O(x){return x>0}S.isGreaterThan=O;function b(x){return x===0}S.isNeitherLessOrGreaterThan=b,S.greaterThan=1,S.lessThan=-1,S.neitherLessOrGreaterThan=0})($||(t.CompareResult=$={}));function V(S,T){return(O,b)=>T(S(O),S(b))}t.compareBy=V;function _(...S){return(T,O)=>{for(const b of S){const x=b(T,O);if(!$.isNeitherLessOrGreaterThan(x))return x}return $.neitherLessOrGreaterThan}}t.tieBreakComparators=_;const K=(S,T)=>S-T;t.numberComparator=K;function z(S,T){if(S.length===0)return;let O=S[0];for(let b=1;b<S.length;b++){const x=S[b];T(x,O)>0&&(O=x)}return O}t.findMaxBy=z;function o(S,T){if(S.length===0)return;let O=S[0];for(let b=1;b<S.length;b++){const x=S[b];T(x,O)>=0&&(O=x)}return O}t.findLastMaxBy=o;function F(S,T){return z(S,(O,b)=>-T(O,b))}t.findMinBy=F;class j{constructor(T){this.items=T,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(T){let O=this.firstIdx;for(;O<this.items.length&&T(this.items[O]);)O++;const b=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,b}takeFromEndWhile(T){let O=this.lastIdx;for(;O>=0&&T(this.items[O]);)O--;const b=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,b}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const T=this.items[this.firstIdx];return this.firstIdx++,T}removeLast(){const T=this.items[this.lastIdx];return this.lastIdx--,T}takeCount(T){const O=this.items.slice(this.firstIdx,this.firstIdx+T);return this.firstIdx+=T,O}}t.ArrayQueue=j;class te{constructor(T){this.iterate=T}forEach(T){this.iterate(O=>(T(O),!0))}toArray(){const T=[];return this.iterate(O=>(T.push(O),!0)),T}filter(T){return new te(O=>this.iterate(b=>T(b)?O(b):!0))}map(T){return new te(O=>this.iterate(b=>O(T(b))))}some(T){let O=!1;return this.iterate(b=>(O=T(b),!O)),O}findFirst(T){let O;return this.iterate(b=>T(b)?(O=b,!1):!0),O}findLast(T){let O;return this.iterate(b=>(T(b)&&(O=b),!0)),O}findLastMaxBy(T){let O,b=!0;return this.iterate(x=>((b||$.isGreaterThan(T(x,O)))&&(b=!1,O=x),!0)),O}}t.CallbackIterable=te,te.empty=new te(S=>{})}),define(ge[72],me([1,0,7]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function I(c,u){if(!c)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}t.ok=I;function i(c,u="Unreachable"){throw new Error(u)}t.assertNever=i;function W(c){if(!c)throw new E.BugIndicatingError("Assertion Failed")}t.assert=W;function w(c){if(!c()){debugger;c(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}t.assertFn=w;function y(c,u){let d=0;for(;d<c.length-1;){const P=c[d],r=c[d+1];if(!u(P,r))return!1;d++}return!0}t.checkAdjacentItems=y}),define(ge[41],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function E(I){const i=this;let W=!1,w;return function(){return W||(W=!0,w=I.apply(i,arguments)),w}}t.once=E}),define(ge[73],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class E{constructor(i){this._prefix=i,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=E,t.defaultGenerator=new E("id#")}),define(ge[26],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var E;(function(I){function i(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}I.is=i;const W=Object.freeze([]);function w(){return W}I.empty=w;function*y(v){yield v}I.single=y;function c(v){return i(v)?v:y(v)}I.wrap=c;function u(v){return v||W}I.from=u;function d(v){return!v||v[Symbol.iterator]().next().done===!0}I.isEmpty=d;function P(v){return v[Symbol.iterator]().next().value}I.first=P;function r(v,C){for(const f of v)if(C(f))return!0;return!1}I.some=r;function l(v,C){for(const f of v)if(C(f))return f}I.find=l;function*e(v,C){for(const f of v)C(f)&&(yield f)}I.filter=e;function*a(v,C){let f=0;for(const D of v)yield C(D,f++)}I.map=a;function*n(...v){for(const C of v)for(const f of C)yield f}I.concat=n;function h(v,C,f){let D=f;for(const M of v)D=C(D,M);return D}I.reduce=h;function*s(v,C,f=v.length){for(C<0&&(C+=v.length),f<0?f+=v.length:f>v.length&&(f=v.length);C<f;C++)yield v[C]}I.slice=s;function p(v,C=Number.POSITIVE_INFINITY){const f=[];if(C===0)return[f,v];const D=v[Symbol.iterator]();for(let M=0;M<C;M++){const R=D.next();if(R.done)return[f,I.empty()];f.push(R.value)}return[f,{[Symbol.iterator](){return D}}]}I.consume=p})(E||(t.Iterable=E={}))}),define(ge[42],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var E;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(E||(t.KeyCode=E={}));var I;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(I||(t.ScanCode=I={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(a,n){this._keyCodeToStr[a]=n,this._strToKeyCode[n.toLowerCase()]=a}keyCodeToStr(a){return this._keyCodeToStr[a]}strToKeyCode(a){return this._strToKeyCode[a.toLowerCase()]||0}}const W=new i,w=new i,y=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const c=[],u=Object.create(null),d=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>d[e]||0,toEnum:e=>u[e]||0,toString:e=>c[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",a=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],n=[],h=[];for(const s of a){const[p,v,C,f,D,M,R,g,m]=s;if(h[v]||(h[v]=!0,c[v]=C,u[C]=v,d[C.toLowerCase()]=v,p&&(t.IMMUTABLE_CODE_TO_KEY_CODE[v]=f,f!==0&&f!==3&&f!==5&&f!==4&&f!==6&&f!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[f]=v))),!n[f]){if(n[f]=!0,!D)throw new Error(`String representation missing for key code ${f} around scan code ${C}`);W.define(f,D),w.define(f,g||D),y.define(f,m||g||D)}M&&(t.EVENT_KEY_CODE_MAP[M]=f),R&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[R]=f)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var P;(function(e){function a(C){return W.keyCodeToStr(C)}e.toString=a;function n(C){return W.strToKeyCode(C)}e.fromString=n;function h(C){return w.keyCodeToStr(C)}e.toUserSettingsUS=h;function s(C){return y.keyCodeToStr(C)}e.toUserSettingsGeneral=s;function p(C){return w.strToKeyCode(C)||y.strToKeyCode(C)}e.fromUserSettings=p;function v(C){if(C>=98&&C<=113)return null;switch(C){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return W.keyCodeToStr(C)}e.toElectronAccelerator=v})(P||(t.KeyCodeUtils=P={}));var r;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(r||(t.KeyMod=r={}));function l(e,a){const n=(a&65535)<<16>>>0;return(e|n)>>>0}t.KeyChord=l}),define(ge[74],me([1,0,7]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedChord=t.Keybinding=t.ScanCodeChord=t.KeyCodeChord=t.createSimpleKeybinding=t.decodeKeybinding=void 0;var I;(function(P){P[P.CtrlCmd=2048]="CtrlCmd",P[P.Shift=1024]="Shift",P[P.Alt=512]="Alt",P[P.WinCtrl=256]="WinCtrl",P[P.KeyCode=255]="KeyCode"})(I||(I={}));function i(P,r){if(typeof P=="number"){if(P===0)return null;const l=(P&65535)>>>0,e=(P&4294901760)>>>16;return e!==0?new c([W(l,r),W(e,r)]):new c([W(l,r)])}else{const l=[];for(let e=0;e<P.length;e++)l.push(W(P[e],r));return new c(l)}}t.decodeKeybinding=i;function W(P,r){const l=!!(P&2048),e=!!(P&256),a=r===2?e:l,n=!!(P&1024),h=!!(P&512),s=r===2?l:e,p=P&255;return new w(a,n,h,s,p)}t.createSimpleKeybinding=W;class w{constructor(r,l,e,a,n){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=a,this.keyCode=n}equals(r){return r instanceof w&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.keyCode===r.keyCode}getHashCode(){const r=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",a=this.metaKey?"1":"0";return`K${r}${l}${e}${a}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new c([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.KeyCodeChord=w;class y{constructor(r,l,e,a,n){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=a,this.scanCode=n}equals(r){return r instanceof y&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.scanCode===r.scanCode}getHashCode(){const r=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",a=this.metaKey?"1":"0";return`S${r}${l}${e}${a}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeChord=y;class c{constructor(r){if(r.length===0)throw(0,E.illegalArgument)("chords");this.chords=r}getHashCode(){let r="";for(let l=0,e=this.chords.length;l<e;l++)l!==0&&(r+=";"),r+=this.chords[l].getHashCode();return r}equals(r){if(r===null||this.chords.length!==r.chords.length)return!1;for(let l=0;l<this.chords.length;l++)if(!this.chords[l].equals(r.chords[l]))return!1;return!0}}t.Keybinding=c;class u{constructor(r,l,e,a,n,h){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=a,this.keyLabel=n,this.keyAriaLabel=h}}t.ResolvedChord=u;class d{}t.ResolvedKeybinding=d}),define(ge[30],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class E{constructor(i){this.executor=i,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=E}),define(ge[2],me([1,0,41,26]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let W=null;function w(m){W=m}if(t.setDisposableTracker=w,i){const m="__is_disposable_tracked__";w(new class{trackDisposable(L){const k=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[m]||console.log(k)},3e3)}setParent(L,k){if(L&&L!==s.None)try{L[m]=!0}catch{}}markAsDisposed(L){if(L&&L!==s.None)try{L[m]=!0}catch{}}markAsSingleton(L){}})}function y(m){return W?.trackDisposable(m),m}function c(m){W?.markAsDisposed(m)}function u(m,L){W?.setParent(m,L)}function d(m,L){if(W)for(const k of m)W.setParent(k,L)}function P(m){return W?.markAsSingleton(m),m}t.markAsSingleton=P;function r(m){return typeof m.dispose=="function"&&m.dispose.length===0}t.isDisposable=r;function l(m){if(I.Iterable.is(m)){const L=[];for(const k of m)if(k)try{k.dispose()}catch(A){L.push(A)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(m)?[]:m}else if(m)return m.dispose(),m}t.dispose=l;function e(m){for(const L of m)r(L)&&L.dispose();return[]}t.disposeIfDisposable=e;function a(...m){const L=n(()=>l(m));return d(m,L),L}t.combinedDisposable=a;function n(m){const L=y({dispose:(0,E.once)(()=>{c(L),m()})});return L}t.toDisposable=n;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(c(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{l(this._toDispose)}finally{this._toDispose.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return u(L,this),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(L),L}}t.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class s{constructor(){this._store=new h,y(this),u(this._store,this)}dispose(){c(this),this._store.dispose()}_register(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(L)}}t.Disposable=s,s.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(L){this._isDisposed||L===this._value||(this._value?.dispose(),L&&u(L,this),this._value=L)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,c(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const L=this._value;return this._value=void 0,L&&u(L,null),L}}t.MutableDisposable=p;class v{constructor(L){this._disposable=L,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=v;class C{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(L){let k=L;return this.unset=()=>k=void 0,this.isset=()=>k!==void 0,this.dispose=()=>{k&&(k(),k=void 0,c(this))},this}}t.SafeDisposable=C;class f{constructor(){this.references=new Map}acquire(L,...k){let A=this.references.get(L);A||(A={counter:0,object:this.createReferencedObject(L,...k)},this.references.set(L,A));const{object:H}=A,G=(0,E.once)(()=>{--A.counter===0&&(this.destroyReferencedObject(L,A.object),this.references.delete(L))});return A.counter++,{object:H,dispose:G}}}t.ReferenceCollection=f;class D{constructor(L){this.referenceCollection=L}async acquire(L,...k){const A=this.referenceCollection.acquire(L,...k);try{return{object:await A.object,dispose:()=>A.dispose()}}catch(H){throw A.dispose(),H}}}t.AsyncReferenceCollection=D;class M{constructor(L){this.object=L}dispose(){}}t.ImmortalReference=M;function R(m){const L=new h;try{m(L)}finally{L.dispose()}}t.disposeOnReturn=R;class g{constructor(){this._store=new Map,this._isDisposed=!1,y(this)}dispose(){c(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{l(this._store.values())}finally{this._store.clear()}}has(L){return this._store.has(L)}get(L){return this._store.get(L)}set(L,k,A=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),A||this._store.get(L)?.dispose(),this._store.set(L,k)}deleteAndDispose(L){this._store.get(L)?.dispose(),this._store.delete(L)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=g}),define(ge[43],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class E{constructor(W){this.element=W,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class I{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let W=this._first;for(;W!==E.Undefined;){const w=W.next;W.prev=E.Undefined,W.next=E.Undefined,W=w}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(W){return this._insert(W,!1)}push(W){return this._insert(W,!0)}_insert(W,w){const y=new E(W);if(this._first===E.Undefined)this._first=y,this._last=y;else if(w){const u=this._last;this._last=y,y.prev=u,u.next=y}else{const u=this._first;this._first=y,y.next=u,u.prev=y}this._size+=1;let c=!1;return()=>{c||(c=!0,this._remove(y))}}shift(){if(this._first!==E.Undefined){const W=this._first.element;return this._remove(this._first),W}}pop(){if(this._last!==E.Undefined){const W=this._last.element;return this._remove(this._last),W}}_remove(W){if(W.prev!==E.Undefined&&W.next!==E.Undefined){const w=W.prev;w.next=W.next,W.next.prev=w}else W.prev===E.Undefined&&W.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):W.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):W.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let W=this._first;for(;W!==E.Undefined;)yield W.element,W=W.next}}t.LinkedList=I}),define(ge[75],me([1,0]),function(ee,t){"use strict";var E,I,i;Object.defineProperty(t,"__esModule",{value:!0}),t.CounterSet=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function W(a,n,h){let s=a.get(n);return s===void 0&&(s=h,a.set(n,s)),s}t.getOrSet=W;function w(a){const n=[];return a.forEach((h,s)=>{n.push(`${s} => ${h}`)}),`Map(${a.size}) {${n.join(", ")}}`}t.mapToString=w;function y(a){const n=[];return a.forEach(h=>{n.push(h)}),`Set(${a.size}) {${n.join(", ")}}`}t.setToString=y;class c{constructor(n,h){this.uri=n,this.value=h}}class u{constructor(n,h){this[E]="ResourceMap",n instanceof u?(this.map=new Map(n.map),this.toKey=h??u.defaultToKey):(this.map=new Map,this.toKey=n??u.defaultToKey)}set(n,h){return this.map.set(this.toKey(n),new c(n,h)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,h){typeof h<"u"&&(n=n.bind(h));for(const[s,p]of this.map)n(p.value,p.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}t.ResourceMap=u,u.defaultToKey=a=>a.toString();class d{constructor(n,h){this[I]="ResourceSet",!n||typeof n=="function"?this._map=new u(n):(this._map=new u(h),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,h){this._map.forEach((s,p)=>n.call(h,p,p,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=d;var P;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(P||(t.Touch=P={}));class r{constructor(){this[i]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,h=0){const s=this._map.get(n);if(s)return h!==0&&this.touch(s,h),s.value}set(n,h,s=0){let p=this._map.get(n);if(p)p.value=h,s!==0&&this.touch(p,s);else{switch(p={key:n,value:h,next:void 0,previous:void 0},s){case 0:this.addItemLast(p);break;case 1:this.addItemFirst(p);break;case 2:this.addItemLast(p);break;default:this.addItemLast(p);break}this._map.set(n,p),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const h=this._map.get(n);if(h)return this._map.delete(n),this.removeItem(h),this._size--,h.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,h){const s=this._state;let p=this._head;for(;p;){if(h?n.bind(h)(p.value,p.key,this):n(p.value,p.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const n=this,h=this._state;let s=this._head;const p={[Symbol.iterator](){return p},next(){if(n._state!==h)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:s.key,done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return p}values(){const n=this,h=this._state;let s=this._head;const p={[Symbol.iterator](){return p},next(){if(n._state!==h)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:s.value,done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return p}entries(){const n=this,h=this._state;let s=this._head;const p={[Symbol.iterator](){return p},next(){if(n._state!==h)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:[s.key,s.value],done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return p}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let h=this._head,s=this.size;for(;h&&s>n;)this._map.delete(h.key),h=h.next,s--;this._head=h,this._size=s,h&&(h.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const h=n.next,s=n.previous;if(!h||!s)throw new Error("Invalid list");h.previous=s,s.next=h}n.next=void 0,n.previous=void 0,this._state++}touch(n,h){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(n===this._head)return;const s=n.next,p=n.previous;n===this._tail?(p.next=void 0,this._tail=p):(s.previous=p,p.next=s),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(h===2){if(n===this._tail)return;const s=n.next,p=n.previous;n===this._head?(s.previous=void 0,this._head=s):(s.previous=p,p.next=s),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((h,s)=>{n.push([s,h])}),n}fromJSON(n){this.clear();for(const[h,s]of n)this.set(h,s)}}t.LinkedMap=r;class l extends r{constructor(n,h=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,h),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,h=2){return super.get(n,h)}peek(n){return super.get(n,0)}set(n,h){return super.set(n,h,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=l;class e{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let h=this.map.get(n)||0;return h===0?!1:(h--,h===0?this.map.delete(n):this.map.set(n,h),!0)}has(n){return this.map.has(n)}}t.CounterSet=e}),function(ee,t){typeof define=="function"&&define.amd?define(ge[76],me([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ee=typeof globalThis<"u"?globalThis:ee||self,t(ee.marked={}))}(this,function(ee){"use strict";function t(S,T){for(var O=0;O<T.length;O++){var b=T[O];b.enumerable=b.enumerable||!1,b.configurable=!0,"value"in b&&(b.writable=!0),Object.defineProperty(S,b.key,b)}}function E(S,T,O){return T&&t(S.prototype,T),O&&t(S,O),Object.defineProperty(S,"prototype",{writable:!1}),S}function I(S,T){if(S){if(typeof S=="string")return i(S,T);var O=Object.prototype.toString.call(S).slice(8,-1);if(O==="Object"&&S.constructor&&(O=S.constructor.name),O==="Map"||O==="Set")return Array.from(S);if(O==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(O))return i(S,T)}}function i(S,T){(T==null||T>S.length)&&(T=S.length);for(var O=0,b=new Array(T);O<T;O++)b[O]=S[O];return b}function W(S,T){var O=typeof Symbol<"u"&&S[Symbol.iterator]||S["@@iterator"];if(O)return(O=O.call(S)).next.bind(O);if(Array.isArray(S)||(O=I(S))||T&&S&&typeof S.length=="number"){O&&(S=O);var b=0;return function(){return b>=S.length?{done:!0}:{done:!1,value:S[b++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function w(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=w();function y(S){ee.defaults=S}var c=/[&<>"']/,u=/[&<>"']/g,d=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(T){return r[T]};function e(S,T){if(T){if(c.test(S))return S.replace(u,l)}else if(d.test(S))return S.replace(P,l);return S}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function n(S){return S.replace(a,function(T,O){return O=O.toLowerCase(),O==="colon"?":":O.charAt(0)==="#"?O.charAt(1)==="x"?String.fromCharCode(parseInt(O.substring(2),16)):String.fromCharCode(+O.substring(1)):""})}var h=/(^|[^\[])\^/g;function s(S,T){S=typeof S=="string"?S:S.source,T=T||"";var O={replace:function(x,B){return B=B.source||B,B=B.replace(h,"$1"),S=S.replace(x,B),O},getRegex:function(){return new RegExp(S,T)}};return O}var p=/[^\w:]/g,v=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function C(S,T,O){if(S){var b;try{b=decodeURIComponent(n(O)).replace(p,"").toLowerCase()}catch{return null}if(b.indexOf("javascript:")===0||b.indexOf("vbscript:")===0||b.indexOf("data:")===0)return null}T&&!v.test(O)&&(O=g(T,O));try{O=encodeURI(O).replace(/%25/g,"%")}catch{return null}return O}var f={},D=/^[^:]+:\/*[^/]*$/,M=/^([^:]+:)[\s\S]*$/,R=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(S,T){f[" "+S]||(D.test(S)?f[" "+S]=S+"/":f[" "+S]=A(S,"/",!0)),S=f[" "+S];var O=S.indexOf(":")===-1;return T.substring(0,2)==="//"?O?T:S.replace(M,"$1")+T:T.charAt(0)==="/"?O?T:S.replace(R,"$1")+T:S+T}var m={exec:function(){}};function L(S){for(var T=1,O,b;T<arguments.length;T++){O=arguments[T];for(b in O)Object.prototype.hasOwnProperty.call(O,b)&&(S[b]=O[b])}return S}function k(S,T){var O=S.replace(/\|/g,function(B,N,U){for(var Y=!1,J=N;--J>=0&&U[J]==="\\";)Y=!Y;return Y?"|":" |"}),b=O.split(/ \|/),x=0;if(b[0].trim()||b.shift(),b.length>0&&!b[b.length-1].trim()&&b.pop(),b.length>T)b.splice(T);else for(;b.length<T;)b.push("");for(;x<b.length;x++)b[x]=b[x].trim().replace(/\\\|/g,"|");return b}function A(S,T,O){var b=S.length;if(b===0)return"";for(var x=0;x<b;){var B=S.charAt(b-x-1);if(B===T&&!O)x++;else if(B!==T&&O)x++;else break}return S.slice(0,b-x)}function H(S,T){if(S.indexOf(T[1])===-1)return-1;for(var O=S.length,b=0,x=0;x<O;x++)if(S[x]==="\\")x++;else if(S[x]===T[0])b++;else if(S[x]===T[1]&&(b--,b<0))return x;return-1}function G(S){S&&S.sanitize&&!S.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function ne(S,T){if(T<1)return"";for(var O="";T>1;)T&1&&(O+=S),T>>=1,S+=S;return O+S}function se(S,T,O,b){var x=T.href,B=T.title?e(T.title):null,N=S[1].replace(/\\([\[\]])/g,"$1");if(S[0].charAt(0)!=="!"){b.state.inLink=!0;var U={type:"link",raw:O,href:x,title:B,text:N,tokens:b.inlineTokens(N)};return b.state.inLink=!1,U}return{type:"image",raw:O,href:x,title:B,text:e(N)}}function de(S,T){var O=S.match(/^(\s+)(?:```)/);if(O===null)return T;var b=O[1];return T.split(`
`).map(function(x){var B=x.match(/^\s+/);if(B===null)return x;var N=B[0];return N.length>=b.length?x.slice(b.length):x}).join(`
`)}var ue=function(){function S(O){this.options=O||ee.defaults}var T=S.prototype;return T.space=function(b){var x=this.rules.block.newline.exec(b);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},T.code=function(b){var x=this.rules.block.code.exec(b);if(x){var B=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?B:A(B,`
`)}}},T.fences=function(b){var x=this.rules.block.fences.exec(b);if(x){var B=x[0],N=de(B,x[3]||"");return{type:"code",raw:B,lang:x[2]?x[2].trim():x[2],text:N}}},T.heading=function(b){var x=this.rules.block.heading.exec(b);if(x){var B=x[2].trim();if(/#$/.test(B)){var N=A(B,"#");(this.options.pedantic||!N||/ $/.test(N))&&(B=N.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:B,tokens:this.lexer.inline(B)}}},T.hr=function(b){var x=this.rules.block.hr.exec(b);if(x)return{type:"hr",raw:x[0]}},T.blockquote=function(b){var x=this.rules.block.blockquote.exec(b);if(x){var B=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(B,[]),text:B}}},T.list=function(b){var x=this.rules.block.list.exec(b);if(x){var B,N,U,Y,J,oe,be,De,Le,Se,ve,ke,Ie=x[1].trim(),Ke=Ie.length>1,xe={type:"list",raw:"",ordered:Ke,start:Ke?+Ie.slice(0,-1):"",loose:!1,items:[]};Ie=Ke?"\\d{1,9}\\"+Ie.slice(-1):"\\"+Ie,this.options.pedantic&&(Ie=Ke?Ie:"[*+-]");for(var We=new RegExp("^( {0,3}"+Ie+")((?:[	 ][^\\n]*)?(?:\\n|$))");b&&(ke=!1,!(!(x=We.exec(b))||this.rules.block.hr.test(b)));){if(B=x[0],b=b.substring(B.length),De=x[2].split(`
`,1)[0],Le=b.split(`
`,1)[0],this.options.pedantic?(Y=2,ve=De.trimLeft()):(Y=x[2].search(/[^ ]/),Y=Y>4?1:Y,ve=De.slice(Y),Y+=x[1].length),oe=!1,!De&&/^ *$/.test(Le)&&(B+=Le+`
`,b=b.substring(Le.length+1),ke=!0),!ke)for(var Je=new RegExp("^ {0,"+Math.min(3,Y-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,Y-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Re=new RegExp("^ {0,"+Math.min(3,Y-1)+"}(?:```|~~~)"),Ve=new RegExp("^ {0,"+Math.min(3,Y-1)+"}#");b&&(Se=b.split(`
`,1)[0],De=Se,this.options.pedantic&&(De=De.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Re.test(De)||Ve.test(De)||Je.test(De)||it.test(b)));){if(De.search(/[^ ]/)>=Y||!De.trim())ve+=`
`+De.slice(Y);else if(!oe)ve+=`
`+De;else break;!oe&&!De.trim()&&(oe=!0),B+=Se+`
`,b=b.substring(Se.length+1)}xe.loose||(be?xe.loose=!0:/\n *\n *$/.test(B)&&(be=!0)),this.options.gfm&&(N=/^\[[ xX]\] /.exec(ve),N&&(U=N[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),xe.items.push({type:"list_item",raw:B,task:!!N,checked:U,loose:!1,text:ve}),xe.raw+=B}xe.items[xe.items.length-1].raw=B.trimRight(),xe.items[xe.items.length-1].text=ve.trimRight(),xe.raw=xe.raw.trimRight();var X=xe.items.length;for(J=0;J<X;J++){this.lexer.state.top=!1,xe.items[J].tokens=this.lexer.blockTokens(xe.items[J].text,[]);var ae=xe.items[J].tokens.filter(function(we){return we.type==="space"}),pe=ae.every(function(we){for(var Ee=we.raw.split(""),Pe=0,Ue=W(Ee),Ge;!(Ge=Ue()).done;){var et=Ge.value;if(et===`
`&&(Pe+=1),Pe>1)return!0}return!1});!xe.loose&&ae.length&&pe&&(xe.loose=!0,xe.items[J].loose=!0)}return xe}},T.html=function(b){var x=this.rules.block.html.exec(b);if(x){var B={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var N=this.options.sanitizer?this.options.sanitizer(x[0]):e(x[0]);B.type="paragraph",B.text=N,B.tokens=this.lexer.inline(N)}return B}},T.def=function(b){var x=this.rules.block.def.exec(b);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var B=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:B,raw:x[0],href:x[2],title:x[3]}}},T.table=function(b){var x=this.rules.block.table.exec(b);if(x){var B={type:"table",header:k(x[1]).map(function(be){return{text:be}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(B.header.length===B.align.length){B.raw=x[0];var N=B.align.length,U,Y,J,oe;for(U=0;U<N;U++)/^ *-+: *$/.test(B.align[U])?B.align[U]="right":/^ *:-+: *$/.test(B.align[U])?B.align[U]="center":/^ *:-+ *$/.test(B.align[U])?B.align[U]="left":B.align[U]=null;for(N=B.rows.length,U=0;U<N;U++)B.rows[U]=k(B.rows[U],B.header.length).map(function(be){return{text:be}});for(N=B.header.length,Y=0;Y<N;Y++)B.header[Y].tokens=this.lexer.inline(B.header[Y].text);for(N=B.rows.length,Y=0;Y<N;Y++)for(oe=B.rows[Y],J=0;J<oe.length;J++)oe[J].tokens=this.lexer.inline(oe[J].text);return B}}},T.lheading=function(b){var x=this.rules.block.lheading.exec(b);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},T.paragraph=function(b){var x=this.rules.block.paragraph.exec(b);if(x){var B=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:B,tokens:this.lexer.inline(B)}}},T.text=function(b){var x=this.rules.block.text.exec(b);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},T.escape=function(b){var x=this.rules.inline.escape.exec(b);if(x)return{type:"escape",raw:x[0],text:e(x[1])}},T.tag=function(b){var x=this.rules.inline.tag.exec(b);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):e(x[0]):x[0]}},T.link=function(b){var x=this.rules.inline.link.exec(b);if(x){var B=x[2].trim();if(!this.options.pedantic&&/^</.test(B)){if(!/>$/.test(B))return;var N=A(B.slice(0,-1),"\\");if((B.length-N.length)%2===0)return}else{var U=H(x[2],"()");if(U>-1){var Y=x[0].indexOf("!")===0?5:4,J=Y+x[1].length+U;x[2]=x[2].substring(0,U),x[0]=x[0].substring(0,J).trim(),x[3]=""}}var oe=x[2],be="";if(this.options.pedantic){var De=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(oe);De&&(oe=De[1],be=De[3])}else be=x[3]?x[3].slice(1,-1):"";return oe=oe.trim(),/^</.test(oe)&&(this.options.pedantic&&!/>$/.test(B)?oe=oe.slice(1):oe=oe.slice(1,-1)),se(x,{href:oe&&oe.replace(this.rules.inline._escapes,"$1"),title:be&&be.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},T.reflink=function(b,x){var B;if((B=this.rules.inline.reflink.exec(b))||(B=this.rules.inline.nolink.exec(b))){var N=(B[2]||B[1]).replace(/\s+/g," ");if(N=x[N.toLowerCase()],!N||!N.href){var U=B[0].charAt(0);return{type:"text",raw:U,text:U}}return se(B,N,B[0],this.lexer)}},T.emStrong=function(b,x,B){B===void 0&&(B="");var N=this.rules.inline.emStrong.lDelim.exec(b);if(N&&!(N[3]&&B.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var U=N[1]||N[2]||"";if(!U||U&&(B===""||this.rules.inline.punctuation.exec(B))){var Y=N[0].length-1,J,oe,be=Y,De=0,Le=N[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Le.lastIndex=0,x=x.slice(-1*b.length+Y);(N=Le.exec(x))!=null;)if(J=N[1]||N[2]||N[3]||N[4]||N[5]||N[6],!!J){if(oe=J.length,N[3]||N[4]){be+=oe;continue}else if((N[5]||N[6])&&Y%3&&!((Y+oe)%3)){De+=oe;continue}if(be-=oe,!(be>0)){if(oe=Math.min(oe,oe+be+De),Math.min(Y,oe)%2){var Se=b.slice(1,Y+N.index+oe);return{type:"em",raw:b.slice(0,Y+N.index+oe+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}var ve=b.slice(2,Y+N.index+oe-1);return{type:"strong",raw:b.slice(0,Y+N.index+oe+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},T.codespan=function(b){var x=this.rules.inline.code.exec(b);if(x){var B=x[2].replace(/\n/g," "),N=/[^ ]/.test(B),U=/^ /.test(B)&&/ $/.test(B);return N&&U&&(B=B.substring(1,B.length-1)),B=e(B,!0),{type:"codespan",raw:x[0],text:B}}},T.br=function(b){var x=this.rules.inline.br.exec(b);if(x)return{type:"br",raw:x[0]}},T.del=function(b){var x=this.rules.inline.del.exec(b);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},T.autolink=function(b,x){var B=this.rules.inline.autolink.exec(b);if(B){var N,U;return B[2]==="@"?(N=e(this.options.mangle?x(B[1]):B[1]),U="mailto:"+N):(N=e(B[1]),U=N),{type:"link",raw:B[0],text:N,href:U,tokens:[{type:"text",raw:N,text:N}]}}},T.url=function(b,x){var B;if(B=this.rules.inline.url.exec(b)){var N,U;if(B[2]==="@")N=e(this.options.mangle?x(B[0]):B[0]),U="mailto:"+N;else{var Y;do Y=B[0],B[0]=this.rules.inline._backpedal.exec(B[0])[0];while(Y!==B[0]);N=e(B[0]),B[1]==="www."?U="http://"+N:U=N}return{type:"link",raw:B[0],text:N,href:U,tokens:[{type:"text",raw:N,text:N}]}}},T.inlineText=function(b,x){var B=this.rules.inline.text.exec(b);if(B){var N;return this.lexer.state.inRawBlock?N=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(B[0]):e(B[0]):B[0]:N=e(this.options.smartypants?x(B[0]):B[0]),{type:"text",raw:B[0],text:N}}},S}(),re={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};re._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,re._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,re.def=s(re.def).replace("label",re._label).replace("title",re._title).getRegex(),re.bullet=/(?:[*+-]|\d{1,9}[.)])/,re.listItemStart=s(/^( *)(bull) */).replace("bull",re.bullet).getRegex(),re.list=s(re.list).replace(/bull/g,re.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+re.def.source+")").getRegex(),re._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",re._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,re.html=s(re.html,"i").replace("comment",re._comment).replace("tag",re._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),re.paragraph=s(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.blockquote=s(re.blockquote).replace("paragraph",re.paragraph).getRegex(),re.normal=L({},re),re.gfm=L({},re.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),re.gfm.table=s(re.gfm.table).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.gfm.paragraph=s(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",re.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.pedantic=L({},re.normal,{html:s(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",re._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:s(re.normal._paragraph).replace("hr",re.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",re.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var le={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};le._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",le.punctuation=s(le.punctuation).replace(/punctuation/g,le._punctuation).getRegex(),le.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,le.escapedEmSt=/\\\*|\\_/g,le._comment=s(re._comment).replace("(?:-->|$)","-->").getRegex(),le.emStrong.lDelim=s(le.emStrong.lDelim).replace(/punct/g,le._punctuation).getRegex(),le.emStrong.rDelimAst=s(le.emStrong.rDelimAst,"g").replace(/punct/g,le._punctuation).getRegex(),le.emStrong.rDelimUnd=s(le.emStrong.rDelimUnd,"g").replace(/punct/g,le._punctuation).getRegex(),le._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,le._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,le._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,le.autolink=s(le.autolink).replace("scheme",le._scheme).replace("email",le._email).getRegex(),le._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,le.tag=s(le.tag).replace("comment",le._comment).replace("attribute",le._attribute).getRegex(),le._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,le._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,le._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,le.link=s(le.link).replace("label",le._label).replace("href",le._href).replace("title",le._title).getRegex(),le.reflink=s(le.reflink).replace("label",le._label).replace("ref",re._label).getRegex(),le.nolink=s(le.nolink).replace("ref",re._label).getRegex(),le.reflinkSearch=s(le.reflinkSearch,"g").replace("reflink",le.reflink).replace("nolink",le.nolink).getRegex(),le.normal=L({},le),le.pedantic=L({},le.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:s(/^!?\[(label)\]\((.*?)\)/).replace("label",le._label).getRegex(),reflink:s(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",le._label).getRegex()}),le.gfm=L({},le.normal,{escape:s(le.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),le.gfm.url=s(le.gfm.url,"i").replace("email",le.gfm._extended_email).getRegex(),le.breaks=L({},le.gfm,{br:s(le.br).replace("{2,}","*").getRegex(),text:s(le.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ye(S){return S.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Te(S){var T="",O,b,x=S.length;for(O=0;O<x;O++)b=S.charCodeAt(O),Math.random()>.5&&(b="x"+b.toString(16)),T+="&#"+b+";";return T}var Me=function(){function S(O){this.tokens=[],this.tokens.links=Object.create(null),this.options=O||ee.defaults,this.options.tokenizer=this.options.tokenizer||new ue,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var b={block:re.normal,inline:le.normal};this.options.pedantic?(b.block=re.pedantic,b.inline=le.pedantic):this.options.gfm&&(b.block=re.gfm,this.options.breaks?b.inline=le.breaks:b.inline=le.gfm),this.tokenizer.rules=b}S.lex=function(b,x){var B=new S(x);return B.lex(b)},S.lexInline=function(b,x){var B=new S(x);return B.inlineTokens(b)};var T=S.prototype;return T.lex=function(b){b=b.replace(/\r\n|\r/g,`
`),this.blockTokens(b,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},T.blockTokens=function(b,x){var B=this;x===void 0&&(x=[]),this.options.pedantic?b=b.replace(/\t/g,"    ").replace(/^ +$/gm,""):b=b.replace(/^( *)(\t+)/gm,function(be,De,Le){return De+"    ".repeat(Le.length)});for(var N,U,Y,J;b;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(be){return(N=be.call({lexer:B},b,x))?(b=b.substring(N.raw.length),x.push(N),!0):!1}))){if(N=this.tokenizer.space(b)){b=b.substring(N.raw.length),N.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(N);continue}if(N=this.tokenizer.code(b)){b=b.substring(N.raw.length),U=x[x.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+N.raw,U.text+=`
`+N.text,this.inlineQueue[this.inlineQueue.length-1].src=U.text):x.push(N);continue}if(N=this.tokenizer.fences(b)){b=b.substring(N.raw.length),x.push(N);continue}if(N=this.tokenizer.heading(b)){b=b.substring(N.raw.length),x.push(N);continue}if(N=this.tokenizer.hr(b)){b=b.substring(N.raw.length),x.push(N);continue}if(N=this.tokenizer.blockquote(b)){b=b.substring(N.raw.length),x.push(N);continue}if(N=this.tokenizer.list(b)){b=b.substring(N.raw.length),x.push(N);continue}if(N=this.tokenizer.html(b)){b=b.substring(N.raw.length),x.push(N);continue}if(N=this.tokenizer.def(b)){b=b.substring(N.raw.length),U=x[x.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+N.raw,U.text+=`
`+N.raw,this.inlineQueue[this.inlineQueue.length-1].src=U.text):this.tokens.links[N.tag]||(this.tokens.links[N.tag]={href:N.href,title:N.title});continue}if(N=this.tokenizer.table(b)){b=b.substring(N.raw.length),x.push(N);continue}if(N=this.tokenizer.lheading(b)){b=b.substring(N.raw.length),x.push(N);continue}if(Y=b,this.options.extensions&&this.options.extensions.startBlock&&function(){var be=1/0,De=b.slice(1),Le=void 0;B.options.extensions.startBlock.forEach(function(Se){Le=Se.call({lexer:this},De),typeof Le=="number"&&Le>=0&&(be=Math.min(be,Le))}),be<1/0&&be>=0&&(Y=b.substring(0,be+1))}(),this.state.top&&(N=this.tokenizer.paragraph(Y))){U=x[x.length-1],J&&U.type==="paragraph"?(U.raw+=`
`+N.raw,U.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):x.push(N),J=Y.length!==b.length,b=b.substring(N.raw.length);continue}if(N=this.tokenizer.text(b)){b=b.substring(N.raw.length),U=x[x.length-1],U&&U.type==="text"?(U.raw+=`
`+N.raw,U.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):x.push(N);continue}if(b){var oe="Infinite loop on byte: "+b.charCodeAt(0);if(this.options.silent){console.error(oe);break}else throw new Error(oe)}}return this.state.top=!0,x},T.inline=function(b,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:b,tokens:x}),x},T.inlineTokens=function(b,x){var B=this;x===void 0&&(x=[]);var N,U,Y,J=b,oe,be,De;if(this.tokens.links){var Le=Object.keys(this.tokens.links);if(Le.length>0)for(;(oe=this.tokenizer.rules.inline.reflinkSearch.exec(J))!=null;)Le.includes(oe[0].slice(oe[0].lastIndexOf("[")+1,-1))&&(J=J.slice(0,oe.index)+"["+ne("a",oe[0].length-2)+"]"+J.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(oe=this.tokenizer.rules.inline.blockSkip.exec(J))!=null;)J=J.slice(0,oe.index)+"["+ne("a",oe[0].length-2)+"]"+J.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(oe=this.tokenizer.rules.inline.escapedEmSt.exec(J))!=null;)J=J.slice(0,oe.index)+"++"+J.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;b;)if(be||(De=""),be=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(N=ve.call({lexer:B},b,x))?(b=b.substring(N.raw.length),x.push(N),!0):!1}))){if(N=this.tokenizer.escape(b)){b=b.substring(N.raw.length),x.push(N);continue}if(N=this.tokenizer.tag(b)){b=b.substring(N.raw.length),U=x[x.length-1],U&&N.type==="text"&&U.type==="text"?(U.raw+=N.raw,U.text+=N.text):x.push(N);continue}if(N=this.tokenizer.link(b)){b=b.substring(N.raw.length),x.push(N);continue}if(N=this.tokenizer.reflink(b,this.tokens.links)){b=b.substring(N.raw.length),U=x[x.length-1],U&&N.type==="text"&&U.type==="text"?(U.raw+=N.raw,U.text+=N.text):x.push(N);continue}if(N=this.tokenizer.emStrong(b,J,De)){b=b.substring(N.raw.length),x.push(N);continue}if(N=this.tokenizer.codespan(b)){b=b.substring(N.raw.length),x.push(N);continue}if(N=this.tokenizer.br(b)){b=b.substring(N.raw.length),x.push(N);continue}if(N=this.tokenizer.del(b)){b=b.substring(N.raw.length),x.push(N);continue}if(N=this.tokenizer.autolink(b,Te)){b=b.substring(N.raw.length),x.push(N);continue}if(!this.state.inLink&&(N=this.tokenizer.url(b,Te))){b=b.substring(N.raw.length),x.push(N);continue}if(Y=b,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,ke=b.slice(1),Ie=void 0;B.options.extensions.startInline.forEach(function(Ke){Ie=Ke.call({lexer:this},ke),typeof Ie=="number"&&Ie>=0&&(ve=Math.min(ve,Ie))}),ve<1/0&&ve>=0&&(Y=b.substring(0,ve+1))}(),N=this.tokenizer.inlineText(Y,ye)){b=b.substring(N.raw.length),N.raw.slice(-1)!=="_"&&(De=N.raw.slice(-1)),be=!0,U=x[x.length-1],U&&U.type==="text"?(U.raw+=N.raw,U.text+=N.text):x.push(N);continue}if(b){var Se="Infinite loop on byte: "+b.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return x},E(S,null,[{key:"rules",get:function(){return{block:re,inline:le}}}]),S}(),Oe=function(){function S(O){this.options=O||ee.defaults}var T=S.prototype;return T.code=function(b,x,B){var N=(x||"").match(/\S*/)[0];if(this.options.highlight){var U=this.options.highlight(b,N);U!=null&&U!==b&&(B=!0,b=U)}return b=b.replace(/\n$/,"")+`
`,N?'<pre><code class="'+this.options.langPrefix+e(N,!0)+'">'+(B?b:e(b,!0))+`</code></pre>
`:"<pre><code>"+(B?b:e(b,!0))+`</code></pre>
`},T.blockquote=function(b){return`<blockquote>
`+b+`</blockquote>
`},T.html=function(b){return b},T.heading=function(b,x,B,N){if(this.options.headerIds){var U=this.options.headerPrefix+N.slug(B);return"<h"+x+' id="'+U+'">'+b+"</h"+x+`>
`}return"<h"+x+">"+b+"</h"+x+`>
`},T.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},T.list=function(b,x,B){var N=x?"ol":"ul",U=x&&B!==1?' start="'+B+'"':"";return"<"+N+U+`>
`+b+"</"+N+`>
`},T.listitem=function(b){return"<li>"+b+`</li>
`},T.checkbox=function(b){return"<input "+(b?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},T.paragraph=function(b){return"<p>"+b+`</p>
`},T.table=function(b,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+b+`</thead>
`+x+`</table>
`},T.tablerow=function(b){return`<tr>
`+b+`</tr>
`},T.tablecell=function(b,x){var B=x.header?"th":"td",N=x.align?"<"+B+' align="'+x.align+'">':"<"+B+">";return N+b+("</"+B+`>
`)},T.strong=function(b){return"<strong>"+b+"</strong>"},T.em=function(b){return"<em>"+b+"</em>"},T.codespan=function(b){return"<code>"+b+"</code>"},T.br=function(){return this.options.xhtml?"<br/>":"<br>"},T.del=function(b){return"<del>"+b+"</del>"},T.link=function(b,x,B){if(b=C(this.options.sanitize,this.options.baseUrl,b),b===null)return B;var N='<a href="'+e(b)+'"';return x&&(N+=' title="'+x+'"'),N+=">"+B+"</a>",N},T.image=function(b,x,B){if(b=C(this.options.sanitize,this.options.baseUrl,b),b===null)return B;var N='<img src="'+b+'" alt="'+B+'"';return x&&(N+=' title="'+x+'"'),N+=this.options.xhtml?"/>":">",N},T.text=function(b){return b},S}(),ce=function(){function S(){}var T=S.prototype;return T.strong=function(b){return b},T.em=function(b){return b},T.codespan=function(b){return b},T.del=function(b){return b},T.html=function(b){return b},T.text=function(b){return b},T.link=function(b,x,B){return""+B},T.image=function(b,x,B){return""+B},T.br=function(){return""},S}(),ie=function(){function S(){this.seen={}}var T=S.prototype;return T.serialize=function(b){return b.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},T.getNextSafeSlug=function(b,x){var B=b,N=0;if(this.seen.hasOwnProperty(B)){N=this.seen[b];do N++,B=b+"-"+N;while(this.seen.hasOwnProperty(B))}return x||(this.seen[b]=N,this.seen[B]=0),B},T.slug=function(b,x){x===void 0&&(x={});var B=this.serialize(b);return this.getNextSafeSlug(B,x.dryrun)},S}(),q=function(){function S(O){this.options=O||ee.defaults,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ce,this.slugger=new ie}S.parse=function(b,x){var B=new S(x);return B.parse(b)},S.parseInline=function(b,x){var B=new S(x);return B.parseInline(b)};var T=S.prototype;return T.parse=function(b,x){x===void 0&&(x=!0);var B="",N,U,Y,J,oe,be,De,Le,Se,ve,ke,Ie,Ke,xe,We,Je,it,Re,Ve,X=b.length;for(N=0;N<X;N++){if(ve=b[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(Ve=this.options.extensions.renderers[ve.type].call({parser:this},ve),Ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){B+=Ve||"";continue}switch(ve.type){case"space":continue;case"hr":{B+=this.renderer.hr();continue}case"heading":{B+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,n(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{B+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Le="",De="",J=ve.header.length,U=0;U<J;U++)De+=this.renderer.tablecell(this.parseInline(ve.header[U].tokens),{header:!0,align:ve.align[U]});for(Le+=this.renderer.tablerow(De),Se="",J=ve.rows.length,U=0;U<J;U++){for(be=ve.rows[U],De="",oe=be.length,Y=0;Y<oe;Y++)De+=this.renderer.tablecell(this.parseInline(be[Y].tokens),{header:!1,align:ve.align[Y]});Se+=this.renderer.tablerow(De)}B+=this.renderer.table(Le,Se);continue}case"blockquote":{Se=this.parse(ve.tokens),B+=this.renderer.blockquote(Se);continue}case"list":{for(ke=ve.ordered,Ie=ve.start,Ke=ve.loose,J=ve.items.length,Se="",U=0;U<J;U++)We=ve.items[U],Je=We.checked,it=We.task,xe="",We.task&&(Re=this.renderer.checkbox(Je),Ke?We.tokens.length>0&&We.tokens[0].type==="paragraph"?(We.tokens[0].text=Re+" "+We.tokens[0].text,We.tokens[0].tokens&&We.tokens[0].tokens.length>0&&We.tokens[0].tokens[0].type==="text"&&(We.tokens[0].tokens[0].text=Re+" "+We.tokens[0].tokens[0].text)):We.tokens.unshift({type:"text",text:Re}):xe+=Re),xe+=this.parse(We.tokens,Ke),Se+=this.renderer.listitem(xe,it,Je);B+=this.renderer.list(Se,ke,Ie);continue}case"html":{B+=this.renderer.html(ve.text);continue}case"paragraph":{B+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Se=ve.tokens?this.parseInline(ve.tokens):ve.text;N+1<X&&b[N+1].type==="text";)ve=b[++N],Se+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);B+=x?this.renderer.paragraph(Se):Se;continue}default:{var ae='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(ae);return}else throw new Error(ae)}}}return B},T.parseInline=function(b,x){x=x||this.renderer;var B="",N,U,Y,J=b.length;for(N=0;N<J;N++){if(U=b[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[U.type]&&(Y=this.options.extensions.renderers[U.type].call({parser:this},U),Y!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(U.type))){B+=Y||"";continue}switch(U.type){case"escape":{B+=x.text(U.text);break}case"html":{B+=x.html(U.text);break}case"link":{B+=x.link(U.href,U.title,this.parseInline(U.tokens,x));break}case"image":{B+=x.image(U.href,U.title,U.text);break}case"strong":{B+=x.strong(this.parseInline(U.tokens,x));break}case"em":{B+=x.em(this.parseInline(U.tokens,x));break}case"codespan":{B+=x.codespan(U.text);break}case"br":{B+=x.br();break}case"del":{B+=x.del(this.parseInline(U.tokens,x));break}case"text":{B+=x.text(U.text);break}default:{var oe='Token with "'+U.type+'" type was not found.';if(this.options.silent){console.error(oe);return}else throw new Error(oe)}}}return B},S}();function $(S,T,O){if(typeof S>"u"||S===null)throw new Error("marked(): input parameter is undefined or null");if(typeof S!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(S)+", string expected");if(typeof T=="function"&&(O=T,T=null),T=L({},$.defaults,T||{}),G(T),O){var b=T.highlight,x;try{x=Me.lex(S,T)}catch(J){return O(J)}var B=function(oe){var be;if(!oe)try{T.walkTokens&&$.walkTokens(x,T.walkTokens),be=q.parse(x,T)}catch(De){oe=De}return T.highlight=b,oe?O(oe):O(null,be)};if(!b||b.length<3||(delete T.highlight,!x.length))return B();var N=0;$.walkTokens(x,function(J){J.type==="code"&&(N++,setTimeout(function(){b(J.text,J.lang,function(oe,be){if(oe)return B(oe);be!=null&&be!==J.text&&(J.text=be,J.escaped=!0),N--,N===0&&B()})},0))}),N===0&&B();return}function U(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,T.silent)return"<p>An error occurred:</p><pre>"+e(J.message+"",!0)+"</pre>";throw J}try{var Y=Me.lex(S,T);if(T.walkTokens){if(T.async)return Promise.all($.walkTokens(Y,T.walkTokens)).then(function(){return q.parse(Y,T)}).catch(U);$.walkTokens(Y,T.walkTokens)}return q.parse(Y,T)}catch(J){U(J)}}$.options=$.setOptions=function(S){return L($.defaults,S),y($.defaults),$},$.getDefaults=w,$.defaults=ee.defaults,$.use=function(){for(var S=arguments.length,T=new Array(S),O=0;O<S;O++)T[O]=arguments[O];var b=L.apply(void 0,[{}].concat(T)),x=$.defaults.extensions||{renderers:{},childTokens:{}},B;T.forEach(function(N){if(N.extensions&&(B=!0,N.extensions.forEach(function(Y){if(!Y.name)throw new Error("extension name required");if(Y.renderer){var J=x.renderers?x.renderers[Y.name]:null;J?x.renderers[Y.name]=function(){for(var oe=arguments.length,be=new Array(oe),De=0;De<oe;De++)be[De]=arguments[De];var Le=Y.renderer.apply(this,be);return Le===!1&&(Le=J.apply(this,be)),Le}:x.renderers[Y.name]=Y.renderer}if(Y.tokenizer){if(!Y.level||Y.level!=="block"&&Y.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[Y.level]?x[Y.level].unshift(Y.tokenizer):x[Y.level]=[Y.tokenizer],Y.start&&(Y.level==="block"?x.startBlock?x.startBlock.push(Y.start):x.startBlock=[Y.start]:Y.level==="inline"&&(x.startInline?x.startInline.push(Y.start):x.startInline=[Y.start]))}Y.childTokens&&(x.childTokens[Y.name]=Y.childTokens)})),N.renderer&&function(){var Y=$.defaults.renderer||new Oe,J=function(De){var Le=Y[De];Y[De]=function(){for(var Se=arguments.length,ve=new Array(Se),ke=0;ke<Se;ke++)ve[ke]=arguments[ke];var Ie=N.renderer[De].apply(Y,ve);return Ie===!1&&(Ie=Le.apply(Y,ve)),Ie}};for(var oe in N.renderer)J(oe);b.renderer=Y}(),N.tokenizer&&function(){var Y=$.defaults.tokenizer||new ue,J=function(De){var Le=Y[De];Y[De]=function(){for(var Se=arguments.length,ve=new Array(Se),ke=0;ke<Se;ke++)ve[ke]=arguments[ke];var Ie=N.tokenizer[De].apply(Y,ve);return Ie===!1&&(Ie=Le.apply(Y,ve)),Ie}};for(var oe in N.tokenizer)J(oe);b.tokenizer=Y}(),N.walkTokens){var U=$.defaults.walkTokens;b.walkTokens=function(Y){var J=[];return J.push(N.walkTokens.call(this,Y)),U&&(J=J.concat(U.call(this,Y))),J}}B&&(b.extensions=x),$.setOptions(b)})},$.walkTokens=function(S,T){for(var O=[],b=function(){var U=B.value;switch(O=O.concat(T.call($,U)),U.type){case"table":{for(var Y=W(U.header),J;!(J=Y()).done;){var oe=J.value;O=O.concat($.walkTokens(oe.tokens,T))}for(var be=W(U.rows),De;!(De=be()).done;)for(var Le=De.value,Se=W(Le),ve;!(ve=Se()).done;){var ke=ve.value;O=O.concat($.walkTokens(ke.tokens,T))}break}case"list":{O=O.concat($.walkTokens(U.items,T));break}default:$.defaults.extensions&&$.defaults.extensions.childTokens&&$.defaults.extensions.childTokens[U.type]?$.defaults.extensions.childTokens[U.type].forEach(function(Ie){O=O.concat($.walkTokens(U[Ie],T))}):U.tokens&&(O=O.concat($.walkTokens(U.tokens,T)))}},x=W(S),B;!(B=x()).done;)b();return O},$.parseInline=function(S,T){if(typeof S>"u"||S===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof S!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(S)+", string expected");T=L({},$.defaults,T||{}),G(T);try{var O=Me.lexInline(S,T);return T.walkTokens&&$.walkTokens(O,T.walkTokens),q.parseInline(O,T)}catch(b){if(b.message+=`
Please report this to https://github.com/markedjs/marked.`,T.silent)return"<p>An error occurred:</p><pre>"+e(b.message+"",!0)+"</pre>";throw b}},$.Parser=q,$.parser=q.parse,$.Renderer=Oe,$.TextRenderer=ce,$.Lexer=Me,$.lexer=Me.lex,$.Tokenizer=ue,$.Slugger=ie,$.parse=$;var V=$.options,_=$.setOptions,K=$.use,z=$.walkTokens,o=$.parseInline,F=$,j=q.parse,te=Me.lex;ee.Lexer=Me,ee.Parser=q,ee.Renderer=Oe,ee.Slugger=ie,ee.TextRenderer=ce,ee.Tokenizer=ue,ee.getDefaults=w,ee.lexer=te,ee.marked=$,ee.options=V,ee.parse=F,ee.parseInline=o,ee.parser=j,ee.setOptions=_,ee.use=K,ee.walkTokens=z,Object.defineProperty(ee,"__esModule",{value:!0})}),define(ge[77],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class E{constructor(i,W=0,w=i.length,y=W-1){this.items=i,this.start=W,this.end=w,this.index=y}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=E}),define(ge[78],me([1,0,77]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class I{constructor(w=[],y=10){this._initialize(w),this._limit=y,this._onChange()}getHistory(){return this._elements}add(w){this._history.delete(w),this._history.add(w),this._onChange()}next(){return this._navigator.next()}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}isFirst(){return this._currentPosition()===0}isLast(){return this._currentPosition()>=this._elements.length-1}isNowhere(){return this._navigator.current()===null}has(w){return this._history.has(w)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const w=this._elements;this._navigator=new E.ArrayNavigator(w,0,w.length,w.length)}_reduceToLimit(){const w=this._elements;w.length>this._limit&&this._initialize(w.slice(w.length-this._limit))}_currentPosition(){const w=this._navigator.current();return w?this._elements.indexOf(w):-1}_initialize(w){this._history=new Set;for(const y of w)this._history.add(y)}get _elements(){const w=[];return this._history.forEach(y=>w.push(y)),w}}t.HistoryNavigator=I;class i{constructor(w,y=10){if(this.capacity=y,w.length<1)throw new Error("not supported");this.size=1,this.head=this.tail=this.cursor={value:w[0],previous:void 0,next:void 0},this.valueSet=new Set([w[0]]);for(let c=1;c<w.length;c++)this.add(w[c])}add(w){const y={value:w,previous:this.tail,next:void 0};for(this.tail.next=y,this.tail=y,this.cursor=this.tail,this.size++,this.valueSet.has(w)?this._deleteFromList(w):this.valueSet.add(w);this.size>this.capacity;)this.valueSet.delete(this.head.value),this.head=this.head.next,this.head.previous=void 0,this.size--}replaceLast(w){if(this.tail.value===w)return w;const y=this.tail.value;return this.valueSet.delete(y),this.tail.value=w,this.valueSet.has(w)?this._deleteFromList(w):this.valueSet.add(w),y}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(w){return this.valueSet.has(w)}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let w=this.head;for(;w;)yield w.value,w=w.next}_deleteFromList(w){let y=this.head;for(;y!==this.tail;)y.value===w&&(y===this.head?(this.head=this.head.next,this.head.previous=void 0):(y.previous.next=y.next,y.next.previous=y.previous),this.size--),y=y.next}}t.HistoryNavigator2=i}),define(ge[44],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function E(y,c,u){return Math.min(Math.max(y,c),u)}t.clamp=E;function I(y,c){return(c+y%c)%c}t.rot=I;class i{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=i;class W{constructor(){this._n=1,this._val=0}update(c){return this._val=this._val+(c-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=W;class w{constructor(c){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(c),this._values.fill(0,0,c)}update(c){const u=this._values[this._index];return this._values[this._index]=c,this._index=(this._index+1)%this._values.length,this._sum-=u,this._sum+=c,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=w}),define(ge[45],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var E;(function(I){function i(c,u){if(c.start>=u.end||u.start>=c.end)return{start:0,end:0};const d=Math.max(c.start,u.start),P=Math.min(c.end,u.end);return P-d<=0?{start:0,end:0}:{start:d,end:P}}I.intersect=i;function W(c){return c.end-c.start<=0}I.isEmpty=W;function w(c,u){return!W(i(c,u))}I.intersects=w;function y(c,u){const d=[],P={start:c.start,end:Math.min(u.start,c.end)},r={start:Math.max(u.end,c.start),end:c.end};return W(P)||d.push(P),W(r)||d.push(r),d}I.relativeComplement=y})(E||(t.Range=E={}))}),define(ge[79],me([1,0,45]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function I(c,u){const d=[];for(const P of u){if(c.start>=P.range.end)continue;if(c.end<P.range.start)break;const r=E.Range.intersect(c,P.range);E.Range.isEmpty(r)||d.push({range:r,size:P.size})}return d}t.groupIntersect=I;function i({start:c,end:u},d){return{start:c+d,end:u+d}}t.shift=i;function W(c){const u=[];let d=null;for(const P of c){const r=P.range.start,l=P.range.end,e=P.size;if(d&&e===d.size){d.range.end=l;continue}d={range:{start:r,end:l},size:e},u.push(d)}return u}t.consolidate=W;function w(...c){return W(c.reduce((u,d)=>u.concat(d),[]))}class y{constructor(){this.groups=[],this._size=0}splice(u,d,P=[]){const r=P.length-d,l=I({start:0,end:u},this.groups),e=I({start:u+d,end:Number.POSITIVE_INFINITY},this.groups).map(n=>({range:i(n.range,r),size:n.size})),a=P.map((n,h)=>({range:{start:u+h,end:u+h+1},size:n.size}));this.groups=w(l,a,e),this._size=this.groups.reduce((n,h)=>n+h.size*(h.range.end-h.range.start),0)}get count(){const u=this.groups.length;return u?this.groups[u-1].range.end:0}get size(){return this._size}indexAt(u){if(u<0)return-1;let d=0,P=0;for(const r of this.groups){const l=r.range.end-r.range.start,e=P+l*r.size;if(u<e)return d+Math.floor((u-P)/r.size);d+=l,P=e}return d}indexAfter(u){return Math.min(this.indexAt(u)+1,this.count)}positionAt(u){if(u<0)return-1;let d=0,P=0;for(const r of this.groups){const l=r.range.end-r.range.start,e=P+l;if(u<e)return d+(u-P)*r.size;d+=l*r.size,P=e}return-1}}t.RangeMap=y}),define(ge[80],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const E=globalThis.performance&&typeof globalThis.performance.now=="function";class I{static create(W){return new I(W)}constructor(W){this._now=E&&W===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=I}),define(ge[3],me([1,0,7,41,2,43,80]),function(ee,t,E,I,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const y=!1,c=!1;var u;(function(k){k.None=()=>i.Disposable.None;function A(S){if(c){const{onDidAddListener:T}=S,O=e.create();let b=0;S.onDidAddListener=()=>{++b===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),O.print()),T?.()}}}function H(S,T){return Te(S,()=>{},0,void 0,!0,void 0,T)}k.defer=H;function G(S){return(T,O=null,b)=>{let x=!1,B;return B=S(N=>{if(!x)return B?B.dispose():x=!0,T.call(O,N)},null,b),x&&B.dispose(),B}}k.once=G;function ne(S,T,O){return ye((b,x=null,B)=>S(N=>b.call(x,T(N)),null,B),O)}k.map=ne;function se(S,T,O){return ye((b,x=null,B)=>S(N=>{T(N),b.call(x,N)},null,B),O)}k.forEach=se;function de(S,T,O){return ye((b,x=null,B)=>S(N=>T(N)&&b.call(x,N),null,B),O)}k.filter=de;function ue(S){return S}k.signal=ue;function re(...S){return(T,O=null,b)=>(0,i.combinedDisposable)(...S.map(x=>x(B=>T.call(O,B),null,b)))}k.any=re;function le(S,T,O,b){let x=O;return ne(S,B=>(x=T(x,B),x),b)}k.reduce=le;function ye(S,T){let O;const b={onWillAddFirstListener(){O=S(x.fire,x)},onDidRemoveLastListener(){O?.dispose()}};T||A(b);const x=new p(b);return T?.add(x),x.event}function Te(S,T,O=100,b=!1,x=!1,B,N){let U,Y,J,oe=0,be;const De={leakWarningThreshold:B,onWillAddFirstListener(){U=S(Se=>{oe++,Y=T(Y,Se),b&&!J&&(Le.fire(Y),Y=void 0),be=()=>{const ve=Y;Y=void 0,J=void 0,(!b||oe>1)&&Le.fire(ve),oe=0},typeof O=="number"?(clearTimeout(J),J=setTimeout(be,O)):J===void 0&&(J=0,queueMicrotask(be))})},onWillRemoveListener(){x&&oe>0&&be?.()},onDidRemoveLastListener(){be=void 0,U.dispose()}};N||A(De);const Le=new p(De);return N?.add(Le),Le.event}k.debounce=Te;function Me(S,T=0,O){return k.debounce(S,(b,x)=>b?(b.push(x),b):[x],T,void 0,!0,void 0,O)}k.accumulate=Me;function Oe(S,T=(b,x)=>b===x,O){let b=!0,x;return de(S,B=>{const N=b||!T(B,x);return b=!1,x=B,N},O)}k.latch=Oe;function ce(S,T,O){return[k.filter(S,T,O),k.filter(S,b=>!T(b),O)]}k.split=ce;function ie(S,T=!1,O=[]){let b=O.slice(),x=S(U=>{b?b.push(U):N.fire(U)});const B=()=>{b?.forEach(U=>N.fire(U)),b=null},N=new p({onWillAddFirstListener(){x||(x=S(U=>N.fire(U)))},onDidAddFirstListener(){b&&(T?setTimeout(B):B())},onDidRemoveLastListener(){x&&x.dispose(),x=null}});return N.event}k.buffer=ie;class q{constructor(T){this.event=T,this.disposables=new i.DisposableStore}map(T){return new q(ne(this.event,T,this.disposables))}forEach(T){return new q(se(this.event,T,this.disposables))}filter(T){return new q(de(this.event,T,this.disposables))}reduce(T,O){return new q(le(this.event,T,O,this.disposables))}latch(){return new q(Oe(this.event,void 0,this.disposables))}debounce(T,O=100,b=!1,x=!1,B){return new q(Te(this.event,T,O,b,x,B,this.disposables))}on(T,O,b){return this.event(T,O,b)}once(T,O,b){return G(this.event)(T,O,b)}dispose(){this.disposables.dispose()}}function $(S){return new q(S)}k.chain=$;function V(S,T,O=b=>b){const b=(...U)=>N.fire(O(...U)),x=()=>S.on(T,b),B=()=>S.removeListener(T,b),N=new p({onWillAddFirstListener:x,onDidRemoveLastListener:B});return N.event}k.fromNodeEventEmitter=V;function _(S,T,O=b=>b){const b=(...U)=>N.fire(O(...U)),x=()=>S.addEventListener(T,b),B=()=>S.removeEventListener(T,b),N=new p({onWillAddFirstListener:x,onDidRemoveLastListener:B});return N.event}k.fromDOMEventEmitter=_;function K(S){return new Promise(T=>G(S)(T))}k.toPromise=K;function z(S,T){return T(void 0),S(O=>T(O))}k.runAndSubscribe=z;function o(S,T){let O=null;function b(B){O?.dispose(),O=new i.DisposableStore,T(B,O)}b(void 0);const x=S(B=>b(B));return(0,i.toDisposable)(()=>{x.dispose(),O?.dispose()})}k.runAndSubscribeWithStore=o;class F{constructor(T,O){this._observable=T,this._counter=0,this._hasChanged=!1;const b={onWillAddFirstListener:()=>{T.addObserver(this)},onDidRemoveLastListener:()=>{T.removeObserver(this)}};O||A(b),this.emitter=new p(b),O&&O.add(this.emitter)}beginUpdate(T){this._counter++}handlePossibleChange(T){}handleChange(T,O){this._hasChanged=!0}endUpdate(T){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function j(S,T){return new F(S,T).emitter.event}k.fromObservable=j;function te(S){return T=>{let O=0,b=!1;const x={beginUpdate(){O++},endUpdate(){O--,O===0&&(S.reportChanges(),b&&(b=!1,T()))},handlePossibleChange(){},handleChange(){b=!0}};return S.addObserver(x),{dispose(){S.removeObserver(x)}}}}k.fromObservableLight=te})(u||(t.Event=u={}));class d{constructor(A){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${A}_${d._idPool++}`,d.all.add(this)}start(A){this._stopWatch=new w.StopWatch,this.listenerCount=A}stop(){if(this._stopWatch){const A=this._stopWatch.elapsed();this.durations.push(A),this.elapsedOverall+=A,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=d,d.all=new Set,d._idPool=0;let P=-1;function r(k){const A=P;return P=k,{dispose(){P=A}}}t.setGlobalLeakWarningThreshold=r;class l{constructor(A,H=Math.random().toString(18).slice(2,5)){this.threshold=A,this.name=H,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(A,H){const G=this.threshold;if(G<=0||H<G)return;this._stacks||(this._stacks=new Map);const ne=this._stacks.get(A.value)||0;if(this._stacks.set(A.value,ne+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=G*.5;let se,de=0;for(const[ue,re]of this._stacks)(!se||de<re)&&(se=ue,de=re);console.warn(`[${this.name}] potential listener LEAK detected, having ${H} listeners already. MOST frequent listener (${de}):`),console.warn(se)}return()=>{const se=this._stacks.get(A.value)||0;this._stacks.set(A.value,se-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(A){this.value=A}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let a=0;class n{constructor(A){this.value=A,this.id=a++}}const h=2,s=(k,A)=>{if(k instanceof n)A(k);else for(let H=0;H<k.length;H++){const G=k[H];G&&A(G)}};class p{constructor(A){this._size=0,this._options=A,this._leakageMon=P>0||this._options?.leakWarningThreshold?new l(this._options?.leakWarningThreshold??P):void 0,this._perfMon=this._options?._profName?new d(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(y){const A=this._listeners;queueMicrotask(()=>{s(A,H=>H.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(A,H,G)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;if(this._disposed)return i.Disposable.None;H&&(A=A.bind(H));const ne=new n(A);let se,de;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(ne.stack=e.create(),se=this._leakageMon.check(ne.stack,this._size+1)),y&&(ne.stack=de??e.create()),this._listeners?this._listeners instanceof n?(this._deliveryQueue??=new C,this._listeners=[this._listeners,ne]):this._listeners.push(ne):(this._options?.onWillAddFirstListener?.(this),this._listeners=ne,this._options?.onDidAddFirstListener?.(this)),this._size++;const ue=(0,i.toDisposable)(()=>{se?.(),this._removeListener(ne)});return G instanceof i.DisposableStore?G.add(ue):Array.isArray(G)&&G.push(ue),ue},this._event}_removeListener(A){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const H=this._listeners,G=H.indexOf(A);if(G===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,H[G]=void 0;const ne=this._deliveryQueue.current===this;if(this._size*h<=H.length){let se=0;for(let de=0;de<H.length;de++)H[de]?H[se++]=H[de]:ne&&(this._deliveryQueue.end--,se<this._deliveryQueue.i&&this._deliveryQueue.i--);H.length=se}}_deliver(A,H){if(!A)return;const G=this._options?.onListenerError||E.onUnexpectedError;if(!G){A.value(H);return}try{A.value(H)}catch(ne){G(ne)}}_deliverQueue(A){const H=A.current._listeners;for(;A.i<A.end;)this._deliver(H[A.i++],A.value);A.reset()}fire(A){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof n)this._deliver(this._listeners,A);else{const H=this._deliveryQueue;H.enqueue(this,A,this._listeners.length),this._deliverQueue(H)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=p;const v=()=>new C;t.createEventDeliveryQueue=v;class C{constructor(){this.i=-1,this.end=0}enqueue(A,H,G){this.i=0,this.end=G,this.current=A,this.value=H}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class f extends p{async fireAsync(A,H,G){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new W.LinkedList),s(this._listeners,ne=>this._asyncDeliveryQueue.push([ne.value,A]));this._asyncDeliveryQueue.size>0&&!H.isCancellationRequested;){const[ne,se]=this._asyncDeliveryQueue.shift(),de=[],ue={...se,token:H,waitUntil:re=>{if(Object.isFrozen(de))throw new Error("waitUntil can NOT be called asynchronous");G&&(re=G(re,ne)),de.push(re)}};try{ne(ue)}catch(re){(0,E.onUnexpectedError)(re);continue}Object.freeze(de),await Promise.allSettled(de).then(re=>{for(const le of re)le.status==="rejected"&&(0,E.onUnexpectedError)(le.reason)})}}}t.AsyncEmitter=f;class D extends p{get isPaused(){return this._isPaused!==0}constructor(A){super(A),this._isPaused=0,this._eventQueue=new W.LinkedList,this._mergeFn=A?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const A=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(A))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(A){this._size&&(this._isPaused!==0?this._eventQueue.push(A):super.fire(A))}}t.PauseableEmitter=D;class M extends D{constructor(A){super(A),this._delay=A.delay??100}fire(A){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(A)}}t.DebounceEmitter=M;class R extends p{constructor(A){super(A),this._queuedEvents=[],this._mergeFn=A?.merge}fire(A){this.hasListeners()&&(this._queuedEvents.push(A),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(H=>super.fire(H)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=R;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(A){const H={event:A,listener:null};this.events.push(H),this.hasListeners&&this.hook(H);const G=()=>{this.hasListeners&&this.unhook(H);const ne=this.events.indexOf(H);this.events.splice(ne,1)};return(0,i.toDisposable)((0,I.once)(G))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(A=>this.hook(A))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(A=>this.unhook(A))}hook(A){A.listener=A.event(H=>this.emitter.fire(H))}unhook(A){A.listener&&A.listener.dispose(),A.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=g;class m{constructor(){this.buffers=[]}wrapEvent(A){return(H,G,ne)=>A(se=>{const de=this.buffers[this.buffers.length-1];de?de.push(()=>H.call(G,se)):H.call(G,se)},void 0,ne)}bufferEvents(A){const H=[];this.buffers.push(H);const G=A();return this.buffers.pop(),H.forEach(ne=>ne()),G}}t.EventBufferer=m;class L{constructor(){this.listening=!1,this.inputEvent=u.None,this.inputEventListener=i.Disposable.None,this.emitter=new p({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(A){this.inputEvent=A,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=A(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=L}),define(ge[16],me([1,0,3,2]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isWCOEnabled=t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class i{constructor(){this._zoomLevel=0,this._zoomFactor=1,this._fullscreen=!1,this._onDidChangeFullscreen=new E.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event}getZoomLevel(){return this._zoomLevel}setZoomLevel(v,C){this._zoomLevel!==v&&(this._zoomLevel=v)}getZoomFactor(){return this._zoomFactor}setZoomFactor(v){this._zoomFactor=v}setFullscreen(v){this._fullscreen!==v&&(this._fullscreen=v,this._onDidChangeFullscreen.fire())}isFullscreen(){return this._fullscreen}}i.INSTANCE=new i;class W extends I.Disposable{constructor(){super(),this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this._listener=()=>this._handleChange(!0),this._mediaQueryList=null,this._handleChange(!1)}_handleChange(v){this._mediaQueryList?.removeEventListener("change",this._listener),this._mediaQueryList=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this._mediaQueryList.addEventListener("change",this._listener),v&&this._onDidChange.fire()}}class w extends I.Disposable{get value(){return this._value}constructor(){super(),this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this._value=this._getPixelRatio();const v=this._register(new W);this._register(v.onDidChange(()=>{this._value=this._getPixelRatio(),this._onDidChange.fire(this._value)}))}_getPixelRatio(){const v=document.createElement("canvas").getContext("2d"),C=window.devicePixelRatio||1,f=v.webkitBackingStorePixelRatio||v.mozBackingStorePixelRatio||v.msBackingStorePixelRatio||v.oBackingStorePixelRatio||v.backingStorePixelRatio||1;return C/f}}class y{constructor(){this._pixelRatioMonitor=null}_getOrCreatePixelRatioMonitor(){return this._pixelRatioMonitor||(this._pixelRatioMonitor=(0,I.markAsSingleton)(new w)),this._pixelRatioMonitor}get value(){return this._getOrCreatePixelRatioMonitor().value}get onDidChange(){return this._getOrCreatePixelRatioMonitor().onDidChange}}function c(p,v){typeof p=="string"&&(p=window.matchMedia(p)),p.addEventListener("change",v)}t.addMatchMediaChangeListener=c,t.PixelRatio=new y;function u(p,v){i.INSTANCE.setZoomLevel(p,v)}t.setZoomLevel=u;function d(){return i.INSTANCE.getZoomLevel()}t.getZoomLevel=d;function P(){return i.INSTANCE.getZoomFactor()}t.getZoomFactor=P;function r(p){i.INSTANCE.setZoomFactor(p)}t.setZoomFactor=r;function l(p){i.INSTANCE.setFullscreen(p)}t.setFullscreen=l;function e(){return i.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=i.INSTANCE.onDidChangeFullscreen;const a=navigator.userAgent;t.isFirefox=a.indexOf("Firefox")>=0,t.isWebKit=a.indexOf("AppleWebKit")>=0,t.isChrome=a.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&a.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=a.indexOf("Electron/")>=0,t.isAndroid=a.indexOf("Android")>=0;let n=!1;if(window.matchMedia){const p=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),v=window.matchMedia("(display-mode: fullscreen)");n=p.matches,c(p,({matches:C})=>{n&&v.matches||(n=C)})}function h(){return n}t.isStandalone=h;function s(){return navigator?.windowControlsOverlay?.visible}t.isWCOEnabled=s}),define(ge[20],me([1,0,3]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class I{get event(){return this.emitter.event}constructor(W,w,y){const c=u=>this.emitter.fire(u);this.emitter=new E.Emitter({onWillAddFirstListener:()=>W.addEventListener(w,c,y),onDidRemoveLastListener:()=>W.removeEventListener(w,c,y)})}dispose(){this.emitter.dispose()}}t.DomEmitter=I}),define(ge[27],me([1,0,3]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const I=Object.freeze(function(y,c){const u=setTimeout(y.bind(c),0);return{dispose(){clearTimeout(u)}}});var i;(function(y){function c(u){return u===y.None||u===y.Cancelled||u instanceof W?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}y.isCancellationToken=c,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(i||(t.CancellationToken=i={}));class W{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class w{constructor(c){this._token=void 0,this._parentListener=void 0,this._parentListener=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new W),this._token}cancel(){this._token?this._token instanceof W&&this._token.cancel():this._token=i.Cancelled}dispose(c=!1){c&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof W&&this._token.dispose():this._token=i.None}}t.CancellationTokenSource=w}),define(ge[81],me([1,0,27]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class I{constructor(y){this.task=y,this.result=null}get(){if(this.result)return this.result;const y=new E.CancellationTokenSource,c=this.task(y.token);return this.result={promise:c,dispose:()=>{this.result=null,y.cancel(),y.dispose()}},this.result}}t.Cache=I;class i{constructor(y){this.fn=y,this.lastCache=void 0,this.lastArgKey=void 0}get(y){const c=JSON.stringify(y);return this.lastArgKey!==c&&(this.lastArgKey=c,this.lastCache=this.fn(y)),this.lastCache}}t.LRUCachedFunction=i;class W{get cachedValues(){return this._map}constructor(y){this.fn=y,this._map=new Map}get(y){if(this._map.has(y))return this._map.get(y);const c=this.fn(y);return this._map.set(y,c),c}}t.CachedFunction=W}),define(ge[46],me([1,0,3,2]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var i;(function(l){l[l.Auto=1]="Auto",l[l.Hidden=2]="Hidden",l[l.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class W{constructor(e,a,n,h,s,p,v){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(a=a|0,n=n|0,h=h|0,s=s|0,p=p|0,v=v|0),this.rawScrollLeft=h,this.rawScrollTop=v,a<0&&(a=0),h+a>n&&(h=n-a),h<0&&(h=0),s<0&&(s=0),v+s>p&&(v=p-s),v<0&&(v=0),this.width=a,this.scrollWidth=n,this.scrollLeft=h,this.height=s,this.scrollHeight=p,this.scrollTop=v}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,a){return new W(this._forceIntegerValues,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new W(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,a){const n=this.width!==e.width,h=this.scrollWidth!==e.scrollWidth,s=this.scrollLeft!==e.scrollLeft,p=this.height!==e.height,v=this.scrollHeight!==e.scrollHeight,C=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:a,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:n,scrollWidthChanged:h,scrollLeftChanged:s,heightChanged:p,scrollHeightChanged:v,scrollTopChanged:C}}}t.ScrollState=W;class w extends I.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new E.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new W(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,a){const n=this._state.withScrollDimensions(e,a);this._setState(n,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const a=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(a,!1)}setScrollPositionSmooth(e,a){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this._smoothScrolling.to.scrollTop:e.scrollTop};const n=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===n.scrollLeft&&this._smoothScrolling.to.scrollTop===n.scrollTop)return;let h;a?h=new d(this._smoothScrolling.from,n,this._smoothScrolling.startTime,this._smoothScrolling.duration):h=this._smoothScrolling.combine(this._state,n,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=h}else{const n=this._state.withScrollPosition(e);this._smoothScrolling=d.start(this._state,n,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),a=this._state.withScrollPosition(e);if(this._setState(a,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,a){const n=this._state;n.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(n,a)))}}t.Scrollable=w;class y{constructor(e,a,n){this.scrollLeft=e,this.scrollTop=a,this.isDone=n}}t.SmoothScrollingUpdate=y;function c(l,e){const a=e-l;return function(n){return l+a*r(n)}}function u(l,e,a){return function(n){return n<a?l(n/a):e((n-a)/(1-a))}}class d{constructor(e,a,n,h){this.from=e,this.to=a,this.duration=h,this.startTime=n,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,a,n){if(Math.abs(e-a)>2.5*n){let s,p;return e<a?(s=e+.75*n,p=a-.75*n):(s=e-.75*n,p=a+.75*n),u(c(e,s),c(p,a),.33)}return c(e,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const a=(e-this.startTime)/this.duration;if(a<1){const n=this.scrollLeft(a),h=this.scrollTop(a);return new y(n,h,!1)}return new y(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,a,n){return d.start(e,a,n)}static start(e,a,n){n=n+10;const h=Date.now()-10;return new d(e,a,h,n)}}t.SmoothScrollingOperation=d;function P(l){return Math.pow(l,3)}function r(l){return 1-P(1-l)}}),define(ge[82],me([1,0,7,2]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function i(v){const C=v;return C?typeof C.read=="function":!1}t.isReadable=i;function W(v){const C=v;return C?[C.on,C.pause,C.resume,C.destroy].every(f=>typeof f=="function"):!1}t.isReadableStream=W;function w(v){const C=v;return C?W(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}t.isReadableBufferedStream=w;function y(v,C){return new c(v,C)}t.newWriteableStream=y;class c{constructor(C,f){this.reducer=C,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(C){if(!this.state.destroyed){if(this.state.flowing)this.emitData(C);else if(this.buffer.data.push(C),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(f=>this.pendingWritePromises.push(f))}}error(C){this.state.destroyed||(this.state.flowing?this.emitError(C):this.buffer.error.push(C))}end(C){this.state.destroyed||(typeof C<"u"&&this.write(C),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(C){this.listeners.data.slice(0).forEach(f=>f(C))}emitError(C){this.listeners.error.length===0?(0,E.onUnexpectedError)(C):this.listeners.error.slice(0).forEach(f=>f(C))}emitEnd(){this.listeners.end.slice(0).forEach(C=>C())}on(C,f){if(!this.state.destroyed)switch(C){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(C,f){if(this.state.destroyed)return;let D;switch(C){case"data":D=this.listeners.data;break;case"end":D=this.listeners.end;break;case"error":D=this.listeners.error;break}if(D){const M=D.indexOf(f);M>=0&&D.splice(M,1)}}flowData(){if(this.buffer.data.length>0){const C=this.reducer(this.buffer.data);this.emitData(C),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(D=>D())}}flowErrors(){if(this.listeners.error.length>0){for(const C of this.buffer.error)this.emitError(C);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(v,C){const f=[];let D;for(;(D=v.read())!==null;)f.push(D);return C(f)}t.consumeReadable=u;function d(v,C,f){const D=[];let M;for(;(M=v.read())!==null&&D.length<f;)D.push(M);return M===null&&D.length>0?C(D):{read:()=>{if(D.length>0)return D.shift();if(typeof M<"u"){const R=M;return M=void 0,R}return v.read()}}}t.peekReadable=d;function P(v,C){return new Promise((f,D)=>{const M=[];r(v,{onData:R=>{C&&M.push(R)},onError:R=>{C?D(R):f(void 0)},onEnd:()=>{f(C?C(M):void 0)}})})}t.consumeStream=P;function r(v,C){let f=!1;return v.on("error",D=>{f||C.onError(D)}),v.on("end",()=>{f||C.onEnd()}),v.on("data",D=>{f||C.onData(D)}),(0,I.toDisposable)(()=>f=!0)}t.listenStream=r;function l(v,C){return new Promise((f,D)=>{const M=new I.DisposableStore,R=[],g=k=>{if(R.push(k),R.length>C)return M.dispose(),v.pause(),f({stream:v,buffer:R,ended:!1})},m=k=>D(k),L=()=>f({stream:v,buffer:R,ended:!0});M.add((0,I.toDisposable)(()=>v.removeListener("error",m))),v.on("error",m),M.add((0,I.toDisposable)(()=>v.removeListener("end",L))),v.on("end",L),M.add((0,I.toDisposable)(()=>v.removeListener("data",g))),v.on("data",g)})}t.peekStream=l;function e(v,C){const f=y(C);return f.end(v),f}t.toStream=e;function a(){const v=y(()=>{throw new Error("not supported")});return v.end(),v}t.emptyStream=a;function n(v){let C=!1;return{read:()=>C?null:(C=!0,v)}}t.toReadable=n;function h(v,C,f){const D=y(f);return r(v,{onData:M=>D.write(C.data(M)),onError:M=>D.error(C.error?C.error(M):M),onEnd:()=>D.end()}),D}t.transform=h;function s(v,C,f){let D=!1;return{read:()=>{const M=C.read();return D?M:(D=!0,M!==null?f([v,M]):v)}}}t.prefixedReadable=s;function p(v,C,f){let D=!1;const M=y(f);return r(C,{onData:R=>D?M.write(R):(D=!0,M.write(f([v,R]))),onError:R=>M.error(R),onEnd:()=>{D||(D=!0,M.write(v)),M.end()}}),M}t.prefixedStream=p}),define(ge[31],me([1,0,30,82]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer<"u",W=new E.Lazy(()=>new Uint8Array(256));let w,y;class c{static alloc(H){return i?new c(Buffer.allocUnsafe(H)):new c(new Uint8Array(H))}static wrap(H){return i&&!Buffer.isBuffer(H)&&(H=Buffer.from(H.buffer,H.byteOffset,H.byteLength)),new c(H)}static fromString(H,G){return!(G?.dontUseNodeBuffer||!1)&&i?new c(Buffer.from(H)):(w||(w=new TextEncoder),new c(w.encode(H)))}static fromByteArray(H){const G=c.alloc(H.length);for(let ne=0,se=H.length;ne<se;ne++)G.buffer[ne]=H[ne];return G}static concat(H,G){if(typeof G>"u"){G=0;for(let de=0,ue=H.length;de<ue;de++)G+=H[de].byteLength}const ne=c.alloc(G);let se=0;for(let de=0,ue=H.length;de<ue;de++){const re=H[de];ne.set(re,se),se+=re.byteLength}return ne}constructor(H){this.buffer=H,this.byteLength=this.buffer.byteLength}clone(){const H=c.alloc(this.byteLength);return H.set(this),H}toString(){return i?this.buffer.toString():(y||(y=new TextDecoder),y.decode(this.buffer))}slice(H,G){return new c(this.buffer.subarray(H,G))}set(H,G){if(H instanceof c)this.buffer.set(H.buffer,G);else if(H instanceof Uint8Array)this.buffer.set(H,G);else if(H instanceof ArrayBuffer)this.buffer.set(new Uint8Array(H),G);else if(ArrayBuffer.isView(H))this.buffer.set(new Uint8Array(H.buffer,H.byteOffset,H.byteLength),G);else throw new Error("Unknown argument 'array'")}readUInt32BE(H){return P(this.buffer,H)}writeUInt32BE(H,G){r(this.buffer,H,G)}readUInt32LE(H){return l(this.buffer,H)}writeUInt32LE(H,G){e(this.buffer,H,G)}readUInt8(H){return a(this.buffer,H)}writeUInt8(H,G){n(this.buffer,H,G)}indexOf(H){const G=H instanceof c?H.buffer:H,ne=G.byteLength,se=this.buffer,de=se.byteLength;if(ne===0)return 0;if(ne===1)return se.indexOf(G[0]);if(ne>de)return-1;const ue=W.value;ue.fill(G.length);for(let Te=0;Te<G.length;Te++)ue[G[Te]]=G.length-Te-1;let re=G.length-1,le=re,ye=-1;for(;re<de;)if(se[re]===G[le]){if(le===0){ye=re;break}re--,le--}else re+=Math.max(G.length-le,ue[se[re]]),le=G.length-1;return ye}}t.VSBuffer=c;function u(A,H){return A[H+0]<<0>>>0|A[H+1]<<8>>>0}t.readUInt16LE=u;function d(A,H,G){A[G+0]=H&255,H=H>>>8,A[G+1]=H&255}t.writeUInt16LE=d;function P(A,H){return A[H]*2**24+A[H+1]*2**16+A[H+2]*2**8+A[H+3]}t.readUInt32BE=P;function r(A,H,G){A[G+3]=H,H=H>>>8,A[G+2]=H,H=H>>>8,A[G+1]=H,H=H>>>8,A[G]=H}t.writeUInt32BE=r;function l(A,H){return A[H+0]<<0>>>0|A[H+1]<<8>>>0|A[H+2]<<16>>>0|A[H+3]<<24>>>0}t.readUInt32LE=l;function e(A,H,G){A[G+0]=H&255,H=H>>>8,A[G+1]=H&255,H=H>>>8,A[G+2]=H&255,H=H>>>8,A[G+3]=H&255}t.writeUInt32LE=e;function a(A,H){return A[H]}t.readUInt8=a;function n(A,H,G){A[G]=H}t.writeUInt8=n;function h(A){return I.consumeReadable(A,H=>c.concat(H))}t.readableToBuffer=h;function s(A){return I.toReadable(A)}t.bufferToReadable=s;function p(A){return I.consumeStream(A,H=>c.concat(H))}t.streamToBuffer=p;async function v(A){return A.ended?c.concat(A.buffer):c.concat([...A.buffer,await p(A.stream)])}t.bufferedStreamToBuffer=v;function C(A){return I.toStream(A,H=>c.concat(H))}t.bufferToStream=C;function f(A){return I.transform(A,{data:H=>typeof H=="string"?c.fromString(H):c.wrap(H)},H=>c.concat(H))}t.streamToBufferReadableStream=f;function D(A){return I.newWriteableStream(H=>c.concat(H),A)}t.newWriteableBufferStream=D;function M(A,H){return I.prefixedReadable(A,H,G=>c.concat(G))}t.prefixedBufferReadable=M;function R(A,H){return I.prefixedStream(A,H,G=>c.concat(G))}t.prefixedBufferStream=R;function g(A){let H=0,G=0,ne=0;const se=new Uint8Array(Math.floor(A.length/4*3)),de=re=>{switch(G){case 3:se[ne++]=H|re,G=0;break;case 2:se[ne++]=H|re>>>2,H=re<<6,G=3;break;case 1:se[ne++]=H|re>>>4,H=re<<4,G=2;break;default:H=re<<2,G=1}};for(let re=0;re<A.length;re++){const le=A.charCodeAt(re);if(le>=65&&le<=90)de(le-65);else if(le>=97&&le<=122)de(le-97+26);else if(le>=48&&le<=57)de(le-48+52);else if(le===43||le===45)de(62);else if(le===47||le===95)de(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${A[re]}`)}}const ue=ne;for(;G>0;)de(0);return c.wrap(se).slice(0,ue)}t.decodeBase64=g;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:A},H=!0,G=!1){const ne=G?L:m;let se="";const de=A.byteLength%3;let ue=0;for(;ue<A.byteLength-de;ue+=3){const re=A[ue+0],le=A[ue+1],ye=A[ue+2];se+=ne[re>>>2],se+=ne[(re<<4|le>>>4)&63],se+=ne[(le<<2|ye>>>6)&63],se+=ne[ye&63]}if(de===1){const re=A[ue+0];se+=ne[re>>>2],se+=ne[re<<4&63],H&&(se+="==")}else if(de===2){const re=A[ue+0],le=A[ue+1];se+=ne[re>>>2],se+=ne[(re<<4|le>>>4)&63],se+=ne[le<<2&63],H&&(se+="=")}return se}t.encodeBase64=k}),define(ge[10],me([1,0,81,30]),function(ee,t,E,I){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function W(X){return!X||typeof X!="string"?!0:X.trim().length===0}t.isFalsyOrWhitespace=W;const w=/{(\d+)}/g;function y(X,...ae){return ae.length===0?X:X.replace(w,function(pe,we){const Ee=parseInt(we,10);return isNaN(Ee)||Ee<0||Ee>=ae.length?pe:ae[Ee]})}t.format=y;const c=/{([^}]+)}/g;function u(X,ae){return X.replace(c,(pe,we)=>ae[we]??pe)}t.format2=u;function d(X){return X.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}t.escape=d;function P(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=P;function r(X,ae){let pe=0;const we=ae.charCodeAt(0);for(let Ee=X.length-1;Ee>=0;Ee--)X.charCodeAt(Ee)===we&&pe++;return pe}t.count=r;function l(X,ae,pe="\u2026"){return X.length<=ae?X:`${X.substr(0,ae)}${pe}`}t.truncate=l;function e(X,ae=" "){const pe=a(X,ae);return n(pe,ae)}t.trim=e;function a(X,ae){if(!X||!ae)return X;const pe=ae.length;if(pe===0||X.length===0)return X;let we=0;for(;X.indexOf(ae,we)===we;)we=we+pe;return X.substring(we)}t.ltrim=a;function n(X,ae){if(!X||!ae)return X;const pe=ae.length,we=X.length;if(pe===0||we===0)return X;let Ee=we,Pe=-1;for(;Pe=X.lastIndexOf(ae,Ee-1),!(Pe===-1||Pe+pe!==Ee);){if(Pe===0)return"";Ee=Pe}return X.substring(0,Ee)}t.rtrim=n;function h(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=h;function s(X){return X.replace(/\*/g,"")}t.stripWildcards=s;function p(X,ae,pe={}){if(!X)throw new Error("Cannot create regex from empty string");ae||(X=P(X)),pe.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let we="";return pe.global&&(we+="g"),pe.matchCase||(we+="i"),pe.multiline&&(we+="m"),pe.unicode&&(we+="u"),new RegExp(X,we)}t.createRegExp=p;function v(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}t.regExpLeadsToEndlessLoop=v;function C(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=C;function f(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}t.regExpFlags=f;function D(X){return X.split(/\r\n|\r|\n/)}t.splitLines=D;function M(X){for(let ae=0,pe=X.length;ae<pe;ae++){const we=X.charCodeAt(ae);if(we!==32&&we!==9)return ae}return-1}t.firstNonWhitespaceIndex=M;function R(X,ae=0,pe=X.length){for(let we=ae;we<pe;we++){const Ee=X.charCodeAt(we);if(Ee!==32&&Ee!==9)return X.substring(ae,we)}return X.substring(ae,pe)}t.getLeadingWhitespace=R;function g(X,ae=X.length-1){for(let pe=ae;pe>=0;pe--){const we=X.charCodeAt(pe);if(we!==32&&we!==9)return pe}return-1}t.lastNonWhitespaceIndex=g;function m(X,ae,pe){const we=[];let Ee=0;for(const Pe of X.matchAll(ae)){if(we.push(X.slice(Ee,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");Ee=Pe.index+Pe[0].length,we.push(pe(Pe[0],...Pe.slice(1),Pe.index,X,Pe.groups))}return we.push(X.slice(Ee)),Promise.all(we).then(Pe=>Pe.join(""))}t.replaceAsync=m;function L(X,ae){return X<ae?-1:X>ae?1:0}t.compare=L;function k(X,ae,pe=0,we=X.length,Ee=0,Pe=ae.length){for(;pe<we&&Ee<Pe;pe++,Ee++){const et=X.charCodeAt(pe),Ae=ae.charCodeAt(Ee);if(et<Ae)return-1;if(et>Ae)return 1}const Ue=we-pe,Ge=Pe-Ee;return Ue<Ge?-1:Ue>Ge?1:0}t.compareSubstring=k;function A(X,ae){return H(X,ae,0,X.length,0,ae.length)}t.compareIgnoreCase=A;function H(X,ae,pe=0,we=X.length,Ee=0,Pe=ae.length){for(;pe<we&&Ee<Pe;pe++,Ee++){let et=X.charCodeAt(pe),Ae=ae.charCodeAt(Ee);if(et===Ae)continue;if(et>=128||Ae>=128)return k(X.toLowerCase(),ae.toLowerCase(),pe,we,Ee,Pe);ne(et)&&(et-=32),ne(Ae)&&(Ae-=32);const he=et-Ae;if(he!==0)return he}const Ue=we-pe,Ge=Pe-Ee;return Ue<Ge?-1:Ue>Ge?1:0}t.compareSubstringIgnoreCase=H;function G(X){return X>=48&&X<=57}t.isAsciiDigit=G;function ne(X){return X>=97&&X<=122}t.isLowerAsciiLetter=ne;function se(X){return X>=65&&X<=90}t.isUpperAsciiLetter=se;function de(X,ae){return X.length===ae.length&&H(X,ae)===0}t.equalsIgnoreCase=de;function ue(X,ae){const pe=ae.length;return ae.length>X.length?!1:H(X,ae,0,pe)===0}t.startsWithIgnoreCase=ue;function re(X,ae){const pe=Math.min(X.length,ae.length);let we;for(we=0;we<pe;we++)if(X.charCodeAt(we)!==ae.charCodeAt(we))return we;return pe}t.commonPrefixLength=re;function le(X,ae){const pe=Math.min(X.length,ae.length);let we;const Ee=X.length-1,Pe=ae.length-1;for(we=0;we<pe;we++)if(X.charCodeAt(Ee-we)!==ae.charCodeAt(Pe-we))return we;return pe}t.commonSuffixLength=le;function ye(X){return 55296<=X&&X<=56319}t.isHighSurrogate=ye;function Te(X){return 56320<=X&&X<=57343}t.isLowSurrogate=Te;function Me(X,ae){return(X-55296<<10)+(ae-56320)+65536}t.computeCodePoint=Me;function Oe(X,ae,pe){const we=X.charCodeAt(pe);if(ye(we)&&pe+1<ae){const Ee=X.charCodeAt(pe+1);if(Te(Ee))return Me(we,Ee)}return we}t.getNextCodePoint=Oe;function ce(X,ae){const pe=X.charCodeAt(ae-1);if(Te(pe)&&ae>1){const we=X.charCodeAt(ae-2);if(ye(we))return Me(we,pe)}return pe}class ie{get offset(){return this._offset}constructor(ae,pe=0){this._str=ae,this._len=ae.length,this._offset=pe}setOffset(ae){this._offset=ae}prevCodePoint(){const ae=ce(this._str,this._offset);return this._offset-=ae>=65536?2:1,ae}nextCodePoint(){const ae=Oe(this._str,this._len,this._offset);return this._offset+=ae>=65536?2:1,ae}eol(){return this._offset>=this._len}}t.CodePointIterator=ie;class q{get offset(){return this._iterator.offset}constructor(ae,pe=0){this._iterator=new ie(ae,pe)}nextGraphemeLength(){const ae=Ie.getInstance(),pe=this._iterator,we=pe.offset;let Ee=ae.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Pe=pe.offset,Ue=ae.getGraphemeBreakType(pe.nextCodePoint());if(ve(Ee,Ue)){pe.setOffset(Pe);break}Ee=Ue}return pe.offset-we}prevGraphemeLength(){const ae=Ie.getInstance(),pe=this._iterator,we=pe.offset;let Ee=ae.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Pe=pe.offset,Ue=ae.getGraphemeBreakType(pe.prevCodePoint());if(ve(Ue,Ee)){pe.setOffset(Pe);break}Ee=Ue}return we-pe.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=q;function $(X,ae){return new q(X,ae).nextGraphemeLength()}t.nextCharLength=$;function V(X,ae){return new q(X,ae).prevGraphemeLength()}t.prevCharLength=V;function _(X,ae){ae>0&&Te(X.charCodeAt(ae))&&ae--;const pe=ae+$(X,ae);return[pe-V(X,pe),pe]}t.getCharContainingOffset=_;function K(X){const ae=new q(X);let pe=0;for(;!ae.eol();)pe++,ae.nextGraphemeLength();return pe}t.charCount=K;let z;function o(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function F(X){return z||(z=o()),z.test(X)}t.containsRTL=F;const j=/^[\t\n\r\x20-\x7E]*$/;function te(X){return j.test(X)}t.isBasicASCII=te,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function S(X){return t.UNUSUAL_LINE_TERMINATORS.test(X)}t.containsUnusualLineTerminators=S;function T(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}t.isFullWidthCharacter=T;function O(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}t.isEmojiImprecise=O;function b(X,ae){if(X.length<ae)return X;const pe=/\b/g;let we=0;for(;pe.test(X)&&!(X.length-pe.lastIndex<ae);)we=pe.lastIndex,pe.lastIndex+=1;return X.substring(we).replace(/^\s/,"")}t.lcut=b;const x=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,B=/\x1b\].*?\x07/g;function N(X){return X&&(X=X.replace(x,"").replace(B,"")),X}t.removeAnsiEscapeCodes=N,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function U(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}t.startsWithUTF8BOM=U;function Y(X){return U(X)?X.substr(1):X}t.stripUTF8BOM=Y;function J(X,ae){if(!X||!ae||X.length<ae.length)return!1;const pe=ae.length,we=X.toLowerCase();let Ee=0,Pe=-1;for(;Ee<pe;){const Ue=we.indexOf(ae[Ee],Pe+1);if(Ue<0)return!1;Pe=Ue,Ee++}return!0}t.fuzzyContains=J;function oe(X,ae=!1){return X?(ae&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}t.containsUppercaseCharacter=oe;function be(X){return X.charAt(0).toUpperCase()+X.slice(1)}t.uppercaseFirstLetter=be;function De(X,ae=1){if(ae===0)return"";let pe=-1;do pe=X.indexOf(`
`,pe+1),ae--;while(ae>0&&pe>=0);return pe===-1?X:(X[pe-1]==="\r"&&pe--,X.substr(0,pe))}t.getNLines=De;function Le(X){return X=X%(2*26),X<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}t.singleLetterHash=Le;function Se(X){return Ie.getInstance().getGraphemeBreakType(X)}t.getGraphemeBreakType=Se;function ve(X,ae){return X===0?ae!==5&&ae!==7:X===2&&ae===3?!1:X===4||X===2||X===3||ae===4||ae===2||ae===3?!0:!(X===8&&(ae===8||ae===9||ae===11||ae===12)||(X===11||X===9)&&(ae===9||ae===10)||(X===12||X===10)&&ae===10||ae===5||ae===13||ae===7||X===1||X===13&&ae===14||X===6&&ae===6)}var ke;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(ke||(t.GraphemeBreakType=ke={}));class Ie{static getInstance(){return Ie._INSTANCE||(Ie._INSTANCE=new Ie),Ie._INSTANCE}constructor(){this._data=Ke()}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const pe=this._data,we=pe.length/3;let Ee=1;for(;Ee<=we;)if(ae<pe[3*Ee])Ee=2*Ee;else if(ae>pe[3*Ee+1])Ee=2*Ee+1;else return pe[3*Ee+2];return 0}}Ie._INSTANCE=null;function Ke(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function xe(X,ae){if(X===0)return 0;const pe=We(X,ae);if(pe!==void 0)return pe;const we=new ie(ae,X);return we.prevCodePoint(),we.offset}t.getLeftDeleteOffset=xe;function We(X,ae){const pe=new ie(ae,X);let we=pe.prevCodePoint();for(;Je(we)||we===65039||we===8419;){if(pe.offset===0)return;we=pe.prevCodePoint()}if(!O(we))return;let Ee=pe.offset;return Ee>0&&pe.prevCodePoint()===8205&&(Ee=pe.offset),Ee}function Je(X){return 127995<=X&&X<=127999}var it;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),t.noBreakWhitespace="\xA0";class Re{static getInstance(ae){return Re.cache.get(Array.from(ae))}static getLocales(){return Re._locales.value}constructor(ae){this.confusableDictionary=ae}isAmbiguous(ae){return this.confusableDictionary.has(ae)}getPrimaryConfusable(ae){return this.confusableDictionary.get(ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=Re,i=Re,Re.ambiguousCharacterData=new I.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Re.cache=new E.LRUCachedFunction(X=>{function ae(Ae){const he=new Map;for(let _e=0;_e<Ae.length;_e+=2)he.set(Ae[_e],Ae[_e+1]);return he}function pe(Ae,he){const _e=new Map(Ae);for(const[Ne,He]of he)_e.set(Ne,He);return _e}function we(Ae,he){if(!Ae)return he;const _e=new Map;for(const[Ne,He]of Ae)he.has(Ne)&&_e.set(Ne,He);return _e}const Ee=i.ambiguousCharacterData.value;let Pe=X.filter(Ae=>!Ae.startsWith("_")&&Ae in Ee);Pe.length===0&&(Pe=["_default"]);let Ue;for(const Ae of Pe){const he=ae(Ee[Ae]);Ue=we(Ue,he)}const Ge=ae(Ee._common),et=pe(Ge,Ue);return new Re(et)}),Re._locales=new I.Lazy(()=>Object.keys(Re.ambiguousCharacterData.value).filter(X=>!X.startsWith("_")));class Ve{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ve.getRawData())),this._data}static isInvisibleCharacter(ae){return Ve.getData().has(ae)}static get codePoints(){return Ve.getData()}}t.InvisibleCharacters=Ve,Ve._data=void 0}),define(ge[32],me([1,0,75,10]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function i(...B){return function(N,U){for(let Y=0,J=B.length;Y<J;Y++){const oe=B[Y](N,U);if(oe)return oe}return null}}t.or=i,t.matchesStrictPrefix=W.bind(void 0,!1),t.matchesPrefix=W.bind(void 0,!0);function W(B,N,U){if(!U||U.length<N.length)return null;let Y;return B?Y=I.startsWithIgnoreCase(U,N):Y=U.indexOf(N)===0,Y?N.length>0?[{start:0,end:N.length}]:[]:null}function w(B,N){const U=N.toLowerCase().indexOf(B.toLowerCase());return U===-1?null:[{start:U,end:U+B.length}]}t.matchesContiguousSubString=w;function y(B,N){return c(B.toLowerCase(),N.toLowerCase(),0,0)}t.matchesSubString=y;function c(B,N,U,Y){if(U===B.length)return[];if(Y===N.length)return null;if(B[U]===N[Y]){let J=null;return(J=c(B,N,U+1,Y+1))?h({start:Y,end:Y+1},J):null}return c(B,N,U,Y+1)}function u(B){return 97<=B&&B<=122}function d(B){return 65<=B&&B<=90}t.isUpper=d;function P(B){return 48<=B&&B<=57}function r(B){return B===32||B===9||B===10||B===13}const l=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(B=>l.add(B.charCodeAt(0)));function e(B){return r(B)||l.has(B)}function a(B,N){return B===N||e(B)&&e(N)}function n(B){return u(B)||d(B)||P(B)}function h(B,N){return N.length===0?N=[B]:B.end===N[0].start?N[0].start=B.start:N.unshift(B),N}function s(B,N){for(let U=N;U<B.length;U++){const Y=B.charCodeAt(U);if(d(Y)||P(Y)||U>0&&!n(B.charCodeAt(U-1)))return U}return B.length}function p(B,N,U,Y){if(U===B.length)return[];if(Y===N.length)return null;if(B[U]!==N[Y].toLowerCase())return null;{let J=null,oe=Y+1;for(J=p(B,N,U+1,Y+1);!J&&(oe=s(N,oe))<N.length;)J=p(B,N,U+1,oe),oe++;return J===null?null:h({start:Y,end:Y+1},J)}}function v(B){let N=0,U=0,Y=0,J=0,oe=0;for(let ve=0;ve<B.length;ve++)oe=B.charCodeAt(ve),d(oe)&&N++,u(oe)&&U++,n(oe)&&Y++,P(oe)&&J++;const be=N/B.length,De=U/B.length,Le=Y/B.length,Se=J/B.length;return{upperPercent:be,lowerPercent:De,alphaPercent:Le,numericPercent:Se}}function C(B){const{upperPercent:N,lowerPercent:U}=B;return U===0&&N>.6}function f(B){const{upperPercent:N,lowerPercent:U,alphaPercent:Y,numericPercent:J}=B;return U>.2&&N<.8&&Y>.6&&J<.2}function D(B){let N=0,U=0,Y=0,J=0;for(let oe=0;oe<B.length;oe++)Y=B.charCodeAt(oe),d(Y)&&N++,u(Y)&&U++,r(Y)&&J++;return(N===0||U===0)&&J===0?B.length<=30:N<=5}function M(B,N){if(!N||(N=N.trim(),N.length===0)||!D(B)||N.length>60)return null;const U=v(N);if(!f(U)){if(!C(U))return null;N=N.toLowerCase()}let Y=null,J=0;for(B=B.toLowerCase();J<N.length&&(Y=p(B,N,0,J))===null;)J=s(N,J+1);return Y}t.matchesCamelCase=M;function R(B,N,U=!1){if(!N||N.length===0)return null;let Y=null,J=0;for(B=B.toLowerCase(),N=N.toLowerCase();J<N.length&&(Y=g(B,N,0,J,U))===null;)J=m(N,J+1);return Y}t.matchesWords=R;function g(B,N,U,Y,J){if(U===B.length)return[];if(Y===N.length)return null;if(a(B.charCodeAt(U),N.charCodeAt(Y))){let oe=null,be=Y+1;if(oe=g(B,N,U+1,Y+1,J),!J)for(;!oe&&(be=m(N,be))<N.length;)oe=g(B,N,U+1,be,J),be++;return oe?B.charCodeAt(U)!==N.charCodeAt(Y)?oe:h({start:Y,end:Y+1},oe):null}else return null}function m(B,N){for(let U=N;U<B.length;U++)if(e(B.charCodeAt(U))||U>0&&e(B.charCodeAt(U-1)))return U;return B.length}const L=i(t.matchesPrefix,M,w),k=i(t.matchesPrefix,M,y),A=new E.LRUCache(1e4);function H(B,N,U=!1){if(typeof B!="string"||typeof N!="string")return null;let Y=A.get(B);Y||(Y=new RegExp(I.convertSimple2RegExpPattern(B),"i"),A.set(B,Y));const J=Y.exec(N);return J?[{start:J.index,end:J.index+J[0].length}]:U?k(B,N):L(B,N)}t.matchesFuzzy=H;function G(B,N){const U=j(B,B.toLowerCase(),0,N,N.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return U?se(U):null}t.matchesFuzzy2=G;function ne(B,N,U,Y,J,oe){const be=Math.min(13,B.length);for(;U<be;U++){const De=j(B,N,U,Y,J,oe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(De)return De}return[0,oe]}t.anyScore=ne;function se(B){if(typeof B>"u")return[];const N=[],U=B[1];for(let Y=B.length-1;Y>1;Y--){const J=B[Y]+U,oe=N[N.length-1];oe&&oe.end===J?oe.end=J+1:N.push({start:J,end:J+1})}return N}t.createMatches=se;const de=128;function ue(){const B=[],N=[];for(let U=0;U<=de;U++)N[U]=0;for(let U=0;U<=de;U++)B.push(N.slice(0));return B}function re(B){const N=[];for(let U=0;U<=B;U++)N[U]=0;return N}const le=re(2*de),ye=re(2*de),Te=ue(),Me=ue(),Oe=ue(),ce=!1;function ie(B,N,U,Y,J){function oe(De,Le,Se=" "){for(;De.length<Le;)De=Se+De;return De}let be=` |   |${Y.split("").map(De=>oe(De,3)).join("|")}
`;for(let De=0;De<=U;De++)De===0?be+=" |":be+=`${N[De-1]}|`,be+=B[De].slice(0,J+1).map(Le=>oe(Le.toString(),3)).join("|")+`
`;return be}function q(B,N,U,Y){B=B.substr(N),U=U.substr(Y),console.log(ie(Me,B,B.length,U,U.length)),console.log(ie(Oe,B,B.length,U,U.length)),console.log(ie(Te,B,B.length,U,U.length))}function $(B,N){if(N<0||N>=B.length)return!1;const U=B.codePointAt(N);switch(U){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(U)}}function V(B,N){if(N<0||N>=B.length)return!1;switch(B.charCodeAt(N)){case 32:case 9:return!0;default:return!1}}function _(B,N,U){return N[B]!==U[B]}function K(B,N,U,Y,J,oe,be=!1){for(;N<U&&J<oe;)B[N]===Y[J]&&(be&&(le[N]=J),N+=1),J+=1;return N===U}t.isPatternInWord=K;var z;(function(B){B[B.Diag=1]="Diag",B[B.Left=2]="Left",B[B.LeftLeft=3]="LeftLeft"})(z||(z={}));var o;(function(B){B.Default=[-100,0];function N(U){return!U||U.length===2&&U[0]===-100&&U[1]===0}B.isDefault=N})(o||(t.FuzzyScore=o={}));class F{constructor(N,U){this.firstMatchCanBeWeak=N,this.boostFullMatch=U}}t.FuzzyScoreOptions=F,F.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function j(B,N,U,Y,J,oe,be=F.default){const De=B.length>de?de:B.length,Le=Y.length>de?de:Y.length;if(U>=De||oe>=Le||De-U>Le-oe||!K(N,U,De,J,oe,Le,!0))return;te(De,Le,U,oe,N,J);let Se=1,ve=1,ke=U,Ie=oe;const Ke=[!1];for(Se=1,ke=U;ke<De;Se++,ke++){const Re=le[ke],Ve=ye[ke],X=ke+1<De?ye[ke+1]:Le;for(ve=Re-oe+1,Ie=Re;Ie<X;ve++,Ie++){let ae=Number.MIN_SAFE_INTEGER,pe=!1;Ie<=Ve&&(ae=S(B,N,ke,U,Y,J,Ie,Le,oe,Te[Se-1][ve-1]===0,Ke));let we=0;ae!==Number.MAX_SAFE_INTEGER&&(pe=!0,we=ae+Me[Se-1][ve-1]);const Ee=Ie>Re,Pe=Ee?Me[Se][ve-1]+(Te[Se][ve-1]>0?-5:0):0,Ue=Ie>Re+1&&Te[Se][ve-1]>0,Ge=Ue?Me[Se][ve-2]+(Te[Se][ve-2]>0?-5:0):0;if(Ue&&(!Ee||Ge>=Pe)&&(!pe||Ge>=we))Me[Se][ve]=Ge,Oe[Se][ve]=3,Te[Se][ve]=0;else if(Ee&&(!pe||Pe>=we))Me[Se][ve]=Pe,Oe[Se][ve]=2,Te[Se][ve]=0;else if(pe)Me[Se][ve]=we,Oe[Se][ve]=1,Te[Se][ve]=Te[Se-1][ve-1]+1;else throw new Error("not possible")}}if(ce&&q(B,U,Y,oe),!Ke[0]&&!be.firstMatchCanBeWeak)return;Se--,ve--;const xe=[Me[Se][ve],oe];let We=0,Je=0;for(;Se>=1;){let Re=ve;do{const Ve=Oe[Se][Re];if(Ve===3)Re=Re-2;else if(Ve===2)Re=Re-1;else break}while(Re>=1);We>1&&N[U+Se-1]===J[oe+ve-1]&&!_(Re+oe-1,Y,J)&&We+1>Te[Se][Re]&&(Re=ve),Re===ve?We++:We=1,Je||(Je=Re),Se--,ve=Re-1,xe.push(ve)}Le===De&&be.boostFullMatch&&(xe[0]+=2);const it=Je-De;return xe[0]-=it,xe}t.fuzzyScore=j;function te(B,N,U,Y,J,oe){let be=B-1,De=N-1;for(;be>=U&&De>=Y;)J[be]===oe[De]&&(ye[be]=De,be--),De--}function S(B,N,U,Y,J,oe,be,De,Le,Se,ve){if(N[U]!==oe[be])return Number.MIN_SAFE_INTEGER;let ke=1,Ie=!1;return be===U-Y?ke=B[U]===J[be]?7:5:_(be,J,oe)&&(be===0||!_(be-1,J,oe))?(ke=B[U]===J[be]?7:5,Ie=!0):$(oe,be)&&(be===0||!$(oe,be-1))?ke=5:($(oe,be-1)||V(oe,be-1))&&(ke=5,Ie=!0),ke>1&&U===Y&&(ve[0]=!0),Ie||(Ie=_(be,J,oe)||$(oe,be-1)||V(oe,be-1)),U===Y?be>Le&&(ke-=Ie?3:5):Se?ke+=Ie?2:0:ke+=Ie?0:1,be+1===De&&(ke-=Ie?3:5),ke}function T(B,N,U,Y,J,oe,be){return b(B,N,U,Y,J,oe,!0,be)}t.fuzzyScoreGracefulAggressive=T;function O(B,N,U,Y,J,oe,be){return b(B,N,U,Y,J,oe,!1,be)}t.fuzzyScoreGraceful=O;function b(B,N,U,Y,J,oe,be,De){let Le=j(B,N,U,Y,J,oe,De);if(Le&&!be)return Le;if(B.length>=3){const Se=Math.min(7,B.length-1);for(let ve=U+1;ve<Se;ve++){const ke=x(B,ve);if(ke){const Ie=j(ke,ke.toLowerCase(),U,Y,J,oe,De);Ie&&(Ie[0]-=3,(!Le||Ie[0]>Le[0])&&(Le=Ie))}}}return Le}function x(B,N){if(N+1>=B.length)return;const U=B[N],Y=B[N+1];if(U!==Y)return B.slice(0,N)+Y+U+B.slice(N+2)}}),define(ge[83],me([1,0,10]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function I(h){return i(h,0)}t.hash=I;function i(h,s){switch(typeof h){case"object":return h===null?W(349,s):Array.isArray(h)?c(h,s):u(h,s);case"string":return y(h,s);case"boolean":return w(h,s);case"number":return W(h,s);case"undefined":return W(937,s);default:return W(617,s)}}t.doHash=i;function W(h,s){return(s<<5)-s+h|0}t.numberHash=W;function w(h,s){return W(h?433:863,s)}function y(h,s){s=W(149417,s);for(let p=0,v=h.length;p<v;p++)s=W(h.charCodeAt(p),s);return s}t.stringHash=y;function c(h,s){return s=W(104579,s),h.reduce((p,v)=>i(v,p),s)}function u(h,s){return s=W(181387,s),Object.keys(h).sort().reduce((p,v)=>(p=y(v,p),i(h[v],p)),s)}class d{constructor(){this._value=0}get value(){return this._value}hash(s){return this._value=i(s,this._value),this._value}}t.Hasher=d;var P;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function r(h,s,p=32){const v=p-s,C=~((1<<v)-1);return(h<<s|(C&h)>>>v)>>>0}function l(h,s=0,p=h.byteLength,v=0){for(let C=0;C<p;C++)h[s+C]=v}function e(h,s,p="0"){for(;h.length<s;)h=p+h;return h}function a(h,s=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(p=>p.toString(16).padStart(2,"0")).join(""):e((h>>>0).toString(16),s/4)}t.toHexString=a;class n{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(s){const p=s.length;if(p===0)return;const v=this._buff;let C=this._buffLen,f=this._leftoverHighSurrogate,D,M;for(f!==0?(D=f,M=-1,f=0):(D=s.charCodeAt(0),M=0);;){let R=D;if(E.isHighSurrogate(D))if(M+1<p){const g=s.charCodeAt(M+1);E.isLowSurrogate(g)?(M++,R=E.computeCodePoint(D,g)):R=65533}else{f=D;break}else E.isLowSurrogate(D)&&(R=65533);if(C=this._push(v,C,R),M++,M<p)D=s.charCodeAt(M);else break}this._buffLen=C,this._leftoverHighSurrogate=f}_push(s,p,v){return v<128?s[p++]=v:v<2048?(s[p++]=192|(v&1984)>>>6,s[p++]=128|(v&63)>>>0):v<65536?(s[p++]=224|(v&61440)>>>12,s[p++]=128|(v&4032)>>>6,s[p++]=128|(v&63)>>>0):(s[p++]=240|(v&1835008)>>>18,s[p++]=128|(v&258048)>>>12,s[p++]=128|(v&4032)>>>6,s[p++]=128|(v&63)>>>0),p>=64&&(this._step(),p-=64,this._totalLen+=64,s[0]=s[64+0],s[1]=s[64+1],s[2]=s[64+2]),p}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),a(this._h0)+a(this._h1)+a(this._h2)+a(this._h3)+a(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,l(this._buff,this._buffLen),this._buffLen>56&&(this._step(),l(this._buff));const s=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(s/4294967296),!1),this._buffDV.setUint32(60,s%4294967296,!1),this._step()}_step(){const s=n._bigBlock32,p=this._buffDV;for(let L=0;L<64;L+=4)s.setUint32(L,p.getUint32(L,!1),!1);for(let L=64;L<320;L+=4)s.setUint32(L,r(s.getUint32(L-12,!1)^s.getUint32(L-32,!1)^s.getUint32(L-56,!1)^s.getUint32(L-64,!1),1),!1);let v=this._h0,C=this._h1,f=this._h2,D=this._h3,M=this._h4,R,g,m;for(let L=0;L<80;L++)L<20?(R=C&f|~C&D,g=1518500249):L<40?(R=C^f^D,g=1859775393):L<60?(R=C&f|C&D|f&D,g=2400959708):(R=C^f^D,g=3395469782),m=r(v,5)+R+M+g+s.getUint32(L*4,!1)&4294967295,M=D,D=f,f=r(C,30),C=v,v=m;this._h0=this._h0+v&4294967295,this._h1=this._h1+C&4294967295,this._h2=this._h2+f&4294967295,this._h3=this._h3+D&4294967295,this._h4=this._h4+M&4294967295}}t.StringSHA1=n,n._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[84],me([1,0,71,83]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(r){this.source=r}getElements(){const r=this.source,l=new Int32Array(r.length);for(let e=0,a=r.length;e<a;e++)l[e]=r.charCodeAt(e);return l}}t.StringDiffSequence=i;function W(P,r,l){return new d(new i(P),new i(r)).ComputeDiff(l).changes}t.stringDiff=W;class w{static Assert(r,l){if(!r)throw new Error(l)}}class y{static Copy(r,l,e,a,n){for(let h=0;h<n;h++)e[a+h]=r[l+h]}static Copy2(r,l,e,a,n){for(let h=0;h<n;h++)e[a+h]=r[l+h]}}var c;(function(P){P[P.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(c||(c={}));class u{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new E.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(r,l){this.m_originalStart=Math.min(this.m_originalStart,r),this.m_modifiedStart=Math.min(this.m_modifiedStart,l),this.m_originalCount++}AddModifiedElement(r,l){this.m_originalStart=Math.min(this.m_originalStart,r),this.m_modifiedStart=Math.min(this.m_modifiedStart,l),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class d{constructor(r,l,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=r,this._modifiedSequence=l;const[a,n,h]=d._getElements(r),[s,p,v]=d._getElements(l);this._hasStrings=h&&v,this._originalStringElements=a,this._originalElementsOrHash=n,this._modifiedStringElements=s,this._modifiedElementsOrHash=p,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(r){return r.length>0&&typeof r[0]=="string"}static _getElements(r){const l=r.getElements();if(d._isStringArray(l)){const e=new Int32Array(l.length);for(let a=0,n=l.length;a<n;a++)e[a]=(0,I.stringHash)(l[a],0);return[l,e,!0]}return l instanceof Int32Array?[[],l,!1]:[[],new Int32Array(l),!1]}ElementsAreEqual(r,l){return this._originalElementsOrHash[r]!==this._modifiedElementsOrHash[l]?!1:this._hasStrings?this._originalStringElements[r]===this._modifiedStringElements[l]:!0}ElementsAreStrictEqual(r,l){if(!this.ElementsAreEqual(r,l))return!1;const e=d._getStrictElement(this._originalSequence,r),a=d._getStrictElement(this._modifiedSequence,l);return e===a}static _getStrictElement(r,l){return typeof r.getStrictElement=="function"?r.getStrictElement(l):null}OriginalElementsAreEqual(r,l){return this._originalElementsOrHash[r]!==this._originalElementsOrHash[l]?!1:this._hasStrings?this._originalStringElements[r]===this._originalStringElements[l]:!0}ModifiedElementsAreEqual(r,l){return this._modifiedElementsOrHash[r]!==this._modifiedElementsOrHash[l]?!1:this._hasStrings?this._modifiedStringElements[r]===this._modifiedStringElements[l]:!0}ComputeDiff(r){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,r)}_ComputeDiff(r,l,e,a,n){const h=[!1];let s=this.ComputeDiffRecursive(r,l,e,a,h);return n&&(s=this.PrettifyChanges(s)),{quitEarly:h[0],changes:s}}ComputeDiffRecursive(r,l,e,a,n){for(n[0]=!1;r<=l&&e<=a&&this.ElementsAreEqual(r,e);)r++,e++;for(;l>=r&&a>=e&&this.ElementsAreEqual(l,a);)l--,a--;if(r>l||e>a){let f;return e<=a?(w.Assert(r===l+1,"originalStart should only be one more than originalEnd"),f=[new E.DiffChange(r,0,e,a-e+1)]):r<=l?(w.Assert(e===a+1,"modifiedStart should only be one more than modifiedEnd"),f=[new E.DiffChange(r,l-r+1,e,0)]):(w.Assert(r===l+1,"originalStart should only be one more than originalEnd"),w.Assert(e===a+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const h=[0],s=[0],p=this.ComputeRecursionPoint(r,l,e,a,h,s,n),v=h[0],C=s[0];if(p!==null)return p;if(!n[0]){const f=this.ComputeDiffRecursive(r,v,e,C,n);let D=[];return n[0]?D=[new E.DiffChange(v+1,l-(v+1)+1,C+1,a-(C+1)+1)]:D=this.ComputeDiffRecursive(v+1,l,C+1,a,n),this.ConcatenateChanges(f,D)}return[new E.DiffChange(r,l-r+1,e,a-e+1)]}WALKTRACE(r,l,e,a,n,h,s,p,v,C,f,D,M,R,g,m,L,k){let A=null,H=null,G=new u,ne=l,se=e,de=M[0]-m[0]-a,ue=-1073741824,re=this.m_forwardHistory.length-1;do{const le=de+r;le===ne||le<se&&v[le-1]<v[le+1]?(f=v[le+1],R=f-de-a,f<ue&&G.MarkNextChange(),ue=f,G.AddModifiedElement(f+1,R),de=le+1-r):(f=v[le-1]+1,R=f-de-a,f<ue&&G.MarkNextChange(),ue=f-1,G.AddOriginalElement(f,R+1),de=le-1-r),re>=0&&(v=this.m_forwardHistory[re],r=v[0],ne=1,se=v.length-1)}while(--re>=-1);if(A=G.getReverseChanges(),k[0]){let le=M[0]+1,ye=m[0]+1;if(A!==null&&A.length>0){const Te=A[A.length-1];le=Math.max(le,Te.getOriginalEnd()),ye=Math.max(ye,Te.getModifiedEnd())}H=[new E.DiffChange(le,D-le+1,ye,g-ye+1)]}else{G=new u,ne=h,se=s,de=M[0]-m[0]-p,ue=1073741824,re=L?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const le=de+n;le===ne||le<se&&C[le-1]>=C[le+1]?(f=C[le+1]-1,R=f-de-p,f>ue&&G.MarkNextChange(),ue=f+1,G.AddOriginalElement(f+1,R+1),de=le+1-n):(f=C[le-1],R=f-de-p,f>ue&&G.MarkNextChange(),ue=f,G.AddModifiedElement(f+1,R+1),de=le-1-n),re>=0&&(C=this.m_reverseHistory[re],n=C[0],ne=1,se=C.length-1)}while(--re>=-1);H=G.getChanges()}return this.ConcatenateChanges(A,H)}ComputeRecursionPoint(r,l,e,a,n,h,s){let p=0,v=0,C=0,f=0,D=0,M=0;r--,e--,n[0]=0,h[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const R=l-r+(a-e),g=R+1,m=new Int32Array(g),L=new Int32Array(g),k=a-e,A=l-r,H=r-e,G=l-a,se=(A-k)%2===0;m[k]=r,L[A]=l,s[0]=!1;for(let de=1;de<=R/2+1;de++){let ue=0,re=0;C=this.ClipDiagonalBound(k-de,de,k,g),f=this.ClipDiagonalBound(k+de,de,k,g);for(let ye=C;ye<=f;ye+=2){ye===C||ye<f&&m[ye-1]<m[ye+1]?p=m[ye+1]:p=m[ye-1]+1,v=p-(ye-k)-H;const Te=p;for(;p<l&&v<a&&this.ElementsAreEqual(p+1,v+1);)p++,v++;if(m[ye]=p,p+v>ue+re&&(ue=p,re=v),!se&&Math.abs(ye-A)<=de-1&&p>=L[ye])return n[0]=p,h[0]=v,Te<=L[ye]&&1447>0&&de<=1447+1?this.WALKTRACE(k,C,f,H,A,D,M,G,m,L,p,l,n,v,a,h,se,s):null}const le=(ue-r+(re-e)-de)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(ue,le))return s[0]=!0,n[0]=ue,h[0]=re,le>0&&1447>0&&de<=1447+1?this.WALKTRACE(k,C,f,H,A,D,M,G,m,L,p,l,n,v,a,h,se,s):(r++,e++,[new E.DiffChange(r,l-r+1,e,a-e+1)]);D=this.ClipDiagonalBound(A-de,de,A,g),M=this.ClipDiagonalBound(A+de,de,A,g);for(let ye=D;ye<=M;ye+=2){ye===D||ye<M&&L[ye-1]>=L[ye+1]?p=L[ye+1]-1:p=L[ye-1],v=p-(ye-A)-G;const Te=p;for(;p>r&&v>e&&this.ElementsAreEqual(p,v);)p--,v--;if(L[ye]=p,se&&Math.abs(ye-k)<=de&&p<=m[ye])return n[0]=p,h[0]=v,Te>=m[ye]&&1447>0&&de<=1447+1?this.WALKTRACE(k,C,f,H,A,D,M,G,m,L,p,l,n,v,a,h,se,s):null}if(de<=1447){let ye=new Int32Array(f-C+2);ye[0]=k-C+1,y.Copy2(m,C,ye,1,f-C+1),this.m_forwardHistory.push(ye),ye=new Int32Array(M-D+2),ye[0]=A-D+1,y.Copy2(L,D,ye,1,M-D+1),this.m_reverseHistory.push(ye)}}return this.WALKTRACE(k,C,f,H,A,D,M,G,m,L,p,l,n,v,a,h,se,s)}PrettifyChanges(r){for(let l=0;l<r.length;l++){const e=r[l],a=l<r.length-1?r[l+1].originalStart:this._originalElementsOrHash.length,n=l<r.length-1?r[l+1].modifiedStart:this._modifiedElementsOrHash.length,h=e.originalLength>0,s=e.modifiedLength>0;for(;e.originalStart+e.originalLength<a&&e.modifiedStart+e.modifiedLength<n&&(!h||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!s||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const v=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!v)break;e.originalStart++,e.modifiedStart++}const p=[null];if(l<r.length-1&&this.ChangesOverlap(r[l],r[l+1],p)){r[l]=p[0],r.splice(l+1,1),l--;continue}}for(let l=r.length-1;l>=0;l--){const e=r[l];let a=0,n=0;if(l>0){const f=r[l-1];a=f.originalStart+f.originalLength,n=f.modifiedStart+f.modifiedLength}const h=e.originalLength>0,s=e.modifiedLength>0;let p=0,v=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let f=1;;f++){const D=e.originalStart-f,M=e.modifiedStart-f;if(D<a||M<n||h&&!this.OriginalElementsAreEqual(D,D+e.originalLength)||s&&!this.ModifiedElementsAreEqual(M,M+e.modifiedLength))break;const g=(D===a&&M===n?5:0)+this._boundaryScore(D,e.originalLength,M,e.modifiedLength);g>v&&(v=g,p=f)}e.originalStart-=p,e.modifiedStart-=p;const C=[null];if(l>0&&this.ChangesOverlap(r[l-1],r[l],C)){r[l-1]=C[0],r.splice(l,1),l++;continue}}if(this._hasStrings)for(let l=1,e=r.length;l<e;l++){const a=r[l-1],n=r[l],h=n.originalStart-a.originalStart-a.originalLength,s=a.originalStart,p=n.originalStart+n.originalLength,v=p-s,C=a.modifiedStart,f=n.modifiedStart+n.modifiedLength,D=f-C;if(h<5&&v<20&&D<20){const M=this._findBetterContiguousSequence(s,v,C,D,h);if(M){const[R,g]=M;(R!==a.originalStart+a.originalLength||g!==a.modifiedStart+a.modifiedLength)&&(a.originalLength=R-a.originalStart,a.modifiedLength=g-a.modifiedStart,n.originalStart=R+h,n.modifiedStart=g+h,n.originalLength=p-n.originalStart,n.modifiedLength=f-n.modifiedStart)}}}return r}_findBetterContiguousSequence(r,l,e,a,n){if(l<n||a<n)return null;const h=r+l-n+1,s=e+a-n+1;let p=0,v=0,C=0;for(let f=r;f<h;f++)for(let D=e;D<s;D++){const M=this._contiguousSequenceScore(f,D,n);M>0&&M>p&&(p=M,v=f,C=D)}return p>0?[v,C]:null}_contiguousSequenceScore(r,l,e){let a=0;for(let n=0;n<e;n++){if(!this.ElementsAreEqual(r+n,l+n))return 0;a+=this._originalStringElements[r+n].length}return a}_OriginalIsBoundary(r){return r<=0||r>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[r])}_OriginalRegionIsBoundary(r,l){if(this._OriginalIsBoundary(r)||this._OriginalIsBoundary(r-1))return!0;if(l>0){const e=r+l;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(r){return r<=0||r>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[r])}_ModifiedRegionIsBoundary(r,l){if(this._ModifiedIsBoundary(r)||this._ModifiedIsBoundary(r-1))return!0;if(l>0){const e=r+l;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(r,l,e,a){const n=this._OriginalRegionIsBoundary(r,l)?1:0,h=this._ModifiedRegionIsBoundary(e,a)?1:0;return n+h}ConcatenateChanges(r,l){const e=[];if(r.length===0||l.length===0)return l.length>0?l:r;if(this.ChangesOverlap(r[r.length-1],l[0],e)){const a=new Array(r.length+l.length-1);return y.Copy(r,0,a,0,r.length-1),a[r.length-1]=e[0],y.Copy(l,1,a,r.length,l.length-1),a}else{const a=new Array(r.length+l.length);return y.Copy(r,0,a,0,r.length),y.Copy(l,0,a,r.length,l.length),a}}ChangesOverlap(r,l,e){if(w.Assert(r.originalStart<=l.originalStart,"Left change is not less than or equal to right change"),w.Assert(r.modifiedStart<=l.modifiedStart,"Left change is not less than or equal to right change"),r.originalStart+r.originalLength>=l.originalStart||r.modifiedStart+r.modifiedLength>=l.modifiedStart){const a=r.originalStart;let n=r.originalLength;const h=r.modifiedStart;let s=r.modifiedLength;return r.originalStart+r.originalLength>=l.originalStart&&(n=l.originalStart+l.originalLength-r.originalStart),r.modifiedStart+r.modifiedLength>=l.modifiedStart&&(s=l.modifiedStart+l.modifiedLength-r.modifiedStart),e[0]=new E.DiffChange(a,n,h,s),!0}else return e[0]=null,!1}ClipDiagonalBound(r,l,e,a){if(r>=0&&r<a)return r;const n=e,h=a-e-1,s=l%2===0;if(r<0){const p=n%2===0;return s===p?0:1}else{const p=h%2===0;return s===p?a-1:a-2}}}t.LcsDiff=d}),define(ge[47],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MicrotaskDelay=void 0,t.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ge[85],me([1,0,13,10]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class i{constructor(){this._value="",this._pos=0}reset(l){return this._value=l,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(l){const e=l.charCodeAt(0),a=this._value.charCodeAt(this._pos);return e-a}value(){return this._value[this._pos]}}t.StringIterator=i;class W{constructor(l=!0){this._caseSensitive=l}reset(l){return this._value=l,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(l)this._from++;else break;else l=!1;return this}cmp(l){return this._caseSensitive?(0,I.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=W;class w{constructor(l=!0,e=!0){this._splitOnBackslash=l,this._caseSensitive=e}reset(l){this._from=0,this._to=0,this._value=l,this._valueLen=l.length;for(let e=l.length-1;e>=0;e--,this._valueLen--){const a=this._value.charCodeAt(e);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let l=!0;for(;this._to<this._valueLen;this._to++){const e=this._value.charCodeAt(this._to);if(e===47||this._splitOnBackslash&&e===92)if(l)this._from++;else break;else l=!1}return this}cmp(l){return this._caseSensitive?(0,I.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=w;var y;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(y||(y={}));class c{constructor(l,e){this._ignorePathCasing=l,this._ignoreQueryAndFragment=e,this._states=[],this._stateIdx=0}reset(l){return this._value=l,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new w(!1,!this._ignorePathCasing(l)),this._pathIterator.reset(l.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(l)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(l){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(l,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(l,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(l);if(this._states[this._stateIdx]===4)return(0,I.compare)(l,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(l,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}t.UriIterator=c;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(d||(d={}));class P{static forUris(l=()=>!1,e=()=>!1){return new P(new c(l,e))}static forPaths(l=!1){return new P(new w(void 0,!l))}static forStrings(){return new P(new i)}static forConfigKeys(){return new P(new W)}constructor(l){this._iter=l}clear(){this._root=void 0}fill(l,e){if(e){const a=e.slice(0);(0,E.shuffle)(a);for(const n of a)this.set(n,l)}else{const a=l.slice(0);(0,E.shuffle)(a);for(const n of a)this.set(n[0],n[1])}}set(l,e){const a=this._iter.reset(l);let n;this._root||(this._root=new u,this._root.segment=a.value());const h=[];for(n=this._root;;){const p=a.cmp(n.segment);if(p>0)n.left||(n.left=new u,n.left.segment=a.value()),h.push([-1,n]),n=n.left;else if(p<0)n.right||(n.right=new u,n.right.segment=a.value()),h.push([1,n]),n=n.right;else if(a.hasNext())a.next(),n.mid||(n.mid=new u,n.mid.segment=a.value()),h.push([0,n]),n=n.mid;else break}const s=n.value;n.value=e,n.key=l;for(let p=h.length-1;p>=0;p--){const v=h[p][1];v.updateHeight();const C=v.balanceFactor();if(C<-1||C>1){const f=h[p][0],D=h[p+1][0];if(f===1&&D===1)h[p][1]=v.rotateLeft();else if(f===-1&&D===-1)h[p][1]=v.rotateRight();else if(f===1&&D===-1)v.right=h[p+1][1]=h[p+1][1].rotateRight(),h[p][1]=v.rotateLeft();else if(f===-1&&D===1)v.left=h[p+1][1]=h[p+1][1].rotateLeft(),h[p][1]=v.rotateRight();else throw new Error;if(p>0)switch(h[p-1][0]){case-1:h[p-1][1].left=h[p][1];break;case 1:h[p-1][1].right=h[p][1];break;case 0:h[p-1][1].mid=h[p][1];break}else this._root=h[0][1]}}return s}get(l){return this._getNode(l)?.value}_getNode(l){const e=this._iter.reset(l);let a=this._root;for(;a;){const n=e.cmp(a.segment);if(n>0)a=a.left;else if(n<0)a=a.right;else if(e.hasNext())e.next(),a=a.mid;else break}return a}has(l){const e=this._getNode(l);return!(e?.value===void 0&&e?.mid===void 0)}delete(l){return this._delete(l,!1)}deleteSuperstr(l){return this._delete(l,!0)}_delete(l,e){const a=this._iter.reset(l),n=[];let h=this._root;for(;h;){const s=a.cmp(h.segment);if(s>0)n.push([-1,h]),h=h.left;else if(s<0)n.push([1,h]),h=h.right;else if(a.hasNext())a.next(),n.push([0,h]),h=h.mid;else break}if(h){if(e?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const s=this._min(h.right);if(s.key){const{key:p,value:v,segment:C}=s;this._delete(s.key,!1),h.key=p,h.value=v,h.segment=C}}else{const s=h.left??h.right;if(n.length>0){const[p,v]=n[n.length-1];switch(p){case-1:v.left=s;break;case 0:v.mid=s;break;case 1:v.right=s;break}}else this._root=s}for(let s=n.length-1;s>=0;s--){const p=n[s][1];p.updateHeight();const v=p.balanceFactor();if(v>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),n[s][1]=p.rotateLeft()):v<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),n[s][1]=p.rotateRight()),s>0)switch(n[s-1][0]){case-1:n[s-1][1].left=n[s][1];break;case 1:n[s-1][1].right=n[s][1];break;case 0:n[s-1][1].mid=n[s][1];break}else this._root=n[0][1]}}}_min(l){for(;l.left;)l=l.left;return l}findSubstr(l){const e=this._iter.reset(l);let a=this._root,n;for(;a;){const h=e.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(e.hasNext())e.next(),n=a.value||n,a=a.mid;else break}return a&&a.value||n}findSuperstr(l){return this._findSuperstrOrElement(l,!1)}_findSuperstrOrElement(l,e){const a=this._iter.reset(l);let n=this._root;for(;n;){const h=a.cmp(n.segment);if(h>0)n=n.left;else if(h<0)n=n.right;else if(a.hasNext())a.next(),n=n.mid;else return n.mid?this._entries(n.mid):e?n.value:void 0}}hasElementOrSubtree(l){return this._findSuperstrOrElement(l,!0)!==void 0}forEach(l){for(const[e,a]of this)l(a,e)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(l){const e=[];return this._dfsEntries(l,e),e[Symbol.iterator]()}_dfsEntries(l,e){l&&(l.left&&this._dfsEntries(l.left,e),l.value&&e.push([l.key,l.value]),l.mid&&this._dfsEntries(l.mid,e),l.right&&this._dfsEntries(l.right,e))}_isBalanced(){const l=e=>{if(!e)return!0;const a=e.balanceFactor();return a<-1||a>1?!1:l(e.left)&&l(e.right)};return l(this._root)}}t.TernarySearchTree=P}),define(ge[6],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function E(D){return typeof D=="string"}t.isString=E;function I(D){return Array.isArray(D)&&D.every(M=>E(M))}t.isStringArray=I;function i(D){return typeof D=="object"&&D!==null&&!Array.isArray(D)&&!(D instanceof RegExp)&&!(D instanceof Date)}t.isObject=i;function W(D){const M=Object.getPrototypeOf(Uint8Array);return typeof D=="object"&&D instanceof M}t.isTypedArray=W;function w(D){return typeof D=="number"&&!isNaN(D)}t.isNumber=w;function y(D){return!!D&&typeof D[Symbol.iterator]=="function"}t.isIterable=y;function c(D){return D===!0||D===!1}t.isBoolean=c;function u(D){return typeof D>"u"}t.isUndefined=u;function d(D){return!P(D)}t.isDefined=d;function P(D){return u(D)||D===null}t.isUndefinedOrNull=P;function r(D,M){if(!D)throw new Error(M?`Unexpected type, expected '${M}'`:"Unexpected type")}t.assertType=r;function l(D){if(P(D))throw new Error("Assertion Failed: argument is undefined or null");return D}t.assertIsDefined=l;function e(...D){const M=[];for(let R=0;R<D.length;R++){const g=D[R];if(P(g))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);M.push(g)}return M}t.assertAllDefined=e;const a=Object.prototype.hasOwnProperty;function n(D){if(!i(D))return!1;for(const M in D)if(a.call(D,M))return!1;return!0}t.isEmptyObject=n;function h(D){return typeof D=="function"}t.isFunction=h;function s(...D){return D.length>0&&D.every(h)}t.areFunctions=s;function p(D,M){const R=Math.min(D.length,M.length);for(let g=0;g<R;g++)v(D[g],M[g])}t.validateConstraints=p;function v(D,M){if(E(M)){if(typeof D!==M)throw new Error(`argument does not match constraint: typeof ${M}`)}else if(h(M)){try{if(D instanceof M)return}catch{}if(!P(D)&&D.constructor===M||M.length===1&&M.call(void 0,D)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=v;function C(D){return D===null?void 0:D}t.withNullAsUndefined=C;function f(D){return typeof D>"u"?null:D}t.withUndefinedAsNull=f}),define(ge[17],me([1,0,6]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const I=Object.create(null);function i(y,c){if((0,E.isString)(c)){const u=I[c];if(u===void 0)throw new Error(`${y} references an unknown codicon: ${c}`);c=u}return I[y]=c,{id:y}}function W(){return I}t.getCodiconFontCharacters=W;function w(){return Object.values(t.Codicon)}t.getAllCodicons=w,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(ge[48],me([1,0,6]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function I(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const s=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([p,v])=>{s[p]=v&&typeof v=="object"?I(v):v}),s}t.deepClone=I;function i(h){if(!h||typeof h!="object")return h;const s=[h];for(;s.length>0;){const p=s.shift();Object.freeze(p);for(const v in p)if(W.call(p,v)){const C=p[v];typeof C=="object"&&!Object.isFrozen(C)&&!(0,E.isTypedArray)(C)&&s.push(C)}}return h}t.deepFreeze=i;const W=Object.prototype.hasOwnProperty;function w(h,s){return y(h,s,new Set)}t.cloneAndChange=w;function y(h,s,p){if((0,E.isUndefinedOrNull)(h))return h;const v=s(h);if(typeof v<"u")return v;if(Array.isArray(h)){const C=[];for(const f of h)C.push(y(f,s,p));return C}if((0,E.isObject)(h)){if(p.has(h))throw new Error("Cannot clone recursive data-structure");p.add(h);const C={};for(const f in h)W.call(h,f)&&(C[f]=y(h[f],s,p));return p.delete(h),C}return h}function c(h,s,p=!0){return(0,E.isObject)(h)?((0,E.isObject)(s)&&Object.keys(s).forEach(v=>{v in h?p&&((0,E.isObject)(h[v])&&(0,E.isObject)(s[v])?c(h[v],s[v],p):h[v]=s[v]):h[v]=s[v]}),h):s}t.mixin=c;function u(h,s){if(h===s)return!0;if(h==null||s===null||s===void 0||typeof h!=typeof s||typeof h!="object"||Array.isArray(h)!==Array.isArray(s))return!1;let p,v;if(Array.isArray(h)){if(h.length!==s.length)return!1;for(p=0;p<h.length;p++)if(!u(h[p],s[p]))return!1}else{const C=[];for(v in h)C.push(v);C.sort();const f=[];for(v in s)f.push(v);if(f.sort(),!u(C,f))return!1;for(p=0;p<C.length;p++)if(!u(h[C[p]],s[C[p]]))return!1}return!0}t.equals=u;function d(h){const s=new Set;return JSON.stringify(h,(p,v)=>{if((0,E.isObject)(v)||Array.isArray(v)){if(s.has(v))return"[Circular]";s.add(v)}return v})}t.safeStringify=d;function P(h,s){const p=Object.create(null);return!h||!s||Object.keys(s).forEach(C=>{const f=h[C],D=s[C];u(f,D)||(p[C]=D)}),p}t.distinct=P;function r(h,s){const p=s.toLowerCase(),v=Object.keys(h).find(C=>C.toLowerCase()===p);return v?h[v]:h[s]}t.getCaseInsensitive=r;function l(h,s){const p=Object.create(null);for(const[v,C]of Object.entries(h))s(v,C)&&(p[v]=C);return p}t.filter=l;function e(h){let s=[],p=Object.getPrototypeOf(h);for(;Object.prototype!==p;)s=s.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return s}t.getAllPropertyNames=e;function a(h){const s=[];for(const p of e(h))typeof h[p]=="function"&&s.push(p);return s}t.getAllMethodNames=a;function n(h,s){const p=C=>function(){const f=Array.prototype.slice.call(arguments,0);return s(C,f)},v={};for(const C of h)v[C]=p(C);return v}t.createProxyObject=n}),define(ge[18],me([1,0,17]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.themeColorFromId=t.ThemeColor=void 0;var I;(function(w){function y(c){return c&&typeof c=="object"&&typeof c.id=="string"}w.isThemeColor=y})(I||(t.ThemeColor=I={}));function i(w){return{id:w}}t.themeColorFromId=i;var W;(function(w){w.iconNameSegment="[A-Za-z0-9]+",w.iconNameExpression="[A-Za-z0-9-]+",w.iconModifierExpression="~[A-Za-z]+",w.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${w.iconNameExpression})(${w.iconModifierExpression})?$`);function c(s){const p=y.exec(s.id);if(!p)return c(E.Codicon.error);const[,v,C]=p,f=["codicon","codicon-"+v];return C&&f.push("codicon-modifier-"+C.substring(1)),f}w.asClassNameArray=c;function u(s){return c(s).join(" ")}w.asClassName=u;function d(s){return"."+c(s).join(".")}w.asCSSSelector=d;function P(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||I.isThemeColor(s.color))}w.isThemeIcon=P;const r=new RegExp(`^\\$\\((${w.iconNameExpression}(?:${w.iconModifierExpression})?)\\)$`);function l(s){const p=r.exec(s);if(!p)return;const[,v]=p;return{id:v}}w.fromString=l;function e(s){return{id:s}}w.fromId=e;function a(s,p){let v=s.id;const C=v.lastIndexOf("~");return C!==-1&&(v=v.substring(0,C)),p&&(v=`${v}~${p}`),{id:v}}w.modify=a;function n(s){const p=s.id.lastIndexOf("~");if(p!==-1)return s.id.substring(p+1)}w.getModifier=n;function h(s,p){return s.id===p.id&&s.color?.id===p.color?.id}w.isEqual=h})(W||(t.ThemeIcon=W={}))}),define(ge[33],me([1,0,32,10,18]),function(ee,t,E,I,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.getCodiconAriaLabel=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=void 0;const W="$(",w=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${w.source}`,"g");function c(h){return h.replace(y,(s,p)=>p?s:`\\${s}`)}t.escapeIcons=c;const u=new RegExp(`\\\\${w.source}`,"g");function d(h){return h.replace(u,s=>`\\${s}`)}t.markdownEscapeEscapedIcons=d;const P=new RegExp(`(\\s)?(\\\\)?${w.source}(\\s)?`,"g");function r(h){return h.indexOf(W)===-1?h:h.replace(P,(s,p,v,C)=>v?s:p||C||"")}t.stripIcons=r;function l(h){return h?h.replace(/\$\((.*?)\)/g,(s,p)=>` ${p} `).trim():""}t.getCodiconAriaLabel=l;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(h){e.lastIndex=0;let s="";const p=[];let v=0;for(;;){const C=e.lastIndex,f=e.exec(h),D=h.substring(C,f?.index);if(D.length>0){s+=D;for(let M=0;M<D.length;M++)p.push(v)}if(!f)break;v+=f[0].length}return{text:s,iconOffsets:p}}t.parseLabelWithIcons=a;function n(h,s,p=!1){const{text:v,iconOffsets:C}=s;if(!C||C.length===0)return(0,E.matchesFuzzy)(h,v,p);const f=(0,I.ltrim)(v," "),D=v.length-f.length,M=(0,E.matchesFuzzy)(h,f,p);if(M)for(const R of M){const g=C[R.start+D]+D;R.start+=g,R.end+=g}return M}t.matchesFuzzyIconAware=n}),define(ge[86],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ge[87],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class E{constructor(i,W){this.sender=i,this.onMessage=W}send(i){try{this.sender.send("vscode:message",i.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=E}),define(ge[49],me([8]),{}),define(ge[88],me([8]),{}),define(ge[89],me([8]),{}),define(ge[90],me([8]),{}),define(ge[91],me([1,0,89,90]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(ge[92],me([8]),{}),define(ge[93],me([8]),{}),define(ge[94],me([8]),{}),define(ge[95],me([8]),{}),define(ge[96],me([8]),{}),define(ge[97],me([8]),{}),define(ge[98],me([8]),{}),define(ge[99],me([8]),{}),define(ge[100],me([8]),{}),define(ge[101],me([12,11]),function(ee,t){return ee.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(ge[102],me([12,11]),function(ee,t){return ee.create("vs/base/browser/ui/findinput/findInput",t)}),define(ge[103],me([12,11]),function(ee,t){return ee.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(ge[104],me([12,11]),function(ee,t){return ee.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(ge[105],me([12,11]),function(ee,t){return ee.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(ge[106],me([12,11]),function(ee,t){return ee.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(ge[107],me([12,11]),function(ee,t){return ee.create("vs/base/browser/ui/tree/abstractTree",t)}),define(ge[108],me([12,11]),function(ee,t){return ee.create("vs/base/common/actions",t)}),define(ge[34],me([1,0,3,2,108]),function(ee,t,E,I,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class W extends I.Disposable{constructor(r,l="",e="",a=!0,n){super(),this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=r,this._label=l,this._cssClass=e,this._enabled=a,this._actionCallback=n}get id(){return this._id}get label(){return this._label}set label(r){this._setLabel(r)}_setLabel(r){this._label!==r&&(this._label=r,this._onDidChange.fire({label:r}))}get tooltip(){return this._tooltip||""}set tooltip(r){this._setTooltip(r)}_setTooltip(r){this._tooltip!==r&&(this._tooltip=r,this._onDidChange.fire({tooltip:r}))}get class(){return this._cssClass}set class(r){this._setClass(r)}_setClass(r){this._cssClass!==r&&(this._cssClass=r,this._onDidChange.fire({class:r}))}get enabled(){return this._enabled}set enabled(r){this._setEnabled(r)}_setEnabled(r){this._enabled!==r&&(this._enabled=r,this._onDidChange.fire({enabled:r}))}get checked(){return this._checked}set checked(r){this._setChecked(r)}_setChecked(r){this._checked!==r&&(this._checked=r,this._onDidChange.fire({checked:r}))}async run(r,l){this._actionCallback&&await this._actionCallback(r)}}t.Action=W;class w extends I.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new E.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new E.Emitter),this.onDidRun=this._onDidRun.event}async run(r,l){if(!r.enabled)return;this._onWillRun.fire({action:r});let e;try{await this.runAction(r,l)}catch(a){e=a}this._onDidRun.fire({action:r,error:e})}async runAction(r,l){await r.run(l)}}t.ActionRunner=w;class y{constructor(){this.id=y.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...r){let l=[];for(const e of r)e.length&&(l.length?l=[...l,new y,...e]:l=e);return l}async run(){}}t.Separator=y,y.ID="vs.actions.separator";class c{get actions(){return this._actions}constructor(r,l,e,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=r,this.label=l,this.class=a,this._actions=e}async run(){}}t.SubmenuAction=c;class u extends W{constructor(){super(u.ID,i.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=u,u.ID="vs.actions.empty";function d(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async()=>P.run(),tooltip:P.label}}t.toAction=d}),define(ge[109],me([12,11]),function(ee,t){return ee.create("vs/base/common/platform",t)}),define(ge[5],me([1,0,109]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let I=!1,i=!1,W=!1,w=!1,y=!1,c=!1,u=!1,d=!1,P=!1,r=!1,l,e=t.LANGUAGE_DEFAULT,a=t.LANGUAGE_DEFAULT,n,h;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?s=t.globals.vscode.process:typeof process<"u"&&(s=process);const p=typeof s?.versions?.electron=="string",v=p&&s?.type==="renderer";if(typeof navigator=="object"&&!v)h=navigator.userAgent,I=h.indexOf("Windows")>=0,i=h.indexOf("Macintosh")>=0,d=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,W=h.indexOf("Linux")>=0,r=h?.indexOf("Mobi")>=0,c=!0,l=E.getConfiguredDefaultLocale(E.localize(0,null))||t.LANGUAGE_DEFAULT,e=l,a=navigator.language;else if(typeof s=="object"){I=s.platform==="win32",i=s.platform==="darwin",W=s.platform==="linux",w=W&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,u=p,P=!!s.env.CI||!!s.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const k=s.env.VSCODE_NLS_CONFIG;if(k)try{const A=JSON.parse(k),H=A.availableLanguages["*"];l=A.locale,a=A.osLocale,e=H||t.LANGUAGE_DEFAULT,n=A._translationsConfigFile}catch{}y=!0}else console.error("Unable to resolve platform.");var C;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(C||(t.Platform=C={}));function f(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=f;let D=0;i?D=1:I?D=3:W&&(D=2),t.isWindows=I,t.isMacintosh=i,t.isLinux=W,t.isLinuxSnap=w,t.isNative=y,t.isElectron=u,t.isWeb=c,t.isWebWorker=c&&typeof t.globals.importScripts=="function",t.isIOS=d,t.isMobile=r,t.isCI=P,t.platform=D,t.userAgent=h,t.language=e;var M;(function(k){function A(){return t.language}k.value=A;function H(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}k.isDefaultVariant=H;function G(){return t.language==="en"}k.isDefault=G})(M||(t.Language=M={})),t.locale=l,t.platformLocale=a,t.translationsConfigFile=n,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const k=[];t.globals.addEventListener("message",H=>{if(H.data&&H.data.vscodeScheduleAsyncWork)for(let G=0,ne=k.length;G<ne;G++){const se=k[G];if(se.id===H.data.vscodeScheduleAsyncWork){k.splice(G,1),se.callback();return}}});let A=0;return H=>{const G=++A;k.push({id:G,callback:H}),t.globals.postMessage({vscodeScheduleAsyncWork:G},"*")}}return k=>setTimeout(k)})();var R;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(R||(t.OperatingSystem=R={})),t.OS=i||d?2:I?1:3;let g=!0,m=!1;function L(){if(!m){m=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,g=new Uint16Array(k.buffer)[0]===(2<<8)+1}return g}t.isLittleEndian=L,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(ge[110],me([1,0,16,5]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var i;(function(W){W[W.Always=0]="Always",W[W.FullScreen=1]="FullScreen",W[W.None=2]="None"})(i||(t.KeyboardSupport=i={})),t.BrowserFeatures={clipboard:{writeText:I.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:I.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>I.isNative||E.isStandalone()?0:navigator.keyboard||E.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(ge[14],me([1,0,16,42,74,5]),function(ee,t,E,I,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function w(e){if(e.charCode){const n=String.fromCharCode(e.charCode).toUpperCase();return I.KeyCodeUtils.fromString(n)}const a=e.keyCode;if(a===3)return 7;if(E.isFirefox)switch(a){case 59:return 85;case 60:if(W.isLinux)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(W.isMacintosh)return 57;break}else if(E.isWebKit){if(W.isMacintosh&&a===93)return 57;if(!W.isMacintosh&&a===92)return 57}return I.EVENT_KEY_CODE_MAP[a]||0}const y=W.isMacintosh?256:2048,c=512,u=1024,d=W.isMacintosh?2048:256;function P(e){const a=[];return e.ctrlKey&&a.push("ctrl"),e.shiftKey&&a.push("shift"),e.altKey&&a.push("alt"),e.metaKey&&a.push("meta"),`modifiers: [${a.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=P;function r(e){const a=[];return e.ctrlKey&&a.push("ctrl"),e.shiftKey&&a.push("shift"),e.altKey&&a.push("alt"),e.metaKey&&a.push("meta"),`modifiers: [${a.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${I.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=r;class l{constructor(a){this._standardKeyboardEventBrand=!0;const n=a;this.browserEvent=n,this.target=n.target,this.ctrlKey=n.ctrlKey,this.shiftKey=n.shiftKey,this.altKey=n.altKey,this.metaKey=n.metaKey,this.altGraphKey=n.getModifierState("AltGraph"),this.keyCode=w(n),this.code=n.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this._asKeybinding=this._computeKeybinding(),this._asKeyCodeChord=this._computeKeyCodeChord()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this._asKeyCodeChord}equals(a){return this._asKeybinding===a}_computeKeybinding(){let a=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(a=this.keyCode);let n=0;return this.ctrlKey&&(n|=y),this.altKey&&(n|=c),this.shiftKey&&(n|=u),this.metaKey&&(n|=d),n|=a,n}_computeKeyCodeChord(){let a=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(a=this.keyCode),new i.KeyCodeChord(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,a)}}t.StandardKeyboardEvent=l}),define(ge[21],me([1,0,16,66,5]),function(ee,t,E,I,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class W{constructor(u){this.timestamp=Date.now(),this.browserEvent=u,this.leftButton=u.button===0,this.middleButton=u.button===1,this.rightButton=u.button===2,this.buttons=u.buttons,this.target=u.target,this.detail=u.detail||1,u.type==="dblclick"&&(this.detail=2),this.ctrlKey=u.ctrlKey,this.shiftKey=u.shiftKey,this.altKey=u.altKey,this.metaKey=u.metaKey,typeof u.pageX=="number"?(this.posx=u.pageX,this.posy=u.pageY):(this.posx=u.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=u.clientY+document.body.scrollTop+document.documentElement.scrollTop);const d=I.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(window,u.view);this.posx-=d.left,this.posy-=d.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=W;class w extends W{constructor(u){super(u),this.dataTransfer=u.dataTransfer}}t.DragMouseEvent=w;class y{constructor(u,d=0,P=0){if(this.browserEvent=u||null,this.target=u?u.target||u.targetNode||u.srcElement:null,this.deltaY=P,this.deltaX=d,u){const r=u,l=u;if(typeof r.wheelDeltaY<"u")this.deltaY=r.wheelDeltaY/120;else if(typeof l.VERTICAL_AXIS<"u"&&l.axis===l.VERTICAL_AXIS)this.deltaY=-l.detail/3;else if(u.type==="wheel"){const e=u;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!i.isMacintosh?this.deltaY=-u.deltaY/3:this.deltaY=-u.deltaY:this.deltaY=-u.deltaY/40}if(typeof r.wheelDeltaX<"u")E.isSafari&&i.isWindows?this.deltaX=-(r.wheelDeltaX/120):this.deltaX=r.wheelDeltaX/120;else if(typeof l.HORIZONTAL_AXIS<"u"&&l.axis===l.HORIZONTAL_AXIS)this.deltaX=-u.detail/3;else if(u.type==="wheel"){const e=u;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!i.isMacintosh?this.deltaX=-u.deltaX/3:this.deltaX=-u.deltaX:this.deltaX=-u.deltaX/40}this.deltaY===0&&this.deltaX===0&&u.wheelDelta&&(this.deltaY=u.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=y}),define(ge[111],me([1,0,5]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let I;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const i=E.globals.vscode.process;I={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?I={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:I={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=I.cwd,t.env=I.env,t.platform=I.platform,t.arch=I.arch}),define(ge[22],me([1,0,111]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const I=65,i=97,W=90,w=122,y=46,c=47,u=92,d=58,P=63;class r extends Error{constructor(D,M,R){let g;typeof M=="string"&&M.indexOf("not ")===0?(g="must not be",M=M.replace(/^not /,"")):g="must be";const m=D.indexOf(".")!==-1?"property":"argument";let L=`The "${D}" ${m} ${g} of type ${M}`;L+=`. Received type ${typeof R}`,super(L),this.code="ERR_INVALID_ARG_TYPE"}}function l(f,D){if(f===null||typeof f!="object")throw new r(D,"Object",f)}function e(f,D){if(typeof f!="string")throw new r(D,"string",f)}const a=E.platform==="win32";function n(f){return f===c||f===u}function h(f){return f===c}function s(f){return f>=I&&f<=W||f>=i&&f<=w}function p(f,D,M,R){let g="",m=0,L=-1,k=0,A=0;for(let H=0;H<=f.length;++H){if(H<f.length)A=f.charCodeAt(H);else{if(R(A))break;A=c}if(R(A)){if(!(L===H-1||k===1))if(k===2){if(g.length<2||m!==2||g.charCodeAt(g.length-1)!==y||g.charCodeAt(g.length-2)!==y){if(g.length>2){const G=g.lastIndexOf(M);G===-1?(g="",m=0):(g=g.slice(0,G),m=g.length-1-g.lastIndexOf(M)),L=H,k=0;continue}else if(g.length!==0){g="",m=0,L=H,k=0;continue}}D&&(g+=g.length>0?`${M}..`:"..",m=2)}else g.length>0?g+=`${M}${f.slice(L+1,H)}`:g=f.slice(L+1,H),m=H-L-1;L=H,k=0}else A===y&&k!==-1?++k:k=-1}return g}function v(f,D){l(D,"pathObject");const M=D.dir||D.root,R=D.base||`${D.name||""}${D.ext||""}`;return M?M===D.root?`${M}${R}`:`${M}${f}${R}`:R}t.win32={resolve(...f){let D="",M="",R=!1;for(let g=f.length-1;g>=-1;g--){let m;if(g>=0){if(m=f[g],e(m,"path"),m.length===0)continue}else D.length===0?m=E.cwd():(m=E.env[`=${D}`]||E.cwd(),(m===void 0||m.slice(0,2).toLowerCase()!==D.toLowerCase()&&m.charCodeAt(2)===u)&&(m=`${D}\\`));const L=m.length;let k=0,A="",H=!1;const G=m.charCodeAt(0);if(L===1)n(G)&&(k=1,H=!0);else if(n(G))if(H=!0,n(m.charCodeAt(1))){let ne=2,se=ne;for(;ne<L&&!n(m.charCodeAt(ne));)ne++;if(ne<L&&ne!==se){const de=m.slice(se,ne);for(se=ne;ne<L&&n(m.charCodeAt(ne));)ne++;if(ne<L&&ne!==se){for(se=ne;ne<L&&!n(m.charCodeAt(ne));)ne++;(ne===L||ne!==se)&&(A=`\\\\${de}\\${m.slice(se,ne)}`,k=ne)}}}else k=1;else s(G)&&m.charCodeAt(1)===d&&(A=m.slice(0,2),k=2,L>2&&n(m.charCodeAt(2))&&(H=!0,k=3));if(A.length>0)if(D.length>0){if(A.toLowerCase()!==D.toLowerCase())continue}else D=A;if(R){if(D.length>0)break}else if(M=`${m.slice(k)}\\${M}`,R=H,H&&D.length>0)break}return M=p(M,!R,"\\",n),R?`${D}\\${M}`:`${D}${M}`||"."},normalize(f){e(f,"path");const D=f.length;if(D===0)return".";let M=0,R,g=!1;const m=f.charCodeAt(0);if(D===1)return h(m)?"\\":f;if(n(m))if(g=!0,n(f.charCodeAt(1))){let k=2,A=k;for(;k<D&&!n(f.charCodeAt(k));)k++;if(k<D&&k!==A){const H=f.slice(A,k);for(A=k;k<D&&n(f.charCodeAt(k));)k++;if(k<D&&k!==A){for(A=k;k<D&&!n(f.charCodeAt(k));)k++;if(k===D)return`\\\\${H}\\${f.slice(A)}\\`;k!==A&&(R=`\\\\${H}\\${f.slice(A,k)}`,M=k)}}}else M=1;else s(m)&&f.charCodeAt(1)===d&&(R=f.slice(0,2),M=2,D>2&&n(f.charCodeAt(2))&&(g=!0,M=3));let L=M<D?p(f.slice(M),!g,"\\",n):"";return L.length===0&&!g&&(L="."),L.length>0&&n(f.charCodeAt(D-1))&&(L+="\\"),R===void 0?g?`\\${L}`:L:g?`${R}\\${L}`:`${R}${L}`},isAbsolute(f){e(f,"path");const D=f.length;if(D===0)return!1;const M=f.charCodeAt(0);return n(M)||D>2&&s(M)&&f.charCodeAt(1)===d&&n(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let D,M;for(let m=0;m<f.length;++m){const L=f[m];e(L,"path"),L.length>0&&(D===void 0?D=M=L:D+=`\\${L}`)}if(D===void 0)return".";let R=!0,g=0;if(typeof M=="string"&&n(M.charCodeAt(0))){++g;const m=M.length;m>1&&n(M.charCodeAt(1))&&(++g,m>2&&(n(M.charCodeAt(2))?++g:R=!1))}if(R){for(;g<D.length&&n(D.charCodeAt(g));)g++;g>=2&&(D=`\\${D.slice(g)}`)}return t.win32.normalize(D)},relative(f,D){if(e(f,"from"),e(D,"to"),f===D)return"";const M=t.win32.resolve(f),R=t.win32.resolve(D);if(M===R||(f=M.toLowerCase(),D=R.toLowerCase(),f===D))return"";let g=0;for(;g<f.length&&f.charCodeAt(g)===u;)g++;let m=f.length;for(;m-1>g&&f.charCodeAt(m-1)===u;)m--;const L=m-g;let k=0;for(;k<D.length&&D.charCodeAt(k)===u;)k++;let A=D.length;for(;A-1>k&&D.charCodeAt(A-1)===u;)A--;const H=A-k,G=L<H?L:H;let ne=-1,se=0;for(;se<G;se++){const ue=f.charCodeAt(g+se);if(ue!==D.charCodeAt(k+se))break;ue===u&&(ne=se)}if(se!==G){if(ne===-1)return R}else{if(H>G){if(D.charCodeAt(k+se)===u)return R.slice(k+se+1);if(se===2)return R.slice(k+se)}L>G&&(f.charCodeAt(g+se)===u?ne=se:se===2&&(ne=3)),ne===-1&&(ne=0)}let de="";for(se=g+ne+1;se<=m;++se)(se===m||f.charCodeAt(se)===u)&&(de+=de.length===0?"..":"\\..");return k+=ne,de.length>0?`${de}${R.slice(k,A)}`:(R.charCodeAt(k)===u&&++k,R.slice(k,A))},toNamespacedPath(f){if(typeof f!="string"||f.length===0)return f;const D=t.win32.resolve(f);if(D.length<=2)return f;if(D.charCodeAt(0)===u){if(D.charCodeAt(1)===u){const M=D.charCodeAt(2);if(M!==P&&M!==y)return`\\\\?\\UNC\\${D.slice(2)}`}}else if(s(D.charCodeAt(0))&&D.charCodeAt(1)===d&&D.charCodeAt(2)===u)return`\\\\?\\${D}`;return f},dirname(f){e(f,"path");const D=f.length;if(D===0)return".";let M=-1,R=0;const g=f.charCodeAt(0);if(D===1)return n(g)?f:".";if(n(g)){if(M=R=1,n(f.charCodeAt(1))){let k=2,A=k;for(;k<D&&!n(f.charCodeAt(k));)k++;if(k<D&&k!==A){for(A=k;k<D&&n(f.charCodeAt(k));)k++;if(k<D&&k!==A){for(A=k;k<D&&!n(f.charCodeAt(k));)k++;if(k===D)return f;k!==A&&(M=R=k+1)}}}}else s(g)&&f.charCodeAt(1)===d&&(M=D>2&&n(f.charCodeAt(2))?3:2,R=M);let m=-1,L=!0;for(let k=D-1;k>=R;--k)if(n(f.charCodeAt(k))){if(!L){m=k;break}}else L=!1;if(m===-1){if(M===-1)return".";m=M}return f.slice(0,m)},basename(f,D){D!==void 0&&e(D,"ext"),e(f,"path");let M=0,R=-1,g=!0,m;if(f.length>=2&&s(f.charCodeAt(0))&&f.charCodeAt(1)===d&&(M=2),D!==void 0&&D.length>0&&D.length<=f.length){if(D===f)return"";let L=D.length-1,k=-1;for(m=f.length-1;m>=M;--m){const A=f.charCodeAt(m);if(n(A)){if(!g){M=m+1;break}}else k===-1&&(g=!1,k=m+1),L>=0&&(A===D.charCodeAt(L)?--L===-1&&(R=m):(L=-1,R=k))}return M===R?R=k:R===-1&&(R=f.length),f.slice(M,R)}for(m=f.length-1;m>=M;--m)if(n(f.charCodeAt(m))){if(!g){M=m+1;break}}else R===-1&&(g=!1,R=m+1);return R===-1?"":f.slice(M,R)},extname(f){e(f,"path");let D=0,M=-1,R=0,g=-1,m=!0,L=0;f.length>=2&&f.charCodeAt(1)===d&&s(f.charCodeAt(0))&&(D=R=2);for(let k=f.length-1;k>=D;--k){const A=f.charCodeAt(k);if(n(A)){if(!m){R=k+1;break}continue}g===-1&&(m=!1,g=k+1),A===y?M===-1?M=k:L!==1&&(L=1):M!==-1&&(L=-1)}return M===-1||g===-1||L===0||L===1&&M===g-1&&M===R+1?"":f.slice(M,g)},format:v.bind(null,"\\"),parse(f){e(f,"path");const D={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return D;const M=f.length;let R=0,g=f.charCodeAt(0);if(M===1)return n(g)?(D.root=D.dir=f,D):(D.base=D.name=f,D);if(n(g)){if(R=1,n(f.charCodeAt(1))){let ne=2,se=ne;for(;ne<M&&!n(f.charCodeAt(ne));)ne++;if(ne<M&&ne!==se){for(se=ne;ne<M&&n(f.charCodeAt(ne));)ne++;if(ne<M&&ne!==se){for(se=ne;ne<M&&!n(f.charCodeAt(ne));)ne++;ne===M?R=ne:ne!==se&&(R=ne+1)}}}}else if(s(g)&&f.charCodeAt(1)===d){if(M<=2)return D.root=D.dir=f,D;if(R=2,n(f.charCodeAt(2))){if(M===3)return D.root=D.dir=f,D;R=3}}R>0&&(D.root=f.slice(0,R));let m=-1,L=R,k=-1,A=!0,H=f.length-1,G=0;for(;H>=R;--H){if(g=f.charCodeAt(H),n(g)){if(!A){L=H+1;break}continue}k===-1&&(A=!1,k=H+1),g===y?m===-1?m=H:G!==1&&(G=1):m!==-1&&(G=-1)}return k!==-1&&(m===-1||G===0||G===1&&m===k-1&&m===L+1?D.base=D.name=f.slice(L,k):(D.name=f.slice(L,m),D.base=f.slice(L,k),D.ext=f.slice(m,k))),L>0&&L!==R?D.dir=f.slice(0,L-1):D.dir=D.root,D},sep:"\\",delimiter:";",win32:null,posix:null};const C=(()=>{if(a){const f=/\\/g;return()=>{const D=E.cwd().replace(f,"/");return D.slice(D.indexOf("/"))}}return()=>E.cwd()})();t.posix={resolve(...f){let D="",M=!1;for(let R=f.length-1;R>=-1&&!M;R--){const g=R>=0?f[R]:C();e(g,"path"),g.length!==0&&(D=`${g}/${D}`,M=g.charCodeAt(0)===c)}return D=p(D,!M,"/",h),M?`/${D}`:D.length>0?D:"."},normalize(f){if(e(f,"path"),f.length===0)return".";const D=f.charCodeAt(0)===c,M=f.charCodeAt(f.length-1)===c;return f=p(f,!D,"/",h),f.length===0?D?"/":M?"./":".":(M&&(f+="/"),D?`/${f}`:f)},isAbsolute(f){return e(f,"path"),f.length>0&&f.charCodeAt(0)===c},join(...f){if(f.length===0)return".";let D;for(let M=0;M<f.length;++M){const R=f[M];e(R,"path"),R.length>0&&(D===void 0?D=R:D+=`/${R}`)}return D===void 0?".":t.posix.normalize(D)},relative(f,D){if(e(f,"from"),e(D,"to"),f===D||(f=t.posix.resolve(f),D=t.posix.resolve(D),f===D))return"";const M=1,R=f.length,g=R-M,m=1,L=D.length-m,k=g<L?g:L;let A=-1,H=0;for(;H<k;H++){const ne=f.charCodeAt(M+H);if(ne!==D.charCodeAt(m+H))break;ne===c&&(A=H)}if(H===k)if(L>k){if(D.charCodeAt(m+H)===c)return D.slice(m+H+1);if(H===0)return D.slice(m+H)}else g>k&&(f.charCodeAt(M+H)===c?A=H:H===0&&(A=0));let G="";for(H=M+A+1;H<=R;++H)(H===R||f.charCodeAt(H)===c)&&(G+=G.length===0?"..":"/..");return`${G}${D.slice(m+A)}`},toNamespacedPath(f){return f},dirname(f){if(e(f,"path"),f.length===0)return".";const D=f.charCodeAt(0)===c;let M=-1,R=!0;for(let g=f.length-1;g>=1;--g)if(f.charCodeAt(g)===c){if(!R){M=g;break}}else R=!1;return M===-1?D?"/":".":D&&M===1?"//":f.slice(0,M)},basename(f,D){D!==void 0&&e(D,"ext"),e(f,"path");let M=0,R=-1,g=!0,m;if(D!==void 0&&D.length>0&&D.length<=f.length){if(D===f)return"";let L=D.length-1,k=-1;for(m=f.length-1;m>=0;--m){const A=f.charCodeAt(m);if(A===c){if(!g){M=m+1;break}}else k===-1&&(g=!1,k=m+1),L>=0&&(A===D.charCodeAt(L)?--L===-1&&(R=m):(L=-1,R=k))}return M===R?R=k:R===-1&&(R=f.length),f.slice(M,R)}for(m=f.length-1;m>=0;--m)if(f.charCodeAt(m)===c){if(!g){M=m+1;break}}else R===-1&&(g=!1,R=m+1);return R===-1?"":f.slice(M,R)},extname(f){e(f,"path");let D=-1,M=0,R=-1,g=!0,m=0;for(let L=f.length-1;L>=0;--L){const k=f.charCodeAt(L);if(k===c){if(!g){M=L+1;break}continue}R===-1&&(g=!1,R=L+1),k===y?D===-1?D=L:m!==1&&(m=1):D!==-1&&(m=-1)}return D===-1||R===-1||m===0||m===1&&D===R-1&&D===M+1?"":f.slice(D,R)},format:v.bind(null,"/"),parse(f){e(f,"path");const D={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return D;const M=f.charCodeAt(0)===c;let R;M?(D.root="/",R=1):R=0;let g=-1,m=0,L=-1,k=!0,A=f.length-1,H=0;for(;A>=R;--A){const G=f.charCodeAt(A);if(G===c){if(!k){m=A+1;break}continue}L===-1&&(k=!1,L=A+1),G===y?g===-1?g=A:H!==1&&(H=1):g!==-1&&(H=-1)}if(L!==-1){const G=m===0&&M?1:m;g===-1||H===0||H===1&&g===L-1&&g===m+1?D.base=D.name=f.slice(G,L):(D.name=f.slice(G,g),D.base=f.slice(G,L),D.ext=f.slice(g,L))}return m>0?D.dir=f.slice(0,m-1):M&&(D.dir="/"),D},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=a?t.win32.normalize:t.posix.normalize,t.isAbsolute=a?t.win32.isAbsolute:t.posix.isAbsolute,t.join=a?t.win32.join:t.posix.join,t.resolve=a?t.win32.resolve:t.posix.resolve,t.relative=a?t.win32.relative:t.posix.relative,t.dirname=a?t.win32.dirname:t.posix.dirname,t.basename=a?t.win32.basename:t.posix.basename,t.extname=a?t.win32.extname:t.posix.extname,t.format=a?t.win32.format:t.posix.format,t.parse=a?t.win32.parse:t.posix.parse,t.toNamespacedPath=a?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=a?t.win32.sep:t.posix.sep,t.delimiter=a?t.win32.delimiter:t.posix.delimiter}),define(ge[112],me([1,0,22,5,10,6]),function(ee,t,E,I,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function w(m){return m===47||m===92}t.isPathSeparator=w;function y(m){return m.replace(/[\\/]/g,E.posix.sep)}t.toSlashes=y;function c(m){return m.indexOf("/")===-1&&(m=y(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}t.toPosixPath=c;function u(m,L=E.posix.sep){if(!m)return"";const k=m.length,A=m.charCodeAt(0);if(w(A)){if(w(m.charCodeAt(1))&&!w(m.charCodeAt(2))){let G=3;const ne=G;for(;G<k&&!w(m.charCodeAt(G));G++);if(ne!==G&&!w(m.charCodeAt(G+1))){for(G+=1;G<k;G++)if(w(m.charCodeAt(G)))return m.slice(0,G+1).replace(/[\\/]/g,L)}}return L}else if(h(A)&&m.charCodeAt(1)===58)return w(m.charCodeAt(2))?m.slice(0,2)+L:m.slice(0,2);let H=m.indexOf("://");if(H!==-1){for(H+=3;H<k;H++)if(w(m.charCodeAt(H)))return m.slice(0,H+1)}return""}t.getRoot=u;function d(m){if(!I.isWindows||!m||m.length<5)return!1;let L=m.charCodeAt(0);if(L!==92||(L=m.charCodeAt(1),L!==92))return!1;let k=2;const A=k;for(;k<m.length&&(L=m.charCodeAt(k),L!==92);k++);return!(A===k||(L=m.charCodeAt(k+1),isNaN(L)||L===92))}t.isUNC=d;const P=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(m,L=I.isWindows){const k=L?P:r;return!(!m||m.length===0||/^\s+$/.test(m)||(k.lastIndex=0,k.test(m))||L&&l.test(m)||m==="."||m===".."||L&&m[m.length-1]==="."||L&&m.length!==m.trim().length||m.length>255)}t.isValidBasename=e;function a(m,L,k){const A=m===L;return!k||A?A:!m||!L?!1:(0,i.equalsIgnoreCase)(m,L)}t.isEqual=a;function n(m,L,k,A=E.sep){if(m===L)return!0;if(!m||!L||L.length>m.length)return!1;if(k){if(!(0,i.startsWithIgnoreCase)(m,L))return!1;if(L.length===m.length)return!0;let G=L.length;return L.charAt(L.length-1)===A&&G--,m.charAt(G)===A}return L.charAt(L.length-1)!==A&&(L+=A),m.indexOf(L)===0}t.isEqualOrParent=n;function h(m){return m>=65&&m<=90||m>=97&&m<=122}t.isWindowsDriveLetter=h;function s(m,L){return I.isWindows&&m.endsWith(":")&&(m+=E.sep),(0,E.isAbsolute)(m)||(m=(0,E.join)(L,m)),m=(0,E.normalize)(m),I.isWindows?(m=(0,i.rtrim)(m,E.sep),m.endsWith(":")&&(m+=E.sep)):(m=(0,i.rtrim)(m,E.sep),m||(m=E.sep)),m}t.sanitizeFilePath=s;function p(m){const L=(0,E.normalize)(m);return I.isWindows?m.length>3?!1:v(L)&&(m.length===2||L.charCodeAt(2)===92):L===E.posix.sep}t.isRootOrDriveLetter=p;function v(m,L=I.isWindows){return L?h(m.charCodeAt(0))&&m.charCodeAt(1)===58:!1}t.hasDriveLetter=v;function C(m,L=I.isWindows){return v(m,L)?m[0]:void 0}t.getDriveLetter=C;function f(m,L,k){return L.length>m.length?-1:m===L?0:(k&&(m=m.toLowerCase(),L=L.toLowerCase()),m.indexOf(L))}t.indexOfPath=f;function D(m){const L=m.split(":");let k,A,H;for(const G of L){const ne=Number(G);(0,W.isNumber)(ne)?A===void 0?A=ne:H===void 0&&(H=ne):k=k?[k,G].join(":"):G}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:A!==void 0?A:void 0,column:H!==void 0?H:A!==void 0?1:void 0}}t.parseLineAndColumnAware=D;const M="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function g(m,L,k=8){let A="";for(let G=0;G<k;G++){let ne;G===0&&I.isWindows&&!L&&(k===3||k===4)?ne=R:ne=M,A+=ne.charAt(Math.floor(Math.random()*ne.length))}let H;return L?H=`${L}-${A}`:H=A,m?(0,E.join)(m,H):H}t.randomPath=g}),define(ge[113],me([1,0,22]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function W(d){const P=(0,E.extname)(d),r=I[P.toLowerCase()];return r!==void 0?r:w(d)}t.getMediaOrTextMime=W;function w(d){const P=(0,E.extname)(d);return i[P.toLowerCase()]}t.getMediaMime=w;function y(d){for(const P in i)if(i[P]===d)return P}t.getExtensionForMimeType=y;const c=/^(.+)\/(.+?)(;.+)?$/;function u(d,P){const r=c.exec(d);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${r[3]??""}`:P?void 0:d}t.normalizeMimeType=u}),define(ge[15],me([1,0,22,5]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.isUriComponents=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,W=/^\//,w=/^\/\//;function y(R,g){if(!R.scheme&&g)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!i.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!W.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(R,g){return!R&&!g?"file":R}function u(R,g){switch(R){case"https":case"http":case"file":g?g[0]!==P&&(g=P+g):g=P;break}return g}const d="",P="/",r=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(g){return g instanceof l?!0:g?typeof g.authority=="string"&&typeof g.fragment=="string"&&typeof g.path=="string"&&typeof g.query=="string"&&typeof g.scheme=="string"&&typeof g.fsPath=="string"&&typeof g.with=="function"&&typeof g.toString=="function":!1}constructor(g,m,L,k,A,H=!1){typeof g=="object"?(this.scheme=g.scheme||d,this.authority=g.authority||d,this.path=g.path||d,this.query=g.query||d,this.fragment=g.fragment||d):(this.scheme=c(g,H),this.authority=m||d,this.path=u(this.scheme,L||d),this.query=k||d,this.fragment=A||d,y(this,H))}get fsPath(){return v(this,!1)}with(g){if(!g)return this;let{scheme:m,authority:L,path:k,query:A,fragment:H}=g;return m===void 0?m=this.scheme:m===null&&(m=d),L===void 0?L=this.authority:L===null&&(L=d),k===void 0?k=this.path:k===null&&(k=d),A===void 0?A=this.query:A===null&&(A=d),H===void 0?H=this.fragment:H===null&&(H=d),m===this.scheme&&L===this.authority&&k===this.path&&A===this.query&&H===this.fragment?this:new n(m,L,k,A,H)}static parse(g,m=!1){const L=r.exec(g);return L?new n(L[2]||d,M(L[4]||d),M(L[5]||d),M(L[7]||d),M(L[9]||d),m):new n(d,d,d,d,d)}static file(g){let m=d;if(I.isWindows&&(g=g.replace(/\\/g,P)),g[0]===P&&g[1]===P){const L=g.indexOf(P,2);L===-1?(m=g.substring(2),g=P):(m=g.substring(2,L),g=g.substring(L)||P)}return new n("file",m,g,d,d)}static from(g,m){return new n(g.scheme,g.authority,g.path,g.query,g.fragment,m)}static joinPath(g,...m){if(!g.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let L;return I.isWindows&&g.scheme==="file"?L=l.file(E.win32.join(v(g,!0),...m)).path:L=E.posix.join(g.path,...m),g.with({path:L})}toString(g=!1){return C(this,g)}toJSON(){return this}static revive(g){if(g){if(g instanceof l)return g;{const m=new n(g);return m._formatted=g.external??null,m._fsPath=g._sep===a?g.fsPath??null:null,m}}else return g}}t.URI=l;function e(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}t.isUriComponents=e;const a=I.isWindows?1:void 0;class n extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(g=!1){return g?C(this,!0):(this._formatted||(this._formatted=C(this,!1)),this._formatted)}toJSON(){const g={$mid:1};return this._fsPath&&(g.fsPath=this._fsPath,g._sep=a),this._formatted&&(g.external=this._formatted),this.path&&(g.path=this.path),this.scheme&&(g.scheme=this.scheme),this.authority&&(g.authority=this.authority),this.query&&(g.query=this.query),this.fragment&&(g.fragment=this.fragment),g}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function s(R,g,m){let L,k=-1;for(let A=0;A<R.length;A++){const H=R.charCodeAt(A);if(H>=97&&H<=122||H>=65&&H<=90||H>=48&&H<=57||H===45||H===46||H===95||H===126||g&&H===47||m&&H===91||m&&H===93||m&&H===58)k!==-1&&(L+=encodeURIComponent(R.substring(k,A)),k=-1),L!==void 0&&(L+=R.charAt(A));else{L===void 0&&(L=R.substr(0,A));const G=h[H];G!==void 0?(k!==-1&&(L+=encodeURIComponent(R.substring(k,A)),k=-1),L+=G):k===-1&&(k=A)}}return k!==-1&&(L+=encodeURIComponent(R.substring(k))),L!==void 0?L:R}function p(R){let g;for(let m=0;m<R.length;m++){const L=R.charCodeAt(m);L===35||L===63?(g===void 0&&(g=R.substr(0,m)),g+=h[L]):g!==void 0&&(g+=R[m])}return g!==void 0?g:R}function v(R,g){let m;return R.authority&&R.path.length>1&&R.scheme==="file"?m=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===47&&(R.path.charCodeAt(1)>=65&&R.path.charCodeAt(1)<=90||R.path.charCodeAt(1)>=97&&R.path.charCodeAt(1)<=122)&&R.path.charCodeAt(2)===58?g?m=R.path.substr(1):m=R.path[1].toLowerCase()+R.path.substr(2):m=R.path,I.isWindows&&(m=m.replace(/\//g,"\\")),m}t.uriToFsPath=v;function C(R,g){const m=g?p:s;let L="",{scheme:k,authority:A,path:H,query:G,fragment:ne}=R;if(k&&(L+=k,L+=":"),(A||k==="file")&&(L+=P,L+=P),A){let se=A.indexOf("@");if(se!==-1){const de=A.substr(0,se);A=A.substr(se+1),se=de.lastIndexOf(":"),se===-1?L+=m(de,!1,!1):(L+=m(de.substr(0,se),!1,!1),L+=":",L+=m(de.substr(se+1),!1,!0)),L+="@"}A=A.toLowerCase(),se=A.lastIndexOf(":"),se===-1?L+=m(A,!1,!0):(L+=m(A.substr(0,se),!1,!0),L+=A.substr(se))}if(H){if(H.length>=3&&H.charCodeAt(0)===47&&H.charCodeAt(2)===58){const se=H.charCodeAt(1);se>=65&&se<=90&&(H=`/${String.fromCharCode(se+32)}:${H.substr(3)}`)}else if(H.length>=2&&H.charCodeAt(1)===58){const se=H.charCodeAt(0);se>=65&&se<=90&&(H=`${String.fromCharCode(se+32)}:${H.substr(2)}`)}L+=m(H,!0,!1)}return G&&(L+="?",L+=m(G,!1,!1)),ne&&(L+="#",L+=g?ne:s(ne,!1,!1)),L}function f(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+f(R.substr(3)):R}}const D=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function M(R){return R.match(D)?R.replace(D,g=>f(g)):R}}),define(ge[50],me([1,0,31,10,15]),function(ee,t,E,I,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function W(u){return JSON.stringify(u,y)}t.stringify=W;function w(u){let d=JSON.parse(u);return d=c(d),d}t.parse=w;function y(u,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:(0,I.regExpFlags)(d)}:d}function c(u,d=0){if(!u||d>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return i.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof E.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let P=0;P<u.length;++P)u[P]=c(u[P],d+1);else for(const P in u)Object.hasOwnProperty.call(u,P)&&(u[P]=c(u[P],d+1))}return u}t.revive=c}),define(ge[28],me([1,0,7,5,15]),function(ee,t,E,I,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var W;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(W||(t.Schemas=W={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class w{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${W.vscodeRemoteResource}`}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}setServerRootPath(d){this._remoteResourcesPath=`${d}/${W.vscodeRemoteResource}`}set(d,P,r){this._hosts[d]=P,this._ports[d]=r}setConnectionToken(d,P){this._connectionTokens[d]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(d){if(this._delegate)try{return this._delegate(d)}catch(n){return E.onUnexpectedError(n),d}const P=d.authority;let r=this._hosts[P];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const l=this._ports[P],e=this._connectionTokens[P];let a=`path=${encodeURIComponent(d.path)}`;return typeof e=="string"&&(a+=`&${t.connectionTokenQueryName}=${encodeURIComponent(e)}`),i.URI.from({scheme:I.isWeb?this._preferredWebSchema:W.vscodeRemoteResource,authority:`${r}:${l}`,path:this._remoteResourcesPath,query:a})}}t.RemoteAuthorities=new w,t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class y{asBrowserUri(d){const P=this.toUri(d,ee);return this.uriToBrowserUri(P)}uriToBrowserUri(d){return d.scheme===W.vscodeRemote?t.RemoteAuthorities.rewrite(d):d.scheme===W.file&&(I.isNative||I.isWebWorker&&I.globals.origin===`${W.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?d.with({scheme:W.vscodeFileResource,authority:d.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):d}asFileUri(d){const P=this.toUri(d,ee);return this.uriToFileUri(P)}uriToFileUri(d){return d.scheme===W.vscodeFileResource?d.with({scheme:W.file,authority:d.authority!==y.FALLBACK_AUTHORITY?d.authority:null,query:null,fragment:null}):d}toUri(d,P){return i.URI.isUri(d)?d:i.URI.parse(P.toUrl(d))}}y.FALLBACK_AUTHORITY="vscode-app",t.FileAccess=new y;var c;(function(u){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(d.get("3"));const P="vscode-coi";function r(e){let a;typeof e=="string"?a=new URL(e).searchParams:e instanceof URL?a=e.searchParams:i.URI.isUri(e)&&(a=new URL(e.toString(!0)).searchParams);const n=a?.get(P);if(n)return d.get(n)}u.getHeadersFromQuery=r;function l(e,a,n){if(!globalThis.crossOriginIsolated)return;const h=a&&n?"3":n?"2":"1";e instanceof URLSearchParams?e.set(P,h):e[P]=h}u.addSearchParam=l})(c||(t.COI=c={}))}),define(ge[35],me([1,0,112,28,22,5,10,15]),function(ee,t,E,I,i,W,w,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function c(l){return(0,y.uriToFsPath)(l,!0)}t.originalFSPath=c;class u{constructor(e){this._ignorePathCasing=e}compare(e,a,n=!1){return e===a?0:(0,w.compare)(this.getComparisonKey(e,n),this.getComparisonKey(a,n))}isEqual(e,a,n=!1){return e===a?!0:!e||!a?!1:this.getComparisonKey(e,n)===this.getComparisonKey(a,n)}getComparisonKey(e,a=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(e){return this._ignorePathCasing(e)}isEqualOrParent(e,a,n=!1){if(e.scheme===a.scheme){if(e.scheme===I.Schemas.file)return E.isEqualOrParent(c(e),c(a),this._ignorePathCasing(e))&&e.query===a.query&&(n||e.fragment===a.fragment);if((0,t.isEqualAuthority)(e.authority,a.authority))return E.isEqualOrParent(e.path,a.path,this._ignorePathCasing(e),"/")&&e.query===a.query&&(n||e.fragment===a.fragment)}return!1}joinPath(e,...a){return y.URI.joinPath(e,...a)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return i.posix.basename(e.path)}extname(e){return i.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let a;return e.scheme===I.Schemas.file?a=y.URI.file(i.dirname(c(e))).path:(a=i.posix.dirname(e.path),e.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),a="/")),e.with({path:a})}normalizePath(e){if(!e.path.length)return e;let a;return e.scheme===I.Schemas.file?a=y.URI.file(i.normalize(c(e))).path:a=i.posix.normalize(e.path),e.with({path:a})}relativePath(e,a){if(e.scheme!==a.scheme||!(0,t.isEqualAuthority)(e.authority,a.authority))return;if(e.scheme===I.Schemas.file){const s=i.relative(c(e),c(a));return W.isWindows?E.toSlashes(s):s}let n=e.path||"/";const h=a.path||"/";if(this._ignorePathCasing(e)){let s=0;for(const p=Math.min(n.length,h.length);s<p&&!(n.charCodeAt(s)!==h.charCodeAt(s)&&n.charAt(s).toLowerCase()!==h.charAt(s).toLowerCase());s++);n=h.substr(0,s)+n.substr(s)}return i.posix.relative(n,h)}resolvePath(e,a){if(e.scheme===I.Schemas.file){const n=y.URI.file(i.resolve(c(e),a));return e.with({authority:n.authority,path:n.path})}return a=E.toPosixPath(a),e.with({path:i.posix.resolve(e.path,a)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,a){return e===a||e!==void 0&&a!==void 0&&(0,w.equalsIgnoreCase)(e,a)}hasTrailingPathSeparator(e,a=i.sep){if(e.scheme===I.Schemas.file){const n=c(e);return n.length>E.getRoot(n).length&&n[n.length-1]===a}else{const n=e.path;return n.length>1&&n.charCodeAt(n.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,a=i.sep){return(0,t.hasTrailingPathSeparator)(e,a)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,a=i.sep){let n=!1;if(e.scheme===I.Schemas.file){const h=c(e);n=h!==void 0&&h.length===E.getRoot(h).length&&h[h.length-1]===a}else{a="/";const h=e.path;n=h.length===1&&h.charCodeAt(h.length-1)===47}return!n&&!(0,t.hasTrailingPathSeparator)(e,a)?e.with({path:e.path+"/"}):e}}t.ExtUri=u,t.extUri=new u(()=>!1),t.extUriBiasedIgnorePathCase=new u(l=>l.scheme===I.Schemas.file?!W.isLinux:!0),t.extUriIgnorePathCase=new u(l=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function d(l,e){const a=[];for(let n=0;n<l.length;n++){const h=e(l[n]);l.some((s,p)=>p===n?!1:(0,t.isEqualOrParent)(h,e(s)))||a.push(l[n])}return a}t.distinctParents=d;var P;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function e(a){const n=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(p=>{const[v,C]=p.split(":");v&&C&&n.set(v,C)});const s=a.path.substring(0,a.path.indexOf(";"));return s&&n.set(l.META_DATA_MIME,s),n}l.parseMetaData=e})(P||(t.DataUri=P={}));function r(l,e,a){if(e){let n=l.path;return n&&n[0]!==i.posix.sep&&(n=i.posix.sep+n),l.with({scheme:a,authority:e,path:n})}return l.with({scheme:a})}t.toLocalResource=r}),define(ge[9],me([1,0,27,7,3,2,35,5,47]),function(ee,t,E,I,i,W,w,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function u(z){return!!z&&typeof z.then=="function"}t.isThenable=u;function d(z){const o=new E.CancellationTokenSource,F=z(o.token),j=new Promise((te,S)=>{const T=o.token.onCancellationRequested(()=>{T.dispose(),o.dispose(),S(new I.CancellationError)});Promise.resolve(F).then(O=>{T.dispose(),o.dispose(),te(O)},O=>{T.dispose(),o.dispose(),S(O)})});return new class{cancel(){o.cancel()}then(te,S){return j.then(te,S)}catch(te){return this.then(void 0,te)}finally(te){return j.finally(te)}}}t.createCancelablePromise=d;function P(z,o,F){return new Promise((j,te)=>{const S=o.onCancellationRequested(()=>{S.dispose(),j(F)});z.then(j,te).finally(()=>S.dispose())})}t.raceCancellation=P;function r(z,o){return new Promise((F,j)=>{const te=o.onCancellationRequested(()=>{te.dispose(),j(new I.CancellationError)});z.then(F,j).finally(()=>te.dispose())})}t.raceCancellationError=r;async function l(z){let o=-1;const F=z.map((j,te)=>j.then(S=>(o=te,S)));try{return await Promise.race(F)}finally{z.forEach((j,te)=>{te!==o&&j.cancel()})}}t.raceCancellablePromises=l;function e(z,o,F){let j;const te=setTimeout(()=>{j?.(void 0),F?.()},o);return Promise.race([z.finally(()=>clearTimeout(te)),new Promise(S=>j=S)])}t.raceTimeout=e;function a(z){return new Promise((o,F)=>{const j=z();u(j)?j.then(o,F):o(j)})}t.asPromise=a;class n{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(o){if(this.isDisposed)throw new Error("Throttler is disposed");if(this.activePromise){if(this.queuedPromiseFactory=o,!this.queuedPromise){const F=()=>{if(this.queuedPromise=null,this.isDisposed)return;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(F,F).then(j)})}return new Promise((F,j)=>{this.queuedPromise.then(F,j)})}return this.activePromise=o(),new Promise((F,j)=>{this.activePromise.then(te=>{this.activePromise=null,F(te)},te=>{this.activePromise=null,j(te)})})}dispose(){this.isDisposed=!0}}t.Throttler=n;class h{constructor(){this.current=Promise.resolve(null)}queue(o){return this.current=this.current.then(()=>o(),()=>o())}}t.Sequencer=h;class s{constructor(){this.promiseMap=new Map}queue(o,F){const te=(this.promiseMap.get(o)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.promiseMap.get(o)===te&&this.promiseMap.delete(o)});return this.promiseMap.set(o,te),te}}t.SequencerByKey=s;const p=(z,o)=>{let F=!0;const j=setTimeout(()=>{F=!1,o()},z);return{isTriggered:()=>F,dispose:()=>{clearTimeout(j),F=!1}}},v=z=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,z())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class C{constructor(o){this.defaultDelay=o,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(o,F=this.defaultDelay){this.task=o,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((te,S)=>{this.doResolve=te,this.doReject=S}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const te=this.task;return this.task=null,te()}}));const j=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=F===c.MicrotaskDelay?v(j):p(F,j),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new I.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=C;class f{constructor(o){this.delayer=new C(o),this.throttler=new n}trigger(o,F){return this.delayer.trigger(()=>this.throttler.queue(o),F)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}t.ThrottledDelayer=f;class D{constructor(){this._isOpen=!1,this._promise=new Promise((o,F)=>{this._completePromise=o})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=D;class M extends D{constructor(o){super(),this._timeout=setTimeout(()=>this.open(),o)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=M;function R(z,o){return o?new Promise((F,j)=>{const te=setTimeout(()=>{S.dispose(),F()},z),S=o.onCancellationRequested(()=>{clearTimeout(te),S.dispose(),j(new I.CancellationError)})}):d(F=>R(z,F))}t.timeout=R;function g(z,o=0){const F=setTimeout(z,o);return(0,W.toDisposable)(()=>clearTimeout(F))}t.disposableTimeout=g;function m(z){const o=[];let F=0;const j=z.length;function te(){return F<j?z[F++]():null}function S(T){T!=null&&o.push(T);const O=te();return O?O.then(S):Promise.resolve(o)}return Promise.resolve(null).then(S)}t.sequence=m;function L(z,o=j=>!!j,F=null){let j=0;const te=z.length,S=()=>{if(j>=te)return Promise.resolve(F);const T=z[j++];return Promise.resolve(T()).then(b=>o(b)?Promise.resolve(b):S())};return S()}t.first=L;function k(z,o=j=>!!j,F=null){if(z.length===0)return Promise.resolve(F);let j=z.length;const te=()=>{j=-1;for(const S of z)S.cancel?.()};return new Promise((S,T)=>{for(const O of z)O.then(b=>{--j>=0&&o(b)?(te(),S(b)):j===0&&S(F)}).catch(b=>{--j>=0&&(te(),T(b))})})}t.firstParallel=k;class A{constructor(o){this._size=0,this.maxDegreeOfParalellism=o,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new i.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(o){return this._size++,new Promise((F,j)=>{this.outstandingPromises.push({factory:o,c:F,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const o=this.outstandingPromises.shift();this.runningPromises++;const F=o.factory();F.then(o.c,o.e),F.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}t.Limiter=A;class H extends A{constructor(){super(1)}}t.Queue=H;class G{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const o=new ie;return this.drainers.add(o),o.p}isDrained(){for(const[,o]of this.queues)if(o.size>0)return!1;return!0}queueFor(o,F=w.extUri){const j=F.getComparisonKey(o);let te=this.queues.get(j);return te||(te=new H,i.Event.once(te.onDrained)(()=>{te?.dispose(),this.queues.delete(j),this.onDidQueueDrain()}),this.queues.set(j,te)),te}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const o of this.drainers)o.complete();this.drainers.clear()}dispose(){for(const[,o]of this.queues)o.dispose();this.queues.clear(),this.releaseDrainers()}}t.ResourceQueue=G;class ne{constructor(o,F){this._token=-1,typeof o=="function"&&typeof F=="number"&&this.setIfNotSet(o,F)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(o,F){this.cancel(),this._token=setTimeout(()=>{this._token=-1,o()},F)}setIfNotSet(o,F){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,o()},F))}}t.TimeoutTimer=ne;class se{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(o,F){this.cancel(),this._token=setInterval(()=>{o()},F)}}t.IntervalTimer=se;class de{constructor(o,F){this.timeoutToken=-1,this.runner=o,this.timeout=F,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(o=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,o)}get delay(){return this.timeout}set delay(o){this.timeout=o}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=de;class ue{constructor(o,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.runner=o,this.timeout=F,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(o=this.timeout){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(o/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=ue;class re extends de{constructor(o,F){super(o,F),this.units=[]}work(o){this.units.push(o),this.isScheduled()||this.schedule()}doRun(){const o=this.units;this.units=[],this.runner?.(o)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=re;class le extends W.Disposable{constructor(o,F){super(),this.options=o,this.handler=F,this.pendingWork=[],this.throttler=this._register(new W.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(o){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+o.length>this.options.maxBufferedWork)return!1}else if(this.pending+o.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const F of o)this.pendingWork.push(F);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new de(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=le,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=z=>{(0,y.setTimeout0)(()=>{if(o)return;const F=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let o=!1;return{dispose(){o||(o=!0)}}}:t.runWhenIdle=(z,o)=>{const F=requestIdleCallback(z,typeof o=="number"?{timeout:o}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(F))}}}}();class ye{constructor(o){this._didRun=!1,this._executor=()=>{try{this._value=o()}catch(F){this._error=F}finally{this._didRun=!0}},this._handle=(0,t.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.IdleValue=ye;async function Te(z,o,F){let j;for(let te=0;te<F;te++)try{return await z()}catch(S){j=S,await R(o)}throw j}t.retry=Te;class Me{hasPending(o){return this._pending?typeof o=="number"?this._pending.taskId===o:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(o,F,j){return this._pending={taskId:o,cancel:()=>j?.(),promise:F},F.then(()=>this.donePending(o),()=>this.donePending(o)),F}donePending(o){this._pending&&o===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const o=this._next;this._next=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}setNext(o){if(this._next)this._next.run=o;else{let F,j;const te=new Promise((S,T)=>{F=S,j=T});this._next={run:o,promise:te,promiseResolve:F,promiseReject:j}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}t.TaskSequentializer=Me;class Oe{constructor(o,F=()=>Date.now()){this.interval=o,this.nowFn=F,this.lastIncrementTime=0,this.value=0}increment(){const o=this.nowFn();return o-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=o,this.value=0),this.value++,this.value}}t.IntervalCounter=Oe;var ce;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(ce||(ce={}));class ie{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((o,F)=>{this.completeCallback=o,this.errorCallback=F})}complete(o){return new Promise(F=>{this.completeCallback(o),this.outcome={outcome:0,value:o},F()})}error(o){return new Promise(F=>{this.errorCallback(o),this.outcome={outcome:1,value:o},F()})}cancel(){return this.error(new I.CancellationError)}}t.DeferredPromise=ie;var q;(function(z){async function o(j){let te;const S=await Promise.all(j.map(T=>T.then(O=>O,O=>{te||(te=O)})));if(typeof te<"u")throw te;return S}z.settled=o;function F(j){return new Promise(async(te,S)=>{try{await j(te,S)}catch(T){S(T)}})}z.withAsyncBody=F})(q||(t.Promises=q={}));var $;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})($||($={}));class V{static fromArray(o){return new V(F=>{F.emitMany(o)})}static fromPromise(o){return new V(async F=>{F.emitMany(await o)})}static fromPromises(o){return new V(async F=>{await Promise.all(o.map(async j=>F.emitOne(await j)))})}static merge(o){return new V(async F=>{await Promise.all(o.map(async j=>{for await(const te of j)F.emitOne(te)}))})}constructor(o){this._state=0,this._results=[],this._error=null,this._onStateChanged=new i.Emitter,queueMicrotask(async()=>{const F={emitOne:j=>this.emitOne(j),emitMany:j=>this.emitMany(j),reject:j=>this.reject(j)};try{await Promise.resolve(o(F)),this.resolve()}catch(j){this.reject(j)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(o<this._results.length)return{done:!1,value:this._results[o++]};if(this._state===1)return{done:!0,value:void 0};await i.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(o,F){return new V(async j=>{for await(const te of o)j.emitOne(F(te))})}map(o){return V.map(this,o)}static filter(o,F){return new V(async j=>{for await(const te of o)F(te)&&j.emitOne(te)})}filter(o){return V.filter(this,o)}static coalesce(o){return V.filter(o,F=>!!F)}coalesce(){return V.coalesce(this)}static async toPromise(o){const F=[];for await(const j of o)F.push(j);return F}toPromise(){return V.toPromise(this)}emitOne(o){this._state===0&&(this._results.push(o),this._onStateChanged.fire())}emitMany(o){this._state===0&&(this._results=this._results.concat(o),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(o){this._state===0&&(this._state=2,this._error=o,this._onStateChanged.fire())}}t.AsyncIterableObject=V,V.EMPTY=V.fromArray([]);class _ extends V{constructor(o,F){super(F),this._source=o}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=_;function K(z){const o=new E.CancellationTokenSource,F=z(o.token);return new _(o,async j=>{const te=o.token.onCancellationRequested(()=>{te.dispose(),o.dispose(),j.reject(new I.CancellationError)});try{for await(const S of F){if(o.token.isCancellationRequested)return;j.emitOne(S)}te.dispose(),o.dispose()}catch(S){te.dispose(),o.dispose(),j.reject(S)}})}t.createCancelableAsyncIterable=K}),define(ge[4],me([1,0,16,110,14,21,9,7,3,114,2,28,5,6,15]),function(ee,t,E,I,i,W,w,y,c,u,d,P,r,l,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.basicMarkupHtmlTags=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCssValueWithDefault=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.setVisibility=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.isEventLike=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function a(Q){for(;Q.firstChild;)Q.firstChild.remove()}t.clearNode=a;function n(Q){return Q?.isConnected??!1}t.isInDOM=n;class h{constructor(Z,fe,Ce,Fe){this._node=Z,this._type=fe,this._handler=Ce,this._options=Fe||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){this._handler&&(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function s(Q,Z,fe,Ce){return new h(Q,Z,fe,Ce)}t.addDisposableListener=s;function p(Q){return function(Z){return Q(new W.StandardMouseEvent(Z))}}function v(Q){return function(Z){return Q(new i.StandardKeyboardEvent(Z))}}const C=function(Z,fe,Ce,Fe){let $e=Ce;return fe==="click"||fe==="mousedown"?$e=p(Ce):(fe==="keydown"||fe==="keypress"||fe==="keyup")&&($e=v(Ce)),s(Z,fe,$e,Fe)};t.addStandardDisposableListener=C;const f=function(Z,fe,Ce){const Fe=p(fe);return M(Z,Fe,Ce)};t.addStandardDisposableGenericMouseDownListener=f;const D=function(Z,fe,Ce){const Fe=p(fe);return g(Z,Fe,Ce)};t.addStandardDisposableGenericMouseUpListener=D;function M(Q,Z,fe){return s(Q,r.isIOS&&I.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,Z,fe)}t.addDisposableGenericMouseDownListener=M;function R(Q,Z,fe){return s(Q,r.isIOS&&I.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,Z,fe)}t.addDisposableGenericMouseMoveListener=R;function g(Q,Z,fe){return s(Q,r.isIOS&&I.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,Z,fe)}t.addDisposableGenericMouseUpListener=g;class m{constructor(Z,fe=0){this._runner=Z,this.priority=fe,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(Z){(0,y.onUnexpectedError)(Z)}}static sort(Z,fe){return fe.priority-Z.priority}}(function(){let Q=[],Z=null,fe=!1,Ce=!1;const Fe=()=>{for(fe=!1,Z=Q,Q=[],Ce=!0;Z.length>0;)Z.sort(m.sort),Z.shift().execute();Ce=!1};t.scheduleAtNextAnimationFrame=($e,ze=0)=>{const Ye=new m($e,ze);return Q.push(Ye),fe||(fe=!0,requestAnimationFrame(Fe)),Ye},t.runAtThisOrScheduleAtNextAnimationFrame=($e,ze)=>{if(Ce){const Ye=new m($e,ze);return Z.push(Ye),Ye}else return(0,t.scheduleAtNextAnimationFrame)($e,ze)}})();function L(Q){return(0,t.scheduleAtNextAnimationFrame)(Q,1e4)}t.measure=L;function k(Q){return(0,t.scheduleAtNextAnimationFrame)(Q,-1e4)}t.modify=k;const A=8,H=function(Q,Z){return Z};class G extends d.Disposable{constructor(Z,fe,Ce,Fe=H,$e=A){super();let ze=null,Ye=0;const nt=this._register(new w.TimeoutTimer),je=()=>{Ye=new Date().getTime(),Ce(ze),ze=null};this._register(s(Z,fe,vt=>{ze=Fe(ze,vt);const _t=new Date().getTime()-Ye;_t>=$e?(nt.cancel(),je()):nt.setIfNotSet(je,$e-_t)}))}}function ne(Q,Z,fe,Ce,Fe){return new G(Q,Z,fe,Ce,Fe)}t.addDisposableThrottledListener=ne;function se(Q){return document.defaultView.getComputedStyle(Q,null)}t.getComputedStyle=se;function de(Q){if(Q!==document.body)return new re(Q.clientWidth,Q.clientHeight);if(r.isIOS&&window.visualViewport)return new re(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new re(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new re(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new re(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=de;class ue{static convertToPixels(Z,fe){return parseFloat(fe)||0}static getDimension(Z,fe,Ce){const Fe=se(Z),$e=Fe?Fe.getPropertyValue(fe):"0";return ue.convertToPixels(Z,$e)}static getBorderLeftWidth(Z){return ue.getDimension(Z,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Z){return ue.getDimension(Z,"border-right-width","borderRightWidth")}static getBorderTopWidth(Z){return ue.getDimension(Z,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Z){return ue.getDimension(Z,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Z){return ue.getDimension(Z,"padding-left","paddingLeft")}static getPaddingRight(Z){return ue.getDimension(Z,"padding-right","paddingRight")}static getPaddingTop(Z){return ue.getDimension(Z,"padding-top","paddingTop")}static getPaddingBottom(Z){return ue.getDimension(Z,"padding-bottom","paddingBottom")}static getMarginLeft(Z){return ue.getDimension(Z,"margin-left","marginLeft")}static getMarginTop(Z){return ue.getDimension(Z,"margin-top","marginTop")}static getMarginRight(Z){return ue.getDimension(Z,"margin-right","marginRight")}static getMarginBottom(Z){return ue.getDimension(Z,"margin-bottom","marginBottom")}}class re{constructor(Z,fe){this.width=Z,this.height=fe}with(Z=this.width,fe=this.height){return Z!==this.width||fe!==this.height?new re(Z,fe):this}static is(Z){return typeof Z=="object"&&typeof Z.height=="number"&&typeof Z.width=="number"}static lift(Z){return Z instanceof re?Z:new re(Z.width,Z.height)}static equals(Z,fe){return Z===fe?!0:!Z||!fe?!1:Z.width===fe.width&&Z.height===fe.height}}t.Dimension=re,re.None=new re(0,0);function le(Q){let Z=Q.offsetParent,fe=Q.offsetTop,Ce=Q.offsetLeft;for(;(Q=Q.parentNode)!==null&&Q!==document.body&&Q!==document.documentElement;){fe-=Q.scrollTop;const Fe=O(Q)?null:se(Q);Fe&&(Ce-=Fe.direction!=="rtl"?Q.scrollLeft:-Q.scrollLeft),Q===Z&&(Ce+=ue.getBorderLeftWidth(Q),fe+=ue.getBorderTopWidth(Q),fe+=Q.offsetTop,Ce+=Q.offsetLeft,Z=Q.offsetParent)}return{left:Ce,top:fe}}t.getTopLeftOffset=le;function ye(Q,Z,fe){typeof Z=="number"&&(Q.style.width=`${Z}px`),typeof fe=="number"&&(Q.style.height=`${fe}px`)}t.size=ye;function Te(Q,Z,fe,Ce,Fe,$e="absolute"){typeof Z=="number"&&(Q.style.top=`${Z}px`),typeof fe=="number"&&(Q.style.right=`${fe}px`),typeof Ce=="number"&&(Q.style.bottom=`${Ce}px`),typeof Fe=="number"&&(Q.style.left=`${Fe}px`),Q.style.position=$e}t.position=Te;function Me(Q){const Z=Q.getBoundingClientRect();return{left:Z.left+window.scrollX,top:Z.top+window.scrollY,width:Z.width,height:Z.height}}t.getDomNodePagePosition=Me;function Oe(Q){let Z=Q,fe=1;do{const Ce=se(Z).zoom;Ce!=null&&Ce!=="1"&&(fe*=Ce),Z=Z.parentElement}while(Z!==null&&Z!==document.documentElement);return fe}t.getDomNodeZoomLevel=Oe;function ce(Q){const Z=ue.getMarginLeft(Q)+ue.getMarginRight(Q);return Q.offsetWidth+Z}t.getTotalWidth=ce;function ie(Q){const Z=ue.getBorderLeftWidth(Q)+ue.getBorderRightWidth(Q),fe=ue.getPaddingLeft(Q)+ue.getPaddingRight(Q);return Q.offsetWidth-Z-fe}t.getContentWidth=ie;function q(Q){const Z=ue.getMarginLeft(Q)+ue.getMarginRight(Q);return Q.scrollWidth+Z}t.getTotalScrollWidth=q;function $(Q){const Z=ue.getBorderTopWidth(Q)+ue.getBorderBottomWidth(Q),fe=ue.getPaddingTop(Q)+ue.getPaddingBottom(Q);return Q.offsetHeight-Z-fe}t.getContentHeight=$;function V(Q){const Z=ue.getMarginTop(Q)+ue.getMarginBottom(Q);return Q.offsetHeight+Z}t.getTotalHeight=V;function _(Q,Z){if(Q===null)return 0;const fe=le(Q),Ce=le(Z);return fe.left-Ce.left}function K(Q,Z){const fe=Z.map(Fe=>Math.max(q(Fe),ce(Fe))+_(Fe,Q)||0);return Math.max(...fe)}t.getLargestChildWidth=K;function z(Q,Z){for(;Q;){if(Q===Z)return!0;Q=Q.parentNode}return!1}t.isAncestor=z;const o="parentFlowToElementId";function F(Q,Z){Q.dataset[o]=Z.id}t.setParentFlowTo=F;function j(Q){const Z=Q.dataset[o];return typeof Z=="string"?document.getElementById(Z):null}function te(Q,Z){let fe=Q;for(;fe;){if(fe===Z)return!0;if(fe instanceof HTMLElement){const Ce=j(fe);if(Ce){fe=Ce;continue}}fe=fe.parentNode}return!1}t.isAncestorUsingFlowTo=te;function S(Q,Z,fe){for(;Q&&Q.nodeType===Q.ELEMENT_NODE;){if(Q.classList.contains(Z))return Q;if(fe){if(typeof fe=="string"){if(Q.classList.contains(fe))return null}else if(Q===fe)return null}Q=Q.parentNode}return null}t.findParentWithClass=S;function T(Q,Z,fe){return!!S(Q,Z,fe)}t.hasParentWithClass=T;function O(Q){return Q&&!!Q.host&&!!Q.mode}t.isShadowRoot=O;function b(Q){return!!x(Q)}t.isInShadowDOM=b;function x(Q){for(;Q.parentNode;){if(Q===document.body)return null;Q=Q.parentNode}return O(Q)?Q:null}t.getShadowRoot=x;function B(){let Q=document.activeElement;for(;Q?.shadowRoot;)Q=Q.shadowRoot.activeElement;return Q}t.getActiveElement=B;function N(Q=document.getElementsByTagName("head")[0],Z){const fe=document.createElement("style");return fe.type="text/css",fe.media="screen",Z?.(fe),Q.appendChild(fe),fe}t.createStyleSheet=N;function U(Q=document.getElementsByTagName("head")[0]){const Z=document.createElement("meta");return Q.appendChild(Z),Z}t.createMetaElement=U;let Y=null;function J(){return Y||(Y=N()),Y}function oe(Q){return Q?.sheet?.rules?Q.sheet.rules:Q?.sheet?.cssRules?Q.sheet.cssRules:[]}function be(Q,Z,fe=J()){!fe||!Z||fe.sheet.insertRule(Q+"{"+Z+"}",0)}t.createCSSRule=be;function De(Q,Z=J()){if(!Z)return;const fe=oe(Z),Ce=[];for(let Fe=0;Fe<fe.length;Fe++)fe[Fe].selectorText.indexOf(Q)!==-1&&Ce.push(Fe);for(let Fe=Ce.length-1;Fe>=0;Fe--)Z.sheet.deleteRule(Ce[Fe])}t.removeCSSRulesContainingSelector=De;function Le(Q){return typeof HTMLElement=="object"?Q instanceof HTMLElement:Q&&typeof Q=="object"&&Q.nodeType===1&&typeof Q.nodeName=="string"}t.isHTMLElement=Le,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:E.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:E.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:E.isWebKit?"webkitAnimationIteration":"animationiteration"};function Se(Q){const Z=Q;return!!(Z&&typeof Z.preventDefault=="function"&&typeof Z.stopPropagation=="function")}t.isEventLike=Se,t.EventHelper={stop:(Q,Z)=>(Q.preventDefault(),Z&&Q.stopPropagation(),Q)};function ve(Q){const Z=[];for(let fe=0;Q&&Q.nodeType===Q.ELEMENT_NODE;fe++)Z[fe]=Q.scrollTop,Q=Q.parentNode;return Z}t.saveParentsScrollTop=ve;function ke(Q,Z){for(let fe=0;Q&&Q.nodeType===Q.ELEMENT_NODE;fe++)Q.scrollTop!==Z[fe]&&(Q.scrollTop=Z[fe]),Q=Q.parentNode}t.restoreParentsScrollTop=ke;class Ie extends d.Disposable{static hasFocusWithin(Z){const fe=x(Z),Ce=fe?fe.activeElement:document.activeElement;return z(Ce,Z)}constructor(Z){super(),this._onDidFocus=this._register(new c.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new c.Emitter),this.onDidBlur=this._onDidBlur.event;let fe=Ie.hasFocusWithin(Z),Ce=!1;const Fe=()=>{Ce=!1,fe||(fe=!0,this._onDidFocus.fire())},$e=()=>{fe&&(Ce=!0,window.setTimeout(()=>{Ce&&(Ce=!1,fe=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{Ie.hasFocusWithin(Z)!==fe&&(fe?$e():Fe())},this._register(s(Z,t.EventType.FOCUS,Fe,!0)),this._register(s(Z,t.EventType.BLUR,$e,!0)),this._register(s(Z,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(s(Z,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler()))}refreshState(){this._refreshStateHandler()}}function Ke(Q){return new Ie(Q)}t.trackFocus=Ke;function xe(Q,Z){return Q.after(Z),Z}t.after=xe;function We(Q,...Z){if(Q.append(...Z),Z.length===1&&typeof Z[0]!="string")return Z[0]}t.append=We;function Je(Q,Z){return Q.insertBefore(Z,Q.firstChild),Z}t.prepend=Je;function it(Q,...Z){Q.innerText="",We(Q,...Z)}t.reset=it;const Re=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Ve;(function(Q){Q.HTML="http://www.w3.org/1999/xhtml",Q.SVG="http://www.w3.org/2000/svg"})(Ve||(t.Namespace=Ve={}));function X(Q,Z,fe,...Ce){const Fe=Re.exec(Z);if(!Fe)throw new Error("Bad use of emmet");const $e=Fe[1]||"div";let ze;return Q!==Ve.HTML?ze=document.createElementNS(Q,$e):ze=document.createElement($e),Fe[3]&&(ze.id=Fe[3]),Fe[4]&&(ze.className=Fe[4].replace(/\./g," ").trim()),fe&&Object.entries(fe).forEach(([Ye,nt])=>{typeof nt>"u"||(/^on\w+$/.test(Ye)?ze[Ye]=nt:Ye==="selected"?nt&&ze.setAttribute(Ye,"true"):ze.setAttribute(Ye,nt))}),ze.append(...Ce),ze}function ae(Q,Z,...fe){return X(Ve.HTML,Q,Z,...fe)}t.$=ae,ae.SVG=function(Q,Z,...fe){return X(Ve.SVG,Q,Z,...fe)};function pe(Q,Z){const fe=[];return Q.forEach((Ce,Fe)=>{Fe>0&&(Z instanceof Node?fe.push(Z.cloneNode()):fe.push(document.createTextNode(Z))),fe.push(Ce)}),fe}t.join=pe;function we(Q,...Z){Q?Ee(...Z):Pe(...Z)}t.setVisibility=we;function Ee(...Q){for(const Z of Q)Z.style.display="",Z.removeAttribute("aria-hidden")}t.show=Ee;function Pe(...Q){for(const Z of Q)Z.style.display="none",Z.setAttribute("aria-hidden","true")}t.hide=Pe;function Ue(Q,Z){for(;Q&&Q.nodeType===Q.ELEMENT_NODE;){if(Q instanceof HTMLElement&&Q.hasAttribute(Z))return Q;Q=Q.parentNode}return null}function Ge(Q){!Q||!Q.hasAttribute("tabIndex")||(document.activeElement===Q&&Ue(Q.parentElement,"tabIndex")?.focus(),Q.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=Ge;function et(Q){return Z=>{Z.preventDefault(),Z.stopPropagation(),Q(Z)}}t.finalHandler=et;function Ae(){return new Promise(Q=>{document.readyState==="complete"||document&&document.body!==null?Q(void 0):window.addEventListener("DOMContentLoaded",Q,!1)})}t.domContentLoaded=Ae;function he(Q){const Z=window.devicePixelRatio*Q;return Math.max(1,Math.floor(Z))/window.devicePixelRatio}t.computeScreenAwareSize=he;function _e(Q){window.open(Q,"_blank","noopener")}t.windowOpenNoOpener=_e;const Ne=780,He=640;function Xe(Q){const Z=Math.floor(window.screenLeft+window.innerWidth/2-Ne/2),fe=Math.floor(window.screenTop+window.innerHeight/2-He/2);window.open(Q,"_blank",`width=${Ne},height=${He},top=${fe},left=${Z}`)}t.windowOpenPopup=Xe;function Ze(Q,Z=!0){const fe=window.open();return fe?(Z&&(fe.opener=null),fe.location.href=Q,!0):!1}t.windowOpenWithSuccess=Ze;function Qe(Q){const Z=()=>{Q(),fe=(0,t.scheduleAtNextAnimationFrame)(Z)};let fe=(0,t.scheduleAtNextAnimationFrame)(Z);return(0,d.toDisposable)(()=>fe.dispose())}t.animate=Qe,P.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function rt(Q){return Q?`url('${P.FileAccess.uriToBrowserUri(Q).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=rt;function dt(Q){return`'${Q.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=dt;function pt(Q,Z){if(Q!==void 0){const fe=Q.match(/^\s*var\((.+)\)$/);if(fe){const Ce=fe[1].split(",",2);return Ce.length===2&&(Z=pt(Ce[1].trim(),Z)),`var(${Ce[0]}, ${Z})`}return Q}return Z}t.asCssValueWithDefault=pt;function Ft(Q,Z){let fe;if(e.URI.isUri(Q))fe=Q.toString(!0);else{const Fe=new Blob([Q]);fe=URL.createObjectURL(Fe),setTimeout(()=>URL.revokeObjectURL(fe))}const Ce=document.createElement("a");document.body.appendChild(Ce),Ce.download=Z,Ce.href=fe,Ce.click(),setTimeout(()=>document.body.removeChild(Ce))}t.triggerDownload=Ft;function Wt(){return new Promise(Q=>{const Z=document.createElement("input");document.body.appendChild(Z),Z.type="file",Z.multiple=!0,c.Event.once(c.Event.fromDOMEventEmitter(Z,"input"))(()=>{Q((0,l.withNullAsUndefined)(Z.files))}),Z.click(),setTimeout(()=>document.body.removeChild(Z))})}t.triggerUpload=Wt;var bt;(function(Q){Q[Q.DOCUMENT=1]="DOCUMENT",Q[Q.BROWSER=2]="BROWSER"})(bt||(t.DetectedFullscreenMode=bt={}));function di(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:bt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:bt.BROWSER,guess:!1}:(r.isMacintosh||r.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:bt.BROWSER,guess:!0}:null}t.detectFullscreen=di;function zt(Q,Z=!1){const fe=document.createElement("a");return u.addHook("afterSanitizeAttributes",Ce=>{for(const Fe of["href","src"])if(Ce.hasAttribute(Fe)){const $e=Ce.getAttribute(Fe);if(Fe==="href"&&$e.startsWith("#"))continue;if(fe.href=$e,!Q.includes(fe.protocol.replace(/:$/,""))){if(Z&&Fe==="src"&&fe.href.startsWith("data:"))continue;Ce.removeAttribute(Fe)}}}),(0,d.toDisposable)(()=>{u.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=zt;const fi=[P.Schemas.http,P.Schemas.https,P.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const gi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function mi(Q,Z){const fe=zt(fi);try{const Ce=u.sanitize(Z,gi);Q.innerHTML=Ce}finally{fe.dispose()}}t.safeInnerHtml=mi;function pi(Q){const Z=new Uint16Array(Q.length);for(let Fe=0;Fe<Z.length;Fe++)Z[Fe]=Q.charCodeAt(Fe);let fe="";const Ce=new Uint8Array(Z.buffer);for(let Fe=0;Fe<Ce.length;Fe++)fe+=String.fromCharCode(Ce[Fe]);return fe}function bi(Q){return btoa(pi(Q))}t.multibyteAwareBtoa=bi;class ft extends c.Emitter{constructor(){super(),this._subscriptions=new d.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(s(window,"keydown",Z=>{if(Z.defaultPrevented)return;const fe=new i.StandardKeyboardEvent(Z);if(!(fe.keyCode===6&&Z.repeat)){if(Z.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(Z.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(Z.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(Z.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(fe.keyCode!==6)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=Z.altKey,this._keyStatus.ctrlKey=Z.ctrlKey,this._keyStatus.metaKey=Z.metaKey,this._keyStatus.shiftKey=Z.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=Z,this.fire(this._keyStatus))}},!0)),this._subscriptions.add(s(window,"keyup",Z=>{Z.defaultPrevented||(!Z.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!Z.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!Z.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!Z.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=Z.altKey,this._keyStatus.ctrlKey=Z.ctrlKey,this._keyStatus.metaKey=Z.metaKey,this._keyStatus.shiftKey=Z.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=Z,this.fire(this._keyStatus)))},!0)),this._subscriptions.add(s(document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(s(document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(s(document.body,"mousemove",Z=>{Z.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),this._subscriptions.add(s(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return ft.instance||(ft.instance=new ft),ft.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=ft;function vi(Q){const Z=document.cookie.match("(^|[^;]+)\\s*"+Q+"\\s*=\\s*([^;]+)");return Z?Z.pop():void 0}t.getCookieValue=vi;class Di extends d.Disposable{constructor(Z,fe){super(),this.element=Z,this.callbacks=fe,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this._register(s(this.element,t.EventType.DRAG_ENTER,Z=>{this.counter++,this.dragStartTime=Z.timeStamp,this.callbacks.onDragEnter(Z)})),this._register(s(this.element,t.EventType.DRAG_OVER,Z=>{Z.preventDefault(),this.callbacks.onDragOver?.(Z,Z.timeStamp-this.dragStartTime)})),this._register(s(this.element,t.EventType.DRAG_LEAVE,Z=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave(Z))})),this._register(s(this.element,t.EventType.DRAG_END,Z=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd(Z)})),this._register(s(this.element,t.EventType.DROP,Z=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop(Z)}))}}t.DragAndDropObserver=Di;const wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function yi(Q,...Z){let fe,Ce;Array.isArray(Z[0])?(fe={},Ce=Z[0]):(fe=Z[0]||{},Ce=Z[1]);const Fe=wi.exec(Q);if(!Fe||!Fe.groups)throw new Error("Bad use of h");const $e=Fe.groups.tag||"div",ze=document.createElement($e);Fe.groups.id&&(ze.id=Fe.groups.id);const Ye=[];if(Fe.groups.class)for(const je of Fe.groups.class.split("."))je!==""&&Ye.push(je);if(fe.className!==void 0)for(const je of fe.className.split("."))je!==""&&Ye.push(je);Ye.length>0&&(ze.className=Ye.join(" "));const nt={};if(Fe.groups.name&&(nt[Fe.groups.name]=ze),Ce)for(const je of Ce)je instanceof HTMLElement?ze.appendChild(je):typeof je=="string"?ze.append(je):"root"in je&&(Object.assign(nt,je),ze.appendChild(je.root));for(const[je,vt]of Object.entries(fe))if(je!=="className")if(je==="style")for(const[_t,Lt]of Object.entries(vt))ze.style.setProperty(Ut(_t),typeof Lt=="number"?Lt+"px":""+Lt);else je==="tabIndex"?ze.tabIndex=vt:ze.setAttribute(Ut(je),vt.toString());return nt.root=ze,nt}t.h=yi;function Ut(Q){return Q.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(ge[51],me([1,0,4,2,113]),function(ee,t,E,I,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class W extends I.Disposable{constructor(c,u){super(),this._register((0,E.addDisposableListener)(c,"dragover",d=>{d.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{u(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(d=>{this._register((0,E.addDisposableListener)(c,d,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=W,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.Mimes.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function w(y,c,u,d,P){const r=document.createElement("div");r.className=u,r.textContent=c,P&&(r.style.color=P),d&&(r.style.background=d),y.dataTransfer&&(document.body.appendChild(r),y.dataTransfer.setDragImage(r,-10,-10),setTimeout(()=>document.body.removeChild(r),0))}t.applyDragImage=w}),define(ge[52],me([1,0,4]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function I(r,l={}){const e=W(l);return e.textContent=r,e}t.renderText=I;function i(r,l={}){const e=W(l);return c(e,u(r,!!l.renderCodeSegments),l.actionHandler,l.renderCodeSegments),e}t.renderFormattedText=i;function W(r){const l=r.inline?"span":"div",e=document.createElement(l);return r.className&&(e.className=r.className),e}t.createElement=W;class w{constructor(l){this.source=l,this.index=0}eos(){return this.index>=this.source.length}next(){const l=this.peek();return this.advance(),l}peek(){return this.source[this.index]}advance(){this.index++}}var y;(function(r){r[r.Invalid=0]="Invalid",r[r.Root=1]="Root",r[r.Text=2]="Text",r[r.Bold=3]="Bold",r[r.Italics=4]="Italics",r[r.Action=5]="Action",r[r.ActionClose=6]="ActionClose",r[r.Code=7]="Code",r[r.NewLine=8]="NewLine"})(y||(y={}));function c(r,l,e,a){let n;if(l.type===2)n=document.createTextNode(l.content||"");else if(l.type===3)n=document.createElement("b");else if(l.type===4)n=document.createElement("i");else if(l.type===7&&a)n=document.createElement("code");else if(l.type===5&&e){const h=document.createElement("a");e.disposables.add(E.addStandardDisposableListener(h,"click",s=>{e.callback(String(l.index),s)})),n=h}else l.type===8?n=document.createElement("br"):l.type===1&&(n=r);n&&r!==n&&r.appendChild(n),n&&Array.isArray(l.children)&&l.children.forEach(h=>{c(n,h,e,a)})}function u(r,l){const e={type:1,children:[]};let a=0,n=e;const h=[],s=new w(r);for(;!s.eos();){let p=s.next();const v=p==="\\"&&P(s.peek(),l)!==0;if(v&&(p=s.next()),!v&&d(p,l)&&p===s.peek()){s.advance(),n.type===2&&(n=h.pop());const C=P(p,l);if(n.type===C||n.type===5&&C===6)n=h.pop();else{const f={type:C,children:[]};C===5&&(f.index=a,a++),n.children.push(f),h.push(n),n=f}}else if(p===`
`)n.type===2&&(n=h.pop()),n.children.push({type:8});else if(n.type!==2){const C={type:2,content:p};n.children.push(C),h.push(n),n=C}else n.content+=p}return n.type===2&&(n=h.pop()),h.length,e}function d(r,l){return P(r,l)!==0}function P(r,l){switch(r){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return l?7:0;default:return 0}}}),define(ge[53],me([1,0,4,2]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class i{constructor(){this._hooks=new I.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(w,y){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const c=this._onStopCallback;this._onStopCallback=null,w&&c&&c(y)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(w,y,c,u,d){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=u,this._onStopCallback=d;let P=w;try{w.setPointerCapture(y),this._hooks.add((0,I.toDisposable)(()=>{try{w.releasePointerCapture(y)}catch{}}))}catch{P=window}this._hooks.add(E.addDisposableListener(P,E.EventType.POINTER_MOVE,r=>{if(r.buttons!==c){this.stopMonitoring(!0);return}r.preventDefault(),this._pointerMoveCallback(r)})),this._hooks.add(E.addDisposableListener(P,E.EventType.POINTER_UP,r=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=i});var qe=this&&this.__decorate||function(ee,t,E,I){var i=arguments.length,W=i<3?t:I===null?I=Object.getOwnPropertyDescriptor(t,E):I,w;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")W=Reflect.decorate(ee,t,E,I);else for(var y=ee.length-1;y>=0;y--)(w=ee[y])&&(W=(i<3?w(W):i>3?w(t,E,W):w(t,E))||W);return i>3&&W&&Object.defineProperty(t,E,W),W};define(ge[23],me([1,0,4,13,25,2,43]),function(ee,t,E,I,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var y;(function(u){u.Tap="-monaco-gesturetap",u.Change="-monaco-gesturechange",u.Start="-monaco-gesturestart",u.End="-monaco-gesturesend",u.Contextmenu="-monaco-gesturecontextmenu"})(y||(t.EventType=y={}));class c extends W.Disposable{constructor(){super(),this.dispatched=!1,this.targets=new w.LinkedList,this.ignoreTargets=new w.LinkedList,this.activeTouches={},this.handle=null,this._lastSetTapCountTime=0,this._register(E.addDisposableListener(document,"touchstart",d=>this.onTouchStart(d),{passive:!1})),this._register(E.addDisposableListener(document,"touchend",d=>this.onTouchEnd(d))),this._register(E.addDisposableListener(document,"touchmove",d=>this.onTouchMove(d),{passive:!1}))}static addTarget(d){if(!c.isTouchDevice())return W.Disposable.None;c.INSTANCE||(c.INSTANCE=new c);const P=c.INSTANCE.targets.push(d);return(0,W.toDisposable)(P)}static ignoreTarget(d){if(!c.isTouchDevice())return W.Disposable.None;c.INSTANCE||(c.INSTANCE=new c);const P=c.INSTANCE.ignoreTargets.push(d);return(0,W.toDisposable)(P)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(d){const P=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let r=0,l=d.targetTouches.length;r<l;r++){const e=d.targetTouches.item(r);this.activeTouches[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:P,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[P],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const a=this.newGestureEvent(y.Start,e.target);a.pageX=e.pageX,a.pageY=e.pageY,this.dispatchEvent(a)}this.dispatched&&(d.preventDefault(),d.stopPropagation(),this.dispatched=!1)}onTouchEnd(d){const P=Date.now(),r=Object.keys(this.activeTouches).length;for(let l=0,e=d.changedTouches.length;l<e;l++){const a=d.changedTouches.item(l);if(!this.activeTouches.hasOwnProperty(String(a.identifier))){console.warn("move of an UNKNOWN touch",a);continue}const n=this.activeTouches[a.identifier],h=Date.now()-n.initialTimeStamp;if(h<c.HOLD_DELAY&&Math.abs(n.initialPageX-I.tail(n.rollingPageX))<30&&Math.abs(n.initialPageY-I.tail(n.rollingPageY))<30){const s=this.newGestureEvent(y.Tap,n.initialTarget);s.pageX=I.tail(n.rollingPageX),s.pageY=I.tail(n.rollingPageY),this.dispatchEvent(s)}else if(h>=c.HOLD_DELAY&&Math.abs(n.initialPageX-I.tail(n.rollingPageX))<30&&Math.abs(n.initialPageY-I.tail(n.rollingPageY))<30){const s=this.newGestureEvent(y.Contextmenu,n.initialTarget);s.pageX=I.tail(n.rollingPageX),s.pageY=I.tail(n.rollingPageY),this.dispatchEvent(s)}else if(r===1){const s=I.tail(n.rollingPageX),p=I.tail(n.rollingPageY),v=I.tail(n.rollingTimestamps)-n.rollingTimestamps[0],C=s-n.rollingPageX[0],f=p-n.rollingPageY[0],D=[...this.targets].filter(M=>n.initialTarget instanceof Node&&M.contains(n.initialTarget));this.inertia(D,P,Math.abs(C)/v,C>0?1:-1,s,Math.abs(f)/v,f>0?1:-1,p)}this.dispatchEvent(this.newGestureEvent(y.End,n.initialTarget)),delete this.activeTouches[a.identifier]}this.dispatched&&(d.preventDefault(),d.stopPropagation(),this.dispatched=!1)}newGestureEvent(d,P){const r=document.createEvent("CustomEvent");return r.initEvent(d,!1,!0),r.initialTarget=P,r.tapCount=0,r}dispatchEvent(d){if(d.type===y.Tap){const P=new Date().getTime();let r=0;P-this._lastSetTapCountTime>c.CLEAR_TAP_COUNT_TIME?r=1:r=2,this._lastSetTapCountTime=P,d.tapCount=r}else(d.type===y.Change||d.type===y.Contextmenu)&&(this._lastSetTapCountTime=0);if(d.initialTarget instanceof Node){for(const P of this.ignoreTargets)if(P.contains(d.initialTarget))return;for(const P of this.targets)P.contains(d.initialTarget)&&(P.dispatchEvent(d),this.dispatched=!0)}}inertia(d,P,r,l,e,a,n,h){this.handle=E.scheduleAtNextAnimationFrame(()=>{const s=Date.now(),p=s-P;let v=0,C=0,f=!0;r+=c.SCROLL_FRICTION*p,a+=c.SCROLL_FRICTION*p,r>0&&(f=!1,v=l*r*p),a>0&&(f=!1,C=n*a*p);const D=this.newGestureEvent(y.Change);D.translationX=v,D.translationY=C,d.forEach(M=>M.dispatchEvent(D)),f||this.inertia(d,s,r,l,e+v,a,n,h+C)})}onTouchMove(d){const P=Date.now();for(let r=0,l=d.changedTouches.length;r<l;r++){const e=d.changedTouches.item(r);if(!this.activeTouches.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const a=this.activeTouches[e.identifier],n=this.newGestureEvent(y.Change,a.initialTarget);n.translationX=e.pageX-I.tail(a.rollingPageX),n.translationY=e.pageY-I.tail(a.rollingPageY),n.pageX=e.pageX,n.pageY=e.pageY,this.dispatchEvent(n),a.rollingPageX.length>3&&(a.rollingPageX.shift(),a.rollingPageY.shift(),a.rollingTimestamps.shift()),a.rollingPageX.push(e.pageX),a.rollingPageY.push(e.pageY),a.rollingTimestamps.push(P)}this.dispatched&&(d.preventDefault(),d.stopPropagation(),this.dispatched=!1)}}t.Gesture=c,c.SCROLL_FRICTION=-.005,c.HOLD_DELAY=700,c.CLEAR_TAP_COUNT_TIME=400,qe([i.memoize],c,"isTouchDevice",null)}),define(ge[54],me([1,0,4,88]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const I=2e4;let i,W,w,y,c;function u(l){i=document.createElement("div"),i.className="monaco-aria-container";const e=()=>{const n=document.createElement("div");return n.className="monaco-alert",n.setAttribute("role","alert"),n.setAttribute("aria-atomic","true"),i.appendChild(n),n};W=e(),w=e();const a=()=>{const n=document.createElement("div");return n.className="monaco-status",n.setAttribute("role","complementary"),n.setAttribute("aria-live","polite"),n.setAttribute("aria-atomic","true"),i.appendChild(n),n};y=a(),c=a(),l.appendChild(i)}t.setARIAContainer=u;function d(l){i&&(W.textContent!==l?(E.clearNode(w),r(W,l)):(E.clearNode(W),r(w,l)))}t.alert=d;function P(l){i&&(y.textContent!==l?(E.clearNode(c),r(y,l)):(E.clearNode(y),r(c,l)))}t.status=P;function r(l,e){E.clearNode(l),e.length>I&&(e=e.substr(0,I)),l.textContent=e,l.style.visibility="hidden",l.style.visibility="visible"}}),define(ge[115],me([1,0,4,18]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const i=new RegExp(`(\\\\)?\\$\\((${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?)\\)`,"g");function W(y){const c=new Array;let u,d=0,P=0;for(;(u=i.exec(y))!==null;){P=u.index||0,d<P&&c.push(y.substring(d,P)),d=(u.index||0)+u[0].length;const[,r,l]=u;c.push(r?`$(${l})`:w({id:l}))}return d<y.length&&c.push(y.substring(d)),c}t.renderLabelWithIcons=W;function w(y){const c=E.$("span");return c.classList.add(...I.ThemeIcon.asClassNameArray(y)),c}t.renderIcon=w}),define(ge[116],me([1,0,4]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function I(W){try{W.parentElement?.removeChild(W)}catch{}}class i{constructor(w){this.renderers=w,this.cache=new Map,this.transactionNodesPendingRemoval=new Set,this.inTransaction=!1}alloc(w){let y=this.getTemplateCache(w).pop(),c=!1;if(y)c=this.transactionNodesPendingRemoval.has(y.domNode),c&&this.transactionNodesPendingRemoval.delete(y.domNode);else{const u=(0,E.$)(".monaco-list-row"),P=this.getRenderer(w).renderTemplate(u);y={domNode:u,templateId:w,templateData:P}}return{row:y,isReusingConnectedDomNode:c}}release(w){w&&this.releaseRow(w)}transact(w){if(this.inTransaction)throw new Error("Already in transaction");this.inTransaction=!0;try{w()}finally{for(const y of this.transactionNodesPendingRemoval)this.doRemoveNode(y);this.transactionNodesPendingRemoval.clear(),this.inTransaction=!1}}releaseRow(w){const{domNode:y,templateId:c}=w;y&&(this.inTransaction?this.transactionNodesPendingRemoval.add(y):this.doRemoveNode(y)),this.getTemplateCache(c).push(w)}doRemoveNode(w){w.classList.remove("scrolling"),I(w)}getTemplateCache(w){let y=this.cache.get(w);return y||(y=[],this.cache.set(w,y)),y}dispose(){this.cache.forEach((w,y)=>{for(const c of w)this.getRenderer(y).disposeTemplate(c.templateData),c.templateData=null}),this.cache.clear(),this.transactionNodesPendingRemoval.clear()}getRenderer(w){const y=this.renderers.get(w);if(!y)throw new Error(`No renderer found for ${w}`);return y}}t.RowCache=i}),define(ge[117],me([1,0,9,2]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class i extends I.Disposable{constructor(w,y,c){super(),this._visibility=w,this._visibleClassName=y,this._invisibleClassName=c,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new E.TimeoutTimer)}setVisibility(w){this._visibility!==w&&(this._visibility=w,this._updateShouldBeVisible())}setShouldBeVisible(w){this._rawShouldBeVisible=w,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===2?!1:this._visibility===3?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const w=this._applyVisibilitySetting();this._shouldBeVisible!==w&&(this._shouldBeVisible=w,this.ensureVisibility())}setIsNeeded(w){this._isNeeded!==w&&(this._isNeeded=w,this.ensureVisibility())}setDomNode(w){this._domNode=w,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(w){this._revealTimer.cancel(),this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(w?" fade":"")))}}t.ScrollbarVisibilityController=i}),define(ge[118],me([1,0,4,23,13,3,2,5]),function(ee,t,E,I,i,W,w,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class c extends w.Disposable{constructor(d,P,r,l){super(),this.selected=0,this.selectBoxOptions=l||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new W.Emitter),this.styles=r,this.registerListeners(),this.setOptions(d,P)}registerListeners(){this._register(I.Gesture.addTarget(this.selectElement)),[I.EventType.Tap].forEach(d=>{this._register(E.addDisposableListener(this.selectElement,d,P=>{this.selectElement.focus()}))}),this._register(E.addStandardDisposableListener(this.selectElement,"click",d=>{E.EventHelper.stop(d,!0)})),this._register(E.addStandardDisposableListener(this.selectElement,"change",d=>{this.selectElement.title=d.target.value,this._onDidSelect.fire({index:d.target.selectedIndex,selected:d.target.value})})),this._register(E.addStandardDisposableListener(this.selectElement,"keydown",d=>{let P=!1;y.isMacintosh?(d.keyCode===18||d.keyCode===16||d.keyCode===10)&&(P=!0):(d.keyCode===18&&d.altKey||d.keyCode===10||d.keyCode===3)&&(P=!0),P&&d.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(d,P){(!this.options||!i.equals(this.options,d))&&(this.options=d,this.selectElement.options.length=0,this.options.forEach((r,l)=>{this.selectElement.add(this.createOption(r.text,l,r.isDisabled))})),P!==void 0&&this.select(P)}select(d){this.options.length===0?this.selected=0:d>=0&&d<this.options.length?this.selected=d:d>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(d){this.selectBoxOptions.ariaLabel=d,this.selectElement.setAttribute("aria-label",d)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(d){this.selectElement.tabIndex=d?0:-1}render(d){d.classList.add("select-container"),d.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(d){this.styles=d,this.applyStyles()}applyStyles(){this.selectElement&&(this.selectElement.style.backgroundColor=this.styles.selectBackground??"",this.selectElement.style.color=this.styles.selectForeground??"",this.selectElement.style.borderColor=this.styles.selectBorder??"")}createOption(d,P,r){const l=document.createElement("option");return l.value=d,l.text=d,l.disabled=!!r,l}}t.SelectBoxNative=c}),define(ge[55],me([1,0,24,13,9,47,84,3,26]),function(ee,t,E,I,i,W,w,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function u(l){return typeof l=="object"&&"visibility"in l&&"data"in l}t.isFilterResult=u;function d(l){switch(l){case!0:return 1;case!1:return 0;default:return l}}t.getVisibleState=d;function P(l){return typeof l.collapsible=="boolean"}class r{constructor(e,a,n,h={}){this.user=e,this.list=a,this.rootRef=[],this.eventBufferer=new y.EventBufferer,this._onDidChangeCollapseState=new y.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new y.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new y.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new i.Delayer(W.MicrotaskDelay),this.collapseByDefault=typeof h.collapseByDefault>"u"?!1:h.collapseByDefault,this.filter=h.filter,this.autoExpandSingleChildren=typeof h.autoExpandSingleChildren>"u"?!1:h.autoExpandSingleChildren,this.root={parent:void 0,element:n,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,a,n=c.Iterable.empty(),h={}){if(e.length===0)throw new E.TreeError(this.user,"Invalid tree location");h.diffIdentityProvider?this.spliceSmart(h.diffIdentityProvider,e,a,n,h):this.spliceSimple(e,a,n,h)}spliceSmart(e,a,n,h=c.Iterable.empty(),s,p=s.diffDepth??0){const{parentNode:v}=this.getParentNodeWithListIndex(a);if(!v.lastDiffIds)return this.spliceSimple(a,n,h,s);const C=[...h],f=a[a.length-1],D=new w.LcsDiff({getElements:()=>v.lastDiffIds},{getElements:()=>[...v.children.slice(0,f),...C,...v.children.slice(f+n)].map(L=>e.getId(L.element).toString())}).ComputeDiff(!1);if(D.quitEarly)return v.lastDiffIds=void 0,this.spliceSimple(a,n,C,s);const M=a.slice(0,-1),R=(L,k,A)=>{if(p>0)for(let H=0;H<A;H++)L--,k--,this.spliceSmart(e,[...M,L,0],Number.MAX_SAFE_INTEGER,C[k].children,s,p-1)};let g=Math.min(v.children.length,f+n),m=C.length;for(const L of D.changes.sort((k,A)=>A.originalStart-k.originalStart))R(g,m,g-(L.originalStart+L.originalLength)),g=L.originalStart,m=L.modifiedStart-f,this.spliceSimple([...M,g],L.originalLength,c.Iterable.slice(C,m,m+L.modifiedLength),s);R(g,m,g)}spliceSimple(e,a,n=c.Iterable.empty(),{onDidCreateNode:h,onDidDeleteNode:s,diffIdentityProvider:p}){const{parentNode:v,listIndex:C,revealed:f,visible:D}=this.getParentNodeWithListIndex(e),M=[],R=c.Iterable.map(n,ue=>this.createTreeNode(ue,v,v.visible?1:0,f,M,h)),g=e[e.length-1],m=v.children.length>0;let L=0;for(let ue=g;ue>=0&&ue<v.children.length;ue--){const re=v.children[ue];if(re.visible){L=re.visibleChildIndex;break}}const k=[];let A=0,H=0;for(const ue of R)k.push(ue),H+=ue.renderNodeCount,ue.visible&&(ue.visibleChildIndex=L+A++);const G=(0,I.splice)(v.children,g,a,k);p?v.lastDiffIds?(0,I.splice)(v.lastDiffIds,g,a,k.map(ue=>p.getId(ue.element).toString())):v.lastDiffIds=v.children.map(ue=>p.getId(ue.element).toString()):v.lastDiffIds=void 0;let ne=0;for(const ue of G)ue.visible&&ne++;if(ne!==0)for(let ue=g+k.length;ue<v.children.length;ue++){const re=v.children[ue];re.visible&&(re.visibleChildIndex-=ne)}if(v.visibleChildrenCount+=A-ne,f&&D){const ue=G.reduce((re,le)=>re+(le.visible?le.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(v,H-ue),this.list.splice(C,ue,M)}if(G.length>0&&s){const ue=re=>{s(re),re.children.forEach(ue)};G.forEach(ue)}this._onDidSplice.fire({insertedNodes:k,deletedNodes:G});const se=v.children.length>0;m!==se&&this.setCollapsible(e.slice(0,-1),se);let de=v;for(;de;){if(de.visibility===2){this.refilterDelayer.trigger(()=>this.refilter());break}de=de.parent}}rerender(e){if(e.length===0)throw new E.TreeError(this.user,"Invalid tree location");const{node:a,listIndex:n,revealed:h}=this.getTreeNodeWithListIndex(e);a.visible&&h&&this.list.splice(n,1,[a])}updateElementHeight(e,a){if(e.length===0)throw new E.TreeError(this.user,"Invalid tree location");const{listIndex:n}=this.getTreeNodeWithListIndex(e);this.list.updateElementHeight(n,a)}has(e){return this.hasTreeNode(e)}getListIndex(e){const{listIndex:a,visible:n,revealed:h}=this.getTreeNodeWithListIndex(e);return n&&h?a:-1}getListRenderCount(e){return this.getTreeNode(e).renderNodeCount}isCollapsible(e){return this.getTreeNode(e).collapsible}setCollapsible(e,a){const n=this.getTreeNode(e);typeof a>"u"&&(a=!n.collapsible);const h={collapsible:a};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,h))}isCollapsed(e){return this.getTreeNode(e).collapsed}setCollapsed(e,a,n){const h=this.getTreeNode(e);typeof a>"u"&&(a=!h.collapsed);const s={collapsed:a,recursive:n||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,s))}_setCollapseState(e,a){const{node:n,listIndex:h,revealed:s}=this.getTreeNodeWithListIndex(e),p=this._setListNodeCollapseState(n,h,s,a);if(n!==this.root&&this.autoExpandSingleChildren&&p&&!P(a)&&n.collapsible&&!n.collapsed&&!a.recursive){let v=-1;for(let C=0;C<n.children.length;C++)if(n.children[C].visible)if(v>-1){v=-1;break}else v=C;v>-1&&this._setCollapseState([...e,v],a)}return p}_setListNodeCollapseState(e,a,n,h){const s=this._setNodeCollapseState(e,h,!1);if(!n||!e.visible||!s)return s;const p=e.renderNodeCount,v=this.updateNodeAfterCollapseChange(e),C=p-(a===-1?0:1);return this.list.splice(a+1,C,v.slice(1)),s}_setNodeCollapseState(e,a,n){let h;if(e===this.root?h=!1:(P(a)?(h=e.collapsible!==a.collapsible,e.collapsible=a.collapsible):e.collapsible?(h=e.collapsed!==a.collapsed,e.collapsed=a.collapsed):h=!1,h&&this._onDidChangeCollapseState.fire({node:e,deep:n})),!P(a)&&a.recursive)for(const s of e.children)h=this._setNodeCollapseState(s,a,!0)||h;return h}expandTo(e){this.eventBufferer.bufferEvents(()=>{let a=this.getTreeNode(e);for(;a.parent;)a=a.parent,e=e.slice(0,e.length-1),a.collapsed&&this._setCollapseState(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.root.renderNodeCount,a=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,e,a),this.refilterDelayer.cancel()}createTreeNode(e,a,n,h,s,p){const v={parent:a,element:e.element,children:[],depth:a.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.collapseByDefault:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},C=this._filterNode(v,n);v.visibility=C,h&&s.push(v);const f=e.children||c.Iterable.empty(),D=h&&C!==0&&!v.collapsed;let M=0,R=1;for(const g of f){const m=this.createTreeNode(g,v,C,D,s,p);v.children.push(m),R+=m.renderNodeCount,m.visible&&(m.visibleChildIndex=M++)}return v.collapsible=v.collapsible||v.children.length>0,v.visibleChildrenCount=M,v.visible=C===2?M>0:C===1,v.visible?v.collapsed||(v.renderNodeCount=R):(v.renderNodeCount=0,h&&s.pop()),p?.(v),v}updateNodeAfterCollapseChange(e){const a=e.renderNodeCount,n=[];return this._updateNodeAfterCollapseChange(e,n),this._updateAncestorsRenderNodeCount(e.parent,n.length-a),n}_updateNodeAfterCollapseChange(e,a){if(e.visible===!1)return 0;if(a.push(e),e.renderNodeCount=1,!e.collapsed)for(const n of e.children)e.renderNodeCount+=this._updateNodeAfterCollapseChange(n,a);return this._onDidChangeRenderNodeCount.fire(e),e.renderNodeCount}updateNodeAfterFilterChange(e){const a=e.renderNodeCount,n=[];return this._updateNodeAfterFilterChange(e,e.visible?1:0,n),this._updateAncestorsRenderNodeCount(e.parent,n.length-a),n}_updateNodeAfterFilterChange(e,a,n,h=!0){let s;if(e!==this.root){if(s=this._filterNode(e,a),s===0)return e.visible=!1,e.renderNodeCount=0,!1;h&&n.push(e)}const p=n.length;e.renderNodeCount=e===this.root?0:1;let v=!1;if(!e.collapsed||s!==0){let C=0;for(const f of e.children)v=this._updateNodeAfterFilterChange(f,s,n,h&&!e.collapsed)||v,f.visible&&(f.visibleChildIndex=C++);e.visibleChildrenCount=C}else e.visibleChildrenCount=0;return e!==this.root&&(e.visible=s===2?v:s===1,e.visibility=s),e.visible?e.collapsed||(e.renderNodeCount+=n.length-p):(e.renderNodeCount=0,h&&n.pop()),this._onDidChangeRenderNodeCount.fire(e),e.visible}_updateAncestorsRenderNodeCount(e,a){if(a!==0)for(;e;)e.renderNodeCount+=a,this._onDidChangeRenderNodeCount.fire(e),e=e.parent}_filterNode(e,a){const n=this.filter?this.filter.filter(e.element,a):1;return typeof n=="boolean"?(e.filterData=void 0,n?1:0):u(n)?(e.filterData=n.data,d(n.visibility)):(e.filterData=void 0,d(n))}hasTreeNode(e,a=this.root){if(!e||e.length===0)return!0;const[n,...h]=e;return n<0||n>a.children.length?!1:this.hasTreeNode(h,a.children[n])}getTreeNode(e,a=this.root){if(!e||e.length===0)return a;const[n,...h]=e;if(n<0||n>a.children.length)throw new E.TreeError(this.user,"Invalid tree location");return this.getTreeNode(h,a.children[n])}getTreeNodeWithListIndex(e){if(e.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:a,listIndex:n,revealed:h,visible:s}=this.getParentNodeWithListIndex(e),p=e[e.length-1];if(p<0||p>a.children.length)throw new E.TreeError(this.user,"Invalid tree location");const v=a.children[p];return{node:v,listIndex:n,revealed:h,visible:s&&v.visible}}getParentNodeWithListIndex(e,a=this.root,n=0,h=!0,s=!0){const[p,...v]=e;if(p<0||p>a.children.length)throw new E.TreeError(this.user,"Invalid tree location");for(let C=0;C<p;C++)n+=a.children[C].renderNodeCount;return h=h&&!a.collapsed,s=s&&a.visible,v.length===0?{parentNode:a,listIndex:n,revealed:h,visible:s}:this.getParentNodeWithListIndex(v,a.children[p],n+1,h,s)}getNode(e=[]){return this.getTreeNode(e)}getNodeLocation(e){const a=[];let n=e;for(;n.parent;)a.push(n.parent.children.indexOf(n)),n=n.parent;return a.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,I.tail2)(e)[0]}getFirstElementChild(e){const a=this.getTreeNode(e);if(a.children.length!==0)return a.children[0].element}getLastElementAncestor(e=[]){const a=this.getTreeNode(e);if(a.children.length!==0)return this._getLastElementAncestor(a)}_getLastElementAncestor(e){return e.children.length===0?e.element:this._getLastElementAncestor(e.children[e.children.length-1])}}t.IndexTreeModel=r}),define(ge[119],me([1,0,55,24,26]),function(ee,t,E,I,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class W{get size(){return this.nodes.size}constructor(y,c,u={}){this.user=y,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new E.IndexTreeModel(y,c,null,u),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,u.sorter&&(this.sorter={compare(d,P){return u.sorter.compare(d.element,P.element)}}),this.identityProvider=u.identityProvider}setChildren(y,c=i.Iterable.empty(),u={}){const d=this.getElementLocation(y);this._setChildren(d,this.preserveCollapseState(c),u)}_setChildren(y,c=i.Iterable.empty(),u){const d=new Set,P=new Set,r=e=>{if(e.element===null)return;const a=e;if(d.add(a.element),this.nodes.set(a.element,a),this.identityProvider){const n=this.identityProvider.getId(a.element).toString();P.add(n),this.nodesByIdentity.set(n,a)}u.onDidCreateNode?.(a)},l=e=>{if(e.element===null)return;const a=e;if(d.has(a.element)||this.nodes.delete(a.element),this.identityProvider){const n=this.identityProvider.getId(a.element).toString();P.has(n)||this.nodesByIdentity.delete(n)}u.onDidDeleteNode?.(a)};this.model.splice([...y,0],Number.MAX_VALUE,c,{...u,onDidCreateNode:r,onDidDeleteNode:l})}preserveCollapseState(y=i.Iterable.empty()){return this.sorter&&(y=[...y].sort(this.sorter.compare.bind(this.sorter))),i.Iterable.map(y,c=>{let u=this.nodes.get(c.element);if(!u&&this.identityProvider){const r=this.identityProvider.getId(c.element).toString();u=this.nodesByIdentity.get(r)}if(!u){let r;return typeof c.collapsed>"u"?r=void 0:c.collapsed===I.ObjectTreeElementCollapseState.Collapsed||c.collapsed===I.ObjectTreeElementCollapseState.PreserveOrCollapsed?r=!0:c.collapsed===I.ObjectTreeElementCollapseState.Expanded||c.collapsed===I.ObjectTreeElementCollapseState.PreserveOrExpanded?r=!1:r=!!c.collapsed,{...c,children:this.preserveCollapseState(c.children),collapsed:r}}const d=typeof c.collapsible=="boolean"?c.collapsible:u.collapsible;let P;return typeof c.collapsed>"u"||c.collapsed===I.ObjectTreeElementCollapseState.PreserveOrCollapsed||c.collapsed===I.ObjectTreeElementCollapseState.PreserveOrExpanded?P=u.collapsed:c.collapsed===I.ObjectTreeElementCollapseState.Collapsed?P=!0:c.collapsed===I.ObjectTreeElementCollapseState.Expanded?P=!1:P=!!c.collapsed,{...c,collapsible:d,collapsed:P,children:this.preserveCollapseState(c.children)}})}rerender(y){const c=this.getElementLocation(y);this.model.rerender(c)}updateElementHeight(y,c){const u=this.getElementLocation(y);this.model.updateElementHeight(u,c)}resort(y=null,c=!0){if(!this.sorter)return;const u=this.getElementLocation(y),d=this.model.getNode(u);this._setChildren(u,this.resortChildren(d,c),{})}resortChildren(y,c,u=!0){let d=[...y.children];return(c||u)&&(d=d.sort(this.sorter.compare.bind(this.sorter))),i.Iterable.map(d,P=>({element:P.element,collapsible:P.collapsible,collapsed:P.collapsed,children:this.resortChildren(P,c,!1)}))}getFirstElementChild(y=null){const c=this.getElementLocation(y);return this.model.getFirstElementChild(c)}getLastElementAncestor(y=null){const c=this.getElementLocation(y);return this.model.getLastElementAncestor(c)}has(y){return this.nodes.has(y)}getListIndex(y){const c=this.getElementLocation(y);return this.model.getListIndex(c)}getListRenderCount(y){const c=this.getElementLocation(y);return this.model.getListRenderCount(c)}isCollapsible(y){const c=this.getElementLocation(y);return this.model.isCollapsible(c)}setCollapsible(y,c){const u=this.getElementLocation(y);return this.model.setCollapsible(u,c)}isCollapsed(y){const c=this.getElementLocation(y);return this.model.isCollapsed(c)}setCollapsed(y,c,u){const d=this.getElementLocation(y);return this.model.setCollapsed(d,c,u)}expandTo(y){const c=this.getElementLocation(y);this.model.expandTo(c)}refilter(){this.model.refilter()}getNode(y=null){if(y===null)return this.model.getNode(this.model.rootRef);const c=this.nodes.get(y);if(!c)throw new I.TreeError(this.user,`Tree element not found: ${y}`);return c}getNodeLocation(y){return y.element}getParentNodeLocation(y){if(y===null)throw new I.TreeError(this.user,"Invalid getParentNodeLocation call");const c=this.nodes.get(y);if(!c)throw new I.TreeError(this.user,`Tree element not found: ${y}`);const u=this.model.getNodeLocation(c),d=this.model.getParentNodeLocation(u);return this.model.getNode(d).element}getElementLocation(y){if(y===null)return[];const c=this.nodes.get(y);if(!c)throw new I.TreeError(this.user,`Tree element not found: ${y}`);return this.model.getNodeLocation(c)}}t.ObjectTreeModel=W}),define(ge[19],me([1,0,4,14,21,23,2]),function(ee,t,E,I,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class y extends w.Disposable{onclick(u,d){this._register(E.addDisposableListener(u,E.EventType.CLICK,P=>d(new i.StandardMouseEvent(P))))}onmousedown(u,d){this._register(E.addDisposableListener(u,E.EventType.MOUSE_DOWN,P=>d(new i.StandardMouseEvent(P))))}onmouseover(u,d){this._register(E.addDisposableListener(u,E.EventType.MOUSE_OVER,P=>d(new i.StandardMouseEvent(P))))}onmouseleave(u,d){this._register(E.addDisposableListener(u,E.EventType.MOUSE_LEAVE,P=>d(new i.StandardMouseEvent(P))))}onkeydown(u,d){this._register(E.addDisposableListener(u,E.EventType.KEY_DOWN,P=>d(new I.StandardKeyboardEvent(P))))}onkeyup(u,d){this._register(E.addDisposableListener(u,E.EventType.KEY_UP,P=>d(new I.StandardKeyboardEvent(P))))}oninput(u,d){this._register(E.addDisposableListener(u,E.EventType.INPUT,d))}onblur(u,d){this._register(E.addDisposableListener(u,E.EventType.BLUR,d))}onfocus(u,d){this._register(E.addDisposableListener(u,E.EventType.FOCUS,d))}onchange(u,d){this._register(E.addDisposableListener(u,E.EventType.CHANGE,d))}ignoreGesture(u){return W.Gesture.ignoreTarget(u)}}t.Widget=y}),define(ge[36],me([1,0,53,19,9,18,4]),function(ee,t,E,I,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class y extends I.Widget{constructor(u){super(),this._onActivate=u.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=u.bgWidth+"px",this.bgDomNode.style.height=u.bgHeight+"px",typeof u.top<"u"&&(this.bgDomNode.style.top="0px"),typeof u.left<"u"&&(this.bgDomNode.style.left="0px"),typeof u.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof u.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=u.className,this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(u.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof u.top<"u"&&(this.domNode.style.top=u.top+"px"),typeof u.left<"u"&&(this.domNode.style.left=u.left+"px"),typeof u.bottom<"u"&&(this.domNode.style.bottom=u.bottom+"px"),typeof u.right<"u"&&(this.domNode.style.right=u.right+"px"),this._pointerMoveMonitor=this._register(new E.GlobalPointerMoveMonitor),this._register(w.addStandardDisposableListener(this.bgDomNode,w.EventType.POINTER_DOWN,d=>this._arrowPointerDown(d))),this._register(w.addStandardDisposableListener(this.domNode,w.EventType.POINTER_DOWN,d=>this._arrowPointerDown(d))),this._pointerdownRepeatTimer=this._register(new i.IntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new i.TimeoutTimer)}_arrowPointerDown(u){if(!u.target||!(u.target instanceof Element))return;const d=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24)};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(d,200),this._pointerMoveMonitor.startMonitoring(u.target,u.pointerId,u.buttons,P=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),u.preventDefault()}}t.ScrollbarArrow=y}),define(ge[56],me([1,0,4,39,53,36,117,19,5]),function(ee,t,E,I,i,W,w,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const u=140;class d extends y.Widget{constructor(r){super(),this._lazyRender=r.lazyRender,this._host=r.host,this._scrollable=r.scrollable,this._scrollByPage=r.scrollByPage,this._scrollbarState=r.scrollbarState,this._visibilityController=this._register(new w.ScrollbarVisibilityController(r.visibility,"visible scrollbar "+r.extraScrollbarClassName,"invisible scrollbar "+r.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new i.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,I.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(E.addDisposableListener(this.domNode.domNode,E.EventType.POINTER_DOWN,l=>this._domNodePointerDown(l)))}_createArrow(r){const l=this._register(new W.ScrollbarArrow(r));this.domNode.domNode.appendChild(l.bgDomNode),this.domNode.domNode.appendChild(l.domNode)}_createSlider(r,l,e,a){this.slider=(0,I.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(r),this.slider.setLeft(l),typeof e=="number"&&this.slider.setWidth(e),typeof a=="number"&&this.slider.setHeight(a),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(E.addDisposableListener(this.slider.domNode,E.EventType.POINTER_DOWN,n=>{n.button===0&&(n.preventDefault(),this._sliderPointerDown(n))})),this.onclick(this.slider.domNode,n=>{n.leftButton&&n.stopPropagation()})}_onElementSize(r){return this._scrollbarState.setVisibleSize(r)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(r){return this._scrollbarState.setScrollSize(r)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(r){return this._scrollbarState.setScrollPosition(r)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){this._shouldRender&&(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(r){r.target===this.domNode.domNode&&this._onPointerDown(r)}delegatePointerDown(r){const l=this.domNode.domNode.getClientRects()[0].top,e=l+this._scrollbarState.getSliderPosition(),a=l+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),n=this._sliderPointerPosition(r);e<=n&&n<=a?r.button===0&&(r.preventDefault(),this._sliderPointerDown(r)):this._onPointerDown(r)}_onPointerDown(r){let l,e;if(r.target===this.domNode.domNode&&typeof r.offsetX=="number"&&typeof r.offsetY=="number")l=r.offsetX,e=r.offsetY;else{const n=E.getDomNodePagePosition(this.domNode.domNode);l=r.pageX-n.left,e=r.pageY-n.top}const a=this._pointerDownRelativePosition(l,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(a):this._scrollbarState.getDesiredScrollPositionFromOffset(a)),r.button===0&&(r.preventDefault(),this._sliderPointerDown(r))}_sliderPointerDown(r){if(!r.target||!(r.target instanceof Element))return;const l=this._sliderPointerPosition(r),e=this._sliderOrthogonalPointerPosition(r),a=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(r.target,r.pointerId,r.buttons,n=>{const h=this._sliderOrthogonalPointerPosition(n),s=Math.abs(h-e);if(c.isWindows&&s>u){this._setDesiredScrollPositionNow(a.getScrollPosition());return}const v=this._sliderPointerPosition(n)-l;this._setDesiredScrollPositionNow(a.getDesiredScrollPositionFromDelta(v))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(r){const l={};this.writeScrollPosition(l,r),this._scrollable.setScrollPositionNow(l)}updateScrollbarSize(r){this._updateScrollbarSize(r),this._scrollbarState.setScrollbarSize(r),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=d}),define(ge[120],me([1,0,21,56,36,40,17]),function(ee,t,E,I,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class y extends I.AbstractScrollbar{constructor(u,d,P){const r=u.getScrollDimensions(),l=u.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:P,scrollbarState:new W.ScrollbarState(d.horizontalHasArrows?d.arrowSize:0,d.horizontal===2?0:d.horizontalScrollbarSize,d.vertical===2?0:d.verticalScrollbarSize,r.width,r.scrollWidth,l.scrollLeft),visibility:d.horizontal,extraScrollbarClassName:"horizontal",scrollable:u,scrollByPage:d.scrollByPage}),d.horizontalHasArrows){const e=(d.arrowSize-i.ARROW_IMG_SIZE)/2,a=(d.horizontalScrollbarSize-i.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:w.Codicon.scrollbarButtonLeft,top:a,left:e,bottom:void 0,right:void 0,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:w.Codicon.scrollbarButtonRight,top:a,left:void 0,bottom:void 0,right:e,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((d.horizontalScrollbarSize-d.horizontalSliderSize)/2),0,void 0,d.horizontalSliderSize)}_updateSlider(u,d){this.slider.setWidth(u),this.slider.setLeft(d)}_renderDomNode(u,d){this.domNode.setWidth(u),this.domNode.setHeight(d),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(u){return this._shouldRender=this._onElementScrollSize(u.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(u.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(u.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(u,d){return u}_sliderPointerPosition(u){return u.pageX}_sliderOrthogonalPointerPosition(u){return u.pageY}_updateScrollbarSize(u){this.slider.setHeight(u)}writeScrollPosition(u,d){u.scrollLeft=d}updateOptions(u){this.updateScrollbarSize(u.horizontal===2?0:u.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(u.vertical===2?0:u.verticalScrollbarSize),this._visibilityController.setVisibility(u.horizontal),this._scrollByPage=u.scrollByPage}}t.HorizontalScrollbar=y}),define(ge[121],me([1,0,21,56,36,40,17]),function(ee,t,E,I,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class y extends I.AbstractScrollbar{constructor(u,d,P){const r=u.getScrollDimensions(),l=u.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:P,scrollbarState:new W.ScrollbarState(d.verticalHasArrows?d.arrowSize:0,d.vertical===2?0:d.verticalScrollbarSize,0,r.height,r.scrollHeight,l.scrollTop),visibility:d.vertical,extraScrollbarClassName:"vertical",scrollable:u,scrollByPage:d.scrollByPage}),d.verticalHasArrows){const e=(d.arrowSize-i.ARROW_IMG_SIZE)/2,a=(d.verticalScrollbarSize-i.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:w.Codicon.scrollbarButtonUp,top:e,left:a,bottom:void 0,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:w.Codicon.scrollbarButtonDown,top:void 0,left:a,bottom:e,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((d.verticalScrollbarSize-d.verticalSliderSize)/2),d.verticalSliderSize,void 0)}_updateSlider(u,d){this.slider.setHeight(u),this.slider.setTop(d)}_renderDomNode(u,d){this.domNode.setWidth(d),this.domNode.setHeight(u),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(u){return this._shouldRender=this._onElementScrollSize(u.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(u.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(u.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(u,d){return d}_sliderPointerPosition(u){return u.pageY}_sliderOrthogonalPointerPosition(u){return u.pageX}_updateScrollbarSize(u){this.slider.setWidth(u)}writeScrollPosition(u,d){u.scrollTop=d}updateOptions(u){this.updateScrollbarSize(u.vertical===2?0:u.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(u.vertical),this._scrollByPage=u.scrollByPage}}t.VerticalScrollbar=y}),define(ge[57],me([1,0,16,4,39,21,120,121,19,9,3,2,5,46,95]),function(ee,t,E,I,i,W,w,y,c,u,d,P,r,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,a=50,n=!0;class h{constructor(R,g,m){this.timestamp=R,this.deltaX=g,this.deltaY=m,this.score=0}}class s{constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let R=1,g=0,m=1,L=this._rear;do{const k=L===this._front?R:Math.pow(2,-m);if(R-=k,g+=this._memory[L].score*k,L===this._front)break;L=(this._capacity+L-1)%this._capacity,m++}while(!0);return g<=.5}acceptStandardWheelEvent(R){const g=window.devicePixelRatio/(0,E.getZoomFactor)();r.isWindows||r.isLinux?this.accept(Date.now(),R.deltaX/g,R.deltaY/g):this.accept(Date.now(),R.deltaX,R.deltaY)}accept(R,g,m){const L=new h(R,g,m);L.score=this._computeScore(L),this._front===-1&&this._rear===-1?(this._memory[0]=L,this._front=0,this._rear=0):(this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=L)}_computeScore(R){if(Math.abs(R.deltaX)>0&&Math.abs(R.deltaY)>0)return 1;let g=.5;const m=this._front===-1&&this._rear===-1?null:this._memory[this._rear];return(!this._isAlmostInt(R.deltaX)||!this._isAlmostInt(R.deltaY))&&(g+=.25),Math.min(Math.max(g,0),1)}_isAlmostInt(R){return Math.abs(Math.round(R)-R)<.01}}t.MouseWheelClassifier=s,s.INSTANCE=new s;class p extends c.Widget{get options(){return this._options}constructor(R,g,m){super(),this._onScroll=this._register(new d.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new d.Emitter),this.onWillScroll=this._onWillScroll.event,R.style.overflow="hidden",this._options=D(g),this._scrollable=m,this._register(this._scrollable.onScroll(k=>{this._onWillScroll.fire(k),this._onDidScroll(k),this._onScroll.fire(k)}));const L={onMouseWheel:k=>this._onMouseWheel(k),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new y.VerticalScrollbar(this._scrollable,this._options,L)),this._horizontalScrollbar=this._register(new w.HorizontalScrollbar(this._scrollable,this._options,L)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(R),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,i.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,i.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,i.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,k=>this._onMouseOver(k)),this.onmouseleave(this._listenOnDomNode,k=>this._onMouseLeave(k)),this._hideTimeout=this._register(new u.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}dispose(){this._mouseWheelToDispose=(0,P.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(R){this._verticalScrollbar.delegatePointerDown(R)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(R){this._scrollable.setScrollDimensions(R,!1)}updateClassName(R){this._options.className=R,r.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(R){typeof R.handleMouseWheel<"u"&&(this._options.handleMouseWheel=R.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof R.mouseWheelScrollSensitivity<"u"&&(this._options.mouseWheelScrollSensitivity=R.mouseWheelScrollSensitivity),typeof R.fastScrollSensitivity<"u"&&(this._options.fastScrollSensitivity=R.fastScrollSensitivity),typeof R.scrollPredominantAxis<"u"&&(this._options.scrollPredominantAxis=R.scrollPredominantAxis),typeof R.horizontal<"u"&&(this._options.horizontal=R.horizontal),typeof R.vertical<"u"&&(this._options.vertical=R.vertical),typeof R.horizontalScrollbarSize<"u"&&(this._options.horizontalScrollbarSize=R.horizontalScrollbarSize),typeof R.verticalScrollbarSize<"u"&&(this._options.verticalScrollbarSize=R.verticalScrollbarSize),typeof R.scrollByPage<"u"&&(this._options.scrollByPage=R.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(R){this._revealOnScroll=R}delegateScrollFromMouseWheelEvent(R){this._onMouseWheel(new W.StandardWheelEvent(R))}_setListeningToMouseWheel(R){if(this._mouseWheelToDispose.length>0!==R&&(this._mouseWheelToDispose=(0,P.dispose)(this._mouseWheelToDispose),R)){const m=L=>{this._onMouseWheel(new W.StandardWheelEvent(L))};this._mouseWheelToDispose.push(I.addDisposableListener(this._listenOnDomNode,I.EventType.MOUSE_WHEEL,m,{passive:!1}))}}_onMouseWheel(R){if(R.browserEvent?.defaultPrevented)return;const g=s.INSTANCE;n&&g.acceptStandardWheelEvent(R);let m=!1;if(R.deltaY||R.deltaX){let k=R.deltaY*this._options.mouseWheelScrollSensitivity,A=R.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(Math.abs(k)>=Math.abs(A)?A=0:k=0),this._options.flipAxes&&([k,A]=[A,k]);const H=!r.isMacintosh&&R.browserEvent&&R.browserEvent.shiftKey;(this._options.scrollYToX||H)&&!A&&(A=k,k=0),R.browserEvent&&R.browserEvent.altKey&&(A=A*this._options.fastScrollSensitivity,k=k*this._options.fastScrollSensitivity);const G=this._scrollable.getFutureScrollPosition();let ne={};if(k){const se=a*k,de=G.scrollTop-(se<0?Math.floor(se):Math.ceil(se));this._verticalScrollbar.writeScrollPosition(ne,de)}if(A){const se=a*A,de=G.scrollLeft-(se<0?Math.floor(se):Math.ceil(se));this._horizontalScrollbar.writeScrollPosition(ne,de)}ne=this._scrollable.validateScrollPosition(ne),(G.scrollLeft!==ne.scrollLeft||G.scrollTop!==ne.scrollTop)&&(n&&this._options.mouseWheelSmoothScroll&&g.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(ne):this._scrollable.setScrollPositionNow(ne),m=!0)}let L=m;!L&&this._options.alwaysConsumeMouseWheel&&(L=!0),!L&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(L=!0),L&&(R.preventDefault(),R.stopPropagation())}_onDidScroll(R){this._shouldRender=this._horizontalScrollbar.onDidScroll(R)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(R)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const R=this._scrollable.getCurrentScrollPosition(),g=R.scrollTop>0,m=R.scrollLeft>0,L=m?" left":"",k=g?" top":"",A=m||g?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${L}`),this._topShadowDomNode.setClassName(`shadow${k}`),this._topLeftShadowDomNode.setClassName(`shadow${A}${k}${L}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(R){this._mouseIsOver=!1,this._hide()}_onMouseOver(R){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=p;class v extends p{constructor(R,g){g=g||{},g.mouseWheelSmoothScroll=!1;const m=new l.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:L=>I.scheduleAtNextAnimationFrame(L)});super(R,g,m),this._register(m)}setScrollPosition(R){this._scrollable.setScrollPositionNow(R)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=v;class C extends p{constructor(R,g,m){super(R,g,m)}setScrollPosition(R){R.reuseAnimation?this._scrollable.setScrollPositionSmooth(R,R.reuseAnimation):this._scrollable.setScrollPositionNow(R)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=C;class f extends p{constructor(R,g){g=g||{},g.mouseWheelSmoothScroll=!1;const m=new l.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:L=>I.scheduleAtNextAnimationFrame(L)});super(R,g,m),this._register(m),this._element=R,this.onScroll(L=>{L.scrollTopChanged&&(this._element.scrollTop=L.scrollTop),L.scrollLeftChanged&&(this._element.scrollLeft=L.scrollLeft)}),this.scanDomNode()}setScrollPosition(R){this._scrollable.setScrollPositionNow(R)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=f;function D(M){const R={lazyRender:typeof M.lazyRender<"u"?M.lazyRender:!1,className:typeof M.className<"u"?M.className:"",useShadows:typeof M.useShadows<"u"?M.useShadows:!0,handleMouseWheel:typeof M.handleMouseWheel<"u"?M.handleMouseWheel:!0,flipAxes:typeof M.flipAxes<"u"?M.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof M.consumeMouseWheelIfScrollbarIsNeeded<"u"?M.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof M.alwaysConsumeMouseWheel<"u"?M.alwaysConsumeMouseWheel:!1,scrollYToX:typeof M.scrollYToX<"u"?M.scrollYToX:!1,mouseWheelScrollSensitivity:typeof M.mouseWheelScrollSensitivity<"u"?M.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof M.fastScrollSensitivity<"u"?M.fastScrollSensitivity:5,scrollPredominantAxis:typeof M.scrollPredominantAxis<"u"?M.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof M.mouseWheelSmoothScroll<"u"?M.mouseWheelSmoothScroll:!0,arrowSize:typeof M.arrowSize<"u"?M.arrowSize:11,listenOnDomNode:typeof M.listenOnDomNode<"u"?M.listenOnDomNode:null,horizontal:typeof M.horizontal<"u"?M.horizontal:1,horizontalScrollbarSize:typeof M.horizontalScrollbarSize<"u"?M.horizontalScrollbarSize:10,horizontalSliderSize:typeof M.horizontalSliderSize<"u"?M.horizontalSliderSize:0,horizontalHasArrows:typeof M.horizontalHasArrows<"u"?M.horizontalHasArrows:!1,vertical:typeof M.vertical<"u"?M.vertical:1,verticalScrollbarSize:typeof M.verticalScrollbarSize<"u"?M.verticalScrollbarSize:10,verticalHasArrows:typeof M.verticalHasArrows<"u"?M.verticalHasArrows:!1,verticalSliderSize:typeof M.verticalSliderSize<"u"?M.verticalSliderSize:0,scrollByPage:typeof M.scrollByPage<"u"?M.scrollByPage:!1};return R.horizontalSliderSize=typeof M.horizontalSliderSize<"u"?M.horizontalSliderSize:R.horizontalScrollbarSize,R.verticalSliderSize=typeof M.verticalSliderSize<"u"?M.verticalSliderSize:R.verticalScrollbarSize,r.isMacintosh&&(R.className+=" mac"),R}}),define(ge[58],me([1,0,51,4,20,23,57,13,9,25,3,2,45,46,79,116,7]),function(ee,t,E,I,i,W,w,y,c,u,d,P,r,l,e,a,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const h={CurrentDragAndDropData:void 0},s={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(R){return[R]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class p{get context(){return this._context}set context(g){this._context=g}constructor(g){this.elements=g}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=p;class v{constructor(g){this.elements=g}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=v;class C{constructor(){this.types=[],this.files=[]}update(g){if(g.types&&this.types.splice(0,this.types.length,...g.types),g.files){this.files.splice(0,this.files.length);for(let m=0;m<g.files.length;m++){const L=g.files.item(m);L&&(L.size||L.type)&&this.files.push(L)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=C;function f(R,g){return Array.isArray(R)&&Array.isArray(g)?(0,y.equals)(R,g):R===g}class D{constructor(g){g?.getSetSize?this.getSetSize=g.getSetSize.bind(g):this.getSetSize=(m,L,k)=>k,g?.getPosInSet?this.getPosInSet=g.getPosInSet.bind(g):this.getPosInSet=(m,L)=>L+1,g?.getRole?this.getRole=g.getRole.bind(g):this.getRole=m=>"listitem",g?.isChecked?this.isChecked=g.isChecked.bind(g):this.isChecked=m=>{}}}class M{get contentHeight(){return this.rangeMap.size}get contentWidth(){return this.scrollWidth??0}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(g){if(g!==this._horizontalScrolling){if(g&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=g,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const m of this.items)this.measureItemWidth(m);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,I.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}constructor(g,m,L,k=s){if(this.virtualDelegate=m,this.domId=`list_id_${++M.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new c.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=P.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=P.Disposable.None,this.onDragLeaveTimeout=P.Disposable.None,this.disposables=new P.DisposableStore,this._onDidChangeContentHeight=new d.Emitter,this._onDidChangeContentWidth=new d.Emitter,this.onDidChangeContentHeight=d.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this.onDidChangeContentWidth=d.Event.latch(this._onDidChangeContentWidth.event,void 0,this.disposables),this._horizontalScrolling=!1,k.horizontalScrolling&&k.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=new e.RangeMap;for(const H of L)this.renderers.set(H.templateId,H);this.cache=this.disposables.add(new a.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof k.mouseSupport=="boolean"?k.mouseSupport:!0),this._horizontalScrolling=k.horizontalScrolling??s.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.additionalScrollHeight=typeof k.additionalScrollHeight>"u"?0:k.additionalScrollHeight,this.accessibilityProvider=new D(k.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(k.transformOptimization??s.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)",this.rowsContainer.style.overflow="hidden",this.rowsContainer.style.contain="strict"),this.disposables.add(W.Gesture.addTarget(this.rowsContainer)),this.scrollable=new l.Scrollable({forceIntegerValues:!0,smoothScrollDuration:k.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:H=>(0,I.scheduleAtNextAnimationFrame)(H)}),this.scrollableElement=this.disposables.add(new w.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:k.alwaysConsumeMouseWheel??s.alwaysConsumeMouseWheel,horizontal:1,vertical:k.verticalScrollMode??s.verticalScrollMode,useShadows:k.useShadows??s.useShadows,mouseWheelScrollSensitivity:k.mouseWheelScrollSensitivity,fastScrollSensitivity:k.fastScrollSensitivity,scrollByPage:k.scrollByPage},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),g.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,I.addDisposableListener)(this.rowsContainer,W.EventType.Change,H=>this.onTouchChange(H))),this.disposables.add((0,I.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",H=>H.target.scrollTop=0)),this.disposables.add((0,I.addDisposableListener)(this.domNode,"dragover",H=>this.onDragOver(this.toDragEvent(H)))),this.disposables.add((0,I.addDisposableListener)(this.domNode,"drop",H=>this.onDrop(this.toDragEvent(H)))),this.disposables.add((0,I.addDisposableListener)(this.domNode,"dragleave",H=>this.onDragLeave(this.toDragEvent(H)))),this.disposables.add((0,I.addDisposableListener)(this.domNode,"dragend",H=>this.onDragEnd(H))),this.setRowLineHeight=k.setRowLineHeight??s.setRowLineHeight,this.setRowHeight=k.setRowHeight??s.setRowHeight,this.supportDynamicHeights=k.supportDynamicHeights??s.supportDynamicHeights,this.dnd=k.dnd??s.dnd,this.layout(k.initialSize?.height,k.initialSize?.width)}updateOptions(g){g.additionalScrollHeight!==void 0&&(this.additionalScrollHeight=g.additionalScrollHeight,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),g.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(g.smoothScrolling?125:0),g.horizontalScrolling!==void 0&&(this.horizontalScrolling=g.horizontalScrolling);let m;g.scrollByPage!==void 0&&(m={...m??{},scrollByPage:g.scrollByPage}),g.mouseWheelScrollSensitivity!==void 0&&(m={...m??{},mouseWheelScrollSensitivity:g.mouseWheelScrollSensitivity}),g.fastScrollSensitivity!==void 0&&(m={...m??{},fastScrollSensitivity:g.fastScrollSensitivity}),m&&this.scrollableElement.updateOptions(m)}delegateScrollFromMouseWheelEvent(g){this.scrollableElement.delegateScrollFromMouseWheelEvent(g)}delegateVerticalScrollbarPointerDown(g){this.scrollableElement.delegateVerticalScrollbarPointerDown(g)}updateElementHeight(g,m,L){if(g<0||g>=this.items.length)return;const k=this.items[g].size;if(typeof m>"u"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[g].lastDynamicHeightWidth=void 0,m=k+this.probeDynamicHeight(g)}if(k===m)return;const A=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let H=0;g<A.start||L!==null&&L>g&&L<=A.end?H=m-k:H=0,this.rangeMap.splice(g,1,[{size:m}]),this.items[g].size=m,this.render(A,Math.max(0,this.lastRenderTop+H),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}splice(g,m,L=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(g,m,L)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(g,m,L=[]){const k=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),A={start:g,end:g+m},H=r.Range.intersect(k,A),G=new Map;for(let V=H.end-1;V>=H.start;V--){const _=this.items[V];if(_.dragStartDisposable.dispose(),_.checkedDisposable.dispose(),_.row){let K=G.get(_.templateId);K||(K=[],G.set(_.templateId,K));const z=this.renderers.get(_.templateId);z&&z.disposeElement&&z.disposeElement(_.element,V,_.row.templateData,_.size),K.push(_.row)}_.row=null}const ne={start:g+m,end:this.items.length},se=r.Range.intersect(ne,k),de=r.Range.relativeComplement(ne,k),ue=L.map(V=>({id:String(this.itemId++),element:V,templateId:this.virtualDelegate.getTemplateId(V),size:this.virtualDelegate.getHeight(V),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(V),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:P.Disposable.None,checkedDisposable:P.Disposable.None}));let re;g===0&&m>=this.items.length?(this.rangeMap=new e.RangeMap,this.rangeMap.splice(0,0,ue),re=this.items,this.items=ue):(this.rangeMap.splice(g,m,ue),re=this.items.splice(g,m,...ue));const le=L.length-m,ye=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),Te=(0,e.shift)(se,le),Me=r.Range.intersect(ye,Te);for(let V=Me.start;V<Me.end;V++)this.updateItemInDOM(this.items[V],V);const Oe=r.Range.relativeComplement(Te,ye);for(const V of Oe)for(let _=V.start;_<V.end;_++)this.removeItemFromDOM(_);const ce=de.map(V=>(0,e.shift)(V,le)),q=[{start:g,end:g+L.length},...ce].map(V=>r.Range.intersect(ye,V)),$=this.getNextToLastElement(q);for(const V of q)for(let _=V.start;_<V.end;_++){const K=this.items[_],o=G.get(K.templateId)?.pop();this.insertItemInDOM(_,$,o)}for(const V of G.values())for(const _ of V)this.cache.release(_);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),re.map(V=>V.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,I.scheduleAtNextAnimationFrame)(()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let g=0;for(const m of this.items)typeof m.width<"u"&&(g=Math.max(g,m.width));this.scrollWidth=g,this.scrollableElement.setScrollDimensions({scrollWidth:g===0?0:g+10}),this._onDidChangeContentWidth.fire(this.scrollWidth)}updateWidth(g){if(!this.horizontalScrolling||typeof this.scrollWidth>"u")return;const m=this.items[g];this.measureItemWidth(m),typeof m.width<"u"&&m.width>this.scrollWidth&&(this.scrollWidth=m.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}),this._onDidChangeContentWidth.fire(this.scrollWidth))}rerender(){if(this.supportDynamicHeights){for(const g of this.items)g.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){const g=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),m=this.rangeMap.positionAt(g.start),L=this.rangeMap.positionAt(g.start+1);return L!==-1&&(L-m)/2+m<this.scrollTop?g.start+1:g.start}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(g){return this.items[g].element}indexOf(g){return this.items.findIndex(m=>m.element===g)}domElement(g){const m=this.items[g].row;return m&&m.domNode}elementHeight(g){return this.items[g].size}elementTop(g){return this.rangeMap.positionAt(g)}indexAt(g){return this.rangeMap.indexAt(g)}indexAfter(g){return this.rangeMap.indexAfter(g)}layout(g,m){const L={height:typeof g=="number"?g:(0,I.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,L.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(L),typeof m<"u"&&(this.renderWidth=m,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof m=="number"?m:(0,I.getContentWidth)(this.domNode)})}render(g,m,L,k,A,H=!1){const G=this.getRenderRange(m,L),ne=r.Range.relativeComplement(G,g),se=r.Range.relativeComplement(g,G),de=this.getNextToLastElement(ne);if(H){const ue=r.Range.intersect(g,G);for(let re=ue.start;re<ue.end;re++)this.updateItemInDOM(this.items[re],re)}this.cache.transact(()=>{for(const ue of se)for(let re=ue.start;re<ue.end;re++)this.removeItemFromDOM(re);for(const ue of ne)for(let re=ue.start;re<ue.end;re++)this.insertItemInDOM(re,de)}),k!==void 0&&(this.rowsContainer.style.left=`-${k}px`),this.rowsContainer.style.top=`-${m}px`,this.horizontalScrolling&&A!==void 0&&(this.rowsContainer.style.width=`${Math.max(A,this.renderWidth)}px`),this.lastRenderTop=m,this.lastRenderHeight=L}insertItemInDOM(g,m,L){const k=this.items[g];let A=!1;if(!k.row)if(L)k.row=L;else{const de=this.cache.alloc(k.templateId);k.row=de.row,A=de.isReusingConnectedDomNode}const H=this.accessibilityProvider.getRole(k.element)||"listitem";k.row.domNode.setAttribute("role",H);const G=this.accessibilityProvider.isChecked(k.element);if(typeof G=="boolean")k.row.domNode.setAttribute("aria-checked",String(!!G));else if(G){const de=ue=>k.row.domNode.setAttribute("aria-checked",String(!!ue));de(G.value),k.checkedDisposable=G.onDidChange(de)}(A||!k.row.domNode.parentElement)&&(m?this.rowsContainer.insertBefore(k.row.domNode,m):this.rowsContainer.appendChild(k.row.domNode)),this.updateItemInDOM(k,g);const ne=this.renderers.get(k.templateId);if(!ne)throw new Error(`No renderer found for template id ${k.templateId}`);ne?.renderElement(k.element,g,k.row.templateData,k.size);const se=this.dnd.getDragURI(k.element);k.dragStartDisposable.dispose(),k.row.domNode.draggable=!!se,se&&(k.dragStartDisposable=(0,I.addDisposableListener)(k.row.domNode,"dragstart",de=>this.onDragStart(k.element,se,de))),this.horizontalScrolling&&(this.measureItemWidth(k),this.eventuallyUpdateScrollWidth())}measureItemWidth(g){if(!g.row||!g.row.domNode)return;g.row.domNode.style.width="fit-content",g.width=(0,I.getContentWidth)(g.row.domNode);const m=window.getComputedStyle(g.row.domNode);m.paddingLeft&&(g.width+=parseFloat(m.paddingLeft)),m.paddingRight&&(g.width+=parseFloat(m.paddingRight)),g.row.domNode.style.width=""}updateItemInDOM(g,m){g.row.domNode.style.top=`${this.elementTop(m)}px`,this.setRowHeight&&(g.row.domNode.style.height=`${g.size}px`),this.setRowLineHeight&&(g.row.domNode.style.lineHeight=`${g.size}px`),g.row.domNode.setAttribute("data-index",`${m}`),g.row.domNode.setAttribute("data-last-element",m===this.length-1?"true":"false"),g.row.domNode.setAttribute("data-parity",m%2===0?"even":"odd"),g.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(g.element,m,this.length))),g.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(g.element,m))),g.row.domNode.setAttribute("id",this.getElementDomId(m)),g.row.domNode.classList.toggle("drop-target",g.dropTarget)}removeItemFromDOM(g){const m=this.items[g];if(m.dragStartDisposable.dispose(),m.checkedDisposable.dispose(),m.row){const L=this.renderers.get(m.templateId);L&&L.disposeElement&&L.disposeElement(m.element,g,m.row.templateData,m.size),this.cache.release(m.row),m.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(g,m){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:g,reuseAnimation:m})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(g){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:g})}get scrollTop(){return this.getScrollTop()}set scrollTop(g){this.setScrollTop(g)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.additionalScrollHeight}get onMouseClick(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"click")).event,g=>this.toMouseEvent(g),this.disposables)}get onMouseDblClick(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"dblclick")).event,g=>this.toMouseEvent(g),this.disposables)}get onMouseMiddleClick(){return d.Event.filter(d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"auxclick")).event,g=>this.toMouseEvent(g),this.disposables),g=>g.browserEvent.button===1,this.disposables)}get onMouseUp(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mouseup")).event,g=>this.toMouseEvent(g),this.disposables)}get onMouseDown(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mousedown")).event,g=>this.toMouseEvent(g),this.disposables)}get onMouseOver(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mouseover")).event,g=>this.toMouseEvent(g),this.disposables)}get onMouseMove(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mousemove")).event,g=>this.toMouseEvent(g),this.disposables)}get onMouseOut(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mouseout")).event,g=>this.toMouseEvent(g),this.disposables)}get onContextMenu(){return d.Event.any(d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"contextmenu")).event,g=>this.toMouseEvent(g),this.disposables),d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,W.EventType.Contextmenu)).event,g=>this.toGestureEvent(g),this.disposables))}get onTouchStart(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"touchstart")).event,g=>this.toTouchEvent(g),this.disposables)}get onTap(){return d.Event.map(this.disposables.add(new i.DomEmitter(this.rowsContainer,W.EventType.Tap)).event,g=>this.toGestureEvent(g),this.disposables)}toMouseEvent(g){const m=this.getItemIndexFromEventTarget(g.target||null),L=typeof m>"u"?void 0:this.items[m],k=L&&L.element;return{browserEvent:g,index:m,element:k}}toTouchEvent(g){const m=this.getItemIndexFromEventTarget(g.target||null),L=typeof m>"u"?void 0:this.items[m],k=L&&L.element;return{browserEvent:g,index:m,element:k}}toGestureEvent(g){const m=this.getItemIndexFromEventTarget(g.initialTarget||null),L=typeof m>"u"?void 0:this.items[m],k=L&&L.element;return{browserEvent:g,index:m,element:k}}toDragEvent(g){const m=this.getItemIndexFromEventTarget(g.target||null),L=typeof m>"u"?void 0:this.items[m],k=L&&L.element;return{browserEvent:g,index:m,element:k}}onScroll(g){try{const m=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(m,g.scrollTop,g.height,g.scrollLeft,g.scrollWidth),this.supportDynamicHeights&&this._rerender(g.scrollTop,g.height,g.inSmoothScrolling)}catch(m){throw console.error("Got bad scroll event:",g),m}}onTouchChange(g){g.preventDefault(),g.stopPropagation(),this.scrollTop-=g.translationY}onDragStart(g,m,L){if(!L.dataTransfer)return;const k=this.dnd.getDragElements(g);if(L.dataTransfer.effectAllowed="copyMove",L.dataTransfer.setData(E.DataTransfers.TEXT,m),L.dataTransfer.setDragImage){let A;this.dnd.getDragLabel&&(A=this.dnd.getDragLabel(k,L)),typeof A>"u"&&(A=String(k.length));const H=(0,I.$)(".monaco-drag-image");H.textContent=A;const ne=(se=>{for(;se&&!se.classList.contains("monaco-workbench");)se=se.parentElement;return se||document.body})(this.domNode);ne.appendChild(H),L.dataTransfer.setDragImage(H,-10,-10),setTimeout(()=>ne.removeChild(H),0)}this.domNode.classList.add("dragging"),this.currentDragData=new p(k),h.CurrentDragAndDropData=new v(k),this.dnd.onDragStart?.(this.currentDragData,L)}onDragOver(g){if(g.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),h.CurrentDragAndDropData&&h.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(g.browserEvent),!g.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(h.CurrentDragAndDropData)this.currentDragData=h.CurrentDragAndDropData;else{if(!g.browserEvent.dataTransfer.types)return!1;this.currentDragData=new C}const m=this.dnd.onDragOver(this.currentDragData,g.element,g.index,g.browserEvent);if(this.canDrop=typeof m=="boolean"?m:m.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;g.browserEvent.dataTransfer.dropEffect=typeof m!="boolean"&&m.effect===0?"copy":"move";let L;if(typeof m!="boolean"&&m.feedback?L=m.feedback:typeof g.index>"u"?L=[-1]:L=[g.index],L=(0,y.distinct)(L).filter(k=>k>=-1&&k<this.length).sort((k,A)=>k-A),L=L[0]===-1?[-1]:L,f(this.currentDragFeedback,L))return!0;if(this.currentDragFeedback=L,this.currentDragFeedbackDisposable.dispose(),L[0]===-1)this.domNode.classList.add("drop-target"),this.rowsContainer.classList.add("drop-target"),this.currentDragFeedbackDisposable=(0,P.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.rowsContainer.classList.remove("drop-target")});else{for(const k of L){const A=this.items[k];A.dropTarget=!0,A.row?.domNode.classList.add("drop-target")}this.currentDragFeedbackDisposable=(0,P.toDisposable)(()=>{for(const k of L){const A=this.items[k];A.dropTarget=!1,A.row?.domNode.classList.remove("drop-target")}})}return!0}onDragLeave(g){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,c.disposableTimeout)(()=>this.clearDragOverFeedback(),100),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,g.element,g.index,g.browserEvent)}onDrop(g){if(!this.canDrop)return;const m=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,h.CurrentDragAndDropData=void 0,!(!m||!g.browserEvent.dataTransfer)&&(g.browserEvent.preventDefault(),m.update(g.browserEvent.dataTransfer),this.dnd.drop(m,g.element,g.index,g.browserEvent))}onDragEnd(g){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,h.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(g)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=P.Disposable.None}setupDragAndDropScrollTopAnimation(g){if(!this.dragOverAnimationDisposable){const m=(0,I.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,I.animate)(this.animateDragAndDropScrollTop.bind(this,m))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,c.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3),this.dragOverMouseY=g.pageY}animateDragAndDropScrollTop(g){if(this.dragOverMouseY===void 0)return;const m=this.dragOverMouseY-g,L=this.renderHeight-35;m<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(m-35))):m>L&&(this.scrollTop+=Math.min(14,Math.floor(.3*(m-L))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getItemIndexFromEventTarget(g){const m=this.scrollableElement.getDomNode();let L=g;for(;L instanceof HTMLElement&&L!==this.rowsContainer&&m.contains(L);){const k=L.getAttribute("data-index");if(k){const A=Number(k);if(!isNaN(A))return A}L=L.parentElement}}getRenderRange(g,m){return{start:this.rangeMap.indexAt(g),end:this.rangeMap.indexAfter(g+m-1)}}_rerender(g,m,L){const k=this.getRenderRange(g,m);let A,H;g===this.elementTop(k.start)?(A=k.start,H=0):k.end-k.start>1&&(A=k.start+1,H=this.elementTop(A)-g);let G=0;for(;;){const ne=this.getRenderRange(g,m);let se=!1;for(let de=ne.start;de<ne.end;de++){const ue=this.probeDynamicHeight(de);ue!==0&&this.rangeMap.splice(de,1,[this.items[de]]),G+=ue,se=se||ue!==0}if(!se){G!==0&&this.eventuallyUpdateScrollDimensions();const de=r.Range.relativeComplement(k,ne);for(const re of de)for(let le=re.start;le<re.end;le++)this.items[le].row&&this.removeItemFromDOM(le);const ue=r.Range.relativeComplement(ne,k);for(const re of ue)for(let le=re.start;le<re.end;le++){const ye=le+1,Te=ye<this.items.length?this.items[ye].row:null,Me=Te?Te.domNode:null;this.insertItemInDOM(le,Me)}for(let re=ne.start;re<ne.end;re++)this.items[re].row&&this.updateItemInDOM(this.items[re],re);if(typeof A=="number"){const re=this.scrollable.getFutureScrollPosition().scrollTop-g,le=this.elementTop(A)-H+re;this.setScrollTop(le,L)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(g){const m=this.items[g];if(this.virtualDelegate.getDynamicHeight){const H=this.virtualDelegate.getDynamicHeight(m.element);if(H!==null){const G=m.size;return m.size=H,m.lastDynamicHeightWidth=this.renderWidth,H-G}}if(!m.hasDynamicHeight||m.lastDynamicHeightWidth===this.renderWidth||this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(m.element))return 0;const L=m.size;if(m.row)return m.row.domNode.style.height="",m.size=m.row.domNode.offsetHeight,m.lastDynamicHeightWidth=this.renderWidth,m.size-L;const{row:k}=this.cache.alloc(m.templateId);k.domNode.style.height="",this.rowsContainer.appendChild(k.domNode);const A=this.renderers.get(m.templateId);if(!A)throw new n.BugIndicatingError("Missing renderer for templateId: "+m.templateId);return A.renderElement(m.element,g,k.templateData,void 0),m.size=k.domNode.offsetHeight,A.disposeElement?.(m.element,g,k.templateData,void 0),this.virtualDelegate.setDynamicHeight?.(m.element,m.size),m.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(k.domNode),this.cache.release(k),m.size-L}getNextToLastElement(g){const m=g[g.length-1];if(!m)return null;const L=this.items[m.end];return!L||!L.row?null:L.row.domNode}getElementDomId(g){return`${this.domId}_${g}`}dispose(){if(this.items){for(const g of this.items)if(g.row){const m=this.renderers.get(g.row.templateId);m&&(m.disposeElement?.(g.element,-1,g.row.templateData,void 0),m.disposeTemplate(g.row.templateData))}this.items=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,P.dispose)(this.disposables)}}t.ListView=M,M.InstanceCount=0,qe([u.memoize],M.prototype,"onMouseClick",null),qe([u.memoize],M.prototype,"onMouseDblClick",null),qe([u.memoize],M.prototype,"onMouseMiddleClick",null),qe([u.memoize],M.prototype,"onMouseUp",null),qe([u.memoize],M.prototype,"onMouseDown",null),qe([u.memoize],M.prototype,"onMouseOver",null),qe([u.memoize],M.prototype,"onMouseMove",null),qe([u.memoize],M.prototype,"onMouseOut",null),qe([u.memoize],M.prototype,"onContextMenu",null),qe([u.memoize],M.prototype,"onTouchStart",null),qe([u.memoize],M.prototype,"onTap",null)}),define(ge[37],me([1,0,4,20,14,23,54,68,13,9,70,25,3,32,2,44,5,6,67,58,94]),function(ee,t,E,I,i,W,w,y,c,u,d,P,r,l,e,a,n,h,s,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.unthemedListStyles=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class v{constructor(_){this.trait=_,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(_){return _}renderElement(_,K,z){const o=this.renderedElements.findIndex(F=>F.templateData===z);if(o>=0){const F=this.renderedElements[o];this.trait.unrender(z),F.index=K}else{const F={index:K,templateData:z};this.renderedElements.push(F)}this.trait.renderIndex(K,z)}splice(_,K,z){const o=[];for(const F of this.renderedElements)F.index<_?o.push(F):F.index>=_+K&&o.push({index:F.index+z-K,templateData:F.templateData});this.renderedElements=o}renderIndexes(_){for(const{index:K,templateData:z}of this.renderedElements)_.indexOf(K)>-1&&this.trait.renderIndex(K,z)}disposeTemplate(_){const K=this.renderedElements.findIndex(z=>z.templateData===_);K<0||this.renderedElements.splice(K,1)}}class C{get name(){return this._trait}get renderer(){return new v(this)}constructor(_){this._trait=_,this.length=0,this.indexes=[],this.sortedIndexes=[],this._onChange=new r.Emitter,this.onChange=this._onChange.event}splice(_,K,z){K=Math.max(0,Math.min(K,this.length-_));const o=z.length-K,F=_+K,j=[];let te=0;for(;te<this.sortedIndexes.length&&this.sortedIndexes[te]<_;)j.push(this.sortedIndexes[te++]);for(let T=0;T<z.length;T++)z[T]&&j.push(T+_);for(;te<this.sortedIndexes.length&&this.sortedIndexes[te]>=F;)j.push(this.sortedIndexes[te++]+o);const S=this.length+o;if(this.sortedIndexes.length>0&&j.length===0&&S>0){const T=this.sortedIndexes.find(O=>O>=_)??S-1;j.push(Math.min(T,S-1))}this.renderer.splice(_,K,z.length),this._set(j,j),this.length=S}renderIndex(_,K){K.classList.toggle(this._trait,this.contains(_))}unrender(_){_.classList.remove(this._trait)}set(_,K){return this._set(_,[..._].sort(Oe),K)}_set(_,K,z){const o=this.indexes,F=this.sortedIndexes;this.indexes=_,this.sortedIndexes=K;const j=Te(F,_);return this.renderer.renderIndexes(j),this._onChange.fire({indexes:_,browserEvent:z}),o}get(){return this.indexes}contains(_){return(0,c.binarySearch)(this.sortedIndexes,_,Oe)>=0}dispose(){(0,e.dispose)(this._onChange)}}qe([P.memoize],C.prototype,"renderer",null);class f extends C{constructor(_){super("selected"),this.setAriaSelected=_}renderIndex(_,K){super.renderIndex(_,K),this.setAriaSelected&&(this.contains(_)?K.setAttribute("aria-selected","true"):K.setAttribute("aria-selected","false"))}}class D{constructor(_,K,z){this.trait=_,this.view=K,this.identityProvider=z}splice(_,K,z){if(!this.identityProvider)return this.trait.splice(_,K,new Array(z.length).fill(!1));const o=this.trait.get().map(te=>this.identityProvider.getId(this.view.element(te)).toString());if(o.length===0)return this.trait.splice(_,K,new Array(z.length).fill(!1));const F=new Set(o),j=z.map(te=>F.has(this.identityProvider.getId(te).toString()));this.trait.splice(_,K,j)}}function M(V){return V.tagName==="INPUT"||V.tagName==="TEXTAREA"}t.isInputElement=M;function R(V){return V.classList.contains("monaco-editor")?!0:V.classList.contains("monaco-list")||!V.parentElement?!1:R(V.parentElement)}t.isMonacoEditor=R;function g(V){return V.tagName==="A"&&V.classList.contains("monaco-button")||V.tagName==="DIV"&&V.classList.contains("monaco-button-dropdown")?!0:V.classList.contains("monaco-list")||!V.parentElement?!1:g(V.parentElement)}t.isButton=g;class m{get onKeyDown(){return this.disposables.add(r.Event.chain(this.disposables.add(new I.DomEmitter(this.view.domNode,"keydown")).event).filter(_=>!M(_.target)).map(_=>new i.StandardKeyboardEvent(_)))}constructor(_,K,z){this.list=_,this.view=K,this.disposables=new e.DisposableStore,this.multipleSelectionDisposables=new e.DisposableStore,this.onKeyDown.filter(o=>o.keyCode===3).on(this.onEnter,this,this.disposables),this.onKeyDown.filter(o=>o.keyCode===16).on(this.onUpArrow,this,this.disposables),this.onKeyDown.filter(o=>o.keyCode===18).on(this.onDownArrow,this,this.disposables),this.onKeyDown.filter(o=>o.keyCode===11).on(this.onPageUpArrow,this,this.disposables),this.onKeyDown.filter(o=>o.keyCode===12).on(this.onPageDownArrow,this,this.disposables),this.onKeyDown.filter(o=>o.keyCode===9).on(this.onEscape,this,this.disposables),z.multipleSelectionSupport!==!1&&this.onKeyDown.filter(o=>(n.isMacintosh?o.metaKey:o.ctrlKey)&&o.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables)}updateOptions(_){_.multipleSelectionSupport!==void 0&&(this.multipleSelectionDisposables.clear(),_.multipleSelectionSupport&&this.onKeyDown.filter(K=>(n.isMacintosh?K.metaKey:K.ctrlKey)&&K.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables))}onEnter(_){_.preventDefault(),_.stopPropagation(),this.list.setSelection(this.list.getFocus(),_.browserEvent)}onUpArrow(_){_.preventDefault(),_.stopPropagation(),this.list.focusPrevious(1,!1,_.browserEvent);const K=this.list.getFocus()[0];this.list.setAnchor(K),this.list.reveal(K),this.view.domNode.focus()}onDownArrow(_){_.preventDefault(),_.stopPropagation(),this.list.focusNext(1,!1,_.browserEvent);const K=this.list.getFocus()[0];this.list.setAnchor(K),this.list.reveal(K),this.view.domNode.focus()}onPageUpArrow(_){_.preventDefault(),_.stopPropagation(),this.list.focusPreviousPage(_.browserEvent);const K=this.list.getFocus()[0];this.list.setAnchor(K),this.list.reveal(K),this.view.domNode.focus()}onPageDownArrow(_){_.preventDefault(),_.stopPropagation(),this.list.focusNextPage(_.browserEvent);const K=this.list.getFocus()[0];this.list.setAnchor(K),this.list.reveal(K),this.view.domNode.focus()}onCtrlA(_){_.preventDefault(),_.stopPropagation(),this.list.setSelection((0,c.range)(this.list.length),_.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(_){this.list.getSelection().length&&(_.preventDefault(),_.stopPropagation(),this.list.setSelection([],_.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}qe([P.memoize],m.prototype,"onKeyDown",null);var L;(function(V){V[V.Automatic=0]="Automatic",V[V.Trigger=1]="Trigger"})(L||(t.TypeNavigationMode=L={}));var k;(function(V){V[V.Idle=0]="Idle",V[V.Typing=1]="Typing"})(k||(k={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(V){return V.ctrlKey||V.metaKey||V.altKey?!1:V.keyCode>=31&&V.keyCode<=56||V.keyCode>=21&&V.keyCode<=30||V.keyCode>=98&&V.keyCode<=107||V.keyCode>=85&&V.keyCode<=95}};class A{constructor(_,K,z,o,F){this.list=_,this.view=K,this.keyboardNavigationLabelProvider=z,this.keyboardNavigationEventFilter=o,this.delegate=F,this.enabled=!1,this.state=k.Idle,this.mode=L.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new e.DisposableStore,this.disposables=new e.DisposableStore,this.updateOptions(_.options)}updateOptions(_){_.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=_.typeNavigationMode??L.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let _=!1;const K=this.enabledDisposables.add(r.Event.chain(this.enabledDisposables.add(new I.DomEmitter(this.view.domNode,"keydown")).event)).filter(F=>!M(F.target)).filter(()=>this.mode===L.Automatic||this.triggered).map(F=>new i.StandardKeyboardEvent(F)).filter(F=>_||this.keyboardNavigationEventFilter(F)).filter(F=>this.delegate.mightProducePrintableCharacter(F)).forEach(F=>E.EventHelper.stop(F,!0)).map(F=>F.browserEvent.key).event,z=r.Event.debounce(K,()=>null,800,void 0,void 0,void 0,this.enabledDisposables);r.Event.reduce(r.Event.any(K,z),(F,j)=>j===null?null:(F||"")+j,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),z(this.onClear,this,this.enabledDisposables),K(()=>_=!0,void 0,this.enabledDisposables),z(()=>_=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){this.enabled&&(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const _=this.list.getFocus();if(_.length>0&&_[0]===this.previouslyFocused){const K=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(_[0]));K&&(0,w.alert)(K)}this.previouslyFocused=-1}onInput(_){if(!_){this.state=k.Idle,this.triggered=!1;return}const K=this.list.getFocus(),z=K.length>0?K[0]:0,o=this.state===k.Idle?1:0;this.state=k.Typing;for(let F=0;F<this.list.length;F++){const j=(z+F+o)%this.list.length,te=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(j)),S=te&&te.toString();if(typeof S>"u"||(0,l.matchesPrefix)(_,S)){this.previouslyFocused=z,this.list.setFocus([j]),this.list.reveal(j);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class H{constructor(_,K){this.list=_,this.view=K,this.disposables=new e.DisposableStore,this.disposables.add(r.Event.chain(this.disposables.add(new I.DomEmitter(K.domNode,"keydown")).event)).filter(o=>!M(o.target)).map(o=>new i.StandardKeyboardEvent(o)).filter(o=>o.keyCode===2&&!o.ctrlKey&&!o.metaKey&&!o.shiftKey&&!o.altKey).on(this.onTab,this,this.disposables)}onTab(_){if(_.target!==this.view.domNode)return;const K=this.list.getFocus();if(K.length===0)return;const z=this.view.domElement(K[0]);if(!z)return;const o=z.querySelector("[tabIndex]");if(!o||!(o instanceof HTMLElement)||o.tabIndex===-1)return;const F=window.getComputedStyle(o);F.visibility==="hidden"||F.display==="none"||(_.preventDefault(),_.stopPropagation(),o.focus())}dispose(){this.disposables.dispose()}}function G(V){return n.isMacintosh?V.browserEvent.metaKey:V.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=G;function ne(V){return V.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=ne;function se(V){return V instanceof MouseEvent&&V.button===2}const de={isSelectionSingleChangeEvent:G,isSelectionRangeChangeEvent:ne};class ue{constructor(_){this.list=_,this.disposables=new e.DisposableStore,this._onPointer=new r.Emitter,this.onPointer=this._onPointer.event,_.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||de),this.mouseSupport=typeof _.options.mouseSupport>"u"||!!_.options.mouseSupport,this.mouseSupport&&(_.onMouseDown(this.onMouseDown,this,this.disposables),_.onContextMenu(this.onContextMenu,this,this.disposables),_.onMouseDblClick(this.onDoubleClick,this,this.disposables),_.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(W.Gesture.addTarget(_.getHTMLElement()))),r.Event.any(_.onMouseClick,_.onMouseMiddleClick,_.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(_){_.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,_.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||de))}isSelectionSingleChangeEvent(_){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(_):!1}isSelectionRangeChangeEvent(_){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(_):!1}isSelectionChangeEvent(_){return this.isSelectionSingleChangeEvent(_)||this.isSelectionRangeChangeEvent(_)}onMouseDown(_){R(_.browserEvent.target)||document.activeElement!==_.browserEvent.target&&this.list.domFocus()}onContextMenu(_){if(M(_.browserEvent.target)||R(_.browserEvent.target))return;const K=typeof _.index>"u"?[]:[_.index];this.list.setFocus(K,_.browserEvent)}onViewPointer(_){if(!this.mouseSupport||M(_.browserEvent.target)||R(_.browserEvent.target)||_.browserEvent.isHandledByList)return;_.browserEvent.isHandledByList=!0;const K=_.index;if(typeof K>"u"){this.list.setFocus([],_.browserEvent),this.list.setSelection([],_.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionRangeChangeEvent(_))return this.changeSelection(_);if(this.isSelectionChangeEvent(_))return this.changeSelection(_);this.list.setFocus([K],_.browserEvent),this.list.setAnchor(K),se(_.browserEvent)||this.list.setSelection([K],_.browserEvent),this._onPointer.fire(_)}onDoubleClick(_){if(M(_.browserEvent.target)||R(_.browserEvent.target)||this.isSelectionChangeEvent(_)||_.browserEvent.isHandledByList)return;_.browserEvent.isHandledByList=!0;const K=this.list.getFocus();this.list.setSelection(K,_.browserEvent)}changeSelection(_){const K=_.index;let z=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(_)){typeof z>"u"&&(z=this.list.getFocus()[0]??K,this.list.setAnchor(z));const o=Math.min(z,K),F=Math.max(z,K),j=(0,c.range)(o,F+1),te=this.list.getSelection(),S=ye(Te(te,[z]),z);if(S.length===0)return;const T=Te(j,Me(te,S));this.list.setSelection(T,_.browserEvent),this.list.setFocus([K],_.browserEvent)}else if(this.isSelectionSingleChangeEvent(_)){const o=this.list.getSelection(),F=o.filter(j=>j!==K);this.list.setFocus([K]),this.list.setAnchor(K),o.length===F.length?this.list.setSelection([...F,K],_.browserEvent):this.list.setSelection(F,_.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=ue;class re{constructor(_,K){this.styleElement=_,this.selectorSuffix=K}style(_){const K=this.selectorSuffix&&`.${this.selectorSuffix}`,z=[];_.listBackground&&z.push(`.monaco-list${K} .monaco-list-rows { background: ${_.listBackground}; }`),_.listFocusBackground&&(z.push(`.monaco-list${K}:focus .monaco-list-row.focused { background-color: ${_.listFocusBackground}; }`),z.push(`.monaco-list${K}:focus .monaco-list-row.focused:hover { background-color: ${_.listFocusBackground}; }`)),_.listFocusForeground&&z.push(`.monaco-list${K}:focus .monaco-list-row.focused { color: ${_.listFocusForeground}; }`),_.listActiveSelectionBackground&&(z.push(`.monaco-list${K}:focus .monaco-list-row.selected { background-color: ${_.listActiveSelectionBackground}; }`),z.push(`.monaco-list${K}:focus .monaco-list-row.selected:hover { background-color: ${_.listActiveSelectionBackground}; }`)),_.listActiveSelectionForeground&&z.push(`.monaco-list${K}:focus .monaco-list-row.selected { color: ${_.listActiveSelectionForeground}; }`),_.listActiveSelectionIconForeground&&z.push(`.monaco-list${K}:focus .monaco-list-row.selected .codicon { color: ${_.listActiveSelectionIconForeground}; }`),_.listFocusAndSelectionBackground&&z.push(`
				.monaco-drag-image,
				.monaco-list${K}:focus .monaco-list-row.selected.focused { background-color: ${_.listFocusAndSelectionBackground}; }
			`),_.listFocusAndSelectionForeground&&z.push(`
				.monaco-drag-image,
				.monaco-list${K}:focus .monaco-list-row.selected.focused { color: ${_.listFocusAndSelectionForeground}; }
			`),_.listInactiveFocusForeground&&(z.push(`.monaco-list${K} .monaco-list-row.focused { color:  ${_.listInactiveFocusForeground}; }`),z.push(`.monaco-list${K} .monaco-list-row.focused:hover { color:  ${_.listInactiveFocusForeground}; }`)),_.listInactiveSelectionIconForeground&&z.push(`.monaco-list${K} .monaco-list-row.focused .codicon { color:  ${_.listInactiveSelectionIconForeground}; }`),_.listInactiveFocusBackground&&(z.push(`.monaco-list${K} .monaco-list-row.focused { background-color:  ${_.listInactiveFocusBackground}; }`),z.push(`.monaco-list${K} .monaco-list-row.focused:hover { background-color:  ${_.listInactiveFocusBackground}; }`)),_.listInactiveSelectionBackground&&(z.push(`.monaco-list${K} .monaco-list-row.selected { background-color:  ${_.listInactiveSelectionBackground}; }`),z.push(`.monaco-list${K} .monaco-list-row.selected:hover { background-color:  ${_.listInactiveSelectionBackground}; }`)),_.listInactiveSelectionForeground&&z.push(`.monaco-list${K} .monaco-list-row.selected { color: ${_.listInactiveSelectionForeground}; }`),_.listHoverBackground&&z.push(`.monaco-list${K}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${_.listHoverBackground}; }`),_.listHoverForeground&&z.push(`.monaco-list${K}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${_.listHoverForeground}; }`);const o=(0,E.asCssValueWithDefault)(_.listFocusAndSelectionOutline,(0,E.asCssValueWithDefault)(_.listSelectionOutline,_.listFocusOutline??""));o&&z.push(`.monaco-list${K}:focus .monaco-list-row.focused.selected { outline: 1px solid ${o}; outline-offset: -1px;}`),_.listFocusOutline&&z.push(`
				.monaco-drag-image,
				.monaco-list${K}:focus .monaco-list-row.focused { outline: 1px solid ${_.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${K}.last-focused .monaco-list-row.focused { outline: 1px solid ${_.listFocusOutline}; outline-offset: -1px; }
			`);const F=(0,E.asCssValueWithDefault)(_.listSelectionOutline,_.listInactiveFocusOutline??"");F&&z.push(`.monaco-list${K} .monaco-list-row.focused.selected { outline: 1px dotted ${F}; outline-offset: -1px; }`),_.listSelectionOutline&&z.push(`.monaco-list${K} .monaco-list-row.selected { outline: 1px dotted ${_.listSelectionOutline}; outline-offset: -1px; }`),_.listInactiveFocusOutline&&z.push(`.monaco-list${K} .monaco-list-row.focused { outline: 1px dotted ${_.listInactiveFocusOutline}; outline-offset: -1px; }`),_.listHoverOutline&&z.push(`.monaco-list${K} .monaco-list-row:hover { outline: 1px dashed ${_.listHoverOutline}; outline-offset: -1px; }`),_.listDropBackground&&z.push(`
				.monaco-list${K}.drop-target,
				.monaco-list${K} .monaco-list-rows.drop-target,
				.monaco-list${K} .monaco-list-row.drop-target { background-color: ${_.listDropBackground} !important; color: inherit !important; }
			`),_.tableColumnsBorder&&z.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${_.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),_.tableOddRowsBackgroundColor&&z.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${_.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=z.join(`
`)}}t.DefaultStyleController=re,t.unthemedListStyles={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:d.Color.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:d.Color.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:d.Color.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const le={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function ye(V,_){const K=V.indexOf(_);if(K===-1)return[];const z=[];let o=K-1;for(;o>=0&&V[o]===_-(K-o);)z.push(V[o--]);for(z.reverse(),o=K;o<V.length&&V[o]===_+(o-K);)z.push(V[o++]);return z}function Te(V,_){const K=[];let z=0,o=0;for(;z<V.length||o<_.length;)if(z>=V.length)K.push(_[o++]);else if(o>=_.length)K.push(V[z++]);else if(V[z]===_[o]){K.push(V[z]),z++,o++;continue}else V[z]<_[o]?K.push(V[z++]):K.push(_[o++]);return K}function Me(V,_){const K=[];let z=0,o=0;for(;z<V.length||o<_.length;)if(z>=V.length)K.push(_[o++]);else if(o>=_.length)K.push(V[z++]);else if(V[z]===_[o]){z++,o++;continue}else V[z]<_[o]?K.push(V[z++]):o++;return K}const Oe=(V,_)=>V-_;class ce{constructor(_,K){this._templateId=_,this.renderers=K}get templateId(){return this._templateId}renderTemplate(_){return this.renderers.map(K=>K.renderTemplate(_))}renderElement(_,K,z,o){let F=0;for(const j of this.renderers)j.renderElement(_,K,z[F++],o)}disposeElement(_,K,z,o){let F=0;for(const j of this.renderers)j.disposeElement?.(_,K,z[F],o),F+=1}disposeTemplate(_){let K=0;for(const z of this.renderers)z.disposeTemplate(_[K++])}}class ie{constructor(_){this.accessibilityProvider=_,this.templateId="a18n"}renderTemplate(_){return _}renderElement(_,K,z){const o=this.accessibilityProvider.getAriaLabel(_);o?z.setAttribute("aria-label",o):z.removeAttribute("aria-label");const F=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(_);typeof F=="number"?z.setAttribute("aria-level",`${F}`):z.removeAttribute("aria-level")}disposeTemplate(_){}}class q{constructor(_,K){this.list=_,this.dnd=K}getDragElements(_){const K=this.list.getSelectedElements();return K.indexOf(_)>-1?K:[_]}getDragURI(_){return this.dnd.getDragURI(_)}getDragLabel(_,K){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(_,K)}onDragStart(_,K){this.dnd.onDragStart?.(_,K)}onDragOver(_,K,z,o){return this.dnd.onDragOver(_,K,z,o)}onDragLeave(_,K,z,o){this.dnd.onDragLeave?.(_,K,z,o)}onDragEnd(_){this.dnd.onDragEnd?.(_)}drop(_,K,z,o){this.dnd.drop(_,K,z,o)}}class ${get onDidChangeFocus(){return r.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),_=>this.toListEvent(_),this.disposables)}get onDidChangeSelection(){return r.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),_=>this.toListEvent(_),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let _=!1;const K=this.disposables.add(r.Event.chain(this.disposables.add(new I.DomEmitter(this.view.domNode,"keydown")).event)).map(F=>new i.StandardKeyboardEvent(F)).filter(F=>_=F.keyCode===58||F.shiftKey&&F.keyCode===68).map(F=>E.EventHelper.stop(F,!0)).filter(()=>!1).event,z=this.disposables.add(r.Event.chain(this.disposables.add(new I.DomEmitter(this.view.domNode,"keyup")).event)).forEach(()=>_=!1).map(F=>new i.StandardKeyboardEvent(F)).filter(F=>F.keyCode===58||F.shiftKey&&F.keyCode===68).map(F=>E.EventHelper.stop(F,!0)).map(({browserEvent:F})=>{const j=this.getFocus(),te=j.length?j[0]:void 0,S=typeof te<"u"?this.view.element(te):void 0,T=typeof te<"u"?this.view.domElement(te):this.view.domNode;return{index:te,element:S,anchor:T,browserEvent:F}}).event,o=this.disposables.add(r.Event.chain(this.view.onContextMenu)).filter(F=>!_).map(({element:F,index:j,browserEvent:te})=>({element:F,index:j,anchor:{x:te.pageX+1,y:te.pageY},browserEvent:te})).event;return r.Event.any(K,z,o)}get onKeyDown(){return this.disposables.add(new I.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new I.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new I.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return r.Event.signal(this.disposables.add(new I.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return r.Event.signal(this.disposables.add(new I.DomEmitter(this.view.domNode,"blur",!0)).event)}constructor(_,K,z,o,F=le){this.user=_,this._options=F,this.focus=new C("focused"),this.anchor=new C("anchor"),this.eventBufferer=new r.EventBufferer,this._ariaLabel="",this.disposables=new e.DisposableStore,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event;const j=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new f(j!=="listbox");const te=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=F.accessibilityProvider,this.accessibilityProvider&&(te.push(new ie(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),o=o.map(T=>new ce(T.templateId,[...te,T]));const S={...F,dnd:F.dnd&&new q(this,F.dnd)};if(this.view=this.createListView(K,z,o,S),this.view.domNode.setAttribute("role",j),F.styleController)this.styleController=F.styleController(this.view.domId);else{const T=(0,E.createStyleSheet)(this.view.domNode);this.styleController=new re(T,this.view.domId)}if(this.spliceable=new y.CombinedSpliceable([new D(this.focus,this.view,F.identityProvider),new D(this.selection,this.view,F.identityProvider),new D(this.anchor,this.view,F.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new H(this,this.view)),(typeof F.keyboardSupport!="boolean"||F.keyboardSupport)&&(this.keyboardController=new m(this,this.view,F),this.disposables.add(this.keyboardController)),F.keyboardNavigationLabelProvider){const T=F.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new A(this,this.view,F.keyboardNavigationLabelProvider,F.keyboardNavigationEventFilter??(()=>!0),T),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(F),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}createListView(_,K,z,o){return new p.ListView(_,K,z,o)}createMouseController(_){return new ue(this)}updateOptions(_={}){this._options={...this._options,..._},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(_),this.keyboardController?.updateOptions(_),this.view.updateOptions(_)}get options(){return this._options}splice(_,K,z=[]){if(_<0||_>this.view.length)throw new s.ListError(this.user,`Invalid start index: ${_}`);if(K<0)throw new s.ListError(this.user,`Invalid delete count: ${K}`);K===0&&z.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(_,K,z))}updateWidth(_){this.view.updateWidth(_)}updateElementHeight(_,K){this.view.updateElementHeight(_,K,null)}rerender(){this.view.rerender()}element(_){return this.view.element(_)}indexOf(_){return this.view.indexOf(_)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.getScrollTop()}set scrollTop(_){this.view.setScrollTop(_)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(_){this.view.setScrollLeft(_)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(_){this._ariaLabel=_,this.view.domNode.setAttribute("aria-label",_)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(_,K){this.view.layout(_,K)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(_,K){for(const z of _)if(z<0||z>=this.length)throw new s.ListError(this.user,`Invalid index ${z}`);this.selection.set(_,K)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(_=>this.view.element(_))}setAnchor(_){if(typeof _>"u"){this.anchor.set([]);return}if(_<0||_>=this.length)throw new s.ListError(this.user,`Invalid index ${_}`);this.anchor.set([_])}getAnchor(){return(0,c.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const _=this.getAnchor();return typeof _>"u"?void 0:this.element(_)}setFocus(_,K){for(const z of _)if(z<0||z>=this.length)throw new s.ListError(this.user,`Invalid index ${z}`);this.focus.set(_,K)}focusNext(_=1,K=!1,z,o){if(this.length===0)return;const F=this.focus.get(),j=this.findNextIndex(F.length>0?F[0]+_:0,K,o);j>-1&&this.setFocus([j],z)}focusPrevious(_=1,K=!1,z,o){if(this.length===0)return;const F=this.focus.get(),j=this.findPreviousIndex(F.length>0?F[0]-_:0,K,o);j>-1&&this.setFocus([j],z)}async focusNextPage(_,K){let z=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);z=z===0?0:z-1;const o=this.getFocus()[0];if(o!==z&&(o===void 0||z>o)){const F=this.findPreviousIndex(z,!1,K);F>-1&&o!==F?this.setFocus([F],_):this.setFocus([z],_)}else{const F=this.view.getScrollTop();let j=F+this.view.renderHeight;z>o&&(j-=this.view.elementHeight(z)),this.view.setScrollTop(j),this.view.getScrollTop()!==F&&(this.setFocus([]),await(0,u.timeout)(0),await this.focusNextPage(_,K))}}async focusPreviousPage(_,K){let z;const o=this.view.getScrollTop();o===0?z=this.view.indexAt(o):z=this.view.indexAfter(o-1);const F=this.getFocus()[0];if(F!==z&&(F===void 0||F>=z)){const j=this.findNextIndex(z,!1,K);j>-1&&F!==j?this.setFocus([j],_):this.setFocus([z],_)}else{const j=o;this.view.setScrollTop(o-this.view.renderHeight),this.view.getScrollTop()!==j&&(this.setFocus([]),await(0,u.timeout)(0),await this.focusPreviousPage(_,K))}}focusLast(_,K){if(this.length===0)return;const z=this.findPreviousIndex(this.length-1,!1,K);z>-1&&this.setFocus([z],_)}focusFirst(_,K){this.focusNth(0,_,K)}focusNth(_,K,z){if(this.length===0)return;const o=this.findNextIndex(_,!1,z);o>-1&&this.setFocus([o],K)}findNextIndex(_,K=!1,z){for(let o=0;o<this.length;o++){if(_>=this.length&&!K)return-1;if(_=_%this.length,!z||z(this.element(_)))return _;_++}return-1}findPreviousIndex(_,K=!1,z){for(let o=0;o<this.length;o++){if(_<0&&!K)return-1;if(_=(this.length+_%this.length)%this.length,!z||z(this.element(_)))return _;_--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(_=>this.view.element(_))}reveal(_,K){if(_<0||_>=this.length)throw new s.ListError(this.user,`Invalid index ${_}`);const z=this.view.getScrollTop(),o=this.view.elementTop(_),F=this.view.elementHeight(_);if((0,h.isNumber)(K)){const j=F-this.view.renderHeight;this.view.setScrollTop(j*(0,a.clamp)(K,0,1)+o)}else{const j=o+F,te=z+this.view.renderHeight;o<z&&j>=te||(o<z||j>=te&&F>=this.view.renderHeight?this.view.setScrollTop(o):j>=te&&this.view.setScrollTop(j-this.view.renderHeight))}}getRelativeTop(_){if(_<0||_>=this.length)throw new s.ListError(this.user,`Invalid index ${_}`);const K=this.view.getScrollTop(),z=this.view.elementTop(_),o=this.view.elementHeight(_);if(z<K||z+o>K+this.view.renderHeight)return null;const F=o-this.view.renderHeight;return Math.abs((K-z)/F)}isDOMFocused(){return this.view.domNode===document.activeElement}getHTMLElement(){return this.view.domNode}getElementID(_){return this.view.getElementDomId(_)}style(_){this.styleController.style(_)}toListEvent({indexes:_,browserEvent:K}){return{indexes:_,elements:_.map(z=>this.view.element(z)),browserEvent:K}}_onFocusChange(){const _=this.focus.get();this.view.domNode.classList.toggle("element-focused",_.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const _=this.focus.get();if(_.length>0){let K;this.accessibilityProvider?.getActiveDescendantId&&(K=this.accessibilityProvider.getActiveDescendantId(this.view.element(_[0]))),this.view.domNode.setAttribute("aria-activedescendant",K||this.view.getElementDomId(_[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const _=this.selection.get();this.view.domNode.classList.toggle("selection-none",_.length===0),this.view.domNode.classList.toggle("selection-single",_.length===1),this.view.domNode.classList.toggle("selection-multiple",_.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}t.List=$,qe([P.memoize],$.prototype,"onDidChangeFocus",null),qe([P.memoize],$.prototype,"onDidChangeSelection",null),qe([P.memoize],$.prototype,"onContextMenu",null),qe([P.memoize],$.prototype,"onKeyDown",null),qe([P.memoize],$.prototype,"onKeyUp",null),qe([P.memoize],$.prototype,"onKeyPress",null),qe([P.memoize],$.prototype,"onDidFocus",null),qe([P.memoize],$.prototype,"onDidBlur",null)}),define(ge[59],me([1,0,7,33,35,10,15]),function(ee,t,E,I,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var y;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(y||(t.MarkdownStringTextNewlineStyle=y={}));class c{constructor(h="",s=!1){if(this.value=h,typeof this.value!="string")throw(0,E.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(h,s=0){return this.value+=r(this.supportThemeIcons?(0,I.escapeIcons)(h):h).replace(/([ \t]+)/g,(p,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,s){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}appendLink(h,s,p){return this.value+="[",this.value+=this._escape(s,"]"),this.value+="](",this.value+=this._escape(String(h),")"),p&&(this.value+=` "${this._escape(this._escape(p,'"'),")")}"`),this.value+=")",this}_escape(h,s){const p=new RegExp((0,W.escapeRegExpCharacters)(s),"g");return h.replace(p,(v,C)=>h.charAt(C-1)!=="\\"?`\\${v}`:v)}}t.MarkdownString=c;function u(n){return d(n)?!n.value:Array.isArray(n)?n.every(u):!0}t.isEmptyMarkdownString=u;function d(n){return n instanceof c?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||typeof n.isTrusted=="object"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}t.isMarkdownString=d;function P(n,h){return n===h?!0:!n||!h?!1:n.value===h.value&&n.isTrusted===h.isTrusted&&n.supportThemeIcons===h.supportThemeIcons&&n.supportHtml===h.supportHtml&&(n.baseUri===h.baseUri||!!n.baseUri&&!!h.baseUri&&(0,i.isEqual)(w.URI.from(n.baseUri),w.URI.from(h.baseUri)))}t.markdownStringEqual=P;function r(n){return n.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=r;function l(n){return n.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=l;function e(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.removeMarkdownEscapes=e;function a(n){const h=[],s=n.split("|").map(v=>v.trim());n=s[0];const p=s[1];if(p){const v=/height=(\d+)/.exec(p),C=/width=(\d+)/.exec(p),f=v?v[1]:"",D=C?C[1]:"",M=isFinite(parseInt(D)),R=isFinite(parseInt(f));M&&h.push(`width="${D}"`),R&&h.push(`height="${f}"`)}return{href:n,dimensions:h}}t.parseHrefAndDimensions=a}),define(ge[122],me([1,0,4,114,20,52,14,21,115,7,3,59,33,73,30,2,76,50,28,48,35,10,15]),function(ee,t,E,I,i,W,w,y,c,u,d,P,r,l,e,a,n,h,s,p,v,C,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fillInIncompleteTokens=t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.allowedMarkdownAttr=t.renderMarkdown=void 0;const D=Object.freeze({image:($,V,_)=>{let K=[],z=[];return $&&({href:$,dimensions:K}=(0,P.parseHrefAndDimensions)($),z.push(`src="${(0,P.escapeDoubleQuotes)($)}"`)),_&&z.push(`alt="${(0,P.escapeDoubleQuotes)(_)}"`),V&&z.push(`title="${(0,P.escapeDoubleQuotes)(V)}"`),K.length&&(z=z.concat(K)),"<img "+z.join(" ")+">"},paragraph:$=>`<p>${$}</p>`,link:($,V,_)=>typeof $!="string"?"":($===_&&(_=(0,P.removeMarkdownEscapes)(_)),V=typeof V=="string"?(0,P.escapeDoubleQuotes)((0,P.removeMarkdownEscapes)(V)):"",$=(0,P.removeMarkdownEscapes)($),$=$.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${$}" title="${V||$}">${_}</a>`)});function M($,V={},_={}){const K=new a.DisposableStore;let z=!1;const o=(0,W.createElement)(V),F=function(N){let U;try{U=(0,h.parse)(decodeURIComponent(N))}catch{}return U?(U=(0,p.cloneAndChange)(U,Y=>{if($.uris&&$.uris[Y])return f.URI.revive($.uris[Y])}),encodeURIComponent(JSON.stringify(U))):N},j=function(N,U){const Y=$.uris&&$.uris[N];let J=f.URI.revive(Y);return U?N.startsWith(s.Schemas.data+":")?N:(J||(J=f.URI.parse(N)),s.FileAccess.uriToBrowserUri(J).toString(!0)):!J||f.URI.parse(N).toString()===J.toString()?N:(J.query&&(J=J.with({query:F(J.query)})),J.toString())},te=new n.marked.Renderer;te.image=D.image,te.link=D.link,te.paragraph=D.paragraph;const S=[],T=[];if(V.codeBlockRendererSync?te.code=(N,U)=>{const Y=l.defaultGenerator.nextId(),J=V.codeBlockRendererSync(R(U),N);return T.push([Y,J]),`<div class="code" data-code="${Y}">${(0,C.escape)(N)}</div>`}:V.codeBlockRenderer&&(te.code=(N,U)=>{const Y=l.defaultGenerator.nextId(),J=V.codeBlockRenderer(R(U),N);return S.push(J.then(oe=>[Y,oe])),`<div class="code" data-code="${Y}">${(0,C.escape)(N)}</div>`}),V.actionHandler){const N=function(J){let oe=J.target;if(!(oe.tagName!=="A"&&(oe=oe.parentElement,!oe||oe.tagName!=="A")))try{let be=oe.dataset.href;be&&($.baseUri&&(be=g(f.URI.from($.baseUri),be)),V.actionHandler.callback(be,J))}catch(be){(0,u.onUnexpectedError)(be)}finally{J.preventDefault()}},U=V.actionHandler.disposables.add(new i.DomEmitter(o,"click")),Y=V.actionHandler.disposables.add(new i.DomEmitter(o,"auxclick"));V.actionHandler.disposables.add(d.Event.any(U.event,Y.event)(J=>{const oe=new y.StandardMouseEvent(J);!oe.leftButton&&!oe.middleButton||N(oe)})),V.actionHandler.disposables.add(E.addDisposableListener(o,"keydown",J=>{const oe=new w.StandardKeyboardEvent(J);!oe.equals(10)&&!oe.equals(3)||N(oe)}))}$.supportHtml||(_.sanitizer=N=>($.isTrusted?N.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?N:"",_.sanitize=!0,_.silent=!0),_.renderer=te;let O=$.value??"";O.length>1e5&&(O=`${O.substr(0,1e5)}\u2026`),$.supportThemeIcons&&(O=(0,r.markdownEscapeEscapedIcons)(O));let b;if(V.fillInIncompleteTokens){const N={...n.marked.defaults,..._},U=n.marked.lexer(O,N),Y=de(U);b=n.marked.parser(Y,N)}else b=n.marked.parse(O,_);$.supportThemeIcons&&(b=(0,c.renderLabelWithIcons)(b).map(U=>typeof U=="string"?U:U.outerHTML).join(""));const B=new DOMParser().parseFromString(m($,b),"text/html");if(B.body.querySelectorAll("img").forEach(N=>{const U=N.getAttribute("src");if(U){let Y=U;try{$.baseUri&&(Y=g(f.URI.from($.baseUri),Y))}catch{}N.src=j(Y,!0)}}),B.body.querySelectorAll("a").forEach(N=>{const U=N.getAttribute("href");if(N.setAttribute("href",""),!U||/^data:|javascript:/i.test(U)||/^command:/i.test(U)&&!$.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(U))N.replaceWith(...N.childNodes);else{let Y=j(U,!1);$.baseUri&&(Y=g(f.URI.from($.baseUri),U)),N.dataset.href=Y}}),o.innerHTML=m($,B.body.innerHTML),S.length>0)Promise.all(S).then(N=>{if(z)return;const U=new Map(N),Y=o.querySelectorAll("div[data-code]");for(const J of Y){const oe=U.get(J.dataset.code??"");oe&&E.reset(J,oe)}V.asyncRenderCallback?.()});else if(T.length>0){const N=new Map(T),U=o.querySelectorAll("div[data-code]");for(const Y of U){const J=N.get(Y.dataset.code??"");J&&E.reset(Y,J)}}if(V.asyncRenderCallback)for(const N of o.getElementsByTagName("img")){const U=K.add(E.addDisposableListener(N,"load",()=>{U.dispose(),V.asyncRenderCallback()}))}return{element:o,dispose:()=>{z=!0,K.dispose()}}}t.renderMarkdown=M;function R($){if(!$)return"";const V=$.split(/[\s+|:|,|\{|\?]/,1);return V.length?V[0]:$}function g($,V){return/^\w[\w\d+.-]*:/.test(V)?V:$.path.endsWith("/")?(0,v.resolvePath)($,V).toString():(0,v.resolvePath)((0,v.dirname)($),V).toString()}function m($,V){const{config:_,allowedSchemes:K}=L($);I.addHook("uponSanitizeAttribute",(o,F)=>{if(F.attrName==="style"||F.attrName==="class"){if(o.tagName==="SPAN"){if(F.attrName==="style"){F.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(F.attrValue);return}else if(F.attrName==="class"){F.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(F.attrValue);return}}F.keepAttr=!1;return}});const z=E.hookDomPurifyHrefAndSrcSanitizer(K);try{return I.sanitize(V,{..._,RETURN_TRUSTED_TYPE:!0})}finally{I.removeHook("uponSanitizeAttribute"),z.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function L($){const V=[s.Schemas.http,s.Schemas.https,s.Schemas.mailto,s.Schemas.data,s.Schemas.file,s.Schemas.vscodeFileResource,s.Schemas.vscodeRemote,s.Schemas.vscodeRemoteResource];return $.isTrusted&&V.push(s.Schemas.command),{config:{ALLOWED_TAGS:[...E.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:V}}function k($){return typeof $=="string"?$:A($)}t.renderStringAsPlaintext=k;function A($){let V=$.value??"";V.length>1e5&&(V=`${V.substr(0,1e5)}\u2026`);const _=n.marked.parse(V,{renderer:G.value}).replace(/&(#\d+|[a-zA-Z]+);/g,K=>H.get(K)??K);return m({isTrusted:!1},_).toString()}t.renderMarkdownAsPlaintext=A;const H=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),G=new e.Lazy(()=>{const $=new n.marked.Renderer;return $.code=V=>V,$.blockquote=V=>V,$.html=V=>"",$.heading=(V,_,K)=>V+`
`,$.hr=()=>"",$.list=(V,_)=>V,$.listitem=V=>V+`
`,$.paragraph=V=>V+`
`,$.table=(V,_)=>V+_+`
`,$.tablerow=V=>V,$.tablecell=(V,_)=>V+" ",$.strong=V=>V,$.em=V=>V,$.codespan=V=>V,$.br=()=>`
`,$.del=V=>V,$.image=(V,_,K)=>"",$.text=V=>V,$.link=(V,_,K)=>K,$});function ne($){let V="";return $.forEach(_=>{V+=_.raw}),V}function se($){for(const V of $.tokens)if(V.type==="text"){const _=V.raw.split(`
`),K=_[_.length-1];if(K.includes("`"))return re($);if(K.includes("**"))return Oe($);if(K.match(/\*\w/))return le($);if(K.match(/(^|\s)__\w/))return ce($);if(K.match(/(^|\s)_\w/))return ye($);if(K.match(/(^|\s)\[.*\]\(\w*/))return Te($);if(K.match(/(^|\s)\[\w/))return Me($)}}function de($){let V,_;for(V=0;V<$.length;V++){const K=$[V];if(K.type==="paragraph"&&K.raw.match(/(\n|^)```/)){_=ue($.slice(V));break}if(K.type==="paragraph"&&K.raw.match(/(\n|^)\|/)){_=q($.slice(V));break}if(V===$.length-1&&K.type==="paragraph"){const z=se(K);if(z){_=[z];break}}}if(_){const K=[...$.slice(0,V),..._];return K.links=$.links,K}return $}t.fillInIncompleteTokens=de;function ue($){const V=ne($);return n.marked.lexer(V+"\n```")}function re($){return ie($,"`")}function le($){return ie($,"*")}function ye($){return ie($,"_")}function Te($){return ie($,")")}function Me($){return ie($,"](about:blank)")}function Oe($){return ie($,"**")}function ce($){return ie($,"__")}function ie($,V){const _=ne(Array.isArray($)?$:[$]);return n.marked.lexer(_+V)[0]}function q($){const V=ne($),_=V.split(`
`);let K,z=!1;for(let o=0;o<_.length;o++){const F=_[o].trim();if(typeof K>"u"&&F.match(/^\s*\|/)){const j=F.match(/(\|[^\|]+)(?=\||$)/g);j&&(K=j.length)}else if(typeof K=="number")if(F.match(/^\s*\|/)){if(o!==_.length-1)return;z=!0}else return}if(typeof K=="number"&&K>0){const o=z?_.slice(0,-1).join(`
`):V,F=!!o.match(/\|\s*$/),j=o+(F?"":"|")+`
|${" --- |".repeat(K)}`;return n.marked.lexer(j)}}}),define(ge[123],me([1,0,4,9,27,59,33,2,6,104]),function(ee,t,E,I,i,W,w,y,c,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function d(l,e){(0,c.isString)(e)?l.title=(0,w.stripIcons)(e):e?.markdownNotSupportedFallback?l.title=e.markdownNotSupportedFallback:l.removeAttribute("title")}t.setupNativeHover=d;class P{constructor(e,a,n){this.hoverDelegate=e,this.target=a,this.fadeInAnimation=n}async update(e,a,n){if(this._cancellationTokenSource&&(this._cancellationTokenSource.dispose(!0),this._cancellationTokenSource=void 0),this.isDisposed)return;let h;if(e===void 0||(0,c.isString)(e)||e instanceof HTMLElement)h=e;else if(!(0,c.isFunction)(e.markdown))h=e.markdown??e.markdownNotSupportedFallback;else{this._hoverWidget||this.show((0,u.localize)(0,null),a),this._cancellationTokenSource=new i.CancellationTokenSource;const s=this._cancellationTokenSource.token;if(h=await e.markdown(s),h===void 0&&(h=e.markdownNotSupportedFallback),this.isDisposed||s.isCancellationRequested)return}this.show(h,a,n)}show(e,a,n){const h=this._hoverWidget;if(this.hasContent(e)){const s={content:e,target:this.target,showPointer:this.hoverDelegate.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.fadeInAnimation||!!h,...n};this._hoverWidget=this.hoverDelegate.showHover(s,a)}h?.dispose()}hasContent(e){return e?(0,W.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this._hoverWidget?.isDisposed}dispose(){this._hoverWidget?.dispose(),this._cancellationTokenSource?.dispose(!0),this._cancellationTokenSource=void 0}}function r(l,e,a,n){let h,s;const p=(M,R)=>{const g=s!==void 0;M&&(s?.dispose(),s=void 0),R&&(h?.dispose(),h=void 0),g&&l.onDidHideHover?.()},v=(M,R,g)=>new I.TimeoutTimer(async()=>{(!s||s.isDisposed)&&(s=new P(l,g||e,M>0),await s.update(a,R,n))},M),C=()=>{if(h)return;const M=new y.DisposableStore,R=L=>p(!1,L.fromElement===e);M.add(E.addDisposableListener(e,E.EventType.MOUSE_LEAVE,R,!0));const g=()=>p(!0,!0);M.add(E.addDisposableListener(e,E.EventType.MOUSE_DOWN,g,!0));const m={targetElements:[e],dispose:()=>{}};if(l.placement===void 0||l.placement==="mouse"){const L=k=>{m.x=k.x+10,k.target instanceof HTMLElement&&k.target.classList.contains("action-label")&&p(!0,!0)};M.add(E.addDisposableListener(e,E.EventType.MOUSE_MOVE,L,!0))}M.add(v(l.delay,!1,m)),h=M},f=E.addDisposableListener(e,E.EventType.MOUSE_OVER,C,!0);return{show:M=>{p(!1,!0),v(0,M)},hide:()=>{p(!0,!0)},update:async(M,R)=>{a=M,await s?.update(a,void 0,R)},dispose:()=>{f.dispose(),p(!0,!0)}}}t.setupCustomHover=r}),define(ge[124],me([1,0,4,20,14,122,37,13,3,42,2,5,106,97]),function(ee,t,E,I,i,W,w,y,c,u,d,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const l=E.$,e="selectOption.entry.template";class a{get templateId(){return e}renderTemplate(s){const p=Object.create(null);return p.root=s,p.text=E.append(s,l(".option-text")),p.detail=E.append(s,l(".option-detail")),p.decoratorRight=E.append(s,l(".option-decorator-right")),p}renderElement(s,p,v){const C=v,f=s.text,D=s.detail,M=s.decoratorRight,R=s.isDisabled;C.text.textContent=f,C.detail.textContent=D||"",C.decoratorRight.innerText=M||"",R?C.root.classList.add("option-disabled"):C.root.classList.remove("option-disabled")}disposeTemplate(s){}}class n extends d.Disposable{constructor(s,p,v,C,f){super(),this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.styles=C,this.selectBoxOptions=f||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=n.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new c.Emitter,this._register(this._onDidSelect),this.registerListeners(),this.constructSelectDropDown(v),this.selected=p||0,s&&this.setOptions(s,p),this.initStyleSheet()}getHeight(){return 22}getTemplateId(){return e}constructSelectDropDown(s){this.contextViewProvider=s,this.selectDropDownContainer=E.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=E.append(this.selectDropDownContainer,l(".select-box-details-pane"));const p=E.append(this.selectDropDownContainer,l(".select-box-dropdown-container-width-control")),v=E.append(p,l(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",E.append(v,this.widthControlElement),this._dropDownPosition=0,this.styleElement=E.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(E.addDisposableListener(this.selectDropDownContainer,E.EventType.DRAG_START,C=>{E.EventHelper.stop(C,!0)}))}registerListeners(){this._register(E.addStandardDisposableListener(this.selectElement,"change",p=>{this.selected=p.target.selectedIndex,this._onDidSelect.fire({index:p.target.selectedIndex,selected:p.target.value}),this.options[this.selected]&&this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)})),this._register(E.addDisposableListener(this.selectElement,E.EventType.CLICK,p=>{E.EventHelper.stop(p),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(E.addDisposableListener(this.selectElement,E.EventType.MOUSE_DOWN,p=>{E.EventHelper.stop(p)}));let s;this._register(E.addDisposableListener(this.selectElement,"touchstart",p=>{s=this._isVisible})),this._register(E.addDisposableListener(this.selectElement,"touchend",p=>{E.EventHelper.stop(p),s?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(E.addDisposableListener(this.selectElement,E.EventType.KEY_DOWN,p=>{const v=new i.StandardKeyboardEvent(p);let C=!1;P.isMacintosh?(v.keyCode===18||v.keyCode===16||v.keyCode===10||v.keyCode===3)&&(C=!0):(v.keyCode===18&&v.altKey||v.keyCode===16&&v.altKey||v.keyCode===10||v.keyCode===3)&&(C=!0),C&&(this.showSelectDropDown(),E.EventHelper.stop(p,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(s,p){y.equals(this.options,s)||(this.options=s,this.selectElement.options.length=0,this._hasDetails=!1,this._cachedMaxDetailsHeight=void 0,this.options.forEach((v,C)=>{this.selectElement.add(this.createOption(v.text,C,v.isDisabled)),typeof v.description=="string"&&(this._hasDetails=!0)})),p!==void 0&&(this.select(p),this._currentSelection=this.selected)}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(s){s>=0&&s<this.options.length?this.selected=s:s>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.options[this.selected]&&this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)}setAriaLabel(s){this.selectBoxOptions.ariaLabel=s,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(s){this.selectElement.tabIndex=s?0:-1}render(s){this.container=s,s.classList.add("select-container"),s.appendChild(this.selectElement),this.styleSelectElement()}initStyleSheet(){const s=[];this.styles.listFocusBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&this.styles.selectBorder!==this.styles.selectBackground?(s.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=s.join(`
`)}styleSelectElement(){const s=this.styles.selectBackground??"",p=this.styles.selectForeground??"",v=this.styles.selectBorder??"";this.selectElement.style.backgroundColor=s,this.selectElement.style.color=p,this.selectElement.style.borderColor=v}styleList(){const s=this.styles.selectBackground??"",p=E.asCssValueWithDefault(this.styles.selectListBackground,s);this.selectDropDownListContainer.style.backgroundColor=p,this.selectionDetailsPane.style.backgroundColor=p;const v=this.styles.focusBorder??"";this.selectDropDownContainer.style.outlineColor=v,this.selectDropDownContainer.style.outlineOffset="-1px",this.selectList.style(this.styles)}createOption(s,p,v){const C=document.createElement("option");return C.value=s,C.text=s,C.disabled=!!v,C}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:s=>this.renderSelectDropDown(s,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:s=>this.renderSelectDropDown(s),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(s){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),s&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(s,p){return s.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(p),{dispose:()=>{try{s.removeChild(this.selectDropDownContainer)}catch{}}}}measureMaxDetailsHeight(){let s=0;return this.options.forEach((p,v)=>{this.updateDetail(v),this.selectionDetailsPane.offsetHeight>s&&(s=this.selectionDetailsPane.offsetHeight)}),s}layoutSelectDropDown(s){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const p=E.getDomNodePagePosition(this.selectElement),v=getComputedStyle(this.selectElement),C=parseFloat(v.getPropertyValue("--dropdown-padding-top"))+parseFloat(v.getPropertyValue("--dropdown-padding-bottom")),f=window.innerHeight-p.top-p.height-(this.selectBoxOptions.minBottomMargin||0),D=p.top-n.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,M=this.selectElement.offsetWidth,R=this.setWidthControlElement(this.widthControlElement),g=Math.max(R,Math.round(M)).toString()+"px";this.selectDropDownContainer.style.width=g,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let m=this.selectList.contentHeight;this._hasDetails&&this._cachedMaxDetailsHeight===void 0&&(this._cachedMaxDetailsHeight=this.measureMaxDetailsHeight());const L=this._hasDetails?this._cachedMaxDetailsHeight:0,k=m+C+L,A=Math.floor((f-C-L)/this.getHeight()),H=Math.floor((D-C-L)/this.getHeight());if(s)return p.top+p.height>window.innerHeight-22||p.top<n.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||A<1&&H<1?!1:(A<n.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&H>A&&this.options.length>A?(this._dropDownPosition=1,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=0,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(p.top+p.height>window.innerHeight-22||p.top<n.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===0&&A<1||this._dropDownPosition===1&&H<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===0){if(this._isVisible&&A+H<1)return this.hideSelectDropDown(!0),!1;k>f&&(m=A*this.getHeight())}else k>D&&(m=H*this.getHeight());return this.selectList.layout(m),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=m+C+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=m+C+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=g,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(s){let p=0;if(s){let v=0,C=0;this.options.forEach((f,D)=>{const M=f.detail?f.detail.length:0,R=f.decoratorRight?f.decoratorRight.length:0,g=f.text.length+M+R;g>C&&(v=D,C=g)}),s.textContent=this.options[v].text+(this.options[v].decoratorRight?this.options[v].decoratorRight+" ":""),p=E.getTotalWidth(s)}return p}createSelectList(s){if(this.selectList)return;this.selectDropDownListContainer=E.append(s,l(".select-box-dropdown-list-container")),this.listRenderer=new a,this.selectList=new w.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:C=>{let f=C.text;return C.detail&&(f+=`. ${C.detail}`),C.decoratorRight&&(f+=`. ${C.decoratorRight}`),C.description&&(f+=`. ${C.description}`),f},getWidgetAriaLabel:()=>(0,r.localize)(0,null),getRole:()=>P.isMacintosh?"":"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const p=this._register(new I.DomEmitter(this.selectDropDownListContainer,"keydown")),v=c.Event.chain(p.event).filter(()=>this.selectList.length>0).map(C=>new i.StandardKeyboardEvent(C));this._register(v.filter(C=>C.keyCode===3).on(C=>this.onEnter(C),this)),this._register(v.filter(C=>C.keyCode===2).on(C=>this.onEnter(C),this)),this._register(v.filter(C=>C.keyCode===9).on(C=>this.onEscape(C),this)),this._register(v.filter(C=>C.keyCode===16).on(C=>this.onUpArrow(C),this)),this._register(v.filter(C=>C.keyCode===18).on(C=>this.onDownArrow(C),this)),this._register(v.filter(C=>C.keyCode===12).on(this.onPageDown,this)),this._register(v.filter(C=>C.keyCode===11).on(this.onPageUp,this)),this._register(v.filter(C=>C.keyCode===14).on(this.onHome,this)),this._register(v.filter(C=>C.keyCode===13).on(this.onEnd,this)),this._register(v.filter(C=>C.keyCode>=21&&C.keyCode<=56||C.keyCode>=85&&C.keyCode<=113).on(this.onCharacter,this)),this._register(E.addDisposableListener(this.selectList.getHTMLElement(),E.EventType.POINTER_UP,C=>this.onPointerUp(C))),this._register(this.selectList.onMouseOver(C=>typeof C.index<"u"&&this.selectList.setFocus([C.index]))),this._register(this.selectList.onDidChangeFocus(C=>this.onListFocus(C))),this._register(E.addDisposableListener(this.selectDropDownContainer,E.EventType.FOCUS_OUT,C=>{!this._isVisible||E.isAncestor(C.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(s){if(!this.selectList.length)return;E.EventHelper.stop(s);const p=s.target;if(!p||p.classList.contains("slider"))return;const v=p.closest(".monaco-list-row");if(!v)return;const C=Number(v.getAttribute("data-index")),f=v.classList.contains("option-disabled");C>=0&&C<this.options.length&&!f&&(this.selected=C,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(s,p){const v=f=>{for(let D=0;D<f.childNodes.length;D++){const M=f.childNodes.item(D);(M.tagName&&M.tagName.toLowerCase())==="img"?f.removeChild(M):v(M)}},C=(0,W.renderMarkdown)({value:s,supportThemeIcons:!0},{actionHandler:p});return C.element.classList.add("select-box-description-markdown"),v(C.element),C.element}onListFocus(s){!this._isVisible||!this._hasDetails||this.updateDetail(s.indexes[0])}updateDetail(s){this.selectionDetailsPane.innerText="";const p=this.options[s],v=p?.description??"",C=p?.descriptionIsMarkdown??!1;if(v){if(C){const f=p.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(v,f))}else this.selectionDetailsPane.innerText=v;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(s){E.EventHelper.stop(s),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(s){E.EventHelper.stop(s),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(s){if(this.selected<this.options.length-1){E.EventHelper.stop(s,!0);const p=this.options[this.selected+1].isDisabled;if(p&&this.options.length>this.selected+2)this.selected+=2;else{if(p)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(s){this.selected>0&&(E.EventHelper.stop(s,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(s){E.EventHelper.stop(s),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(s){E.EventHelper.stop(s),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(s){E.EventHelper.stop(s),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(s){E.EventHelper.stop(s),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(s){const p=u.KeyCodeUtils.toString(s.keyCode);let v=-1;for(let C=0;C<this.options.length-1;C++)if(v=(C+this.selected+1)%this.options.length,this.options[v].text.charAt(0).toUpperCase()===p&&!this.options[v].isDisabled){this.select(v),this.selectList.setFocus([v]),this.selectList.reveal(this.selectList.getFocus()[0]),E.EventHelper.stop(s);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=n,n.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32,n.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2,n.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}),define(ge[125],me([1,0,37,124,118,19,5,96]),function(ee,t,E,I,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.unthemedSelectBoxStyles=void 0,t.unthemedSelectBoxStyles={...E.unthemedListStyles,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class y extends W.Widget{constructor(u,d,P,r,l){super(),w.isMacintosh&&!l?.useCustomDrawn?this.selectBoxDelegate=new i.SelectBoxNative(u,d,r,l):this.selectBoxDelegate=new I.SelectBoxList(u,d,P,r,l),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(u,d){this.selectBoxDelegate.setOptions(u,d)}select(u){this.selectBoxDelegate.select(u)}setAriaLabel(u){this.selectBoxDelegate.setAriaLabel(u)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(u){this.selectBoxDelegate.setFocusable(u)}render(u){this.selectBoxDelegate.render(u)}}t.SelectBox=y}),define(ge[60],me([1,0,16,51,4,23,123,125,34,2,5,6,101,49]),function(ee,t,E,I,i,W,w,y,c,u,d,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class l extends u.Disposable{get action(){return this._action}constructor(h,s,p={}){super(),this.options=p,this._context=h||this,this._action=s,s instanceof c.Action&&this._register(s.onDidChange(v=>{this.element&&this.handleActionChangeEvent(v)}))}handleActionChangeEvent(h){h.enabled!==void 0&&this.updateEnabled(),h.checked!==void 0&&this.updateChecked(),h.class!==void 0&&this.updateClass(),h.label!==void 0&&(this.updateLabel(),this.updateTooltip()),h.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new c.ActionRunner)),this._actionRunner}set actionRunner(h){this._actionRunner=h}isEnabled(){return this._action.enabled}setActionContext(h){this._context=h}render(h){const s=this.element=h;this._register(W.Gesture.addTarget(h));const p=this.options&&this.options.draggable;p&&(h.draggable=!0,E.isFirefox&&this._register((0,i.addDisposableListener)(h,i.EventType.DRAG_START,v=>v.dataTransfer?.setData(I.DataTransfers.TEXT,this._action.label)))),this._register((0,i.addDisposableListener)(s,W.EventType.Tap,v=>this.onClick(v,!0))),this._register((0,i.addDisposableListener)(s,i.EventType.MOUSE_DOWN,v=>{p||i.EventHelper.stop(v,!0),this._action.enabled&&v.button===0&&s.classList.add("active")})),d.isMacintosh&&this._register((0,i.addDisposableListener)(s,i.EventType.CONTEXT_MENU,v=>{v.button===0&&v.ctrlKey===!0&&this.onClick(v)})),this._register((0,i.addDisposableListener)(s,i.EventType.CLICK,v=>{i.EventHelper.stop(v,!0),this.options&&this.options.isMenu||this.onClick(v)})),this._register((0,i.addDisposableListener)(s,i.EventType.DBLCLICK,v=>{i.EventHelper.stop(v,!0)})),[i.EventType.MOUSE_UP,i.EventType.MOUSE_OUT].forEach(v=>{this._register((0,i.addDisposableListener)(s,v,C=>{i.EventHelper.stop(C),s.classList.remove("active")}))})}onClick(h,s=!1){i.EventHelper.stop(h,!0);const p=P.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?h:{preserveFocus:s}:this._context;this.actionRunner.run(this._action,p)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(h){this.element&&(this.element.tabIndex=h?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getTooltip(){return this.action.tooltip}updateTooltip(){if(!this.element)return;const h=this.getTooltip()??"";this.updateAriaLabel(),this.options.hoverDelegate?(this.element.title="",this.customHover?this.customHover.update(h):(this.customHover=(0,w.setupCustomHover)(this.options.hoverDelegate,this.element,h),this._store.add(this.customHover))):this.element.title=h}updateAriaLabel(){if(this.element){const h=this.getTooltip()??"";this.element.setAttribute("aria-label",h)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=l;class e extends l{constructor(h,s,p){super(h,s,p),this.options=p,this.options.icon=p.icon!==void 0?p.icon:!1,this.options.label=p.label!==void 0?p.label:!0,this.cssClass=""}render(h){super.render(h),this.element&&(this.label=(0,i.append)(this.element,(0,i.$)("a.action-label"))),this.label&&this.label.setAttribute("role",this.getDefaultAriaRole()),this.options.label&&this.options.keybinding&&this.element&&((0,i.append)(this.element,(0,i.$)("span.keybinding")).textContent=this.options.keybinding),this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}getDefaultAriaRole(){return this._action.id===c.Separator.ID?"presentation":this.options.isMenu?"menuitem":"button"}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(h){this.label&&(this.label.tabIndex=h?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.action.label)}getTooltip(){let h=null;return this.action.tooltip?h=this.action.tooltip:!this.options.label&&this.action.label&&this.options.icon&&(h=this.action.label,this.options.keybinding&&(h=r.localize(0,null,h,this.options.keybinding))),h??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.action.class,this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.action.enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateAriaLabel(){if(this.label){const h=this.getTooltip()??"";this.label.setAttribute("aria-label",h)}}updateChecked(){this.label&&(this.action.checked!==void 0?(this.label.classList.toggle("checked",this.action.checked),this.label.setAttribute("aria-checked",this.action.checked?"true":"false"),this.label.setAttribute("role","checkbox")):(this.label.classList.remove("checked"),this.label.setAttribute("aria-checked",""),this.label.setAttribute("role",this.getDefaultAriaRole())))}}t.ActionViewItem=e;class a extends l{constructor(h,s,p,v,C,f,D){super(h,s),this.selectBox=new y.SelectBox(p,v,C,f,D),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(h,s){this.selectBox.setOptions(h,s)}select(h){this.selectBox.select(h)}registerListeners(){this._register(this.selectBox.onDidSelect(h=>this.runAction(h.selected,h.index)))}runAction(h,s){this.actionRunner.run(this._action,this.getActionContext(h,s))}getActionContext(h,s){return h}setFocusable(h){this.selectBox.setFocusable(h)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(h){this.selectBox.render(h)}}t.SelectActionViewItem=a}),define(ge[61],me([1,0,4,14,60,34,3,2,6,49]),function(ee,t,E,I,i,W,w,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var u;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(u||(t.ActionsOrientation=u={}));class d extends y.Disposable{constructor(l,e={}){super(),this._actionRunnerDisposables=this._register(new y.DisposableStore),this.viewItemDisposables=this._register(new y.DisposableMap),this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new w.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new w.Emitter({onWillAddFirstListener:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new w.Emitter),this.onDidRun=this._onDidRun.event,this._onWillRun=this._register(new w.Emitter),this.onWillRun=this._onWillRun.event,this.options=e,this._context=e.context??null,this._orientation=this.options.orientation??0,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[3,10]},this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new W.ActionRunner,this._actionRunnerDisposables.add(this._actionRunner)),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(h=>this._onDidRun.fire(h))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(h=>this._onWillRun.fire(h))),this.viewItems=[],this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let a,n;switch(this._orientation){case 0:a=[15],n=[17];break;case 1:a=[16],n=[18],this.domNode.className+=" vertical";break}this._register(E.addDisposableListener(this.domNode,E.EventType.KEY_DOWN,h=>{const s=new I.StandardKeyboardEvent(h);let p=!0;const v=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;a&&(s.equals(a[0])||s.equals(a[1]))?p=this.focusPrevious():n&&(s.equals(n[0])||s.equals(n[1]))?p=this.focusNext():s.equals(9)&&this.cancelHasListener?this._onDidCancel.fire():s.equals(14)?p=this.focusFirst():s.equals(13)?p=this.focusLast():s.equals(2)&&v instanceof i.BaseActionViewItem&&v.trapsArrowNavigation?p=this.focusNext():this.isTriggerKeyEvent(s)?this._triggerKeys.keyDown?this.doTrigger(s):this.triggerKeyDown=!0:p=!1,p&&(s.preventDefault(),s.stopPropagation())})),this._register(E.addDisposableListener(this.domNode,E.EventType.KEY_UP,h=>{const s=new I.StandardKeyboardEvent(h);this.isTriggerKeyEvent(s)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(s)),s.preventDefault(),s.stopPropagation()):(s.equals(2)||s.equals(1026))&&this.updateFocusedItem()})),this.focusTracker=this._register(E.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(E.getActiveElement()===this.domNode||!E.isAncestor(E.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.focusedItem=void 0,this.previouslyFocusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),l.appendChild(this.domNode)}refreshRole(){this.length()>=2?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(l){l?this.actionsList.setAttribute("aria-label",l):this.actionsList.removeAttribute("aria-label")}setFocusable(l){if(this.focusable=l,this.focusable){const e=this.viewItems.find(a=>a instanceof i.BaseActionViewItem&&a.isEnabled());e instanceof i.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.BaseActionViewItem&&e.setFocusable(!1)})}isTriggerKeyEvent(l){let e=!1;return this._triggerKeys.keys.forEach(a=>{e=e||l.equals(a)}),e}updateFocusedItem(){for(let l=0;l<this.actionsList.children.length;l++){const e=this.actionsList.children[l];if(E.isAncestor(E.getActiveElement(),e)){this.focusedItem=l;break}}}get context(){return this._context}set context(l){this._context=l,this.viewItems.forEach(e=>e.setActionContext(l))}get actionRunner(){return this._actionRunner}set actionRunner(l){this._actionRunner=l,this._actionRunnerDisposables.clear(),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(e=>this._onDidRun.fire(e))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(e=>this._onWillRun.fire(e))),this.viewItems.forEach(e=>e.actionRunner=l)}getContainer(){return this.domNode}hasAction(l){return this.viewItems.findIndex(e=>e.action.id===l.id)!==-1}getAction(l){if(typeof l=="number")return this.viewItems[l]?.action;if(l instanceof HTMLElement){for(;l.parentElement!==this.actionsList;){if(!l.parentElement)return;l=l.parentElement}for(let e=0;e<this.actionsList.childNodes.length;e++)if(this.actionsList.childNodes[e]===l)return this.viewItems[e].action}}push(l,e={}){const a=Array.isArray(l)?l:[l];let n=c.isNumber(e.index)?e.index:null;a.forEach(h=>{const s=document.createElement("li");s.className="action-item",s.setAttribute("role","presentation");let p;const v={hoverDelegate:this.options.hoverDelegate,...e};this.options.actionViewItemProvider&&(p=this.options.actionViewItemProvider(h,v)),p||(p=new i.ActionViewItem(this.context,h,v)),this.options.allowContextMenu||this.viewItemDisposables.set(p,E.addDisposableListener(s,E.EventType.CONTEXT_MENU,C=>{E.EventHelper.stop(C,!0)})),p.actionRunner=this._actionRunner,p.setActionContext(this.context),p.render(s),this.focusable&&p instanceof i.BaseActionViewItem&&this.viewItems.length===0&&p.setFocusable(!0),n===null||n<0||n>=this.actionsList.children.length?(this.actionsList.appendChild(s),this.viewItems.push(p)):(this.actionsList.insertBefore(s,this.actionsList.children[n]),this.viewItems.splice(n,0,p),n++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(l){if(l>=0&&l<this.actionsList.children.length){const e=this.actionsList.children.item(l);if(e)return e.clientWidth}return 0}getHeight(l){if(l>=0&&l<this.actionsList.children.length){const e=this.actionsList.children.item(l);if(e)return e.clientHeight}return 0}pull(l){l>=0&&l<this.viewItems.length&&(this.actionsList.removeChild(this.actionsList.childNodes[l]),this.viewItemDisposables.deleteAndDispose(this.viewItems[l]),(0,y.dispose)(this.viewItems.splice(l,1)),this.refreshRole())}clear(){this.isEmpty()||(this.viewItems=(0,y.dispose)(this.viewItems),this.viewItemDisposables.clearAndDisposeAll(),E.clearNode(this.actionsList),this.refreshRole())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(l){let e=!1,a;if(l===void 0?e=!0:typeof l=="number"?a=l:typeof l=="boolean"&&(e=l),e&&typeof this.focusedItem>"u"){const n=this.viewItems.findIndex(h=>h.isEnabled());this.focusedItem=n===-1?void 0:n,this.updateFocus(void 0,void 0,!0)}else a!==void 0&&(this.focusedItem=a),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(l){if(typeof this.focusedItem>"u")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let a;do{if(!l&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=e,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,a=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===W.Separator.ID));return this.updateFocus(),!0}focusPrevious(l){if(typeof this.focusedItem>"u")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let a;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!l&&this.options.preventLoopNavigation)return this.focusedItem=e,!1;this.focusedItem=this.viewItems.length-1}a=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===W.Separator.ID));return this.updateFocus(!0),!0}updateFocus(l,e,a=!1){typeof this.focusedItem>"u"&&this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const n=this.focusedItem!==void 0&&this.viewItems[this.focusedItem];if(n){let h=!0;c.isFunction(n.focus)||(h=!1),this.options.focusOnlyEnabledItems&&c.isFunction(n.isEnabled)&&!n.isEnabled()&&(h=!1),n.action.id===W.Separator.ID&&(h=!1),h?(a||this.previouslyFocusedItem!==this.focusedItem)&&(n.focus(l),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem=void 0)}}doTrigger(l){if(typeof this.focusedItem>"u")return;const e=this.viewItems[this.focusedItem];if(e instanceof i.BaseActionViewItem){const a=e._context===null||e._context===void 0?l:e._context;this.run(e._action,a)}}async run(l,e){await this._actionRunner.run(l,e)}dispose(){this._context=void 0,this.viewItems=(0,y.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=d;function P(r){if(!r.length)return r;let l=-1;for(let a=0;a<r.length;a++)if(r[a].id!==W.Separator.ID){l=a;break}if(l===-1)return[];r=r.slice(l);for(let a=r.length-1;a>=0&&r[a].id===W.Separator.ID;a--)r.splice(a,1);let e=!1;for(let a=r.length-1;a>=0;a--){const n=r[a].id===W.Separator.ID;n&&!e?r.splice(a,1):n?n&&(e=!1):e=!0}return r}t.prepareActions=P}),define(ge[62],me([1,0,4,20,52,61,54,57,19,3,78,48,105,93]),function(ee,t,E,I,i,W,w,y,c,u,d,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0;const l=E.$;var e;(function(h){h[h.INFO=1]="INFO",h[h.WARNING=2]="WARNING",h[h.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class a extends c.Widget{constructor(s,p,v){super(),this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new u.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new u.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=p,this.options=v,this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=E.append(s,l(".monaco-inputbox.idle"));const C=this.options.flexibleHeight?"textarea":"input",f=E.append(this.element,l(".ibwrapper"));if(this.input=E.append(f,l(C+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=E.append(f,l("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new y.ScrollableElement(this.element,{vertical:1}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),E.append(s,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(R=>this.input.scrollTop=R.scrollTop));const D=this._register(new I.DomEmitter(document,"selectionchange")),M=u.Event.filter(D.event,()=>document.getSelection()?.anchorNode===f);this._register(M(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this._register(this.ignoreGesture(this.input)),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new W.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(s){this.placeholder=s,this.input.setAttribute("placeholder",s)}setTooltip(s){this.tooltip=s,this.input.title=s}setAriaLabel(s){this.ariaLabel=s,s?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(s){this.input.value!==s&&(this.input.value=s,this.onValueChange())}get step(){return this.input.step}set step(s){this.input.step=s}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:E.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return document.activeElement===this.input}select(s=null){this.input.select(),s&&(this.input.setSelectionRange(s.start,s.end),s.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(s){s?this.enable():this.disable()}get width(){return E.getTotalWidth(this.input)}set width(s){if(this.options.flexibleHeight&&this.options.flexibleWidth){let p=0;if(this.mirror){const v=parseFloat(this.mirror.style.paddingLeft||"")||0,C=parseFloat(this.mirror.style.paddingRight||"")||0;p=v+C}this.input.style.width=s-p+"px"}else this.input.style.width=s+"px";this.mirror&&(this.mirror.style.width=s+"px")}set paddingRight(s){this.input.style.width=`calc(100% - ${s}px)`,this.mirror&&(this.mirror.style.paddingRight=s+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const s=this.cachedContentHeight,p=this.cachedHeight,v=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:s,height:p}),this.scrollableElement.setScrollPosition({scrollTop:v})}showMessage(s,p){if(this.state==="open"&&(0,P.equals)(this.message,s))return;this.message=s,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(s.type));const v=this.stylesForType(this.message.type);this.element.style.border=`1px solid ${E.asCssValueWithDefault(v.border,"transparent")}`,this.message.content&&(this.hasFocus()||p)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let s=null;return this.validation&&(s=this.validation(this.value),s?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(s)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),s?.type}stylesForType(s){const p=this.options.inputBoxStyles;switch(s){case 1:return{border:p.inputValidationInfoBorder,background:p.inputValidationInfoBackground,foreground:p.inputValidationInfoForeground};case 2:return{border:p.inputValidationWarningBorder,background:p.inputValidationWarningBackground,foreground:p.inputValidationWarningForeground};default:return{border:p.inputValidationErrorBorder,background:p.inputValidationErrorBackground,foreground:p.inputValidationErrorForeground}}}classForType(s){switch(s){case 1:return"info";case 2:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let s;const p=()=>s.style.width=E.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:C=>{if(!this.message)return null;s=E.append(C,l(".monaco-inputbox-container")),p();const f={inline:!0,className:"monaco-inputbox-message"},D=this.message.formatContent?(0,i.renderFormattedText)(this.message.content,f):(0,i.renderText)(this.message.content,f);D.classList.add(this.classForType(this.message.type));const M=this.stylesForType(this.message.type);return D.style.backgroundColor=M.background??"",D.style.color=M.foreground??"",D.style.border=M.border?`1px solid ${M.border}`:"",E.append(s,D),null},onHide:()=>{this.state="closed"},layout:p});let v;this.message.type===3?v=r.localize(0,null,this.message.content):this.message.type===2?v=r.localize(1,null,this.message.content):v=r.localize(2,null,this.message.content),w.alert(v),this.state="open"}_hideMessage(){this.contextViewProvider&&(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const s=this.value,v=s.charCodeAt(s.length-1)===10?" ":"";(s+v).replace(/\u000c/g,"")?this.mirror.textContent=s+v:this.mirror.innerText="\xA0",this.layout()}applyStyles(){const s=this.options.inputBoxStyles,p=s.inputBackground??"",v=s.inputForeground??"",C=s.inputBorder??"";this.element.style.backgroundColor=p,this.element.style.color=v,this.input.style.backgroundColor="inherit",this.input.style.color=v,this.element.style.border=`1px solid ${E.asCssValueWithDefault(C,"transparent")}`}layout(){if(!this.mirror)return;const s=this.cachedContentHeight;this.cachedContentHeight=E.getTotalHeight(this.mirror),s!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(s){const p=this.inputElement,v=p.selectionStart,C=p.selectionEnd,f=p.value;v!==null&&C!==null&&(this.value=f.substr(0,v)+s+f.substr(C),p.setSelectionRange(v+1,v+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}t.InputBox=a;class n extends a{constructor(s,p,v){const C=r.localize(3,null),f=` or \u21C5 ${C}`,D=` (\u21C5 ${C})`;super(s,p,v),this._onDidFocus=this._register(new u.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new u.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new d.HistoryNavigator(v.history,100);const M=()=>{if(v.showHistoryHint&&v.showHistoryHint()&&!this.placeholder.endsWith(f)&&!this.placeholder.endsWith(D)&&this.history.getHistory().length){const R=this.placeholder.endsWith(")")?f:D,g=this.placeholder+R;v.showPlaceholderOnFocus&&document.activeElement!==this.input?this.placeholder=g:this.setPlaceHolder(g)}};this.observer=new MutationObserver((R,g)=>{R.forEach(m=>{m.target.textContent||M()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>M()),this.onblur(this.input,()=>{const R=g=>{if(this.placeholder.endsWith(g)){const m=this.placeholder.slice(0,this.placeholder.length-g.length);return v.showPlaceholderOnFocus?this.placeholder=m:this.setPlaceHolder(m),!0}else return!1};R(D)||R(f)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(s){this.value&&(s||this.value!==this.getCurrentValue())&&this.history.add(this.value)}getHistory(){return this.history.getHistory()}isAtFirstInHistory(){return this.history.isFirst()}isAtLastInHistory(){return this.history.isLast()}isNowhereInHistory(){return this.history.isNowhere()}showNextValue(){this.history.has(this.value)||this.addToHistory();let s=this.getNextValue();s&&(s=s===this.value?this.getNextValue():s),this.value=s??"",w.status(this.value?this.value:r.localize(4,null))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let s=this.getPreviousValue();s&&(s=s===this.value?this.getPreviousValue():s),s&&(this.value=s,w.status(this.value))}clearHistory(){this.history.clear()}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let s=this.history.current();return s||(s=this.history.last(),this.history.next()),s}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()}}t.HistoryInputBox=n}),define(ge[63],me([1,0,60,19,17,18,3,98]),function(ee,t,E,I,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class y extends E.BaseActionViewItem{constructor(P,r,l){super(P,r,l),this.toggle=this._register(new c({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:l.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:l.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:l.toggleStyles?.inputActiveOptionForeground})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(P){this.element=P,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(P){this.toggle.domNode.tabIndex=P?0:-1}}t.ToggleActionViewItem=y;class c extends I.Widget{constructor(P){super(),this._onChange=this._register(new w.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new w.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts=P,this._checked=this._opts.isChecked;const r=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,r.push(...W.ThemeIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&r.push(...this._opts.actionClassName.split(" ")),this._checked&&r.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this._opts.title,this.domNode.classList.add(...r),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,l=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),l.preventDefault())}),this._register(this.ignoreGesture(this.domNode)),this.onkeydown(this.domNode,l=>{if(l.keyCode===10||l.keyCode===3){this.checked=!this._checked,this._onChange.fire(!0),l.preventDefault(),l.stopPropagation();return}this._onKeyDown.fire(l)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(P){this._checked=P,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(P){this._icon&&this.domNode.classList.remove(...W.ThemeIcon.asClassNameArray(this._icon)),this._icon=P,this._icon&&this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(this._icon))}width(){return 2+2+2+16}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder||"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(P){this.domNode.title=P,this.domNode.setAttribute("aria-label",P)}}t.Toggle=c;class u extends I.Widget{constructor(P,r,l){super(),this.title=P,this.isChecked=r,this.checkbox=new c({title:this.title,isChecked:this.isChecked,icon:i.Codicon.check,actionClassName:"monaco-checkbox",...t.unthemedToggleStyles}),this.domNode=this.checkbox.domNode,this.styles=l,this.applyStyles(),this._register(this.checkbox.onChange(()=>this.applyStyles()))}get checked(){return this.checkbox.checked}set checked(P){this.checkbox.checked=P,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground||"",this.domNode.style.backgroundColor=this.styles.checkboxBackground||"",this.domNode.style.borderColor=this.styles.checkboxBorder||""}}t.Checkbox=u}),define(ge[126],me([1,0,63,17,103]),function(ee,t,E,I,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const W=i.localize(0,null),w=i.localize(1,null),y=i.localize(2,null);class c extends E.Toggle{constructor(r){super({icon:I.Codicon.caseSensitive,title:W+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.CaseSensitiveToggle=c;class u extends E.Toggle{constructor(r){super({icon:I.Codicon.wholeWord,title:w+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.WholeWordsToggle=u;class d extends E.Toggle{constructor(r){super({icon:I.Codicon.regex,title:y+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.RegexToggle=d}),define(ge[127],me([1,0,4,126,62,19,3,102,2,92]),function(ee,t,E,I,i,W,w,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const u=y.localize(0,null);class d extends W.Widget{constructor(r,l,e){super(),this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalTogglesDisposables=new c.DisposableStore,this.additionalToggles=[],this._onDidOptionChange=this._register(new w.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new w.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new w.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new w.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new w.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new w.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new w.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.placeholder=e.placeholder||"",this.validation=e.validation,this.label=e.label||u,this.showCommonFindToggles=!!e.showCommonFindToggles;const a=e.appendCaseSensitiveLabel||"",n=e.appendWholeWordsLabel||"",h=e.appendRegexLabel||"",s=e.history||[],p=!!e.flexibleHeight,v=!!e.flexibleWidth,C=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new i.HistoryInputBox(this.domNode,l,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},history:s,showHistoryHint:e.showHistoryHint,flexibleHeight:p,flexibleWidth:v,flexibleMaxHeight:C,inputBoxStyles:e.inputBoxStyles})),this.showCommonFindToggles){this.regex=this._register(new I.RegexToggle({appendTitle:h,isChecked:!1,...e.toggleStyles})),this._register(this.regex.onChange(D=>{this._onDidOptionChange.fire(D),!D&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(D=>{this._onRegexKeyDown.fire(D)})),this.wholeWords=this._register(new I.WholeWordsToggle({appendTitle:n,isChecked:!1,...e.toggleStyles})),this._register(this.wholeWords.onChange(D=>{this._onDidOptionChange.fire(D),!D&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new I.CaseSensitiveToggle({appendTitle:a,isChecked:!1,...e.toggleStyles})),this._register(this.caseSensitive.onChange(D=>{this._onDidOptionChange.fire(D),!D&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(D=>{this._onCaseSensitiveKeyDown.fire(D)}));const f=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,D=>{if(D.equals(15)||D.equals(17)||D.equals(9)){const M=f.indexOf(document.activeElement);if(M>=0){let R=-1;D.equals(17)?R=(M+1)%f.length:D.equals(15)&&(M===0?R=f.length-1:R=M-1),D.equals(9)?(f[M].blur(),this.inputBox.focus()):R>=0&&f[R].focus(),E.EventHelper.stop(D,!0)}}})}this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this.showCommonFindToggles?"":"none",this.caseSensitive&&this.controls.append(this.caseSensitive.domNode),this.wholeWords&&this.controls.appendChild(this.wholeWords.domNode),this.regex&&this.controls.appendChild(this.regex.domNode),this.setAdditionalToggles(e?.additionalToggles),this.controls&&this.domNode.appendChild(this.controls),r?.appendChild(this.domNode),this._register(E.addDisposableListener(this.inputBox.inputElement,"compositionstart",f=>{this.imeSessionInProgress=!0})),this._register(E.addDisposableListener(this.inputBox.inputElement,"compositionend",f=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,f=>this._onKeyDown.fire(f)),this.onkeyup(this.inputBox.inputElement,f=>this._onKeyUp.fire(f)),this.oninput(this.inputBox.inputElement,f=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,f=>this._onMouseDown.fire(f))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}layout(r){this.inputBox.layout(),this.updateInputBoxPadding(r.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex?.enable(),this.wholeWords?.enable(),this.caseSensitive?.enable();for(const r of this.additionalToggles)r.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex?.disable(),this.wholeWords?.disable(),this.caseSensitive?.disable();for(const r of this.additionalToggles)r.disable()}setFocusInputOnOptionClick(r){this.fixFocusOnOptionClickEnabled=r}setEnabled(r){r?this.enable():this.disable()}setAdditionalToggles(r){for(const l of this.additionalToggles)l.domNode.remove();this.additionalToggles=[],this.additionalTogglesDisposables.dispose(),this.additionalTogglesDisposables=new c.DisposableStore;for(const l of r??[])this.additionalTogglesDisposables.add(l),this.controls.appendChild(l.domNode),this.additionalTogglesDisposables.add(l.onChange(e=>{this._onDidOptionChange.fire(e),!e&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(l);this.additionalToggles.length>0&&(this.controls.style.display=""),this.updateInputBoxPadding()}updateInputBoxPadding(r=!1){r?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.caseSensitive?.width()??0)+(this.wholeWords?.width()??0)+(this.regex?.width()??0)+this.additionalToggles.reduce((l,e)=>l+e.width(),0)}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(r){this.inputBox.value!==r&&(this.inputBox.value=r)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive?.checked??!1}setCaseSensitive(r){this.caseSensitive&&(this.caseSensitive.checked=r)}getWholeWords(){return this.wholeWords?.checked??!1}setWholeWords(r){this.wholeWords&&(this.wholeWords.checked=r)}getRegex(){return this.regex?.checked??!1}setRegex(r){this.regex&&(this.regex.checked=r,this.validate())}focusOnCaseSensitive(){this.caseSensitive?.focus()}focusOnRegex(){this.regex?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(r){this.inputBox.showMessage(r)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=d,d.OPTION_CHANGE="optionChange"}),define(ge[128],me([1,0,4,20,14,61,127,62,58,37,63,55,24,34,13,9,17,18,69,3,32,2,44,6,107,99]),function(ee,t,E,I,i,W,w,y,c,u,d,P,r,l,e,a,n,h,s,p,v,C,f,D,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMatchType=t.TreeFindMode=t.FuzzyToggle=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class R extends c.ElementsDragAndDropData{set context(o){this.data.context=o}get context(){return this.data.context}constructor(o){super(o.elements.map(F=>F.element)),this.data=o}}function g(z){return z instanceof c.ElementsDragAndDropData?new R(z):z}class m{constructor(o,F){this.modelProvider=o,this.dnd=F,this.autoExpandDisposable=C.Disposable.None}getDragURI(o){return this.dnd.getDragURI(o.element)}getDragLabel(o,F){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(o.map(j=>j.element),F)}onDragStart(o,F){this.dnd.onDragStart?.(g(o),F)}onDragOver(o,F,j,te,S=!0){const T=this.dnd.onDragOver(g(o),F&&F.element,j,te),O=this.autoExpandNode!==F;if(O&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=F),typeof F>"u")return T;if(O&&typeof T!="boolean"&&T.autoExpand&&(this.autoExpandDisposable=(0,a.disposableTimeout)(()=>{const U=this.modelProvider(),Y=U.getNodeLocation(F);U.isCollapsed(Y)&&U.setCollapsed(Y,!1),this.autoExpandNode=void 0},500)),typeof T=="boolean"||!T.accept||typeof T.bubble>"u"||T.feedback){if(!S){const U=typeof T=="boolean"?T:T.accept,Y=typeof T=="boolean"?void 0:T.effect;return{accept:U,effect:Y,feedback:[j]}}return T}if(T.bubble===1){const U=this.modelProvider(),Y=U.getNodeLocation(F),J=U.getParentNodeLocation(Y),oe=U.getNode(J),be=J&&U.getListIndex(J);return this.onDragOver(o,oe,be,te,!1)}const b=this.modelProvider(),x=b.getNodeLocation(F),B=b.getListIndex(x),N=b.getListRenderCount(x);return{...T,feedback:(0,e.range)(B,B+N)}}drop(o,F,j,te){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(g(o),F&&F.element,j,te)}onDragEnd(o){this.dnd.onDragEnd?.(o)}}function L(z,o){return o&&{...o,identityProvider:o.identityProvider&&{getId(F){return o.identityProvider.getId(F.element)}},dnd:o.dnd&&new m(z,o.dnd),multipleSelectionController:o.multipleSelectionController&&{isSelectionSingleChangeEvent(F){return o.multipleSelectionController.isSelectionSingleChangeEvent({...F,element:F.element})},isSelectionRangeChangeEvent(F){return o.multipleSelectionController.isSelectionRangeChangeEvent({...F,element:F.element})}},accessibilityProvider:o.accessibilityProvider&&{...o.accessibilityProvider,getSetSize(F){const j=z(),te=j.getNodeLocation(F),S=j.getParentNodeLocation(te);return j.getNode(S).visibleChildrenCount},getPosInSet(F){return F.visibleChildIndex+1},isChecked:o.accessibilityProvider&&o.accessibilityProvider.isChecked?F=>o.accessibilityProvider.isChecked(F.element):void 0,getRole:o.accessibilityProvider&&o.accessibilityProvider.getRole?F=>o.accessibilityProvider.getRole(F.element):()=>"treeitem",getAriaLabel(F){return o.accessibilityProvider.getAriaLabel(F.element)},getWidgetAriaLabel(){return o.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:o.accessibilityProvider&&o.accessibilityProvider.getWidgetRole?()=>o.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:o.accessibilityProvider&&o.accessibilityProvider.getAriaLevel?F=>o.accessibilityProvider.getAriaLevel(F.element):F=>F.depth,getActiveDescendantId:o.accessibilityProvider.getActiveDescendantId&&(F=>o.accessibilityProvider.getActiveDescendantId(F.element))},keyboardNavigationLabelProvider:o.keyboardNavigationLabelProvider&&{...o.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(F){return o.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(F.element)}}}}class k{constructor(o){this.delegate=o}getHeight(o){return this.delegate.getHeight(o.element)}getTemplateId(o){return this.delegate.getTemplateId(o.element)}hasDynamicHeight(o){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(o.element)}setDynamicHeight(o,F){this.delegate.setDynamicHeight?.(o.element,F)}}t.ComposedTreeDelegate=k;class A{static lift(o){return o instanceof A?o:new A(o)}static empty(o=0){return new A({focus:[],selection:[],expanded:Object.create(null),scrollTop:o})}constructor(o){if(this.focus=new Set(o.focus),this.selection=new Set(o.selection),o.expanded instanceof Array){this.expanded=Object.create(null);for(const F of o.expanded)this.expanded[F]=1}else this.expanded=o.expanded;this.expanded=o.expanded,this.scrollTop=o.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=A;var H;(function(z){z.None="none",z.OnHover="onHover",z.Always="always"})(H||(t.RenderIndentGuides=H={}));class G{get elements(){return this._elements}constructor(o,F=[]){this._elements=F,this.disposables=new C.DisposableStore,this.onDidChange=p.Event.forEach(o,j=>this._elements=j,this.disposables)}dispose(){this.disposables.dispose()}}class ne{constructor(o,F,j,te,S,T={}){this.renderer=o,this.modelProvider=F,this.activeNodes=te,this.renderedIndentGuides=S,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=ne.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.activeIndentNodes=new Set,this.indentGuidesDisposable=C.Disposable.None,this.disposables=new C.DisposableStore,this.templateId=o.templateId,this.updateOptions(T),p.Event.map(j,O=>O.node)(this.onDidChangeNodeTwistieState,this,this.disposables),o.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(o={}){if(typeof o.indent<"u"){const F=(0,f.clamp)(o.indent,0,40);if(F!==this.indent){this.indent=F;for(const[j,te]of this.renderedNodes)this.renderTreeElement(j,te)}}if(typeof o.renderIndentGuides<"u"){const F=o.renderIndentGuides!==H.None;if(F!==this.shouldRenderIndentGuides){this.shouldRenderIndentGuides=F;for(const[j,te]of this.renderedNodes)this._renderIndentGuides(j,te);if(this.indentGuidesDisposable.dispose(),F){const j=new C.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,j),this.indentGuidesDisposable=j,this._onDidChangeActiveNodes(this.activeNodes.elements)}}}typeof o.hideTwistiesOfChildlessElements<"u"&&(this.hideTwistiesOfChildlessElements=o.hideTwistiesOfChildlessElements)}renderTemplate(o){const F=(0,E.append)(o,(0,E.$)(".monaco-tl-row")),j=(0,E.append)(F,(0,E.$)(".monaco-tl-indent")),te=(0,E.append)(F,(0,E.$)(".monaco-tl-twistie")),S=(0,E.append)(F,(0,E.$)(".monaco-tl-contents")),T=this.renderer.renderTemplate(S);return{container:o,indent:j,twistie:te,indentGuidesDisposable:C.Disposable.None,templateData:T}}renderElement(o,F,j,te){this.renderedNodes.set(o,j),this.renderedElements.set(o.element,o),this.renderTreeElement(o,j),this.renderer.renderElement(o,F,j.templateData,te)}disposeElement(o,F,j,te){j.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(o,F,j.templateData,te),typeof te=="number"&&(this.renderedNodes.delete(o),this.renderedElements.delete(o.element))}disposeTemplate(o){this.renderer.disposeTemplate(o.templateData)}onDidChangeTwistieState(o){const F=this.renderedElements.get(o);F&&this.onDidChangeNodeTwistieState(F)}onDidChangeNodeTwistieState(o){const F=this.renderedNodes.get(o);F&&(this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderTreeElement(o,F))}renderTreeElement(o,F){const j=ne.DefaultIndent+(o.depth-1)*this.indent;F.twistie.style.paddingLeft=`${j}px`,F.indent.style.width=`${j+this.indent-16}px`,o.collapsible?F.container.setAttribute("aria-expanded",String(!o.collapsed)):F.container.removeAttribute("aria-expanded"),F.twistie.classList.remove(...h.ThemeIcon.asClassNameArray(n.Codicon.treeItemExpanded));let te=!1;this.renderer.renderTwistie&&(te=this.renderer.renderTwistie(o.element,F.twistie)),o.collapsible&&(!this.hideTwistiesOfChildlessElements||o.visibleChildrenCount>0)?(te||F.twistie.classList.add(...h.ThemeIcon.asClassNameArray(n.Codicon.treeItemExpanded)),F.twistie.classList.add("collapsible"),F.twistie.classList.toggle("collapsed",o.collapsed)):F.twistie.classList.remove("collapsible","collapsed"),this._renderIndentGuides(o,F)}_renderIndentGuides(o,F){if((0,E.clearNode)(F.indent),F.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const j=new C.DisposableStore,te=this.modelProvider();for(;;){const S=te.getNodeLocation(o),T=te.getParentNodeLocation(S);if(!T)break;const O=te.getNode(T),b=(0,E.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(O)&&b.classList.add("active"),F.indent.childElementCount===0?F.indent.appendChild(b):F.indent.insertBefore(b,F.indent.firstElementChild),this.renderedIndentGuides.add(O,b),j.add((0,C.toDisposable)(()=>this.renderedIndentGuides.delete(O,b))),o=O}F.indentGuidesDisposable=j}_onDidChangeActiveNodes(o){if(!this.shouldRenderIndentGuides)return;const F=new Set,j=this.modelProvider();o.forEach(te=>{const S=j.getNodeLocation(te);try{const T=j.getParentNodeLocation(S);te.collapsible&&te.children.length>0&&!te.collapsed?F.add(te):T&&F.add(j.getNode(T))}catch{}}),this.activeIndentNodes.forEach(te=>{F.has(te)||this.renderedIndentGuides.forEach(te,S=>S.classList.remove("active"))}),F.forEach(te=>{this.activeIndentNodes.has(te)||this.renderedIndentGuides.forEach(te,S=>S.classList.add("active"))}),this.activeIndentNodes=F}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,C.dispose)(this.disposables)}}ne.DefaultIndent=8;class se{get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(o){this._pattern=o,this._lowercasePattern=o.toLowerCase()}constructor(o,F,j){this.tree=o,this.keyboardNavigationLabelProvider=F,this._filter=j,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new C.DisposableStore,o.onWillRefilter(this.reset,this,this.disposables)}filter(o,F){let j=1;if(this._filter){const T=this._filter.filter(o,F);if(typeof T=="boolean"?j=T?1:0:(0,P.isFilterResult)(T)?j=(0,P.getVisibleState)(T.visibility):j=T,j===0)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:v.FuzzyScore.Default,visibility:j};const te=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(o),S=Array.isArray(te)?te:[te];for(const T of S){const O=T&&T.toString();if(typeof O>"u")return{data:v.FuzzyScore.Default,visibility:j};let b;if(this.tree.findMatchType===ye.Contiguous){const x=O.toLowerCase().indexOf(this._lowercasePattern);if(x>-1){b=[Number.MAX_SAFE_INTEGER,0];for(let B=this._lowercasePattern.length;B>0;B--)b.push(x+B-1)}}else b=(0,v.fuzzyScore)(this._pattern,this._lowercasePattern,0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(b)return this._matchCount++,S.length===1?{data:b,visibility:j}:{data:{label:O,score:b},visibility:j}}return this.tree.findMode===le.Filter?typeof this.tree.options.defaultFindVisibility=="number"?this.tree.options.defaultFindVisibility:this.tree.options.defaultFindVisibility?this.tree.options.defaultFindVisibility(o):2:{data:v.FuzzyScore.Default,visibility:j}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,C.dispose)(this.disposables)}}class de extends d.Toggle{constructor(o){super({icon:n.Codicon.listFilter,title:(0,M.localize)(0,null),isChecked:o.isChecked??!1,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.ModeToggle=de;class ue extends d.Toggle{constructor(o){super({icon:n.Codicon.searchFuzzy,title:(0,M.localize)(1,null),isChecked:o.isChecked??!1,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.FuzzyToggle=ue;const re={inputBoxStyles:y.unthemedInboxStyles,toggleStyles:d.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var le;(function(z){z[z.Highlight=0]="Highlight",z[z.Filter=1]="Filter"})(le||(t.TreeFindMode=le={}));var ye;(function(z){z[z.Fuzzy=0]="Fuzzy",z[z.Contiguous=1]="Contiguous"})(ye||(t.TreeFindMatchType=ye={}));class Te extends C.Disposable{set mode(o){this.modeToggle.checked=o===le.Filter,this.findInput.inputBox.setPlaceHolder(o===le.Filter?(0,M.localize)(2,null):(0,M.localize)(3,null))}set matchType(o){this.matchTypeToggle.checked=o===ye.Fuzzy}get value(){return this.findInput.inputBox.value}set value(o){this.findInput.inputBox.value=o}constructor(o,F,j,te,S,T){super(),this.tree=F,this.elements=(0,E.h)(".monaco-tree-type-filter",[(0,E.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,E.h)(".monaco-tree-type-filter-input@findInput"),(0,E.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this.top=0,this._onDidDisable=new p.Emitter,this.onDidDisable=this._onDidDisable.event,o.appendChild(this.elements.root),this._register((0,C.toDisposable)(()=>o.removeChild(this.elements.root)));const O=T?.styles??re;O.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=O.listFilterWidgetBackground),O.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${O.listFilterWidgetShadow}`),this.modeToggle=this._register(new de({...O.toggleStyles,isChecked:te===le.Filter})),this.matchTypeToggle=this._register(new ue({...O.toggleStyles,isChecked:S===ye.Fuzzy})),this.onDidChangeMode=p.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?le.Filter:le.Highlight,this._store),this.onDidChangeMatchType=p.Event.map(this.matchTypeToggle.onChange,()=>this.matchTypeToggle.checked?ye.Fuzzy:ye.Contiguous,this._store),this.findInput=this._register(new w.FindInput(this.elements.findInput,j,{label:(0,M.localize)(4,null),additionalToggles:[this.modeToggle,this.matchTypeToggle],showCommonFindToggles:!1,inputBoxStyles:O.inputBoxStyles,toggleStyles:O.toggleStyles,history:T?.history})),this.actionbar=this._register(new W.ActionBar(this.elements.actionbar)),this.mode=te;const b=this._register(new I.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),x=this._register(p.Event.chain(b.event)).map(Y=>new i.StandardKeyboardEvent(Y)).event;this._register(x(Y=>{if(Y.equals(3)){Y.preventDefault(),Y.stopPropagation(),this.findInput.inputBox.addToHistory(),this.tree.domFocus();return}if(Y.equals(18)){Y.preventDefault(),Y.stopPropagation(),this.findInput.inputBox.isAtLastInHistory()||this.findInput.inputBox.isNowhereInHistory()?(this.findInput.inputBox.addToHistory(),this.tree.domFocus()):this.findInput.inputBox.showNextValue();return}if(Y.equals(16)){Y.preventDefault(),Y.stopPropagation(),this.findInput.inputBox.showPreviousValue();return}}));const B=this._register(new l.Action("close",(0,M.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(B,{icon:!0,label:!1});const N=this._register(new I.DomEmitter(this.elements.grab,"mousedown"));this._register(N.event(Y=>{const J=new C.DisposableStore,oe=J.add(new I.DomEmitter(window,"mousemove")),be=J.add(new I.DomEmitter(window,"mouseup")),De=this.right,Le=Y.pageX,Se=this.top,ve=Y.pageY;this.elements.grab.classList.add("grabbing");const ke=this.elements.root.style.transition;this.elements.root.style.transition="unset";const Ie=Ke=>{const xe=Ke.pageX-Le;this.right=De-xe;const We=Ke.pageY-ve;this.top=Se+We,this.layout()};J.add(oe.event(Ie)),J.add(be.event(Ke=>{Ie(Ke),this.elements.grab.classList.remove("grabbing"),this.elements.root.style.transition=ke,J.dispose()}))}));const U=this._register(p.Event.chain(this._register(new I.DomEmitter(this.elements.grab,"keydown")).event)).map(Y=>new i.StandardKeyboardEvent(Y)).event;this._register(U(Y=>{let J,oe;if(Y.keyCode===15?J=Number.POSITIVE_INFINITY:Y.keyCode===17?J=0:Y.keyCode===10&&(J=this.right===0?Number.POSITIVE_INFINITY:0),Y.keyCode===16?oe=0:Y.keyCode===18&&(oe=Number.POSITIVE_INFINITY),J!==void 0&&(Y.preventDefault(),Y.stopPropagation(),this.right=J,this.layout()),oe!==void 0){Y.preventDefault(),Y.stopPropagation(),this.top=oe;const be=this.elements.root.style.transition;this.elements.root.style.transition="unset",this.layout(),setTimeout(()=>{this.elements.root.style.transition=be},0)}})),this.onDidChangeValue=this.findInput.onDidChange}getHistory(){return this.findInput.inputBox.getHistory()}focus(){this.findInput.focus()}select(){this.findInput.select(),this.findInput.inputBox.addToHistory(!0)}layout(o=this.width){this.width=o,this.right=(0,f.clamp)(this.right,0,Math.max(0,o-212)),this.elements.root.style.right=`${this.right}px`,this.top=(0,f.clamp)(this.top,0,24),this.elements.root.style.top=`${this.top}px`}showMessage(o){this.findInput.showMessage(o)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,a.timeout)(300),super.dispose()}}class Me{get pattern(){return this._pattern}get mode(){return this._mode}set mode(o){o!==this._mode&&(this._mode=o,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(o))}get matchType(){return this._matchType}set matchType(o){o!==this._matchType&&(this._matchType=o,this.widget&&(this.widget.matchType=this._matchType),this.tree.refilter(),this.render(),this._onDidChangeMatchType.fire(o))}constructor(o,F,j,te,S,T={}){this.tree=o,this.view=j,this.filter=te,this.contextViewProvider=S,this.options=T,this._pattern="",this.previousPattern="",this.width=0,this._onDidChangeMode=new p.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangeMatchType=new p.Emitter,this.onDidChangeMatchType=this._onDidChangeMatchType.event,this._onDidChangePattern=new p.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new p.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new C.DisposableStore,this.disposables=new C.DisposableStore,this._mode=o.options.defaultFindMode??le.Highlight,this._matchType=o.options.defaultFindMatchType??ye.Fuzzy,F.onDidSplice(this.onDidSpliceModel,this,this.disposables)}updateOptions(o={}){o.defaultFindMode!==void 0&&(this.mode=o.defaultFindMode),o.defaultFindMatchType!==void 0&&(this.matchType=o.defaultFindMatchType)}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.widget=new Te(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.matchType,{...this.options,history:this._history}),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(o=>this.mode=o,void 0,this.enabledDisposables),this.widget.onDidChangeMatchType(o=>this.matchType=o,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this.widget.value=this.previousPattern,this.widget.select(),this._onDidChangeOpenState.fire(!0)}close(){this.widget&&(this._history=this.widget.getHistory(),this.widget=void 0,this.enabledDisposables.dispose(),this.enabledDisposables=new C.DisposableStore,this.previousPattern=this.pattern,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(o){this._pattern=o,this._onDidChangePattern.fire(o),this.filter.pattern=o,this.tree.refilter(),o&&this.tree.focusNext(0,!0,void 0,j=>!v.FuzzyScore.isDefault(j.filterData));const F=this.tree.getFocus();if(F.length>0){const j=F[0];this.tree.getRelativeTop(j)===null&&this.tree.reveal(j,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const o=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&o?this.tree.options.showNotFoundMessage??!0?this.widget?.showMessage({type:2,content:(0,M.localize)(6,null)}):this.widget?.showMessage({type:2}):this.widget?.clearMessage()}shouldAllowFocus(o){return!this.widget||!this.pattern||this._mode===le.Filter||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!v.FuzzyScore.isDefault(o.filterData)}layout(o){this.width=o,this.widget?.layout(o)}dispose(){this._history=void 0,this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function Oe(z){let o=r.TreeMouseEventTarget.Unknown;return(0,E.hasParentWithClass)(z.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?o=r.TreeMouseEventTarget.Twistie:(0,E.hasParentWithClass)(z.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?o=r.TreeMouseEventTarget.Element:(0,E.hasParentWithClass)(z.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(o=r.TreeMouseEventTarget.Filter),{browserEvent:z.browserEvent,element:z.element?z.element.element:null,target:o}}function ce(z){return{element:z.element?z.element.element:null,browserEvent:z.browserEvent,anchor:z.anchor}}function ie(z,o){o(z),z.children.forEach(F=>ie(F,o))}class q{get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}constructor(o,F){this.getFirstViewElementWithTrait=o,this.identityProvider=F,this.nodes=[],this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event}set(o,F){!F?.__forceEvent&&(0,e.equals)(this.nodes,o)||this._set(o,!1,F)}_set(o,F,j){if(this.nodes=[...o],this.elements=void 0,this._nodeSet=void 0,!F){const te=this;this._onDidChange.fire({get elements(){return te.get()},browserEvent:j})}}get(){return this.elements||(this.elements=this.nodes.map(o=>o.element)),[...this.elements]}getNodes(){return this.nodes}has(o){return this.nodeSet.has(o)}onDidModelSplice({insertedNodes:o,deletedNodes:F}){if(!this.identityProvider){const b=this.createNodeSet(),x=B=>b.delete(B);F.forEach(B=>ie(B,x)),this.set([...b.values()]);return}const j=new Set,te=b=>j.add(this.identityProvider.getId(b.element).toString());F.forEach(b=>ie(b,te));const S=new Map,T=b=>S.set(this.identityProvider.getId(b.element).toString(),b);o.forEach(b=>ie(b,T));const O=[];for(const b of this.nodes){const x=this.identityProvider.getId(b.element).toString();if(!j.has(x))O.push(b);else{const N=S.get(x);N&&N.visible&&O.push(N)}}if(this.nodes.length>0&&O.length===0){const b=this.getFirstViewElementWithTrait();b&&O.push(b)}this._set(O,!0)}createNodeSet(){const o=new Set;for(const F of this.nodes)o.add(F);return o}}class $ extends u.MouseController{constructor(o,F){super(o),this.tree=F}onViewPointer(o){if((0,u.isButton)(o.browserEvent.target)||(0,u.isInputElement)(o.browserEvent.target)||(0,u.isMonacoEditor)(o.browserEvent.target)||o.browserEvent.isHandledByList)return;const F=o.element;if(!F)return super.onViewPointer(o);if(this.isSelectionRangeChangeEvent(o)||this.isSelectionSingleChangeEvent(o))return super.onViewPointer(o);const j=o.browserEvent.target,te=j.classList.contains("monaco-tl-twistie")||j.classList.contains("monaco-icon-label")&&j.classList.contains("folder-icon")&&o.browserEvent.offsetX<16;let S=!1;if(typeof this.tree.expandOnlyOnTwistieClick=="function"?S=this.tree.expandOnlyOnTwistieClick(F.element):S=!!this.tree.expandOnlyOnTwistieClick,S&&!te&&o.browserEvent.detail!==2)return super.onViewPointer(o);if(!this.tree.expandOnDoubleClick&&o.browserEvent.detail===2)return super.onViewPointer(o);if(F.collapsible){const T=this.tree.getNodeLocation(F),O=o.browserEvent.altKey;if(this.tree.setFocus([T]),this.tree.toggleCollapsed(T,O),S&&te){o.browserEvent.isHandledByList=!0;return}}super.onViewPointer(o)}onDoubleClick(o){o.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||o.browserEvent.isHandledByList||super.onDoubleClick(o)}}class V extends u.List{constructor(o,F,j,te,S,T,O,b){super(o,F,j,te,b),this.focusTrait=S,this.selectionTrait=T,this.anchorTrait=O}createMouseController(o){return new $(this,o.tree)}splice(o,F,j=[]){if(super.splice(o,F,j),j.length===0)return;const te=[],S=[];let T;j.forEach((O,b)=>{this.focusTrait.has(O)&&te.push(o+b),this.selectionTrait.has(O)&&S.push(o+b),this.anchorTrait.has(O)&&(T=o+b)}),te.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...te])),S.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...S])),typeof T=="number"&&super.setAnchor(T)}setFocus(o,F,j=!1){super.setFocus(o,F),j||this.focusTrait.set(o.map(te=>this.element(te)),F)}setSelection(o,F,j=!1){super.setSelection(o,F),j||this.selectionTrait.set(o.map(te=>this.element(te)),F)}setAnchor(o,F=!1){super.setAnchor(o),F||(typeof o>"u"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(o)]))}}class _{get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return p.Event.map(this.view.onMouseClick,Oe)}get onMouseDblClick(){return p.Event.filter(p.Event.map(this.view.onMouseDblClick,Oe),o=>o.target!==r.TreeMouseEventTarget.Filter)}get onContextMenu(){return p.Event.map(this.view.onContextMenu,ce)}get onTap(){return p.Event.map(this.view.onTap,Oe)}get onPointer(){return p.Event.map(this.view.onPointer,Oe)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return p.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??le.Highlight}set findMode(o){this.findController&&(this.findController.mode=o)}get findMatchType(){return this.findController?.matchType??ye.Fuzzy}set findMatchType(o){this.findController&&(this.findController.matchType=o)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:p.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick>"u"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick>"u"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}constructor(o,F,j,te,S={}){this._user=o,this._options=S,this.eventBufferer=new p.EventBufferer,this.onDidChangeFindOpenState=p.Event.None,this.disposables=new C.DisposableStore,this._onWillRefilter=new p.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new p.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event;const T=new k(j),O=new p.Relay,b=new p.Relay,x=this.disposables.add(new G(b.event)),B=new s.SetMap;this.renderers=te.map(Y=>new ne(Y,()=>this.model,O.event,x,B,S));for(const Y of this.renderers)this.disposables.add(Y);let N;S.keyboardNavigationLabelProvider&&(N=new se(this,S.keyboardNavigationLabelProvider,S.filter),S={...S,filter:N},this.disposables.add(N)),this.focus=new q(()=>this.view.getFocusedElements()[0],S.identityProvider),this.selection=new q(()=>this.view.getSelectedElements()[0],S.identityProvider),this.anchor=new q(()=>this.view.getAnchorElement(),S.identityProvider),this.view=new V(o,F,T,this.renderers,this.focus,this.selection,this.anchor,{...L(()=>this.model,S),tree:this}),this.model=this.createModel(o,this.view,S),O.input=this.model.onDidChangeCollapseState;const U=p.Event.forEach(this.model.onDidSplice,Y=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(Y),this.selection.onDidModelSplice(Y)})},this.disposables);if(U(()=>null,null,this.disposables),b.input=p.Event.chain(p.Event.any(U,this.focus.onDidChange,this.selection.onDidChange)).debounce(()=>null,0).map(()=>{const Y=new Set;for(const J of this.focus.getNodes())Y.add(J);for(const J of this.selection.getNodes())Y.add(J);return[...Y.values()]}).event,S.keyboardSupport!==!1){const Y=p.Event.chain(this.view.onKeyDown).filter(J=>!(0,u.isInputElement)(J.target)).map(J=>new i.StandardKeyboardEvent(J));Y.filter(J=>J.keyCode===15).on(this.onLeftArrow,this,this.disposables),Y.filter(J=>J.keyCode===17).on(this.onRightArrow,this,this.disposables),Y.filter(J=>J.keyCode===10).on(this.onSpace,this,this.disposables)}if((S.findWidgetEnabled??!0)&&S.keyboardNavigationLabelProvider&&S.contextViewProvider){const Y=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.findController=new Me(this,this.model,this.view,N,S.contextViewProvider,Y),this.focusNavigationFilter=J=>this.findController.shouldAllowFocus(J),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode,this.onDidChangeFindMatchType=this.findController.onDidChangeMatchType}else this.onDidChangeFindMode=p.Event.None,this.onDidChangeFindMatchType=p.Event.None;this.styleElement=(0,E.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===H.Always)}updateOptions(o={}){this._options={...this._options,...o};for(const F of this.renderers)F.updateOptions(o);this.view.updateOptions(this._options),this.findController?.updateOptions(o),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===H.Always)}get options(){return this._options}updateWidth(o){const F=this.model.getListIndex(o);F!==-1&&this.view.updateWidth(F)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.scrollTop}set scrollTop(o){this.view.scrollTop=o}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(o){this.view.scrollLeft=o}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){const o=this.view.firstVisibleIndex;return o<0||o>=this.view.length?void 0:this.view.element(o).element}get lastVisibleElement(){const o=this.view.lastVisibleIndex;return this.view.element(o).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(o){this.view.ariaLabel=o}get selectionSize(){return this.selection.getNodes().length}domFocus(){this.view.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(o,F){this.view.layout(o,F),(0,D.isNumber)(F)&&this.findController?.layout(F)}style(o){const F=`.${this.view.domId}`,j=[];o.treeIndentGuidesStroke&&(j.push(`.monaco-list${F}:hover .monaco-tl-indent > .indent-guide, .monaco-list${F}.always .monaco-tl-indent > .indent-guide  { border-color: ${o.treeInactiveIndentGuidesStroke}; }`),j.push(`.monaco-list${F} .monaco-tl-indent > .indent-guide.active { border-color: ${o.treeIndentGuidesStroke}; }`)),this.styleElement.textContent=j.join(`
`),this.view.style(o)}getParentElement(o){const F=this.model.getParentNodeLocation(o);return this.model.getNode(F).element}getFirstElementChild(o){return this.model.getFirstElementChild(o)}getNode(o){return this.model.getNode(o)}getNodeLocation(o){return this.model.getNodeLocation(o)}collapse(o,F=!1){return this.model.setCollapsed(o,!0,F)}expand(o,F=!1){return this.model.setCollapsed(o,!1,F)}toggleCollapsed(o,F=!1){return this.model.setCollapsed(o,void 0,F)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(o){return this.model.isCollapsible(o)}setCollapsible(o,F){return this.model.setCollapsible(o,F)}isCollapsed(o){return this.model.isCollapsed(o)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(o){if(typeof o>"u")return this.view.setAnchor(void 0);const F=this.model.getNode(o);this.anchor.set([F]);const j=this.model.getListIndex(o);j>-1&&this.view.setAnchor(j,!0)}getAnchor(){return(0,e.firstOrDefault)(this.anchor.get(),void 0)}setSelection(o,F){const j=o.map(S=>this.model.getNode(S));this.selection.set(j,F);const te=o.map(S=>this.model.getListIndex(S)).filter(S=>S>-1);this.view.setSelection(te,F,!0)}getSelection(){return this.selection.get()}setFocus(o,F){const j=o.map(S=>this.model.getNode(S));this.focus.set(j,F);const te=o.map(S=>this.model.getListIndex(S)).filter(S=>S>-1);this.view.setFocus(te,F,!0)}focusNext(o=1,F=!1,j,te=this.focusNavigationFilter){this.view.focusNext(o,F,j,te)}focusPrevious(o=1,F=!1,j,te=this.focusNavigationFilter){this.view.focusPrevious(o,F,j,te)}focusNextPage(o,F=this.focusNavigationFilter){return this.view.focusNextPage(o,F)}focusPreviousPage(o,F=this.focusNavigationFilter){return this.view.focusPreviousPage(o,F)}focusLast(o,F=this.focusNavigationFilter){this.view.focusLast(o,F)}focusFirst(o,F=this.focusNavigationFilter){this.view.focusFirst(o,F)}getFocus(){return this.focus.get()}reveal(o,F){this.model.expandTo(o);const j=this.model.getListIndex(o);j!==-1&&this.view.reveal(j,F)}getRelativeTop(o){const F=this.model.getListIndex(o);return F===-1?null:this.view.getRelativeTop(F)}getViewState(o=this.options.identityProvider){if(!o)throw new r.TreeError(this._user,"Can't get tree view state without an identity provider");const F=T=>o.getId(T).toString(),j=A.empty(this.scrollTop);for(const T of this.getFocus())j.focus.add(F(T));for(const T of this.getSelection())j.selection.add(F(T));const te=this.model.getNode(),S=[te];for(;S.length>0;){const T=S.shift();T!==te&&T.collapsible&&(j.expanded[F(T.element)]=T.collapsed?0:1),S.push(...T.children)}return j}onLeftArrow(o){o.preventDefault(),o.stopPropagation();const F=this.view.getFocusedElements();if(F.length===0)return;const j=F[0],te=this.model.getNodeLocation(j);if(!this.model.setCollapsed(te,!0)){const T=this.model.getParentNodeLocation(te);if(!T)return;const O=this.model.getListIndex(T);this.view.reveal(O),this.view.setFocus([O])}}onRightArrow(o){o.preventDefault(),o.stopPropagation();const F=this.view.getFocusedElements();if(F.length===0)return;const j=F[0],te=this.model.getNodeLocation(j);if(!this.model.setCollapsed(te,!1)){if(!j.children.some(b=>b.visible))return;const[T]=this.view.getFocus(),O=T+1;this.view.reveal(O),this.view.setFocus([O])}}onSpace(o){o.preventDefault(),o.stopPropagation();const F=this.view.getFocusedElements();if(F.length===0)return;const j=F[0],te=this.model.getNodeLocation(j),S=o.browserEvent.altKey;this.model.setCollapsed(te,void 0,S)}navigate(o){return new K(this.view,this.model,o)}dispose(){(0,C.dispose)(this.disposables),this.view.dispose()}}t.AbstractTree=_;class K{constructor(o,F,j){this.view=o,this.model=F,j?this.index=this.model.getListIndex(j):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(ge[129],me([1,0,128,119,24,26]),function(ee,t,E,I,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class w extends E.AbstractTree{constructor(c,u,d,P,r,l={}){super(c,u,d,P,l),this.user=c,this.dataSource=r,this.nodesByIdentity=new Map,this.identityProvider=l.identityProvider}getInput(){return this.input}setInput(c,u){if(u&&!this.identityProvider)throw new i.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=c,!c){this.nodesByIdentity.clear(),this.model.setChildren(null,W.Iterable.empty());return}if(!u){this._refresh(c);return}const d=[],P=[],r=e=>{const a=this.identityProvider.getId(e).toString();return!u.expanded[a]},l=e=>{const a=this.identityProvider.getId(e.element).toString();u.focus.has(a)&&d.push(e.element),u.selection.has(a)&&P.push(e.element)};this._refresh(c,r,l),this.setFocus(d),this.setSelection(P),u&&typeof u.scrollTop=="number"&&(this.scrollTop=u.scrollTop)}updateChildren(c=this.input){if(typeof this.input>"u")throw new i.TreeError(this.user,"Tree input not set");let u;this.identityProvider&&(u=d=>{const P=this.identityProvider.getId(d).toString(),r=this.nodesByIdentity.get(P);if(r)return r.collapsed}),this._refresh(c,u)}resort(c=this.input,u=!0){this.model.resort(c===this.input?null:c,u)}refresh(c){if(c===void 0){this.view.rerender();return}this.model.rerender(c)}_refresh(c,u,d){let P;if(this.identityProvider){const r=new Set,l=d;d=e=>{const a=this.identityProvider.getId(e.element).toString();r.add(a),this.nodesByIdentity.set(a,e),l?.(e)},P=e=>{const a=this.identityProvider.getId(e.element).toString();r.has(a)||this.nodesByIdentity.delete(a)}}this.model.setChildren(c===this.input?null:c,this.iterate(c,u).elements,{onDidCreateNode:d,onDidDeleteNode:P})}iterate(c,u){const d=[...this.dataSource.getChildren(c)];return{elements:W.Iterable.map(d,r=>{const{elements:l,size:e}=this.iterate(r,u),a=this.dataSource.hasChildren?this.dataSource.hasChildren(r):void 0,n=e===0?void 0:u&&u(r);return{element:r,children:l,collapsible:a,collapsed:n}}),size:d.length}}createModel(c,u,d){return new I.ObjectTreeModel(c,u,d)}}t.DataTree=w}),define(ge[64],me([1,0,13,9,31,27,25,7,3,2,50,10,6]),function(ee,t,E,I,i,W,w,y,c,u,d,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.deserialize=t.serialize=t.BufferWriter=t.BufferReader=void 0;var l;(function(ce){ce[ce.Promise=100]="Promise",ce[ce.PromiseCancel=101]="PromiseCancel",ce[ce.EventListen=102]="EventListen",ce[ce.EventDispose=103]="EventDispose"})(l||(l={}));function e(ce){switch(ce){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(ce){ce[ce.Initialize=200]="Initialize",ce[ce.PromiseSuccess=201]="PromiseSuccess",ce[ce.PromiseError=202]="PromiseError",ce[ce.PromiseErrorObj=203]="PromiseErrorObj",ce[ce.EventFire=204]="EventFire"})(a||(a={}));function n(ce){switch(ce){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(ce){ce[ce.Uninitialized=0]="Uninitialized",ce[ce.Idle=1]="Idle"})(h||(h={}));function s(ce){let ie=0;for(let q=0;;q+=7){const $=ce.read(1);if(ie|=($.buffer[0]&127)<<q,!($.buffer[0]&128))return ie}}const p=M(0);function v(ce,ie){if(ie===0){ce.write(p);return}let q=0;for(let V=ie;V!==0;V=V>>>7)q++;const $=i.VSBuffer.alloc(q);for(let V=0;ie!==0;V++)$.buffer[V]=ie&127,ie=ie>>>7,ie>0&&($.buffer[V]|=128);ce.write($)}class C{constructor(ie){this.buffer=ie,this.pos=0}read(ie){const q=this.buffer.slice(this.pos,this.pos+ie);return this.pos+=q.byteLength,q}}t.BufferReader=C;class f{constructor(){this.buffers=[]}get buffer(){return i.VSBuffer.concat(this.buffers)}write(ie){this.buffers.push(ie)}}t.BufferWriter=f;var D;(function(ce){ce[ce.Undefined=0]="Undefined",ce[ce.String=1]="String",ce[ce.Buffer=2]="Buffer",ce[ce.VSBuffer=3]="VSBuffer",ce[ce.Array=4]="Array",ce[ce.Object=5]="Object",ce[ce.Int=6]="Int"})(D||(D={}));function M(ce){const ie=i.VSBuffer.alloc(1);return ie.writeUInt8(ce,0),ie}const R={Undefined:M(D.Undefined),String:M(D.String),Buffer:M(D.Buffer),VSBuffer:M(D.VSBuffer),Array:M(D.Array),Object:M(D.Object),Uint:M(D.Int)},g=typeof Buffer<"u";function m(ce,ie){if(typeof ie>"u")ce.write(R.Undefined);else if(typeof ie=="string"){const q=i.VSBuffer.fromString(ie);ce.write(R.String),v(ce,q.byteLength),ce.write(q)}else if(g&&Buffer.isBuffer(ie)){const q=i.VSBuffer.wrap(ie);ce.write(R.Buffer),v(ce,q.byteLength),ce.write(q)}else if(ie instanceof i.VSBuffer)ce.write(R.VSBuffer),v(ce,ie.byteLength),ce.write(ie);else if(Array.isArray(ie)){ce.write(R.Array),v(ce,ie.length);for(const q of ie)m(ce,q)}else if(typeof ie=="number"&&(ie|0)===ie)ce.write(R.Uint),v(ce,ie);else{const q=i.VSBuffer.fromString(JSON.stringify(ie));ce.write(R.Object),v(ce,q.byteLength),ce.write(q)}}t.serialize=m;function L(ce){switch(ce.read(1).readUInt8(0)){case D.Undefined:return;case D.String:return ce.read(s(ce)).toString();case D.Buffer:return ce.read(s(ce)).buffer;case D.VSBuffer:return ce.read(s(ce));case D.Array:{const q=s(ce),$=[];for(let V=0;V<q;V++)$.push(L(ce));return $}case D.Object:return JSON.parse(ce.read(s(ce)).toString());case D.Int:return s(ce)}}t.deserialize=L;class k{constructor(ie,q,$=null,V=1e3){this.protocol=ie,this.ctx=q,this.logger=$,this.timeoutDelay=V,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(_=>this.onRawMessage(_)),this.sendResponse({type:200})}registerChannel(ie,q){this.channels.set(ie,q),setTimeout(()=>this.flushPendingRequests(ie),0)}sendResponse(ie){switch(ie.type){case 200:{const q=this.send([ie.type]);this.logger?.logOutgoing(q,0,1,n(ie.type));return}case 201:case 202:case 204:case 203:{const q=this.send([ie.type,ie.id],ie.data);this.logger?.logOutgoing(q,ie.id,1,n(ie.type),ie.data);return}}}send(ie,q=void 0){const $=new f;return m($,ie),m($,q),this.sendBuffer($.buffer)}sendBuffer(ie){try{return this.protocol.send(ie),ie.byteLength}catch{return 0}}onRawMessage(ie){const q=new C(ie),$=L(q),V=L(q),_=$[0];switch(_){case 100:return this.logger?.logIncoming(ie.byteLength,$[1],1,`${e(_)}: ${$[2]}.${$[3]}`,V),this.onPromise({type:_,id:$[1],channelName:$[2],name:$[3],arg:V});case 102:return this.logger?.logIncoming(ie.byteLength,$[1],1,`${e(_)}: ${$[2]}.${$[3]}`,V),this.onEventListen({type:_,id:$[1],channelName:$[2],name:$[3],arg:V});case 101:return this.logger?.logIncoming(ie.byteLength,$[1],1,`${e(_)}`),this.disposeActiveRequest({type:_,id:$[1]});case 103:return this.logger?.logIncoming(ie.byteLength,$[1],1,`${e(_)}`),this.disposeActiveRequest({type:_,id:$[1]})}}onPromise(ie){const q=this.channels.get(ie.channelName);if(!q){this.collectPendingRequest(ie);return}const $=new W.CancellationTokenSource;let V;try{V=q.call(this.ctx,ie.name,ie.arg,$.token)}catch(z){V=Promise.reject(z)}const _=ie.id;V.then(z=>{this.sendResponse({id:_,data:z,type:201}),this.activeRequests.delete(ie.id)},z=>{z instanceof Error?this.sendResponse({id:_,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.sendResponse({id:_,data:z,type:203}),this.activeRequests.delete(ie.id)});const K=(0,u.toDisposable)(()=>$.cancel());this.activeRequests.set(ie.id,K)}onEventListen(ie){const q=this.channels.get(ie.channelName);if(!q){this.collectPendingRequest(ie);return}const $=ie.id,_=q.listen(this.ctx,ie.name,ie.arg)(K=>this.sendResponse({id:$,data:K,type:204}));this.activeRequests.set(ie.id,_)}disposeActiveRequest(ie){const q=this.activeRequests.get(ie.id);q&&(q.dispose(),this.activeRequests.delete(ie.id))}collectPendingRequest(ie){let q=this.pendingRequests.get(ie.channelName);q||(q=[],this.pendingRequests.set(ie.channelName,q));const $=setTimeout(()=>{console.error(`Unknown channel: ${ie.channelName}`),ie.type===100&&this.sendResponse({id:ie.id,data:{name:"Unknown channel",message:`Channel name '${ie.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:ie,timeoutTimer:$})}flushPendingRequests(ie){const q=this.pendingRequests.get(ie);if(q){for(const $ of q)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(ie)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,u.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=k;var A;(function(ce){ce[ce.LocalSide=0]="LocalSide",ce[ce.OtherSide=1]="OtherSide"})(A||(t.RequestInitiator=A={}));class H{constructor(ie,q=null){this.protocol=ie,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=q}getChannel(ie){const q=this;return{call($,V,_){return q.isDisposed?Promise.reject(new y.CancellationError):q.requestPromise(ie,$,V,_)},listen($,V){return q.isDisposed?c.Event.None:q.requestEvent(ie,$,V)}}}requestPromise(ie,q,$,V=W.CancellationToken.None){const _=this.lastRequestId++,z={id:_,type:100,channelName:ie,name:q,arg:$};if(V.isCancellationRequested)return Promise.reject(new y.CancellationError);let o;return new Promise((j,te)=>{if(V.isCancellationRequested)return te(new y.CancellationError);const S=()=>{const x=B=>{switch(B.type){case 201:this.handlers.delete(_),j(B.data);break;case 202:{this.handlers.delete(_);const N=new Error(B.data.message);N.stack=Array.isArray(B.data.stack)?B.data.stack.join(`
`):B.data.stack,N.name=B.data.name,te(N);break}case 203:this.handlers.delete(_),te(B.data);break}};this.handlers.set(_,x),this.sendRequest(z)};let T=null;this.state===h.Idle?S():(T=(0,I.createCancelablePromise)(x=>this.whenInitialized()),T.then(()=>{T=null,S()}));const O=()=>{T?(T.cancel(),T=null):this.sendRequest({id:_,type:101}),te(new y.CancellationError)},b=V.onCancellationRequested(O);o=(0,u.combinedDisposable)((0,u.toDisposable)(O),b),this.activeRequests.add(o)}).finally(()=>{this.activeRequests.delete(o)})}requestEvent(ie,q,$){const V=this.lastRequestId++,K={id:V,type:102,channelName:ie,name:q,arg:$};let z=null;const o=new c.Emitter({onWillAddFirstListener:()=>{z=(0,I.createCancelablePromise)(j=>this.whenInitialized()),z.then(()=>{z=null,this.activeRequests.add(o),this.sendRequest(K)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.activeRequests.delete(o),this.sendRequest({id:V,type:103}))}}),F=j=>o.fire(j.data);return this.handlers.set(V,F),o.event}sendRequest(ie){switch(ie.type){case 100:case 102:{const q=this.send([ie.type,ie.id,ie.channelName,ie.name],ie.arg);this.logger?.logOutgoing(q,ie.id,0,`${e(ie.type)}: ${ie.channelName}.${ie.name}`,ie.arg);return}case 101:case 103:{const q=this.send([ie.type,ie.id]);this.logger?.logOutgoing(q,ie.id,0,e(ie.type));return}}}send(ie,q=void 0){const $=new f;return m($,ie),m($,q),this.sendBuffer($.buffer)}sendBuffer(ie){try{return this.protocol.send(ie),ie.byteLength}catch{return 0}}onBuffer(ie){const q=new C(ie),$=L(q),V=L(q),_=$[0];switch(_){case 200:return this.logger?.logIncoming(ie.byteLength,0,0,n(_)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(ie.byteLength,$[1],0,n(_),V),this.onResponse({type:$[0],id:$[1],data:V})}}onResponse(ie){if(ie.type===200){this.state=h.Idle,this._onDidInitialize.fire();return}this.handlers.get(ie.id)?.(ie)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,u.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelClient=H,qe([w.memoize],H.prototype,"onDidInitializePromise",null);class G{get connections(){const ie=[];return this._connections.forEach(q=>ie.push(q)),ie}constructor(ie){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,ie(({protocol:q,onDidClientDisconnect:$})=>{c.Event.once(q.onMessage)(_=>{const K=new C(_),z=L(K),o=new k(q,z),F=new H(q);this.channels.forEach((te,S)=>o.registerChannel(S,te));const j={channelServer:o,channelClient:F,ctx:z};this._connections.add(j),this._onDidAddConnection.fire(j),$(()=>{o.dispose(),F.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}getChannel(ie,q){const $=this;return{call(V,_,K){let z;if((0,r.isFunction)(q)){const F=(0,E.getRandomElement)($.connections.filter(q));z=F?Promise.resolve(F):c.Event.toPromise(c.Event.filter($.onDidAddConnection,q))}else z=q.routeCall($,V,_);const o=z.then(F=>F.channelClient.getChannel(ie));return se(o).call(V,_,K)},listen(V,_){if((0,r.isFunction)(q))return $.getMulticastEvent(ie,q,V,_);const K=q.routeEvent($,V,_).then(z=>z.channelClient.getChannel(ie));return se(K).listen(V,_)}}}getMulticastEvent(ie,q,$,V){const _=this;let K=new u.DisposableStore;const z=new c.Emitter({onWillAddFirstListener:()=>{K=new u.DisposableStore;const o=new c.EventMultiplexer,F=new Map,j=S=>{const O=S.channelClient.getChannel(ie).listen($,V),b=o.add(O);F.set(S,b)},te=S=>{const T=F.get(S);T&&(T.dispose(),F.delete(S))};_.connections.filter(q).forEach(j),c.Event.filter(_.onDidAddConnection,q)(j,void 0,K),_.onDidRemoveConnection(te,void 0,K),o.event(z.fire,z,K),K.add(o)},onDidRemoveLastListener:()=>{K.dispose()}});return z.event}registerChannel(ie,q){this.channels.set(ie,q),this._connections.forEach($=>{$.channelServer.registerChannel(ie,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=G;class ne{constructor(ie,q,$=null){const V=new f;m(V,q),ie.send(V.buffer),this.channelClient=new H(ie,$),this.channelServer=new k(ie,q,$)}getChannel(ie){return this.channelClient.getChannel(ie)}registerChannel(ie,q){this.channelServer.registerChannel(ie,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=ne;function se(ce){return{call(ie,q,$){return ce.then(V=>V.call(ie,q,$))},listen(ie,q){const $=new c.Relay;return ce.then(V=>$.input=V.listen(ie,q)),$.event}}}t.getDelayedChannel=se;function de(ce){let ie=!1;return{call(q,$,V){return ie?ce.call(q,$,V):(0,I.timeout)(0).then(()=>ie=!0).then(()=>ce.call(q,$,V))},listen(q,$){if(ie)return ce.listen(q,$);const V=new c.Relay;return(0,I.timeout)(0).then(()=>ie=!0).then(()=>V.input=ce.listen(q,$)),V.event}}}t.getNextTickChannel=de;class ue{constructor(ie){this.fn=ie}routeCall(ie){return this.route(ie)}routeEvent(ie){return this.route(ie)}async route(ie){for(const q of ie.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await c.Event.toPromise(ie.onDidAddConnection),await this.route(ie)}}t.StaticRouter=ue;var re;(function(ce){function ie(_,K){const z=_,o=K&&K.disableMarshalling,F=new Map;for(const j in z)$(j)&&F.set(j,c.Event.buffer(z[j],!0));return new class{listen(j,te,S){const T=F.get(te);if(T)return T;if(V(te)){const O=z[te];if(typeof O=="function")return O.call(z,S)}throw new Error(`Event not found: ${te}`)}call(j,te,S){const T=z[te];if(typeof T=="function"){if(!o&&Array.isArray(S))for(let O=0;O<S.length;O++)S[O]=(0,d.revive)(S[O]);return T.apply(z,S)}throw new Error(`Method not found: ${te}`)}}}ce.fromService=ie;function q(_,K){const z=K&&K.disableMarshalling;return new Proxy({},{get(o,F){if(typeof F=="string")return K?.properties?.has(F)?K.properties.get(F):V(F)?function(j){return _.listen(F,j)}:$(F)?_.listen(F):async function(...j){let te;K&&!(0,r.isUndefinedOrNull)(K.context)?te=[K.context,...j]:te=j;const S=await _.call(F,te);return z?S:(0,d.revive)(S)};throw new Error(`Property not found: ${String(F)}`)}})}ce.toService=q;function $(_){return _[0]==="o"&&_[1]==="n"&&P.isUpperAsciiLetter(_.charCodeAt(2))}function V(_){return/^onDynamic/.test(_)&&P.isUpperAsciiLetter(_.charCodeAt(9))}})(re||(t.ProxyChannel=re={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ye(ce){if(Array.isArray(ce))return ce;if(ce&&typeof ce=="object"&&typeof ce.toString=="function"){const ie=ce.toString();if(ie!=="[object Object]")return ie}return ce}function Te(ce){return Array.isArray(ce)?ce.map(ye):ye(ce)}function Me(ce,ie,q,$,V,_,K){K=Te(K);const z=le[V],o=z[$%z.length];let F=[`%c[${ce}]%c[${String(ie).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String($).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${o}`];/\($/.test(_)?(F=F.concat(K),F.push(")")):F.push(K),console.log.apply(console,F)}class Oe{constructor(ie,q){this._outgoingPrefix=ie,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(ie,q,$,V,_){this._totalOutgoing+=ie,Me(this._outgoingPrefix,this._totalOutgoing,ie,q,$,V,_)}logIncoming(ie,q,$,V,_){this._totalIncoming+=ie,Me(this._incomingPrefix,this._totalIncoming,ie,q,$,V,_)}}t.IPCLogger=Oe}),define(ge[29],me([1,0,5]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=E.globals.vscode.ipcRenderer,t.ipcMessagePort=E.globals.vscode.ipcMessagePort,t.webFrame=E.globals.vscode.webFrame,t.process=E.globals.vscode.process,t.context=E.globals.vscode.context}),define(ge[130],me([1,0,86,29]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let i=0;function W(y,c,u){const d=[],P=i++,r=`vscode:onContextMenu${P}`,l=(e,a,n)=>{d[a].click?.(n)};I.ipcRenderer.once(r,l),I.ipcRenderer.once(E.CONTEXT_MENU_CLOSE_CHANNEL,(e,a)=>{a===P&&(I.ipcRenderer.removeListener(r,l),u?.())}),I.ipcRenderer.send(E.CONTEXT_MENU_CHANNEL,P,y.map(e=>w(e,d)),r,c)}t.popup=W;function w(y,c){const u={id:c.length,label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:typeof y.enabled=="boolean"?y.enabled:!0,visible:typeof y.visible=="boolean"?y.visible:!0};return c.push(y),Array.isArray(y.submenu)&&(u.submenu=y.submenu.map(d=>w(d,c))),u}}),define(ge[131],me([1,0,31,3,64,87,29]),function(ee,t,E,I,i,W,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class y extends i.IPCClient{static createProtocol(){const u=I.Event.fromNodeEventEmitter(w.ipcRenderer,"vscode:message",(d,P)=>E.VSBuffer.wrap(P));return w.ipcRenderer.send("vscode:hello"),new W.Protocol(w.ipcRenderer,u)}constructor(u){const d=y.createProtocol();super(d,u),this.protocol=d}dispose(){this.protocol.disconnect()}}t.Client=y}),define(ge[132],me([12,11]),function(ee,t){return ee.create("vs/platform/files/common/files",t)}),define(ge[133],me([12,11]),function(ee,t){return ee.create("vs/platform/theme/common/iconRegistry",t)}),define(ge[38],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var E;(function(w){w.serviceIds=new Map,w.DI_TARGET="$di$target",w.DI_DEPENDENCIES="$di$dependencies";function y(c){return c[w.DI_DEPENDENCIES]||[]}w.getServiceDependencies=y})(E||(t._util=E={})),t.IInstantiationService=i("instantiationService");function I(w,y,c){y[E.DI_TARGET]===y?y[E.DI_DEPENDENCIES].push({id:w,index:c}):(y[E.DI_DEPENDENCIES]=[{id:w,index:c}],y[E.DI_TARGET]=y)}function i(w){if(E.serviceIds.has(w))return E.serviceIds.get(w);const y=function(c,u,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(y,c,d)};return y.toString=()=>w,E.serviceIds.set(w,y),y}t.createDecorator=i;function W(w){return w}t.refineServiceDecorator=W}),define(ge[134],me([1,0,38]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,E.createDecorator)(t.ID);function I(W){return!!W.hostName&&!!W.errorMessage}t.isRemoteDiagnosticError=I;class i{async getPerformanceInfo(w,y){return{}}async getSystemInfo(w,y){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(w,y){return""}async getWorkspaceFileExtensions(w){return{extensions:[]}}async reportWorkspaceStats(w){}}t.NullDiagnosticsService=i}),define(ge[135],me([1,0,85,22,10,6,15,132,38,5,28]),function(ee,t,E,I,i,W,w,y,c,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLargeFileConfirmationLimit=t.ByteSize=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_READONLY_FROM_PERMISSIONS_CONFIG=t.FILES_READONLY_EXCLUDE_CONFIG=t.FILES_READONLY_INCLUDE_CONFIG=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.TooLargeFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasReadonlyCapability=t.hasFileAtomicDeleteCapability=t.hasFileAtomicWriteCapability=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,c.createDecorator)("fileService");function P(q){return q.create===!0}t.isFileOpenForWriteOptions=P;var r;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(r||(t.FileType=r={}));var l;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(l||(t.FilePermission=l={}));var e;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(e||(t.FileSystemProviderCapabilities=e={}));function a(q){return!!(q.capabilities&2)}t.hasReadWriteCapability=a;function n(q){return!!(q.capabilities&8)}t.hasFileFolderCopyCapability=n;function h(q){return!!(q.capabilities&131072)}t.hasFileCloneCapability=h;function s(q){return!!(q.capabilities&4)}t.hasOpenReadWriteCloseCapability=s;function p(q){return!!(q.capabilities&16)}t.hasFileReadStreamCapability=p;function v(q){return a(q)?!!(q.capabilities&16384):!1}t.hasFileAtomicReadCapability=v;function C(q){return a(q)?!!(q.capabilities&32768):!1}t.hasFileAtomicWriteCapability=C;function f(q){return!!(q.capabilities&65536)}t.hasFileAtomicDeleteCapability=f;function D(q){return!!(q.capabilities&2048)}t.hasReadonlyCapability=D;var M;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(M||(t.FileSystemProviderErrorCode=M={}));class R extends Error{static create($,V){const _=new R($.toString(),V);return L(_,V),_}constructor($,V){super($),this.code=V}}t.FileSystemProviderError=R;function g(q,$){return R.create(q,$)}t.createFileSystemProviderError=g;function m(q){return q||g((0,y.localize)(0,null),M.Unknown)}t.ensureFileSystemProviderError=m;function L(q,$){return q.name=$?`${$} (FileSystemError)`:"FileSystemError",q}t.markAsFileSystemProviderError=L;function k(q){if(!q)return M.Unknown;if(q instanceof R)return q.code;const $=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!$)return M.Unknown;switch($[1]){case M.FileExists:return M.FileExists;case M.FileIsADirectory:return M.FileIsADirectory;case M.FileNotADirectory:return M.FileNotADirectory;case M.FileNotFound:return M.FileNotFound;case M.FileTooLarge:return M.FileTooLarge;case M.FileWriteLocked:return M.FileWriteLocked;case M.NoPermissions:return M.NoPermissions;case M.Unavailable:return M.Unavailable}return M.Unknown}t.toFileSystemProviderErrorCode=k;function A(q){if(q instanceof ue)return q.fileOperationResult;switch(k(q)){case M.FileNotFound:return 1;case M.FileIsADirectory:return 0;case M.FileNotADirectory:return 9;case M.FileWriteLocked:return 5;case M.NoPermissions:return 6;case M.FileExists:return 4;case M.FileTooLarge:return 7;default:return 10}}t.toFileOperationResult=A;var H;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(H||(t.FileOperation=H={}));class G{constructor($,V,_){this.resource=$,this.operation=V,this.target=_}isOperation($){return this.operation===$}}t.FileOperationEvent=G;var ne;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(ne||(t.FileChangeType=ne={}));class se{constructor($,V){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const _=new Map;for(const K of $){const z=_.get(K.type);switch(z?z.push([K.resource,K]):_.set(K.type,[[K.resource,K]]),K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}}for(const[K,z]of _)switch(K){case 1:this.added=E.TernarySearchTree.forUris(()=>V),this.added.fill(z);break;case 0:this.updated=E.TernarySearchTree.forUris(()=>V),this.updated.fill(z);break;case 2:this.deleted=E.TernarySearchTree.forUris(()=>V),this.deleted.fill(z);break}}contains($,...V){return this.doContains($,{includeChildren:!1},...V)}affects($,...V){return this.doContains($,{includeChildren:!0},...V)}doContains($,V,..._){if(!$)return!1;const K=_.length>0;return!!((!K||_.includes(1))&&(this.added?.get($)||V.includeChildren&&this.added?.findSuperstr($))||(!K||_.includes(0))&&(this.updated?.get($)||V.includeChildren&&this.updated?.findSuperstr($))||(!K||_.includes(2))&&(this.deleted?.findSubstr($)||V.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}t.FileChangesEvent=se;function de(q,$,V){return!q||!$||q===$||$.length>q.length?!1:($.charAt($.length-1)!==I.sep&&($+=I.sep),V?(0,i.startsWithIgnoreCase)(q,$):q.indexOf($)===0)}t.isParent=de;class ue extends Error{constructor($,V,_){super($),this.fileOperationResult=V,this.options=_}}t.FileOperationError=ue;class re extends ue{constructor($,V,_,K){super($,V,K),this.fileOperationResult=V,this.size=_}}t.TooLargeFileOperationError=re;class le extends ue{constructor($,V,_){super($,2,_),this.stat=V}}t.NotModifiedSinceFileOperationError=le;var ye;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ye||(t.FileOperationResult=ye={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude",t.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",t.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",t.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var Te;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(Te||(t.FileKind=Te={})),t.ETAG_DISABLED="";function Me(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}t.etag=Me;async function Oe(q,$){if(!$.hasProvider(w.URI.from({scheme:q.scheme})))return new Promise(V=>{const _=$.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===q.scheme&&K.added&&(_.dispose(),V())})})}t.whenProviderRegistered=Oe;class ce{static formatSize($){return(0,W.isNumber)($)||($=0),$<ce.KB?(0,y.localize)(1,null,$.toFixed(0)):$<ce.MB?(0,y.localize)(2,null,($/ce.KB).toFixed(2)):$<ce.GB?(0,y.localize)(3,null,($/ce.MB).toFixed(2)):$<ce.TB?(0,y.localize)(4,null,($/ce.GB).toFixed(2)):(0,y.localize)(5,null,($/ce.TB).toFixed(2))}}t.ByteSize=ce,ce.KB=1024,ce.MB=ce.KB*ce.KB,ce.GB=ce.MB*ce.KB,ce.TB=ce.GB*ce.KB;function ie(q){const $=typeof q=="string"||q?.scheme===d.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===d.Schemas.file?1024*ce.MB:$?10*ce.MB:u.isWeb?50*ce.MB:1024*ce.MB}t.getLargeFileConfirmationLimit=ie}),define(ge[136],me([1,0,38]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MainProcessService=t.IMainProcessService=void 0,t.IMainProcessService=(0,E.createDecorator)("mainProcessService");class I{constructor(W,w){this.server=W,this.router=w}getChannel(W){return this.server.getChannel(W,this.router)}registerChannel(W,w){this.server.registerChannel(W,w)}}t.MainProcessService=I}),define(ge[137],me([1,0,2,131]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class i extends E.Disposable{constructor(w){super(),this.mainProcessConnection=this._register(new I.Client(`window:${w}`))}getChannel(w){return this.mainProcessConnection.getChannel(w)}registerChannel(w,y){this.mainProcessConnection.registerChannel(w,y)}}t.ElectronIPCMainProcessService=i});var hi=this&&this.__param||function(ee,t){return function(E,I){t(E,I,ee)}};define(ge[138],me([1,0,64,136]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let i=t.NativeHostService=class{constructor(w,y){return this.windowId=w,E.ProxyChannel.toService(y.getChannel("nativeHost"),{context:w,properties:(()=>{const c=new Map;return c.set("windowId",w),c})()})}};t.NativeHostService=i=qe([hi(1,I.IMainProcessService)],i)}),define(ge[65],me([1,0,72,6]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class i{constructor(){this.data=new Map}add(w,y){E.ok(I.isString(w)),E.ok(I.isObject(y)),E.ok(!this.data.has(w),"There is already an extension with this id"),this.data.set(w,y)}knows(w){return this.data.has(w)}as(w){return this.data.get(w)||null}}t.Registry=new i}),define(ge[139],me([1,0,3,65]),function(ee,t,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function i(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class W{constructor(){this._onDidChangeSchema=new E.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,u){this.schemasById[i(c)]=u,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const w=new W;I.Registry.add(t.Extensions.JSONContribution,w)}),define(ge[140],me([1,0,9,17,18,3,6,15,133,139,65]),function(ee,t,E,I,i,W,w,y,c,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var P;(function(v){function C(f,D){let M=f.defaults;for(;i.ThemeIcon.isThemeIcon(M);){const R=e.getIcon(M.id);if(!R)return;M=R.defaults}return M}v.getDefinition=C})(P||(t.IconContribution=P={}));var r;(function(v){function C(D){return{weight:D.weight,style:D.style,src:D.src.map(M=>({format:M.format,location:M.location.toString()}))}}v.toJSONObject=C;function f(D){const M=R=>(0,w.isString)(R)?R:void 0;if(D&&Array.isArray(D.src)&&D.src.every(R=>(0,w.isString)(R.format)&&(0,w.isString)(R.location)))return{weight:M(D.weight),style:M(D.style),src:D.src.map(R=>({format:R.format,location:y.URI.parse(R.location)}))}}v.fromJSONObject=f})(r||(t.IconFontDefinition=r={}));class l{constructor(){this._onDidChange=new W.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(C,f,D,M){const R=this.iconsById[C];if(R){if(D&&!R.description){R.description=D,this.iconSchema.properties[C].markdownDescription=`${D} $(${C})`;const L=this.iconReferenceSchema.enum.indexOf(C);L!==-1&&(this.iconReferenceSchema.enumDescriptions[L]=D),this._onDidChange.fire()}return R}const g={id:C,description:D,defaults:f,deprecationMessage:M};this.iconsById[C]=g;const m={$ref:"#/definitions/icons"};return M&&(m.deprecationMessage=M),D&&(m.markdownDescription=`${D}: $(${C})`),this.iconSchema.properties[C]=m,this.iconReferenceSchema.enum.push(C),this.iconReferenceSchema.enumDescriptions.push(D||""),this._onDidChange.fire(),{id:C}}deregisterIcon(C){delete this.iconsById[C],delete this.iconSchema.properties[C];const f=this.iconReferenceSchema.enum.indexOf(C);f!==-1&&(this.iconReferenceSchema.enum.splice(f,1),this.iconReferenceSchema.enumDescriptions.splice(f,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(C=>this.iconsById[C])}getIcon(C){return this.iconsById[C]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(C,f){const D=this.iconFontsById[C];return D||(this.iconFontsById[C]=f,this._onDidChange.fire(),f)}deregisterIconFont(C){delete this.iconFontsById[C]}getIconFont(C){return this.iconFontsById[C]}toString(){const C=(R,g)=>R.id.localeCompare(g.id),f=R=>{for(;i.ThemeIcon.isThemeIcon(R.defaults);)R=this.iconsById[R.defaults.id];return`codicon codicon-${R?R.id:""}`},D=[];D.push("| preview     | identifier                        | default codicon ID                | description"),D.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const M=Object.keys(this.iconsById).map(R=>this.iconsById[R]);for(const R of M.filter(g=>!!g.description).sort(C))D.push(`|<i class="${f(R)}"></i>|${R.id}|${i.ThemeIcon.isThemeIcon(R.defaults)?R.defaults.id:R.id}|${R.description||""}|`);D.push("| preview     | identifier                        "),D.push("| ----------- | --------------------------------- |");for(const R of M.filter(g=>!i.ThemeIcon.isThemeIcon(g.defaults)).sort(C))D.push(`|<i class="${f(R)}"></i>|${R.id}|`);return D.join(`
`)}}const e=new l;d.Registry.add(t.Extensions.IconContribution,e);function a(v,C,f,D){return e.registerIcon(v,C,f,D)}t.registerIcon=a;function n(){return e}t.getIconRegistry=n;function h(){const v=(0,I.getCodiconFontCharacters)();for(const C in v){const f="\\"+v[C].toString(16);e.registerIcon(C,{fontCharacter:f})}}h(),t.iconsSchemaId="vscode://schemas/icons";const s=d.Registry.as(u.Extensions.JSONContribution);s.registerSchema(t.iconsSchemaId,e.getIconSchema());const p=new E.RunOnceScheduler(()=>s.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{p.isScheduled()||p.schedule()}),t.widgetClose=a("widget-close",I.Codicon.close,(0,c.localize)(2,null)),t.gotoPreviousLocation=a("goto-previous-location",I.Codicon.arrowUp,(0,c.localize)(3,null)),t.gotoNextLocation=a("goto-next-location",I.Codicon.arrowDown,(0,c.localize)(4,null)),t.syncing=i.ThemeIcon.modify(I.Codicon.sync,"spin"),t.spinningLoading=i.ThemeIcon.modify(I.Codicon.loading,"spin")}),define(ge[141],me([1,0,4,3,18,140]),function(ee,t,E,I,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function w(c){const u=new I.Emitter,d=(0,W.getIconRegistry)();return d.onDidChange(()=>u.fire()),c?.onDidProductIconThemeChange(()=>u.fire()),{onDidChange:u.event,getCSS(){const P=c?c.getProductIconTheme():new y,r={},l=a=>{const n=P.getIcon(a);if(!n)return;const h=n.font;return h?(r[h.id]=h.definition,`.codicon-${a.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,E.asCSSPropertyValue)(h.id)}; }`):`.codicon-${a.id}:before { content: '${n.fontCharacter}'; }`},e=[];for(const a of d.getIcons()){const n=l(a);n&&e.push(n)}for(const a in r){const n=r[a],h=n.weight?`font-weight: ${n.weight};`:"",s=n.style?`font-style: ${n.style};`:"",p=n.src.map(v=>`${(0,E.asCSSUrl)(v.location)} format('${v.format}')`).join(", ");e.push(`@font-face { src: ${p}; font-family: ${(0,E.asCSSPropertyValue)(a)};${h}${s} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=w;class y{getIcon(u){const d=(0,W.getIconRegistry)();let P=u.defaults;for(;i.ThemeIcon.isThemeIcon(P);){const r=d.getIcon(P.id);if(!r)return;P=r.defaults}return P}}t.UnthemedProductIconTheme=y}),define(ge[142],me([1,0,5]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function I(d){return!!d.workspaceUri}t.isWorkspaceToOpen=I;function i(d){return!!d.folderUri}t.isFolderToOpen=i;function W(d){return!!d.fileUri}t.isFileToOpen=W;function w(d){const P=y(d),r=d.getValue("window.menuBarVisibility");return r==="default"||P==="native"&&r==="compact"||E.isMacintosh&&E.isNative?"classic":r}t.getMenuBarVisibility=w;function y(d){if(E.isWeb)return"custom";const P=d.getValue("window");if(P){if(E.isMacintosh&&P.nativeTabs===!0||E.isMacintosh&&P.nativeFullScreen===!1)return"native";const e=P.titleBarStyle;if(e==="native"||e==="custom")return e}return E.isLinux?"native":"custom"}t.getTitleBarStyle=y;function c(d){if(!E.isWindows||E.isWeb||y(d)==="native")return!1;const P=d.getValue("window.experimental.windowControlsOverlay.enabled");return typeof P=="boolean"?P:!0}t.useWindowControlsOverlay=c;function u(d=0){return Math.pow(1.2,d)}t.zoomLevelToZoomFactor=u}),define(ge[143],me([1,0,16,29,142]),function(ee,t,E,I,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function W(c){I.webFrame.setZoomLevel(c),(0,E.setZoomFactor)((0,i.zoomLevelToZoomFactor)(c)),(0,E.setZoomLevel)(c,!1)}t.applyZoom=W;function w(){W((0,E.getZoomLevel)()+1)}t.zoomIn=w;function y(){W((0,E.getZoomLevel)()-1)}t.zoomOut=y}),define(ge[144],me([1,0,11,4,129,9,130,29,134,135,137,138,141,143,14,100,91]),function(ee,t,E,I,i,W,w,y,c,u,d,P,r,l,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const a=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,n=/\s--inspect-port=(?<port>\d+)/;class h{getHeight(A){return 22}getTemplateId(A){return R(A)?"process":D(A)?"machine":(0,c.isRemoteDiagnosticError)(A)?"error":M(A)?"header":""}}class s{hasChildren(A){return(0,c.isRemoteDiagnosticError)(A)?!1:R(A)?!!A.children?.length:!0}getChildren(A){return R(A)?A.children?A.children:[]:(0,c.isRemoteDiagnosticError)(A)?[]:M(A)?A.processRoots.length>1?A.processRoots:[A.processRoots[0].rootProcess]:D(A)?[A.rootProcess]:[A.processes]}}class p{constructor(){this.templateId="header"}renderTemplate(A){const H=(0,I.append)(A,(0,I.$)(".row")),G=(0,I.append)(H,(0,I.$)(".nameLabel")),ne=(0,I.append)(H,(0,I.$)(".cpu")),se=(0,I.append)(H,(0,I.$)(".memory")),de=(0,I.append)(H,(0,I.$)(".pid"));return{name:G,CPU:ne,memory:se,PID:de}}renderElement(A,H,G,ne){G.name.textContent=(0,E.localize)(0,null),G.CPU.textContent=(0,E.localize)(1,null),G.PID.textContent=(0,E.localize)(2,null),G.memory.textContent=(0,E.localize)(3,null)}disposeTemplate(A){}}class v{constructor(){this.templateId="machine"}renderTemplate(A){const H=Object.create(null),G=(0,I.append)(A,(0,I.$)(".row"));return H.name=(0,I.append)(G,(0,I.$)(".nameLabel")),H}renderElement(A,H,G,ne){G.name.textContent=A.element.name}disposeTemplate(A){}}class C{constructor(){this.templateId="error"}renderTemplate(A){const H=Object.create(null),G=(0,I.append)(A,(0,I.$)(".row"));return H.name=(0,I.append)(G,(0,I.$)(".nameLabel")),H}renderElement(A,H,G,ne){G.name.textContent=A.element.errorMessage}disposeTemplate(A){}}class f{constructor(A,H,G){this.platform=A,this.totalMem=H,this.mapPidToName=G,this.templateId="process"}renderTemplate(A){const H=(0,I.append)(A,(0,I.$)(".row")),G=(0,I.append)(H,(0,I.$)(".nameLabel")),ne=(0,I.append)(H,(0,I.$)(".cpu")),se=(0,I.append)(H,(0,I.$)(".memory")),de=(0,I.append)(H,(0,I.$)(".pid"));return{name:G,CPU:ne,PID:de,memory:se}}renderElement(A,H,G,ne){const{element:se}=A,de=se.pid.toFixed(0);let ue=se.name;this.mapPidToName.has(se.pid)&&(ue=this.mapPidToName.get(se.pid)),G.name.textContent=ue,G.name.title=se.cmd,G.CPU.textContent=se.load.toFixed(0),G.PID.textContent=de,G.PID.parentElement.id=`pid-${de}`;const re=this.platform==="win32"?se.mem:this.totalMem*(se.mem/100);G.memory.textContent=(re/u.ByteSize.MB).toFixed(0)}disposeTemplate(A){}}function D(k){return!!k.name&&!!k.rootProcess}function M(k){return!!k.processRoots}function R(k){return!!k.pid}class g{constructor(A,H){this.data=H,this.mapPidToName=new Map;const G=new d.ElectronIPCMainProcessService(A);this.nativeHostService=new P.NativeHostService(A,G),this.applyStyles(H.styles),this.setEventHandlers(H),y.ipcRenderer.on("vscode:pidToNameResponse",(ne,se)=>{this.mapPidToName=new Map;for(const[de,ue]of se)this.mapPidToName.set(de,ue)}),y.ipcRenderer.on("vscode:listProcessesResponse",async(ne,se)=>{se.forEach((de,ue)=>{R(de.rootProcess)&&(de.rootProcess.name=ue===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?(this.tree.setInput({processes:{processRoots:se}}),this.tree.layout(window.innerHeight,window.innerWidth)):await this.createProcessTree(se),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),y.ipcRenderer.send("vscode:pidToNameRequest"),y.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(A){document.onkeydown=H=>{const G=A.platform==="darwin"?H.metaKey:H.ctrlKey;G&&H.keyCode===87&&(H.stopPropagation(),H.preventDefault(),y.ipcRenderer.send("vscode:closeProcessExplorer")),G&&H.keyCode===187&&(0,l.zoomIn)(),G&&H.keyCode===189&&(0,l.zoomOut)()}}async createProcessTree(A){const H=document.getElementById("process-list");if(!H)return;const{totalmem:G}=await this.nativeHostService.getOSStatistics(),ne=[new f(this.data.platform,G,this.mapPidToName),new p,new v,new C];this.tree=new i.DataTree("processExplorer",H,new h,ne,new s,{identityProvider:{getId:se=>R(se)?se.pid.toString():(0,c.isRemoteDiagnosticError)(se)?se.hostName:M(se)?"processes":D(se)?se.name:"header"}}),this.tree.setInput({processes:{processRoots:A}}),this.tree.layout(window.innerHeight,window.innerWidth),this.tree.onKeyDown(se=>{const de=new e.StandardKeyboardEvent(se);if(de.keyCode===35&&de.altKey){const ue=this.getSelectedPids();Promise.all(ue.map(re=>this.nativeHostService.killProcess(re,"SIGTERM"))).then(()=>this.tree?.refresh())}}),this.tree.onContextMenu(se=>{R(se.element)&&this.showContextMenu(se.element,!0)}),H.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{H.style.height=`${window.innerHeight}px`,this.tree?.layout(window.innerHeight,window.innerWidth)})}isDebuggable(A){const H=a.exec(A);return H&&H.groups.port!=="0"||A.indexOf("node ")>=0||A.indexOf("node.exe")>=0}attachTo(A){const H={type:"node",request:"attach",name:`process ${A.pid}`};let G=a.exec(A.cmd);G?H.port=Number(G.groups.port):H.processId=String(A.pid),G=n.exec(A.cmd),G&&(H.port=Number(G.groups.port)),y.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[H]})}applyStyles(A){const H=(0,I.createStyleSheet)(),G=[];A.listFocusBackground&&(G.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${A.listFocusBackground}; }`),G.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${A.listFocusBackground}; }`)),A.listFocusForeground&&G.push(`.monaco-list:focus .monaco-list-row.focused { color: ${A.listFocusForeground}; }`),A.listActiveSelectionBackground&&(G.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${A.listActiveSelectionBackground}; }`),G.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${A.listActiveSelectionBackground}; }`)),A.listActiveSelectionForeground&&G.push(`.monaco-list:focus .monaco-list-row.selected { color: ${A.listActiveSelectionForeground}; }`),A.listHoverBackground&&G.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${A.listHoverBackground}; }`),A.listHoverForeground&&G.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${A.listHoverForeground}; }`),A.listFocusOutline&&G.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${A.listFocusOutline}; outline-offset: -1px; }`),A.listHoverOutline&&G.push(`.monaco-list-row:hover { outline: 1px dashed ${A.listHoverOutline}; outline-offset: -1px; }`),A.scrollbarShadowColor&&G.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${A.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${A.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${A.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),A.scrollbarSliderBackgroundColor&&G.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${A.scrollbarSliderBackgroundColor};
				}
			`),A.scrollbarSliderHoverBackgroundColor&&G.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${A.scrollbarSliderHoverBackgroundColor};
				}
			`),A.scrollbarSliderActiveBackgroundColor&&G.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${A.scrollbarSliderActiveBackgroundColor};
				}
			`),H.textContent=G.join(`
`),A.color&&(document.body.style.color=A.color)}showContextMenu(A,H){const G=[],ne=Number(A.pid);H&&(G.push({accelerator:"Alt+E",label:(0,E.localize)(4,null),click:()=>{this.nativeHostService.killProcess(ne,"SIGTERM")}}),G.push({label:(0,E.localize)(5,null),click:()=>{this.nativeHostService.killProcess(ne,"SIGKILL")}}),G.push({type:"separator"})),G.push({label:(0,E.localize)(6,null),click:()=>{const se=this.getSelectedPids();se?.includes(ne)||(se.length=0,se.push(ne));const de=se?.map(ue=>document.getElementById(`pid-${ue}`)).filter(ue=>!!ue);if(de){const ue=de.map(re=>re.innerText).filter(re=>!!re);this.nativeHostService.writeClipboardText(ue.join(`
`))}}}),G.push({label:(0,E.localize)(7,null),click:()=>{const se=document.getElementById("process-list");se&&this.nativeHostService.writeClipboardText(se.innerText)}}),A&&H&&this.isDebuggable(A.cmd)&&(G.push({type:"separator"}),G.push({label:(0,E.localize)(8,null),click:()=>{this.attachTo(A)}})),(0,w.popup)(G)}requestProcessList(A){setTimeout(()=>{const H=Date.now(),G=A+H-this.lastRequestTime;this.lastRequestTime=H,G>1e3?(y.ipcRenderer.send("vscode:pidToNameRequest"),y.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList(G)},200)}getSelectedPids(){return this.tree?.getSelection()?.map(A=>{if(!(!A||!("pid"in A)))return A.pid}).filter(A=>!!A)}}function m(){const k=(0,I.createStyleSheet)();k.id="codiconStyles";const A=(0,r.getIconsStyleSheet)(void 0);function H(){k.textContent=A.getCSS()}const G=new W.RunOnceScheduler(H,0);A.onDidChange(()=>G.schedule()),G.schedule()}function L(k){const A=k.data.platform==="win32"?"windows":k.data.platform==="linux"?"linux":"mac";document.body.classList.add(A),m(),(0,l.applyZoom)(k.data.zoomLevel),new g(k.windowId,k.data)}t.startup=L})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9d3b0fa210fb4535589e8296483a5b43fe5e660a/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
