/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/types","vs/nls","vs/base/common/uri","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/path","vs/base/common/buffer","vs/platform/userDataProfile/common/userDataProfile","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/resources","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/network","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/node/pfs","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/stream","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/hash","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/id","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ce=function(ne){for(var e=[],R=0,N=ne.length;R<N;R++)e[R]=ae[ne[R]];return e};define(ae[59],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function R(_){return(D,b,S)=>{let P=null,C=null;if(typeof S.value=="function"?(P="value",C=S.value):typeof S.get=="function"&&(P="get",C=S.get),!C)throw new Error("not supported");S[P]=_(C,b)}}function N(_,D,b){let S=null,P=null;if(typeof b.value=="function"?(S="value",P=b.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(S="get",P=b.get),!P)throw new Error("not supported");const C=`$memoize$${D}`;b[S]=function(...v){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,v)}),this[C]}}e.memoize=N;function L(_,D,b){return R((S,P)=>{const C=`$debounce$${P}`,v=`$debounce$result$${P}`;return function(...d){this[v]||(this[v]=b?b():void 0),clearTimeout(this[C]),D&&(this[v]=D(this[v],...d),d=[this[v]]),this[C]=setTimeout(()=>{S.apply(this,d),this[v]=b?b():void 0},_)}})}e.debounce=L;function T(_,D,b){return R((S,P)=>{const C=`$throttle$timer$${P}`,v=`$throttle$result$${P}`,d=`$throttle$lastRun$${P}`,g=`$throttle$pending$${P}`;return function(...w){if(this[v]||(this[v]=b?b():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),D&&(this[v]=D(this[v],...w)),this[g])return;const a=this[d]+_;a<=Date.now()?(this[d]=Date.now(),S.apply(this,[this[v]]),this[v]=b?b():void 0):(this[g]=!0,this[C]=setTimeout(()=>{this[g]=!1,this[d]=Date.now(),S.apply(this,[this[v]]),this[v]=b?b():void 0},a-Date.now()))}})}e.throttle=T}),define(ae[7],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?p.isErrorNoTelemetry(r)?new p(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(i=>{i(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=R,e.errorHandler=new R;function N(n){e.errorHandler.setUnexpectedErrorHandler(n)}e.setUnexpectedErrorHandler=N;function L(n){if(!n||typeof n!="object")return!1;const r=n;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=L;function T(n){S(n)||e.errorHandler.onUnexpectedError(n)}e.onUnexpectedError=T;function _(n){S(n)||e.errorHandler.onUnexpectedExternalError(n)}e.onUnexpectedExternalError=_;function D(n){if(n instanceof Error){const{name:r,message:i}=n,t=n.stacktrace||n.stack;return{$isError:!0,name:r,message:i,stack:t,noTelemetry:p.isErrorNoTelemetry(n)}}return n}e.transformErrorForSerialization=D;const b="Canceled";function S(n){return n instanceof P?!0:n instanceof Error&&n.name===b&&n.message===b}e.isCancellationError=S;class P extends Error{constructor(){super(b),this.name=this.message}}e.CancellationError=P;function C(){const n=new Error(b);return n.name=n.message,n}e.canceled=C;function v(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}e.illegalArgument=v;function d(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}e.illegalState=d;function g(n){return n?new Error(`readonly property '${n} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function w(n){const r=new Error(`${n} has been disposed`);return r.name="DISPOSED",r}e.disposed=w;function a(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}e.getErrorMessage=a;class u extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=u;class h extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=h;class E extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=E;class p extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof p)return r;const i=new p;return i.message=r.message,i.stack=r.stack,i}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=p;class k extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype)}}e.BugIndicatingError=k}),define(ae[21],ce([0,1,7]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function N($,H=0){return $[$.length-(1+H)]}e.tail=N;function L($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=L;function T($,H,te=(oe,ue)=>oe===ue){if($===H)return!0;if(!$||!H||$.length!==H.length)return!1;for(let oe=0,ue=$.length;oe<ue;oe++)if(!te($[oe],H[oe]))return!1;return!0}e.equals=T;function _($,H){const te=$.length-1;H<te&&($[H]=$[te]),$.pop()}e.removeFastWithoutKeepingOrder=_;function D($,H,te){return b($.length,oe=>te($[oe],H))}e.binarySearch=D;function b($,H){let te=0,oe=$-1;for(;te<=oe;){const ue=(te+oe)/2|0,de=H(ue);if(de<0)te=ue+1;else if(de>0)oe=ue-1;else return ue}return-(te+1)}e.binarySearch2=b;function S($,H){let te=0,oe=$.length;if(oe===0)return 0;for(;te<oe;){const ue=Math.floor((te+oe)/2);H($[ue])?oe=ue:te=ue+1}return te}e.findFirstInSorted=S;function P($,H,te){if($=$|0,$>=H.length)throw new TypeError("invalid index");const oe=H[Math.floor(H.length*Math.random())],ue=[],de=[],ve=[];for(const Ee of H){const Ce=te(Ee,oe);Ce<0?ue.push(Ee):Ce>0?de.push(Ee):ve.push(Ee)}return $<ue.length?P($,ue,te):$<ue.length+ve.length?ve[0]:P($-(ue.length+ve.length),de,te)}e.quickSelect=P;function C($,H){const te=[];let oe;for(const ue of $.slice(0).sort(H))!oe||H(oe[0],ue)!==0?(oe=[ue],te.push(oe)):oe.push(ue);return te}e.groupBy=C;function v($,H,te){const oe=[];function ue(Ee,Ce,De){if(Ce===0&&De.length===0)return;const Le=oe[oe.length-1];Le&&Le.start+Le.deleteCount===Ee?(Le.deleteCount+=Ce,Le.toInsert.push(...De)):oe.push({start:Ee,deleteCount:Ce,toInsert:De})}let de=0,ve=0;for(;;){if(de===$.length){ue(de,0,H.slice(ve));break}if(ve===H.length){ue(de,$.length-de,[]);break}const Ee=$[de],Ce=H[ve],De=te(Ee,Ce);De===0?(de+=1,ve+=1):De<0?(ue(de,1,[]),de+=1):De>0&&(ue(de,0,[Ce]),ve+=1)}return oe}e.sortedDiff=v;function d($,H,te){const oe=v($,H,te),ue=[],de=[];for(const ve of oe)ue.push(...$.slice(ve.start,ve.start+ve.deleteCount)),de.push(...ve.toInsert);return{removed:ue,added:de}}e.delta=d;function g($,H,te){if(te===0)return[];const oe=$.slice(0,te).sort(H);return a($,H,oe,te,$.length),oe}e.top=g;function w($,H,te,oe,ue){return te===0?Promise.resolve([]):new Promise((de,ve)=>{(async()=>{const Ee=$.length,Ce=$.slice(0,te).sort(H);for(let De=te,Le=Math.min(te+oe,Ee);De<Ee;De=Le,Le=Math.min(Le+oe,Ee)){if(De>te&&await new Promise(We=>setTimeout(We)),ue&&ue.isCancellationRequested)throw new R.CancellationError;a($,H,Ce,De,Le)}return Ce})().then(de,ve)})}e.topAsync=w;function a($,H,te,oe,ue){for(const de=te.length;oe<ue;oe++){const ve=$[oe];if(H(ve,te[de-1])<0){te.pop();const Ee=S(te,Ce=>H(ve,Ce)<0);te.splice(Ee,0,ve)}}}function u($){return $.filter(H=>!!H)}e.coalesce=u;function h($){let H=0;for(let te=0;te<$.length;te++)$[te]&&($[H]=$[te],H+=1);$.length=H}e.coalesceInPlace=h;function E($,H,te){$.splice(te,0,$.splice(H,1)[0])}e.move=E;function p($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=p;function k($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=k;function n($,H=te=>te){const te=new Set;return $.filter(oe=>{const ue=H(oe);return te.has(ue)?!1:(te.add(ue),!0)})}e.distinct=n;function r($){const H=new Set;return te=>{const oe=$(te);return H.has(oe)?!1:(H.add(oe),!0)}}e.uniqueFilter=r;function i($,H){const te=t($,H);if(te!==-1)return $[te]}e.findLast=i;function t($,H){for(let te=$.length-1;te>=0;te--){const oe=$[te];if(H(oe))return te}return-1}e.lastIndex=t;function s($,H){return $.length>0?$[0]:H}e.firstOrDefault=s;function o($,H){return $.length>0?$[$.length-1]:H}e.lastOrDefault=o;function c($,H,te=(oe,ue)=>oe===ue){let oe=0;for(let ue=0,de=Math.min($.length,H.length);ue<de&&te($[ue],H[ue]);ue++)oe++;return oe}e.commonPrefixLength=c;function y($){return[].concat(...$)}e.flatten=y;function f($,H){let te=typeof H=="number"?$:0;typeof H=="number"?te=$:(te=0,H=$);const oe=[];if(te<=H)for(let ue=te;ue<H;ue++)oe.push(ue);else for(let ue=te;ue>H;ue--)oe.push(ue);return oe}e.range=f;function l($,H,te){return $.reduce((oe,ue)=>(oe[H(ue)]=te?te(ue):ue,oe),Object.create(null))}e.index=l;function I($,H){return $.push(H),()=>A($,H)}e.insert=I;function A($,H){const te=$.indexOf(H);if(te>-1)return $.splice(te,1),H}e.remove=A;function F($,H,te){const oe=$.slice(0,H),ue=$.slice(H);return oe.concat(te,ue)}e.arrayInsert=F;function M($,H){let te;if(typeof H=="number"){let oe=H;te=()=>{const ue=Math.sin(oe++)*179426549;return ue-Math.floor(ue)}}else te=Math.random;for(let oe=$.length-1;oe>0;oe-=1){const ue=Math.floor(te()*(oe+1)),de=$[oe];$[oe]=$[ue],$[ue]=de}}e.shuffle=M;function V($,H){const te=$.indexOf(H);te>-1&&($.splice(te,1),$.unshift(H))}e.pushToStart=V;function x($,H){const te=$.indexOf(H);te>-1&&($.splice(te,1),$.push(H))}e.pushToEnd=x;function q($,H){for(const te of H)$.push(te)}e.pushMany=q;function X($,H){return Array.isArray($)?$.map(H):H($)}e.mapArrayOrNot=X;function ee($){return Array.isArray($)?$:[$]}e.asArray=ee;function Y($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=Y;function Z($,H){for(const te of $){const oe=H(te);if(oe!==void 0)return oe}}e.mapFind=Z;function j($,H,te){const oe=z($,H),ue=$.length,de=te.length;$.length=ue+de;for(let ve=ue-1;ve>=oe;ve--)$[ve+de]=$[ve];for(let ve=0;ve<de;ve++)$[ve+oe]=te[ve]}e.insertInto=j;function B($,H,te,oe){const ue=z($,H),de=$.splice(ue,te);return j($,ue,oe),de}e.splice=B;function z($,H){return H<0?Math.max(H+$.length,0):Math.min(H,$.length)}var ie;(function($){function H(ue){return ue<0}$.isLessThan=H;function te(ue){return ue>0}$.isGreaterThan=te;function oe(ue){return ue===0}$.isNeitherLessOrGreaterThan=oe,$.greaterThan=1,$.lessThan=-1,$.neitherLessOrGreaterThan=0})(ie||(e.CompareResult=ie={}));function re($,H){return(te,oe)=>H($(te),$(oe))}e.compareBy=re;function K(...$){return(H,te)=>{for(const oe of $){const ue=oe(H,te);if(!ie.isNeitherLessOrGreaterThan(ue))return ue}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=K;const Q=($,H)=>$-H;e.numberComparator=Q;function O($,H){if($.length===0)return;let te=$[0];for(let oe=1;oe<$.length;oe++){const ue=$[oe];H(ue,te)>0&&(te=ue)}return te}e.findMaxBy=O;function m($,H){if($.length===0)return;let te=$[0];for(let oe=1;oe<$.length;oe++){const ue=$[oe];H(ue,te)>=0&&(te=ue)}return te}e.findLastMaxBy=m;function U($,H){return O($,(te,oe)=>-H(te,oe))}e.findMinBy=U;class W{constructor(H){this.items=H,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(H){let te=this.firstIdx;for(;te<this.items.length&&H(this.items[te]);)te++;const oe=te===this.firstIdx?null:this.items.slice(this.firstIdx,te);return this.firstIdx=te,oe}takeFromEndWhile(H){let te=this.lastIdx;for(;te>=0&&H(this.items[te]);)te--;const oe=te===this.lastIdx?null:this.items.slice(te+1,this.lastIdx+1);return this.lastIdx=te,oe}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const H=this.items[this.firstIdx];return this.firstIdx++,H}removeLast(){const H=this.items[this.lastIdx];return this.lastIdx--,H}takeCount(H){const te=this.items.slice(this.firstIdx,this.firstIdx+H);return this.firstIdx+=H,te}}e.ArrayQueue=W;class J{constructor(H){this.iterate=H}forEach(H){this.iterate(te=>(H(te),!0))}toArray(){const H=[];return this.iterate(te=>(H.push(te),!0)),H}filter(H){return new J(te=>this.iterate(oe=>H(oe)?te(oe):!0))}map(H){return new J(te=>this.iterate(oe=>te(H(oe))))}some(H){let te=!1;return this.iterate(oe=>(te=H(oe),!te)),te}findFirst(H){let te;return this.iterate(oe=>H(oe)?(te=oe,!1):!0),te}findLast(H){let te;return this.iterate(oe=>(H(oe)&&(te=oe),!0)),te}findLastMaxBy(H){let te,oe=!0;return this.iterate(ue=>((oe||ie.isGreaterThan(H(ue,te)))&&(oe=!1,te=ue),!0)),te}}e.CallbackIterable=J,J.empty=new J($=>{})}),define(ae[122],ce([0,1,7]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function N(b,S){if(!b)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=N;function L(b,S="Unreachable"){throw new Error(S)}e.assertNever=L;function T(b){if(!b)throw new R.BugIndicatingError("Assertion Failed")}e.assert=T;function _(b){if(!b()){debugger;b(),(0,R.onUnexpectedError)(new R.BugIndicatingError("Assertion Failed"))}}e.assertFn=_;function D(b,S){let P=0;for(;P<b.length-1;){const C=b[P],v=b[P+1];if(!S(C,v))return!1;P++}return!0}e.checkAdjacentItems=D}),define(ae[82],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(N){const L=this;let T=!1,_;return function(){return T||(T=!0,_=N.apply(L,arguments)),_}}e.once=R}),define(ae[60],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(N){function L(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}N.is=L;const T=Object.freeze([]);function _(){return T}N.empty=_;function*D(p){yield p}N.single=D;function b(p){return L(p)?p:D(p)}N.wrap=b;function S(p){return p||T}N.from=S;function P(p){return!p||p[Symbol.iterator]().next().done===!0}N.isEmpty=P;function C(p){return p[Symbol.iterator]().next().value}N.first=C;function v(p,k){for(const n of p)if(k(n))return!0;return!1}N.some=v;function d(p,k){for(const n of p)if(k(n))return n}N.find=d;function*g(p,k){for(const n of p)k(n)&&(yield n)}N.filter=g;function*w(p,k){let n=0;for(const r of p)yield k(r,n++)}N.map=w;function*a(...p){for(const k of p)for(const n of k)yield n}N.concat=a;function u(p,k,n){let r=n;for(const i of p)r=k(r,i);return r}N.reduce=u;function*h(p,k,n=p.length){for(k<0&&(k+=p.length),n<0?n+=p.length:n>p.length&&(n=p.length);k<n;k++)yield p[k]}N.slice=h;function E(p,k=Number.POSITIVE_INFINITY){const n=[];if(k===0)return[n,p];const r=p[Symbol.iterator]();for(let i=0;i<k;i++){const t=r.next();if(t.done)return[n,N.empty()];n.push(t.value)}return[n,{[Symbol.iterator](){return r}}]}N.consume=E})(R||(e.Iterable=R={}))}),define(ae[34],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(R||(e.ScanError=R={}));var N;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var T;(function(n){n.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function _(n,r=!1){let i=0;const t=n.length;let s="",o=0,c=16,y=0;function f(x){let q=0,X=0;for(;q<x;){const ee=n.charCodeAt(i);if(ee>=48&&ee<=57)X=X*16+ee-48;else if(ee>=65&&ee<=70)X=X*16+ee-65+10;else if(ee>=97&&ee<=102)X=X*16+ee-97+10;else break;i++,q++}return q<x&&(X=-1),X}function l(x){i=x,s="",o=0,c=16,y=0}function I(){const x=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&S(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&S(n.charCodeAt(i)))for(i++;i<n.length&&S(n.charCodeAt(i));)i++;else return y=3,n.substring(x,i);let q=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&S(n.charCodeAt(i))){for(i++;i<n.length&&S(n.charCodeAt(i));)i++;q=i}else y=3;return n.substring(x,q)}function A(){let x="",q=i;for(;;){if(i>=t){x+=n.substring(q,i),y=2;break}const X=n.charCodeAt(i);if(X===34){x+=n.substring(q,i),i++;break}if(X===92){if(x+=n.substring(q,i),i++,i>=t){y=2;break}switch(n.charCodeAt(i++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const Y=f(4);Y>=0?x+=String.fromCharCode(Y):y=4;break}default:y=5}q=i;continue}if(X>=0&&X<=31)if(b(X)){x+=n.substring(q,i),y=2;break}else y=6;i++}return x}function F(){if(s="",y=0,o=i,i>=t)return o=t,c=17;let x=n.charCodeAt(i);if(D(x)){do i++,s+=String.fromCharCode(x),x=n.charCodeAt(i);while(D(x));return c=15}if(b(x))return i++,s+=String.fromCharCode(x),x===13&&n.charCodeAt(i)===10&&(i++,s+=`
`),c=14;switch(x){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,s=A(),c=10;case 47:{const q=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<t&&!b(n.charCodeAt(i));)i++;return s=n.substring(q,i),c=12}if(n.charCodeAt(i+1)===42){i+=2;const X=t-1;let ee=!1;for(;i<X;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,ee=!0;break}i++}return ee||(i++,y=1),s=n.substring(q,i),c=13}return s+=String.fromCharCode(x),i++,c=16}case 45:if(s+=String.fromCharCode(x),i++,i===t||!S(n.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=I(),c=11;default:for(;i<t&&M(x);)i++,x=n.charCodeAt(i);if(o!==i){switch(s=n.substring(o,i),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(x),i++,c=16}}function M(x){if(D(x)||b(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let x;do x=F();while(x>=12&&x<=15);return x}return{setPosition:l,getPosition:()=>i,scan:r?V:F,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>y}}e.createScanner=_;function D(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function b(n){return n===10||n===13||n===8232||n===8233}function S(n){return n>=48&&n<=57}var P;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(P||(P={}));function C(n,r){const i=[],t=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function y(f,l,I,A){o.value=f,o.offset=l,o.length=I,o.type=A,o.colonOffset=void 0,s=o}try{E(n,{onObjectBegin:(f,l)=>{if(r<=f)throw t;s=void 0,c=r>f,i.push("")},onObjectProperty:(f,l,I)=>{if(r<l||(y(f,l,I,"property"),i[i.length-1]=f,r<=l+I))throw t},onObjectEnd:(f,l)=>{if(r<=f)throw t;s=void 0,i.pop()},onArrayBegin:(f,l)=>{if(r<=f)throw t;s=void 0,i.push(0)},onArrayEnd:(f,l)=>{if(r<=f)throw t;s=void 0,i.pop()},onLiteralValue:(f,l,I)=>{if(r<l||(y(f,l,I,k(f)),r<=l+I))throw t},onSeparator:(f,l,I)=>{if(r<=l)throw t;if(f===":"&&s&&s.type==="property")s.colonOffset=l,c=!1,s=void 0;else if(f===","){const A=i[i.length-1];typeof A=="number"?i[i.length-1]=A+1:(c=!0,i[i.length-1]=""),s=void 0}}})}catch(f){if(f!==t)throw f}return{path:i,previousNode:s,isAtPropertyKey:c,matches:f=>{let l=0;for(let I=0;l<f.length&&I<i.length;I++)if(f[l]===i[I]||f[l]==="*")l++;else if(f[l]!=="**")return!1;return l===f.length}}}e.getLocation=C;function v(n,r=[],i=T.DEFAULT){let t=null,s=[];const o=[];function c(f){Array.isArray(s)?s.push(f):t!==null&&(s[t]=f)}return E(n,{onObjectBegin:()=>{const f={};c(f),o.push(s),s=f,t=null},onObjectProperty:f=>{t=f},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const f=[];c(f),o.push(s),s=f,t=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:c,onError:(f,l,I)=>{r.push({error:f,offset:l,length:I})}},i),s[0]}e.parse=v;function d(n,r=[],i=T.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(f){t.type==="property"&&(t.length=f-t.offset,t=t.parent)}function o(f){return t.children.push(f),f}E(n,{onObjectBegin:f=>{t=o({type:"object",offset:f,length:-1,parent:t,children:[]})},onObjectProperty:(f,l,I)=>{t=o({type:"property",offset:l,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:f,offset:l,length:I,parent:t})},onObjectEnd:(f,l)=>{t.length=f+l-t.offset,t=t.parent,s(f+l)},onArrayBegin:(f,l)=>{t=o({type:"array",offset:f,length:-1,parent:t,children:[]})},onArrayEnd:(f,l)=>{t.length=f+l-t.offset,t=t.parent,s(f+l)},onLiteralValue:(f,l,I)=>{o({type:k(f),offset:l,length:I,parent:t,value:f}),s(l+I)},onSeparator:(f,l,I)=>{t.type==="property"&&(f===":"?t.colonOffset=l:f===","&&s(l))},onError:(f,l,I)=>{r.push({error:f,offset:l,length:I})}},i);const y=t.children[0];return y&&delete y.parent,y}e.parseTree=d;function g(n,r){if(!n)return;let i=n;for(const t of r)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===t){i=o.children[1],s=!0;break}if(!s)return}else{const s=t;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=g;function w(n){if(!n.parent||!n.parent.children)return[];const r=w(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;r.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&r.push(i)}return r}e.getNodePath=w;function a(n){switch(n.type){case"array":return n.children.map(a);case"object":{const r=Object.create(null);for(const i of n.children){const t=i.children[1];t&&(r[i.children[0].value]=a(t))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=a;function u(n,r,i=!1){return r>=n.offset&&r<n.offset+n.length||i&&r===n.offset+n.length}e.contains=u;function h(n,r,i=!1){if(u(n,r,i)){const t=n.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=r;s++){const o=h(t[s],r,i);if(o)return o}return n}}e.findNodeAtOffset=h;function E(n,r,i=T.DEFAULT){const t=_(n,!1);function s(re){return re?()=>re(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(re){return re?K=>re(K,t.getTokenOffset(),t.getTokenLength()):()=>!0}const c=s(r.onObjectBegin),y=o(r.onObjectProperty),f=s(r.onObjectEnd),l=s(r.onArrayBegin),I=s(r.onArrayEnd),A=o(r.onLiteralValue),F=o(r.onSeparator),M=s(r.onComment),V=o(r.onError),x=i&&i.disallowComments,q=i&&i.allowTrailingComma;function X(){for(;;){const re=t.scan();switch(t.getTokenError()){case 4:ee(14);break;case 5:ee(15);break;case 3:ee(13);break;case 1:x||ee(11);break;case 2:ee(12);break;case 6:ee(16);break}switch(re){case 12:case 13:x?ee(10):M();break;case 16:ee(1);break;case 15:case 14:break;default:return re}}}function ee(re,K=[],Q=[]){if(V(re),K.length+Q.length>0){let O=t.getToken();for(;O!==17;){if(K.indexOf(O)!==-1){X();break}else if(Q.indexOf(O)!==-1)break;O=X()}}}function Y(re){const K=t.getTokenValue();return re?A(K):y(K),X(),!0}function Z(){switch(t.getToken()){case 11:{let re=0;try{re=JSON.parse(t.getTokenValue()),typeof re!="number"&&(ee(2),re=0)}catch{ee(2)}A(re);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return X(),!0}function j(){return t.getToken()!==10?(ee(3,[],[2,5]),!1):(Y(!1),t.getToken()===6?(F(":"),X(),ie()||ee(4,[],[2,5])):ee(5,[],[2,5]),!0)}function B(){c(),X();let re=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(re||ee(4,[],[]),F(","),X(),t.getToken()===2&&q)break}else re&&ee(6,[],[]);j()||ee(4,[],[2,5]),re=!0}return f(),t.getToken()!==2?ee(7,[2],[]):X(),!0}function z(){l(),X();let re=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(re||ee(4,[],[]),F(","),X(),t.getToken()===4&&q)break}else re&&ee(6,[],[]);ie()||ee(4,[],[4,5]),re=!0}return I(),t.getToken()!==4?ee(8,[4],[]):X(),!0}function ie(){switch(t.getToken()){case 3:return z();case 1:return B();case 10:return Y(!0);default:return Z()}}return X(),t.getToken()===17?i.allowEmptyContent?!0:(ee(4,[],[]),!1):ie()?(t.getToken()!==17&&ee(9,[],[]),!0):(ee(4,[],[]),!1)}e.visit=E;function p(n,r){const i=_(n),t=[];let s,o=0,c;do switch(c=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:o!==c&&t.push(n.substring(o,c)),r!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,r)),o=i.getPosition();break}while(s!==17);return t.join("")}e.stripComments=p;function k(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=k}),define(ae[41],ce([0,1,34]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function N(S,P,C){let v,d,g,w,a;if(P){for(w=P.offset,a=w+P.length,g=w;g>0&&!b(S,g-1);)g--;let c=a;for(;c<S.length&&!b(S,c);)c++;d=S.substring(g,c),v=_(d,C)}else d=S,v=0,g=0,w=0,a=S.length;const u=D(C,S);let h=!1,E=0,p;C.insertSpaces?p=T(" ",C.tabSize||4):p="	";const k=(0,R.createScanner)(d,!1);let n=!1;function r(){return u+T(p,v+E)}function i(){let c=k.scan();for(h=!1;c===15||c===14;)h=h||c===14,c=k.scan();return n=c===16||k.getTokenError()!==0,c}const t=[];function s(c,y,f){!n&&y<a&&f>w&&S.substring(y,f)!==c&&t.push({offset:y,length:f-y,content:c})}let o=i();if(o!==17){const c=k.getTokenOffset()+g,y=T(p,v);s(y,g,c)}for(;o!==17;){let c=k.getTokenOffset()+k.getTokenLength()+g,y=i(),f="";for(;!h&&(y===12||y===13);){const I=k.getTokenOffset()+g;s(" ",c,I),c=k.getTokenOffset()+k.getTokenLength()+g,f=y===12?r():"",y=i()}if(y===2)o!==1&&(E--,f=r());else if(y===4)o!==3&&(E--,f=r());else{switch(o){case 3:case 1:E++,f=r();break;case 5:case 12:f=r();break;case 13:h?f=r():f=" ";break;case 6:f=" ";break;case 10:if(y===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?f=" ":y!==5&&y!==17&&(n=!0);break;case 16:n=!0;break}h&&(y===12||y===13)&&(f=r())}const l=k.getTokenOffset()+g;s(f,c,l),o=y}return t}e.format=N;function L(S,P){const C=JSON.stringify(S,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?C.replace(/\r\n|\r|\n/g,P.eol):C}e.toFormattedString=L;function T(S,P){let C="";for(let v=0;v<P;v++)C+=S;return C}function _(S,P){let C=0,v=0;const d=P.tabSize||4;for(;C<S.length;){const g=S.charAt(C);if(g===" ")v++;else if(g==="	")v+=d;else break;C++}return Math.floor(v/d)}function D(S,P){for(let C=0;C<P.length;C++){const v=P.charAt(C);if(v==="\r")return C+1<P.length&&P.charAt(C+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=D;function b(S,P){return`\r
`.indexOf(S.charAt(P))!==-1}e.isEOL=b}),define(ae[83],ce([0,1,34,41]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(S,P,C){return T(S,P,void 0,C)}e.removeProperty=L;function T(S,P,C,v,d){const g=P.slice(),w=[],a=(0,R.parseTree)(S,w);let u,h;for(;g.length>0&&(h=g.pop(),u=(0,R.findNodeAtLocation)(a,g),u===void 0&&C!==void 0);)typeof h=="string"?C={[h]:C}:C=[C];if(u)if(u.type==="object"&&typeof h=="string"&&Array.isArray(u.children)){const E=(0,R.findNodeAtLocation)(u,[h]);if(E!==void 0)if(C===void 0){if(!E.parent)throw new Error("Malformed AST");const p=u.children.indexOf(E.parent);let k,n=E.parent.offset+E.parent.length;if(p>0){const r=u.children[p-1];k=r.offset+r.length}else k=u.offset+1,u.children.length>1&&(n=u.children[1].offset);return _(S,{offset:k,length:n-k,content:""},v)}else return _(S,{offset:E.offset,length:E.length,content:JSON.stringify(C)},v);else{if(C===void 0)return[];const p=`${JSON.stringify(h)}: ${JSON.stringify(C)}`,k=d?d(u.children.map(r=>r.children[0].value)):u.children.length;let n;if(k>0){const r=u.children[k-1];n={offset:r.offset+r.length,length:0,content:","+p}}else u.children.length===0?n={offset:u.offset+1,length:0,content:p}:n={offset:u.offset+1,length:0,content:p+","};return _(S,n,v)}}else if(u.type==="array"&&typeof h=="number"&&Array.isArray(u.children))if(C!==void 0){const E=`${JSON.stringify(C)}`;let p;if(u.children.length===0||h===0)p={offset:u.offset+1,length:0,content:u.children.length===0?E:E+","};else{const k=h===-1||h>u.children.length?u.children.length:h,n=u.children[k-1];p={offset:n.offset+n.length,length:0,content:","+E}}return _(S,p,v)}else{const E=h,p=u.children[E];let k;if(u.children.length===1)k={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===E){const n=u.children[E-1],r=n.offset+n.length,i=u.offset+u.length;k={offset:r,length:i-2-r,content:""}}else k={offset:p.offset,length:u.children[E+1].offset-p.offset,content:""};return _(S,k,v)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${u.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return _(S,{offset:a?a.offset:0,length:a?a.length:0,content:JSON.stringify(C)},v)}}e.setProperty=T;function _(S,P,C){let v=D(S,P),d=P.offset,g=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;d>0&&!(0,N.isEOL)(v,d-1);)d--;for(;g<v.length&&!(0,N.isEOL)(v,g);)g++}const w=(0,N.format)(v,{offset:d,length:g-d},C);for(let u=w.length-1;u>=0;u--){const h=w[u];v=D(v,h),d=Math.min(d,h.offset),g=Math.max(g,h.offset+h.length),g+=h.content.length-h.length}const a=S.length-(v.length-g)-d;return[{offset:d,length:a,content:v.substring(d,g)}]}e.withFormatting=_;function D(S,P){return S.substring(0,P.offset)+P.content+S.substring(P.offset+P.length)}e.applyEdit=D;function b(S,P){const C=P.slice(0).sort((d,g)=>{const w=d.offset-g.offset;return w===0?d.length-g.length:w});let v=S.length;for(let d=C.length-1;d>=0;d--){const g=C[d];if(g.offset+g.length<=v)S=D(S,g);else throw new Error("Overlapping edit");v=g.offset}return S}e.applyEdits=b}),define(ae[84],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class R{constructor(L){this.executor=L,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=R}),define(ae[2],ce([0,1,82,60]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let T=null;function _(o){T=o}if(e.setDisposableTracker=_,L){const o="__is_disposable_tracked__";_(new class{trackDisposable(c){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[o]||console.log(y)},3e3)}setParent(c,y){if(c&&c!==h.None)try{c[o]=!0}catch{}}markAsDisposed(c){if(c&&c!==h.None)try{c[o]=!0}catch{}}markAsSingleton(c){}})}function D(o){return T?.trackDisposable(o),o}function b(o){T?.markAsDisposed(o)}function S(o,c){T?.setParent(o,c)}function P(o,c){if(T)for(const y of o)T.setParent(y,c)}function C(o){return T?.markAsSingleton(o),o}e.markAsSingleton=C;function v(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=v;function d(o){if(N.Iterable.is(o)){const c=[];for(const y of o)if(y)try{y.dispose()}catch(f){c.push(f)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=d;function g(o){for(const c of o)v(c)&&c.dispose();return[]}e.disposeIfDisposable=g;function w(...o){const c=a(()=>d(o));return P(o,c),c}e.combinedDisposable=w;function a(o){const c=D({dispose:(0,R.once)(()=>{b(c),o()})});return c}e.toDisposable=a;class u{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{d(this._toDispose)}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return S(c,this),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new u,D(this),S(this._store,this)}dispose(){b(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=h,h.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&S(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&S(c,null),c}}e.MutableDisposable=E;class p{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=p;class k{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(c){let y=c;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,b(this))},this}}e.SafeDisposable=k;class n{constructor(){this.references=new Map}acquire(c,...y){let f=this.references.get(c);f||(f={counter:0,object:this.createReferencedObject(c,...y)},this.references.set(c,f));const{object:l}=f,I=(0,R.once)(()=>{--f.counter===0&&(this.destroyReferencedObject(c,f.object),this.references.delete(c))});return f.counter++,{object:l,dispose:I}}}e.ReferenceCollection=n;class r{constructor(c){this.referenceCollection=c}async acquire(c,...y){const f=this.referenceCollection.acquire(c,...y);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(l){throw f.dispose(),l}}}e.AsyncReferenceCollection=r;class i{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=i;function t(o){const c=new u;try{o(c)}finally{c.dispose()}}e.disposeOnReturn=t;class s{constructor(){this._store=new Map,this._isDisposed=!1,D(this)}dispose(){b(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{d(this._store.values())}finally{this._store.clear()}}has(c){return this._store.has(c)}get(c){return this._store.get(c)}set(c,y,f=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),f||this._store.get(c)?.dispose(),this._store.set(c,y)}deleteAndDispose(c){this._store.get(c)?.dispose(),this._store.delete(c)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=s}),define(ae[85],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(T){this.element=T,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class N{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let T=this._first;for(;T!==R.Undefined;){const _=T.next;T.prev=R.Undefined,T.next=R.Undefined,T=_}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,_){const D=new R(T);if(this._first===R.Undefined)this._first=D,this._last=D;else if(_){const S=this._last;this._last=D,D.prev=S,S.next=D}else{const S=this._first;this._first=D,D.next=S,S.prev=D}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(D))}}shift(){if(this._first!==R.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==R.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==R.Undefined&&T.next!==R.Undefined){const _=T.prev;_.next=T.next,T.next.prev=_}else T.prev===R.Undefined&&T.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):T.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):T.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==R.Undefined;)yield T.element,T=T.next}}e.LinkedList=N}),define(ae[35],ce([0,1]),function(ne,e){"use strict";var R,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function T(w,a,u){let h=w.get(a);return h===void 0&&(h=u,w.set(a,h)),h}e.getOrSet=T;function _(w){const a=[];return w.forEach((u,h)=>{a.push(`${h} => ${u}`)}),`Map(${w.size}) {${a.join(", ")}}`}e.mapToString=_;function D(w){const a=[];return w.forEach(u=>{a.push(u)}),`Set(${w.size}) {${a.join(", ")}}`}e.setToString=D;class b{constructor(a,u){this.uri=a,this.value=u}}class S{constructor(a,u){this[R]="ResourceMap",a instanceof S?(this.map=new Map(a.map),this.toKey=u??S.defaultToKey):(this.map=new Map,this.toKey=a??S.defaultToKey)}set(a,u){return this.map.set(this.toKey(a),new b(a,u)),this}get(a){return this.map.get(this.toKey(a))?.value}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,u){typeof u<"u"&&(a=a.bind(u));for(const[h,E]of this.map)a(E.value,E.uri,this)}*values(){for(const a of this.map.values())yield a.value}*keys(){for(const a of this.map.values())yield a.uri}*entries(){for(const a of this.map.values())yield[a.uri,a.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.map)yield[a.uri,a.value]}}e.ResourceMap=S,S.defaultToKey=w=>w.toString();class P{constructor(a,u){this[N]="ResourceSet",!a||typeof a=="function"?this._map=new S(a):(this._map=new S(u),a.forEach(this.add,this))}get size(){return this._map.size}add(a){return this._map.set(a,a),this}clear(){this._map.clear()}delete(a){return this._map.delete(a)}forEach(a,u){this._map.forEach((h,E)=>a.call(u,E,E,this))}has(a){return this._map.has(a)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=P;var C;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(C||(e.Touch=C={}));class v{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(a){return this._map.has(a)}get(a,u=0){const h=this._map.get(a);if(h)return u!==0&&this.touch(h,u),h.value}set(a,u,h=0){let E=this._map.get(a);if(E)E.value=u,h!==0&&this.touch(E,h);else{switch(E={key:a,value:u,next:void 0,previous:void 0},h){case 0:this.addItemLast(E);break;case 1:this.addItemFirst(E);break;case 2:this.addItemLast(E);break;default:this.addItemLast(E);break}this._map.set(a,E),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const u=this._map.get(a);if(u)return this._map.delete(a),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}forEach(a,u){const h=this._state;let E=this._head;for(;E;){if(u?a.bind(u)(E.value,E.key,this):a(E.value,E.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");E=E.next}}keys(){const a=this,u=this._state;let h=this._head;const E={[Symbol.iterator](){return E},next(){if(a._state!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const p={value:h.key,done:!1};return h=h.next,p}else return{value:void 0,done:!0}}};return E}values(){const a=this,u=this._state;let h=this._head;const E={[Symbol.iterator](){return E},next(){if(a._state!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const p={value:h.value,done:!1};return h=h.next,p}else return{value:void 0,done:!0}}};return E}entries(){const a=this,u=this._state;let h=this._head;const E={[Symbol.iterator](){return E},next(){if(a._state!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const p={value:[h.key,h.value],done:!1};return h=h.next,p}else return{value:void 0,done:!0}}};return E}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(a>=this.size)return;if(a===0){this.clear();return}let u=this._head,h=this.size;for(;u&&h>a;)this._map.delete(u.key),u=u.next,h--;this._head=u,this._size=h,u&&(u.previous=void 0),this._state++}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const u=a.next,h=a.previous;if(!u||!h)throw new Error("Invalid list");u.previous=h,h.next=u}a.next=void 0,a.previous=void 0,this._state++}touch(a,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(a===this._head)return;const h=a.next,E=a.previous;a===this._tail?(E.next=void 0,this._tail=E):(h.previous=E,E.next=h),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(u===2){if(a===this._tail)return;const h=a.next,E=a.previous;a===this._head?(h.previous=void 0,this._head=h):(h.previous=E,E.next=h),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((u,h)=>{a.push([h,u])}),a}fromJSON(a){this.clear();for(const[u,h]of a)this.set(u,h)}}e.LinkedMap=v;class d extends v{constructor(a,u=1){super(),this._limit=a,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,u=2){return super.get(a,u)}peek(a){return super.get(a,0)}set(a,u){return super.set(a,u,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d;class g{constructor(){this.map=new Map}add(a){return this.map.set(a,(this.map.get(a)||0)+1),this}delete(a){let u=this.map.get(a)||0;return u===0?!1:(u--,u===0?this.map.delete(a):this.map.set(a,u),!0)}has(a){return this.map.has(a)}}e.CounterSet=g}),define(ae[86],ce([0,1,35]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const N=new R.LRUCache(1e4);function L(S){return b(S,"NFC",N)}e.normalizeNFC=L;const T=new R.LRUCache(1e4);function _(S){return b(S,"NFD",T)}e.normalizeNFD=_;const D=/[^\u0000-\u0080]/;function b(S,P,C){if(!S)return S;const v=C.get(S);if(v)return v;let d;return D.test(S)?d=S.normalize(P):d=S,C.set(S,d),d}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(P){return _(P).replace(S,"")}}()}),function(){function ne(L){const T=[];typeof L=="number"&&T.push("code/timeOrigin",L);function _(b){T.push(b,Date.now())}function D(){const b=[];for(let S=0;S<T.length;S+=2)b.push({name:T[S],startTime:T[S+1]});return b}return{mark:_,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const _ of performance.getEntriesByType("mark"))T.push({name:_.name,startTime:Math.round(L+_.startTime)});return T}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function R(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=R(N))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var N in R)(typeof exports=="object"?exports:ne)[N]=R[N]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function R(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return ne[N].call(L.exports,L,L.exports,R),L.l=!0,L.exports}return R.m=ne,R.c=e,R.d=function(N,L,T){R.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:T})},R.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},R.t=function(N,L){if(1&L&&(N=R(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var T=Object.create(null);if(R.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var _ in N)R.d(T,_,function(D){return N[D]}.bind(null,_));return T},R.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return R.d(L,"a",L),L},R.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},R.p="",R(R.s=0)}([function(ne,e,R){(function(N){var L;e=ne.exports=Q,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],b=e.src=[],S=0,P=S++;b[P]="0|[1-9]\\d*";var C=S++;b[C]="[0-9]+";var v=S++;b[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=S++;b[d]="("+b[P]+")\\.("+b[P]+")\\.("+b[P]+")";var g=S++;b[g]="("+b[C]+")\\.("+b[C]+")\\.("+b[C]+")";var w=S++;b[w]="(?:"+b[P]+"|"+b[v]+")";var a=S++;b[a]="(?:"+b[C]+"|"+b[v]+")";var u=S++;b[u]="(?:-("+b[w]+"(?:\\."+b[w]+")*))";var h=S++;b[h]="(?:-?("+b[a]+"(?:\\."+b[a]+")*))";var E=S++;b[E]="[0-9A-Za-z-]+";var p=S++;b[p]="(?:\\+("+b[E]+"(?:\\."+b[E]+")*))";var k=S++,n="v?"+b[d]+b[u]+"?"+b[p]+"?";b[k]="^"+n+"$";var r="[v=\\s]*"+b[g]+b[h]+"?"+b[p]+"?",i=S++;b[i]="^"+r+"$";var t=S++;b[t]="((?:<|>)?=?)";var s=S++;b[s]=b[C]+"|x|X|\\*";var o=S++;b[o]=b[P]+"|x|X|\\*";var c=S++;b[c]="[v=\\s]*("+b[o]+")(?:\\.("+b[o]+")(?:\\.("+b[o]+")(?:"+b[u]+")?"+b[p]+"?)?)?";var y=S++;b[y]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[h]+")?"+b[p]+"?)?)?";var f=S++;b[f]="^"+b[t]+"\\s*"+b[c]+"$";var l=S++;b[l]="^"+b[t]+"\\s*"+b[y]+"$";var I=S++;b[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=S++;b[A]="(?:~>?)";var F=S++;b[F]="(\\s*)"+b[A]+"\\s+",D[F]=new RegExp(b[F],"g");var M=S++;b[M]="^"+b[A]+b[c]+"$";var V=S++;b[V]="^"+b[A]+b[y]+"$";var x=S++;b[x]="(?:\\^)";var q=S++;b[q]="(\\s*)"+b[x]+"\\s+",D[q]=new RegExp(b[q],"g");var X=S++;b[X]="^"+b[x]+b[c]+"$";var ee=S++;b[ee]="^"+b[x]+b[y]+"$";var Y=S++;b[Y]="^"+b[t]+"\\s*("+r+")$|^$";var Z=S++;b[Z]="^"+b[t]+"\\s*("+n+")$|^$";var j=S++;b[j]="(\\s*)"+b[t]+"\\s*("+r+"|"+b[c]+")",D[j]=new RegExp(b[j],"g");var B=S++;b[B]="^\\s*("+b[c]+")\\s+-\\s+("+b[c]+")\\s*$";var z=S++;b[z]="^\\s*("+b[y]+")\\s+-\\s+("+b[y]+")\\s*$";var ie=S++;b[ie]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)L(re,b[re]),D[re]||(D[re]=new RegExp(b[re]));function K(le,fe){if(le instanceof Q)return le;if(typeof le!="string"||le.length>T||!(fe?D[i]:D[k]).test(le))return null;try{return new Q(le,fe)}catch{return null}}function Q(le,fe){if(le instanceof Q){if(le.loose===fe)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof Q))return new Q(le,fe);L("SemVer",le,fe),this.loose=fe;var ge=le.trim().match(fe?D[i]:D[k]);if(!ge)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Ie=+Pe;if(Ie>=0&&Ie<_)return Ie}return Pe}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=K,e.valid=function(le,fe){var ge=K(le,fe);return ge?ge.version:null},e.clean=function(le,fe){var ge=K(le.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(le){return L("SemVer.compare",this.version,this.loose,le),le instanceof Q||(le=new Q(le,this.loose)),this.compareMain(le)||this.comparePre(le)},Q.prototype.compareMain=function(le){return le instanceof Q||(le=new Q(le,this.loose)),m(this.major,le.major)||m(this.minor,le.minor)||m(this.patch,le.patch)},Q.prototype.comparePre=function(le){if(le instanceof Q||(le=new Q(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Pe=le.prerelease[fe];if(L("prerelease compare",fe,ge,Pe),ge===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(ge===void 0)return-1;if(ge!==Pe)return m(ge,Pe)}while(++fe)},Q.prototype.inc=function(le,fe){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,fe,ge,Pe){typeof ge=="string"&&(Pe=ge,ge=void 0);try{return new Q(le,ge).inc(fe,Pe).version}catch{return null}},e.diff=function(le,fe){if($(le,fe))return null;var ge=K(le),Pe=K(fe);if(ge.prerelease.length||Pe.prerelease.length){for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==Pe[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==Pe[Ie])return Ie},e.compareIdentifiers=m;var O=/^[0-9]+$/;function m(le,fe){var ge=O.test(le),Pe=O.test(fe);return ge&&Pe&&(le=+le,fe=+fe),ge&&!Pe?-1:Pe&&!ge?1:le<fe?-1:le>fe?1:0}function U(le,fe,ge){return new Q(le,ge).compare(new Q(fe,ge))}function W(le,fe,ge){return U(le,fe,ge)>0}function J(le,fe,ge){return U(le,fe,ge)<0}function $(le,fe,ge){return U(le,fe,ge)===0}function H(le,fe,ge){return U(le,fe,ge)!==0}function te(le,fe,ge){return U(le,fe,ge)>=0}function oe(le,fe,ge){return U(le,fe,ge)<=0}function ue(le,fe,ge,Pe){var Ie;switch(fe){case"===":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Ie=le===ge;break;case"!==":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Ie=le!==ge;break;case"":case"=":case"==":Ie=$(le,ge,Pe);break;case"!=":Ie=H(le,ge,Pe);break;case">":Ie=W(le,ge,Pe);break;case">=":Ie=te(le,ge,Pe);break;case"<":Ie=J(le,ge,Pe);break;case"<=":Ie=oe(le,ge,Pe);break;default:throw new TypeError("Invalid operator: "+fe)}return Ie}function de(le,fe){if(le instanceof de){if(le.loose===fe)return le;le=le.value}if(!(this instanceof de))return new de(le,fe);L("comparator",le,fe),this.loose=fe,this.parse(le),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(le,fe){return m(fe,le)},e.major=function(le,fe){return new Q(le,fe).major},e.minor=function(le,fe){return new Q(le,fe).minor},e.patch=function(le,fe){return new Q(le,fe).patch},e.compare=U,e.compareLoose=function(le,fe){return U(le,fe,!0)},e.rcompare=function(le,fe,ge){return U(fe,le,ge)},e.sort=function(le,fe){return le.sort(function(ge,Pe){return e.compare(ge,Pe,fe)})},e.rsort=function(le,fe){return le.sort(function(ge,Pe){return e.rcompare(ge,Pe,fe)})},e.gt=W,e.lt=J,e.eq=$,e.neq=H,e.gte=te,e.lte=oe,e.cmp=ue,e.Comparator=de;var ve={};function Ee(le,fe){if(le instanceof Ee)return le.loose===fe?le:new Ee(le.raw,fe);if(le instanceof de)return new Ee(le.value,fe);if(!(this instanceof Ee))return new Ee(le,fe);if(this.loose=fe,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function Ce(le){return!le||le.toLowerCase()==="x"||le==="*"}function De(le,fe,ge,Pe,Ie,Ne,ke,je,Ue,Me,Fe,_e,se){return((fe=Ce(ge)?"":Ce(Pe)?">="+ge+".0.0":Ce(Ie)?">="+ge+"."+Pe+".0":">="+fe)+" "+(je=Ce(Ue)?"":Ce(Me)?"<"+(+Ue+1)+".0.0":Ce(Fe)?"<"+Ue+"."+(+Me+1)+".0":_e?"<="+Ue+"."+Me+"."+Fe+"-"+_e:"<="+je)).trim()}function Le(le,fe){for(var ge=0;ge<le.length;ge++)if(!le[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<le.length;ge++)if(L(le[ge].semver),le[ge].semver!==ve&&le[ge].semver.prerelease.length>0){var Pe=le[ge].semver;if(Pe.major===fe.major&&Pe.minor===fe.minor&&Pe.patch===fe.patch)return!0}return!1}return!0}function We(le,fe,ge){try{fe=new Ee(fe,ge)}catch{return!1}return fe.test(le)}function Be(le,fe,ge,Pe){var Ie,Ne,ke,je,Ue;switch(le=new Q(le,Pe),fe=new Ee(fe,Pe),ge){case">":Ie=W,Ne=oe,ke=J,je=">",Ue=">=";break;case"<":Ie=J,Ne=te,ke=W,je="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(We(le,fe,Pe))return!1;for(var Me=0;Me<fe.set.length;++Me){var Fe=fe.set[Me],_e=null,se=null;if(Fe.forEach(function(he){he.semver===ve&&(he=new de(">=0.0.0")),_e=_e||he,se=se||he,Ie(he.semver,_e.semver,Pe)?_e=he:ke(he.semver,se.semver,Pe)&&(se=he)}),_e.operator===je||_e.operator===Ue||(!se.operator||se.operator===je)&&Ne(le,se.semver)||se.operator===Ue&&ke(le,se.semver))return!1}return!0}de.prototype.parse=function(le){var fe=this.loose?D[Y]:D[Z],ge=le.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+le);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new Q(ge[2],this.loose):this.semver=ve},de.prototype.toString=function(){return this.value},de.prototype.test=function(le){return L("Comparator.test",le,this.loose),this.semver===ve||(typeof le=="string"&&(le=new Q(le,this.loose)),ue(le,this.operator,this.semver,this.loose))},de.prototype.intersects=function(le,fe){if(!(le instanceof de))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new Ee(le.value,fe),We(this.value,ge,fe);if(le.operator==="")return ge=new Ee(this.value,fe),We(le.semver,ge,fe);var Pe=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Ne=this.semver.version===le.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),je=ue(this.semver,"<",le.semver,fe)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Ue=ue(this.semver,">",le.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Pe||Ie||Ne&&ke||je||Ue},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(le){var fe=this.loose;le=le.trim(),L("range",le,fe);var ge=fe?D[z]:D[B];le=le.replace(ge,De),L("hyphen replace",le),le=le.replace(D[j],"$1$2$3"),L("comparator trim",le,D[j]),le=(le=(le=le.replace(D[F],"$1~")).replace(D[q],"$1^")).split(/\s+/).join(" ");var Pe=fe?D[Y]:D[Z],Ie=le.split(" ").map(function(Ne){return function(ke,je){return L("comp",ke),ke=function(Ue,Me){return Ue.trim().split(/\s+/).map(function(Fe){return function(_e,se){L("caret",_e,se);var he=se?D[ee]:D[X];return _e.replace(he,function(me,Se,ye,be,Re){var Ae;return L("caret",_e,me,Se,ye,be,Re),Ce(Se)?Ae="":Ce(ye)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ce(be)?Ae=Se==="0"?">="+Se+"."+ye+".0 <"+Se+"."+(+ye+1)+".0":">="+Se+"."+ye+".0 <"+(+Se+1)+".0.0":Re?(L("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ae=Se==="0"?ye==="0"?">="+Se+"."+ye+"."+be+Re+" <"+Se+"."+ye+"."+(+be+1):">="+Se+"."+ye+"."+be+Re+" <"+Se+"."+(+ye+1)+".0":">="+Se+"."+ye+"."+be+Re+" <"+(+Se+1)+".0.0"):(L("no pr"),Ae=Se==="0"?ye==="0"?">="+Se+"."+ye+"."+be+" <"+Se+"."+ye+"."+(+be+1):">="+Se+"."+ye+"."+be+" <"+Se+"."+(+ye+1)+".0":">="+Se+"."+ye+"."+be+" <"+(+Se+1)+".0.0"),L("caret return",Ae),Ae})}(Fe,Me)}).join(" ")}(ke,je),L("caret",ke),ke=function(Ue,Me){return Ue.trim().split(/\s+/).map(function(Fe){return function(_e,se){var he=se?D[V]:D[M];return _e.replace(he,function(me,Se,ye,be,Re){var Ae;return L("tilde",_e,me,Se,ye,be,Re),Ce(Se)?Ae="":Ce(ye)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ce(be)?Ae=">="+Se+"."+ye+".0 <"+Se+"."+(+ye+1)+".0":Re?(L("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ae=">="+Se+"."+ye+"."+be+Re+" <"+Se+"."+(+ye+1)+".0"):Ae=">="+Se+"."+ye+"."+be+" <"+Se+"."+(+ye+1)+".0",L("tilde return",Ae),Ae})}(Fe,Me)}).join(" ")}(ke,je),L("tildes",ke),ke=function(Ue,Me){return L("replaceXRanges",Ue,Me),Ue.split(/\s+/).map(function(Fe){return function(_e,se){_e=_e.trim();var he=se?D[l]:D[f];return _e.replace(he,function(me,Se,ye,be,Re,Ae){L("xRange",_e,me,Se,ye,be,Re,Ae);var ze=Ce(ye),Te=ze||Ce(be),$e=Te||Ce(Re);return Se==="="&&$e&&(Se=""),ze?me=Se===">"||Se==="<"?"<0.0.0":"*":Se&&$e?(Te&&(be=0),$e&&(Re=0),Se===">"?(Se=">=",Te?(ye=+ye+1,be=0,Re=0):$e&&(be=+be+1,Re=0)):Se==="<="&&(Se="<",Te?ye=+ye+1:be=+be+1),me=Se+ye+"."+be+"."+Re):Te?me=">="+ye+".0.0 <"+(+ye+1)+".0.0":$e&&(me=">="+ye+"."+be+".0 <"+ye+"."+(+be+1)+".0"),L("xRange return",me),me})}(Fe,Me)}).join(" ")}(ke,je),L("xrange",ke),ke=function(Ue,Me){return L("replaceStars",Ue,Me),Ue.trim().replace(D[ie],"")}(ke,je),L("stars",ke),ke}(Ne,fe)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Ne){return!!Ne.match(Pe)})),Ie=Ie.map(function(Ne){return new de(Ne,fe)})},Ee.prototype.intersects=function(le,fe){if(!(le instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Pe){return le.set.some(function(Ie){return Ie.every(function(Ne){return Pe.intersects(Ne,fe)})})})})},e.toComparators=function(le,fe){return new Ee(le,fe).set.map(function(ge){return ge.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new Q(le,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Le(this.set[fe],le))return!0;return!1},e.satisfies=We,e.maxSatisfying=function(le,fe,ge){var Pe=null,Ie=null;try{var Ne=new Ee(fe,ge)}catch{return null}return le.forEach(function(ke){Ne.test(ke)&&(Pe&&Ie.compare(ke)!==-1||(Ie=new Q(Pe=ke,ge)))}),Pe},e.minSatisfying=function(le,fe,ge){var Pe=null,Ie=null;try{var Ne=new Ee(fe,ge)}catch{return null}return le.forEach(function(ke){Ne.test(ke)&&(Pe&&Ie.compare(ke)!==1||(Ie=new Q(Pe=ke,ge)))}),Pe},e.validRange=function(le,fe){try{return new Ee(le,fe).range||"*"}catch{return null}},e.ltr=function(le,fe,ge){return Be(le,fe,"<",ge)},e.gtr=function(le,fe,ge){return Be(le,fe,">",ge)},e.outside=Be,e.prerelease=function(le,fe){var ge=K(le,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(le,fe,ge){return le=new Ee(le,ge),fe=new Ee(fe,ge),le.intersects(fe)},e.coerce=function(le){if(le instanceof Q)return le;if(typeof le!="string")return null;var fe=le.match(D[I]);return fe==null?null:K((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,R(1))},function(ne,e){var R,N,L=ne.exports={};function T(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function D(a){if(R===setTimeout)return setTimeout(a,0);if((R===T||!R)&&setTimeout)return R=setTimeout,setTimeout(a,0);try{return R(a,0)}catch{try{return R.call(null,a,0)}catch{return R.call(this,a,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:T}catch{R=T}try{N=typeof clearTimeout=="function"?clearTimeout:_}catch{N=_}})();var b,S=[],P=!1,C=-1;function v(){P&&b&&(P=!1,b.length?S=b.concat(S):C=-1,S.length&&d())}function d(){if(!P){var a=D(v);P=!0;for(var u=S.length;u;){for(b=S,S=[];++C<u;)b&&b[C].run();C=-1,u=S.length}b=null,P=!1,function(h){if(N===clearTimeout)return clearTimeout(h);if((N===_||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(h);try{N(h)}catch{try{return N.call(null,h)}catch{return N.call(this,h)}}}(a)}}function g(a,u){this.fun=a,this.array=u}function w(){}L.nextTick=function(a){var u=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)u[h-1]=arguments[h];S.push(new g(a,u)),S.length!==1||P||D(d)},g.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=w,L.addListener=w,L.once=w,L.off=w,L.removeListener=w,L.removeAllListeners=w,L.emit=w,L.prependListener=w,L.prependOnceListener=w,L.listeners=function(a){return[]},L.binding=function(a){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(a){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ae[123],ce([0,1]),function(ne,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class N{constructor(D,b,S){this.level=D,this.key=b,this.value=S,this.forward=[]}}const L=void 0;class T{constructor(D,b=2**16){this.comparator=D,this[R]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new N(this._maxLevel,L,L)}get size(){return this._size}clear(){this._header=new N(this._maxLevel,L,L)}has(D){return!!T._search(this,D,this.comparator)}get(D){return T._search(this,D,this.comparator)?.value}set(D,b){return T._insert(this,D,b,this.comparator)&&(this._size+=1),this}delete(D){const b=T._delete(this,D,this.comparator);return b&&(this._size-=1),b}forEach(D,b){let S=this._header.forward[0];for(;S;)D.call(b,S.value,S.key,this),S=S.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let D=this._header.forward[0];for(;D;)yield[D.key,D.value],D=D.forward[0]}*keys(){let D=this._header.forward[0];for(;D;)yield D.key,D=D.forward[0]}*values(){let D=this._header.forward[0];for(;D;)yield D.value,D=D.forward[0]}toString(){let D="[SkipList]:",b=this._header.forward[0];for(;b;)D+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return D}static _search(D,b,S){let P=D._header;for(let C=D._level-1;C>=0;C--)for(;P.forward[C]&&S(P.forward[C].key,b)<0;)P=P.forward[C];if(P=P.forward[0],P&&S(P.key,b)===0)return P}static _insert(D,b,S,P){const C=[];let v=D._header;for(let d=D._level-1;d>=0;d--){for(;v.forward[d]&&P(v.forward[d].key,b)<0;)v=v.forward[d];C[d]=v}if(v=v.forward[0],v&&P(v.key,b)===0)return v.value=S,!1;{const d=T._randomLevel(D);if(d>D._level){for(let g=D._level;g<d;g++)C[g]=D._header;D._level=d}v=new N(d,b,S);for(let g=0;g<d;g++)v.forward[g]=C[g].forward[g],C[g].forward[g]=v;return!0}}static _randomLevel(D,b=.5){let S=1;for(;Math.random()<b&&S<D._maxLevel;)S+=1;return S}static _delete(D,b,S){const P=[];let C=D._header;for(let v=D._level-1;v>=0;v--){for(;C.forward[v]&&S(C.forward[v].key,b)<0;)C=C.forward[v];P[v]=C}if(C=C.forward[0],!C||S(C.key,b)!==0)return!1;for(let v=0;v<D._level&&P[v].forward[v]===C;v++)P[v].forward[v]=C.forward[v];for(;D._level>0&&D._header.forward[D._level-1]===L;)D._level-=1;return!0}}e.SkipList=T}),define(ae[87],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(T){return new N(T)}constructor(T){this._now=R&&T===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=N}),define(ae[3],ce([0,1,7,82,2,85,87]),function(ne,e,R,N,L,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const D=!1,b=!1;var S;(function(y){y.None=()=>L.Disposable.None;function f($){if(b){const{onDidAddListener:H}=$,te=g.create();let oe=0;$.onDidAddListener=()=>{++oe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),te.print()),H?.()}}}function l($,H){return ee($,()=>{},0,void 0,!0,void 0,H)}y.defer=l;function I($){return(H,te=null,oe)=>{let ue=!1,de;return de=$(ve=>{if(!ue)return de?de.dispose():ue=!0,H.call(te,ve)},null,oe),ue&&de.dispose(),de}}y.once=I;function A($,H,te){return X((oe,ue=null,de)=>$(ve=>oe.call(ue,H(ve)),null,de),te)}y.map=A;function F($,H,te){return X((oe,ue=null,de)=>$(ve=>{H(ve),oe.call(ue,ve)},null,de),te)}y.forEach=F;function M($,H,te){return X((oe,ue=null,de)=>$(ve=>H(ve)&&oe.call(ue,ve),null,de),te)}y.filter=M;function V($){return $}y.signal=V;function x(...$){return(H,te=null,oe)=>(0,L.combinedDisposable)(...$.map(ue=>ue(de=>H.call(te,de),null,oe)))}y.any=x;function q($,H,te,oe){let ue=te;return A($,de=>(ue=H(ue,de),ue),oe)}y.reduce=q;function X($,H){let te;const oe={onWillAddFirstListener(){te=$(ue.fire,ue)},onDidRemoveLastListener(){te?.dispose()}};H||f(oe);const ue=new E(oe);return H?.add(ue),ue.event}function ee($,H,te=100,oe=!1,ue=!1,de,ve){let Ee,Ce,De,Le=0,We;const Be={leakWarningThreshold:de,onWillAddFirstListener(){Ee=$(fe=>{Le++,Ce=H(Ce,fe),oe&&!De&&(le.fire(Ce),Ce=void 0),We=()=>{const ge=Ce;Ce=void 0,De=void 0,(!oe||Le>1)&&le.fire(ge),Le=0},typeof te=="number"?(clearTimeout(De),De=setTimeout(We,te)):De===void 0&&(De=0,queueMicrotask(We))})},onWillRemoveListener(){ue&&Le>0&&We?.()},onDidRemoveLastListener(){We=void 0,Ee.dispose()}};ve||f(Be);const le=new E(Be);return ve?.add(le),le.event}y.debounce=ee;function Y($,H=0,te){return y.debounce($,(oe,ue)=>oe?(oe.push(ue),oe):[ue],H,void 0,!0,void 0,te)}y.accumulate=Y;function Z($,H=(oe,ue)=>oe===ue,te){let oe=!0,ue;return M($,de=>{const ve=oe||!H(de,ue);return oe=!1,ue=de,ve},te)}y.latch=Z;function j($,H,te){return[y.filter($,H,te),y.filter($,oe=>!H(oe),te)]}y.split=j;function B($,H=!1,te=[]){let oe=te.slice(),ue=$(Ee=>{oe?oe.push(Ee):ve.fire(Ee)});const de=()=>{oe?.forEach(Ee=>ve.fire(Ee)),oe=null},ve=new E({onWillAddFirstListener(){ue||(ue=$(Ee=>ve.fire(Ee)))},onDidAddFirstListener(){oe&&(H?setTimeout(de):de())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return ve.event}y.buffer=B;class z{constructor(H){this.event=H,this.disposables=new L.DisposableStore}map(H){return new z(A(this.event,H,this.disposables))}forEach(H){return new z(F(this.event,H,this.disposables))}filter(H){return new z(M(this.event,H,this.disposables))}reduce(H,te){return new z(q(this.event,H,te,this.disposables))}latch(){return new z(Z(this.event,void 0,this.disposables))}debounce(H,te=100,oe=!1,ue=!1,de){return new z(ee(this.event,H,te,oe,ue,de,this.disposables))}on(H,te,oe){return this.event(H,te,oe)}once(H,te,oe){return I(this.event)(H,te,oe)}dispose(){this.disposables.dispose()}}function ie($){return new z($)}y.chain=ie;function re($,H,te=oe=>oe){const oe=(...Ee)=>ve.fire(te(...Ee)),ue=()=>$.on(H,oe),de=()=>$.removeListener(H,oe),ve=new E({onWillAddFirstListener:ue,onDidRemoveLastListener:de});return ve.event}y.fromNodeEventEmitter=re;function K($,H,te=oe=>oe){const oe=(...Ee)=>ve.fire(te(...Ee)),ue=()=>$.addEventListener(H,oe),de=()=>$.removeEventListener(H,oe),ve=new E({onWillAddFirstListener:ue,onDidRemoveLastListener:de});return ve.event}y.fromDOMEventEmitter=K;function Q($){return new Promise(H=>I($)(H))}y.toPromise=Q;function O($,H){return H(void 0),$(te=>H(te))}y.runAndSubscribe=O;function m($,H){let te=null;function oe(de){te?.dispose(),te=new L.DisposableStore,H(de,te)}oe(void 0);const ue=$(de=>oe(de));return(0,L.toDisposable)(()=>{ue.dispose(),te?.dispose()})}y.runAndSubscribeWithStore=m;class U{constructor(H,te){this._observable=H,this._counter=0,this._hasChanged=!1;const oe={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};te||f(oe),this.emitter=new E(oe),te&&te.add(this.emitter)}beginUpdate(H){this._counter++}handlePossibleChange(H){}handleChange(H,te){this._hasChanged=!0}endUpdate(H){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function W($,H){return new U($,H).emitter.event}y.fromObservable=W;function J($){return H=>{let te=0,oe=!1;const ue={beginUpdate(){te++},endUpdate(){te--,te===0&&($.reportChanges(),oe&&(oe=!1,H()))},handlePossibleChange(){},handleChange(){oe=!0}};return $.addObserver(ue),{dispose(){$.removeObserver(ue)}}}}y.fromObservableLight=J})(S||(e.Event=S={}));class P{constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${P._idPool++}`,P.all.add(this)}start(f){this._stopWatch=new _.StopWatch,this.listenerCount=f}stop(){if(this._stopWatch){const f=this._stopWatch.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=P,P.all=new Set,P._idPool=0;let C=-1;function v(y){const f=C;return C=y,{dispose(){C=f}}}e.setGlobalLeakWarningThreshold=v;class d{constructor(f,l=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=l,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(f,l){const I=this.threshold;if(I<=0||l<I)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(f.value)||0;if(this._stacks.set(f.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=I*.5;let F,M=0;for(const[V,x]of this._stacks)(!F||M<x)&&(F=V,M=x);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${M}):`),console.warn(F)}return()=>{const F=this._stacks.get(f.value)||0;this._stacks.set(f.value,F-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class a{constructor(f){this.value=f,this.id=w++}}const u=2,h=(y,f)=>{if(y instanceof a)f(y);else for(let l=0;l<y.length;l++){const I=y[l];I&&f(I)}};class E{constructor(f){this._size=0,this._options=f,this._leakageMon=C>0||this._options?.leakWarningThreshold?new d(this._options?.leakWarningThreshold??C):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(D){const f=this._listeners;queueMicrotask(()=>{h(f,l=>l.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(f,l,I)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.Disposable.None;if(this._disposed)return L.Disposable.None;l&&(f=f.bind(l));const A=new a(f);let F,M;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(A.stack=g.create(),F=this._leakageMon.check(A.stack,this._size+1)),D&&(A.stack=M??g.create()),this._listeners?this._listeners instanceof a?(this._deliveryQueue??=new k,this._listeners=[this._listeners,A]):this._listeners.push(A):(this._options?.onWillAddFirstListener?.(this),this._listeners=A,this._options?.onDidAddFirstListener?.(this)),this._size++;const V=(0,L.toDisposable)(()=>{F?.(),this._removeListener(A)});return I instanceof L.DisposableStore?I.add(V):Array.isArray(I)&&I.push(V),V},this._event}_removeListener(f){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const l=this._listeners,I=l.indexOf(f);if(I===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,l[I]=void 0;const A=this._deliveryQueue.current===this;if(this._size*u<=l.length){let F=0;for(let M=0;M<l.length;M++)l[M]?l[F++]=l[M]:A&&(this._deliveryQueue.end--,F<this._deliveryQueue.i&&this._deliveryQueue.i--);l.length=F}}_deliver(f,l){if(!f)return;const I=this._options?.onListenerError||R.onUnexpectedError;if(!I){f.value(l);return}try{f.value(l)}catch(A){I(A)}}_deliverQueue(f){const l=f.current._listeners;for(;f.i<f.end;)this._deliver(l[f.i++],f.value);f.reset()}fire(f){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof a)this._deliver(this._listeners,f);else{const l=this._deliveryQueue;l.enqueue(this,f,this._listeners.length),this._deliverQueue(l)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=E;const p=()=>new k;e.createEventDeliveryQueue=p;class k{constructor(){this.i=-1,this.end=0}enqueue(f,l,I){this.i=0,this.end=I,this.current=f,this.value=l}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends E{async fireAsync(f,l,I){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList),h(this._listeners,A=>this._asyncDeliveryQueue.push([A.value,f]));this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[A,F]=this._asyncDeliveryQueue.shift(),M=[],V={...F,token:l,waitUntil:x=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");I&&(x=I(x,A)),M.push(x)}};try{A(V)}catch(x){(0,R.onUnexpectedError)(x);continue}Object.freeze(M),await Promise.allSettled(M).then(x=>{for(const q of x)q.status==="rejected"&&(0,R.onUnexpectedError)(q.reason)})}}}e.AsyncEmitter=n;class r extends E{get isPaused(){return this._isPaused!==0}constructor(f){super(f),this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=f?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const f=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(f))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(f){this._size&&(this._isPaused!==0?this._eventQueue.push(f):super.fire(f))}}e.PauseableEmitter=r;class i extends r{constructor(f){super(f),this._delay=f.delay??100}fire(f){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(f)}}e.DebounceEmitter=i;class t extends E{constructor(f){super(f),this._queuedEvents=[],this._mergeFn=f?.merge}fire(f){this.hasListeners()&&(this._queuedEvents.push(f),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(l=>super.fire(l)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=t;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(f){const l={event:f,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const I=()=>{this.hasListeners&&this.unhook(l);const A=this.events.indexOf(l);this.events.splice(A,1)};return(0,L.toDisposable)((0,N.once)(I))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(f=>this.hook(f))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(f=>this.unhook(f))}hook(f){f.listener=f.event(l=>this.emitter.fire(l))}unhook(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=s;class o{constructor(){this.buffers=[]}wrapEvent(f){return(l,I,A)=>f(F=>{const M=this.buffers[this.buffers.length-1];M?M.push(()=>l.call(I,F)):l.call(I,F)},void 0,A)}bufferEvents(f){const l=[];this.buffers.push(l);const I=f();return this.buffers.pop(),l.forEach(A=>A()),I}}e.EventBufferer=o;class c{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=L.Disposable.None,this.emitter=new E({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(f){this.inputEvent=f,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=f(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(ae[26],ce([0,1,3]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const N=Object.freeze(function(D,b){const S=setTimeout(D.bind(b),0);return{dispose(){clearTimeout(S)}}});var L;(function(D){function b(S){return S===D.None||S===D.Cancelled||S instanceof T?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}D.isCancellationToken=b,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?N:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=L.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=_}),define(ae[124],ce([0,1,26]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class N{constructor(D){this.task=D,this.result=null}get(){if(this.result)return this.result;const D=new R.CancellationTokenSource,b=this.task(D.token);return this.result={promise:b,dispose:()=>{this.result=null,D.cancel(),D.dispose()}},this.result}}e.Cache=N;class L{constructor(D){this.fn=D,this.lastCache=void 0,this.lastArgKey=void 0}get(D){const b=JSON.stringify(D);return this.lastArgKey!==b&&(this.lastArgKey=b,this.lastCache=this.fn(D)),this.lastCache}}e.LRUCachedFunction=L;class T{get cachedValues(){return this._map}constructor(D){this.fn=D,this._map=new Map}get(D){if(this._map.has(D))return this._map.get(D);const b=this.fn(D);return this._map.set(D,b),b}}e.CachedFunction=T}),define(ae[42],ce([0,1,7,2]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function L(p){const k=p;return k?typeof k.read=="function":!1}e.isReadable=L;function T(p){const k=p;return k?[k.on,k.pause,k.resume,k.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=T;function _(p){const k=p;return k?T(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.isReadableBufferedStream=_;function D(p,k){return new b(p,k)}e.newWriteableStream=D;class b{constructor(k,n){this.reducer=k,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(k){if(!this.state.destroyed){if(this.state.flowing)this.emitData(k);else if(this.buffer.data.push(k),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(k){this.state.destroyed||(this.state.flowing?this.emitError(k):this.buffer.error.push(k))}end(k){this.state.destroyed||(typeof k<"u"&&this.write(k),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(k){this.listeners.data.slice(0).forEach(n=>n(k))}emitError(k){this.listeners.error.length===0?(0,R.onUnexpectedError)(k):this.listeners.error.slice(0).forEach(n=>n(k))}emitEnd(){this.listeners.end.slice(0).forEach(k=>k())}on(k,n){if(!this.state.destroyed)switch(k){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(k,n){if(this.state.destroyed)return;let r;switch(k){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const i=r.indexOf(n);i>=0&&r.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const k=this.reducer(this.buffer.data);this.emitData(k),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const k of this.buffer.error)this.emitError(k);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(p,k){const n=[];let r;for(;(r=p.read())!==null;)n.push(r);return k(n)}e.consumeReadable=S;function P(p,k,n){const r=[];let i;for(;(i=p.read())!==null&&r.length<n;)r.push(i);return i===null&&r.length>0?k(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i<"u"){const t=i;return i=void 0,t}return p.read()}}}e.peekReadable=P;function C(p,k){return new Promise((n,r)=>{const i=[];v(p,{onData:t=>{k&&i.push(t)},onError:t=>{k?r(t):n(void 0)},onEnd:()=>{n(k?k(i):void 0)}})})}e.consumeStream=C;function v(p,k){let n=!1;return p.on("error",r=>{n||k.onError(r)}),p.on("end",()=>{n||k.onEnd()}),p.on("data",r=>{n||k.onData(r)}),(0,N.toDisposable)(()=>n=!0)}e.listenStream=v;function d(p,k){return new Promise((n,r)=>{const i=new N.DisposableStore,t=[],s=y=>{if(t.push(y),t.length>k)return i.dispose(),p.pause(),n({stream:p,buffer:t,ended:!1})},o=y=>r(y),c=()=>n({stream:p,buffer:t,ended:!0});i.add((0,N.toDisposable)(()=>p.removeListener("error",o))),p.on("error",o),i.add((0,N.toDisposable)(()=>p.removeListener("end",c))),p.on("end",c),i.add((0,N.toDisposable)(()=>p.removeListener("data",s))),p.on("data",s)})}e.peekStream=d;function g(p,k){const n=D(k);return n.end(p),n}e.toStream=g;function w(){const p=D(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=w;function a(p){let k=!1;return{read:()=>k?null:(k=!0,p)}}e.toReadable=a;function u(p,k,n){const r=D(n);return v(p,{onData:i=>r.write(k.data(i)),onError:i=>r.error(k.error?k.error(i):i),onEnd:()=>r.end()}),r}e.transform=u;function h(p,k,n){let r=!1;return{read:()=>{const i=k.read();return r?i:(r=!0,i!==null?n([p,i]):p)}}}e.prefixedReadable=h;function E(p,k,n){let r=!1;const i=D(n);return v(k,{onData:t=>r?i.write(t):(r=!0,i.write(n([p,t]))),onError:t=>i.error(t),onEnd:()=>{r||(r=!0,i.write(p)),i.end()}}),i}e.prefixedStream=E}),define(ae[16],ce([0,1,84,42]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer<"u",T=new R.Lazy(()=>new Uint8Array(256));let _,D;class b{static alloc(l){return L?new b(Buffer.allocUnsafe(l)):new b(new Uint8Array(l))}static wrap(l){return L&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new b(l)}static fromString(l,I){return!(I?.dontUseNodeBuffer||!1)&&L?new b(Buffer.from(l)):(_||(_=new TextEncoder),new b(_.encode(l)))}static fromByteArray(l){const I=b.alloc(l.length);for(let A=0,F=l.length;A<F;A++)I.buffer[A]=l[A];return I}static concat(l,I){if(typeof I>"u"){I=0;for(let M=0,V=l.length;M<V;M++)I+=l[M].byteLength}const A=b.alloc(I);let F=0;for(let M=0,V=l.length;M<V;M++){const x=l[M];A.set(x,F),F+=x.byteLength}return A}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=b.alloc(this.byteLength);return l.set(this),l}toString(){return L?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(l,I){return new b(this.buffer.subarray(l,I))}set(l,I){if(l instanceof b)this.buffer.set(l.buffer,I);else if(l instanceof Uint8Array)this.buffer.set(l,I);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),I);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return C(this.buffer,l)}writeUInt32BE(l,I){v(this.buffer,l,I)}readUInt32LE(l){return d(this.buffer,l)}writeUInt32LE(l,I){g(this.buffer,l,I)}readUInt8(l){return w(this.buffer,l)}writeUInt8(l,I){a(this.buffer,l,I)}indexOf(l){const I=l instanceof b?l.buffer:l,A=I.byteLength,F=this.buffer,M=F.byteLength;if(A===0)return 0;if(A===1)return F.indexOf(I[0]);if(A>M)return-1;const V=T.value;V.fill(I.length);for(let ee=0;ee<I.length;ee++)V[I[ee]]=I.length-ee-1;let x=I.length-1,q=x,X=-1;for(;x<M;)if(F[x]===I[q]){if(q===0){X=x;break}x--,q--}else x+=Math.max(I.length-q,V[F[x]]),q=I.length-1;return X}}e.VSBuffer=b;function S(f,l){return f[l+0]<<0>>>0|f[l+1]<<8>>>0}e.readUInt16LE=S;function P(f,l,I){f[I+0]=l&255,l=l>>>8,f[I+1]=l&255}e.writeUInt16LE=P;function C(f,l){return f[l]*2**24+f[l+1]*2**16+f[l+2]*2**8+f[l+3]}e.readUInt32BE=C;function v(f,l,I){f[I+3]=l,l=l>>>8,f[I+2]=l,l=l>>>8,f[I+1]=l,l=l>>>8,f[I]=l}e.writeUInt32BE=v;function d(f,l){return f[l+0]<<0>>>0|f[l+1]<<8>>>0|f[l+2]<<16>>>0|f[l+3]<<24>>>0}e.readUInt32LE=d;function g(f,l,I){f[I+0]=l&255,l=l>>>8,f[I+1]=l&255,l=l>>>8,f[I+2]=l&255,l=l>>>8,f[I+3]=l&255}e.writeUInt32LE=g;function w(f,l){return f[l]}e.readUInt8=w;function a(f,l,I){f[I]=l}e.writeUInt8=a;function u(f){return N.consumeReadable(f,l=>b.concat(l))}e.readableToBuffer=u;function h(f){return N.toReadable(f)}e.bufferToReadable=h;function E(f){return N.consumeStream(f,l=>b.concat(l))}e.streamToBuffer=E;async function p(f){return f.ended?b.concat(f.buffer):b.concat([...f.buffer,await E(f.stream)])}e.bufferedStreamToBuffer=p;function k(f){return N.toStream(f,l=>b.concat(l))}e.bufferToStream=k;function n(f){return N.transform(f,{data:l=>typeof l=="string"?b.fromString(l):b.wrap(l)},l=>b.concat(l))}e.streamToBufferReadableStream=n;function r(f){return N.newWriteableStream(l=>b.concat(l),f)}e.newWriteableBufferStream=r;function i(f,l){return N.prefixedReadable(f,l,I=>b.concat(I))}e.prefixedBufferReadable=i;function t(f,l){return N.prefixedStream(f,l,I=>b.concat(I))}e.prefixedBufferStream=t;function s(f){let l=0,I=0,A=0;const F=new Uint8Array(Math.floor(f.length/4*3)),M=x=>{switch(I){case 3:F[A++]=l|x,I=0;break;case 2:F[A++]=l|x>>>2,l=x<<6,I=3;break;case 1:F[A++]=l|x>>>4,l=x<<4,I=2;break;default:l=x<<2,I=1}};for(let x=0;x<f.length;x++){const q=f.charCodeAt(x);if(q>=65&&q<=90)M(q-65);else if(q>=97&&q<=122)M(q-97+26);else if(q>=48&&q<=57)M(q-48+52);else if(q===43||q===45)M(62);else if(q===47||q===95)M(63);else{if(q===61)break;throw new SyntaxError(`Unexpected base64 character ${f[x]}`)}}const V=A;for(;I>0;)M(0);return b.wrap(F).slice(0,V)}e.decodeBase64=s;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:f},l=!0,I=!1){const A=I?c:o;let F="";const M=f.byteLength%3;let V=0;for(;V<f.byteLength-M;V+=3){const x=f[V+0],q=f[V+1],X=f[V+2];F+=A[x>>>2],F+=A[(x<<4|q>>>4)&63],F+=A[(q<<2|X>>>6)&63],F+=A[X&63]}if(M===1){const x=f[V+0];F+=A[x>>>2],F+=A[x<<4&63],l&&(F+="==")}else if(M===2){const x=f[V+0],q=f[V+1];F+=A[x>>>2],F+=A[(x<<4|q>>>4)&63],F+=A[q<<2&63],l&&(F+="=")}return F}e.encodeBase64=y}),define(ae[27],ce([0,1,124,84]),function(ne,e,R,N){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(se){return!se||typeof se!="string"?!0:se.trim().length===0}e.isFalsyOrWhitespace=T;const _=/{(\d+)}/g;function D(se,...he){return he.length===0?se:se.replace(_,function(me,Se){const ye=parseInt(Se,10);return isNaN(ye)||ye<0||ye>=he.length?me:he[ye]})}e.format=D;const b=/{([^}]+)}/g;function S(se,he){return se.replace(b,(me,Se)=>he[Se]??me)}e.format2=S;function P(se){return se.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=P;function C(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function v(se,he){let me=0;const Se=he.charCodeAt(0);for(let ye=se.length-1;ye>=0;ye--)se.charCodeAt(ye)===Se&&me++;return me}e.count=v;function d(se,he,me="\u2026"){return se.length<=he?se:`${se.substr(0,he)}${me}`}e.truncate=d;function g(se,he=" "){const me=w(se,he);return a(me,he)}e.trim=g;function w(se,he){if(!se||!he)return se;const me=he.length;if(me===0||se.length===0)return se;let Se=0;for(;se.indexOf(he,Se)===Se;)Se=Se+me;return se.substring(Se)}e.ltrim=w;function a(se,he){if(!se||!he)return se;const me=he.length,Se=se.length;if(me===0||Se===0)return se;let ye=Se,be=-1;for(;be=se.lastIndexOf(he,ye-1),!(be===-1||be+me!==ye);){if(be===0)return"";ye=be}return se.substring(0,ye)}e.rtrim=a;function u(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function h(se){return se.replace(/\*/g,"")}e.stripWildcards=h;function E(se,he,me={}){if(!se)throw new Error("Cannot create regex from empty string");he||(se=C(se)),me.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let Se="";return me.global&&(Se+="g"),me.matchCase||(Se+="i"),me.multiline&&(Se+="m"),me.unicode&&(Se+="u"),new RegExp(se,Se)}e.createRegExp=E;function p(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function k(se){return!!se.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=k;function n(se){return(se.global?"g":"")+(se.ignoreCase?"i":"")+(se.multiline?"m":"")+(se.unicode?"u":"")}e.regExpFlags=n;function r(se){return se.split(/\r\n|\r|\n/)}e.splitLines=r;function i(se){for(let he=0,me=se.length;he<me;he++){const Se=se.charCodeAt(he);if(Se!==32&&Se!==9)return he}return-1}e.firstNonWhitespaceIndex=i;function t(se,he=0,me=se.length){for(let Se=he;Se<me;Se++){const ye=se.charCodeAt(Se);if(ye!==32&&ye!==9)return se.substring(he,Se)}return se.substring(he,me)}e.getLeadingWhitespace=t;function s(se,he=se.length-1){for(let me=he;me>=0;me--){const Se=se.charCodeAt(me);if(Se!==32&&Se!==9)return me}return-1}e.lastNonWhitespaceIndex=s;function o(se,he,me){const Se=[];let ye=0;for(const be of se.matchAll(he)){if(Se.push(se.slice(ye,be.index)),be.index===void 0)throw new Error("match.index should be defined");ye=be.index+be[0].length,Se.push(me(be[0],...be.slice(1),be.index,se,be.groups))}return Se.push(se.slice(ye)),Promise.all(Se).then(be=>be.join(""))}e.replaceAsync=o;function c(se,he){return se<he?-1:se>he?1:0}e.compare=c;function y(se,he,me=0,Se=se.length,ye=0,be=he.length){for(;me<Se&&ye<be;me++,ye++){const ze=se.charCodeAt(me),Te=he.charCodeAt(ye);if(ze<Te)return-1;if(ze>Te)return 1}const Re=Se-me,Ae=be-ye;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstring=y;function f(se,he){return l(se,he,0,se.length,0,he.length)}e.compareIgnoreCase=f;function l(se,he,me=0,Se=se.length,ye=0,be=he.length){for(;me<Se&&ye<be;me++,ye++){let ze=se.charCodeAt(me),Te=he.charCodeAt(ye);if(ze===Te)continue;if(ze>=128||Te>=128)return y(se.toLowerCase(),he.toLowerCase(),me,Se,ye,be);A(ze)&&(ze-=32),A(Te)&&(Te-=32);const $e=ze-Te;if($e!==0)return $e}const Re=Se-me,Ae=be-ye;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstringIgnoreCase=l;function I(se){return se>=48&&se<=57}e.isAsciiDigit=I;function A(se){return se>=97&&se<=122}e.isLowerAsciiLetter=A;function F(se){return se>=65&&se<=90}e.isUpperAsciiLetter=F;function M(se,he){return se.length===he.length&&l(se,he)===0}e.equalsIgnoreCase=M;function V(se,he){const me=he.length;return he.length>se.length?!1:l(se,he,0,me)===0}e.startsWithIgnoreCase=V;function x(se,he){const me=Math.min(se.length,he.length);let Se;for(Se=0;Se<me;Se++)if(se.charCodeAt(Se)!==he.charCodeAt(Se))return Se;return me}e.commonPrefixLength=x;function q(se,he){const me=Math.min(se.length,he.length);let Se;const ye=se.length-1,be=he.length-1;for(Se=0;Se<me;Se++)if(se.charCodeAt(ye-Se)!==he.charCodeAt(be-Se))return Se;return me}e.commonSuffixLength=q;function X(se){return 55296<=se&&se<=56319}e.isHighSurrogate=X;function ee(se){return 56320<=se&&se<=57343}e.isLowSurrogate=ee;function Y(se,he){return(se-55296<<10)+(he-56320)+65536}e.computeCodePoint=Y;function Z(se,he,me){const Se=se.charCodeAt(me);if(X(Se)&&me+1<he){const ye=se.charCodeAt(me+1);if(ee(ye))return Y(Se,ye)}return Se}e.getNextCodePoint=Z;function j(se,he){const me=se.charCodeAt(he-1);if(ee(me)&&he>1){const Se=se.charCodeAt(he-2);if(X(Se))return Y(Se,me)}return me}class B{get offset(){return this._offset}constructor(he,me=0){this._str=he,this._len=he.length,this._offset=me}setOffset(he){this._offset=he}prevCodePoint(){const he=j(this._str,this._offset);return this._offset-=he>=65536?2:1,he}nextCodePoint(){const he=Z(this._str,this._len,this._offset);return this._offset+=he>=65536?2:1,he}eol(){return this._offset>=this._len}}e.CodePointIterator=B;class z{get offset(){return this._iterator.offset}constructor(he,me=0){this._iterator=new B(he,me)}nextGraphemeLength(){const he=Ie.getInstance(),me=this._iterator,Se=me.offset;let ye=he.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const be=me.offset,Re=he.getGraphemeBreakType(me.nextCodePoint());if(ge(ye,Re)){me.setOffset(be);break}ye=Re}return me.offset-Se}prevGraphemeLength(){const he=Ie.getInstance(),me=this._iterator,Se=me.offset;let ye=he.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const be=me.offset,Re=he.getGraphemeBreakType(me.prevCodePoint());if(ge(Re,ye)){me.setOffset(be);break}ye=Re}return Se-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=z;function ie(se,he){return new z(se,he).nextGraphemeLength()}e.nextCharLength=ie;function re(se,he){return new z(se,he).prevGraphemeLength()}e.prevCharLength=re;function K(se,he){he>0&&ee(se.charCodeAt(he))&&he--;const me=he+ie(se,he);return[me-re(se,me),me]}e.getCharContainingOffset=K;function Q(se){const he=new z(se);let me=0;for(;!he.eol();)me++,he.nextGraphemeLength();return me}e.charCount=Q;let O;function m(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(se){return O||(O=m()),O.test(se)}e.containsRTL=U;const W=/^[\t\n\r\x20-\x7E]*$/;function J(se){return W.test(se)}e.isBasicASCII=J,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function $(se){return e.UNUSUAL_LINE_TERMINATORS.test(se)}e.containsUnusualLineTerminators=$;function H(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}e.isFullWidthCharacter=H;function te(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}e.isEmojiImprecise=te;function oe(se,he){if(se.length<he)return se;const me=/\b/g;let Se=0;for(;me.test(se)&&!(se.length-me.lastIndex<he);)Se=me.lastIndex,me.lastIndex+=1;return se.substring(Se).replace(/^\s/,"")}e.lcut=oe;const ue=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,de=/\x1b\].*?\x07/g;function ve(se){return se&&(se=se.replace(ue,"").replace(de,"")),se}e.removeAnsiEscapeCodes=ve,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(se){return!!(se&&se.length>0&&se.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Ce(se){return Ee(se)?se.substr(1):se}e.stripUTF8BOM=Ce;function De(se,he){if(!se||!he||se.length<he.length)return!1;const me=he.length,Se=se.toLowerCase();let ye=0,be=-1;for(;ye<me;){const Re=Se.indexOf(he[ye],be+1);if(Re<0)return!1;be=Re,ye++}return!0}e.fuzzyContains=De;function Le(se,he=!1){return se?(he&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}e.containsUppercaseCharacter=Le;function We(se){return se.charAt(0).toUpperCase()+se.slice(1)}e.uppercaseFirstLetter=We;function Be(se,he=1){if(he===0)return"";let me=-1;do me=se.indexOf(`
`,me+1),he--;while(he>0&&me>=0);return me===-1?se:(se[me-1]==="\r"&&me--,se.substr(0,me))}e.getNLines=Be;function le(se){return se=se%(2*26),se<26?String.fromCharCode(97+se):String.fromCharCode(65+se-26)}e.singleLetterHash=le;function fe(se){return Ie.getInstance().getGraphemeBreakType(se)}e.getGraphemeBreakType=fe;function ge(se,he){return se===0?he!==5&&he!==7:se===2&&he===3?!1:se===4||se===2||se===3||he===4||he===2||he===3?!0:!(se===8&&(he===8||he===9||he===11||he===12)||(se===11||se===9)&&(he===9||he===10)||(se===12||se===10)&&he===10||he===5||he===13||he===7||se===1||se===13&&he===14||se===6&&he===6)}var Pe;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(e.GraphemeBreakType=Pe={}));class Ie{static getInstance(){return Ie._INSTANCE||(Ie._INSTANCE=new Ie),Ie._INSTANCE}constructor(){this._data=Ne()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const me=this._data,Se=me.length/3;let ye=1;for(;ye<=Se;)if(he<me[3*ye])ye=2*ye;else if(he>me[3*ye+1])ye=2*ye+1;else return me[3*ye+2];return 0}}Ie._INSTANCE=null;function Ne(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ke(se,he){if(se===0)return 0;const me=je(se,he);if(me!==void 0)return me;const Se=new B(he,se);return Se.prevCodePoint(),Se.offset}e.getLeftDeleteOffset=ke;function je(se,he){const me=new B(he,se);let Se=me.prevCodePoint();for(;Ue(Se)||Se===65039||Se===8419;){if(me.offset===0)return;Se=me.prevCodePoint()}if(!te(Se))return;let ye=me.offset;return ye>0&&me.prevCodePoint()===8205&&(ye=me.offset),ye}function Ue(se){return 127995<=se&&se<=127999}var Me;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class Fe{static getInstance(he){return Fe.cache.get(Array.from(he))}static getLocales(){return Fe._locales.value}constructor(he){this.confusableDictionary=he}isAmbiguous(he){return this.confusableDictionary.has(he)}getPrimaryConfusable(he){return this.confusableDictionary.get(he)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Fe,L=Fe,Fe.ambiguousCharacterData=new N.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Fe.cache=new R.LRUCachedFunction(se=>{function he(Te){const $e=new Map;for(let xe=0;xe<Te.length;xe+=2)$e.set(Te[xe],Te[xe+1]);return $e}function me(Te,$e){const xe=new Map(Te);for(const[Ze,nt]of $e)xe.set(Ze,nt);return xe}function Se(Te,$e){if(!Te)return $e;const xe=new Map;for(const[Ze,nt]of Te)$e.has(Ze)&&xe.set(Ze,nt);return xe}const ye=L.ambiguousCharacterData.value;let be=se.filter(Te=>!Te.startsWith("_")&&Te in ye);be.length===0&&(be=["_default"]);let Re;for(const Te of be){const $e=he(ye[Te]);Re=Se(Re,$e)}const Ae=he(ye._common),ze=me(Ae,Re);return new Fe(ze)}),Fe._locales=new N.Lazy(()=>Object.keys(Fe.ambiguousCharacterData.value).filter(se=>!se.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(he){return _e.getData().has(he)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(ae[61],ce([0,1,27]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function N(u){return L(u,0)}e.hash=N;function L(u,h){switch(typeof u){case"object":return u===null?T(349,h):Array.isArray(u)?b(u,h):S(u,h);case"string":return D(u,h);case"boolean":return _(u,h);case"number":return T(u,h);case"undefined":return T(937,h);default:return T(617,h)}}e.doHash=L;function T(u,h){return(h<<5)-h+u|0}e.numberHash=T;function _(u,h){return T(u?433:863,h)}function D(u,h){h=T(149417,h);for(let E=0,p=u.length;E<p;E++)h=T(u.charCodeAt(E),h);return h}e.stringHash=D;function b(u,h){return h=T(104579,h),u.reduce((E,p)=>L(p,E),h)}function S(u,h){return h=T(181387,h),Object.keys(u).sort().reduce((E,p)=>(E=D(p,E),L(u[p],E)),h)}class P{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=L(h,this._value),this._value}}e.Hasher=P;var C;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function v(u,h,E=32){const p=E-h,k=~((1<<p)-1);return(u<<h|(k&u)>>>p)>>>0}function d(u,h=0,E=u.byteLength,p=0){for(let k=0;k<E;k++)u[h+k]=p}function g(u,h,E="0"){for(;u.length<h;)u=E+u;return u}function w(u,h=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(E=>E.toString(16).padStart(2,"0")).join(""):g((u>>>0).toString(16),h/4)}e.toHexString=w;class a{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const E=h.length;if(E===0)return;const p=this._buff;let k=this._buffLen,n=this._leftoverHighSurrogate,r,i;for(n!==0?(r=n,i=-1,n=0):(r=h.charCodeAt(0),i=0);;){let t=r;if(R.isHighSurrogate(r))if(i+1<E){const s=h.charCodeAt(i+1);R.isLowSurrogate(s)?(i++,t=R.computeCodePoint(r,s)):t=65533}else{n=r;break}else R.isLowSurrogate(r)&&(t=65533);if(k=this._push(p,k,t),i++,i<E)r=h.charCodeAt(i);else break}this._buffLen=k,this._leftoverHighSurrogate=n}_push(h,E,p){return p<128?h[E++]=p:p<2048?(h[E++]=192|(p&1984)>>>6,h[E++]=128|(p&63)>>>0):p<65536?(h[E++]=224|(p&61440)>>>12,h[E++]=128|(p&4032)>>>6,h[E++]=128|(p&63)>>>0):(h[E++]=240|(p&1835008)>>>18,h[E++]=128|(p&258048)>>>12,h[E++]=128|(p&4032)>>>6,h[E++]=128|(p&63)>>>0),E>=64&&(this._step(),E-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),E}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=a._bigBlock32,E=this._buffDV;for(let c=0;c<64;c+=4)h.setUint32(c,E.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)h.setUint32(c,v(h.getUint32(c-12,!1)^h.getUint32(c-32,!1)^h.getUint32(c-56,!1)^h.getUint32(c-64,!1),1),!1);let p=this._h0,k=this._h1,n=this._h2,r=this._h3,i=this._h4,t,s,o;for(let c=0;c<80;c++)c<20?(t=k&n|~k&r,s=1518500249):c<40?(t=k^n^r,s=1859775393):c<60?(t=k&n|k&r|n&r,s=2400959708):(t=k^n^r,s=3395469782),o=v(p,5)+t+i+s+h.getUint32(c*4,!1)&4294967295,i=r,r=n,n=v(k,30),k=p,p=o;this._h0=this._h0+p&4294967295,this._h1=this._h1+k&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=a,a._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ae[88],ce([0,1,27]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const T="error",_="warning",D="warn",b="info",S="ignore";function P(v){return v?R.equalsIgnoreCase(T,v)?L.Error:R.equalsIgnoreCase(_,v)||R.equalsIgnoreCase(D,v)?L.Warning:R.equalsIgnoreCase(b,v)?L.Info:L.Ignore:L.Ignore}L.fromValue=P;function C(v){switch(v){case L.Error:return T;case L.Warning:return _;case L.Info:return b;default:return S}}L.toString=C}(N||(N={})),e.default=N}),define(ae[125],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ae[46],ce([0,1,21,27]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class L{constructor(){this._value="",this._pos=0}reset(d){return this._value=d,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(d){const g=d.charCodeAt(0),w=this._value.charCodeAt(this._pos);return g-w}value(){return this._value[this._pos]}}e.StringIterator=L;class T{constructor(d=!0){this._caseSensitive=d}reset(d){return this._value=d,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let d=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(d)this._from++;else break;else d=!1;return this}cmp(d){return this._caseSensitive?(0,N.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,N.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class _{constructor(d=!0,g=!0){this._splitOnBackslash=d,this._caseSensitive=g}reset(d){this._from=0,this._to=0,this._value=d,this._valueLen=d.length;for(let g=d.length-1;g>=0;g--,this._valueLen--){const w=this._value.charCodeAt(g);if(!(w===47||this._splitOnBackslash&&w===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let d=!0;for(;this._to<this._valueLen;this._to++){const g=this._value.charCodeAt(this._to);if(g===47||this._splitOnBackslash&&g===92)if(d)this._from++;else break;else d=!1}return this}cmp(d){return this._caseSensitive?(0,N.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,N.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=_;var D;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(D||(D={}));class b{constructor(d,g){this._ignorePathCasing=d,this._ignoreQueryAndFragment=g,this._states=[],this._stateIdx=0}reset(d){return this._value=d,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new _(!1,!this._ignorePathCasing(d)),this._pathIterator.reset(d.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(d)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(d){if(this._states[this._stateIdx]===1)return(0,N.compareIgnoreCase)(d,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,N.compareIgnoreCase)(d,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(d);if(this._states[this._stateIdx]===4)return(0,N.compare)(d,this._value.query);if(this._states[this._stateIdx]===5)return(0,N.compare)(d,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=b;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(P||(P={}));class C{static forUris(d=()=>!1,g=()=>!1){return new C(new b(d,g))}static forPaths(d=!1){return new C(new _(void 0,!d))}static forStrings(){return new C(new L)}static forConfigKeys(){return new C(new T)}constructor(d){this._iter=d}clear(){this._root=void 0}fill(d,g){if(g){const w=g.slice(0);(0,R.shuffle)(w);for(const a of w)this.set(a,d)}else{const w=d.slice(0);(0,R.shuffle)(w);for(const a of w)this.set(a[0],a[1])}}set(d,g){const w=this._iter.reset(d);let a;this._root||(this._root=new S,this._root.segment=w.value());const u=[];for(a=this._root;;){const E=w.cmp(a.segment);if(E>0)a.left||(a.left=new S,a.left.segment=w.value()),u.push([-1,a]),a=a.left;else if(E<0)a.right||(a.right=new S,a.right.segment=w.value()),u.push([1,a]),a=a.right;else if(w.hasNext())w.next(),a.mid||(a.mid=new S,a.mid.segment=w.value()),u.push([0,a]),a=a.mid;else break}const h=a.value;a.value=g,a.key=d;for(let E=u.length-1;E>=0;E--){const p=u[E][1];p.updateHeight();const k=p.balanceFactor();if(k<-1||k>1){const n=u[E][0],r=u[E+1][0];if(n===1&&r===1)u[E][1]=p.rotateLeft();else if(n===-1&&r===-1)u[E][1]=p.rotateRight();else if(n===1&&r===-1)p.right=u[E+1][1]=u[E+1][1].rotateRight(),u[E][1]=p.rotateLeft();else if(n===-1&&r===1)p.left=u[E+1][1]=u[E+1][1].rotateLeft(),u[E][1]=p.rotateRight();else throw new Error;if(E>0)switch(u[E-1][0]){case-1:u[E-1][1].left=u[E][1];break;case 1:u[E-1][1].right=u[E][1];break;case 0:u[E-1][1].mid=u[E][1];break}else this._root=u[0][1]}}return h}get(d){return this._getNode(d)?.value}_getNode(d){const g=this._iter.reset(d);let w=this._root;for(;w;){const a=g.cmp(w.segment);if(a>0)w=w.left;else if(a<0)w=w.right;else if(g.hasNext())g.next(),w=w.mid;else break}return w}has(d){const g=this._getNode(d);return!(g?.value===void 0&&g?.mid===void 0)}delete(d){return this._delete(d,!1)}deleteSuperstr(d){return this._delete(d,!0)}_delete(d,g){const w=this._iter.reset(d),a=[];let u=this._root;for(;u;){const h=w.cmp(u.segment);if(h>0)a.push([-1,u]),u=u.left;else if(h<0)a.push([1,u]),u=u.right;else if(w.hasNext())w.next(),a.push([0,u]),u=u.mid;else break}if(u){if(g?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const h=this._min(u.right);if(h.key){const{key:E,value:p,segment:k}=h;this._delete(h.key,!1),u.key=E,u.value=p,u.segment=k}}else{const h=u.left??u.right;if(a.length>0){const[E,p]=a[a.length-1];switch(E){case-1:p.left=h;break;case 0:p.mid=h;break;case 1:p.right=h;break}}else this._root=h}for(let h=a.length-1;h>=0;h--){const E=a[h][1];E.updateHeight();const p=E.balanceFactor();if(p>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),a[h][1]=E.rotateLeft()):p<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),a[h][1]=E.rotateRight()),h>0)switch(a[h-1][0]){case-1:a[h-1][1].left=a[h][1];break;case 1:a[h-1][1].right=a[h][1];break;case 0:a[h-1][1].mid=a[h][1];break}else this._root=a[0][1]}}}_min(d){for(;d.left;)d=d.left;return d}findSubstr(d){const g=this._iter.reset(d);let w=this._root,a;for(;w;){const u=g.cmp(w.segment);if(u>0)w=w.left;else if(u<0)w=w.right;else if(g.hasNext())g.next(),a=w.value||a,w=w.mid;else break}return w&&w.value||a}findSuperstr(d){return this._findSuperstrOrElement(d,!1)}_findSuperstrOrElement(d,g){const w=this._iter.reset(d);let a=this._root;for(;a;){const u=w.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(w.hasNext())w.next(),a=a.mid;else return a.mid?this._entries(a.mid):g?a.value:void 0}}hasElementOrSubtree(d){return this._findSuperstrOrElement(d,!0)!==void 0}forEach(d){for(const[g,w]of this)d(w,g)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(d){const g=[];return this._dfsEntries(d,g),g[Symbol.iterator]()}_dfsEntries(d,g){d&&(d.left&&this._dfsEntries(d.left,g),d.value&&g.push([d.key,d.value]),d.mid&&this._dfsEntries(d.mid,g),d.right&&this._dfsEntries(d.right,g))}_isBalanced(){const d=g=>{if(!g)return!0;const w=g.balanceFactor();return w<-1||w>1?!1:d(g.left)&&d(g.right)};return d(this._root)}}e.TernarySearchTree=C}),define(ae[10],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function R(r){return typeof r=="string"}e.isString=R;function N(r){return Array.isArray(r)&&r.every(i=>R(i))}e.isStringArray=N;function L(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=L;function T(r){const i=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof i}e.isTypedArray=T;function _(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=_;function D(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=D;function b(r){return r===!0||r===!1}e.isBoolean=b;function S(r){return typeof r>"u"}e.isUndefined=S;function P(r){return!C(r)}e.isDefined=P;function C(r){return S(r)||r===null}e.isUndefinedOrNull=C;function v(r,i){if(!r)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=v;function d(r){if(C(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=d;function g(...r){const i=[];for(let t=0;t<r.length;t++){const s=r[t];if(C(s))throw new Error(`Assertion Failed: argument at index ${t} is undefined or null`);i.push(s)}return i}e.assertAllDefined=g;const w=Object.prototype.hasOwnProperty;function a(r){if(!L(r))return!1;for(const i in r)if(w.call(r,i))return!1;return!0}e.isEmptyObject=a;function u(r){return typeof r=="function"}e.isFunction=u;function h(...r){return r.length>0&&r.every(u)}e.areFunctions=h;function E(r,i){const t=Math.min(r.length,i.length);for(let s=0;s<t;s++)p(r[s],i[s])}e.validateConstraints=E;function p(r,i){if(R(i)){if(typeof r!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(r instanceof i)return}catch{}if(!C(r)&&r.constructor===i||i.length===1&&i.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p;function k(r){return r===null?void 0:r}e.withNullAsUndefined=k;function n(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=n}),define(ae[31],ce([0,1,10]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function N(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const h=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([E,p])=>{h[E]=p&&typeof p=="object"?N(p):p}),h}e.deepClone=N;function L(u){if(!u||typeof u!="object")return u;const h=[u];for(;h.length>0;){const E=h.shift();Object.freeze(E);for(const p in E)if(T.call(E,p)){const k=E[p];typeof k=="object"&&!Object.isFrozen(k)&&!(0,R.isTypedArray)(k)&&h.push(k)}}return u}e.deepFreeze=L;const T=Object.prototype.hasOwnProperty;function _(u,h){return D(u,h,new Set)}e.cloneAndChange=_;function D(u,h,E){if((0,R.isUndefinedOrNull)(u))return u;const p=h(u);if(typeof p<"u")return p;if(Array.isArray(u)){const k=[];for(const n of u)k.push(D(n,h,E));return k}if((0,R.isObject)(u)){if(E.has(u))throw new Error("Cannot clone recursive data-structure");E.add(u);const k={};for(const n in u)T.call(u,n)&&(k[n]=D(u[n],h,E));return E.delete(u),k}return u}function b(u,h,E=!0){return(0,R.isObject)(u)?((0,R.isObject)(h)&&Object.keys(h).forEach(p=>{p in u?E&&((0,R.isObject)(u[p])&&(0,R.isObject)(h[p])?b(u[p],h[p],E):u[p]=h[p]):u[p]=h[p]}),u):h}e.mixin=b;function S(u,h){if(u===h)return!0;if(u==null||h===null||h===void 0||typeof u!=typeof h||typeof u!="object"||Array.isArray(u)!==Array.isArray(h))return!1;let E,p;if(Array.isArray(u)){if(u.length!==h.length)return!1;for(E=0;E<u.length;E++)if(!S(u[E],h[E]))return!1}else{const k=[];for(p in u)k.push(p);k.sort();const n=[];for(p in h)n.push(p);if(n.sort(),!S(k,n))return!1;for(E=0;E<k.length;E++)if(!S(u[k[E]],h[k[E]]))return!1}return!0}e.equals=S;function P(u){const h=new Set;return JSON.stringify(u,(E,p)=>{if((0,R.isObject)(p)||Array.isArray(p)){if(h.has(p))return"[Circular]";h.add(p)}return p})}e.safeStringify=P;function C(u,h){const E=Object.create(null);return!u||!h||Object.keys(h).forEach(k=>{const n=u[k],r=h[k];S(n,r)||(E[k]=r)}),E}e.distinct=C;function v(u,h){const E=h.toLowerCase(),p=Object.keys(u).find(k=>k.toLowerCase()===E);return p?u[p]:u[h]}e.getCaseInsensitive=v;function d(u,h){const E=Object.create(null);for(const[p,k]of Object.entries(u))h(p,k)&&(E[p]=k);return E}e.filter=d;function g(u){let h=[],E=Object.getPrototypeOf(u);for(;Object.prototype!==E;)h=h.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return h}e.getAllPropertyNames=g;function w(u){const h=[];for(const E of g(u))typeof u[E]=="function"&&h.push(E);return h}e.getAllMethodNames=w;function a(u,h){const E=k=>function(){const n=Array.prototype.slice.call(arguments,0);return h(k,n)},p={};for(const k of u)p[k]=E(k);return p}e.createProxyObject=a}),define(ae[32],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return R.test(L)}e.isUUID=N,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(D){for(let b=0;b<D.length;b++)D[b]=Math.floor(Math.random()*256);return D};const T=new Uint8Array(16),_=[];for(let D=0;D<256;D++)_.push(D.toString(16).padStart(2,"0"));return function(){L(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let b=0,S="";return S+=_[T[b++]],S+=_[T[b++]],S+=_[T[b++]],S+=_[T[b++]],S+="-",S+=_[T[b++]],S+=_[T[b++]],S+="-",S+=_[T[b++]],S+=_[T[b++]],S+="-",S+=_[T[b++]],S+=_[T[b++]],S+="-",S+=_[T[b++]],S+=_[T[b++]],S+=_[T[b++]],S+=_[T[b++]],S+=_[T[b++]],S+=_[T[b++]],S}}()}),define(ae[126],ce([0,1,36]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(_){const D=_.replace(/\-/g,":").toLowerCase();return!N.has(D)}function T(){const _=(0,R.networkInterfaces)();for(const D in _){const b=_[D];if(b){for(const{mac:S}of b)if(L(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(ae[127],ce([0,1,36,46,32,126]),function(ne,e,R,N,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(S){return this._virtualMachineOUIs||(this._virtualMachineOUIs=N.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(S)}value(){if(this._value===void 0){let S=0,P=0;const C=(0,R.networkInterfaces)();for(const v in C){const d=C[v];if(d)for(const{mac:g,internal:w}of d)w||(P+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(S+=1))}this._value=P>0?S/P:0}return this._value}};let _;async function D(S){return _||(_=(async()=>await b(S)||L.generateUuid())()),_}e.getMachineId=D;async function b(S){try{const P=await new Promise((v,d)=>{ne(["crypto"],v,d)}),C=(0,T.getMac)();return P.createHash("sha256").update(C,"utf8").digest("hex")}catch(P){S(P);return}}}),define(ae[128],ce([0,1,62]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function N(D,b,S,P=1){let C=!1;return new Promise(v=>{const d=setTimeout(()=>{if(!C)return C=!0,v(0)},S);L(D,b,P,g=>{if(!C)return C=!0,clearTimeout(d),v(g)})})}e.findFreePort=N;function L(D,b,S,P){if(b===0)return P(0);const C=new R.Socket;C.once("connect",()=>(_(C),L(D+S,b-1,S,P))),C.once("data",()=>{}),C.once("error",v=>(_(C),v.code!=="ECONNREFUSED"?L(D+S,b-1,S,P):P(D))),C.connect(D,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(D,b,S,P="127.0.0.1"){let C=!1,v,d=1;const g=R.createServer({pauseOnConnect:!0});function w(a,u){C||(C=!0,g.removeAllListeners(),g.close(),v&&clearTimeout(v),u(a))}return new Promise(a=>{v=setTimeout(()=>{w(0,a)},S),g.on("listening",()=>{w(D,a)}),g.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&d<b?(D++,d++,g.listen(D,P)):w(0,a)}),g.on("close",()=>{w(0,a)}),g.listen(D,P)})}e.findFreePortFaster=T;function _(D){try{D.removeAllListeners("connect"),D.removeAllListeners("error"),D.end(),D.destroy(),D.unref()}catch(b){console.error(b)}}}),define(ae[129],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function R(N){return!!N.parentPort}e.isUtilityProcess=R}),define(ae[130],ce([11,9]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ae[63],ce([0,1,130]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const N=60,L=N*60,T=L*24,_=T*7,D=T*30,b=T*365;function S(C,v,d,g){typeof C!="number"&&(C=C.getTime());const w=Math.round((new Date().getTime()-C)/1e3);if(w<-30)return(0,R.localize)(0,null,S(new Date().getTime()+w*1e3,!1));if(!g&&w<30)return(0,R.localize)(1,null);let a;return w<N?(a=w,v?a===1?d?(0,R.localize)(2,null,a):(0,R.localize)(3,null,a):d?(0,R.localize)(4,null,a):(0,R.localize)(5,null,a):a===1?d?(0,R.localize)(6,null,a):(0,R.localize)(7,null,a):d?(0,R.localize)(8,null,a):(0,R.localize)(9,null,a)):w<L?(a=Math.floor(w/N),v?a===1?d?(0,R.localize)(10,null,a):(0,R.localize)(11,null,a):d?(0,R.localize)(12,null,a):(0,R.localize)(13,null,a):a===1?d?(0,R.localize)(14,null,a):(0,R.localize)(15,null,a):d?(0,R.localize)(16,null,a):(0,R.localize)(17,null,a)):w<T?(a=Math.floor(w/L),v?a===1?d?(0,R.localize)(18,null,a):(0,R.localize)(19,null,a):d?(0,R.localize)(20,null,a):(0,R.localize)(21,null,a):a===1?d?(0,R.localize)(22,null,a):(0,R.localize)(23,null,a):d?(0,R.localize)(24,null,a):(0,R.localize)(25,null,a)):w<_?(a=Math.floor(w/T),v?a===1?(0,R.localize)(26,null,a):(0,R.localize)(27,null,a):a===1?(0,R.localize)(28,null,a):(0,R.localize)(29,null,a)):w<D?(a=Math.floor(w/_),v?a===1?d?(0,R.localize)(30,null,a):(0,R.localize)(31,null,a):d?(0,R.localize)(32,null,a):(0,R.localize)(33,null,a):a===1?d?(0,R.localize)(34,null,a):(0,R.localize)(35,null,a):d?(0,R.localize)(36,null,a):(0,R.localize)(37,null,a)):w<b?(a=Math.floor(w/D),v?a===1?d?(0,R.localize)(38,null,a):(0,R.localize)(39,null,a):d?(0,R.localize)(40,null,a):(0,R.localize)(41,null,a):a===1?d?(0,R.localize)(42,null,a):(0,R.localize)(43,null,a):d?(0,R.localize)(44,null,a):(0,R.localize)(45,null,a)):(a=Math.floor(w/b),v?a===1?d?(0,R.localize)(46,null,a):(0,R.localize)(47,null,a):d?(0,R.localize)(48,null,a):(0,R.localize)(49,null,a):a===1?d?(0,R.localize)(50,null,a):(0,R.localize)(51,null,a):d?(0,R.localize)(52,null,a):(0,R.localize)(53,null,a))}e.fromNow=S;function P(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(ae[131],ce([11,9]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ae[38],ce([0,1,21,10,131]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(C,v){return v&&(C.stack||C.stacktrace)?L.localize(0,null,D(C),_(C.stack)||_(C.stacktrace)):D(C)}function _(C){return Array.isArray(C)?C.join(`
`):C}function D(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?L.localize(1,null,C.message):C.message||L.localize(2,null)}function b(C=null,v=!1){if(!C)return L.localize(3,null);if(Array.isArray(C)){const d=R.coalesce(C),g=b(d[0],v);return d.length>1?L.localize(4,null,g,d.length):g}if(N.isString(C))return C;if(C.detail){const d=C.detail;if(d.error)return T(d.error,v);if(d.exception)return T(d.exception,v)}return C.stack?T(C,v):C.message?C.message:L.localize(5,null)}e.toErrorMessage=b;function S(C){const v=C;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=S;function P(C,v){let d;return typeof C=="string"?d=new Error(C):d=C,d.actions=v,d}e.createErrorWithActions=P}),define(ae[132],ce([11,9]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(ae[133],ce([0,1,132]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function N(L){switch(L){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}e.getParseErrorMessage=N}),define(ae[134],ce([11,9]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ae[5],ce([0,1,134]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let N=!1,L=!1,T=!1,_=!1,D=!1,b=!1,S=!1,P=!1,C=!1,v=!1,d,g=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT,a,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const E=typeof h?.versions?.electron=="string",p=E&&h?.type==="renderer";if(typeof navigator=="object"&&!p)u=navigator.userAgent,N=u.indexOf("Windows")>=0,L=u.indexOf("Macintosh")>=0,P=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=u.indexOf("Linux")>=0,v=u?.indexOf("Mobi")>=0,b=!0,d=R.getConfiguredDefaultLocale(R.localize(0,null))||e.LANGUAGE_DEFAULT,g=d,w=navigator.language;else if(typeof h=="object"){N=h.platform==="win32",L=h.platform==="darwin",T=h.platform==="linux",_=T&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,S=E,C=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,g=e.LANGUAGE_DEFAULT;const y=h.env.VSCODE_NLS_CONFIG;if(y)try{const f=JSON.parse(y),l=f.availableLanguages["*"];d=f.locale,w=f.osLocale,g=l||e.LANGUAGE_DEFAULT,a=f._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var k;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(k||(e.Platform=k={}));function n(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=n;let r=0;L?r=1:N?r=3:T&&(r=2),e.isWindows=N,e.isMacintosh=L,e.isLinux=T,e.isLinuxSnap=_,e.isNative=D,e.isElectron=S,e.isWeb=b,e.isWebWorker=b&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isMobile=v,e.isCI=C,e.platform=r,e.userAgent=u,e.language=g;var i;(function(y){function f(){return e.language}y.value=f;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}y.isDefaultVariant=l;function I(){return e.language==="en"}y.isDefault=I})(i||(e.Language=i={})),e.locale=d,e.platformLocale=w,e.translationsConfigFile=a,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const y=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let I=0,A=y.length;I<A;I++){const F=y[I];if(F.id===l.data.vscodeScheduleAsyncWork){y.splice(I,1),F.callback();return}}});let f=0;return l=>{const I=++f;y.push({id:I,callback:l}),e.globals.postMessage({vscodeScheduleAsyncWork:I},"*")}}return y=>setTimeout(y)})();var t;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=L||P?2:N?1:3;let s=!0,o=!1;function c(){if(!o){o=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,s=new Uint16Array(y.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ae[37],ce([0,1,5]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let N;if(typeof R.globals.vscode<"u"&&typeof R.globals.vscode.process<"u"){const L=R.globals.vscode.process;N={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.platform=N.platform,e.arch=N.arch}),define(ae[15],ce([0,1,37]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const N=65,L=97,T=90,_=122,D=46,b=47,S=92,P=58,C=63;class v extends Error{constructor(r,i,t){let s;typeof i=="string"&&i.indexOf("not ")===0?(s="must not be",i=i.replace(/^not /,"")):s="must be";const o=r.indexOf(".")!==-1?"property":"argument";let c=`The "${r}" ${o} ${s} of type ${i}`;c+=`. Received type ${typeof t}`,super(c),this.code="ERR_INVALID_ARG_TYPE"}}function d(n,r){if(n===null||typeof n!="object")throw new v(r,"Object",n)}function g(n,r){if(typeof n!="string")throw new v(r,"string",n)}const w=R.platform==="win32";function a(n){return n===b||n===S}function u(n){return n===b}function h(n){return n>=N&&n<=T||n>=L&&n<=_}function E(n,r,i,t){let s="",o=0,c=-1,y=0,f=0;for(let l=0;l<=n.length;++l){if(l<n.length)f=n.charCodeAt(l);else{if(t(f))break;f=b}if(t(f)){if(!(c===l-1||y===1))if(y===2){if(s.length<2||o!==2||s.charCodeAt(s.length-1)!==D||s.charCodeAt(s.length-2)!==D){if(s.length>2){const I=s.lastIndexOf(i);I===-1?(s="",o=0):(s=s.slice(0,I),o=s.length-1-s.lastIndexOf(i)),c=l,y=0;continue}else if(s.length!==0){s="",o=0,c=l,y=0;continue}}r&&(s+=s.length>0?`${i}..`:"..",o=2)}else s.length>0?s+=`${i}${n.slice(c+1,l)}`:s=n.slice(c+1,l),o=l-c-1;c=l,y=0}else f===D&&y!==-1?++y:y=-1}return s}function p(n,r){d(r,"pathObject");const i=r.dir||r.root,t=r.base||`${r.name||""}${r.ext||""}`;return i?i===r.root?`${i}${t}`:`${i}${n}${t}`:t}e.win32={resolve(...n){let r="",i="",t=!1;for(let s=n.length-1;s>=-1;s--){let o;if(s>=0){if(o=n[s],g(o,"path"),o.length===0)continue}else r.length===0?o=R.cwd():(o=R.env[`=${r}`]||R.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==r.toLowerCase()&&o.charCodeAt(2)===S)&&(o=`${r}\\`));const c=o.length;let y=0,f="",l=!1;const I=o.charCodeAt(0);if(c===1)a(I)&&(y=1,l=!0);else if(a(I))if(l=!0,a(o.charCodeAt(1))){let A=2,F=A;for(;A<c&&!a(o.charCodeAt(A));)A++;if(A<c&&A!==F){const M=o.slice(F,A);for(F=A;A<c&&a(o.charCodeAt(A));)A++;if(A<c&&A!==F){for(F=A;A<c&&!a(o.charCodeAt(A));)A++;(A===c||A!==F)&&(f=`\\\\${M}\\${o.slice(F,A)}`,y=A)}}}else y=1;else h(I)&&o.charCodeAt(1)===P&&(f=o.slice(0,2),y=2,c>2&&a(o.charCodeAt(2))&&(l=!0,y=3));if(f.length>0)if(r.length>0){if(f.toLowerCase()!==r.toLowerCase())continue}else r=f;if(t){if(r.length>0)break}else if(i=`${o.slice(y)}\\${i}`,t=l,l&&r.length>0)break}return i=E(i,!t,"\\",a),t?`${r}\\${i}`:`${r}${i}`||"."},normalize(n){g(n,"path");const r=n.length;if(r===0)return".";let i=0,t,s=!1;const o=n.charCodeAt(0);if(r===1)return u(o)?"\\":n;if(a(o))if(s=!0,a(n.charCodeAt(1))){let y=2,f=y;for(;y<r&&!a(n.charCodeAt(y));)y++;if(y<r&&y!==f){const l=n.slice(f,y);for(f=y;y<r&&a(n.charCodeAt(y));)y++;if(y<r&&y!==f){for(f=y;y<r&&!a(n.charCodeAt(y));)y++;if(y===r)return`\\\\${l}\\${n.slice(f)}\\`;y!==f&&(t=`\\\\${l}\\${n.slice(f,y)}`,i=y)}}}else i=1;else h(o)&&n.charCodeAt(1)===P&&(t=n.slice(0,2),i=2,r>2&&a(n.charCodeAt(2))&&(s=!0,i=3));let c=i<r?E(n.slice(i),!s,"\\",a):"";return c.length===0&&!s&&(c="."),c.length>0&&a(n.charCodeAt(r-1))&&(c+="\\"),t===void 0?s?`\\${c}`:c:s?`${t}\\${c}`:`${t}${c}`},isAbsolute(n){g(n,"path");const r=n.length;if(r===0)return!1;const i=n.charCodeAt(0);return a(i)||r>2&&h(i)&&n.charCodeAt(1)===P&&a(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let r,i;for(let o=0;o<n.length;++o){const c=n[o];g(c,"path"),c.length>0&&(r===void 0?r=i=c:r+=`\\${c}`)}if(r===void 0)return".";let t=!0,s=0;if(typeof i=="string"&&a(i.charCodeAt(0))){++s;const o=i.length;o>1&&a(i.charCodeAt(1))&&(++s,o>2&&(a(i.charCodeAt(2))?++s:t=!1))}if(t){for(;s<r.length&&a(r.charCodeAt(s));)s++;s>=2&&(r=`\\${r.slice(s)}`)}return e.win32.normalize(r)},relative(n,r){if(g(n,"from"),g(r,"to"),n===r)return"";const i=e.win32.resolve(n),t=e.win32.resolve(r);if(i===t||(n=i.toLowerCase(),r=t.toLowerCase(),n===r))return"";let s=0;for(;s<n.length&&n.charCodeAt(s)===S;)s++;let o=n.length;for(;o-1>s&&n.charCodeAt(o-1)===S;)o--;const c=o-s;let y=0;for(;y<r.length&&r.charCodeAt(y)===S;)y++;let f=r.length;for(;f-1>y&&r.charCodeAt(f-1)===S;)f--;const l=f-y,I=c<l?c:l;let A=-1,F=0;for(;F<I;F++){const V=n.charCodeAt(s+F);if(V!==r.charCodeAt(y+F))break;V===S&&(A=F)}if(F!==I){if(A===-1)return t}else{if(l>I){if(r.charCodeAt(y+F)===S)return t.slice(y+F+1);if(F===2)return t.slice(y+F)}c>I&&(n.charCodeAt(s+F)===S?A=F:F===2&&(A=3)),A===-1&&(A=0)}let M="";for(F=s+A+1;F<=o;++F)(F===o||n.charCodeAt(F)===S)&&(M+=M.length===0?"..":"\\..");return y+=A,M.length>0?`${M}${t.slice(y,f)}`:(t.charCodeAt(y)===S&&++y,t.slice(y,f))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const r=e.win32.resolve(n);if(r.length<=2)return n;if(r.charCodeAt(0)===S){if(r.charCodeAt(1)===S){const i=r.charCodeAt(2);if(i!==C&&i!==D)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(h(r.charCodeAt(0))&&r.charCodeAt(1)===P&&r.charCodeAt(2)===S)return`\\\\?\\${r}`;return n},dirname(n){g(n,"path");const r=n.length;if(r===0)return".";let i=-1,t=0;const s=n.charCodeAt(0);if(r===1)return a(s)?n:".";if(a(s)){if(i=t=1,a(n.charCodeAt(1))){let y=2,f=y;for(;y<r&&!a(n.charCodeAt(y));)y++;if(y<r&&y!==f){for(f=y;y<r&&a(n.charCodeAt(y));)y++;if(y<r&&y!==f){for(f=y;y<r&&!a(n.charCodeAt(y));)y++;if(y===r)return n;y!==f&&(i=t=y+1)}}}}else h(s)&&n.charCodeAt(1)===P&&(i=r>2&&a(n.charCodeAt(2))?3:2,t=i);let o=-1,c=!0;for(let y=r-1;y>=t;--y)if(a(n.charCodeAt(y))){if(!c){o=y;break}}else c=!1;if(o===-1){if(i===-1)return".";o=i}return n.slice(0,o)},basename(n,r){r!==void 0&&g(r,"ext"),g(n,"path");let i=0,t=-1,s=!0,o;if(n.length>=2&&h(n.charCodeAt(0))&&n.charCodeAt(1)===P&&(i=2),r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let c=r.length-1,y=-1;for(o=n.length-1;o>=i;--o){const f=n.charCodeAt(o);if(a(f)){if(!s){i=o+1;break}}else y===-1&&(s=!1,y=o+1),c>=0&&(f===r.charCodeAt(c)?--c===-1&&(t=o):(c=-1,t=y))}return i===t?t=y:t===-1&&(t=n.length),n.slice(i,t)}for(o=n.length-1;o>=i;--o)if(a(n.charCodeAt(o))){if(!s){i=o+1;break}}else t===-1&&(s=!1,t=o+1);return t===-1?"":n.slice(i,t)},extname(n){g(n,"path");let r=0,i=-1,t=0,s=-1,o=!0,c=0;n.length>=2&&n.charCodeAt(1)===P&&h(n.charCodeAt(0))&&(r=t=2);for(let y=n.length-1;y>=r;--y){const f=n.charCodeAt(y);if(a(f)){if(!o){t=y+1;break}continue}s===-1&&(o=!1,s=y+1),f===D?i===-1?i=y:c!==1&&(c=1):i!==-1&&(c=-1)}return i===-1||s===-1||c===0||c===1&&i===s-1&&i===t+1?"":n.slice(i,s)},format:p.bind(null,"\\"),parse(n){g(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const i=n.length;let t=0,s=n.charCodeAt(0);if(i===1)return a(s)?(r.root=r.dir=n,r):(r.base=r.name=n,r);if(a(s)){if(t=1,a(n.charCodeAt(1))){let A=2,F=A;for(;A<i&&!a(n.charCodeAt(A));)A++;if(A<i&&A!==F){for(F=A;A<i&&a(n.charCodeAt(A));)A++;if(A<i&&A!==F){for(F=A;A<i&&!a(n.charCodeAt(A));)A++;A===i?t=A:A!==F&&(t=A+1)}}}}else if(h(s)&&n.charCodeAt(1)===P){if(i<=2)return r.root=r.dir=n,r;if(t=2,a(n.charCodeAt(2))){if(i===3)return r.root=r.dir=n,r;t=3}}t>0&&(r.root=n.slice(0,t));let o=-1,c=t,y=-1,f=!0,l=n.length-1,I=0;for(;l>=t;--l){if(s=n.charCodeAt(l),a(s)){if(!f){c=l+1;break}continue}y===-1&&(f=!1,y=l+1),s===D?o===-1?o=l:I!==1&&(I=1):o!==-1&&(I=-1)}return y!==-1&&(o===-1||I===0||I===1&&o===y-1&&o===c+1?r.base=r.name=n.slice(c,y):(r.name=n.slice(c,o),r.base=n.slice(c,y),r.ext=n.slice(o,y))),c>0&&c!==t?r.dir=n.slice(0,c-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const k=(()=>{if(w){const n=/\\/g;return()=>{const r=R.cwd().replace(n,"/");return r.slice(r.indexOf("/"))}}return()=>R.cwd()})();e.posix={resolve(...n){let r="",i=!1;for(let t=n.length-1;t>=-1&&!i;t--){const s=t>=0?n[t]:k();g(s,"path"),s.length!==0&&(r=`${s}/${r}`,i=s.charCodeAt(0)===b)}return r=E(r,!i,"/",u),i?`/${r}`:r.length>0?r:"."},normalize(n){if(g(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===b,i=n.charCodeAt(n.length-1)===b;return n=E(n,!r,"/",u),n.length===0?r?"/":i?"./":".":(i&&(n+="/"),r?`/${n}`:n)},isAbsolute(n){return g(n,"path"),n.length>0&&n.charCodeAt(0)===b},join(...n){if(n.length===0)return".";let r;for(let i=0;i<n.length;++i){const t=n[i];g(t,"path"),t.length>0&&(r===void 0?r=t:r+=`/${t}`)}return r===void 0?".":e.posix.normalize(r)},relative(n,r){if(g(n,"from"),g(r,"to"),n===r||(n=e.posix.resolve(n),r=e.posix.resolve(r),n===r))return"";const i=1,t=n.length,s=t-i,o=1,c=r.length-o,y=s<c?s:c;let f=-1,l=0;for(;l<y;l++){const A=n.charCodeAt(i+l);if(A!==r.charCodeAt(o+l))break;A===b&&(f=l)}if(l===y)if(c>y){if(r.charCodeAt(o+l)===b)return r.slice(o+l+1);if(l===0)return r.slice(o+l)}else s>y&&(n.charCodeAt(i+l)===b?f=l:l===0&&(f=0));let I="";for(l=i+f+1;l<=t;++l)(l===t||n.charCodeAt(l)===b)&&(I+=I.length===0?"..":"/..");return`${I}${r.slice(o+f)}`},toNamespacedPath(n){return n},dirname(n){if(g(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===b;let i=-1,t=!0;for(let s=n.length-1;s>=1;--s)if(n.charCodeAt(s)===b){if(!t){i=s;break}}else t=!1;return i===-1?r?"/":".":r&&i===1?"//":n.slice(0,i)},basename(n,r){r!==void 0&&g(r,"ext"),g(n,"path");let i=0,t=-1,s=!0,o;if(r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let c=r.length-1,y=-1;for(o=n.length-1;o>=0;--o){const f=n.charCodeAt(o);if(f===b){if(!s){i=o+1;break}}else y===-1&&(s=!1,y=o+1),c>=0&&(f===r.charCodeAt(c)?--c===-1&&(t=o):(c=-1,t=y))}return i===t?t=y:t===-1&&(t=n.length),n.slice(i,t)}for(o=n.length-1;o>=0;--o)if(n.charCodeAt(o)===b){if(!s){i=o+1;break}}else t===-1&&(s=!1,t=o+1);return t===-1?"":n.slice(i,t)},extname(n){g(n,"path");let r=-1,i=0,t=-1,s=!0,o=0;for(let c=n.length-1;c>=0;--c){const y=n.charCodeAt(c);if(y===b){if(!s){i=c+1;break}continue}t===-1&&(s=!1,t=c+1),y===D?r===-1?r=c:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||t===-1||o===0||o===1&&r===t-1&&r===i+1?"":n.slice(r,t)},format:p.bind(null,"/"),parse(n){g(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const i=n.charCodeAt(0)===b;let t;i?(r.root="/",t=1):t=0;let s=-1,o=0,c=-1,y=!0,f=n.length-1,l=0;for(;f>=t;--f){const I=n.charCodeAt(f);if(I===b){if(!y){o=f+1;break}continue}c===-1&&(y=!1,c=f+1),I===D?s===-1?s=f:l!==1&&(l=1):s!==-1&&(l=-1)}if(c!==-1){const I=o===0&&i?1:o;s===-1||l===0||l===1&&s===c-1&&s===o+1?r.base=r.name=n.slice(I,c):(r.name=n.slice(I,s),r.base=n.slice(I,c),r.ext=n.slice(s,c))}return o>0?r.dir=n.slice(0,o-1):i&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w?e.win32.normalize:e.posix.normalize,e.isAbsolute=w?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w?e.win32.join:e.posix.join,e.resolve=w?e.win32.resolve:e.posix.resolve,e.relative=w?e.win32.relative:e.posix.relative,e.dirname=w?e.win32.dirname:e.posix.dirname,e.basename=w?e.win32.basename:e.posix.basename,e.extname=w?e.win32.extname:e.posix.extname,e.format=w?e.win32.format:e.posix.format,e.parse=w?e.win32.parse:e.posix.parse,e.toNamespacedPath=w?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w?e.win32.sep:e.posix.sep,e.delimiter=w?e.win32.delimiter:e.posix.delimiter}),define(ae[47],ce([0,1,15,5,27,10]),function(ne,e,R,N,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(o){return o===47||o===92}e.isPathSeparator=_;function D(o){return o.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=D;function b(o){return o.indexOf("/")===-1&&(o=D(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=b;function S(o,c=R.posix.sep){if(!o)return"";const y=o.length,f=o.charCodeAt(0);if(_(f)){if(_(o.charCodeAt(1))&&!_(o.charCodeAt(2))){let I=3;const A=I;for(;I<y&&!_(o.charCodeAt(I));I++);if(A!==I&&!_(o.charCodeAt(I+1))){for(I+=1;I<y;I++)if(_(o.charCodeAt(I)))return o.slice(0,I+1).replace(/[\\/]/g,c)}}return c}else if(u(f)&&o.charCodeAt(1)===58)return _(o.charCodeAt(2))?o.slice(0,2)+c:o.slice(0,2);let l=o.indexOf("://");if(l!==-1){for(l+=3;l<y;l++)if(_(o.charCodeAt(l)))return o.slice(0,l+1)}return""}e.getRoot=S;function P(o){if(!N.isWindows||!o||o.length<5)return!1;let c=o.charCodeAt(0);if(c!==92||(c=o.charCodeAt(1),c!==92))return!1;let y=2;const f=y;for(;y<o.length&&(c=o.charCodeAt(y),c!==92);y++);return!(f===y||(c=o.charCodeAt(y+1),isNaN(c)||c===92))}e.isUNC=P;const C=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(o,c=N.isWindows){const y=c?C:v;return!(!o||o.length===0||/^\s+$/.test(o)||(y.lastIndex=0,y.test(o))||c&&d.test(o)||o==="."||o===".."||c&&o[o.length-1]==="."||c&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=g;function w(o,c,y){const f=o===c;return!y||f?f:!o||!c?!1:(0,L.equalsIgnoreCase)(o,c)}e.isEqual=w;function a(o,c,y,f=R.sep){if(o===c)return!0;if(!o||!c||c.length>o.length)return!1;if(y){if(!(0,L.startsWithIgnoreCase)(o,c))return!1;if(c.length===o.length)return!0;let I=c.length;return c.charAt(c.length-1)===f&&I--,o.charAt(I)===f}return c.charAt(c.length-1)!==f&&(c+=f),o.indexOf(c)===0}e.isEqualOrParent=a;function u(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=u;function h(o,c){return N.isWindows&&o.endsWith(":")&&(o+=R.sep),(0,R.isAbsolute)(o)||(o=(0,R.join)(c,o)),o=(0,R.normalize)(o),N.isWindows?(o=(0,L.rtrim)(o,R.sep),o.endsWith(":")&&(o+=R.sep)):(o=(0,L.rtrim)(o,R.sep),o||(o=R.sep)),o}e.sanitizeFilePath=h;function E(o){const c=(0,R.normalize)(o);return N.isWindows?o.length>3?!1:p(c)&&(o.length===2||c.charCodeAt(2)===92):c===R.posix.sep}e.isRootOrDriveLetter=E;function p(o,c=N.isWindows){return c?u(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function k(o,c=N.isWindows){return p(o,c)?o[0]:void 0}e.getDriveLetter=k;function n(o,c,y){return c.length>o.length?-1:o===c?0:(y&&(o=o.toLowerCase(),c=c.toLowerCase()),o.indexOf(c))}e.indexOfPath=n;function r(o){const c=o.split(":");let y,f,l;for(const I of c){const A=Number(I);(0,T.isNumber)(A)?f===void 0?f=A:l===void 0&&(l=A):y=y?[y,I].join(":"):I}if(!y)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:y,line:f!==void 0?f:void 0,column:l!==void 0?l:f!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(o,c,y=8){let f="";for(let I=0;I<y;I++){let A;I===0&&N.isWindows&&!c&&(y===3||y===4)?A=t:A=i,f+=A.charAt(Math.floor(Math.random()*A.length))}let l;return c?l=`${c}-${f}`:l=f,o?(0,R.join)(o,l):l}e.randomPath=s}),define(ae[135],ce([0,1,15]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(P){const C=(0,R.extname)(P),v=N[C.toLowerCase()];return v!==void 0?v:_(P)}e.getMediaOrTextMime=T;function _(P){const C=(0,R.extname)(P);return L[C.toLowerCase()]}e.getMediaMime=_;function D(P){for(const C in L)if(L[C]===P)return C}e.getExtensionForMimeType=D;const b=/^(.+)\/(.+?)(;.+)?$/;function S(P,C){const v=b.exec(P);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:C?void 0:P}e.normalizeMimeType=S}),define(ae[89],ce([0,1,5]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var N;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function T(D,...b){const S=b.reduce((v,d)=>(v[d]=!0,v),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(v=>!S[v]).forEach(v=>{for(let d=0;d<P.length;d++)if(v.search(P[d])!==-1){delete D[v];break}})}e.sanitizeProcessEnvironment=T;function _(D){D&&(delete D.DEBUG,R.isMacintosh&&delete D.DYLD_LIBRARY_PATH,R.isLinux&&delete D.LD_PRELOAD)}e.removeDangerousEnvVariables=_}),define(ae[12],ce([0,1,15,5]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,T=/^\//,_=/^\/\//;function D(t,s){if(!t.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!L.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!T.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(t,s){return!t&&!s?"file":t}function S(t,s){switch(t){case"https":case"http":case"file":s?s[0]!==C&&(s=C+s):s=C;break}return s}const P="",C="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(s){return s instanceof d?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,o,c,y,f,l=!1){typeof s=="object"?(this.scheme=s.scheme||P,this.authority=s.authority||P,this.path=s.path||P,this.query=s.query||P,this.fragment=s.fragment||P):(this.scheme=b(s,l),this.authority=o||P,this.path=S(this.scheme,c||P),this.query=y||P,this.fragment=f||P,D(this,l))}get fsPath(){return p(this,!1)}with(s){if(!s)return this;let{scheme:o,authority:c,path:y,query:f,fragment:l}=s;return o===void 0?o=this.scheme:o===null&&(o=P),c===void 0?c=this.authority:c===null&&(c=P),y===void 0?y=this.path:y===null&&(y=P),f===void 0?f=this.query:f===null&&(f=P),l===void 0?l=this.fragment:l===null&&(l=P),o===this.scheme&&c===this.authority&&y===this.path&&f===this.query&&l===this.fragment?this:new a(o,c,y,f,l)}static parse(s,o=!1){const c=v.exec(s);return c?new a(c[2]||P,i(c[4]||P),i(c[5]||P),i(c[7]||P),i(c[9]||P),o):new a(P,P,P,P,P)}static file(s){let o=P;if(N.isWindows&&(s=s.replace(/\\/g,C)),s[0]===C&&s[1]===C){const c=s.indexOf(C,2);c===-1?(o=s.substring(2),s=C):(o=s.substring(2,c),s=s.substring(c)||C)}return new a("file",o,s,P,P)}static from(s,o){return new a(s.scheme,s.authority,s.path,s.query,s.fragment,o)}static joinPath(s,...o){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return N.isWindows&&s.scheme==="file"?c=d.file(R.win32.join(p(s,!0),...o)).path:c=R.posix.join(s.path,...o),s.with({path:c})}toString(s=!1){return k(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof d)return s;{const o=new a(s);return o._formatted=s.external??null,o._fsPath=s._sep===w?s.fsPath??null:null,o}}else return s}}e.URI=d;function g(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.isUriComponents=g;const w=N.isWindows?1:void 0;class a extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(s=!1){return s?k(this,!0):(this._formatted||(this._formatted=k(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=w),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const u={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(t,s,o){let c,y=-1;for(let f=0;f<t.length;f++){const l=t.charCodeAt(f);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||s&&l===47||o&&l===91||o&&l===93||o&&l===58)y!==-1&&(c+=encodeURIComponent(t.substring(y,f)),y=-1),c!==void 0&&(c+=t.charAt(f));else{c===void 0&&(c=t.substr(0,f));const I=u[l];I!==void 0?(y!==-1&&(c+=encodeURIComponent(t.substring(y,f)),y=-1),c+=I):y===-1&&(y=f)}}return y!==-1&&(c+=encodeURIComponent(t.substring(y))),c!==void 0?c:t}function E(t){let s;for(let o=0;o<t.length;o++){const c=t.charCodeAt(o);c===35||c===63?(s===void 0&&(s=t.substr(0,o)),s+=u[c]):s!==void 0&&(s+=t[o])}return s!==void 0?s:t}function p(t,s){let o;return t.authority&&t.path.length>1&&t.scheme==="file"?o=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?s?o=t.path.substr(1):o=t.path[1].toLowerCase()+t.path.substr(2):o=t.path,N.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=p;function k(t,s){const o=s?E:h;let c="",{scheme:y,authority:f,path:l,query:I,fragment:A}=t;if(y&&(c+=y,c+=":"),(f||y==="file")&&(c+=C,c+=C),f){let F=f.indexOf("@");if(F!==-1){const M=f.substr(0,F);f=f.substr(F+1),F=M.lastIndexOf(":"),F===-1?c+=o(M,!1,!1):(c+=o(M.substr(0,F),!1,!1),c+=":",c+=o(M.substr(F+1),!1,!0)),c+="@"}f=f.toLowerCase(),F=f.lastIndexOf(":"),F===-1?c+=o(f,!1,!0):(c+=o(f.substr(0,F),!1,!0),c+=f.substr(F))}if(l){if(l.length>=3&&l.charCodeAt(0)===47&&l.charCodeAt(2)===58){const F=l.charCodeAt(1);F>=65&&F<=90&&(l=`/${String.fromCharCode(F+32)}:${l.substr(3)}`)}else if(l.length>=2&&l.charCodeAt(1)===58){const F=l.charCodeAt(0);F>=65&&F<=90&&(l=`${String.fromCharCode(F+32)}:${l.substr(2)}`)}c+=o(l,!0,!1)}return I&&(c+="?",c+=o(I,!1,!1)),A&&(c+="#",c+=s?A:h(A,!1,!1)),c}function n(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+n(t.substr(3)):t}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(t){return t.match(r)?t.replace(r,s=>n(s)):t}}),define(ae[136],ce([0,1,12]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function N(S){const P=S;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=N;function L(S){const P=[];let C;try{const v=JSON.parse(S.arguments),d=v[v.length-1];d&&d.__$stack&&(v.pop(),C=d.__$stack),P.push(...v)}catch{P.push("Unable to log remote console arguments",S.arguments)}return{args:P,stack:C}}e.parse=L;function T(S){if(typeof S!="string")return T(L(S).stack);const P=S;if(P){const C=_(P),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(v&&v.length===4)return{uri:R.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=T;function _(S){if(!S)return S;const P=S.indexOf(`
`);return P===-1?S:S.substring(0,P)}function D(S,P){const{args:C,stack:v}=L(S),d=typeof C[0]=="string"&&C.length===1;let g=_(v);g&&(g=`(${g.trim()})`);let w=[];if(typeof C[0]=="string"?g&&d?w=[`%c[${P}] %c${C[0]} %c${g}`,b("blue"),b(""),b("grey")]:w=[`%c[${P}] %c${C[0]}`,b("blue"),b(""),...C.slice(1)]:w=[`%c[${P}]%`,b("blue"),...C],g&&!d&&w.push(g),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,w)}e.log=D;function b(S){return`color: ${S}`}}),define(ae[64],ce([0,1,16,27,12]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(S){return JSON.stringify(S,D)}e.stringify=T;function _(S){let P=JSON.parse(S);return P=b(P),P}e.parse=_;function D(S,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,N.regExpFlags)(P)}:P}function b(S,P=0){if(!S||P>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return L.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof R.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let C=0;C<S.length;++C)S[C]=b(S[C],P+1);else for(const C in S)Object.hasOwnProperty.call(S,C)&&(S[C]=b(S[C],P+1))}return S}e.revive=b}),define(ae[25],ce([0,1,7,5,12]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var T;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeManagedRemoteResource="vscode-managed-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.vscodeChatSesssion="vscode-chat-editor",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(T||(e.Schemas=T={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${T.vscodeRemoteResource}`}set(P,C,v){this._hosts[P]=C,this._ports[P]=v}setConnectionToken(P,C){this._connectionTokens[P]=C}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)try{return this._delegate(P)}catch(a){return R.onUnexpectedError(a),P}const C=P.authority;let v=this._hosts[C];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const d=this._ports[C],g=this._connectionTokens[C];let w=`path=${encodeURIComponent(P.path)}`;return typeof g=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),L.URI.from({scheme:N.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${v}:${d}`,path:this._remoteResourcesPath,query:w})}}e.RemoteAuthorities=new _,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class D{asBrowserUri(P){const C=this.toUri(P,ne);return this.uriToBrowserUri(C)}uriToBrowserUri(P){return P.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===T.file&&(N.isNative||N.isWebWorker&&N.globals.origin===`${T.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?P.with({scheme:T.vscodeFileResource,authority:P.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(P){const C=this.toUri(P,ne);return this.uriToFileUri(C)}uriToFileUri(P){return P.scheme===T.vscodeFileResource?P.with({scheme:T.file,authority:P.authority!==D.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(P,C){return L.URI.isUri(P)?P:L.URI.parse(C.toUrl(P))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D;var b;(function(S){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(P.get("3"));const C="vscode-coi";function v(g){let w;typeof g=="string"?w=new URL(g).searchParams:g instanceof URL?w=g.searchParams:L.URI.isUri(g)&&(w=new URL(g.toString(!0)).searchParams);const a=w?.get(C);if(a)return P.get(a)}S.getHeadersFromQuery=v;function d(g,w,a){if(!globalThis.crossOriginIsolated)return;const u=w&&a?"3":a?"2":"1";g instanceof URLSearchParams?g.set(C,u):g[C]=u}S.addSearchParam=d})(b||(e.COI=b={}))}),define(ae[22],ce([0,1,47,25,15,5,27,12]),function(ne,e,R,N,L,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(d){return(0,D.uriToFsPath)(d,!0)}e.originalFSPath=b;class S{constructor(g){this._ignorePathCasing=g}compare(g,w,a=!1){return g===w?0:(0,_.compare)(this.getComparisonKey(g,a),this.getComparisonKey(w,a))}isEqual(g,w,a=!1){return g===w?!0:!g||!w?!1:this.getComparisonKey(g,a)===this.getComparisonKey(w,a)}getComparisonKey(g,w=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,w,a=!1){if(g.scheme===w.scheme){if(g.scheme===N.Schemas.file)return R.isEqualOrParent(b(g),b(w),this._ignorePathCasing(g))&&g.query===w.query&&(a||g.fragment===w.fragment);if((0,e.isEqualAuthority)(g.authority,w.authority))return R.isEqualOrParent(g.path,w.path,this._ignorePathCasing(g),"/")&&g.query===w.query&&(a||g.fragment===w.fragment)}return!1}joinPath(g,...w){return D.URI.joinPath(g,...w)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return L.posix.basename(g.path)}extname(g){return L.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let w;return g.scheme===N.Schemas.file?w=D.URI.file(L.dirname(b(g))).path:(w=L.posix.dirname(g.path),g.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),w="/")),g.with({path:w})}normalizePath(g){if(!g.path.length)return g;let w;return g.scheme===N.Schemas.file?w=D.URI.file(L.normalize(b(g))).path:w=L.posix.normalize(g.path),g.with({path:w})}relativePath(g,w){if(g.scheme!==w.scheme||!(0,e.isEqualAuthority)(g.authority,w.authority))return;if(g.scheme===N.Schemas.file){const h=L.relative(b(g),b(w));return T.isWindows?R.toSlashes(h):h}let a=g.path||"/";const u=w.path||"/";if(this._ignorePathCasing(g)){let h=0;for(const E=Math.min(a.length,u.length);h<E&&!(a.charCodeAt(h)!==u.charCodeAt(h)&&a.charAt(h).toLowerCase()!==u.charAt(h).toLowerCase());h++);a=u.substr(0,h)+a.substr(h)}return L.posix.relative(a,u)}resolvePath(g,w){if(g.scheme===N.Schemas.file){const a=D.URI.file(L.resolve(b(g),w));return g.with({authority:a.authority,path:a.path})}return w=R.toPosixPath(w),g.with({path:L.posix.resolve(g.path,w)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,w){return g===w||g!==void 0&&w!==void 0&&(0,_.equalsIgnoreCase)(g,w)}hasTrailingPathSeparator(g,w=L.sep){if(g.scheme===N.Schemas.file){const a=b(g);return a.length>R.getRoot(a).length&&a[a.length-1]===w}else{const a=g.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,w=L.sep){return(0,e.hasTrailingPathSeparator)(g,w)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,w=L.sep){let a=!1;if(g.scheme===N.Schemas.file){const u=b(g);a=u!==void 0&&u.length===R.getRoot(u).length&&u[u.length-1]===w}else{w="/";const u=g.path;a=u.length===1&&u.charCodeAt(u.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(g,w)?g.with({path:g.path+"/"}):g}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(d=>d.scheme===N.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new S(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(d,g){const w=[];for(let a=0;a<d.length;a++){const u=g(d[a]);d.some((h,E)=>E===a?!1:(0,e.isEqualOrParent)(u,g(h)))||w.push(d[a])}return w}e.distinctParents=P;var C;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function g(w){const a=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(E=>{const[p,k]=E.split(":");p&&k&&a.set(p,k)});const h=w.path.substring(0,w.path.indexOf(";"));return h&&a.set(d.META_DATA_MIME,h),a}d.parseMetaData=g})(C||(e.DataUri=C={}));function v(d,g,w){if(g){let a=d.path;return a&&a[0]!==L.posix.sep&&(a=L.posix.sep+a),d.with({scheme:w,authority:g,path:a})}return d.with({scheme:w})}e.toLocalResource=v}),define(ae[6],ce([0,1,26,7,3,2,22,5,125]),function(ne,e,R,N,L,T,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(O){return!!O&&typeof O.then=="function"}e.isThenable=S;function P(O){const m=new R.CancellationTokenSource,U=O(m.token),W=new Promise((J,$)=>{const H=m.token.onCancellationRequested(()=>{H.dispose(),m.dispose(),$(new N.CancellationError)});Promise.resolve(U).then(te=>{H.dispose(),m.dispose(),J(te)},te=>{H.dispose(),m.dispose(),$(te)})});return new class{cancel(){m.cancel()}then(J,$){return W.then(J,$)}catch(J){return this.then(void 0,J)}finally(J){return W.finally(J)}}}e.createCancelablePromise=P;function C(O,m,U){return new Promise((W,J)=>{const $=m.onCancellationRequested(()=>{$.dispose(),W(U)});O.then(W,J).finally(()=>$.dispose())})}e.raceCancellation=C;function v(O,m){return new Promise((U,W)=>{const J=m.onCancellationRequested(()=>{J.dispose(),W(new N.CancellationError)});O.then(U,W).finally(()=>J.dispose())})}e.raceCancellationError=v;async function d(O){let m=-1;const U=O.map((W,J)=>W.then($=>(m=J,$)));try{return await Promise.race(U)}finally{O.forEach((W,J)=>{J!==m&&W.cancel()})}}e.raceCancellablePromises=d;function g(O,m,U){let W;const J=setTimeout(()=>{W?.(void 0),U?.()},m);return Promise.race([O.finally(()=>clearTimeout(J)),new Promise($=>W=$)])}e.raceTimeout=g;function w(O){return new Promise((m,U)=>{const W=O();S(W)?W.then(m,U):m(W)})}e.asPromise=w;class a{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(m){if(this.isDisposed)throw new Error("Throttler is disposed");if(this.activePromise){if(this.queuedPromiseFactory=m,!this.queuedPromise){const U=()=>{if(this.queuedPromise=null,this.isDisposed)return;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(U,U).then(W)})}return new Promise((U,W)=>{this.queuedPromise.then(U,W)})}return this.activePromise=m(),new Promise((U,W)=>{this.activePromise.then(J=>{this.activePromise=null,U(J)},J=>{this.activePromise=null,W(J)})})}dispose(){this.isDisposed=!0}}e.Throttler=a;class u{constructor(){this.current=Promise.resolve(null)}queue(m){return this.current=this.current.then(()=>m(),()=>m())}}e.Sequencer=u;class h{constructor(){this.promiseMap=new Map}queue(m,U){const J=(this.promiseMap.get(m)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(m)===J&&this.promiseMap.delete(m)});return this.promiseMap.set(m,J),J}}e.SequencerByKey=h;const E=(O,m)=>{let U=!0;const W=setTimeout(()=>{U=!1,m()},O);return{isTriggered:()=>U,dispose:()=>{clearTimeout(W),U=!1}}},p=O=>{let m=!0;return queueMicrotask(()=>{m&&(m=!1,O())}),{isTriggered:()=>m,dispose:()=>{m=!1}}};class k{constructor(m){this.defaultDelay=m,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(m,U=this.defaultDelay){this.task=m,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((J,$)=>{this.doResolve=J,this.doReject=$}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const J=this.task;return this.task=null,J()}}));const W=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=U===b.MicrotaskDelay?p(W):E(U,W),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new N.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=k;class n{constructor(m){this.delayer=new k(m),this.throttler=new a}trigger(m,U){return this.delayer.trigger(()=>this.throttler.queue(m),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=n;class r{constructor(){this._isOpen=!1,this._promise=new Promise((m,U)=>{this._completePromise=m})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class i extends r{constructor(m){super(),this._timeout=setTimeout(()=>this.open(),m)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=i;function t(O,m){return m?new Promise((U,W)=>{const J=setTimeout(()=>{$.dispose(),U()},O),$=m.onCancellationRequested(()=>{clearTimeout(J),$.dispose(),W(new N.CancellationError)})}):P(U=>t(O,U))}e.timeout=t;function s(O,m=0){const U=setTimeout(O,m);return(0,T.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=s;function o(O){const m=[];let U=0;const W=O.length;function J(){return U<W?O[U++]():null}function $(H){H!=null&&m.push(H);const te=J();return te?te.then($):Promise.resolve(m)}return Promise.resolve(null).then($)}e.sequence=o;function c(O,m=W=>!!W,U=null){let W=0;const J=O.length,$=()=>{if(W>=J)return Promise.resolve(U);const H=O[W++];return Promise.resolve(H()).then(oe=>m(oe)?Promise.resolve(oe):$())};return $()}e.first=c;function y(O,m=W=>!!W,U=null){if(O.length===0)return Promise.resolve(U);let W=O.length;const J=()=>{W=-1;for(const $ of O)$.cancel?.()};return new Promise(($,H)=>{for(const te of O)te.then(oe=>{--W>=0&&m(oe)?(J(),$(oe)):W===0&&$(U)}).catch(oe=>{--W>=0&&(J(),H(oe))})})}e.firstParallel=y;class f{constructor(m){this._size=0,this.maxDegreeOfParalellism=m,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new L.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(m){return this._size++,new Promise((U,W)=>{this.outstandingPromises.push({factory:m,c:U,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const m=this.outstandingPromises.shift();this.runningPromises++;const U=m.factory();U.then(m.c,m.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=f;class l extends f{constructor(){super(1)}}e.Queue=l;class I{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const m=new B;return this.drainers.add(m),m.p}isDrained(){for(const[,m]of this.queues)if(m.size>0)return!1;return!0}queueFor(m,U=_.extUri){const W=U.getComparisonKey(m);let J=this.queues.get(W);return J||(J=new l,L.Event.once(J.onDrained)(()=>{J?.dispose(),this.queues.delete(W),this.onDidQueueDrain()}),this.queues.set(W,J)),J}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const m of this.drainers)m.complete();this.drainers.clear()}dispose(){for(const[,m]of this.queues)m.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=I;class A{constructor(m,U){this._token=-1,typeof m=="function"&&typeof U=="number"&&this.setIfNotSet(m,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(m,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,m()},U)}setIfNotSet(m,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,m()},U))}}e.TimeoutTimer=A;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(m,U){this.cancel(),this._token=setInterval(()=>{m()},U)}}e.IntervalTimer=F;class M{constructor(m,U){this.timeoutToken=-1,this.runner=m,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(m=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,m)}get delay(){return this.timeout}set delay(m){this.timeout=m}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=M;class V{constructor(m,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=m,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(m=this.timeout){m%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${m}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(m/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=V;class x extends M{constructor(m,U){super(m,U),this.units=[]}work(m){this.units.push(m),this.isScheduled()||this.schedule()}doRun(){const m=this.units;this.units=[],this.runner?.(m)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class q extends T.Disposable{constructor(m,U){super(),this.options=m,this.handler=U,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(m){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+m.length>this.options.maxBufferedWork)return!1}else if(this.pending+m.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const U of m)this.pendingWork.push(U);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=O=>{(0,D.setTimeout0)(()=>{if(m)return;const U=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let m=!1;return{dispose(){m||(m=!0)}}}:e.runWhenIdle=(O,m)=>{const U=requestIdleCallback(O,typeof m=="number"?{timeout:m}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(U))}}}}();class X{constructor(m){this._didRun=!1,this._executor=()=>{try{this._value=m()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=X;async function ee(O,m,U){let W;for(let J=0;J<U;J++)try{return await O()}catch($){W=$,await t(m)}throw W}e.retry=ee;class Y{hasPending(m){return this._pending?typeof m=="number"?this._pending.taskId===m:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(m,U,W){return this._pending={taskId:m,cancel:()=>W?.(),promise:U},U.then(()=>this.donePending(m),()=>this.donePending(m)),U}donePending(m){this._pending&&m===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const m=this._next;this._next=void 0,m.run().then(m.promiseResolve,m.promiseReject)}}setNext(m){if(this._next)this._next.run=m;else{let U,W;const J=new Promise(($,H)=>{U=$,W=H});this._next={run:m,promise:J,promiseResolve:U,promiseReject:W}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=Y;class Z{constructor(m,U=()=>Date.now()){this.interval=m,this.nowFn=U,this.lastIncrementTime=0,this.value=0}increment(){const m=this.nowFn();return m-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=m,this.value=0),this.value++,this.value}}e.IntervalCounter=Z;var j;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(j||(j={}));class B{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((m,U)=>{this.completeCallback=m,this.errorCallback=U})}complete(m){return new Promise(U=>{this.completeCallback(m),this.outcome={outcome:0,value:m},U()})}error(m){return new Promise(U=>{this.errorCallback(m),this.outcome={outcome:1,value:m},U()})}cancel(){return this.error(new N.CancellationError)}}e.DeferredPromise=B;var z;(function(O){async function m(W){let J;const $=await Promise.all(W.map(H=>H.then(te=>te,te=>{J||(J=te)})));if(typeof J<"u")throw J;return $}O.settled=m;function U(W){return new Promise(async(J,$)=>{try{await W(J,$)}catch(H){$(H)}})}O.withAsyncBody=U})(z||(e.Promises=z={}));var ie;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(ie||(ie={}));class re{static fromArray(m){return new re(U=>{U.emitMany(m)})}static fromPromise(m){return new re(async U=>{U.emitMany(await m)})}static fromPromises(m){return new re(async U=>{await Promise.all(m.map(async W=>U.emitOne(await W)))})}static merge(m){return new re(async U=>{await Promise.all(m.map(async W=>{for await(const J of W)U.emitOne(J)}))})}constructor(m){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const U={emitOne:W=>this.emitOne(W),emitMany:W=>this.emitMany(W),reject:W=>this.reject(W)};try{await Promise.resolve(m(U)),this.resolve()}catch(W){this.reject(W)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let m=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(m<this._results.length)return{done:!1,value:this._results[m++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(m,U){return new re(async W=>{for await(const J of m)W.emitOne(U(J))})}map(m){return re.map(this,m)}static filter(m,U){return new re(async W=>{for await(const J of m)U(J)&&W.emitOne(J)})}filter(m){return re.filter(this,m)}static coalesce(m){return re.filter(m,U=>!!U)}coalesce(){return re.coalesce(this)}static async toPromise(m){const U=[];for await(const W of m)U.push(W);return U}toPromise(){return re.toPromise(this)}emitOne(m){this._state===0&&(this._results.push(m),this._onStateChanged.fire())}emitMany(m){this._state===0&&(this._results=this._results.concat(m),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(m){this._state===0&&(this._state=2,this._error=m,this._onStateChanged.fire())}}e.AsyncIterableObject=re,re.EMPTY=re.fromArray([]);class K extends re{constructor(m,U){super(U),this._source=m}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=K;function Q(O){const m=new R.CancellationTokenSource,U=O(m.token);return new K(m,async W=>{const J=m.token.onCancellationRequested(()=>{J.dispose(),m.dispose(),W.reject(new N.CancellationError)});try{for await(const $ of U){if(m.token.isCancellationRequested)return;W.emitOne($)}J.dispose(),m.dispose()}catch($){J.dispose(),m.dispose(),W.reject($)}})}e.createCancelableAsyncIterable=Q}),define(ae[90],ce([0,1,21,6,47,35,15,5,27]),function(ne,e,R,N,L,T,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",C="[^/\\\\]",v=/\//g;function d(Z,j){switch(Z){case 0:return"";case 1:return`${C}*?`;default:return`(?:${P}|${C}+${P}${j?`|${P}${C}+`:""})*?`}}function g(Z,j){if(!Z)return[];const B=[];let z=!1,ie=!1,re="";for(const K of Z){switch(K){case j:if(!z&&!ie){B.push(re),re="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}re+=K}return re&&B.push(re),B}e.splitGlobAware=g;function w(Z){if(!Z)return"";let j="";const B=g(Z,e.GLOB_SPLIT);if(B.every(z=>z===e.GLOBSTAR))j=".*";else{let z=!1;B.forEach((ie,re)=>{if(ie===e.GLOBSTAR){if(z)return;j+=d(2,re===B.length-1)}else{let K=!1,Q="",O=!1,m="";for(const U of ie){if(U!=="}"&&K){Q+=U;continue}if(O&&(U!=="]"||!m)){let W;U==="-"?W=U:(U==="^"||U==="!")&&!m?W="^":U===e.GLOB_SPLIT?W="":W=(0,b.escapeRegExpCharacters)(U),m+=W;continue}switch(U){case"{":K=!0;continue;case"[":O=!0;continue;case"}":{const J=`(?:${g(Q,",").map($=>w($)).join("|")})`;j+=J,K=!1,Q="";break}case"]":{j+="["+m+"]",O=!1,m="";break}case"?":j+=C;continue;case"*":j+=d(1);continue;default:j+=(0,b.escapeRegExpCharacters)(U)}}re<B.length-1&&(B[re+1]!==e.GLOBSTAR||re+2<B.length)&&(j+=P)}z=ie===e.GLOBSTAR})}return j}const a=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new T.LRUCache(1e4),r=function(){return!1},i=function(){return null};function t(Z,j){if(!Z)return i;let B;typeof Z!="string"?B=Z.pattern:B=Z,B=B.trim();const z=`${B}_${!!j.trimForExclusions}`;let ie=n.get(z);if(ie)return s(ie,Z);let re;return a.test(B)?ie=c(B.substr(4),B):(re=u.exec(o(B,j)))?ie=y(re[1],B):(j.trimForExclusions?E:h).test(B)?ie=f(B,j):(re=p.exec(o(B,j)))?ie=l(re[1].substr(1),B,!0):(re=k.exec(o(B,j)))?ie=l(re[1],B,!1):ie=I(B),n.set(z,ie),s(ie,Z)}function s(Z,j){if(typeof j=="string")return Z;const B=function(z,ie){return(0,L.isEqualOrParent)(z,j.base,!D.isLinux)?Z((0,b.ltrim)(z.substr(j.base.length),_.sep),ie):null};return B.allBasenames=Z.allBasenames,B.allPaths=Z.allPaths,B.basenames=Z.basenames,B.patterns=Z.patterns,B}function o(Z,j){return j.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function c(Z,j){return function(B,z){return typeof B=="string"&&B.endsWith(Z)?j:null}}function y(Z,j){const B=`/${Z}`,z=`\\${Z}`,ie=function(K,Q){return typeof K!="string"?null:Q?Q===Z?j:null:K===Z||K.endsWith(B)||K.endsWith(z)?j:null},re=[Z];return ie.basenames=re,ie.patterns=[j],ie.allBasenames=re,ie}function f(Z,j){const B=ee(Z.slice(1,-1).split(",").map(Q=>t(Q,j)).filter(Q=>Q!==i),Z),z=B.length;if(!z)return i;if(z===1)return B[0];const ie=function(Q,O){for(let m=0,U=B.length;m<U;m++)if(B[m](Q,O))return Z;return null},re=B.find(Q=>!!Q.allBasenames);re&&(ie.allBasenames=re.allBasenames);const K=B.reduce((Q,O)=>O.allPaths?Q.concat(O.allPaths):Q,[]);return K.length&&(ie.allPaths=K),ie}function l(Z,j,B){const z=_.sep===_.posix.sep,ie=z?Z:Z.replace(v,_.sep),re=_.sep+ie,K=_.posix.sep+Z;let Q;return B?Q=function(O,m){return typeof O=="string"&&(O===ie||O.endsWith(re)||!z&&(O===Z||O.endsWith(K)))?j:null}:Q=function(O,m){return typeof O=="string"&&(O===ie||!z&&O===Z)?j:null},Q.allPaths=[(B?"*/":"./")+Z],Q}function I(Z){try{const j=new RegExp(`^${w(Z)}$`);return function(B){return j.lastIndex=0,typeof B=="string"&&j.test(B)?Z:null}}catch{return i}}function A(Z,j,B){return!Z||typeof j!="string"?!1:F(Z)(j,void 0,B)}e.match=A;function F(Z,j={}){if(!Z)return r;if(typeof Z=="string"||M(Z)){const B=t(Z,j);if(B===i)return r;const z=function(ie,re){return!!B(ie,re)};return B.allBasenames&&(z.allBasenames=B.allBasenames),B.allPaths&&(z.allPaths=B.allPaths),z}return q(Z,j)}e.parse=F;function M(Z){const j=Z;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=M;function V(Z){return Z.allBasenames||[]}e.getBasenameTerms=V;function x(Z){return Z.allPaths||[]}e.getPathTerms=x;function q(Z,j){const B=ee(Object.getOwnPropertyNames(Z).map(Q=>X(Q,Z[Q],j)).filter(Q=>Q!==i)),z=B.length;if(!z)return i;if(!B.some(Q=>!!Q.requiresSiblings)){if(z===1)return B[0];const Q=function(U,W){let J;for(let $=0,H=B.length;$<H;$++){const te=B[$](U,W);if(typeof te=="string")return te;(0,N.isThenable)(te)&&(J||(J=[]),J.push(te))}return J?(async()=>{for(const $ of J){const H=await $;if(typeof H=="string")return H}return null})():null},O=B.find(U=>!!U.allBasenames);O&&(Q.allBasenames=O.allBasenames);const m=B.reduce((U,W)=>W.allPaths?U.concat(W.allPaths):U,[]);return m.length&&(Q.allPaths=m),Q}const ie=function(Q,O,m){let U,W;for(let J=0,$=B.length;J<$;J++){const H=B[J];H.requiresSiblings&&m&&(O||(O=(0,_.basename)(Q)),U||(U=O.substr(0,O.length-(0,_.extname)(Q).length)));const te=H(Q,O,U,m);if(typeof te=="string")return te;(0,N.isThenable)(te)&&(W||(W=[]),W.push(te))}return W?(async()=>{for(const J of W){const $=await J;if(typeof $=="string")return $}return null})():null},re=B.find(Q=>!!Q.allBasenames);re&&(ie.allBasenames=re.allBasenames);const K=B.reduce((Q,O)=>O.allPaths?Q.concat(O.allPaths):Q,[]);return K.length&&(ie.allPaths=K),ie}function X(Z,j,B){if(j===!1)return i;const z=t(Z,B);if(z===i)return i;if(typeof j=="boolean")return z;if(j){const ie=j.when;if(typeof ie=="string"){const re=(K,Q,O,m)=>{if(!m||!z(K,Q))return null;const U=ie.replace("$(basename)",()=>O),W=m(U);return(0,N.isThenable)(W)?W.then(J=>J?Z:null):W?Z:null};return re.requiresSiblings=!0,re}}return z}function ee(Z,j){const B=Z.filter(Q=>!!Q.basenames);if(B.length<2)return Z;const z=B.reduce((Q,O)=>{const m=O.basenames;return m?Q.concat(m):Q},[]);let ie;if(j){ie=[];for(let Q=0,O=z.length;Q<O;Q++)ie.push(j)}else ie=B.reduce((Q,O)=>{const m=O.patterns;return m?Q.concat(m):Q},[]);const re=function(Q,O){if(typeof Q!="string")return null;if(!O){let U;for(U=Q.length;U>0;U--){const W=Q.charCodeAt(U-1);if(W===47||W===92)break}O=Q.substr(U)}const m=z.indexOf(O);return m!==-1?ie[m]:null};re.basenames=z,re.patterns=ie,re.allBasenames=z;const K=Z.filter(Q=>!Q.basenames);return K.push(re),K}function Y(Z,j){return(0,R.equals)(Z,j,(B,z)=>typeof B=="string"&&typeof z=="string"?B===z:typeof B!="string"&&typeof z!="string"?B.base===z.base&&B.pattern===z.pattern:!1)}e.patternsEquals=Y}),define(ae[91],ce([0,1,16,12]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(C){return C.toJSON()}class T{constructor(v){this._uriTransformer=v}transformIncoming(v){const d=this._uriTransformer.transformIncoming(v);return d===v?v:L(N.URI.from(d))}transformOutgoing(v){const d=this._uriTransformer.transformOutgoing(v);return d===v?v:L(N.URI.from(d))}transformOutgoingURI(v){const d=this._uriTransformer.transformOutgoing(v);return d===v?v:N.URI.from(d)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function _(C,v,d){if(!C||d>200)return null;if(typeof C=="object"){if(C instanceof N.URI)return v.transformOutgoing(C);for(const g in C)if(Object.hasOwnProperty.call(C,g)){const w=_(C[g],v,d+1);w!==null&&(C[g]=w)}}return null}function D(C,v){const d=_(C,v,0);return d===null?C:d}e.transformOutgoingURIs=D;function b(C,v,d,g){if(!C||g>200)return null;if(typeof C=="object"){if(C.$mid===1)return d?N.URI.revive(v.transformIncoming(C)):v.transformIncoming(C);if(C instanceof R.VSBuffer)return null;for(const w in C)if(Object.hasOwnProperty.call(C,w)){const a=b(C[w],v,d,g+1);a!==null&&(C[w]=a)}}return null}function S(C,v){const d=b(C,v,!1,0);return d===null?C:d}e.transformIncomingURIs=S;function P(C,v){const d=b(C,v,!0,0);return d===null?C:d}e.transformAndReviveIncomingURIs=P}),define(ae[30],ce([0,1,51,36,261,6,47,86,15,5,22,12]),function(ne,e,R,N,L,T,_,D,b,S,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(q){q[q.UNLINK=0]="UNLINK",q[q.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function d(q,X=v.UNLINK,ee){if((0,_.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");return X===v.UNLINK?w(q):g(q,ee)}async function g(q,X=(0,_.randomPath)((0,N.tmpdir)())){try{try{await R.promises.rename(q,X)}catch(ee){return ee.code==="ENOENT"?void 0:w(q)}w(X).catch(ee=>{})}catch(ee){if(ee.code!=="ENOENT")throw ee}}async function w(q){return(0,L.promisify)(R.rm)(q,{recursive:!0,force:!0,maxRetries:3})}function a(q){if((0,_.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=a;async function u(q,X){return p(await(X?h(q):(0,L.promisify)(R.readdir)(q)))}async function h(q){try{return await(0,L.promisify)(R.readdir)(q,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const X=[],ee=await u(q);for(const Y of ee){let Z=!1,j=!1,B=!1;try{const z=await e.Promises.lstat((0,b.join)(q,Y));Z=z.isFile(),j=z.isDirectory(),B=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}X.push({name:Y,isFile:()=>Z,isDirectory:()=>j,isSymbolicLink:()=>B})}return X}function E(q){return p(R.readdirSync(q))}e.readdirSync=E;function p(q){return q.map(X=>typeof X=="string"?S.isMacintosh?(0,D.normalizeNFC)(X):X:(X.name=S.isMacintosh?(0,D.normalizeNFC)(X.name):X.name,X))}async function k(q){const X=await u(q),ee=[];for(const Y of X)await r.existsDirectory((0,b.join)(q,Y))&&ee.push(Y);return ee}function n(q,X=1e3){return new Promise(ee=>{let Y=!1;const Z=setInterval(()=>{Y||(Y=!0,R.access(q,j=>{Y=!1,j&&(clearInterval(Z),ee(void 0))}))},X)})}e.whenDeleted=n;var r;(function(q){async function X(Z){let j;try{if(j=await e.Promises.lstat(Z),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(S.isWindows&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw z}throw B}}q.stat=X;async function ee(Z){try{const{stat:j,symbolicLink:B}=await q.stat(Z);return j.isFile()&&B?.dangling!==!0}catch{}return!1}q.existsFile=ee;async function Y(Z){try{const{stat:j,symbolicLink:B}=await q.stat(Z);return j.isDirectory()&&B?.dangling!==!0}catch{}return!1}q.existsDirectory=Y})(r||(e.SymlinkSupport=r={}));const i=new T.ResourceQueue;function t(q,X,ee){return i.queueFor(C.URI.file(q),P.extUriBiasedIgnorePathCase).queue(()=>{const Y=f(ee);return new Promise((Z,j)=>c(q,X,Y,B=>B?j(B):Z()))})}let s=!0;function o(q){s=q}e.configureFlushOnWrite=o;function c(q,X,ee,Y){if(!s)return R.writeFile(q,X,{mode:ee.mode,flag:ee.flag},Y);R.open(q,ee.flag,ee.mode,(Z,j)=>{if(Z)return Y(Z);R.writeFile(j,X,B=>{if(B)return R.close(j,()=>Y(B));R.fdatasync(j,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),o(!1)),R.close(j,ie=>Y(ie))))})})}function y(q,X,ee){const Y=f(ee);if(!s)return R.writeFileSync(q,X,{mode:Y.mode,flag:Y.flag});const Z=R.openSync(q,Y.flag,Y.mode);try{R.writeFileSync(Z,X);try{R.fdatasyncSync(Z)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),o(!1)}}finally{R.closeSync(Z)}}e.writeFileSync=y;function f(q){return q?{mode:typeof q.mode=="number"?q.mode:438,flag:typeof q.flag=="string"?q.flag:"w"}:{mode:438,flag:"w"}}async function l(q,X){if(q!==X)try{await e.Promises.rename(q,X)}catch(ee){if(q.toLowerCase()!==X.toLowerCase()&&ee.code==="EXDEV"||q.endsWith("."))await I(q,X,{preserveSymlinks:!1}),await d(q,v.MOVE);else throw ee}}async function I(q,X,ee){return F(q,X,{root:{source:q,target:X},options:ee,handledSourcePaths:new Set})}const A=511;async function F(q,X,ee){if(ee.handledSourcePaths.has(q))return;ee.handledSourcePaths.add(q);const{stat:Y,symbolicLink:Z}=await r.stat(q);if(Z){if(ee.options.preserveSymlinks)try{return await x(q,X,ee)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(Z.dangling)return}return Y.isDirectory()?M(q,X,Y.mode&A,ee):V(q,X,Y.mode&A)}async function M(q,X,ee,Y){await e.Promises.mkdir(X,{recursive:!0,mode:ee});const Z=await u(q);for(const j of Z)await F((0,b.join)(q,j),(0,b.join)(X,j),Y)}async function V(q,X,ee){await e.Promises.copyFile(q,X),await e.Promises.chmod(X,ee)}async function x(q,X,ee){let Y=await e.Promises.readlink(q);(0,_.isEqualOrParent)(Y,ee.root.source,!S.isLinux)&&(Y=(0,b.join)(ee.root.target,Y.substr(ee.root.source.length+1))),await e.Promises.symlink(Y,X)}e.Promises=new class{get access(){return(0,L.promisify)(R.access)}get stat(){return(0,L.promisify)(R.stat)}get lstat(){return(0,L.promisify)(R.lstat)}get utimes(){return(0,L.promisify)(R.utimes)}get read(){return(q,X,ee,Y,Z)=>new Promise((j,B)=>{R.read(q,X,ee,Y,Z,(z,ie,re)=>z?B(z):j({bytesRead:ie,buffer:re}))})}get readFile(){return(0,L.promisify)(R.readFile)}get write(){return(q,X,ee,Y,Z)=>new Promise((j,B)=>{R.write(q,X,ee,Y,Z,(z,ie,re)=>z?B(z):j({bytesWritten:ie,buffer:re}))})}get appendFile(){return(0,L.promisify)(R.appendFile)}get fdatasync(){return(0,L.promisify)(R.fdatasync)}get truncate(){return(0,L.promisify)(R.truncate)}get rename(){return(0,L.promisify)(R.rename)}get copyFile(){return(0,L.promisify)(R.copyFile)}get open(){return(0,L.promisify)(R.open)}get close(){return(0,L.promisify)(R.close)}get symlink(){return(0,L.promisify)(R.symlink)}get readlink(){return(0,L.promisify)(R.readlink)}get chmod(){return(0,L.promisify)(R.chmod)}get mkdir(){return(0,L.promisify)(R.mkdir)}get unlink(){return(0,L.promisify)(R.unlink)}get rmdir(){return(0,L.promisify)(R.rmdir)}get realpath(){return(0,L.promisify)(R.realpath)}async exists(q){try{return await e.Promises.access(q),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return k}get writeFile(){return t}get rm(){return d}get move(){return l}get copy(){return I}}}),define(ae[137],ce([0,1,51,15,5,27,30]),function(ne,e,R,N,L,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function D(v){if(L.isLinux)return v;const d=(0,N.dirname)(v);if(v===d)return v;const g=((0,N.basename)(v)||v).toLowerCase();try{const a=(0,_.readdirSync)(d).filter(u=>u.toLowerCase()===g);if(a.length===1){const u=D(d);if(u)return(0,N.join)(u,a[0])}else if(a.length>1){const u=a.indexOf(g);if(u>=0){const h=D(d);if(h)return(0,N.join)(h,a[u])}}}catch{}return null}e.realcaseSync=D;async function b(v){if(L.isLinux)return v;const d=(0,N.dirname)(v);if(v===d)return v;const g=((0,N.basename)(v)||v).toLowerCase();try{const a=(await _.Promises.readdir(d)).filter(u=>u.toLowerCase()===g);if(a.length===1){const u=await b(d);if(u)return(0,N.join)(u,a[0])}else if(a.length>1){const u=a.indexOf(g);if(u>=0){const h=await b(d);if(h)return(0,N.join)(h,a[u])}}}catch{}return null}e.realcase=b;async function S(v){try{return await _.Promises.realpath(v)}catch{const g=C(v);return await _.Promises.access(g,R.constants.R_OK),g}}e.realpath=S;function P(v){try{return R.realpathSync(v)}catch{const g=C(v);return R.accessSync(g,R.constants.R_OK),g}}e.realpathSync=P;function C(v){return(0,T.rtrim)((0,N.normalize)(v),N.sep)}}),define(ae[138],ce([0,1,15,5,37,89,10,30]),function(ne,e,R,N,L,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function b(C=L.env){return C.comspec||"cmd.exe"}e.getWindowsShell=b;function S(C){let v=[],d=!1;const g=function(w){if(d){v.push(w);return}(!C.send(w,u=>{if(u&&console.error(u),d=!1,v.length>0){const h=v.slice(0);v=[],h.forEach(E=>g(E))}})||N.isWindows)&&(d=!0)};return{send:g}}e.createQueuedSender=S;var P;(function(C){async function v(d,g,w){if(R.isAbsolute(d))return d;if(g===void 0&&(g=L.cwd()),R.dirname(d)!=="."||(w===void 0&&_.isString(L.env.PATH)&&(w=L.env.PATH.split(R.delimiter)),w===void 0||w.length===0))return R.join(g,d);async function u(h){if(await D.Promises.exists(h)){let E;try{E=await D.Promises.stat(h)}catch(p){p.message.startsWith("EACCES")&&(E=await D.Promises.lstat(h))}return E?!E.isDirectory():!1}return!1}for(const h of w){let E;if(R.isAbsolute(h)?E=R.join(h,d):E=R.join(g,h,d),await u(E))return E;let p=E+".com";if(await u(p)||(p=E+".exe",await u(p)))return p}return R.join(g,d)}C.findExecutable=v})(P||(e.win32=P={}))}),define(ae[139],ce([0,1,65,25]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(_){return new Promise((D,b)=>{let S;const P=new Map;function C(d,g,w,a,u){const h=P.get(g);if(d===_||h){const E={name:v(w),cmd:w,pid:d,ppid:g,load:a,mem:u};P.set(d,E),d===_&&(S=E),h&&(h.children||(h.children=[]),h.children.push(E),h.children.length>1&&(h.children=h.children.sort((p,k)=>p.pid-k.pid)))}}function v(d){const g=/--utility-sub-type=network/i,w=/--ms-enable-electron-run-as-node/i,a=/--crashes-directory/i,u=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,E=/--type=([a-zA-Z-]+)/;if(a.exec(d))return"electron-crash-reporter";if(u.exec(d))return"winpty-agent";if(h.exec(d))return"conpty-agent";let p=E.exec(d);if(p&&p.length===2)return p[1]==="renderer"?"window":p[1]==="utility"?g.exec(d)?"utility-network-service":"utility-process":p[1]==="extensionHost"?"extension-host":p[1];const k=/[a-zA-Z-]+\.js/g;let n="";do p=k.exec(d),p&&(n+=p+" ");while(p);return n&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${n})`:w.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,w)=>{ne(["@vscode/windows-process-tree"],g,w)}).then(g=>{g.getProcessList(_,w=>{if(!w){b(new Error(`Root process ${_} not found`));return}g.getProcessCpuUsage(w,a=>{const u=new Map;a.forEach(h=>{const E=d(h.commandLine||"");u.set(h.pid,{name:v(E),cmd:E,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),S=u.get(_),S?(u.forEach(h=>{const E=u.get(h.ppid);E&&(E.children||(E.children=[]),E.children.push(h))}),u.forEach(h=>{h.children&&(h.children=h.children.sort((E,p)=>E.pid-p.pid))}),D(S)):b(new Error(`Root process ${_} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let d=function(){let g=[S];const w=[];for(;g.length;){const u=g.shift();u&&(w.push(u.pid),u.children&&(g=g.concat(u.children)))}let a=JSON.stringify(N.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);a+=" "+w.join(" "),(0,R.exec)(a,{},(u,h,E)=>{if(u||E)b(u||new Error(E.toString()));else{const p=h.toString().split(`
`);for(let k=0;k<w.length;k++){const n=P.get(w[k]);n.load=parseFloat(p[k])}if(!S){b(new Error(`Root process ${_} not found`));return}D(S)}})};(0,R.exec)("which ps",{},(g,w,a)=>{if(g||a)if(process.platform!=="linux")b(g||new Error(a.toString()));else{const u=JSON.stringify(N.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,R.exec)(u,{},(h,E,p)=>{h||p?b(h||new Error(p.toString())):(T(E,C),d())})}else{const u=w.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${u} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(E,p,k)=>{E||k&&!k.includes("screen size is bogus")?b(E||new Error(k.toString())):(T(p,C),process.platform==="linux"?d():S?D(S):b(new Error(`Root process ${_} not found`)))})}})}})}e.listProcesses=L;function T(_,D){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=_.toString().split(`
`);for(const P of S){const C=b.exec(P.trim());C&&C.length===6&&D(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}});var pe=this&&this.__decorate||function(ne,e,R,N){var L=arguments.length,T=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,R):N,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(ne,e,R,N);else for(var D=ne.length-1;D>=0;D--)(_=ne[D])&&(T=(L<3?_(T):L>3?_(e,R,T):_(e,R))||T);return L>3&&T&&Object.defineProperty(e,R,T),T};define(ae[43],ce([0,1,21,6,16,26,59,7,3,2,64,27,10]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(d||(d={}));function g(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(w||(w={}));function a(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(u||(u={}));function h(j){let B=0;for(let z=0;;z+=7){const ie=j.read(1);if(B|=(ie.buffer[0]&127)<<z,!(ie.buffer[0]&128))return B}}const E=i(0);function p(j,B){if(B===0){j.write(E);return}let z=0;for(let re=B;re!==0;re=re>>>7)z++;const ie=L.VSBuffer.alloc(z);for(let re=0;B!==0;re++)ie.buffer[re]=B&127,B=B>>>7,B>0&&(ie.buffer[re]|=128);j.write(ie)}class k{constructor(B){this.buffer=B,this.pos=0}read(B){const z=this.buffer.slice(this.pos,this.pos+B);return this.pos+=z.byteLength,z}}e.BufferReader=k;class n{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(B){this.buffers.push(B)}}e.BufferWriter=n;var r;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(r||(r={}));function i(j){const B=L.VSBuffer.alloc(1);return B.writeUInt8(j,0),B}const t={Undefined:i(r.Undefined),String:i(r.String),Buffer:i(r.Buffer),VSBuffer:i(r.VSBuffer),Array:i(r.Array),Object:i(r.Object),Uint:i(r.Int)},s=typeof Buffer<"u";function o(j,B){if(typeof B>"u")j.write(t.Undefined);else if(typeof B=="string"){const z=L.VSBuffer.fromString(B);j.write(t.String),p(j,z.byteLength),j.write(z)}else if(s&&Buffer.isBuffer(B)){const z=L.VSBuffer.wrap(B);j.write(t.Buffer),p(j,z.byteLength),j.write(z)}else if(B instanceof L.VSBuffer)j.write(t.VSBuffer),p(j,B.byteLength),j.write(B);else if(Array.isArray(B)){j.write(t.Array),p(j,B.length);for(const z of B)o(j,z)}else if(typeof B=="number"&&(B|0)===B)j.write(t.Uint),p(j,B);else{const z=L.VSBuffer.fromString(JSON.stringify(B));j.write(t.Object),p(j,z.byteLength),j.write(z)}}e.serialize=o;function c(j){switch(j.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return j.read(h(j)).toString();case r.Buffer:return j.read(h(j)).buffer;case r.VSBuffer:return j.read(h(j));case r.Array:{const z=h(j),ie=[];for(let re=0;re<z;re++)ie.push(c(j));return ie}case r.Object:return JSON.parse(j.read(h(j)).toString());case r.Int:return h(j)}}e.deserialize=c;class y{constructor(B,z,ie=null,re=1e3){this.protocol=B,this.ctx=z,this.logger=ie,this.timeoutDelay=re,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(B,z){this.channels.set(B,z),setTimeout(()=>this.flushPendingRequests(B),0)}sendResponse(B){switch(B.type){case 200:{const z=this.send([B.type]);this.logger?.logOutgoing(z,0,1,a(B.type));return}case 201:case 202:case 204:case 203:{const z=this.send([B.type,B.id],B.data);this.logger?.logOutgoing(z,B.id,1,a(B.type),B.data);return}}}send(B,z=void 0){const ie=new n;return o(ie,B),o(ie,z),this.sendBuffer(ie.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onRawMessage(B){const z=new k(B),ie=c(z),re=c(z),K=ie[0];switch(K){case 100:return this.logger?.logIncoming(B.byteLength,ie[1],1,`${g(K)}: ${ie[2]}.${ie[3]}`,re),this.onPromise({type:K,id:ie[1],channelName:ie[2],name:ie[3],arg:re});case 102:return this.logger?.logIncoming(B.byteLength,ie[1],1,`${g(K)}: ${ie[2]}.${ie[3]}`,re),this.onEventListen({type:K,id:ie[1],channelName:ie[2],name:ie[3],arg:re});case 101:return this.logger?.logIncoming(B.byteLength,ie[1],1,`${g(K)}`),this.disposeActiveRequest({type:K,id:ie[1]});case 103:return this.logger?.logIncoming(B.byteLength,ie[1],1,`${g(K)}`),this.disposeActiveRequest({type:K,id:ie[1]})}}onPromise(B){const z=this.channels.get(B.channelName);if(!z){this.collectPendingRequest(B);return}const ie=new T.CancellationTokenSource;let re;try{re=z.call(this.ctx,B.name,B.arg,ie.token)}catch(O){re=Promise.reject(O)}const K=B.id;re.then(O=>{this.sendResponse({id:K,data:O,type:201}),this.activeRequests.delete(B.id)},O=>{O instanceof Error?this.sendResponse({id:K,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.sendResponse({id:K,data:O,type:203}),this.activeRequests.delete(B.id)});const Q=(0,S.toDisposable)(()=>ie.cancel());this.activeRequests.set(B.id,Q)}onEventListen(B){const z=this.channels.get(B.channelName);if(!z){this.collectPendingRequest(B);return}const ie=B.id,K=z.listen(this.ctx,B.name,B.arg)(Q=>this.sendResponse({id:ie,data:Q,type:204}));this.activeRequests.set(B.id,K)}disposeActiveRequest(B){const z=this.activeRequests.get(B.id);z&&(z.dispose(),this.activeRequests.delete(B.id))}collectPendingRequest(B){let z=this.pendingRequests.get(B.channelName);z||(z=[],this.pendingRequests.set(B.channelName,z));const ie=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.sendResponse({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:B,timeoutTimer:ie})}flushPendingRequests(B){const z=this.pendingRequests.get(B);if(z){for(const ie of z)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.onPromise(ie.request);break;case 102:this.onEventListen(ie.request);break}this.pendingRequests.delete(B)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=y;var f;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(f||(e.RequestInitiator=f={}));class l{constructor(B,z=null){this.protocol=B,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ie=>this.onBuffer(ie)),this.logger=z}getChannel(B){const z=this;return{call(ie,re,K){return z.isDisposed?Promise.reject(new D.CancellationError):z.requestPromise(B,ie,re,K)},listen(ie,re){return z.isDisposed?b.Event.None:z.requestEvent(B,ie,re)}}}requestPromise(B,z,ie,re=T.CancellationToken.None){const K=this.lastRequestId++,O={id:K,type:100,channelName:B,name:z,arg:ie};if(re.isCancellationRequested)return Promise.reject(new D.CancellationError);let m;return new Promise((W,J)=>{if(re.isCancellationRequested)return J(new D.CancellationError);const $=()=>{const ue=de=>{switch(de.type){case 201:this.handlers.delete(K),W(de.data);break;case 202:{this.handlers.delete(K);const ve=new Error(de.data.message);ve.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ve.name=de.data.name,J(ve);break}case 203:this.handlers.delete(K),J(de.data);break}};this.handlers.set(K,ue),this.sendRequest(O)};let H=null;this.state===u.Idle?$():(H=(0,N.createCancelablePromise)(ue=>this.whenInitialized()),H.then(()=>{H=null,$()}));const te=()=>{H?(H.cancel(),H=null):this.sendRequest({id:K,type:101}),J(new D.CancellationError)},oe=re.onCancellationRequested(te);m=(0,S.combinedDisposable)((0,S.toDisposable)(te),oe),this.activeRequests.add(m)}).finally(()=>{this.activeRequests.delete(m)})}requestEvent(B,z,ie){const re=this.lastRequestId++,Q={id:re,type:102,channelName:B,name:z,arg:ie};let O=null;const m=new b.Emitter({onWillAddFirstListener:()=>{O=(0,N.createCancelablePromise)(W=>this.whenInitialized()),O.then(()=>{O=null,this.activeRequests.add(m),this.sendRequest(Q)})},onDidRemoveLastListener:()=>{O?(O.cancel(),O=null):(this.activeRequests.delete(m),this.sendRequest({id:re,type:103}))}}),U=W=>m.fire(W.data);return this.handlers.set(re,U),m.event}sendRequest(B){switch(B.type){case 100:case 102:{const z=this.send([B.type,B.id,B.channelName,B.name],B.arg);this.logger?.logOutgoing(z,B.id,0,`${g(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const z=this.send([B.type,B.id]);this.logger?.logOutgoing(z,B.id,0,g(B.type));return}}}send(B,z=void 0){const ie=new n;return o(ie,B),o(ie,z),this.sendBuffer(ie.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onBuffer(B){const z=new k(B),ie=c(z),re=c(z),K=ie[0];switch(K){case 200:return this.logger?.logIncoming(B.byteLength,0,0,a(K)),this.onResponse({type:ie[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(B.byteLength,ie[1],0,a(K),re),this.onResponse({type:ie[0],id:ie[1],data:re})}}onResponse(B){if(B.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(B.id)?.(B)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=l,pe([_.memoize],l.prototype,"onDidInitializePromise",null);class I{get connections(){const B=[];return this._connections.forEach(z=>B.push(z)),B}constructor(B){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,B(({protocol:z,onDidClientDisconnect:ie})=>{b.Event.once(z.onMessage)(K=>{const Q=new k(K),O=c(Q),m=new y(z,O),U=new l(z);this.channels.forEach((J,$)=>m.registerChannel($,J));const W={channelServer:m,channelClient:U,ctx:O};this._connections.add(W),this._onDidAddConnection.fire(W),ie(()=>{m.dispose(),U.dispose(),this._connections.delete(W),this._onDidRemoveConnection.fire(W)})})})}getChannel(B,z){const ie=this;return{call(re,K,Q){let O;if((0,v.isFunction)(z)){const U=(0,R.getRandomElement)(ie.connections.filter(z));O=U?Promise.resolve(U):b.Event.toPromise(b.Event.filter(ie.onDidAddConnection,z))}else O=z.routeCall(ie,re,K);const m=O.then(U=>U.channelClient.getChannel(B));return F(m).call(re,K,Q)},listen(re,K){if((0,v.isFunction)(z))return ie.getMulticastEvent(B,z,re,K);const Q=z.routeEvent(ie,re,K).then(O=>O.channelClient.getChannel(B));return F(Q).listen(re,K)}}}getMulticastEvent(B,z,ie,re){const K=this;let Q=new S.DisposableStore;const O=new b.Emitter({onWillAddFirstListener:()=>{Q=new S.DisposableStore;const m=new b.EventMultiplexer,U=new Map,W=$=>{const te=$.channelClient.getChannel(B).listen(ie,re),oe=m.add(te);U.set($,oe)},J=$=>{const H=U.get($);H&&(H.dispose(),U.delete($))};K.connections.filter(z).forEach(W),b.Event.filter(K.onDidAddConnection,z)(W,void 0,Q),K.onDidRemoveConnection(J,void 0,Q),m.event(O.fire,O,Q),Q.add(m)},onDidRemoveLastListener:()=>{Q.dispose()}});return O.event}registerChannel(B,z){this.channels.set(B,z),this._connections.forEach(ie=>{ie.channelServer.registerChannel(B,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class A{constructor(B,z,ie=null){const re=new n;o(re,z),B.send(re.buffer),this.channelClient=new l(B,ie),this.channelServer=new y(B,z,ie)}getChannel(B){return this.channelClient.getChannel(B)}registerChannel(B,z){this.channelServer.registerChannel(B,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function F(j){return{call(B,z,ie){return j.then(re=>re.call(B,z,ie))},listen(B,z){const ie=new b.Relay;return j.then(re=>ie.input=re.listen(B,z)),ie.event}}}e.getDelayedChannel=F;function M(j){let B=!1;return{call(z,ie,re){return B?j.call(z,ie,re):(0,N.timeout)(0).then(()=>B=!0).then(()=>j.call(z,ie,re))},listen(z,ie){if(B)return j.listen(z,ie);const re=new b.Relay;return(0,N.timeout)(0).then(()=>B=!0).then(()=>re.input=j.listen(z,ie)),re.event}}}e.getNextTickChannel=M;class V{constructor(B){this.fn=B}routeCall(B){return this.route(B)}routeEvent(B){return this.route(B)}async route(B){for(const z of B.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await b.Event.toPromise(B.onDidAddConnection),await this.route(B)}}e.StaticRouter=V;var x;(function(j){function B(K,Q){const O=K,m=Q&&Q.disableMarshalling,U=new Map;for(const W in O)ie(W)&&U.set(W,b.Event.buffer(O[W],!0));return new class{listen(W,J,$){const H=U.get(J);if(H)return H;if(re(J)){const te=O[J];if(typeof te=="function")return te.call(O,$)}throw new Error(`Event not found: ${J}`)}call(W,J,$){const H=O[J];if(typeof H=="function"){if(!m&&Array.isArray($))for(let te=0;te<$.length;te++)$[te]=(0,P.revive)($[te]);return H.apply(O,$)}throw new Error(`Method not found: ${J}`)}}}j.fromService=B;function z(K,Q){const O=Q&&Q.disableMarshalling;return new Proxy({},{get(m,U){if(typeof U=="string")return Q?.properties?.has(U)?Q.properties.get(U):re(U)?function(W){return K.listen(U,W)}:ie(U)?K.listen(U):async function(...W){let J;Q&&!(0,v.isUndefinedOrNull)(Q.context)?J=[Q.context,...W]:J=W;const $=await K.call(U,J);return O?$:(0,P.revive)($)};throw new Error(`Property not found: ${String(U)}`)}})}j.toService=z;function ie(K){return K[0]==="o"&&K[1]==="n"&&C.isUpperAsciiLetter(K.charCodeAt(2))}function re(K){return/^onDynamic/.test(K)&&C.isUpperAsciiLetter(K.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const B=j.toString();if(B!=="[object Object]")return B}return j}function ee(j){return Array.isArray(j)?j.map(X):X(j)}function Y(j,B,z,ie,re,K,Q){Q=ee(Q);const O=q[re],m=O[ie%O.length];let U=[`%c[${j}]%c[${String(B).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${m}`];/\($/.test(K)?(U=U.concat(Q),U.push(")")):U.push(Q),console.log.apply(console,U)}class Z{constructor(B,z){this._outgoingPrefix=B,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(B,z,ie,re,K){this._totalOutgoing+=B,Y(this._outgoingPrefix,this._totalOutgoing,B,z,ie,re,K)}logIncoming(B,z,ie,re,K){this._totalIncoming+=B,Y(this._incomingPrefix,this._totalIncoming,B,z,ie,re,K)}}e.IPCLogger=Z}),define(ae[92],ce([0,1,16,3,2,43]),function(ne,e,R,N,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var _;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(_||(e.SocketDiagnosticsEventType=_={}));var D;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let o=0;function c(f,l){if(!s.has(f)){const I=String(++o);s.set(f,I)}return s.get(f)}function y(f,l,I,A){if(!t.enableDiagnostics)return;const F=c(f,l);if(A instanceof R.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const M=R.VSBuffer.alloc(A.byteLength);M.set(A),t.records.push({timestamp:Date.now(),id:F,label:l,type:I,buff:M})}else t.records.push({timestamp:Date.now(),id:F,label:l,type:I,data:A})}t.traceSocketEvent=y})(D||(e.SocketDiagnostics=D={}));var b;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let S=null;function P(){return S||(S=R.VSBuffer.alloc(0)),S}class C{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return P();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const l=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),l}if(this._chunks[0].byteLength>s){const l=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),l}const c=R.VSBuffer.alloc(s);let y=0,f=0;for(;s>0;){const l=this._chunks[f];if(l.byteLength>s){const I=l.slice(0,s);c.set(I,y),y+=s,o&&(this._chunks[f]=l.slice(s),this._totalLength-=s),s-=s}else c.set(l,y),y+=l.byteLength,o?(this._chunks.shift(),this._totalLength-=l.byteLength):f++,s-=l.byteLength}return c}}e.ChunkStream=C;var v;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(v||(v={}));function d(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class w{constructor(s,o,c,y){this.type=s,this.id=o,this.ack=c,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class a extends L.Disposable{constructor(s){super(),this._onMessage=this._register(new N.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:d(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,y=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new w(c,y,f,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=R.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:d(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(o,s.data)}_bufferAdd(s,o){const c=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,c}_bufferTake(){const s=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class h extends L.Disposable{constructor(s){super(),this._onMessage=new N.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new N.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new a(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new w(1,0,0,s))}}e.Protocol=h;class E extends T.IPCClient{static fromSocket(s,o){return new E(new h(s),o)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,o,c=null){super(s,o,c),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=E;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new N.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class k{constructor(s){this.data=s,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let s=0,o=this._first;for(;o;)o=o.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let o=0,c=this._first;for(;c;)s[o++]=c.data,c=c.next;return s}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new k(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class r{static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<r._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=r._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),o=(1+r._HISTORY_LENGTH)*1e3;let c=0;for(let y=0;y<r._HISTORY_LENGTH;y++)s-this.lastRuns[y]<=o&&c++;return 1-c/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class i{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=s.loadEstimator??r.getInstance(),this._shouldSendKeepAlive=s.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new L.DisposableStore,this._socket=s.socket,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new a(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.add(this._socket.onClose(o=>this._onSocketClose.fire(o))),s.initialChunk&&this._socketReader.acceptChunk(s.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new w(5,0,0,P());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new w(7,0,0,P());this._socketWriter.write(s)}sendResume(){const s=new w(8,0,0,P());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new L.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new a(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.add(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new w(3,0,this._incomingAckId,P());this._socketWriter.write(s);const o=this._outgoingUnackMsg.toArray();for(let c=0,y=o.length;c<y;c++)this._socketWriter.write(o[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new w(6,0,0,P())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let c=0,y=o.length;c<y;c++)this._socketWriter.write(o[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new w(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(s){const o=new w(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime,c=Date.now()-this._socketReader.lastReadTime,y=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&c>=2e4&&y>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:c});return}const f=Math.max(2e4-o,2e4-c,2e4-y,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},f)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new w(3,0,this._incomingAckId,P());this._socketWriter.write(s)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const s=new w(9,0,this._incomingAckId,P());this._socketWriter.write(s)}}e.PersistentProtocol=i}),define(ae[93],ce([0,1,65,6,16,26,136,7,3,2,31,138,89,43]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class g extends d.ChannelServer{constructor(u){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",h=>L.VSBuffer.wrap(Buffer.from(h,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=g;class w{constructor(u,h){this.modulePath=u,this.options=h,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const E=h&&h.timeout?h.timeout:6e4;this.disposeDelayer=new N.Delayer(E),this.child=null,this._client=null}getChannel(u){const h=this;return{call(E,p,k){return h.requestPromise(u,E,p,k)},listen(E,p){return h.requestEvent(u,E,p)}}}requestPromise(u,h,E,p=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(D.canceled());this.disposeDelayer.cancel();const k=this.getCachedChannel(u),n=(0,N.createCancelablePromise)(t=>k.call(h,E,t)),r=p.onCancellationRequested(()=>n.cancel()),i=(0,S.toDisposable)(()=>n.cancel());return this.activeRequests.add(i),n.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(u,h,E){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let p;const k=new b.Emitter({onWillAddFirstListener:()=>{p=this.getCachedChannel(u).listen(h,E)(k.fire,k),this.activeRequests.add(p)},onDidRemoveLastListener:()=>{this.activeRequests.delete(p),p.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return k.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],h=Object.create(null);h.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(h.env={...h.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(h.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,v.removeDangerousEnvVariables)(h.env),this.child=(0,R.fork)(this.modulePath,u,h);const E=new b.Emitter;b.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,_.isRemoteConsoleLog)(s)){(0,_.log)(s,`IPC Library: ${this.options.serverName}`);return}E.fire(L.VSBuffer.wrap(Buffer.from(s,"base64")))});const k=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,n=s=>this.child&&this.child.connected&&k.send(s.buffer.toString("base64")),r=E.event,i={send:n,onMessage:r};this._client=new d.ChannelClient(i);const t=()=>this.disposeClient();process.once("exit",t),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,o)=>{process.removeListener("exit",t),this.activeRequests.forEach(c=>(0,S.dispose)(c)),this.activeRequests.clear(),s!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+o),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:o})})}return this._client}getCachedChannel(u){let h=this.channels.get(u);return h||(h=this.client.getChannel(u),this.channels.set(u,h)),h}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=w}),define(ae[140],ce([0,1,129,16,43,3,10,21]),function(ne,e,R,N,L,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class b{constructor(v){this.port=v,this.onMessage=T.Event.fromNodeEventEmitter(this.port,"message",d=>N.VSBuffer.wrap(d.data)),v.start()}send(v){this.port.postMessage(v.buffer)}disconnect(){this.port.close()}}class S extends L.IPCServer{static getOnDidClientConnect(){(0,_.assertType)((0,R.isUtilityProcess)(process),"Electron Utility Process");const v=new T.Emitter;return process.parentPort.on("message",d=>{const g=(0,D.firstOrDefault)(d.ports);g&&v.fire(g)}),T.Event.map(v.event,d=>({protocol:new b(d),onDidClientDisconnect:T.Event.fromNodeEventEmitter(d,"close")}))}constructor(){super(S.getOnDidClientConnect())}}e.Server=S;function P(C,v,d){const g=w=>{w.data===v&&(C.removeListener("message",g),d())};C.on("message",g)}e.once=P}),define(ae[66],ce([0,1,6,3,2,64,10]),function(ne,e,R,N,L,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D||(e.StorageHint=D={}));function b(v){const d=v;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var S;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(S||(e.StorageState=S={}));class P extends L.Disposable{constructor(d,g=Object.create(null)){super(),this.database=d,this.options=g,this._onDidChangeStorage=this._register(new N.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=S.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(P.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){this._onDidChangeStorage.pause();try{d.changed?.forEach((g,w)=>this.acceptExternal(w,g)),d.deleted?.forEach(g=>this.acceptExternal(g,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(d,g){if(this.state===S.Closed)return;let w=!1;(0,_.isUndefinedOrNull)(g)?w=this.cache.delete(d):this.cache.get(d)!==g&&(this.cache.set(d,g),w=!0),w&&this._onDidChangeStorage.fire({key:d,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===S.None&&(this.state=S.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,g){const w=this.cache.get(d);return(0,_.isUndefinedOrNull)(w)?g:w}getBoolean(d,g){const w=this.get(d);return(0,_.isUndefinedOrNull)(w)?g:w==="true"}getNumber(d,g){const w=this.get(d);return(0,_.isUndefinedOrNull)(w)?g:parseInt(w,10)}getObject(d,g){const w=this.get(d);return(0,_.isUndefinedOrNull)(w)?g:(0,T.parse)(w)}async set(d,g,w=!1){if(this.state===S.Closed)return;if((0,_.isUndefinedOrNull)(g))return this.delete(d,w);const a=(0,_.isObject)(g)||Array.isArray(g)?(0,T.stringify)(g):String(g);if(this.cache.get(d)!==a)return this.cache.set(d,a),this.pendingInserts.set(d,a),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire({key:d,external:w}),this.doFlush()}async delete(d,g=!1){if(!(this.state===S.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire({key:d,external:g}),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=S.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}isInMemory(){return this.options.hint===D.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=P,P.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert?.forEach((g,w)=>this.items.set(w,g)),d.delete?.forEach(g=>this.items.delete(g))}async close(){}}e.InMemoryStorageDatabase=C}),define(ae[141],ce([11,9]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(ae[142],ce([11,9]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[143],ce([11,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[144],ce([11,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(ae[145],ce([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ae[146],ce([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[147],ce([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[148],ce([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[149],ce([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ae[150],ce([11,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ae[151],ce([11,9]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[152],ce([11,9]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(ae[153],ce([11,9]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ae[154],ce([11,9]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(ae[155],ce([11,9]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[156],ce([11,9]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ae[157],ce([11,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ae[158],ce([11,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ae[159],ce([11,9]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(ae[160],ce([11,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ae[161],ce([11,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[162],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[163],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ae[164],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ae[165],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ae[166],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ae[167],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ae[168],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ae[169],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ae[170],ce([11,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ae[171],ce([11,9]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ae[172],ce([0,1,7,144]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var L;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(L||(e.TokenType=L={}));function T(...S){switch(S.length){case 1:return(0,N.localize)(0,null,S[0]);case 2:return(0,N.localize)(1,null,S[0],S[1]);case 3:return(0,N.localize)(2,null,S[0],S[1],S[2]);default:return}}const _=(0,N.localize)(3,null),D=(0,N.localize)(4,null);class b{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,R.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(P){return this._input=P,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const C=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:C})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const C=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:C})}else this._match(126)?this._addToken(9):this._error(T("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(T("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(T("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(P){return this._isAtEnd()||this._input.charCodeAt(this._current)!==P?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(P){this._tokens.push({type:P,offset:this._start})}_error(P){const C=this._start,v=this._input.substring(this._start,this._current),d={type:19,offset:this._start,lexeme:v};this._errors.push({offset:C,lexeme:v,additionalInfo:P}),this._tokens.push(d)}_string(){this.stringRe.lastIndex=this._start;const P=this.stringRe.exec(this._input);if(P){this._current=this._start+P[0].length;const C=this._input.substring(this._start,this._current),v=b._keywords.get(C);v?this._addToken(v):this._tokens.push({type:17,lexeme:C,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(_);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let P=this._current,C=!1,v=!1;for(;;){if(P>=this._input.length){this._current=P,this._error(D);return}const g=this._input.charCodeAt(P);if(C)C=!1;else if(g===47&&!v){P++;break}else g===91?v=!0:g===92?C=!0:g===93&&(v=!1);P++}for(;P<this._input.length&&b._regexFlags.has(this._input.charCodeAt(P));)P++;this._current=P;const d=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:d,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=b,b._regexFlags=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0))),b._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(ae[173],ce([0,1,63,59,25,15,37,22,12]),function(ne,e,R,N,L,T,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class S{get appRoot(){return(0,T.dirname)(L.FileAccess.asFileUri("").fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,D.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,D.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",d)}return b.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,D.joinPath)(b.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,D.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,D.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=_.env.VSCODE_PORTABLE;return d?b.URI.file((0,T.join)(d,"argv.json")):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,T.resolve)(d):(0,T.normalize)((0,T.join)(L.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?b.URI.file((0,T.resolve)(d)):b.URI.file((0,T.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,T.resolve)(d);const g=_.env.VSCODE_EXTENSIONS;if(g)return g;const w=_.env.VSCODE_PORTABLE;return w?(0,T.join)(w,"extensions"):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(g=>/^[^:/?#]+?:\/\//.test(g)?b.URI.parse(g):b.URI.file((0,T.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?b.URI.parse(d):b.URI.file((0,T.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!_.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const g of this.args.log||[]){const w=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(g);w&&w[1]&&w[2]&&d.push([w[1],w[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,D.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=_.env.VSCODE_PORTABLE;return d?b.URI.file((0,T.join)(d,"policy.json")):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this._args}constructor(d,g,w){this._args=d,this.paths=g,this.productService=w,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=S,pe([N.memoize],S.prototype,"appRoot",null),pe([N.memoize],S.prototype,"userHome",null),pe([N.memoize],S.prototype,"userDataPath",null),pe([N.memoize],S.prototype,"appSettingsHome",null),pe([N.memoize],S.prototype,"tmpDir",null),pe([N.memoize],S.prototype,"cacheHome",null),pe([N.memoize],S.prototype,"stateResource",null),pe([N.memoize],S.prototype,"userRoamingDataHome",null),pe([N.memoize],S.prototype,"userDataSyncHome",null),pe([N.memoize],S.prototype,"sync",null),pe([N.memoize],S.prototype,"machineSettingsResource",null),pe([N.memoize],S.prototype,"workspaceStorageHome",null),pe([N.memoize],S.prototype,"localHistoryHome",null),pe([N.memoize],S.prototype,"keyboardLayoutResource",null),pe([N.memoize],S.prototype,"argvResource",null),pe([N.memoize],S.prototype,"isExtensionDevelopment",null),pe([N.memoize],S.prototype,"untitledWorkspacesHome",null),pe([N.memoize],S.prototype,"builtinExtensionsPath",null),pe([N.memoize],S.prototype,"extensionsPath",null),pe([N.memoize],S.prototype,"extensionDevelopmentLocationURI",null),pe([N.memoize],S.prototype,"extensionDevelopmentKind",null),pe([N.memoize],S.prototype,"extensionTestsLocationURI",null),pe([N.memoize],S.prototype,"debugExtensionHost",null),pe([N.memoize],S.prototype,"logLevel",null),pe([N.memoize],S.prototype,"extensionLogLevel",null),pe([N.memoize],S.prototype,"serviceMachineIdResource",null),pe([N.memoize],S.prototype,"disableTelemetry",null),pe([N.memoize],S.prototype,"disableWorkspaceTrust",null),pe([N.memoize],S.prototype,"policyFile",null);function P(v,d){return C(v["inspect-extensions"],v["inspect-brk-extensions"],5870,d,v.debugId,v.extensionEnvironment)}e.parseExtensionHostDebugPort=P;function C(v,d,g,w,a,u){const E=Number(d||v)||(w?null:g),p=E?!!d:!1;let k;if(u)try{k=JSON.parse(u)}catch{}return{port:E,break:p,debugId:a,env:k}}e.parseDebugParams=C}),function(){"use strict";function ne(e,R,N){function L(_,D){const b=T(_,D),S=[b];return e.isAbsolute(b)||S.unshift(N),e.resolve(...S)}function T(_,D){process.env.VSCODE_DEV&&(D="code-oss-dev");const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,D);const P=_["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(C,"AppData","Roaming")}break;case"darwin":S=e.join(R.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,D)}return{getUserDataPath:L}}if(typeof define=="function")define(ae[174],ce([262,36,37]),function(e,R,N){return ne(e,R,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),R=require("os");module.exports=ne(e,R,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[175],ce([0,1,36,173,174]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class T extends N.AbstractNativeEnvironmentService{constructor(S,P){super(S,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,L.getUserDataPath)(S,P.nameShort)},P)}}e.NativeEnvironmentService=T;function _(b,S){return(0,N.parseDebugParams)(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,S,b.extensionEnvironment)}e.parsePtyHostDebugPort=_;function D(b,S){return(0,N.parseDebugParams)(b["inspect-sharedprocess"],b["inspect-brk-sharedprocess"],5879,S,b.extensionEnvironment)}e.parseSharedProcessDebugPort=D}),define(ae[176],ce([0,1,10,147]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function L(_,D,b){try{T(_,D,b)}catch(S){console.error(S?.message??S)}return _}e.localizeManifest=L;function T(_,D,b){const S=(P,C,v)=>{const d=P[C];if((0,R.isString)(d)){const g=d,w=g.length;if(w>1&&g[0]==="%"&&g[w-1]==="%"){const a=g.substr(1,w-2);let u=D[a];u===void 0&&b&&(u=b[a]);const h=typeof u=="string"?u:u?.message,E=b?.[a],p=typeof E=="string"?E:E?.message;if(!h){p||console.warn(`[${_.name}]: ${(0,N.localize)(0,null,a)}`);return}if(v&&(C==="title"||C==="category")&&p&&p!==h){const k={value:h,original:p};P[C]=k}else P[C]=h}}else if((0,R.isObject)(d))for(const g in d)d.hasOwnProperty(g)&&(g==="commands"?S(d,g,!0):S(d,g,v));else if(Array.isArray(d))for(let g=0;g<d.length;g++)S(d,g,v)};for(const P in _)_.hasOwnProperty(P)&&S(_,P)}}),define(ae[177],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T){return this.channel.call("promptImportantExtensionsInstallNotification",[T])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class N{constructor(T){this.service=T}listen(T,_){throw new Error(`Event not found: ${_}`)}call(T,_,D){switch(_){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(D[0])}throw new Error(`Call not found: ${_}`)}}e.ExtensionRecommendationNotificationServiceChannel=N}),define(ae[67],ce([0,1,22,88,151,52]),function(ne,e,R,N,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function b(u){return u=u.trim(),u==="*"||_.test(u)}e.isValidVersionStr=b;function S(u){if(!b(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=u.match(_);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=S;function P(u){if(!u)return null;const h=u.majorBase,E=u.majorMustEqual,p=u.minorBase;let k=u.minorMustEqual;const n=u.patchBase;let r=u.patchMustEqual;u.hasCaret&&(h===0||(k=!1),r=!1);let i=0;if(u.preRelease){const t=D.exec(u.preRelease);if(t){const[,s,o,c]=t;i=Date.UTC(Number(s),Number(o)-1,Number(c))}}return{majorBase:h,majorMustEqual:E,minorBase:p,minorMustEqual:k,patchBase:n,patchMustEqual:r,isMinimum:u.hasGreaterEquals,notBefore:i}}e.normalizeVersion=P;function C(u,h,E){let p;typeof u=="string"?p=P(S(u)):p=u;let k;h instanceof Date?k=h.getTime():typeof h=="string"&&(k=new Date(h).getTime());let n;if(typeof E=="string"?n=P(S(E)):n=E,!p||!n)return!1;const r=p.majorBase,i=p.minorBase,t=p.patchBase;let s=n.majorBase,o=n.minorBase,c=n.patchBase;const y=n.notBefore;let f=n.majorMustEqual,l=n.minorMustEqual,I=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:i>o?!0:i<o||k&&k<y?!1:t>=c:(r===1&&s===0&&(!f||!l||!I)&&(s=1,o=0,c=0,f=!0,l=!1,I=!1),r<s?!1:r>s?!f:i<o?!1:i>o?!l:t<c?!1:t>c?!I:!(k&&k<y))}e.isValidVersion=C;function v(u,h,E,p,k){const n=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return n.push([N.default.Error,L.localize(0,null)]),n;if(typeof p.name!="string")return n.push([N.default.Error,L.localize(1,null,"name")]),n;if(typeof p.version!="string")return n.push([N.default.Error,L.localize(2,null,"version")]),n;if(!p.engines)return n.push([N.default.Error,L.localize(3,null,"engines")]),n;if(typeof p.engines.vscode!="string")return n.push([N.default.Error,L.localize(4,null,"engines.vscode")]),n;if(typeof p.extensionDependencies<"u"&&!a(p.extensionDependencies))return n.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),n;if(typeof p.activationEvents<"u"){if(!a(p.activationEvents))return n.push([N.default.Error,L.localize(6,null,"activationEvents")]),n;if(typeof p.main>"u"&&typeof p.browser>"u")return n.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),n}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&n.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return n.push([N.default.Error,L.localize(9,null,"main")]),n;{const t=(0,R.joinPath)(E,p.main);(0,R.isEqualOrParent)(t,E)||n.push([N.default.Warning,L.localize(10,null,t.path,E.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return n.push([N.default.Error,L.localize(11,null,"browser")]),n;{const t=(0,R.joinPath)(E,p.browser);(0,R.isEqualOrParent)(t,E)||n.push([N.default.Warning,L.localize(12,null,t.path,E.path)])}}if(!T.valid(p.version))return n.push([N.default.Error,L.localize(13,null)]),n;const r=[];if(!d(u,h,p,k,r))for(const t of r)n.push([N.default.Error,t]);return n}e.validateExtensionManifest=v;function d(u,h,E,p,k){return p||typeof E.main>"u"&&typeof E.browser>"u"?!0:w(u,h,E.engines.vscode,k)}e.isValidExtensionVersion=d;function g(u,h,E){return u==="*"||w(h,E,u)}e.isEngineValid=g;function w(u,h,E,p=[]){const k=P(S(E));if(!k)return p.push(L.localize(14,null,E)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return p.push(L.localize(15,null,E)),!1}else if(!k.majorMustEqual)return p.push(L.localize(16,null,E)),!1;return C(u,h,k)?!0:(p.push(L.localize(17,null,u,E)),!1)}function a(u){if(!Array.isArray(u))return!1;for(let h=0,E=u.length;h<E;h++)if(typeof u[h]!="string")return!1;return!0}}),define(ae[44],ce([0,1,16,32]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(T,_,D){let b=D&&D.get("storage.serviceMachineId",-1)||null;if(b)return b;try{const P=(await _.readFile(T.serviceMachineIdResource)).value.toString();b=(0,N.isUUID)(P)?P:null}catch{b=null}if(!b){b=(0,N.generateUuid)();try{await _.writeFile(T.serviceMachineIdResource,R.VSBuffer.fromString(b))}catch{}}return D?.store("storage.serviceMachineId",b,-1,1),b}e.getServiceMachineId=L}),define(ae[68],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(L,T=[],_=!1){this.ctor=L,this.staticArguments=T,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=R}),define(ae[178],ce([0,1,68]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const N=[];var L;(function(D){D[D.Eager=0]="Eager",D[D.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function T(D,b,S){b instanceof R.SyncDescriptor||(b=new R.SyncDescriptor(b,[],!!S)),N.push([D,b])}e.registerSingleton=T;function _(){return N}e.getSingletonServiceDescriptors=_}),define(ae[179],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(T,_){this.key=T,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=R;class N{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(const _ of this._nodes.values())_.outgoing.size===0&&T.push(_);return T}insertEdge(T,_){const D=this.lookupOrInsertNode(T),b=this.lookupOrInsertNode(_);D.outgoing.set(b.key,b),b.incoming.set(D.key,D)}removeNode(T){const _=this._hashFn(T);this._nodes.delete(_);for(const D of this._nodes.values())D.outgoing.delete(_),D.incoming.delete(_)}lookupOrInsertNode(T){const _=this._hashFn(T);let D=this._nodes.get(_);return D||(D=new R(_,T),this._nodes.set(_,D)),D}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){const T=[];for(const[_,D]of this._nodes)T.push(`${_}
	(-> incoming)[${[...D.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...D.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,_]of this._nodes){const D=new Set([T]),b=this._findCycle(_,D);if(b)return b}}_findCycle(T,_){for(const[D,b]of T.outgoing){if(_.has(D))return[..._,D].join(" -> ");_.add(D);const S=this._findCycle(b,_);if(S)return S;_.delete(D)}}}e.Graph=N}),define(ae[4],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function D(b){return b[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=D})(R||(e._util=R={})),e.IInstantiationService=L("instantiationService");function N(_,D,b){D[R.DI_TARGET]===D?D[R.DI_DEPENDENCIES].push({id:_,index:b}):(D[R.DI_DEPENDENCIES]=[{id:_,index:b}],D[R.DI_TARGET]=D)}function L(_){if(R.serviceIds.has(_))return R.serviceIds.get(_);const D=function(b,S,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(D,b,P)};return D.toString=()=>_,R.serviceIds.set(_,D),D}e.createDecorator=L;function T(_){return _}e.refineServiceDecorator=T}),define(ae[180],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(ae[18],ce([0,1,10,12,4]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function T(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof N.URI)}e.isConfigurationOverrides=T;function _(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof N.URI)}e.isConfigurationUpdateOverrides=_;var D;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(D||(e.ConfigurationTarget=D={}));function b(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=b;function S(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.isConfigured=S;function P(u,h){const E=Object.create(null);for(const p in u)C(E,p,u[p],h);return E}e.toValuesTree=P;function C(u,h,E,p){const k=h.split("."),n=k.pop();let r=u;for(let i=0;i<k.length;i++){const t=k[i];let s=r[t];switch(typeof s){case"undefined":s=r[t]=Object.create(null);break;case"object":break;default:p(`Ignoring ${h} as ${k.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[n]=E}catch{p(`Ignoring ${h} as ${k.join(".")} is ${JSON.stringify(r)}`)}else p(`Ignoring ${h} as ${k.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=C;function v(u,h){const E=h.split(".");d(u,E)}e.removeFromValueTree=v;function d(u,h){const E=h.shift();if(h.length===0){delete u[E];return}if(Object.keys(u).indexOf(E)!==-1){const p=u[E];typeof p=="object"&&!Array.isArray(p)&&(d(p,h),Object.keys(p).length===0&&delete u[E])}}function g(u,h,E){function p(r,i){let t=r;for(const s of i){if(typeof t!="object"||t===null)return;t=t[s]}return t}const k=h.split("."),n=p(u,k);return typeof n>"u"?E:n}e.getConfigurationValue=g;function w(u,h,E){Object.keys(h).forEach(p=>{p!=="__proto__"&&(p in u?R.isObject(u[p])&&R.isObject(h[p])?w(u[p],h[p],E):E&&(u[p]=h[p]):u[p]=h[p])})}e.merge=w;function a(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=a}),define(ae[94],ce([0,1,5,27,172,4,143,7]),function(ne,e,R,N,L,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",R.isMacintosh),b.set("isLinux",R.isLinux),b.set("isWindows",R.isWindows),b.set("isWeb",R.isWeb),b.set("isMacNative",R.isMacintosh&&!R.isWeb),b.set("isEdge",R.isEdge),b.set("isFirefox",R.isFirefox),b.set("isChrome",R.isChrome),b.set("isSafari",R.isSafari);function S(O,m){if(b.get(O)!==void 0)throw(0,D.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(O,m)}e.setConstant=S;const P=Object.prototype.hasOwnProperty;var C;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const v={regexParsingWithErrorRecovery:!0},d=(0,_.localize)(0,null),g=(0,_.localize)(1,null),w=(0,_.localize)(2,null),a=(0,_.localize)(3,null),u=(0,_.localize)(4,null),h=(0,_.localize)(5,null),E=(0,_.localize)(6,null),p=(0,_.localize)(7,null);class k{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(m=v){this._config=m,this._scanner=new L.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(m){if(m===""){this._parsingErrors.push({message:d,offset:0,lexeme:"",additionalInfo:g});return}this._tokens=this._scanner.reset(m).scan(),this._current=0,this._parsingErrors=[];try{const U=this._expr();if(!this._isAtEnd()){const W=this._peek(),J=W.type===17?h:void 0;throw this._parsingErrors.push({message:u,offset:W.offset,lexeme:L.Scanner.getLexeme(W),additionalInfo:J}),k._parseError}return U}catch(U){if(U!==k._parseError)throw U;return}}_expr(){return this._or()}_or(){const m=[this._and()];for(;this._matchOne(16);){const U=this._and();m.push(U)}return m.length===1?m[0]:n.or(...m)}_and(){const m=[this._term()];for(;this._matchOne(15);){const U=this._term();m.push(U)}return m.length===1?m[0]:n.and(...m)}_term(){if(this._matchOne(2)){const m=this._peek();switch(m.type){case 11:return this._advance(),s.INSTANCE;case 12:return this._advance(),o.INSTANCE;case 0:{this._advance();const U=this._expr();return this._consume(1,a),U?.negate()}case 17:return this._advance(),A.create(m.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",m)}}return this._primary()}_primary(){const m=this._peek();switch(m.type){case 11:return this._advance(),n.true();case 12:return this._advance(),n.false();case 0:{this._advance();const U=this._expr();return this._consume(1,a),U}case 17:{const U=m.lexeme;if(this._advance(),this._matchOne(9)){const J=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),J.type!==10)throw this._errExpectedButGot("REGEX",J);const $=J.lexeme,H=$.lastIndexOf("/"),te=H===$.length-1?void 0:this._removeFlagsGY($.substring(H+1));let oe;try{oe=new RegExp($.substring(1,H),te)}catch{throw this._errExpectedButGot("REGEX",J)}return X.create(U,oe)}switch(J.type){case 10:case 19:{const $=[J.lexeme];this._advance();let H=this._peek(),te=0;for(let Ee=0;Ee<J.lexeme.length;Ee++)J.lexeme.charCodeAt(Ee)===40?te++:J.lexeme.charCodeAt(Ee)===41&&te--;for(;!this._isAtEnd()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let Ee=0;Ee<H.lexeme.length;Ee++)H.lexeme.charCodeAt(Ee)===40?te++:J.lexeme.charCodeAt(Ee)===41&&te--}if(te<0)break;$.push(L.Scanner.getLexeme(H)),this._advance(),H=this._peek()}const oe=$.join(""),ue=oe.lastIndexOf("/"),de=ue===oe.length-1?void 0:this._removeFlagsGY(oe.substring(ue+1));let ve;try{ve=new RegExp(oe.substring(1,ue),de)}catch{throw this._errExpectedButGot("REGEX",J)}return n.regex(U,ve)}case 18:{const $=J.lexeme;this._advance();let H=null;if(!(0,N.isFalsyOrWhitespace)($)){const te=$.indexOf("/"),oe=$.lastIndexOf("/");if(te!==oe&&te>=0){const ue=$.slice(te+1,oe),de=$[oe+1]==="i"?"i":"";try{H=new RegExp(ue,de)}catch{throw this._errExpectedButGot("REGEX",J)}}}if(H===null)throw this._errExpectedButGot("REGEX",J);return X.create(U,H)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,w);const J=this._value();return n.notIn(U,J)}switch(this._peek().type){case 3:{this._advance();const J=this._value();if(this._previous().type===18)return n.equals(U,J);switch(J){case"true":return n.has(U);case"false":return n.not(U);default:return n.equals(U,J)}}case 4:{this._advance();const J=this._value();if(this._previous().type===18)return n.notEquals(U,J);switch(J){case"true":return n.not(U);case"false":return n.has(U);default:return n.notEquals(U,J)}}case 5:return this._advance(),x.create(U,this._value());case 6:return this._advance(),q.create(U,this._value());case 7:return this._advance(),M.create(U,this._value());case 8:return this._advance(),V.create(U,this._value());case 13:return this._advance(),n.in(U,this._value());default:return n.has(U)}}case 20:throw this._parsingErrors.push({message:E,offset:m.offset,lexeme:"",additionalInfo:p}),k._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const m=this._peek();switch(m.type){case 17:case 18:return this._advance(),m.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(m){return m.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(m){return this._check(m)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(m,U){if(this._check(m))return this._advance();throw this._errExpectedButGot(U,this._peek())}_errExpectedButGot(m,U,W){const J=(0,_.localize)(8,null,m,L.Scanner.getLexeme(U)),$=U.offset,H=L.Scanner.getLexeme(U);return this._parsingErrors.push({message:J,offset:$,lexeme:H,additionalInfo:W}),k._parseError}_check(m){return this._peek().type===m}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=k,k._parseError=new Error;class n{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(m){return c.create(m)}static equals(m,U){return y.create(m,U)}static notEquals(m,U){return I.create(m,U)}static regex(m,U){return X.create(m,U)}static in(m,U){return f.create(m,U)}static notIn(m,U){return l.create(m,U)}static not(m){return A.create(m)}static and(...m){return Z.create(m,null,!0)}static or(...m){return j.create(m,null,!0)}static greater(m,U){return M.create(m,U)}static greaterEquals(m,U){return V.create(m,U)}static smaller(m,U){return x.create(m,U)}static smallerEquals(m,U){return q.create(m,U)}static deserialize(m){return m==null?void 0:this._parser.parse(m)}}e.ContextKeyExpr=n,n._parser=new k({regexParsingWithErrorRecovery:!1});function r(O){const m=new k({regexParsingWithErrorRecovery:!1});return O.map(U=>(m.parse(U),m.lexingErrors.length>0?m.lexingErrors.map(W=>({errorMessage:W.additionalInfo?(0,_.localize)(9,null,W.additionalInfo):(0,_.localize)(10,null),offset:W.offset,length:W.lexeme.length})):m.parsingErrors.length>0?m.parsingErrors.map(W=>({errorMessage:W.additionalInfo?`${W.message}. ${W.additionalInfo}`:W.message,offset:W.offset,length:W.lexeme.length})):[]))}e.validateWhenClauses=r;function i(O,m){const U=O?O.substituteConstants():void 0,W=m?m.substituteConstants():void 0;return!U&&!W?!0:!U||!W?!1:U.equals(W)}e.expressionsAreEqualWithConstantSubstitution=i;function t(O,m){return O.cmp(m)}class s{constructor(){this.type=0}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}substituteConstants(){return this}evaluate(m){return!1}serialize(){return"false"}keys(){return[]}map(m){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=s,s.INSTANCE=new s;class o{constructor(){this.type=1}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}substituteConstants(){return this}evaluate(m){return!0}serialize(){return"true"}keys(){return[]}map(m){return this}negate(){return s.INSTANCE}}e.ContextKeyTrueExpr=o,o.INSTANCE=new o;class c{static create(m,U=null){const W=b.get(m);return typeof W=="boolean"?W?o.INSTANCE:s.INSTANCE:new c(m,U)}constructor(m,U){this.key=m,this.negated=U,this.type=2}cmp(m){return m.type!==this.type?this.type-m.type:z(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}substituteConstants(){const m=b.get(this.key);return typeof m=="boolean"?m?o.INSTANCE:s.INSTANCE:this}evaluate(m){return!!m.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(m){return m.mapDefined(this.key)}negate(){return this.negated||(this.negated=A.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=c;class y{static create(m,U,W=null){if(typeof U=="boolean")return U?c.create(m,W):A.create(m,W);const J=b.get(m);return typeof J=="boolean"?U===(J?"true":"false")?o.INSTANCE:s.INSTANCE:new y(m,U,W)}constructor(m,U,W){this.key=m,this.value=U,this.negated=W,this.type=4}cmp(m){return m.type!==this.type?this.type-m.type:ie(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){const m=b.get(this.key);if(typeof m=="boolean"){const U=m?"true":"false";return this.value===U?o.INSTANCE:s.INSTANCE}return this}evaluate(m){return m.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(m){return m.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=y;class f{static create(m,U){return new f(m,U)}constructor(m,U){this.key=m,this.valueKey=U,this.type=10,this.negated=null}cmp(m){return m.type!==this.type?this.type-m.type:ie(this.key,this.valueKey,m.key,m.valueKey)}equals(m){return m.type===this.type?this.key===m.key&&this.valueKey===m.valueKey:!1}substituteConstants(){return this}evaluate(m){const U=m.getValue(this.valueKey),W=m.getValue(this.key);return Array.isArray(U)?U.includes(W):typeof W=="string"&&typeof U=="object"&&U!==null?P.call(U,W):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(m){return m.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=l.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=f;class l{static create(m,U){return new l(m,U)}constructor(m,U){this.key=m,this.valueKey=U,this.type=11,this._negated=f.create(m,U)}cmp(m){return m.type!==this.type?this.type-m.type:this._negated.cmp(m._negated)}equals(m){return m.type===this.type?this._negated.equals(m._negated):!1}substituteConstants(){return this}evaluate(m){return!this._negated.evaluate(m)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(m){return m.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=l;class I{static create(m,U,W=null){if(typeof U=="boolean")return U?A.create(m,W):c.create(m,W);const J=b.get(m);return typeof J=="boolean"?U===(J?"true":"false")?s.INSTANCE:o.INSTANCE:new I(m,U,W)}constructor(m,U,W){this.key=m,this.value=U,this.negated=W,this.type=5}cmp(m){return m.type!==this.type?this.type-m.type:ie(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){const m=b.get(this.key);if(typeof m=="boolean"){const U=m?"true":"false";return this.value===U?s.INSTANCE:o.INSTANCE}return this}evaluate(m){return m.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(m){return m.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=I;class A{static create(m,U=null){const W=b.get(m);return typeof W=="boolean"?W?s.INSTANCE:o.INSTANCE:new A(m,U)}constructor(m,U){this.key=m,this.negated=U,this.type=3}cmp(m){return m.type!==this.type?this.type-m.type:z(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}substituteConstants(){const m=b.get(this.key);return typeof m=="boolean"?m?s.INSTANCE:o.INSTANCE:this}evaluate(m){return!m.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(m){return m.mapNot(this.key)}negate(){return this.negated||(this.negated=c.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=A;function F(O,m){if(typeof O=="string"){const U=parseFloat(O);isNaN(U)||(O=U)}return typeof O=="string"||typeof O=="number"?m(O):s.INSTANCE}class M{static create(m,U,W=null){return F(U,J=>new M(m,J,W))}constructor(m,U,W){this.key=m,this.value=U,this.negated=W,this.type=12}cmp(m){return m.type!==this.type?this.type-m.type:ie(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=q.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=M;class V{static create(m,U,W=null){return F(U,J=>new V(m,J,W))}constructor(m,U,W){this.key=m,this.value=U,this.negated=W,this.type=13}cmp(m){return m.type!==this.type?this.type-m.type:ie(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=V;class x{static create(m,U,W=null){return F(U,J=>new x(m,J,W))}constructor(m,U,W){this.key=m,this.value=U,this.negated=W,this.type=14}cmp(m){return m.type!==this.type?this.type-m.type:ie(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=V.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=x;class q{static create(m,U,W=null){return F(U,J=>new q(m,J,W))}constructor(m,U,W){this.key=m,this.value=U,this.negated=W,this.type=15}cmp(m){return m.type!==this.type?this.type-m.type:ie(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=q;class X{static create(m,U){return new X(m,U)}constructor(m,U){this.key=m,this.regexp=U,this.type=7,this.negated=null}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.key<m.key)return-1;if(this.key>m.key)return 1;const U=this.regexp?this.regexp.source:"",W=m.regexp?m.regexp.source:"";return U<W?-1:U>W?1:0}equals(m){if(m.type===this.type){const U=this.regexp?this.regexp.source:"",W=m.regexp?m.regexp.source:"";return this.key===m.key&&U===W}return!1}substituteConstants(){return this}evaluate(m){const U=m.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const m=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${m}`}keys(){return[this.key]}map(m){return m.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ee.create(this)),this.negated}}e.ContextKeyRegexExpr=X;class ee{static create(m){return new ee(m)}constructor(m){this._actual=m,this.type=8}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}substituteConstants(){return this}evaluate(m){return!this._actual.evaluate(m)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(m){return new ee(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ee;function Y(O){let m=null;for(let U=0,W=O.length;U<W;U++){const J=O[U].substituteConstants();if(O[U]!==J&&m===null){m=[];for(let $=0;$<U;$++)m[$]=O[$]}m!==null&&(m[U]=J)}return m===null?O:m}class Z{static create(m,U,W){return Z._normalizeArr(m,U,W)}constructor(m,U){this.expr=m,this.negated=U,this.type=6}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let U=0,W=this.expr.length;U<W;U++){const J=t(this.expr[U],m.expr[U]);if(J!==0)return J}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let U=0,W=this.expr.length;U<W;U++)if(!this.expr[U].equals(m.expr[U]))return!1;return!0}return!1}substituteConstants(){const m=Y(this.expr);return m===this.expr?this:Z.create(m,this.negated,!1)}evaluate(m){for(let U=0,W=this.expr.length;U<W;U++)if(!this.expr[U].evaluate(m))return!1;return!0}static _normalizeArr(m,U,W){const J=[];let $=!1;for(const H of m)if(H){if(H.type===1){$=!0;continue}if(H.type===0)return s.INSTANCE;if(H.type===6){J.push(...H.expr);continue}J.push(H)}if(J.length===0&&$)return o.INSTANCE;if(J.length!==0){if(J.length===1)return J[0];J.sort(t);for(let H=1;H<J.length;H++)J[H-1].equals(J[H])&&(J.splice(H,1),H--);if(J.length===1)return J[0];for(;J.length>1;){const H=J[J.length-1];if(H.type!==9)break;J.pop();const te=J.pop(),oe=J.length===0,ue=j.create(H.expr.map(de=>Z.create([de,te],null,W)),null,oe);ue&&(J.push(ue),J.sort(t))}if(J.length===1)return J[0];if(W){for(let H=0;H<J.length;H++)for(let te=H+1;te<J.length;te++)if(J[H].negate().equals(J[te]))return s.INSTANCE;if(J.length===1)return J[0]}return new Z(J,U)}}serialize(){return this.expr.map(m=>m.serialize()).join(" && ")}keys(){const m=[];for(const U of this.expr)m.push(...U.keys());return m}map(m){return new Z(this.expr.map(U=>U.map(m)),null)}negate(){if(!this.negated){const m=[];for(const U of this.expr)m.push(U.negate());this.negated=j.create(m,this,!0)}return this.negated}}e.ContextKeyAndExpr=Z;class j{static create(m,U,W){return j._normalizeArr(m,U,W)}constructor(m,U){this.expr=m,this.negated=U,this.type=9}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let U=0,W=this.expr.length;U<W;U++){const J=t(this.expr[U],m.expr[U]);if(J!==0)return J}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let U=0,W=this.expr.length;U<W;U++)if(!this.expr[U].equals(m.expr[U]))return!1;return!0}return!1}substituteConstants(){const m=Y(this.expr);return m===this.expr?this:j.create(m,this.negated,!1)}evaluate(m){for(let U=0,W=this.expr.length;U<W;U++)if(this.expr[U].evaluate(m))return!0;return!1}static _normalizeArr(m,U,W){let J=[],$=!1;if(m){for(let H=0,te=m.length;H<te;H++){const oe=m[H];if(oe){if(oe.type===0){$=!0;continue}if(oe.type===1)return o.INSTANCE;if(oe.type===9){J=J.concat(oe.expr);continue}J.push(oe)}}if(J.length===0&&$)return s.INSTANCE;J.sort(t)}if(J.length!==0){if(J.length===1)return J[0];for(let H=1;H<J.length;H++)J[H-1].equals(J[H])&&(J.splice(H,1),H--);if(J.length===1)return J[0];if(W){for(let H=0;H<J.length;H++)for(let te=H+1;te<J.length;te++)if(J[H].negate().equals(J[te]))return o.INSTANCE;if(J.length===1)return J[0]}return new j(J,U)}}serialize(){return this.expr.map(m=>m.serialize()).join(" || ")}keys(){const m=[];for(const U of this.expr)m.push(...U.keys());return m}map(m){return new j(this.expr.map(U=>U.map(m)),null)}negate(){if(!this.negated){const m=[];for(const U of this.expr)m.push(U.negate());for(;m.length>1;){const U=m.shift(),W=m.shift(),J=[];for(const $ of Q(U))for(const H of Q(W))J.push(Z.create([$,H],null,!1));m.unshift(j.create(J,null,!1))}this.negated=j.create(m,this,!0)}return this.negated}}e.ContextKeyOrExpr=j;class B extends c{static all(){return B._info.values()}constructor(m,U,W){super(m,null),this._defaultValue=U,typeof W=="object"?B._info.push({...W,key:m}):W!==!0&&B._info.push({key:m,description:W,type:U!=null?typeof U:void 0})}bindTo(m){return m.createKey(this.key,this._defaultValue)}getValue(m){return m.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(m){return y.create(this.key,m)}notEqualsTo(m){return I.create(this.key,m)}}e.RawContextKey=B,B._info=[],e.IContextKeyService=(0,T.createDecorator)("contextKeyService");function z(O,m){return O<m?-1:O>m?1:0}function ie(O,m,U,W){return O<U?-1:O>U?1:m<W?-1:m>W?1:0}function re(O,m){if(O.type===0||m.type===1)return!0;if(O.type===9)return m.type===9?K(O.expr,m.expr):!1;if(m.type===9){for(const U of m.expr)if(re(O,U))return!0;return!1}if(O.type===6){if(m.type===6)return K(m.expr,O.expr);for(const U of O.expr)if(re(U,m))return!0;return!1}return O.equals(m)}e.implies=re;function K(O,m){let U=0,W=0;for(;U<O.length&&W<m.length;){const J=O[U].cmp(m[W]);if(J<0)return!1;J===0&&U++,W++}return U===O.length}function Q(O){return O.type===9?O.expr:[O]}}),define(ae[95],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function N(T){return!!T.hostName&&!!T.errorMessage}e.isRemoteDiagnosticError=N;class L{async getPerformanceInfo(_,D){return{}}async getSystemInfo(_,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(_,D){return""}async getWorkspaceFileExtensions(_){return{extensions:[]}}async reportWorkspaceStats(_){}}e.NullDiagnosticsService=L}),define(ae[96],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(ae[14],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(ae[28],ce([0,1,146,4]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function L(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=L;function T(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function _(h,E){switch(h){case 3:return E==="x64"?"win32-x64":E==="ia32"?"win32-ia32":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":E==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return E==="x64"?"alpine-x64":E==="arm64"?"alpine-arm64":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function D(h,E){return E==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function b(h,E,p){return D(E,p)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===p?!0:S(p).includes(h)}e.isTargetPlatformCompatible=b;function S(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function P(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=P;var C;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var v;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var d;(function(h){h.Install="install",h.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var g;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.IExtensionGalleryService=(0,N.createDecorator)("extensionGalleryService");var w;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var a;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a||(e.ExtensionSignaturetErrorCode=a={}));class u extends Error{constructor(E,p){super(E),this.code=p,this.name=p}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,N.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,N.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,N.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,R.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,R.localize)(1,null),original:"Preferences"}}),define(ae[181],ce([0,1,3,2,31,12,91,28]),function(ne,e,R,N,L,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(a,u){return a?T.URI.revive(u?u.transformIncoming(a):a):void 0}function S(a,u){return u?u.transformOutgoingURI(a):a}function P(a,u){u=u||_.DefaultURITransformer;const h=a.manifest;return{...(0,_.transformAndReviveIncomingURIs)({...a,manifest:void 0},u),manifest:h}}function C(a,u){return a?.profileLocation?(0,_.transformAndReviveIncomingURIs)(a,u??_.DefaultURITransformer):a}function v(a,u){return u?(0,L.cloneAndChange)(a,h=>h instanceof T.URI?u.transformOutgoingURI(h):void 0):a}class d{constructor(u,h){this.service=u,this.getUriTransformer=h,this.onInstallExtension=R.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=R.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,h){const E=this.getUriTransformer(u);switch(h){case"onInstallExtension":return R.Event.map(this.onInstallExtension,p=>({...p,profileLocation:p.profileLocation?S(p.profileLocation,E):p.profileLocation}));case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,p=>p.map(k=>({...k,local:k.local?v(k.local,E):k.local,profileLocation:k.profileLocation?S(k.profileLocation,E):k.profileLocation})));case"onUninstallExtension":return R.Event.map(this.onUninstallExtension,p=>({...p,profileLocation:p.profileLocation?S(p.profileLocation,E):p.profileLocation}));case"onDidUninstallExtension":return R.Event.map(this.onDidUninstallExtension,p=>({...p,profileLocation:p.profileLocation?S(p.profileLocation,E):p.profileLocation}));case"onDidUpdateExtensionMetadata":return R.Event.map(this.onDidUpdateExtensionMetadata,p=>v(p,E))}throw new Error("Invalid listen")}async call(u,h,E){const p=this.getUriTransformer(u);switch(h){case"zip":{const k=P(E[0],p),n=await this.service.zip(k);return S(n,p)}case"unzip":return this.service.unzip(b(E[0],p));case"install":return this.service.install(b(E[0],p),C(E[1],p));case"installFromLocation":return this.service.installFromLocation(b(E[0],p),b(E[1],p));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(E[0],b(E[1],p),b(E[2],p));case"getManifest":return this.service.getManifest(b(E[0],p));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(E[0]);case"installFromGallery":return this.service.installFromGallery(E[0],C(E[1],p));case"installGalleryExtensions":{const k=E[0];return this.service.installGalleryExtensions(k.map(({extension:n,options:r})=>({extension:n,options:C(r,p)??{}})))}case"uninstall":return this.service.uninstall(P(E[0],p),C(E[1],p));case"reinstallFromGallery":return this.service.reinstallFromGallery(P(E[0],p));case"getInstalled":return(await this.service.getInstalled(E[0],b(E[1],p))).map(n=>v(n,p));case"copyExtensions":return this.service.copyExtensions(b(E[0],p),b(E[1],p));case"updateMetadata":{const k=await this.service.updateMetadata(P(E[0],p),E[1],b(E[2],p));return v(k,p)}case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(E[0],E[1],E[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class g extends N.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(u){super(),this.channel=u,this._onInstallExtension=this._register(new R.Emitter),this._onDidInstallExtensions=this._register(new R.Emitter),this._onUninstallExtension=this._register(new R.Emitter),this._onDidUninstallExtension=this._register(new R.Emitter),this._onDidUpdateExtensionMetadata=this._register(new R.Emitter),this._register(this.channel.listen("onInstallExtension")(h=>this.fireEvent(this._onInstallExtension,{...h,source:this.isUriComponents(h.source)?T.URI.revive(h.source):h.source,profileLocation:T.URI.revive(h.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(h=>this.fireEvent(this._onDidInstallExtensions,h.map(E=>({...E,local:E.local?P(E.local,null):E.local,source:this.isUriComponents(E.source)?T.URI.revive(E.source):E.source,profileLocation:T.URI.revive(E.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(h=>this.fireEvent(this._onUninstallExtension,{...h,profileLocation:T.URI.revive(h.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(h=>this.fireEvent(this._onDidUninstallExtension,{...h,profileLocation:T.URI.revive(h.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(h=>this._onDidUpdateExtensionMetadata.fire(P(h,null))))}fireEvent(u,h){u.fire(h)}isUriComponents(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(u){const h=await this.getTargetPlatform();return u.allTargetPlatforms.some(E=>(0,D.isTargetPlatformCompatible)(E,u.allTargetPlatforms,h))}zip(u){return Promise.resolve(this.channel.call("zip",[u]).then(h=>T.URI.revive(h)))}unzip(u){return Promise.resolve(this.channel.call("unzip",[u]))}install(u,h){return Promise.resolve(this.channel.call("install",[u,h])).then(E=>P(E,null))}installFromLocation(u,h){return Promise.resolve(this.channel.call("installFromLocation",[u,h])).then(E=>P(E,null))}async installExtensionsFromProfile(u,h,E){return(await this.channel.call("installExtensionsFromProfile",[u,h,E])).map(k=>P(k,null))}getManifest(u){return Promise.resolve(this.channel.call("getManifest",[u]))}installFromGallery(u,h){return Promise.resolve(this.channel.call("installFromGallery",[u,h])).then(E=>P(E,null))}async installGalleryExtensions(u){return(await this.channel.call("installGalleryExtensions",[u])).map(E=>({...E,local:E.local?P(E.local,null):E.local,source:this.isUriComponents(E.source)?T.URI.revive(E.source):E.source,profileLocation:T.URI.revive(E.profileLocation)}))}uninstall(u,h){return Promise.resolve(this.channel.call("uninstall",[u,h]))}reinstallFromGallery(u){return Promise.resolve(this.channel.call("reinstallFromGallery",[u])).then(h=>P(h,null))}getInstalled(u=null,h){return Promise.resolve(this.channel.call("getInstalled",[u,h])).then(E=>E.map(p=>P(p,null)))}updateMetadata(u,h,E){return Promise.resolve(this.channel.call("updateMetadata",[u,h,E])).then(p=>P(p,null))}copyExtensions(u,h){return this.channel.call("copyExtensions",[u,h])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(u,h,E){const p=await this.channel.call("download",[u,h,E]);return T.URI.revive(p)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=g;class w{constructor(u){this.service=u}listen(u,h){throw new Error("Invalid listen")}call(u,h,E){switch(h){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(E[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=w}),define(ae[97],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,R.createDecorator)("IExtensionSignatureVerificationService");class N{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((T,_)=>ne(["node-vsce-sign"],async D=>T(D),_))),this.moduleLoadingPromise}async verify(T,_,D){let b;try{b=await this.vsceSign()}catch{return!1}return b.verify(T,_,D)}}e.ExtensionSignatureVerificationService=N}),define(ae[98],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var N;(function(_){_[_.FILE=1]="FILE",_[_.WORKSPACE=2]="WORKSPACE",_[_.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function L(_){switch(_){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var T;(function(_){_.Ignored="ignored",_.Cancelled="cancelled",_.TooMany="toomany",_.IncompatibleWindow="incompatibleWindow",_.Accepted="reacted"})(T||(e.RecommendationsNotificationResult=T={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(ae[13],ce([0,1,46,15,27,10,12,153,4,5,25]),function(ne,e,R,N,L,T,_,D,b,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function C(z){return z.create===!0}e.isFileOpenForWriteOptions=C;var v;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var d;(function(z){z[z.Readonly=1]="Readonly",z[z.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var g;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileAtomicWrite=32768]="FileAtomicWrite",z[z.FileAtomicDelete=65536]="FileAtomicDelete",z[z.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function w(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=w;function a(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=a;function u(z){return!!(z.capabilities&131072)}e.hasFileCloneCapability=u;function h(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function E(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=E;function p(z){return w(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;function k(z){return w(z)?!!(z.capabilities&32768):!1}e.hasFileAtomicWriteCapability=k;function n(z){return!!(z.capabilities&65536)}e.hasFileAtomicDeleteCapability=n;function r(z){return!!(z.capabilities&2048)}e.hasReadonlyCapability=r;var i;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsStorageQuota="EntryExceedsStorageQuota",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(i||(e.FileSystemProviderErrorCode=i={}));class t extends Error{static create(ie,re){const K=new t(ie.toString(),re);return c(K,re),K}constructor(ie,re){super(ie),this.code=re}}e.FileSystemProviderError=t;function s(z,ie){return t.create(z,ie)}e.createFileSystemProviderError=s;function o(z){return z||s((0,D.localize)(0,null),i.Unknown)}e.ensureFileSystemProviderError=o;function c(z,ie){return z.name=ie?`${ie} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=c;function y(z){if(!z)return i.Unknown;if(z instanceof t)return z.code;const ie=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!ie)return i.Unknown;switch(ie[1]){case i.FileExists:return i.FileExists;case i.FileIsADirectory:return i.FileIsADirectory;case i.FileNotADirectory:return i.FileNotADirectory;case i.FileNotFound:return i.FileNotFound;case i.FileTooLarge:return i.FileTooLarge;case i.FileWriteLocked:return i.FileWriteLocked;case i.NoPermissions:return i.NoPermissions;case i.Unavailable:return i.Unavailable}return i.Unknown}e.toFileSystemProviderErrorCode=y;function f(z){if(z instanceof V)return z.fileOperationResult;switch(y(z)){case i.FileNotFound:return 1;case i.FileIsADirectory:return 0;case i.FileNotADirectory:return 9;case i.FileWriteLocked:return 5;case i.NoPermissions:return 6;case i.FileExists:return 4;case i.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=f;var l;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(l||(e.FileOperation=l={}));class I{constructor(ie,re,K){this.resource=ie,this.operation=re,this.target=K}isOperation(ie){return this.operation===ie}}e.FileOperationEvent=I;var A;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(A||(e.FileChangeType=A={}));class F{constructor(ie,re){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const K=new Map;for(const Q of ie){const O=K.get(Q.type);switch(O?O.push([Q.resource,Q]):K.set(Q.type,[[Q.resource,Q]]),Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}}for(const[Q,O]of K)switch(Q){case 1:this.added=R.TernarySearchTree.forUris(()=>re),this.added.fill(O);break;case 0:this.updated=R.TernarySearchTree.forUris(()=>re),this.updated.fill(O);break;case 2:this.deleted=R.TernarySearchTree.forUris(()=>re),this.deleted.fill(O);break}}contains(ie,...re){return this.doContains(ie,{includeChildren:!1},...re)}affects(ie,...re){return this.doContains(ie,{includeChildren:!0},...re)}doContains(ie,re,...K){if(!ie)return!1;const Q=K.length>0;return!!((!Q||K.includes(1))&&(this.added?.get(ie)||re.includeChildren&&this.added?.findSuperstr(ie))||(!Q||K.includes(0))&&(this.updated?.get(ie)||re.includeChildren&&this.updated?.findSuperstr(ie))||(!Q||K.includes(2))&&(this.deleted?.findSubstr(ie)||re.includeChildren&&this.deleted?.findSuperstr(ie)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=F;function M(z,ie,re){return!z||!ie||z===ie||ie.length>z.length?!1:(ie.charAt(ie.length-1)!==N.sep&&(ie+=N.sep),re?(0,L.startsWithIgnoreCase)(z,ie):z.indexOf(ie)===0)}e.isParent=M;class V extends Error{constructor(ie,re,K){super(ie),this.fileOperationResult=re,this.options=K}}e.FileOperationError=V;class x extends V{constructor(ie,re,K,Q){super(ie,re,Q),this.fileOperationResult=re,this.size=K}}e.TooLargeFileOperationError=x;class q extends V{constructor(ie,re,K){super(ie,2,K),this.stat=re}}e.NotModifiedSinceFileOperationError=q;var X;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ee;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(ee||(e.FileKind=ee={})),e.ETAG_DISABLED="";function Y(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=Y;async function Z(z,ie){if(!ie.hasProvider(_.URI.from({scheme:z.scheme})))return new Promise(re=>{const K=ie.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===z.scheme&&Q.added&&(K.dispose(),re())})})}e.whenProviderRegistered=Z;class j{static formatSize(ie){return(0,T.isNumber)(ie)||(ie=0),ie<j.KB?(0,D.localize)(1,null,ie.toFixed(0)):ie<j.MB?(0,D.localize)(2,null,(ie/j.KB).toFixed(2)):ie<j.GB?(0,D.localize)(3,null,(ie/j.MB).toFixed(2)):ie<j.TB?(0,D.localize)(4,null,(ie/j.GB).toFixed(2)):(0,D.localize)(5,null,(ie/j.TB).toFixed(2))}}e.ByteSize=j,j.KB=1024,j.MB=j.KB*j.KB,j.GB=j.MB*j.KB,j.TB=j.GB*j.KB;function B(z){const ie=typeof z=="string"||z?.scheme===P.Schemas.vscodeRemote;return typeof z!="string"&&z?.scheme===P.Schemas.file?1024*j.MB:ie?10*j.MB:S.isWeb?50*j.MB:1024*j.MB}e.getLargeFileConfirmationLimit=B});var G=this&&this.__param||function(ne,e){return function(R,N){e(R,N,ne)}};define(ae[182],ce([0,1,69,42,13]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=e.ChecksumService=class{constructor(D){this.fileService=D}async checksum(D){const b=(await this.fileService.readFileStream(D)).value;return new Promise((S,P)=>{const C=(0,R.createHash)("md5");(0,N.listenStream)(b,{onData:v=>C.update(v.buffer),onError:v=>P(v),onEnd:()=>S(C.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=T=pe([G(0,L.IFileService)],T)}),define(ae[183],ce([0,1,16,38,7,3,2,42,12,32,13]),function(ne,e,R,N,L,T,_,D,b,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends _.Disposable{constructor(d,g){super(),this.channel=d,this.extraCapabilities=g,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,S.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(d){return this.channel.call("stat",[d])}readdir(d){return this.channel.call("readdir",[d])}async readFile(d,g){const{buffer:w}=await this.channel.call("readFile",[d,g]);return w}readFileStream(d,g,w){const a=(0,D.newWriteableStream)(h=>R.VSBuffer.concat(h.map(E=>R.VSBuffer.wrap(E))).buffer),u=this.channel.listen("readFileStream",[d,g])(h=>{if(h instanceof R.VSBuffer)a.write(h.buffer);else{if(h==="end")a.end();else{let E;if(h instanceof Error)E=h;else{const p=h;E=(0,P.createFileSystemProviderError)(p.message??(0,N.toErrorMessage)(p),p.code??P.FileSystemProviderErrorCode.Unknown)}a.error(E),a.end()}u.dispose()}});return w.onCancellationRequested(()=>{a.error((0,L.canceled)()),a.end(),u.dispose()}),a}writeFile(d,g,w){return this.channel.call("writeFile",[d,R.VSBuffer.wrap(g),w])}open(d,g){return this.channel.call("open",[d,g])}close(d){return this.channel.call("close",[d])}async read(d,g,w,a,u){const[h,E]=await this.channel.call("read",[d,g,u]);return w.set(h.buffer.slice(0,E),a),E}write(d,g,w,a,u){return this.channel.call("write",[d,g,R.VSBuffer.wrap(w),a,u])}mkdir(d){return this.channel.call("mkdir",[d])}delete(d,g){return this.channel.call("delete",[d,g])}rename(d,g,w){return this.channel.call("rename",[d,g,w])}copy(d,g,w){return this.channel.call("copy",[d,g,w])}cloneFile(d,g){return this.channel.call("cloneFile",[d,g])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(d=>{if(Array.isArray(d)){const g=d;this._onDidChange.fire(g.map(w=>({resource:b.URI.revive(w.resource),type:w.type})))}else{const g=d;this._onDidWatchError.fire(g)}}))}watch(d,g){const w=(0,S.generateUuid)();return this.channel.call("watch",[this.sessionId,w,d,g]),(0,_.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,w]))}}e.DiskFileSystemProviderClient=C}),define(ae[99],ce([0,1,16,7,154,13]),function(ne,e,R,N,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function _(P,C,v,d,g,w){let a;try{await D(P,C,v,d,g,w)}catch(u){a=u}finally{a&&g.errorTransformer&&(a=g.errorTransformer(a)),typeof a<"u"&&v.error(a),v.end()}}e.readFileIntoStream=_;async function D(P,C,v,d,g,w){b(w);const a=await P.open(C,{create:!1});try{b(w);let u=0,h=0,E=g&&typeof g.length=="number"?g.length:void 0,p=R.VSBuffer.alloc(Math.min(g.bufferSize,typeof E=="number"?E:g.bufferSize)),k=g&&typeof g.position=="number"?g.position:0,n=0;do h=await P.read(a,k,p.buffer,n,p.byteLength-n),k+=h,n+=h,u+=h,typeof E=="number"&&(E-=h),n===p.byteLength&&(await v.write(d(p)),p=R.VSBuffer.alloc(Math.min(g.bufferSize,typeof E=="number"?E:g.bufferSize)),n=0);while(h>0&&(typeof E!="number"||E>0)&&b(w)&&S(u,g));if(n>0){let r=n;typeof E=="number"&&(r=Math.min(n,E)),v.write(d(p.slice(0,r)))}}catch(u){throw(0,T.ensureFileSystemProviderError)(u)}finally{await P.close(a)}}function b(P){if(P.isCancellationRequested)throw(0,N.canceled)();return!0}function S(P,C){if(typeof C?.limits?.size=="number"&&P>C.limits.size)throw(0,T.createFileSystemProviderError)((0,L.localize)(0,null),T.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[53],ce([0,1,90,2,15,5,12,13]),function(ne,e,R,N,L,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function b(u){return u.recursive===!0}e.isRecursiveWatchRequest=b;class S extends N.Disposable{constructor(h,E,p,k){super(),this.onFileChanges=h,this.onLogMessage=E,this.verboseLogging=p,this.options=k,this.watcherDisposables=this._register(new N.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const h=new N.DisposableStore;this.watcherDisposables.value=h,this.watcher=this.createWatcher(h),this.watcher.setVerboseLogging(this.verboseLogging),h.add(this.watcher.onDidChangeFile(E=>this.onFileChanges(E))),h.add(this.watcher.onDidLogMessage(E=>this.onLogMessage(E))),h.add(this.watcher.onDidError(E=>this.onError(E)))}onError(h){this.options.restartOnError?this.restartCounter<S.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${h}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${h}`):this.error(h)}restart(h){this.restartCounter++,this.init(),this.watch(h)}async watch(h){this.requests=h,await this.watcher?.watch(h)}async setVerboseLogging(h){this.verboseLogging=h,await this.watcher?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${h}`})}trace(h){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${h}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=S,S.MAX_RESTARTS=5;class P extends S{constructor(h,E,p){super(h,E,p,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=P;class C extends S{constructor(h,E,p){super(h,E,p,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=C;function v(u){return u.map(h=>({type:h.type,resource:_.URI.file(h.path)}))}e.toFileChanges=v;function d(u){const h=new a;for(const E of u)h.processEvent(E);return h.coalesce()}e.coalesceEvents=d;function g(u,h){return typeof h=="string"&&!h.startsWith(R.GLOBSTAR)&&!(0,L.isAbsolute)(h)?{base:u,pattern:h}:h}e.normalizeWatcherPattern=g;function w(u,h){const E=[];for(const p of h)E.push((0,R.parse)(g(u,p)));return E}e.parseWatcherPatterns=w;class a{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(h){return T.isLinux?h.path:h.path.toLowerCase()}processEvent(h){const E=this.mapPathToChange.get(this.toKey(h));let p=!1;if(E){const k=E.type,n=h.type;E.path!==h.path&&(h.type===2||h.type===1)?p=!0:k===1&&n===2?(this.mapPathToChange.delete(this.toKey(h)),this.coalesced.delete(E)):k===2&&n===1?E.type=0:k===1&&n===0||(E.type=n)}else p=!0;p&&(this.coalesced.add(h),this.mapPathToChange.set(this.toKey(h),h))}coalesce(){const h=[],E=[];return Array.from(this.coalesced).filter(p=>p.type!==2?(h.push(p),!1):!0).sort((p,k)=>p.path.length-k.path.length).filter(p=>E.some(k=>(0,D.isParent)(p.path,k,!T.isLinux))?!1:(E.push(p.path),!0)).concat(h)}}}),define(ae[184],ce([0,1,51,6,26,47,2,86,15,5,137,30,53]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends _.Disposable{constructor(a,u,h,E){super(),this.request=a,this.onDidFilesChange=u,this.onLogMessage=h,this.verboseLogging=E,this.throttledFileChangesEmitter=this._register(new N.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},p=>this.onDidFilesChange(p))),this.fileChangesAggregator=this._register(new N.RunOnceWorker(p=>this.handleFileChanges(p),d.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,v.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,v.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const a=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const u=await C.Promises.stat(a);this._register(await this.doWatch(a,u.isDirectory()))}catch(a){a.code!=="ENOENT"?this.error(a):this.trace(a)}}async normalizePath(a){let u=a.path;try{u=await C.Promises.realpath(a.path),a.path===u&&(u=await(0,P.realcase)(a.path)??a.path),a.path!==u&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${a.path}, real: ${u})`)}catch{}return u}async doWatch(a,u){if(S.isMacintosh&&(0,T.isEqualOrParent)(a,"/Volumes/",!0))return this.error(`Refusing to watch ${a} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),_.Disposable.None;const h=new L.CancellationTokenSource(this.cts.token),E=new _.DisposableStore;try{const p=(0,b.basename)(a),k=(0,R.watch)(a);E.add((0,_.toDisposable)(()=>{k.removeAllListeners(),k.close()})),this.trace(`Started watching: '${a}'`);const n=new Set;if(u)try{for(const i of await C.Promises.readdir(a))n.add(i)}catch(i){this.error(i)}const r=new Map;E.add((0,_.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),k.on("error",(i,t)=>{this.error(`Failed to watch ${a} for changes using fs.watch() (${i}, ${t})`),this.dispose()}),k.on("change",(i,t)=>{if(h.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${t}`);let s="";if(t&&(s=t.toString(),S.isMacintosh&&(s=(0,D.normalizeNFC)(s))),!(!s||i!=="change"&&i!=="rename"))if(u)if(i==="rename"){r.get(s)?.dispose();const o=setTimeout(async()=>{if(r.delete(s),s===p&&!await C.Promises.exists(a)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const c=await this.existsChildStrictCase((0,b.join)(a,s));if(h.token.isCancellationRequested)return;let y;c?n.has(s)?y=0:(y=1,n.add(s)):(n.delete(s),y=2),this.onFileChange({path:(0,b.join)(this.request.path,s),type:y})},d.FILE_DELETE_HANDLER_DELAY);r.set(s,(0,_.toDisposable)(()=>clearTimeout(o)))}else{let o;n.has(s)?o=0:(o=1,n.add(s)),this.onFileChange({path:(0,b.join)(this.request.path,s),type:o})}else if(i==="rename"||s!==p){const o=setTimeout(async()=>{const c=await C.Promises.exists(a);h.token.isCancellationRequested||(c?(this.onFileChange({path:this.request.path,type:0},!0),E.add(await this.doWatch(a,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},d.FILE_DELETE_HANDLER_DELAY);E.clear(),E.add((0,_.toDisposable)(()=>clearTimeout(o)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(p){await C.Promises.exists(a)&&!h.token.isCancellationRequested&&this.error(`Failed to watch ${a} for changes using fs.watch() (${p.toString()})`)}return(0,_.toDisposable)(()=>{h.dispose(!0),E.dispose()})}onFileChange(a,u=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`),!u&&this.excludes.some(h=>h(a.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${a.path}`):!u&&this.includes&&this.includes.length>0&&!this.includes.some(h=>h(a.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${a.path}`):this.fileChangesAggregator.work(a))}handleFileChanges(a){const u=(0,v.coalesceEvents)(a);if(u.length>0){if(this.verboseLogging)for(const E of u)this.trace(`>> normalized ${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`);this.throttledFileChangesEmitter.work(u)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(a){if(S.isLinux)return C.Promises.exists(a);try{const u=(0,b.basename)(a);return(await C.Promises.readdir((0,b.dirname)(a))).some(E=>E===u)}catch(u){return this.trace(u),!1}}setVerboseLogging(a){this.verboseLogging=a}error(a){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${a}`})}warn(a){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${a}`})}trace(a){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${a}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=d,d.FILE_DELETE_HANDLER_DELAY=100,d.FILE_CHANGES_HANDLER_DELAY=75;async function g(w,a,u,h,E=512){const p=await C.Promises.open(w,"r"),k=Buffer.allocUnsafe(E),n=new L.CancellationTokenSource(h);let r,i=!1;const t={path:w,excludes:[],recursive:!1},s=new d(t,o=>{(async()=>{for(const{type:c}of o)if(c===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:y}=await C.Promises.read(p,k,0,E,null);if(!y||n.token.isCancellationRequested)break;a(k.slice(0,y))}}catch(y){r=new Error(y),n.dispose(!0)}finally{i=!1}}})()});return await s.ready,u(),new Promise((o,c)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await C.Promises.close(p)}catch(y){r=new Error(y)}r?c(r):o()})})}e.watchFileContents=g}),define(ae[185],ce([0,1,3,90,2,5,184]),function(ne,e,R,N,L,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class D extends L.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=R.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(S){const P=this.normalizeRequests(S),C=P.filter(d=>{const g=this.watchers.get(d.path);return g?!(0,N.patternsEquals)(g.request.excludes,d.excludes)||!(0,N.patternsEquals)(g.request.includes,d.includes):!0}),v=Array.from(this.watchers.values()).filter(({request:d})=>!P.find(g=>g.path===d.path&&(0,N.patternsEquals)(g.excludes,d.excludes)&&(0,N.patternsEquals)(g.includes,d.includes))).map(({request:d})=>d.path);C.length&&this.trace(`Request to start watching: ${C.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),v.length&&this.trace(`Request to stop watching: ${v.join(",")}`);for(const d of v)this.stopWatching(d);for(const d of C)this.startWatching(d)}startWatching(S){const P=new _.NodeJSFileWatcherLibrary(S,v=>this._onDidChangeFile.fire(v),v=>this._onDidLogMessage.fire(v),this.verboseLogging),C={request:S,instance:P};this.watchers.set(S.path,C)}async stop(){for(const[S]of this.watchers)this.stopWatching(S);this.watchers.clear()}stopWatching(S){const P=this.watchers.get(S);P&&(this.watchers.delete(S),P.instance.dispose())}normalizeRequests(S){const P=new Map;for(const C of S){const v=T.isLinux?C.path:C.path.toLowerCase();P.set(v,C)}return Array.from(P.values())}async setVerboseLogging(S){this.verboseLogging=S;for(const[,P]of this.watchers)P.instance.setVerboseLogging(S)}trace(S){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(S)})}toMessage(S,P){return P?`[File Watcher (node.js)] ${S} (path: ${P.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=D}),define(ae[186],ce([0,1,53,185]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends R.AbstractNonRecursiveWatcherClient{constructor(_,D,b){super(_,D,b),this.init()}createWatcher(){return new N.NodeJSWatcher}}e.NodeJSWatcherClient=L}),define(ae[187],ce([0,1,25,43,93,53]),function(ne,e,R,N,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class _ extends T.AbstractUniversalWatcherClient{constructor(b,S,P){super(b,S,P),this.init()}createWatcher(b){const S=b.add(new L.Client(R.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(S.onDidProcessExit(({code:P,signal:C})=>this.onError(`terminated by itself with code ${P}, signal: ${C}`))),N.ProxyChannel.toService((0,N.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=_}),define(ae[70],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...L){this._entries=new Map;for(const[T,_]of L)this.set(T,_)}set(L,T){const _=this._entries.get(L);return this._entries.set(L,T),_}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=R}),define(ae[188],ce([0,1,6,7,2,68,179,4,70,85]),function(ne,e,R,N,L,T,_,D,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class C extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class v{constructor(a=new b.ServiceCollection,u=!1,h,E=P){this._services=a,this._strict=u,this._parent=h,this._enableTracing=E,this._activeInstantiations=new Set,this._services.set(D.IInstantiationService,this),this._globalGraph=E?h?._globalGraph??new _.Graph(p=>p):void 0}createChild(a){return new v(a,this._strict,this,this._enableTracing)}invokeFunction(a,...u){const h=g.traceInvocation(this._enableTracing,a);let E=!1;try{return a({get:k=>{if(E)throw(0,N.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(k,h);if(!n)throw new Error(`[invokeFunction] unknown service '${k}'`);return n}},...u)}finally{E=!0,h.stop()}}createInstance(a,...u){let h,E;return a instanceof T.SyncDescriptor?(h=g.traceCreation(this._enableTracing,a.ctor),E=this._createInstance(a.ctor,a.staticArguments.concat(u),h)):(h=g.traceCreation(this._enableTracing,a),E=this._createInstance(a,u,h)),h.stop(),E}_createInstance(a,u=[],h){const E=D._util.getServiceDependencies(a).sort((n,r)=>n.index-r.index),p=[];for(const n of E){const r=this._getOrCreateServiceInstance(n.id,h);r||this._throwIfStrict(`[createInstance] ${a.name} depends on UNKNOWN service ${n.id}.`,!1),p.push(r)}const k=E.length>0?E[0].index:u.length;if(u.length!==k){console.trace(`[createInstance] First service dependency of ${a.name} at position ${k+1} conflicts with ${u.length} static arguments`);const n=k-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,k)}return Reflect.construct(a,u.concat(p))}_setServiceInstance(a,u){if(this._services.get(a)instanceof T.SyncDescriptor)this._services.set(a,u);else if(this._parent)this._parent._setServiceInstance(a,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){const u=this._services.get(a);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):u}_getOrCreateServiceInstance(a,u){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(a));const h=this._getServiceInstanceOrDescriptor(a);return h instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,h,u.branch(a,!0)):(u.branch(a,!1),h)}_safeCreateAndCacheServiceInstance(a,u,h){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,u,h)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,u,h){const E=new _.Graph(n=>n.id.toString());let p=0;const k=[{id:a,desc:u,_trace:h}];for(;k.length;){const n=k.pop();if(E.lookupOrInsertNode(n),p++>1e3)throw new C(E);for(const r of D._util.getServiceDependencies(n.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(r.id);if(i||this._throwIfStrict(`[createInstance] ${a} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),i instanceof T.SyncDescriptor){const t={id:r.id,desc:i,_trace:n._trace.branch(r.id,!0)};E.insertEdge(n,t),k.push(t)}}}for(;;){const n=E.roots();if(n.length===0){if(!E.isEmpty())throw new C(E);break}for(const{data:r}of n){if(this._getServiceInstanceOrDescriptor(r.id)instanceof T.SyncDescriptor){const t=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,t)}E.removeNode(r)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,u,h=[],E,p){if(this._services.get(a)instanceof T.SyncDescriptor)return this._createServiceInstance(a,u,h,E,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,u,h,E,p);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(a,u,h=[],E,p){if(E){const k=new v(void 0,this._strict,this,this._enableTracing);k._globalGraphImplicitDependency=String(a);const n=new Map,r=new R.IdleValue(()=>{const i=k._createInstance(u,h,p);for(const[t,s]of n){const o=i[t];if(typeof o=="function")for(const c of s)o.apply(i,c)}return n.clear(),i});return new Proxy(Object.create(null),{get(i,t){if(!r.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let c=n.get(t);return c||(c=new S.LinkedList,n.set(t,c)),(f,l,I)=>{const A=c.push([f,l,I]);return(0,L.toDisposable)(A)}}if(t in i)return i[t];const s=r.value;let o=s[t];return typeof o!="function"||(o=o.bind(s),i[t]=o),o},set(i,t,s){return r.value[t]=s,!0},getPrototypeOf(i){return u.prototype}})}else return this._createInstance(u,h,p)}_throwIfStrict(a,u){if(u&&console.warn(a),this._strict)throw new Error(a)}}e.InstantiationService=v;var d;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(d||(d={}));class g{static traceInvocation(a,u){return a?new g(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g._None}static traceCreation(a,u){return a?new g(1,u.name):g._None}constructor(a,u){this.type=a,this.name=u,this._start=Date.now(),this._dep=[]}branch(a,u){const h=new g(3,a.toString());return this._dep.push([a,u,h]),h}stop(){const a=Date.now()-this._start;g._totals+=a;let u=!1;function h(p,k){const n=[],r=new Array(p+1).join("	");for(const[i,t,s]of k._dep)if(t&&s){u=!0,n.push(`${r}CREATES -> ${i}`);const o=h(p+1,s);o&&n.push(o)}else n.push(`${r}uses -> ${i}`);return n.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(a>2||u)&&g.all.add(E.join(`
`))}}e.Trace=g,g.all=new Set,g._None=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}},g._totals=0}),define(ae[71],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,R.createDecorator)("mainProcessService");class N{constructor(T,_){this.server=T,this.router=_}getChannel(T){return this.server.getChannel(T,this.router)}registerChannel(T,_){this.server.registerChannel(T,_)}}e.MainProcessService=N}),define(ae[72],ce([0,1,26,2,5,156,28,4]),function(ne,e,R,N,L,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function b(P){return P.tags.find(C=>C.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=b,e.ILanguagePackService=(0,D.createDecorator)("languagePackService");let S=e.LanguagePackBaseService=class extends N.Disposable{constructor(C){super(),this.extensionGalleryService=C}async getAvailableLanguages(){const C=new R.CancellationTokenSource;setTimeout(()=>C.cancel(),1e3);let v;try{v=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},C.token)}catch{return[]}const g=v.firstPage.filter(w=>w.properties.localizedLanguages?.length&&w.tags.some(a=>a.startsWith("lp-"))).map(w=>{const a=w.properties.localizedLanguages?.[0],u=b(w);return{...this.createQuickPickItem(u,a,w),extensionId:w.identifier.id,galleryExtension:w}});return g.push(this.createQuickPickItem("en","English")),g}createQuickPickItem(C,v,d){const g=v??C;let w;if(g!==C&&(w=`(${C})`),C.toLowerCase()===L.language.toLowerCase()&&(w??="",w+=(0,T.localize)(0,null)),d?.installCount){w??="";const a=d.installCount;let u;a>1e6?u=`${Math.floor(a/1e5)/10}M`:a>1e3?u=`${Math.floor(a/1e3)}K`:u=String(a),w+=` $(cloud-download) ${u}`}return{id:C,label:g,description:w}}};e.LanguagePackBaseService=S=pe([G(0,_.IExtensionGalleryService)],S)}),define(ae[189],ce([0,1,2,72]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=e.LocalizationsUpdater=class extends R.Disposable{constructor(_){super(),this.localizationsService=_,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};e.LocalizationsUpdater=L=pe([G(0,N.ILanguagePackService)],L)}),define(ae[8],ce([0,1,38,3,61,2,35,5,22,10,12,94,4]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function d(){return new Date().toISOString()}function g(f){return(0,S.isNumber)(f)}e.isLogLevel=g;var w;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(w||(e.LogLevel=w={})),e.DEFAULT_LOG_LEVEL=w.Info;function a(f,l,I){switch(l){case w.Trace:f.trace(I);break;case w.Debug:f.debug(I);break;case w.Info:f.info(I);break;case w.Warning:f.warn(I);break;case w.Error:f.error(I);break;case w.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=a;function u(f,l=!1){let I="";for(let A=0;A<f.length;A++){let F=f[A];if(F instanceof Error&&(F=(0,R.toErrorMessage)(F,l)),typeof F=="object")try{F=JSON.stringify(F)}catch{}I+=(A>0?" ":"")+F}return I}class h extends T.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new N.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(l){this.level!==l&&(this.level=l,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(l){return this.level!==w.Off&&this.level<=l}}e.AbstractLogger=h;class E extends h{constructor(l){super(),this.logAlways=l}checkLogLevel(l){return this.logAlways||super.checkLogLevel(l)}trace(l,...I){this.checkLogLevel(w.Trace)&&this.log(w.Trace,u([l,...I],!0))}debug(l,...I){this.checkLogLevel(w.Debug)&&this.log(w.Debug,u([l,...I]))}info(l,...I){this.checkLogLevel(w.Info)&&this.log(w.Info,u([l,...I]))}warn(l,...I){this.checkLogLevel(w.Warning)&&this.log(w.Warning,u([l,...I]))}error(l,...I){if(this.checkLogLevel(w.Error))if(l instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=l.stack,this.log(w.Error,u(A))}else this.log(w.Error,u([l,...I]))}flush(){}}e.AbstractMessageLogger=E;class p extends h{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l),this.useColors=!D.isWindows}trace(l,...I){this.checkLogLevel(w.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,l,...I):console.log(`[main ${d()}]`,l,...I))}debug(l,...I){this.checkLogLevel(w.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,l,...I):console.log(`[main ${d()}]`,l,...I))}info(l,...I){this.checkLogLevel(w.Info)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,l,...I):console.log(`[main ${d()}]`,l,...I))}warn(l,...I){this.checkLogLevel(w.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,l,...I):console.warn(`[main ${d()}]`,l,...I))}error(l,...I){this.checkLogLevel(w.Error)&&(this.useColors?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,l,...I):console.error(`[main ${d()}]`,l,...I))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class k extends h{constructor(l=e.DEFAULT_LOG_LEVEL,I=!0){super(),this.useColors=I,this.setLevel(l)}trace(l,...I){this.checkLogLevel(w.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",l,...I):console.log(l,...I))}debug(l,...I){this.checkLogLevel(w.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",l,...I):console.log(l,...I))}info(l,...I){this.checkLogLevel(w.Info)&&(this.useColors?console.log("%c INFO","color: #33f",l,...I):console.log(l,...I))}warn(l,...I){this.checkLogLevel(w.Warning)&&(this.useColors?console.log("%c WARN","color: #993",l,...I):console.log(l,...I))}error(l,...I){this.checkLogLevel(w.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",l,...I):console.error(l,...I))}dispose(){}flush(){}}e.ConsoleLogger=k;class n extends h{constructor(l,I=e.DEFAULT_LOG_LEVEL){super(),this.adapter=l,this.setLevel(I)}trace(l,...I){this.checkLogLevel(w.Trace)&&this.adapter.log(w.Trace,[this.extractMessage(l),...I])}debug(l,...I){this.checkLogLevel(w.Debug)&&this.adapter.log(w.Debug,[this.extractMessage(l),...I])}info(l,...I){this.checkLogLevel(w.Info)&&this.adapter.log(w.Info,[this.extractMessage(l),...I])}warn(l,...I){this.checkLogLevel(w.Warning)&&this.adapter.log(w.Warning,[this.extractMessage(l),...I])}error(l,...I){this.checkLogLevel(w.Error)&&this.adapter.log(w.Error,[this.extractMessage(l),...I])}extractMessage(l){return typeof l=="string"?l:(0,R.toErrorMessage)(l,this.checkLogLevel(w.Trace))}dispose(){}flush(){}}e.AdapterLogger=n;class r extends h{constructor(l){super(),this.loggers=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const I of this.loggers)I.setLevel(l);super.setLevel(l)}trace(l,...I){for(const A of this.loggers)A.trace(l,...I)}debug(l,...I){for(const A of this.loggers)A.debug(l,...I)}info(l,...I){for(const A of this.loggers)A.info(l,...I)}warn(l,...I){for(const A of this.loggers)A.warn(l,...I)}error(l,...I){for(const A of this.loggers)A.error(l,...I)}flush(){for(const l of this.loggers)l.flush()}dispose(){for(const l of this.loggers)l.dispose()}}e.MultiplexLogger=r;class i extends T.Disposable{constructor(l,I,A){if(super(),this.logLevel=l,this.logsHome=I,this._loggers=new _.ResourceMap,this._onDidChangeLoggers=this._register(new N.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new N.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new N.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,A)for(const F of A)this._loggers.set(F.resource,{logger:void 0,info:F})}getLoggerEntry(l){return(0,S.isString)(l)?[...this._loggers.values()].find(I=>I.info.id===l):this._loggers.get(l)}getLogger(l){return this.getLoggerEntry(l)?.logger}createLogger(l,I){const A=this.toResource(l),F=(0,S.isString)(l)?l:I?.id??(0,L.hash)(A.toString()).toString(16);let M=this._loggers.get(A)?.logger;const V=I?.logLevel==="always"?w.Trace:I?.logLevel;M||(M=this.doCreateLogger(A,V??this.getLogLevel(A)??this.logLevel,{...I,id:F}));const x={logger:M,info:{resource:A,id:F,logLevel:V,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(x.info),this._loggers.set(A,x),M}toResource(l){return(0,S.isString)(l)?(0,b.joinPath)(this.logsHome,`${l}.log`):l}setLogLevel(l,I){if(P.URI.isUri(l)){const A=l,F=I,M=this._loggers.get(A);M&&F!==M.info.logLevel&&(M.info.logLevel=F===this.logLevel?void 0:F,M.logger?.setLevel(F),this._loggers.set(M.info.resource,M),this._onDidChangeLogLevel.fire([A,F]))}else{this.logLevel=l;for(const[A,F]of this._loggers.entries())this._loggers.get(A)?.info.logLevel===void 0&&F.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(l,I){const A=this.getLoggerEntry(l);A&&I!==!A.info.hidden&&(A.info.hidden=!I,this._loggers.set(A.info.resource,A),this._onDidChangeVisibility.fire([A.info.resource,I]))}getLogLevel(l){let I;return l&&(I=this._loggers.get(l)?.info.logLevel),I??this.logLevel}registerLogger(l){const I=this._loggers.get(l.resource);I?I.info.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this._loggers.set(l.resource,{info:l,logger:void 0}),this._onDidChangeLoggers.fire({added:[l],removed:[]}))}deregisterLogger(l){const I=this._loggers.get(l);I&&(I.logger&&I.logger.dispose(),this._loggers.delete(l),this._onDidChangeLoggers.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const l of this._loggers.values())yield l.info}getRegisteredLogger(l){return this._loggers.get(l)?.info}dispose(){this._loggers.forEach(l=>l.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=i;class t{constructor(){this.onDidChangeLogLevel=new N.Emitter().event}setLevel(l){}getLevel(){return w.Info}trace(l,...I){}debug(l,...I){}info(l,...I){}warn(l,...I){}error(l,...I){}critical(l,...I){}dispose(){}flush(){}}e.NullLogger=t;class s extends t{}e.NullLogService=s;function o(f){if(f.verbose)return w.Trace;if(typeof f.logLevel=="string"){const l=y(f.logLevel.toLowerCase());if(l!==void 0)return l}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function c(f){switch(f){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.LogLevelToString=c;function y(f){switch(f){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.parseLogLevel=y,e.CONTEXT_LOG_LEVEL=new C.RawContextKey("logLevel",c(w.Info))}),define(ae[190],ce([0,1,6,7,2,22,30,14,8]),function(ne,e,R,N,L,T,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=e.LogsDataCleaner=class extends L.Disposable{constructor(C,v){super(),this.environmentService=C,this.logService=v,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,T.basename)(this.environmentService.logsHome),v=(0,T.dirname)(this.environmentService.logsHome),w=(await _.Promises.readdir(v.fsPath)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==C),a=w.slice(0,Math.max(0,w.length-9));a.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${a.join(", ")}'`),await Promise.all(a.map(u=>_.Promises.rm((0,T.joinPath)(v,u).fsPath))))}catch(C){(0,N.onUnexpectedError)(C)}}};e.LogsDataCleaner=S=pe([G(0,D.IEnvironmentService),G(1,b.ILogService)],S)}),define(ae[191],ce([0,1,21,6,7,3,2,15,53,8]),function(ne,e,R,N,L,T,_,D,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends _.Disposable{constructor(v,d){super(),this.logService=v,this.options=d,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new N.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new N.ThrottledDelayer(0))}watch(v,d){return d.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,d):this.watchNonRecursive(v,d)}watchUniversal(v,d){const g={path:this.toFilePath(v),excludes:d.excludes,includes:d.includes,recursive:d.recursive},w=(0,R.insert)(this.universalPathsToWatch,g);return this.refreshUniversalWatchers(),(0,_.toDisposable)(()=>{w(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,L.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(d=>this._onDidChangeFile.fire((0,b.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const d of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const d of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(d)&&v.includes(d.path)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(v,d){const g={path:this.toFilePath(v),excludes:d.excludes,includes:d.includes,recursive:!1},w=(0,R.insert)(this.nonRecursivePathsToWatch,g);return this.refreshNonRecursiveWatchers(),(0,_.toDisposable)(()=>{w(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,L.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,b.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logService[v.type](v.message)}toFilePath(v){return(0,D.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(ae[192],ce([0,1,21,6,16,26,3,61,60,2,46,25,100,22,42,152,13,99,8,7]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let p=e.FileService=class extends S.Disposable{constructor(n){super(),this.logService=n,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new _.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new _.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new _.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new _.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new _.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new N.ResourceQueue)}registerProvider(n,r){if(this.provider.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${n}`);const i=new S.DisposableStore;return this.provider.set(n,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:n,provider:r}),i.add(r.onDidChangeFile(t=>this._onDidFilesChange.fire(new a.FileChangesEvent(t,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),i.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:n}))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:n,provider:r}),this.provider.delete(n),(0,S.dispose)(i)})}getProvider(n){return this.provider.get(n)}async activateProvider(n){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:n,join(i){r.push(i)}}),!this.provider.has(n)&&await N.Promises.settled(r)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.provider.has(n.scheme)}hasCapability(n,r){const i=this.provider.get(n.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return b.Iterable.map(this.provider,([n,r])=>({scheme:n,capabilities:r.capabilities}))}async withProvider(n){if(!(0,d.isAbsolutePath)(n))throw new a.FileOperationError((0,w.localize)(0,null,this.resourceForError(n)),8);await this.activateProvider(n.scheme);const r=this.provider.get(n.scheme);if(!r){const i=new E.ErrorNoTelemetry;throw i.message=(0,w.localize)(1,null,n.toString()),i}return r}async withReadProvider(n){const r=await this.withProvider(n);if((0,a.hasOpenReadWriteCloseCapability)(r)||(0,a.hasReadWriteCapability)(r)||(0,a.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(n){const r=await this.withProvider(n);if((0,a.hasOpenReadWriteCloseCapability)(r)||(0,a.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,r){try{return await this.doResolveFile(n,r)}catch(i){throw(0,a.toFileSystemProviderErrorCode)(i)===a.FileSystemProviderErrorCode.FileNotFound?new a.FileOperationError((0,w.localize)(2,null,this.resourceForError(n)),1):(0,a.ensureFileSystemProviderError)(i)}}async doResolveFile(n,r){const i=await this.withProvider(n),t=this.isPathCaseSensitive(i),s=r?.resolveTo,o=r?.resolveSingleChildDescendants,c=r?.resolveMetadata,y=await i.stat(n);let f;return this.toFileStat(i,n,y,void 0,!!c,(l,I)=>(f||(f=P.TernarySearchTree.forUris(()=>!t),f.set(n,!0),s&&f.fill(!0,s)),f.get(l.resource)||f.findSuperstr(l.resource.with({query:null,fragment:null}))?!0:l.isDirectory&&o?I===1:!1))}async toFileStat(n,r,i,t,s,o){const{providerExtUri:c}=this.getExtUri(n),y={resource:r,name:c.basename(r),isFile:(i.type&a.FileType.File)!==0,isDirectory:(i.type&a.FileType.Directory)!==0,isSymbolicLink:(i.type&a.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&a.FilePermission.Readonly)||!!(n.capabilities&2048),locked:!!((i.permissions??0)&a.FilePermission.Locked),etag:(0,a.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(y.isDirectory&&o(y,t)){try{const f=await n.readdir(r),l=await N.Promises.settled(f.map(async([I,A])=>{try{const F=c.joinPath(r,I),M=s?await n.stat(F):{type:A};return await this.toFileStat(n,F,M,f.length,s,o)}catch(F){return this.logService.trace(F),null}}));y.children=(0,R.coalesce)(l)}catch(f){this.logService.trace(f),y.children=[]}return y}return y}async resolveAll(n){return N.Promises.settled(n.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(n){const r=await this.withProvider(n),i=await r.stat(n);return this.toFileStat(r,n,i,void 0,!0,()=>!1)}async exists(n){const r=await this.withProvider(n);try{return!!await r.stat(n)}catch{return!1}}async canCreateFile(n,r){try{await this.doValidateCreateFile(n,r)}catch(i){return i}return!0}async doValidateCreateFile(n,r){if(!r?.overwrite&&await this.exists(n))throw new a.FileOperationError((0,w.localize)(3,null,this.resourceForError(n)),3,r)}async createFile(n,r=L.VSBuffer.fromString(""),i){await this.doValidateCreateFile(n,i);const t=await this.writeFile(n,r);return this._onDidRunOperation.fire(new a.FileOperationEvent(n,0,t)),t}async writeFile(n,r,i){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),{providerExtUri:s}=this.getExtUri(t);try{await this.validateWriteFile(t,n,i)||await this.mkdirp(t,s.dirname(n));let c;if((0,a.hasReadWriteCapability)(t)&&!(r instanceof L.VSBuffer))if((0,g.isReadableStream)(r)){const y=await(0,g.peekStream)(r,3);y.ended?c=L.VSBuffer.concat(y.buffer):c=y}else c=(0,g.peekReadable)(r,y=>L.VSBuffer.concat(y),3);else c=r;if(!(0,a.hasOpenReadWriteCloseCapability)(t)||(0,a.hasReadWriteCapability)(t)&&c instanceof L.VSBuffer)await this.doWriteUnbuffered(t,n,i,c);else{const y=c instanceof L.VSBuffer?(0,L.bufferToReadable)(c):c;i?.atomic!==!1&&i?.atomic?.postfix?await this.doWriteBufferedAtomic(t,n,(0,d.joinPath)((0,d.dirname)(n),`${(0,d.basename)(n)}${i.atomic.postfix}`),i,y):await this.doWriteBuffered(t,n,i,y)}this._onDidRunOperation.fire(new a.FileOperationEvent(n,4))}catch(o){throw new a.FileOperationError((0,w.localize)(4,null,this.resourceForError(n),(0,a.ensureFileSystemProviderError)(o).toString()),(0,a.toFileOperationResult)(o),i)}return this.resolve(n,{resolveMetadata:!0})}async validateWriteFile(n,r,i){const t=!!i?.unlock;if(t&&!(n.capabilities&8192))throw new Error((0,w.localize)(5,null,this.resourceForError(r)));if(!!i?.atomic){if(!(n.capabilities&32768))throw new Error((0,w.localize)(6,null,this.resourceForError(r)));if(t)throw new Error((0,w.localize)(7,null,this.resourceForError(r)))}let o;try{o=await n.stat(r)}catch{return}if(o.type&a.FileType.Directory)throw new a.FileOperationError((0,w.localize)(8,null,this.resourceForError(r)),0,i);if(this.throwIfFileIsReadonly(r,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==a.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,a.etag)({mtime:i.mtime,size:o.size}))throw new a.FileOperationError((0,w.localize)(9,null),3,i);return o}async readFile(n,r,i){const t=await this.withReadProvider(n);return r?.atomic?this.doReadFileAtomic(t,n,r,i):this.doReadFile(t,n,r,i)}async doReadFileAtomic(n,r,i,t){return new Promise((s,o)=>{this.writeQueue.queueFor(r,this.getExtUri(n).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(n,r,i,t);s(c)}catch(c){o(c)}})})}async doReadFile(n,r,i,t){const s=await this.doReadFileStream(n,r,{...i,preferUnbuffered:!0},t);return{...s,value:await(0,L.streamToBuffer)(s.value)}}async readFileStream(n,r,i){const t=await this.withReadProvider(n);return this.doReadFileStream(t,n,r,i)}async doReadFileStream(n,r,i,t){const s=new T.CancellationTokenSource(t),o=this.validateReadFile(r,i).then(y=>y,y=>{throw s.cancel(),y});let c;try{return typeof i?.etag=="string"&&i.etag!==a.ETAG_DISABLED&&await o,i?.atomic&&(0,a.hasFileAtomicReadCapability)(n)||!((0,a.hasOpenReadWriteCloseCapability)(n)||(0,a.hasFileReadStreamCapability)(n))||(0,a.hasReadWriteCapability)(n)&&i?.preferUnbuffered?c=this.readFileUnbuffered(n,r,i):(0,a.hasFileReadStreamCapability)(n)?c=this.readFileStreamed(n,r,s.token,i):c=this.readFileBuffered(n,r,s.token,i),{...await o,value:c}}catch(y){throw c&&await(0,g.consumeStream)(c),this.restoreReadError(y,r,i)}}restoreReadError(n,r,i){const t=(0,w.localize)(10,null,this.resourceForError(r),(0,a.ensureFileSystemProviderError)(n).toString());return n instanceof a.NotModifiedSinceFileOperationError?new a.NotModifiedSinceFileOperationError(t,n.stat,i):n instanceof a.TooLargeFileOperationError?new a.TooLargeFileOperationError(t,n.fileOperationResult,n.size,n.options):new a.FileOperationError(t,(0,a.toFileOperationResult)(n),i)}readFileStreamed(n,r,i,t=Object.create(null)){const s=n.readFileStream(r,t,i);return(0,g.transform)(s,{data:o=>o instanceof L.VSBuffer?o:L.VSBuffer.wrap(o),error:o=>this.restoreReadError(o,r,t)},o=>L.VSBuffer.concat(o))}readFileBuffered(n,r,i,t=Object.create(null)){const s=(0,L.newWriteableBufferStream)();return(0,u.readFileIntoStream)(n,r,s,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>this.restoreReadError(o,r,t)},i),s}readFileUnbuffered(n,r,i){const t=(0,g.newWriteableStream)(s=>L.VSBuffer.concat(s));return(async()=>{try{let s;i?.atomic&&(0,a.hasFileAtomicReadCapability)(n)?s=await n.readFile(r,{atomic:!0}):s=await n.readFile(r),typeof i?.position=="number"&&(s=s.slice(i.position)),typeof i?.length=="number"&&(s=s.slice(0,i.length)),this.validateReadFileLimits(r,s.byteLength,i),t.end(L.VSBuffer.wrap(s))}catch(s){t.error(s),t.end()}})(),t}async validateReadFile(n,r){const i=await this.resolve(n,{resolveMetadata:!0});if(i.isDirectory)throw new a.FileOperationError((0,w.localize)(11,null,this.resourceForError(n)),0,r);if(typeof r?.etag=="string"&&r.etag!==a.ETAG_DISABLED&&r.etag===i.etag)throw new a.NotModifiedSinceFileOperationError((0,w.localize)(12,null),i,r);return this.validateReadFileLimits(n,i.size,r),i}validateReadFileLimits(n,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new a.TooLargeFileOperationError((0,w.localize)(13,null,this.resourceForError(n)),7,r,i)}async canMove(n,r,i){return this.doCanMoveCopy(n,r,"move",i)}async canCopy(n,r,i){return this.doCanMoveCopy(n,r,"copy",i)}async doCanMoveCopy(n,r,i,t){if(n.toString()!==r.toString())try{const s=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n):await this.withReadProvider(n),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(s,n,o,r,i,t)}catch(s){return s}return!0}async move(n,r,i){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(t,n,s,r,"move",!!i),c=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(n,o==="move"?2:3,c)),c}async copy(n,r,i){const t=await this.withReadProvider(n),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(t,n,s,r,"copy",!!i),c=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(n,o==="copy"?3:2,c)),c}async doMoveCopy(n,r,i,t,s,o){if(r.toString()===t.toString())return s;const{exists:c,isSameResourceWithDifferentPathCase:y}=await this.doValidateMoveCopy(n,r,i,t,s,o);if(c&&!y&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(t)),s==="copy"){if(n===i&&(0,a.hasFileFolderCopyCapability)(n))await n.copy(r,t,{overwrite:o});else{const f=await this.resolve(r);f.isDirectory?await this.doCopyFolder(n,f,i,t):await this.doCopyFile(n,r,i,t)}return s}else return n===i?(await n.rename(r,t,{overwrite:o}),s):(await this.doMoveCopy(n,r,i,t,"copy",o),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(n,r,i,t){if((0,a.hasOpenReadWriteCloseCapability)(n)&&(0,a.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(n,r,i,t);if((0,a.hasOpenReadWriteCloseCapability)(n)&&(0,a.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(n,r,i,t);if((0,a.hasReadWriteCapability)(n)&&(0,a.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(n,r,i,t);if((0,a.hasReadWriteCapability)(n)&&(0,a.hasReadWriteCapability)(i))return this.doPipeUnbuffered(n,r,i,t)}async doCopyFolder(n,r,i,t){await i.mkdir(t),Array.isArray(r.children)&&await N.Promises.settled(r.children.map(async s=>{const o=this.getExtUri(i).providerExtUri.joinPath(t,s.name);return s.isDirectory?this.doCopyFolder(n,await this.resolve(s.resource),i,o):this.doCopyFile(n,s.resource,i,o)}))}async doValidateMoveCopy(n,r,i,t,s,o){let c=!1;if(n===i){const{providerExtUri:f,isPathCaseSensitive:l}=this.getExtUri(n);if(l||(c=f.isEqual(r,t)),c&&s==="copy")throw new Error((0,w.localize)(14,null,this.resourceForError(r),this.resourceForError(t)));if(!c&&f.isEqualOrParent(t,r))throw new Error((0,w.localize)(15,null,this.resourceForError(r),this.resourceForError(t)))}const y=await this.exists(t);if(y&&!c){if(!o)throw new a.FileOperationError((0,w.localize)(16,null,this.resourceForError(r),this.resourceForError(t)),4);if(n===i){const{providerExtUri:f}=this.getExtUri(n);if(f.isEqualOrParent(r,t))throw new Error((0,w.localize)(17,null,this.resourceForError(r),this.resourceForError(t)))}}return{exists:y,isSameResourceWithDifferentPathCase:c}}getExtUri(n){const r=this.isPathCaseSensitive(n);return{providerExtUri:r?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(n){return!!(n.capabilities&1024)}async createFolder(n){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(n),n);await this.mkdirp(r,n);const i=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(n,0,i)),i}async mkdirp(n,r){const i=[],{providerExtUri:t}=this.getExtUri(n);for(;!t.isEqual(r,t.dirname(r));)try{if(!((await n.stat(r)).type&a.FileType.Directory))throw new Error((0,w.localize)(18,null,this.resourceForError(r)));break}catch(s){if((0,a.toFileSystemProviderErrorCode)(s)!==a.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(t.basename(r)),r=t.dirname(r)}for(let s=i.length-1;s>=0;s--){r=t.joinPath(r,i[s]);try{await n.mkdir(r)}catch(o){if((0,a.toFileSystemProviderErrorCode)(o)!==a.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(n,r){try{await this.doValidateDelete(n,r)}catch(i){return i}return!0}async doValidateDelete(n,r){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(n),n),t=!!r?.useTrash;if(t&&!(i.capabilities&4096))throw new Error((0,w.localize)(19,null,this.resourceForError(n)));const s=r?.atomic;if(s&&!(i.capabilities&65536))throw new Error((0,w.localize)(20,null,this.resourceForError(n)));if(t&&s)throw new Error((0,w.localize)(21,null,this.resourceForError(n)));let o;try{o=await i.stat(n)}catch{}if(o)this.throwIfFileIsReadonly(n,o);else throw new a.FileOperationError((0,w.localize)(22,null,this.resourceForError(n)),1);if(!!!r?.recursive){const y=await this.resolve(n);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,w.localize)(23,null,this.resourceForError(n)))}return i}async del(n,r){const i=await this.doValidateDelete(n,r),t=!!r?.useTrash,s=!!r?.recursive,o=r?.atomic??!1;await i.delete(n,{recursive:s,useTrash:t,atomic:o}),this._onDidRunOperation.fire(new a.FileOperationEvent(n,1))}async cloneFile(n,r){const i=await this.withProvider(n),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);if(i===t&&this.getExtUri(i).providerExtUri.isEqual(n,r))return;if(i===t&&(0,a.hasFileCloneCapability)(i))return i.cloneFile(n,r);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r));const s=this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri);return i===t&&(0,a.hasFileFolderCopyCapability)(i)?s.queue(()=>i.copy(n,r,{overwrite:!0})):s.queue(()=>this.doCopyFile(i,n,t,r))}watch(n,r={recursive:!1,excludes:[]}){const i=new S.DisposableStore;let t=!1,s=()=>{t=!0};return i.add((0,S.toDisposable)(()=>s())),(async()=>{try{const o=await this.doWatch(n,r);t?(0,S.dispose)(o):s=()=>(0,S.dispose)(o)}catch(o){this.logService.error(o)}})(),i}async doWatch(n,r){const i=await this.withProvider(n),t=(0,D.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(n),r]);let s=this.activeWatchers.get(t);return s||(s={count:0,disposable:i.watch(n,r)},this.activeWatchers.set(t,s)),s.count+=1,(0,S.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,S.dispose)(s.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,n]of this.activeWatchers)(0,S.dispose)(n.disposable);this.activeWatchers.clear()}async doWriteBufferedAtomic(n,r,i,t,s){await this.doWriteBuffered(n,i,t,s);try{await n.rename(i,r,{overwrite:!0})}catch(o){try{await n.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}async doWriteBuffered(n,r,i,t){return this.writeQueue.queueFor(r,this.getExtUri(n).providerExtUri).queue(async()=>{const s=await n.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,g.isReadableStream)(t)||(0,g.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(n,s,t):await this.doWriteReadableBufferedQueued(n,s,t)}catch(o){throw(0,a.ensureFileSystemProviderError)(o)}finally{await n.close(s)}})}async doWriteStreamBufferedQueued(n,r,i){let t=0,s;if((0,g.isReadableBufferedStream)(i)){if(i.buffer.length>0){const o=L.VSBuffer.concat(i.buffer);await this.doWriteBuffer(n,r,o,o.byteLength,t,0),t+=o.byteLength}if(i.ended)return;s=i.stream}else s=i;return new Promise((o,c)=>{(0,g.listenStream)(s,{onData:async y=>{s.pause();try{await this.doWriteBuffer(n,r,y,y.byteLength,t,0)}catch(f){return c(f)}t+=y.byteLength,setTimeout(()=>s.resume())},onError:y=>c(y),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(n,r,i){let t=0,s;for(;(s=i.read())!==null;)await this.doWriteBuffer(n,r,s,s.byteLength,t,0),t+=s.byteLength}async doWriteBuffer(n,r,i,t,s,o){let c=0;for(;c<t;){const y=await n.write(r,s+c,i.buffer,o+c,t-c);c+=y}}async doWriteUnbuffered(n,r,i,t){return this.writeQueue.queueFor(r,this.getExtUri(n).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(n,r,i,t))}async doWriteUnbufferedQueued(n,r,i,t){let s;t instanceof L.VSBuffer?s=t:(0,g.isReadableStream)(t)?s=await(0,L.streamToBuffer)(t):(0,g.isReadableBufferedStream)(t)?s=await(0,L.bufferedStreamToBuffer)(t):s=(0,L.readableToBuffer)(t),await n.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async doPipeBuffered(n,r,i,t){return this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(n,r,i,t))}async doPipeBufferedQueued(n,r,i,t){let s,o;try{s=await n.open(r,{create:!1}),o=await i.open(t,{create:!0,unlock:!1});const c=L.VSBuffer.alloc(this.BUFFER_SIZE);let y=0,f=0,l=0;do l=await n.read(s,y,c.buffer,f,c.byteLength-f),await this.doWriteBuffer(i,o,c,l,y,f),y+=l,f+=l,f===c.byteLength&&(f=0);while(l>0)}catch(c){throw(0,a.ensureFileSystemProviderError)(c)}finally{await N.Promises.settled([typeof s=="number"?n.close(s):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async doPipeUnbuffered(n,r,i,t){return this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(n,r,i,t))}async doPipeUnbufferedQueued(n,r,i,t){return i.writeFile(t,await n.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(n,r,i,t){return this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(n,r,i,t))}async doPipeUnbufferedToBufferedQueued(n,r,i,t){const s=await i.open(t,{create:!0,unlock:!1});try{const o=await n.readFile(r);await this.doWriteBuffer(i,s,L.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,a.ensureFileSystemProviderError)(o)}finally{await i.close(s)}}async doPipeBufferedToUnbuffered(n,r,i,t){const s=await(0,L.streamToBuffer)(this.readFileBuffered(n,r,T.CancellationToken.None));await this.doWriteUnbuffered(i,t,void 0,s)}throwIfFileSystemIsReadonly(n,r){if(n.capabilities&2048)throw new a.FileOperationError((0,w.localize)(24,null,this.resourceForError(r)),6);return n}throwIfFileIsReadonly(n,r){if((r.permissions??0)&a.FilePermission.Readonly)throw new a.FileOperationError((0,w.localize)(25,null,this.resourceForError(n)),6)}resourceForError(n){return n.scheme===C.Schemas.file?n.fsPath:n.toString(!0)}};e.FileService=p=pe([G(0,h.ILogService)],p)}),define(ae[193],ce([0,1,51,263,6,35,16,3,47,2,15,5,22,42,30,155,13,99,191,38,187,186]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u,h,E,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,N.gracefulify)(R)}catch(r){console.error(`Error enabling graceful-fs: ${(0,E.toErrorMessage)(r)}`)}})();class n extends h.AbstractDiskFileSystemProvider{constructor(i,t){super(i,t),this.onDidChangeCapabilities=D.Event.None,this.resourceLocks=new T.ResourceMap(s=>v.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:t,symbolicLink:s}=await g.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:a.FilePermission.Locked}}catch(t){throw this.toFileSystemProviderError(t)}}async statIgnoreError(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const t=await g.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async o=>{try{let c;o.isSymbolicLink()?c=(await this.stat((0,v.joinPath)(i,o.name))).type:c=this.toType(o),s.push([o.name,c])}catch(c){this.logService.trace(c)}})),s}catch(t){throw this.toFileSystemProviderError(t)}}toType(i,t){let s;return t?.dangling?s=a.FileType.Unknown:i.isFile()?s=a.FileType.File:i.isDirectory()?s=a.FileType.Directory:s=a.FileType.Unknown,t&&(s|=a.FileType.SymbolicLink),s}async createResourceLock(i){const t=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let s;for(;s=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await s.wait();const o=new L.Barrier;return this.resourceLocks.set(i,o),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,S.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.resourceLocks.get(i)===o&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),o.open()})}async readFile(i,t){let s;try{t?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),s=await this.createResourceLock(i));const o=this.toFilePath(i);return await g.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{s?.dispose()}}traceLock(i){n.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,t,s){const o=(0,d.newWriteableStream)(c=>_.VSBuffer.concat(c.map(y=>_.VSBuffer.wrap(y))).buffer);return(0,u.readFileIntoStream)(this,i,o,c=>c.buffer,{...t,bufferSize:256*1024},s),o}async writeFile(i,t,s){return s?.atomic!==!1&&s?.atomic?.postfix?this.doWriteFileAtomic(i,(0,v.joinPath)((0,v.dirname)(i),`${(0,v.basename)(i)}${s.atomic.postfix}`),t,s):this.doWriteFile(i,t,s)}async doWriteFileAtomic(i,t,s,o){await this.doWriteFile(t,s,o);try{await this.rename(t,i,{overwrite:!0})}catch(c){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw c}}async doWriteFile(i,t,s){let o;try{const c=this.toFilePath(i);if(!s.create||!s.overwrite){if(await g.Promises.exists(c)){if(!s.overwrite)throw(0,a.createFileSystemProviderError)((0,w.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,a.createFileSystemProviderError)((0,w.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(o,0,t,0,t.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(i,c)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(i){n.canFlush=i}async open(i,t){const s=this.toFilePath(i);let o;(0,a.isFileOpenForWriteOptions)(t)&&(o=await this.createResourceLock(i));let c;try{if((0,a.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:f}=await g.SymlinkSupport.stat(s);f.mode&128||await g.Promises.chmod(s,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.logService.trace(f)}let y;if((0,a.isFileOpenForWriteOptions)(t)){if(C.isWindows)try{await g.Promises.truncate(s,0),y="r+"}catch(f){f.code!=="ENOENT"&&this.logService.trace(f)}y||(y="w")}else y="r";c=await g.Promises.open(s,y)}catch(y){throw o?.dispose(),(0,a.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(i,y):this.toFileSystemProviderError(y)}if(this.mapHandleToPos.set(c,0),(0,a.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(c,i),o){const y=this.mapHandleToLock.get(c);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${s})`),this.mapHandleToLock.set(c,o),y&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${s})`),y.dispose())}return c}async close(i){const t=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&n.canFlush)try{await g.Promises.fdatasync(i)}catch(s){n.configureFlushOnWrite(!1),this.logService.error(s)}return await g.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}finally{t&&(this.mapHandleToLock.get(i)===t&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),t.dispose())}}async read(i,t,s,o,c){const y=this.normalizePos(i,t);let f=null;try{f=(await g.Promises.read(i,s,o,c,y)).bytesRead}catch(l){throw this.toFileSystemProviderError(l)}finally{this.updatePos(i,y,f)}return f}normalizePos(i,t){return t===this.mapHandleToPos.get(i)?null:t}updatePos(i,t,s){const o=this.mapHandleToPos.get(i);typeof o=="number"&&(typeof t=="number"||(typeof s=="number"?this.mapHandleToPos.set(i,o+s):this.mapHandleToPos.delete(i)))}async write(i,t,s,o,c){return(0,L.retry)(()=>this.doWrite(i,t,s,o,c),100,3)}async doWrite(i,t,s,o,c){const y=this.normalizePos(i,t);let f=null;try{f=(await g.Promises.write(i,s,o,c,y)).bytesWritten}catch(l){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),l)}finally{this.updatePos(i,y,f)}return f}async mkdir(i){try{await g.Promises.mkdir(this.toFilePath(i))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(i,t){try{const s=this.toFilePath(i);if(t.recursive){let o;t?.atomic!==!1&&t.atomic.postfix&&(o=(0,P.join)((0,P.dirname)(s),`${(0,P.basename)(s)}${t.atomic.postfix}`)),await g.Promises.rm(s,g.RimRafMode.MOVE,o)}else try{await g.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let c=!1;try{const{stat:y,symbolicLink:f}=await g.SymlinkSupport.stat(s);c=y.isDirectory()&&!f}catch{}if(c)await g.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.toFileSystemProviderError(s)}}async rename(i,t,s){const o=this.toFilePath(i),c=this.toFilePath(t);if(o!==c)try{await this.validateMoveCopy(i,t,"move",s.overwrite),await g.Promises.move(o,c)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,w.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(c)),y.toString()))),this.toFileSystemProviderError(y)}}async copy(i,t,s){const o=this.toFilePath(i),c=this.toFilePath(t);if(o!==c)try{await this.validateMoveCopy(i,t,"copy",s.overwrite),await g.Promises.copy(o,c,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,w.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(c)),y.toString()))),this.toFileSystemProviderError(y)}}async validateMoveCopy(i,t,s,o){const c=this.toFilePath(i),y=this.toFilePath(t);let f=!1;if(!!(this.capabilities&1024)||(f=(0,b.isEqual)(c,y,!0)),f){if(s==="copy")throw(0,a.createFileSystemProviderError)((0,w.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const I=await this.statIgnoreError(i);if(!I)throw(0,a.createFileSystemProviderError)((0,w.localize)(5,null),a.FileSystemProviderErrorCode.FileNotFound);const A=await this.statIgnoreError(t);if(A){if(!o)throw(0,a.createFileSystemProviderError)((0,w.localize)(6,null),a.FileSystemProviderErrorCode.FileExists);I.type&a.FileType.File&&A.type&a.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,t){return this.doCloneFile(i,t,!1)}async doCloneFile(i,t,s){const o=this.toFilePath(i),c=this.toFilePath(t),y=!!(this.capabilities&1024);if((0,b.isEqual)(o,c,!y))return;const f=new S.DisposableStore;try{const[l,I]=await Promise.all([this.createResourceLock(i),this.createResourceLock(t)]);f.add(l),f.add(I),s&&await g.Promises.mkdir((0,P.dirname)(c),{recursive:!0}),await g.Promises.copyFile(o,c)}catch(l){if(l.code==="ENOENT"&&!s)return this.doCloneFile(i,t,!0);throw this.toFileSystemProviderError(l)}finally{f.dispose()}}createUniversalWatcher(i,t,s){return new p.UniversalWatcherClient(o=>i(o),o=>t(o),s)}createNonRecursiveWatcher(i,t,s){return new k.NodeJSWatcherClient(o=>i(o),o=>t(o),s)}toFileSystemProviderError(i){if(i instanceof a.FileSystemProviderError)return i;let t=i,s;switch(i.code){case"ENOENT":s=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=a.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=a.FileSystemProviderErrorCode.Unknown;break;default:s=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(t,s)}async toFileSystemProviderWriteError(i,t){let s=this.toFileSystemProviderError(t);if(i&&s.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await g.SymlinkSupport.stat(this.toFilePath(i));o.mode&128||(s=(0,a.createFileSystemProviderError)(t,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return s}}e.DiskFileSystemProvider=n,n.TRACE_LOG_RESOURCE_LOCKS=!1,n.canFlush=!0}),define(ae[101],ce([0,1,3,2,4,8]),function(ne,e,R,N,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,L.createDecorator)("sharedProcessLifecycleService");let _=e.SharedProcessLifecycleService=class extends N.Disposable{constructor(b){super(),this.logService=b,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};e.SharedProcessLifecycleService=_=pe([G(0,T.ILogService)],_)}),define(ae[194],ce([0,1,12,3,8,2]),function(ne,e,R,N,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class _ extends L.AbstractLoggerService{constructor(C,v,d,g,w){super(v,d,g),this.windowId=C,this.channel=w,this._register(w.listen("onDidChangeLogLevel",C)(a=>{(0,L.isLogLevel)(a)?super.setLogLevel(a):super.setLogLevel(R.URI.revive(a[0]),a[1])})),this._register(w.listen("onDidChangeVisibility",C)(([a,u])=>super.setVisibility(R.URI.revive(a),u))),this._register(w.listen("onDidChangeLoggers",C)(({added:a,removed:u})=>{for(const h of a)super.registerLogger({...h,resource:R.URI.revive(h.resource)});for(const h of u)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new L.AdapterLogger({log:(C,v)=>{this.channel.call("consoleLog",[C,v])}})}registerLogger(C){super.registerLogger(C),this.channel.call("registerLogger",[C,this.windowId])}deregisterLogger(C){super.deregisterLogger(C),this.channel.call("deregisterLogger",[C,this.windowId])}setLogLevel(C,v){super.setLogLevel(C,v),this.channel.call("setLogLevel",[C,v])}setVisibility(C,v){super.setVisibility(C,v),this.channel.call("setVisibility",[this.toResource(C),v])}doCreateLogger(C,v,d){return new D(this.channel,C,v,d,this.windowId)}static setLogLevel(C,v,d){return C.call("setLogLevel",[v,d])}}e.LoggerChannelClient=_;class D extends L.AbstractMessageLogger{constructor(C,v,d,g,w){super(g?.logLevel==="always"),this.channel=C,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[v,g,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(C,v){const d=[[C,v]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(C){this.channel.call("log",[this.file,C])}}class b{constructor(C,v){this.loggerService=C,this.getUriTransformer=v}listen(C,v){const d=this.getUriTransformer(C);switch(v){case"onDidChangeLoggers":return N.Event.map(this.loggerService.onDidChangeLoggers,g=>({added:[...g.added].map(w=>this.transformLogger(w,d)),removed:[...g.removed].map(w=>this.transformLogger(w,d))}));case"onDidChangeVisibility":return N.Event.map(this.loggerService.onDidChangeVisibility,g=>[d.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return N.Event.map(this.loggerService.onDidChangeLogLevel,g=>(0,L.isLogLevel)(g)?g:[d.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${v}`)}async call(C,v,d){const g=this.getUriTransformer(C);switch(v){case"setLogLevel":return(0,L.isLogLevel)(d[0])?this.loggerService.setLogLevel(d[0]):this.loggerService.setLogLevel(R.URI.revive(g.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(w=>this.transformLogger(w,g)))}throw new Error(`Call not found: ${v}`)}transformLogger(C,v){return{...C,resource:v.transformOutgoingURI(C.resource)}}}e.LoggerChannel=b;class S extends T.Disposable{constructor(C,v){super(),v.call("setLogLevel",[C.getLogLevel()]),this._register(C.onDidChangeLogLevel(d=>v.call("setLogLevel",[d]))),v.call("getRegisteredLoggers").then(d=>{for(const g of d)C.registerLogger({...g,resource:R.URI.revive(g.resource)})}),this._register(v.listen("onDidChangeVisibility")(([d,g])=>C.setVisibility(R.URI.revive(d),g))),this._register(v.listen("onDidChangeLoggers")(({added:d,removed:g})=>{for(const w of d)C.registerLogger({...w,resource:R.URI.revive(w.resource)});for(const w of g)C.deregisterLogger(w.resource)}))}}e.RemoteLoggerChannelClient=S}),define(ae[195],ce([0,1,2,8]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class L extends R.Disposable{constructor(_,D=[]){super(),this.logger=new N.MultiplexLogger([_,...D]),this._register(_.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(_){this.logger.setLevel(_)}getLevel(){return this.logger.getLevel()}trace(_,...D){this.logger.trace(_,...D)}debug(_,...D){this.logger.debug(_,...D)}info(_,...D){this.logger.info(_,...D)}warn(_,...D){this.logger.warn(_,...D)}error(_,...D){this.logger.error(_,...D)}flush(){this.logger.flush()}}e.LogService=L}),define(ae[54],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(ae[55],ce([0,1,3,60,2,4]),function(ne,e,R,N,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class _ extends L.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(S){const P=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...S,...this.policyDefinitions},P!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(S),N.Iterable.reduce(this.policies.entries(),(C,[v,d])=>({...C,[v]:d}),{})}getPolicyValue(S){return this.policies.get(S)}serialize(){return N.Iterable.reduce(Object.entries(this.policyDefinitions),(S,[P,C])=>({...S,[P]:{definition:C,value:this.policies.get(P)}}),{})}}e.AbstractPolicyService=_;class D{constructor(){this.onDidChange=R.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=D}),define(ae[196],ce([0,1,3,2,55]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class T{constructor(b){this.service=b,this.disposables=new N.DisposableStore}listen(b,S){switch(S){case"onDidChange":return R.Event.map(this.service.onDidChange,P=>P.reduce((C,v)=>({...C,[v]:this.service.getPolicyValue(v)??null}),{}),this.disposables)}throw new Error(`Event not found: ${S}`)}call(b,S,P){switch(S){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${S}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=T;class _ extends L.AbstractPolicyService{constructor(b,S){super(),this.channel=S;for(const P in b){const{definition:C,value:v}=b[P];this.policyDefinitions[P]=C,v!==void 0&&this.policies.set(P,v)}this.channel.listen("onDidChange")(P=>{for(const C in P){const v=P[C];v===null?this.policies.delete(C):this.policies.set(C,v)}this._onDidChange.fire(Object.keys(P))})}async _updatePolicyDefinitions(b){const S=await this.channel.call("updatePolicyDefinitions",b);for(const P in S)this.policies.set(P,S[P])}}e.PolicyChannelClient=_}),define(ae[102],ce([0,1,5,37]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;if(typeof R.globals.vscode<"u"&&typeof R.globals.vscode.context<"u"){const T=R.globals.vscode.context.configuration();if(T)L=T.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){L=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:T,searchUrl:_,itemUrl:D,controlUrl:b}=L.extensionsGallery||{};Object.assign(L,{extensionsGallery:{serviceUrl:N.env.VSCODE_GALLERY_SERVICE_URL||T,searchUrl:N.env.VSCODE_GALLERY_SEARCH_URL||_,itemUrl:N.env.VSCODE_GALLERY_ITEM_URL||D,controlUrl:N.env.VSCODE_GALLERY_CONTROL_URL||b}});try{const S=(...C)=>C.reduce((v,d)=>(Object.keys(d).forEach(g=>{Array.isArray(v[g])&&Array.isArray(d[g])?v[g]=d[g]:typeof v[g]=="object"&&typeof d[g]=="object"?v[g]=S(v[g],d[g]):v[g]=d[g]}),v),{}),P=globalThis._VSCODE_USER_PRODUCT_JSON||{};L=S(L,P)}catch{}if(N.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const S=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:S.version,release:S.release})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.80.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(ae[24],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ae[197],ce([0,1,6,7,2,15,30,8,24]),function(ne,e,R,N,L,T,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let S=e.CodeCacheCleaner=class extends L.Disposable{constructor(C,v,d){super(),this.productService=v,this.logService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},3e4)).schedule()}async cleanUpCodeCaches(C){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const v=Date.now(),d=(0,T.dirname)(C),g=(0,T.basename)(C),w=await _.Promises.readdir(d);await Promise.all(w.map(async a=>{if(a===g)return;const u=(0,T.join)(d,a),h=await _.Promises.stat(u);if(h.isDirectory()&&v-h.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${a}.`),_.Promises.rm(u)}))}catch(v){(0,N.onUnexpectedError)(v)}}};e.CodeCacheCleaner=S=pe([G(1,b.IProductService),G(2,D.ILogService)],S)}),define(ae[198],ce([0,1,6,7,2,15,30,14,8,24]),function(ne,e,R,N,L,T,_,D,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=e.LanguagePackCachedDataCleaner=class extends L.Disposable{constructor(v,d,g){super(),this.environmentService=v,this.logService=d,this.productService=g,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const v=Object.create(null),d=JSON.parse(await _.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const h of Object.keys(d)){const E=d[h];v[`${E.hash}.${h}`]=!0}const g=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await _.Promises.exists(g))return;const a=await _.Promises.readdir(g);for(const h of a){if(v[h]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${h}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${h}`),await _.Promises.rm((0,T.join)(g,h))}const u=Date.now();for(const h of Object.keys(v)){const E=(0,T.join)(g,h),p=await _.Promises.readdir(E);for(const k of p){if(k==="tcf.json")continue;const n=(0,T.join)(E,k),r=await _.Promises.stat(n);r.isDirectory()&&u-r.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(h,k)}`),await _.Promises.rm(n))}}}catch(v){(0,N.onUnexpectedError)(v)}}};e.LanguagePackCachedDataCleaner=P=pe([G(0,D.INativeEnvironmentService),G(1,b.ILogService),G(2,S.IProductService)],P)}),define(ae[199],ce([0,1,15,4]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,N.createDecorator)("IV8InspectProfilingService");var L;(function(T){function _(b){return!!(b.samples&&b.timeDeltas)}T.isValidProfile=_;function D(b,S="noAbsolutePaths"){for(const P of b.nodes)P.callFrame&&P.callFrame.url&&((0,R.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,R.join)(S,(0,R.basename)(P.callFrame.url)));return b}T.rewriteAbsolutePaths=D})(L||(e.Utils=L={}))}),define(ae[200],ce([0,1,32]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class N{constructor(){this._sessions=new Map}async startProfiling(T){const D=await(await new Promise((S,P)=>{ne(["v8-inspect-profiler"],S,P)})).startProfiling({port:T.port,checkForPaused:!0}),b=(0,R.generateUuid)();return this._sessions.set(b,D),b}async stopProfiling(T){const _=this._sessions.get(T);if(!_)throw new Error(`UNKNOWN session '${T}'`);const D=await _.stop();return this._sessions.delete(T),D.profile}}e.InspectProfilingService=N}),define(ae[40],ce([0,1,122,10]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(_,D){R.ok(N.isString(_)),R.ok(N.isObject(D)),R.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,D)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new L}),define(ae[103],ce([0,1,3,40]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class T{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,S){this.schemasById[L(b)]=S,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new T;N.Registry.add(e.Extensions.JSONContribution,_)}),define(ae[48],ce([0,1,21,3,10,142,18,103,40]),function(ne,e,R,N,L,T,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(S||(e.EditPresentationTypes=S={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=b.Registry.as(D.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new N.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new N.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const i=new Set;this.doRegisterConfigurations(n,r,i),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(n){const r=new Set;this.doDeregisterConfigurations(n,r),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:n,remove:r}){const i=new Set;this.doDeregisterConfigurations(r,i),this.doRegisterConfigurations(n,!1,i),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}registerDefaultConfigurations(n){const r=new Set;this.doRegisterDefaultConfigurations(n,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doRegisterDefaultConfigurations(n,r){const i=[];for(const{overrides:t,source:s}of n)for(const o in t)if(r.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const c=this.configurationDefaultsOverrides.get(o),y=c?.valuesSources??new Map;if(s)for(const A of Object.keys(t[o]))y.set(A,s);const f={...c?.value||{},...t[o]};this.configurationDefaultsOverrides.set(o,{source:s,value:f,valuesSources:y});const l=(0,_.getLanguageTagSettingPlainKey)(o),I={type:"object",default:f,description:T.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:L.isString(s)?void 0:s,defaultValueSource:s};i.push(...w(o)),this.configurationProperties[o]=I,this.defaultLanguageConfigurationOverridesNode.properties[o]=I}else{this.configurationDefaultsOverrides.set(o,{value:t[o],source:s});const c=this.configurationProperties[o];c&&(this.updatePropertyDefaultValue(o,c),this.updateSchema(o,c))}this.doRegisterOverrideIdentifiers(i)}deregisterDefaultConfigurations(n){const r=new Set;this.doDeregisterDefaultConfigurations(n,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(n,r){for(const{overrides:i,source:t}of n)for(const s in i){const o=this.configurationDefaultsOverrides.get(s),c=L.isString(t)?t:t?.id,y=L.isString(o?.source)?o?.source:o?.source?.id;if(c===y)if(r.add(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const f=this.configurationProperties[s];f&&(this.updatePropertyDefaultValue(s,f),this.updateSchema(s,f))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(n){let r=!1;const i=new Set;n.removedDefaults&&(this.doDeregisterDefaultConfigurations(n.removedDefaults,i),r=!0),n.addedDefaults&&(this.doRegisterDefaultConfigurations(n.addedDefaults,i),r=!0),n.removedConfigurations&&this.doDeregisterConfigurations(n.removedConfigurations,i),n.addedConfigurations&&this.doRegisterConfigurations(n.addedConfigurations,!1,i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){this.doRegisterOverrideIdentifiers(n),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(n){for(const r of n)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,r,i){n.forEach(t=>{this.validateAndRegisterProperties(t,r,t.extensionInfo,t.restrictedProperties,void 0,i),this.configurationContributors.push(t),this.registerJSONConfiguration(t)})}doDeregisterConfigurations(n,r){const i=t=>{if(t.properties)for(const s in t.properties){r.add(s);const o=this.configurationProperties[s];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,t.properties[s])}t.allOf?.forEach(s=>i(s))};for(const t of n){i(t);const s=this.configurationContributors.indexOf(t);s!==-1&&this.configurationContributors.splice(s,1)}}validateAndRegisterProperties(n,r=!0,i,t,s=3,o){s=L.isUndefinedOrNull(n.scope)?s:n.scope;const c=n.properties;if(c)for(const f in c){const l=c[f];if(r&&E(f,l)){delete c[f];continue}if(l.source=i,l.defaultDefaultValue=c[f].default,this.updatePropertyDefaultValue(f,l),e.OVERRIDE_PROPERTY_REGEX.test(f)?l.scope=void 0:(l.scope=L.isUndefinedOrNull(l.scope)?s:l.scope,l.restricted=L.isUndefinedOrNull(l.restricted)?!!t?.includes(f):l.restricted),c[f].hasOwnProperty("included")&&!c[f].included){this.excludedConfigurationProperties[f]=c[f],delete c[f];continue}else this.configurationProperties[f]=c[f],c[f].policy?.name&&this.policyConfigurations.set(c[f].policy.name,f);!c[f].deprecationMessage&&c[f].markdownDeprecationMessage&&(c[f].deprecationMessage=c[f].markdownDeprecationMessage),o.add(f)}const y=n.allOf;if(y)for(const f of y)this.validateAndRegisterProperties(f,r,i,t,s,o)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const r=i=>{const t=i.properties;if(t)for(const o in t)this.updateSchema(o,t[o]);i.allOf?.forEach(r)};r(n)}updateSchema(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.resourceLanguageSettingsSchema.properties[n]=r;break}}removeFromSchema(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const r=`[${n}]`,i={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,i),e.allSettings.properties[r]=i,e.applicationSettings.properties[r]=i,e.machineSettings.properties[r]=i,e.machineOverridableSettings.properties[r]=i,e.windowSettings.properties[r]=i,e.resourceSettings.properties[r]=i}}registerOverridePropertyPatternKey(){const n={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,r){const i=this.configurationDefaultsOverrides.get(n);let t=i?.value,s=i?.source;L.isUndefined(t)&&(t=r.defaultDefaultValue,s=void 0),L.isUndefined(t)&&(t=u(r.type)),r.default=t,r.defaultValueSource=s}}const d="\\[([^\\]]+)\\]",g=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(k){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(k)){let r=g.exec(k);for(;r?.length;){const i=r[1].trim();i&&n.push(i),r=g.exec(k)}}return(0,R.distinct)(n)}e.overrideIdentifiersFromKey=w;function a(k){return k.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=a;function u(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const h=new v;b.Registry.add(e.Extensions.Configuration,h);function E(k,n){return k.trim()?e.OVERRIDE_PROPERTY_REGEX.test(k)?T.localize(7,null,k):h.getConfigurationProperties()[k]!==void 0?T.localize(8,null,k):n.policy?.name&&h.getPolicyConfigurations().get(n.policy?.name)!==void 0?T.localize(9,null,k,n.policy?.name,h.getPolicyConfigurations().get(n.policy?.name)):null:T.localize(6,null)}e.validateProperty=E;function p(){const k=[],n=h.getConfigurationProperties();for(const r of Object.keys(n))k.push([r,n[r].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.getScopes=p}),define(ae[73],ce([0,1,21,3,34,2,35,31,10,12,18,48,40]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function d(r){return Object.isFrozen(r)?r:D.deepFreeze(r)}class g{constructor(i={},t=[],s=[],o){this._contents=i,this._keys=t,this._overrides=s,this.raw=o,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(t=>{if(t instanceof g)return t;const s=new w("");return s.parseRaw(t),s.configurationModel});this._rawConfiguration=i.reduce((t,s)=>s===t?s:t.merge(s),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,P.getConfigurationValue)(this.contents,i):this.contents}inspect(i,t){const s=this.rawConfiguration.getValue(i),o=t?this.rawConfiguration.getOverrideValue(i,t):void 0,c=t?this.rawConfiguration.override(t).getValue(i):s;return{value:s,override:o,merged:c}}getOverrideValue(i,t){const s=this.getContentsForOverrideIdentifer(t);return s?i?(0,P.getConfigurationValue)(s,i):s:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const s of this.overrides)s.identifiers.includes(i)&&t.push(...s.keys);return R.distinct(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return R.distinct(i)}override(i){let t=this.overrideConfigurations.get(i);return t||(t=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,t)),t}merge(...i){const t=D.deepClone(this.contents),s=D.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const y of i)if(c.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.mergeContents(t,y.contents);for(const f of y.overrides){const[l]=s.filter(I=>R.equals(I.identifiers,f.identifiers));l?(this.mergeContents(l.contents,f.contents),l.keys.push(...f.keys),l.keys=R.distinct(l.keys)):s.push(D.deepClone(f))}for(const f of y.keys)o.indexOf(f)===-1&&o.push(f)}return new g(t,o,s,c.every(y=>y instanceof g)?void 0:c)}createOverrideConfigurationModel(i){const t=this.getContentsForOverrideIdentifer(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const s={};for(const o of R.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[o];const y=t[o];y&&(typeof c=="object"&&typeof y=="object"?(c=D.deepClone(c),this.mergeContents(c,y)):c=y),s[o]=c}return new g(s,this.keys,this.overrides)}mergeContents(i,t){for(const s of Object.keys(t)){if(s in i&&b.isObject(i[s])&&b.isObject(t[s])){this.mergeContents(i[s],t[s]);continue}i[s]=D.deepClone(t[s])}}getContentsForOverrideIdentifer(i){let t=null,s=null;const o=c=>{c&&(s?this.mergeContents(s,c):s=D.deepClone(c))};for(const c of this.overrides)R.equals(c.identifiers,[i])?t=c.contents:c.identifiers.includes(i)&&o(c.contents);return o(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,t){this.updateValue(i,t,!0)}setValue(i,t){this.updateValue(i,t,!1)}removeValue(i){const t=this.keys.indexOf(i);t!==-1&&(this.keys.splice(t,1),(0,P.removeFromValueTree)(this.contents,i),C.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(s=>R.equals(s.identifiers,(0,C.overrideIdentifiersFromKey)(i))),1))}updateValue(i,t,s){(0,P.addToValueTree)(this.contents,i,t,o=>console.error(o)),s=s||this.keys.indexOf(i)===-1,s&&this.keys.push(i),C.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,C.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,P.toValuesTree)(this.contents[i],o=>console.error(o))})}}e.ConfigurationModel=g;class w{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,t){if(!b.isUndefinedOrNull(i)){const s=this.doParseContent(i);this.parseRaw(s,t)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,t){this._raw=i;const{contents:s,keys:o,overrides:c,restricted:y,hasExcludedProperties:f}=this.doParseRaw(i,t);this._configurationModel=new g(s,o,c,f?[i]:void 0),this._restrictedConfigurations=y||[]}doParseContent(i){let t={},s=null,o=[];const c=[],y=[];function f(I){Array.isArray(o)?o.push(I):s!==null&&(o[s]=I)}const l={onObjectBegin:()=>{const I={};f(I),c.push(o),o=I,s=null},onObjectProperty:I=>{s=I},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const I=[];f(I),c.push(o),o=I,s=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:f,onError:(I,A,F)=>{y.push({error:I,offset:A,length:F})}};if(i)try{L.visit(i,l),t=o[0]||{}}catch(I){console.error(`Error while parsing settings file ${this._name}: ${I}`),this._parseErrors=[I]}return t}doParseRaw(i,t){const s=v.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,s,!0,t);i=o.raw;const c=(0,P.toValuesTree)(i,l=>console.error(`Conflict in settings file ${this._name}: ${l}`)),y=Object.keys(i),f=this.toOverrides(i,l=>console.error(`Conflict in settings file ${this._name}: ${l}`));return{contents:c,keys:y,overrides:f,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(i,t,s,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:c};const y={},f=[];for(const l in i)if(C.OVERRIDE_PROPERTY_REGEX.test(l)&&s){const I=this.filter(i[l],t,!1,o);y[l]=I.raw,c=c||I.hasExcludedProperties,f.push(...I.restricted)}else{const I=t[l],A=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&f.push(l),(A===void 0||o.scopes===void 0||o.scopes.includes(A))&&!(o.skipRestricted&&I?.restricted)?y[l]=i[l]:c=!0}return{raw:y,restricted:f,hasExcludedProperties:c}}toOverrides(i,t){const s=[];for(const o of Object.keys(i))if(C.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const y in i[o])c[y]=i[o][y];s.push({identifiers:(0,C.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,P.toValuesTree)(c,t)})}return s}}e.ConfigurationModelParser=w;class a extends T.Disposable{constructor(i,t,s,o){super(),this.userSettingsResource=i,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new N.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(N.Event.any(N.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),N.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&s.isEqual(c.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=a;class u{constructor(i,t,s,o,c,y,f,l,I,A,F,M,V){this.key=i,this.overrides=t,this._value=s,this.overrideIdentifiers=o,this.defaultConfiguration=c,this.policyConfiguration=y,this.applicationConfiguration=f,this.userConfiguration=l,this.localUserConfiguration=I,this.remoteUserConfiguration=A,this.workspaceConfiguration=F,this.folderConfigurationModel=M,this.memoryConfigurationModel=V}get value(){return d(this._value)}inspect(i,t,s){const o=i.inspect(t,s);return{get value(){return d(o.value)},get override(){return d(o.override)},get merged(){return d(o.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class h{constructor(i,t,s,o,c=new g,y=new g,f=new _.ResourceMap,l=new g,I=new _.ResourceMap){this._defaultConfiguration=i,this._policyConfiguration=t,this._applicationConfiguration=s,this._localUserConfiguration=o,this._remoteUserConfiguration=c,this._workspaceConfiguration=y,this._folderConfigurations=f,this._memoryConfiguration=l,this._memoryConfigurationByResource=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(i,t,s){return this.getConsolidatedConfigurationModel(i,t,s).getValue(i)}updateValue(i,t,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new g,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(i):o.setValue(i,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,t,s){const o=this.getConsolidatedConfigurationModel(i,t,s),c=this.getFolderConfigurationModelForResource(t.resource,s),y=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,f=new Set;for(const l of o.overrides)for(const I of l.identifiers)o.getOverrideValue(i,I)!==void 0&&f.add(I);return new u(i,t,o.getValue(i),f.size?[...f]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this._workspaceConfiguration:void 0,c||void 0,y)}keys(i){const t=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,t){this._folderConfigurations.set(i,t),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const s=[];if(!t){const{added:o,updated:c,removed:y}=k(this._defaultConfiguration,i);t=[...o,...c,...y]}for(const o of t)for(const c of(0,C.overrideIdentifiersFromKey)(o)){const y=this._defaultConfiguration.getKeysForOverrideIdentifier(c),f=i.getKeysForOverrideIdentifier(c),l=[...f.filter(I=>y.indexOf(I)===-1),...y.filter(I=>f.indexOf(I)===-1),...y.filter(I=>!D.equals(this._defaultConfiguration.override(c).getValue(I),i.override(c).getValue(I)))];s.push([c,l])}return this.updateDefaultConfiguration(i),{keys:t,overrides:s}}compareAndUpdatePolicyConfiguration(i){const{added:t,updated:s,removed:o}=k(this._policyConfiguration,i),c=[...t,...s,...o];return c.length&&this.updatePolicyConfiguration(i),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=k(this.applicationConfiguration,i),y=[...t,...s,...o];return y.length&&this.updateApplicationConfiguration(i),{keys:y,overrides:c}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=k(this.localUserConfiguration,i),y=[...t,...s,...o];return y.length&&this.updateLocalUserConfiguration(i),{keys:y,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=k(this.remoteUserConfiguration,i),y=[...t,...s,...o];return y.length&&this.updateRemoteUserConfiguration(i),{keys:y,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=k(this.workspaceConfiguration,i),y=[...t,...s,...o];return y.length&&this.updateWorkspaceConfiguration(i),{keys:y,overrides:c}}compareAndUpdateFolderConfiguration(i,t){const s=this.folderConfigurations.get(i),{added:o,updated:c,removed:y,overrides:f}=k(s,t),l=[...o,...c,...y];return(l.length||!s)&&this.updateFolderConfiguration(i,t),{keys:l,overrides:f}}compareAndDeleteFolderConfiguration(i){const t=this.folderConfigurations.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:s,updated:o,removed:c,overrides:y}=k(t,void 0);return{keys:[...s,...o,...c],overrides:y}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,t,s){let o=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:i},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&i){const o=t.getFolder(i);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const c=this._memoryConfigurationByResource.get(i);c&&(s=s.merge(c))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let t=this._foldersConsolidatedConfigurations.get(i);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(t=s.merge(o),this._foldersConsolidatedConfigurations.set(i,t)):t=s}return t}getFolderConfigurationModelForResource(i,t){if(t&&i){const s=t.getFolder(i);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,t)=>{const{contents:s,overrides:o,keys:c}=this._folderConfigurations.get(t);return i.push([t,{contents:s,overrides:o,keys:c}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.keys.forEach(t=>i.add(t)),this.userConfiguration.keys.forEach(t=>i.add(t)),this._workspaceConfiguration.keys.forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.keys.forEach(s=>i.add(s))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.getAllOverrideIdentifiers().forEach(s=>i.add(s))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o))),[...t.values()]}static parse(i){const t=this.parseConfigurationModel(i.defaults),s=this.parseConfigurationModel(i.policy),o=this.parseConfigurationModel(i.application),c=this.parseConfigurationModel(i.user),y=this.parseConfigurationModel(i.workspace),f=i.folders.reduce((l,I)=>(l.set(S.URI.revive(I[0]),this.parseConfigurationModel(I[1])),l),new _.ResourceMap);return new h(t,s,o,c,new g,y,f,new g,new _.ResourceMap)}static parseConfigurationModel(i){return new g(i.contents,i.keys,i.overrides)}}e.Configuration=h;function E(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const i=new Set,t=new Map;for(const o of r)o.keys.forEach(c=>i.add(c)),o.overrides.forEach(([c,y])=>{const f=(0,_.getOrSet)(t,c,new Set);y.forEach(l=>f.add(l))});const s=[];return t.forEach((o,c)=>s.push([c,[...o.values()]])),{keys:[...i.values()],overrides:s}}e.mergeChanges=E;class p{constructor(i,t,s,o){this.change=i,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=o,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const c of i.keys)this.affectedKeys.add(c);for(const[,c]of i.overrides)for(const y of c)this.affectedKeys.add(y);this._affectsConfigStr=this._marker;for(const c of this.affectedKeys)this._affectsConfigStr+=c+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,t){const s=this._marker+i,o=this._affectsConfigStr.indexOf(s);if(o<0)return!1;const c=o+s.length;if(c>=this._affectsConfigStr.length)return!1;const y=this._affectsConfigStr.charCodeAt(c);if(y!==this._markerCode1&&y!==this._markerCode2)return!1;if(t){const f=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.previous?.workspace):void 0,l=this.currentConfiguraiton.getValue(i,t,this.currentWorkspace);return!D.equals(f,l)}return!0}}e.ConfigurationChangeEvent=p;function k(r,i){const{added:t,removed:s,updated:o}=n(i?.rawConfiguration,r?.rawConfiguration),c=[],y=r?.getAllOverrideIdentifiers()||[],f=i?.getAllOverrideIdentifiers()||[];if(i){const l=f.filter(I=>!y.includes(I));for(const I of l)c.push([I,i.getKeysForOverrideIdentifier(I)])}if(r){const l=y.filter(I=>!f.includes(I));for(const I of l)c.push([I,r.getKeysForOverrideIdentifier(I)])}if(i&&r){for(const l of y)if(f.includes(l)){const I=n({contents:r.getOverrideValue(void 0,l)||{},keys:r.getKeysForOverrideIdentifier(l)},{contents:i.getOverrideValue(void 0,l)||{},keys:i.getKeysForOverrideIdentifier(l)});c.push([l,[...I.added,...I.removed,...I.updated]])}}return{added:t,removed:s,updated:o,overrides:c}}function n(r,i){const t=r?i?r.keys.filter(c=>i.keys.indexOf(c)===-1):[...r.keys]:[],s=i?r?i.keys.filter(c=>r.keys.indexOf(c)===-1):[...i.keys]:[],o=[];if(r&&i){for(const c of i.keys)if(r.keys.indexOf(c)!==-1){const y=(0,P.getConfigurationValue)(i.contents,c),f=(0,P.getConfigurationValue)(r.contents,c);D.equals(y,f)||o.push(c)}}return{added:t,removed:s,updated:o}}}),define(ae[201],ce([0,1,21,3,2,31,10,73,48,8,55,40]),function(ne,e,R,N,L,T,_,D,b,S,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class v extends L.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new N.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new D.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(C.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:a,defaultsOverrides:u})=>this.onDidUpdateConfiguration(Array.from(a),u))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(a,u){this.updateConfigurationModel(a,C.Registry.as(b.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:a})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new D.ConfigurationModel;const a=C.Registry.as(b.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(a),a)}updateConfigurationModel(a,u){const h=this.getConfigurationDefaultOverrides();for(const E of a){const p=h[E],k=u[E];p!==void 0?this._configurationModel.addValue(E,p):k?this._configurationModel.addValue(E,k.default):this._configurationModel.removeValue(E)}}}e.DefaultConfiguration=v;class d{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new D.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let g=e.PolicyConfiguration=class extends L.Disposable{get configurationModel(){return this._configurationModel}constructor(a,u,h){super(),this.defaultConfiguration=a,this.policyService=u,this.logService=h,this._onDidChangeConfiguration=this._register(new N.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new D.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(a=>this.onDidChangePolicies(a))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:a})=>this.update(await this.updatePolicyDefinitions(a),!0))),this._configurationModel}async updatePolicyDefinitions(a){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",a);const u={},h=[],E=C.Registry.as(b.Extensions.Configuration).getConfigurationProperties();for(const p of a){const k=E[p];if(!k){h.push(p);continue}if(k.policy){if(k.type!=="string"&&k.type!=="number"){this.logService.warn(`Policy ${k.policy.name} has unsupported type ${k.type}`);continue}h.push(p),u[k.policy.name]={type:k.type}}}return(0,_.isEmptyObject)(u)||await this.policyService.updatePolicyDefinitions(u),h}onDidChangePolicies(a){this.logService.trace("PolicyConfiguration#onDidChangePolicies",a);const u=C.Registry.as(b.Extensions.Configuration).getPolicyConfigurations(),h=(0,R.coalesce)(a.map(E=>u.get(E)));this.update(h,!0)}update(a,u){this.logService.trace("PolicyConfiguration#update",a);const h=C.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),E=[],p=this._configurationModel.isEmpty();for(const k of a){const n=h[k]?.policy?.name;if(n){const r=this.policyService.getPolicyValue(n);(p?r!==void 0:!(0,T.equals)(this._configurationModel.getValue(k),r))&&E.push([k,r])}else this._configurationModel.getValue(k)!==void 0&&E.push([k,void 0])}if(E.length){this.logService.trace("PolicyConfiguration#changed",E);const k=this._configurationModel;this._configurationModel=new D.ConfigurationModel;for(const n of k.keys)this._configurationModel.setValue(n,k.getValue(n));for(const[n,r]of E)r===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,r);u&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=g=pe([G(1,P.IPolicyService),G(2,S.ILogService)],g)}),define(ae[202],ce([0,1,6,3,2,22,18,73,201,55]),function(ne,e,R,N,L,T,_,D,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends L.Disposable{constructor(v,d,g,w){super(),this.settingsResource=v,this._onDidChangeConfiguration=this._register(new N.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new b.DefaultConfiguration),this.policyConfiguration=g instanceof S.NullPolicyService?new b.NullPolicyConfiguration:this._register(new b.PolicyConfiguration(this.defaultConfiguration,g,w)),this.userConfiguration=this._register(new D.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,d)),this.configuration=new D.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new D.ConfigurationModel,new D.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:a,properties:u})=>this.onDidDefaultConfigurationChange(a,u))),this._register(this.policyConfiguration.onDidChangeConfiguration(a=>this.onDidPolicyConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[v,d,g]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new D.Configuration(v,d,new D.ConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(v,d){const g=typeof v=="string"?v:void 0,w=(0,_.isConfigurationOverrides)(v)?v:(0,_.isConfigurationOverrides)(d)?d:{};return this.configuration.getValue(g,w,void 0)}updateValue(v,d,g,w){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const d=this.configuration.toData(),g=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(g,d,2)}onDidDefaultConfigurationChange(v,d){const g=this.configuration.toData(),w=this.configuration.compareAndUpdateDefaultConfiguration(v,d);this.trigger(w,g,7)}onDidPolicyConfigurationChange(v){const d=this.configuration.toData(),g=this.configuration.compareAndUpdatePolicyConfiguration(v);this.trigger(g,d,7)}trigger(v,d,g){const w=new D.ConfigurationChangeEvent(v,{data:d},this.configuration);w.source=g,w.sourceConfig=this.getTargetConfiguration(g),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(v){switch(v){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(ae[203],ce([0,1,16]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0;const N=(L,T,_)=>{const D=new Uint8Array(16);for(let P=0;P<16;P++)D[P]=Math.round(Math.random()*256);const b=(0,R.encodeBase64)(R.VSBuffer.wrap(D));return[`GET ws://localhost${L}?${T}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${b}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=N,e.socketRawEndHeaderSequence=R.VSBuffer.fromString(`\r
\r
`)}),define(ae[204],ce([0,1,7,4]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,N.createDecorator)("remoteAuthorityResolverService");var L;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class T{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=T;class _{constructor(C,v){this.host=C,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=_;var D;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(D||(e.RemoteAuthorityResolverErrorCode=D={}));class b extends R.ErrorNoTelemetry{static isNotAvailable(C){return C instanceof b&&C._code===D.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof b&&C._code===D.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof b&&C._code===D.NoResolverFound}static isHandled(C){return C instanceof b&&C.isHandled}constructor(C,v=D.Unknown,d){super(C),this._message=C,this._code=v,this._detail=d,this.isHandled=v===D.NotAvailable&&d===!0,Object.setPrototypeOf(this,b.prototype)}}e.RemoteAuthorityResolverError=b;function S(P){const C=P.indexOf("+");return C===-1?P:P.substring(0,C)}e.getRemoteAuthorityPrefix=S}),define(ae[74],ce([0,1,25]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function N(S){return S.scheme===R.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=N;function L(S){if(!S)return;const P=S.indexOf("+");return P<0?S:S.substr(0,P)}e.getRemoteName=L;function T(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=T;function _(S){const{host:P,port:C}=b(S);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:C}}e.parseAuthorityWithPort=_;function D(S,P){let{host:C,port:v}=b(S);return typeof v>"u"&&(v=P),{host:C,port:v}}e.parseAuthorityWithOptionalPort=D;function b(S){const P=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const C=S.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const v=S.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:S,port:void 0}}}),define(ae[49],ce([0,1,27,4,74]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var _;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(_||(e.ExtensionType=_={}));var D;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.LINUX_PPC64LE="linux-ppc64le",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(D||(e.TargetPlatform=D={}));class b{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,u){if(typeof a>"u"||a===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof a=="string"||typeof u=="string"){const h=typeof a=="string"?a:a.value,E=typeof u=="string"?u:u.value;return R.equalsIgnoreCase(h,E)}return a._lower===u._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.ExtensionIdentifier=b;class S{get size(){return this._set.size}constructor(a){if(this._set=new Set,a)for(const u of a)this.add(u)}add(a){this._set.add(b.toKey(a))}delete(a){return this._set.delete(b.toKey(a))}has(a){return this._set.has(b.toKey(a))}}e.ExtensionIdentifierSet=S;class P{constructor(){this._map=new Map}clear(){this._map.clear()}delete(a){this._map.delete(b.toKey(a))}get(a){return this._map.get(b.toKey(a))}has(a){return this._map.has(b.toKey(a))}set(a,u){this._map.set(b.toKey(a),u)}values(){return this._map.values()}forEach(a){this._map.forEach(a)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function C(w){return v(w)}e.isApplicationScopedExtension=C;function v(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function d(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function g(w,a){if(a){const u=`onResolveRemoteAuthority:${(0,L.getRemoteName)(a)}`;return!!w.activationEvents?.includes(u)}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,N.createDecorator)("IBuiltinExtensionsScannerService")}),define(ae[205],ce([0,1,2,49,13]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends R.Disposable{constructor(D,b,S,P,C){super(),this.userDataProfilesService=D,this.fileService=b,this.uriIdentityService=S,this.logService=C,this._register(P.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(P.onDidUninstallExtension(v=>this.onDidUnInstallExtension(v)))}onDidInstallExtensions(D){for(const b of D)b.local&&this.invalidate(b.profileLocation)}onDidUnInstallExtension(D){D.error||this.invalidate(D.profileLocation)}async invalidate(D){if(D)for(const b of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(b.extensionsResource,D)&&await this.deleteUserCacheFile(b);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(D){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(D.cacheHome,N.USER_MANIFEST_CACHE_FILE))}catch(b){(0,L.toFileOperationResult)(b)!==1&&this.logService.error(b)}}}e.ExtensionsManifestCache=T}),define(ae[206],ce([0,1,6,16,26,7,3,2,100,87,32,92,204,74]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const g=30*1e3;var w;(function(O){O[O.Management=1]="Management",O[O.ExtensionHost=2]="ExtensionHost",O[O.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function a(O){switch(O){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(O){const m=new L.CancellationTokenSource;return setTimeout(()=>m.cancel(),O),m.token}function h(O,m){if(O.isCancellationRequested||m.isCancellationRequested)return L.CancellationToken.Cancelled;const U=new L.CancellationTokenSource;return O.onCancellationRequested(()=>U.cancel()),m.onCancellationRequested(()=>U.cancel()),U.token}class E{get didTimeout(){return this._state==="timedout"}constructor(m){this._state="pending",this._disposables=new D.DisposableStore,this.promise=new Promise((U,W)=>{this._resolvePromise=U,this._rejectPromise=W}),m.isCancellationRequested?this._timeout():this._disposables.add(m.onCancellationRequested(()=>this._timeout()))}registerDisposable(m){this._state==="pending"?this._disposables.add(m):m.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const m=new Error("Time limit reached");return m.code="ETIMEDOUT",m.syscall="connect",m}resolve(m){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(m))}reject(m){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(m))}}function p(O,m){const U=new E(m);return U.registerDisposable(O.onControlMessage(W=>{const J=JSON.parse(W.toString()),$=B(J);$?U.reject($):U.resolve(J)})),U.promise}function k(O,m,U,W,J,$,H,te){const oe=new E(te),ue=S.StopWatch.create(!1);return O.info(`Creating a socket (${H})...`),b.mark(`code/willCreateSocket/${$}`),m.connect(U,W,J,H).then(de=>{oe.didTimeout?(b.mark(`code/didCreateSocketError/${$}`),O.info(`Creating a socket (${H}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),de?.dispose()):(b.mark(`code/didCreateSocketOK/${$}`),O.info(`Creating a socket (${H}) was successful after ${ue.elapsed()} ms.`),oe.resolve(de))},de=>{b.mark(`code/didCreateSocketError/${$}`),O.info(`Creating a socket (${H}) returned an error after ${ue.elapsed()} ms.`),O.error(de),oe.reject(de)}),oe.promise}function n(O,m){const U=new E(m);return O.then(W=>{U.didTimeout||U.resolve(W)},W=>{U.didTimeout||U.reject(W)}),U.promise}async function r(O,m,U,W){const J=K(O,m);O.logService.trace(`${J} 1/6. invoking socketFactory.connect().`);let $;try{$=await k(O.logService,O.remoteSocketFactoryService,O.connectTo,(0,d.getRemoteServerRootPath)(O),`reconnectionToken=${O.reconnectionToken}&reconnection=${O.reconnectionProtocol?"true":"false"}`,a(m),`renderer-${a(m)}-${O.reconnectionToken}`,W)}catch(de){throw O.logService.error(`${J} socketFactory.connect() failed or timed out. Error:`),O.logService.error(de),de}O.logService.trace(`${J} 2/6. socketFactory.connect() was successful.`);let H,te;O.reconnectionProtocol?(O.reconnectionProtocol.beginAcceptReconnection($,null),H=O.reconnectionProtocol,te=!1):(H=new C.PersistentProtocol({socket:$}),te=!0),O.logService.trace(`${J} 3/6. sending AuthRequest control message.`);const oe=await n(O.signService.createNewMessage((0,P.generateUuid)()),W),ue={type:"auth",auth:O.connectionToken||"00000000000000000000",data:oe.data};H.sendControl(N.VSBuffer.fromString(JSON.stringify(ue)));try{const de=await p(H,h(W,u(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(O.logService.trace(`${J} 4/6. received SignRequest control message.`),!await n(O.signService.validate(oe,de.signedData),W)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Ee=await n(O.signService.sign(de.data),W),Ce={type:"connectionType",commit:O.commit,signedData:Ee,desiredConnectionType:m};return U&&(Ce.args=U),O.logService.trace(`${J} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(N.VSBuffer.fromString(JSON.stringify(Ce))),{protocol:H,ownsProtocol:te}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(O.logService.error(`${J} the handshake timed out. Error:`),O.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(O.logService.error(`${J} received error control message when negotiating connection. Error:`),O.logService.error(de)),te&&j(H),de}}async function i(O,m,U,W){const J=Date.now(),$=K(O,m),{protocol:H,ownsProtocol:te}=await r(O,m,U,W),oe=new E(W);return oe.registerDisposable(H.onControlMessage(ue=>{const de=JSON.parse(ue.toString()),ve=B(de);ve?(O.logService.error(`${$} received error control message when negotiating connection. Error:`),O.logService.error(ve),te&&j(H),oe.reject(ve)):(O.reconnectionProtocol?.endAcceptReconnection(),O.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${Q(J)}!`),oe.resolve({protocol:H,firstMessage:de}))})),oe.promise}async function t(O,m){const{protocol:U}=await i(O,1,void 0,m);return{protocol:U}}async function s(O,m,U){const{protocol:W,firstMessage:J}=await i(O,2,m,U),$=J&&J.debugPort;return{protocol:W,debugPort:$}}async function o(O,m,U){const W=Date.now(),J=K(O,3),{protocol:$}=await r(O,3,m,U);return O.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${Q(W)}!`),$}async function c(O,m,U){const{connectTo:W,connectionToken:J}=await O.addressProvider.getAddress();return{commit:O.commit,quality:O.quality,connectTo:W,connectionToken:J,reconnectionToken:m,reconnectionProtocol:U,remoteSocketFactoryService:O.remoteSocketFactoryService,signService:O.signService,logService:O.logService}}async function y(O,m,U){return l(O,async W=>{const{protocol:J}=await t(W,L.CancellationToken.None);return new Y(O,m,U,W.reconnectionToken,J)})}e.connectRemoteAgentManagement=y;async function f(O,m){return l(O,async U=>{const{protocol:W,debugPort:J}=await s(U,m,L.CancellationToken.None);return new Z(O,m,U.reconnectionToken,W,J)})}e.connectRemoteAgentExtensionHost=f;async function l(O,m){for(let W=1;;W++)try{const J=(0,P.generateUuid)(),$=await c(O,J,null);return await m($)}catch(J){if(W<5)O.logService.error(`[remote-connection][attempt ${W}] An error occurred in initial connection! Will retry... Error:`),O.logService.error(J);else throw O.logService.error(`[remote-connection][attempt ${W}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),O.logService.error(J),ee.triggerPermanentFailure(0,0,v.RemoteAuthorityResolverError.isHandled(J)),J}}async function I(O,m,U){const W=await c(O,(0,P.generateUuid)(),null);return await o(W,{host:m,port:U},L.CancellationToken.None)}e.connectRemoteAgentTunnel=I;function A(O){return(0,R.createCancelablePromise)(m=>new Promise((U,W)=>{const J=setTimeout(U,O*1e3);m.onCancellationRequested(()=>{clearTimeout(J),U()})}))}var F;(function(O){O[O.ConnectionLost=0]="ConnectionLost",O[O.ReconnectionWait=1]="ReconnectionWait",O[O.ReconnectionRunning=2]="ReconnectionRunning",O[O.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",O[O.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class M{constructor(m,U){this.reconnectionToken=m,this.millisSinceLastIncomingData=U,this.type=0}}e.ConnectionLostEvent=M;class V{constructor(m,U,W,J){this.reconnectionToken=m,this.millisSinceLastIncomingData=U,this.durationSeconds=W,this.cancellableTimer=J,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=V;class x{constructor(m,U,W){this.reconnectionToken=m,this.millisSinceLastIncomingData=U,this.attempt=W,this.type=2}}e.ReconnectionRunningEvent=x;class q{constructor(m,U,W){this.reconnectionToken=m,this.millisSinceLastIncomingData=U,this.attempt=W,this.type=4}}e.ConnectionGainEvent=q;class X{constructor(m,U,W,J){this.reconnectionToken=m,this.millisSinceLastIncomingData=U,this.attempt=W,this.handled=J,this.type=3}}e.ReconnectionPermanentFailureEvent=X;class ee extends D.Disposable{static triggerPermanentFailure(m,U,W){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=m,this._permanentFailureAttempt=U,this._permanentFailureHandled=W,this._instances.forEach(J=>J._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(m=>m._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(m=>m._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||ee._permanentFailure}constructor(m,U,W,J,$){super(),this._connectionType=m,this._options=U,this.reconnectionToken=W,this.protocol=J,this._reconnectionFailureIsFatal=$,this._onDidStateChange=this._register(new _.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new q(this.reconnectionToken,0,0)),this._register(J.onSocketClose(H=>{const te=re(this._connectionType,this.reconnectionToken,!0);H?H.type===0?(this._options.logService.info(`${te} received socket close event (hadError: ${H.hadError}).`),H.error&&this._options.logService.error(H.error)):(this._options.logService.info(`${te} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this._options.logService.error(H.event)):this._options.logService.info(`${te} received socket close event.`),this._beginReconnecting()})),this._register(J.onSocketTimeout(H=>{const te=re(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${te} received socket timeout event (unacknowledgedMsgCount: ${H.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${H.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${H.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),ee._instances.push(this),this._register((0,D.toDisposable)(()=>{const H=ee._instances.indexOf(this);H>=0&&ee._instances.splice(H,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(ee._permanentFailureMillisSinceLastIncomingData,ee._permanentFailureAttempt,ee._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const m=re(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${m} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const J=W<U.length?U[W]:U[U.length-1];try{if(J>0){const H=A(J);this._onDidStateChange.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J,H)),this._options.logService.info(`${m} waiting for ${J} seconds before reconnecting...`);try{await H}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${m} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this._options.logService.info(`${m} resolving connection...`);const $=await c(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${m} connecting to ${$.connectTo}...`),await this._reconnect($,u(g)),this._options.logService.info(`${m} reconnected!`),this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch($){if($.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${m} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this._options.logService.error(`${m} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(v.RemoteAuthorityResolverError.isTemporarilyNotAvailable($)){this._options.logService.info(`${m} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if(($.code==="ETIMEDOUT"||$.code==="ENETUNREACH"||$.code==="ECONNREFUSED"||$.code==="ECONNRESET")&&$.syscall==="connect"){this._options.logService.info(`${m} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if((0,T.isCancellationError)($)){this._options.logService.info(`${m} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if($ instanceof v.RemoteAuthorityResolverError){this._options.logService.error(`${m} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,v.RemoteAuthorityResolverError.isHandled($));break}this._options.logService.error(`${m} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(m,U,W){this._reconnectionFailureIsFatal?ee.triggerPermanentFailure(m,U,W):this._gotoPermanentFailure(m,U,W)}_gotoPermanentFailure(m,U,W){this._onDidStateChange.fire(new X(this.reconnectionToken,m,U,W)),j(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ee,ee._permanentFailure=!1,ee._permanentFailureMillisSinceLastIncomingData=0,ee._permanentFailureAttempt=0,ee._permanentFailureHandled=!1,ee._instances=[];class Y extends ee{constructor(m,U,W,J,$){super(1,m,J,$,!0),this.client=this._register(new C.Client($,{remoteAuthority:U,clientId:W},m.ipcLogger))}async _reconnect(m,U){await t(m,U)}}e.ManagementPersistentConnection=Y;class Z extends ee{constructor(m,U,W,J,$){super(2,m,W,J,!1),this._startArguments=U,this.debugPort=$}async _reconnect(m,U){await s(m,this._startArguments,U)}}e.ExtensionHostPersistentConnection=Z;function j(O){try{O.acceptDisconnect();const m=O.getSocket();O.dispose(),m.dispose()}catch(m){(0,T.onUnexpectedError)(m)}}function B(O){if(O&&O.type==="error"){const m=new Error(`Connection error: ${O.reason}`);return m.code="VSCODE_CONNECTION_ERROR",m}return null}function z(O,m){for(;O.length<m;)O+=" ";return O}function ie(O,m){return`[remote-connection][${z(a(O),13)}][${m.substr(0,5)}\u2026]`}function re(O,m,U){return`${ie(O,m)}[${U?"reconnect":"initial"}]`}function K(O,m){return`${re(m,O.reconnectionToken,!!O.reconnectionProtocol)}[${O.connectTo}]`}function Q(O){return`${Date.now()-O} ms`}}),define(ae[104],ce([0,1,2,4]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,N.createDecorator)("remoteSocketFactoryService");class L{constructor(){this.factories={}}register(_,D){return this.factories[_]??=[],this.factories[_].push(D),(0,R.toDisposable)(()=>{const b=this.factories[_]?.indexOf(D);typeof b=="number"&&b>=0&&this.factories[_]?.splice(b,1)})}getSocketFactory(_){return(this.factories[_.type]||[]).find(b=>b.supports(_))}connect(_,D,b,S){const P=this.getSocketFactory(_);if(!P)throw new Error(`No socket factory found for ${_}`);return P.connect(_,D,b,S)}}e.RemoteSocketFactoryService=L}),define(ae[207],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ae[105],ce([0,1,4,157]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,R.createDecorator)("IRemoteTunnelService");var L;(function(T){T.disconnected=_=>({type:"disconnected",onTokenFailed:_}),T.connected=_=>({type:"connected",info:_}),T.connecting=_=>({type:"connecting",progress:_}),T.uninitialized={type:"uninitialized"}})(L||(e.TunnelStates=L={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,N.localize)(0,null)}),define(ae[56],ce([0,1,16,7,2,159,48,4,8,40]),function(ne,e,R,N,L,T,_,D,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");class P{constructor(k){this.original=k}toJSON(){if(!this.headers){const k=Object.create(null);for(const n in this.original)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?k[n]="*****":k[n]=this.original[n];this.headers=k}return this.headers}}class C extends L.Disposable{constructor(k){super(),this.counter=0,this.logger=k.createLogger("network",{name:(0,T.localize)(0,null),when:b.CONTEXT_LOG_LEVEL.isEqualTo((0,b.LogLevelToString)(b.LogLevel.Trace)).serialize()})}async logAndRequest(k,n,r){const i=`${k} #${++this.counter}: ${n.url}`;this.logger.trace(`${i} - begin`,n.type,new P(n.headers??{}));try{const t=await r();return this.logger.trace(`${i} - end`,n.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.logger.error(`${i} - error`,n.type,(0,N.getErrorMessage)(t)),t}}}e.AbstractRequestService=C;function v(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=v;function d(p){return p.res.statusCode===204}async function g(p){return d(p)?null:(await(0,R.streamToBuffer)(p.stream)).toString()}e.asText=g;async function w(p){if(!v(p))throw new Error("Server returned "+p.res.statusCode);return g(p)}e.asTextOrError=w;async function a(p){if(!v(p))throw new Error("Server returned "+p.res.statusCode);if(d(p))return null;const n=(await(0,R.streamToBuffer)(p.stream)).toString();try{return JSON.parse(n)}catch(r){throw r.message+=`:
`+n,r}}e.asJson=a;function u(p){E(p)}e.updateProxyConfigurationsScope=u;let h;function E(p){const k=S.Registry.as(_.Extensions.Configuration),n=h;h={id:"http",order:15,title:(0,T.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(3,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(4,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(5,null),(0,T.localize)(6,null),(0,T.localize)(7,null),(0,T.localize)(8,null)],default:"override",description:(0,T.localize)(9,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(10,null),restricted:!0}}},k.updateConfigurations({add:[h],remove:n?[n]:[]})}E(1)}),define(ae[208],ce([0,1,26,25,13,56]),function(ne,e,R,N,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let _=e.DownloadService=class{constructor(b,S){this.requestService=b,this.fileService=S}async download(b,S,P=R.CancellationToken.None){if(b.scheme===N.Schemas.file||b.scheme===N.Schemas.vscodeRemote){await this.fileService.copy(b,S);return}const C={type:"GET",url:b.toString(!0)},v=await this.requestService.request(C,P);if(v.res.statusCode===200)await this.fileService.writeFile(S,v.stream);else{const d=await(0,T.asTextOrError)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${d}`)}}};e.DownloadService=_=pe([G(0,T.IRequestService),G(1,L.IFileService)],_)}),define(ae[209],ce([0,1,16,26]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class L{constructor(D){this.service=D}listen(D,b){throw new Error("Invalid listen")}call(D,b,S,P=N.CancellationToken.None){switch(b){case"request":return this.service.request(S[0],P).then(async({res:C,stream:v})=>{const d=await(0,R.streamToBuffer)(v);return[{statusCode:C.statusCode,headers:C.headers},d]});case"resolveProxy":return this.service.resolveProxy(S[0])}throw new Error("Invalid call")}}e.RequestChannel=L;class T{constructor(D){this.channel=D}async request(D,b){const[S,P]=await this.channel.call("request",[D],b);return{res:S,stream:(0,R.bufferToStream)(P)}}async resolveProxy(D){return this.channel.call("resolveProxy",[D])}}e.RequestChannelClient=T}),define(ae[210],ce([0,1,59,25,175]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends L.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:N.Schemas.vscodeUserData})}}e.SharedProcessEnvironmentService=T,pe([R.memoize],T.prototype,"userRoamingDataHome",null)}),define(ae[211],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class R{constructor(){this.validators=new Map}async createNewMessage(L){try{const T=await this.getValidator();if(T){const _=String(R._nextId++);return this.validators.set(_,T),{id:_,data:T.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,T){if(!L.id)return!0;const _=this.validators.get(L.id);if(!_)return!1;this.validators.delete(L.id);try{return _.validate(T)==="ok"}catch{return!1}finally{_.dispose?.()}}async sign(L){try{return await this.signValue(L)}catch{}return L}}e.AbstractSignService=R,R._nextId=1}),define(ae[106],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(ae[212],ce([0,1,211]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class N extends R.AbstractSignService{getValidator(){return this.vsda().then(T=>new T.validator)}signValue(T){return this.vsda().then(_=>new _.signer().sign(T))}vsda(){return new Promise((T,_)=>ne(["vsda"],T,_))}}e.SignService=N}),define(ae[75],ce([0,1,3,2]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class L extends N.Disposable{constructor(C,v,d){super(),this.channel=C,this.profile=v,this.workspace=d}async getItems(){const C={profile:this.profile,workspace:this.workspace},v=await this.channel.call("getItems",C);return new Map(v)}updateItems(C){const v={profile:this.profile,workspace:this.workspace};return C.insert&&(v.insert=Array.from(C.insert.entries())),C.delete&&(v.delete=Array.from(C.delete.values())),this.channel.call("updateItems",v)}}class T extends L{constructor(C,v){super(C,v,void 0),this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(C=>this.onDidChangeStorage(C)))}onDidChangeStorage(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this._onDidChangeItemsExternal.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}}class _ extends T{constructor(C){super(C,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=_;class D extends T{constructor(C,v){super(C,v)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=D;class b extends L{constructor(C,v){super(C,void 0,v),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=b;class S{constructor(C){this.channel=C}isUsed(C){const v={payload:C,profile:void 0,workspace:void 0};return this.channel.call("isUsed",v)}}e.StorageClient=S}),define(ae[107],ce([0,1,5,37,32]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(b){if(R.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}function _(b,S,P,C,v,d,g,w){const a=Object.create(null);a["common.machineId"]=d,a.sessionID=(0,L.generateUuid)()+Date.now(),a.commitHash=C,a.version=v,a["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,R.PlatformToString)(R.platform),a["common.nodePlatform"]=N.platform,a["common.nodeArch"]=P,a["common.product"]=w||"desktop",g&&(a["common.msftInternal"]=g);let u=0;const h=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),R.isLinuxSnap&&(a["common.snap"]="true");const E=T(S);return E&&(a["common.platformDetail"]=E),a}e.resolveCommonProperties=_;function D(b){const S=N.env.USERDNSDOMAIN;if(!S)return!1;const P=S.toLowerCase();return b.some(C=>P===C)}e.verifyMicrosoftInternalDomain=D}),define(ae[20],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var N;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ae[213],ce([0,1,36,6,34,25,15,5,12,127,30,139,95,13,24,20]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const a=new Map;async function u(n,r){const i=`${n}::${r.join(":")}`,t=a.get(i);if(t)return t;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,c=new Map,y=2e4;function f(I,A,F,M){const V=A.substring(I.length+1);return N.Promises.withAsyncBody(async x=>{let q;try{q=await P.Promises.readdir(A,{withFileTypes:!0})}catch{x();return}if(M.count>=y){M.count+=q.length,M.maxReached=!0,x();return}let X=q.length;if(X===0){x();return}let ee=q;M.count+q.length>y&&(M.maxReached=!0,X=y-M.count,ee=q.slice(0,X)),M.count+=q.length;for(const Y of ee)if(Y.isDirectory()){if(F.includes(Y.name)||await f(I,(0,_.join)(A,Y.name),F,M),--X===0){x();return}}else{const Z=Y.name.lastIndexOf(".");if(Z>=0){const j=Y.name.substring(Z+1);j&&o.set(j,(o.get(j)??0)+1)}for(const j of s)j.relativePathPattern?.test(V)!==!1&&j.filePattern.test(Y.name)&&c.set(j.tag,(c.get(j.tag)??0)+1);if(--X===0){x();return}}})}const l=N.Promises.withAsyncBody(async I=>{const A={count:0,maxReached:!1};await f(n,n,r,A);const F=await p(n);I({configFiles:h(c),fileTypes:h(o),fileCount:A.count,maxFilesReached:A.maxReached,launchConfigFiles:F})});return a.set(i,l),l}e.collectWorkspaceStats=u;function h(n){return Array.from(n.entries(),([r,i])=>({name:r,count:i})).sort((r,i)=>i.count-r.count)}function E(){const n={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},r=R.cpus();return r&&r.length>0&&(n.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),n}e.getMachineInfo=E;async function p(n){try{const r=new Map,i=(0,_.join)(n,".vscode","launch.json"),t=await P.Promises.readFile(i),s=[],o=(0,L.parse)(t.toString(),s);if(s.length)return console.log(`Unable to parse ${i}`),[];if((0,L.getNodeType)(o)==="object"&&o.configurations)for(const c of o.configurations){const y=c.type;y&&(r.has(y)?r.set(y,r.get(y)+1):r.set(y,1))}return h(r)}catch{return[]}}e.collectLaunchConfigs=p;let k=e.DiagnosticsService=class{constructor(r,i){this.telemetryService=r,this.productService=i}formatMachineInfo(r){const i=[];return i.push(`OS Version:       ${r.os}`),i.push(`CPUs:             ${r.cpus}`),i.push(`Memory (System):  ${r.memory}`),i.push(`VM:               ${r.vmHint}`),i.join(`
`)}formatEnvironment(r){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const t=R.cpus();return t&&t.length>0&&i.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),i.push(`Memory (System):  ${(R.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),D.isWindows||i.push(`Load (avg):       ${R.loadavg().map(s=>Math.round(s)).join(", ")}`),i.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${r.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(r,i){return Promise.all([(0,C.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async t=>{let[s,o]=t,c=this.formatProcessList(r,s);return i.forEach(y=>{if((0,v.isRemoteDiagnosticError)(y))c+=`
${y.errorMessage}`,o+=`
${y.errorMessage}`;else if(c+=`

Remote: ${y.hostName}`,y.processes&&(c+=`
${this.formatProcessList(r,y.processes)}`),y.workspaceMetadata){o+=`
|  Remote: ${y.hostName}`;for(const f of Object.keys(y.workspaceMetadata)){const l=y.workspaceMetadata[f];let I=`${l.fileCount} files`;l.maxFilesReached&&(I=`more than ${I}`),o+=`|    Folder (${f}): ${I}`,o+=this.formatWorkspaceStats(l)}}}),{processInfo:c,workspaceInfo:o}})}async getSystemInfo(r,i){const{memory:t,vmHint:s,os:o,cpus:c}=E(),y={os:o,memory:t,cpus:c,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:i};return D.isWindows||(y.load=`${R.loadavg().map(f=>Math.round(f)).join(", ")}`),D.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(r,i){const t=[];return(0,C.listProcesses)(r.mainPID).then(async s=>(t.push(""),t.push(this.formatEnvironment(r)),t.push(""),t.push(this.formatProcessList(r,s)),r.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(r))),i.forEach(o=>{if((0,v.isRemoteDiagnosticError)(o))t.push(`
${o.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${o.hostName}`),t.push(this.formatMachineInfo(o.machineInfo)),o.processes&&t.push(this.formatProcessList(r,o.processes)),o.workspaceMetadata)for(const c of Object.keys(o.workspaceMetadata)){const y=o.workspaceMetadata[c];let f=`${y.fileCount} files`;y.maxFilesReached&&(f=`more than ${f}`),t.push(`Folder (${c}): ${f}`),t.push(this.formatWorkspaceStats(y))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(r){const i=[];let s=0;const o=(l,I)=>{const A=` ${l}(${I})`;s+A.length>60?(i.push(c),c="|                 ",s=c.length):s+=A.length,c+=A};let c="|      File types:";const y=10,f=r.fileTypes.length>y?y:r.fileTypes.length;for(let l=0;l<f;l++){const I=r.fileTypes[l];o(I.name,I.count)}if(i.push(c),r.configFiles.length>=0&&(c="|      Conf files:",s=0,r.configFiles.forEach(l=>{o(l.name,l.count)}),i.push(c)),r.launchConfigFiles.length>0){let l="|      Launch Configs:";r.launchConfigFiles.forEach(I=>{const A=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;l+=A}),i.push(l)}return i.join(`
`)}expandGPUFeatures(r){const i=Math.max(...Object.keys(r).map(t=>t.length));return Object.keys(r).map(t=>`${t}:  ${" ".repeat(i-t.length)}  ${r[t]}`).join(`
                  `)}formatWorkspaceMetadata(r){const i=[],t=[];return r.windows.forEach(s=>{s.folderURIs.length===0||s.remoteAuthority||(i.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const c=b.URI.revive(o);if(c.scheme===T.Schemas.file){const y=c.fsPath;t.push(u(y,["node_modules",".git"]).then(f=>{let l=`${f.fileCount} files`;f.maxFilesReached&&(l=`more than ${l}`),i.push(`|    Folder (${(0,_.basename)(y)}): ${l}`),i.push(this.formatWorkspaceStats(f))}).catch(f=>{i.push(`|      Error: Unable to collect workspace stats for folder ${y} (${f.toString()})`)}))}else i.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(s=>i.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(r,i){const t=new Map;r.windows.forEach(o=>t.set(o.pid,`window [${o.id}] (${o.title})`)),r.pidToNames.forEach(({pid:o,name:c})=>t.set(o,c));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(r.mainPID,t,s,i,0),s.join(`
`)}formatProcessItem(r,i,t,s,o){const c=o===0;let y;c?y=s.pid===r?`${this.productService.applicationName} main`:"remote agent":i.has(s.pid)?y=i.get(s.pid):y=`${"  ".repeat(o)} ${s.name}`;const f=process.platform==="win32"?s.mem:R.totalmem()*(s.mem/100);t.push(`${s.load.toFixed(0).padStart(5," ")}	${(f/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(s.children)&&s.children.forEach(l=>this.formatProcessItem(r,i,t,l,o+1))}async getWorkspaceFileExtensions(r){const i=new Set;for(const{uri:t}of r.folders){const s=b.URI.revive(t);if(s.scheme!==T.Schemas.file)continue;const o=s.fsPath;try{(await u(o,["node_modules",".git"])).fileTypes.forEach(y=>i.add(y.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(r){for(const{uri:i}of r.folders){const t=b.URI.revive(i);if(t.scheme!==T.Schemas.file)continue;const s=t.fsPath;try{const o=await u(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),o.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:c.name,count:c.count})}),o.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:c.name,count:c.count})}),o.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};e.DiagnosticsService=k=pe([G(0,w.ITelemetryService),G(1,g.IProductService)],k)}),define(ae[108],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(T){this.appenders=T}listen(T,_){throw new Error(`Event not found: ${_}`)}call(T,_,{eventName:D,data:b}){return this.appenders.forEach(S=>S.log(D,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class N{constructor(T){this.channel=T}log(T,_){return this.channel.call("log",{eventName:T,data:_}).then(void 0,D=>`Failed to log telemetry: ${console.warn(D)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=N}),define(ae[45],ce([0,1,31,10,3,18,74,107,20]),function(ne,e,R,N,L,T,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class S{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=S;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class C{async publicLog(s,o,c){}async publicLogError(s,o,c){}}e.NullEndpointTelemetryService=C,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(t,s){return L.Event.debounce(s.onDidChangeConfiguration,(c,y)=>{const f=c?new Set([...c.affectedKeys,...y.affectedKeys]):y.affectedKeys;return{...y,affectedKeys:f}},1e3,!0)(c=>{c.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.configurationTelemetry=v;function d(t,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!t.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=d;function g(t,s){return!(s.isBuilt||s.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.isLoggingOnly=g;function w(t){const s=t.getValue(b.TELEMETRY_SETTING_ID),o=t.getValue(b.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(b.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function a(t){const s={},o={},c={};E(t,c);for(let y in c){y=y.length>150?y.substr(y.length-149):y;const f=c[y];typeof f=="number"?o[y]=f:typeof f=="boolean"?o[y]=f?1:0:typeof f=="string"?(f.length>8192&&console.warn(`Telemetry property: ${y} has been trimmed to 8192, the original length is ${f.length}`),s[y]=f.substring(0,8191)):typeof f<"u"&&f!==null&&(s[y]=f)}return{properties:s,measurements:o}}e.validateTelemetryData=a;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(t){if(!t)return"none";const s=(0,_.getRemoteName)(t);return u.has(s)?s:"other"}e.cleanRemoteAuthority=h;function E(t,s,o=0,c){if(t)for(const y of Object.getOwnPropertyNames(t)){const f=t[y],l=c?c+y:y;Array.isArray(f)?s[l]=(0,R.safeStringify)(f):f instanceof Date?s[l]=f.toISOString():(0,N.isObject)(f)?o<2?E(f,s,o+1,l+"."):s[l]=(0,R.safeStringify)(f):s[l]=f}}function p(t,s){const o=t.msftInternalDomains||[],c=s.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(o)||c}e.isInternalTelemetry=p;function k(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.getPiiPathsFromEnvironment=k;function n(t,s){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let o=t;const c=[];for(const I of s)for(;;){const A=I.exec(t);if(!A)break;c.push([A.index,I.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(o="";;){const I=f.exec(t);if(!I)break;const A=c.some(([F,M])=>I.index<M&&F<f.lastIndex);!y.test(I[0])&&!A&&(o+=t.substring(l,I.index)+"<REDACTED: user-file-path>",l=f.lastIndex)}return l<t.length&&(o+=t.substr(l)),o}function r(t){if(!t)return t;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of s)if(o.regex.test(t))return`<REDACTED: ${o.label}>`;return t}function i(t,s){return(0,R.cloneAndChange)(t,o=>{if(o instanceof S||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let c=o.replaceAll("%20"," ");c=n(c,s);for(const y of s)c=c.replace(y,"");return c=r(c),c}})}e.cleanData=i}),define(ae[33],ce([0,1,27,28,49,5,12,7,37,45]),function(ne,e,R,N,L,T,_,D,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(i,t){return i.uuid&&t.uuid?i.uuid===t.uuid:i.id===t.id?!0:(0,R.compareIgnoreCase)(i.id,t.id)===0}e.areSameExtensions=P;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(t){const s=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new v(t.identifier,s,o)}static parse(t){const s=C.exec(t);return s&&s[1]&&s[2]?new v({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof v?P(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=v;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(i){const t=d.exec(i);return t&&t[1]?[a(t[1]),t[2]]:[a(i),void 0]}e.getIdAndVersion=g;function w(i,t){return`${i}.${t}`}e.getExtensionId=w;function a(i){return i.toLowerCase()}e.adoptToGalleryExtensionId=a;function u(i,t){return a(w(i??L.UNDEFINED_PUBLISHER,t))}e.getGalleryExtensionId=u;function h(i,t){const s=[],o=c=>{for(const y of s)if(y.some(f=>P(t(f),t(c))))return y;return null};for(const c of i){const y=o(c);y?y.push(c):s.push([c])}return s}e.groupByExtension=h;function E(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function p(i){return{id:new S.TelemetryTrustedValue(i.identifier.id),name:new S.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function k(i,t){const s=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&s.every(y=>!P(y.identifier,{id:c}))){const y=i.filter(f=>P(f.identifier,{id:c}));y.length===1&&(s.push(y[0]),o.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=k;async function n(i,t){if(!T.isLinux)return!1;let s;try{s=(await i.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await i.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){t.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(c))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(i,t){const s=await n(i,t),o=(0,N.getTargetPlatform)(s?"alpine":T.platform,b.arch);return t.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=r}),define(ae[214],ce([0,1,21,2,22,12,13,24,6,3,15,5,37,33]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let g=e.ExtensionTipsService=class extends N.Disposable{constructor(E,p){super(),this.fileService=E,this.productService=p,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,k])=>this.allConfigBasedTips.set(k.configPath,k))}getConfigBasedTips(E){return this.getValidConfigBasedTips(E)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(E){const p=[];for(const[k,n]of this.allConfigBasedTips)if(!(n.configScheme&&n.configScheme!==E.scheme))try{const r=(await this.fileService.readFile((0,L.joinPath)(E,k))).value.toString();for(const[i,t]of Object.entries(n.recommendations))(!t.contentPattern||new RegExp(t.contentPattern,"mig").test(r))&&p.push({extensionId:i,extensionName:t.name,configName:n.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack,whenNotInstalled:t.whenNotInstalled})}catch{}return p}};e.ExtensionTipsService=g=pe([G(0,_.IFileService),G(1,D.IProductService)],g);const w="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";class u extends g{constructor(E,p,k,n,r,i,t,s){super(t,s),this.userHome=E,this.windowEvents=p,this.telemetryService=k,this.extensionManagementService=n,this.storageService=r,this.extensionRecommendationNotificationService=i,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,s.exeBasedExtensionTips&&Object.entries(s.exeBasedExtensionTips).forEach(([o,c])=>{const y=[],f=[],l=[];Object.entries(c.recommendations).forEach(([I,A])=>{A.important?c.important?y.push({extensionId:I,extensionName:A.name,isExtensionPack:!!A.isExtensionPack}):f.push({extensionId:I,extensionName:A.name,isExtensionPack:!!A.isExtensionPack}):l.push({extensionId:I,extensionName:A.name,isExtensionPack:!!A.isExtensionPack})}),y.length&&this.highImportanceExecutableTips.set(o,{exeFriendlyName:c.friendlyName,windowsPath:c.windowsPath,recommendations:y}),f.length&&this.mediumImportanceExecutableTips.set(o,{exeFriendlyName:c.friendlyName,windowsPath:c.windowsPath,recommendations:f}),l.length&&this.allOtherExecutableTips.set(o,{exeFriendlyName:c.friendlyName,windowsPath:c.windowsPath,recommendations:l})}),(0,b.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const E=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),p=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...E,...p]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const E=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),p=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),k=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(E,k),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(p,k)}groupImportantTipsByExe(E,p){const k=new Map;E.forEach(s=>k.set(s.extensionId.toLowerCase(),s));const{installed:n,uninstalled:r}=this.groupByInstalled([...k.keys()],p);for(const s of n){const o=k.get(s);o&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:s,exeName:o.exeName})}for(const s of r){const o=k.get(s);o&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:s,exeName:o.exeName})}const i=this.getPromptedExecutableTips(),t=new Map;for(const s of r){const o=k.get(s);if(o&&(!i[o.exeName]||!i[o.exeName].includes(o.extensionId))){let c=t.get(o.exeName);c||(c=[],t.set(o.exeName,c)),c.push(o)}}return t}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[E,p]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(p).then(k=>{switch(k){case"reacted":this.addToRecommendedExecutables(p[0].exeName,p);break;case"ignored":this.highImportanceTipsByExe.delete(E);break;case"incompatibleWindow":{const n=S.Event.once(S.Event.latch(S.Event.any(this.windowEvents.onDidOpenWindow,this.windowEvents.onDidFocusWindow)));this._register(n(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const n=this._register((0,b.disposableTimeout)(()=>{n.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const E=this.getLastPromptedMediumExeTime(),p=Date.now()-E,k=7*24*60*60*1e3;if(p<k){const i=this._register((0,b.disposableTimeout)(()=>{i.dispose(),this.promptMediumImportanceExeBasedTip()},k-p));return}const[n,r]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(r).then(i=>{switch(i){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(n),this.addToRecommendedExecutables(r[0].exeName,r);const t=this._register((0,b.disposableTimeout)(()=>{t.dispose(),this.promptMediumImportanceExeBasedTip()},k));break}case"ignored":this.mediumImportanceTipsByExe.delete(n),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const t=S.Event.once(S.Event.latch(S.Event.any(this.windowEvents.onDidOpenWindow,this.windowEvents.onDidFocusWindow)));this._register(t(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const t=this._register((0,b.disposableTimeout)(()=>{t.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(E){const p=await this.extensionManagementService.getInstalled(1),k=E.filter(n=>!n.whenNotInstalled||n.whenNotInstalled.every(r=>p.every(i=>!(0,d.areSameExtensions)(i.identifier,{id:r})))).map(({extensionId:n})=>n.toLowerCase());return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification({extensions:k,source:3,name:E[0].exeFriendlyName,searchValue:`@exe:"${E[0].exeName}"`})}getLastPromptedMediumExeTime(){let E=this.storageService.getNumber(a,-1);return E||(E=Date.now(),this.updateLastPromptedMediumExeTime(E)),E}updateLastPromptedMediumExeTime(E){this.storageService.store(a,E,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(w,-1,"{}"))}addToRecommendedExecutables(E,p){const k=this.getPromptedExecutableTips();k[E]=p.map(({extensionId:n})=>n.toLowerCase()),this.storageService.store(w,JSON.stringify(k),-1,0)}groupByInstalled(E,p){const k=[],n=[],r=p.reduce((i,t)=>(i.add(t.identifier.id.toLowerCase()),i),new Set);return E.forEach(i=>{r.has(i.toLowerCase())?k.push(i):n.push(i)}),{installed:k,uninstalled:n}}async getValidExecutableBasedExtensionTips(E){const p=[],k=new Map;for(const n of E.keys()){const r=E.get(n);if(!r||!(0,R.isNonEmptyArray)(r.recommendations))continue;const i=[];C.isWindows?r.windowsPath&&i.push(r.windowsPath.replace("%USERPROFILE%",()=>v.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>v.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>v.env.ProgramFiles).replace("%APPDATA%",()=>v.env.APPDATA).replace("%WINDIR%",()=>v.env.WINDIR)):(i.push((0,P.join)("/usr/local/bin",n)),i.push((0,P.join)("/usr/bin",n)),i.push((0,P.join)(this.userHome.fsPath,n)));for(const t of i){let s=k.get(t);if(s===void 0&&(s=await this.fileService.exists(T.URI.file(t)),k.set(t,s)),s)for(const{extensionId:o,extensionName:c,isExtensionPack:y,whenNotInstalled:f}of r.recommendations)p.push({extensionId:o,extensionName:c,isExtensionPack:y,exeName:n,exeFriendlyName:r.exeFriendlyName,windowsPath:r.windowsPath,whenNotInstalled:f})}}return p}}e.AbstractNativeExtensionTipsService=u}),define(ae[215],ce([0,1,26,33]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function L(T,_,D,b,S){try{const P=await T.getExtensionsControlManifest();if(!P.deprecated)return;const C=await T.getInstalled(1);for(const[v,d]of Object.entries(P.deprecated)){if(!d?.extension)continue;const{id:g,autoMigrate:w,preRelease:a}=d.extension;if(!w)continue;const u=C.find(E=>(0,N.areSameExtensions)(E.identifier,{id:v}));if(!u)continue;const h=(await _.getExtensions([{id:g,preRelease:a}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!h){S.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${g}' extension is not found`);continue}try{S.info(`Migrating '${u.identifier.id}' extension to '${g}' extension...`);const E=!b.getDisabledExtensions().some(k=>(0,N.areSameExtensions)(k,u.identifier));await T.uninstall(u),S.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let p=C.find(k=>(0,N.areSameExtensions)(k.identifier,{id:g}));(!p||!p.isPreReleaseVersion&&E)&&(p=await T.installFromGallery(h,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),S.info(`Installed the pre-release extension '${p.identifier.id}'`),E||(await b.disableExtension(p.identifier),S.info(`Disabled the pre-release extension '${p.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),w.storage&&(D.addToMigrationList((0,N.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,N.getExtensionId)(p.manifest.publisher,p.manifest.name)),S.info("Added pre-release extension to the storage migration list"))),S.info(`Migrated '${u.identifier.id}' extension to '${g}' extension.`)}catch(E){S.error(E)}}}catch(P){S.error(P)}}e.migrateUnsupportedExtensions=L}),define(ae[216],ce([0,1,3,2,35,33,49]),function(ne,e,R,N,L,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class D extends N.Disposable{constructor(S,P,C,v,d,g,w){super(),this.extensionManagementService=S,this.extensionsScannerService=P,this.userDataProfilesService=C,this.extensionsProfileScannerService=v,this.uriIdentityService=d,this.fileService=g,this.logService=w,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new N.DisposableMap),this.initialize().then(null,a=>w.error(a))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(S=>this.onDidChangeProfiles(S.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(S=>this.onAddExtensions(S))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(S=>this.onDidAddExtensions(S))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(S=>this.onRemoveExtensions(S))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(S=>this.onDidRemoveExtensions(S))),this._register(this.fileService.onDidFilesChange(S=>this.onDidFilesChange(S)))}async onDidChangeProfiles(S){try{S.length&&await Promise.all(S.map(P=>(this.extensionsProfileWatchDisposables.set(P.id,(0,N.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(P.extensionsResource)),this.fileService.watch(P.extensionsResource))),this.populateExtensionsFromProfile(P.extensionsResource))))}catch(P){throw this.logService.error(P),P}}async onAddExtensions(S){for(const P of S.extensions)this.addExtensionWithKey(this.getKey(P.identifier,P.version),S.profileLocation)}async onDidAddExtensions(S){for(const P of S.extensions){const C=this.getKey(P.identifier,P.version);S.error?this.removeExtensionWithKey(C,S.profileLocation):this.addExtensionWithKey(C,S.profileLocation)}}async onRemoveExtensions(S){for(const P of S.extensions)this.removeExtensionWithKey(this.getKey(P.identifier,P.version),S.profileLocation)}async onDidRemoveExtensions(S){const P=[],C=[];for(const v of S.extensions){const d=this.getKey(v.identifier,v.version);S.error?this.addExtensionWithKey(d,S.profileLocation):(this.removeExtensionWithKey(d,S.profileLocation),this.allExtensions.has(d)||(this.logService.debug("Extension is removed from all profiles",v.identifier.id,v.version),C.push(this.extensionManagementService.scanInstalledExtensionAtLocation(v.location).then(g=>{g?P.push(g):this.logService.info("Extension not found at the location",v.location.toString())},g=>this.logService.error(g)))))}try{await Promise.all(C),P.length&&await this.uninstallExtensionsNotInProfiles(P)}catch(v){this.logService.error(v)}}onDidFilesChange(S){for(const P of this.userDataProfilesService.profiles)S.contains(P.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(P.extensionsResource)}async onDidExtensionsProfileChange(S){const P=[],C=[],v=await this.extensionsProfileScannerService.scanProfileExtensions(S),d=new Set,g=new Set;for(const[w,a]of this.allExtensions)a.has(S)&&g.add(w);for(const w of v){const a=this.getKey(w.identifier,w.version);d.add(a),g.has(a)||(P.push(w.identifier),this.addExtensionWithKey(a,S))}for(const w of g)if(!d.has(w)){const a=this.fromKey(w);a&&(C.push(a.identifier),this.removeExtensionWithKey(w,S))}(P.length||C.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:P.length?{extensions:P,profileLocation:S}:void 0,removed:C.length?{extensions:C,profileLocation:S}:void 0})}async populateExtensionsFromProfile(S){const P=await this.extensionsProfileScannerService.scanProfileExtensions(S);for(const C of P)this.addExtensionWithKey(this.getKey(C.identifier,C.version),S)}async uninstallExtensionsNotInProfiles(S){S||(S=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(C=>!this.allExtensions.has(this.getKey(C.identifier,C.manifest.version)))),S.length&&await this.extensionManagementService.markAsUninstalled(...S)}addExtensionWithKey(S,P){let C=this.allExtensions.get(S);C||this.allExtensions.set(S,C=new L.ResourceSet(v=>this.uriIdentityService.extUri.getComparisonKey(v))),C.add(P)}removeExtensionWithKey(S,P){const C=this.allExtensions.get(S);C&&C.delete(P),C?.size||this.allExtensions.delete(S)}getKey(S,P){return`${_.ExtensionIdentifier.toKey(S.id)}@${P}`}fromKey(S){const[P,C]=(0,T.getIdAndVersion)(S);return C?{identifier:{id:P},version:C}:void 0}}e.ExtensionsWatcher=D}),define(ae[217],ce([0,1,44,45]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function L(T,_,D,b,S,P,C){const v={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${_.nameShort})`};if((0,N.supportsTelemetry)(_,D)&&(0,N.getTelemetryLevel)(b)===3){const d=await(0,R.getServiceMachineId)(D,S,P);v["X-Market-User-Id"]=d,v["VSCode-SessionId"]=C.machineId||d}return v}e.resolveMarketplaceHeaders=L}),define(ae[218],ce([0,1,69,21,6,2,25,15,30,14,28,33,8,72,12]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let w=e.NativeLanguagePackService=class extends d.LanguagePackBaseService{constructor(E,p,k,n){super(k),this.extensionManagementService=E,this.logService=n,this.cache=this._register(new a(p,n)),this.extensionManagementService.registerParticipant({postInstall:async r=>this.postInstallExtension(r),postUninstall:async r=>this.postUninstallExtension(r)})}async getBuiltInExtensionTranslationsUri(E,p){const n=(await this.cache.getLanguagePacks())[p];if(!n){this.logService.warn(`No language pack found for ${p}`);return}const r=n.translations[E];return r?g.URI.file(r):void 0}async getInstalledLanguages(){const E=await this.cache.getLanguagePacks(),p=Object.keys(E).map(k=>{const n=E[k];return{...this.createQuickPickItem(k,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return p.push(this.createQuickPickItem("en","English")),p.sort((k,n)=>k.label.localeCompare(n.label)),p}async postInstallExtension(E){E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",E.identifier.id),await this.update())}async postUninstallExtension(E){const p=await this.cache.getLanguagePacks();Object.keys(p).some(k=>p[k]&&p[k].extensions.some(n=>(0,C.areSameExtensions)(n.extensionIdentifier,E.identifier)))&&(this.logService.info("Removing language packs from the extension",E.identifier.id),await this.update())}async update(){const[E,p]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),k=await this.cache.update(p);return!(0,N.equals)(Object.keys(E),Object.keys(k))}};e.NativeLanguagePackService=w=pe([G(0,P.IExtensionManagementService),G(1,S.INativeEnvironmentService),G(2,P.IExtensionGalleryService),G(3,v.ILogService)],w);let a=class extends T.Disposable{constructor(E,p){super(),this.logService=p,this.languagePacks={},this.languagePacksFilePath=(0,D.join)(E.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(E){return this.withLanguagePacks(p=>{Object.keys(p).forEach(k=>delete p[k]),this.createLanguagePacksFromExtensions(p,...E)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(E,...p){for(const k of p)k&&k.manifest&&k.manifest.contributes&&k.manifest.contributes.localizations&&k.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(E,k);Object.keys(E).forEach(k=>this.updateHash(E[k]))}createLanguagePacksFromExtension(E,p){const k=p.identifier,n=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const r of n)if(p.location.scheme===_.Schemas.file&&u(r)){let i=E[r.languageId];i||(i={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},E[r.languageId]=i);const t=i.extensions.filter(s=>(0,C.areSameExtensions)(s.extensionIdentifier,k))[0];t?t.version=p.manifest.version:i.extensions.push({extensionIdentifier:k,version:p.manifest.version});for(const s of r.translations)i.translations[s.id]=(0,D.join)(p.location.fsPath,s.path)}}updateHash(E){if(E){const p=(0,R.createHash)("md5");for(const k of E.extensions)p.update(k.extensionIdentifier.uuid||k.extensionIdentifier.id).update(k.version);E.hash=p.digest("hex")}}withLanguagePacks(E=()=>null){return this.languagePacksFileLimiter.queue(()=>{let p=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,k=>k.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(k)).then(k=>{try{return JSON.parse(k)}catch{return{}}}).then(k=>(p=E(k),k)).then(k=>{for(const r of Object.keys(k))k[r]||delete k[r];this.languagePacks=k,this.initializedCache=!0;const n=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",n),b.Promises.writeFile(this.languagePacksFilePath,n)}).then(()=>p,k=>this.logService.error(k))})}};a=pe([G(0,S.INativeEnvironmentService),G(1,v.ILogService)],a);function u(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const E of h.translations)if(typeof E.id!="string"||typeof E.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(ae[219],ce([0,1,7,31,45]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://0.0.0.0/OneCollector/1.0",_="https://0.0.0.0/ping";async function D(S,P,C){const v=await new Promise((u,h)=>{ne(["@microsoft/1ds-core-js"],u,h)}),d=await new Promise((u,h)=>{ne(["@microsoft/1ds-post-js"],u,h)}),g=new v.AppInsightsCore,w=new d.PostChannel,a={instrumentationKey:S,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(C){a.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:C};a.extensionConfig[w.identifier]=u}return g.initialize(a,[]),g.addTelemetryInitializer(u=>{P&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),g}class b{constructor(P,C,v,d,g){this._isInternalTelemetry=P,this._eventPrefix=C,this._defaultData=v,this._xhrOverride=g,this.endPointUrl=T,this.endPointHealthUrl=_,this._defaultData||(this._defaultData={}),typeof d=="function"?this._aiCoreOrKey=d():this._aiCoreOrKey=d,this._asyncAiCore=null}_withAIClient(P){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){P(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=D(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(C=>{P(C)},C=>{(0,R.onUnexpectedError)(C),console.error(C)})}}log(P,C){if(!this._aiCoreOrKey)return;C=(0,N.mixin)(C,this._defaultData),C=(0,L.validateTelemetryData)(C);const v=this._eventPrefix+"/"+P;try{this._withAIClient(d=>{d.pluginVersionString=C?.properties.version??"Unknown",d.track({name:v,baseData:{name:v,properties:C?.properties,measurements:C?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(P=>{this._withAIClient(C=>{C.unload(!0,()=>{this._aiCoreOrKey=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=b}),define(ae[109],ce([0,1,2,160,14,8,24,45]),function(ne,e,R,N,L,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let b=e.TelemetryLogAppender=class extends R.Disposable{constructor(P,C,v,d,g=""){super(),this.prefix=g;const w=C.getLogger(D.telemetryLogId);if(w)this.logger=this._register(w);else{const u=(0,D.isLoggingOnly)(d,v)?" (Not Sent)":"",h=()=>(0,D.supportsTelemetry)(d,v)&&P.getLevel()===T.LogLevel.Trace;this.logger=this._register(C.createLogger(D.telemetryLogId,{name:(0,N.localize)(0,null,u),hidden:!h()})),this._register(P.onDidChangeLogLevel(()=>C.setVisibility(D.telemetryLogId,h()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,C){this.logger.trace(`${this.prefix}telemetry/${P}`,(0,D.validateTelemetryData)(C))}};e.TelemetryLogAppender=b=pe([G(0,T.ILogService),G(1,T.ILoggerService),G(2,L.IEnvironmentService),G(3,_.IProductService)],b)}),define(ae[110],ce([0,1,2,31,5,27,161,18,48,102,24,40,20,45]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=e.TelemetryService=class{constructor(u,h,E){this._configurationService=h,this._productService=E,this._experimentProperties={},this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=u.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(p),"gi")),p.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(p.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(p=>{(p.affectsConfiguration(v.TELEMETRY_SETTING_ID)||p.affectsConfiguration(v.TELEMETRY_OLD_SETTING_ID)||p.affectsConfiguration(v.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(u,h){this._experimentProperties[u]=h}_updateTelemetryLevel(){let u=(0,d.getTelemetryLevel)(this._configurationService);const h=this._productService.enabledTelemetryLevels;if(h){this._sendErrorTelemetry=this.sendErrorTelemetry?h.error:!1;const E=h.usage?3:h.error?2:0;u=Math.min(u,E)}this._telemetryLevel=u}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(u,h,E){this._telemetryLevel<h||(E=(0,N.mixin)(E,this._experimentProperties),E=(0,d.cleanData)(E,this._cleanupPatterns),E=(0,N.mixin)(E,this._commonProperties),this._appenders.forEach(p=>p.log(u,E)))}publicLog(u,h){this._log(u,3,h)}publicLog2(u,h){this.publicLog(u,h)}publicLogError(u,h){this._sendErrorTelemetry&&this._log(u,2,h)}publicLogError2(u,h){this.publicLogError(u,h)}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=g=pe([G(1,D.IConfigurationService),G(2,P.IProductService)],g);function w(){const a=(0,_.localize)(0,null,S.default.nameLong),u=S.default.privacyStatementUrl?(0,_.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,_.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=L.isWeb?"":(0,_.localize)(3,null),E=(0,_.localize)(4,null),p=(0,_.localize)(5,null),k=(0,_.localize)(6,null),n=(0,_.localize)(7,null),r=`
|       | ${E} | ${p} | ${k} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,_.localize)(8,null);return`
${a} ${u} ${h}

&nbsp;

${n}
${r}

&nbsp;

${i}
`}C.Registry.as(b.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,_.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,_.localize)(10,null),(0,_.localize)(11,null),(0,_.localize)(12,null),(0,_.localize)(13,null)],markdownDescription:w(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(b.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,_.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,_.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,_.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,_.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[220],ce([0,1,264,219]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class L extends N.AbstractOneDataSystemAppender{constructor(_,D,b,S){const P={sendPOST:(C,v)=>{const d={method:"POST",headers:{...C.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(C.data)}};try{const g=R.request(C.urlString,d,w=>{w.on("data",function(a){v(w.statusCode??200,w.headers,a.toString())}),w.on("error",function(a){v(0,{})})});g.write(C.data),g.end()}catch{v(0,{})}}};super(_,D,b,S,P)}}e.OneDataSystemAppender=L}),define(ae[221],ce([0,1,25,93,18,14,8,24,20,108,109,110]),function(ne,e,R,N,L,T,_,D,b,S,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let v=e.CustomEndpointTelemetryService=class{constructor(g,w,a,u,h,E){this.configurationService=g,this.telemetryService=w,this.logService=a,this.loggerService=u,this.environmentService=h,this.productService=E,this.customTelemetryServices=new Map}getCustomTelemetryService(g){if(!this.customTelemetryServices.has(g.id)){const w=Object.create(null);w["common.vscodemachineid"]=this.telemetryService.machineId,w["common.vscodesessionid"]=this.telemetryService.sessionId;const a=[g.id,JSON.stringify(w),g.aiKey],h=new N.Client(R.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:a,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),E=[new S.TelemetryAppenderClient(h),new P.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${g.id}] `)];this.customTelemetryServices.set(g.id,new C.TelemetryService({appenders:E,sendErrorTelemetry:g.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(g.id)}publicLog(g,w,a){this.getCustomTelemetryService(g).publicLog(w,a)}publicLogError(g,w,a){this.getCustomTelemetryService(g).publicLogError(w,a)}};e.CustomEndpointTelemetryService=v=pe([G(0,L.IConfigurationService),G(1,b.ITelemetryService),G(2,_.ILogService),G(3,_.ILoggerService),G(4,T.IEnvironmentService),G(5,D.IProductService)],v)}),define(ae[76],ce([0,1,3,18,4,8]),function(ne,e,R,N,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var _;(function(w){w.Http="http",w.Https="https"})(_||(e.TunnelProtocol=_={}));var D;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(D||(e.TunnelPrivacyId=D={}));var b;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function S(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(a)return{address:a[1],port:+a[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(w){return e.LOCALHOST_ADDRESSES.indexOf(w)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(w){return e.ALL_INTERFACES_ADDRESSES.indexOf(w)>=0}e.isAllInterfaces=C;function v(w,a,u,h){if(u===1)return!1;if(u===2&&C(a)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(E?.length===4&&parseInt(E[1])>=18)return!1}return w<1024}e.isPortPrivileged=v;class d{constructor(a,u,h){this.remoteAddress=a,this.localAddress=u,this._dispose=h,this._onDispose=new R.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=d;let g=e.AbstractTunnelService=class{constructor(a,u){this.logService=a,this.configurationService=u,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const a=this.configurationService.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(a){return this._tunnelProvider=a,a?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this._canElevate=a.elevation,this._privacyOptions=a.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const a=[],u=Array.from(this._tunnels.values());for(const h of u){const E=Array.from(h.values());for(const p of E){const k=await p.value;k&&a.push(k)}}return a}async dispose(){for(const a of this._tunnels.values()){for(const{value:u}of a.values())await u.then(h=>h?.dispose());a.clear()}this._tunnels.clear()}setEnvironmentTunnel(a,u,h,E,p){this.addTunnelToMap(a,u,Promise.resolve({tunnelRemoteHost:a,tunnelRemotePort:u,localAddress:h,privacy:E,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(a,u){(C(a)||P(a))&&(a=e.LOCALHOST_ADDRESSES[0]);const h=this.getTunnelFromMap(a,u);if(h)return++h.refcount,h.value}openTunnel(a,u,h,E,p,k=!1,n,r){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${h} on local port ${p}.`),!a)return;if(u||(u="localhost"),E||(E=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(h)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.retainOrCreateTunnel(a,u,h,E,p,k,n,r);return i?i.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(u,h);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(t);return(t.tunnelRemoteHost!==u||t.tunnelRemotePort!==h)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&t.privacy!==n&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const u=this._tunnels.get(a.tunnelRemoteHost);if(u){const h=u.get(a.tunnelRemotePort);h&&(h.refcount--,await this.tryDisposeTunnel(a.tunnelRemoteHost,a.tunnelRemotePort,h))}}}}async tryDisposeTunnel(a,u,h){if(h.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${u}.`);const E=h.value.then(async p=>{p&&(await p.dispose(!0),this._onTunnelClosed.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this._tunnels.has(a)&&this._tunnels.get(a).delete(u),E}}async closeTunnel(a,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${u} `);const h=this._tunnels.get(a);if(h&&h.has(u)){const E=h.get(u);E.refcount=0,await this.tryDisposeTunnel(a,u,E)}}addTunnelToMap(a,u,h){this._tunnels.has(a)||this._tunnels.set(a,new Map),this._tunnels.get(a).set(u,{refcount:1,value:h})}async removeEmptyTunnelFromMap(a,u){const h=this._tunnels.get(a);if(h){const E=h.get(u);(E?await E.value:void 0)||h.delete(u),h.size===0&&this._tunnels.delete(a)}}getTunnelFromMap(a,u){const h=[a];P(a)?(h.push(...e.LOCALHOST_ADDRESSES),h.push(...e.ALL_INTERFACES_ADDRESSES)):C(a)&&h.push(...e.ALL_INTERFACES_ADDRESSES);const E=h.map(p=>this._tunnels.get(p));for(const p of E){const k=p?.get(u);if(k)return k}}canTunnel(a){return!!S(a)}createWithProvider(a,u,h,E,p,k,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${h} on local port ${E}.`);const r=h;this._factoryInProgress.add(r);const i=E===void 0?h:E,t={elevationRequired:p?this.isPortPrivileged(i):!1},s={remoteAddress:{host:u,port:h},localAddressPort:E,privacy:k,public:k?k!==D.Private:void 0,protocol:n},o=a.forwardPort(s,t);return o?(this.addTunnelToMap(u,h,o),o.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),o}};e.AbstractTunnelService=g=pe([G(0,T.ILogService),G(1,N.IConfigurationService)],g)}),define(ae[222],ce([0,1,8,76,2,7,6]),function(ne,e,R,N,L,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class D extends L.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new _.DeferredPromise),this._addressPromise.p)}setAddress(P){this._address=P,this._addressPromise&&(this._addressPromise.complete(P),this._addressPromise=null)}setTunnel(P){this._register(P)}}let b=e.SharedProcessTunnelService=class Ct extends L.Disposable{constructor(P,C){super(),this._tunnelService=P,this._logService=C,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(P,C,v,d,g,w,a){const u=new D,h=await Promise.resolve(this._tunnelService.openTunnel(P,u,v,d,g,w,a));if(!h)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${v}:${d} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(C))throw this._disposedTunnels.delete(C),u.dispose(),await h.dispose(),(0,T.canceled)();return u.setTunnel(h),this._tunnels.set(C,u),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${C}: ${h.localAddress} (local) to ${v}:${d} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(P,C){const v=this._tunnels.get(P);v&&v.setAddress(C)}async destroyTunnel(P){const C=this._tunnels.get(P);if(C){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this._tunnels.delete(P),await C.dispose();return}this._disposedTunnels.add(P)}};b._lastId=0,e.SharedProcessTunnelService=b=pe([G(0,N.ISharedTunnelsService),G(1,R.ILogService)],b)}),define(ae[223],ce([0,1,62,36,128,6,2,18,8,24,206,76,106,5,104]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function w(p,k,n,r,i){let t;for(let s=3;s&&(t?.dispose(),t=await new a(p,k,n,r,i).waitForReady(),!(i&&L.BROWSER_RESTRICTED_PORTS[i]||!L.BROWSER_RESTRICTED_PORTS[t.tunnelLocalPort]));s--);return t}class a extends _.Disposable{constructor(k,n,r,i,t){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=t,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=k,this._server=R.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const k=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,C.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let r=await(0,L.findFreePortFaster)(k,2,1e3,n),i=null;return this._server.listen(r,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address(),i||(r=0,this._server.listen(r,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async _onConnection(k){k.pause();const n=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,P.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),i=r.getSocket().socket,t=r.readEntireBuffer();r.dispose(),t.byteLength>0&&k.write(t.buffer),k.on("end",()=>{k.localAddress&&this._socketsDispose.delete(k.localAddress),i.end()}),k.on("close",()=>i.end()),k.on("error",()=>{k.localAddress&&this._socketsDispose.delete(k.localAddress),i.destroy()}),i.on("end",()=>k.end()),i.on("close",()=>k.end()),i.on("error",()=>{k.destroy()}),k.pipe(i),i.pipe(k),k.localAddress&&this._socketsDispose.set(k.localAddress,()=>{k.end(),i.end()})}}let u=e.BaseTunnelService=class extends C.AbstractTunnelService{constructor(k,n,r,i,t){super(n,t),this.remoteSocketFactoryService=k,this.signService=r,this.productService=i}isPortPrivileged(k){return(0,C.isPortPrivileged)(k,this.defaultTunnelHost,d.OS,N.release())}retainOrCreateTunnel(k,n,r,i,t,s,o,c){const y=this.getTunnelFromMap(n,r);if(y)return++y.refcount,y.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,n,r,t,s,o,c);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${r} on local port ${t}.`);const f={commit:this.productService.commit,quality:this.productService.quality,addressProvider:k,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},l=w(f,i,n,r,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,r,l),l}}};e.BaseTunnelService=u=pe([G(0,g.IRemoteSocketFactoryService),G(1,b.ILogService),G(2,v.ISignService),G(3,S.IProductService),G(4,D.IConfigurationService)],u);let h=e.TunnelService=class extends u{constructor(k,n,r,i,t){super(k,n,r,i,t)}};e.TunnelService=h=pe([G(0,g.IRemoteSocketFactoryService),G(1,b.ILogService),G(2,v.ISignService),G(3,S.IProductService),G(4,D.IConfigurationService)],h);let E=e.SharedTunnelsService=class extends _.Disposable{constructor(k,n,r,i,t){super(),this.remoteSocketFactoryService=k,this.logService=n,this.productService=r,this.signService=i,this.configurationService=t,this._tunnelServices=new Map}async openTunnel(k,n,r,i,t,s,o,c,y){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${i} on local port ${s}.`),!this._tunnelServices.has(k)){const f=new h(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(f),this._tunnelServices.set(k,f),f.onTunnelClosed(async()=>{(await f.tunnels).length===0&&(f.dispose(),this._tunnelServices.delete(k))})}return this._tunnelServices.get(k).openTunnel(n,r,i,t,s,o,c,y)}};e.SharedTunnelsService=E=pe([G(0,g.IRemoteSocketFactoryService),G(1,b.ILogService),G(2,S.IProductService),G(3,v.ISignService),G(4,D.IConfigurationService)],E)}),define(ae[29],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,R.createDecorator)("IUriIdentityService")}),define(ae[224],ce([0,1,29,178,13,22,123,3,2]),function(ne,e,R,N,L,T,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{constructor(v){this.uri=v,this.time=S._clock++}touch(){return this.time=S._clock++,this}}S._clock=0;let P=e.UriIdentityService=class{constructor(v){this._fileService=v,this._dispooables=new b.DisposableStore,this._limit=2**16;const d=new Map,g=w=>{let a=d.get(w.scheme);return a===void 0&&(a=v.hasProvider(w)&&!this._fileService.hasCapability(w,1024),d.set(w.scheme,a)),a};this._dispooables.add(D.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(w=>{d.delete(w.scheme)})),this.extUri=new T.ExtUri(g),this._canonicalUris=new _.SkipList((w,a)=>this.extUri.compare(w,a,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(v){this._fileService.hasProvider(v)&&(v=(0,T.normalizePath)(v));const d=this._canonicalUris.get(v);return d?d.touch().uri.with({fragment:v.fragment}):(this._canonicalUris.set(v,new S(v)),this._checkTrim(),v)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const v=[...this._canonicalUris.entries()].sort((g,w)=>g[1].time<w[1].time?1:g[1].time>w[1].time?-1:0);S._clock=0,this._canonicalUris.clear();const d=this._limit*.5;for(let g=0;g<d;g++)this._canonicalUris.set(v[g][0],v[g][1].touch())}};e.UriIdentityService=P=pe([G(0,L.IFileService)],P),(0,N.registerSingleton)(R.IUriIdentityService,P,1)}),define(ae[225],ce([0,1,3,2,13,42,46,16]),function(ne,e,R,N,L,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class b extends N.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(P,C,v,d){super(),this.fileSystemScheme=P,this.fileSystemProvider=C,this.userDataScheme=v,this.logService=d,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=_.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(g=>this.handleFileChanges(g)))}watch(P,C){this.watchResources.set(P,P);const v=this.fileSystemProvider.watch(this.toFileSystemResource(P),C);return(0,N.toDisposable)(()=>{this.watchResources.delete(P),v.dispose()})}stat(P){return this.fileSystemProvider.stat(this.toFileSystemResource(P))}mkdir(P){return this.fileSystemProvider.mkdir(this.toFileSystemResource(P))}rename(P,C,v){return this.fileSystemProvider.rename(this.toFileSystemResource(P),this.toFileSystemResource(C),v)}readFile(P){return this.fileSystemProvider.readFile(this.toFileSystemResource(P),{atomic:!0})}readFileStream(P,C,v){const d=(0,T.newWriteableStream)(g=>D.VSBuffer.concat(g.map(w=>D.VSBuffer.wrap(w))).buffer);return(async()=>{try{const g=await this.readFile(P);d.end(g)}catch(g){d.error(g),d.end()}})(),d}readdir(P){return this.fileSystemProvider.readdir(this.toFileSystemResource(P))}writeFile(P,C,v){return this.fileSystemProvider.writeFile(this.toFileSystemResource(P),C,v)}delete(P,C){return this.fileSystemProvider.delete(this.toFileSystemResource(P),C)}copy(P,C,v){if((0,L.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(P),this.toFileSystemResource(C),v);throw new Error("copy not supported")}handleFileChanges(P){const C=[];for(const v of P){if(v.resource.scheme!==this.fileSystemScheme)continue;const d=this.toUserDataResource(v.resource);this.watchResources.findSubstr(d)&&C.push({resource:d,type:v.type})}C.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(C))}toFileSystemResource(P){return P.with({scheme:this.fileSystemScheme})}toUserDataResource(P){return P.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=b}),define(ae[57],ce([0,1,83]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function N(_,D,b,S){const P=(0,R.setProperty)(_,D,b,S)[0];return P&&(_=_.substring(0,P.offset)+P.content+_.substring(P.offset+P.length)),_}e.edit=N;function L(_,D,b){let S=b;for(;S>=0;){if(_.charAt(S)===D.charAt(D.length-1)&&D.length===1)return S+1;if(S--,D.length===2&&S>=0&&_.charAt(S)===D.charAt(0))return S+2}return 0}e.getLineStartOffset=L;function T(_,D,b){let S=b;for(;S>=0;)if(_.charAt(S)===D.charAt(D.length-1)&&D.length===1||(S++,D.length===2&&S>=0&&_.charAt(S)===D.charAt(1)))return S;return _.length-1}e.getLineEndOffset=T}),define(ae[226],ce([0,1,31,52,10]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(d,g,w,a,u,h){const E=[],p=[],k=[];if(!g){const x=d.filter(({identifier:q})=>u.every(X=>X.toLowerCase()!==q.id.toLowerCase()));return{local:{added:E,removed:p,updated:k},remote:x.length>0?{added:x,updated:[],removed:[],all:x}:null}}d=d.map(C),g=g.map(C),w=w?w.map(C):null;const n=new Map,r=x=>{x.uuid&&n.set(x.id.toLowerCase(),x.uuid)};d.forEach(({identifier:x})=>r(x)),g.forEach(({identifier:x})=>r(x)),w?.forEach(({identifier:x})=>r(x));const i=x=>{const q=x.identifier.uuid||n.get(x.identifier.id.toLowerCase());return q?`uuid:${q}`:`id:${x.identifier.id.toLowerCase()}`},t=(x,q)=>(x.set(i(q),q),x),s=d.reduce(t,new Map),o=g.reduce(t,new Map),c=g.reduce((x,q)=>t(x,(0,R.deepClone)(q)),new Map),y=w?w.reduce(t,new Map):null,f=a.reduce(t,new Map),l=u.reduce((x,q)=>{const X=n.get(q.toLowerCase());return x.add(X?`uuid:${X}`:`id:${q.toLowerCase()}`)},new Set),I=h?h.reduce((x,{id:q,uuid:X})=>(X=X??n.get(q.toLowerCase()),x.add(X?`uuid:${X}`:`id:${q.toLowerCase()}`)),new Set):null,A=_(s,o,l,!1);if(A.added.size>0||A.removed.size>0||A.updated.size>0){const x=_(y,s,l,!1),q=_(y,o,l,!0),X=(ee,Y,Z,j)=>{let B,z,ie;return Y.installed?(B=j.pinned,ie=j.preRelease,B&&(z=j.version)):(B=Z.pinned,ie=Z.preRelease,B&&(z=Z.version)),B===void 0&&(B=Y.pinned,B&&(z=Y.version)),ie===void 0&&(ie=Y.preRelease),{...j,installed:Y.installed||Z.installed,pinned:B,preRelease:ie,version:z??(Z.version&&(!Y.installed||N.gt(Z.version,Y.version))?Z.version:Y.version),state:b(Y,Z,y?.get(ee))}};for(const ee of q.removed.values()){const Y=s.get(ee);if(!Y)continue;const Z=(0,L.assertIsDefined)(y?.get(ee)),j=I&&!I.has(ee)&&Z.installed;Y.installed&&j?p.push(Y.identifier):c.set(ee,Y)}for(const ee of q.added.values()){const Y=(0,L.assertIsDefined)(o.get(ee)),Z=s.get(ee);if(Z){if(A.updated.has(ee)){const j=X(ee,Z,Y,Y);D(Z,Y,!1,!1)||k.push(v(j,ee)),c.set(ee,j)}}else Y.installed&&E.push(v(Y,ee))}for(const ee of q.updated.values()){const Y=(0,L.assertIsDefined)(o.get(ee)),Z=(0,L.assertIsDefined)(y?.get(ee)),j=s.get(ee);if(j)if(I&&!I.has(ee)&&Z.installed&&j.installed&&!Y.installed)p.push(j.identifier);else{const z=X(ee,j,Y,Y);k.push(v(z,ee)),c.set(ee,z)}else Y.installed&&E.push(v(Y,ee))}for(const ee of x.added.values())q.added.has(ee)||c.set(ee,(0,L.assertIsDefined)(s.get(ee)));for(const ee of x.updated.values()){if(q.removed.has(ee)||q.updated.has(ee))continue;const Y=(0,L.assertIsDefined)(s.get(ee)),Z=(0,L.assertIsDefined)(o.get(ee));c.set(ee,X(ee,Y,Z,Y))}for(const ee of x.removed.values())q.updated.has(ee)||q.removed.has(ee)||f.has(ee)||(0,L.assertIsDefined)(o.get(ee)).installed&&I&&(I.has(ee)||!(0,L.assertIsDefined)(y?.get(ee)).installed||c.delete(ee))}const F=[],M=_(o,c,new Set,!0),V=M.added.size>0||M.updated.size>0||M.removed.size>0;return V&&c.forEach((x,q)=>F.push(v(x,q))),{local:{added:E,removed:p,updated:k},remote:V?{added:[...M.added].map(x=>c.get(x)),updated:[...M.updated].map(x=>c.get(x)),removed:[...M.removed].map(x=>o.get(x)),all:F}:null}}e.merge=T;function _(d,g,w,a){const u=d?[...d.keys()].filter(n=>!w.has(n)):[],h=[...g.keys()].filter(n=>!w.has(n)),E=h.filter(n=>!u.includes(n)).reduce((n,r)=>(n.add(r),n),new Set),p=u.filter(n=>!h.includes(n)).reduce((n,r)=>(n.add(r),n),new Set),k=new Set;for(const n of u){if(p.has(n))continue;const r=d.get(n),i=g.get(n);(!i||!D(r,i,a,!0))&&k.add(n)}return{added:E,removed:p,updated:k}}function D(d,g,w,a){return!(d.disabled!==g.disabled||a&&d.installed!==g.installed||d.installed&&g.installed&&(d.preRelease!==g.preRelease||d.pinned!==g.pinned||g.pinned&&d.version!==g.version)||!P(d.state,g.state)||w&&d.version!==g.version)}function b(d,g,w){const a=d.state,u=g.state,h=w?.state;if(!g.version||a&&N.gt(d.version,g.version))return a;if(u&&N.gt(g.version,d.version)||!a)return u;if(!u)return a;const E=(0,R.deepClone)(a),p=h?S(h,u):{added:Object.keys(u).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set},k=h?S(h,a):{added:Object.keys(a).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set};for(const n of[...p.added.values(),...p.updated.values()])E[n]=u[n];for(const n of p.removed.values())k.updated.has(n)||delete E[n];return E}function S(d,g){const w=Object.keys(d),a=Object.keys(g),u=a.filter(p=>!w.includes(p)).reduce((p,k)=>(p.add(k),p),new Set),h=w.filter(p=>!a.includes(p)).reduce((p,k)=>(p.add(k),p),new Set),E=new Set;for(const p of w){if(h.has(p))continue;const k=d[p],n=g[p];(0,R.equals)(k,n)||E.add(p)}return{added:u,removed:h,updated:E}}function P(d={},g={}){const{added:w,removed:a,updated:u}=S(d,g);return w.size===0&&a.size===0&&u.size===0}function C(d){return{...d,disabled:!!d.disabled,installed:!!d.installed}}function v(d,g){const w={identifier:{id:d.identifier.id,uuid:g.startsWith("uuid:")?g.substring(5):void 0},version:d.version,preRelease:!!d.preRelease,pinned:!!d.pinned};return d.disabled&&(w.disabled=!0),d.installed&&(w.installed=!0),d.state&&(w.state=d.state),w}}),define(ae[111],ce([0,1,21,18,4]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,L.createDecorator)("IIgnoredExtensionsManagementService");let T=e.IgnoredExtensionsManagementService=class{constructor(D){this.configurationService=D}hasToNeverSyncExtension(D){return this.getConfiguredIgnoredExtensions().includes(D.toLowerCase())}hasToAlwaysSyncExtension(D){return this.getConfiguredIgnoredExtensions().includes(`-${D.toLowerCase()}`)}updateIgnoredExtensions(D,b){let S=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return S=S.filter(P=>P!==D&&P!==`-${D}`),b&&S.push(D.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}updateSynchronizedExtensions(D,b){let S=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return S=S.filter(P=>P!==D&&P!==`-${D}`),b&&S.push(`-${D.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}getIgnoredExtensions(D){const b=D.filter(v=>v.isMachineScoped).map(v=>v.identifier.id.toLowerCase()),S=this.getConfiguredIgnoredExtensions().map(v=>v.toLowerCase()),P=[],C=[];if(Array.isArray(S))for(const v of S)v.startsWith("-")?C.push(v.substring(1)):P.push(v);return(0,R.distinct)([...b,...P].filter(v=>!C.includes(v)))}getConfiguredIgnoredExtensions(){let D=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return D!==void 0||(D=this.configurationService.inspect("sync.ignoredExtensions").userValue,D!==void 0)?D:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(b=>b.toLowerCase())}};e.IgnoredExtensionsManagementService=T=pe([G(0,N.IConfigurationService)],T)}),define(ae[227],ce([0,1,21,34,31,94,57]),function(ne,e,R,N,L,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(p){return(0,N.parse)(p)||[]}async function b(p,k,n,r,i){const t=D(p),s=D(k),o=n?D(n):null,c=[...t,...s,...o||[]].map(X=>X.key),y=await i.resolveUserBindings(c),f=P(t,s,o,y);if(!f.hasLocalForwarded&&!f.hasRemoteForwarded)return{mergeContent:p,hasChanges:!1,hasConflicts:!1};if(!f.hasLocalForwarded&&f.hasRemoteForwarded)return{mergeContent:k,hasChanges:!0,hasConflicts:!1};if(f.hasLocalForwarded&&!f.hasRemoteForwarded)return{mergeContent:p,hasChanges:!0,hasConflicts:!1};const l=v(t),I=v(s),A=o?v(o):null,F=g(l,I,y),M=A?g(A,l,y):{added:[...l.keys()].reduce((X,ee)=>(X.add(ee),X),new Set),removed:new Set,updated:new Set},V=A?g(A,I,y):{added:[...I.keys()].reduce((X,ee)=>(X.add(ee),X),new Set),removed:new Set,updated:new Set},x=S(F,M,V);let q=p;for(const X of x.removed.values())x.conflicts.has(X)||(q=h(q,X,r));for(const X of x.added.values()){if(x.conflicts.has(X))continue;const ee=I.get(X);if(ee.some(Y=>Y.command!==`-${X}`&&f.conflicts.has(y[Y.key]))){x.conflicts.add(X);continue}q=u(q,ee,r)}for(const X of x.updated.values()){if(x.conflicts.has(X))continue;const ee=I.get(X);if(ee.some(Y=>Y.command!==`-${X}`&&f.conflicts.has(y[Y.key]))){x.conflicts.add(X);continue}q=E(q,X,ee,r)}return{mergeContent:q,hasChanges:!0,hasConflicts:x.conflicts.size>0}}e.merge=b;function S(p,k,n){const r=new Set,i=new Set,t=new Set,s=new Set;for(const o of k.removed.values())n.updated.has(o)&&s.add(o);for(const o of n.removed.values())s.has(o)||(k.updated.has(o)?s.add(o):i.add(o));for(const o of k.added.values())s.has(o)||n.added.has(o)&&p.updated.has(o)&&s.add(o);for(const o of n.added.values())s.has(o)||(k.added.has(o)?p.updated.has(o)&&s.add(o):r.add(o));for(const o of k.updated.values())s.has(o)||n.updated.has(o)&&p.updated.has(o)&&s.add(o);for(const o of n.updated.values())s.has(o)||(k.updated.has(o)?p.updated.has(o)&&s.add(o):t.add(o));return{added:r,removed:i,updated:t,conflicts:s}}function P(p,k,n,r){const i=new Set,t=C(p,r),s=C(k,r),o=n?C(n,r):null,c=d(t,s);if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const y=o?d(o,t):{added:[...t.keys()].reduce((M,V)=>(M.add(V),M),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const f=o?d(o,s):{added:[...s.keys()].reduce((M,V)=>(M.add(V),M),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:l,removed:I,updated:A,conflicts:F}=S(c,y,f);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:l,removed:I,updated:A,conflicts:F}}function C(p,k){const n=new Map;for(const r of p){const i=k[r.key];let t=n.get(i);t||(t=[],n.set(i,t)),t.push(r)}return n}function v(p){const k=new Map;for(const n of p){const r=n.command[0]==="-"?n.command.substring(1):n.command;let i=k.get(r);i||(i=[],k.set(r,i)),i.push(n)}return k}function d(p,k){const n=[...p.keys()],r=[...k.keys()],i=r.filter(o=>!n.includes(o)).reduce((o,c)=>(o.add(c),o),new Set),t=n.filter(o=>!r.includes(o)).reduce((o,c)=>(o.add(c),o),new Set),s=new Set;for(const o of n){if(t.has(o))continue;const c=p.get(o).map(f=>({...f,key:o})),y=k.get(o).map(f=>({...f,key:o}));(0,R.equals)(c,y,(f,l)=>a(f,l))||s.add(o)}return{added:i,removed:t,updated:s}}function g(p,k,n){const r=[...p.keys()],i=[...k.keys()],t=i.filter(c=>!r.includes(c)).reduce((c,y)=>(c.add(y),c),new Set),s=r.filter(c=>!i.includes(c)).reduce((c,y)=>(c.add(y),c),new Set),o=new Set;for(const c of r){if(s.has(c))continue;const y=p.get(c).map(l=>({...l,key:n[l.key]})),f=k.get(c).map(l=>({...l,key:n[l.key]}));w(y,f)||o.add(c)}return{added:t,removed:s,updated:o}}function w(p,k){return!(!(0,R.equals)(p.filter(({command:n})=>n[0]!=="-"),k.filter(({command:n})=>n[0]!=="-"),(n,r)=>a(n,r))||!(0,R.equals)(p.filter(({command:n})=>n[0]==="-"),k.filter(({command:n})=>n[0]==="-"),(n,r)=>a(n,r)))}function a(p,k){if(p.command!==k.command||p.key!==k.key)return!1;const n=T.ContextKeyExpr.deserialize(p.when),r=T.ContextKeyExpr.deserialize(k.when);return!(n&&!r||!n&&r||n&&r&&!n.equals(r)||!L.equals(p.args,k.args))}function u(p,k,n){for(const r of k)p=_.edit(p,[-1],r,n);return p}function h(p,k,n){const r=D(p);for(let i=r.length-1;i>=0;i--)(r[i].command===k||r[i].command===`-${k}`)&&(p=_.edit(p,[i],void 0,n));return p}function E(p,k,n,r){const i=D(p),t=i.findIndex(s=>s.command===k||s.command===`-${k}`);for(let s=i.length-1;s>=0;s--)(i[s].command===k||i[s].command===`-${k}`)&&(p=_.edit(p,[s],void 0,r));for(let s=n.length-1;s>=0;s--)p=_.edit(p,[t],n[s],r);return p}}),define(ae[228],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(T,_,D){const b={},S={},P=new Set;if(!_)return{local:{added:b,updated:S,removed:[...P.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const C=N(T,_);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:b,updated:S,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const v=N(D,T),d=N(D,_),g={},w={},a=new Set,u=new Set;for(const h of v.removed.values())d.updated.has(h)?b[h]=_[h]:a.add(h);for(const h of d.removed.values())u.has(h)||(v.updated.has(h)?u.add(h):P.add(h));for(const h of v.updated.values())u.has(h)||(d.updated.has(h)?C.updated.has(h)&&u.add(h):w[h]=T[h]);for(const h of d.updated.values())u.has(h)||(v.updated.has(h)?C.updated.has(h)&&u.add(h):T[h]!==void 0&&(S[h]=_[h]));for(const h of v.added.values())u.has(h)||(d.added.has(h)?C.updated.has(h)&&u.add(h):g[h]=T[h]);for(const h of d.added.values())u.has(h)||(v.added.has(h)?C.updated.has(h)&&u.add(h):b[h]=_[h]);return{local:{added:b,removed:[...P.values()],updated:S},remote:{added:g,removed:[...a.values()],updated:w},conflicts:[...u.values()]}}e.merge=R;function N(T,_){const D=T?Object.keys(T):[],b=_?Object.keys(_):[],S=b.filter(v=>!D.includes(v)).reduce((v,d)=>(v.add(d),v),new Set),P=D.filter(v=>!b.includes(v)).reduce((v,d)=>(v.add(d),v),new Set),C=new Set;for(const v of D){if(P.has(v))continue;const d=T[v],g=_[v];d!==g&&C.add(v)}return{added:S,removed:P,updated:C}}function L(T,_){const{added:D,removed:b,updated:S}=N(T,_);return D.size===0&&b.size===0&&S.size===0}e.areSame=L}),define(ae[229],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(L,T,_,D){const b={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!T){const C=L.filter(({id:v})=>!D.includes(v));return C.length?S.added=C:S=null,{local:b,remote:S}}const P=N(L,T,D);if(P.added.length>0||P.removed.length>0||P.updated.length>0){const C=N(_,L,D),v=N(_,T,D);for(const d of v.removed){const g=L.find(w=>w.id===d);g&&b.removed.push(g)}for(const d of v.added){const g=T.find(w=>w.id===d);C.added.includes(d)?P.updated.includes(d)&&b.updated.push(g):b.added.push(g)}for(const d of v.updated)b.updated.push(T.find(g=>g.id===d));for(const d of C.added)v.added.includes(d)||S.added.push(L.find(g=>g.id===d));for(const d of C.updated)v.removed.includes(d)||v.updated.includes(d)||S.updated.push(L.find(g=>g.id===d));for(const d of C.removed){const g=T.find(w=>w.id===d);g&&S.removed.push(g)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:b,remote:S}}e.merge=R;function N(L,T,_){L=L?L.filter(({id:v})=>!_.includes(v)):[],T=T.filter(({id:v})=>!_.includes(v));const D=L.map(({id:v})=>v),b=T.map(({id:v})=>v),S=b.filter(v=>!D.includes(v)),P=D.filter(v=>!b.includes(v)),C=[];for(const{id:v,name:d,shortName:g}of L){if(P.includes(v))continue;const w=T.find(a=>a.id===v);(!w||w.name!==d||w.shortName!==g)&&C.push(v)}return{added:S,removed:P,updated:C}}}),define(ae[23],ce([0,1,21,10,167,48,28,4,103,40]),function(ne,e,R,N,L,T,_,D,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function P(){const s=S.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(o=>!!s[o].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=P;function C(){const s=S.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(s).filter(f=>!!s[f].ignoreSync),c=Object.keys(s).filter(f=>s[f].scope===2||s[f].scope===6),y=P();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...o,...c,...y])}e.getDefaultIgnoredSettings=C,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function v(){const s="vscode://schemas/ignoredSettings",o=S.Registry.as(T.Extensions.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:_.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const c=S.Registry.as(b.Extensions.JSONContribution),y=()=>{const f=P(),l=C().filter(M=>M!==e.CONFIGURATION_SYNC_STORE_KEY),I=Object.keys(T.allSettings.properties).filter(M=>!l.includes(M)),A=l.filter(M=>!f.includes(M)),F={items:{type:"string",enum:[...I,...A.map(M=>`-${M}`)]}};c.registerSchema(s,F)};return o.onDidUpdateConfiguration(()=>y())}e.registerConfiguration=v;function d(s){return s&&(0,N.isObject)(s)&&(0,N.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=d;var g;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles",s.WorkspaceState="workspaceState"})(g||(e.SyncResource=g={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function w(s,...o){return s?[s,...o]:o}e.getPathSegments=w;function a(s,o,c,y){return y.joinPath(c.userDataSyncHome,...w(s,o,`lastSync${o}.json`))}e.getLastSyncResourceUri=a,e.IUserDataSyncStoreManagementService=(0,D.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,D.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,D.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(s){const o={};return o[e.HEADER_EXECUTION_ID]=s,o}e.createSyncHeaders=u;var h;(function(s){s.Unauthorized="Unauthorized",s.Forbidden="Forbidden",s.NotFound="NotFound",s.MethodNotFound="MethodNotFound",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyProfiles="LocalTooManyProfiles",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.Unknown="Unknown"})(h||(e.UserDataSyncErrorCode=h={}));class E extends Error{constructor(o,c,y,f){super(o),this.code=c,this.resource=y,this.operationId=f,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=E;class p extends E{constructor(o,c,y,f,l){super(o,y,void 0,l),this.url=c,this.serverCode=f}}e.UserDataSyncStoreError=p;class k extends E{constructor(o,c){super(o,c)}}e.UserDataAutoSyncError=k,function(s){function o(c){if(c instanceof s)return c;const y=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(c.name);if(y&&y[1]){const f=y[2]==="unknown"?void 0:y[2],l=y[3]==="unknown"?void 0:y[3];return new s(c.message,y[1],f,l)}return new s(c.message,"Unknown")}s.toUserDataSyncError=o}(E||(e.UserDataSyncError=E={}));var n;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(n||(e.SyncStatus=n={}));var r;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(r||(e.Change=r={}));var i;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(i||(e.MergeState=i={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(s){return`sync.enable.${s}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,D.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,D.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,D.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,D.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,D.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,D.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(ae[230],ce([0,1,31,23]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(_,D,b,S,P){if(!D)return{remote:{added:Object.keys(_),removed:[],updated:[],all:Object.keys(_).length>0?_:null},local:{added:{},removed:[],updated:{}}};const C=T(_,D);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const v=b?T(b,D):{added:Object.keys(D).reduce((h,E)=>(h.add(E),h),new Set),removed:new Set,updated:new Set},d=b?T(b,_):{added:Object.keys(_).reduce((h,E)=>(h.add(E),h),new Set),removed:new Set,updated:new Set},g={added:{},removed:[],updated:{}},w=R.deepClone(D),a=!b;for(const h of d.added.values())h!==N.SYNC_SERVICE_URL_TYPE&&a&&v.added.has(h)||(w[h]=_[h]);for(const h of d.updated.values())w[h]=_[h];for(const h of d.removed.values())S.unregistered.includes(h)||delete w[h];for(const h of v.added.values()){const E=D[h];if(S.machine.includes(h)){P.info(`GlobalState: Skipped adding ${h} in local storage because it is declared as machine scoped.`);continue}if(b&&d.added.has(h))continue;const p=_[h];p&&p.value===E.value||h===N.SYNC_SERVICE_URL_TYPE&&a&&d.added.has(h)||(p?g.updated[h]=E:g.added[h]=E)}for(const h of v.updated.values()){const E=D[h];if(S.machine.includes(h)){P.info(`GlobalState: Skipped updating ${h} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(h)||d.removed.has(h))continue;const p=_[h];p&&p.value===E.value||(g.updated[h]=E)}for(const h of v.removed.values()){if(S.machine.includes(h)){P.trace(`GlobalState: Skipped removing ${h} in local storage because it is declared as machine scoped.`);continue}d.updated.has(h)||d.removed.has(h)||g.removed.push(h)}const u=T(D,w);return{local:g,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:w}}}e.merge=L;function T(_,D){const b=Object.keys(_),S=Object.keys(D),P=S.filter(d=>!b.includes(d)).reduce((d,g)=>(d.add(g),d),new Set),C=b.filter(d=>!S.includes(d)).reduce((d,g)=>(d.add(g),d),new Set),v=new Set;for(const d of b){if(C.has(d))continue;const g=_[d],w=D[d];R.equals(g,w)||v.add(d)}return{added:P,removed:C,updated:v}}}),define(ae[231],ce([0,1,21,34,83,41,31,57,23]),function(ne,e,R,N,L,T,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function S(c,y,f){let l=[];f?l=C(f):l=P(y);const I=[],A=[...(0,b.getDisallowedIgnoredSettings)()];if(Array.isArray(l))for(const F of l)F.startsWith("-")?A.push(F.substring(1)):I.push(F);return(0,R.distinct)([...c,...I].filter(F=>!A.includes(F)))}e.getIgnoredSettings=S;function P(c){let y=c.inspect("settingsSync.ignoredSettings").userValue;return y!==void 0||(y=c.inspect("sync.ignoredSettings").userValue,y!==void 0)?y:c.getValue("settingsSync.ignoredSettings")||[]}function C(c){const y=(0,N.parse)(c);return y?y["settingsSync.ignoredSettings"]||y["sync.ignoredSettings"]||[]:[]}function v(c,y){const f=(0,N.parse)(c)||{};let l="{}";for(const I of Object.keys(f)){const A=(0,L.setProperty)(l,[I],f[I],y);l=(0,L.applyEdits)(l,A)}return l}e.removeComments=v;function d(c,y,f,l){if(f.length){const I=o(y),A=(0,N.parse)(y)||{},F=(0,N.parse)(c);if(!F)return c;const M=[];for(const V of f){const x=A[V],q=F[V];x===void 0?c=D.edit(c,[V],void 0,l):q!==void 0?c=D.edit(c,[V],x,l):M.push(n(V,I))}M.sort((V,x)=>V.startOffset-x.startOffset),M.forEach(V=>c=h(V.setting.key,y,c,l))}return c}e.updateIgnoredSettings=d;function g(c,y,f,l,I,A){const F=d(c,y,l,A),M=f!==F,V=f!==y;if(!M&&!V)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!V)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(V&&!M)return{conflictsSettings:[],localContent:d(y,c,l,A),remoteContent:null,hasConflicts:!1};if(f===null&&a(c)){const U=w(c,y,l)?null:d(y,c,l,A);return{conflictsSettings:[],localContent:U,remoteContent:null,hasConflicts:!1}}let x=c,q=y;const X=(0,N.parse)(c),ee=(0,N.parse)(y),Y=f?(0,N.parse)(f):null,Z=l.reduce((U,W)=>(U.add(W),U),new Set),j=u(X,ee,Z),B=u(Y,X,Z),z=u(Y,ee,Z),ie=new Map,re=new Set,K=U=>{re.add(U);const W=I.filter(({key:J})=>J===U)[0];W?(x=D.edit(x,[U],W.value,A),q=D.edit(q,[U],W.value,A)):ie.set(U,{key:U,localValue:X[U],remoteValue:ee[U]})};for(const U of B.removed.values())z.updated.has(U)?K(U):q=D.edit(q,[U],void 0,A);for(const U of z.removed.values())re.has(U)||(B.updated.has(U)?K(U):x=D.edit(x,[U],void 0,A));for(const U of B.updated.values())re.has(U)||(z.updated.has(U)?j.updated.has(U)&&K(U):q=D.edit(q,[U],X[U],A));for(const U of z.updated.values())re.has(U)||(B.updated.has(U)?j.updated.has(U)&&K(U):x=D.edit(x,[U],ee[U],A));for(const U of B.added.values())re.has(U)||(z.added.has(U)?j.updated.has(U)&&K(U):q=h(U,x,q,A));for(const U of z.added.values())re.has(U)||(B.added.has(U)?j.updated.has(U)&&K(U):x=h(U,q,x,A));const Q=ie.size>0||!w(x,q,l),O=Q||!w(x,c,[]),m=Q||!w(q,y,[]);return{localContent:O?x:null,remoteContent:m?q:null,conflictsSettings:[...ie.values()],hasConflicts:Q}}e.merge=g;function w(c,y,f){if(c===y)return!0;const l=(0,N.parse)(c),I=(0,N.parse)(y),A=f.reduce((V,x)=>(V.add(x),V),new Set),F=o(c).filter(V=>!(V.setting&&A.has(V.setting.key))),M=o(y).filter(V=>!(V.setting&&A.has(V.setting.key)));if(F.length!==M.length)return!1;for(let V=0;V<F.length;V++){const x=F[V],q=M[V];if(x.setting&&q.setting){if(x.setting.key!==q.setting.key||!_.equals(l[x.setting.key],I[x.setting.key]))return!1}else if(!x.setting&&!q.setting){if(x.value!==q.value)return!1}else return!1}return!0}function a(c){return c?o(c).length===0:!0}e.isEmpty=a;function u(c,y,f){const l=c?Object.keys(c).filter(V=>!f.has(V)):[],I=Object.keys(y).filter(V=>!f.has(V)),A=I.filter(V=>!l.includes(V)).reduce((V,x)=>(V.add(x),V),new Set),F=l.filter(V=>!I.includes(V)).reduce((V,x)=>(V.add(x),V),new Set),M=new Set;if(c)for(const V of l){if(F.has(V))continue;const x=c[V],q=y[V];_.equals(x,q)||M.add(V)}return{added:A,removed:F,updated:M}}function h(c,y,f,l){const I=(0,N.parse)(y),A=o(y),F=o(f),M=E(c,A,F);return p(f,c,I[c],M,F,l)}e.addSetting=h;function E(c,y,f){const l=y.findIndex(A=>A.setting?.key===c),I=y[l-1];if(I){if(I.setting){const F=n(I.setting.key,f);if(F)return{index:f.indexOf(F),insertAfter:!0}}else{const F=r(l,y);if(F){const M=n(F.setting.key,f);if(M){const V=i(f.indexOf(M),f),x=t(y,F,y[l]);if(V){const q=t(f,M,V),X=s(x,q);return X?{index:f.indexOf(X),insertAfter:!0}:{index:f.indexOf(V),insertAfter:!1}}else{const q=t(f,M,f[f.length-1]),X=s(x,q);return X?{index:f.indexOf(X),insertAfter:!0}:{index:f.length-1,insertAfter:!0}}}}}const A=y[l+1];if(A)if(A.setting){const F=n(A.setting.key,f);if(F)return{index:f.indexOf(F),insertAfter:!1}}else{const F=i(l,y);if(F){const M=n(F.setting.key,f);if(M){const V=r(f.indexOf(M),f),x=t(y,y[l],F);if(V){const q=t(f,V,M),X=s(x.reverse(),q.reverse());return X?{index:f.indexOf(X),insertAfter:!1}:{index:f.indexOf(V),insertAfter:!0}}else{const q=t(f,f[0],M),X=s(x.reverse(),q.reverse());return X?{index:f.indexOf(X),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:f.length-1,insertAfter:!0}}function p(c,y,f,l,I,A){let F;return l.index===-1?F=(0,L.setProperty)(c,[y],f,A):F=k(c,y,f,l,I,A).map(M=>(0,L.withFormatting)(c,M,A)[0]),(0,L.applyEdits)(c,F)}function k(c,y,f,l,I,A){const F=`${JSON.stringify(y)}: ${JSON.stringify(f)}`,M=(0,T.getEOL)(A,c),V=I[l.index];if(l.insertAfter){const x=[];if(V.setting)x.push({offset:V.endOffset,length:0,content:","+F});else{const q=i(l.index,I),X=r(l.index,I),ee=X?.setting?.commaOffset;X&&ee===void 0&&x.push({offset:X.endOffset,length:0,content:","});const Y=ee!==void 0&&ee>V.endOffset;x.push({offset:Y?ee+1:V.endOffset,length:0,content:q?M+F+",":M+F})}return x}else{if(V.setting)return[{offset:V.startOffset,length:0,content:F+","}];const x=(I[l.index-1]&&!I[l.index-1].setting?M:"")+F+(i(l.index,I)?",":"")+M;return[{offset:V.startOffset,length:0,content:x}]}}function n(c,y){return y.filter(f=>f.setting?.key===c)[0]}function r(c,y){for(let f=c-1;f>=0;f--)if(y[f].setting)return y[f]}function i(c,y){for(let f=c+1;f<y.length;f++)if(y[f].setting)return y[f]}function t(c,y,f){const l=c.indexOf(y),I=c.indexOf(f);return c.filter((A,F)=>l<F&&F<I)}function s(c,y){if(c.length&&y.length){let f=0;for(;f<y.length&&f<c.length;f++)if(c[f].value!==y[f].value)return y[f-1];return y[f-1]}}function o(c){const y=[];let f=-1,l,I;const A={onObjectBegin:F=>{f++},onObjectProperty:(F,M,V)=>{f===0&&(l=M,I=F)},onObjectEnd:(F,M)=>{f--,f===0&&y.push({startOffset:l,endOffset:F+M,value:c.substring(l,F+M),setting:{key:I,commaOffset:void 0}})},onArrayBegin:(F,M)=>{f++},onArrayEnd:(F,M)=>{f--,f===0&&y.push({startOffset:l,endOffset:F+M,value:c.substring(l,F+M),setting:{key:I,commaOffset:void 0}})},onLiteralValue:(F,M,V)=>{f===0&&y.push({startOffset:l,endOffset:M+V,value:c.substring(l,M+V),setting:{key:I,commaOffset:void 0}})},onSeparator:(F,M,V)=>{if(f===0&&F===","){let x=y.length-1;for(;x>=0&&!y[x].setting;x--);const q=y[x];q&&y.splice(x,1,{startOffset:q.startOffset,endOffset:q.endOffset,value:q.value,setting:{key:q.setting.key,commaOffset:M}})}},onComment:(F,M)=>{f===0&&y.push({startOffset:F,endOffset:F+M,value:c.substring(F,F+M)})}};return(0,N.visit)(c,A),y}}),define(ae[77],ce([0,1,3,2,4,23]),function(ne,e,R,N,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,L.createDecorator)("IUserDataSyncAccountService");let _=e.UserDataSyncAccountService=class extends N.Disposable{get account(){return this._account}constructor(b,S){super(),this.userDataSyncStoreService=b,this.logService=S,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(b.onTokenFailed(P=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed,P),this.updateAccount(void 0),P==="Forbidden"?this._onTokenFailed.fire(!0):this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(b.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(b){(b&&this._account?b.token!==this._account.token||b.authenticationProviderId!==this._account.authenticationProviderId:b!==this._account)&&(this._account=b,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(b))}};e.UserDataSyncAccountService=_=pe([G(0,T.IUserDataSyncStoreService),G(1,T.IUserDataSyncLogService)],_)}),define(ae[232],ce([0,1,2,12]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(v){this.service=v}listen(v,d){switch(d){case"onError":return this.service.onError}throw new Error(`Event not found: ${d}`)}call(v,d,g){switch(d){case"triggerSync":return this.service.triggerSync(g[0],g[1],g[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(g[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class T{constructor(v){this.service=v}listen(v,d){throw new Error(`Event not found: ${d}`)}call(v,d,g){switch(d){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(g[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(N.URI.revive(g[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class _{constructor(v){this.channel=v}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(v){return this.channel.call("resolveUserKeybindings",[v])}async resolveFormattingOptions(v){return this.channel.call("resolveFormattingOptions",[v])}}e.UserDataSyncUtilServiceClient=_;class D{constructor(v){this.service=v}listen(v,d){switch(d){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${d}`)}async call(v,d,g){switch(d){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(g[0],g[1]);case"setEnablements":return this.service.setEnablements(g)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=D;class b{constructor(v){this.service=v}listen(v,d){switch(d){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${d}`)}call(v,d,g){switch(d){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(g)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=b;class S{constructor(v){this.service=v}listen(v,d){switch(d){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${d}`)}call(v,d,g){switch(d){case"switch":return this.service.switch(g[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class P extends R.Disposable{constructor(v){super(),this.channel=v,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(v){return this.channel.call("switch",[v])}async getPreviousUserDataSyncStore(){const v=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(v)}revive(v){return{url:N.URI.revive(v.url),type:v.type,defaultUrl:N.URI.revive(v.defaultUrl),insidersUrl:N.URI.revive(v.insidersUrl),stableUrl:N.URI.revive(v.stableUrl),canSwitch:v.canSwitch,authenticationProviders:v.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(ae[233],ce([0,1,168,8,23]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let T=e.UserDataSyncLogService=class extends N.AbstractLogger{constructor(D){super(),this.logger=this._register(D.createLogger(L.USER_DATA_SYNC_LOG_ID,{name:(0,R.localize)(0,null)}))}trace(D,...b){this.logger.trace(D,...b)}debug(D,...b){this.logger.debug(D,...b)}info(D,...b){this.logger.info(D,...b)}warn(D,...b){this.logger.warn(D,...b)}error(D,...b){this.logger.error(D,...b)}flush(){this.logger.flush()}};e.UserDataSyncLogService=T=pe([G(0,N.ILoggerService)],T)}),define(ae[234],ce([0,1,6,3,2]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends L.Disposable{constructor({onDidOpenWindow:D,onDidFocusWindow:b,getActiveWindowId:S}){super(),this.disposables=this._register(new L.DisposableStore),N.Event.latch(N.Event.any(D,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>S()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(D){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=D}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(ae[112],ce([0,1,171,15,46,22,12,4,25]),function(ne,e,R,N,L,T,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function S(t){const s=t;return typeof s?.id=="string"&&_.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=S;function P(t){return typeof t?.id=="string"&&!S(t)&&!v(t)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function C(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,N.basename)(t)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=C;function v(t){const s=t;return typeof s?.id=="string"&&_.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=v;function d(t){const s=t;if(s?.uri)return{id:s.id,uri:_.URI.revive(s.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:_.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=d;var g;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function w(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=w;function a(t){const s=t;return!!(s&&typeof s=="object"&&_.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=a;class u{constructor(s,o,c,y,f){this._id=s,this._transient=c,this._configuration=y,this._ignorePathCasing=f,this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class h{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,T.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function E(t){return new h({uri:t,index:0,name:(0,T.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(t,s){return T.extUriBiasedIgnorePathCase.isEqualOrParent(t,s.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function k(t){let s;return _.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===b.Schemas.tmp}e.isTemporaryWorkspace=k,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(t){return t.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=n;function r(t,s){return!p(t,s)&&!k(t)}e.isSavedWorkspace=r;function i(t){return(typeof t=="string"?(0,N.extname)(t):(0,T.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ae[17],ce([0,1,61,3,2,22,12,162,14,13,4,8,112,35,29,6,32,27,10]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function E(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&_.URI.isUri(t.location)&&_.URI.isUri(t.globalStorageHome)&&_.URI.isUri(t.settingsResource)&&_.URI.isUri(t.keybindingsResource)&&_.URI.isUri(t.tasksResource)&&_.URI.isUri(t.snippetsHome)&&_.URI.isUri(t.extensionsResource))}e.isUserDataProfile=E,e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function p(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:_.URI.revive(i.location).with({scheme:t}),globalStorageHome:_.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:_.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:_.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:_.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:_.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:_.URI.revive(i.extensionsResource).with({scheme:t}),cacheHome:_.URI.revive(i.cacheHome).with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=p;function k(i,t,s,o,c){return{id:i,name:t,location:s,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,T.joinPath)(s,"globalStorage"),settingsResource:(0,T.joinPath)(s,"settings.json"),keybindingsResource:(0,T.joinPath)(s,"keybindings.json"),tasksResource:(0,T.joinPath)(s,"tasks.json"),snippetsHome:(0,T.joinPath)(s,"snippets"),extensionsResource:(0,T.joinPath)(s,"extensions.json"),cacheHome:(0,T.joinPath)(o,i),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=k;let n=e.UserDataProfilesService=class extends L.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(t,s,o,c){super(),this.environmentService=t,this.fileService=s,this.uriIdentityService=o,this.logService=c,this.enabled=!0,this._onDidChangeProfiles=this._register(new N.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new N.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new N.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new N.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,T.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,T.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const t=[];if(this.enabled)try{for(const y of this.getStoredProfiles()){if(!y.name||!(0,h.isString)(y.name)||!y.location){this.logService.warn("Skipping the invalid stored profile",y.location||y.name);continue}t.push(k((0,T.basename)(y.location),y.name,y.location,this.profilesCacheHome,{shortName:y.shortName,useDefaultFlags:y.useDefaultFlags}))}}catch(y){this.logService.error(y)}const s=new d.ResourceMap,o=new Map,c=this.createDefaultProfile();if(t.unshift({...c,extensionsResource:this.getDefaultProfileExtensionsLocation()??c.extensionsResource,isDefault:!0}),t.length)try{const y=this.getStoredProfileAssociations();if(y.workspaces)for(const[f,l]of Object.entries(y.workspaces)){const I=_.URI.parse(f),A=t.find(F=>F.id===l);A&&s.set(I,A)}if(y.emptyWindows)for(const[f,l]of Object.entries(y.emptyWindows)){const I=t.find(A=>A.id===l);I&&o.set(f,I)}}catch(y){this.logService.error(y)}this._profilesObject={profiles:t,workspaces:s,emptyWindows:o}}return this._profilesObject}createDefaultProfile(){return k("__default__profile__",(0,D.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome)}async createTransientProfile(t){const s="Temp",o=new RegExp(`${(0,u.escapeRegExpCharacters)(s)}\\s(\\d+)`);let c=0;for(const f of this.profiles){const l=o.exec(f.name),I=l?parseInt(l[1]):0;c=I>c?I:c}const y=`${s} ${c+1}`;return this.createProfile((0,R.hash)((0,a.generateUuid)()).toString(16),y,{transient:!0},t)}async createNamedProfile(t,s,o){return this.createProfile((0,R.hash)((0,a.generateUuid)()).toString(16),t,s,o)}async createProfile(t,s,o,c){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const y=await this.doCreateProfile(t,s,o);return c&&await this.setProfileForWorkspace(c,y),y}async doCreateProfile(t,s,o){if(!(0,h.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let c=this.profileCreationPromises.get(s);return c||(c=(async()=>{try{const y=this.profiles.find(I=>I.name===s||I.id===t);if(y)return y;const f=k(t,s,(0,T.joinPath)(this.profilesHome,t),this.profilesCacheHome,o);await this.fileService.createFolder(f.location);const l=[];return this._onWillCreateProfile.fire({profile:f,join(I){l.push(I)}}),await w.Promises.settled(l),this.updateProfiles([f],[],[]),f}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,c)),c}async updateProfile(t,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(c=>c.id===t.id);if(!o)throw new Error(`Profile '${t.name}' does not exist`);return o=k(o.id,s.name??o.name,o.location,this.profilesCacheHome,{shortName:s.shortName??o.shortName,transient:s.transient??o.isTransient,useDefaultFlags:s.useDefaultFlags??o.useDefaultFlags}),this.updateProfiles([],[],[o]),o}async removeProfile(t){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(c=>c.id===t.id);if(!s)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:s,join(c){o.push(c)}});try{await Promise.allSettled(o)}catch(c){this.logService.error(c)}for(const c of[...this.profilesObject.emptyWindows.keys()])s.id===this.profilesObject.emptyWindows.get(c)?.id&&this.profilesObject.emptyWindows.delete(c);for(const c of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(c)?.id&&this.profilesObject.workspaces.delete(c);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{await this.fileService.del(s.cacheHome,{recursive:!0})}catch(c){(0,S.toFileOperationResult)(c)!==1&&this.logService.error(c)}}async setProfileForWorkspace(t,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(c=>c.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(t,o)}unsetWorkspace(t,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(t,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(s=>s.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(t.map(s=>this.removeProfile(s)))}getProfileForWorkspace(t){const s=this.getWorkspace(t);return _.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindows.get(s)??this.profilesObject.emptyWindows.get(s)}getWorkspace(t){return(0,v.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,v.isWorkspaceIdentifier)(t)?t.configPath:t.id}isProfileAssociatedToWorkspace(t){return!!([...this.transientProfilesObject.emptyWindows.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,t.location))||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,t.location))||[...this.profilesObject.emptyWindows.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,t.location))||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,t.location)))}updateProfiles(t,s,o){const c=[...this.profiles,...t],y=[];this.transientProfilesObject.profiles=[];for(let f of c)f.isDefault||s.some(l=>f.id===l.id)||(f=o.find(l=>f.id===l.id)??f,f.isTransient?this.transientProfilesObject.profiles.push(f):y.push({location:f.location,name:f.name,shortName:f.shortName,useDefaultFlags:f.useDefaultFlags}));this.saveStoredProfiles(y),this._profilesObject=void 0,this.triggerProfilesChanges(t,s,o)}triggerProfilesChanges(t,s,o){this._onDidChangeProfiles.fire({added:t,removed:s,updated:o,all:this.profiles})}updateWorkspaceAssociation(t,s,o){o=s?.isTransient?!0:o,o||this.updateWorkspaceAssociation(t,void 0,!0);const c=this.getWorkspace(t),y=o?this.transientProfilesObject:this.profilesObject;_.URI.isUri(c)?(y.workspaces.delete(c),s&&y.workspaces.set(c,s)):(y.emptyWindows.delete(c),s&&y.emptyWindows.set(c,s)),o||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[o,c]of this.profilesObject.workspaces.entries())t[o.toString()]=c.id;const s={};for(const[o,c]of this.profilesObject.emptyWindows.entries())s[o.toString()]=c.id;this.saveStoredProfileAssociations({workspaces:t,emptyWindows:s}),this._profilesObject=void 0}migrateStoredProfileAssociations(t){const s={},o=this.createDefaultProfile();if(t.workspaces)for(const[y,f]of Object.entries(t.workspaces)){const l=_.URI.parse(f);s[y]=this.uriIdentityService.extUri.isEqual(l,o.location)?o.id:this.uriIdentityService.extUri.basename(l)}const c={};if(t.emptyWindows)for(const[y,f]of Object.entries(t.emptyWindows)){const l=_.URI.parse(f);c[y]=this.uriIdentityService.extUri.isEqual(l,o.location)?o.id:this.uriIdentityService.extUri.basename(l)}return{workspaces:s,emptyWindows:c}}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};n.PROFILES_KEY="userDataProfiles",n.PROFILE_ASSOCIATIONS_KEY="profileAssociations",e.UserDataProfilesService=n=pe([G(0,b.IEnvironmentService),G(1,S.IFileService),G(2,g.IUriIdentityService),G(3,C.ILogService)],n);class r extends n{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(t){this.storedProfiles=t}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(t){this.storedProfileAssociations=t}}e.InMemoryUserDataProfilesService=r}),define(ae[235],ce([0,1,6,2,17]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let T=e.UserDataProfilesCleaner=class extends N.Disposable{constructor(D){super(),this._register(new R.RunOnceScheduler(()=>{D.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=T=pe([G(0,L.IUserDataProfilesService)],T)}),define(ae[236],ce([0,1,21,6,26,7,3,2,5,10,12,145,28,33,49,8,24,20,17]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.toExtensionManagementError=e.joinErrors=e.AbstractExtensionManagementService=void 0;let E=e.AbstractExtensionManagementService=class extends D.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(t,s,o,c,y){super(),this.galleryService=t,this.telemetryService=s,this.logService=o,this.productService=c,this.userDataProfilesService=y,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new _.Emitter),this._onDidInstallExtensions=this._register(new _.Emitter),this._onUninstallExtension=this._register(new _.Emitter),this._onDidUninstallExtension=this._register(new _.Emitter),this.participants=[],this._register((0,D.toDisposable)(()=>{this.installingExtensions.forEach(({task:f})=>f.cancel()),this.uninstallingExtensions.forEach(f=>f.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const s=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,v.isTargetPlatformCompatible)(o,t.allTargetPlatforms,s))}async installFromGallery(t,s={}){try{const c=(await this.installGalleryExtensions([{extension:t,options:s}])).find(({identifier:y})=>(0,d.areSameExtensions)(y,t.identifier));if(c?.local)return c?.local;throw c?.error?c.error:k(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(o){throw k(o)}}async installGalleryExtensions(t){if(!this.galleryService.isEnabled())throw new v.ExtensionManagementError(C.localize(0,null),v.ExtensionManagementErrorCode.Internal);const s=[],o=[];await Promise.allSettled(t.map(async({extension:c,options:y})=>{try{const f=await this.checkAndGetCompatibleVersion(c,!!y?.installGivenVersion,!!y?.installPreReleaseVersion);o.push({...f,options:y})}catch(f){s.push({identifier:c.identifier,operation:2,source:c,error:f})}})),o.length&&s.push(...await this.installExtensions(o));for(const c of s)c.error&&(this.logService.error("Failed to install extension.",c.identifier.id),this.logService.error(c.error),c.source&&!P.URI.isUri(c.source)&&n(this.telemetryService,"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(c.source),error:c.error}));return s}async uninstall(t,s={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,s)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtensions(t){const s=[];return await Promise.allSettled(t.map(async o=>{try{const c=await this.installExtension(o);s.push(...c)}catch(c){s.push({identifier:{id:(0,d.getGalleryExtensionId)(o.manifest.publisher,o.manifest.name)},operation:2,source:o.extension,error:c})}})),this._onDidInstallExtensions.fire(s),s}async installExtension({manifest:t,extension:s,options:o}){const c=o.isApplicationScoped||o.isBuiltin||(0,g.isApplicationScopedExtension)(t),y={...o,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(s)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:c,profileLocation:c?this.userDataProfilesService.defaultProfile.extensionsResource:o.profileLocation??this.getCurrentExtensionsManifestLocation()},f=V=>`${d.ExtensionKey.create(V).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!P.URI.isUri(s)){const V=this.installingExtensions.get(f(s));if(V)return this.logService.info("Extensions is already requested to install",s.identifier.id),await V.task.waitUntilTaskIsFinished(),[]}const l=[],I=[],A=[],F=this.createInstallExtensionTask(t,s,y);P.URI.isUri(s)||this.installingExtensions.set(f(s),{task:F,waitingTasks:[]}),this._onInstallExtension.fire({identifier:F.identifier,source:s,profileLocation:y.profileLocation}),this.logService.info("Installing extension:",F.identifier.id),l.push({task:F,manifest:t});let M=!1;try{if(y.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",F.identifier.id);else try{const x=await this.getAllDepsAndPackExtensions(F.identifier,t,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),q=await this.getInstalled(void 0,y.profileLocation);for(const{gallery:X,manifest:ee}of(0,R.distinct)(x,({gallery:Y})=>Y.identifier.id)){M=M||!!ee.extensionDependencies?.some(j=>(0,d.areSameExtensions)({id:j},F.identifier));const Y=f(X),Z=this.installingExtensions.get(Y);if(Z){if(this.canWaitForTask(F,Z.task)){const j=Z.task.identifier;this.logService.info("Waiting for already requested installing extension",j.id,F.identifier.id),Z.waitingTasks.push(F),I.push(_.Event.toPromise(_.Event.filter(this.onDidInstallExtensions,B=>B.some(z=>(0,d.areSameExtensions)(z.identifier,j)))).then(B=>{if(this.logService.info("Finished waiting for already requested installing extension",j.id,F.identifier.id),!B.find(ie=>(0,d.areSameExtensions)(ie.identifier,j))?.local)throw new Error(`Extension ${j.id} is not installed`)}))}}else if(!q.some(({identifier:j})=>(0,d.areSameExtensions)(j,X.identifier))){const j=this.createInstallExtensionTask(ee,X,{...y,donotIncludePackAndDependencies:!0});this.installingExtensions.set(Y,{task:j,waitingTasks:[F]}),this._onInstallExtension.fire({identifier:j.identifier,source:X,profileLocation:y.profileLocation}),this.logService.info("Installing extension:",j.identifier.id,F.identifier.id),l.push({task:j,manifest:ee})}}}catch(x){if(P.URI.isUri(F.source))(0,R.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",F.identifier.id,x.message),(0,R.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",F.identifier.id,x.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",F.identifier.id),x}const V=l.reduce((x,{task:q,manifest:X})=>(x.set(q.identifier.id.toLowerCase(),{task:q,manifest:X}),x),new Map);for(;V.size;){let x;const q=[...V.values()].filter(({manifest:X})=>!X.extensionDependencies?.some(ee=>V.has(ee.toLowerCase())));q.length?x=V.size===1?q:q.filter(({task:X})=>!(X===F&&!M)):(this.logService.info("Found extensions with circular dependencies",q.map(({task:X})=>X.identifier.id)),x=[...V.values()]),await this.joinAllSettled(x.map(async({task:X})=>{const ee=new Date().getTime();try{const Y=await X.run();if(await this.joinAllSettled(this.participants.map(Z=>Z.postInstall(Y,X.source,y,L.CancellationToken.None))),!P.URI.isUri(X.source)){const Z=X.operation===3,j=Z?void 0:(new Date().getTime()-X.source.lastUpdated)/1e3;if(n(this.telemetryService,Z?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(X.source),verificationStatus:X.verificationStatus,duration:new Date().getTime()-ee,durationSinceUpdate:j}),b.isWeb&&X.operation!==3)try{await this.galleryService.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,"install")}catch{}}A.push({local:Y,identifier:X.identifier,operation:X.operation,source:X.source,context:y.context,profileLocation:X.profileLocation,applicationScoped:Y.isApplicationScoped})}catch(Y){throw P.URI.isUri(X.source)||n(this.telemetryService,X.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(X.source),verificationStatus:X.verificationStatus,duration:new Date().getTime()-ee,error:Y}),this.logService.error("Error while installing the extension:",X.identifier.id),Y}finally{V.delete(X.identifier.id.toLowerCase())}}))}return I.length&&await this.joinAllSettled(I),A.forEach(({identifier:x})=>this.logService.info("Extension installed successfully:",x.id)),A}catch(V){if(l.forEach(({task:x})=>x.cancel()),A.length)try{const x=await Promise.allSettled(A.map(({local:q})=>this.createUninstallExtensionTask(q,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let q=0;q<x.length;q++){const X=x[q],{identifier:ee}=A[q];X.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ee.id):this.logService.warn("Rollback: Error while uninstalling extension",ee.id,(0,T.getErrorMessage)(X.reason))}}catch(x){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(x),A.map(({identifier:q})=>q.id))}return l.map(({task:x})=>({identifier:x.identifier,operation:2,source:x.source,context:y.context,profileLocation:y.profileLocation,error:V}))}finally{for(const{task:V}of l)V.source&&!P.URI.isUri(V.source)&&this.installingExtensions.delete(f(V.source))}}canWaitForTask(t,s){for(const[,{task:o,waitingTasks:c}]of this.installingExtensions.entries())if(o===t&&(c.includes(s)||c.some(y=>this.canWaitForTask(y,s)))||o===s&&c[0]&&!this.canWaitForTask(t,c[0]))return!1;return!0}async joinAllSettled(t){const s=[],o=[],c=await Promise.allSettled(t);for(const y of c)y.status==="fulfilled"?s.push(y.value):o.push(y.reason);if(o.length)throw p(o);return s}async getAllDepsAndPackExtensions(t,s,o,c,y){if(!this.galleryService.isEnabled())return[];const f=await this.getInstalled(void 0,y),l=[],I=[],A=async(F,M)=>{l.push(F);const V=M.extensionDependencies||[],x=[...V];if(M.extensionPack){const q=o?f.find(X=>(0,d.areSameExtensions)(X.identifier,F)):void 0;for(const X of M.extensionPack)q&&q.manifest.extensionPack&&q.manifest.extensionPack.some(ee=>(0,d.areSameExtensions)({id:ee},{id:X}))||x.every(ee=>!(0,d.areSameExtensions)({id:ee},{id:X}))&&x.push(X)}if(x.length){const q=x.filter(X=>l.every(ee=>!(0,d.areSameExtensions)(ee,{id:X})));if(q.length){const X=await this.galleryService.getExtensions(q.map(ee=>({id:ee,preRelease:c})),L.CancellationToken.None);for(const ee of X){if(l.find(j=>(0,d.areSameExtensions)(j,ee.identifier)))continue;const Y=V.some(j=>(0,d.areSameExtensions)({id:j},ee.identifier));let Z;try{Z=await this.checkAndGetCompatibleVersion(ee,!1,c)}catch(j){if(j instanceof v.ExtensionManagementError&&j.code===v.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!Y){this.logService.info("Skipping the packed extension as it cannot be installed",ee.identifier.id);continue}else throw j}I.push({gallery:Z.extension,manifest:Z.manifest}),await A(Z.extension.identifier,Z.manifest)}}}};return await A(t,s),I}async checkAndGetCompatibleVersion(t,s,o){if((await this.getExtensionsControlManifest()).malicious.some(l=>(0,d.areSameExtensions)(t.identifier,l)))throw new v.ExtensionManagementError(C.localize(1,null,t.identifier.id),v.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const l=await this.getTargetPlatform();throw new v.ExtensionManagementError(C.localize(2,null,t.identifier.id,this.productService.nameLong,(0,v.TargetPlatformToString)(l)),v.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const y=await this.getCompatibleVersion(t,s,o);if(y){if(o&&!s&&t.hasPreReleaseVersion&&!y.properties.isPreReleaseVersion)throw new v.ExtensionManagementError(C.localize(3,null,t.identifier.id,this.productService.nameLong,this.productService.version),v.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],L.CancellationToken.None))[0]?new v.ExtensionManagementError(C.localize(4,null,t.identifier.id),v.ExtensionManagementErrorCode.ReleaseVersionNotFound):new v.ExtensionManagementError(C.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),v.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",y.identifier.id);const f=await this.galleryService.getManifest(y,L.CancellationToken.None);if(f===null)throw new v.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,v.ExtensionManagementErrorCode.Invalid);if(f.version!==y.version)throw new v.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,v.ExtensionManagementErrorCode.Invalid);return{extension:y,manifest:f}}async getCompatibleVersion(t,s,o){const c=await this.getTargetPlatform();let y=null;return!s&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(y=(await this.galleryService.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:c,compatible:!0},L.CancellationToken.None))[0]||null),!y&&await this.galleryService.isExtensionCompatible(t,o,c)&&(y=t),y||(s?y=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:c,compatible:!0},L.CancellationToken.None))[0]||null:y=await this.galleryService.getCompatibleExtension(t,o,c)),y}async uninstallExtension(t,s){const o={...s,profileLocation:t.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:s.profileLocation??this.getCurrentExtensionsManifestLocation()},c=F=>`${F.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,y=this.uninstallingExtensions.get(c(t.identifier));if(y)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),y.waitUntilTaskIsFinished();const f=F=>{const M=this.createUninstallExtensionTask(F,o);return this.uninstallingExtensions.set(c(M.extension.identifier),M),o.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,o.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this._onUninstallExtension.fire({identifier:F.identifier,profileLocation:o.profileLocation,applicationScoped:F.isApplicationScoped}),M},l=(F,M)=>{M?o.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,o.profileLocation.toString(),M.message):this.logService.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,M.message):o.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,o.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),n(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,d.getLocalExtensionTelemetryData)(F),error:M}),this._onDidUninstallExtension.fire({identifier:F.identifier,error:M?.code,profileLocation:o.profileLocation,applicationScoped:F.isApplicationScoped})},I=[],A=[];try{I.push(f(t));const F=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const M=this.getAllPackExtensionsToUninstall(t,F);for(const V of M)this.uninstallingExtensions.has(c(V.identifier))?this.logService.info("Extensions is already requested to uninstall",V.identifier.id):I.push(f(V))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(I.map(M=>M.extension),F,t),await this.joinAllSettled(I.map(async M=>{try{if(await M.run(),await this.joinAllSettled(this.participants.map(V=>V.postUninstall(M.extension,o,L.CancellationToken.None))),M.extension.identifier.uuid)try{await this.galleryService.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}l(M.extension)}catch(V){const x=V instanceof v.ExtensionManagementError?V:new v.ExtensionManagementError((0,T.getErrorMessage)(V),v.ExtensionManagementErrorCode.Internal);throw l(M.extension,x),x}finally{A.push(M)}}))}catch(F){const M=F instanceof v.ExtensionManagementError?F:new v.ExtensionManagementError((0,T.getErrorMessage)(F),v.ExtensionManagementErrorCode.Internal);for(const V of I){try{V.cancel()}catch{}A.includes(V)||l(V.extension,M)}throw M}finally{for(const F of I)this.uninstallingExtensions.delete(c(F.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}checkForDependents(t,s,o){for(const c of t){const y=this.getDependents(c,s);if(y.length){const f=y.filter(l=>!t.some(I=>(0,d.areSameExtensions)(I.identifier,l.identifier)));if(f.length)throw new Error(this.getDependentsErrorMessage(c,f,o))}}}getDependentsErrorMessage(t,s,o){return o===t?s.length===1?C.localize(6,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?C.localize(7,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):C.localize(8,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?C.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?C.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):C.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(t,s,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const c=t.manifest.extensionPack?t.manifest.extensionPack:[];if(c.length){const y=s.filter(l=>!l.isBuiltin&&c.some(I=>(0,d.areSameExtensions)({id:I},l.identifier))),f=[];for(const l of y)f.push(...this.getAllPackExtensionsToUninstall(l,s,o));return[...y,...f]}return[]}getDependents(t,s){return s.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(c=>(0,d.areSameExtensions)({id:c},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=E=pe([G(0,v.IExtensionGalleryService),G(1,u.ITelemetryService),G(2,w.ILogService),G(3,a.IProductService),G(4,h.IUserDataProfilesService)],E);function p(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((s,o)=>new Error(`${s.message}${s.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=p;function k(i){if(i instanceof v.ExtensionManagementError)return i;const t=new v.ExtensionManagementError(i.message,v.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}e.toExtensionManagementError=k;function n(i,t,{extensionData:s,verificationStatus:o,duration:c,error:y,durationSinceUpdate:f}){let l,I;(0,S.isDefined)(o)&&(o===!0?o="Verified":(o===!1||(l=v.ExtensionManagementErrorCode.Signature,I=o),o="Unverified")),y&&(y instanceof v.ExtensionManagementError?(l=y.code,y.code===v.ExtensionManagementErrorCode.Signature&&(I=y.message)):l=v.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...s,verificationStatus:o,success:!y,duration:c,errorcode:l,errorcodeDetail:I,durationSinceUpdate:f})}class r{constructor(){this.barrier=new N.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,N.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,N.createCancelablePromise)(t=>new Promise((s,o)=>{const c=t.onCancellationRequested(()=>{c.dispose(),o(new T.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=r}),define(ae[50],ce([0,1,6,16,2,3,35,12,28,33,13,4,8,17,29,10,7,20]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class E extends Error{constructor(i,t){super(i),this.code=t}}e.ExtensionsProfileScanningError=E,e.IExtensionsProfileScannerService=(0,C.createDecorator)("IExtensionsProfileScannerService");let p=e.AbstractExtensionsProfileScannerService=class extends L.Disposable{constructor(i,t,s,o,c,y){super(),this.extensionsLocation=i,this.fileService=t,this.userDataProfilesService=s,this.uriIdentityService=o,this.telemetryService=c,this.logService=y,this._onAddExtensions=this._register(new T.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new T.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new T.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new T.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new _.ResourceMap}scanProfileExtensions(i,t){return this.withProfileExtensions(i,void 0,t)}async addExtensionsToProfile(i,t){const s=[],o=[];try{return await this.withProfileExtensions(t,c=>{const y=[];for(const f of c)i.some(([l])=>(0,S.areSameExtensions)(l.identifier,f.identifier)&&l.manifest.version!==f.version)?s.push(f):y.push(f);for(const[f,l]of i)if(!y.some(I=>(0,S.areSameExtensions)(I.identifier,f.identifier)&&I.version===f.manifest.version)){const I={identifier:f.identifier,version:f.manifest.version,location:f.location,metadata:l};o.push(I),y.push(I)}return o.length&&this._onAddExtensions.fire({extensions:o,profileLocation:t}),s.length&&this._onRemoveExtensions.fire({extensions:s,profileLocation:t}),y}),o.length&&this._onDidAddExtensions.fire({extensions:o,profileLocation:t}),s.length&&this._onDidRemoveExtensions.fire({extensions:s,profileLocation:t}),o}catch(c){throw o.length&&this._onDidAddExtensions.fire({extensions:o,error:c,profileLocation:t}),s.length&&this._onDidRemoveExtensions.fire({extensions:s,error:c,profileLocation:t}),c}}async updateMetadata(i,t){const s=[];return await this.withProfileExtensions(t,o=>{const c=[];for(const y of o){const f=i.find(([l])=>(0,S.areSameExtensions)(l.identifier,y.identifier)&&l.manifest.version===y.version);f&&(y.metadata={...y.metadata,...f[1]},s.push(y)),c.push(y)}return c}),s}async removeExtensionFromProfile(i,t){const s=[];this._onRemoveExtensions.fire({extensions:s,profileLocation:t});try{await this.withProfileExtensions(t,o=>{const c=[];for(const y of o)(0,S.areSameExtensions)(y.identifier,i.identifier)?s.push(y):c.push(y);return s.length&&this._onRemoveExtensions.fire({extensions:s,profileLocation:t}),c}),s.length&&this._onDidRemoveExtensions.fire({extensions:s,profileLocation:t})}catch(o){throw s.length&&this._onDidRemoveExtensions.fire({extensions:s,error:o,profileLocation:t}),o}}async withProfileExtensions(i,t,s){return this.getResourceAccessQueue(i).queue(async()=>{let o=[],c;try{const y=await this.fileService.readFile(i);c=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,P.toFileOperationResult)(y)!==1)throw y;if(this.uriIdentityService.extUri.isEqual(i,this.userDataProfilesService.defaultProfile.extensionsResource)&&(c=await this.migrateFromOldDefaultProfileExtensionsLocation()),!c&&s?.bailOutWhenFileNotFound)throw new E((0,a.getErrorMessage)(y),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.reportAndThrowInvalidConentError(i);let y=!1;for(const f of c){k(f)||this.reportAndThrowInvalidConentError(i);let l;if((0,w.isString)(f.relativeLocation)&&f.relativeLocation)l=this.resolveExtensionLocation(f.relativeLocation);else if((0,w.isString)(f.location))l=this.resolveExtensionLocation(f.location),y=!0,f.relativeLocation=f.location,f.location=l.toJSON();else{l=D.URI.revive(f.location);const I=this.toRelativePath(l);I&&(y=!0,f.relativeLocation=I)}o.push({identifier:f.identifier,location:l,version:f.version,metadata:f.metadata})}y&&await this.fileService.writeFile(i,N.VSBuffer.fromString(JSON.stringify(c)))}if(t){o=t(o);const y=o.map(f=>({identifier:f.identifier,version:f.version,location:f.location.toJSON(),relativeLocation:this.toRelativePath(f.location),metadata:f.metadata}));await this.fileService.writeFile(i,N.VSBuffer.fromString(JSON.stringify(y)))}return o})}reportAndThrowInvalidConentError(i){const t=new E(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}toRelativePath(i){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(i),this.extensionsLocation)?this.uriIdentityService.extUri.basename(i):void 0}resolveExtensionLocation(i){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,i)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const i=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),t=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let s;try{s=(await this.fileService.readFile(i)).value.toString()}catch(c){if((0,P.toFileOperationResult)(c)===1)return;throw c}this.logService.info("Migrating extensions from old default profile location",i.toString());let o;try{const c=JSON.parse(s);Array.isArray(c)&&c.every(y=>k(y))?o=c:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.logService.error(c)}if(o)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,N.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(c){if((0,P.toFileOperationResult)(c)===3)this.logService.info("Migration from old default profile location to new location is done by another window",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw c}try{await this.fileService.del(i)}catch(c){(0,P.toFileOperationResult)(c)!==1&&this.logService.error(c)}try{await this.fileService.del(t)}catch(c){(0,P.toFileOperationResult)(c)!==1&&this.logService.error(c)}return o})()),this._migrationPromise}getResourceAccessQueue(i){let t=this.resourcesAccessQueueMap.get(i);return t||(t=new R.Queue,this.resourcesAccessQueueMap.set(i,t)),t}};e.AbstractExtensionsProfileScannerService=p=pe([G(1,P.IFileService),G(2,d.IUserDataProfilesService),G(3,g.IUriIdentityService),G(4,u.ITelemetryService),G(5,v.ILogService)],p);function k(r){return(0,w.isObject)(r)&&(0,b.isIExtensionIdentifier)(r.identifier)&&(n(r.location)||(0,w.isString)(r.location)&&r.location)&&((0,w.isUndefined)(r.relativeLocation)||(0,w.isString)(r.relativeLocation))&&r.version&&(0,w.isString)(r.version)}function n(r){return r?(0,w.isString)(r.path)&&(0,w.isString)(r.scheme):!1}}),define(ae[78],ce([0,1,21,6,31,16,7,34,133,2,25,15,5,22,52,88,10,12,148,14,33,49,67,13,4,8,24,3,64,50,17,29,176]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u,h,E,p,k,n,r,i,t,s,o,c,y,f,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var A;(function(ee){function Y(Z,j){if(Z===j)return!0;const B=Object.keys(Z),z=new Set;for(const ie of Object.keys(j))z.add(ie);if(B.length!==z.size)return!1;for(const ie of B){if(Z[ie]!==j[ie])return!1;z.delete(ie)}return z.size===0}ee.equals=Y})(A||(e.Translations=A={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let F=e.AbstractExtensionsScannerService=class extends S.Disposable{constructor(Y,Z,j,B,z,ie,re,K,Q,O,m,U){super(),this.systemExtensionsLocation=Y,this.userExtensionsLocation=Z,this.extensionsControlLocation=j,this.currentProfile=B,this.userDataProfilesService=z,this.extensionsProfileScannerService=ie,this.fileService=re,this.logService=K,this.environmentService=Q,this.productService=O,this.uriIdentityService=m,this.instantiationService=U,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(x,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(x,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(V,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,p.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(Y,Z,j){const[B,z]=await Promise.all([this.scanSystemExtensions(Y),this.scanUserExtensions(Z)]),ie=j?await this.scanExtensionsUnderDevelopment(Y,[...B,...z]):[];return this.dedupExtensions(B,z,ie,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Y){const Z=[];Z.push(this.scanDefaultSystemExtensions(!!Y.useCache,Y.language)),Z.push(this.scanDevSystemExtensions(Y.language,!!Y.checkControlFile));const[j,B]=await Promise.all(Z);return this.applyScanOptions([...j,...B],0,Y,!1)}async scanUserExtensions(Y){const Z=Y.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",Z);const j=this.uriIdentityService.extUri.isEqual(Y.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.createExtensionScannerInput(Z,!!Y.profileLocation,1,!Y.includeUninstalled,Y.language,!0,j),z=Y.useCache&&!B.devMode&&B.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let ie;try{ie=await z.scanExtensions(B)}catch(re){if(re instanceof y.ExtensionsProfileScanningError&&re.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),ie=await z.scanExtensions(B);else throw re}return ie=await this.applyScanOptions(ie,1,Y,!0),this.logService.trace("Scanned user extensions:",ie.length),ie}async scanExtensionsUnderDevelopment(Y,Z){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const j=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(B=>B.scheme===P.Schemas.file).map(async B=>{const z=await this.createExtensionScannerInput(B,!1,1,!0,Y.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(z)).map(re=>(re.type=Z.find(K=>(0,p.areSameExtensions)(K.identifier,re.identifier))?.type??re.type,this.extensionsScanner.validate(re,z)))}))).flat();return this.applyScanOptions(j,"development",Y,!0)}return[]}async scanExistingExtension(Y,Z,j){const B=await this.createExtensionScannerInput(Y,!1,Z,!0,j.language,!0,void 0),z=await this.extensionsScanner.scanExtension(B);return!z||!j.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions(Y,Z,j){const B=await this.createExtensionScannerInput(Y,!1,Z,!0,j.language,!0,void 0),z=await this.extensionsScanner.scanOneOrMultipleExtensions(B);return this.applyScanOptions(z,Z,j,!0)}async scanMetadata(Y){const Z=(0,d.joinPath)(Y,"package.json"),j=(await this.fileService.readFile(Z)).value.toString();return JSON.parse(j).__metadata}async updateMetadata(Y,Z){const j=(0,d.joinPath)(Y,"package.json"),B=(await this.fileService.readFile(j)).value.toString(),z=JSON.parse(B);Z.isMachineScoped=Z.isMachineScoped||void 0,Z.isBuiltin=Z.isBuiltin||void 0,z.__metadata={...z.__metadata,...Z},await this.fileService.writeFile((0,d.joinPath)(Y,"package.json"),T.VSBuffer.fromString(JSON.stringify(z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Y){if(Y instanceof y.ExtensionsProfileScanningError&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw Y}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Y=await this.scanUserExtensions({includeInvalid:!0});if(Y.length)await this.extensionsProfileScannerService.addExtensionsToProfile(Y.map(Z=>[Z,Z.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,T.VSBuffer.fromString(JSON.stringify([])))}catch(Z){(0,r.toFileOperationResult)(Z)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,_.getErrorMessage)(Z))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Y){this.logService.error(Y)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(Y,Z,j,B){return j.includeAllVersions||(Y=this.dedupExtensions(Z===0?Y:void 0,Z===1?Y:void 0,Z==="development"?Y:void 0,await this.getTargetPlatform(),B)),j.includeInvalid||(Y=Y.filter(z=>z.isValid)),Y.sort((z,ie)=>{const re=C.basename(z.location.fsPath),K=C.basename(ie.location.fsPath);return re<K?-1:re>K?1:0})}dedupExtensions(Y,Z,j,B,z){const ie=(K,Q,O)=>{if(K.isValid&&!Q.isValid)return!1;if(K.isValid===Q.isValid){if(z&&g.gt(K.manifest.version,Q.manifest.version))return this.logService.debug(`Skipping extension ${Q.location.path} with lower version ${Q.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(g.eq(K.manifest.version,Q.manifest.version)){if(K.type===0)return this.logService.debug(`Skipping extension ${Q.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===B)return this.logService.debug(`Skipping extension ${Q.location.path} from different target platform ${Q.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${K.location.path} with ${Q.location.path}.`):this.logService.debug(`Overwriting user extension ${K.location.path} with ${Q.location.path}.`),!0},re=new k.ExtensionIdentifierMap;return Y?.forEach(K=>{const Q=re.get(K.identifier.id);(!Q||ie(Q,K,!1))&&re.set(K.identifier.id,K)}),Z?.forEach(K=>{const Q=re.get(K.identifier.id);if(!Q&&Y&&K.type===0){this.logService.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!Q||ie(Q,K,!1))&&re.set(K.identifier.id,K)}),j?.forEach(K=>{const Q=re.get(K.identifier.id);(!Q||ie(Q,K,!0))&&re.set(K.identifier.id,K),re.set(K.identifier.id,K)}),[...re.values()]}async scanDefaultSystemExtensions(Y,Z){this.logService.trace("Started scanning system extensions");const j=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0),z=await(Y&&!j.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(j);return this.logService.trace("Scanned system extensions:",z.length),z}async scanDevSystemExtensions(Y,Z){const j=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!j?.length)return[];this.logService.trace("Started scanning dev system extensions");const B=Z?await this.getBuiltInExtensionControl():{},z=[],ie=u.URI.file(C.normalize(C.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of j){const Q=B[K.name]||"marketplace";switch(Q){case"disabled":break;case"marketplace":z.push((0,d.joinPath)(ie,K.name));break;default:z.push(u.URI.file(Q));break}}const re=await Promise.all(z.map(async K=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(K,!1,0,!0,Y,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",re.length),(0,R.coalesce)(re)}async getBuiltInExtensionControl(){try{const Y=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(Y.value.toString())}catch{return{}}}async createExtensionScannerInput(Y,Z,j,B,z,ie,re){const K=await this.getTranslations(z??v.language),Q=await this.getMtime(Y),O=Z&&!this.uriIdentityService.extUri.isEqual(Y,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,m=O?await this.getMtime(O):void 0;return new M(Y,Q,O,m,Z,re,j,B,ie,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,z,K)}async getMtime(Y){try{const Z=await this.fileService.stat(Y);if(typeof Z.mtime=="number")return Z.mtime}catch{}}};e.AbstractExtensionsScannerService=F=pe([G(4,f.IUserDataProfilesService),G(5,y.IExtensionsProfileScannerService),G(6,r.IFileService),G(7,t.ILogService),G(8,E.IEnvironmentService),G(9,s.IProductService),G(10,l.IUriIdentityService),G(11,i.IInstantiationService)],F);class M{constructor(Y,Z,j,B,z,ie,re,K,Q,O,m,U,W,J,$){this.location=Y,this.mtime=Z,this.applicationExtensionslocation=j,this.applicationExtensionslocationMtime=B,this.profile=z,this.profileScanOptions=ie,this.type=re,this.excludeObsolete=K,this.validate=Q,this.productVersion=O,this.productDate=m,this.productCommit=U,this.devMode=W,this.language=J,this.translations=$}static createNlsConfiguration(Y){return{language:Y.language,pseudo:Y.language==="pseudo",devMode:Y.devMode,translations:Y.translations}}static equals(Y,Z){return(0,d.isEqual)(Y.location,Z.location)&&Y.mtime===Z.mtime&&(0,d.isEqual)(Y.applicationExtensionslocation,Z.applicationExtensionslocation)&&Y.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&Y.profile===Z.profile&&L.equals(Y.profileScanOptions,Z.profileScanOptions)&&Y.type===Z.type&&Y.excludeObsolete===Z.excludeObsolete&&Y.validate===Z.validate&&Y.productVersion===Z.productVersion&&Y.productDate===Z.productDate&&Y.productCommit===Z.productCommit&&Y.devMode===Z.devMode&&Y.language===Z.language&&A.equals(Y.translations,Z.translations)}}e.ExtensionScannerInput=M;let V=class extends S.Disposable{constructor(Y,Z,j,B,z){super(),this.obsoleteFile=Y,this.extensionsProfileScannerService=Z,this.uriIdentityService=j,this.fileService=B,this.logService=z}async scanExtensions(Y){const Z=Y.profile?await this.scanExtensionsFromProfile(Y):await this.scanExtensionsFromLocation(Y);let j={};if(Y.excludeObsolete&&Y.type===1)try{const B=(await this.fileService.readFile(this.obsoleteFile)).value.toString();j=JSON.parse(B)}catch{}return(0,a.isEmptyObject)(j)?Z:Z.filter(B=>!j[p.ExtensionKey.create(B).toString()])}async scanExtensionsFromLocation(Y){const Z=await this.fileService.resolve(Y.location);if(!Z.children?.length)return[];const j=await Promise.all(Z.children.map(async B=>{if(!B.isDirectory||Y.type===1&&(0,d.basename)(B.resource).indexOf(".")===0)return null;const z=new M(B.resource,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(z)}));return(0,R.coalesce)(j).sort((B,z)=>B.location.path<z.location.path?-1:1)}async scanExtensionsFromProfile(Y){let Z=await this.scanExtensionsFromProfileResource(Y.location,()=>!0,Y);if(Y.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(Y.location,Y.applicationExtensionslocation)){Z=Z.filter(B=>!B.metadata?.isApplicationScoped);const j=await this.scanExtensionsFromProfileResource(Y.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,Y);Z.push(...j)}return Z}async scanExtensionsFromProfileResource(Y,Z,j){const B=await this.extensionsProfileScannerService.scanProfileExtensions(Y,j.profileScanOptions);if(!B.length)return[];const z=await Promise.all(B.map(async ie=>{if(Z(ie)){const re=new M(ie.location,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.profileScanOptions,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(re,ie.metadata)}return null}));return(0,R.coalesce)(z)}async scanOneOrMultipleExtensions(Y){try{if(await this.fileService.exists((0,d.joinPath)(Y.location,"package.json"))){const Z=await this.scanExtension(Y);return Z?[Z]:[]}else return await this.scanExtensions(Y)}catch(Z){return this.logService.error(`Error scanning extensions at ${Y.location.path}:`,(0,_.getErrorMessage)(Z)),[]}}async scanExtension(Y,Z){try{let j=await this.scanExtensionManifest(Y.location);if(j){j.publisher||(j.publisher=k.UNDEFINED_PUBLISHER),Z=Z??j.__metadata,delete j.__metadata;const B=(0,p.getGalleryExtensionId)(j.publisher,j.name),z=Z?.id?{id:B,uuid:Z.id}:{id:B},ie=Z?.isSystem?0:Y.type,re=ie===0||!!Z?.isBuiltin;j=await this.translateManifest(Y.location,j,M.createNlsConfiguration(Y));const K={type:ie,identifier:z,manifest:j,location:Y.location,isBuiltin:re,targetPlatform:Z?.targetPlatform??"undefined",metadata:Z,isValid:!0,validations:[]};return Y.validate?this.validate(K,Y):K}}catch(j){Y.type!==0&&this.logService.error(j)}return null}validate(Y,Z){let j=!0;const B=(0,n.validateExtensionManifest)(Z.productVersion,Z.productDate,Z.location,Y.manifest,Y.isBuiltin);for(const[z,ie]of B)z===w.default.Error&&(j=!1,this.logService.error(this.formatMessage(Z.location,ie)));return Y.isValid=j,Y.validations=B,Y}async scanExtensionManifest(Y){const Z=(0,d.joinPath)(Y,"package.json");let j;try{j=(await this.fileService.readFile(Z)).value.toString()}catch(z){return(0,r.toFileOperationResult)(z)!==1&&this.logService.error(this.formatMessage(Y,(0,h.localize)(0,null,Z.path,z.message))),null}let B;try{B=JSON.parse(j)}catch{const ie=[];(0,D.parse)(j,ie);for(const re of ie)this.logService.error(this.formatMessage(Y,(0,h.localize)(1,null,Z.path,re.offset,re.length,(0,b.getParseErrorMessage)(re.error))));return null}return(0,D.getNodeType)(B)!=="object"?(this.logService.error(this.formatMessage(Y,(0,h.localize)(2,null,Z.path))),null):B}async translateManifest(Y,Z,j){const B=await this.getLocalizedMessages(Y,Z,j);if(B)try{const z=[],ie=await this.resolveOriginalMessageBundle(B.default,z);if(z.length>0)return z.forEach(K=>{this.logService.error(this.formatMessage(Y,(0,h.localize)(3,null,B.default?.path,(0,b.getParseErrorMessage)(K.error))))}),Z;if((0,D.getNodeType)(B)!=="object")return this.logService.error(this.formatMessage(Y,(0,h.localize)(4,null,B.default?.path))),Z;const re=B.values||Object.create(null);return(0,I.localizeManifest)(Z,re,ie)}catch{}return Z}async getLocalizedMessages(Y,Z,j){const B=(0,d.joinPath)(Y,"package.nls.json"),z=(Q,O)=>{O.forEach(m=>{this.logService.error(this.formatMessage(Y,(0,h.localize)(5,null,Q?.path,(0,b.getParseErrorMessage)(m.error))))})},ie=Q=>{this.logService.error(this.formatMessage(Y,(0,h.localize)(6,null,Q?.path)))},re=`${Z.publisher}.${Z.name}`,K=j.translations[re];if(K)try{const Q=u.URI.file(K),O=(await this.fileService.readFile(Q)).value.toString(),m=[],U=(0,D.parse)(O,m);return m.length>0?(z(Q,m),{values:void 0,default:B}):(0,D.getNodeType)(U)!=="object"?(ie(Q),{values:void 0,default:B}):{values:U.contents?U.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.fileService.exists(B))return;let O;try{O=await this.findMessageBundles(Y,j)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const m=(await this.fileService.readFile(O.localized)).value.toString(),U=[],W=(0,D.parse)(m,U);return U.length>0?(z(O.localized,U),{values:void 0,default:O.original}):(0,D.getNodeType)(W)!=="object"?(ie(O.localized),{values:void 0,default:O.original}):{values:W,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(Y,Z){if(Y)try{const j=(await this.fileService.readFile(Y)).value.toString();return(0,D.parse)(j,Z)}catch{}}findMessageBundles(Y,Z){return new Promise((j,B)=>{const z=ie=>{const re=(0,d.joinPath)(Y,`package.nls.${ie}.json`);this.fileService.exists(re).then(K=>{K&&j({localized:re,original:(0,d.joinPath)(Y,"package.nls.json")});const Q=ie.lastIndexOf("-");Q===-1?j({localized:(0,d.joinPath)(Y,"package.nls.json"),original:null}):(ie=ie.substring(0,Q),z(ie))})};if(Z.devMode||Z.pseudo||!Z.language)return j({localized:(0,d.joinPath)(Y,"package.nls.json"),original:null});z(Z.language)})}formatMessage(Y,Z){return`[${Y.path}]: ${Z}`}};V=pe([G(1,y.IExtensionsProfileScannerService),G(2,l.IUriIdentityService),G(3,r.IFileService),G(4,t.ILogService)],V);let x=class extends V{constructor(Y,Z,j,B,z,ie,re){super(Z,B,z,ie,re),this.currentProfile=Y,this.userDataProfilesService=j,this.cacheValidatorThrottler=this._register(new N.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(Y){const Z=this.getCacheFile(Y),j=await this.readExtensionCache(Z);if(this.input=Y,j&&j.input&&M.equals(j.input,this.input))return this.logService.debug("Using cached extensions scan result",Y.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),j.result.map(z=>(z.location=u.URI.revive(z.location),z));const B=await super.scanExtensions(Y);return await this.writeExtensionCache(Z,{input:Y,result:B}),B}async readExtensionCache(Y){try{const Z=await this.fileService.readFile(Y),j=JSON.parse(Z.value.toString());return{result:j.result,input:(0,c.revive)(j.input)}}catch(Z){this.logService.debug("Error while reading the extension cache file:",Y.path,(0,_.getErrorMessage)(Z))}return null}async writeExtensionCache(Y,Z){try{await this.fileService.writeFile(Y,T.VSBuffer.fromString(JSON.stringify(Z)))}catch(j){this.logService.debug("Error while writing the extension cache file:",Y.path,(0,_.getErrorMessage)(j))}}async validateCache(){if(!this.input)return;const Y=this.getCacheFile(this.input),Z=await this.readExtensionCache(Y);if(!Z)return;const j=Z.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!L.equals(B,j))try{this.logService.info("Invalidating Cache",j,B),await this.fileService.del(Y),this._onDidChangeCache.fire()}catch(z){this.logService.error(z)}}getCacheFile(Y){const Z=this.getProfile(Y);return this.uriIdentityService.extUri.joinPath(Z.cacheHome,Y.type===0?k.BUILTIN_MANIFEST_CACHE_FILE:k.USER_MANIFEST_CACHE_FILE)}getProfile(Y){return Y.type===0?this.userDataProfilesService.defaultProfile:Y.profile?this.uriIdentityService.extUri.isEqual(Y.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(Z=>this.uriIdentityService.extUri.isEqual(Y.location,Z.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};x=pe([G(2,f.IUserDataProfilesService),G(3,y.IExtensionsProfileScannerService),G(4,l.IUriIdentityService),G(5,r.IFileService),G(6,t.ILogService)],x);function q(ee,Y){const Z=(0,p.getExtensionId)(ee.manifest.publisher,ee.manifest.name);return{id:Z,identifier:new k.ExtensionIdentifier(Z),isBuiltin:ee.type===0,isUserBuiltin:ee.type===1&&ee.isBuiltin,isUnderDevelopment:Y,extensionLocation:ee.location,uuid:ee.identifier.uuid,targetPlatform:ee.targetPlatform,...ee.manifest}}e.toExtensionDescription=q;class X extends F{constructor(Y,Z,j,B,z,ie,re,K,Q,O,m,U){super(Y,Z,(0,d.joinPath)(j,".vscode-oss-dev","extensions","control.json"),B,z,ie,re,K,Q,O,m,U),this.translationsPromise=(async()=>{if(v.translationsConfigFile)try{const W=await this.fileService.readFile(u.URI.file(v.translationsConfigFile));return JSON.parse(W.value.toString())}catch{}return Object.create(null)})()}getTranslations(Y){return this.translationsPromise}}e.NativeExtensionsScannerService=X}),define(ae[237],ce([0,1,65,6,38,3,2,25,15,30,8,17]),function(ne,e,R,N,L,T,_,D,b,S,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=e.ExtensionsLifecycle=class extends _.Disposable{constructor(g,w){super(),this.userDataProfilesService=g,this.logService=w,this.processesLimiter=new N.Limiter(5)}async postUninstall(g){const w=this.parseScript(g,"uninstall");w&&(this.logService.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(w.script,"uninstall",w.args,!0,g),this.logService.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(a){this.logService.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.logService.error(a)}}));try{await S.Promises.rm(this.getExtensionStoragePath(g))}catch(a){this.logService.error("Error while removing extension storage path",g.identifier.id),this.logService.error(a)}}parseScript(g,w){const a=`vscode:${w}`;if(g.location.scheme===D.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[a]=="string"){const u=g.manifest.scripts[a].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.logService.warn(g.identifier.id,g.manifest.version,`${a} should be a node script`),null):{script:(0,b.join)(g.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}runLifecycleHook(g,w,a,u,h){return new Promise((E,p)=>{const k=this.start(g,w,a,h);let n;const r=i=>{n&&(clearTimeout(n),n=null),i?p(i):E(void 0)};k.on("error",i=>{r((0,L.toErrorMessage)(i)||"Unknown")}),k.on("exit",(i,t)=>{r(i?`post-${w} process exited with code ${i}`:void 0)}),u&&(n=setTimeout(()=>{n=null,k.kill(),p("timed out")},5e3))})}start(g,w,a,u){const h={silent:!0,execArgv:void 0},E=(0,R.fork)(g,[`--type=extension-post-${w}`,...a],h);E.stdout.setEncoding("utf8"),E.stderr.setEncoding("utf8");const p=T.Event.fromNodeEventEmitter(E.stdout,"data"),k=T.Event.fromNodeEventEmitter(E.stderr,"data");p(i=>this.logService.info(u.identifier.id,u.manifest.version,`post-${w}`,i)),k(i=>this.logService.error(u.identifier.id,u.manifest.version,`post-${w}`,i));const n=T.Event.any(T.Event.map(p,i=>({data:`%c${i}`,format:[""]})),T.Event.map(k,i=>({data:`%c${i}`,format:["color: red"]})));return T.Event.debounce(n,(i,t)=>i?{data:i.data+t.data,format:[...i.format,...t.format]}:{data:t.data,format:t.format},100)(i=>{console.group(u.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),E}getExtensionStoragePath(g){return(0,b.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=v=pe([G(0,C.IUserDataProfilesService),G(1,P.ILogService)],v)}),define(ae[238],ce([0,1,8,17,29,20,50,13,14,12]),function(ne,e,R,N,L,T,_,D,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=e.ExtensionsProfileScannerService=class extends _.AbstractExtensionsProfileScannerService{constructor(v,d,g,w,a,u){super(S.URI.file(v.extensionsPath),d,g,w,a,u)}};e.ExtensionsProfileScannerService=P=pe([G(0,b.INativeEnvironmentService),G(1,D.IFileService),G(2,N.IUserDataProfilesService),G(3,L.IUriIdentityService),G(4,T.ITelemetryService),G(5,R.ILogService)],P)}),define(ae[239],ce([0,1,12,14,50,78,13,4,8,24,29,17]),function(ne,e,R,N,L,T,_,D,b,S,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let v=e.ExtensionsScannerService=class extends T.NativeExtensionsScannerService{constructor(g,w,a,u,h,E,p,k){super(R.URI.file(h.builtinExtensionsPath),R.URI.file(h.extensionsPath),h.userHome,g.defaultProfile,g,w,a,u,h,E,p,k)}};e.ExtensionsScannerService=v=pe([G(0,C.IUserDataProfilesService),G(1,L.IExtensionsProfileScannerService),G(2,_.IFileService),G(3,b.ILogService),G(4,N.INativeEnvironmentService),G(5,S.IProductService),G(6,P.IUriIdentityService),G(7,D.IInstantiationService)],v)}),define(ae[19],ce([0,1,6,3,2,100,10,66,4,17]),function(ne,e,R,N,L,T,_,D,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,b.createDecorator)("storageService");var P;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var C;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var v;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function d(h){const E=h.get(e.TARGET_KEY);if(E)try{return JSON.parse(E)}catch{}return Object.create(null)}e.loadKeyTargets=d;class g extends L.Disposable{constructor(E={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super(),this.options=E,this._onDidChangeValue=this._register(new N.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new N.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new N.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(E,p){const{key:k,external:n}=p;if(k===e.TARGET_KEY){switch(E){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:E})}else this._onDidChangeValue.fire({scope:E,key:k,target:this.getKeyTargets(E)[k],external:n})}emitWillSaveState(E){this._onWillSaveState.fire({reason:E})}get(E,p,k){return this.getStorage(p)?.get(E,k)}getBoolean(E,p,k){return this.getStorage(p)?.getBoolean(E,k)}getNumber(E,p,k){return this.getStorage(p)?.getNumber(E,k)}getObject(E,p,k){return this.getStorage(p)?.getObject(E,k)}storeAll(E,p){this.withPausedEmitters(()=>{for(const k of E)this.store(k.key,k.value,k.scope,k.target,p)})}store(E,p,k,n,r=!1){if((0,_.isUndefinedOrNull)(p)){this.remove(E,k,r);return}this.withPausedEmitters(()=>{this.updateKeyTarget(E,k,n),this.getStorage(k)?.set(E,p,r)})}remove(E,p,k=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(E,p,void 0),this.getStorage(p)?.delete(E,k)})}withPausedEmitters(E){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{E()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(E,p){const k=[],n=this.getKeyTargets(E);for(const r of Object.keys(n))n[r]===p&&k.push(r);return k}updateKeyTarget(E,p,k,n=!1){const r=this.getKeyTargets(p);typeof k=="number"?r[E]!==k&&(r[E]=k,this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(r),n)):typeof r[E]=="number"&&(delete r[E],this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(r),n))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(E){switch(E){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(E){const p=this.getStorage(E);return p?d(p):Object.create(null)}isNew(E){return this.getBoolean(e.IS_NEW_KEY,E)===!0}async flush(E=P.NONE){this._onWillSaveState.fire({reason:E});const p=this.getStorage(-1),k=this.getStorage(0),n=this.getStorage(1);switch(E){case P.NONE:await R.Promises.settled([p?.whenFlushed()??Promise.resolve(),k?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await R.Promises.settled([p?.flush(0)??Promise.resolve(),k?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const E=this.getStorage(-1)?.items??new Map,p=this.getStorage(0)?.items??new Map,k=this.getStorage(1)?.items??new Map;return u(E,p,k,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(E,p){return this.emitWillSaveState(P.NONE),(0,S.isUserDataProfile)(E)?this.switchToProfile(E,p):this.switchToWorkspace(E,p)}canSwitchProfile(E,p){return!(E.id===p.id||w(p)&&w(E))}switchData(E,p,k){this.withPausedEmitters(()=>{const n=new Set;for(const[r,i]of E)n.add(r),p.get(r)!==i&&this.emitDidChangeValue(k,{key:r,external:!0});for(const[r]of p.items)n.has(r)||this.emitDidChangeValue(k,{key:r,external:!0})})}}e.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;function w(h){return h.isDefault||!!h.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=w;class a extends g{constructor(){super(),this.applicationStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(E=>this.emitDidChangeValue(1,E))),this._register(this.profileStorage.onDidChangeStorage(E=>this.emitDidChangeValue(0,E))),this._register(this.applicationStorage.onDidChangeStorage(E=>this.emitDidChangeValue(-1,E)))}getStorage(E){switch(E){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(E){switch(E){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(E){return!1}}e.InMemoryStorageService=a;async function u(h,E,p,k,n,r){const i=A=>{try{return JSON.parse(A)}catch{return A}},t=new Map,s=new Map;h.forEach((A,F)=>{t.set(F,A),s.set(F,i(A))});const o=new Map,c=new Map;E.forEach((A,F)=>{o.set(F,A),c.set(F,i(A))});const y=new Map,f=new Map;p.forEach((A,F)=>{y.set(F,A),f.set(F,i(A))}),console.group(k!==n?`Storage: Application (path: ${k})`:`Storage: Application & Profile (path: ${k}, default profile)`);const l=[];if(t.forEach((A,F)=>{l.push({key:F,value:A})}),console.table(l),console.groupEnd(),console.log(s),k!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const A=[];o.forEach((F,M)=>{A.push({key:M,value:F})}),console.table(A),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${r})`);const I=[];y.forEach((A,F)=>{I.push({key:F,value:A})}),console.table(I),console.groupEnd(),console.log(f)}e.logStorage=u}),define(ae[113],ce([0,1,3,2,10,28,33,19]),function(ne,e,R,N,L,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let b=e.GlobalExtensionEnablementService=class extends N.Disposable{constructor(C,v){super(),this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new S(C)),this._register(this.storageManger.onDidChange(d=>this._onDidChangeEnablement.fire({extensions:d,source:"storage"}))),this._register(v.onDidInstallExtensions(d=>d.forEach(({local:g,operation:w})=>{g&&w===4&&this._removeFromDisabledExtensions(g.identifier)})))}async enableExtension(C,v){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:v}),!0):!1}async disableExtension(C,v){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:v}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){const v=this.getDisabledExtensions();return v.every(d=>!(0,_.areSameExtensions)(d,C))?(v.push(C),this._setDisabledExtensions(v),!0):!1}_removeFromDisabledExtensions(C){const v=this.getDisabledExtensions();for(let d=0;d<v.length;d++){const g=v[d];if((0,_.areSameExtensions)(g,C))return v.splice(d,1),this._setDisabledExtensions(v),!0}return!1}_setDisabledExtensions(C){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,v){this.storageManger.set(C,v,0)}};e.GlobalExtensionEnablementService=b=pe([G(0,D.IStorageService),G(1,T.IExtensionManagementService)],b);class S extends N.Disposable{constructor(C){super(),this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(v=>this.onDidStorageChange(v)))}get(C,v){let d;return v===0?((0,L.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,v)),d=this.storage[C]):d=this._get(C,v),JSON.parse(d)}set(C,v,d){const g=JSON.stringify(v.map(({id:a,uuid:u})=>({id:a,uuid:u})));this._get(C,d)!==g&&(d===0&&(v.length?this.storage[C]=g:delete this.storage[C]),this._set(C,v.length?g:void 0,d))}onDidStorageChange(C){if(C.scope===0&&!(0,L.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const d=this.get(C.key,C.scope);delete this.storage[C.key];const g=this.get(C.key,C.scope),w=d.filter(u=>!g.some(h=>(0,_.areSameExtensions)(u,h))),a=g.filter(u=>!d.some(h=>(0,_.areSameExtensions)(h,u)));(w.length||a.length)&&this._onDidChange.fire([...w,...a])}}_get(C,v){return this.storageService.get(C,v,"[]")}_set(C,v,d){v?this.storageService.store(C,v,d,1):this.storageService.remove(C,d)}}e.StorageManager=S}),define(ae[240],ce([0,1,21,26,7,5,37,10,12,18,14,28,33,67,13,8,24,56,217,19,20]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u,h,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const k=T.isWeb?"web":(0,C.getTargetPlatform)(T.platform,_.arch),n="X-Market-Search-Activity-Id";var r;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function i(...O){return String(O.reduce((m,U)=>m|U,0))}var t;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class f{constructor(m=y){this.state=m}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(m,U=this.state.pageSize){return new f({...this.state,pageNumber:m,pageSize:U})}withFilter(m,...U){const W=[...this.state.criteria,...U.length?U.map(J=>({filterType:m,value:J})):[{filterType:m}]];return new f({...this.state,criteria:W})}withSortBy(m){return new f({...this.state,sortBy:m})}withSortOrder(m){return new f({...this.state,sortOrder:m})}withFlags(...m){return new f({...this.state,flags:m.reduce((U,W)=>U|W,0)})}withAssetTypes(...m){return new f({...this.state,assetTypes:m})}withSource(m){return new f({...this.state,source:m})}get raw(){const{criteria:m,pageNumber:U,pageSize:W,sortBy:J,sortOrder:$,flags:H,assetTypes:te}=this.state;return{filters:[{criteria:m,pageNumber:U,pageSize:W,sortBy:J,sortOrder:$}],assetTypes:te,flags:H}}get searchText(){const m=this.state.criteria.filter(U=>U.filterType===t.SearchText)[0];return m&&m.value?m.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(m=>String(m.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function l(O,m){const U=(O||[]).filter(W=>W.statisticName===m)[0];return U?U.value:0}function I(O){const m="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(W=>W.assetType.indexOf(m)===0).reduce((W,J)=>{const $=M(O,J.assetType);return $&&W.push([J.assetType.substring(m.length),$]),W},[])}function A(O){if(O.properties){const m=O.properties.filter(J=>J.key===s.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=m.filter(J=>U.test(J.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return M(O,s.Repository)}function F(O){return{uri:`${O.fallbackAssetUri}/${s.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${s.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function M(O,m){return O.files.filter(W=>W.assetType===m)[0]?{uri:`${O.assetUri}/${m}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${m}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function V(O,m){const U=O.properties?O.properties.filter(J=>J.key===m):[],W=U.length>0&&U[0].value;return W?W.split(",").map(J=>(0,v.adoptToGalleryExtensionId)(J)):[]}function x(O){const m=O.properties?O.properties.filter(U=>U.key===o.Engine):[];return m.length>0&&m[0].value||""}function q(O){const m=O.properties?O.properties.filter(U=>U.key===o.PreRelease):[];return m.length>0&&m[0].value==="true"}function X(O){const m=O.properties?O.properties.filter(W=>W.key===o.LocalizedLanguages):[],U=m.length>0&&m[0].value||"";return U?U.split(","):[]}function ee(O){return O.properties?.find(m=>m.key===o.SponsorLink)?.value}function Y(O){return O.indexOf("preview")!==-1}function Z(O){return O.targetPlatform?(0,C.toTargetPlatform)(O.targetPlatform):"undefined"}function j(O){const m=(0,R.distinct)(O.versions.map(Z)),U=!!O.tags?.includes(C.WEB_EXTENSION_TAG),W=m.indexOf("web");return U?W===-1&&m.push("web"):W!==-1&&m.splice(W,1),m}function B(O,m){const U=(0,C.getFallbackTargetPlarforms)(m);for(let W=0;W<O.length;W++){const J=O[W];if(J.version===O[W-1]?.version){let $=W;const H=Z(J);if(H===m)for(;$>0&&O[$-1].version===J.version;)$--;else if(U.includes(H))for(;$>0&&O[$-1].version===J.version&&Z(O[$-1])!==m;)$--;$!==W&&(O.splice(W,1),O.splice($,0,J))}}return O}e.sortExtensionVersions=B;function z(O,m,U){O.telemetryData={index:m,querySource:U,queryActivityId:O.queryContext?.[n]}}function ie(O,m,U,W){const J=O.versions[0],$={manifest:M(m,s.Manifest),readme:M(m,s.Details),changelog:M(m,s.Changelog),license:M(m,s.License),repository:A(m),download:F(m),icon:M(m,s.Icon),signature:M(m,s.Signature),coreTranslations:I(m)};return{identifier:{id:(0,v.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:m.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:ee(J),description:O.shortDescription||"",installCount:l(O.statistics,"install"),rating:l(O.statistics,"averagerating"),ratingCount:l(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:U,assets:$,properties:{dependencies:V(m,o.Dependency),extensionPack:V(m,o.ExtensionPack),engine:x(m),localizedLanguages:X(m),targetPlatform:Z(m),isPreReleaseVersion:q(m)},hasPreReleaseVersion:q(J),hasReleaseVersion:!0,preview:Y(O.flags),isSigned:!!$.signature,queryContext:W}}let re=class{constructor(m,U,W,J,$,H,te,oe){this.requestService=U,this.logService=W,this.environmentService=J,this.telemetryService=$,this.fileService=H,this.productService=te,this.configurationService=oe;const ue=te.extensionsGallery,de=ue?.servicePPEUrl&&oe.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=de?ue.servicePPEUrl:ue?.serviceUrl,this.extensionsGallerySearchUrl=de?void 0:ue?.searchUrl,this.extensionsControlUrl=ue?.controlUrl,this.commonHeadersPromise=(0,h.resolveMarketplaceHeaders)(te.version,te,this.environmentService,this.configurationService,this.fileService,m,this.telemetryService)}api(m=""){return`${this.extensionsGalleryUrl}${m}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(m,U,W){const J=N.CancellationToken.isCancellationToken(U)?{}:U,$=N.CancellationToken.isCancellationToken(U)?U:W,H=[],te=[],oe=[],ue=[];let de=!0;for(const Ce of m){Ce.uuid?te.push(Ce.uuid):H.push(Ce.id);const De=!!(Ce.version||Ce.preRelease);oe.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:De}),Ce.version&&ue.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),de=de&&!!Ce.hasPreRelease&&!De}if(!te.length&&!H.length)return[];let ve=new f().withPage(1,m.length);te.length&&(ve=ve.withFilter(t.ExtensionId,...te)),H.length&&(ve=ve.withFilter(t.ExtensionName,...H)),(J.queryAllVersions||de)&&(ve=ve.withFlags(ve.flags,r.IncludeVersions)),J.source&&(ve=ve.withSource(J.source));const{extensions:Ee}=await this.queryGalleryExtensions(ve,{targetPlatform:J.targetPlatform??k,includePreRelease:oe,versions:ue,compatible:!!J.compatible},$);return J.source&&Ee.forEach((Ce,De)=>z(Ce,De,J.source)),Ee}async getCompatibleExtension(m,U,W){if((0,C.isNotWebExtensionInWebTargetPlatform)(m.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(m,U,W))return m;const J=new f().withFlags(r.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,m.identifier.uuid),{extensions:$}=await this.queryGalleryExtensions(J,{targetPlatform:W,compatible:!0,includePreRelease:U},N.CancellationToken.None);return $[0]||null}async isExtensionCompatible(m,U,W){if(!(0,C.isTargetPlatformCompatible)(m.properties.targetPlatform,m.allTargetPlatforms,W)||!U&&m.properties.isPreReleaseVersion)return!1;let J=m.properties.engine;if(!J){const $=await this.getManifest(m,N.CancellationToken.None);if(!$)throw new Error("Manifest was not found");J=$.engines.vscode}return(0,d.isEngineValid)(J,this.productService.version,this.productService.date)}async isValidVersion(m,U,W,J,$){if(!(0,C.isTargetPlatformCompatible)(Z(m),J,$)||U!=="any"&&q(m)!==(U==="prerelease"))return!1;if(W)try{const H=await this.getEngine(m);if(!(0,d.isEngineValid)(H,this.productService.version,this.productService.date))return!1}catch(H){return this.logService.error(`Error while getting the engine for the version ${m.version}.`,(0,L.getErrorMessage)(H)),!1}return!0}async query(m,U){let W=m.text||"";const J=m.pageSize??50;let $=new f().withPage(1,J);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ve,Ee)=>($=$.withFilter(t.Category,Ee||ve),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ve,Ee)=>($=$.withFilter(t.Tag,Ee||ve),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>($=$.withFilter(t.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),$=$.withFilter(t.SearchText,W)),$=$.withSortBy(0)):m.ids?$=$.withFilter(t.ExtensionId,...m.ids):m.names?$=$.withFilter(t.ExtensionName,...m.names):$=$.withSortBy(4),typeof m.sortBy=="number"&&($=$.withSortBy(m.sortBy)),typeof m.sortOrder=="number"&&($=$.withSortOrder(m.sortOrder)),m.source&&($=$.withSource(m.source));const H=async(de,ve)=>{const{extensions:Ee,total:Ce}=await this.queryGalleryExtensions(de,{targetPlatform:k,compatible:!1,includePreRelease:!!m.includePreRelease},ve);return Ee.forEach((De,Le)=>z(De,(de.pageNumber-1)*de.pageSize+Le,m.source)),{extensions:Ee,total:Ce}},{extensions:te,total:oe}=await H($,U),ue=async(de,ve)=>{if(ve.isCancellationRequested)throw new L.CancellationError;const{extensions:Ee}=await H($.withPage(de+1),ve);return Ee};return{firstPage:te,total:oe,pageSize:$.pageSize,getPage:ue}}async queryGalleryExtensions(m,U,W){const J=m.flags;m.flags&r.IncludeLatestVersionOnly&&m.flags&r.IncludeVersions&&(m=m.withFlags(m.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(m.flags&r.IncludeLatestVersionOnly)&&!(m.flags&r.IncludeVersions)&&(m=m.withFlags(m.flags,r.IncludeLatestVersionOnly)),U.versions?.length&&(m=m.withFlags(m.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),m=m.withFlags(m.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:$,total:H,context:te}=await this.queryRawGalleryExtensions(m,W);if(!(m.flags&r.IncludeLatestVersionOnly)){const ve=[];for(const Ee of $){const Ce=await this.toGalleryExtensionWithCriteria(Ee,U,te);Ce&&ve.push(Ce)}return{extensions:ve,total:H}}const ue=[],de=new Map;for(let ve=0;ve<$.length;ve++){const Ee=$[ve],Ce={id:(0,v.getGalleryExtensionId)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},De=(0,D.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(We=>(0,v.areSameExtensions)(We,Ce))?.includePreRelease;if(U.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(j(Ee),U.targetPlatform))continue;const Le=await this.toGalleryExtensionWithCriteria(Ee,U,te);!Le||Le.properties.isPreReleaseVersion&&(!De||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==U.targetPlatform&&Le.hasPreReleaseVersion?de.set(Ee.extensionId,ve):ue.push([ve,Le])}if(de.size){const ve=new Date().getTime(),Ee=new f().withFlags(J&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,de.size).withFilter(t.ExtensionId,...de.keys()),{extensions:Ce}=await this.queryGalleryExtensions(Ee,U,W);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ve,count:de.size});for(const De of Ce){const Le=de.get(De.identifier.uuid);ue.push([Le,De])}}return{extensions:ue.sort((ve,Ee)=>ve[0]-Ee[0]).map(([,ve])=>ve),total:H}}async toGalleryExtensionWithCriteria(m,U,W){const J={id:(0,v.getGalleryExtensionId)(m.publisher.publisherName,m.extensionName),uuid:m.extensionId},$=U.versions?.find(ue=>(0,v.areSameExtensions)(ue,J))?.version,H=(0,D.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(ue=>(0,v.areSameExtensions)(ue,J))?.includePreRelease,te=j(m),oe=B(m.versions,U.targetPlatform);if(U.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(te,U.targetPlatform))return null;for(let ue=0;ue<oe.length;ue++){const de=oe[ue];if(!($&&de.version!==$)){if(await this.isValidVersion(de,H?"any":"release",U.compatible,te,U.targetPlatform))return ie(m,de,te,W);if($&&de.version===$)return null}}return $||U.compatible?null:ie(m,m.versions[0],te)}async queryRawGalleryExtensions(m,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");m=m.withFlags(m.flags,r.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(r.Unpublished));const W=await this.commonHeadersPromise,J=JSON.stringify(m.raw),$={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},H=new Date().getTime();let te,oe,ue=0;try{if(te=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&m.criteria.some(ve=>ve.filterType===t.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:J,headers:$},U),te.res.statusCode&&te.res.statusCode>=400&&te.res.statusCode<500)return{galleryExtensions:[],total:ue};const de=await(0,u.asJson)(te);if(de){const ve=de.results[0],Ee=ve.extensions,Ce=ve.resultMetadata&&ve.resultMetadata.filter(De=>De.metadataType==="ResultCount")[0];return ue=Ce&&Ce.metadataItems.filter(De=>De.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:ue,context:{[n]:te.res.headers.activityid}}}return{galleryExtensions:[],total:ue}}catch(de){throw oe=de,de}finally{this.telemetryService.publicLog2("galleryService:query",{...m.telemetryData,requestBodySize:String(J.length),duration:new Date().getTime()-H,success:!!te&&(0,u.isSuccess)(te),responseBodySize:te?.res.headers["Content-Length"],statusCode:te?String(te.res.statusCode):void 0,errorCode:oe?(0,L.isCancellationError)(oe)?"canceled":(0,L.getErrorMessage)(oe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(m,U,W,J){if(!this.isEnabled())return;const $=T.isWeb?this.api(`/itemName/${m}.${U}/version/${W}/statType/${J==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${m}/extensions/${U}/${W}/stats?statType=${J}`),H=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",oe={...await this.commonHeadersPromise,Accept:H};try{await this.requestService.request({type:"POST",url:$,headers:oe},N.CancellationToken.None)}catch{}}async download(m,U,W){this.logService.trace("ExtensionGalleryService#download",m.identifier.id);const J=(0,v.getGalleryExtensionTelemetryData)(m),$=new Date().getTime(),H=ve=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...J,duration:ve}),te=W===2?"install":W===3?"update":"",oe=te?{uri:`${m.assets.download.uri}${b.URI.parse(m.assets.download.uri).query?"&":"?"}${te}=true`,fallbackUri:`${m.assets.download.fallbackUri}${b.URI.parse(m.assets.download.fallbackUri).query?"&":"?"}${te}=true`}:m.assets.download,ue=m.queryContext?.[n]?{[n]:m.queryContext[n]}:void 0,de=await this.getAsset(oe,ue?{headers:ue}:void 0);await this.fileService.writeFile(U,de.stream),H(new Date().getTime()-$)}async downloadSignatureArchive(m,U){if(!m.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",m.identifier.id);const W=await this.getAsset(m.assets.signature);await this.fileService.writeFile(U,W.stream)}async getReadme(m,U){if(m.assets.readme){const W=await this.getAsset(m.assets.readme,{},U);return await(0,u.asTextOrError)(W)||""}return""}async getManifest(m,U){if(m.assets.manifest){const W=await this.getAsset(m.assets.manifest,{},U),J=await(0,u.asTextOrError)(W);return J?JSON.parse(J):null}return null}async getManifestFromRawExtensionVersion(m,U){const W=M(m,s.Manifest);if(!W)throw new Error("Manifest was not found");const J={"Accept-Encoding":"gzip"},$=await this.getAsset(W,{headers:J});return await(0,u.asJson)($)}async getCoreTranslation(m,U){const W=m.assets.coreTranslations.filter(J=>J[0]===U.toUpperCase())[0];if(W){const J=await this.getAsset(W[1]),$=await(0,u.asTextOrError)(J);return $?JSON.parse($):null}return null}async getChangelog(m,U){if(m.assets.changelog){const W=await this.getAsset(m.assets.changelog,{},U);return await(0,u.asTextOrError)(W)||""}return""}async getAllCompatibleVersions(m,U,W){let J=new f().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);m.identifier.uuid?J=J.withFilter(t.ExtensionId,m.identifier.uuid):J=J.withFilter(t.ExtensionName,m.identifier.id);const{galleryExtensions:$}=await this.queryRawGalleryExtensions(J,N.CancellationToken.None);if(!$.length)return[];const H=j($[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(H,W))return[];const te=[];await Promise.all($[0].versions.map(async de=>{try{await this.isValidVersion(de,U?"any":"release",!0,H,W)&&te.push(de)}catch{}}));const oe=[],ue=new Set;for(const de of B(te,W))ue.has(de.version)||(ue.add(de.version),oe.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:q(de)}));return oe}async getAsset(m,U={},W=N.CancellationToken.None){const J=await this.commonHeadersPromise,$={type:"GET"},H={...J,...U.headers||{}};U={...U,...$,headers:H};const te=m.uri,oe=m.fallbackUri,ue={...U,url:te};try{const de=await this.requestService.request(ue,W);if(de.res.statusCode===200)return de;const ve=await(0,u.asTextOrError)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${ve}`)}catch(de){if((0,L.isCancellationError)(de))throw de;const ve=(0,L.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:te,message:ve});const Ee={...U,url:oe};return this.requestService.request(Ee,W)}}async getEngine(m){let U=x(m);if(!U){const W=await this.getManifestFromRawExtensionVersion(m,N.CancellationToken.None);if(!W)throw new Error("Manifest was not found");U=W.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const m=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},N.CancellationToken.None);if(m.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,u.asJson)(m),W=[],J={},$=[];if(U){for(const H of U.malicious)W.push({id:H});if(U.migrateToPreRelease)for(const[H,te]of Object.entries(U.migrateToPreRelease))(!te.engine||(0,d.isEngineValid)(te.engine,this.productService.version,this.productService.date))&&(J[H.toLowerCase()]={disallowInstall:!0,extension:{id:te.id,displayName:te.displayName,autoMigrate:{storage:!!te.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[H,te]of Object.entries(U.deprecated))te&&(J[H.toLowerCase()]=(0,D.isBoolean)(te)?{}:te);if(U.search)for(const H of U.search)$.push(H)}return{malicious:W,deprecated:J,search:$}}};re=pe([G(1,u.IRequestService),G(2,w.ILogService),G(3,P.IEnvironmentService),G(4,p.ITelemetryService),G(5,g.IFileService),G(6,a.IProductService),G(7,S.IConfigurationService)],re);let K=e.ExtensionGalleryService=class extends re{constructor(m,U,W,J,$,H,te,oe){super(m,U,W,J,$,H,te,oe)}};e.ExtensionGalleryService=K=pe([G(0,E.IStorageService),G(1,u.IRequestService),G(2,w.ILogService),G(3,P.IEnvironmentService),G(4,p.ITelemetryService),G(5,g.IFileService),G(6,a.IProductService),G(7,S.IConfigurationService)],K);let Q=e.ExtensionGalleryServiceWithNoStorageService=class extends re{constructor(m,U,W,J,$,H,te){super(void 0,m,U,W,J,$,H,te)}};e.ExtensionGalleryServiceWithNoStorageService=Q=pe([G(0,u.IRequestService),G(1,w.ILogService),G(2,P.IEnvironmentService),G(3,p.ITelemetryService),G(4,g.IFileService),G(5,a.IProductService),G(6,S.IConfigurationService)],Q)}),define(ae[79],ce([0,1,4,3,2,19,33,24,21,8,10]),function(ne,e,R,N,L,T,_,D,b,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,R.createDecorator)("IExtensionStorageService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let v=e.ExtensionStorageService=class Je extends L.Disposable{static toKey(g){return`extensionKeys/${(0,_.adoptToGalleryExtensionId)(g.id)}@${g.version}`}static fromKey(g){const w=C.exec(g);if(w&&w[1])return{id:w[1],version:w[2]}}static async removeOutdatedExtensionVersions(g,w){const a=await g.getInstalled(),u=[];for(const[h,E]of Je.readAllExtensionsWithKeysForSync(w)){const p=a.find(k=>(0,_.areSameExtensions)(k.identifier,{id:h}))?.manifest.version;for(const k of E)p!==k&&u.push(Je.toKey({id:h,version:k}))}for(const h of u)w.remove(h,0)}static readAllExtensionsWithKeysForSync(g){const w=new Map,a=g.keys(0,1);for(const u of a){const h=Je.fromKey(u);if(h){let E=w.get(h.id.toLowerCase());E||w.set(h.id.toLowerCase(),E=[]),E.push(h.version)}}return w}constructor(g,w,a){super(),this.storageService=g,this.productService=w,this.logService=a,this._onDidChangeExtensionStorageToSync=this._register(new N.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Je.readAllExtensionsWithKeysForSync(g),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}onDidChangeStorageValue(g){if(g.scope!==0)return;if(this.extensionsWithKeysForSync.has(g.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const w=Je.fromKey(g.key);if(w){if(this.storageService.get(g.key,0)===void 0)this.extensionsWithKeysForSync.delete(w.id.toLowerCase());else{let a=this.extensionsWithKeysForSync.get(w.id.toLowerCase());a||this.extensionsWithKeysForSync.set(w.id.toLowerCase(),a=[]),a.push(w.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(g){if((0,P.isString)(g))return g;const w=g.manifest?g.manifest.publisher:g.publisher,a=g.manifest?g.manifest.name:g.name;return(0,_.getExtensionId)(w,a)}getExtensionState(g,w){const a=this.getExtensionId(g),u=this.getExtensionStateRaw(g,w);if(u)try{return JSON.parse(u)}catch(h){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${a}, global: ${w}): ${h}`)}}getExtensionStateRaw(g,w){const a=this.getExtensionId(g),u=this.storageService.get(a,w?0:1);return u&&u?.length>Je.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${a}, global: ${w}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(g,w,a){const u=this.getExtensionId(g);w===void 0?this.storageService.remove(u,a?0:1):this.storageService.store(u,JSON.stringify(w),a?0:1,1)}setKeysForSync(g,w){this.storageService.store(Je.toKey(g),JSON.stringify(w),0,1)}getKeysForSync(g){const w=this.productService.extensionSyncedKeys?.[g.id.toLowerCase()],a=this.storageService.get(Je.toKey(g),0),u=a?JSON.parse(a):void 0;return u&&w?(0,b.distinct)([...u,...w]):u||w}addToMigrationList(g,w){if(g!==w){const a=this.migrationList.filter(u=>!u.includes(g)&&!u.includes(w));a.push([g,w]),this.migrationList=a}}getSourceExtensionToMigrate(g){const w=this.migrationList.find(([,a])=>g===a);return w?w[0]:void 0}get migrationList(){const g=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const w=JSON.parse(g);if(Array.isArray(w))return w}catch{}return[]}set migrationList(g){g.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(g),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};v.LARGE_STATE_WARNING_THRESHOLD=512*1024,e.ExtensionStorageService=v=pe([G(0,T.IStorageService),G(1,D.IProductService),G(2,S.ILogService)],v)}),define(ae[241],ce([0,1,28,13,24,14,98,54,19,20,214]),function(ne,e,R,N,L,T,_,D,b,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let C=e.ExtensionTipsService=class extends P.AbstractNativeExtensionTipsService{constructor(d,g,w,a,u,h,E,p){super(d.userHome,u,g,w,a,h,E,p)}};e.ExtensionTipsService=C=pe([G(0,T.INativeEnvironmentService),G(1,S.ITelemetryService),G(2,R.IExtensionManagementService),G(3,b.IStorageService),G(4,D.INativeHostService),G(5,_.IExtensionRecommendationNotificationService),G(6,N.IFileService),G(7,L.IProductService)],C)}),define(ae[242],ce([0,1,105,3,20,14,2,8,15,65,24,5,6,101,18,158,36,19,10]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const E=[R.CONFIGURATION_KEY_HOST_NAME,R.CONFIGURATION_KEY_PREVENT_SLEEP],p="remoteTunnelSession";let k=e.RemoteTunnelService=class extends _.Disposable{constructor(i,t,s,o,c,y,f){super(),this.telemetryService=i,this.productService=t,this.environmentService=s,this.configurationService=y,this.storageService=f,this._onDidTokenFailedEmitter=new N.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new N.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeSessionEmitter=new N.Emitter,this.onDidChangeSession=this._onDidChangeSessionEmitter.event,this._initialized=!1,this._logger=this._register(o.createLogger(R.LOG_ID,{name:R.LOGGER_NAME})),this._startTunnelProcessDelayer=new v.Delayer(100),this._register(this._logger.onDidChangeLogLevel(l=>this._logger.info("Log level changed to "+(0,D.LogLevelToString)(l)))),this._register(c.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(y.onDidChangeConfiguration(l=>{E.some(I=>l.affectsConfiguration(I))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())})),this._session=this._restoreSession(),this._tunnelStatus=R.TunnelStates.uninitialized}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(i){this._tunnelStatus=i,this._onDidChangeTunnelStatusEmitter.fire(i)}setSession(i){n(i,this._session)||(this._session=i,this._onDidChangeSessionEmitter.fire(i),this._storeSession(i),i?(this._logger.info(`Session updated: ${i.accountLabel} (${i.providerId})`),i.token&&this._logger.info(`Session token updated: ${i.accountLabel} (${i.providerId})`)):this._logger.info("Session reset"))}async getSession(){return this._session}async initialize(i){if(this._initialized)return this._tunnelStatus;this._initialized=!0,this.setSession(i);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(t){this._logger.error(t)}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let i;C.isMacintosh?i=this.environmentService.appRoot:i=(0,b.dirname)((0,b.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,b.join)(i,"bin",`${this.productService.tunnelApplicationName}${C.isWindows?".exe":""}`)}return this._tunnelCommand}async startTunnel(i){if(n(i,this._session)&&this._tunnelStatus.type!=="disconnected")return this._tunnelStatus;this.setSession(i);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(t){this._logger.error(t)}return this._tunnelStatus}async stopTunnel(){this.setSession(void 0),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);const i=(t,s)=>{s?this._logger.error(t):this._logger.info(t)};try{await this.runCodeTunnelCommand("stop",["kill"],i)}catch(t){this._logger.error(t)}this.setTunnelStatus(R.TunnelStates.disconnected())}async updateTunnelProcess(){this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:!!this._session}),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);let i=!1,t="";const s=(I,A)=>{A?this._logger.error(I):t+=I,!this.environmentService.isBuilt&&I.startsWith("   Compiling")&&this.setTunnelStatus(R.TunnelStates.connecting((0,w.localize)(0,null)))},o=this.runCodeTunnelCommand("status",["status"],s);this._tunnelProcess=o;try{if(await o,this._tunnelProcess!==o)return;if(i=!!JSON.parse(t.trim().split(`
`).find(A=>A.startsWith("{"))).tunnel,this._logger.info(i?"Other tunnel running, attaching...":"No other tunnel running"),!i&&!this._session){this._tunnelProcess=void 0,this.setTunnelStatus(R.TunnelStates.disconnected());return}}catch(I){this._logger.error(I),this._tunnelProcess=void 0,this.setTunnelStatus(R.TunnelStates.disconnected());return}const c=this._session;if(c&&c.token){const I=c.token;this.setTunnelStatus(R.TunnelStates.connecting((0,w.localize)(1,null,c.accountLabel,c.providerId)));const A=(M,V)=>{M=M.replaceAll(I,"*".repeat(4)),s(M,V)},F=this.runCodeTunnelCommand("login",["user","login","--provider",c.providerId,"--access-token",I,"--log",(0,D.LogLevelToString)(this._logger.getLevel())],A);this._tunnelProcess=F;try{if(await F,this._tunnelProcess!==F)return}catch(M){this._logger.error(M),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(c),this.setTunnelStatus(R.TunnelStates.disconnected(c));return}}const y=this._getTunnelName();y?this.setTunnelStatus(R.TunnelStates.connecting((0,w.localize)(2,null,y))):this.setTunnelStatus(R.TunnelStates.connecting((0,w.localize)(3,null)));const f=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,D.LogLevelToString)(this._logger.getLevel())];y?f.push("--name",y):f.push("--random-name"),this._preventSleep()&&f.push("--no-sleep");const l=this.runCodeTunnelCommand("tunnel",f,(I,A)=>{A?this._logger.error(I):this._logger.info(I);const F=I.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const M={link:F[1],domain:F[2],tunnelName:F[4],isAttached:i};this.setTunnelStatus(R.TunnelStates.connected(M))}else I.match(/error refreshing token/)&&(l.cancel(),this._onDidTokenFailedEmitter.fire(c),this.setTunnelStatus(R.TunnelStates.disconnected(c)))});this._tunnelProcess=l,l.finally(()=>{l===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._session=void 0,this.setTunnelStatus(R.TunnelStates.disconnected()))})}runCodeTunnelCommand(i,t,s=()=>{}){return(0,v.createCancelablePromise)(o=>new Promise((c,y)=>{o.isCancellationRequested&&c(-1);let f;const l=["ignore","pipe","pipe"];if(o.onCancellationRequested(()=>{f&&(this._logger.info(`${i} terminating(${f.pid})`),f.kill())}),!this.environmentService.isBuilt)s(`Building tunnel CLI from sources and run
`,!1),s(`${i} Spawning: cargo run -- tunnel ${t.join(" ")}
`,!1),f=(0,S.spawn)("cargo",["run","--","tunnel",...t],{cwd:(0,b.join)(this.environmentService.appRoot,"cli"),stdio:l});else{s(`Running tunnel CLI
`,!1);const I=this.getTunnelCommandLocation();s(`${i} Spawning: ${I} tunnel ${t.join(" ")}
`,!1),f=(0,S.spawn)(I,["tunnel",...t],{cwd:(0,a.homedir)(),stdio:l})}f.stdout.on("data",I=>{if(f){const A=I.toString();s(A,!1)}}),f.stderr.on("data",I=>{if(f){const A=I.toString();s(A,!0)}}),f.on("exit",I=>{f&&(s(`${i} exit(${f.pid}): + ${I} `,!1),f=void 0,c(I||0))}),f.on("error",I=>{f&&(s(`${i} error(${f.pid}): + ${I} `,!0),f=void 0,y())})}))}async getTunnelName(){return this._getTunnelName()}_preventSleep(){return!!this.configurationService.getValue(R.CONFIGURATION_KEY_PREVENT_SLEEP)}_getTunnelName(){let i=this.configurationService.getValue(R.CONFIGURATION_KEY_HOST_NAME)||(0,a.hostname)();return i=i.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),i||void 0}_restoreSession(){try{const i=this.storageService.get(p,-1);if(i){const t=JSON.parse(i);if(t&&(0,h.isString)(t.accountLabel)&&(0,h.isString)(t.sessionId)&&(0,h.isString)(t.providerId))return t;this._logger.error("Problems restoring session from storage, invalid format",t)}}catch(i){this._logger.error("Problems restoring session from storage",i)}}_storeSession(i){if(i){const t={providerId:i.providerId,sessionId:i.sessionId,accountLabel:i.accountLabel};this.storageService.store(p,JSON.stringify(t),-1,1)}else this.storageService.remove(p,-1)}};e.RemoteTunnelService=k=pe([G(0,L.ITelemetryService),G(1,P.IProductService),G(2,T.INativeEnvironmentService),G(3,D.ILoggerService),G(4,d.ISharedProcessLifecycleService),G(5,g.IConfigurationService),G(6,u.IStorageService)],k);function n(r,i){return r&&i?r.sessionId===i.sessionId&&r.providerId===i.providerId&&r.token===i.token:r===i}}),define(ae[243],ce([0,1,6,2,22,66,19,75,17]),function(ne,e,R,N,L,T,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class S extends _.AbstractStorageService{constructor(C,v,d,g){super(),this.initialWorkspace=C,this.initialProfiles=v,this.remoteService=d,this.environmentService=g,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new N.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new N.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const C=this._register(new D.ApplicationStorageDatabaseClient(this.remoteService.getChannel("storage"))),v=this._register(new T.Storage(C));return this._register(v.onDidChangeStorage(d=>this.emitDidChangeValue(-1,d))),v}createProfileStorage(C){this.profileStorageDisposables.clear(),this.profileStorageProfile=C;let v;if((0,_.isProfileUsingDefaultStorage)(C))v=this.applicationStorage;else{const d=this.profileStorageDisposables.add(new D.ProfileStorageDatabaseClient(this.remoteService.getChannel("storage"),C));v=this.profileStorageDisposables.add(new T.Storage(d))}return this.profileStorageDisposables.add(v.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),v}createWorkspaceStorage(C){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=C?.id;let v;if(C){const d=this.workspaceStorageDisposables.add(new D.WorkspaceStorageDatabaseClient(this.remoteService.getChannel("storage"),C));v=this.workspaceStorageDisposables.add(new T.Storage(d)),this.workspaceStorageDisposables.add(v.onDidChangeStorage(g=>this.emitDidChangeValue(1,g)))}return v}async doInitialize(){await R.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(C){switch(C){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(C){switch(C){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,L.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(_.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(C){if(!this.canSwitchProfile(this.profileStorageProfile,C))return;const v=this.profileStorage,d=v.items;v!==this.applicationStorage&&await v.close(),this.profileStorage=this.createProfileStorage(C),await this.profileStorage.init(),this.switchData(d,this.profileStorage,0)}async switchToWorkspace(C,v){const d=this.workspaceStorage,g=d?.items??new Map;await d?.close(),this.workspaceStorage=this.createWorkspaceStorage(C),await this.workspaceStorage.init(),this.switchData(g,this.workspaceStorage,1)}hasScope(C){return(0,b.isUserDataProfile)(C)?this.profileStorageProfile.id===C.id:this.workspaceStorageId===C.id}}e.RemoteStorageService=S}),define(ae[244],ce([0,1,3,2,17,91]),function(ne,e,R,N,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class _{constructor(S,P){this.service=S,this.getUriTransformer=P}listen(S,P){const C=this.getUriTransformer(S);switch(P){case"onDidChangeProfiles":return R.Event.map(this.service.onDidChangeProfiles,v=>({all:v.all.map(d=>(0,T.transformOutgoingURIs)({...d},C)),added:v.added.map(d=>(0,T.transformOutgoingURIs)({...d},C)),removed:v.removed.map(d=>(0,T.transformOutgoingURIs)({...d},C)),updated:v.updated.map(d=>(0,T.transformOutgoingURIs)({...d},C))}))}throw new Error(`Invalid listen ${P}`)}async call(S,P,C){const v=this.getUriTransformer(S);switch(P){case"createProfile":{const d=await this.service.createProfile(C[0],C[1],C[2]);return(0,T.transformOutgoingURIs)({...d},v)}case"updateProfile":{let d=(0,L.reviveProfile)((0,T.transformIncomingURIs)(C[0],v),this.service.profilesHome.scheme);return d=await this.service.updateProfile(d,C[1]),(0,T.transformOutgoingURIs)({...d},v)}case"removeProfile":{const d=(0,L.reviveProfile)((0,T.transformIncomingURIs)(C[0],v),this.service.profilesHome.scheme);return this.service.removeProfile(d)}}throw new Error(`Invalid call ${P}`)}}e.RemoteUserDataProfilesServiceChannel=_;class D extends N.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(S,P,C){super(),this.profilesHome=P,this.channel=C,this._profiles=[],this._onDidChangeProfiles=this._register(new R.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=S.map(v=>(0,L.reviveProfile)(v,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(v=>{const d=v.added.map(a=>(0,L.reviveProfile)(a,this.profilesHome.scheme)),g=v.removed.map(a=>(0,L.reviveProfile)(a,this.profilesHome.scheme)),w=v.updated.map(a=>(0,L.reviveProfile)(a,this.profilesHome.scheme));this._profiles=v.all.map(a=>(0,L.reviveProfile)(a,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:d,removed:g,updated:w,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(S){this.enabled=S}isEnabled(){return this.enabled}async createNamedProfile(S,P,C){const v=await this.channel.call("createNamedProfile",[S,P,C]);return(0,L.reviveProfile)(v,this.profilesHome.scheme)}async createProfile(S,P,C,v){const d=await this.channel.call("createProfile",[S,P,C,v]);return(0,L.reviveProfile)(d,this.profilesHome.scheme)}async createTransientProfile(S){const P=await this.channel.call("createTransientProfile",[S]);return(0,L.reviveProfile)(P,this.profilesHome.scheme)}async setProfileForWorkspace(S,P){await this.channel.call("setProfileForWorkspace",[S,P])}removeProfile(S){return this.channel.call("removeProfile",[S])}async updateProfile(S,P){const C=await this.channel.call("updateProfile",[S,P]);return(0,L.reviveProfile)(C,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=D}),define(ae[58],ce([0,1,2,66,4,19,3,75,17]),function(ne,e,R,N,L,T,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,L.createDecorator)("IUserDataProfileStorageService");let S=e.AbstractUserDataProfileStorageService=class extends R.Disposable{constructor(d){super(),this.storageService=d}async readStorageData(d){return this.withProfileScopedStorageService(d,async g=>this.getItems(g))}async updateStorageData(d,g,w){return this.withProfileScopedStorageService(d,async a=>this.writeItems(a,g,w))}async withProfileScopedStorageService(d,g){if(this.storageService.hasScope(d))return g(this.storageService);const w=await this.createStorageDatabase(d),a=new C(w);try{await a.initialize();const u=await g(a);return await a.flush(),u}finally{a.dispose(),await this.closeAndDispose(w)}}getItems(d){const g=new Map,w=a=>{for(const u of d.keys(0,a))g.set(u,{value:d.get(u,0),target:a})};return w(0),w(1),g}writeItems(d,g,w){d.storeAll(Array.from(g.entries()).map(([a,u])=>({key:a,value:u,scope:0,target:w})),!0)}async closeAndDispose(d){try{await d.close()}finally{(0,R.isDisposable)(d)&&d.dispose()}}};e.AbstractUserDataProfileStorageService=S=pe([G(0,T.IStorageService)],S);class P extends S{constructor(d,g,w,a){super(w),this.remoteService=d;const u=d.getChannel("profileStorageListener"),h=this._register(new R.MutableDisposable);this._onDidChange=this._register(new _.Emitter({onWillAddFirstListener:()=>{h.value=u.listen("onDidChange")(E=>{a.trace("profile storage changes",E),this._onDidChange.fire({targetChanges:E.targetChanges.map(p=>(0,b.reviveProfile)(p,g.profilesHome.scheme)),valueChanges:E.valueChanges.map(p=>({...p,profile:(0,b.reviveProfile)(p.profile,g.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>h.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(d){const g=this.remoteService.getChannel("storage");return(0,T.isProfileUsingDefaultStorage)(d)?new D.ApplicationStorageDatabaseClient(g):new D.ProfileStorageDatabaseClient(g,d)}}e.RemoteUserDataProfileStorageService=P;class C extends T.AbstractStorageService{constructor(d){super({flushInterval:100}),this.profileStorage=this._register(new N.Storage(d))}doInitialize(){return this.profileStorage.init()}getStorage(d){return d===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(ae[245],ce([0,1,19,8,17,71,58]),function(ne,e,R,N,L,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let D=e.NativeUserDataProfileStorageService=class extends _.RemoteUserDataProfileStorageService{constructor(S,P,C,v){super(S,P,C,v)}};e.NativeUserDataProfileStorageService=D=pe([G(0,T.IMainProcessService),G(1,L.IUserDataProfilesService),G(2,R.IStorageService),G(3,N.ILogService)],D)}),define(ae[39],ce([0,1,21,6,16,26,3,34,2,27,10,163,18,14,13,8,44,19,20,29,23,17]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u,h,E,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function n(y){return!!(y&&y.ref!==void 0&&typeof y.ref=="string"&&y.ref!==""&&y.syncData!==void 0&&(y.syncData===null||r(y.syncData)))}e.isRemoteUserData=n;function r(y){return!!(y&&y.version!==void 0&&typeof y.version=="number"&&y.content!==void 0&&typeof y.content=="string"&&(Object.keys(y).length===2||Object.keys(y).length===3&&y.machineId!==void 0&&typeof y.machineId=="string"))}e.isSyncData=r;function i(y,f){return`${(0,S.uppercaseFirstLetter)(y)}${f.isDefault?"":` (${f.name})`}`}e.getSyncResourceLogLabel=i;let t=e.AbstractSynchroniser=class extends b.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(f,l,I,A,F,M,V,x,q,X,ee,Y){super(),this.syncResource=f,this.collection=l,this.fileService=I,this.environmentService=A,this.storageService=F,this.userDataSyncStoreService=M,this.userDataSyncBackupStoreService=V,this.userDataSyncEnablementService=x,this.telemetryService=q,this.logService=X,this.configurationService=ee,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new N.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=i(f.syncResource,f.profile),this.extUri=Y.extUri,this.syncFolder=this.extUri.joinPath(A.userDataSyncHome,...(0,p.getPathSegments)(f.profile.isDefault?void 0:f.profile.id,f.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,p.PREVIEW_DIR_NAME),this.lastSyncResource=(0,p.getLastSyncResourceUri)(f.profile.isDefault?void 0:f.profile.id,f.syncResource,A,this.extUri),this.currentMachineIdPromise=(0,a.getServiceMachineId)(A,I,F)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const f=await this.syncPreviewPromise;this.syncPreviewPromise=null;const l=await this.performSync(f.remoteUserData,f.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(l)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const f=await this.getLastSyncUserData();(f?await this.hasRemoteChanged(f):!0)&&this._onDidChangeLocal.fire()}}setStatus(f){this._status!==f&&(this._status=f,this._onDidChangStatus.fire(f))}async sync(f,l={}){await this._sync(f,!0,this.getUserDataSyncConfiguration(),l)}async preview(f,l,I={}){return this._sync(f,!1,l,I)}async apply(f,l={}){try{this.syncHeaders={...l};const I=await this.doApply(f);return this.setStatus(I),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(f,l,I,A){try{if(this.syncHeaders={...A},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let F="idle";try{const M=await this.getLastSyncUserData(),V=await this.getLatestRemoteUserData(f,M);return F=await this.performSync(V,M,l,I),F==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(F)}}finally{this.syncHeaders={}}}async replace(f){const l=this.parseSyncData(f);if(!l)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const I=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,I),F=await this.isRemoteDataFromCurrentMachine(A),M=await this.generateSyncPreview({ref:A.ref,syncData:l},I,F,this.getUserDataSyncConfiguration(),T.CancellationToken.None),V=[];for(const x of M){const q=await this.getAcceptResult(x,x.remoteResource,void 0,T.CancellationToken.None),{remoteChange:X}=await this.getAcceptResult(x,x.previewResource,x.remoteContent,T.CancellationToken.None);V.push([x,{...q,remoteChange:X!==0?X:2}])}await this.applyResult(A,I,V,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(f){const l=await this.currentMachineIdPromise;return!!f.syncData?.machineId&&f.syncData.machineId===l}async getLatestRemoteUserData(f,l){if(l){const I=f?f[this.resource]:void 0;if(l.ref===I||I===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async performSync(f,l,I,A){if(f.syncData&&f.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new p.UserDataSyncError((0,C.localize)(0,null,this.resource,this.version,f.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(f,l,I,A)}catch(F){if(F instanceof p.UserDataSyncError)switch(F.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(f,l,I,A);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),f=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.performSync(f,l,I,A)}throw F}}async doSync(f,l,I,A){try{const F=await this.isRemoteDataFromCurrentMachine(f),M=!F&&l===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,V=I&&!M;this.syncPreviewPromise||(this.syncPreviewPromise=(0,N.createCancelablePromise)(q=>this.doGenerateSyncResourcePreview(f,l,F,V,A,q)));let x=await this.syncPreviewPromise;if(I&&M){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const q of x.resourcePreviews)x=await this.accept(q.remoteResource)||x}return this.updateConflicts(x.resourcePreviews),x.resourcePreviews.some(({mergeState:q})=>q==="conflict")?"hasConflicts":I?await this.doApply(!1):"syncing"}catch(F){throw this.syncPreviewPromise=null,F}}async merge(f){return await this.updateSyncResourcePreview(f,async l=>{const I=await this.getMergeResult(l,T.CancellationToken.None);await this.fileService.writeFile(l.previewResource,L.VSBuffer.fromString(I?.content||""));const A=I&&!I.hasConflicts?await this.getAcceptResult(l,l.previewResource,void 0,T.CancellationToken.None):void 0;return l.acceptResult=A,l.mergeState=I.hasConflicts?"conflict":A?"accepted":"preview",l.localChange=A?A.localChange:I.localChange,l.remoteChange=A?A.remoteChange:I.remoteChange,l}),this.syncPreviewPromise}async accept(f,l){return await this.updateSyncResourcePreview(f,async I=>{const A=await this.getAcceptResult(I,f,l,T.CancellationToken.None);return I.acceptResult=A,I.mergeState="accepted",I.localChange=A.localChange,I.remoteChange=A.remoteChange,I}),this.syncPreviewPromise}async discard(f){return await this.updateSyncResourcePreview(f,async l=>{const I=await this.getMergeResult(l,T.CancellationToken.None);return await this.fileService.writeFile(l.previewResource,L.VSBuffer.fromString(I.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=I.localChange,l.remoteChange=I.remoteChange,l}),this.syncPreviewPromise}async updateSyncResourcePreview(f,l){if(!this.syncPreviewPromise)return;let I=await this.syncPreviewPromise;const A=I.resourcePreviews.findIndex(({localResource:F,remoteResource:M,previewResource:V})=>this.extUri.isEqual(F,f)||this.extUri.isEqual(M,f)||this.extUri.isEqual(V,f));A!==-1&&(this.syncPreviewPromise=(0,N.createCancelablePromise)(async F=>{const M=[...I.resourcePreviews];return M[A]=await l(M[A]),{...I,resourcePreviews:M}}),I=await this.syncPreviewPromise,this.updateConflicts(I.resourcePreviews),I.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(f){if(!this.syncPreviewPromise)return"idle";const l=await this.syncPreviewPromise;return l.resourcePreviews.some(({mergeState:I})=>I==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:I})=>I!=="accepted")?"syncing":(await this.applyResult(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(I=>[I,I.acceptResult]),f),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(f){const l=f.filter(({mergeState:I})=>I==="conflict");(0,R.equals)(this._conflicts,l,(I,A)=>this.extUri.isEqual(I.previewResource,A.previewResource))||(this._conflicts=l,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const f=await this.getLastSyncUserData();return!!f&&f.syncData!==null}async resolvePreviewContent(f){const l=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(l)for(const I of l.resourcePreviews){if(this.extUri.isEqual(I.acceptedResource,f))return I.acceptResult?I.acceptResult.content:null;if(this.extUri.isEqual(I.remoteResource,f))return I.remoteContent;if(this.extUri.isEqual(I.localResource,f))return I.localContent;if(this.extUri.isEqual(I.baseResource,f))return I.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,-1);try{await this.fileService.del(this.lastSyncResource)}catch(f){(0,g.toFileOperationResult)(f)!==1&&this.logService.error(f)}}async doGenerateSyncResourcePreview(f,l,I,A,F,M){const V=await this.generateSyncPreview(f,l,I,F,M),x=[];for(const q of V){const X=q.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(q.localChange===0&&q.remoteChange===0)x.push({...q,acceptedResource:X,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const ee=A?await this.getMergeResult(q,M):void 0;if(M.isCancellationRequested)break;await this.fileService.writeFile(q.previewResource,L.VSBuffer.fromString(ee?.content||""));const Y=ee&&!ee.hasConflicts?await this.getAcceptResult(q,q.previewResource,void 0,M):void 0;x.push({...q,acceptResult:Y,mergeState:ee?.hasConflicts?"conflict":Y?"accepted":"preview",localChange:Y?Y.localChange:ee?ee.localChange:q.localChange,remoteChange:Y?Y.remoteChange:ee?ee.remoteChange:q.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:f,lastSyncUserData:l,resourcePreviews:x,isLastSyncFromCurrentMachine:I}}async getLastSyncUserData(){let f=this.getStoredLastSyncUserDataStateContent();if(f||(f=await this.migrateLastSyncUserData()),!f)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const l=JSON.parse(f),I=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!l.version&&!!I&&l.version!==I,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${I}.`),await this.resetLocal(),null;let A,F=1;for(;A===void 0&&F++<6;)try{const M=await this.readLastSyncStoredRemoteUserData();M&&(M.ref===l.ref?A=M.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof g.FileOperationError&&M.fileOperationResult===1){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(M instanceof p.UserDataSyncError)throw M;this.logService.error(M,F)}}if(A===void 0)try{const M=await this.userDataSyncStoreService.resolveResourceContent(this.resource,l.ref,this.collection,this.syncHeaders);A=M===null?null:this.parseSyncData(M),await this.writeLastSyncStoredRemoteUserData({ref:l.ref,syncData:A})}catch(M){if(M instanceof p.UserDataSyncError&&M.code==="NotFound")this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw M}return A===void 0?null:{...l,syncData:A}}async updateLastSyncUserData(f,l={}){if(l.ref||l.version)throw new Error("Cannot have core properties as additional");const I=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),A={ref:f.ref,version:I,...l};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(A),-1,1),await this.writeLastSyncStoredRemoteUserData(f)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async readLastSyncStoredRemoteUserData(){const f=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const l=f?JSON.parse(f):void 0;if(n(l))return l}catch(l){this.logService.error(l)}}async writeLastSyncStoredRemoteUserData(f){await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(f)))}async migrateLastSyncUserData(){try{const f=await this.fileService.readFile(this.lastSyncResource),l=JSON.parse(f.value.toString());await this.fileService.del(this.lastSyncResource),l.ref&&l.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...l,content:void 0}),-1,1),await this.writeLastSyncStoredRemoteUserData({ref:l.ref,syncData:l.content===null?null:JSON.parse(l.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,l)}catch(f){f instanceof g.FileOperationError&&f.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(f)}return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async getRemoteUserData(f){const{ref:l,content:I}=await this.getUserData(f);let A=null;return I!==null&&(A=this.parseSyncData(I)),{ref:l,syncData:A}}parseSyncData(f){try{const l=JSON.parse(f);if(r(l))return l}catch(l){this.logService.error(l)}throw new p.UserDataSyncError((0,C.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(f){const l=f?{ref:f.ref,content:f.syncData?JSON.stringify(f.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,l,this.collection,this.syncHeaders)}async updateRemoteUserData(f,l){const I=await this.currentMachineIdPromise,A={version:this.version,machineId:I,content:f};try{return l=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(A),l,this.collection,this.syncHeaders),{ref:l,syncData:A}}catch(F){throw F instanceof p.UserDataSyncError&&F.code==="TooLarge"&&(F=new p.UserDataSyncError(F.message,F.code,this.resource)),F}}async backupLocal(f){const l={version:this.version,content:f};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(l))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=t=pe([G(2,g.IFileService),G(3,d.IEnvironmentService),G(4,u.IStorageService),G(5,p.IUserDataSyncStoreService),G(6,p.IUserDataSyncBackupStoreService),G(7,p.IUserDataSyncEnablementService),G(8,h.ITelemetryService),G(9,p.IUserDataSyncLogService),G(10,v.IConfigurationService),G(11,E.IUriIdentityService)],t);let s=e.AbstractFileSynchroniser=class extends t{constructor(f,l,I,A,F,M,V,x,q,X,ee,Y,Z){super(l,I,A,F,M,V,x,q,X,ee,Y,Z),this.file=f,this._register(this.fileService.watch(this.extUri.dirname(f))),this._register(this.fileService.onDidFilesChange(j=>this.onFileChanges(j)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(f,l,I){try{l?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(f),I?void 0:l):await this.fileService.createFile(this.file,L.VSBuffer.fromString(f),{overwrite:I})}catch(A){throw A instanceof g.FileOperationError&&A.fileOperationResult===1||A instanceof g.FileOperationError&&A.fileOperationResult===3?new p.UserDataSyncError(A.message,"LocalPreconditionFailed"):A}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(f){if(!(f instanceof g.FileOperationError&&f.fileOperationResult===1))throw f}}onFileChanges(f){f.contains(this.file)&&this.triggerLocalChange()}};e.AbstractFileSynchroniser=s=pe([G(3,g.IFileService),G(4,d.IEnvironmentService),G(5,u.IStorageService),G(6,p.IUserDataSyncStoreService),G(7,p.IUserDataSyncBackupStoreService),G(8,p.IUserDataSyncEnablementService),G(9,h.ITelemetryService),G(10,p.IUserDataSyncLogService),G(11,v.IConfigurationService),G(12,E.IUriIdentityService)],s);let o=e.AbstractJsonFileSynchroniser=class extends s{constructor(f,l,I,A,F,M,V,x,q,X,ee,Y,Z,j){super(f,l,I,A,F,M,V,x,q,X,ee,Z,j),this.userDataSyncUtilService=Y,this._formattingOptions=void 0}hasErrors(f,l){const I=[],A=(0,D.parse)(f,I,{allowEmptyContent:!0,allowTrailingComma:!0});return I.length>0||!(0,P.isUndefined)(A)&&l!==Array.isArray(A)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};e.AbstractJsonFileSynchroniser=o=pe([G(3,g.IFileService),G(4,d.IEnvironmentService),G(5,u.IStorageService),G(6,p.IUserDataSyncStoreService),G(7,p.IUserDataSyncBackupStoreService),G(8,p.IUserDataSyncEnablementService),G(9,h.ITelemetryService),G(10,p.IUserDataSyncLogService),G(11,p.IUserDataSyncUtilService),G(12,v.IConfigurationService),G(13,E.IUriIdentityService)],o);let c=e.AbstractInitializer=class{constructor(f,l,I,A,F,M,V){this.resource=f,this.userDataProfilesService=l,this.environmentService=I,this.logService=A,this.fileService=F,this.storageService=M,this.extUri=V.extUri,this.lastSyncResource=(0,p.getLastSyncResourceUri)(void 0,this.resource,I,this.extUri)}async initialize({ref:f,content:l}){if(!l){this.logService.info("Remote content does not exist.",this.resource);return}const I=this.parseSyncData(l);if(I)try{await this.doInitialize({ref:f,syncData:I})}catch(A){this.logService.error(A)}}parseSyncData(f){try{const l=JSON.parse(f);if(r(l))return l}catch(l){this.logService.error(l)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(f,l={}){if(l.ref||l.version)throw new Error("Cannot have core properties as additional");const I={ref:f.ref,version:void 0,...l};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(I),-1,1),await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(f)))}};e.AbstractInitializer=c=pe([G(1,k.IUserDataProfilesService),G(2,d.IEnvironmentService),G(3,w.ILogService),G(4,g.IFileService),G(5,u.IStorageService),G(6,E.IUriIdentityService)],c)}),define(ae[114],ce([0,1,6,26,7,3,41,2,27,18,14,113,28,33,79,13,4,70,8,19,20,29,17,39,226,111,23,58]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u,h,E,p,k,n,r,i,t,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function c(F,M){const V=JSON.parse(F.content);if(F.version===1||F.version===2){const x=(await M.getInstalled(0)).filter(q=>q.isBuiltin);for(const q of V)F.version===1&&(q.enabled===!1&&(q.disabled=!0),delete q.enabled),F.version===2&&x.every(X=>!(0,d.areSameExtensions)(X.identifier,q.identifier))&&(q.installed=!0)}return V}function y(F){return JSON.parse(F.content)}e.parseExtensions=y;function f(F,M){return F.sort((V,x)=>!V.identifier.uuid&&x.identifier.uuid?-1:V.identifier.uuid&&!x.identifier.uuid?1:(0,b.compare)(V.identifier.id,x.identifier.id)),M?(0,_.toFormattedString)(F,{}):JSON.stringify(F)}e.stringify=f;let l=e.ExtensionsSynchroniser=class extends r.AbstractSynchroniser{constructor(M,V,x,q,X,ee,Y,Z,j,B,z,ie,re,K,Q,O,m){super({syncResource:"extensions",profile:M},V,q,x,X,ee,Y,ie,re,B,z,Q),this.extensionManagementService=Z,this.ignoredExtensionsManagementService=j,this.instantiationService=m,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(I),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,U=>U.some(({local:W})=>!!W)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,U=>!U.error),T.Event.filter(O.onDidChange,U=>U.valueChanges.some(({profile:W,changes:J})=>this.syncResource.profile.id===W.id&&J.some($=>$.key===v.DISABLED_EXTENSIONS_STORAGE_PATH))),K.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(M,V){const x=M.syncData?await c(M.syncData,this.extensionManagementService):null,q=V?.skippedExtensions??[],X=V?.builtinExtensions??null,ee=V?.syncData?await c(V.syncData,this.extensionManagementService):null,{localExtensions:Y,ignoredExtensions:Z}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);x?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:j,remote:B}=(0,i.merge)(Y,x,ee,q,Z,X),z={local:j,remote:B,content:this.getPreviewContent(Y,j.added,j.updated,j.removed),localChange:j.added.length>0||j.removed.length>0||j.updated.length>0?2:0,remoteChange:B!==null?2:0},ie=this.stringify(Y,!1);return[{skippedExtensions:q,builtinExtensions:X,baseResource:this.baseResource,baseContent:ee?this.stringify(ee,!1):ie,localResource:this.localResource,localContent:ie,localExtensions:Y,remoteResource:this.remoteResource,remoteExtensions:x,remoteContent:x?this.stringify(x,!1):null,previewResource:this.previewResource,previewResult:z,localChange:z.localChange,remoteChange:z.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(M){const V=M.syncData?await c(M.syncData,this.extensionManagementService):null,{localExtensions:x,ignoredExtensions:q}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:X}=(0,i.merge)(x,V,V,M.skippedExtensions||[],q,M.builtinExtensions||[]);return X!==null}getPreviewContent(M,V,x,q){const X=[...V,...x],ee=new Set,Y=Z=>{ee.add(Z.id.toLowerCase()),Z.uuid&&ee.add(Z.uuid)};X.forEach(({identifier:Z})=>Y(Z)),q.forEach(Y);for(const Z of M)ee.has(Z.identifier.id.toLowerCase())||Z.identifier.uuid&&ee.has(Z.identifier.uuid)||X.push(Z);return this.stringify(X,!1)}async getMergeResult(M,V){return{...M.previewResult,hasConflicts:!1}}async getAcceptResult(M,V,x,q){if(this.extUri.isEqual(V,this.localResource))return this.acceptLocal(M);if(this.extUri.isEqual(V,this.remoteResource))return this.acceptRemote(M);if(this.extUri.isEqual(V,this.previewResource))return M.previewResult;throw new Error(`Invalid Resource: ${V.toString()}`)}async acceptLocal(M){const V=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),x=this.ignoredExtensionsManagementService.getIgnoredExtensions(V),q=(0,i.merge)(M.localExtensions,null,null,M.skippedExtensions,x,M.builtinExtensions),{local:X,remote:ee}=q;return{content:M.localContent,local:X,remote:ee,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?2:0,remoteChange:ee!==null?2:0}}async acceptRemote(M){const V=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),x=this.ignoredExtensionsManagementService.getIgnoredExtensions(V),q=M.remoteContent?JSON.parse(M.remoteContent):null;if(q!==null){const X=(0,i.merge)(M.localExtensions,q,M.localExtensions,[],x,M.builtinExtensions),{local:ee,remote:Y}=X;return{content:M.remoteContent,local:ee,remote:Y,localChange:ee.added.length>0||ee.removed.length>0||ee.updated.length>0?2:0,remoteChange:Y!==null?2:0}}else return{content:M.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(M,V,x,q){let{skippedExtensions:X,builtinExtensions:ee,localExtensions:Y}=x[0][0];const{local:Z,remote:j,localChange:B,remoteChange:z}=x[0][1];if(B===0&&z===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),B!==0&&(await this.backupLocal(JSON.stringify(Y)),X=await this.localExtensionsProvider.updateLocalExtensions(Z.added,Z.removed,Z.updated,X,this.syncResource.profile)),j){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const ie=JSON.stringify(j.all);M=await this.updateRemoteUserData(ie,q?null:M.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${j.added.length?` Added: ${JSON.stringify(j.added.map(re=>re.identifier.id))}.`:""}${j.updated.length?` Updated: ${JSON.stringify(j.updated.map(re=>re.identifier.id))}.`:""}${j.removed.length?` Removed: ${JSON.stringify(j.removed.map(re=>re.identifier.id))}.`:""}`)}V?.ref!==M.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),ee=this.computeBuiltinExtensions(Y,ee),await this.updateLastSyncUserData(M,{skippedExtensions:X,builtinExtensions:ee}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${X.length?` Skipped: ${JSON.stringify(X.map(ie=>ie.identifier.id))}.`:""}`))}computeBuiltinExtensions(M,V){const x=new Set,q=[];for(const X of M)x.add(X.identifier.id.toLowerCase()),X.installed||q.push(X.identifier);if(V)for(const X of V)x.has(X.id.toLowerCase())||q.push(X);return q}async resolveContent(M){if(this.extUri.isEqual(this.remoteResource,M)||this.extUri.isEqual(this.baseResource,M)||this.extUri.isEqual(this.localResource,M)||this.extUri.isEqual(this.acceptedResource,M)){const V=await this.resolvePreviewContent(M);return V&&this.stringify(JSON.parse(V),!0)}return null}stringify(M,V){return f(M,V)}async hasLocalData(){try{const{localExtensions:M}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(M.some(V=>V.installed||V.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=l=pe([G(2,P.IEnvironmentService),G(3,w.IFileService),G(4,E.IStorageService),G(5,s.IUserDataSyncStoreService),G(6,s.IUserDataSyncBackupStoreService),G(7,v.IExtensionManagementService),G(8,t.IIgnoredExtensionsManagementService),G(9,s.IUserDataSyncLogService),G(10,S.IConfigurationService),G(11,s.IUserDataSyncEnablementService),G(12,p.ITelemetryService),G(13,g.IExtensionStorageService),G(14,k.IUriIdentityService),G(15,o.IUserDataProfileStorageService),G(16,a.IInstantiationService)],l);let I=e.LocalExtensionsProvider=class{constructor(M,V,x,q,X,ee){this.extensionManagementService=M,this.userDataProfileStorageService=V,this.extensionGalleryService=x,this.ignoredExtensionsManagementService=q,this.instantiationService=X,this.logService=ee}async getLocalExtensions(M){const V=await this.extensionManagementService.getInstalled(void 0,M.extensionsResource),x=this.ignoredExtensionsManagementService.getIgnoredExtensions(V);return{localExtensions:await this.withProfileScopedServices(M,async(X,ee)=>{const Y=X.getDisabledExtensions();return V.map(Z=>{const{identifier:j,isBuiltin:B,manifest:z,preRelease:ie,pinned:re}=Z,K={identifier:j,preRelease:ie,version:z.version,pinned:!!re};Y.some(Q=>(0,d.areSameExtensions)(Q,j))&&(K.disabled=!0),B||(K.installed=!0);try{const Q=ee.getKeysForSync({id:j.id,version:z.version});if(Q){const O=ee.getExtensionState(Z,!0)||{};K.state=Object.keys(O).reduce((m,U)=>(Q.includes(U)&&(m[U]=O[U]),m),{})}}catch(Q){this.logService.info(`${(0,r.getSyncResourceLogLabel)("extensions",M)}: Error while parsing extension state`,(0,L.getErrorMessage)(Q))}return K})}),ignoredExtensions:x}}async updateLocalExtensions(M,V,x,q,X){const ee=(0,r.getSyncResourceLogLabel)("extensions",X),Y=[],Z=new Map,j=[],B=[],z=await this.extensionManagementService.getInstalled(void 0,X.extensionsResource);if((M.length||x.length)&&await this.withProfileScopedServices(X,async(K,Q)=>{await R.Promises.settled([...M,...x].map(async O=>{const m=z.find(J=>(0,d.areSameExtensions)(J.identifier,O.identifier));if(m&&m.isBuiltin){O.state&&m.manifest.version===O.version&&this.updateExtensionState(O.state,m,m.manifest.version,Q),K.getDisabledExtensions().some($=>(0,d.areSameExtensions)($,O.identifier))!==!!O.disabled&&(O.disabled?(this.logService.trace(`${ee}: Disabling extension...`,O.identifier.id),await K.disableExtension(O.identifier),this.logService.info(`${ee}: Disabled extension`,O.identifier.id)):(this.logService.trace(`${ee}: Enabling extension...`,O.identifier.id),await K.enableExtension(O.identifier),this.logService.info(`${ee}: Enabled extension`,O.identifier.id))),j.push(O.identifier);return}const U=O.pinned?O.version:void 0,W=(await this.extensionGalleryService.getExtensions([{...O.identifier,version:U,preRelease:U?void 0:O.preRelease}],N.CancellationToken.None))[0];if(O.state&&(m?m.manifest.version===O.version:W)&&this.updateExtensionState(O.state,m||W,m?.manifest.version,Q),W)try{K.getDisabledExtensions().some($=>(0,d.areSameExtensions)($,O.identifier))!==!!O.disabled&&(O.disabled?(this.logService.trace(`${ee}: Disabling extension...`,O.identifier.id,W.version),await K.disableExtension(W.identifier),this.logService.info(`${ee}: Disabled extension`,O.identifier.id,W.version)):(this.logService.trace(`${ee}: Enabling extension...`,O.identifier.id,W.version),await K.enableExtension(W.identifier),this.logService.info(`${ee}: Enabled extension`,O.identifier.id,W.version))),(!m||m.preRelease!==O.preRelease||m.pinned!==O.pinned||U&&m.manifest.version!==U)&&(await this.extensionManagementService.canInstall(W)?(Y.push({extension:W,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:O.pinned&&!!O.version,installPreReleaseVersion:O.preRelease,profileLocation:X.extensionsResource,context:{[v.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[v.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}}),Z.set(W.identifier.id.toLowerCase(),O)):(this.logService.info(`${ee}: Skipped synchronizing extension because it cannot be installed.`,W.displayName||W.identifier.id),B.push(O)))}catch(J){B.push(O),this.logService.error(J),this.logService.info(`${ee}: Skipped synchronizing extension`,W.displayName||W.identifier.id)}else B.push(O),this.logService.info(`${ee}: Skipped synchronizing extension because the extension is not found.`,O.identifier.id)}))}),V.length){const K=z.filter(({identifier:Q,isBuiltin:O})=>!O&&V.some(m=>(0,d.areSameExtensions)(Q,m)));await R.Promises.settled(K.map(async Q=>{this.logService.trace(`${ee}: Uninstalling local extension...`,Q.identifier.id),await this.extensionManagementService.uninstall(Q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:X.extensionsResource}),this.logService.info(`${ee}: Uninstalled local extension.`,Q.identifier.id),j.push(Q.identifier)}))}const ie=await this.extensionManagementService.installGalleryExtensions(Y);for(const{identifier:K,local:Q,error:O,source:m}of ie){const U=m;if(Q)this.logService.info(`${ee}: Installed extension.`,K.id,U.version),j.push(K);else{const W=Z.get(K.id.toLowerCase());W&&(B.push(W),this.logService.info(`${ee}: Skipped synchronizing extension`,U.displayName||U.identifier.id)),O instanceof v.ExtensionManagementError&&[v.ExtensionManagementErrorCode.Incompatible,v.ExtensionManagementErrorCode.IncompatiblePreRelease,v.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(O.code)?this.logService.info(`${ee}: Skipped synchronizing extension because the compatible extension is not found.`,U.displayName||U.identifier.id):O&&this.logService.error(O)}}const re=[];for(const K of q)j.some(Q=>(0,d.areSameExtensions)(Q,K.identifier))||re.push(K);for(const K of B)re.some(Q=>(0,d.areSameExtensions)(Q.identifier,K.identifier))||re.push(K);return re}updateExtensionState(M,V,x,q){const X=q.getExtensionState(V,!0)||{},ee=x?q.getKeysForSync({id:V.identifier.id,version:x}):void 0;ee?ee.forEach(Y=>{X[Y]=M[Y]}):Object.keys(M).forEach(Y=>X[Y]=M[Y]),q.setExtensionState(V,X,!0)}async withProfileScopedServices(M,V){return this.userDataProfileStorageService.withProfileScopedStorageService(M,async x=>{const q=new D.DisposableStore,X=this.instantiationService.createChild(new u.ServiceCollection([E.IStorageService,x])),ee=q.add(X.createInstance(C.GlobalExtensionEnablementService)),Y=q.add(X.createInstance(g.ExtensionStorageService));try{return await V(ee,Y)}finally{q.dispose()}})}};e.LocalExtensionsProvider=I=pe([G(0,v.IExtensionManagementService),G(1,o.IUserDataProfileStorageService),G(2,v.IExtensionGalleryService),G(3,t.IIgnoredExtensionsManagementService),G(4,a.IInstantiationService),G(5,s.IUserDataSyncLogService)],I);let A=e.AbstractExtensionsInitializer=class extends r.AbstractInitializer{constructor(M,V,x,q,X,ee,Y,Z){super("extensions",q,X,ee,x,Y,Z),this.extensionManagementService=M,this.ignoredExtensionsManagementService=V}async parseExtensions(M){return M.syncData?await c(M.syncData,this.extensionManagementService):null}generatePreview(M,V){const x=[],q=[],X=[];for(const ee of M){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(ee.identifier.id))continue;const Y=V.find(Z=>(0,d.areSameExtensions)(Z.identifier,ee.identifier));Y?(x.push(Y),ee.disabled&&X.push(ee.identifier)):ee.installed&&(q.push({...ee.identifier,preRelease:!!ee.preRelease}),ee.disabled&&X.push(ee.identifier))}return{installedExtensions:x,newExtensions:q,disabledExtensions:X,remoteExtensions:M}}};e.AbstractExtensionsInitializer=A=pe([G(0,v.IExtensionManagementService),G(1,t.IIgnoredExtensionsManagementService),G(2,w.IFileService),G(3,n.IUserDataProfilesService),G(4,P.IEnvironmentService),G(5,h.ILogService),G(6,E.IStorageService),G(7,k.IUriIdentityService)],A)}),define(ae[115],ce([0,1,16,7,3,34,41,5,32,18,14,13,8,44,19,20,29,39,57,230,23,17,58,4]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u,h,E,p,k,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const i="globalState.argv.",t=["locale"];function s(I,A){const F=I.storage?Object.keys(I.storage).sort():[],M={};return F.forEach(V=>M[V]=I.storage[V]),I.storage=M,A?(0,_.toFormattedString)(I,{}):JSON.stringify(I)}e.stringify=s;const o=1;let c=e.GlobalStateSynchroniser=class extends u.AbstractSynchroniser{constructor(A,F,M,V,x,q,X,ee,Y,Z,j,B,z,ie){super({syncResource:"globalState",profile:A},F,V,ee,B,x,q,Y,Z,X,j,z),this.userDataProfileStorageService=M,this.version=o,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=ie.createInstance(y),this._register(V.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(V.onDidFilesChange,re=>re.contains(this.environmentService.argvResource)),L.Event.filter(M.onDidChange,re=>!!(re.targetChanges.some(K=>this.syncResource.profile.id===K.id)||re.valueChanges.some(({profile:K,changes:Q})=>this.syncResource.profile.id===K.id&&Q.some(O=>O.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(A,F,M){const V=A.syncData?JSON.parse(A.syncData.content):null;F=F===null&&M?A:F;const x=F&&F.syncData?JSON.parse(F.syncData.content):null,q=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);V?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const X=await this.getStorageKeys(x),{local:ee,remote:Y}=(0,E.merge)(q.storage,V?V.storage:null,x?x.storage:null,X,this.logService),Z={content:null,local:ee,remote:Y,localChange:Object.keys(ee.added).length>0||Object.keys(ee.updated).length>0||ee.removed.length>0?2:0,remoteChange:Y.all!==null?2:0},j=s(q,!1);return[{baseResource:this.baseResource,baseContent:x?s(x,!1):j,localResource:this.localResource,localContent:j,localUserData:q,remoteResource:this.remoteResource,remoteContent:V?s(V,!1):null,previewResource:this.previewResource,previewResult:Z,localChange:Z.localChange,remoteChange:Z.remoteChange,acceptedResource:this.acceptedResource,storageKeys:X}]}async hasRemoteChanged(A){const F=A.syncData?JSON.parse(A.syncData.content):null;if(F===null)return!0;const M=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),V=await this.getStorageKeys(F),{remote:x}=(0,E.merge)(M.storage,F.storage,F.storage,V,this.logService);return x.all!==null}async getMergeResult(A,F){return{...A.previewResult,hasConflicts:!1}}async getAcceptResult(A,F,M,V){if(this.extUri.isEqual(F,this.localResource))return this.acceptLocal(A);if(this.extUri.isEqual(F,this.remoteResource))return this.acceptRemote(A);if(this.extUri.isEqual(F,this.previewResource))return A.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async acceptLocal(A){return{content:A.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(A.localUserData.storage),removed:[],updated:[],all:A.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(A){if(A.remoteContent!==null){const F=JSON.parse(A.remoteContent),{local:M,remote:V}=(0,E.merge)(A.localUserData.storage,F.storage,null,A.storageKeys,this.logService);return{content:A.remoteContent,local:M,remote:V,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:V!==null?2:0}}else return{content:A.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(A,F,M,V){const{localUserData:x}=M[0][0],{local:q,remote:X,localChange:ee,remoteChange:Y}=M[0][1];if(ee===0&&Y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),ee!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(x)),await this.localGlobalStateProvider.writeLocalGlobalState(q,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),Y!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const Z=JSON.stringify({storage:X.all});A=await this.updateRemoteUserData(Z,V?null:A.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${X.added.length?` Added: ${X.added}.`:""}${X.updated.length?` Updated: ${X.updated}.`:""}${X.removed.length?` Removed: ${X.removed}.`:""}`)}F?.ref!==A.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(A),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(A){if(this.extUri.isEqual(this.remoteResource,A)||this.extUri.isEqual(this.baseResource,A)||this.extUri.isEqual(this.localResource,A)||this.extUri.isEqual(this.acceptedResource,A)){const F=await this.resolvePreviewContent(A);return F&&s(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:A}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(A).length>1||A[`${i}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(A){const F=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),M=[],V=[];for(const[X,ee]of F)ee.target===0?M.push(X):ee.target===1&&V.push(X);const x=[...M,...V],q=A?.storage?Object.keys(A.storage).filter(X=>!X.startsWith(i)&&!x.includes(X)&&F.get(X)!==void 0):[];if(!D.isWeb){const X=[...p.ALL_SYNC_RESOURCES.map(ee=>(0,p.getEnablementKey)(ee)),p.SYNC_SERVICE_URL_TYPE];q.push(...X),V.push(...X)}return{user:M,machine:V,unregistered:q}}};e.GlobalStateSynchroniser=c=pe([G(2,n.IUserDataProfileStorageService),G(3,C.IFileService),G(4,p.IUserDataSyncStoreService),G(5,p.IUserDataSyncBackupStoreService),G(6,p.IUserDataSyncLogService),G(7,P.IEnvironmentService),G(8,p.IUserDataSyncEnablementService),G(9,w.ITelemetryService),G(10,S.IConfigurationService),G(11,g.IStorageService),G(12,a.IUriIdentityService),G(13,r.IInstantiationService)],c);let y=e.LocalGlobalStateProvider=class{constructor(A,F,M,V){this.fileService=A,this.environmentService=F,this.userDataProfileStorageService=M,this.logService=V}async getLocalGlobalState(A){const F={};if(A.isDefault){const V=await this.getLocalArgvContent(),x=(0,T.parse)(V);for(const q of t)x[q]!==void 0&&(F[`${i}${q}`]={version:1,value:x[q]})}const M=await this.userDataProfileStorageService.readStorageData(A);for(const[V,x]of M)x.value&&x.target===0&&(F[V]={version:1,value:x.value});return{storage:F}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const A=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),A.value.toString()}catch(A){this.logService.debug((0,N.getErrorMessage)(A))}return"{}"}async writeLocalGlobalState({added:A,removed:F,updated:M},V){const x=(0,u.getSyncResourceLogLabel)("globalState",V),q={},X=new Map,ee=await this.userDataProfileStorageService.readStorageData(V),Y=(Z,j)=>{for(const B of Z){if(B.startsWith(i)){q[B.substring(i.length)]=j?j[B].value:void 0;continue}if(j){const z=j[B];z.value!==ee.get(B)?.value&&X.set(B,z.value)}else ee.get(B)!==void 0&&X.set(B,void 0)}};if(Y(Object.keys(A),A),Y(Object.keys(M),M),Y(F),Object.keys(q).length){this.logService.trace(`${x}: Updating locale...`);const Z=await this.getLocalArgvContent();let j=Z;for(const B of Object.keys(q))j=(0,h.edit)(j,[B],q[B],{});Z!==j&&(this.logService.trace(`${x}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(j)),this.logService.info(`${x}: Updated locale.`)),this.logService.info(`${x}: Updated locale`)}X.size&&(this.logService.trace(`${x}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData(V,X,0),this.logService.info(`${x}: Updated global state`,[...X.keys()]))}};e.LocalGlobalStateProvider=y=pe([G(0,C.IFileService),G(1,P.IEnvironmentService),G(2,n.IUserDataProfileStorageService),G(3,p.IUserDataSyncLogService)],y);let f=e.GlobalStateInitializer=class extends u.AbstractInitializer{constructor(A,F,M,V,x,q){super("globalState",M,V,x,F,A,q)}async doInitialize(A){const F=A.syncData?JSON.parse(A.syncData.content):null;if(!F){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const M={},V={};for(const x of Object.keys(F.storage))x.startsWith(i)?M[x.substring(i.length)]=F.storage[x].value:this.storageService.get(x,0)===void 0&&(V[x]=F.storage[x].value);if(Object.keys(M).length){let x="{}";try{x=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const q of Object.keys(M))x=(0,h.edit)(x,[q],M[q],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(x))}if(Object.keys(V).length){const x=[];for(const q of Object.keys(V))x.push({key:q,value:V[q],scope:0,target:0});this.storageService.storeAll(x,!0)}}};e.GlobalStateInitializer=f=pe([G(0,g.IStorageService),G(1,C.IFileService),G(2,k.IUserDataProfilesService),G(3,P.IEnvironmentService),G(4,p.IUserDataSyncLogService),G(5,a.IUriIdentityService)],f);let l=e.UserDataSyncStoreTypeSynchronizer=class{constructor(A,F,M,V,x){this.userDataSyncStoreClient=A,this.storageService=F,this.environmentService=M,this.fileService=V,this.logService=x}getSyncStoreType(A){return this.parseGlobalState(A)?.storage[p.SYNC_SERVICE_URL_TYPE]?.value}async sync(A){const F=(0,p.createSyncHeaders)((0,b.generateUuid)());try{return await this.doSync(A,F)}catch(M){if(M instanceof p.UserDataSyncError)switch(M.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(A,F)}throw M}}async doSync(A,F){const M=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,F),V=this.parseGlobalState(M)||{storage:{}};V.storage[p.SYNC_SERVICE_URL_TYPE]={value:A,version:o};const x=await(0,d.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),q={version:o,machineId:x,content:s(V,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(q),M.ref,void 0,F)}parseGlobalState({content:A}){if(!A)return null;const F=JSON.parse(A);if((0,u.isSyncData)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=l=pe([G(1,g.IStorageService),G(2,P.IEnvironmentService),G(3,C.IFileService),G(4,v.ILogService)],l)}),define(ae[116],ce([0,1,21,16,3,34,5,10,164,18,14,13,19,20,29,17,39,227,23]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function E(n,r,i){try{const t=JSON.parse(n);if(!r)return(0,D.isUndefined)(t.all)?null:t.all;switch(_.OS){case 2:return(0,D.isUndefined)(t.mac)?null:t.mac;case 3:return(0,D.isUndefined)(t.linux)?null:t.linux;case 1:return(0,D.isUndefined)(t.windows)?null:t.windows}}catch(t){return i.error(t),null}}e.getKeybindingsContentFromSyncContent=E;let p=e.KeybindingsSynchroniser=class extends a.AbstractJsonFileSynchroniser{constructor(r,i,t,s,o,c,y,f,l,I,A,F,M){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},i,f,l,I,t,s,y,F,o,A,c,M),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.filter(c.onDidChangeConfiguration,V=>V.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,i,t,s){const o=r.syncData?E(r.syncData.content,s.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;i=i===null&&t?r:i;const c=i?this.getKeybindingsContentFromLastSyncUserData(i):null,y=await this.getLocalFileContent(),f=await this.getFormattingOptions();let l=null,I=!1,A=!1,F=!1;if(o){let x=y?y.value.toString():"[]";if(x=x||"[]",this.hasErrors(x,!0))throw new h.UserDataSyncError((0,b.localize)(0,null),"LocalInvalidContent",this.resource);if(!c||c!==x||c!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const q=await(0,u.merge)(x,o,c,f,this.userDataSyncUtilService);q.hasChanges&&(l=q.mergeContent,F=q.hasConflicts,I=F||q.mergeContent!==x,A=F||q.mergeContent!==o)}}else y&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),l=y.value.toString(),A=!0);const M={content:F?c:l,localChange:I?y?2:1:0,remoteChange:A?2:0,hasConflicts:F},V=y?y.value.toString():null;return[{fileContent:y,baseResource:this.baseResource,baseContent:c,localResource:this.localResource,localContent:V,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const i=this.getKeybindingsContentFromLastSyncUserData(r);if(i===null)return!0;const t=await this.getLocalFileContent(),s=t?t.value.toString():"",o=await this.getFormattingOptions(),c=await(0,u.merge)(s||"[]",i,i,o,this.userDataSyncUtilService);return c.hasConflicts||c.mergeContent!==i}async getMergeResult(r,i){return r.previewResult}async getAcceptResult(r,i,t,s){if(this.extUri.isEqual(i,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return t===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:t,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(r,i,t,s){const{fileContent:o}=t[0][0];let{content:c,localChange:y,remoteChange:f}=t[0][1];if(y===0&&f===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.hasErrors(c,!0)))throw new h.UserDataSyncError((0,b.localize)(1,null),"LocalInvalidContent",this.resource);if(y!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(c||"[]",o,s),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),f!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const l=this.toSyncContent(c||"[]",r.syncData?.content);r=await this.updateRemoteUserData(l,s?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}i?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const i=(0,T.parse)(r.value.toString());if((0,R.isNonEmptyArray)(i))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.baseResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r)?this.resolvePreviewContent(r):null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:E(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,i){let t={};try{t=JSON.parse(i||"{}")}catch(s){this.logService.error(s)}switch(this.syncKeybindingsPerPlatform()?delete t.all:t.all=r,_.OS){case 2:t.mac=r;break;case 3:t.linux=r;break;case 1:t.windows=r;break}return JSON.stringify(t)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(h.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=p=pe([G(2,h.IUserDataSyncStoreService),G(3,h.IUserDataSyncBackupStoreService),G(4,h.IUserDataSyncLogService),G(5,S.IConfigurationService),G(6,h.IUserDataSyncEnablementService),G(7,C.IFileService),G(8,P.IEnvironmentService),G(9,v.IStorageService),G(10,h.IUserDataSyncUtilService),G(11,d.ITelemetryService),G(12,g.IUriIdentityService)],p);let k=e.KeybindingsInitializer=class extends a.AbstractInitializer{constructor(r,i,t,s,o,c){super("keybindings",i,t,s,r,o,c)}async doInitialize(r){const i=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!i){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,N.VSBuffer.fromString(i)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),i=(0,T.parse)(r.value.toString());return!(0,R.isNonEmptyArray)(i)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return E(r,!0,this.logService)}catch(i){return this.logService.error(i),null}}};e.KeybindingsInitializer=k=pe([G(0,C.IFileService),G(1,w.IUserDataProfilesService),G(2,P.IEnvironmentService),G(3,h.IUserDataSyncLogService),G(4,v.IStorageService),G(5,g.IUriIdentityService)],k)}),define(ae[117],ce([0,1,16,3,165,18,73,14,28,13,19,20,29,17,39,57,231,23]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function h(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function E(n){const r=JSON.parse(n);return h(r)?r:{settings:n}}e.parseSettingsSyncContent=E;let p=e.SettingsSynchroniser=class extends g.AbstractJsonFileSynchroniser{constructor(r,i,t,s,o,c,y,f,l,I,A,F,M,V){super(r.settingsResource,{syncResource:"settings",profile:r},i,t,s,o,c,y,A,F,f,l,I,V),this.extensionManagementService=M,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const i=await this.getLastSyncUserData(),t=await this.getLatestRemoteUserData(r,i),s=this.getSettingsSyncContent(t),o=new _.ConfigurationModelParser(u.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&o.parse(s.settings),o.configurationModel.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,i,t){const s=await this.getLocalFileContent(),o=await this.getFormattingOptions(),c=this.getSettingsSyncContent(r);i=i===null&&t?r:i;const y=i?this.getSettingsSyncContent(i):null,f=await this.getIgnoredSettings();let l=null,I=!1,A=!1,F=!1;if(c){let q=s?s.value.toString().trim():"{}";q=q||"{}",this.validateContent(q),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const X=(0,a.merge)(q,c.settings,y?y.settings:null,f,[],o);l=X.localContent||X.remoteContent,I=X.localContent!==null,A=X.remoteContent!==null,F=X.hasConflicts}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),l=s.value.toString().trim()||"{}",this.validateContent(l),A=!0);const M=s?s.value.toString():null,V=y?.settings??null,x={content:F?V:l,localChange:I?2:0,remoteChange:A?2:0,hasConflicts:F};return[{fileContent:s,baseResource:this.baseResource,baseContent:V,localResource:this.localResource,localContent:M,localChange:x.localChange,remoteResource:this.remoteResource,remoteContent:c?c.settings:null,remoteChange:x.remoteChange,previewResource:this.previewResource,previewResult:x,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const i=this.getSettingsSyncContent(r);if(i===null)return!0;const t=await this.getLocalFileContent(),s=t?t.value.toString().trim():"",o=await this.getIgnoredSettings(),c=await this.getFormattingOptions();return(0,a.merge)(s||"{}",i.settings,i.settings,o,[],c).remoteContent!==null}async getMergeResult(r,i){const t=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,a.updateIgnoredSettings)(r.previewResult.content,"{}",s,t):null}}async getAcceptResult(r,i,t,s){const o=await this.getFormattingOptions(),c=await this.getIgnoredSettings();if(this.extUri.isEqual(i,this.localResource))return{content:r.fileContent?(0,a.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",c,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:r.remoteContent!==null?(0,a.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",c,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return t===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:t!==null?(0,a.updateIgnoredSettings)(t,r.fileContent?r.fileContent.value.toString():"{}",c,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(r,i,t,s){const{fileContent:o}=t[0][0];let{content:c,localChange:y,remoteChange:f}=t[0][1];if(y===0&&f===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.validateContent(c),y!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(c,o,s),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),f!==0){const l=await this.getFormattingOptions(),I=this.getSettingsSyncContent(r),A=await this.getIgnoredSettings(c);c=(0,a.updateIgnoredSettings)(c,I?I.settings:"{}",A,l),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(c)),s?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}i?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const i=await this.getFormattingOptions(),t=(0,w.edit)(r.value.toString(),[u.CONFIGURATION_SYNC_STORE_KEY],void 0,i);return!(0,a.isEmpty)(t)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r)||this.extUri.isEqual(this.baseResource,r)?this.resolvePreviewContent(r):null}async resolvePreviewContent(r){let i=await super.resolvePreviewContent(r);if(i){const t=await this.getFormattingOptions(),s=await this.getIgnoredSettings();i=(0,a.updateIgnoredSettings)(i,"{}",s,t)}return i}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return E(r)}catch(i){this.logService.error(i)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const t=N.Event.any(N.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:o})=>!!o)),N.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{t.dispose(),this._defaultIgnoredSettings=void 0})}const i=await this._defaultIgnoredSettings;return(0,a.getIgnoredSettings)(i,this.configurationService,r)}validateContent(r){if(this.hasErrors(r,!1))throw new u.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};e.SettingsSynchroniser=p=pe([G(2,S.IFileService),G(3,D.IEnvironmentService),G(4,P.IStorageService),G(5,u.IUserDataSyncStoreService),G(6,u.IUserDataSyncBackupStoreService),G(7,u.IUserDataSyncLogService),G(8,u.IUserDataSyncUtilService),G(9,T.IConfigurationService),G(10,u.IUserDataSyncEnablementService),G(11,C.ITelemetryService),G(12,b.IExtensionManagementService),G(13,v.IUriIdentityService)],p);let k=e.SettingsInitializer=class extends g.AbstractInitializer{constructor(r,i,t,s,o,c){super("settings",i,t,s,r,o,c)}async doInitialize(r){const i=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!i){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,R.VSBuffer.fromString(i.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,a.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return E(r)}catch(i){this.logService.error(i)}return null}};e.SettingsInitializer=k=pe([G(0,S.IFileService),G(1,d.IUserDataProfilesService),G(2,D.IEnvironmentService),G(3,u.IUserDataSyncLogService),G(4,P.IStorageService),G(5,v.IUriIdentityService)],k)}),define(ae[118],ce([0,1,16,3,31,18,14,13,19,20,29,17,39,228,23]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function w(h){return JSON.parse(h.content)}e.parseSnippets=w;let a=e.SnippetsSynchroniser=class extends v.AbstractSynchroniser{constructor(E,p,k,n,r,i,t,s,o,c,y,f){super({syncResource:"snippets",profile:E},p,n,k,r,i,t,c,y,s,o,f),this.version=1,this.snippetsFolder=E.snippetsHome,this._register(this.fileService.watch(k.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(N.Event.filter(this.fileService.onDidFilesChange,l=>l.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(E,p,k){const n=await this.getSnippetsFileContents(),r=this.toSnippetsContents(n),i=E.syncData?this.parseSnippets(E.syncData):null;p=p===null&&k?E:p;const t=p&&p.syncData?this.parseSnippets(p.syncData):null;i?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,d.merge)(r,i,t);return this.getResourcePreviews(s,n,i||{},t||{})}async hasRemoteChanged(E){const p=E.syncData?this.parseSnippets(E.syncData):null;if(p===null)return!0;const k=await this.getSnippetsFileContents(),n=this.toSnippetsContents(k),r=(0,d.merge)(n,p,p);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async getMergeResult(E,p){return E.previewResult}async getAcceptResult(E,p,k,n){if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:E.fileContent?E.fileContent.value.toString():null,localChange:0,remoteChange:E.fileContent?E.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:E.remoteContent,localChange:E.remoteContent!==null?E.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder))return k===void 0?{content:E.previewResult.content,localChange:E.previewResult.localChange,remoteChange:E.previewResult.remoteChange}:{content:k,localChange:k===null?E.fileContent!==null?3:0:2,remoteChange:k===null?E.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${p.toString()}`)}async applyResult(E,p,k,n){const r=k.map(([i,t])=>({...i,acceptResult:t}));r.every(({localChange:i,remoteChange:t})=>i===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),r.some(({localChange:i})=>i!==0)&&(await this.updateLocalBackup(r),await this.updateLocalSnippets(r,n)),r.some(({remoteChange:i})=>i!==0)&&(E=await this.updateRemoteSnippets(r,E,n)),p?.ref!==E.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(E),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:i}of r)try{await this.fileService.del(i)}catch{}}getResourcePreviews(E,p,k,n){const r=new Map;for(const i of Object.keys(E.local.added)){const t={content:E.local.added[i],hasConflicts:!1,localChange:1,remoteChange:0};r.set(i,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[i],previewResource:this.extUri.joinPath(this.syncPreviewFolder,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const i of Object.keys(E.local.updated)){const t={content:E.local.updated[i],hasConflicts:!1,localChange:2,remoteChange:0},s=p[i]?p[i].value.toString():null;r.set(i,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[i]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[i],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[i],previewResource:this.extUri.joinPath(this.syncPreviewFolder,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const i of E.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=p[i]?p[i].value.toString():null;r.set(i,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[i]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[i],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const i of Object.keys(E.remote.added)){const t={content:E.remote.added[i],hasConflicts:!1,localChange:0,remoteChange:1},s=p[i]?p[i].value.toString():null;r.set(i,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[i]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[i],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const i of Object.keys(E.remote.updated)){const t={content:E.remote.updated[i],hasConflicts:!1,localChange:0,remoteChange:2},s=p[i]?p[i].value.toString():null;r.set(i,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[i]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[i],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[i],previewResource:this.extUri.joinPath(this.syncPreviewFolder,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const i of E.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(i,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[i]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[i],previewResource:this.extUri.joinPath(this.syncPreviewFolder,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const i of E.conflicts){const t={content:n[i]??null,hasConflicts:!0,localChange:p[i]?2:1,remoteChange:k[i]?2:1},s=p[i]?p[i].value.toString():null;r.set(i,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[i]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[i]||null,localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[i]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const i of Object.keys(p))if(!r.has(i)){const t={content:p[i]?p[i].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=p[i]?p[i].value.toString():null;r.set(i,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[i]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[i]||null,localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[i]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async resolveContent(E){return this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(E):null}async hasLocalData(){try{const E=await this.getSnippetsFileContents();if(Object.keys(E).length)return!0}catch{}return!1}async updateLocalBackup(E){const p={};for(const k of E)k.fileContent&&(p[this.extUri.basename(k.localResource)]=k.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(p)))}async updateLocalSnippets(E,p){for(const{fileContent:k,acceptResult:n,localResource:r,remoteResource:i,localChange:t}of E)if(t!==0){const s=i?this.extUri.basename(i):this.extUri.basename(r),o=this.extUri.joinPath(this.snippetsFolder,s);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(o)),await this.fileService.del(o),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(o))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(o)),await this.fileService.createFile(o,R.VSBuffer.fromString(n.content),{overwrite:p}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(o))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(o)),await this.fileService.writeFile(o,R.VSBuffer.fromString(n.content),p?void 0:k),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(o)))}}async updateRemoteSnippets(E,p,k){const n=p.syncData?this.parseSnippets(p.syncData):{},r=(0,L.deepClone)(n);for(const{acceptResult:i,localResource:t,remoteResource:s,remoteChange:o}of E)if(o!==0){const c=t?this.extUri.basename(t):this.extUri.basename(s);o===3?delete r[c]:r[c]=i.content}return(0,d.areSame)(n,r)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),p=await this.updateRemoteUserData(JSON.stringify(r),k?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),p}parseSnippets(E){return w(E)}toSnippetsContents(E){const p={};for(const k of Object.keys(E))p[k]=E[k].value.toString();return p}async getSnippetsFileContents(){const E={};let p;try{p=await this.fileService.resolve(this.snippetsFolder)}catch(k){if(k instanceof D.FileOperationError&&k.fileOperationResult===1)return E;throw k}for(const k of p.children||[]){const n=k.resource,r=this.extUri.extname(n);if(r===".json"||r===".code-snippets"){const i=this.extUri.relativePath(this.snippetsFolder,n),t=await this.fileService.readFile(n);E[i]=t}}return E}};e.SnippetsSynchroniser=a=pe([G(2,_.IEnvironmentService),G(3,D.IFileService),G(4,b.IStorageService),G(5,g.IUserDataSyncStoreService),G(6,g.IUserDataSyncBackupStoreService),G(7,g.IUserDataSyncLogService),G(8,T.IConfigurationService),G(9,g.IUserDataSyncEnablementService),G(10,S.ITelemetryService),G(11,P.IUriIdentityService)],a);let u=e.SnippetsInitializer=class extends v.AbstractInitializer{constructor(E,p,k,n,r,i){super("snippets",p,k,n,E,r,i)}async doInitialize(E){const p=E.syncData?JSON.parse(E.syncData.content):null;if(!p){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(p)){const r=p[n];if(r){const i=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,n);await this.fileService.createFile(i,R.VSBuffer.fromString(r)),this.logService.info("Created snippet",this.extUri.basename(i))}}await this.updateLastSyncUserData(E)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(E){return E.fileOperationResult===1}}};e.SnippetsInitializer=u=pe([G(0,D.IFileService),G(1,C.IUserDataProfilesService),G(2,_.IEnvironmentService),G(3,g.IUserDataSyncLogService),G(4,b.IStorageService),G(5,P.IUriIdentityService)],u)}),define(ae[119],ce([0,1,16,18,14,13,19,20,29,17,39,23]),function(ne,e,R,N,L,T,_,D,b,S,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function v(a,u){try{return JSON.parse(a).tasks??null}catch(h){return u.error(h),null}}e.getTasksContentFromSyncContent=v;let d=e.TasksSynchroniser=class extends P.AbstractFileSynchroniser{constructor(u,h,E,p,k,n,r,i,t,s,o,c){super(u.tasksResource,{syncResource:"tasks",profile:u},h,i,t,s,E,p,r,o,k,n,c),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(u,h,E,p){const k=u.syncData?v(u.syncData.content,this.logService):null;h=h===null&&E?u:h;const n=h?.syncData?v(h.syncData.content,this.logService):null,r=await this.getLocalFileContent();let i=null,t=!1,s=!1,o=!1;if(u.syncData){const f=r?r.value.toString():null;if(!n||n!==f||n!==k){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const l=w(f,k,n);i=l.content,o=l.hasConflicts,t=l.hasLocalChanged,s=l.hasRemoteChanged}}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),i=r.value.toString(),s=!0);const c={content:o?n:i,localChange:t?r?2:1:0,remoteChange:s?2:0,hasConflicts:o},y=r?r.value.toString():null;return[{fileContent:r,baseResource:this.baseResource,baseContent:n,localResource:this.localResource,localContent:y,localChange:c.localChange,remoteResource:this.remoteResource,remoteContent:k,remoteChange:c.remoteChange,previewResource:this.previewResource,previewResult:c,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const h=u?.syncData?v(u.syncData.content,this.logService):null;if(h===null)return!0;const E=await this.getLocalFileContent(),p=E?E.value.toString():null,k=w(p,h,h);return k.hasLocalChanged||k.hasRemoteChanged}async getMergeResult(u,h){return u.previewResult}async getAcceptResult(u,h,E,p){if(this.extUri.isEqual(h,this.localResource))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(h,this.remoteResource))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(h,this.previewResource))return E===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:E,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${h.toString()}`)}async applyResult(u,h,E,p){const{fileContent:k}=E[0][0],{content:n,localChange:r,remoteChange:i}=E[0][1];if(r===0&&i===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),r!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),k&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(k.value.toString()))),n?await this.updateLocalFileContent(n,k,p):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),i!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const t=JSON.stringify(this.toTasksSyncContent(n));u=await this.updateRemoteUserData(t,p?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}h?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(u){return this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)?this.resolvePreviewContent(u):null}toTasksSyncContent(u){return u?{tasks:u}:{}}};e.TasksSynchroniser=d=pe([G(2,C.IUserDataSyncStoreService),G(3,C.IUserDataSyncBackupStoreService),G(4,C.IUserDataSyncLogService),G(5,N.IConfigurationService),G(6,C.IUserDataSyncEnablementService),G(7,T.IFileService),G(8,L.IEnvironmentService),G(9,_.IStorageService),G(10,D.ITelemetryService),G(11,b.IUriIdentityService)],d);let g=e.TasksInitializer=class extends P.AbstractInitializer{constructor(u,h,E,p,k,n){super("tasks",h,E,p,u,k,n),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(u){const h=u.syncData?v(u.syncData.content,this.logService):null;if(!h){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,R.VSBuffer.fromString(h)),await this.updateLastSyncUserData(u)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};e.TasksInitializer=g=pe([G(0,T.IFileService),G(1,S.IUserDataProfilesService),G(2,L.IEnvironmentService),G(3,C.IUserDataSyncLogService),G(4,_.IStorageService),G(5,b.IUriIdentityService)],g);function w(a,u,h){if(a===null&&u===null&&h===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(a===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const E=h!==a,p=h!==u;return!E&&!p?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:E&&!p?{content:a,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:p&&!E?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:a,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ae[120],ce([0,1,41,18,14,13,19,20,29,17,39,229,23]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let d=e.UserDataProfilesManifestSynchroniser=class extends P.AbstractSynchroniser{constructor(u,h,E,p,k,n,r,i,t,s,o,c,y){super({syncResource:"profiles",profile:u},h,p,k,n,r,i,o,c,t,s,y),this.userDataProfilesService=E,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?w(u.syncData):null}async getRemoteSyncedProfiles(u){const h=await this.getLastSyncUserData(),E=await this.getLatestRemoteUserData(u,h);return E?.syncData?w(E.syncData):null}async generateSyncPreview(u,h,E){if(!this.userDataProfilesService.isEnabled())throw new v.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const p=u.syncData?w(u.syncData):null,k=h?.syncData?w(h.syncData):null,n=this.getLocalUserDataProfiles(),{local:r,remote:i}=(0,C.merge)(n,p,k,[]),t={local:r,remote:i,content:k?this.stringifyRemoteProfiles(k):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:i!==null?2:0},s=g(n,!1);return[{baseResource:this.baseResource,baseContent:k?this.stringifyRemoteProfiles(k):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:p?this.stringifyRemoteProfiles(p):null,remoteProfiles:p,previewResource:this.previewResource,previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const h=u?.syncData?w(u.syncData):null,E=this.getLocalUserDataProfiles(),{remote:p}=(0,C.merge)(E,h,h,[]);return!!p?.added.length||!!p?.removed.length||!!p?.updated.length}async getMergeResult(u,h){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,h,E,p){if(this.extUri.isEqual(h,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(h,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(h,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${h.toString()}`)}async acceptLocal(u){const h=this.getLocalUserDataProfiles(),E=(0,C.merge)(h,null,null,[]),{local:p,remote:k}=E;return{content:u.localContent,local:p,remote:k,localChange:p.added.length>0||p.removed.length>0||p.updated.length>0?2:0,remoteChange:k!==null?2:0}}async acceptRemote(u){const h=u.remoteContent?JSON.parse(u.remoteContent):null,E=[],p=[];for(const k of this.getLocalUserDataProfiles()){const n=h?.find(r=>r.id===k.id);n&&(E.push({id:k.id,name:k.name,collection:n.collection}),p.push(k))}if(h!==null){const k=(0,C.merge)(p,h,E,[]),{local:n,remote:r}=k;return{content:u.remoteContent,local:n,remote:r,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,h,E,p){const{local:k,remote:n,localChange:r,remoteChange:i}=E[0][1];r===0&&i===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const t=E[0][0].remoteProfiles||[];if(t.length+(n?.added.length??0)-(n?.removed.length??0)>20)throw new v.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0){await this.backupLocal(g(this.getLocalUserDataProfiles(),!1));const s=[];for(const o of k.added)s.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${o.name}' profile...`),await this.userDataProfilesService.createProfile(o.id,o.name,{shortName:o.shortName}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${o.name}'.`)})());for(const o of k.removed)s.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${o.name}' profile...`),await this.userDataProfilesService.removeProfile(o),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${o.name}'.`)})());for(const o of k.updated){const c=this.userDataProfilesService.profiles.find(y=>y.id===o.id);c?s.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Updating '${o.name}' profile...`),await this.userDataProfilesService.updateProfile(c,{name:o.name,shortName:o.shortName}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${o.name}'.`)})()):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${o.id}' to update.`)}await Promise.all(s)}if(i!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const s=[],o=t.length+(n?.added.length??0)<=20;if(o)for(const c of n?.added||[]){const y=await this.userDataSyncStoreService.createCollection(this.syncHeaders);s.push(y),t.push({id:c.id,name:c.name,collection:y,shortName:c.shortName})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const c of n?.removed||[])t.splice(t.findIndex(({id:y})=>c.id===y),1);for(const c of n?.updated||[]){const y=t.find(({id:f})=>c.id===f);y&&t.splice(t.indexOf(y),1,{id:c.id,name:c.name,collection:y.collection,shortName:c.shortName})}try{u=await this.updateRemoteProfiles(t,p?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${o&&n?.added.length?` Added: ${JSON.stringify(n.added.map(c=>c.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(c=>c.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(c=>c.name))}.`:""}`)}catch(c){if(s.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const y of s)await this.userDataSyncStoreService.deleteCollection(y,this.syncHeaders)}throw c}for(const c of n?.removed||[])await this.userDataSyncStoreService.deleteCollection(c.collection,this.syncHeaders)}h?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,h){return this.updateRemoteUserData(this.stringifyRemoteProfiles(u),h)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(u){if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)){const h=await this.resolvePreviewContent(u);return h&&(0,R.toFormattedString)(JSON.parse(h),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(u=>!u.isDefault&&!u.isTransient)}stringifyRemoteProfiles(u){return JSON.stringify([...u].sort((h,E)=>h.name.localeCompare(E.name)))}};e.UserDataProfilesManifestSynchroniser=d=pe([G(2,S.IUserDataProfilesService),G(3,T.IFileService),G(4,L.IEnvironmentService),G(5,_.IStorageService),G(6,v.IUserDataSyncStoreService),G(7,v.IUserDataSyncBackupStoreService),G(8,v.IUserDataSyncLogService),G(9,N.IConfigurationService),G(10,v.IUserDataSyncEnablementService),G(11,D.ITelemetryService),G(12,b.IUriIdentityService)],d);function g(a,u){const h=[...a].sort((E,p)=>E.name.localeCompare(p.name)).map(E=>({id:E.id,name:E.name}));return u?(0,R.toFormattedString)(h,{}):JSON.stringify(h)}e.stringifyLocalProfiles=g;function w(a){return JSON.parse(a.content)}e.parseUserDataProfilesManifest=w}),define(ae[246],ce([0,1,6,16,63,2,22,18,14,13,17,23]),function(ne,e,R,N,L,T,_,D,b,S,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let v=e.UserDataSyncBackupStoreService=class extends T.Disposable{constructor(g,w,a,u,h){super(),this.environmentService=g,this.fileService=w,this.configurationService=a,this.logService=u,this.userDataProfilesService=h,this.cleanUp()}async cleanUp(){for(const w of this.userDataProfilesService.profiles)for(const a of C.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(w,a))}catch(u){this.logService.error(u)}let g;try{g=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(w){(0,S.toFileOperationResult)(w)!==1&&this.logService.error(w);return}if(g.children){for(const w of g.children)if(w.isDirectory&&!this.userDataProfilesService.profiles.some(a=>a.id===w.name))try{this.logService.info("Deleting non existing profile from backup",w.resource.path),await this.fileService.del(w.resource,{recursive:!0})}catch(a){this.logService.error(a)}}}async getAllRefs(g,w){const a=this.getResourceBackupHome(g,w);try{const u=await this.fileService.resolve(a);if(u.children)return u.children.filter(E=>E.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(E.name)).sort().reverse().map(E=>({ref:E.name,created:this.getCreationTime(E)}))}catch(u){if((0,S.toFileOperationResult)(u)!==1)throw u}return[]}async resolveContent(g,w,a){const u=this.getResourceBackupHome(g,w),h=(0,_.joinPath)(u,a);try{return(await this.fileService.readFile(h)).value.toString()}catch(E){return this.logService.error(E),null}}async backup(g,w,a){const u=this.getResourceBackupHome(g,w),h=(0,_.joinPath)(u,`${(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(h,N.VSBuffer.fromString(a))}catch(E){this.logService.error(E)}try{this.cleanUpBackup(u)}catch{}}getResourceBackupHome(g,w){return(0,_.joinPath)(this.environmentService.userDataSyncHome,...g.isDefault?[w]:[g.id,w])}async cleanUpBackup(g){try{try{if(!await this.fileService.exists(g))return}catch{return}const w=await this.fileService.resolve(g);if(w.children){const a=w.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort(),u=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let h=a.filter(p=>Date.now()-this.getCreationTime(p)>u);const E=a.length-h.length;E<10&&(h=h.slice(10-E)),await R.Promises.settled(h.map(async p=>{this.logService.info("Deleting from backup",p.resource.path),await this.fileService.del(p.resource)}))}}catch(w){this.logService.error(w)}}getCreationTime(g){return g.ctime||new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};e.UserDataSyncBackupStoreService=v=pe([G(0,b.IEnvironmentService),G(1,S.IFileService),G(2,D.IConfigurationService),G(3,C.IUserDataSyncLogService),G(4,P.IUserDataProfilesService)],v)}),define(ae[247],ce([0,1,3,2,5,14,19,20,23]),function(ne,e,R,N,L,T,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const S="sync.enable";let P=e.UserDataSyncEnablementService=class extends N.Disposable{constructor(v,d,g,w){super(),this.storageService=v,this.telemetryService=d,this.environmentService=g,this.userDataSyncStoreManagementService=w,this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(v.onDidChangeValue(a=>this.onDidStorageChange(a)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(S,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(v){v&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(S,{enabled:v}),this.storageService.store(S,v,-1,1))}isResourceEnabled(v){return this.storageService.getBoolean((0,b.getEnablementKey)(v),-1,!0)}setResourceEnablement(v,d){if(this.isResourceEnabled(v)!==d){const g=(0,b.getEnablementKey)(v);this.storeResourceEnablement(g,d)}}getResourceSyncStateVersion(v){}storeResourceEnablement(v,d){this.storageService.store(v,d,-1,L.isWeb?0:1)}onDidStorageChange(v){if(v.scope!==-1)return;if(S===v.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const d=b.ALL_SYNC_RESOURCES.filter(g=>(0,b.getEnablementKey)(g)===v.key)[0];if(d){this._onDidChangeResourceEnablement.fire([d,this.isResourceEnabled(d)]);return}}};e.UserDataSyncEnablementService=P=pe([G(0,_.IStorageService),G(1,D.ITelemetryService),G(2,T.IEnvironmentService),G(3,b.IUserDataSyncStoreManagementService)],P)}),define(ae[80],ce([0,1,3,2,5,27,169,14,13,4,24,44,19,23]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const g="sync.currentMachineName",w="Safari",a="Chrome",u="Edge",h="Firefox",E="Android";function p(r){switch(r){case w:case a:case u:case h:case E:case(0,L.PlatformToString)(0):return!0}return!1}e.isWebPlatform=p;function k(){return L.isSafari?w:L.isChrome?a:L.isEdge?u:L.isFirefox?h:L.isAndroid?E:(0,L.PlatformToString)(L.isWeb?0:L.platform)}let n=e.UserDataSyncMachinesService=class it extends N.Disposable{constructor(i,t,s,o,c,y){super(),this.storageService=s,this.userDataSyncStoreService=o,this.logService=c,this.productService=y,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(i,t,s)}async getMachines(i){const t=await this.currentMachineIdPromise;return(await this.readMachinesData(i)).machines.map(o=>({...o,isCurrent:o.id===t}))}async addCurrentMachine(i){const t=await this.currentMachineIdPromise,s=await this.readMachinesData(i);s.machines.some(({id:o})=>o===t)||(s.machines.push({id:t,name:this.computeCurrentMachineName(s.machines),platform:k()}),await this.writeMachinesData(s))}async removeCurrentMachine(i){const t=await this.currentMachineIdPromise,s=await this.readMachinesData(i),o=s.machines.filter(({id:c})=>c!==t);o.length!==s.machines.length&&(s.machines=o,await this.writeMachinesData(s))}async renameMachine(i,t,s){const o=await this.readMachinesData(s),c=o.machines.find(({id:y})=>y===i);if(c){c.name=t,await this.writeMachinesData(o);const y=await this.currentMachineIdPromise;i===y&&this.storageService.store(g,t,-1,1)}}async setEnablements(i){const t=await this.readMachinesData();for(const[s,o]of i){const c=t.machines.find(y=>y.id===s);c&&(c.disabled=o?void 0:!0)}await this.writeMachinesData(t)}computeCurrentMachineName(i){const t=this.storageService.get(g,-1);if(t)return t;const s=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${k()} (${this.productService.nameShort})`,o=new RegExp(`${(0,T.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let c=0;for(const y of i){const f=o.exec(y.name),l=f?parseInt(f[1]):0;c=l>c?l:c}return`${s} #${c+1}`}async readMachinesData(i){this.userData=await this.readUserData(i);const t=this.parse(this.userData);if(t.version!==it.VERSION)throw new Error((0,_.localize)(0,null,this.productService.nameLong));return t}async writeMachinesData(i){const t=JSON.stringify(i),s=await this.userDataSyncStoreService.writeResource(it.RESOURCE,t,this.userData?.ref||null);this.userData={ref:s,content:t},this._onDidChange.fire()}async readUserData(i){if(this.userData){const t=i&&i.latest?i.latest[it.RESOURCE]:void 0;if(this.userData.ref===t)return this.userData;if(t===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(it.RESOURCE,this.userData)}parse(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.logService.error(t)}return{version:it.VERSION,machines:[]}}};n.VERSION=1,n.RESOURCE="machines",e.UserDataSyncMachinesService=n=pe([G(0,D.IEnvironmentService),G(1,b.IFileService),G(2,v.IStorageService),G(3,d.IUserDataSyncStoreService),G(4,d.IUserDataSyncLogService),G(5,P.IProductService)],n)}),define(ae[248],ce([0,1,6,63,38,7,3,2,5,22,12,166,24,19,20,23,77,80]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const h="sync.disableMachineEventually",E="sync.sessionId",p="sync.storeUrl",k="sync.productQuality";let n=e.UserDataAutoSyncService=class extends D.Disposable{get syncUrl(){const t=this.storageService.get(p,-1);return t?P.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(p,t.toString(),-1,1):this.storageService.remove(p,-1)}get productQuality(){return this.storageService.get(k,-1)}set productQuality(t){t?this.storageService.store(k,t,-1,1):this.storageService.remove(k,-1)}constructor(t,s,o,c,y,f,l,I,A,F){super(),this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=c,this.userDataSyncService=y,this.logService=f,this.userDataSyncAccountService=l,this.telemetryService=I,this.userDataSyncMachinesService=A,this.storageService=F,this.autoSync=this._register(new D.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new R.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,S.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(l.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(y.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this._register(_.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:t,message:s}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new r(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.telemetryService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,s,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(E,-1),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(c){if(this.logService.error(c),s)this.updateEnablement(!1);else throw c}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const s=w.UserDataSyncError.toUserDataSyncError(t);s instanceof w.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?b.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(h,!0,-1,1),await(0,R.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(h,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(h,-1)}async triggerSync(t,s,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const c=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:c}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};e.UserDataAutoSyncService=n=pe([G(0,v.IProductService),G(1,w.IUserDataSyncStoreManagementService),G(2,w.IUserDataSyncStoreService),G(3,w.IUserDataSyncEnablementService),G(4,w.IUserDataSyncService),G(5,w.IUserDataSyncLogService),G(6,a.IUserDataSyncAccountService),G(7,g.ITelemetryService),G(8,u.IUserDataSyncMachinesService),G(9,d.IStorageService)],n);class r extends D.Disposable{constructor(t,s,o,c,y,f,l,I,A){super(),this.lastSyncUrl=t,this.interval=s,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=c,this.userDataSyncService=y,this.userDataSyncMachinesService=f,this.logService=l,this.telemetryService=I,this.storageService=A,this.intervalHandler=this._register(new D.MutableDisposable),this._onDidStartSync=this._register(new _.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new _.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,D.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(r.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(r.INTERVAL_SYNCING,!1),this.interval)}sync(t,s){const o=(0,R.createCancelablePromise)(async c=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(y){if((0,T.isCancellationError)(y))return}return this.doSync(t,s,c)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,S.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!t&&(!(0,S.isEqual)(s.defaultUrl,t.defaultUrl)||!(0,S.isEqual)(s.insidersUrl,t.insidersUrl)||!(0,S.isEqual)(s.stableUrl,t.stableUrl))}async doSync(t,s,o){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let c;try{await this.createAndRunSyncTask(s,o)}catch(y){if(this.logService.error(y),c=y,w.UserDataSyncError.toUserDataSyncError(y).code==="MethodNotFound")try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(s,o),c=void 0}catch(f){this.logService.error(f),c=f}}this._onDidFinishSync.fire(c)}async createAndRunSyncTask(t,s){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,t),s.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new w.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new w.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new w.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const o=this.storageService.get(E,-1);if(o&&this.manifest&&o!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new w.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new w.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new w.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const c=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(s.isCancellationRequested)return;const y=c.find(l=>l.isCurrent);if(y?.disabled)throw new w.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");const f=new Date().getTime();if(await this.syncTask.run(),this.telemetryService.publicLog2("settingsSync:sync",{duration:new Date().getTime()-f}),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(l){throw new w.UserDataAutoSyncError((0,L.toErrorMessage)(l),l instanceof w.UserDataSyncError?l.code:"Unknown")}this.manifest&&this.manifest.session!==o&&this.storageService.store(E,this.manifest.session,-1,1),!s.isCancellationRequested&&(y||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(t){return super._register(t)}}r.INTERVAL_SYNCING="Interval"}),define(ae[249],ce([0,1,12,170,14,13,44,19,29,23,17,39,118,117,116,18,119,114,115,4,120,41]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u,h,E,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=e.UserDataSyncResourceProviderService=class qe{constructor(i,t,s,o,c,y,f,l,I,A){this.userDataSyncStoreService=i,this.userDataSyncBackupStoreService=t,this.logService=s,this.environmentService=c,this.storageService=y,this.fileService=f,this.userDataProfilesService=l,this.configurationService=I,this.instantiationService=A,this.extUri=o.extUri}async getRemoteSyncedProfiles(){const i=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(i.content){const t=this.parseSyncData(i.content,"profiles");return(0,p.parseUserDataProfilesManifest)(t)}return[]}async getRemoteSyncResourceHandles(i,t){return(await this.userDataSyncStoreService.getAllResourceRefs(i,t?.collection)).map(({created:o,ref:c})=>({created:o,uri:this.toUri({remote:!0,syncResource:i,profile:t?.id??this.userDataProfilesService.defaultProfile.id,collection:t?.collection,ref:c,node:void 0})}))}async getLocalSyncResourceHandles(i,t){return(await this.userDataSyncBackupStoreService.getAllRefs(t,i)).map(({created:o,ref:c})=>({created:o,uri:this.toUri({remote:!1,syncResource:i,profile:t.id,collection:void 0,ref:c,node:void 0})}))}resolveUserDataSyncResource({uri:i}){const t=this.resolveUri(i),s=t?this.userDataProfilesService.profiles.find(o=>o.id===t.profile):void 0;return t&&s?{profile:s,syncResource:t?.syncResource}:void 0}async getAssociatedResources({uri:i}){const t=this.resolveUri(i);if(!t)return[];const s=this.userDataProfilesService.profiles.find(o=>o.id===t.profile);switch(t.syncResource){case"settings":return this.getSettingsAssociatedResources(i,s);case"keybindings":return this.getKeybindingsAssociatedResources(i,s);case"tasks":return this.getTasksAssociatedResources(i,s);case"snippets":return this.getSnippetsAssociatedResources(i,s);case"globalState":return this.getGlobalStateAssociatedResources(i,s);case"extensions":return this.getExtensionsAssociatedResources(i,s);case"profiles":return this.getProfilesAssociatedResources(i,s);case"workspaceState":return[]}}async getMachineId({uri:i}){const t=this.resolveUri(i);if(t){if(t.remote){if(t.ref){const{content:s}=await this.getUserData(t.syncResource,t.ref,t.collection);if(s)return this.parseSyncData(s,t.syncResource)?.machineId}return}return(0,_.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(i){const t=this.resolveUri(i);if(!t||t.node===qe.NOT_EXISTING_RESOURCE)return null;if(t.ref){const s=await this.getContentFromStore(t.remote,t.syncResource,t.profile,t.collection,t.ref);return t.node&&s?this.resolveNodeContent(t.syncResource,s,t.node):s}return!t.remote&&!t.node?this.resolveLatestContent(t.syncResource,t.profile):null}async getContentFromStore(i,t,s,o,c){if(i){const{content:f}=await this.getUserData(t,c,o);return f}const y=this.userDataProfilesService.profiles.find(f=>f.id===s);return y?this.userDataSyncBackupStoreService.resolveContent(y,t,c):null}resolveNodeContent(i,t,s){const o=this.parseSyncData(t,i);switch(i){case"settings":return this.resolveSettingsNodeContent(o,s);case"keybindings":return this.resolveKeybindingsNodeContent(o,s);case"tasks":return this.resolveTasksNodeContent(o,s);case"snippets":return this.resolveSnippetsNodeContent(o,s);case"globalState":return this.resolveGlobalStateNodeContent(o,s);case"extensions":return this.resolveExtensionsNodeContent(o,s);case"profiles":return this.resolveProfileNodeContent(o,s);case"workspaceState":return null}}async resolveLatestContent(i,t){const s=this.userDataProfilesService.profiles.find(o=>o.id===t);if(!s)return null;switch(i){case"globalState":return this.resolveLatestGlobalStateContent(s);case"extensions":return this.resolveLatestExtensionsContent(s);case"profiles":return this.resolveLatestProfilesContent(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}getSettingsAssociatedResources(i,t){const s=this.extUri.joinPath(i,"settings.json"),o=t?t.settingsResource:this.extUri.joinPath(i,qe.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:o}]}resolveSettingsNodeContent(i,t){switch(t){case"settings.json":return(0,d.parseSettingsSyncContent)(i.content).settings}return null}getKeybindingsAssociatedResources(i,t){const s=this.extUri.joinPath(i,"keybindings.json"),o=t?t.keybindingsResource:this.extUri.joinPath(i,qe.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:o}]}resolveKeybindingsNodeContent(i,t){switch(t){case"keybindings.json":return(0,g.getKeybindingsContentFromSyncContent)(i.content,!!this.configurationService.getValue(S.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(i,t){const s=this.extUri.joinPath(i,"tasks.json"),o=t?t.tasksResource:this.extUri.joinPath(i,qe.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:o}]}resolveTasksNodeContent(i,t){switch(t){case"tasks.json":return(0,a.getTasksContentFromSyncContent)(i.content,this.logService)}return null}async getSnippetsAssociatedResources(i,t){const s=await this.resolveContent(i);if(s){const o=this.parseSyncData(s,"snippets");if(o){const c=(0,v.parseSnippets)(o),y=[];for(const f of Object.keys(c)){const l=this.extUri.joinPath(i,f),I=t?this.extUri.joinPath(t.snippetsHome,f):this.extUri.joinPath(i,qe.NOT_EXISTING_RESOURCE);y.push({resource:l,comparableResource:I})}return y}}return[]}resolveSnippetsNodeContent(i,t){return(0,v.parseSnippets)(i)[t]||null}getExtensionsAssociatedResources(i,t){const s=this.extUri.joinPath(i,"extensions.json"),o=t?this.toUri({remote:!1,syncResource:"extensions",profile:t.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(i,qe.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:o}]}resolveExtensionsNodeContent(i,t){switch(t){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(i),!0)}return null}async resolveLatestExtensionsContent(i){const{localExtensions:t}=await this.instantiationService.createInstance(u.LocalExtensionsProvider).getLocalExtensions(i);return(0,u.stringify)(t,!0)}getGlobalStateAssociatedResources(i,t){const s=this.extUri.joinPath(i,"globalState.json"),o=t?this.toUri({remote:!1,syncResource:"globalState",profile:t.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(i,qe.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:o}]}resolveGlobalStateNodeContent(i,t){switch(t){case"globalState.json":return(0,h.stringify)(JSON.parse(i.content),!0)}return null}async resolveLatestGlobalStateContent(i){const t=await this.instantiationService.createInstance(h.LocalGlobalStateProvider).getLocalGlobalState(i);return(0,h.stringify)(t,!0)}getProfilesAssociatedResources(i,t){const s=this.extUri.joinPath(i,"profiles.json"),o=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:o}]}resolveProfileNodeContent(i,t){switch(t){case"profiles.json":return(0,k.toFormattedString)(JSON.parse(i.content),{})}return null}async resolveLatestProfilesContent(i){return(0,p.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(t=>!t.isDefault&&!t.isTransient),!0)}toUri(i){const t=i.remote?qe.REMOTE_BACKUP_AUTHORITY:qe.LOCAL_BACKUP_AUTHORITY,s=[i.syncResource,i.profile];return i.collection&&s.push(`collection:${i.collection}`),i.ref&&s.push(`ref:${i.ref}`),i.node&&s.push(i.node),this.extUri.joinPath(R.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:t,path:"/"}),...s)}resolveUri(i){if(i.scheme!==S.USER_DATA_SYNC_SCHEME||i.authority!==qe.LOCAL_BACKUP_AUTHORITY&&i.authority!==qe.REMOTE_BACKUP_AUTHORITY)return;const t=[];for(;i.path!=="/";)t.unshift(this.extUri.basename(i)),i=this.extUri.dirname(i);if(t.length<2)return;const s=i.authority===qe.REMOTE_BACKUP_AUTHORITY,o=t.shift(),c=t.shift();let y,f,l;for(;t.length;){const I=t.shift();I.startsWith("collection:")?y=I.substring(11):I.startsWith("ref:")?f=I.substring(4):l=I}return{remote:s,syncResource:o,profile:c,collection:y,ref:f,node:l}}parseSyncData(i,t){try{const s=JSON.parse(i);if((0,C.isSyncData)(s))return s}catch(s){this.logService.error(s)}throw new S.UserDataSyncError((0,N.localize)(0,null),"IncompatibleRemoteContent",t)}async getUserData(i,t,s){const o=await this.userDataSyncStoreService.resolveResourceContent(i,t,s);return{ref:t,content:o}}};n.NOT_EXISTING_RESOURCE="not-existing-resource",n.REMOTE_BACKUP_AUTHORITY="remote-backup",n.LOCAL_BACKUP_AUTHORITY="local-backup",e.UserDataSyncResourceProviderService=n=pe([G(0,S.IUserDataSyncStoreService),G(1,S.IUserDataSyncBackupStoreService),G(2,S.IUserDataSyncLogService),G(3,b.IUriIdentityService),G(4,L.IEnvironmentService),G(5,D.IStorageService),G(6,T.IFileService),G(7,P.IUserDataProfilesService),G(8,w.IConfigurationService),G(9,E.IInstantiationService)],n)}),define(ae[250],ce([0,1,21,6,26,38,3,2,22,10,32,18,28,4,19,20,17,114,115,116,117,118,119,120,23]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u,h,E,p,k,n,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const t="sync.lastSyncTime";let s=e.UserDataSyncService=class extends D.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(l,I,A,F,M,V,x,q,X){super(),this.userDataSyncStoreService=l,this.userDataSyncStoreManagementService=I,this.instantiationService=A,this.logService=F,this.telemetryService=M,this.storageService=V,this.userDataSyncEnablementService=x,this.userDataProfilesService=q,this.userDataSyncResourceProviderService=X,this._status="uninitialized",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new _.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new _.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new _.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new _.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=I.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(t,-1,void 0),this._register((0,D.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(l,I){this.checkEnablement(),this.logService.info("Sync started.");const A=new Date().getTime(),F=(0,P.generateUuid)();try{const q=(0,i.createSyncHeaders)(F);I&&(q["Cache-Control"]="no-cache"),l=await this.userDataSyncStoreService.manifest(l,q)}catch(q){const X=i.UserDataSyncError.toUserDataSyncError(q);throw y(X,F,this.userDataSyncStoreManagementService,this.telemetryService),X}const M=!1,V=this;let x;return{manifest:l,async run(){if(M)throw new Error("Can run a task only once");x=(0,N.createCancelablePromise)(q=>V.sync(l,!1,F,q)),await x.finally(()=>x=void 0),V.logService.info(`Sync done. Took ${new Date().getTime()-A}ms`),V.updateLastSyncTime()},stop(){return x?.cancel(),V.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new i.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const l=new Date().getTime(),I=(0,P.generateUuid)(),A=(0,i.createSyncHeaders)(I);let F;try{F=await this.userDataSyncStoreService.manifest(null,A)}catch(x){const q=i.UserDataSyncError.toUserDataSyncError(x);throw y(q,I,this.userDataSyncStoreManagementService,this.telemetryService),q}await this.resetLocal();const M=this,V=new L.CancellationTokenSource;return{id:I,async merge(){return M.sync(F,!0,I,V.token)},async apply(){try{try{await M.applyManualSync(F,I,V.token)}catch(x){if(i.UserDataSyncError.toUserDataSyncError(x).code==="MethodNotFound")M.logService.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.logService.info("Applying manual sync again..."),await M.applyManualSync(F,I,V.token);else throw x}}catch(x){throw M.logService.error(x),x}M.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),M.updateLastSyncTime()},async stop(){V.cancel(),await M.stop(),await M.resetLocal()}}}async sync(l,I,A,F){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(M,l,I,A,F));const V=M.enabled.find(x=>x.resource==="profiles");if(V){const x=await V.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.syncRemoteProfiles(x,l,I,A,F)}}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(l,I,A,F,M){for(const V of l){if(M.isCancellationRequested)return;const x=this.userDataProfilesService.profiles.find(X=>X.id===V.id);if(!x){this.logService.error(`Profile with id:${V.id} and name: ${V.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",V.name);const q=this.getOrCreateActiveProfileSynchronizer(x,V);this._syncErrors.push(...await this.syncProfile(q,I,A,F,M))}for(const[V,x]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(q=>q.id===x[0].profile.id)||(x[1].dispose(),this.activeProfileSynchronizers.delete(V))}async applyManualSync(l,I,A){const F=this.getActiveProfileSynchronizers();for(const X of F){if(A.isCancellationRequested)return;await X.apply(I,A)}const M=F.find(X=>X.profile.isDefault);if(!M)return;const V=M.enabled.find(X=>X.resource==="profiles");if(!V)return;const q=(await V.getRemoteSyncedProfiles(l?.latest??null)||[]).filter(X=>F.every(ee=>ee.profile.id!==X.id));q.length&&await this.syncRemoteProfiles(q,l,!1,I,A)}async syncProfile(l,I,A,F,M){return(await l.sync(I,A,F,M)).map(([x,q])=>({profile:l.profile,syncResource:x,error:q}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(l=>l.stop()))}async resolveContent(l){const I=await this.userDataSyncResourceProviderService.resolveContent(l);if(I)return I;for(const A of this.getActiveProfileSynchronizers())for(const F of A.enabled){const M=await F.resolveContent(l);if(M)return M}return null}async replace(l){this.checkEnablement();const I=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(l);if(!I)return;const A=await this.resolveContent(l.uri);A&&await this.performAction(I.profile,async F=>{if(I.syncResource===F.resource)return await F.replace(A),!0})}async accept(l,I,A,F){this.checkEnablement(),await this.performAction(l.profile,async M=>{if(l.syncResource===M.resource)return await M.accept(I,A),F&&await M.apply((0,S.isBoolean)(F)?!1:F.force,(0,i.createSyncHeaders)((0,P.generateUuid)())),!0})}getRemoteProfiles(){return this.userDataSyncResourceProviderService.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(l,I){return this.userDataSyncResourceProviderService.getRemoteSyncResourceHandles(l,I)}async getLocalSyncResourceHandles(l,I){return this.userDataSyncResourceProviderService.getLocalSyncResourceHandles(l,I??this.userDataProfilesService.defaultProfile)}async getAssociatedResources(l){return this.userDataSyncResourceProviderService.getAssociatedResources(l)}async getMachineId(l){return this.userDataSyncResourceProviderService.getMachineId(l)}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async I=>{if(I.resource!=="globalState"&&await I.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async I=>{if(await I.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(l){this.logService.error(l)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(t,-1);for(const[l]of this.activeProfileSynchronizers.values())try{await l.resetLocal()}catch(I){this.logService.error(I)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpRemoteData(){const l=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),I=l.map(V=>V.collection),A=await this.userDataSyncStoreService.getAllCollections(),F=A.filter(V=>!I.includes(V));F.length&&(this.logService.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(V=>this.userDataSyncStoreService.deleteCollection(V))),this.logService.info("Deleted redundant collections on server"));const M=l.filter(V=>A.includes(V.collection));if(M.length!==l.length){this.logService.info("Updating remote profiles with invalid collections on server");const V=this.instantiationService.createInstance(r.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{await V.updateRemoteProfiles(M,null),this.logService.info("Updated remote profiles on server")}finally{V.dispose()}}}async performAction(l,I){const A=new D.DisposableStore;try{const F=this.activeProfileSynchronizers.get(l.id);if(F){const X=await this.performActionWithProfileSynchronizer(F[0],I,A);return(0,S.isUndefined)(X)?null:X}if(l.isDefault){const X=A.add(this.instantiationService.createInstance(o,l,void 0)),ee=await this.performActionWithProfileSynchronizer(X,I,A);return(0,S.isUndefined)(ee)?null:ee}if(this.userDataProfilesService.isEnabled())return null;const M=A.add(this.instantiationService.createInstance(r.UserDataProfilesManifestSynchroniser,l,void 0)),V=await this.userDataSyncStoreService.manifest(null),q=(await M.getRemoteSyncedProfiles(V?.latest??null)||[]).find(X=>X.id===l.id);if(q){const X=A.add(this.instantiationService.createInstance(o,l,q.collection)),ee=await this.performActionWithProfileSynchronizer(X,I,A);return(0,S.isUndefined)(ee)?null:ee}return null}finally{A.dispose()}}async performActionWithProfileSynchronizer(l,I,A){const F=[...l.enabled,...l.disabled.reduce((M,V)=>(V!=="workspaceState"&&M.push(A.add(l.createSynchronizer(V))),M),[])];for(const M of F){const V=await I(M);if(!(0,S.isUndefined)(V))return V}}setStatus(l){const I=this._status;this._status!==l&&(this._status=l,this._onDidChangeStatus.fire(l),I==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const l=this.getActiveProfileSynchronizers().map(I=>I.conflicts).flat();(0,R.equals)(this._conflicts,l,(I,A)=>I.profile.id===A.profile.id&&I.syncResource===A.syncResource&&(0,R.equals)(I.conflicts,A.conflicts,(F,M)=>(0,b.isEqual)(F.previewResource,M.previewResource)))||(this._conflicts=l,this._onDidChangeConflicts.fire(l))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(t,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(l,I){let A=this.activeProfileSynchronizers.get(l.id);if(A&&A[0].collection!==I?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),A[1].dispose(),A=void 0,this.activeProfileSynchronizers.delete(l.id)),!A){const F=new D.DisposableStore,M=F.add(this.instantiationService.createInstance(o,l,I?.collection));F.add(M.onDidChangeStatus(V=>this.setStatus(V))),F.add(M.onDidChangeConflicts(V=>this.updateConflicts())),F.add(M.onDidChangeLocal(V=>this._onDidChangeLocal.fire(V))),this.activeProfileSynchronizers.set(l.id,A=[M,F])}return A[0]}getActiveProfileSynchronizers(){const l=[];for(const[I]of this.activeProfileSynchronizers.values())l.push(I);return l}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,l])=>l.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=s=pe([G(0,i.IUserDataSyncStoreService),G(1,i.IUserDataSyncStoreManagementService),G(2,d.IInstantiationService),G(3,i.IUserDataSyncLogService),G(4,w.ITelemetryService),G(5,g.IStorageService),G(6,i.IUserDataSyncEnablementService),G(7,a.IUserDataProfilesService),G(8,i.IUserDataSyncResourceProviderService)],s);let o=class extends D.Disposable{get enabled(){return this._enabled.sort((l,I)=>l[1]-I[1]).map(([l])=>l)}get disabled(){return i.ALL_SYNC_RESOURCES.filter(l=>!this.userDataSyncEnablementService.isResourceEnabled(l))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(l,I,A,F,M,V,x,q,X,ee){super(),this.profile=l,this.collection=I,this.userDataSyncEnablementService=A,this.instantiationService=F,this.extensionGalleryService=M,this.userDataSyncStoreManagementService=V,this.telemetryService=x,this.logService=q,this.userDataProfilesService=X,this.configurationService=ee,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(A.onDidChangeResourceEnablement(([Y,Z])=>this.onDidChangeResourceEnablement(Y,Z))),this._register((0,D.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,Y])=>Y.dispose())));for(const Y of i.ALL_SYNC_RESOURCES)A.isResourceEnabled(Y)&&this.registerSynchronizer(Y)}onDidChangeResourceEnablement(l,I){I?this.registerSynchronizer(l):this.deRegisterSynchronizer(l)}registerSynchronizer(l){if(this._enabled.some(([M])=>M.resource===l))return;if(l==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(l==="profiles"&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled())||l==="workspaceState")return;const I=new D.DisposableStore,A=I.add(this.createSynchronizer(l));I.add(A.onDidChangeStatus(()=>this.updateStatus())),I.add(A.onDidChangeConflicts(()=>this.updateConflicts())),I.add(A.onDidChangeLocal(()=>this._onDidChangeLocal.fire(l)));const F=this.getOrder(l);this._enabled.push([A,F,I])}deRegisterSynchronizer(l){const I=this._enabled.findIndex(([A])=>A.resource===l);if(I!==-1){const[[A,,F]]=this._enabled.splice(I,1);F.dispose(),this.updateStatus(),Promise.allSettled([A.stop(),A.resetLocal()]).then(null,M=>this.logService.error(M))}}createSynchronizer(l){switch(l){case"settings":return this.instantiationService.createInstance(p.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.instantiationService.createInstance(E.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.instantiationService.createInstance(k.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.instantiationService.createInstance(n.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.instantiationService.createInstance(h.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.instantiationService.createInstance(u.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.instantiationService.createInstance(r.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(l,I,A,F){if(F.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const V=[],x=(0,i.createSyncHeaders)(A),q=(this.collection?l?.collections?.[this.collection]?.latest:l?.latest)??null,X=I?await this.getUserDataSyncConfiguration(q):{};for(const ee of M){if(F.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(ee.resource))return[];try{if(I){const Y=await ee.preview(q,X,x);if(Y)for(const Z of Y.resourcePreviews)(Z.localChange!==0||Z.remoteChange!==0)&&Z.mergeState==="preview"&&await ee.merge(Z.previewResource)}else await ee.sync(q,x)}catch(Y){const Z=i.UserDataSyncError.toUserDataSyncError(Y);if(y(Z,A,this.userDataSyncStoreManagementService,this.telemetryService),c(Y))throw Z;this.logService.error(Y),this.logService.error(`${ee.resource}: ${(0,T.toErrorMessage)(Y)}`),V.push([ee.resource,Z])}}return V}finally{this.updateStatus()}}async apply(l,I){const A=(0,i.createSyncHeaders)(l);for(const F of this.enabled){if(I.isCancellationRequested)return;try{await F.apply(!1,A)}catch(M){const V=i.UserDataSyncError.toUserDataSyncError(M);if(y(V,l,this.userDataSyncStoreManagementService,this.telemetryService),c(M))throw V;this.logService.error(M),this.logService.error(`${F.resource}: ${(0,T.toErrorMessage)(M)}`)}}}async stop(){for(const l of this.enabled)try{l.status!=="idle"&&await l.stop()}catch(I){this.logService.error(I)}}async resetLocal(){for(const l of this.enabled)try{await l.resetLocal()}catch(I){this.logService.error(`${l.resource}: ${(0,T.toErrorMessage)(I)}`),this.logService.error(I)}}async getUserDataSyncConfiguration(l){if(!this.profile.isDefault)return{};const I=this.configurationService.getValue(i.USER_DATA_SYNC_CONFIGURATION_SCOPE),A=this.enabled.find(F=>F instanceof p.SettingsSynchroniser);if(A){const F=await A.getRemoteUserDataSyncConfiguration(l);return{...I,...F}}return I}setStatus(l){this._status!==l&&(this._status=l,this._onDidChangeStatus.fire(l))}updateStatus(){return this.updateConflicts(),this.enabled.some(l=>l.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(l=>l.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const l=this.enabled.filter(I=>I.status==="hasConflicts").filter(I=>I.conflicts.conflicts.length>0).map(I=>I.conflicts);(0,R.equals)(this._conflicts,l,(I,A)=>I.syncResource===A.syncResource&&(0,R.equals)(I.conflicts,A.conflicts,(F,M)=>(0,b.isEqual)(F.previewResource,M.previewResource)))||(this._conflicts=l,this._onDidChangeConflicts.fire(l))}getOrder(l){switch(l){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};o=pe([G(2,i.IUserDataSyncEnablementService),G(3,d.IInstantiationService),G(4,v.IExtensionGalleryService),G(5,i.IUserDataSyncStoreManagementService),G(6,w.ITelemetryService),G(7,i.IUserDataSyncLogService),G(8,a.IUserDataProfilesService),G(9,C.IConfigurationService)],o);function c(f){if(f instanceof i.UserDataSyncError)switch(f.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function y(f,l,I,A){A.publicLog2("sync/error",{code:f.code,serverCode:f instanceof i.UserDataSyncStoreError?String(f.serverCode):void 0,url:f instanceof i.UserDataSyncStoreError?f.url:void 0,resource:f.resource,executionId:l,service:I.userDataSyncStore.url.toString()})}}),define(ae[251],ce([0,1,3,2,12,17,23]),function(ne,e,R,N,L,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function D(v,d){return{...v,profile:(0,T.reviveProfile)(v.profile,d.profilesHome.scheme)}}function b(v){return{created:v.created,uri:L.URI.revive(v.uri)}}class S{constructor(d,g,w){this.service=d,this.userDataProfilesService=g,this.logService=w,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(d,g){switch(g){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${g}`)}async call(d,g,w){try{return await this._call(d,g,w)}catch(a){throw this.logService.error(a),a}}async _call(d,g,w){switch(g){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(L.URI.revive(w[0]));case"accept":return this.service.accept(D(w[0],this.userDataProfilesService),L.URI.revive(w[1]),w[2],w[3]);case"getRemoteProfiles":return this.service.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(w[0],w[1]?(0,T.reviveProfile)(w[1],this.userDataProfilesService.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(w[0],w[1]);case"replace":return this.service.replace(b(w[0]));case"getAssociatedResources":return this.service.getAssociatedResources(b(w[0]));case"getMachineId":return this.service.getMachineId(b(w[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"createManualSyncTask":return this.createManualSyncTask()}if(g.startsWith("manualSync/")){const a=g.substring(11),u=w[0],h=this.getManualSyncTask(u);switch(w=w.slice(1),a){case"merge":return h.merge();case"apply":return h.apply().then(()=>this.manualSyncTasks.delete(this.createKey(h.id)));case"stop":return h.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(h.id)))}}throw new Error("Invalid call")}getManualSyncTask(d){const g=this.manualSyncTasks.get(this.createKey(d));if(!g)throw new Error(`Manual sync taks not found: ${d}`);return g}async createManualSyncTask(){const d=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(d.id),d),d.id}createKey(d){return`manualSyncTask-${d}`}}e.UserDataSyncChannel=S;let P=e.UserDataSyncChannelClient=class extends N.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(d,g){super(),this.userDataProfilesService=g,this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(w,a,u){return d.call(w,a,u).then(null,h=>{throw _.UserDataSyncError.toUserDataSyncError(h)})},listen(w,a){return d.listen(w,a)}},this.channel.call("_getInitialData").then(([w,a,u])=>{this.updateStatus(w),this.updateConflicts(a),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(h=>this.updateStatus(h))),this._register(this.channel.listen("onDidChangeLastSyncTime")(h=>this.updateLastSyncTime(h)))}),this._register(this.channel.listen("onDidChangeConflicts")(w=>this.updateConflicts(w))),this._register(this.channel.listen("onSyncErrors")(w=>this._onSyncErrors.fire(w.map(a=>({...a,error:_.UserDataSyncError.toUserDataSyncError(a.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const d=await this.channel.call("createManualSyncTask"),g=this;return new C(d,{async call(a,u,h){return g.channel.call(`manualSync/${a}`,[d,...Array.isArray(u)?u:[u]],h)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(d,g,w,a){return this.channel.call("accept",[d,g,w,a])}resolveContent(d){return this.channel.call("resolveContent",[d])}getRemoteProfiles(){return this.channel.call("getRemoteProfiles")}async getLocalSyncResourceHandles(d,g){return(await this.channel.call("getLocalSyncResourceHandles",[d,g])).map(({created:a,uri:u})=>({created:a,uri:L.URI.revive(u)}))}async getRemoteSyncResourceHandles(d,g){return(await this.channel.call("getRemoteSyncResourceHandles",[d,g])).map(({created:a,uri:u})=>({created:a,uri:L.URI.revive(u)}))}async getAssociatedResources(d){return(await this.channel.call("getAssociatedResources",[d])).map(({resource:w,comparableResource:a})=>({resource:L.URI.revive(w),comparableResource:L.URI.revive(a)}))}getMachineId(d){return this.channel.call("getMachineId",[d])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(d){return this.channel.call("replace",[d])}async updateStatus(d){this._status=d,this._onDidChangeStatus.fire(d)}async updateConflicts(d){this._conflicts=d.map(g=>({syncResource:g.syncResource,profile:(0,T.reviveProfile)(g.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:g.conflicts.map(w=>({...w,baseResource:L.URI.revive(w.baseResource),localResource:L.URI.revive(w.localResource),remoteResource:L.URI.revive(w.remoteResource),previewResource:L.URI.revive(w.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(d){this._lastSyncTime!==d&&(this._lastSyncTime=d,this._onDidChangeLastSyncTime.fire(d))}};e.UserDataSyncChannelClient=P=pe([G(1,T.IUserDataProfilesService)],P);class C extends N.Disposable{constructor(d,g){super(),this.id=d,this.channel=g}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(ae[252],ce([0,1,6,26,7,3,2,135,5,22,10,12,32,18,14,13,24,56,44,19,23]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u,h,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const k="sync.previous.store",n="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",t=100,s=1e3*60*5;let o=e.AbstractUserDataSyncStoreManagementService=class extends _.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(p.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(A){this.storageService.store(p.SYNC_SERVICE_URL_TYPE,A,-1,b.isWeb?0:1)}constructor(A,F,M){super(),this.productService=A,this.configurationService=F,this.storageService=M,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(M.onDidChangeValue,V=>V.key===p.SYNC_SERVICE_URL_TYPE&&V.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[p.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(p.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(A,F){A=b.isWeb&&A?.web?{...A,...A.web}:A;const M={...A||{},...F||{}};if(M&&(0,P.isString)(M.url)&&(0,P.isObject)(M.authenticationProviders)&&Object.keys(M.authenticationProviders).every(V=>Array.isArray(M.authenticationProviders[V].scopes))){const V=M,x=!!V.canSwitch&&!F?.url,q=V.url===V.insidersUrl?"insiders":"stable",X=(x?this.userDataSyncStoreType:void 0)||q,ee=F?.url||(X==="insiders"?V.insidersUrl:X==="stable"?V.stableUrl:V.url);return{url:C.URI.parse(ee),type:X,defaultType:q,defaultUrl:C.URI.parse(V.url),stableUrl:C.URI.parse(V.stableUrl),insidersUrl:C.URI.parse(V.insidersUrl),canSwitch:x,authenticationProviders:Object.keys(V.authenticationProviders).reduce((Y,Z)=>(Y.push({id:Z,scopes:V.authenticationProviders[Z].scopes}),Y),[])}}}};e.AbstractUserDataSyncStoreManagementService=o=pe([G(0,a.IProductService),G(1,d.IConfigurationService),G(2,E.IStorageService)],o);let c=e.UserDataSyncStoreManagementService=class extends o{constructor(A,F,M){super(A,F,M);const V=this.storageService.get(k,-1);V&&(this.previousConfigurationSyncStore=JSON.parse(V));const x=this.productService[p.CONFIGURATION_SYNC_STORE_KEY];x?this.storageService.store(k,JSON.stringify(x),-1,1):this.storageService.remove(k,-1)}async switch(A){A!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=A,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};e.UserDataSyncStoreManagementService=c=pe([G(0,a.IProductService),G(1,d.IConfigurationService),G(2,E.IStorageService)],c);let y=e.UserDataSyncStoreClient=class extends _.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(A,F,M,V,x,q,X){super(),this.requestService=M,this.logService=V,this.storageService=X,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(A),this.commonHeadersPromise=(0,h.getServiceMachineId)(x,q,X).then(ee=>{const Y={"X-Client-Name":`${F.applicationName}${b.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(Y["X-Client-Commit"]=F.commit),Y}),this.session=new l(t,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,_.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(A,F){this.authToken={token:A,type:F}}updateUserDataSyncStoreUrl(A){this.userDataSyncStoreUrl=A?(0,S.joinPath)(A,"v1"):void 0}initDonotMakeRequestsUntil(){const A=this.storageService.getNumber(n,-1);A&&Date.now()<A&&this.setDonotMakeRequestsUntil(new Date(A))}setDonotMakeRequestsUntil(A){this._donotMakeRequestsUntil?.getTime()!==A?.getTime()&&(this._donotMakeRequestsUntil=A,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(n,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(F=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(n,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(A={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,S.joinPath)(this.userDataSyncStoreUrl,"collection").toString();A={...A},A["Content-Type"]="application/json";const M=await this.request(F,{type:"GET",headers:A},[],N.CancellationToken.None);return(await(0,u.asJson)(M))?.map(({id:V})=>V)||[]}async createCollection(A={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,S.joinPath)(this.userDataSyncStoreUrl,"collection").toString();A={...A},A["Content-Type"]=D.Mimes.text;const M=await this.request(F,{type:"POST",headers:A},[],N.CancellationToken.None),V=await(0,u.asTextOrError)(M);if(!V)throw new p.UserDataSyncStoreError("Server did not return the collection id",F,"NoCollection",M.res.statusCode,M.res.headers[p.HEADER_OPERATION_ID]);return V}async deleteCollection(A,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=A?(0,S.joinPath)(this.userDataSyncStoreUrl,"collection",A).toString():(0,S.joinPath)(this.userDataSyncStoreUrl,"collection").toString();F={...F},await this.request(M,{type:"DELETE",headers:F},[],N.CancellationToken.None)}async getAllResourceRefs(A,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=this.getResourceUrl(this.userDataSyncStoreUrl,F,A),V={},x=await this.request(M.toString(),{type:"GET",headers:V},[],N.CancellationToken.None);return(await(0,u.asJson)(x)||[]).map(({url:X,created:ee})=>({ref:(0,S.relativePath)(M,M.with({path:X})),created:ee*1e3}))}async resolveResourceContent(A,F,M,V={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,S.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,M,A),F).toString();V={...V},V["Cache-Control"]="no-cache";const q=await this.request(x,{type:"GET",headers:V},[],N.CancellationToken.None);return await(0,u.asTextOrError)(q)}async deleteResource(A,F,M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=F!==null?(0,S.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,M,A),F).toString():this.getResourceUrl(this.userDataSyncStoreUrl,M,A).toString(),x={};await this.request(V,{type:"DELETE",headers:x},[],N.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const A=(0,S.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":D.Mimes.text};await this.request(A,{type:"DELETE",headers:F},[],N.CancellationToken.None)}async readResource(A,F,M,V={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,S.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,M,A),"latest").toString();V={...V},V["Cache-Control"]="no-cache",F&&(V["If-None-Match"]=F.ref);const q=await this.request(x,{type:"GET",headers:V},[304],N.CancellationToken.None);let X=null;if(q.res.statusCode===304&&(X=F),X===null){const ee=q.res.headers.etag;if(!ee)throw new p.UserDataSyncStoreError("Server did not return the ref",x,"NoRef",q.res.statusCode,q.res.headers[p.HEADER_OPERATION_ID]);const Y=await(0,u.asTextOrError)(q);if(!Y&&q.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",x,"EmptyResponse",q.res.statusCode,q.res.headers[p.HEADER_OPERATION_ID]);X={ref:ee,content:Y}}return X}async writeResource(A,F,M,V,x={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=this.getResourceUrl(this.userDataSyncStoreUrl,V,A).toString();x={...x},x["Content-Type"]=D.Mimes.text,M&&(x["If-Match"]=M);const X=await this.request(q,{type:"POST",data:F,headers:x},[],N.CancellationToken.None),ee=X.res.headers.etag;if(!ee)throw new p.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",X.res.statusCode,X.res.headers[p.HEADER_OPERATION_ID]);return ee}async manifest(A,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,S.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",A&&(F["If-None-Match"]=A.ref);const V=await this.request(M,{type:"GET",headers:F},[304],N.CancellationToken.None);let x=null;if(V.res.statusCode===304&&(x=A),!x){const X=V.res.headers.etag;if(!X)throw new p.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",V.res.statusCode,V.res.headers[p.HEADER_OPERATION_ID]);const ee=await(0,u.asTextOrError)(V);if(!ee&&V.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",M,"EmptyResponse",V.res.statusCode,V.res.headers[p.HEADER_OPERATION_ID]);ee&&(x={...JSON.parse(ee),ref:X})}const q=this.storageService.get(r,-1);return q&&x&&q!==x.session&&this.clearSession(),x===null&&q&&this.clearSession(),x&&this.storageService.store(r,x.session,-1,1),x}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}getResourceUrl(A,F,M){return F?(0,S.joinPath)(A,"collection",F,"resource",M):(0,S.joinPath)(A,"resource",M)}clearSession(){this.storageService.remove(r,-1),this.storageService.remove(i,-1)}async request(A,F,M,V){if(!this.authToken)throw new p.UserDataSyncStoreError("No Auth Token Available",A,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new p.UserDataSyncStoreError(`${F.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const x=await this.commonHeadersPromise;F.headers={...F.headers||{},...x,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:A,type:F.type,headers:{...F.headers,authorization:void 0}});let q;try{q=await this.session.request(A,F,V)}catch(j){if(!(j instanceof p.UserDataSyncStoreError)){let B="RequestFailed";const z=(0,L.getErrorMessage)(j).toLowerCase();z.includes("xhr timeout")?B="RequestTimeout":z.includes("protocol")&&z.includes("not supported")?B="RequestProtocolNotSupported":z.includes("request path contains unescaped characters")?B="RequestPathNotEscaped":z.includes("headers must be an object")?B="RequestHeadersNotObject":(0,L.isCancellationError)(j)&&(B="RequestCanceled"),j=new p.UserDataSyncStoreError(`Connection refused for the request '${A}'.`,A,B,void 0,void 0)}throw this.logService.info("Request failed",A),j}const X=q.res.headers[p.HEADER_OPERATION_ID],ee={url:A,status:q.res.statusCode,"execution-id":F.headers[p.HEADER_EXECUTION_ID],"operation-id":X},Y=(0,u.isSuccess)(q)||q.res.statusCode&&M.includes(q.res.statusCode);let Z="";if(Y?this.logService.trace("Request succeeded",ee):(this.logService.info("Request failed",ee),Z=await(0,u.asText)(q)||""),q.res.statusCode===401||q.res.statusCode===403){if(this.authToken=void 0,q.res.statusCode===401)throw this._onTokenFailed.fire("Unauthorized"),new p.UserDataSyncStoreError(`${F.type} request '${A}' failed because of Unauthorized (401).`,A,"Unauthorized",q.res.statusCode,X);if(q.res.statusCode===403)throw this._onTokenFailed.fire("Forbidden"),new p.UserDataSyncStoreError(`${F.type} request '${A}' failed because the access is forbidden (403).`,A,"Forbidden",q.res.statusCode,X)}if(this._onTokenSucceed.fire(),q.res.statusCode===404)throw new p.UserDataSyncStoreError(`${F.type} request '${A}' failed because the requested resource is not found (404).`,A,"NotFound",q.res.statusCode,X);if(q.res.statusCode===405)throw new p.UserDataSyncStoreError(`${F.type} request '${A}' failed because the requested endpoint is not found (405). ${Z}`,A,"MethodNotFound",q.res.statusCode,X);if(q.res.statusCode===409)throw new p.UserDataSyncStoreError(`${F.type} request '${A}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,A,"Conflict",q.res.statusCode,X);if(q.res.statusCode===410)throw new p.UserDataSyncStoreError(`${F.type} request '${A}' failed because the requested resource is not longer available (410).`,A,"Gone",q.res.statusCode,X);if(q.res.statusCode===412)throw new p.UserDataSyncStoreError(`${F.type} request '${A}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,A,"PreconditionFailed",q.res.statusCode,X);if(q.res.statusCode===413)throw new p.UserDataSyncStoreError(`${F.type} request '${A}' failed because of too large payload (413).`,A,"TooLarge",q.res.statusCode,X);if(q.res.statusCode===426)throw new p.UserDataSyncStoreError(`${F.type} request '${A}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,A,"UpgradeRequired",q.res.statusCode,X);if(q.res.statusCode===429){const j=q.res.headers["retry-after"];throw j?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(j)*1e3)),new p.UserDataSyncStoreError(`${F.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",q.res.statusCode,X)):new p.UserDataSyncStoreError(`${F.type} request '${A}' failed because of too many requests (429).`,A,"RemoteTooManyRequests",q.res.statusCode,X)}if(!Y)throw new p.UserDataSyncStoreError("Server returned "+q.res.statusCode,A,"Unknown",q.res.statusCode,X);return q}addSessionHeaders(A){let F=this.storageService.get(i,-1);F===void 0&&(F=(0,v.generateUuid)(),this.storageService.store(i,F,-1,1)),A["X-Machine-Session-Id"]=F;const M=this.storageService.get(r,-1);M!==void 0&&(A["X-User-Session-Id"]=M)}};e.UserDataSyncStoreClient=y=pe([G(1,a.IProductService),G(2,u.IRequestService),G(3,p.IUserDataSyncLogService),G(4,g.IEnvironmentService),G(5,w.IFileService),G(6,E.IStorageService)],y);let f=e.UserDataSyncStoreService=class extends y{constructor(A,F,M,V,x,q,X){super(A.userDataSyncStore?.url,F,M,V,x,q,X),this._register(A.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(A.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=f=pe([G(0,p.IUserDataSyncStoreManagementService),G(1,a.IProductService),G(2,u.IRequestService),G(3,p.IUserDataSyncLogService),G(4,g.IEnvironmentService),G(5,w.IFileService),G(6,E.IStorageService)],f);class l{constructor(A,F,M,V){this.limit=A,this.interval=F,this.requestService=M,this.logService=V,this.requests=[],this.startTime=void 0}request(A,F,M){if(this.isExpired()&&this.reset(),F.url=A,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new p.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,A,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(A),this.requestService.request(F,M)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=l}),define(ae[253],ce([0,1,3,54,24,19,20,248,23,77,80]),function(ne,e,R,N,L,T,_,D,b,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=e.UserDataAutoSyncService=class extends D.UserDataAutoSyncService{constructor(d,g,w,a,u,h,E,p,k,n,r){super(d,g,w,a,u,E,p,k,n,r),this._register(R.Event.debounce(R.Event.any(R.Event.map(h.onDidFocusWindow,()=>"windowFocus"),R.Event.map(h.onDidOpenWindow,()=>"windowOpen")),(i,t)=>i?[...i,t]:[t],1e3)(i=>this.triggerSync(i,!0,!1)))}};e.UserDataAutoSyncService=C=pe([G(0,L.IProductService),G(1,b.IUserDataSyncStoreManagementService),G(2,b.IUserDataSyncStoreService),G(3,b.IUserDataSyncEnablementService),G(4,b.IUserDataSyncService),G(5,N.INativeHostService),G(6,b.IUserDataSyncLogService),G(7,S.IUserDataSyncAccountService),G(8,_.ITelemetryService),G(9,P.IUserDataSyncMachinesService),G(10,T.IStorageService)],C)}),define(ae[254],ce([0,1,69,25,5,22]),function(ne,e,R,N,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function _(S){function P(){let C=S.scheme===N.Schemas.file?(0,T.originalFSPath)(S):S.toString();return L.isLinux||(C=C.toLowerCase()),(0,R.createHash)("md5").update(C).digest("hex")}return{id:P(),configPath:S}}e.getWorkspaceIdentifier=_;function D(S,P){function C(){if(S.scheme!==N.Schemas.file)return(0,R.createHash)("md5").update(S.toString()).digest("hex");if(!P)return;let d;return L.isLinux?d=P.ino:L.isMacintosh?d=P.birthtime.getTime():L.isWindows&&(typeof P.birthtimeMs=="number"?d=Math.floor(P.birthtimeMs):d=P.birthtime.getTime()),(0,R.createHash)("md5").update(S.fsPath).update(d?String(d):"").digest("hex")}const v=C();if(typeof v=="string")return{id:v,uri:S}}e.getSingleFolderWorkspaceIdentifier=D;function b(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=b}),define(ae[255],ce([0,1,6,7,2,15,30,14,8,75,112,254,54,71]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let g=e.UnusedWorkspaceStorageDataCleaner=class extends L.Disposable{constructor(a,u,h,E){super(),this.environmentService=a,this.logService=u,this.nativeHostService=h,this.mainProcessService=E,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const a=await _.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),u=new S.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(a.map(async h=>{const E=(0,T.join)(this.environmentService.workspaceStorageHome.fsPath,h);h.length===C.NON_EMPTY_WORKSPACE_ID_LENGTH||h===P.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(n=>n.workspace?.id===h)||await u.isUsed(E)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${h} as it seems to be an unused empty workspace.`),await _.Promises.rm(E))}))}catch(a){(0,N.onUnexpectedError)(a)}}};e.UnusedWorkspaceStorageDataCleaner=g=pe([G(0,D.INativeEnvironmentService),G(1,b.ILogService),G(2,v.INativeHostService),G(3,d.IMainProcessService)],g)}),define(ae[81],ce([0,1,51,6,15,10,30,141,265,266]),function(ne,e,R,N,L,T,_,D,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const P=new RegExp(e.CorruptZipMessage);class C extends Error{constructor(r,i){let t=i.message;switch(r){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=r,this.cause=i}}e.ExtractError=C;function v(n){const r=n.externalFileAttributes>>16||33188;return[448,56,7].map(i=>r&i).reduce((i,t)=>i+t,r&61440)}function d(n){if(n instanceof C)return n;let r;return P.test(n.message)&&(r="CorruptZip"),new C(r,n)}function g(n,r,i,t,s,o){const c=L.dirname(r),y=L.join(t,c);if(!y.startsWith(t))return Promise.reject(new Error(D.localize(0,null,r)));const f=L.join(t,r);let l;return o.onCancellationRequested(()=>{l?.destroy()}),Promise.resolve(_.Promises.mkdir(y,{recursive:!0})).then(()=>new Promise((I,A)=>{if(!o.isCancellationRequested)try{l=(0,R.createWriteStream)(f,{mode:i}),l.once("close",()=>I()),l.once("error",A),n.once("error",A),n.pipe(l)}catch(F){A(F)}}))}function w(n,r,i,t){let s=(0,N.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{s.cancel(),n.close()}),new Promise((c,y)=>{const f=new N.Sequencer,l=I=>{I.isCancellationRequested||(o++,n.readEntry())};n.once("error",y),n.once("close",()=>s.then(()=>{t.isCancellationRequested||n.entryCount===o?c():y(new C("Incomplete",new Error(D.localize(1,null,o,n.entryCount))))},y)),n.readEntry(),n.on("entry",I=>{if(t.isCancellationRequested)return;if(!i.sourcePathRegex.test(I.fileName)){l(t);return}const A=I.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(A)){const V=L.join(r,A);s=(0,N.createCancelablePromise)(x=>_.Promises.mkdir(V,{recursive:!0}).then(()=>l(x)).then(void 0,y));return}const F=u(n,I),M=v(I);s=(0,N.createCancelablePromise)(V=>f.queue(()=>F.then(x=>g(x,A,M,r,i,V).then(()=>l(V)))).then(null,y))})})}function a(n,r=!1){return new Promise((i,t)=>{(0,b.open)(n,r?{lazyEntries:!0}:void 0,(s,o)=>{s?t(d(s)):i((0,T.assertIsDefined)(o))})})}function u(n,r){return new Promise((i,t)=>{n.openReadStream(r,(s,o)=>{s?t(d(s)):i((0,T.assertIsDefined)(o))})})}function h(n,r){return new Promise((i,t)=>{const s=new S.ZipFile;r.forEach(c=>{c.contents?s.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&s.addFile(c.localPath,c.path)}),s.end();const o=(0,R.createWriteStream)(n);s.outputStream.pipe(o),s.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>i(n))})}e.zip=h;function E(n,r,i={},t){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let o=a(n,!0);return i.overwrite&&(o=o.then(c=>_.Promises.rm(r).then(()=>c))),o.then(c=>w(c,r,{sourcePathRegex:s},t))}e.extract=E;function p(n,r){return a(n).then(i=>new Promise((t,s)=>{i.on("entry",o=>{o.fileName===r&&u(i,o).then(c=>t(c),c=>s(c))}),i.once("close",()=>s(new Error(D.localize(2,null,r))))}))}function k(n,r){return p(n,r).then(i=>new Promise((t,s)=>{const o=[];i.once("error",s),i.on("data",c=>o.push(c)),i.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=k}),define(ae[256],ce([0,1,6,7,2,25,5,22,52,10,32,30,81,18,14,28,33,97,13,8]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let p=e.ExtensionsDownloader=class gt extends L.Disposable{constructor(n,r,i,t,s,o){super(),this.fileService=r,this.extensionGalleryService=i,this.configurationService=t,this.extensionSignatureVerificationService=s,this.logService=o,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(n,r,i){await this.cleanUpPromise;const t=(0,D.joinPath)(this.extensionsDownloadDir,this.getName(n));try{await this.downloadFile(n,t,o=>this.extensionGalleryService.download(n,o,r))}catch(o){throw new w.ExtensionManagementError(o.message,w.ExtensionManagementErrorCode.Download)}let s=!1;if(i&&this.shouldVerifySignature(n)){const o=await this.downloadSignatureArchive(n);try{s=await this.extensionSignatureVerificationService.verify(t.fsPath,o.fsPath,this.logService.getLevel()===E.LogLevel.Trace)}catch(c){const y=c;if(s=y.code,y.output&&this.logService.trace(`Extension signature verification details for ${n.identifier.id} ${n.version}:
${y.output}`),s===w.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===w.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new w.ExtensionManagementError(v.CorruptZipMessage,w.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(o)}catch(c){this.logService.error(c)}}}return s===!0?this.logService.info(`Extension signature is verified: ${n.identifier.id}`):s===!1?this.logService.info(`Extension signature verification is not done: ${n.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${s}': ${n.identifier.id}`),{location:t,verificationStatus:s}}shouldVerifySignature(n){if(!n.isSigned)return!1;const r=this.configurationService.getValue("extensions.verifySignature");return(0,S.isBoolean)(r)?r:!0}async downloadSignatureArchive(n){await this.cleanUpPromise;const r=(0,D.joinPath)(this.extensionsDownloadDir,`${this.getName(n)}${gt.SignatureArchiveExtension}`);return await this.downloadFile(n,r,i=>this.extensionGalleryService.downloadSignatureArchive(n,i)),r}async downloadFile(n,r,i){if(await this.fileService.exists(r))return;if(r.scheme!==T.Schemas.file){await i(r);return}const t=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.fileService.exists(t)||await i(t);try{await this.rename(t,r,Date.now()+2*60*1e3)}catch(s){try{await this.fileService.del(t)}catch{}if(s.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,r.path);else throw this.logService.info(`Rename failed because of ${(0,N.getErrorMessage)(s)}. Deleted the file from downloaded location`,t.path),s}}async delete(n){await this.cleanUpPromise,await this.fileService.del(n)}async rename(n,r,i){try{await C.Promises.rename(n.fsPath,r.fsPath)}catch(t){if(_.isWindows&&t&&t.code==="EPERM"&&Date.now()<i)return this.logService.info(`Failed renaming ${n} to ${r} with 'EPERM' error. Trying again...`),this.rename(n,r,i);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const r=[],i=[],t=[];for(const c of n.children)if(c.name.endsWith(gt.SignatureArchiveExtension))t.push(c.resource);else{const y=a.ExtensionKey.parse(c.name);y&&i.push([y,c])}const s=(0,a.groupByExtension)(i,([c])=>c),o=[];for(const c of s)c.sort((y,f)=>b.rcompare(y[0].version,f[0].version)),r.push(...c.slice(1).map(y=>y[1].resource)),o.push(c[0][1]);o.sort((c,y)=>c.mtime-y.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(c=>c.resource)),r.push(...t),await R.Promises.settled(r.map(c=>(this.logService.trace("Deleting from cache",c.path),this.fileService.del(c))))}}catch(n){this.logService.error(n)}}getName(n){return this.cache?a.ExtensionKey.create(n).toString().toLowerCase():(0,P.generateUuid)()}};p.SignatureArchiveExtension=".sigzip",e.ExtensionsDownloader=p=pe([G(0,g.INativeEnvironmentService),G(1,h.IFileService),G(2,w.IExtensionGalleryService),G(3,d.IConfigurationService),G(4,u.IExtensionSignatureVerificationService),G(5,E.ILogService)],p)}),define(ae[257],ce([0,1,81,150]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(T){return(0,R.buffer)(T,"extension/package.json").then(_=>{try{return JSON.parse(_.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.getManifest=L}),define(ae[121],ce([0,1,6,16,26,38,7,3,2,35,25,15,5,22,52,10,12,32,30,81,149,96,14,236,28,33,50,78,256,237,257,205,216,67,13,4,8,24,20,29,17]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u,h,E,p,k,n,r,i,t,s,o,c,y,f,l,I,A,F,M,V,x,q,X,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,M.refineServiceDecorator)(i.IExtensionManagementService);let Y=e.ExtensionManagementService=class extends r.AbstractExtensionManagementService{constructor(K,Q,O,m,U,W,J,$,H,te,oe,ue){super(K,Q,O,te,ue),this.extensionsScannerService=U,this.extensionsProfileScannerService=W,this.downloadService=J,this.fileService=H,this.uriIdentityService=oe,this._onDidUpdateExtensionMetadata=this._register(new D.Emitter),this.onDidUpdateExtensionMetadata=this._onDidUpdateExtensionMetadata.event,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new S.ResourceSet;const de=this._register($.createInstance(y.ExtensionsLifecycle));this.extensionsScanner=this._register($.createInstance(Z,Ee=>de.postUninstall(Ee))),this.manifestCache=this._register(new l.ExtensionsManifestCache(ue,H,oe,this,this.logService)),this.extensionsDownloader=this._register($.createInstance(c.ExtensionsDownloader));const ve=this._register(new I.ExtensionsWatcher(this,this.extensionsScannerService,ue,W,oe,H,O));this._register(ve.onDidChangeExtensionsByAnotherSource(Ee=>this.onDidChangeExtensionsFromAnotherSource(Ee))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,t.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(K){this.logService.trace("ExtensionManagementService#zip",K.identifier.id);const Q=await this.collectFiles(K),O=await(0,E.zip)((0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,Q);return a.URI.file(O)}async unzip(K){return this.logService.trace("ExtensionManagementService#unzip",K.toString()),(await this.install(K)).identifier}async getManifest(K){const{location:Q,cleanup:O}=await this.downloadVsix(K),m=C.resolve(Q.fsPath);try{return await(0,f.getManifest)(m)}finally{await O()}}getInstalled(K,Q=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(K??null,Q)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(K){return this.extensionsScanner.scanUserExtensionAtLocation(K)}async install(K,Q={}){this.logService.trace("ExtensionManagementService#install",K.toString());const{location:O,cleanup:m}=await this.downloadVsix(K);try{const U=await(0,f.getManifest)(C.resolve(O.fsPath)),W=(0,t.getGalleryExtensionId)(U.publisher,U.name);if(U.engines&&U.engines.vscode&&!(0,A.isEngineValid)(U.engines.vscode,this.productService.version,this.productService.date))throw new Error(p.localize(0,null,W,this.productService.version));const J=await this.installExtensions([{manifest:U,extension:O,options:Q}]);if(J[0]?.local)return J[0]?.local;throw J[0]?.error?J[0].error:(0,r.toExtensionManagementError)(new Error(`Unknown error while installing extension ${W}`))}finally{await m()}}async installFromLocation(K,Q){this.logService.trace("ExtensionManagementService#installFromLocation",K.toString());const O=await this.extensionsScanner.scanUserExtensionAtLocation(K);if(!O)throw new Error(`Cannot find a valid extension from the location ${K.toString()}`);return await this.addExtensionsToProfile([[O,void 0]],Q),this.logService.info("Successfully installed extension",O.identifier.id,Q.toString()),O}async installExtensionsFromProfile(K,Q,O){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",K,Q.toString(),O.toString());const m=(await this.extensionsScanner.scanExtensions(1,Q)).filter(U=>K.some(W=>(0,t.areSameExtensions)(W,U.identifier)));if(m.length){const U=await Promise.all(m.map(W=>this.extensionsScanner.scanMetadata(W,Q)));await this.addExtensionsToProfile(m.map((W,J)=>[W,U[J]]),O),this.logService.info("Successfully installed extensions",m.map(W=>W.identifier.id),O.toString())}return m}async updateMetadata(K,Q,O=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",K.identifier.id),Q.isPreReleaseVersion&&(Q.preRelease=!0),Q.isMachineScoped=Q.isMachineScoped||void 0,Q.isBuiltin=Q.isBuiltin||void 0,Q.pinned=Q.pinned||void 0,K=await this.extensionsScanner.updateMetadata(K,Q,O),this.manifestCache.invalidate(O),this._onDidUpdateExtensionMetadata.fire(K),K}async reinstallFromGallery(K){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",K.identifier.id),!this.galleryService.isEnabled())throw new Error(p.localize(1,null));const Q=await this.getTargetPlatform(),[O]=await this.galleryService.getExtensions([{...K.identifier,preRelease:K.preRelease}],{targetPlatform:Q,compatible:!0},L.CancellationToken.None);if(!O)throw new Error(p.localize(2,null));await this.extensionsScanner.setUninstalled(K);try{await this.extensionsScanner.removeUninstalledExtension(K)}catch(m){throw new Error(p.localize(3,null,(0,T.toErrorMessage)(m)))}return this.installFromGallery(O)}copyExtensions(K,Q){return this.extensionsScanner.copyExtensions(K,Q)}markAsUninstalled(...K){return this.extensionsScanner.setUninstalled(...K)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(K){this.logService.error(K)}}async download(K,Q,O){const{location:m}=await this.extensionsDownloader.download(K,Q,!O);return m}async downloadVsix(K){if(K.scheme===P.Schemas.file)return{location:K,async cleanup(){}};this.logService.trace("Downloading extension from",K.toString());const Q=(0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,u.generateUuid)());return await this.downloadService.download(K,Q),this.logService.info("Downloaded extension to",Q.toString()),{location:Q,cleanup:async()=>{try{await this.fileService.del(Q)}catch(m){this.logService.error(m)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(K,Q,O){if(a.URI.isUri(Q))return new z(K,Q,O,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const m=t.ExtensionKey.create(Q).toString();let U=this.installGalleryExtensionsTasks.get(m);return U||(this.installGalleryExtensionsTasks.set(m,U=new B(K,Q,O,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),U.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(m))),U}createUninstallExtensionTask(K,Q){return new ie(K,Q.profileLocation,this.extensionsProfileScannerService)}async collectFiles(K){const Q=async m=>{let U=await h.Promises.readdir(m);U=U.map($=>C.join(m,$));const W=await Promise.all(U.map($=>h.Promises.stat($)));let J=Promise.resolve([]);return W.forEach(($,H)=>{const te=U[H];$.isFile()&&(J=J.then(oe=>[...oe,te])),$.isDirectory()&&(J=J.then(oe=>Q(te).then(ue=>[...oe,...ue])))}),J};return(await Q(K.location.fsPath)).map(m=>({path:`extension/${C.relative(K.location.fsPath,m)}`,localPath:m}))}async onDidChangeExtensionsFromAnotherSource({added:K,removed:Q}){if(Q)for(const O of Q.extensions)this.logService.info("Extensions removed from another source",O.id,Q.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:O,profileLocation:Q.profileLocation});if(K){const m=(await this.extensionsScanner.scanExtensions(1,K.profileLocation)).filter(U=>K.extensions.some(W=>(0,t.areSameExtensions)(W,U.identifier)));this._onDidInstallExtensions.fire(m.map(U=>(this.logService.info("Extensions added from another source",U.identifier.id,K.profileLocation.toString()),{identifier:U.identifier,local:U,profileLocation:K.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(Q=>this.knownDirectories.add(Q)));const K=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const Q of K.children??[])Q.isDirectory&&this.knownDirectories.add(Q.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(Q=>this.onDidFilesChange(Q)))}async onDidFilesChange(K){if(!K.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const Q=[];for(const O of K.rawAdded){if(this.knownDirectories.has(O)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(O),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(O,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(O).startsWith(".")||!(await this.fileService.stat(O)).isDirectory)continue;const m=await this.extensionsScanner.scanUserExtensionAtLocation(O);m&&m.installedTimestamp===void 0&&(this.knownDirectories.add(O),Q.push(m))}Q.length&&(await this.addExtensionsToProfile(Q.map(O=>[O,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",Q.map(O=>O.identifier.id)))}async addExtensionsToProfile(K,Q){const O=K.map(m=>m[0]);await this.setInstalled(O),await this.extensionsProfileScannerService.addExtensionsToProfile(K,Q),this._onDidInstallExtensions.fire(O.map(m=>({local:m,identifier:m.identifier,operation:1,profileLocation:Q})))}async setInstalled(K){const Q=await this.extensionsScanner.getUninstalledExtensions();for(const O of K){const m=t.ExtensionKey.create(O);Q[m.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",m.id),await this.extensionsScanner.setInstalled(m),this.logService.info("Removed the extension from uninstalled list:",m.id))}}};e.ExtensionManagementService=Y=pe([G(0,i.IExtensionGalleryService),G(1,q.ITelemetryService),G(2,V.ILogService),G(3,n.INativeEnvironmentService),G(4,o.IExtensionsScannerService),G(5,s.IExtensionsProfileScannerService),G(6,k.IDownloadService),G(7,M.IInstantiationService),G(8,F.IFileService),G(9,x.IProductService),G(10,X.IUriIdentityService),G(11,ee.IUserDataProfilesService)],Y);let Z=e.ExtensionsScanner=class extends b.Disposable{constructor(K,Q,O,m,U,W){super(),this.beforeRemovingExtension=K,this.fileService=Q,this.extensionsScannerService=O,this.extensionsProfileScannerService=m,this.uriIdentityService=U,this.logService=W,this._onExtract=this._register(new D.Emitter),this.onExtract=this._onExtract.event,this.cleanUpGeneratedFoldersPromise=Promise.resolve(),this.uninstalledResource=(0,d.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),this.cleanUpGeneratedFoldersPromise=this.cleanUpGeneratedFoldersPromise.then(()=>this.removeGeneratedFolders()),await this.cleanUpGeneratedFoldersPromise}async scanExtensions(K,Q){const O={includeInvalid:!0,profileLocation:Q};let m=[];return K===null||K===0?m.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},O,!1)):K===1&&m.push(...await this.extensionsScannerService.scanUserExtensions(O)),m=K!==null?m.filter(U=>U.type===K):m,Promise.all(m.map(U=>this.toLocalExtension(U)))}async scanAllUserExtensions(K){const Q=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!K,includeInvalid:!0});return Promise.all(Q.map(O=>this.toLocalExtension(O)))}async scanUserExtensionAtLocation(K){try{const Q=await this.extensionsScannerService.scanExistingExtension(K,1,{includeInvalid:!0});if(Q)return await this.toLocalExtension(Q)}catch(Q){this.logService.error(Q)}return null}async extractUserExtension(K,Q,O,m,U){await this.cleanUpGeneratedFoldersPromise.catch(()=>{});const W=K.toString(),J=C.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),$=C.join(this.extensionsScannerService.userExtensionsLocation.fsPath,W);let H=await this.fileService.exists(a.URI.file($));if(H&&m){try{await h.Promises.rm($)}catch{throw new i.ExtensionManagementError(p.localize(4,null,$,K.id),i.ExtensionManagementErrorCode.Delete)}H=!1}if(!H){await this.extractAtLocation(K,Q,J,U),await this.extensionsScannerService.updateMetadata(a.URI.file(J),O);try{this._onExtract.fire(a.URI.file($)),await this.rename(K,J,$,Date.now()+2*60*1e3),this.logService.info("Renamed to",$)}catch(te){try{await h.Promises.rm(J)}catch{}if(te.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",K.id);else throw this.logService.info(`Rename failed because of ${(0,_.getErrorMessage)(te)}. Deleted from extracted location`,J),te}}return this.scanLocalExtension(a.URI.file($),1)}async scanMetadata(K,Q){return Q?(await this.extensionsProfileScannerService.scanProfileExtensions(Q)).find(m=>(0,t.areSameExtensions)(m.identifier,K.identifier))?.metadata:this.extensionsScannerService.scanMetadata(K.location)}async updateMetadata(K,Q,O){return O?await this.extensionsProfileScannerService.updateMetadata([[K,Q]],O):await this.extensionsScannerService.updateMetadata(K.location,Q),this.scanLocalExtension(K.location,K.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...K){const Q=K.map(O=>t.ExtensionKey.create(O));await this.withUninstalledExtensions(O=>Q.forEach(m=>{O[m.toString()]=!0,this.logService.info("Marked extension as uninstalled",m.toString())}))}async setInstalled(K){await this.withUninstalledExtensions(Q=>delete Q[K.toString()])}async removeExtension(K,Q){this.logService.trace(`Deleting ${Q} extension from disk`,K.identifier.id,K.location.fsPath);const O=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(K.location),`._${(0,u.generateUuid)()}`);await this.rename(K.identifier,K.location.fsPath,O.fsPath,Date.now()+2*60*1e3),await this.fileService.del(O,{recursive:!0}),this.logService.info("Deleted from disk",K.identifier.id,K.location.fsPath)}async removeUninstalledExtension(K){await this.removeExtension(K,"uninstalled"),await this.withUninstalledExtensions(Q=>delete Q[t.ExtensionKey.create(K).toString()])}async copyExtensions(K,Q){const O=await this.scanExtensions(1,K),m=await Promise.all(O.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,K)]));await this.extensionsProfileScannerService.addExtensionsToProfile(m,Q)}async withUninstalledExtensions(K){return this.uninstalledFileLimiter.queue(async()=>{let Q;try{Q=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(m){if((0,F.toFileOperationResult)(m)!==1)throw m}let O={};if(Q)try{O=JSON.parse(Q)}catch{}return K&&(K(O),Object.keys(O).length?await this.fileService.writeFile(this.uninstalledResource,N.VSBuffer.fromString(JSON.stringify(O))):await this.fileService.del(this.uninstalledResource)),O})}async extractAtLocation(K,Q,O,m){this.logService.trace(`Started extracting the extension from ${Q} to ${O}`);try{await h.Promises.rm(O)}catch(U){throw new i.ExtensionManagementError(this.joinErrors(U).message,i.ExtensionManagementErrorCode.Delete)}try{await(0,E.extract)(Q,O,{sourcePath:"extension",overwrite:!0},m),this.logService.info(`Extracted extension to ${O}:`,K.id)}catch(U){try{await h.Promises.rm(O)}catch{}let W=i.ExtensionManagementErrorCode.Extract;throw U instanceof E.ExtractError&&(U.type==="CorruptZip"?W=i.ExtensionManagementErrorCode.CorruptZip:U.type==="Incomplete"&&(W=i.ExtensionManagementErrorCode.IncompleteZip)),new i.ExtensionManagementError(U.message,W)}}async rename(K,Q,O,m){try{await h.Promises.rename(Q,O)}catch(U){if(v.isWindows&&U&&U.code==="EPERM"&&Date.now()<m)return this.logService.info(`Failed renaming ${Q} to ${O} with 'EPERM' error. Trying again...`,K.id),this.rename(K,Q,O,m);throw new i.ExtensionManagementError(U.message||p.localize(5,null,Q,O),U.code||i.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(K,Q){const O=await this.extensionsScannerService.scanExistingExtension(K,Q,{includeInvalid:!0});if(O)return this.toLocalExtension(O);throw new Error(p.localize(6,null,K.path))}async toLocalExtension(K){const Q=await this.fileService.resolve(K.location);let O,m;return Q.children&&(O=Q.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,m=Q.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:K.identifier,type:K.type,isBuiltin:K.isBuiltin||!!K.metadata?.isBuiltin,location:K.location,manifest:K.manifest,targetPlatform:K.targetPlatform,validations:K.validations,isValid:K.isValid,readmeUrl:O,changelogUrl:m,publisherDisplayName:K.metadata?.publisherDisplayName||null,publisherId:K.metadata?.publisherId||null,isApplicationScoped:!!K.metadata?.isApplicationScoped,isMachineScoped:!!K.metadata?.isMachineScoped,isPreReleaseVersion:!!K.metadata?.isPreReleaseVersion,preRelease:!!K.metadata?.preRelease,installedTimestamp:K.metadata?.installedTimestamp,updated:!!K.metadata?.updated,pinned:!!K.metadata?.pinned}}async removeUninstalledExtensions(){const K=await this.getUninstalledExtensions();if(Object.keys(K).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(K));const Q=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const U of Q)K[t.ExtensionKey.create(U).toString()]||O.add(U.identifier.id.toLowerCase());try{const U=(0,t.groupByExtension)(Q,W=>W.identifier);await R.Promises.settled(U.map(async W=>{const J=W.sort(($,H)=>g.rcompare($.manifest.version,H.manifest.version))[0];O.has(J.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(J))}))}catch(U){this.logService.error(U)}const m=Q.filter(U=>U.metadata&&K[t.ExtensionKey.create(U).toString()]);await Promise.allSettled(m.map(U=>this.removeUninstalledExtension(U)))}async removeGeneratedFolders(){this.logService.trace("ExtensionManagementService#removeGeneratedFolders");const K=[];let Q;try{Q=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(O){(0,F.toFileOperationResult)(O)!==1&&this.logService.error(O)}for(const O of Q?.children??[])O.isDirectory&&O.name.startsWith("._")&&(0,u.isUUID)(O.name.substring(2))&&K.push((async()=>{this.logService.trace("Deleting the generated extension folder",O.resource.toString());try{await this.fileService.del(O.resource,{recursive:!0}),this.logService.info("Deleted the generated extension folder",O.resource.toString())}catch(m){this.logService.error(m)}})());await Promise.allSettled(K)}joinErrors(K){const Q=Array.isArray(K)?K:[K];return Q.length===1?Q[0]instanceof Error?Q[0]:new Error(Q[0]):Q.reduce((O,m)=>new Error(`${O.message}${O.message?",":""}${m instanceof Error?m.message:m}`),new Error(""))}};e.ExtensionsScanner=Z=pe([G(1,F.IFileService),G(2,o.IExtensionsScannerService),G(3,s.IExtensionsProfileScannerService),G(4,X.IUriIdentityService),G(5,V.ILogService)],Z);class j extends r.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,w.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(K,Q,O,m,U,W,J,$,H){super(),this.identifier=K,this.source=Q,this.options=O,this.extensionsScanner=m,this.uriIdentityService=U,this.userDataProfilesService=W,this.extensionsScannerService=J,this.extensionsProfileScannerService=$,this.logService=H,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(K){const[Q,O]=await this.install(K);return this._profileLocation=Q.isBuiltin||Q.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[Q,O]],this._profileLocation),Q}async extractExtension({zipPath:K,key:Q,metadata:O},m,U){let W=await this.unsetIfUninstalled(Q);return W||(this.logService.trace("Extracting extension...",Q.id),W=await this.extensionsScanner.extractUserExtension(Q,K,O,m,U),this.logService.info("Extracting extension completed.",Q.id)),W}async unsetIfUninstalled(K){return await this.isUninstalled(K)?(this.logService.trace("Removing the extension from uninstalled list:",K.id),await this.extensionsScanner.setInstalled(K),this.logService.info("Removed the extension from uninstalled list:",K.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(m=>t.ExtensionKey.create(m).equals(K))):void 0}async isUninstalled(K){return!!(await this.extensionsScanner.getUninstalledExtensions())[K.toString()]}}class B extends j{constructor(K,Q,O,m,U,W,J,$,H,te){super(Q.identifier,Q,O,U,W,J,$,H,te),this.gallery=Q,this.extensionsDownloader=m}async install(K){const O=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(J=>(0,t.areSameExtensions)(J.identifier,this.gallery.identifier));O&&(this._operation=3);const m={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||O?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,w.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:O?.preRelease)};if(O?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata(O,m),m];const{location:U,verificationStatus:W}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=W,this.validateManifest(U.fsPath),[await this.extractExtension({zipPath:U.fsPath,key:t.ExtensionKey.create(this.gallery),metadata:m},!1,K),m]}catch(J){try{await this.extensionsDownloader.delete(U)}catch($){this.logService.warn("Error while deleting the downloaded file",U.toString(),(0,_.getErrorMessage)($))}throw J}}async validateManifest(K){try{await(0,f.getManifest)(K)}catch(Q){throw new i.ExtensionManagementError((0,r.joinErrors)(Q).message,i.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=B;class z extends j{constructor(K,Q,O,m,U,W,J,$,H,te){super({id:(0,t.getGalleryExtensionId)(K.publisher,K.name)},Q,O,U,W,J,$,H,te),this.manifest=K,this.location=Q,this.galleryService=m}async doRun(K){const Q=await super.doRun(K);return this.updateMetadata(Q,K),Q}async install(K){const Q=new t.ExtensionKey(this.identifier,this.manifest.version),m=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(J=>(0,t.areSameExtensions)(this.identifier,J.identifier)),U={isApplicationScoped:this.options.isApplicationScoped||m?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||m?.isMachineScoped,isBuiltin:this.options.isBuiltin||m?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(m)if(this._operation=3,Q.equals(new t.ExtensionKey(m.identifier,m.manifest.version)))try{await this.extensionsScanner.removeExtension(m,"existing")}catch{throw new Error(p.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&g.gt(m.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(m);else{const J=await this.unsetIfUninstalled(Q);if(J)try{await this.extensionsScanner.removeExtension(J,"existing")}catch{throw new Error(p.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:C.resolve(this.location.fsPath),key:Q,metadata:U},!0,K),U]}async updateMetadata(K,Q){try{let[O]=await this.galleryService.getExtensions([{id:K.identifier.id,version:K.manifest.version}],Q);if(O||([O]=await this.galleryService.getExtensions([{id:K.identifier.id}],Q)),O){const m={id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId,isPreReleaseVersion:O.properties.isPreReleaseVersion,preRelease:O.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(K,m,this.options.profileLocation)}}catch{}}}class ie extends r.AbstractExtensionTask{constructor(K,Q,O){super(),this.extension=K,this.profileLocation=Q,this.extensionsProfileScannerService=O}async doRun(K){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(ae[258],ce([0,1,2,28,79,215,121,8,19]),function(ne,e,R,N,L,T,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let S=e.ExtensionsContributions=class extends R.Disposable{constructor(C,v,d,g,w,a){super(),C.cleanUp(),(0,T.migrateUnsupportedExtensions)(C,v,d,g,a),L.ExtensionStorageService.removeOutdatedExtensionVersions(C,w)}};e.ExtensionsContributions=S=pe([G(0,_.INativeServerExtensionManagementService),G(1,N.IExtensionGalleryService),G(2,L.IExtensionStorageService),G(3,N.IGlobalExtensionEnablementService),G(4,b.IStorageService),G(5,D.ILogService)],S)}),define(ae[259],ce([0,1,69,62,36,267,16,7,3,2,15,5,32,43,92]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{traceSocketEvent(l,I){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,I)}constructor(l,I=""){this._canWrite=!0,this.debugLabel=I,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,D.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener),this._closeListener=A=>{this.traceSocketEvent("close",{hadError:A}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(l){const I=A=>{this.traceSocketEvent("read",A),l(_.VSBuffer.wrap(A))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(l){const I=A=>{l({type:0,hadError:A,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(l){const I=()=>{l()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(l){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,D.onUnexpectedError)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,D.onUnexpectedError)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=w;var a;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize",f[f.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(a||(a={}));var u;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(u||(u={}));class h extends S.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(l,I){this.socket.traceSocketEvent(l,I)}constructor(l,I,A,F){super(),this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:A?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new E(this,I,A,F,this._onData,(M,V)=>this._write(M,V))),this._register(this._flowManager.onError(M=>{console.error(M),(0,D.onUnexpectedError)(M),this._onClose.fire({type:0,hadError:!0,error:M})})),this._incomingData=new g.ChunkStream,this._register(this.socket.onData(M=>this._acceptChunk(M))),this._register(this.socket.onClose(async M=>{this._flowManager.isProcessingReadQueue()&&await b.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(M)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){let I=0;for(;I<l.byteLength;)this._flowManager.writeMessage(l.slice(I,Math.min(I+262144,l.byteLength))),I+=262144}_write(l,I){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let A=2;l.byteLength<126?A+=0:l.byteLength<2**16?A+=2:A+=8;const F=_.VSBuffer.alloc(A);if(I?F.writeUInt8(194,0):F.writeUInt8(130,0),l.byteLength<126)F.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){F.writeUInt8(126,1);let M=1;F.writeUInt8(l.byteLength>>>8&255,++M),F.writeUInt8(l.byteLength>>>0&255,++M)}else{F.writeUInt8(127,1);let M=1;F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(l.byteLength>>>24&255,++M),F.writeUInt8(l.byteLength>>>16&255,++M),F.writeUInt8(l.byteLength>>>8&255,++M),F.writeUInt8(l.byteLength>>>0&255,++M)}this.socket.write(_.VSBuffer.concat([F,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const I=this._incomingData.peek(this._state.readLen),A=I.readUInt8(0),F=(A&128)>>>7,M=(A&64)>>>6,V=I.readUInt8(1),x=(V&128)>>>7,q=V&127;this._state.state=2,this._state.readLen=2+(x?4:0)+(q===126?2:0)+(q===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=!!M),this._state.firstFrameOfMessage=!!F,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const I=this._incomingData.read(this._state.readLen),A=I.readUInt8(1),F=(A&128)>>>7;let M=A&127,V=1;M===126?M=I.readUInt8(++V)*2**8+I.readUInt8(++V):M===127&&(M=I.readUInt8(++V)*0+I.readUInt8(++V)*0+I.readUInt8(++V)*0+I.readUInt8(++V)*0+I.readUInt8(++V)*2**24+I.readUInt8(++V)*2**16+I.readUInt8(++V)*2**8+I.readUInt8(++V));let x=0;F&&(x=I.readUInt8(++V)*2**24+I.readUInt8(++V)*2**16+I.readUInt8(++V)*2**8+I.readUInt8(++V)),this._state.state=3,this._state.readLen=M,this._state.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const I=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),n(I,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(I,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await b.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=h;class E extends S.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:_.VSBuffer.alloc(0)}constructor(l,I,A,F,M,V){super(),this._tracer=l,this._onData=M,this._writeFn=V,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new b.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new b.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,I?(this._zlibInflateStream=this._register(new p(this._tracer,F,A,{windowBits:15})),this._zlibDeflateStream=this._register(new k(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(x=>this._onError.fire(x))),this._register(this._zlibDeflateStream.onError(x=>this._onError.fire(x)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(l){this._writeQueue.push(l),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const l=this._writeQueue.shift();if(this._zlibDeflateStream){const I=await this._deflateMessage(this._zlibDeflateStream,l);this._writeFn(I,!0)}else this._writeFn(l,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(l,I){return new Promise((A,F)=>{l.write(I),l.flush(M=>A(M))})}acceptFrame(l,I,A){this._readQueue.push({data:l,isCompressed:I,isLastFrameOfMessage:A}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const l=this._readQueue.shift();if(this._zlibInflateStream&&l.isCompressed){const I=await this._inflateFrame(this._zlibInflateStream,l.data,l.isLastFrameOfMessage);this._onData.fire(I)}else this._onData.fire(l.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(l,I,A){return new Promise((F,M)=>{l.write(I),A&&l.write(_.VSBuffer.fromByteArray([0,0,255,255])),l.flush(V=>F(V))})}}class p extends S.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?_.VSBuffer.concat(this._recordedInflateBytes):_.VSBuffer.alloc(0)}constructor(l,I,A,F){super(),this._tracer=l,this._recordInflateBytes=I,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,T.createInflateRaw)(F),this._zlibInflate.on("error",M=>{this._tracer.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibInflate.on("data",M=>{this._tracer.traceSocketEvent("zlibInflateData",M),this._pendingInflateData.push(_.VSBuffer.wrap(M))}),A&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(l){this._recordInflateBytes&&this._recordedInflateBytes.push(l.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",l),this._zlibInflate.write(l.buffer)}flush(l){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const I=_.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,l(I)})}}class k extends S.Disposable{constructor(l,I){super(),this._tracer=l,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,T.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",A=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this._onError.fire(A)}),this._zlibDeflate.on("data",A=>{this._tracer.traceSocketEvent("zlibDeflateData",A),this._pendingDeflateData.push(_.VSBuffer.wrap(A))})}write(l){this._tracer.traceSocketEvent("zlibDeflateWrite",l.buffer),this._zlibDeflate.write(l.buffer)}flush(l){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let I=_.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,I=I.slice(0,I.byteLength-4),l(I)})}}function n(f,l){if(l===0)return;const I=f.byteLength>>>2;for(let q=0;q<I;q++){const X=f.readUInt32BE(q*4);f.writeUInt32BE(X^l,q*4)}const A=I*4,F=f.byteLength-A,M=l>>>24&255,V=l>>>16&255,x=l>>>8&255;F>=1&&f.writeUInt8(f.readUInt8(A)^M,A),F>=2&&f.writeUInt8(f.readUInt8(A+1)^V,A+1),F>=3&&f.writeUInt8(f.readUInt8(A+2)^x,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function i(){const f=(0,v.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;const l=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,L.tmpdir)(),I=(0,P.join)(l,`vscode-ipc-${f}.sock`);return s(I),I}e.createRandomIPCHandle=i;function t(f,l,I){const A=(0,R.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${I}-${l}-sock`;const F=I.substr(0,4),M=l.substr(0,6),V=A.substr(0,8);let x;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?x=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${V}-${F}-${M}.sock`):x=(0,P.join)(f,`${F}-${M}.sock`),s(x),x}e.createStaticIPCHandle=t;function s(f){const l=r[C.platform];typeof l=="number"&&f.length>=l&&console.warn(`WARNING: IPC handle "${f}" is longer than ${l} chars, try a shorter --user-data-dir`)}class o extends d.IPCServer{static toClientConnectionEvent(l){const I=b.Event.fromNodeEventEmitter(l,"connection");return b.Event.map(I,A=>({protocol:new g.Protocol(new w(A,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(A,"close"))}))}constructor(l){super(o.toClientConnectionEvent(l)),this.server=l}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function c(f){return new Promise((l,I)=>{const A=(0,N.createServer)();A.on("error",I),A.listen(f,()=>{A.removeListener("error",I),l(new o(A))})})}e.serve=c;function y(f,l){return new Promise((I,A)=>{const F=(0,N.createConnection)(f,()=>{F.removeListener("error",A),I(g.Client.fromSocket(new w(F,`ipc-client${l}`),l))});F.once("error",A)})}e.connect=y}),define(ae[260],ce([0,1,62,259,203]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{supports(T){return!0}connect({host:T,port:_},D,b,S){return new Promise((P,C)=>{const v=R.createConnection({host:T,port:_},()=>{v.removeListener("error",C),v.write((0,L.makeRawSocketHeaders)(D,b,S));const d=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(v.off("data",d),P(new N.NodeSocket(v,S)))};v.on("data",d)});v.setNoDelay(!0),v.once("error",C)})}}}),define(ae[268],ce([0,1,36,38,7,2,25,12,43,140,197,198,189,190,255,180,182,18,202,95,213,96,208,14,210,113,240,28,97,181,121,98,13,192,193,68,4,188,70,72,218,8,194,102,24,56,19,107,20,108,109,110,45,221,79,111,23,77,246,232,233,80,247,250,251,252,58,245,234,106,212,76,223,207,222,29,224,5,225,183,200,199,78,239,17,50,196,55,244,220,235,105,249,258,9,195,101,242,238,209,177,54,253,241,71,243,104,260]),function(ne,e,R,N,L,T,_,D,b,S,P,C,v,d,g,w,a,u,h,E,p,k,n,r,i,t,s,o,c,y,f,l,I,A,F,M,V,x,q,X,ee,Y,Z,j,B,z,ie,re,K,Q,O,m,U,W,J,$,H,te,oe,ue,de,ve,Ee,Ce,De,Le,We,Be,le,fe,ge,Pe,Ie,Ne,ke,je,Ue,Me,Fe,_e,se,he,me,Se,ye,be,Re,Ae,ze,Te,$e,xe,Ze,nt,bt,Pt,mt,It,Dt,Rt,kt,Lt,_t,Tt,St,At,vt,Ut){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ot extends T.Disposable{constructor(we){super(),this.configuration=we,this.server=this._register(new S.Server),this.lifecycleService=void 0,this.registerListeners()}registerListeners(){let we=!1;const Oe=()=>{we||(we=!0,this.lifecycleService?.fireOnWillShutdown(),this.dispose())};process.once("exit",Oe),(0,S.once)(process.parentPort,"vscode:electron-main->shared-process=exit",Oe)}async init(){const we=await this.initServices();(0,H.registerConfiguration)(),we.invokeFunction(Oe=>{const Ye=Oe.get(Y.ILogService);Ye.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(Ye)}),this._register((0,T.combinedDisposable)(we.createInstance(P.CodeCacheCleaner,this.configuration.codeCachePath),we.createInstance(C.LanguagePackCachedDataCleaner),we.createInstance(g.UnusedWorkspaceStorageDataCleaner),we.createInstance(d.LogsDataCleaner),we.createInstance(v.LocalizationsUpdater),we.createInstance(nt.ExtensionsContributions),we.createInstance($e.UserDataProfilesCleaner)))}async initServices(){const we=new q.ServiceCollection,Oe={_serviceBrand:void 0,...j.default};we.set(B.IProductService,Oe);const Ye=new b.StaticRouter(Ve=>Ve==="main"),He=new St.MainProcessService(this.server,Ye);we.set(St.IMainProcessService,He);const at=this.configuration.policiesData?new Re.PolicyChannelClient(this.configuration.policiesData,He.getChannel("policy")):new Ae.NullPolicyService;we.set(Ae.IPolicyService,at);const Ge=new i.SharedProcessEnvironmentService(this.configuration.args,Oe);we.set(r.INativeEnvironmentService,Ge);const et=new Z.LoggerChannelClient(void 0,this.configuration.logLevel,Ge.logsHome,this.configuration.loggers.map(Ve=>({...Ve,resource:D.URI.revive(Ve.resource)})),He.getChannel("logger"));we.set(Y.ILoggerService,et);const ct=this._register(et.createLogger("sharedprocess",{name:(0,bt.localize)(0,null)})),ht=this._register(new Y.ConsoleLogger(ct.getLevel())),Ke=this._register(new Pt.LogService(ct,[ht]));we.set(Y.ILogService,Ke),this.lifecycleService=this._register(new mt.SharedProcessLifecycleService(Ke)),we.set(mt.ISharedProcessLifecycleService,this.lifecycleService);const Qe=this._register(new A.FileService(Ke));we.set(I.IFileService,Qe);const dt=this._register(new F.DiskFileSystemProvider(Ke));Qe.registerProvider(_.Schemas.file,dt);const ft=this._register(new Fe.FileUserDataProvider(_.Schemas.file,this._register(new _e.DiskFileSystemProviderClient(He.getChannel(_e.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Me.isLinux})),_.Schemas.vscodeUserData,Ke));Qe.registerProvider(_.Schemas.vscodeUserData,ft);const tt=this._register(new ze.UserDataProfilesService(this.configuration.profiles.all,D.URI.revive(this.configuration.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),He.getChannel("userDataProfiles")));we.set(ye.IUserDataProfilesService,tt);const Xe=this._register(new h.ConfigurationService(tt.defaultProfile.settingsResource,Qe,at,Ke));we.set(u.IConfigurationService,Xe);const st=new At.RemoteStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},He,Ge);we.set(ie.IStorageService,st),this._register((0,T.toDisposable)(()=>st.flush())),await Promise.all([Xe.initialize(),st.initialize()]);const Nt=new Ue.UriIdentityService(Qe);we.set(je.IUriIdentityService,Nt),we.set(z.IRequestService,new Rt.RequestChannelClient(He.getChannel("request"))),we.set(w.IChecksumService,new M.SyncDescriptor(a.ChecksumService,void 0,!1)),we.set(he.IV8InspectProfilingService,new M.SyncDescriptor(se.InspectProfilingService,void 0,!1));const yt=b.ProxyChannel.toService(He.getChannel("nativeHost"));we.set(Lt.INativeHostService,yt),we.set(k.IDownloadService,new M.SyncDescriptor(n.DownloadService,void 0,!0));const Ft=this._register(new le.ActiveWindowManager(yt)),Mt=new b.StaticRouter(Ve=>Ft.getActiveClientId().then(ut=>Ve===ut));we.set(l.IExtensionRecommendationNotificationService,new kt.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Mt)));let lt;const rt=[],Et=(0,U.isInternalTelemetry)(Oe,Xe);if((0,U.supportsTelemetry)(Oe,Ge)){const Ve=new O.TelemetryLogAppender(Ke,et,Ge,Oe);if(rt.push(Ve),Oe.aiConfig?.ariaKey){const ut=new Te.OneDataSystemAppender(Et,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,T.toDisposable)(()=>ut.flush())),rt.push(ut)}lt=new m.TelemetryService({appenders:rt,commonProperties:(0,re.resolveCommonProperties)((0,R.release)(),(0,R.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Et),sendErrorTelemetry:!0,piiPaths:(0,U.getPiiPathsFromEnvironment)(Ge)},Xe,Oe)}else{lt=U.NullTelemetryService;const Ve=U.NullAppender;rt.push(Ve)}this.server.registerChannel("telemetryAppender",new Q.TelemetryAppenderChannel(rt)),we.set(K.ITelemetryService,lt);const $t=new W.CustomEndpointTelemetryService(Xe,lt,Ke,et,Ge,Oe);we.set(K.ICustomEndpointTelemetryService,$t),we.set(be.IExtensionsProfileScannerService,new M.SyncDescriptor(Dt.ExtensionsProfileScannerService,void 0,!0)),we.set(me.IExtensionsScannerService,new M.SyncDescriptor(Se.ExtensionsScannerService,void 0,!0)),we.set(c.IExtensionSignatureVerificationService,new M.SyncDescriptor(c.ExtensionSignatureVerificationService,void 0,!0)),we.set(f.INativeServerExtensionManagementService,new M.SyncDescriptor(f.ExtensionManagementService,void 0,!0)),we.set(o.IExtensionGalleryService,new M.SyncDescriptor(s.ExtensionGalleryService,void 0,!0)),we.set(o.IExtensionTipsService,new M.SyncDescriptor(Tt.ExtensionTipsService,void 0,!1)),we.set(X.ILanguagePackService,new M.SyncDescriptor(ee.NativeLanguagePackService,void 0,!1)),we.set(E.IDiagnosticsService,new M.SyncDescriptor(p.DiagnosticsService,void 0,!1)),we.set(te.IUserDataSyncAccountService,new M.SyncDescriptor(te.UserDataSyncAccountService,void 0,!0)),we.set(H.IUserDataSyncLogService,new M.SyncDescriptor(de.UserDataSyncLogService,void 0,!0)),we.set(H.IUserDataSyncUtilService,new ue.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ve=>Ve.ctx!=="main"))),we.set(o.IGlobalExtensionEnablementService,new M.SyncDescriptor(t.GlobalExtensionEnablementService,void 0,!1)),we.set($.IIgnoredExtensionsManagementService,new M.SyncDescriptor($.IgnoredExtensionsManagementService,void 0,!0)),we.set(J.IExtensionStorageService,new M.SyncDescriptor(J.ExtensionStorageService)),we.set(H.IUserDataSyncStoreManagementService,new M.SyncDescriptor(Le.UserDataSyncStoreManagementService,void 0,!0)),we.set(H.IUserDataSyncStoreService,new M.SyncDescriptor(Le.UserDataSyncStoreService,void 0,!0)),we.set(ve.IUserDataSyncMachinesService,new M.SyncDescriptor(ve.UserDataSyncMachinesService,void 0,!0)),we.set(H.IUserDataSyncBackupStoreService,new M.SyncDescriptor(oe.UserDataSyncBackupStoreService,void 0,!1)),we.set(H.IUserDataSyncEnablementService,new M.SyncDescriptor(Ee.UserDataSyncEnablementService,void 0,!0)),we.set(H.IUserDataSyncService,new M.SyncDescriptor(Ce.UserDataSyncService,void 0,!1)),we.set(We.IUserDataProfileStorageService,new M.SyncDescriptor(Be.NativeUserDataProfileStorageService,void 0,!0)),we.set(H.IUserDataSyncResourceProviderService,new M.SyncDescriptor(Ze.UserDataSyncResourceProviderService,void 0,!0)),we.set(fe.ISignService,new M.SyncDescriptor(ge.SignService,void 0,!1));const wt=new vt.RemoteSocketFactoryService;return we.set(vt.IRemoteSocketFactoryService,wt),wt.register(0,Ut.nodeSocketFactory),we.set(Pe.ISharedTunnelsService,new M.SyncDescriptor(Ie.SharedTunnelsService)),we.set(Ne.ISharedProcessTunnelService,new M.SyncDescriptor(ke.SharedProcessTunnelService)),we.set(xe.IRemoteTunnelService,new M.SyncDescriptor(It.RemoteTunnelService)),new x.InstantiationService(we)}initChannels(we){const Oe=new y.ExtensionManagementChannel(we.get(o.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const Ye=b.ProxyChannel.fromService(we.get(X.ILanguagePackService));this.server.registerChannel("languagePacks",Ye);const He=b.ProxyChannel.fromService(we.get(E.IDiagnosticsService));this.server.registerChannel("diagnostics",He);const at=new y.ExtensionTipsChannel(we.get(o.IExtensionTipsService));this.server.registerChannel("extensionTipsService",at);const Ge=b.ProxyChannel.fromService(we.get(w.IChecksumService));this.server.registerChannel("checksum",Ge);const et=b.ProxyChannel.fromService(we.get(he.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",et);const ct=new ue.UserDataSyncMachinesServiceChannel(we.get(ve.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ct);const ht=b.ProxyChannel.fromService(we.get(K.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",ht);const Ke=new ue.UserDataSyncAccountServiceChannel(we.get(te.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ke);const Qe=new ue.UserDataSyncStoreManagementServiceChannel(we.get(H.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Qe);const dt=new De.UserDataSyncChannel(we.get(H.IUserDataSyncService),we.get(ye.IUserDataProfilesService),we.get(Y.ILogService));this.server.registerChannel("userDataSync",dt);const ft=this._register(we.get(V.IInstantiationService).createInstance(_t.UserDataAutoSyncService)),tt=new ue.UserDataAutoSyncChannel(ft);this.server.registerChannel("userDataAutoSync",tt);const Xe=b.ProxyChannel.fromService(we.get(Ne.ISharedProcessTunnelService));this.server.registerChannel(Ne.ipcSharedProcessTunnelChannelName,Xe);const st=b.ProxyChannel.fromService(we.get(xe.IRemoteTunnelService));this.server.registerChannel("remoteTunnel",st)}registerErrorHandler(we){process.on("uncaughtException",Oe=>(0,L.onUnexpectedError)(Oe)),process.on("unhandledRejection",Oe=>(0,L.onUnexpectedError)(Oe)),(0,L.setUnexpectedErrorHandler)(Oe=>{const Ye=(0,N.toErrorMessage)(Oe,!0);Ye&&we.error(`[uncaught exception in sharedProcess]: ${Ye}`)})}}async function pt(ot){const we=new Ot(ot);process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"),await we.init(),process.parentPort.postMessage("vscode:shared-process->electron-main=init-done")}e.main=pt,process.parentPort.once("message",ot=>{pt(ot.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9d3b0fa210fb4535589e8296483a5b43fe5e660a/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
