/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/event","vs/base/common/lifecycle","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/strings","vs/base/common/platform","vs/base/common/path","vs/base/common/types","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/uuid","vs/base/common/glob","vs/workbench/services/search/common/search","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/process","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","child_process","vs/platform/contextkey/common/contextkey","vs/base/common/iterator","fs","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/marshalling","os","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/common/htmlContent","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/labels","vs/base/common/uriIpc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(re){for(var e=[],v=0,T=re.length;v<T;v++)e[v]=De[re[v]];return e};define(De[65],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function v(R,g){const y=Object.create(null);for(const m of R){const A=g(m);let k=y[A];k||(k=y[A]=[]),k.push(m)}return y}e.groupBy=v;function T(R,g){const y=[],m=[];for(const A of R)g.has(A)||y.push(A);for(const A of g)R.has(A)||m.push(A);return{removed:y,added:m}}e.diffSets=T;function d(R,g){const y=[],m=[];for(const[A,k]of R)g.has(A)||y.push(k);for(const[A,k]of g)R.has(A)||m.push(k);return{removed:y,added:m}}e.diffMaps=d;class L{constructor(){this.map=new Map}add(g,y){let m=this.map.get(g);m||(m=new Set,this.map.set(g,m)),m.add(y)}delete(g,y){const m=this.map.get(g);m&&(m.delete(y),m.size===0&&this.map.delete(g))}forEach(g,y){const m=this.map.get(g);m&&m.forEach(y)}}e.SetMap=L}),define(De[66],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function v(R){return(g,y,m)=>{let A=null,k=null;if(typeof m.value=="function"?(A="value",k=m.value):typeof m.get=="function"&&(A="get",k=m.get),!k)throw new Error("not supported");m[A]=R(k,y)}}function T(R,g,y){let m=null,A=null;if(typeof y.value=="function"?(m="value",A=y.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(m="get",A=y.get),!A)throw new Error("not supported");const k=`$memoize$${g}`;y[m]=function(...w){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,w)}),this[k]}}e.memoize=T;function d(R,g,y){return v((m,A)=>{const k=`$debounce$${A}`,w=`$debounce$result$${A}`;return function(...D){this[w]||(this[w]=y?y():void 0),clearTimeout(this[k]),g&&(this[w]=g(this[w],...D),D=[this[w]]),this[k]=setTimeout(()=>{m.apply(this,D),this[w]=y?y():void 0},R)}})}e.debounce=d;function L(R,g,y){return v((m,A)=>{const k=`$throttle$timer$${A}`,w=`$throttle$result$${A}`,D=`$throttle$lastRun$${A}`,I=`$throttle$pending$${A}`;return function(...E){if(this[w]||(this[w]=y?y():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),g&&(this[w]=g(this[w],...E)),this[I])return;const i=this[D]+R;i<=Date.now()?(this[D]=Date.now(),m.apply(this,[this[w]]),this[w]=y?y():void 0):(this[I]=!0,this[k]=setTimeout(()=>{this[I]=!1,this[D]=Date.now(),m.apply(this,[this[w]]),this[w]=y?y():void 0},i-Date.now()))}})}e.throttle=L}),define(De[8],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?f.isErrorNoTelemetry(o)?new f(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(s=>{s(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=v,e.errorHandler=new v;function T(n){e.errorHandler.setUnexpectedErrorHandler(n)}e.setUnexpectedErrorHandler=T;function d(n){if(!n||typeof n!="object")return!1;const o=n;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=d;function L(n){m(n)||e.errorHandler.onUnexpectedError(n)}e.onUnexpectedError=L;function R(n){m(n)||e.errorHandler.onUnexpectedExternalError(n)}e.onUnexpectedExternalError=R;function g(n){if(n instanceof Error){const{name:o,message:s}=n,t=n.stacktrace||n.stack;return{$isError:!0,name:o,message:s,stack:t,noTelemetry:f.isErrorNoTelemetry(n)}}return n}e.transformErrorForSerialization=g;const y="Canceled";function m(n){return n instanceof A?!0:n instanceof Error&&n.name===y&&n.message===y}e.isCancellationError=m;class A extends Error{constructor(){super(y),this.name=this.message}}e.CancellationError=A;function k(){const n=new Error(y);return n.name=n.message,n}e.canceled=k;function w(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}e.illegalArgument=w;function D(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}e.illegalState=D;function I(n){return n?new Error(`readonly property '${n} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=I;function E(n){const o=new Error(`${n} has been disposed`);return o.name="DISPOSED",o}e.disposed=E;function i(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}e.getErrorMessage=i;class l extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=l;class a extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=a;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class f extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof f)return o;const s=new f;return s.message=o.message,s.stack=o.stack,s}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class _ extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,_.prototype)}}e.BugIndicatingError=_}),define(De[19],Ie([1,0,8]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function T(ee,te=0){return ee[ee.length-(1+te)]}e.tail=T;function d(ee){if(ee.length===0)throw new Error("Invalid tail call");return[ee.slice(0,ee.length-1),ee[ee.length-1]]}e.tail2=d;function L(ee,te,ue=(Q,le)=>Q===le){if(ee===te)return!0;if(!ee||!te||ee.length!==te.length)return!1;for(let Q=0,le=ee.length;Q<le;Q++)if(!ue(ee[Q],te[Q]))return!1;return!0}e.equals=L;function R(ee,te){const ue=ee.length-1;te<ue&&(ee[te]=ee[ue]),ee.pop()}e.removeFastWithoutKeepingOrder=R;function g(ee,te,ue){return y(ee.length,Q=>ue(ee[Q],te))}e.binarySearch=g;function y(ee,te){let ue=0,Q=ee-1;for(;ue<=Q;){const le=(ue+Q)/2|0,se=te(le);if(se<0)ue=le+1;else if(se>0)Q=le-1;else return le}return-(ue+1)}e.binarySearch2=y;function m(ee,te){let ue=0,Q=ee.length;if(Q===0)return 0;for(;ue<Q;){const le=Math.floor((ue+Q)/2);te(ee[le])?Q=le:ue=le+1}return ue}e.findFirstInSorted=m;function A(ee,te,ue){if(ee=ee|0,ee>=te.length)throw new TypeError("invalid index");const Q=te[Math.floor(te.length*Math.random())],le=[],se=[],oe=[];for(const F of te){const j=ue(F,Q);j<0?le.push(F):j>0?se.push(F):oe.push(F)}return ee<le.length?A(ee,le,ue):ee<le.length+oe.length?oe[0]:A(ee-(le.length+oe.length),se,ue)}e.quickSelect=A;function k(ee,te){const ue=[];let Q;for(const le of ee.slice(0).sort(te))!Q||te(Q[0],le)!==0?(Q=[le],ue.push(Q)):Q.push(le);return ue}e.groupBy=k;function w(ee,te,ue){const Q=[];function le(F,j,Y){if(j===0&&Y.length===0)return;const Z=Q[Q.length-1];Z&&Z.start+Z.deleteCount===F?(Z.deleteCount+=j,Z.toInsert.push(...Y)):Q.push({start:F,deleteCount:j,toInsert:Y})}let se=0,oe=0;for(;;){if(se===ee.length){le(se,0,te.slice(oe));break}if(oe===te.length){le(se,ee.length-se,[]);break}const F=ee[se],j=te[oe],Y=ue(F,j);Y===0?(se+=1,oe+=1):Y<0?(le(se,1,[]),se+=1):Y>0&&(le(se,0,[j]),oe+=1)}return Q}e.sortedDiff=w;function D(ee,te,ue){const Q=w(ee,te,ue),le=[],se=[];for(const oe of Q)le.push(...ee.slice(oe.start,oe.start+oe.deleteCount)),se.push(...oe.toInsert);return{removed:le,added:se}}e.delta=D;function I(ee,te,ue){if(ue===0)return[];const Q=ee.slice(0,ue).sort(te);return i(ee,te,Q,ue,ee.length),Q}e.top=I;function E(ee,te,ue,Q,le){return ue===0?Promise.resolve([]):new Promise((se,oe)=>{(async()=>{const F=ee.length,j=ee.slice(0,ue).sort(te);for(let Y=ue,Z=Math.min(ue+Q,F);Y<F;Y=Z,Z=Math.min(Z+Q,F)){if(Y>ue&&await new Promise(me=>setTimeout(me)),le&&le.isCancellationRequested)throw new v.CancellationError;i(ee,te,j,Y,Z)}return j})().then(se,oe)})}e.topAsync=E;function i(ee,te,ue,Q,le){for(const se=ue.length;Q<le;Q++){const oe=ee[Q];if(te(oe,ue[se-1])<0){ue.pop();const F=m(ue,j=>te(oe,j)<0);ue.splice(F,0,oe)}}}function l(ee){return ee.filter(te=>!!te)}e.coalesce=l;function a(ee){let te=0;for(let ue=0;ue<ee.length;ue++)ee[ue]&&(ee[te]=ee[ue],te+=1);ee.length=te}e.coalesceInPlace=a;function b(ee,te,ue){ee.splice(ue,0,ee.splice(te,1)[0])}e.move=b;function f(ee){return!Array.isArray(ee)||ee.length===0}e.isFalsyOrEmpty=f;function _(ee){return Array.isArray(ee)&&ee.length>0}e.isNonEmptyArray=_;function n(ee,te=ue=>ue){const ue=new Set;return ee.filter(Q=>{const le=te(Q);return ue.has(le)?!1:(ue.add(le),!0)})}e.distinct=n;function o(ee){const te=new Set;return ue=>{const Q=ee(ue);return te.has(Q)?!1:(te.add(Q),!0)}}e.uniqueFilter=o;function s(ee,te){const ue=t(ee,te);if(ue!==-1)return ee[ue]}e.findLast=s;function t(ee,te){for(let ue=ee.length-1;ue>=0;ue--){const Q=ee[ue];if(te(Q))return ue}return-1}e.lastIndex=t;function u(ee,te){return ee.length>0?ee[0]:te}e.firstOrDefault=u;function p(ee,te){return ee.length>0?ee[ee.length-1]:te}e.lastOrDefault=p;function h(ee,te,ue=(Q,le)=>Q===le){let Q=0;for(let le=0,se=Math.min(ee.length,te.length);le<se&&ue(ee[le],te[le]);le++)Q++;return Q}e.commonPrefixLength=h;function C(ee){return[].concat(...ee)}e.flatten=C;function S(ee,te){let ue=typeof te=="number"?ee:0;typeof te=="number"?ue=ee:(ue=0,te=ee);const Q=[];if(ue<=te)for(let le=ue;le<te;le++)Q.push(le);else for(let le=ue;le>te;le--)Q.push(le);return Q}e.range=S;function c(ee,te,ue){return ee.reduce((Q,le)=>(Q[te(le)]=ue?ue(le):le,Q),Object.create(null))}e.index=c;function r(ee,te){return ee.push(te),()=>P(ee,te)}e.insert=r;function P(ee,te){const ue=ee.indexOf(te);if(ue>-1)return ee.splice(ue,1),te}e.remove=P;function M(ee,te,ue){const Q=ee.slice(0,te),le=ee.slice(te);return Q.concat(ue,le)}e.arrayInsert=M;function W(ee,te){let ue;if(typeof te=="number"){let Q=te;ue=()=>{const le=Math.sin(Q++)*179426549;return le-Math.floor(le)}}else ue=Math.random;for(let Q=ee.length-1;Q>0;Q-=1){const le=Math.floor(ue()*(Q+1)),se=ee[Q];ee[Q]=ee[le],ee[le]=se}}e.shuffle=W;function $(ee,te){const ue=ee.indexOf(te);ue>-1&&(ee.splice(ue,1),ee.unshift(te))}e.pushToStart=$;function z(ee,te){const ue=ee.indexOf(te);ue>-1&&(ee.splice(ue,1),ee.push(te))}e.pushToEnd=z;function N(ee,te){for(const ue of te)ee.push(ue)}e.pushMany=N;function q(ee,te){return Array.isArray(ee)?ee.map(te):te(ee)}e.mapArrayOrNot=q;function x(ee){return Array.isArray(ee)?ee:[ee]}e.asArray=x;function U(ee){return ee[Math.floor(Math.random()*ee.length)]}e.getRandomElement=U;function de(ee,te){for(const ue of ee){const Q=te(ue);if(Q!==void 0)return Q}}e.mapFind=de;function ie(ee,te,ue){const Q=H(ee,te),le=ee.length,se=ue.length;ee.length=le+se;for(let oe=le-1;oe>=Q;oe--)ee[oe+se]=ee[oe];for(let oe=0;oe<se;oe++)ee[oe+Q]=ue[oe]}e.insertInto=ie;function ne(ee,te,ue,Q){const le=H(ee,te),se=ee.splice(le,ue);return ie(ee,le,Q),se}e.splice=ne;function H(ee,te){return te<0?Math.max(te+ee.length,0):Math.min(te,ee.length)}var V;(function(ee){function te(le){return le<0}ee.isLessThan=te;function ue(le){return le>0}ee.isGreaterThan=ue;function Q(le){return le===0}ee.isNeitherLessOrGreaterThan=Q,ee.greaterThan=1,ee.lessThan=-1,ee.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function ce(ee,te){return(ue,Q)=>te(ee(ue),ee(Q))}e.compareBy=ce;function be(...ee){return(te,ue)=>{for(const Q of ee){const le=Q(te,ue);if(!V.isNeitherLessOrGreaterThan(le))return le}return V.neitherLessOrGreaterThan}}e.tieBreakComparators=be;const Se=(ee,te)=>ee-te;e.numberComparator=Se;function ge(ee,te){if(ee.length===0)return;let ue=ee[0];for(let Q=1;Q<ee.length;Q++){const le=ee[Q];te(le,ue)>0&&(ue=le)}return ue}e.findMaxBy=ge;function O(ee,te){if(ee.length===0)return;let ue=ee[0];for(let Q=1;Q<ee.length;Q++){const le=ee[Q];te(le,ue)>=0&&(ue=le)}return ue}e.findLastMaxBy=O;function K(ee,te){return ge(ee,(ue,Q)=>-te(ue,Q))}e.findMinBy=K;class we{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let ue=this.firstIdx;for(;ue<this.items.length&&te(this.items[ue]);)ue++;const Q=ue===this.firstIdx?null:this.items.slice(this.firstIdx,ue);return this.firstIdx=ue,Q}takeFromEndWhile(te){let ue=this.lastIdx;for(;ue>=0&&te(this.items[ue]);)ue--;const Q=ue===this.lastIdx?null:this.items.slice(ue+1,this.lastIdx+1);return this.lastIdx=ue,Q}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const te=this.items[this.firstIdx];return this.firstIdx++,te}removeLast(){const te=this.items[this.lastIdx];return this.lastIdx--,te}takeCount(te){const ue=this.items.slice(this.firstIdx,this.firstIdx+te);return this.firstIdx+=te,ue}}e.ArrayQueue=we;class Ce{constructor(te){this.iterate=te}forEach(te){this.iterate(ue=>(te(ue),!0))}toArray(){const te=[];return this.iterate(ue=>(te.push(ue),!0)),te}filter(te){return new Ce(ue=>this.iterate(Q=>te(Q)?ue(Q):!0))}map(te){return new Ce(ue=>this.iterate(Q=>ue(te(Q))))}some(te){let ue=!1;return this.iterate(Q=>(ue=te(Q),!ue)),ue}findFirst(te){let ue;return this.iterate(Q=>te(Q)?(ue=Q,!1):!0),ue}findLast(te){let ue;return this.iterate(Q=>(te(Q)&&(ue=Q),!0)),ue}findLastMaxBy(te){let ue,Q=!0;return this.iterate(le=>((Q||V.isGreaterThan(te(le,ue)))&&(Q=!1,ue=le),!0)),ue}}e.CallbackIterable=Ce,Ce.empty=new Ce(ee=>{})}),define(De[53],Ie([1,0,8]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function T(y,m){if(!y)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=T;function d(y,m="Unreachable"){throw new Error(m)}e.assertNever=d;function L(y){if(!y)throw new v.BugIndicatingError("Assertion Failed")}e.assert=L;function R(y){if(!y()){debugger;y(),(0,v.onUnexpectedError)(new v.BugIndicatingError("Assertion Failed"))}}e.assertFn=R;function g(y,m){let A=0;for(;A<y.length-1;){const k=y[A],w=y[A+1];if(!m(k,w))return!1;A++}return!0}e.checkAdjacentItems=g}),define(De[67],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(T){const d=this;let L=!1,R;return function(){return L||(L=!0,R=T.apply(d,arguments)),R}}e.once=v}),define(De[111],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class v{constructor(d){this._prefix=d,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=v,e.defaultGenerator=new v("id#")}),define(De[48],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(T){function d(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}T.is=d;const L=Object.freeze([]);function R(){return L}T.empty=R;function*g(f){yield f}T.single=g;function y(f){return d(f)?f:g(f)}T.wrap=y;function m(f){return f||L}T.from=m;function A(f){return!f||f[Symbol.iterator]().next().done===!0}T.isEmpty=A;function k(f){return f[Symbol.iterator]().next().value}T.first=k;function w(f,_){for(const n of f)if(_(n))return!0;return!1}T.some=w;function D(f,_){for(const n of f)if(_(n))return n}T.find=D;function*I(f,_){for(const n of f)_(n)&&(yield n)}T.filter=I;function*E(f,_){let n=0;for(const o of f)yield _(o,n++)}T.map=E;function*i(...f){for(const _ of f)for(const n of _)yield n}T.concat=i;function l(f,_,n){let o=n;for(const s of f)o=_(o,s);return o}T.reduce=l;function*a(f,_,n=f.length){for(_<0&&(_+=f.length),n<0?n+=f.length:n>f.length&&(n=f.length);_<n;_++)yield f[_]}T.slice=a;function b(f,_=Number.POSITIVE_INFINITY){const n=[];if(_===0)return[n,f];const o=f[Symbol.iterator]();for(let s=0;s<_;s++){const t=o.next();if(t.done)return[n,T.empty()];n.push(t.value)}return[n,{[Symbol.iterator](){return o}}]}T.consume=b})(v||(e.Iterable=v={}))}),define(De[150],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var T;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var d;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(d||(e.ParseErrorCode=d={}));var L;(function(n){n.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(n,o=!1){let s=0;const t=n.length;let u="",p=0,h=16,C=0;function S(z){let N=0,q=0;for(;N<z;){const x=n.charCodeAt(s);if(x>=48&&x<=57)q=q*16+x-48;else if(x>=65&&x<=70)q=q*16+x-65+10;else if(x>=97&&x<=102)q=q*16+x-97+10;else break;s++,N++}return N<z&&(q=-1),q}function c(z){s=z,u="",p=0,h=16,C=0}function r(){const z=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&m(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&m(n.charCodeAt(s)))for(s++;s<n.length&&m(n.charCodeAt(s));)s++;else return C=3,n.substring(z,s);let N=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&m(n.charCodeAt(s))){for(s++;s<n.length&&m(n.charCodeAt(s));)s++;N=s}else C=3;return n.substring(z,N)}function P(){let z="",N=s;for(;;){if(s>=t){z+=n.substring(N,s),C=2;break}const q=n.charCodeAt(s);if(q===34){z+=n.substring(N,s),s++;break}if(q===92){if(z+=n.substring(N,s),s++,s>=t){C=2;break}switch(n.charCodeAt(s++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const U=S(4);U>=0?z+=String.fromCharCode(U):C=4;break}default:C=5}N=s;continue}if(q>=0&&q<=31)if(y(q)){z+=n.substring(N,s),C=2;break}else C=6;s++}return z}function M(){if(u="",C=0,p=s,s>=t)return p=t,h=17;let z=n.charCodeAt(s);if(g(z)){do s++,u+=String.fromCharCode(z),z=n.charCodeAt(s);while(g(z));return h=15}if(y(z))return s++,u+=String.fromCharCode(z),z===13&&n.charCodeAt(s)===10&&(s++,u+=`
`),h=14;switch(z){case 123:return s++,h=1;case 125:return s++,h=2;case 91:return s++,h=3;case 93:return s++,h=4;case 58:return s++,h=6;case 44:return s++,h=5;case 34:return s++,u=P(),h=10;case 47:{const N=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<t&&!y(n.charCodeAt(s));)s++;return u=n.substring(N,s),h=12}if(n.charCodeAt(s+1)===42){s+=2;const q=t-1;let x=!1;for(;s<q;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,x=!0;break}s++}return x||(s++,C=1),u=n.substring(N,s),h=13}return u+=String.fromCharCode(z),s++,h=16}case 45:if(u+=String.fromCharCode(z),s++,s===t||!m(n.charCodeAt(s)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=r(),h=11;default:for(;s<t&&W(z);)s++,z=n.charCodeAt(s);if(p!==s){switch(u=n.substring(p,s),u){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return u+=String.fromCharCode(z),s++,h=16}}function W(z){if(g(z)||y(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function $(){let z;do z=M();while(z>=12&&z<=15);return z}return{setPosition:c,getPosition:()=>s,scan:o?$:M,getToken:()=>h,getTokenValue:()=>u,getTokenOffset:()=>p,getTokenLength:()=>s-p,getTokenError:()=>C}}e.createScanner=R;function g(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function y(n){return n===10||n===13||n===8232||n===8233}function m(n){return n>=48&&n<=57}var A;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(A||(A={}));function k(n,o){const s=[],t=new Object;let u;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function C(S,c,r,P){p.value=S,p.offset=c,p.length=r,p.type=P,p.colonOffset=void 0,u=p}try{b(n,{onObjectBegin:(S,c)=>{if(o<=S)throw t;u=void 0,h=o>S,s.push("")},onObjectProperty:(S,c,r)=>{if(o<c||(C(S,c,r,"property"),s[s.length-1]=S,o<=c+r))throw t},onObjectEnd:(S,c)=>{if(o<=S)throw t;u=void 0,s.pop()},onArrayBegin:(S,c)=>{if(o<=S)throw t;u=void 0,s.push(0)},onArrayEnd:(S,c)=>{if(o<=S)throw t;u=void 0,s.pop()},onLiteralValue:(S,c,r)=>{if(o<c||(C(S,c,r,_(S)),o<=c+r))throw t},onSeparator:(S,c,r)=>{if(o<=c)throw t;if(S===":"&&u&&u.type==="property")u.colonOffset=c,h=!1,u=void 0;else if(S===","){const P=s[s.length-1];typeof P=="number"?s[s.length-1]=P+1:(h=!0,s[s.length-1]=""),u=void 0}}})}catch(S){if(S!==t)throw S}return{path:s,previousNode:u,isAtPropertyKey:h,matches:S=>{let c=0;for(let r=0;c<S.length&&r<s.length;r++)if(S[c]===s[r]||S[c]==="*")c++;else if(S[c]!=="**")return!1;return c===S.length}}}e.getLocation=k;function w(n,o=[],s=L.DEFAULT){let t=null,u=[];const p=[];function h(S){Array.isArray(u)?u.push(S):t!==null&&(u[t]=S)}return b(n,{onObjectBegin:()=>{const S={};h(S),p.push(u),u=S,t=null},onObjectProperty:S=>{t=S},onObjectEnd:()=>{u=p.pop()},onArrayBegin:()=>{const S=[];h(S),p.push(u),u=S,t=null},onArrayEnd:()=>{u=p.pop()},onLiteralValue:h,onError:(S,c,r)=>{o.push({error:S,offset:c,length:r})}},s),u[0]}e.parse=w;function D(n,o=[],s=L.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(S){t.type==="property"&&(t.length=S-t.offset,t=t.parent)}function p(S){return t.children.push(S),S}b(n,{onObjectBegin:S=>{t=p({type:"object",offset:S,length:-1,parent:t,children:[]})},onObjectProperty:(S,c,r)=>{t=p({type:"property",offset:c,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:S,offset:c,length:r,parent:t})},onObjectEnd:(S,c)=>{t.length=S+c-t.offset,t=t.parent,u(S+c)},onArrayBegin:(S,c)=>{t=p({type:"array",offset:S,length:-1,parent:t,children:[]})},onArrayEnd:(S,c)=>{t.length=S+c-t.offset,t=t.parent,u(S+c)},onLiteralValue:(S,c,r)=>{p({type:_(S),offset:c,length:r,parent:t,value:S}),u(c+r)},onSeparator:(S,c,r)=>{t.type==="property"&&(S===":"?t.colonOffset=c:S===","&&u(c))},onError:(S,c,r)=>{o.push({error:S,offset:c,length:r})}},s);const C=t.children[0];return C&&delete C.parent,C}e.parseTree=D;function I(n,o){if(!n)return;let s=n;for(const t of o)if(typeof t=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let u=!1;for(const p of s.children)if(Array.isArray(p.children)&&p.children[0].value===t){s=p.children[1],u=!0;break}if(!u)return}else{const u=t;if(s.type!=="array"||u<0||!Array.isArray(s.children)||u>=s.children.length)return;s=s.children[u]}return s}e.findNodeAtLocation=I;function E(n){if(!n.parent||!n.parent.children)return[];const o=E(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;o.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&o.push(s)}return o}e.getNodePath=E;function i(n){switch(n.type){case"array":return n.children.map(i);case"object":{const o=Object.create(null);for(const s of n.children){const t=s.children[1];t&&(o[s.children[0].value]=i(t))}return o}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=i;function l(n,o,s=!1){return o>=n.offset&&o<n.offset+n.length||s&&o===n.offset+n.length}e.contains=l;function a(n,o,s=!1){if(l(n,o,s)){const t=n.children;if(Array.isArray(t))for(let u=0;u<t.length&&t[u].offset<=o;u++){const p=a(t[u],o,s);if(p)return p}return n}}e.findNodeAtOffset=a;function b(n,o,s=L.DEFAULT){const t=R(n,!1);function u(ce){return ce?()=>ce(t.getTokenOffset(),t.getTokenLength()):()=>!0}function p(ce){return ce?be=>ce(be,t.getTokenOffset(),t.getTokenLength()):()=>!0}const h=u(o.onObjectBegin),C=p(o.onObjectProperty),S=u(o.onObjectEnd),c=u(o.onArrayBegin),r=u(o.onArrayEnd),P=p(o.onLiteralValue),M=p(o.onSeparator),W=u(o.onComment),$=p(o.onError),z=s&&s.disallowComments,N=s&&s.allowTrailingComma;function q(){for(;;){const ce=t.scan();switch(t.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:z||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(ce){case 12:case 13:z?x(10):W();break;case 16:x(1);break;case 15:case 14:break;default:return ce}}}function x(ce,be=[],Se=[]){if($(ce),be.length+Se.length>0){let ge=t.getToken();for(;ge!==17;){if(be.indexOf(ge)!==-1){q();break}else if(Se.indexOf(ge)!==-1)break;ge=q()}}}function U(ce){const be=t.getTokenValue();return ce?P(be):C(be),q(),!0}function de(){switch(t.getToken()){case 11:{let ce=0;try{ce=JSON.parse(t.getTokenValue()),typeof ce!="number"&&(x(2),ce=0)}catch{x(2)}P(ce);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return q(),!0}function ie(){return t.getToken()!==10?(x(3,[],[2,5]),!1):(U(!1),t.getToken()===6?(M(":"),q(),V()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function ne(){h(),q();let ce=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(ce||x(4,[],[]),M(","),q(),t.getToken()===2&&N)break}else ce&&x(6,[],[]);ie()||x(4,[],[2,5]),ce=!0}return S(),t.getToken()!==2?x(7,[2],[]):q(),!0}function H(){c(),q();let ce=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(ce||x(4,[],[]),M(","),q(),t.getToken()===4&&N)break}else ce&&x(6,[],[]);V()||x(4,[],[4,5]),ce=!0}return r(),t.getToken()!==4?x(8,[4],[]):q(),!0}function V(){switch(t.getToken()){case 3:return H();case 1:return ne();case 10:return U(!0);default:return de()}}return q(),t.getToken()===17?s.allowEmptyContent?!0:(x(4,[],[]),!1):V()?(t.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.visit=b;function f(n,o){const s=R(n),t=[];let u,p=0,h;do switch(h=s.getPosition(),u=s.scan(),u){case 12:case 13:case 17:p!==h&&t.push(n.substring(p,h)),o!==void 0&&t.push(s.getTokenValue().replace(/[^\r\n]/g,o)),p=s.getPosition();break}while(u!==17);return t.join("")}e.stripComments=f;function _(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=_}),define(De[54],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(d){this.executor=d,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(d){this._error=d}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=v}),define(De[4],Ie([1,0,67,48]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const d=!1;let L=null;function R(p){L=p}if(e.setDisposableTracker=R,d){const p="__is_disposable_tracked__";R(new class{trackDisposable(h){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{h[p]||console.log(C)},3e3)}setParent(h,C){if(h&&h!==a.None)try{h[p]=!0}catch{}}markAsDisposed(h){if(h&&h!==a.None)try{h[p]=!0}catch{}}markAsSingleton(h){}})}function g(p){return L?.trackDisposable(p),p}function y(p){L?.markAsDisposed(p)}function m(p,h){L?.setParent(p,h)}function A(p,h){if(L)for(const C of p)L.setParent(C,h)}function k(p){return L?.markAsSingleton(p),p}e.markAsSingleton=k;function w(p){return typeof p.dispose=="function"&&p.dispose.length===0}e.isDisposable=w;function D(p){if(T.Iterable.is(p)){const h=[];for(const C of p)if(C)try{C.dispose()}catch(S){h.push(S)}if(h.length===1)throw h[0];if(h.length>1)throw new AggregateError(h,"Encountered errors while disposing of store");return Array.isArray(p)?[]:p}else if(p)return p.dispose(),p}e.dispose=D;function I(p){for(const h of p)w(h)&&h.dispose();return[]}e.disposeIfDisposable=I;function E(...p){const h=i(()=>D(p));return A(p,h),h}e.combinedDisposable=E;function i(p){const h=g({dispose:(0,v.once)(()=>{y(h),p()})});return h}e.toDisposable=i;class l{constructor(){this._toDispose=new Set,this._isDisposed=!1,g(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{D(this._toDispose)}finally{this._toDispose.clear()}}add(h){if(!h)return h;if(h===this)throw new Error("Cannot register a disposable on itself!");return m(h,this),this._isDisposed?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(h),h}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class a{constructor(){this._store=new l,g(this),m(this._store,this)}dispose(){y(this),this._store.dispose()}_register(h){if(h===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(h)}}e.Disposable=a,a.None=Object.freeze({dispose(){}});class b{constructor(){this._isDisposed=!1,g(this)}get value(){return this._isDisposed?void 0:this._value}set value(h){this._isDisposed||h===this._value||(this._value?.dispose(),h&&m(h,this),this._value=h)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const h=this._value;return this._value=void 0,h&&m(h,null),h}}e.MutableDisposable=b;class f{constructor(h){this._disposable=h,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class _{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,g(this)}set(h){let C=h;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,y(this))},this}}e.SafeDisposable=_;class n{constructor(){this.references=new Map}acquire(h,...C){let S=this.references.get(h);S||(S={counter:0,object:this.createReferencedObject(h,...C)},this.references.set(h,S));const{object:c}=S,r=(0,v.once)(()=>{--S.counter===0&&(this.destroyReferencedObject(h,S.object),this.references.delete(h))});return S.counter++,{object:c,dispose:r}}}e.ReferenceCollection=n;class o{constructor(h){this.referenceCollection=h}async acquire(h,...C){const S=this.referenceCollection.acquire(h,...C);try{return{object:await S.object,dispose:()=>S.dispose()}}catch(c){throw S.dispose(),c}}}e.AsyncReferenceCollection=o;class s{constructor(h){this.object=h}dispose(){}}e.ImmortalReference=s;function t(p){const h=new l;try{p(h)}finally{h.dispose()}}e.disposeOnReturn=t;class u{constructor(){this._store=new Map,this._isDisposed=!1,g(this)}dispose(){y(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{D(this._store.values())}finally{this._store.clear()}}has(h){return this._store.has(h)}get(h){return this._store.get(h)}set(h,C,S=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),S||this._store.get(h)?.dispose(),this._store.set(h,C)}deleteAndDispose(h){this._store.get(h)?.dispose(),this._store.delete(h)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=u}),define(De[68],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(L){this.element=L,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class T{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let L=this._first;for(;L!==v.Undefined;){const R=L.next;L.prev=v.Undefined,L.next=v.Undefined,L=R}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,R){const g=new v(L);if(this._first===v.Undefined)this._first=g,this._last=g;else if(R){const m=this._last;this._last=g,g.prev=m,m.next=g}else{const m=this._first;this._first=g,g.next=m,m.prev=g}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(g))}}shift(){if(this._first!==v.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==v.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==v.Undefined&&L.next!==v.Undefined){const R=L.prev;R.next=L.next,L.next.prev=R}else L.prev===v.Undefined&&L.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):L.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):L.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==v.Undefined;)yield L.element,L=L.next}}e.LinkedList=T}),define(De[28],Ie([1,0]),function(re,e){"use strict";var v,T,d;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function L(E,i,l){let a=E.get(i);return a===void 0&&(a=l,E.set(i,a)),a}e.getOrSet=L;function R(E){const i=[];return E.forEach((l,a)=>{i.push(`${a} => ${l}`)}),`Map(${E.size}) {${i.join(", ")}}`}e.mapToString=R;function g(E){const i=[];return E.forEach(l=>{i.push(l)}),`Set(${E.size}) {${i.join(", ")}}`}e.setToString=g;class y{constructor(i,l){this.uri=i,this.value=l}}class m{constructor(i,l){this[v]="ResourceMap",i instanceof m?(this.map=new Map(i.map),this.toKey=l??m.defaultToKey):(this.map=new Map,this.toKey=i??m.defaultToKey)}set(i,l){return this.map.set(this.toKey(i),new y(i,l)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,l){typeof l<"u"&&(i=i.bind(l));for(const[a,b]of this.map)i(b.value,b.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=m,m.defaultToKey=E=>E.toString();class A{constructor(i,l){this[T]="ResourceSet",!i||typeof i=="function"?this._map=new m(i):(this._map=new m(l),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,l){this._map.forEach((a,b)=>i.call(l,b,b,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=A;var k;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class w{constructor(){this[d]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,l=0){const a=this._map.get(i);if(a)return l!==0&&this.touch(a,l),a.value}set(i,l,a=0){let b=this._map.get(i);if(b)b.value=l,a!==0&&this.touch(b,a);else{switch(b={key:i,value:l,next:void 0,previous:void 0},a){case 0:this.addItemLast(b);break;case 1:this.addItemFirst(b);break;case 2:this.addItemLast(b);break;default:this.addItemLast(b);break}this._map.set(i,b),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const l=this._map.get(i);if(l)return this._map.delete(i),this.removeItem(l),this._size--,l.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,l){const a=this._state;let b=this._head;for(;b;){if(l?i.bind(l)(b.value,b.key,this):i(b.value,b.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const i=this,l=this._state;let a=this._head;const b={[Symbol.iterator](){return b},next(){if(i._state!==l)throw new Error("LinkedMap got modified during iteration.");if(a){const f={value:a.key,done:!1};return a=a.next,f}else return{value:void 0,done:!0}}};return b}values(){const i=this,l=this._state;let a=this._head;const b={[Symbol.iterator](){return b},next(){if(i._state!==l)throw new Error("LinkedMap got modified during iteration.");if(a){const f={value:a.value,done:!1};return a=a.next,f}else return{value:void 0,done:!0}}};return b}entries(){const i=this,l=this._state;let a=this._head;const b={[Symbol.iterator](){return b},next(){if(i._state!==l)throw new Error("LinkedMap got modified during iteration.");if(a){const f={value:[a.key,a.value],done:!1};return a=a.next,f}else return{value:void 0,done:!0}}};return b}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let l=this._head,a=this.size;for(;l&&a>i;)this._map.delete(l.key),l=l.next,a--;this._head=l,this._size=a,l&&(l.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const l=i.next,a=i.previous;if(!l||!a)throw new Error("Invalid list");l.previous=a,a.next=l}i.next=void 0,i.previous=void 0,this._state++}touch(i,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(i===this._head)return;const a=i.next,b=i.previous;i===this._tail?(b.next=void 0,this._tail=b):(a.previous=b,b.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(l===2){if(i===this._tail)return;const a=i.next,b=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=b,b.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((l,a)=>{i.push([a,l])}),i}fromJSON(i){this.clear();for(const[l,a]of i)this.set(l,a)}}e.LinkedMap=w;class D extends w{constructor(i,l=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,l=2){return super.get(i,l)}peek(i){return super.get(i,0)}set(i,l){return super.set(i,l,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=D;class I{constructor(){this.map=new Map}add(i){return this.map.set(i,(this.map.get(i)||0)+1),this}delete(i){let l=this.map.get(i)||0;return l===0?!1:(l--,l===0?this.map.delete(i):this.map.set(i,l),!0)}has(i){return this.map.has(i)}}e.CounterSet=I}),function(re,e){typeof define=="function"&&define.amd?define(De[151],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(ee,te){for(var ue=0;ue<te.length;ue++){var Q=te[ue];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(ee,Q.key,Q)}}function v(ee,te,ue){return te&&e(ee.prototype,te),ue&&e(ee,ue),Object.defineProperty(ee,"prototype",{writable:!1}),ee}function T(ee,te){if(ee){if(typeof ee=="string")return d(ee,te);var ue=Object.prototype.toString.call(ee).slice(8,-1);if(ue==="Object"&&ee.constructor&&(ue=ee.constructor.name),ue==="Map"||ue==="Set")return Array.from(ee);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return d(ee,te)}}function d(ee,te){(te==null||te>ee.length)&&(te=ee.length);for(var ue=0,Q=new Array(te);ue<te;ue++)Q[ue]=ee[ue];return Q}function L(ee,te){var ue=typeof Symbol<"u"&&ee[Symbol.iterator]||ee["@@iterator"];if(ue)return(ue=ue.call(ee)).next.bind(ue);if(Array.isArray(ee)||(ue=T(ee))||te&&ee&&typeof ee.length=="number"){ue&&(ee=ue);var Q=0;return function(){return Q>=ee.length?{done:!0}:{done:!1,value:ee[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=R();function g(ee){re.defaults=ee}var y=/[&<>"']/,m=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},D=function(te){return w[te]};function I(ee,te){if(te){if(y.test(ee))return ee.replace(m,D)}else if(A.test(ee))return ee.replace(k,D);return ee}var E=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function i(ee){return ee.replace(E,function(te,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var l=/(^|[^\[])\^/g;function a(ee,te){ee=typeof ee=="string"?ee:ee.source,te=te||"";var ue={replace:function(le,se){return se=se.source||se,se=se.replace(l,"$1"),ee=ee.replace(le,se),ue},getRegex:function(){return new RegExp(ee,te)}};return ue}var b=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function _(ee,te,ue){if(ee){var Q;try{Q=decodeURIComponent(i(ue)).replace(b,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}te&&!f.test(ue)&&(ue=u(te,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var n={},o=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(ee,te){n[" "+ee]||(o.test(ee)?n[" "+ee]=ee+"/":n[" "+ee]=S(ee,"/",!0)),ee=n[" "+ee];var ue=ee.indexOf(":")===-1;return te.substring(0,2)==="//"?ue?te:ee.replace(s,"$1")+te:te.charAt(0)==="/"?ue?te:ee.replace(t,"$1")+te:ee+te}var p={exec:function(){}};function h(ee){for(var te=1,ue,Q;te<arguments.length;te++){ue=arguments[te];for(Q in ue)Object.prototype.hasOwnProperty.call(ue,Q)&&(ee[Q]=ue[Q])}return ee}function C(ee,te){var ue=ee.replace(/\|/g,function(se,oe,F){for(var j=!1,Y=oe;--Y>=0&&F[Y]==="\\";)j=!j;return j?"|":" |"}),Q=ue.split(/ \|/),le=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>te)Q.splice(te);else for(;Q.length<te;)Q.push("");for(;le<Q.length;le++)Q[le]=Q[le].trim().replace(/\\\|/g,"|");return Q}function S(ee,te,ue){var Q=ee.length;if(Q===0)return"";for(var le=0;le<Q;){var se=ee.charAt(Q-le-1);if(se===te&&!ue)le++;else if(se!==te&&ue)le++;else break}return ee.slice(0,Q-le)}function c(ee,te){if(ee.indexOf(te[1])===-1)return-1;for(var ue=ee.length,Q=0,le=0;le<ue;le++)if(ee[le]==="\\")le++;else if(ee[le]===te[0])Q++;else if(ee[le]===te[1]&&(Q--,Q<0))return le;return-1}function r(ee){ee&&ee.sanitize&&!ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ee,te){if(te<1)return"";for(var ue="";te>1;)te&1&&(ue+=ee),te>>=1,ee+=ee;return ue+ee}function M(ee,te,ue,Q){var le=te.href,se=te.title?I(te.title):null,oe=ee[1].replace(/\\([\[\]])/g,"$1");if(ee[0].charAt(0)!=="!"){Q.state.inLink=!0;var F={type:"link",raw:ue,href:le,title:se,text:oe,tokens:Q.inlineTokens(oe)};return Q.state.inLink=!1,F}return{type:"image",raw:ue,href:le,title:se,text:I(oe)}}function W(ee,te){var ue=ee.match(/^(\s+)(?:```)/);if(ue===null)return te;var Q=ue[1];return te.split(`
`).map(function(le){var se=le.match(/^\s+/);if(se===null)return le;var oe=se[0];return oe.length>=Q.length?le.slice(Q.length):le}).join(`
`)}var $=function(){function ee(ue){this.options=ue||re.defaults}var te=ee.prototype;return te.space=function(Q){var le=this.rules.block.newline.exec(Q);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},te.code=function(Q){var le=this.rules.block.code.exec(Q);if(le){var se=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?se:S(se,`
`)}}},te.fences=function(Q){var le=this.rules.block.fences.exec(Q);if(le){var se=le[0],oe=W(se,le[3]||"");return{type:"code",raw:se,lang:le[2]?le[2].trim():le[2],text:oe}}},te.heading=function(Q){var le=this.rules.block.heading.exec(Q);if(le){var se=le[2].trim();if(/#$/.test(se)){var oe=S(se,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(se=oe.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:se,tokens:this.lexer.inline(se)}}},te.hr=function(Q){var le=this.rules.block.hr.exec(Q);if(le)return{type:"hr",raw:le[0]}},te.blockquote=function(Q){var le=this.rules.block.blockquote.exec(Q);if(le){var se=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},te.list=function(Q){var le=this.rules.block.list.exec(Q);if(le){var se,oe,F,j,Y,Z,me,_e,fe,ke,Pe,$e,He=le[1].trim(),tt=He.length>1,Ge={type:"list",raw:"",ordered:tt,start:tt?+He.slice(0,-1):"",loose:!1,items:[]};He=tt?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=tt?He:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&($e=!1,!(!(le=Ke.exec(Q))||this.rules.block.hr.test(Q)));){if(se=le[0],Q=Q.substring(se.length),_e=le[2].split(`
`,1)[0],fe=Q.split(`
`,1)[0],this.options.pedantic?(j=2,Pe=_e.trimLeft()):(j=le[2].search(/[^ ]/),j=j>4?1:j,Pe=_e.slice(j),j+=le[1].length),Z=!1,!_e&&/^ *$/.test(fe)&&(se+=fe+`
`,Q=Q.substring(fe.length+1),$e=!0),!$e)for(var st=new RegExp("^ {0,"+Math.min(3,j-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),at=new RegExp("^ {0,"+Math.min(3,j-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ze=new RegExp("^ {0,"+Math.min(3,j-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,j-1)+"}#");Q&&(ke=Q.split(`
`,1)[0],_e=ke,this.options.pedantic&&(_e=_e.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ze.test(_e)||rt.test(_e)||st.test(_e)||at.test(Q)));){if(_e.search(/[^ ]/)>=j||!_e.trim())Pe+=`
`+_e.slice(j);else if(!Z)Pe+=`
`+_e;else break;!Z&&!_e.trim()&&(Z=!0),se+=ke+`
`,Q=Q.substring(ke.length+1)}Ge.loose||(me?Ge.loose=!0:/\n *\n *$/.test(se)&&(me=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(Pe),oe&&(F=oe[0]!=="[ ] ",Pe=Pe.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:se,task:!!oe,checked:F,loose:!1,text:Pe}),Ge.raw+=se}Ge.items[Ge.items.length-1].raw=se.trimRight(),Ge.items[Ge.items.length-1].text=Pe.trimRight(),Ge.raw=Ge.raw.trimRight();var he=Ge.items.length;for(Y=0;Y<he;Y++){this.lexer.state.top=!1,Ge.items[Y].tokens=this.lexer.blockTokens(Ge.items[Y].text,[]);var Oe=Ge.items[Y].tokens.filter(function(X){return X.type==="space"}),J=Oe.every(function(X){for(var Ee=X.raw.split(""),Ue=0,Ne=L(Ee),Qe;!(Qe=Ne()).done;){var et=Qe.value;if(et===`
`&&(Ue+=1),Ue>1)return!0}return!1});!Ge.loose&&Oe.length&&J&&(Ge.loose=!0,Ge.items[Y].loose=!0)}return Ge}},te.html=function(Q){var le=this.rules.block.html.exec(Q);if(le){var se={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(le[0]):I(le[0]);se.type="paragraph",se.text=oe,se.tokens=this.lexer.inline(oe)}return se}},te.def=function(Q){var le=this.rules.block.def.exec(Q);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var se=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:le[0],href:le[2],title:le[3]}}},te.table=function(Q){var le=this.rules.block.table.exec(Q);if(le){var se={type:"table",header:C(le[1]).map(function(me){return{text:me}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=le[0];var oe=se.align.length,F,j,Y,Z;for(F=0;F<oe;F++)/^ *-+: *$/.test(se.align[F])?se.align[F]="right":/^ *:-+: *$/.test(se.align[F])?se.align[F]="center":/^ *:-+ *$/.test(se.align[F])?se.align[F]="left":se.align[F]=null;for(oe=se.rows.length,F=0;F<oe;F++)se.rows[F]=C(se.rows[F],se.header.length).map(function(me){return{text:me}});for(oe=se.header.length,j=0;j<oe;j++)se.header[j].tokens=this.lexer.inline(se.header[j].text);for(oe=se.rows.length,j=0;j<oe;j++)for(Z=se.rows[j],Y=0;Y<Z.length;Y++)Z[Y].tokens=this.lexer.inline(Z[Y].text);return se}}},te.lheading=function(Q){var le=this.rules.block.lheading.exec(Q);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},te.paragraph=function(Q){var le=this.rules.block.paragraph.exec(Q);if(le){var se=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:se,tokens:this.lexer.inline(se)}}},te.text=function(Q){var le=this.rules.block.text.exec(Q);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},te.escape=function(Q){var le=this.rules.inline.escape.exec(Q);if(le)return{type:"escape",raw:le[0],text:I(le[1])}},te.tag=function(Q){var le=this.rules.inline.tag.exec(Q);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):I(le[0]):le[0]}},te.link=function(Q){var le=this.rules.inline.link.exec(Q);if(le){var se=le[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var oe=S(se.slice(0,-1),"\\");if((se.length-oe.length)%2===0)return}else{var F=c(le[2],"()");if(F>-1){var j=le[0].indexOf("!")===0?5:4,Y=j+le[1].length+F;le[2]=le[2].substring(0,F),le[0]=le[0].substring(0,Y).trim(),le[3]=""}}var Z=le[2],me="";if(this.options.pedantic){var _e=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Z);_e&&(Z=_e[1],me=_e[3])}else me=le[3]?le[3].slice(1,-1):"";return Z=Z.trim(),/^</.test(Z)&&(this.options.pedantic&&!/>$/.test(se)?Z=Z.slice(1):Z=Z.slice(1,-1)),M(le,{href:Z&&Z.replace(this.rules.inline._escapes,"$1"),title:me&&me.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},te.reflink=function(Q,le){var se;if((se=this.rules.inline.reflink.exec(Q))||(se=this.rules.inline.nolink.exec(Q))){var oe=(se[2]||se[1]).replace(/\s+/g," ");if(oe=le[oe.toLowerCase()],!oe||!oe.href){var F=se[0].charAt(0);return{type:"text",raw:F,text:F}}return M(se,oe,se[0],this.lexer)}},te.emStrong=function(Q,le,se){se===void 0&&(se="");var oe=this.rules.inline.emStrong.lDelim.exec(Q);if(oe&&!(oe[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var F=oe[1]||oe[2]||"";if(!F||F&&(se===""||this.rules.inline.punctuation.exec(se))){var j=oe[0].length-1,Y,Z,me=j,_e=0,fe=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(fe.lastIndex=0,le=le.slice(-1*Q.length+j);(oe=fe.exec(le))!=null;)if(Y=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!Y){if(Z=Y.length,oe[3]||oe[4]){me+=Z;continue}else if((oe[5]||oe[6])&&j%3&&!((j+Z)%3)){_e+=Z;continue}if(me-=Z,!(me>0)){if(Z=Math.min(Z,Z+me+_e),Math.min(j,Z)%2){var ke=Q.slice(1,j+oe.index+Z);return{type:"em",raw:Q.slice(0,j+oe.index+Z+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}var Pe=Q.slice(2,j+oe.index+Z-1);return{type:"strong",raw:Q.slice(0,j+oe.index+Z+1),text:Pe,tokens:this.lexer.inlineTokens(Pe)}}}}}},te.codespan=function(Q){var le=this.rules.inline.code.exec(Q);if(le){var se=le[2].replace(/\n/g," "),oe=/[^ ]/.test(se),F=/^ /.test(se)&&/ $/.test(se);return oe&&F&&(se=se.substring(1,se.length-1)),se=I(se,!0),{type:"codespan",raw:le[0],text:se}}},te.br=function(Q){var le=this.rules.inline.br.exec(Q);if(le)return{type:"br",raw:le[0]}},te.del=function(Q){var le=this.rules.inline.del.exec(Q);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},te.autolink=function(Q,le){var se=this.rules.inline.autolink.exec(Q);if(se){var oe,F;return se[2]==="@"?(oe=I(this.options.mangle?le(se[1]):se[1]),F="mailto:"+oe):(oe=I(se[1]),F=oe),{type:"link",raw:se[0],text:oe,href:F,tokens:[{type:"text",raw:oe,text:oe}]}}},te.url=function(Q,le){var se;if(se=this.rules.inline.url.exec(Q)){var oe,F;if(se[2]==="@")oe=I(this.options.mangle?le(se[0]):se[0]),F="mailto:"+oe;else{var j;do j=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(j!==se[0]);oe=I(se[0]),se[1]==="www."?F="http://"+oe:F=oe}return{type:"link",raw:se[0],text:oe,href:F,tokens:[{type:"text",raw:oe,text:oe}]}}},te.inlineText=function(Q,le){var se=this.rules.inline.text.exec(Q);if(se){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):I(se[0]):se[0]:oe=I(this.options.smartypants?le(se[0]):se[0]),{type:"text",raw:se[0],text:oe}}},ee}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=a(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=a(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=a(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=a(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=a(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=a(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=h({},z),z.gfm=h({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=a(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=a(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=h({},z.normal,{html:a(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:a(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=a(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=a(z._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=a(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=a(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=a(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=a(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=a(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=a(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=a(N.reflink).replace("label",N._label).replace("ref",z._label).getRegex(),N.nolink=a(N.nolink).replace("ref",z._label).getRegex(),N.reflinkSearch=a(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=h({},N),N.pedantic=h({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:a(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:a(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=h({},N.normal,{escape:a(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=a(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=h({},N.gfm,{br:a(N.br).replace("{2,}","*").getRegex(),text:a(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function q(ee){return ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(ee){var te="",ue,Q,le=ee.length;for(ue=0;ue<le;ue++)Q=ee.charCodeAt(ue),Math.random()>.5&&(Q="x"+Q.toString(16)),te+="&#"+Q+";";return te}var U=function(){function ee(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||re.defaults,this.options.tokenizer=this.options.tokenizer||new $,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:z.normal,inline:N.normal};this.options.pedantic?(Q.block=z.pedantic,Q.inline=N.pedantic):this.options.gfm&&(Q.block=z.gfm,this.options.breaks?Q.inline=N.breaks:Q.inline=N.gfm),this.tokenizer.rules=Q}ee.lex=function(Q,le){var se=new ee(le);return se.lex(Q)},ee.lexInline=function(Q,le){var se=new ee(le);return se.inlineTokens(Q)};var te=ee.prototype;return te.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},te.blockTokens=function(Q,le){var se=this;le===void 0&&(le=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(me,_e,fe){return _e+"    ".repeat(fe.length)});for(var oe,F,j,Y;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(me){return(oe=me.call({lexer:se},Q,le))?(Q=Q.substring(oe.raw.length),le.push(oe),!0):!1}))){if(oe=this.tokenizer.space(Q)){Q=Q.substring(oe.raw.length),oe.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(oe);continue}if(oe=this.tokenizer.code(Q)){Q=Q.substring(oe.raw.length),F=le[le.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+oe.raw,F.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=F.text):le.push(oe);continue}if(oe=this.tokenizer.fences(Q)){Q=Q.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.heading(Q)){Q=Q.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.hr(Q)){Q=Q.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.blockquote(Q)){Q=Q.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.list(Q)){Q=Q.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.html(Q)){Q=Q.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.def(Q)){Q=Q.substring(oe.raw.length),F=le[le.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+oe.raw,F.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=F.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(Q)){Q=Q.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.lheading(Q)){Q=Q.substring(oe.raw.length),le.push(oe);continue}if(j=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var me=1/0,_e=Q.slice(1),fe=void 0;se.options.extensions.startBlock.forEach(function(ke){fe=ke.call({lexer:this},_e),typeof fe=="number"&&fe>=0&&(me=Math.min(me,fe))}),me<1/0&&me>=0&&(j=Q.substring(0,me+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(j))){F=le[le.length-1],Y&&F.type==="paragraph"?(F.raw+=`
`+oe.raw,F.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):le.push(oe),Y=j.length!==Q.length,Q=Q.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(Q)){Q=Q.substring(oe.raw.length),F=le[le.length-1],F&&F.type==="text"?(F.raw+=`
`+oe.raw,F.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):le.push(oe);continue}if(Q){var Z="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return this.state.top=!0,le},te.inline=function(Q,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:Q,tokens:le}),le},te.inlineTokens=function(Q,le){var se=this;le===void 0&&(le=[]);var oe,F,j,Y=Q,Z,me,_e;if(this.tokens.links){var fe=Object.keys(this.tokens.links);if(fe.length>0)for(;(Z=this.tokenizer.rules.inline.reflinkSearch.exec(Y))!=null;)fe.includes(Z[0].slice(Z[0].lastIndexOf("[")+1,-1))&&(Y=Y.slice(0,Z.index)+"["+P("a",Z[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Z=this.tokenizer.rules.inline.blockSkip.exec(Y))!=null;)Y=Y.slice(0,Z.index)+"["+P("a",Z[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Z=this.tokenizer.rules.inline.escapedEmSt.exec(Y))!=null;)Y=Y.slice(0,Z.index)+"++"+Y.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(me||(_e=""),me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Pe){return(oe=Pe.call({lexer:se},Q,le))?(Q=Q.substring(oe.raw.length),le.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(Q)){Q=Q.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.tag(Q)){Q=Q.substring(oe.raw.length),F=le[le.length-1],F&&oe.type==="text"&&F.type==="text"?(F.raw+=oe.raw,F.text+=oe.text):le.push(oe);continue}if(oe=this.tokenizer.link(Q)){Q=Q.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(oe.raw.length),F=le[le.length-1],F&&oe.type==="text"&&F.type==="text"?(F.raw+=oe.raw,F.text+=oe.text):le.push(oe);continue}if(oe=this.tokenizer.emStrong(Q,Y,_e)){Q=Q.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.codespan(Q)){Q=Q.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.br(Q)){Q=Q.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.del(Q)){Q=Q.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.autolink(Q,x)){Q=Q.substring(oe.raw.length),le.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(Q,x))){Q=Q.substring(oe.raw.length),le.push(oe);continue}if(j=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var Pe=1/0,$e=Q.slice(1),He=void 0;se.options.extensions.startInline.forEach(function(tt){He=tt.call({lexer:this},$e),typeof He=="number"&&He>=0&&(Pe=Math.min(Pe,He))}),Pe<1/0&&Pe>=0&&(j=Q.substring(0,Pe+1))}(),oe=this.tokenizer.inlineText(j,q)){Q=Q.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(_e=oe.raw.slice(-1)),me=!0,F=le[le.length-1],F&&F.type==="text"?(F.raw+=oe.raw,F.text+=oe.text):le.push(oe);continue}if(Q){var ke="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return le},v(ee,null,[{key:"rules",get:function(){return{block:z,inline:N}}}]),ee}(),de=function(){function ee(ue){this.options=ue||re.defaults}var te=ee.prototype;return te.code=function(Q,le,se){var oe=(le||"").match(/\S*/)[0];if(this.options.highlight){var F=this.options.highlight(Q,oe);F!=null&&F!==Q&&(se=!0,Q=F)}return Q=Q.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+I(oe,!0)+'">'+(se?Q:I(Q,!0))+`</code></pre>
`:"<pre><code>"+(se?Q:I(Q,!0))+`</code></pre>
`},te.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},te.html=function(Q){return Q},te.heading=function(Q,le,se,oe){if(this.options.headerIds){var F=this.options.headerPrefix+oe.slug(se);return"<h"+le+' id="'+F+'">'+Q+"</h"+le+`>
`}return"<h"+le+">"+Q+"</h"+le+`>
`},te.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},te.list=function(Q,le,se){var oe=le?"ol":"ul",F=le&&se!==1?' start="'+se+'"':"";return"<"+oe+F+`>
`+Q+"</"+oe+`>
`},te.listitem=function(Q){return"<li>"+Q+`</li>
`},te.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},te.paragraph=function(Q){return"<p>"+Q+`</p>
`},te.table=function(Q,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+le+`</table>
`},te.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},te.tablecell=function(Q,le){var se=le.header?"th":"td",oe=le.align?"<"+se+' align="'+le.align+'">':"<"+se+">";return oe+Q+("</"+se+`>
`)},te.strong=function(Q){return"<strong>"+Q+"</strong>"},te.em=function(Q){return"<em>"+Q+"</em>"},te.codespan=function(Q){return"<code>"+Q+"</code>"},te.br=function(){return this.options.xhtml?"<br/>":"<br>"},te.del=function(Q){return"<del>"+Q+"</del>"},te.link=function(Q,le,se){if(Q=_(this.options.sanitize,this.options.baseUrl,Q),Q===null)return se;var oe='<a href="'+I(Q)+'"';return le&&(oe+=' title="'+le+'"'),oe+=">"+se+"</a>",oe},te.image=function(Q,le,se){if(Q=_(this.options.sanitize,this.options.baseUrl,Q),Q===null)return se;var oe='<img src="'+Q+'" alt="'+se+'"';return le&&(oe+=' title="'+le+'"'),oe+=this.options.xhtml?"/>":">",oe},te.text=function(Q){return Q},ee}(),ie=function(){function ee(){}var te=ee.prototype;return te.strong=function(Q){return Q},te.em=function(Q){return Q},te.codespan=function(Q){return Q},te.del=function(Q){return Q},te.html=function(Q){return Q},te.text=function(Q){return Q},te.link=function(Q,le,se){return""+se},te.image=function(Q,le,se){return""+se},te.br=function(){return""},ee}(),ne=function(){function ee(){this.seen={}}var te=ee.prototype;return te.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},te.getNextSafeSlug=function(Q,le){var se=Q,oe=0;if(this.seen.hasOwnProperty(se)){oe=this.seen[Q];do oe++,se=Q+"-"+oe;while(this.seen.hasOwnProperty(se))}return le||(this.seen[Q]=oe,this.seen[se]=0),se},te.slug=function(Q,le){le===void 0&&(le={});var se=this.serialize(Q);return this.getNextSafeSlug(se,le.dryrun)},ee}(),H=function(){function ee(ue){this.options=ue||re.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ie,this.slugger=new ne}ee.parse=function(Q,le){var se=new ee(le);return se.parse(Q)},ee.parseInline=function(Q,le){var se=new ee(le);return se.parseInline(Q)};var te=ee.prototype;return te.parse=function(Q,le){le===void 0&&(le=!0);var se="",oe,F,j,Y,Z,me,_e,fe,ke,Pe,$e,He,tt,Ge,Ke,st,at,Ze,rt,he=Q.length;for(oe=0;oe<he;oe++){if(Pe=Q[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(rt=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Pe.type))){se+=rt||"";continue}switch(Pe.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(Pe.tokens),Pe.depth,i(this.parseInline(Pe.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(Pe.text,Pe.lang,Pe.escaped);continue}case"table":{for(fe="",_e="",Y=Pe.header.length,F=0;F<Y;F++)_e+=this.renderer.tablecell(this.parseInline(Pe.header[F].tokens),{header:!0,align:Pe.align[F]});for(fe+=this.renderer.tablerow(_e),ke="",Y=Pe.rows.length,F=0;F<Y;F++){for(me=Pe.rows[F],_e="",Z=me.length,j=0;j<Z;j++)_e+=this.renderer.tablecell(this.parseInline(me[j].tokens),{header:!1,align:Pe.align[j]});ke+=this.renderer.tablerow(_e)}se+=this.renderer.table(fe,ke);continue}case"blockquote":{ke=this.parse(Pe.tokens),se+=this.renderer.blockquote(ke);continue}case"list":{for($e=Pe.ordered,He=Pe.start,tt=Pe.loose,Y=Pe.items.length,ke="",F=0;F<Y;F++)Ke=Pe.items[F],st=Ke.checked,at=Ke.task,Ge="",Ke.task&&(Ze=this.renderer.checkbox(st),tt?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=Ze+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=Ze+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:Ze}):Ge+=Ze),Ge+=this.parse(Ke.tokens,tt),ke+=this.renderer.listitem(Ge,at,st);se+=this.renderer.list(ke,$e,He);continue}case"html":{se+=this.renderer.html(Pe.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(Pe.tokens));continue}case"text":{for(ke=Pe.tokens?this.parseInline(Pe.tokens):Pe.text;oe+1<he&&Q[oe+1].type==="text";)Pe=Q[++oe],ke+=`
`+(Pe.tokens?this.parseInline(Pe.tokens):Pe.text);se+=le?this.renderer.paragraph(ke):ke;continue}default:{var Oe='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(Oe);return}else throw new Error(Oe)}}}return se},te.parseInline=function(Q,le){le=le||this.renderer;var se="",oe,F,j,Y=Q.length;for(oe=0;oe<Y;oe++){if(F=Q[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[F.type]&&(j=this.options.extensions.renderers[F.type].call({parser:this},F),j!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(F.type))){se+=j||"";continue}switch(F.type){case"escape":{se+=le.text(F.text);break}case"html":{se+=le.html(F.text);break}case"link":{se+=le.link(F.href,F.title,this.parseInline(F.tokens,le));break}case"image":{se+=le.image(F.href,F.title,F.text);break}case"strong":{se+=le.strong(this.parseInline(F.tokens,le));break}case"em":{se+=le.em(this.parseInline(F.tokens,le));break}case"codespan":{se+=le.codespan(F.text);break}case"br":{se+=le.br();break}case"del":{se+=le.del(this.parseInline(F.tokens,le));break}case"text":{se+=le.text(F.text);break}default:{var Z='Token with "'+F.type+'" type was not found.';if(this.options.silent){console.error(Z);return}else throw new Error(Z)}}}return se},ee}();function V(ee,te,ue){if(typeof ee>"u"||ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ee)+", string expected");if(typeof te=="function"&&(ue=te,te=null),te=h({},V.defaults,te||{}),r(te),ue){var Q=te.highlight,le;try{le=U.lex(ee,te)}catch(Y){return ue(Y)}var se=function(Z){var me;if(!Z)try{te.walkTokens&&V.walkTokens(le,te.walkTokens),me=H.parse(le,te)}catch(_e){Z=_e}return te.highlight=Q,Z?ue(Z):ue(null,me)};if(!Q||Q.length<3||(delete te.highlight,!le.length))return se();var oe=0;V.walkTokens(le,function(Y){Y.type==="code"&&(oe++,setTimeout(function(){Q(Y.text,Y.lang,function(Z,me){if(Z)return se(Z);me!=null&&me!==Y.text&&(Y.text=me,Y.escaped=!0),oe--,oe===0&&se()})},0))}),oe===0&&se();return}function F(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,te.silent)return"<p>An error occurred:</p><pre>"+I(Y.message+"",!0)+"</pre>";throw Y}try{var j=U.lex(ee,te);if(te.walkTokens){if(te.async)return Promise.all(V.walkTokens(j,te.walkTokens)).then(function(){return H.parse(j,te)}).catch(F);V.walkTokens(j,te.walkTokens)}return H.parse(j,te)}catch(Y){F(Y)}}V.options=V.setOptions=function(ee){return h(V.defaults,ee),g(V.defaults),V},V.getDefaults=R,V.defaults=re.defaults,V.use=function(){for(var ee=arguments.length,te=new Array(ee),ue=0;ue<ee;ue++)te[ue]=arguments[ue];var Q=h.apply(void 0,[{}].concat(te)),le=V.defaults.extensions||{renderers:{},childTokens:{}},se;te.forEach(function(oe){if(oe.extensions&&(se=!0,oe.extensions.forEach(function(j){if(!j.name)throw new Error("extension name required");if(j.renderer){var Y=le.renderers?le.renderers[j.name]:null;Y?le.renderers[j.name]=function(){for(var Z=arguments.length,me=new Array(Z),_e=0;_e<Z;_e++)me[_e]=arguments[_e];var fe=j.renderer.apply(this,me);return fe===!1&&(fe=Y.apply(this,me)),fe}:le.renderers[j.name]=j.renderer}if(j.tokenizer){if(!j.level||j.level!=="block"&&j.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[j.level]?le[j.level].unshift(j.tokenizer):le[j.level]=[j.tokenizer],j.start&&(j.level==="block"?le.startBlock?le.startBlock.push(j.start):le.startBlock=[j.start]:j.level==="inline"&&(le.startInline?le.startInline.push(j.start):le.startInline=[j.start]))}j.childTokens&&(le.childTokens[j.name]=j.childTokens)})),oe.renderer&&function(){var j=V.defaults.renderer||new de,Y=function(_e){var fe=j[_e];j[_e]=function(){for(var ke=arguments.length,Pe=new Array(ke),$e=0;$e<ke;$e++)Pe[$e]=arguments[$e];var He=oe.renderer[_e].apply(j,Pe);return He===!1&&(He=fe.apply(j,Pe)),He}};for(var Z in oe.renderer)Y(Z);Q.renderer=j}(),oe.tokenizer&&function(){var j=V.defaults.tokenizer||new $,Y=function(_e){var fe=j[_e];j[_e]=function(){for(var ke=arguments.length,Pe=new Array(ke),$e=0;$e<ke;$e++)Pe[$e]=arguments[$e];var He=oe.tokenizer[_e].apply(j,Pe);return He===!1&&(He=fe.apply(j,Pe)),He}};for(var Z in oe.tokenizer)Y(Z);Q.tokenizer=j}(),oe.walkTokens){var F=V.defaults.walkTokens;Q.walkTokens=function(j){var Y=[];return Y.push(oe.walkTokens.call(this,j)),F&&(Y=Y.concat(F.call(this,j))),Y}}se&&(Q.extensions=le),V.setOptions(Q)})},V.walkTokens=function(ee,te){for(var ue=[],Q=function(){var F=se.value;switch(ue=ue.concat(te.call(V,F)),F.type){case"table":{for(var j=L(F.header),Y;!(Y=j()).done;){var Z=Y.value;ue=ue.concat(V.walkTokens(Z.tokens,te))}for(var me=L(F.rows),_e;!(_e=me()).done;)for(var fe=_e.value,ke=L(fe),Pe;!(Pe=ke()).done;){var $e=Pe.value;ue=ue.concat(V.walkTokens($e.tokens,te))}break}case"list":{ue=ue.concat(V.walkTokens(F.items,te));break}default:V.defaults.extensions&&V.defaults.extensions.childTokens&&V.defaults.extensions.childTokens[F.type]?V.defaults.extensions.childTokens[F.type].forEach(function(He){ue=ue.concat(V.walkTokens(F[He],te))}):F.tokens&&(ue=ue.concat(V.walkTokens(F.tokens,te)))}},le=L(ee),se;!(se=le()).done;)Q();return ue},V.parseInline=function(ee,te){if(typeof ee>"u"||ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ee)+", string expected");te=h({},V.defaults,te||{}),r(te);try{var ue=U.lexInline(ee,te);return te.walkTokens&&V.walkTokens(ue,te.walkTokens),H.parseInline(ue,te)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,te.silent)return"<p>An error occurred:</p><pre>"+I(Q.message+"",!0)+"</pre>";throw Q}},V.Parser=H,V.parser=H.parse,V.Renderer=de,V.TextRenderer=ie,V.Lexer=U,V.lexer=U.lex,V.Tokenizer=$,V.Slugger=ne,V.parse=V;var ce=V.options,be=V.setOptions,Se=V.use,ge=V.walkTokens,O=V.parseInline,K=V,we=H.parse,Ce=U.lex;re.Lexer=U,re.Parser=H,re.Renderer=de,re.Slugger=ne,re.TextRenderer=ie,re.Tokenizer=$,re.getDefaults=R,re.lexer=Ce,re.marked=V,re.options=ce,re.parse=K,re.parseInline=O,re.parser=we,re.setOptions=be,re.use=Se,re.walkTokens=ge,Object.defineProperty(re,"__esModule",{value:!0})}),define(De[69],Ie([1,0,28]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const T=new v.LRUCache(1e4);function d(m){return y(m,"NFC",T)}e.normalizeNFC=d;const L=new v.LRUCache(1e4);function R(m){return y(m,"NFD",L)}e.normalizeNFD=R;const g=/[^\u0000-\u0080]/;function y(m,A,k){if(!m)return m;const w=k.get(m);if(w)return w;let D;return g.test(m)?D=m.normalize(A):D=m,k.set(m,D),D}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(A){return R(A).replace(m,"")}}()}),define(De[112],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function v(g,y,m){return Math.min(Math.max(g,y),m)}e.clamp=v;function T(g,y){return(y+g%y)%y}e.rot=T;class d{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=d;class L{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=L;class R{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const m=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=m,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=R}),function(){function re(d){const L=[];typeof d=="number"&&L.push("code/timeOrigin",d);function R(y){L.push(y,Date.now())}function g(){const y=[];for(let m=0;m<L.length;m+=2)y.push({name:L[m],startTime:L[m+1]});return y}return{mark:R,getMarks:g}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(d){performance.mark(d)},getMarks(){let d=performance.timeOrigin;typeof d!="number"&&(d=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(d)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(d+R.startTime)});return L}};if(typeof process=="object"){const d=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(d)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function v(d){return d.MonacoPerformanceMarks||(d.MonacoPerformanceMarks=e()),d.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=v(T))}(),function(re,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var T in v)(typeof exports=="object"?exports:re)[T]=v[T]}}(typeof self<"u"?self:this,function(){return function(re){var e={};function v(T){if(e[T])return e[T].exports;var d=e[T]={i:T,l:!1,exports:{}};return re[T].call(d.exports,d,d.exports,v),d.l=!0,d.exports}return v.m=re,v.c=e,v.d=function(T,d,L){v.o(T,d)||Object.defineProperty(T,d,{enumerable:!0,get:L})},v.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},v.t=function(T,d){if(1&d&&(T=v(T)),8&d||4&d&&typeof T=="object"&&T&&T.__esModule)return T;var L=Object.create(null);if(v.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:T}),2&d&&typeof T!="string")for(var R in T)v.d(L,R,function(g){return T[g]}.bind(null,R));return L},v.n=function(T){var d=T&&T.__esModule?function(){return T.default}:function(){return T};return v.d(d,"a",d),d},v.o=function(T,d){return Object.prototype.hasOwnProperty.call(T,d)},v.p="",v(v.s=0)}([function(re,e,v){(function(T){var d;e=re.exports=Se,d=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var fe=Array.prototype.slice.call(arguments,0);fe.unshift("SEMVER"),console.log.apply(console,fe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,g=e.re=[],y=e.src=[],m=0,A=m++;y[A]="0|[1-9]\\d*";var k=m++;y[k]="[0-9]+";var w=m++;y[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=m++;y[D]="("+y[A]+")\\.("+y[A]+")\\.("+y[A]+")";var I=m++;y[I]="("+y[k]+")\\.("+y[k]+")\\.("+y[k]+")";var E=m++;y[E]="(?:"+y[A]+"|"+y[w]+")";var i=m++;y[i]="(?:"+y[k]+"|"+y[w]+")";var l=m++;y[l]="(?:-("+y[E]+"(?:\\."+y[E]+")*))";var a=m++;y[a]="(?:-?("+y[i]+"(?:\\."+y[i]+")*))";var b=m++;y[b]="[0-9A-Za-z-]+";var f=m++;y[f]="(?:\\+("+y[b]+"(?:\\."+y[b]+")*))";var _=m++,n="v?"+y[D]+y[l]+"?"+y[f]+"?";y[_]="^"+n+"$";var o="[v=\\s]*"+y[I]+y[a]+"?"+y[f]+"?",s=m++;y[s]="^"+o+"$";var t=m++;y[t]="((?:<|>)?=?)";var u=m++;y[u]=y[k]+"|x|X|\\*";var p=m++;y[p]=y[A]+"|x|X|\\*";var h=m++;y[h]="[v=\\s]*("+y[p]+")(?:\\.("+y[p]+")(?:\\.("+y[p]+")(?:"+y[l]+")?"+y[f]+"?)?)?";var C=m++;y[C]="[v=\\s]*("+y[u]+")(?:\\.("+y[u]+")(?:\\.("+y[u]+")(?:"+y[a]+")?"+y[f]+"?)?)?";var S=m++;y[S]="^"+y[t]+"\\s*"+y[h]+"$";var c=m++;y[c]="^"+y[t]+"\\s*"+y[C]+"$";var r=m++;y[r]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=m++;y[P]="(?:~>?)";var M=m++;y[M]="(\\s*)"+y[P]+"\\s+",g[M]=new RegExp(y[M],"g");var W=m++;y[W]="^"+y[P]+y[h]+"$";var $=m++;y[$]="^"+y[P]+y[C]+"$";var z=m++;y[z]="(?:\\^)";var N=m++;y[N]="(\\s*)"+y[z]+"\\s+",g[N]=new RegExp(y[N],"g");var q=m++;y[q]="^"+y[z]+y[h]+"$";var x=m++;y[x]="^"+y[z]+y[C]+"$";var U=m++;y[U]="^"+y[t]+"\\s*("+o+")$|^$";var de=m++;y[de]="^"+y[t]+"\\s*("+n+")$|^$";var ie=m++;y[ie]="(\\s*)"+y[t]+"\\s*("+o+"|"+y[h]+")",g[ie]=new RegExp(y[ie],"g");var ne=m++;y[ne]="^\\s*("+y[h]+")\\s+-\\s+("+y[h]+")\\s*$";var H=m++;y[H]="^\\s*("+y[C]+")\\s+-\\s+("+y[C]+")\\s*$";var V=m++;y[V]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)d(ce,y[ce]),g[ce]||(g[ce]=new RegExp(y[ce]));function be(fe,ke){if(fe instanceof Se)return fe;if(typeof fe!="string"||fe.length>L||!(ke?g[s]:g[_]).test(fe))return null;try{return new Se(fe,ke)}catch{return null}}function Se(fe,ke){if(fe instanceof Se){if(fe.loose===ke)return fe;fe=fe.version}else if(typeof fe!="string")throw new TypeError("Invalid Version: "+fe);if(fe.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof Se))return new Se(fe,ke);d("SemVer",fe,ke),this.loose=ke;var Pe=fe.trim().match(ke?g[s]:g[_]);if(!Pe)throw new TypeError("Invalid Version: "+fe);if(this.raw=fe,this.major=+Pe[1],this.minor=+Pe[2],this.patch=+Pe[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Pe[4]?this.prerelease=Pe[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var He=+$e;if(He>=0&&He<R)return He}return $e}):this.prerelease=[],this.build=Pe[5]?Pe[5].split("."):[],this.format()}e.parse=be,e.valid=function(fe,ke){var Pe=be(fe,ke);return Pe?Pe.version:null},e.clean=function(fe,ke){var Pe=be(fe.trim().replace(/^[=v]+/,""),ke);return Pe?Pe.version:null},e.SemVer=Se,Se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Se.prototype.toString=function(){return this.version},Se.prototype.compare=function(fe){return d("SemVer.compare",this.version,this.loose,fe),fe instanceof Se||(fe=new Se(fe,this.loose)),this.compareMain(fe)||this.comparePre(fe)},Se.prototype.compareMain=function(fe){return fe instanceof Se||(fe=new Se(fe,this.loose)),O(this.major,fe.major)||O(this.minor,fe.minor)||O(this.patch,fe.patch)},Se.prototype.comparePre=function(fe){if(fe instanceof Se||(fe=new Se(fe,this.loose)),this.prerelease.length&&!fe.prerelease.length)return-1;if(!this.prerelease.length&&fe.prerelease.length)return 1;if(!this.prerelease.length&&!fe.prerelease.length)return 0;var ke=0;do{var Pe=this.prerelease[ke],$e=fe.prerelease[ke];if(d("prerelease compare",ke,Pe,$e),Pe===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(Pe===void 0)return-1;if(Pe!==$e)return O(Pe,$e)}while(++ke)},Se.prototype.inc=function(fe,ke){switch(fe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ke);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ke);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ke),this.inc("pre",ke);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ke),this.inc("pre",ke);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Pe=this.prerelease.length;--Pe>=0;)typeof this.prerelease[Pe]=="number"&&(this.prerelease[Pe]++,Pe=-2);Pe===-1&&this.prerelease.push(0)}ke&&(this.prerelease[0]===ke?isNaN(this.prerelease[1])&&(this.prerelease=[ke,0]):this.prerelease=[ke,0]);break;default:throw new Error("invalid increment argument: "+fe)}return this.format(),this.raw=this.version,this},e.inc=function(fe,ke,Pe,$e){typeof Pe=="string"&&($e=Pe,Pe=void 0);try{return new Se(fe,Pe).inc(ke,$e).version}catch{return null}},e.diff=function(fe,ke){if(ee(fe,ke))return null;var Pe=be(fe),$e=be(ke);if(Pe.prerelease.length||$e.prerelease.length){for(var He in Pe)if((He==="major"||He==="minor"||He==="patch")&&Pe[He]!==$e[He])return"pre"+He;return"prerelease"}for(var He in Pe)if((He==="major"||He==="minor"||He==="patch")&&Pe[He]!==$e[He])return He},e.compareIdentifiers=O;var ge=/^[0-9]+$/;function O(fe,ke){var Pe=ge.test(fe),$e=ge.test(ke);return Pe&&$e&&(fe=+fe,ke=+ke),Pe&&!$e?-1:$e&&!Pe?1:fe<ke?-1:fe>ke?1:0}function K(fe,ke,Pe){return new Se(fe,Pe).compare(new Se(ke,Pe))}function we(fe,ke,Pe){return K(fe,ke,Pe)>0}function Ce(fe,ke,Pe){return K(fe,ke,Pe)<0}function ee(fe,ke,Pe){return K(fe,ke,Pe)===0}function te(fe,ke,Pe){return K(fe,ke,Pe)!==0}function ue(fe,ke,Pe){return K(fe,ke,Pe)>=0}function Q(fe,ke,Pe){return K(fe,ke,Pe)<=0}function le(fe,ke,Pe,$e){var He;switch(ke){case"===":typeof fe=="object"&&(fe=fe.version),typeof Pe=="object"&&(Pe=Pe.version),He=fe===Pe;break;case"!==":typeof fe=="object"&&(fe=fe.version),typeof Pe=="object"&&(Pe=Pe.version),He=fe!==Pe;break;case"":case"=":case"==":He=ee(fe,Pe,$e);break;case"!=":He=te(fe,Pe,$e);break;case">":He=we(fe,Pe,$e);break;case">=":He=ue(fe,Pe,$e);break;case"<":He=Ce(fe,Pe,$e);break;case"<=":He=Q(fe,Pe,$e);break;default:throw new TypeError("Invalid operator: "+ke)}return He}function se(fe,ke){if(fe instanceof se){if(fe.loose===ke)return fe;fe=fe.value}if(!(this instanceof se))return new se(fe,ke);d("comparator",fe,ke),this.loose=ke,this.parse(fe),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,d("comp",this)}e.rcompareIdentifiers=function(fe,ke){return O(ke,fe)},e.major=function(fe,ke){return new Se(fe,ke).major},e.minor=function(fe,ke){return new Se(fe,ke).minor},e.patch=function(fe,ke){return new Se(fe,ke).patch},e.compare=K,e.compareLoose=function(fe,ke){return K(fe,ke,!0)},e.rcompare=function(fe,ke,Pe){return K(ke,fe,Pe)},e.sort=function(fe,ke){return fe.sort(function(Pe,$e){return e.compare(Pe,$e,ke)})},e.rsort=function(fe,ke){return fe.sort(function(Pe,$e){return e.rcompare(Pe,$e,ke)})},e.gt=we,e.lt=Ce,e.eq=ee,e.neq=te,e.gte=ue,e.lte=Q,e.cmp=le,e.Comparator=se;var oe={};function F(fe,ke){if(fe instanceof F)return fe.loose===ke?fe:new F(fe.raw,ke);if(fe instanceof se)return new F(fe.value,ke);if(!(this instanceof F))return new F(fe,ke);if(this.loose=ke,this.raw=fe,this.set=fe.split(/\s*\|\|\s*/).map(function(Pe){return this.parseRange(Pe.trim())},this).filter(function(Pe){return Pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+fe);this.format()}function j(fe){return!fe||fe.toLowerCase()==="x"||fe==="*"}function Y(fe,ke,Pe,$e,He,tt,Ge,Ke,st,at,Ze,rt,he){return((ke=j(Pe)?"":j($e)?">="+Pe+".0.0":j(He)?">="+Pe+"."+$e+".0":">="+ke)+" "+(Ke=j(st)?"":j(at)?"<"+(+st+1)+".0.0":j(Ze)?"<"+st+"."+(+at+1)+".0":rt?"<="+st+"."+at+"."+Ze+"-"+rt:"<="+Ke)).trim()}function Z(fe,ke){for(var Pe=0;Pe<fe.length;Pe++)if(!fe[Pe].test(ke))return!1;if(ke.prerelease.length){for(Pe=0;Pe<fe.length;Pe++)if(d(fe[Pe].semver),fe[Pe].semver!==oe&&fe[Pe].semver.prerelease.length>0){var $e=fe[Pe].semver;if($e.major===ke.major&&$e.minor===ke.minor&&$e.patch===ke.patch)return!0}return!1}return!0}function me(fe,ke,Pe){try{ke=new F(ke,Pe)}catch{return!1}return ke.test(fe)}function _e(fe,ke,Pe,$e){var He,tt,Ge,Ke,st;switch(fe=new Se(fe,$e),ke=new F(ke,$e),Pe){case">":He=we,tt=Q,Ge=Ce,Ke=">",st=">=";break;case"<":He=Ce,tt=ue,Ge=we,Ke="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(me(fe,ke,$e))return!1;for(var at=0;at<ke.set.length;++at){var Ze=ke.set[at],rt=null,he=null;if(Ze.forEach(function(Oe){Oe.semver===oe&&(Oe=new se(">=0.0.0")),rt=rt||Oe,he=he||Oe,He(Oe.semver,rt.semver,$e)?rt=Oe:Ge(Oe.semver,he.semver,$e)&&(he=Oe)}),rt.operator===Ke||rt.operator===st||(!he.operator||he.operator===Ke)&&tt(fe,he.semver)||he.operator===st&&Ge(fe,he.semver))return!1}return!0}se.prototype.parse=function(fe){var ke=this.loose?g[U]:g[de],Pe=fe.match(ke);if(!Pe)throw new TypeError("Invalid comparator: "+fe);this.operator=Pe[1],this.operator==="="&&(this.operator=""),Pe[2]?this.semver=new Se(Pe[2],this.loose):this.semver=oe},se.prototype.toString=function(){return this.value},se.prototype.test=function(fe){return d("Comparator.test",fe,this.loose),this.semver===oe||(typeof fe=="string"&&(fe=new Se(fe,this.loose)),le(fe,this.operator,this.semver,this.loose))},se.prototype.intersects=function(fe,ke){if(!(fe instanceof se))throw new TypeError("a Comparator is required");var Pe;if(this.operator==="")return Pe=new F(fe.value,ke),me(this.value,Pe,ke);if(fe.operator==="")return Pe=new F(this.value,ke),me(fe.semver,Pe,ke);var $e=!(this.operator!==">="&&this.operator!==">"||fe.operator!==">="&&fe.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||fe.operator!=="<="&&fe.operator!=="<"),tt=this.semver.version===fe.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||fe.operator!==">="&&fe.operator!=="<="),Ke=le(this.semver,"<",fe.semver,ke)&&(this.operator===">="||this.operator===">")&&(fe.operator==="<="||fe.operator==="<"),st=le(this.semver,">",fe.semver,ke)&&(this.operator==="<="||this.operator==="<")&&(fe.operator===">="||fe.operator===">");return $e||He||tt&&Ge||Ke||st},e.Range=F,F.prototype.format=function(){return this.range=this.set.map(function(fe){return fe.join(" ").trim()}).join("||").trim(),this.range},F.prototype.toString=function(){return this.range},F.prototype.parseRange=function(fe){var ke=this.loose;fe=fe.trim(),d("range",fe,ke);var Pe=ke?g[H]:g[ne];fe=fe.replace(Pe,Y),d("hyphen replace",fe),fe=fe.replace(g[ie],"$1$2$3"),d("comparator trim",fe,g[ie]),fe=(fe=(fe=fe.replace(g[M],"$1~")).replace(g[N],"$1^")).split(/\s+/).join(" ");var $e=ke?g[U]:g[de],He=fe.split(" ").map(function(tt){return function(Ge,Ke){return d("comp",Ge),Ge=function(st,at){return st.trim().split(/\s+/).map(function(Ze){return function(rt,he){d("caret",rt,he);var Oe=he?g[x]:g[q];return rt.replace(Oe,function(J,X,Ee,Ue,Ne){var Qe;return d("caret",rt,J,X,Ee,Ue,Ne),j(X)?Qe="":j(Ee)?Qe=">="+X+".0.0 <"+(+X+1)+".0.0":j(Ue)?Qe=X==="0"?">="+X+"."+Ee+".0 <"+X+"."+(+Ee+1)+".0":">="+X+"."+Ee+".0 <"+(+X+1)+".0.0":Ne?(d("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Qe=X==="0"?Ee==="0"?">="+X+"."+Ee+"."+Ue+Ne+" <"+X+"."+Ee+"."+(+Ue+1):">="+X+"."+Ee+"."+Ue+Ne+" <"+X+"."+(+Ee+1)+".0":">="+X+"."+Ee+"."+Ue+Ne+" <"+(+X+1)+".0.0"):(d("no pr"),Qe=X==="0"?Ee==="0"?">="+X+"."+Ee+"."+Ue+" <"+X+"."+Ee+"."+(+Ue+1):">="+X+"."+Ee+"."+Ue+" <"+X+"."+(+Ee+1)+".0":">="+X+"."+Ee+"."+Ue+" <"+(+X+1)+".0.0"),d("caret return",Qe),Qe})}(Ze,at)}).join(" ")}(Ge,Ke),d("caret",Ge),Ge=function(st,at){return st.trim().split(/\s+/).map(function(Ze){return function(rt,he){var Oe=he?g[$]:g[W];return rt.replace(Oe,function(J,X,Ee,Ue,Ne){var Qe;return d("tilde",rt,J,X,Ee,Ue,Ne),j(X)?Qe="":j(Ee)?Qe=">="+X+".0.0 <"+(+X+1)+".0.0":j(Ue)?Qe=">="+X+"."+Ee+".0 <"+X+"."+(+Ee+1)+".0":Ne?(d("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Qe=">="+X+"."+Ee+"."+Ue+Ne+" <"+X+"."+(+Ee+1)+".0"):Qe=">="+X+"."+Ee+"."+Ue+" <"+X+"."+(+Ee+1)+".0",d("tilde return",Qe),Qe})}(Ze,at)}).join(" ")}(Ge,Ke),d("tildes",Ge),Ge=function(st,at){return d("replaceXRanges",st,at),st.split(/\s+/).map(function(Ze){return function(rt,he){rt=rt.trim();var Oe=he?g[c]:g[S];return rt.replace(Oe,function(J,X,Ee,Ue,Ne,Qe){d("xRange",rt,J,X,Ee,Ue,Ne,Qe);var et=j(Ee),nt=et||j(Ue),ft=nt||j(Ne);return X==="="&&ft&&(X=""),et?J=X===">"||X==="<"?"<0.0.0":"*":X&&ft?(nt&&(Ue=0),ft&&(Ne=0),X===">"?(X=">=",nt?(Ee=+Ee+1,Ue=0,Ne=0):ft&&(Ue=+Ue+1,Ne=0)):X==="<="&&(X="<",nt?Ee=+Ee+1:Ue=+Ue+1),J=X+Ee+"."+Ue+"."+Ne):nt?J=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ft&&(J=">="+Ee+"."+Ue+".0 <"+Ee+"."+(+Ue+1)+".0"),d("xRange return",J),J})}(Ze,at)}).join(" ")}(Ge,Ke),d("xrange",Ge),Ge=function(st,at){return d("replaceStars",st,at),st.trim().replace(g[V],"")}(Ge,Ke),d("stars",Ge),Ge}(tt,ke)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(tt){return!!tt.match($e)})),He=He.map(function(tt){return new se(tt,ke)})},F.prototype.intersects=function(fe,ke){if(!(fe instanceof F))throw new TypeError("a Range is required");return this.set.some(function(Pe){return Pe.every(function($e){return fe.set.some(function(He){return He.every(function(tt){return $e.intersects(tt,ke)})})})})},e.toComparators=function(fe,ke){return new F(fe,ke).set.map(function(Pe){return Pe.map(function($e){return $e.value}).join(" ").trim().split(" ")})},F.prototype.test=function(fe){if(!fe)return!1;typeof fe=="string"&&(fe=new Se(fe,this.loose));for(var ke=0;ke<this.set.length;ke++)if(Z(this.set[ke],fe))return!0;return!1},e.satisfies=me,e.maxSatisfying=function(fe,ke,Pe){var $e=null,He=null;try{var tt=new F(ke,Pe)}catch{return null}return fe.forEach(function(Ge){tt.test(Ge)&&($e&&He.compare(Ge)!==-1||(He=new Se($e=Ge,Pe)))}),$e},e.minSatisfying=function(fe,ke,Pe){var $e=null,He=null;try{var tt=new F(ke,Pe)}catch{return null}return fe.forEach(function(Ge){tt.test(Ge)&&($e&&He.compare(Ge)!==1||(He=new Se($e=Ge,Pe)))}),$e},e.validRange=function(fe,ke){try{return new F(fe,ke).range||"*"}catch{return null}},e.ltr=function(fe,ke,Pe){return _e(fe,ke,"<",Pe)},e.gtr=function(fe,ke,Pe){return _e(fe,ke,">",Pe)},e.outside=_e,e.prerelease=function(fe,ke){var Pe=be(fe,ke);return Pe&&Pe.prerelease.length?Pe.prerelease:null},e.intersects=function(fe,ke,Pe){return fe=new F(fe,Pe),ke=new F(ke,Pe),fe.intersects(ke)},e.coerce=function(fe){if(fe instanceof Se)return fe;if(typeof fe!="string")return null;var ke=fe.match(g[r]);return ke==null?null:be((ke[1]||"0")+"."+(ke[2]||"0")+"."+(ke[3]||"0"))}}).call(this,v(1))},function(re,e){var v,T,d=re.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function g(i){if(v===setTimeout)return setTimeout(i,0);if((v===L||!v)&&setTimeout)return v=setTimeout,setTimeout(i,0);try{return v(i,0)}catch{try{return v.call(null,i,0)}catch{return v.call(this,i,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:L}catch{v=L}try{T=typeof clearTimeout=="function"?clearTimeout:R}catch{T=R}})();var y,m=[],A=!1,k=-1;function w(){A&&y&&(A=!1,y.length?m=y.concat(m):k=-1,m.length&&D())}function D(){if(!A){var i=g(w);A=!0;for(var l=m.length;l;){for(y=m,m=[];++k<l;)y&&y[k].run();k=-1,l=m.length}y=null,A=!1,function(a){if(T===clearTimeout)return clearTimeout(a);if((T===R||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(a);try{T(a)}catch{try{return T.call(null,a)}catch{return T.call(this,a)}}}(i)}}function I(i,l){this.fun=i,this.array=l}function E(){}d.nextTick=function(i){var l=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)l[a-1]=arguments[a];m.push(new I(i,l)),m.length!==1||A||g(D)},I.prototype.run=function(){this.fun.apply(null,this.array)},d.title="browser",d.browser=!0,d.env={},d.argv=[],d.version="",d.versions={},d.on=E,d.addListener=E,d.once=E,d.off=E,d.removeListener=E,d.removeAllListeners=E,d.emit=E,d.prependListener=E,d.prependOnceListener=E,d.listeners=function(i){return[]},d.binding=function(i){throw new Error("process.binding is not supported")},d.cwd=function(){return"/"},d.chdir=function(i){throw new Error("process.chdir is not supported")},d.umask=function(){return 0}}])}),define(De[39],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const v=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(L){return new T(L)}constructor(L){this._now=v&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=T}),define(De[3],Ie([1,0,8,67,4,68,39]),function(re,e,v,T,d,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const g=!1,y=!1;var m;(function(C){C.None=()=>d.Disposable.None;function S(ee){if(y){const{onDidAddListener:te}=ee,ue=I.create();let Q=0;ee.onDidAddListener=()=>{++Q===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ue.print()),te?.()}}}function c(ee,te){return x(ee,()=>{},0,void 0,!0,void 0,te)}C.defer=c;function r(ee){return(te,ue=null,Q)=>{let le=!1,se;return se=ee(oe=>{if(!le)return se?se.dispose():le=!0,te.call(ue,oe)},null,Q),le&&se.dispose(),se}}C.once=r;function P(ee,te,ue){return q((Q,le=null,se)=>ee(oe=>Q.call(le,te(oe)),null,se),ue)}C.map=P;function M(ee,te,ue){return q((Q,le=null,se)=>ee(oe=>{te(oe),Q.call(le,oe)},null,se),ue)}C.forEach=M;function W(ee,te,ue){return q((Q,le=null,se)=>ee(oe=>te(oe)&&Q.call(le,oe),null,se),ue)}C.filter=W;function $(ee){return ee}C.signal=$;function z(...ee){return(te,ue=null,Q)=>(0,d.combinedDisposable)(...ee.map(le=>le(se=>te.call(ue,se),null,Q)))}C.any=z;function N(ee,te,ue,Q){let le=ue;return P(ee,se=>(le=te(le,se),le),Q)}C.reduce=N;function q(ee,te){let ue;const Q={onWillAddFirstListener(){ue=ee(le.fire,le)},onDidRemoveLastListener(){ue?.dispose()}};te||S(Q);const le=new b(Q);return te?.add(le),le.event}function x(ee,te,ue=100,Q=!1,le=!1,se,oe){let F,j,Y,Z=0,me;const _e={leakWarningThreshold:se,onWillAddFirstListener(){F=ee(ke=>{Z++,j=te(j,ke),Q&&!Y&&(fe.fire(j),j=void 0),me=()=>{const Pe=j;j=void 0,Y=void 0,(!Q||Z>1)&&fe.fire(Pe),Z=0},typeof ue=="number"?(clearTimeout(Y),Y=setTimeout(me,ue)):Y===void 0&&(Y=0,queueMicrotask(me))})},onWillRemoveListener(){le&&Z>0&&me?.()},onDidRemoveLastListener(){me=void 0,F.dispose()}};oe||S(_e);const fe=new b(_e);return oe?.add(fe),fe.event}C.debounce=x;function U(ee,te=0,ue){return C.debounce(ee,(Q,le)=>Q?(Q.push(le),Q):[le],te,void 0,!0,void 0,ue)}C.accumulate=U;function de(ee,te=(Q,le)=>Q===le,ue){let Q=!0,le;return W(ee,se=>{const oe=Q||!te(se,le);return Q=!1,le=se,oe},ue)}C.latch=de;function ie(ee,te,ue){return[C.filter(ee,te,ue),C.filter(ee,Q=>!te(Q),ue)]}C.split=ie;function ne(ee,te=!1,ue=[]){let Q=ue.slice(),le=ee(F=>{Q?Q.push(F):oe.fire(F)});const se=()=>{Q?.forEach(F=>oe.fire(F)),Q=null},oe=new b({onWillAddFirstListener(){le||(le=ee(F=>oe.fire(F)))},onDidAddFirstListener(){Q&&(te?setTimeout(se):se())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return oe.event}C.buffer=ne;class H{constructor(te){this.event=te,this.disposables=new d.DisposableStore}map(te){return new H(P(this.event,te,this.disposables))}forEach(te){return new H(M(this.event,te,this.disposables))}filter(te){return new H(W(this.event,te,this.disposables))}reduce(te,ue){return new H(N(this.event,te,ue,this.disposables))}latch(){return new H(de(this.event,void 0,this.disposables))}debounce(te,ue=100,Q=!1,le=!1,se){return new H(x(this.event,te,ue,Q,le,se,this.disposables))}on(te,ue,Q){return this.event(te,ue,Q)}once(te,ue,Q){return r(this.event)(te,ue,Q)}dispose(){this.disposables.dispose()}}function V(ee){return new H(ee)}C.chain=V;function ce(ee,te,ue=Q=>Q){const Q=(...F)=>oe.fire(ue(...F)),le=()=>ee.on(te,Q),se=()=>ee.removeListener(te,Q),oe=new b({onWillAddFirstListener:le,onDidRemoveLastListener:se});return oe.event}C.fromNodeEventEmitter=ce;function be(ee,te,ue=Q=>Q){const Q=(...F)=>oe.fire(ue(...F)),le=()=>ee.addEventListener(te,Q),se=()=>ee.removeEventListener(te,Q),oe=new b({onWillAddFirstListener:le,onDidRemoveLastListener:se});return oe.event}C.fromDOMEventEmitter=be;function Se(ee){return new Promise(te=>r(ee)(te))}C.toPromise=Se;function ge(ee,te){return te(void 0),ee(ue=>te(ue))}C.runAndSubscribe=ge;function O(ee,te){let ue=null;function Q(se){ue?.dispose(),ue=new d.DisposableStore,te(se,ue)}Q(void 0);const le=ee(se=>Q(se));return(0,d.toDisposable)(()=>{le.dispose(),ue?.dispose()})}C.runAndSubscribeWithStore=O;class K{constructor(te,ue){this._observable=te,this._counter=0,this._hasChanged=!1;const Q={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};ue||S(Q),this.emitter=new b(Q),ue&&ue.add(this.emitter)}beginUpdate(te){this._counter++}handlePossibleChange(te){}handleChange(te,ue){this._hasChanged=!0}endUpdate(te){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function we(ee,te){return new K(ee,te).emitter.event}C.fromObservable=we;function Ce(ee){return te=>{let ue=0,Q=!1;const le={beginUpdate(){ue++},endUpdate(){ue--,ue===0&&(ee.reportChanges(),Q&&(Q=!1,te()))},handlePossibleChange(){},handleChange(){Q=!0}};return ee.addObserver(le),{dispose(){ee.removeObserver(le)}}}}C.fromObservableLight=Ce})(m||(e.Event=m={}));class A{constructor(S){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${S}_${A._idPool++}`,A.all.add(this)}start(S){this._stopWatch=new R.StopWatch,this.listenerCount=S}stop(){if(this._stopWatch){const S=this._stopWatch.elapsed();this.durations.push(S),this.elapsedOverall+=S,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=A,A.all=new Set,A._idPool=0;let k=-1;function w(C){const S=k;return k=C,{dispose(){k=S}}}e.setGlobalLeakWarningThreshold=w;class D{constructor(S,c=Math.random().toString(18).slice(2,5)){this.threshold=S,this.name=c,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(S,c){const r=this.threshold;if(r<=0||c<r)return;this._stacks||(this._stacks=new Map);const P=this._stacks.get(S.value)||0;if(this._stacks.set(S.value,P+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let M,W=0;for(const[$,z]of this._stacks)(!M||W<z)&&(M=$,W=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${W}):`),console.warn(M)}return()=>{const M=this._stacks.get(S.value)||0;this._stacks.set(S.value,M-1)}}}class I{static create(){return new I(new Error().stack??"")}constructor(S){this.value=S}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let E=0;class i{constructor(S){this.value=S,this.id=E++}}const l=2,a=(C,S)=>{if(C instanceof i)S(C);else for(let c=0;c<C.length;c++){const r=C[c];r&&S(r)}};class b{constructor(S){this._size=0,this._options=S,this._leakageMon=k>0||this._options?.leakWarningThreshold?new D(this._options?.leakWarningThreshold??k):void 0,this._perfMon=this._options?._profName?new A(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(g){const S=this._listeners;queueMicrotask(()=>{a(S,c=>c.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(S,c,r)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),d.Disposable.None;if(this._disposed)return d.Disposable.None;c&&(S=S.bind(c));const P=new i(S);let M,W;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(P.stack=I.create(),M=this._leakageMon.check(P.stack,this._size+1)),g&&(P.stack=W??I.create()),this._listeners?this._listeners instanceof i?(this._deliveryQueue??=new _,this._listeners=[this._listeners,P]):this._listeners.push(P):(this._options?.onWillAddFirstListener?.(this),this._listeners=P,this._options?.onDidAddFirstListener?.(this)),this._size++;const $=(0,d.toDisposable)(()=>{M?.(),this._removeListener(P)});return r instanceof d.DisposableStore?r.add($):Array.isArray(r)&&r.push($),$},this._event}_removeListener(S){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const c=this._listeners,r=c.indexOf(S);if(r===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,c[r]=void 0;const P=this._deliveryQueue.current===this;if(this._size*l<=c.length){let M=0;for(let W=0;W<c.length;W++)c[W]?c[M++]=c[W]:P&&(this._deliveryQueue.end--,M<this._deliveryQueue.i&&this._deliveryQueue.i--);c.length=M}}_deliver(S,c){if(!S)return;const r=this._options?.onListenerError||v.onUnexpectedError;if(!r){S.value(c);return}try{S.value(c)}catch(P){r(P)}}_deliverQueue(S){const c=S.current._listeners;for(;S.i<S.end;)this._deliver(c[S.i++],S.value);S.reset()}fire(S){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof i)this._deliver(this._listeners,S);else{const c=this._deliveryQueue;c.enqueue(this,S,this._listeners.length),this._deliverQueue(c)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=b;const f=()=>new _;e.createEventDeliveryQueue=f;class _{constructor(){this.i=-1,this.end=0}enqueue(S,c,r){this.i=0,this.end=r,this.current=S,this.value=c}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends b{async fireAsync(S,c,r){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList),a(this._listeners,P=>this._asyncDeliveryQueue.push([P.value,S]));this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[P,M]=this._asyncDeliveryQueue.shift(),W=[],$={...M,token:c,waitUntil:z=>{if(Object.isFrozen(W))throw new Error("waitUntil can NOT be called asynchronous");r&&(z=r(z,P)),W.push(z)}};try{P($)}catch(z){(0,v.onUnexpectedError)(z);continue}Object.freeze(W),await Promise.allSettled(W).then(z=>{for(const N of z)N.status==="rejected"&&(0,v.onUnexpectedError)(N.reason)})}}}e.AsyncEmitter=n;class o extends b{get isPaused(){return this._isPaused!==0}constructor(S){super(S),this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=S?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const S=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(S))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(S){this._size&&(this._isPaused!==0?this._eventQueue.push(S):super.fire(S))}}e.PauseableEmitter=o;class s extends o{constructor(S){super(S),this._delay=S.delay??100}fire(S){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(S)}}e.DebounceEmitter=s;class t extends b{constructor(S){super(S),this._queuedEvents=[],this._mergeFn=S?.merge}fire(S){this.hasListeners()&&(this._queuedEvents.push(S),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(c=>super.fire(c)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=t;class u{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(S){const c={event:S,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const r=()=>{this.hasListeners&&this.unhook(c);const P=this.events.indexOf(c);this.events.splice(P,1)};return(0,d.toDisposable)((0,T.once)(r))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(S=>this.hook(S))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(S=>this.unhook(S))}hook(S){S.listener=S.event(c=>this.emitter.fire(c))}unhook(S){S.listener&&S.listener.dispose(),S.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=u;class p{constructor(){this.buffers=[]}wrapEvent(S){return(c,r,P)=>S(M=>{const W=this.buffers[this.buffers.length-1];W?W.push(()=>c.call(r,M)):c.call(r,M)},void 0,P)}bufferEvents(S){const c=[];this.buffers.push(c);const r=S();return this.buffers.pop(),c.forEach(P=>P()),r}}e.EventBufferer=p;class h{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=d.Disposable.None,this.emitter=new b({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(S){this.inputEvent=S,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=S(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=h}),define(De[21],Ie([1,0,3]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(g,y){const m=setTimeout(g.bind(y),0);return{dispose(){clearTimeout(m)}}});var d;(function(g){function y(m){return m===g.None||m===g.Cancelled||m instanceof L?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}g.isCancellationToken=y,g.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),g.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(d||(e.CancellationToken=d={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=d.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=d.None}}e.CancellationTokenSource=R}),define(De[152],Ie([1,0,21]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class T{constructor(g){this.task=g,this.result=null}get(){if(this.result)return this.result;const g=new v.CancellationTokenSource,y=this.task(g.token);return this.result={promise:y,dispose:()=>{this.result=null,g.cancel(),g.dispose()}},this.result}}e.Cache=T;class d{constructor(g){this.fn=g,this.lastCache=void 0,this.lastArgKey=void 0}get(g){const y=JSON.stringify(g);return this.lastArgKey!==y&&(this.lastArgKey=y,this.lastCache=this.fn(g)),this.lastCache}}e.LRUCachedFunction=d;class L{get cachedValues(){return this._map}constructor(g){this.fn=g,this._map=new Map}get(g){if(this._map.has(g))return this._map.get(g);const y=this.fn(g);return this._map.set(g,y),y}}e.CachedFunction=L}),define(De[91],Ie([1,0,8,4]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function d(f){const _=f;return _?typeof _.read=="function":!1}e.isReadable=d;function L(f){const _=f;return _?[_.on,_.pause,_.resume,_.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=L;function R(f){const _=f;return _?L(_.stream)&&Array.isArray(_.buffer)&&typeof _.ended=="boolean":!1}e.isReadableBufferedStream=R;function g(f,_){return new y(f,_)}e.newWriteableStream=g;class y{constructor(_,n){this.reducer=_,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(_){if(!this.state.destroyed){if(this.state.flowing)this.emitData(_);else if(this.buffer.data.push(_),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(_){this.state.destroyed||(this.state.flowing?this.emitError(_):this.buffer.error.push(_))}end(_){this.state.destroyed||(typeof _<"u"&&this.write(_),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(_){this.listeners.data.slice(0).forEach(n=>n(_))}emitError(_){this.listeners.error.length===0?(0,v.onUnexpectedError)(_):this.listeners.error.slice(0).forEach(n=>n(_))}emitEnd(){this.listeners.end.slice(0).forEach(_=>_())}on(_,n){if(!this.state.destroyed)switch(_){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(_,n){if(this.state.destroyed)return;let o;switch(_){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const s=o.indexOf(n);s>=0&&o.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const _=this.reducer(this.buffer.data);this.emitData(_),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const _ of this.buffer.error)this.emitError(_);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(f,_){const n=[];let o;for(;(o=f.read())!==null;)n.push(o);return _(n)}e.consumeReadable=m;function A(f,_,n){const o=[];let s;for(;(s=f.read())!==null&&o.length<n;)o.push(s);return s===null&&o.length>0?_(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const t=s;return s=void 0,t}return f.read()}}}e.peekReadable=A;function k(f,_){return new Promise((n,o)=>{const s=[];w(f,{onData:t=>{_&&s.push(t)},onError:t=>{_?o(t):n(void 0)},onEnd:()=>{n(_?_(s):void 0)}})})}e.consumeStream=k;function w(f,_){let n=!1;return f.on("error",o=>{n||_.onError(o)}),f.on("end",()=>{n||_.onEnd()}),f.on("data",o=>{n||_.onData(o)}),(0,T.toDisposable)(()=>n=!0)}e.listenStream=w;function D(f,_){return new Promise((n,o)=>{const s=new T.DisposableStore,t=[],u=C=>{if(t.push(C),t.length>_)return s.dispose(),f.pause(),n({stream:f,buffer:t,ended:!1})},p=C=>o(C),h=()=>n({stream:f,buffer:t,ended:!0});s.add((0,T.toDisposable)(()=>f.removeListener("error",p))),f.on("error",p),s.add((0,T.toDisposable)(()=>f.removeListener("end",h))),f.on("end",h),s.add((0,T.toDisposable)(()=>f.removeListener("data",u))),f.on("data",u)})}e.peekStream=D;function I(f,_){const n=g(_);return n.end(f),n}e.toStream=I;function E(){const f=g(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=E;function i(f){let _=!1;return{read:()=>_?null:(_=!0,f)}}e.toReadable=i;function l(f,_,n){const o=g(n);return w(f,{onData:s=>o.write(_.data(s)),onError:s=>o.error(_.error?_.error(s):s),onEnd:()=>o.end()}),o}e.transform=l;function a(f,_,n){let o=!1;return{read:()=>{const s=_.read();return o?s:(o=!0,s!==null?n([f,s]):f)}}}e.prefixedReadable=a;function b(f,_,n){let o=!1;const s=g(n);return w(_,{onData:t=>o?s.write(t):(o=!0,s.write(n([f,t]))),onError:t=>s.error(t),onEnd:()=>{o||(o=!0,s.write(f)),s.end()}}),s}e.prefixedStream=b}),define(De[22],Ie([1,0,54,91]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const d=typeof Buffer<"u",L=new v.Lazy(()=>new Uint8Array(256));let R,g;class y{static alloc(c){return d?new y(Buffer.allocUnsafe(c)):new y(new Uint8Array(c))}static wrap(c){return d&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new y(c)}static fromString(c,r){return!(r?.dontUseNodeBuffer||!1)&&d?new y(Buffer.from(c)):(R||(R=new TextEncoder),new y(R.encode(c)))}static fromByteArray(c){const r=y.alloc(c.length);for(let P=0,M=c.length;P<M;P++)r.buffer[P]=c[P];return r}static concat(c,r){if(typeof r>"u"){r=0;for(let W=0,$=c.length;W<$;W++)r+=c[W].byteLength}const P=y.alloc(r);let M=0;for(let W=0,$=c.length;W<$;W++){const z=c[W];P.set(z,M),M+=z.byteLength}return P}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=y.alloc(this.byteLength);return c.set(this),c}toString(){return d?this.buffer.toString():(g||(g=new TextDecoder),g.decode(this.buffer))}slice(c,r){return new y(this.buffer.subarray(c,r))}set(c,r){if(c instanceof y)this.buffer.set(c.buffer,r);else if(c instanceof Uint8Array)this.buffer.set(c,r);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),r);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),r);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return k(this.buffer,c)}writeUInt32BE(c,r){w(this.buffer,c,r)}readUInt32LE(c){return D(this.buffer,c)}writeUInt32LE(c,r){I(this.buffer,c,r)}readUInt8(c){return E(this.buffer,c)}writeUInt8(c,r){i(this.buffer,c,r)}indexOf(c){const r=c instanceof y?c.buffer:c,P=r.byteLength,M=this.buffer,W=M.byteLength;if(P===0)return 0;if(P===1)return M.indexOf(r[0]);if(P>W)return-1;const $=L.value;$.fill(r.length);for(let x=0;x<r.length;x++)$[r[x]]=r.length-x-1;let z=r.length-1,N=z,q=-1;for(;z<W;)if(M[z]===r[N]){if(N===0){q=z;break}z--,N--}else z+=Math.max(r.length-N,$[M[z]]),N=r.length-1;return q}}e.VSBuffer=y;function m(S,c){return S[c+0]<<0>>>0|S[c+1]<<8>>>0}e.readUInt16LE=m;function A(S,c,r){S[r+0]=c&255,c=c>>>8,S[r+1]=c&255}e.writeUInt16LE=A;function k(S,c){return S[c]*2**24+S[c+1]*2**16+S[c+2]*2**8+S[c+3]}e.readUInt32BE=k;function w(S,c,r){S[r+3]=c,c=c>>>8,S[r+2]=c,c=c>>>8,S[r+1]=c,c=c>>>8,S[r]=c}e.writeUInt32BE=w;function D(S,c){return S[c+0]<<0>>>0|S[c+1]<<8>>>0|S[c+2]<<16>>>0|S[c+3]<<24>>>0}e.readUInt32LE=D;function I(S,c,r){S[r+0]=c&255,c=c>>>8,S[r+1]=c&255,c=c>>>8,S[r+2]=c&255,c=c>>>8,S[r+3]=c&255}e.writeUInt32LE=I;function E(S,c){return S[c]}e.readUInt8=E;function i(S,c,r){S[r]=c}e.writeUInt8=i;function l(S){return T.consumeReadable(S,c=>y.concat(c))}e.readableToBuffer=l;function a(S){return T.toReadable(S)}e.bufferToReadable=a;function b(S){return T.consumeStream(S,c=>y.concat(c))}e.streamToBuffer=b;async function f(S){return S.ended?y.concat(S.buffer):y.concat([...S.buffer,await b(S.stream)])}e.bufferedStreamToBuffer=f;function _(S){return T.toStream(S,c=>y.concat(c))}e.bufferToStream=_;function n(S){return T.transform(S,{data:c=>typeof c=="string"?y.fromString(c):y.wrap(c)},c=>y.concat(c))}e.streamToBufferReadableStream=n;function o(S){return T.newWriteableStream(c=>y.concat(c),S)}e.newWriteableBufferStream=o;function s(S,c){return T.prefixedReadable(S,c,r=>y.concat(r))}e.prefixedBufferReadable=s;function t(S,c){return T.prefixedStream(S,c,r=>y.concat(r))}e.prefixedBufferStream=t;function u(S){let c=0,r=0,P=0;const M=new Uint8Array(Math.floor(S.length/4*3)),W=z=>{switch(r){case 3:M[P++]=c|z,r=0;break;case 2:M[P++]=c|z>>>2,c=z<<6,r=3;break;case 1:M[P++]=c|z>>>4,c=z<<4,r=2;break;default:c=z<<2,r=1}};for(let z=0;z<S.length;z++){const N=S.charCodeAt(z);if(N>=65&&N<=90)W(N-65);else if(N>=97&&N<=122)W(N-97+26);else if(N>=48&&N<=57)W(N-48+52);else if(N===43||N===45)W(62);else if(N===47||N===95)W(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${S[z]}`)}}const $=P;for(;r>0;)W(0);return y.wrap(M).slice(0,$)}e.decodeBase64=u;const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:S},c=!0,r=!1){const P=r?h:p;let M="";const W=S.byteLength%3;let $=0;for(;$<S.byteLength-W;$+=3){const z=S[$+0],N=S[$+1],q=S[$+2];M+=P[z>>>2],M+=P[(z<<4|N>>>4)&63],M+=P[(N<<2|q>>>6)&63],M+=P[q&63]}if(W===1){const z=S[$+0];M+=P[z>>>2],M+=P[z<<4&63],c&&(M+="==")}else if(W===2){const z=S[$+0],N=S[$+1];M+=P[z>>>2],M+=P[(z<<4|N>>>4)&63],M+=P[N<<2&63],c&&(M+="=")}return M}e.encodeBase64=C}),define(De[9],Ie([1,0,152,54]),function(re,e,v,T){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(he){return!he||typeof he!="string"?!0:he.trim().length===0}e.isFalsyOrWhitespace=L;const R=/{(\d+)}/g;function g(he,...Oe){return Oe.length===0?he:he.replace(R,function(J,X){const Ee=parseInt(X,10);return isNaN(Ee)||Ee<0||Ee>=Oe.length?J:Oe[Ee]})}e.format=g;const y=/{([^}]+)}/g;function m(he,Oe){return he.replace(y,(J,X)=>Oe[X]??J)}e.format2=m;function A(he){return he.replace(/[<>&]/g,function(Oe){switch(Oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Oe}})}e.escape=A;function k(he){return he.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function w(he,Oe){let J=0;const X=Oe.charCodeAt(0);for(let Ee=he.length-1;Ee>=0;Ee--)he.charCodeAt(Ee)===X&&J++;return J}e.count=w;function D(he,Oe,J="\u2026"){return he.length<=Oe?he:`${he.substr(0,Oe)}${J}`}e.truncate=D;function I(he,Oe=" "){const J=E(he,Oe);return i(J,Oe)}e.trim=I;function E(he,Oe){if(!he||!Oe)return he;const J=Oe.length;if(J===0||he.length===0)return he;let X=0;for(;he.indexOf(Oe,X)===X;)X=X+J;return he.substring(X)}e.ltrim=E;function i(he,Oe){if(!he||!Oe)return he;const J=Oe.length,X=he.length;if(J===0||X===0)return he;let Ee=X,Ue=-1;for(;Ue=he.lastIndexOf(Oe,Ee-1),!(Ue===-1||Ue+J!==Ee);){if(Ue===0)return"";Ee=Ue}return he.substring(0,Ee)}e.rtrim=i;function l(he){return he.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function a(he){return he.replace(/\*/g,"")}e.stripWildcards=a;function b(he,Oe,J={}){if(!he)throw new Error("Cannot create regex from empty string");Oe||(he=k(he)),J.wholeWord&&(/\B/.test(he.charAt(0))||(he="\\b"+he),/\B/.test(he.charAt(he.length-1))||(he=he+"\\b"));let X="";return J.global&&(X+="g"),J.matchCase||(X+="i"),J.multiline&&(X+="m"),J.unicode&&(X+="u"),new RegExp(he,X)}e.createRegExp=b;function f(he){return he.source==="^"||he.source==="^$"||he.source==="$"||he.source==="^\\s*$"?!1:!!(he.exec("")&&he.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function _(he){return!!he.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=_;function n(he){return(he.global?"g":"")+(he.ignoreCase?"i":"")+(he.multiline?"m":"")+(he.unicode?"u":"")}e.regExpFlags=n;function o(he){return he.split(/\r\n|\r|\n/)}e.splitLines=o;function s(he){for(let Oe=0,J=he.length;Oe<J;Oe++){const X=he.charCodeAt(Oe);if(X!==32&&X!==9)return Oe}return-1}e.firstNonWhitespaceIndex=s;function t(he,Oe=0,J=he.length){for(let X=Oe;X<J;X++){const Ee=he.charCodeAt(X);if(Ee!==32&&Ee!==9)return he.substring(Oe,X)}return he.substring(Oe,J)}e.getLeadingWhitespace=t;function u(he,Oe=he.length-1){for(let J=Oe;J>=0;J--){const X=he.charCodeAt(J);if(X!==32&&X!==9)return J}return-1}e.lastNonWhitespaceIndex=u;function p(he,Oe,J){const X=[];let Ee=0;for(const Ue of he.matchAll(Oe)){if(X.push(he.slice(Ee,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");Ee=Ue.index+Ue[0].length,X.push(J(Ue[0],...Ue.slice(1),Ue.index,he,Ue.groups))}return X.push(he.slice(Ee)),Promise.all(X).then(Ue=>Ue.join(""))}e.replaceAsync=p;function h(he,Oe){return he<Oe?-1:he>Oe?1:0}e.compare=h;function C(he,Oe,J=0,X=he.length,Ee=0,Ue=Oe.length){for(;J<X&&Ee<Ue;J++,Ee++){const et=he.charCodeAt(J),nt=Oe.charCodeAt(Ee);if(et<nt)return-1;if(et>nt)return 1}const Ne=X-J,Qe=Ue-Ee;return Ne<Qe?-1:Ne>Qe?1:0}e.compareSubstring=C;function S(he,Oe){return c(he,Oe,0,he.length,0,Oe.length)}e.compareIgnoreCase=S;function c(he,Oe,J=0,X=he.length,Ee=0,Ue=Oe.length){for(;J<X&&Ee<Ue;J++,Ee++){let et=he.charCodeAt(J),nt=Oe.charCodeAt(Ee);if(et===nt)continue;if(et>=128||nt>=128)return C(he.toLowerCase(),Oe.toLowerCase(),J,X,Ee,Ue);P(et)&&(et-=32),P(nt)&&(nt-=32);const ft=et-nt;if(ft!==0)return ft}const Ne=X-J,Qe=Ue-Ee;return Ne<Qe?-1:Ne>Qe?1:0}e.compareSubstringIgnoreCase=c;function r(he){return he>=48&&he<=57}e.isAsciiDigit=r;function P(he){return he>=97&&he<=122}e.isLowerAsciiLetter=P;function M(he){return he>=65&&he<=90}e.isUpperAsciiLetter=M;function W(he,Oe){return he.length===Oe.length&&c(he,Oe)===0}e.equalsIgnoreCase=W;function $(he,Oe){const J=Oe.length;return Oe.length>he.length?!1:c(he,Oe,0,J)===0}e.startsWithIgnoreCase=$;function z(he,Oe){const J=Math.min(he.length,Oe.length);let X;for(X=0;X<J;X++)if(he.charCodeAt(X)!==Oe.charCodeAt(X))return X;return J}e.commonPrefixLength=z;function N(he,Oe){const J=Math.min(he.length,Oe.length);let X;const Ee=he.length-1,Ue=Oe.length-1;for(X=0;X<J;X++)if(he.charCodeAt(Ee-X)!==Oe.charCodeAt(Ue-X))return X;return J}e.commonSuffixLength=N;function q(he){return 55296<=he&&he<=56319}e.isHighSurrogate=q;function x(he){return 56320<=he&&he<=57343}e.isLowSurrogate=x;function U(he,Oe){return(he-55296<<10)+(Oe-56320)+65536}e.computeCodePoint=U;function de(he,Oe,J){const X=he.charCodeAt(J);if(q(X)&&J+1<Oe){const Ee=he.charCodeAt(J+1);if(x(Ee))return U(X,Ee)}return X}e.getNextCodePoint=de;function ie(he,Oe){const J=he.charCodeAt(Oe-1);if(x(J)&&Oe>1){const X=he.charCodeAt(Oe-2);if(q(X))return U(X,J)}return J}class ne{get offset(){return this._offset}constructor(Oe,J=0){this._str=Oe,this._len=Oe.length,this._offset=J}setOffset(Oe){this._offset=Oe}prevCodePoint(){const Oe=ie(this._str,this._offset);return this._offset-=Oe>=65536?2:1,Oe}nextCodePoint(){const Oe=de(this._str,this._len,this._offset);return this._offset+=Oe>=65536?2:1,Oe}eol(){return this._offset>=this._len}}e.CodePointIterator=ne;class H{get offset(){return this._iterator.offset}constructor(Oe,J=0){this._iterator=new ne(Oe,J)}nextGraphemeLength(){const Oe=He.getInstance(),J=this._iterator,X=J.offset;let Ee=Oe.getGraphemeBreakType(J.nextCodePoint());for(;!J.eol();){const Ue=J.offset,Ne=Oe.getGraphemeBreakType(J.nextCodePoint());if(Pe(Ee,Ne)){J.setOffset(Ue);break}Ee=Ne}return J.offset-X}prevGraphemeLength(){const Oe=He.getInstance(),J=this._iterator,X=J.offset;let Ee=Oe.getGraphemeBreakType(J.prevCodePoint());for(;J.offset>0;){const Ue=J.offset,Ne=Oe.getGraphemeBreakType(J.prevCodePoint());if(Pe(Ne,Ee)){J.setOffset(Ue);break}Ee=Ne}return X-J.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=H;function V(he,Oe){return new H(he,Oe).nextGraphemeLength()}e.nextCharLength=V;function ce(he,Oe){return new H(he,Oe).prevGraphemeLength()}e.prevCharLength=ce;function be(he,Oe){Oe>0&&x(he.charCodeAt(Oe))&&Oe--;const J=Oe+V(he,Oe);return[J-ce(he,J),J]}e.getCharContainingOffset=be;function Se(he){const Oe=new H(he);let J=0;for(;!Oe.eol();)J++,Oe.nextGraphemeLength();return J}e.charCount=Se;let ge;function O(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function K(he){return ge||(ge=O()),ge.test(he)}e.containsRTL=K;const we=/^[\t\n\r\x20-\x7E]*$/;function Ce(he){return we.test(he)}e.isBasicASCII=Ce,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ee(he){return e.UNUSUAL_LINE_TERMINATORS.test(he)}e.containsUnusualLineTerminators=ee;function te(he){return he>=11904&&he<=55215||he>=63744&&he<=64255||he>=65281&&he<=65374}e.isFullWidthCharacter=te;function ue(he){return he>=127462&&he<=127487||he===8986||he===8987||he===9200||he===9203||he>=9728&&he<=10175||he===11088||he===11093||he>=127744&&he<=128591||he>=128640&&he<=128764||he>=128992&&he<=129008||he>=129280&&he<=129535||he>=129648&&he<=129782}e.isEmojiImprecise=ue;function Q(he,Oe){if(he.length<Oe)return he;const J=/\b/g;let X=0;for(;J.test(he)&&!(he.length-J.lastIndex<Oe);)X=J.lastIndex,J.lastIndex+=1;return he.substring(X).replace(/^\s/,"")}e.lcut=Q;const le=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,se=/\x1b\].*?\x07/g;function oe(he){return he&&(he=he.replace(le,"").replace(se,"")),he}e.removeAnsiEscapeCodes=oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function F(he){return!!(he&&he.length>0&&he.charCodeAt(0)===65279)}e.startsWithUTF8BOM=F;function j(he){return F(he)?he.substr(1):he}e.stripUTF8BOM=j;function Y(he,Oe){if(!he||!Oe||he.length<Oe.length)return!1;const J=Oe.length,X=he.toLowerCase();let Ee=0,Ue=-1;for(;Ee<J;){const Ne=X.indexOf(Oe[Ee],Ue+1);if(Ne<0)return!1;Ue=Ne,Ee++}return!0}e.fuzzyContains=Y;function Z(he,Oe=!1){return he?(Oe&&(he=he.replace(/\\./g,"")),he.toLowerCase()!==he):!1}e.containsUppercaseCharacter=Z;function me(he){return he.charAt(0).toUpperCase()+he.slice(1)}e.uppercaseFirstLetter=me;function _e(he,Oe=1){if(Oe===0)return"";let J=-1;do J=he.indexOf(`
`,J+1),Oe--;while(Oe>0&&J>=0);return J===-1?he:(he[J-1]==="\r"&&J--,he.substr(0,J))}e.getNLines=_e;function fe(he){return he=he%(2*26),he<26?String.fromCharCode(97+he):String.fromCharCode(65+he-26)}e.singleLetterHash=fe;function ke(he){return He.getInstance().getGraphemeBreakType(he)}e.getGraphemeBreakType=ke;function Pe(he,Oe){return he===0?Oe!==5&&Oe!==7:he===2&&Oe===3?!1:he===4||he===2||he===3||Oe===4||Oe===2||Oe===3?!0:!(he===8&&(Oe===8||Oe===9||Oe===11||Oe===12)||(he===11||he===9)&&(Oe===9||Oe===10)||(he===12||he===10)&&Oe===10||Oe===5||Oe===13||Oe===7||he===1||he===13&&Oe===14||he===6&&Oe===6)}var $e;(function(he){he[he.Other=0]="Other",he[he.Prepend=1]="Prepend",he[he.CR=2]="CR",he[he.LF=3]="LF",he[he.Control=4]="Control",he[he.Extend=5]="Extend",he[he.Regional_Indicator=6]="Regional_Indicator",he[he.SpacingMark=7]="SpacingMark",he[he.L=8]="L",he[he.V=9]="V",he[he.T=10]="T",he[he.LV=11]="LV",he[he.LVT=12]="LVT",he[he.ZWJ=13]="ZWJ",he[he.Extended_Pictographic=14]="Extended_Pictographic"})($e||(e.GraphemeBreakType=$e={}));class He{static getInstance(){return He._INSTANCE||(He._INSTANCE=new He),He._INSTANCE}constructor(){this._data=tt()}getGraphemeBreakType(Oe){if(Oe<32)return Oe===10?3:Oe===13?2:4;if(Oe<127)return 0;const J=this._data,X=J.length/3;let Ee=1;for(;Ee<=X;)if(Oe<J[3*Ee])Ee=2*Ee;else if(Oe>J[3*Ee+1])Ee=2*Ee+1;else return J[3*Ee+2];return 0}}He._INSTANCE=null;function tt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(he,Oe){if(he===0)return 0;const J=Ke(he,Oe);if(J!==void 0)return J;const X=new ne(Oe,he);return X.prevCodePoint(),X.offset}e.getLeftDeleteOffset=Ge;function Ke(he,Oe){const J=new ne(Oe,he);let X=J.prevCodePoint();for(;st(X)||X===65039||X===8419;){if(J.offset===0)return;X=J.prevCodePoint()}if(!ue(X))return;let Ee=J.offset;return Ee>0&&J.prevCodePoint()===8205&&(Ee=J.offset),Ee}function st(he){return 127995<=he&&he<=127999}var at;(function(he){he[he.zwj=8205]="zwj",he[he.emojiVariantSelector=65039]="emojiVariantSelector",he[he.enclosingKeyCap=8419]="enclosingKeyCap"})(at||(at={})),e.noBreakWhitespace="\xA0";class Ze{static getInstance(Oe){return Ze.cache.get(Array.from(Oe))}static getLocales(){return Ze._locales.value}constructor(Oe){this.confusableDictionary=Oe}isAmbiguous(Oe){return this.confusableDictionary.has(Oe)}getPrimaryConfusable(Oe){return this.confusableDictionary.get(Oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ze,d=Ze,Ze.ambiguousCharacterData=new T.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ze.cache=new v.LRUCachedFunction(he=>{function Oe(nt){const ft=new Map;for(let wt=0;wt<nt.length;wt+=2)ft.set(nt[wt],nt[wt+1]);return ft}function J(nt,ft){const wt=new Map(nt);for(const[Mt,Ft]of ft)wt.set(Mt,Ft);return wt}function X(nt,ft){if(!nt)return ft;const wt=new Map;for(const[Mt,Ft]of nt)ft.has(Mt)&&wt.set(Mt,Ft);return wt}const Ee=d.ambiguousCharacterData.value;let Ue=he.filter(nt=>!nt.startsWith("_")&&nt in Ee);Ue.length===0&&(Ue=["_default"]);let Ne;for(const nt of Ue){const ft=Oe(Ee[nt]);Ne=X(Ne,ft)}const Qe=Oe(Ee._common),et=J(Qe,Ne);return new Ze(et)}),Ze._locales=new T.Lazy(()=>Object.keys(Ze.ambiguousCharacterData.value).filter(he=>!he.startsWith("_")));class rt{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(rt.getRawData())),this._data}static isInvisibleCharacter(Oe){return rt.getData().has(Oe)}static get codePoints(){return rt.getData()}}e.InvisibleCharacters=rt,rt._data=void 0}),define(De[113],Ie([1,0,28,9]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function d(...se){return function(oe,F){for(let j=0,Y=se.length;j<Y;j++){const Z=se[j](oe,F);if(Z)return Z}return null}}e.or=d,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(se,oe,F){if(!F||F.length<oe.length)return null;let j;return se?j=T.startsWithIgnoreCase(F,oe):j=F.indexOf(oe)===0,j?oe.length>0?[{start:0,end:oe.length}]:[]:null}function R(se,oe){const F=oe.toLowerCase().indexOf(se.toLowerCase());return F===-1?null:[{start:F,end:F+se.length}]}e.matchesContiguousSubString=R;function g(se,oe){return y(se.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=g;function y(se,oe,F,j){if(F===se.length)return[];if(j===oe.length)return null;if(se[F]===oe[j]){let Y=null;return(Y=y(se,oe,F+1,j+1))?l({start:j,end:j+1},Y):null}return y(se,oe,F,j+1)}function m(se){return 97<=se&&se<=122}function A(se){return 65<=se&&se<=90}e.isUpper=A;function k(se){return 48<=se&&se<=57}function w(se){return se===32||se===9||se===10||se===13}const D=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>D.add(se.charCodeAt(0)));function I(se){return w(se)||D.has(se)}function E(se,oe){return se===oe||I(se)&&I(oe)}function i(se){return m(se)||A(se)||k(se)}function l(se,oe){return oe.length===0?oe=[se]:se.end===oe[0].start?oe[0].start=se.start:oe.unshift(se),oe}function a(se,oe){for(let F=oe;F<se.length;F++){const j=se.charCodeAt(F);if(A(j)||k(j)||F>0&&!i(se.charCodeAt(F-1)))return F}return se.length}function b(se,oe,F,j){if(F===se.length)return[];if(j===oe.length)return null;if(se[F]!==oe[j].toLowerCase())return null;{let Y=null,Z=j+1;for(Y=b(se,oe,F+1,j+1);!Y&&(Z=a(oe,Z))<oe.length;)Y=b(se,oe,F+1,Z),Z++;return Y===null?null:l({start:j,end:j+1},Y)}}function f(se){let oe=0,F=0,j=0,Y=0,Z=0;for(let Pe=0;Pe<se.length;Pe++)Z=se.charCodeAt(Pe),A(Z)&&oe++,m(Z)&&F++,i(Z)&&j++,k(Z)&&Y++;const me=oe/se.length,_e=F/se.length,fe=j/se.length,ke=Y/se.length;return{upperPercent:me,lowerPercent:_e,alphaPercent:fe,numericPercent:ke}}function _(se){const{upperPercent:oe,lowerPercent:F}=se;return F===0&&oe>.6}function n(se){const{upperPercent:oe,lowerPercent:F,alphaPercent:j,numericPercent:Y}=se;return F>.2&&oe<.8&&j>.6&&Y<.2}function o(se){let oe=0,F=0,j=0,Y=0;for(let Z=0;Z<se.length;Z++)j=se.charCodeAt(Z),A(j)&&oe++,m(j)&&F++,w(j)&&Y++;return(oe===0||F===0)&&Y===0?se.length<=30:oe<=5}function s(se,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!o(se)||oe.length>60)return null;const F=f(oe);if(!n(F)){if(!_(F))return null;oe=oe.toLowerCase()}let j=null,Y=0;for(se=se.toLowerCase();Y<oe.length&&(j=b(se,oe,0,Y))===null;)Y=a(oe,Y+1);return j}e.matchesCamelCase=s;function t(se,oe,F=!1){if(!oe||oe.length===0)return null;let j=null,Y=0;for(se=se.toLowerCase(),oe=oe.toLowerCase();Y<oe.length&&(j=u(se,oe,0,Y,F))===null;)Y=p(oe,Y+1);return j}e.matchesWords=t;function u(se,oe,F,j,Y){if(F===se.length)return[];if(j===oe.length)return null;if(E(se.charCodeAt(F),oe.charCodeAt(j))){let Z=null,me=j+1;if(Z=u(se,oe,F+1,j+1,Y),!Y)for(;!Z&&(me=p(oe,me))<oe.length;)Z=u(se,oe,F+1,me,Y),me++;return Z?se.charCodeAt(F)!==oe.charCodeAt(j)?Z:l({start:j,end:j+1},Z):null}else return null}function p(se,oe){for(let F=oe;F<se.length;F++)if(I(se.charCodeAt(F))||F>0&&I(se.charCodeAt(F-1)))return F;return se.length}const h=d(e.matchesPrefix,s,R),C=d(e.matchesPrefix,s,g),S=new v.LRUCache(1e4);function c(se,oe,F=!1){if(typeof se!="string"||typeof oe!="string")return null;let j=S.get(se);j||(j=new RegExp(T.convertSimple2RegExpPattern(se),"i"),S.set(se,j));const Y=j.exec(oe);return Y?[{start:Y.index,end:Y.index+Y[0].length}]:F?C(se,oe):h(se,oe)}e.matchesFuzzy=c;function r(se,oe){const F=we(se,se.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return F?M(F):null}e.matchesFuzzy2=r;function P(se,oe,F,j,Y,Z){const me=Math.min(13,se.length);for(;F<me;F++){const _e=we(se,oe,F,j,Y,Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(_e)return _e}return[0,Z]}e.anyScore=P;function M(se){if(typeof se>"u")return[];const oe=[],F=se[1];for(let j=se.length-1;j>1;j--){const Y=se[j]+F,Z=oe[oe.length-1];Z&&Z.end===Y?Z.end=Y+1:oe.push({start:Y,end:Y+1})}return oe}e.createMatches=M;const W=128;function $(){const se=[],oe=[];for(let F=0;F<=W;F++)oe[F]=0;for(let F=0;F<=W;F++)se.push(oe.slice(0));return se}function z(se){const oe=[];for(let F=0;F<=se;F++)oe[F]=0;return oe}const N=z(2*W),q=z(2*W),x=$(),U=$(),de=$(),ie=!1;function ne(se,oe,F,j,Y){function Z(_e,fe,ke=" "){for(;_e.length<fe;)_e=ke+_e;return _e}let me=` |   |${j.split("").map(_e=>Z(_e,3)).join("|")}
`;for(let _e=0;_e<=F;_e++)_e===0?me+=" |":me+=`${oe[_e-1]}|`,me+=se[_e].slice(0,Y+1).map(fe=>Z(fe.toString(),3)).join("|")+`
`;return me}function H(se,oe,F,j){se=se.substr(oe),F=F.substr(j),console.log(ne(U,se,se.length,F,F.length)),console.log(ne(de,se,se.length,F,F.length)),console.log(ne(x,se,se.length,F,F.length))}function V(se,oe){if(oe<0||oe>=se.length)return!1;const F=se.codePointAt(oe);switch(F){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(F)}}function ce(se,oe){if(oe<0||oe>=se.length)return!1;switch(se.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function be(se,oe,F){return oe[se]!==F[se]}function Se(se,oe,F,j,Y,Z,me=!1){for(;oe<F&&Y<Z;)se[oe]===j[Y]&&(me&&(N[oe]=Y),oe+=1),Y+=1;return oe===F}e.isPatternInWord=Se;var ge;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var O;(function(se){se.Default=[-100,0];function oe(F){return!F||F.length===2&&F[0]===-100&&F[1]===0}se.isDefault=oe})(O||(e.FuzzyScore=O={}));class K{constructor(oe,F){this.firstMatchCanBeWeak=oe,this.boostFullMatch=F}}e.FuzzyScoreOptions=K,K.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function we(se,oe,F,j,Y,Z,me=K.default){const _e=se.length>W?W:se.length,fe=j.length>W?W:j.length;if(F>=_e||Z>=fe||_e-F>fe-Z||!Se(oe,F,_e,Y,Z,fe,!0))return;Ce(_e,fe,F,Z,oe,Y);let ke=1,Pe=1,$e=F,He=Z;const tt=[!1];for(ke=1,$e=F;$e<_e;ke++,$e++){const Ze=N[$e],rt=q[$e],he=$e+1<_e?q[$e+1]:fe;for(Pe=Ze-Z+1,He=Ze;He<he;Pe++,He++){let Oe=Number.MIN_SAFE_INTEGER,J=!1;He<=rt&&(Oe=ee(se,oe,$e,F,j,Y,He,fe,Z,x[ke-1][Pe-1]===0,tt));let X=0;Oe!==Number.MAX_SAFE_INTEGER&&(J=!0,X=Oe+U[ke-1][Pe-1]);const Ee=He>Ze,Ue=Ee?U[ke][Pe-1]+(x[ke][Pe-1]>0?-5:0):0,Ne=He>Ze+1&&x[ke][Pe-1]>0,Qe=Ne?U[ke][Pe-2]+(x[ke][Pe-2]>0?-5:0):0;if(Ne&&(!Ee||Qe>=Ue)&&(!J||Qe>=X))U[ke][Pe]=Qe,de[ke][Pe]=3,x[ke][Pe]=0;else if(Ee&&(!J||Ue>=X))U[ke][Pe]=Ue,de[ke][Pe]=2,x[ke][Pe]=0;else if(J)U[ke][Pe]=X,de[ke][Pe]=1,x[ke][Pe]=x[ke-1][Pe-1]+1;else throw new Error("not possible")}}if(ie&&H(se,F,j,Z),!tt[0]&&!me.firstMatchCanBeWeak)return;ke--,Pe--;const Ge=[U[ke][Pe],Z];let Ke=0,st=0;for(;ke>=1;){let Ze=Pe;do{const rt=de[ke][Ze];if(rt===3)Ze=Ze-2;else if(rt===2)Ze=Ze-1;else break}while(Ze>=1);Ke>1&&oe[F+ke-1]===Y[Z+Pe-1]&&!be(Ze+Z-1,j,Y)&&Ke+1>x[ke][Ze]&&(Ze=Pe),Ze===Pe?Ke++:Ke=1,st||(st=Ze),ke--,Pe=Ze-1,Ge.push(Pe)}fe===_e&&me.boostFullMatch&&(Ge[0]+=2);const at=st-_e;return Ge[0]-=at,Ge}e.fuzzyScore=we;function Ce(se,oe,F,j,Y,Z){let me=se-1,_e=oe-1;for(;me>=F&&_e>=j;)Y[me]===Z[_e]&&(q[me]=_e,me--),_e--}function ee(se,oe,F,j,Y,Z,me,_e,fe,ke,Pe){if(oe[F]!==Z[me])return Number.MIN_SAFE_INTEGER;let $e=1,He=!1;return me===F-j?$e=se[F]===Y[me]?7:5:be(me,Y,Z)&&(me===0||!be(me-1,Y,Z))?($e=se[F]===Y[me]?7:5,He=!0):V(Z,me)&&(me===0||!V(Z,me-1))?$e=5:(V(Z,me-1)||ce(Z,me-1))&&($e=5,He=!0),$e>1&&F===j&&(Pe[0]=!0),He||(He=be(me,Y,Z)||V(Z,me-1)||ce(Z,me-1)),F===j?me>fe&&($e-=He?3:5):ke?$e+=He?2:0:$e+=He?0:1,me+1===_e&&($e-=He?3:5),$e}function te(se,oe,F,j,Y,Z,me){return Q(se,oe,F,j,Y,Z,!0,me)}e.fuzzyScoreGracefulAggressive=te;function ue(se,oe,F,j,Y,Z,me){return Q(se,oe,F,j,Y,Z,!1,me)}e.fuzzyScoreGraceful=ue;function Q(se,oe,F,j,Y,Z,me,_e){let fe=we(se,oe,F,j,Y,Z,_e);if(fe&&!me)return fe;if(se.length>=3){const ke=Math.min(7,se.length-1);for(let Pe=F+1;Pe<ke;Pe++){const $e=le(se,Pe);if($e){const He=we($e,$e.toLowerCase(),F,j,Y,Z,_e);He&&(He[0]-=3,(!fe||He[0]>fe[0])&&(fe=He))}}}return fe}function le(se,oe){if(oe+1>=se.length)return;const F=se[oe],j=se[oe+1];if(F!==j)return se.slice(0,oe)+j+F+se.slice(oe+2)}}),define(De[70],Ie([1,0,9]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function T(l){return d(l,0)}e.hash=T;function d(l,a){switch(typeof l){case"object":return l===null?L(349,a):Array.isArray(l)?y(l,a):m(l,a);case"string":return g(l,a);case"boolean":return R(l,a);case"number":return L(l,a);case"undefined":return L(937,a);default:return L(617,a)}}e.doHash=d;function L(l,a){return(a<<5)-a+l|0}e.numberHash=L;function R(l,a){return L(l?433:863,a)}function g(l,a){a=L(149417,a);for(let b=0,f=l.length;b<f;b++)a=L(l.charCodeAt(b),a);return a}e.stringHash=g;function y(l,a){return a=L(104579,a),l.reduce((b,f)=>d(f,b),a)}function m(l,a){return a=L(181387,a),Object.keys(l).sort().reduce((b,f)=>(b=g(f,b),d(l[f],b)),a)}class A{constructor(){this._value=0}get value(){return this._value}hash(a){return this._value=d(a,this._value),this._value}}e.Hasher=A;var k;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function w(l,a,b=32){const f=b-a,_=~((1<<f)-1);return(l<<a|(_&l)>>>f)>>>0}function D(l,a=0,b=l.byteLength,f=0){for(let _=0;_<b;_++)l[a+_]=f}function I(l,a,b="0"){for(;l.length<a;)l=b+l;return l}function E(l,a=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(b=>b.toString(16).padStart(2,"0")).join(""):I((l>>>0).toString(16),a/4)}e.toHexString=E;class i{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(a){const b=a.length;if(b===0)return;const f=this._buff;let _=this._buffLen,n=this._leftoverHighSurrogate,o,s;for(n!==0?(o=n,s=-1,n=0):(o=a.charCodeAt(0),s=0);;){let t=o;if(v.isHighSurrogate(o))if(s+1<b){const u=a.charCodeAt(s+1);v.isLowSurrogate(u)?(s++,t=v.computeCodePoint(o,u)):t=65533}else{n=o;break}else v.isLowSurrogate(o)&&(t=65533);if(_=this._push(f,_,t),s++,s<b)o=a.charCodeAt(s);else break}this._buffLen=_,this._leftoverHighSurrogate=n}_push(a,b,f){return f<128?a[b++]=f:f<2048?(a[b++]=192|(f&1984)>>>6,a[b++]=128|(f&63)>>>0):f<65536?(a[b++]=224|(f&61440)>>>12,a[b++]=128|(f&4032)>>>6,a[b++]=128|(f&63)>>>0):(a[b++]=240|(f&1835008)>>>18,a[b++]=128|(f&258048)>>>12,a[b++]=128|(f&4032)>>>6,a[b++]=128|(f&63)>>>0),b>=64&&(this._step(),b-=64,this._totalLen+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),b}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,D(this._buff,this._buffLen),this._buffLen>56&&(this._step(),D(this._buff));const a=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(a/4294967296),!1),this._buffDV.setUint32(60,a%4294967296,!1),this._step()}_step(){const a=i._bigBlock32,b=this._buffDV;for(let h=0;h<64;h+=4)a.setUint32(h,b.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)a.setUint32(h,w(a.getUint32(h-12,!1)^a.getUint32(h-32,!1)^a.getUint32(h-56,!1)^a.getUint32(h-64,!1),1),!1);let f=this._h0,_=this._h1,n=this._h2,o=this._h3,s=this._h4,t,u,p;for(let h=0;h<80;h++)h<20?(t=_&n|~_&o,u=1518500249):h<40?(t=_^n^o,u=1859775393):h<60?(t=_&n|_&o|n&o,u=2400959708):(t=_^n^o,u=3395469782),p=w(f,5)+t+s+u+a.getUint32(h*4,!1)&4294967295,s=o,o=n,n=w(_,30),_=f,f=p;this._h0=this._h0+f&4294967295,this._h1=this._h1+_&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=i,i._bigBlock32=new DataView(new ArrayBuffer(320))}),define(De[40],Ie([1,0,9]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(d){d[d.Ignore=0]="Ignore",d[d.Info=1]="Info",d[d.Warning=2]="Warning",d[d.Error=3]="Error"})(T||(T={})),function(d){const L="error",R="warning",g="warn",y="info",m="ignore";function A(w){return w?v.equalsIgnoreCase(L,w)?d.Error:v.equalsIgnoreCase(R,w)||v.equalsIgnoreCase(g,w)?d.Warning:v.equalsIgnoreCase(y,w)?d.Info:d.Ignore:d.Ignore}d.fromValue=A;function k(w){switch(w){case d.Error:return L;case d.Warning:return R;case d.Info:return y;default:return m}}d.toString=k}(T||(T={})),e.default=T}),define(De[153],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(De[71],Ie([1,0,19,9]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class d{constructor(){this._value="",this._pos=0}reset(D){return this._value=D,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(D){const I=D.charCodeAt(0),E=this._value.charCodeAt(this._pos);return I-E}value(){return this._value[this._pos]}}e.StringIterator=d;class L{constructor(D=!0){this._caseSensitive=D}reset(D){return this._value=D,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let D=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(D)this._from++;else break;else D=!1;return this}cmp(D){return this._caseSensitive?(0,T.compareSubstring)(D,this._value,0,D.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(D,this._value,0,D.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=L;class R{constructor(D=!0,I=!0){this._splitOnBackslash=D,this._caseSensitive=I}reset(D){this._from=0,this._to=0,this._value=D,this._valueLen=D.length;for(let I=D.length-1;I>=0;I--,this._valueLen--){const E=this._value.charCodeAt(I);if(!(E===47||this._splitOnBackslash&&E===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let D=!0;for(;this._to<this._valueLen;this._to++){const I=this._value.charCodeAt(this._to);if(I===47||this._splitOnBackslash&&I===92)if(D)this._from++;else break;else D=!1}return this}cmp(D){return this._caseSensitive?(0,T.compareSubstring)(D,this._value,0,D.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(D,this._value,0,D.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var g;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(g||(g={}));class y{constructor(D,I){this._ignorePathCasing=D,this._ignoreQueryAndFragment=I,this._states=[],this._stateIdx=0}reset(D){return this._value=D,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(D)),this._pathIterator.reset(D.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(D)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(D){if(this._states[this._stateIdx]===1)return(0,T.compareIgnoreCase)(D,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,T.compareIgnoreCase)(D,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(D);if(this._states[this._stateIdx]===4)return(0,T.compare)(D,this._value.query);if(this._states[this._stateIdx]===5)return(0,T.compare)(D,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=y;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const D=this.right;return this.right=D.left,D.left=this,this.updateHeight(),D.updateHeight(),D}rotateRight(){const D=this.left;return this.left=D.right,D.right=this,this.updateHeight(),D.updateHeight(),D}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(A||(A={}));class k{static forUris(D=()=>!1,I=()=>!1){return new k(new y(D,I))}static forPaths(D=!1){return new k(new R(void 0,!D))}static forStrings(){return new k(new d)}static forConfigKeys(){return new k(new L)}constructor(D){this._iter=D}clear(){this._root=void 0}fill(D,I){if(I){const E=I.slice(0);(0,v.shuffle)(E);for(const i of E)this.set(i,D)}else{const E=D.slice(0);(0,v.shuffle)(E);for(const i of E)this.set(i[0],i[1])}}set(D,I){const E=this._iter.reset(D);let i;this._root||(this._root=new m,this._root.segment=E.value());const l=[];for(i=this._root;;){const b=E.cmp(i.segment);if(b>0)i.left||(i.left=new m,i.left.segment=E.value()),l.push([-1,i]),i=i.left;else if(b<0)i.right||(i.right=new m,i.right.segment=E.value()),l.push([1,i]),i=i.right;else if(E.hasNext())E.next(),i.mid||(i.mid=new m,i.mid.segment=E.value()),l.push([0,i]),i=i.mid;else break}const a=i.value;i.value=I,i.key=D;for(let b=l.length-1;b>=0;b--){const f=l[b][1];f.updateHeight();const _=f.balanceFactor();if(_<-1||_>1){const n=l[b][0],o=l[b+1][0];if(n===1&&o===1)l[b][1]=f.rotateLeft();else if(n===-1&&o===-1)l[b][1]=f.rotateRight();else if(n===1&&o===-1)f.right=l[b+1][1]=l[b+1][1].rotateRight(),l[b][1]=f.rotateLeft();else if(n===-1&&o===1)f.left=l[b+1][1]=l[b+1][1].rotateLeft(),l[b][1]=f.rotateRight();else throw new Error;if(b>0)switch(l[b-1][0]){case-1:l[b-1][1].left=l[b][1];break;case 1:l[b-1][1].right=l[b][1];break;case 0:l[b-1][1].mid=l[b][1];break}else this._root=l[0][1]}}return a}get(D){return this._getNode(D)?.value}_getNode(D){const I=this._iter.reset(D);let E=this._root;for(;E;){const i=I.cmp(E.segment);if(i>0)E=E.left;else if(i<0)E=E.right;else if(I.hasNext())I.next(),E=E.mid;else break}return E}has(D){const I=this._getNode(D);return!(I?.value===void 0&&I?.mid===void 0)}delete(D){return this._delete(D,!1)}deleteSuperstr(D){return this._delete(D,!0)}_delete(D,I){const E=this._iter.reset(D),i=[];let l=this._root;for(;l;){const a=E.cmp(l.segment);if(a>0)i.push([-1,l]),l=l.left;else if(a<0)i.push([1,l]),l=l.right;else if(E.hasNext())E.next(),i.push([0,l]),l=l.mid;else break}if(l){if(I?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const a=this._min(l.right);if(a.key){const{key:b,value:f,segment:_}=a;this._delete(a.key,!1),l.key=b,l.value=f,l.segment=_}}else{const a=l.left??l.right;if(i.length>0){const[b,f]=i[i.length-1];switch(b){case-1:f.left=a;break;case 0:f.mid=a;break;case 1:f.right=a;break}}else this._root=a}for(let a=i.length-1;a>=0;a--){const b=i[a][1];b.updateHeight();const f=b.balanceFactor();if(f>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),i[a][1]=b.rotateLeft()):f<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),i[a][1]=b.rotateRight()),a>0)switch(i[a-1][0]){case-1:i[a-1][1].left=i[a][1];break;case 1:i[a-1][1].right=i[a][1];break;case 0:i[a-1][1].mid=i[a][1];break}else this._root=i[0][1]}}}_min(D){for(;D.left;)D=D.left;return D}findSubstr(D){const I=this._iter.reset(D);let E=this._root,i;for(;E;){const l=I.cmp(E.segment);if(l>0)E=E.left;else if(l<0)E=E.right;else if(I.hasNext())I.next(),i=E.value||i,E=E.mid;else break}return E&&E.value||i}findSuperstr(D){return this._findSuperstrOrElement(D,!1)}_findSuperstrOrElement(D,I){const E=this._iter.reset(D);let i=this._root;for(;i;){const l=E.cmp(i.segment);if(l>0)i=i.left;else if(l<0)i=i.right;else if(E.hasNext())E.next(),i=i.mid;else return i.mid?this._entries(i.mid):I?i.value:void 0}}hasElementOrSubtree(D){return this._findSuperstrOrElement(D,!0)!==void 0}forEach(D){for(const[I,E]of this)D(E,I)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(D){const I=[];return this._dfsEntries(D,I),I[Symbol.iterator]()}_dfsEntries(D,I){D&&(D.left&&this._dfsEntries(D.left,I),D.value&&I.push([D.key,D.value]),D.mid&&this._dfsEntries(D.mid,I),D.right&&this._dfsEntries(D.right,I))}_isBalanced(){const D=I=>{if(!I)return!0;const E=I.balanceFactor();return E<-1||E>1?!1:D(I.left)&&D(I.right)};return D(this._root)}}e.TernarySearchTree=k}),define(De[12],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function v(o){return typeof o=="string"}e.isString=v;function T(o){return Array.isArray(o)&&o.every(s=>v(s))}e.isStringArray=T;function d(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=d;function L(o){const s=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof s}e.isTypedArray=L;function R(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=R;function g(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=g;function y(o){return o===!0||o===!1}e.isBoolean=y;function m(o){return typeof o>"u"}e.isUndefined=m;function A(o){return!k(o)}e.isDefined=A;function k(o){return m(o)||o===null}e.isUndefinedOrNull=k;function w(o,s){if(!o)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=w;function D(o){if(k(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=D;function I(...o){const s=[];for(let t=0;t<o.length;t++){const u=o[t];if(k(u))throw new Error(`Assertion Failed: argument at index ${t} is undefined or null`);s.push(u)}return s}e.assertAllDefined=I;const E=Object.prototype.hasOwnProperty;function i(o){if(!d(o))return!1;for(const s in o)if(E.call(o,s))return!1;return!0}e.isEmptyObject=i;function l(o){return typeof o=="function"}e.isFunction=l;function a(...o){return o.length>0&&o.every(l)}e.areFunctions=a;function b(o,s){const t=Math.min(o.length,s.length);for(let u=0;u<t;u++)f(o[u],s[u])}e.validateConstraints=b;function f(o,s){if(v(s)){if(typeof o!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(l(s)){try{if(o instanceof s)return}catch{}if(!k(o)&&o.constructor===s||s.length===1&&s.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function _(o){return o===null?void 0:o}e.withNullAsUndefined=_;function n(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=n}),define(De[72],Ie([1,0,12]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const T=Object.create(null);function d(g,y){if((0,v.isString)(y)){const m=T[y];if(m===void 0)throw new Error(`${g} references an unknown codicon: ${y}`);y=m}return T[g]=y,{id:g}}function L(){return T}e.getCodiconFontCharacters=L;function R(){return Object.values(e.Codicon)}e.getAllCodicons=R,e.Codicon={add:d("add",6e4),plus:d("plus",6e4),gistNew:d("gist-new",6e4),repoCreate:d("repo-create",6e4),lightbulb:d("lightbulb",60001),lightBulb:d("light-bulb",60001),repo:d("repo",60002),repoDelete:d("repo-delete",60002),gistFork:d("gist-fork",60003),repoForked:d("repo-forked",60003),gitPullRequest:d("git-pull-request",60004),gitPullRequestAbandoned:d("git-pull-request-abandoned",60004),recordKeys:d("record-keys",60005),keyboard:d("keyboard",60005),tag:d("tag",60006),tagAdd:d("tag-add",60006),tagRemove:d("tag-remove",60006),person:d("person",60007),personFollow:d("person-follow",60007),personOutline:d("person-outline",60007),personFilled:d("person-filled",60007),gitBranch:d("git-branch",60008),gitBranchCreate:d("git-branch-create",60008),gitBranchDelete:d("git-branch-delete",60008),sourceControl:d("source-control",60008),mirror:d("mirror",60009),mirrorPublic:d("mirror-public",60009),star:d("star",60010),starAdd:d("star-add",60010),starDelete:d("star-delete",60010),starEmpty:d("star-empty",60010),comment:d("comment",60011),commentAdd:d("comment-add",60011),alert:d("alert",60012),warning:d("warning",60012),search:d("search",60013),searchSave:d("search-save",60013),logOut:d("log-out",60014),signOut:d("sign-out",60014),logIn:d("log-in",60015),signIn:d("sign-in",60015),eye:d("eye",60016),eyeUnwatch:d("eye-unwatch",60016),eyeWatch:d("eye-watch",60016),circleFilled:d("circle-filled",60017),primitiveDot:d("primitive-dot",60017),closeDirty:d("close-dirty",60017),debugBreakpoint:d("debug-breakpoint",60017),debugBreakpointDisabled:d("debug-breakpoint-disabled",60017),debugHint:d("debug-hint",60017),primitiveSquare:d("primitive-square",60018),edit:d("edit",60019),pencil:d("pencil",60019),info:d("info",60020),issueOpened:d("issue-opened",60020),gistPrivate:d("gist-private",60021),gitForkPrivate:d("git-fork-private",60021),lock:d("lock",60021),mirrorPrivate:d("mirror-private",60021),close:d("close",60022),removeClose:d("remove-close",60022),x:d("x",60022),repoSync:d("repo-sync",60023),sync:d("sync",60023),clone:d("clone",60024),desktopDownload:d("desktop-download",60024),beaker:d("beaker",60025),microscope:d("microscope",60025),vm:d("vm",60026),deviceDesktop:d("device-desktop",60026),file:d("file",60027),fileText:d("file-text",60027),more:d("more",60028),ellipsis:d("ellipsis",60028),kebabHorizontal:d("kebab-horizontal",60028),mailReply:d("mail-reply",60029),reply:d("reply",60029),organization:d("organization",60030),organizationFilled:d("organization-filled",60030),organizationOutline:d("organization-outline",60030),newFile:d("new-file",60031),fileAdd:d("file-add",60031),newFolder:d("new-folder",60032),fileDirectoryCreate:d("file-directory-create",60032),trash:d("trash",60033),trashcan:d("trashcan",60033),history:d("history",60034),clock:d("clock",60034),folder:d("folder",60035),fileDirectory:d("file-directory",60035),symbolFolder:d("symbol-folder",60035),logoGithub:d("logo-github",60036),markGithub:d("mark-github",60036),github:d("github",60036),terminal:d("terminal",60037),console:d("console",60037),repl:d("repl",60037),zap:d("zap",60038),symbolEvent:d("symbol-event",60038),error:d("error",60039),stop:d("stop",60039),variable:d("variable",60040),symbolVariable:d("symbol-variable",60040),array:d("array",60042),symbolArray:d("symbol-array",60042),symbolModule:d("symbol-module",60043),symbolPackage:d("symbol-package",60043),symbolNamespace:d("symbol-namespace",60043),symbolObject:d("symbol-object",60043),symbolMethod:d("symbol-method",60044),symbolFunction:d("symbol-function",60044),symbolConstructor:d("symbol-constructor",60044),symbolBoolean:d("symbol-boolean",60047),symbolNull:d("symbol-null",60047),symbolNumeric:d("symbol-numeric",60048),symbolNumber:d("symbol-number",60048),symbolStructure:d("symbol-structure",60049),symbolStruct:d("symbol-struct",60049),symbolParameter:d("symbol-parameter",60050),symbolTypeParameter:d("symbol-type-parameter",60050),symbolKey:d("symbol-key",60051),symbolText:d("symbol-text",60051),symbolReference:d("symbol-reference",60052),goToFile:d("go-to-file",60052),symbolEnum:d("symbol-enum",60053),symbolValue:d("symbol-value",60053),symbolRuler:d("symbol-ruler",60054),symbolUnit:d("symbol-unit",60054),activateBreakpoints:d("activate-breakpoints",60055),archive:d("archive",60056),arrowBoth:d("arrow-both",60057),arrowDown:d("arrow-down",60058),arrowLeft:d("arrow-left",60059),arrowRight:d("arrow-right",60060),arrowSmallDown:d("arrow-small-down",60061),arrowSmallLeft:d("arrow-small-left",60062),arrowSmallRight:d("arrow-small-right",60063),arrowSmallUp:d("arrow-small-up",60064),arrowUp:d("arrow-up",60065),bell:d("bell",60066),bold:d("bold",60067),book:d("book",60068),bookmark:d("bookmark",60069),debugBreakpointConditionalUnverified:d("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:d("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:d("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:d("debug-breakpoint-data-unverified",60072),debugBreakpointData:d("debug-breakpoint-data",60073),debugBreakpointDataDisabled:d("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:d("debug-breakpoint-log-unverified",60074),debugBreakpointLog:d("debug-breakpoint-log",60075),debugBreakpointLogDisabled:d("debug-breakpoint-log-disabled",60075),briefcase:d("briefcase",60076),broadcast:d("broadcast",60077),browser:d("browser",60078),bug:d("bug",60079),calendar:d("calendar",60080),caseSensitive:d("case-sensitive",60081),check:d("check",60082),checklist:d("checklist",60083),chevronDown:d("chevron-down",60084),dropDownButton:d("drop-down-button",60084),chevronLeft:d("chevron-left",60085),chevronRight:d("chevron-right",60086),chevronUp:d("chevron-up",60087),chromeClose:d("chrome-close",60088),chromeMaximize:d("chrome-maximize",60089),chromeMinimize:d("chrome-minimize",60090),chromeRestore:d("chrome-restore",60091),circle:d("circle",60092),circleOutline:d("circle-outline",60092),debugBreakpointUnverified:d("debug-breakpoint-unverified",60092),circleSlash:d("circle-slash",60093),circuitBoard:d("circuit-board",60094),clearAll:d("clear-all",60095),clippy:d("clippy",60096),closeAll:d("close-all",60097),cloudDownload:d("cloud-download",60098),cloudUpload:d("cloud-upload",60099),code:d("code",60100),collapseAll:d("collapse-all",60101),colorMode:d("color-mode",60102),commentDiscussion:d("comment-discussion",60103),compareChanges:d("compare-changes",60157),creditCard:d("credit-card",60105),dash:d("dash",60108),dashboard:d("dashboard",60109),database:d("database",60110),debugContinue:d("debug-continue",60111),debugDisconnect:d("debug-disconnect",60112),debugPause:d("debug-pause",60113),debugRestart:d("debug-restart",60114),debugStart:d("debug-start",60115),debugStepInto:d("debug-step-into",60116),debugStepOut:d("debug-step-out",60117),debugStepOver:d("debug-step-over",60118),debugStop:d("debug-stop",60119),debug:d("debug",60120),deviceCameraVideo:d("device-camera-video",60121),deviceCamera:d("device-camera",60122),deviceMobile:d("device-mobile",60123),diffAdded:d("diff-added",60124),diffIgnored:d("diff-ignored",60125),diffModified:d("diff-modified",60126),diffRemoved:d("diff-removed",60127),diffRenamed:d("diff-renamed",60128),diff:d("diff",60129),discard:d("discard",60130),editorLayout:d("editor-layout",60131),emptyWindow:d("empty-window",60132),exclude:d("exclude",60133),extensions:d("extensions",60134),eyeClosed:d("eye-closed",60135),fileBinary:d("file-binary",60136),fileCode:d("file-code",60137),fileMedia:d("file-media",60138),filePdf:d("file-pdf",60139),fileSubmodule:d("file-submodule",60140),fileSymlinkDirectory:d("file-symlink-directory",60141),fileSymlinkFile:d("file-symlink-file",60142),fileZip:d("file-zip",60143),files:d("files",60144),filter:d("filter",60145),flame:d("flame",60146),foldDown:d("fold-down",60147),foldUp:d("fold-up",60148),fold:d("fold",60149),folderActive:d("folder-active",60150),folderOpened:d("folder-opened",60151),gear:d("gear",60152),gift:d("gift",60153),gistSecret:d("gist-secret",60154),gist:d("gist",60155),gitCommit:d("git-commit",60156),gitCompare:d("git-compare",60157),gitMerge:d("git-merge",60158),githubAction:d("github-action",60159),githubAlt:d("github-alt",60160),globe:d("globe",60161),grabber:d("grabber",60162),graph:d("graph",60163),gripper:d("gripper",60164),heart:d("heart",60165),home:d("home",60166),horizontalRule:d("horizontal-rule",60167),hubot:d("hubot",60168),inbox:d("inbox",60169),issueClosed:d("issue-closed",60324),issueReopened:d("issue-reopened",60171),issues:d("issues",60172),italic:d("italic",60173),jersey:d("jersey",60174),json:d("json",60175),bracket:d("bracket",60175),kebabVertical:d("kebab-vertical",60176),key:d("key",60177),law:d("law",60178),lightbulbAutofix:d("lightbulb-autofix",60179),linkExternal:d("link-external",60180),link:d("link",60181),listOrdered:d("list-ordered",60182),listUnordered:d("list-unordered",60183),liveShare:d("live-share",60184),loading:d("loading",60185),location:d("location",60186),mailRead:d("mail-read",60187),mail:d("mail",60188),markdown:d("markdown",60189),megaphone:d("megaphone",60190),mention:d("mention",60191),milestone:d("milestone",60192),mortarBoard:d("mortar-board",60193),move:d("move",60194),multipleWindows:d("multiple-windows",60195),mute:d("mute",60196),noNewline:d("no-newline",60197),note:d("note",60198),octoface:d("octoface",60199),openPreview:d("open-preview",60200),package_:d("package",60201),paintcan:d("paintcan",60202),pin:d("pin",60203),play:d("play",60204),run:d("run",60204),plug:d("plug",60205),preserveCase:d("preserve-case",60206),preview:d("preview",60207),project:d("project",60208),pulse:d("pulse",60209),question:d("question",60210),quote:d("quote",60211),radioTower:d("radio-tower",60212),reactions:d("reactions",60213),references:d("references",60214),refresh:d("refresh",60215),regex:d("regex",60216),remoteExplorer:d("remote-explorer",60217),remote:d("remote",60218),remove:d("remove",60219),replaceAll:d("replace-all",60220),replace:d("replace",60221),repoClone:d("repo-clone",60222),repoForcePush:d("repo-force-push",60223),repoPull:d("repo-pull",60224),repoPush:d("repo-push",60225),report:d("report",60226),requestChanges:d("request-changes",60227),rocket:d("rocket",60228),rootFolderOpened:d("root-folder-opened",60229),rootFolder:d("root-folder",60230),rss:d("rss",60231),ruby:d("ruby",60232),saveAll:d("save-all",60233),saveAs:d("save-as",60234),save:d("save",60235),screenFull:d("screen-full",60236),screenNormal:d("screen-normal",60237),searchStop:d("search-stop",60238),server:d("server",60240),settingsGear:d("settings-gear",60241),settings:d("settings",60242),shield:d("shield",60243),smiley:d("smiley",60244),sortPrecedence:d("sort-precedence",60245),splitHorizontal:d("split-horizontal",60246),splitVertical:d("split-vertical",60247),squirrel:d("squirrel",60248),starFull:d("star-full",60249),starHalf:d("star-half",60250),symbolClass:d("symbol-class",60251),symbolColor:d("symbol-color",60252),symbolCustomColor:d("symbol-customcolor",60252),symbolConstant:d("symbol-constant",60253),symbolEnumMember:d("symbol-enum-member",60254),symbolField:d("symbol-field",60255),symbolFile:d("symbol-file",60256),symbolInterface:d("symbol-interface",60257),symbolKeyword:d("symbol-keyword",60258),symbolMisc:d("symbol-misc",60259),symbolOperator:d("symbol-operator",60260),symbolProperty:d("symbol-property",60261),wrench:d("wrench",60261),wrenchSubaction:d("wrench-subaction",60261),symbolSnippet:d("symbol-snippet",60262),tasklist:d("tasklist",60263),telescope:d("telescope",60264),textSize:d("text-size",60265),threeBars:d("three-bars",60266),thumbsdown:d("thumbsdown",60267),thumbsup:d("thumbsup",60268),tools:d("tools",60269),triangleDown:d("triangle-down",60270),triangleLeft:d("triangle-left",60271),triangleRight:d("triangle-right",60272),triangleUp:d("triangle-up",60273),twitter:d("twitter",60274),unfold:d("unfold",60275),unlock:d("unlock",60276),unmute:d("unmute",60277),unverified:d("unverified",60278),verified:d("verified",60279),versions:d("versions",60280),vmActive:d("vm-active",60281),vmOutline:d("vm-outline",60282),vmRunning:d("vm-running",60283),watch:d("watch",60284),whitespace:d("whitespace",60285),wholeWord:d("whole-word",60286),window:d("window",60287),wordWrap:d("word-wrap",60288),zoomIn:d("zoom-in",60289),zoomOut:d("zoom-out",60290),listFilter:d("list-filter",60291),listFlat:d("list-flat",60292),listSelection:d("list-selection",60293),selection:d("selection",60293),listTree:d("list-tree",60294),debugBreakpointFunctionUnverified:d("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:d("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:d("debug-breakpoint-function-disabled",60296),debugStackframeActive:d("debug-stackframe-active",60297),circleSmallFilled:d("circle-small-filled",60298),debugStackframeDot:d("debug-stackframe-dot",60298),debugStackframe:d("debug-stackframe",60299),debugStackframeFocused:d("debug-stackframe-focused",60299),debugBreakpointUnsupported:d("debug-breakpoint-unsupported",60300),symbolString:d("symbol-string",60301),debugReverseContinue:d("debug-reverse-continue",60302),debugStepBack:d("debug-step-back",60303),debugRestartFrame:d("debug-restart-frame",60304),callIncoming:d("call-incoming",60306),callOutgoing:d("call-outgoing",60307),menu:d("menu",60308),expandAll:d("expand-all",60309),feedback:d("feedback",60310),groupByRefType:d("group-by-ref-type",60311),ungroupByRefType:d("ungroup-by-ref-type",60312),account:d("account",60313),bellDot:d("bell-dot",60314),debugConsole:d("debug-console",60315),library:d("library",60316),output:d("output",60317),runAll:d("run-all",60318),syncIgnored:d("sync-ignored",60319),pinned:d("pinned",60320),githubInverted:d("github-inverted",60321),debugAlt:d("debug-alt",60305),serverProcess:d("server-process",60322),serverEnvironment:d("server-environment",60323),pass:d("pass",60324),stopCircle:d("stop-circle",60325),playCircle:d("play-circle",60326),record:d("record",60327),debugAltSmall:d("debug-alt-small",60328),vmConnect:d("vm-connect",60329),cloud:d("cloud",60330),merge:d("merge",60331),exportIcon:d("export",60332),graphLeft:d("graph-left",60333),magnet:d("magnet",60334),notebook:d("notebook",60335),redo:d("redo",60336),checkAll:d("check-all",60337),pinnedDirty:d("pinned-dirty",60338),passFilled:d("pass-filled",60339),circleLargeFilled:d("circle-large-filled",60340),circleLarge:d("circle-large",60341),circleLargeOutline:d("circle-large-outline",60341),combine:d("combine",60342),gather:d("gather",60342),table:d("table",60343),variableGroup:d("variable-group",60344),typeHierarchy:d("type-hierarchy",60345),typeHierarchySub:d("type-hierarchy-sub",60346),typeHierarchySuper:d("type-hierarchy-super",60347),gitPullRequestCreate:d("git-pull-request-create",60348),runAbove:d("run-above",60349),runBelow:d("run-below",60350),notebookTemplate:d("notebook-template",60351),debugRerun:d("debug-rerun",60352),workspaceTrusted:d("workspace-trusted",60353),workspaceUntrusted:d("workspace-untrusted",60354),workspaceUnspecified:d("workspace-unspecified",60355),terminalCmd:d("terminal-cmd",60356),terminalDebian:d("terminal-debian",60357),terminalLinux:d("terminal-linux",60358),terminalPowershell:d("terminal-powershell",60359),terminalTmux:d("terminal-tmux",60360),terminalUbuntu:d("terminal-ubuntu",60361),terminalBash:d("terminal-bash",60362),arrowSwap:d("arrow-swap",60363),copy:d("copy",60364),personAdd:d("person-add",60365),filterFilled:d("filter-filled",60366),wand:d("wand",60367),debugLineByLine:d("debug-line-by-line",60368),inspect:d("inspect",60369),layers:d("layers",60370),layersDot:d("layers-dot",60371),layersActive:d("layers-active",60372),compass:d("compass",60373),compassDot:d("compass-dot",60374),compassActive:d("compass-active",60375),azure:d("azure",60376),issueDraft:d("issue-draft",60377),gitPullRequestClosed:d("git-pull-request-closed",60378),gitPullRequestDraft:d("git-pull-request-draft",60379),debugAll:d("debug-all",60380),debugCoverage:d("debug-coverage",60381),runErrors:d("run-errors",60382),folderLibrary:d("folder-library",60383),debugContinueSmall:d("debug-continue-small",60384),beakerStop:d("beaker-stop",60385),graphLine:d("graph-line",60386),graphScatter:d("graph-scatter",60387),pieChart:d("pie-chart",60388),bracketDot:d("bracket-dot",60389),bracketError:d("bracket-error",60390),lockSmall:d("lock-small",60391),azureDevops:d("azure-devops",60392),verifiedFilled:d("verified-filled",60393),newLine:d("newline",60394),layout:d("layout",60395),layoutActivitybarLeft:d("layout-activitybar-left",60396),layoutActivitybarRight:d("layout-activitybar-right",60397),layoutPanelLeft:d("layout-panel-left",60398),layoutPanelCenter:d("layout-panel-center",60399),layoutPanelJustify:d("layout-panel-justify",60400),layoutPanelRight:d("layout-panel-right",60401),layoutPanel:d("layout-panel",60402),layoutSidebarLeft:d("layout-sidebar-left",60403),layoutSidebarRight:d("layout-sidebar-right",60404),layoutStatusbar:d("layout-statusbar",60405),layoutMenubar:d("layout-menubar",60406),layoutCentered:d("layout-centered",60407),layoutSidebarRightOff:d("layout-sidebar-right-off",60416),layoutPanelOff:d("layout-panel-off",60417),layoutSidebarLeftOff:d("layout-sidebar-left-off",60418),target:d("target",60408),indent:d("indent",60409),recordSmall:d("record-small",60410),errorSmall:d("error-small",60411),arrowCircleDown:d("arrow-circle-down",60412),arrowCircleLeft:d("arrow-circle-left",60413),arrowCircleRight:d("arrow-circle-right",60414),arrowCircleUp:d("arrow-circle-up",60415),heartFilled:d("heart-filled",60420),map:d("map",60421),mapFilled:d("map-filled",60422),circleSmall:d("circle-small",60423),bellSlash:d("bell-slash",60424),bellSlashDot:d("bell-slash-dot",60425),commentUnresolved:d("comment-unresolved",60426),gitPullRequestGoToChanges:d("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:d("git-pull-request-new-changes",60428),searchFuzzy:d("search-fuzzy",60429),commentDraft:d("comment-draft",60430),send:d("send",60431),sparkle:d("sparkle",60432),insert:d("insert",60433),dialogError:d("dialog-error","error"),dialogWarning:d("dialog-warning","warning"),dialogInfo:d("dialog-info","info"),dialogClose:d("dialog-close","close"),treeItemExpanded:d("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:d("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:d("tree-filter-on-type-off","list-selection"),treeFilterClear:d("tree-filter-clear","close"),treeItemLoading:d("tree-item-loading","loading"),menuSelection:d("menu-selection","check"),menuSubmenu:d("menu-submenu","chevron-right"),menuBarMore:d("menubar-more","more"),scrollbarButtonLeft:d("scrollbar-button-left","triangle-left"),scrollbarButtonRight:d("scrollbar-button-right","triangle-right"),scrollbarButtonUp:d("scrollbar-button-up","triangle-up"),scrollbarButtonDown:d("scrollbar-button-down","triangle-down"),toolBarMore:d("toolbar-more","more"),quickInputBack:d("quick-input-back","arrow-left")}}),define(De[24],Ie([1,0,12]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const a=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([b,f])=>{a[b]=f&&typeof f=="object"?T(f):f}),a}e.deepClone=T;function d(l){if(!l||typeof l!="object")return l;const a=[l];for(;a.length>0;){const b=a.shift();Object.freeze(b);for(const f in b)if(L.call(b,f)){const _=b[f];typeof _=="object"&&!Object.isFrozen(_)&&!(0,v.isTypedArray)(_)&&a.push(_)}}return l}e.deepFreeze=d;const L=Object.prototype.hasOwnProperty;function R(l,a){return g(l,a,new Set)}e.cloneAndChange=R;function g(l,a,b){if((0,v.isUndefinedOrNull)(l))return l;const f=a(l);if(typeof f<"u")return f;if(Array.isArray(l)){const _=[];for(const n of l)_.push(g(n,a,b));return _}if((0,v.isObject)(l)){if(b.has(l))throw new Error("Cannot clone recursive data-structure");b.add(l);const _={};for(const n in l)L.call(l,n)&&(_[n]=g(l[n],a,b));return b.delete(l),_}return l}function y(l,a,b=!0){return(0,v.isObject)(l)?((0,v.isObject)(a)&&Object.keys(a).forEach(f=>{f in l?b&&((0,v.isObject)(l[f])&&(0,v.isObject)(a[f])?y(l[f],a[f],b):l[f]=a[f]):l[f]=a[f]}),l):a}e.mixin=y;function m(l,a){if(l===a)return!0;if(l==null||a===null||a===void 0||typeof l!=typeof a||typeof l!="object"||Array.isArray(l)!==Array.isArray(a))return!1;let b,f;if(Array.isArray(l)){if(l.length!==a.length)return!1;for(b=0;b<l.length;b++)if(!m(l[b],a[b]))return!1}else{const _=[];for(f in l)_.push(f);_.sort();const n=[];for(f in a)n.push(f);if(n.sort(),!m(_,n))return!1;for(b=0;b<_.length;b++)if(!m(l[_[b]],a[_[b]]))return!1}return!0}e.equals=m;function A(l){const a=new Set;return JSON.stringify(l,(b,f)=>{if((0,v.isObject)(f)||Array.isArray(f)){if(a.has(f))return"[Circular]";a.add(f)}return f})}e.safeStringify=A;function k(l,a){const b=Object.create(null);return!l||!a||Object.keys(a).forEach(_=>{const n=l[_],o=a[_];m(n,o)||(b[_]=o)}),b}e.distinct=k;function w(l,a){const b=a.toLowerCase(),f=Object.keys(l).find(_=>_.toLowerCase()===b);return f?l[f]:l[a]}e.getCaseInsensitive=w;function D(l,a){const b=Object.create(null);for(const[f,_]of Object.entries(l))a(f,_)&&(b[f]=_);return b}e.filter=D;function I(l){let a=[],b=Object.getPrototypeOf(l);for(;Object.prototype!==b;)a=a.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return a}e.getAllPropertyNames=I;function E(l){const a=[];for(const b of I(l))typeof l[b]=="function"&&a.push(b);return a}e.getAllMethodNames=E;function i(l,a){const b=_=>function(){const n=Array.prototype.slice.call(arguments,0);return a(_,n)},f={};for(const _ of l)f[_]=b(_);return f}e.createProxyObject=i}),define(De[55],Ie([1,0,72]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var T;(function(R){function g(y){return y&&typeof y=="object"&&typeof y.id=="string"}R.isThemeColor=g})(T||(e.ThemeColor=T={}));function d(R){return{id:R}}e.themeColorFromId=d;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const g=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function y(a){const b=g.exec(a.id);if(!b)return y(v.Codicon.error);const[,f,_]=b,n=["codicon","codicon-"+f];return _&&n.push("codicon-modifier-"+_.substring(1)),n}R.asClassNameArray=y;function m(a){return y(a).join(" ")}R.asClassName=m;function A(a){return"."+y(a).join(".")}R.asCSSSelector=A;function k(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||T.isThemeColor(a.color))}R.isThemeIcon=k;const w=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function D(a){const b=w.exec(a);if(!b)return;const[,f]=b;return{id:f}}R.fromString=D;function I(a){return{id:a}}R.fromId=I;function E(a,b){let f=a.id;const _=f.lastIndexOf("~");return _!==-1&&(f=f.substring(0,_)),b&&(f=`${f}~${b}`),{id:f}}R.modify=E;function i(a){const b=a.id.lastIndexOf("~");if(b!==-1)return a.id.substring(b+1)}R.getModifier=i;function l(a,b){return a.id===b.id&&a.color?.id===b.color?.id}R.isEqual=l})(L||(e.ThemeIcon=L={}))}),define(De[154],Ie([1,0,113,9,55]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const L="$(",R=new RegExp(`\\$\\(${d.ThemeIcon.iconNameExpression}(?:${d.ThemeIcon.iconModifierExpression})?\\)`,"g"),g=new RegExp(`(\\\\)?${R.source}`,"g");function y(l){return l.replace(g,(a,b)=>b?a:`\\${a}`)}e.escapeIcons=y;const m=new RegExp(`\\\\${R.source}`,"g");function A(l){return l.replace(m,a=>`\\${a}`)}e.markdownEscapeEscapedIcons=A;const k=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function w(l){return l.indexOf(L)===-1?l:l.replace(k,(a,b,f,_)=>f?a:b||_||"")}e.stripIcons=w;function D(l){return l?l.replace(/\$\((.*?)\)/g,(a,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=D;const I=new RegExp(`\\$\\(${d.ThemeIcon.iconNameCharacter}+\\)`,"g");function E(l){I.lastIndex=0;let a="";const b=[];let f=0;for(;;){const _=I.lastIndex,n=I.exec(l),o=l.substring(_,n?.index);if(o.length>0){a+=o;for(let s=0;s<o.length;s++)b.push(f)}if(!n)break;f+=n[0].length}return{text:a,iconOffsets:b}}e.parseLabelWithIcons=E;function i(l,a,b=!1){const{text:f,iconOffsets:_}=a;if(!_||_.length===0)return(0,v.matchesFuzzy)(l,f,b);const n=(0,T.ltrim)(f," "),o=f.length-n.length,s=(0,v.matchesFuzzy)(l,n,b);if(s)for(const t of s){const u=_[t.start+o]+o;t.start+=u,t.end+=u}return s}e.matchesFuzzyIconAware=i}),define(De[114],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var v;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(v||(e.Constants=v={}));function T(L){return L<0?0:L>255?255:L|0}e.toUint8=T;function d(L){return L<0?0:L>4294967295?4294967295:L|0}e.toUint32=d}),define(De[32],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(d){return v.test(d)}e.isUUID=T,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let d;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?d=crypto.getRandomValues.bind(crypto):d=function(g){for(let y=0;y<g.length;y++)g[y]=Math.floor(Math.random()*256);return g};const L=new Uint8Array(16),R=[];for(let g=0;g<256;g++)R.push(g.toString(16).padStart(2,"0"));return function(){d(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let y=0,m="";return m+=R[L[y++]],m+=R[L[y++]],m+=R[L[y++]],m+=R[L[y++]],m+="-",m+=R[L[y++]],m+=R[L[y++]],m+="-",m+=R[L[y++]],m+=R[L[y++]],m+="-",m+=R[L[y++]],m+=R[L[y++]],m+="-",m+=R[L[y++]],m+=R[L[y++]],m+=R[L[y++]],m+=R[L[y++]],m+=R[L[y++]],m+=R[L[y++]],m}}()}),define(De[155],Ie([1,0,19,48,32]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function L(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.createStringDataTransferItem=L;function R(k,w,D){const I={id:(0,d.generateUuid)(),name:k,uri:w,data:D};return{asString:async()=>"",asFile:()=>I,value:void 0}}e.createFileDataTransferItem=R;class g{constructor(){this._entries=new Map}get size(){let w=0;for(const D of this._entries)w++;return w}has(w){return this._entries.has(this.toKey(w))}matches(w){const D=[...this._entries.keys()];return T.Iterable.some(this,([I,E])=>E.asFile())&&D.push("files"),A(y(w),D)}get(w){return this._entries.get(this.toKey(w))?.[0]}append(w,D){const I=this._entries.get(w);I?I.push(D):this._entries.set(this.toKey(w),[D])}replace(w,D){this._entries.set(this.toKey(w),[D])}delete(w){this._entries.delete(this.toKey(w))}*[Symbol.iterator](){for(const[w,D]of this._entries)for(const I of D)yield[w,I]}toKey(w){return y(w)}}e.VSDataTransfer=g;function y(k){return k.toLowerCase()}function m(k,w){return A(y(k),w.map(y))}e.matchesMimeType=m;function A(k,w){if(k==="*/*")return w.length>0;if(w.includes(k))return!0;const D=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!D)return!1;const[I,E,i]=D;return i==="*"?w.some(l=>l.startsWith(E+"/")):!1}e.UriList=Object.freeze({create:k=>(0,v.distinct)(k.map(w=>w.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.UriList.split(k).filter(w=>!w.startsWith("#"))})}),define(De[115],Ie([1,0,114]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class T{constructor(g){const y=(0,v.toUint8)(g);this._defaultValue=y,this._asciiMap=T._createAsciiMap(y),this._map=new Map}static _createAsciiMap(g){const y=new Uint8Array(256);return y.fill(g),y}set(g,y){const m=(0,v.toUint8)(y);g>=0&&g<256?this._asciiMap[g]=m:this._map.set(g,m)}get(g){return g>=0&&g<256?this._asciiMap[g]:this._map.get(g)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=T;var d;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(d||(d={}));class L{constructor(){this._actual=new T(0)}add(g){this._actual.set(g,1)}has(g){return this._actual.get(g)===1}clear(){return this._actual.clear()}}e.CharacterSet=L}),define(De[56],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class v{constructor(d,L){this.lineNumber=d,this.column=L}with(d=this.lineNumber,L=this.column){return d===this.lineNumber&&L===this.column?this:new v(d,L)}delta(d=0,L=0){return this.with(this.lineNumber+d,this.column+L)}equals(d){return v.equals(this,d)}static equals(d,L){return!d&&!L?!0:!!d&&!!L&&d.lineNumber===L.lineNumber&&d.column===L.column}isBefore(d){return v.isBefore(this,d)}static isBefore(d,L){return d.lineNumber<L.lineNumber?!0:L.lineNumber<d.lineNumber?!1:d.column<L.column}isBeforeOrEqual(d){return v.isBeforeOrEqual(this,d)}static isBeforeOrEqual(d,L){return d.lineNumber<L.lineNumber?!0:L.lineNumber<d.lineNumber?!1:d.column<=L.column}static compare(d,L){const R=d.lineNumber|0,g=L.lineNumber|0;if(R===g){const y=d.column|0,m=L.column|0;return y-m}return R-g}clone(){return new v(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(d){return new v(d.lineNumber,d.column)}static isIPosition(d){return d&&typeof d.lineNumber=="number"&&typeof d.column=="number"}}e.Position=v}),define(De[35],Ie([1,0,56]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class T{constructor(L,R,g,y){L>g||L===g&&R>y?(this.startLineNumber=g,this.startColumn=y,this.endLineNumber=L,this.endColumn=R):(this.startLineNumber=L,this.startColumn=R,this.endLineNumber=g,this.endColumn=y)}isEmpty(){return T.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return T.containsPosition(this,L)}static containsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<L.startColumn||R.lineNumber===L.endLineNumber&&R.column>L.endColumn)}static strictContainsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<=L.startColumn||R.lineNumber===L.endLineNumber&&R.column>=L.endColumn)}containsRange(L){return T.containsRange(this,L)}static containsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>L.endColumn)}strictContainsRange(L){return T.strictContainsRange(this,L)}static strictContainsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<=L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>=L.endColumn)}plusRange(L){return T.plusRange(this,L)}static plusRange(L,R){let g,y,m,A;return R.startLineNumber<L.startLineNumber?(g=R.startLineNumber,y=R.startColumn):R.startLineNumber===L.startLineNumber?(g=R.startLineNumber,y=Math.min(R.startColumn,L.startColumn)):(g=L.startLineNumber,y=L.startColumn),R.endLineNumber>L.endLineNumber?(m=R.endLineNumber,A=R.endColumn):R.endLineNumber===L.endLineNumber?(m=R.endLineNumber,A=Math.max(R.endColumn,L.endColumn)):(m=L.endLineNumber,A=L.endColumn),new T(g,y,m,A)}intersectRanges(L){return T.intersectRanges(this,L)}static intersectRanges(L,R){let g=L.startLineNumber,y=L.startColumn,m=L.endLineNumber,A=L.endColumn;const k=R.startLineNumber,w=R.startColumn,D=R.endLineNumber,I=R.endColumn;return g<k?(g=k,y=w):g===k&&(y=Math.max(y,w)),m>D?(m=D,A=I):m===D&&(A=Math.min(A,I)),g>m||g===m&&y>A?null:new T(g,y,m,A)}equalsRange(L){return T.equalsRange(this,L)}static equalsRange(L,R){return!L&&!R?!0:!!L&&!!R&&L.startLineNumber===R.startLineNumber&&L.startColumn===R.startColumn&&L.endLineNumber===R.endLineNumber&&L.endColumn===R.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(L){return new v.Position(L.endLineNumber,L.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(L){return new v.Position(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,R){return new T(this.startLineNumber,this.startColumn,L,R)}setStartPosition(L,R){return new T(L,R,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(L){return new T(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(L){return new T(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new T(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,R=L){return new T(L.lineNumber,L.column,R.lineNumber,R.column)}static lift(L){return L?new T(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn)}static areIntersecting(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,R){if(L&&R){const m=L.startLineNumber|0,A=R.startLineNumber|0;if(m===A){const k=L.startColumn|0,w=R.startColumn|0;if(k===w){const D=L.endLineNumber|0,I=R.endLineNumber|0;if(D===I){const E=L.endColumn|0,i=R.endColumn|0;return E-i}return D-I}return k-w}return m-A}return(L?1:0)-(R?1:0)}static compareRangesUsingEnds(L,R){return L.endLineNumber===R.endLineNumber?L.endColumn===R.endColumn?L.startLineNumber===R.startLineNumber?L.startColumn-R.startColumn:L.startLineNumber-R.startLineNumber:L.endColumn-R.endColumn:L.endLineNumber-R.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.Range=T}),define(De[156],Ie([1,0,56,35]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var d;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(d||(e.SelectionDirection=d={}));class L extends T.Range{constructor(g,y,m,A){super(g,y,m,A),this.selectionStartLineNumber=g,this.selectionStartColumn=y,this.positionLineNumber=m,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(g){return L.selectionsEqual(this,g)}static selectionsEqual(g,y){return g.selectionStartLineNumber===y.selectionStartLineNumber&&g.selectionStartColumn===y.selectionStartColumn&&g.positionLineNumber===y.positionLineNumber&&g.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(g,y){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,g,y):new L(g,y,this.startLineNumber,this.startColumn)}getPosition(){return new v.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new v.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(g,y){return this.getDirection()===0?new L(g,y,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,g,y)}static fromPositions(g,y=g){return new L(g.lineNumber,g.column,y.lineNumber,y.column)}static fromRange(g,y){return y===0?new L(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):new L(g.endLineNumber,g.endColumn,g.startLineNumber,g.startColumn)}static liftSelection(g){return new L(g.selectionStartLineNumber,g.selectionStartColumn,g.positionLineNumber,g.positionColumn)}static selectionsArrEqual(g,y){if(g&&!y||!g&&y)return!1;if(!g&&!y)return!0;if(g.length!==y.length)return!1;for(let m=0,A=g.length;m<A;m++)if(!this.selectionsEqual(g[m],y[m]))return!1;return!0}static isISelection(g){return g&&typeof g.selectionStartLineNumber=="number"&&typeof g.selectionStartColumn=="number"&&typeof g.positionLineNumber=="number"&&typeof g.positionColumn=="number"}static createWithDirection(g,y,m,A,k){return k===0?new L(g,y,m,A):new L(m,A,g,y)}}e.Selection=L}),define(De[157],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[158],Ie([1,0,115]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var T;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class d extends v.CharacterClassifier{constructor(g){super(0);for(let y=0,m=g.length;y<m;y++)this.set(g.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=d;function L(R){const g={};return y=>(g.hasOwnProperty(y)||(g[y]=R(y)),g[y])}e.getMapForWordSeparators=L(R=>new d(R))}),define(De[116],Ie([1,0,48,4,68]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(k=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const D of e.USUAL_WORD_SEPARATORS)k.indexOf(D)>=0||(w+="\\"+D);return w+="\\s]+)",new RegExp(w,"g")}e.DEFAULT_WORD_REGEXP=L();function R(k){let w=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)w=k;else{let D="g";k.ignoreCase&&(D+="i"),k.multiline&&(D+="m"),k.unicode&&(D+="u"),w=new RegExp(k.source,D)}return w.lastIndex=0,w}e.ensureValidWordDefinition=R;const g=new d.LinkedList;g.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(k){const w=g.unshift(k);return(0,T.toDisposable)(w)}e.setDefaultGetWordAtTextConfig=y;function m(k,w,D,I,E){if(E||(E=v.Iterable.first(g)),D.length>E.maxLen){let f=k-E.maxLen/2;return f<0?f=0:I+=f,D=D.substring(f,k+E.maxLen/2),m(k,w,D,I,E)}const i=Date.now(),l=k-1-I;let a=-1,b=null;for(let f=1;!(Date.now()-i>=E.timeBudget);f++){const _=l-E.windowSize*f;w.lastIndex=Math.max(0,_);const n=A(w,D,l,a);if(!n&&b||(b=n,_<=0))break;a=_}if(b){const f={word:b[0],startColumn:I+1+b.index,endColumn:I+1+b.index+b[0].length};return w.lastIndex=0,f}return null}e.getWordAtText=m;function A(k,w,D,I){let E;for(;E=k.exec(w);){const i=E.index||0;if(i<=D&&k.lastIndex>=D)return E;if(I>0&&i>I)return null}return null}}),define(De[159],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var v;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(v||(e.IndentAction=v={}));class T{constructor(g){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=g.open,this.close=g.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(g.notIn))for(let y=0,m=g.notIn.length;y<m;y++)switch(g.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(g){switch(g){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(g,y){if(g.getTokenCount()===0)return!0;const m=g.findTokenIndexAtOffset(y-2),A=g.getStandardTokenType(m);return this.isOK(A)}_findNeutralCharacterInRange(g,y){for(let m=g;m<=y;m++){const A=String.fromCharCode(m);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=T;class d{constructor(g){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of g)L(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),L(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),L(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),L(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&L(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=d;function L(R,g,y){R.has(g)?R.get(g).push(y):R.set(g,[y])}}),define(De[160],Ie([1,0,115]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var T;(function(D){D[D.Invalid=0]="Invalid",D[D.Start=1]="Start",D[D.H=2]="H",D[D.HT=3]="HT",D[D.HTT=4]="HTT",D[D.HTTP=5]="HTTP",D[D.F=6]="F",D[D.FI=7]="FI",D[D.FIL=8]="FIL",D[D.BeforeColon=9]="BeforeColon",D[D.AfterColon=10]="AfterColon",D[D.AlmostThere=11]="AlmostThere",D[D.End=12]="End",D[D.Accept=13]="Accept",D[D.LastKnownState=14]="LastKnownState"})(T||(e.State=T={}));class d{constructor(I,E,i){const l=new Uint8Array(I*E);for(let a=0,b=I*E;a<b;a++)l[a]=i;this._data=l,this.rows=I,this.cols=E}get(I,E){return this._data[I*this.cols+E]}set(I,E,i){this._data[I*this.cols+E]=i}}class L{constructor(I){let E=0,i=0;for(let a=0,b=I.length;a<b;a++){const[f,_,n]=I[a];_>E&&(E=_),f>i&&(i=f),n>i&&(i=n)}E++,i++;const l=new d(i,E,0);for(let a=0,b=I.length;a<b;a++){const[f,_,n]=I[a];l.set(f,_,n)}this._states=l,this._maxCharCode=E}nextState(I,E){return E<0||E>=this._maxCharCode?0:this._states.get(I,E)}}e.StateMachine=L;let R=null;function g(){return R===null&&(R=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var y;(function(D){D[D.None=0]="None",D[D.ForceTermination=1]="ForceTermination",D[D.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let m=null;function A(){if(m===null){m=new v.CharacterClassifier(0);const D=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<D.length;E++)m.set(D.charCodeAt(E),1);const I=".,;:";for(let E=0;E<I.length;E++)m.set(I.charCodeAt(E),2)}return m}class k{static _createLink(I,E,i,l,a){let b=a-1;do{const f=E.charCodeAt(b);if(I.get(f)!==2)break;b--}while(b>l);if(l>0){const f=E.charCodeAt(l-1),_=E.charCodeAt(b);(f===40&&_===41||f===91&&_===93||f===123&&_===125)&&b--}return{range:{startLineNumber:i,startColumn:l+1,endLineNumber:i,endColumn:b+2},url:E.substring(l,b+1)}}static computeLinks(I,E=g()){const i=A(),l=[];for(let a=1,b=I.getLineCount();a<=b;a++){const f=I.getLineContent(a),_=f.length;let n=0,o=0,s=0,t=1,u=!1,p=!1,h=!1,C=!1;for(;n<_;){let S=!1;const c=f.charCodeAt(n);if(t===13){let r;switch(c){case 40:u=!0,r=0;break;case 41:r=u?0:1;break;case 91:h=!0,p=!0,r=0;break;case 93:h=!1,r=p?0:1;break;case 123:C=!0,r=0;break;case 125:r=C?0:1;break;case 39:case 34:case 96:s===c?r=1:s===39||s===34||s===96?r=0:r=1;break;case 42:r=s===42?1:0;break;case 124:r=s===124?1:0;break;case 32:r=h?0:1;break;default:r=i.get(c)}r===1&&(l.push(k._createLink(i,f,a,o,n)),S=!0)}else if(t===12){let r;c===91?(p=!0,r=0):r=i.get(c),r===1?S=!0:t=13}else t=E.nextState(t,c),t===0&&(S=!0);S&&(t=1,u=!1,p=!1,C=!1,o=n+1,s=c),n++}t===13&&l.push(k._createLink(i,f,a,o,_))}return l}}e.LinkComputer=k;function w(D){return!D||typeof D.getLineCount!="function"||typeof D.getLineContent!="function"?[]:k.computeLinks(D)}e.computeLinks=w}),define(De[117],Ie([1,0,24]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var T;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(T||(e.OverviewRulerLane=T={}));var d;(function(f){f[f.Left=1]="Left",f[f.Right=2]="Right"})(d||(e.GlyphMarginLane=d={}));var L;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var R;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var g;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(g||(e.EndOfLinePreference=g={}));var y;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(y||(e.DefaultEndOfLine=y={}));var m;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(m||(e.EndOfLineSequence=m={}));class A{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(_){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,_.tabSize|0),_.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,_.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!_.insertSpaces,this.defaultEOL=_.defaultEOL|0,this.trimAutoWhitespace=!!_.trimAutoWhitespace,this.bracketPairColorizationOptions=_.bracketPairColorizationOptions}equals(_){return this.tabSize===_.tabSize&&this._indentSizeIsTabSize===_._indentSizeIsTabSize&&this.indentSize===_.indentSize&&this.insertSpaces===_.insertSpaces&&this.defaultEOL===_.defaultEOL&&this.trimAutoWhitespace===_.trimAutoWhitespace&&(0,v.equals)(this.bracketPairColorizationOptions,_.bracketPairColorizationOptions)}createChangeEvent(_){return{tabSize:this.tabSize!==_.tabSize,indentSize:this.indentSize!==_.indentSize,insertSpaces:this.insertSpaces!==_.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==_.trimAutoWhitespace}}}e.TextModelResolvedOptions=A;class k{constructor(_,n){this._findMatchBrand=void 0,this.range=_,this.matches=n}}e.FindMatch=k;var w;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(w||(e.TrackedRangeStickiness=w={}));function D(f){return f&&typeof f.read=="function"}e.isITextSnapshot=D;var I;(function(f){f[f.Left=0]="Left",f[f.Right=1]="Right",f[f.None=2]="None",f[f.LeftOfInjectedText=3]="LeftOfInjectedText",f[f.RightOfInjectedText=4]="RightOfInjectedText"})(I||(e.PositionAffinity=I={}));var E;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E||(e.ModelConstants=E={}));class i{constructor(_,n,o,s,t,u){this.identifier=_,this.range=n,this.text=o,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=t,this._isTracked=u}}e.ValidAnnotatedEditOperation=i;class l{constructor(_,n,o){this.regex=_,this.wordSeparators=n,this.simpleSearch=o}}e.SearchData=l;class a{constructor(_,n,o){this.reverseEdits=_,this.changes=n,this.trimAutoWhitespaceLineNumbers=o}}e.ApplyEditsResult=a;function b(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}e.shouldSynchronizeModel=b}),define(De[161],Ie([1,0,19,114]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class d{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,m){y=(0,T.toUint32)(y);const A=this.values,k=this.prefixSum,w=m.length;return w===0?!1:(this.values=new Uint32Array(A.length+w),this.values.set(A.subarray(0,y),0),this.values.set(A.subarray(y),y+w),this.values.set(m,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(y,m){return y=(0,T.toUint32)(y),m=(0,T.toUint32)(m),this.values[y]===m?!1:(this.values[y]=m,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,m){y=(0,T.toUint32)(y),m=(0,T.toUint32)(m);const A=this.values,k=this.prefixSum;if(y>=A.length)return!1;const w=A.length-y;return m>=w&&(m=w),m===0?!1:(this.values=new Uint32Array(A.length-m),this.values.set(A.subarray(0,y),0),this.values.set(A.subarray(y+m),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(y){return y<0?0:(y=(0,T.toUint32)(y),this._getPrefixSum(y))}_getPrefixSum(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let m=this.prefixSumValidIndex[0]+1;m===0&&(this.prefixSum[0]=this.values[0],m++),y>=this.values.length&&(y=this.values.length-1);for(let A=m;A<=y;A++)this.prefixSum[A]=this.prefixSum[A-1]+this.values[A];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let m=0,A=this.values.length-1,k=0,w=0,D=0;for(;m<=A;)if(k=m+(A-m)/2|0,w=this.prefixSum[k],D=w-this.values[k],y<D)A=k-1;else if(y>=w)m=k+1;else break;return new R(k,y-D)}}e.PrefixSumComputer=d;class L{constructor(y){this._values=y,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(y){return this._ensureValid(),y===0?0:this._prefixSum[y-1]}getIndexOf(y){this._ensureValid();const m=this._indexBySum[y],A=m>0?this._prefixSum[m-1]:0;return new R(m,y-A)}removeValues(y,m){this._values.splice(y,m),this._invalidate(y)}insertValues(y,m){this._values=(0,v.arrayInsert)(this._values,y,m),this._invalidate(y)}_invalidate(y){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,y-1)}_ensureValid(){if(!this._isValid){for(let y=this._validEndIndex+1,m=this._values.length;y<m;y++){const A=this._values[y],k=y>0?this._prefixSum[y-1]:0;this._prefixSum[y]=k+A;for(let w=0;w<A;w++)this._indexBySum[k+w]=y}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(y,m){this._values[y]!==m&&(this._values[y]=m,this._invalidate(y))}}e.ConstantTimePrefixSumComputer=L;class R{constructor(y,m){this.index=y,this.remainder=m,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=m}}e.PrefixSumIndexOfResult=R}),define(De[162],Ie([1,0,9,56,161]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class L{constructor(g,y,m,A){this._uri=g,this._lines=y,this._eol=m,this._versionId=A,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(g){g.eol&&g.eol!==this._eol&&(this._eol=g.eol,this._lineStarts=null);const y=g.changes;for(const m of y)this._acceptDeleteRange(m.range),this._acceptInsertText(new T.Position(m.range.startLineNumber,m.range.startColumn),m.text);this._versionId=g.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const g=this._eol.length,y=this._lines.length,m=new Uint32Array(y);for(let A=0;A<y;A++)m[A]=this._lines[A].length+g;this._lineStarts=new d.PrefixSumComputer(m)}}_setLineText(g,y){this._lines[g]=y,this._lineStarts&&this._lineStarts.setValue(g,this._lines[g].length+this._eol.length)}_acceptDeleteRange(g){if(g.startLineNumber===g.endLineNumber){if(g.startColumn===g.endColumn)return;this._setLineText(g.startLineNumber-1,this._lines[g.startLineNumber-1].substring(0,g.startColumn-1)+this._lines[g.startLineNumber-1].substring(g.endColumn-1));return}this._setLineText(g.startLineNumber-1,this._lines[g.startLineNumber-1].substring(0,g.startColumn-1)+this._lines[g.endLineNumber-1].substring(g.endColumn-1)),this._lines.splice(g.startLineNumber,g.endLineNumber-g.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(g.startLineNumber,g.endLineNumber-g.startLineNumber)}_acceptInsertText(g,y){if(y.length===0)return;const m=(0,v.splitLines)(y);if(m.length===1){this._setLineText(g.lineNumber-1,this._lines[g.lineNumber-1].substring(0,g.column-1)+m[0]+this._lines[g.lineNumber-1].substring(g.column-1));return}m[m.length-1]+=this._lines[g.lineNumber-1].substring(g.column-1),this._setLineText(g.lineNumber-1,this._lines[g.lineNumber-1].substring(0,g.column-1)+m[0]);const A=new Uint32Array(m.length-1);for(let k=1;k<m.length;k++)this._lines.splice(g.lineNumber+k-1,0,m[k]),A[k-1]=m[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(g.lineNumber,A)}}e.MirrorTextModel=L}),define(De[163],Ie([1,0,9,158,56,35,117]),function(re,e,v,T,d,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const g=999;class y{constructor(a,b,f,_){this.searchString=a,this.isRegex=b,this.matchCase=f,this.wordSeparators=_}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=m(this.searchString):a=this.searchString.indexOf(`
`)>=0;let b=null;try{b=v.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch{return null}if(!b)return null;let f=!this.isRegex&&!a;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new R.SearchData(b,this.wordSeparators?(0,T.getMapForWordSeparators)(this.wordSeparators):null,f?this.searchString:null)}}e.SearchParams=y;function m(l){if(!l||l.length===0)return!1;for(let a=0,b=l.length;a<b;a++){const f=l.charCodeAt(a);if(f===10)return!0;if(f===92){if(a++,a>=b)break;const _=l.charCodeAt(a);if(_===110||_===114||_===87)return!0}}return!1}e.isMultilineRegexSource=m;function A(l,a,b){if(!b)return new R.FindMatch(l,null);const f=[];for(let _=0,n=a.length;_<n;_++)f[_]=a[_];return new R.FindMatch(l,f)}e.createFindMatch=A;class k{constructor(a){const b=[];let f=0;for(let _=0,n=a.length;_<n;_++)a.charCodeAt(_)===10&&(b[f++]=_);this._lineFeedsOffsets=b}findLineFeedCountBeforeOffset(a){const b=this._lineFeedsOffsets;let f=0,_=b.length-1;if(_===-1||a<=b[0])return 0;for(;f<_;){const n=f+((_-f)/2>>0);b[n]>=a?_=n-1:b[n+1]>=a?(f=n,_=n):f=n+1}return f+1}}class w{static findMatches(a,b,f,_,n){const o=b.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(a,f,new i(o.wordSeparators,o.regex),_,n):this._doFindMatchesLineByLine(a,f,o,_,n):[]}static _getMultilineMatchRange(a,b,f,_,n,o){let s,t=0;_?(t=_.findLineFeedCountBeforeOffset(n),s=b+n+t):s=b+n;let u;if(_){const S=_.findLineFeedCountBeforeOffset(n+o.length)-t;u=s+o.length+S}else u=s+o.length;const p=a.getPositionAt(s),h=a.getPositionAt(u);return new L.Range(p.lineNumber,p.column,h.lineNumber,h.column)}static _doFindMatchesMultiline(a,b,f,_,n){const o=a.getOffsetAt(b.getStartPosition()),s=a.getValueInRange(b,1),t=a.getEOL()===`\r
`?new k(s):null,u=[];let p=0,h;for(f.reset(0);h=f.next(s);)if(u[p++]=A(this._getMultilineMatchRange(a,o,s,t,h.index,h[0]),h,_),p>=n)return u;return u}static _doFindMatchesLineByLine(a,b,f,_,n){const o=[];let s=0;if(b.startLineNumber===b.endLineNumber){const u=a.getLineContent(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);return s=this._findMatchesInLine(f,u,b.startLineNumber,b.startColumn-1,s,o,_,n),o}const t=a.getLineContent(b.startLineNumber).substring(b.startColumn-1);s=this._findMatchesInLine(f,t,b.startLineNumber,b.startColumn-1,s,o,_,n);for(let u=b.startLineNumber+1;u<b.endLineNumber&&s<n;u++)s=this._findMatchesInLine(f,a.getLineContent(u),u,0,s,o,_,n);if(s<n){const u=a.getLineContent(b.endLineNumber).substring(0,b.endColumn-1);s=this._findMatchesInLine(f,u,b.endLineNumber,0,s,o,_,n)}return o}static _findMatchesInLine(a,b,f,_,n,o,s,t){const u=a.wordSeparators;if(!s&&a.simpleSearch){const C=a.simpleSearch,S=C.length,c=b.length;let r=-S;for(;(r=b.indexOf(C,r+S))!==-1;)if((!u||E(u,b,c,r,S))&&(o[n++]=new R.FindMatch(new L.Range(f,r+1+_,f,r+1+S+_),null),n>=t))return n;return n}const p=new i(a.wordSeparators,a.regex);let h;p.reset(0);do if(h=p.next(b),h&&(o[n++]=A(new L.Range(f,h.index+1+_,f,h.index+1+h[0].length+_),h,s),n>=t))return n;while(h);return n}static findNextMatch(a,b,f,_){const n=b.parseSearchRequest();if(!n)return null;const o=new i(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(a,f,o,_):this._doFindNextMatchLineByLine(a,f,o,_)}static _doFindNextMatchMultiline(a,b,f,_){const n=new d.Position(b.lineNumber,1),o=a.getOffsetAt(n),s=a.getLineCount(),t=a.getValueInRange(new L.Range(n.lineNumber,n.column,s,a.getLineMaxColumn(s)),1),u=a.getEOL()===`\r
`?new k(t):null;f.reset(b.column-1);const p=f.next(t);return p?A(this._getMultilineMatchRange(a,o,t,u,p.index,p[0]),p,_):b.lineNumber!==1||b.column!==1?this._doFindNextMatchMultiline(a,new d.Position(1,1),f,_):null}static _doFindNextMatchLineByLine(a,b,f,_){const n=a.getLineCount(),o=b.lineNumber,s=a.getLineContent(o),t=this._findFirstMatchInLine(f,s,o,b.column,_);if(t)return t;for(let u=1;u<=n;u++){const p=(o+u-1)%n,h=a.getLineContent(p+1),C=this._findFirstMatchInLine(f,h,p+1,1,_);if(C)return C}return null}static _findFirstMatchInLine(a,b,f,_,n){a.reset(_-1);const o=a.next(b);return o?A(new L.Range(f,o.index+1,f,o.index+1+o[0].length),o,n):null}static findPreviousMatch(a,b,f,_){const n=b.parseSearchRequest();if(!n)return null;const o=new i(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(a,f,o,_):this._doFindPreviousMatchLineByLine(a,f,o,_)}static _doFindPreviousMatchMultiline(a,b,f,_){const n=this._doFindMatchesMultiline(a,new L.Range(1,1,b.lineNumber,b.column),f,_,10*g);if(n.length>0)return n[n.length-1];const o=a.getLineCount();return b.lineNumber!==o||b.column!==a.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(a,new d.Position(o,a.getLineMaxColumn(o)),f,_):null}static _doFindPreviousMatchLineByLine(a,b,f,_){const n=a.getLineCount(),o=b.lineNumber,s=a.getLineContent(o).substring(0,b.column-1),t=this._findLastMatchInLine(f,s,o,_);if(t)return t;for(let u=1;u<=n;u++){const p=(n+o-u-1)%n,h=a.getLineContent(p+1),C=this._findLastMatchInLine(f,h,p+1,_);if(C)return C}return null}static _findLastMatchInLine(a,b,f,_){let n=null,o;for(a.reset(0);o=a.next(b);)n=A(new L.Range(f,o.index+1,f,o.index+1+o[0].length),o,_);return n}}e.TextModelSearch=w;function D(l,a,b,f,_){if(f===0)return!0;const n=a.charCodeAt(f-1);if(l.get(n)!==0||n===13||n===10)return!0;if(_>0){const o=a.charCodeAt(f);if(l.get(o)!==0)return!0}return!1}function I(l,a,b,f,_){if(f+_===b)return!0;const n=a.charCodeAt(f+_);if(l.get(n)!==0||n===13||n===10)return!0;if(_>0){const o=a.charCodeAt(f+_-1);if(l.get(o)!==0)return!0}return!1}function E(l,a,b,f,_){return D(l,a,b,f,_)&&I(l,a,b,f,_)}e.isValidMatch=E;class i{constructor(a,b){this._wordSeparators=a,this._searchRegex=b,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const b=a.length;let f;do{if(this._prevMatchStartIndex+this._prevMatchLength===b||(f=this._searchRegex.exec(a),!f))return null;const _=f.index,n=f[0].length;if(_===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){v.getNextCodePoint(a,b,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=_,this._prevMatchLength=n,!this._wordSeparators||E(this._wordSeparators,a,b,_,n))return f}while(f);return null}}e.Searcher=i}),define(De[164],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class v{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(L){if(L&&this._dragOperations.has(L)){const R=this._dragOperations.get(L);return this._dragOperations.delete(L),R}}addDragOperationTransfer(L,R){this._dragOperations.set(L,R)}}e.TreeViewsDnDService=v;class T{constructor(L){this.identifier=L}}e.DraggedTreeItemsIdentifier=T}),define(De[165],Ie([1,0,3,4]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class d{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(g){this._onDidChange.fire({changedLanguages:g,changedColorMap:!1})}register(g,y){return this._tokenizationSupports.set(g,y),this.handleChange([g]),(0,T.toDisposable)(()=>{this._tokenizationSupports.get(g)===y&&(this._tokenizationSupports.delete(g),this.handleChange([g]))})}get(g){return this._tokenizationSupports.get(g)||null}registerFactory(g,y){this._factories.get(g)?.dispose();const m=new L(this,g,y);return this._factories.set(g,m),(0,T.toDisposable)(()=>{const A=this._factories.get(g);!A||A!==m||(this._factories.delete(g),A.dispose())})}async getOrCreate(g){const y=this.get(g);if(y)return y;const m=this._factories.get(g);return!m||m.isResolved?null:(await m.resolve(),this.get(g))}isResolved(g){if(this.get(g))return!0;const m=this._factories.get(g);return!!(!m||m.isResolved)}setColorMap(g){this._colorMap=g,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=d;class L extends T.Disposable{get isResolved(){return this._isResolved}constructor(g,y,m){super(),this._registry=g,this._languageId=y,this._factory=m,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const g=await this._factory.tokenizationSupport;this._isResolved=!0,g&&!this._isDisposed&&this._register(this._registry.register(this._languageId,g))}}}),define(De[166],Ie([13,14]),function(re,e){return re.create("vs/base/common/actions",e)}),define(De[167],Ie([1,0,3,4,166]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class L extends T.Disposable{constructor(w,D="",I="",E=!0,i){super(),this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=w,this._label=D,this._cssClass=I,this._enabled=E,this._actionCallback=i}get id(){return this._id}get label(){return this._label}set label(w){this._setLabel(w)}_setLabel(w){this._label!==w&&(this._label=w,this._onDidChange.fire({label:w}))}get tooltip(){return this._tooltip||""}set tooltip(w){this._setTooltip(w)}_setTooltip(w){this._tooltip!==w&&(this._tooltip=w,this._onDidChange.fire({tooltip:w}))}get class(){return this._cssClass}set class(w){this._setClass(w)}_setClass(w){this._cssClass!==w&&(this._cssClass=w,this._onDidChange.fire({class:w}))}get enabled(){return this._enabled}set enabled(w){this._setEnabled(w)}_setEnabled(w){this._enabled!==w&&(this._enabled=w,this._onDidChange.fire({enabled:w}))}get checked(){return this._checked}set checked(w){this._setChecked(w)}_setChecked(w){this._checked!==w&&(this._checked=w,this._onDidChange.fire({checked:w}))}async run(w,D){this._actionCallback&&await this._actionCallback(w)}}e.Action=L;class R extends T.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new v.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new v.Emitter),this.onDidRun=this._onDidRun.event}async run(w,D){if(!w.enabled)return;this._onWillRun.fire({action:w});let I;try{await this.runAction(w,D)}catch(E){I=E}this._onDidRun.fire({action:w,error:I})}async runAction(w,D){await w.run(D)}}e.ActionRunner=R;class g{constructor(){this.id=g.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let D=[];for(const I of w)I.length&&(D.length?D=[...D,new g,...I]:D=I);return D}async run(){}}e.Separator=g,g.ID="vs.actions.separator";class y{get actions(){return this._actions}constructor(w,D,I,E){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=D,this.class=E,this._actions=I}async run(){}}e.SubmenuAction=y;class m extends L{constructor(){super(m.ID,d.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=m,m.ID="vs.actions.empty";function A(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async()=>k.run(),tooltip:k.label}}e.toAction=A}),define(De[168],Ie([13,14]),function(re,e){return re.create("vs/base/common/date",e)}),define(De[169],Ie([1,0,168]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,d=T*60,L=d*24,R=L*7,g=L*30,y=L*365;function m(k,w,D,I){typeof k!="number"&&(k=k.getTime());const E=Math.round((new Date().getTime()-k)/1e3);if(E<-30)return(0,v.localize)(0,null,m(new Date().getTime()+E*1e3,!1));if(!I&&E<30)return(0,v.localize)(1,null);let i;return E<T?(i=E,w?i===1?D?(0,v.localize)(2,null,i):(0,v.localize)(3,null,i):D?(0,v.localize)(4,null,i):(0,v.localize)(5,null,i):i===1?D?(0,v.localize)(6,null,i):(0,v.localize)(7,null,i):D?(0,v.localize)(8,null,i):(0,v.localize)(9,null,i)):E<d?(i=Math.floor(E/T),w?i===1?D?(0,v.localize)(10,null,i):(0,v.localize)(11,null,i):D?(0,v.localize)(12,null,i):(0,v.localize)(13,null,i):i===1?D?(0,v.localize)(14,null,i):(0,v.localize)(15,null,i):D?(0,v.localize)(16,null,i):(0,v.localize)(17,null,i)):E<L?(i=Math.floor(E/d),w?i===1?D?(0,v.localize)(18,null,i):(0,v.localize)(19,null,i):D?(0,v.localize)(20,null,i):(0,v.localize)(21,null,i):i===1?D?(0,v.localize)(22,null,i):(0,v.localize)(23,null,i):D?(0,v.localize)(24,null,i):(0,v.localize)(25,null,i)):E<R?(i=Math.floor(E/L),w?i===1?(0,v.localize)(26,null,i):(0,v.localize)(27,null,i):i===1?(0,v.localize)(28,null,i):(0,v.localize)(29,null,i)):E<g?(i=Math.floor(E/R),w?i===1?D?(0,v.localize)(30,null,i):(0,v.localize)(31,null,i):D?(0,v.localize)(32,null,i):(0,v.localize)(33,null,i):i===1?D?(0,v.localize)(34,null,i):(0,v.localize)(35,null,i):D?(0,v.localize)(36,null,i):(0,v.localize)(37,null,i)):E<y?(i=Math.floor(E/g),w?i===1?D?(0,v.localize)(38,null,i):(0,v.localize)(39,null,i):D?(0,v.localize)(40,null,i):(0,v.localize)(41,null,i):i===1?D?(0,v.localize)(42,null,i):(0,v.localize)(43,null,i):D?(0,v.localize)(44,null,i):(0,v.localize)(45,null,i)):(i=Math.floor(E/y),w?i===1?D?(0,v.localize)(46,null,i):(0,v.localize)(47,null,i):D?(0,v.localize)(48,null,i):(0,v.localize)(49,null,i):i===1?D?(0,v.localize)(50,null,i):(0,v.localize)(51,null,i):D?(0,v.localize)(52,null,i):(0,v.localize)(53,null,i))}e.fromNow=m;function A(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=A}),define(De[170],Ie([13,14]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(De[45],Ie([1,0,19,12,170]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(k,w){return w&&(k.stack||k.stacktrace)?d.localize(0,null,g(k),R(k.stack)||R(k.stacktrace)):g(k)}function R(k){return Array.isArray(k)?k.join(`
`):k}function g(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?d.localize(1,null,k.message):k.message||d.localize(2,null)}function y(k=null,w=!1){if(!k)return d.localize(3,null);if(Array.isArray(k)){const D=v.coalesce(k),I=y(D[0],w);return D.length>1?d.localize(4,null,I,D.length):I}if(T.isString(k))return k;if(k.detail){const D=k.detail;if(D.error)return L(D.error,w);if(D.exception)return L(D.exception,w)}return k.stack?L(k,w):k.message?k.message:d.localize(5,null)}e.toErrorMessage=y;function m(k){const w=k;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=m;function A(k,w){let D;return typeof k=="string"?D=new Error(k):D=k,D.actions=w,D}e.createErrorWithActions=A}),define(De[171],Ie([13,14]),function(re,e){return re.create("vs/base/common/platform",e)}),define(De[10],Ie([1,0,171]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let T=!1,d=!1,L=!1,R=!1,g=!1,y=!1,m=!1,A=!1,k=!1,w=!1,D,I=e.LANGUAGE_DEFAULT,E=e.LANGUAGE_DEFAULT,i,l;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?a=e.globals.vscode.process:typeof process<"u"&&(a=process);const b=typeof a?.versions?.electron=="string",f=b&&a?.type==="renderer";if(typeof navigator=="object"&&!f)l=navigator.userAgent,T=l.indexOf("Windows")>=0,d=l.indexOf("Macintosh")>=0,A=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=l.indexOf("Linux")>=0,w=l?.indexOf("Mobi")>=0,y=!0,D=v.getConfiguredDefaultLocale(v.localize(0,null))||e.LANGUAGE_DEFAULT,I=D,E=navigator.language;else if(typeof a=="object"){T=a.platform==="win32",d=a.platform==="darwin",L=a.platform==="linux",R=L&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,m=b,k=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,D=e.LANGUAGE_DEFAULT,I=e.LANGUAGE_DEFAULT;const C=a.env.VSCODE_NLS_CONFIG;if(C)try{const S=JSON.parse(C),c=S.availableLanguages["*"];D=S.locale,E=S.osLocale,I=c||e.LANGUAGE_DEFAULT,i=S._translationsConfigFile}catch{}g=!0}else console.error("Unable to resolve platform.");var _;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(_||(e.Platform=_={}));function n(C){switch(C){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=n;let o=0;d?o=1:T?o=3:L&&(o=2),e.isWindows=T,e.isMacintosh=d,e.isLinux=L,e.isLinuxSnap=R,e.isNative=g,e.isElectron=m,e.isWeb=y,e.isWebWorker=y&&typeof e.globals.importScripts=="function",e.isIOS=A,e.isMobile=w,e.isCI=k,e.platform=o,e.userAgent=l,e.language=I;var s;(function(C){function S(){return e.language}C.value=S;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}C.isDefaultVariant=c;function r(){return e.language==="en"}C.isDefault=r})(s||(e.Language=s={})),e.locale=D,e.platformLocale=E,e.translationsConfigFile=i,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const C=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let r=0,P=C.length;r<P;r++){const M=C[r];if(M.id===c.data.vscodeScheduleAsyncWork){C.splice(r,1),M.callback();return}}});let S=0;return c=>{const r=++S;C.push({id:r,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:r},"*")}}return C=>setTimeout(C)})();var t;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=d||A?2:T?1:3;let u=!0,p=!1;function h(){if(!p){p=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,u=new Uint16Array(C.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=h,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[41],Ie([1,0,10]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let T;if(typeof v.globals.vscode<"u"&&typeof v.globals.vscode.process<"u"){const d=v.globals.vscode.process;T={get platform(){return d.platform},get arch(){return d.arch},get env(){return d.env},cwd(){return d.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.arch=T.arch}),define(De[11],Ie([1,0,41]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,d=97,L=90,R=122,g=46,y=47,m=92,A=58,k=63;class w extends Error{constructor(o,s,t){let u;typeof s=="string"&&s.indexOf("not ")===0?(u="must not be",s=s.replace(/^not /,"")):u="must be";const p=o.indexOf(".")!==-1?"property":"argument";let h=`The "${o}" ${p} ${u} of type ${s}`;h+=`. Received type ${typeof t}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function D(n,o){if(n===null||typeof n!="object")throw new w(o,"Object",n)}function I(n,o){if(typeof n!="string")throw new w(o,"string",n)}const E=v.platform==="win32";function i(n){return n===y||n===m}function l(n){return n===y}function a(n){return n>=T&&n<=L||n>=d&&n<=R}function b(n,o,s,t){let u="",p=0,h=-1,C=0,S=0;for(let c=0;c<=n.length;++c){if(c<n.length)S=n.charCodeAt(c);else{if(t(S))break;S=y}if(t(S)){if(!(h===c-1||C===1))if(C===2){if(u.length<2||p!==2||u.charCodeAt(u.length-1)!==g||u.charCodeAt(u.length-2)!==g){if(u.length>2){const r=u.lastIndexOf(s);r===-1?(u="",p=0):(u=u.slice(0,r),p=u.length-1-u.lastIndexOf(s)),h=c,C=0;continue}else if(u.length!==0){u="",p=0,h=c,C=0;continue}}o&&(u+=u.length>0?`${s}..`:"..",p=2)}else u.length>0?u+=`${s}${n.slice(h+1,c)}`:u=n.slice(h+1,c),p=c-h-1;h=c,C=0}else S===g&&C!==-1?++C:C=-1}return u}function f(n,o){D(o,"pathObject");const s=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${t}`:`${s}${n}${t}`:t}e.win32={resolve(...n){let o="",s="",t=!1;for(let u=n.length-1;u>=-1;u--){let p;if(u>=0){if(p=n[u],I(p,"path"),p.length===0)continue}else o.length===0?p=v.cwd():(p=v.env[`=${o}`]||v.cwd(),(p===void 0||p.slice(0,2).toLowerCase()!==o.toLowerCase()&&p.charCodeAt(2)===m)&&(p=`${o}\\`));const h=p.length;let C=0,S="",c=!1;const r=p.charCodeAt(0);if(h===1)i(r)&&(C=1,c=!0);else if(i(r))if(c=!0,i(p.charCodeAt(1))){let P=2,M=P;for(;P<h&&!i(p.charCodeAt(P));)P++;if(P<h&&P!==M){const W=p.slice(M,P);for(M=P;P<h&&i(p.charCodeAt(P));)P++;if(P<h&&P!==M){for(M=P;P<h&&!i(p.charCodeAt(P));)P++;(P===h||P!==M)&&(S=`\\\\${W}\\${p.slice(M,P)}`,C=P)}}}else C=1;else a(r)&&p.charCodeAt(1)===A&&(S=p.slice(0,2),C=2,h>2&&i(p.charCodeAt(2))&&(c=!0,C=3));if(S.length>0)if(o.length>0){if(S.toLowerCase()!==o.toLowerCase())continue}else o=S;if(t){if(o.length>0)break}else if(s=`${p.slice(C)}\\${s}`,t=c,c&&o.length>0)break}return s=b(s,!t,"\\",i),t?`${o}\\${s}`:`${o}${s}`||"."},normalize(n){I(n,"path");const o=n.length;if(o===0)return".";let s=0,t,u=!1;const p=n.charCodeAt(0);if(o===1)return l(p)?"\\":n;if(i(p))if(u=!0,i(n.charCodeAt(1))){let C=2,S=C;for(;C<o&&!i(n.charCodeAt(C));)C++;if(C<o&&C!==S){const c=n.slice(S,C);for(S=C;C<o&&i(n.charCodeAt(C));)C++;if(C<o&&C!==S){for(S=C;C<o&&!i(n.charCodeAt(C));)C++;if(C===o)return`\\\\${c}\\${n.slice(S)}\\`;C!==S&&(t=`\\\\${c}\\${n.slice(S,C)}`,s=C)}}}else s=1;else a(p)&&n.charCodeAt(1)===A&&(t=n.slice(0,2),s=2,o>2&&i(n.charCodeAt(2))&&(u=!0,s=3));let h=s<o?b(n.slice(s),!u,"\\",i):"";return h.length===0&&!u&&(h="."),h.length>0&&i(n.charCodeAt(o-1))&&(h+="\\"),t===void 0?u?`\\${h}`:h:u?`${t}\\${h}`:`${t}${h}`},isAbsolute(n){I(n,"path");const o=n.length;if(o===0)return!1;const s=n.charCodeAt(0);return i(s)||o>2&&a(s)&&n.charCodeAt(1)===A&&i(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let o,s;for(let p=0;p<n.length;++p){const h=n[p];I(h,"path"),h.length>0&&(o===void 0?o=s=h:o+=`\\${h}`)}if(o===void 0)return".";let t=!0,u=0;if(typeof s=="string"&&i(s.charCodeAt(0))){++u;const p=s.length;p>1&&i(s.charCodeAt(1))&&(++u,p>2&&(i(s.charCodeAt(2))?++u:t=!1))}if(t){for(;u<o.length&&i(o.charCodeAt(u));)u++;u>=2&&(o=`\\${o.slice(u)}`)}return e.win32.normalize(o)},relative(n,o){if(I(n,"from"),I(o,"to"),n===o)return"";const s=e.win32.resolve(n),t=e.win32.resolve(o);if(s===t||(n=s.toLowerCase(),o=t.toLowerCase(),n===o))return"";let u=0;for(;u<n.length&&n.charCodeAt(u)===m;)u++;let p=n.length;for(;p-1>u&&n.charCodeAt(p-1)===m;)p--;const h=p-u;let C=0;for(;C<o.length&&o.charCodeAt(C)===m;)C++;let S=o.length;for(;S-1>C&&o.charCodeAt(S-1)===m;)S--;const c=S-C,r=h<c?h:c;let P=-1,M=0;for(;M<r;M++){const $=n.charCodeAt(u+M);if($!==o.charCodeAt(C+M))break;$===m&&(P=M)}if(M!==r){if(P===-1)return t}else{if(c>r){if(o.charCodeAt(C+M)===m)return t.slice(C+M+1);if(M===2)return t.slice(C+M)}h>r&&(n.charCodeAt(u+M)===m?P=M:M===2&&(P=3)),P===-1&&(P=0)}let W="";for(M=u+P+1;M<=p;++M)(M===p||n.charCodeAt(M)===m)&&(W+=W.length===0?"..":"\\..");return C+=P,W.length>0?`${W}${t.slice(C,S)}`:(t.charCodeAt(C)===m&&++C,t.slice(C,S))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const o=e.win32.resolve(n);if(o.length<=2)return n;if(o.charCodeAt(0)===m){if(o.charCodeAt(1)===m){const s=o.charCodeAt(2);if(s!==k&&s!==g)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(a(o.charCodeAt(0))&&o.charCodeAt(1)===A&&o.charCodeAt(2)===m)return`\\\\?\\${o}`;return n},dirname(n){I(n,"path");const o=n.length;if(o===0)return".";let s=-1,t=0;const u=n.charCodeAt(0);if(o===1)return i(u)?n:".";if(i(u)){if(s=t=1,i(n.charCodeAt(1))){let C=2,S=C;for(;C<o&&!i(n.charCodeAt(C));)C++;if(C<o&&C!==S){for(S=C;C<o&&i(n.charCodeAt(C));)C++;if(C<o&&C!==S){for(S=C;C<o&&!i(n.charCodeAt(C));)C++;if(C===o)return n;C!==S&&(s=t=C+1)}}}}else a(u)&&n.charCodeAt(1)===A&&(s=o>2&&i(n.charCodeAt(2))?3:2,t=s);let p=-1,h=!0;for(let C=o-1;C>=t;--C)if(i(n.charCodeAt(C))){if(!h){p=C;break}}else h=!1;if(p===-1){if(s===-1)return".";p=s}return n.slice(0,p)},basename(n,o){o!==void 0&&I(o,"ext"),I(n,"path");let s=0,t=-1,u=!0,p;if(n.length>=2&&a(n.charCodeAt(0))&&n.charCodeAt(1)===A&&(s=2),o!==void 0&&o.length>0&&o.length<=n.length){if(o===n)return"";let h=o.length-1,C=-1;for(p=n.length-1;p>=s;--p){const S=n.charCodeAt(p);if(i(S)){if(!u){s=p+1;break}}else C===-1&&(u=!1,C=p+1),h>=0&&(S===o.charCodeAt(h)?--h===-1&&(t=p):(h=-1,t=C))}return s===t?t=C:t===-1&&(t=n.length),n.slice(s,t)}for(p=n.length-1;p>=s;--p)if(i(n.charCodeAt(p))){if(!u){s=p+1;break}}else t===-1&&(u=!1,t=p+1);return t===-1?"":n.slice(s,t)},extname(n){I(n,"path");let o=0,s=-1,t=0,u=-1,p=!0,h=0;n.length>=2&&n.charCodeAt(1)===A&&a(n.charCodeAt(0))&&(o=t=2);for(let C=n.length-1;C>=o;--C){const S=n.charCodeAt(C);if(i(S)){if(!p){t=C+1;break}continue}u===-1&&(p=!1,u=C+1),S===g?s===-1?s=C:h!==1&&(h=1):s!==-1&&(h=-1)}return s===-1||u===-1||h===0||h===1&&s===u-1&&s===t+1?"":n.slice(s,u)},format:f.bind(null,"\\"),parse(n){I(n,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return o;const s=n.length;let t=0,u=n.charCodeAt(0);if(s===1)return i(u)?(o.root=o.dir=n,o):(o.base=o.name=n,o);if(i(u)){if(t=1,i(n.charCodeAt(1))){let P=2,M=P;for(;P<s&&!i(n.charCodeAt(P));)P++;if(P<s&&P!==M){for(M=P;P<s&&i(n.charCodeAt(P));)P++;if(P<s&&P!==M){for(M=P;P<s&&!i(n.charCodeAt(P));)P++;P===s?t=P:P!==M&&(t=P+1)}}}}else if(a(u)&&n.charCodeAt(1)===A){if(s<=2)return o.root=o.dir=n,o;if(t=2,i(n.charCodeAt(2))){if(s===3)return o.root=o.dir=n,o;t=3}}t>0&&(o.root=n.slice(0,t));let p=-1,h=t,C=-1,S=!0,c=n.length-1,r=0;for(;c>=t;--c){if(u=n.charCodeAt(c),i(u)){if(!S){h=c+1;break}continue}C===-1&&(S=!1,C=c+1),u===g?p===-1?p=c:r!==1&&(r=1):p!==-1&&(r=-1)}return C!==-1&&(p===-1||r===0||r===1&&p===C-1&&p===h+1?o.base=o.name=n.slice(h,C):(o.name=n.slice(h,p),o.base=n.slice(h,C),o.ext=n.slice(p,C))),h>0&&h!==t?o.dir=n.slice(0,h-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const _=(()=>{if(E){const n=/\\/g;return()=>{const o=v.cwd().replace(n,"/");return o.slice(o.indexOf("/"))}}return()=>v.cwd()})();e.posix={resolve(...n){let o="",s=!1;for(let t=n.length-1;t>=-1&&!s;t--){const u=t>=0?n[t]:_();I(u,"path"),u.length!==0&&(o=`${u}/${o}`,s=u.charCodeAt(0)===y)}return o=b(o,!s,"/",l),s?`/${o}`:o.length>0?o:"."},normalize(n){if(I(n,"path"),n.length===0)return".";const o=n.charCodeAt(0)===y,s=n.charCodeAt(n.length-1)===y;return n=b(n,!o,"/",l),n.length===0?o?"/":s?"./":".":(s&&(n+="/"),o?`/${n}`:n)},isAbsolute(n){return I(n,"path"),n.length>0&&n.charCodeAt(0)===y},join(...n){if(n.length===0)return".";let o;for(let s=0;s<n.length;++s){const t=n[s];I(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(n,o){if(I(n,"from"),I(o,"to"),n===o||(n=e.posix.resolve(n),o=e.posix.resolve(o),n===o))return"";const s=1,t=n.length,u=t-s,p=1,h=o.length-p,C=u<h?u:h;let S=-1,c=0;for(;c<C;c++){const P=n.charCodeAt(s+c);if(P!==o.charCodeAt(p+c))break;P===y&&(S=c)}if(c===C)if(h>C){if(o.charCodeAt(p+c)===y)return o.slice(p+c+1);if(c===0)return o.slice(p+c)}else u>C&&(n.charCodeAt(s+c)===y?S=c:c===0&&(S=0));let r="";for(c=s+S+1;c<=t;++c)(c===t||n.charCodeAt(c)===y)&&(r+=r.length===0?"..":"/..");return`${r}${o.slice(p+S)}`},toNamespacedPath(n){return n},dirname(n){if(I(n,"path"),n.length===0)return".";const o=n.charCodeAt(0)===y;let s=-1,t=!0;for(let u=n.length-1;u>=1;--u)if(n.charCodeAt(u)===y){if(!t){s=u;break}}else t=!1;return s===-1?o?"/":".":o&&s===1?"//":n.slice(0,s)},basename(n,o){o!==void 0&&I(o,"ext"),I(n,"path");let s=0,t=-1,u=!0,p;if(o!==void 0&&o.length>0&&o.length<=n.length){if(o===n)return"";let h=o.length-1,C=-1;for(p=n.length-1;p>=0;--p){const S=n.charCodeAt(p);if(S===y){if(!u){s=p+1;break}}else C===-1&&(u=!1,C=p+1),h>=0&&(S===o.charCodeAt(h)?--h===-1&&(t=p):(h=-1,t=C))}return s===t?t=C:t===-1&&(t=n.length),n.slice(s,t)}for(p=n.length-1;p>=0;--p)if(n.charCodeAt(p)===y){if(!u){s=p+1;break}}else t===-1&&(u=!1,t=p+1);return t===-1?"":n.slice(s,t)},extname(n){I(n,"path");let o=-1,s=0,t=-1,u=!0,p=0;for(let h=n.length-1;h>=0;--h){const C=n.charCodeAt(h);if(C===y){if(!u){s=h+1;break}continue}t===-1&&(u=!1,t=h+1),C===g?o===-1?o=h:p!==1&&(p=1):o!==-1&&(p=-1)}return o===-1||t===-1||p===0||p===1&&o===t-1&&o===s+1?"":n.slice(o,t)},format:f.bind(null,"/"),parse(n){I(n,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return o;const s=n.charCodeAt(0)===y;let t;s?(o.root="/",t=1):t=0;let u=-1,p=0,h=-1,C=!0,S=n.length-1,c=0;for(;S>=t;--S){const r=n.charCodeAt(S);if(r===y){if(!C){p=S+1;break}continue}h===-1&&(C=!1,h=S+1),r===g?u===-1?u=S:c!==1&&(c=1):u!==-1&&(c=-1)}if(h!==-1){const r=p===0&&s?1:p;u===-1||c===0||c===1&&u===h-1&&u===p+1?o.base=o.name=n.slice(r,h):(o.name=n.slice(r,u),o.base=n.slice(r,h),o.ext=n.slice(u,h))}return p>0?o.dir=n.slice(0,p-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E?e.win32.normalize:e.posix.normalize,e.isAbsolute=E?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E?e.win32.join:e.posix.join,e.resolve=E?e.win32.resolve:e.posix.resolve,e.relative=E?e.win32.relative:e.posix.relative,e.dirname=E?e.win32.dirname:e.posix.dirname,e.basename=E?e.win32.basename:e.posix.basename,e.extname=E?e.win32.extname:e.posix.extname,e.format=E?e.win32.format:e.posix.format,e.parse=E?e.win32.parse:e.posix.parse,e.toNamespacedPath=E?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E?e.win32.sep:e.posix.sep,e.delimiter=E?e.win32.delimiter:e.posix.delimiter}),define(De[118],Ie([1,0,54,11]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const d=new v.Lazy(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),L=new v.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new v.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function g(C,S,c=!1){const r=C||"",P=S||"",M=d.value.collator.compare(r,P);return d.value.collatorIsNumeric&&M===0&&r!==P?r<P?-1:1:M}e.compareFileNames=g;function y(C,S){const c=L.value.collator;return C=C||"",S=S||"",f(c,C,S)}e.compareFileNamesDefault=y;function m(C,S){const c=L.value.collator;return C=C||"",S=S||"",s(C,S)||f(c,C,S)}e.compareFileNamesUpper=m;function A(C,S){const c=L.value.collator;return C=C||"",S=S||"",o(C,S)||f(c,C,S)}e.compareFileNamesLower=A;function k(C,S){return C=C||"",S=S||"",C===S?0:C<S?-1:1}e.compareFileNamesUnicode=k;function w(C,S){const[c,r]=a(C),[P,M]=a(S);let W=d.value.collator.compare(r,M);if(W===0){if(d.value.collatorIsNumeric&&r!==M)return r<M?-1:1;if(W=d.value.collator.compare(c,P),d.value.collatorIsNumeric&&W===0&&c!==P)return c<P?-1:1}return W}e.compareFileExtensions=w;function D(C,S){C=C||"",S=S||"";const c=b(C),r=b(S),P=L.value.collator,M=R.value.collator;return f(M,c,r)||f(P,C,S)}e.compareFileExtensionsDefault=D;function I(C,S){C=C||"",S=S||"";const c=b(C),r=b(S),P=L.value.collator,M=R.value.collator;return f(M,c,r)||s(C,S)||f(P,C,S)}e.compareFileExtensionsUpper=I;function E(C,S){C=C||"",S=S||"";const c=b(C),r=b(S),P=L.value.collator,M=R.value.collator;return f(M,c,r)||o(C,S)||f(P,C,S)}e.compareFileExtensionsLower=E;function i(C,S){C=C||"",S=S||"";const c=b(C).toLowerCase(),r=b(S).toLowerCase();return c!==r?c<r?-1:1:C!==S?C<S?-1:1:0}e.compareFileExtensionsUnicode=i;const l=/^(.*?)(\.([^.]*))?$/;function a(C,S=!1){const c=C?l.exec(C):[];let r=[c&&c[1]||"",c&&c[3]||""];return S&&(!r[0]&&r[1]||r[0]&&r[0].charAt(0)===".")&&(r=[r[0]+"."+r[1],""]),r}function b(C){const S=C?l.exec(C):[];return S&&S[1]&&S[1].charAt(0)!=="."&&S[3]||""}function f(C,S,c){const r=C.compare(S,c);return r!==0?r:S.length!==c.length?S.length<c.length?-1:1:0}function _(C){const S=C.charAt(0);return S.toLocaleUpperCase()!==S}function n(C){const S=C.charAt(0);return S.toLocaleLowerCase()!==S}function o(C,S){return _(C)&&n(S)?-1:n(C)&&_(S)?1:0}function s(C,S){return n(C)&&_(S)?-1:_(C)&&n(S)?1:0}function t(C,S,c=!1){return c||(C=C&&C.toLowerCase(),S=S&&S.toLowerCase()),C===S?0:C<S?-1:1}function u(C,S,c=!1){const r=C.split(T.sep),P=S.split(T.sep),M=r.length-1,W=P.length-1;let $,z;for(let N=0;;N++){if($=M===N,z=W===N,$&&z)return g(r[N],P[N],c);if($)return-1;if(z)return 1;const q=t(r[N],P[N],c);if(q!==0)return q}}e.comparePaths=u;function p(C,S,c){const r=C.toLowerCase(),P=S.toLowerCase(),M=h(C,S,c);if(M)return M;const W=r.endsWith(c),$=P.endsWith(c);if(W!==$)return W?-1:1;const z=g(r,P);return z!==0?z:r.localeCompare(P)}e.compareAnything=p;function h(C,S,c){const r=C.toLowerCase(),P=S.toLowerCase(),M=r.startsWith(c),W=P.startsWith(c);if(M!==W)return M?-1:1;if(M&&W){if(r.length<P.length)return-1;if(r.length>P.length)return 1}return 0}e.compareByPrefix=h}),define(De[31],Ie([1,0,11,10,9,12]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(p){return p===47||p===92}e.isPathSeparator=R;function g(p){return p.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=g;function y(p){return p.indexOf("/")===-1&&(p=g(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}e.toPosixPath=y;function m(p,h=v.posix.sep){if(!p)return"";const C=p.length,S=p.charCodeAt(0);if(R(S)){if(R(p.charCodeAt(1))&&!R(p.charCodeAt(2))){let r=3;const P=r;for(;r<C&&!R(p.charCodeAt(r));r++);if(P!==r&&!R(p.charCodeAt(r+1))){for(r+=1;r<C;r++)if(R(p.charCodeAt(r)))return p.slice(0,r+1).replace(/[\\/]/g,h)}}return h}else if(l(S)&&p.charCodeAt(1)===58)return R(p.charCodeAt(2))?p.slice(0,2)+h:p.slice(0,2);let c=p.indexOf("://");if(c!==-1){for(c+=3;c<C;c++)if(R(p.charCodeAt(c)))return p.slice(0,c+1)}return""}e.getRoot=m;function A(p){if(!T.isWindows||!p||p.length<5)return!1;let h=p.charCodeAt(0);if(h!==92||(h=p.charCodeAt(1),h!==92))return!1;let C=2;const S=C;for(;C<p.length&&(h=p.charCodeAt(C),h!==92);C++);return!(S===C||(h=p.charCodeAt(C+1),isNaN(h)||h===92))}e.isUNC=A;const k=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,D=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function I(p,h=T.isWindows){const C=h?k:w;return!(!p||p.length===0||/^\s+$/.test(p)||(C.lastIndex=0,C.test(p))||h&&D.test(p)||p==="."||p===".."||h&&p[p.length-1]==="."||h&&p.length!==p.trim().length||p.length>255)}e.isValidBasename=I;function E(p,h,C){const S=p===h;return!C||S?S:!p||!h?!1:(0,d.equalsIgnoreCase)(p,h)}e.isEqual=E;function i(p,h,C,S=v.sep){if(p===h)return!0;if(!p||!h||h.length>p.length)return!1;if(C){if(!(0,d.startsWithIgnoreCase)(p,h))return!1;if(h.length===p.length)return!0;let r=h.length;return h.charAt(h.length-1)===S&&r--,p.charAt(r)===S}return h.charAt(h.length-1)!==S&&(h+=S),p.indexOf(h)===0}e.isEqualOrParent=i;function l(p){return p>=65&&p<=90||p>=97&&p<=122}e.isWindowsDriveLetter=l;function a(p,h){return T.isWindows&&p.endsWith(":")&&(p+=v.sep),(0,v.isAbsolute)(p)||(p=(0,v.join)(h,p)),p=(0,v.normalize)(p),T.isWindows?(p=(0,d.rtrim)(p,v.sep),p.endsWith(":")&&(p+=v.sep)):(p=(0,d.rtrim)(p,v.sep),p||(p=v.sep)),p}e.sanitizeFilePath=a;function b(p){const h=(0,v.normalize)(p);return T.isWindows?p.length>3?!1:f(h)&&(p.length===2||h.charCodeAt(2)===92):h===v.posix.sep}e.isRootOrDriveLetter=b;function f(p,h=T.isWindows){return h?l(p.charCodeAt(0))&&p.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function _(p,h=T.isWindows){return f(p,h)?p[0]:void 0}e.getDriveLetter=_;function n(p,h,C){return h.length>p.length?-1:p===h?0:(C&&(p=p.toLowerCase(),h=h.toLowerCase()),p.indexOf(h))}e.indexOfPath=n;function o(p){const h=p.split(":");let C,S,c;for(const r of h){const P=Number(r);(0,L.isNumber)(P)?S===void 0?S=P:c===void 0&&(c=P):C=C?[C,r].join(":"):r}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:S!==void 0?S:void 0,column:c!==void 0?c:S!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function u(p,h,C=8){let S="";for(let r=0;r<C;r++){let P;r===0&&T.isWindows&&!h&&(C===3||C===4)?P=t:P=s,S+=P.charAt(Math.floor(Math.random()*P.length))}let c;return h?c=`${h}-${S}`:c=S,p?(0,v.join)(p,c):c}e.randomPath=u}),define(De[119],Ie([1,0,118,113,70,11,10,9]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,m=[y,[]];function A(x,U,de,ie){if(!x||!U)return m;const ne=x.length,H=U.length;if(ne<H)return m;const V=x.toLowerCase();return k(U,de,H,x,V,ne,ie)}e.scoreFuzzy=A;function k(x,U,de,ie,ne,H,V){const ce=[],be=[];for(let K=0;K<de;K++){const we=K*H,Ce=we-H,ee=K>0,te=x[K],ue=U[K];for(let Q=0;Q<H;Q++){const le=Q>0,se=we+Q,oe=se-1,F=Ce+Q-1,j=le?ce[oe]:0,Y=ee&&le?ce[F]:0,Z=ee&&le?be[F]:0;let me;!Y&&ee?me=0:me=w(te,ue,ie,ne,Q,Z),me&&Y+me>=j&&(V||ee||ne.startsWith(U,Q))?(be[se]=Z+1,ce[se]=Y+me):(be[se]=y,ce[se]=j)}}const Se=[];let ge=de-1,O=H-1;for(;ge>=0&&O>=0;){const K=ge*H+O;be[K]===y||(Se.push(O),ge--),O--}return[ce[de*H-1],Se.reverse()]}function w(x,U,de,ie,ne,H){let V=0;if(!D(U,ie[ne]))return V;if(V+=1,H>0&&(V+=H*5),x===de[ne]&&(V+=1),ne===0)V+=8;else{const ce=I(de.charCodeAt(ne-1));ce?V+=ce:(0,T.isUpper)(de.charCodeAt(ne))&&H===0&&(V+=2)}return V}function D(x,U){return x===U?!0:x==="/"||x==="\\"?U==="/"||U==="\\":!1}function I(x){switch(x){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const E=[void 0,[]];function i(x,U,de=0,ie=0){const ne=U;return ne.values&&ne.values.length>1?l(x,ne.values,de,ie):a(x,U,de,ie)}e.scoreFuzzy2=i;function l(x,U,de,ie){let ne=0;const H=[];for(const V of U){const[ce,be]=a(x,V,de,ie);if(typeof ce!="number")return E;ne+=ce,H.push(...be)}return[ne,C(H)]}function a(x,U,de,ie){const ne=(0,T.fuzzyScore)(U.original,U.originalLowercase,de,x,x.toLowerCase(),ie,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ne?[ne[0],(0,T.createMatches)(ne)]:E}const b=Object.freeze({score:0}),f=1<<18,_=1<<17,n=1<<16;function o(x,U,de,ie){const ne=ie.values?ie.values:[ie];return(0,d.hash)({[ie.normalized]:{values:ne.map(V=>({value:V.normalized,expectContiguousMatch:V.expectContiguousMatch})),label:x,description:U,allowNonContiguousMatches:de}})}function s(x,U,de,ie,ne){if(!x||!U.normalized)return b;const H=ie.getItemLabel(x);if(!H)return b;const V=ie.getItemDescription(x),ce=o(H,V,de,U),be=ne[ce];if(be)return be;const Se=t(H,V,ie.getItemPath(x),U,de);return ne[ce]=Se,Se}e.scoreItemFuzzy=s;function t(x,U,de,ie,ne){const H=!de||!ie.containsPathSeparator;return de&&(R.isLinux?ie.pathNormalized===de:(0,g.equalsIgnoreCase)(ie.pathNormalized,de))?{score:f,labelMatch:[{start:0,end:x.length}],descriptionMatch:U?[{start:0,end:U.length}]:void 0}:ie.values&&ie.values.length>1?u(x,U,de,ie.values,H,ne):p(x,U,de,ie,H,ne)}function u(x,U,de,ie,ne,H){let V=0;const ce=[],be=[];for(const Se of ie){const{score:ge,labelMatch:O,descriptionMatch:K}=p(x,U,de,Se,ne,H);if(ge===y)return b;V+=ge,O&&ce.push(...O),K&&be.push(...K)}return{score:V,labelMatch:C(ce),descriptionMatch:C(be)}}function p(x,U,de,ie,ne,H){if(ne||!U){const[V,ce]=A(x,ie.normalized,ie.normalizedLowercase,H&&!ie.expectContiguousMatch);if(V){const be=(0,T.matchesPrefix)(ie.normalized,x);let Se;if(be){Se=_;const ge=Math.round(ie.normalized.length/x.length*100);Se+=ge}else Se=n;return{score:Se+V,labelMatch:be||h(ce)}}}if(U){let V=U;de&&(V=`${U}${L.sep}`);const ce=V.length,be=`${V}${x}`,[Se,ge]=A(be,ie.normalized,ie.normalizedLowercase,H&&!ie.expectContiguousMatch);if(Se){const O=h(ge),K=[],we=[];return O.forEach(Ce=>{Ce.start<ce&&Ce.end>ce?(K.push({start:0,end:Ce.end-ce}),we.push({start:Ce.start,end:ce})):Ce.start>=ce?K.push({start:Ce.start-ce,end:Ce.end-ce}):we.push(Ce)}),{score:Se,labelMatch:K,descriptionMatch:we}}}return b}function h(x){const U=[];if(!x)return U;let de;for(const ie of x)de&&de.end===ie?de.end+=1:(de={start:ie,end:ie+1},U.push(de));return U}function C(x){const U=x.sort((ne,H)=>ne.start-H.start),de=[];let ie;for(const ne of U)!ie||!S(ie,ne)?(ie=ne,de.push(ne)):(ie.start=Math.min(ie.start,ne.start),ie.end=Math.max(ie.end,ne.end));return de}function S(x,U){return!(x.end<U.start||U.end<x.start)}function c(x,U,de,ie,ne,H){const V=s(x,de,ie,ne,H),ce=s(U,de,ie,ne,H),be=V.score,Se=ce.score;if((be===f||Se===f)&&be!==Se)return be===f?-1:1;if(be>n||Se>n){if(be!==Se)return be>Se?-1:1;if(be<_&&Se<_){const te=P(V.labelMatch,ce.labelMatch);if(te!==0)return te}const Ce=ne.getItemLabel(x)||"",ee=ne.getItemLabel(U)||"";if(Ce.length!==ee.length)return Ce.length-ee.length}if(be!==Se)return be>Se?-1:1;const ge=Array.isArray(V.labelMatch)&&V.labelMatch.length>0,O=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0;if(ge&&!O)return-1;if(O&&!ge)return 1;const K=r(x,V,ne),we=r(U,ce,ne);return K&&we&&K!==we?we>K?-1:1:M(x,U,de,ne)}e.compareItemsByFuzzyScore=c;function r(x,U,de){let ie=-1,ne=-1;if(U.descriptionMatch&&U.descriptionMatch.length?ie=U.descriptionMatch[0].start:U.labelMatch&&U.labelMatch.length&&(ie=U.labelMatch[0].start),U.labelMatch&&U.labelMatch.length){if(ne=U.labelMatch[U.labelMatch.length-1].end,U.descriptionMatch&&U.descriptionMatch.length){const H=de.getItemDescription(x);H&&(ne+=H.length)}}else U.descriptionMatch&&U.descriptionMatch.length&&(ne=U.descriptionMatch[U.descriptionMatch.length-1].end);return ne-ie}function P(x,U){if(!x&&!U||(!x||!x.length)&&(!U||!U.length))return 0;if(!U||!U.length)return-1;if(!x||!x.length)return 1;const de=x[0].start,ne=x[x.length-1].end-de,H=U[0].start,ce=U[U.length-1].end-H;return ne===ce?0:ce<ne?1:-1}function M(x,U,de,ie){const ne=ie.getItemLabel(x)||"",H=ie.getItemLabel(U)||"",V=ie.getItemDescription(x),ce=ie.getItemDescription(U),be=ne.length+(V?V.length:0),Se=H.length+(ce?ce.length:0);if(be!==Se)return be-Se;const ge=ie.getItemPath(x),O=ie.getItemPath(U);return ge&&O&&ge.length!==O.length?ge.length-O.length:ne!==H?(0,v.compareAnything)(ne,H,de.normalized):V&&ce&&V!==ce?(0,v.compareAnything)(V,ce,de.normalized):ge&&O&&ge!==O?(0,v.compareAnything)(ge,O,de.normalized):0}function W(x){return x.startsWith('"')&&x.endsWith('"')}const $=" ";function z(x){typeof x!="string"&&(x="");const U=x.toLowerCase(),{pathNormalized:de,normalized:ie,normalizedLowercase:ne}=N(x),H=de.indexOf(L.sep)>=0,V=W(x);let ce;const be=x.split($);if(be.length>1)for(const Se of be){const ge=W(Se),{pathNormalized:O,normalized:K,normalizedLowercase:we}=N(Se);K&&(ce||(ce=[]),ce.push({original:Se,originalLowercase:Se.toLowerCase(),pathNormalized:O,normalized:K,normalizedLowercase:we,expectContiguousMatch:ge}))}return{original:x,originalLowercase:U,pathNormalized:de,normalized:ie,normalizedLowercase:ne,values:ce,containsPathSeparator:H,expectContiguousMatch:V}}e.prepareQuery=z;function N(x){let U;R.isWindows?U=x.replace(/\//g,L.sep):U=x.replace(/\\/g,L.sep);const de=(0,g.stripWildcards)(U).replace(/\s|"/g,"");return{pathNormalized:U,normalized:de,normalizedLowercase:de.toLowerCase()}}function q(x){return Array.isArray(x)?z(x.map(U=>U.original).join($)):z(x.original)}e.pieceToQuery=q}),define(De[92],Ie([1,0,11]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},d={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(A){const k=(0,v.extname)(A),w=T[k.toLowerCase()];return w!==void 0?w:R(A)}e.getMediaOrTextMime=L;function R(A){const k=(0,v.extname)(A);return d[k.toLowerCase()]}e.getMediaMime=R;function g(A){for(const k in d)if(d[k]===A)return k}e.getExtensionForMimeType=g;const y=/^(.+)\/(.+?)(;.+)?$/;function m(A,k){const w=y.exec(A);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:k?void 0:A}e.normalizeMimeType=m}),define(De[93],Ie([1,0,10]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var T;(function(g){g[g.stdout=0]="stdout",g[g.stderr=1]="stderr"})(T||(e.Source=T={}));var d;(function(g){g[g.Success=0]="Success",g[g.Unknown=1]="Unknown",g[g.AccessDenied=2]="AccessDenied",g[g.ProcessNotFound=3]="ProcessNotFound"})(d||(e.TerminateResponseCode=d={}));function L(g,...y){const m=y.reduce((w,D)=>(w[D]=!0,w),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(g).filter(w=>!m[w]).forEach(w=>{for(let D=0;D<A.length;D++)if(w.search(A[D])!==-1){delete g[w];break}})}e.sanitizeProcessEnvironment=L;function R(g){g&&(delete g.DEBUG,v.isMacintosh&&delete g.DYLD_LIBRARY_PATH,v.isLinux&&delete g.LD_PRELOAD)}e.removeDangerousEnvVariables=R}),define(De[2],Ie([1,0,11,10]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const d=/^\w[\w\d+.-]*$/,L=/^\//,R=/^\/\//;function g(t,u){if(!t.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!d.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!L.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(t,u){return!t&&!u?"file":t}function m(t,u){switch(t){case"https":case"http":case"file":u?u[0]!==k&&(u=k+u):u=k;break}return u}const A="",k="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class D{static isUri(u){return u instanceof D?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,p,h,C,S,c=!1){typeof u=="object"?(this.scheme=u.scheme||A,this.authority=u.authority||A,this.path=u.path||A,this.query=u.query||A,this.fragment=u.fragment||A):(this.scheme=y(u,c),this.authority=p||A,this.path=m(this.scheme,h||A),this.query=C||A,this.fragment=S||A,g(this,c))}get fsPath(){return f(this,!1)}with(u){if(!u)return this;let{scheme:p,authority:h,path:C,query:S,fragment:c}=u;return p===void 0?p=this.scheme:p===null&&(p=A),h===void 0?h=this.authority:h===null&&(h=A),C===void 0?C=this.path:C===null&&(C=A),S===void 0?S=this.query:S===null&&(S=A),c===void 0?c=this.fragment:c===null&&(c=A),p===this.scheme&&h===this.authority&&C===this.path&&S===this.query&&c===this.fragment?this:new i(p,h,C,S,c)}static parse(u,p=!1){const h=w.exec(u);return h?new i(h[2]||A,s(h[4]||A),s(h[5]||A),s(h[7]||A),s(h[9]||A),p):new i(A,A,A,A,A)}static file(u){let p=A;if(T.isWindows&&(u=u.replace(/\\/g,k)),u[0]===k&&u[1]===k){const h=u.indexOf(k,2);h===-1?(p=u.substring(2),u=k):(p=u.substring(2,h),u=u.substring(h)||k)}return new i("file",p,u,A,A)}static from(u,p){return new i(u.scheme,u.authority,u.path,u.query,u.fragment,p)}static joinPath(u,...p){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return T.isWindows&&u.scheme==="file"?h=D.file(v.win32.join(f(u,!0),...p)).path:h=v.posix.join(u.path,...p),u.with({path:h})}toString(u=!1){return _(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof D)return u;{const p=new i(u);return p._formatted=u.external??null,p._fsPath=u._sep===E?u.fsPath??null:null,p}}else return u}}e.URI=D;function I(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.isUriComponents=I;const E=T.isWindows?1:void 0;class i extends D{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(u=!1){return u?_(this,!0):(this._formatted||(this._formatted=_(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=E),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const l={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(t,u,p){let h,C=-1;for(let S=0;S<t.length;S++){const c=t.charCodeAt(S);if(c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57||c===45||c===46||c===95||c===126||u&&c===47||p&&c===91||p&&c===93||p&&c===58)C!==-1&&(h+=encodeURIComponent(t.substring(C,S)),C=-1),h!==void 0&&(h+=t.charAt(S));else{h===void 0&&(h=t.substr(0,S));const r=l[c];r!==void 0?(C!==-1&&(h+=encodeURIComponent(t.substring(C,S)),C=-1),h+=r):C===-1&&(C=S)}}return C!==-1&&(h+=encodeURIComponent(t.substring(C))),h!==void 0?h:t}function b(t){let u;for(let p=0;p<t.length;p++){const h=t.charCodeAt(p);h===35||h===63?(u===void 0&&(u=t.substr(0,p)),u+=l[h]):u!==void 0&&(u+=t[p])}return u!==void 0?u:t}function f(t,u){let p;return t.authority&&t.path.length>1&&t.scheme==="file"?p=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?u?p=t.path.substr(1):p=t.path[1].toLowerCase()+t.path.substr(2):p=t.path,T.isWindows&&(p=p.replace(/\//g,"\\")),p}e.uriToFsPath=f;function _(t,u){const p=u?b:a;let h="",{scheme:C,authority:S,path:c,query:r,fragment:P}=t;if(C&&(h+=C,h+=":"),(S||C==="file")&&(h+=k,h+=k),S){let M=S.indexOf("@");if(M!==-1){const W=S.substr(0,M);S=S.substr(M+1),M=W.lastIndexOf(":"),M===-1?h+=p(W,!1,!1):(h+=p(W.substr(0,M),!1,!1),h+=":",h+=p(W.substr(M+1),!1,!0)),h+="@"}S=S.toLowerCase(),M=S.lastIndexOf(":"),M===-1?h+=p(S,!1,!0):(h+=p(S.substr(0,M),!1,!0),h+=S.substr(M))}if(c){if(c.length>=3&&c.charCodeAt(0)===47&&c.charCodeAt(2)===58){const M=c.charCodeAt(1);M>=65&&M<=90&&(c=`/${String.fromCharCode(M+32)}:${c.substr(3)}`)}else if(c.length>=2&&c.charCodeAt(1)===58){const M=c.charCodeAt(0);M>=65&&M<=90&&(c=`${String.fromCharCode(M+32)}:${c.substr(2)}`)}h+=p(c,!0,!1)}return r&&(h+="?",h+=p(r,!1,!1)),P&&(h+="#",h+=u?P:a(P,!1,!1)),h}function n(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+n(t.substr(3)):t}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(t){return t.match(o)?t.replace(o,u=>n(u)):t}}),define(De[172],Ie([1,0,2]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function T(m){const A=m;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.isRemoteConsoleLog=T;function d(m){const A=[];let k;try{const w=JSON.parse(m.arguments),D=w[w.length-1];D&&D.__$stack&&(w.pop(),k=D.__$stack),A.push(...w)}catch{A.push("Unable to log remote console arguments",m.arguments)}return{args:A,stack:k}}e.parse=d;function L(m){if(typeof m!="string")return L(d(m).stack);const A=m;if(A){const k=R(A),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(w&&w.length===4)return{uri:v.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.getFirstFrame=L;function R(m){if(!m)return m;const A=m.indexOf(`
`);return A===-1?m:m.substring(0,A)}function g(m,A){const{args:k,stack:w}=d(m),D=typeof k[0]=="string"&&k.length===1;let I=R(w);I&&(I=`(${I.trim()})`);let E=[];if(typeof k[0]=="string"?I&&D?E=[`%c[${A}] %c${k[0]} %c${I}`,y("blue"),y(""),y("grey")]:E=[`%c[${A}] %c${k[0]}`,y("blue"),y(""),...k.slice(1)]:E=[`%c[${A}]%`,y("blue"),...k],I&&!D&&E.push(I),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,E)}e.log=g;function y(m){return`color: ${m}`}}),define(De[73],Ie([1,0,22,9,2]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(m){return JSON.stringify(m,g)}e.stringify=L;function R(m){let A=JSON.parse(m);return A=y(A),A}e.parse=R;function g(m,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,T.regExpFlags)(A)}:A}function y(m,A=0){if(!m||A>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return d.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof v.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let k=0;k<m.length;++k)m[k]=y(m[k],A+1);else for(const k in m)Object.hasOwnProperty.call(m,k)&&(m[k]=y(m[k],A+1))}return m}e.revive=y}),define(De[16],Ie([1,0,8,10,2]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(A){this._preferredWebSchema=A}setDelegate(A){this._delegate=A}setServerRootPath(A){this._remoteResourcesPath=`${A}/${L.vscodeRemoteResource}`}set(A,k,w){this._hosts[A]=k,this._ports[A]=w}setConnectionToken(A,k){this._connectionTokens[A]=k}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(A){if(this._delegate)try{return this._delegate(A)}catch(i){return v.onUnexpectedError(i),A}const k=A.authority;let w=this._hosts[k];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const D=this._ports[k],I=this._connectionTokens[k];let E=`path=${encodeURIComponent(A.path)}`;return typeof I=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(I)}`),d.URI.from({scheme:T.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${w}:${D}`,path:this._remoteResourcesPath,query:E})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class g{asBrowserUri(A){const k=this.toUri(A,re);return this.uriToBrowserUri(k)}uriToBrowserUri(A){return A.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(A):A.scheme===L.file&&(T.isNative||T.isWebWorker&&T.globals.origin===`${L.vscodeFileResource}://${g.FALLBACK_AUTHORITY}`)?A.with({scheme:L.vscodeFileResource,authority:A.authority||g.FALLBACK_AUTHORITY,query:null,fragment:null}):A}asFileUri(A){const k=this.toUri(A,re);return this.uriToFileUri(k)}uriToFileUri(A){return A.scheme===L.vscodeFileResource?A.with({scheme:L.file,authority:A.authority!==g.FALLBACK_AUTHORITY?A.authority:null,query:null,fragment:null}):A}toUri(A,k){return d.URI.isUri(A)?A:d.URI.parse(k.toUrl(A))}}g.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new g;var y;(function(m){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(A.get("3"));const k="vscode-coi";function w(I){let E;typeof I=="string"?E=new URL(I).searchParams:I instanceof URL?E=I.searchParams:d.URI.isUri(I)&&(E=new URL(I.toString(!0)).searchParams);const i=E?.get(k);if(i)return A.get(i)}m.getHeadersFromQuery=w;function D(I,E,i){if(!globalThis.crossOriginIsolated)return;const l=E&&i?"3":i?"2":"1";I instanceof URLSearchParams?I.set(k,l):I[k]=l}m.addSearchParam=D})(y||(e.COI=y={}))}),define(De[23],Ie([1,0,31,16,11,10,9,2]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(D){return(0,g.uriToFsPath)(D,!0)}e.originalFSPath=y;class m{constructor(I){this._ignorePathCasing=I}compare(I,E,i=!1){return I===E?0:(0,R.compare)(this.getComparisonKey(I,i),this.getComparisonKey(E,i))}isEqual(I,E,i=!1){return I===E?!0:!I||!E?!1:this.getComparisonKey(I,i)===this.getComparisonKey(E,i)}getComparisonKey(I,E=!1){return I.with({path:this._ignorePathCasing(I)?I.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(I){return this._ignorePathCasing(I)}isEqualOrParent(I,E,i=!1){if(I.scheme===E.scheme){if(I.scheme===T.Schemas.file)return v.isEqualOrParent(y(I),y(E),this._ignorePathCasing(I))&&I.query===E.query&&(i||I.fragment===E.fragment);if((0,e.isEqualAuthority)(I.authority,E.authority))return v.isEqualOrParent(I.path,E.path,this._ignorePathCasing(I),"/")&&I.query===E.query&&(i||I.fragment===E.fragment)}return!1}joinPath(I,...E){return g.URI.joinPath(I,...E)}basenameOrAuthority(I){return(0,e.basename)(I)||I.authority}basename(I){return d.posix.basename(I.path)}extname(I){return d.posix.extname(I.path)}dirname(I){if(I.path.length===0)return I;let E;return I.scheme===T.Schemas.file?E=g.URI.file(d.dirname(y(I))).path:(E=d.posix.dirname(I.path),I.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${I.toString})) resulted in a relative path`),E="/")),I.with({path:E})}normalizePath(I){if(!I.path.length)return I;let E;return I.scheme===T.Schemas.file?E=g.URI.file(d.normalize(y(I))).path:E=d.posix.normalize(I.path),I.with({path:E})}relativePath(I,E){if(I.scheme!==E.scheme||!(0,e.isEqualAuthority)(I.authority,E.authority))return;if(I.scheme===T.Schemas.file){const a=d.relative(y(I),y(E));return L.isWindows?v.toSlashes(a):a}let i=I.path||"/";const l=E.path||"/";if(this._ignorePathCasing(I)){let a=0;for(const b=Math.min(i.length,l.length);a<b&&!(i.charCodeAt(a)!==l.charCodeAt(a)&&i.charAt(a).toLowerCase()!==l.charAt(a).toLowerCase());a++);i=l.substr(0,a)+i.substr(a)}return d.posix.relative(i,l)}resolvePath(I,E){if(I.scheme===T.Schemas.file){const i=g.URI.file(d.resolve(y(I),E));return I.with({authority:i.authority,path:i.path})}return E=v.toPosixPath(E),I.with({path:d.posix.resolve(I.path,E)})}isAbsolutePath(I){return!!I.path&&I.path[0]==="/"}isEqualAuthority(I,E){return I===E||I!==void 0&&E!==void 0&&(0,R.equalsIgnoreCase)(I,E)}hasTrailingPathSeparator(I,E=d.sep){if(I.scheme===T.Schemas.file){const i=y(I);return i.length>v.getRoot(i).length&&i[i.length-1]===E}else{const i=I.path;return i.length>1&&i.charCodeAt(i.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(I.fsPath)}}removeTrailingPathSeparator(I,E=d.sep){return(0,e.hasTrailingPathSeparator)(I,E)?I.with({path:I.path.substr(0,I.path.length-1)}):I}addTrailingPathSeparator(I,E=d.sep){let i=!1;if(I.scheme===T.Schemas.file){const l=y(I);i=l!==void 0&&l.length===v.getRoot(l).length&&l[l.length-1]===E}else{E="/";const l=I.path;i=l.length===1&&l.charCodeAt(l.length-1)===47}return!i&&!(0,e.hasTrailingPathSeparator)(I,E)?I.with({path:I.path+"/"}):I}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(D=>D.scheme===T.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new m(D=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(D,I){const E=[];for(let i=0;i<D.length;i++){const l=I(D[i]);D.some((a,b)=>b===i?!1:(0,e.isEqualOrParent)(l,I(a)))||E.push(D[i])}return E}e.distinctParents=A;var k;(function(D){D.META_DATA_LABEL="label",D.META_DATA_DESCRIPTION="description",D.META_DATA_SIZE="size",D.META_DATA_MIME="mime";function I(E){const i=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(b=>{const[f,_]=b.split(":");f&&_&&i.set(f,_)});const a=E.path.substring(0,E.path.indexOf(";"));return a&&i.set(D.META_DATA_MIME,a),i}D.parseMetaData=I})(k||(e.DataUri=k={}));function w(D,I,E){if(I){let i=D.path;return i&&i[0]!==d.posix.sep&&(i=d.posix.sep+i),D.with({scheme:E,authority:I,path:i})}return D.with({scheme:E})}e.toLocalResource=w}),define(De[17],Ie([1,0,21,8,3,4,23,10,153]),function(re,e,v,T,d,L,R,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(ge){return!!ge&&typeof ge.then=="function"}e.isThenable=m;function A(ge){const O=new v.CancellationTokenSource,K=ge(O.token),we=new Promise((Ce,ee)=>{const te=O.token.onCancellationRequested(()=>{te.dispose(),O.dispose(),ee(new T.CancellationError)});Promise.resolve(K).then(ue=>{te.dispose(),O.dispose(),Ce(ue)},ue=>{te.dispose(),O.dispose(),ee(ue)})});return new class{cancel(){O.cancel()}then(Ce,ee){return we.then(Ce,ee)}catch(Ce){return this.then(void 0,Ce)}finally(Ce){return we.finally(Ce)}}}e.createCancelablePromise=A;function k(ge,O,K){return new Promise((we,Ce)=>{const ee=O.onCancellationRequested(()=>{ee.dispose(),we(K)});ge.then(we,Ce).finally(()=>ee.dispose())})}e.raceCancellation=k;function w(ge,O){return new Promise((K,we)=>{const Ce=O.onCancellationRequested(()=>{Ce.dispose(),we(new T.CancellationError)});ge.then(K,we).finally(()=>Ce.dispose())})}e.raceCancellationError=w;async function D(ge){let O=-1;const K=ge.map((we,Ce)=>we.then(ee=>(O=Ce,ee)));try{return await Promise.race(K)}finally{ge.forEach((we,Ce)=>{Ce!==O&&we.cancel()})}}e.raceCancellablePromises=D;function I(ge,O,K){let we;const Ce=setTimeout(()=>{we?.(void 0),K?.()},O);return Promise.race([ge.finally(()=>clearTimeout(Ce)),new Promise(ee=>we=ee)])}e.raceTimeout=I;function E(ge){return new Promise((O,K)=>{const we=ge();m(we)?we.then(O,K):O(we)})}e.asPromise=E;class i{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.isDisposed)throw new Error("Throttler is disposed");if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const K=()=>{if(this.queuedPromise=null,this.isDisposed)return;const we=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,we};this.queuedPromise=new Promise(we=>{this.activePromise.then(K,K).then(we)})}return new Promise((K,we)=>{this.queuedPromise.then(K,we)})}return this.activePromise=O(),new Promise((K,we)=>{this.activePromise.then(Ce=>{this.activePromise=null,K(Ce)},Ce=>{this.activePromise=null,we(Ce)})})}dispose(){this.isDisposed=!0}}e.Throttler=i;class l{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}e.Sequencer=l;class a{constructor(){this.promiseMap=new Map}queue(O,K){const Ce=(this.promiseMap.get(O)??Promise.resolve()).catch(()=>{}).then(K).finally(()=>{this.promiseMap.get(O)===Ce&&this.promiseMap.delete(O)});return this.promiseMap.set(O,Ce),Ce}}e.SequencerByKey=a;const b=(ge,O)=>{let K=!0;const we=setTimeout(()=>{K=!1,O()},ge);return{isTriggered:()=>K,dispose:()=>{clearTimeout(we),K=!1}}},f=ge=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,ge())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};class _{constructor(O){this.defaultDelay=O,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,K=this.defaultDelay){this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Ce,ee)=>{this.doResolve=Ce,this.doReject=ee}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Ce=this.task;return this.task=null,Ce()}}));const we=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=K===y.MicrotaskDelay?f(we):b(K,we),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new T.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=_;class n{constructor(O){this.delayer=new _(O),this.throttler=new i}trigger(O,K){return this.delayer.trigger(()=>this.throttler.queue(O),K)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=n;class o{constructor(){this._isOpen=!1,this._promise=new Promise((O,K)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class s extends o{constructor(O){super(),this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function t(ge,O){return O?new Promise((K,we)=>{const Ce=setTimeout(()=>{ee.dispose(),K()},ge),ee=O.onCancellationRequested(()=>{clearTimeout(Ce),ee.dispose(),we(new T.CancellationError)})}):A(K=>t(ge,K))}e.timeout=t;function u(ge,O=0){const K=setTimeout(ge,O);return(0,L.toDisposable)(()=>clearTimeout(K))}e.disposableTimeout=u;function p(ge){const O=[];let K=0;const we=ge.length;function Ce(){return K<we?ge[K++]():null}function ee(te){te!=null&&O.push(te);const ue=Ce();return ue?ue.then(ee):Promise.resolve(O)}return Promise.resolve(null).then(ee)}e.sequence=p;function h(ge,O=we=>!!we,K=null){let we=0;const Ce=ge.length,ee=()=>{if(we>=Ce)return Promise.resolve(K);const te=ge[we++];return Promise.resolve(te()).then(Q=>O(Q)?Promise.resolve(Q):ee())};return ee()}e.first=h;function C(ge,O=we=>!!we,K=null){if(ge.length===0)return Promise.resolve(K);let we=ge.length;const Ce=()=>{we=-1;for(const ee of ge)ee.cancel?.()};return new Promise((ee,te)=>{for(const ue of ge)ue.then(Q=>{--we>=0&&O(Q)?(Ce(),ee(Q)):we===0&&ee(K)}).catch(Q=>{--we>=0&&(Ce(),te(Q))})})}e.firstParallel=C;class S{constructor(O){this._size=0,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new d.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(O){return this._size++,new Promise((K,we)=>{this.outstandingPromises.push({factory:O,c:K,e:we}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const K=O.factory();K.then(O.c,O.e),K.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=S;class c extends S{constructor(){super(1)}}e.Queue=c;class r{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const O=new ne;return this.drainers.add(O),O.p}isDrained(){for(const[,O]of this.queues)if(O.size>0)return!1;return!0}queueFor(O,K=R.extUri){const we=K.getComparisonKey(O);let Ce=this.queues.get(we);return Ce||(Ce=new c,d.Event.once(Ce.onDrained)(()=>{Ce?.dispose(),this.queues.delete(we),this.onDidQueueDrain()}),this.queues.set(we,Ce)),Ce}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const O of this.drainers)O.complete();this.drainers.clear()}dispose(){for(const[,O]of this.queues)O.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=r;class P{constructor(O,K){this._token=-1,typeof O=="function"&&typeof K=="number"&&this.setIfNotSet(O,K)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,K){this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},K)}setIfNotSet(O,K){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},K))}}e.TimeoutTimer=P;class M{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(O,K){this.cancel(),this._token=setInterval(()=>{O()},K)}}e.IntervalTimer=M;class W{constructor(O,K){this.timeoutToken=-1,this.runner=O,this.timeout=K,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=W;class ${constructor(O,K){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.runner=O,this.timeout=K,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(O=this.timeout){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(O/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=$;class z extends W{constructor(O,K){super(O,K),this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner?.(O)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class N extends L.Disposable{constructor(O,K){super(),this.options=O,this.handler=K,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(O){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+O.length>this.options.maxBufferedWork)return!1}else if(this.pending+O.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const K of O)this.pendingWork.push(K);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new W(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ge=>{(0,g.setTimeout0)(()=>{if(O)return;const K=Date.now()+15;ge(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,K-Date.now())}}))});let O=!1;return{dispose(){O||(O=!0)}}}:e.runWhenIdle=(ge,O)=>{const K=requestIdleCallback(ge,typeof O=="number"?{timeout:O}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(K))}}}}();class q{constructor(O){this._didRun=!1,this._executor=()=>{try{this._value=O()}catch(K){this._error=K}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function x(ge,O,K){let we;for(let Ce=0;Ce<K;Ce++)try{return await ge()}catch(ee){we=ee,await t(O)}throw we}e.retry=x;class U{hasPending(O){return this._pending?typeof O=="number"?this._pending.taskId===O:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(O,K,we){return this._pending={taskId:O,cancel:()=>we?.(),promise:K},K.then(()=>this.donePending(O),()=>this.donePending(O)),K}donePending(O){this._pending&&O===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const O=this._next;this._next=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this._next)this._next.run=O;else{let K,we;const Ce=new Promise((ee,te)=>{K=ee,we=te});this._next={run:O,promise:Ce,promiseResolve:K,promiseReject:we}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=U;class de{constructor(O,K=()=>Date.now()){this.interval=O,this.nowFn=K,this.lastIncrementTime=0,this.value=0}increment(){const O=this.nowFn();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}e.IntervalCounter=de;var ie;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(ie||(ie={}));class ne{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((O,K)=>{this.completeCallback=O,this.errorCallback=K})}complete(O){return new Promise(K=>{this.completeCallback(O),this.outcome={outcome:0,value:O},K()})}error(O){return new Promise(K=>{this.errorCallback(O),this.outcome={outcome:1,value:O},K()})}cancel(){return this.error(new T.CancellationError)}}e.DeferredPromise=ne;var H;(function(ge){async function O(we){let Ce;const ee=await Promise.all(we.map(te=>te.then(ue=>ue,ue=>{Ce||(Ce=ue)})));if(typeof Ce<"u")throw Ce;return ee}ge.settled=O;function K(we){return new Promise(async(Ce,ee)=>{try{await we(Ce,ee)}catch(te){ee(te)}})}ge.withAsyncBody=K})(H||(e.Promises=H={}));var V;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(V||(V={}));class ce{static fromArray(O){return new ce(K=>{K.emitMany(O)})}static fromPromise(O){return new ce(async K=>{K.emitMany(await O)})}static fromPromises(O){return new ce(async K=>{await Promise.all(O.map(async we=>K.emitOne(await we)))})}static merge(O){return new ce(async K=>{await Promise.all(O.map(async we=>{for await(const Ce of we)K.emitOne(Ce)}))})}constructor(O){this._state=0,this._results=[],this._error=null,this._onStateChanged=new d.Emitter,queueMicrotask(async()=>{const K={emitOne:we=>this.emitOne(we),emitMany:we=>this.emitMany(we),reject:we=>this.reject(we)};try{await Promise.resolve(O(K)),this.resolve()}catch(we){this.reject(we)}finally{K.emitOne=void 0,K.emitMany=void 0,K.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(O<this._results.length)return{done:!1,value:this._results[O++]};if(this._state===1)return{done:!0,value:void 0};await d.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(O,K){return new ce(async we=>{for await(const Ce of O)we.emitOne(K(Ce))})}map(O){return ce.map(this,O)}static filter(O,K){return new ce(async we=>{for await(const Ce of O)K(Ce)&&we.emitOne(Ce)})}filter(O){return ce.filter(this,O)}static coalesce(O){return ce.filter(O,K=>!!K)}coalesce(){return ce.coalesce(this)}static async toPromise(O){const K=[];for await(const we of O)K.push(we);return K}toPromise(){return ce.toPromise(this)}emitOne(O){this._state===0&&(this._results.push(O),this._onStateChanged.fire())}emitMany(O){this._state===0&&(this._results=this._results.concat(O),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(O){this._state===0&&(this._state=2,this._error=O,this._onStateChanged.fire())}}e.AsyncIterableObject=ce,ce.EMPTY=ce.fromArray([]);class be extends ce{constructor(O,K){super(K),this._source=O}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=be;function Se(ge){const O=new v.CancellationTokenSource,K=ge(O.token);return new be(O,async we=>{const Ce=O.token.onCancellationRequested(()=>{Ce.dispose(),O.dispose(),we.reject(new T.CancellationError)});try{for await(const ee of K){if(O.token.isCancellationRequested)return;we.emitOne(ee)}Ce.dispose(),O.dispose()}catch(ee){Ce.dispose(),O.dispose(),we.reject(ee)}})}e.createCancelableAsyncIterable=Se}),define(De[33],Ie([1,0,19,17,31,28,11,10,9]),function(re,e,v,T,d,L,R,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const A="[/\\\\]",k="[^/\\\\]",w=/\//g;function D(de,ie){switch(de){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}${ie?`|${A}${k}+`:""})*?`}}function I(de,ie){if(!de)return[];const ne=[];let H=!1,V=!1,ce="";for(const be of de){switch(be){case ie:if(!H&&!V){ne.push(ce),ce="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":V=!0;break;case"]":V=!1;break}ce+=be}return ce&&ne.push(ce),ne}e.splitGlobAware=I;function E(de){if(!de)return"";let ie="";const ne=I(de,e.GLOB_SPLIT);if(ne.every(H=>H===e.GLOBSTAR))ie=".*";else{let H=!1;ne.forEach((V,ce)=>{if(V===e.GLOBSTAR){if(H)return;ie+=D(2,ce===ne.length-1)}else{let be=!1,Se="",ge=!1,O="";for(const K of V){if(K!=="}"&&be){Se+=K;continue}if(ge&&(K!=="]"||!O)){let we;K==="-"?we=K:(K==="^"||K==="!")&&!O?we="^":K===e.GLOB_SPLIT?we="":we=(0,y.escapeRegExpCharacters)(K),O+=we;continue}switch(K){case"{":be=!0;continue;case"[":ge=!0;continue;case"}":{const Ce=`(?:${I(Se,",").map(ee=>E(ee)).join("|")})`;ie+=Ce,be=!1,Se="";break}case"]":{ie+="["+O+"]",ge=!1,O="";break}case"?":ie+=k;continue;case"*":ie+=D(1);continue;default:ie+=(0,y.escapeRegExpCharacters)(K)}}ce<ne.length-1&&(ne[ce+1]!==e.GLOBSTAR||ce+2<ne.length)&&(ie+=A)}H=V===e.GLOBSTAR})}return ie}const i=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,_=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.LRUCache(1e4),o=function(){return!1},s=function(){return null};function t(de,ie){if(!de)return s;let ne;typeof de!="string"?ne=de.pattern:ne=de,ne=ne.trim();const H=`${ne}_${!!ie.trimForExclusions}`;let V=n.get(H);if(V)return u(V,de);let ce;return i.test(ne)?V=h(ne.substr(4),ne):(ce=l.exec(p(ne,ie)))?V=C(ce[1],ne):(ie.trimForExclusions?b:a).test(ne)?V=S(ne,ie):(ce=f.exec(p(ne,ie)))?V=c(ce[1].substr(1),ne,!0):(ce=_.exec(p(ne,ie)))?V=c(ce[1],ne,!1):V=r(ne),n.set(H,V),u(V,de)}function u(de,ie){if(typeof ie=="string")return de;const ne=function(H,V){return(0,d.isEqualOrParent)(H,ie.base,!g.isLinux)?de((0,y.ltrim)(H.substr(ie.base.length),R.sep),V):null};return ne.allBasenames=de.allBasenames,ne.allPaths=de.allPaths,ne.basenames=de.basenames,ne.patterns=de.patterns,ne}function p(de,ie){return ie.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function h(de,ie){return function(ne,H){return typeof ne=="string"&&ne.endsWith(de)?ie:null}}function C(de,ie){const ne=`/${de}`,H=`\\${de}`,V=function(be,Se){return typeof be!="string"?null:Se?Se===de?ie:null:be===de||be.endsWith(ne)||be.endsWith(H)?ie:null},ce=[de];return V.basenames=ce,V.patterns=[ie],V.allBasenames=ce,V}function S(de,ie){const ne=x(de.slice(1,-1).split(",").map(Se=>t(Se,ie)).filter(Se=>Se!==s),de),H=ne.length;if(!H)return s;if(H===1)return ne[0];const V=function(Se,ge){for(let O=0,K=ne.length;O<K;O++)if(ne[O](Se,ge))return de;return null},ce=ne.find(Se=>!!Se.allBasenames);ce&&(V.allBasenames=ce.allBasenames);const be=ne.reduce((Se,ge)=>ge.allPaths?Se.concat(ge.allPaths):Se,[]);return be.length&&(V.allPaths=be),V}function c(de,ie,ne){const H=R.sep===R.posix.sep,V=H?de:de.replace(w,R.sep),ce=R.sep+V,be=R.posix.sep+de;let Se;return ne?Se=function(ge,O){return typeof ge=="string"&&(ge===V||ge.endsWith(ce)||!H&&(ge===de||ge.endsWith(be)))?ie:null}:Se=function(ge,O){return typeof ge=="string"&&(ge===V||!H&&ge===de)?ie:null},Se.allPaths=[(ne?"*/":"./")+de],Se}function r(de){try{const ie=new RegExp(`^${E(de)}$`);return function(ne){return ie.lastIndex=0,typeof ne=="string"&&ie.test(ne)?de:null}}catch{return s}}function P(de,ie,ne){return!de||typeof ie!="string"?!1:M(de)(ie,void 0,ne)}e.match=P;function M(de,ie={}){if(!de)return o;if(typeof de=="string"||W(de)){const ne=t(de,ie);if(ne===s)return o;const H=function(V,ce){return!!ne(V,ce)};return ne.allBasenames&&(H.allBasenames=ne.allBasenames),ne.allPaths&&(H.allPaths=ne.allPaths),H}return N(de,ie)}e.parse=M;function W(de){const ie=de;return ie?typeof ie.base=="string"&&typeof ie.pattern=="string":!1}e.isRelativePattern=W;function $(de){return de.allBasenames||[]}e.getBasenameTerms=$;function z(de){return de.allPaths||[]}e.getPathTerms=z;function N(de,ie){const ne=x(Object.getOwnPropertyNames(de).map(Se=>q(Se,de[Se],ie)).filter(Se=>Se!==s)),H=ne.length;if(!H)return s;if(!ne.some(Se=>!!Se.requiresSiblings)){if(H===1)return ne[0];const Se=function(K,we){let Ce;for(let ee=0,te=ne.length;ee<te;ee++){const ue=ne[ee](K,we);if(typeof ue=="string")return ue;(0,T.isThenable)(ue)&&(Ce||(Ce=[]),Ce.push(ue))}return Ce?(async()=>{for(const ee of Ce){const te=await ee;if(typeof te=="string")return te}return null})():null},ge=ne.find(K=>!!K.allBasenames);ge&&(Se.allBasenames=ge.allBasenames);const O=ne.reduce((K,we)=>we.allPaths?K.concat(we.allPaths):K,[]);return O.length&&(Se.allPaths=O),Se}const V=function(Se,ge,O){let K,we;for(let Ce=0,ee=ne.length;Ce<ee;Ce++){const te=ne[Ce];te.requiresSiblings&&O&&(ge||(ge=(0,R.basename)(Se)),K||(K=ge.substr(0,ge.length-(0,R.extname)(Se).length)));const ue=te(Se,ge,K,O);if(typeof ue=="string")return ue;(0,T.isThenable)(ue)&&(we||(we=[]),we.push(ue))}return we?(async()=>{for(const Ce of we){const ee=await Ce;if(typeof ee=="string")return ee}return null})():null},ce=ne.find(Se=>!!Se.allBasenames);ce&&(V.allBasenames=ce.allBasenames);const be=ne.reduce((Se,ge)=>ge.allPaths?Se.concat(ge.allPaths):Se,[]);return be.length&&(V.allPaths=be),V}function q(de,ie,ne){if(ie===!1)return s;const H=t(de,ne);if(H===s)return s;if(typeof ie=="boolean")return H;if(ie){const V=ie.when;if(typeof V=="string"){const ce=(be,Se,ge,O)=>{if(!O||!H(be,Se))return null;const K=V.replace("$(basename)",()=>ge),we=O(K);return(0,T.isThenable)(we)?we.then(Ce=>Ce?de:null):we?de:null};return ce.requiresSiblings=!0,ce}}return H}function x(de,ie){const ne=de.filter(Se=>!!Se.basenames);if(ne.length<2)return de;const H=ne.reduce((Se,ge)=>{const O=ge.basenames;return O?Se.concat(O):Se},[]);let V;if(ie){V=[];for(let Se=0,ge=H.length;Se<ge;Se++)V.push(ie)}else V=ne.reduce((Se,ge)=>{const O=ge.patterns;return O?Se.concat(O):Se},[]);const ce=function(Se,ge){if(typeof Se!="string")return null;if(!ge){let K;for(K=Se.length;K>0;K--){const we=Se.charCodeAt(K-1);if(we===47||we===92)break}ge=Se.substr(K)}const O=H.indexOf(ge);return O!==-1?V[O]:null};ce.basenames=H,ce.patterns=V,ce.allBasenames=H;const be=de.filter(Se=>!Se.basenames);return be.push(ce),be}function U(de,ie){return(0,v.equals)(de,ie,(ne,H)=>typeof ne=="string"&&typeof H=="string"?ne===H:typeof ne!="string"&&typeof H!="string"?ne.base===H.base&&ne.pattern===H.pattern:!1)}e.patternsEquals=U}),define(De[94],Ie([1,0,8,154,23,9,2]),function(re,e,v,T,d,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var g;(function(i){i[i.Paragraph=0]="Paragraph",i[i.Break=1]="Break"})(g||(e.MarkdownStringTextNewlineStyle=g={}));class y{constructor(l="",a=!1){if(this.value=l,typeof this.value!="string")throw(0,v.illegalArgument)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(l,a=0){return this.value+=w(this.supportThemeIcons?(0,T.escapeIcons)(l):l).replace(/([ \t]+)/g,(b,f)=>"&nbsp;".repeat(f.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,a){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}appendLink(l,a,b){return this.value+="[",this.value+=this._escape(a,"]"),this.value+="](",this.value+=this._escape(String(l),")"),b&&(this.value+=` "${this._escape(this._escape(b,'"'),")")}"`),this.value+=")",this}_escape(l,a){const b=new RegExp((0,L.escapeRegExpCharacters)(a),"g");return l.replace(b,(f,_)=>l.charAt(_-1)!=="\\"?`\\${f}`:f)}}e.MarkdownString=y;function m(i){return A(i)?!i.value:Array.isArray(i)?i.every(m):!0}e.isEmptyMarkdownString=m;function A(i){return i instanceof y?!0:i&&typeof i=="object"?typeof i.value=="string"&&(typeof i.isTrusted=="boolean"||typeof i.isTrusted=="object"||i.isTrusted===void 0)&&(typeof i.supportThemeIcons=="boolean"||i.supportThemeIcons===void 0):!1}e.isMarkdownString=A;function k(i,l){return i===l?!0:!i||!l?!1:i.value===l.value&&i.isTrusted===l.isTrusted&&i.supportThemeIcons===l.supportThemeIcons&&i.supportHtml===l.supportHtml&&(i.baseUri===l.baseUri||!!i.baseUri&&!!l.baseUri&&(0,d.isEqual)(R.URI.from(i.baseUri),R.URI.from(l.baseUri)))}e.markdownStringEqual=k;function w(i){return i.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=w;function D(i){return i.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=D;function I(i){return i&&i.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=I;function E(i){const l=[],a=i.split("|").map(f=>f.trim());i=a[0];const b=a[1];if(b){const f=/height=(\d+)/.exec(b),_=/width=(\d+)/.exec(b),n=f?f[1]:"",o=_?_[1]:"",s=isFinite(parseInt(o)),t=isFinite(parseInt(n));s&&l.push(`width="${o}"`),t&&l.push(`height="${n}"`)}return{href:i,dimensions:l}}e.parseHrefAndDimensions=E}),define(De[120],Ie([1,0,19,31,11,10,23,9]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(t,u){const{os:p,tildify:h,relative:C}=u;if(C){const r=m(t,C,p);if(typeof r=="string")return r}let S=t.fsPath;if(p===1&&!L.isWindows?S=S.replace(/\//g,"\\"):p!==1&&L.isWindows&&(S=S.replace(/\\/g,"/")),p!==1&&h?.userHome){const r=h.userHome.fsPath;let P;t.scheme!==h.userHome.scheme&&t.path.startsWith(d.posix.sep)?P=h.userHome.with({path:t.path}).fsPath:P=t.fsPath,S=w(P,r,p)}return(p===1?d.win32:d.posix).normalize(A(S,p===1))}e.getPathLabel=y;function m(t,u,p){const h=p===1?d.win32:d.posix,C=p===3?R.extUri:R.extUriIgnorePathCase,S=u.getWorkspace(),c=(0,v.firstOrDefault)(S.folders);if(!c)return;t.scheme!==c.uri.scheme&&t.path.startsWith(d.posix.sep)&&(t=c.uri.with({path:t.path}));const r=u.getWorkspaceFolder(t);if(!r)return;let P;if(C.isEqual(r.uri,t)?P="":P=C.relativePath(r.uri,t)??"",P&&(P=h.normalize(P)),S.folders.length>1&&!u.noPrefix){const M=r.name?r.name:C.basenameOrAuthority(r.uri);P=P?`${M} \u2022 ${P}`:M}return P}function A(t,u=L.isWindows){return(0,T.hasDriveLetter)(t,u)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=A;let k=Object.create(null);function w(t,u,p=L.OS){if(p===1||!t||!u)return t;let h=k.original===u?k.normalized:void 0;h||(h=u,L.isWindows&&(h=(0,T.toSlashes)(h)),h=`${(0,g.rtrim)(h,d.posix.sep)}${d.posix.sep}`,k={original:u,normalized:h});let C=t;return L.isWindows&&(C=(0,T.toSlashes)(C)),(p===3?C.startsWith(h):(0,g.startsWithIgnoreCase)(C,h))?`~/${C.substr(h.length)}`:t}e.tildify=w;function D(t,u){return t.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=D;const I="\u2026",E="\\\\",i="~";function l(t,u=d.sep){const p=new Array(t.length);let h=!1;for(let C=0;C<t.length;C++){const S=t[C];if(S===""){p[C]=`.${u}`;continue}if(!S){p[C]=S;continue}h=!0;let c="",r=S;r.indexOf(E)===0?(c=r.substr(0,r.indexOf(E)+E.length),r=r.substr(r.indexOf(E)+E.length)):r.indexOf(u)===0?(c=r.substr(0,r.indexOf(u)+u.length),r=r.substr(r.indexOf(u)+u.length)):r.indexOf(i)===0&&(c=r.substr(0,r.indexOf(i)+i.length),r=r.substr(r.indexOf(i)+i.length));const P=r.split(u);for(let M=1;h&&M<=P.length;M++)for(let W=P.length-M;h&&W>=0;W--){h=!1;let $=P.slice(W,W+M).join(u);for(let z=0;!h&&z<t.length;z++)if(z!==C&&t[z]&&t[z].indexOf($)>-1){const N=W+M===P.length,q=W>0&&t[z].indexOf(u)>-1?u+$:$,x=t[z].endsWith(q);h=!N||x}if(!h){let z="";(P[0].endsWith(":")||c!=="")&&(W===1&&(W=0,M++,$=P[0]+u+$),W>0&&(z=P[0]+u),z=c+z),W>0&&(z=z+I+u),z=z+$,W+M<P.length&&(z=z+u+I),p[C]=z}}h&&(p[C]=S)}return p}e.shorten=l;var a;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function b(t,u=Object.create(null)){const p=[];let h=!1,C="";for(const S of t)if(S==="$"||h&&S==="{")C&&p.push({value:C,type:a.TEXT}),C="",h=!0;else if(S==="}"&&h){const c=u[C];if(typeof c=="string")c.length&&p.push({value:c,type:a.VARIABLE});else if(c){const r=p[p.length-1];(!r||r.type!==a.SEPARATOR)&&p.push({value:c.label,type:a.SEPARATOR})}C="",h=!1}else C+=S;return C&&!h&&p.push({value:C,type:a.TEXT}),p.filter((S,c)=>{if(S.type===a.SEPARATOR){const r=p[c-1],P=p[c+1];return[r,P].every(M=>M&&(M.type===a.VARIABLE||M.type===a.TEXT)&&M.value.length>0)}return!0}).map(S=>S.value).join("")}e.template=b;function f(t,u){return L.isMacintosh||u?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):t.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function _(t,u){return L.isMacintosh||u?t.replace(/\(&&\w\)|&&/g,""):L.isWindows?t.replace(/&&|&/g,p=>p==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=_;function n(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=n;function o(t){if(t.endsWith("]")){const u=t.lastIndexOf(" [",t.length-2);if(u!==-1){const p=s(t.substring(0,u));return{name:p.name,parentPath:p.parentPath+t.substring(u)}}}return s(t)}e.splitRecentLabel=o;function s(t){const u=t.indexOf("/")!==-1?d.posix:d.win32,p=u.basename(t),h=u.dirname(t);return p.length?{name:p,parentPath:h}:{name:h,parentPath:""}}}),define(De[121],Ie([1,0,22,2]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function d(k){return k.toJSON()}class L{constructor(w){this._uriTransformer=w}transformIncoming(w){const D=this._uriTransformer.transformIncoming(w);return D===w?w:d(T.URI.from(D))}transformOutgoing(w){const D=this._uriTransformer.transformOutgoing(w);return D===w?w:d(T.URI.from(D))}transformOutgoingURI(w){const D=this._uriTransformer.transformOutgoing(w);return D===w?w:T.URI.from(D)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function R(k,w,D){if(!k||D>200)return null;if(typeof k=="object"){if(k instanceof T.URI)return w.transformOutgoing(k);for(const I in k)if(Object.hasOwnProperty.call(k,I)){const E=R(k[I],w,D+1);E!==null&&(k[I]=E)}}return null}function g(k,w){const D=R(k,w,0);return D===null?k:D}e.transformOutgoingURIs=g;function y(k,w,D,I){if(!k||I>200)return null;if(typeof k=="object"){if(k.$mid===1)return D?T.URI.revive(w.transformIncoming(k)):w.transformIncoming(k);if(k instanceof v.VSBuffer)return null;for(const E in k)if(Object.hasOwnProperty.call(k,E)){const i=y(k[E],w,D,I+1);i!==null&&(k[E]=i)}}return null}function m(k,w){const D=y(k,w,!1,0);return D===null?k:D}e.transformIncomingURIs=m;function A(k,w){const D=y(k,w,!0,0);return D===null?k:D}e.transformAndReviveIncomingURIs=A}),define(De[29],Ie([1,0,49,74,345,17,31,69,11,10,23,2]),function(re,e,v,T,d,L,R,g,y,m,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function D(N,q=w.UNLINK,x){if((0,R.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return q===w.UNLINK?E(N):I(N,x)}async function I(N,q=(0,R.randomPath)((0,T.tmpdir)())){try{try{await v.promises.rename(N,q)}catch(x){return x.code==="ENOENT"?void 0:E(N)}E(q).catch(x=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function E(N){return(0,d.promisify)(v.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function i(N){if((0,R.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");v.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=i;async function l(N,q){return f(await(q?a(N):(0,d.promisify)(v.readdir)(N)))}async function a(N){try{return await(0,d.promisify)(v.readdir)(N,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const q=[],x=await l(N);for(const U of x){let de=!1,ie=!1,ne=!1;try{const H=await e.Promises.lstat((0,y.join)(N,U));de=H.isFile(),ie=H.isDirectory(),ne=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}q.push({name:U,isFile:()=>de,isDirectory:()=>ie,isSymbolicLink:()=>ne})}return q}function b(N){return f(v.readdirSync(N))}e.readdirSync=b;function f(N){return N.map(q=>typeof q=="string"?m.isMacintosh?(0,g.normalizeNFC)(q):q:(q.name=m.isMacintosh?(0,g.normalizeNFC)(q.name):q.name,q))}async function _(N){const q=await l(N),x=[];for(const U of q)await o.existsDirectory((0,y.join)(N,U))&&x.push(U);return x}function n(N,q=1e3){return new Promise(x=>{let U=!1;const de=setInterval(()=>{U||(U=!0,v.access(N,ie=>{U=!1,ie&&(clearInterval(de),x(void 0))}))},q)})}e.whenDeleted=n;var o;(function(N){async function q(de){let ie;try{if(ie=await e.Promises.lstat(de),!ie.isSymbolicLink())return{stat:ie}}catch{}try{return{stat:await e.Promises.stat(de),symbolicLink:ie?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ne){if(ne.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};if(m.isWindows&&ne.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(de)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};throw H}throw ne}}N.stat=q;async function x(de){try{const{stat:ie,symbolicLink:ne}=await N.stat(de);return ie.isFile()&&ne?.dangling!==!0}catch{}return!1}N.existsFile=x;async function U(de){try{const{stat:ie,symbolicLink:ne}=await N.stat(de);return ie.isDirectory()&&ne?.dangling!==!0}catch{}return!1}N.existsDirectory=U})(o||(e.SymlinkSupport=o={}));const s=new L.ResourceQueue;function t(N,q,x){return s.queueFor(k.URI.file(N),A.extUriBiasedIgnorePathCase).queue(()=>{const U=S(x);return new Promise((de,ie)=>h(N,q,U,ne=>ne?ie(ne):de()))})}let u=!0;function p(N){u=N}e.configureFlushOnWrite=p;function h(N,q,x,U){if(!u)return v.writeFile(N,q,{mode:x.mode,flag:x.flag},U);v.open(N,x.flag,x.mode,(de,ie)=>{if(de)return U(de);v.writeFile(ie,q,ne=>{if(ne)return v.close(ie,()=>U(ne));v.fdatasync(ie,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),p(!1)),v.close(ie,V=>U(V))))})})}function C(N,q,x){const U=S(x);if(!u)return v.writeFileSync(N,q,{mode:U.mode,flag:U.flag});const de=v.openSync(N,U.flag,U.mode);try{v.writeFileSync(de,q);try{v.fdatasyncSync(de)}catch(ie){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",ie),p(!1)}}finally{v.closeSync(de)}}e.writeFileSync=C;function S(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function c(N,q){if(N!==q)try{await e.Promises.rename(N,q)}catch(x){if(N.toLowerCase()!==q.toLowerCase()&&x.code==="EXDEV"||N.endsWith("."))await r(N,q,{preserveSymlinks:!1}),await D(N,w.MOVE);else throw x}}async function r(N,q,x){return M(N,q,{root:{source:N,target:q},options:x,handledSourcePaths:new Set})}const P=511;async function M(N,q,x){if(x.handledSourcePaths.has(N))return;x.handledSourcePaths.add(N);const{stat:U,symbolicLink:de}=await o.stat(N);if(de){if(x.options.preserveSymlinks)try{return await z(N,q,x)}catch(ie){console.warn("[node.js fs] copy of symlink failed: ",ie)}if(de.dangling)return}return U.isDirectory()?W(N,q,U.mode&P,x):$(N,q,U.mode&P)}async function W(N,q,x,U){await e.Promises.mkdir(q,{recursive:!0,mode:x});const de=await l(N);for(const ie of de)await M((0,y.join)(N,ie),(0,y.join)(q,ie),U)}async function $(N,q,x){await e.Promises.copyFile(N,q),await e.Promises.chmod(q,x)}async function z(N,q,x){let U=await e.Promises.readlink(N);(0,R.isEqualOrParent)(U,x.root.source,!m.isLinux)&&(U=(0,y.join)(x.root.target,U.substr(x.root.source.length+1))),await e.Promises.symlink(U,q)}e.Promises=new class{get access(){return(0,d.promisify)(v.access)}get stat(){return(0,d.promisify)(v.stat)}get lstat(){return(0,d.promisify)(v.lstat)}get utimes(){return(0,d.promisify)(v.utimes)}get read(){return(N,q,x,U,de)=>new Promise((ie,ne)=>{v.read(N,q,x,U,de,(H,V,ce)=>H?ne(H):ie({bytesRead:V,buffer:ce}))})}get readFile(){return(0,d.promisify)(v.readFile)}get write(){return(N,q,x,U,de)=>new Promise((ie,ne)=>{v.write(N,q,x,U,de,(H,V,ce)=>H?ne(H):ie({bytesWritten:V,buffer:ce}))})}get appendFile(){return(0,d.promisify)(v.appendFile)}get fdatasync(){return(0,d.promisify)(v.fdatasync)}get truncate(){return(0,d.promisify)(v.truncate)}get rename(){return(0,d.promisify)(v.rename)}get copyFile(){return(0,d.promisify)(v.copyFile)}get open(){return(0,d.promisify)(v.open)}get close(){return(0,d.promisify)(v.close)}get symlink(){return(0,d.promisify)(v.symlink)}get readlink(){return(0,d.promisify)(v.readlink)}get chmod(){return(0,d.promisify)(v.chmod)}get mkdir(){return(0,d.promisify)(v.mkdir)}get unlink(){return(0,d.promisify)(v.unlink)}get rmdir(){return(0,d.promisify)(v.rmdir)}get realpath(){return(0,d.promisify)(v.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return _}get writeFile(){return t}get rm(){return D}get move(){return c}get copy(){return r}}}),define(De[95],Ie([1,0,49,11,10,9,29]),function(re,e,v,T,d,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function g(w){if(d.isLinux)return w;const D=(0,T.dirname)(w);if(w===D)return w;const I=((0,T.basename)(w)||w).toLowerCase();try{const i=(0,R.readdirSync)(D).filter(l=>l.toLowerCase()===I);if(i.length===1){const l=g(D);if(l)return(0,T.join)(l,i[0])}else if(i.length>1){const l=i.indexOf(I);if(l>=0){const a=g(D);if(a)return(0,T.join)(a,i[l])}}}catch{}return null}e.realcaseSync=g;async function y(w){if(d.isLinux)return w;const D=(0,T.dirname)(w);if(w===D)return w;const I=((0,T.basename)(w)||w).toLowerCase();try{const i=(await R.Promises.readdir(D)).filter(l=>l.toLowerCase()===I);if(i.length===1){const l=await y(D);if(l)return(0,T.join)(l,i[0])}else if(i.length>1){const l=i.indexOf(I);if(l>=0){const a=await y(D);if(a)return(0,T.join)(a,i[l])}}}catch{}return null}e.realcase=y;async function m(w){try{return await R.Promises.realpath(w)}catch{const I=k(w);return await R.Promises.access(I,v.constants.R_OK),I}}e.realpath=m;function A(w){try{return v.realpathSync(w)}catch{const I=k(w);return v.accessSync(I,v.constants.R_OK),I}}e.realpathSync=A;function k(w){return(0,L.rtrim)((0,T.normalize)(w),T.sep)}}),define(De[96],Ie([1,0,11,10,41,93,12,29]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function y(k=d.env){return k.comspec||"cmd.exe"}e.getWindowsShell=y;function m(k){let w=[],D=!1;const I=function(E){if(D){w.push(E);return}(!k.send(E,l=>{if(l&&console.error(l),D=!1,w.length>0){const a=w.slice(0);w=[],a.forEach(b=>I(b))}})||T.isWindows)&&(D=!0)};return{send:I}}e.createQueuedSender=m;var A;(function(k){async function w(D,I,E){if(v.isAbsolute(D))return D;if(I===void 0&&(I=d.cwd()),v.dirname(D)!=="."||(E===void 0&&R.isString(d.env.PATH)&&(E=d.env.PATH.split(v.delimiter)),E===void 0||E.length===0))return v.join(I,D);async function l(a){if(await g.Promises.exists(a)){let b;try{b=await g.Promises.stat(a)}catch(f){f.message.startsWith("EACCES")&&(b=await g.Promises.lstat(a))}return b?!b.isDirectory():!1}return!1}for(const a of E){let b;if(v.isAbsolute(a)?b=v.join(a,D):b=v.join(I,a,D),await l(b))return b;let f=b+".com";if(await l(f)||(f=b+".exe",await l(f)))return f}return v.join(I,D)}k.findExecutable=w})(A||(e.win32=A={}))});var Ve=this&&this.__decorate||function(re,e,v,T){var d=arguments.length,L=d<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,v):T,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(re,e,v,T);else for(var g=re.length-1;g>=0;g--)(R=re[g])&&(L=(d<3?R(L):d>3?R(e,v,L):R(e,v))||L);return d>3&&L&&Object.defineProperty(e,v,L),L};define(De[75],Ie([1,0,19,17,22,21,66,8,3,4,73,9,12]),function(re,e,v,T,d,L,R,g,y,m,A,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var D;(function(ie){ie[ie.Promise=100]="Promise",ie[ie.PromiseCancel=101]="PromiseCancel",ie[ie.EventListen=102]="EventListen",ie[ie.EventDispose=103]="EventDispose"})(D||(D={}));function I(ie){switch(ie){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(ie){ie[ie.Initialize=200]="Initialize",ie[ie.PromiseSuccess=201]="PromiseSuccess",ie[ie.PromiseError=202]="PromiseError",ie[ie.PromiseErrorObj=203]="PromiseErrorObj",ie[ie.EventFire=204]="EventFire"})(E||(E={}));function i(ie){switch(ie){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(ie){ie[ie.Uninitialized=0]="Uninitialized",ie[ie.Idle=1]="Idle"})(l||(l={}));function a(ie){let ne=0;for(let H=0;;H+=7){const V=ie.read(1);if(ne|=(V.buffer[0]&127)<<H,!(V.buffer[0]&128))return ne}}const b=s(0);function f(ie,ne){if(ne===0){ie.write(b);return}let H=0;for(let ce=ne;ce!==0;ce=ce>>>7)H++;const V=d.VSBuffer.alloc(H);for(let ce=0;ne!==0;ce++)V.buffer[ce]=ne&127,ne=ne>>>7,ne>0&&(V.buffer[ce]|=128);ie.write(V)}class _{constructor(ne){this.buffer=ne,this.pos=0}read(ne){const H=this.buffer.slice(this.pos,this.pos+ne);return this.pos+=H.byteLength,H}}e.BufferReader=_;class n{constructor(){this.buffers=[]}get buffer(){return d.VSBuffer.concat(this.buffers)}write(ne){this.buffers.push(ne)}}e.BufferWriter=n;var o;(function(ie){ie[ie.Undefined=0]="Undefined",ie[ie.String=1]="String",ie[ie.Buffer=2]="Buffer",ie[ie.VSBuffer=3]="VSBuffer",ie[ie.Array=4]="Array",ie[ie.Object=5]="Object",ie[ie.Int=6]="Int"})(o||(o={}));function s(ie){const ne=d.VSBuffer.alloc(1);return ne.writeUInt8(ie,0),ne}const t={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},u=typeof Buffer<"u";function p(ie,ne){if(typeof ne>"u")ie.write(t.Undefined);else if(typeof ne=="string"){const H=d.VSBuffer.fromString(ne);ie.write(t.String),f(ie,H.byteLength),ie.write(H)}else if(u&&Buffer.isBuffer(ne)){const H=d.VSBuffer.wrap(ne);ie.write(t.Buffer),f(ie,H.byteLength),ie.write(H)}else if(ne instanceof d.VSBuffer)ie.write(t.VSBuffer),f(ie,ne.byteLength),ie.write(ne);else if(Array.isArray(ne)){ie.write(t.Array),f(ie,ne.length);for(const H of ne)p(ie,H)}else if(typeof ne=="number"&&(ne|0)===ne)ie.write(t.Uint),f(ie,ne);else{const H=d.VSBuffer.fromString(JSON.stringify(ne));ie.write(t.Object),f(ie,H.byteLength),ie.write(H)}}e.serialize=p;function h(ie){switch(ie.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return ie.read(a(ie)).toString();case o.Buffer:return ie.read(a(ie)).buffer;case o.VSBuffer:return ie.read(a(ie));case o.Array:{const H=a(ie),V=[];for(let ce=0;ce<H;ce++)V.push(h(ie));return V}case o.Object:return JSON.parse(ie.read(a(ie)).toString());case o.Int:return a(ie)}}e.deserialize=h;class C{constructor(ne,H,V=null,ce=1e3){this.protocol=ne,this.ctx=H,this.logger=V,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(be=>this.onRawMessage(be)),this.sendResponse({type:200})}registerChannel(ne,H){this.channels.set(ne,H),setTimeout(()=>this.flushPendingRequests(ne),0)}sendResponse(ne){switch(ne.type){case 200:{const H=this.send([ne.type]);this.logger?.logOutgoing(H,0,1,i(ne.type));return}case 201:case 202:case 204:case 203:{const H=this.send([ne.type,ne.id],ne.data);this.logger?.logOutgoing(H,ne.id,1,i(ne.type),ne.data);return}}}send(ne,H=void 0){const V=new n;return p(V,ne),p(V,H),this.sendBuffer(V.buffer)}sendBuffer(ne){try{return this.protocol.send(ne),ne.byteLength}catch{return 0}}onRawMessage(ne){const H=new _(ne),V=h(H),ce=h(H),be=V[0];switch(be){case 100:return this.logger?.logIncoming(ne.byteLength,V[1],1,`${I(be)}: ${V[2]}.${V[3]}`,ce),this.onPromise({type:be,id:V[1],channelName:V[2],name:V[3],arg:ce});case 102:return this.logger?.logIncoming(ne.byteLength,V[1],1,`${I(be)}: ${V[2]}.${V[3]}`,ce),this.onEventListen({type:be,id:V[1],channelName:V[2],name:V[3],arg:ce});case 101:return this.logger?.logIncoming(ne.byteLength,V[1],1,`${I(be)}`),this.disposeActiveRequest({type:be,id:V[1]});case 103:return this.logger?.logIncoming(ne.byteLength,V[1],1,`${I(be)}`),this.disposeActiveRequest({type:be,id:V[1]})}}onPromise(ne){const H=this.channels.get(ne.channelName);if(!H){this.collectPendingRequest(ne);return}const V=new L.CancellationTokenSource;let ce;try{ce=H.call(this.ctx,ne.name,ne.arg,V.token)}catch(ge){ce=Promise.reject(ge)}const be=ne.id;ce.then(ge=>{this.sendResponse({id:be,data:ge,type:201}),this.activeRequests.delete(ne.id)},ge=>{ge instanceof Error?this.sendResponse({id:be,data:{message:ge.message,name:ge.name,stack:ge.stack?ge.stack.split?ge.stack.split(`
`):ge.stack:void 0},type:202}):this.sendResponse({id:be,data:ge,type:203}),this.activeRequests.delete(ne.id)});const Se=(0,m.toDisposable)(()=>V.cancel());this.activeRequests.set(ne.id,Se)}onEventListen(ne){const H=this.channels.get(ne.channelName);if(!H){this.collectPendingRequest(ne);return}const V=ne.id,be=H.listen(this.ctx,ne.name,ne.arg)(Se=>this.sendResponse({id:V,data:Se,type:204}));this.activeRequests.set(ne.id,be)}disposeActiveRequest(ne){const H=this.activeRequests.get(ne.id);H&&(H.dispose(),this.activeRequests.delete(ne.id))}collectPendingRequest(ne){let H=this.pendingRequests.get(ne.channelName);H||(H=[],this.pendingRequests.set(ne.channelName,H));const V=setTimeout(()=>{console.error(`Unknown channel: ${ne.channelName}`),ne.type===100&&this.sendResponse({id:ne.id,data:{name:"Unknown channel",message:`Channel name '${ne.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);H.push({request:ne,timeoutTimer:V})}flushPendingRequests(ne){const H=this.pendingRequests.get(ne);if(H){for(const V of H)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(ne)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=C;var S;(function(ie){ie[ie.LocalSide=0]="LocalSide",ie[ie.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));class c{constructor(ne,H=null){this.protocol=ne,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=H}getChannel(ne){const H=this;return{call(V,ce,be){return H.isDisposed?Promise.reject(new g.CancellationError):H.requestPromise(ne,V,ce,be)},listen(V,ce){return H.isDisposed?y.Event.None:H.requestEvent(ne,V,ce)}}}requestPromise(ne,H,V,ce=L.CancellationToken.None){const be=this.lastRequestId++,ge={id:be,type:100,channelName:ne,name:H,arg:V};if(ce.isCancellationRequested)return Promise.reject(new g.CancellationError);let O;return new Promise((we,Ce)=>{if(ce.isCancellationRequested)return Ce(new g.CancellationError);const ee=()=>{const le=se=>{switch(se.type){case 201:this.handlers.delete(be),we(se.data);break;case 202:{this.handlers.delete(be);const oe=new Error(se.data.message);oe.stack=Array.isArray(se.data.stack)?se.data.stack.join(`
`):se.data.stack,oe.name=se.data.name,Ce(oe);break}case 203:this.handlers.delete(be),Ce(se.data);break}};this.handlers.set(be,le),this.sendRequest(ge)};let te=null;this.state===l.Idle?ee():(te=(0,T.createCancelablePromise)(le=>this.whenInitialized()),te.then(()=>{te=null,ee()}));const ue=()=>{te?(te.cancel(),te=null):this.sendRequest({id:be,type:101}),Ce(new g.CancellationError)},Q=ce.onCancellationRequested(ue);O=(0,m.combinedDisposable)((0,m.toDisposable)(ue),Q),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(ne,H,V){const ce=this.lastRequestId++,Se={id:ce,type:102,channelName:ne,name:H,arg:V};let ge=null;const O=new y.Emitter({onWillAddFirstListener:()=>{ge=(0,T.createCancelablePromise)(we=>this.whenInitialized()),ge.then(()=>{ge=null,this.activeRequests.add(O),this.sendRequest(Se)})},onDidRemoveLastListener:()=>{ge?(ge.cancel(),ge=null):(this.activeRequests.delete(O),this.sendRequest({id:ce,type:103}))}}),K=we=>O.fire(we.data);return this.handlers.set(ce,K),O.event}sendRequest(ne){switch(ne.type){case 100:case 102:{const H=this.send([ne.type,ne.id,ne.channelName,ne.name],ne.arg);this.logger?.logOutgoing(H,ne.id,0,`${I(ne.type)}: ${ne.channelName}.${ne.name}`,ne.arg);return}case 101:case 103:{const H=this.send([ne.type,ne.id]);this.logger?.logOutgoing(H,ne.id,0,I(ne.type));return}}}send(ne,H=void 0){const V=new n;return p(V,ne),p(V,H),this.sendBuffer(V.buffer)}sendBuffer(ne){try{return this.protocol.send(ne),ne.byteLength}catch{return 0}}onBuffer(ne){const H=new _(ne),V=h(H),ce=h(H),be=V[0];switch(be){case 200:return this.logger?.logIncoming(ne.byteLength,0,0,i(be)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(ne.byteLength,V[1],0,i(be),ce),this.onResponse({type:V[0],id:V[1],data:ce})}}onResponse(ne){if(ne.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}this.handlers.get(ne.id)?.(ne)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=c,Ve([R.memoize],c.prototype,"onDidInitializePromise",null);class r{get connections(){const ne=[];return this._connections.forEach(H=>ne.push(H)),ne}constructor(ne){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,ne(({protocol:H,onDidClientDisconnect:V})=>{y.Event.once(H.onMessage)(be=>{const Se=new _(be),ge=h(Se),O=new C(H,ge),K=new c(H);this.channels.forEach((Ce,ee)=>O.registerChannel(ee,Ce));const we={channelServer:O,channelClient:K,ctx:ge};this._connections.add(we),this._onDidAddConnection.fire(we),V(()=>{O.dispose(),K.dispose(),this._connections.delete(we),this._onDidRemoveConnection.fire(we)})})})}getChannel(ne,H){const V=this;return{call(ce,be,Se){let ge;if((0,w.isFunction)(H)){const K=(0,v.getRandomElement)(V.connections.filter(H));ge=K?Promise.resolve(K):y.Event.toPromise(y.Event.filter(V.onDidAddConnection,H))}else ge=H.routeCall(V,ce,be);const O=ge.then(K=>K.channelClient.getChannel(ne));return M(O).call(ce,be,Se)},listen(ce,be){if((0,w.isFunction)(H))return V.getMulticastEvent(ne,H,ce,be);const Se=H.routeEvent(V,ce,be).then(ge=>ge.channelClient.getChannel(ne));return M(Se).listen(ce,be)}}}getMulticastEvent(ne,H,V,ce){const be=this;let Se=new m.DisposableStore;const ge=new y.Emitter({onWillAddFirstListener:()=>{Se=new m.DisposableStore;const O=new y.EventMultiplexer,K=new Map,we=ee=>{const ue=ee.channelClient.getChannel(ne).listen(V,ce),Q=O.add(ue);K.set(ee,Q)},Ce=ee=>{const te=K.get(ee);te&&(te.dispose(),K.delete(ee))};be.connections.filter(H).forEach(we),y.Event.filter(be.onDidAddConnection,H)(we,void 0,Se),be.onDidRemoveConnection(Ce,void 0,Se),O.event(ge.fire,ge,Se),Se.add(O)},onDidRemoveLastListener:()=>{Se.dispose()}});return ge.event}registerChannel(ne,H){this.channels.set(ne,H),this._connections.forEach(V=>{V.channelServer.registerChannel(ne,H)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=r;class P{constructor(ne,H,V=null){const ce=new n;p(ce,H),ne.send(ce.buffer),this.channelClient=new c(ne,V),this.channelServer=new C(ne,H,V)}getChannel(ne){return this.channelClient.getChannel(ne)}registerChannel(ne,H){this.channelServer.registerChannel(ne,H)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=P;function M(ie){return{call(ne,H,V){return ie.then(ce=>ce.call(ne,H,V))},listen(ne,H){const V=new y.Relay;return ie.then(ce=>V.input=ce.listen(ne,H)),V.event}}}e.getDelayedChannel=M;function W(ie){let ne=!1;return{call(H,V,ce){return ne?ie.call(H,V,ce):(0,T.timeout)(0).then(()=>ne=!0).then(()=>ie.call(H,V,ce))},listen(H,V){if(ne)return ie.listen(H,V);const ce=new y.Relay;return(0,T.timeout)(0).then(()=>ne=!0).then(()=>ce.input=ie.listen(H,V)),ce.event}}}e.getNextTickChannel=W;class ${constructor(ne){this.fn=ne}routeCall(ne){return this.route(ne)}routeEvent(ne){return this.route(ne)}async route(ne){for(const H of ne.connections)if(await Promise.resolve(this.fn(H.ctx)))return Promise.resolve(H);return await y.Event.toPromise(ne.onDidAddConnection),await this.route(ne)}}e.StaticRouter=$;var z;(function(ie){function ne(be,Se){const ge=be,O=Se&&Se.disableMarshalling,K=new Map;for(const we in ge)V(we)&&K.set(we,y.Event.buffer(ge[we],!0));return new class{listen(we,Ce,ee){const te=K.get(Ce);if(te)return te;if(ce(Ce)){const ue=ge[Ce];if(typeof ue=="function")return ue.call(ge,ee)}throw new Error(`Event not found: ${Ce}`)}call(we,Ce,ee){const te=ge[Ce];if(typeof te=="function"){if(!O&&Array.isArray(ee))for(let ue=0;ue<ee.length;ue++)ee[ue]=(0,A.revive)(ee[ue]);return te.apply(ge,ee)}throw new Error(`Method not found: ${Ce}`)}}}ie.fromService=ne;function H(be,Se){const ge=Se&&Se.disableMarshalling;return new Proxy({},{get(O,K){if(typeof K=="string")return Se?.properties?.has(K)?Se.properties.get(K):ce(K)?function(we){return be.listen(K,we)}:V(K)?be.listen(K):async function(...we){let Ce;Se&&!(0,w.isUndefinedOrNull)(Se.context)?Ce=[Se.context,...we]:Ce=we;const ee=await be.call(K,Ce);return ge?ee:(0,A.revive)(ee)};throw new Error(`Property not found: ${String(K)}`)}})}ie.toService=H;function V(be){return be[0]==="o"&&be[1]==="n"&&k.isUpperAsciiLetter(be.charCodeAt(2))}function ce(be){return/^onDynamic/.test(be)&&k.isUpperAsciiLetter(be.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(ie){if(Array.isArray(ie))return ie;if(ie&&typeof ie=="object"&&typeof ie.toString=="function"){const ne=ie.toString();if(ne!=="[object Object]")return ne}return ie}function x(ie){return Array.isArray(ie)?ie.map(q):q(ie)}function U(ie,ne,H,V,ce,be,Se){Se=x(Se);const ge=N[ce],O=ge[V%ge.length];let K=[`%c[${ie}]%c[${String(ne).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${be}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(be)?(K=K.concat(Se),K.push(")")):K.push(Se),console.log.apply(console,K)}class de{constructor(ne,H){this._outgoingPrefix=ne,this._incomingPrefix=H,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(ne,H,V,ce,be){this._totalOutgoing+=ne,U(this._outgoingPrefix,this._totalOutgoing,ne,H,V,ce,be)}logIncoming(ne,H,V,ce,be){this._totalIncoming+=ne,U(this._incomingPrefix,this._totalIncoming,ne,H,V,ce,be)}}e.IPCLogger=de}),define(De[122],Ie([1,0,22,3,4,75]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var g;(function(t){t.enableDiagnostics=!1,t.records=[];const u=new WeakMap;let p=0;function h(S,c){if(!u.has(S)){const r=String(++p);u.set(S,r)}return u.get(S)}function C(S,c,r,P){if(!t.enableDiagnostics)return;const M=h(S,c);if(P instanceof v.VSBuffer||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const W=v.VSBuffer.alloc(P.byteLength);W.set(P),t.records.push({timestamp:Date.now(),id:M,label:c,type:r,buff:W})}else t.records.push({timestamp:Date.now(),id:M,label:c,type:r,data:P})}t.traceSocketEvent=C})(g||(e.SocketDiagnostics=g={}));var y;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y||(e.SocketCloseEventType=y={}));let m=null;function A(){return m||(m=v.VSBuffer.alloc(0)),m}class k{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(u){this._chunks.push(u),this._totalLength+=u.byteLength}read(u){return this._read(u,!0)}peek(u){return this._read(u,!1)}_read(u,p){if(u===0)return A();if(u>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===u){const c=this._chunks[0];return p&&(this._chunks.shift(),this._totalLength-=u),c}if(this._chunks[0].byteLength>u){const c=this._chunks[0].slice(0,u);return p&&(this._chunks[0]=this._chunks[0].slice(u),this._totalLength-=u),c}const h=v.VSBuffer.alloc(u);let C=0,S=0;for(;u>0;){const c=this._chunks[S];if(c.byteLength>u){const r=c.slice(0,u);h.set(r,C),C+=u,p&&(this._chunks[S]=c.slice(u),this._totalLength-=u),u-=u}else h.set(c,C),C+=c.byteLength,p?(this._chunks.shift(),this._totalLength-=c.byteLength):S++,u-=c.byteLength}return h}}e.ChunkStream=k;var w;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(w||(w={}));function D(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var I;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(I||(e.ProtocolConstants=I={}));class E{constructor(u,p,h,C){this.type=u,this.id=p,this.ack=h,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class i extends d.Disposable{constructor(u){super(),this._onMessage=this._register(new T.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=u,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(p=>this.acceptChunk(p))),this.lastReadTime=Date.now()}acceptChunk(u){if(!(!u||u.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;){const p=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=p.readUInt32BE(9),this._state.messageType=p.readUInt8(0),this._state.id=p.readUInt32BE(1),this._state.ack=p.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:D(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const h=this._state.messageType,C=this._state.id,S=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",p),this._onMessage.fire(new E(h,C,S,p)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class l{constructor(u){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=u,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(u){if(this._isDisposed)return;u.writtenTime=Date.now(),this.lastWriteTime=Date.now();const p=v.VSBuffer.alloc(13);p.writeUInt8(u.type,0),p.writeUInt32BE(u.id,1),p.writeUInt32BE(u.ack,5),p.writeUInt32BE(u.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:D(u.type),id:u.id,ack:u.ack,messageSize:u.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",u.data),this._writeSoon(p,u.data)}_bufferAdd(u,p){const h=this._totalLength===0;return this._data.push(u,p),this._totalLength+=u.byteLength+p.byteLength,h}_bufferTake(){const u=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,u}_writeSoon(u,p){this._bufferAdd(u,p)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const u=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:u.byteLength}),this._socket.write(u)}}class a extends d.Disposable{constructor(u){super(),this._onMessage=new T.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=u,this._socketWriter=this._register(new l(this._socket)),this._socketReader=this._register(new i(this._socket)),this._register(this._socketReader.onMessage(p=>{p.type===1&&this._onMessage.fire(p.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(u){this._socketWriter.write(new E(1,0,0,u))}}e.Protocol=a;class b extends L.IPCClient{static fromSocket(u,p){return new b(new a(u),p)}get onDidDispose(){return this.protocol.onDidDispose}constructor(u,p,h=null){super(u,p,h),this.protocol=u}dispose(){super.dispose();const u=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),u.end()}}e.Client=b;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new T.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(u){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(u):this._emitter.fire(u):this._bufferedMessages.push(u)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class _{constructor(u){this.data=u,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let u=0,p=this._first;for(;p;)p=p.next,u++;return u}peek(){return this._first?this._first.data:null}toArray(){const u=[];let p=0,h=this._first;for(;h;)u[p++]=h.data,h=h.next;return u}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(u){const p=new _(u);if(!this._first){this._first=p,this._last=p;return}this._last.next=p,this._last=p}}class o{static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const u=Date.now();for(let p=0;p<o._HISTORY_LENGTH;p++)this.lastRuns[p]=u-1e3*p;setInterval(()=>{for(let p=o._HISTORY_LENGTH;p>=1;p--)this.lastRuns[p]=this.lastRuns[p-1];this.lastRuns[0]=Date.now()},1e3)}load(){const u=Date.now(),p=(1+o._HISTORY_LENGTH)*1e3;let h=0;for(let C=0;C<o._HISTORY_LENGTH;C++)u-this.lastRuns[C]<=p&&h++;return 1-h/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(u){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u.loadEstimator??o.getInstance(),this._shouldSendKeepAlive=u.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new d.DisposableStore,this._socket=u.socket,this._socketWriter=this._socketDisposables.add(new l(this._socket)),this._socketReader=this._socketDisposables.add(new i(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.add(this._socket.onClose(p=>this._onSocketClose.fire(p))),u.initialChunk&&this._socketReader.acceptChunk(u.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const u=new E(5,0,0,A());this._socketWriter.write(u),this._socketWriter.flush()}sendPause(){const u=new E(7,0,0,A());this._socketWriter.write(u)}sendResume(){const u=new E(8,0,0,A());this._socketWriter.write(u)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(u,p){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new d.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=u,this._socketWriter=this._socketDisposables.add(new l(this._socket)),this._socketReader=this._socketDisposables.add(new i(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.add(this._socket.onClose(h=>this._onSocketClose.fire(h))),this._socketReader.acceptChunk(p)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const u=new E(3,0,this._incomingAckId,A());this._socketWriter.write(u);const p=this._outgoingUnackMsg.toArray();for(let h=0,C=p.length;h<C;h++)this._socketWriter.write(p[h]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(u){if(u.ack>this._outgoingAckId){this._outgoingAckId=u.ack;do{const p=this._outgoingUnackMsg.peek();if(p&&p.id<=u.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(u.type){case 0:break;case 1:{if(u.id>this._incomingMsgId)if(u.id!==this._incomingMsgId+1){const p=Date.now();p-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=p,this._socketWriter.write(new E(6,0,0,A())))}else this._incomingMsgId=u.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(u.data);break}case 2:{this._onControlMessage.fire(u.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const p=this._outgoingUnackMsg.toArray();for(let h=0,C=p.length;h<C;h++)this._socketWriter.write(p[h]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(u){const p=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new E(1,p,this._incomingAckId,u);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(u){const p=new E(2,0,0,u);this._socketWriter.write(p)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const u=Date.now()-this._incomingMsgLastTime;if(u>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-u+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const u=this._outgoingUnackMsg.peek(),p=Date.now()-u.writtenTime,h=Date.now()-this._socketReader.lastReadTime,C=Date.now()-this._lastSocketTimeoutTime;if(p>=2e4&&h>=2e4&&C>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:p,timeSinceLastReceivedSomeData:h});return}const S=Math.max(2e4-p,2e4-h,2e4-C,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},S)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const u=new E(3,0,this._incomingAckId,A());this._socketWriter.write(u)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const u=new E(9,0,this._incomingAckId,A());this._socketWriter.write(u)}}e.PersistentProtocol=s}),define(De[173],Ie([1,0,46,17,22,21,172,8,3,4,24,96,93,75]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class I extends D.ChannelServer{constructor(l){super({send:a=>{try{process.send?.(a.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",a=>d.VSBuffer.wrap(Buffer.from(a,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=I;class E{constructor(l,a){this.modulePath=l,this.options=a,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new y.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const b=a&&a.timeout?a.timeout:6e4;this.disposeDelayer=new T.Delayer(b),this.child=null,this._client=null}getChannel(l){const a=this;return{call(b,f,_){return a.requestPromise(l,b,f,_)},listen(b,f){return a.requestEvent(l,b,f)}}}requestPromise(l,a,b,f=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(g.canceled());this.disposeDelayer.cancel();const _=this.getCachedChannel(l),n=(0,T.createCancelablePromise)(t=>_.call(a,b,t)),o=f.onCancellationRequested(()=>n.cancel()),s=(0,m.toDisposable)(()=>n.cancel());return this.activeRequests.add(s),n.finally(()=>{o.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(l,a,b){if(!this.disposeDelayer)return y.Event.None;this.disposeDelayer.cancel();let f;const _=new y.Emitter({onWillAddFirstListener:()=>{f=this.getCachedChannel(l).listen(a,b)(_.fire,_),this.activeRequests.add(f)},onDidRemoveLastListener:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return _.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],a=Object.create(null);a.env={...(0,A.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(a.env={...a.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(a.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,w.removeDangerousEnvVariables)(a.env),this.child=(0,v.fork)(this.modulePath,l,a);const b=new y.Emitter;y.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,R.isRemoteConsoleLog)(u)){(0,R.log)(u,`IPC Library: ${this.options.serverName}`);return}b.fire(d.VSBuffer.wrap(Buffer.from(u,"base64")))});const _=this.options.useQueue?(0,k.createQueuedSender)(this.child):this.child,n=u=>this.child&&this.child.connected&&_.send(u.buffer.toString("base64")),o=b.event,s={send:n,onMessage:o};this._client=new D.ChannelClient(s);const t=()=>this.disposeClient();process.once("exit",t),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,p)=>{process.removeListener("exit",t),this.activeRequests.forEach(h=>(0,m.dispose)(h)),this.activeRequests.clear(),u!==0&&p!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+p),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:p})})}return this._client}getCachedChannel(l){let a=this.channels.get(l);return a||(a=this.client.getChannel(l),this.channels.set(l,a)),a}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=E}),define(De[174],Ie([1,0,33,11]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function d(L,R,g,y,m,A){if(Array.isArray(L)){let k=0;for(const w of L){const D=d(w,R,g,y,m,A);if(D===10)return D;D>k&&(k=D)}return k}else{if(typeof L=="string")return y?L==="*"?5:L===g?10:0:0;if(L){const{language:k,pattern:w,scheme:D,hasAccessToAllModels:I,notebookType:E}=L;if(!y&&!I)return 0;E&&m&&(R=m);let i=0;if(D)if(D===R.scheme)i=10;else if(D==="*")i=5;else return 0;if(k)if(k===g)i=10;else if(k==="*")i=Math.max(i,5);else return 0;if(E)if(E===A)i=10;else if(E==="*"&&A!==void 0)i=Math.max(i,5);else return 0;if(w){let l;if(typeof w=="string"?l=w:l={...w,base:(0,T.normalize)(w.base)},l===R.fsPath||(0,v.match)(l,R.fsPath))i=10;else return 0}return i}else return 0}}e.score=d}),define(De[76],Ie([1,0,72,2,35,165]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class R{constructor(P,M,W){this.offset=P,this.type=M,this.language=W,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=R;class g{constructor(P,M){this.tokens=P,this.endState=M,this._tokenizationResultBrand=void 0}}e.TokenizationResult=g;class y{constructor(P,M){this.tokens=P,this.endState=M,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=y;var m;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(m||(e.CompletionItemKind=m={}));var A;(function(r){const P=new Map;P.set(0,v.Codicon.symbolMethod),P.set(1,v.Codicon.symbolFunction),P.set(2,v.Codicon.symbolConstructor),P.set(3,v.Codicon.symbolField),P.set(4,v.Codicon.symbolVariable),P.set(5,v.Codicon.symbolClass),P.set(6,v.Codicon.symbolStruct),P.set(7,v.Codicon.symbolInterface),P.set(8,v.Codicon.symbolModule),P.set(9,v.Codicon.symbolProperty),P.set(10,v.Codicon.symbolEvent),P.set(11,v.Codicon.symbolOperator),P.set(12,v.Codicon.symbolUnit),P.set(13,v.Codicon.symbolValue),P.set(15,v.Codicon.symbolEnum),P.set(14,v.Codicon.symbolConstant),P.set(15,v.Codicon.symbolEnum),P.set(16,v.Codicon.symbolEnumMember),P.set(17,v.Codicon.symbolKeyword),P.set(27,v.Codicon.symbolSnippet),P.set(18,v.Codicon.symbolText),P.set(19,v.Codicon.symbolColor),P.set(20,v.Codicon.symbolFile),P.set(21,v.Codicon.symbolReference),P.set(22,v.Codicon.symbolCustomColor),P.set(23,v.Codicon.symbolFolder),P.set(24,v.Codicon.symbolTypeParameter),P.set(25,v.Codicon.account),P.set(26,v.Codicon.issues);function M(z){let N=P.get(z);return N||(console.info("No codicon found for CompletionItemKind "+z),N=v.Codicon.symbolProperty),N}r.toIcon=M;const W=new Map;W.set("method",0),W.set("function",1),W.set("constructor",2),W.set("field",3),W.set("variable",4),W.set("class",5),W.set("struct",6),W.set("interface",7),W.set("module",8),W.set("property",9),W.set("event",10),W.set("operator",11),W.set("unit",12),W.set("value",13),W.set("constant",14),W.set("enum",15),W.set("enum-member",16),W.set("enumMember",16),W.set("keyword",17),W.set("snippet",27),W.set("text",18),W.set("color",19),W.set("file",20),W.set("reference",21),W.set("customcolor",22),W.set("folder",23),W.set("type-parameter",24),W.set("typeParameter",24),W.set("account",25),W.set("issue",26);function $(z,N){let q=W.get(z);return typeof q>"u"&&!N&&(q=9),q}r.fromString=$})(A||(e.CompletionItemKinds=A={}));var k;(function(r){r[r.Deprecated=1]="Deprecated"})(k||(e.CompletionItemTag=k={}));var w;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(w||(e.CompletionItemInsertTextRule=w={}));var D;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(D||(e.CompletionTriggerKind=D={}));var I;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(I||(e.InlineCompletionTriggerKind=I={}));class E{constructor(P,M,W,$){this.range=P,this.text=M,this.completionKind=W,this.isSnippetText=$}equals(P){return d.Range.lift(this.range).equalsRange(P.range)&&this.text===P.text&&this.completionKind===P.completionKind&&this.isSnippetText===P.isSnippetText}}e.SelectedSuggestionInfo=E;var i;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var l;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(l||(e.SignatureHelpTriggerKind=l={}));var a;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(a||(e.DocumentHighlightKind=a={}));function b(r){return r&&T.URI.isUri(r.uri)&&d.Range.isIRange(r.range)&&(d.Range.isIRange(r.originSelectionRange)||d.Range.isIRange(r.targetSelectionRange))}e.isLocationLink=b;var f;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(f||(e.SymbolKind=f={}));var _;(function(r){r[r.Deprecated=1]="Deprecated"})(_||(e.SymbolTag=_={}));var n;(function(r){const P=new Map;P.set(0,v.Codicon.symbolFile),P.set(1,v.Codicon.symbolModule),P.set(2,v.Codicon.symbolNamespace),P.set(3,v.Codicon.symbolPackage),P.set(4,v.Codicon.symbolClass),P.set(5,v.Codicon.symbolMethod),P.set(6,v.Codicon.symbolProperty),P.set(7,v.Codicon.symbolField),P.set(8,v.Codicon.symbolConstructor),P.set(9,v.Codicon.symbolEnum),P.set(10,v.Codicon.symbolInterface),P.set(11,v.Codicon.symbolFunction),P.set(12,v.Codicon.symbolVariable),P.set(13,v.Codicon.symbolConstant),P.set(14,v.Codicon.symbolString),P.set(15,v.Codicon.symbolNumber),P.set(16,v.Codicon.symbolBoolean),P.set(17,v.Codicon.symbolArray),P.set(18,v.Codicon.symbolObject),P.set(19,v.Codicon.symbolKey),P.set(20,v.Codicon.symbolNull),P.set(21,v.Codicon.symbolEnumMember),P.set(22,v.Codicon.symbolStruct),P.set(23,v.Codicon.symbolEvent),P.set(24,v.Codicon.symbolOperator),P.set(25,v.Codicon.symbolTypeParameter);function M(W){let $=P.get(W);return $||(console.info("No codicon found for SymbolKind "+W),$=v.Codicon.symbolProperty),$}r.toIcon=M})(n||(e.SymbolKinds=n={}));class o{static fromValue(P){switch(P){case"comment":return o.Comment;case"imports":return o.Imports;case"region":return o.Region}return new o(P)}constructor(P){this.value=P}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var s;(function(r){function P(M){return!M||typeof M!="object"?!1:typeof M.id=="string"&&typeof M.title=="string"}r.is=P})(s||(e.Command=s={}));var t;(function(r){r[r.Collapsed=0]="Collapsed",r[r.Expanded=1]="Expanded"})(t||(e.CommentThreadCollapsibleState=t={}));var u;(function(r){r[r.Unresolved=0]="Unresolved",r[r.Resolved=1]="Resolved"})(u||(e.CommentThreadState=u={}));var p;(function(r){r[r.Editing=0]="Editing",r[r.Preview=1]="Preview"})(p||(e.CommentMode=p={}));var h;(function(r){r[r.Published=0]="Published",r[r.Draft=1]="Draft"})(h||(e.CommentState=h={}));var C;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(C||(e.InlayHintKind=C={}));class S{constructor(P){this.createSupport=P,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(P=>{P&&P.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=S,e.TokenizationRegistry=new L.TokenizationRegistry;var c;(function(r){r[r.None=0]="None",r[r.Option=1]="Option",r[r.Default=2]="Default",r[r.Preferred=3]="Preferred"})(c||(e.ExternalUriOpenerPriority=c={}))}),define(De[123],Ie([1,0,22,10]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var d;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(d||(d={}));function L(k){for(let w=0,D=k.length;w<D;w+=4){const I=k[w+0],E=k[w+1],i=k[w+2],l=k[w+3];k[w+0]=l,k[w+1]=i,k[w+2]=E,k[w+3]=I}}function R(k){const w=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return T.isLittleEndian()||L(w),v.VSBuffer.wrap(w)}function g(k){const w=k.buffer;if(T.isLittleEndian()||L(w),w.byteOffset%4===0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const D=new Uint8Array(w.byteLength);return D.set(w),new Uint32Array(D.buffer,D.byteOffset,D.length/4)}}function y(k){const w=new Uint32Array(m(k));let D=0;if(w[D++]=k.id,k.type==="full")w[D++]=1,w[D++]=k.data.length,w.set(k.data,D),D+=k.data.length;else{w[D++]=2,w[D++]=k.deltas.length;for(const I of k.deltas)w[D++]=I.start,w[D++]=I.deleteCount,I.data?(w[D++]=I.data.length,w.set(I.data,D),D+=I.data.length):w[D++]=0}return R(w)}e.encodeSemanticTokensDto=y;function m(k){let w=0;if(w+=1+1,k.type==="full")w+=1+k.data.length;else{w+=1,w+=(1+1+1)*k.deltas.length;for(const D of k.deltas)D.data&&(w+=D.data.length)}return w}function A(k){const w=g(k);let D=0;const I=w[D++];if(w[D++]===1){const a=w[D++],b=w.subarray(D,D+a);return D+=a,{id:I,type:"full",data:b}}const i=w[D++],l=[];for(let a=0;a<i;a++){const b=w[D++],f=w[D++],_=w[D++];let n;_>0&&(n=w.subarray(D,D+_),D+=_),l[a]={start:b,deleteCount:f,data:n}}return{id:I,type:"delta",deltas:l}}e.decodeSemanticTokensDto=A}),define(De[175],Ie([13,14]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(De[124],Ie([1,0,19,24,10,157,116,175]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class m{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=m;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class k{constructor(X,Ee,Ue,Ne){this.id=X,this.name=Ee,this.defaultValue=Ue,this.schema=Ne}applyUpdate(X,Ee){return D(X,Ee)}compute(X,Ee,Ue){return Ue}}class w{constructor(X,Ee){this.newValue=X,this.didChange=Ee}}e.ApplyUpdateResult=w;function D(J,X){if(typeof J!="object"||typeof X!="object"||!J||!X)return new w(X,J!==X);if(Array.isArray(J)||Array.isArray(X)){const Ue=Array.isArray(J)&&Array.isArray(X)&&v.equals(J,X);return new w(X,!Ue)}let Ee=!1;for(const Ue in X)if(X.hasOwnProperty(Ue)){const Ne=D(J[Ue],X[Ue]);Ne.didChange&&(J[Ue]=Ne.newValue,Ee=!0)}return new w(J,Ee)}class I{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,Ee){return D(X,Ee)}validate(X){return this.defaultValue}}class E{constructor(X,Ee,Ue,Ne){this.id=X,this.name=Ee,this.defaultValue=Ue,this.schema=Ne}applyUpdate(X,Ee){return D(X,Ee)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,Ee,Ue){return Ue}}function i(J,X){return typeof J>"u"?X:J==="false"?!1:!!J}e.boolean=i;class l extends E{constructor(X,Ee,Ue,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Ue),super(X,Ee,Ue,Ne)}validate(X){return i(X,this.defaultValue)}}function a(J,X,Ee,Ue){if(typeof J>"u")return X;let Ne=parseInt(J,10);return isNaN(Ne)?X:(Ne=Math.max(Ee,Ne),Ne=Math.min(Ue,Ne),Ne|0)}e.clampedInt=a;class b extends E{static clampedInt(X,Ee,Ue,Ne){return a(X,Ee,Ue,Ne)}constructor(X,Ee,Ue,Ne,Qe,et=void 0){typeof et<"u"&&(et.type="integer",et.default=Ue,et.minimum=Ne,et.maximum=Qe),super(X,Ee,Ue,et),this.minimum=Ne,this.maximum=Qe}validate(X){return b.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function f(J,X,Ee,Ue){if(typeof J>"u")return X;const Ne=_.float(J,X);return _.clamp(Ne,Ee,Ue)}e.clampedFloat=f;class _ extends E{static clamp(X,Ee,Ue){return X<Ee?Ee:X>Ue?Ue:X}static float(X,Ee){if(typeof X=="number")return X;if(typeof X>"u")return Ee;const Ue=parseFloat(X);return isNaN(Ue)?Ee:Ue}constructor(X,Ee,Ue,Ne,Qe){typeof Qe<"u"&&(Qe.type="number",Qe.default=Ue),super(X,Ee,Ue,Qe),this.validationFn=Ne}validate(X){return this.validationFn(_.float(X,this.defaultValue))}}class n extends E{static string(X,Ee){return typeof X!="string"?Ee:X}constructor(X,Ee,Ue,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Ue),super(X,Ee,Ue,Ne)}validate(X){return n.string(X,this.defaultValue)}}function o(J,X,Ee,Ue){return typeof J!="string"?X:Ue&&J in Ue?Ue[J]:Ee.indexOf(J)===-1?X:J}e.stringSet=o;class s extends E{constructor(X,Ee,Ue,Ne,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.enum=Ne,Qe.default=Ue),super(X,Ee,Ue,Qe),this._allowedValues=Ne}validate(X){return o(X,this.defaultValue,this._allowedValues)}}class t extends k{constructor(X,Ee,Ue,Ne,Qe,et,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Qe,nt.default=Ne),super(X,Ee,Ue,nt),this._allowedValues=Qe,this._convert=et}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function u(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",tags:["accessibility"],description:g.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,Ee,Ue){return Ue===0?X.accessibilitySupport:Ue}}class h extends k{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(21,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:g.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ee=X;return{insertSpace:i(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var C;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(C||(e.TextEditorCursorBlinkingStyle=C={}));function S(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var c;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(c||(e.TextEditorCursorStyle=c={}));function r(J){switch(J){case c.Line:return"line";case c.Block:return"block";case c.Underline:return"underline";case c.LineThin:return"line-thin";case c.BlockOutline:return"block-outline";case c.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=r;function P(J){switch(J){case"line":return c.Line;case"block":return c.Block;case"underline":return c.Underline;case"line-thin":return c.LineThin;case"block-outline":return c.BlockOutline;case"underline-thin":return c.UnderlineThin}}class M extends I{constructor(){super(138)}compute(X,Ee,Ue){const Ne=["monaco-editor"];return Ee.get(37)&&Ne.push(Ee.get(37)),X.extraEditorClassName&&Ne.push(X.extraEditorClassName),Ee.get(71)==="default"?Ne.push("mouse-default"):Ee.get(71)==="copy"&&Ne.push("mouse-copy"),Ee.get(108)&&Ne.push("showUnused"),Ee.get(136)&&Ne.push("showDeprecated"),Ne.join(" ")}}class W extends l{constructor(){super(35,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(X,Ee,Ue){return Ue&&X.emptySelectionClipboard}}class $ extends k{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(39,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:g.localize(16,null),included:d.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:g.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ee=X;return{cursorMoveOnType:i(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":o(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":o(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Ee.loop,this.defaultValue.loop)}}}class z extends k{constructor(){super(49,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?z.OFF:X==="true"?z.ON:X:X?z.ON:z.OFF}}e.EditorFontLigatures=z,z.OFF='"liga" off, "calt" off',z.ON='"liga" on, "calt" on';class N extends k{constructor(){super(52,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:g.localize(22,null)},{type:"string",description:g.localize(23,null)}],description:g.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?N.OFF:X==="true"?N.TRANSLATE:X:X?N.TRANSLATE:N.OFF}compute(X,Ee,Ue){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=N,N.OFF="normal",N.TRANSLATE="translate";class q extends I{constructor(){super(48)}compute(X,Ee,Ue){return X.fontInfo}}class x extends E{constructor(){super(50,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(25,null)})}validate(X){const Ee=_.float(X,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:_.clamp(Ee,6,100)}compute(X,Ee,Ue){return X.fontInfo.fontSize}}class U extends k{constructor(){super(51,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.MINIMUM_VALUE,maximum:U.MAXIMUM_VALUE,errorMessage:g.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(b.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,U.MINIMUM_VALUE,U.MAXIMUM_VALUE))}}U.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],U.MINIMUM_VALUE=1,U.MAXIMUM_VALUE=1e3;class de extends k{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[g.localize(28,null),g.localize(29,null),g.localize(30,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(56,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(32,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(33,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:g.localize(34,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:g.localize(35,null),...Ee},"editor.gotoLocation.multipleReferences":{description:g.localize(36,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ue,description:g.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ue,description:g.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ue,description:g.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ue,description:g.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ue,description:g.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ee=X;return{multiple:o(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??o(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??o(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??o(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??o(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??o(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ie extends k{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(58,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:g.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:g.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:g.localize(44,null)},"editor.hover.above":{type:"boolean",default:X.above,description:g.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ee=X;return{enabled:i(Ee.enabled,this.defaultValue.enabled),delay:b.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:i(Ee.sticky,this.defaultValue.sticky),above:i(Ee.above,this.defaultValue.above)}}}var ne;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(ne||(e.RenderMinimap=ne={}));class H extends I{constructor(){super(141)}compute(X,Ee,Ue){return H.computeLayout(Ee,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const Ee=X.height/X.lineHeight,Ue=Math.floor(X.paddingTop/X.lineHeight);let Ne=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Ne=Math.max(Ne,Ee-1));const Qe=(Ue+X.viewLineCount+Ne)/(X.pixelRatio*X.height),et=Math.floor(X.viewLineCount/Qe);return{typicalViewportLineCount:Ee,extraLinesBeforeFirstLine:Ue,extraLinesBeyondLastLine:Ne,desiredRatio:Qe,minimapLineCount:et}}static _computeMinimapLayout(X,Ee){const Ue=X.outerWidth,Ne=X.outerHeight,Qe=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const et=Ee.stableMinimapLayoutInput,nt=et&&X.outerHeight===et.outerHeight&&X.lineHeight===et.lineHeight&&X.typicalHalfwidthCharacterWidth===et.typicalHalfwidthCharacterWidth&&X.pixelRatio===et.pixelRatio&&X.scrollBeyondLastLine===et.scrollBeyondLastLine&&X.paddingTop===et.paddingTop&&X.paddingBottom===et.paddingBottom&&X.minimap.enabled===et.minimap.enabled&&X.minimap.side===et.minimap.side&&X.minimap.size===et.minimap.size&&X.minimap.showSlider===et.minimap.showSlider&&X.minimap.renderCharacters===et.minimap.renderCharacters&&X.minimap.maxColumn===et.minimap.maxColumn&&X.minimap.scale===et.minimap.scale&&X.verticalScrollbarWidth===et.verticalScrollbarWidth&&X.isViewportWrapping===et.isViewportWrapping,ft=X.lineHeight,wt=X.typicalHalfwidthCharacterWidth,Mt=X.scrollBeyondLastLine,Ft=X.minimap.renderCharacters;let _t=Qe>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Bt=X.minimap.maxColumn,Nt=X.minimap.size,Ut=X.minimap.side,Ht=X.verticalScrollbarWidth,Vt=X.viewLineCount,lt=X.remainingWidth,gt=X.isViewportWrapping,zt=Ft?2:3;let Rt=Math.floor(Qe*Ne);const It=Rt/Qe;let ut=!1,Pt=!1,Ot=zt*_t,Le=_t/Qe,Ae=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:it,extraLinesBeforeFirstLine:yt,extraLinesBeyondLastLine:kt,desiredRatio:Tt,minimapLineCount:vt}=H.computeContainedMinimapLineCount({viewLineCount:Vt,scrollBeyondLastLine:Mt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Ne,lineHeight:ft,pixelRatio:Qe});if(Vt/vt>1)ut=!0,Pt=!0,_t=1,Ot=1,Le=_t/Qe;else{let mt=!1,St=_t+1;if(Nt==="fit"){const Et=Math.ceil((yt+Vt+kt)*Ot);gt&&nt&&lt<=Ee.stableFitRemainingWidth?(mt=!0,St=Ee.stableFitMaxMinimapScale):mt=Et>Rt}if(Nt==="fill"||mt){ut=!0;const Et=_t;Ot=Math.min(ft*Qe,Math.max(1,Math.floor(1/Tt))),gt&&nt&&lt<=Ee.stableFitRemainingWidth&&(St=Ee.stableFitMaxMinimapScale),_t=Math.min(St,Math.max(1,Math.floor(Ot/zt))),_t>Et&&(Ae=Math.min(2,_t/Et)),Le=_t/Qe/Ae,Rt=Math.ceil(Math.max(it,yt+Vt+kt)*Ot),gt?(Ee.stableMinimapLayoutInput=X,Ee.stableFitRemainingWidth=lt,Ee.stableFitMaxMinimapScale=_t):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const Te=Math.floor(Bt*Le),ae=Math.min(Te,Math.max(0,Math.floor((lt-Ht-2)*Le/(wt+Le)))+e.MINIMAP_GUTTER_WIDTH);let Me=Math.floor(Qe*ae);const Be=Me/Qe;Me=Math.floor(Me*Ae);const Xe=Ft?1:2,je=Ut==="left"?0:Ue-ae-Ht;return{renderMinimap:Xe,minimapLeft:je,minimapWidth:ae,minimapHeightIsEditorHeight:ut,minimapIsSampling:Pt,minimapScale:_t,minimapLineHeight:Ot,minimapCanvasInnerWidth:Me,minimapCanvasInnerHeight:Rt,minimapCanvasOuterWidth:Be,minimapCanvasOuterHeight:It}}static computeLayout(X,Ee){const Ue=Ee.outerWidth|0,Ne=Ee.outerHeight|0,Qe=Ee.lineHeight|0,et=Ee.lineNumbersDigitCount|0,nt=Ee.typicalHalfwidthCharacterWidth,ft=Ee.maxDigitWidth,wt=Ee.pixelRatio,Mt=Ee.viewLineCount,Ft=X.get(133),_t=Ft==="inherit"?X.get(132):Ft,Bt=_t==="inherit"?X.get(128):_t,Nt=X.get(131),Ut=Ee.isDominatedByLongLines,Ht=X.get(55),Vt=X.get(65).renderType!==0,lt=X.get(66),gt=X.get(102),zt=X.get(81),Rt=X.get(70),It=X.get(100),ut=It.verticalScrollbarSize,Pt=It.verticalHasArrows,Ot=It.arrowSize,Le=It.horizontalScrollbarSize,Ae=X.get(41),Te=X.get(107)!=="never";let ae=X.get(63);Ae&&Te&&(ae+=16);let Me=0;if(Vt){const $t=Math.max(et,lt);Me=Math.round($t*ft)}let Be=0;Ht&&(Be=Qe*Ee.glyphMarginDecorationLaneCount);let Xe=0,je=Xe+Be,it=je+Me,yt=it+ae;const kt=Ue-Be-Me-ae;let Tt=!1,vt=!1,bt=-1;_t==="inherit"&&Ut?(Tt=!0,vt=!0):Bt==="on"||Bt==="bounded"?vt=!0:Bt==="wordWrapColumn"&&(bt=Nt);const mt=H._computeMinimapLayout({outerWidth:Ue,outerHeight:Ne,lineHeight:Qe,typicalHalfwidthCharacterWidth:nt,pixelRatio:wt,scrollBeyondLastLine:gt,paddingTop:zt.top,paddingBottom:zt.bottom,minimap:Rt,verticalScrollbarWidth:ut,viewLineCount:Mt,remainingWidth:kt,isViewportWrapping:vt},Ee.memory||new A);mt.renderMinimap!==0&&mt.minimapLeft===0&&(Xe+=mt.minimapWidth,je+=mt.minimapWidth,it+=mt.minimapWidth,yt+=mt.minimapWidth);const St=kt-mt.minimapWidth,Et=Math.max(1,Math.floor((St-ut-2)/nt)),Qt=Pt?Ot:0;return vt&&(bt=Math.max(1,Et),Bt==="bounded"&&(bt=Math.min(bt,Nt))),{width:Ue,height:Ne,glyphMarginLeft:Xe,glyphMarginWidth:Be,glyphMarginDecorationLaneCount:Ee.glyphMarginDecorationLaneCount,lineNumbersLeft:je,lineNumbersWidth:Me,decorationsLeft:it,decorationsWidth:ae,contentLeft:yt,contentWidth:St,minimap:mt,viewportColumn:Et,isWordWrapMinified:Tt,isViewportWrapping:vt,wrappingColumn:bt,verticalScrollbarWidth:ut,horizontalScrollbarHeight:Le,overviewRuler:{top:Qt,width:ut,height:Ne-2*Qt,right:0}}}}e.EditorLayoutInfoComputer=H;class V extends k{constructor(){super(135,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[g.localize(46,null),g.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:g.localize(48,null)}})}validate(X){return o(X,"simple",["simple","advanced"])}compute(X,Ee,Ue){return Ee.get(2)===2?"advanced":Ue}}class ce extends k{constructor(){const X={enabled:!0};super(62,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:g.localize(49,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:i(X.enabled,this.defaultValue.enabled)}}}class be extends k{constructor(){const X={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(112,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:g.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:g.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:g.localize(52,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ee=X;return{enabled:i(Ee.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:o(Ee.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class Se extends k{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(137,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:g.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[g.localize(54,null),g.localize(55,null,d.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),g.localize(56,null,d.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),g.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:g.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:g.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:g.localize(60,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ee=X;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:o(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:i(Ee.padding,this.defaultValue.padding)}}}class ge extends k{constructor(){super(63,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):b.clampedInt(X,this.defaultValue,0,1e3)}compute(X,Ee,Ue){return Ue<0?b.clampedInt(-Ue*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ue}}class O extends _{constructor(){super(64,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>_.clamp(X,0,150),{markdownDescription:g.localize(61,null)})}compute(X,Ee,Ue){return X.fontInfo.lineHeight}}class K extends k{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(70,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:g.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:g.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(64,null),g.localize(65,null),g.localize(66,null)],default:X.size,description:g.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:g.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:g.localize(69,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:g.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:g.localize(72,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ee=X;return{enabled:i(Ee.enabled,this.defaultValue.enabled),autohide:i(Ee.autohide,this.defaultValue.autohide),size:o(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:o(Ee.side,this.defaultValue.side,["right","left"]),showSlider:o(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(Ee.scale,1,1,3),maxColumn:b.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function we(J){return J==="ctrlCmd"?d.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ce extends k{constructor(){super(81,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(74,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ee=X;return{top:b.clampedInt(Ee.top,0,0,1e3),bottom:b.clampedInt(Ee.bottom,0,0,1e3)}}}class ee extends k{constructor(){const X={enabled:!0,cycle:!0};super(83,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:g.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:g.localize(76,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ee=X;return{enabled:i(Ee.enabled,this.defaultValue.enabled),cycle:i(Ee.cycle,this.defaultValue.cycle)}}}class te extends I{constructor(){super(139)}compute(X,Ee,Ue){return X.pixelRatio}}class ue extends k{constructor(){const X={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[g.localize(77,null),g.localize(78,null),g.localize(79,null)]}];super(86,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:X.strings,description:g.localize(80,null)},comments:{anyOf:Ee,default:X.comments,description:g.localize(81,null)},other:{anyOf:Ee,default:X.other,description:g.localize(82,null)}},default:X,markdownDescription:g.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const wt=X?"on":"off";return{comments:wt,strings:wt,other:wt}}if(!X||typeof X!="object")return this.defaultValue;const{other:Ee,comments:Ue,strings:Ne}=X,Qe=["on","inline","off"];let et,nt,ft;return typeof Ee=="boolean"?et=Ee?"on":"off":et=o(Ee,this.defaultValue.other,Qe),typeof Ue=="boolean"?nt=Ue?"on":"off":nt=o(Ue,this.defaultValue.comments,Qe),typeof Ne=="boolean"?ft=Ne?"on":"off":ft=o(Ne,this.defaultValue.strings,Qe),{other:et,comments:nt,strings:ft}}}var Q;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(Q||(e.RenderLineNumbersType=Q={}));class le extends k{constructor(){super(65,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(84,null),g.localize(85,null),g.localize(86,null),g.localize(87,null)],default:"on",description:g.localize(88,null)})}validate(X){let Ee=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(Ee=4,Ue=X):X==="interval"?Ee=3:X==="relative"?Ee=2:X==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Ue}}}function se(J){const X=J.get(95);return X==="editable"?J.get(88):X!=="on"}e.filterValidationDecorations=se;class oe extends k{constructor(){const X=[],Ee={type:"number",description:g.localize(89,null)};super(99,"rulers",X,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:g.localize(90,null),format:"color-hex"}}}]},default:X,description:g.localize(91,null)})}validate(X){if(Array.isArray(X)){const Ee=[];for(const Ue of X)if(typeof Ue=="number")Ee.push({column:b.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const Ne=Ue;Ee.push({column:b.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return Ee.sort((Ue,Ne)=>Ue.column-Ne.column),Ee}return this.defaultValue}}class F extends k{constructor(){super(89,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function j(J,X){if(typeof J!="string")return X;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class Y extends k{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(100,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(92,null),g.localize(93,null),g.localize(94,null)],default:"auto",description:g.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(96,null),g.localize(97,null),g.localize(98,null)],default:"auto",description:g.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:g.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:g.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:g.localize(102,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ee=X,Ue=b.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=b.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:j(Ee.vertical,this.defaultValue.vertical),horizontal:j(Ee.horizontal,this.defaultValue.horizontal),useShadows:i(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:b.clampedInt(Ee.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:b.clampedInt(Ee.verticalSliderSize,Ne,0,1e3),scrollByPage:i(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Z extends k{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(122,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:g.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:g.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:g.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:g.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:g.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:g.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:g.localize(109,null)}})}applyUpdate(X,Ee){let Ue=!1;Ee.allowedCharacters&&X&&(T.equals(X.allowedCharacters,Ee.allowedCharacters)||(X={...X,allowedCharacters:Ee.allowedCharacters},Ue=!0)),Ee.allowedLocales&&X&&(T.equals(X.allowedLocales,Ee.allowedLocales)||(X={...X,allowedLocales:Ee.allowedLocales},Ue=!0));const Ne=super.applyUpdate(X,Ee);return Ue?new w(Ne.newValue,!0):Ne}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ee=X;return{nonBasicASCII:ke(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ke(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ke(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(X.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(X,Ee){if(typeof X!="object"||!X)return Ee;const Ue={};for(const[Ne,Qe]of Object.entries(X))Qe===!0&&(Ue[Ne]=!0);return Ue}}class me extends k{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(60,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:g.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover"],enumDescriptions:[g.localize(111,null),g.localize(112,null)],description:g.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:g.localize(114,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ee=X;return{enabled:i(Ee.enabled,this.defaultValue.enabled),mode:o(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:o(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:i(Ee.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Ee.keepOnBlur,this.defaultValue.keepOnBlur)}}}class _e extends k{constructor(){const X={enabled:L.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(13,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:g.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:g.localize(116,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ee=X;return{enabled:i(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class fe extends k{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(14,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(117,null),g.localize(118,null),g.localize(119,null)],default:X.bracketPairs,description:g.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(121,null),g.localize(122,null),g.localize(123,null)],default:X.bracketPairsHorizontal,description:g.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:g.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:g.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[g.localize(127,null),g.localize(128,null),g.localize(129,null)],default:X.highlightActiveIndentation,description:g.localize(130,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ee=X;return{bracketPairs:ke(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ke(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:ke(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ke(J,X,Ee){const Ue=Ee.indexOf(J);return Ue===-1?X:Ee[Ue]}class Pe extends k{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(115,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(131,null),g.localize(132,null)],default:X.insertMode,description:g.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:g.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:g.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:g.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[g.localize(137,null),g.localize(138,null),g.localize(139,null),g.localize(140,null)],default:X.selectionMode,markdownDescription:g.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:g.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:g.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:g.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:g.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:g.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:g.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(178,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ee=X;return{insertMode:o(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:o(Ee.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:i(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:i(Ee.preview,this.defaultValue.preview),previewMode:o(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Ee.showMethods,this.defaultValue.showMethods),showFunctions:i(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Ee.showFields,this.defaultValue.showFields),showVariables:i(Ee.showVariables,this.defaultValue.showVariables),showClasses:i(Ee.showClasses,this.defaultValue.showClasses),showStructs:i(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:i(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Ee.showModules,this.defaultValue.showModules),showProperties:i(Ee.showProperties,this.defaultValue.showProperties),showEvents:i(Ee.showEvents,this.defaultValue.showEvents),showOperators:i(Ee.showOperators,this.defaultValue.showOperators),showUnits:i(Ee.showUnits,this.defaultValue.showUnits),showValues:i(Ee.showValues,this.defaultValue.showValues),showConstants:i(Ee.showConstants,this.defaultValue.showConstants),showEnums:i(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Ee.showKeywords,this.defaultValue.showKeywords),showWords:i(Ee.showWords,this.defaultValue.showWords),showColors:i(Ee.showColors,this.defaultValue.showColors),showFiles:i(Ee.showFiles,this.defaultValue.showFiles),showReferences:i(Ee.showReferences,this.defaultValue.showReferences),showFolders:i(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:i(Ee.showUsers,this.defaultValue.showUsers),showIssues:i(Ee.showIssues,this.defaultValue.showIssues)}}}class $e extends k{constructor(){super(110,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(179,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:g.localize(180,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(X.selectSubwords,this.defaultValue.selectSubwords)}}}var He;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class tt extends k{constructor(){super(134,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[g.localize(181,null),g.localize(182,null),g.localize(183,null),g.localize(184,null)],description:g.localize(185,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,Ee,Ue){return Ee.get(2)===2?0:Ue}}class Ge extends I{constructor(){super(142)}compute(X,Ee,Ue){const Ne=Ee.get(141);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class Ke extends k{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(34,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:g.localize(186,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:g.localize(187,null),enum:["afterDrop","never"],enumDescriptions:[g.localize(188,null),g.localize(189,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ee=X;return{enabled:i(Ee.enabled,this.defaultValue.enabled),showDropSelector:o(Ee.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends k{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(82,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:g.localize(190,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:g.localize(191,null),enum:["afterPaste","never"],enumDescriptions:[g.localize(192,null),g.localize(193,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ee=X;return{enabled:i(Ee.enabled,this.defaultValue.enabled),showPasteSelector:o(Ee.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const at="Consolas, 'Courier New', monospace",Ze="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:d.isMacintosh?Ze:d.isLinux?rt:at,fontWeight:"normal",fontSize:d.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function he(J){return e.editorOptionsRegistry[J.id]=J,J}var Oe;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",J[J.autoClosingDelete=7]="autoClosingDelete",J[J.autoClosingOvertype=8]="autoClosingOvertype",J[J.autoClosingQuotes=9]="autoClosingQuotes",J[J.autoIndent=10]="autoIndent",J[J.automaticLayout=11]="automaticLayout",J[J.autoSurround=12]="autoSurround",J[J.bracketPairColorization=13]="bracketPairColorization",J[J.guides=14]="guides",J[J.codeLens=15]="codeLens",J[J.codeLensFontFamily=16]="codeLensFontFamily",J[J.codeLensFontSize=17]="codeLensFontSize",J[J.colorDecorators=18]="colorDecorators",J[J.colorDecoratorsLimit=19]="colorDecoratorsLimit",J[J.columnSelection=20]="columnSelection",J[J.comments=21]="comments",J[J.contextmenu=22]="contextmenu",J[J.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",J[J.cursorBlinking=24]="cursorBlinking",J[J.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",J[J.cursorStyle=26]="cursorStyle",J[J.cursorSurroundingLines=27]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",J[J.cursorWidth=29]="cursorWidth",J[J.disableLayerHinting=30]="disableLayerHinting",J[J.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",J[J.domReadOnly=32]="domReadOnly",J[J.dragAndDrop=33]="dragAndDrop",J[J.dropIntoEditor=34]="dropIntoEditor",J[J.emptySelectionClipboard=35]="emptySelectionClipboard",J[J.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",J[J.extraEditorClassName=37]="extraEditorClassName",J[J.fastScrollSensitivity=38]="fastScrollSensitivity",J[J.find=39]="find",J[J.fixedOverflowWidgets=40]="fixedOverflowWidgets",J[J.folding=41]="folding",J[J.foldingStrategy=42]="foldingStrategy",J[J.foldingHighlight=43]="foldingHighlight",J[J.foldingImportsByDefault=44]="foldingImportsByDefault",J[J.foldingMaximumRegions=45]="foldingMaximumRegions",J[J.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=47]="fontFamily",J[J.fontInfo=48]="fontInfo",J[J.fontLigatures=49]="fontLigatures",J[J.fontSize=50]="fontSize",J[J.fontWeight=51]="fontWeight",J[J.fontVariations=52]="fontVariations",J[J.formatOnPaste=53]="formatOnPaste",J[J.formatOnType=54]="formatOnType",J[J.glyphMargin=55]="glyphMargin",J[J.gotoLocation=56]="gotoLocation",J[J.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",J[J.hover=58]="hover",J[J.inDiffEditor=59]="inDiffEditor",J[J.inlineSuggest=60]="inlineSuggest",J[J.letterSpacing=61]="letterSpacing",J[J.lightbulb=62]="lightbulb",J[J.lineDecorationsWidth=63]="lineDecorationsWidth",J[J.lineHeight=64]="lineHeight",J[J.lineNumbers=65]="lineNumbers",J[J.lineNumbersMinChars=66]="lineNumbersMinChars",J[J.linkedEditing=67]="linkedEditing",J[J.links=68]="links",J[J.matchBrackets=69]="matchBrackets",J[J.minimap=70]="minimap",J[J.mouseStyle=71]="mouseStyle",J[J.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=73]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",J[J.multiCursorModifier=75]="multiCursorModifier",J[J.multiCursorPaste=76]="multiCursorPaste",J[J.multiCursorLimit=77]="multiCursorLimit",J[J.occurrencesHighlight=78]="occurrencesHighlight",J[J.overviewRulerBorder=79]="overviewRulerBorder",J[J.overviewRulerLanes=80]="overviewRulerLanes",J[J.padding=81]="padding",J[J.pasteAs=82]="pasteAs",J[J.parameterHints=83]="parameterHints",J[J.peekWidgetDefaultFocus=84]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=85]="definitionLinkOpensInPeek",J[J.quickSuggestions=86]="quickSuggestions",J[J.quickSuggestionsDelay=87]="quickSuggestionsDelay",J[J.readOnly=88]="readOnly",J[J.readOnlyMessage=89]="readOnlyMessage",J[J.renameOnType=90]="renameOnType",J[J.renderControlCharacters=91]="renderControlCharacters",J[J.renderFinalNewline=92]="renderFinalNewline",J[J.renderLineHighlight=93]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=94]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=95]="renderValidationDecorations",J[J.renderWhitespace=96]="renderWhitespace",J[J.revealHorizontalRightPadding=97]="revealHorizontalRightPadding",J[J.roundedSelection=98]="roundedSelection",J[J.rulers=99]="rulers",J[J.scrollbar=100]="scrollbar",J[J.scrollBeyondLastColumn=101]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=102]="scrollBeyondLastLine",J[J.scrollPredominantAxis=103]="scrollPredominantAxis",J[J.selectionClipboard=104]="selectionClipboard",J[J.selectionHighlight=105]="selectionHighlight",J[J.selectOnLineNumbers=106]="selectOnLineNumbers",J[J.showFoldingControls=107]="showFoldingControls",J[J.showUnused=108]="showUnused",J[J.snippetSuggestions=109]="snippetSuggestions",J[J.smartSelect=110]="smartSelect",J[J.smoothScrolling=111]="smoothScrolling",J[J.stickyScroll=112]="stickyScroll",J[J.stickyTabStops=113]="stickyTabStops",J[J.stopRenderingLineAfter=114]="stopRenderingLineAfter",J[J.suggest=115]="suggest",J[J.suggestFontSize=116]="suggestFontSize",J[J.suggestLineHeight=117]="suggestLineHeight",J[J.suggestOnTriggerCharacters=118]="suggestOnTriggerCharacters",J[J.suggestSelection=119]="suggestSelection",J[J.tabCompletion=120]="tabCompletion",J[J.tabIndex=121]="tabIndex",J[J.unicodeHighlighting=122]="unicodeHighlighting",J[J.unusualLineTerminators=123]="unusualLineTerminators",J[J.useShadowDOM=124]="useShadowDOM",J[J.useTabStops=125]="useTabStops",J[J.wordBreak=126]="wordBreak",J[J.wordSeparators=127]="wordSeparators",J[J.wordWrap=128]="wordWrap",J[J.wordWrapBreakAfterCharacters=129]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=130]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=131]="wordWrapColumn",J[J.wordWrapOverride1=132]="wordWrapOverride1",J[J.wordWrapOverride2=133]="wordWrapOverride2",J[J.wrappingIndent=134]="wrappingIndent",J[J.wrappingStrategy=135]="wrappingStrategy",J[J.showDeprecated=136]="showDeprecated",J[J.inlayHints=137]="inlayHints",J[J.editorClassName=138]="editorClassName",J[J.pixelRatio=139]="pixelRatio",J[J.tabFocusMode=140]="tabFocusMode",J[J.layoutInfo=141]="layoutInfo",J[J.wrappingInfo=142]="wrappingInfo",J[J.defaultColorDecorators=143]="defaultColorDecorators",J[J.colorDecoratorsActivatedOn=144]="colorDecoratorsActivatedOn"})(Oe||(e.EditorOption=Oe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:he(new l(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(194,null)})),acceptSuggestionOnEnter:he(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(195,null),""],markdownDescription:g.localize(196,null)})),accessibilitySupport:he(new p),accessibilityPageSize:he(new b(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(197,null),tags:["accessibility"]})),ariaLabel:he(new n(4,"ariaLabel",g.localize(198,null))),screenReaderAnnounceInlineSuggestion:he(new l(6,"screenReaderAnnounceInlineSuggestion",!0,{description:g.localize(199,null),tags:["accessibility"]})),autoClosingBrackets:he(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(200,null),g.localize(201,null),""],description:g.localize(202,null)})),autoClosingDelete:he(new s(7,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(203,null),""],description:g.localize(204,null)})),autoClosingOvertype:he(new s(8,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(205,null),""],description:g.localize(206,null)})),autoClosingQuotes:he(new s(9,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(207,null),g.localize(208,null),""],description:g.localize(209,null)})),autoIndent:he(new t(10,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[g.localize(210,null),g.localize(211,null),g.localize(212,null),g.localize(213,null),g.localize(214,null)],description:g.localize(215,null)})),automaticLayout:he(new l(11,"automaticLayout",!1)),autoSurround:he(new s(12,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(216,null),g.localize(217,null),g.localize(218,null),""],description:g.localize(219,null)})),bracketPairColorization:he(new _e),bracketPairGuides:he(new fe),stickyTabStops:he(new l(113,"stickyTabStops",!1,{description:g.localize(220,null)})),codeLens:he(new l(15,"codeLens",!0,{description:g.localize(221,null)})),codeLensFontFamily:he(new n(16,"codeLensFontFamily","",{description:g.localize(222,null)})),codeLensFontSize:he(new b(17,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(223,null)})),colorDecorators:he(new l(18,"colorDecorators",!0,{description:g.localize(224,null)})),colorDecoratorActivatedOn:he(new s(144,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[g.localize(225,null),g.localize(226,null),g.localize(227,null)],description:g.localize(228,null)})),colorDecoratorsLimit:he(new b(19,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:g.localize(229,null)})),columnSelection:he(new l(20,"columnSelection",!1,{description:g.localize(230,null)})),comments:he(new h),contextmenu:he(new l(22,"contextmenu",!0)),copyWithSyntaxHighlighting:he(new l(23,"copyWithSyntaxHighlighting",!0,{description:g.localize(231,null)})),cursorBlinking:he(new t(24,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],S,{description:g.localize(232,null)})),cursorSmoothCaretAnimation:he(new s(25,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[g.localize(233,null),g.localize(234,null),g.localize(235,null)],description:g.localize(236,null)})),cursorStyle:he(new t(26,"cursorStyle",c.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:g.localize(237,null)})),cursorSurroundingLines:he(new b(27,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(238,null)})),cursorSurroundingLinesStyle:he(new s(28,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(239,null),g.localize(240,null)],description:g.localize(241,null)})),cursorWidth:he(new b(29,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(242,null)})),disableLayerHinting:he(new l(30,"disableLayerHinting",!1)),disableMonospaceOptimizations:he(new l(31,"disableMonospaceOptimizations",!1)),domReadOnly:he(new l(32,"domReadOnly",!1)),dragAndDrop:he(new l(33,"dragAndDrop",!0,{description:g.localize(243,null)})),emptySelectionClipboard:he(new W),dropIntoEditor:he(new Ke),stickyScroll:he(new be),experimentalWhitespaceRendering:he(new s(36,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[g.localize(244,null),g.localize(245,null),g.localize(246,null)],description:g.localize(247,null)})),extraEditorClassName:he(new n(37,"extraEditorClassName","")),fastScrollSensitivity:he(new _(38,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:g.localize(248,null)})),find:he(new $),fixedOverflowWidgets:he(new l(40,"fixedOverflowWidgets",!1)),folding:he(new l(41,"folding",!0,{description:g.localize(249,null)})),foldingStrategy:he(new s(42,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(250,null),g.localize(251,null)],description:g.localize(252,null)})),foldingHighlight:he(new l(43,"foldingHighlight",!0,{description:g.localize(253,null)})),foldingImportsByDefault:he(new l(44,"foldingImportsByDefault",!1,{description:g.localize(254,null)})),foldingMaximumRegions:he(new b(45,"foldingMaximumRegions",5e3,10,65e3,{description:g.localize(255,null)})),unfoldOnClickAfterEndOfLine:he(new l(46,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(256,null)})),fontFamily:he(new n(47,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(257,null)})),fontInfo:he(new q),fontLigatures2:he(new z),fontSize:he(new x),fontWeight:he(new U),fontVariations:he(new N),formatOnPaste:he(new l(53,"formatOnPaste",!1,{description:g.localize(258,null)})),formatOnType:he(new l(54,"formatOnType",!1,{description:g.localize(259,null)})),glyphMargin:he(new l(55,"glyphMargin",!0,{description:g.localize(260,null)})),gotoLocation:he(new de),hideCursorInOverviewRuler:he(new l(57,"hideCursorInOverviewRuler",!1,{description:g.localize(261,null)})),hover:he(new ie),inDiffEditor:he(new l(59,"inDiffEditor",!1)),letterSpacing:he(new _(61,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>_.clamp(J,-5,20),{description:g.localize(262,null)})),lightbulb:he(new ce),lineDecorationsWidth:he(new ge),lineHeight:he(new O),lineNumbers:he(new le),lineNumbersMinChars:he(new b(66,"lineNumbersMinChars",5,1,300)),linkedEditing:he(new l(67,"linkedEditing",!1,{description:g.localize(263,null)})),links:he(new l(68,"links",!0,{description:g.localize(264,null)})),matchBrackets:he(new s(69,"matchBrackets","always",["always","near","never"],{description:g.localize(265,null)})),minimap:he(new K),mouseStyle:he(new s(71,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:he(new _(72,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:g.localize(266,null)})),mouseWheelZoom:he(new l(73,"mouseWheelZoom",!1,{markdownDescription:g.localize(267,null)})),multiCursorMergeOverlapping:he(new l(74,"multiCursorMergeOverlapping",!0,{description:g.localize(268,null)})),multiCursorModifier:he(new t(75,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],we,{markdownEnumDescriptions:[g.localize(269,null),g.localize(270,null)],markdownDescription:g.localize(271,null)})),multiCursorPaste:he(new s(76,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(272,null),g.localize(273,null)],markdownDescription:g.localize(274,null)})),multiCursorLimit:he(new b(77,"multiCursorLimit",1e4,1,1e5,{markdownDescription:g.localize(275,null)})),occurrencesHighlight:he(new l(78,"occurrencesHighlight",!0,{description:g.localize(276,null)})),overviewRulerBorder:he(new l(79,"overviewRulerBorder",!0,{description:g.localize(277,null)})),overviewRulerLanes:he(new b(80,"overviewRulerLanes",3,0,3)),padding:he(new Ce),pasteAs:he(new st),parameterHints:he(new ee),peekWidgetDefaultFocus:he(new s(84,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(278,null),g.localize(279,null)],description:g.localize(280,null)})),definitionLinkOpensInPeek:he(new l(85,"definitionLinkOpensInPeek",!1,{description:g.localize(281,null)})),quickSuggestions:he(new ue),quickSuggestionsDelay:he(new b(87,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(282,null)})),readOnly:he(new l(88,"readOnly",!1)),readOnlyMessage:he(new F),renameOnType:he(new l(90,"renameOnType",!1,{description:g.localize(283,null),markdownDeprecationMessage:g.localize(284,null)})),renderControlCharacters:he(new l(91,"renderControlCharacters",!0,{description:g.localize(285,null),restricted:!0})),renderFinalNewline:he(new s(92,"renderFinalNewline",d.isLinux?"dimmed":"on",["off","on","dimmed"],{description:g.localize(286,null)})),renderLineHighlight:he(new s(93,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(287,null)],description:g.localize(288,null)})),renderLineHighlightOnlyWhenFocus:he(new l(94,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(289,null)})),renderValidationDecorations:he(new s(95,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:he(new s(96,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(290,null),g.localize(291,null),g.localize(292,null),""],description:g.localize(293,null)})),revealHorizontalRightPadding:he(new b(97,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:he(new l(98,"roundedSelection",!0,{description:g.localize(294,null)})),rulers:he(new oe),scrollbar:he(new Y),scrollBeyondLastColumn:he(new b(101,"scrollBeyondLastColumn",4,0,1073741824,{description:g.localize(295,null)})),scrollBeyondLastLine:he(new l(102,"scrollBeyondLastLine",!0,{description:g.localize(296,null)})),scrollPredominantAxis:he(new l(103,"scrollPredominantAxis",!0,{description:g.localize(297,null)})),selectionClipboard:he(new l(104,"selectionClipboard",!0,{description:g.localize(298,null),included:d.isLinux})),selectionHighlight:he(new l(105,"selectionHighlight",!0,{description:g.localize(299,null)})),selectOnLineNumbers:he(new l(106,"selectOnLineNumbers",!0)),showFoldingControls:he(new s(107,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[g.localize(300,null),g.localize(301,null),g.localize(302,null)],description:g.localize(303,null)})),showUnused:he(new l(108,"showUnused",!0,{description:g.localize(304,null)})),showDeprecated:he(new l(136,"showDeprecated",!0,{description:g.localize(305,null)})),inlayHints:he(new Se),snippetSuggestions:he(new s(109,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(306,null),g.localize(307,null),g.localize(308,null),g.localize(309,null)],description:g.localize(310,null)})),smartSelect:he(new $e),smoothScrolling:he(new l(111,"smoothScrolling",!1,{description:g.localize(311,null)})),stopRenderingLineAfter:he(new b(114,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:he(new Pe),inlineSuggest:he(new me),suggestFontSize:he(new b(116,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(312,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:he(new b(117,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(313,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:he(new l(118,"suggestOnTriggerCharacters",!0,{description:g.localize(314,null)})),suggestSelection:he(new s(119,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(315,null),g.localize(316,null),g.localize(317,null)],description:g.localize(318,null)})),tabCompletion:he(new s(120,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(319,null),g.localize(320,null),g.localize(321,null)],description:g.localize(322,null)})),tabIndex:he(new b(121,"tabIndex",0,-1,1073741824)),unicodeHighlight:he(new Z),unusualLineTerminators:he(new s(123,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(323,null),g.localize(324,null),g.localize(325,null)],description:g.localize(326,null)})),useShadowDOM:he(new l(124,"useShadowDOM",!0)),useTabStops:he(new l(125,"useTabStops",!0,{description:g.localize(327,null)})),wordBreak:he(new s(126,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[g.localize(328,null),g.localize(329,null)],description:g.localize(330,null)})),wordSeparators:he(new n(127,"wordSeparators",R.USUAL_WORD_SEPARATORS,{description:g.localize(331,null)})),wordWrap:he(new s(128,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(332,null),g.localize(333,null),g.localize(334,null),g.localize(335,null)],description:g.localize(336,null)})),wordWrapBreakAfterCharacters:he(new n(129,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:he(new n(130,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:he(new b(131,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(337,null)})),wordWrapOverride1:he(new s(132,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:he(new s(133,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:he(new M),defaultColorDecorators:he(new l(143,"defaultColorDecorators",!1,{markdownDescription:g.localize(338,null)})),pixelRatio:he(new te),tabFocusMode:he(new l(140,"tabFocusMode",!1,{markdownDescription:g.localize(339,null)})),layoutInfo:he(new H),wrappingInfo:he(new Ge),wrappingIndent:he(new tt),wrappingStrategy:he(new V)}}),define(De[176],Ie([13,14]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[177],Ie([13,14]),function(re,e){return re.create("vs/platform/contextkey/common/contextkey",e)}),define(De[178],Ie([13,14]),function(re,e){return re.create("vs/platform/contextkey/common/scanner",e)}),define(De[179],Ie([13,14]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[180],Ie([13,14]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[181],Ie([13,14]),function(re,e){return re.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[182],Ie([13,14]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(De[183],Ie([13,14]),function(re,e){return re.create("vs/platform/files/common/io",e)}),define(De[184],Ie([13,14]),function(re,e){return re.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[185],Ie([13,14]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(De[186],Ie([13,14]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(De[187],Ie([13,14]),function(re,e){return re.create("vs/platform/workspace/common/workspace",e)}),define(De[188],Ie([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostChat",e)}),define(De[189],Ie([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[190],Ie([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[191],Ie([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[192],Ie([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostLogService",e)}),define(De[193],Ie([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(De[194],Ie([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[195],Ie([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[196],Ie([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[197],Ie([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[198],Ie([13,14]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[199],Ie([13,14]),function(re,e){return re.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[200],Ie([13,14]),function(re,e){return re.create("vs/workbench/api/node/extHostTunnelService",e)}),define(De[201],Ie([13,14]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(De[202],Ie([13,14]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(De[203],Ie([13,14]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[204],Ie([13,14]),function(re,e){return re.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[205],Ie([13,14]),function(re,e){return re.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[206],Ie([13,14]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[207],Ie([13,14]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[208],Ie([13,14]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[209],Ie([13,14]),function(re,e){return re.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[210],Ie([13,14]),function(re,e){return re.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[211],Ie([1,0,8,178]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var d;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(d||(e.TokenType=d={}));function L(...m){switch(m.length){case 1:return(0,T.localize)(0,null,m[0]);case 2:return(0,T.localize)(1,null,m[0],m[1]);case 3:return(0,T.localize)(2,null,m[0],m[1],m[2]);default:return}}const R=(0,T.localize)(3,null),g=(0,T.localize)(4,null);class y{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,v.illegalState)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(A){return this._input=A,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const k=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:k})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const k=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:k})}else this._match(126)?this._addToken(9):this._error(L("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(L("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(A){return this._isAtEnd()||this._input.charCodeAt(this._current)!==A?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(A){this._tokens.push({type:A,offset:this._start})}_error(A){const k=this._start,w=this._input.substring(this._start,this._current),D={type:19,offset:this._start,lexeme:w};this._errors.push({offset:k,lexeme:w,additionalInfo:A}),this._tokens.push(D)}_string(){this.stringRe.lastIndex=this._start;const A=this.stringRe.exec(this._input);if(A){this._current=this._start+A[0].length;const k=this._input.substring(this._start,this._current),w=y._keywords.get(k);w?this._addToken(w):this._tokens.push({type:17,lexeme:k,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let A=this._current,k=!1,w=!1;for(;;){if(A>=this._input.length){this._current=A,this._error(g);return}const I=this._input.charCodeAt(A);if(k)k=!1;else if(I===47&&!w){A++;break}else I===91?w=!0:I===92?k=!0:I===93&&(w=!1);A++}for(;A<this._input.length&&y._regexFlags.has(this._input.charCodeAt(A));)A++;this._current=A;const D=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:D,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=y,y._regexFlags=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0))),y._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(De[212],Ie([1,0,23,40,180,346]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,g=/^-(\d{4})(\d{2})(\d{2})$/;function y(l){return l=l.trim(),l==="*"||R.test(l)}e.isValidVersionStr=y;function m(l){if(!y(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=l.match(R);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.parseVersion=m;function A(l){if(!l)return null;const a=l.majorBase,b=l.majorMustEqual,f=l.minorBase;let _=l.minorMustEqual;const n=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(a===0||(_=!1),o=!1);let s=0;if(l.preRelease){const t=g.exec(l.preRelease);if(t){const[,u,p,h]=t;s=Date.UTC(Number(u),Number(p)-1,Number(h))}}return{majorBase:a,majorMustEqual:b,minorBase:f,minorMustEqual:_,patchBase:n,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:s}}e.normalizeVersion=A;function k(l,a,b){let f;typeof l=="string"?f=A(m(l)):f=l;let _;a instanceof Date?_=a.getTime():typeof a=="string"&&(_=new Date(a).getTime());let n;if(typeof b=="string"?n=A(m(b)):n=b,!f||!n)return!1;const o=f.majorBase,s=f.minorBase,t=f.patchBase;let u=n.majorBase,p=n.minorBase,h=n.patchBase;const C=n.notBefore;let S=n.majorMustEqual,c=n.minorMustEqual,r=n.patchMustEqual;return n.isMinimum?o>u?!0:o<u?!1:s>p?!0:s<p||_&&_<C?!1:t>=h:(o===1&&u===0&&(!S||!c||!r)&&(u=1,p=0,h=0,S=!0,c=!1,r=!1),o<u?!1:o>u?!S:s<p?!1:s>p?!c:t<h?!1:t>h?!r:!(_&&_<C))}e.isValidVersion=k;function w(l,a,b,f,_){const n=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return n.push([T.default.Error,d.localize(0,null)]),n;if(typeof f.name!="string")return n.push([T.default.Error,d.localize(1,null,"name")]),n;if(typeof f.version!="string")return n.push([T.default.Error,d.localize(2,null,"version")]),n;if(!f.engines)return n.push([T.default.Error,d.localize(3,null,"engines")]),n;if(typeof f.engines.vscode!="string")return n.push([T.default.Error,d.localize(4,null,"engines.vscode")]),n;if(typeof f.extensionDependencies<"u"&&!i(f.extensionDependencies))return n.push([T.default.Error,d.localize(5,null,"extensionDependencies")]),n;if(typeof f.activationEvents<"u"){if(!i(f.activationEvents))return n.push([T.default.Error,d.localize(6,null,"activationEvents")]),n;if(typeof f.main>"u"&&typeof f.browser>"u")return n.push([T.default.Error,d.localize(7,null,"activationEvents","main","browser")]),n}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&n.push([T.default.Warning,d.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return n.push([T.default.Error,d.localize(9,null,"main")]),n;{const t=(0,v.joinPath)(b,f.main);(0,v.isEqualOrParent)(t,b)||n.push([T.default.Warning,d.localize(10,null,t.path,b.path)])}}if(typeof f.browser<"u"){if(typeof f.browser!="string")return n.push([T.default.Error,d.localize(11,null,"browser")]),n;{const t=(0,v.joinPath)(b,f.browser);(0,v.isEqualOrParent)(t,b)||n.push([T.default.Warning,d.localize(12,null,t.path,b.path)])}}if(!L.valid(f.version))return n.push([T.default.Error,d.localize(13,null)]),n;const o=[];if(!D(l,a,f,_,o))for(const t of o)n.push([T.default.Error,t]);return n}e.validateExtensionManifest=w;function D(l,a,b,f,_){return f||typeof b.main>"u"&&typeof b.browser>"u"?!0:E(l,a,b.engines.vscode,_)}e.isValidExtensionVersion=D;function I(l,a,b){return l==="*"||E(a,b,l)}e.isEngineValid=I;function E(l,a,b,f=[]){const _=A(m(b));if(!_)return f.push(d.localize(14,null,b)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return f.push(d.localize(15,null,b)),!1}else if(!_.majorMustEqual)return f.push(d.localize(16,null,b)),!1;return k(l,a,_)?!0:(f.push(d.localize(17,null,l,b)),!1)}function i(l){if(!Array.isArray(l))return!1;for(let a=0,b=l.length;a<b;a++)if(typeof l[a]!="string")return!1;return!0}}),define(De[97],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(d,L=[],R=!1){this.ctor=d,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=v}),define(De[98],Ie([1,0,97]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const T=[];var d;(function(g){g[g.Eager=0]="Eager",g[g.Delayed=1]="Delayed"})(d||(e.InstantiationType=d={}));function L(g,y,m){y instanceof v.SyncDescriptor||(y=new v.SyncDescriptor(y,[],!!m)),T.push([g,y])}e.registerSingleton=L;function R(){return T}e.getSingletonServiceDescriptors=R}),define(De[213],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=v;class T{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const R of this._nodes.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const g=this.lookupOrInsertNode(L),y=this.lookupOrInsertNode(R);g.outgoing.set(y.key,y),y.incoming.set(g.key,g)}removeNode(L){const R=this._hashFn(L);this._nodes.delete(R);for(const g of this._nodes.values())g.outgoing.delete(R),g.incoming.delete(R)}lookupOrInsertNode(L){const R=this._hashFn(L);let g=this._nodes.get(R);return g||(g=new v(R,L),this._nodes.set(R,g)),g}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[R,g]of this._nodes)L.push(`${R}
	(-> incoming)[${[...g.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...g.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this._nodes){const g=new Set([L]),y=this._findCycle(R,g);if(y)return y}}_findCycle(L,R){for(const[g,y]of L.outgoing){if(R.has(g))return[...R,g].join(" -> ");R.add(g);const m=this._findCycle(y,R);if(m)return m;R.delete(g)}}}e.Graph=T}),define(De[5],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function g(y){return y[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=g})(v||(e._util=v={})),e.IInstantiationService=d("instantiationService");function T(R,g,y){g[v.DI_TARGET]===g?g[v.DI_DEPENDENCIES].push({id:R,index:y}):(g[v.DI_DEPENDENCIES]=[{id:R,index:y}],g[v.DI_TARGET]=g)}function d(R){if(v.serviceIds.has(R))return v.serviceIds.get(R);const g=function(y,m,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(g,y,A)};return g.toString=()=>R,v.serviceIds.set(R,g),g}e.createDecorator=d;function L(R){return R}e.refineServiceDecorator=L}),define(De[57],Ie([1,0,12,2,5]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,d.createDecorator)("configurationService");function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof T.URI)}e.isConfigurationOverrides=L;function R(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=R;var g;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(g||(e.ConfigurationTarget=g={}));function y(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function m(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.isConfigured=m;function A(l,a){const b=Object.create(null);for(const f in l)k(b,f,l[f],a);return b}e.toValuesTree=A;function k(l,a,b,f){const _=a.split("."),n=_.pop();let o=l;for(let s=0;s<_.length;s++){const t=_[s];let u=o[t];switch(typeof u){case"undefined":u=o[t]=Object.create(null);break;case"object":break;default:f(`Ignoring ${a} as ${_.slice(0,s+1).join(".")} is ${JSON.stringify(u)}`);return}o=u}if(typeof o=="object"&&o!==null)try{o[n]=b}catch{f(`Ignoring ${a} as ${_.join(".")} is ${JSON.stringify(o)}`)}else f(`Ignoring ${a} as ${_.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=k;function w(l,a){const b=a.split(".");D(l,b)}e.removeFromValueTree=w;function D(l,a){const b=a.shift();if(a.length===0){delete l[b];return}if(Object.keys(l).indexOf(b)!==-1){const f=l[b];typeof f=="object"&&!Array.isArray(f)&&(D(f,a),Object.keys(f).length===0&&delete l[b])}}function I(l,a,b){function f(o,s){let t=o;for(const u of s){if(typeof t!="object"||t===null)return;t=t[u]}return t}const _=a.split("."),n=f(l,_);return typeof n>"u"?b:n}e.getConfigurationValue=I;function E(l,a,b){Object.keys(a).forEach(f=>{f!=="__proto__"&&(f in l?v.isObject(l[f])&&v.isObject(a[f])?E(l[f],a[f],b):b&&(l[f]=a[f]):l[f]=a[f])})}e.merge=E;function i(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=i}),define(De[47],Ie([1,0,10,9,211,5,177,8]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",v.isMacintosh),y.set("isLinux",v.isLinux),y.set("isWindows",v.isWindows),y.set("isWeb",v.isWeb),y.set("isMacNative",v.isMacintosh&&!v.isWeb),y.set("isEdge",v.isEdge),y.set("isFirefox",v.isFirefox),y.set("isChrome",v.isChrome),y.set("isSafari",v.isSafari);function m(ge,O){if(y.get(ge)!==void 0)throw(0,g.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(ge,O)}e.setConstant=m;const A=Object.prototype.hasOwnProperty;var k;(function(ge){ge[ge.False=0]="False",ge[ge.True=1]="True",ge[ge.Defined=2]="Defined",ge[ge.Not=3]="Not",ge[ge.Equals=4]="Equals",ge[ge.NotEquals=5]="NotEquals",ge[ge.And=6]="And",ge[ge.Regex=7]="Regex",ge[ge.NotRegex=8]="NotRegex",ge[ge.Or=9]="Or",ge[ge.In=10]="In",ge[ge.NotIn=11]="NotIn",ge[ge.Greater=12]="Greater",ge[ge.GreaterEquals=13]="GreaterEquals",ge[ge.Smaller=14]="Smaller",ge[ge.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const w={regexParsingWithErrorRecovery:!0},D=(0,R.localize)(0,null),I=(0,R.localize)(1,null),E=(0,R.localize)(2,null),i=(0,R.localize)(3,null),l=(0,R.localize)(4,null),a=(0,R.localize)(5,null),b=(0,R.localize)(6,null),f=(0,R.localize)(7,null);class _{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(O=w){this._config=O,this._scanner=new d.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(O){if(O===""){this._parsingErrors.push({message:D,offset:0,lexeme:"",additionalInfo:I});return}this._tokens=this._scanner.reset(O).scan(),this._current=0,this._parsingErrors=[];try{const K=this._expr();if(!this._isAtEnd()){const we=this._peek(),Ce=we.type===17?a:void 0;throw this._parsingErrors.push({message:l,offset:we.offset,lexeme:d.Scanner.getLexeme(we),additionalInfo:Ce}),_._parseError}return K}catch(K){if(K!==_._parseError)throw K;return}}_expr(){return this._or()}_or(){const O=[this._and()];for(;this._matchOne(16);){const K=this._and();O.push(K)}return O.length===1?O[0]:n.or(...O)}_and(){const O=[this._term()];for(;this._matchOne(15);){const K=this._term();O.push(K)}return O.length===1?O[0]:n.and(...O)}_term(){if(this._matchOne(2)){const O=this._peek();switch(O.type){case 11:return this._advance(),u.INSTANCE;case 12:return this._advance(),p.INSTANCE;case 0:{this._advance();const K=this._expr();return this._consume(1,i),K?.negate()}case 17:return this._advance(),P.create(O.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",O)}}return this._primary()}_primary(){const O=this._peek();switch(O.type){case 11:return this._advance(),n.true();case 12:return this._advance(),n.false();case 0:{this._advance();const K=this._expr();return this._consume(1,i),K}case 17:{const K=O.lexeme;if(this._advance(),this._matchOne(9)){const Ce=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Ce.type!==10)throw this._errExpectedButGot("REGEX",Ce);const ee=Ce.lexeme,te=ee.lastIndexOf("/"),ue=te===ee.length-1?void 0:this._removeFlagsGY(ee.substring(te+1));let Q;try{Q=new RegExp(ee.substring(1,te),ue)}catch{throw this._errExpectedButGot("REGEX",Ce)}return q.create(K,Q)}switch(Ce.type){case 10:case 19:{const ee=[Ce.lexeme];this._advance();let te=this._peek(),ue=0;for(let F=0;F<Ce.lexeme.length;F++)Ce.lexeme.charCodeAt(F)===40?ue++:Ce.lexeme.charCodeAt(F)===41&&ue--;for(;!this._isAtEnd()&&te.type!==15&&te.type!==16;){switch(te.type){case 0:ue++;break;case 1:ue--;break;case 10:case 18:for(let F=0;F<te.lexeme.length;F++)te.lexeme.charCodeAt(F)===40?ue++:Ce.lexeme.charCodeAt(F)===41&&ue--}if(ue<0)break;ee.push(d.Scanner.getLexeme(te)),this._advance(),te=this._peek()}const Q=ee.join(""),le=Q.lastIndexOf("/"),se=le===Q.length-1?void 0:this._removeFlagsGY(Q.substring(le+1));let oe;try{oe=new RegExp(Q.substring(1,le),se)}catch{throw this._errExpectedButGot("REGEX",Ce)}return n.regex(K,oe)}case 18:{const ee=Ce.lexeme;this._advance();let te=null;if(!(0,T.isFalsyOrWhitespace)(ee)){const ue=ee.indexOf("/"),Q=ee.lastIndexOf("/");if(ue!==Q&&ue>=0){const le=ee.slice(ue+1,Q),se=ee[Q+1]==="i"?"i":"";try{te=new RegExp(le,se)}catch{throw this._errExpectedButGot("REGEX",Ce)}}}if(te===null)throw this._errExpectedButGot("REGEX",Ce);return q.create(K,te)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,E);const Ce=this._value();return n.notIn(K,Ce)}switch(this._peek().type){case 3:{this._advance();const Ce=this._value();if(this._previous().type===18)return n.equals(K,Ce);switch(Ce){case"true":return n.has(K);case"false":return n.not(K);default:return n.equals(K,Ce)}}case 4:{this._advance();const Ce=this._value();if(this._previous().type===18)return n.notEquals(K,Ce);switch(Ce){case"true":return n.not(K);case"false":return n.has(K);default:return n.notEquals(K,Ce)}}case 5:return this._advance(),z.create(K,this._value());case 6:return this._advance(),N.create(K,this._value());case 7:return this._advance(),W.create(K,this._value());case 8:return this._advance(),$.create(K,this._value());case 13:return this._advance(),n.in(K,this._value());default:return n.has(K)}}case 20:throw this._parsingErrors.push({message:b,offset:O.offset,lexeme:"",additionalInfo:f}),_._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const O=this._peek();switch(O.type){case 17:case 18:return this._advance(),O.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(O){return O.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(O){return this._check(O)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(O,K){if(this._check(O))return this._advance();throw this._errExpectedButGot(K,this._peek())}_errExpectedButGot(O,K,we){const Ce=(0,R.localize)(8,null,O,d.Scanner.getLexeme(K)),ee=K.offset,te=d.Scanner.getLexeme(K);return this._parsingErrors.push({message:Ce,offset:ee,lexeme:te,additionalInfo:we}),_._parseError}_check(O){return this._peek().type===O}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=_,_._parseError=new Error;class n{static false(){return u.INSTANCE}static true(){return p.INSTANCE}static has(O){return h.create(O)}static equals(O,K){return C.create(O,K)}static notEquals(O,K){return r.create(O,K)}static regex(O,K){return q.create(O,K)}static in(O,K){return S.create(O,K)}static notIn(O,K){return c.create(O,K)}static not(O){return P.create(O)}static and(...O){return de.create(O,null,!0)}static or(...O){return ie.create(O,null,!0)}static greater(O,K){return W.create(O,K)}static greaterEquals(O,K){return $.create(O,K)}static smaller(O,K){return z.create(O,K)}static smallerEquals(O,K){return N.create(O,K)}static deserialize(O){return O==null?void 0:this._parser.parse(O)}}e.ContextKeyExpr=n,n._parser=new _({regexParsingWithErrorRecovery:!1});function o(ge){const O=new _({regexParsingWithErrorRecovery:!1});return ge.map(K=>(O.parse(K),O.lexingErrors.length>0?O.lexingErrors.map(we=>({errorMessage:we.additionalInfo?(0,R.localize)(9,null,we.additionalInfo):(0,R.localize)(10,null),offset:we.offset,length:we.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(we=>({errorMessage:we.additionalInfo?`${we.message}. ${we.additionalInfo}`:we.message,offset:we.offset,length:we.lexeme.length})):[]))}e.validateWhenClauses=o;function s(ge,O){const K=ge?ge.substituteConstants():void 0,we=O?O.substituteConstants():void 0;return!K&&!we?!0:!K||!we?!1:K.equals(we)}e.expressionsAreEqualWithConstantSubstitution=s;function t(ge,O){return ge.cmp(O)}class u{constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=u,u.INSTANCE=new u;class p{constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return u.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class h{static create(O,K=null){const we=y.get(O);return typeof we=="boolean"?we?p.INSTANCE:u.INSTANCE:new h(O,K)}constructor(O,K){this.key=O,this.negated=K,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:H(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=y.get(this.key);return typeof O=="boolean"?O?p.INSTANCE:u.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.negated||(this.negated=P.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class C{static create(O,K,we=null){if(typeof K=="boolean")return K?h.create(O,we):P.create(O,we);const Ce=y.get(O);return typeof Ce=="boolean"?K===(Ce?"true":"false")?p.INSTANCE:u.INSTANCE:new C(O,K,we)}constructor(O,K,we){this.key=O,this.value=K,this.negated=we,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:V(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){const O=y.get(this.key);if(typeof O=="boolean"){const K=O?"true":"false";return this.value===K?p.INSTANCE:u.INSTANCE}return this}evaluate(O){return O.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(O){return O.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=C;class S{static create(O,K){return new S(O,K)}constructor(O,K){this.key=O,this.valueKey=K,this.type=10,this.negated=null}cmp(O){return O.type!==this.type?this.type-O.type:V(this.key,this.valueKey,O.key,O.valueKey)}equals(O){return O.type===this.type?this.key===O.key&&this.valueKey===O.valueKey:!1}substituteConstants(){return this}evaluate(O){const K=O.getValue(this.valueKey),we=O.getValue(this.key);return Array.isArray(K)?K.includes(we):typeof we=="string"&&typeof K=="object"&&K!==null?A.call(K,we):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(O){return O.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=c.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=S;class c{static create(O,K){return new c(O,K)}constructor(O,K){this.key=O,this.valueKey=K,this.type=11,this._negated=S.create(O,K)}cmp(O){return O.type!==this.type?this.type-O.type:this._negated.cmp(O._negated)}equals(O){return O.type===this.type?this._negated.equals(O._negated):!1}substituteConstants(){return this}evaluate(O){return!this._negated.evaluate(O)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(O){return O.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=c;class r{static create(O,K,we=null){if(typeof K=="boolean")return K?P.create(O,we):h.create(O,we);const Ce=y.get(O);return typeof Ce=="boolean"?K===(Ce?"true":"false")?u.INSTANCE:p.INSTANCE:new r(O,K,we)}constructor(O,K,we){this.key=O,this.value=K,this.negated=we,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:V(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){const O=y.get(this.key);if(typeof O=="boolean"){const K=O?"true":"false";return this.value===K?u.INSTANCE:p.INSTANCE}return this}evaluate(O){return O.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(O){return O.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=r;class P{static create(O,K=null){const we=y.get(O);return typeof we=="boolean"?we?u.INSTANCE:p.INSTANCE:new P(O,K)}constructor(O,K){this.key=O,this.negated=K,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:H(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=y.get(this.key);return typeof O=="boolean"?O?u.INSTANCE:p.INSTANCE:this}evaluate(O){return!O.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(O){return O.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=P;function M(ge,O){if(typeof ge=="string"){const K=parseFloat(ge);isNaN(K)||(ge=K)}return typeof ge=="string"||typeof ge=="number"?O(ge):u.INSTANCE}class W{static create(O,K,we=null){return M(K,Ce=>new W(O,Ce,we))}constructor(O,K,we){this.key=O,this.value=K,this.negated=we,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:V(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(O){return O.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=W;class ${static create(O,K,we=null){return M(K,Ce=>new $(O,Ce,we))}constructor(O,K,we){this.key=O,this.value=K,this.negated=we,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:V(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(O){return O.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=$;class z{static create(O,K,we=null){return M(K,Ce=>new z(O,Ce,we))}constructor(O,K,we){this.key=O,this.value=K,this.negated=we,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:V(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(O){return O.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=z;class N{static create(O,K,we=null){return M(K,Ce=>new N(O,Ce,we))}constructor(O,K,we){this.key=O,this.value=K,this.negated=we,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:V(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(O){return O.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=W.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=N;class q{static create(O,K){return new q(O,K)}constructor(O,K){this.key=O,this.regexp=K,this.type=7,this.negated=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.key<O.key)return-1;if(this.key>O.key)return 1;const K=this.regexp?this.regexp.source:"",we=O.regexp?O.regexp.source:"";return K<we?-1:K>we?1:0}equals(O){if(O.type===this.type){const K=this.regexp?this.regexp.source:"",we=O.regexp?O.regexp.source:"";return this.key===O.key&&K===we}return!1}substituteConstants(){return this}evaluate(O){const K=O.getValue(this.key);return this.regexp?this.regexp.test(K):!1}serialize(){const O=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${O}`}keys(){return[this.key]}map(O){return O.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=x.create(this)),this.negated}}e.ContextKeyRegexExpr=q;class x{static create(O){return new x(O)}constructor(O){this._actual=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this._actual.cmp(O._actual)}equals(O){return O.type===this.type?this._actual.equals(O._actual):!1}substituteConstants(){return this}evaluate(O){return!this._actual.evaluate(O)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(O){return new x(this._actual.map(O))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=x;function U(ge){let O=null;for(let K=0,we=ge.length;K<we;K++){const Ce=ge[K].substituteConstants();if(ge[K]!==Ce&&O===null){O=[];for(let ee=0;ee<K;ee++)O[ee]=ge[ee]}O!==null&&(O[K]=Ce)}return O===null?ge:O}class de{static create(O,K,we){return de._normalizeArr(O,K,we)}constructor(O,K){this.expr=O,this.negated=K,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let K=0,we=this.expr.length;K<we;K++){const Ce=t(this.expr[K],O.expr[K]);if(Ce!==0)return Ce}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let K=0,we=this.expr.length;K<we;K++)if(!this.expr[K].equals(O.expr[K]))return!1;return!0}return!1}substituteConstants(){const O=U(this.expr);return O===this.expr?this:de.create(O,this.negated,!1)}evaluate(O){for(let K=0,we=this.expr.length;K<we;K++)if(!this.expr[K].evaluate(O))return!1;return!0}static _normalizeArr(O,K,we){const Ce=[];let ee=!1;for(const te of O)if(te){if(te.type===1){ee=!0;continue}if(te.type===0)return u.INSTANCE;if(te.type===6){Ce.push(...te.expr);continue}Ce.push(te)}if(Ce.length===0&&ee)return p.INSTANCE;if(Ce.length!==0){if(Ce.length===1)return Ce[0];Ce.sort(t);for(let te=1;te<Ce.length;te++)Ce[te-1].equals(Ce[te])&&(Ce.splice(te,1),te--);if(Ce.length===1)return Ce[0];for(;Ce.length>1;){const te=Ce[Ce.length-1];if(te.type!==9)break;Ce.pop();const ue=Ce.pop(),Q=Ce.length===0,le=ie.create(te.expr.map(se=>de.create([se,ue],null,we)),null,Q);le&&(Ce.push(le),Ce.sort(t))}if(Ce.length===1)return Ce[0];if(we){for(let te=0;te<Ce.length;te++)for(let ue=te+1;ue<Ce.length;ue++)if(Ce[te].negate().equals(Ce[ue]))return u.INSTANCE;if(Ce.length===1)return Ce[0]}return new de(Ce,K)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const K of this.expr)O.push(...K.keys());return O}map(O){return new de(this.expr.map(K=>K.map(O)),null)}negate(){if(!this.negated){const O=[];for(const K of this.expr)O.push(K.negate());this.negated=ie.create(O,this,!0)}return this.negated}}e.ContextKeyAndExpr=de;class ie{static create(O,K,we){return ie._normalizeArr(O,K,we)}constructor(O,K){this.expr=O,this.negated=K,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let K=0,we=this.expr.length;K<we;K++){const Ce=t(this.expr[K],O.expr[K]);if(Ce!==0)return Ce}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let K=0,we=this.expr.length;K<we;K++)if(!this.expr[K].equals(O.expr[K]))return!1;return!0}return!1}substituteConstants(){const O=U(this.expr);return O===this.expr?this:ie.create(O,this.negated,!1)}evaluate(O){for(let K=0,we=this.expr.length;K<we;K++)if(this.expr[K].evaluate(O))return!0;return!1}static _normalizeArr(O,K,we){let Ce=[],ee=!1;if(O){for(let te=0,ue=O.length;te<ue;te++){const Q=O[te];if(Q){if(Q.type===0){ee=!0;continue}if(Q.type===1)return p.INSTANCE;if(Q.type===9){Ce=Ce.concat(Q.expr);continue}Ce.push(Q)}}if(Ce.length===0&&ee)return u.INSTANCE;Ce.sort(t)}if(Ce.length!==0){if(Ce.length===1)return Ce[0];for(let te=1;te<Ce.length;te++)Ce[te-1].equals(Ce[te])&&(Ce.splice(te,1),te--);if(Ce.length===1)return Ce[0];if(we){for(let te=0;te<Ce.length;te++)for(let ue=te+1;ue<Ce.length;ue++)if(Ce[te].negate().equals(Ce[ue]))return p.INSTANCE;if(Ce.length===1)return Ce[0]}return new ie(Ce,K)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const K of this.expr)O.push(...K.keys());return O}map(O){return new ie(this.expr.map(K=>K.map(O)),null)}negate(){if(!this.negated){const O=[];for(const K of this.expr)O.push(K.negate());for(;O.length>1;){const K=O.shift(),we=O.shift(),Ce=[];for(const ee of Se(K))for(const te of Se(we))Ce.push(de.create([ee,te],null,!1));O.unshift(ie.create(Ce,null,!1))}this.negated=ie.create(O,this,!0)}return this.negated}}e.ContextKeyOrExpr=ie;class ne extends h{static all(){return ne._info.values()}constructor(O,K,we){super(O,null),this._defaultValue=K,typeof we=="object"?ne._info.push({...we,key:O}):we!==!0&&ne._info.push({key:O,description:we,type:K!=null?typeof K:void 0})}bindTo(O){return O.createKey(this.key,this._defaultValue)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return C.create(this.key,O)}notEqualsTo(O){return r.create(this.key,O)}}e.RawContextKey=ne,ne._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService");function H(ge,O){return ge<O?-1:ge>O?1:0}function V(ge,O,K,we){return ge<K?-1:ge>K?1:O<we?-1:O>we?1:0}function ce(ge,O){if(ge.type===0||O.type===1)return!0;if(ge.type===9)return O.type===9?be(ge.expr,O.expr):!1;if(O.type===9){for(const K of O.expr)if(ce(ge,K))return!0;return!1}if(ge.type===6){if(O.type===6)return be(O.expr,ge.expr);for(const K of ge.expr)if(ce(K,O))return!0;return!1}return ge.equals(O)}e.implies=ce;function be(ge,O){let K=0,we=0;for(;K<ge.length&&we<O.length;){const Ce=ge[K].cmp(O[we]);if(Ce<0)return!1;Ce===0&&K++,we++}return K===ge.length}function Se(ge){return ge.type===9?ge.expr:[ge]}}),define(De[214],Ie([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(De[125],Ie([1,0,179,5]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function d(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=d;function L(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function R(a,b){switch(a){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":b==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function g(a,b){return b==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=g;function y(a,b,f){return g(b,f)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===f?!0:m(f).includes(a)}e.isTargetPlatformCompatible=y;function m(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function A(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=A;var k;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var w;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var D;(function(a){a.Install="install",a.Uninstall="uninstall"})(D||(e.StatisticType=D={}));var I;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(I||(e.InstallOperation=I={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var E;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));var i;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(i||(e.ExtensionSignaturetErrorCode=i={}));class l extends Error{constructor(b,f){super(b),this.code=f,this.name=f}}e.ExtensionManagementError=l,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,v.localize)(1,null),original:"Preferences"}}),define(De[215],Ie([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(De[216],Ie([1,0,46,16,11,10,93,29,96,181,215]),function(re,e,v,T,d,L,R,g,y,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=m.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:D.getDefaultTerminalWindows(),linux:await E.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class D extends w{openTerminal(f,_){return this.spawnTerminal(v,f,y.getWindowsShell(),_)}spawnTerminal(f,_,n,o){const s=_.windowsExec||D.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const t=d.basename(s,".exe").toLowerCase();if(t==="cmder")return f.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return s.indexOf(" ")>=0&&u.push('""'),u.push(s),t==="wt"&&u.push("-d ."),new Promise((p,h)=>{const C=i(process),S=f.spawn(n,u,{cwd:o,env:C});S.on("error",h),S.on("exit",()=>p())})}runInTerminal(f,_,n,o,s){const t="windowsExec"in s&&s.windowsExec?s.windowsExec:D.getDefaultTerminalWindows();return new Promise((u,p)=>{const h=`"${_} - ${k}"`,C=`""${n.join('" "')}" & pause"`,S=Object.assign({},i(process),o);Object.keys(S).filter(W=>S[W]===null).forEach(W=>delete S[W]);const c={cwd:_,env:S,windowsVerbatimArguments:!0};let r,P;d.basename(t,".exe")==="wt"?(r=t,P=["-d",".",D.CMD,"/c",C]):(r=D.CMD,P=["/c","start",h,"/wait",t,"/c",C]),v.spawn(r,P,c).on("error",W=>{p(l(W))}),u(void 0)})}static getDefaultTerminalWindows(){if(!D._DEFAULT_TERMINAL_WINDOWS){const f=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");D._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${f?"Sysnative":"System32"}\\cmd.exe`}return D._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=D,D.CMD="cmd.exe";class I extends w{openTerminal(f,_){return this.spawnTerminal(v,f,_)}runInTerminal(f,_,n,o,s){const t=s.osxExec||A.DEFAULT_TERMINAL_OSX;return new Promise((u,p)=>{if(t===A.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const h=t===A.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",S=[T.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`).fsPath,"-t",f||k,"-w",_];for(const P of n)S.push("-a"),S.push(P);if(o){const P=Object.assign({},i(process),o);for(const M in P){const W=P[M];W===null?(S.push("-u"),S.push(M)):(S.push("-e"),S.push(`${M}=${W}`))}}let c="";const r=v.spawn(I.OSASCRIPT,S);r.on("error",P=>{p(l(P))}),r.stderr.on("data",P=>{c+=P.toString()}),r.on("exit",P=>{if(P===0)u(void 0);else if(c){const M=c.split(`
`,1);p(new Error(M[0]))}else p(new Error(m.localize(1,null,h,P)))})}else p(new Error(m.localize(2,null,t)))})}spawnTerminal(f,_,n){const o=_.osxExec||A.DEFAULT_TERMINAL_OSX;return new Promise((s,t)=>{const u=["-a",o];n&&u.push(n);const p=i(process),h=f.spawn("/usr/bin/open",u,{cwd:n,env:p});h.on("error",t),h.on("exit",()=>s())})}}e.MacExternalTerminalService=I,I.OSASCRIPT="/usr/bin/osascript";class E extends w{openTerminal(f,_){return this.spawnTerminal(v,f,_)}runInTerminal(f,_,n,o,s){const t=s.linuxExec?Promise.resolve(s.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((u,p)=>{const h=[];t.then(C=>{C.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const S=`${a(n)}; echo; read -p "${E.WAIT_MESSAGE}" -n1;`;h.push(`''${S}''`);const c=Object.assign({},i(process),o);Object.keys(c).filter(W=>c[W]===null).forEach(W=>delete c[W]);const r={cwd:_,env:c};let P="";const M=v.spawn(C,h,r);M.on("error",W=>{p(l(W))}),M.stderr.on("data",W=>{P+=W.toString()}),M.on("exit",W=>{if(W===0)u(void 0);else if(P){const $=P.split(`
`,1);p(new Error($[0]))}else p(new Error(m.localize(4,null,C,W)))})})})}static async getDefaultTerminalLinuxReady(){if(!E._DEFAULT_TERMINAL_LINUX_READY)if(!L.isLinux)E._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const f=await g.Promises.exists("/etc/debian_version");E._DEFAULT_TERMINAL_LINUX_READY=new Promise(_=>{f?_("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?_("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?_("konsole"):process.env.COLORTERM?_(process.env.COLORTERM):process.env.TERM?_(process.env.TERM):_("xterm")})}return E._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(f,_,n){const o=_.linuxExec?Promise.resolve(_.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((s,t)=>{o.then(u=>{const p=i(process),h=f.spawn(u,[],{cwd:n,env:p});h.on("error",t),h.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=E,E.WAIT_MESSAGE=m.localize(3,null);function i(b){const f={...b.env};return(0,R.sanitizeProcessEnvironment)(f),f}function l(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(m.localize(5,null,b.path)):b}function a(b){let f="";for(const _ of b)_.indexOf(" ")>=0?f+='"'+_+'"':f+=_,f+=" ";return f}}),define(De[30],Ie([1,0,71,11,9,12,2,182,5,10,16]),function(re,e,v,T,d,L,R,g,y,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function k(H){return H.create===!0}e.isFileOpenForWriteOptions=k;var w;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var D;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(D||(e.FilePermission=D={}));var I;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(I||(e.FileSystemProviderCapabilities=I={}));function E(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=E;function i(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=i;function l(H){return!!(H.capabilities&131072)}e.hasFileCloneCapability=l;function a(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function b(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=b;function f(H){return E(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=f;function _(H){return E(H)?!!(H.capabilities&32768):!1}e.hasFileAtomicWriteCapability=_;function n(H){return!!(H.capabilities&65536)}e.hasFileAtomicDeleteCapability=n;function o(H){return!!(H.capabilities&2048)}e.hasReadonlyCapability=o;var s;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class t extends Error{static create(V,ce){const be=new t(V.toString(),ce);return h(be,ce),be}constructor(V,ce){super(V),this.code=ce}}e.FileSystemProviderError=t;function u(H,V){return t.create(H,V)}e.createFileSystemProviderError=u;function p(H){return H||u((0,g.localize)(0,null),s.Unknown)}e.ensureFileSystemProviderError=p;function h(H,V){return H.name=V?`${V} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=h;function C(H){if(!H)return s.Unknown;if(H instanceof t)return H.code;const V=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!V)return s.Unknown;switch(V[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.toFileSystemProviderErrorCode=C;function S(H){if(H instanceof $)return H.fileOperationResult;switch(C(H)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=S;var c;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(c||(e.FileOperation=c={}));class r{constructor(V,ce,be){this.resource=V,this.operation=ce,this.target=be}isOperation(V){return this.operation===V}}e.FileOperationEvent=r;var P;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(P||(e.FileChangeType=P={}));class M{constructor(V,ce){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const be=new Map;for(const Se of V){const ge=be.get(Se.type);switch(ge?ge.push([Se.resource,Se]):be.set(Se.type,[[Se.resource,Se]]),Se.type){case 1:this.rawAdded.push(Se.resource);break;case 0:this.rawUpdated.push(Se.resource);break;case 2:this.rawDeleted.push(Se.resource);break}}for(const[Se,ge]of be)switch(Se){case 1:this.added=v.TernarySearchTree.forUris(()=>ce),this.added.fill(ge);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>ce),this.updated.fill(ge);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>ce),this.deleted.fill(ge);break}}contains(V,...ce){return this.doContains(V,{includeChildren:!1},...ce)}affects(V,...ce){return this.doContains(V,{includeChildren:!0},...ce)}doContains(V,ce,...be){if(!V)return!1;const Se=be.length>0;return!!((!Se||be.includes(1))&&(this.added?.get(V)||ce.includeChildren&&this.added?.findSuperstr(V))||(!Se||be.includes(0))&&(this.updated?.get(V)||ce.includeChildren&&this.updated?.findSuperstr(V))||(!Se||be.includes(2))&&(this.deleted?.findSubstr(V)||ce.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=M;function W(H,V,ce){return!H||!V||H===V||V.length>H.length?!1:(V.charAt(V.length-1)!==T.sep&&(V+=T.sep),ce?(0,d.startsWithIgnoreCase)(H,V):H.indexOf(V)===0)}e.isParent=W;class $ extends Error{constructor(V,ce,be){super(V),this.fileOperationResult=ce,this.options=be}}e.FileOperationError=$;class z extends ${constructor(V,ce,be,Se){super(V,ce,Se),this.fileOperationResult=ce,this.size=be}}e.TooLargeFileOperationError=z;class N extends ${constructor(V,ce,be){super(V,2,be),this.stat=ce}}e.NotModifiedSinceFileOperationError=N;var q;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(q||(e.FileOperationResult=q={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var x;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(x||(e.FileKind=x={})),e.ETAG_DISABLED="";function U(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=U;async function de(H,V){if(!V.hasProvider(R.URI.from({scheme:H.scheme})))return new Promise(ce=>{const be=V.onDidChangeFileSystemProviderRegistrations(Se=>{Se.scheme===H.scheme&&Se.added&&(be.dispose(),ce())})})}e.whenProviderRegistered=de;class ie{static formatSize(V){return(0,L.isNumber)(V)||(V=0),V<ie.KB?(0,g.localize)(1,null,V.toFixed(0)):V<ie.MB?(0,g.localize)(2,null,(V/ie.KB).toFixed(2)):V<ie.GB?(0,g.localize)(3,null,(V/ie.MB).toFixed(2)):V<ie.TB?(0,g.localize)(4,null,(V/ie.GB).toFixed(2)):(0,g.localize)(5,null,(V/ie.TB).toFixed(2))}}e.ByteSize=ie,ie.KB=1024,ie.MB=ie.KB*ie.KB,ie.GB=ie.MB*ie.KB,ie.TB=ie.GB*ie.KB;function ne(H){const V=typeof H=="string"||H?.scheme===A.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===A.Schemas.file?1024*ie.MB:V?10*ie.MB:m.isWeb?50*ie.MB:1024*ie.MB}e.getLargeFileConfirmationLimit=ne}),define(De[217],Ie([1,0,22,8,183,30]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(A,k,w,D,I,E){let i;try{await g(A,k,w,D,I,E)}catch(l){i=l}finally{i&&I.errorTransformer&&(i=I.errorTransformer(i)),typeof i<"u"&&w.error(i),w.end()}}e.readFileIntoStream=R;async function g(A,k,w,D,I,E){y(E);const i=await A.open(k,{create:!1});try{y(E);let l=0,a=0,b=I&&typeof I.length=="number"?I.length:void 0,f=v.VSBuffer.alloc(Math.min(I.bufferSize,typeof b=="number"?b:I.bufferSize)),_=I&&typeof I.position=="number"?I.position:0,n=0;do a=await A.read(i,_,f.buffer,n,f.byteLength-n),_+=a,n+=a,l+=a,typeof b=="number"&&(b-=a),n===f.byteLength&&(await w.write(D(f)),f=v.VSBuffer.alloc(Math.min(I.bufferSize,typeof b=="number"?b:I.bufferSize)),n=0);while(a>0&&(typeof b!="number"||b>0)&&y(E)&&m(l,I));if(n>0){let o=n;typeof b=="number"&&(o=Math.min(n,b)),w.write(D(f.slice(0,o)))}}catch(l){throw(0,L.ensureFileSystemProviderError)(l)}finally{await A.close(i)}}function y(A){if(A.isCancellationRequested)throw(0,T.canceled)();return!0}function m(A,k){if(typeof k?.limits?.size=="number"&&A>k.limits.size)throw(0,L.createFileSystemProviderError)((0,d.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[77],Ie([1,0,33,4,11,10,2,30]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function y(l){return l.recursive===!0}e.isRecursiveWatchRequest=y;class m extends T.Disposable{constructor(a,b,f,_){super(),this.onFileChanges=a,this.onLogMessage=b,this.verboseLogging=f,this.options=_,this.watcherDisposables=this._register(new T.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const a=new T.DisposableStore;this.watcherDisposables.value=a,this.watcher=this.createWatcher(a),this.watcher.setVerboseLogging(this.verboseLogging),a.add(this.watcher.onDidChangeFile(b=>this.onFileChanges(b))),a.add(this.watcher.onDidLogMessage(b=>this.onLogMessage(b))),a.add(this.watcher.onDidError(b=>this.onError(b)))}onError(a){this.options.restartOnError?this.restartCounter<m.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${a}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${a}`):this.error(a)}restart(a){this.restartCounter++,this.init(),this.watch(a)}async watch(a){this.requests=a,await this.watcher?.watch(a)}async setVerboseLogging(a){this.verboseLogging=a,await this.watcher?.setVerboseLogging(a)}error(a){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${a}`})}trace(a){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${a}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.MAX_RESTARTS=5;class A extends m{constructor(a,b,f){super(a,b,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=A;class k extends m{constructor(a,b,f){super(a,b,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=k;function w(l){return l.map(a=>({type:a.type,resource:R.URI.file(a.path)}))}e.toFileChanges=w;function D(l){const a=new i;for(const b of l)a.processEvent(b);return a.coalesce()}e.coalesceEvents=D;function I(l,a){return typeof a=="string"&&!a.startsWith(v.GLOBSTAR)&&!(0,d.isAbsolute)(a)?{base:l,pattern:a}:a}e.normalizeWatcherPattern=I;function E(l,a){const b=[];for(const f of a)b.push((0,v.parse)(I(l,f)));return b}e.parseWatcherPatterns=E;class i{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(a){return L.isLinux?a.path:a.path.toLowerCase()}processEvent(a){const b=this.mapPathToChange.get(this.toKey(a));let f=!1;if(b){const _=b.type,n=a.type;b.path!==a.path&&(a.type===2||a.type===1)?f=!0:_===1&&n===2?(this.mapPathToChange.delete(this.toKey(a)),this.coalesced.delete(b)):_===2&&n===1?b.type=0:_===1&&n===0||(b.type=n)}else f=!0;f&&(this.coalesced.add(a),this.mapPathToChange.set(this.toKey(a),a))}coalesce(){const a=[],b=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(a.push(f),!1):!0).sort((f,_)=>f.path.length-_.path.length).filter(f=>b.some(_=>(0,g.isParent)(f.path,_,!L.isLinux))?!1:(b.push(f.path),!0)).concat(a)}}}),define(De[218],Ie([1,0,49,17,21,31,4,69,11,10,95,29,77]),function(re,e,v,T,d,L,R,g,y,m,A,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class D extends R.Disposable{constructor(i,l,a,b){super(),this.request=i,this.onDidFilesChange=l,this.onLogMessage=a,this.verboseLogging=b,this.throttledFileChangesEmitter=this._register(new T.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.onDidFilesChange(f))),this.fileChangesAggregator=this._register(new T.RunOnceWorker(f=>this.handleFileChanges(f),D.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,w.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,w.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new d.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const i=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const l=await k.Promises.stat(i);this._register(await this.doWatch(i,l.isDirectory()))}catch(i){i.code!=="ENOENT"?this.error(i):this.trace(i)}}async normalizePath(i){let l=i.path;try{l=await k.Promises.realpath(i.path),i.path===l&&(l=await(0,A.realcase)(i.path)??i.path),i.path!==l&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${l})`)}catch{}return l}async doWatch(i,l){if(m.isMacintosh&&(0,L.isEqualOrParent)(i,"/Volumes/",!0))return this.error(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const a=new d.CancellationTokenSource(this.cts.token),b=new R.DisposableStore;try{const f=(0,y.basename)(i),_=(0,v.watch)(i);b.add((0,R.toDisposable)(()=>{_.removeAllListeners(),_.close()})),this.trace(`Started watching: '${i}'`);const n=new Set;if(l)try{for(const s of await k.Promises.readdir(i))n.add(s)}catch(s){this.error(s)}const o=new Map;b.add((0,R.toDisposable)(()=>{for(const[,s]of o)s.dispose();o.clear()})),_.on("error",(s,t)=>{this.error(`Failed to watch ${i} for changes using fs.watch() (${s}, ${t})`),this.dispose()}),_.on("change",(s,t)=>{if(a.token.isCancellationRequested)return;this.trace(`[raw] ["${s}"] ${t}`);let u="";if(t&&(u=t.toString(),m.isMacintosh&&(u=(0,g.normalizeNFC)(u))),!(!u||s!=="change"&&s!=="rename"))if(l)if(s==="rename"){o.get(u)?.dispose();const p=setTimeout(async()=>{if(o.delete(u),u===f&&!await k.Promises.exists(i)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const h=await this.existsChildStrictCase((0,y.join)(i,u));if(a.token.isCancellationRequested)return;let C;h?n.has(u)?C=0:(C=1,n.add(u)):(n.delete(u),C=2),this.onFileChange({path:(0,y.join)(this.request.path,u),type:C})},D.FILE_DELETE_HANDLER_DELAY);o.set(u,(0,R.toDisposable)(()=>clearTimeout(p)))}else{let p;n.has(u)?p=0:(p=1,n.add(u)),this.onFileChange({path:(0,y.join)(this.request.path,u),type:p})}else if(s==="rename"||u!==f){const p=setTimeout(async()=>{const h=await k.Promises.exists(i);a.token.isCancellationRequested||(h?(this.onFileChange({path:this.request.path,type:0},!0),b.add(await this.doWatch(i,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},D.FILE_DELETE_HANDLER_DELAY);b.clear(),b.add((0,R.toDisposable)(()=>clearTimeout(p)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(f){await k.Promises.exists(i)&&!a.token.isCancellationRequested&&this.error(`Failed to watch ${i} for changes using fs.watch() (${f.toString()})`)}return(0,R.toDisposable)(()=>{a.dispose(!0),b.dispose()})}onFileChange(i,l=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.path}`),!l&&this.excludes.some(a=>a(i.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${i.path}`):!l&&this.includes&&this.includes.length>0&&!this.includes.some(a=>a(i.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${i.path}`):this.fileChangesAggregator.work(i))}handleFileChanges(i){const l=(0,w.coalesceEvents)(i);if(l.length>0){if(this.verboseLogging)for(const b of l)this.trace(`>> normalized ${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`);this.throttledFileChangesEmitter.work(l)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(i){if(m.isLinux)return k.Promises.exists(i);try{const l=(0,y.basename)(i);return(await k.Promises.readdir((0,y.dirname)(i))).some(b=>b===l)}catch(l){return this.trace(l),!1}}setVerboseLogging(i){this.verboseLogging=i}error(i){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}warn(i){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}trace(i){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=D,D.FILE_DELETE_HANDLER_DELAY=100,D.FILE_CHANGES_HANDLER_DELAY=75;async function I(E,i,l,a,b=512){const f=await k.Promises.open(E,"r"),_=Buffer.allocUnsafe(b),n=new d.CancellationTokenSource(a);let o,s=!1;const t={path:E,excludes:[],recursive:!1},u=new D(t,p=>{(async()=>{for(const{type:h}of p)if(h===0){if(s)return;s=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:C}=await k.Promises.read(f,_,0,b,null);if(!C||n.token.isCancellationRequested)break;i(_.slice(0,C))}}catch(C){o=new Error(C),n.dispose(!0)}finally{s=!1}}})()});return await u.ready,l(),new Promise((p,h)=>{n.token.onCancellationRequested(async()=>{u.dispose();try{await k.Promises.close(f)}catch(C){o=new Error(C)}o?h(o):p()})})}e.watchFileContents=I}),define(De[219],Ie([1,0,3,33,4,10,218]),function(re,e,v,T,d,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class g extends d.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new v.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new v.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=v.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(m){const A=this.normalizeRequests(m),k=A.filter(D=>{const I=this.watchers.get(D.path);return I?!(0,T.patternsEquals)(I.request.excludes,D.excludes)||!(0,T.patternsEquals)(I.request.includes,D.includes):!0}),w=Array.from(this.watchers.values()).filter(({request:D})=>!A.find(I=>I.path===D.path&&(0,T.patternsEquals)(I.excludes,D.excludes)&&(0,T.patternsEquals)(I.includes,D.includes))).map(({request:D})=>D.path);k.length&&this.trace(`Request to start watching: ${k.map(D=>`${D.path} (excludes: ${D.excludes.length>0?D.excludes:"<none>"}, includes: ${D.includes&&D.includes.length>0?JSON.stringify(D.includes):"<all>"})`).join(",")}`),w.length&&this.trace(`Request to stop watching: ${w.join(",")}`);for(const D of w)this.stopWatching(D);for(const D of k)this.startWatching(D)}startWatching(m){const A=new R.NodeJSFileWatcherLibrary(m,w=>this._onDidChangeFile.fire(w),w=>this._onDidLogMessage.fire(w),this.verboseLogging),k={request:m,instance:A};this.watchers.set(m.path,k)}async stop(){for(const[m]of this.watchers)this.stopWatching(m);this.watchers.clear()}stopWatching(m){const A=this.watchers.get(m);A&&(this.watchers.delete(m),A.instance.dispose())}normalizeRequests(m){const A=new Map;for(const k of m){const w=L.isLinux?k.path:k.path.toLowerCase();A.set(w,k)}return Array.from(A.values())}async setVerboseLogging(m){this.verboseLogging=m;for(const[,A]of this.watchers)A.instance.setVerboseLogging(m)}trace(m){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m)})}toMessage(m,A){return A?`[File Watcher (node.js)] ${m} (path: ${A.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=g}),define(De[220],Ie([1,0,77,219]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class d extends v.AbstractNonRecursiveWatcherClient{constructor(R,g,y){super(R,g,y),this.init()}createWatcher(){return new T.NodeJSWatcher}}e.NodeJSWatcherClient=d}),define(De[221],Ie([1,0,16,75,173,77]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class R extends L.AbstractUniversalWatcherClient{constructor(y,m,A){super(y,m,A),this.init()}createWatcher(y){const m=y.add(new d.Client(v.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(m.onDidProcessExit(({code:A,signal:k})=>this.onError(`terminated by itself with code ${A}, signal: ${k}`))),T.ProxyChannel.toService((0,T.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=R}),define(De[99],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...d){this._entries=new Map;for(const[L,R]of d)this.set(L,R)}set(d,L){const R=this._entries.get(d);return this._entries.set(d,L),R}has(d){return this._entries.has(d)}get(d){return this._entries.get(d)}}e.ServiceCollection=v}),define(De[222],Ie([1,0,17,8,4,97,213,5,99,68]),function(re,e,v,T,d,L,R,g,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const A=!1;class k extends Error{constructor(i){super("cyclic dependency between services"),this.message=i.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${i.toString()}`}}class w{constructor(i=new y.ServiceCollection,l=!1,a,b=A){this._services=i,this._strict=l,this._parent=a,this._enableTracing=b,this._activeInstantiations=new Set,this._services.set(g.IInstantiationService,this),this._globalGraph=b?a?._globalGraph??new R.Graph(f=>f):void 0}createChild(i){return new w(i,this._strict,this,this._enableTracing)}invokeFunction(i,...l){const a=I.traceInvocation(this._enableTracing,i);let b=!1;try{return i({get:_=>{if(b)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(_,a);if(!n)throw new Error(`[invokeFunction] unknown service '${_}'`);return n}},...l)}finally{b=!0,a.stop()}}createInstance(i,...l){let a,b;return i instanceof L.SyncDescriptor?(a=I.traceCreation(this._enableTracing,i.ctor),b=this._createInstance(i.ctor,i.staticArguments.concat(l),a)):(a=I.traceCreation(this._enableTracing,i),b=this._createInstance(i,l,a)),a.stop(),b}_createInstance(i,l=[],a){const b=g._util.getServiceDependencies(i).sort((n,o)=>n.index-o.index),f=[];for(const n of b){const o=this._getOrCreateServiceInstance(n.id,a);o||this._throwIfStrict(`[createInstance] ${i.name} depends on UNKNOWN service ${n.id}.`,!1),f.push(o)}const _=b.length>0?b[0].index:l.length;if(l.length!==_){console.trace(`[createInstance] First service dependency of ${i.name} at position ${_+1} conflicts with ${l.length} static arguments`);const n=_-l.length;n>0?l=l.concat(new Array(n)):l=l.slice(0,_)}return Reflect.construct(i,l.concat(f))}_setServiceInstance(i,l){if(this._services.get(i)instanceof L.SyncDescriptor)this._services.set(i,l);else if(this._parent)this._parent._setServiceInstance(i,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(i){const l=this._services.get(i);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(i):l}_getOrCreateServiceInstance(i,l){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(i));const a=this._getServiceInstanceOrDescriptor(i);return a instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(i,a,l.branch(i,!0)):(l.branch(i,!1),a)}_safeCreateAndCacheServiceInstance(i,l,a){if(this._activeInstantiations.has(i))throw new Error(`illegal state - RECURSIVELY instantiating service '${i}'`);this._activeInstantiations.add(i);try{return this._createAndCacheServiceInstance(i,l,a)}finally{this._activeInstantiations.delete(i)}}_createAndCacheServiceInstance(i,l,a){const b=new R.Graph(n=>n.id.toString());let f=0;const _=[{id:i,desc:l,_trace:a}];for(;_.length;){const n=_.pop();if(b.lookupOrInsertNode(n),f++>1e3)throw new k(b);for(const o of g._util.getServiceDependencies(n.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(o.id);if(s||this._throwIfStrict(`[createInstance] ${i} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(o.id)),s instanceof L.SyncDescriptor){const t={id:o.id,desc:s,_trace:n._trace.branch(o.id,!0)};b.insertEdge(n,t),_.push(t)}}}for(;;){const n=b.roots();if(n.length===0){if(!b.isEmpty())throw new k(b);break}for(const{data:o}of n){if(this._getServiceInstanceOrDescriptor(o.id)instanceof L.SyncDescriptor){const t=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,t)}b.removeNode(o)}}return this._getServiceInstanceOrDescriptor(i)}_createServiceInstanceWithOwner(i,l,a=[],b,f){if(this._services.get(i)instanceof L.SyncDescriptor)return this._createServiceInstance(i,l,a,b,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(i,l,a,b,f);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(i,l,a=[],b,f){if(b){const _=new w(void 0,this._strict,this,this._enableTracing);_._globalGraphImplicitDependency=String(i);const n=new Map,o=new v.IdleValue(()=>{const s=_._createInstance(l,a,f);for(const[t,u]of n){const p=s[t];if(typeof p=="function")for(const h of u)p.apply(s,h)}return n.clear(),s});return new Proxy(Object.create(null),{get(s,t){if(!o.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let h=n.get(t);return h||(h=new m.LinkedList,n.set(t,h)),(S,c,r)=>{const P=h.push([S,c,r]);return(0,d.toDisposable)(P)}}if(t in s)return s[t];const u=o.value;let p=u[t];return typeof p!="function"||(p=p.bind(u),s[t]=p),p},set(s,t,u){return o.value[t]=u,!0},getPrototypeOf(s){return l.prototype}})}else return this._createInstance(l,a,f)}_throwIfStrict(i,l){if(l&&console.warn(i),this._strict)throw new Error(i)}}e.InstantiationService=w;var D;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(D||(D={}));class I{static traceInvocation(i,l){return i?new I(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):I._None}static traceCreation(i,l){return i?new I(1,l.name):I._None}constructor(i,l){this.type=i,this.name=l,this._start=Date.now(),this._dep=[]}branch(i,l){const a=new I(3,i.toString());return this._dep.push([i,l,a]),a}stop(){const i=Date.now()-this._start;I._totals+=i;let l=!1;function a(f,_){const n=[],o=new Array(f+1).join("	");for(const[s,t,u]of _._dep)if(t&&u){l=!0,n.push(`${o}CREATES -> ${s}`);const p=a(f+1,u);p&&n.push(p)}else n.push(`${o}uses -> ${s}`);return n.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${i.toFixed(2)}ms (grand total ${I._totals.toFixed(2)}ms)`];(i>2||l)&&I.all.add(b.join(`
`))}}e.Trace=I,I.all=new Set,I._None=new class extends I{constructor(){super(0,null)}stop(){}branch(){return this}},I._totals=0}),define(De[18],Ie([1,0,45,3,70,4,28,10,23,12,2,47,5]),function(re,e,v,T,d,L,R,g,y,m,A,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function D(){return new Date().toISOString()}function I(S){return(0,m.isNumber)(S)}e.isLogLevel=I;var E;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(E||(e.LogLevel=E={})),e.DEFAULT_LOG_LEVEL=E.Info;function i(S,c,r){switch(c){case E.Trace:S.trace(r);break;case E.Debug:S.debug(r);break;case E.Info:S.info(r);break;case E.Warning:S.warn(r);break;case E.Error:S.error(r);break;case E.Off:break;default:throw new Error(`Invalid log level ${c}`)}}e.log=i;function l(S,c=!1){let r="";for(let P=0;P<S.length;P++){let M=S[P];if(M instanceof Error&&(M=(0,v.toErrorMessage)(M,c)),typeof M=="object")try{M=JSON.stringify(M)}catch{}r+=(P>0?" ":"")+M}return r}class a extends L.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(c){this.level!==c&&(this.level=c,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(c){return this.level!==E.Off&&this.level<=c}}e.AbstractLogger=a;class b extends a{constructor(c){super(),this.logAlways=c}checkLogLevel(c){return this.logAlways||super.checkLogLevel(c)}trace(c,...r){this.checkLogLevel(E.Trace)&&this.log(E.Trace,l([c,...r],!0))}debug(c,...r){this.checkLogLevel(E.Debug)&&this.log(E.Debug,l([c,...r]))}info(c,...r){this.checkLogLevel(E.Info)&&this.log(E.Info,l([c,...r]))}warn(c,...r){this.checkLogLevel(E.Warning)&&this.log(E.Warning,l([c,...r]))}error(c,...r){if(this.checkLogLevel(E.Error))if(c instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=c.stack,this.log(E.Error,l(P))}else this.log(E.Error,l([c,...r]))}flush(){}}e.AbstractMessageLogger=b;class f extends a{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c),this.useColors=!g.isWindows}trace(c,...r){this.checkLogLevel(E.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,c,...r):console.log(`[main ${D()}]`,c,...r))}debug(c,...r){this.checkLogLevel(E.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,c,...r):console.log(`[main ${D()}]`,c,...r))}info(c,...r){this.checkLogLevel(E.Info)&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,c,...r):console.log(`[main ${D()}]`,c,...r))}warn(c,...r){this.checkLogLevel(E.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${D()}]\x1B[0m`,c,...r):console.warn(`[main ${D()}]`,c,...r))}error(c,...r){this.checkLogLevel(E.Error)&&(this.useColors?console.error(`\x1B[91m[main ${D()}]\x1B[0m`,c,...r):console.error(`[main ${D()}]`,c,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class _ extends a{constructor(c=e.DEFAULT_LOG_LEVEL,r=!0){super(),this.useColors=r,this.setLevel(c)}trace(c,...r){this.checkLogLevel(E.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",c,...r):console.log(c,...r))}debug(c,...r){this.checkLogLevel(E.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",c,...r):console.log(c,...r))}info(c,...r){this.checkLogLevel(E.Info)&&(this.useColors?console.log("%c INFO","color: #33f",c,...r):console.log(c,...r))}warn(c,...r){this.checkLogLevel(E.Warning)&&(this.useColors?console.log("%c WARN","color: #993",c,...r):console.log(c,...r))}error(c,...r){this.checkLogLevel(E.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",c,...r):console.error(c,...r))}dispose(){}flush(){}}e.ConsoleLogger=_;class n extends a{constructor(c,r=e.DEFAULT_LOG_LEVEL){super(),this.adapter=c,this.setLevel(r)}trace(c,...r){this.checkLogLevel(E.Trace)&&this.adapter.log(E.Trace,[this.extractMessage(c),...r])}debug(c,...r){this.checkLogLevel(E.Debug)&&this.adapter.log(E.Debug,[this.extractMessage(c),...r])}info(c,...r){this.checkLogLevel(E.Info)&&this.adapter.log(E.Info,[this.extractMessage(c),...r])}warn(c,...r){this.checkLogLevel(E.Warning)&&this.adapter.log(E.Warning,[this.extractMessage(c),...r])}error(c,...r){this.checkLogLevel(E.Error)&&this.adapter.log(E.Error,[this.extractMessage(c),...r])}extractMessage(c){return typeof c=="string"?c:(0,v.toErrorMessage)(c,this.checkLogLevel(E.Trace))}dispose(){}flush(){}}e.AdapterLogger=n;class o extends a{constructor(c){super(),this.loggers=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const r of this.loggers)r.setLevel(c);super.setLevel(c)}trace(c,...r){for(const P of this.loggers)P.trace(c,...r)}debug(c,...r){for(const P of this.loggers)P.debug(c,...r)}info(c,...r){for(const P of this.loggers)P.info(c,...r)}warn(c,...r){for(const P of this.loggers)P.warn(c,...r)}error(c,...r){for(const P of this.loggers)P.error(c,...r)}flush(){for(const c of this.loggers)c.flush()}dispose(){for(const c of this.loggers)c.dispose()}}e.MultiplexLogger=o;class s extends L.Disposable{constructor(c,r,P){if(super(),this.logLevel=c,this.logsHome=r,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new T.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,P)for(const M of P)this._loggers.set(M.resource,{logger:void 0,info:M})}getLoggerEntry(c){return(0,m.isString)(c)?[...this._loggers.values()].find(r=>r.info.id===c):this._loggers.get(c)}getLogger(c){return this.getLoggerEntry(c)?.logger}createLogger(c,r){const P=this.toResource(c),M=(0,m.isString)(c)?c:r?.id??(0,d.hash)(P.toString()).toString(16);let W=this._loggers.get(P)?.logger;const $=r?.logLevel==="always"?E.Trace:r?.logLevel;W||(W=this.doCreateLogger(P,$??this.getLogLevel(P)??this.logLevel,{...r,id:M}));const z={logger:W,info:{resource:P,id:M,logLevel:$,name:r?.name,hidden:r?.hidden,extensionId:r?.extensionId,when:r?.when}};return this.registerLogger(z.info),this._loggers.set(P,z),W}toResource(c){return(0,m.isString)(c)?(0,y.joinPath)(this.logsHome,`${c}.log`):c}setLogLevel(c,r){if(A.URI.isUri(c)){const P=c,M=r,W=this._loggers.get(P);W&&M!==W.info.logLevel&&(W.info.logLevel=M===this.logLevel?void 0:M,W.logger?.setLevel(M),this._loggers.set(W.info.resource,W),this._onDidChangeLogLevel.fire([P,M]))}else{this.logLevel=c;for(const[P,M]of this._loggers.entries())this._loggers.get(P)?.info.logLevel===void 0&&M.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(c,r){const P=this.getLoggerEntry(c);P&&r!==!P.info.hidden&&(P.info.hidden=!r,this._loggers.set(P.info.resource,P),this._onDidChangeVisibility.fire([P.info.resource,r]))}getLogLevel(c){let r;return c&&(r=this._loggers.get(c)?.info.logLevel),r??this.logLevel}registerLogger(c){const r=this._loggers.get(c.resource);r?r.info.hidden!==c.hidden&&this.setVisibility(c.resource,!c.hidden):(this._loggers.set(c.resource,{info:c,logger:void 0}),this._onDidChangeLoggers.fire({added:[c],removed:[]}))}deregisterLogger(c){const r=this._loggers.get(c);r&&(r.logger&&r.logger.dispose(),this._loggers.delete(c),this._onDidChangeLoggers.fire({added:[],removed:[r.info]}))}*getRegisteredLoggers(){for(const c of this._loggers.values())yield c.info}getRegisteredLogger(c){return this._loggers.get(c)?.info}dispose(){this._loggers.forEach(c=>c.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class t{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(c){}getLevel(){return E.Info}trace(c,...r){}debug(c,...r){}info(c,...r){}warn(c,...r){}error(c,...r){}critical(c,...r){}dispose(){}flush(){}}e.NullLogger=t;class u extends t{}e.NullLogService=u;function p(S){if(S.verbose)return E.Trace;if(typeof S.logLevel=="string"){const c=C(S.logLevel.toLowerCase());if(c!==void 0)return c}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function h(S){switch(S){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=h;function C(S){switch(S){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=C,e.CONTEXT_LOG_LEVEL=new k.RawContextKey("logLevel",h(E.Info))}),define(De[223],Ie([1,0,19,17,8,3,4,11,77,18]),function(re,e,v,T,d,L,R,g,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class A extends R.Disposable{constructor(w,D){super(),this.logService=w,this.options=D,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new T.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new T.ThrottledDelayer(0))}watch(w,D){return D.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(w,D):this.watchNonRecursive(w,D)}watchUniversal(w,D){const I={path:this.toFilePath(w),excludes:D.excludes,includes:D.includes,recursive:D.recursive},E=(0,v.insert)(this.universalPathsToWatch,I);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{E(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(w=>(0,d.onUnexpectedError)(w))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(D=>this._onDidChangeFile.fire((0,y.toFileChanges)(D)),D=>this.onWatcherLogMessage(D),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const w=this.options?.watcher?.recursive?.usePolling;if(w===!0)for(const D of this.universalPathsToWatch)(0,y.isRecursiveWatchRequest)(D)&&(D.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const D of this.universalPathsToWatch)(0,y.isRecursiveWatchRequest)(D)&&w.includes(D.path)&&(D.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(w,D){const I={path:this.toFilePath(w),excludes:D.excludes,includes:D.includes,recursive:!1},E=(0,v.insert)(this.nonRecursivePathsToWatch,I);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{E(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(w=>(0,d.onUnexpectedError)(w))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(w=>this._onDidChangeFile.fire((0,y.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(w){w.type==="error"&&this._onDidWatchError.fire(w.message),this.logService[w.type](w.message)}toFilePath(w){return(0,g.normalize)(w.fsPath)}}e.AbstractDiskFileSystemProvider=A}),define(De[224],Ie([1,0,49,347,17,28,22,3,31,4,11,10,23,91,29,184,30,217,223,45,221,220]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l,a,b,f,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,T.gracefulify)(v)}catch(o){console.error(`Error enabling graceful-fs: ${(0,b.toErrorMessage)(o)}`)}})();class n extends a.AbstractDiskFileSystemProvider{constructor(s,t){super(s,t),this.onDidChangeCapabilities=g.Event.None,this.resourceLocks=new L.ResourceMap(u=>w.extUriBiasedIgnorePathCase.getComparisonKey(u)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:t,symbolicLink:u}=await I.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(t,u),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:i.FilePermission.Locked}}catch(t){throw this.toFileSystemProviderError(t)}}async statIgnoreError(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const t=await I.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),u=[];return await Promise.all(t.map(async p=>{try{let h;p.isSymbolicLink()?h=(await this.stat((0,w.joinPath)(s,p.name))).type:h=this.toType(p),u.push([p.name,h])}catch(h){this.logService.trace(h)}})),u}catch(t){throw this.toFileSystemProviderError(t)}}toType(s,t){let u;return t?.dangling?u=i.FileType.Unknown:s.isFile()?u=i.FileType.File:s.isDirectory()?u=i.FileType.Directory:u=i.FileType.Unknown,t&&(u|=i.FileType.SymbolicLink),u}async createResourceLock(s){const t=this.toFilePath(s);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let u;for(;u=this.resourceLocks.get(s);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await u.wait();const p=new d.Barrier;return this.resourceLocks.set(s,p),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,m.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.resourceLocks.get(s)===p&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.resourceLocks.delete(s)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),p.open()})}async readFile(s,t){let u;try{t?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),u=await this.createResourceLock(s));const p=this.toFilePath(s);return await I.Promises.readFile(p)}catch(p){throw this.toFileSystemProviderError(p)}finally{u?.dispose()}}traceLock(s){n.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(s)}readFileStream(s,t,u){const p=(0,D.newWriteableStream)(h=>R.VSBuffer.concat(h.map(C=>R.VSBuffer.wrap(C))).buffer);return(0,l.readFileIntoStream)(this,s,p,h=>h.buffer,{...t,bufferSize:256*1024},u),p}async writeFile(s,t,u){return u?.atomic!==!1&&u?.atomic?.postfix?this.doWriteFileAtomic(s,(0,w.joinPath)((0,w.dirname)(s),`${(0,w.basename)(s)}${u.atomic.postfix}`),t,u):this.doWriteFile(s,t,u)}async doWriteFileAtomic(s,t,u,p){await this.doWriteFile(t,u,p);try{await this.rename(t,s,{overwrite:!0})}catch(h){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw h}}async doWriteFile(s,t,u){let p;try{const h=this.toFilePath(s);if(!u.create||!u.overwrite){if(await I.Promises.exists(h)){if(!u.overwrite)throw(0,i.createFileSystemProviderError)((0,E.localize)(0,null),i.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,i.createFileSystemProviderError)((0,E.localize)(1,null),i.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(s,{create:!0,unlock:u.unlock}),await this.write(p,0,t,0,t.byteLength)}catch(h){throw await this.toFileSystemProviderWriteError(s,h)}finally{typeof p=="number"&&await this.close(p)}}static configureFlushOnWrite(s){n.canFlush=s}async open(s,t){const u=this.toFilePath(s);let p;(0,i.isFileOpenForWriteOptions)(t)&&(p=await this.createResourceLock(s));let h;try{if((0,i.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:S}=await I.SymlinkSupport.stat(u);S.mode&128||await I.Promises.chmod(u,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}let C;if((0,i.isFileOpenForWriteOptions)(t)){if(k.isWindows)try{await I.Promises.truncate(u,0),C="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}C||(C="w")}else C="r";h=await I.Promises.open(u,C)}catch(C){throw p?.dispose(),(0,i.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(s,C):this.toFileSystemProviderError(C)}if(this.mapHandleToPos.set(h,0),(0,i.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(h,s),p){const C=this.mapHandleToLock.get(h);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${h} (${u})`),this.mapHandleToLock.set(h,p),C&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${h} (${u})`),C.dispose())}return h}async close(s){const t=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&n.canFlush)try{await I.Promises.fdatasync(s)}catch(u){n.configureFlushOnWrite(!1),this.logService.error(u)}return await I.Promises.close(s)}catch(u){throw this.toFileSystemProviderError(u)}finally{t&&(this.mapHandleToLock.get(s)===t&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),t.dispose())}}async read(s,t,u,p,h){const C=this.normalizePos(s,t);let S=null;try{S=(await I.Promises.read(s,u,p,h,C)).bytesRead}catch(c){throw this.toFileSystemProviderError(c)}finally{this.updatePos(s,C,S)}return S}normalizePos(s,t){return t===this.mapHandleToPos.get(s)?null:t}updatePos(s,t,u){const p=this.mapHandleToPos.get(s);typeof p=="number"&&(typeof t=="number"||(typeof u=="number"?this.mapHandleToPos.set(s,p+u):this.mapHandleToPos.delete(s)))}async write(s,t,u,p,h){return(0,d.retry)(()=>this.doWrite(s,t,u,p,h),100,3)}async doWrite(s,t,u,p,h){const C=this.normalizePos(s,t);let S=null;try{S=(await I.Promises.write(s,u,p,h,C)).bytesWritten}catch(c){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),c)}finally{this.updatePos(s,C,S)}return S}async mkdir(s){try{await I.Promises.mkdir(this.toFilePath(s))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(s,t){try{const u=this.toFilePath(s);if(t.recursive){let p;t?.atomic!==!1&&t.atomic.postfix&&(p=(0,A.join)((0,A.dirname)(u),`${(0,A.basename)(u)}${t.atomic.postfix}`)),await I.Promises.rm(u,I.RimRafMode.MOVE,p)}else try{await I.Promises.unlink(u)}catch(p){if(p.code==="EPERM"||p.code==="EISDIR"){let h=!1;try{const{stat:C,symbolicLink:S}=await I.SymlinkSupport.stat(u);h=C.isDirectory()&&!S}catch{}if(h)await I.Promises.rmdir(u);else throw p}else throw p}}catch(u){throw this.toFileSystemProviderError(u)}}async rename(s,t,u){const p=this.toFilePath(s),h=this.toFilePath(t);if(p!==h)try{await this.validateMoveCopy(s,t,"move",u.overwrite),await I.Promises.move(p,h)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,E.localize)(2,null,(0,A.basename)(p),(0,A.basename)((0,A.dirname)(h)),C.toString()))),this.toFileSystemProviderError(C)}}async copy(s,t,u){const p=this.toFilePath(s),h=this.toFilePath(t);if(p!==h)try{await this.validateMoveCopy(s,t,"copy",u.overwrite),await I.Promises.copy(p,h,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,E.localize)(3,null,(0,A.basename)(p),(0,A.basename)((0,A.dirname)(h)),C.toString()))),this.toFileSystemProviderError(C)}}async validateMoveCopy(s,t,u,p){const h=this.toFilePath(s),C=this.toFilePath(t);let S=!1;if(!!(this.capabilities&1024)||(S=(0,y.isEqual)(h,C,!0)),S){if(u==="copy")throw(0,i.createFileSystemProviderError)((0,E.localize)(4,null),i.FileSystemProviderErrorCode.FileExists);if(u==="move")return}const r=await this.statIgnoreError(s);if(!r)throw(0,i.createFileSystemProviderError)((0,E.localize)(5,null),i.FileSystemProviderErrorCode.FileNotFound);const P=await this.statIgnoreError(t);if(P){if(!p)throw(0,i.createFileSystemProviderError)((0,E.localize)(6,null),i.FileSystemProviderErrorCode.FileExists);r.type&i.FileType.File&&P.type&i.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,t){return this.doCloneFile(s,t,!1)}async doCloneFile(s,t,u){const p=this.toFilePath(s),h=this.toFilePath(t),C=!!(this.capabilities&1024);if((0,y.isEqual)(p,h,!C))return;const S=new m.DisposableStore;try{const[c,r]=await Promise.all([this.createResourceLock(s),this.createResourceLock(t)]);S.add(c),S.add(r),u&&await I.Promises.mkdir((0,A.dirname)(h),{recursive:!0}),await I.Promises.copyFile(p,h)}catch(c){if(c.code==="ENOENT"&&!u)return this.doCloneFile(s,t,!0);throw this.toFileSystemProviderError(c)}finally{S.dispose()}}createUniversalWatcher(s,t,u){return new f.UniversalWatcherClient(p=>s(p),p=>t(p),u)}createNonRecursiveWatcher(s,t,u){return new _.NodeJSWatcherClient(p=>s(p),p=>t(p),u)}toFileSystemProviderError(s){if(s instanceof i.FileSystemProviderError)return s;let t=s,u;switch(s.code){case"ENOENT":u=i.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":u=i.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":u=i.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":u=i.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":u=i.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,u=i.FileSystemProviderErrorCode.Unknown;break;default:u=i.FileSystemProviderErrorCode.Unknown}return(0,i.createFileSystemProviderError)(t,u)}async toFileSystemProviderWriteError(s,t){let u=this.toFileSystemProviderError(t);if(s&&u.code===i.FileSystemProviderErrorCode.NoPermissions)try{const{stat:p}=await I.SymlinkSupport.stat(this.toFilePath(s));p.mode&128||(u=(0,i.createFileSystemProviderError)(t,i.FileSystemProviderErrorCode.FileWriteLocked))}catch(p){this.logService.trace(p)}return u}}e.DiskFileSystemProvider=n,n.TRACE_LOG_RESOURCE_LOCKS=!1,n.canFlush=!0}),define(De[225],Ie([1,0,4,18]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class d extends v.Disposable{constructor(R,g=[]){super(),this.logger=new T.MultiplexLogger([R,...g]),this._register(R.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(R){this.logger.setLevel(R)}getLevel(){return this.logger.getLevel()}trace(R,...g){this.logger.trace(R,...g)}debug(R,...g){this.logger.debug(R,...g)}info(R,...g){this.logger.info(R,...g)}warn(R,...g){this.logger.warn(R,...g)}error(R,...g){this.logger.error(R,...g)}flush(){this.logger.flush()}}e.LogService=d}),define(De[226],Ie([1,0,30,18]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var d;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(d||(d={}));async function L(m,A,k,w,D){try{const I=await new Promise((i,l)=>{re(["@vscode/spdlog"],i,l)});I.setFlushOn(d.Trace);const E=await I.createAsyncRotatingLogger(m,A,k,w);return D?E.clearFormatters():E.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),E}catch(I){console.error(I)}return null}function R(m,A,k){switch(A){case T.LogLevel.Trace:m.trace(k);break;case T.LogLevel.Debug:m.debug(k);break;case T.LogLevel.Info:m.info(k);break;case T.LogLevel.Warning:m.warn(k);break;case T.LogLevel.Error:m.error(k);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function g(m,A){switch(A){case T.LogLevel.Trace:m.setLevel(d.Trace);break;case T.LogLevel.Debug:m.setLevel(d.Debug);break;case T.LogLevel.Info:m.setLevel(d.Info);break;case T.LogLevel.Warning:m.setLevel(d.Warning);break;case T.LogLevel.Error:m.setLevel(d.Error);break;case T.LogLevel.Off:m.setLevel(d.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class y extends T.AbstractMessageLogger{constructor(A,k,w,D,I){super(),this.buffer=[],this.setLevel(I),this._loggerCreationPromise=this._createSpdLogLogger(A,k,w,D),this._register(this.onDidChangeLogLevel(E=>{this._logger&&g(this._logger,E)}))}async _createSpdLogLogger(A,k,w,D){const I=w?6:1,E=30/I*v.ByteSize.MB,i=await L(A,k,E,I,D);if(i){this._logger=i,g(this._logger,this.getLevel());for(const{level:l,message:a}of this.buffer)R(this._logger,l,a);this.buffer=[]}}log(A,k){this._logger?R(this._logger,A,k):this.getLevel()<=A&&this.buffer.push({level:A,message:k})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=y}),define(De[126],Ie([1,0,40,185,5]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(y){function m(I,E){return E-I}y.compare=m;const A=Object.create(null);A[y.Error]=(0,T.localize)(0,null),A[y.Warning]=(0,T.localize)(1,null),A[y.Info]=(0,T.localize)(2,null);function k(I){return A[I]||""}y.toString=k;function w(I){switch(I){case v.default.Error:return y.Error;case v.default.Warning:return y.Warning;case v.default.Info:return y.Info;case v.default.Ignore:return y.Hint}}y.fromSeverity=w;function D(I){switch(I){case y.Error:return v.default.Error;case y.Warning:return v.default.Warning;case y.Info:return v.default.Info;case y.Hint:return v.default.Ignore}}y.toSeverity=D}(R||(e.MarkerSeverity=R={}));var g;(function(y){const m="";function A(w){return k(w,!0)}y.makeKey=A;function k(w,D){const I=[m];return w.source?I.push(w.source.replace("\xA6","\\\xA6")):I.push(m),w.code?typeof w.code=="string"?I.push(w.code.replace("\xA6","\\\xA6")):I.push(w.code.value.replace("\xA6","\\\xA6")):I.push(m),w.severity!==void 0&&w.severity!==null?I.push(R.toString(w.severity)):I.push(m),w.message&&D?I.push(w.message.replace("\xA6","\\\xA6")):I.push(m),w.startLineNumber!==void 0&&w.startLineNumber!==null?I.push(w.startLineNumber.toString()):I.push(m),w.startColumn!==void 0&&w.startColumn!==null?I.push(w.startColumn.toString()):I.push(m),w.endLineNumber!==void 0&&w.endLineNumber!==null?I.push(w.endLineNumber.toString()):I.push(m),w.endColumn!==void 0&&w.endColumn!==null?I.push(w.endColumn.toString()):I.push(m),I.push(m),I.join("\xA6")}y.makeKeyOptionalMessage=k})(g||(e.IMarkerData=g={})),e.IMarkerService=(0,d.createDecorator)("markerService")}),define(De[227],Ie([1,0,3,40,5]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=T.default,e.INotificationService=(0,d.createDecorator)("notificationService");var L;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var g;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(g||(e.NotificationsFilter=g={}));class y{constructor(){this.progress=new m,this.onDidClose=v.Event.None,this.onDidChangeVisibility=v.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.NoOpNotification=y;class m{infinite(){}done(){}total(k){}worked(k){}}e.NoOpProgress=m}),define(De[127],Ie([1,0,9,2,5]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,d.createDecorator)("openerService");function L(m,A){return T.URI.isUri(m)?(0,v.equalsIgnoreCase)(m.scheme,A):(0,v.startsWithIgnoreCase)(m,A+":")}e.matchesScheme=L;function R(m,...A){return A.some(k=>L(m,k))}e.matchesSomeScheme=R;function g(m,A){return m.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.withSelection=g;function y(m){let A;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(m.fragment);return k&&(A={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},m=m.with({fragment:""})),{selection:A,uri:m}}e.extractSelection=y}),define(De[228],Ie([1,0,10,41]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let d;if(typeof v.globals.vscode<"u"&&typeof v.globals.vscode.context<"u"){const L=v.globals.vscode.context.configuration();if(L)d=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){d=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:L,searchUrl:R,itemUrl:g,controlUrl:y}=d.extensionsGallery||{};Object.assign(d,{extensionsGallery:{serviceUrl:T.env.VSCODE_GALLERY_SERVICE_URL||L,searchUrl:T.env.VSCODE_GALLERY_SEARCH_URL||R,itemUrl:T.env.VSCODE_GALLERY_ITEM_URL||g,controlUrl:T.env.VSCODE_GALLERY_CONTROL_URL||y}});try{const m=(...k)=>k.reduce((w,D)=>(Object.keys(D).forEach(I=>{Array.isArray(w[I])&&Array.isArray(D[I])?w[I]=D[I]:typeof w[I]=="object"&&typeof D[I]=="object"?w[I]=m(w[I],D[I]):w[I]=D[I]}),w),{}),A=globalThis._VSCODE_USER_PRODUCT_JSON||{};d=m(d,A)}catch{}if(T.env.VSCODE_DEV&&Object.assign(d,{nameShort:`${d.nameShort} Dev`,nameLong:`${d.nameLong} Dev`,dataFolderName:`${d.dataFolderName}-dev`,serverDataFolderName:d.serverDataFolderName?`${d.serverDataFolderName}-dev`:void 0}),!d.version){const m=globalThis._VSCODE_PACKAGE_JSON;Object.assign(d,{version:m.version,release:m.release})}}else d={},Object.keys(d).length===0&&Object.assign(d,{version:"1.80.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=d}),define(De[229],Ie([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__param||function(re,e){return function(v,T){e(v,T,re)}};define(De[128],Ie([1,0,17,21,4,5]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var R;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class g{get value(){return this._value}constructor(k){this.callback=k}report(k){this._value=k,this.callback(this._value)}}e.Progress=g,g.None=Object.freeze({report(){}});let y=e.UnmanagedProgress=class extends d.Disposable{constructor(k,w){super(),this.deferred=new v.DeferredPromise,w.withProgress(k,D=>(this.reporter=D,this.lastStep&&D.report(this.lastStep),this.deferred.p)),this._register((0,d.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};e.UnmanagedProgress=y=Ve([ze(1,e.IProgressService)],y);class m extends d.Disposable{constructor(k){super(),this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new d.DisposableStore)}start(k){this.stop();const w=++this.currentOperationId,D=new T.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{w===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,d.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,d.toDisposable)(()=>D.cancel())),this.currentOperationDisposables.add((0,d.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:w,token:D.token,stop:()=>this.doStop(w),isCurrent:()=>this.currentOperationId===w}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=m,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(De[42],Ie([1,0,53,12]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class d{constructor(){this.data=new Map}add(R,g){v.ok(T.isString(R)),v.ok(T.isObject(g)),v.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,g)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new d}),define(De[100],Ie([1,0,3,42]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function d(g){return g.length>0&&g.charAt(g.length-1)==="#"?g.substring(0,g.length-1):g}class L{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,m){this.schemasById[d(y)]=m,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new L;T.Registry.add(e.Extensions.JSONContribution,R)}),define(De[129],Ie([1,0,19,3,12,176,57,100,42]),function(re,e,v,T,d,L,R,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(_){_.Multiline="multilineText",_.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=y.Registry.as(g.Extensions.JSONContribution);class w{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,o=!0){this.registerConfigurations([n],o)}registerConfigurations(n,o=!0){const s=new Set;this.doRegisterConfigurations(n,o,s),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(n){const o=new Set;this.doDeregisterConfigurations(n,o),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:n,remove:o}){const s=new Set;this.doDeregisterConfigurations(o,s),this.doRegisterConfigurations(n,!1,s),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(n){const o=new Set;this.doRegisterDefaultConfigurations(n,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(n,o){const s=[];for(const{overrides:t,source:u}of n)for(const p in t)if(o.add(p),e.OVERRIDE_PROPERTY_REGEX.test(p)){const h=this.configurationDefaultsOverrides.get(p),C=h?.valuesSources??new Map;if(u)for(const P of Object.keys(t[p]))C.set(P,u);const S={...h?.value||{},...t[p]};this.configurationDefaultsOverrides.set(p,{source:u,value:S,valuesSources:C});const c=(0,R.getLanguageTagSettingPlainKey)(p),r={type:"object",default:S,description:L.localize(1,null,c),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:d.isString(u)?void 0:u,defaultValueSource:u};s.push(...E(p)),this.configurationProperties[p]=r,this.defaultLanguageConfigurationOverridesNode.properties[p]=r}else{this.configurationDefaultsOverrides.set(p,{value:t[p],source:u});const h=this.configurationProperties[p];h&&(this.updatePropertyDefaultValue(p,h),this.updateSchema(p,h))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(n){const o=new Set;this.doDeregisterDefaultConfigurations(n,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(n,o){for(const{overrides:s,source:t}of n)for(const u in s){const p=this.configurationDefaultsOverrides.get(u),h=d.isString(t)?t:t?.id,C=d.isString(p?.source)?p?.source:p?.source?.id;if(h===C)if(o.add(u),this.configurationDefaultsOverrides.delete(u),e.OVERRIDE_PROPERTY_REGEX.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const S=this.configurationProperties[u];S&&(this.updatePropertyDefaultValue(u,S),this.updateSchema(u,S))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(n){let o=!1;const s=new Set;n.removedDefaults&&(this.doDeregisterDefaultConfigurations(n.removedDefaults,s),o=!0),n.addedDefaults&&(this.doRegisterDefaultConfigurations(n.addedDefaults,s),o=!0),n.removedConfigurations&&this.doDeregisterConfigurations(n.removedConfigurations,s),n.addedConfigurations&&this.doRegisterConfigurations(n.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){this.doRegisterOverrideIdentifiers(n),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(n){for(const o of n)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,o,s){n.forEach(t=>{this.validateAndRegisterProperties(t,o,t.extensionInfo,t.restrictedProperties,void 0,s),this.configurationContributors.push(t),this.registerJSONConfiguration(t)})}doDeregisterConfigurations(n,o){const s=t=>{if(t.properties)for(const u in t.properties){o.add(u);const p=this.configurationProperties[u];p?.policy?.name&&this.policyConfigurations.delete(p.policy.name),delete this.configurationProperties[u],this.removeFromSchema(u,t.properties[u])}t.allOf?.forEach(u=>s(u))};for(const t of n){s(t);const u=this.configurationContributors.indexOf(t);u!==-1&&this.configurationContributors.splice(u,1)}}validateAndRegisterProperties(n,o=!0,s,t,u=3,p){u=d.isUndefinedOrNull(n.scope)?u:n.scope;const h=n.properties;if(h)for(const S in h){const c=h[S];if(o&&b(S,c)){delete h[S];continue}if(c.source=s,c.defaultDefaultValue=h[S].default,this.updatePropertyDefaultValue(S,c),e.OVERRIDE_PROPERTY_REGEX.test(S)?c.scope=void 0:(c.scope=d.isUndefinedOrNull(c.scope)?u:c.scope,c.restricted=d.isUndefinedOrNull(c.restricted)?!!t?.includes(S):c.restricted),h[S].hasOwnProperty("included")&&!h[S].included){this.excludedConfigurationProperties[S]=h[S],delete h[S];continue}else this.configurationProperties[S]=h[S],h[S].policy?.name&&this.policyConfigurations.set(h[S].policy.name,S);!h[S].deprecationMessage&&h[S].markdownDeprecationMessage&&(h[S].deprecationMessage=h[S].markdownDeprecationMessage),p.add(S)}const C=n.allOf;if(C)for(const S of C)this.validateAndRegisterProperties(S,o,s,t,u,p)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const o=s=>{const t=s.properties;if(t)for(const p in t)this.updateSchema(p,t[p]);s.allOf?.forEach(o)};o(n)}updateSchema(n,o){switch(e.allSettings.properties[n]=o,o.scope){case 1:e.applicationSettings.properties[n]=o;break;case 2:e.machineSettings.properties[n]=o;break;case 6:e.machineOverridableSettings.properties[n]=o;break;case 3:e.windowSettings.properties[n]=o;break;case 4:e.resourceSettings.properties[n]=o;break;case 5:e.resourceSettings.properties[n]=o,this.resourceLanguageSettingsSchema.properties[n]=o;break}}removeFromSchema(n,o){switch(delete e.allSettings.properties[n],o.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const o=`[${n}]`,s={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,s),e.allSettings.properties[o]=s,e.applicationSettings.properties[o]=s,e.machineSettings.properties[o]=s,e.machineOverridableSettings.properties[o]=s,e.windowSettings.properties[o]=s,e.resourceSettings.properties[o]=s}}registerOverridePropertyPatternKey(){const n={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,o){const s=this.configurationDefaultsOverrides.get(n);let t=s?.value,u=s?.source;d.isUndefined(t)&&(t=o.defaultDefaultValue,u=void 0),d.isUndefined(t)&&(t=l(o.type)),o.default=t,o.defaultValueSource=u}}const D="\\[([^\\]]+)\\]",I=new RegExp(D,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${D})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(_){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(_)){let o=I.exec(_);for(;o?.length;){const s=o[1].trim();s&&n.push(s),o=I.exec(_)}}return(0,v.distinct)(n)}e.overrideIdentifiersFromKey=E;function i(_){return _.reduce((n,o)=>`${n}[${o}]`,"")}e.keyFromOverrideIdentifiers=i;function l(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const a=new w;y.Registry.add(e.Extensions.Configuration,a);function b(_,n){return _.trim()?e.OVERRIDE_PROPERTY_REGEX.test(_)?L.localize(7,null,_):a.getConfigurationProperties()[_]!==void 0?L.localize(8,null,_):n.policy?.name&&a.getPolicyConfigurations().get(n.policy?.name)!==void 0?L.localize(9,null,_,n.policy?.name,a.getPolicyConfigurations().get(n.policy?.name)):null:L.localize(6,null)}e.validateProperty=b;function f(){const _=[],n=a.getConfigurationProperties();for(const o of Object.keys(n))_.push([o,n[o].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=f}),define(De[230],Ie([1,0,19,3,150,4,28,24,12,2,57,129,42]),function(re,e,v,T,d,L,R,g,y,m,A,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function D(o){return Object.isFrozen(o)?o:g.deepFreeze(o)}class I{constructor(s={},t=[],u=[],p){this._contents=s,this._keys=t,this._overrides=u,this.raw=p,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(t=>{if(t instanceof I)return t;const u=new E("");return u.parseRaw(t),u.configurationModel});this._rawConfiguration=s.reduce((t,u)=>u===t?u:t.merge(u),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,A.getConfigurationValue)(this.contents,s):this.contents}inspect(s,t){const u=this.rawConfiguration.getValue(s),p=t?this.rawConfiguration.getOverrideValue(s,t):void 0,h=t?this.rawConfiguration.override(t).getValue(s):u;return{value:u,override:p,merged:h}}getOverrideValue(s,t){const u=this.getContentsForOverrideIdentifer(t);return u?s?(0,A.getConfigurationValue)(u,s):u:void 0}getKeysForOverrideIdentifier(s){const t=[];for(const u of this.overrides)u.identifiers.includes(s)&&t.push(...u.keys);return v.distinct(t)}getAllOverrideIdentifiers(){const s=[];for(const t of this.overrides)s.push(...t.identifiers);return v.distinct(s)}override(s){let t=this.overrideConfigurations.get(s);return t||(t=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,t)),t}merge(...s){const t=g.deepClone(this.contents),u=g.deepClone(this.overrides),p=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const C of s)if(h.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.mergeContents(t,C.contents);for(const S of C.overrides){const[c]=u.filter(r=>v.equals(r.identifiers,S.identifiers));c?(this.mergeContents(c.contents,S.contents),c.keys.push(...S.keys),c.keys=v.distinct(c.keys)):u.push(g.deepClone(S))}for(const S of C.keys)p.indexOf(S)===-1&&p.push(S)}return new I(t,p,u,h.every(C=>C instanceof I)?void 0:h)}createOverrideConfigurationModel(s){const t=this.getContentsForOverrideIdentifer(s);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const u={};for(const p of v.distinct([...Object.keys(this.contents),...Object.keys(t)])){let h=this.contents[p];const C=t[p];C&&(typeof h=="object"&&typeof C=="object"?(h=g.deepClone(h),this.mergeContents(h,C)):h=C),u[p]=h}return new I(u,this.keys,this.overrides)}mergeContents(s,t){for(const u of Object.keys(t)){if(u in s&&y.isObject(s[u])&&y.isObject(t[u])){this.mergeContents(s[u],t[u]);continue}s[u]=g.deepClone(t[u])}}getContentsForOverrideIdentifer(s){let t=null,u=null;const p=h=>{h&&(u?this.mergeContents(u,h):u=g.deepClone(h))};for(const h of this.overrides)v.equals(h.identifiers,[s])?t=h.contents:h.identifiers.includes(s)&&p(h.contents);return p(t),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,t){this.updateValue(s,t,!0)}setValue(s,t){this.updateValue(s,t,!1)}removeValue(s){const t=this.keys.indexOf(s);t!==-1&&(this.keys.splice(t,1),(0,A.removeFromValueTree)(this.contents,s),k.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(u=>v.equals(u.identifiers,(0,k.overrideIdentifiersFromKey)(s))),1))}updateValue(s,t,u){(0,A.addToValueTree)(this.contents,s,t,p=>console.error(p)),u=u||this.keys.indexOf(s)===-1,u&&this.keys.push(s),k.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,k.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,A.toValuesTree)(this.contents[s],p=>console.error(p))})}}e.ConfigurationModel=I;class E{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,t){if(!y.isUndefinedOrNull(s)){const u=this.doParseContent(s);this.parseRaw(u,t)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,t){this._raw=s;const{contents:u,keys:p,overrides:h,restricted:C,hasExcludedProperties:S}=this.doParseRaw(s,t);this._configurationModel=new I(u,p,h,S?[s]:void 0),this._restrictedConfigurations=C||[]}doParseContent(s){let t={},u=null,p=[];const h=[],C=[];function S(r){Array.isArray(p)?p.push(r):u!==null&&(p[u]=r)}const c={onObjectBegin:()=>{const r={};S(r),h.push(p),p=r,u=null},onObjectProperty:r=>{u=r},onObjectEnd:()=>{p=h.pop()},onArrayBegin:()=>{const r=[];S(r),h.push(p),p=r,u=null},onArrayEnd:()=>{p=h.pop()},onLiteralValue:S,onError:(r,P,M)=>{C.push({error:r,offset:P,length:M})}};if(s)try{d.visit(s,c),t=p[0]||{}}catch(r){console.error(`Error while parsing settings file ${this._name}: ${r}`),this._parseErrors=[r]}return t}doParseRaw(s,t){const u=w.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),p=this.filter(s,u,!0,t);s=p.raw;const h=(0,A.toValuesTree)(s,c=>console.error(`Conflict in settings file ${this._name}: ${c}`)),C=Object.keys(s),S=this.toOverrides(s,c=>console.error(`Conflict in settings file ${this._name}: ${c}`));return{contents:h,keys:C,overrides:S,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}filter(s,t,u,p){let h=!1;if(!p?.scopes&&!p?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:h};const C={},S=[];for(const c in s)if(k.OVERRIDE_PROPERTY_REGEX.test(c)&&u){const r=this.filter(s[c],t,!1,p);C[c]=r.raw,h=h||r.hasExcludedProperties,S.push(...r.restricted)}else{const r=t[c],P=r?typeof r.scope<"u"?r.scope:3:void 0;r?.restricted&&S.push(c),(P===void 0||p.scopes===void 0||p.scopes.includes(P))&&!(p.skipRestricted&&r?.restricted)?C[c]=s[c]:h=!0}return{raw:C,restricted:S,hasExcludedProperties:h}}toOverrides(s,t){const u=[];for(const p of Object.keys(s))if(k.OVERRIDE_PROPERTY_REGEX.test(p)){const h={};for(const C in s[p])h[C]=s[p][C];u.push({identifiers:(0,k.overrideIdentifiersFromKey)(p),keys:Object.keys(h),contents:(0,A.toValuesTree)(h,t)})}return u}}e.ConfigurationModelParser=E;class i extends L.Disposable{constructor(s,t,u,p){super(),this.userSettingsResource=s,this.scopes=t,this.fileService=p,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(u.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(T.Event.any(T.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource)),T.Event.filter(this.fileService.onDidRunOperation,h=>(h.isOperation(0)||h.isOperation(3)||h.isOperation(1)||h.isOperation(4))&&u.isEqual(h.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new I}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=i;class l{constructor(s,t,u,p,h,C,S,c,r,P,M,W,$){this.key=s,this.overrides=t,this._value=u,this.overrideIdentifiers=p,this.defaultConfiguration=h,this.policyConfiguration=C,this.applicationConfiguration=S,this.userConfiguration=c,this.localUserConfiguration=r,this.remoteUserConfiguration=P,this.workspaceConfiguration=M,this.folderConfigurationModel=W,this.memoryConfigurationModel=$}get value(){return D(this._value)}inspect(s,t,u){const p=s.inspect(t,u);return{get value(){return D(p.value)},get override(){return D(p.override)},get merged(){return D(p.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class a{constructor(s,t,u,p,h=new I,C=new I,S=new R.ResourceMap,c=new I,r=new R.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=t,this._applicationConfiguration=u,this._localUserConfiguration=p,this._remoteUserConfiguration=h,this._workspaceConfiguration=C,this._folderConfigurations=S,this._memoryConfiguration=c,this._memoryConfigurationByResource=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(s,t,u){return this.getConsolidatedConfigurationModel(s,t,u).getValue(s)}updateValue(s,t,u={}){let p;u.resource?(p=this._memoryConfigurationByResource.get(u.resource),p||(p=new I,this._memoryConfigurationByResource.set(u.resource,p))):p=this._memoryConfiguration,t===void 0?p.removeValue(s):p.setValue(s,t),u.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,t,u){const p=this.getConsolidatedConfigurationModel(s,t,u),h=this.getFolderConfigurationModelForResource(t.resource,u),C=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,S=new Set;for(const c of p.overrides)for(const r of c.identifiers)p.getOverrideValue(s,r)!==void 0&&S.add(r);return new l(s,t,p.getValue(s),S.size?[...S]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this._workspaceConfiguration:void 0,h||void 0,C)}keys(s){const t=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,t){this._folderConfigurations.set(s,t),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,t){const u=[];if(!t){const{added:p,updated:h,removed:C}=_(this._defaultConfiguration,s);t=[...p,...h,...C]}for(const p of t)for(const h of(0,k.overrideIdentifiersFromKey)(p)){const C=this._defaultConfiguration.getKeysForOverrideIdentifier(h),S=s.getKeysForOverrideIdentifier(h),c=[...S.filter(r=>C.indexOf(r)===-1),...C.filter(r=>S.indexOf(r)===-1),...C.filter(r=>!g.equals(this._defaultConfiguration.override(h).getValue(r),s.override(h).getValue(r)))];u.push([h,c])}return this.updateDefaultConfiguration(s),{keys:t,overrides:u}}compareAndUpdatePolicyConfiguration(s){const{added:t,updated:u,removed:p}=_(this._policyConfiguration,s),h=[...t,...u,...p];return h.length&&this.updatePolicyConfiguration(s),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:t,updated:u,removed:p,overrides:h}=_(this.applicationConfiguration,s),C=[...t,...u,...p];return C.length&&this.updateApplicationConfiguration(s),{keys:C,overrides:h}}compareAndUpdateLocalUserConfiguration(s){const{added:t,updated:u,removed:p,overrides:h}=_(this.localUserConfiguration,s),C=[...t,...u,...p];return C.length&&this.updateLocalUserConfiguration(s),{keys:C,overrides:h}}compareAndUpdateRemoteUserConfiguration(s){const{added:t,updated:u,removed:p,overrides:h}=_(this.remoteUserConfiguration,s),C=[...t,...u,...p];return C.length&&this.updateRemoteUserConfiguration(s),{keys:C,overrides:h}}compareAndUpdateWorkspaceConfiguration(s){const{added:t,updated:u,removed:p,overrides:h}=_(this.workspaceConfiguration,s),C=[...t,...u,...p];return C.length&&this.updateWorkspaceConfiguration(s),{keys:C,overrides:h}}compareAndUpdateFolderConfiguration(s,t){const u=this.folderConfigurations.get(s),{added:p,updated:h,removed:C,overrides:S}=_(u,t),c=[...p,...h,...C];return(c.length||!u)&&this.updateFolderConfiguration(s,t),{keys:c,overrides:S}}compareAndDeleteFolderConfiguration(s){const t=this.folderConfigurations.get(s);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:u,updated:p,removed:h,overrides:C}=_(t,void 0);return{keys:[...u,...p,...h],overrides:C}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,t,u){let p=this.getConsolidatedConfigurationModelForResource(t,u);return t.overrideIdentifier&&(p=p.override(t.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(p=p.merge(this._policyConfiguration)),p}getConsolidatedConfigurationModelForResource({resource:s},t){let u=this.getWorkspaceConsolidatedConfiguration();if(t&&s){const p=t.getFolder(s);p&&(u=this.getFolderConsolidatedConfiguration(p.uri)||u);const h=this._memoryConfigurationByResource.get(s);h&&(u=u.merge(h))}return u}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let t=this._foldersConsolidatedConfigurations.get(s);if(!t){const u=this.getWorkspaceConsolidatedConfiguration(),p=this._folderConfigurations.get(s);p?(t=u.merge(p),this._foldersConsolidatedConfigurations.set(s,t)):t=u}return t}getFolderConfigurationModelForResource(s,t){if(t&&s){const u=t.getFolder(s);if(u)return this._folderConfigurations.get(u.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,t)=>{const{contents:u,overrides:p,keys:h}=this._folderConfigurations.get(t);return s.push([t,{contents:u,overrides:p,keys:h}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(t=>s.add(t)),this.userConfiguration.keys.forEach(t=>s.add(t)),this._workspaceConfiguration.keys.forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.keys.forEach(u=>s.add(u))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(t=>s.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>s.add(t)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.getAllOverrideIdentifiers().forEach(u=>s.add(u))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(u=>t.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(u=>t.add(u)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(u=>t.add(u)),this._folderConfigurations.forEach(u=>u.getKeysForOverrideIdentifier(s).forEach(p=>t.add(p))),[...t.values()]}static parse(s){const t=this.parseConfigurationModel(s.defaults),u=this.parseConfigurationModel(s.policy),p=this.parseConfigurationModel(s.application),h=this.parseConfigurationModel(s.user),C=this.parseConfigurationModel(s.workspace),S=s.folders.reduce((c,r)=>(c.set(m.URI.revive(r[0]),this.parseConfigurationModel(r[1])),c),new R.ResourceMap);return new a(t,u,p,h,new I,C,S,new I,new R.ResourceMap)}static parseConfigurationModel(s){return new I(s.contents,s.keys,s.overrides)}}e.Configuration=a;function b(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,t=new Map;for(const p of o)p.keys.forEach(h=>s.add(h)),p.overrides.forEach(([h,C])=>{const S=(0,R.getOrSet)(t,h,new Set);C.forEach(c=>S.add(c))});const u=[];return t.forEach((p,h)=>u.push([h,[...p.values()]])),{keys:[...s.values()],overrides:u}}e.mergeChanges=b;class f{constructor(s,t,u,p){this.change=s,this.previous=t,this.currentConfiguraiton=u,this.currentWorkspace=p,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const h of s.keys)this.affectedKeys.add(h);for(const[,h]of s.overrides)for(const C of h)this.affectedKeys.add(C);this._affectsConfigStr=this._marker;for(const h of this.affectedKeys)this._affectsConfigStr+=h+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=a.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,t){const u=this._marker+s,p=this._affectsConfigStr.indexOf(u);if(p<0)return!1;const h=p+u.length;if(h>=this._affectsConfigStr.length)return!1;const C=this._affectsConfigStr.charCodeAt(h);if(C!==this._markerCode1&&C!==this._markerCode2)return!1;if(t){const S=this.previousConfiguration?this.previousConfiguration.getValue(s,t,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(s,t,this.currentWorkspace);return!g.equals(S,c)}return!0}}e.ConfigurationChangeEvent=f;function _(o,s){const{added:t,removed:u,updated:p}=n(s?.rawConfiguration,o?.rawConfiguration),h=[],C=o?.getAllOverrideIdentifiers()||[],S=s?.getAllOverrideIdentifiers()||[];if(s){const c=S.filter(r=>!C.includes(r));for(const r of c)h.push([r,s.getKeysForOverrideIdentifier(r)])}if(o){const c=C.filter(r=>!S.includes(r));for(const r of c)h.push([r,o.getKeysForOverrideIdentifier(r)])}if(s&&o){for(const c of C)if(S.includes(c)){const r=n({contents:o.getOverrideValue(void 0,c)||{},keys:o.getKeysForOverrideIdentifier(c)},{contents:s.getOverrideValue(void 0,c)||{},keys:s.getKeysForOverrideIdentifier(c)});h.push([c,[...r.added,...r.removed,...r.updated]])}}return{added:t,removed:u,updated:p,overrides:h}}function n(o,s){const t=o?s?o.keys.filter(h=>s.keys.indexOf(h)===-1):[...o.keys]:[],u=s?o?s.keys.filter(h=>o.keys.indexOf(h)===-1):[...s.keys]:[],p=[];if(o&&s){for(const h of s.keys)if(o.keys.indexOf(h)!==-1){const C=(0,A.getConfigurationValue)(s.contents,h),S=(0,A.getConfigurationValue)(o.contents,h);g.equals(C,S)||p.push(h)}}return{added:t,removed:u,updated:p}}}),define(De[130],Ie([1,0,8,5]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var d;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(d||(e.RemoteConnectionType=d={}));class L{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=L;class R{constructor(k,w){this.host=k,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=R;var g;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(g||(e.RemoteAuthorityResolverErrorCode=g={}));class y extends v.ErrorNoTelemetry{static isNotAvailable(k){return k instanceof y&&k._code===g.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof y&&k._code===g.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof y&&k._code===g.NoResolverFound}static isHandled(k){return k instanceof y&&k.isHandled}constructor(k,w=g.Unknown,D){super(k),this._message=k,this._code=w,this._detail=D,this.isHandled=w===g.NotAvailable&&D===!0,Object.setPrototypeOf(this,y.prototype)}}e.RemoteAuthorityResolverError=y;function m(A){const k=A.indexOf("+");return k===-1?A:A.substring(0,k)}e.getRemoteAuthorityPrefix=m}),define(De[78],Ie([1,0,16]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function T(m){return m.scheme===v.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=T;function d(m){if(!m)return;const A=m.indexOf("+");return A<0?m:m.substr(0,A)}e.getRemoteName=d;function L(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=L;function R(m){const{host:A,port:k}=y(m);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:k}}e.parseAuthorityWithPort=R;function g(m,A){let{host:k,port:w}=y(m);return typeof w>"u"&&(w=A),{host:k,port:w}}e.parseAuthorityWithOptionalPort=g;function y(m){const A=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const k=m.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const w=m.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:m,port:void 0}}}),define(De[25],Ie([1,0,9,5,78]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(R||(e.ExtensionType=R={}));var g;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.LINUX_PPC64LE="linux-ppc64le",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(g||(e.TargetPlatform=g={}));class y{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,l){if(typeof i>"u"||i===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof i=="string"||typeof l=="string"){const a=typeof i=="string"?i:i.value,b=typeof l=="string"?l:l.value;return v.equalsIgnoreCase(a,b)}return i._lower===l._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=y;class m{get size(){return this._set.size}constructor(i){if(this._set=new Set,i)for(const l of i)this.add(l)}add(i){this._set.add(y.toKey(i))}delete(i){return this._set.delete(y.toKey(i))}has(i){return this._set.has(y.toKey(i))}}e.ExtensionIdentifierSet=m;class A{constructor(){this._map=new Map}clear(){this._map.clear()}delete(i){this._map.delete(y.toKey(i))}get(i){return this._map.get(y.toKey(i))}has(i){return this._map.has(y.toKey(i))}set(i,l){this._map.set(y.toKey(i),l)}values(){return this._map.values()}forEach(i){this._map.forEach(i)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=A;function k(E){return w(E)}e.isApplicationScopedExtension=k;function w(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function D(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=D;function I(E,i){if(i){const l=`onResolveRemoteAuthority:${(0,d.getRemoteName)(i)}`;return!!E.activationEvents?.includes(l)}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[131],Ie([1,0,8,25]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class d{constructor(){this._generators=new Map,this._cache=new WeakMap}register(R,g){this._generators.set(R,g)}readActivationEvents(R){return this._cache.has(R)||this._cache.set(R,this._readActivationEvents(R)),this._cache.get(R)}createActivationEventsMap(R){const g=Object.create(null);for(const y of R){const m=this.readActivationEvents(y);m.length>0&&(g[T.ExtensionIdentifier.toKey(y.identifier)]=m)}return g}_readActivationEvents(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const g=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];if(!R.contributes)return g;for(const y in R.contributes){const m=this._generators.get(y);if(!m)continue;const A=R.contributes[y],k=Array.isArray(A)?A:[A];try{m(k,g)}catch(w){(0,v.onUnexpectedError)(w)}}return g}}e.ImplicitActivationEventsImpl=d,e.ImplicitActivationEvents=new d}),define(De[231],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class v{constructor(){this.validators=new Map}async createNewMessage(d){try{const L=await this.getValidator();if(L){const R=String(v._nextId++);return this.validators.set(R,L),{id:R,data:L.createNewMessage(d)}}}catch{}return{id:"",data:d}}async validate(d,L){if(!d.id)return!0;const R=this.validators.get(d.id);if(!R)return!1;this.validators.delete(d.id);try{return R.validate(L)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(d){try{return await this.signValue(d)}catch{}return d}}e.AbstractSignService=v,v._nextId=1}),define(De[232],Ie([1,0,231]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class T extends v.AbstractSignService{getValidator(){return this.vsda().then(L=>new L.validator)}signValue(L){return this.vsda().then(R=>new R.signer().sign(L))}vsda(){return new Promise((L,R)=>re(["vsda"],L,R))}}e.SignService=T}),define(De[233],Ie([1,0,10,41,32]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(y){if(v.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}function R(y,m,A,k,w,D,I,E){const i=Object.create(null);i["common.machineId"]=D,i.sessionID=(0,d.generateUuid)()+Date.now(),i.commitHash=k,i.version=w,i["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,v.PlatformToString)(v.platform),i["common.nodePlatform"]=T.platform,i["common.nodeArch"]=A,i["common.product"]=E||"desktop",I&&(i["common.msftInternal"]=I);let l=0;const a=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),v.isLinuxSnap&&(i["common.snap"]="true");const b=L(m);return b&&(i["common.platformDetail"]=b),i}e.resolveCommonProperties=R;function g(y){const m=T.env.USERDNSDOMAIN;if(!m)return!1;const A=m.toLowerCase();return y.some(k=>A===k)}e.verifyMicrosoftInternalDomain=g}),define(De[234],Ie([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var d;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(d||(e.TelemetryConfiguration=d={}))}),define(De[79],Ie([1,0,24,12,3,57,78,233,234]),function(re,e,v,T,d,L,R,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=m;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=A,e.NullTelemetryService=new A;class k{async publicLog(u,p,h){}async publicLogError(u,p,h){}}e.NullEndpointTelemetryService=k,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(t,u){return d.Event.debounce(u.onDidChangeConfiguration,(h,C)=>{const S=h?new Set([...h.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:S}},1e3,!0)(h=>{h.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(h.source),configurationKeys:Array.from(h.affectedKeys)})})}e.configurationTelemetry=w;function D(t,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!t.enableTelemetry||u.extensionTestsLocationURI)}e.supportsTelemetry=D;function I(t,u){return!(u.isBuilt||u.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.isLoggingOnly=I;function E(t){const u=t.getValue(y.TELEMETRY_SETTING_ID),p=t.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||p===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function i(t){const u={},p={},h={};b(t,h);for(let C in h){C=C.length>150?C.substr(C.length-149):C;const S=h[C];typeof S=="number"?p[C]=S:typeof S=="boolean"?p[C]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${S.length}`),u[C]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(u[C]=S)}return{properties:u,measurements:p}}e.validateTelemetryData=i;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(t){if(!t)return"none";const u=(0,R.getRemoteName)(t);return l.has(u)?u:"other"}e.cleanRemoteAuthority=a;function b(t,u,p=0,h){if(t)for(const C of Object.getOwnPropertyNames(t)){const S=t[C],c=h?h+C:C;Array.isArray(S)?u[c]=(0,v.safeStringify)(S):S instanceof Date?u[c]=S.toISOString():(0,T.isObject)(S)?p<2?b(S,u,p+1,c+"."):u[c]=(0,v.safeStringify)(S):u[c]=S}}function f(t,u){const p=t.msftInternalDomains||[],h=u.getValue("telemetry.internalTesting");return(0,g.verifyMicrosoftInternalDomain)(p)||h}e.isInternalTelemetry=f;function _(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.getPiiPathsFromEnvironment=_;function n(t,u){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let p=t;const h=[];for(const r of u)for(;;){const P=r.exec(t);if(!P)break;h.push([P.index,r.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(p="";;){const r=S.exec(t);if(!r)break;const P=h.some(([M,W])=>r.index<W&&M<S.lastIndex);!C.test(r[0])&&!P&&(p+=t.substring(c,r.index)+"<REDACTED: user-file-path>",c=S.lastIndex)}return c<t.length&&(p+=t.substr(c)),p}function o(t){if(!t)return t;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const p of u)if(p.regex.test(t))return`<REDACTED: ${p.label}>`;return t}function s(t,u){return(0,v.cloneAndChange)(t,p=>{if(p instanceof m||Object.hasOwnProperty.call(p,"isTrustedTelemetryValue"))return p.value;if(typeof p=="string"){let h=p.replaceAll("%20"," ");h=n(h,u);for(const C of u)h=h.replace(C,"");return h=o(h),h}})}e.cleanData=s}),define(De[235],Ie([1,0,9,125,25,10,2,8,41,79]),function(re,e,v,T,d,L,R,g,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function A(s,t){return s.uuid&&t.uuid?s.uuid===t.uuid:s.id===t.id?!0:(0,v.compareIgnoreCase)(s.id,t.id)===0}e.areSameExtensions=A;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(t){const u=t.manifest?t.manifest.version:t.version,p=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new w(t.identifier,u,p)}static parse(t){const u=k.exec(t);return u&&u[1]&&u[2]?new w({id:u[1]},u[2],u[4]||void 0):null}constructor(t,u,p="undefined"){this.version=u,this.targetPlatform=p,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof w?A(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=w;const D=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(s){const t=D.exec(s);return t&&t[1]?[i(t[1]),t[2]]:[i(s),void 0]}e.getIdAndVersion=I;function E(s,t){return`${s}.${t}`}e.getExtensionId=E;function i(s){return s.toLowerCase()}e.adoptToGalleryExtensionId=i;function l(s,t){return i(E(s??d.UNDEFINED_PUBLISHER,t))}e.getGalleryExtensionId=l;function a(s,t){const u=[],p=h=>{for(const C of u)if(C.some(S=>A(t(S),t(h))))return C;return null};for(const h of s){const C=p(h);C?C.push(h):u.push([h])}return u}e.groupByExtension=a;function b(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function f(s){return{id:new m.TelemetryTrustedValue(s.identifier.id),name:new m.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new d.ExtensionIdentifier("pprice.better-merge");function _(s,t){const u=[],p=t.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const h=p.shift();if(h&&u.every(C=>!A(C.identifier,{id:h}))){const C=s.filter(S=>A(S.identifier,{id:h}));C.length===1&&(u.push(C[0]),p.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.getExtensionDependencies=_;async function n(s,t){if(!L.isLinux)return!1;let u;try{u=(await s.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await s.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){t.debug("Error while getting the os-release file.",(0,g.getErrorMessage)(h))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,t){const u=await n(s,t),p=(0,T.getTargetPlatform)(u?"alpine":L.platform,y.arch);return t.debug("ComputeTargetPlatform:",p),p}e.computeTargetPlatform=o}),define(De[236],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function v(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=v;function T(y){return y?[...y.entries()]:[]}e.serializeEnvironmentDescriptionMap=T;function d(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=d;function L(y){return new Map(y??[])}e.deserializeEnvironmentDescriptionMap=L;function R(y){return Array.from(y.entries()).map(m=>[m[0],v(m[1].map),T(m[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=R;function g(y){return new Map(y.map(m=>[m[0],{map:d(m[1]),descriptionMap:L(m[2])}]))}e.deserializeEnvironmentVariableCollections=g}),define(De[237],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class v{constructor(d){this._callback=d,this._terminalBufferMap=new Map}dispose(){for(const d of this._terminalBufferMap.values())d.dispose()}startBuffering(d,L,R=5){const g=L(y=>{const m=typeof y=="string"?y:y.data;let A=this._terminalBufferMap.get(d);if(A){A.data.push(m);return}const k=setTimeout(()=>this.flushBuffer(d),R);A={data:[m],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(d),g.dispose()}},this._terminalBufferMap.set(d,A)});return g}stopBuffering(d){this._terminalBufferMap.get(d)?.dispose()}flushBuffer(d){const L=this._terminalBufferMap.get(d);L&&(this._terminalBufferMap.delete(d),this._callback(d,L.data.join("")))}}e.TerminalDataBufferer=v}),define(De[238],Ie([1,0,17,72,55,3,12,2,186,100,42]),function(re,e,v,T,d,L,R,g,y,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var k;(function(f){function _(n,o){let s=n.defaults;for(;d.ThemeIcon.isThemeIcon(s);){const t=I.getIcon(s.id);if(!t)return;s=t.defaults}return s}f.getDefinition=_})(k||(e.IconContribution=k={}));var w;(function(f){function _(o){return{weight:o.weight,style:o.style,src:o.src.map(s=>({format:s.format,location:s.location.toString()}))}}f.toJSONObject=_;function n(o){const s=t=>(0,R.isString)(t)?t:void 0;if(o&&Array.isArray(o.src)&&o.src.every(t=>(0,R.isString)(t.format)&&(0,R.isString)(t.location)))return{weight:s(o.weight),style:s(o.style),src:o.src.map(t=>({format:t.format,location:g.URI.parse(t.location)}))}}f.fromJSONObject=n})(w||(e.IconFontDefinition=w={}));class D{constructor(){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${d.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(_,n,o,s){const t=this.iconsById[_];if(t){if(o&&!t.description){t.description=o,this.iconSchema.properties[_].markdownDescription=`${o} $(${_})`;const h=this.iconReferenceSchema.enum.indexOf(_);h!==-1&&(this.iconReferenceSchema.enumDescriptions[h]=o),this._onDidChange.fire()}return t}const u={id:_,description:o,defaults:n,deprecationMessage:s};this.iconsById[_]=u;const p={$ref:"#/definitions/icons"};return s&&(p.deprecationMessage=s),o&&(p.markdownDescription=`${o}: $(${_})`),this.iconSchema.properties[_]=p,this.iconReferenceSchema.enum.push(_),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:_}}deregisterIcon(_){delete this.iconsById[_],delete this.iconSchema.properties[_];const n=this.iconReferenceSchema.enum.indexOf(_);n!==-1&&(this.iconReferenceSchema.enum.splice(n,1),this.iconReferenceSchema.enumDescriptions.splice(n,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(_=>this.iconsById[_])}getIcon(_){return this.iconsById[_]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(_,n){const o=this.iconFontsById[_];return o||(this.iconFontsById[_]=n,this._onDidChange.fire(),n)}deregisterIconFont(_){delete this.iconFontsById[_]}getIconFont(_){return this.iconFontsById[_]}toString(){const _=(t,u)=>t.id.localeCompare(u.id),n=t=>{for(;d.ThemeIcon.isThemeIcon(t.defaults);)t=this.iconsById[t.defaults.id];return`codicon codicon-${t?t.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.iconsById).map(t=>this.iconsById[t]);for(const t of s.filter(u=>!!u.description).sort(_))o.push(`|<i class="${n(t)}"></i>|${t.id}|${d.ThemeIcon.isThemeIcon(t.defaults)?t.defaults.id:t.id}|${t.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const t of s.filter(u=>!d.ThemeIcon.isThemeIcon(u.defaults)).sort(_))o.push(`|<i class="${n(t)}"></i>|${t.id}|`);return o.join(`
`)}}const I=new D;A.Registry.add(e.Extensions.IconContribution,I);function E(f,_,n,o){return I.registerIcon(f,_,n,o)}e.registerIcon=E;function i(){return I}e.getIconRegistry=i;function l(){const f=(0,T.getCodiconFontCharacters)();for(const _ in f){const n="\\"+f[_].toString(16);I.registerIcon(_,{fontCharacter:n})}}l(),e.iconsSchemaId="vscode://schemas/icons";const a=A.Registry.as(m.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,I.getIconSchema());const b=new v.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);I.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.widgetClose=E("widget-close",T.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=E("goto-previous-location",T.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=E("goto-next-location",T.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=d.ThemeIcon.modify(T.Codicon.sync,"spin"),e.spinningLoading=d.ThemeIcon.modify(T.Codicon.loading,"spin")}),define(De[132],Ie([1,0,3,57,5,18]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,d.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,d.createDecorator)("sharedTunnelsService");var R;(function(E){E.Http="http",E.Https="https"})(R||(e.TunnelProtocol=R={}));var g;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(g||(e.TunnelPrivacyId=g={}));var y;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function m(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(i)return{address:i[1],port:+i[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function A(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=A,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=k;function w(E,i,l,a){if(l===1)return!1;if(l===2&&k(i)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(b?.length===4&&parseInt(b[1])>=18)return!1}return E<1024}e.isPortPrivileged=w;class D{constructor(i,l,a){this.remoteAddress=i,this.localAddress=l,this._dispose=a,this._onDispose=new v.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=D;let I=e.AbstractTunnelService=class{constructor(i,l){this.logService=i,this.configurationService=l,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const i=this.configurationService.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this._tunnelProvider=i,i?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this._canElevate=i.elevation,this._privacyOptions=i.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const i=[],l=Array.from(this._tunnels.values());for(const a of l){const b=Array.from(a.values());for(const f of b){const _=await f.value;_&&i.push(_)}}return i}async dispose(){for(const i of this._tunnels.values()){for(const{value:l}of i.values())await l.then(a=>a?.dispose());i.clear()}this._tunnels.clear()}setEnvironmentTunnel(i,l,a,b,f){this.addTunnelToMap(i,l,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:l,localAddress:a,privacy:b,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,l){(k(i)||A(i))&&(i=e.LOCALHOST_ADDRESSES[0]);const a=this.getTunnelFromMap(i,l);if(a)return++a.refcount,a.value}openTunnel(i,l,a,b,f,_=!1,n,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${a} on local port ${f}.`),!i)return;if(l||(l="localhost"),b||(b=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(a)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.retainOrCreateTunnel(i,l,a,b,f,_,n,o);return s?s.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(l,a);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.makeTunnel(t);return(t.tunnelRemoteHost!==l||t.tunnelRemotePort!==a)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&t.privacy!==n&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(u),u}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const l=this._tunnels.get(i.tunnelRemoteHost);if(l){const a=l.get(i.tunnelRemotePort);a&&(a.refcount--,await this.tryDisposeTunnel(i.tunnelRemoteHost,i.tunnelRemotePort,a))}}}}async tryDisposeTunnel(i,l,a){if(a.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${l}.`);const b=a.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(i)&&this._tunnels.get(i).delete(l),b}}async closeTunnel(i,l){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${l} `);const a=this._tunnels.get(i);if(a&&a.has(l)){const b=a.get(l);b.refcount=0,await this.tryDisposeTunnel(i,l,b)}}addTunnelToMap(i,l,a){this._tunnels.has(i)||this._tunnels.set(i,new Map),this._tunnels.get(i).set(l,{refcount:1,value:a})}async removeEmptyTunnelFromMap(i,l){const a=this._tunnels.get(i);if(a){const b=a.get(l);(b?await b.value:void 0)||a.delete(l),a.size===0&&this._tunnels.delete(i)}}getTunnelFromMap(i,l){const a=[i];A(i)?(a.push(...e.LOCALHOST_ADDRESSES),a.push(...e.ALL_INTERFACES_ADDRESSES)):k(i)&&a.push(...e.ALL_INTERFACES_ADDRESSES);const b=a.map(f=>this._tunnels.get(f));for(const f of b){const _=f?.get(l);if(_)return _}}canTunnel(i){return!!m(i)}createWithProvider(i,l,a,b,f,_,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${a} on local port ${b}.`);const o=a;this._factoryInProgress.add(o);const s=b===void 0?a:b,t={elevationRequired:f?this.isPortPrivileged(s):!1},u={remoteAddress:{host:l,port:a},localAddressPort:b,privacy:_,public:_?_!==g.Private:void 0,protocol:n},p=i.forwardPort(u,t);return p?(this.addTunnelToMap(l,a,p),p.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),p}};e.AbstractTunnelService=I=Ve([ze(0,L.ILogService),ze(1,T.IConfigurationService)],I)}),define(De[239],Ie([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,v.createDecorator)("editSessionIdentityService");var T;(function(d){d[d.Complete=100]="Complete",d[d.Partial=50]="Partial",d[d.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(De[240],Ie([1,0,16]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function T(y){return y.scheme!==v.Schemas.file&&y.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=T;function d(y){if(y.folders.length)return y.folders.every(m=>T(m.uri))?y.folders[0].uri:void 0;if(y.configuration&&T(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=d;function L(y){return d(y)?.scheme}e.getVirtualWorkspaceScheme=L;function R(y){return d(y)?.authority}e.getVirtualWorkspaceAuthority=R;function g(y){return d(y)!==void 0}e.isVirtualWorkspace=g}),define(De[50],Ie([1,0,187,11,71,23,2,5,16]),function(re,e,v,T,d,L,R,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,g.createDecorator)("contextService");function m(t){const u=t;return typeof u?.id=="string"&&R.URI.isUri(u.uri)}e.isSingleFolderWorkspaceIdentifier=m;function A(t){return typeof t?.id=="string"&&!m(t)&&!w(t)}e.isEmptyWorkspaceIdentifier=A,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function k(t,u){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,T.basename)(t)}:u?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const p=t;return p.configuration?{id:p.id,configPath:p.configuration}:p.folders.length===1?{id:p.id,uri:p.folders[0].uri}:{id:p.id}}e.toWorkspaceIdentifier=k;function w(t){const u=t;return typeof u?.id=="string"&&R.URI.isUri(u.configPath)}e.isWorkspaceIdentifier=w;function D(t){const u=t;if(u?.uri)return{id:u.id,uri:R.URI.revive(u.uri)};const p=t;if(p?.configPath)return{id:p.id,configPath:R.URI.revive(p.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=D;var I;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(I||(e.WorkbenchState=I={}));function E(t){const u=t;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.isWorkspace=E;function i(t){const u=t;return!!(u&&typeof u=="object"&&R.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.isWorkspaceFolder=i;class l{constructor(u,p,h,C,S){this._id=u,this._transient=h,this._configuration=C,this._ignorePathCasing=S,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=p}update(u){this._id=u.id,this._configuration=u.configuration,this._transient=u.transient,this._ignorePathCasing=u._ignorePathCasing,this.folders=u.folders}get folders(){return this._folders}set folders(u){this._folders=u,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(u){this._configuration=u}getFolder(u){return u&&this._foldersMap.findSubstr(u)||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const u of this.folders)this._foldersMap.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class a{constructor(u,p){this.raw=p,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,L.joinPath)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=a;function b(t){return new a({uri:t,index:0,name:(0,L.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,v.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(t,u){return L.extUriBiasedIgnorePathCase.isEqualOrParent(t,u.untitledWorkspacesHome)}e.isUntitledWorkspace=f;function _(t){let u;return R.URI.isUri(t)?u=t:u=t.configuration,u?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=_,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(t){return t.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=n;function o(t,u){return!f(t,u)&&!_(t)}e.isSavedWorkspace=o;function s(t){return(typeof t=="string"?(0,T.extname)(t):(0,L.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(De[80],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class v{constructor(d){this.id=d,this._data=new Map,this._idPool=1}add(d){const L=this._idPool++;return this._data.set(L,d),this.logDebugInfo(),L}get(d,L){return this._data.has(d)?this._data.get(d)[L]:void 0}delete(d){this._data.delete(d),this.logDebugInfo()}logDebugInfo(){v.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=v,v.enableDebugLogging=!1}),define(De[51],Ie([1,0,16,23,5]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this._systemSchemes=new Set(Object.keys(v.Schemas)),this._providerInfo=new Map,this.extUri=new T.ExtUri(g=>{const y=this._providerInfo.get(g.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(g,y){y===null?this._providerInfo.delete(g.scheme):this._providerInfo.set(g.scheme,y)}isFreeScheme(g){return!this._providerInfo.has(g)&&!this._systemSchemes.has(g)}getCapabilities(g){return this._providerInfo.get(g)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,d.createDecorator)("IExtHostFileSystemInfo")}),define(De[26],Ie([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,v.createDecorator)("IExtHostInitDataService")}),define(De[241],Ie([1,0,192,18,225,26]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=e.ExtHostLogService=class extends d.LogService{constructor(y,m,A){const k=A.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",w=A.remote.isRemote?(0,v.localize)(0,null):y?(0,v.localize)(1,null):(0,v.localize)(2,null);super(m.createLogger(k,{name:w}))}};e.ExtHostLogService=R=Ve([ze(1,T.ILoggerService),ze(2,L.IExtHostInitDataService)],R)}),define(De[242],Ie([1,0,17]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(R,g,y){this._deferredPromises=new Map,this._id=R,this._shared=g,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(m=>(this._value=m,this)),this._storageListener=this._storage.onDidChangeStorage(m=>{m.shared===this._shared&&m.key===this._id&&(this._value=m.value)}),this._scheduler=new v.RunOnceScheduler(()=>{const m=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const A of m.values())A.complete()}catch(A){for(const k of m.values())k.error(A)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,g){let y=this._value[R];return typeof y>"u"&&(y=g),y}update(R,g){this._value[R]=g;const y=this._deferredPromises.get(R);if(y!==void 0)return y.p;const m=new v.DeferredPromise;return this._deferredPromises.set(R,m),this._scheduler.isScheduled()||this._scheduler.schedule(),m.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=T;class d extends T{setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}constructor(R,g){super(R.identifier.value,!0,g),this._extension=R}}e.ExtensionGlobalMemento=d}),define(De[243],Ie([1,0,3,2]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class d{constructor(R){this._notebooksAndEditors=R,this._onDidSaveNotebookDocument=new v.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new v.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(R,g,y,m){const k=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(R)).acceptModelChanged(g.value,y,m);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(R,g){this._notebooksAndEditors.getNotebookDocument(T.URI.revive(R)).acceptDirty(g)}$acceptModelSaved(R){const g=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(R));this._onDidSaveNotebookDocument.fire(g.apiNotebook)}}e.ExtHostNotebookDocuments=d}),define(De[20],Ie([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,v.createDecorator)("IExtHostRpcService");class T{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=T});var Ye=this&&this.__classPrivateFieldSet||function(re,e,v,T,d){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!d)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!d:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?d.call(re,v):d?d.value=v:e.set(re,v),v},Fe=this&&this.__classPrivateFieldGet||function(re,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!T:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(re):T?T.value:e.get(re)};define(De[244],Ie([1,0,25,3]),function(re,e,v,T){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{constructor(g,y){d.set(this,void 0),this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._id=v.ExtensionIdentifier.toKey(g.identifier),Ye(this,d,y,"f"),Fe(this,d,"f").onDidChangePassword(m=>{m.extensionId===this._id&&this._onDidChange.fire({key:m.key})})}get(g){return Fe(this,d,"f").get(this._id,g)}store(g,y){return Fe(this,d,"f").store(this._id,g,y)}delete(g){return Fe(this,d,"f").delete(this._id,g)}}e.ExtensionSecrets=L,d=new WeakMap}),define(De[58],Ie([1,0,5,132,3,20]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var R;(function(y){function m(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?T.TunnelPrivacyId.Public:T.TunnelPrivacyId.Private),protocol:k.protocol}}y.fromApiTunnel=m;function A(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==T.TunnelPrivacyId.ConstantPrivate&&k.privacy!==T.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}y.fromServiceTunnel=A})(R||(e.TunnelDtoConverter=R={})),e.IExtHostTunnelService=(0,v.createDecorator)("IExtHostTunnelService");let g=e.ExtHostTunnelService=class{constructor(m){this.onDidChangeTunnels=new d.Emitter().event}async $applyCandidateFilter(m){return m}async openTunnel(m,A){}async getTunnels(){return[]}async setTunnelFactory(m){return{dispose:()=>{}}}registerPortsAttributesProvider(m,A){return{dispose:()=>{}}}async $providePortAttributes(m,A,k,w,D){return[]}async $forwardPort(m,A){}async $closeTunnel(m){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};e.ExtHostTunnelService=g=Ve([ze(0,L.IExtHostRpcService)],g)}),define(De[59],Ie([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,v.createDecorator)("IURITransformerService");class T{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=T}),define(De[245],Ie([1,0,22]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(y){let m=this.buffers.indexOf(y);return m<0&&(m=this.buffers.length,this.buffers.push(y)),m}}function d(g,y){if(y.serializeBuffersForPostMessage){const m=new T,k=JSON.stringify(g,(D,I)=>{if(I instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:m.add(I)};if(ArrayBuffer.isView(I)){const E=L(I);if(E)return{$$vscode_array_buffer_reference$$:!0,index:m.add(I.buffer),view:{type:E,byteLength:I.byteLength,byteOffset:I.byteOffset}}}return I}),w=m.buffers.map(D=>{const I=new Uint8Array(D);return v.VSBuffer.wrap(I)});return{message:k,buffers:w}}else return{message:JSON.stringify(g),buffers:[]}}e.serializeWebviewMessage=d;function L(g){switch(g.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(g,y){const m=y.map(w=>{const D=new ArrayBuffer(w.byteLength);return new Uint8Array(D).set(w.buffer),D}),A=y.length?(w,D)=>{if(D&&typeof D=="object"&&D.$$vscode_array_buffer_reference$$){const I=D,{index:E}=I,i=m[E];if(I.view)switch(I.view.type){case 1:return new Int8Array(i,I.view.byteOffset,I.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(i,I.view.byteOffset,I.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(i,I.view.byteOffset,I.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(i,I.view.byteOffset,I.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(i,I.view.byteOffset,I.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(i,I.view.byteOffset,I.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(i,I.view.byteOffset,I.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(i,I.view.byteOffset,I.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(i,I.view.byteOffset,I.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(i,I.view.byteOffset,I.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(i,I.view.byteOffset,I.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return i}return D}:void 0;return{message:JSON.parse(g,A),arrayBuffers:m}}e.deserializeWebviewMessage=R}),define(De[246],Ie([1,0,247,348,349,101,2,350]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function y(I,E,i,l,a,b){const f=b.environment.useHostProxy,_=typeof f=="boolean"?f:!b.remote.isRemote,n={resolveProxy:t=>I.resolveProxy(t),getHttpProxySetting:()=>E.getConfiguration("http").get("proxy"),log:(t,u,...p)=>{switch(t){case g.LogLevel.Trace:l.trace(u,...p);break;case g.LogLevel.Debug:l.debug(u,...p);break;case g.LogLevel.Info:l.info(u,...p);break;case g.LogLevel.Warning:l.warn(u,...p);break;case g.LogLevel.Error:l.error(u,...p);break;case g.LogLevel.Critical:l.error(u,...p);break;case g.LogLevel.Off:break;default:h(t,u,p);break}function h(C,S,...c){l.error("Unknown log level",C),l.error(S,...c)}},getLogLevel:()=>l.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:_,useSystemCertificatesV2:k(E),addCertificates:[],env:process.env};E.onDidChangeConfiguration(t=>{n.useSystemCertificatesV2=k(E)});const o=(0,g.createProxyResolver)(n),s=m(n,E,o);return D(i,s)}e.connectProxyResolver=y;function m(I,E,i){const l={config:E.getConfiguration("http").get("proxySupport")||"off"};E.onDidChangeConfiguration(b=>{l.config=E.getConfiguration("http").get("proxySupport")||"off"});const a={config:A(E)};return E.onDidChangeConfiguration(b=>{a.config=A(E)}),{http:{off:Object.assign({},v,(0,g.createHttpPatch)(v,i,{config:"off"},a,!0)),on:Object.assign({},v,(0,g.createHttpPatch)(v,i,{config:"on"},a,!0)),override:Object.assign({},v,(0,g.createHttpPatch)(v,i,{config:"override"},a,!0)),onRequest:Object.assign({},v,(0,g.createHttpPatch)(v,i,l,a,!0)),default:Object.assign(v,(0,g.createHttpPatch)(v,i,l,a,!1))},https:{off:Object.assign({},T,(0,g.createHttpPatch)(T,i,{config:"off"},a,!0)),on:Object.assign({},T,(0,g.createHttpPatch)(T,i,{config:"on"},a,!0)),override:Object.assign({},T,(0,g.createHttpPatch)(T,i,{config:"override"},a,!0)),onRequest:Object.assign({},T,(0,g.createHttpPatch)(T,i,l,a,!0)),default:Object.assign(T,(0,g.createHttpPatch)(T,i,l,a,!1))},net:Object.assign(L,(0,g.createNetPatch)(I,L)),tls:Object.assign(d,(0,g.createTlsPatch)(I,d))}}function A(I){const E=I.getConfiguration("http");return!E.get("experimental.systemCertificatesV2")&&!!E.get("systemCertificates")}function k(I){const E=I.getConfiguration("http");return!!E.get("experimental.systemCertificatesV2")&&!!E.get("systemCertificates")}const w=new Map;function D(I,E){return I.getExtensionPathIndex().then(i=>{const l=globalThis._VSCODE_NODE_MODULES.module,a=l._load;l._load=function(f,_,n){if(f==="net")return E.net;if(f==="tls")return E.tls;if(f!=="http"&&f!=="https")return a.apply(this,arguments);const o=E[f],s=i.findSubstr(R.URI.file(_.filename));let t=w.get(s);if(t||w.set(s,t={}),!t[f]){const u=o.default;t[f]={...u}}return t[f]}})}}),define(De[248],Ie([1,0,121]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function T(L){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:L,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function d(L){return new v.URITransformer(T(L))}e.createURITransformer=d}),define(De[133],Ie([1,0,201,12,2,4,5,42,30,16,45,167,40]),function(re,e,v,T,d,L,R,g,y,m,A,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,v.localize)(0,null),providerDisplayName:(0,v.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var D;(function(V){V[V.PROGRAMMATIC=1]="PROGRAMMATIC",V[V.USER=2]="USER",V[V.EDIT=3]="EDIT",V[V.NAVIGATION=4]="NAVIGATION",V[V.JUMP=5]="JUMP"})(D||(e.EditorPaneSelectionChangeReason=D={}));var I;(function(V){V[V.IDENTICAL=1]="IDENTICAL",V[V.SIMILAR=2]="SIMILAR",V[V.DIFFERENT=3]="DIFFERENT"})(I||(e.EditorPaneSelectionCompareResult=I={}));function E(V){const ce=V;return!!ce&&typeof ce.getSelection=="function"&&!!ce.onDidChangeSelection}e.isEditorPaneWithSelection=E;function i(V,ce,be){for(const Se of be.visibleEditorPanes)if(Se.group.id===ce&&V.matches(Se.input))return Se.getViewState()}e.findViewStateForEditor=i;function l(V){if(p(V))return!1;const ce=V;return d.URI.isUri(ce?.resource)}e.isResourceEditorInput=l;function a(V){if(p(V))return!1;const ce=V;return ce?.original!==void 0&&ce.modified!==void 0}e.isResourceDiffEditorInput=a;function b(V){if(p(V)||a(V))return!1;const ce=V;return ce?.primary!==void 0&&ce.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function f(V){if(p(V))return!1;const ce=V;return ce?ce.resource===void 0||ce.resource.scheme===m.Schemas.untitled||ce.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=f;function _(V){if(p(V))return!1;const ce=V;return d.URI.isUri(ce?.base?.resource)&&d.URI.isUri(ce?.input1?.resource)&&d.URI.isUri(ce?.input2?.resource)&&d.URI.isUri(ce?.result?.resource)}e.isResourceMergeEditorInput=_;var n;(function(V){V[V.SHORT=0]="SHORT",V[V.MEDIUM=1]="MEDIUM",V[V.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var o;(function(V){V[V.EXPLICIT=1]="EXPLICIT",V[V.AUTO=2]="AUTO",V[V.FOCUS_CHANGE=3]="FOCUS_CHANGE",V[V.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o||(e.SaveReason=o={}));class s{constructor(){this.mapIdToSaveSource=new Map}registerSource(ce,be){let Se=this.mapIdToSaveSource.get(ce);return Se||(Se={source:ce,label:be},this.mapIdToSaveSource.set(ce,Se)),Se.source}getSourceLabel(ce){return this.mapIdToSaveSource.get(ce)?.label??ce}}e.SaveSourceRegistry=new s;var t;(function(V){V[V.None=0]="None",V[V.Readonly=2]="Readonly",V[V.Untitled=4]="Untitled",V[V.Singleton=8]="Singleton",V[V.RequiresTrust=16]="RequiresTrust",V[V.CanSplitInGroup=32]="CanSplitInGroup",V[V.ForceDescription=64]="ForceDescription",V[V.CanDropIntoEditor=128]="CanDropIntoEditor",V[V.MultipleEditors=256]="MultipleEditors",V[V.Scratchpad=512]="Scratchpad"})(t||(e.EditorInputCapabilities=t={}));class u extends L.Disposable{}e.AbstractEditorInput=u;function p(V){return V instanceof u}e.isEditorInput=p;function h(V){const ce=V;return d.URI.isUri(ce?.preferredResource)}function C(V){const ce=V;return p(ce?.primary)&&p(ce?.secondary)}e.isSideBySideEditorInput=C;function S(V){const ce=V;return p(ce?.modified)&&p(ce?.original)}e.isDiffEditorInput=S;function c(V,ce,be,Se,ge){return H(Se,[(0,k.toAction)({id:"workbench.action.openLargeFile",label:(0,v.localize)(2,null),run:()=>{const O={...be,limits:{size:Number.MAX_VALUE}};V.openEditor(ce,O)}}),(0,k.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(3,null),run:()=>ge.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}e.createTooLargeFileError=c;function r(V){return p(V?.editor)}e.isEditorInputWithOptions=r;function P(V){const ce=V;return r(V)&&ce?.group!==void 0}e.isEditorInputWithOptionsAndGroup=P;function M(V){const ce=V;return typeof ce?.groupId=="number"&&p(ce.editor)}e.isEditorIdentifier=M;var W;(function(V){V[V.UNKNOWN=0]="UNKNOWN",V[V.REPLACE=1]="REPLACE",V[V.MOVE=2]="MOVE",V[V.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var $;(function(V){V[V.GROUP_ACTIVE=0]="GROUP_ACTIVE",V[V.GROUP_INDEX=1]="GROUP_INDEX",V[V.GROUP_LOCKED=2]="GROUP_LOCKED",V[V.EDITOR_OPEN=3]="EDITOR_OPEN",V[V.EDITOR_CLOSE=4]="EDITOR_CLOSE",V[V.EDITOR_MOVE=5]="EDITOR_MOVE",V[V.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",V[V.EDITOR_LABEL=7]="EDITOR_LABEL",V[V.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",V[V.EDITOR_PIN=9]="EDITOR_PIN",V[V.EDITOR_STICKY=10]="EDITOR_STICKY",V[V.EDITOR_DIRTY=11]="EDITOR_DIRTY",V[V.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})($||(e.GroupModelChangeKind=$={}));var z;(function(V){V[V.PRIMARY=1]="PRIMARY",V[V.SECONDARY=2]="SECONDARY",V[V.BOTH=3]="BOTH",V[V.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class N{getOriginalUri(ce,be){if(!ce)return;if(_(ce))return e.EditorResourceAccessor.getOriginalUri(ce.result,be);if(be?.supportSideBySide){const{primary:ge,secondary:O}=this.getSideEditors(ce);if(ge&&O){if(be?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(ge,{filterByScheme:be.filterByScheme}),secondary:this.getOriginalUri(O,{filterByScheme:be.filterByScheme})};if(be?.supportSideBySide===z.ANY)return this.getOriginalUri(ge,{filterByScheme:be.filterByScheme})??this.getOriginalUri(O,{filterByScheme:be.filterByScheme});ce=be.supportSideBySide===z.PRIMARY?ge:O}}if(a(ce)||b(ce)||_(ce))return;const Se=h(ce)?ce.preferredResource:ce.resource;return!Se||!be||!be.filterByScheme?Se:this.filterUri(Se,be.filterByScheme)}getSideEditors(ce){return C(ce)||b(ce)?{primary:ce.primary,secondary:ce.secondary}:S(ce)||a(ce)?{primary:ce.modified,secondary:ce.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ce,be){if(!ce)return;if(_(ce))return e.EditorResourceAccessor.getCanonicalUri(ce.result,be);if(be?.supportSideBySide){const{primary:ge,secondary:O}=this.getSideEditors(ce);if(ge&&O){if(be?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(ge,{filterByScheme:be.filterByScheme}),secondary:this.getCanonicalUri(O,{filterByScheme:be.filterByScheme})};if(be?.supportSideBySide===z.ANY)return this.getCanonicalUri(ge,{filterByScheme:be.filterByScheme})??this.getCanonicalUri(O,{filterByScheme:be.filterByScheme});ce=be.supportSideBySide===z.PRIMARY?ge:O}}if(a(ce)||b(ce)||_(ce))return;const Se=ce.resource;return!Se||!be||!be.filterByScheme?Se:this.filterUri(Se,be.filterByScheme)}filterUri(ce,be){if(Array.isArray(be)){if(be.some(Se=>ce.scheme===Se))return ce}else if(be===ce.scheme)return ce}}e.EditorResourceAccessor=new N;var q;(function(V){V[V.LEFT=0]="LEFT",V[V.RIGHT=1]="RIGHT"})(q||(e.CloseDirection=q={}));class x{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(ce){const be=this.instantiationService=ce.get(R.IInstantiationService);for(const[Se,ge]of this.editorSerializerConstructors)this.createEditorSerializer(Se,ge,be);this.editorSerializerConstructors.clear()}createEditorSerializer(ce,be,Se){const ge=Se.createInstance(be);this.editorSerializerInstances.set(ce,ge)}registerFileEditorFactory(ce){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=ce}getFileEditorFactory(){return(0,T.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(ce,be){if(this.editorSerializerConstructors.has(ce)||this.editorSerializerInstances.has(ce))throw new Error(`A editor serializer with type ID '${ce}' was already registered.`);return this.instantiationService?this.createEditorSerializer(ce,be,this.instantiationService):this.editorSerializerConstructors.set(ce,be),(0,L.toDisposable)(()=>{this.editorSerializerConstructors.delete(ce),this.editorSerializerInstances.delete(ce)})}getEditorSerializer(ce){return this.editorSerializerInstances.get(typeof ce=="string"?ce:ce.typeId)}}g.Registry.add(e.EditorExtensions.EditorFactory,new x);async function U(V,ce,be){return!V||!V.length?[]:await Promise.all(V.map(async Se=>{const ge=d.URI.revive(Se.fileUri);if(!ge){be.info("Cannot resolve the path because it is not valid.",Se);return}if(!await ce.canHandleResource(ge)){be.info("Cannot resolve the path because it cannot be handled",Se);return}let K=Se.exists,we=Se.type;if(typeof K!="boolean"||typeof we!="number")try{we=(await ce.stat(ge)).isDirectory?y.FileType.Directory:y.FileType.Unknown,K=!0}catch(ee){be.error(ee),K=!1}if(!K&&Se.openOnlyIfExists){be.info("Cannot resolve the path because it does not exist",Se);return}if(we===y.FileType.Directory){be.info("Cannot resolve the path because it is a directory",Se);return}const Ce={...Se.options,pinned:!0};return K?{resource:ge,options:Ce}:{resource:ge,options:Ce,forceUntitled:!0}}))}e.pathsToEditors=U;var de;(function(V){V[V.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",V[V.SEQUENTIAL=1]="SEQUENTIAL"})(de||(e.EditorsOrder=de={}));function ie(V){const ce=V;if(!ce)return!1;const be=ce;if(be.modified)return ie(be.modified);const Se=ce;return!!(Se.contributionsState&&Se.viewState&&Array.isArray(Se.cursorState))}e.isTextEditorViewState=ie;function ne(V){return(0,A.isErrorWithActions)(V)}e.isEditorOpenError=ne;function H(V,ce,be){const Se=(0,A.createErrorWithActions)(V,ce);return Se.forceMessage=be?.forceMessage,Se.forceSeverity=be?.forceSeverity,Se.allowDialog=be?.allowDialog,Se}e.createEditorOpenError=H}),define(De[249],Ie([1,0,3,202,5,4,28,42,19,65,24,72,238]),function(re,e,v,T,d,L,R,g,y,m,A,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,w.registerIcon)("default-view-icon",k.Codicon.window,(0,T.localize)(0,null));var D;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(D||(e.Extensions=D={}));var I;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(I||(e.ViewContainerLocation=I={})),e.ViewContainerLocations=[0,1,2];function E(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=E;class i extends L.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new v.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new v.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,y.flatten)([...this.viewContainers.values()])}registerViewContainer(t,u,p){const h=this.get(t.id);if(h)return h;const C=t;return C.openCommandActionDescriptor=p?.doNotRegisterOpenCommand?void 0:C.openCommandActionDescriptor??{id:C.id},(0,R.getOrSet)(this.viewContainers,u,[]).push(C),p?.isDefault&&this.defaultViewContainers.push(C),this._onDidRegister.fire({viewContainer:C,viewContainerLocation:u}),C}deregisterViewContainer(t){for(const u of this.viewContainers.keys()){const p=this.viewContainers.get(u),h=p?.indexOf(t);if(h!==-1){p?.splice(h,1),p.length===0&&this.viewContainers.delete(u),this._onDidDeregister.fire({viewContainer:t,viewContainerLocation:u});return}}}get(t){return this.all.filter(u=>u.id===t)[0]}getViewContainers(t){return[...this.viewContainers.get(t)||[]]}getViewContainerLocation(t){return[...this.viewContainers.keys()].filter(u=>this.getViewContainers(u).filter(p=>p?.id===t.id).length>0)[0]}getDefaultViewContainer(t){return this.defaultViewContainers.find(u=>this.getViewContainerLocation(u)===t)}}g.Registry.add(D.ViewContainersRegistry,new i);var l;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(l||(e.ViewContentGroups=l={}));function a(s,t){const u=s.group??l.More,p=t.group??l.More;return u!==p?u.localeCompare(p):(s.order??5)-(t.order??5)}class b extends L.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new v.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new v.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new v.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new v.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new m.SetMap}registerViews(t,u){this.registerViews2([{views:t,viewContainer:u}])}registerViews2(t){t.forEach(({views:u,viewContainer:p})=>this.addViews(u,p)),this._onViewsRegistered.fire(t)}deregisterViews(t,u){const p=this.removeViews(t,u);p.length&&this._onViewsDeregistered.fire({views:p,viewContainer:u})}moveViews(t,u){for(const p of this._views.keys())if(p!==u){const h=this.removeViews(t,p);h.length&&(this.addViews(h,u),this._onDidChangeContainer.fire({views:h,from:p,to:u}))}}getViews(t){return this._views.get(t)||[]}getView(t){for(const u of this._viewContainers){const p=(this._views.get(u)||[]).filter(h=>h.id===t)[0];if(p)return p}return null}getViewContainer(t){for(const u of this._viewContainers)if((this._views.get(u)||[]).filter(h=>h.id===t)[0])return u;return null}registerViewWelcomeContent(t,u){return this._viewWelcomeContents.add(t,u),this._onDidChangeViewWelcomeContent.fire(t),(0,L.toDisposable)(()=>{this._viewWelcomeContents.delete(t,u),this._onDidChangeViewWelcomeContent.fire(t)})}registerViewWelcomeContent2(t,u){const p=new Map;for(const[h,C]of u)this._viewWelcomeContents.add(t,C),p.set(h,(0,L.toDisposable)(()=>{this._viewWelcomeContents.delete(t,C),this._onDidChangeViewWelcomeContent.fire(t)}));return this._onDidChangeViewWelcomeContent.fire(t),p}getViewWelcomeContent(t){const u=[];return this._viewWelcomeContents.forEach(t,p=>u.push(p)),u.sort(a)}addViews(t,u){let p=this._views.get(u);p||(p=[],this._views.set(u,p),this._viewContainers.push(u));for(const h of t){if(this.getView(h.id)!==null)throw new Error((0,T.localize)(1,null,h.id));p.push(h)}}removeViews(t,u){const p=this._views.get(u);if(!p)return[];const h=[],C=[];for(const S of p)t.includes(S)?h.push(S):C.push(S);return h.length&&(C.length?this._views.set(u,C):(this._views.delete(u),this._viewContainers.splice(this._viewContainers.indexOf(u),1))),h}}g.Registry.add(D.ViewsRegistry,new b),e.IViewsService=(0,d.createDecorator)("viewsService"),e.IViewDescriptorService=(0,d.createDecorator)("viewDescriptorService");var f;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(f||(e.ViewVisibilityState=f={}));var _;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(_||(e.TreeItemCollapsibleState=_={}));class n{constructor(t,u){this.resolved=!1,this._hasResolve=!1,(0,A.mixin)(this,t),this._hasResolve=!!u,this.resolve=async p=>{if(u&&!this.resolved){const h=await u(p);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}p.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n;class o extends Error{constructor(t){super((0,T.localize)(2,null,t)),this.name="NoTreeViewError"}static is(t){return t.name==="NoTreeViewError"}}e.NoTreeViewError=o}),define(De[134],Ie([1,0,3,17,203]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new v.Emitter,this._onExit=new v.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(g){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=g}onEvent(g){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=g}onRequest(g){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=g}sendResponse(g){g.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${g.command}`)):this.internalSend("response",g)}sendRequest(g,y,m,A){const k={command:g};if(y&&Object.keys(y).length>0&&(k.arguments=y),this.internalSend("request",k),typeof A=="number"){const w=setTimeout(()=>{clearTimeout(w);const D=this.pendingRequests.get(k.seq);if(D){this.pendingRequests.delete(k.seq);const I={type:"response",seq:0,request_seq:k.seq,success:!1,command:g,message:(0,d.localize)(0,null,A,g)};D(I)}},A)}return m&&this.pendingRequests.set(k.seq,m),k.seq}acceptMessage(g){this.messageCallback?this.messageCallback(g):(this.queue.push(g),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(g,y){return g.type!=="event"||y.type!=="event"}async processQueue(){let g;for(;this.queue.length;){if((!g||this.needsTaskBoundaryBetween(this.queue[0],g))&&await(0,T.timeout)(0),g=this.queue.shift(),!g)return;switch(g.type){case"event":this.eventCallback?.(g);break;case"request":this.requestCallback?.(g);break;case"response":{const y=g,m=this.pendingRequests.get(y.request_seq);m&&(this.pendingRequests.delete(y.request_seq),m(y));break}}}}internalSend(g,y){y.type=g,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const g=new Map;this.pendingRequests.forEach((y,m)=>g.set(m,y)),await(0,T.timeout)(500),g.forEach((y,m)=>{y({type:"response",seq:0,request_seq:m,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(m)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=L}),define(De[250],Ie([1,0,204,47,5]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new T.RawContextKey("debugType",void 0,{type:"string",description:v.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new T.RawContextKey("debugConfigurationType",void 0,{type:"string",description:v.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new T.RawContextKey("debugState","inactive",{type:"string",description:v.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new T.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:v.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new T.RawContextKey("hasDebugged",!1,{type:"boolean",description:v.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new T.RawContextKey("inDebugMode",!1,{type:"boolean",description:v.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new T.RawContextKey("inDebugRepl",!1,{type:"boolean",description:v.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new T.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:v.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new T.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:v.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new T.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:v.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new T.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:v.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new T.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:v.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new T.RawContextKey("variablesFocused",!0,{type:"boolean",description:v.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new T.RawContextKey("expressionSelected",!1,{type:"boolean",description:v.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new T.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:v.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new T.RawContextKey("callStackItemType",void 0,{type:"string",description:v.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new T.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:v.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new T.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:v.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new T.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:v.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new T.RawContextKey("watchItemType",void 0,{type:"string",description:v.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new T.RawContextKey("canViewMemory",void 0,{type:"boolean",description:v.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new T.RawContextKey("breakpointItemType",void 0,{type:"string",description:v.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new T.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:v.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new T.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:v.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new T.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:v.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new T.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:v.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new T.RawContextKey("stepBackSupported",!1,{type:"boolean",description:v.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new T.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:v.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new T.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:v.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new T.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:v.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new T.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:v.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new T.RawContextKey("breakpointsExist",!1,{type:"boolean",description:v.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new T.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:v.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new T.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:v.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new T.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:v.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new T.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:v.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new T.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:v.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new T.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:v.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new T.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:v.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new T.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:v.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new T.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:v.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new T.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:v.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new T.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:v.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new T.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:v.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new T.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:v.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new T.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:v.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new T.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:v.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new T.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:v.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new T.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:v.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new T.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:v.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new T.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:v.localize(50,null)});const L=w=>v.localize(51,null,w);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:v.localize(52,null)};var R;(function(w){w[w.Inactive=0]="Inactive",w[w.Initializing=1]="Initializing",w[w.Stopped=2]="Stopped",w[w.Running=3]="Running"})(R||(e.State=R={}));function g(w){switch(w){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=g;var y;(function(w){w[w.Valid=0]="Valid",w[w.Unreadable=1]="Unreadable",w[w.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var m;(function(w){w[w.Initial=1]="Initial",w[w.Dynamic=2]="Dynamic"})(m||(e.DebugConfigurationProviderTriggerKind=m={}));var A;(function(w){w.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.IDebugService=(0,d.createDecorator)("debugService");var k;(function(w){w[w.CONDITION=0]="CONDITION",w[w.HIT_COUNT=1]="HIT_COUNT",w[w.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(De[251],Ie([1,0,9,2,11,24,16,35,21,19]),function(re,e,v,T,d,L,R,g,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function k(h,C,S){return h.replace(A,function(c,r){return C&&r.length>0&&r[0]!=="_"?c:S&&S.hasOwnProperty(r)?S[r]:c})}e.formatPII=k;function w(h){const C={};for(const S of Object.keys(h))S.startsWith("!")||(C[S]=h[S]);return C}e.filterExceptionsFromTelemetry=w;function D(h){return h.configuration.request==="attach"&&!I(h)&&(!h.parentSession||D(h.parentSession))}e.isSessionAttach=D;function I(h){let C=h.configuration.type;if(C)return C==="vslsShare"&&(C=h.configuration.adapterProxy.configuration.type),(0,v.equalsIgnoreCase)(C,"extensionhost")||(0,v.equalsIgnoreCase)(C,"pwa-extensionhost")?h:h.parentSession?I(h.parentSession):void 0}e.getExtensionHostDebugSession=I;function E(h){return h.type&&(h.label||h.program||h.runtime)}e.isDebuggerMainContribution=E;function i(h,C,S){let c,r=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let M=null;for(;M=P.exec(h);){const W=M.index+1,$=W+M[0].length;if(W<=C&&$>=S){c=M[0],r=W;break}}if(c){const W=/\w+/g;let $=null;for(;($=W.exec(c))&&!($.index+1+r+$[0].length>=S););$&&(c=c.substring(0,W.lastIndex))}return c?{start:r,end:r+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=i;async function l(h,C,S,c){if(h.evaluatableExpressionProvider.has(C)){const r=h.evaluatableExpressionProvider.ordered(C),P=(0,m.coalesce)(await Promise.all(r.map(async M=>{try{return await M.provideEvaluatableExpression(C,S,c??y.CancellationToken.None)}catch{return}})));if(P.length>0){let M=P[0].expression;const W=P[0].range;return M||(M=C.getLineContent(S.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:M}}}else{const r=C.getLineContent(S.lineNumber),{start:P,end:M}=i(r,S.column,S.column),W=r.substring(P-1,M);return{matchingExpression:W,range:new g.Range(S.lineNumber,P,S.lineNumber,P+W.length)}}return null}e.getEvaluatableExpressionAtPosition=l;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(h){return!!(h&&h.match(a))}e.isUri=b;function f(h){if(typeof h.path=="string"&&!(typeof h.sourceReference=="number"&&h.sourceReference>0)){if(b(h.path))return T.URI.parse(h.path);if((0,d.isAbsolute)(h.path))return T.URI.file(h.path)}return h.path}function _(h){if(typeof h.path=="object"){const C=T.URI.revive(h.path);if(C)return C.scheme===R.Schemas.file?C.fsPath:C.toString()}return h.path}function n(h,C){const S=C?f:_,c=(0,L.deepClone)(h);return s(c,(r,P)=>{r&&P&&(P.path=S(P))}),c}e.convertToDAPaths=n;function o(h,C){const S=C?f:_,c=(0,L.deepClone)(h);return s(c,(r,P)=>{!r&&P&&(P.path=S(P))}),c}e.convertToVSCPaths=o;function s(h,C){switch(h.type){case"event":{const S=h;switch(S.event){case"output":C(!1,S.body.source);break;case"loadedSource":C(!1,S.body.source);break;case"breakpoint":C(!1,S.body.breakpoint.source);break;default:break}break}case"request":{const S=h;switch(S.command){case"setBreakpoints":C(!0,S.arguments.source);break;case"breakpointLocations":C(!0,S.arguments.source);break;case"source":C(!0,S.arguments.source);break;case"gotoTargets":C(!0,S.arguments.source);break;case"launchVSCode":S.arguments.args.forEach(c=>C(!1,c));break;default:break}break}case"response":{const S=h;if(S.success&&S.body)switch(S.command){case"stackTrace":S.body.stackFrames.forEach(c=>C(!1,c.source));break;case"loadedSources":S.body.sources.forEach(c=>C(!1,c));break;case"scopes":S.body.scopes.forEach(c=>C(!1,c.source));break;case"setFunctionBreakpoints":S.body.breakpoints.forEach(c=>C(!1,c.source));break;case"setBreakpoints":S.body.breakpoints.forEach(c=>C(!1,c.source));break;case"disassemble":S.body?.instructions.forEach(r=>C(!1,r.location));break;default:break}break}}}function t(h){return h.filter(C=>!C.presentation?.hidden).sort((C,S)=>C.presentation?S.presentation?C.presentation.group?S.presentation.group?C.presentation.group!==S.presentation.group?C.presentation.group.localeCompare(S.presentation.group):u(C.presentation.order,S.presentation.order):-1:S.presentation.group?1:u(C.presentation.order,S.presentation.order):-1:S.presentation?1:0)}e.getVisibleAndSorted=t;function u(h,C){return typeof h!="number"?typeof C!="number"?0:1:typeof C!="number"?-1:h-C}async function p(h,C){const S=h.getValue("debug.saveBeforeStart",{overrideIdentifier:C.activeTextEditorLanguageId});if(S!=="none"&&(await C.saveAll(),S==="allEditorsInActiveGroup")){const c=C.activeEditorPane;c&&c.input.resource?.scheme===R.Schemas.untitled&&await C.save({editor:c.input,groupId:c.group.id})}await h.reloadConfiguration()}e.saveAllBeforeDebugStart=p}),define(De[252],Ie([1,0,46,101,24,11,10,9,29,205,134]),function(re,e,v,T,d,L,R,g,y,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class k extends A.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(l,a){this.outputStream=a,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,l.on("data",b=>this.handleData(b))}sendMessage(l){if(this.outputStream){const a=JSON.stringify(l);this.outputStream.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${k.TWO_CRLF}${a}`,"utf8")}}handleData(l){for(this.rawData=Buffer.concat([this.rawData,l]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const a=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(b){this._onError.fire(new Error((b.message||b)+`
`+a))}continue}}else{const a=this.rawData.indexOf(k.TWO_CRLF);if(a!==-1){const f=this.rawData.toString("utf8",0,a).split(k.HEADER_LINESEPARATOR);for(const _ of f){const n=_.split(k.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(a+k.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=k,k.TWO_CRLF=`\r
\r
`,k.HEADER_LINESEPARATOR=/\r?\n/,k.HEADER_FIELDSEPARATOR=/: */;class w extends k{startSession(){return new Promise((l,a)=>{let b=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),l(),b=!0}),this.socket.on("close",()=>{b?this._onError.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.socket.on("error",f=>{b?this._onError.fire(f):a(f)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=w;class D extends w{constructor(l){super(),this.adapterServer=l}createConnection(l){return T.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",l)}}e.SocketDebugAdapter=D;class I extends w{constructor(l){super(),this.adapterServer=l}createConnection(l){return T.createConnection(this.adapterServer.path,l)}}e.NamedPipeDebugAdapter=I;class E extends k{constructor(l,a){super(),this.adapterExecutable=l,this.debugType=a}async startSession(){const l=this.adapterExecutable.command,a=this.adapterExecutable.args,b=this.adapterExecutable.options||{};try{if(l)if(L.isAbsolute(l)){if(!await y.Promises.exists(l))throw new Error(m.localize(0,null,l))}else l.indexOf("/")<0&&l.indexOf("\\")<0;else throw new Error(m.localize(1,null,this.debugType));let f=process.env;if(b.env&&Object.keys(b.env).length>0&&(f=d.mixin(d.deepClone(process.env),b.env)),l==="node")if(Array.isArray(a)&&a.length>0){const _=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:f,execArgv:_?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};b.cwd&&(n.cwd=b.cwd);const o=v.fork(a[0],a.slice(1),n);if(!o.pid)throw new Error(m.localize(2,null,a[0]));this.serverProcess=o}else throw new Error(m.localize(3,null));else{const _={env:f};b.cwd&&(_.cwd=b.cwd),this.serverProcess=v.spawn(l,a,_)}this.serverProcess.on("error",_=>{this._onError.fire(_)}),this.serverProcess.on("exit",(_,n)=>{this._onExit.fire(_)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",_=>{this._onError.fire(_)}),this.serverProcess.stdin.on("error",_=>{this._onError.fire(_)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(f){this._onError.fire(f)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),R.isWindows?new Promise((l,a)=>{const b=v.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(f,_,n){if(f)return a(f)});b.on("exit",l),b.on("error",a)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(l,a){if(!l)return;const b=Object.create(null);l.runtime&&(l.runtime.indexOf("./")===0?b.runtime=L.join(a,l.runtime):b.runtime=l.runtime),l.runtimeArgs&&(b.runtimeArgs=l.runtimeArgs),l.program&&(L.isAbsolute(l.program)?b.program=l.program:b.program=L.join(a,l.program)),l.args&&(b.args=l.args);const f=l;return f.win&&(b.win=E.extract(f.win,a)),f.winx86&&(b.winx86=E.extract(f.winx86,a)),f.windows&&(b.windows=E.extract(f.windows,a)),f.osx&&(b.osx=E.extract(f.osx,a)),f.linux&&(b.linux=E.extract(f.linux,a)),b}static platformAdapterExecutable(l,a){let b=Object.create(null);a=a.toLowerCase();for(const t of l)if(t.contributes){const u=t.contributes.debuggers;u&&u.length>0&&u.filter(p=>typeof p.type=="string"&&g.equalsIgnoreCase(p.type,a)).forEach(p=>{const h=E.extract(p,t.extensionLocation.fsPath);b=d.mixin(b,h,t.isBuiltin)})}let f;R.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?f=b.winx86||b.win||b.windows:R.isWindows?f=b.win||b.windows:R.isMacintosh?f=b.osx:R.isLinux&&(f=b.linux),f=f||b;const _=f.program||b.program,n=f.args||b.args,o=f.runtime||b.runtime,s=f.runtimeArgs||b.runtimeArgs;if(o)return{type:"executable",command:o,args:(s||[]).concat(typeof _=="string"?[_]:[]).concat(n||[])};if(_)return{type:"executable",command:_,args:n||[]}}}e.ExecutableDebugAdapter=E}),define(De[253],Ie([1,0,46,31,10]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function L(m,A){return new Promise((k,w)=>{let D="";const I=v.spawn(m,A);I.pid&&I.stdout.on("data",E=>{D+=E.toString()}),I.on("error",E=>{w(E)}),I.on("close",E=>{k(D)})})}async function R(m){if(m)if(d.isWindows){const A=await new Promise((k,w)=>{re(["@vscode/windows-process-tree"],k,w)});return new Promise(k=>{A.getProcessTree(m,w=>{k(!!w&&w.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(m)]).then(A=>{const k=A.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.hasChildProcesses=R;var g;(function(m){m[m.cmd=0]="cmd",m[m.powershell=1]="powershell",m[m.bash=2]="bash"})(g||(g={}));function y(m,A,k,w,D){m=m.trim().toLowerCase();let I;m.indexOf("powershell")>=0||m.indexOf("pwsh")>=0?I=1:m.indexOf("cmd.exe")>=0?I=0:m.indexOf("bash")>=0?I=2:d.isWindows?I=0:I=2;let E,i=" ";switch(I){case 1:if(E=l=>(l=l.replace(/\'/g,"''"),l.length>0&&l.charAt(l.length-1)==="\\"?`'${l}\\'`:`'${l}'`),w){const l=(0,T.getDriveLetter)(w);l&&(i+=`${l}:; `),i+=`cd ${E(w)}; `}if(D)for(const l in D){const a=D[l];a===null?i+=`Remove-Item env:${l}; `:i+=`\${env:${l}}='${a}'; `}if(A.length>0){const l=A.shift(),a=k?l:E(l);i+=a[0]==="'"?`& ${a} `:`${a} `;for(const b of A)i+=b==="<"||b===">"||k?b:E(b),i+=" "}break;case 0:if(E=l=>(l=l.replace(/\"/g,'""'),l=l.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(a=>l.includes(a))||l.length===0?`"${l}"`:l),w){const l=(0,T.getDriveLetter)(w);l&&(i+=`${l}: && `),i+=`cd ${E(w)} && `}if(D){i+='cmd /C "';for(const l in D){let a=D[l];a===null?i+=`set "${l}=" && `:(a=a.replace(/[&^|<>]/g,b=>`^${b}`),i+=`set "${l}=${a}" && `)}}for(const l of A)i+=l==="<"||l===">"||k?l:E(l),i+=" ";D&&(i+='"');break;case 2:{E=a=>(a=a.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),a.length===0?'""':a);const l=a=>/[^\w@%\/+=,.:^-]/.test(a)?`'${a.replace(/'/g,"'\\''")}'`:a;if(w&&(i+=`cd ${E(w)} ; `),D){i+="/usr/bin/env";for(const a in D){const b=D[a];b===null?i+=` -u ${l(a)}`:i+=` ${l(`${a}=${b}`)}`}i+=" "}for(const a of A)i+=a==="<"||a===">"||k?a:E(a),i+=" ";break}}return i}e.prepareCommand=y}),define(De[102],Ie([1,0,22,33,48,92,16,11,10,47]),function(re,e,v,T,d,L,R,g,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var A;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(A||(e.CellKind=A={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(x){x[x.Running=1]="Running",x[x.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var w;(function(x){x[x.Unconfirmed=1]="Unconfirmed",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var D;(function(x){x[x.Unconfirmed=1]="Unconfirmed",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(D||(e.NotebookExecutionState=D={}));var I;(function(x){x[x.WithHardKernelDependency=0]="WithHardKernelDependency",x[x.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",x[x.Pure=2]="Pure",x[x.Never=3]="Never"})(I||(e.NotebookRendererMatch=I={}));var E;(function(x){x.Always="always",x.Never="never",x.Optional="optional"})(E||(e.RendererMessagingSpec=E={}));var i;(function(x){x[x.ModelChange=1]="ModelChange",x[x.Move=2]="Move",x[x.ChangeCellLanguage=5]="ChangeCellLanguage",x[x.Initialize=6]="Initialize",x[x.ChangeCellMetadata=7]="ChangeCellMetadata",x[x.Output=8]="Output",x[x.OutputItem=9]="OutputItem",x[x.ChangeCellContent=10]="ChangeCellContent",x[x.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",x[x.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",x[x.ChangeCellMime=13]="ChangeCellMime",x[x.Unknown=100]="Unknown"})(i||(e.NotebookCellsChangeType=i={}));var l;(function(x){x[x.Handle=0]="Handle",x[x.Index=1]="Index"})(l||(e.SelectionStateType=l={}));var a;(function(x){x[x.Replace=1]="Replace",x[x.Output=2]="Output",x[x.Metadata=3]="Metadata",x[x.CellLanguage=4]="CellLanguage",x[x.DocumentMetadata=5]="DocumentMetadata",x[x.Move=6]="Move",x[x.OutputItems=7]="OutputItems",x[x.PartialMetadata=8]="PartialMetadata",x[x.PartialInternalMetadata=9]="PartialInternalMetadata"})(a||(e.CellEditType=a={}));var b;(function(x){x.scheme=R.Schemas.vscodeNotebookCell;const U=["W","X","Y","Z","a","b","c","d","e","f"],de=new RegExp(`^[${U.join("")}]+`),ie=7;function ne(ge,O){const K=O.toString(ie),Ce=`${K.length<U.length?U[K.length-1]:"z"}${K}s${(0,v.encodeBase64)(v.VSBuffer.fromString(ge.scheme),!0,!0)}`;return ge.with({scheme:x.scheme,fragment:Ce})}x.generate=ne;function H(ge){if(ge.scheme!==x.scheme)return;const O=ge.fragment.indexOf("s");if(O<0)return;const K=parseInt(ge.fragment.substring(0,O).replace(de,""),ie),we=(0,v.decodeBase64)(ge.fragment.substring(O+1)).toString();if(!isNaN(K))return{handle:K,notebook:ge.with({scheme:we,fragment:null})}}x.parse=H;function V(ge,O){return ge.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${O??""},${ge.scheme!==R.Schemas.file?ge.scheme:""}`})}x.generateCellOutputUri=V;function ce(ge){if(ge.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const O=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ge.fragment);if(!O)return;const K=O[1]&&O[1]!==""?O[1]:void 0,we=O[2];return{outputId:K,notebook:ge.with({scheme:we||R.Schemas.file,fragment:null})}}x.parseCellOutputUri=ce;function be(ge,O,K){return x.generate(ge,O).with({scheme:K})}x.generateCellPropertyUri=be;function Se(ge,O){if(ge.scheme===O)return x.parse(ge.with({scheme:x.scheme}))}x.parseCellPropertyUri=Se})(b||(e.CellUri=b={}));const f=x=>y.isWindows?x.replace(/\//g,"\\"):x;class _{constructor(U=[],de=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=de,this.order=[...new Set(U)].map(ie=>({pattern:ie,matches:T.parse(f(ie))}))}sort(U){const de=new Map(d.Iterable.map(U,ne=>[ne,f(ne)]));let ie=[];for(const{matches:ne}of this.order)for(const[H,V]of de)if(ne(V)){ie.push(H),de.delete(H);break}return de.size&&(ie=ie.concat([...de.keys()].sort((ne,H)=>this.defaultOrder.indexOf(ne)-this.defaultOrder.indexOf(H)))),ie}prioritize(U,de){const ie=this.findIndex(U);if(ie===-1){this.order.unshift({pattern:U,matches:T.parse(f(U))});return}const ne=new Set(de.map(V=>this.findIndex(V,ie)));ne.delete(-1);const H=Array.from(ne).sort();this.order.splice(ie+1,0,...H.map(V=>this.order[V]));for(let V=H.length-1;V>=0;V--)this.order.splice(H[V],1)}toArray(){return this.order.map(U=>U.pattern)}findIndex(U,de=this.order.length){const ie=f(U);for(let ne=0;ne<de;ne++)if(this.order[ne].matches(ie))return ne;return-1}}e.MimeTypeDisplayOrder=_;function n(x,U,de,ie=(ne,H)=>ne===H){const ne=[];function H(be,Se,ge){if(Se===0&&ge.length===0)return;const O=ne[ne.length-1];O&&O.start+O.deleteCount===be?(O.deleteCount+=Se,O.toInsert.push(...ge)):ne.push({start:be,deleteCount:Se,toInsert:ge})}let V=0,ce=0;for(;;){if(V===x.length){H(V,0,U.slice(ce));break}if(ce===U.length){H(V,x.length-V,[]);break}const be=x[V],Se=U[ce];if(ie(be,Se)){V+=1,ce+=1;continue}de(Se)?(H(V,1,[]),V+=1):(H(V,0,[Se]),ce+=1)}return ne}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new m.RawContextKey("notebookEditorCursorAtBoundary","none");var o;(function(x){x.default="default",x.option="option"})(o||(e.NotebookEditorPriority=o={}));function s(x){const U=x;return!!((typeof U.include=="string"||T.isRelativePattern(U.include))&&(typeof U.exclude=="string"||T.isRelativePattern(U.exclude)))}e.isDocumentExcludePattern=s;function t(x,U,de){if(Array.isArray(x.viewType)&&x.viewType.indexOf(U)>=0||x.viewType===U)return!0;if(x.filenamePattern){const ie=s(x.filenamePattern)?x.filenamePattern.include:x.filenamePattern,ne=s(x.filenamePattern)?x.filenamePattern.exclude:void 0;if(T.match(ie,(0,g.basename)(de.fsPath).toLowerCase()))return!(ne&&T.match(ne,(0,g.basename)(de.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=t,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell"};var u;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(u||(e.CellStatusbarAlignment=u={}));class p{static create(U){return`${p._prefix}${U}`}static parse(U){if(U.startsWith(p._prefix))return U.substring(p._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=p,p._prefix="notebook/";function h(x){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(x)}e.isTextStreamMime=h;const C=new TextDecoder;function S(x){const U=[];let de=!1;for(const ie of x)(U.length===0||de)&&(U.push(ie),de=!0);return M(U),q(v.VSBuffer.concat(U.map(ie=>v.VSBuffer.wrap(ie))))}e.compressOutputItemStreams=S;const c=`${String.fromCharCode(27)}[A`,r=c.split("").map(x=>x.charCodeAt(0)),P=10;function M(x){x.forEach((U,de)=>{if(de===0||U.length<c.length)return;const ie=x[de-1],ne=U.subarray(0,c.length);if(ne[0]===r[0]&&ne[1]===r[1]&&ne[2]===r[2]){const H=ie.lastIndexOf(P);if(H===-1)return;x[de-1]=ie.subarray(0,H),x[de]=U.subarray(c.length)}})}function W(x){let U=x;do x=U,U=x.replace(/[^\n]\x08/gm,"");while(U.length<x.length);return x}function $(x){for(x=x.replace(/\r+\n/gm,`
`);x.search(/\r[^$]/g)>-1;){const U=x.match(/^(.*)\r+/m)[1];let de=x.match(/\r+(.*)$/m)[1];de=de+U.slice(de.length,U.length),x=x.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,de)}return x}const z="\b".charCodeAt(0),N="\r".charCodeAt(0);function q(x){return!x.buffer.includes(z)&&!x.buffer.includes(N)?x:v.VSBuffer.fromString($(W(C.decode(x.buffer))))}});var Ye=this&&this.__classPrivateFieldSet||function(re,e,v,T,d){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!d)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!d:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?d.call(re,v):d?d.value=v:e.set(re,v),v},Fe=this&&this.__classPrivateFieldGet||function(re,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!T:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(re):T?T.value:e.get(re)};define(De[7],Ie([1,0,19,8,94,28,92,9,12,2,32,25,30,130,102]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I){"use strict";var E,i,l,a,b,f,_,n,o,s,t,u,p,h,C,S,c,r,P,M,W,$,z,N,q,x;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.NotebookCodeActionKind=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function U(G){return Object.assign(G,{apply:function(){const ve=arguments.length===1?[]:arguments[1];return Reflect.construct(G,ve,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(G,[]);{const[ve,...Re]=arguments;return Reflect.construct(G,Re,ve.constructor)}}})}var de;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(de||(e.TerminalOutputAnchor=de={}));var ie;(function(G){G[G.Command=0]="Command",G[G.Opener=1]="Opener"})(ie||(e.TerminalQuickFixType=ie={}));let ne=e.Disposable=o=class{static from(...B){let ve=B;return new o(function(){if(ve){for(const Re of ve)Re&&typeof Re.dispose=="function"&&Re.dispose();ve=void 0}})}constructor(B){E.set(this,void 0),Ye(this,E,B,"f")}dispose(){typeof Fe(this,E,"f")=="function"&&(Fe(this,E,"f").call(this),Ye(this,E,void 0,"f"))}};E=new WeakMap,e.Disposable=ne=o=Ve([U],ne);let H=e.Position=s=class{static Min(...B){if(B.length===0)throw new TypeError;let ve=B[0];for(let Re=1;Re<B.length;Re++){const qe=B[Re];qe.isBefore(ve)&&(ve=qe)}return ve}static Max(...B){if(B.length===0)throw new TypeError;let ve=B[0];for(let Re=1;Re<B.length;Re++){const qe=B[Re];qe.isAfter(ve)&&(ve=qe)}return ve}static isPosition(B){if(!B)return!1;if(B instanceof s)return!0;const{line:ve,character:Re}=B;return typeof ve=="number"&&typeof Re=="number"}static of(B){if(B instanceof s)return B;if(this.isPosition(B))return new s(B.line,B.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(B,ve){if(B<0)throw(0,T.illegalArgument)("line must be non-negative");if(ve<0)throw(0,T.illegalArgument)("character must be non-negative");this._line=B,this._character=ve}isBefore(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<B._character}isBeforeOrEqual(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<=B._character}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this._line===B._line&&this._character===B._character}compareTo(B){return this._line<B._line?-1:this._line>B.line?1:this._character<B._character?-1:this._character>B._character?1:0}translate(B,ve=0){if(B===null||ve===null)throw(0,T.illegalArgument)();let Re;return typeof B>"u"?Re=0:typeof B=="number"?Re=B:(Re=typeof B.lineDelta=="number"?B.lineDelta:0,ve=typeof B.characterDelta=="number"?B.characterDelta:0),Re===0&&ve===0?this:new s(this.line+Re,this.character+ve)}with(B,ve=this.character){if(B===null||ve===null)throw(0,T.illegalArgument)();let Re;return typeof B>"u"?Re=this.line:typeof B=="number"?Re=B:(Re=typeof B.line=="number"?B.line:this.line,ve=typeof B.character=="number"?B.character:this.character),Re===this.line&&ve===this.character?this:new s(Re,ve)}toJSON(){return{line:this.line,character:this.character}}};e.Position=H=s=Ve([U],H);let V=e.Range=t=class{static isRange(B){return B instanceof t?!0:B?H.isPosition(B.start)&&H.isPosition(B.end):!1}static of(B){if(B instanceof t)return B;if(this.isRange(B))return new t(B.start,B.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(B,ve,Re,qe){let Je,ct;if(typeof B=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof qe=="number"?(Je=new H(B,ve),ct=new H(Re,qe)):H.isPosition(B)&&H.isPosition(ve)&&(Je=H.of(B),ct=H.of(ve)),!Je||!ct)throw new Error("Invalid arguments");Je.isBefore(ct)?(this._start=Je,this._end=ct):(this._start=ct,this._end=Je)}contains(B){return t.isRange(B)?this.contains(B.start)&&this.contains(B.end):H.isPosition(B)?!(H.of(B).isBefore(this._start)||this._end.isBefore(B)):!1}isEqual(B){return this._start.isEqual(B._start)&&this._end.isEqual(B._end)}intersection(B){const ve=H.Max(B.start,this._start),Re=H.Min(B.end,this._end);if(!ve.isAfter(Re))return new t(ve,Re)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const ve=H.Min(B.start,this._start),Re=H.Max(B.end,this.end);return new t(ve,Re)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(B,ve=this.end){if(B===null||ve===null)throw(0,T.illegalArgument)();let Re;return B?H.isPosition(B)?Re=B:(Re=B.start||this.start,ve=B.end||this.end):Re=this.start,Re.isEqual(this._start)&&ve.isEqual(this.end)?this:new t(Re,ve)}toJSON(){return[this.start,this.end]}};e.Range=V=t=Ve([U],V);let ce=e.Selection=u=class extends V{static isSelection(B){return B instanceof u?!0:B?V.isRange(B)&&H.isPosition(B.anchor)&&H.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(B,ve,Re,qe){let Je,ct;if(typeof B=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof qe=="number"?(Je=new H(B,ve),ct=new H(Re,qe)):H.isPosition(B)&&H.isPosition(ve)&&(Je=H.of(B),ct=H.of(ve)),!Je||!ct)throw new Error("Invalid arguments");super(Je,ct),this._anchor=Je,this._active=ct}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=ce=u=Ve([U],ce);const be=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,T.illegalArgument)("connectionToken")};class Se{static isResolvedAuthority(B){return B&&typeof B=="object"&&typeof B.host=="string"&&typeof B.port=="number"&&(B.connectionToken===void 0||typeof B.connectionToken=="string")}constructor(B,ve,Re){if(typeof B!="string"||B.length===0)throw(0,T.illegalArgument)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,T.illegalArgument)("port");typeof Re<"u"&&be(Re),this.host=B,this.port=Math.round(ve),this.connectionToken=Re}}e.ResolvedAuthority=Se;class ge{static isManagedResolvedAuthority(B){return B&&typeof B=="object"&&typeof B.makeConnection=="function"&&(B.connectionToken===void 0||typeof B.connectionToken=="string")}constructor(B,ve){this.makeConnection=B,this.connectionToken=ve,typeof ve<"u"&&be(ve)}}e.ManagedResolvedAuthority=ge;class O extends Error{static NotAvailable(B,ve){return new O(B,D.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(B){return new O(B,D.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(B,ve=D.RemoteAuthorityResolverErrorCode.Unknown,Re){super(B),this._message=B,this._code=ve,this._detail=Re,Object.setPrototypeOf(this,O.prototype)}}e.RemoteAuthorityResolverError=O;var K;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(K||(e.EndOfLine=K={}));var we;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(we||(e.EnvironmentVariableMutatorType=we={}));let Ce=e.TextEdit=p=class{static isTextEdit(B){return B instanceof p?!0:B?V.isRange(B)&&typeof B.newText=="string":!1}static replace(B,ve){return new p(B,ve)}static insert(B,ve){return p.replace(new V(B,B),ve)}static delete(B){return p.replace(B,"")}static setEndOfLine(B){const ve=new p(new V(new H(0,0),new H(0,0)),"");return ve.newEol=B,ve}get range(){return this._range}set range(B){if(B&&!V.isRange(B))throw(0,T.illegalArgument)("range");this._range=B}get newText(){return this._newText||""}set newText(B){if(B&&typeof B!="string")throw(0,T.illegalArgument)("newText");this._newText=B}get newEol(){return this._newEol}set newEol(B){if(B&&typeof B!="number")throw(0,T.illegalArgument)("newEol");this._newEol=B}constructor(B,ve){this._range=B,this._newText=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=Ce=p=Ve([U],Ce);let ee=e.NotebookEdit=h=class{static isNotebookCellEdit(B){return B instanceof h?!0:B?Jt.isNotebookRange(B)&&Array.isArray(B.newCells):!1}static replaceCells(B,ve){return new h(B,ve)}static insertCells(B,ve){return new h(new Jt(B,B),ve)}static deleteCells(B){return new h(B,[])}static updateCellMetadata(B,ve){const Re=new h(new Jt(B,B),[]);return Re.newCellMetadata=ve,Re}static updateNotebookMetadata(B){const ve=new h(new Jt(0,0),[]);return ve.newNotebookMetadata=B,ve}constructor(B,ve){this.range=B,this.newCells=ve}};e.NotebookEdit=ee=h=Ve([U],ee);class te{static isSnippetTextEdit(B){return B instanceof te?!0:B?V.isRange(B.range)&&le.isSnippetString(B.snippet):!1}static replace(B,ve){return new te(B,ve)}static insert(B,ve){return te.replace(new V(B,B),ve)}constructor(B,ve){this.range=B,this.snippet=ve}}e.SnippetTextEdit=te;var ue;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(ue||(e.FileEditType=ue={}));let Q=e.WorkspaceEdit=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(B,ve,Re,qe){this._edits.push({_type:1,from:B,to:ve,options:Re,metadata:qe})}createFile(B,ve,Re){this._edits.push({_type:1,from:void 0,to:B,options:ve,metadata:Re})}deleteFile(B,ve,Re){this._edits.push({_type:1,from:B,to:void 0,options:ve,metadata:Re})}replaceNotebookMetadata(B,ve,Re){this._edits.push({_type:3,metadata:Re,uri:B,edit:{editType:5,metadata:ve},notebookMetadata:ve})}replaceNotebookCells(B,ve,Re,qe){const Je=ve.start,ct=ve.end;(Je!==ct||Re.length>0)&&this._edits.push({_type:5,uri:B,index:Je,count:ct-Je,cells:Re,metadata:qe})}replaceNotebookCellMetadata(B,ve,Re,qe){this._edits.push({_type:3,metadata:qe,uri:B,edit:{editType:3,index:ve,metadata:Re}})}replace(B,ve,Re,qe){this._edits.push({_type:2,uri:B,edit:new Ce(ve,Re),metadata:qe})}insert(B,ve,Re,qe){this.replace(B,new V(ve,ve),Re,qe)}delete(B,ve,Re){this.replace(B,ve,"",Re)}has(B){return this._edits.some(ve=>ve._type===2&&ve.uri.toString()===B.toString())}set(B,ve){if(ve)for(const Re of ve){if(!Re)continue;let qe,Je;Array.isArray(Re)?(qe=Re[0],Je=Re[1]):qe=Re,ee.isNotebookCellEdit(qe)?qe.newCellMetadata?this.replaceNotebookCellMetadata(B,qe.range.start,qe.newCellMetadata,Je):qe.newNotebookMetadata?this.replaceNotebookMetadata(B,qe.newNotebookMetadata,Je):this.replaceNotebookCells(B,qe.range,qe.newCells,Je):te.isSnippetTextEdit(qe)?this._edits.push({_type:6,uri:B,range:qe.range,edit:qe.snippet,metadata:Je}):this._edits.push({_type:2,uri:B,edit:qe,metadata:Je})}else{for(let Re=0;Re<this._edits.length;Re++){const qe=this._edits[Re];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===B.toString()&&(this._edits[Re]=void 0);break}}(0,v.coalesceInPlace)(this._edits)}}get(B){const ve=[];for(const Re of this._edits)Re._type===2&&Re.uri.toString()===B.toString()&&ve.push(Re.edit);return ve}entries(){const B=new L.ResourceMap;for(const ve of this._edits)if(ve._type===2){let Re=B.get(ve.uri);Re||(Re=[ve.uri,[]],B.set(ve.uri,Re)),Re[1].push(ve.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=Q=Ve([U],Q);let le=e.SnippetString=C=class{static isSnippetString(B){return B instanceof C?!0:B?typeof B.value=="string":!1}static _escape(B){return B.replace(/\$|}|\\/g,"\\$&")}constructor(B){this._tabstop=1,this.value=B||""}appendText(B){return this.value+=C._escape(B),this}appendTabstop(B=this._tabstop++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,ve=this._tabstop++){if(typeof B=="function"){const Re=new C;Re._tabstop=this._tabstop,B(Re),this._tabstop=Re._tabstop,B=Re.value}else B=C._escape(B);return this.value+="${",this.value+=ve,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,ve=this._tabstop++){const Re=B.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(B,ve){if(typeof ve=="function"){const Re=new C;Re._tabstop=this._tabstop,ve(Re),this._tabstop=Re._tabstop,ve=Re.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.SnippetString=le=C=Ve([U],le);var se;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(se||(e.DiagnosticTag=se={}));var oe;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(oe||(e.DiagnosticSeverity=oe={}));let F=e.Location=S=class{static isLocation(B){return B instanceof S?!0:B?V.isRange(B.range)&&m.URI.isUri(B.uri):!1}constructor(B,ve){if(this.uri=B,ve)if(V.isRange(ve))this.range=V.of(ve);else if(H.isPosition(ve))this.range=new V(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=F=S=Ve([U],F);let j=e.DiagnosticRelatedInformation=class{static is(B){return B?typeof B.message=="string"&&B.location&&V.isRange(B.location.range)&&m.URI.isUri(B.location.uri):!1}constructor(B,ve){this.location=B,this.message=ve}static isEqual(B,ve){return B===ve?!0:!B||!ve?!1:B.message===ve.message&&B.location.range.isEqual(ve.location.range)&&B.location.uri.toString()===ve.location.uri.toString()}};e.DiagnosticRelatedInformation=j=Ve([U],j);let Y=e.Diagnostic=class{constructor(B,ve,Re=oe.Error){if(!V.isRange(B))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=B,this.message=ve,this.severity=Re}toJSON(){return{severity:oe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,ve){return B===ve?!0:!B||!ve?!1:B.message===ve.message&&B.severity===ve.severity&&B.code===ve.code&&B.severity===ve.severity&&B.source===ve.source&&B.range.isEqual(ve.range)&&(0,v.equals)(B.tags,ve.tags)&&(0,v.equals)(B.relatedInformation,ve.relatedInformation,j.isEqual)}};e.Diagnostic=Y=Ve([U],Y);let Z=e.Hover=class{constructor(B,ve){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:this.contents=[B],this.range=ve}};e.Hover=Z=Ve([U],Z);var me;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(me||(e.DocumentHighlightKind=me={}));let _e=e.DocumentHighlight=class{constructor(B,ve=me.Text){this.range=B,this.kind=ve}toJSON(){return{range:this.range,kind:me[this.kind]}}};e.DocumentHighlight=_e=Ve([U],_e);var fe;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(fe||(e.SymbolKind=fe={}));var ke;(function(G){G[G.Deprecated=1]="Deprecated"})(ke||(e.SymbolTag=ke={}));let Pe=e.SymbolInformation=c=class{static validate(B){if(!B.name)throw new Error("name must not be falsy")}constructor(B,ve,Re,qe,Je){this.name=B,this.kind=ve,this.containerName=Je,typeof Re=="string"&&(this.containerName=Re),qe instanceof F?this.location=qe:Re instanceof V&&(this.location=new F(qe,Re)),c.validate(this)}toJSON(){return{name:this.name,kind:fe[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Pe=c=Ve([U],Pe);let $e=e.DocumentSymbol=r=class{static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children?.forEach(r.validate)}constructor(B,ve,Re,qe,Je){this.name=B,this.detail=ve,this.kind=Re,this.range=qe,this.selectionRange=Je,this.children=[],r.validate(this)}};e.DocumentSymbol=$e=r=Ve([U],$e);var He;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(He||(e.CodeActionTriggerKind=He={}));let tt=e.CodeAction=class{constructor(B,ve){this.title=B,this.kind=ve}};e.CodeAction=tt=Ve([U],tt);let Ge=e.CodeActionKind=P=class{constructor(B){this.value=B}append(B){return new P(this.value?this.value+P.sep+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+P.sep)}};Ge.sep=".",e.CodeActionKind=Ge=P=Ve([U],Ge);class Ke extends Ge{constructor(B){super(B),this.value=B}}e.NotebookCodeActionKind=Ke,Ge.Empty=new Ge(""),Ge.QuickFix=Ge.Empty.append("quickfix"),Ge.Refactor=Ge.Empty.append("refactor"),Ge.RefactorExtract=Ge.Refactor.append("extract"),Ge.RefactorInline=Ge.Refactor.append("inline"),Ge.RefactorMove=Ge.Refactor.append("move"),Ge.RefactorRewrite=Ge.Refactor.append("rewrite"),Ge.Source=Ge.Empty.append("source"),Ge.SourceOrganizeImports=Ge.Source.append("organizeImports"),Ge.SourceFixAll=Ge.Source.append("fixAll"),Ge.Notebook=Ge.Empty.append("notebook");let st=e.SelectionRange=class{constructor(B,ve){if(this.range=B,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=st=Ve([U],st);class at{constructor(B,ve,Re,qe,Je,ct){this.kind=B,this.name=ve,this.detail=Re,this.uri=qe,this.range=Je,this.selectionRange=ct}}e.CallHierarchyItem=at;class Ze{constructor(B,ve){this.fromRanges=ve,this.from=B}}e.CallHierarchyIncomingCall=Ze;class rt{constructor(B,ve){this.fromRanges=ve,this.to=B}}e.CallHierarchyOutgoingCall=rt;var he;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(he||(e.LanguageStatusSeverity=he={}));let Oe=e.CodeLens=class{constructor(B,ve){this.range=B,this.command=ve}get isResolved(){return!!this.command}};e.CodeLens=Oe=Ve([U],Oe);let J=e.MarkdownString=M=class{static isMarkdownString(B){return B instanceof M?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}constructor(B,ve=!1){i.set(this,void 0),Ye(this,i,new d.MarkdownString(B,{supportThemeIcons:ve}),"f")}get value(){return Fe(this,i,"f").value}set value(B){Fe(this,i,"f").value=B}get isTrusted(){return Fe(this,i,"f").isTrusted}set isTrusted(B){Fe(this,i,"f").isTrusted=B}get supportThemeIcons(){return Fe(this,i,"f").supportThemeIcons}set supportThemeIcons(B){Fe(this,i,"f").supportThemeIcons=B}get supportHtml(){return Fe(this,i,"f").supportHtml}set supportHtml(B){Fe(this,i,"f").supportHtml=B}get baseUri(){return Fe(this,i,"f").baseUri}set baseUri(B){Fe(this,i,"f").baseUri=B}appendText(B){return Fe(this,i,"f").appendText(B),this}appendMarkdown(B){return Fe(this,i,"f").appendMarkdown(B),this}appendCodeblock(B,ve){return Fe(this,i,"f").appendCodeblock(ve??"",B),this}};i=new WeakMap,e.MarkdownString=J=M=Ve([U],J);let X=e.ParameterInformation=class{constructor(B,ve){this.label=B,this.documentation=ve}};e.ParameterInformation=X=Ve([U],X);let Ee=e.SignatureInformation=class{constructor(B,ve){this.label=B,this.documentation=ve,this.parameters=[]}};e.SignatureInformation=Ee=Ve([U],Ee);let Ue=e.SignatureHelp=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=Ue=Ve([U],Ue);var Ne;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(Ne||(e.SignatureHelpTriggerKind=Ne={}));var Qe;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(Qe||(e.InlayHintKind=Qe={}));let et=e.InlayHintLabelPart=class{constructor(B){this.value=B}};e.InlayHintLabelPart=et=Ve([U],et);let nt=e.InlayHint=class{constructor(B,ve,Re){this.position=B,this.label=ve,this.kind=Re}};e.InlayHint=nt=Ve([U],nt);var ft;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ft||(e.CompletionTriggerKind=ft={}));var wt;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(wt||(e.CompletionItemKind=wt={}));var Mt;(function(G){G[G.Deprecated=1]="Deprecated"})(Mt||(e.CompletionItemTag=Mt={}));let Ft=e.CompletionItem=class{constructor(B,ve){this.label=B,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&wt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=Ft=Ve([U],Ft);let _t=e.CompletionList=class{constructor(B=[],ve=!1){this.items=B,this.isIncomplete=ve}};e.CompletionList=_t=Ve([U],_t);let Bt=e.InlineSuggestion=class{constructor(B,ve,Re){this.insertText=B,this.range=ve,this.command=Re}};e.InlineSuggestion=Bt=Ve([U],Bt);let Nt=e.InlineSuggestionList=class{constructor(B){this.commands=void 0,this.suppressSuggestions=void 0,this.items=B}};e.InlineSuggestionList=Nt=Ve([U],Nt);var Ut;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(Ut||(e.ViewColumn=Ut={}));var Ht;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Ht||(e.StatusBarAlignment=Ht={}));function Vt(G,B){return`${k.ExtensionIdentifier.toKey(G)}.${B}`}e.asStatusBarItemIdentifier=Vt;var lt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(lt||(e.TextEditorLineNumbersStyle=lt={}));var gt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(gt||(e.TextDocumentSaveReason=gt={}));var zt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(zt||(e.TextEditorRevealType=zt={}));var Rt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Rt||(e.TextEditorSelectionChangeKind=Rt={}));var It;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(It||(e.TextDocumentChangeReason=It={}));var ut;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(ut||(e.DecorationRangeBehavior=ut={})),function(G){function B(ve){switch(ve){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=B}(Rt||(e.TextEditorSelectionChangeKind=Rt={}));let Pt=e.DocumentLink=class{constructor(B,ve){if(ve&&!m.URI.isUri(ve))throw(0,T.illegalArgument)("target");if(!V.isRange(B)||B.isEmpty)throw(0,T.illegalArgument)("range");this.range=B,this.target=ve}};e.DocumentLink=Pt=Ve([U],Pt);let Ot=e.Color=class{constructor(B,ve,Re,qe){this.red=B,this.green=ve,this.blue=Re,this.alpha=qe}};e.Color=Ot=Ve([U],Ot);let Le=e.ColorInformation=class{constructor(B,ve){if(ve&&!(ve instanceof Ot))throw(0,T.illegalArgument)("color");if(!V.isRange(B)||B.isEmpty)throw(0,T.illegalArgument)("range");this.range=B,this.color=ve}};e.ColorInformation=Le=Ve([U],Le);let Ae=e.ColorPresentation=class{constructor(B){if(!B||typeof B!="string")throw(0,T.illegalArgument)("label");this.label=B}};e.ColorPresentation=Ae=Ve([U],Ae);var Te;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Te||(e.ColorFormat=Te={}));var ae;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(ae||(e.SourceControlInputBoxValidationType=ae={}));var Me;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(Me||(e.TerminalExitReason=Me={}));class Be{constructor(B,ve,Re){if(this.startIndex=B,this.length=ve,this.tooltip=Re,typeof B!="number"||B<0)throw(0,T.illegalArgument)("startIndex");if(typeof ve!="number"||ve<1)throw(0,T.illegalArgument)("length");if(Re!==void 0&&typeof Re!="string")throw(0,T.illegalArgument)("tooltip")}}e.TerminalLink=Be;class Xe{constructor(B){this.uri=B}}e.TerminalQuickFixOpener=Xe;class je{constructor(B){this.terminalCommand=B}}e.TerminalQuickFixCommand=je;var it;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(it||(e.TerminalLocation=it={}));class yt{constructor(B){if(this.options=B,typeof B!="object")throw(0,T.illegalArgument)("options")}}e.TerminalProfile=yt;var kt;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(kt||(e.TaskRevealKind=kt={}));var Tt;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Tt||(e.TaskPanelKind=Tt={}));let vt=e.TaskGroup=W=class{static from(B){switch(B){case"clean":return W.Clean;case"build":return W.Build;case"rebuild":return W.Rebuild;case"test":return W.Test;default:return}}constructor(B,ve){if(this.label=ve,typeof B!="string"||typeof ve!="string")throw(0,T.illegalArgument)("name");this._id=B}get id(){return this._id}};vt.Clean=new W("clean","Clean"),vt.Build=new W("build","Build"),vt.Rebuild=new W("rebuild","Rebuild"),vt.Test=new W("test","Test"),e.TaskGroup=vt=W=Ve([U],vt);function bt(G){let B="";for(let ve=0;ve<G.length;ve++)B+=G[ve].replace(/,/g,",,")+",";return B}let mt=e.ProcessExecution=class{constructor(B,ve,Re){if(typeof B!="string")throw(0,T.illegalArgument)("process");this._args=[],this._process=B,ve!==void 0&&(Array.isArray(ve)?(this._args=ve,this._options=Re):this._options=ve)}get process(){return this._process}set process(B){if(typeof B!="string")throw(0,T.illegalArgument)("process");this._process=B}get args(){return this._args}set args(B){Array.isArray(B)||(B=[]),this._args=B}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("process"),this._process!==void 0&&B.push(this._process),this._args&&this._args.length>0)for(const ve of this._args)B.push(ve);return bt(B)}};e.ProcessExecution=mt=Ve([U],mt);let St=e.ShellExecution=class{constructor(B,ve,Re){if(this._args=[],Array.isArray(ve)){if(!B)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,T.illegalArgument)("command");this._command=B,this._args=ve,this._options=Re}else{if(typeof B!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=B,this._options=ve}}get commandLine(){return this._commandLine}set commandLine(B){if(typeof B!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=B}get command(){return this._command?this._command:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,T.illegalArgument)("command");this._command=B}get args(){return this._args}set args(B){this._args=B||[]}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("shell"),this._commandLine!==void 0&&B.push(this._commandLine),this._command!==void 0&&B.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ve of this._args)B.push(typeof ve=="string"?ve:ve.value);return bt(B)}};e.ShellExecution=St=Ve([U],St);var Et;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(Et||(e.ShellQuoting=Et={}));var Qt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Qt||(e.TaskScope=Qt={}));class $t{constructor(B){this._callback=B}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(B){this._callback=B}get callback(){return this._callback}}e.CustomExecution=$t;let ni=e.Task=$=class{constructor(B,ve,Re,qe,Je,ct){this.__deprecated=!1,this._definition=this.definition=B;let ht;typeof ve=="string"?(this._name=this.name=ve,this._source=this.source=Re,this.execution=qe,ht=Je,this.__deprecated=!0):ve===Qt.Global||ve===Qt.Workspace?(this.target=ve,this._name=this.name=Re,this._source=this.source=qe,this.execution=Je,ht=ct):(this.target=ve,this._name=this.name=Re,this._source=this.source=qe,this.execution=Je,ht=ct),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(B){this.__id=B}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof mt?this._definition={type:$.ProcessType,id:this._execution.computeId()}:this._execution instanceof St?this._definition={type:$.ShellType,id:this._execution.computeId()}:this._execution instanceof $t?this._definition={type:$.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:$.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(B){if(B==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=B}get scope(){return this._scope}set target(B){this.clear(),this._scope=B}get name(){return this._name}set name(B){if(typeof B!="string")throw(0,T.illegalArgument)("name");this.clear(),this._name=B}get execution(){return this._execution}set execution(B){B===null&&(B=void 0),this.clear(),this._execution=B;const ve=this._definition.type;($.EmptyType===ve||$.ProcessType===ve||$.ShellType===ve||$.ExtensionCallbackType===ve)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(B){if(Array.isArray(B))this.clear(),this._problemMatchers=B,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.clear(),this._isBackground=B}get source(){return this._source}set source(B){if(typeof B!="string"||B.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=B}get group(){return this._group}set group(B){B===null&&(B=void 0),this.clear(),this._group=B}get detail(){return this._detail}set detail(B){B===null&&(B=void 0),this._detail=B}get presentationOptions(){return this._presentationOptions}set presentationOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._presentationOptions=B}get runOptions(){return this._runOptions}set runOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._runOptions=B}};ni.ExtensionCallbackType="customExecution",ni.ProcessType="process",ni.ShellType="shell",ni.EmptyType="$empty",e.Task=ni=$=Ve([U],ni);var ai;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(ai||(e.ProgressLocation=ai={}));var Si;(function(G){function B(ve){const Re=ve;return(0,y.isNumber)(Re.value)?Re.tooltip&&!(0,y.isString)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}G.isViewBadge=B})(Si||(e.ViewBadge=Si={}));let At=e.TreeItem=z=class{static isTreeItem(B,ve){const Re=B;if(Re.checkboxState!==void 0){const qe=(0,y.isNumber)(Re.checkboxState)?Re.checkboxState:(0,y.isObject)(Re.checkboxState)&&(0,y.isNumber)(Re.checkboxState.state)?Re.checkboxState.state:void 0,Je=!(0,y.isNumber)(Re.checkboxState)&&(0,y.isObject)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(qe===void 0||qe!==fi.Checked&&qe!==fi.Unchecked||Je!==void 0&&!(0,y.isString)(Je))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(B instanceof z)return!0;if(Re.label!==void 0&&!(0,y.isString)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,y.isString)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,y.isString)(Re.iconPath)&&!m.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,y.isString)(Re.iconPath.id))){const qe=Re.iconPath;if(!qe||!(0,y.isString)(qe.light)&&!m.URI.isUri(qe.light)&&!(0,y.isString)(qe.dark)&&!m.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,y.isString)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!m.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,y.isString)(Re.tooltip)&&!(Re.tooltip instanceof J)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<ci.None&&Re.collapsibleState>ci.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,y.isString)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(B,ve=ci.None){this.collapsibleState=ve,m.URI.isUri(B)?this.resourceUri=B:this.label=B}};e.TreeItem=At=z=Ve([U],At);var ci;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(ci||(e.TreeItemCollapsibleState=ci={}));var fi;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(fi||(e.TreeItemCheckboxState=fi={}));let Dt=e.DataTransferItem=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(B){this.value=B}};e.DataTransferItem=Dt=Ve([U],Dt);class _i extends Dt{}e.InternalDataTransferItem=_i;class Li extends _i{constructor(B){super(""),l.set(this,void 0),Ye(this,l,B,"f")}asFile(){return Fe(this,l,"f")}}e.InternalFileDataTransferItem=Li,l=new WeakMap;class mi{constructor(B,ve,Re,qe){this.name=B,this.uri=ve,this._itemId=Re,this._getData=qe}data(){return this._getData()}}e.DataTransferFile=mi;let Fi=e.DataTransfer=class{constructor(B){a.add(this),b.set(this,new Map);for(const[ve,Re]of B??[]){const qe=Fe(this,b,"f").get(Fe(this,a,"m",f).call(this,ve));qe?qe.push(Re):Fe(this,b,"f").set(Fe(this,a,"m",f).call(this,ve),[Re])}}get(B){return Fe(this,b,"f").get(Fe(this,a,"m",f).call(this,B))?.[0]}set(B,ve){Fe(this,b,"f").set(Fe(this,a,"m",f).call(this,B),[ve])}forEach(B,ve){for(const[Re,qe]of Fe(this,b,"f"))for(const Je of qe)B.call(ve,Je,Re,this)}*[(b=new WeakMap,a=new WeakSet,Symbol.iterator)](){for(const[B,ve]of Fe(this,b,"f"))for(const Re of ve)yield[B,Re]}};f=function(B){return B.toLowerCase()},e.DataTransfer=Fi=Ve([U],Fi);let Oi=e.DocumentDropEdit=class{constructor(B){this.insertText=B}};e.DocumentDropEdit=Oi=Ve([U],Oi);let xt=e.DocumentPasteEdit=class{constructor(B,ve,Re){this.id=ve,this.label=Re,this.insertText=B}};e.DocumentPasteEdit=xt=Ve([U],xt);let Kt=e.ThemeIcon=class{constructor(B,ve){this.id=B,this.color=ve}static isThemeIcon(B){return typeof B.id!="string"?(console.log("INVALID ThemeIcon, invalid id",B.id),!1):!0}};e.ThemeIcon=Kt=Ve([U],Kt),Kt.File=new Kt("file"),Kt.Folder=new Kt("folder");let Mi=e.ThemeColor=class{constructor(B){this.id=B}};e.ThemeColor=Mi=Ve([U],Mi);var li;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(li||(e.ConfigurationTarget=li={}));let ui=e.RelativePattern=class{get base(){return this._base}set base(B){this._base=B,this._baseUri=m.URI.file(B)}get baseUri(){return this._baseUri}set baseUri(B){this._baseUri=B,this._base=B.fsPath}constructor(B,ve){if(typeof B!="string"&&(!B||!m.URI.isUri(B)&&!m.URI.isUri(B.uri)))throw(0,T.illegalArgument)("base");if(typeof ve!="string")throw(0,T.illegalArgument)("pattern");typeof B=="string"?this.baseUri=m.URI.file(B):m.URI.isUri(B)?this.baseUri=B:this.baseUri=B.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=ui=Ve([U],ui);const dt=new WeakMap;function an(G,B){dt.set(G,B)}e.setBreakpointId=an;let jt=e.Breakpoint=class{constructor(B,ve,Re,qe){this.enabled=typeof B=="boolean"?B:!0,typeof ve=="string"&&(this.condition=ve),typeof Re=="string"&&(this.hitCondition=Re),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=dt.get(this)??(0,A.generateUuid)()),this._id}};e.Breakpoint=jt=Ve([U],jt);let ri=e.SourceBreakpoint=class extends jt{constructor(B,ve,Re,qe,Je){if(super(ve,Re,qe,Je),B===null)throw(0,T.illegalArgument)("location");this.location=B}};e.SourceBreakpoint=ri=Ve([U],ri);let yi=e.FunctionBreakpoint=class extends jt{constructor(B,ve,Re,qe,Je){super(ve,Re,qe,Je),this.functionName=B}};e.FunctionBreakpoint=yi=Ve([U],yi);let Ni=e.DataBreakpoint=class extends jt{constructor(B,ve,Re,qe,Je,ct,ht){if(super(qe,Je,ct,ht),!ve)throw(0,T.illegalArgument)("dataId");this.label=B,this.dataId=ve,this.canPersist=Re}};e.DataBreakpoint=Ni=Ve([U],Ni);let xi=e.DebugAdapterExecutable=class{constructor(B,ve,Re){this.command=B,this.args=ve||[],this.options=Re}};e.DebugAdapterExecutable=xi=Ve([U],xi);let Ui=e.DebugAdapterServer=class{constructor(B,ve){this.port=B,this.host=ve}};e.DebugAdapterServer=Ui=Ve([U],Ui);let Ci=e.DebugAdapterNamedPipeServer=class{constructor(B){this.path=B}};e.DebugAdapterNamedPipeServer=Ci=Ve([U],Ci);let Wi=e.DebugAdapterInlineImplementation=class{constructor(B){this.implementation=B}};e.DebugAdapterInlineImplementation=Wi=Ve([U],Wi);let Di=e.StackFrameFocus=class{constructor(B,ve,Re){this.session=B,this.threadId=ve,this.frameId=Re}};e.StackFrameFocus=Di=Ve([U],Di);let si=e.ThreadFocus=class{constructor(B,ve){this.session=B,this.threadId=ve}};e.ThreadFocus=si=Ve([U],si);let Bi=e.EvaluatableExpression=class{constructor(B,ve){this.range=B,this.expression=ve}};e.EvaluatableExpression=Bi=Ve([U],Bi);var gi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(gi||(e.InlineCompletionTriggerKind=gi={}));let pi=e.InlineValueText=class{constructor(B,ve){this.range=B,this.text=ve}};e.InlineValueText=pi=Ve([U],pi);let zi=e.InlineValueVariableLookup=class{constructor(B,ve,Re=!0){this.range=B,this.variableName=ve,this.caseSensitiveLookup=Re}};e.InlineValueVariableLookup=zi=Ve([U],zi);let $i=e.InlineValueEvaluatableExpression=class{constructor(B,ve){this.range=B,this.expression=ve}};e.InlineValueEvaluatableExpression=$i=Ve([U],$i);let oi=e.InlineValueContext=class{constructor(B,ve){this.frameId=B,this.stoppedLocation=ve}};e.InlineValueContext=oi=Ve([U],oi);var Hi;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Hi||(e.FileChangeType=Hi={}));let Vi=e.FileSystemError=N=class extends Error{static FileExists(B){return new N(B,w.FileSystemProviderErrorCode.FileExists,N.FileExists)}static FileNotFound(B){return new N(B,w.FileSystemProviderErrorCode.FileNotFound,N.FileNotFound)}static FileNotADirectory(B){return new N(B,w.FileSystemProviderErrorCode.FileNotADirectory,N.FileNotADirectory)}static FileIsADirectory(B){return new N(B,w.FileSystemProviderErrorCode.FileIsADirectory,N.FileIsADirectory)}static NoPermissions(B){return new N(B,w.FileSystemProviderErrorCode.NoPermissions,N.NoPermissions)}static Unavailable(B){return new N(B,w.FileSystemProviderErrorCode.Unavailable,N.Unavailable)}constructor(B,ve=w.FileSystemProviderErrorCode.Unknown,Re){super(m.URI.isUri(B)?B.toString(!0):B),this.code=Re?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,ve),Object.setPrototypeOf(this,N.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.FileSystemError=Vi=N=Ve([U],Vi);let ji=e.FoldingRange=class{constructor(B,ve,Re){this.start=B,this.end=ve,this.kind=Re}};e.FoldingRange=ji=Ve([U],ji);var ei;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(ei||(e.FoldingRangeKind=ei={}));var qi;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(qi||(e.CommentThreadCollapsibleState=qi={}));var Gi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Gi||(e.CommentMode=Gi={}));var Ii;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Ii||(e.CommentState=Ii={}));var Ki;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(Ki||(e.CommentThreadState=Ki={}));class cn{constructor(B,ve=[]){this.tokenTypes=B,this.tokenModifiers=ve}}e.SemanticTokensLegend=cn;function ln(G){return typeof G>"u"||(0,y.isStringArray)(G)}class di{constructor(B){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,B){this._hasLegend=!0;for(let ve=0,Re=B.tokenTypes.length;ve<Re;ve++)this._tokenTypeStrToInt.set(B.tokenTypes[ve],ve);for(let ve=0,Re=B.tokenModifiers.length;ve<Re;ve++)this._tokenModifierStrToInt.set(B.tokenModifiers[ve],ve)}}push(B,ve,Re,qe,Je){if(typeof B=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof qe=="number"&&(typeof Je=="number"||typeof Je>"u"))return typeof Je>"u"&&(Je=0),this._pushEncoded(B,ve,Re,qe,Je);if(V.isRange(B)&&typeof ve=="string"&&ln(Re))return this._push(B,ve,Re);throw(0,T.illegalArgument)()}_push(B,ve,Re){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ve))throw new Error("`tokenType` is not in the provided legend");const qe=B.start.line,Je=B.start.character,ct=B.end.character-B.start.character,ht=this._tokenTypeStrToInt.get(ve);let Wt=0;if(Re)for(const Gt of Re){if(!this._tokenModifierStrToInt.has(Gt))throw new Error("`tokenModifier` is not in the provided legend");const Xt=this._tokenModifierStrToInt.get(Gt);Wt|=1<<Xt>>>0}this._pushEncoded(qe,Je,ct,ht,Wt)}_pushEncoded(B,ve,Re,qe,Je){if(this._dataIsSortedAndDeltaEncoded&&(B<this._prevLine||B===this._prevLine&&ve<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Wt=this._data.length/5|0;let Gt=0,Xt=0;for(let Zt=0;Zt<Wt;Zt++){let ti=this._data[5*Zt],Ai=this._data[5*Zt+1];ti===0?(ti=Gt,Ai+=Xt):ti+=Gt,this._data[5*Zt]=ti,this._data[5*Zt+1]=Ai,Gt=ti,Xt=Ai}}let ct=B,ht=ve;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Re,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=Je,this._prevLine=B,this._prevChar=ve}static _sortAndDeltaEncode(B){const ve=[],Re=B.length/5|0;for(let ht=0;ht<Re;ht++)ve[ht]=ht;ve.sort((ht,Wt)=>{const Gt=B[5*ht],Xt=B[5*Wt];if(Gt===Xt){const Zt=B[5*ht+1],ti=B[5*Wt+1];return Zt-ti}return Gt-Xt});const qe=new Uint32Array(B.length);let Je=0,ct=0;for(let ht=0;ht<Re;ht++){const Wt=5*ve[ht],Gt=B[Wt+0],Xt=B[Wt+1],Zt=B[Wt+2],ti=B[Wt+3],Ai=B[Wt+4],Tn=Gt-Je,qn=Tn===0?Xt-ct:Xt,Ri=5*ht;qe[Ri+0]=Tn,qe[Ri+1]=qn,qe[Ri+2]=Zt,qe[Ri+3]=ti,qe[Ri+4]=Ai,Je=Gt,ct=Xt}return qe}build(B){return this._dataIsSortedAndDeltaEncoded?new vi(new Uint32Array(this._data),B):new vi(di._sortAndDeltaEncode(this._data),B)}}e.SemanticTokensBuilder=di;class vi{constructor(B,ve){this.resultId=ve,this.data=B}}e.SemanticTokens=vi;class We{constructor(B,ve,Re){this.start=B,this.deleteCount=ve,this.data=Re}}e.SemanticTokensEdit=We;class Yt{constructor(B,ve){this.resultId=ve,this.edits=B}}e.SemanticTokensEdits=Yt;var ki;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(ki||(e.DebugConsoleMode=ki={}));let pt=e.QuickInputButtons=class{constructor(){}};pt.Back={iconPath:new Kt("arrow-left")},e.QuickInputButtons=pt=Ve([U],pt);var Xi;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Xi||(e.QuickPickItemKind=Xi={}));var Qi;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Qi||(e.InputBoxValidationSeverity=Qi={}));var Pi;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Pi||(e.ExtensionKind=Pi={}));class un{static validate(B){if(typeof B.badge=="string"){let ve=(0,g.nextCharLength)(B.badge,0);if(ve<B.badge.length&&(ve+=(0,g.nextCharLength)(B.badge,ve)),B.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(B.badge&&!Kt.isThemeIcon(B.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty");return!0}constructor(B,ve,Re){this.badge=B,this.tooltip=ve,this.color=Re}}e.FileDecoration=un;let hi=e.ColorTheme=class{constructor(B){this.kind=B}};e.ColorTheme=hi=Ve([U],hi);var Yi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Yi||(e.ColorThemeKind=Yi={}));class Jt{static isNotebookRange(B){return B instanceof Jt?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(B,ve){if(B<0)throw(0,T.illegalArgument)("start must be positive");if(ve<0)throw(0,T.illegalArgument)("end must be positive");B<=ve?(this._start=B,this._end=ve):(this._start=ve,this._end=B)}with(B){let ve=this._start,Re=this._end;return B.start!==void 0&&(ve=B.start),B.end!==void 0&&(Re=B.end),ve===this._start&&Re===this._end?this:new Jt(ve,Re)}}e.NotebookRange=Jt;class bi{static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(ve=>bi.isNotebookCellData(ve))}static isNotebookCellData(B){return!0}constructor(B,ve,Re,qe,Je,ct,ht){this.kind=B,this.value=ve,this.languageId=Re,this.mime=qe,this.outputs=Je??[],this.metadata=ct,this.executionSummary=ht,bi.validate(this)}}e.NotebookCellData=bi;class Ji{constructor(B){this.cells=B}}e.NotebookData=Ji;class qt{static isNotebookCellOutputItem(B){return B instanceof qt?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B){const ve={name:B.name,message:B.message,stack:B.stack};return qt.json(ve,"application/vnd.code.notebook.error")}static stdout(B){return qt.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return qt.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,ve="application/octet-stream"){return new qt(B,ve)}static text(B,ve=R.Mimes.text){const Re=Fe(qt,_,"f",n).encode(String(B));return new qt(Re,ve)}static json(B,ve="text/x-json"){const Re=JSON.stringify(B,void 0,"	");return qt.text(Re,ve)}constructor(B,ve){this.data=B,this.mime=ve;const Re=(0,R.normalizeMimeType)(ve,!0);if(!Re)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.NotebookCellOutputItem=qt,_=qt,n={value:new TextEncoder};class Ei{static isNotebookCellOutput(B){return B instanceof Ei?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&Array.isArray(B.items)}static ensureUniqueMimeTypes(B,ve=!1){const Re=new Set,qe=new Set;for(let Je=0;Je<B.length;Je++){const ct=B[Je],ht=(0,R.normalizeMimeType)(ct.mime);if(!Re.has(ht)||(0,I.isTextStreamMime)(ht)){Re.add(ht);continue}qe.add(Je),ve&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return qe.size===0?B:B.filter((Je,ct)=>!qe.has(ct))}constructor(B,ve,Re){this.items=Ei.ensureUniqueMimeTypes(B,!0),typeof ve=="string"?(this.id=ve,this.metadata=Re):(this.id=(0,A.generateUuid)(),this.metadata=ve??Re)}}e.NotebookCellOutput=Ei;var Zi;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Zi||(e.NotebookCellKind=Zi={}));var en;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(en||(e.NotebookCellExecutionState=en={}));var tn;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(tn||(e.NotebookCellStatusBarAlignment=tn={}));var nn;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(nn||(e.NotebookEditorRevealType=nn={}));class dn{constructor(B,ve){this.text=B,this.alignment=ve}}e.NotebookCellStatusBarItem=dn;var rn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(rn||(e.NotebookControllerAffinity=rn={}));var sn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(sn||(e.NotebookControllerAffinity2=sn={}));class pe{constructor(B,ve=[]){this.uri=B,this.provides=(0,v.asArray)(ve)}}e.NotebookRendererScript=pe;class ye{constructor(B){this.label=B}}e.NotebookKernelSourceAction=ye;let xe=e.TimelineItem=class{constructor(B,ve){this.label=B,this.timestamp=ve}};e.TimelineItem=xe=Ve([U],xe);var ot;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(ot||(e.ExtensionMode=ot={}));var Ct;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(Ct||(e.ExtensionRuntime=Ct={}));var Lt;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Lt||(e.StandardTokenType=Lt={}));class On{constructor(B,ve){this.ranges=B,this.wordPattern=ve}}e.LinkedEditingRanges=On;class Mn{constructor(B){this._autoForwardAction=B}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mn;var mn;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(mn||(e.TestResultState=mn={}));var gn;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(gn||(e.TestRunProfileKind=gn={}));let hn=e.TestRunRequest=class{constructor(B=void 0,ve=void 0,Re=void 0,qe=!1){this.include=B,this.exclude=ve,this.profile=Re,this.continuous=qe}};e.TestRunRequest=hn=Ve([U],hn);let pn=e.TestRunRequest2=class extends hn{};e.TestRunRequest2=pn=Ve([U],pn);let vn=e.TestMessage=q=class{static diff(B,ve,Re){const qe=new q(B);return qe.expectedOutput=ve,qe.actualOutput=Re,qe}constructor(B){this.message=B}};e.TestMessage=vn=q=Ve([U],vn);let bn=e.TestTag=class{constructor(B){this.id=B}};e.TestTag=bn=Ve([U],bn);let Ti=e.CoveredCount=class{constructor(B,ve){this.covered=B,this.total=ve}};e.CoveredCount=Ti=Ve([U],Ti);let En=e.FileCoverage=x=class{static fromDetails(B,ve){const Re=new Ti(0,0),qe=new Ti(0,0),Je=new Ti(0,0);for(const ht of ve)if("branches"in ht){Re.total+=1,Re.covered+=ht.executionCount>0?1:0;for(const Wt of ht.branches)qe.total+=1,qe.covered+=Wt.executionCount>0?1:0}else Je.total+=1,Je.covered+=ht.executionCount>0?1:0;const ct=new x(B,Re,qe.total>0?qe:void 0,Je.total>0?Je:void 0);return ct.detailedCoverage=ve,ct}constructor(B,ve,Re,qe){this.uri=B,this.statementCoverage=ve,this.branchCoverage=Re,this.functionCoverage=qe}};e.FileCoverage=En=x=Ve([U],En);let wn=e.StatementCoverage=class{constructor(B,ve,Re=[]){this.executionCount=B,this.location=ve,this.branches=Re}};e.StatementCoverage=wn=Ve([U],wn);let Sn=e.BranchCoverage=class{constructor(B,ve){this.executionCount=B,this.location=ve}};e.BranchCoverage=Sn=Ve([U],Sn);let _n=e.FunctionCoverage=class{constructor(B,ve){this.executionCount=B,this.location=ve}};e.FunctionCoverage=_n=Ve([U],_n);var yn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(yn||(e.ExternalUriOpenerPriority=yn={}));var Cn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(Cn||(e.WorkspaceTrustState=Cn={}));var Dn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(Dn||(e.PortAutoForwardAction=Dn={}));class Nn{constructor(B,ve,Re,qe,Je,ct){this.kind=B,this.name=ve,this.detail=Re,this.uri=qe,this.range=Je,this.selectionRange=ct}}e.TypeHierarchyItem=Nn;class xn{constructor(B){this.uri=B}}e.TextTabInput=xn;class Un{constructor(B,ve){this.original=B,this.modified=ve}}e.TextDiffTabInput=Un;class Wn{constructor(B,ve,Re,qe){this.base=B,this.input1=ve,this.input2=Re,this.result=qe}}e.TextMergeTabInput=Wn;class Bn{constructor(B,ve){this.uri=B,this.viewType=ve}}e.CustomEditorTabInput=Bn;class zn{constructor(B){this.viewType=B}}e.WebviewEditorTabInput=zn;class $n{constructor(B,ve){this.uri=B,this.notebookType=ve}}e.NotebookEditorTabInput=$n;class Hn{constructor(B,ve,Re){this.original=B,this.modified=ve,this.notebookType=Re}}e.NotebookDiffEditorTabInput=Hn;class Vn{constructor(){}}e.TerminalEditorTabInput=Vn;class jn{constructor(B,ve){this.uri=B,this.inputBoxUri=ve}}e.InteractiveWindowInput=jn;var In;(function(G){G[G.Up=1]="Up",G[G.Down=2]="Down"})(In||(e.InteractiveSessionVoteDirection=In={}));var kn;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(kn||(e.InteractiveSessionCopyKind=kn={}));var Pn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone"})(Pn||(e.InteractiveEditorResponseFeedbackKind=Pn={}))}),define(De[135],Ie([1,0,53,16,9,162,116,7,19]),function(re,e,v,T,d,L,R,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const m=new Map;function A(I,E){E?m.set(I,E):m.delete(I)}e.setWordDefinitionFor=A;function k(I){return m.get(I)}class w extends L.MirrorTextModel{constructor(E,i,l,a,b,f,_,n){super(i,l,a,b),this._proxy=E,this._languageId=f,this._isDirty=_,this.notebook=n,this._isDisposed=!1}dispose(){(0,v.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(E){return(0,y.equals)(this._lines,E)}get document(){if(!this._document){const E=this;this._document={get uri(){return E._uri},get fileName(){return E._uri.fsPath},get isUntitled(){return E._uri.scheme===T.Schemas.untitled},get languageId(){return E._languageId},get version(){return E._versionId},get isClosed(){return E._isDisposed},get isDirty(){return E._isDirty},save(){return E._save()},getText(i){return i?E._getTextInRange(i):E.getText()},get eol(){return E._eol===`
`?g.EndOfLine.LF:g.EndOfLine.CRLF},get lineCount(){return E._lines.length},lineAt(i){return E._lineAt(i)},offsetAt(i){return E._offsetAt(i)},positionAt(i){return E._positionAt(i)},validateRange(i){return E._validateRange(i)},validatePosition(i){return E._validatePosition(i)},getWordRangeAtPosition(i,l){return E._getWordRangeAtPosition(i,l)}}}return Object.freeze(this._document)}_acceptLanguageId(E){(0,v.ok)(!this._isDisposed),this._languageId=E}_acceptIsDirty(E){(0,v.ok)(!this._isDisposed),this._isDirty=E}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(E){const i=this._validateRange(E);if(i.isEmpty)return"";if(i.isSingleLine)return this._lines[i.start.line].substring(i.start.character,i.end.character);const l=this._eol,a=i.start.line,b=i.end.line,f=[];f.push(this._lines[a].substring(i.start.character));for(let _=a+1;_<b;_++)f.push(this._lines[_]);return f.push(this._lines[b].substring(0,i.end.character)),f.join(l)}_lineAt(E){let i;if(E instanceof g.Position?i=E.line:typeof E=="number"&&(i=E),typeof i!="number"||i<0||i>=this._lines.length||Math.floor(i)!==i)throw new Error("Illegal value for `line`");return new D(i,this._lines[i],i===this._lines.length-1)}_offsetAt(E){return E=this._validatePosition(E),this._ensureLineStarts(),this._lineStarts.getPrefixSum(E.line-1)+E.character}_positionAt(E){E=Math.floor(E),E=Math.max(0,E),this._ensureLineStarts();const i=this._lineStarts.getIndexOf(E),l=this._lines[i.index].length;return new g.Position(i.index,Math.min(i.remainder,l))}_validateRange(E){if(!(E instanceof g.Range))throw new Error("Invalid argument");const i=this._validatePosition(E.start),l=this._validatePosition(E.end);return i===E.start&&l===E.end?E:new g.Range(i.line,i.character,l.line,l.character)}_validatePosition(E){if(!(E instanceof g.Position))throw new Error("Invalid argument");if(this._lines.length===0)return E.with(0,0);let{line:i,character:l}=E,a=!1;if(i<0)i=0,l=0,a=!0;else if(i>=this._lines.length)i=this._lines.length-1,l=this._lines[i].length,a=!0;else{const b=this._lines[i].length;l<0?(l=0,a=!0):l>b&&(l=b,a=!0)}return a?new g.Position(i,l):E}_getWordRangeAtPosition(E,i){const l=this._validatePosition(E);if(!i)i=k(this._languageId);else if((0,d.regExpLeadsToEndlessLoop)(i))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${i.source}' because it matches the empty string.`);const a=(0,R.getWordAtText)(l.character+1,(0,R.ensureValidWordDefinition)(i),this._lines[l.line],0);if(a)return new g.Range(l.line,a.startColumn-1,l.line,a.endColumn-1)}}e.ExtHostDocumentData=w;class D{constructor(E,i,l){this._line=E,this._text=i,this._isLastLine=l}get lineNumber(){return this._line}get text(){return this._text}get range(){return new g.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new g.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=D}),define(De[254],Ie([1,0,7,20,3]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=e.ExtHostTheming=class{constructor(g){this._actual=new v.ColorTheme(v.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new d.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(g){let y;switch(g){case"light":y=v.ColorThemeKind.Light;break;case"hcDark":y=v.ColorThemeKind.HighContrast;break;case"hcLight":y=v.ColorThemeKind.HighContrastLight;break;default:y=v.ColorThemeKind.Dark}this._actual=new v.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=L=Ve([ze(0,T.IExtHostRpcService)],L)}),define(De[255],Ie([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var T;(function(d){d[d.Output=1]="Output",d[d.OutputItems=2]="OutputItems",d[d.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.INotebookExecutionService=(0,v.createDecorator)("INotebookExecutionService")}),define(De[60],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(L){L.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var T;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class d{static fromExtHostTestItem(R,g,y=R.parent){if(R._isRoot)return new d([g]);const m=[R.id];for(let A=y;A&&A.id!==g;A=A.parent)m.push(A.id);return m.push(g),new d(m.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const g=R.indexOf("\0");return g===-1?R:R.slice(0,g)}static fromString(R){return new d(R.split("\0"))}static join(R,g){return new d([...R.path,g])}static joinToString(R,g){return R.toString()+"\0"+g}static parentId(R){const g=R.lastIndexOf("\0");return g===-1?void 0:R.slice(0,g)}static localId(R){const g=R.lastIndexOf("\0");return g===-1?R:R.slice(g+1)}static isChild(R,g){return g.startsWith(R)&&g[R.length]==="\0"}static compare(R,g){return R===g?0:d.isChild(R,g)?2:d.isChild(g,R)?3:1}constructor(R,g=R.length){if(this.path=R,this.viewEnd=g,R.length===0||g<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new d(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new d(this.path,R)}*idsToRoot(){for(let R=this.viewEnd;R>0;R--)yield new d(this.path,R)}compare(R){if(typeof R=="string")return d.compare(this.toString(),R);for(let g=0;g<R.viewEnd&&g<this.viewEnd;g++)if(R.path[g]!==this.path[g])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=d}),define(De[81],Ie([1,0,2,35,60]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var R;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var g;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const y=C=>"runId"in C;e.isStartControllerTests=y;var m;(function(C){C.serialize=S=>({range:S.range.toJSON(),uri:S.uri.toJSON()}),C.deserialize=S=>({range:T.Range.lift(S.range),uri:v.URI.revive(S.uri)})})(m||(e.IRichLocation=m={}));var A;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(A||(e.TestMessageType=A={}));var k;(function(C){C.serialize=S=>({message:S.message,type:0,expected:S.expected,actual:S.actual,location:S.location&&m.serialize(S.location)}),C.deserialize=S=>({message:S.message,type:0,expected:S.expected,actual:S.actual,location:S.location&&m.deserialize(S.location)})})(k||(e.ITestErrorMessage=k={}));const w=(C,S)=>`${S?"s":"e"}${C}`;e.getMarkId=w;var D;(function(C){C.serialize=S=>({message:S.message,type:1,offset:S.offset,length:S.length,location:S.location&&m.serialize(S.location)}),C.deserialize=S=>({message:S.message,type:1,offset:S.offset,length:S.length,location:S.location&&m.deserialize(S.location)})})(D||(e.ITestOutputMessage=D={}));var I;(function(C){C.serialize=S=>S.type===0?k.serialize(S):D.serialize(S),C.deserialize=S=>S.type===0?k.deserialize(S):D.deserialize(S)})(I||(e.ITestMessage=I={}));var E;(function(C){C.serializeWithoutMessages=S=>({state:S.state,duration:S.duration,messages:[]}),C.serialize=S=>({state:S.state,duration:S.duration,messages:S.messages.map(I.serialize)}),C.deserialize=S=>({state:S.state,duration:S.duration,messages:S.messages.map(I.deserialize)})})(E||(e.ITestTaskState=E={}));const i="\0",l=(C,S)=>C+i+S;e.namespaceTestTag=l;const a=C=>{const S=C.indexOf(i);return{ctrlId:C.slice(0,S),tagId:C.slice(S+1)}};e.denamespaceTestTag=a;var b;(function(C){C.serialize=S=>({extId:S.extId,label:S.label,tags:S.tags,busy:S.busy,children:void 0,uri:S.uri?.toJSON(),range:S.range?.toJSON()||null,description:S.description,error:S.error,sortText:S.sortText}),C.deserialize=S=>({extId:S.extId,label:S.label,tags:S.tags,busy:S.busy,children:void 0,uri:S.uri?v.URI.revive(S.uri):void 0,range:S.range?T.Range.lift(S.range):null,description:S.description,error:S.error,sortText:S.sortText})})(b||(e.ITestItem=b={}));var f;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(f||(e.TestItemExpandState=f={}));var _;(function(C){C.serialize=S=>({expand:S.expand,item:b.serialize(S.item)}),C.deserialize=S=>({controllerId:d.TestId.root(S.item.extId),expand:S.expand,item:b.deserialize(S.item)})})(_||(e.InternalTestItem=_={}));var n;(function(C){C.serialize=S=>{let c;return S.item&&(c={},S.item.label!==void 0&&(c.label=S.item.label),S.item.tags!==void 0&&(c.tags=S.item.tags),S.item.busy!==void 0&&(c.busy=S.item.busy),S.item.uri!==void 0&&(c.uri=S.item.uri?.toJSON()),S.item.range!==void 0&&(c.range=S.item.range?.toJSON()),S.item.description!==void 0&&(c.description=S.item.description),S.item.error!==void 0&&(c.error=S.item.error),S.item.sortText!==void 0&&(c.sortText=S.item.sortText)),{extId:S.extId,expand:S.expand,item:c}},C.deserialize=S=>{let c;return S.item&&(c={},S.item.label!==void 0&&(c.label=S.item.label),S.item.tags!==void 0&&(c.tags=S.item.tags),S.item.busy!==void 0&&(c.busy=S.item.busy),S.item.range!==void 0&&(c.range=S.item.range?T.Range.lift(S.item.range):null),S.item.description!==void 0&&(c.description=S.item.description),S.item.error!==void 0&&(c.error=S.item.error),S.item.sortText!==void 0&&(c.sortText=S.item.sortText)),{extId:S.extId,expand:S.expand,item:c}}})(n||(e.ITestItemUpdate=n={}));const o=(C,S)=>{S.expand!==void 0&&(C.expand=S.expand),S.item!==void 0&&(C.item=C.item?Object.assign(C.item,S.item):S.item)};e.applyTestItemUpdate=o;var s;(function(C){C.serializeWithoutMessages=S=>({..._.serialize(S),ownComputedState:S.ownComputedState,computedState:S.computedState,tasks:S.tasks.map(E.serializeWithoutMessages)}),C.serialize=S=>({..._.serialize(S),ownComputedState:S.ownComputedState,computedState:S.computedState,tasks:S.tasks.map(E.serialize)}),C.deserialize=S=>({..._.deserialize(S),ownComputedState:S.ownComputedState,computedState:S.computedState,tasks:S.tasks.map(E.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var t;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(t||(e.DetailType=t={}));var u;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(u||(e.TestDiffOpType=u={}));var p;(function(C){C.deserialize=S=>S.op===0?{op:S.op,item:_.deserialize(S.item)}:S.op===1?{op:S.op,item:n.deserialize(S.item)}:S.op===2?{op:S.op,uri:v.URI.revive(S.uri),docv:S.docv}:S,C.serialize=S=>S.op===0?{op:S.op,item:_.serialize(S.item)}:S.op===1?{op:S.op,item:n.serialize(S.item)}:S})(p||(e.TestsDiffOp=p={}));class h{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(S){const c=this.createChangeCollector();for(const r of S)switch(r.op){case 0:this.add(_.deserialize(r.item),c);break;case 1:this.update(n.deserialize(r.item),c);break;case 3:this.remove(r.itemId,c);break;case 5:this.retireTest(r.itemId);break;case 4:this.updatePendingRoots(r.amount);break;case 6:this._tags.set(r.tag.id,r.tag);break;case 7:this._tags.delete(r.id);break}c.complete?.()}add(S,c){const r=d.TestId.parentId(S.item.extId)?.toString();let P;if(!r)P=this.createItem(S),this.roots.add(P),this.items.set(S.item.extId,P);else if(this.items.has(r)){const M=this.items.get(r);M.children.add(S.item.extId),P=this.createItem(S,M),this.items.set(S.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(S)}`);return}return c.add?.(P),S.expand===2&&this.busyControllerCount++,P}update(S,c){const r=this.items.get(S.extId);if(r)return S.expand!==void 0&&(r.expand===2&&this.busyControllerCount--,S.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(r,S),c.update?.(r),r}remove(S,c){const r=this.items.get(S);if(!r)return;const P=d.TestId.parentId(r.item.extId)?.toString();P?this.items.get(P).children.delete(r.item.extId):this.roots.delete(r);const M=[[S]];for(;M.length;)for(const W of M.pop()){const $=this.items.get(W);$&&(M.push($.children),this.items.delete(W),c.remove?.($,$!==r),$.expand===2&&this.busyControllerCount--)}}retireTest(S){}updatePendingRoots(S){this.pendingRootCount+=S}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=h}),define(De[103],Ie([1,0,17,3,4,53,81,60]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const m=(a,b)=>a===b,k=Object.entries({range:(a,b)=>a===b?!0:!a||!b?!1:a.equalsRange(b),busy:m,label:m,description:m,error:m,sortText:m,tags:(a,b)=>!(a.length!==b.length||a.some(f=>!b.includes(f)))}),w=(a,b)=>{let f;for(const[_,n]of k)n(a[_],b[_])||(f?f[_]=b[_]:f={[_]:b[_]});return f};class D extends d.Disposable{get root(){return this.options.root}constructor(b){super(),this.options=b,this.debounceSendDiff=this._register(new v.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new T.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(b){this._resolveHandler=b;for(const f of this.tree.values())this.updateExpandability(f)}get resolveHandler(){return this._resolveHandler}collectDiff(){const b=this.diff;return this.diff=[],b}pushDiff(b){switch(b.op){case 2:{for(const f of this.diff)if(f.op===2&&f.uri===b.uri){f.docv=b.docv;return}break}case 1:{const f=this.diff[this.diff.length-1];if(f){if(f.op===1&&f.item.extId===b.item.extId){(0,R.applyTestItemUpdate)(f.item,b.item);return}if(f.op===0&&f.item.item.extId===b.item.extId){(0,R.applyTestItemUpdate)(f.item,b.item);return}}break}}this.diff.push(b),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(b,f){const _=this.tree.get(b);if(_){if((_.expandLevels===void 0||f>_.expandLevels)&&(_.expandLevels=f),_.expand===1){const n=this.resolveChildren(_);return n.isOpen()?this.expandChildren(_,f-1):n.wait().then(()=>this.expandChildren(_,f-1))}else if(_.expand===3)return _.resolveBarrier?.isOpen()===!1?_.resolveBarrier.wait().then(()=>this.expandChildren(_,f-1)):this.expandChildren(_,f-1)}}dispose(){for(const b of this.tree.values())this.options.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(b,f){switch(f.op){case 3:this.removeItem(g.TestId.joinToString(b.fullId,f.id));break;case 0:this.upsertItem(f.item,b);break;case 5:for(const _ of f.ops)this.onTestItemEvent(b,_);break;case 1:this.diffTagRefs(f.new,f.old,b.fullId.toString());break;case 2:this.updateExpandability(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:f.update}});break;case 6:this.documentSynced(b.actual.uri);break;default:(0,L.assertNever)(f)}}documentSynced(b){b&&this.pushDiff({op:2,uri:b,docv:this.options.getDocumentVersion(b)})}upsertItem(b,f){const _=g.TestId.fromExtHostTestItem(b,this.root.id,f?.actual),n=this.options.getApiFor(b);n.parent&&n.parent!==f?.actual&&this.options.getChildren(n.parent).delete(b.id);let o=this.tree.get(_.toString());if(!o){o={fullId:_,actual:b,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},b.tags.forEach(this.incrementTagRefs,this),this.tree.set(o.fullId.toString(),o),this.setItemParent(b,f),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:o.expand,item:this.options.toITestItem(b)}}),this.connectItemAndChildren(b,o,f);return}if(o.actual===b){this.connectItem(b,o,f);return}if(o.actual.uri?.toString()!==b.uri?.toString())return this.removeItem(_.toString()),this.upsertItem(b,f);const s=this.options.getChildren(o.actual),t=o.actual,u=w(this.options.toITestItem(t),this.options.toITestItem(b));this.options.getApiFor(t).listener=void 0,o.actual=b,o.expand=0,u&&(u.hasOwnProperty("tags")&&(this.diffTagRefs(b.tags,t.tags,_.toString()),delete u.tags),this.onTestItemEvent(o,{op:4,update:u})),this.connectItemAndChildren(b,o,f);for(const[p,h]of s)this.options.getChildren(b).get(h.id)||this.removeItem(g.TestId.joinToString(_,h.id));this.documentSynced(o.actual.uri)}diffTagRefs(b,f,_){const n=new Set(f.map(o=>o.id));for(const o of b)n.delete(o.id)||this.incrementTagRefs(o);this.pushDiff({op:1,item:{extId:_,item:{tags:b.map(o=>(0,R.namespaceTestTag)(this.options.controllerId,o.id))}}}),n.forEach(this.decrementTagRefs,this)}incrementTagRefs(b){const f=this.tags.get(b.id);f?f.refCount++:(this.tags.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.namespaceTestTag)(this.options.controllerId,b.id)}}))}decrementTagRefs(b){const f=this.tags.get(b);f&&!--f.refCount&&(this.tags.delete(b),this.pushDiff({op:7,id:(0,R.namespaceTestTag)(this.options.controllerId,b)}))}setItemParent(b,f){this.options.getApiFor(b).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(b,f,_){this.setItemParent(b,_);const n=this.options.getApiFor(b);n.parent=_?.actual,n.listener=o=>this.onTestItemEvent(f,o),this.updateExpandability(f)}connectItemAndChildren(b,f,_){this.connectItem(b,f,_);for(const[n,o]of this.options.getChildren(b))this.upsertItem(o,f)}updateExpandability(b){let f;this._resolveHandler?b.resolveBarrier?f=b.resolveBarrier.isOpen()?3:2:f=b.actual.canResolveChildren?1:0:f=0,f!==b.expand&&(b.expand=f,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:f}}),f===1&&b.expandLevels!==void 0&&this.resolveChildren(b))}expandChildren(b,f){if(f<0)return;const _=[];for(const[n,o]of this.options.getChildren(b.actual)){const s=this.expand(g.TestId.joinToString(b.fullId,o.id),f);(0,v.isThenable)(s)&&_.push(s)}if(_.length)return Promise.all(_).then(()=>{})}resolveChildren(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this._resolveHandler){const o=new v.Barrier;return o.open(),o}b.expand=2,this.pushExpandStateUpdate(b);const f=b.resolveBarrier=new v.Barrier,_=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,o)};let n;try{n=this._resolveHandler(b.actual===this.root?void 0:b.actual)}catch(o){_(o)}return(0,v.isThenable)(n)?n.catch(_).then(()=>{f.open(),this.updateExpandability(b)}):(f.open(),this.updateExpandability(b)),b.resolveBarrier}pushExpandStateUpdate(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}removeItem(b){const f=this.tree.get(b);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const _=[f];for(;_.length;){const n=_.pop();if(n){this.options.getApiFor(n.actual).listener=void 0;for(const o of n.actual.tags)this.decrementTagRefs(o.id);this.tree.delete(n.fullId.toString());for(const[o,s]of this.options.getChildren(n.actual))_.push(this.tree.get(g.TestId.joinToString(n.fullId,s.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.diffOpEmitter.fire(b)}}e.TestItemCollection=D;class I extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=I;class E extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class i extends Error{constructor(b,f,_){super(`TestItem with ID "${b}" is from controller "${f}" and cannot be added as a child of an item from controller "${_}".`)}}e.MixedTestItemController=i;const l=(a,b,f)=>{let _=new Map;return{get size(){return _.size},forEach(n,o){for(const s of _.values())n.call(o,s,this)},[Symbol.iterator](){return _.entries()},replace(n){const o=new Map,s=new Set(_.keys()),t={op:5,ops:[]};for(const u of n){if(!(u instanceof f))throw new E(u.id);const p=b(u).controllerId;if(p!==a.controllerId)throw new i(u.id,p,a.controllerId);if(o.has(u.id))throw new I(u.id);o.set(u.id,u),s.delete(u.id),t.ops.push({op:0,item:u})}for(const u of s.keys())t.ops.push({op:3,id:u});a.listener?.(t),_=o},add(n){if(!(n instanceof f))throw new E(n.id);_.set(n.id,n),a.listener?.({op:0,item:n})},delete(n){_.delete(n)&&a.listener?.({op:3,id:n})},get(n){return _.get(n)},toJSON(){return Array.from(_.values())}}};e.createTestItemChildren=l}),define(De[136],Ie([1,0,103]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const T=new WeakMap,d=(R,g)=>{const y={controllerId:g};return T.set(R,y),y};e.createPrivateApiFor=d;const L=R=>{const g=T.get(R);if(!g)throw new v.InvalidTestItemError(R?.id||"<unknown>");return g};e.getPrivateApiFor=L}),define(De[104],Ie([1,0,16,2]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function d(g,y){return g.scheme===v.Schemas.http||g.scheme===v.Schemas.https?g:(y&&y.authority&&y.isRemote&&g.scheme===v.Schemas.file&&(g=T.URI.from({scheme:v.Schemas.vscodeRemote,authority:y.authority,path:g.path})),T.URI.from({scheme:v.Schemas.https,authority:`${g.scheme}+${L(g.authority)}.${e.webviewRootResourceAuthority}`,path:g.path,fragment:g.fragment,query:g.query}))}e.asWebviewUri=d;function L(g){return g.replace(/./g,y=>{const m=y.charCodeAt(0);return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57?y:"-"+m.toString(16).padStart(4,"0")})}function R(g){return g.replace(/-([0-9a-f]{4})/g,(y,m)=>String.fromCharCode(parseInt(m,16)))}e.decodeAuthority=R}),define(De[256],Ie([1,0,3,4,104]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(g,y,m){this._proxy=g,this._editors=y,this._remoteInfo=m,this._handlePool=0,this._disposables=new T.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const A=y.getVisibleTextEditors();for(const k of this._insets.values())A.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(g=>g.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(g,y,m,A,k){let w;for(const b of this._editors.getVisibleTextEditors(!0))if(b.value===g){w=b;break}if(!w)throw new Error("not a visible editor");const D=this,I=this._handlePool++,E=new v.Emitter,i=new v.Emitter,l=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(b){return(0,d.asWebviewUri)(b,D._remoteInfo)}get cspSource(){return d.webviewGenericCspSource}set options(b){this._options=b,D._proxy.$setOptions(I,b)}get options(){return this._options}set html(b){this._html=b,D._proxy.$setHtml(I,b)}get html(){return this._html}get onDidReceiveMessage(){return E.event}postMessage(b){return D._proxy.$postMessage(I,b)}},a=new class{constructor(){this.editor=g,this.line=y,this.height=m,this.webview=l,this.onDidDispose=i.event}dispose(){D._insets.has(I)&&(D._insets.delete(I),D._proxy.$disposeEditorInset(I),i.fire(),i.dispose(),E.dispose())}};return this._proxy.$createEditorInset(I,w.id,w.value.document.uri,y+1,m,A||{},k.identifier,k.extensionLocation),this._insets.set(I,{editor:g,inset:a,onDidReceiveMessage:E}),a}$onDidDispose(g){const y=this._insets.get(g);y&&y.inset.dispose()}$onDidReceiveMessage(g,y){this._insets.get(g)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=L}),define(De[257],Ie([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,v.createDecorator)("configurationResolverService");var T;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class d extends Error{constructor(R,g){super(g),this.variable=R}}e.VariableError=d}),define(De[258],Ie([1,0,11,41,12,24,10,120,208,257,9]),function(re,e,v,T,d,L,R,g,y,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(D,I,E,i){this._contributedVariables=new Map,this._context=D,this._labelService=I,this._userHomePromise=E,i&&(this._envVariablesPromise=i.then(l=>this.prepareEnv(l)))}prepareEnv(D){if(R.isWindows){const I=Object.create(null);return Object.keys(D).forEach(E=>{I[E.toLowerCase()]=D[E]}),I}return D}resolveWithEnvironment(D,I,E){return this.recursiveResolve({env:this.prepareEnv(D),userHome:void 0},I?I.uri:void 0,E)}async resolveAsync(D,I){const E={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(E,D?D.uri:void 0,I)}async resolveAnyBase(D,I,E,i){const l=L.deepClone(I);R.isWindows&&l.windows?Object.keys(l.windows).forEach(b=>l[b]=l.windows[b]):R.isMacintosh&&l.osx?Object.keys(l.osx).forEach(b=>l[b]=l.osx[b]):R.isLinux&&l.linux&&Object.keys(l.linux).forEach(b=>l[b]=l.linux[b]),delete l.windows,delete l.osx,delete l.linux;const a={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(a,D?D.uri:void 0,l,E,i)}async resolveAnyAsync(D,I,E){return this.resolveAnyBase(D,I,E)}async resolveAnyMap(D,I,E){const i=new Map;return{newConfig:await this.resolveAnyBase(D,I,E,i),resolvedVariables:i}}resolveWithInteractionReplace(D,I,E,i){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,I,E,i){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,I){if(this._contributedVariables.has(D))throw new Error("Variable "+D+" is contributed twice.");this._contributedVariables.set(D,I)}async recursiveResolve(D,I,E,i,l){if(d.isString(E))return this.resolveString(D,I,E,i,l);if(Array.isArray(E))return Promise.all(E.map(a=>this.recursiveResolve(D,I,a,i,l)));if(d.isObject(E)){const a=Object.create(null),b=await Promise.all(Object.keys(E).map(async f=>[await this.resolveString(D,I,f,i,l),await this.recursiveResolve(D,I,E[f],i,l)]));for(const[f,_]of b)a[f]=_;return a}return E}resolveString(D,I,E,i,l){return(0,A.replaceAsync)(E,k.VARIABLE_REGEXP,async(a,b)=>{if(b.includes(k.VARIABLE_LHS))return a;let f=await this.evaluateSingleVariable(D,a,b,I,i);return l?.set(b,f),f!==a&&d.isString(f)&&f.match(k.VARIABLE_REGEXP)&&(f=await this.resolveString(D,I,f,i,l)),f})}fsPath(D){return this._labelService?this._labelService.getUriLabel(D,{noPrefix:!0}):D.fsPath}async evaluateSingleVariable(D,I,E,i,l){let a;const b=E.split(":");b.length>1&&(E=b[0],a=b[1]);const f=o=>{const s=this._context.getFilePath();if(s)return(0,g.normalizeDriveLetter)(s);throw new m.VariableError(o,(0,y.localize)(0,null,I))},_=o=>{const s=f(o);if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return(0,g.normalizeDriveLetter)(t)}throw new m.VariableError(o,(0,y.localize)(1,null,I,v.basename(s)))},n=o=>{if(a){const s=this._context.getFolderUri(a);if(s)return s;throw new m.VariableError(o,(0,y.localize)(2,null,I,a))}if(i)return i;throw this._context.getWorkspaceFolderCount()>1?new m.VariableError(o,(0,y.localize)(3,null,I)):new m.VariableError(o,(0,y.localize)(4,null,I))};switch(E){case"env":if(a){if(D.env){const o=D.env[R.isWindows?a.toLowerCase():a];if(d.isString(o))return o}return""}throw new m.VariableError(m.VariableKind.Env,(0,y.localize)(5,null,I));case"config":if(a){const o=this._context.getConfigurationValue(i,a);if(d.isUndefinedOrNull(o))throw new m.VariableError(m.VariableKind.Config,(0,y.localize)(6,null,I,a));if(d.isObject(o))throw new m.VariableError(m.VariableKind.Config,(0,y.localize)(7,null,I,a));return o}throw new m.VariableError(m.VariableKind.Config,(0,y.localize)(8,null,I));case"command":return this.resolveFromMap(m.VariableKind.Command,I,a,l,"command");case"input":return this.resolveFromMap(m.VariableKind.Input,I,a,l,"input");case"extensionInstallFolder":if(a){const o=await this._context.getExtension(a);if(!o)throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,I,a));return this.fsPath(o.extensionLocation)}throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,I));default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,g.normalizeDriveLetter)(this.fsPath(n(m.VariableKind.WorkspaceFolder)));case"cwd":return i||a?(0,g.normalizeDriveLetter)(this.fsPath(n(m.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,g.normalizeDriveLetter)(v.basename(this.fsPath(n(m.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(D.userHome)return D.userHome;throw new m.VariableError(m.VariableKind.UserHome,(0,y.localize)(11,null,I))}case"lineNumber":{const o=this._context.getLineNumber();if(o)return o;throw new m.VariableError(m.VariableKind.LineNumber,(0,y.localize)(12,null,I))}case"selectedText":{const o=this._context.getSelectedText();if(o)return o;throw new m.VariableError(m.VariableKind.SelectedText,(0,y.localize)(13,null,I))}case"file":return f(m.VariableKind.File);case"fileWorkspaceFolder":return _(m.VariableKind.FileWorkspaceFolder);case"relativeFile":return i||a?v.relative(this.fsPath(n(m.VariableKind.RelativeFile)),f(m.VariableKind.RelativeFile)):f(m.VariableKind.RelativeFile);case"relativeFileDirname":{const o=v.dirname(f(m.VariableKind.RelativeFileDirname));if(i||a){const s=v.relative(this.fsPath(n(m.VariableKind.RelativeFileDirname)),o);return s.length===0?".":s}return o}case"fileDirname":return v.dirname(f(m.VariableKind.FileDirname));case"fileExtname":return v.extname(f(m.VariableKind.FileExtname));case"fileBasename":return v.basename(f(m.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=v.basename(f(m.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-v.extname(o).length)}case"fileDirnameBasename":return v.basename(v.dirname(f(m.VariableKind.FileDirnameBasename)));case"execPath":{const o=this._context.getExecPath();return o||I}case"execInstallFolder":{const o=this._context.getAppRoot();return o||I}case"pathSeparator":return v.sep;default:try{const o=a?`${E}:${a}`:E;return this.resolveFromMap(m.VariableKind.Unknown,I,o,l,void 0)}catch{return I}}}}resolveFromMap(D,I,E,i,l){if(E&&i){const a=l===void 0?i[E]:i[l+":"+E];if(typeof a=="string")return a;throw new m.VariableError(D,(0,y.localize)(14,null,I))}return I}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[137],Ie([1,0,5,133]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,v.createDecorator)("editorGroupsService");var d;(function(I){I[I.UP=0]="UP",I[I.DOWN=1]="DOWN",I[I.LEFT=2]="LEFT",I[I.RIGHT=3]="RIGHT"})(d||(e.GroupDirection=d={}));var L;(function(I){I[I.HORIZONTAL=0]="HORIZONTAL",I[I.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function(I){I[I.FIRST=0]="FIRST",I[I.LAST=1]="LAST",I[I.NEXT=2]="NEXT",I[I.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var g;(function(I){I[I.MAXIMIZE=0]="MAXIMIZE",I[I.EVEN=1]="EVEN",I[I.TOGGLE=2]="TOGGLE"})(g||(e.GroupsArrangement=g={}));var y;(function(I){I[I.COPY_EDITORS=0]="COPY_EDITORS",I[I.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function m(I){const E=I;return(0,T.isEditorInput)(E?.editor)&&(0,T.isEditorInput)(E?.replacement)}e.isEditorReplacement=m;var A;(function(I){I[I.CREATION_TIME=0]="CREATION_TIME",I[I.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",I[I.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var k;(function(I){I[I.NEW_EDITOR=1]="NEW_EDITOR",I[I.MOVE_EDITOR=2]="MOVE_EDITOR",I[I.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function w(I){const E=I;return!!E&&typeof E.id=="number"&&Array.isArray(E.editors)}e.isEditorGroup=w;function D(I){return I.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=D}),define(De[259],Ie([1,0,5,137]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,v.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function d(L){const R=L;return typeof L=="number"||(0,T.isEditorGroup)(R)}e.isPreferredGroup=d}),define(De[15],Ie([1,0,19,22,155,67,94,28,151,73,92,24,12,2,35,76,126,136,133,102,60,81,259,7]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l,a,b,f,_,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Le){function Ae(ae){const{selectionStartLineNumber:Me,selectionStartColumn:Be,positionLineNumber:Xe,positionColumn:je}=ae,it=new o.Position(Me-1,Be-1),yt=new o.Position(Xe-1,je-1);return new o.Selection(it,yt)}Le.to=Ae;function Te(ae){const{anchor:Me,active:Be}=ae;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Le.from=Te})(s||(e.Selection=s={}));var t;(function(Le){function Ae(ae){if(!ae)return;const{start:Me,end:Be}=ae;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Le.from=Ae;function Te(ae){if(!ae)return;const{startLineNumber:Me,startColumn:Be,endLineNumber:Xe,endColumn:je}=ae;return new o.Range(Me-1,Be-1,Xe-1,je-1)}Le.to=Te})(t||(e.Range=t={}));var u;(function(Le){function Ae(Te){switch(Te){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Le.to=Ae})(u||(e.TokenType=u={}));var p;(function(Le){function Ae(ae){return new o.Position(ae.lineNumber-1,ae.column-1)}Le.to=Ae;function Te(ae){return{lineNumber:ae.line+1,column:ae.character+1}}Le.from=Te})(p||(e.Position=p={}));var h;(function(Le){function Ae(Me,Be,Xe){return(0,v.coalesce)((0,v.asArray)(Me).map(je=>Te(je,Be,Xe)))}Le.from=Ae;function Te(Me,Be,Xe){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Xe?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:ae(Me.scheme,Be),pattern:Oe.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Xe?.isBuiltin}}function ae(Me,Be){return Be&&typeof Me=="string"?Be.transformOutgoingScheme(Me):Me}})(h||(e.DocumentSelector=h={}));var C;(function(Le){function Ae(ae){switch(ae){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Le.from=Ae;function Te(ae){switch(ae){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Le.to=Te})(C||(e.DiagnosticTag=C={}));var S;(function(Le){function Ae(ae){let Me;return ae.code&&((0,w.isString)(ae.code)||(0,w.isNumber)(ae.code)?Me=String(ae.code):Me={value:String(ae.code.value),target:ae.code.target}),{...t.from(ae.range),message:ae.message,source:ae.source,code:Me,severity:r.from(ae.severity),relatedInformation:ae.relatedInformation&&ae.relatedInformation.map(c.from),tags:Array.isArray(ae.tags)?(0,v.coalesce)(ae.tags.map(C.from)):void 0}}Le.from=Ae;function Te(ae){const Me=new o.Diagnostic(t.to(ae),ae.message,r.to(ae.severity));return Me.source=ae.source,Me.code=(0,w.isString)(ae.code)?ae.code:ae.code?.value,Me.relatedInformation=ae.relatedInformation&&ae.relatedInformation.map(c.to),Me.tags=ae.tags&&(0,v.coalesce)(ae.tags.map(C.to)),Me}Le.to=Te})(S||(e.Diagnostic=S={}));var c;(function(Le){function Ae(ae){return{...t.from(ae.location.range),message:ae.message,resource:ae.location.uri}}Le.from=Ae;function Te(ae){return new o.DiagnosticRelatedInformation(new o.Location(ae.resource,t.to(ae)),ae.message)}Le.to=Te})(c||(e.DiagnosticRelatedInformation=c={}));var r;(function(Le){function Ae(ae){switch(ae){case o.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Le.from=Ae;function Te(ae){switch(ae){case i.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Le.to=Te})(r||(e.DiagnosticSeverity=r={}));var P;(function(Le){function Ae(ae){return typeof ae=="number"&&ae>=o.ViewColumn.One?ae-1:ae===o.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}Le.from=Ae;function Te(ae){if(typeof ae=="number"&&ae>=0)return ae+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=Te})(P||(e.ViewColumn=P={}));function M(Le){return typeof Le.range<"u"}function W(Le){return Le.length===0?!0:!!M(Le[0])}e.isDecorationOptionsArr=W;var $;(function(Le){function Ae(je){return je.map(Le.from)}Le.fromMany=Ae;function Te(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function ae(je){let it;if(Te(je)){const{language:vt,value:bt}=je;it={value:"```"+vt+`
`+bt+"\n```\n"}}else o.MarkdownString.isMarkdownString(je)?it={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?it={value:je}:it={value:""};const yt=Object.create(null);it.uris=yt;const kt=vt=>{try{let bt=D.URI.parse(vt,!0);bt=bt.with({query:Me(bt.query,yt)}),yt[vt]=bt}catch{}return""},Tt=new y.marked.Renderer;return Tt.link=kt,Tt.image=vt=>typeof vt=="string"?kt(R.parseHrefAndDimensions(vt).href):"",(0,y.marked)(it.value,{renderer:Tt}),it}Le.from=ae;function Me(je,it){if(!je)return je;let yt;try{yt=(0,m.parse)(je)}catch{}if(!yt)return je;let kt=!1;return yt=(0,k.cloneAndChange)(yt,Tt=>{if(D.URI.isUri(Tt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[vt]=Tt,kt=!0,vt}else return}),kt?JSON.stringify(yt):je}function Be(je){const it=new o.MarkdownString(je.value,je.supportThemeIcons);return it.isTrusted=je.isTrusted,it.supportHtml=je.supportHtml,it.baseUri=je.baseUri?D.URI.from(je.baseUri):void 0,it}Le.to=Be;function Xe(je){if(je)return typeof je=="string"?je:Le.from(je)}Le.fromStrict=Xe})($||(e.MarkdownString=$={}));function z(Le){return W(Le)?Le.map(Ae=>({range:t.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?$.fromMany(Ae.hoverMessage):Ae.hoverMessage?$.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):Le.map(Ae=>({range:t.from(Ae)}))}e.fromRangeOrRangeWithMessage=z;function N(Le){return typeof Le>"u"?Le:typeof Le=="string"?D.URI.file(Le):Le}e.pathOrURIToURI=N;var q;(function(Le){function Ae(Te){return typeof Te>"u"?Te:{contentText:Te.contentText,contentIconPath:Te.contentIconPath?N(Te.contentIconPath):void 0,border:Te.border,borderColor:Te.borderColor,fontStyle:Te.fontStyle,fontWeight:Te.fontWeight,textDecoration:Te.textDecoration,color:Te.color,backgroundColor:Te.backgroundColor,margin:Te.margin,width:Te.width,height:Te.height}}Le.from=Ae})(q||(e.ThemableDecorationAttachmentRenderOptions=q={}));var x;(function(Le){function Ae(Te){return typeof Te>"u"?Te:{backgroundColor:Te.backgroundColor,outline:Te.outline,outlineColor:Te.outlineColor,outlineStyle:Te.outlineStyle,outlineWidth:Te.outlineWidth,border:Te.border,borderColor:Te.borderColor,borderRadius:Te.borderRadius,borderSpacing:Te.borderSpacing,borderStyle:Te.borderStyle,borderWidth:Te.borderWidth,fontStyle:Te.fontStyle,fontWeight:Te.fontWeight,textDecoration:Te.textDecoration,cursor:Te.cursor,color:Te.color,opacity:Te.opacity,letterSpacing:Te.letterSpacing,gutterIconPath:Te.gutterIconPath?N(Te.gutterIconPath):void 0,gutterIconSize:Te.gutterIconSize,overviewRulerColor:Te.overviewRulerColor,before:Te.before?q.from(Te.before):void 0,after:Te.after?q.from(Te.after):void 0}}Le.from=Ae})(x||(e.ThemableDecorationRenderOptions=x={}));var U;(function(Le){function Ae(Te){if(typeof Te>"u")return Te;switch(Te){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=Ae})(U||(e.DecorationRangeBehavior=U={}));var de;(function(Le){function Ae(Te){return{isWholeLine:Te.isWholeLine,rangeBehavior:Te.rangeBehavior?U.from(Te.rangeBehavior):void 0,overviewRulerLane:Te.overviewRulerLane,light:Te.light?x.from(Te.light):void 0,dark:Te.dark?x.from(Te.dark):void 0,backgroundColor:Te.backgroundColor,outline:Te.outline,outlineColor:Te.outlineColor,outlineStyle:Te.outlineStyle,outlineWidth:Te.outlineWidth,border:Te.border,borderColor:Te.borderColor,borderRadius:Te.borderRadius,borderSpacing:Te.borderSpacing,borderStyle:Te.borderStyle,borderWidth:Te.borderWidth,fontStyle:Te.fontStyle,fontWeight:Te.fontWeight,textDecoration:Te.textDecoration,cursor:Te.cursor,color:Te.color,opacity:Te.opacity,letterSpacing:Te.letterSpacing,gutterIconPath:Te.gutterIconPath?N(Te.gutterIconPath):void 0,gutterIconSize:Te.gutterIconSize,overviewRulerColor:Te.overviewRulerColor,before:Te.before?q.from(Te.before):void 0,after:Te.after?q.from(Te.after):void 0}}Le.from=Ae})(de||(e.DecorationRenderOptions=de={}));var ie;(function(Le){function Ae(ae){return{text:ae.newText,eol:ae.newEol&&st.from(ae.newEol),range:t.from(ae.range)}}Le.from=Ae;function Te(ae){const Me=new o.TextEdit(t.to(ae.range),ae.text);return Me.newEol=typeof ae.eol>"u"?void 0:st.to(ae.eol),Me}Le.to=Te})(ie||(e.TextEdit=ie={}));var ne;(function(Le){function Ae(ae,Me){const Be={edits:[]};if(ae instanceof o.WorkspaceEdit){const Xe=new g.ResourceSet;for(const je of ae._allEntries())je._type===1&&D.URI.isUri(je.to)&&je.from===void 0&&Xe.add(je.to);for(const je of ae._allEntries())if(je._type===1){let it;je.options?.contents&&(ArrayBuffer.isView(je.options.contents)?it={type:"base64",value:(0,T.encodeBase64)(T.VSBuffer.wrap(je.options.contents))}:it={type:"dataTransferItem",id:je.options.contents._itemId}),Be.edits.push({oldResource:je.from,newResource:je.to,options:{...je.options,contents:it},metadata:je.metadata})}else je._type===2?Be.edits.push({resource:je.uri,textEdit:ie.from(je.edit),versionId:Xe.has(je.uri)?void 0:Me?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===6?Be.edits.push({resource:je.uri,textEdit:{range:t.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:Xe.has(je.uri)?void 0:Me?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===3?Be.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(je.uri)}):je._type===5&&Be.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Me?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(et.from)}})}return Be}Le.from=Ae;function Te(ae){const Me=new o.WorkspaceEdit,Be=new g.ResourceMap;for(const Xe of ae.edits)if(Xe.textEdit){const je=Xe,it=D.URI.revive(je.resource),yt=t.to(je.textEdit.range),kt=je.textEdit.text,Tt=je.textEdit.insertAsSnippet;let vt;Tt?vt=o.SnippetTextEdit.replace(yt,new o.SnippetString(kt)):vt=o.TextEdit.replace(yt,kt);const bt=Be.get(it);bt?bt.push(vt):Be.set(it,[vt])}else Me.renameFile(D.URI.revive(Xe.oldResource),D.URI.revive(Xe.newResource),Xe.options);for(const[Xe,je]of Be)Me.set(Xe,je);return Me}Le.to=Te})(ne||(e.WorkspaceEdit=ne={}));var H;(function(Le){const Ae=Object.create(null);Ae[o.SymbolKind.File]=0,Ae[o.SymbolKind.Module]=1,Ae[o.SymbolKind.Namespace]=2,Ae[o.SymbolKind.Package]=3,Ae[o.SymbolKind.Class]=4,Ae[o.SymbolKind.Method]=5,Ae[o.SymbolKind.Property]=6,Ae[o.SymbolKind.Field]=7,Ae[o.SymbolKind.Constructor]=8,Ae[o.SymbolKind.Enum]=9,Ae[o.SymbolKind.Interface]=10,Ae[o.SymbolKind.Function]=11,Ae[o.SymbolKind.Variable]=12,Ae[o.SymbolKind.Constant]=13,Ae[o.SymbolKind.String]=14,Ae[o.SymbolKind.Number]=15,Ae[o.SymbolKind.Boolean]=16,Ae[o.SymbolKind.Array]=17,Ae[o.SymbolKind.Object]=18,Ae[o.SymbolKind.Key]=19,Ae[o.SymbolKind.Null]=20,Ae[o.SymbolKind.EnumMember]=21,Ae[o.SymbolKind.Struct]=22,Ae[o.SymbolKind.Event]=23,Ae[o.SymbolKind.Operator]=24,Ae[o.SymbolKind.TypeParameter]=25;function Te(Me){return typeof Ae[Me]=="number"?Ae[Me]:6}Le.from=Te;function ae(Me){for(const Be in Ae)if(Ae[Be]===Me)return Number(Be);return o.SymbolKind.Property}Le.to=ae})(H||(e.SymbolKind=H={}));var V;(function(Le){function Ae(ae){switch(ae){case o.SymbolTag.Deprecated:return 1}}Le.from=Ae;function Te(ae){switch(ae){case 1:return o.SymbolTag.Deprecated}}Le.to=Te})(V||(e.SymbolTag=V={}));var ce;(function(Le){function Ae(ae){return{name:ae.name,kind:H.from(ae.kind),tags:ae.tags&&ae.tags.map(V.from),containerName:ae.containerName,location:K.from(ae.location)}}Le.from=Ae;function Te(ae){const Me=new o.SymbolInformation(ae.name,H.to(ae.kind),ae.containerName,K.to(ae.location));return Me.tags=ae.tags&&ae.tags.map(V.to),Me}Le.to=Te})(ce||(e.WorkspaceSymbol=ce={}));var be;(function(Le){function Ae(ae){const Me={name:ae.name||"!!MISSING: name!!",detail:ae.detail,range:t.from(ae.range),selectionRange:t.from(ae.selectionRange),kind:H.from(ae.kind),tags:ae.tags?.map(V.from)??[]};return ae.children&&(Me.children=ae.children.map(Ae)),Me}Le.from=Ae;function Te(ae){const Me=new o.DocumentSymbol(ae.name,ae.detail,H.to(ae.kind),t.to(ae.range),t.to(ae.selectionRange));return(0,v.isNonEmptyArray)(ae.tags)&&(Me.tags=ae.tags.map(V.to)),ae.children&&(Me.children=ae.children.map(Te)),Me}Le.to=Te})(be||(e.DocumentSymbol=be={}));var Se;(function(Le){function Ae(ae){const Me=new o.CallHierarchyItem(H.to(ae.kind),ae.name,ae.detail||"",D.URI.revive(ae.uri),t.to(ae.range),t.to(ae.selectionRange));return Me._sessionId=ae._sessionId,Me._itemId=ae._itemId,Me}Le.to=Ae;function Te(ae,Me,Be){if(Me=Me??ae._sessionId,Be=Be??ae._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,name:ae.name,detail:ae.detail,kind:H.from(ae.kind),uri:ae.uri,range:t.from(ae.range),selectionRange:t.from(ae.selectionRange),tags:ae.tags?.map(V.from)}}Le.from=Te})(Se||(e.CallHierarchyItem=Se={}));var ge;(function(Le){function Ae(Te){return new o.CallHierarchyIncomingCall(Se.to(Te.from),Te.fromRanges.map(ae=>t.to(ae)))}Le.to=Ae})(ge||(e.CallHierarchyIncomingCall=ge={}));var O;(function(Le){function Ae(Te){return new o.CallHierarchyOutgoingCall(Se.to(Te.to),Te.fromRanges.map(ae=>t.to(ae)))}Le.to=Ae})(O||(e.CallHierarchyOutgoingCall=O={}));var K;(function(Le){function Ae(ae){return{range:ae.range&&t.from(ae.range),uri:ae.uri}}Le.from=Ae;function Te(ae){return new o.Location(D.URI.revive(ae.uri),t.to(ae.range))}Le.to=Te})(K||(e.location=K={}));var we;(function(Le){function Ae(ae){const Me=ae,Be=ae;return{originSelectionRange:Me.originSelectionRange?t.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Be.uri,range:t.from(Me.targetRange?Me.targetRange:Be.range),targetSelectionRange:Me.targetSelectionRange?t.from(Me.targetSelectionRange):void 0}}Le.from=Ae;function Te(ae){return{targetUri:D.URI.revive(ae.uri),targetRange:t.to(ae.range),targetSelectionRange:ae.targetSelectionRange?t.to(ae.targetSelectionRange):void 0,originSelectionRange:ae.originSelectionRange?t.to(ae.originSelectionRange):void 0}}Le.to=Te})(we||(e.DefinitionLink=we={}));var Ce;(function(Le){function Ae(ae){return{range:t.from(ae.range),contents:$.fromMany(ae.contents)}}Le.from=Ae;function Te(ae){return new o.Hover(ae.contents.map($.to),t.to(ae.range))}Le.to=Te})(Ce||(e.Hover=Ce={}));var ee;(function(Le){function Ae(ae){return{range:t.from(ae.range),expression:ae.expression}}Le.from=Ae;function Te(ae){return new o.EvaluatableExpression(t.to(ae.range),ae.expression)}Le.to=Te})(ee||(e.EvaluatableExpression=ee={}));var te;(function(Le){function Ae(ae){if(ae instanceof o.InlineValueText)return{type:"text",range:t.from(ae.range),text:ae.text};if(ae instanceof o.InlineValueVariableLookup)return{type:"variable",range:t.from(ae.range),variableName:ae.variableName,caseSensitiveLookup:ae.caseSensitiveLookup};if(ae instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:t.from(ae.range),expression:ae.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=Ae;function Te(ae){switch(ae.type){case"text":return{range:t.to(ae.range),text:ae.text};case"variable":return{range:t.to(ae.range),variableName:ae.variableName,caseSensitiveLookup:ae.caseSensitiveLookup};case"expression":return{range:t.to(ae.range),expression:ae.expression}}}Le.to=Te})(te||(e.InlineValue=te={}));var ue;(function(Le){function Ae(ae){return{frameId:ae.frameId,stoppedLocation:t.from(ae.stoppedLocation)}}Le.from=Ae;function Te(ae){return new o.InlineValueContext(ae.frameId,t.to(ae.stoppedLocation))}Le.to=Te})(ue||(e.InlineValueContext=ue={}));var Q;(function(Le){function Ae(ae){return{range:t.from(ae.range),kind:ae.kind}}Le.from=Ae;function Te(ae){return new o.DocumentHighlight(t.to(ae.range),ae.kind)}Le.to=Te})(Q||(e.DocumentHighlight=Q={}));var le;(function(Le){function Ae(Te){switch(Te){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Le.to=Ae})(le||(e.CompletionTriggerKind=le={}));var se;(function(Le){function Ae(Te){return{triggerKind:le.to(Te.triggerKind),triggerCharacter:Te.triggerCharacter}}Le.to=Ae})(se||(e.CompletionContext=se={}));var oe;(function(Le){function Ae(ae){switch(ae){case o.CompletionItemTag.Deprecated:return 1}}Le.from=Ae;function Te(ae){switch(ae){case 1:return o.CompletionItemTag.Deprecated}}Le.to=Te})(oe||(e.CompletionItemTag=oe={}));var F;(function(Le){const Ae=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function Te(Be){return Ae.get(Be)??9}Le.from=Te;const ae=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Me(Be){return ae.get(Be)??o.CompletionItemKind.Property}Le.to=Me})(F||(e.CompletionItemKind=F={}));var j;(function(Le){function Ae(Te,ae){const Me=new o.CompletionItem(Te.label);return Me.insertText=Te.insertText,Me.kind=F.to(Te.kind),Me.tags=Te.tags?.map(oe.to),Me.detail=Te.detail,Me.documentation=R.isMarkdownString(Te.documentation)?$.to(Te.documentation):Te.documentation,Me.sortText=Te.sortText,Me.filterText=Te.filterText,Me.preselect=Te.preselect,Me.commitCharacters=Te.commitCharacters,I.Range.isIRange(Te.range)?Me.range=t.to(Te.range):typeof Te.range=="object"&&(Me.range={inserting:t.to(Te.range.insert),replacing:t.to(Te.range.replace)}),Me.keepWhitespace=typeof Te.insertTextRules>"u"?!1:!!(Te.insertTextRules&1),typeof Te.insertTextRules<"u"&&Te.insertTextRules&4?Me.insertText=new o.SnippetString(Te.insertText):(Me.insertText=Te.insertText,Me.textEdit=Me.range instanceof o.Range?new o.TextEdit(Me.range,Me.insertText):void 0),Te.additionalTextEdits&&Te.additionalTextEdits.length>0&&(Me.additionalTextEdits=Te.additionalTextEdits.map(Be=>ie.to(Be))),Me.command=ae&&Te.command?ae.fromInternal(Te.command):void 0,Me}Le.to=Ae})(j||(e.CompletionItem=j={}));var Y;(function(Le){function Ae(ae){if(typeof ae.label!="string"&&!Array.isArray(ae.label))throw new TypeError("Invalid label");return{label:ae.label,documentation:$.fromStrict(ae.documentation)}}Le.from=Ae;function Te(ae){return{label:ae.label,documentation:R.isMarkdownString(ae.documentation)?$.to(ae.documentation):ae.documentation}}Le.to=Te})(Y||(e.ParameterInformation=Y={}));var Z;(function(Le){function Ae(ae){return{label:ae.label,documentation:$.fromStrict(ae.documentation),parameters:Array.isArray(ae.parameters)?ae.parameters.map(Y.from):[],activeParameter:ae.activeParameter}}Le.from=Ae;function Te(ae){return{label:ae.label,documentation:R.isMarkdownString(ae.documentation)?$.to(ae.documentation):ae.documentation,parameters:Array.isArray(ae.parameters)?ae.parameters.map(Y.to):[],activeParameter:ae.activeParameter}}Le.to=Te})(Z||(e.SignatureInformation=Z={}));var me;(function(Le){function Ae(ae){return{activeSignature:ae.activeSignature,activeParameter:ae.activeParameter,signatures:Array.isArray(ae.signatures)?ae.signatures.map(Z.from):[]}}Le.from=Ae;function Te(ae){return{activeSignature:ae.activeSignature,activeParameter:ae.activeParameter,signatures:Array.isArray(ae.signatures)?ae.signatures.map(Z.to):[]}}Le.to=Te})(me||(e.SignatureHelp=me={}));var _e;(function(Le){function Ae(Te,ae){const Me=new o.InlayHint(p.to(ae.position),typeof ae.label=="string"?ae.label:ae.label.map(fe.to.bind(void 0,Te)),ae.kind&&ke.to(ae.kind));return Me.textEdits=ae.textEdits&&ae.textEdits.map(ie.to),Me.tooltip=R.isMarkdownString(ae.tooltip)?$.to(ae.tooltip):ae.tooltip,Me.paddingLeft=ae.paddingLeft,Me.paddingRight=ae.paddingRight,Me}Le.to=Ae})(_e||(e.InlayHint=_e={}));var fe;(function(Le){function Ae(Te,ae){const Me=new o.InlayHintLabelPart(ae.label);return Me.tooltip=R.isMarkdownString(ae.tooltip)?$.to(ae.tooltip):ae.tooltip,E.Command.is(ae.command)&&(Me.command=Te.fromInternal(ae.command)),ae.location&&(Me.location=K.to(ae.location)),Me}Le.to=Ae})(fe||(e.InlayHintLabelPart=fe={}));var ke;(function(Le){function Ae(ae){return ae}Le.from=Ae;function Te(ae){return ae}Le.to=Te})(ke||(e.InlayHintKind=ke={}));var Pe;(function(Le){function Ae(ae){return{range:t.from(ae.range),url:ae.target,tooltip:ae.tooltip}}Le.from=Ae;function Te(ae){let Me;if(ae.url)try{Me=typeof ae.url=="string"?D.URI.parse(ae.url,!0):D.URI.revive(ae.url)}catch{}return new o.DocumentLink(t.to(ae.range),Me)}Le.to=Te})(Pe||(e.DocumentLink=Pe={}));var $e;(function(Le){function Ae(ae){const Me=new o.ColorPresentation(ae.label);return ae.textEdit&&(Me.textEdit=ie.to(ae.textEdit)),ae.additionalTextEdits&&(Me.additionalTextEdits=ae.additionalTextEdits.map(Be=>ie.to(Be))),Me}Le.to=Ae;function Te(ae){return{label:ae.label,textEdit:ae.textEdit?ie.from(ae.textEdit):void 0,additionalTextEdits:ae.additionalTextEdits?ae.additionalTextEdits.map(Me=>ie.from(Me)):void 0}}Le.from=Te})($e||(e.ColorPresentation=$e={}));var He;(function(Le){function Ae(ae){return new o.Color(ae[0],ae[1],ae[2],ae[3])}Le.to=Ae;function Te(ae){return[ae.red,ae.green,ae.blue,ae.alpha]}Le.from=Te})(He||(e.Color=He={}));var tt;(function(Le){function Ae(ae){return{range:t.from(ae.range)}}Le.from=Ae;function Te(ae){return new o.SelectionRange(t.to(ae.range))}Le.to=Te})(tt||(e.SelectionRange=tt={}));var Ge;(function(Le){function Ae(Te){switch(Te){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Le.to=Ae})(Ge||(e.TextDocumentSaveReason=Ge={}));var Ke;(function(Le){function Ae(ae){switch(ae){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=Ae;function Te(ae){switch(ae){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Le.to=Te})(Ke||(e.TextEditorLineNumbersStyle=Ke={}));var st;(function(Le){function Ae(ae){if(ae===o.EndOfLine.CRLF)return 1;if(ae===o.EndOfLine.LF)return 0}Le.from=Ae;function Te(ae){if(ae===1)return o.EndOfLine.CRLF;if(ae===0)return o.EndOfLine.LF}Le.to=Te})(st||(e.EndOfLine=st={}));var at;(function(Le){function Ae(Te){if(typeof Te=="object")return Te.viewId;switch(Te){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=Ae})(at||(e.ProgressLocation=at={}));var Ze;(function(Le){function Ae(ae){const Me={start:ae.start+1,end:ae.end+1};return ae.kind&&(Me.kind=rt.from(ae.kind)),Me}Le.from=Ae;function Te(ae){const Me={start:ae.start-1,end:ae.end-1};return ae.kind&&(Me.kind=rt.to(ae.kind)),Me}Le.to=Te})(Ze||(e.FoldingRange=Ze={}));var rt;(function(Le){function Ae(ae){if(ae)switch(ae){case o.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}Le.from=Ae;function Te(ae){if(ae)switch(ae.value){case E.FoldingRangeKind.Comment.value:return o.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports.value:return o.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region.value:return o.FoldingRangeKind.Region}}Le.to=Te})(rt||(e.FoldingRangeKind=rt={}));var he;(function(Le){function Ae(Te){if(Te)return{pinned:typeof Te.preview=="boolean"?!Te.preview:void 0,inactive:Te.background,preserveFocus:Te.preserveFocus,selection:typeof Te.selection=="object"?t.from(Te.selection):void 0,override:typeof Te.override=="boolean"?a.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Le.from=Ae})(he||(e.TextEditorOpenOptions=he={}));var Oe;(function(Le){function Ae(Be){return Be instanceof o.RelativePattern?Be.toJSON():typeof Be=="string"?Be:Te(Be)||ae(Be)?new o.RelativePattern(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Le.from=Ae;function Te(Be){const Xe=Be;return Xe?D.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function ae(Be){const Xe=Be;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Me(Be){return typeof Be=="string"?Be:new o.RelativePattern(D.URI.revive(Be.baseUri),Be.pattern)}Le.to=Me})(Oe||(e.GlobPattern=Oe={}));var J;(function(Le){function Ae(Te){if(Te){if(Array.isArray(Te))return Te.map(Ae);if(typeof Te=="string")return Te;{const ae=Te;return{language:ae.language,scheme:ae.scheme,pattern:Oe.from(ae.pattern),exclusive:ae.exclusive,notebookType:ae.notebookType}}}else return}Le.from=Ae})(J||(e.LanguageSelector=J={}));var X;(function(Le){function Ae(ae){return{start:ae.start,end:ae.end}}Le.from=Ae;function Te(ae){return new o.NotebookRange(ae.start,ae.end)}Le.to=Te})(X||(e.NotebookRange=X={}));var Ee;(function(Le){function Ae(ae){return{timing:typeof ae.runStartTime=="number"&&typeof ae.runEndTime=="number"?{startTime:ae.runStartTime,endTime:ae.runEndTime}:void 0,executionOrder:ae.executionOrder,success:ae.lastRunSuccess}}Le.to=Ae;function Te(ae){return{lastRunSuccess:ae.success,runStartTime:ae.timing?.startTime,runEndTime:ae.timing?.endTime,executionOrder:ae.executionOrder}}Le.from=Te})(Ee||(e.NotebookCellExecutionSummary=Ee={}));var Ue;(function(Le){function Ae(Te){if(Te===b.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(Te===b.NotebookCellExecutionState.Pending)return;if(Te===b.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Te}`)}Le.to=Ae})(Ue||(e.NotebookCellExecutionState=Ue={}));var Ne;(function(Le){function Ae(ae){switch(ae){case o.NotebookCellKind.Markup:return b.CellKind.Markup;case o.NotebookCellKind.Code:default:return b.CellKind.Code}}Le.from=Ae;function Te(ae){switch(ae){case b.CellKind.Markup:return o.NotebookCellKind.Markup;case b.CellKind.Code:default:return o.NotebookCellKind.Code}}Le.to=Te})(Ne||(e.NotebookCellKind=Ne={}));var Qe;(function(Le){function Ae(ae){const Me={metadata:ae.metadata??Object.create(null),cells:[]};for(const Be of ae.cells)o.NotebookCellData.validate(Be),Me.cells.push(et.from(Be));return Me}Le.from=Ae;function Te(ae){const Me=new o.NotebookData(ae.cells.map(et.to));return(0,w.isEmptyObject)(ae.metadata)||(Me.metadata=ae.metadata),Me}Le.to=Te})(Qe||(e.NotebookData=Qe={}));var et;(function(Le){function Ae(ae){return{cellKind:Ne.from(ae.kind),language:ae.languageId,mime:ae.mime,source:ae.value,metadata:ae.metadata,internalMetadata:Ee.from(ae.executionSummary??{}),outputs:ae.outputs?ae.outputs.map(ft.from):[]}}Le.from=Ae;function Te(ae){return new o.NotebookCellData(Ne.to(ae.cellKind),ae.source,ae.language,ae.mime,ae.outputs?ae.outputs.map(ft.to):void 0,ae.metadata,ae.internalMetadata?Ee.to(ae.internalMetadata):void 0)}Le.to=Te})(et||(e.NotebookCellData=et={}));var nt;(function(Le){function Ae(ae){return{mime:ae.mime,valueBytes:T.VSBuffer.wrap(ae.data)}}Le.from=Ae;function Te(ae){return new o.NotebookCellOutputItem(ae.valueBytes.buffer,ae.mime)}Le.to=Te})(nt||(e.NotebookCellOutputItem=nt={}));var ft;(function(Le){function Ae(ae){return{outputId:ae.id,items:ae.items.map(nt.from),metadata:ae.metadata}}Le.from=Ae;function Te(ae){const Me=ae.items.map(nt.to);return new o.NotebookCellOutput(Me,ae.outputId,ae.metadata)}Le.to=Te})(ft||(e.NotebookCellOutput=ft={}));var wt;(function(Le){function Ae(Me){return ae(Me)?{include:(0,w.withNullAsUndefined)(Oe.from(Me.include)),exclude:(0,w.withNullAsUndefined)(Oe.from(Me.exclude))}:(0,w.withNullAsUndefined)(Oe.from(Me))}Le.from=Ae;function Te(Me){return ae(Me)?{include:Oe.to(Me.include),exclude:Oe.to(Me.exclude)}:Oe.to(Me)}Le.to=Te;function ae(Me){const Be=Me;return Be?!(0,w.isUndefinedOrNull)(Be.include)&&!(0,w.isUndefinedOrNull)(Be.exclude):!1}})(wt||(e.NotebookExclusiveDocumentPattern=wt={}));var Mt;(function(Le){function Ae(Te,ae,Me){const Be=typeof Te.command=="string"?{title:"",command:Te.command}:Te.command;return{alignment:Te.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:ae.toInternal(Be,Me),text:Te.text,tooltip:Te.tooltip,accessibilityInformation:Te.accessibilityInformation,priority:Te.priority}}Le.from=Ae})(Mt||(e.NotebookStatusBarItem=Mt={}));var Ft;(function(Le){function Ae(Te,ae,Me){const Be=typeof Te.command=="string"?{title:"",command:Te.command}:Te.command;return{command:ae.toInternal(Be,Me),label:Te.label,description:Te.description,detail:Te.detail,documentation:Te.documentation}}Le.from=Ae})(Ft||(e.NotebookKernelSourceAction=Ft={}));var _t;(function(Le){function Ae(Te){return{transientOutputs:Te?.transientOutputs??!1,transientCellMetadata:Te?.transientCellMetadata??{},transientDocumentMetadata:Te?.transientDocumentMetadata??{},cellContentMetadata:Te?.cellContentMetadata??{}}}Le.from=Ae})(_t||(e.NotebookDocumentContentOptions=_t={}));var Bt;(function(Le){function Ae(ae){return{uri:ae.uri,provides:ae.provides}}Le.from=Ae;function Te(ae){return new o.NotebookRendererScript(D.URI.revive(ae.uri),ae.provides)}Le.to=Te})(Bt||(e.NotebookRendererScript=Bt={}));var Nt;(function(Le){function Ae(ae){return{message:$.fromStrict(ae.message)||"",type:0,expected:ae.expectedOutput,actual:ae.actualOutput,location:ae.location&&{range:t.from(ae.location.range),uri:ae.location.uri}}}Le.from=Ae;function Te(ae){const Me=new o.TestMessage(typeof ae.message=="string"?ae.message:$.to(ae.message));return Me.actualOutput=ae.actual,Me.expectedOutput=ae.expected,Me.location=ae.location?K.to(ae.location):void 0,Me}Le.to=Te})(Nt||(e.TestMessage=Nt={}));var Ut;(function(Le){Le.namespace=_.namespaceTestTag,Le.denamespace=_.denamespaceTestTag})(Ut||(e.TestTag=Ut={}));var Ht;(function(Le){function Ae(ae){const Me=(0,l.getPrivateApiFor)(ae).controllerId;return{extId:f.TestId.fromExtHostTestItem(ae,Me).toString(),label:ae.label,uri:D.URI.revive(ae.uri),busy:ae.busy,tags:ae.tags.map(Be=>Ut.namespace(Me,Be.id)),range:I.Range.lift(t.from(ae.range)),description:ae.description||null,sortText:ae.sortText||null,error:ae.error&&$.fromStrict(ae.error)||null}}Le.from=Ae;function Te(ae){return{parent:void 0,error:void 0,id:f.TestId.fromString(ae.extId).localId,label:ae.label,uri:D.URI.revive(ae.uri),tags:(ae.tags||[]).map(Me=>{const{tagId:Be}=Ut.denamespace(Me);return new o.TestTag(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:t.to(ae.range||void 0),canResolveChildren:!1,busy:ae.busy,description:ae.description||void 0,sortText:ae.sortText||void 0}}Le.toPlain=Te})(Ht||(e.TestItem=Ht={})),function(Le){function Ae(ae){return{id:ae.id}}Le.from=Ae;function Te(ae){return new o.TestTag(ae.id)}Le.to=Te}(Ut||(e.TestTag=Ut={}));var Vt;(function(Le){const Ae=(ae,Me)=>{const Be=[];for(const[je,it]of Me)f.TestId.compare(it.item.extId,je)===2&&(Me.delete(je),Be.push(it));const Xe={...Ht.toPlain(ae.item),parent:void 0,taskStates:ae.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(it=>it.type===0).map(Nt.to)})),children:Be.map(je=>Ae(je,Me))};for(const je of Xe.children)je.parent=Xe;return Xe};function Te(ae){const Me=[],Be=new Map;for(const Xe of ae.items){Be.set(Xe.item.extId,Xe);const je=f.TestId.root(Xe.item.extId);ae.request.targets.some(it=>it.controllerId===je&&it.testIds.includes(Xe.item.extId))&&Me.push(Xe)}return{completedAt:ae.completedAt,results:Me.map(Xe=>Ae(Xe,Be))}}Le.to=Te})(Vt||(e.TestResults=Vt={}));var lt;(function(Le){function Ae(Be){return{covered:Be.covered,total:Be.covered}}function Te(Be){return"line"in Be?p.from(Be):t.from(Be)}function ae(Be){return"branches"in Be?{count:Be.executionCount,location:Te(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&Te(Xe.location)})):void 0}:{type:0,count:Be.executionCount,location:Te(Be.location)}}Le.fromDetailed=ae;function Me(Be){return{uri:Be.uri,statement:Ae(Be.statementCoverage),branch:Be.branchCoverage&&Ae(Be.branchCoverage),function:Be.functionCoverage&&Ae(Be.functionCoverage),details:Be.detailedCoverage?.map(ae)}}Le.fromFile=Me})(lt||(e.TestCoverage=lt={}));var gt;(function(Le){function Ae(Te){switch(Te){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Le.to=Ae})(gt||(e.CodeActionTriggerKind=gt={}));var zt;(function(Le){function Ae(ae){const Me=new o.TypeHierarchyItem(H.to(ae.kind),ae.name,ae.detail||"",D.URI.revive(ae.uri),t.to(ae.range),t.to(ae.selectionRange));return Me._sessionId=ae._sessionId,Me._itemId=ae._itemId,Me}Le.to=Ae;function Te(ae,Me,Be){if(Me=Me??ae._sessionId,Be=Be??ae._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,kind:H.from(ae.kind),name:ae.name,detail:ae.detail??"",uri:ae.uri,range:t.from(ae.range),selectionRange:t.from(ae.selectionRange),tags:ae.tags?.map(V.from)}}Le.from=Te})(zt||(e.TypeHierarchyItem=zt={}));var Rt;(function(Le){function Ae(Te){if(Te)return{value:Te.value,tooltip:Te.tooltip}}Le.from=Ae})(Rt||(e.ViewBadge=Rt={}));var It;(function(Le){function Ae(Be,Xe,je){const it=Xe.fileData;return it?new o.InternalFileDataTransferItem(new o.DataTransferFile(it.name,D.URI.revive(it.uri),it.id,(0,L.once)(()=>je(it.id)))):Be===A.Mimes.uriList&&Xe.uriListData?new o.InternalDataTransferItem(Me(Xe.uriListData)):new o.InternalDataTransferItem(Xe.asString)}Le.to=Ae;async function Te(Be,Xe){const je=await Xe.asString();if(Be===A.Mimes.uriList)return{asString:je,fileData:void 0,uriListData:ae(je)};const it=Xe.asFile();return{asString:je,fileData:it?{name:it.name,uri:it.uri,id:it._itemId??it.id}:void 0}}Le.from=Te;function ae(Be){return d.UriList.split(Be).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return D.URI.parse(Xe)}catch{}return Xe})}function Me(Be){return d.UriList.create(Be.map(Xe=>typeof Xe=="string"?Xe:D.URI.revive(Xe)))}})(It||(e.DataTransferItem=It={}));var ut;(function(Le){function Ae(ae,Me){const Be=ae.items.map(([Xe,je])=>[Xe,It.to(Xe,je,Me)]);return new o.DataTransfer(Be)}Le.toDataTransfer=Ae;async function Te(ae){const Me={items:[]},Be=[];for(const[Xe,je]of ae)Be.push((async()=>{Me.items.push([Xe,await It.from(Xe,je)])})());return await Promise.all(Be),Me}Le.from=Te})(ut||(e.DataTransfer=ut={}));var Pt;(function(Le){function Ae(ae){return{message:ae.message,metadata:ae.metadata,title:ae.title,tooltip:ae.tooltip}}Le.to=Ae;function Te(ae){return{kind:"reply",message:ae.message,metadata:ae.metadata,title:ae.title,tooltip:ae.tooltip}}Le.from=Te})(Pt||(e.ChatReplyFollowup=Pt={}));var Ot;(function(Le){function Ae(Te){return typeof Te=="string"?{title:Te,message:Te,kind:"reply"}:"commandId"in Te?{kind:"command",title:Te.title??"",commandId:Te.commandId??"",args:Te.args}:Pt.from(Te)}Le.from=Ae})(Ot||(e.ChatFollowup=Ot={}))}),define(De[260],Ie([1,0,2,8,7,15,68]),function(re,e,v,T,d,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class g{constructor(m,A,k,w={timeout:1500,errors:3}){this._logService=m,this._documents=A,this._mainThreadBulkEdits=k,this._thresholds=w,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(m){return(A,k,w)=>{const I={dispose:this._callbacks.push([A,k,m])};return Array.isArray(w)&&w.push(I),I}}async $participateInSave(m,A){const k=v.URI.revive(m);let w=!1;const D=setTimeout(()=>w=!0,this._thresholds.timeout),I=[];try{for(const E of[...this._callbacks]){if(w)break;const i=this._documents.getDocument(k),l=await this._deliverEventAsyncAndBlameBadListeners(E,{document:i,reason:L.TextDocumentSaveReason.to(A)});I.push(l)}}finally{clearTimeout(D)}return I}_deliverEventAsyncAndBlameBadListeners([m,A,k],w){const D=this._badListeners.get(m);return typeof D=="number"&&D>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,m,A,w).then(()=>!0,I=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(I),!(I instanceof Error)||I.message!=="concurrent_edits"){const E=this._badListeners.get(m);this._badListeners.set(m,E?E+1:1),typeof E=="number"&&E>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(m,A,k,w){const D=[],I=Date.now(),{document:E,reason:i}=w,{version:l}=E,a=Object.freeze({document:E,reason:i,waitUntil(b){if(Object.isFrozen(D))throw(0,T.illegalState)("waitUntil can not be called async");D.push(Promise.resolve(b))}});try{A.apply(k,[a])}catch(b){return Promise.reject(b)}return Object.freeze(D),new Promise((b,f)=>{const _=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(D).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' finished after ${Date.now()-I}ms`),clearTimeout(_),b(n)}).catch(n=>{clearTimeout(_),f(n)})}).then(b=>{const f={edits:[]};for(const _ of b)if(Array.isArray(_)&&_.every(n=>n instanceof d.TextEdit))for(const{newText:n,newEol:o,range:s}of _)f.edits.push({resource:E.uri,versionId:void 0,textEdit:{range:s&&L.Range.from(s),text:n,eol:o&&L.EndOfLine.from(o)}});if(f.edits.length!==0)return l===E.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=g}),define(De[261],Ie([1,0,16,2,15,7,102]),function(re,e,v,T,d,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class g{constructor(k,w,D,I){this.start=k,this.deletedCount=w,this.deletedItems=D,this.items=I}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(k,w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,w,D){this.notebook=k,this._extHostDocument=w,this._cellData=D,this.handle=D.handle,this.uri=T.URI.revive(D.uri),this.cellKind=D.cellKind,this._outputs=D.outputs.map(d.NotebookCellOutput.to),this._internalMetadata=D.internalMetadata??{},this._metadata=Object.freeze(D.metadata??{}),this._previousResult=Object.freeze(d.NotebookCellExecutionSummary.to(D.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,w=this._extHostDocument.getDocument(this.uri);if(!w)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const D={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:d.NotebookCellKind.to(this._cellData.cellKind),document:w.document,get mime(){return k._mime},set mime(I){k._mime=I},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(D)}return this._apiCell}setOutputs(k){this._outputs=k.map(d.NotebookCellOutput.to)}setOutputItems(k,w,D){const I=D.map(d.NotebookCellOutputItem.to),E=this._outputs.find(i=>i.id===k);if(E&&(w||(E.items.length=0),E.items.push(...I),E.items.length>1&&E.items.every(i=>R.isTextStreamMime(i.mime)))){const i=new Map,l=[];E.items.forEach(a=>{let b;i.has(a.mime)?b=i.get(a.mime):(b=[],i.set(a.mime,b),l.push(a.mime)),b.push(a.data)}),E.items.length=0,l.forEach(a=>{const b=R.compressOutputItemStreams(i.get(a));E.items.push({mime:a,data:b.buffer})})}}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(d.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=y;class m{constructor(k,w,D,I,E){this._proxy=k,this._textDocumentsAndEditors=w,this._textDocuments=D,this.uri=I,this.handle=m._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=E.viewType,this._metadata=Object.freeze(E.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,E.cells]],!0,void 0),this._versionId=E.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const k=this,w={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===v.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(D){return D=k._validateIndex(D),k._cells[D].apiCell},getCells(D){return(D?k._getCells(D):k._cells).map(E=>E.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(w)}return this._notebook}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,w,D){this._versionId=k.versionId,this._isDirty=w,this.acceptDocumentPropertiesChanged({metadata:D});const I={notebook:this.apiNotebook,metadata:D,cellChanges:[],contentChanges:[]},E=[];for(const l of k.rawEvents)l.kind===R.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1,I.contentChanges):l.kind===R.NotebookCellsChangeType.Move?this._moveCells(l.index,l.length,l.newIdx,I.contentChanges):l.kind===R.NotebookCellsChangeType.Output?(this._setCellOutputs(l.index,l.outputs),E.push({cell:this._cells[l.index].apiCell,outputs:this._cells[l.index].apiCell.outputs})):l.kind===R.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems),E.push({cell:this._cells[l.index].apiCell,outputs:this._cells[l.index].apiCell.outputs})):l.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(l.index,l.language),E.push({cell:this._cells[l.index].apiCell,document:this._cells[l.index].apiCell.document})):l.kind===R.NotebookCellsChangeType.ChangeCellContent?E.push({cell:this._cells[l.index].apiCell,document:this._cells[l.index].apiCell.document}):l.kind===R.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(l.index,l.mime):l.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(l.index,l.metadata),E.push({cell:this._cells[l.index].apiCell,metadata:this._cells[l.index].apiCell.metadata})):l.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(l.index,l.internalMetadata),E.push({cell:this._cells[l.index].apiCell,executionSummary:this._cells[l.index].apiCell.executionSummary}));const i=new Map;for(let l=0;l<E.length;l++){const a=E[l],b=i.get(a.cell);if(b===void 0){const f=I.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...a});i.set(a.cell,f-1)}else I.cellChanges[b]={...I.cellChanges[b],...a}}return Object.freeze(I),Object.freeze(I.cellChanges),Object.freeze(I.contentChanges),I}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let w=k.start|0,D=k.end|0;return w<0&&(w=0),D>this._cells.length&&(D=this._cells.length),k.with({start:w,end:D})}_getCells(k){k=this._validateRange(k);const w=[];for(let D=k.start;D<k.end;D++)w.push(this._cells[D]);return w}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,w,D){if(this._disposed)return;const I=[],E=[],i=[];if(k.reverse().forEach(l=>{const b=l[2].map(n=>{const o=new y(this,this._textDocumentsAndEditors,n);return w||E.push(y.asModelAddData(this.apiNotebook,n)),o}),f=new g(l[0],l[1],[],b),_=this._cells.splice(l[0],l[1],...b);for(const n of _)i.push(n.uri),f.deletedItems.push(n.apiCell);I.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:E,removedDocuments:i}),D)for(const l of I)D.push(l.asApiEvent())}_moveCells(k,w,D,I){const E=this._cells.splice(k,w);this._cells.splice(D,0,...E);const i=[new g(k,w,E.map(l=>l.apiCell),[]),new g(D,0,[],E)];for(const l of i)I.push(l.asApiEvent())}_setCellOutputs(k,w){this._cells[k].setOutputs(w)}_setCellOutputItems(k,w,D,I){this._cells[k].setOutputItems(w,D,I)}_changeCellLanguage(k,w){const D=this._cells[k];D.apiCell.document.languageId!==w&&this._textDocuments.$acceptModelLanguageChanged(D.uri,w)}_changeCellMime(k,w){const D=this._cells[k];D.apiCell.mime=w}_changeCellMetadata(k,w){this._cells[k].setMetadata(w)}_changeCellInternalMetadata(k,w){this._cells[k].setInternalMetadata(w)}getCellFromApiCell(k){return this._cells.find(w=>w.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(w=>w.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}e.ExtHostNotebookDocument=m,m._handlePool=0}),define(De[262],Ie([1,0,3,2,15,7]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class R{constructor(y,m,A,k={timeout:1500,errors:3}){this._logService=y,this._notebooksAndEditors=m,this._mainThreadBulkEdits=A,this._thresholds=k,this._onWillSaveNotebookDocumentEvent=new v.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(m,A,k)=>{const w=function(I){m.call(A,I)};return w.extension=y,this._onWillSaveNotebookDocumentEvent.event(w,void 0,k)}}async $participateInSave(y,m,A){const k=T.URI.revive(y),w=this._notebooksAndEditors.getNotebookDocument(k);if(!w)throw new Error("Unable to resolve notebook document");const D=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:w.apiNotebook,reason:d.TextDocumentSaveReason.to(m)},A,async(E,i)=>{const l=Date.now(),a=await await Promise.resolve(E);Date.now()-l>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",i.extension.identifier),!A.isCancellationRequested&&a&&(a instanceof L.WorkspaceEdit?D.push(a):this._logService.warn("onWillSaveNotebookDocument-listener from extension",i.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(D.length===0)return!0;const I={edits:[]};for(const E of D){const{edits:i}=d.WorkspaceEdit.from(E);I.edits=I.edits.concat(i)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(I)}}e.ExtHostNotebookDocumentSaveParticipant=R}),define(De[138],Ie([1,0,8,15,7]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{constructor(g,y,m,A,k,w){this.id=g,this._proxy=y,this.notebookData=m,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=k,this._visibleRanges=A,this._viewColumn=w}get apiEditor(){if(!this._editor){const g=this;this._editor={get notebook(){return g.notebookData.apiNotebook},get selection(){return g._selections[0]},set selection(y){this.selections=[y]},get selections(){return g._selections},set selections(y){if(!Array.isArray(y)||!y.every(d.NotebookRange.isNotebookRange))throw(0,v.illegalArgument)("selections");g._selections=y,g._trySetSelections(y)},get visibleRanges(){return g._visibleRanges},revealRange(y,m){g._proxy.$tryRevealRange(g.id,T.NotebookRange.from(y),m??d.NotebookEditorRevealType.Default)},get viewColumn(){return g._viewColumn}},L.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(g){this._visible=g}_acceptVisibleRanges(g){this._visibleRanges=g}_acceptSelections(g){this._selections=g}_trySetSelections(g){this._proxy.$trySetSelections(this.id,g.map(T.NotebookRange.from))}_acceptViewColumn(g){this._viewColumn=g}}e.ExtHostNotebookEditor=L,L.apiEditorsToExtHost=new WeakMap}),define(De[263],Ie([1,0,8,3,18,15]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=e.ExtHostNotebookEditors=class{constructor(y,m){this._logService=y,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new T.Emitter({onListenerError:v.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new T.Emitter({onListenerError:v.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(y,m){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,m);const A=this._notebooksAndEditors.getEditorById(y);m.visibleRanges&&A._acceptVisibleRanges(m.visibleRanges.ranges.map(L.NotebookRange.to)),m.selections&&A._acceptSelections(m.selections.selections.map(L.NotebookRange.to)),m.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),m.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const m in y)this._notebooksAndEditors.getEditorById(m)._acceptViewColumn(L.ViewColumn.to(y[m]))}};e.ExtHostNotebookEditors=R=Ve([ze(0,d.ILogService)],R)}),define(De[264],Ie([1,0,15,128,193,21,66,8]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(w){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=w}async withProgress(w,D,I){const E=this._handles++,{title:i,location:l,cancellable:a}=D,b={label:(0,d.localize)(0,null,w.displayName||w.name),id:w.identifier.value};return this._proxy.$startProgress(E,{location:v.ProgressLocation.from(l),title:i,source:b,cancellable:a},w.isUnderDevelopment?void 0:w.identifier.value).catch(g.onUnexpectedExternalError),this._withProgress(E,I,!!a)}_withProgress(w,D,I){let E;I&&(E=new L.CancellationTokenSource,this._mapHandleToCancellationSource.set(w,E));const i=a=>{this._proxy.$progressEnd(a),this._mapHandleToCancellationSource.delete(a),E?.dispose()};let l;try{l=D(new A(this._proxy,w),I&&E?E.token:L.CancellationToken.None)}catch(a){throw i(w),a}return l.then(a=>i(w),a=>i(w)),l}$acceptProgressCanceled(w){const D=this._mapHandleToCancellationSource.get(w);D&&(D.cancel(),this._mapHandleToCancellationSource.delete(w))}}e.ExtHostProgress=y;function m(k,w){return k.message=w.message,typeof w.increment=="number"&&(typeof k.increment=="number"?k.increment+=w.increment:k.increment=w.increment),k}class A extends T.Progress{constructor(w,D){super(I=>this.throttledReport(I)),this._proxy=w,this._handle=D}throttledReport(w){this._proxy.$progressReport(this._handle,w)}}Ve([(0,R.throttle)(100,(k,w)=>m(k,w),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(De[139],Ie([1,0,35,136,60,103,81,15,2]),function(re,e,v,T,d,L,R,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const m=(b,f,_,n)=>{let o=f;return{enumerable:!0,configurable:!1,get(){return o},set(s){if(!_(o,s)){const t=o;o=s,b.listener?.(n(s,t))}}}},A=(b,f)=>b===f,k={range:(b,f)=>b===f?!0:!b||!f?!1:b.isEqual(f),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(b,f)=>!(b.length!==f.length||b.some(_=>!f.find(n=>_.id===n.id)))},w=b=>f=>({op:4,update:b(f)}),D=(b,f)=>({range:(()=>{let _;const n=w(o=>({range:v.Range.lift(g.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return _},set(o){b.listener?.({op:6}),k.range(_,o)||(_=o,b.listener?.(n(o)))}}})(),label:m(b,f,k.label,w(_=>({label:_}))),description:m(b,void 0,k.description,w(_=>({description:_}))),sortText:m(b,void 0,k.sortText,w(_=>({sortText:_}))),canResolveChildren:m(b,!1,k.canResolveChildren,_=>({op:2,state:_})),busy:m(b,!1,k.busy,w(_=>({busy:_}))),error:m(b,void 0,k.error,w(_=>({error:g.MarkdownString.fromStrict(_)||null}))),tags:m(b,[],k.tags,(_,n)=>({op:1,new:_.map(g.TestTag.from),old:n.map(g.TestTag.from)}))}),I=b=>{const f=d.TestId.fromString(b.extId),_=new i(f.controllerId,f.localId,b.label,y.URI.revive(b.uri)||void 0);return _.range=g.Range.to(b.range||void 0),_.description=b.description||void 0,_.sortText=b.sortText||void 0,_.tags=b.tags.map(n=>g.TestTag.to({id:(0,R.denamespaceTestTag)(n).tagId})),_},E=b=>{let f;for(const _ of b.tests){const n=I(_.item);(0,T.getPrivateApiFor)(n).parent=f,f=n}return f};e.toItemFromContext=E;class i{constructor(f,_,n,o){if(_.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(_)} symbol`);const s=(0,T.createPrivateApiFor)(this,f);Object.defineProperties(this,{id:{value:_,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof l?void 0:s.parent}},children:{value:(0,L.createTestItemChildren)(s,T.getPrivateApiFor,i),enumerable:!0,writable:!1},...D(s,n)})}}e.TestItemImpl=i;class l extends i{constructor(f,_){super(f,f,_,void 0),this._isRoot=!0}}e.TestItemRootImpl=l;class a extends L.TestItemCollection{constructor(f,_,n){super({controllerId:f,getDocumentVersion:o=>o&&n.getDocument(o)?.version,getApiFor:T.getPrivateApiFor,getChildren:o=>o.children,root:new l(f,_),toITestItem:g.TestItem.from})}}e.ExtHostTestItemCollection=a}),define(De[140],Ie([1,0,53,8,111,15,7]),function(re,e,v,T,d,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class g{constructor(w,D,I){const E=g._Keys.nextId();w.$registerTextEditorDecorationType(D.identifier,E,L.DecorationRenderOptions.from(I)),this.value=Object.freeze({key:E,dispose(){w.$removeTextEditorDecorationType(E)}})}}e.TextEditorDecorationType=g,g._Keys=new d.IdGenerator("TextEditorDecorationType");class y{constructor(w,D){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=w,this._documentVersionId=w.version,this._undoStopBefore=D.undoStopBefore,this._undoStopAfter=D.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(w,D){this._throwIfFinalized();let I=null;if(w instanceof R.Position)I=new R.Range(w,w);else if(w instanceof R.Range)I=w;else throw new Error("Unrecognized location");this._pushEdit(I,D,!1)}insert(w,D){this._throwIfFinalized(),this._pushEdit(new R.Range(w,w),D,!0)}delete(w){this._throwIfFinalized();let D=null;if(w instanceof R.Range)D=w;else throw new Error("Unrecognized location");this._pushEdit(D,null,!0)}_pushEdit(w,D,I){const E=this._document.validateRange(w);this._collectedEdits.push({range:E,text:D,forceMoveMarkers:I})}setEndOfLine(w){if(this._throwIfFinalized(),w!==R.EndOfLine.LF&&w!==R.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this._setEndOfLine=w}}class m{constructor(w,D,I,E){this._proxy=w,this._id=D,this._accept(I),this._logService=E;const i=this;this.value={get tabSize(){return i._tabSize},set tabSize(l){i._setTabSize(l)},get indentSize(){return i._indentSize},set indentSize(l){i._setIndentSize(l)},get insertSpaces(){return i._insertSpaces},set insertSpaces(l){i._setInsertSpaces(l)},get cursorStyle(){return i._cursorStyle},set cursorStyle(l){i._setCursorStyle(l)},get lineNumbers(){return i._lineNumbers},set lineNumbers(l){i._setLineNumbers(l)}}}_accept(w){this._tabSize=w.tabSize,this._indentSize=w.indentSize,this._insertSpaces=w.insertSpaces,this._cursorStyle=w.cursorStyle,this._lineNumbers=L.TextEditorLineNumbersStyle.to(w.lineNumbers)}_validateTabSize(w){if(w==="auto")return"auto";if(typeof w=="number"){const D=Math.floor(w);return D>0?D:null}if(typeof w=="string"){const D=parseInt(w,10);return isNaN(D)?null:D>0?D:null}return null}_setTabSize(w){const D=this._validateTabSize(w);if(D!==null){if(typeof D=="number"){if(this._tabSize===D)return;this._tabSize=D}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:D}))}}_validateIndentSize(w){if(w==="tabSize")return"tabSize";if(typeof w=="number"){const D=Math.floor(w);return D>0?D:null}if(typeof w=="string"){const D=parseInt(w,10);return isNaN(D)?null:D>0?D:null}return null}_setIndentSize(w){const D=this._validateIndentSize(w);if(D!==null){if(typeof D=="number"){if(this._indentSize===D)return;this._indentSize=D}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:D}))}}_validateInsertSpaces(w){return w==="auto"?"auto":w==="false"?!1:!!w}_setInsertSpaces(w){const D=this._validateInsertSpaces(w);if(typeof D=="boolean"){if(this._insertSpaces===D)return;this._insertSpaces=D}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:D}))}_setCursorStyle(w){this._cursorStyle!==w&&(this._cursorStyle=w,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:w})))}_setLineNumbers(w){this._lineNumbers!==w&&(this._lineNumbers=w,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:L.TextEditorLineNumbersStyle.from(w)})))}assign(w){const D={};let I=!1;if(typeof w.tabSize<"u"){const E=this._validateTabSize(w.tabSize);E==="auto"?(I=!0,D.tabSize=E):typeof E=="number"&&this._tabSize!==E&&(this._tabSize=E,I=!0,D.tabSize=E)}if(typeof w.indentSize<"u"){const E=this._validateIndentSize(w.indentSize);E==="tabSize"?(I=!0,D.indentSize=E):typeof E=="number"&&this._indentSize!==E&&(this._indentSize=E,I=!0,D.indentSize=E)}if(typeof w.insertSpaces<"u"){const E=this._validateInsertSpaces(w.insertSpaces);E==="auto"?(I=!0,D.insertSpaces=E):this._insertSpaces!==E&&(this._insertSpaces=E,I=!0,D.insertSpaces=E)}typeof w.cursorStyle<"u"&&this._cursorStyle!==w.cursorStyle&&(this._cursorStyle=w.cursorStyle,I=!0,D.cursorStyle=w.cursorStyle),typeof w.lineNumbers<"u"&&this._lineNumbers!==w.lineNumbers&&(this._lineNumbers=w.lineNumbers,I=!0,D.lineNumbers=L.TextEditorLineNumbersStyle.from(w.lineNumbers)),I&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,D))}_warnOnError(w,D){D.catch(I=>{this._logService.warn(`ExtHostTextEditorOptions '${w}' failed:'`),this._logService.warn(I)})}}e.ExtHostTextEditorOptions=m;class A{constructor(w,D,I,E,i,l,a,b){this.id=w,this._proxy=D,this._logService=I,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=i,this._options=new m(this._proxy,this.id,l,I),this._visibleRanges=a,this._viewColumn=b;const f=this;this.value=Object.freeze({get document(){return E.value},set document(_){throw(0,T.readonly)("document")},get selection(){return f._selections&&f._selections[0]},set selection(_){if(!(_ instanceof R.Selection))throw(0,T.illegalArgument)("selection");f._selections=[_],f._trySetSelection()},get selections(){return f._selections},set selections(_){if(!Array.isArray(_)||_.some(n=>!(n instanceof R.Selection)))throw(0,T.illegalArgument)("selections");f._selections=_,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(_){throw(0,T.readonly)("visibleRanges")},get options(){return f._options.value},set options(_){f._disposed||f._options.assign(_)},get viewColumn(){return f._viewColumn},set viewColumn(_){throw(0,T.readonly)("viewColumn")},edit(_,n={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new y(E.value,n);return _(o),f._applyEdit(o)},insertSnippet(_,n,o={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!n||Array.isArray(n)&&n.length===0)s=f._selections.map(t=>L.Range.from(t));else if(n instanceof R.Position){const{lineNumber:t,column:u}=L.Position.from(n);s=[{startLineNumber:t,startColumn:u,endLineNumber:t,endColumn:u}]}else if(n instanceof R.Range)s=[L.Range.from(n)];else{s=[];for(const t of n)if(t instanceof R.Range)s.push(L.Range.from(t));else{const{lineNumber:u,column:p}=L.Position.from(t);s.push({startLineNumber:u,startColumn:p,endLineNumber:u,endColumn:p})}}return D.$tryInsertSnippet(w,E.value.version,_.value,s,o)},setDecorations(_,n){const o=n.length===0;o&&!f._hasDecorationsForKey.has(_.key)||(o?f._hasDecorationsForKey.delete(_.key):f._hasDecorationsForKey.add(_.key),f._runOnProxy(()=>{if(L.isDecorationOptionsArr(n))return D.$trySetDecorations(w,_.key,L.fromRangeOrRangeWithMessage(n));{const s=new Array(4*n.length);for(let t=0,u=n.length;t<u;t++){const p=n[t];s[4*t]=p.start.line+1,s[4*t+1]=p.start.character+1,s[4*t+2]=p.end.line+1,s[4*t+3]=p.end.character+1}return D.$trySetDecorationsFast(w,_.key,s)}}))},revealRange(_,n){f._runOnProxy(()=>D.$tryRevealRange(w,L.Range.from(_),n||R.TextEditorRevealType.Default))},show(_){D.$tryShowEditor(w,L.ViewColumn.from(_))},hide(){D.$tryHideEditor(w)}})}dispose(){(0,v.ok)(!this._disposed),this._disposed=!0}_acceptOptions(w){(0,v.ok)(!this._disposed),this._options._accept(w)}_acceptVisibleRanges(w){(0,v.ok)(!this._disposed),this._visibleRanges=w}_acceptViewColumn(w){(0,v.ok)(!this._disposed),this._viewColumn=w}_acceptSelections(w){(0,v.ok)(!this._disposed),this._selections=w}async _trySetSelection(){const w=this._selections.map(L.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,w)),this.value}_applyEdit(w){const D=w.finalize();if(D.edits.length===0&&!D.setEndOfLine)return Promise.resolve(!0);const I=D.edits.map(i=>i.range);I.sort((i,l)=>i.end.line===l.end.line?i.end.character===l.end.character?i.start.line===l.start.line?i.start.character-l.start.character:i.start.line-l.start.line:i.end.character-l.end.character:i.end.line-l.end.line);for(let i=0,l=I.length-1;i<l;i++){const a=I[i].end;if(I[i+1].start.isBefore(a))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const E=D.edits.map(i=>({range:L.Range.from(i.range),text:i.text,forceMoveMarkers:i.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,E,{setEndOfLine:typeof D.setEndOfLine=="number"?L.EndOfLine.from(D.setEndOfLine):void 0,undoStopBefore:D.undoStopBefore,undoStopAfter:D.undoStopAfter})}_runOnProxy(w){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,D=>(D instanceof Error&&D.name==="DISPOSED"||this._logService.warn(D),null))}}e.ExtHostTextEditor=A}),define(De[265],Ie([1,0,197,7,23,2,3,4,249,17,7,12,19,15,21,164]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function i(b,f){if((0,k.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let _;return Array.isArray(b.highlights)&&(_=b.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),_=_.length?_:void 0),{label:b.label,highlights:_}}}class l{constructor(f,_,n){this._proxy=f,this.commands=_,this.logService=n,this.treeViews=new Map,this.treeDragAndDropService=new E.TreeViewsDnDService;function o(s){return s&&s.$treeViewId&&(s.$treeItemHandle||s.$selectedTreeItems||s.$focusedTreeItem)}_.registerArgumentProcessor({processArgument:s=>o(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(t=>o(t)?this.convertArgument(t):t):s})}registerTreeDataProvider(f,_,n){const o=this.createTreeView(f,{treeDataProvider:_},n);return{dispose:()=>o.dispose()}}createTreeView(f,_,n){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=_.dragAndDropController?.dropMimeTypes??[],s=_.dragAndDropController?.dragMimeTypes??[],t=!!_.dragAndDropController?.handleDrag,u=!!_.dragAndDropController?.handleDrop,p=this.createExtHostTreeView(f,_,n),h={showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany,dropMimeTypes:o,dragMimeTypes:s,hasHandleDrag:t,hasHandleDrop:u,manuallyManageCheckboxes:!!_.manageCheckboxStateManually},C=this._proxy.$registerTreeViewDataProvider(f,h);return{get onDidCollapseElement(){return p.onDidCollapseElement},get onDidExpandElement(){return p.onDidExpandElement},get selection(){return p.selectedElements},get onDidChangeSelection(){return p.onDidChangeSelection},get visible(){return p.visible},get onDidChangeVisibility(){return p.onDidChangeVisibility},get onDidChangeCheckboxState(){return p.onDidChangeCheckboxState},get message(){return p.message},set message(S){p.message=S},get title(){return p.title},set title(S){p.title=S},get description(){return p.description},set description(S){p.description=S},get badge(){return p.badge},set badge(S){S!==void 0&&A.ViewBadge.isViewBadge(S)?p.badge={value:Math.floor(Math.abs(S.value)),tooltip:S.tooltip}:S===void 0&&(p.badge=void 0)},reveal:(S,c)=>p.reveal(S,c),dispose:async()=>{await C,this.treeViews.delete(f),p.dispose()}}}$getChildren(f,_){const n=this.treeViews.get(f);return n?n.getChildren(_):Promise.reject(new y.NoTreeViewError(f))}async $handleDrop(f,_,n,o,s,t,u,p){const h=this.treeViews.get(f);if(!h)return Promise.reject(new y.NoTreeViewError(f));const C=D.DataTransfer.toDataTransfer(n,async S=>(await this._proxy.$resolveDropFileData(f,_,S)).buffer);return u===f&&p&&await this.addAdditionalTransferItems(C,h,p,s,t),h.onDrop(C,o,s)}async addAdditionalTransferItems(f,_,n,o,s){const t=this.treeDragAndDropService.removeDragOperationTransfer(s);if(t)(await t)?.forEach((u,p)=>{u&&f.set(p,u)});else if(s&&_.handleDrag){const u=_.handleDrag(n,f,o);this.treeDragAndDropService.addDragOperationTransfer(s,u),await u}return f}async $handleDrag(f,_,n,o){const s=this.treeViews.get(f);if(!s)return Promise.reject(new y.NoTreeViewError(f));const t=await this.addAdditionalTransferItems(new T.DataTransfer,s,_,o,n);if(!(!t||o.isCancellationRequested))return D.DataTransfer.from(t)}async $hasResolve(f){const _=this.treeViews.get(f);if(!_)throw new y.NoTreeViewError(f);return _.hasResolve}$resolve(f,_,n){const o=this.treeViews.get(f);if(!o)throw new y.NoTreeViewError(f);return o.resolveTreeItem(_,n)}$setExpanded(f,_,n){const o=this.treeViews.get(f);if(!o)throw new y.NoTreeViewError(f);o.setExpanded(_,n)}$setSelection(f,_){const n=this.treeViews.get(f);if(!n)throw new y.NoTreeViewError(f);n.setSelection(_)}$setFocus(f,_){const n=this.treeViews.get(f);if(!n)throw new y.NoTreeViewError(f);n.setFocus(_)}$setVisible(f,_){const n=this.treeViews.get(f);if(!n)throw new y.NoTreeViewError(f);n.setVisible(_)}$changeCheckboxState(f,_){const n=this.treeViews.get(f);if(!n)throw new y.NoTreeViewError(f);n.setCheckboxState(_)}createExtHostTreeView(f,_,n){const o=new a(f,_,this._proxy,this.commands.converter,this.logService,n);return this.treeViews.set(f,o),o}convertArgument(f){const _=this.treeViews.get(f.$treeViewId);return _&&"$treeItemHandle"in f?_.getExtensionElement(f.$treeItemHandle):_&&"$focusedTreeItem"in f&&f.$focusedTreeItem?_.focusedElement:null}}e.ExtHostTreeViews=l;class a extends g.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(f=>this.getExtensionElement(f)).filter(f=>!(0,k.isUndefinedOrNull)(f))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(f,_,n,o,s,t){if(super(),this.viewId=f,this.proxy=n,this.commands=o,this.logService=s,this.extension=t,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new R.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new R.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new R.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new R.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new R.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new R.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new I.CancellationTokenSource,t.contributes&&t.contributes.views)for(const h in t.contributes.views)for(const C of t.contributes.views[h])C.id===f&&(this._title=C.name);this.dataProvider=_.treeDataProvider,this.dndController=_.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(h=>this._onDidChangeData.fire({message:!1,element:h})));let u,p;this._register(R.Event.debounce(this._onDidChangeData.event,(h,C)=>(h||(h={message:!1,elements:[]}),C.element!==!1&&(u||(u=new Promise(S=>p=S),this.refreshPromise=this.refreshPromise.then(()=>u)),Array.isArray(C.element)?h.elements.push(...C.element):h.elements.push(C.element)),C.message&&(h.message=!0),h),200,!0)(({message:h,elements:C})=>{C.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const S=p;return u=null,this.refresh(C).then(()=>S())})),h&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(f){const _=f?this.getExtensionElement(f):void 0;if(f&&!_)return this.logService.error(`No tree item with id '${f}' found.`),Promise.resolve([]);let n=this.getChildrenNodes(f);return n||(n=await this.fetchChildrenNodes(_)),n?n.map(o=>o.item):void 0}getExtensionElement(f){return this.elements.get(f)}reveal(f,_){_=_||{select:!0,focus:!1};const n=(0,k.isUndefinedOrNull)(_.select)?!0:_.select,o=(0,k.isUndefinedOrNull)(_.focus)?!1:_.focus,s=(0,k.isUndefinedOrNull)(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):f?this.refreshPromise.then(()=>this.resolveUnknownParentChain(f)).then(t=>this.resolveTreeNode(f,t[t.length-1]).then(u=>this.proxy.$reveal(this.viewId,{item:u.item,parentChain:t.map(p=>p.item)},{select:n,focus:o,expand:s})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:n,focus:o,expand:s})}get message(){return this._message}set message(f){this._message=f,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(f){this._title=f,this.proxy.$setTitle(this.viewId,f,this._description)}get description(){return this._description}set description(f){this._description=f,this.proxy.$setTitle(this.viewId,this._title,f)}get badge(){return this._badge}set badge(f){this._badge?.value===f?.value&&this._badge?.tooltip===f?.tooltip||(this._badge=D.ViewBadge.from(f),this.proxy.$setBadge(this.viewId,f))}setExpanded(f,_){const n=this.getExtensionElement(f);n&&(_?this._onDidExpandElement.fire(Object.freeze({element:n})):this._onDidCollapseElement.fire(Object.freeze({element:n})))}setSelection(f){(0,w.equals)(this._selectedHandles,f)||(this._selectedHandles=f,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(f){this._focusedHandle=f}setVisible(f){f!==this._visible&&(this._visible=f,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(f){const _=(await Promise.all(f.map(async n=>{const o=this.getExtensionElement(n.treeItemHandle);return o?{extensionItem:o,treeItem:await this.dataProvider.getTreeItem(o),newState:n.newState?A.TreeItemCheckboxState.Checked:A.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);_.forEach(n=>{n.treeItem.checkboxState=n.newState?A.TreeItemCheckboxState.Checked:A.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:_.map(n=>[n.extensionItem,n.newState])})}async handleDrag(f,_,n){const o=[];for(const s of f){const t=this.getExtensionElement(s);t&&o.push(t)}if(!(!this.dndController?.handleDrag||o.length===0))return await this.dndController.handleDrag(o,_,n),_}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(f,_,n){const o=_?this.getExtensionElement(_):void 0;if(!(!o&&_||!this.dndController?.handleDrop))return(0,m.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(o,f,n):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(f,_){if(!this.dataProvider.resolveTreeItem)return;const n=this.elements.get(f);if(n){const o=this.nodes.get(n);if(o){const s=await this.dataProvider.resolveTreeItem(o.extensionItem,n,_)??o.extensionItem;return this.validateTreeItem(s),o.item.tooltip=this.getTooltip(s.tooltip),o.item.command=this.getCommand(o.disposableStore,s.command),o.item}}}resolveUnknownParentChain(f){return this.resolveParent(f).then(_=>_?this.resolveUnknownParentChain(_).then(n=>this.resolveTreeNode(_,n[n.length-1]).then(o=>(n.push(o),n))):Promise.resolve([]))}resolveParent(f){const _=this.nodes.get(f);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):(0,m.asPromise)(()=>this.dataProvider.getParent(f))}resolveTreeNode(f,_){const n=this.nodes.get(f);return n?Promise.resolve(n):(0,m.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(o=>this.createHandle(f,o,_,!0)).then(o=>this.getChildren(_?_.item.handle:void 0).then(()=>{const s=this.getExtensionElement(o);if(s){const t=this.nodes.get(s);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${o}`)}))}getChildrenNodes(f){if(f){let _;if(typeof f=="string"){const n=this.getExtensionElement(f);_=n?this.nodes.get(n):void 0}else _=f;return _&&_.children||void 0}return this.roots}async fetchChildrenNodes(f){this.clearChildren(f);const _=new I.CancellationTokenSource(this._refreshCancellationSource.token);try{const n=f?this.nodes.get(f):void 0,o=await this.dataProvider.getChildren(f);if(_.token.isCancellationRequested)return;const s=await Promise.all((0,w.coalesce)(o||[]).map(async t=>{const u=await this.dataProvider.getTreeItem(t);return u&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(t,u,n):null}));return _.token.isCancellationRequested?void 0:(0,w.coalesce)(s)}finally{_.dispose()}}refresh(f){if(f.some(n=>!n))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new I.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const n=this.getHandlesToRefresh(f);if(n.length)return this.refreshHandles(n)}return Promise.resolve(void 0)}getHandlesToRefresh(f){const _=new Set,n=f.map(s=>this.nodes.get(s));for(const s of n)if(s&&!_.has(s.item.handle)){let t=s;for(;t&&t.parent&&n.findIndex(u=>t&&t.parent&&u&&u.item.handle===t.parent.item.handle)===-1;){const u=this.elements.get(t.parent.item.handle);t=u?this.nodes.get(u):void 0}t&&!t.parent&&_.add(s.item.handle)}const o=[];return _.forEach(s=>{const t=this.elements.get(s);if(t){const u=this.nodes.get(t);u&&(!u.parent||!_.has(u.parent.item.handle))&&o.push(s)}}),o}refreshHandles(f){const _={};return Promise.all(f.map(n=>this.refreshNode(n).then(o=>{o&&(_[n]=o.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(f){const _=this.getExtensionElement(f);if(_){const n=this.nodes.get(_);if(n)return this.clearChildren(_),(0,m.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(o=>{if(o){const s=this.createTreeNode(_,o,n.parent);return this.updateNodeCache(_,s,n,n.parent),n.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(f,_,n){const o=this.createTreeNode(f,_,n);if(_.id&&this.elements.has(o.item.handle))throw new Error((0,v.localize)(0,null,_.id));return this.addNodeToCache(f,o),this.addNodeToParentCache(o,n),o}getTooltip(f){return A.MarkdownString.isMarkdownString(f)?D.MarkdownString.from(f):f}getCommand(f,_){return _?{...this.commands.toInternal(_,f),originalId:_.command}:void 0}getCheckbox(f){if(f.checkboxState===void 0)return;let _,n,o;return typeof f.checkboxState=="number"?_=f.checkboxState:(_=f.checkboxState.state,n=f.checkboxState.tooltip,o=f.checkboxState.accessibilityInformation),{isChecked:_===A.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:o}}validateTreeItem(f){if(!A.TreeItem.isTreeItem(f,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(f,_,n){this.validateTreeItem(_);const o=new g.DisposableStore,s=this.createHandle(f,_,n),t=this.getLightIconPath(_);return{item:{handle:s,parentHandle:n?n.item.handle:void 0,label:i(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(o,_.command),contextValue:_.contextValue,icon:t,iconDark:this.getDarkIconPath(_)||t,themeIcon:this.getThemeIcon(_),collapsibleState:(0,k.isUndefinedOrNull)(_.collapsibleState)?A.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation,checkbox:this.getCheckbox(_)},extensionItem:_,parent:n,children:void 0,disposableStore:o,dispose(){o.dispose()}}}getThemeIcon(f){return f.iconPath instanceof A.ThemeIcon?f.iconPath:void 0}createHandle(f,{id:_,label:n,resourceUri:o},s,t){if(_)return`${a.ID_HANDLE_PREFIX}/${_}`;const u=i(n,this.extension),p=s?s.item.handle:a.LABEL_HANDLE_PREFIX;let h=u?u.label:o?(0,d.basename)(o):"";h=h.indexOf("/")!==-1?h.replace("/","//"):h;const C=this.nodes.has(f)?this.nodes.get(f).item.handle:void 0,S=this.getChildrenNodes(s)||[];let c,r=0;do{if(c=`${p}/${r}:${h}`,t||!this.elements.has(c)||C===c)break;r++}while(r<=S.length);return c}getLightIconPath(f){if(f.iconPath&&!(f.iconPath instanceof A.ThemeIcon))return typeof f.iconPath=="string"||L.URI.isUri(f.iconPath)?this.getIconPath(f.iconPath):this.getIconPath(f.iconPath.light)}getDarkIconPath(f){if(f.iconPath&&!(f.iconPath instanceof A.ThemeIcon)&&f.iconPath.dark)return this.getIconPath(f.iconPath.dark)}getIconPath(f){return L.URI.isUri(f)?f:L.URI.file(f)}addNodeToCache(f,_){this.elements.set(_.item.handle,f),this.nodes.set(f,_)}updateNodeCache(f,_,n,o){this.elements.delete(_.item.handle),this.nodes.delete(f),_.item.handle!==n.item.handle&&this.elements.delete(n.item.handle),this.addNodeToCache(f,_);const s=this.getChildrenNodes(o)||[],t=s.filter(u=>u.item.handle===n.item.handle)[0];t&&s.splice(s.indexOf(t),1,_)}addNodeToParentCache(f,_){_?(_.children||(_.children=[]),_.children.push(f)):(this.roots||(this.roots=[]),this.roots.push(f))}clearChildren(f){if(f){const _=this.nodes.get(f);if(_){if(_.children)for(const n of _.children){const o=this.elements.get(n.item.handle);o&&this.clear(o)}_.children=void 0}}else this.clearAll()}clear(f){const _=this.nodes.get(f);if(_){if(_.children)for(const n of _.children){const o=this.elements.get(n.item.handle);o&&this.clear(o)}this.nodes.delete(f),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(f=>f.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}a.LABEL_HANDLE_PREFIX="0",a.ID_HANDLE_PREFIX="1"}),define(De[266],Ie([1,0,5,214]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,v.refineServiceDecorator)(T.IEnvironmentService)}),define(De[141],Ie([1,0,25,3,11,4]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=R;class g{static isHostExtension(i,l,a){if(l.getExtensionDescription(i))return!1;const b=a.getExtensionDescription(i);return b?!!((b.main||b.browser)&&b.api==="none"):!1}constructor(i,l){this._activationEventsReader=i,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=l,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new v.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this._extensionsMap.set(i.identifier,i),this._extensionsArr.push(i);const l=this._activationEventsReader.readActivationEvents(i);if(Array.isArray(l))for(let a of l)a==="onUri"&&(a=`onUri:${v.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(a)||this._activationMap.set(a,[]),this._activationMap.get(a).push(i)}}set(i){this._extensionDescriptions=i,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,l){this._extensionDescriptions=I(this._extensionDescriptions,l),this._extensionDescriptions=this._extensionDescriptions.concat(i);const a=g._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=I(this._extensionDescriptions,a.map(b=>b.identifier)),this._initialize(),this._onDidChange.fire(void 0),new R(a)}static _findLoopingExtensions(i){const l=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(n){this._nodesSet.has(n)||(this._nodesSet.add(n),this._nodesArr.push(n))}addArc(n,o){this.addNode(n),this.addNode(o),this._arcs.has(n)?this._arcs.get(n).push(o):this._arcs.set(n,[o])}getArcs(n){return this._arcs.has(n)?this._arcs.get(n):[]}hasOnlyGoodArcs(n,o){const s=l.getArcs(n);for(let t=0;t<s.length;t++)if(!o.has(s[t]))return!1;return!0}getNodes(){return this._nodesArr}},a=new v.ExtensionIdentifierMap;for(const n of i)if(a.set(n.identifier,n),n.extensionDependencies)for(const o of n.extensionDependencies)l.addArc(v.ExtensionIdentifier.toKey(n.identifier),v.ExtensionIdentifier.toKey(o));const b=new Set;l.getNodes().filter(n=>l.getArcs(n).length===0).forEach(n=>b.add(n));const f=l.getNodes().filter(n=>!b.has(n));let _;do{_=!1;for(let n=0;n<f.length;n++){const o=f[n];l.hasOnlyGoodArcs(o,b)&&(f.splice(n,1),n--,b.add(o),_=!0)}}while(_);return f.map(n=>a.get(n))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(i)}getExtensionDescriptionsForActivationEvent(i){const l=this._activationMap.get(i);return l?l.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const l=this._extensionsMap.get(i);return l||void 0}getExtensionDescriptionByUUID(i){for(const l of this._extensionsArr)if(l.uuid===i)return l}getExtensionDescriptionByIdOrUUID(i,l){return this.getExtensionDescription(i)??(l?this.getExtensionDescriptionByUUID(l):void 0)}}e.ExtensionDescriptionRegistry=g,e.basicActivationEventsReader={readActivationEvents:E=>E.activationEvents};class y{constructor(i){this._lock=new k,this._actual=new g(i,[])}async acquireLock(i){const l=await this._lock.acquire(i);return new m(this,l)}deltaExtensions(i,l,a){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(l,a)}containsActivationEvent(i){return this._actual.containsActivationEvent(i)}containsExtension(i){return this._actual.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this._actual.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getExtensionDescription(i){return this._actual.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this._actual.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,l){return this._actual.getExtensionDescriptionByIdOrUUID(i,l)}}e.LockableExtensionDescriptionRegistry=y;class m extends L.Disposable{constructor(i,l){super(),this._registry=i,this._isDisposed=!1,this._register(l)}isAcquiredFor(i){return!this._isDisposed&&this._registry===i}}e.ExtensionDescriptionRegistryLock=m;class A{constructor(i){this.name=i,this.promise=new Promise((l,a)=>{this._resolve=l})}resolve(i){this._resolve(i)}}class k{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(i){const l=new A(i);return this._pendingCustomers.push(l),this._advance(),l.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const i=this._pendingCustomers.shift();this._isLocked=!0;let l=!0;const a=setTimeout(()=>{l&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),b=()=>{l&&(clearTimeout(a),l=!1,this._isLocked=!1,this._advance())};i.resolve((0,L.toDisposable)(b))}}var w;(function(E){E[E.Builtin=0]="Builtin",E[E.User=1]="User",E[E.Dev=2]="Dev"})(w||(w={}));function D(E,i){const l=E.isBuiltin?0:E.isUnderDevelopment?2:1,a=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(l!==a)return l-a;const b=d.posix.basename(E.extensionLocation.path),f=d.posix.basename(i.extensionLocation.path);return b<f?-1:b>f?1:0}function I(E,i){const l=new v.ExtensionIdentifierSet(i);return E.filter(a=>!l.has(a.identifier))}}),define(De[267],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var v;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(v||(e.ExtHostConnectionType=v={}));class T{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[T.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=T,T.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class d{constructor(){this.type=2}serialize(k){k[d.ENV_KEY]="1"}}e.SocketExtHostConnection=d,d.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class L{constructor(){this.type=3}serialize(k){k[L.ENV_KEY]="1"}}e.MessagePortExtHostConnection=L,L.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function R(A){delete A[T.ENV_KEY],delete A[d.ENV_KEY],delete A[L.ENV_KEY]}function g(A,k){R(k),A.serialize(k)}e.writeExtHostConnection=g;function y(A){if(A[T.ENV_KEY])return m(A,new T(A[T.ENV_KEY]));if(A[d.ENV_KEY])return m(A,new d);if(A[L.ENV_KEY])return m(A,new L);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function m(A,k){return R(A),k}}),define(De[105],Ie([1,0,22]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(T||(e.UIKind=T={}));var d;(function(m){m[m.VersionMismatch=55]="VersionMismatch",m[m.UnexpectedError=81]="UnexpectedError"})(d||(e.ExtensionHostExitCode=d={}));var L;(function(m){m[m.Initialized=0]="Initialized",m[m.Ready=1]="Ready",m[m.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(m){const A=v.VSBuffer.alloc(1);switch(m){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.createMessageOfType=R;function g(m,A){if(m.byteLength!==1)return!1;switch(m.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.isMessageOfType=g;var y;(function(m){m.Start="START_NATIVE_LOG",m.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(De[82],Ie([1,0,5,3,18,26,105,78,79,24,2,4,195]),function(re,e,v,T,d,L,R,g,y,m,A,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let D=e.ExtHostTelemetry=class extends k.Disposable{constructor(l,a){super(),this.initData=l,this.loggerService=a,this._onDidChangeTelemetryEnabled=this._register(new T.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new T.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=A.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=a.createLogger(this.extHostTelemetryLogFile,{id:y.extensionTelemetryLogChannelId,name:(0,w.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(a.onDidChangeLogLevel(b=>{(0,d.isLogLevel)(b)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===d.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(l,a,b){const f=this.getTelemetryDetails(),_=new I(a,b,l,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(l),{isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}),n=this._telemetryLoggers.get(l.identifier.value)??[];return this._telemetryLoggers.set(l.identifier.value,[...n,_]),_.apiTelemetryLogger}$initializeTelemetryLevel(l,a,b){this._level=l,this._telemetryIsSupported=a,this._productConfig=b??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(l){const a=Object.create(null);switch(a["common.extname"]=`${l.publisher}.${l.name}`,a["common.extversion"]=l.version,a["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,a["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,a["common.vscodeversion"]=this.initData.version,a["common.isnewappinstall"]=E(this.initData.telemetryInfo.firstSessionDate),a["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case R.UIKind.Web:a["common.uikind"]="web";break;case R.UIKind.Desktop:a["common.uikind"]="desktop";break;default:a["common.uikind"]="unknown"}return a["common.remotename"]=(0,g.getRemoteName)((0,y.cleanRemoteAuthority)(this.initData.remote.authority)),a}$onDidChangeTelemetryLevel(l){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=l;const a=this.getTelemetryDetails();this._telemetryLoggers.forEach((b,f)=>{const _=b.filter(n=>!n.isDisposed);_.length===0?this._telemetryLoggers.delete(f):this._telemetryLoggers.set(f,_)}),this._telemetryLoggers.forEach(b=>{for(const f of b)f.updateTelemetryEnablements(a.isUsageEnabled,a.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(l,a){const f=this._telemetryLoggers.get(l.value)?.filter(n=>!n.isDisposed);if(!f)return this._telemetryLoggers.delete(l.value),!1;let _=!1;for(const n of f)n.ignoreUnhandledExtHostErrors||(n.logError(a),_=!0);return _}};e.ExtHostTelemetry=D=Ve([ze(0,L.IExtHostInitDataService),ze(1,d.ILoggerService)],D);class I{static validateSender(l){if(typeof l!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof l.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof l.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof l.flush<"u"&&typeof l.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(l,a,b,f,_,n,o){this._extension=b,this._logger=f,this._inLoggingOnlyMode=_,this._commonProperties=n,this._onDidChangeEnableStates=new T.Emitter,this.ignoreUnhandledExtHostErrors=a?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=a?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=a?.additionalCommonProperties,this._sender=l,this._telemetryEnablements={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(l,a){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:l,isErrorsEnabled:a},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(l){let a="properties"in l?l.properties??{}:l;return a=(0,y.cleanData)(a,[]),this._additionalCommonProperties&&(a=(0,m.mixin)(a,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(a=(0,m.mixin)(a,this._commonProperties)),"properties"in l?l.properties=a:l=a,l}logEvent(l,a){this._sender&&(this._extension.publisher==="vscode"?l=this._extension.name+"/"+l:l=this._extension.identifier.value+"/"+l,a=this.mixInCommonPropsAndCleanData(a||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(l,a),this._logger.trace(l,a))}logUsage(l,a){this._telemetryEnablements.isUsageEnabled&&this.logEvent(l,a)}logError(l,a){!this._telemetryEnablements.isErrorsEnabled||!this._sender||(typeof l=="string"?this.logEvent(l,a):this._sender.sendErrorData(l,a))}get apiTelemetryLogger(){if(!this._apiObject){const l=this,a={logUsage:l.logUsage.bind(l),get isUsageEnabled(){return l._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return l._telemetryEnablements.isErrorsEnabled},logError:l.logError.bind(l),dispose:l.dispose.bind(l),onDidChangeEnableStates:l._onDidChangeEnableStates.event.bind(l)};this._apiObject=Object.freeze(a)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let l=this._sender;this._sender=void 0,Promise.resolve(l.flush()).then(l=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=I;function E(i){const l=Date.now()-new Date(i).getTime();return isNaN(l)?!1:l<1e3*60*60*24}e.isNewAppInstall=E,e.IExtHostTelemetry=(0,v.createDecorator)("IExtHostTelemetry")}),define(De[27],Ie([1,0,3,2,235,131,25,5]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,g.createDecorator)("extensionService");class y{constructor(_){this.dependency=_}}e.MissingExtensionDependency=y;var m;(function(f){f[f.EagerAutoStart=1]="EagerAutoStart",f[f.EagerManualStart=2]="EagerManualStart",f[f.Lazy=3]="Lazy"})(m||(e.ExtensionHostStartup=m={}));class A{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,addActivationEvents:L.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions),myToRemove:[],myToAdd:this._myExtensions}}set(_,n){const o=[],s=[],t=[],u=[],p=k(this._allExtensions),h=k(_),C=(M,W)=>M.extensionLocation.toString()===W.extensionLocation.toString()||M.isBuiltin===W.isBuiltin||M.isUserBuiltin===W.isUserBuiltin||M.isUnderDevelopment===W.isUnderDevelopment;for(const M of this._allExtensions){const W=h.get(M.identifier);if(!W){o.push(M.identifier),p.delete(M.identifier);continue}if(!C(M,W)){o.push(M.identifier),p.delete(M.identifier);continue}}for(const M of _){const W=p.get(M.identifier);if(!W){s.push(M);continue}if(!C(W,M)){o.push(W.identifier),p.delete(W.identifier);continue}}const S=new R.ExtensionIdentifierSet(this._myExtensions),c=new R.ExtensionIdentifierSet(n);for(const M of this._myExtensions)c.has(M)||t.push(M);for(const M of n)S.has(M)||u.push(M);const r=L.ImplicitActivationEvents.createActivationEventsMap(s),P={toRemove:o,toAdd:s,addActivationEvents:r,myToRemove:t,myToAdd:u};return this.delta(P),P}delta(_){const{toRemove:n,toAdd:o,myToRemove:s,myToAdd:t}=_,u=new R.ExtensionIdentifierSet(n),p=new R.ExtensionIdentifierSet(s);for(let h=0;h<this._allExtensions.length;h++)u.has(this._allExtensions[h].identifier)&&(this._allExtensions.splice(h,1),h--);for(let h=0;h<this._myExtensions.length;h++)p.has(this._myExtensions[h])&&(this._myExtensions.splice(h,1),h--);for(const h of o)this._allExtensions.push(h);for(const h of t)this._myExtensions.push(h)}containsExtension(_){for(const n of this._myExtensions)if(R.ExtensionIdentifier.equals(n,_))return!0;return!1}}e.ExtensionHostExtensions=A;function k(f){const _=new R.ExtensionIdentifierMap;for(const n of f)_.set(n.identifier,n);return _}function w(f,_){return f.enabledApiProposals?f.enabledApiProposals.includes(_):!1}e.isProposedApiEnabled=w;function D(f,_){if(!w(f,_))throw new Error(`Extension '${f.identifier.value}' CANNOT use API proposal: ${_}.
Its package.json#enabledApiProposals-property declares: ${f.enabledApiProposals?.join(", ")??"[]"} but NOT ${_}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${f.identifier.value}`)}e.checkProposedApiEnabled=D;class I{constructor(_,n,o,s){this.codeLoadingTime=_,this.activateCallTime=n,this.activateResolvedTime=o,this.activationReason=s}}e.ActivationTimes=I;class E{constructor(_,n){this.description=_,this.value=n}}e.ExtensionPointContribution=E;var i;(function(f){f[f.Normal=0]="Normal",f[f.Immediate=1]="Immediate"})(i||(e.ActivationKind=i={}));function l(f){return{type:f.isBuiltin?0:1,isBuiltin:f.isBuiltin||f.isUserBuiltin,identifier:{id:(0,d.getGalleryExtensionId)(f.publisher,f.name),uuid:f.uuid},manifest:f,location:f.extensionLocation,targetPlatform:f.targetPlatform,validations:[],isValid:!0}}e.toExtension=l;function a(f,_){return{identifier:new R.ExtensionIdentifier((0,d.getExtensionId)(f.manifest.publisher,f.manifest.name)),isBuiltin:f.type===0,isUserBuiltin:f.type===1&&f.isBuiltin,isUnderDevelopment:!!_,extensionLocation:f.location,...f.manifest,uuid:f.identifier.uuid,targetPlatform:f.targetPlatform}}e.toExtensionDescription=a;class b{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.onWillStop=v.Event.None,this.extensions=[]}activateByEvent(_){return Promise.resolve(void 0)}activationEventIsDone(_){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(_){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(_,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(_){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=b}),define(De[268],Ie([1,0,8,141,25,27,18,17]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(l,a,b,f){this.startup=l,this.codeLoadingTime=a,this.activateCallTime=b,this.activateResolvedTime=f}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class m{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,a){return l===-1||a===-1?-1:a-l}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=m;class A{constructor(l,a,b,f,_,n){this.activationFailed=l,this.activationFailedError=a,this.activationTimes=b,this.module=f,this.exports=_,this.subscriptions=n}}e.ActivatedExtension=A;class k extends A{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class w extends A{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=w;class D extends A{constructor(l){super(!0,l,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let I=e.ExtensionsActivator=class{constructor(l,a,b,f){this._logService=f,this._registry=l,this._globalRegistry=a,this._host=b,this._operations=new d.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[l,a]of this._operations)a.dispose()}async waitForActivatingExtensions(){const l=[];for(const[a,b]of this._operations)l.push(b.wait());await Promise.all(l)}isActivated(l){const a=this._operations.get(l);return!!(a&&a.value)}getActivatedExtension(l){const a=this._operations.get(l);if(!a||!a.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return a.value}async activateByEvent(l,a){if(this._alreadyActivatedEvents[l])return;const b=this._registry.getExtensionDescriptionsForActivationEvent(l);await this._activateExtensions(b.map(f=>({id:f.identifier,reason:{startup:a,extensionId:f.identifier,activationEvent:l}}))),this._alreadyActivatedEvents[l]=!0}activateById(l,a){const b=this._registry.getExtensionDescription(l);if(!b)throw new Error(`Extension '${l}' is not known`);return this._activateExtensions([{id:b.identifier,reason:a}])}async _activateExtensions(l){const a=l.filter(b=>!this.isActivated(b.id)).map(b=>this._handleActivationRequest(b));await Promise.all(a.map(b=>b.wait()))}_handleActivationRequest(l){if(this._operations.has(l.id))return this._operations.get(l.id);if(this._isHostExtension(l.id))return this._createAndSaveOperation(l,null,[],null);const a=this._registry.getExtensionDescription(l.id);if(!a){const _=new Error(`Cannot activate unknown extension '${l.id.value}'`),n=this._createAndSaveOperation(l,null,[],new D(_));return this._host.onExtensionActivationError(l.id,_,new L.MissingExtensionDependency(l.id.value)),n}const b=[],f=typeof a.extensionDependencies>"u"?[]:a.extensionDependencies;for(const _ of f){if(this._isResolvedExtension(_))continue;const n=this._operations.get(_);if(n){b.push(n);continue}if(this._isHostExtension(_)){b.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(_).identifier,reason:l.reason}));continue}const o=this._registry.getExtensionDescription(_);if(o){if(!o.main&&!o.browser)continue;b.push(this._handleActivationRequest({id:o.identifier,reason:l.reason}));continue}const s=a.displayName||a.identifier.value,t=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${_}'`),u=this._createAndSaveOperation(l,a.displayName,[],new D(t));return this._host.onExtensionActivationError(a.identifier,t,new L.MissingExtensionDependency(_)),u}return this._createAndSaveOperation(l,a.displayName,b,null)}_createAndSaveOperation(l,a,b,f){const _=new E(l.id,a,l.reason,b,f,this._host,this._logService);return this._operations.set(l.id,_),_}_isHostExtension(l){return T.ExtensionDescriptionRegistry.isHostExtension(l,this._registry,this._globalRegistry)}_isResolvedExtension(l){const a=this._globalRegistry.getExtensionDescription(l);return a?!a.main&&!a.browser:!1}};e.ExtensionsActivator=I=Ve([ze(3,R.ILogService)],I);let E=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(l,a,b,f,_,n,o){this._id=l,this._displayName=a,this._reason=b,this._deps=f,this._value=_,this._host=n,this._logService=o,this._barrier=new g.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let l=0;l<this._deps.length;l++){const a=this._deps[l];if(a.value&&!a.value.activationFailed){this._deps.splice(l,1),l--;continue}if(a.value&&a.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${a.friendlyName}' failed to activate`);b.detail=a.value.activationFailedError,this._value=new D(b),this._host.onExtensionActivationError(this._id,b,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(l=>l.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(l){const a=new Error;if(l&&l.name&&(a.name=l.name),l&&l.message?a.message=`Activating extension '${this._id.value}' failed: ${l.message}.`:a.message=`Activating extension '${this._id.value}' failed: ${l}.`,l&&l.stack&&(a.stack=l.stack),this._value=new D(a),this._isDisposed&&v.isCancellationError(l))return;this._host.onExtensionActivationError(this._id,a,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(l)}}};E=Ve([ze(6,R.ILogService)],E)}),define(De[269],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionOptions.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveSlashCommands.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemIcon:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemIcon.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testInvalidateResults:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testInvalidateResults.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[270],Ie([1,0,209,8,40,125,100,42,25,269,229,131]),function(re,e,v,T,d,L,R,g,y,m,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const w=g.Registry.as(R.Extensions.JSONContribution);class D{constructor(_,n,o){this._messageHandler=_,this._extension=n,this._extensionPointId=o}_msg(_,n){this._messageHandler({type:_,message:n,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(_){this._msg(d.default.Error,_)}warn(_){this._msg(d.default.Warning,_)}info(_){this._msg(d.default.Info,_)}}e.ExtensionMessageCollector=D;class I{static _toSet(_){const n=new y.ExtensionIdentifierSet;for(let o=0,s=_.length;o<s;o++)n.add(_[o].description.identifier);return n}static compute(_,n){if(!_||!_.length)return new I(n,[]);if(!n||!n.length)return new I([],_);const o=this._toSet(_),s=this._toSet(n),t=n.filter(p=>!o.has(p.description.identifier)),u=_.filter(p=>!s.has(p.description.identifier));return new I(t,u)}constructor(_,n){this.added=_,this.removed=n}}e.ExtensionPointUserDelta=I;class E{constructor(_,n){this.name=_,this.defaultExtensionKind=n,this._handler=null,this._users=null,this._delta=null}setHandler(_){if(this._handler!==null)throw new Error("Handler already set!");this._handler=_,this._handle()}acceptUsers(_){this._delta=I.compute(this._users,_),this._users=_,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(_){(0,T.onUnexpectedError)(_)}}}e.ExtensionPoint=E;const i={type:"string",enum:["ui","workspace"],enumDescriptions:[v.localize(0,null),v.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:v.localize(2,null),properties:{vscode:{type:"string",description:v.localize(3,null),default:"^1.22.0"}}},publisher:{description:v.localize(4,null),type:"string"},displayName:{description:v.localize(5,null),type:"string"},categories:{description:v.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:v.localize(7,null)}]}},galleryBanner:{type:"object",description:v.localize(8,null),properties:{color:{description:v.localize(9,null),type:"string"},theme:{description:v.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:v.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:v.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:v.localize(13,null)},enabledApiProposals:{markdownDescription:v.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}},api:{markdownDescription:v.localize(15,null),type:"string",enum:["none"],enumDescriptions:[v.localize(16,null)]},activationEvents:{description:v.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:v.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:v.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:v.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:v.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:v.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:v.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:v.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:v.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:v.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:v.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:v.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:v.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:v.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:v.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:v.localize(32,null)},{label:"onUri",body:"onUri",description:v.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:v.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:v.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:v.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:v.localize(37,null)},{label:"onRenderer",description:v.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:v.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:v.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:v.localize(41,null)},{label:"*",description:v.localize(42,null),body:"*"}]}},badges:{type:"array",description:v.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:v.localize(44,null)},href:{type:"string",description:v.localize(45,null)},description:{type:"string",description:v.localize(46,null)}}}},markdown:{type:"string",description:v.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:v.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:v.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:v.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:v.localize(51,null),type:"array",items:i,default:["workspace"],defaultSnippets:[{body:["ui"],description:v.localize(52,null)},{body:["workspace"],description:v.localize(53,null)},{body:["ui","workspace"],description:v.localize(54,null)},{body:["workspace","ui"],description:v.localize(55,null)},{body:[],description:v.localize(56,null)}]},capabilities:{description:v.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:v.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:v.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(60,null),v.localize(61,null),v.localize(62,null)]},description:{type:"string",markdownDescription:v.localize(63,null)}}},untrustedWorkspaces:{description:v.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:v.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(66,null),v.localize(67,null),v.localize(68,null)]},restrictedConfigurations:{description:v.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:v.localize(70,null)}}}}},sponsor:{description:v.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:v.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:v.localize(73,null),type:"string"},"vscode:uninstall":{description:v.localize(74,null),type:"string"}}},icon:{type:"string",description:v.localize(75,null)},l10n:{type:"string",description:v.localize(76,null)}}};class a{constructor(){this._extensionPoints=new Map}registerExtensionPoint(_){if(this._extensionPoints.has(_.extensionPoint))throw new Error("Duplicate extension point: "+_.extensionPoint);const n=new E(_.extensionPoint,_.defaultExtensionKind);return this._extensionPoints.set(_.extensionPoint,n),_.activationEventsGenerator&&k.ImplicitActivationEvents.register(_.extensionPoint,_.activationEventsGenerator),e.schema.properties.contributes.properties[_.extensionPoint]=_.jsonSchema,w.registerSchema(l,e.schema),n}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=a;const b={ExtensionsRegistry:"ExtensionsRegistry"};g.Registry.add(b.ExtensionsRegistry,new a),e.ExtensionsRegistry=g.Registry.as(b.ExtensionsRegistry),w.registerSchema(l,e.schema),w.registerSchema(A.productSchemaId,{properties:{extensionEnabledApiProposals:{description:v.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}}]}}}})}),define(De[271],Ie([1,0,206,12,24,270,47,3]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:v.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:v.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:v.localize(2,null),default:""}}};var m;(function(w){function D(I,E,i){if(!I)return;const l=T.isString(I.type)?I.type:void 0;if(!l||l.length===0){i.error(v.localize(3,null));return}const a=[];if(Array.isArray(I.required))for(const b of I.required)T.isString(b)&&a.push(b);return{extensionId:E.value,taskType:l,required:a,properties:I.properties?d.deepClone(I.properties):{},when:I.when?R.ContextKeyExpr.deserialize(I.when):void 0}}w.from=D})(m||(m={}));const A=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(w,D)=>{for(const I of w)I.type&&D.push(`onTaskType:${I.type}`)},jsonSchema:{description:v.localize(4,null),type:"array",items:y}});class k{constructor(){this._onDefinitionsChanged=new g.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((D,I)=>{A.setHandler((E,i)=>{this._schema=void 0;try{for(const l of i.removed){const a=l.value;for(const b of a)this.taskTypes&&b.type&&this.taskTypes[b.type]&&delete this.taskTypes[b.type]}for(const l of i.added){const a=l.value;for(const b of a){const f=m.from(b,l.description.identifier,l.collector);f&&(this.taskTypes[f.taskType]=f)}}(i.removed.length>0||i.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}D(void 0)})})}onReady(){return this.readyPromise}get(D){return this.taskTypes[D]}all(){return Object.keys(this.taskTypes).map(D=>this.taskTypes[D])}getJsonSchema(){if(this._schema===void 0){const D=[];for(const I of this.all()){const E={type:"object",additionalProperties:!1};I.required.length>0&&(E.required=I.required.slice(0)),I.properties!==void 0?E.properties=d.deepClone(I.properties):E.properties=Object.create(null),E.properties.type={type:"string",enum:[I.taskType]},D.push(E)}this._schema={oneOf:D}}return this._schema}}e.TaskDefinitionRegistry=new k}),define(De[272],Ie([1,0,207,12,23,24,47,271]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new R.RawContextKey("taskRunning",!1,v.localize(0,null)),e.TASKS_CATEGORY={value:v.localize(1,null),original:"Tasks"};var y;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(y||(e.ShellQuoting=y={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function q(x){if(!x)return N.Strong;switch(x.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=q}(y||(e.ShellQuoting=y={}));var m;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(m||(e.CommandOptions=m={}));var A;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(A||(e.RevealKind=A={})),function(N){function q(x){switch(x.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=q}(A||(e.RevealKind=A={}));var k;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(N){function q(x){switch(x.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=q}(k||(e.RevealProblemKind=k={}));var w;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(w||(e.PanelKind=w={})),function(N){function q(x){switch(x.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=q}(w||(e.PanelKind=w={}));var D;(function(N){N.defaults={echo:!0,reveal:A.Always,revealProblems:k.Never,focus:!1,panel:w.Shared,showReuseMessage:!0,clear:!1}})(D||(e.PresentationOptions=D={}));var I;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(I||(e.RuntimeType=I={})),function(N){function q(U){switch(U.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=q;function x(U){switch(U){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=x}(I||(e.RuntimeType=I={}));var E;(function(N){function q(x){return T.isString(x)?x:x.value}N.value=q})(E||(e.CommandString=E={}));var i;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function q(U){return U===N.Clean._id||U===N.Build._id||U===N.Rebuild._id||U===N.Test._id}N.is=q;function x(U){if(U!==void 0)return T.isString(U)?q(U)?{_id:U,isDefault:!1}:void 0:U}N.from=x})(i||(e.TaskGroup=i={}));var l;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(l||(e.TaskScope=l={}));var a;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function q(x){switch(x){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=q})(a||(e.TaskSourceKind=a={}));var b;(function(N){N.parallel="parallel",N.sequence="sequence"})(b||(e.DependsOrder=b={}));var f;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(f||(e.RunOnOptions=f={}));var _;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:f.default,instanceLimit:1}})(_||(e.RunOptions=_={}));class n{constructor(q,x,U,de,ie,ne){this._label="",this._id=q,x&&(this._label=x),U&&(this.type=U),this.runOptions=de,this.configurationProperties=ie,this._source=ne}getDefinition(q){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const q={folder:this.getFolderId(),id:this._id};return JSON.stringify(q)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(q,x=!1){if(q===void 0)return!1;if(T.isString(q))return q===this._label||q===this.configurationProperties.identifier||x&&q===this._id;const U=this.getDefinition(!0);return U!==void 0&&U._key===q._key}getQualifiedLabel(){const q=this.getWorkspaceFolder();return q?`${this._label} (${q.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(q){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),q&&(this._taskLoadMessages=this._taskLoadMessages.concat(q))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=n;class o extends n{constructor(q,x,U,de,ie,ne,H,V){super(q,U,void 0,H,V,x),this.command={},this._source=x,this.hasDefinedMatchers=ne,ie&&(this.command=ie)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(q=!1){if(q&&this._source.customizes!==void 0)return this._source.customizes;{let x;switch(this.command?this.command.runtime:void 0){case I.Shell:x="shell";break;case I.Process:x="process";break;case I.CustomExecution:x="customExecution";break;case void 0:x="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:x,_key:this._id,id:this._id}}}static is(q){return q instanceof o}getMapKey(){const q=this._source.config.workspaceFolder;return q?`${q.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===a.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const q=this.getFolderId();if(!q)return;let x=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(x+=this._source.kind);const U={type:e.CUSTOMIZED_TASK_TYPE,folder:q,id:x};return JSON.stringify(U)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(q){return new o(q._id,q._source,q._label,q.type,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.CustomTask=o;class s extends n{constructor(q,x,U,de,ie,ne,H){super(q,U,de,ne,H,x),this._source=x,this.configures=ie}static is(q){return q instanceof s}fromObject(q){return q}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===a.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const q=this.getFolderId();if(!q)return;let x=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(x+=this._source.kind);const U={type:e.CUSTOMIZED_TASK_TYPE,folder:q,id:x};return JSON.stringify(U)}}e.ConfiguringTask=s;class t extends n{constructor(q,x,U,de,ie,ne,H,V,ce){super(q,U,de,V,ce,x),this.defines=ie,this.hasDefinedMatchers=H,this.command=ne,this.icon=ce.icon,this.hide=ce.hide}clone(){return new t(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(q){return q instanceof t}getMapKey(){const q=this._source.workspaceFolder;return q?`${this._source.scope.toString()}|${q.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const q={type:"contributed",scope:this._source.scope,id:this._id};return q.folder=this.getFolderId(),JSON.stringify(q)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(q){return new t(q._id,q._source,q._label,q.type,q.defines,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.ContributedTask=t;class u extends n{constructor(q,x,U,de,ie,ne){super(q,U,de,ie,ne,x),this._source=x}clone(){return new u(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(q){return q instanceof u}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(q){return new u(q._id,q._source,q._label,q.type,q.runOptions,q.configurationProperties)}}e.InMemoryTask=u;var p;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(p||(e.ExecutionEngine=p={})),function(N){N._default=N.Terminal}(p||(e.ExecutionEngine=p={}));var h;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(h||(e.JsonSchemaVersion=h={}));class C{constructor(q){this._order=new Map;for(let x=0;x<q.length;x++)this._order.set(q[x].uri.toString(),x)}compare(q,x){const U=q.getWorkspaceFolder(),de=x.getWorkspaceFolder();if(U&&de){let ie=this._order.get(U.uri.toString());ie=ie===void 0?0:ie+1;let ne=this._order.get(de.uri.toString());return ne=ne===void 0?0:ne+1,ie===ne?q._label.localeCompare(x._label):ie-ne}else return!U&&de?-1:U&&!de?1:0}}e.TaskSorter=C;var S;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(S||(e.TaskEventKind=S={}));var c;(function(N){N.SingleRun="singleRun",N.Background="background"})(c||(e.TaskRunType=c={}));var r;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(r||(e.TaskRunSource=r={}));var P;(function(N){function q(x,U,de,ie){if(U){const ne={kind:x,taskId:U._id,taskName:U.configurationProperties.name,runType:U.configurationProperties.isBackground?"background":"singleRun",group:U.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:de,__task:U};return x==="start"?ne.resolvedVariables=ie:x==="processStarted"?ne.processId=ie:x==="processEnded"&&(ne.exitCode=ie),Object.freeze(ne)}else return Object.freeze({kind:"changed"})}N.create=q})(P||(e.TaskEvent=P={}));var M;(function(N){function q(U){const de=Object.keys(U).sort();let ie="";for(const ne of de){let H=U[ne];H instanceof Object?H=q(H):typeof H=="string"&&(H=H.replace(/,/g,",,")),ie+=ne+","+H+","}return ie}function x(U){const ie={_key:q(U),type:U.taskType};return Object.assign(ie,U),ie}N.create=x})(M||(e.KeyedTaskIdentifier=M={}));var W;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(W||(e.TaskSettingId=W={}));var $;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})($||(e.TasksSchemaProperties=$={}));var z;(function(N){function q(x,U){const de=g.TaskDefinitionRegistry.get(x.type);if(de===void 0){const V=L.deepClone(x);return delete V._key,M.create(V)}const ie=Object.create(null);ie.type=de.taskType;const ne=new Set;de.required.forEach(V=>ne.add(V));const H=de.properties;for(const V of Object.keys(H)){const ce=x[V];if(ce!=null)ie[V]=ce;else if(ne.has(V)){const be=H[V];if(be.default!==void 0)ie[V]=L.deepClone(be.default);else switch(be.type){case"boolean":ie[V]=!1;break;case"number":case"integer":ie[V]=0;break;case"string":ie[V]="";break;default:U.error(v.localize(2,null,JSON.stringify(x,void 0,0),V));return}}}return M.create(ie)}N.createTaskIdentifier=q})(z||(e.TaskDefinition=z={}))}),define(De[273],Ie([1,0,8]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class T{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((R,g)=>{this._actualOk=R,this._actualErr=g,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(R){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=R,this._actual&&this._actualOk(R))}resolveErr(R){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=R,this._actual?this._actualErr(R):(0,v.onUnexpectedError)(R))}then(R,g){return this._ensureActual().then(R,g)}catch(R){return this._ensureActual().then(void 0,R)}finally(R){return this._ensureActual().finally(R)}}e.LazyPromise=T;class d extends T{constructor(){super(),this._hasErr=!0,this._err=new v.CancellationError}}e.CanceledLazyPromise=d}),define(De[61],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class v{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++v.count}}e.ProxyIdentifier=v,v.count=0;const T=[];function d(g){const y=new v(g);return T[y.nid]=y,y}e.createProxyIdentifier=d;function L(g){return T[g].sid}e.getStringIdentifierForProxy=L;class R{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=R}),define(De[6],Ie([1,0,61]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var d;(function(E){E[E.UnknownInput=0]="UnknownInput",E[E.TextInput=1]="TextInput",E[E.TextDiffInput=2]="TextDiffInput",E[E.TextMergeInput=3]="TextMergeInput",E[E.NotebookInput=4]="NotebookInput",E[E.NotebookDiffInput=5]="NotebookDiffInput",E[E.CustomEditorInput=6]="CustomEditorInput",E[E.WebviewEditorInput=7]="WebviewEditorInput",E[E.TerminalEditorInput=8]="TerminalEditorInput",E[E.InteractiveEditorInput=9]="InteractiveEditorInput"})(d||(e.TabInputKind=d={}));var L;(function(E){E[E.TAB_OPEN=0]="TAB_OPEN",E[E.TAB_CLOSE=1]="TAB_CLOSE",E[E.TAB_UPDATE=2]="TAB_UPDATE",E[E.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(E){E[E.Editable=0]="Editable",E[E.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var g;(function(E){E[E.Int8Array=1]="Int8Array",E[E.Uint8Array=2]="Uint8Array",E[E.Uint8ClampedArray=3]="Uint8ClampedArray",E[E.Int16Array=4]="Int16Array",E[E.Uint16Array=5]="Uint16Array",E[E.Int32Array=6]="Int32Array",E[E.Uint32Array=7]="Uint32Array",E[E.Float32Array=8]="Float32Array",E[E.Float64Array=9]="Float64Array",E[E.BigInt64Array=10]="BigInt64Array",E[E.BigUint64Array=11]="BigUint64Array"})(g||(e.WebviewMessageArrayBufferViewType=g={}));var y;(function(E){E[E.Text=1]="Text",E[E.Error=2]="Error",E[E.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var m;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})(m||(e.NotebookEditorRevealType=m={}));var A;(function(E){E[E.None=0]="None",E[E.Process=1]="Process",E[E.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class k{static mixin(i){return i._id=k._n++,i}}e.IdObject=k,k._n=0;var w;(function(E){E.label="a",E.kind="b",E.detail="c",E.documentation="d",E.sortText="e",E.filterText="f",E.preselect="g",E.insertText="h",E.insertTextRules="i",E.range="j",E.commitCharacters="k",E.additionalTextEdits="l",E.kindModifier="m",E.commandIdent="n",E.commandId="o",E.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var D;(function(E){E.defaultRanges="a",E.completions="b",E.isIncomplete="c",E.duration="d"})(D||(e.ISuggestResultDtoField=D={}));var I;(function(E){E[E.Workspace=0]="Workspace",E[E.TextDocument=1]="TextDocument"})(I||(e.ExtHostTestingResource=I={})),e.MainContext={MainThreadAuthentication:(0,v.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,v.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,v.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,v.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,v.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,v.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,v.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,v.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,v.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,v.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,v.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,v.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,v.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,v.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,v.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,v.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,v.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,v.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,v.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,v.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,v.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,v.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,v.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,v.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,v.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,v.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,v.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,v.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,v.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,v.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,v.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,v.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,v.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,v.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,v.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,v.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,v.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,v.createProxyIdentifier)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,v.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,v.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,v.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,v.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,v.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,v.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,v.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,v.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,v.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,v.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,v.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,v.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,v.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,v.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,v.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,v.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,v.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,v.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,v.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,v.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,v.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,v.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,v.createProxyIdentifier)("ExtHostChat"),ExtHostSemanticSimilarity:(0,v.createProxyIdentifier)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,v.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,v.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,v.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,v.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,v.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,v.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,v.createProxyIdentifier)("ExtHostIssueReporter")}}),define(De[83],Ie([1,0,5,18,6,20]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,v.createDecorator)("IExtHostApiDeprecationService");let R=e.ExtHostApiDeprecationService=class{constructor(y,m){this._extHostLogService=m,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(d.MainContext.MainThreadTelemetry)}report(y,m,A){const k=this.getUsageKey(y,m);this._reportedUsages.has(k)||(this._reportedUsages.add(k),m.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:m.identifier.value,apiId:y}))}getUsageKey(y,m){return`${y}-${m.identifier.value}`}};e.ExtHostApiDeprecationService=R=Ve([ze(0,L.IExtHostRpcService),ze(1,T.ILogService)],R),e.NullApiDeprecationService=Object.freeze(new class{report(g,y,m){}})}),define(De[274],Ie([1,0,3,6,7,25]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(m){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new v.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new g,this._getSessionsTaskSingler=new g,this._proxy=m.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(m){return this._providers=m,Promise.resolve()}async getSession(m,A,k,w={}){const D=L.ExtensionIdentifier.toKey(m.identifier),I=[...k].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${D} ${A} ${I}`,async()=>{await this._proxy.$ensureProvider(A);const E=m.displayName||m.name;return this._proxy.$getSession(A,k,D,E,w)})}async getSessions(m,A,k){const w=L.ExtensionIdentifier.toKey(m.identifier),D=[...k].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${w} ${D}`,async()=>{await this._proxy.$ensureProvider(A);const I=m.displayName||m.name;return this._proxy.$getSessions(A,k,w,I)})}async removeSession(m,A){const k=this._authenticationProviders.get(m);return k?k.provider.removeSession(A):this._proxy.$removeSession(m,A)}registerAuthenticationProvider(m,A,k,w){if(this._authenticationProviders.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this._authenticationProviders.set(m,{label:A,provider:k,options:w??{supportsMultipleAccounts:!1}}),this._providers.find(I=>I.id===m)||this._providers.push({id:m,label:A});const D=k.onDidChangeSessions(I=>{this._proxy.$sendDidChangeSessions(m,{added:I.added??[],changed:I.changed??[],removed:I.removed??[]})});return this._proxy.$registerAuthenticationProvider(m,A,w?.supportsMultipleAccounts??!1),new d.Disposable(()=>{D.dispose(),this._authenticationProviders.delete(m);const I=this._providers.findIndex(E=>E.id===m);I>-1&&this._providers.splice(I),this._proxy.$unregisterAuthenticationProvider(m)})}$createSession(m,A,k){const w=this._authenticationProviders.get(m);if(w)return Promise.resolve(w.provider.createSession(A,k));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,A){const k=this._authenticationProviders.get(m);if(k)return Promise.resolve(k.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,A){const k=this._authenticationProviders.get(m);if(k)return Promise.resolve(k.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,A){return this._onDidChangeSessions.fire({provider:{id:m,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=R;class g{constructor(){this._inFlightPromises=new Map}getOrCreate(m,A){const k=this._inFlightPromises.get(m);if(k)return k;const w=A().finally(()=>this._inFlightPromises.delete(m));return this._inFlightPromises.set(m,w),w}}}),define(De[275],Ie([1,0,6,20,15]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=e.ExtHostBulkEdits=class{constructor(g,y){this._proxy=g.getProxy(v.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:m=>y.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,y,m){const A=d.WorkspaceEdit.from(g,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(A,void 0,m?.isRefactoring??!1)}};e.ExtHostBulkEdits=L=Ve([ze(0,T.IExtHostRpcService)],L)}),define(De[276],Ie([1,0,3,48,4,39,12,188,6,15]),function(re,e,v,T,d,L,R,g,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class A{constructor(D,I){this.extension=D,this.provider=I,this.handle=A._pool++}}A._pool=0;class k{constructor(D,I){this.logService=I,this._chatProvider=new Map,this._slashCommandProvider=new Map,this._chatSessions=new Map,this._onDidPerformUserAction=new v.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=D.getProxy(y.MainContext.MainThreadChat)}registerChatProvider(D,I,E){const i=new A(D,E);return this._chatProvider.set(i.handle,i),this._proxy.$registerChatProvider(i.handle,I),(0,d.toDisposable)(()=>{this._proxy.$unregisterChatProvider(i.handle),this._chatProvider.delete(i.handle)})}transferChatSession(D,I){const E=T.Iterable.find(this._chatSessions.keys(),i=>this._chatSessions.get(i)===D)??0;typeof E=="number"&&this._proxy.$transferChatSession(E,I)}addChatRequest(D){this._proxy.$addRequest(D)}sendInteractiveRequestToProvider(D,I){this._proxy.$sendRequestToProvider(D,I)}async $prepareChat(D,I,E){const i=this._chatProvider.get(D);if(!i)return;const l=await i.provider.prepareSession(I,E);if(!l)return;const a=k._nextId++;return this._chatSessions.set(a,l),{id:a,requesterUsername:l.requester?.name,requesterAvatarIconUri:l.requester?.icon,responderUsername:l.responder?.name,responderAvatarIconUri:l.responder?.icon,inputPlaceholder:l.inputPlaceholder}}async $resolveRequest(D,I,E,i){const l=this._chatProvider.get(D);if(!l)return;const a=this._chatSessions.get(I);if(!a||!l.provider.resolveRequest)return;const b=await l.provider.resolveRequest(a,E,i);if(b)return{message:typeof b.message=="string"?b.message:m.ChatReplyFollowup.from(b.message)}}async $provideWelcomeMessage(D,I){const E=this._chatProvider.get(D);if(!E||!E.provider.provideWelcomeMessage)return;const i=await E.provider.provideWelcomeMessage(I);if(i)return i.map(l=>typeof l=="string"?l:l.map(a=>m.ChatReplyFollowup.from(a)))}async $provideFollowups(D,I,E){const i=this._chatProvider.get(D);if(!i)return;const l=this._chatSessions.get(I);return!l||!i.provider.provideFollowups?void 0:(await i.provider.provideFollowups(l,E))?.map(b=>m.ChatFollowup.from(b))}$removeRequest(D,I,E){const i=this._chatProvider.get(D);if(!i)return;const l=this._chatSessions.get(I);l&&i.provider.removeRequest&&i.provider.removeRequest(l,E)}async $provideReply(D,I,E,i){const l=this._chatProvider.get(D);if(!l)return;const a=this._chatSessions.get(I);if(!a)return;const b={session:a,message:typeof E.message=="string"?E.message:m.ChatReplyFollowup.to(E.message)},f=L.StopWatch.create(!1);let _;const n={report:t=>{if(i.isCancellationRequested)return;typeof _>"u"&&(_=f.elapsed());const u="responseId"in t?{requestId:t.responseId}:t;this._proxy.$acceptResponseProgress(D,I,u)}};let o;try{o=await l.provider.provideResponseWithProgress(b,n,i),o||(o={errorDetails:{message:(0,g.localize)(0,null)}})}catch(t){o={errorDetails:{message:(0,g.localize)(1,null,t.message),responseIsIncomplete:!0}},this.logService.error(t)}try{if(a.saveState&&this._chatSessions.has(I)){const t=a.saveState();this._proxy.$acceptChatState(I,t)}}catch(t){this.logService.warn(t)}const s={firstProgress:_??0,totalElapsed:f.elapsed()};return{errorDetails:o.errorDetails,timings:s}}async $provideSlashCommands(D,I,E){const i=this._chatProvider.get(D);if(!i)return;const l=this._chatSessions.get(I);return!l||!i.provider.provideSlashCommands?void 0:(await i.provider.provideSlashCommands(l,E))?.map(b=>({...b,kind:m.CompletionItemKind.from(b.kind)}))}$releaseSession(D){this._chatSessions.delete(D)}async $onDidPerformUserAction(D){this._onDidPerformUserAction.fire(D)}registerSlashCommandProvider(D,I,E){const i=new A(D,E);return this._slashCommandProvider.set(i.handle,i),this._proxy.$registerSlashCommandProvider(i.handle,I),(0,d.toDisposable)(()=>{this._proxy.$unregisterSlashCommandProvider(i.handle),this._slashCommandProvider.delete(i.handle)})}async $provideProviderSlashCommands(D,I){const E=this._slashCommandProvider.get(D);return E?(await E.provider.provideSlashCommands(I))?.map(l=>({...l,kind:m.CompletionItemKind.from(l.kind)})):void 0}async $resolveSlashCommand(D,I,E){const i=this._slashCommandProvider.get(D);if(!i)return;const l=await i.provider.resolveSlashCommand(I,E);return(0,R.withNullAsUndefined)(l)}}e.ExtHostChat=k,k._nextId=0}),define(De[277],Ie([1,0,6]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(L){const R=L.getProxy(v.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(g){return R.$writeText(g)}})}}e.ExtHostClipboard=T});var Ye=this&&this.__classPrivateFieldSet||function(re,e,v,T,d){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!d)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!d:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?d.call(re,v):d?d.value=v:e.set(re,v),v},Fe=this&&this.__classPrivateFieldGet||function(re,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!T:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(re):T?T.value:e.get(re)};define(De[36],Ie([1,0,12,7,15,24,6,19,18,73,35,56,2,4,5,20,139,22,61,45,39,79,82]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l,a,b,f,_,n){"use strict";var o,s,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let u=e.ExtHostCommands=class{constructor(r,P,M){o.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,s.set(this,void 0),t.set(this,void 0),Ye(this,o,r.getProxy(R.MainContext.MainThreadCommands),"f"),this._logService=P,Ye(this,t,M,"f"),Ye(this,s,r.getProxy(R.MainContext.MainThreadTelemetry),"f"),this.converter=new p(this,W=>{const $=this._apiCommands.get(W);return $?.result===C.Void?$:void 0},P),this._argumentProcessors=[{processArgument(W){return(0,m.revive)(W)}},{processArgument(W){return(0,L.cloneAndChange)(W,function($){if(A.Range.isIRange($))return d.Range.to($);if(k.Position.isIPosition($))return d.Position.to($);if(A.Range.isIRange($.range)&&w.URI.isUri($.uri))return d.location.to($);if($ instanceof l.VSBuffer)return $.buffer.buffer;if(!Array.isArray($))return $})}}]}registerArgumentProcessor(r){this._argumentProcessors.push(r)}registerApiCommand(r){const P=this.registerCommand(!1,r.id,async(...M)=>{const W=r.args.map((z,N)=>{if(!z.validate(M[N]))throw new Error(`Invalid argument '${z.name}' when running '${r.id}', received: ${M[N]}`);return z.convert(M[N])}),$=await this.executeCommand(r.internalId,...W);return r.result.convert($,M,this.converter)},void 0,{description:r.description,args:r.args,returns:r.result.description});return this._apiCommands.set(r.id,r),new T.Disposable(()=>{P.dispose(),this._apiCommands.delete(r.id)})}registerCommand(r,P,M,W,$,z){if(this._logService.trace("ExtHostCommands#registerCommand",P),!P.trim().length)throw new Error("invalid id");if(this._commands.has(P))throw new Error(`command '${P}' already exists`);return this._commands.set(P,{callback:M,thisArg:W,description:$,extension:z}),r&&Fe(this,o,"f").$registerCommand(P),new T.Disposable(()=>{this._commands.delete(P)&&r&&Fe(this,o,"f").$unregisterCommand(P)})}executeCommand(r,...P){return this._logService.trace("ExtHostCommands#executeCommand",r),this._doExecuteCommand(r,P,!0)}async _doExecuteCommand(r,P,M){if(this._commands.has(r))return Fe(this,o,"f").$fireCommandActivationEvent(r),this._executeContributedCommand(r,P,!1);{let W=!1;const $=(0,L.cloneAndChange)(P,function(z){if(z instanceof T.Position)return d.Position.from(z);if(z instanceof T.Range)return d.Range.from(z);if(z instanceof T.Location)return d.location.from(z);if(T.NotebookRange.isNotebookRange(z))return d.NotebookRange.from(z);if(z instanceof ArrayBuffer)return W=!0,l.VSBuffer.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return W=!0,l.VSBuffer.wrap(z);if(z instanceof l.VSBuffer)return W=!0,z;if(!Array.isArray(z))return z});try{const z=await Fe(this,o,"f").$executeCommand(r,W?new a.SerializableObjectWithBuffers($):$,M);return(0,m.revive)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this._doExecuteCommand(r,P,!1);throw z}}}async _executeContributedCommand(r,P,M){const W=this._commands.get(r);if(!W)throw new Error("Unknown command");const{callback:$,thisArg:z,description:N}=W;if(N)for(let x=0;x<N.args.length;x++)try{(0,v.validateConstraint)(P[x],N.args[x].constraint)}catch{throw new Error(`Running the contributed command: '${r}' failed. Illegal argument '${N.args[x].name}' - ${N.args[x].description}`)}const q=f.StopWatch.create();try{return await $.apply(z,P)}catch(x){if(r===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...P);U&&(r=U.command)}if(this._logService.error(x,r,W.extension?.identifier),!M)throw x;if(W.extension?.identifier){const U=Fe(this,t,"f").onExtensionError(W.extension.identifier,x);this._logService.trace("forwarded error to extension?",U,W.extension?.identifier)}throw new class extends Error{constructor(){super((0,b.toErrorMessage)(x)),this.id=r,this.source=W.extension?.displayName??W.extension?.name}}}finally{this._reportTelemetry(W,r,q.elapsed())}}_reportTelemetry(r,P,M){r.extension&&Fe(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:r.extension.identifier.value,id:new _.TelemetryTrustedValue(P),duration:M})}$executeContributedCommand(r,...P){this._logService.trace("ExtHostCommands#$executeContributedCommand",r);const M=this._commands.get(r);return M?(P=P.map(W=>this._argumentProcessors.reduce(($,z)=>z.processArgument($,M.extension?.identifier),W)),this._executeContributedCommand(r,P,!0)):Promise.reject(new Error(`Contributed command '${r}' does not exist.`))}getCommands(r=!1){return this._logService.trace("ExtHostCommands#getCommands",r),Fe(this,o,"f").$getCommands().then(P=>(r&&(P=P.filter(M=>M[0]!=="_")),P))}$getContributedCommandHandlerDescriptions(){const r=Object.create(null);for(const[P,M]of this._commands){const{description:W}=M;W&&(r[P]=W)}return Promise.resolve(r)}};o=new WeakMap,s=new WeakMap,t=new WeakMap,e.ExtHostCommands=u=Ve([ze(0,E.IExtHostRpcService),ze(1,y.ILogService),ze(2,n.IExtHostTelemetry)],u),e.IExtHostCommands=(0,I.createDecorator)("IExtHostCommands");class p{constructor(r,P,M){this._commands=r,this._lookupApiCommand=P,this._logService=M,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(r,P){if(!r)return;const M={$ident:void 0,id:r.command,title:r.title,tooltip:r.tooltip};if(!r.command)return M;const W=this._lookupApiCommand(r.command);if(W)M.id=W.internalId,M.arguments=W.args.map(($,z)=>$.convert(r.arguments&&r.arguments[z]));else if((0,g.isNonEmptyArray)(r.arguments)){const $=`${r.command}/${++this._cachIdPool}`;this._cache.set($,r),P.add((0,D.toDisposable)(()=>{this._cache.delete($),this._logService.trace("CommandsConverter#DISPOSE",$)})),M.$ident=$,M.id=this.delegatingCommandId,M.arguments=[$],this._logService.trace("CommandsConverter#CREATE",r.command,$)}return M}fromInternal(r){return typeof r.$ident=="string"?this._cache.get(r.$ident):{command:r.id,title:r.title,arguments:r.arguments}}getActualCommand(...r){return this._cache.get(r[0])}_executeConvertedCommand(...r){const P=this.getActualCommand(...r);return this._logService.trace("CommandsConverter#EXECUTE",r[0],P?P.command:"MISSING"),P?this._commands.executeCommand(P.command,...P.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${r[0]}`)}}e.CommandsConverter=p;class h{constructor(r,P,M,W){this.name=r,this.description=P,this.validate=M,this.convert=W}optional(){return new h(this.name,`(optional) ${this.description}`,r=>r==null||this.validate(r),r=>r===void 0?void 0:r===null?null:this.convert(r))}with(r,P){return new h(r??this.name,P??this.description,this.validate,this.convert)}}e.ApiCommandArgument=h,h.Uri=new h("uri","Uri of a text document",c=>w.URI.isUri(c),c=>c),h.Position=new h("position","A position in a text document",c=>T.Position.isPosition(c),d.Position.from),h.Range=new h("range","A range in a text document",c=>T.Range.isRange(c),d.Range.from),h.Selection=new h("selection","A selection in a text document",c=>T.Selection.isSelection(c),d.Selection.from),h.Number=new h("number","",c=>typeof c=="number",c=>c),h.String=new h("string","",c=>typeof c=="string",c=>c),h.CallHierarchyItem=new h("item","A call hierarchy item",c=>c instanceof T.CallHierarchyItem,d.CallHierarchyItem.from),h.TypeHierarchyItem=new h("item","A type hierarchy item",c=>c instanceof T.TypeHierarchyItem,d.TypeHierarchyItem.from),h.TestItem=new h("testItem","A VSCodium TestItem",c=>c instanceof i.TestItemImpl,d.TestItem.from);class C{constructor(r,P){this.description=r,this.convert=P}}e.ApiCommandResult=C,C.Void=new C("no result",c=>c);class S{constructor(r,P,M,W,$){this.id=r,this.internalId=P,this.description=M,this.args=W,this.result=$}}e.ApiCommand=S}),define(De[278],Ie([1,0,19,16,2,76,123,47,127,36,15,7]),function(re,e,v,T,d,L,R,g,y,m,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const w=[new m.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",I(A.DocumentHighlight.to))),new m.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,l)=>{if((0,v.isFalsyOrEmpty)(i))return;class a extends k.SymbolInformation{static to(f){const _=new a(f.name,A.SymbolKind.to(f.kind),f.containerName||"",new k.Location(l[0],A.Range.to(f.range)));return _.detail=f.detail,_.range=_.location.range,_.selectionRange=A.Range.to(f.selectionRange),_.children=f.children?f.children.map(a.to):[],_}}return i.map(a.to)})),new m.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(A.TextEdit.to))),new m.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range,new m.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(A.TextEdit.to))),new m.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,new m.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new m.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(A.TextEdit.to))),new m.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new m.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new m.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new m.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new m.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location-instances.",I(A.location.to))),new m.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Hover-instances.",I(A.Hover.to))),new m.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(l=>k.Position.isPosition(l)),i=>i.map(A.Position.from))],new m.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(l=>{let a;for(const b of l.reverse())a=new k.SelectionRange(A.Range.to(b),a);return a}))),new m.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.ApiCommandArgument.String.with("query","Search string")],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(A.WorkspaceSymbol.to))),new m.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",i=>i.map(A.CallHierarchyItem.to))),new m.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",i=>i.map(A.CallHierarchyIncomingCall.to))),new m.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",i=>i.map(A.CallHierarchyOutgoingCall.to))),new m.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to a range and placeholder text.",i=>{if(i)return{range:A.Range.to(i.range),placeholder:i.text}})),new m.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("newName","The new symbol name")],new m.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(i){if(i.rejectReason)throw new Error(i.rejectReason);return A.WorkspaceEdit.to(i)}})),new m.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(A.DocumentLink.to))),new m.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(i)return new k.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const l=(0,R.decodeSemanticTokensDto)(i);if(l.type==="full")return new k.SemanticTokens(l.data,void 0)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range.optional()],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(i)return new k.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const l=(0,R.decodeSemanticTokensDto)(i);if(l.type==="full")return new k.SemanticTokens(l.data,void 0)})),new m.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,l,a)=>{if(!i)return new k.CompletionList([]);const b=i.suggestions.map(f=>A.CompletionItem.to(f,a));return new k.CompletionList(b,i.incomplete)})),new m.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return A.SignatureHelp.to(i)})),new m.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,l,a)=>I(b=>new k.CodeLens(A.Range.to(b.range),b.command&&a.fromInternal(b.command)))(i))),new m.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>k.Range.isRange(i),i=>k.Selection.isSelection(i)?A.Selection.from(i):A.Range.from(i)),m.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,l,a)=>I(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(b.command)}else{const f=new k.CodeAction(b.title,b.kind?new k.CodeActionKind(b.kind):void 0);return b.edit&&(f.edit=A.WorkspaceEdit.to(b.edit)),b.command&&(f.command=a.fromInternal(b.command)),f.isPreferred=b.isPreferred,f}})(i))),new m.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(l=>new k.ColorInformation(A.Range.to(l.range),A.Color.to(l.color))):[])),new m.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.ApiCommandArgument("color","The color to show and insert",i=>i instanceof k.Color,A.Color.from),new m.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:A.Range.from(i.range)}))],new m.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(A.ColorPresentation.to):[])),new m.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of Inlay objects",(i,l,a)=>i.map(A.InlayHint.to.bind(void 0,a)))),new m.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(i,l)=>{if(i)return i.map(A.FoldingRange.to)})),new m.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",I(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(l=>A.NotebookExclusiveDocumentPattern.to(l))})))),new m.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(A.InlineValue.to))),new m.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",i=>d.URI.isUri(i)||typeof i=="string"&&(0,y.matchesSomeScheme)(i,T.Schemas.http,T.Schemas.https),i=>i),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[A.ViewColumn.from(i),void 0]:[A.ViewColumn.from(i.viewColumn),A.TextEditorOpenOptions.from(i)])).optional(),m.ApiCommandArgument.String.with("label","").optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.ApiCommandArgument.Uri.with("resource","Resource to open"),m.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VSCodium's default editor"),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[A.ViewColumn.from(i),void 0]:[A.ViewColumn.from(i.viewColumn),A.TextEditorOpenOptions.from(i)])).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),m.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),m.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[A.ViewColumn.from(i.viewColumn),A.TextEditorOpenOptions.from(i)]).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(A.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(A.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(A.TypeHierarchyItem.to))),new m.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.ApiCommandArgument.TestItem],m.ApiCommandResult.Void),new m.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.ApiCommandResult.Void),new m.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.ApiCommandArgument.String.with("name","The context key name"),new m.ApiCommandArgument("value","The context key value",()=>!0,i=>i)],m.ApiCommandResult.Void)];class D{static register(l){w.forEach(l.registerApiCommand,l),this._registerValidateWhenClausesCommand(l)}static _registerValidateWhenClausesCommand(l){l.registerCommand(!1,"_validateWhenClauses",g.validateWhenClauses)}}e.ExtHostApiCommands=D;function I(i){return l=>{if(Array.isArray(l))return l.map(i)}}function E(i){if(!Array.isArray(i))return;const l=[];for(const a of i)L.isLocationLink(a)?l.push(A.DefinitionLink.to(a)):l.push(A.location.to(a));return l}}),define(De[279],Ie([1,0,17,66,3,4,2,76,25,15,7,6,27,12]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function I(E,i,l){const a=E.getProxy(k.MainContext.MainThreadComments);class b{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new y.ExtensionIdentifierMap,i.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const C=this._commentControllers.get(h.handle);return C?C.value:h}else if(h&&h.$mid===7){const C=this._commentControllers.get(h.commentControlHandle);if(!C)return h;const S=C.getCommentThread(h.commentThreadHandle);return S?S.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const C=this._commentControllers.get(h.thread.commentControlHandle);if(!C)return h;const S=C.getCommentThread(h.thread.commentThreadHandle);return S?h.$mid===8?S.value:{thread:S.value,text:h.text}:h}else if(h&&h.$mid===10){const C=this._commentControllers.get(h.thread.commentControlHandle);if(!C)return h;const S=C.getCommentThread(h.thread.commentThreadHandle);if(!S)return h;const c=h.commentUniqueId,r=S.getCommentByUniqueId(c);return r||h}else if(h&&h.$mid===11){const C=this._commentControllers.get(h.thread.commentControlHandle);if(!C)return h;const S=C.getCommentThread(h.thread.commentThreadHandle);if(!S)return h;const c=h.text,r=h.commentUniqueId,P=S.getCommentByUniqueId(r);return P?(typeof P.body=="string"?P.body=c:P.body=new A.MarkdownString(c),P):h}return h}})}createCommentController(h,C,S){const c=b.handlePool++,r=new _(h,c,C,S);this._commentControllers.set(r.handle,r);const P=this._commentControllersByExtension.get(h.identifier)||[];return P.push(r),this._commentControllersByExtension.set(h.identifier,P),r.value}$createCommentThreadTemplate(h,C,S){const c=this._commentControllers.get(h);c&&c.$createCommentThreadTemplate(C,S)}async $updateCommentThreadTemplate(h,C,S){const c=this._commentControllers.get(h);c&&c.$updateCommentThreadTemplate(C,S)}$deleteCommentThread(h,C){this._commentControllers.get(h)?.$deleteCommentThread(C)}$provideCommentingRanges(h,C,S){const c=this._commentControllers.get(h);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const r=l.getDocument(R.URI.revive(C));return(0,v.asPromise)(async()=>{const P=await c.commentingRangeProvider.provideCommentingRanges(r,S);let M;return Array.isArray(P)?M={ranges:P,fileComments:!1}:P?M={ranges:P.ranges||[],fileComments:P.fileComments||!1}:M=(0,D.withNullAsUndefined)(P),M}).then(P=>{let M;return P&&(M={ranges:P.ranges.map(W=>m.Range.from(W)),fileComments:P.fileComments}),M})}$toggleReaction(h,C,S,c,r){const P=this._commentControllers.get(h);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,v.asPromise)(()=>{const M=P.getCommentThread(C);if(M){const W=M.getCommentByUniqueId(c.uniqueIdInThread);if(P!==void 0&&W&&P.reactionHandler)return P.reactionHandler(W,s(r))}return Promise.resolve(void 0)})}}b.handlePool=0;class f{set threadId(h){this._id=h}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(h){(h===void 0!=(this._range===void 0)||!h||!this._range||!h.isEqual(this._range))&&(this._range=h,this.modifications.range=h,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(h){this._canReply!==h&&(this._canReply=h,this.modifications.canReply=h,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(h){this._label=h,this.modifications.label=h,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(h){this._contextValue=h,this.modifications.contextValue=h,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(h){this._comments=h,this.modifications.comments=h,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(h){this._collapseState=h,this.modifications.collapsibleState=h,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(h){this._state=h,this.modifications.state=h,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(h,C,S,c,r,P,M,W){this._commentControllerHandle=C,this._id=S,this._uri=c,this._range=r,this._comments=P,this.extensionDescription=M,this._isTemplate=W,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new d.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new L.MutableDisposable,this._acceptInputDisposables.value=new L.DisposableStore,this._id===void 0&&(this._id=`${h}.${this.handle}`),a.$createCommentThread(C,this.handle,this._id,this._uri,m.Range.from(this._range),M.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this._localDisposables.push({dispose:()=>{a.$deleteCommentThread(C,this.handle)}});const $=this;this.value={get uri(){return $.uri},get range(){return $.range},set range(z){$.range=z},get comments(){return $.comments},set comments(z){$.comments=z},get collapsibleState(){return $.collapsibleState},set collapsibleState(z){$.collapsibleState=z},get canReply(){return $.canReply},set canReply(z){$.canReply=z},get contextValue(){return $.contextValue},set contextValue(z){$.contextValue=z},get label(){return $.label},set label(z){$.label=z},get state(){return $.state},set state(z){$.state=z},dispose:()=>{$.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new L.DisposableStore);const h=S=>Object.prototype.hasOwnProperty.call(this.modifications,S),C={};h("range")&&(C.range=m.Range.from(this._range)),h("label")&&(C.label=this.label),h("contextValue")&&(C.contextValue=this.contextValue??null),h("comments")&&(C.comments=this._comments.map(S=>n(this,S,this._commentsMap,this.extensionDescription))),h("collapsibleState")&&(C.collapseState=t(this._collapseState)),h("canReply")&&(C.canReply=this.canReply),h("state")&&(C.state=u(this._state)),h("isTemplate")&&(C.isTemplate=this._isTemplate),this.modifications={},a.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,C)}getCommentByUniqueId(h){for(const C of this._commentsMap){const S=C[0],c=C[1];if(h===c)return S}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(h=>h.dispose())}}f._handlePool=0,Ve([(0,T.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class _{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(h){this._commentingRangeProvider=h,a.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(h){this._reactionHandler=h,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this._options}set options(h){this._options=h,a.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(h,C,S,c){this._extension=h,this._handle=C,this._id=S,this._label=c,this._threads=new Map,a.$registerCommentController(this.handle,S,c);const r=this;this.value=Object.freeze({id:r.id,label:r.label,get options(){return r.options},set options(P){r.options=P},get commentingRangeProvider(){return r.commentingRangeProvider},set commentingRangeProvider(P){r.commentingRangeProvider=P},get reactionHandler(){return r.reactionHandler},set reactionHandler(P){r.reactionHandler=P},createCommentThread(P,M,W){return r.createCommentThread(P,M,W).value},dispose:()=>{r.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(h,C,S){C===void 0&&(0,w.checkProposedApiEnabled)(this._extension,"fileComments");const c=new f(this.id,this.handle,void 0,h,C,S,this._extension,!1);return this._threads.set(c.handle,c),c}$createCommentThreadTemplate(h,C){const S=new f(this.id,this.handle,void 0,R.URI.revive(h),m.Range.to(C),[],this._extension,!0);return S.collapsibleState=g.CommentThreadCollapsibleState.Expanded,this._threads.set(S.handle,S),S}$updateCommentThreadTemplate(h,C){const S=this._threads.get(h);S&&(S.range=m.Range.to(C))}$deleteCommentThread(h){this._threads.get(h)?.dispose(),this._threads.delete(h)}getCommentThread(h){return this._threads.get(h)}dispose(){this._threads.forEach(h=>{h.dispose()}),this._localDisposables.forEach(h=>h.dispose())}}function n(p,h,C,S){let c=C.get(h);return c||(c=++p.commentHandle,C.set(h,c)),h.state!==void 0&&(0,w.checkProposedApiEnabled)(S,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:c,body:typeof h.body=="string"?h.body:m.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(r=>o(r)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function o(p){return{label:p.label,iconPath:p.iconPath?m.pathOrURIToURI(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted}}function s(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?R.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1}}function t(p){if(p!==void 0)switch(p){case A.CommentThreadCollapsibleState.Expanded:return g.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return g.CommentThreadCollapsibleState.Collapsed}return g.CommentThreadCollapsibleState.Collapsed}function u(p){if(p!==void 0)switch(p){case A.CommentThreadState.Unresolved:return g.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return g.CommentThreadState.Resolved}return g.CommentThreadState.Unresolved}return new b}e.createExtHostComments=I}),define(De[280],Ie([1,0,24,6,26,20]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let R=e.AbstractExtHostConsoleForwarder=class{constructor(A,k){this._mainThreadConsole=A.getProxy(T.MainContext.MainThreadConsole),this._includeStack=k.consoleForward.includeStack,this._logNative=k.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(A,k){const w=this,D=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){w._handleConsoleCall(A,k,D,arguments)}})}_handleConsoleCall(A,k,w,D){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:k,arguments:y(D,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(A,w,D)}};e.AbstractExtHostConsoleForwarder=R=Ve([ze(0,L.IExtHostRpcService),ze(1,d.IExtHostInitDataService)],R);const g=1e5;function y(m,A){const k=[];if(m.length)for(let w=0;w<m.length;w++){let D=m[w];if(typeof D>"u")D="undefined";else if(D instanceof Error){const I=D;I.stack?D=I.stack:D=I.toString()}k.push(D)}if(A){const w=new Error().stack;w&&k.push({__$stack:w.split(`
`).slice(3).join(`
`)})}try{const w=(0,v.safeStringify)(k);return w.length>g?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}),define(De[142],Ie([1,0,2,6,7,5,20,18,19,9,11,27]),function(re,e,v,T,d,L,R,g,y,m,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let w=e.ExtHostDecorations=class on{constructor(I,E){this._logService=E,this._provider=new Map,this._proxy=I.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(I,E){const i=on._handlePool++;this._provider.set(i,{provider:I,extensionDescription:E}),this._proxy.$registerDecorationProvider(i,E.identifier.value);const l=I.onDidChangeFileDecorations&&I.onDidChangeFileDecorations(a=>{if(!a){this._proxy.$onDidChange(i,null);return}const b=(0,y.asArray)(a);if(b.length<=on._maxEventSize){this._proxy.$onDidChange(i,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",E.identifier.value,b.length);const f=b.map(o=>({uri:o,rank:(0,m.count)(o.path,"/")})),_=(0,y.groupBy)(f,(o,s)=>o.rank-s.rank||(0,m.compare)(o.uri.path,s.uri.path)),n=[];e:for(const o of _){let s;for(const t of o){const u=(0,A.dirname)(t.uri.path);if(s!==u&&(s=u,n.push(t.uri)>=on._maxEventSize))break e}}this._proxy.$onDidChange(i,n)});return new d.Disposable(()=>{l?.dispose(),this._proxy.$unregisterDecorationProvider(i),this._provider.delete(i)})}async $provideDecorations(I,E,i){if(!this._provider.has(I))return Object.create(null);const l=Object.create(null),{provider:a,extensionDescription:b}=this._provider.get(I);return await Promise.all(E.map(async f=>{try{const{uri:_,id:n}=f,o=await Promise.resolve(a.provideFileDecoration(v.URI.revive(_),i));if(!o)return;try{d.FileDecoration.validate(o),o.badge&&typeof o.badge!="string"&&(0,k.checkProposedApiEnabled)(b,"codiconDecoration"),l[n]=[o.propagate,o.tooltip,o.badge,o.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${b}': ${s}`)}}catch(_){this._logService.error(_)}})),l}};w._handlePool=0,w._maxEventSize=250,e.ExtHostDecorations=w=Ve([ze(0,R.IExtHostRpcService),ze(1,g.ILogService)],w),e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(re,e,v,T,d){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!d)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!d:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?d.call(re,v):d?d.value=v:e.set(re,v),v},Fe=this&&this.__classPrivateFieldGet||function(re,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!T:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(re):T?T.value:e.get(re)};define(De[281],Ie([1,0,189,126,2,6,7,15,3,18,28,51]),function(re,e,v,T,d,L,R,g,y,m,A,k){"use strict";var w,D,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class E{constructor(a,b,f,_,n,o,s){this._name=a,this._owner=b,this._maxDiagnosticsPerFile=f,this._modelVersionIdProvider=_,w.set(this,void 0),D.set(this,void 0),I.set(this,void 0),this._isDisposed=!1,Ye(this,I,new A.ResourceMap(t=>n.getComparisonKey(t)),"f"),Ye(this,w,o,"f"),Ye(this,D,s,"f")}dispose(){this._isDisposed||(Fe(this,D,"f").fire([...Fe(this,I,"f").keys()]),Fe(this,w,"f")?.$clear(this._owner),Fe(this,I,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,b){if(!a){this.clear();return}this._checkDisposed();let f=[];if(d.URI.isUri(a)){if(!b){this.delete(a);return}Fe(this,I,"f").set(a,b.slice()),f=[a]}else if(Array.isArray(a)){f=[];let n;a=[...a].sort(E._compareIndexedTuplesByUri);for(const o of a){const[s,t]=o;if((!n||s.toString()!==n.toString())&&(n&&Fe(this,I,"f").get(n).length===0&&Fe(this,I,"f").delete(n),n=s,f.push(s),Fe(this,I,"f").set(s,[])),t)Fe(this,I,"f").get(s)?.push(...t);else{const u=Fe(this,I,"f").get(s);u&&(u.length=0)}}}if(Fe(this,D,"f").fire(f),!Fe(this,w,"f"))return;const _=[];for(const n of f){let o=[];const s=Fe(this,I,"f").get(n);if(s)if(s.length>this._maxDiagnosticsPerFile){o=[];const t=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const p of s)if(p.severity===t[u]&&o.push({...g.Diagnostic.from(p),modelVersionId:this._modelVersionIdProvider(n)})===this._maxDiagnosticsPerFile)break e;o.push({severity:T.MarkerSeverity.Info,message:(0,v.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=s.map(t=>({...g.Diagnostic.from(t),modelVersionId:this._modelVersionIdProvider(n)}));_.push([n,o])}Fe(this,w,"f").$changeMany(this._owner,_)}delete(a){this._checkDisposed(),Fe(this,D,"f").fire([a]),Fe(this,I,"f").delete(a),Fe(this,w,"f")?.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),Fe(this,D,"f").fire([...Fe(this,I,"f").keys()]),Fe(this,I,"f").clear(),Fe(this,w,"f")?.$clear(this._owner)}forEach(a,b){this._checkDisposed();for(const[f,_]of this)a.call(b,f,_,this)}*[(w=new WeakMap,D=new WeakMap,I=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const a of Fe(this,I,"f").keys())yield[a,this.get(a)]}get(a){this._checkDisposed();const b=Fe(this,I,"f").get(a);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(Fe(this,I,"f").get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,b){return a[0].toString()<b[0].toString()?-1:a[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=E;let i=e.ExtHostDiagnostics=class wi{static _mapper(a){const b=new A.ResourceMap;for(const f of a)b.set(f,f);return{uris:Object.freeze(Array.from(b.values()))}}constructor(a,b,f,_){this._logService=b,this._fileSystemInfoService=f,this._extHostDocumentsAndEditors=_,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,wi._mapper),this._proxy=a.getProxy(L.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(a,b){const{_collections:f,_proxy:_,_onDidChangeDiagnostics:n,_logService:o,_fileSystemInfoService:s,_extHostDocumentsAndEditors:t}=this,u=new class{$changeMany(C,S){_.$changeMany(C,S),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,C,S.length===0?"CLEARING":S)}$clear(C){_.$clear(C),o.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,C)}dispose(){_.dispose()}};let p;if(!b)b="_generated_diagnostic_collection_name_#"+wi._idPool++,p=b;else if(!f.has(b))p=b;else{this._logService.warn(`DiagnosticCollection with name '${b}' does already exist.`);do p=b+wi._idPool++;while(f.has(p))}return new class extends E{constructor(){super(b,p,wi._maxDiagnosticsPerFile,C=>t.getDocument(C)?.version,s.extUri,u,n),f.set(p,this)}dispose(){super.dispose(),f.delete(p)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const b=new Map,f=[];for(const _ of this._collections.values())_.forEach((n,o)=>{let s=b.get(n.toString());typeof s>"u"&&(s=f.length,b.set(n.toString(),s),f.push([n,[]])),f[s][1]=f[s][1].concat(...o)});return f}}_getDiagnostics(a){let b=[];for(const f of this._collections.values())f.has(a)&&(b=b.concat(f.get(a)));return b}$acceptMarkersChange(a){if(!this._mirrorCollection){const b="_generated_mirror",f=new E(b,b,wi._maxDiagnosticsPerFile,_=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(b,f),this._mirrorCollection=f}for(const[b,f]of a)this._mirrorCollection.set(d.URI.revive(b),f.map(g.Diagnostic.to))}};i._idPool=0,i._maxDiagnosticsPerFile=1e3,e.ExtHostDiagnostics=i=Ve([ze(1,m.ILogService),ze(2,k.IExtHostFileSystemInfo)],i)}),define(De[282],Ie([1,0,2,6,27]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class L{constructor(g){this._proxy=g.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(g,y){return y?.allowUIResources&&(0,d.checkProposedApiEnabled)(g,"showLocal"),this._proxy.$showOpenDialog(y).then(m=>m?m.map(A=>v.URI.revive(A)):void 0)}showSaveDialog(g){return this._proxy.$showSaveDialog(g).then(y=>y?v.URI.revive(y):void 0)}}e.ExtHostDialogs=L}),define(De[283],Ie([1,0,8,2,7,6,16,21,9]),function(re,e,v,T,d,L,R,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class m{constructor(k,w,D){this._documentsAndEditors=w,this._logService=D,this._documentContentProviders=new Map,this._proxy=k.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,w){if(Object.keys(R.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const D=m._handlePool++;this._documentContentProviders.set(D,w),this._proxy.$registerTextContentProvider(D,k);let I;return typeof w.onDidChange=="function"&&(I=w.onDidChange(E=>{if(E.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${E.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(E)&&this.$provideTextDocumentContent(D,E).then(i=>{if(!i&&typeof i!="string")return;const l=this._documentsAndEditors.getDocument(E);if(!l)return;const a=(0,y.splitLines)(i);if(!l.equalLines(a))return this._proxy.$onVirtualDocumentChange(E,i)},v.onUnexpectedError)})),new d.Disposable(()=>{this._documentContentProviders.delete(D)&&this._proxy.$unregisterTextContentProvider(D),I&&(I.dispose(),I=void 0)})}$provideTextDocumentContent(k,w){const D=this._documentContentProviders.get(k);return D?Promise.resolve(D.provideTextDocumentContent(T.URI.revive(w),g.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.ExtHostDocumentContentProvider=m,m._handlePool=0}),define(De[284],Ie([1,0,3,4,2,6,135,15,12,24,7,8]),function(re,e,v,T,d,L,R,g,y,m,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(I,E){this._onDidAddDocument=new v.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidRemoveDocument=new v.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidChangeDocument=new v.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidSaveDocument=new v.Emitter({onListenerError:k.onUnexpectedExternalError}),this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new T.DisposableStore,this._documentLoader=new Map,this._proxy=I.getProxy(L.MainContext.MainThreadDocuments),this._documentsAndEditors=E,this._documentsAndEditors.onDidRemoveDocuments(i=>{for(const l of i)this._onDidRemoveDocument.fire(l.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(i=>{for(const l of i)this._onDidAddDocument.fire(l.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(I){if(!I)return;const E=this._documentsAndEditors.getDocument(I);if(E)return E}getDocument(I){const E=this.getDocumentData(I);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${I}'`);return E.document}ensureDocumentData(I){const E=this._documentsAndEditors.getDocument(I);if(E)return Promise.resolve(E);let i=this._documentLoader.get(I.toString());return i||(i=this._proxy.$tryOpenDocument(I).then(l=>{this._documentLoader.delete(I.toString());const a=d.URI.revive(l);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(a))},l=>(this._documentLoader.delete(I.toString()),Promise.reject(l))),this._documentLoader.set(I.toString(),i)),i}createDocumentData(I){return this._proxy.$tryCreateDocument(I).then(E=>d.URI.revive(E))}$acceptModelLanguageChanged(I,E){const i=d.URI.revive(I),l=this._documentsAndEditors.getDocument(i);if(!l)throw new Error("unknown document");this._onDidRemoveDocument.fire(l.document),l._acceptLanguageId(E),this._onDidAddDocument.fire(l.document)}$acceptModelSaved(I){const E=d.URI.revive(I),i=this._documentsAndEditors.getDocument(E);if(!i)throw new Error("unknown document");this.$acceptDirtyStateChanged(I,!1),this._onDidSaveDocument.fire(i.document)}$acceptDirtyStateChanged(I,E){const i=d.URI.revive(I),l=this._documentsAndEditors.getDocument(i);if(!l)throw new Error("unknown document");l._acceptIsDirty(E),this._onDidChangeDocument.fire({document:l.document,contentChanges:[],reason:void 0})}$acceptModelChanged(I,E,i){const l=d.URI.revive(I),a=this._documentsAndEditors.getDocument(l);if(!a)throw new Error("unknown document");a._acceptIsDirty(i),a.onEvents(E);let b;E.isUndoing?b=A.TextDocumentChangeReason.Undo:E.isRedoing&&(b=A.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,m.deepFreeze)({document:a.document,contentChanges:E.changes.map(f=>({range:g.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:b}))}setWordDefinitionFor(I,E){(0,R.setWordDefinitionFor)(I,E)}}e.ExtHostDocuments=w}),define(De[62],Ie([1,0,53,3,4,2,5,6,135,20,140,15,18,28,16,48,54]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class l{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let a=e.ExtHostDocumentsAndEditors=class{constructor(f,_){this._extHostRpc=f,this._logService=_,this._activeEditorId=null,this._editors=new Map,this._documents=new D.ResourceMap,this._onDidAddDocuments=new T.Emitter,this._onDidRemoveDocuments=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const _=[],n=[],o=[];if(f.removedDocuments)for(const s of f.removedDocuments){const t=L.URI.revive(s),u=this._documents.get(t);u?.unref()&&(this._documents.delete(t),_.push(u.value))}if(f.addedDocuments)for(const s of f.addedDocuments){const t=L.URI.revive(s.uri);let u=this._documents.get(t);if(u&&t.scheme!==I.Schemas.vscodeNotebookCell&&t.scheme!==I.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);u||(u=new l(new y.ExtHostDocumentData(this._extHostRpc.getProxy(g.MainContext.MainThreadDocuments),t,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(t,u),n.push(u.value)),u.ref()}if(f.removedEditors)for(const s of f.removedEditors){const t=this._editors.get(s);this._editors.delete(s),t&&o.push(t)}if(f.addedEditors)for(const s of f.addedEditors){const t=L.URI.revive(s.documentUri);v.ok(this._documents.has(t),`document '${t}' does not exist`),v.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const u=this._documents.get(t).value,p=new A.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(g.MainContext.MainThreadTextEditors),this._logService,new i.Lazy(()=>u.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(h=>k.Range.to(h)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,p)}f.newActiveEditor!==void 0&&(v.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),(0,d.dispose)(_),(0,d.dispose)(o),f.removedDocuments&&this._onDidRemoveDocuments.fire(_),f.addedDocuments&&this._onDidAddDocuments.fire(n),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){return this._documents.get(f)?.value}allDocuments(){return E.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const _=this._editors.get(this._activeEditorId);return f?_:_?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=a=Ve([ze(0,m.IExtHostRpcService),ze(1,w.ILogService)],a),e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[63],Ie([1,0,15,6,2,3,5,7,20,12,65]),function(re,e,v,T,d,L,R,g,y,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,R.createDecorator)("IExtHostEditorTabs");class k{constructor(i,l,a){this._activeTabIdGetter=a,this._parentGroup=l,this.acceptDtoUpdate(i)}get apiObject(){if(!this._apiObject){const i=this,l={get isActive(){return i._dto.id===i._activeTabIdGetter()},get label(){return i._dto.label},get input(){return i._input},get isDirty(){return i._dto.isDirty},get isPinned(){return i._dto.isPinned},get isPreview(){return i._dto.isPreview},get group(){return i._parentGroup.apiObject}};this._apiObject=Object.freeze(l)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(i){this._dto=i,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new g.TextTabInput(d.URI.revive(this._dto.input.uri));case 2:return new g.TextDiffTabInput(d.URI.revive(this._dto.input.original),d.URI.revive(this._dto.input.modified));case 3:return new g.TextMergeTabInput(d.URI.revive(this._dto.input.base),d.URI.revive(this._dto.input.input1),d.URI.revive(this._dto.input.input2),d.URI.revive(this._dto.input.result));case 6:return new g.CustomEditorTabInput(d.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new g.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new g.NotebookEditorTabInput(d.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new g.NotebookDiffEditorTabInput(d.URI.revive(this._dto.input.original),d.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new g.TerminalEditorTabInput;case 9:return new g.InteractiveWindowInput(d.URI.revive(this._dto.input.uri),d.URI.revive(this._dto.input.inputBoxUri));default:return}}}class w{constructor(i,l){this._tabs=[],this._activeTabId="",this._dto=i,this._activeGroupIdGetter=l;for(const a of i.tabs)a.isActive&&(this._activeTabId=a.id),this._tabs.push(new k(a,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const i=this,l={get isActive(){return i._dto.groupId===i._activeGroupIdGetter()},get viewColumn(){return v.ViewColumn.to(i._dto.viewColumn)},get activeTab(){return i._tabs.find(a=>a.tabId===i._activeTabId)?.apiObject},get tabs(){return Object.freeze(i._tabs.map(a=>a.apiObject))}};this._apiObject=Object.freeze(l)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(i){this._dto=i}acceptTabOperation(i){if(i.kind===0){const a=new k(i.tabDto,this,()=>this.activeTabId());return this._tabs.splice(i.index,0,a),i.tabDto.isActive&&(this._activeTabId=a.tabId),a}else if(i.kind===1){const a=this._tabs.splice(i.index,1)[0];if(!a)throw new Error(`Tab close updated received for index ${i.index} which does not exist`);return a.tabId===this._activeTabId&&(this._activeTabId=""),a}else if(i.kind===3){if(i.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const a=this._tabs.splice(i.oldIndex,1)[0];if(!a)throw new Error(`Tab move updated received for index ${i.oldIndex} which does not exist`);return this._tabs.splice(i.index,0,a),a}const l=this._tabs.find(a=>a.tabId===i.tabDto.id);if(!l)throw new Error("INVALID tab");return i.tabDto.isActive?this._activeTabId=i.tabDto.id:this._activeTabId===i.tabDto.id&&!i.tabDto.isActive&&(this._activeTabId=""),l.acceptDtoUpdate(i.tabDto),l}activeTabId(){return this._activeTabId}}let D=e.ExtHostEditorTabs=class{constructor(i){this._onDidChangeTabs=new L.Emitter,this._onDidChangeTabGroups=new L.Emitter,this._extHostTabGroups=[],this._proxy=i.getProxy(T.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const i=this,l={onDidChangeTabGroups:i._onDidChangeTabGroups.event,onDidChangeTabs:i._onDidChangeTabs.event,get all(){return Object.freeze(i._extHostTabGroups.map(a=>a.apiObject))},get activeTabGroup(){const a=i._activeGroupId;return(0,m.assertIsDefined)(i._extHostTabGroups.find(f=>f.groupId===a)?.apiObject)},close:async(a,b)=>{const f=Array.isArray(a)?a:[a];return f.length?I(f[0])?this._closeGroups(f,b):this._closeTabs(f,b):!0}};this._apiObject=Object.freeze(l)}return this._apiObject}$acceptEditorTabModel(i){const l=new Set(this._extHostTabGroups.map(s=>s.groupId)),a=new Set(i.map(s=>s.groupId)),b=(0,A.diffSets)(l,a),f=this._extHostTabGroups.filter(s=>b.removed.includes(s.groupId)).map(s=>s.apiObject),_=[],n=[];this._extHostTabGroups=i.map(s=>{const t=new w(s,()=>this._activeGroupId);return b.added.includes(t.groupId)?_.push(t.apiObject):n.push(t.apiObject),t});const o=(0,m.assertIsDefined)(i.find(s=>s.isActive===!0)?.groupId);o!==void 0&&this._activeGroupId!==o&&(this._activeGroupId=o),this._onDidChangeTabGroups.fire(Object.freeze({opened:_,closed:f,changed:n}))}$acceptTabGroupUpdate(i){const l=this._extHostTabGroups.find(a=>a.groupId===i.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(i),i.isActive&&(this._activeGroupId=i.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(i){const l=this._extHostTabGroups.find(b=>b.groupId===i.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const a=l.acceptTabOperation(i);switch(i.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[a.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[a.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[a.apiObject]}));return}}_findExtHostTabFromApi(i){for(const l of this._extHostTabGroups)for(const a of l.tabs)if(a.apiObject===i)return a}_findExtHostTabGroupFromApi(i){return this._extHostTabGroups.find(l=>l.apiObject===i)}async _closeTabs(i,l){const a=[];for(const b of i){const f=this._findExtHostTabFromApi(b);if(!f)throw new Error("Tab close: Invalid tab not found!");a.push(f.tabId)}return this._proxy.$closeTab(a,l)}async _closeGroups(i,l){const a=[];for(const b of i){const f=this._findExtHostTabGroupFromApi(b);if(!f)throw new Error("Group close: Invalid group not found!");a.push(f.groupId)}return this._proxy.$closeGroup(a,l)}};e.ExtHostEditorTabs=D=Ve([ze(0,y.IExtHostRpcService)],D);function I(E){return E.tabs!==void 0}}),define(De[285],Ie([1,0,2,6,4,7,15,160,9,22,27,94]),function(re,e,v,T,d,L,R,g,y,m,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this._schemes=[]}add(E){this._stateMachine=void 0,this._schemes.push(E)}delete(E){const i=this._schemes.indexOf(E);i>=0&&(this._schemes.splice(i,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const E=this._schemes.sort(),i=[];let l,a,b=14,f=14;for(const _ of E){let n=l?(0,y.commonPrefixLength)(l,_):0;for(n===0?a=1:a=f;n<_.length;n++)n+1===_.length?(b=f,f=9):f+=1,i.push([a,_.toUpperCase().charCodeAt(n),f]),i.push([a,_.toLowerCase().charCodeAt(n),f]),a=f;l=_,f=b}i.push([9,58,10]),i.push([10,47,12]),this._stateMachine=new g.StateMachine(i)}}provideDocumentLinks(E){this._initStateMachine();const i=[],l=g.LinkComputer.computeLinks({getLineContent(a){return E.lineAt(a-1).text},getLineCount(){return E.lineCount}},this._stateMachine);for(const a of l){const b=R.DocumentLink.to(a);b.target&&i.push(b)}return i}}class D{constructor(E,i){this._extHostLanguageFeatures=i,this._linkProvider=new w,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=E.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(E,i,l,a={}){if(D._validateFileSystemProvider(l),this._registeredSchemes.has(i))throw new Error(`a provider for the scheme '${i}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(E,"*",this._linkProvider));const b=this._handlePool++;this._linkProvider.add(i),this._registeredSchemes.add(i),this._fsProvider.set(b,l);let f=2;a.isCaseSensitive&&(f+=1024),a.isReadonly&&(f+=2048),typeof l.copy=="function"&&(f+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&((0,A.checkProposedApiEnabled)(E,"fsChunks"),f+=4);let _;a.isReadonly&&(0,k.isMarkdownString)(a.isReadonly)&&((0,A.checkProposedApiEnabled)(E,"readonlyMessage"),_={value:a.isReadonly.value,isTrusted:a.isReadonly.isTrusted,supportThemeIcons:a.isReadonly.supportThemeIcons,supportHtml:a.isReadonly.supportHtml,baseUri:a.isReadonly.baseUri,uris:a.isReadonly.uris}),this._proxy.$registerFileSystemProvider(b,i,f,_).catch(o=>{console.error(`FAILED to register filesystem provider of ${E.identifier.value}-extension for the scheme ${i}`),console.error(o)});const n=l.onDidChangeFile(o=>{const s=[];for(const t of o){const{uri:u,type:p}=t;if(u.scheme!==i)continue;let h;switch(p){case L.FileChangeType.Changed:h=0;break;case L.FileChangeType.Created:h=1;break;case L.FileChangeType.Deleted:h=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:u,type:h})}this._proxy.$onFileSystemChange(b,s)});return(0,d.toDisposable)(()=>{n.dispose(),this._linkProvider.delete(i),this._registeredSchemes.delete(i),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _validateFileSystemProvider(E){if(!E)throw new Error("MISSING provider");if(typeof E.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof E.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof E.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof E.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof E.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof E.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof E.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof E.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(E){const{type:i,ctime:l,mtime:a,size:b,permissions:f}=E;return{type:i,ctime:l,mtime:a,size:b,permissions:f}}$stat(E,i){return Promise.resolve(this._getFsProvider(E).stat(v.URI.revive(i))).then(l=>D._asIStat(l))}$readdir(E,i){return Promise.resolve(this._getFsProvider(E).readDirectory(v.URI.revive(i)))}$readFile(E,i){return Promise.resolve(this._getFsProvider(E).readFile(v.URI.revive(i))).then(l=>m.VSBuffer.wrap(l))}$writeFile(E,i,l,a){return Promise.resolve(this._getFsProvider(E).writeFile(v.URI.revive(i),l.buffer,a))}$delete(E,i,l){return Promise.resolve(this._getFsProvider(E).delete(v.URI.revive(i),l))}$rename(E,i,l,a){return Promise.resolve(this._getFsProvider(E).rename(v.URI.revive(i),v.URI.revive(l),a))}$copy(E,i,l,a){const b=this._getFsProvider(E);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(v.URI.revive(i),v.URI.revive(l),a))}$mkdir(E,i){return Promise.resolve(this._getFsProvider(E).createDirectory(v.URI.revive(i)))}$watch(E,i,l,a){const b=this._getFsProvider(E).watch(v.URI.revive(l),a);this._watches.set(i,b)}$unwatch(E,i){const l=this._watches.get(i);l&&(l.dispose(),this._watches.delete(i))}$open(E,i,l){const a=this._getFsProvider(E);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(v.URI.revive(i),l))}$close(E,i){const l=this._getFsProvider(E);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(i))}$read(E,i,l,a){const b=this._getFsProvider(E);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const f=m.VSBuffer.alloc(a);return Promise.resolve(b.read(i,l,f.buffer,0,a)).then(_=>f.slice(0,_))}$write(E,i,l,a){const b=this._getFsProvider(E);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(i,l,a.buffer,0,a.byteLength))}_getFsProvider(E){const i=this._fsProvider.get(E);if(!i){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return i}}e.ExtHostFileSystem=D}),define(De[64],Ie([1,0,6,30,7,22,5,20,51,4,17,23,16]),function(re,e,v,T,d,L,R,g,y,m,A,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let D=e.ExtHostConsumerFileSystem=class ii{constructor(E,i){this._fileSystemProvider=new Map,this._writeQueue=new A.ResourceQueue,this._proxy=E.getProxy(v.MainContext.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(a){try{let b;const f=l._fileSystemProvider.get(a.scheme);return f?(await l._proxy.$ensureActivation(a.scheme),b=await f.impl.stat(a)):b=await l._proxy.$stat(a),{type:b.type,ctime:b.ctime,mtime:b.mtime,size:b.size,permissions:b.permissions===T.FilePermission.Readonly?1:void 0}}catch(b){ii._handleError(b)}},async readDirectory(a){try{const b=l._fileSystemProvider.get(a.scheme);return b?(await l._proxy.$ensureActivation(a.scheme),(await b.impl.readDirectory(a)).slice()):await l._proxy.$readdir(a)}catch(b){return ii._handleError(b)}},async createDirectory(a){try{const b=l._fileSystemProvider.get(a.scheme);return b&&!b.isReadonly?(await l._proxy.$ensureActivation(a.scheme),await l.mkdirp(b.impl,b.extUri,a)):await l._proxy.$mkdir(a)}catch(b){return ii._handleError(b)}},async readFile(a){try{const b=l._fileSystemProvider.get(a.scheme);return b?(await l._proxy.$ensureActivation(a.scheme),(await b.impl.readFile(a)).slice()):(await l._proxy.$readFile(a)).buffer}catch(b){return ii._handleError(b)}},async writeFile(a,b){try{const f=l._fileSystemProvider.get(a.scheme);return f&&!f.isReadonly?(await l._proxy.$ensureActivation(a.scheme),await l.mkdirp(f.impl,f.extUri,f.extUri.dirname(a)),await l._writeQueue.queueFor(a).queue(()=>Promise.resolve(f.impl.writeFile(a,b,{create:!0,overwrite:!0})))):await l._proxy.$writeFile(a,L.VSBuffer.wrap(b))}catch(f){return ii._handleError(f)}},async delete(a,b){try{const f=l._fileSystemProvider.get(a.scheme);return f&&!f.isReadonly?(await l._proxy.$ensureActivation(a.scheme),await f.impl.delete(a,{recursive:!1,...b})):await l._proxy.$delete(a,{recursive:!1,useTrash:!1,atomic:!1,...b})}catch(f){return ii._handleError(f)}},async rename(a,b,f){try{return await l._proxy.$rename(a,b,{overwrite:!1,...f})}catch(_){return ii._handleError(_)}},async copy(a,b,f){try{return await l._proxy.$copy(a,b,{overwrite:!1,...f})}catch(_){return ii._handleError(_)}},isWritableFileSystem(a){const b=i.getCapabilities(a);if(typeof b=="number")return!(b&2048)}})}async mkdirp(E,i,l){const a=[];for(;!i.isEqual(l,i.dirname(l));)try{if(!((await E.stat(l)).type&T.FileType.Directory))throw d.FileSystemError.FileExists(`Unable to create folder '${l.scheme===w.Schemas.file?l.fsPath:l.toString(!0)}' that already exists but is not a directory`);break}catch(b){if(T.toFileSystemProviderErrorCode(b)!==T.FileSystemProviderErrorCode.FileNotFound)throw b;a.push(i.basename(l)),l=i.dirname(l)}for(let b=a.length-1;b>=0;b--){l=i.joinPath(l,a[b]);try{await E.createDirectory(l)}catch(f){if(T.toFileSystemProviderErrorCode(f)!==T.FileSystemProviderErrorCode.FileExists)throw f}}}static _handleError(E){if(E instanceof d.FileSystemError)throw E;if(E instanceof T.FileSystemProviderError)switch(E.code){case T.FileSystemProviderErrorCode.FileExists:throw d.FileSystemError.FileExists(E.message);case T.FileSystemProviderErrorCode.FileNotFound:throw d.FileSystemError.FileNotFound(E.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw d.FileSystemError.FileNotADirectory(E.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw d.FileSystemError.FileIsADirectory(E.message);case T.FileSystemProviderErrorCode.NoPermissions:throw d.FileSystemError.NoPermissions(E.message);case T.FileSystemProviderErrorCode.Unavailable:throw d.FileSystemError.Unavailable(E.message);default:throw new d.FileSystemError(E.message,E.name)}if(!(E instanceof Error))throw new d.FileSystemError(String(E));if(E.name==="ENOPRO"||E.message.includes("ENOPRO"))throw d.FileSystemError.Unavailable(E.message);switch(E.name){case T.FileSystemProviderErrorCode.FileExists:throw d.FileSystemError.FileExists(E.message);case T.FileSystemProviderErrorCode.FileNotFound:throw d.FileSystemError.FileNotFound(E.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw d.FileSystemError.FileNotADirectory(E.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw d.FileSystemError.FileIsADirectory(E.message);case T.FileSystemProviderErrorCode.NoPermissions:throw d.FileSystemError.NoPermissions(E.message);case T.FileSystemProviderErrorCode.Unavailable:throw d.FileSystemError.Unavailable(E.message);default:throw new d.FileSystemError(E.message,E.name)}}addFileSystemProvider(E,i,l){return this._fileSystemProvider.set(E,{impl:i,extUri:l?.isCaseSensitive?k.extUri:k.extUriIgnorePathCase,isReadonly:!!l?.isReadonly}),(0,m.toDisposable)(()=>this._fileSystemProvider.delete(E))}};e.ExtHostConsumerFileSystem=D=Ve([ze(0,g.IExtHostRpcService),ze(1,y.IExtHostFileSystemInfo)],D),e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(De[286],Ie([1,0,3,33,2,6,15,7]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(k,w,D,I,E,i,l,a){this._onDidCreate=new v.Emitter,this._onDidChange=new v.Emitter,this._onDidDelete=new v.Emitter;const b=this.ensureWatching(k,D,E);this._config=0,i&&(this._config+=1),l&&(this._config+=2),a&&(this._config+=4);const f=(0,T.parse)(E),_=typeof E=="string",n=I(o=>{if(!i)for(const s of o.created){const t=d.URI.revive(s);f(t.fsPath)&&(!_||w.getWorkspaceFolder(t))&&this._onDidCreate.fire(t)}if(!l)for(const s of o.changed){const t=d.URI.revive(s);f(t.fsPath)&&(!_||w.getWorkspaceFolder(t))&&this._onDidChange.fire(t)}if(!a)for(const s of o.deleted){const t=d.URI.revive(s);f(t.fsPath)&&(!_||w.getWorkspaceFolder(t))&&this._onDidDelete.fire(t)}});this._disposable=g.Disposable.from(b,this._onDidCreate,this._onDidChange,this._onDidDelete,n)}ensureWatching(k,w,D){const I=g.Disposable.from();if(typeof D=="string")return I;const E=k.getProxy(L.MainContext.MainThreadFileSystem);let i=!1;(D.pattern.includes(T.GLOBSTAR)||D.pattern.includes(T.GLOB_SPLIT))&&(i=!0);const l=Math.random();return E.$watch(w.identifier.value,l,D.baseUri,{recursive:i,excludes:[]}),g.Disposable.from({dispose:()=>E.$unwatch(l)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class m{constructor(k,w,D){this._mainContext=k,this._logService=w,this._extHostDocumentsAndEditors=D,this._onFileSystemEvent=new v.Emitter,this._onDidRenameFile=new v.Emitter,this._onDidCreateFile=new v.Emitter,this._onDidDeleteFile=new v.Emitter,this._onWillRenameFile=new v.AsyncEmitter,this._onWillCreateFile=new v.AsyncEmitter,this._onWillDeleteFile=new v.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,w,D,I,E,i){return new y(this._mainContext,k,w,this._onFileSystemEvent.event,R.GlobPattern.from(D),I,E,i)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,w){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:w.map(D=>({oldUri:d.URI.revive(D.source),newUri:d.URI.revive(D.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:w.map(D=>d.URI.revive(D.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:w.map(D=>d.URI.revive(D.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,w){return(D,I,E)=>{const i=function(a){D.call(I,a)};return i.extension=k,w.event(i,void 0,E)}}async $onWillRunFileOperation(k,w,D,I){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:w.map(E=>({oldUri:d.URI.revive(E.source),newUri:d.URI.revive(E.target)}))},D,I);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:w.map(E=>d.URI.revive(E.target))},D,I);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:w.map(E=>d.URI.revive(E.target))},D,I)}}async _fireWillEvent(k,w,D,I){const E=new Set,i=[];if(await k.fireAsync(w,I,async(a,b)=>{const f=Date.now(),_=await Promise.resolve(a);_ instanceof g.WorkspaceEdit&&(i.push([b.extension,_]),E.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-f>D&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),I.isCancellationRequested||i.length===0)return;const l={edits:[]};for(const[,a]of i){const{edits:b}=R.WorkspaceEdit.from(a,{getTextDocumentVersion:f=>this._extHostDocumentsAndEditors.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}});l.edits=l.edits.concat(b)}return{edit:l,extensionNames:Array.from(E)}}}e.ExtHostFileSystemEventService=m}),define(De[287],Ie([1,0,4,2,6,15,7,36]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class y{constructor(w,D){this.extension=w,this.provider=D,this.handle=y._pool++}}y._pool=0;class m{constructor(w){this.session=w,this.responses=[]}}class A{constructor(w,D,I,E){this._documents=I,this._logService=E,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=w.getProxy(d.MainContext.MainThreadInlineChat),D.registerApiCommand(new g.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new g.ApiCommandArgument("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?L.Range.from(i.initialRange):void 0,message:i.message,autoSend:i.autoSend}})],g.ApiCommandResult.Void))}registerProvider(w,D){const I=new y(w,D);return this._inputProvider.set(I.handle,I),this._proxy.$registerInteractiveEditorProvider(I.handle,w.identifier.value,typeof D.handleInteractiveEditorResponseFeedback=="function"),(0,v.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(I.handle),this._inputProvider.delete(I.handle)})}async $prepareSession(w,D,I,E){const i=this._inputProvider.get(w);if(!i){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const l=this._documents.getDocument(T.URI.revive(D)),a=L.Selection.to(I),b=await i.provider.prepareInteractiveEditorSession({document:l,selection:a},E);if(!b)return;if(b.wholeRange&&!b.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const f=A._nextId++;return this._inputSessions.set(f,new m(b)),{id:f,placeholder:b.placeholder,slashCommands:b.slashCommands?.map(_=>({command:_.command,detail:_.detail,refer:_.refer})),wholeRange:L.Range.from(b.wholeRange),message:b.message}}async $provideResponse(w,D,I,E){const i=this._inputProvider.get(w);if(!i)return;const l=this._inputSessions.get(D.id);if(!l)return;const a=await i.provider.provideInteractiveEditorResponse({session:l.session,prompt:I.prompt,selection:L.Selection.to(I.selection),wholeRange:L.Range.to(I.wholeRange),attempt:I.attempt},E);if(a){const b=l.responses.push(a)-1,f={wholeRange:L.Range.from(a.wholeRange),placeholder:a.placeholder};if(A._isMessageResponse(a))return{...f,id:b,type:"message",message:L.MarkdownString.from(a.contents)};const{edits:_}=a;if(_ instanceof R.WorkspaceEdit)return{...f,id:b,type:"bulkEdit",edits:L.WorkspaceEdit.from(_)};if(Array.isArray(_))return{...f,id:b,type:"editorEdit",edits:_.map(L.TextEdit.from)}}}$handleFeedback(w,D,I,E){const i=this._inputProvider.get(w),l=this._inputSessions.get(D),a=l?.responses[I];if(i&&a){let b;switch(E){case 1:b=R.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:b=R.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:b=R.InteractiveEditorResponseFeedbackKind.Undone;break}i.provider.handleInteractiveEditorResponseFeedback?.(l.session,a,b)}}$releaseSession(w,D){const I=this._inputSessions.get(D),E=this._inputProvider.get(w);I&&E&&E.provider.releaseInteractiveEditorSession?.(I.session),this._inputSessions.delete(D)}static _isMessageResponse(w){return typeof w=="object"&&typeof w.contents=="object"}}e.ExtHostInteractiveEditor=A,A._nextId=0}),define(De[288],Ie([1,0,2,36]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class d{constructor(R,g,y,m,A){this._extHostNotebooks=g,this._textDocumentsAndEditors=y,this._commands=m;const k=new T.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.ApiCommandArgument("showOptions","Show Options",w=>!0,w=>w),new T.ApiCommandArgument("resource","Interactive resource Uri",w=>!0,w=>w),new T.ApiCommandArgument("controllerId","Notebook controller Id",w=>!0,w=>w),new T.ApiCommandArgument("title","Interactive editor title",w=>!0,w=>w)],new T.ApiCommandResult("Notebook and input URI",w=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",w.notebookEditorId),w.notebookEditorId!==void 0){const D=this._extHostNotebooks.getEditorById(w.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",D.id),{notebookUri:v.URI.revive(w.notebookUri),inputUri:v.URI.revive(w.inputUri),notebookEditor:D.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",w.notebookUri,w.inputUri),{notebookUri:v.URI.revive(w.notebookUri),inputUri:v.URI.revive(w.inputUri)}}));this._commands.registerApiCommand(k)}$willAddInteractiveDocument(R,g,y,m){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:g,lines:[""],languageId:y,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(v.URI.revive(m))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,g){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=d}),define(De[289],Ie([1,0,6,7]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class d{constructor(R){this._IssueUriRequestHandlers=new Map,this._proxy=R.getProxy(v.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(R,g){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const y=this._IssueUriRequestHandlers.get(R);if(!y)throw new Error("Issue request handler not found");const m=await y.handleIssueUrlRequest();if(!m)throw new Error("Issue request handler returned no result");return m}registerIssueUriRequestHandler(R,g){const y=R.identifier.value;return this._IssueUriRequestHandlers.set(y,g),this._proxy.$registerIssueUriRequestHandler(y),new T.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(y),this._IssueUriRequestHandlers.delete(y)})}}e.ExtHostIssueReporter=d}),define(De[290],Ie([1,0,4,6]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class d{constructor(R){this._handlePool=0,this._proxy=R.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const g=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(g,R),(0,v.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(g)})}}e.ExtHostLabelService=d}),define(De[291],Ie([1,0,2,24,15,7,76,6,9,35,19,12,156,21,4,123,111,80,39,8,17,27,191]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l,a,b,f,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class o{constructor(F,j){this._documents=F,this._provider=j}async provideDocumentSymbols(F,j){const Y=this._documents.getDocument(F),Z=await this._provider.provideDocumentSymbols(Y,j);if(!(0,A.isFalsyOrEmpty)(Z))return Z[0]instanceof L.DocumentSymbol?Z.map(d.DocumentSymbol.from):o._asDocumentSymbolTree(Z)}static _asDocumentSymbolTree(F){F=F.slice(0).sort((Z,me)=>{let _e=Z.location.range.start.compareTo(me.location.range.start);return _e===0&&(_e=me.location.range.end.compareTo(Z.location.range.end)),_e});const j=[],Y=[];for(const Z of F){const me={name:Z.name||"!!MISSING: name!!",kind:d.SymbolKind.from(Z.kind),tags:Z.tags?.map(d.SymbolTag.from)||[],detail:"",containerName:Z.containerName,range:d.Range.from(Z.location.range),selectionRange:d.Range.from(Z.location.range),children:[]};for(;;){if(Y.length===0){Y.push(me),j.push(me);break}const _e=Y[Y.length-1];if(m.Range.containsRange(_e.range,me.range)&&!m.Range.equalsRange(_e.range,me.range)){_e.children?.push(me),Y.push(me);break}Y.pop()}}return j}}class s{constructor(F,j,Y){this._documents=F,this._commands=j,this._provider=Y,this._cache=new l.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(F,j){const Y=this._documents.getDocument(F),Z=await this._provider.provideCodeLenses(Y,j);if(!Z||j.isCancellationRequested)return;const me=this._cache.add(Z),_e=new I.DisposableStore;this._disposables.set(me,_e);const fe={cacheId:me,lenses:[]};for(let ke=0;ke<Z.length;ke++)fe.lenses.push({cacheId:[me,ke],range:d.Range.from(Z[ke].range),command:this._commands.toInternal(Z[ke].command,_e)});return fe}async resolveCodeLens(F,j){const Y=F.cacheId&&this._cache.get(...F.cacheId);if(!Y)return;let Z;if(typeof this._provider.resolveCodeLens!="function"||Y.isResolved?Z=Y:Z=await this._provider.resolveCodeLens(Y,j),Z||(Z=Y),j.isCancellationRequested)return;const me=F.cacheId&&this._disposables.get(F.cacheId[0]);if(me)return F.command=this._commands.toInternal(Z.command??s._badCmd,me),F}releaseCodeLenses(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}}s._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(oe){return Array.isArray(oe)?oe.map(d.DefinitionLink.from):oe?[d.DefinitionLink.from(oe)]:[]}class u{constructor(F,j){this._documents=F,this._provider=j}async provideDefinition(F,j,Y){const Z=this._documents.getDocument(F),me=d.Position.to(j),_e=await this._provider.provideDefinition(Z,me,Y);return t(_e)}}class p{constructor(F,j){this._documents=F,this._provider=j}async provideDeclaration(F,j,Y){const Z=this._documents.getDocument(F),me=d.Position.to(j),_e=await this._provider.provideDeclaration(Z,me,Y);return t(_e)}}class h{constructor(F,j){this._documents=F,this._provider=j}async provideImplementation(F,j,Y){const Z=this._documents.getDocument(F),me=d.Position.to(j),_e=await this._provider.provideImplementation(Z,me,Y);return t(_e)}}class C{constructor(F,j){this._documents=F,this._provider=j}async provideTypeDefinition(F,j,Y){const Z=this._documents.getDocument(F),me=d.Position.to(j),_e=await this._provider.provideTypeDefinition(Z,me,Y);return t(_e)}}class S{constructor(F,j){this._documents=F,this._provider=j}async provideHover(F,j,Y){const Z=this._documents.getDocument(F),me=d.Position.to(j),_e=await this._provider.provideHover(Z,me,Y);if(!(!_e||(0,A.isFalsyOrEmpty)(_e.contents)))return _e.range||(_e.range=Z.getWordRangeAtPosition(me)),_e.range||(_e.range=new L.Range(me,me)),d.Hover.from(_e)}}class c{constructor(F,j){this._documents=F,this._provider=j}async provideEvaluatableExpression(F,j,Y){const Z=this._documents.getDocument(F),me=d.Position.to(j),_e=await this._provider.provideEvaluatableExpression(Z,me,Y);if(_e)return d.EvaluatableExpression.from(_e)}}class r{constructor(F,j){this._documents=F,this._provider=j}async provideInlineValues(F,j,Y,Z){const me=this._documents.getDocument(F),_e=await this._provider.provideInlineValues(me,d.Range.to(j),d.InlineValueContext.to(Y),Z);if(Array.isArray(_e))return _e.map(fe=>d.InlineValue.from(fe))}}class P{constructor(F,j){this._documents=F,this._provider=j}async provideDocumentHighlights(F,j,Y){const Z=this._documents.getDocument(F),me=d.Position.to(j),_e=await this._provider.provideDocumentHighlights(Z,me,Y);if(Array.isArray(_e))return _e.map(d.DocumentHighlight.from)}}class M{constructor(F,j){this._documents=F,this._provider=j}async provideLinkedEditingRanges(F,j,Y){const Z=this._documents.getDocument(F),me=d.Position.to(j),_e=await this._provider.provideLinkedEditingRanges(Z,me,Y);if(_e&&Array.isArray(_e.ranges))return{ranges:(0,A.coalesce)(_e.ranges.map(d.Range.from)),wordPattern:_e.wordPattern}}}class W{constructor(F,j){this._documents=F,this._provider=j}async provideReferences(F,j,Y,Z){const me=this._documents.getDocument(F),_e=d.Position.to(j),fe=await this._provider.provideReferences(me,_e,Y,Z);if(Array.isArray(fe))return fe.map(d.location.from)}}class ${constructor(F,j,Y,Z,me,_e,fe){this._documents=F,this._commands=j,this._diagnostics=Y,this._provider=Z,this._logService=me,this._extension=_e,this._apiDeprecation=fe,this._cache=new l.Cache("CodeAction"),this._disposables=new Map,this.nbKind=new L.CodeActionKind("notebook")}async provideCodeActions(F,j,Y,Z){const me=this._documents.getDocument(F),_e=w.Selection.isISelection(j)?d.Selection.to(j):d.Range.to(j),fe=[];for(const Ge of this._diagnostics.getDiagnostics(F))if(_e.intersection(Ge.range)&&fe.push(Ge)>$._maxCodeActionsPerFile)break;const ke={diagnostics:fe,only:Y.only?new L.CodeActionKind(Y.only):void 0,triggerKind:d.CodeActionTriggerKind.to(Y.trigger)},Pe=await this._provider.provideCodeActions(me,_e,ke,Z);if(!(0,A.isNonEmptyArray)(Pe)||Z.isCancellationRequested)return;const $e=this._cache.add(Pe),He=new I.DisposableStore;this._disposables.set($e,He);const tt=[];for(let Ge=0;Ge<Pe.length;Ge++){const Ke=Pe[Ge];if(Ke)if($._isCommand(Ke))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:Ke.title,command:this._commands.toInternal(Ke,He)});else{if(ke.triggerKind!==L.CodeActionTriggerKind.Invoke&&Ke.kind&&this.nbKind.contains(Ke.kind))continue;ke.only&&(Ke.kind?ke.only.contains(Ke.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ke.only.value} 'requested but returned code action is of kind '${Ke.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ke.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[$e,Ge],title:Ke.title,command:Ke.command&&this._commands.toInternal(Ke.command,He),diagnostics:Ke.diagnostics&&Ke.diagnostics.map(d.Diagnostic.from),edit:Ke.edit&&d.WorkspaceEdit.from(Ke.edit,void 0),kind:Ke.kind&&Ke.kind.value,isPreferred:Ke.isPreferred,disabled:Ke.disabled?.reason})}}return{cacheId:$e,actions:tt}}async resolveCodeAction(F,j){const[Y,Z]=F,me=this._cache.get(Y,Z);if(!me||$._isCommand(me))return{};if(!this._provider.resolveCodeAction)return{};const _e=await this._provider.resolveCodeAction(me,j)??me;let fe;_e.edit&&(fe=d.WorkspaceEdit.from(_e.edit,void 0));let ke;if(_e.command){const Pe=this._disposables.get(Y);Pe&&(ke=this._commands.toInternal(_e.command,Pe))}return{edit:fe,command:ke}}releaseCodeActions(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}static _isCommand(F){return typeof F.command=="string"&&typeof F.title=="string"}}$._maxCodeActionsPerFile=1e3;class z{constructor(F,j,Y,Z,me){this._proxy=F,this._documents=j,this._provider=Y,this._handle=Z,this._extension=me}async prepareDocumentPaste(F,j,Y,Z){if(!this._provider.prepareDocumentPaste)return;const me=this._documents.getDocument(F),_e=j.map(Pe=>d.Range.to(Pe)),fe=d.DataTransfer.toDataTransfer(Y,()=>{throw new b.NotImplementedError});if(await this._provider.prepareDocumentPaste(me,_e,fe,Z),Z.isCancellationRequested)return;const ke=Array.from(fe).filter(([,Pe])=>!(Pe instanceof L.InternalDataTransferItem));return d.DataTransfer.from(ke)}async providePasteEdits(F,j,Y,Z,me){if(!this._provider.provideDocumentPasteEdits)return;const _e=this._documents.getDocument(j),fe=Y.map($e=>d.Range.to($e)),ke=d.DataTransfer.toDataTransfer(Z,async $e=>(await this._proxy.$resolvePasteFileData(this._handle,F,$e)).buffer),Pe=await this._provider.provideDocumentPasteEdits(_e,fe,ke,me);if(Pe)return{id:Pe.id?this._extension.identifier.value+"."+Pe.id:this._extension.identifier.value,label:Pe.label??(0,n.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,priority:Pe.priority??0,insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?d.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class N{constructor(F,j){this._documents=F,this._provider=j}async provideDocumentFormattingEdits(F,j,Y){const Z=this._documents.getDocument(F),me=await this._provider.provideDocumentFormattingEdits(Z,j,Y);if(Array.isArray(me))return me.map(d.TextEdit.from)}}class q{constructor(F,j){this._documents=F,this._provider=j}async provideDocumentRangeFormattingEdits(F,j,Y,Z){const me=this._documents.getDocument(F),_e=d.Range.to(j),fe=await this._provider.provideDocumentRangeFormattingEdits(me,_e,Y,Z);if(Array.isArray(fe))return fe.map(d.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,j,Y,Z){(0,k.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const me=this._documents.getDocument(F),_e=j.map(d.Range.to),fe=await this._provider.provideDocumentRangesFormattingEdits(me,_e,Y,Z);if(Array.isArray(fe))return fe.map(d.TextEdit.from)}}class x{constructor(F,j){this._documents=F,this._provider=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,j,Y,Z,me){const _e=this._documents.getDocument(F),fe=d.Position.to(j),ke=await this._provider.provideOnTypeFormattingEdits(_e,fe,Y,Z,me);if(Array.isArray(ke))return ke.map(d.TextEdit.from)}}class U{constructor(F,j){this._provider=F,this._logService=j,this._cache=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(F,j){const Y=await this._provider.provideWorkspaceSymbols(F,j);if(!(0,A.isNonEmptyArray)(Y))return{symbols:[]};const Z=this._cache.add(Y),me={cacheId:Z,symbols:[]};for(let _e=0;_e<Y.length;_e++){const fe=Y[_e];if(!fe||!fe.name){this._logService.warn("INVALID SymbolInformation",fe);continue}me.symbols.push({...d.WorkspaceSymbol.from(fe),cacheId:[Z,_e]})}return me}async resolveWorkspaceSymbol(F,j){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const Y=this._cache.get(...F.cacheId);if(Y){const Z=await this._provider.resolveWorkspaceSymbol(Y,j);return Z&&(0,T.mixin)(F,d.WorkspaceSymbol.from(Z),!0)}}releaseWorkspaceSymbols(F){this._cache.delete(F)}}class de{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,j,Y){this._documents=F,this._provider=j,this._logService=Y}async provideRenameEdits(F,j,Y,Z){const me=this._documents.getDocument(F),_e=d.Position.to(j);try{const fe=await this._provider.provideRenameEdits(me,_e,Y,Z);return fe?d.WorkspaceEdit.from(fe):void 0}catch(fe){const ke=de._asMessage(fe);return ke?{rejectReason:ke,edits:void 0}:Promise.reject(fe)}}async resolveRenameLocation(F,j,Y){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const Z=this._documents.getDocument(F),me=d.Position.to(j);try{const _e=await this._provider.prepareRename(Z,me,Y);let fe,ke;if(L.Range.isRange(_e)?(fe=_e,ke=Z.getText(_e)):(0,k.isObject)(_e)&&(fe=_e.range,ke=_e.placeholder),!fe||!ke)return;if(fe.start.line>me.line||fe.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:d.Range.from(fe),text:ke}}catch(_e){const fe=de._asMessage(_e);return fe?{rejectReason:fe,range:void 0,text:void 0}:Promise.reject(_e)}}static _asMessage(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class ie{constructor(F,j){this.resultId=F,this.tokens=j}}class ne{constructor(F,j){this._documents=F,this._provider=j,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(F,j,Y){const Z=this._documents.getDocument(F),me=j!==0?this._previousResults.get(j):null;let _e=typeof me?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(Z,me.resultId,Y):await this._provider.provideDocumentSemanticTokens(Z,Y);return me&&this._previousResults.delete(j),_e?(_e=ne._fixProvidedSemanticTokens(_e),this._send(ne._convertToEdits(me,_e),_e)):null}async releaseDocumentSemanticColoring(F){this._previousResults.delete(F)}static _fixProvidedSemanticTokens(F){return ne._isSemanticTokens(F)?ne._isCorrectSemanticTokens(F)?F:new L.SemanticTokens(new Uint32Array(F.data),F.resultId):ne._isSemanticTokensEdits(F)?ne._isCorrectSemanticTokensEdits(F)?F:new L.SemanticTokensEdits(F.edits.map(j=>new L.SemanticTokensEdit(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),F.resultId):F}static _isSemanticTokens(F){return F&&!!F.data}static _isCorrectSemanticTokens(F){return F.data instanceof Uint32Array}static _isSemanticTokensEdits(F){return F&&Array.isArray(F.edits)}static _isCorrectSemanticTokensEdits(F){for(const j of F.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(F,j){if(!ne._isSemanticTokens(j)||!F||!F.tokens)return j;const Y=F.tokens,Z=Y.length,me=j.data,_e=me.length;let fe=0;const ke=Math.min(Z,_e);for(;fe<ke&&Y[fe]===me[fe];)fe++;if(fe===Z&&fe===_e)return new L.SemanticTokensEdits([],j.resultId);let Pe=0;const $e=ke-fe;for(;Pe<$e&&Y[Z-Pe-1]===me[_e-Pe-1];)Pe++;return new L.SemanticTokensEdits([{start:fe,deleteCount:Z-fe-Pe,data:me.subarray(fe,_e-Pe)}],j.resultId)}_send(F,j){if(ne._isSemanticTokens(F)){const Y=this._nextResultId++;return this._previousResults.set(Y,new ie(F.resultId,F.data)),(0,E.encodeSemanticTokensDto)({id:Y,type:"full",data:F.data})}if(ne._isSemanticTokensEdits(F)){const Y=this._nextResultId++;return ne._isSemanticTokens(j)?this._previousResults.set(Y,new ie(j.resultId,j.data)):this._previousResults.set(Y,new ie(F.resultId)),(0,E.encodeSemanticTokensDto)({id:Y,type:"delta",deltas:(F.edits||[]).map(Z=>({start:Z.start,deleteCount:Z.deleteCount,data:Z.data}))})}return null}}class H{constructor(F,j){this._documents=F,this._provider=j}async provideDocumentRangeSemanticTokens(F,j,Y){const Z=this._documents.getDocument(F),me=await this._provider.provideDocumentRangeSemanticTokens(Z,d.Range.to(j),Y);return me?this._send(me):null}_send(F){return(0,E.encodeSemanticTokensDto)({id:0,type:"full",data:F.data})}}class V{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,j,Y,Z,me){this._documents=F,this._commands=j,this._provider=Y,this._apiDeprecation=Z,this._extension=me,this._cache=new l.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(F,j,Y,Z){const me=this._documents.getDocument(F),_e=d.Position.to(j),fe=me.getWordRangeAtPosition(_e)||new L.Range(_e,_e),ke=fe.with({end:_e}),Pe=new a.StopWatch,$e=await this._provider.provideCompletionItems(me,_e,Z,d.CompletionContext.to(Y));if(!$e||Z.isCancellationRequested)return;const He=Array.isArray($e)?new L.CompletionList($e):$e,tt=V.supportsResolving(this._provider)?this._cache.add(He.items):this._cache.add([]),Ge=new I.DisposableStore;this._disposables.set(tt,Ge);const Ke=[],st={x:tt,b:Ke,a:{replace:d.Range.from(fe),insert:d.Range.from(ke)},c:He.isIncomplete||void 0,d:Pe.elapsed()};for(let at=0;at<He.items.length;at++){const Ze=He.items[at],rt=this._convertCompletionItem(Ze,[tt,at],ke,fe);Ke.push(rt)}return st}async resolveCompletionItem(F,j){if(typeof this._provider.resolveCompletionItem!="function")return;const Y=this._cache.get(...F);if(!Y)return;const Z=this._convertCompletionItem(Y,F),me=await this._provider.resolveCompletionItem(Y,j);if(!me)return;const _e=this._convertCompletionItem(me,F);return(Z.h!==_e.h||Z.i!==_e.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Z.n!==_e.n||Z.o!==_e.o||!(0,T.equals)(Z.p,_e.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Z,d:_e.d,c:_e.c,l:_e.l,h:_e.h,i:_e.i,n:_e.n,o:_e.o,p:_e.p}}releaseCompletionItems(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}_convertCompletionItem(F,j,Y,Z){const me=this._disposables.get(j[0]);if(!me)throw Error("DisposableStore is missing...");const _e=this._commands.toInternal(F.command,me),fe={x:j,a:F.label,b:F.kind!==void 0?d.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(d.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:d.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(d.TextEdit.from),n:_e?.$ident,o:_e?.id,p:_e?.$ident?void 0:_e?.arguments};F.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),fe.h=F.textEdit.newText):typeof F.insertText=="string"?fe.h=F.insertText:F.insertText instanceof L.SnippetString&&(fe.h=F.insertText.value,fe.i|=4);let ke;return F.textEdit?ke=F.textEdit.range:F.range&&(ke=F.range),L.Range.isRange(ke)?fe.j=d.Range.from(ke):ke&&(!Y?.isEqual(ke.inserting)||!Z?.isEqual(ke.replacing))&&(fe.j={insert:d.Range.from(ke.inserting),replace:d.Range.from(ke.replacing)}),fe}}class ce{async provideInlineCompletions(F,j,Y,Z){}disposeCompletions(F){}handleDidShowCompletionItem(F,j,Y){}handlePartialAccept(F,j,Y){}}class be extends ce{constructor(F,j,Y,Z){super(),this._extension=F,this._documents=j,this._provider=Y,this._commands=Z,this._references=new Se,this._isAdditionsProposedApiEnabled=(0,_.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[R.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,_.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,j,Y,Z){const me=this._documents.getDocument(F),_e=d.Position.to(j),fe=await this._provider.provideInlineCompletionItems(me,_e,{selectedCompletionInfo:Y.selectedSuggestionInfo?{range:d.Range.to(Y.selectedSuggestionInfo.range),text:Y.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[Y.triggerKind]},Z);if(!fe||Z.isCancellationRequested)return;const ke=Array.isArray(fe)?fe:fe.items,Pe=this._isAdditionsProposedApiEnabled?Array.isArray(fe)?[]:fe.commands||[]:[],$e=this._isAdditionsProposedApiEnabled&&!Array.isArray(fe)?fe.suppressSuggestions:void 0,He=this._isAdditionsProposedApiEnabled&&!Array.isArray(fe)?fe.enableForwardStability:void 0;let tt;return{pid:this._references.createReferenceId({dispose(){tt?.dispose()},items:ke}),items:ke.map((Ke,st)=>{let at;Ke.command&&(tt||(tt=new I.DisposableStore),at=this._commands.toInternal(Ke.command,tt));const Ze=Ke.insertText;return{insertText:typeof Ze=="string"?Ze:{snippet:Ze.value},filterText:Ke.filterText,range:Ke.range?d.Range.from(Ke.range):void 0,command:at,idx:st,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ke.completeBracketPairs:!1}}),commands:Pe.map(Ke=>(tt||(tt=new I.DisposableStore),this._commands.toInternal(Ke,tt))),suppressSuggestions:$e,enableForwardStability:He}}disposeCompletions(F){this._references.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,j,Y){const Z=this._references.get(F)?.items[j];Z&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(Z,Y)}handlePartialAccept(F,j,Y){const Z=this._references.get(F)?.items[j];Z&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(Z,Y)}}class Se{constructor(){this._references=new Map,this._idPool=1}createReferenceId(F){const j=this._idPool++;return this._references.set(j,F),j}disposeReferenceId(F){const j=this._references.get(F);return this._references.delete(F),j}get(F){return this._references.get(F)}}class ge{constructor(F,j){this._documents=F,this._provider=j,this._cache=new l.Cache("SignatureHelp")}async provideSignatureHelp(F,j,Y,Z){const me=this._documents.getDocument(F),_e=d.Position.to(j),fe=this.reviveContext(Y),ke=await this._provider.provideSignatureHelp(me,_e,Z,fe);if(ke){const Pe=this._cache.add([ke]);return{...d.SignatureHelp.from(ke),id:Pe}}}reviveContext(F){let j;if(F.activeSignatureHelp){const Y=d.SignatureHelp.to(F.activeSignatureHelp),Z=this._cache.get(F.activeSignatureHelp.id,0);Z?(j=Z,j.activeSignature=Y.activeSignature,j.activeParameter=Y.activeParameter):j=Y}return{...F,activeSignatureHelp:j}}releaseSignatureHelp(F){this._cache.delete(F)}}class O{constructor(F,j,Y,Z,me){this._documents=F,this._commands=j,this._provider=Y,this._logService=Z,this._extension=me,this._cache=new l.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(F,j,Y){const Z=this._documents.getDocument(F),me=d.Range.to(j),_e=await this._provider.provideInlayHints(Z,me,Y);if(!Array.isArray(_e)||_e.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${j}`);return}if(Y.isCancellationRequested)return;const fe=this._cache.add(_e);this._disposables.set(fe,new I.DisposableStore);const ke={hints:[],cacheId:fe};for(let Pe=0;Pe<_e.length;Pe++)this._isValidInlayHint(_e[Pe],me)&&ke.hints.push(this._convertInlayHint(_e[Pe],[fe,Pe]));return this._logService.trace(`[InlayHints] ${ke.hints.length} inlay hints from '${this._extension.identifier.value}' for ${j}`),ke}async resolveInlayHint(F,j){if(typeof this._provider.resolveInlayHint!="function")return;const Y=this._cache.get(...F);if(!Y)return;const Z=await this._provider.resolveInlayHint(Y,j);if(Z&&this._isValidInlayHint(Z))return this._convertInlayHint(Z,F)}releaseHints(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}_isValidInlayHint(F,j){return F.label.length===0||Array.isArray(F.label)&&F.label.every(Y=>Y.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(j&&!j.contains(F.position))}_convertInlayHint(F,j){const Y=this._disposables.get(j[0]);if(!Y)throw Error("DisposableStore is missing...");const Z={label:"",cacheId:j,tooltip:d.MarkdownString.fromStrict(F.tooltip),position:d.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(d.TextEdit.from),kind:F.kind&&d.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?Z.label=F.label:Z.label=F.label.map(me=>{const _e={label:me.value};return _e.tooltip=d.MarkdownString.fromStrict(me.tooltip),L.Location.isLocation(me.location)&&(_e.location=d.location.from(me.location)),me.command&&(_e.command=this._commands.toInternal(me.command,Y)),_e}),Z}}class K{constructor(F,j){this._documents=F,this._provider=j,this._cache=new l.Cache("DocumentLink")}async provideLinks(F,j){const Y=this._documents.getDocument(F),Z=await this._provider.provideDocumentLinks(Y,j);if(!(!Array.isArray(Z)||Z.length===0)&&!j.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:Z.filter(K._validateLink).map(d.DocumentLink.from)};{const me=this._cache.add(Z),_e={links:[],cacheId:me};for(let fe=0;fe<Z.length;fe++){if(!K._validateLink(Z[fe]))continue;const ke=d.DocumentLink.from(Z[fe]);ke.cacheId=[me,fe],_e.links.push(ke)}return _e}}}static _validateLink(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,j){if(typeof this._provider.resolveDocumentLink!="function")return;const Y=this._cache.get(...F);if(!Y)return;const Z=await this._provider.resolveDocumentLink(Y,j);if(!(!Z||!K._validateLink(Z)))return d.DocumentLink.from(Z)}releaseLinks(F){this._cache.delete(F)}}class we{constructor(F,j){this._documents=F,this._provider=j}async provideColors(F,j){const Y=this._documents.getDocument(F),Z=await this._provider.provideDocumentColors(Y,j);return Array.isArray(Z)?Z.map(_e=>({color:d.Color.from(_e.color),range:d.Range.from(_e.range)})):[]}async provideColorPresentations(F,j,Y){const Z=this._documents.getDocument(F),me=d.Range.to(j.range),_e=d.Color.to(j.color),fe=await this._provider.provideColorPresentations(_e,{document:Z,range:me},Y);if(Array.isArray(fe))return fe.map(d.ColorPresentation.from)}}class Ce{constructor(F,j){this._documents=F,this._provider=j}async provideFoldingRanges(F,j,Y){const Z=this._documents.getDocument(F),me=await this._provider.provideFoldingRanges(Z,j,Y);if(Array.isArray(me))return me.map(d.FoldingRange.from)}}class ee{constructor(F,j,Y){this._documents=F,this._provider=j,this._logService=Y}async provideSelectionRanges(F,j,Y){const Z=this._documents.getDocument(F),me=j.map(d.Position.to),_e=await this._provider.provideSelectionRanges(Z,me,Y);if(!(0,A.isNonEmptyArray)(_e))return[];if(_e.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const fe=[];for(let ke=0;ke<me.length;ke++){const Pe=[];fe.push(Pe);let $e=me[ke],He=_e[ke];for(;;){if(!He.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(Pe.push(d.SelectionRange.from(He)),!He.parent)break;$e=He.range,He=He.parent}}return fe}}class te{constructor(F,j){this._documents=F,this._provider=j,this._idPool=new i.IdGenerator(""),this._cache=new Map}async prepareSession(F,j,Y){const Z=this._documents.getDocument(F),me=d.Position.to(j),_e=await this._provider.prepareCallHierarchy(Z,me,Y);if(!_e)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(_e)?_e.map(ke=>this._cacheAndConvertItem(fe,ke)):[this._cacheAndConvertItem(fe,_e)]}async provideCallsTo(F,j,Y){const Z=this._itemFromCache(F,j);if(!Z)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(Z,Y);if(me)return me.map(_e=>({from:this._cacheAndConvertItem(F,_e.from),fromRanges:_e.fromRanges.map(fe=>d.Range.from(fe))}))}async provideCallsFrom(F,j,Y){const Z=this._itemFromCache(F,j);if(!Z)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(Z,Y);if(me)return me.map(_e=>({to:this._cacheAndConvertItem(F,_e.to),fromRanges:_e.fromRanges.map(fe=>d.Range.from(fe))}))}releaseSession(F){this._cache.delete(F)}_cacheAndConvertItem(F,j){const Y=this._cache.get(F),Z=d.CallHierarchyItem.from(j,F,Y.size.toString(36));return Y.set(Z._itemId,j),Z}_itemFromCache(F,j){return this._cache.get(F)?.get(j)}}class ue{constructor(F,j){this._documents=F,this._provider=j,this._idPool=new i.IdGenerator(""),this._cache=new Map}async prepareSession(F,j,Y){const Z=this._documents.getDocument(F),me=d.Position.to(j),_e=await this._provider.prepareTypeHierarchy(Z,me,Y);if(!_e)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(_e)?_e.map(ke=>this._cacheAndConvertItem(fe,ke)):[this._cacheAndConvertItem(fe,_e)]}async provideSupertypes(F,j,Y){const Z=this._itemFromCache(F,j);if(!Z)throw new Error("missing type hierarchy item");const me=await this._provider.provideTypeHierarchySupertypes(Z,Y);if(me)return me.map(_e=>this._cacheAndConvertItem(F,_e))}async provideSubtypes(F,j,Y){const Z=this._itemFromCache(F,j);if(!Z)throw new Error("missing type hierarchy item");const me=await this._provider.provideTypeHierarchySubtypes(Z,Y);if(me)return me.map(_e=>this._cacheAndConvertItem(F,_e))}releaseSession(F){this._cache.delete(F)}_cacheAndConvertItem(F,j){const Y=this._cache.get(F),Z=d.TypeHierarchyItem.from(j,F,Y.size.toString(36));return Y.set(Z._itemId,j),Z}_itemFromCache(F,j){return this._cache.get(F)?.get(j)}}class Q{constructor(F,j,Y,Z,me){this._proxy=F,this._documents=j,this._provider=Y,this._handle=Z,this._extension=me}async provideDocumentOnDropEdits(F,j,Y,Z,me){const _e=this._documents.getDocument(j),fe=d.Position.to(Y),ke=d.DataTransfer.toDataTransfer(Z,async $e=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,F,$e)).buffer),Pe=await this._provider.provideDocumentDropEdits(_e,fe,ke,me);if(Pe)return{id:Pe.id?this._extension.identifier.value+"."+Pe.id:this._extension.identifier.value,label:Pe.label??(0,n.localize)(1,null,this._extension.displayName||this._extension.name),priority:Pe.priority??0,insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?d.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class le{constructor(F,j){this.adapter=F,this.extension=j}}class se{constructor(F,j,Y,Z,me,_e,fe,ke){this._uriTransformer=j,this._documents=Y,this._commands=Z,this._diagnostics=me,this._logService=_e,this._apiDeprecation=fe,this._extensionTelemetry=ke,this._adapter=new Map,this._proxy=F.getProxy(g.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(F,j){return d.DocumentSelector.from(F,this._uriTransformer,j)}_createDisposable(F){return new L.Disposable(()=>{this._adapter.delete(F),this._proxy.$unregister(F)})}_nextHandle(){return se._handlePool++}async _withAdapter(F,j,Y,Z,me,_e=!1){const fe=this._adapter.get(F);if(!fe||!(fe.adapter instanceof j))return Z;const ke=Date.now();_e||this._logService.trace(`[${fe.extension.identifier.value}] INVOKE provider '${Y.toString().replace(/[\r\n]/g,"")}'`);const Pe=Y(fe.adapter,fe.extension);return Promise.resolve(Pe).catch($e=>{(0,b.isCancellationError)($e)||(this._logService.error(`[${fe.extension.identifier.value}] provider FAILED`),this._logService.error($e),this._extensionTelemetry.onExtensionError(fe.extension.identifier,$e))}).finally(()=>{_e||this._logService.trace(`[${fe.extension.identifier.value}] provider DONE after ${Date.now()-ke}ms`)}),D.CancellationToken.isCancellationToken(me)?(0,f.raceCancellationError)(Pe,me):Pe}_addNewAdapter(F,j){const Y=this._nextHandle();return this._adapter.set(Y,new le(F,j)),Y}static _extLabel(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,j,Y,Z){const me=this._addNewAdapter(new o(this._documents,Y),F),_e=Z&&Z.label||se._extLabel(F);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(j,F),_e),this._createDisposable(me)}$provideDocumentSymbols(F,j,Y){return this._withAdapter(F,o,Z=>Z.provideDocumentSymbols(v.URI.revive(j),Y),void 0,Y)}registerCodeLensProvider(F,j,Y){const Z=this._nextHandle(),me=typeof Y.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(Z,new le(new s(this._documents,this._commands.converter,Y),F)),this._proxy.$registerCodeLensSupport(Z,this._transformDocumentSelector(j,F),me);let _e=this._createDisposable(Z);if(me!==void 0){const fe=Y.onDidChangeCodeLenses(ke=>this._proxy.$emitCodeLensEvent(me));_e=L.Disposable.from(_e,fe)}return _e}$provideCodeLenses(F,j,Y){return this._withAdapter(F,s,Z=>Z.provideCodeLenses(v.URI.revive(j),Y),void 0,Y)}$resolveCodeLens(F,j,Y){return this._withAdapter(F,s,Z=>Z.resolveCodeLens(j,Y),void 0,void 0)}$releaseCodeLenses(F,j){this._withAdapter(F,s,Y=>Promise.resolve(Y.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(F,j,Y){const Z=this._addNewAdapter(new u(this._documents,Y),F);return this._proxy.$registerDefinitionSupport(Z,this._transformDocumentSelector(j,F)),this._createDisposable(Z)}$provideDefinition(F,j,Y,Z){return this._withAdapter(F,u,me=>me.provideDefinition(v.URI.revive(j),Y,Z),[],Z)}registerDeclarationProvider(F,j,Y){const Z=this._addNewAdapter(new p(this._documents,Y),F);return this._proxy.$registerDeclarationSupport(Z,this._transformDocumentSelector(j,F)),this._createDisposable(Z)}$provideDeclaration(F,j,Y,Z){return this._withAdapter(F,p,me=>me.provideDeclaration(v.URI.revive(j),Y,Z),[],Z)}registerImplementationProvider(F,j,Y){const Z=this._addNewAdapter(new h(this._documents,Y),F);return this._proxy.$registerImplementationSupport(Z,this._transformDocumentSelector(j,F)),this._createDisposable(Z)}$provideImplementation(F,j,Y,Z){return this._withAdapter(F,h,me=>me.provideImplementation(v.URI.revive(j),Y,Z),[],Z)}registerTypeDefinitionProvider(F,j,Y){const Z=this._addNewAdapter(new C(this._documents,Y),F);return this._proxy.$registerTypeDefinitionSupport(Z,this._transformDocumentSelector(j,F)),this._createDisposable(Z)}$provideTypeDefinition(F,j,Y,Z){return this._withAdapter(F,C,me=>me.provideTypeDefinition(v.URI.revive(j),Y,Z),[],Z)}registerHoverProvider(F,j,Y,Z){const me=this._addNewAdapter(new S(this._documents,Y),F);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(j,F)),this._createDisposable(me)}$provideHover(F,j,Y,Z){return this._withAdapter(F,S,me=>me.provideHover(v.URI.revive(j),Y,Z),void 0,Z)}registerEvaluatableExpressionProvider(F,j,Y,Z){const me=this._addNewAdapter(new c(this._documents,Y),F);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(j,F)),this._createDisposable(me)}$provideEvaluatableExpression(F,j,Y,Z){return this._withAdapter(F,c,me=>me.provideEvaluatableExpression(v.URI.revive(j),Y,Z),void 0,Z)}registerInlineValuesProvider(F,j,Y,Z){const me=typeof Y.onDidChangeInlineValues=="function"?this._nextHandle():void 0,_e=this._addNewAdapter(new r(this._documents,Y),F);this._proxy.$registerInlineValuesProvider(_e,this._transformDocumentSelector(j,F),me);let fe=this._createDisposable(_e);if(me!==void 0){const ke=Y.onDidChangeInlineValues(Pe=>this._proxy.$emitInlineValuesEvent(me));fe=L.Disposable.from(fe,ke)}return fe}$provideInlineValues(F,j,Y,Z,me){return this._withAdapter(F,r,_e=>_e.provideInlineValues(v.URI.revive(j),Y,Z,me),void 0,me)}registerDocumentHighlightProvider(F,j,Y){const Z=this._addNewAdapter(new P(this._documents,Y),F);return this._proxy.$registerDocumentHighlightProvider(Z,this._transformDocumentSelector(j,F)),this._createDisposable(Z)}$provideDocumentHighlights(F,j,Y,Z){return this._withAdapter(F,P,me=>me.provideDocumentHighlights(v.URI.revive(j),Y,Z),void 0,Z)}registerLinkedEditingRangeProvider(F,j,Y){const Z=this._addNewAdapter(new M(this._documents,Y),F);return this._proxy.$registerLinkedEditingRangeProvider(Z,this._transformDocumentSelector(j,F)),this._createDisposable(Z)}$provideLinkedEditingRanges(F,j,Y,Z){return this._withAdapter(F,M,async me=>{const _e=await me.provideLinkedEditingRanges(v.URI.revive(j),Y,Z);if(_e)return{ranges:_e.ranges,wordPattern:_e.wordPattern?se._serializeRegExp(_e.wordPattern):void 0}},void 0,Z)}registerReferenceProvider(F,j,Y){const Z=this._addNewAdapter(new W(this._documents,Y),F);return this._proxy.$registerReferenceSupport(Z,this._transformDocumentSelector(j,F)),this._createDisposable(Z)}$provideReferences(F,j,Y,Z,me){return this._withAdapter(F,W,_e=>_e.provideReferences(v.URI.revive(j),Y,Z,me),void 0,me)}registerCodeActionProvider(F,j,Y,Z){const me=new I.DisposableStore,_e=this._addNewAdapter(new $(this._documents,this._commands.converter,this._diagnostics,Y,this._logService,F,this._apiDeprecation),F);return this._proxy.$registerQuickFixSupport(_e,this._transformDocumentSelector(j,F),{providedKinds:Z?.providedCodeActionKinds?.map(fe=>fe.value),documentation:Z?.documentation?.map(fe=>({kind:fe.kind.value,command:this._commands.converter.toInternal(fe.command,me)}))},se._extLabel(F),!!Y.resolveCodeAction),me.add(this._createDisposable(_e)),me}$provideCodeActions(F,j,Y,Z,me){return this._withAdapter(F,$,_e=>_e.provideCodeActions(v.URI.revive(j),Y,Z,me),void 0,me)}$resolveCodeAction(F,j,Y){return this._withAdapter(F,$,Z=>Z.resolveCodeAction(j,Y),{},void 0)}$releaseCodeActions(F,j){this._withAdapter(F,$,Y=>Promise.resolve(Y.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(F,j,Y){const Z=this._addNewAdapter(new N(this._documents,Y),F);return this._proxy.$registerDocumentFormattingSupport(Z,this._transformDocumentSelector(j,F),F.identifier,F.displayName||F.name),this._createDisposable(Z)}$provideDocumentFormattingEdits(F,j,Y,Z){return this._withAdapter(F,N,me=>me.provideDocumentFormattingEdits(v.URI.revive(j),Y,Z),void 0,Z)}registerDocumentRangeFormattingEditProvider(F,j,Y){const Z=typeof Y.provideDocumentRangesFormattingEdits=="function";Z&&(0,_.checkProposedApiEnabled)(F,"formatMultipleRanges");const me=this._addNewAdapter(new q(this._documents,Y),F);return this._proxy.$registerRangeFormattingSupport(me,this._transformDocumentSelector(j,F),F.identifier,F.displayName||F.name,Z),this._createDisposable(me)}$provideDocumentRangeFormattingEdits(F,j,Y,Z,me){return this._withAdapter(F,q,_e=>_e.provideDocumentRangeFormattingEdits(v.URI.revive(j),Y,Z,me),void 0,me)}$provideDocumentRangesFormattingEdits(F,j,Y,Z,me){return this._withAdapter(F,q,_e=>_e.provideDocumentRangesFormattingEdits(v.URI.revive(j),Y,Z,me),void 0,me)}registerOnTypeFormattingEditProvider(F,j,Y,Z){const me=this._addNewAdapter(new x(this._documents,Y),F);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(j,F),Z,F.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits(F,j,Y,Z,me,_e){return this._withAdapter(F,x,fe=>fe.provideOnTypeFormattingEdits(v.URI.revive(j),Y,Z,me,_e),void 0,_e)}registerWorkspaceSymbolProvider(F,j){const Y=this._addNewAdapter(new U(j,this._logService),F);return this._proxy.$registerNavigateTypeSupport(Y,typeof j.resolveWorkspaceSymbol=="function"),this._createDisposable(Y)}$provideWorkspaceSymbols(F,j,Y){return this._withAdapter(F,U,Z=>Z.provideWorkspaceSymbols(j,Y),{symbols:[]},Y)}$resolveWorkspaceSymbol(F,j,Y){return this._withAdapter(F,U,Z=>Z.resolveWorkspaceSymbol(j,Y),void 0,void 0)}$releaseWorkspaceSymbols(F,j){this._withAdapter(F,U,Y=>Y.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(F,j,Y){const Z=this._addNewAdapter(new de(this._documents,Y,this._logService),F);return this._proxy.$registerRenameSupport(Z,this._transformDocumentSelector(j,F),de.supportsResolving(Y)),this._createDisposable(Z)}$provideRenameEdits(F,j,Y,Z,me){return this._withAdapter(F,de,_e=>_e.provideRenameEdits(v.URI.revive(j),Y,Z,me),void 0,me)}$resolveRenameLocation(F,j,Y,Z){return this._withAdapter(F,de,me=>me.resolveRenameLocation(v.URI.revive(j),Y,Z),void 0,Z)}registerDocumentSemanticTokensProvider(F,j,Y,Z){const me=this._addNewAdapter(new ne(this._documents,Y),F),_e=typeof Y.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(j,F),Z,_e);let fe=this._createDisposable(me);if(_e){const ke=Y.onDidChangeSemanticTokens(Pe=>this._proxy.$emitDocumentSemanticTokensEvent(_e));fe=L.Disposable.from(fe,ke)}return fe}$provideDocumentSemanticTokens(F,j,Y,Z){return this._withAdapter(F,ne,me=>me.provideDocumentSemanticTokens(v.URI.revive(j),Y,Z),null,Z)}$releaseDocumentSemanticTokens(F,j){this._withAdapter(F,ne,Y=>Y.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,j,Y,Z){const me=this._addNewAdapter(new H(this._documents,Y),F);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(j,F),Z),this._createDisposable(me)}$provideDocumentRangeSemanticTokens(F,j,Y,Z){return this._withAdapter(F,H,me=>me.provideDocumentRangeSemanticTokens(v.URI.revive(j),Y,Z),null,Z)}registerCompletionItemProvider(F,j,Y,Z){const me=this._addNewAdapter(new V(this._documents,this._commands.converter,Y,this._apiDeprecation,F),F);return this._proxy.$registerCompletionsProvider(me,this._transformDocumentSelector(j,F),Z,V.supportsResolving(Y),F.identifier),this._createDisposable(me)}$provideCompletionItems(F,j,Y,Z,me){return this._withAdapter(F,V,_e=>_e.provideCompletionItems(v.URI.revive(j),Y,Z,me),void 0,me)}$resolveCompletionItem(F,j,Y){return this._withAdapter(F,V,Z=>Z.resolveCompletionItem(j,Y),void 0,Y)}$releaseCompletionItems(F,j){this._withAdapter(F,V,Y=>Y.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(F,j,Y){const Z=new be(F,this._documents,Y,this._commands.converter),me=this._addNewAdapter(Z,F);return this._proxy.$registerInlineCompletionsSupport(me,this._transformDocumentSelector(j,F),Z.supportsHandleEvents),this._createDisposable(me)}$provideInlineCompletions(F,j,Y,Z,me){return this._withAdapter(F,ce,_e=>_e.provideInlineCompletions(v.URI.revive(j),Y,Z,me),void 0,me)}$handleInlineCompletionDidShow(F,j,Y,Z){this._withAdapter(F,ce,async me=>{me.handleDidShowCompletionItem(j,Y,Z)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,j,Y,Z){this._withAdapter(F,ce,async me=>{me.handlePartialAccept(j,Y,Z)},void 0,void 0)}$freeInlineCompletionsList(F,j){this._withAdapter(F,ce,async Y=>{Y.disposeCompletions(j)},void 0,void 0)}registerSignatureHelpProvider(F,j,Y,Z){const me=Array.isArray(Z)?{triggerCharacters:Z,retriggerCharacters:[]}:Z,_e=this._addNewAdapter(new ge(this._documents,Y),F);return this._proxy.$registerSignatureHelpProvider(_e,this._transformDocumentSelector(j,F),me),this._createDisposable(_e)}$provideSignatureHelp(F,j,Y,Z,me){return this._withAdapter(F,ge,_e=>_e.provideSignatureHelp(v.URI.revive(j),Y,Z,me),void 0,me)}$releaseSignatureHelp(F,j){this._withAdapter(F,ge,Y=>Y.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(F,j,Y){const Z=typeof Y.onDidChangeInlayHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new O(this._documents,this._commands.converter,Y,this._logService,F),F);this._proxy.$registerInlayHintsProvider(me,this._transformDocumentSelector(j,F),typeof Y.resolveInlayHint=="function",Z,se._extLabel(F));let _e=this._createDisposable(me);if(Z!==void 0){const fe=Y.onDidChangeInlayHints(ke=>this._proxy.$emitInlayHintsEvent(Z));_e=L.Disposable.from(_e,fe)}return _e}$provideInlayHints(F,j,Y,Z){return this._withAdapter(F,O,me=>me.provideInlayHints(v.URI.revive(j),Y,Z),void 0,Z)}$resolveInlayHint(F,j,Y){return this._withAdapter(F,O,Z=>Z.resolveInlayHint(j,Y),void 0,Y)}$releaseInlayHints(F,j){this._withAdapter(F,O,Y=>Y.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(F,j,Y){const Z=this._addNewAdapter(new K(this._documents,Y),F);return this._proxy.$registerDocumentLinkProvider(Z,this._transformDocumentSelector(j,F),typeof Y.resolveDocumentLink=="function"),this._createDisposable(Z)}$provideDocumentLinks(F,j,Y){return this._withAdapter(F,K,Z=>Z.provideLinks(v.URI.revive(j),Y),void 0,Y,j.scheme==="output")}$resolveDocumentLink(F,j,Y){return this._withAdapter(F,K,Z=>Z.resolveLink(j,Y),void 0,void 0,!0)}$releaseDocumentLinks(F,j){this._withAdapter(F,K,Y=>Y.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(F,j,Y){const Z=this._addNewAdapter(new we(this._documents,Y),F);return this._proxy.$registerDocumentColorProvider(Z,this._transformDocumentSelector(j,F)),this._createDisposable(Z)}$provideDocumentColors(F,j,Y){return this._withAdapter(F,we,Z=>Z.provideColors(v.URI.revive(j),Y),[],Y)}$provideColorPresentations(F,j,Y,Z){return this._withAdapter(F,we,me=>me.provideColorPresentations(v.URI.revive(j),Y,Z),void 0,Z)}registerFoldingRangeProvider(F,j,Y){const Z=this._nextHandle(),me=typeof Y.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(Z,new le(new Ce(this._documents,Y),F)),this._proxy.$registerFoldingRangeProvider(Z,this._transformDocumentSelector(j,F),F.identifier,me);let _e=this._createDisposable(Z);if(me!==void 0){const fe=Y.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));_e=L.Disposable.from(_e,fe)}return _e}$provideFoldingRanges(F,j,Y,Z){return this._withAdapter(F,Ce,me=>me.provideFoldingRanges(v.URI.revive(j),Y,Z),void 0,Z)}registerSelectionRangeProvider(F,j,Y){const Z=this._addNewAdapter(new ee(this._documents,Y,this._logService),F);return this._proxy.$registerSelectionRangeProvider(Z,this._transformDocumentSelector(j,F)),this._createDisposable(Z)}$provideSelectionRanges(F,j,Y,Z){return this._withAdapter(F,ee,me=>me.provideSelectionRanges(v.URI.revive(j),Y,Z),[],Z)}registerCallHierarchyProvider(F,j,Y){const Z=this._addNewAdapter(new te(this._documents,Y),F);return this._proxy.$registerCallHierarchyProvider(Z,this._transformDocumentSelector(j,F)),this._createDisposable(Z)}$prepareCallHierarchy(F,j,Y,Z){return this._withAdapter(F,te,me=>Promise.resolve(me.prepareSession(v.URI.revive(j),Y,Z)),void 0,Z)}$provideCallHierarchyIncomingCalls(F,j,Y,Z){return this._withAdapter(F,te,me=>me.provideCallsTo(j,Y,Z),void 0,Z)}$provideCallHierarchyOutgoingCalls(F,j,Y,Z){return this._withAdapter(F,te,me=>me.provideCallsFrom(j,Y,Z),void 0,Z)}$releaseCallHierarchy(F,j){this._withAdapter(F,te,Y=>Promise.resolve(Y.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(F,j,Y){const Z=this._addNewAdapter(new ue(this._documents,Y),F);return this._proxy.$registerTypeHierarchyProvider(Z,this._transformDocumentSelector(j,F)),this._createDisposable(Z)}$prepareTypeHierarchy(F,j,Y,Z){return this._withAdapter(F,ue,me=>Promise.resolve(me.prepareSession(v.URI.revive(j),Y,Z)),void 0,Z)}$provideTypeHierarchySupertypes(F,j,Y,Z){return this._withAdapter(F,ue,me=>me.provideSupertypes(j,Y,Z),void 0,Z)}$provideTypeHierarchySubtypes(F,j,Y,Z){return this._withAdapter(F,ue,me=>me.provideSubtypes(j,Y,Z),void 0,Z)}$releaseTypeHierarchy(F,j){this._withAdapter(F,ue,Y=>Promise.resolve(Y.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(F,j,Y,Z){const me=this._nextHandle();return this._adapter.set(me,new le(new Q(this._proxy,this._documents,Y,me,F),F)),this._proxy.$registerDocumentOnDropEditProvider(me,this._transformDocumentSelector(j,F),(0,_.isProposedApiEnabled)(F,"dropMetadata")?Z:void 0),this._createDisposable(me)}$provideDocumentOnDropEdits(F,j,Y,Z,me,_e){return this._withAdapter(F,Q,fe=>Promise.resolve(fe.provideDocumentOnDropEdits(j,v.URI.revive(Y),Z,me,_e)),void 0,void 0)}registerDocumentPasteEditProvider(F,j,Y,Z){const me=this._nextHandle();return this._adapter.set(me,new le(new z(this._proxy,this._documents,Y,me,F),F)),this._proxy.$registerPasteEditProvider(me,this._transformDocumentSelector(j,F),{supportsCopy:!!Y.prepareDocumentPaste,supportsPaste:!!Y.provideDocumentPasteEdits,copyMimeTypes:Z.copyMimeTypes,pasteMimeTypes:Z.pasteMimeTypes}),this._createDisposable(me)}$prepareDocumentPaste(F,j,Y,Z,me){return this._withAdapter(F,z,_e=>_e.prepareDocumentPaste(v.URI.revive(j),Y,Z,me),void 0,me)}$providePasteEdits(F,j,Y,Z,me,_e){return this._withAdapter(F,z,fe=>fe.providePasteEdits(j,v.URI.revive(Y),Z,me,_e),void 0,_e)}static _serializeRegExp(F){return{pattern:F.source,flags:(0,y.regExpFlags)(F)}}static _serializeIndentationRule(F){return{decreaseIndentPattern:se._serializeRegExp(F.decreaseIndentPattern),increaseIndentPattern:se._serializeRegExp(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?se._serializeRegExp(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?se._serializeRegExp(F.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(F){return{beforeText:se._serializeRegExp(F.beforeText),afterText:F.afterText?se._serializeRegExp(F.afterText):void 0,previousLineText:F.previousLineText?se._serializeRegExp(F.previousLineText):void 0,action:F.action}}static _serializeOnEnterRules(F){return F.map(se._serializeOnEnterRule)}setLanguageConfiguration(F,j,Y){const{wordPattern:Z}=Y;if(Z&&(0,y.regExpLeadsToEndlessLoop)(Z))throw new Error(`Invalid language configuration: wordPattern '${Z}' is not allowed to match the empty string.`);Z?this._documents.setWordDefinitionFor(j,Z):this._documents.setWordDefinitionFor(j,void 0),Y.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),Y.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const me=this._nextHandle(),_e={comments:Y.comments,brackets:Y.brackets,wordPattern:Y.wordPattern?se._serializeRegExp(Y.wordPattern):void 0,indentationRules:Y.indentationRules?se._serializeIndentationRule(Y.indentationRules):void 0,onEnterRules:Y.onEnterRules?se._serializeOnEnterRules(Y.onEnterRules):void 0,__electricCharacterSupport:Y.__electricCharacterSupport,__characterPairSupport:Y.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,j,_e),this._createDisposable(me)}$setWordDefinitions(F){for(const j of F)this._documents.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.ExtHostLanguageFeatures=se,se._handlePool=0}),define(De[292],Ie([1,0,6,15,7,40,17,4]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(A,k,w,D){this._documents=k,this._commands=w,this._uriTransformer=D,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=A.getProxy(v.MainContext.MainThreadLanguages)}$acceptLanguageIds(A){this._languageIds=A}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(A,k){await this._proxy.$changeLanguage(A,k);const w=this._documents.getDocumentData(A);if(!w)throw new Error(`document '${A.toString()}' NOT found`);return w.document}async tokenAtPosition(A,k){const w=A.version,D=T.Position.from(k),I=await this._proxy.$tokensAtPosition(A.uri,D),E={type:d.StandardTokenType.Other,range:A.getWordRangeAtPosition(k)??new d.Range(k.line,k.character,k.line,k.character)};if(!I)return E;const i={range:T.Range.to(I.range),type:T.TokenType.to(I.type)};return!i.range.contains(k)||w!==A.version?E:i}createLanguageStatusItem(A,k,w){const D=this._handlePool++,I=this._proxy,E=this._ids,i=`${A.identifier.value}/${k}`;if(E.has(i))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);E.add(i);const l={selector:w,id:k,name:A.displayName??A.name,severity:d.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const b=new g.DisposableStore,f=()=>{a?.dispose(),a=(0,R.disposableTimeout)(()=>{b.clear(),this._proxy.$setLanguageStatus(D,{id:i,name:l.name??A.displayName??A.name,source:A.displayName??A.name,selector:T.DocumentSelector.from(l.selector,this._uriTransformer),label:l.text,detail:l.detail??"",severity:l.severity===d.LanguageStatusSeverity.Error?L.default.Error:l.severity===d.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:l.command&&this._commands.toInternal(l.command,b),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},_={dispose(){b.dispose(),a?.dispose(),I.$removeLanguageStatus(D),E.delete(i)},get id(){return l.id},get name(){return l.name},set name(n){l.name=n,f()},get selector(){return l.selector},set selector(n){l.selector=n,f()},get text(){return l.text},set text(n){l.text=n,f()},get detail(){return l.detail},set detail(n){l.detail=n,f()},get severity(){return l.severity},set severity(n){l.severity=n,f()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(n){l.accessibilityInformation=n,f()},get command(){return l.command},set command(n){l.command=n,f()},get busy(){return l.busy},set busy(n){l.busy=n,f()}};return f(),_}}e.ExtHostLanguages=y}),define(De[106],Ie([1,0,10,9,2,5,18,6,26,20]),function(re,e,v,T,d,L,R,g,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let A=e.ExtHostLocalizationService=class{constructor(w,D,I){this.logService=I,this.bundleCache=new Map,this._proxy=D.getProxy(g.MainContext.MainThreadLocalization),this.currentLanguage=w.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===v.LANGUAGE_DEFAULT}getMessage(w,D){const{message:I,args:E,comment:i}=D;if(this.isDefaultLanguage)return(0,T.format2)(I,E??{});let l=I;i&&i.length>0&&(l+=`/${Array.isArray(i)?i.join(""):i}`);const a=this.bundleCache.get(w)?.contents[l];return a||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,T.format2)(a??I,E??{})}getBundle(w){return this.bundleCache.get(w)?.contents}getBundleUri(w){return this.bundleCache.get(w)?.uri}async initializeLocalizedMessages(w){if(this.isDefaultLanguage||!w.l10n&&!w.isBuiltin||this.bundleCache.has(w.identifier.value))return;let D;const I=await this.getBundleLocation(w);if(!I){this.logService.error(`No bundle location found for extension ${w.identifier.value}`);return}try{const E=await this._proxy.$fetchBundleContents(I),i=JSON.parse(E);D=w.isBuiltin?i.contents?.bundle:i}catch(E){this.logService.error(`Failed to load translations for ${w.identifier.value} from ${I}: ${E.message}`);return}D&&this.bundleCache.set(w.identifier.value,{contents:D,uri:I})}async getBundleLocation(w){if(w.isBuiltin){const D=await this._proxy.$fetchBuiltInBundleUri(w.identifier.value,this.currentLanguage);return d.URI.revive(D)}return w.l10n?d.URI.joinPath(w.extensionLocation,w.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=A=Ve([ze(0,y.IExtHostInitDataService),ze(1,m.IExtHostRpcService),ze(2,R.ILogService)],A),e.IExtHostLocalizationService=(0,L.createDecorator)("IExtHostLocalizationService")}),define(De[143],Ie([1,0,18,6,26,20,2,73]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=e.ExtHostLoggerService=class extends v.AbstractLoggerService{constructor(k,w){super(w.logLevel,w.logsLocation,w.loggers.map(D=>(0,g.revive)(D))),this._proxy=k.getProxy(T.MainContext.MainThreadLogger)}$setLogLevel(k,w){w?this.setLogLevel(R.URI.revive(w),k):this.setLogLevel(k)}setVisibility(k,w){super.setVisibility(k,w),this._proxy.$setVisibility(k,w)}doCreateLogger(k,w,D){return new m(this._proxy,k,w,D)}};e.ExtHostLoggerService=y=Ve([ze(0,L.IExtHostRpcService),ze(1,d.IExtHostInitDataService)],y);class m extends v.AbstractMessageLogger{constructor(k,w,D,I){super(I?.logLevel==="always"),this.proxy=k,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(D),this.proxy.$createLogger(w,I).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(k,w){const D=[[k,w]];this.isLoggerCreated?this.doLog(D):this.buffer.push(...D)}doLog(k){this.proxy.$log(this.file,k)}flush(){this.proxy.$flush(this.file)}}}),define(De[107],Ie([1,0,6,5,4,20,22]),function(re,e,v,T,d,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,T.createDecorator)("IExtHostManagedSockets");let g=e.ExtHostManagedSockets=class{constructor(k){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=k.getProxy(v.MainContext.MainThreadManagedSockets)}setFactory(k,w){for(const D of this._managedRemoteSockets.values())D.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new y(k,w),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(k){if(!this._factory||this._factory.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const w=++this._remoteSocketIdCounter,D=await this._factory.makeConnection(),I=new d.DisposableStore;return this._managedRemoteSockets.set(w,new m(w,D,I)),I.add((0,d.toDisposable)(()=>this._managedRemoteSockets.delete(w))),I.add(D.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(w),I.dispose()})),I.add(D.onDidClose(E=>{this._proxy.$onDidManagedSocketClose(w,E?.stack??E?.message),I.dispose()})),I.add(D.onDidReceiveMessage(E=>this._proxy.$onDidManagedSocketHaveData(w,R.VSBuffer.wrap(E)))),w}$remoteSocketWrite(k,w){this._managedRemoteSockets.get(k)?.actual.send(w.buffer)}$remoteSocketEnd(k){const w=this._managedRemoteSockets.get(k);w&&(w.actual.end(),w.dispose())}async $remoteSocketDrain(k){await this._managedRemoteSockets.get(k)?.actual.drain?.()}};e.ExtHostManagedSockets=g=Ve([ze(0,L.IExtHostRpcService)],g);class y{constructor(k,w){this.socketFactoryId=k,this.makeConnection=w}}class m extends d.Disposable{constructor(k,w,D){super(),this.socketId=k,this.actual=w,this._register(D)}}}),define(De[293],Ie([1,0,6,18,27]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(g){return g&&g.title}let R=e.ExtHostMessageService=class{constructor(y,m){this._logService=m,this._proxy=y.getProxy(v.MainContext.MainThreadMessageService)}showMessage(y,m,A,k,w){const D={source:{identifier:y.identifier,label:y.displayName||y.name}};let I;typeof k=="string"||L(k)?I=[k,...w]:(D.modal=k?.modal,D.useCustom=k?.useCustom,D.detail=k?.detail,I=w),D.useCustom&&(0,d.checkProposedApiEnabled)(y,"resolvers");const E=[];for(let i=0;i<I.length;i++){const l=I[i];if(typeof l=="string")E.push({title:l,handle:i,isCloseAffordance:!1});else if(typeof l=="object"){const{title:a,isCloseAffordance:b}=l;E.push({title:a,isCloseAffordance:!!b,handle:i})}else this._logService.warn("Invalid message item:",l)}return this._proxy.$showMessage(m,A,D,E).then(i=>{if(typeof i=="number")return I[i]})}};e.ExtHostMessageService=R=Ve([ze(1,T.ILogService)],R)}),define(De[294],Ie([1,0,22,3,4,28,9,12,2,30,80,6,36,15,7,61,261,138,8,23,24]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l,a,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class _{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}constructor(o,s,t,u,p){this._textDocumentsAndEditors=t,this._textDocuments=u,this._extHostFileSystem=p,this._notebookStatusBarItemProviders=new Map,this._documents=new L.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new T.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new A.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=o.getProxy(k.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(k.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(k.MainContext.MainThreadNotebookEditors),this._commandsConverter=s.converter,s.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===13){const C=h.notebookEditor?.notebookUri,S=h.cell.handle,r=this._documents.get(C)?.getCell(S);if(r)return r.apiCell}if(h&&h.$mid===14){const C=h.uri,S=this._documents.get(C);if(S)return S.apiNotebook}return h}}),_._registerApiCommands(s)}getEditorById(o){const s=this._editors.get(o);if(!s)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return s}getIdByEditor(o){for(const[s,t]of this._editors)if(t.apiEditor===o)return s}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,s){const t=this._documents.get(o);if(!t&&!s)throw new Error(`NO notebook document for '${o}'`);return t}static _convertNotebookRegistrationData(o,s){if(!s)return;const t=s.filenamePattern.map(u=>D.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(s.filenamePattern&&!t){console.warn(`Notebook content provider view options file name pattern is invalid ${s.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:s.displayName,filenamePattern:t,exclusive:s.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,s,t){const u=_._notebookStatusBarItemProviderHandlePool++,p=typeof t.onDidChangeCellStatusBarItems=="function"?_._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(u,t),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(u,p,s);let h;return p!==void 0&&(h=t.onDidChangeCellStatusBarItems(C=>this._notebookProxy.$emitCellStatusBarEvent(p))),new I.Disposable(()=>{this._notebookStatusBarItemProviders.delete(u),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(u,p),h?.dispose()})}async createNotebookDocument(o){const s=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&D.NotebookData.from(o.content)});return y.URI.revive(s)}async openNotebookDocument(o){const s=this._documents.get(o);if(s)return s.apiNotebook;const t=await this._notebookDocumentsProxy.$tryOpenNotebook(o),u=this._documents.get(y.URI.revive(t));return(0,g.assertIsDefined)(u?.apiNotebook)}async showNotebookDocument(o,s){y.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let t;typeof s=="object"?t={position:D.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(D.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:t={preserveFocus:!1};const u=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,t),p=u&&this._editors.get(u)?.apiEditor;if(p)return p;throw u?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,s,t,u){const p=this._notebookStatusBarItemProviders.get(o),h=y.URI.revive(s),C=this._documents.get(h);if(!C||!p)return;const S=C.getCellFromIndex(t);if(!S)return;const c=await p.provideCellStatusBarItems(S.apiCell,u);if(!c)return;const r=new d.DisposableStore,P=this._statusBarCache.add([r]),W=(Array.isArray(c)?c:[c]).map($=>D.NotebookStatusBarItem.from($,this._commandsConverter,r));return{cacheId:P,items:W}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,s,t,u,p){if((0,R.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");const h=this._handlePool++;return this._notebookSerializer.set(h,{viewType:s,serializer:t,options:u}),this._notebookProxy.$registerNotebookSerializer(h,{id:o.identifier,location:o.extensionLocation},s,D.NotebookDocumentContentOptions.from(u),_._convertNotebookRegistrationData(o,p)),(0,d.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(h)})}async $dataToNotebook(o,s,t){const u=this._notebookSerializer.get(o);if(!u)throw new Error("NO serializer found");const p=await u.serializer.deserializeNotebook(s.buffer,t);return new E.SerializableObjectWithBuffers(D.NotebookData.from(p))}async $notebookToData(o,s,t){const u=this._notebookSerializer.get(o);if(!u)throw new Error("NO serializer found");const p=await u.serializer.serializeNotebook(D.NotebookData.to(s.value),t);return v.VSBuffer.wrap(p)}async $saveNotebook(o,s,t,u,p){const h=y.URI.revive(s),C=this._notebookSerializer.get(o);if(!C)throw new Error("NO serializer found");const S=this._documents.get(h);if(!S)throw new Error("Document NOT found");if(S.versionId!==t)throw new Error("Document version mismatch");const c={metadata:(0,f.filter)(S.apiNotebook.metadata,W=>!(C.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of S.apiNotebook.getCells()){const $=new I.NotebookCellData(W.kind,W.document.getText(),W.document.languageId,W.mime,C.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);$.metadata=(0,f.filter)(W.metadata,z=>!(C.options?.transientCellMetadata??{})[z]),c.cells.push($)}const r=await C.serializer.serializeNotebook(c,p);await this._extHostFileSystem.value.writeFile(h,r);const P=await this._extHostFileSystem.value.stat(h);return{name:(0,b.basename)(h),isFile:(P.type&m.FileType.File)!==0,isDirectory:(P.type&m.FileType.Directory)!==0,isSymbolicLink:(P.type&m.FileType.SymbolicLink)!==0,mtime:P.mtime,ctime:P.ctime,size:P.size,readonly:!!((P.permissions??0)&m.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(h.scheme),locked:!!((P.permissions??0)&m.FilePermission.Locked),etag:m.etag({mtime:P.mtime,size:P.size}),children:void 0}}_createExtHostEditor(o,s,t){if(this._editors.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const u=new l.ExtHostNotebookEditor(s,this._notebookEditorsProxy,o,t.visibleRanges.map(D.NotebookRange.to),t.selections.map(D.NotebookRange.to),typeof t.viewColumn=="number"?D.ViewColumn.to(t.viewColumn):void 0);this._editors.set(s,u)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const t of o.value.removedDocuments){const u=y.URI.revive(t),p=this._documents.get(u);p&&(p.dispose(),this._documents.delete(u),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(h=>h.document.uri)}),this._onDidCloseNotebookDocument.fire(p.apiNotebook));for(const h of this._editors.values())h.notebookData.uri.toString()===u.toString()&&this._editors.delete(h.id)}if(o.value.addedDocuments){const t=[];for(const u of o.value.addedDocuments){const p=y.URI.revive(u.uri);if(this._documents.has(p))throw new Error(`adding EXISTING notebook ${p} `);const h=new i.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,p,u);t.push(...u.cells.map(C=>i.ExtHostCell.asModelAddData(h.apiNotebook,C))),this._documents.get(p)?.dispose(),this._documents.set(p,h),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:t}),this._onDidOpenNotebookDocument.fire(h.apiNotebook)}}if(o.value.addedEditors)for(const t of o.value.addedEditors){if(this._editors.has(t.id))return;const u=y.URI.revive(t.documentUri),p=this._documents.get(u);p&&this._createExtHostEditor(p,t.id,t)}const s=[];if(o.value.removedEditors)for(const t of o.value.removedEditors){const u=this._editors.get(t);u&&(this._editors.delete(t),this._activeNotebookEditor?.id===u.id&&(this._activeNotebookEditor=void 0),s.push(u))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(u=>this._editors.get(u)).filter(u=>!!u);const t=new Set;this._visibleNotebookEditors.forEach(u=>t.add(u.id));for(const u of this._editors.values()){const p=t.has(u.id);u._acceptVisibility(p)}this._visibleNotebookEditors=[...this._editors.values()].map(u=>u).filter(u=>u.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._editors.get(o.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${o.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(o){const s=w.ApiCommandArgument.String.with("notebookType","A notebook type"),t=new w.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[s,new w.ApiCommandArgument("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>v.VSBuffer.wrap(p))],new w.ApiCommandResult("Notebook Data",p=>D.NotebookData.to(p.value))),u=new w.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[s,new w.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new E.SerializableObjectWithBuffers(D.NotebookData.from(p)))],new w.ApiCommandResult("Bytes",p=>p.buffer));o.registerApiCommand(t),o.registerApiCommand(u)}}e.ExtHostNotebookController=_,_._notebookStatusBarItemProviderHandlePool=0}),define(De[295],Ie([1,0,19,17,21,3,4,28,2,25,18,80,6,36,15,7,104,255,27,61]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let f=e.ExtHostNotebookKernels=class{constructor(h,C,S,c,r){this._initData=C,this._extHostNotebook=S,this._commands=c,this._logService=r,this._activeExecutions=new g.ResourceMap,this._activeNotebookExecutions=new g.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new k.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=h.getProxy(w.MainContext.MainThreadNotebookKernels);const P=new D.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new D.ApiCommandArgument("options","Select kernel options",M=>!0,M=>{if(M&&"notebookEditor"in M&&"id"in M){const W=this._extHostNotebook.getIdByEditor(M.notebookEditor);return{id:M.id,extension:M.extension,notebookEditorId:W}}else if(M&&"notebookEditor"in M){const W=this._extHostNotebook.getIdByEditor(M.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${M.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return M})],D.ApiCommandResult.Void);this._commands.registerApiCommand(P)}createNotebookController(h,C,S,c,r,P){for(const be of this._kernelData.values())if(be.controller.id===C&&m.ExtensionIdentifier.equals(h.identifier,be.extensionId))throw new Error(`notebook controller with id '${C}' ALREADY exist`);const M=this._handlePool++,W=this;this._logService.trace(`NotebookController[${M}], CREATED by ${h.identifier.value}, ${C}`);const $=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${h.identifier}'`);let z=!1;const N=new R.DisposableStore,q=new L.Emitter,x=new L.Emitter,U={id:u(h.identifier,C),notebookType:S,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:c||h.identifier.value,preloads:P?P.map(I.NotebookRendererScript.from):[]};let de=r??$,ie;this._proxy.$addKernel(M,U).catch(be=>{console.log(be),z=!0});let ne=0;const H=()=>{if(z)return;const be=++ne;Promise.resolve().then(()=>{be===ne&&this._proxy.$updateKernel(M,U)})},V=new g.ResourceMap,ce={get id(){return C},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:q.event,get label(){return U.label},set label(be){U.label=be??h.displayName??h.name,H()},get detail(){return U.detail??""},set detail(be){U.detail=be,H()},get description(){return U.description??""},set description(be){U.description=be,H()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(be){U.supportedLanguages=be,H()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(be){U.supportsExecutionOrder=be,H()},get rendererScripts(){return U.preloads?U.preloads.map(I.NotebookRendererScript.to):[]},get executeHandler(){return de},set executeHandler(be){de=be??$},get interruptHandler(){return ie},set interruptHandler(be){ie=be,U.supportsInterrupt=!!be,H()},createNotebookCellExecution(be){if(z)throw new Error("notebook controller is DISPOSED");if(!V.has(be.notebook.uri))throw W._logService.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${be.notebook.uri.toString()}`);return W._createNotebookCellExecution(be,u(h.identifier,this.id))},createNotebookExecution(be){if((0,a.checkProposedApiEnabled)(h,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!V.has(be.uri))throw W._logService.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${be.uri.toString()}`);return W._createNotebookExecution(be,u(h.identifier,this.id))},dispose:()=>{z||(this._logService.trace(`NotebookController[${M}], DISPOSED`),z=!0,this._kernelData.delete(M),N.dispose(),q.dispose(),x.dispose(),this._proxy.$removeKernel(M))},updateNotebookAffinity(be,Se){Se===E.NotebookControllerAffinity2.Hidden&&(0,a.checkProposedApiEnabled)(h,"notebookControllerAffinityHidden"),W._proxy.$updateNotebookPriority(M,be.uri,Se)},onDidReceiveMessage:x.event,postMessage(be,Se){return(0,a.checkProposedApiEnabled)(h,"notebookMessaging"),W._proxy.$postMessage(M,Se&&W._extHostNotebook.getIdByEditor(Se),be)},asWebviewUri(be){return(0,a.checkProposedApiEnabled)(h,"notebookMessaging"),(0,i.asWebviewUri)(be,W._initData.remote)}};return this._kernelData.set(M,{extensionId:h.identifier,controller:ce,onDidReceiveMessage:x,onDidChangeSelection:q,associatedNotebooks:V}),ce}getIdByController(h){for(const[C,S]of this._kernelData)if(S.controller===h)return u(S.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,C){const S=this._kernelDetectionTaskHandlePool++,c=this;this._logService.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${h.identifier.value}`),this._proxy.$addKernelDetectionTask(S,C);const r={dispose:()=>{this._kernelDetectionTask.delete(S),c._proxy.$removeKernelDetectionTask(S)}};return this._kernelDetectionTask.set(S,r),r}registerKernelSourceActionProvider(h,C,S){const c=this._kernelSourceActionProviderHandlePool++,r=typeof S.onDidChangeNotebookKernelSourceActions=="function"?c:void 0,P=this;this._kernelSourceActionProviders.set(c,S),this._logService.trace(`NotebookKernelSourceActionProvider[${c}], CREATED by ${h.identifier.value}`),this._proxy.$addKernelSourceActionProvider(c,c,C);let M;return r!==void 0&&(M=S.onDidChangeNotebookKernelSourceActions(W=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(r))),{dispose:()=>{this._kernelSourceActionProviders.delete(c),P._proxy.$removeKernelSourceActionProvider(c,c),M?.dispose()}}}async $provideKernelSourceActions(h,C){const S=this._kernelSourceActionProviders.get(h);if(S){const c=new R.DisposableStore;return this._kernelSourceActionProviderCache.add([c]),(await S.provideNotebookKernelSourceActions(C)??[]).map(P=>I.NotebookKernelSourceAction.from(P,this._commands.converter,c))}return[]}$acceptNotebookAssociation(h,C,S){const c=this._kernelData.get(h);if(c){const r=this._extHostNotebook.getNotebookDocument(y.URI.revive(C));S?c.associatedNotebooks.set(r.uri,!0):c.associatedNotebooks.delete(r.uri),this._logService.trace(`NotebookController[${h}] ASSOCIATE notebook`,r.uri.toString(),S),c.onDidChangeSelection.fire({selected:S,notebook:r.apiNotebook})}}async $executeCells(h,C,S){const c=this._kernelData.get(h);if(!c)return;const r=this._extHostNotebook.getNotebookDocument(y.URI.revive(C)),P=[];for(const M of S){const W=r.getCell(M);W&&P.push(W.apiCell)}try{this._logService.trace(`NotebookController[${h}] EXECUTE cells`,r.uri.toString(),P.length),await c.controller.executeHandler.call(c.controller,P,r.apiNotebook,c.controller)}catch(M){this._logService.error(`NotebookController[${h}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(h,C,S){const c=this._kernelData.get(h);if(!c)return;const r=this._extHostNotebook.getNotebookDocument(y.URI.revive(C));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,r.apiNotebook);else for(const P of S){const M=r.getCell(P);M&&this._activeExecutions.get(M.uri)?.cancel()}if(c.controller.interruptHandler){const P=this._activeNotebookExecutions.get(r.uri);S.length&&Array.isArray(P)&&P.length&&P.forEach(M=>M.dispose())}}$acceptKernelMessageFromRenderer(h,C,S){const c=this._kernelData.get(h);if(!c)return;const r=this._extHostNotebook.getEditorById(C);c.onDidReceiveMessage.fire(Object.freeze({editor:r.apiEditor,message:S}))}$cellExecutionChanged(h,C,S){const r=this._extHostNotebook.getNotebookDocument(y.URI.revive(h)).getCell(C);if(r){const P=S?I.NotebookCellExecutionState.to(S):E.NotebookCellExecutionState.Idle;P!==void 0&&this._onDidChangeCellExecutionState.fire({cell:r.apiCell,state:P})}}_createNotebookCellExecution(h,C){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const r=new n(C,c,this._proxy);this._activeExecutions.set(c.uri,r);const P=r.onDidChangeState(()=>{r.state===_.Resolved&&(r.dispose(),P.dispose(),this._activeExecutions.delete(c.uri))});return r.asApiObject()}_createNotebookExecution(h,C){const S=this._extHostNotebook.getNotebookDocument(h.uri),c=h.getCells().find(M=>{const W=S.getCellFromApiCell(M);return W&&this._activeExecutions.has(W.uri)});if(c)throw new Error(`duplicate cell execution for ${c.document.uri}`);if(this._activeNotebookExecutions.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const r=new s(C,S,this._proxy),P=r.onDidChangeState(()=>{r.state===o.Resolved&&(r.dispose(),P.dispose(),this._activeNotebookExecutions.delete(S.uri))});return this._activeNotebookExecutions.set(S.uri,[r,P]),r.asApiObject()}};e.ExtHostNotebookKernels=f=Ve([ze(4,A.ILogService)],f);var _;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(_||(_={}));class n extends R.Disposable{get state(){return this._state}constructor(h,C,S){super(),this._cell=C,this._proxy=S,this._handle=n.HANDLE++,this._onDidChangeState=new L.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=_.Init,this._tokenSource=this._register(new d.CancellationTokenSource),this._collector=new t(10,c=>this.update(c)),this._executionOrder=C.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,h,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(h){await this._collector.addItem(h)}async update(h){const C=Array.isArray(h)?h:[h];return this._proxy.$updateExecution(this._handle,new b.SerializableObjectWithBuffers(C))}verifyStateForOutput(){if(this._state===_.Init)throw new Error("Must call start before modifying cell output");if(this._state===_.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(h){let C=this._cell;if(h&&(C=this._cell.notebook.getCellFromApiCell(h)),!C)throw new Error("INVALID cell");return C.handle}validateAndConvertOutputs(h){return h.map(C=>{const S=E.NotebookCellOutput.ensureUniqueMimeTypes(C.items,!0);return S===C.items?I.NotebookCellOutput.from(C):I.NotebookCellOutput.from({items:S,id:C.id,metadata:C.metadata})})}async updateOutputs(h,C,S){const c=this.cellIndexToHandle(C),r=this.validateAndConvertOutputs((0,v.asArray)(h));return this.updateSoon({editType:l.CellExecutionUpdateType.Output,cellHandle:c,append:S,outputs:r})}async updateOutputItems(h,C,S){return h=E.NotebookCellOutput.ensureUniqueMimeTypes((0,v.asArray)(h),!0),this.updateSoon({editType:l.CellExecutionUpdateType.OutputItems,items:h.map(I.NotebookCellOutputItem.from),outputId:C.id,append:S})}asApiObject(){const h=this;return Object.freeze({get token(){return h._tokenSource.token},get cell(){return h._cell.apiCell},get executionOrder(){return h._executionOrder},set executionOrder(S){h._executionOrder=S,h.update([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:h._executionOrder}])},start(S){if(h._state===_.Resolved||h._state===_.Started)throw new Error("Cannot call start again");h._state=_.Started,h._onDidChangeState.fire(),h.update({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,c){if(h._state===_.Resolved)throw new Error("Cannot call resolve twice");h._state=_.Resolved,h._onDidChangeState.fire(),h._collector.flush(),h._proxy.$completeExecution(h._handle,new b.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:S}))},clearOutput(S){return h.verifyStateForOutput(),h.updateOutputs([],S,!1)},appendOutput(S,c){return h.verifyStateForOutput(),h.updateOutputs(S,c,!0)},replaceOutput(S,c){return h.verifyStateForOutput(),h.updateOutputs(S,c,!1)},appendOutputItems(S,c){return h.verifyStateForOutput(),h.updateOutputItems(S,c,!0)},replaceOutputItems(S,c){return h.verifyStateForOutput(),h.updateOutputItems(S,c,!1)}})}}n.HANDLE=0;var o;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(o||(o={}));class s extends R.Disposable{get state(){return this._state}constructor(h,C,S){super(),this._notebook=C,this._proxy=S,this._handle=s.HANDLE++,this._onDidChangeState=new L.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new d.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,h,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===o.Resolved||this._state===o.Started)throw new Error("Cannot call start again");this._state=o.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===o.Resolved)throw new Error("Cannot call resolve twice");this._state=o.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}s.HANDLE=0;class t{constructor(h,C){this.delay=h,this.callback=C,this.batch=[],this.startedTimer=Date.now()}addItem(h){return this.batch.push(h),this.currentDeferred||(this.currentDeferred=new T.DeferredPromise,this.startedTimer=Date.now(),(0,T.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const h=this.currentDeferred;this.currentDeferred=void 0;const C=this.batch;return this.batch=[],this.callback(C).finally(()=>h.complete())}}function u(p,h){return`${p.value}/${h}`}e.createKernelId=u}),define(De[296],Ie([1,0,3,6,138]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(g,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=g.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(g,y,m){const A=this._extHostNotebook.getEditorById(g);this._rendererMessageEmitters.get(y)?.fire({editor:A.apiEditor,message:m})}createRendererMessaging(g,y){if(!g.contributes?.notebookRenderer?.some(A=>A.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(A,k,w)=>this.getOrCreateEmitterFor(y).event(A,k,w),postMessage:(A,k)=>{d.ExtHostNotebookEditor.apiEditorsToExtHost.has(A)&&([A,k]=[k,A]);const w=k&&d.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.proxy.$postMessage(w?.id,y,A)}}}getOrCreateEmitterFor(g){let y=this._rendererMessageEmitters.get(g);return y||(y=new v.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this._rendererMessageEmitters.delete(g)}}),this._rendererMessageEmitters.set(g,y),y)}}e.ExtHostNotebookRenderers=L}),define(De[297],Ie([1,0,4,12,2,27,6]),function(re,e,v,T,d,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class g{constructor(m){this.handlers=new Map,this.proxy=m.getProxy(R.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(m,A,k){if((0,L.checkProposedApiEnabled)(m,"profileContentHandlers"),this.handlers.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.handlers.set(A,k),this.proxy.$registerProfileContentHandler(A,k.name,k.description,m.identifier.value),(0,v.toDisposable)(()=>{this.handlers.delete(A),this.proxy.$unregisterProfileContentHandler(A)})}async $saveProfile(m,A,k,w){const D=this.handlers.get(m);if(!D)throw new Error(`Unknown handler with id: ${m}`);return D.saveProfile(A,k,w)}async $readProfile(m,A,k){const w=this.handlers.get(m);if(!w)throw new Error(`Unknown handler with id: ${m}`);return w.readProfile((0,T.isString)(A)?A:d.URI.revive(A),k)}}e.ExtHostProfileContentHandlers=g}),define(De[298],Ie([1,0,2,6,17,15]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class R{constructor(y,m){this.uriTransformer=m,this.providers=new Map,this.proxy=y.getProxy(T.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,m,A){const k=v.URI.revive(m),w=this.providers.get(y);return w?(0,d.asPromise)(()=>w.provideOriginalResource(k,A)).then(D=>D||null):Promise.resolve(null)}registerQuickDiffProvider(y,m,A,k){const w=R.handlePool++;return this.providers.set(w,m),this.proxy.$registerQuickDiffProvider(w,L.DocumentSelector.from(y,this.uriTransformer),A,k),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(w),this.providers.delete(w)}}}}e.ExtHostQuickDiff=R,R.handlePool=0}),define(De[299],Ie([1,0,21,3,4,6,2,7,8,19,40,55,27,15]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function I(E,i,l){const a=E.getProxy(L.MainContext.MainThreadQuickOpen);class b{constructor(h,C){this._sessions=new Map,this._instances=0,this._workspace=h,this._commands=C}showQuickPick(h,C,S,c=v.CancellationToken.None){this._onDidSelectItem=void 0;const r=Promise.resolve(C),P=++this._instances,M=a.$show(P,{title:S?.title,placeHolder:S?.placeHolder,matchOnDescription:S?.matchOnDescription,matchOnDetail:S?.matchOnDetail,ignoreFocusLost:S?.ignoreFocusOut,canPickMany:S?.canPickMany},c),W={},$=M.then(()=>W);return Promise.race([$,r]).then(z=>{if(z===W)return;const N=(0,w.isProposedApiEnabled)(h,"quickPickItemTooltip"),q=(0,w.isProposedApiEnabled)(h,"quickPickItemIcon");return r.then(x=>{const U=[];for(let de=0;de<x.length;de++){const ie=x[de];if(typeof ie=="string")U.push({label:ie,handle:de});else if(ie.kind===g.QuickPickItemKind.Separator)U.push({type:"separator",label:ie.label});else{ie.tooltip&&!N&&console.warn(`Extension '${h.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${h.identifier.value}`),ie.iconPath&&!q&&console.warn(`Extension '${h.identifier.value}' uses an icon which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${h.identifier.value}`);const ne=ie.iconPath&&q?s(ie.iconPath):void 0;U.push({label:ie.label,iconPath:ne?.iconPath,iconClass:ne?.iconClass,description:ie.description,detail:ie.detail,picked:ie.picked,alwaysShow:ie.alwaysShow,tooltip:N?D.MarkdownString.fromStrict(ie.tooltip):void 0,handle:de})}}return S&&typeof S.onDidSelectItem=="function"&&(this._onDidSelectItem=de=>{S.onDidSelectItem(x[de])}),a.$setItems(P,U),M.then(de=>{if(typeof de=="number")return x[de];if(Array.isArray(de))return de.map(ie=>x[ie])})})}).then(void 0,z=>{if(!(0,y.isCancellationError)(z))return a.$setError(P,z),Promise.reject(z)})}$onItemSelected(h){this._onDidSelectItem?.(h)}showInput(h,C=v.CancellationToken.None){return this._validateInput=h?.validateInput,a.$input(h,typeof this._validateInput=="function",C).then(void 0,S=>{if(!(0,y.isCancellationError)(S))return Promise.reject(S)})}async $validateInput(h){if(!this._validateInput)return;const C=await this._validateInput(h);if(!C||typeof C=="string")return C;let S;switch(C.severity){case g.InputBoxValidationSeverity.Info:S=A.default.Info;break;case g.InputBoxValidationSeverity.Warning:S=A.default.Warning;break;case g.InputBoxValidationSeverity.Error:S=A.default.Error;break;default:S=C.message?A.default.Error:A.default.Ignore;break}return{content:C.message,severity:S}}async showWorkspaceFolderPick(h,C=v.CancellationToken.None){const S=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[h]);if(!S)return;const c=await this._workspace.getWorkspaceFolders2();if(c)return c.find(r=>r.uri.toString()===S.uri.toString())}createQuickPick(h){const C=new t(h,()=>this._sessions.delete(C._id));return this._sessions.set(C._id,C),C}createInputBox(h){const C=new u(h,()=>this._sessions.delete(C._id));return this._sessions.set(C._id,C),C}$onDidChangeValue(h,C){this._sessions.get(h)?._fireDidChangeValue(C)}$onDidAccept(h){this._sessions.get(h)?._fireDidAccept()}$onDidChangeActive(h,C){const S=this._sessions.get(h);S instanceof t&&S._fireDidChangeActive(C)}$onDidChangeSelection(h,C){const S=this._sessions.get(h);S instanceof t&&S._fireDidChangeSelection(C)}$onDidTriggerButton(h,C){this._sessions.get(h)?._fireDidTriggerButton(C)}$onDidTriggerItemButton(h,C,S){const c=this._sessions.get(h);c instanceof t&&c._fireDidTriggerItemButton(C,S)}$onDidHide(h){this._sessions.get(h)?._fireDidHide()}}class f{constructor(h,C){this._extensionId=h,this._onDidDispose=C,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(h){this._title=h,this.update({title:h})}get step(){return this._steps}set step(h){this._steps=h,this.update({step:h})}get totalSteps(){return this._totalSteps}set totalSteps(h){this._totalSteps=h,this.update({totalSteps:h})}get enabled(){return this._enabled}set enabled(h){this._enabled=h,this.update({enabled:h})}get busy(){return this._busy}set busy(h){this._busy=h,this.update({busy:h})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(h){this._ignoreFocusOut=h,this.update({ignoreFocusOut:h})}get value(){return this._value}set value(h){this._value=h,this.update({value:h})}get placeholder(){return this._placeholder}set placeholder(h){this._placeholder=h,this.update({placeholder:h})}get buttons(){return this._buttons}set buttons(h){this._buttons=h.slice(),this._handlesToButtons.clear(),h.forEach((C,S)=>{const c=C===g.QuickInputButtons.Back?-1:S;this._handlesToButtons.set(c,C)}),this.update({buttons:h.map((C,S)=>({...s(C.iconPath),tooltip:C.tooltip,handle:C===g.QuickInputButtons.Back?-1:S}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(h){this._value=h,this._onDidChangeValueEmitter.fire(h)}_fireDidTriggerButton(h){const C=this._handlesToButtons.get(h);C&&this._onDidTriggerButtonEmitter.fire(C)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,d.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),a.$dispose(this._id))}update(h){if(!this._disposed){for(const C of Object.keys(h)){const S=h[C];this._pendingUpdate[C]=S===void 0?null:S}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){a.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}f._nextId=1;function _(p){if(p instanceof g.ThemeIcon)return{id:p.id};const h=o(p),C=n(p);return{dark:typeof h=="string"?R.URI.file(h):h,light:typeof C=="string"?R.URI.file(C):C}}function n(p){return typeof p=="object"&&"light"in p?p.light:p}function o(p){return typeof p=="object"&&"dark"in p?p.dark:p}function s(p){const h=_(p);let C,S;return"id"in h?S=k.ThemeIcon.asClassName(h):C=h,{iconPath:C,iconClass:S}}class t extends f{constructor(h,C){super(h.identifier,C),this.extension=h,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this._onDidTriggerItemButtonEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(h){this._items=h.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),h.forEach((r,P)=>{this._handlesToItems.set(P,r),this._itemsToHandles.set(r,P)});const C=(0,w.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),S=(0,w.isProposedApiEnabled)(this.extension,"quickPickItemIcon"),c=[];for(let r=0;r<h.length;r++){const P=h[r];if(P.kind===g.QuickPickItemKind.Separator)c.push({type:"separator",label:P.label});else{P.tooltip&&!C&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`),P.iconPath&&!S&&console.warn(`Extension '${this.extension.identifier.value}' uses an icon which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const M=P.iconPath&&S?s(P.iconPath):void 0;c.push({handle:r,label:P.label,iconPath:M?.iconPath,iconClass:M?.iconClass,description:P.description,detail:P.detail,picked:P.picked,alwaysShow:P.alwaysShow,tooltip:C?D.MarkdownString.fromStrict(P.tooltip):void 0,buttons:P.buttons?.map((W,$)=>({...s(W.iconPath),tooltip:W.tooltip,handle:$}))})}}this.update({items:c})}get canSelectMany(){return this._canSelectMany}set canSelectMany(h){this._canSelectMany=h,this.update({canSelectMany:h})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(h){this._matchOnDescription=h,this.update({matchOnDescription:h})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(h){this._matchOnDetail=h,this.update({matchOnDetail:h})}get sortByLabel(){return this._sortByLabel}set sortByLabel(h){this._sortByLabel=h,this.update({sortByLabel:h})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(h){this._keepScrollPosition=h,this.update({keepScrollPosition:h})}get activeItems(){return this._activeItems}set activeItems(h){this._activeItems=h.filter(C=>this._itemsToHandles.has(C)),this.update({activeItems:this._activeItems.map(C=>this._itemsToHandles.get(C))})}get selectedItems(){return this._selectedItems}set selectedItems(h){this._selectedItems=h.filter(C=>this._itemsToHandles.has(C)),this.update({selectedItems:this._selectedItems.map(C=>this._itemsToHandles.get(C))})}_fireDidChangeActive(h){const C=(0,m.coalesce)(h.map(S=>this._handlesToItems.get(S)));this._activeItems=C,this._onDidChangeActiveEmitter.fire(C)}_fireDidChangeSelection(h){const C=(0,m.coalesce)(h.map(S=>this._handlesToItems.get(S)));this._selectedItems=C,this._onDidChangeSelectionEmitter.fire(C)}_fireDidTriggerItemButton(h,C){const S=this._handlesToItems.get(h);if(!S||!S.buttons||!S.buttons.length)return;const c=S.buttons[C];c&&this._onDidTriggerItemButtonEmitter.fire({button:c,item:S})}}class u extends f{constructor(h,C){super(h.identifier,C),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(h){this._password=h,this.update({password:h})}get prompt(){return this._prompt}set prompt(h){this._prompt=h,this.update({prompt:h})}get valueSelection(){return this._valueSelection}set valueSelection(h){this._valueSelection=h,this.update({valueSelection:h})}get validationMessage(){return this._validationMessage}set validationMessage(h){this._validationMessage=h,h?typeof h=="string"?this.update({validationMessage:h,severity:A.default.Error}):this.update({validationMessage:h.message,severity:h.severity??A.default.Error}):this.update({validationMessage:void 0,severity:A.default.Ignore})}}return new b(i,l)}e.createExtHostQuickOpen=I});var Fe=this&&this.__classPrivateFieldGet||function(re,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!T:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(re):T?T.value:e.get(re)},Ye=this&&this.__classPrivateFieldSet||function(re,e,v,T,d){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!d)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!d:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?d.call(re,v):d?d.value=v:e.set(re,v),v};define(De[300],Ie([1,0,2,3,66,4,17,6,19,118,18,25,55,15,27,16]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E){"use strict";var i,l,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function b(c){if(c)return typeof c.iconPath=="string"?v.URI.file(c.iconPath):v.URI.isUri(c.iconPath)||w.ThemeIcon.isThemeIcon(c.iconPath)?c.iconPath:void 0}function f(c,r){if(!c.iconPath&&!r.iconPath)return 0;if(c.iconPath){if(!r.iconPath)return 1}else return-1;const P=typeof c.iconPath=="string"?c.iconPath:v.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id,M=typeof r.iconPath=="string"?r.iconPath:v.URI.isUri(r.iconPath)?r.iconPath.fsPath:r.iconPath.id;return(0,m.comparePaths)(P,M)}function _(c,r){let P=0;if(c.strikeThrough!==r.strikeThrough)return c.strikeThrough?1:-1;if(c.faded!==r.faded)return c.faded?1:-1;if(c.tooltip!==r.tooltip)return(c.tooltip||"").localeCompare(r.tooltip||"");if(P=f(c,r),P!==0)return P;if(c.light&&r.light)P=f(c.light,r.light);else{if(c.light)return 1;if(r.light)return-1}if(P!==0)return P;if(c.dark&&r.dark)P=f(c.dark,r.dark);else{if(c.dark)return 1;if(r.dark)return-1}return P}function n(c,r){if(c.command!==r.command)return c.command<r.command?-1:1;if(c.title!==r.title)return c.title<r.title?-1:1;if(c.tooltip!==r.tooltip){if(c.tooltip!==void 0&&r.tooltip!==void 0)return c.tooltip<r.tooltip?-1:1;if(c.tooltip!==void 0)return 1;if(r.tooltip!==void 0)return-1}if(c.arguments===r.arguments)return 0;if(c.arguments)if(r.arguments){if(c.arguments.length!==r.arguments.length)return c.arguments.length-r.arguments.length}else return 1;else return-1;for(let P=0;P<c.arguments.length;P++){const M=c.arguments[P],W=r.arguments[P];if(M!==W)return M<W?-1:1}return 0}function o(c,r){let P=(0,m.comparePaths)(c.resourceUri.fsPath,r.resourceUri.fsPath,!0);if(P!==0)return P;if(c.command&&r.command)P=n(c.command,r.command);else{if(c.command)return 1;if(r.command)return-1}if(P!==0)return P;if(c.decorations&&r.decorations)P=_(c.decorations,r.decorations);else{if(c.decorations)return 1;if(r.decorations)return-1}return P}function s(c,r){for(let P=0;P<c.length;P++)if(c[P]!==r[P])return!1;return!0}function t(c,r){return c.command===r.command&&c.title===r.title&&c.tooltip===r.tooltip&&(c.arguments&&r.arguments?s(c.arguments,r.arguments):c.arguments===r.arguments)}function u(c,r){return(0,y.equals)(c,r,t)}class p{get value(){return this._value}set value(r){r=r??"",Fe(this,i,"f").$setInputBoxValue(this._sourceControlHandle,r),this.updateValue(r)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(r){Fe(this,i,"f").$setInputBoxPlaceholder(this._sourceControlHandle,r),this._placeholder=r}get validateInput(){return(0,I.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(r){if((0,I.checkProposedApiEnabled)(this._extension,"scmValidation"),r&&typeof r!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=r,Fe(this,i,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!r)}get enabled(){return this._enabled}set enabled(r){r=!!r,this._enabled!==r&&(this._enabled=r,Fe(this,i,"f").$setInputBoxEnablement(this._sourceControlHandle,r))}get visible(){return this._visible}set visible(r){r=!!r,this._visible!==r&&(this._visible=r,Fe(this,i,"f").$setInputBoxVisibility(this._sourceControlHandle,r))}get document(){return(0,I.checkProposedApiEnabled)(this._extension,"scmTextDocument"),Fe(this,l,"f").getDocument(this._documentUri)}constructor(r,P,M,W,$){this._extension=r,this._sourceControlHandle=W,this._documentUri=$,i.set(this,void 0),l.set(this,void 0),this._value="",this._onDidChange=new T.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Ye(this,l,P,"f"),Ye(this,i,M,"f")}showValidationMessage(r,P){(0,I.checkProposedApiEnabled)(this._extension,"scmValidation"),Fe(this,i,"f").$showValidationMessage(this._sourceControlHandle,r,P)}$onInputBoxValueChange(r){this.updateValue(r)}updateValue(r){this._value=r,this._onDidChange.fire(r)}}e.ExtHostSCMInputBox=p,i=new WeakMap,l=new WeakMap;class h{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(r){this._label=r,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,r)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(r){this._hideWhenEmpty=r,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(r){this._resourceStates=[...r],this._onDidUpdateResourceStates.fire()}constructor(r,P,M,W,$){this._proxy=r,this._commands=P,this._sourceControlHandle=M,this._id=W,this._label=$,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new T.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=h._handlePool++}getResourceState(r){return this._resourceStatesMap.get(r)}$executeResourceCommand(r,P){const M=this._resourceStatesCommandsMap.get(r);return M?(0,R.asPromise)(()=>this._commands.executeCommand(M.command,...M.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const r=[...this._resourceStates].sort(o),M=(0,y.sortedDiff)(this._resourceSnapshot,r,o).map(z=>{const N=z.toInsert.map(q=>{const x=this._resourceHandlePool++;this._resourceStatesMap.set(x,q);const U=q.resourceUri;let de;if(q.command)if(q.command.command==="vscode.open"||q.command.command==="vscode.diff"){const K=new L.DisposableStore;de=this._commands.converter.toInternal(q.command,K),this._resourceStatesDisposablesMap.set(x,K)}else this._resourceStatesCommandsMap.set(x,q.command);const ie=b(q.decorations),ne=q.decorations&&b(q.decorations.light)||ie,H=q.decorations&&b(q.decorations.dark)||ie,V=[ne,H],ce=q.decorations&&q.decorations.tooltip||"",be=q.decorations&&!!q.decorations.strikeThrough,Se=q.decorations&&!!q.decorations.faded,ge=q.contextValue||"";return{rawResource:[x,U,V,ce,be,Se,ge,de],handle:x}});return{start:z.start,deleteCount:z.deleteCount,toInsert:N}}),W=M.map(({start:z,deleteCount:N,toInsert:q})=>[z,N,q.map(x=>x.rawResource)]),$=M.reverse();for(const{start:z,deleteCount:N,toInsert:q}of $){const x=q.map(de=>de.handle),U=this._handlesSnapshot.splice(z,N,...x);for(const de of U)this._resourceStatesMap.delete(de),this._resourceStatesCommandsMap.delete(de),this._resourceStatesDisposablesMap.get(de)?.dispose(),this._resourceStatesDisposablesMap.delete(de)}return this._resourceSnapshot=r,W}dispose(){this._disposed=!0,this._onDidDispose.fire()}}h._handlePool=0;class C{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(r){this._count!==r&&(this._count=r,Fe(this,a,"f").$updateSourceControl(this.handle,{count:r}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(r){this._quickDiffProvider=r;let P;(0,I.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(P=r?.label),Fe(this,a,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!r,quickDiffLabel:P})}get commitTemplate(){return this._commitTemplate}set commitTemplate(r){r!==this._commitTemplate&&(this._commitTemplate=r,Fe(this,a,"f").$updateSourceControl(this.handle,{commitTemplate:r}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(r){this._acceptInputDisposables.value=new L.DisposableStore,this._acceptInputCommand=r;const P=this._commands.converter.toInternal(r,this._acceptInputDisposables.value);Fe(this,a,"f").$updateSourceControl(this.handle,{acceptInputCommand:P})}get actionButton(){return(0,I.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(r){(0,I.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new L.DisposableStore,this._actionButton=r;const P=r!==void 0?{command:this._commands.converter.toInternal(r.command,this._actionButtonDisposables.value),secondaryCommands:r.secondaryCommands?.map(M=>M.map(W=>this._commands.converter.toInternal(W,this._actionButtonDisposables.value))),description:r.description,enabled:r.enabled}:void 0;Fe(this,a,"f").$updateSourceControl(this.handle,{actionButton:P??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(r){if(this._statusBarCommands&&r&&u(this._statusBarCommands,r))return;this._statusBarDisposables.value=new L.DisposableStore,this._statusBarCommands=r;const P=(r||[]).map(M=>this._commands.converter.toInternal(M,this._statusBarDisposables.value));Fe(this,a,"f").$updateSourceControl(this.handle,{statusBarCommands:P})}get selected(){return this._selected}constructor(r,P,M,W,$,z,N){this._extension=r,this._commands=W,this._id=$,this._label=z,this._rootUri=N,a.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new L.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new L.MutableDisposable,this._statusBarDisposables=new L.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new T.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=C._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ye(this,a,M,"f");const q=v.URI.from({scheme:E.Schemas.vscodeSourceControl,path:`${$}/scm${this.handle}/input`,query:N?`rootUri=${encodeURIComponent(N.toString())}`:void 0});this._inputBox=new p(r,P,Fe(this,a,"f"),this.handle,q),Fe(this,a,"f").$registerSourceControl(this.handle,$,z,N,q)}createResourceGroup(r,P){const M=new h(Fe(this,a,"f"),this._commands,this.handle,r,P),W=T.Event.once(M.onDidDispose)(()=>this.createdResourceGroups.delete(M));return this.createdResourceGroups.set(M,W),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const r=[],P=[];for(const[M,W]of this.createdResourceGroups){W.dispose();const $=M.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(M),this.eventuallyUpdateResourceStates()});T.Event.once(M.onDidDispose)(()=>{this.updatedResourceGroups.delete(M),$.dispose(),this._groups.delete(M.handle),Fe(this,a,"f").$unregisterGroup(this.handle,M.handle)}),r.push([M.handle,M.id,M.label,M.features]);const z=M._takeResourceStateSnapshot();z.length>0&&P.push([M.handle,z]),this._groups.set(M.handle,M)}Fe(this,a,"f").$registerGroups(this.handle,r,P),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const r=[];this.updatedResourceGroups.forEach(P=>{const M=P._takeResourceStateSnapshot();M.length!==0&&r.push([P.handle,M])}),r.length>0&&Fe(this,a,"f").$spliceResourceStates(this.handle,r),this.updatedResourceGroups.clear()}getResourceGroup(r){return this._groups.get(r)}setSelectionState(r){this._selected=r,this._onDidChangeSelection.fire(r)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(r=>r.dispose()),Fe(this,a,"f").$unregisterSourceControl(this.handle)}}a=new WeakMap,C._handlePool=0,Ve([(0,d.debounce)(100)],C.prototype,"eventuallyAddResourceGroups",null),Ve([(0,d.debounce)(100)],C.prototype,"eventuallyUpdateResourceStates",null);let S=e.ExtHostSCM=class An{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(r,P,M,W){this._commands=P,this._extHostDocuments=M,this.logService=W,this._sourceControls=new Map,this._sourceControlsByExtension=new k.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new T.Emitter,this._proxy=r.getProxy(g.MainContext.MainThreadSCM),this._telemetry=r.getProxy(g.MainContext.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:$=>{if($&&$.$mid===3){const z=this._sourceControls.get($.sourceControlHandle);if(!z)return $;const N=z.getResourceGroup($.groupHandle);return N?N.getResourceState($.handle):$}else if($&&$.$mid===4){const z=this._sourceControls.get($.sourceControlHandle);return z?z.getResourceGroup($.groupHandle):$}else if($&&$.$mid===5){const z=this._sourceControls.get($.handle);return z||$}return $}})}createSourceControl(r,P,M,W){this.logService.trace("ExtHostSCM#createSourceControl",r.identifier.value,P,M,W),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:r.identifier.value});const $=An._handlePool++,z=new C(r,this._extHostDocuments,this._proxy,this._commands,P,M,W);this._sourceControls.set($,z);const N=this._sourceControlsByExtension.get(r.identifier)||[];return N.push(z),this._sourceControlsByExtension.set(r.identifier,N),z}getLastInputBox(r){this.logService.trace("ExtHostSCM#getLastInputBox",r.identifier.value);const P=this._sourceControlsByExtension.get(r.identifier),M=P&&P[P.length-1];return M&&M.inputBox}$provideOriginalResource(r,P,M){const W=v.URI.revive(P);this.logService.trace("ExtHostSCM#$provideOriginalResource",r,W.toString());const $=this._sourceControls.get(r);return!$||!$.quickDiffProvider||!$.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>$.quickDiffProvider.provideOriginalResource(W,M)).then(z=>z||null)}$onInputBoxValueChange(r,P){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",r);const M=this._sourceControls.get(r);return M&&M.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(r,P,M,W){this.logService.trace("ExtHostSCM#$executeResourceCommand",r,P,M);const $=this._sourceControls.get(r);if(!$)return Promise.resolve(void 0);const z=$.getResourceGroup(P);return z?z.$executeResourceCommand(M,W):Promise.resolve(void 0)}$validateInput(r,P,M){this.logService.trace("ExtHostSCM#$validateInput",r);const W=this._sourceControls.get(r);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>W.inputBox.validateInput(P,M)).then($=>{if(!$)return Promise.resolve(void 0);const z=D.MarkdownString.fromStrict($.message);return z?Promise.resolve([z,$.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(r){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",r),r!==void 0&&this._sourceControls.get(r)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=r,Promise.resolve(void 0)}};S._handlePool=0,e.ExtHostSCM=S=Ve([ze(3,A.ILogService)],S)}),define(De[108],Ie([1,0,6,3,5]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(g){this._onDidChangePassword=new T.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=g.getProxy(v.MainContext.MainThreadSecretState)}async $onDidChangePassword(g){this._onDidChangePassword.fire(g)}get(g,y){return this._proxy.$getPassword(g,y)}store(g,y,m){return this._proxy.$setPassword(g,y,m)}delete(g,y){return this._proxy.$deletePassword(g,y)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,d.createDecorator)("IExtHostSecretState")}),define(De[301],Ie([1,0,6,7]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSemanticSimilarity=void 0;class d{constructor(R){this._semanticSimilarityProviders=new Map,this._nextHandle=0,this._proxy=R.getProxy(v.MainContext.MainThreadSemanticSimilarity)}async $provideSimilarityScore(R,g,y,m){if(this._semanticSimilarityProviders.size===0)throw new Error("No semantic similarity providers registered");const A=this._semanticSimilarityProviders.get(R);if(!A)throw new Error("Semantic similarity provider not found");return await A.provideSimilarityScore(g,y,m)}registerSemanticSimilarityProvider(R,g){const y=this._nextHandle;return this._nextHandle++,this._semanticSimilarityProviders.set(y,g),this._proxy.$registerSemanticSimilarityProvider(y),new T.Disposable(()=>{this._proxy.$unregisterSemanticSimilarityProvider(y),this._semanticSimilarityProviders.delete(y)})}}e.ExtHostSemanticSimilarity=d}),define(De[302],Ie([1,0,6,15,2]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class L{constructor(g,y){this.uriTransformer=y,this.providers=new Map,this.proxy=g.getProxy(v.MainContext.MainThreadShare)}async $provideShare(g,y,m){return await this.providers.get(g)?.provideShare({selection:T.Range.to(y.selection),resourceUri:d.URI.revive(y.resourceUri)},m)??void 0}registerShareProvider(g,y){const m=L.handlePool++;return this.providers.set(m,y),this.proxy.$registerShareProvider(m,T.DocumentSelector.from(g,this.uriTransformer),y.id,y.label,y.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(m),this.providers.delete(m)}}}}e.ExtHostShare=L,L.handlePool=0});var Ye=this&&this.__classPrivateFieldSet||function(re,e,v,T,d){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!d)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!d:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?d.call(re,v):d?d.value=v:e.set(re,v),v},Fe=this&&this.__classPrivateFieldGet||function(re,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!T:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(re):T?T.value:e.get(re)};define(De[303],Ie([1,0,7,6,194,4,15,12]),function(re,e,v,T,d,L,R,g){"use strict";var y,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class A{constructor(I,E,i,l,a,b=v.StatusBarAlignment.Left,f){if(y.set(this,void 0),m.set(this,void 0),this._disposed=!1,this._text="",this._staleCommandRegistrations=new L.DisposableStore,Ye(this,y,I,"f"),Ye(this,m,E,"f"),a&&l){this._entryId=(0,v.asStatusBarItemIdentifier)(l.identifier,a);const _=i.get(this._entryId);_&&(b=_.alignLeft?v.StatusBarAlignment.Left:v.StatusBarAlignment.Right,f=_.priority,this._visible=!0,this.name=_.name,this.text=_.text,this.tooltip=_.tooltip,this.command=_.command,this.accessibilityInformation=_.accessibilityInformation)}else this._entryId=String(A.ID_GEN++);this._extension=l,this._id=a,this._alignment=b,this._priority=this.validatePriority(f)}validatePriority(I){if((0,g.isNumber)(I))return I===Number.POSITIVE_INFINITY?Number.MAX_VALUE:I===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:I}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(I){this._text=I,this.update()}set name(I){this._name=I,this.update()}set tooltip(I){this._tooltip=I,this.update()}set color(I){this._color=I,this.update()}set backgroundColor(I){I&&!A.ALLOWED_BACKGROUND_COLORS.has(I.id)&&(I=void 0),this._backgroundColor=I,this.update()}set command(I){this._command?.fromApi!==I&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new L.DisposableStore,typeof I=="string"?this._command={fromApi:I,internal:Fe(this,m,"f").toInternal({title:"",command:I},this._latestCommandRegistration)}:I?this._command={fromApi:I,internal:Fe(this,m,"f").toInternal(I,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(I){this._accessibilityInformation=I,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Fe(this,y,"f").$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let I;this._extension?this._id?I=`${this._extension.identifier.value}.${this._id}`:I=this._extension.identifier.value:I=this._id;let E;this._name?E=this._name:E=(0,d.localize)(0,null,this._extension.displayName||this._extension.name);let i=this._color;this._backgroundColor&&(i=A.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const l=R.MarkdownString.fromStrict(this._tooltip);Fe(this,y,"f").$setEntry(this._entryId,I,this._extension?.identifier.value,E,this._text,l,this._command?.internal,i,this._backgroundColor,this._alignment===v.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=A,y=new WeakMap,m=new WeakMap,A.ID_GEN=0,A.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new v.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new v.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(I){this._messages=[],this._item=I.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,d.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(I){const E={message:I};return this._messages.unshift(E),this._update(),new v.Disposable(()=>{const i=this._messages.indexOf(E);i>=0&&(this._messages.splice(i,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class w{constructor(I,E){this._existingItems=new Map,this._proxy=I.getProxy(T.MainContext.MainThreadStatusBar),this._commands=E,this._statusMessage=new k(this)}$acceptStaticEntries(I){for(const E of I)this._existingItems.set(E.entryId,E)}createStatusBarEntry(I,E,i,l){return new A(this._proxy,this._commands,this._existingItems,I,E,i,l)}setStatusBarMessage(I,E){const i=this._statusMessage.setMessage(I);let l;return typeof E=="number"?l=setTimeout(()=>i.dispose(),E):typeof E<"u"&&E.then(()=>i.dispose(),()=>i.dispose()),new v.Disposable(()=>{i.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=w}),define(De[109],Ie([1,0,6,3,5]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(g,y){this._logService=y,this._onDidChangeStorage=new T.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=g.getProxy(v.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(g,y){this._proxy.$registerExtensionStorageKeysToSync(g,y)}async initializeExtensionStorage(g,y,m){const A=await this._proxy.$initializeExtensionStorage(g,y);let k;return A&&(k=this.safeParseValue(g,y,A)),k||m}setValue(g,y,m){return this._proxy.$setValue(g,y,m)}$acceptValue(g,y,m){const A=this.safeParseValue(g,y,m);A&&this._onDidChangeStorage.fire({shared:g,key:y,value:A})}safeParseValue(g,y,m){try{return JSON.parse(m)}catch(A){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${g}): ${A}`)}}}e.ExtHostStorage=L,e.IExtHostStorage=(0,d.createDecorator)("IExtHostStorage")}),define(De[84],Ie([1,0,5,26,18,64,2]),function(re,e,v,T,d,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,v.createDecorator)("IExtensionStoragePaths");let g=e.ExtensionStoragePaths=class{constructor(m,A,k){this._logService=A,this._extHostFileSystem=k,this._workspace=m.workspace??void 0,this._environment=m.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(w=>this._value=w)}async _getWorkspaceStorageURI(m){return R.URI.joinPath(this._environment.workspaceStorageHome,m)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const m=this._workspace.id,A=await this._getWorkspaceStorageURI(m);try{return await this._extHostFileSystem.value.stat(A),this._logService.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",A),await this._extHostFileSystem.value.createDirectory(A),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),A}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(m){if(this._value)return R.URI.joinPath(this._value,m.identifier.value)}globalValue(m){return R.URI.joinPath(this._environment.globalStorageHome,m.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=g=Ve([ze(0,T.IExtHostInitDataService),ze(1,d.ILogService),ze(2,L.IExtHostConsumerFileSystem)],g)}),define(De[43],Ie([1,0,3,6,5,2,20,4,7,196,8,236,21,32,237,55,12,17,15,27]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,d.createDecorator)("IExtHostTerminalService");class f{constructor(c,r,P,M){this._proxy=c,this._id=r,this._creationOptions=P,this._name=M,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise($=>this._pidPromiseComplete=$);const W=this;this.value={get name(){return W._name||""},get processId(){return W._pidPromise},get creationOptions(){return W._creationOptions},get exitStatus(){return W._exitStatus},get state(){return W._state},sendText($,z=!0){W._checkDisposed(),W._proxy.$sendText(W._id,$,z)},show($){W._checkDisposed(),W._proxy.$show(W._id,$)},hide(){W._checkDisposed(),W._proxy.$hide(W._id)},dispose(){W._disposed||(W._disposed=!0,W._proxy.$dispose(W._id))},get dimensions(){if(!(W._cols===void 0||W._rows===void 0))return{columns:W._cols,rows:W._rows}}}}async create(c,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:c.name,shellPath:(0,i.withNullAsUndefined)(c.shellPath),shellArgs:(0,i.withNullAsUndefined)(c.shellArgs),cwd:(0,i.withNullAsUndefined)(c.cwd),env:(0,i.withNullAsUndefined)(c.env),icon:(0,i.withNullAsUndefined)(p(c.iconPath)),color:E.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,i.withNullAsUndefined)(c.message),strictEnv:(0,i.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,i.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,i.withNullAsUndefined)(r?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,i.withNullAsUndefined)(r?.useShellEnvironment),location:r?.location||this._serializeParentTerminal(c.location,r?.resolvedExtHostIdentifier),isTransient:(0,i.withNullAsUndefined)(c.isTransient)})}async createExtensionTerminal(c,r,P,M){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:P,color:E.ThemeColor.isThemeColor(M)?M.id:void 0,location:this._serializeParentTerminal(c,r),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(c,r){return typeof c=="object"?"parentTerminal"in c&&c.parentTerminal&&r?{parentTerminal:r}:"viewColumn"in c?{viewColumn:a.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus}:void 0:c}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(c){this._name=c}setExitStatus(c,r){this._exitStatus=Object.freeze({code:c,reason:r})}setDimensions(c,r){return c===this._cols&&r===this._rows||c===0||r===0?!1:(this._cols=c,this._rows=r,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(c){this._pidPromiseComplete?(this._pidPromiseComplete(c),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==c&&(this._pidPromise=Promise.resolve(c))})}}e.ExtHostTerminal=f;class _{get onProcessReady(){return this._onProcessReady.event}constructor(c){this._pty=c,this.id=0,this.shouldPersist=!1,this._onProcessData=new v.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new v.Emitter,this._onDidChangeProperty=new v.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new v.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(c){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${c}`)}updateProperty(c,r){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${c}, value: ${r}`)}async start(){}shutdown(){this._pty.close()}input(c){this._pty.handleInput?.(c)}resize(c,r){this._pty.setDimensions?.({columns:c,rows:r})}clearBuffer(){}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose?.((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions?.(r=>{r&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:r.columns,rows:r.rows}})}),this._pty.onDidChangeName?.(r=>{this._onDidChangeProperty.fire({type:"title",value:r})}),this._pty.open(c||void 0),c&&this._pty.setDimensions?.(c),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let n=1,o=e.BaseExtHostTerminalService=class extends g.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(c=>c.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(c,r){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new v.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new v.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new v.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new v.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new v.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new v.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=r.getProxy(T.MainContext.MainThreadTerminalService),this._bufferer=new I.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new v.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(c),this._register({dispose:()=>{for(const[P,M]of this._terminalProcesses)M.shutdown(!0)}})}getDefaultShell(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(c,r){const P=new f(this._proxy,(0,D.generateUuid)(),c,c.name),M=new _(c.pty);return P.createExtensionTerminal(c.location,this._serializeParentTerminal(c,r).resolvedExtHostIdentifier,p(c.iconPath),h(c.color)).then(W=>{const $=this._setupExtHostProcessListeners(W,M);this._terminalProcessDisposables[W]=$}),this._terminals.push(P),P.value}_serializeParentTerminal(c,r){if(r=r||{},c.location&&typeof c.location=="object"&&"parentTerminal"in c.location){const P=c.location.parentTerminal;if(P){const M=this._terminals.find(W=>W.value===P);M&&(r.resolvedExtHostIdentifier=M._id)}}else c.location&&typeof c.location!="object"?r.location=c.location:r.location&&typeof r.location=="object"&&"splitActiveTerminal"in r.location&&(r.location={splitActiveTerminal:!0});return r}attachPtyToTerminal(c,r){if(!this._getTerminalById(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const M=new _(r),W=this._setupExtHostProcessListeners(c,M);this._terminalProcessDisposables[c]=W}async $acceptActiveTerminalChanged(c){const r=this._activeTerminal;if(c===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const P=this._getTerminalById(c);P&&(this._activeTerminal=P,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(c,r){const P=this._getTerminalById(c);P&&this._onDidWriteTerminalData.fire({terminal:P.value,data:r})}async $acceptTerminalDimensions(c,r,P){const M=this._getTerminalById(c);M&&M.setDimensions(r,P)&&this._onDidChangeTerminalDimensions.fire({terminal:M.value,dimensions:M.value.dimensions})}async $acceptTerminalMaximumDimensions(c,r,P){this._terminalProcesses.get(c)?.resize(r,P)}async $acceptTerminalTitleChange(c,r){const P=this._getTerminalById(c);P&&(P.name=r)}async $acceptTerminalClosed(c,r,P){const M=this._getTerminalObjectIndexById(this._terminals,c);if(M!==null){const W=this._terminals.splice(M,1)[0];W.setExitStatus(r,P),this._onDidCloseTerminal.fire(W.value)}}$acceptTerminalOpened(c,r,P,M){if(r){const z=this._getTerminalObjectIndexById(this._terminals,r);if(z!==null){this._terminals[z]._id=c,this._onDidOpenTerminal.fire(this.terminals[z]),this._terminals[z].isOpen=!0;return}}const W={name:M.name,shellPath:M.executable,shellArgs:M.args,cwd:typeof M.cwd=="string"?M.cwd:L.URI.revive(M.cwd),env:M.env,hideFromUser:M.hideFromUser},$=new f(this._proxy,c,W,P);this._terminals.push($),this._onDidOpenTerminal.fire($.value),$.isOpen=!0}async $acceptTerminalProcessId(c,r){this._getTerminalById(c)?._setProcessId(r)}async $startExtensionTerminal(c,r){const P=this._getTerminalById(c);if(!P)return{message:(0,m.localize)(0,null,c)};P.isOpen||await new Promise(W=>{const $=this.onDidOpenTerminal(async z=>{z===P.value&&($.dispose(),W())})});const M=this._terminalProcesses.get(c);M?M.startSendingEvents(r):this._extensionTerminalAwaitingStart[c]={initialDimensions:r}}_setupExtHostProcessListeners(c,r){const P=new g.DisposableStore;P.add(r.onProcessReady(W=>this._proxy.$sendProcessReady(c,W.pid,W.cwd,W.windowsPty))),P.add(r.onDidChangeProperty(W=>this._proxy.$sendProcessProperty(c,W))),this._bufferer.startBuffering(c,r.onProcessData),P.add(r.onProcessExit(W=>this._onProcessExit(c,W))),this._terminalProcesses.set(c,r);const M=this._extensionTerminalAwaitingStart[c];return M&&r instanceof _&&(r.startSendingEvents(M.initialDimensions),delete this._extensionTerminalAwaitingStart[c]),P}$acceptProcessAckDataEvent(c,r){this._terminalProcesses.get(c)?.acknowledgeDataEvent(r)}$acceptProcessInput(c,r){this._terminalProcesses.get(c)?.input(r)}$acceptTerminalInteraction(c){const r=this._getTerminalById(c);r?.setInteractedWith()&&this._onDidChangeTerminalState.fire(r.value)}$acceptProcessResize(c,r,P){try{this._terminalProcesses.get(c)?.resize(r,P)}catch(M){if(M.code!=="EPIPE"&&M.code!=="ERR_IPC_CHANNEL_CLOSED")throw M}}$acceptProcessShutdown(c,r){this._terminalProcesses.get(c)?.shutdown(r)}$acceptProcessRequestInitialCwd(c){this._terminalProcesses.get(c)?.getInitialCwd().then(r=>this._proxy.$sendProcessProperty(c,{type:"initialCwd",value:r}))}$acceptProcessRequestCwd(c){this._terminalProcesses.get(c)?.getCwd().then(r=>this._proxy.$sendProcessProperty(c,{type:"cwd",value:r}))}$acceptProcessRequestLatency(c){return Promise.resolve(c)}registerLinkProvider(c){return this._linkProviders.add(c),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(c),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(c,r,P){if(this._profileProviders.has(r))throw new Error(`Terminal profile provider "${r}" already registered`);return this._profileProviders.set(r,P),this._proxy.$registerProfileProvider(r,c.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(r),this._proxy.$unregisterProfileProvider(r)})}registerTerminalQuickFixProvider(c,r,P){if(this._quickFixProviders.has(c))throw new Error(`Terminal quick fix provider "${c}" is already registered`);return this._quickFixProviders.set(c,P),this._proxy.$registerQuickFixProvider(c,r),new y.Disposable(()=>{this._quickFixProviders.delete(c),this._proxy.$unregisterQuickFixProvider(c)})}async $provideTerminalQuickFixes(c,r){const P=new w.CancellationTokenSource().token;if(P.isCancellationRequested)return;const M=this._quickFixProviders.get(c);if(!M)return;const W=await M.provideTerminalQuickFixes(r,P);if(W!==null)return W}async $createContributedProfileTerminal(c,r){const P=new w.CancellationTokenSource().token;let M=await this._profileProviders.get(c)?.provideTerminalProfile(P);if(!P.isCancellationRequested){if(M&&!("options"in M)&&(M={options:M}),!M||!("options"in M))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in M.options){this.createExtensionTerminal(M.options,r);return}this.createTerminalFromOptions(M.options,r)}}async $provideLinks(c,r){const P=this._getTerminalById(c);if(!P)return[];this._terminalLinkCache.delete(c),this._terminalLinkCancellationSource.get(c)?.dispose(!0);const W=new w.CancellationTokenSource;this._terminalLinkCancellationSource.set(c,W);const $=[],z={terminal:P.value,line:r},N=[];for(const U of this._linkProviders)N.push(l.Promises.withAsyncBody(async de=>{W.token.onCancellationRequested(()=>de({provider:U,links:[]}));const ie=await U.provideTerminalLinks(z,W.token)||[];W.token.isCancellationRequested||de({provider:U,links:ie})}));const q=await Promise.all(N);if(W.token.isCancellationRequested)return[];const x=new Map;for(const U of q)U&&U.links.length>0&&$.push(...U.links.map(de=>{const ie={id:n++,startIndex:de.startIndex,length:de.length,label:de.tooltip};return x.set(ie.id,{provider:U.provider,link:de}),ie}));return this._terminalLinkCache.set(c,x),$}$activateLink(c,r){const P=this._terminalLinkCache.get(c)?.get(r);P&&P.provider.handleTerminalLink(P.link)}_onProcessExit(c,r){this._bufferer.stopBuffering(c),this._terminalProcesses.delete(c),delete this._extensionTerminalAwaitingStart[c];const P=this._terminalProcessDisposables[c];P&&(P.dispose(),delete this._terminalProcessDisposables[c]),this._proxy.$sendProcessExit(c,r)}_getTerminalById(c){return this._getTerminalObjectById(this._terminals,c)}_getTerminalObjectById(c,r){const P=this._getTerminalObjectIndexById(c,r);return P!==null?c[P]:null}_getTerminalObjectIndexById(c,r){const P=c.findIndex(M=>M._id===r);return P===-1?null:P}getEnvironmentVariableCollection(c){let r=this._environmentVariableCollections.get(c.identifier.value);return r||(r=new s(c),this._setEnvironmentVariableCollection(c.identifier.value,r)),r.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(c,r){const P=(0,k.serializeEnvironmentVariableCollection)(r.map),M=(0,k.serializeEnvironmentDescriptionMap)(r.descriptionMap);this._proxy.$setEnvironmentVariableCollection(c,r.persistent,P.length===0?void 0:P,M)}$initEnvironmentVariableCollections(c){c.forEach(r=>{const P=r[0],M=new s(void 0,r[1]);this._setEnvironmentVariableCollection(P,M)})}$acceptDefaultProfile(c,r){const P=this._defaultProfile;this._defaultProfile=c,this._defaultAutomationProfile=r,P?.path!==c.path&&this._onDidChangeShell.fire(c.path)}_setEnvironmentVariableCollection(c,r){this._environmentVariableCollections.set(c,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(c,r)})}};e.BaseExtHostTerminalService=o=Ve([ze(1,R.IExtHostRpcService)],o);class s{get persistent(){return this._persistent}set persistent(c){this._persistent=c,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(c,r){this._extension=c,this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new v.Emitter,this.map=new Map(r)}getScopedEnvironmentVariableCollection(c){this._extension&&c&&(0,b.checkProposedApiEnabled)(this._extension,"envCollectionWorkspace");const r=this.getScopeKey(c);let P=this.scopedCollections.get(r);return P||(P=new t(this,c),this.scopedCollections.set(r,P),P.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),P}replace(c,r,P,M){this._extension&&P&&(0,b.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(c,{value:r,type:y.EnvironmentVariableMutatorType.Replace,options:P??{},scope:M})}append(c,r,P,M){this._extension&&P&&(0,b.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(c,{value:r,type:y.EnvironmentVariableMutatorType.Append,options:P??{},scope:M})}prepend(c,r,P,M){this._extension&&P&&(0,b.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(c,{value:r,type:y.EnvironmentVariableMutatorType.Prepend,options:P??{},scope:M})}_setIfDiffers(c,r){if(r.options&&r.options.applyAtProcessCreation===!1&&!r.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const P=this.getKey(c,r.scope),M=this.map.get(P);if(!M||M.value!==r.value||M.type!==r.type||M.options?.applyAtProcessCreation!==(r.options.applyAtProcessCreation??!0)||M.options?.applyAtShellIntegration!==(r.options.applyAtShellIntegration??!1)||M.scope?.workspaceFolder?.index!==r.scope?.workspaceFolder?.index){const W=this.getKey(c,r.scope),$={variable:c,...r,options:{applyAtProcessCreation:r.options.applyAtProcessCreation??!0,applyAtShellIntegration:r.options.applyAtShellIntegration??!1}};this.map.set(W,$),this._onDidChangeCollection.fire()}}get(c,r){const P=this.getKey(c,r),M=this.map.get(P);return M?C(M):void 0}getKey(c,r){const P=this.getScopeKey(r);return P.length?`${c}:::${P}`:c}getScopeKey(c){return this.getWorkspaceKey(c?.workspaceFolder)??""}getWorkspaceKey(c){return c?c.uri.toString():void 0}getVariableMap(c){const r=new Map;for(const[P,M]of this.map)this.getScopeKey(M.scope)===this.getScopeKey(c)&&r.set(P,C(M));return r}delete(c,r){const P=this.getKey(c,r);this.map.delete(P),this._onDidChangeCollection.fire()}clear(c){if(c?.workspaceFolder){for(const[r,P]of this.map)P.scope?.workspaceFolder?.index===c.workspaceFolder.index&&this.map.delete(r);this.clearDescription(c)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(c,r){const P=this.getScopeKey(r),M=this.descriptionMap.get(P);if(!M||M.description!==c){let W;typeof c=="string"?W=c:W=c?.value.split(`

`)[0];const $={description:W,scope:r};this.descriptionMap.set(P,$),this._onDidChangeCollection.fire()}}getDescription(c){const r=this.getScopeKey(c);return this.descriptionMap.get(r)?.description}clearDescription(c){const r=this.getScopeKey(c);this.descriptionMap.delete(r)}}class t{get persistent(){return this.collection.persistent}set persistent(c){this.collection.persistent=c}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(c,r){this.collection=c,this.scope=r,this._onDidChangeCollection=new v.Emitter}getScopedEnvironmentVariableCollection(c){return this.collection.getScopedEnvironmentVariableCollection(c)}replace(c,r,P){this.collection.replace(c,r,P,this.scope)}append(c,r,P){this.collection.append(c,r,P,this.scope)}prepend(c,r,P){this.collection.prepend(c,r,P,this.scope)}get(c){return this.collection.get(c,this.scope)}forEach(c,r){this.collection.getVariableMap(this.scope).forEach((P,M)=>c.call(r,M,P,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(c){this.collection.delete(c,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(c){this.collection.setDescription(c,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let u=e.WorkerExtHostTerminalService=class extends o{constructor(c){super(!1,c)}createTerminal(c,r,P){throw new A.NotSupportedError}createTerminalFromOptions(c,r){throw new A.NotSupportedError}};e.WorkerExtHostTerminalService=u=Ve([ze(0,R.IExtHostRpcService)],u);function p(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function h(S){return E.ThemeColor.isThemeColor(S)?S:void 0}function C(S){const c={...S};return delete c.scope,c.options=c.options??void 0,delete c.variable,c}});var Fe=this&&this.__classPrivateFieldGet||function(re,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!T:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(re):T?T.value:e.get(re)},Ye=this&&this.__classPrivateFieldSet||function(re,e,v,T,d){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!d)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!d:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?d.call(re,v):d?d.value=v:e.set(re,v),v};define(De[304],Ie([1,0,19,17,22,21,3,67,70,4,24,12,32,6,20,139,15,7,60,103,81,27]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l,a,b,f,_){"use strict";var n,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=e.ExtHostTesting=class{constructor(N,q,x){this.editors=x,this.resultsChangedEmitter=new R.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=N.getProxy(D.MainContext.MainThreadTesting),this.observer=new M(this.proxy),this.runTracker=new h(this.proxy),q.registerArgumentProcessor({processArgument:U=>{if(U?.$mid!==15)return U;const de=U,ie=de.tests[de.tests.length-1].item.extId;return this.controllers.get(a.TestId.root(ie))?.collection.tree.get(ie)?.actual??(0,E.toItemFromContext)(U)}}),q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const U=await q.executeCommand("_testing.getExplorerSelection"),de=ie=>{const ne=this.controllers.get(a.TestId.root(ie));if(ne)return a.TestId.isRoot(ie)?ne.controller:ne.collection.tree.get(ie)?.actual};return{include:U?.include.map(de).filter(k.isDefined)||[],exclude:U?.exclude.map(de).filter(k.isDefined)||[]}})}createTestController(N,q,x,U){if(this.controllers.has(q))throw new Error(`Attempt to insert a duplicate controller with ID "${q}"`);const de=new m.DisposableStore,ie=de.add(new E.ExtHostTestItemCollection(q,x,this.editors));ie.root.label=x;const ne=new Map,H=this.proxy,V={items:ie.root.children,get label(){return x},set label(be){x=be,ie.root.label=be,H.$updateController(q,{label:x})},get refreshHandler(){return U},set refreshHandler(be){U=be,H.$updateController(q,{canRefresh:!!be})},get id(){return q},createRunProfile:(be,Se,ge,O,K,we)=>{let Ce=(0,y.hash)(be);for(;ne.has(Ce);)Ce++;return new W(this.proxy,ne,q,Ce,be,Se,ge,O,K,we)},createTestItem(be,Se,ge){return new E.TestItemImpl(q,be,Se,ge)},createTestRun:(be,Se,ge=!0)=>this.runTracker.createTestRun(q,ie,be,Se,ge),invalidateTestResults:be=>{(0,_.checkProposedApiEnabled)(N,"testInvalidateResults");for(const Se of be instanceof Array?be:[be]){const ge=Se?a.TestId.fromExtHostTestItem(Se,q).toString():q;this.proxy.$markTestRetired(ge)}},set resolveHandler(be){ie.resolveHandler=be},get resolveHandler(){return ie.resolveHandler},dispose:()=>{de.dispose()}};H.$registerTestController(q,x,!!U),de.add((0,m.toDisposable)(()=>H.$unregisterTestController(q)));const ce={controller:V,collection:ie,profiles:ne};return this.controllers.set(q,ce),de.add((0,m.toDisposable)(()=>this.controllers.delete(q))),de.add(ie.onDidGenerateDiff(be=>H.$publishDiff(q,be.map(f.TestsDiffOp.serialize)))),V}createTestObserver(){return this.observer.checkout()}async runTests(N,q=L.CancellationToken.None){const x=C(N);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.controllers.get(x.controllerId);if(!U)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(de=>a.TestId.fromExtHostTestItem(de,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:$[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:N.exclude?.map(de=>de.id)},q)}$syncTests(){for(const{collection:N}of this.controllers.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,q,x){return(0,v.mapFind)(this.runTracker.trackers,de=>de.id===N?de.getCoverage(q):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(N,q,x,U){return(0,v.mapFind)(this.runTracker.trackers,ie=>ie.id===N?ie.getCoverage(q):void 0)?.resolveFileCoverage(x,U)??Promise.resolve([])}$configureRunProfile(N,q){this.controllers.get(N)?.profiles.get(q)?.configureHandler?.()}async $refreshTests(N,q){await this.controllers.get(N)?.controller.refreshHandler?.(q)}$publishTestResults(N){this.results=Object.freeze(N.map(q=>(0,A.deepFreeze)(i.TestResults.to(q))).concat(this.results).sort((q,x)=>x.completedAt-q.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(N,q){const x=this.controllers.get(a.TestId.fromString(N).controllerId)?.collection;x&&(await x.expand(N,q<0?1/0:q),x.flushDiff())}$acceptDiff(N){this.observer.applyDiff(N.map(f.TestsDiffOp.deserialize))}async $runControllerTests(N,q){return Promise.all(N.map(x=>this.runControllerTestRequest(x,!1,q)))}async $startContinuousRun(N,q){const x=new L.CancellationTokenSource(q),U=await Promise.all(N.map(de=>this.runControllerTestRequest(de,!0,x.token)));return!q.isCancellationRequested&&!U.some(de=>de.error)&&await new Promise(de=>q.onCancellationRequested(de)),x.dispose(!0),U}async runControllerTestRequest(N,q,x){const U=this.controllers.get(N.controllerId);if(!U)return{};const{collection:de,profiles:ie}=U,ne=ie.get(N.profileId);if(!ne)return{};const H=N.testIds.map(Se=>de.tree.get(Se)).filter(k.isDefined),V=N.excludeExtIds.map(Se=>U.collection.tree.get(Se)).filter(k.isDefined).filter(Se=>H.some(ge=>ge.fullId.compare(Se.fullId)===2));if(!H.length)return{};const ce=new l.TestRunRequest(H.some(Se=>Se.actual instanceof E.TestItemRootImpl)?void 0:H.map(Se=>Se.actual),V.map(Se=>Se.actual),ne,q),be=(0,f.isStartControllerTests)(N)&&this.runTracker.prepareForMainThreadTestRun(ce,S.fromInternal(N,U.collection),x);try{return await ne.runHandler(ce,x),{}}catch(Se){return{error:String(Se)}}finally{be&&(be.hasRunningTasks&&!x.isCancellationRequested&&await R.Event.toPromise(be.onEnd),be.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(N)}};e.ExtHostTesting=s=Ve([ze(0,I.IExtHostRpcService)],s);const t=1e4;var u;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(u||(u={}));class p extends m.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(N,q,x){super(),this.dto=N,this.proxy=q,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new R.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new L.CancellationTokenSource(x));const U=this._register(new T.RunOnceScheduler(()=>this.forciblyEndTasks(),t));this._register(this.cts.token.onCancellationRequested(()=>U.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(N){return this.tasks.get(N)?.coverage}createRun(N){const q=this.dto.id,x=this.dto.controllerId,U=(0,w.generateUuid)(),de=new c(this.proxy,q,U),ie=ce=>(be,...Se)=>{if(H){console.warn(`Setting the state of test "${be.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(be)&&(this.ensureTestIsKnown(be),ce(be,...Se))},ne=(ce,be)=>{const Se=be instanceof Array?be.map(i.TestMessage.from):[i.TestMessage.from(be)];if(ce.uri&&ce.range){const ge={range:i.Range.from(ce.range),uri:ce.uri};for(const O of Se)O.location=O.location||ge}this.proxy.$appendTestMessagesInRun(q,U,a.TestId.fromExtHostTestItem(ce,x).toString(),Se)};let H=!1;const V={isPersisted:this.dto.isPersisted,token:this.cts.token,name:N,get coverageProvider(){return de.coverageProvider},set coverageProvider(ce){de.coverageProvider=ce},enqueued:ie(ce=>{this.proxy.$updateTestStateInRun(q,U,a.TestId.fromExtHostTestItem(ce,x).toString(),1)}),skipped:ie(ce=>{this.proxy.$updateTestStateInRun(q,U,a.TestId.fromExtHostTestItem(ce,x).toString(),5)}),started:ie(ce=>{this.proxy.$updateTestStateInRun(q,U,a.TestId.fromExtHostTestItem(ce,x).toString(),2)}),errored:ie((ce,be,Se)=>{ne(ce,be),this.proxy.$updateTestStateInRun(q,U,a.TestId.fromExtHostTestItem(ce,x).toString(),6,Se)}),failed:ie((ce,be,Se)=>{ne(ce,be),this.proxy.$updateTestStateInRun(q,U,a.TestId.fromExtHostTestItem(ce,x).toString(),4,Se)}),passed:ie((ce,be)=>{this.proxy.$updateTestStateInRun(q,U,a.TestId.fromExtHostTestItem(ce,this.dto.controllerId).toString(),3,be)}),appendOutput:(ce,be,Se)=>{H||(Se&&(this.dto.isIncluded(Se)?this.ensureTestIsKnown(Se):Se=void 0),this.proxy.$appendOutputToRun(q,U,d.VSBuffer.fromString(ce),be&&i.location.from(be),Se&&a.TestId.fromExtHostTestItem(Se,x).toString()))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(q,U),this.tasks.delete(U),this.tasks.size||this.markEnded())}};return this.tasks.set(U,{run:V,coverage:de}),this.proxy.$startedTestRunTask(q,{id:U,name:N,running:!0}),V}forciblyEndTasks(){for(const{run:N}of this.tasks.values())N.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(N){if(!(N instanceof E.TestItemImpl))throw new b.InvalidTestItemError(N.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(N,this.dto.controllerId).toString()))return;const q=[],x=this.dto.colllection.root;for(;;){const U=i.TestItem.from(N);if(q.unshift(U),this.sharedTestIds.has(U.extId)||(this.sharedTestIds.add(U.extId),N===x))break;N=N.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,q)}}class h{get trackers(){return this.tracked.values()}constructor(N){this.proxy=N,this.tracked=new Map}prepareForMainThreadTestRun(N,q,x){return this.getTracker(N,q,x)}cancelRunById(N){for(const q of this.tracked.values())if(q.id===N){q.cancel();return}}cancelAllRuns(){for(const N of this.tracked.values())N.cancel()}createTestRun(N,q,x,U,de){const ie=this.tracked.get(x);if(ie)return ie.createRun(U);const ne=S.fromPublic(N,q,x,de),H=C(x);this.proxy.$startedExtensionTestRun({controllerId:N,continuous:!!x.continuous,profile:H&&{group:$[H.kind],id:H.profileId},exclude:x.exclude?.map(ce=>a.TestId.fromExtHostTestItem(ce,q.root.id).toString())??[],id:ne.id,include:x.include?.map(ce=>a.TestId.fromExtHostTestItem(ce,q.root.id).toString())??[q.root.id],persist:de});const V=this.getTracker(x,ne);return V.onEnd(()=>{this.proxy.$finishedExtensionTestRun(ne.id),V.dispose()}),V.createRun(U)}getTracker(N,q,x){const U=new p(q,this.proxy,x);return this.tracked.set(N,U),U.onEnd(()=>this.tracked.delete(N)),U}}e.TestRunCoordinator=h;const C=z=>{if(z.profile){if(!(z.profile instanceof W))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class S{static fromPublic(N,q,x,U){return new S(N,(0,w.generateUuid)(),x.include?.map(de=>a.TestId.fromExtHostTestItem(de,N).toString())??[N],x.exclude?.map(de=>a.TestId.fromExtHostTestItem(de,N).toString())??[],U,q)}static fromInternal(N,q){return new S(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,q)}constructor(N,q,x,U,de,ie){this.controllerId=N,this.id=q,this.isPersisted=de,this.colllection=ie,this.includePrefix=x.map(ne=>ne+"\0"),this.excludePrefix=U.map(ne=>ne+"\0")}isIncluded(N){const q=a.TestId.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(q===x||q.startsWith(x))return!1;for(const x of this.includePrefix)if(q===x||q.startsWith(x))return!0;return!1}}e.TestRunDto=S;class c{set coverageProvider(N){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");N&&(this._coverageProvider=N,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(N,q,x){this.proxy=N,this.runId=q,this.taskId=x}async provideFileCoverage(N){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(N))());try{return(await this.fileCoverage)?.map(i.TestCoverage.fromFile)??[]}catch(q){throw this.fileCoverage=void 0,q}}async resolveFileCoverage(N,q){const x=await this.fileCoverage;let U=x?.[N];return!this._coverageProvider||!x||!U?[]:(U.detailedCoverage||(U=x[N]=await this._coverageProvider.resolveFileCoverage?.(U,q)??U),U.detailedCoverage?.map(i.TestCoverage.fromDetailed)??[])}}class r{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(N){this.emitter=N,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(N){this.added.add(N)}update(N){Object.assign(N.revived,i.TestItem.toPlain(N.item)),this.added.has(N)||this.updated.add(N)}remove(N){if(this.added.has(N)){this.added.delete(N);return}this.updated.delete(N);const q=a.TestId.parentId(N.item.extId);if(q&&this.alreadyRemoved.has(q.toString())){this.alreadyRemoved.add(N.item.extId);return}this.removed.add(N)}getChangeEvent(){const{added:N,updated:q,removed:x}=this;return{get added(){return[...N].map(U=>U.revived)},get updated(){return[...q].map(U=>U.revived)},get removed(){return[...x].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class P extends f.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new R.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(N){return this.items.get(N)}getMirroredTestDataByReference(N){return this.items.get(N.id)}createItem(N,q){return{...N,revived:i.TestItem.toPlain(N.item),depth:q?q.depth+1:0,children:new Set}}createChangeCollector(){return new r(this.changeEmitter)}}class M{constructor(N){this.proxy=N}checkout(){this.current||(this.current=this.createObserverData());const N=this.current;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(q=>q.revived)},dispose:(0,g.once)(()=>{--N.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(N){return this.current?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.current?.tests.apply(N)}createObserverData(){const N=new P;return this.proxy.$subscribeToDiffs(),{observers:0,tests:N}}}class W{get label(){return this._label}set label(N){N!==this._label&&(this._label=N,Fe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(N){N!==this._supportsContinuousRun&&(this._supportsContinuousRun=N,Fe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this._isDefault}set isDefault(N){N!==this._isDefault&&(this._isDefault=N,Fe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,Fe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?i.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(N){N!==this._configureHandler&&(this._configureHandler=N,Fe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}constructor(N,q,x,U,de,ie,ne,H=!1,V=void 0,ce=!1){this.controllerId=x,this.profileId=U,this._label=de,this.kind=ie,this.runHandler=ne,this._isDefault=H,this._tag=V,this._supportsContinuousRun=ce,n.set(this,void 0),o.set(this,void 0),Ye(this,n,N,"f"),Ye(this,o,q,"f"),q.set(U,this);const be=$[ie];if(typeof be!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);Fe(this,n,"f").$publishTestRunProfile({profileId:U,controllerId:x,tag:V?i.TestTag.namespace(this.controllerId,V.id):null,label:de,group:be,isDefault:H,hasConfigurationHandler:!1,supportsContinuousRun:ce})}dispose(){Fe(this,o,"f")?.delete(this.profileId)&&(Ye(this,o,void 0,"f"),Fe(this,n,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=W,n=new WeakMap,o=new WeakMap;const $={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(De[305],Ie([1,0,19,8,3,6,140,15,7]),function(re,e,v,T,d,L,R,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class m{constructor(k,w){this._extHostDocumentsAndEditors=w,this._onDidChangeTextEditorSelection=new d.Emitter({onListenerError:T.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new d.Emitter({onListenerError:T.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new d.Emitter({onListenerError:T.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new d.Emitter({onListenerError:T.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new d.Emitter({onListenerError:T.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new d.Emitter({onListenerError:T.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=k.getProxy(L.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(D=>this._onDidChangeVisibleTextEditors.fire(D)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(D=>this._onDidChangeActiveTextEditor.fire(D))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(k){const w=this._extHostDocumentsAndEditors.allEditors();return k?w:w.map(D=>D.value)}async showTextDocument(k,w,D){let I;typeof w=="number"?I={position:g.ViewColumn.from(w),preserveFocus:D}:typeof w=="object"?I={position:g.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?g.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:I={preserveFocus:!1};const E=await this._proxy.$tryShowTextDocument(k.uri,I),i=E&&this._extHostDocumentsAndEditors.getEditor(E);if(i)return i.value;throw E?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,w){return new R.TextEditorDecorationType(this._proxy,k,w).value}$acceptEditorPropertiesChanged(k,w){const D=this._extHostDocumentsAndEditors.getEditor(k);if(!D)throw new Error("unknown text editor");if(w.options&&D._acceptOptions(w.options),w.selections){const I=w.selections.selections.map(g.Selection.to);D._acceptSelections(I)}if(w.visibleRanges){const I=v.coalesce(w.visibleRanges.map(g.Range.to));D._acceptVisibleRanges(I)}if(w.options&&this._onDidChangeTextEditorOptions.fire({textEditor:D.value,options:{...w.options,lineNumbers:g.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const I=y.TextEditorSelectionChangeKind.fromValue(w.selections.source),E=w.selections.selections.map(g.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:D.value,selections:E,kind:I})}if(w.visibleRanges){const I=v.coalesce(w.visibleRanges.map(g.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:D.value,visibleRanges:I})}}$acceptEditorPositionData(k){for(const w in k){const D=this._extHostDocumentsAndEditors.getEditor(w);if(!D)throw new Error("Unknown text editor");const I=g.ViewColumn.to(k[w]);D.value.viewColumn!==I&&(D._acceptViewColumn(I),this._onDidChangeTextEditorViewColumn.fire({textEditor:D.value,viewColumn:I}))}}getDiffInformation(k){return Promise.resolve(this._proxy.$getDiffInformation(k))}}e.ExtHostEditors=m}),define(De[306],Ie([1,0,2,5,6,4,7,15,25,12]),function(re,e,v,T,d,L,R,g,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class A{constructor(D,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=D.getProxy(d.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:(E,i)=>{if(E&&E.$mid===12)if(this._providers.get(E.source)&&y.ExtensionIdentifier.equals(i,this._providers.get(E.source)?.extension)){const l=E.uri===void 0?void 0:v.URI.revive(E.uri);return this._itemsBySourceAndUriMap.get(E.source)?.get(k(l))?.get(E.handle)}else return;return E}})}async $getTimeline(D,I,E,i){return this._providers.get(D)?.provider.provideTimeline(v.URI.revive(I),E,i)}registerTimelineProvider(D,I,E,i){const l=new L.DisposableStore,a=this.convertTimelineItem(I.id,i,l).bind(this);let b;I.onDidChange&&(b=I.onDidChange(_=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,..._,id:I.id}),this));const f=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:D,onDidChange:void 0,async provideTimeline(_,n,o){n?.resetCache&&(l.clear(),f.get(I.id)?.clear());const s=await I.provideTimeline(_,n,o);if(s==null)return;const t=a(_,n);return{...s,source:I.id,items:s.items.map(t)}},dispose(){for(const _ of f.values())_.get(I.id)?.clear();b?.dispose(),l.dispose()}},E)}convertTimelineItem(D,I,E){return(i,l)=>{let a;if(l?.cacheResults){let b=this._itemsBySourceAndUriMap.get(D);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(D,b));const f=k(i);a=b.get(f),a===void 0&&(a=new Map,b.set(f,a))}return b=>{const{iconPath:f,..._}=b,n=`${D}|${b.id??b.timestamp}`;a?.set(n,b);let o,s,t;b.iconPath&&(f instanceof R.ThemeIcon?t={id:f.id,color:f.color}:v.URI.isUri(f)?(o=f,s=f):{light:o,dark:s}=f);let u;return R.MarkdownString.isMarkdownString(_.tooltip)?u=g.MarkdownString.from(_.tooltip):(0,m.isString)(_.tooltip)?u=_.tooltip:R.MarkdownString.isMarkdownString(_.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=g.MarkdownString.from(_.detail)):(0,m.isString)(_.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=_.detail),{..._,id:_.id??void 0,handle:n,source:D,command:b.command?I.toInternal(b.command,E):void 0,icon:o,iconDark:s,themeIcon:t,tooltip:u,accessibilityInformation:b.accessibilityInformation}}}}registerTimelineProviderCore(D,I){if(this._providers.get(D.id))throw new Error(`Timeline Provider ${D.id} already exists.`);return this._proxy.$registerTimelineProvider({id:D.id,label:D.label,scheme:D.scheme}),this._providers.set(D.id,{provider:D,extension:I}),(0,L.toDisposable)(()=>{for(const i of this._itemsBySourceAndUriMap.values())i.get(D.id)?.clear();this._providers.delete(D.id),this._proxy.$unregisterTimelineProvider(D.id),D.dispose()})}}e.ExtHostTimeline=A;function k(w){return w?.toString()}}),define(De[307],Ie([1,0,4,16,2,6]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(y){this._openers=new Map,this._proxy=y.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,m,A,k){if(this._openers.has(m))throw new Error(`Opener with id '${m}' already registered`);const w=k.schemes.find(D=>!R.supportedSchemes.has(D));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this._openers.set(m,A),this._proxy.$registerUriOpener(m,k.schemes,y,k.label),(0,v.toDisposable)(()=>{this._openers.delete(m),this._proxy.$unregisterUriOpener(m)})}async $canOpenUri(y,m,A){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener with id: ${y}`);const w=d.URI.revive(m);return k.canOpenExternalUri(w,A)}async $openUri(y,m,A){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener id: '${y}'`);return k.openExternalUri(d.URI.revive(m.resolvedUri),{sourceUri:d.URI.revive(m.sourceUri)},A)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([T.Schemas.http,T.Schemas.https])}),define(De[308],Ie([1,0,6,2,4,8,25]),function(re,e,v,T,d,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class g{constructor(m){this.handles=new R.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=m.getProxy(v.MainContext.MainThreadUrls)}registerUriHandler(m,A){const k=m.identifier;if(this.handles.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const w=g.HandlePool++;return this.handles.add(k),this.handlers.set(w,A),this._proxy.$registerUriHandler(w,k,m.displayName||m.name),(0,d.toDisposable)(()=>{this.handles.delete(k),this.handlers.delete(w),this._proxy.$unregisterUriHandler(w)})}$handleExternalUri(m,A){const k=this.handlers.get(m);if(!k)return Promise.resolve(void 0);try{k.handleUri(T.URI.revive(A))}catch(w){(0,L.onUnexpectedError)(w)}return Promise.resolve(void 0)}async createAppUri(m){return T.URI.revive(await this._proxy.$createAppUri(m))}}e.ExtHostUrls=g,g.HandlePool=0});var Ye=this&&this.__classPrivateFieldSet||function(re,e,v,T,d){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!d)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!d:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?d.call(re,v):d?d.value=v:e.set(re,v),v},Fe=this&&this.__classPrivateFieldGet||function(re,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!T:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(re):T?T.value:e.get(re)};define(De[85],Ie([1,0,3,16,24,2,212,245,104,6]),function(re,e,v,T,d,L,R,g,y,m){"use strict";var A,k,w,D,I,E,i,l,a,b,f,_,n;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(r,P,M,W,$,z,N){A.set(this,void 0),k.set(this,void 0),w.set(this,void 0),D.set(this,void 0),I.set(this,void 0),E.set(this,void 0),i.set(this,""),l.set(this,void 0),a.set(this,!1),b.set(this,!1),f.set(this,void 0),_.set(this,void 0),this._onMessageEmitter=new v.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,n.set(this,new v.Emitter),this._onDidDispose=Fe(this,n,"f").event,Ye(this,A,r,"f"),Ye(this,k,P,"f"),Ye(this,l,M,"f"),Ye(this,D,W,"f"),Ye(this,I,$,"f"),Ye(this,E,z,"f"),Ye(this,f,s(z),"f"),Ye(this,_,t(z),"f"),Ye(this,w,N,"f")}dispose(){Ye(this,a,!0,"f"),Fe(this,n,"f").fire(),Fe(this,n,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return Ye(this,b,!0,"f"),(0,y.asWebviewUri)(r,Fe(this,D,"f"))}get cspSource(){const r=Fe(this,E,"f").extensionLocation;if(r.scheme===T.Schemas.https||r.scheme===T.Schemas.http){let P=r.toString();return P.endsWith("/")||(P+="/"),P+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Fe(this,i,"f")}set html(r){this.assertNotDisposed(),Fe(this,i,"f")!==r&&(Ye(this,i,r,"f"),Fe(this,_,"f")&&!Fe(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(Ye(this,b,!0,"f"),Fe(this,w,"f").report("Webview vscode-resource: uris",Fe(this,E,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Fe(this,k,"f").$setHtml(Fe(this,A,"f"),this.rewriteOldResourceUrlsIfNeeded(r)))}get options(){return this.assertNotDisposed(),Fe(this,l,"f")}set options(r){this.assertNotDisposed(),d.equals(Fe(this,l,"f"),r)||Fe(this,k,"f").$setOptions(Fe(this,A,"f"),h(Fe(this,E,"f"),Fe(this,I,"f"),r)),Ye(this,l,r,"f")}async postMessage(r){if(Fe(this,a,"f"))return!1;const P=(0,g.serializeWebviewMessage)(r,{serializeBuffersForPostMessage:Fe(this,f,"f")});return Fe(this,k,"f").$postMessage(Fe(this,A,"f"),P.message,...P.buffers)}assertNotDisposed(){if(Fe(this,a,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(r){if(!Fe(this,_,"f"))return r;const P=Fe(this,E,"f").extensionLocation?.scheme===T.Schemas.vscodeRemote,M=Fe(this,E,"f").extensionLocation.scheme===T.Schemas.vscodeRemote?Fe(this,E,"f").extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(W,$,z,N,q,x)=>{const U=L.URI.from({scheme:N||"file",path:decodeURIComponent(q)}),de=(0,y.asWebviewUri)(U,{isRemote:P,authority:M}).toString();return`${$}${de}${x}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(W,$,z,N,q,x)=>{const U=L.URI.from({scheme:N||"file",path:decodeURIComponent(q)}),de=(0,y.asWebviewUri)(U,{isRemote:P,authority:M}).toString();return`${$}${de}${x}`})}}e.ExtHostWebview=o,A=new WeakMap,k=new WeakMap,w=new WeakMap,D=new WeakMap,I=new WeakMap,E=new WeakMap,i=new WeakMap,l=new WeakMap,a=new WeakMap,b=new WeakMap,f=new WeakMap,_=new WeakMap,n=new WeakMap;function s(c){try{const r=(0,R.normalizeVersion)((0,R.parseVersion)(c.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;function t(c){try{const r=(0,R.normalizeVersion)((0,R.parseVersion)(c.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class u{constructor(r,P,M,W,$){this.remoteInfo=P,this.workspace=M,this._logService=W,this._deprecationService=$,this._webviews=new Map,this._webviewProxy=r.getProxy(m.MainContext.MainThreadWebviews)}$onMessage(r,P,M){const W=this.getWebview(r);if(W){const{message:$}=(0,g.deserializeWebviewMessage)(P,M.value);W._onMessageEmitter.fire($)}}$onMissingCsp(r,P){this._logService.warn(`${P} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,P,M){const W=new o(r,this._webviewProxy,C(P),this.remoteInfo,this.workspace,M,this._deprecationService);return this._webviews.set(r,W),W._onDidDispose(()=>{this._webviews.delete(r)}),W}deleteWebview(r){this._webviews.delete(r)}getWebview(r){return this._webviews.get(r)}}e.ExtHostWebviews=u;function p(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=p;function h(c,r,P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,enableForms:P.enableForms,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots||S(c,r)}}e.serializeWebviewOptions=h;function C(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(r=>L.URI.from(r))}}function S(c,r){return[...(r?.getWorkspaceFolders()||[]).map(P=>P.uri),c.extensionLocation]}}),define(De[309],Ie([1,0,21,70,4,16,23,2,15,85,80,6,7]),function(re,e,v,T,d,L,R,g,y,m,A,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class D{constructor(o,s){this.document=o,this._storagePath=s,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(o){return this._edits.add([o])}async undo(o,s){await this.getEdit(o).undo(),s||this.disposeBackup()}async redo(o,s){await this.getEdit(o).redo(),s||this.disposeBackup()}disposeEdits(o){for(const s of o)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const o=_(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,o)}updateBackup(o){this._backup?.delete(),this._backup=o}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(o){const s=this._edits.get(o,0);if(!s)throw new Error("No edit found");return s}}class I{constructor(){this._documents=new Map}get(o,s){return this._documents.get(this.key(o,s))}add(o,s,t){const u=this.key(o,s.uri);if(this._documents.has(u))throw new Error(`Document already exists for viewType:${o} resource:${s.uri}`);const p=new D(s,t);return this._documents.set(u,p),p}delete(o,s){const t=this.key(o,s.uri);this._documents.delete(t)}key(o,s){return`${o}@@@${s}`}}var E;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(E||(E={}));class i{constructor(){this._providers=new Map}addTextProvider(o,s,t){return this.add(0,o,s,t)}addCustomProvider(o,s,t){return this.add(1,o,s,t)}get(o){return this._providers.get(o)}add(o,s,t,u){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:o,extension:t,provider:u}),new w.Disposable(()=>this._providers.delete(s))}}class l{constructor(o,s,t,u,p){this._extHostDocuments=s,this._extensionStoragePaths=t,this._extHostWebview=u,this._extHostWebviewPanels=p,this._editorProviders=new i,this._documents=new I,this._proxy=o.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,s,t,u){const p=new d.DisposableStore;return b(t)?(p.add(this._editorProviders.addTextProvider(s,o,t)),this._proxy.$registerTextEditorProvider((0,m.toExtensionData)(o),s,u.webviewOptions||{},{supportsMove:!!t.moveCustomTextEditor},(0,m.shouldSerializeBuffersForPostMessage)(o))):(p.add(this._editorProviders.addCustomProvider(s,o,t)),a(t)&&p.add(t.onDidChangeCustomDocument(h=>{const C=this.getCustomDocumentEntry(s,h.document.uri);if(f(h)){const S=C.addEdit(h);this._proxy.$onDidEdit(h.document.uri,s,S,h.label)}else this._proxy.$onContentChange(h.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,m.toExtensionData)(o),s,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument,(0,m.shouldSerializeBuffersForPostMessage)(o))),w.Disposable.from(p,new w.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(o,s,t,u,p){const h=this._editorProviders.get(s);if(!h)throw new Error(`No provider found for '${s}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${s}'`);const C=g.URI.revive(o),S=await h.provider.openCustomDocument(C,{backupId:t,untitledDocumentData:u?.buffer},p);let c;return a(h.provider)&&this._extensionStoragePaths&&(c=this._extensionStoragePaths.workspaceValue(h.extension)??this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(s,S,c),{editable:a(h.provider)}}async $disposeCustomDocument(o,s){const t=this._editorProviders.get(s);if(!t)throw new Error(`No provider found for '${s}'`);if(t.type!==1)throw new Error(`Invalid provider type for '${s}'`);const u=g.URI.revive(o),{document:p}=this.getCustomDocumentEntry(s,u);this._documents.delete(s,p),p.dispose()}async $resolveCustomEditor(o,s,t,u,p,h){const C=this._editorProviders.get(t);if(!C)throw new Error(`No provider found for '${t}'`);const S=y.ViewColumn.to(p),c=this._extHostWebview.createNewWebview(s,u.contentOptions,C.extension),r=this._extHostWebviewPanels.createNewWebviewPanel(s,t,u.title,S,u.options,c,u.active),P=g.URI.revive(o);switch(C.type){case 1:{const{document:M}=this.getCustomDocumentEntry(t,P);return C.provider.resolveCustomEditor(M,r,h)}case 0:{const M=this._extHostDocuments.getDocument(P);return C.provider.resolveCustomTextEditor(M,r,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,s,t){this.getCustomDocumentEntry(s,o).disposeEdits(t)}async $onMoveCustomEditor(o,s,t){const u=this._editorProviders.get(t);if(!u)throw new Error(`No provider found for '${t}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${t}'`);const p=this._extHostWebviewPanels.getWebviewPanel(o);if(!p)throw new Error("No webview found");const h=g.URI.revive(s),C=this._extHostDocuments.getDocument(h);await u.provider.moveCustomTextEditor(C,p,v.CancellationToken.None)}async $undo(o,s,t,u){return this.getCustomDocumentEntry(s,o).undo(t,u)}async $redo(o,s,t,u){return this.getCustomDocumentEntry(s,o).redo(t,u)}async $revert(o,s,t){const u=this.getCustomDocumentEntry(s,o);await this.getCustomEditorProvider(s).revertCustomDocument(u.document,t),u.disposeBackup()}async $onSave(o,s,t){const u=this.getCustomDocumentEntry(s,o);await this.getCustomEditorProvider(s).saveCustomDocument(u.document,t),u.disposeBackup()}async $onSaveAs(o,s,t,u){const p=this.getCustomDocumentEntry(s,o);return this.getCustomEditorProvider(s).saveCustomDocumentAs(p.document,g.URI.revive(t),u)}async $backup(o,s,t){const u=this.getCustomDocumentEntry(s,o),h=await this.getCustomEditorProvider(s).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},t);return u.updateBackup(h),h.id}getCustomDocumentEntry(o,s){const t=this._documents.get(o,g.URI.revive(s));if(!t)throw new Error("No custom document found");return t}getCustomEditorProvider(o){const t=this._editorProviders.get(o)?.provider;if(!t||!a(t))throw new Error("Custom document is not editable");return t}}e.ExtHostCustomEditors=l;function a(n){return!!n.onDidChangeCustomDocument}function b(n){return typeof n.resolveCustomTextEditor=="function"}function f(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function _(n){const o=n.scheme===L.Schemas.file||n.scheme===L.Schemas.untitled?n.fsPath:n.toString();return(0,T.hash)(o)+""}});var Ye=this&&this.__classPrivateFieldSet||function(re,e,v,T,d){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!d)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!d:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?d.call(re,v):d?d.value=v:e.set(re,v),v},Fe=this&&this.__classPrivateFieldGet||function(re,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!T:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(re):T?T.value:e.get(re)};define(De[310],Ie([1,0,3,4,2,32,15,85,6,7]),function(re,e,v,T,d,L,R,g,y,m){"use strict";var A,k,w,D,I,E,i,l,a,b,f,_,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends T.Disposable{constructor(p,h,C,S){super(),A.set(this,void 0),k.set(this,void 0),w.set(this,void 0),D.set(this,void 0),I.set(this,void 0),E.set(this,void 0),i.set(this,void 0),l.set(this,void 0),a.set(this,!0),b.set(this,void 0),f.set(this,!1),_.set(this,this._register(new v.Emitter)),this.onDidDispose=Fe(this,_,"f").event,n.set(this,this._register(new v.Emitter)),this.onDidChangeViewState=Fe(this,n,"f").event,Ye(this,A,p,"f"),Ye(this,k,h,"f"),Ye(this,D,C,"f"),Ye(this,w,S.viewType,"f"),Ye(this,I,S.panelOptions,"f"),Ye(this,l,S.viewColumn,"f"),Ye(this,E,S.title,"f"),Ye(this,b,S.active,"f")}dispose(){Fe(this,f,"f")||(Ye(this,f,!0,"f"),Fe(this,_,"f").fire(),Fe(this,k,"f").$disposeWebview(Fe(this,A,"f")),Fe(this,D,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Fe(this,D,"f")}get viewType(){return this.assertNotDisposed(),Fe(this,w,"f")}get title(){return this.assertNotDisposed(),Fe(this,E,"f")}set title(p){this.assertNotDisposed(),Fe(this,E,"f")!==p&&(Ye(this,E,p,"f"),Fe(this,k,"f").$setTitle(Fe(this,A,"f"),p))}get iconPath(){return this.assertNotDisposed(),Fe(this,i,"f")}set iconPath(p){this.assertNotDisposed(),Fe(this,i,"f")!==p&&(Ye(this,i,p,"f"),Fe(this,k,"f").$setIconPath(Fe(this,A,"f"),d.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return Fe(this,I,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Fe(this,l,"f")=="number"&&Fe(this,l,"f")<0))return Fe(this,l,"f")}get active(){return this.assertNotDisposed(),Fe(this,b,"f")}get visible(){return this.assertNotDisposed(),Fe(this,a,"f")}_updateViewState(p){Fe(this,f,"f")||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(Ye(this,b,p.active,"f"),Ye(this,a,p.visible,"f"),Ye(this,l,p.viewColumn,"f"),Fe(this,n,"f").fire({webviewPanel:this}))}reveal(p,h){this.assertNotDisposed(),Fe(this,k,"f").$reveal(Fe(this,A,"f"),{viewColumn:typeof p>"u"?void 0:R.ViewColumn.from(p),preserveFocus:!!h})}assertNotDisposed(){if(Fe(this,f,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,k=new WeakMap,w=new WeakMap,D=new WeakMap,I=new WeakMap,E=new WeakMap,i=new WeakMap,l=new WeakMap,a=new WeakMap,b=new WeakMap,f=new WeakMap,_=new WeakMap,n=new WeakMap;class s{static newHandle(){return(0,L.generateUuid)()}constructor(p,h,C){this.webviews=h,this.workspace=C,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=p.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(p,h,C,S,c={}){const r=typeof S=="object"?S.viewColumn:S,P={viewColumn:R.ViewColumn.from(r),preserveFocus:typeof S=="object"&&!!S.preserveFocus},M=(0,g.shouldSerializeBuffersForPostMessage)(p),W=s.newHandle();this._proxy.$createWebviewPanel((0,g.toExtensionData)(p),W,h,{title:C,panelOptions:t(c),webviewOptions:(0,g.serializeWebviewOptions)(p,this.workspace,c),serializeBuffersForPostMessage:M},P);const $=this.webviews.createNewWebview(W,c,p);return this.createNewWebviewPanel(W,h,C,r,c,$,!0)}$onDidChangeWebviewPanelViewStates(p){const h=Object.keys(p);h.sort((C,S)=>{const c=p[C],r=p[S];return c.active?1:r.active?-1:+c.visible-+r.visible});for(const C of h){const S=this.getWebviewPanel(C);if(!S)continue;const c=p[C];S._updateViewState({active:c.active,visible:c.visible,viewColumn:R.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this._webviewPanels.delete(p),this.webviews.deleteWebview(p)}registerWebviewPanelSerializer(p,h,C){if(this._serializers.has(h))throw new Error(`Serializer for '${h}' already registered`);return this._serializers.set(h,{serializer:C,extension:p}),this._proxy.$registerSerializer(h,{serializeBuffersForPostMessage:(0,g.shouldSerializeBuffersForPostMessage)(p)}),new m.Disposable(()=>{this._serializers.delete(h),this._proxy.$unregisterSerializer(h)})}async $deserializeWebviewPanel(p,h,C,S){const c=this._serializers.get(h);if(!c)throw new Error(`No serializer found for '${h}'`);const{serializer:r,extension:P}=c,M=this.webviews.createNewWebview(p,C.webviewOptions,P),W=this.createNewWebviewPanel(p,h,C.title,S,C.panelOptions,M,C.active);await r.deserializeWebviewPanel(W,C.state)}createNewWebviewPanel(p,h,C,S,c,r,P){const M=new o(p,this._proxy,r,{viewType:h,title:C,viewColumn:S,panelOptions:c,active:P});return this._webviewPanels.set(p,M),M}getWebviewPanel(p){return this._webviewPanels.get(p)}}e.ExtHostWebviewPanels=s;function t(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(re,e,v,T,d){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!d)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!d:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?d.call(re,v):d?d.value=v:e.set(re,v),v},Fe=this&&this.__classPrivateFieldGet||function(re,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!T:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(re):T?T.value:e.get(re)};define(De[311],Ie([1,0,3,4,85,15,6,7]),function(re,e,v,T,d,L,R,g){"use strict";var y,m,A,k,w,D,I,E,i,l,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends T.Disposable{constructor(n,o,s,t,u,p){super(),y.set(this,void 0),m.set(this,void 0),A.set(this,void 0),k.set(this,void 0),w.set(this,!1),D.set(this,void 0),I.set(this,void 0),E.set(this,void 0),i.set(this,void 0),l.set(this,this._register(new v.Emitter)),this.onDidChangeVisibility=Fe(this,l,"f").event,a.set(this,this._register(new v.Emitter)),this.onDidDispose=Fe(this,a,"f").event,Ye(this,A,s,"f"),Ye(this,I,t,"f"),Ye(this,y,n,"f"),Ye(this,m,o,"f"),Ye(this,k,u,"f"),Ye(this,D,p,"f")}dispose(){Fe(this,w,"f")||(Ye(this,w,!0,"f"),Fe(this,a,"f").fire(),Fe(this,k,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Fe(this,I,"f")}set title(n){this.assertNotDisposed(),Fe(this,I,"f")!==n&&(Ye(this,I,n,"f"),Fe(this,m,"f").$setWebviewViewTitle(Fe(this,y,"f"),n))}get description(){return this.assertNotDisposed(),Fe(this,E,"f")}set description(n){this.assertNotDisposed(),Fe(this,E,"f")!==n&&(Ye(this,E,n,"f"),Fe(this,m,"f").$setWebviewViewDescription(Fe(this,y,"f"),n))}get visible(){return Fe(this,D,"f")}get webview(){return Fe(this,k,"f")}get viewType(){return Fe(this,A,"f")}_setVisible(n){n===Fe(this,D,"f")||Fe(this,w,"f")||(Ye(this,D,n,"f"),Fe(this,l,"f").fire())}get badge(){return this.assertNotDisposed(),Fe(this,i,"f")}set badge(n){this.assertNotDisposed(),!(n?.value===Fe(this,i,"f")?.value&&n?.tooltip===Fe(this,i,"f")?.tooltip)&&(Ye(this,i,L.ViewBadge.from(n),"f"),Fe(this,m,"f").$setWebviewViewBadge(Fe(this,y,"f"),n))}show(n){this.assertNotDisposed(),Fe(this,m,"f").$show(Fe(this,y,"f"),!!n)}assertNotDisposed(){if(Fe(this,w,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,m=new WeakMap,A=new WeakMap,k=new WeakMap,w=new WeakMap,D=new WeakMap,I=new WeakMap,E=new WeakMap,i=new WeakMap,l=new WeakMap,a=new WeakMap;class f{constructor(n,o){this._extHostWebview=o,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=n.getProxy(R.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(n,o,s,t){if(this._viewProviders.has(o))throw new Error(`View provider for '${o}' already registered`);return this._viewProviders.set(o,{provider:s,extension:n}),this._proxy.$registerWebviewViewProvider((0,d.toExtensionData)(n),o,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,d.shouldSerializeBuffersForPostMessage)(n)}),new g.Disposable(()=>{this._viewProviders.delete(o),this._proxy.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(n,o,s,t,u){const p=this._viewProviders.get(o);if(!p)throw new Error(`No view provider found for '${o}'`);const{provider:h,extension:C}=p,S=this._extHostWebview.createNewWebview(n,{},C),c=new b(n,this._proxy,o,s,S,!0);this._webviewViews.set(n,c),await h.resolveWebviewView(c,{state:t},u)}async $onDidChangeWebviewViewVisibility(n,o){this.getWebviewView(n)._setVisible(o)}async $disposeWebviewView(n){const o=this.getWebviewView(n);this._webviewViews.delete(n),o.dispose(),this._extHostWebview.deleteWebview(n)}getWebviewView(n){const o=this._webviewViews.get(n);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=f}),define(De[144],Ie([1,0,3,6,2,16,9,5,20,27]),function(re,e,v,T,d,L,R,g,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=e.ExtHostWindow=class Rn{getState(w){const D=this._state;return{get focused(){return D.focused},get active(){return(0,m.checkProposedApiEnabled)(w,"windowActivity"),D.active}}}constructor(w){this._onDidChangeWindowState=new v.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Rn.InitialState,this._proxy=w.getProxy(T.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:D,isActive:I})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",I)})}$onDidChangeWindowFocus(w){this.onDidChangeWindowProperty("focused",w)}$onDidChangeWindowActive(w){this.onDidChangeWindowProperty("active",w)}onDidChangeWindowProperty(w,D){D!==this._state[w]&&(this._state={...this._state,[w]:D},this._onDidChangeWindowState.fire(this._state))}openUri(w,D){let I;if(typeof w=="string"){I=w;try{w=d.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,R.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this._proxy.$openUri(w,I,D)}async asExternalUri(w,D){if((0,R.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const I=await this._proxy.$asExternalUri(w,D);return d.URI.from(I)}};A.InitialState={focused:!0,active:!0},e.ExtHostWindow=A=Ve([ze(0,y.IExtHostRpcService)],A),e.IExtHostWindow=(0,g.createDecorator)("IExtHostWindow")}),define(De[312],Ie([1,0,280,26,20]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const L=1024*1024;let R=e.ExtHostConsoleForwarder=class extends v.AbstractExtHostConsoleForwarder{constructor(y,m){super(y,m),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(y,m,A){const k=y==="error"||y==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,k.write(`
START_NATIVE_LOG
`),m.apply(console,A),k.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(y,m){const A=process[y],k=A.write;let w="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(D,I,E)=>{if(!this._isMakingConsoleCall){w+=D.toString(I);const i=w.length>L?w.length:w.lastIndexOf(`
`);i!==-1&&(console[m](w.slice(0,i)),w=w.slice(i+1))}k.call(A,D,I,E)}})}};e.ExtHostConsoleForwarder=R=Ve([ze(0,d.IExtHostRpcService),ze(1,T.IExtHostInitDataService)],R)}),define(De[313],Ie([1,0,64,16,18,224,30,10]),function(re,e,v,T,d,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiskFileSystemProvider=void 0;let y=e.ExtHostDiskFileSystemProvider=class{constructor(k,w){k.addFileSystemProvider(T.Schemas.file,new m(w),{isCaseSensitive:g.isLinux})}};e.ExtHostDiskFileSystemProvider=y=Ve([ze(0,v.IExtHostConsumerFileSystem),ze(1,d.ILogService)],y);class m{constructor(k){this.logService=k,this.impl=new L.DiskFileSystemProvider(this.logService)}async stat(k){const w=await this.impl.stat(k);return{type:w.type,ctime:w.ctime,mtime:w.mtime,size:w.size,permissions:w.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(k){return this.impl.readdir(k)}createDirectory(k){return this.impl.mkdir(k)}readFile(k){return this.impl.readFile(k)}writeFile(k,w,D){return this.impl.writeFile(k,w,{...D,unlock:!1,atomic:!1})}delete(k,w){return this.impl.delete(k,{...w,useTrash:!1,atomic:!1})}rename(k,w,D){return this.impl.rename(k,w,D)}copy(k,w,D){return this.impl.copy(k,w,D)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(k,w){throw new Error("Method not implemented.")}}}),define(De[314],Ie([1,0,11,74,32,36,4,6,2,20]),function(re,e,v,T,d,L,R,g,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let A=e.ExtHostDownloadService=class extends R.Disposable{constructor(w,D){super();const I=w.getProxy(g.MainContext.MainThreadDownloadService);D.registerCommand(!1,"_workbench.downloadResource",async E=>{const i=y.URI.file((0,v.join)((0,T.tmpdir)(),(0,d.generateUuid)()));return await I.$download(E,i),i})}};e.ExtHostDownloadService=A=Ve([ze(0,m.IExtHostRpcService),ze(1,L.IExtHostCommands)],A)}),define(De[315],Ie([1,0,143,16,226,32]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class R extends v.ExtHostLoggerService{doCreateLogger(y,m,A){return y.scheme===T.Schemas.file?new d.SpdLogLogger(A?.name||(0,L.generateUuid)(),y.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,m):super.doCreateLogger(y,m,A)}registerLogger(y){super.registerLogger(y),this._proxy.$registerLogger(y)}deregisterLogger(y){super.deregisterLogger(y),this._proxy.$deregisterLogger(y)}}e.ExtHostLoggerService=R}),define(De[316],Ie([1,0,49,11,2,84,4,16,17,29]),function(re,e,v,T,d,L,R,g,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class A extends L.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(n){const o=await super._getWorkspaceStorageURI(n);if(o.scheme!==g.Schemas.file)return o;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const s=o.fsPath;let t=0;do{let u;t===0?u=s:u=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${t}`:`${s}-${t}`,await k(u);const p=T.join(u,"vscode.lock"),h=await E(this._logService,p,!1);if(h)return this._workspaceStorageLock=h,process.on("exit",()=>{h.dispose()}),d.URI.file(u);t++}while(t<10);return o}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=A;async function k(_){try{await m.Promises.stat(_);return}catch{}try{await m.Promises.mkdir(_,{recursive:!0})}catch{}}const w=1e3,D=10*60*1e3;class I extends R.Disposable{constructor(n,o){super(),this.logService=n,this.filename=o,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await i(n,o);(!s||s.pid!==process.pid)&&(n.info(`Lock '${o}': The lock was lost unexpectedly.`),this._timer.cancel());try{await m.Promises.utimes(o,new Date,new Date)}catch(t){n.error(t),n.info(`Lock '${o}': Could not update mtime.`)}},w)}dispose(){super.dispose();try{v.unlinkSync(this.filename)}catch{}}async setWillRelease(n){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${n} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+n};await m.Promises.writeFile(this.filename,JSON.stringify(o),{flag:"w"})}catch(o){this.logService.error(o)}}}async function E(_,n,o){try{const t={pid:process.pid,willReleaseAt:0};await m.Promises.writeFile(n,JSON.stringify(t),{flag:"wx"})}catch(t){_.error(t)}const s=await i(_,n);return!s||s.pid!==process.pid?o?(_.info(`Lock '${n}': Could not acquire lock, giving up.`),null):(_.info(`Lock '${n}': Could not acquire lock, checking if the file is stale.`),b(_,n)):(_.info(`Lock '${n}': Lock acquired.`),new I(_,n))}async function i(_,n){let o;try{o=await m.Promises.readFile(n)}catch(s){return _.error(s),null}try{return JSON.parse(String(o))}catch(s){return _.error(s),null}}async function l(_,n){let o;try{o=await m.Promises.stat(n)}catch(s){return _.error(s),0}return o.mtime.getTime()}function a(_){try{return process.kill(_,0),!0}catch{return!1}}async function b(_,n){const o=await i(_,n);if(!o)return _.info(`Lock '${n}': Could not read pid of lock holder.`),f(_,n);if(o.willReleaseAt){let h=o.willReleaseAt-Date.now();if(h<5e3){for(h>0?_.info(`Lock '${n}': The lockfile is scheduled to be released in ${h} ms.`):_.info(`Lock '${n}': The lockfile is scheduled to have been released.`);h>0;){if(await(0,y.timeout)(Math.min(100,h)),await l(_,n)===0)return f(_,n);h=o.willReleaseAt-Date.now()}return f(_,n)}}if(!a(o.pid))return _.info(`Lock '${n}': The pid ${o.pid} appears to be gone.`),f(_,n);const s=await l(_,n),t=Date.now()-s;if(t<=D)return _.info(`Lock '${n}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;_.info(`Lock '${n}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const u=await l(_,n),p=Date.now()-u;return p<=D?(_.info(`Lock '${n}': The lock does not look stale, elapsed: ${p} ms, giving up.`),null):(_.info(`Lock '${n}': The lock looks stale even after waiting for 2s.`),f(_,n))}async function f(_,n){_.info(`Lock '${n}': Deleting a stale lock.`);try{await m.Promises.unlink(n)}catch{}return E(_,n,!0)}}),define(De[317],Ie([1,0,32,20,43]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let L=e.ExtHostTerminalService=class extends d.BaseExtHostTerminalService{constructor(g){super(!0,g)}createTerminal(g,y,m){return this.createTerminalFromOptions({name:g,shellPath:y,shellArgs:m})}createTerminalFromOptions(g,y){const m=new d.ExtHostTerminal(this._proxy,(0,v.generateUuid)(),g,g.name);return this._terminals.push(m),m.create(g,this._serializeParentTerminal(g,y)),m.value}};e.ExtHostTerminalService=L=Ve([ze(0,T.IExtHostRpcService)],L)}),define(De[318],Ie([1,0,6,20,200,4,26,2,46,23,29,7,10,58,3,132,112,18]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class a extends E.DisposableTunnel{}function b(h){const C=h.trim().split(`
`),S=[];return C.forEach(r=>{const P=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(r);P&&P.length>=3&&S.push({pid:parseInt(P[1],10),socket:parseInt(P[2],10)})}),S.reduce((r,P)=>(r[P.socket]=P,r),{})}e.getSockets=b;function f(...h){const C=[].concat(...h.map(n));return[...new Map(C.filter(S=>S.st==="0A").map(S=>{const c=S.local_address.split(":");return{socket:parseInt(S.inode,10),ip:_(c[0]),port:parseInt(c[1],16)}}).map(S=>[S.ip+":"+S.port,S])).values()]}e.loadListeningPorts=f;function _(h){let C="";if(h.length===8)for(let S=h.length-2;S>=0;S-=2)C+=parseInt(h.substr(S,2),16),S!==0&&(C+=".");else for(let S=0;S<h.length;S+=8){const c=h.substring(S,S+8);let r="";for(let P=8;P>=2;P-=2)r+=c.substring(P-2,P),(P===6||P===2)&&(r=parseInt(r,16).toString(16),C+=`${r}`,r="",S+P!==h.length-6&&(C+=":"))}return C}e.parseIpAddress=_;function n(h){const C=h.trim().split(`
`),S=C.shift().trim().split(/\s+/).filter(r=>r!=="rx_queue"&&r!=="tm->when");return C.map(r=>r.trim().split(/\s+/).reduce((P,M,W)=>(P[S[W]||W]=M,P),{}))}e.loadConnectionTable=n;function o(h){return!!h.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||h.indexOf("out/server-main.js")!==-1||h.indexOf("_productName=VSCode")!==-1}function s(h){const C=h.trim().split(`
`),S=[];return C.forEach(c=>{const r=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(c);r&&r.length>=4&&S.push({pid:parseInt(r[1],10),ppid:parseInt(r[2]),cmd:r[3]})}),S}e.getRootProcesses=s;async function t(h,C,S){const c=S.reduce((P,M)=>(P[M.pid]=M,P),{}),r=[];return h.forEach(({socket:P,ip:M,port:W})=>{const $=C[P]?C[P].pid:void 0,z=$?c[$]?.cmd:void 0;$&&z&&!o(z)&&r.push({host:M,port:W,detail:z,pid:$})}),r}e.findPorts=t;function u(h,C,S){const c=new Map,r=s(C);for(const P of h){const M=S.get(P.port);if(M){c.set(P.port,M);continue}const W=r.find($=>$.cmd.includes(`${P.port}`));if(W){let $=W,z;do z=r.find(N=>N.ppid===$.pid),z&&($=z);while(z);c.set(P.port,{host:P.ip,port:P.port,pid:$.pid,detail:$.cmd,ppid:$.ppid})}else c.set(P.port,{host:P.ip,port:P.port,ppid:Number.MAX_VALUE})}return c}e.tryFindRootPorts=u;let p=e.ExtHostTunnelService=class extends L.Disposable{constructor(C,S,c){super(),this.logService=c,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new I.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._initialCandidates=void 0,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=C.getProxy(v.MainContext.MainThreadTunnelService),w.isLinux&&S.remote.isRemote&&S.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async openTunnel(C,S){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${C.identifier.value} called openTunnel API for ${S.remoteAddress.host}:${S.remoteAddress.port}.`);const c=await this._proxy.$openTunnel(S,C.displayName);if(c){const r=new a(c.remoteAddress,c.localAddress,()=>this._proxy.$closeTunnel(c.remoteAddress));return this._register(r),r}}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(C=>C.port).join(", ")}`)}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(C){return Math.max(C*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(C,S){const c=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(c,{selector:C,provider:S}),this._proxy.$registerPortsAttributesProvider(C,c),new k.Disposable(()=>{this._portAttributesProviders.delete(c),this._proxy.$unregisterPortsAttributesProvider(c)})}async $providePortAttributes(C,S,c,r,P){const M=[];for(const $ of C){const z=this._portAttributesProviders.get($);if(!z)return[];M.push(...await Promise.all(S.map(async N=>({providedAttributes:await z.provider.providePortAttributes(N,c,r,P),port:N}))))}const W=M.filter($=>!!$.providedAttributes);return W.length>0?W.map($=>({autoForwardAction:$.providedAttributes.autoForwardAction,port:$.port})):[]}async $registerCandidateFinder(C){if(C&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=C;let S;this._initialCandidates&&(S=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const c=new i.MovingAverage;let r=0;for(;this._candidateFindingEnabled;){const P=new Date().getTime(),M=(await this.findCandidatePorts()).filter(z=>(0,E.isLocalhost)(z.host)||(0,E.isAllInterfaces)(z.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(z=>z.port).join(", ")}`);const W=new Date().getTime()-P;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${W} ms.`),r++>3&&c.update(W),(!S||JSON.stringify(S)!==JSON.stringify(M))&&(S=M,await this._proxy.$onFoundNewCandidates(S));const $=this.calculateDelay(c.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${$} ms.`),await new Promise(z=>setTimeout(()=>z(),$))}}async setTunnelFactory(C){if(C){if(C.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(C.candidatePortSource),C.showCandidatePort&&(this._showCandidatePort=C.showCandidatePort,this._proxy.$setCandidateFilter()),C.tunnelFactory){this._forwardPortProvider=C.tunnelFactory;let S=C.tunnelFeatures?.privacyOptions??[];C.tunnelFeatures?.public&&S.length===0&&(S=[{id:"private",label:d.localize(0,null),themeIcon:"lock"},{id:"public",label:d.localize(1,null),themeIcon:"eye"}]);const c=C.tunnelFeatures?{elevation:!!C.tunnelFeatures?.elevation,public:!!C.tunnelFeatures?.public,privacyOptions:S}:void 0;this._proxy.$setTunnelProvider(c)}}else this._forwardPortProvider=void 0;return(0,L.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(C,S){if(this._extensionTunnels.has(C.host)){const c=this._extensionTunnels.get(C.host);c.has(C.port)&&(S&&c.get(C.port).disposeListener.dispose(),await c.get(C.port).tunnel.dispose(),c.delete(C.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(C,S){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const c=this._forwardPortProvider(C,S);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),c!==void 0){const r=await c;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(C.remoteAddress.host)||this._extensionTunnels.set(C.remoteAddress.host,new Map);const P=this._register(r.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(r.remoteAddress))));return this._extensionTunnels.get(C.remoteAddress.host).set(C.remoteAddress.port,{tunnel:r,disposeListener:P}),D.TunnelDtoConverter.fromApiTunnel(r)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(C){const S=await Promise.all(C.map(r=>this._showCandidatePort(r.host,r.port,r.detail??""))),c=C.filter((r,P)=>S[P]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${C.map(r=>r.port).join(", ")} to ${c.map(r=>r.port).join(", ")}`),c}async findCandidatePorts(){let C="",S="";try{C=await A.Promises.readFile("/proc/net/tcp","utf8"),S=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const c=f(C,S),r=await new Promise(x=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(U,de,ie)=>{x(de)})}),P=b(r),M=await A.Promises.readdir("/proc"),W=[];for(const x of M)try{const U=Number(x),de=m.joinPath(g.URI.file("/proc"),x);if((await A.Promises.stat(de.fsPath)).isDirectory()&&!isNaN(U)){const ne=await A.Promises.readlink(m.joinPath(de,"cwd").fsPath),H=await A.Promises.readFile(m.joinPath(de,"cmdline").fsPath,"utf8");W.push({pid:U,cwd:ne,cmd:H})}}catch{}const $=[],z=c.filter(x=>{const U=P[x.socket];return U||$.push(x),U}),N=t(z,P,W);let q;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${$.length}`),$.length>0){const x=await new Promise(U=>{(0,y.exec)("ps -F -A -l | grep root",(de,ie,ne)=>{U(ie)})});this._foundRootPorts=u($,x,this._foundRootPorts),q=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${q.map(U=>U.port).join(", ")}`)}return N.then(x=>q?x.concat(q):x)}};e.ExtHostTunnelService=p=Ve([ze(0,T.IExtHostRpcService),ze(1,R.IExtHostInitDataService),ze(2,l.ILogService)],p)}),define(De[319],Ie([1,0,17,22,21,8,3,4,121,273,61]),function(re,e,v,T,d,L,R,g,y,m,A){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function w(c,r){try{return JSON.stringify(c,r)}catch{return"null"}}const D="$$ref$$",I={[D]:-1};class E{constructor(r,P){this.jsonString=r,this.referencedBuffers=P}}function i(c,r=null,P=!1){const M=[];return{jsonString:(P?w:JSON.stringify)(c,($,z)=>{if(typeof z>"u")return I;if(typeof z=="object"){if(z instanceof T.VSBuffer){const N=M.push(z)-1;return{[D]:N}}if(r)return r($,z)}return z}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=i;function l(c,r,P){return JSON.parse(c,(M,W)=>{if(W){const $=W[D];if(typeof $=="number")return r[$];if(P&&W.$mid===1)return P.transformIncoming(W)}return W})}e.parseJsonAndRestoreBufferRefs=l;function a(c,r){return JSON.stringify(c,r)}function b(c){return c?(r,P)=>P&&P.$mid===1?c.transformOutgoing(P):P:null}var f;(function(c){c[c.LocalSide=0]="LocalSide",c[c.OtherSide=1]="OtherSide"})(f||(e.RequestInitiator=f={}));var _;(function(c){c[c.Responsive=0]="Responsive",c[c.Unresponsive=1]="Unresponsive"})(_||(e.ResponsiveState=_={}));const n=()=>{},o=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class t extends g.Disposable{constructor(r,P=null,M=null){super(),this[k]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=r,this._logger=P,this._uriTransformer=M,this._uriReplacer=b(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let W=0,$=A.ProxyIdentifier.count;W<$;W++)this._locals[W]=null,this._proxies[W]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new v.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(W=>this._receiveOneMessage(W))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(r=>{this._pendingRPCReplies[r].resolveErr(L.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(r){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(r){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(r){this._responsiveState!==r&&(this._responsiveState=r,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(r){return this._uriTransformer?(0,y.transformIncomingURIs)(r,this._uriTransformer):r}getProxy(r){const{nid:P,sid:M}=r;return this._proxies[P]||(this._proxies[P]=this._createProxy(P,M)),this._proxies[P]}_createProxy(r,P){const M={get:(W,$)=>(typeof $=="string"&&!W[$]&&$.charCodeAt(0)===36&&(W[$]=(...z)=>this._remoteCall(r,$,z)),$===s?P:W[$])};return new Proxy(Object.create(null),M)}set(r,P){return this._locals[r.nid]=P,P}assertRegistered(r){for(let P=0,M=r.length;P<M;P++){const W=r[P];if(!this._locals[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}_receiveOneMessage(r){if(this._isDisposed)return;const P=r.byteLength,M=u.read(r,0),W=M.readUInt8(),$=M.readUInt32();switch(W){case 1:case 2:{let{rpcId:z,method:N,args:q}=h.deserializeRequestJSONArgs(M);this._uriTransformer&&(q=(0,y.transformIncomingURIs)(q,this._uriTransformer)),this._receiveRequest(P,$,z,N,q,W===2);break}case 3:case 4:{let{rpcId:z,method:N,args:q}=h.deserializeRequestMixedArgs(M);this._uriTransformer&&(q=(0,y.transformIncomingURIs)(q,this._uriTransformer)),this._receiveRequest(P,$,z,N,q,W===4);break}case 5:{this._logger?.logIncoming(P,$,0,"ack"),this._onDidReceiveAcknowledge($);break}case 6:{this._receiveCancel(P,$);break}case 7:{this._receiveReply(P,$,void 0);break}case 9:{let z=h.deserializeReplyOKJSON(M);this._uriTransformer&&(z=(0,y.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReply(P,$,z);break}case 10:{const z=h.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(P,$,z);break}case 8:{const z=h.deserializeReplyOKVSBuffer(M);this._receiveReply(P,$,z);break}case 11:{let z=h.deserializeReplyErrError(M);this._uriTransformer&&(z=(0,y.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReplyErr(P,$,z);break}case 12:{this._receiveReplyErr(P,$,void 0);break}default:console.error("received unexpected message"),console.error(r)}}_receiveRequest(r,P,M,W,$,z){this._logger?.logIncoming(r,P,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)(M)}.${W}(`,$);const N=String(P);let q,x;if(z){const de=new d.CancellationTokenSource;$.push(de.token),q=this._invokeHandler(M,W,$),x=()=>de.cancel()}else q=this._invokeHandler(M,W,$),x=n;this._cancelInvokedHandlers[N]=x;const U=h.serializeAcknowledged(P);this._logger?.logOutgoing(U.byteLength,P,1,"ack"),this._protocol.send(U),q.then(de=>{delete this._cancelInvokedHandlers[N];const ie=h.serializeReplyOK(P,de,this._uriReplacer);this._logger?.logOutgoing(ie.byteLength,P,1,"reply:",de),this._protocol.send(ie)},de=>{delete this._cancelInvokedHandlers[N];const ie=h.serializeReplyErr(P,de);this._logger?.logOutgoing(ie.byteLength,P,1,"replyErr:",de),this._protocol.send(ie)})}_receiveCancel(r,P){this._logger?.logIncoming(r,P,1,"receiveCancel");const M=String(P);this._cancelInvokedHandlers[M]?.()}_receiveReply(r,P,M){this._logger?.logIncoming(r,P,0,"receiveReply:",M);const W=String(P);if(!this._pendingRPCReplies.hasOwnProperty(W))return;const $=this._pendingRPCReplies[W];delete this._pendingRPCReplies[W],$.resolveOk(M)}_receiveReplyErr(r,P,M){this._logger?.logIncoming(r,P,0,"receiveReplyErr:",M);const W=String(P);if(!this._pendingRPCReplies.hasOwnProperty(W))return;const $=this._pendingRPCReplies[W];delete this._pendingRPCReplies[W];let z;M&&(M.$isError?(z=new Error,z.name=M.name,z.message=M.message,z.stack=M.stack):z=M),$.resolveErr(z)}_invokeHandler(r,P,M){try{return Promise.resolve(this._doInvokeHandler(r,P,M))}catch(W){return Promise.reject(W)}}_doInvokeHandler(r,P,M){const W=this._locals[r];if(!W)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(r));const $=W[P];if(typeof $!="function")throw new Error("Unknown method "+P+" on actor "+(0,A.getStringIdentifierForProxy)(r));return $.apply(W,M)}_remoteCall(r,P,M){if(this._isDisposed)return new m.CanceledLazyPromise;let W=null;if(M.length>0&&d.CancellationToken.isCancellationToken(M[M.length-1])&&(W=M.pop()),W&&W.isCancellationRequested)return Promise.reject(L.canceled());const $=h.serializeRequestArguments(M,this._uriReplacer),z=++this._lastMessageId,N=String(z),q=new m.LazyPromise;W&&W.onCancellationRequested(()=>{const U=h.serializeCancel(z);this._logger?.logOutgoing(U.byteLength,z,0,"cancel"),this._protocol.send(h.serializeCancel(z))}),this._pendingRPCReplies[N]=q,this._onWillSendRequest(z);const x=h.serializeRequest(z,r,P,$,!!W);return this._logger?.logOutgoing(x.byteLength,z,0,`request: ${(0,A.getStringIdentifierForProxy)(r)}.${P}(`,M),this._protocol.send(x),q}}e.RPCProtocol=t,k=o,t.UNRESPONSIVE_TIME=3*1e3;class u{static alloc(r,P,M){const W=new u(T.VSBuffer.alloc(M+1+4),0);return W.writeUInt8(r),W.writeUInt32(P),W}static read(r,P){return new u(r,P)}get buffer(){return this._buff}constructor(r,P){this._buff=r,this._offset=P}static sizeUInt8(){return 1}writeUInt8(r){this._buff.writeUInt8(r,this._offset),this._offset+=1}readUInt8(){const r=this._buff.readUInt8(this._offset);return this._offset+=1,r}writeUInt32(r){this._buff.writeUInt32BE(r,this._offset),this._offset+=4}readUInt32(){const r=this._buff.readUInt32BE(this._offset);return this._offset+=4,r}static sizeShortString(r){return 1+r.byteLength}writeShortString(r){this._buff.writeUInt8(r.byteLength,this._offset),this._offset+=1,this._buff.set(r,this._offset),this._offset+=r.byteLength}readShortString(){const r=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+r).toString();return this._offset+=r,M}static sizeLongString(r){return 4+r.byteLength}writeLongString(r){this._buff.writeUInt32BE(r.byteLength,this._offset),this._offset+=4,this._buff.set(r,this._offset),this._offset+=r.byteLength}readLongString(){const r=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+r).toString();return this._offset+=r,M}writeBuffer(r){this._buff.writeUInt32BE(r.byteLength,this._offset),this._offset+=4,this._buff.set(r,this._offset),this._offset+=r.byteLength}static sizeVSBuffer(r){return 4+r.byteLength}writeVSBuffer(r){this._buff.writeUInt32BE(r.byteLength,this._offset),this._offset+=4,this._buff.set(r,this._offset),this._offset+=r.byteLength}readVSBuffer(){const r=this._buff.readUInt32BE(this._offset);this._offset+=4;const P=this._buff.slice(this._offset,this._offset+r);return this._offset+=r,P}static sizeMixedArray(r){let P=0;P+=1;for(let M=0,W=r.length;M<W;M++){const $=r[M];switch(P+=1,$.type){case 1:P+=this.sizeLongString($.value);break;case 2:P+=this.sizeVSBuffer($.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString($.value);for(let z=0;z<$.buffers.length;++z)P+=this.sizeVSBuffer($.buffers[z]);break;case 4:break}}return P}writeMixedArray(r){this._buff.writeUInt8(r.length,this._offset),this._offset+=1;for(let P=0,M=r.length;P<M;P++){const W=r[P];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let $=0;$<W.buffers.length;++$)this.writeBuffer(W.buffers[$]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const r=this._buff.readUInt8(this._offset);this._offset+=1;const P=new Array(r);for(let M=0;M<r;M++)switch(this.readUInt8()){case 1:P[M]=this.readLongString();break;case 2:P[M]=this.readVSBuffer();break;case 3:{const $=this.readUInt32(),z=this.readLongString(),N=[];for(let q=0;q<$;++q)N.push(this.readVSBuffer());P[M]=new A.SerializableObjectWithBuffers(l(z,N,null));break}case 4:P[M]=void 0;break}return P}}u.sizeUInt32=4;var p;(function(c){c[c.Simple=0]="Simple",c[c.Mixed=1]="Mixed"})(p||(p={}));class h{static _useMixedArgSerialization(r){for(let P=0,M=r.length;P<M;P++)if(r[P]instanceof T.VSBuffer||r[P]instanceof A.SerializableObjectWithBuffers||typeof r[P]>"u")return!0;return!1}static serializeRequestArguments(r,P){if(this._useMixedArgSerialization(r)){const M=[];for(let W=0,$=r.length;W<$;W++){const z=r[W];if(z instanceof T.VSBuffer)M[W]={type:2,value:z};else if(typeof z>"u")M[W]={type:4};else if(z instanceof A.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:q}=i(z.value,P);M[W]={type:3,value:T.VSBuffer.fromString(N),buffers:q}}else M[W]={type:1,value:T.VSBuffer.fromString(a(z,P))}}return{type:1,args:M}}return{type:0,args:a(r,P)}}static serializeRequest(r,P,M,W,$){switch(W.type){case 0:return this._requestJSONArgs(r,P,M,W.args,$);case 1:return this._requestMixedArgs(r,P,M,W.args,$)}}static _requestJSONArgs(r,P,M,W,$){const z=T.VSBuffer.fromString(M),N=T.VSBuffer.fromString(W);let q=0;q+=u.sizeUInt8(),q+=u.sizeShortString(z),q+=u.sizeLongString(N);const x=u.alloc($?2:1,r,q);return x.writeUInt8(P),x.writeShortString(z),x.writeLongString(N),x.buffer}static deserializeRequestJSONArgs(r){const P=r.readUInt8(),M=r.readShortString(),W=r.readLongString();return{rpcId:P,method:M,args:JSON.parse(W)}}static _requestMixedArgs(r,P,M,W,$){const z=T.VSBuffer.fromString(M);let N=0;N+=u.sizeUInt8(),N+=u.sizeShortString(z),N+=u.sizeMixedArray(W);const q=u.alloc($?4:3,r,N);return q.writeUInt8(P),q.writeShortString(z),q.writeMixedArray(W),q.buffer}static deserializeRequestMixedArgs(r){const P=r.readUInt8(),M=r.readShortString(),W=r.readMixedArray(),$=new Array(W.length);for(let z=0,N=W.length;z<N;z++){const q=W[z];typeof q=="string"?$[z]=JSON.parse(q):$[z]=q}return{rpcId:P,method:M,args:$}}static serializeAcknowledged(r){return u.alloc(5,r,0).buffer}static serializeCancel(r){return u.alloc(6,r,0).buffer}static serializeReplyOK(r,P,M){if(typeof P>"u")return this._serializeReplyOKEmpty(r);if(P instanceof T.VSBuffer)return this._serializeReplyOKVSBuffer(r,P);if(P instanceof A.SerializableObjectWithBuffers){const{jsonString:W,referencedBuffers:$}=i(P.value,M,!0);return this._serializeReplyOKJSONWithBuffers(r,W,$)}else return this._serializeReplyOKJSON(r,w(P,M))}static _serializeReplyOKEmpty(r){return u.alloc(7,r,0).buffer}static _serializeReplyOKVSBuffer(r,P){let M=0;M+=u.sizeVSBuffer(P);const W=u.alloc(8,r,M);return W.writeVSBuffer(P),W.buffer}static deserializeReplyOKVSBuffer(r){return r.readVSBuffer()}static _serializeReplyOKJSON(r,P){const M=T.VSBuffer.fromString(P);let W=0;W+=u.sizeLongString(M);const $=u.alloc(9,r,W);return $.writeLongString(M),$.buffer}static _serializeReplyOKJSONWithBuffers(r,P,M){const W=T.VSBuffer.fromString(P);let $=0;$+=u.sizeUInt32,$+=u.sizeLongString(W);for(const N of M)$+=u.sizeVSBuffer(N);const z=u.alloc(10,r,$);z.writeUInt32(M.length),z.writeLongString(W);for(const N of M)z.writeBuffer(N);return z.buffer}static deserializeReplyOKJSON(r){const P=r.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(r,P){const M=r.readUInt32(),W=r.readLongString(),$=[];for(let z=0;z<M;++z)$.push(r.readVSBuffer());return new A.SerializableObjectWithBuffers(l(W,$,P))}static serializeReplyErr(r,P){const M=P?w(L.transformErrorForSerialization(P),null):void 0;if(typeof M!="string")return this._serializeReplyErrEmpty(r);const W=T.VSBuffer.fromString(M);let $=0;$+=u.sizeLongString(W);const z=u.alloc(11,r,$);return z.writeLongString(W),z.buffer}static deserializeReplyErrError(r){const P=r.readLongString();return JSON.parse(P)}static _serializeReplyErrEmpty(r){return u.alloc(12,r,0).buffer}}var C;(function(c){c[c.RequestJSONArgs=1]="RequestJSONArgs",c[c.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",c[c.RequestMixedArgs=3]="RequestMixedArgs",c[c.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",c[c.Acknowledged=5]="Acknowledged",c[c.Cancel=6]="Cancel",c[c.ReplyOKEmpty=7]="ReplyOKEmpty",c[c.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",c[c.ReplyOKJSON=9]="ReplyOKJSON",c[c.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",c[c.ReplyErrError=11]="ReplyErrError",c[c.ReplyErrEmpty=12]="ReplyErrEmpty"})(C||(C={}));var S;(function(c){c[c.String=1]="String",c[c.VSBuffer=2]="VSBuffer",c[c.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",c[c.Undefined=4]="Undefined"})(S||(S={}))}),define(De[320],Ie([1,0,3,42,47,5]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new d.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new d.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new d.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)("outputService");var R;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class g{constructor(){this.channels=new Map,this._onDidRegisterChannel=new v.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new v.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(m){this.channels.has(m.id)||(this.channels.set(m.id,m),this._onDidRegisterChannel.fire(m.id))}getChannels(){const m=[];return this.channels.forEach(A=>m.push(A)),m}getChannel(m){return this.channels.get(m)}removeChannel(m){this.channels.delete(m),this._onDidRemoveChannel.fire(m)}}T.Registry.add(e.Extensions.OutputChannels,new g),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new d.RawContextKey("activeOutputChannel","")}),define(De[145],Ie([1,0,6,5,20,25,18,320,64,26,51,169,22,12,30,3,4]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class l extends R.AbstractMessageLogger{get disposed(){return this._disposed}constructor(_,n,o,s,t){super(),this.id=_,this.name=n,this.logger=o,this.proxy=s,this.extension=t,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(o.getLevel()),this._register(o.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.getLevel()}appendLine(_){this.append(_+`
`)}append(_){this.info(_)}clear(){const _=this.offset;this.logger.flush(),this.proxy.$update(this.id,g.OutputChannelUpdateMode.Clear,_)}replace(_){const n=this.offset;this.info(_),this.proxy.$update(this.id,g.OutputChannelUpdateMode.Replace,n),this.visible&&this.logger.flush()}show(_,n){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof _=="boolean"?_:n))}hide(){this.proxy.$close(this.id)}log(_,n){this.offset+=w.VSBuffer.fromString(n).byteLength,(0,R.log)(this.logger,_,n),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,g.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class a extends l{appendLine(_){this.append(_)}}let b=e.ExtHostOutputService=class{constructor(_,n,o,s,t,u){this.initData=n,this.extHostFileSystem=o,this.extHostFileSystemInfo=s,this.loggerService=t,this.logService=u,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=_.getProxy(v.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(n.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(_){this.visibleChannelId=_;for(const[n,o]of this.channels)o.visible=n===this.visibleChannelId}createOutputChannel(_,n,o){if(_=_.trim(),!_)throw new Error("illegal argument `name`. must not be falsy");const s=typeof n=="object"&&n.log,t=(0,D.isString)(n)?n:void 0;if((0,D.isString)(t)&&!t.trim())throw new Error("illegal argument `languageId`. must not be empty");let u;const p=this.initData.environment.extensionLogLevel?.find(([C])=>L.ExtensionIdentifier.equals(o.identifier,C))?.[1];p&&(u=(0,R.parseLogLevel)(p));const h=s?this.doCreateLogOutputChannel(_,u,o):this.doCreateOutputChannel(_,t,o);return h.then(C=>{this.channels.set(C.id,C),C.visible=C.id===this.visibleChannelId}),s?this.createExtHostLogOutputChannel(_,u??this.logService.getLevel(),h):this.createExtHostOutputChannel(_,h)}async doCreateOutputChannel(_,n,o){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const s=await this.outputDirectoryPromise,t=this.extHostFileSystemInfo.extUri.joinPath(s,`${this.namePool++}-${_.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.loggerService.createLogger(t,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.proxy.$register(_,t,n,o.identifier.value);return new l(p,_,u,this.proxy,o)}async doCreateLogOutputChannel(_,n,o){const s=await this.createExtensionLogDirectory(o),t=_.replace(/[\\/:\*\?"<>\|]/g,""),u=this.extHostFileSystemInfo.extUri.joinPath(s,`${t}.log`),p=`${o.identifier.value}.${t}`,h=this.loggerService.createLogger(u,{id:p,name:_,logLevel:n,extensionId:o.identifier.value});return new a(p,_,h,this.proxy,o)}createExtensionLogDirectory(_){let n=this.extensionLogDirectoryPromise.get(_.identifier.value);if(!n){const o=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,_.identifier.value);this.extensionLogDirectoryPromise.set(_.identifier.value,n=(async()=>{try{await this.extHostFileSystem.value.createDirectory(o)}catch(s){if((0,I.toFileSystemProviderErrorCode)(s)!==I.FileSystemProviderErrorCode.FileExists)throw s}return o})())}return n}createExtHostOutputChannel(_,n){let o=!1;const s=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return _},append(t){s(),n.then(u=>u.append(t))},appendLine(t){s(),n.then(u=>u.appendLine(t))},clear(){s(),n.then(t=>t.clear())},replace(t){s(),n.then(u=>u.replace(t))},show(t,u){s(),n.then(p=>p.show(t,u))},hide(){s(),n.then(t=>t.hide())},dispose(){o=!0,n.then(t=>t.dispose())}}}createExtHostLogOutputChannel(_,n,o){const s=new i.DisposableStore,t=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},u=s.add(new E.Emitter);function p(h){n=h,u.fire(h)}return o.then(h=>{s.add(h),h.logLevel!==n&&p(h.logLevel),s.add(h.onDidChangeLogLevel(C=>p(C)))}),{...this.createExtHostOutputChannel(_,o),get logLevel(){return n},onDidChangeLogLevel:u.event,trace(h,...C){t(),o.then(S=>S.trace(h,...C))},debug(h,...C){t(),o.then(S=>S.debug(h,...C))},info(h,...C){t(),o.then(S=>S.info(h,...C))},warn(h,...C){t(),o.then(S=>S.warn(h,...C))},error(h,...C){t(),o.then(S=>S.error(h,...C))},dispose(){s.dispose()}}}};e.ExtHostOutputService=b=Ve([ze(0,d.IExtHostRpcService),ze(1,m.IExtHostInitDataService),ze(2,y.IExtHostConsumerFileSystem),ze(3,A.IExtHostFileSystemInfo),ze(4,R.ILoggerService),ze(5,R.ILogService)],b),e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")});var Fe=this&&this.__classPrivateFieldGet||function(re,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!T:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(re):T?T.value:e.get(re)},Ye=this&&this.__classPrivateFieldSet||function(re,e,v,T,d){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!d)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!d:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?d.call(re,v):d?d.value=v:e.set(re,v),v};define(De[321],Ie([1,0,5,17]),function(re,e,v,T){"use strict";var d,L,R,g,y,m,A,k,w,D,I;Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,v.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new(I=class{constructor(){d.set(this,5),L.set(this,2e3),R.set(this,[]),g.set(this,3),y.set(this,[]),m.set(this,100),A.set(this,2),k.set(this,500),w.set(this,1500),D.set(this,void 0)}get latency(){return Fe(this,D,"f")}async measure(E){let i=1/0;for(let a=0;a<Fe(this,d,"f");a++){const b=await E.getRoundTripTime();if(b===void 0)return;i=Math.min(i,b/2),await(0,T.timeout)(Fe(this,L,"f"))}Fe(this,y,"f").push(i),Fe(this,y,"f").length>Fe(this,m,"f")&&Fe(this,y,"f").shift();let l;return Fe(this,R,"f").length<Fe(this,g,"f")?Fe(this,R,"f").push(i):l=Fe(this,R,"f").reduce((a,b)=>a+b,0)/Fe(this,R,"f").length,Ye(this,D,{initial:l,current:i,average:Fe(this,y,"f").reduce((a,b)=>a+b,0)/Fe(this,y,"f").length,high:(()=>typeof l>"u"?!1:i>Fe(this,w,"f")||i>Fe(this,k,"f")&&i>l*Fe(this,A,"f"))()},"f"),Fe(this,D,"f")}},d=new WeakMap,L=new WeakMap,R=new WeakMap,g=new WeakMap,y=new WeakMap,m=new WeakMap,A=new WeakMap,k=new WeakMap,w=new WeakMap,D=new WeakMap,I)}),define(De[322],Ie([1,0,31,16,11,10,23,2,5,240,50,266,321]),function(re,e,v,T,d,L,R,g,y,m,A,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=e.AbstractPathService=class Ln{constructor(E,i,l,a){this.localUserHome=E,this.remoteAgentService=i,this.environmentService=l,this.contextService=a,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||L.OS)(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=b?.userHome??E})()}hasValidBasename(E,i,l){return typeof i=="string"||typeof i>"u"?this.resolveOS.then(a=>this.doHasValidBasename(E,a,i)):this.doHasValidBasename(E,i,l)}doHasValidBasename(E,i,l){return E.scheme===T.Schemas.file||E.scheme===T.Schemas.vscodeRemote?(0,v.isValidBasename)(l??(0,R.basename)(E),i===1):!0}get defaultUriScheme(){return Ln.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(E,i){if(E.remoteAuthority)return T.Schemas.vscodeRemote;const l=(0,m.getVirtualWorkspaceScheme)(i.getWorkspace());if(l)return l;const a=i.getWorkspace().folders[0];if(a)return a.uri.scheme;const b=i.getWorkspace().configuration;return b?b.scheme:T.Schemas.file}userHome(E){return E?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(E=>E===1?d.win32:d.posix)}async fileURI(E){let i="";if(await this.resolveOS===1&&(E=E.replace(/\\/g,"/")),E[0]==="/"&&E[1]==="/"){const a=E.indexOf("/",2);a===-1?(i=E.substring(2),E="/"):(i=E.substring(2,a),E=E.substring(a)||"/")}return g.URI.from({scheme:T.Schemas.file,authority:i,path:E,query:"",fragment:""})}};e.AbstractPathService=D=Ve([ze(1,w.IRemoteAgentService),ze(2,k.IWorkbenchEnvironmentService),ze(3,A.IWorkspaceContextService)],D)}),define(De[86],Ie([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class v{constructor(R,g){this.line=R,this.character=g}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,g){return new v(0,0)}with(R){return new v(0,0)}}e.Position=v;class T{constructor(R,g,y,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(R,g),this.end=new v(y,m)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new T(0,0,0,0)}with(R){return new T(0,0,0,0)}}e.Range=T;var d;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(d||(e.TextSearchCompleteMessageType=d={}))}),define(De[34],Ie([1,0,19,33,24,31,9,5,11,8,86,17]),function(re,e,v,T,d,L,R,g,y,m,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const w="\u27EA ",D=" characters skipped \u27EB",I=(w.length+D.length+5)*2;e.ISearchService=(0,g.createDecorator)("searchService");var E;(function(H){H[H.file=0]="file",H[H.text=1]="text"})(E||(e.SearchProviderType=E={}));var i;(function(H){H[H.File=1]="File",H[H.Text=2]="Text"})(i||(e.QueryType=i={}));function l(H){return!!H.preview}e.resultIsMatch=l;function a(H){return!!H.resource}e.isFileMatch=a;function b(H){return!!H.message}e.isProgressMessage=b;var f;(function(H){H[H.Normal=0]="Normal",H[H.NewSearchStarted=1]="NewSearchStarted"})(f||(e.SearchCompletionExitCode=f={}));class _{constructor(V){this.resource=V,this.results=[]}}e.FileMatch=_;class n{constructor(V,ce,be,Se){this.ranges=ce,this.webviewIndex=Se;const ge=Array.isArray(ce)?ce:[ce];if(be&&be.matchLines===1&&o(ge)){V=(0,R.getNLines)(V,be.matchLines);let O="",K=0,we=0;const Ce=Math.floor(be.charsPerLine/5),ee=[];for(const te of ge){const ue=Math.max(te.startColumn-Ce,0),Q=te.startColumn+be.charsPerLine;if(ue>we+Ce+I){const le=w+(ue-we)+D;O+=le+V.slice(ue,Q),K+=ue-(we+le.length)}else O+=V.slice(we,Q);ee.push(new t(0,te.startColumn-K,te.endColumn-K)),we=Q}this.preview={text:O,matches:Array.isArray(this.ranges)?ee:ee[0]}}else{const O=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:V,matches:(0,v.mapArrayOrNot)(ce,K=>new s(K.startLineNumber-O,K.startColumn,K.endLineNumber-O,K.endColumn))}}}}e.TextSearchMatch=n;function o(H){const V=H[0].startLineNumber;for(const ce of H)if(ce.startLineNumber!==V||ce.endLineNumber!==V)return!1;return!0}class s{constructor(V,ce,be,Se){this.startLineNumber=V,this.startColumn=ce,this.endLineNumber=be,this.endColumn=Se}}e.SearchRange=s;class t extends s{constructor(V,ce,be){super(V,ce,V,be)}}e.OneLineRange=t;var u;(function(H){H.List="list",H.Tree="tree"})(u||(e.ViewMode=u={}));var p;(function(H){H.Default="default",H.FileNames="fileNames",H.Type="type",H.Modified="modified",H.CountDescending="countDescending",H.CountAscending="countAscending"})(p||(e.SearchSortOrder=p={}));function h(H,V=!0){const ce=H&&H.files&&H.files.exclude,be=V&&H&&H.search&&H.search.exclude;if(!ce&&!be)return;if(!ce||!be)return ce||be;let Se=Object.create(null);return Se=d.mixin(Se,d.deepClone(ce)),Se=d.mixin(Se,d.deepClone(be),!0),Se}e.getExcludes=h;function C(H,V){return H.excludePattern&&T.match(H.excludePattern,V)?!1:H.includePattern||H.usingSearchPaths?H.includePattern&&T.match(H.includePattern,V)?!0:H.usingSearchPaths?!!H.folderQueries&&H.folderQueries.some(ce=>{const be=ce.folder.fsPath;if(L.isEqualOrParent(V,be)){const Se=y.relative(be,V);return!ce.includePattern||!!T.match(ce.includePattern,Se)}else return!1}):!1:!0}e.pathIncludedInQuery=C;var S;(function(H){H[H.unknownEncoding=1]="unknownEncoding",H[H.regexParseError=2]="regexParseError",H[H.globParseError=3]="globParseError",H[H.invalidLiteral=4]="invalidLiteral",H[H.rgProcessError=5]="rgProcessError",H[H.other=6]="other",H[H.canceled=7]="canceled"})(S||(e.SearchErrorCode=S={}));class c extends Error{constructor(V,ce){super(V),this.code=ce}}e.SearchError=c;function r(H){const V=H.message;if((0,m.isCancellationError)(H))return new c(V,S.canceled);try{const ce=JSON.parse(V);return new c(ce.message,ce.code)}catch{return new c(V,S.other)}}e.deserializeSearchError=r;function P(H){const V={message:H.message,code:H.code};return new Error(JSON.stringify(V))}e.serializeSearchError=P;function M(H){return H.type==="error"?!0:H.type==="success"}e.isSerializedSearchComplete=M;function W(H){return H.type==="success"}e.isSerializedSearchSuccess=W;function $(H){return!!H.path}e.isSerializedFileMatch=$;function z(H,V){const ce=H.searchPath?H.searchPath:H.relativePath;return(0,R.fuzzyContains)(ce,V)}e.isFilePatternMatch=z;class N{constructor(V){this.path=V,this.results=[]}addMatch(V){this.results.push(V)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function q(H,V){const ce={...H||{},...V||{}};return Object.keys(ce).filter(be=>{const Se=ce[be];return typeof Se=="boolean"&&Se})}e.resolvePatternsForProvider=q;class x{constructor(V,ce){this._parsedIncludeExpression=null,this._excludeExpression={...V.excludePattern||{},...ce.excludePattern||{}},this._parsedExcludeExpression=T.parse(this._excludeExpression);let be=V.includePattern;ce.includePattern&&(be?be={...be,...ce.includePattern}:be=ce.includePattern),be&&(this._parsedIncludeExpression=T.parse(be))}matchesExcludesSync(V,ce,be){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,ce,be))}includedInQuerySync(V,ce,be){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,ce,be)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(V,ce,be))}includedInQuery(V,ce,be){const Se=this._parsedExcludeExpression(V,ce,be),ge=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(V,ce,be):!0;return(0,k.isThenable)(Se)?Se.then(O=>O?!1:ge()):ge()}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=x;function U(H){for(const V in H)if(typeof H[V]!="boolean")return!0;return!1}function de(H){if(!H)return;let V;return ce=>(V||(V=(H()||Promise.resolve([])).then(be=>be?ne(be):{})),V.then(be=>!!be[ce]))}e.hasSiblingPromiseFn=de;function ie(H){if(!H)return;let V;return ce=>{if(!V){const be=H();V=be?ne(be):{}}return!!V[ce]}}e.hasSiblingFn=ie;function ne(H){const V={};for(const ce of H)V[ce]=!0;return V}}),define(De[37],Ie([1,0,19,17,21,3,4,71,16,112,23,9,12,2,198,5,18,227,50,51,26,20,15,7,59,34,6]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l,a,b,f,_,n,o,s,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function p(W,$,z){return new A.ExtUri(N=>c(N,z)).isEqual(W,$)}function h(W,$,z){return p(W.uri,$.uri,z)?0:(0,k.compare)(W.uri.toString(),$.uri.toString())}function C(W,$,z){return W.index!==$.index?W.index<$.index?-1:1:p(W.uri,$.uri,z)?(0,k.compare)(W.name,$.name):(0,k.compare)(W.uri.toString(),$.uri.toString())}function S(W,$,z,N){const q=W.slice(0).sort((U,de)=>z(U,de,N)),x=$.slice(0).sort((U,de)=>z(U,de,N));return(0,v.delta)(q,x,(U,de)=>z(U,de,N))}function c(W,$){const z=$.getCapabilities(W.scheme);return!(z&&z&1024)}class r extends a.Workspace{static toExtHostWorkspace($,z,N,q){if(!$)return{workspace:null,added:[],removed:[]};const{id:x,name:U,folders:de,configuration:ie,transient:ne,isUntitled:H}=$,V=[],ce=z;z?de.forEach((O,K)=>{const we=D.URI.revive(O.uri),Ce=r._findFolder(N||z,we,q);Ce?(Ce.name=O.name,Ce.index=O.index,V.push(Ce)):V.push({uri:we,name:O.name,index:K})}):V.push(...de.map(({uri:O,name:K,index:we})=>({uri:D.URI.revive(O),name:K,index:we}))),V.sort((O,K)=>O.index<K.index?-1:1);const be=new r(x,U,V,!!ne,ie?D.URI.revive(ie):null,!!H,O=>c(O,q)),{added:Se,removed:ge}=S(ce?ce.workspaceFolders:[],be.workspaceFolders,h,q);return{workspace:be,added:Se,removed:ge}}static _findFolder($,z,N){for(let q=0;q<$.folders.length;q++){const x=$.workspaceFolders[q];if(p(x.uri,z,N))return x}}constructor($,z,N,q,x,U,de){super($,N.map(ie=>new a.WorkspaceFolder(ie)),q,x,de),this._name=z,this._isUntitled=U,this._workspaceFolders=[],this._structure=g.TernarySearchTree.forUris(de),N.forEach(ie=>{this._workspaceFolders.push(ie),this._structure.set(ie.uri,ie)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder($,z){return z&&this._structure.get($)&&($=(0,A.dirname)($)),this._structure.findSubstr($)}resolveWorkspaceFolder($){return this._structure.get($)}}let P=e.ExtHostWorkspace=class{constructor($,z,N,q,x){this._onDidChangeWorkspace=new L.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new L.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new L.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=q,this._extHostFileSystemInfo=N,this._uriTransformerService=x,this._requestIdProvider=new m.Counter,this._barrier=new T.Barrier,this._proxy=$.getProxy(u.MainContext.MainThreadWorkspace),this._messageService=$.getProxy(u.MainContext.MainThreadMessageService);const U=z.workspace;this._confirmedWorkspace=U?new r(U.id,U.name,[],!!U.transient,U.configuration?D.URI.revive(U.configuration):null,!!U.isUntitled,de=>c(de,N)):void 0}$initializeWorkspace($,z){this._trusted=z,this.$acceptWorkspaceData($),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?D.URI.from({scheme:y.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders($,z,N,...q){const x=[];if(Array.isArray(q)&&q.forEach(H=>{D.URI.isUri(H.uri)&&!x.some(V=>p(V.uri,H.uri,this._extHostFileSystemInfo))&&x.push({uri:H.uri,name:H.name||(0,A.basenameOrAuthority)(H.uri)})}),this._unconfirmedWorkspace||[z,N].some(H=>typeof H!="number"||H<0)||N===0&&x.length===0)return!1;const U=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(z+N>U.length)return!1;const de=U.slice(0);de.splice(z,N,...x.map(H=>({uri:H.uri,name:H.name||(0,A.basenameOrAuthority)(H.uri),index:void 0})));for(let H=0;H<de.length;H++){const V=de[H];if(de.some((ce,be)=>be!==H&&p(V.uri,ce.uri,this._extHostFileSystemInfo)))return!1}de.forEach((H,V)=>H.index=V);const{added:ie,removed:ne}=S(U,de,C,this._extHostFileSystemInfo);if(ie.length===0&&ne.length===0)return!1;if(this._proxy){const H=$.displayName||$.name;this._proxy.$updateWorkspaceFolders(H,z,N,x).then(void 0,V=>{this._unconfirmedWorkspace=void 0;const ce={source:{identifier:$.identifier,label:$.displayName||$.name}};this._messageService.$showMessage(l.Severity.Error,(0,I.localize)(0,null,H,V.toString()),ce,[])})}return this.trySetWorkspaceFolders(de),!0}getWorkspaceFolder($,z){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,z)}async getWorkspaceFolder2($,z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,z)}async resolveWorkspaceFolder($){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder($)}getPath(){if(!this._actualWorkspace)return;const{folders:$}=this._actualWorkspace;if($.length!==0)return $[0].uri.fsPath}getRelativePath($,z){let N,q="";if(typeof $=="string"?(N=D.URI.file($),q=$):typeof $<"u"&&(N=$,q=$.fsPath),!N)return q;const x=this.getWorkspaceFolder(N,!0);if(!x)return q;typeof z>"u"&&this._actualWorkspace&&(z=this._actualWorkspace.folders.length>1);let U=(0,A.relativePath)(x.uri,N);return z&&x.name&&(U=`${x.name}/${U}`),U}trySetWorkspaceFolders($){this._actualWorkspace&&(this._unconfirmedWorkspace=r.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:$,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData($){const{workspace:z,added:N,removed:q}=r.toExtHostWorkspace($,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=z||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:q}))}findFiles($,z,N,q,x=d.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${q.value}, entryPoint: findFiles`);let U;if(z===null?U=!1:z&&(typeof z=="string"?U=z:U=z.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:de,folder:ie}=M(n.GlobPattern.from($));return this._proxy.$startFileSearch((0,w.withUndefinedAsNull)(de),(0,w.withUndefinedAsNull)(ie),(0,w.withUndefinedAsNull)(U),(0,w.withUndefinedAsNull)(N),x).then(ne=>Array.isArray(ne)?ne.map(H=>D.URI.revive(H)):[])}async findTextInFiles($,z,N,q,x=d.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${q.value}, entryPoint: findTextInFiles`);const U=this._requestIdProvider.getNext(),de=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:ie,folder:ne}=M(n.GlobPattern.from(z.include)),H=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,V={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:de,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:ie,excludePattern:H},ce=!1;if(this._activeSearchCallbacks[U]=be=>{if(ce)return;const Se=D.URI.revive(be.resource);be.results.forEach(ge=>{(0,t.resultIsMatch)(ge)?N({uri:Se,preview:{text:ge.preview.text,matches:(0,v.mapArrayOrNot)(ge.preview.matches,O=>new o.Range(O.startLineNumber,O.startColumn,O.endLineNumber,O.endColumn))},ranges:(0,v.mapArrayOrNot)(ge.ranges,O=>new o.Range(O.startLineNumber,O.startColumn,O.endLineNumber,O.endColumn))}):N({uri:Se,text:ge.text,lineNumber:ge.lineNumber})})},x.isCancellationRequested)return{};try{const be=await this._proxy.$startTextSearch($,(0,w.withUndefinedAsNull)(ne),V,U,x);return delete this._activeSearchCallbacks[U],be||{}}catch(be){throw delete this._activeSearchCallbacks[U],be}}$handleTextSearchResult($,z){this._activeSearchCallbacks[z]?.($)}async save($){const z=await this._proxy.$save($,{saveAs:!1});return D.URI.revive(z)}async saveAs($){const z=await this._proxy.$save($,{saveAs:!0});return D.URI.revive(z)}saveAll($){return this._proxy.$saveAll($)}resolveProxy($){return this._proxy.$resolveProxy($)}get trusted(){return this._trusted}requestWorkspaceTrust($){return this._proxy.$requestWorkspaceTrust($)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider($,z){if(this._editSessionIdentityProviders.has($))throw new Error(`A provider has already been registered for scheme ${$}`);this._editSessionIdentityProviders.set($,z);const N=this._uriTransformerService.transformOutgoingScheme($),q=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(q,N),(0,R.toDisposable)(()=>{this._editSessionIdentityProviders.delete($),this._proxy.$unregisterEditSessionIdentityProvider(q)})}async $getEditSessionIdentifier($,z){this._logService.info("Getting edit session identifier for workspaceFolder",$);const N=await this.resolveWorkspaceFolder(D.URI.revive($));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const q=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!q),!q)return;const x=await q.provideEditSessionIdentity(N,z);if(this._logService.info("Provider returned edit session identifier: ",x),!!x)return x}async $provideEditSessionIdentityMatch($,z,N,q){this._logService.info("Getting edit session identifier for workspaceFolder",$);const x=await this.resolveWorkspaceFolder(D.URI.revive($));if(!x){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",x);const U=this._editSessionIdentityProviders.get(x.uri.scheme);if(this._logService.info(`Provider for scheme ${x.uri.scheme} is defined: `,!!U),!U)return;const de=await U.provideEditSessionIdentityMatch?.(z,N,q);if(this._logService.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent($){return(z,N,q)=>{const x=function(de){z.call(N,de)};return x.extension=$,this._onWillCreateEditSessionIdentityEvent.event(x,void 0,q)}}async $onWillCreateEditSessionIdentity($,z,N){const q=await this.resolveWorkspaceFolder(D.URI.revive($));if(q===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:q},z,async(x,U)=>{const de=Date.now();await Promise.resolve(x),Date.now()-de>N&&this._logService.warn("SLOW edit session create-participant",U.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider($,z){if(this._canonicalUriProviders.has($))throw new Error(`A provider has already been registered for scheme ${$}`);this._canonicalUriProviders.set($,z);const N=this._uriTransformerService.transformOutgoingScheme($),q=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(q,N),(0,R.toDisposable)(()=>{this._canonicalUriProviders.delete($),this._proxy.$unregisterCanonicalUriProvider(q)})}async provideCanonicalUri($,z,N){const q=this._canonicalUriProviders.get($.scheme);if(!q)return;const x=await q.provideCanonicalUri?.(D.URI.revive($),z,N);if(x)return x}async $provideCanonicalUri($,z,N){return this.provideCanonicalUri(D.URI.revive($),{targetScheme:z},N)}};e.ExtHostWorkspace=P=Ve([ze(0,_.IExtHostRpcService),ze(1,f.IExtHostInitDataService),ze(2,b.IExtHostFileSystemInfo),ze(3,i.ILogService),ze(4,s.IURITransformerService)],P),e.IExtHostWorkspace=(0,E.createDecorator)("IExtHostWorkspace");function M(W){let $,z;return W&&(typeof W=="string"?$=W:($=W.pattern,z=D.URI.revive(W.baseUri))),{includePattern:$,folder:z}}}),define(De[38],Ie([1,0,24,3,37,6,7,230,129,12,17,5,20,18,2]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function E(o,s){if(s){const t=s.split(".");let u=o;for(let p=0;u&&p<t.length;p++)u=u[t[p]];return u}}function i(o){return o instanceof I.URI}function l(o){return o&&o.uri instanceof I.URI&&o.languageId&&typeof o.languageId=="string"}function a(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function b(o){return o&&o.uri instanceof I.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function f(o){if(i(o))return{resource:o};if(l(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(a(o))return{overrideIdentifier:o.languageId};if(b(o))return{resource:o.uri};if(o===null)return{resource:null}}let _=e.ExtHostConfiguration=class{constructor(s,t,u){this._proxy=s.getProxy(L.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=u,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new n(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,t){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(s,t))}};e.ExtHostConfiguration=_=Ve([ze(0,w.IExtHostRpcService),ze(1,d.IExtHostWorkspace),ze(2,D.ILogService)],_);class n{constructor(s,t,u,p){this._onDidChangeConfiguration=new T.Emitter,this._proxy=s,this._logService=p,this._extHostWorkspace=t,this._configuration=g.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,t){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=g.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,u))}getConfiguration(s,t,u){const p=f(t)||{},h=this._toReadonlyValue(s?E(this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,p,u?.identifier);function C(c){if(c==null)return null;if(typeof c=="boolean")return c?2:5;switch(c){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const S={has(c){return typeof E(h,c)<"u"},get:(c,r)=>{this._validateConfigurationAccess(s?`${s}.${c}`:c,p,u?.identifier);let P=E(h,c);if(typeof P>"u")P=r;else{let M;const W=($,z)=>{if((0,m.isObject)($)){let N;const q=()=>{M=M||(0,v.deepClone)(h),N=N||E(M,z)};return new Proxy($,{get:(x,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return q(),()=>N;if(M)return N=N||E(M,z),N[U];const de=x[U];return typeof U=="string"?W(de,`${z}.${U}`):de},set:(x,U,de)=>(q(),N&&(N[U]=de),!0),deleteProperty:(x,U)=>(q(),N&&delete N[U],!0),defineProperty:(x,U,de)=>(q(),N&&Object.defineProperty(N,U,de),!0)})}return Array.isArray($)?(0,v.deepClone)($):$};P=W(P,c)}return P},update:(c,r,P,M)=>{c=s?`${s}.${c}`:c;const W=C(P);return r!==void 0?this._proxy.$updateConfigurationOption(W,c,r,p,M):this._proxy.$removeConfigurationOption(W,c,p,M)},inspect:c=>{c=s?`${s}.${c}`:c;const r=this._configuration.inspect(c,p,this._extHostWorkspace.workspace);if(r)return{key:c,defaultValue:(0,v.deepClone)(r.policy?.value??r.default?.value),globalValue:(0,v.deepClone)(r.user?.value??r.application?.value),workspaceValue:(0,v.deepClone)(r.workspace?.value),workspaceFolderValue:(0,v.deepClone)(r.workspaceFolder?.value),defaultLanguageValue:(0,v.deepClone)(r.default?.override),globalLanguageValue:(0,v.deepClone)(r.user?.override??r.application?.override),workspaceLanguageValue:(0,v.deepClone)(r.workspace?.override),workspaceFolderLanguageValue:(0,v.deepClone)(r.workspaceFolder?.override),languageIds:(0,v.deepClone)(r.overrideIdentifiers)}}};return typeof h=="object"&&(0,v.mixin)(S,h,!1),Object.freeze(S)}_toReadonlyValue(s){const t=u=>(0,m.isObject)(u)?new Proxy(u,{get:(p,h)=>t(p[h]),set:(p,h,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(h)}' of object`)},deleteProperty:(p,h)=>{throw new Error(`TypeError: Cannot delete read only property '${String(h)}' of object`)},defineProperty:(p,h)=>{throw new Error(`TypeError: Cannot define property '${String(h)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return t(s)}_validateConfigurationAccess(s,t,u){const p=y.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),h=u?`[${u.value}] `:"";if(p===4){typeof t?.resource>"u"&&this._logService.warn(`${h}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){t?.resource&&this._logService.warn(`${h}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,t){const u=new g.ConfigurationChangeEvent(s,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(p,h)=>u.affectsConfiguration(p,f(h))})}_toMap(s){return s.reduce((t,u)=>(t.set(u[0],u[1]),t),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(re,e,v,T,d){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!d)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!d:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?d.call(re,v):d?d.value=v:e.set(re,v),v},Fe=this&&this.__classPrivateFieldGet||function(re,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!T:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(re):T?T.value:e.get(re)};define(De[87],Ie([1,0,2,17,3,6,7,37,62,38,21,43,20,26,5,16,10,18,83,272,8]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l,a,b,f){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var n;(function($){function z(q){if(q!=null)return q}$.from=z;function N(q){if(q!=null)return q}$.to=N})(n||(n={}));var o;(function($){function z(q){if(q!=null)return q}$.from=z;function N(q){if(q!=null)return q}$.to=N})(o||(o={}));var s;(function($){function z(q){if(q!=null)return q}$.from=z;function N(q){if(q!=null)return q}$.to=N})(s||(s={}));var t;(function($){function z(x){if(x){const U=x;return U&&!!U.process}else return!1}$.is=z;function N(x){if(x==null)return;const U={process:x.process,args:x.args};return x.options&&(U.options=s.from(x.options)),U}$.from=N;function q(x){if(x!=null)return new R.ProcessExecution(x.process,x.args,x.options)}$.to=q})(t||(t={}));var u;(function($){function z(q){if(q!=null)return q}$.from=z;function N(q){if(q!=null)return q}$.to=N})(u||(u={}));var p;(function($){function z(x){if(x){const U=x;return U&&(!!U.commandLine||!!U.command)}else return!1}$.is=z;function N(x){if(x==null)return;const U={};return x.commandLine!==void 0?U.commandLine=x.commandLine:(U.command=x.command,U.args=x.args),x.options&&(U.options=u.from(x.options)),U}$.from=N;function q(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new R.ShellExecution(x.commandLine,x.options):new R.ShellExecution(x.command,x.args?x.args:[],x.options)}$.to=q})(p||(p={}));var h;(function($){function z(x){if(x){const U=x;return U&&U.customExecution==="customExecution"}else return!1}$.is=z;function N(x){return{customExecution:"customExecution"}}$.from=N;function q(x,U){return U.get(x)}$.to=q})(h||(e.CustomExecutionDTO=h={}));var C;(function($){function z(N,q){let x;return N.scope!==void 0&&typeof N.scope!="number"?x=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===R.TaskScope.Workspace&&q&&q.workspaceFile?x=q.workspaceFile:x=b.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:x}}$.from=z})(C||(e.TaskHandleDTO=C={}));var S;(function($){function z(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}$.from=z})(S||(S={}));var c;(function($){function z(x,U){if(x==null)return[];const de=[];for(const ie of x){const ne=N(ie,U);ne&&de.push(ne)}return de}$.fromMany=z;function N(x,U){if(x==null)return;let de;x.execution instanceof R.ProcessExecution?de=t.from(x.execution):x.execution instanceof R.ShellExecution?de=p.from(x.execution):x.execution&&x.execution instanceof R.CustomExecution&&(de=h.from(x.execution));const ie=n.from(x.definition);let ne;return x.scope?typeof x.scope=="number"?ne=x.scope:ne=x.scope.uri:ne=R.TaskScope.Workspace,!ie||!ne?void 0:{_id:x._id,definition:ie,name:x.name,source:{extensionId:U.identifier.value,label:x.source,scope:ne},execution:de,isBackground:x.isBackground,group:S.from(x.group),presentationOptions:o.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}$.from=N;async function q(x,U,de){if(x==null)return;let ie;t.is(x.execution)?ie=t.to(x.execution):p.is(x.execution)?ie=p.to(x.execution):h.is(x.execution)&&(ie=h.to(x._id,de));const ne=n.to(x.definition);let H;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?H=x.source.scope:H=await U.resolveWorkspaceFolder(v.URI.revive(x.source.scope)):H=R.TaskScope.Workspace),!ne||!H)return;const V=new R.Task(ne,H,x.name,x.source.label,ie,x.problemMatchers);return x.isBackground!==void 0&&(V.isBackground=x.isBackground),x.group!==void 0&&(V.group=R.TaskGroup.from(x.group._id),V.group&&x.group.isDefault&&(V.group=new R.TaskGroup(V.group.id,V.group.label),x.group.isDefault===!0&&(V.group.isDefault=x.group.isDefault))),x.presentationOptions&&(V.presentationOptions=o.to(x.presentationOptions)),x._id&&(V._id=x._id),x.detail&&(V.detail=x.detail),V}$.to=q})(c||(e.TaskDTO=c={}));var r;(function($){function z(q){return q}$.from=z;function N(q){if(q)return Object.assign(Object.create(null),q)}$.to=N})(r||(r={}));class P{constructor(z,N,q){this._id=N,this._task=q,_.set(this,void 0),Ye(this,_,z,"f")}get task(){return this._task}terminate(){Fe(this,_,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}_=new WeakMap;let M=e.ExtHostTaskBase=class{constructor(z,N,q,x,U,de,ie,ne){this._onDidExecuteTask=new d.Emitter,this._onDidTerminateTask=new d.Emitter,this._onDidTaskProcessStarted=new d.Emitter,this._onDidTaskProcessEnded=new d.Emitter,this._proxy=z.getProxy(L.MainContext.MainThreadTask),this._workspaceProvider=q,this._editorService=x,this._configurationService=U,this._terminalService=de,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ie,this._deprecationService=ne,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,N,q){if(!q)return new R.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:N,provider:q,extension:z}),this._proxy.$registerTaskProvider(x,N),new R.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(z,N){this._proxy.$registerTaskSystem(z,N)}fetchTasks(z){return this._proxy.$fetchTasks(r.from(z)).then(async N=>{const q=[];for(const x of N){const U=await c.to(x,this._workspaceProvider,this._providedCustomExecutions2);U&&q.push(U)}return q})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(N=>z.push(N)),z}terminateTask(z){if(!(z instanceof P))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,N,q){const x=this._providedCustomExecutions2.get(z.id);x&&(this._activeCustomExecutions2.set(z.id,x),this._terminalService.attachPtyToTerminal(N,await x.callback(q))),this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const N=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:N})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const N=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:N,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const N=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:N,exitCode:z.exitCode})}$provideTasks(z,N){const q=this._handlers.get(z);if(!q)return Promise.reject(new Error("no handler found"));const x=[],U=(0,T.asPromise)(()=>q.provider.provideTasks(A.CancellationToken.None)).then(de=>this.provideTasksInternal(N,x,q,de));return new Promise(de=>{U.then(ie=>{Promise.all(x).then(()=>{de(ie)})})})}async $resolveTask(z,N){const q=this._handlers.get(z);if(!q)return Promise.reject(new Error("no handler found"));if(N.definition.type!==q.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${q.type}].`);const x=await c.to(N,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const U=await q.provider.resolveTask(x,A.CancellationToken.None);if(!U)return;this.checkDeprecation(U,q);const de=c.from(U,q.extension);if(!de)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(de.execution)&&await this.addCustomExecution(de,U,!0),await this.resolveTaskInternal(de)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,N,q){const x=await this._proxy.$createTaskId(z);!q&&!this._providedCustomExecutions2.has(x)&&(this._notProvidedCustomExecutions.add(x),this._activeCustomExecutions2.set(x,N.execution)),this._providedCustomExecutions2.set(x,N.execution)}async getTaskExecution(z,N){if(typeof z=="string"){const U=this._taskExecutionPromises.get(z);if(!U)throw new f.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return U}const q=this._taskExecutionPromises.get(z.id);if(q)return q;const x=new Promise((U,de)=>{function ie(ne,H,V){V?U(new P(ne,H.id,V)):de("Unexpected: Task does not exist.")}N?ie(this,z,N):c.to(z.task,this._workspaceProvider,this._providedCustomExecutions2).then(ne=>ie(this,z,ne))});return this._taskExecutionPromises.set(z.id,x),x.then(U=>(this._taskExecutions.set(z.id,U),U),U=>Promise.reject(U))}checkDeprecation(z,N){z._deprecated&&this._deprecationService.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));const q=this._notProvidedCustomExecutions.values();let x=q.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=q.next()}};e.ExtHostTaskBase=M=Ve([ze(0,w.IExtHostRpcService),ze(1,D.IExtHostInitDataService),ze(2,g.IExtHostWorkspace),ze(3,y.IExtHostDocumentsAndEditors),ze(4,m.IExtHostConfiguration),ze(5,k.IExtHostTerminalService),ze(6,l.ILogService),ze(7,a.IExtHostApiDeprecationService)],M);let W=e.WorkerExtHostTask=class extends M{constructor(z,N,q,x,U,de,ie,ne){super(z,N,q,x,U,de,ie,ne),this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:"",platform:i.PlatformToString(0)})}async executeTask(z,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const q=c.from(N,z);if(q===void 0)throw new Error("Task is not valid");if(h.is(q.execution))await this.addCustomExecution(q,N,!1);else throw new f.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(q),N);return this._proxy.$executeTask(q).catch(U=>{throw new Error(U)}),x}provideTasksInternal(z,N,q,x){const U=[];if(x)for(const de of x){this.checkDeprecation(de,q),(!de.definition||!z[de.definition.type])&&this._logService.warn(`The task [${de.source}, ${de.name}] uses an undefined task type. The task will be ignored in the future.`);const ie=c.from(de,q.extension);ie&&h.is(ie.execution)?(U.push(ie),N.push(this.addCustomExecution(ie,de,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:U,extension:q.extension}}async resolveTaskInternal(z){if(h.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,N,q){}};e.WorkerExtHostTask=W=Ve([ze(0,w.IExtHostRpcService),ze(1,D.IExtHostInitDataService),ze(2,g.IExtHostWorkspace),ze(3,y.IExtHostDocumentsAndEditors),ze(4,m.IExtHostConfiguration),ze(5,k.IExtHostTerminalService),ze(6,l.ILogService),ze(7,a.IExtHostApiDeprecationService)],W),e.IExtHostTask=(0,I.createDecorator)("IExtHostTask")}),define(De[323],Ie([1,0,11,21,45,33,23,39,34]),function(re,e,v,T,d,L,R,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class m{constructor(w,D,I){this.config=w,this.provider=D,this.sessionToken=I,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=w.filePattern,this.includePattern=w.includePattern&&L.parse(w.includePattern),this.maxResults=w.maxResults||void 0,this.exists=w.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=w.excludePattern&&L.parse(w.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(w=>w.cancel()),this.activeCancellationTokens=new Set}search(w){const D=this.config.folderQueries||[];return new Promise((I,E)=>{const i=l=>{this.resultCount++,w(l)};if(this.isCanceled)return I({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(l=>{const a=l.toString(),b=v.basename(a);this.globalExcludePattern&&this.globalExcludePattern(a,b)||this.matchFile(i,{base:l,basename:b})}),Promise.all(D.map(l=>this.searchInFolder(l,i))).then(l=>{I({limitHit:this.isLimitHit,stats:l[0]||void 0})},l=>{E(new Error((0,d.toErrorMessage)(l)))})})}async searchInFolder(w,D){const I=new T.CancellationTokenSource,E=this.getSearchOptionsForFolder(w),i=this.initDirectoryTree(),l=new y.QueryGlobTester(this.config,w),a=!l.hasSiblingExcludeClauses();let b;try{this.activeCancellationTokens.add(I),b=g.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},E,I.token),_=b.elapsed(),n=g.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(o=>{const s=v.posix.relative(w.folder.path,o.path);if(a){const t=v.basename(o.path);this.matchFile(D,{base:w.folder,relativePath:s,basename:t});return}this.addDirectoryEntries(i,w.folder,s,D)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(i,l,D),{providerTime:_,postProcessTime:n.elapsed()})}finally{I.dispose(),this.activeCancellationTokens.delete(I)}}getSearchOptionsForFolder(w){const D=(0,y.resolvePatternsForProvider)(this.config.includePattern,w.includePattern),I=(0,y.resolvePatternsForProvider)(this.config.excludePattern,w.excludePattern);return{folder:w.folder,excludes:I,includes:D,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}addDirectoryEntries({pathToEntries:w},D,I,E){if(I===this.filePattern){const l=v.basename(this.filePattern);this.matchFile(E,{base:D,relativePath:this.filePattern,basename:l})}function i(l){const a=v.basename(l),b=v.dirname(l);let f=w[b];f||(f=w[b]=[],i(b)),f.push({base:D,relativePath:l,basename:a})}i(I)}matchDirectoryTree({rootEntries:w,pathToEntries:D},I,E){const i=this,l=this.filePattern;function a(b){const f=(0,y.hasSiblingFn)(()=>b.map(_=>_.basename));for(let _=0,n=b.length;_<n;_++){const o=b[_],{relativePath:s,basename:t}=o;if(I.matchesExcludesSync(s,t,l!==t?f:void 0))continue;const u=D[s];if(u)a(u);else{if(s===l)continue;i.matchFile(E,o)}if(i.isLimitHit)break}}a(w)}matchFile(w,D){(!this.includePattern||D.relativePath&&this.includePattern(D.relativePath,D.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||w(D))}}class A{constructor(){this.sessions=new Map}fileSearch(w,D,I,E){const i=this.getSessionTokenSource(w.cacheKey),l=new m(w,D,i&&i.token);let a=0;const b=f=>{a+=f.length,I(f.map(_=>this.rawMatchToSearchItem(_)))};return this.doSearch(l,A.BATCH_SIZE,b,E).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:a,detailStats:f.stats}}))}clearCache(w){this.getSessionTokenSource(w)?.cancel()}getSessionTokenSource(w){if(w)return this.sessions.has(w)||this.sessions.set(w,new T.CancellationTokenSource),this.sessions.get(w)}rawMatchToSearchItem(w){return w.relativePath?{resource:R.joinPath(w.base,w.relativePath)}:{resource:w.base}}doSearch(w,D,I,E){E.onCancellationRequested(()=>{w.cancel()});const i=a=>{a&&(l.push(a),D>0&&l.length>=D&&(I(l),l=[]))};let l=[];return w.search(i).then(a=>(l.length&&I(l),a),a=>(l.length&&I(l),Promise.reject(a)))}}e.FileSearchManager=A,A.BATCH_SIZE=512}),define(De[324],Ie([1,0,19,65,33,120,28,16,11,23,9,12,2,163,210,57,18,50,137,322,34]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l,a,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let _=e.QueryBuilder=class{constructor(c,r,P,M,W){this.configurationService=c,this.workspaceContextService=r,this.editorGroupsService=P,this.logService=M,this.pathService=W}text(c,r,P={}){c=this.getContentPattern(c,P);const M=this.configurationService.getValue(),W=r&&r.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep);return{...this.commonQuery(r?.map(l.toWorkspaceFolder),P),type:2,contentPattern:c,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:M.search.usePCRE2||W||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}getContentPattern(c,r){const P=this.configurationService.getValue();c.isRegExp&&(c.pattern=c.pattern.replace(/\r?\n/g,"\\n"));const M={...c,wordSeparators:P.editor.wordSeparators};return this.isCaseSensitive(c,r)&&(M.isCaseSensitive=!0),this.isMultiline(c)&&(M.isMultiline=!0),r.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=r.notebookSearchConfig.includeMarkupInput),r.notebookSearchConfig?.includeMarkupPreview&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownPreview=r.notebookSearchConfig.includeMarkupPreview),r.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=r.notebookSearchConfig.includeCodeInput),r.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=r.notebookSearchConfig.includeOutput),M}file(c,r={}){return{...this.commonQuery(c,r),type:1,filePattern:r.filePattern?r.filePattern.trim():r.filePattern,exists:r.exists,sortByScore:r.sortByScore,cacheKey:r.cacheKey}}handleIncludeExclude(c,r){return c?(c=Array.isArray(c)?c.map(u):u(c),r?this.parseSearchPaths(c):{pattern:o(...Array.isArray(c)?c:[c])}):{}}commonQuery(c=[],r={}){const P=this.handleIncludeExclude(r.includePattern,r.expandPatterns),M=this.handleIncludeExclude(r.excludePattern,r.expandPatterns),W=c.length>1,$=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(q=>this.getFolderQueryForSearchPath(q,r,M)):c.map(q=>this.getFolderQueryForRoot(q,r,M,W))).filter(q=>!!q),z={_reason:r._reason,folderQueries:$,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:r.extraFileResources,excludePattern:M.pattern,includePattern:P.pattern,onlyOpenEditors:r.onlyOpenEditors,maxResults:r.maxResults};if(r.onlyOpenEditors){const q=v.coalesce(v.flatten(this.editorGroupsService.groups.map(de=>de.editors.map(ie=>ie.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(q));const x=q.filter(de=>(0,f.pathIncludedInQuery)(z,de.fsPath)),U=this.commonQueryFromFileList(x);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(U)),{...z,...U}}const N=r.extraFileResources&&r.extraFileResources.filter(q=>(0,f.pathIncludedInQuery)(z,q.fsPath));return z.extraFileResources=N&&N.length?N:void 0,z}commonQueryFromFileList(c){const r=[],P=new R.ResourceMap,M={};let W=!1;return c.forEach($=>{if($.scheme===g.Schemas.walkThrough)return;if((0,m.isAbsolutePath)($)){const N=this.workspaceContextService.getWorkspaceFolder($)?.uri??$.with({path:y.dirname($.fsPath)});let q=P.get(N);q||(W=!0,q={folder:N,includePattern:{}},r.push(q),P.set(N,q));const x=y.relative(N.fsPath,$.fsPath);(0,k.assertIsDefined)(q.includePattern)[x.replace(/\\/g,"/")]=!0}else $.fsPath&&(W=!0,M[$.fsPath]=!0)}),{folderQueries:r,includePattern:M,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}isCaseSensitive(c,r){if(r.isSmartCase){if(c.isRegExp){if(A.containsUppercaseCharacter(c.pattern,!0))return!0}else if(A.containsUppercaseCharacter(c.pattern))return!0}return!!c.isCaseSensitive}isMultiline(c){return c.isMultiline||c.isRegExp&&(0,D.isMultilineRegexSource)(c.pattern)||c.pattern.indexOf(`
`)>=0?!0:!!c.isMultiline}parseSearchPaths(c){const r=U=>y.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),M=(Array.isArray(c)?c:s(c)).map(U=>{const de=this.pathService.resolvedUserHome;return de?(0,L.untildify)(U,de.scheme===g.Schemas.file?de.fsPath:de.path):U}),W=T.groupBy(M,U=>r(U)?"searchPaths":"exprSegments"),$=(W.exprSegments||[]).map(U=>A.rtrim(U,"/")).map(U=>A.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),t(U))),z={},N=this.expandSearchPathPatterns(W.searchPaths||[]);N&&N.length&&(z.searchPaths=N);const q=v.flatten($),x=o(...q);return x&&(z.pattern=x),z}getExcludesForFolder(c,r){return r.disregardExcludeSettings?void 0:(0,f.getExcludes)(c,!r.disregardSearchExcludeSettings)}expandSearchPathPatterns(c){if(!c||!c.length)return[];const r=c.flatMap(M=>{let{pathPortion:W,globPortion:$}=n(M);return $&&($=p($)),this.expandOneSearchPath(W).flatMap(N=>this.resolveOneSearchPathPattern(N,$))}),P=new Map;return r.forEach(M=>{const W=M.searchPath.toString(),$=P.get(W);$?M.pattern&&($.pattern=$.pattern||{},$.pattern[M.pattern]=!0):P.set(W,{searchPath:M.searchPath,pattern:M.pattern?o(M.pattern):void 0})}),Array.from(P.values())}expandOneSearchPath(c){if(y.isAbsolute(c)){const r=this.workspaceContextService.getWorkspace().folders;return r[0]&&r[0].uri.scheme!==g.Schemas.file?[{searchPath:r[0].uri.with({path:c})}]:[{searchPath:w.URI.file(y.normalize(c))}]}if(this.workspaceContextService.getWorkbenchState()===2){const r=this.workspaceContextService.getWorkspace().folders[0].uri;if(c=u(c),c.startsWith("../")||c===".."){const M=y.posix.resolve(r.path,c);return[{searchPath:r.with({path:M})}]}const P=p(c);return[{searchPath:r,pattern:P}]}else{if(c==="./"||c===".\\")return[];{const r=c.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map(W=>{const $=r.match(new RegExp(`^${A.escapeRegExpCharacters(W.name)}(?:/(.*)|$)`));return $?{match:$,folder:W}:null}).filter(k.isDefined);if(M.length)return M.map(W=>{const $=W.match[1];return{searchPath:W.folder.uri,pattern:$&&p($)}});{const W=c.match(/\.[\/\\](.+)[\/\\]?/),$=W?W[1]:c,z=I.localize(0,null,$);throw new Error(z)}}}}resolveOneSearchPathPattern(c,r){const P=c.pattern&&r?`${c.pattern}/${r}`:c.pattern||r,M=[{searchPath:c.searchPath,pattern:P}];return P&&!P.endsWith("**")&&M.push({searchPath:c.searchPath,pattern:P+"/**"}),M}getFolderQueryForSearchPath(c,r,P){const M=this.getFolderQueryForRoot((0,l.toWorkspaceFolder)(c.searchPath),r,P,!1);return M?{...M,includePattern:c.pattern}:null}getFolderQueryForRoot(c,r,P,M){let W;const $=w.URI.isUri(c)?c:c.uri;if(P.searchPaths){const U=P.searchPaths.filter(de=>(0,m.isEqual)(de.searchPath,$))[0];if(U&&!U.pattern)return null;U&&(W=U.pattern)}const z=this.configurationService.getValue({resource:$}),q={...this.getExcludesForFolder(z,r)||{},...W||{}},x=w.URI.isUri(c)?(0,m.basename)(c):c.name;return{folder:$,folderName:M?x:void 0,excludePattern:Object.keys(q).length>0?q:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof r.disregardIgnoreFiles=="boolean"?r.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof r.disregardGlobalIgnoreFiles=="boolean"?r.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof r.disregardParentIgnoreFiles=="boolean"?r.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof r.ignoreSymlinks=="boolean"?r.ignoreSymlinks:!z.search.followSymlinks}}};e.QueryBuilder=_=Ve([ze(0,E.IConfigurationService),ze(1,l.IWorkspaceContextService),ze(2,a.IEditorGroupsService),ze(3,i.ILogService),ze(4,b.IPathService)],_);function n(S){const c=S.match(/[\*\{\}\(\)\[\]\?]/);if(c){const r=c.index,P=S.substr(0,r).match(/[/|\\][^/\\]*$/);if(P){let M=S.substr(0,P.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:S.substr((P.index||0)+1)}}}return{pathPortion:S}}function o(...S){return S.length?S.reduce((c,r)=>(c[r]=!0,c),Object.create(null)):void 0}function s(S){return d.splitGlobAware(S,",").map(c=>c.trim()).filter(c=>!!c.length)}function t(S){return[`**/${S}/**`,`**/${S}`].map(r=>r.replace(/\*\*\/\*\*/g,"**"))}function u(S){return S.replace(/\\/g,"/")}function p(S){return u(S).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(S){return S.replace(/([?*[\]])/g,"[$1]")}function C(S,c){S=v.distinct(S,M=>M.toString());const r=[],P=c.getWorkspace();return S&&S.forEach(M=>{let W;if(c.getWorkbenchState()===2)W=(0,m.relativePath)(P.folders[0].uri,M),W&&W!=="."&&(W="./"+W);else{const $=c.getWorkspaceFolder(M);if($){const z=$.name;if(P.folders.filter(q=>q.name===z).length===1){const q=(0,m.relativePath)($.uri,M);q===""?W=`./${$.name}`:W=`./${$.name}/${q}`}else W=M.fsPath}}W&&r.push(h(W))}),r}e.resolveResourcesForSearchIncludes=C}),define(De[325],Ie([1,0,23,2,21,8,5,324,34,50]),function(re,e,v,T,d,L,R,g,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const A=7e3;function k(E,i){const l=i.activationEvents;if(!l)return Promise.resolve(void 0);const a=[],b=[];for(const t of l)if(/^workspaceContains:/.test(t)){const u=t.substr(18);u.indexOf("*")>=0||u.indexOf("?")>=0||E.forceUsingSearch?b.push(u):a.push(u)}if(a.length===0&&b.length===0)return Promise.resolve(void 0);let f;const _=new Promise((t,u)=>{f=t}),n=t=>f({activationEvent:t}),o=Promise.all(a.map(t=>w(E,t,n))).then(()=>{}),s=D(E,i.identifier,b,n);return Promise.all([o,s]).then(()=>{f(void 0)}),_}e.checkActivateWorkspaceContainsExtension=k;async function w(E,i,l){for(const a of E.folders)if(await E.exists(v.joinPath(T.URI.revive(a),i))){l(`workspaceContains:${i}`);return}}async function D(E,i,l,a){if(l.length===0)return Promise.resolve(void 0);const b=new d.CancellationTokenSource,f=E.checkExists(E.folders,l,b.token),_=setTimeout(async()=>{b.cancel(),E.logService.info(`Not activating extension '${i.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},A);let n=!1;try{n=await f}catch(o){L.isCancellationError(o)||L.onUnexpectedError(o)}b.dispose(),clearTimeout(_),n&&a(`workspaceContains:${l.join(",")}`)}function I(E,i,l,a){const b=E.get(R.IInstantiationService),f=E.get(y.ISearchService),n=b.createInstance(g.QueryBuilder).file(i.map(o=>(0,m.toWorkspaceFolder)(T.URI.revive(o))),{_reason:"checkExists",includePattern:l,exists:!0});return f.fileSearch(n,a).then(o=>!!o.limitHit,o=>L.isCancellationError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=I});var Ye=this&&this.__classPrivateFieldSet||function(re,e,v,T,d){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!d)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!d:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?d.call(re,v):d?d.value=v:e.set(re,v),v},Fe=this&&this.__classPrivateFieldGet||function(re,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!T:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(re):T?T.value:e.get(re)};define(De[44],Ie([1,0,190,11,88,23,17,4,71,2,18,6,38,268,109,37,27,141,8,25,22,242,7,130,5,26,84,20,99,58,43,3,325,108,244,16,106,39,10,107]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l,a,b,f,_,n,o,s,t,u,p,h,C,S,c,r,P,M,W,$,z,N,q){"use strict";var x,U,de;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let ie=e.AbstractExtHostExtensionService=class Fn extends g.Disposable{constructor(O,K,we,Ce,ee,te,ue,Q,le,se,oe,F){super(),this._extHostManagedSockets=F,this._onDidChangeRemoteConnectionData=this._register(new c.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=K,this._extHostContext=we,this._initData=ue,this._extHostWorkspace=Ce,this._extHostConfiguration=ee,this._logService=te,this._extHostTunnelService=le,this._extHostTerminalService=se,this._extHostLocalizationService=oe,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._activationEventsReader=new Se(this._initData.activationEvents),this._globalRegistry=new l.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.allExtensions);const j=new b.ExtensionIdentifierSet(this._initData.myExtensions);this._myRegistry=new l.ExtensionDescriptionRegistry(this._activationEventsReader,ce(this._globalRegistry,j)),this._storage=new I.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new P.ExtHostSecretState(this._extHostContext),this._storagePath=Q,this._instaService=O.createChild(new h.ServiceCollection([I.IExtHostStorage,this._storage],[P.IExtHostSecretState,this._secretState])),this._activator=this._register(new D.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(Y,Z,me)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Y,a.transformErrorForSerialization(Z),me)},actualActivateExtension:async(Y,Z)=>{if(l.ExtensionDescriptionRegistry.isHostExtension(Y,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(Y,Z),new D.HostExtension;const me=this._myRegistry.getExtensionDescription(Y);return this._activateExtension(me,Z)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),d.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){a.onUnexpectedError(O)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let O=[];try{O=this._myRegistry.getAllExtensionDescriptions().map(ee=>ee.identifier).filter(ee=>this.isActivated(ee)).map(ee=>this._deactivate(ee))}catch{}await Promise.all(O)}terminate(O,K=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${O}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),a.setUnexpectedErrorHandler(Ce=>{this._logService.error(Ce)}),this._extHostContext.dispose();const we=this._deactivateAll();Promise.race([(0,R.timeout)(5e3),we]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${K}`):this._logService.info(`Extension host exiting with code ${K}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(K)})}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}async getExtension(O){const K=await this._mainThreadExtensionsProxy.$getExtension(O);return K&&{...K,identifier:new b.ExtensionIdentifier(K.identifier.value),extensionLocation:m.URI.revive(K.extensionLocation)}}_activateByEvent(O,K){return this._activator.activateByEvent(O,K)}_activateById(O,K){return this._activator.activateById(O,K)}activateByIdWithErrors(O,K){return this._activateById(O,K).then(()=>{const we=this._activator.getActivatedExtension(O);if(we.activationFailed)return Promise.reject(we.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._myRegistry)}getExtensionExports(O){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(O).exports;try{return this._activator.getActivatedExtension(O).exports}catch{return null}}async _realPathExtensionUri(O){if(O.scheme!==W.Schemas.file)return O;const K=await this._hostUtils.realpath(O.fsPath);return m.URI.file(K)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(O=>new be(O))),this._extensionPathIndex}async _createExtensionPathIndex(O){const K=y.TernarySearchTree.forUris(we=>L.extUriBiasedIgnorePathCase.ignorePathCasing(we));return await Promise.all(O.map(async we=>{if(this._getEntryPoint(we)){const Ce=await this._realPathExtensionUri(we.extensionLocation);K.set(Ce,we)}})),K}_deactivate(O){let K=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return K;const we=this._activator.getActivatedExtension(O);if(!we)return K;try{typeof we.module.deactivate=="function"&&(K=Promise.resolve(we.module.deactivate()).then(void 0,Ce=>(this._logService.error(Ce),Promise.resolve(void 0))))}catch(Ce){this._logService.error(`An error occurred when deactivating the extension '${O.value}':`),this._logService.error(Ce)}try{(0,g.dispose)(we.subscriptions)}catch(Ce){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${O.value}':`),this._logService.error(Ce)}return K}async _activateExtension(O,K){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,K).then(we=>{const Ce=we.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,Ce.codeLoadingTime,Ce.activateCallTime,Ce.activateResolvedTime,K),this._logExtensionActivationTimes(O,K,"success",Ce),we},we=>{throw this._logExtensionActivationTimes(O,K,"failure"),we})}_logExtensionActivationTimes(O,K,we,Ce){const ee=H(O,K);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ee,...Ce||{},outcome:we})}_doActivateExtension(O,K){const we=H(O,K);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",we);const Ce=this._getEntryPoint(O);if(!Ce)return Promise.resolve(new D.EmptyExtension(D.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value}, startup: ${K.startup}, activationEvent: '${K.activationEvent}'${O.identifier.value!==K.extensionId.value?`, root cause: ${K.extensionId.value}`:""}`),this._logService.flush();const ee=new D.ExtensionActivationTimesBuilder(K.startup);return Promise.all([this._loadCommonJSModule(O,(0,L.joinPath)(O.extensionLocation,Ce),ee),this._loadExtensionContext(O)]).then(te=>(d.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Fn._callActivate(this._logService,O.identifier,te[0],te[1],ee))).then(te=>(d.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),te))}_loadExtensionContext(O){const K=new _.ExtensionGlobalMemento(O,this._storage),we=new _.ExtensionMemento(O.identifier.value,!1,this._storage),Ce=new M.ExtensionSecrets(O,this._secretState),ee=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,te=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([K.whenReady,we.whenReady,this._storagePath.whenReady]).then(()=>{const ue=this;let Q,le;const se=(0,i.isProposedApiEnabled)(O,"ipc")?this._initData.messagePorts?.get(b.ExtensionIdentifier.toKey(O.identifier)):void 0;return Object.freeze({globalState:K,workspaceState:we,secrets:Ce,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(oe){return T.join(O.extensionLocation.fsPath,oe)},get storagePath(){return ue._storagePath.workspaceValue(O)?.fsPath},get globalStoragePath(){return ue._storagePath.globalValue(O).fsPath},get logPath(){return T.join(ue._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return m.URI.joinPath(ue._initData.logsLocation,O.identifier.value)},get storageUri(){return ue._storagePath.workspaceValue(O)},get globalStorageUri(){return ue._storagePath.globalValue(O)},get extensionMode(){return ee},get extension(){return Q===void 0&&(Q=new V(ue,O.identifier,O,te,!1)),Q},get extensionRuntime(){return(0,i.checkProposedApiEnabled)(O,"extensionRuntime"),ue.extensionRuntime},get environmentVariableCollection(){return ue._extHostTerminalService.getEnvironmentVariableCollection(O)},get messagePassingProtocol(){if(!le){if(!se)return;const oe=c.Event.buffer(c.Event.fromDOMEventEmitter(se,"message",F=>F.data));se.start(),le={onDidReceiveMessage:oe,postMessage:se.postMessage.bind(se)}}return le}})})}static _callActivate(O,K,we,Ce,ee){return we=we||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,K,we,Ce,ee).then(te=>new D.ActivatedExtension(!1,null,ee.build(),we,te,Ce.subscriptions))}static _callActivateOptional(O,K,we,Ce,ee){if(typeof we.activate=="function")try{ee.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${K.value}`);const te=typeof global=="object"?global:self,ue=we.activate.apply(te,[Ce]);return ee.activateCallStop(),ee.activateResolveStart(),Promise.resolve(ue).then(Q=>(ee.activateResolveStop(),Q))}catch(te){return Promise.reject(te)}else return Promise.resolve(we)}_activateOneStartupFinished(O,K){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:K}).then(void 0,we=>{this._logService.error(we)})}_activateAllStartupFinishedDeferred(O,K=0){const Ce=Date.now();(0,N.setTimeout0)(()=>{for(let ee=K;ee<O.length;ee+=1){const te=O[ee];for(const ue of te.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-Ce>50){this._activateAllStartupFinishedDeferred(O,ee);break}else this._activateOneStartupFinished(te,ue)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(d.getMarks()),this._extHostConfiguration.getConfigProvider().then(O=>{const K=O.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),we=this._myRegistry.getAllExtensionDescriptions();if(K)this._activateAllStartupFinishedDeferred(we);else for(const Ce of we)if(Ce.activationEvents)for(const ee of Ce.activationEvents)ee==="onStartupFinished"&&this._activateOneStartupFinished(Ce,ee)})}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,te=>{this._logService.error(te)});this._register(this._extHostWorkspace.onDidChangeWorkspace(te=>this._handleWorkspaceContainsEagerExtensions(te.added)));const K=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],we=this._handleWorkspaceContainsEagerExtensions(K),Ce=this._handleRemoteResolverEagerExtensions(),ee=Promise.all([Ce,O,we]).then(()=>{});return Promise.race([ee,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ee}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(K=>this._handleWorkspaceContainsEagerExtension(O,K))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,K){if(this.isActivated(K.identifier))return;const we=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Ce={logService:this._logService,folders:O.map(te=>te.uri),forceUsingSearch:we,exists:te=>this._hostUtils.exists(te.fsPath),checkExists:(te,ue,Q)=>this._mainThreadWorkspaceProxy.$checkExists(te,ue,Q)},ee=await(0,r.checkActivateWorkspaceContainsExtension)(Ce,K);if(ee)return this._activateById(K.identifier,{startup:!0,extensionId:K.identifier,activationEvent:ee.activationEvent}).then(void 0,te=>this._logService.error(te))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:K}=this._initData.environment;if(!O||!K)throw new Error(v.localize(0,null));const we=await this._loadCommonJSModule(null,K,new D.ExtensionActivationTimesBuilder(!1));if(!we||typeof we.run!="function")throw new Error(v.localize(1,null,K.toString()));return new Promise((Ce,ee)=>{const te=(le,se)=>{le?ee(le):Ce(typeof se=="number"&&se>0?1:0)},ue=(0,L.originalFSPath)(K),Q=we.run(ue,te);Q&&Q.then&&Q.then(()=>{Ce(0)}).catch(le=>{ee(le instanceof Error&&le.stack?le.stack:String(le))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,R.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(O,K){return this._resolvers[O]=K,(0,g.toDisposable)(()=>{delete this._resolvers[O]})}async getRemoteExecServer(O){const{resolver:K}=await this._activateAndGetResolver(O);return K?.resolveExecServer?.(O,{resolveAttempt:0})}async _activateAndGetResolver(O){const K=O.indexOf("+");if(K===-1)throw new Error("Not an authority that can be resolved!");const we=O.substr(0,K);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${we}`,!1),{authorityPrefix:we,resolver:this._resolvers[we]}}async $resolveAuthority(O,K){const we=z.StopWatch.create(!1),Ce=()=>`[resolveAuthority(${(0,o.getRemoteAuthorityPrefix)(O)},${K})][${we.elapsed()}ms] `,ee=me=>this._logService.info(`${Ce()}${me}`),te=(me,_e=void 0)=>this._logService.error(`${Ce()}${me}`,_e),ue=me=>{if(me instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:me._code,message:me._message,detail:me._detail}};throw me},Q=O.split(/@|%40/g).reverse();ee(`activating remote resolvers ${Q.join(" -> ")}`);let le;try{le=await Promise.all(Q.map(async me=>{ee("activating resolver...");const{resolver:_e,authorityPrefix:fe}=await this._activateAndGetResolver(me);if(!_e)throw te("no resolver"),new n.RemoteAuthorityResolverError(`No remote extension installed to resolve ${fe}.`,o.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:_e,authorityPrefix:fe,remoteAuthority:me}}))}catch(me){return ue(me)}const se=new R.IntervalTimer;se.cancelAndSet(()=>ee("waiting..."),1e3);let oe,F;for(const[me,{authorityPrefix:_e,resolver:fe,remoteAuthority:ke}]of le.entries())try{if(me===le.length-1)ee("invoking final resolve()..."),d.mark(`code/extHost/willResolveAuthority/${_e}`),oe=await fe.resolve(ke,{resolveAttempt:K,execServer:F}),d.mark(`code/extHost/didResolveAuthorityOK/${_e}`),ee("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(fe));else{if(ee(`invoking resolveExecServer() for ${ke}`),d.mark(`code/extHost/willResolveExecServer/${_e}`),F=await fe.resolveExecServer?.(ke,{resolveAttempt:K,execServer:F}),!F)throw new n.RemoteAuthorityResolverError(`Exec server was not available for ${ke}`,o.RemoteAuthorityResolverErrorCode.NoResolverFound);d.mark(`code/extHost/didResolveExecServerOK/${_e}`)}}catch(Pe){return d.mark(`code/extHost/didResolveAuthorityError/${_e}`),te("returned an error",Pe),se.dispose(),ue(Pe)}se.dispose();const j={environmentTunnels:oe.environmentTunnels,features:oe.tunnelFeatures},Y={extensionHostEnv:oe.extensionHostEnv,isTrusted:oe.isTrusted,authenticationSession:oe.authenticationSessionForInitializingExtensions?{id:oe.authenticationSessionForInitializingExtensions.id,providerId:oe.authenticationSessionForInitializingExtensions.providerId}:void 0};ee(`returned ${n.ManagedResolvedAuthority.isManagedResolvedAuthority(oe)?"managed authority":`${oe.host}:${oe.port}`}`);let Z;if(n.ManagedResolvedAuthority.isManagedResolvedAuthority(oe)){const me=K;this._extHostManagedSockets.setFactory(me,oe.makeConnection),Z={authority:O,connectTo:new o.ManagedRemoteConnection(me),connectionToken:oe.connectionToken}}else Z={authority:O,connectTo:new o.WebSocketRemoteConnection(oe.host,oe.port),connectionToken:oe.connectionToken};return{type:"ok",value:{authority:Z,options:Y,tunnelInformation:j}}}async $getCanonicalURI(O,K){this._logService.info(`$getCanonicalURI invoked for authority (${(0,o.getRemoteAuthorityPrefix)(O)})`);const{resolver:we}=await this._activateAndGetResolver(O);if(!we)return null;const Ce=m.URI.revive(K);if(typeof we.getCanonicalURI>"u")return Ce;const ee=await(0,R.asPromise)(()=>we.getCanonicalURI(Ce));return ee||Ce}$startExtensionHost(O){O.toAdd.forEach(Ce=>Ce.extensionLocation=m.URI.revive(Ce.extensionLocation));const{globalRegistry:K,myExtensions:we}=ne(this._activationEventsReader,this._globalRegistry,this._myRegistry,O);return this._globalRegistry.set(K.getAllExtensionDescriptions()),this._myRegistry.set(we),this._startExtensionHost()}$activateByEvent(O,K){return K===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(we=>this._activateByEvent(O,!1))}async $activate(O,K){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(O)?(await this._activateById(O,K),!0):!1}async $deltaExtensions(O){O.toAdd.forEach(te=>te.extensionLocation=m.URI.revive(te.extensionLocation));const{globalRegistry:K,myExtensions:we}=ne(this._activationEventsReader,this._globalRegistry,this._myRegistry,O),Ce=await this._createExtensionPathIndex(we);return(await this.getExtensionPathIndex()).setSearchTree(Ce),this._globalRegistry.set(K.getAllExtensionDescriptions()),this._myRegistry.set(we),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){const K=f.VSBuffer.alloc(O),we=Math.random()%256;for(let Ce=0;Ce<O;Ce++)K.writeUInt8(we,Ce);return K}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=ie=Ve([ze(0,s.IInstantiationService),ze(1,e.IHostUtils),ze(2,p.IExtHostRpcService),ze(3,E.IExtHostWorkspace),ze(4,w.IExtHostConfiguration),ze(5,A.ILogService),ze(6,t.IExtHostInitDataService),ze(7,u.IExtensionStoragePaths),ze(8,C.IExtHostTunnelService),ze(9,S.IExtHostTerminalService),ze(10,$.IExtHostLocalizationService),ze(11,q.IExtHostManagedSockets)],ie);function ne(ge,O,K,we){ge.addActivationEvents(we.addActivationEvents);const Ce=new l.ExtensionDescriptionRegistry(ge,O.getAllExtensionDescriptions());Ce.deltaExtensions(we.toAdd,we.toRemove);const ee=new b.ExtensionIdentifierSet(K.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of we.myToRemove)ee.delete(ue);for(const ue of we.myToAdd)ee.add(ue);const te=ce(Ce,ee);return{globalRegistry:Ce,myExtensions:te}}function H(ge,O){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class V{constructor(O,K,we,Ce,ee){x.set(this,void 0),U.set(this,void 0),de.set(this,void 0),Ye(this,x,O,"f"),Ye(this,U,K,"f"),Ye(this,de,we.identifier,"f"),this.id=we.identifier.value,this.extensionUri=we.extensionLocation,this.extensionPath=T.normalize((0,L.originalFSPath)(we.extensionLocation)),this.packageJSON=we,this.extensionKind=Ce,this.isFromDifferentExtensionHost=ee}get isActive(){return Fe(this,x,"f").isActivated(Fe(this,de,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Fe(this,x,"f").getExtensionExports(Fe(this,de,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Fe(this,x,"f").activateByIdWithErrors(Fe(this,de,"f"),{startup:!1,extensionId:Fe(this,U,"f"),activationEvent:"api"}),this.exports}}e.Extension=V,x=new WeakMap,U=new WeakMap,de=new WeakMap;function ce(ge,O){return ge.getAllExtensionDescriptions().filter(K=>O.has(K.identifier))}class be{constructor(O){this._searchTree=O}setSearchTree(O){this._searchTree=O}findSubstr(O){return this._searchTree.findSubstr(O)}forEach(O){return this._searchTree.forEach(O)}}e.ExtensionPaths=be;class Se{constructor(O){this._map=new b.ExtensionIdentifierMap,this.addActivationEvents(O)}readActivationEvents(O){return this._map.get(O.identifier)}addActivationEvents(O){for(const K of Object.keys(O))this._map.set(K,O[K])}}}),define(De[326],Ie([1,0,88,2,6,38,27,25,20,26,5,44,41,18,9]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let E=e.RequireInterceptor=class{constructor(_,n,o,s,t,u,p){this._apiFactory=_,this._extensionRegistry=n,this._instaService=o,this._extHostConfiguration=s,this._extHostExtensionService=t,this._initData=u,this._logService=p,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),v.mark("code/extHost/willWaitForConfig");const _=await this._extHostConfiguration.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const n=await this._extHostExtensionService.getExtensionPathIndex();this.register(new l(this._apiFactory,n,this._extensionRegistry,_,this._logService)),this.register(this._instaService.createInstance(a,n)),this.register(this._instaService.createInstance(i)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,n,this._initData.environment.appUriScheme))}register(_){if("nodeModuleName"in _)if(Array.isArray(_.nodeModuleName))for(const n of _.nodeModuleName)this._factories.set(n,_);else this._factories.set(_.nodeModuleName,_);typeof _.alternativeModuleName=="function"&&this._alternatives.push(n=>_.alternativeModuleName(n))}};e.RequireInterceptor=E=Ve([ze(2,A.IInstantiationService),ze(3,L.IExtHostConfiguration),ze(4,k.IExtHostExtensionService),ze(5,m.IExtHostInitDataService),ze(6,D.ILogService)],E);let i=class fn{constructor(_){if(_.environment.appRoot&&fn.aliased.size){const n=(0,I.escapeRegExpCharacters)(this.forceForwardSlashes(_.environment.appRoot.fsPath)),o="[a-z0-9_.-]",s=`@${o}+\\/${o}+|${o}+`,t="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${n}/${t}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(_){if(!this.re)return;const n=this.re.exec(this.forceForwardSlashes(_));if(!n)return;const[,o,s,t]=n,u=fn.aliased.get(s);if(u!==void 0)return console.warn(`${s} as been renamed to ${u}, please update your imports`),o+u+t}forceForwardSlashes(_){return _.replace(/\\/g,"/")}};i.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),i=Ve([ze(0,m.IExtHostInitDataService)],i);class l{constructor(_,n,o,s,t){this._apiFactory=_,this._extensionPaths=n,this._extensionRegistry=o,this._configProvider=s,this._logService=t,this.nodeModuleName="vscode",this._extApiImpl=new g.ExtensionIdentifierMap}load(_,n){const o=this._extensionPaths.findSubstr(n);if(o){let s=this._extApiImpl.get(o.identifier);return s||(s=this._apiFactory(o,this._extensionRegistry,this._configProvider),this._extApiImpl.set(o.identifier,s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((t,u)=>s+=`	${u} -> ${t.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let a=class{constructor(_,n,o){this._extensionPaths=_,this.nodeModuleName="keytar",this._mainThreadTelemetry=n.getProxy(d.MainContext.MainThreadTelemetry);const{environment:s}=o,t=n.getProxy(d.MainContext.MainThreadKeytar);if(s.appRoot){let u=s.appRoot.fsPath;w.platform==="win32"&&(u=u.replace(/\\/g,"/")),u[u.length-1]==="/"&&(u=u.substr(0,u.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${u}/node_modules.asar/keytar`),this.alternativeNames.add(`${u}/node_modules/keytar`)}this._impl={getPassword:(u,p)=>t.$getPassword(u,p),setPassword:(u,p,h)=>t.$setPassword(u,p,h),deletePassword:(u,p)=>t.$deletePassword(u,p),findPassword:u=>t.$findPassword(u),findCredentials(u){return t.$findCredentials(u)}}}load(_,n){const o=this._extensionPaths.findSubstr(n);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(_){const n=_.length;if(n<=7||!this.alternativeNames)return;const o=n-7;if((_.charAt(o)==="/"||_.charAt(o)==="\\")&&_.endsWith("keytar")&&(_=_.replace(/\\/g,"/"),this.alternativeNames.has(_)))return"keytar"}};a=Ve([ze(1,y.IExtHostRpcService),ze(2,m.IExtHostInitDataService)],a);let b=class{constructor(_,n,o){this._extensionPaths=_,this._appUriScheme=n,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=o.getProxy(d.MainContext.MainThreadTelemetry);const s=o.getProxy(d.MainContext.MainThreadWindow);this._impl=(t,u)=>{const p=T.URI.parse(t);return u?this.callOriginal(t,u):p.scheme==="http"||p.scheme==="https"?s.$openUri(p,t,{allowTunneling:!0}):p.scheme==="mailto"||p.scheme===this._appUriScheme?s.$openUri(p,t,{}):this.callOriginal(t,u)}}load(_,n,o){const s=this._extensionPaths.findSubstr(n);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=o(_),this._impl}callOriginal(_,n){return this.sendNoForwardTelemetry(),this._original(_,n)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=Ve([ze(2,y.IExtHostRpcService)],b)}),define(De[52],Ie([1,0,54,4,11,41,5,62,63,44,7,37,258,38]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,R.createDecorator)("IExtHostVariableResolverProvider");class I extends w.AbstractVariableResolverService{constructor(l,a,b,f,_,n,o){function s(){if(b){const t=b.activeEditor();if(t)return t.document.uri;const u=f.tabGroups.all.find(p=>p.isActive)?.activeTab;if(u!==void 0){if(u.input instanceof A.TextDiffTabInput||u.input instanceof A.NotebookDiffEditorTabInput)return u.input.modified;if(u.input instanceof A.TextTabInput||u.input instanceof A.NotebookEditorTabInput||u.input instanceof A.CustomEditorTabInput)return u.input.uri}}}super({getFolderUri:t=>{const u=n.folders.filter(p=>p.name===t);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(t,u)=>_.getConfiguration(void 0,t).get(u),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const t=s();if(t)return d.normalize(t.fsPath)},getWorkspaceFolderPathForFile:()=>{if(a){const t=s();if(t){const u=a.getWorkspaceFolder(t);if(u)return d.normalize(u.uri.fsPath)}}},getSelectedText:()=>{if(b){const t=b.activeEditor();if(t&&!t.selection.isEmpty)return t.document.getText(t.selection)}},getLineNumber:()=>{if(b){const t=b.activeEditor();if(t)return String(t.selection.end.line+1)}},getExtension:t=>l.getExtension(t)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(L.env))}}let E=e.ExtHostVariableResolverProviderService=class extends T.Disposable{constructor(l,a,b,f,_){super(),this.extensionService=l,this.workspaceService=a,this.editorService=b,this.configurationService=f,this.editorTabs=_,this._resolver=new v.Lazy(async()=>{const n=await this.configurationService.getConfigProvider(),s={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async t=>{s.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new I(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,n,s,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=E=Ve([ze(0,m.IExtHostExtensionService),ze(1,k.IExtHostWorkspace),ze(2,g.IExtHostDocumentsAndEditors),ze(3,D.IExtHostConfiguration),ze(4,y.IExtHostEditorTabs)],E)}),define(De[89],Ie([1,0,17,3,12,2,5,6,63,44,20,7,37,134,251,38,52]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,R.createDecorator)("IExtHostDebugService");let l=e.ExtHostDebugServiceBase=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(s,t,u,p,h,C){this._workspaceService=t,this._extensionService=u,this._configurationService=p,this._editorTabs=h,this._variableResolver=C,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=s.getProxy(g.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onWillAddFirstListener:()=>{this.startBreakpoints()}}),this._onDidChangeStackFrameFocus=new T.Emitter,this._activeDebugConsole=new b(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(S=>{S.onDidChange(c=>{this.registerAllDebugTypes(S)}),this.registerAllDebugTypes(S)})}asDebugSourceUri(s,t){const u=s;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let p=`debug:${encodeURIComponent(u.path||"")}`,h="?";return t&&(p+=`${h}session=${encodeURIComponent(t.id)}`,h="&"),p+=`${h}ref=${u.sourceReference}`,L.URI.parse(p)}else{if(u.path)return L.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const t=[];for(const u of s.getAllExtensionDescriptions())if(u.contributes){const p=u.contributes.debuggers;if(p&&p.length>0)for(const h of p)(0,I.isDebuggerMainContribution)(h)&&t.push(h.type)}this._debugServiceProxy.$registerDebugTypes(t)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(t=>s.push(t)),s}addBreakpoints(s){this.startBreakpoints();const t=s.filter(h=>{const C=h.id;return this._breakpoints.has(C)?!1:(this._breakpoints.set(C,h),!0)});this.fireBreakpointChanges(t,[],[]);const u=[],p=new Map;for(const h of t)if(h instanceof k.SourceBreakpoint){let C=p.get(h.location.uri.toString());C||(C={type:"sourceMulti",uri:h.location.uri,lines:[]},p.set(h.location.uri.toString(),C),u.push(C)),C.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof k.FunctionBreakpoint&&u.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this._debugServiceProxy.$registerBreakpoints(u)}removeBreakpoints(s){this.startBreakpoints();const t=s.filter(C=>this._breakpoints.delete(C.id));this.fireBreakpointChanges([],t,[]);const u=t.filter(C=>C instanceof k.SourceBreakpoint).map(C=>C.id),p=t.filter(C=>C instanceof k.FunctionBreakpoint).map(C=>C.id),h=t.filter(C=>C instanceof k.DataBreakpoint).map(C=>C.id);return this._debugServiceProxy.$unregisterBreakpoints(u,p,h)}startDebugging(s,t,u){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,t,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,suppressSaveBeforeStart:u.suppressSaveBeforeStart,suppressDebugStatusbar:u.suppressDebugStatusbar??u.debugUI?.simple,suppressDebugToolbar:u.suppressDebugToolbar??u.debugUI?.simple,suppressDebugView:u.suppressDebugView??u.debugUI?.simple})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,t,u){if(!t)return new k.Disposable(()=>{});const p=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:p,provider:t}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,u,!!t.provideDebugConfigurations,!!t.resolveDebugConfiguration,!!t.resolveDebugConfigurationWithSubstitutedVariables,p),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(h=>h.provider!==t),this._debugServiceProxy.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(s,t,u){if(!u)return new k.Disposable(()=>{});if(!this.definesDebugType(s,t))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${t}' debugger.`);if(this.getAdapterDescriptorFactoryByType(t))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:t,handle:p,factory:u}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(t,p),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(h=>h.factory!==u),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(s,t){if(!t)return new k.Disposable(()=>{});const u=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:u,factory:t}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(p=>p.factory!==t)})}async $runInTerminal(s,t){return Promise.resolve(void 0)}async $substituteVariables(s,t){let u;const p=await this.getFolder(s);return p&&(u={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(u,t)}createDebugAdapter(s,t){if(s.type==="implementation")return new _(s.implementation)}createSignService(){}async $startDASession(s,t){const u=this,p=await this.getSession(t);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(p.type),p).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const C=this.convertToDto(h),S=this.createDebugAdapter(C,p);if(!S)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const c=S;return this._debugAdapters.set(s,c),this.getDebugAdapterTrackers(p).then(r=>(r&&this._debugAdaptersTrackers.set(s,r),c.onMessage(async P=>{if(P.type==="request"&&P.command==="handshake"){const M=P,W={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(M.arguments.value);W.body={signature:$},c.sendResponse(W)}else throw new Error("no signer")}catch($){W.success=!1,W.message=$.message,c.sendResponse(W)}}else r&&r.onDidSendMessage&&r.onDidSendMessage(P),P=(0,I.convertToVSCPaths)(P,!0),u._debugServiceProxy.$acceptDAMessage(s,P)}),c.onError(P=>{r&&r.onError&&r.onError(P),this._debugServiceProxy.$acceptDAError(s,P.name,P.message,P.stack)}),c.onExit(P=>{r&&r.onExit&&r.onExit((0,d.withNullAsUndefined)(P),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,d.withNullAsUndefined)(P),void 0)}),r&&r.onWillStartSession&&r.onWillStartSession(),c.startSession()))})}$sendDAMessage(s,t){t=(0,I.convertToDAPaths)(t,!1);const u=this._debugAdaptersTrackers.get(s);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(t),this._debugAdapters.get(s)?.sendMessage(t)}$stopDASession(s){const t=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),t&&t.onWillStopSession&&t.onWillStopSession();const u=this._debugAdapters.get(s);return this._debugAdapters.delete(s),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const t=[],u=[],p=[];if(s.added)for(const h of s.added){const C=h.id;if(C&&!this._breakpoints.has(C)){let S;if(h.type==="function")S=new k.FunctionBreakpoint(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")S=new k.DataBreakpoint(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const c=L.URI.revive(h.uri);S=new k.SourceBreakpoint(new k.Location(c,new k.Position(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,k.setBreakpointId)(S,C),this._breakpoints.set(C,S),t.push(S)}}if(s.removed)for(const h of s.removed){const C=this._breakpoints.get(h);C&&(this._breakpoints.delete(h),u.push(C))}if(s.changed){for(const h of s.changed)if(h.id){const C=this._breakpoints.get(h.id);if(C){if(C instanceof k.FunctionBreakpoint&&h.type==="function"){const S=C;S.enabled=h.enabled,S.condition=h.condition,S.hitCondition=h.hitCondition,S.logMessage=h.logMessage,S.functionName=h.functionName}else if(C instanceof k.SourceBreakpoint&&h.type==="source"){const S=C;S.enabled=h.enabled,S.condition=h.condition,S.hitCondition=h.hitCondition,S.logMessage=h.logMessage,S.location=new k.Location(L.URI.revive(h.uri),new k.Position(h.line,h.character))}p.push(C)}}}this.fireBreakpointChanges(t,u,p)}async $acceptStackFrameFocus(s){let t;const u=s.sessionId?await this.getSession(s.sessionId):void 0;if(!u)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?t=new k.ThreadFocus(u,s.threadId):t=new k.StackFrameFocus(u,s.threadId,s.frameId),this._stackFrameFocus=t,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(s,t,u){return(0,v.asPromise)(async()=>{const p=this.getConfigProviderByHandle(s);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.getFolder(t);return p.provideDebugConfigurations(h,u)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(s,t,u,p){return(0,v.asPromise)(async()=>{const h=this.getConfigProviderByHandle(s);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.getFolder(t);return h.resolveDebugConfiguration(C,u,p)})}$resolveDebugConfigurationWithSubstitutedVariables(s,t,u,p){return(0,v.asPromise)(async()=>{const h=this.getConfigProviderByHandle(s);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.getFolder(t);return h.resolveDebugConfigurationWithSubstitutedVariables(C,u,p)})}async $provideDebugAdapter(s,t){const u=this.getAdapterDescriptorFactoryByHandle(s);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.getSession(t);return this.getAdapterDescriptor(u,p).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.convertToDto(h)})}async $acceptDebugSessionStarted(s){const t=await this.getSession(s);this._onDidStartDebugSession.fire(t)}async $acceptDebugSessionTerminated(s){const t=await this.getSession(s);t&&(this._onDidTerminateDebugSession.fire(t),this._debugSessions.delete(t.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,t){(await this.getSession(s))?._acceptNameChanged(t)}async $acceptDebugSessionCustomEvent(s,t){const p={session:await this.getSession(s),event:t.event,body:t.body};this._onDidReceiveDebugSessionCustomEvent.fire(p)}convertToDto(s){if(s instanceof k.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof k.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const t=this._adapterFactories.filter(u=>u.type===s);if(t.length>0)return t[0].factory}getAdapterDescriptorFactoryByHandle(s){const t=this._adapterFactories.filter(u=>u.handle===s);if(t.length>0)return t[0].factory}getConfigProviderByHandle(s){const t=this._configProviders.filter(u=>u.handle===s);if(t.length>0)return t[0].provider}definesDebugType(s,t){if(s.contributes){const u=s.contributes.debuggers;if(u&&u.length>0){for(const p of u)if(p.label&&p.type&&p.type===t)return!0}}return!1}getDebugAdapterTrackers(s){const u=s.configuration.type,p=this._trackerFactories.filter(h=>h.type===u||h.type==="*").map(h=>(0,v.asPromise)(()=>h.factory.createDebugAdapterTracker(s)).then(C=>C,C=>null));return Promise.race([Promise.all(p).then(h=>{const C=h.filter(S=>!!S);if(C.length>0)return new f(C)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async getAdapterDescriptor(s,t){const u=t.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new k.DebugAdapterServer(u));if(s){const h=await this._extensionService.getExtensionRegistry();return(0,v.asPromise)(()=>s.createDebugAdapterDescriptor(t,this.daExecutableFromPackage(t,h))).then(C=>{if(C)return C})}const p=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(t,p))}daExecutableFromPackage(s,t){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,t,u){(s.length>0||t.length>0||u.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:t,changed:u}))}async getSession(s){if(s)if(typeof s=="string"){const t=this._debugSessions.get(s);if(t)return t}else{let t=this._debugSessions.get(s.id);if(!t){const u=await this.getFolder(s.folderUri),p=s.parent?this._debugSessions.get(s.parent):void 0;t=new a(this._debugServiceProxy,s.id,s.type,s.name,u,s.configuration,p),this._debugSessions.set(t.id,t),this._debugServiceProxy.$sessionCached(t.id)}return t}throw new Error("cannot find session")}getFolder(s){if(s){const t=L.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(t)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=l=Ve([ze(0,A.IExtHostRpcService),ze(1,w.IExtHostWorkspace),ze(2,m.IExtHostExtensionService),ze(3,E.IExtHostConfiguration),ze(4,y.IExtHostEditorTabs),ze(5,i.IExtHostVariableResolverProvider)],l);class a{constructor(s,t,u,p,h,C,S){this._debugServiceProxy=s,this._id=t,this._type=u,this._name=p,this._workspaceFolder=h,this._configuration=C,this._parentSession=S}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,t){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,t)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=a;class b{constructor(s){this.value=Object.freeze({append(t){s.$appendDebugConsole(t)},appendLine(t){this.append(t+`
`)}})}}e.ExtHostDebugConsole=b;class f{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(t=>t.onWillReceiveMessage?t.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(t=>t.onDidSendMessage?t.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(t=>t.onError?t.onError(s):void 0)}onExit(s,t){this.trackers.forEach(u=>u.onExit?u.onExit(s,t):void 0)}}class _ extends D.AbstractDebugAdapter{constructor(s){super(),this.implementation=s,s.onDidSendMessage(t=>{this.acceptMessage(t)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let n=e.WorkerExtHostDebugService=class extends l{constructor(s,t,u,p,h,C){super(s,t,u,p,h,C)}};e.WorkerExtHostDebugService=n=Ve([ze(0,A.IExtHostRpcService),ze(1,w.IExtHostWorkspace),ze(2,m.IExtHostExtensionService),ze(3,E.IExtHostConfiguration),ze(4,y.IExtHostEditorTabs),ze(5,i.IExtHostVariableResolverProvider)],n)}),define(De[327],Ie([1,0,8,88,2,6,319,18,98,99,26,222,20,59,44,82]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class i{static async installEarlyHandler(b){const f=b.get(g.ILogService),n=b.get(w.IExtHostRpcService).getProxy(L.MainContext.MainThreadErrors);v.setUnexpectedErrorHandler(o=>{f.error(o);const s=v.transformErrorForSerialization(o);n.$onUnexpectedError(s)})}static async installFullHandler(b){const f=b.get(g.ILogService),_=b.get(w.IExtHostRpcService),n=b.get(I.IExtHostExtensionService),o=b.get(E.IExtHostTelemetry),s=_.getProxy(L.MainContext.MainThreadExtensionService),t=_.getProxy(L.MainContext.MainThreadErrors),u=await n.getExtensionPathIndex(),p=new WeakMap;function h(c,r){if(p.has(c))return p.get(c).stack;let P="",M,W;for(const z of r)P+=`
	at ${z.toString()}`,W=z.getFileName(),!M&&W&&(M=u.findSubstr(d.URI.file(W)));const $=`${c.name||"Error"}: ${c.message||""}${P}`;return p.set(c,{extensionIdentifier:M?.identifier,stack:$}),$}const C=Symbol("prepareStackTrace wrapped");let S=h;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return S},set(c){if(c===h||c[C]){S=c;return}S=function(r,P){return h(r,P),c.call(Error,r,P)},Object.assign(S,{[C]:!0})}}),v.setUnexpectedErrorHandler(c=>{f.error(c);const r=v.transformErrorForSerialization(c),P=p.get(c);if(!P?.extensionIdentifier){t.$onUnexpectedError(r);return}s.$onExtensionRuntimeError(P.extensionIdentifier,r);const M=o.onExtensionError(P.extensionIdentifier,c);f.trace("forwarded error to extension?",M,P)})}}e.ErrorHandler=i,Error.stackTraceLimit=100;class l{constructor(b,f,_,n,o){this._hostUtils=_,this._rpcProtocol=new R.RPCProtocol(b,null,n),f=l._transform(f,this._rpcProtocol);const s=new m.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());s.set(A.IExtHostInitDataService,{_serviceBrand:void 0,...f,messagePorts:o}),s.set(w.IExtHostRpcService,new w.ExtHostRpcService(this._rpcProtocol)),s.set(D.IURITransformerService,new D.URITransformerService(n)),s.set(I.IHostUtils,_);const t=new k.InstantiationService(s,!0);t.invokeFunction(i.installEarlyHandler),this._logService=t.invokeFunction(u=>u.get(g.ILogService)),T.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",f),this._extensionService=t.invokeFunction(u=>u.get(I.IExtHostExtensionService)),this._extensionService.initialize(),t.invokeFunction(i.installFullHandler)}async asBrowserUri(b){const f=this._rpcProtocol.getProxy(L.MainContext.MainThreadExtensionService);return d.URI.revive(await f.$asBrowserUri(b))}terminate(b){this._extensionService.terminate(b)}static _transform(b,f){b.allExtensions.forEach(n=>{n.extensionLocation=d.URI.revive(f.transformIncomingURIs(n.extensionLocation))}),b.environment.appRoot=d.URI.revive(f.transformIncomingURIs(b.environment.appRoot));const _=b.environment.extensionDevelopmentLocationURI;return _&&(b.environment.extensionDevelopmentLocationURI=_.map(n=>d.URI.revive(f.transformIncomingURIs(n)))),b.environment.extensionTestsLocationURI=d.URI.revive(f.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=d.URI.revive(f.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=d.URI.revive(f.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=d.URI.revive(f.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=d.URI.revive(f.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=d.URI.revive(f.transformIncomingURIs(b.logsLocation)),b.workspace=f.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=l}),define(De[328],Ie([1,0,17,10,199,216,232,89,63,44,20,43,7,52,37,252,253,38]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let a=e.ExtHostDebugService=class extends g.ExtHostDebugServiceBase{constructor(o,s,t,u,p,h,C){super(o,s,t,u,h,C),this._terminalService=p,this._integratedTerminalInstances=new _}createDebugAdapter(o,s){switch(o.type){case"server":return new E.SocketDebugAdapter(o);case"pipeServer":return new E.NamedPipeDebugAdapter(o);case"executable":return new E.ExecutableDebugAdapter(o,s.type)}return super.createDebugAdapter(o,s)}daExecutableFromPackage(o,s){const t=E.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),o.type);if(t)return new w.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new R.SignService}async $runInTerminal(o,s){if(o.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal($=>{this._integratedTerminalInstances.onTerminalClosed($)}));const t=await this._configurationService.getConfigProvider(),u=this._terminalService.getDefaultShell(!0),p=this._terminalService.getDefaultShellArgs(!0),h=o.title||d.localize(0,null),C=JSON.stringify({shell:u,shellArgs:p});let S=await this._integratedTerminalInstances.checkout(C,h),c,r=!1;if(S)c=o.cwd;else{const $={shellPath:u,shellArgs:p,cwd:o.cwd,name:h,iconPath:new w.ThemeIcon("debug")};r=!0,S=this._terminalService.createTerminalFromOptions($,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(S,C)}S.show(!0);const P=await S.processId;r?await new Promise($=>setTimeout($,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0||u.indexOf("cmd.exe")>=0?S.sendText("cls"):u.indexOf("bash")>=0?S.sendText("clear"):T.isWindows?S.sendText("cls"):S.sendText("clear"));const M=(0,i.prepareCommand)(u,o.args,!!o.argsCanBeInterpretedByShell,c,o.env);S.sendText(M);const W=this.onDidTerminateDebugSession($=>{$.id===s&&(this._integratedTerminalInstances.free(S),W.dispose())});return P}else if(o.kind==="external")return f(o,await this._configurationService.getConfigProvider());return super.$runInTerminal(o,s)}};e.ExtHostDebugService=a=Ve([ze(0,A.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,m.IExtHostExtensionService),ze(3,l.IExtHostConfiguration),ze(4,k.IExtHostTerminalService),ze(5,y.IExtHostEditorTabs),ze(6,D.IExtHostVariableResolverProvider)],a);let b;function f(n,o){if(!b)if(T.isWindows)b=new L.WindowsExternalTerminalService;else if(T.isMacintosh)b=new L.MacExternalTerminalService;else if(T.isLinux)b=new L.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=o.getConfiguration("terminal");return b.runInTerminal(n.title,n.cwd,n.args,n.env||{},s.external||{})}class _{constructor(){this._terminalInstances=new Map}async checkout(o,s){const u=[...this._terminalInstances.entries()].map(([p,h])=>(0,v.createCancelablePromise)(async C=>{if(p.name!==s||h.lastUsedAt!==-1&&await(0,i.hasChildProcesses)(await p.processId))return null;const S=Date.now();return h.lastUsedAt+_.minUseDelay>S||C.isCancellationRequested||h.config!==o?null:(h.lastUsedAt=S,p)}));return await(0,v.firstParallel)(u,p=>!!p)}insert(o,s){this._terminalInstances.set(o,{lastUsedAt:Date.now(),config:s})}free(o){const s=this._terminalInstances.get(o);s&&(s.lastUsedAt=-1)}onTerminalClosed(o){this._terminalInstances.delete(o)}}_.minUseDelay=1e3}),define(De[329],Ie([1,0,11,2,96,37,62,38,50,43,20,26,87,16,18,83,23,74,52]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let b=e.ExtHostTask=class extends w.ExtHostTaskBase{constructor(_,n,o,s,t,u,p,h,C){super(_,n,o,s,t,u,p,h),this.workspaceService=o,this.variableResolver=C,n.remote.isRemote&&n.remote.authority?this.registerTaskSystem(D.Schemas.vscodeRemote,{scheme:D.Schemas.vscodeRemote,authority:n.remote.authority,platform:process.platform}):this.registerTaskSystem(D.Schemas.file,{scheme:D.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(_,n){const o=n;if(!n.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const s=w.TaskHandleDTO.from(o,this.workspaceService),t=await this._proxy.$getTaskExecution(s);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.getTaskExecution(t,n);return this._proxy.$executeTask(s).catch(()=>{}),u}else{const s=w.TaskDTO.from(n,_);if(s===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(s.execution)&&await this.addCustomExecution(s,n,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(s),n);return this._proxy.$executeTask(s).catch(()=>{}),t}}provideTasksInternal(_,n,o,s){const t=[];if(s)for(const u of s){this.checkDeprecation(u,o),(!u.definition||!_[u.definition.type])&&this._logService.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const p=w.TaskDTO.from(u,o.extension);p&&(t.push(p),w.CustomExecutionDTO.is(p.execution)&&n.push(this.addCustomExecution(p,u,!0)))}return{tasks:t,extension:o.extension}}async resolveTaskInternal(_){return _}async getAFolder(_){let n=_&&_.length>0?_[0]:void 0;if(!n){const o=T.URI.file((0,l.homedir)());n=new y.WorkspaceFolder({uri:o,name:i.basename(o),index:0})}return{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(_,n){const o=T.URI.revive(_),s={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(o),u=await this._workspaceProvider.getWorkspaceFolders2()??[],p=await this.variableResolver.getResolver(),h=t?{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(u);for(const C of n.variables)s.variables[C]=await p.resolveAsync(h,C);if(n.process!==void 0){let C;if(n.process.path!==void 0){C=n.process.path.split(v.delimiter);for(let S=0;S<C.length;S++)C[S]=await p.resolveAsync(h,C[S])}s.process=await d.win32.findExecutable(await p.resolveAsync(h,n.process.name),n.process.cwd!==void 0?await p.resolveAsync(h,n.process.cwd):void 0,C)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(_,n,o){return d.win32.findExecutable(_,n,o)}};e.ExtHostTask=b=Ve([ze(0,A.IExtHostRpcService),ze(1,k.IExtHostInitDataService),ze(2,L.IExtHostWorkspace),ze(3,R.IExtHostDocumentsAndEditors),ze(4,g.IExtHostConfiguration),ze(5,m.IExtHostTerminalService),ze(6,I.ILogService),ze(7,E.IExtHostApiDeprecationService),ze(8,a.IExtHostVariableResolverProvider)],b)}),define(De[330],Ie([1,0,74,52]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class d extends T.ExtHostVariableResolverProviderService{homeDir(){return(0,v.homedir)()}}e.NodeExtHostVariableResolverProviderService=d}),define(De[146],Ie([1,0,19,17,21,45,16,11,23,2,34]),function(re,e,v,T,d,L,R,g,y,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(a,b,f,_){this.query=a,this.provider=b,this.fileUtils=f,this.processType=_,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,b){const f=this.query.folderQueries||[],_=new d.CancellationTokenSource;return b.onCancellationRequested(()=>_.cancel()),new Promise((n,o)=>{this.collector=new D(a);let s=!1;const t=(u,p)=>{if(!s&&!this.isLimitHit){const h=this.resultSize(u);E(u)&&typeof this.query.maxResults=="number"&&this.resultCount+h>this.query.maxResults&&(this.isLimitHit=!0,s=!0,_.cancel(),u=this.trimResultToSize(u,this.query.maxResults-this.resultCount));const C=this.resultSize(u);this.resultCount+=C,(C>0||!E(u))&&this.collector.add(u,p)}};Promise.all(f.map((u,p)=>this.searchInFolder(u,h=>t(h,p),_.token))).then(u=>{_.dispose(),this.collector.flush();const p=u.some(h=>!!h&&!!h.limitHit);n({limitHit:this.isLimitHit||p,messages:(0,v.flatten)(u.map(h=>h?.message?Array.isArray(h.message)?h.message:[h.message]:[])),stats:{type:this.processType}})},u=>{_.dispose();const p=(0,L.toErrorMessage)(u);o(new Error(p))})})}resultSize(a){return E(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,b){const f=Array.isArray(a.ranges)?a.ranges:[a.ranges],_=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:f.slice(0,b),preview:{matches:_.slice(0,b),text:a.preview.text},uri:a.uri}}async searchInFolder(a,b,f){const _=new A.QueryGlobTester(this.query,a),n=[],o={report:u=>{if(!this.validateProviderResult(u))return;const p=a.folder.scheme===R.Schemas.file?(0,A.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(u.uri))):void 0,h=y.relativePath(a.folder,u.uri);if(h){const C=_.includedInQuery(h,g.basename(h),p);(0,T.isThenable)(C)?n.push(C.then(S=>{S&&b(u)})):C&&b(u)}}},s=this.getSearchOptionsForFolder(a),t=await this.provider.provideTextSearchResults(w(this.query.contentPattern),s,o,f);return n.length&&await Promise.all(n),t}validateProviderResult(a){if(E(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const b=(0,A.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),f=(0,A.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),_={folder:m.URI.from(a.folder),excludes:f,includes:b,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return _.usePCRE2=this.query.usePCRE2,_}}e.TextSearchManager=k;function w(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class D{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new i(512,b=>this.sendItems(b))}add(a,b){this._currentFileMatch&&(this._currentFolderIdx!==b||!y.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=b,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(I(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=D;function I(l){return E(l)?{preview:{matches:(0,v.mapArrayOrNot)(l.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:l.preview.text},ranges:(0,v.mapArrayOrNot)(l.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function E(l){return!!l.preview}e.extensionResultIsMatch=E;class i{constructor(a,b){this.maxBatchSize=a,this.cb=b,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,b){a&&this.addItemToBatch(a,b)}addItems(a,b){a&&this.addItemsToBatch(a,b)}addItemToBatch(a,b){this.batch.push(a),this.batchSize+=b,this.onUpdate()}addItemsToBatch(a,b){this.batch=this.batch.concat(a),this.batchSize+=b,this.onUpdate()}onUpdate(){this.totalNumberCompleted<i.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},i.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=i,i.TIMEOUT=4e3,i.START_BATCH_AFTER_COUNT=50}),define(De[90],Ie([1,0,4,6,5,323,20,59,18,2,146]),function(re,e,v,T,d,L,R,g,y,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,d.createDecorator)("IExtHostSearch");let k=e.ExtHostSearch=class{constructor(E,i,l){this.extHostRpc=E,this._uriTransformer=i,this._logService=l,this._proxy=this.extHostRpc.getProxy(T.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new L.FileSearchManager}_transformScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}registerTextSearchProvider(E,i){if(this._textSearchUsedSchemes.has(E))throw new Error(`a text search provider for the scheme '${E}' is already registered`);this._textSearchUsedSchemes.add(E);const l=this._handlePool++;return this._textSearchProvider.set(l,i),this._proxy.$registerTextSearchProvider(l,this._transformScheme(E)),(0,v.toDisposable)(()=>{this._textSearchUsedSchemes.delete(E),this._textSearchProvider.delete(l),this._proxy.$unregisterProvider(l)})}registerFileSearchProvider(E,i){if(this._fileSearchUsedSchemes.has(E))throw new Error(`a file search provider for the scheme '${E}' is already registered`);this._fileSearchUsedSchemes.add(E);const l=this._handlePool++;return this._fileSearchProvider.set(l,i),this._proxy.$registerFileSearchProvider(l,this._transformScheme(E)),(0,v.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(E),this._fileSearchProvider.delete(l),this._proxy.$unregisterProvider(l)})}$provideFileSearchResults(E,i,l,a){const b=w(l),f=this._fileSearchProvider.get(E);if(f)return this._fileSearchManager.fileSearch(b,f,_=>{this._proxy.$handleFileMatch(E,i,_.map(n=>n.resource))},a);throw new Error("unknown provider: "+E)}$clearCache(E){return this._fileSearchManager.clearCache(E),Promise.resolve(void 0)}$provideTextSearchResults(E,i,l,a){const b=this._textSearchProvider.get(E);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${E}`);const f=w(l);return this.createTextSearchManager(f,b).search(n=>this._proxy.$handleTextMatch(E,i,n),a)}$enableExtensionHostSearch(){}createTextSearchManager(E,i){return new A.TextSearchManager(E,i,{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}};e.ExtHostSearch=k=Ve([ze(0,R.IExtHostRpcService),ze(1,g.IURITransformerService),ze(2,y.ILogService)],k);function w(I){return{...I,folderQueries:I.folderQueries&&I.folderQueries.map(D),extraFileResources:I.extraFileResources&&I.extraFileResources.map(E=>m.URI.revive(E))}}e.reviveQuery=w;function D(I){return{...I,folder:m.URI.revive(I.folder)}}}),define(De[331],Ie([1,0,21,8,3,40,2,124,117,159,174,30,6,105,278,277,36,279,38,281,282,283,260,284,62,44,285,286,291,292,293,145,264,299,300,303,109,43,305,265,15,7,79,308,85,144,37,25,256,290,78,142,87,89,90,18,59,20,26,294,254,58,83,274,306,84,64,311,309,310,275,51,304,307,108,63,82,295,86,296,16,127,263,243,288,4,27,250,106,239,297,298,276,287,262,301,289,107,302]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l,a,b,f,_,n,o,s,t,u,p,h,C,S,c,r,P,M,W,$,z,N,q,x,U,de,ie,ne,H,V,ce,be,Se,ge,O,K,we,Ce,ee,te,ue,Q,le,se,oe,F,j,Y,Z,me,_e,fe,ke,Pe,$e,He,tt,Ge,Ke,st,at,Ze,rt,he,Oe,J,X,Ee,Ue,Ne,Qe,et,nt,ft,wt,Mt,Ft,_t,Bt,Nt,Ut,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Vt(lt){const gt=lt.get(Q.IExtHostInitDataService),zt=lt.get($e.IExtHostFileSystemInfo),Rt=lt.get(me.IExtHostConsumerFileSystem),It=lt.get(t.IExtHostExtensionService),ut=lt.get(V.IExtHostWorkspace),Pt=lt.get(st.IExtHostTelemetry),Ot=lt.get(a.IExtHostConfiguration),Le=lt.get(te.IURITransformerService),Ae=lt.get(ue.IExtHostRpcService),Te=lt.get($.IExtHostStorage),ae=lt.get(Z.IExtensionStoragePaths),Me=lt.get(ee.ILoggerService),Be=lt.get(ee.ILogService),Xe=lt.get(oe.IExtHostTunnelService),je=lt.get(F.IExtHostApiDeprecationService),it=lt.get(H.IExtHostWindow),yt=lt.get(Ge.IExtHostSecretState),kt=lt.get(Ke.IExtHostEditorTabs),Tt=lt.get(Ut.IExtHostManagedSockets);Ae.set(w.ExtHostContext.ExtHostFileSystemInfo,zt),Ae.set(w.ExtHostContext.ExtHostLogLevelServiceShape,Me),Ae.set(w.ExtHostContext.ExtHostWorkspace,ut),Ae.set(w.ExtHostContext.ExtHostConfiguration,Ot),Ae.set(w.ExtHostContext.ExtHostExtensionService,It),Ae.set(w.ExtHostContext.ExtHostStorage,Te),Ae.set(w.ExtHostContext.ExtHostTunnelService,Xe),Ae.set(w.ExtHostContext.ExtHostWindow,it),Ae.set(w.ExtHostContext.ExtHostSecretState,yt),Ae.set(w.ExtHostContext.ExtHostTelemetry,Pt),Ae.set(w.ExtHostContext.ExtHostEditorTabs,kt),Ae.set(w.ExtHostContext.ExtHostManagedSockets,Tt);const vt=Ae.set(w.ExtHostContext.ExtHostDecorations,lt.get(O.IExtHostDecorations)),bt=Ae.set(w.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(s.IExtHostDocumentsAndEditors)),mt=Ae.set(w.ExtHostContext.ExtHostCommands,lt.get(i.IExtHostCommands)),St=Ae.set(w.ExtHostContext.ExtHostTerminalService,lt.get(z.IExtHostTerminalService)),Et=Ae.set(w.ExtHostContext.ExtHostDebugService,lt.get(we.IExtHostDebugService)),Qt=Ae.set(w.ExtHostContext.ExtHostSearch,lt.get(Ce.IExtHostSearch)),$t=Ae.set(w.ExtHostContext.ExtHostTask,lt.get(K.IExtHostTask)),ni=Ae.set(w.ExtHostContext.ExtHostOutputService,lt.get(c.IExtHostOutputService)),ai=Ae.set(w.ExtHostContext.ExtHostLocalization,lt.get(et.IExtHostLocalizationService)),Si=Ae.set(w.ExtHostContext.ExtHostUrls,new ie.ExtHostUrls(Ae)),At=Ae.set(w.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(Ae,bt)),ci=Ae.set(w.ExtHostContext.ExtHostDocumentContentProviders,new _.ExtHostDocumentContentProvider(Ae,bt,Be)),fi=Ae.set(w.ExtHostContext.ExtHostDocumentSaveParticipant,new n.ExtHostDocumentSaveParticipant(Be,At,Ae.getProxy(w.MainContext.MainThreadBulkEdits))),Dt=Ae.set(w.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(Ae,mt,bt,At,Rt)),_i=Ae.set(w.ExtHostContext.ExtHostNotebookDocuments,new X.ExtHostNotebookDocuments(Dt)),Li=Ae.set(w.ExtHostContext.ExtHostNotebookEditors,new J.ExtHostNotebookEditors(Be,Dt)),mi=Ae.set(w.ExtHostContext.ExtHostNotebookKernels,new at.ExtHostNotebookKernels(Ae,gt,Dt,mt,Be)),Fi=Ae.set(w.ExtHostContext.ExtHostNotebookRenderers,new rt.ExtHostNotebookRenderers(Ae,Dt)),Oi=Ae.set(w.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new _t.ExtHostNotebookDocumentSaveParticipant(Be,Dt,Ae.getProxy(w.MainContext.MainThreadBulkEdits))),xt=Ae.set(w.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(Ae,bt)),Kt=Ae.set(w.ExtHostContext.ExtHostTreeViews,new q.ExtHostTreeViews(Ae.getProxy(w.MainContext.MainThreadTreeViews),mt,Be)),Mi=Ae.set(w.ExtHostContext.ExtHostEditorInsets,new be.ExtHostEditorInsets(Ae.getProxy(w.MainContext.MainThreadEditorInsets),xt,gt.remote)),li=Ae.set(w.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Ae,Be,zt,bt)),ui=Ae.set(w.ExtHostContext.ExtHostLanguages,new C.ExtHostLanguages(Ae,At,mt.converter,Le)),dt=Ae.set(w.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(Ae,Le,At,mt,li,Be,je,Pt)),an=Ae.set(w.ExtHostContext.ExtHostFileSystem,new u.ExtHostFileSystem(Ae,dt)),jt=Ae.set(w.ExtHostContext.ExtHostFileSystemEventService,new p.ExtHostFileSystemEventService(Ae,Be,bt)),ri=Ae.set(w.ExtHostContext.ExtHostQuickOpen,(0,P.createExtHostQuickOpen)(Ae,ut,mt)),yi=Ae.set(w.ExtHostContext.ExtHostSCM,new M.ExtHostSCM(Ae,mt,At,Be)),Ni=Ae.set(w.ExtHostContext.ExtHostQuickDiff,new wt.ExtHostQuickDiff(Ae,Le)),xi=Ae.set(w.ExtHostContext.ExtHostShare,new Ht.ExtHostShare(Ae,Le)),Ui=Ae.set(w.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(Ae,mt,At)),Ci=Ae.set(w.ExtHostContext.ExtHostProgress,new r.ExtHostProgress(Ae.getProxy(w.MainContext.MainThreadProgress))),Wi=Ae.set(w.ExtHostContext.ExtHosLabelService,new Se.ExtHostLabelService(Ae)),Di=Ae.set(w.ExtHostContext.ExtHostTheming,new se.ExtHostTheming(Ae)),si=Ae.set(w.ExtHostContext.ExtHostAuthentication,new j.ExtHostAuthentication(Ae)),Bi=Ae.set(w.ExtHostContext.ExtHostTimeline,new Y.ExtHostTimeline(Ae,mt)),gi=Ae.set(w.ExtHostContext.ExtHostWebviews,new ne.ExtHostWebviews(Ae,gt.remote,ut,Be,je)),pi=Ae.set(w.ExtHostContext.ExtHostWebviewPanels,new ke.ExtHostWebviewPanels(Ae,gi,ut)),zi=Ae.set(w.ExtHostContext.ExtHostCustomEditors,new fe.ExtHostCustomEditors(Ae,At,ae,gi,pi)),$i=Ae.set(w.ExtHostContext.ExtHostWebviewViews,new _e.ExtHostWebviewViews(Ae,gi)),oi=Ae.set(w.ExtHostContext.ExtHostTesting,new He.ExtHostTesting(Ae,mt,bt)),Hi=Ae.set(w.ExtHostContext.ExtHostUriOpeners,new tt.ExtHostUriOpeners(Ae)),Vi=Ae.set(w.ExtHostContext.ExtHostProfileContentHandlers,new ft.ExtHostProfileContentHandlers(Ae));Ae.set(w.ExtHostContext.ExtHostInteractive,new Ee.ExtHostInteractive(Ae,Dt,bt,mt,Be));const ji=Ae.set(w.ExtHostContext.ExtHostInlineChat,new Ft.ExtHostInteractiveEditor(Ae,mt,At,Be)),ei=Ae.set(w.ExtHostContext.ExtHostChat,new Mt.ExtHostChat(Ae,Be)),qi=Ae.set(w.ExtHostContext.ExtHostSemanticSimilarity,new Bt.ExtHostSemanticSimilarity(Ae)),Gi=Ae.set(w.ExtHostContext.ExtHostIssueReporter,new Nt.ExtHostIssueReporter(Ae)),Ii=Ae.set(w.ExtHostContext.ExtHostStatusBar,new W.ExtHostStatusBar(Ae,mt.converter)),Ki=Object.values(w.ExtHostContext);Ae.assertRegistered(Ki);const cn=new Pe.ExtHostBulkEdits(Ae,bt),ln=new E.ExtHostClipboard(Ae),di=new S.ExtHostMessageService(Ae,Be),vi=new f.ExtHostDialogs(Ae);return I.ExtHostApiCommands.register(mt),function(We,Yt,ki){const pt=function(){let pe=!We.isUnderDevelopment;function ye(){pe||(Be.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function xe(ot){if(Array.isArray(ot))ot.forEach(xe);else if(typeof ot=="string")ye();else{const Ct=ot;typeof Ct.scheme>"u"&&ye(),typeof Ct.exclusive=="boolean"&&(0,Ne.checkProposedApiEnabled)(We,"documentFiltersExclusive")}return ot}}(),Xi={getSession(pe,ye,xe){return si.getSession(We,pe,ye,xe)},getSessions(pe,ye){return(0,Ne.checkProposedApiEnabled)(We,"authGetSessions"),si.getSessions(We,pe,ye)},async hasSession(pe,ye){return(0,Ne.checkProposedApiEnabled)(We,"authSession"),!!await si.getSession(We,pe,ye,{silent:!0})},get onDidChangeSessions(){return si.onDidChangeSessions},registerAuthenticationProvider(pe,ye,xe,ot){return si.registerAuthenticationProvider(pe,ye,xe,ot)}},Qi={registerCommand(pe,ye,xe){return mt.registerCommand(!0,pe,ye,xe,void 0,We)},registerTextEditorCommand(pe,ye,xe){return mt.registerCommand(!0,pe,(...ot)=>{const Ct=xt.getActiveTextEditor();if(!Ct){Be.warn("Cannot execute "+pe+" because there is no active text editor.");return}return Ct.edit(Lt=>{ye.apply(xe,[Ct,Lt,...ot])}).then(Lt=>{Lt||Be.warn("Edits from command "+pe+" were not applied.")},Lt=>{Be.warn("An error occurred while running command "+pe,Lt)})},void 0,void 0,We)},registerDiffInformationCommand:(pe,ye,xe)=>((0,Ne.checkProposedApiEnabled)(We,"diffCommand"),mt.registerCommand(!0,pe,async(...ot)=>{const Ct=bt.activeEditor(!0);if(!Ct){Be.warn("Cannot execute "+pe+" because there is no active text editor.");return}const Lt=await xt.getDiffInformation(Ct.id);ye.apply(xe,[Lt,...ot])},void 0,void 0,We)),executeCommand(pe,...ye){return mt.executeCommand(pe,...ye)},getCommands(pe=!1){return mt.getCommands(pe)}},Pi={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ne.checkProposedApiEnabled)(We,"envShellEvent"),St.onDidChangeShell},get isTelemetryEnabled(){return Pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Pt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.checkProposedApiEnabled)(We,"telemetry"),Pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.checkProposedApiEnabled)(We,"telemetry"),Pt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,st.isNewAppInstall)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(pe,ye){return st.ExtHostTelemetryLogger.validateSender(pe),Pt.instantiateLogger(We,pe,ye)},openExternal(pe,ye){return it.openUri(pe,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===gt.environment.appUriScheme)return Si.createAppUri(pe);try{return await it.asExternalUri(pe,{allowTunneling:!!gt.remote.authority})}catch(ye){if((0,Oe.matchesScheme)(pe,he.Schemas.http)||(0,Oe.matchesScheme)(pe,he.Schemas.https))return pe;throw ye}},get remoteName(){return(0,ge.getRemoteName)(gt.remote.authority)},get remoteAuthority(){return(0,Ne.checkProposedApiEnabled)(We,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return Be.getLevel()},get onDidChangeLogLevel(){return Be.onDidChangeLogLevel},registerIssueUriRequestHandler(pe){return(0,Ne.checkProposedApiEnabled)(We,"handleIssueUri"),Gi.registerIssueUriRequestHandler(We,pe)},get appQuality(){return(0,Ne.checkProposedApiEnabled)(We,"resolvers"),gt.quality},get appCommit(){return(0,Ne.checkProposedApiEnabled)(We,"resolvers"),gt.commit}};gt.environment.extensionTestsLocationURI||Object.freeze(Pi);const un={createTestController(pe,ye,xe){return oi.createTestController(We,pe,ye,xe)},createTestObserver(){return(0,Ne.checkProposedApiEnabled)(We,"testObserver"),oi.createTestObserver()},runTests(pe){return(0,Ne.checkProposedApiEnabled)(We,"testObserver"),oi.runTests(pe)},get onDidChangeTestResults(){return(0,Ne.checkProposedApiEnabled)(We,"testObserver"),oi.onResultsChanged},get testResults(){return(0,Ne.checkProposedApiEnabled)(We,"testObserver"),oi.results}},hi=gt.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Yi={getExtension(pe,ye){(0,Ne.isProposedApiEnabled)(We,"extensionsAny")||(ye=!1);const xe=Yt.mine.getExtensionDescription(pe);if(xe)return new t.Extension(It,We.identifier,xe,hi,!1);if(ye){const ot=Yt.all.getExtensionDescription(pe);if(ot)return new t.Extension(It,We.identifier,ot,hi,!0)}},get all(){const pe=[];for(const ye of Yt.mine.getAllExtensionDescriptions())pe.push(new t.Extension(It,We.identifier,ye,hi,!1));return pe},get allAcrossExtensionHosts(){(0,Ne.checkProposedApiEnabled)(We,"extensionsAny");const pe=new ce.ExtensionIdentifierSet(Yt.mine.getAllExtensionDescriptions().map(xe=>xe.identifier)),ye=[];for(const xe of Yt.all.getAllExtensionDescriptions()){const ot=!pe.has(xe.identifier);ye.push(new t.Extension(It,We.identifier,xe,hi,ot))}return ye},get onDidChange(){return(0,Ne.isProposedApiEnabled)(We,"extensionsAny")?d.Event.any(Yt.mine.onDidChange,Yt.all.onDidChange):Yt.mine.onDidChange}},Jt={createDiagnosticCollection(pe){return li.createDiagnosticCollection(We.identifier,pe)},get onDidChangeDiagnostics(){return li.onDidChangeDiagnostics},getDiagnostics:pe=>li.getDiagnostics(pe),getLanguages(){return ui.getLanguages()},setTextDocumentLanguage(pe,ye){return ui.changeLanguage(pe.uri,ye)},match(pe,ye){const xe=At.getDocumentData(ye.uri)?.notebook;return(0,A.score)(x.LanguageSelector.from(pe),ye.uri,ye.languageId,!0,xe?.uri,xe?.notebookType)},registerCodeActionsProvider(pe,ye,xe){return dt.registerCodeActionProvider(We,pt(pe),ye,xe)},registerDocumentPasteEditProvider(pe,ye,xe){return(0,Ne.checkProposedApiEnabled)(We,"documentPaste"),dt.registerDocumentPasteEditProvider(We,pt(pe),ye,xe)},registerCodeLensProvider(pe,ye){return dt.registerCodeLensProvider(We,pt(pe),ye)},registerDefinitionProvider(pe,ye){return dt.registerDefinitionProvider(We,pt(pe),ye)},registerDeclarationProvider(pe,ye){return dt.registerDeclarationProvider(We,pt(pe),ye)},registerImplementationProvider(pe,ye){return dt.registerImplementationProvider(We,pt(pe),ye)},registerTypeDefinitionProvider(pe,ye){return dt.registerTypeDefinitionProvider(We,pt(pe),ye)},registerHoverProvider(pe,ye){return dt.registerHoverProvider(We,pt(pe),ye,We.identifier)},registerEvaluatableExpressionProvider(pe,ye){return dt.registerEvaluatableExpressionProvider(We,pt(pe),ye,We.identifier)},registerInlineValuesProvider(pe,ye){return dt.registerInlineValuesProvider(We,pt(pe),ye,We.identifier)},registerDocumentHighlightProvider(pe,ye){return dt.registerDocumentHighlightProvider(We,pt(pe),ye)},registerLinkedEditingRangeProvider(pe,ye){return dt.registerLinkedEditingRangeProvider(We,pt(pe),ye)},registerReferenceProvider(pe,ye){return dt.registerReferenceProvider(We,pt(pe),ye)},registerRenameProvider(pe,ye){return dt.registerRenameProvider(We,pt(pe),ye)},registerDocumentSymbolProvider(pe,ye,xe){return dt.registerDocumentSymbolProvider(We,pt(pe),ye,xe)},registerWorkspaceSymbolProvider(pe){return dt.registerWorkspaceSymbolProvider(We,pe)},registerDocumentFormattingEditProvider(pe,ye){return dt.registerDocumentFormattingEditProvider(We,pt(pe),ye)},registerDocumentRangeFormattingEditProvider(pe,ye){return dt.registerDocumentRangeFormattingEditProvider(We,pt(pe),ye)},registerOnTypeFormattingEditProvider(pe,ye,xe,...ot){return dt.registerOnTypeFormattingEditProvider(We,pt(pe),ye,[xe].concat(ot))},registerDocumentSemanticTokensProvider(pe,ye,xe){return dt.registerDocumentSemanticTokensProvider(We,pt(pe),ye,xe)},registerDocumentRangeSemanticTokensProvider(pe,ye,xe){return dt.registerDocumentRangeSemanticTokensProvider(We,pt(pe),ye,xe)},registerSignatureHelpProvider(pe,ye,xe,...ot){return typeof xe=="object"?dt.registerSignatureHelpProvider(We,pt(pe),ye,xe):dt.registerSignatureHelpProvider(We,pt(pe),ye,typeof xe>"u"?[]:[xe,...ot])},registerCompletionItemProvider(pe,ye,...xe){return dt.registerCompletionItemProvider(We,pt(pe),ye,xe)},registerInlineCompletionItemProvider(pe,ye){return ye.handleDidShowCompletionItem&&(0,Ne.checkProposedApiEnabled)(We,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,Ne.checkProposedApiEnabled)(We,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(We,pt(pe),ye)},registerDocumentLinkProvider(pe,ye){return dt.registerDocumentLinkProvider(We,pt(pe),ye)},registerColorProvider(pe,ye){return dt.registerColorProvider(We,pt(pe),ye)},registerFoldingRangeProvider(pe,ye){return dt.registerFoldingRangeProvider(We,pt(pe),ye)},registerSelectionRangeProvider(pe,ye){return dt.registerSelectionRangeProvider(We,pe,ye)},registerCallHierarchyProvider(pe,ye){return dt.registerCallHierarchyProvider(We,pe,ye)},registerTypeHierarchyProvider(pe,ye){return dt.registerTypeHierarchyProvider(We,pe,ye)},setLanguageConfiguration:(pe,ye)=>dt.setLanguageConfiguration(We,pe,ye),getTokenInformationAtPosition(pe,ye){return(0,Ne.checkProposedApiEnabled)(We,"tokenInformation"),ui.tokenAtPosition(pe,ye)},registerInlayHintsProvider(pe,ye){return dt.registerInlayHintsProvider(We,pe,ye)},createLanguageStatusItem(pe,ye){return ui.createLanguageStatusItem(We,pe,ye)},registerDocumentDropEditProvider(pe,ye,xe){return dt.registerDocumentOnDropEditProvider(We,pe,ye,(0,Ne.isProposedApiEnabled)(We,"dropMetadata")?xe:void 0)}},bi={get activeTextEditor(){return xt.getActiveTextEditor()},get visibleTextEditors(){return xt.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(pe,ye,xe){const ot=await(R.URI.isUri(pe)?Promise.resolve(Ji.openTextDocument(pe)):Promise.resolve(pe));return xt.showTextDocument(ot,ye,xe)},createTextEditorDecorationType(pe){return xt.createTextEditorDecorationType(We,pe)},onDidChangeActiveTextEditor(pe,ye,xe){return xt.onDidChangeActiveTextEditor(pe,ye,xe)},onDidChangeVisibleTextEditors(pe,ye,xe){return xt.onDidChangeVisibleTextEditors(pe,ye,xe)},onDidChangeTextEditorSelection(pe,ye,xe){return xt.onDidChangeTextEditorSelection(pe,ye,xe)},onDidChangeTextEditorOptions(pe,ye,xe){return xt.onDidChangeTextEditorOptions(pe,ye,xe)},onDidChangeTextEditorVisibleRanges(pe,ye,xe){return xt.onDidChangeTextEditorVisibleRanges(pe,ye,xe)},onDidChangeTextEditorViewColumn(pe,ye,xe){return xt.onDidChangeTextEditorViewColumn(pe,ye,xe)},onDidCloseTerminal(pe,ye,xe){return St.onDidCloseTerminal(pe,ye,xe)},onDidOpenTerminal(pe,ye,xe){return St.onDidOpenTerminal(pe,ye,xe)},onDidChangeActiveTerminal(pe,ye,xe){return St.onDidChangeActiveTerminal(pe,ye,xe)},onDidChangeTerminalDimensions(pe,ye,xe){return(0,Ne.checkProposedApiEnabled)(We,"terminalDimensions"),St.onDidChangeTerminalDimensions(pe,ye,xe)},onDidChangeTerminalState(pe,ye,xe){return St.onDidChangeTerminalState(pe,ye,xe)},onDidWriteTerminalData(pe,ye,xe){return(0,Ne.checkProposedApiEnabled)(We,"terminalDataWriteEvent"),St.onDidWriteTerminalData(pe,ye,xe)},get state(){return it.getState(We)},onDidChangeWindowState(pe,ye,xe){return it.onDidChangeWindowState(pe,ye,xe)},showInformationMessage(pe,...ye){return di.showMessage(We,L.default.Info,pe,ye[0],ye.slice(1))},showWarningMessage(pe,...ye){return di.showMessage(We,L.default.Warning,pe,ye[0],ye.slice(1))},showErrorMessage(pe,...ye){return di.showMessage(We,L.default.Error,pe,ye[0],ye.slice(1))},showQuickPick(pe,ye,xe){return ri.showQuickPick(We,pe,ye,xe)},showWorkspaceFolderPick(pe){return ri.showWorkspaceFolderPick(pe)},showInputBox(pe,ye){return ri.showInput(pe,ye)},showOpenDialog(pe){return vi.showOpenDialog(We,pe)},showSaveDialog(pe){return vi.showSaveDialog(pe)},createStatusBarItem(pe,ye,xe){let ot,Ct,Lt;return typeof pe=="string"?(ot=pe,Ct=ye,Lt=xe):(Ct=pe,Lt=ye),Ii.createStatusBarEntry(We,ot,Ct,Lt)},setStatusBarMessage(pe,ye){return Ii.setStatusBarMessage(pe,ye)},withScmProgress(pe){return je.report("window.withScmProgress",We,"Use 'withProgress' instead."),Ci.withProgress(We,{location:U.ProgressLocation.SourceControl},(ye,xe)=>pe({report(ot){}}))},withProgress(pe,ye){return Ci.withProgress(We,pe,ye)},createOutputChannel(pe,ye){return ni.createOutputChannel(pe,ye,We)},createWebviewPanel(pe,ye,xe,ot){return pi.createWebviewPanel(We,pe,ye,xe,ot)},createWebviewTextEditorInset(pe,ye,xe,ot){return(0,Ne.checkProposedApiEnabled)(We,"editorInsets"),Mi.createWebviewEditorInset(pe,ye,xe,ot,We)},createTerminal(pe,ye,xe){return typeof pe=="object"?"pty"in pe?St.createExtensionTerminal(pe):St.createTerminalFromOptions(pe):St.createTerminal(pe,ye,xe)},registerTerminalLinkProvider(pe){return St.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,ye){return St.registerProfileProvider(We,pe,ye)},registerTerminalQuickFixProvider(pe,ye){return(0,Ne.checkProposedApiEnabled)(We,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(pe,We.identifier.value,ye)},registerTreeDataProvider(pe,ye){return Kt.registerTreeDataProvider(pe,ye,We)},createTreeView(pe,ye){return Kt.createTreeView(pe,ye,We)},registerWebviewPanelSerializer:(pe,ye)=>pi.registerWebviewPanelSerializer(We,pe,ye),registerCustomEditorProvider:(pe,ye,xe={})=>zi.registerCustomEditorProvider(We,pe,ye,xe),registerFileDecorationProvider(pe){return vt.registerFileDecorationProvider(pe,We)},registerUriHandler(pe){return Si.registerUriHandler(We,pe)},createQuickPick(){return ri.createQuickPick(We)},createInputBox(){return ri.createInputBox(We)},get activeColorTheme(){return Di.activeColorTheme},onDidChangeActiveColorTheme(pe,ye,xe){return Di.onDidChangeActiveColorTheme(pe,ye,xe)},registerWebviewViewProvider(pe,ye,xe){return $i.registerWebviewViewProvider(We,pe,ye,xe?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,ye,xe){return Dt.onDidChangeActiveNotebookEditor(pe,ye,xe)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(pe,ye,xe){return Li.onDidChangeNotebookEditorSelection(pe,ye,xe)},onDidChangeNotebookEditorVisibleRanges(pe,ye,xe){return Li.onDidChangeNotebookEditorVisibleRanges(pe,ye,xe)},showNotebookDocument(pe,ye){return Dt.showNotebookDocument(pe,ye)},registerExternalUriOpener(pe,ye,xe){return(0,Ne.checkProposedApiEnabled)(We,"externalUriOpener"),Hi.registerExternalUriOpener(We.identifier,pe,ye,xe)},registerProfileContentHandler(pe,ye){return(0,Ne.checkProposedApiEnabled)(We,"profileContentHandlers"),Vi.registrProfileContentHandler(We,pe,ye)},registerQuickDiffProvider(pe,ye,xe,ot){return(0,Ne.checkProposedApiEnabled)(We,"quickDiffProvider"),Ni.registerQuickDiffProvider(pt(pe),ye,xe,ot)},get tabGroups(){return kt.tabGroups},registerShareProvider(pe,ye){return(0,Ne.checkProposedApiEnabled)(We,"shareProvider"),xi.registerShareProvider(pt(pe),ye)}},Ji={get rootPath(){return je.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ut.getPath()},set rootPath(pe){throw T.readonly()},getWorkspaceFolder(pe){return ut.getWorkspaceFolder(pe)},get workspaceFolders(){return ut.getWorkspaceFolders()},get name(){return ut.name},set name(pe){throw T.readonly()},get workspaceFile(){return ut.workspaceFile},set workspaceFile(pe){throw T.readonly()},updateWorkspaceFolders:(pe,ye,...xe)=>ut.updateWorkspaceFolders(We,pe,ye||0,...xe),onDidChangeWorkspaceFolders:function(pe,ye,xe){return ut.onDidChangeWorkspace(pe,ye,xe)},asRelativePath:(pe,ye)=>ut.getRelativePath(pe,ye),findFiles:(pe,ye,xe,ot)=>ut.findFiles(pe,ye,xe,We.identifier,ot),findTextInFiles:(pe,ye,xe,ot)=>{(0,Ne.checkProposedApiEnabled)(We,"findTextInFiles");let Ct,Lt;return typeof ye=="object"?(Ct=ye,Lt=xe):(Ct={},Lt=ye,ot=xe),ut.findTextInFiles(pe,Ct||{},Lt,We.identifier,ot)},save:pe=>((0,Ne.checkProposedApiEnabled)(We,"saveEditor"),ut.save(pe)),saveAs:pe=>((0,Ne.checkProposedApiEnabled)(We,"saveEditor"),ut.saveAs(pe)),saveAll:pe=>ut.saveAll(pe),applyEdit(pe,ye){return cn.applyWorkspaceEdit(pe,We,ye)},createFileSystemWatcher:(pe,ye,xe,ot)=>jt.createFileSystemWatcher(ut,We,pe,ye,xe,ot),get textDocuments(){return At.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw T.readonly()},openTextDocument(pe){let ye;const xe=pe;if(typeof pe=="string")ye=Promise.resolve(R.URI.file(pe));else if(R.URI.isUri(pe))ye=Promise.resolve(pe);else if(!xe||typeof xe=="object")ye=At.createDocumentData(xe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(ot=>At.ensureDocumentData(ot).then(Ct=>Ct.document))},onDidOpenTextDocument:(pe,ye,xe)=>At.onDidAddDocument(pe,ye,xe),onDidCloseTextDocument:(pe,ye,xe)=>At.onDidRemoveDocument(pe,ye,xe),onDidChangeTextDocument:(pe,ye,xe)=>At.onDidChangeDocument(pe,ye,xe),onDidSaveTextDocument:(pe,ye,xe)=>At.onDidSaveDocument(pe,ye,xe),onWillSaveTextDocument:(pe,ye,xe)=>fi.getOnWillSaveTextDocumentEvent(We)(pe,ye,xe),get notebookDocuments(){return Dt.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,ye){let xe;if(R.URI.isUri(pe))xe=pe,await Dt.openNotebookDocument(pe);else if(typeof pe=="string")xe=R.URI.revive(await Dt.createNotebookDocument({viewType:pe,content:ye}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(xe).apiNotebook},onDidSaveNotebookDocument(pe,ye,xe){return _i.onDidSaveNotebookDocument(pe,ye,xe)},onDidChangeNotebookDocument(pe,ye,xe){return _i.onDidChangeNotebookDocument(pe,ye,xe)},onWillSaveNotebookDocument(pe,ye,xe){return Oi.getOnWillSaveNotebookDocumentEvent(We)(pe,ye,xe)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer(pe,ye,xe,ot){return Dt.registerNotebookSerializer(We,pe,ye,xe,(0,Ne.isProposedApiEnabled)(We,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(pe,ye,xe)=>ki.onDidChangeConfiguration(pe,ye,xe),getConfiguration(pe,ye){return ye=arguments.length===1?void 0:ye,ki.getConfiguration(pe,ye,We)},registerTextDocumentContentProvider(pe,ye){return ci.registerTextDocumentContentProvider(pe,ye)},registerTaskProvider:(pe,ye)=>(je.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),$t.registerTaskProvider(We,pe,ye)),registerFileSystemProvider(pe,ye,xe){return(0,Ue.combinedDisposable)(an.registerFileSystemProvider(We,pe,ye,xe),Rt.addFileSystemProvider(pe,ye,xe))},get fs(){return Rt.value},registerFileSearchProvider:(pe,ye)=>((0,Ne.checkProposedApiEnabled)(We,"fileSearchProvider"),Qt.registerFileSearchProvider(pe,ye)),registerTextSearchProvider:(pe,ye)=>((0,Ne.checkProposedApiEnabled)(We,"textSearchProvider"),Qt.registerTextSearchProvider(pe,ye)),registerRemoteAuthorityResolver:(pe,ye)=>((0,Ne.checkProposedApiEnabled)(We,"resolvers"),It.registerRemoteAuthorityResolver(pe,ye)),registerResourceLabelFormatter:pe=>((0,Ne.checkProposedApiEnabled)(We,"resolvers"),Wi.$registerResourceLabelFormatter(pe)),getRemoteExecServer:pe=>((0,Ne.checkProposedApiEnabled)(We,"resolvers"),It.getRemoteExecServer(pe)),onDidCreateFiles:(pe,ye,xe)=>jt.onDidCreateFile(pe,ye,xe),onDidDeleteFiles:(pe,ye,xe)=>jt.onDidDeleteFile(pe,ye,xe),onDidRenameFiles:(pe,ye,xe)=>jt.onDidRenameFile(pe,ye,xe),onWillCreateFiles:(pe,ye,xe)=>jt.getOnWillCreateFileEvent(We)(pe,ye,xe),onWillDeleteFiles:(pe,ye,xe)=>jt.getOnWillDeleteFileEvent(We)(pe,ye,xe),onWillRenameFiles:(pe,ye,xe)=>jt.getOnWillRenameFileEvent(We)(pe,ye,xe),openTunnel:pe=>((0,Ne.checkProposedApiEnabled)(We,"tunnels"),Xe.openTunnel(We,pe).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,Ne.checkProposedApiEnabled)(We,"tunnels"),Xe.getTunnels()},onDidChangeTunnels:(pe,ye,xe)=>((0,Ne.checkProposedApiEnabled)(We,"tunnels"),Xe.onDidChangeTunnels(pe,ye,xe)),registerPortAttributesProvider:(pe,ye)=>((0,Ne.checkProposedApiEnabled)(We,"portsAttributes"),Xe.registerPortsAttributesProvider(pe,ye)),registerTimelineProvider:(pe,ye)=>((0,Ne.checkProposedApiEnabled)(We,"timeline"),Bi.registerTimelineProvider(pe,ye,We.identifier,mt.converter)),get isTrusted(){return ut.trusted},requestWorkspaceTrust:pe=>((0,Ne.checkProposedApiEnabled)(We,"workspaceTrust"),ut.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,ye,xe)=>ut.onDidGrantWorkspaceTrust(pe,ye,xe),registerEditSessionIdentityProvider:(pe,ye)=>((0,Ne.checkProposedApiEnabled)(We,"editSessionIdentityProvider"),ut.registerEditSessionIdentityProvider(pe,ye)),onWillCreateEditSessionIdentity:(pe,ye,xe)=>((0,Ne.checkProposedApiEnabled)(We,"editSessionIdentityProvider"),ut.getOnWillCreateEditSessionIdentityEvent(We)(pe,ye,xe)),registerCanonicalUriProvider:(pe,ye)=>((0,Ne.checkProposedApiEnabled)(We,"canonicalUriProvider"),ut.registerCanonicalUriProvider(pe,ye)),getCanonicalUri:(pe,ye,xe)=>((0,Ne.checkProposedApiEnabled)(We,"canonicalUriProvider"),ut.provideCanonicalUri(pe,ye,xe))},qt={get inputBox(){return je.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),yi.getLastInputBox(We)},createSourceControl(pe,ye,xe){return yi.createSourceControl(We,pe,ye,xe)}},Ei={createCommentController(pe,ye){return Ui.createCommentController(We,pe,ye)}},Zi={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get stackFrameFocus(){return Et.stackFrameFocus},onDidStartDebugSession(pe,ye,xe){return Et.onDidStartDebugSession(pe,ye,xe)},onDidTerminateDebugSession(pe,ye,xe){return Et.onDidTerminateDebugSession(pe,ye,xe)},onDidChangeActiveDebugSession(pe,ye,xe){return Et.onDidChangeActiveDebugSession(pe,ye,xe)},onDidReceiveDebugSessionCustomEvent(pe,ye,xe){return Et.onDidReceiveDebugSessionCustomEvent(pe,ye,xe)},onDidChangeBreakpoints(pe,ye,xe){return Et.onDidChangeBreakpoints(pe,ye,xe)},onDidChangeStackFrameFocus(pe,ye,xe){return(0,Ne.checkProposedApiEnabled)(We,"debugFocus"),Et.onDidChangeStackFrameFocus(pe,ye,xe)},registerDebugConfigurationProvider(pe,ye,xe){return Et.registerDebugConfigurationProvider(pe,ye,xe||Qe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,ye){return Et.registerDebugAdapterDescriptorFactory(We,pe,ye)},registerDebugAdapterTrackerFactory(pe,ye){return Et.registerDebugAdapterTrackerFactory(pe,ye)},startDebugging(pe,ye,xe){return!xe||typeof xe=="object"&&"configuration"in xe?Et.startDebugging(pe,ye,{parentSession:xe}):Et.startDebugging(pe,ye,xe||{})},stopDebugging(pe){return Et.stopDebugging(pe)},addBreakpoints(pe){return Et.addBreakpoints(pe)},removeBreakpoints(pe){return Et.removeBreakpoints(pe)},asDebugSourceUri(pe,ye){return Et.asDebugSourceUri(pe,ye)}},en={registerTaskProvider:(pe,ye)=>$t.registerTaskProvider(We,pe,ye),fetchTasks:pe=>$t.fetchTasks(pe),executeTask:pe=>$t.executeTask(We,pe),get taskExecutions(){return $t.taskExecutions},onDidStartTask:(pe,ye,xe)=>$t.onDidStartTask(pe,ye,xe),onDidEndTask:(pe,ye,xe)=>$t.onDidEndTask(pe,ye,xe),onDidStartTaskProcess:(pe,ye,xe)=>$t.onDidStartTaskProcess(pe,ye,xe),onDidEndTaskProcess:(pe,ye,xe)=>$t.onDidEndTaskProcess(pe,ye,xe)},tn={createNotebookController(pe,ye,xe,ot,Ct){return mi.createNotebookController(We,pe,ye,xe,ot,(0,Ne.isProposedApiEnabled)(We,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(pe,ye)=>Dt.registerNotebookCellStatusBarItemProvider(We,pe,ye),createRendererMessaging(pe){return Fi.createRendererMessaging(We,pe)},createNotebookControllerDetectionTask(pe){return(0,Ne.checkProposedApiEnabled)(We,"notebookKernelSource"),mi.createNotebookControllerDetectionTask(We,pe)},registerKernelSourceActionProvider(pe,ye){return(0,Ne.checkProposedApiEnabled)(We,"notebookKernelSource"),mi.registerKernelSourceActionProvider(We,pe,ye)},onDidChangeNotebookCellExecutionState(pe,ye,xe){return(0,Ne.checkProposedApiEnabled)(We,"notebookCellExecutionState"),mi.onDidChangeNotebookCellExecutionState(pe,ye,xe)}},nn={t(...pe){if(typeof pe[0]=="string"){const ye=pe.shift(),xe=!pe||typeof pe[0]!="object"?pe:pe[0];return ai.getMessage(We.identifier.value,{message:ye,args:xe})}return ai.getMessage(We.identifier.value,pe[0])},get bundle(){return ai.getBundle(We.identifier.value)},get uri(){return ai.getBundleUri(We.identifier.value)}},dn={_version:1,registerInteractiveEditorSessionProvider(pe){return(0,Ne.checkProposedApiEnabled)(We,"interactive"),ji.registerProvider(We,pe)},registerInteractiveSessionProvider(pe,ye){return(0,Ne.checkProposedApiEnabled)(We,"interactive"),ei.registerChatProvider(We,pe,ye)},addInteractiveRequest(pe){return(0,Ne.checkProposedApiEnabled)(We,"interactive"),ei.addChatRequest(pe)},sendInteractiveRequestToProvider(pe,ye){return(0,Ne.checkProposedApiEnabled)(We,"interactive"),ei.sendInteractiveRequestToProvider(pe,ye)},get onDidPerformUserAction(){return(0,Ne.checkProposedApiEnabled)(We,"interactiveUserActions"),ei.onDidPerformUserAction},transferChatSession(pe,ye){return(0,Ne.checkProposedApiEnabled)(We,"interactive"),ei.transferChatSession(pe,ye)}},rn={registerSlashCommandProvider(pe,ye){return(0,Ne.checkProposedApiEnabled)(We,"interactiveSlashCommands"),ei.registerSlashCommandProvider(We,pe,ye)}},sn={registerSemanticSimilarityProvider(pe){return(0,Ne.checkProposedApiEnabled)(We,"semanticSimilarity"),qi.registerSemanticSimilarityProvider(We,pe)}};return{version:gt.version,ai:sn,authentication:Xi,commands:Qi,comments:Ei,debug:Zi,env:Pi,extensions:Yi,interactive:dn,interactiveSlashCommands:rn,l10n:nn,languages:Jt,notebooks:tn,scm:qt,tasks:en,tests:un,window:bi,workspace:Ji,Breakpoint:U.Breakpoint,TerminalOutputAnchor:U.TerminalOutputAnchor,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:v.CancellationTokenSource,CandidatePortSource:w.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentState:U.CommentState,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CommentThreadState:U.CommentThreadState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Qe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,EventEmitter:d.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileDecoration2:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionList:U.InlineSuggestionList,Hover:U.Hover,IndentAction:m.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalQuickFixCommand:U.TerminalQuickFixCommand,TerminalQuickFixOpener:U.TerminalQuickFixOpener,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TerminalExitReason:U.TerminalExitReason,TerminalQuickFixType:U.TerminalQuickFixType,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,SnippetTextEdit:U.SnippetTextEdit,TextEditorCursorStyle:g.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCheckboxState:U.TreeItemCheckboxState,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:D.UIKind,Uri:R.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,DocumentDropEdit:U.DocumentDropEdit,DocumentPasteEdit:U.DocumentPasteEdit,InlayHint:U.InlayHint,InlayHintLabelPart:U.InlayHintLabelPart,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,ManagedResolvedAuthority:U.ManagedResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,NotebookControllerAffinity2:U.NotebookControllerAffinity2,NotebookEdit:U.NotebookEdit,NotebookKernelSourceAction:U.NotebookKernelSourceAction,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestRunRequest2:U.TestRunRequest2,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:Ze.TextSearchCompleteMessageType,DataTransfer:U.DataTransfer,DataTransferItem:U.DataTransferItem,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity,QuickPickItemKind:U.QuickPickItemKind,InputBoxValidationSeverity:U.InputBoxValidationSeverity,TabInputText:U.TextTabInput,TabInputTextDiff:U.TextDiffTabInput,TabInputTextMerge:U.TextMergeTabInput,TabInputCustom:U.CustomEditorTabInput,TabInputNotebook:U.NotebookEditorTabInput,TabInputNotebookDiff:U.NotebookDiffEditorTabInput,TabInputWebview:U.WebviewEditorTabInput,TabInputTerminal:U.TerminalEditorTabInput,TabInputInteractiveWindow:U.InteractiveWindowInput,TelemetryTrustedValue:de.TelemetryTrustedValue,LogLevel:ee.LogLevel,EditSessionIdentityMatch:nt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:U.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:U.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:U.InteractiveEditorResponseFeedbackKind,StackFrameFocus:U.StackFrameFocus,ThreadFocus:U.ThreadFocus,NotebookCodeActionKind:U.NotebookCodeActionKind}}}e.createApiFactoryAndRegisterActors=Vt}),define(De[332],Ie([1,0,98,145,37,142,38,36,62,43,87,89,90,109,58,83,144,64,51,108,82,63,143,18,52,106,107]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l,a,b,f,_,n,o,s,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.registerSingleton)(t.IExtHostLocalizationService,t.ExtHostLocalizationService,1),(0,v.registerSingleton)(o.ILoggerService,n.ExtHostLoggerService,1),(0,v.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService,1),(0,v.registerSingleton)(g.IExtHostCommands,g.ExtHostCommands,0),(0,v.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration,0),(0,v.registerSingleton)(l.IExtHostConsumerFileSystem,l.ExtHostConsumerFileSystem,0),(0,v.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,0),(0,v.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations,0),(0,v.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,v.registerSingleton)(u.IExtHostManagedSockets,u.ExtHostManagedSockets,0),(0,v.registerSingleton)(a.IExtHostFileSystemInfo,a.ExtHostFileSystemInfo,0),(0,v.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService,1),(0,v.registerSingleton)(w.IExtHostSearch,w.ExtHostSearch,0),(0,v.registerSingleton)(D.IExtHostStorage,D.ExtHostStorage,0),(0,v.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask,0),(0,v.registerSingleton)(m.IExtHostTerminalService,m.WorkerExtHostTerminalService,0),(0,v.registerSingleton)(I.IExtHostTunnelService,I.ExtHostTunnelService,0),(0,v.registerSingleton)(i.IExtHostWindow,i.ExtHostWindow,0),(0,v.registerSingleton)(d.IExtHostWorkspace,d.ExtHostWorkspace,0),(0,v.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,v.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry,0),(0,v.registerSingleton)(_.IExtHostEditorTabs,_.ExtHostEditorTabs,0),(0,v.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService,0)}),define(De[110],Ie([1,0,19,18,34,86]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function R(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=R;function g(k,w,D,I){const E=(0,v.mapArrayOrNot)(D,y),i=new d.TextSearchMatch(w,E,I),l=i.preview.matches;return{ranges:(0,v.mapArrayOrNot)(E,m),uri:k,preview:{text:i.preview.text,matches:(0,v.mapArrayOrNot)(l,m)}}}e.createTextSearchResult=g;function y(k){return new d.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function m(k){return new L.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let A=e.OutputChannel=class{constructor(w,D){this.prefix=w,this.logService=D}appendLine(w){this.logService.debug(`${this.prefix}#search`,w)}};e.OutputChannel=A=Ve([ze(1,T.ILogService)],A)}),define(De[333],Ie([1,0,46,11,69,31,10,9,110,334]),function(re,e,v,T,d,L,R,g,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const A=m.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(b,f,_,n){const o=w(b,f,_,n),s=f.folder.fsPath;return{cmd:v.spawn(A,o.args,{cwd:s}),rgDiskPath:A,siblingClauses:o.siblingClauses,rgArgs:o,cwd:s}}e.spawnRipgrepCmd=k;function w(b,f,_,n){const o=["--files","--hidden","--case-sensitive","--no-require-git"];I([f],_,!1).forEach(t=>{const u=(0,y.anchorGlob)(t);if(o.push("-g",u),R.isMacintosh){const p=(0,d.normalizeNFD)(u);p!==u&&o.push("-g",p)}});const s=D([f],n,void 0,!1);return s.globArgs.forEach(t=>{const u=`!${(0,y.anchorGlob)(t)}`;if(o.push("-g",u),R.isMacintosh){const p=(0,d.normalizeNFD)(u);p!==u&&o.push("-g",p)}}),f.disregardIgnoreFiles!==!1?o.push("--no-ignore"):f.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),f.ignoreSymlinks||o.push("--follow"),b.exists&&o.push("--quiet"),o.push("--no-config"),f.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:s.siblingClauses}}function D(b,f,_,n=!0){const o=[];let s={};return b.forEach(t=>{const u=Object.assign({},t.excludePattern||{},f||{}),p=E(u,n?t.folder.fsPath:void 0,_);o.push(...p.globArgs),p.siblingClauses&&(s=Object.assign(s,p.siblingClauses))}),{globArgs:o,siblingClauses:s}}function I(b,f,_=!0){const n=[];return b.forEach(o=>{const s=Object.assign({},f||{},o.includePattern||{}),t=E(s,_?o.folder.fsPath:void 0);n.push(...t.globArgs)}),n}function E(b,f,_){const n=[],o={};return Object.keys(b).forEach(s=>{if(_&&_.has(s)||!s)return;const t=b[s];s=l(f?i(f,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof t=="boolean"&&t?(s.startsWith("\\\\")&&(s+="**"),n.push(a(s))):t&&t.when&&(o[s]=t)}),{globArgs:n,siblingClauses:o}}function i(b,f){return T.isAbsolute(f)?f:T.join(b,f)}e.getAbsoluteGlob=i;function l(b){return b=g.rtrim(b,"\\"),g.rtrim(b,"/")}function a(b){return L.getRoot(b).toLowerCase()==="c:/"?b.replace(/^c:[/\\]/i,"/"):b}e.fixDriveC=a}),define(De[335],Ie([1,0,46,49,11,336,19,45,33,69,31,10,39,9,12,29,34,333,119]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const b=new Set;process.on("exit",()=>{b.forEach(s=>s())});class f{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&y.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,a.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&y.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(u=>{const p=Object.assign({},u.excludePattern||{},this.config.excludePattern||{}),h=u.folder.fsPath;t.folderQueries.map(C=>C.folder.fsPath).filter(C=>C!==h).forEach(C=>{(0,A.isEqualOrParent)(C,h)&&(p[d.relative(h,C)]=!0)}),this.folderExcludePatterns.set(h,new n(p,h))})}cancel(){this.isCanceled=!0,b.forEach(t=>t())}walk(t,u,p,h,C){if(this.fileWalkSW=w.StopWatch.create(!1),this.isCanceled)return C(null,this.isLimitHit);u.forEach(S=>{const c=d.basename(S.fsPath);this.globalExcludePattern&&this.globalExcludePattern(S.fsPath,c)||this.matchFile(p,{relativePath:S.fsPath,searchPath:void 0})}),this.cmdSW=w.StopWatch.create(!1),this.parallel(t,(S,c)=>{this.call(this.cmdTraversal,this,S,p,h,r=>{if(r){const P=(0,g.toErrorMessage)(r);console.error(P),this.errors.push(P),c(r,void 0)}else c(null,void 0)})},(S,c)=>{this.fileWalkSW.stop();const r=S?R.coalesce(S)[0]:null;C(r,this.isLimitHit)})}parallel(t,u,p){const h=new Array(t.length),C=new Array(t.length);let S=!1,c=0;if(t.length===0)return p(null,[]);t.forEach((r,P)=>{u(r,(M,W)=>{if(M?(S=!0,h[P]=null,C[P]=M):(h[P]=W,C[P]=null),++c===t.length)return p(S?C:null,h)})})}call(t,u,...p){try{t.apply(u,p)}catch(h){p[p.length-1](h)}}cmdTraversal(t,u,p,h){const C=t.folder.fsPath,S=k.isMacintosh,c=()=>$&&$.kill();b.add(c);let r=x=>{b.delete(c),r=()=>{},h(x)},P="";const M=this.initDirectoryTree(),W=(0,l.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression),$=W.cmd,z=!Object.keys(W.siblingClauses).length,N=W.rgArgs.args.map(x=>x.match(/^-/)?x:`'${x}'`).join(" ");let q=`${W.rgDiskPath} ${N}
 - cwd: ${W.cwd}`;W.rgArgs.siblingClauses&&(q+=`
 - Sibling clauses: ${JSON.stringify(W.rgArgs.siblingClauses)}`),p({message:q}),this.cmdResultCount=0,this.collectStdout($,"utf8",p,(x,U,de)=>{if(x){r(x);return}if(this.isLimitHit){r();return}const ne=(P+(S?m.normalizeNFC(U||""):U)).split(`
`);if(de){const H=ne.length;ne[H-1]=ne[H-1].trim(),ne[H-1]||ne.pop()}else P=ne.pop()||"";if(ne.length&&ne[0].indexOf(`
`)!==-1){r(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=ne.length,z){for(const H of ne)if(this.matchFile(u,{base:C,relativePath:H,searchPath:this.getSearchPath(t,H)}),this.isLimitHit){c();break}(de||this.isLimitHit)&&r();return}this.addDirectoryEntries(t,M,C,ne,u),de&&(this.matchDirectoryTree(M,C,u),r())})}spawnFindCmd(t){const u=this.folderExcludePatterns.get(t.folder.fsPath),p=u.getBasenameTerms(),h=u.getPathTerms(),C=["-L","."];if(p.length||h.length){C.push("-not","(","(");for(const S of p)C.push("-name",S),C.push("-o");for(const S of h)C.push("-path",S),C.push("-o");C.pop(),C.push(")","-prune",")")}return C.push("-type","f"),v.spawn("find",C,{cwd:t.folder.fsPath})}readStdout(t,u,p){let h="";this.collectStdout(t,u,()=>{},(C,S,c)=>{if(C){p(C);return}h+=S,c&&p(null,h)})}collectStdout(t,u,p,h){let C=(r,P,M)=>{(r||M)&&(C=()=>{},this.cmdSW?.stop()),h(r,P,M)},S=!1;t.stdout?(this.forwardData(t.stdout,u,C),t.stdout.once("data",()=>S=!0)):p({message:"stdout is null"});let c;t.stderr?c=this.collectData(t.stderr):p({message:"stderr is null"}),t.on("error",r=>{C(r)}),t.on("close",r=>{let P;!S&&(P=this.decodeData(c,u))&&o(P)?C(new Error(`command failed with error code ${r}: ${this.decodeData(c,u)}`)):(this.exists&&r===0&&(this.isLimitHit=!0),C(null,"",!0))})}forwardData(t,u,p){const h=new L.StringDecoder(u);return t.on("data",C=>{p(null,h.write(C))}),h}collectData(t){const u=[];return t.on("data",p=>{u.push(p)}),u}decodeData(t,u){const p=new L.StringDecoder(u);return t.map(h=>p.write(h)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:u},p,h,C){h.indexOf(this.filePattern)!==-1&&this.matchFile(C,{base:p,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const S=c=>{const r=d.basename(c),P=d.dirname(c);let M=u[P];M||(M=u[P]=[],S(P)),M.push({base:p,relativePath:c,basename:r,searchPath:this.getSearchPath(t,c)})};h.forEach(S)}matchDirectoryTree({rootEntries:t,pathToEntries:u},p,h){const C=this,S=this.folderExcludePatterns.get(p),c=this.filePattern;function r(P){C.directoriesWalked++;const M=(0,i.hasSiblingFn)(()=>P.map(W=>W.basename));for(let W=0,$=P.length;W<$;W++){const z=P[W],{relativePath:N,basename:q}=z;if(S.test(N,q,c!==q?M:void 0))continue;const x=u[N];if(x)r(x);else{if(C.filesWalked++,N===c)continue;C.matchFile(h,z)}if(C.isLimitHit)break}}r(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,u,p,h,C){const S=t.folder,c=(0,i.hasSiblingFn)(()=>p);this.parallel(p,(r,P)=>{if(this.isCanceled||this.isLimitHit)return P(null);const M=u?[u,r].join(d.sep):r;if(this.folderExcludePatterns.get(t.folder.fsPath).test(M,r,this.config.filePattern!==r?c:void 0))return P(null);const W=[S.fsPath,M].join(d.sep);T.lstat(W,($,z)=>{if($||this.isCanceled||this.isLimitHit)return P(null);this.statLinkIfNeeded(W,z,(N,q)=>N||this.isCanceled||this.isLimitHit?P(null):q.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(W,z,(x,U)=>x||this.isCanceled||this.isLimitHit||(U=U||"",this.walkedPaths[U])?P(null):(this.walkedPaths[U]=!0,E.Promises.readdir(W).then(de=>{if(this.isCanceled||this.isLimitHit)return P(null);this.doWalk(t,M,de,h,ie=>P(ie||null))},de=>{P(null)})))):(this.filesWalked++,M===this.filePattern||this.maxFilesize&&I.isNumber(q.size)&&q.size>this.maxFilesize||this.matchFile(h,{base:S.fsPath,relativePath:M,searchPath:this.getSearchPath(t,M)}),P(null,void 0)))})},r=>{const P=r&&R.coalesce(r);return C(P&&P.length>0?P[0]:void 0)})}matchFile(t,u){this.isFileMatch(u)&&(!this.includePattern||this.includePattern(u.relativePath,d.basename(u.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(u))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,i.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,u,p){return u.isSymbolicLink()?T.stat(t,p):p(null,u)}realPathIfNeeded(t,u,p){return u.isSymbolicLink()?T.realpath(t,(h,C)=>h?p(h):p(null,C)):p(null,t)}getSearchPath(t,u){return t.folderName?d.join(t.folderName,u):u}}e.FileWalker=f;class _{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new f(t)}search(t,u,p){this.walker.walk(this.folderQueries,this.extraFiles,t,u,(h,C)=>{p(h,{limitHit:C,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=_;class n{constructor(t,u){this.expression=t,this.root=u,this.init(t)}init(t){let u,p;Object.keys(t).filter(h=>t[h]).forEach(h=>{d.isAbsolute(h)?(u=u||y.getEmptyExpression(),u[h]=t[h]):(p=p||y.getEmptyExpression(),p[h]=t[h])}),this.absoluteParsedExpr=u&&y.parse(u,{trimForExclusions:!0}),this.relativeParsedExpr=p&&y.parse(p,{trimForExclusions:!0})}test(t,u,p){return this.relativeParsedExpr&&this.relativeParsedExpr(t,u,p)||this.absoluteParsedExpr&&this.absoluteParsedExpr(d.join(this.root,t),u,p)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...y.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...y.getPathTerms(this.relativeParsedExpr)),t}}function o(s){const t=s.trim().split(`
`),u=t[0].trim();if(u.startsWith("Error parsing regex"))return u;if(u.startsWith("regex parse error"))return D.uppercaseFirstLetter(t[t.length-1].trim());if(u.startsWith("error parsing glob")||u.startsWith("unsupported encoding"))return u.charAt(0).toUpperCase()+u.substr(1);if(u==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(u.startsWith("Literal "))return u}}),define(De[337],Ie([1,0,91,22]),function(re,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function d(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(t=>t===s)}e.isUTFEncoding=d,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const L=512,R=512,g=512*8,y=512*128;var m;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(m||(e.DecodeStreamErrorKind=m={}));class A extends Error{constructor(t,u){super(t),this.decodeStreamErrorKind=u}}e.DecodeStreamError=A;class k{static async create(t){let u;if(t!==e.UTF8)u=(await new Promise((h,C)=>{re(["@vscode/iconv-lite-umd"],h,C)})).getDecoder(E(t));else{const p=new TextDecoder;u={write(h){return p.decode(h,{stream:!0})},end(){return p.decode()}}}return new k(u)}constructor(t){this.iconvLiteDecoder=t}write(t){return this.iconvLiteDecoder.write(t)}end(){return this.iconvLiteDecoder.end()}}function w(s,t){const u=t.minBytesRequiredForDetection??t.guessEncoding?g:R;return new Promise((p,h)=>{const C=(0,v.newWriteableStream)(W=>W.join("")),S=[];let c=0,r;const P=async()=>{try{const W=await o({buffer:T.VSBuffer.concat(S),bytesRead:c},t.guessEncoding);if(W.seemsBinary&&t.acceptTextOnly)throw new A("Stream is binary but only text is accepted for decoding",1);W.encoding=await t.overwriteEncoding(W.encoding),r=await k.create(W.encoding);const $=r.write(T.VSBuffer.concat(S).buffer);C.write($),S.length=0,c=0,p({stream:C,detected:W})}catch(W){M?.dispose(),C.destroy(),h(W)}},M=(0,v.listenStream)(s,{onData:async W=>{r?C.write(r.write(W.buffer)):(S.push(W),c+=W.byteLength,c>=u&&(s.pause(),await P(),setTimeout(()=>s.resume())))},onError:W=>C.error(W),onEnd:async()=>{r||await P(),C.end(r?.end())}})})}e.toDecodeStream=w;async function D(s,t,u){const h=(await new Promise((c,r)=>{re(["@vscode/iconv-lite-umd"],c,r)})).getEncoder(E(t),u);let C=!1,S=!1;return{read(){if(S)return null;const c=s.read();if(typeof c!="string"){if(S=!0,!C&&u?.addBOM)switch(t){case e.UTF8:case e.UTF8_with_bom:return T.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return T.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return T.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const r=h.end();return r&&r.length>0?(C=!0,T.VSBuffer.wrap(r)):null}return C=!0,T.VSBuffer.wrap(h.write(c))}}}e.toEncodeReadable=D;async function I(s){return(await new Promise((u,p)=>{re(["@vscode/iconv-lite-umd"],u,p)})).encodingExists(E(s))}e.encodingExists=I;function E(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=E;function i(s,t){if(!s||t<e.UTF16be_BOM.length)return null;const u=s.readUInt8(0),p=s.readUInt8(1);if(u===e.UTF16be_BOM[0]&&p===e.UTF16be_BOM[1])return e.UTF16be;if(u===e.UTF16le_BOM[0]&&p===e.UTF16le_BOM[1])return e.UTF16le;if(t<e.UTF8_BOM.length)return null;const h=s.readUInt8(2);return u===e.UTF8_BOM[0]&&p===e.UTF8_BOM[1]&&h===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=i;const l=["ascii","utf-16","utf-32"];async function a(s){const t=await new Promise((S,c)=>{re(["jschardet"],S,c)}),u=s.slice(0,y),p=_(u.buffer),h=t.detect(p);if(!h||!h.encoding)return null;const C=h.encoding.toLowerCase();return 0<=l.indexOf(C)?null:f(h.encoding)}const b={ibm866:"cp866",big5:"cp950"};function f(s){const t=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[t]||t}function _(s){let t="";for(let u=0;u<s.length;u++)t+=String.fromCharCode(s[u]);return t}function n(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const t=s.match(/windows(\d+)/);return t?"windows-"+t[1]:s}}}e.toCanonicalName=n;function o({buffer:s,bytesRead:t},u){let p=i(s,t),h=!1;if(p!==e.UTF16be&&p!==e.UTF16le&&s){let C=!0,S=!0,c=!1;for(let r=0;r<t&&r<L;r++){const P=r%2===1,M=s.readUInt8(r)===0;if(M&&(c=!0),C&&(P&&!M||!P&&M)&&(C=!1),S&&(P&&M||!P&&!M)&&(S=!1),M&&!C&&!S)break}c&&(C?p=e.UTF16le:S?p=e.UTF16be:h=!0)}return u&&!h&&!p&&s?a(s.slice(0,t)).then(C=>({seemsBinary:!1,encoding:C})):{seemsBinary:h,encoding:p}}e.detectEncodingFromBuffer=o,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[147],Ie([1,0,337,29,146]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class L extends d.TextSearchManager{constructor(g,y,m=T,A="searchProcess"){super(g,y,{readdir:k=>m.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,v.toCanonicalName)(k)},A)}}e.NativeTextSearchManager=L}),define(De[148],Ie([1,0,46,351,336,19,65,33,11,9,2,34,86,352,334,110]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const i=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class l{constructor(r){this.outputChannel=r}provideTextSearchResults(r,P,M,W){return this.outputChannel.appendLine(`provideTextSearchResults ${r.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise(($,z)=>{W.onCancellationRequested(()=>H());const N=o(r,P),q=P.folder.fsPath,x=N.map(ge=>ge.match(/^-/)?ge:`'${ge}'`).join(" ");this.outputChannel.appendLine(`${i} ${x}
 - cwd: ${q}`);let U=v.spawn(i,N,{cwd:q});U.on("error",ge=>{console.error(ge),this.outputChannel.appendLine("Error: "+(ge&&ge.message)),z((0,k.serializeSearchError)(new k.SearchError(ge&&ge.message,k.SearchErrorCode.rgProcessError)))});let de=!1;const ie=new f(P.maxResults,q,P.previewOptions);ie.on("result",ge=>{de=!0,ce="",M.report(ge)});let ne=!1;const H=()=>{ne=!0,U?.kill(),ie?.cancel()};let V=!1;ie.on("hitLimit",()=>{V=!0,H()});let ce="";U.stdout.on("data",ge=>{ie.handleData(ge),de||(ce+=ge)});let be=!1;U.stdout.once("data",()=>be=!0);let Se="";U.stderr.on("data",ge=>{const O=ge.toString();this.outputChannel.appendLine(O),Se.length+O.length<1e6&&(Se+=O)}),U.on("close",()=>{if(this.outputChannel.appendLine(be?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(de?"Got result from parser":"No result from parser"),ce&&this.outputChannel.appendLine(`Got data without result: ${ce}`),this.outputChannel.appendLine(""),ne)$({limitHit:V});else{ie.flush(),U=null;let ge;Se&&!be&&(ge=a(Se))?z((0,k.serializeSearchError)(new k.SearchError(ge.message,ge.code))):$({limitHit:V})}})})}}e.RipgrepTextSearchEngine=l;function a(c){const r=c.split(`
`),P=r[0].trim();if(r.some(W=>W.startsWith("regex parse error")))return new k.SearchError(b(r),k.SearchErrorCode.regexParseError);const M=P.match(/grep config error: unknown encoding: (.*)/);if(M)return new k.SearchError(`Unknown encoding: ${M[1]}`,k.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new k.SearchError(P.charAt(0).toUpperCase()+P.substr(1),k.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new k.SearchError(P.charAt(0).toUpperCase()+P.substr(1),k.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(P,k.SearchErrorCode.regexParseError)}function b(c){const r=["Regex parse error"],P=c.filter(M=>M.startsWith("PCRE2:"));if(P.length>=1){const M=P[0].replace("PCRE2:","");if(M.indexOf(":")!==-1&&M.split(":").length>=2){const W=M.split(":")[1];r.push(":"+W)}}return r.join("")}class f extends T.EventEmitter{constructor(r,P,M){super(),this.maxResults=r,this.rootFolder=P,this.previewOptions=M,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new d.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(r,P){return super.on(r,P),this}handleData(r){if(this.isDone)return;const P=typeof r=="string"?r:this.stringDecoder.write(r);this.handleDecodedData(P)}handleDecodedData(r){let P=r.indexOf(`
`);const M=this.remainder+r;if(P>=0)P+=this.remainder.length;else{this.remainder=M;return}let W=0;for(;P>=0;)this.handleLine(M.substring(W,P).trim()),W=P+1,P=M.indexOf(`
`,W);this.remainder=M.substring(W)}handleLine(r){if(this.isDone||!r)return;let P;try{P=JSON.parse(r)}catch{throw new Error(`malformed line from rg: ${r}`)}if(P.type==="match"){const M=_(P.data.path),W=A.URI.file(y.join(this.rootFolder,M)),$=this.createTextSearchMatch(P.data,W);this.onResult($),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const M=_(P.data.path),W=A.URI.file(y.join(this.rootFolder,M));this.createTextSearchContext(P.data,W).forEach(z=>this.onResult(z))}}createTextSearchMatch(r,P){const M=r.line_number-1,W=_(r.lines),$=Buffer.from(W);let z=0,N=0,q=M;r.submatches.length===0&&r.submatches.push(W.length?{start:0,end:1,match:{text:W[0]}}:{start:0,end:0,match:{text:""}});const x=(0,L.coalesce)(r.submatches.map((U,de)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const ie=_(U.match),ne=$.slice(z,U.start).toString(),H=n(ne),V=H.numLines>0?H.lastLineLength:H.lastLineLength+N,ce=n(ie),be=H.numLines+q,Se=ce.numLines+be,ge=ce.numLines>0?ce.lastLineLength:ce.lastLineLength+V;return z=U.end,N=ge,q=Se,new w.Range(be,V,Se,ge)}));return(0,E.createTextSearchResult)(P,W,x,this.previewOptions)}createTextSearchContext(r,P){const M=_(r.lines),W=r.line_number;return M.replace(/\r?\n$/,"").split(`
`).map(($,z)=>({text:$,uri:P,lineNumber:W+z}))}onResult(r){this.emit("result",r)}}e.RipgrepParser=f;function _(c){return c.bytes?Buffer.from(c.bytes,"base64").toString():c.text}function n(c){const r=/\n/g;let P=0,M=-1,W;for(;W=r.exec(c);)P++,M=W.index;const $=M>=0?c.length-M-1:c.length;return{numLines:P,lastLineLength:$}}function o(c,r){const P=["--hidden","--no-require-git"];P.push(c.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:M,otherIncludes:W}=(0,R.groupBy)(r.includes,z=>z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(W&&W.length){const z=new Set;W.forEach(N=>{z.add(N)}),P.push("-g","!*"),z.forEach(N=>{s(N).map(E.anchorGlob).forEach(q=>{P.push("-g",q)})})}M&&M.length&&M.forEach(z=>{P.push("-g",z)}),r.excludes.map(E.anchorGlob).forEach(z=>P.push("-g",`!${z}`)),r.maxFileSize&&P.push("--max-filesize",r.maxFileSize+""),r.useIgnoreFiles?r.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),r.followSymlinks&&P.push("--follow"),r.encoding&&r.encoding!=="utf8"&&P.push("--encoding",r.encoding),c.pattern==="--"&&(c.isRegExp=!0,c.pattern="\\-\\-"),c.isMultiline&&!c.isRegExp&&(c.pattern=(0,m.escapeRegExpCharacters)(c.pattern),c.isRegExp=!0),r.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),c.isRegExp&&(c.pattern=t(c.pattern),P.push("--engine","auto"));let $;if(c.isWordMatch){const N=(0,m.createRegExp)(c.pattern,!!c.isRegExp,{wholeWord:c.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",N)}else if(c.isRegExp){let z=p(c.pattern);z=h(z),P.push("--regexp",z)}else $=c.pattern,P.push("--fixed-strings");return P.push("--no-config"),r.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),c.isMultiline&&P.push("--multiline"),r.beforeContext&&P.push("--before-context",r.beforeContext+""),r.afterContext&&P.push("--after-context",r.afterContext+""),P.push("--"),$&&P.push($),P.push("."),P}e.getRgArgs=o;function s(c){return S(c).flatMap(P=>{const M=(0,g.splitGlobAware)(P,"/");return M.map((W,$)=>M.slice(0,$+1).join("/"))})}function t(c){const r=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;c.match(r);)c=c.replace(r,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;c.match(P);)c=c.replace(P,"$1\\x{$2}");return c}e.unicodeEscapesToPCRE2=t;const u=c=>c.type==="Assertion"&&c.kind==="lookbehind";function p(c){let r;try{r=new D.RegExpParser().parsePattern(c)}catch{return c}let P="",M=0;const W=(N,q,x)=>{P+=c.slice(M,N)+x,M=q},$=[];return new D.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const q=$[0];if(!q)W(N.start,N.end,"\\r?\\n");else if(!$.some(u))if(q.type==="CharacterClass")if(q.negate){const x=c.slice(q.start+2,N.start)+c.slice(N.end,q.end-1);q.parent?.type==="Quantifier"?W(q.start,q.end,x?`[^${x}]`:"."):W(q.start,q.end,"(?!\\r?\\n"+(x?`|[${x}]`:"")+")")}else{const x=c.slice(q.start+1,N.start)+c.slice(N.end,q.end-1);W(q.start,q.end,x===""?"\\r?\\n":`(?:[${x}]|\\r?\\n)`)}else q.type==="Quantifier"&&W(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){$.unshift(N)},onQuantifierLeave(){$.shift()},onCharacterClassRangeEnter(N){$.unshift(N)},onCharacterClassRangeLeave(){$.shift()},onCharacterClassEnter(N){$.unshift(N)},onCharacterClassLeave(){$.shift()},onAssertionEnter(N){u(N)&&$.push(N)},onAssertionLeave(N){$[0]===N&&$.shift()}}).visit(r),P+=c.slice(M),P}e.fixRegexNewline=p;function h(c){return c.replace(/\n/g,"\\r?\\n")}e.fixNewline=h;function C(c){let r=!1,P=!1,M="",W="";for(let $=0;$<c.length;$++){const z=c[$];switch(z){case"\\":P?(r?W+="\\"+z:M+="\\"+z,P=!1):P=!0;break;case"{":if(P)r?W+=z:M+=z,P=!1;else{if(r)return{strInBraces:M+"{"+W+"{"+c.substring($+1)};r=!0}break;case"}":if(P)r?W+=z:M+=z,P=!1;else{if(r)return{fixedStart:M,strInBraces:W,fixedEnd:c.substring($+1)};M+=z}break;default:r?W+=(P?"\\":"")+z:M+=(P?"\\":"")+z,P=!1;break}}return{strInBraces:M+(r?"{"+W:"")}}function S(c){const{fixedStart:r,strInBraces:P,fixedEnd:M}=C(c);if(r===void 0||M===void 0)return[P];let W=(0,g.splitGlobAware)(P,",");W.length||(W=[""]);const $=S(M);return W.flatMap(z=>{const N=r+z;return $.map(q=>N+q)})}e.performBraceExpansionForRipgrep=S}),define(De[338],Ie([1,0,21,148,128,16]),function(re,e,v,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class R{constructor(m){this.outputChannel=m,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(m,A,k,w){const D=new T.RipgrepTextSearchEngine(this.outputChannel);if(A.folder.scheme===L.Schemas.vscodeUserData){const I={...A,folder:A.folder.with({scheme:L.Schemas.file})},E=new d.Progress(i=>k.report({...i,uri:i.uri.with({scheme:A.folder.scheme})}));return this.withToken(w,i=>D.provideTextSearchResults(m,I,E,i))}else return this.withToken(w,I=>D.provideTextSearchResults(m,A,k,I))}async withToken(m,A){const k=g(m);this.inProgress.add(k);const w=await A(k.token);return this.inProgress.delete(k),w}dispose(){this.inProgress.forEach(m=>m.cancel())}}e.RipgrepSearchProvider=R;function g(y){const m=new v.CancellationTokenSource;return y.onCancellationRequested(()=>m.cancel()),m}}),define(De[339],Ie([1,0,29,148,147]),function(re,e,v,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class L{constructor(y){this.query=y}search(y,m,A){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(D){A({message:D})}},w=new d.NativeTextSearchManager(this.query,new T.RipgrepTextSearchEngine(k),v);return new Promise((D,I)=>w.search(E=>{m(E.map(R))},y).then(E=>D({limitHit:E.limitHit,type:"success",stats:E.stats}),I))}}e.TextSearchEngineAdapter=L;function R(g){return{path:g.resource&&g.resource.fsPath,results:g.results,numMatches:(g.results||[]).reduce((y,m)=>{if(m.ranges){const A=m;return y+(Array.isArray(A.ranges)?A.ranges.length:1)}else return y+1},0)}}}),define(De[340],Ie([1,0,19,17,8,3,119,11,39,2,30,34,335,339]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class I{constructor(f="searchProcess"){this.processType=f,this.caches=Object.create(null)}fileSearch(f){let _;const n=l(f),o=new L.Emitter({onDidAddFirstListener:()=>{_=(0,T.createCancelablePromise)(s=>this.doFileSearchWithEngine(w.Engine,n,t=>o.fire(t),s)),_.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{_.cancel()}});return o.event}textSearch(f){let _;const n=l(f),o=new L.Emitter({onDidAddFirstListener:()=>{_=(0,T.createCancelablePromise)(s=>this.ripgrepTextSearch(n,t=>o.fire(t),s)),_.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{_.cancel()}});return o.event}ripgrepTextSearch(f,_,n){return f.maxFileSize=this.getPlatformFileLimits().maxFileSize,new D.TextSearchEngineAdapter(f).search(n,_,_)}getPlatformFileLimits(){return{maxFileSize:process.arch==="ia32"?300*A.ByteSize.MB:16*A.ByteSize.GB}}doFileSearch(f,_,n){return this.doFileSearchWithEngine(w.Engine,f,_,n)}doFileSearchWithEngine(f,_,n,o,s=I.BATCH_SIZE){let t=0;const u=h=>{Array.isArray(h)?(t+=h.length,n(h.map(C=>this.rawMatchToSearchItem(C)))):h.relativePath?(t++,n(this.rawMatchToSearchItem(h))):n(h)};if(_.sortByScore){let h=this.trySortedSearchFromCache(_,u,o);if(!h){const C=_.maxResults?Object.assign({},_,{maxResults:null}):_,S=new f(C);h=this.doSortedSearch(S,_,n,u,o)}return new Promise((C,S)=>{h.then(([c,r])=>{const P=r.map(M=>this.rawMatchToSearchItem(M));this.sendProgress(P,n,s),C(c)},S)})}const p=new f(_);return this.doSearch(p,u,s,o).then(h=>({limitHit:h.limitHit,type:"success",stats:{detailStats:h.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(f){return{path:f.base?(0,g.join)(f.base,f.relativePath):f.relativePath}}doSortedSearch(f,_,n,o,s){const t=new L.Emitter;let u=(0,T.createCancelablePromise)(h=>{let C=[];const S=c=>{Array.isArray(c)?C=c:(o(c),t.fire(c))};return this.doSearch(f,S,-1,h).then(c=>[c,C])}),p;if(_.cacheKey){p=this.getOrCreateCache(_.cacheKey);const h={promise:u,event:t.event,resolved:!1};p.resultsToSearchCache[_.filePattern||""]=h,u.then(()=>{h.resolved=!0},C=>{delete p.resultsToSearchCache[_.filePattern||""]}),u=this.preventCancellation(u)}return u.then(([h,C])=>{const S=p?p.scorerCache:Object.create(null),c=(typeof _.maxResults!="number"||_.maxResults>0)&&y.StopWatch.create(!1);return this.sortResults(_,C,S,s).then(r=>{const P=c?c.elapsed():-1;return[{type:"success",stats:{detailStats:h.stats,sortingTime:P,fromCache:!1,type:this.processType,workspaceFolderCount:_.folderQueries.length,resultCount:r.length},messages:h.messages,limitHit:h.limitHit||typeof _.maxResults=="number"&&C.length>_.maxResults},r]})})}getOrCreateCache(f){const _=this.caches[f];return _||(this.caches[f]=new E)}trySortedSearchFromCache(f,_,n){const o=f.cacheKey&&this.caches[f.cacheKey];if(!o)return;const s=this.getResultsFromCache(o,f.filePattern||"",_,n);if(s)return s.then(([t,u,p])=>{const h=y.StopWatch.create(!1);return this.sortResults(f,u,o.scorerCache,n).then(C=>{const S=h.elapsed(),c={fromCache:!0,detailStats:p,type:this.processType,resultCount:u.length,sortingTime:S};return[{type:"success",limitHit:t.limitHit||typeof f.maxResults=="number"&&u.length>f.maxResults,stats:c},C]})})}sortResults(f,_,n,o){const s=(0,R.prepareQuery)(f.filePattern||""),t=(p,h)=>(0,R.compareItemsByFuzzyScore)(p,h,s,!0,i,n),u=typeof f.maxResults=="number"?f.maxResults:Number.MAX_VALUE;return v.topAsync(_,t,u,1e4,o)}sendProgress(f,_,n){if(n&&n>0)for(let o=0;o<f.length;o+=n)_(f.slice(o,o+n));else _(f)}getResultsFromCache(f,_,n,o){const s=y.StopWatch.create(!1),t=_.indexOf(g.sep)>=0;let u;for(const S in f.resultsToSearchCache)if(_.startsWith(S)){if(t&&S.indexOf(g.sep)<0&&S!=="")continue;const c=f.resultsToSearchCache[S];u={promise:this.preventCancellation(c.promise),event:c.event,resolved:c.resolved};break}if(!u)return null;const p=s.elapsed(),h=y.StopWatch.create(!1),C=u.event(n);return o&&o.onCancellationRequested(()=>{C.dispose()}),u.promise.then(([S,c])=>{if(o&&o.isCancellationRequested)throw(0,d.canceled)();const r=[],P=(0,R.prepareQuery)(_).normalizedLowercase;for(const M of c)(0,k.isFilePatternMatch)(M,P)&&r.push(M);return[S,r,{cacheWasResolved:u.resolved,cacheLookupTime:p,cacheFilterTime:h.elapsed(),cacheEntryCount:c.length}]})}doSearch(f,_,n,o){return new Promise((s,t)=>{let u=[];o?.onCancellationRequested(()=>f.cancel()),f.search(p=>{p&&(n?(u.push(p),n>0&&u.length>=n&&(_(u),u=[])):_(p))},p=>{_(p)},(p,h)=>{u.length&&_(u),p?t(p):s(h)})})}clearCache(f){return delete this.caches[f],Promise.resolve(void 0)}preventCancellation(f){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(_,n){return f.then(_,n)}catch(_){return this.then(void 0,_)}finally(_){return f.finally(_)}}}}e.SearchService=I,I.BATCH_SIZE=512;class E{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const i=new class{getItemLabel(b){return(0,g.basename)(b.relativePath)}getItemDescription(b){return(0,g.dirname)(b.relativePath)}getItemPath(b){return b.relativePath}};function l(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(a),extraFileResources:b.extraFileResources&&b.extraFileResources.map(f=>m.URI.revive(f))}}function a(b){return{...b,folder:m.URI.revive(b.folder)}}}),define(De[341],Ie([1,0,4,16,2,29,18,26,20,90,59,34,340,338,110,147]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let i=e.NativeExtHostSearch=class extends m.ExtHostSearch{constructor(a,b,f,_){super(a,f,_),this._pfs=L,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const n=new I.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(T.Schemas.vscodeUserData,new D.RipgrepSearchProvider(n)),b.remote.isRemote&&b.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const a=new I.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(T.Schemas.file,new D.RipgrepSearchProvider(a)),this.registerInternalFileSearchProvider(T.Schemas.file,new w.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(a,b){const f=this._handlePool++;return this._internalFileSearchProvider=b,this._internalFileSearchHandle=f,this._proxy.$registerFileSearchProvider(f,this._transformScheme(a)),(0,v.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(a,b,f,_){const n=(0,m.reviveQuery)(f);return a===this._internalFileSearchHandle?this.doInternalFileSearch(a,b,n,_):super.$provideFileSearchResults(a,b,f,_)}doInternalFileSearch(a,b,f,_){const n=o=>{if((0,k.isSerializedFileMatch)(o)&&(o=[o]),Array.isArray(o)){this._proxy.$handleFileMatch(a,b,o.map(s=>d.URI.file(s.path)));return}o.message&&this._logService.debug("ExtHostSearch",o.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(f,n,_)}$clearCache(a){return this._internalFileSearchProvider?.clearCache(a),super.$clearCache(a)}createTextSearchManager(a,b){return new E.NativeTextSearchManager(a,b,void 0,"textSearchProvider")}};e.NativeExtHostSearch=i=Ve([ze(0,y.IExtHostRpcService),ze(1,g.IExtHostInitDataService),ze(2,A.IURITransformerService),ze(3,R.ILogService)],i)}),define(De[149],Ie([1,0,353,101,74,354,22,8,3,4,11,10,32,75,122]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class E{traceSocketEvent(c,r){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,c,r)}constructor(c,r=""){this._canWrite=!0,this.debugLabel=r,this.socket=c,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,g.onUnexpectedError)(P)}},this.socket.on("error",this._errorListener),this._closeListener=P=>{this.traceSocketEvent("close",{hadError:P}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(c){const r=P=>{this.traceSocketEvent("read",P),c(R.VSBuffer.wrap(P))};return this.socket.on("data",r),{dispose:()=>this.socket.off("data",r)}}onClose(c){const r=P=>{c({type:0,hadError:P,error:void 0})};return this.socket.on("close",r),{dispose:()=>this.socket.off("close",r)}}onEnd(c){const r=()=>{c()};return this.socket.on("end",r),{dispose:()=>this.socket.off("end",r)}}write(c){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",c),this.socket.write(c.buffer,r=>{if(r){if(r.code==="EPIPE")return;(0,g.onUnexpectedError)(r)}})}catch(r){if(r.code==="EPIPE")return;(0,g.onUnexpectedError)(r)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((c,r)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),c();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),c()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.NodeSocket=E;var i;(function(S){S[S.MinHeaderByteSize=2]="MinHeaderByteSize",S[S.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(i||(i={}));var l;(function(S){S[S.PeekHeader=1]="PeekHeader",S[S.ReadHeader=2]="ReadHeader",S[S.ReadBody=3]="ReadBody",S[S.Fin=4]="Fin"})(l||(l={}));class a extends m.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(c,r){this.socket.traceSocketEvent(c,r)}constructor(c,r,P,M){super(),this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=c,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:r,inflateBytesLength:P?.byteLength||0,recordInflateBytes:M}),this._flowManager=this._register(new b(this,r,P,M,this._onData,(W,$)=>this._write(W,$))),this._register(this._flowManager.onError(W=>{console.error(W),(0,g.onUnexpectedError)(W),this._onClose.fire({type:0,hadError:!0,error:W})})),this._incomingData=new I.ChunkStream,this._register(this.socket.onData(W=>this._acceptChunk(W))),this._register(this.socket.onClose(async W=>{this._flowManager.isProcessingReadQueue()&&await y.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(W)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(c){return this._onData.event(c)}onClose(c){return this._onClose.event(c)}onEnd(c){return this.socket.onEnd(c)}write(c){let r=0;for(;r<c.byteLength;)this._flowManager.writeMessage(c.slice(r,Math.min(r+262144,c.byteLength))),r+=262144}_write(c,r){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",c);let P=2;c.byteLength<126?P+=0:c.byteLength<2**16?P+=2:P+=8;const M=R.VSBuffer.alloc(P);if(r?M.writeUInt8(194,0):M.writeUInt8(130,0),c.byteLength<126)M.writeUInt8(c.byteLength,1);else if(c.byteLength<2**16){M.writeUInt8(126,1);let W=1;M.writeUInt8(c.byteLength>>>8&255,++W),M.writeUInt8(c.byteLength>>>0&255,++W)}else{M.writeUInt8(127,1);let W=1;M.writeUInt8(0,++W),M.writeUInt8(0,++W),M.writeUInt8(0,++W),M.writeUInt8(0,++W),M.writeUInt8(c.byteLength>>>24&255,++W),M.writeUInt8(c.byteLength>>>16&255,++W),M.writeUInt8(c.byteLength>>>8&255,++W),M.writeUInt8(c.byteLength>>>0&255,++W)}this.socket.write(R.VSBuffer.concat([M,c]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(c){if(c.byteLength!==0){for(this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const r=this._incomingData.peek(this._state.readLen),P=r.readUInt8(0),M=(P&128)>>>7,W=(P&64)>>>6,$=r.readUInt8(1),z=($&128)>>>7,N=$&127;this._state.state=2,this._state.readLen=2+(z?4:0)+(N===126?2:0)+(N===127?8:0),this._state.fin=M,this._state.firstFrameOfMessage&&(this._state.compressed=!!W),this._state.firstFrameOfMessage=!!M,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const r=this._incomingData.read(this._state.readLen),P=r.readUInt8(1),M=(P&128)>>>7;let W=P&127,$=1;W===126?W=r.readUInt8(++$)*2**8+r.readUInt8(++$):W===127&&(W=r.readUInt8(++$)*0+r.readUInt8(++$)*0+r.readUInt8(++$)*0+r.readUInt8(++$)*0+r.readUInt8(++$)*2**24+r.readUInt8(++$)*2**16+r.readUInt8(++$)*2**8+r.readUInt8(++$));let z=0;M&&(z=r.readUInt8(++$)*2**24+r.readUInt8(++$)*2**16+r.readUInt8(++$)*2**8+r.readUInt8(++$)),this._state.state=3,this._state.readLen=W,this._state.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const r=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",r),n(r,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",r),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(r,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await y.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=a;class b extends m.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:R.VSBuffer.alloc(0)}constructor(c,r,P,M,W,$){super(),this._tracer=c,this._onData=W,this._writeFn=$,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new y.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new y.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,r?(this._zlibInflateStream=this._register(new f(this._tracer,M,P,{windowBits:15})),this._zlibDeflateStream=this._register(new _(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(z=>this._onError.fire(z))),this._register(this._zlibDeflateStream.onError(z=>this._onError.fire(z)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(c){this._writeQueue.push(c),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const c=this._writeQueue.shift();if(this._zlibDeflateStream){const r=await this._deflateMessage(this._zlibDeflateStream,c);this._writeFn(r,!0)}else this._writeFn(c,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(c,r){return new Promise((P,M)=>{c.write(r),c.flush(W=>P(W))})}acceptFrame(c,r,P){this._readQueue.push({data:c,isCompressed:r,isLastFrameOfMessage:P}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const c=this._readQueue.shift();if(this._zlibInflateStream&&c.isCompressed){const r=await this._inflateFrame(this._zlibInflateStream,c.data,c.isLastFrameOfMessage);this._onData.fire(r)}else this._onData.fire(c.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(c,r,P){return new Promise((M,W)=>{c.write(r),P&&c.write(R.VSBuffer.fromByteArray([0,0,255,255])),c.flush($=>M($))})}}class f extends m.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.concat(this._recordedInflateBytes):R.VSBuffer.alloc(0)}constructor(c,r,P,M){super(),this._tracer=c,this._recordInflateBytes=r,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,L.createInflateRaw)(M),this._zlibInflate.on("error",W=>{this._tracer.traceSocketEvent("zlibInflateError",{message:W?.message,code:W?.code}),this._onError.fire(W)}),this._zlibInflate.on("data",W=>{this._tracer.traceSocketEvent("zlibInflateData",W),this._pendingInflateData.push(R.VSBuffer.wrap(W))}),P&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this._zlibInflate.write(P.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(c){this._recordInflateBytes&&this._recordedInflateBytes.push(c.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",c),this._zlibInflate.write(c.buffer)}flush(c){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const r=R.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,c(r)})}}class _ extends m.Disposable{constructor(c,r){super(),this._tracer=c,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,L.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",P=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this._onError.fire(P)}),this._zlibDeflate.on("data",P=>{this._tracer.traceSocketEvent("zlibDeflateData",P),this._pendingDeflateData.push(R.VSBuffer.wrap(P))})}write(c){this._tracer.traceSocketEvent("zlibDeflateWrite",c.buffer),this._zlibDeflate.write(c.buffer)}flush(c){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let r=R.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,r=r.slice(0,r.byteLength-4),c(r)})}}function n(S,c){if(c===0)return;const r=S.byteLength>>>2;for(let N=0;N<r;N++){const q=S.readUInt32BE(N*4);S.writeUInt32BE(q^c,N*4)}const P=r*4,M=S.byteLength-P,W=c>>>24&255,$=c>>>16&255,z=c>>>8&255;M>=1&&S.writeUInt8(S.readUInt8(P)^W,P),M>=2&&S.writeUInt8(S.readUInt8(P+1)^$,P+1),M>=3&&S.writeUInt8(S.readUInt8(P+2)^z,P+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function s(){const S=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${S}-sock`;const c=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,d.tmpdir)(),r=(0,A.join)(c,`vscode-ipc-${S}.sock`);return u(r),r}e.createRandomIPCHandle=s;function t(S,c,r){const P=(0,v.createHash)("md5").update(S).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${r}-${c}-sock`;const M=r.substr(0,4),W=c.substr(0,6),$=P.substr(0,8);let z;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?z=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${$}-${M}-${W}.sock`):z=(0,A.join)(S,`${M}-${W}.sock`),u(z),z}e.createStaticIPCHandle=t;function u(S){const c=o[k.platform];typeof c=="number"&&S.length>=c&&console.warn(`WARNING: IPC handle "${S}" is longer than ${c} chars, try a shorter --user-data-dir`)}class p extends D.IPCServer{static toClientConnectionEvent(c){const r=y.Event.fromNodeEventEmitter(c,"connection");return y.Event.map(r,P=>({protocol:new I.Protocol(new E(P,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(P,"close"))}))}constructor(c){super(p.toClientConnectionEvent(c)),this.server=c}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=p;function h(S){return new Promise((c,r)=>{const P=(0,T.createServer)();P.on("error",r),P.listen(S,()=>{P.removeListener("error",r),c(new p(P))})})}e.serve=h;function C(S,c){return new Promise((r,P)=>{const M=(0,T.createConnection)(S,()=>{M.removeListener("error",P),r(I.Client.fromSocket(new E(M,`ipc-client${c}`),c))});M.once("error",P)})}e.connect=C}),define(De[342],Ie([1,0,149,247,49,36,2,18,50]),function(re,e,v,T,d,L,R,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class m{constructor(w,D,I){this._commands=w,this.logService=D,this._ipcHandlePath=I,this._server=T.createServer((E,i)=>this.onRequest(E,i)),this.setup().catch(E=>(D.error(E),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",w=>this.logService.error(w))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(w,D){const I=(i,l)=>{D.writeHead(i,{"content-type":"application/json"}),D.end(JSON.stringify(l||null),a=>a&&this.logService.error(a))},E=[];w.setEncoding("utf8"),w.on("data",i=>E.push(i)),w.on("end",async()=>{try{const i=JSON.parse(E.join(""));let l;switch(i.type){case"open":l=await this.open(i);break;case"openExternal":l=await this.openExternal(i);break;case"status":l=await this.getStatus(i);break;case"extensionManagement":l=await this.manageExtensions(i);break;default:I(404,`Unknown message type: ${i.type}`);break}I(200,l)}catch(i){const l=i instanceof Error?i.message:JSON.stringify(i);I(500,l),this.logService.error("Error while processing pipe request",i)}})}async open(w){const{fileURIs:D,folderURIs:I,forceNewWindow:E,diffMode:i,mergeMode:l,addMode:a,forceReuseWindow:b,gotoLineMode:f,waitMarkerFilePath:_,remoteAuthority:n}=w,o=[];if(Array.isArray(I))for(const p of I)try{o.push({folderUri:R.URI.parse(p)})}catch{}if(Array.isArray(D))for(const p of D)try{(0,y.hasWorkspaceFileExtension)(p)?o.push({workspaceUri:R.URI.parse(p)}):o.push({fileUri:R.URI.parse(p)})}catch{}const s=_?R.URI.file(_):void 0,u={forceNewWindow:E,diffMode:i,mergeMode:l,addMode:a,gotoLineMode:f,forceReuseWindow:b,preferNewWindow:!b&&!s&&!a,waitMarkerFileURI:s,remoteAuthority:n};this._commands.executeCommand("_remoteCLI.windowOpen",o,u)}async openExternal(w){for(const D of w.uris){const I=R.URI.parse(D),E=I.scheme==="file"?I:D;await this._commands.executeCommand("_remoteCLI.openExternal",E)}}async manageExtensions(w){const D=E=>E?.map(i=>/\.vsix$/i.test(i)?R.URI.parse(i):i),I={list:w.list,install:D(w.install),uninstall:D(w.uninstall),force:w.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",I)}async getStatus(w){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&d.existsSync(this._ipcHandlePath)&&d.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=m;let A=e.CLIServer=class extends m{constructor(w,D){super(w,D,(0,v.createRandomIPCHandle)())}};e.CLIServer=A=Ve([ze(0,L.IExtHostCommands),ze(1,g.ILogService)],A)}),define(De[343],Ie([1,0,88,331,326,246,44,314,2,16,7,342,95,312,313]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class E extends d.RequireInterceptor{_installInterceptor(){const a=this,b=globalThis._VSCODE_NODE_MODULES.module,f=b._load;b._load=function(s,t,u){return s=n(s),a._factories.has(s)?a._factories.get(s).load(s,y.URI.file((0,w.realpathSync)(t.filename)),p=>f.apply(this,[p,t,u])):f.apply(this,arguments)};const _=b._resolveLookupPaths;b._resolveLookupPaths=(o,s)=>_.call(this,n(o),s);const n=o=>{for(const s of a._alternatives){const t=s(o);if(t){o=t;break}}return o}}}class i extends R.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(D.ExtHostConsoleForwarder);const a=this._instaService.invokeFunction(T.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(g.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const _=this._instaService.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=_.ipcHandlePath}this._instaService.createInstance(I.ExtHostDiskFileSystemProvider),await this._instaService.createInstance(E,a,{mine:this._myRegistry,all:this._globalRegistry}).install(),v.mark("code/extHost/didInitAPI");const f=await this._extHostConfiguration.getConfigProvider();await(0,L.connectProxyResolver)(this._extHostWorkspace,f,this,this._logService,this._mainThreadTelemetryProxy,this._initData),v.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(a){return a.main}async _loadCommonJSModule(a,b,f){if(b.scheme!==m.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let _=null;f.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();const n=a?.identifier.value;a&&await this._extHostLocalizationService.initializeLocalizedMessages(a);try{n&&v.mark(`code/extHost/willLoadExtensionCode/${n}`),_=re.__$__nodeRequire(b.fsPath)}finally{n&&v.mark(`code/extHost/didLoadExtensionCode/${n}`),f.codeLoadingStop()}return _}async $setRemoteEnvironment(a){if(this._initData.remote.isRemote)for(const b in a){const f=a[b];f===null?delete process.env[b]:process.env[b]=f}}}e.ExtHostExtensionService=i}),define(De[344],Ie([1,0,98,317,329,328,341,343,318,89,44,90,87,43,58,84,316,315,18,330,52,241,97]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l,a,b,f,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.registerSingleton)(A.IExtHostExtensionService,g.ExtHostExtensionService,0),(0,v.registerSingleton)(a.ILoggerService,l.ExtHostLoggerService,1),(0,v.registerSingleton)(a.ILogService,new n.SyncDescriptor(_.ExtHostLogService,[!1],!0)),(0,v.registerSingleton)(E.IExtensionStoragePaths,i.ExtensionStoragePaths,0),(0,v.registerSingleton)(m.IExtHostDebugService,L.ExtHostDebugService,0),(0,v.registerSingleton)(k.IExtHostSearch,R.NativeExtHostSearch,0),(0,v.registerSingleton)(w.IExtHostTask,d.ExtHostTask,0),(0,v.registerSingleton)(D.IExtHostTerminalService,T.ExtHostTerminalService,0),(0,v.registerSingleton)(I.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,v.registerSingleton)(f.IExtHostVariableResolverProvider,b.NodeExtHostVariableResolverProviderService,0)}),define(De[355],Ie([1,0,101,356,88,8,122,149,228,105,327,22,29,95,17,124,248,267,332,344]),function(re,e,v,T,d,L,R,g,y,m,A,k,w,D,I,E,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let p=0;p<process.execArgv.length;p++)process.execArgv[p]==="--inspect-port=0"&&(process.execArgv.splice(p,1),p--)}();const a=T(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const u=globalThis._VSCODE_NODE_MODULES.module,p=u._load;u._load=function(h){if(h==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return p.apply(this,arguments)}})();const b=process.exit.bind(process);function f(u){process.exit=function(p){if(u)b(p);else{const h=new Error("An extension called process.exit() and this was prevented.");console.warn(h.stack)}},process.crash=function(){const p=new Error("An extension called process.crash() and this was prevented.");console.warn(p.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let _=function(u){b()};function n(){const u=(0,l.readExtHostConnection)(process.env);if(u.type===3)return new Promise((p,h)=>{const C=S=>{const c=S[0],r=new R.BufferedEmitter;c.on("message",P=>r.fire(k.VSBuffer.wrap(P.data))),c.on("close",()=>{_("renderer closed the MessagePort")}),c.start(),p({onMessage:r.event,send:P=>c.postMessage(P.buffer)})};process.parentPort.on("message",S=>C(S.ports))});if(u.type===2)return new Promise((p,h)=>{let C=null;const S=setTimeout(()=>{_("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),c=108e5,r=3e5,P=new I.ProcessTimeRunOnceScheduler(()=>_("renderer disconnected for too long (1)"),c),M=new I.ProcessTimeRunOnceScheduler(()=>_("renderer disconnected for too long (2)"),r);process.on("message",($,z)=>{if($&&$.type==="VSCODE_EXTHOST_IPC_SOCKET"){z.setNoDelay(!0);const N=k.VSBuffer.wrap(Buffer.from($.initialDataChunk,"base64"));let q;if($.skipWebSocketFrames)q=new g.NodeSocket(z,"extHost-socket");else{const x=k.VSBuffer.wrap(Buffer.from($.inflateBytes,"base64"));q=new g.WebSocketNodeSocket(new g.NodeSocket(z,"extHost-socket"),$.permessageDeflate,x,!1)}C?(P.cancel(),M.cancel(),C.beginAcceptReconnection(q,N),C.endAcceptReconnection(),C.sendResume()):(clearTimeout(S),C=new R.PersistentProtocol({socket:q,initialChunk:N}),C.sendResume(),C.onDidDispose(()=>_("renderer disconnected")),p(C),C.onSocketClose(()=>{P.schedule()}))}if($&&$.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(M.isScheduled())return;P.isScheduled()&&M.schedule()}});const W={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(W)});{const p=u.pipeName;return new Promise((h,C)=>{const S=v.createConnection(p,()=>{S.removeListener("error",C);const c=new R.PersistentProtocol({socket:new g.NodeSocket(S,"extHost-renderer")});c.sendResume(),h(c)});S.once("error",C),S.on("close",()=>{_("renderer closed the socket")})})}}async function o(){const u=await n();return new class{constructor(){this._onMessage=new R.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,u.onMessage(p=>{(0,m.isMessageOfType)(p,2)?(this._terminating=!0,_("received terminate message from renderer")):this._onMessage.fire(p)})}send(p){this._terminating||u.send(p)}async drain(){if(u.drain)return u.drain()}}}function s(u){return new Promise(p=>{const h=u.onMessage(C=>{h.dispose();const S=JSON.parse(C.toString()),c=S.commit,r=y.default.commit;if(c&&r&&c!==r&&b(55),S.parentPid){let P=0;setInterval(function(){try{process.kill(S.parentPid,0),P=0}catch(W){W&&W.code==="EPERM"?(P++,P>=3&&_(`parent process ${S.parentPid} does not exist anymore (3 x EPERM): ${W.message} (code: ${W.code}) (errno: ${W.errno})`)):_(`parent process ${S.parentPid} does not exist anymore: ${W.message} (code: ${W.code}) (errno: ${W.errno})`)}},1e3);let M;try{M=globalThis._VSCODE_NODE_MODULES["native-watchdog"],M.start(S.parentPid)}catch(W){(0,L.onUnexpectedError)(W)}}u.send((0,m.createMessageOfType)(0)),p({protocol:u,initData:S})});u.send((0,m.createMessageOfType)(1))})}async function t(){const u=[];process.on("unhandledRejection",(P,M)=>{u.push(M),setTimeout(()=>{const W=u.indexOf(M);W>=0&&M.catch($=>{u.splice(W,1),(0,L.isCancellationError)($)||(console.warn(`rejected promise not handled within 1 second: ${$}`),$&&$.stack&&console.warn(`stack trace: ${$.stack}`),P&&(0,L.onUnexpectedError)(P))})},1e3)}),process.on("rejectionHandled",P=>{const M=u.indexOf(P);M>=0&&u.splice(M,1)}),process.on("uncaughtException",function(P){(0,L.isSigPipeError)(P)||(0,L.onUnexpectedError)(P)}),d.mark("code/extHost/willConnectToRenderer");const p=await o();d.mark("code/extHost/didConnectToRenderer");const h=await s(p);d.mark("code/extHost/didWaitForInitData");const{initData:C}=h;f(!!C.environment.extensionTestsLocationURI),C.environment.useHostProxy=a.useHostProxy!==void 0?a.useHostProxy!=="false":void 0,C.environment.skipWorkspaceStorageLock=(0,E.boolean)(a.skipWorkspaceStorageLock,!1);const S=new class{constructor(){this.pid=process.pid}exit(M){b(M)}exists(M){return w.Promises.exists(M)}realpath(M){return(0,D.realpath)(M)}};let c=null;C.remote.authority&&a.transformURIs&&(c=(0,i.createURITransformer)(C.remote.authority));const r=new A.ExtensionHostMain(h.protocol,C,S,c);_=P=>r.terminate(P)}t().catch(u=>console.log(u))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9d3b0fa210fb4535589e8296483a5b43fe5e660a/core/vs/workbench/api/node/extensionHostProcess.js.map
