/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/types","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/resources","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(te){for(var e=[],m=0,k=te.length;m<k;m++)e[m]=Ae[te[m]];return e};define(Ae[64],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function m(F,f){const D=Object.create(null);for(const g of F){const R=f(g);let y=D[R];y||(y=D[R]=[]),y.push(g)}return D}e.groupBy=m;function k(F,f){const D=[],g=[];for(const R of F)f.has(R)||D.push(R);for(const R of f)F.has(R)||g.push(R);return{removed:D,added:g}}e.diffSets=k;function C(F,f){const D=[],g=[];for(const[R,y]of F)f.has(R)||D.push(y);for(const[R,y]of f)F.has(R)||g.push(y);return{removed:D,added:g}}e.diffMaps=C;class M{constructor(){this.map=new Map}add(f,D){let g=this.map.get(f);g||(g=new Set,this.map.set(f,g)),g.add(D)}delete(f,D){const g=this.map.get(f);g&&(g.delete(D),g.size===0&&this.map.delete(f))}forEach(f,D){const g=this.map.get(f);g&&g.forEach(D)}}e.SetMap=M}),define(Ae[65],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function m(F){return(f,D,g)=>{let R=null,y=null;if(typeof g.value=="function"?(R="value",y=g.value):typeof g.get=="function"&&(R="get",y=g.get),!y)throw new Error("not supported");g[R]=F(y,D)}}function k(F,f,D){let g=null,R=null;if(typeof D.value=="function"?(g="value",R=D.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(g="get",R=D.get),!R)throw new Error("not supported");const y=`$memoize$${f}`;D[g]=function(...d){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,d)}),this[y]}}e.memoize=k;function C(F,f,D){return m((g,R)=>{const y=`$debounce$${R}`,d=`$debounce$result$${R}`;return function(...E){this[d]||(this[d]=D?D():void 0),clearTimeout(this[y]),f&&(this[d]=f(this[d],...E),E=[this[d]]),this[y]=setTimeout(()=>{g.apply(this,E),this[d]=D?D():void 0},F)}})}e.debounce=C;function M(F,f,D){return m((g,R)=>{const y=`$throttle$timer$${R}`,d=`$throttle$result$${R}`,E=`$throttle$lastRun$${R}`,p=`$throttle$pending$${R}`;return function(...l){if(this[d]||(this[d]=D?D():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),f&&(this[d]=f(this[d],...l)),this[p])return;const t=this[E]+F;t<=Date.now()?(this[E]=Date.now(),g.apply(this,[this[d]]),this[d]=D?D():void 0):(this[p]=!0,this[y]=setTimeout(()=>{this[p]=!1,this[E]=Date.now(),g.apply(this,[this[d]]),this[d]=D?D():void 0},t-Date.now()))}})}e.throttle=M}),define(Ae[88],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(Ae[115],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(m||(e.ScanError=m={}));var k;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(k||(e.SyntaxKind=k={}));var C;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function F(i,u=!1){let n=0;const s=i.length;let v="",I=0,h=16,T=0;function S(z){let N=0,q=0;for(;N<z;){const B=i.charCodeAt(n);if(B>=48&&B<=57)q=q*16+B-48;else if(B>=65&&B<=70)q=q*16+B-65+10;else if(B>=97&&B<=102)q=q*16+B-97+10;else break;n++,N++}return N<z&&(q=-1),q}function a(z){n=z,v="",I=0,h=16,T=0}function o(){const z=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&g(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&g(i.charCodeAt(n)))for(n++;n<i.length&&g(i.charCodeAt(n));)n++;else return T=3,i.substring(z,n);let N=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&g(i.charCodeAt(n))){for(n++;n<i.length&&g(i.charCodeAt(n));)n++;N=n}else T=3;return i.substring(z,N)}function O(){let z="",N=n;for(;;){if(n>=s){z+=i.substring(N,n),T=2;break}const q=i.charCodeAt(n);if(q===34){z+=i.substring(N,n),n++;break}if(q===92){if(z+=i.substring(N,n),n++,n>=s){T=2;break}switch(i.charCodeAt(n++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const U=S(4);U>=0?z+=String.fromCharCode(U):T=4;break}default:T=5}N=n;continue}if(q>=0&&q<=31)if(D(q)){z+=i.substring(N,n),T=2;break}else T=6;n++}return z}function $(){if(v="",T=0,I=n,n>=s)return I=s,h=17;let z=i.charCodeAt(n);if(f(z)){do n++,v+=String.fromCharCode(z),z=i.charCodeAt(n);while(f(z));return h=15}if(D(z))return n++,v+=String.fromCharCode(z),z===13&&i.charCodeAt(n)===10&&(n++,v+=`
`),h=14;switch(z){case 123:return n++,h=1;case 125:return n++,h=2;case 91:return n++,h=3;case 93:return n++,h=4;case 58:return n++,h=6;case 44:return n++,h=5;case 34:return n++,v=O(),h=10;case 47:{const N=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!D(i.charCodeAt(n));)n++;return v=i.substring(N,n),h=12}if(i.charCodeAt(n+1)===42){n+=2;const q=s-1;let B=!1;for(;n<q;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,B=!0;break}n++}return B||(n++,T=1),v=i.substring(N,n),h=13}return v+=String.fromCharCode(z),n++,h=16}case 45:if(v+=String.fromCharCode(z),n++,n===s||!g(i.charCodeAt(n)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=o(),h=11;default:for(;n<s&&K(z);)n++,z=i.charCodeAt(n);if(I!==n){switch(v=i.substring(I,n),v){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return v+=String.fromCharCode(z),n++,h=16}}function K(z){if(f(z)||D(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let z;do z=$();while(z>=12&&z<=15);return z}return{setPosition:a,getPosition:()=>n,scan:u?V:$,getToken:()=>h,getTokenValue:()=>v,getTokenOffset:()=>I,getTokenLength:()=>n-I,getTokenError:()=>T}}e.createScanner=F;function f(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function D(i){return i===10||i===13||i===8232||i===8233}function g(i){return i>=48&&i<=57}var R;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(R||(R={}));function y(i,u){const n=[],s=new Object;let v;const I={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function T(S,a,o,O){I.value=S,I.offset=a,I.length=o,I.type=O,I.colonOffset=void 0,v=I}try{b(i,{onObjectBegin:(S,a)=>{if(u<=S)throw s;v=void 0,h=u>S,n.push("")},onObjectProperty:(S,a,o)=>{if(u<a||(T(S,a,o,"property"),n[n.length-1]=S,u<=a+o))throw s},onObjectEnd:(S,a)=>{if(u<=S)throw s;v=void 0,n.pop()},onArrayBegin:(S,a)=>{if(u<=S)throw s;v=void 0,n.push(0)},onArrayEnd:(S,a)=>{if(u<=S)throw s;v=void 0,n.pop()},onLiteralValue:(S,a,o)=>{if(u<a||(T(S,a,o,_(S)),u<=a+o))throw s},onSeparator:(S,a,o)=>{if(u<=a)throw s;if(S===":"&&v&&v.type==="property")v.colonOffset=a,h=!1,v=void 0;else if(S===","){const O=n[n.length-1];typeof O=="number"?n[n.length-1]=O+1:(h=!0,n[n.length-1]=""),v=void 0}}})}catch(S){if(S!==s)throw S}return{path:n,previousNode:v,isAtPropertyKey:h,matches:S=>{let a=0;for(let o=0;a<S.length&&o<n.length;o++)if(S[a]===n[o]||S[a]==="*")a++;else if(S[a]!=="**")return!1;return a===S.length}}}e.getLocation=y;function d(i,u=[],n=M.DEFAULT){let s=null,v=[];const I=[];function h(S){Array.isArray(v)?v.push(S):s!==null&&(v[s]=S)}return b(i,{onObjectBegin:()=>{const S={};h(S),I.push(v),v=S,s=null},onObjectProperty:S=>{s=S},onObjectEnd:()=>{v=I.pop()},onArrayBegin:()=>{const S=[];h(S),I.push(v),v=S,s=null},onArrayEnd:()=>{v=I.pop()},onLiteralValue:h,onError:(S,a,o)=>{u.push({error:S,offset:a,length:o})}},n),v[0]}e.parse=d;function E(i,u=[],n=M.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(S){s.type==="property"&&(s.length=S-s.offset,s=s.parent)}function I(S){return s.children.push(S),S}b(i,{onObjectBegin:S=>{s=I({type:"object",offset:S,length:-1,parent:s,children:[]})},onObjectProperty:(S,a,o)=>{s=I({type:"property",offset:a,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:S,offset:a,length:o,parent:s})},onObjectEnd:(S,a)=>{s.length=S+a-s.offset,s=s.parent,v(S+a)},onArrayBegin:(S,a)=>{s=I({type:"array",offset:S,length:-1,parent:s,children:[]})},onArrayEnd:(S,a)=>{s.length=S+a-s.offset,s=s.parent,v(S+a)},onLiteralValue:(S,a,o)=>{I({type:_(S),offset:a,length:o,parent:s,value:S}),v(a+o)},onSeparator:(S,a,o)=>{s.type==="property"&&(S===":"?s.colonOffset=a:S===","&&v(a))},onError:(S,a,o)=>{u.push({error:S,offset:a,length:o})}},n);const T=s.children[0];return T&&delete T.parent,T}e.parseTree=E;function p(i,u){if(!i)return;let n=i;for(const s of u)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let v=!1;for(const I of n.children)if(Array.isArray(I.children)&&I.children[0].value===s){n=I.children[1],v=!0;break}if(!v)return}else{const v=s;if(n.type!=="array"||v<0||!Array.isArray(n.children)||v>=n.children.length)return;n=n.children[v]}return n}e.findNodeAtLocation=p;function l(i){if(!i.parent||!i.parent.children)return[];const u=l(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;u.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&u.push(n)}return u}e.getNodePath=l;function t(i){switch(i.type){case"array":return i.children.map(t);case"object":{const u=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(u[n.children[0].value]=t(s))}return u}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=t;function r(i,u,n=!1){return u>=i.offset&&u<i.offset+i.length||n&&u===i.offset+i.length}e.contains=r;function c(i,u,n=!1){if(r(i,u,n)){const s=i.children;if(Array.isArray(s))for(let v=0;v<s.length&&s[v].offset<=u;v++){const I=c(s[v],u,n);if(I)return I}return i}}e.findNodeAtOffset=c;function b(i,u,n=M.DEFAULT){const s=F(i,!1);function v(ce){return ce?()=>ce(s.getTokenOffset(),s.getTokenLength()):()=>!0}function I(ce){return ce?De=>ce(De,s.getTokenOffset(),s.getTokenLength()):()=>!0}const h=v(u.onObjectBegin),T=I(u.onObjectProperty),S=v(u.onObjectEnd),a=v(u.onArrayBegin),o=v(u.onArrayEnd),O=I(u.onLiteralValue),$=I(u.onSeparator),K=v(u.onComment),V=I(u.onError),z=n&&n.disallowComments,N=n&&n.allowTrailingComma;function q(){for(;;){const ce=s.scan();switch(s.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:z||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ce){case 12:case 13:z?B(10):K();break;case 16:B(1);break;case 15:case 14:break;default:return ce}}}function B(ce,De=[],ke=[]){if(V(ce),De.length+ke.length>0){let ge=s.getToken();for(;ge!==17;){if(De.indexOf(ge)!==-1){q();break}else if(ke.indexOf(ge)!==-1)break;ge=q()}}}function U(ce){const De=s.getTokenValue();return ce?O(De):T(De),q(),!0}function le(){switch(s.getToken()){case 11:{let ce=0;try{ce=JSON.parse(s.getTokenValue()),typeof ce!="number"&&(B(2),ce=0)}catch{B(2)}O(ce);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return q(),!0}function ve(){return s.getToken()!==10?(B(3,[],[2,5]),!1):(U(!1),s.getToken()===6?($(":"),q(),X()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function Pe(){h(),q();let ce=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ce||B(4,[],[]),$(","),q(),s.getToken()===2&&N)break}else ce&&B(6,[],[]);ve()||B(4,[],[2,5]),ce=!0}return S(),s.getToken()!==2?B(7,[2],[]):q(),!0}function J(){a(),q();let ce=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ce||B(4,[],[]),$(","),q(),s.getToken()===4&&N)break}else ce&&B(6,[],[]);X()||B(4,[],[4,5]),ce=!0}return o(),s.getToken()!==4?B(8,[4],[]):q(),!0}function X(){switch(s.getToken()){case 3:return J();case 1:return Pe();case 10:return U(!0);default:return le()}}return q(),s.getToken()===17?n.allowEmptyContent?!0:(B(4,[],[]),!1):X()?(s.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=b;function w(i,u){const n=F(i),s=[];let v,I=0,h;do switch(h=n.getPosition(),v=n.scan(),v){case 12:case 13:case 17:I!==h&&s.push(i.substring(I,h)),u!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,u)),I=n.getPosition();break}while(v!==17);return s.join("")}e.stripComments=w;function _(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=_}),define(Ae[28],Re([1,0]),function(te,e){"use strict";var m,k,C;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(l,t,r){let c=l.get(t);return c===void 0&&(c=r,l.set(t,c)),c}e.getOrSet=M;function F(l){const t=[];return l.forEach((r,c)=>{t.push(`${c} => ${r}`)}),`Map(${l.size}) {${t.join(", ")}}`}e.mapToString=F;function f(l){const t=[];return l.forEach(r=>{t.push(r)}),`Set(${l.size}) {${t.join(", ")}}`}e.setToString=f;class D{constructor(t,r){this.uri=t,this.value=r}}class g{constructor(t,r){this[m]="ResourceMap",t instanceof g?(this.map=new Map(t.map),this.toKey=r??g.defaultToKey):(this.map=new Map,this.toKey=t??g.defaultToKey)}set(t,r){return this.map.set(this.toKey(t),new D(t,r)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,r){typeof r<"u"&&(t=t.bind(r));for(const[c,b]of this.map)t(b.value,b.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(m=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=g,g.defaultToKey=l=>l.toString();class R{constructor(t,r){this[k]="ResourceSet",!t||typeof t=="function"?this._map=new g(t):(this._map=new g(r),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,r){this._map.forEach((c,b)=>t.call(r,b,b,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=R;var y;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class d{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,r=0){const c=this._map.get(t);if(c)return r!==0&&this.touch(c,r),c.value}set(t,r,c=0){let b=this._map.get(t);if(b)b.value=r,c!==0&&this.touch(b,c);else{switch(b={key:t,value:r,next:void 0,previous:void 0},c){case 0:this.addItemLast(b);break;case 1:this.addItemFirst(b);break;case 2:this.addItemLast(b);break;default:this.addItemLast(b);break}this._map.set(t,b),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this._map.get(t);if(r)return this._map.delete(t),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,r){const c=this._state;let b=this._head;for(;b;){if(r?t.bind(r)(b.value,b.key,this):t(b.value,b.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const t=this,r=this._state;let c=this._head;const b={[Symbol.iterator](){return b},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const w={value:c.key,done:!1};return c=c.next,w}else return{value:void 0,done:!0}}};return b}values(){const t=this,r=this._state;let c=this._head;const b={[Symbol.iterator](){return b},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const w={value:c.value,done:!1};return c=c.next,w}else return{value:void 0,done:!0}}};return b}entries(){const t=this,r=this._state;let c=this._head;const b={[Symbol.iterator](){return b},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const w={value:[c.key,c.value],done:!1};return c=c.next,w}else return{value:void 0,done:!0}}};return b}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this._head,c=this.size;for(;r&&c>t;)this._map.delete(r.key),r=r.next,c--;this._head=r,this._size=c,r&&(r.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const r=t.next,c=t.previous;if(!r||!c)throw new Error("Invalid list");r.previous=c,c.next=r}t.next=void 0,t.previous=void 0,this._state++}touch(t,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this._head)return;const c=t.next,b=t.previous;t===this._tail?(b.next=void 0,this._tail=b):(c.previous=b,b.next=c),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(r===2){if(t===this._tail)return;const c=t.next,b=t.previous;t===this._head?(c.previous=void 0,this._head=c):(c.previous=b,b.next=c),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((r,c)=>{t.push([c,r])}),t}fromJSON(t){this.clear();for(const[r,c]of t)this.set(r,c)}}e.LinkedMap=d;class E extends d{constructor(t,r=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=E;class p{constructor(){this.map=new Map}add(t){return this.map.set(t,(this.map.get(t)||0)+1),this}delete(t){let r=this.map.get(t)||0;return r===0?!1:(r--,r===0?this.map.delete(t):this.map.set(t,r),!0)}has(t){return this.map.has(t)}}e.CounterSet=p}),function(te,e){typeof define=="function"&&define.amd?define(Ae[116],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(_e,pe){for(var Ce=0;Ce<pe.length;Ce++){var ae=pe[Ce];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(_e,ae.key,ae)}}function m(_e,pe,Ce){return pe&&e(_e.prototype,pe),Ce&&e(_e,Ce),Object.defineProperty(_e,"prototype",{writable:!1}),_e}function k(_e,pe){if(_e){if(typeof _e=="string")return C(_e,pe);var Ce=Object.prototype.toString.call(_e).slice(8,-1);if(Ce==="Object"&&_e.constructor&&(Ce=_e.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(_e);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return C(_e,pe)}}function C(_e,pe){(pe==null||pe>_e.length)&&(pe=_e.length);for(var Ce=0,ae=new Array(pe);Ce<pe;Ce++)ae[Ce]=_e[Ce];return ae}function M(_e,pe){var Ce=typeof Symbol<"u"&&_e[Symbol.iterator]||_e["@@iterator"];if(Ce)return(Ce=Ce.call(_e)).next.bind(Ce);if(Array.isArray(_e)||(Ce=k(_e))||pe&&_e&&typeof _e.length=="number"){Ce&&(_e=Ce);var ae=0;return function(){return ae>=_e.length?{done:!0}:{done:!1,value:_e[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function F(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=F();function f(_e){te.defaults=_e}var D=/[&<>"']/,g=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,d={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(pe){return d[pe]};function p(_e,pe){if(pe){if(D.test(_e))return _e.replace(g,E)}else if(R.test(_e))return _e.replace(y,E);return _e}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(_e){return _e.replace(l,function(pe,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var r=/(^|[^\[])\^/g;function c(_e,pe){_e=typeof _e=="string"?_e:_e.source,pe=pe||"";var Ce={replace:function(ue,ne){return ne=ne.source||ne,ne=ne.replace(r,"$1"),_e=_e.replace(ue,ne),Ce},getRegex:function(){return new RegExp(_e,pe)}};return Ce}var b=/[^\w:]/g,w=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function _(_e,pe,Ce){if(_e){var ae;try{ae=decodeURIComponent(t(Ce)).replace(b,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}pe&&!w.test(Ce)&&(Ce=v(pe,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch{return null}return Ce}var i={},u=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(_e,pe){i[" "+_e]||(u.test(_e)?i[" "+_e]=_e+"/":i[" "+_e]=S(_e,"/",!0)),_e=i[" "+_e];var Ce=_e.indexOf(":")===-1;return pe.substring(0,2)==="//"?Ce?pe:_e.replace(n,"$1")+pe:pe.charAt(0)==="/"?Ce?pe:_e.replace(s,"$1")+pe:_e+pe}var I={exec:function(){}};function h(_e){for(var pe=1,Ce,ae;pe<arguments.length;pe++){Ce=arguments[pe];for(ae in Ce)Object.prototype.hasOwnProperty.call(Ce,ae)&&(_e[ae]=Ce[ae])}return _e}function T(_e,pe){var Ce=_e.replace(/\|/g,function(ne,ee,P){for(var W=!1,H=ee;--H>=0&&P[H]==="\\";)W=!W;return W?"|":" |"}),ae=Ce.split(/ \|/),ue=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>pe)ae.splice(pe);else for(;ae.length<pe;)ae.push("");for(;ue<ae.length;ue++)ae[ue]=ae[ue].trim().replace(/\\\|/g,"|");return ae}function S(_e,pe,Ce){var ae=_e.length;if(ae===0)return"";for(var ue=0;ue<ae;){var ne=_e.charAt(ae-ue-1);if(ne===pe&&!Ce)ue++;else if(ne!==pe&&Ce)ue++;else break}return _e.slice(0,ae-ue)}function a(_e,pe){if(_e.indexOf(pe[1])===-1)return-1;for(var Ce=_e.length,ae=0,ue=0;ue<Ce;ue++)if(_e[ue]==="\\")ue++;else if(_e[ue]===pe[0])ae++;else if(_e[ue]===pe[1]&&(ae--,ae<0))return ue;return-1}function o(_e){_e&&_e.sanitize&&!_e.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(_e,pe){if(pe<1)return"";for(var Ce="";pe>1;)pe&1&&(Ce+=_e),pe>>=1,_e+=_e;return Ce+_e}function $(_e,pe,Ce,ae){var ue=pe.href,ne=pe.title?p(pe.title):null,ee=_e[1].replace(/\\([\[\]])/g,"$1");if(_e[0].charAt(0)!=="!"){ae.state.inLink=!0;var P={type:"link",raw:Ce,href:ue,title:ne,text:ee,tokens:ae.inlineTokens(ee)};return ae.state.inLink=!1,P}return{type:"image",raw:Ce,href:ue,title:ne,text:p(ee)}}function K(_e,pe){var Ce=_e.match(/^(\s+)(?:```)/);if(Ce===null)return pe;var ae=Ce[1];return pe.split(`
`).map(function(ue){var ne=ue.match(/^\s+/);if(ne===null)return ue;var ee=ne[0];return ee.length>=ae.length?ue.slice(ae.length):ue}).join(`
`)}var V=function(){function _e(Ce){this.options=Ce||te.defaults}var pe=_e.prototype;return pe.space=function(ae){var ue=this.rules.block.newline.exec(ae);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},pe.code=function(ae){var ue=this.rules.block.code.exec(ae);if(ue){var ne=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:S(ne,`
`)}}},pe.fences=function(ae){var ue=this.rules.block.fences.exec(ae);if(ue){var ne=ue[0],ee=K(ne,ue[3]||"");return{type:"code",raw:ne,lang:ue[2]?ue[2].trim():ue[2],text:ee}}},pe.heading=function(ae){var ue=this.rules.block.heading.exec(ae);if(ue){var ne=ue[2].trim();if(/#$/.test(ne)){var ee=S(ne,"#");(this.options.pedantic||!ee||/ $/.test(ee))&&(ne=ee.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:ne,tokens:this.lexer.inline(ne)}}},pe.hr=function(ae){var ue=this.rules.block.hr.exec(ae);if(ue)return{type:"hr",raw:ue[0]}},pe.blockquote=function(ae){var ue=this.rules.block.blockquote.exec(ae);if(ue){var ne=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},pe.list=function(ae){var ue=this.rules.block.list.exec(ae);if(ue){var ne,ee,P,W,H,j,re,he,ie,we,Se,$e,ze=ue[1].trim(),Je=ze.length>1,qe={type:"list",raw:"",ordered:Je,start:Je?+ze.slice(0,-1):"",loose:!1,items:[]};ze=Je?"\\d{1,9}\\"+ze.slice(-1):"\\"+ze,this.options.pedantic&&(ze=Je?ze:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+ze+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&($e=!1,!(!(ue=Ge.exec(ae))||this.rules.block.hr.test(ae)));){if(ne=ue[0],ae=ae.substring(ne.length),he=ue[2].split(`
`,1)[0],ie=ae.split(`
`,1)[0],this.options.pedantic?(W=2,Se=he.trimLeft()):(W=ue[2].search(/[^ ]/),W=W>4?1:W,Se=he.slice(W),W+=ue[1].length),j=!1,!he&&/^ *$/.test(ie)&&(ne+=ie+`
`,ae=ae.substring(ie.length+1),$e=!0),!$e)for(var it=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ct=new RegExp("^ {0,"+Math.min(3,W-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,W-1)+"}#");ae&&(we=ae.split(`
`,1)[0],he=we,this.options.pedantic&&(he=he.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(he)||rt.test(he)||it.test(he)||ct.test(ae)));){if(he.search(/[^ ]/)>=W||!he.trim())Se+=`
`+he.slice(W);else if(!j)Se+=`
`+he;else break;!j&&!he.trim()&&(j=!0),ne+=we+`
`,ae=ae.substring(we.length+1)}qe.loose||(re?qe.loose=!0:/\n *\n *$/.test(ne)&&(re=!0)),this.options.gfm&&(ee=/^\[[ xX]\] /.exec(Se),ee&&(P=ee[0]!=="[ ] ",Se=Se.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:ne,task:!!ee,checked:P,loose:!1,text:Se}),qe.raw+=ne}qe.items[qe.items.length-1].raw=ne.trimRight(),qe.items[qe.items.length-1].text=Se.trimRight(),qe.raw=qe.raw.trimRight();var Ue=qe.items.length;for(H=0;H<Ue;H++){this.lexer.state.top=!1,qe.items[H].tokens=this.lexer.blockTokens(qe.items[H].text,[]);var st=qe.items[H].tokens.filter(function(Y){return Y.type==="space"}),Z=st.every(function(Y){for(var me=Y.raw.split(""),Be=0,Ne=M(me),Qe;!(Qe=Ne()).done;){var tt=Qe.value;if(tt===`
`&&(Be+=1),Be>1)return!0}return!1});!qe.loose&&st.length&&Z&&(qe.loose=!0,qe.items[H].loose=!0)}return qe}},pe.html=function(ae){var ue=this.rules.block.html.exec(ae);if(ue){var ne={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};if(this.options.sanitize){var ee=this.options.sanitizer?this.options.sanitizer(ue[0]):p(ue[0]);ne.type="paragraph",ne.text=ee,ne.tokens=this.lexer.inline(ee)}return ne}},pe.def=function(ae){var ue=this.rules.block.def.exec(ae);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var ne=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:ue[0],href:ue[2],title:ue[3]}}},pe.table=function(ae){var ue=this.rules.block.table.exec(ae);if(ue){var ne={type:"table",header:T(ue[1]).map(function(re){return{text:re}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=ue[0];var ee=ne.align.length,P,W,H,j;for(P=0;P<ee;P++)/^ *-+: *$/.test(ne.align[P])?ne.align[P]="right":/^ *:-+: *$/.test(ne.align[P])?ne.align[P]="center":/^ *:-+ *$/.test(ne.align[P])?ne.align[P]="left":ne.align[P]=null;for(ee=ne.rows.length,P=0;P<ee;P++)ne.rows[P]=T(ne.rows[P],ne.header.length).map(function(re){return{text:re}});for(ee=ne.header.length,W=0;W<ee;W++)ne.header[W].tokens=this.lexer.inline(ne.header[W].text);for(ee=ne.rows.length,W=0;W<ee;W++)for(j=ne.rows[W],H=0;H<j.length;H++)j[H].tokens=this.lexer.inline(j[H].text);return ne}}},pe.lheading=function(ae){var ue=this.rules.block.lheading.exec(ae);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:this.lexer.inline(ue[1])}},pe.paragraph=function(ae){var ue=this.rules.block.paragraph.exec(ae);if(ue){var ne=ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1];return{type:"paragraph",raw:ue[0],text:ne,tokens:this.lexer.inline(ne)}}},pe.text=function(ae){var ue=this.rules.block.text.exec(ae);if(ue)return{type:"text",raw:ue[0],text:ue[0],tokens:this.lexer.inline(ue[0])}},pe.escape=function(ae){var ue=this.rules.inline.escape.exec(ae);if(ue)return{type:"escape",raw:ue[0],text:p(ue[1])}},pe.tag=function(ae){var ue=this.rules.inline.tag.exec(ae);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):p(ue[0]):ue[0]}},pe.link=function(ae){var ue=this.rules.inline.link.exec(ae);if(ue){var ne=ue[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var ee=S(ne.slice(0,-1),"\\");if((ne.length-ee.length)%2===0)return}else{var P=a(ue[2],"()");if(P>-1){var W=ue[0].indexOf("!")===0?5:4,H=W+ue[1].length+P;ue[2]=ue[2].substring(0,P),ue[0]=ue[0].substring(0,H).trim(),ue[3]=""}}var j=ue[2],re="";if(this.options.pedantic){var he=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(j);he&&(j=he[1],re=he[3])}else re=ue[3]?ue[3].slice(1,-1):"";return j=j.trim(),/^</.test(j)&&(this.options.pedantic&&!/>$/.test(ne)?j=j.slice(1):j=j.slice(1,-1)),$(ue,{href:j&&j.replace(this.rules.inline._escapes,"$1"),title:re&&re.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},pe.reflink=function(ae,ue){var ne;if((ne=this.rules.inline.reflink.exec(ae))||(ne=this.rules.inline.nolink.exec(ae))){var ee=(ne[2]||ne[1]).replace(/\s+/g," ");if(ee=ue[ee.toLowerCase()],!ee||!ee.href){var P=ne[0].charAt(0);return{type:"text",raw:P,text:P}}return $(ne,ee,ne[0],this.lexer)}},pe.emStrong=function(ae,ue,ne){ne===void 0&&(ne="");var ee=this.rules.inline.emStrong.lDelim.exec(ae);if(ee&&!(ee[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var P=ee[1]||ee[2]||"";if(!P||P&&(ne===""||this.rules.inline.punctuation.exec(ne))){var W=ee[0].length-1,H,j,re=W,he=0,ie=ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ie.lastIndex=0,ue=ue.slice(-1*ae.length+W);(ee=ie.exec(ue))!=null;)if(H=ee[1]||ee[2]||ee[3]||ee[4]||ee[5]||ee[6],!!H){if(j=H.length,ee[3]||ee[4]){re+=j;continue}else if((ee[5]||ee[6])&&W%3&&!((W+j)%3)){he+=j;continue}if(re-=j,!(re>0)){if(j=Math.min(j,j+re+he),Math.min(W,j)%2){var we=ae.slice(1,W+ee.index+j);return{type:"em",raw:ae.slice(0,W+ee.index+j+1),text:we,tokens:this.lexer.inlineTokens(we)}}var Se=ae.slice(2,W+ee.index+j-1);return{type:"strong",raw:ae.slice(0,W+ee.index+j+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}}}}},pe.codespan=function(ae){var ue=this.rules.inline.code.exec(ae);if(ue){var ne=ue[2].replace(/\n/g," "),ee=/[^ ]/.test(ne),P=/^ /.test(ne)&&/ $/.test(ne);return ee&&P&&(ne=ne.substring(1,ne.length-1)),ne=p(ne,!0),{type:"codespan",raw:ue[0],text:ne}}},pe.br=function(ae){var ue=this.rules.inline.br.exec(ae);if(ue)return{type:"br",raw:ue[0]}},pe.del=function(ae){var ue=this.rules.inline.del.exec(ae);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2])}},pe.autolink=function(ae,ue){var ne=this.rules.inline.autolink.exec(ae);if(ne){var ee,P;return ne[2]==="@"?(ee=p(this.options.mangle?ue(ne[1]):ne[1]),P="mailto:"+ee):(ee=p(ne[1]),P=ee),{type:"link",raw:ne[0],text:ee,href:P,tokens:[{type:"text",raw:ee,text:ee}]}}},pe.url=function(ae,ue){var ne;if(ne=this.rules.inline.url.exec(ae)){var ee,P;if(ne[2]==="@")ee=p(this.options.mangle?ue(ne[0]):ne[0]),P="mailto:"+ee;else{var W;do W=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(W!==ne[0]);ee=p(ne[0]),ne[1]==="www."?P="http://"+ee:P=ee}return{type:"link",raw:ne[0],text:ee,href:P,tokens:[{type:"text",raw:ee,text:ee}]}}},pe.inlineText=function(ae,ue){var ne=this.rules.inline.text.exec(ae);if(ne){var ee;return this.lexer.state.inRawBlock?ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):p(ne[0]):ne[0]:ee=p(this.options.smartypants?ue(ne[0]):ne[0]),{type:"text",raw:ne[0],text:ee}}},_e}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:I,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=c(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=c(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=c(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=c(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=c(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=c(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=h({},z),z.gfm=h({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=c(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=c(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=h({},z.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:I,paragraph:c(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:I,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:I,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=c(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=c(z._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=c(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=c(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=c(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=c(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=c(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=c(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=c(N.reflink).replace("label",N._label).replace("ref",z._label).getRegex(),N.nolink=c(N.nolink).replace("ref",z._label).getRegex(),N.reflinkSearch=c(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=h({},N),N.pedantic=h({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=h({},N.normal,{escape:c(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=c(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=h({},N.gfm,{br:c(N.br).replace("{2,}","*").getRegex(),text:c(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function q(_e){return _e.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(_e){var pe="",Ce,ae,ue=_e.length;for(Ce=0;Ce<ue;Ce++)ae=_e.charCodeAt(Ce),Math.random()>.5&&(ae="x"+ae.toString(16)),pe+="&#"+ae+";";return pe}var U=function(){function _e(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||te.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:z.normal,inline:N.normal};this.options.pedantic?(ae.block=z.pedantic,ae.inline=N.pedantic):this.options.gfm&&(ae.block=z.gfm,this.options.breaks?ae.inline=N.breaks:ae.inline=N.gfm),this.tokenizer.rules=ae}_e.lex=function(ae,ue){var ne=new _e(ue);return ne.lex(ae)},_e.lexInline=function(ae,ue){var ne=new _e(ue);return ne.inlineTokens(ae)};var pe=_e.prototype;return pe.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},pe.blockTokens=function(ae,ue){var ne=this;ue===void 0&&(ue=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(re,he,ie){return he+"    ".repeat(ie.length)});for(var ee,P,W,H;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(re){return(ee=re.call({lexer:ne},ae,ue))?(ae=ae.substring(ee.raw.length),ue.push(ee),!0):!1}))){if(ee=this.tokenizer.space(ae)){ae=ae.substring(ee.raw.length),ee.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(ee);continue}if(ee=this.tokenizer.code(ae)){ae=ae.substring(ee.raw.length),P=ue[ue.length-1],P&&(P.type==="paragraph"||P.type==="text")?(P.raw+=`
`+ee.raw,P.text+=`
`+ee.text,this.inlineQueue[this.inlineQueue.length-1].src=P.text):ue.push(ee);continue}if(ee=this.tokenizer.fences(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.heading(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.hr(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.blockquote(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.list(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.html(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.def(ae)){ae=ae.substring(ee.raw.length),P=ue[ue.length-1],P&&(P.type==="paragraph"||P.type==="text")?(P.raw+=`
`+ee.raw,P.text+=`
`+ee.raw,this.inlineQueue[this.inlineQueue.length-1].src=P.text):this.tokens.links[ee.tag]||(this.tokens.links[ee.tag]={href:ee.href,title:ee.title});continue}if(ee=this.tokenizer.table(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.lheading(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(W=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var re=1/0,he=ae.slice(1),ie=void 0;ne.options.extensions.startBlock.forEach(function(we){ie=we.call({lexer:this},he),typeof ie=="number"&&ie>=0&&(re=Math.min(re,ie))}),re<1/0&&re>=0&&(W=ae.substring(0,re+1))}(),this.state.top&&(ee=this.tokenizer.paragraph(W))){P=ue[ue.length-1],H&&P.type==="paragraph"?(P.raw+=`
`+ee.raw,P.text+=`
`+ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=P.text):ue.push(ee),H=W.length!==ae.length,ae=ae.substring(ee.raw.length);continue}if(ee=this.tokenizer.text(ae)){ae=ae.substring(ee.raw.length),P=ue[ue.length-1],P&&P.type==="text"?(P.raw+=`
`+ee.raw,P.text+=`
`+ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=P.text):ue.push(ee);continue}if(ae){var j="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(j);break}else throw new Error(j)}}return this.state.top=!0,ue},pe.inline=function(ae,ue){return ue===void 0&&(ue=[]),this.inlineQueue.push({src:ae,tokens:ue}),ue},pe.inlineTokens=function(ae,ue){var ne=this;ue===void 0&&(ue=[]);var ee,P,W,H=ae,j,re,he;if(this.tokens.links){var ie=Object.keys(this.tokens.links);if(ie.length>0)for(;(j=this.tokenizer.rules.inline.reflinkSearch.exec(H))!=null;)ie.includes(j[0].slice(j[0].lastIndexOf("[")+1,-1))&&(H=H.slice(0,j.index)+"["+O("a",j[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(j=this.tokenizer.rules.inline.blockSkip.exec(H))!=null;)H=H.slice(0,j.index)+"["+O("a",j[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(j=this.tokenizer.rules.inline.escapedEmSt.exec(H))!=null;)H=H.slice(0,j.index)+"++"+H.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(re||(he=""),re=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Se){return(ee=Se.call({lexer:ne},ae,ue))?(ae=ae.substring(ee.raw.length),ue.push(ee),!0):!1}))){if(ee=this.tokenizer.escape(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.tag(ae)){ae=ae.substring(ee.raw.length),P=ue[ue.length-1],P&&ee.type==="text"&&P.type==="text"?(P.raw+=ee.raw,P.text+=ee.text):ue.push(ee);continue}if(ee=this.tokenizer.link(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(ee.raw.length),P=ue[ue.length-1],P&&ee.type==="text"&&P.type==="text"?(P.raw+=ee.raw,P.text+=ee.text):ue.push(ee);continue}if(ee=this.tokenizer.emStrong(ae,H,he)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.codespan(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.br(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.del(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.autolink(ae,B)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(!this.state.inLink&&(ee=this.tokenizer.url(ae,B))){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(W=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var Se=1/0,$e=ae.slice(1),ze=void 0;ne.options.extensions.startInline.forEach(function(Je){ze=Je.call({lexer:this},$e),typeof ze=="number"&&ze>=0&&(Se=Math.min(Se,ze))}),Se<1/0&&Se>=0&&(W=ae.substring(0,Se+1))}(),ee=this.tokenizer.inlineText(W,q)){ae=ae.substring(ee.raw.length),ee.raw.slice(-1)!=="_"&&(he=ee.raw.slice(-1)),re=!0,P=ue[ue.length-1],P&&P.type==="text"?(P.raw+=ee.raw,P.text+=ee.text):ue.push(ee);continue}if(ae){var we="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return ue},m(_e,null,[{key:"rules",get:function(){return{block:z,inline:N}}}]),_e}(),le=function(){function _e(Ce){this.options=Ce||te.defaults}var pe=_e.prototype;return pe.code=function(ae,ue,ne){var ee=(ue||"").match(/\S*/)[0];if(this.options.highlight){var P=this.options.highlight(ae,ee);P!=null&&P!==ae&&(ne=!0,ae=P)}return ae=ae.replace(/\n$/,"")+`
`,ee?'<pre><code class="'+this.options.langPrefix+p(ee,!0)+'">'+(ne?ae:p(ae,!0))+`</code></pre>
`:"<pre><code>"+(ne?ae:p(ae,!0))+`</code></pre>
`},pe.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},pe.html=function(ae){return ae},pe.heading=function(ae,ue,ne,ee){if(this.options.headerIds){var P=this.options.headerPrefix+ee.slug(ne);return"<h"+ue+' id="'+P+'">'+ae+"</h"+ue+`>
`}return"<h"+ue+">"+ae+"</h"+ue+`>
`},pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},pe.list=function(ae,ue,ne){var ee=ue?"ol":"ul",P=ue&&ne!==1?' start="'+ne+'"':"";return"<"+ee+P+`>
`+ae+"</"+ee+`>
`},pe.listitem=function(ae){return"<li>"+ae+`</li>
`},pe.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},pe.paragraph=function(ae){return"<p>"+ae+`</p>
`},pe.table=function(ae,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+ue+`</table>
`},pe.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},pe.tablecell=function(ae,ue){var ne=ue.header?"th":"td",ee=ue.align?"<"+ne+' align="'+ue.align+'">':"<"+ne+">";return ee+ae+("</"+ne+`>
`)},pe.strong=function(ae){return"<strong>"+ae+"</strong>"},pe.em=function(ae){return"<em>"+ae+"</em>"},pe.codespan=function(ae){return"<code>"+ae+"</code>"},pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},pe.del=function(ae){return"<del>"+ae+"</del>"},pe.link=function(ae,ue,ne){if(ae=_(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ne;var ee='<a href="'+p(ae)+'"';return ue&&(ee+=' title="'+ue+'"'),ee+=">"+ne+"</a>",ee},pe.image=function(ae,ue,ne){if(ae=_(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ne;var ee='<img src="'+ae+'" alt="'+ne+'"';return ue&&(ee+=' title="'+ue+'"'),ee+=this.options.xhtml?"/>":">",ee},pe.text=function(ae){return ae},_e}(),ve=function(){function _e(){}var pe=_e.prototype;return pe.strong=function(ae){return ae},pe.em=function(ae){return ae},pe.codespan=function(ae){return ae},pe.del=function(ae){return ae},pe.html=function(ae){return ae},pe.text=function(ae){return ae},pe.link=function(ae,ue,ne){return""+ne},pe.image=function(ae,ue,ne){return""+ne},pe.br=function(){return""},_e}(),Pe=function(){function _e(){this.seen={}}var pe=_e.prototype;return pe.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},pe.getNextSafeSlug=function(ae,ue){var ne=ae,ee=0;if(this.seen.hasOwnProperty(ne)){ee=this.seen[ae];do ee++,ne=ae+"-"+ee;while(this.seen.hasOwnProperty(ne))}return ue||(this.seen[ae]=ee,this.seen[ne]=0),ne},pe.slug=function(ae,ue){ue===void 0&&(ue={});var ne=this.serialize(ae);return this.getNextSafeSlug(ne,ue.dryrun)},_e}(),J=function(){function _e(Ce){this.options=Ce||te.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ve,this.slugger=new Pe}_e.parse=function(ae,ue){var ne=new _e(ue);return ne.parse(ae)},_e.parseInline=function(ae,ue){var ne=new _e(ue);return ne.parseInline(ae)};var pe=_e.prototype;return pe.parse=function(ae,ue){ue===void 0&&(ue=!0);var ne="",ee,P,W,H,j,re,he,ie,we,Se,$e,ze,Je,qe,Ge,it,ct,et,rt,Ue=ae.length;for(ee=0;ee<Ue;ee++){if(Se=ae[ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Se.type]&&(rt=this.options.extensions.renderers[Se.type].call({parser:this},Se),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Se.type))){ne+=rt||"";continue}switch(Se.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(Se.tokens),Se.depth,t(this.parseInline(Se.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(Se.text,Se.lang,Se.escaped);continue}case"table":{for(ie="",he="",H=Se.header.length,P=0;P<H;P++)he+=this.renderer.tablecell(this.parseInline(Se.header[P].tokens),{header:!0,align:Se.align[P]});for(ie+=this.renderer.tablerow(he),we="",H=Se.rows.length,P=0;P<H;P++){for(re=Se.rows[P],he="",j=re.length,W=0;W<j;W++)he+=this.renderer.tablecell(this.parseInline(re[W].tokens),{header:!1,align:Se.align[W]});we+=this.renderer.tablerow(he)}ne+=this.renderer.table(ie,we);continue}case"blockquote":{we=this.parse(Se.tokens),ne+=this.renderer.blockquote(we);continue}case"list":{for($e=Se.ordered,ze=Se.start,Je=Se.loose,H=Se.items.length,we="",P=0;P<H;P++)Ge=Se.items[P],it=Ge.checked,ct=Ge.task,qe="",Ge.task&&(et=this.renderer.checkbox(it),Je?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=et+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=et+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:et}):qe+=et),qe+=this.parse(Ge.tokens,Je),we+=this.renderer.listitem(qe,ct,it);ne+=this.renderer.list(we,$e,ze);continue}case"html":{ne+=this.renderer.html(Se.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(Se.tokens));continue}case"text":{for(we=Se.tokens?this.parseInline(Se.tokens):Se.text;ee+1<Ue&&ae[ee+1].type==="text";)Se=ae[++ee],we+=`
`+(Se.tokens?this.parseInline(Se.tokens):Se.text);ne+=ue?this.renderer.paragraph(we):we;continue}default:{var st='Token with "'+Se.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return ne},pe.parseInline=function(ae,ue){ue=ue||this.renderer;var ne="",ee,P,W,H=ae.length;for(ee=0;ee<H;ee++){if(P=ae[ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[P.type]&&(W=this.options.extensions.renderers[P.type].call({parser:this},P),W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(P.type))){ne+=W||"";continue}switch(P.type){case"escape":{ne+=ue.text(P.text);break}case"html":{ne+=ue.html(P.text);break}case"link":{ne+=ue.link(P.href,P.title,this.parseInline(P.tokens,ue));break}case"image":{ne+=ue.image(P.href,P.title,P.text);break}case"strong":{ne+=ue.strong(this.parseInline(P.tokens,ue));break}case"em":{ne+=ue.em(this.parseInline(P.tokens,ue));break}case"codespan":{ne+=ue.codespan(P.text);break}case"br":{ne+=ue.br();break}case"del":{ne+=ue.del(this.parseInline(P.tokens,ue));break}case"text":{ne+=ue.text(P.text);break}default:{var j='Token with "'+P.type+'" type was not found.';if(this.options.silent){console.error(j);return}else throw new Error(j)}}}return ne},_e}();function X(_e,pe,Ce){if(typeof _e>"u"||_e===null)throw new Error("marked(): input parameter is undefined or null");if(typeof _e!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(_e)+", string expected");if(typeof pe=="function"&&(Ce=pe,pe=null),pe=h({},X.defaults,pe||{}),o(pe),Ce){var ae=pe.highlight,ue;try{ue=U.lex(_e,pe)}catch(H){return Ce(H)}var ne=function(j){var re;if(!j)try{pe.walkTokens&&X.walkTokens(ue,pe.walkTokens),re=J.parse(ue,pe)}catch(he){j=he}return pe.highlight=ae,j?Ce(j):Ce(null,re)};if(!ae||ae.length<3||(delete pe.highlight,!ue.length))return ne();var ee=0;X.walkTokens(ue,function(H){H.type==="code"&&(ee++,setTimeout(function(){ae(H.text,H.lang,function(j,re){if(j)return ne(j);re!=null&&re!==H.text&&(H.text=re,H.escaped=!0),ee--,ee===0&&ne()})},0))}),ee===0&&ne();return}function P(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+p(H.message+"",!0)+"</pre>";throw H}try{var W=U.lex(_e,pe);if(pe.walkTokens){if(pe.async)return Promise.all(X.walkTokens(W,pe.walkTokens)).then(function(){return J.parse(W,pe)}).catch(P);X.walkTokens(W,pe.walkTokens)}return J.parse(W,pe)}catch(H){P(H)}}X.options=X.setOptions=function(_e){return h(X.defaults,_e),f(X.defaults),X},X.getDefaults=F,X.defaults=te.defaults,X.use=function(){for(var _e=arguments.length,pe=new Array(_e),Ce=0;Ce<_e;Ce++)pe[Ce]=arguments[Ce];var ae=h.apply(void 0,[{}].concat(pe)),ue=X.defaults.extensions||{renderers:{},childTokens:{}},ne;pe.forEach(function(ee){if(ee.extensions&&(ne=!0,ee.extensions.forEach(function(W){if(!W.name)throw new Error("extension name required");if(W.renderer){var H=ue.renderers?ue.renderers[W.name]:null;H?ue.renderers[W.name]=function(){for(var j=arguments.length,re=new Array(j),he=0;he<j;he++)re[he]=arguments[he];var ie=W.renderer.apply(this,re);return ie===!1&&(ie=H.apply(this,re)),ie}:ue.renderers[W.name]=W.renderer}if(W.tokenizer){if(!W.level||W.level!=="block"&&W.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[W.level]?ue[W.level].unshift(W.tokenizer):ue[W.level]=[W.tokenizer],W.start&&(W.level==="block"?ue.startBlock?ue.startBlock.push(W.start):ue.startBlock=[W.start]:W.level==="inline"&&(ue.startInline?ue.startInline.push(W.start):ue.startInline=[W.start]))}W.childTokens&&(ue.childTokens[W.name]=W.childTokens)})),ee.renderer&&function(){var W=X.defaults.renderer||new le,H=function(he){var ie=W[he];W[he]=function(){for(var we=arguments.length,Se=new Array(we),$e=0;$e<we;$e++)Se[$e]=arguments[$e];var ze=ee.renderer[he].apply(W,Se);return ze===!1&&(ze=ie.apply(W,Se)),ze}};for(var j in ee.renderer)H(j);ae.renderer=W}(),ee.tokenizer&&function(){var W=X.defaults.tokenizer||new V,H=function(he){var ie=W[he];W[he]=function(){for(var we=arguments.length,Se=new Array(we),$e=0;$e<we;$e++)Se[$e]=arguments[$e];var ze=ee.tokenizer[he].apply(W,Se);return ze===!1&&(ze=ie.apply(W,Se)),ze}};for(var j in ee.tokenizer)H(j);ae.tokenizer=W}(),ee.walkTokens){var P=X.defaults.walkTokens;ae.walkTokens=function(W){var H=[];return H.push(ee.walkTokens.call(this,W)),P&&(H=H.concat(P.call(this,W))),H}}ne&&(ae.extensions=ue),X.setOptions(ae)})},X.walkTokens=function(_e,pe){for(var Ce=[],ae=function(){var P=ne.value;switch(Ce=Ce.concat(pe.call(X,P)),P.type){case"table":{for(var W=M(P.header),H;!(H=W()).done;){var j=H.value;Ce=Ce.concat(X.walkTokens(j.tokens,pe))}for(var re=M(P.rows),he;!(he=re()).done;)for(var ie=he.value,we=M(ie),Se;!(Se=we()).done;){var $e=Se.value;Ce=Ce.concat(X.walkTokens($e.tokens,pe))}break}case"list":{Ce=Ce.concat(X.walkTokens(P.items,pe));break}default:X.defaults.extensions&&X.defaults.extensions.childTokens&&X.defaults.extensions.childTokens[P.type]?X.defaults.extensions.childTokens[P.type].forEach(function(ze){Ce=Ce.concat(X.walkTokens(P[ze],pe))}):P.tokens&&(Ce=Ce.concat(X.walkTokens(P.tokens,pe)))}},ue=M(_e),ne;!(ne=ue()).done;)ae();return Ce},X.parseInline=function(_e,pe){if(typeof _e>"u"||_e===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof _e!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(_e)+", string expected");pe=h({},X.defaults,pe||{}),o(pe);try{var Ce=U.lexInline(_e,pe);return pe.walkTokens&&X.walkTokens(Ce,pe.walkTokens),J.parseInline(Ce,pe)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+p(ae.message+"",!0)+"</pre>";throw ae}},X.Parser=J,X.parser=J.parse,X.Renderer=le,X.TextRenderer=ve,X.Lexer=U,X.lexer=U.lex,X.Tokenizer=V,X.Slugger=Pe,X.parse=X;var ce=X.options,De=X.setOptions,ke=X.use,ge=X.walkTokens,A=X.parseInline,G=X,de=J.parse,ye=U.lex;te.Lexer=U,te.Parser=J,te.Renderer=le,te.Slugger=Pe,te.TextRenderer=ve,te.Tokenizer=V,te.getDefaults=F,te.lexer=ye,te.marked=X,te.options=ce,te.parse=G,te.parseInline=A,te.parser=de,te.setOptions=De,te.use=ke,te.walkTokens=ge,Object.defineProperty(te,"__esModule",{value:!0})}),define(Ae[117],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(f,D,g){return Math.min(Math.max(f,D),g)}e.clamp=m;function k(f,D){return(D+f%D)%D}e.rot=k;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class M{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=M;class F{constructor(D){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(D),this._values.fill(0,0,D)}update(D){const g=this._values[this._index];return this._values[this._index]=D,this._index=(this._index+1)%this._values.length,this._sum-=g,this._sum+=D,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=F}),function(){function te(C){const M=[];typeof C=="number"&&M.push("code/timeOrigin",C);function F(D){M.push(D,Date.now())}function f(){const D=[];for(let g=0;g<M.length;g+=2)D.push({name:M[g],startTime:M[g+1]});return D}return{mark:F,getMarks:f}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const F of performance.getEntriesByType("mark"))M.push({name:F.name,startTime:Math.round(C+F.startTime)});return M}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function m(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=m(k))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var m=e();for(var k in m)(typeof exports=="object"?exports:te)[k]=m[k]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function m(k){if(e[k])return e[k].exports;var C=e[k]={i:k,l:!1,exports:{}};return te[k].call(C.exports,C,C.exports,m),C.l=!0,C.exports}return m.m=te,m.c=e,m.d=function(k,C,M){m.o(k,C)||Object.defineProperty(k,C,{enumerable:!0,get:M})},m.r=function(k){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},m.t=function(k,C){if(1&C&&(k=m(k)),8&C||4&C&&typeof k=="object"&&k&&k.__esModule)return k;var M=Object.create(null);if(m.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:k}),2&C&&typeof k!="string")for(var F in k)m.d(M,F,function(f){return k[f]}.bind(null,F));return M},m.n=function(k){var C=k&&k.__esModule?function(){return k.default}:function(){return k};return m.d(C,"a",C),C},m.o=function(k,C){return Object.prototype.hasOwnProperty.call(k,C)},m.p="",m(m.s=0)}([function(te,e,m){(function(k){var C;e=te.exports=ke,C=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,F=Number.MAX_SAFE_INTEGER||9007199254740991,f=e.re=[],D=e.src=[],g=0,R=g++;D[R]="0|[1-9]\\d*";var y=g++;D[y]="[0-9]+";var d=g++;D[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=g++;D[E]="("+D[R]+")\\.("+D[R]+")\\.("+D[R]+")";var p=g++;D[p]="("+D[y]+")\\.("+D[y]+")\\.("+D[y]+")";var l=g++;D[l]="(?:"+D[R]+"|"+D[d]+")";var t=g++;D[t]="(?:"+D[y]+"|"+D[d]+")";var r=g++;D[r]="(?:-("+D[l]+"(?:\\."+D[l]+")*))";var c=g++;D[c]="(?:-?("+D[t]+"(?:\\."+D[t]+")*))";var b=g++;D[b]="[0-9A-Za-z-]+";var w=g++;D[w]="(?:\\+("+D[b]+"(?:\\."+D[b]+")*))";var _=g++,i="v?"+D[E]+D[r]+"?"+D[w]+"?";D[_]="^"+i+"$";var u="[v=\\s]*"+D[p]+D[c]+"?"+D[w]+"?",n=g++;D[n]="^"+u+"$";var s=g++;D[s]="((?:<|>)?=?)";var v=g++;D[v]=D[y]+"|x|X|\\*";var I=g++;D[I]=D[R]+"|x|X|\\*";var h=g++;D[h]="[v=\\s]*("+D[I]+")(?:\\.("+D[I]+")(?:\\.("+D[I]+")(?:"+D[r]+")?"+D[w]+"?)?)?";var T=g++;D[T]="[v=\\s]*("+D[v]+")(?:\\.("+D[v]+")(?:\\.("+D[v]+")(?:"+D[c]+")?"+D[w]+"?)?)?";var S=g++;D[S]="^"+D[s]+"\\s*"+D[h]+"$";var a=g++;D[a]="^"+D[s]+"\\s*"+D[T]+"$";var o=g++;D[o]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=g++;D[O]="(?:~>?)";var $=g++;D[$]="(\\s*)"+D[O]+"\\s+",f[$]=new RegExp(D[$],"g");var K=g++;D[K]="^"+D[O]+D[h]+"$";var V=g++;D[V]="^"+D[O]+D[T]+"$";var z=g++;D[z]="(?:\\^)";var N=g++;D[N]="(\\s*)"+D[z]+"\\s+",f[N]=new RegExp(D[N],"g");var q=g++;D[q]="^"+D[z]+D[h]+"$";var B=g++;D[B]="^"+D[z]+D[T]+"$";var U=g++;D[U]="^"+D[s]+"\\s*("+u+")$|^$";var le=g++;D[le]="^"+D[s]+"\\s*("+i+")$|^$";var ve=g++;D[ve]="(\\s*)"+D[s]+"\\s*("+u+"|"+D[h]+")",f[ve]=new RegExp(D[ve],"g");var Pe=g++;D[Pe]="^\\s*("+D[h]+")\\s+-\\s+("+D[h]+")\\s*$";var J=g++;D[J]="^\\s*("+D[T]+")\\s+-\\s+("+D[T]+")\\s*$";var X=g++;D[X]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)C(ce,D[ce]),f[ce]||(f[ce]=new RegExp(D[ce]));function De(ie,we){if(ie instanceof ke)return ie;if(typeof ie!="string"||ie.length>M||!(we?f[n]:f[_]).test(ie))return null;try{return new ke(ie,we)}catch{return null}}function ke(ie,we){if(ie instanceof ke){if(ie.loose===we)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ke))return new ke(ie,we);C("SemVer",ie,we),this.loose=we;var Se=ie.trim().match(we?f[n]:f[_]);if(!Se)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+Se[1],this.minor=+Se[2],this.patch=+Se[3],this.major>F||this.major<0)throw new TypeError("Invalid major version");if(this.minor>F||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>F||this.patch<0)throw new TypeError("Invalid patch version");Se[4]?this.prerelease=Se[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ze=+$e;if(ze>=0&&ze<F)return ze}return $e}):this.prerelease=[],this.build=Se[5]?Se[5].split("."):[],this.format()}e.parse=De,e.valid=function(ie,we){var Se=De(ie,we);return Se?Se.version:null},e.clean=function(ie,we){var Se=De(ie.trim().replace(/^[=v]+/,""),we);return Se?Se.version:null},e.SemVer=ke,ke.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ke.prototype.toString=function(){return this.version},ke.prototype.compare=function(ie){return C("SemVer.compare",this.version,this.loose,ie),ie instanceof ke||(ie=new ke(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},ke.prototype.compareMain=function(ie){return ie instanceof ke||(ie=new ke(ie,this.loose)),A(this.major,ie.major)||A(this.minor,ie.minor)||A(this.patch,ie.patch)},ke.prototype.comparePre=function(ie){if(ie instanceof ke||(ie=new ke(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var we=0;do{var Se=this.prerelease[we],$e=ie.prerelease[we];if(C("prerelease compare",we,Se,$e),Se===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(Se===void 0)return-1;if(Se!==$e)return A(Se,$e)}while(++we)},ke.prototype.inc=function(ie,we){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",we);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",we);break;case"prepatch":this.prerelease.length=0,this.inc("patch",we),this.inc("pre",we);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",we),this.inc("pre",we);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Se=this.prerelease.length;--Se>=0;)typeof this.prerelease[Se]=="number"&&(this.prerelease[Se]++,Se=-2);Se===-1&&this.prerelease.push(0)}we&&(this.prerelease[0]===we?isNaN(this.prerelease[1])&&(this.prerelease=[we,0]):this.prerelease=[we,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,we,Se,$e){typeof Se=="string"&&($e=Se,Se=void 0);try{return new ke(ie,Se).inc(we,$e).version}catch{return null}},e.diff=function(ie,we){if(_e(ie,we))return null;var Se=De(ie),$e=De(we);if(Se.prerelease.length||$e.prerelease.length){for(var ze in Se)if((ze==="major"||ze==="minor"||ze==="patch")&&Se[ze]!==$e[ze])return"pre"+ze;return"prerelease"}for(var ze in Se)if((ze==="major"||ze==="minor"||ze==="patch")&&Se[ze]!==$e[ze])return ze},e.compareIdentifiers=A;var ge=/^[0-9]+$/;function A(ie,we){var Se=ge.test(ie),$e=ge.test(we);return Se&&$e&&(ie=+ie,we=+we),Se&&!$e?-1:$e&&!Se?1:ie<we?-1:ie>we?1:0}function G(ie,we,Se){return new ke(ie,Se).compare(new ke(we,Se))}function de(ie,we,Se){return G(ie,we,Se)>0}function ye(ie,we,Se){return G(ie,we,Se)<0}function _e(ie,we,Se){return G(ie,we,Se)===0}function pe(ie,we,Se){return G(ie,we,Se)!==0}function Ce(ie,we,Se){return G(ie,we,Se)>=0}function ae(ie,we,Se){return G(ie,we,Se)<=0}function ue(ie,we,Se,$e){var ze;switch(we){case"===":typeof ie=="object"&&(ie=ie.version),typeof Se=="object"&&(Se=Se.version),ze=ie===Se;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof Se=="object"&&(Se=Se.version),ze=ie!==Se;break;case"":case"=":case"==":ze=_e(ie,Se,$e);break;case"!=":ze=pe(ie,Se,$e);break;case">":ze=de(ie,Se,$e);break;case">=":ze=Ce(ie,Se,$e);break;case"<":ze=ye(ie,Se,$e);break;case"<=":ze=ae(ie,Se,$e);break;default:throw new TypeError("Invalid operator: "+we)}return ze}function ne(ie,we){if(ie instanceof ne){if(ie.loose===we)return ie;ie=ie.value}if(!(this instanceof ne))return new ne(ie,we);C("comparator",ie,we),this.loose=we,this.parse(ie),this.semver===ee?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(ie,we){return A(we,ie)},e.major=function(ie,we){return new ke(ie,we).major},e.minor=function(ie,we){return new ke(ie,we).minor},e.patch=function(ie,we){return new ke(ie,we).patch},e.compare=G,e.compareLoose=function(ie,we){return G(ie,we,!0)},e.rcompare=function(ie,we,Se){return G(we,ie,Se)},e.sort=function(ie,we){return ie.sort(function(Se,$e){return e.compare(Se,$e,we)})},e.rsort=function(ie,we){return ie.sort(function(Se,$e){return e.rcompare(Se,$e,we)})},e.gt=de,e.lt=ye,e.eq=_e,e.neq=pe,e.gte=Ce,e.lte=ae,e.cmp=ue,e.Comparator=ne;var ee={};function P(ie,we){if(ie instanceof P)return ie.loose===we?ie:new P(ie.raw,we);if(ie instanceof ne)return new P(ie.value,we);if(!(this instanceof P))return new P(ie,we);if(this.loose=we,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function(Se){return this.parseRange(Se.trim())},this).filter(function(Se){return Se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function W(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function H(ie,we,Se,$e,ze,Je,qe,Ge,it,ct,et,rt,Ue){return((we=W(Se)?"":W($e)?">="+Se+".0.0":W(ze)?">="+Se+"."+$e+".0":">="+we)+" "+(Ge=W(it)?"":W(ct)?"<"+(+it+1)+".0.0":W(et)?"<"+it+"."+(+ct+1)+".0":rt?"<="+it+"."+ct+"."+et+"-"+rt:"<="+Ge)).trim()}function j(ie,we){for(var Se=0;Se<ie.length;Se++)if(!ie[Se].test(we))return!1;if(we.prerelease.length){for(Se=0;Se<ie.length;Se++)if(C(ie[Se].semver),ie[Se].semver!==ee&&ie[Se].semver.prerelease.length>0){var $e=ie[Se].semver;if($e.major===we.major&&$e.minor===we.minor&&$e.patch===we.patch)return!0}return!1}return!0}function re(ie,we,Se){try{we=new P(we,Se)}catch{return!1}return we.test(ie)}function he(ie,we,Se,$e){var ze,Je,qe,Ge,it;switch(ie=new ke(ie,$e),we=new P(we,$e),Se){case">":ze=de,Je=ae,qe=ye,Ge=">",it=">=";break;case"<":ze=ye,Je=Ce,qe=de,Ge="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(re(ie,we,$e))return!1;for(var ct=0;ct<we.set.length;++ct){var et=we.set[ct],rt=null,Ue=null;if(et.forEach(function(st){st.semver===ee&&(st=new ne(">=0.0.0")),rt=rt||st,Ue=Ue||st,ze(st.semver,rt.semver,$e)?rt=st:qe(st.semver,Ue.semver,$e)&&(Ue=st)}),rt.operator===Ge||rt.operator===it||(!Ue.operator||Ue.operator===Ge)&&Je(ie,Ue.semver)||Ue.operator===it&&qe(ie,Ue.semver))return!1}return!0}ne.prototype.parse=function(ie){var we=this.loose?f[U]:f[le],Se=ie.match(we);if(!Se)throw new TypeError("Invalid comparator: "+ie);this.operator=Se[1],this.operator==="="&&(this.operator=""),Se[2]?this.semver=new ke(Se[2],this.loose):this.semver=ee},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(ie){return C("Comparator.test",ie,this.loose),this.semver===ee||(typeof ie=="string"&&(ie=new ke(ie,this.loose)),ue(ie,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(ie,we){if(!(ie instanceof ne))throw new TypeError("a Comparator is required");var Se;if(this.operator==="")return Se=new P(ie.value,we),re(this.value,Se,we);if(ie.operator==="")return Se=new P(this.value,we),re(ie.semver,Se,we);var $e=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),ze=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),Je=this.semver.version===ie.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),Ge=ue(this.semver,"<",ie.semver,we)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),it=ue(this.semver,">",ie.semver,we)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return $e||ze||Je&&qe||Ge||it},e.Range=P,P.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},P.prototype.toString=function(){return this.range},P.prototype.parseRange=function(ie){var we=this.loose;ie=ie.trim(),C("range",ie,we);var Se=we?f[J]:f[Pe];ie=ie.replace(Se,H),C("hyphen replace",ie),ie=ie.replace(f[ve],"$1$2$3"),C("comparator trim",ie,f[ve]),ie=(ie=(ie=ie.replace(f[$],"$1~")).replace(f[N],"$1^")).split(/\s+/).join(" ");var $e=we?f[U]:f[le],ze=ie.split(" ").map(function(Je){return function(qe,Ge){return C("comp",qe),qe=function(it,ct){return it.trim().split(/\s+/).map(function(et){return function(rt,Ue){C("caret",rt,Ue);var st=Ue?f[B]:f[q];return rt.replace(st,function(Z,Y,me,Be,Ne){var Qe;return C("caret",rt,Z,Y,me,Be,Ne),W(Y)?Qe="":W(me)?Qe=">="+Y+".0.0 <"+(+Y+1)+".0.0":W(Be)?Qe=Y==="0"?">="+Y+"."+me+".0 <"+Y+"."+(+me+1)+".0":">="+Y+"."+me+".0 <"+(+Y+1)+".0.0":Ne?(C("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Qe=Y==="0"?me==="0"?">="+Y+"."+me+"."+Be+Ne+" <"+Y+"."+me+"."+(+Be+1):">="+Y+"."+me+"."+Be+Ne+" <"+Y+"."+(+me+1)+".0":">="+Y+"."+me+"."+Be+Ne+" <"+(+Y+1)+".0.0"):(C("no pr"),Qe=Y==="0"?me==="0"?">="+Y+"."+me+"."+Be+" <"+Y+"."+me+"."+(+Be+1):">="+Y+"."+me+"."+Be+" <"+Y+"."+(+me+1)+".0":">="+Y+"."+me+"."+Be+" <"+(+Y+1)+".0.0"),C("caret return",Qe),Qe})}(et,ct)}).join(" ")}(qe,Ge),C("caret",qe),qe=function(it,ct){return it.trim().split(/\s+/).map(function(et){return function(rt,Ue){var st=Ue?f[V]:f[K];return rt.replace(st,function(Z,Y,me,Be,Ne){var Qe;return C("tilde",rt,Z,Y,me,Be,Ne),W(Y)?Qe="":W(me)?Qe=">="+Y+".0.0 <"+(+Y+1)+".0.0":W(Be)?Qe=">="+Y+"."+me+".0 <"+Y+"."+(+me+1)+".0":Ne?(C("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Qe=">="+Y+"."+me+"."+Be+Ne+" <"+Y+"."+(+me+1)+".0"):Qe=">="+Y+"."+me+"."+Be+" <"+Y+"."+(+me+1)+".0",C("tilde return",Qe),Qe})}(et,ct)}).join(" ")}(qe,Ge),C("tildes",qe),qe=function(it,ct){return C("replaceXRanges",it,ct),it.split(/\s+/).map(function(et){return function(rt,Ue){rt=rt.trim();var st=Ue?f[a]:f[S];return rt.replace(st,function(Z,Y,me,Be,Ne,Qe){C("xRange",rt,Z,Y,me,Be,Ne,Qe);var tt=W(me),pt=tt||W(Be),bt=pt||W(Ne);return Y==="="&&bt&&(Y=""),tt?Z=Y===">"||Y==="<"?"<0.0.0":"*":Y&&bt?(pt&&(Be=0),bt&&(Ne=0),Y===">"?(Y=">=",pt?(me=+me+1,Be=0,Ne=0):bt&&(Be=+Be+1,Ne=0)):Y==="<="&&(Y="<",pt?me=+me+1:Be=+Be+1),Z=Y+me+"."+Be+"."+Ne):pt?Z=">="+me+".0.0 <"+(+me+1)+".0.0":bt&&(Z=">="+me+"."+Be+".0 <"+me+"."+(+Be+1)+".0"),C("xRange return",Z),Z})}(et,ct)}).join(" ")}(qe,Ge),C("xrange",qe),qe=function(it,ct){return C("replaceStars",it,ct),it.trim().replace(f[X],"")}(qe,Ge),C("stars",qe),qe}(Je,we)}).join(" ").split(/\s+/);return this.loose&&(ze=ze.filter(function(Je){return!!Je.match($e)})),ze=ze.map(function(Je){return new ne(Je,we)})},P.prototype.intersects=function(ie,we){if(!(ie instanceof P))throw new TypeError("a Range is required");return this.set.some(function(Se){return Se.every(function($e){return ie.set.some(function(ze){return ze.every(function(Je){return $e.intersects(Je,we)})})})})},e.toComparators=function(ie,we){return new P(ie,we).set.map(function(Se){return Se.map(function($e){return $e.value}).join(" ").trim().split(" ")})},P.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new ke(ie,this.loose));for(var we=0;we<this.set.length;we++)if(j(this.set[we],ie))return!0;return!1},e.satisfies=re,e.maxSatisfying=function(ie,we,Se){var $e=null,ze=null;try{var Je=new P(we,Se)}catch{return null}return ie.forEach(function(qe){Je.test(qe)&&($e&&ze.compare(qe)!==-1||(ze=new ke($e=qe,Se)))}),$e},e.minSatisfying=function(ie,we,Se){var $e=null,ze=null;try{var Je=new P(we,Se)}catch{return null}return ie.forEach(function(qe){Je.test(qe)&&($e&&ze.compare(qe)!==1||(ze=new ke($e=qe,Se)))}),$e},e.validRange=function(ie,we){try{return new P(ie,we).range||"*"}catch{return null}},e.ltr=function(ie,we,Se){return he(ie,we,"<",Se)},e.gtr=function(ie,we,Se){return he(ie,we,">",Se)},e.outside=he,e.prerelease=function(ie,we){var Se=De(ie,we);return Se&&Se.prerelease.length?Se.prerelease:null},e.intersects=function(ie,we,Se){return ie=new P(ie,Se),we=new P(we,Se),ie.intersects(we)},e.coerce=function(ie){if(ie instanceof ke)return ie;if(typeof ie!="string")return null;var we=ie.match(f[o]);return we==null?null:De((we[1]||"0")+"."+(we[2]||"0")+"."+(we[3]||"0"))}}).call(this,m(1))},function(te,e){var m,k,C=te.exports={};function M(){throw new Error("setTimeout has not been defined")}function F(){throw new Error("clearTimeout has not been defined")}function f(t){if(m===setTimeout)return setTimeout(t,0);if((m===M||!m)&&setTimeout)return m=setTimeout,setTimeout(t,0);try{return m(t,0)}catch{try{return m.call(null,t,0)}catch{return m.call(this,t,0)}}}(function(){try{m=typeof setTimeout=="function"?setTimeout:M}catch{m=M}try{k=typeof clearTimeout=="function"?clearTimeout:F}catch{k=F}})();var D,g=[],R=!1,y=-1;function d(){R&&D&&(R=!1,D.length?g=D.concat(g):y=-1,g.length&&E())}function E(){if(!R){var t=f(d);R=!0;for(var r=g.length;r;){for(D=g,g=[];++y<r;)D&&D[y].run();y=-1,r=g.length}D=null,R=!1,function(c){if(k===clearTimeout)return clearTimeout(c);if((k===F||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(c);try{k(c)}catch{try{return k.call(null,c)}catch{return k.call(this,c)}}}(t)}}function p(t,r){this.fun=t,this.array=r}function l(){}C.nextTick=function(t){var r=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)r[c-1]=arguments[c];g.push(new p(t,r)),g.length!==1||R||f(E)},p.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=l,C.addListener=l,C.once=l,C.off=l,C.removeListener=l,C.removeAllListeners=l,C.emit=l,C.prependListener=l,C.prependOnceListener=l,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ae[118],Re([1,0,9,6]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function C(w){const _=w;return _?typeof _.read=="function":!1}e.isReadable=C;function M(w){const _=w;return _?[_.on,_.pause,_.resume,_.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=M;function F(w){const _=w;return _?M(_.stream)&&Array.isArray(_.buffer)&&typeof _.ended=="boolean":!1}e.isReadableBufferedStream=F;function f(w,_){return new D(w,_)}e.newWriteableStream=f;class D{constructor(_,i){this.reducer=_,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(_){if(!this.state.destroyed){if(this.state.flowing)this.emitData(_);else if(this.buffer.data.push(_),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(_){this.state.destroyed||(this.state.flowing?this.emitError(_):this.buffer.error.push(_))}end(_){this.state.destroyed||(typeof _<"u"&&this.write(_),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(_){this.listeners.data.slice(0).forEach(i=>i(_))}emitError(_){this.listeners.error.length===0?(0,m.onUnexpectedError)(_):this.listeners.error.slice(0).forEach(i=>i(_))}emitEnd(){this.listeners.end.slice(0).forEach(_=>_())}on(_,i){if(!this.state.destroyed)switch(_){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(_,i){if(this.state.destroyed)return;let u;switch(_){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const n=u.indexOf(i);n>=0&&u.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const _=this.reducer(this.buffer.data);this.emitData(_),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const _ of this.buffer.error)this.emitError(_);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(w,_){const i=[];let u;for(;(u=w.read())!==null;)i.push(u);return _(i)}e.consumeReadable=g;function R(w,_,i){const u=[];let n;for(;(n=w.read())!==null&&u.length<i;)u.push(n);return n===null&&u.length>0?_(u):{read:()=>{if(u.length>0)return u.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return w.read()}}}e.peekReadable=R;function y(w,_){return new Promise((i,u)=>{const n=[];d(w,{onData:s=>{_&&n.push(s)},onError:s=>{_?u(s):i(void 0)},onEnd:()=>{i(_?_(n):void 0)}})})}e.consumeStream=y;function d(w,_){let i=!1;return w.on("error",u=>{i||_.onError(u)}),w.on("end",()=>{i||_.onEnd()}),w.on("data",u=>{i||_.onData(u)}),(0,k.toDisposable)(()=>i=!0)}e.listenStream=d;function E(w,_){return new Promise((i,u)=>{const n=new k.DisposableStore,s=[],v=T=>{if(s.push(T),s.length>_)return n.dispose(),w.pause(),i({stream:w,buffer:s,ended:!1})},I=T=>u(T),h=()=>i({stream:w,buffer:s,ended:!0});n.add((0,k.toDisposable)(()=>w.removeListener("error",I))),w.on("error",I),n.add((0,k.toDisposable)(()=>w.removeListener("end",h))),w.on("end",h),n.add((0,k.toDisposable)(()=>w.removeListener("data",v))),w.on("data",v)})}e.peekStream=E;function p(w,_){const i=f(_);return i.end(w),i}e.toStream=p;function l(){const w=f(()=>{throw new Error("not supported")});return w.end(),w}e.emptyStream=l;function t(w){let _=!1;return{read:()=>_?null:(_=!0,w)}}e.toReadable=t;function r(w,_,i){const u=f(i);return d(w,{onData:n=>u.write(_.data(n)),onError:n=>u.error(_.error?_.error(n):n),onEnd:()=>u.end()}),u}e.transform=r;function c(w,_,i){let u=!1;return{read:()=>{const n=_.read();return u?n:(u=!0,n!==null?i([w,n]):w)}}}e.prefixedReadable=c;function b(w,_,i){let u=!1;const n=f(i);return d(_,{onData:s=>u?n.write(s):(u=!0,n.write(i([w,s]))),onError:s=>n.error(s),onEnd:()=>{u||(u=!0,n.write(w)),n.end()}}),n}e.prefixedStream=b}),define(Ae[25],Re([1,0,66,118]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer<"u",M=new m.Lazy(()=>new Uint8Array(256));let F,f;class D{static alloc(a){return C?new D(Buffer.allocUnsafe(a)):new D(new Uint8Array(a))}static wrap(a){return C&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new D(a)}static fromString(a,o){return!(o?.dontUseNodeBuffer||!1)&&C?new D(Buffer.from(a)):(F||(F=new TextEncoder),new D(F.encode(a)))}static fromByteArray(a){const o=D.alloc(a.length);for(let O=0,$=a.length;O<$;O++)o.buffer[O]=a[O];return o}static concat(a,o){if(typeof o>"u"){o=0;for(let K=0,V=a.length;K<V;K++)o+=a[K].byteLength}const O=D.alloc(o);let $=0;for(let K=0,V=a.length;K<V;K++){const z=a[K];O.set(z,$),$+=z.byteLength}return O}constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}clone(){const a=D.alloc(this.byteLength);return a.set(this),a}toString(){return C?this.buffer.toString():(f||(f=new TextDecoder),f.decode(this.buffer))}slice(a,o){return new D(this.buffer.subarray(a,o))}set(a,o){if(a instanceof D)this.buffer.set(a.buffer,o);else if(a instanceof Uint8Array)this.buffer.set(a,o);else if(a instanceof ArrayBuffer)this.buffer.set(new Uint8Array(a),o);else if(ArrayBuffer.isView(a))this.buffer.set(new Uint8Array(a.buffer,a.byteOffset,a.byteLength),o);else throw new Error("Unknown argument 'array'")}readUInt32BE(a){return y(this.buffer,a)}writeUInt32BE(a,o){d(this.buffer,a,o)}readUInt32LE(a){return E(this.buffer,a)}writeUInt32LE(a,o){p(this.buffer,a,o)}readUInt8(a){return l(this.buffer,a)}writeUInt8(a,o){t(this.buffer,a,o)}indexOf(a){const o=a instanceof D?a.buffer:a,O=o.byteLength,$=this.buffer,K=$.byteLength;if(O===0)return 0;if(O===1)return $.indexOf(o[0]);if(O>K)return-1;const V=M.value;V.fill(o.length);for(let B=0;B<o.length;B++)V[o[B]]=o.length-B-1;let z=o.length-1,N=z,q=-1;for(;z<K;)if($[z]===o[N]){if(N===0){q=z;break}z--,N--}else z+=Math.max(o.length-N,V[$[z]]),N=o.length-1;return q}}e.VSBuffer=D;function g(S,a){return S[a+0]<<0>>>0|S[a+1]<<8>>>0}e.readUInt16LE=g;function R(S,a,o){S[o+0]=a&255,a=a>>>8,S[o+1]=a&255}e.writeUInt16LE=R;function y(S,a){return S[a]*2**24+S[a+1]*2**16+S[a+2]*2**8+S[a+3]}e.readUInt32BE=y;function d(S,a,o){S[o+3]=a,a=a>>>8,S[o+2]=a,a=a>>>8,S[o+1]=a,a=a>>>8,S[o]=a}e.writeUInt32BE=d;function E(S,a){return S[a+0]<<0>>>0|S[a+1]<<8>>>0|S[a+2]<<16>>>0|S[a+3]<<24>>>0}e.readUInt32LE=E;function p(S,a,o){S[o+0]=a&255,a=a>>>8,S[o+1]=a&255,a=a>>>8,S[o+2]=a&255,a=a>>>8,S[o+3]=a&255}e.writeUInt32LE=p;function l(S,a){return S[a]}e.readUInt8=l;function t(S,a,o){S[o]=a}e.writeUInt8=t;function r(S){return k.consumeReadable(S,a=>D.concat(a))}e.readableToBuffer=r;function c(S){return k.toReadable(S)}e.bufferToReadable=c;function b(S){return k.consumeStream(S,a=>D.concat(a))}e.streamToBuffer=b;async function w(S){return S.ended?D.concat(S.buffer):D.concat([...S.buffer,await b(S.stream)])}e.bufferedStreamToBuffer=w;function _(S){return k.toStream(S,a=>D.concat(a))}e.bufferToStream=_;function i(S){return k.transform(S,{data:a=>typeof a=="string"?D.fromString(a):D.wrap(a)},a=>D.concat(a))}e.streamToBufferReadableStream=i;function u(S){return k.newWriteableStream(a=>D.concat(a),S)}e.newWriteableBufferStream=u;function n(S,a){return k.prefixedReadable(S,a,o=>D.concat(o))}e.prefixedBufferReadable=n;function s(S,a){return k.prefixedStream(S,a,o=>D.concat(o))}e.prefixedBufferStream=s;function v(S){let a=0,o=0,O=0;const $=new Uint8Array(Math.floor(S.length/4*3)),K=z=>{switch(o){case 3:$[O++]=a|z,o=0;break;case 2:$[O++]=a|z>>>2,a=z<<6,o=3;break;case 1:$[O++]=a|z>>>4,a=z<<4,o=2;break;default:a=z<<2,o=1}};for(let z=0;z<S.length;z++){const N=S.charCodeAt(z);if(N>=65&&N<=90)K(N-65);else if(N>=97&&N<=122)K(N-97+26);else if(N>=48&&N<=57)K(N-48+52);else if(N===43||N===45)K(62);else if(N===47||N===95)K(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${S[z]}`)}}const V=O;for(;o>0;)K(0);return D.wrap($).slice(0,V)}e.decodeBase64=v;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function T({buffer:S},a=!0,o=!1){const O=o?h:I;let $="";const K=S.byteLength%3;let V=0;for(;V<S.byteLength-K;V+=3){const z=S[V+0],N=S[V+1],q=S[V+2];$+=O[z>>>2],$+=O[(z<<4|N>>>4)&63],$+=O[(N<<2|q>>>6)&63],$+=O[q&63]}if(K===1){const z=S[V+0];$+=O[z>>>2],$+=O[z<<4&63],a&&($+="==")}else if(K===2){const z=S[V+0],N=S[V+1];$+=O[z>>>2],$+=O[(z<<4|N>>>4)&63],$+=O[N<<2&63],a&&($+="=")}return $}e.encodeBase64=T}),define(Ae[119],Re([1,0,28,13]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...ne){return function(ee,P){for(let W=0,H=ne.length;W<H;W++){const j=ne[W](ee,P);if(j)return j}return null}}e.or=C,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(ne,ee,P){if(!P||P.length<ee.length)return null;let W;return ne?W=k.startsWithIgnoreCase(P,ee):W=P.indexOf(ee)===0,W?ee.length>0?[{start:0,end:ee.length}]:[]:null}function F(ne,ee){const P=ee.toLowerCase().indexOf(ne.toLowerCase());return P===-1?null:[{start:P,end:P+ne.length}]}e.matchesContiguousSubString=F;function f(ne,ee){return D(ne.toLowerCase(),ee.toLowerCase(),0,0)}e.matchesSubString=f;function D(ne,ee,P,W){if(P===ne.length)return[];if(W===ee.length)return null;if(ne[P]===ee[W]){let H=null;return(H=D(ne,ee,P+1,W+1))?r({start:W,end:W+1},H):null}return D(ne,ee,P,W+1)}function g(ne){return 97<=ne&&ne<=122}function R(ne){return 65<=ne&&ne<=90}e.isUpper=R;function y(ne){return 48<=ne&&ne<=57}function d(ne){return ne===32||ne===9||ne===10||ne===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>E.add(ne.charCodeAt(0)));function p(ne){return d(ne)||E.has(ne)}function l(ne,ee){return ne===ee||p(ne)&&p(ee)}function t(ne){return g(ne)||R(ne)||y(ne)}function r(ne,ee){return ee.length===0?ee=[ne]:ne.end===ee[0].start?ee[0].start=ne.start:ee.unshift(ne),ee}function c(ne,ee){for(let P=ee;P<ne.length;P++){const W=ne.charCodeAt(P);if(R(W)||y(W)||P>0&&!t(ne.charCodeAt(P-1)))return P}return ne.length}function b(ne,ee,P,W){if(P===ne.length)return[];if(W===ee.length)return null;if(ne[P]!==ee[W].toLowerCase())return null;{let H=null,j=W+1;for(H=b(ne,ee,P+1,W+1);!H&&(j=c(ee,j))<ee.length;)H=b(ne,ee,P+1,j),j++;return H===null?null:r({start:W,end:W+1},H)}}function w(ne){let ee=0,P=0,W=0,H=0,j=0;for(let Se=0;Se<ne.length;Se++)j=ne.charCodeAt(Se),R(j)&&ee++,g(j)&&P++,t(j)&&W++,y(j)&&H++;const re=ee/ne.length,he=P/ne.length,ie=W/ne.length,we=H/ne.length;return{upperPercent:re,lowerPercent:he,alphaPercent:ie,numericPercent:we}}function _(ne){const{upperPercent:ee,lowerPercent:P}=ne;return P===0&&ee>.6}function i(ne){const{upperPercent:ee,lowerPercent:P,alphaPercent:W,numericPercent:H}=ne;return P>.2&&ee<.8&&W>.6&&H<.2}function u(ne){let ee=0,P=0,W=0,H=0;for(let j=0;j<ne.length;j++)W=ne.charCodeAt(j),R(W)&&ee++,g(W)&&P++,d(W)&&H++;return(ee===0||P===0)&&H===0?ne.length<=30:ee<=5}function n(ne,ee){if(!ee||(ee=ee.trim(),ee.length===0)||!u(ne)||ee.length>60)return null;const P=w(ee);if(!i(P)){if(!_(P))return null;ee=ee.toLowerCase()}let W=null,H=0;for(ne=ne.toLowerCase();H<ee.length&&(W=b(ne,ee,0,H))===null;)H=c(ee,H+1);return W}e.matchesCamelCase=n;function s(ne,ee,P=!1){if(!ee||ee.length===0)return null;let W=null,H=0;for(ne=ne.toLowerCase(),ee=ee.toLowerCase();H<ee.length&&(W=v(ne,ee,0,H,P))===null;)H=I(ee,H+1);return W}e.matchesWords=s;function v(ne,ee,P,W,H){if(P===ne.length)return[];if(W===ee.length)return null;if(l(ne.charCodeAt(P),ee.charCodeAt(W))){let j=null,re=W+1;if(j=v(ne,ee,P+1,W+1,H),!H)for(;!j&&(re=I(ee,re))<ee.length;)j=v(ne,ee,P+1,re,H),re++;return j?ne.charCodeAt(P)!==ee.charCodeAt(W)?j:r({start:W,end:W+1},j):null}else return null}function I(ne,ee){for(let P=ee;P<ne.length;P++)if(p(ne.charCodeAt(P))||P>0&&p(ne.charCodeAt(P-1)))return P;return ne.length}const h=C(e.matchesPrefix,n,F),T=C(e.matchesPrefix,n,f),S=new m.LRUCache(1e4);function a(ne,ee,P=!1){if(typeof ne!="string"||typeof ee!="string")return null;let W=S.get(ne);W||(W=new RegExp(k.convertSimple2RegExpPattern(ne),"i"),S.set(ne,W));const H=W.exec(ee);return H?[{start:H.index,end:H.index+H[0].length}]:P?T(ne,ee):h(ne,ee)}e.matchesFuzzy=a;function o(ne,ee){const P=de(ne,ne.toLowerCase(),0,ee,ee.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return P?$(P):null}e.matchesFuzzy2=o;function O(ne,ee,P,W,H,j){const re=Math.min(13,ne.length);for(;P<re;P++){const he=de(ne,ee,P,W,H,j,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(he)return he}return[0,j]}e.anyScore=O;function $(ne){if(typeof ne>"u")return[];const ee=[],P=ne[1];for(let W=ne.length-1;W>1;W--){const H=ne[W]+P,j=ee[ee.length-1];j&&j.end===H?j.end=H+1:ee.push({start:H,end:H+1})}return ee}e.createMatches=$;const K=128;function V(){const ne=[],ee=[];for(let P=0;P<=K;P++)ee[P]=0;for(let P=0;P<=K;P++)ne.push(ee.slice(0));return ne}function z(ne){const ee=[];for(let P=0;P<=ne;P++)ee[P]=0;return ee}const N=z(2*K),q=z(2*K),B=V(),U=V(),le=V(),ve=!1;function Pe(ne,ee,P,W,H){function j(he,ie,we=" "){for(;he.length<ie;)he=we+he;return he}let re=` |   |${W.split("").map(he=>j(he,3)).join("|")}
`;for(let he=0;he<=P;he++)he===0?re+=" |":re+=`${ee[he-1]}|`,re+=ne[he].slice(0,H+1).map(ie=>j(ie.toString(),3)).join("|")+`
`;return re}function J(ne,ee,P,W){ne=ne.substr(ee),P=P.substr(W),console.log(Pe(U,ne,ne.length,P,P.length)),console.log(Pe(le,ne,ne.length,P,P.length)),console.log(Pe(B,ne,ne.length,P,P.length))}function X(ne,ee){if(ee<0||ee>=ne.length)return!1;const P=ne.codePointAt(ee);switch(P){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(P)}}function ce(ne,ee){if(ee<0||ee>=ne.length)return!1;switch(ne.charCodeAt(ee)){case 32:case 9:return!0;default:return!1}}function De(ne,ee,P){return ee[ne]!==P[ne]}function ke(ne,ee,P,W,H,j,re=!1){for(;ee<P&&H<j;)ne[ee]===W[H]&&(re&&(N[ee]=H),ee+=1),H+=1;return ee===P}e.isPatternInWord=ke;var ge;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var A;(function(ne){ne.Default=[-100,0];function ee(P){return!P||P.length===2&&P[0]===-100&&P[1]===0}ne.isDefault=ee})(A||(e.FuzzyScore=A={}));class G{constructor(ee,P){this.firstMatchCanBeWeak=ee,this.boostFullMatch=P}}e.FuzzyScoreOptions=G,G.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function de(ne,ee,P,W,H,j,re=G.default){const he=ne.length>K?K:ne.length,ie=W.length>K?K:W.length;if(P>=he||j>=ie||he-P>ie-j||!ke(ee,P,he,H,j,ie,!0))return;ye(he,ie,P,j,ee,H);let we=1,Se=1,$e=P,ze=j;const Je=[!1];for(we=1,$e=P;$e<he;we++,$e++){const et=N[$e],rt=q[$e],Ue=$e+1<he?q[$e+1]:ie;for(Se=et-j+1,ze=et;ze<Ue;Se++,ze++){let st=Number.MIN_SAFE_INTEGER,Z=!1;ze<=rt&&(st=_e(ne,ee,$e,P,W,H,ze,ie,j,B[we-1][Se-1]===0,Je));let Y=0;st!==Number.MAX_SAFE_INTEGER&&(Z=!0,Y=st+U[we-1][Se-1]);const me=ze>et,Be=me?U[we][Se-1]+(B[we][Se-1]>0?-5:0):0,Ne=ze>et+1&&B[we][Se-1]>0,Qe=Ne?U[we][Se-2]+(B[we][Se-2]>0?-5:0):0;if(Ne&&(!me||Qe>=Be)&&(!Z||Qe>=Y))U[we][Se]=Qe,le[we][Se]=3,B[we][Se]=0;else if(me&&(!Z||Be>=Y))U[we][Se]=Be,le[we][Se]=2,B[we][Se]=0;else if(Z)U[we][Se]=Y,le[we][Se]=1,B[we][Se]=B[we-1][Se-1]+1;else throw new Error("not possible")}}if(ve&&J(ne,P,W,j),!Je[0]&&!re.firstMatchCanBeWeak)return;we--,Se--;const qe=[U[we][Se],j];let Ge=0,it=0;for(;we>=1;){let et=Se;do{const rt=le[we][et];if(rt===3)et=et-2;else if(rt===2)et=et-1;else break}while(et>=1);Ge>1&&ee[P+we-1]===H[j+Se-1]&&!De(et+j-1,W,H)&&Ge+1>B[we][et]&&(et=Se),et===Se?Ge++:Ge=1,it||(it=et),we--,Se=et-1,qe.push(Se)}ie===he&&re.boostFullMatch&&(qe[0]+=2);const ct=it-he;return qe[0]-=ct,qe}e.fuzzyScore=de;function ye(ne,ee,P,W,H,j){let re=ne-1,he=ee-1;for(;re>=P&&he>=W;)H[re]===j[he]&&(q[re]=he,re--),he--}function _e(ne,ee,P,W,H,j,re,he,ie,we,Se){if(ee[P]!==j[re])return Number.MIN_SAFE_INTEGER;let $e=1,ze=!1;return re===P-W?$e=ne[P]===H[re]?7:5:De(re,H,j)&&(re===0||!De(re-1,H,j))?($e=ne[P]===H[re]?7:5,ze=!0):X(j,re)&&(re===0||!X(j,re-1))?$e=5:(X(j,re-1)||ce(j,re-1))&&($e=5,ze=!0),$e>1&&P===W&&(Se[0]=!0),ze||(ze=De(re,H,j)||X(j,re-1)||ce(j,re-1)),P===W?re>ie&&($e-=ze?3:5):we?$e+=ze?2:0:$e+=ze?0:1,re+1===he&&($e-=ze?3:5),$e}function pe(ne,ee,P,W,H,j,re){return ae(ne,ee,P,W,H,j,!0,re)}e.fuzzyScoreGracefulAggressive=pe;function Ce(ne,ee,P,W,H,j,re){return ae(ne,ee,P,W,H,j,!1,re)}e.fuzzyScoreGraceful=Ce;function ae(ne,ee,P,W,H,j,re,he){let ie=de(ne,ee,P,W,H,j,he);if(ie&&!re)return ie;if(ne.length>=3){const we=Math.min(7,ne.length-1);for(let Se=P+1;Se<we;Se++){const $e=ue(ne,Se);if($e){const ze=de($e,$e.toLowerCase(),P,W,H,j,he);ze&&(ze[0]-=3,(!ie||ze[0]>ie[0])&&(ie=ze))}}}return ie}function ue(ne,ee){if(ee+1>=ne.length)return;const P=ne[ee],W=ne[ee+1];if(P!==W)return ne.slice(0,ee)+W+P+ne.slice(ee+2)}}),define(Ae[29],Re([1,0,13]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(k||(k={})),function(C){const M="error",F="warning",f="warn",D="info",g="ignore";function R(d){return d?m.equalsIgnoreCase(M,d)?C.Error:m.equalsIgnoreCase(F,d)||m.equalsIgnoreCase(f,d)?C.Warning:m.equalsIgnoreCase(D,d)?C.Info:C.Ignore:C.Ignore}C.fromValue=R;function y(d){switch(d){case C.Error:return M;case C.Warning:return F;case C.Info:return D;default:return g}}C.toString=y}(k||(k={})),e.default=k}),define(Ae[120],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ae[48],Re([1,0,18,13]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class C{constructor(){this._value="",this._pos=0}reset(E){return this._value=E,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(E){const p=E.charCodeAt(0),l=this._value.charCodeAt(this._pos);return p-l}value(){return this._value[this._pos]}}e.StringIterator=C;class M{constructor(E=!0){this._caseSensitive=E}reset(E){return this._value=E,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let E=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(E)this._from++;else break;else E=!1;return this}cmp(E){return this._caseSensitive?(0,k.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=M;class F{constructor(E=!0,p=!0){this._splitOnBackslash=E,this._caseSensitive=p}reset(E){this._from=0,this._to=0,this._value=E,this._valueLen=E.length;for(let p=E.length-1;p>=0;p--,this._valueLen--){const l=this._value.charCodeAt(p);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let E=!0;for(;this._to<this._valueLen;this._to++){const p=this._value.charCodeAt(this._to);if(p===47||this._splitOnBackslash&&p===92)if(E)this._from++;else break;else E=!1}return this}cmp(E){return this._caseSensitive?(0,k.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=F;var f;(function(d){d[d.Scheme=1]="Scheme",d[d.Authority=2]="Authority",d[d.Path=3]="Path",d[d.Query=4]="Query",d[d.Fragment=5]="Fragment"})(f||(f={}));class D{constructor(E,p){this._ignorePathCasing=E,this._ignoreQueryAndFragment=p,this._states=[],this._stateIdx=0}reset(E){return this._value=E,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new F(!1,!this._ignorePathCasing(E)),this._pathIterator.reset(E.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(E)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(E){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(E,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(E,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(E);if(this._states[this._stateIdx]===4)return(0,k.compare)(E,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(E,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=D;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(d){d[d.Left=-1]="Left",d[d.Mid=0]="Mid",d[d.Right=1]="Right"})(R||(R={}));class y{static forUris(E=()=>!1,p=()=>!1){return new y(new D(E,p))}static forPaths(E=!1){return new y(new F(void 0,!E))}static forStrings(){return new y(new C)}static forConfigKeys(){return new y(new M)}constructor(E){this._iter=E}clear(){this._root=void 0}fill(E,p){if(p){const l=p.slice(0);(0,m.shuffle)(l);for(const t of l)this.set(t,E)}else{const l=E.slice(0);(0,m.shuffle)(l);for(const t of l)this.set(t[0],t[1])}}set(E,p){const l=this._iter.reset(E);let t;this._root||(this._root=new g,this._root.segment=l.value());const r=[];for(t=this._root;;){const b=l.cmp(t.segment);if(b>0)t.left||(t.left=new g,t.left.segment=l.value()),r.push([-1,t]),t=t.left;else if(b<0)t.right||(t.right=new g,t.right.segment=l.value()),r.push([1,t]),t=t.right;else if(l.hasNext())l.next(),t.mid||(t.mid=new g,t.mid.segment=l.value()),r.push([0,t]),t=t.mid;else break}const c=t.value;t.value=p,t.key=E;for(let b=r.length-1;b>=0;b--){const w=r[b][1];w.updateHeight();const _=w.balanceFactor();if(_<-1||_>1){const i=r[b][0],u=r[b+1][0];if(i===1&&u===1)r[b][1]=w.rotateLeft();else if(i===-1&&u===-1)r[b][1]=w.rotateRight();else if(i===1&&u===-1)w.right=r[b+1][1]=r[b+1][1].rotateRight(),r[b][1]=w.rotateLeft();else if(i===-1&&u===1)w.left=r[b+1][1]=r[b+1][1].rotateLeft(),r[b][1]=w.rotateRight();else throw new Error;if(b>0)switch(r[b-1][0]){case-1:r[b-1][1].left=r[b][1];break;case 1:r[b-1][1].right=r[b][1];break;case 0:r[b-1][1].mid=r[b][1];break}else this._root=r[0][1]}}return c}get(E){return this._getNode(E)?.value}_getNode(E){const p=this._iter.reset(E);let l=this._root;for(;l;){const t=p.cmp(l.segment);if(t>0)l=l.left;else if(t<0)l=l.right;else if(p.hasNext())p.next(),l=l.mid;else break}return l}has(E){const p=this._getNode(E);return!(p?.value===void 0&&p?.mid===void 0)}delete(E){return this._delete(E,!1)}deleteSuperstr(E){return this._delete(E,!0)}_delete(E,p){const l=this._iter.reset(E),t=[];let r=this._root;for(;r;){const c=l.cmp(r.segment);if(c>0)t.push([-1,r]),r=r.left;else if(c<0)t.push([1,r]),r=r.right;else if(l.hasNext())l.next(),t.push([0,r]),r=r.mid;else break}if(r){if(p?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const c=this._min(r.right);if(c.key){const{key:b,value:w,segment:_}=c;this._delete(c.key,!1),r.key=b,r.value=w,r.segment=_}}else{const c=r.left??r.right;if(t.length>0){const[b,w]=t[t.length-1];switch(b){case-1:w.left=c;break;case 0:w.mid=c;break;case 1:w.right=c;break}}else this._root=c}for(let c=t.length-1;c>=0;c--){const b=t[c][1];b.updateHeight();const w=b.balanceFactor();if(w>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),t[c][1]=b.rotateLeft()):w<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),t[c][1]=b.rotateRight()),c>0)switch(t[c-1][0]){case-1:t[c-1][1].left=t[c][1];break;case 1:t[c-1][1].right=t[c][1];break;case 0:t[c-1][1].mid=t[c][1];break}else this._root=t[0][1]}}}_min(E){for(;E.left;)E=E.left;return E}findSubstr(E){const p=this._iter.reset(E);let l=this._root,t;for(;l;){const r=p.cmp(l.segment);if(r>0)l=l.left;else if(r<0)l=l.right;else if(p.hasNext())p.next(),t=l.value||t,l=l.mid;else break}return l&&l.value||t}findSuperstr(E){return this._findSuperstrOrElement(E,!1)}_findSuperstrOrElement(E,p){const l=this._iter.reset(E);let t=this._root;for(;t;){const r=l.cmp(t.segment);if(r>0)t=t.left;else if(r<0)t=t.right;else if(l.hasNext())l.next(),t=t.mid;else return t.mid?this._entries(t.mid):p?t.value:void 0}}hasElementOrSubtree(E){return this._findSuperstrOrElement(E,!0)!==void 0}forEach(E){for(const[p,l]of this)E(l,p)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(E){const p=[];return this._dfsEntries(E,p),p[Symbol.iterator]()}_dfsEntries(E,p){E&&(E.left&&this._dfsEntries(E.left,p),E.value&&p.push([E.key,E.value]),E.mid&&this._dfsEntries(E.mid,p),E.right&&this._dfsEntries(E.right,p))}_isBalanced(){const E=p=>{if(!p)return!0;const l=p.balanceFactor();return l<-1||l>1?!1:E(p.left)&&E(p.right)};return E(this._root)}}e.TernarySearchTree=y}),define(Ae[40],Re([1,0,89]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var k;(function(F){function f(D){return D&&typeof D=="object"&&typeof D.id=="string"}F.isThemeColor=f})(k||(e.ThemeColor=k={}));function C(F){return{id:F}}e.themeColorFromId=C;var M;(function(F){F.iconNameSegment="[A-Za-z0-9]+",F.iconNameExpression="[A-Za-z0-9-]+",F.iconModifierExpression="~[A-Za-z]+",F.iconNameCharacter="[A-Za-z0-9~-]";const f=new RegExp(`^(${F.iconNameExpression})(${F.iconModifierExpression})?$`);function D(c){const b=f.exec(c.id);if(!b)return D(m.Codicon.error);const[,w,_]=b,i=["codicon","codicon-"+w];return _&&i.push("codicon-modifier-"+_.substring(1)),i}F.asClassNameArray=D;function g(c){return D(c).join(" ")}F.asClassName=g;function R(c){return"."+D(c).join(".")}F.asCSSSelector=R;function y(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||k.isThemeColor(c.color))}F.isThemeIcon=y;const d=new RegExp(`^\\$\\((${F.iconNameExpression}(?:${F.iconModifierExpression})?)\\)$`);function E(c){const b=d.exec(c);if(!b)return;const[,w]=b;return{id:w}}F.fromString=E;function p(c){return{id:c}}F.fromId=p;function l(c,b){let w=c.id;const _=w.lastIndexOf("~");return _!==-1&&(w=w.substring(0,_)),b&&(w=`${w}~${b}`),{id:w}}F.modify=l;function t(c){const b=c.id.lastIndexOf("~");if(b!==-1)return c.id.substring(b+1)}F.getModifier=t;function r(c,b){return c.id===b.id&&c.color?.id===b.color?.id}F.isEqual=r})(M||(e.ThemeIcon=M={}))}),define(Ae[121],Re([1,0,119,13,40]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const M="$(",F=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),f=new RegExp(`(\\\\)?${F.source}`,"g");function D(r){return r.replace(f,(c,b)=>b?c:`\\${c}`)}e.escapeIcons=D;const g=new RegExp(`\\\\${F.source}`,"g");function R(r){return r.replace(g,c=>`\\${c}`)}e.markdownEscapeEscapedIcons=R;const y=new RegExp(`(\\s)?(\\\\)?${F.source}(\\s)?`,"g");function d(r){return r.indexOf(M)===-1?r:r.replace(y,(c,b,w,_)=>w?c:b||_||"")}e.stripIcons=d;function E(r){return r?r.replace(/\$\((.*?)\)/g,(c,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=E;const p=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(r){p.lastIndex=0;let c="";const b=[];let w=0;for(;;){const _=p.lastIndex,i=p.exec(r),u=r.substring(_,i?.index);if(u.length>0){c+=u;for(let n=0;n<u.length;n++)b.push(w)}if(!i)break;w+=i[0].length}return{text:c,iconOffsets:b}}e.parseLabelWithIcons=l;function t(r,c,b=!1){const{text:w,iconOffsets:_}=c;if(!_||_.length===0)return(0,m.matchesFuzzy)(r,w,b);const i=(0,k.ltrim)(w," "),u=w.length-i.length,n=(0,m.matchesFuzzy)(r,i,b);if(n)for(const s of n){const v=_[s.start+u]+u;s.start+=v,s.end+=v}return n}e.matchesFuzzyIconAware=t}),define(Ae[36],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(C){return m.test(C)}e.isUUID=k,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(f){for(let D=0;D<f.length;D++)f[D]=Math.floor(Math.random()*256);return f};const M=new Uint8Array(16),F=[];for(let f=0;f<256;f++)F.push(f.toString(16).padStart(2,"0"));return function(){C(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let D=0,g="";return g+=F[M[D++]],g+=F[M[D++]],g+=F[M[D++]],g+=F[M[D++]],g+="-",g+=F[M[D++]],g+=F[M[D++]],g+="-",g+=F[M[D++]],g+=F[M[D++]],g+="-",g+=F[M[D++]],g+=F[M[D++]],g+="-",g+=F[M[D++]],g+=F[M[D++]],g+=F[M[D++]],g+=F[M[D++]],g+=F[M[D++]],g+=F[M[D++]],g}}()}),define(Ae[122],Re([1,0,18,67,36]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function M(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}e.createStringDataTransferItem=M;function F(y,d,E){const p={id:(0,C.generateUuid)(),name:y,uri:d,data:E};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.createFileDataTransferItem=F;class f{constructor(){this._entries=new Map}get size(){let d=0;for(const E of this._entries)d++;return d}has(d){return this._entries.has(this.toKey(d))}matches(d){const E=[...this._entries.keys()];return k.Iterable.some(this,([p,l])=>l.asFile())&&E.push("files"),R(D(d),E)}get(d){return this._entries.get(this.toKey(d))?.[0]}append(d,E){const p=this._entries.get(d);p?p.push(E):this._entries.set(this.toKey(d),[E])}replace(d,E){this._entries.set(this.toKey(d),[E])}delete(d){this._entries.delete(this.toKey(d))}*[Symbol.iterator](){for(const[d,E]of this._entries)for(const p of E)yield[d,p]}toKey(d){return D(d)}}e.VSDataTransfer=f;function D(y){return y.toLowerCase()}function g(y,d){return R(D(y),d.map(D))}e.matchesMimeType=g;function R(y,d){if(y==="*/*")return d.length>0;if(d.includes(y))return!0;const E=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[p,l,t]=E;return t==="*"?d.some(r=>r.startsWith(l+"/")):!1}e.UriList=Object.freeze({create:y=>(0,m.distinct)(y.map(d=>d.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.UriList.split(y).filter(d=>!d.startsWith("#"))})}),define(Ae[123],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[124],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(F){F[F.None=0]="None",F[F.Indent=1]="Indent",F[F.IndentOutdent=2]="IndentOutdent",F[F.Outdent=3]="Outdent"})(m||(e.IndentAction=m={}));class k{constructor(f){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=f.open,this.close=f.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(f.notIn))for(let D=0,g=f.notIn.length;D<g;D++)switch(f.notIn[D]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(f){switch(f){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(f,D){if(f.getTokenCount()===0)return!0;const g=f.findTokenIndexAtOffset(D-2),R=f.getStandardTokenType(g);return this.isOK(R)}_findNeutralCharacterInRange(f,D){for(let g=f;g<=D;g++){const R=String.fromCharCode(g);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=k;class C{constructor(f){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of f)M(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),M(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),M(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),M(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&M(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=C;function M(F,f,D){F.has(f)?F.get(f).push(D):F.set(f,[D])}}),define(Ae[125],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class m{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(M){if(M&&this._dragOperations.has(M)){const F=this._dragOperations.get(M);return this._dragOperations.delete(M),F}}addDragOperationTransfer(M,F){this._dragOperations.set(M,F)}}e.TreeViewsDnDService=m;class k{constructor(M){this.identifier=M}}e.DraggedTreeItemsIdentifier=k}),define(Ae[126],Re([11,12]),function(te,e){return te.create("vs/base/common/actions",e)}),define(Ae[127],Re([1,0,5,6,126]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class M extends k.Disposable{constructor(d,E="",p="",l=!0,t){super(),this._onDidChange=this._register(new m.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=d,this._label=E,this._cssClass=p,this._enabled=l,this._actionCallback=t}get id(){return this._id}get label(){return this._label}set label(d){this._setLabel(d)}_setLabel(d){this._label!==d&&(this._label=d,this._onDidChange.fire({label:d}))}get tooltip(){return this._tooltip||""}set tooltip(d){this._setTooltip(d)}_setTooltip(d){this._tooltip!==d&&(this._tooltip=d,this._onDidChange.fire({tooltip:d}))}get class(){return this._cssClass}set class(d){this._setClass(d)}_setClass(d){this._cssClass!==d&&(this._cssClass=d,this._onDidChange.fire({class:d}))}get enabled(){return this._enabled}set enabled(d){this._setEnabled(d)}_setEnabled(d){this._enabled!==d&&(this._enabled=d,this._onDidChange.fire({enabled:d}))}get checked(){return this._checked}set checked(d){this._setChecked(d)}_setChecked(d){this._checked!==d&&(this._checked=d,this._onDidChange.fire({checked:d}))}async run(d,E){this._actionCallback&&await this._actionCallback(d)}}e.Action=M;class F extends k.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new m.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new m.Emitter),this.onDidRun=this._onDidRun.event}async run(d,E){if(!d.enabled)return;this._onWillRun.fire({action:d});let p;try{await this.runAction(d,E)}catch(l){p=l}this._onDidRun.fire({action:d,error:p})}async runAction(d,E){await d.run(E)}}e.ActionRunner=F;class f{constructor(){this.id=f.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...d){let E=[];for(const p of d)p.length&&(E.length?E=[...E,new f,...p]:E=p);return E}async run(){}}e.Separator=f,f.ID="vs.actions.separator";class D{get actions(){return this._actions}constructor(d,E,p,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=d,this.label=E,this.class=l,this._actions=p}async run(){}}e.SubmenuAction=D;class g extends M{constructor(){super(g.ID,C.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=g,g.ID="vs.actions.empty";function R(y){return{id:y.id,label:y.label,class:void 0,enabled:y.enabled??!0,checked:y.checked??!1,run:async()=>y.run(),tooltip:y.label}}e.toAction=R}),define(Ae[128],Re([11,12]),function(te,e){return te.create("vs/base/common/date",e)}),define(Ae[129],Re([1,0,128]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,C=k*60,M=C*24,F=M*7,f=M*30,D=M*365;function g(y,d,E,p){typeof y!="number"&&(y=y.getTime());const l=Math.round((new Date().getTime()-y)/1e3);if(l<-30)return(0,m.localize)(0,null,g(new Date().getTime()+l*1e3,!1));if(!p&&l<30)return(0,m.localize)(1,null);let t;return l<k?(t=l,d?t===1?E?(0,m.localize)(2,null,t):(0,m.localize)(3,null,t):E?(0,m.localize)(4,null,t):(0,m.localize)(5,null,t):t===1?E?(0,m.localize)(6,null,t):(0,m.localize)(7,null,t):E?(0,m.localize)(8,null,t):(0,m.localize)(9,null,t)):l<C?(t=Math.floor(l/k),d?t===1?E?(0,m.localize)(10,null,t):(0,m.localize)(11,null,t):E?(0,m.localize)(12,null,t):(0,m.localize)(13,null,t):t===1?E?(0,m.localize)(14,null,t):(0,m.localize)(15,null,t):E?(0,m.localize)(16,null,t):(0,m.localize)(17,null,t)):l<M?(t=Math.floor(l/C),d?t===1?E?(0,m.localize)(18,null,t):(0,m.localize)(19,null,t):E?(0,m.localize)(20,null,t):(0,m.localize)(21,null,t):t===1?E?(0,m.localize)(22,null,t):(0,m.localize)(23,null,t):E?(0,m.localize)(24,null,t):(0,m.localize)(25,null,t)):l<F?(t=Math.floor(l/M),d?t===1?(0,m.localize)(26,null,t):(0,m.localize)(27,null,t):t===1?(0,m.localize)(28,null,t):(0,m.localize)(29,null,t)):l<f?(t=Math.floor(l/F),d?t===1?E?(0,m.localize)(30,null,t):(0,m.localize)(31,null,t):E?(0,m.localize)(32,null,t):(0,m.localize)(33,null,t):t===1?E?(0,m.localize)(34,null,t):(0,m.localize)(35,null,t):E?(0,m.localize)(36,null,t):(0,m.localize)(37,null,t)):l<D?(t=Math.floor(l/f),d?t===1?E?(0,m.localize)(38,null,t):(0,m.localize)(39,null,t):E?(0,m.localize)(40,null,t):(0,m.localize)(41,null,t):t===1?E?(0,m.localize)(42,null,t):(0,m.localize)(43,null,t):E?(0,m.localize)(44,null,t):(0,m.localize)(45,null,t)):(t=Math.floor(l/D),d?t===1?E?(0,m.localize)(46,null,t):(0,m.localize)(47,null,t):E?(0,m.localize)(48,null,t):(0,m.localize)(49,null,t):t===1?E?(0,m.localize)(50,null,t):(0,m.localize)(51,null,t):E?(0,m.localize)(52,null,t):(0,m.localize)(53,null,t))}e.fromNow=g;function R(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Ae[130],Re([11,12]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Ae[41],Re([1,0,18,10,130]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(y,d){return d&&(y.stack||y.stacktrace)?C.localize(0,null,f(y),F(y.stack)||F(y.stacktrace)):f(y)}function F(y){return Array.isArray(y)?y.join(`
`):y}function f(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?C.localize(1,null,y.message):y.message||C.localize(2,null)}function D(y=null,d=!1){if(!y)return C.localize(3,null);if(Array.isArray(y)){const E=m.coalesce(y),p=D(E[0],d);return E.length>1?C.localize(4,null,p,E.length):p}if(k.isString(y))return y;if(y.detail){const E=y.detail;if(E.error)return M(E.error,d);if(E.exception)return M(E.exception,d)}return y.stack?M(y,d):y.message?y.message:C.localize(5,null)}e.toErrorMessage=D;function g(y){const d=y;return d instanceof Error&&Array.isArray(d.actions)}e.isErrorWithActions=g;function R(y,d){let E;return typeof y=="string"?E=new Error(y):E=y,E.actions=d,E}e.createErrorWithActions=R}),define(Ae[131],Re([1,0,66,19]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new m.Lazy(()=>{const T=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:T,collatorIsNumeric:T.resolvedOptions().numeric}}),M=new m.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),F=new m.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function f(T,S,a=!1){const o=T||"",O=S||"",$=C.value.collator.compare(o,O);return C.value.collatorIsNumeric&&$===0&&o!==O?o<O?-1:1:$}e.compareFileNames=f;function D(T,S){const a=M.value.collator;return T=T||"",S=S||"",w(a,T,S)}e.compareFileNamesDefault=D;function g(T,S){const a=M.value.collator;return T=T||"",S=S||"",n(T,S)||w(a,T,S)}e.compareFileNamesUpper=g;function R(T,S){const a=M.value.collator;return T=T||"",S=S||"",u(T,S)||w(a,T,S)}e.compareFileNamesLower=R;function y(T,S){return T=T||"",S=S||"",T===S?0:T<S?-1:1}e.compareFileNamesUnicode=y;function d(T,S){const[a,o]=c(T),[O,$]=c(S);let K=C.value.collator.compare(o,$);if(K===0){if(C.value.collatorIsNumeric&&o!==$)return o<$?-1:1;if(K=C.value.collator.compare(a,O),C.value.collatorIsNumeric&&K===0&&a!==O)return a<O?-1:1}return K}e.compareFileExtensions=d;function E(T,S){T=T||"",S=S||"";const a=b(T),o=b(S),O=M.value.collator,$=F.value.collator;return w($,a,o)||w(O,T,S)}e.compareFileExtensionsDefault=E;function p(T,S){T=T||"",S=S||"";const a=b(T),o=b(S),O=M.value.collator,$=F.value.collator;return w($,a,o)||n(T,S)||w(O,T,S)}e.compareFileExtensionsUpper=p;function l(T,S){T=T||"",S=S||"";const a=b(T),o=b(S),O=M.value.collator,$=F.value.collator;return w($,a,o)||u(T,S)||w(O,T,S)}e.compareFileExtensionsLower=l;function t(T,S){T=T||"",S=S||"";const a=b(T).toLowerCase(),o=b(S).toLowerCase();return a!==o?a<o?-1:1:T!==S?T<S?-1:1:0}e.compareFileExtensionsUnicode=t;const r=/^(.*?)(\.([^.]*))?$/;function c(T,S=!1){const a=T?r.exec(T):[];let o=[a&&a[1]||"",a&&a[3]||""];return S&&(!o[0]&&o[1]||o[0]&&o[0].charAt(0)===".")&&(o=[o[0]+"."+o[1],""]),o}function b(T){const S=T?r.exec(T):[];return S&&S[1]&&S[1].charAt(0)!=="."&&S[3]||""}function w(T,S,a){const o=T.compare(S,a);return o!==0?o:S.length!==a.length?S.length<a.length?-1:1:0}function _(T){const S=T.charAt(0);return S.toLocaleUpperCase()!==S}function i(T){const S=T.charAt(0);return S.toLocaleLowerCase()!==S}function u(T,S){return _(T)&&i(S)?-1:i(T)&&_(S)?1:0}function n(T,S){return i(T)&&_(S)?-1:_(T)&&i(S)?1:0}function s(T,S,a=!1){return a||(T=T&&T.toLowerCase(),S=S&&S.toLowerCase()),T===S?0:T<S?-1:1}function v(T,S,a=!1){const o=T.split(k.sep),O=S.split(k.sep),$=o.length-1,K=O.length-1;let V,z;for(let N=0;;N++){if(V=$===N,z=K===N,V&&z)return f(o[N],O[N],a);if(V)return-1;if(z)return 1;const q=s(o[N],O[N],a);if(q!==0)return q}}e.comparePaths=v;function I(T,S,a){const o=T.toLowerCase(),O=S.toLowerCase(),$=h(T,S,a);if($)return $;const K=o.endsWith(a),V=O.endsWith(a);if(K!==V)return K?-1:1;const z=f(o,O);return z!==0?z:o.localeCompare(O)}e.compareAnything=I;function h(T,S,a){const o=T.toLowerCase(),O=S.toLowerCase(),$=o.startsWith(a),K=O.startsWith(a);if($!==K)return $?-1:1;if($&&K){if(o.length<O.length)return-1;if(o.length>O.length)return 1}return 0}e.compareByPrefix=h}),define(Ae[42],Re([1,0,19,21,13,10]),function(te,e,m,k,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function F(I){return I===47||I===92}e.isPathSeparator=F;function f(I){return I.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=f;function D(I){return I.indexOf("/")===-1&&(I=f(I)),/^[a-zA-Z]:(\/|$)/.test(I)&&(I="/"+I),I}e.toPosixPath=D;function g(I,h=m.posix.sep){if(!I)return"";const T=I.length,S=I.charCodeAt(0);if(F(S)){if(F(I.charCodeAt(1))&&!F(I.charCodeAt(2))){let o=3;const O=o;for(;o<T&&!F(I.charCodeAt(o));o++);if(O!==o&&!F(I.charCodeAt(o+1))){for(o+=1;o<T;o++)if(F(I.charCodeAt(o)))return I.slice(0,o+1).replace(/[\\/]/g,h)}}return h}else if(r(S)&&I.charCodeAt(1)===58)return F(I.charCodeAt(2))?I.slice(0,2)+h:I.slice(0,2);let a=I.indexOf("://");if(a!==-1){for(a+=3;a<T;a++)if(F(I.charCodeAt(a)))return I.slice(0,a+1)}return""}e.getRoot=g;function R(I){if(!k.isWindows||!I||I.length<5)return!1;let h=I.charCodeAt(0);if(h!==92||(h=I.charCodeAt(1),h!==92))return!1;let T=2;const S=T;for(;T<I.length&&(h=I.charCodeAt(T),h!==92);T++);return!(S===T||(h=I.charCodeAt(T+1),isNaN(h)||h===92))}e.isUNC=R;const y=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(I,h=k.isWindows){const T=h?y:d;return!(!I||I.length===0||/^\s+$/.test(I)||(T.lastIndex=0,T.test(I))||h&&E.test(I)||I==="."||I===".."||h&&I[I.length-1]==="."||h&&I.length!==I.trim().length||I.length>255)}e.isValidBasename=p;function l(I,h,T){const S=I===h;return!T||S?S:!I||!h?!1:(0,C.equalsIgnoreCase)(I,h)}e.isEqual=l;function t(I,h,T,S=m.sep){if(I===h)return!0;if(!I||!h||h.length>I.length)return!1;if(T){if(!(0,C.startsWithIgnoreCase)(I,h))return!1;if(h.length===I.length)return!0;let o=h.length;return h.charAt(h.length-1)===S&&o--,I.charAt(o)===S}return h.charAt(h.length-1)!==S&&(h+=S),I.indexOf(h)===0}e.isEqualOrParent=t;function r(I){return I>=65&&I<=90||I>=97&&I<=122}e.isWindowsDriveLetter=r;function c(I,h){return k.isWindows&&I.endsWith(":")&&(I+=m.sep),(0,m.isAbsolute)(I)||(I=(0,m.join)(h,I)),I=(0,m.normalize)(I),k.isWindows?(I=(0,C.rtrim)(I,m.sep),I.endsWith(":")&&(I+=m.sep)):(I=(0,C.rtrim)(I,m.sep),I||(I=m.sep)),I}e.sanitizeFilePath=c;function b(I){const h=(0,m.normalize)(I);return k.isWindows?I.length>3?!1:w(h)&&(I.length===2||h.charCodeAt(2)===92):h===m.posix.sep}e.isRootOrDriveLetter=b;function w(I,h=k.isWindows){return h?r(I.charCodeAt(0))&&I.charCodeAt(1)===58:!1}e.hasDriveLetter=w;function _(I,h=k.isWindows){return w(I,h)?I[0]:void 0}e.getDriveLetter=_;function i(I,h,T){return h.length>I.length?-1:I===h?0:(T&&(I=I.toLowerCase(),h=h.toLowerCase()),I.indexOf(h))}e.indexOfPath=i;function u(I){const h=I.split(":");let T,S,a;for(const o of h){const O=Number(o);(0,M.isNumber)(O)?S===void 0?S=O:a===void 0&&(a=O):T=T?[T,o].join(":"):o}if(!T)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:T,line:S!==void 0?S:void 0,column:a!==void 0?a:S!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(I,h,T=8){let S="";for(let o=0;o<T;o++){let O;o===0&&k.isWindows&&!h&&(T===3||T===4)?O=s:O=n,S+=O.charAt(Math.floor(Math.random()*O.length))}let a;return h?a=`${h}-${S}`:a=S,I?(0,m.join)(I,a):a}e.randomPath=v}),define(Ae[68],Re([1,0,19]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(R){const y=(0,m.extname)(R),d=k[y.toLowerCase()];return d!==void 0?d:F(R)}e.getMediaOrTextMime=M;function F(R){const y=(0,m.extname)(R);return C[y.toLowerCase()]}e.getMediaMime=F;function f(R){for(const y in C)if(C[y]===R)return y}e.getExtensionForMimeType=f;const D=/^(.+)\/(.+?)(;.+)?$/;function g(R,y){const d=D.exec(R);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:y?void 0:R}e.normalizeMimeType=g}),define(Ae[69],Re([1,0,25,13,2]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(g){return JSON.stringify(g,f)}e.stringify=M;function F(g){let R=JSON.parse(g);return R=D(R),R}e.parse=F;function f(g,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,k.regExpFlags)(R)}:R}function D(g,R=0){if(!g||R>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return C.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 16:return new Date(g.source)}if(g instanceof m.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let y=0;y<g.length;++y)g[y]=D(g[y],R+1);else for(const y in g)Object.hasOwnProperty.call(g,y)&&(g[y]=D(g[y],R+1))}return g}e.revive=D}),define(Ae[14],Re([1,0,9,21,2]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class F{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(R){this._preferredWebSchema=R}setDelegate(R){this._delegate=R}setServerRootPath(R){this._remoteResourcesPath=`${R}/${M.vscodeRemoteResource}`}set(R,y,d){this._hosts[R]=y,this._ports[R]=d}setConnectionToken(R,y){this._connectionTokens[R]=y}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(R){if(this._delegate)try{return this._delegate(R)}catch(t){return m.onUnexpectedError(t),R}const y=R.authority;let d=this._hosts[y];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const E=this._ports[y],p=this._connectionTokens[y];let l=`path=${encodeURIComponent(R.path)}`;return typeof p=="string"&&(l+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),C.URI.from({scheme:k.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${d}:${E}`,path:this._remoteResourcesPath,query:l})}}e.RemoteAuthorities=new F,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class f{asBrowserUri(R){const y=this.toUri(R,te);return this.uriToBrowserUri(y)}uriToBrowserUri(R){return R.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===M.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${M.vscodeFileResource}://${f.FALLBACK_AUTHORITY}`)?R.with({scheme:M.vscodeFileResource,authority:R.authority||f.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(R){const y=this.toUri(R,te);return this.uriToFileUri(y)}uriToFileUri(R){return R.scheme===M.vscodeFileResource?R.with({scheme:M.file,authority:R.authority!==f.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(R,y){return C.URI.isUri(R)?R:C.URI.parse(y.toUrl(R))}}f.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new f;var D;(function(g){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(R.get("3"));const y="vscode-coi";function d(p){let l;typeof p=="string"?l=new URL(p).searchParams:p instanceof URL?l=p.searchParams:C.URI.isUri(p)&&(l=new URL(p.toString(!0)).searchParams);const t=l?.get(y);if(t)return R.get(t)}g.getHeadersFromQuery=d;function E(p,l,t){if(!globalThis.crossOriginIsolated)return;const r=l&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(y,r):p[y]=r}g.addSearchParam=E})(D||(e.COI=D={}))}),define(Ae[20],Re([1,0,42,14,19,21,13,2]),function(te,e,m,k,C,M,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(E){return(0,f.uriToFsPath)(E,!0)}e.originalFSPath=D;class g{constructor(p){this._ignorePathCasing=p}compare(p,l,t=!1){return p===l?0:(0,F.compare)(this.getComparisonKey(p,t),this.getComparisonKey(l,t))}isEqual(p,l,t=!1){return p===l?!0:!p||!l?!1:this.getComparisonKey(p,t)===this.getComparisonKey(l,t)}getComparisonKey(p,l=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,l,t=!1){if(p.scheme===l.scheme){if(p.scheme===k.Schemas.file)return m.isEqualOrParent(D(p),D(l),this._ignorePathCasing(p))&&p.query===l.query&&(t||p.fragment===l.fragment);if((0,e.isEqualAuthority)(p.authority,l.authority))return m.isEqualOrParent(p.path,l.path,this._ignorePathCasing(p),"/")&&p.query===l.query&&(t||p.fragment===l.fragment)}return!1}joinPath(p,...l){return f.URI.joinPath(p,...l)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return C.posix.basename(p.path)}extname(p){return C.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let l;return p.scheme===k.Schemas.file?l=f.URI.file(C.dirname(D(p))).path:(l=C.posix.dirname(p.path),p.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),l="/")),p.with({path:l})}normalizePath(p){if(!p.path.length)return p;let l;return p.scheme===k.Schemas.file?l=f.URI.file(C.normalize(D(p))).path:l=C.posix.normalize(p.path),p.with({path:l})}relativePath(p,l){if(p.scheme!==l.scheme||!(0,e.isEqualAuthority)(p.authority,l.authority))return;if(p.scheme===k.Schemas.file){const c=C.relative(D(p),D(l));return M.isWindows?m.toSlashes(c):c}let t=p.path||"/";const r=l.path||"/";if(this._ignorePathCasing(p)){let c=0;for(const b=Math.min(t.length,r.length);c<b&&!(t.charCodeAt(c)!==r.charCodeAt(c)&&t.charAt(c).toLowerCase()!==r.charAt(c).toLowerCase());c++);t=r.substr(0,c)+t.substr(c)}return C.posix.relative(t,r)}resolvePath(p,l){if(p.scheme===k.Schemas.file){const t=f.URI.file(C.resolve(D(p),l));return p.with({authority:t.authority,path:t.path})}return l=m.toPosixPath(l),p.with({path:C.posix.resolve(p.path,l)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,l){return p===l||p!==void 0&&l!==void 0&&(0,F.equalsIgnoreCase)(p,l)}hasTrailingPathSeparator(p,l=C.sep){if(p.scheme===k.Schemas.file){const t=D(p);return t.length>m.getRoot(t).length&&t[t.length-1]===l}else{const t=p.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,l=C.sep){return(0,e.hasTrailingPathSeparator)(p,l)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,l=C.sep){let t=!1;if(p.scheme===k.Schemas.file){const r=D(p);t=r!==void 0&&r.length===m.getRoot(r).length&&r[r.length-1]===l}else{l="/";const r=p.path;t=r.length===1&&r.charCodeAt(r.length-1)===47}return!t&&!(0,e.hasTrailingPathSeparator)(p,l)?p.with({path:p.path+"/"}):p}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(E=>E.scheme===k.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new g(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(E,p){const l=[];for(let t=0;t<E.length;t++){const r=p(E[t]);E.some((c,b)=>b===t?!1:(0,e.isEqualOrParent)(r,p(c)))||l.push(E[t])}return l}e.distinctParents=R;var y;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function p(l){const t=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(b=>{const[w,_]=b.split(":");w&&_&&t.set(w,_)});const c=l.path.substring(0,l.path.indexOf(";"));return c&&t.set(E.META_DATA_MIME,c),t}E.parseMetaData=p})(y||(e.DataUri=y={}));function d(E,p,l){if(p){let t=E.path;return t&&t[0]!==C.posix.sep&&(t=C.posix.sep+t),E.with({scheme:l,authority:p,path:t})}return E.with({scheme:l})}e.toLocalResource=d}),define(Ae[16],Re([1,0,22,9,5,6,20,21,120]),function(te,e,m,k,C,M,F,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(ge){return!!ge&&typeof ge.then=="function"}e.isThenable=g;function R(ge){const A=new m.CancellationTokenSource,G=ge(A.token),de=new Promise((ye,_e)=>{const pe=A.token.onCancellationRequested(()=>{pe.dispose(),A.dispose(),_e(new k.CancellationError)});Promise.resolve(G).then(Ce=>{pe.dispose(),A.dispose(),ye(Ce)},Ce=>{pe.dispose(),A.dispose(),_e(Ce)})});return new class{cancel(){A.cancel()}then(ye,_e){return de.then(ye,_e)}catch(ye){return this.then(void 0,ye)}finally(ye){return de.finally(ye)}}}e.createCancelablePromise=R;function y(ge,A,G){return new Promise((de,ye)=>{const _e=A.onCancellationRequested(()=>{_e.dispose(),de(G)});ge.then(de,ye).finally(()=>_e.dispose())})}e.raceCancellation=y;function d(ge,A){return new Promise((G,de)=>{const ye=A.onCancellationRequested(()=>{ye.dispose(),de(new k.CancellationError)});ge.then(G,de).finally(()=>ye.dispose())})}e.raceCancellationError=d;async function E(ge){let A=-1;const G=ge.map((de,ye)=>de.then(_e=>(A=ye,_e)));try{return await Promise.race(G)}finally{ge.forEach((de,ye)=>{ye!==A&&de.cancel()})}}e.raceCancellablePromises=E;function p(ge,A,G){let de;const ye=setTimeout(()=>{de?.(void 0),G?.()},A);return Promise.race([ge.finally(()=>clearTimeout(ye)),new Promise(_e=>de=_e)])}e.raceTimeout=p;function l(ge){return new Promise((A,G)=>{const de=ge();g(de)?de.then(A,G):A(de)})}e.asPromise=l;class t{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.isDisposed)throw new Error("Throttler is disposed");if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const G=()=>{if(this.queuedPromise=null,this.isDisposed)return;const de=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,de};this.queuedPromise=new Promise(de=>{this.activePromise.then(G,G).then(de)})}return new Promise((G,de)=>{this.queuedPromise.then(G,de)})}return this.activePromise=A(),new Promise((G,de)=>{this.activePromise.then(ye=>{this.activePromise=null,G(ye)},ye=>{this.activePromise=null,de(ye)})})}dispose(){this.isDisposed=!0}}e.Throttler=t;class r{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=r;class c{constructor(){this.promiseMap=new Map}queue(A,G){const ye=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.promiseMap.get(A)===ye&&this.promiseMap.delete(A)});return this.promiseMap.set(A,ye),ye}}e.SequencerByKey=c;const b=(ge,A)=>{let G=!0;const de=setTimeout(()=>{G=!1,A()},ge);return{isTriggered:()=>G,dispose:()=>{clearTimeout(de),G=!1}}},w=ge=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,ge())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};class _{constructor(A){this.defaultDelay=A,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,G=this.defaultDelay){this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ye,_e)=>{this.doResolve=ye,this.doReject=_e}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ye=this.task;return this.task=null,ye()}}));const de=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=G===D.MicrotaskDelay?w(de):b(G,de),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new k.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=_;class i{constructor(A){this.delayer=new _(A),this.throttler=new t}trigger(A,G){return this.delayer.trigger(()=>this.throttler.queue(A),G)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=i;class u{constructor(){this._isOpen=!1,this._promise=new Promise((A,G)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class n extends u{constructor(A){super(),this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=n;function s(ge,A){return A?new Promise((G,de)=>{const ye=setTimeout(()=>{_e.dispose(),G()},ge),_e=A.onCancellationRequested(()=>{clearTimeout(ye),_e.dispose(),de(new k.CancellationError)})}):R(G=>s(ge,G))}e.timeout=s;function v(ge,A=0){const G=setTimeout(ge,A);return(0,M.toDisposable)(()=>clearTimeout(G))}e.disposableTimeout=v;function I(ge){const A=[];let G=0;const de=ge.length;function ye(){return G<de?ge[G++]():null}function _e(pe){pe!=null&&A.push(pe);const Ce=ye();return Ce?Ce.then(_e):Promise.resolve(A)}return Promise.resolve(null).then(_e)}e.sequence=I;function h(ge,A=de=>!!de,G=null){let de=0;const ye=ge.length,_e=()=>{if(de>=ye)return Promise.resolve(G);const pe=ge[de++];return Promise.resolve(pe()).then(ae=>A(ae)?Promise.resolve(ae):_e())};return _e()}e.first=h;function T(ge,A=de=>!!de,G=null){if(ge.length===0)return Promise.resolve(G);let de=ge.length;const ye=()=>{de=-1;for(const _e of ge)_e.cancel?.()};return new Promise((_e,pe)=>{for(const Ce of ge)Ce.then(ae=>{--de>=0&&A(ae)?(ye(),_e(ae)):de===0&&_e(G)}).catch(ae=>{--de>=0&&(ye(),pe(ae))})})}e.firstParallel=T;class S{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new C.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(A){return this._size++,new Promise((G,de)=>{this.outstandingPromises.push({factory:A,c:G,e:de}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const G=A.factory();G.then(A.c,A.e),G.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=S;class a extends S{constructor(){super(1)}}e.Queue=a;class o{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new Pe;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,G=F.extUri){const de=G.getComparisonKey(A);let ye=this.queues.get(de);return ye||(ye=new a,C.Event.once(ye.onDrained)(()=>{ye?.dispose(),this.queues.delete(de),this.onDidQueueDrain()}),this.queues.set(de,ye)),ye}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=o;class O{constructor(A,G){this._token=-1,typeof A=="function"&&typeof G=="number"&&this.setIfNotSet(A,G)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,G){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},G)}setIfNotSet(A,G){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},G))}}e.TimeoutTimer=O;class ${constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,G){this.cancel(),this._token=setInterval(()=>{A()},G)}}e.IntervalTimer=$;class K{constructor(A,G){this.timeoutToken=-1,this.runner=A,this.timeout=G,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=K;class V{constructor(A,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=G,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=V;class z extends K{constructor(A,G){super(A,G),this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner?.(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class N extends M.Disposable{constructor(A,G){super(),this.options=A,this.handler=G,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.options.maxBufferedWork)return!1}else if(this.pending+A.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const G of A)this.pendingWork.push(G);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new K(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ge=>{(0,f.setTimeout0)(()=>{if(A)return;const G=Date.now()+15;ge(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,G-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(ge,A)=>{const G=requestIdleCallback(ge,typeof A=="number"?{timeout:A}:void 0);let de=!1;return{dispose(){de||(de=!0,cancelIdleCallback(G))}}}}();class q{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(G){this._error=G}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function B(ge,A,G){let de;for(let ye=0;ye<G;ye++)try{return await ge()}catch(_e){de=_e,await s(A)}throw de}e.retry=B;class U{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(A,G,de){return this._pending={taskId:A,cancel:()=>de?.(),promise:G},G.then(()=>this.donePending(A),()=>this.donePending(A)),G}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let G,de;const ye=new Promise((_e,pe)=>{G=_e,de=pe});this._next={run:A,promise:ye,promiseResolve:G,promiseReject:de}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=U;class le{constructor(A,G=()=>Date.now()){this.interval=A,this.nowFn=G,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=le;var ve;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(ve||(ve={}));class Pe{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((A,G)=>{this.completeCallback=A,this.errorCallback=G})}complete(A){return new Promise(G=>{this.completeCallback(A),this.outcome={outcome:0,value:A},G()})}error(A){return new Promise(G=>{this.errorCallback(A),this.outcome={outcome:1,value:A},G()})}cancel(){return this.error(new k.CancellationError)}}e.DeferredPromise=Pe;var J;(function(ge){async function A(de){let ye;const _e=await Promise.all(de.map(pe=>pe.then(Ce=>Ce,Ce=>{ye||(ye=Ce)})));if(typeof ye<"u")throw ye;return _e}ge.settled=A;function G(de){return new Promise(async(ye,_e)=>{try{await de(ye,_e)}catch(pe){_e(pe)}})}ge.withAsyncBody=G})(J||(e.Promises=J={}));var X;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(X||(X={}));class ce{static fromArray(A){return new ce(G=>{G.emitMany(A)})}static fromPromise(A){return new ce(async G=>{G.emitMany(await A)})}static fromPromises(A){return new ce(async G=>{await Promise.all(A.map(async de=>G.emitOne(await de)))})}static merge(A){return new ce(async G=>{await Promise.all(A.map(async de=>{for await(const ye of de)G.emitOne(ye)}))})}constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new C.Emitter,queueMicrotask(async()=>{const G={emitOne:de=>this.emitOne(de),emitMany:de=>this.emitMany(de),reject:de=>this.reject(de)};try{await Promise.resolve(A(G)),this.resolve()}catch(de){this.reject(de)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await C.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,G){return new ce(async de=>{for await(const ye of A)de.emitOne(G(ye))})}map(A){return ce.map(this,A)}static filter(A,G){return new ce(async de=>{for await(const ye of A)G(ye)&&de.emitOne(ye)})}filter(A){return ce.filter(this,A)}static coalesce(A){return ce.filter(A,G=>!!G)}coalesce(){return ce.coalesce(this)}static async toPromise(A){const G=[];for await(const de of A)G.push(de);return G}toPromise(){return ce.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}e.AsyncIterableObject=ce,ce.EMPTY=ce.fromArray([]);class De extends ce{constructor(A,G){super(G),this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=De;function ke(ge){const A=new m.CancellationTokenSource,G=ge(A.token);return new De(A,async de=>{const ye=A.token.onCancellationRequested(()=>{ye.dispose(),A.dispose(),de.reject(new k.CancellationError)});try{for await(const _e of G){if(A.token.isCancellationRequested)return;de.emitOne(_e)}ye.dispose(),A.dispose()}catch(_e){ye.dispose(),A.dispose(),de.reject(_e)}})}e.createCancelableAsyncIterable=ke}),define(Ae[37],Re([1,0,18,16,42,28,19,21,13]),function(te,e,m,k,C,M,F,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function g(){return Object.create(null)}e.getEmptyExpression=g,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",y="[^/\\\\]",d=/\//g;function E(le,ve){switch(le){case 0:return"";case 1:return`${y}*?`;default:return`(?:${R}|${y}+${R}${ve?`|${R}${y}+`:""})*?`}}function p(le,ve){if(!le)return[];const Pe=[];let J=!1,X=!1,ce="";for(const De of le){switch(De){case ve:if(!J&&!X){Pe.push(ce),ce="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":X=!0;break;case"]":X=!1;break}ce+=De}return ce&&Pe.push(ce),Pe}e.splitGlobAware=p;function l(le){if(!le)return"";let ve="";const Pe=p(le,e.GLOB_SPLIT);if(Pe.every(J=>J===e.GLOBSTAR))ve=".*";else{let J=!1;Pe.forEach((X,ce)=>{if(X===e.GLOBSTAR){if(J)return;ve+=E(2,ce===Pe.length-1)}else{let De=!1,ke="",ge=!1,A="";for(const G of X){if(G!=="}"&&De){ke+=G;continue}if(ge&&(G!=="]"||!A)){let de;G==="-"?de=G:(G==="^"||G==="!")&&!A?de="^":G===e.GLOB_SPLIT?de="":de=(0,D.escapeRegExpCharacters)(G),A+=de;continue}switch(G){case"{":De=!0;continue;case"[":ge=!0;continue;case"}":{const ye=`(?:${p(ke,",").map(_e=>l(_e)).join("|")})`;ve+=ye,De=!1,ke="";break}case"]":{ve+="["+A+"]",ge=!1,A="";break}case"?":ve+=y;continue;case"*":ve+=E(1);continue;default:ve+=(0,D.escapeRegExpCharacters)(G)}}ce<Pe.length-1&&(Pe[ce+1]!==e.GLOBSTAR||ce+2<Pe.length)&&(ve+=R)}J=X===e.GLOBSTAR})}return ve}const t=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,_=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.LRUCache(1e4),u=function(){return!1},n=function(){return null};function s(le,ve){if(!le)return n;let Pe;typeof le!="string"?Pe=le.pattern:Pe=le,Pe=Pe.trim();const J=`${Pe}_${!!ve.trimForExclusions}`;let X=i.get(J);if(X)return v(X,le);let ce;return t.test(Pe)?X=h(Pe.substr(4),Pe):(ce=r.exec(I(Pe,ve)))?X=T(ce[1],Pe):(ve.trimForExclusions?b:c).test(Pe)?X=S(Pe,ve):(ce=w.exec(I(Pe,ve)))?X=a(ce[1].substr(1),Pe,!0):(ce=_.exec(I(Pe,ve)))?X=a(ce[1],Pe,!1):X=o(Pe),i.set(J,X),v(X,le)}function v(le,ve){if(typeof ve=="string")return le;const Pe=function(J,X){return(0,C.isEqualOrParent)(J,ve.base,!f.isLinux)?le((0,D.ltrim)(J.substr(ve.base.length),F.sep),X):null};return Pe.allBasenames=le.allBasenames,Pe.allPaths=le.allPaths,Pe.basenames=le.basenames,Pe.patterns=le.patterns,Pe}function I(le,ve){return ve.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function h(le,ve){return function(Pe,J){return typeof Pe=="string"&&Pe.endsWith(le)?ve:null}}function T(le,ve){const Pe=`/${le}`,J=`\\${le}`,X=function(De,ke){return typeof De!="string"?null:ke?ke===le?ve:null:De===le||De.endsWith(Pe)||De.endsWith(J)?ve:null},ce=[le];return X.basenames=ce,X.patterns=[ve],X.allBasenames=ce,X}function S(le,ve){const Pe=B(le.slice(1,-1).split(",").map(ke=>s(ke,ve)).filter(ke=>ke!==n),le),J=Pe.length;if(!J)return n;if(J===1)return Pe[0];const X=function(ke,ge){for(let A=0,G=Pe.length;A<G;A++)if(Pe[A](ke,ge))return le;return null},ce=Pe.find(ke=>!!ke.allBasenames);ce&&(X.allBasenames=ce.allBasenames);const De=Pe.reduce((ke,ge)=>ge.allPaths?ke.concat(ge.allPaths):ke,[]);return De.length&&(X.allPaths=De),X}function a(le,ve,Pe){const J=F.sep===F.posix.sep,X=J?le:le.replace(d,F.sep),ce=F.sep+X,De=F.posix.sep+le;let ke;return Pe?ke=function(ge,A){return typeof ge=="string"&&(ge===X||ge.endsWith(ce)||!J&&(ge===le||ge.endsWith(De)))?ve:null}:ke=function(ge,A){return typeof ge=="string"&&(ge===X||!J&&ge===le)?ve:null},ke.allPaths=[(Pe?"*/":"./")+le],ke}function o(le){try{const ve=new RegExp(`^${l(le)}$`);return function(Pe){return ve.lastIndex=0,typeof Pe=="string"&&ve.test(Pe)?le:null}}catch{return n}}function O(le,ve,Pe){return!le||typeof ve!="string"?!1:$(le)(ve,void 0,Pe)}e.match=O;function $(le,ve={}){if(!le)return u;if(typeof le=="string"||K(le)){const Pe=s(le,ve);if(Pe===n)return u;const J=function(X,ce){return!!Pe(X,ce)};return Pe.allBasenames&&(J.allBasenames=Pe.allBasenames),Pe.allPaths&&(J.allPaths=Pe.allPaths),J}return N(le,ve)}e.parse=$;function K(le){const ve=le;return ve?typeof ve.base=="string"&&typeof ve.pattern=="string":!1}e.isRelativePattern=K;function V(le){return le.allBasenames||[]}e.getBasenameTerms=V;function z(le){return le.allPaths||[]}e.getPathTerms=z;function N(le,ve){const Pe=B(Object.getOwnPropertyNames(le).map(ke=>q(ke,le[ke],ve)).filter(ke=>ke!==n)),J=Pe.length;if(!J)return n;if(!Pe.some(ke=>!!ke.requiresSiblings)){if(J===1)return Pe[0];const ke=function(G,de){let ye;for(let _e=0,pe=Pe.length;_e<pe;_e++){const Ce=Pe[_e](G,de);if(typeof Ce=="string")return Ce;(0,k.isThenable)(Ce)&&(ye||(ye=[]),ye.push(Ce))}return ye?(async()=>{for(const _e of ye){const pe=await _e;if(typeof pe=="string")return pe}return null})():null},ge=Pe.find(G=>!!G.allBasenames);ge&&(ke.allBasenames=ge.allBasenames);const A=Pe.reduce((G,de)=>de.allPaths?G.concat(de.allPaths):G,[]);return A.length&&(ke.allPaths=A),ke}const X=function(ke,ge,A){let G,de;for(let ye=0,_e=Pe.length;ye<_e;ye++){const pe=Pe[ye];pe.requiresSiblings&&A&&(ge||(ge=(0,F.basename)(ke)),G||(G=ge.substr(0,ge.length-(0,F.extname)(ke).length)));const Ce=pe(ke,ge,G,A);if(typeof Ce=="string")return Ce;(0,k.isThenable)(Ce)&&(de||(de=[]),de.push(Ce))}return de?(async()=>{for(const ye of de){const _e=await ye;if(typeof _e=="string")return _e}return null})():null},ce=Pe.find(ke=>!!ke.allBasenames);ce&&(X.allBasenames=ce.allBasenames);const De=Pe.reduce((ke,ge)=>ge.allPaths?ke.concat(ge.allPaths):ke,[]);return De.length&&(X.allPaths=De),X}function q(le,ve,Pe){if(ve===!1)return n;const J=s(le,Pe);if(J===n)return n;if(typeof ve=="boolean")return J;if(ve){const X=ve.when;if(typeof X=="string"){const ce=(De,ke,ge,A)=>{if(!A||!J(De,ke))return null;const G=X.replace("$(basename)",()=>ge),de=A(G);return(0,k.isThenable)(de)?de.then(ye=>ye?le:null):de?le:null};return ce.requiresSiblings=!0,ce}}return J}function B(le,ve){const Pe=le.filter(ke=>!!ke.basenames);if(Pe.length<2)return le;const J=Pe.reduce((ke,ge)=>{const A=ge.basenames;return A?ke.concat(A):ke},[]);let X;if(ve){X=[];for(let ke=0,ge=J.length;ke<ge;ke++)X.push(ve)}else X=Pe.reduce((ke,ge)=>{const A=ge.patterns;return A?ke.concat(A):ke},[]);const ce=function(ke,ge){if(typeof ke!="string")return null;if(!ge){let G;for(G=ke.length;G>0;G--){const de=ke.charCodeAt(G-1);if(de===47||de===92)break}ge=ke.substr(G)}const A=J.indexOf(ge);return A!==-1?X[A]:null};ce.basenames=J,ce.patterns=X,ce.allBasenames=J;const De=le.filter(ke=>!ke.basenames);return De.push(ce),De}function U(le,ve){return(0,m.equals)(le,ve,(Pe,J)=>typeof Pe=="string"&&typeof J=="string"?Pe===J:typeof Pe!="string"&&typeof J!="string"?Pe.base===J.base&&Pe.pattern===J.pattern:!1)}e.patternsEquals=U}),define(Ae[70],Re([1,0,9,121,20,13,2]),function(te,e,m,k,C,M,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var f;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(f||(e.MarkdownStringTextNewlineStyle=f={}));class D{constructor(r="",c=!1){if(this.value=r,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(r,c=0){return this.value+=d(this.supportThemeIcons?(0,k.escapeIcons)(r):r).replace(/([ \t]+)/g,(b,w)=>"&nbsp;".repeat(w.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(r){return this.value+=r,this}appendCodeblock(r,c){return this.value+="\n```",this.value+=r,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(r,c,b){return this.value+="[",this.value+=this._escape(c,"]"),this.value+="](",this.value+=this._escape(String(r),")"),b&&(this.value+=` "${this._escape(this._escape(b,'"'),")")}"`),this.value+=")",this}_escape(r,c){const b=new RegExp((0,M.escapeRegExpCharacters)(c),"g");return r.replace(b,(w,_)=>r.charAt(_-1)!=="\\"?`\\${w}`:w)}}e.MarkdownString=D;function g(t){return R(t)?!t.value:Array.isArray(t)?t.every(g):!0}e.isEmptyMarkdownString=g;function R(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function y(t,r){return t===r?!0:!t||!r?!1:t.value===r.value&&t.isTrusted===r.isTrusted&&t.supportThemeIcons===r.supportThemeIcons&&t.supportHtml===r.supportHtml&&(t.baseUri===r.baseUri||!!t.baseUri&&!!r.baseUri&&(0,C.isEqual)(F.URI.from(t.baseUri),F.URI.from(r.baseUri)))}e.markdownStringEqual=y;function d(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=d;function E(t){return t.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=E;function p(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=p;function l(t){const r=[],c=t.split("|").map(w=>w.trim());t=c[0];const b=c[1];if(b){const w=/height=(\d+)/.exec(b),_=/width=(\d+)/.exec(b),i=w?w[1]:"",u=_?_[1]:"",n=isFinite(parseInt(u)),s=isFinite(parseInt(i));n&&r.push(`width="${u}"`),s&&r.push(`height="${i}"`)}return{href:t,dimensions:r}}e.parseHrefAndDimensions=l}),define(Ae[90],Re([1,0,18,42,19,21,20,13]),function(te,e,m,k,C,M,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function D(s,v){const{os:I,tildify:h,relative:T}=v;if(T){const o=g(s,T,I);if(typeof o=="string")return o}let S=s.fsPath;if(I===1&&!M.isWindows?S=S.replace(/\//g,"\\"):I!==1&&M.isWindows&&(S=S.replace(/\\/g,"/")),I!==1&&h?.userHome){const o=h.userHome.fsPath;let O;s.scheme!==h.userHome.scheme&&s.path.startsWith(C.posix.sep)?O=h.userHome.with({path:s.path}).fsPath:O=s.fsPath,S=d(O,o,I)}return(I===1?C.win32:C.posix).normalize(R(S,I===1))}e.getPathLabel=D;function g(s,v,I){const h=I===1?C.win32:C.posix,T=I===3?F.extUri:F.extUriIgnorePathCase,S=v.getWorkspace(),a=(0,m.firstOrDefault)(S.folders);if(!a)return;s.scheme!==a.uri.scheme&&s.path.startsWith(C.posix.sep)&&(s=a.uri.with({path:s.path}));const o=v.getWorkspaceFolder(s);if(!o)return;let O;if(T.isEqual(o.uri,s)?O="":O=T.relativePath(o.uri,s)??"",O&&(O=h.normalize(O)),S.folders.length>1&&!v.noPrefix){const $=o.name?o.name:T.basenameOrAuthority(o.uri);O=O?`${$} \u2022 ${O}`:$}return O}function R(s,v=M.isWindows){return(0,k.hasDriveLetter)(s,v)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=R;let y=Object.create(null);function d(s,v,I=M.OS){if(I===1||!s||!v)return s;let h=y.original===v?y.normalized:void 0;h||(h=v,M.isWindows&&(h=(0,k.toSlashes)(h)),h=`${(0,f.rtrim)(h,C.posix.sep)}${C.posix.sep}`,y={original:v,normalized:h});let T=s;return M.isWindows&&(T=(0,k.toSlashes)(T)),(I===3?T.startsWith(h):(0,f.startsWithIgnoreCase)(T,h))?`~/${T.substr(h.length)}`:s}e.tildify=d;function E(s,v){return s.replace(/^~($|\/|\\)/,`${v}$1`)}e.untildify=E;const p="\u2026",l="\\\\",t="~";function r(s,v=C.sep){const I=new Array(s.length);let h=!1;for(let T=0;T<s.length;T++){const S=s[T];if(S===""){I[T]=`.${v}`;continue}if(!S){I[T]=S;continue}h=!0;let a="",o=S;o.indexOf(l)===0?(a=o.substr(0,o.indexOf(l)+l.length),o=o.substr(o.indexOf(l)+l.length)):o.indexOf(v)===0?(a=o.substr(0,o.indexOf(v)+v.length),o=o.substr(o.indexOf(v)+v.length)):o.indexOf(t)===0&&(a=o.substr(0,o.indexOf(t)+t.length),o=o.substr(o.indexOf(t)+t.length));const O=o.split(v);for(let $=1;h&&$<=O.length;$++)for(let K=O.length-$;h&&K>=0;K--){h=!1;let V=O.slice(K,K+$).join(v);for(let z=0;!h&&z<s.length;z++)if(z!==T&&s[z]&&s[z].indexOf(V)>-1){const N=K+$===O.length,q=K>0&&s[z].indexOf(v)>-1?v+V:V,B=s[z].endsWith(q);h=!N||B}if(!h){let z="";(O[0].endsWith(":")||a!=="")&&(K===1&&(K=0,$++,V=O[0]+v+V),K>0&&(z=O[0]+v),z=a+z),K>0&&(z=z+p+v),z=z+V,K+$<O.length&&(z=z+v+p),I[T]=z}}h&&(I[T]=S)}return I}e.shorten=r;var c;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function b(s,v=Object.create(null)){const I=[];let h=!1,T="";for(const S of s)if(S==="$"||h&&S==="{")T&&I.push({value:T,type:c.TEXT}),T="",h=!0;else if(S==="}"&&h){const a=v[T];if(typeof a=="string")a.length&&I.push({value:a,type:c.VARIABLE});else if(a){const o=I[I.length-1];(!o||o.type!==c.SEPARATOR)&&I.push({value:a.label,type:c.SEPARATOR})}T="",h=!1}else T+=S;return T&&!h&&I.push({value:T,type:c.TEXT}),I.filter((S,a)=>{if(S.type===c.SEPARATOR){const o=I[a-1],O=I[a+1];return[o,O].every($=>$&&($.type===c.VARIABLE||$.type===c.TEXT)&&$.value.length>0)}return!0}).map(S=>S.value).join("")}e.template=b;function w(s,v){return M.isMacintosh||v?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):s.replace(/&&|&/g,I=>I==="&"?"&&":"&")}e.mnemonicMenuLabel=w;function _(s,v){return M.isMacintosh||v?s.replace(/\(&&\w\)|&&/g,""):M.isWindows?s.replace(/&&|&/g,I=>I==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=_;function i(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=i;function u(s){if(s.endsWith("]")){const v=s.lastIndexOf(" [",s.length-2);if(v!==-1){const I=n(s.substring(0,v));return{name:I.name,parentPath:I.parentPath+s.substring(v)}}}return n(s)}e.splitRecentLabel=u;function n(s){const v=s.indexOf("/")!==-1?C.posix:C.win32,I=v.basename(s),h=v.dirname(s);return I.length?{name:I,parentPath:h}:{name:h,parentPath:""}}}),define(Ae[132],Re([1,0,25,2]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function C(y){return y.toJSON()}class M{constructor(d){this._uriTransformer=d}transformIncoming(d){const E=this._uriTransformer.transformIncoming(d);return E===d?d:C(k.URI.from(E))}transformOutgoing(d){const E=this._uriTransformer.transformOutgoing(d);return E===d?d:C(k.URI.from(E))}transformOutgoingURI(d){const E=this._uriTransformer.transformOutgoing(d);return E===d?d:k.URI.from(E)}transformOutgoingScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function F(y,d,E){if(!y||E>200)return null;if(typeof y=="object"){if(y instanceof k.URI)return d.transformOutgoing(y);for(const p in y)if(Object.hasOwnProperty.call(y,p)){const l=F(y[p],d,E+1);l!==null&&(y[p]=l)}}return null}function f(y,d){const E=F(y,d,0);return E===null?y:E}e.transformOutgoingURIs=f;function D(y,d,E,p){if(!y||p>200)return null;if(typeof y=="object"){if(y.$mid===1)return E?k.URI.revive(d.transformIncoming(y)):d.transformIncoming(y);if(y instanceof m.VSBuffer)return null;for(const l in y)if(Object.hasOwnProperty.call(y,l)){const t=D(y[l],d,E,p+1);t!==null&&(y[l]=t)}}return null}function g(y,d){const E=D(y,d,!1,0);return E===null?y:E}e.transformIncomingURIs=g;function R(y,d){const E=D(y,d,!0,0);return E===null?y:E}e.transformAndReviveIncomingURIs=R}),define(Ae[133],Re([1,0,37,19]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(M,F,f,D,g,R){if(Array.isArray(M)){let y=0;for(const d of M){const E=C(d,F,f,D,g,R);if(E===10)return E;E>y&&(y=E)}return y}else{if(typeof M=="string")return D?M==="*"?5:M===f?10:0:0;if(M){const{language:y,pattern:d,scheme:E,hasAccessToAllModels:p,notebookType:l}=M;if(!D&&!p)return 0;l&&g&&(F=g);let t=0;if(E)if(E===F.scheme)t=10;else if(E==="*")t=5;else return 0;if(y)if(y===f)t=10;else if(y==="*")t=Math.max(t,5);else return 0;if(l)if(l===R)t=10;else if(l==="*"&&R!==void 0)t=Math.max(t,5);else return 0;if(d){let r;if(typeof d=="string"?r=d:r={...d,base:(0,k.normalize)(d.base)},r===F.fsPath||(0,m.match)(r,F.fsPath))t=10;else return 0}return t}else return 0}}e.score=C}),define(Ae[91],Re([1,0,25,21]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(C||(C={}));function M(y){for(let d=0,E=y.length;d<E;d+=4){const p=y[d+0],l=y[d+1],t=y[d+2],r=y[d+3];y[d+0]=r,y[d+1]=t,y[d+2]=l,y[d+3]=p}}function F(y){const d=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return k.isLittleEndian()||M(d),m.VSBuffer.wrap(d)}function f(y){const d=y.buffer;if(k.isLittleEndian()||M(d),d.byteOffset%4===0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const E=new Uint8Array(d.byteLength);return E.set(d),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function D(y){const d=new Uint32Array(g(y));let E=0;if(d[E++]=y.id,y.type==="full")d[E++]=1,d[E++]=y.data.length,d.set(y.data,E),E+=y.data.length;else{d[E++]=2,d[E++]=y.deltas.length;for(const p of y.deltas)d[E++]=p.start,d[E++]=p.deleteCount,p.data?(d[E++]=p.data.length,d.set(p.data,E),E+=p.data.length):d[E++]=0}return F(d)}e.encodeSemanticTokensDto=D;function g(y){let d=0;if(d+=1+1,y.type==="full")d+=1+y.data.length;else{d+=1,d+=(1+1+1)*y.deltas.length;for(const E of y.deltas)E.data&&(d+=E.data.length)}return d}function R(y){const d=f(y);let E=0;const p=d[E++];if(d[E++]===1){const c=d[E++],b=d.subarray(E,E+c);return E+=c,{id:p,type:"full",data:b}}const t=d[E++],r=[];for(let c=0;c<t;c++){const b=d[E++],w=d[E++],_=d[E++];let i;_>0&&(i=d.subarray(E,E+_),E+=_),r[c]={start:b,deleteCount:w,data:i}}return{id:p,type:"delta",deltas:r}}e.decodeSemanticTokensDto=R}),define(Ae[134],Re([11,12]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Ae[135],Re([1,0,18,23,21,123,136,134]),function(te,e,m,k,C,M,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(Y){this._values=Y}hasChanged(Y){return this._values[Y]}}e.ConfigurationChangedEvent=g;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class y{constructor(Y,me,Be,Ne){this.id=Y,this.name=me,this.defaultValue=Be,this.schema=Ne}applyUpdate(Y,me){return E(Y,me)}compute(Y,me,Be){return Be}}class d{constructor(Y,me){this.newValue=Y,this.didChange=me}}e.ApplyUpdateResult=d;function E(Z,Y){if(typeof Z!="object"||typeof Y!="object"||!Z||!Y)return new d(Y,Z!==Y);if(Array.isArray(Z)||Array.isArray(Y)){const Be=Array.isArray(Z)&&Array.isArray(Y)&&m.equals(Z,Y);return new d(Y,!Be)}let me=!1;for(const Be in Y)if(Y.hasOwnProperty(Be)){const Ne=E(Z[Be],Y[Be]);Ne.didChange&&(Z[Be]=Ne.newValue,me=!0)}return new d(Z,me)}class p{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,me){return E(Y,me)}validate(Y){return this.defaultValue}}class l{constructor(Y,me,Be,Ne){this.id=Y,this.name=me,this.defaultValue=Be,this.schema=Ne}applyUpdate(Y,me){return E(Y,me)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,me,Be){return Be}}function t(Z,Y){return typeof Z>"u"?Y:Z==="false"?!1:!!Z}e.boolean=t;class r extends l{constructor(Y,me,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Be),super(Y,me,Be,Ne)}validate(Y){return t(Y,this.defaultValue)}}function c(Z,Y,me,Be){if(typeof Z>"u")return Y;let Ne=parseInt(Z,10);return isNaN(Ne)?Y:(Ne=Math.max(me,Ne),Ne=Math.min(Be,Ne),Ne|0)}e.clampedInt=c;class b extends l{static clampedInt(Y,me,Be,Ne){return c(Y,me,Be,Ne)}constructor(Y,me,Be,Ne,Qe,tt=void 0){typeof tt<"u"&&(tt.type="integer",tt.default=Be,tt.minimum=Ne,tt.maximum=Qe),super(Y,me,Be,tt),this.minimum=Ne,this.maximum=Qe}validate(Y){return b.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}function w(Z,Y,me,Be){if(typeof Z>"u")return Y;const Ne=_.float(Z,Y);return _.clamp(Ne,me,Be)}e.clampedFloat=w;class _ extends l{static clamp(Y,me,Be){return Y<me?me:Y>Be?Be:Y}static float(Y,me){if(typeof Y=="number")return Y;if(typeof Y>"u")return me;const Be=parseFloat(Y);return isNaN(Be)?me:Be}constructor(Y,me,Be,Ne,Qe){typeof Qe<"u"&&(Qe.type="number",Qe.default=Be),super(Y,me,Be,Qe),this.validationFn=Ne}validate(Y){return this.validationFn(_.float(Y,this.defaultValue))}}class i extends l{static string(Y,me){return typeof Y!="string"?me:Y}constructor(Y,me,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Be),super(Y,me,Be,Ne)}validate(Y){return i.string(Y,this.defaultValue)}}function u(Z,Y,me,Be){return typeof Z!="string"?Y:Be&&Z in Be?Be[Z]:me.indexOf(Z)===-1?Y:Z}e.stringSet=u;class n extends l{constructor(Y,me,Be,Ne,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.enum=Ne,Qe.default=Be),super(Y,me,Be,Qe),this._allowedValues=Ne}validate(Y){return u(Y,this.defaultValue,this._allowedValues)}}class s extends y{constructor(Y,me,Be,Ne,Qe,tt,pt=void 0){typeof pt<"u"&&(pt.type="string",pt.enum=Qe,pt.default=Ne),super(Y,me,Be,pt),this._allowedValues=Qe,this._convert=tt}validate(Y){return typeof Y!="string"?this.defaultValue:this._allowedValues.indexOf(Y)===-1?this.defaultValue:this._convert(Y)}}function v(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class I extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[f.localize(0,null),f.localize(1,null),f.localize(2,null)],default:"auto",tags:["accessibility"],description:f.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,me,Be){return Be===0?Y.accessibilitySupport:Be}}class h extends y{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(21,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:f.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:f.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertSpace:t(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var T;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(T||(e.TextEditorCursorBlinkingStyle=T={}));function S(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var a;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(a||(e.TextEditorCursorStyle=a={}));function o(Z){switch(Z){case a.Line:return"line";case a.Block:return"block";case a.Underline:return"underline";case a.LineThin:return"line-thin";case a.BlockOutline:return"block-outline";case a.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function O(Z){switch(Z){case"line":return a.Line;case"block":return a.Block;case"underline":return a.Underline;case"line-thin":return a.LineThin;case"block-outline":return a.BlockOutline;case"underline-thin":return a.UnderlineThin}}class $ extends p{constructor(){super(138)}compute(Y,me,Be){const Ne=["monaco-editor"];return me.get(37)&&Ne.push(me.get(37)),Y.extraEditorClassName&&Ne.push(Y.extraEditorClassName),me.get(71)==="default"?Ne.push("mouse-default"):me.get(71)==="copy"&&Ne.push("mouse-copy"),me.get(108)&&Ne.push("showUnused"),me.get(136)&&Ne.push("showDeprecated"),Ne.join(" ")}}class K extends r{constructor(){super(35,"emptySelectionClipboard",!0,{description:f.localize(6,null)})}compute(Y,me,Be){return Be&&Y.emptySelectionClipboard}}class V extends y{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(39,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:f.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[f.localize(8,null),f.localize(9,null),f.localize(10,null)],description:f.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[f.localize(12,null),f.localize(13,null),f.localize(14,null)],description:f.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:f.localize(16,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:f.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:f.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{cursorMoveOnType:t(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":u(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":u(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(me.loop,this.defaultValue.loop)}}}class z extends y{constructor(){super(49,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:f.localize(19,null)},{type:"string",description:f.localize(20,null)}],description:f.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?z.OFF:Y==="true"?z.ON:Y:Y?z.ON:z.OFF}}e.EditorFontLigatures=z,z.OFF='"liga" off, "calt" off',z.ON='"liga" on, "calt" on';class N extends y{constructor(){super(52,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:f.localize(22,null)},{type:"string",description:f.localize(23,null)}],description:f.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?N.OFF:Y==="true"?N.TRANSLATE:Y:Y?N.TRANSLATE:N.OFF}compute(Y,me,Be){return Y.fontInfo.fontVariationSettings}}e.EditorFontVariations=N,N.OFF="normal",N.TRANSLATE="translate";class q extends p{constructor(){super(48)}compute(Y,me,Be){return Y.fontInfo}}class B extends l{constructor(){super(50,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:f.localize(25,null)})}validate(Y){const me=_.float(Y,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:_.clamp(me,6,100)}compute(Y,me,Be){return Y.fontInfo.fontSize}}class U extends y{constructor(){super(51,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.MINIMUM_VALUE,maximum:U.MAXIMUM_VALUE,errorMessage:f.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:f.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(b.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,U.MINIMUM_VALUE,U.MAXIMUM_VALUE))}}U.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],U.MINIMUM_VALUE=1,U.MAXIMUM_VALUE=1e3;class le extends y{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[f.localize(28,null),f.localize(29,null),f.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(56,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:f.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:f.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:f.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:f.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:f.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:f.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Be,description:f.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Be,description:f.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Be,description:f.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Be,description:f.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Be,description:f.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{multiple:u(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??u(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??u(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??u(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??u(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??u(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ve extends y{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(58,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:f.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:f.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:f.localize(44,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:f.localize(45,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:t(me.enabled,this.defaultValue.enabled),delay:b.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:t(me.sticky,this.defaultValue.sticky),above:t(me.above,this.defaultValue.above)}}}var Pe;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class J extends p{constructor(){super(141)}compute(Y,me,Be){return J.computeLayout(me,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Y){const me=Y.height/Y.lineHeight,Be=Math.floor(Y.paddingTop/Y.lineHeight);let Ne=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(Ne=Math.max(Ne,me-1));const Qe=(Be+Y.viewLineCount+Ne)/(Y.pixelRatio*Y.height),tt=Math.floor(Y.viewLineCount/Qe);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Ne,desiredRatio:Qe,minimapLineCount:tt}}static _computeMinimapLayout(Y,me){const Be=Y.outerWidth,Ne=Y.outerHeight,Qe=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const tt=me.stableMinimapLayoutInput,pt=tt&&Y.outerHeight===tt.outerHeight&&Y.lineHeight===tt.lineHeight&&Y.typicalHalfwidthCharacterWidth===tt.typicalHalfwidthCharacterWidth&&Y.pixelRatio===tt.pixelRatio&&Y.scrollBeyondLastLine===tt.scrollBeyondLastLine&&Y.paddingTop===tt.paddingTop&&Y.paddingBottom===tt.paddingBottom&&Y.minimap.enabled===tt.minimap.enabled&&Y.minimap.side===tt.minimap.side&&Y.minimap.size===tt.minimap.size&&Y.minimap.showSlider===tt.minimap.showSlider&&Y.minimap.renderCharacters===tt.minimap.renderCharacters&&Y.minimap.maxColumn===tt.minimap.maxColumn&&Y.minimap.scale===tt.minimap.scale&&Y.verticalScrollbarWidth===tt.verticalScrollbarWidth&&Y.isViewportWrapping===tt.isViewportWrapping,bt=Y.lineHeight,Ot=Y.typicalHalfwidthCharacterWidth,Kt=Y.scrollBeyondLastLine,zt=Y.minimap.renderCharacters;let _t=Qe>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const xt=Y.minimap.maxColumn,Lt=Y.minimap.size,Nt=Y.minimap.side,Wt=Y.verticalScrollbarWidth,Ht=Y.viewLineCount,at=Y.remainingWidth,ft=Y.isViewportWrapping,Bt=zt?2:3;let At=Math.floor(Qe*Ne);const Ct=At/Qe;let lt=!1,kt=!1,Ft=Bt*_t,Te=_t/Qe,be=1;if(Lt==="fill"||Lt==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeforeFirstLine:St,extraLinesBeyondLastLine:It,desiredRatio:Pt,minimapLineCount:gt}=J.computeContainedMinimapLineCount({viewLineCount:Ht,scrollBeyondLastLine:Kt,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:Ne,lineHeight:bt,pixelRatio:Qe});if(Ht/gt>1)lt=!0,kt=!0,_t=1,Ft=1,Te=_t/Qe;else{let ht=!1,wt=_t+1;if(Lt==="fit"){const Et=Math.ceil((St+Ht+It)*Ft);ft&&pt&&at<=me.stableFitRemainingWidth?(ht=!0,wt=me.stableFitMaxMinimapScale):ht=Et>At}if(Lt==="fill"||ht){lt=!0;const Et=_t;Ft=Math.min(bt*Qe,Math.max(1,Math.floor(1/Pt))),ft&&pt&&at<=me.stableFitRemainingWidth&&(wt=me.stableFitMaxMinimapScale),_t=Math.min(wt,Math.max(1,Math.floor(Ft/Bt))),_t>Et&&(be=Math.min(2,_t/Et)),Te=_t/Qe/be,At=Math.ceil(Math.max(Ze,St+Ht+It)*Ft),ft?(me.stableMinimapLayoutInput=Y,me.stableFitRemainingWidth=at,me.stableFitMaxMinimapScale=_t):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const Ee=Math.floor(xt*Te),Q=Math.min(Ee,Math.max(0,Math.floor((at-Wt-2)*Te/(Ot+Te)))+e.MINIMAP_GUTTER_WIDTH);let Oe=Math.floor(Qe*Q);const xe=Oe/Qe;Oe=Math.floor(Oe*be);const Ke=zt?1:2,We=Nt==="left"?0:Be-Q-Wt;return{renderMinimap:Ke,minimapLeft:We,minimapWidth:Q,minimapHeightIsEditorHeight:lt,minimapIsSampling:kt,minimapScale:_t,minimapLineHeight:Ft,minimapCanvasInnerWidth:Oe,minimapCanvasInnerHeight:At,minimapCanvasOuterWidth:xe,minimapCanvasOuterHeight:Ct}}static computeLayout(Y,me){const Be=me.outerWidth|0,Ne=me.outerHeight|0,Qe=me.lineHeight|0,tt=me.lineNumbersDigitCount|0,pt=me.typicalHalfwidthCharacterWidth,bt=me.maxDigitWidth,Ot=me.pixelRatio,Kt=me.viewLineCount,zt=Y.get(133),_t=zt==="inherit"?Y.get(132):zt,xt=_t==="inherit"?Y.get(128):_t,Lt=Y.get(131),Nt=me.isDominatedByLongLines,Wt=Y.get(55),Ht=Y.get(65).renderType!==0,at=Y.get(66),ft=Y.get(102),Bt=Y.get(81),At=Y.get(70),Ct=Y.get(100),lt=Ct.verticalScrollbarSize,kt=Ct.verticalHasArrows,Ft=Ct.arrowSize,Te=Ct.horizontalScrollbarSize,be=Y.get(41),Ee=Y.get(107)!=="never";let Q=Y.get(63);be&&Ee&&(Q+=16);let Oe=0;if(Ht){const $t=Math.max(tt,at);Oe=Math.round($t*bt)}let xe=0;Wt&&(xe=Qe*me.glyphMarginDecorationLaneCount);let Ke=0,We=Ke+xe,Ze=We+Oe,St=Ze+Q;const It=Be-xe-Oe-Q;let Pt=!1,gt=!1,vt=-1;_t==="inherit"&&Nt?(Pt=!0,gt=!0):xt==="on"||xt==="bounded"?gt=!0:xt==="wordWrapColumn"&&(vt=Lt);const ht=J._computeMinimapLayout({outerWidth:Be,outerHeight:Ne,lineHeight:Qe,typicalHalfwidthCharacterWidth:pt,pixelRatio:Ot,scrollBeyondLastLine:ft,paddingTop:Bt.top,paddingBottom:Bt.bottom,minimap:At,verticalScrollbarWidth:lt,viewLineCount:Kt,remainingWidth:It,isViewportWrapping:gt},me.memory||new R);ht.renderMinimap!==0&&ht.minimapLeft===0&&(Ke+=ht.minimapWidth,We+=ht.minimapWidth,Ze+=ht.minimapWidth,St+=ht.minimapWidth);const wt=It-ht.minimapWidth,Et=Math.max(1,Math.floor((wt-lt-2)/pt)),Qt=kt?Ft:0;return gt&&(vt=Math.max(1,Et),xt==="bounded"&&(vt=Math.min(vt,Lt))),{width:Be,height:Ne,glyphMarginLeft:Ke,glyphMarginWidth:xe,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:We,lineNumbersWidth:Oe,decorationsLeft:Ze,decorationsWidth:Q,contentLeft:St,contentWidth:wt,minimap:ht,viewportColumn:Et,isWordWrapMinified:Pt,isViewportWrapping:gt,wrappingColumn:vt,verticalScrollbarWidth:lt,horizontalScrollbarHeight:Te,overviewRuler:{top:Qt,width:lt,height:Ne-2*Qt,right:0}}}}e.EditorLayoutInfoComputer=J;class X extends y{constructor(){super(135,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[f.localize(46,null),f.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:f.localize(48,null)}})}validate(Y){return u(Y,"simple",["simple","advanced"])}compute(Y,me,Be){return me.get(2)===2?"advanced":Be}}class ce extends y{constructor(){const Y={enabled:!0};super(62,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:f.localize(49,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:t(Y.enabled,this.defaultValue.enabled)}}}class De extends y{constructor(){const Y={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(112,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:f.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:f.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Y.defaultModel,description:f.localize(52,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:t(me.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:u(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class ke extends y{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(137,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:f.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[f.localize(54,null),f.localize(55,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),f.localize(56,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),f.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:f.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:f.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:f.localize(60,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:u(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(me.fontFamily,this.defaultValue.fontFamily),padding:t(me.padding,this.defaultValue.padding)}}}class ge extends y{constructor(){super(63,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):b.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,me,Be){return Be<0?b.clampedInt(-Be*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class A extends _{constructor(){super(64,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>_.clamp(Y,0,150),{markdownDescription:f.localize(61,null)})}compute(Y,me,Be){return Y.fontInfo.lineHeight}}class G extends y{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(70,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:f.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:f.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[f.localize(64,null),f.localize(65,null),f.localize(66,null)],default:Y.size,description:f.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:f.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:f.localize(69,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:f.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:f.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:f.localize(72,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:t(me.enabled,this.defaultValue.enabled),autohide:t(me.autohide,this.defaultValue.autohide),size:u(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:u(me.side,this.defaultValue.side,["right","left"]),showSlider:u(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(me.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(me.scale,1,1,3),maxColumn:b.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function de(Z){return Z==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ye extends y{constructor(){super(81,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(74,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{top:b.clampedInt(me.top,0,0,1e3),bottom:b.clampedInt(me.bottom,0,0,1e3)}}}class _e extends y{constructor(){const Y={enabled:!0,cycle:!0};super(83,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:f.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:f.localize(76,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:t(me.enabled,this.defaultValue.enabled),cycle:t(me.cycle,this.defaultValue.cycle)}}}class pe extends p{constructor(){super(139)}compute(Y,me,Be){return Y.pixelRatio}}class Ce extends y{constructor(){const Y={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[f.localize(77,null),f.localize(78,null),f.localize(79,null)]}];super(86,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Y.strings,description:f.localize(80,null)},comments:{anyOf:me,default:Y.comments,description:f.localize(81,null)},other:{anyOf:me,default:Y.other,description:f.localize(82,null)}},default:Y,markdownDescription:f.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const Ot=Y?"on":"off";return{comments:Ot,strings:Ot,other:Ot}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:me,comments:Be,strings:Ne}=Y,Qe=["on","inline","off"];let tt,pt,bt;return typeof me=="boolean"?tt=me?"on":"off":tt=u(me,this.defaultValue.other,Qe),typeof Be=="boolean"?pt=Be?"on":"off":pt=u(Be,this.defaultValue.comments,Qe),typeof Ne=="boolean"?bt=Ne?"on":"off":bt=u(Ne,this.defaultValue.strings,Qe),{other:tt,comments:pt,strings:bt}}}var ae;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(ae||(e.RenderLineNumbersType=ae={}));class ue extends y{constructor(){super(65,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[f.localize(84,null),f.localize(85,null),f.localize(86,null),f.localize(87,null)],default:"on",description:f.localize(88,null)})}validate(Y){let me=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(me=4,Be=Y):Y==="interval"?me=3:Y==="relative"?me=2:Y==="on"?me=1:me=0),{renderType:me,renderFn:Be}}}function ne(Z){const Y=Z.get(95);return Y==="editable"?Z.get(88):Y!=="on"}e.filterValidationDecorations=ne;class ee extends y{constructor(){const Y=[],me={type:"number",description:f.localize(89,null)};super(99,"rulers",Y,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:f.localize(90,null),format:"color-hex"}}}]},default:Y,description:f.localize(91,null)})}validate(Y){if(Array.isArray(Y)){const me=[];for(const Be of Y)if(typeof Be=="number")me.push({column:b.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Ne=Be;me.push({column:b.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return me.sort((Be,Ne)=>Be.column-Ne.column),me}return this.defaultValue}}class P extends y{constructor(){super(89,"readOnlyMessage",void 0)}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:Y}}function W(Z,Y){if(typeof Z!="string")return Y;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class H extends y{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(100,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(92,null),f.localize(93,null),f.localize(94,null)],default:"auto",description:f.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(96,null),f.localize(97,null),f.localize(98,null)],default:"auto",description:f.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:f.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:f.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:f.localize(102,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y,Be=b.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=b.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:W(me.vertical,this.defaultValue.vertical),horizontal:W(me.horizontal,this.defaultValue.horizontal),useShadows:t(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:b.clampedInt(me.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:b.clampedInt(me.verticalSliderSize,Ne,0,1e3),scrollByPage:t(me.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class j extends y{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(122,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:f.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:f.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:f.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:f.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:f.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:f.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:f.localize(109,null)}})}applyUpdate(Y,me){let Be=!1;me.allowedCharacters&&Y&&(k.equals(Y.allowedCharacters,me.allowedCharacters)||(Y={...Y,allowedCharacters:me.allowedCharacters},Be=!0)),me.allowedLocales&&Y&&(k.equals(Y.allowedLocales,me.allowedLocales)||(Y={...Y,allowedLocales:me.allowedLocales},Be=!0));const Ne=super.applyUpdate(Y,me);return Be?new d(Ne.newValue,!0):Ne}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{nonBasicASCII:we(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:we(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:we(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Y.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Y,me){if(typeof Y!="object"||!Y)return me;const Be={};for(const[Ne,Qe]of Object.entries(Y))Qe===!0&&(Be[Ne]=!0);return Be}}class re extends y{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(60,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:f.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover"],enumDescriptions:[f.localize(111,null),f.localize(112,null)],description:f.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Y.suppressSuggestions,description:f.localize(114,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:t(me.enabled,this.defaultValue.enabled),mode:u(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:u(me.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(me.keepOnBlur,this.defaultValue.keepOnBlur)}}}class he extends y{constructor(){const Y={enabled:M.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(13,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:f.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:f.localize(116,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:t(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ie extends y{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(14,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(117,null),f.localize(118,null),f.localize(119,null)],default:Y.bracketPairs,description:f.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(121,null),f.localize(122,null),f.localize(123,null)],default:Y.bracketPairsHorizontal,description:f.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:f.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:f.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[f.localize(127,null),f.localize(128,null),f.localize(129,null)],default:Y.highlightActiveIndentation,description:f.localize(130,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{bracketPairs:we(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:we(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:we(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function we(Z,Y,me){const Be=me.indexOf(Z);return Be===-1?Y:me[Be]}class Se extends y{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(115,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[f.localize(131,null),f.localize(132,null)],default:Y.insertMode,description:f.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:f.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:f.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:f.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[f.localize(137,null),f.localize(138,null),f.localize(139,null),f.localize(140,null)],default:Y.selectionMode,markdownDescription:f.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:f.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:f.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:f.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:f.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:f.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:f.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:f.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:f.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:f.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:f.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:f.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:f.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:f.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:f.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:f.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:f.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:f.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:f.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:f.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:f.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:f.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:f.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:f.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:f.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:f.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:f.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:f.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:f.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:f.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:f.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:f.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:f.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:f.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:f.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:f.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:f.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:f.localize(178,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertMode:u(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:u(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(me.showIcons,this.defaultValue.showIcons),showStatusBar:t(me.showStatusBar,this.defaultValue.showStatusBar),preview:t(me.preview,this.defaultValue.preview),previewMode:u(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(me.showMethods,this.defaultValue.showMethods),showFunctions:t(me.showFunctions,this.defaultValue.showFunctions),showConstructors:t(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(me.showFields,this.defaultValue.showFields),showVariables:t(me.showVariables,this.defaultValue.showVariables),showClasses:t(me.showClasses,this.defaultValue.showClasses),showStructs:t(me.showStructs,this.defaultValue.showStructs),showInterfaces:t(me.showInterfaces,this.defaultValue.showInterfaces),showModules:t(me.showModules,this.defaultValue.showModules),showProperties:t(me.showProperties,this.defaultValue.showProperties),showEvents:t(me.showEvents,this.defaultValue.showEvents),showOperators:t(me.showOperators,this.defaultValue.showOperators),showUnits:t(me.showUnits,this.defaultValue.showUnits),showValues:t(me.showValues,this.defaultValue.showValues),showConstants:t(me.showConstants,this.defaultValue.showConstants),showEnums:t(me.showEnums,this.defaultValue.showEnums),showEnumMembers:t(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(me.showKeywords,this.defaultValue.showKeywords),showWords:t(me.showWords,this.defaultValue.showWords),showColors:t(me.showColors,this.defaultValue.showColors),showFiles:t(me.showFiles,this.defaultValue.showFiles),showReferences:t(me.showReferences,this.defaultValue.showReferences),showFolders:t(me.showFolders,this.defaultValue.showFolders),showTypeParameters:t(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(me.showSnippets,this.defaultValue.showSnippets),showUsers:t(me.showUsers,this.defaultValue.showUsers),showIssues:t(me.showIssues,this.defaultValue.showIssues)}}}class $e extends y{constructor(){super(110,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:f.localize(179,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:f.localize(180,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Y.selectSubwords,this.defaultValue.selectSubwords)}}}var ze;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(ze||(e.WrappingIndent=ze={}));class Je extends y{constructor(){super(134,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[f.localize(181,null),f.localize(182,null),f.localize(183,null),f.localize(184,null)],description:f.localize(185,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,me,Be){return me.get(2)===2?0:Be}}class qe extends p{constructor(){super(142)}compute(Y,me,Be){const Ne=me.get(141);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class Ge extends y{constructor(){const Y={enabled:!0,showDropSelector:"afterDrop"};super(34,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:f.localize(186,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:f.localize(187,null),enum:["afterDrop","never"],enumDescriptions:[f.localize(188,null),f.localize(189,null)],default:"afterDrop"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:t(me.enabled,this.defaultValue.enabled),showDropSelector:u(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends y{constructor(){const Y={enabled:!0,showPasteSelector:"afterPaste"};super(82,"pasteAs",Y,{"editor.pasteAs.enabled":{type:"boolean",default:Y.enabled,markdownDescription:f.localize(190,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:f.localize(191,null),enum:["afterPaste","never"],enumDescriptions:[f.localize(192,null),f.localize(193,null)],default:"afterPaste"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:t(me.enabled,this.defaultValue.enabled),showPasteSelector:u(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ct="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?et:C.isLinux?rt:ct,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var st;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.autoClosingBrackets=5]="autoClosingBrackets",Z[Z.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=7]="autoClosingDelete",Z[Z.autoClosingOvertype=8]="autoClosingOvertype",Z[Z.autoClosingQuotes=9]="autoClosingQuotes",Z[Z.autoIndent=10]="autoIndent",Z[Z.automaticLayout=11]="automaticLayout",Z[Z.autoSurround=12]="autoSurround",Z[Z.bracketPairColorization=13]="bracketPairColorization",Z[Z.guides=14]="guides",Z[Z.codeLens=15]="codeLens",Z[Z.codeLensFontFamily=16]="codeLensFontFamily",Z[Z.codeLensFontSize=17]="codeLensFontSize",Z[Z.colorDecorators=18]="colorDecorators",Z[Z.colorDecoratorsLimit=19]="colorDecoratorsLimit",Z[Z.columnSelection=20]="columnSelection",Z[Z.comments=21]="comments",Z[Z.contextmenu=22]="contextmenu",Z[Z.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=24]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=26]="cursorStyle",Z[Z.cursorSurroundingLines=27]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=29]="cursorWidth",Z[Z.disableLayerHinting=30]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",Z[Z.domReadOnly=32]="domReadOnly",Z[Z.dragAndDrop=33]="dragAndDrop",Z[Z.dropIntoEditor=34]="dropIntoEditor",Z[Z.emptySelectionClipboard=35]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=37]="extraEditorClassName",Z[Z.fastScrollSensitivity=38]="fastScrollSensitivity",Z[Z.find=39]="find",Z[Z.fixedOverflowWidgets=40]="fixedOverflowWidgets",Z[Z.folding=41]="folding",Z[Z.foldingStrategy=42]="foldingStrategy",Z[Z.foldingHighlight=43]="foldingHighlight",Z[Z.foldingImportsByDefault=44]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=45]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=47]="fontFamily",Z[Z.fontInfo=48]="fontInfo",Z[Z.fontLigatures=49]="fontLigatures",Z[Z.fontSize=50]="fontSize",Z[Z.fontWeight=51]="fontWeight",Z[Z.fontVariations=52]="fontVariations",Z[Z.formatOnPaste=53]="formatOnPaste",Z[Z.formatOnType=54]="formatOnType",Z[Z.glyphMargin=55]="glyphMargin",Z[Z.gotoLocation=56]="gotoLocation",Z[Z.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",Z[Z.hover=58]="hover",Z[Z.inDiffEditor=59]="inDiffEditor",Z[Z.inlineSuggest=60]="inlineSuggest",Z[Z.letterSpacing=61]="letterSpacing",Z[Z.lightbulb=62]="lightbulb",Z[Z.lineDecorationsWidth=63]="lineDecorationsWidth",Z[Z.lineHeight=64]="lineHeight",Z[Z.lineNumbers=65]="lineNumbers",Z[Z.lineNumbersMinChars=66]="lineNumbersMinChars",Z[Z.linkedEditing=67]="linkedEditing",Z[Z.links=68]="links",Z[Z.matchBrackets=69]="matchBrackets",Z[Z.minimap=70]="minimap",Z[Z.mouseStyle=71]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=73]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=75]="multiCursorModifier",Z[Z.multiCursorPaste=76]="multiCursorPaste",Z[Z.multiCursorLimit=77]="multiCursorLimit",Z[Z.occurrencesHighlight=78]="occurrencesHighlight",Z[Z.overviewRulerBorder=79]="overviewRulerBorder",Z[Z.overviewRulerLanes=80]="overviewRulerLanes",Z[Z.padding=81]="padding",Z[Z.pasteAs=82]="pasteAs",Z[Z.parameterHints=83]="parameterHints",Z[Z.peekWidgetDefaultFocus=84]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=85]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=86]="quickSuggestions",Z[Z.quickSuggestionsDelay=87]="quickSuggestionsDelay",Z[Z.readOnly=88]="readOnly",Z[Z.readOnlyMessage=89]="readOnlyMessage",Z[Z.renameOnType=90]="renameOnType",Z[Z.renderControlCharacters=91]="renderControlCharacters",Z[Z.renderFinalNewline=92]="renderFinalNewline",Z[Z.renderLineHighlight=93]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=94]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=95]="renderValidationDecorations",Z[Z.renderWhitespace=96]="renderWhitespace",Z[Z.revealHorizontalRightPadding=97]="revealHorizontalRightPadding",Z[Z.roundedSelection=98]="roundedSelection",Z[Z.rulers=99]="rulers",Z[Z.scrollbar=100]="scrollbar",Z[Z.scrollBeyondLastColumn=101]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=102]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=103]="scrollPredominantAxis",Z[Z.selectionClipboard=104]="selectionClipboard",Z[Z.selectionHighlight=105]="selectionHighlight",Z[Z.selectOnLineNumbers=106]="selectOnLineNumbers",Z[Z.showFoldingControls=107]="showFoldingControls",Z[Z.showUnused=108]="showUnused",Z[Z.snippetSuggestions=109]="snippetSuggestions",Z[Z.smartSelect=110]="smartSelect",Z[Z.smoothScrolling=111]="smoothScrolling",Z[Z.stickyScroll=112]="stickyScroll",Z[Z.stickyTabStops=113]="stickyTabStops",Z[Z.stopRenderingLineAfter=114]="stopRenderingLineAfter",Z[Z.suggest=115]="suggest",Z[Z.suggestFontSize=116]="suggestFontSize",Z[Z.suggestLineHeight=117]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=118]="suggestOnTriggerCharacters",Z[Z.suggestSelection=119]="suggestSelection",Z[Z.tabCompletion=120]="tabCompletion",Z[Z.tabIndex=121]="tabIndex",Z[Z.unicodeHighlighting=122]="unicodeHighlighting",Z[Z.unusualLineTerminators=123]="unusualLineTerminators",Z[Z.useShadowDOM=124]="useShadowDOM",Z[Z.useTabStops=125]="useTabStops",Z[Z.wordBreak=126]="wordBreak",Z[Z.wordSeparators=127]="wordSeparators",Z[Z.wordWrap=128]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=129]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=130]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=131]="wordWrapColumn",Z[Z.wordWrapOverride1=132]="wordWrapOverride1",Z[Z.wordWrapOverride2=133]="wordWrapOverride2",Z[Z.wrappingIndent=134]="wrappingIndent",Z[Z.wrappingStrategy=135]="wrappingStrategy",Z[Z.showDeprecated=136]="showDeprecated",Z[Z.inlayHints=137]="inlayHints",Z[Z.editorClassName=138]="editorClassName",Z[Z.pixelRatio=139]="pixelRatio",Z[Z.tabFocusMode=140]="tabFocusMode",Z[Z.layoutInfo=141]="layoutInfo",Z[Z.wrappingInfo=142]="wrappingInfo",Z[Z.defaultColorDecorators=143]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=144]="colorDecoratorsActivatedOn"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:f.localize(194,null)})),acceptSuggestionOnEnter:Ue(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",f.localize(195,null),""],markdownDescription:f.localize(196,null)})),accessibilitySupport:Ue(new I),accessibilityPageSize:Ue(new b(3,"accessibilityPageSize",10,1,1073741824,{description:f.localize(197,null),tags:["accessibility"]})),ariaLabel:Ue(new i(4,"ariaLabel",f.localize(198,null))),screenReaderAnnounceInlineSuggestion:Ue(new r(6,"screenReaderAnnounceInlineSuggestion",!0,{description:f.localize(199,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new n(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(200,null),f.localize(201,null),""],description:f.localize(202,null)})),autoClosingDelete:Ue(new n(7,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",f.localize(203,null),""],description:f.localize(204,null)})),autoClosingOvertype:Ue(new n(8,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",f.localize(205,null),""],description:f.localize(206,null)})),autoClosingQuotes:Ue(new n(9,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(207,null),f.localize(208,null),""],description:f.localize(209,null)})),autoIndent:Ue(new s(10,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[f.localize(210,null),f.localize(211,null),f.localize(212,null),f.localize(213,null),f.localize(214,null)],description:f.localize(215,null)})),automaticLayout:Ue(new r(11,"automaticLayout",!1)),autoSurround:Ue(new n(12,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[f.localize(216,null),f.localize(217,null),f.localize(218,null),""],description:f.localize(219,null)})),bracketPairColorization:Ue(new he),bracketPairGuides:Ue(new ie),stickyTabStops:Ue(new r(113,"stickyTabStops",!1,{description:f.localize(220,null)})),codeLens:Ue(new r(15,"codeLens",!0,{description:f.localize(221,null)})),codeLensFontFamily:Ue(new i(16,"codeLensFontFamily","",{description:f.localize(222,null)})),codeLensFontSize:Ue(new b(17,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:f.localize(223,null)})),colorDecorators:Ue(new r(18,"colorDecorators",!0,{description:f.localize(224,null)})),colorDecoratorActivatedOn:Ue(new n(144,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[f.localize(225,null),f.localize(226,null),f.localize(227,null)],description:f.localize(228,null)})),colorDecoratorsLimit:Ue(new b(19,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:f.localize(229,null)})),columnSelection:Ue(new r(20,"columnSelection",!1,{description:f.localize(230,null)})),comments:Ue(new h),contextmenu:Ue(new r(22,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new r(23,"copyWithSyntaxHighlighting",!0,{description:f.localize(231,null)})),cursorBlinking:Ue(new s(24,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],S,{description:f.localize(232,null)})),cursorSmoothCaretAnimation:Ue(new n(25,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[f.localize(233,null),f.localize(234,null),f.localize(235,null)],description:f.localize(236,null)})),cursorStyle:Ue(new s(26,"cursorStyle",a.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],O,{description:f.localize(237,null)})),cursorSurroundingLines:Ue(new b(27,"cursorSurroundingLines",0,0,1073741824,{description:f.localize(238,null)})),cursorSurroundingLinesStyle:Ue(new n(28,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[f.localize(239,null),f.localize(240,null)],description:f.localize(241,null)})),cursorWidth:Ue(new b(29,"cursorWidth",0,0,1073741824,{markdownDescription:f.localize(242,null)})),disableLayerHinting:Ue(new r(30,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new r(31,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new r(32,"domReadOnly",!1)),dragAndDrop:Ue(new r(33,"dragAndDrop",!0,{description:f.localize(243,null)})),emptySelectionClipboard:Ue(new K),dropIntoEditor:Ue(new Ge),stickyScroll:Ue(new De),experimentalWhitespaceRendering:Ue(new n(36,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[f.localize(244,null),f.localize(245,null),f.localize(246,null)],description:f.localize(247,null)})),extraEditorClassName:Ue(new i(37,"extraEditorClassName","")),fastScrollSensitivity:Ue(new _(38,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:f.localize(248,null)})),find:Ue(new V),fixedOverflowWidgets:Ue(new r(40,"fixedOverflowWidgets",!1)),folding:Ue(new r(41,"folding",!0,{description:f.localize(249,null)})),foldingStrategy:Ue(new n(42,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[f.localize(250,null),f.localize(251,null)],description:f.localize(252,null)})),foldingHighlight:Ue(new r(43,"foldingHighlight",!0,{description:f.localize(253,null)})),foldingImportsByDefault:Ue(new r(44,"foldingImportsByDefault",!1,{description:f.localize(254,null)})),foldingMaximumRegions:Ue(new b(45,"foldingMaximumRegions",5e3,10,65e3,{description:f.localize(255,null)})),unfoldOnClickAfterEndOfLine:Ue(new r(46,"unfoldOnClickAfterEndOfLine",!1,{description:f.localize(256,null)})),fontFamily:Ue(new i(47,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:f.localize(257,null)})),fontInfo:Ue(new q),fontLigatures2:Ue(new z),fontSize:Ue(new B),fontWeight:Ue(new U),fontVariations:Ue(new N),formatOnPaste:Ue(new r(53,"formatOnPaste",!1,{description:f.localize(258,null)})),formatOnType:Ue(new r(54,"formatOnType",!1,{description:f.localize(259,null)})),glyphMargin:Ue(new r(55,"glyphMargin",!0,{description:f.localize(260,null)})),gotoLocation:Ue(new le),hideCursorInOverviewRuler:Ue(new r(57,"hideCursorInOverviewRuler",!1,{description:f.localize(261,null)})),hover:Ue(new ve),inDiffEditor:Ue(new r(59,"inDiffEditor",!1)),letterSpacing:Ue(new _(61,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>_.clamp(Z,-5,20),{description:f.localize(262,null)})),lightbulb:Ue(new ce),lineDecorationsWidth:Ue(new ge),lineHeight:Ue(new A),lineNumbers:Ue(new ue),lineNumbersMinChars:Ue(new b(66,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new r(67,"linkedEditing",!1,{description:f.localize(263,null)})),links:Ue(new r(68,"links",!0,{description:f.localize(264,null)})),matchBrackets:Ue(new n(69,"matchBrackets","always",["always","near","never"],{description:f.localize(265,null)})),minimap:Ue(new G),mouseStyle:Ue(new n(71,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new _(72,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:f.localize(266,null)})),mouseWheelZoom:Ue(new r(73,"mouseWheelZoom",!1,{markdownDescription:f.localize(267,null)})),multiCursorMergeOverlapping:Ue(new r(74,"multiCursorMergeOverlapping",!0,{description:f.localize(268,null)})),multiCursorModifier:Ue(new s(75,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],de,{markdownEnumDescriptions:[f.localize(269,null),f.localize(270,null)],markdownDescription:f.localize(271,null)})),multiCursorPaste:Ue(new n(76,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[f.localize(272,null),f.localize(273,null)],markdownDescription:f.localize(274,null)})),multiCursorLimit:Ue(new b(77,"multiCursorLimit",1e4,1,1e5,{markdownDescription:f.localize(275,null)})),occurrencesHighlight:Ue(new r(78,"occurrencesHighlight",!0,{description:f.localize(276,null)})),overviewRulerBorder:Ue(new r(79,"overviewRulerBorder",!0,{description:f.localize(277,null)})),overviewRulerLanes:Ue(new b(80,"overviewRulerLanes",3,0,3)),padding:Ue(new ye),pasteAs:Ue(new it),parameterHints:Ue(new _e),peekWidgetDefaultFocus:Ue(new n(84,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[f.localize(278,null),f.localize(279,null)],description:f.localize(280,null)})),definitionLinkOpensInPeek:Ue(new r(85,"definitionLinkOpensInPeek",!1,{description:f.localize(281,null)})),quickSuggestions:Ue(new Ce),quickSuggestionsDelay:Ue(new b(87,"quickSuggestionsDelay",10,0,1073741824,{description:f.localize(282,null)})),readOnly:Ue(new r(88,"readOnly",!1)),readOnlyMessage:Ue(new P),renameOnType:Ue(new r(90,"renameOnType",!1,{description:f.localize(283,null),markdownDeprecationMessage:f.localize(284,null)})),renderControlCharacters:Ue(new r(91,"renderControlCharacters",!0,{description:f.localize(285,null),restricted:!0})),renderFinalNewline:Ue(new n(92,"renderFinalNewline",C.isLinux?"dimmed":"on",["off","on","dimmed"],{description:f.localize(286,null)})),renderLineHighlight:Ue(new n(93,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",f.localize(287,null)],description:f.localize(288,null)})),renderLineHighlightOnlyWhenFocus:Ue(new r(94,"renderLineHighlightOnlyWhenFocus",!1,{description:f.localize(289,null)})),renderValidationDecorations:Ue(new n(95,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new n(96,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",f.localize(290,null),f.localize(291,null),f.localize(292,null),""],description:f.localize(293,null)})),revealHorizontalRightPadding:Ue(new b(97,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new r(98,"roundedSelection",!0,{description:f.localize(294,null)})),rulers:Ue(new ee),scrollbar:Ue(new H),scrollBeyondLastColumn:Ue(new b(101,"scrollBeyondLastColumn",4,0,1073741824,{description:f.localize(295,null)})),scrollBeyondLastLine:Ue(new r(102,"scrollBeyondLastLine",!0,{description:f.localize(296,null)})),scrollPredominantAxis:Ue(new r(103,"scrollPredominantAxis",!0,{description:f.localize(297,null)})),selectionClipboard:Ue(new r(104,"selectionClipboard",!0,{description:f.localize(298,null),included:C.isLinux})),selectionHighlight:Ue(new r(105,"selectionHighlight",!0,{description:f.localize(299,null)})),selectOnLineNumbers:Ue(new r(106,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new n(107,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[f.localize(300,null),f.localize(301,null),f.localize(302,null)],description:f.localize(303,null)})),showUnused:Ue(new r(108,"showUnused",!0,{description:f.localize(304,null)})),showDeprecated:Ue(new r(136,"showDeprecated",!0,{description:f.localize(305,null)})),inlayHints:Ue(new ke),snippetSuggestions:Ue(new n(109,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[f.localize(306,null),f.localize(307,null),f.localize(308,null),f.localize(309,null)],description:f.localize(310,null)})),smartSelect:Ue(new $e),smoothScrolling:Ue(new r(111,"smoothScrolling",!1,{description:f.localize(311,null)})),stopRenderingLineAfter:Ue(new b(114,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new Se),inlineSuggest:Ue(new re),suggestFontSize:Ue(new b(116,"suggestFontSize",0,0,1e3,{markdownDescription:f.localize(312,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new b(117,"suggestLineHeight",0,0,1e3,{markdownDescription:f.localize(313,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new r(118,"suggestOnTriggerCharacters",!0,{description:f.localize(314,null)})),suggestSelection:Ue(new n(119,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[f.localize(315,null),f.localize(316,null),f.localize(317,null)],description:f.localize(318,null)})),tabCompletion:Ue(new n(120,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[f.localize(319,null),f.localize(320,null),f.localize(321,null)],description:f.localize(322,null)})),tabIndex:Ue(new b(121,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new j),unusualLineTerminators:Ue(new n(123,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[f.localize(323,null),f.localize(324,null),f.localize(325,null)],description:f.localize(326,null)})),useShadowDOM:Ue(new r(124,"useShadowDOM",!0)),useTabStops:Ue(new r(125,"useTabStops",!0,{description:f.localize(327,null)})),wordBreak:Ue(new n(126,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[f.localize(328,null),f.localize(329,null)],description:f.localize(330,null)})),wordSeparators:Ue(new i(127,"wordSeparators",F.USUAL_WORD_SEPARATORS,{description:f.localize(331,null)})),wordWrap:Ue(new n(128,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[f.localize(332,null),f.localize(333,null),f.localize(334,null),f.localize(335,null)],description:f.localize(336,null)})),wordWrapBreakAfterCharacters:Ue(new i(129,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new i(130,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new b(131,"wordWrapColumn",80,1,1073741824,{markdownDescription:f.localize(337,null)})),wordWrapOverride1:Ue(new n(132,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new n(133,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new $),defaultColorDecorators:Ue(new r(143,"defaultColorDecorators",!1,{markdownDescription:f.localize(338,null)})),pixelRatio:Ue(new pe),tabFocusMode:Ue(new r(140,"tabFocusMode",!1,{markdownDescription:f.localize(339,null)})),layoutInfo:Ue(new J),wrappingInfo:Ue(new qe),wrappingIndent:Ue(new Je),wrappingStrategy:Ue(new X)}}),define(Ae[137],Re([11,12]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[138],Re([11,12]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[139],Re([11,12]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[140],Re([11,12]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[141],Re([11,12]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[142],Re([11,12]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Ae[143],Re([11,12]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Ae[144],Re([11,12]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[145],Re([11,12]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Ae[146],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[147],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[148],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[149],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[150],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[151],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[152],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[153],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[154],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[155],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[156],Re([11,12]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[157],Re([11,12]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Ae[158],Re([11,12]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(Ae[159],Re([11,12]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[160],Re([11,12]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[161],Re([11,12]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[162],Re([11,12]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[163],Re([11,12]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[164],Re([11,12]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[165],Re([11,12]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[166],Re([1,0,9,139]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var C;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(C||(e.TokenType=C={}));function M(...g){switch(g.length){case 1:return(0,k.localize)(0,null,g[0]);case 2:return(0,k.localize)(1,null,g[0],g[1]);case 3:return(0,k.localize)(2,null,g[0],g[1],g[2]);default:return}}const F=(0,k.localize)(3,null),f=(0,k.localize)(4,null);class D{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,m.illegalState)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(R){return this._input=R,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const y=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:y})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const y=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:y})}else this._match(126)?this._addToken(9):this._error(M("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(M("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(R){return this._isAtEnd()||this._input.charCodeAt(this._current)!==R?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(R){this._tokens.push({type:R,offset:this._start})}_error(R){const y=this._start,d=this._input.substring(this._start,this._current),E={type:19,offset:this._start,lexeme:d};this._errors.push({offset:y,lexeme:d,additionalInfo:R}),this._tokens.push(E)}_string(){this.stringRe.lastIndex=this._start;const R=this.stringRe.exec(this._input);if(R){this._current=this._start+R[0].length;const y=this._input.substring(this._start,this._current),d=D._keywords.get(y);d?this._addToken(d):this._tokens.push({type:17,lexeme:y,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(F);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let R=this._current,y=!1,d=!1;for(;;){if(R>=this._input.length){this._current=R,this._error(f);return}const p=this._input.charCodeAt(R);if(y)y=!1;else if(p===47&&!d){R++;break}else p===91?d=!0:p===92?y=!0:p===93&&(d=!1);R++}for(;R<this._input.length&&D._regexFlags.has(this._input.charCodeAt(R));)R++;this._current=R;const E=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:E,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=D,D._regexFlags=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0))),D._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Ae[167],Re([1,0,20,29,141,270]),function(te,e,m,k,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,f=/^-(\d{4})(\d{2})(\d{2})$/;function D(r){return r=r.trim(),r==="*"||F.test(r)}e.isValidVersionStr=D;function g(r){if(!D(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=r.match(F);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.parseVersion=g;function R(r){if(!r)return null;const c=r.majorBase,b=r.majorMustEqual,w=r.minorBase;let _=r.minorMustEqual;const i=r.patchBase;let u=r.patchMustEqual;r.hasCaret&&(c===0||(_=!1),u=!1);let n=0;if(r.preRelease){const s=f.exec(r.preRelease);if(s){const[,v,I,h]=s;n=Date.UTC(Number(v),Number(I)-1,Number(h))}}return{majorBase:c,majorMustEqual:b,minorBase:w,minorMustEqual:_,patchBase:i,patchMustEqual:u,isMinimum:r.hasGreaterEquals,notBefore:n}}e.normalizeVersion=R;function y(r,c,b){let w;typeof r=="string"?w=R(g(r)):w=r;let _;c instanceof Date?_=c.getTime():typeof c=="string"&&(_=new Date(c).getTime());let i;if(typeof b=="string"?i=R(g(b)):i=b,!w||!i)return!1;const u=w.majorBase,n=w.minorBase,s=w.patchBase;let v=i.majorBase,I=i.minorBase,h=i.patchBase;const T=i.notBefore;let S=i.majorMustEqual,a=i.minorMustEqual,o=i.patchMustEqual;return i.isMinimum?u>v?!0:u<v?!1:n>I?!0:n<I||_&&_<T?!1:s>=h:(u===1&&v===0&&(!S||!a||!o)&&(v=1,I=0,h=0,S=!0,a=!1,o=!1),u<v?!1:u>v?!S:n<I?!1:n>I?!a:s<h?!1:s>h?!o:!(_&&_<T))}e.isValidVersion=y;function d(r,c,b,w,_){const i=[];if(typeof w.publisher<"u"&&typeof w.publisher!="string")return i.push([k.default.Error,C.localize(0,null)]),i;if(typeof w.name!="string")return i.push([k.default.Error,C.localize(1,null,"name")]),i;if(typeof w.version!="string")return i.push([k.default.Error,C.localize(2,null,"version")]),i;if(!w.engines)return i.push([k.default.Error,C.localize(3,null,"engines")]),i;if(typeof w.engines.vscode!="string")return i.push([k.default.Error,C.localize(4,null,"engines.vscode")]),i;if(typeof w.extensionDependencies<"u"&&!t(w.extensionDependencies))return i.push([k.default.Error,C.localize(5,null,"extensionDependencies")]),i;if(typeof w.activationEvents<"u"){if(!t(w.activationEvents))return i.push([k.default.Error,C.localize(6,null,"activationEvents")]),i;if(typeof w.main>"u"&&typeof w.browser>"u")return i.push([k.default.Error,C.localize(7,null,"activationEvents","main","browser")]),i}if(typeof w.extensionKind<"u"&&typeof w.main>"u"&&i.push([k.default.Warning,C.localize(8,null,"extensionKind")]),typeof w.main<"u"){if(typeof w.main!="string")return i.push([k.default.Error,C.localize(9,null,"main")]),i;{const s=(0,m.joinPath)(b,w.main);(0,m.isEqualOrParent)(s,b)||i.push([k.default.Warning,C.localize(10,null,s.path,b.path)])}}if(typeof w.browser<"u"){if(typeof w.browser!="string")return i.push([k.default.Error,C.localize(11,null,"browser")]),i;{const s=(0,m.joinPath)(b,w.browser);(0,m.isEqualOrParent)(s,b)||i.push([k.default.Warning,C.localize(12,null,s.path,b.path)])}}if(!M.valid(w.version))return i.push([k.default.Error,C.localize(13,null)]),i;const u=[];if(!E(r,c,w,_,u))for(const s of u)i.push([k.default.Error,s]);return i}e.validateExtensionManifest=d;function E(r,c,b,w,_){return w||typeof b.main>"u"&&typeof b.browser>"u"?!0:l(r,c,b.engines.vscode,_)}e.isValidExtensionVersion=E;function p(r,c,b){return r==="*"||l(c,b,r)}e.isEngineValid=p;function l(r,c,b,w=[]){const _=R(g(b));if(!_)return w.push(C.localize(14,null,b)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return w.push(C.localize(15,null,b)),!1}else if(!_.majorMustEqual)return w.push(C.localize(16,null,b)),!1;return y(r,c,_)?!0:(w.push(C.localize(17,null,r,b)),!1)}function t(r){if(!Array.isArray(r))return!1;for(let c=0,b=r.length;c<b;c++)if(typeof r[c]!="string")return!1;return!0}}),define(Ae[71],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(C,M=[],F=!1){this.ctor=C,this.staticArguments=M,this.supportsDelayedInstantiation=F}}e.SyncDescriptor=m}),define(Ae[72],Re([1,0,71]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const k=[];var C;(function(f){f[f.Eager=0]="Eager",f[f.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function M(f,D,g){D instanceof m.SyncDescriptor||(D=new m.SyncDescriptor(D,[],!!g)),k.push([f,D])}e.registerSingleton=M;function F(){return k}e.getSingletonServiceDescriptors=F}),define(Ae[168],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(M,F){this.key=M,this.data=F,this.incoming=new Map,this.outgoing=new Map}}e.Node=m;class k{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(const F of this._nodes.values())F.outgoing.size===0&&M.push(F);return M}insertEdge(M,F){const f=this.lookupOrInsertNode(M),D=this.lookupOrInsertNode(F);f.outgoing.set(D.key,D),D.incoming.set(f.key,f)}removeNode(M){const F=this._hashFn(M);this._nodes.delete(F);for(const f of this._nodes.values())f.outgoing.delete(F),f.incoming.delete(F)}lookupOrInsertNode(M){const F=this._hashFn(M);let f=this._nodes.get(F);return f||(f=new m(F,M),this._nodes.set(F,f)),f}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){const M=[];for(const[F,f]of this._nodes)M.push(`${F}
	(-> incoming)[${[...f.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...f.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,F]of this._nodes){const f=new Set([M]),D=this._findCycle(F,f);if(D)return D}}_findCycle(M,F){for(const[f,D]of M.outgoing){if(F.has(f))return[...F,f].join(" -> ");F.add(f);const g=this._findCycle(D,F);if(g)return g;F.delete(f)}}}e.Graph=k}),define(Ae[3],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(F){F.serviceIds=new Map,F.DI_TARGET="$di$target",F.DI_DEPENDENCIES="$di$dependencies";function f(D){return D[F.DI_DEPENDENCIES]||[]}F.getServiceDependencies=f})(m||(e._util=m={})),e.IInstantiationService=C("instantiationService");function k(F,f,D){f[m.DI_TARGET]===f?f[m.DI_DEPENDENCIES].push({id:F,index:D}):(f[m.DI_DEPENDENCIES]=[{id:F,index:D}],f[m.DI_TARGET]=f)}function C(F){if(m.serviceIds.has(F))return m.serviceIds.get(F);const f=function(D,g,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(f,D,R)};return f.toString=()=>F,m.serviceIds.set(F,f),f}e.createDecorator=C;function M(F){return F}e.refineServiceDecorator=M}),define(Ae[43],Re([1,0,10,2,3]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function M(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof k.URI)}e.isConfigurationOverrides=M;function F(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof k.URI)}e.isConfigurationUpdateOverrides=F;var f;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(f||(e.ConfigurationTarget=f={}));function D(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=D;function g(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}e.isConfigured=g;function R(r,c){const b=Object.create(null);for(const w in r)y(b,w,r[w],c);return b}e.toValuesTree=R;function y(r,c,b,w){const _=c.split("."),i=_.pop();let u=r;for(let n=0;n<_.length;n++){const s=_[n];let v=u[s];switch(typeof v){case"undefined":v=u[s]=Object.create(null);break;case"object":break;default:w(`Ignoring ${c} as ${_.slice(0,n+1).join(".")} is ${JSON.stringify(v)}`);return}u=v}if(typeof u=="object"&&u!==null)try{u[i]=b}catch{w(`Ignoring ${c} as ${_.join(".")} is ${JSON.stringify(u)}`)}else w(`Ignoring ${c} as ${_.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=y;function d(r,c){const b=c.split(".");E(r,b)}e.removeFromValueTree=d;function E(r,c){const b=c.shift();if(c.length===0){delete r[b];return}if(Object.keys(r).indexOf(b)!==-1){const w=r[b];typeof w=="object"&&!Array.isArray(w)&&(E(w,c),Object.keys(w).length===0&&delete r[b])}}function p(r,c,b){function w(u,n){let s=u;for(const v of n){if(typeof s!="object"||s===null)return;s=s[v]}return s}const _=c.split("."),i=w(r,_);return typeof i>"u"?b:i}e.getConfigurationValue=p;function l(r,c,b){Object.keys(c).forEach(w=>{w!=="__proto__"&&(w in r?m.isObject(r[w])&&m.isObject(c[w])?l(r[w],c[w],b):b&&(r[w]=c[w]):r[w]=c[w])})}e.merge=l;function t(r){return r.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=t}),define(Ae[31],Re([1,0,21,13,166,3,138,9]),function(te,e,m,k,C,M,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",m.isMacintosh),D.set("isLinux",m.isLinux),D.set("isWindows",m.isWindows),D.set("isWeb",m.isWeb),D.set("isMacNative",m.isMacintosh&&!m.isWeb),D.set("isEdge",m.isEdge),D.set("isFirefox",m.isFirefox),D.set("isChrome",m.isChrome),D.set("isSafari",m.isSafari);function g(ge,A){if(D.get(ge)!==void 0)throw(0,f.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(ge,A)}e.setConstant=g;const R=Object.prototype.hasOwnProperty;var y;(function(ge){ge[ge.False=0]="False",ge[ge.True=1]="True",ge[ge.Defined=2]="Defined",ge[ge.Not=3]="Not",ge[ge.Equals=4]="Equals",ge[ge.NotEquals=5]="NotEquals",ge[ge.And=6]="And",ge[ge.Regex=7]="Regex",ge[ge.NotRegex=8]="NotRegex",ge[ge.Or=9]="Or",ge[ge.In=10]="In",ge[ge.NotIn=11]="NotIn",ge[ge.Greater=12]="Greater",ge[ge.GreaterEquals=13]="GreaterEquals",ge[ge.Smaller=14]="Smaller",ge[ge.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const d={regexParsingWithErrorRecovery:!0},E=(0,F.localize)(0,null),p=(0,F.localize)(1,null),l=(0,F.localize)(2,null),t=(0,F.localize)(3,null),r=(0,F.localize)(4,null),c=(0,F.localize)(5,null),b=(0,F.localize)(6,null),w=(0,F.localize)(7,null);class _{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(A=d){this._config=A,this._scanner=new C.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(A){if(A===""){this._parsingErrors.push({message:E,offset:0,lexeme:"",additionalInfo:p});return}this._tokens=this._scanner.reset(A).scan(),this._current=0,this._parsingErrors=[];try{const G=this._expr();if(!this._isAtEnd()){const de=this._peek(),ye=de.type===17?c:void 0;throw this._parsingErrors.push({message:r,offset:de.offset,lexeme:C.Scanner.getLexeme(de),additionalInfo:ye}),_._parseError}return G}catch(G){if(G!==_._parseError)throw G;return}}_expr(){return this._or()}_or(){const A=[this._and()];for(;this._matchOne(16);){const G=this._and();A.push(G)}return A.length===1?A[0]:i.or(...A)}_and(){const A=[this._term()];for(;this._matchOne(15);){const G=this._term();A.push(G)}return A.length===1?A[0]:i.and(...A)}_term(){if(this._matchOne(2)){const A=this._peek();switch(A.type){case 11:return this._advance(),v.INSTANCE;case 12:return this._advance(),I.INSTANCE;case 0:{this._advance();const G=this._expr();return this._consume(1,t),G?.negate()}case 17:return this._advance(),O.create(A.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",A)}}return this._primary()}_primary(){const A=this._peek();switch(A.type){case 11:return this._advance(),i.true();case 12:return this._advance(),i.false();case 0:{this._advance();const G=this._expr();return this._consume(1,t),G}case 17:{const G=A.lexeme;if(this._advance(),this._matchOne(9)){const ye=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),ye.type!==10)throw this._errExpectedButGot("REGEX",ye);const _e=ye.lexeme,pe=_e.lastIndexOf("/"),Ce=pe===_e.length-1?void 0:this._removeFlagsGY(_e.substring(pe+1));let ae;try{ae=new RegExp(_e.substring(1,pe),Ce)}catch{throw this._errExpectedButGot("REGEX",ye)}return q.create(G,ae)}switch(ye.type){case 10:case 19:{const _e=[ye.lexeme];this._advance();let pe=this._peek(),Ce=0;for(let P=0;P<ye.lexeme.length;P++)ye.lexeme.charCodeAt(P)===40?Ce++:ye.lexeme.charCodeAt(P)===41&&Ce--;for(;!this._isAtEnd()&&pe.type!==15&&pe.type!==16;){switch(pe.type){case 0:Ce++;break;case 1:Ce--;break;case 10:case 18:for(let P=0;P<pe.lexeme.length;P++)pe.lexeme.charCodeAt(P)===40?Ce++:ye.lexeme.charCodeAt(P)===41&&Ce--}if(Ce<0)break;_e.push(C.Scanner.getLexeme(pe)),this._advance(),pe=this._peek()}const ae=_e.join(""),ue=ae.lastIndexOf("/"),ne=ue===ae.length-1?void 0:this._removeFlagsGY(ae.substring(ue+1));let ee;try{ee=new RegExp(ae.substring(1,ue),ne)}catch{throw this._errExpectedButGot("REGEX",ye)}return i.regex(G,ee)}case 18:{const _e=ye.lexeme;this._advance();let pe=null;if(!(0,k.isFalsyOrWhitespace)(_e)){const Ce=_e.indexOf("/"),ae=_e.lastIndexOf("/");if(Ce!==ae&&Ce>=0){const ue=_e.slice(Ce+1,ae),ne=_e[ae+1]==="i"?"i":"";try{pe=new RegExp(ue,ne)}catch{throw this._errExpectedButGot("REGEX",ye)}}}if(pe===null)throw this._errExpectedButGot("REGEX",ye);return q.create(G,pe)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,l);const ye=this._value();return i.notIn(G,ye)}switch(this._peek().type){case 3:{this._advance();const ye=this._value();if(this._previous().type===18)return i.equals(G,ye);switch(ye){case"true":return i.has(G);case"false":return i.not(G);default:return i.equals(G,ye)}}case 4:{this._advance();const ye=this._value();if(this._previous().type===18)return i.notEquals(G,ye);switch(ye){case"true":return i.not(G);case"false":return i.has(G);default:return i.notEquals(G,ye)}}case 5:return this._advance(),z.create(G,this._value());case 6:return this._advance(),N.create(G,this._value());case 7:return this._advance(),K.create(G,this._value());case 8:return this._advance(),V.create(G,this._value());case 13:return this._advance(),i.in(G,this._value());default:return i.has(G)}}case 20:throw this._parsingErrors.push({message:b,offset:A.offset,lexeme:"",additionalInfo:w}),_._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const A=this._peek();switch(A.type){case 17:case 18:return this._advance(),A.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(A){return A.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(A){return this._check(A)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(A,G){if(this._check(A))return this._advance();throw this._errExpectedButGot(G,this._peek())}_errExpectedButGot(A,G,de){const ye=(0,F.localize)(8,null,A,C.Scanner.getLexeme(G)),_e=G.offset,pe=C.Scanner.getLexeme(G);return this._parsingErrors.push({message:ye,offset:_e,lexeme:pe,additionalInfo:de}),_._parseError}_check(A){return this._peek().type===A}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=_,_._parseError=new Error;class i{static false(){return v.INSTANCE}static true(){return I.INSTANCE}static has(A){return h.create(A)}static equals(A,G){return T.create(A,G)}static notEquals(A,G){return o.create(A,G)}static regex(A,G){return q.create(A,G)}static in(A,G){return S.create(A,G)}static notIn(A,G){return a.create(A,G)}static not(A){return O.create(A)}static and(...A){return le.create(A,null,!0)}static or(...A){return ve.create(A,null,!0)}static greater(A,G){return K.create(A,G)}static greaterEquals(A,G){return V.create(A,G)}static smaller(A,G){return z.create(A,G)}static smallerEquals(A,G){return N.create(A,G)}static deserialize(A){return A==null?void 0:this._parser.parse(A)}}e.ContextKeyExpr=i,i._parser=new _({regexParsingWithErrorRecovery:!1});function u(ge){const A=new _({regexParsingWithErrorRecovery:!1});return ge.map(G=>(A.parse(G),A.lexingErrors.length>0?A.lexingErrors.map(de=>({errorMessage:de.additionalInfo?(0,F.localize)(9,null,de.additionalInfo):(0,F.localize)(10,null),offset:de.offset,length:de.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(de=>({errorMessage:de.additionalInfo?`${de.message}. ${de.additionalInfo}`:de.message,offset:de.offset,length:de.lexeme.length})):[]))}e.validateWhenClauses=u;function n(ge,A){const G=ge?ge.substituteConstants():void 0,de=A?A.substituteConstants():void 0;return!G&&!de?!0:!G||!de?!1:G.equals(de)}e.expressionsAreEqualWithConstantSubstitution=n;function s(ge,A){return ge.cmp(A)}class v{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return I.INSTANCE}}e.ContextKeyFalseExpr=v,v.INSTANCE=new v;class I{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return v.INSTANCE}}e.ContextKeyTrueExpr=I,I.INSTANCE=new I;class h{static create(A,G=null){const de=D.get(A);return typeof de=="boolean"?de?I.INSTANCE:v.INSTANCE:new h(A,G)}constructor(A,G){this.key=A,this.negated=G,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:J(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=D.get(this.key);return typeof A=="boolean"?A?I.INSTANCE:v.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=O.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class T{static create(A,G,de=null){if(typeof G=="boolean")return G?h.create(A,de):O.create(A,de);const ye=D.get(A);return typeof ye=="boolean"?G===(ye?"true":"false")?I.INSTANCE:v.INSTANCE:new T(A,G,de)}constructor(A,G,de){this.key=A,this.value=G,this.negated=de,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:X(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=D.get(this.key);if(typeof A=="boolean"){const G=A?"true":"false";return this.value===G?I.INSTANCE:v.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=T;class S{static create(A,G){return new S(A,G)}constructor(A,G){this.key=A,this.valueKey=G,this.type=10,this.negated=null}cmp(A){return A.type!==this.type?this.type-A.type:X(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const G=A.getValue(this.valueKey),de=A.getValue(this.key);return Array.isArray(G)?G.includes(de):typeof de=="string"&&typeof G=="object"&&G!==null?R.call(G,de):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=a.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=S;class a{static create(A,G){return new a(A,G)}constructor(A,G){this.key=A,this.valueKey=G,this.type=11,this._negated=S.create(A,G)}cmp(A){return A.type!==this.type?this.type-A.type:this._negated.cmp(A._negated)}equals(A){return A.type===this.type?this._negated.equals(A._negated):!1}substituteConstants(){return this}evaluate(A){return!this._negated.evaluate(A)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(A){return A.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=a;class o{static create(A,G,de=null){if(typeof G=="boolean")return G?O.create(A,de):h.create(A,de);const ye=D.get(A);return typeof ye=="boolean"?G===(ye?"true":"false")?v.INSTANCE:I.INSTANCE:new o(A,G,de)}constructor(A,G,de){this.key=A,this.value=G,this.negated=de,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:X(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=D.get(this.key);if(typeof A=="boolean"){const G=A?"true":"false";return this.value===G?v.INSTANCE:I.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=T.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=o;class O{static create(A,G=null){const de=D.get(A);return typeof de=="boolean"?de?v.INSTANCE:I.INSTANCE:new O(A,G)}constructor(A,G){this.key=A,this.negated=G,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:J(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=D.get(this.key);return typeof A=="boolean"?A?v.INSTANCE:I.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=O;function $(ge,A){if(typeof ge=="string"){const G=parseFloat(ge);isNaN(G)||(ge=G)}return typeof ge=="string"||typeof ge=="number"?A(ge):v.INSTANCE}class K{static create(A,G,de=null){return $(G,ye=>new K(A,ye,de))}constructor(A,G,de){this.key=A,this.value=G,this.negated=de,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:X(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=K;class V{static create(A,G,de=null){return $(G,ye=>new V(A,ye,de))}constructor(A,G,de){this.key=A,this.value=G,this.negated=de,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:X(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=V;class z{static create(A,G,de=null){return $(G,ye=>new z(A,ye,de))}constructor(A,G,de){this.key=A,this.value=G,this.negated=de,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:X(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=V.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=z;class N{static create(A,G,de=null){return $(G,ye=>new N(A,ye,de))}constructor(A,G,de){this.key=A,this.value=G,this.negated=de,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:X(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=K.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=N;class q{static create(A,G){return new q(A,G)}constructor(A,G){this.key=A,this.regexp=G,this.type=7,this.negated=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const G=this.regexp?this.regexp.source:"",de=A.regexp?A.regexp.source:"";return G<de?-1:G>de?1:0}equals(A){if(A.type===this.type){const G=this.regexp?this.regexp.source:"",de=A.regexp?A.regexp.source:"";return this.key===A.key&&G===de}return!1}substituteConstants(){return this}evaluate(A){const G=A.getValue(this.key);return this.regexp?this.regexp.test(G):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=B.create(this)),this.negated}}e.ContextKeyRegexExpr=q;class B{static create(A){return new B(A)}constructor(A){this._actual=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(A){return new B(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=B;function U(ge){let A=null;for(let G=0,de=ge.length;G<de;G++){const ye=ge[G].substituteConstants();if(ge[G]!==ye&&A===null){A=[];for(let _e=0;_e<G;_e++)A[_e]=ge[_e]}A!==null&&(A[G]=ye)}return A===null?ge:A}class le{static create(A,G,de){return le._normalizeArr(A,G,de)}constructor(A,G){this.expr=A,this.negated=G,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let G=0,de=this.expr.length;G<de;G++){const ye=s(this.expr[G],A.expr[G]);if(ye!==0)return ye}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let G=0,de=this.expr.length;G<de;G++)if(!this.expr[G].equals(A.expr[G]))return!1;return!0}return!1}substituteConstants(){const A=U(this.expr);return A===this.expr?this:le.create(A,this.negated,!1)}evaluate(A){for(let G=0,de=this.expr.length;G<de;G++)if(!this.expr[G].evaluate(A))return!1;return!0}static _normalizeArr(A,G,de){const ye=[];let _e=!1;for(const pe of A)if(pe){if(pe.type===1){_e=!0;continue}if(pe.type===0)return v.INSTANCE;if(pe.type===6){ye.push(...pe.expr);continue}ye.push(pe)}if(ye.length===0&&_e)return I.INSTANCE;if(ye.length!==0){if(ye.length===1)return ye[0];ye.sort(s);for(let pe=1;pe<ye.length;pe++)ye[pe-1].equals(ye[pe])&&(ye.splice(pe,1),pe--);if(ye.length===1)return ye[0];for(;ye.length>1;){const pe=ye[ye.length-1];if(pe.type!==9)break;ye.pop();const Ce=ye.pop(),ae=ye.length===0,ue=ve.create(pe.expr.map(ne=>le.create([ne,Ce],null,de)),null,ae);ue&&(ye.push(ue),ye.sort(s))}if(ye.length===1)return ye[0];if(de){for(let pe=0;pe<ye.length;pe++)for(let Ce=pe+1;Ce<ye.length;Ce++)if(ye[pe].negate().equals(ye[Ce]))return v.INSTANCE;if(ye.length===1)return ye[0]}return new le(ye,G)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const G of this.expr)A.push(...G.keys());return A}map(A){return new le(this.expr.map(G=>G.map(A)),null)}negate(){if(!this.negated){const A=[];for(const G of this.expr)A.push(G.negate());this.negated=ve.create(A,this,!0)}return this.negated}}e.ContextKeyAndExpr=le;class ve{static create(A,G,de){return ve._normalizeArr(A,G,de)}constructor(A,G){this.expr=A,this.negated=G,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let G=0,de=this.expr.length;G<de;G++){const ye=s(this.expr[G],A.expr[G]);if(ye!==0)return ye}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let G=0,de=this.expr.length;G<de;G++)if(!this.expr[G].equals(A.expr[G]))return!1;return!0}return!1}substituteConstants(){const A=U(this.expr);return A===this.expr?this:ve.create(A,this.negated,!1)}evaluate(A){for(let G=0,de=this.expr.length;G<de;G++)if(this.expr[G].evaluate(A))return!0;return!1}static _normalizeArr(A,G,de){let ye=[],_e=!1;if(A){for(let pe=0,Ce=A.length;pe<Ce;pe++){const ae=A[pe];if(ae){if(ae.type===0){_e=!0;continue}if(ae.type===1)return I.INSTANCE;if(ae.type===9){ye=ye.concat(ae.expr);continue}ye.push(ae)}}if(ye.length===0&&_e)return v.INSTANCE;ye.sort(s)}if(ye.length!==0){if(ye.length===1)return ye[0];for(let pe=1;pe<ye.length;pe++)ye[pe-1].equals(ye[pe])&&(ye.splice(pe,1),pe--);if(ye.length===1)return ye[0];if(de){for(let pe=0;pe<ye.length;pe++)for(let Ce=pe+1;Ce<ye.length;Ce++)if(ye[pe].negate().equals(ye[Ce]))return I.INSTANCE;if(ye.length===1)return ye[0]}return new ve(ye,G)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const G of this.expr)A.push(...G.keys());return A}map(A){return new ve(this.expr.map(G=>G.map(A)),null)}negate(){if(!this.negated){const A=[];for(const G of this.expr)A.push(G.negate());for(;A.length>1;){const G=A.shift(),de=A.shift(),ye=[];for(const _e of ke(G))for(const pe of ke(de))ye.push(le.create([_e,pe],null,!1));A.unshift(ve.create(ye,null,!1))}this.negated=ve.create(A,this,!0)}return this.negated}}e.ContextKeyOrExpr=ve;class Pe extends h{static all(){return Pe._info.values()}constructor(A,G,de){super(A,null),this._defaultValue=G,typeof de=="object"?Pe._info.push({...de,key:A}):de!==!0&&Pe._info.push({key:A,description:de,type:G!=null?typeof G:void 0})}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return T.create(this.key,A)}notEqualsTo(A){return o.create(this.key,A)}}e.RawContextKey=Pe,Pe._info=[],e.IContextKeyService=(0,M.createDecorator)("contextKeyService");function J(ge,A){return ge<A?-1:ge>A?1:0}function X(ge,A,G,de){return ge<G?-1:ge>G?1:A<de?-1:A>de?1:0}function ce(ge,A){if(ge.type===0||A.type===1)return!0;if(ge.type===9)return A.type===9?De(ge.expr,A.expr):!1;if(A.type===9){for(const G of A.expr)if(ce(ge,G))return!0;return!1}if(ge.type===6){if(A.type===6)return De(A.expr,ge.expr);for(const G of ge.expr)if(ce(G,A))return!0;return!1}return ge.equals(A)}e.implies=ce;function De(ge,A){let G=0,de=0;for(;G<ge.length&&de<A.length;){const ye=ge[G].cmp(A[de]);if(ye<0)return!1;ye===0&&G++,de++}return G===ge.length}function ke(ge){return ge.type===9?ge.expr:[ge]}}),define(Ae[169],Re([1,0,3]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(Ae[92],Re([1,0,140,3]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function C(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=C;function M(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function F(c,b){switch(c){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":b==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=F;function f(c,b){return b==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=f;function D(c,b,w){return f(b,w)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===w?!0:g(w).includes(c)}e.isTargetPlatformCompatible=D;function g(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=g;function R(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=R;var y;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var d;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var E;(function(c){c.Install="install",c.Uninstall="uninstall"})(E||(e.StatisticType=E={}));var p;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var l;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(l||(e.ExtensionManagementErrorCode=l={}));var t;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class r extends Error{constructor(b,w){super(b),this.code=w,this.name=w}}e.ExtensionManagementError=r,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,m.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,m.localize)(1,null),original:"Preferences"}}),define(Ae[38],Re([1,0,48,19,13,10,2,142,3,21,14]),function(te,e,m,k,C,M,F,f,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function y(J){return J.create===!0}e.isFileOpenForWriteOptions=y;var d;(function(J){J[J.Unknown=0]="Unknown",J[J.File=1]="File",J[J.Directory=2]="Directory",J[J.SymbolicLink=64]="SymbolicLink"})(d||(e.FileType=d={}));var E;(function(J){J[J.Readonly=1]="Readonly",J[J.Locked=2]="Locked"})(E||(e.FilePermission=E={}));var p;(function(J){J[J.None=0]="None",J[J.FileReadWrite=2]="FileReadWrite",J[J.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",J[J.FileReadStream=16]="FileReadStream",J[J.FileFolderCopy=8]="FileFolderCopy",J[J.PathCaseSensitive=1024]="PathCaseSensitive",J[J.Readonly=2048]="Readonly",J[J.Trash=4096]="Trash",J[J.FileWriteUnlock=8192]="FileWriteUnlock",J[J.FileAtomicRead=16384]="FileAtomicRead",J[J.FileAtomicWrite=32768]="FileAtomicWrite",J[J.FileAtomicDelete=65536]="FileAtomicDelete",J[J.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function l(J){return!!(J.capabilities&2)}e.hasReadWriteCapability=l;function t(J){return!!(J.capabilities&8)}e.hasFileFolderCopyCapability=t;function r(J){return!!(J.capabilities&131072)}e.hasFileCloneCapability=r;function c(J){return!!(J.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function b(J){return!!(J.capabilities&16)}e.hasFileReadStreamCapability=b;function w(J){return l(J)?!!(J.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;function _(J){return l(J)?!!(J.capabilities&32768):!1}e.hasFileAtomicWriteCapability=_;function i(J){return!!(J.capabilities&65536)}e.hasFileAtomicDeleteCapability=i;function u(J){return!!(J.capabilities&2048)}e.hasReadonlyCapability=u;var n;(function(J){J.FileExists="EntryExists",J.FileNotFound="EntryNotFound",J.FileNotADirectory="EntryNotADirectory",J.FileIsADirectory="EntryIsADirectory",J.FileExceedsStorageQuota="EntryExceedsStorageQuota",J.FileTooLarge="EntryTooLarge",J.FileWriteLocked="EntryWriteLocked",J.NoPermissions="NoPermissions",J.Unavailable="Unavailable",J.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class s extends Error{static create(X,ce){const De=new s(X.toString(),ce);return h(De,ce),De}constructor(X,ce){super(X),this.code=ce}}e.FileSystemProviderError=s;function v(J,X){return s.create(J,X)}e.createFileSystemProviderError=v;function I(J){return J||v((0,f.localize)(0,null),n.Unknown)}e.ensureFileSystemProviderError=I;function h(J,X){return J.name=X?`${X} (FileSystemError)`:"FileSystemError",J}e.markAsFileSystemProviderError=h;function T(J){if(!J)return n.Unknown;if(J instanceof s)return J.code;const X=/^(.+) \(FileSystemError\)$/.exec(J.name);if(!X)return n.Unknown;switch(X[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.toFileSystemProviderErrorCode=T;function S(J){if(J instanceof V)return J.fileOperationResult;switch(T(J)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=S;var a;(function(J){J[J.CREATE=0]="CREATE",J[J.DELETE=1]="DELETE",J[J.MOVE=2]="MOVE",J[J.COPY=3]="COPY",J[J.WRITE=4]="WRITE"})(a||(e.FileOperation=a={}));class o{constructor(X,ce,De){this.resource=X,this.operation=ce,this.target=De}isOperation(X){return this.operation===X}}e.FileOperationEvent=o;var O;(function(J){J[J.UPDATED=0]="UPDATED",J[J.ADDED=1]="ADDED",J[J.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class ${constructor(X,ce){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const De=new Map;for(const ke of X){const ge=De.get(ke.type);switch(ge?ge.push([ke.resource,ke]):De.set(ke.type,[[ke.resource,ke]]),ke.type){case 1:this.rawAdded.push(ke.resource);break;case 0:this.rawUpdated.push(ke.resource);break;case 2:this.rawDeleted.push(ke.resource);break}}for(const[ke,ge]of De)switch(ke){case 1:this.added=m.TernarySearchTree.forUris(()=>ce),this.added.fill(ge);break;case 0:this.updated=m.TernarySearchTree.forUris(()=>ce),this.updated.fill(ge);break;case 2:this.deleted=m.TernarySearchTree.forUris(()=>ce),this.deleted.fill(ge);break}}contains(X,...ce){return this.doContains(X,{includeChildren:!1},...ce)}affects(X,...ce){return this.doContains(X,{includeChildren:!0},...ce)}doContains(X,ce,...De){if(!X)return!1;const ke=De.length>0;return!!((!ke||De.includes(1))&&(this.added?.get(X)||ce.includeChildren&&this.added?.findSuperstr(X))||(!ke||De.includes(0))&&(this.updated?.get(X)||ce.includeChildren&&this.updated?.findSuperstr(X))||(!ke||De.includes(2))&&(this.deleted?.findSubstr(X)||ce.includeChildren&&this.deleted?.findSuperstr(X)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=$;function K(J,X,ce){return!J||!X||J===X||X.length>J.length?!1:(X.charAt(X.length-1)!==k.sep&&(X+=k.sep),ce?(0,C.startsWithIgnoreCase)(J,X):J.indexOf(X)===0)}e.isParent=K;class V extends Error{constructor(X,ce,De){super(X),this.fileOperationResult=ce,this.options=De}}e.FileOperationError=V;class z extends V{constructor(X,ce,De,ke){super(X,ce,ke),this.fileOperationResult=ce,this.size=De}}e.TooLargeFileOperationError=z;class N extends V{constructor(X,ce,De){super(X,2,De),this.stat=ce}}e.NotModifiedSinceFileOperationError=N;var q;(function(J){J[J.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",J[J.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",J[J.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",J[J.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",J[J.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",J[J.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",J[J.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",J[J.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",J[J.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",J[J.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",J[J.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(q||(e.FileOperationResult=q={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var B;(function(J){J[J.FILE=0]="FILE",J[J.FOLDER=1]="FOLDER",J[J.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.ETAG_DISABLED="";function U(J){if(!(typeof J.size!="number"||typeof J.mtime!="number"))return J.mtime.toString(29)+J.size.toString(31)}e.etag=U;async function le(J,X){if(!X.hasProvider(F.URI.from({scheme:J.scheme})))return new Promise(ce=>{const De=X.onDidChangeFileSystemProviderRegistrations(ke=>{ke.scheme===J.scheme&&ke.added&&(De.dispose(),ce())})})}e.whenProviderRegistered=le;class ve{static formatSize(X){return(0,M.isNumber)(X)||(X=0),X<ve.KB?(0,f.localize)(1,null,X.toFixed(0)):X<ve.MB?(0,f.localize)(2,null,(X/ve.KB).toFixed(2)):X<ve.GB?(0,f.localize)(3,null,(X/ve.MB).toFixed(2)):X<ve.TB?(0,f.localize)(4,null,(X/ve.GB).toFixed(2)):(0,f.localize)(5,null,(X/ve.TB).toFixed(2))}}e.ByteSize=ve,ve.KB=1024,ve.MB=ve.KB*ve.KB,ve.GB=ve.MB*ve.KB,ve.TB=ve.GB*ve.KB;function Pe(J){const X=typeof J=="string"||J?.scheme===R.Schemas.vscodeRemote;return typeof J!="string"&&J?.scheme===R.Schemas.file?1024*ve.MB:X?10*ve.MB:g.isWeb?50*ve.MB:1024*ve.MB}e.getLargeFileConfirmationLimit=Pe}),define(Ae[73],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...C){this._entries=new Map;for(const[M,F]of C)this.set(M,F)}set(C,M){const F=this._entries.get(C);return this._entries.set(C,M),F}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=m}),define(Ae[170],Re([1,0,16,9,6,71,168,3,73,171]),function(te,e,m,k,C,M,F,f,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class y extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class d{constructor(t=new D.ServiceCollection,r=!1,c,b=R){this._services=t,this._strict=r,this._parent=c,this._enableTracing=b,this._activeInstantiations=new Set,this._services.set(f.IInstantiationService,this),this._globalGraph=b?c?._globalGraph??new F.Graph(w=>w):void 0}createChild(t){return new d(t,this._strict,this,this._enableTracing)}invokeFunction(t,...r){const c=p.traceInvocation(this._enableTracing,t);let b=!1;try{return t({get:_=>{if(b)throw(0,k.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(_,c);if(!i)throw new Error(`[invokeFunction] unknown service '${_}'`);return i}},...r)}finally{b=!0,c.stop()}}createInstance(t,...r){let c,b;return t instanceof M.SyncDescriptor?(c=p.traceCreation(this._enableTracing,t.ctor),b=this._createInstance(t.ctor,t.staticArguments.concat(r),c)):(c=p.traceCreation(this._enableTracing,t),b=this._createInstance(t,r,c)),c.stop(),b}_createInstance(t,r=[],c){const b=f._util.getServiceDependencies(t).sort((i,u)=>i.index-u.index),w=[];for(const i of b){const u=this._getOrCreateServiceInstance(i.id,c);u||this._throwIfStrict(`[createInstance] ${t.name} depends on UNKNOWN service ${i.id}.`,!1),w.push(u)}const _=b.length>0?b[0].index:r.length;if(r.length!==_){console.trace(`[createInstance] First service dependency of ${t.name} at position ${_+1} conflicts with ${r.length} static arguments`);const i=_-r.length;i>0?r=r.concat(new Array(i)):r=r.slice(0,_)}return Reflect.construct(t,r.concat(w))}_setServiceInstance(t,r){if(this._services.get(t)instanceof M.SyncDescriptor)this._services.set(t,r);else if(this._parent)this._parent._setServiceInstance(t,r);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){const r=this._services.get(t);return!r&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):r}_getOrCreateServiceInstance(t,r){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(t));const c=this._getServiceInstanceOrDescriptor(t);return c instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,c,r.branch(t,!0)):(r.branch(t,!1),c)}_safeCreateAndCacheServiceInstance(t,r,c){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,r,c)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,r,c){const b=new F.Graph(i=>i.id.toString());let w=0;const _=[{id:t,desc:r,_trace:c}];for(;_.length;){const i=_.pop();if(b.lookupOrInsertNode(i),w++>1e3)throw new y(b);for(const u of f._util.getServiceDependencies(i.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(u.id);if(n||this._throwIfStrict(`[createInstance] ${t} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(u.id)),n instanceof M.SyncDescriptor){const s={id:u.id,desc:n,_trace:i._trace.branch(u.id,!0)};b.insertEdge(i,s),_.push(s)}}}for(;;){const i=b.roots();if(i.length===0){if(!b.isEmpty())throw new y(b);break}for(const{data:u}of i){if(this._getServiceInstanceOrDescriptor(u.id)instanceof M.SyncDescriptor){const s=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,s)}b.removeNode(u)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,r,c=[],b,w){if(this._services.get(t)instanceof M.SyncDescriptor)return this._createServiceInstance(t,r,c,b,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,r,c,b,w);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}_createServiceInstance(t,r,c=[],b,w){if(b){const _=new d(void 0,this._strict,this,this._enableTracing);_._globalGraphImplicitDependency=String(t);const i=new Map,u=new m.IdleValue(()=>{const n=_._createInstance(r,c,w);for(const[s,v]of i){const I=n[s];if(typeof I=="function")for(const h of v)I.apply(n,h)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!u.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let h=i.get(s);return h||(h=new g.LinkedList,i.set(s,h)),(S,a,o)=>{const O=h.push([S,a,o]);return(0,C.toDisposable)(O)}}if(s in n)return n[s];const v=u.value;let I=v[s];return typeof I!="function"||(I=I.bind(v),n[s]=I),I},set(n,s,v){return u.value[s]=v,!0},getPrototypeOf(n){return r.prototype}})}else return this._createInstance(r,c,w)}_throwIfStrict(t,r){if(r&&console.warn(t),this._strict)throw new Error(t)}}e.InstantiationService=d;var E;(function(l){l[l.None=0]="None",l[l.Creation=1]="Creation",l[l.Invocation=2]="Invocation",l[l.Branch=3]="Branch"})(E||(E={}));class p{static traceInvocation(t,r){return t?new p(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(t,r){return t?new p(1,r.name):p._None}constructor(t,r){this.type=t,this.name=r,this._start=Date.now(),this._dep=[]}branch(t,r){const c=new p(3,t.toString());return this._dep.push([t,r,c]),c}stop(){const t=Date.now()-this._start;p._totals+=t;let r=!1;function c(w,_){const i=[],u=new Array(w+1).join("	");for(const[n,s,v]of _._dep)if(s&&v){r=!0,i.push(`${u}CREATES -> ${n}`);const I=c(w+1,v);I&&i.push(I)}else i.push(`${u}uses -> ${n}`);return i.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(t>2||r)&&p.all.add(b.join(`
`))}}e.Trace=p,p.all=new Set,p._None=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p._totals=0}),define(Ae[15],Re([1,0,41,5,93,6,28,21,20,10,2,31,3]),function(te,e,m,k,C,M,F,f,D,g,R,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,d.createDecorator)("logService"),e.ILoggerService=(0,d.createDecorator)("loggerService");function E(){return new Date().toISOString()}function p(S){return(0,g.isNumber)(S)}e.isLogLevel=p;var l;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(l||(e.LogLevel=l={})),e.DEFAULT_LOG_LEVEL=l.Info;function t(S,a,o){switch(a){case l.Trace:S.trace(o);break;case l.Debug:S.debug(o);break;case l.Info:S.info(o);break;case l.Warning:S.warn(o);break;case l.Error:S.error(o);break;case l.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=t;function r(S,a=!1){let o="";for(let O=0;O<S.length;O++){let $=S[O];if($ instanceof Error&&($=(0,m.toErrorMessage)($,a)),typeof $=="object")try{$=JSON.stringify($)}catch{}o+=(O>0?" ":"")+$}return o}class c extends M.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(a){return this.level!==l.Off&&this.level<=a}}e.AbstractLogger=c;class b extends c{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||super.checkLogLevel(a)}trace(a,...o){this.checkLogLevel(l.Trace)&&this.log(l.Trace,r([a,...o],!0))}debug(a,...o){this.checkLogLevel(l.Debug)&&this.log(l.Debug,r([a,...o]))}info(a,...o){this.checkLogLevel(l.Info)&&this.log(l.Info,r([a,...o]))}warn(a,...o){this.checkLogLevel(l.Warning)&&this.log(l.Warning,r([a,...o]))}error(a,...o){if(this.checkLogLevel(l.Error))if(a instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=a.stack,this.log(l.Error,r(O))}else this.log(l.Error,r([a,...o]))}flush(){}}e.AbstractMessageLogger=b;class w extends c{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!f.isWindows}trace(a,...o){this.checkLogLevel(l.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,a,...o):console.log(`[main ${E()}]`,a,...o))}debug(a,...o){this.checkLogLevel(l.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,a,...o):console.log(`[main ${E()}]`,a,...o))}info(a,...o){this.checkLogLevel(l.Info)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,a,...o):console.log(`[main ${E()}]`,a,...o))}warn(a,...o){this.checkLogLevel(l.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,a,...o):console.warn(`[main ${E()}]`,a,...o))}error(a,...o){this.checkLogLevel(l.Error)&&(this.useColors?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,a,...o):console.error(`[main ${E()}]`,a,...o))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class _ extends c{constructor(a=e.DEFAULT_LOG_LEVEL,o=!0){super(),this.useColors=o,this.setLevel(a)}trace(a,...o){this.checkLogLevel(l.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",a,...o):console.log(a,...o))}debug(a,...o){this.checkLogLevel(l.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",a,...o):console.log(a,...o))}info(a,...o){this.checkLogLevel(l.Info)&&(this.useColors?console.log("%c INFO","color: #33f",a,...o):console.log(a,...o))}warn(a,...o){this.checkLogLevel(l.Warning)&&(this.useColors?console.log("%c WARN","color: #993",a,...o):console.log(a,...o))}error(a,...o){this.checkLogLevel(l.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",a,...o):console.error(a,...o))}dispose(){}flush(){}}e.ConsoleLogger=_;class i extends c{constructor(a,o=e.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(o)}trace(a,...o){this.checkLogLevel(l.Trace)&&this.adapter.log(l.Trace,[this.extractMessage(a),...o])}debug(a,...o){this.checkLogLevel(l.Debug)&&this.adapter.log(l.Debug,[this.extractMessage(a),...o])}info(a,...o){this.checkLogLevel(l.Info)&&this.adapter.log(l.Info,[this.extractMessage(a),...o])}warn(a,...o){this.checkLogLevel(l.Warning)&&this.adapter.log(l.Warning,[this.extractMessage(a),...o])}error(a,...o){this.checkLogLevel(l.Error)&&this.adapter.log(l.Error,[this.extractMessage(a),...o])}extractMessage(a){return typeof a=="string"?a:(0,m.toErrorMessage)(a,this.checkLogLevel(l.Trace))}dispose(){}flush(){}}e.AdapterLogger=i;class u extends c{constructor(a){super(),this.loggers=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const o of this.loggers)o.setLevel(a);super.setLevel(a)}trace(a,...o){for(const O of this.loggers)O.trace(a,...o)}debug(a,...o){for(const O of this.loggers)O.debug(a,...o)}info(a,...o){for(const O of this.loggers)O.info(a,...o)}warn(a,...o){for(const O of this.loggers)O.warn(a,...o)}error(a,...o){for(const O of this.loggers)O.error(a,...o)}flush(){for(const a of this.loggers)a.flush()}dispose(){for(const a of this.loggers)a.dispose()}}e.MultiplexLogger=u;class n extends M.Disposable{constructor(a,o,O){if(super(),this.logLevel=a,this.logsHome=o,this._loggers=new F.ResourceMap,this._onDidChangeLoggers=this._register(new k.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new k.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,O)for(const $ of O)this._loggers.set($.resource,{logger:void 0,info:$})}getLoggerEntry(a){return(0,g.isString)(a)?[...this._loggers.values()].find(o=>o.info.id===a):this._loggers.get(a)}getLogger(a){return this.getLoggerEntry(a)?.logger}createLogger(a,o){const O=this.toResource(a),$=(0,g.isString)(a)?a:o?.id??(0,C.hash)(O.toString()).toString(16);let K=this._loggers.get(O)?.logger;const V=o?.logLevel==="always"?l.Trace:o?.logLevel;K||(K=this.doCreateLogger(O,V??this.getLogLevel(O)??this.logLevel,{...o,id:$}));const z={logger:K,info:{resource:O,id:$,logLevel:V,name:o?.name,hidden:o?.hidden,extensionId:o?.extensionId,when:o?.when}};return this.registerLogger(z.info),this._loggers.set(O,z),K}toResource(a){return(0,g.isString)(a)?(0,D.joinPath)(this.logsHome,`${a}.log`):a}setLogLevel(a,o){if(R.URI.isUri(a)){const O=a,$=o,K=this._loggers.get(O);K&&$!==K.info.logLevel&&(K.info.logLevel=$===this.logLevel?void 0:$,K.logger?.setLevel($),this._loggers.set(K.info.resource,K),this._onDidChangeLogLevel.fire([O,$]))}else{this.logLevel=a;for(const[O,$]of this._loggers.entries())this._loggers.get(O)?.info.logLevel===void 0&&$.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(a,o){const O=this.getLoggerEntry(a);O&&o!==!O.info.hidden&&(O.info.hidden=!o,this._loggers.set(O.info.resource,O),this._onDidChangeVisibility.fire([O.info.resource,o]))}getLogLevel(a){let o;return a&&(o=this._loggers.get(a)?.info.logLevel),o??this.logLevel}registerLogger(a){const o=this._loggers.get(a.resource);o?o.info.hidden!==a.hidden&&this.setVisibility(a.resource,!a.hidden):(this._loggers.set(a.resource,{info:a,logger:void 0}),this._onDidChangeLoggers.fire({added:[a],removed:[]}))}deregisterLogger(a){const o=this._loggers.get(a);o&&(o.logger&&o.logger.dispose(),this._loggers.delete(a),this._onDidChangeLoggers.fire({added:[],removed:[o.info]}))}*getRegisteredLoggers(){for(const a of this._loggers.values())yield a.info}getRegisteredLogger(a){return this._loggers.get(a)?.info}dispose(){this._loggers.forEach(a=>a.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=n;class s{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(a){}getLevel(){return l.Info}trace(a,...o){}debug(a,...o){}info(a,...o){}warn(a,...o){}error(a,...o){}critical(a,...o){}dispose(){}flush(){}}e.NullLogger=s;class v extends s{}e.NullLogService=v;function I(S){if(S.verbose)return l.Trace;if(typeof S.logLevel=="string"){const a=T(S.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function h(S){switch(S){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Off:return"off"}}e.LogLevelToString=h;function T(S){switch(S){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Error;case"off":return l.Off}}e.parseLogLevel=T,e.CONTEXT_LOG_LEVEL=new y.RawContextKey("logLevel",h(l.Info))}),define(Ae[172],Re([1,0,6,15]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class C extends m.Disposable{constructor(F,f=[]){super(),this.logger=new k.MultiplexLogger([F,...f]),this._register(F.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(F){this.logger.setLevel(F)}getLevel(){return this.logger.getLevel()}trace(F,...f){this.logger.trace(F,...f)}debug(F,...f){this.logger.debug(F,...f)}info(F,...f){this.logger.info(F,...f)}warn(F,...f){this.logger.warn(F,...f)}error(F,...f){this.logger.error(F,...f)}flush(){this.logger.flush()}}e.LogService=C}),define(Ae[94],Re([1,0,29,143,3]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var F;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(F||(e.MarkerSeverity=F={})),function(D){function g(p,l){return l-p}D.compare=g;const R=Object.create(null);R[D.Error]=(0,k.localize)(0,null),R[D.Warning]=(0,k.localize)(1,null),R[D.Info]=(0,k.localize)(2,null);function y(p){return R[p]||""}D.toString=y;function d(p){switch(p){case m.default.Error:return D.Error;case m.default.Warning:return D.Warning;case m.default.Info:return D.Info;case m.default.Ignore:return D.Hint}}D.fromSeverity=d;function E(p){switch(p){case D.Error:return m.default.Error;case D.Warning:return m.default.Warning;case D.Info:return m.default.Info;case D.Hint:return m.default.Ignore}}D.toSeverity=E}(F||(e.MarkerSeverity=F={}));var f;(function(D){const g="";function R(d){return y(d,!0)}D.makeKey=R;function y(d,E){const p=[g];return d.source?p.push(d.source.replace("\xA6","\\\xA6")):p.push(g),d.code?typeof d.code=="string"?p.push(d.code.replace("\xA6","\\\xA6")):p.push(d.code.value.replace("\xA6","\\\xA6")):p.push(g),d.severity!==void 0&&d.severity!==null?p.push(F.toString(d.severity)):p.push(g),d.message&&E?p.push(d.message.replace("\xA6","\\\xA6")):p.push(g),d.startLineNumber!==void 0&&d.startLineNumber!==null?p.push(d.startLineNumber.toString()):p.push(g),d.startColumn!==void 0&&d.startColumn!==null?p.push(d.startColumn.toString()):p.push(g),d.endLineNumber!==void 0&&d.endLineNumber!==null?p.push(d.endLineNumber.toString()):p.push(g),d.endColumn!==void 0&&d.endColumn!==null?p.push(d.endColumn.toString()):p.push(g),p.push(g),p.join("\xA6")}D.makeKeyOptionalMessage=y})(f||(e.IMarkerData=f={})),e.IMarkerService=(0,C.createDecorator)("markerService")}),define(Ae[173],Re([1,0,5,29,3]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=k.default,e.INotificationService=(0,C.createDecorator)("notificationService");var M;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var F;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(F||(e.NeverShowAgainScope=F={}));var f;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(f||(e.NotificationsFilter=f={}));class D{constructor(){this.progress=new g,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(y){}updateMessage(y){}updateActions(y){}close(){}}e.NoOpNotification=D;class g{infinite(){}done(){}total(y){}worked(y){}}e.NoOpProgress=g}),define(Ae[95],Re([1,0,13,2,3]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService");function M(g,R){return k.URI.isUri(g)?(0,m.equalsIgnoreCase)(g.scheme,R):(0,m.startsWithIgnoreCase)(g,R+":")}e.matchesScheme=M;function F(g,...R){return R.some(y=>M(g,y))}e.matchesSomeScheme=F;function f(g,R){return g.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.withSelection=f;function D(g){let R;const y=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return y&&(R={startLineNumber:parseInt(y[1]),startColumn:y[2]?parseInt(y[2]):1,endLineNumber:y[4]?parseInt(y[4]):void 0,endColumn:y[4]?y[5]?parseInt(y[5]):1:void 0},g=g.with({fragment:""})),{selection:R,uri:g}}e.extractSelection=D}),define(Ae[174],Re([1,0,3]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,m.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ve=this&&this.__decorate||function(te,e,m,k){var C=arguments.length,M=C<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,m):k,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(te,e,m,k);else for(var f=te.length-1;f>=0;f--)(F=te[f])&&(M=(C<3?F(M):C>3?F(e,m,M):F(e,m))||M);return C>3&&M&&Object.defineProperty(e,m,M),M},He=this&&this.__param||function(te,e){return function(m,k){e(m,k,te)}};define(Ae[175],Re([1,0,16,22,6,3]),function(te,e,m,k,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var F;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(F||(e.ProgressLocation=F={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class f{get value(){return this._value}constructor(y){this.callback=y}report(y){this._value=y,this.callback(this._value)}}e.Progress=f,f.None=Object.freeze({report(){}});let D=e.UnmanagedProgress=class extends C.Disposable{constructor(y,d){super(),this.deferred=new m.DeferredPromise,d.withProgress(y,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};e.UnmanagedProgress=D=Ve([He(1,e.IProgressService)],D);class g extends C.Disposable{constructor(y){super(),this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(y){this.stop();const d=++this.currentOperationId,E=new k.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:E.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=g,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(Ae[30],Re([1,0,49,10]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(F,f){m.ok(k.isString(F)),m.ok(k.isObject(f)),m.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,f)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}e.Registry=new C}),define(Ae[74],Re([1,0,5,30]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(f){return f.length>0&&f.charAt(f.length-1)==="#"?f.substring(0,f.length-1):f}class M{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,g){this.schemasById[C(D)]=g,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new M;k.Registry.add(e.Extensions.JSONContribution,F)}),define(Ae[96],Re([1,0,18,5,10,137,43,74,30]),function(te,e,m,k,C,M,F,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var g;(function(_){_.Multiline="multilineText",_.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=D.Registry.as(f.Extensions.JSONContribution);class d{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,u=!0){this.registerConfigurations([i],u)}registerConfigurations(i,u=!0){const n=new Set;this.doRegisterConfigurations(i,u,n),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(i){const u=new Set;this.doDeregisterConfigurations(i,u),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:i,remove:u}){const n=new Set;this.doDeregisterConfigurations(u,n),this.doRegisterConfigurations(i,!1,n),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}registerDefaultConfigurations(i){const u=new Set;this.doRegisterDefaultConfigurations(i,u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,u){const n=[];for(const{overrides:s,source:v}of i)for(const I in s)if(u.add(I),e.OVERRIDE_PROPERTY_REGEX.test(I)){const h=this.configurationDefaultsOverrides.get(I),T=h?.valuesSources??new Map;if(v)for(const O of Object.keys(s[I]))T.set(O,v);const S={...h?.value||{},...s[I]};this.configurationDefaultsOverrides.set(I,{source:v,value:S,valuesSources:T});const a=(0,F.getLanguageTagSettingPlainKey)(I),o={type:"object",default:S,description:M.localize(1,null,a),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:C.isString(v)?void 0:v,defaultValueSource:v};n.push(...l(I)),this.configurationProperties[I]=o,this.defaultLanguageConfigurationOverridesNode.properties[I]=o}else{this.configurationDefaultsOverrides.set(I,{value:s[I],source:v});const h=this.configurationProperties[I];h&&(this.updatePropertyDefaultValue(I,h),this.updateSchema(I,h))}this.doRegisterOverrideIdentifiers(n)}deregisterDefaultConfigurations(i){const u=new Set;this.doDeregisterDefaultConfigurations(i,u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,u){for(const{overrides:n,source:s}of i)for(const v in n){const I=this.configurationDefaultsOverrides.get(v),h=C.isString(s)?s:s?.id,T=C.isString(I?.source)?I?.source:I?.source?.id;if(h===T)if(u.add(v),this.configurationDefaultsOverrides.delete(v),e.OVERRIDE_PROPERTY_REGEX.test(v))delete this.configurationProperties[v],delete this.defaultLanguageConfigurationOverridesNode.properties[v];else{const S=this.configurationProperties[v];S&&(this.updatePropertyDefaultValue(v,S),this.updateSchema(v,S))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let u=!1;const n=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,n),u=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,n),u=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,n),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const u of i)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,u,n){i.forEach(s=>{this.validateAndRegisterProperties(s,u,s.extensionInfo,s.restrictedProperties,void 0,n),this.configurationContributors.push(s),this.registerJSONConfiguration(s)})}doDeregisterConfigurations(i,u){const n=s=>{if(s.properties)for(const v in s.properties){u.add(v);const I=this.configurationProperties[v];I?.policy?.name&&this.policyConfigurations.delete(I.policy.name),delete this.configurationProperties[v],this.removeFromSchema(v,s.properties[v])}s.allOf?.forEach(v=>n(v))};for(const s of i){n(s);const v=this.configurationContributors.indexOf(s);v!==-1&&this.configurationContributors.splice(v,1)}}validateAndRegisterProperties(i,u=!0,n,s,v=3,I){v=C.isUndefinedOrNull(i.scope)?v:i.scope;const h=i.properties;if(h)for(const S in h){const a=h[S];if(u&&b(S,a)){delete h[S];continue}if(a.source=n,a.defaultDefaultValue=h[S].default,this.updatePropertyDefaultValue(S,a),e.OVERRIDE_PROPERTY_REGEX.test(S)?a.scope=void 0:(a.scope=C.isUndefinedOrNull(a.scope)?v:a.scope,a.restricted=C.isUndefinedOrNull(a.restricted)?!!s?.includes(S):a.restricted),h[S].hasOwnProperty("included")&&!h[S].included){this.excludedConfigurationProperties[S]=h[S],delete h[S];continue}else this.configurationProperties[S]=h[S],h[S].policy?.name&&this.policyConfigurations.set(h[S].policy.name,S);!h[S].deprecationMessage&&h[S].markdownDeprecationMessage&&(h[S].deprecationMessage=h[S].markdownDeprecationMessage),I.add(S)}const T=i.allOf;if(T)for(const S of T)this.validateAndRegisterProperties(S,u,n,s,v,I)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const u=n=>{const s=n.properties;if(s)for(const I in s)this.updateSchema(I,s[I]);n.allOf?.forEach(u)};u(i)}updateSchema(i,u){switch(e.allSettings.properties[i]=u,u.scope){case 1:e.applicationSettings.properties[i]=u;break;case 2:e.machineSettings.properties[i]=u;break;case 6:e.machineOverridableSettings.properties[i]=u;break;case 3:e.windowSettings.properties[i]=u;break;case 4:e.resourceSettings.properties[i]=u;break;case 5:e.resourceSettings.properties[i]=u,this.resourceLanguageSettingsSchema.properties[i]=u;break}}removeFromSchema(i,u){switch(delete e.allSettings.properties[i],u.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const u=`[${i}]`,n={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,n),e.allSettings.properties[u]=n,e.applicationSettings.properties[u]=n,e.machineSettings.properties[u]=n,e.machineOverridableSettings.properties[u]=n,e.windowSettings.properties[u]=n,e.resourceSettings.properties[u]=n}}registerOverridePropertyPatternKey(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,u){const n=this.configurationDefaultsOverrides.get(i);let s=n?.value,v=n?.source;C.isUndefined(s)&&(s=u.defaultDefaultValue,v=void 0),C.isUndefined(s)&&(s=r(u.type)),u.default=s,u.defaultValueSource=v}}const E="\\[([^\\]]+)\\]",p=new RegExp(E,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function l(_){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(_)){let u=p.exec(_);for(;u?.length;){const n=u[1].trim();n&&i.push(n),u=p.exec(_)}}return(0,m.distinct)(i)}e.overrideIdentifiersFromKey=l;function t(_){return _.reduce((i,u)=>`${i}[${u}]`,"")}e.keyFromOverrideIdentifiers=t;function r(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=r;const c=new d;D.Registry.add(e.Extensions.Configuration,c);function b(_,i){return _.trim()?e.OVERRIDE_PROPERTY_REGEX.test(_)?M.localize(7,null,_):c.getConfigurationProperties()[_]!==void 0?M.localize(8,null,_):i.policy?.name&&c.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,_,i.policy?.name,c.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.validateProperty=b;function w(){const _=[],i=c.getConfigurationProperties();for(const u of Object.keys(i))_.push([u,i[u].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=w}),define(Ae[176],Re([1,0,18,5,115,6,28,23,10,2,43,96,30]),function(te,e,m,k,C,M,F,f,D,g,R,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function E(u){return Object.isFrozen(u)?u:f.deepFreeze(u)}class p{constructor(n={},s=[],v=[],I){this._contents=n,this._keys=s,this._overrides=v,this.raw=I,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof p)return s;const v=new l("");return v.parseRaw(s),v.configurationModel});this._rawConfiguration=n.reduce((s,v)=>v===s?v:s.merge(v),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,R.getConfigurationValue)(this.contents,n):this.contents}inspect(n,s){const v=this.rawConfiguration.getValue(n),I=s?this.rawConfiguration.getOverrideValue(n,s):void 0,h=s?this.rawConfiguration.override(s).getValue(n):v;return{value:v,override:I,merged:h}}getOverrideValue(n,s){const v=this.getContentsForOverrideIdentifer(s);return v?n?(0,R.getConfigurationValue)(v,n):v:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const v of this.overrides)v.identifiers.includes(n)&&s.push(...v.keys);return m.distinct(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return m.distinct(n)}override(n){let s=this.overrideConfigurations.get(n);return s||(s=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,s)),s}merge(...n){const s=f.deepClone(this.contents),v=f.deepClone(this.overrides),I=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const T of n)if(h.push(...T.raw?.length?T.raw:[T]),!T.isEmpty()){this.mergeContents(s,T.contents);for(const S of T.overrides){const[a]=v.filter(o=>m.equals(o.identifiers,S.identifiers));a?(this.mergeContents(a.contents,S.contents),a.keys.push(...S.keys),a.keys=m.distinct(a.keys)):v.push(f.deepClone(S))}for(const S of T.keys)I.indexOf(S)===-1&&I.push(S)}return new p(s,I,v,h.every(T=>T instanceof p)?void 0:h)}createOverrideConfigurationModel(n){const s=this.getContentsForOverrideIdentifer(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const v={};for(const I of m.distinct([...Object.keys(this.contents),...Object.keys(s)])){let h=this.contents[I];const T=s[I];T&&(typeof h=="object"&&typeof T=="object"?(h=f.deepClone(h),this.mergeContents(h,T)):h=T),v[I]=h}return new p(v,this.keys,this.overrides)}mergeContents(n,s){for(const v of Object.keys(s)){if(v in n&&D.isObject(n[v])&&D.isObject(s[v])){this.mergeContents(n[v],s[v]);continue}n[v]=f.deepClone(s[v])}}getContentsForOverrideIdentifer(n){let s=null,v=null;const I=h=>{h&&(v?this.mergeContents(v,h):v=f.deepClone(h))};for(const h of this.overrides)m.equals(h.identifiers,[n])?s=h.contents:h.identifiers.includes(n)&&I(h.contents);return I(s),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.updateValue(n,s,!0)}setValue(n,s){this.updateValue(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,R.removeFromValueTree)(this.contents,n),y.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(v=>m.equals(v.identifiers,(0,y.overrideIdentifiersFromKey)(n))),1))}updateValue(n,s,v){(0,R.addToValueTree)(this.contents,n,s,I=>console.error(I)),v=v||this.keys.indexOf(n)===-1,v&&this.keys.push(n),y.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,y.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,R.toValuesTree)(this.contents[n],I=>console.error(I))})}}e.ConfigurationModel=p;class l{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,s){if(!D.isUndefinedOrNull(n)){const v=this.doParseContent(n);this.parseRaw(v,s)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,s){this._raw=n;const{contents:v,keys:I,overrides:h,restricted:T,hasExcludedProperties:S}=this.doParseRaw(n,s);this._configurationModel=new p(v,I,h,S?[n]:void 0),this._restrictedConfigurations=T||[]}doParseContent(n){let s={},v=null,I=[];const h=[],T=[];function S(o){Array.isArray(I)?I.push(o):v!==null&&(I[v]=o)}const a={onObjectBegin:()=>{const o={};S(o),h.push(I),I=o,v=null},onObjectProperty:o=>{v=o},onObjectEnd:()=>{I=h.pop()},onArrayBegin:()=>{const o=[];S(o),h.push(I),I=o,v=null},onArrayEnd:()=>{I=h.pop()},onLiteralValue:S,onError:(o,O,$)=>{T.push({error:o,offset:O,length:$})}};if(n)try{C.visit(n,a),s=I[0]||{}}catch(o){console.error(`Error while parsing settings file ${this._name}: ${o}`),this._parseErrors=[o]}return s}doParseRaw(n,s){const v=d.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),I=this.filter(n,v,!0,s);n=I.raw;const h=(0,R.toValuesTree)(n,a=>console.error(`Conflict in settings file ${this._name}: ${a}`)),T=Object.keys(n),S=this.toOverrides(n,a=>console.error(`Conflict in settings file ${this._name}: ${a}`));return{contents:h,keys:T,overrides:S,restricted:I.restricted,hasExcludedProperties:I.hasExcludedProperties}}filter(n,s,v,I){let h=!1;if(!I?.scopes&&!I?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:h};const T={},S=[];for(const a in n)if(y.OVERRIDE_PROPERTY_REGEX.test(a)&&v){const o=this.filter(n[a],s,!1,I);T[a]=o.raw,h=h||o.hasExcludedProperties,S.push(...o.restricted)}else{const o=s[a],O=o?typeof o.scope<"u"?o.scope:3:void 0;o?.restricted&&S.push(a),(O===void 0||I.scopes===void 0||I.scopes.includes(O))&&!(I.skipRestricted&&o?.restricted)?T[a]=n[a]:h=!0}return{raw:T,restricted:S,hasExcludedProperties:h}}toOverrides(n,s){const v=[];for(const I of Object.keys(n))if(y.OVERRIDE_PROPERTY_REGEX.test(I)){const h={};for(const T in n[I])h[T]=n[I][T];v.push({identifiers:(0,y.overrideIdentifiersFromKey)(I),keys:Object.keys(h),contents:(0,R.toValuesTree)(h,s)})}return v}}e.ConfigurationModelParser=l;class t extends M.Disposable{constructor(n,s,v,I){super(),this.userSettingsResource=n,this.scopes=s,this.fileService=I,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(v.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(k.Event.any(k.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource)),k.Event.filter(this.fileService.onDidRunOperation,h=>(h.isOperation(0)||h.isOperation(3)||h.isOperation(1)||h.isOperation(4))&&v.isEqual(h.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=t;class r{constructor(n,s,v,I,h,T,S,a,o,O,$,K,V){this.key=n,this.overrides=s,this._value=v,this.overrideIdentifiers=I,this.defaultConfiguration=h,this.policyConfiguration=T,this.applicationConfiguration=S,this.userConfiguration=a,this.localUserConfiguration=o,this.remoteUserConfiguration=O,this.workspaceConfiguration=$,this.folderConfigurationModel=K,this.memoryConfigurationModel=V}get value(){return E(this._value)}inspect(n,s,v){const I=n.inspect(s,v);return{get value(){return E(I.value)},get override(){return E(I.override)},get merged(){return E(I.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class c{constructor(n,s,v,I,h=new p,T=new p,S=new F.ResourceMap,a=new p,o=new F.ResourceMap){this._defaultConfiguration=n,this._policyConfiguration=s,this._applicationConfiguration=v,this._localUserConfiguration=I,this._remoteUserConfiguration=h,this._workspaceConfiguration=T,this._folderConfigurations=S,this._memoryConfiguration=a,this._memoryConfigurationByResource=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(n,s,v){return this.getConsolidatedConfigurationModel(n,s,v).getValue(n)}updateValue(n,s,v={}){let I;v.resource?(I=this._memoryConfigurationByResource.get(v.resource),I||(I=new p,this._memoryConfigurationByResource.set(v.resource,I))):I=this._memoryConfiguration,s===void 0?I.removeValue(n):I.setValue(n,s),v.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,s,v){const I=this.getConsolidatedConfigurationModel(n,s,v),h=this.getFolderConfigurationModelForResource(s.resource,v),T=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,S=new Set;for(const a of I.overrides)for(const o of a.identifiers)I.getOverrideValue(n,o)!==void 0&&S.add(o);return new r(n,s,I.getValue(n),S.size?[...S]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,v?this._workspaceConfiguration:void 0,h||void 0,T)}keys(n){const s=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,s){this._folderConfigurations.set(n,s),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const v=[];if(!s){const{added:I,updated:h,removed:T}=_(this._defaultConfiguration,n);s=[...I,...h,...T]}for(const I of s)for(const h of(0,y.overrideIdentifiersFromKey)(I)){const T=this._defaultConfiguration.getKeysForOverrideIdentifier(h),S=n.getKeysForOverrideIdentifier(h),a=[...S.filter(o=>T.indexOf(o)===-1),...T.filter(o=>S.indexOf(o)===-1),...T.filter(o=>!f.equals(this._defaultConfiguration.override(h).getValue(o),n.override(h).getValue(o)))];v.push([h,a])}return this.updateDefaultConfiguration(n),{keys:s,overrides:v}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:v,removed:I}=_(this._policyConfiguration,n),h=[...s,...v,...I];return h.length&&this.updatePolicyConfiguration(n),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:v,removed:I,overrides:h}=_(this.applicationConfiguration,n),T=[...s,...v,...I];return T.length&&this.updateApplicationConfiguration(n),{keys:T,overrides:h}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:v,removed:I,overrides:h}=_(this.localUserConfiguration,n),T=[...s,...v,...I];return T.length&&this.updateLocalUserConfiguration(n),{keys:T,overrides:h}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:v,removed:I,overrides:h}=_(this.remoteUserConfiguration,n),T=[...s,...v,...I];return T.length&&this.updateRemoteUserConfiguration(n),{keys:T,overrides:h}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:v,removed:I,overrides:h}=_(this.workspaceConfiguration,n),T=[...s,...v,...I];return T.length&&this.updateWorkspaceConfiguration(n),{keys:T,overrides:h}}compareAndUpdateFolderConfiguration(n,s){const v=this.folderConfigurations.get(n),{added:I,updated:h,removed:T,overrides:S}=_(v,s),a=[...I,...h,...T];return(a.length||!v)&&this.updateFolderConfiguration(n,s),{keys:a,overrides:S}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:v,updated:I,removed:h,overrides:T}=_(s,void 0);return{keys:[...v,...I,...h],overrides:T}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,s,v){let I=this.getConsolidatedConfigurationModelForResource(s,v);return s.overrideIdentifier&&(I=I.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(I=I.merge(this._policyConfiguration)),I}getConsolidatedConfigurationModelForResource({resource:n},s){let v=this.getWorkspaceConsolidatedConfiguration();if(s&&n){const I=s.getFolder(n);I&&(v=this.getFolderConsolidatedConfiguration(I.uri)||v);const h=this._memoryConfigurationByResource.get(n);h&&(v=v.merge(h))}return v}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let s=this._foldersConsolidatedConfigurations.get(n);if(!s){const v=this.getWorkspaceConsolidatedConfiguration(),I=this._folderConfigurations.get(n);I?(s=v.merge(I),this._foldersConsolidatedConfigurations.set(n,s)):s=v}return s}getFolderConfigurationModelForResource(n,s){if(s&&n){const v=s.getFolder(n);if(v)return this._folderConfigurations.get(v.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,s)=>{const{contents:v,overrides:I,keys:h}=this._folderConfigurations.get(s);return n.push([s,{contents:v,overrides:I,keys:h}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this._workspaceConfiguration.keys.forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.keys.forEach(v=>n.add(v))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getAllOverrideIdentifiers().forEach(v=>n.add(v))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(v=>s.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(v=>s.add(v)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(v=>s.add(v)),this._folderConfigurations.forEach(v=>v.getKeysForOverrideIdentifier(n).forEach(I=>s.add(I))),[...s.values()]}static parse(n){const s=this.parseConfigurationModel(n.defaults),v=this.parseConfigurationModel(n.policy),I=this.parseConfigurationModel(n.application),h=this.parseConfigurationModel(n.user),T=this.parseConfigurationModel(n.workspace),S=n.folders.reduce((a,o)=>(a.set(g.URI.revive(o[0]),this.parseConfigurationModel(o[1])),a),new F.ResourceMap);return new c(s,v,I,h,new p,T,S,new p,new F.ResourceMap)}static parseConfigurationModel(n){return new p(n.contents,n.keys,n.overrides)}}e.Configuration=c;function b(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const n=new Set,s=new Map;for(const I of u)I.keys.forEach(h=>n.add(h)),I.overrides.forEach(([h,T])=>{const S=(0,F.getOrSet)(s,h,new Set);T.forEach(a=>S.add(a))});const v=[];return s.forEach((I,h)=>v.push([h,[...I.values()]])),{keys:[...n.values()],overrides:v}}e.mergeChanges=b;class w{constructor(n,s,v,I){this.change=n,this.previous=s,this.currentConfiguraiton=v,this.currentWorkspace=I,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const h of n.keys)this.affectedKeys.add(h);for(const[,h]of n.overrides)for(const T of h)this.affectedKeys.add(T);this._affectsConfigStr=this._marker;for(const h of this.affectedKeys)this._affectsConfigStr+=h+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=c.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,s){const v=this._marker+n,I=this._affectsConfigStr.indexOf(v);if(I<0)return!1;const h=I+v.length;if(h>=this._affectsConfigStr.length)return!1;const T=this._affectsConfigStr.charCodeAt(h);if(T!==this._markerCode1&&T!==this._markerCode2)return!1;if(s){const S=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(n,s,this.currentWorkspace);return!f.equals(S,a)}return!0}}e.ConfigurationChangeEvent=w;function _(u,n){const{added:s,removed:v,updated:I}=i(n?.rawConfiguration,u?.rawConfiguration),h=[],T=u?.getAllOverrideIdentifiers()||[],S=n?.getAllOverrideIdentifiers()||[];if(n){const a=S.filter(o=>!T.includes(o));for(const o of a)h.push([o,n.getKeysForOverrideIdentifier(o)])}if(u){const a=T.filter(o=>!S.includes(o));for(const o of a)h.push([o,u.getKeysForOverrideIdentifier(o)])}if(n&&u){for(const a of T)if(S.includes(a)){const o=i({contents:u.getOverrideValue(void 0,a)||{},keys:u.getKeysForOverrideIdentifier(a)},{contents:n.getOverrideValue(void 0,a)||{},keys:n.getKeysForOverrideIdentifier(a)});h.push([a,[...o.added,...o.removed,...o.updated]])}}return{added:s,removed:v,updated:I,overrides:h}}function i(u,n){const s=u?n?u.keys.filter(h=>n.keys.indexOf(h)===-1):[...u.keys]:[],v=n?u?n.keys.filter(h=>u.keys.indexOf(h)===-1):[...n.keys]:[],I=[];if(u&&n){for(const h of n.keys)if(u.keys.indexOf(h)!==-1){const T=(0,R.getConfigurationValue)(n.contents,h),S=(0,R.getConfigurationValue)(u.contents,h);f.equals(T,S)||I.push(h)}}return{added:s,removed:v,updated:I}}}),define(Ae[97],Re([1,0,9,3]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var C;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class M{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=M;class F{constructor(y,d){this.host=y,this.port=d,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=F;var f;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(f||(e.RemoteAuthorityResolverErrorCode=f={}));class D extends m.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof D&&y._code===f.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof D&&y._code===f.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof D&&y._code===f.NoResolverFound}static isHandled(y){return y instanceof D&&y.isHandled}constructor(y,d=f.Unknown,E){super(y),this._message=y,this._code=d,this._detail=E,this.isHandled=d===f.NotAvailable&&E===!0,Object.setPrototypeOf(this,D.prototype)}}e.RemoteAuthorityResolverError=D;function g(R){const y=R.indexOf("+");return y===-1?R:R.substring(0,y)}e.getRemoteAuthorityPrefix=g}),define(Ae[50],Re([1,0,14]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function k(g){return g.scheme===m.Schemas.vscodeRemote?g.authority:void 0}e.getRemoteAuthority=k;function C(g){if(!g)return;const R=g.indexOf("+");return R<0?g:g.substr(0,R)}e.getRemoteName=C;function M(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.getRemoteServerRootPath=M;function F(g){const{host:R,port:y}=D(g);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:y}}e.parseAuthorityWithPort=F;function f(g,R){let{host:y,port:d}=D(g);return typeof d>"u"&&(d=R),{host:y,port:d}}e.parseAuthorityWithOptionalPort=f;function D(g){const R=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const y=g.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const d=g.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:g,port:void 0}}}),define(Ae[24],Re([1,0,13,3,50]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var F;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(F||(e.ExtensionType=F={}));var f;(function(l){l.WIN32_X64="win32-x64",l.WIN32_IA32="win32-ia32",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.LINUX_PPC64LE="linux-ppc64le",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(f||(e.TargetPlatform=f={}));class D{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,r){if(typeof t>"u"||t===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof t=="string"||typeof r=="string"){const c=typeof t=="string"?t:t.value,b=typeof r=="string"?r:r.value;return m.equalsIgnoreCase(c,b)}return t._lower===r._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.ExtensionIdentifier=D;class g{get size(){return this._set.size}constructor(t){if(this._set=new Set,t)for(const r of t)this.add(r)}add(t){this._set.add(D.toKey(t))}delete(t){return this._set.delete(D.toKey(t))}has(t){return this._set.has(D.toKey(t))}}e.ExtensionIdentifierSet=g;class R{constructor(){this._map=new Map}clear(){this._map.clear()}delete(t){this._map.delete(D.toKey(t))}get(t){return this._map.get(D.toKey(t))}has(t){return this._map.has(D.toKey(t))}set(t,r){this._map.set(D.toKey(t),r)}values(){return this._map.values()}forEach(t){this._map.forEach(t)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=R;function y(l){return d(l)}e.isApplicationScopedExtension=y;function d(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=d;function E(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function p(l,t){if(t){const r=`onResolveRemoteAuthority:${(0,C.getRemoteName)(t)}`;return!!l.activationEvents?.includes(r)}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,9,24]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class C{constructor(){this._generators=new Map,this._cache=new WeakMap}register(F,f){this._generators.set(F,f)}readActivationEvents(F){return this._cache.has(F)||this._cache.set(F,this._readActivationEvents(F)),this._cache.get(F)}createActivationEventsMap(F){const f=Object.create(null);for(const D of F){const g=this.readActivationEvents(D);g.length>0&&(f[k.ExtensionIdentifier.toKey(D.identifier)]=g)}return f}_readActivationEvents(F){if(typeof F.main>"u"&&typeof F.browser>"u")return[];const f=Array.isArray(F.activationEvents)?F.activationEvents.slice(0):[];if(!F.contributes)return f;for(const D in F.contributes){const g=this._generators.get(D);if(!g)continue;const R=F.contributes[D],y=Array.isArray(R)?R:[R];try{g(y,f)}catch(d){(0,m.onUnexpectedError)(d)}}return f}}e.ImplicitActivationEventsImpl=C,e.ImplicitActivationEvents=new C}),define(Ae[177],Re([1,0,21,51,36]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(D){if(m.platform===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function F(D,g,R,y,d,E,p,l){const t=Object.create(null);t["common.machineId"]=E,t.sessionID=(0,C.generateUuid)()+Date.now(),t.commitHash=y,t.version=d,t["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,m.PlatformToString)(m.platform),t["common.nodePlatform"]=k.platform,t["common.nodeArch"]=R,t["common.product"]=l||"desktop",p&&(t["common.msftInternal"]=p);let r=0;const c=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),m.isLinuxSnap&&(t["common.snap"]="true");const b=M(g);return b&&(t["common.platformDetail"]=b),t}e.resolveCommonProperties=F;function f(D){const g=k.env.USERDNSDOMAIN;if(!g)return!1;const R=g.toLowerCase();return D.some(y=>R===y)}e.verifyMicrosoftInternalDomain=f}),define(Ae[178],Re([1,0,3]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,m.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,m.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var k;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(k||(e.TelemetryLevel=k={}));var C;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ae[52],Re([1,0,23,10,5,43,50,177,178]),function(te,e,m,k,C,M,F,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class g{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=g;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=R,e.NullTelemetryService=new R;class y{async publicLog(v,I,h){}async publicLogError(v,I,h){}}e.NullEndpointTelemetryService=y,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(s,v){return C.Event.debounce(v.onDidChangeConfiguration,(h,T)=>{const S=h?new Set([...h.affectedKeys,...T.affectedKeys]):T.affectedKeys;return{...T,affectedKeys:S}},1e3,!0)(h=>{h.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(h.source),configurationKeys:Array.from(h.affectedKeys)})})}e.configurationTelemetry=d;function E(s,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!s.enableTelemetry||v.extensionTestsLocationURI)}e.supportsTelemetry=E;function p(s,v){return!(v.isBuilt||v.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=p;function l(s){const v=s.getValue(D.TELEMETRY_SETTING_ID),I=s.getValue(D.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(s.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||I===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=l;function t(s){const v={},I={},h={};b(s,h);for(let T in h){T=T.length>150?T.substr(T.length-149):T;const S=h[T];typeof S=="number"?I[T]=S:typeof S=="boolean"?I[T]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${T} has been trimmed to 8192, the original length is ${S.length}`),v[T]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(v[T]=S)}return{properties:v,measurements:I}}e.validateTelemetryData=t;const r=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(s){if(!s)return"none";const v=(0,F.getRemoteName)(s);return r.has(v)?v:"other"}e.cleanRemoteAuthority=c;function b(s,v,I=0,h){if(s)for(const T of Object.getOwnPropertyNames(s)){const S=s[T],a=h?h+T:T;Array.isArray(S)?v[a]=(0,m.safeStringify)(S):S instanceof Date?v[a]=S.toISOString():(0,k.isObject)(S)?I<2?b(S,v,I+1,a+"."):v[a]=(0,m.safeStringify)(S):v[a]=S}}function w(s,v){const I=s.msftInternalDomains||[],h=v.getValue("telemetry.internalTesting");return(0,f.verifyMicrosoftInternalDomain)(I)||h}e.isInternalTelemetry=w;function _(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=_;function i(s,v){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let I=s;const h=[];for(const o of v)for(;;){const O=o.exec(s);if(!O)break;h.push([O.index,o.lastIndex])}const T=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(I="";;){const o=S.exec(s);if(!o)break;const O=h.some(([$,K])=>o.index<K&&$<S.lastIndex);!T.test(o[0])&&!O&&(I+=s.substring(a,o.index)+"<REDACTED: user-file-path>",a=S.lastIndex)}return a<s.length&&(I+=s.substr(a)),I}function u(s){if(!s)return s;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const I of v)if(I.regex.test(s))return`<REDACTED: ${I.label}>`;return s}function n(s,v){return(0,m.cloneAndChange)(s,I=>{if(I instanceof g||Object.hasOwnProperty.call(I,"isTrustedTelemetryValue"))return I.value;if(typeof I=="string"){let h=I.replaceAll("%20"," ");h=i(h,v);for(const T of v)h=h.replace(T,"");return h=u(h),h}})}e.cleanData=n}),define(Ae[179],Re([1,0,13,92,24,21,2,9,51,52]),function(te,e,m,k,C,M,F,f,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function R(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,m.compareIgnoreCase)(n.id,s.id)===0}e.areSameExtensions=R;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(s){const v=s.manifest?s.manifest.version:s.version,I=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new d(s.identifier,v,I)}static parse(s){const v=y.exec(s);return v&&v[1]&&v[2]?new d({id:v[1]},v[2],v[4]||void 0):null}constructor(s,v,I="undefined"){this.version=v,this.targetPlatform=I,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof d?R(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=d;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(n){const s=E.exec(n);return s&&s[1]?[t(s[1]),s[2]]:[t(n),void 0]}e.getIdAndVersion=p;function l(n,s){return`${n}.${s}`}e.getExtensionId=l;function t(n){return n.toLowerCase()}e.adoptToGalleryExtensionId=t;function r(n,s){return t(l(n??C.UNDEFINED_PUBLISHER,s))}e.getGalleryExtensionId=r;function c(n,s){const v=[],I=h=>{for(const T of v)if(T.some(S=>R(s(S),s(h))))return T;return null};for(const h of n){const T=I(h);T?T.push(h):v.push([h])}return v}e.groupByExtension=c;function b(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function w(n){return{id:new g.TelemetryTrustedValue(n.identifier.id),name:new g.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function _(n,s){const v=[],I=s.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const h=I.shift();if(h&&v.every(T=>!R(T.identifier,{id:h}))){const T=n.filter(S=>R(S.identifier,{id:h}));T.length===1&&(v.push(T[0]),I.push(...T[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=_;async function i(n,s){if(!M.isLinux)return!1;let v;try{v=(await n.readFile(F.URI.file("/etc/os-release"))).value.toString()}catch{try{v=(await n.readFile(F.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){s.debug("Error while getting the os-release file.",(0,f.getErrorMessage)(h))}}return!!v&&(v.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(n,s){const v=await i(n,s),I=(0,k.getTargetPlatform)(v?"alpine":M.platform,D.arch);return s.debug("ComputeTargetPlatform:",I),I}e.computeTargetPlatform=u}),define(Ae[180],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function m(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=m;function k(D){return D?[...D.entries()]:[]}e.serializeEnvironmentDescriptionMap=k;function C(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=C;function M(D){return new Map(D??[])}e.deserializeEnvironmentDescriptionMap=M;function F(D){return Array.from(D.entries()).map(g=>[g[0],m(g[1].map),k(g[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=F;function f(D){return new Map(D.map(g=>[g[0],{map:C(g[1]),descriptionMap:M(g[2])}]))}e.deserializeEnvironmentVariableCollections=f}),define(Ae[181],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,M,F=5){const f=M(D=>{const g=typeof D=="string"?D:D.data;let R=this._terminalBufferMap.get(C);if(R){R.data.push(g);return}const y=setTimeout(()=>this.flushBuffer(C),F);R={data:[g],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(C),f.dispose()}},this._terminalBufferMap.set(C,R)});return f}stopBuffering(C){this._terminalBufferMap.get(C)?.dispose()}flushBuffer(C){const M=this._terminalBufferMap.get(C);M&&(this._terminalBufferMap.delete(C),this._callback(C,M.data.join("")))}}e.TerminalDataBufferer=m}),define(Ae[182],Re([1,0,16,89,40,5,10,2,144,74,30]),function(te,e,m,k,C,M,F,f,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var y;(function(w){function _(i,u){let n=i.defaults;for(;C.ThemeIcon.isThemeIcon(n);){const s=p.getIcon(n.id);if(!s)return;n=s.defaults}return n}w.getDefinition=_})(y||(e.IconContribution=y={}));var d;(function(w){function _(u){return{weight:u.weight,style:u.style,src:u.src.map(n=>({format:n.format,location:n.location.toString()}))}}w.toJSONObject=_;function i(u){const n=s=>(0,F.isString)(s)?s:void 0;if(u&&Array.isArray(u.src)&&u.src.every(s=>(0,F.isString)(s.format)&&(0,F.isString)(s.location)))return{weight:n(u.weight),style:n(u.style),src:u.src.map(s=>({format:s.format,location:f.URI.parse(s.location)}))}}w.fromJSONObject=i})(d||(e.IconFontDefinition=d={}));class E{constructor(){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(_,i,u,n){const s=this.iconsById[_];if(s){if(u&&!s.description){s.description=u,this.iconSchema.properties[_].markdownDescription=`${u} $(${_})`;const h=this.iconReferenceSchema.enum.indexOf(_);h!==-1&&(this.iconReferenceSchema.enumDescriptions[h]=u),this._onDidChange.fire()}return s}const v={id:_,description:u,defaults:i,deprecationMessage:n};this.iconsById[_]=v;const I={$ref:"#/definitions/icons"};return n&&(I.deprecationMessage=n),u&&(I.markdownDescription=`${u}: $(${_})`),this.iconSchema.properties[_]=I,this.iconReferenceSchema.enum.push(_),this.iconReferenceSchema.enumDescriptions.push(u||""),this._onDidChange.fire(),{id:_}}deregisterIcon(_){delete this.iconsById[_],delete this.iconSchema.properties[_];const i=this.iconReferenceSchema.enum.indexOf(_);i!==-1&&(this.iconReferenceSchema.enum.splice(i,1),this.iconReferenceSchema.enumDescriptions.splice(i,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(_=>this.iconsById[_])}getIcon(_){return this.iconsById[_]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(_,i){const u=this.iconFontsById[_];return u||(this.iconFontsById[_]=i,this._onDidChange.fire(),i)}deregisterIconFont(_){delete this.iconFontsById[_]}getIconFont(_){return this.iconFontsById[_]}toString(){const _=(s,v)=>s.id.localeCompare(v.id),i=s=>{for(;C.ThemeIcon.isThemeIcon(s.defaults);)s=this.iconsById[s.defaults.id];return`codicon codicon-${s?s.id:""}`},u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.iconsById).map(s=>this.iconsById[s]);for(const s of n.filter(v=>!!v.description).sort(_))u.push(`|<i class="${i(s)}"></i>|${s.id}|${C.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const s of n.filter(v=>!C.ThemeIcon.isThemeIcon(v.defaults)).sort(_))u.push(`|<i class="${i(s)}"></i>|${s.id}|`);return u.join(`
`)}}const p=new E;R.Registry.add(e.Extensions.IconContribution,p);function l(w,_,i,u){return p.registerIcon(w,_,i,u)}e.registerIcon=l;function t(){return p}e.getIconRegistry=t;function r(){const w=(0,k.getCodiconFontCharacters)();for(const _ in w){const i="\\"+w[_].toString(16);p.registerIcon(_,{fontCharacter:i})}}r(),e.iconsSchemaId="vscode://schemas/icons";const c=R.Registry.as(g.Extensions.JSONContribution);c.registerSchema(e.iconsSchemaId,p.getIconSchema());const b=new m.RunOnceScheduler(()=>c.notifySchemaChanged(e.iconsSchemaId),200);p.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.widgetClose=l("widget-close",k.Codicon.close,(0,D.localize)(2,null)),e.gotoPreviousLocation=l("goto-previous-location",k.Codicon.arrowUp,(0,D.localize)(3,null)),e.gotoNextLocation=l("goto-next-location",k.Codicon.arrowDown,(0,D.localize)(4,null)),e.syncing=C.ThemeIcon.modify(k.Codicon.sync,"spin"),e.spinningLoading=C.ThemeIcon.modify(k.Codicon.loading,"spin")}),define(Ae[183],Re([1,0,5,43,3,15]),function(te,e,m,k,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var F;(function(l){l.Http="http",l.Https="https"})(F||(e.TunnelProtocol=F={}));var f;(function(l){l.ConstantPrivate="constantPrivate",l.Private="private",l.Public="public"})(f||(e.TunnelPrivacyId=f={}));var D;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore",l[l.OpenBrowserOnce=6]="OpenBrowserOnce"})(D||(e.ProvidedOnAutoForward=D={}));function g(l){if(l.scheme!=="http"&&l.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(t)return{address:t[1],port:+t[2]}}e.extractLocalHostUriMetaDataForPortMapping=g,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(l){return e.LOCALHOST_ADDRESSES.indexOf(l)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(l){return e.ALL_INTERFACES_ADDRESSES.indexOf(l)>=0}e.isAllInterfaces=y;function d(l,t,r,c){if(r===1)return!1;if(r===2&&y(t)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(b?.length===4&&parseInt(b[1])>=18)return!1}return l<1024}e.isPortPrivileged=d;class E{constructor(t,r,c){this.remoteAddress=t,this.localAddress=r,this._dispose=c,this._onDispose=new m.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=E;let p=e.AbstractTunnelService=class{constructor(t,r){this.logService=t,this.configurationService=r,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const t=this.configurationService.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this._tunnelProvider=t,t?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this._canElevate=t.elevation,this._privacyOptions=t.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const t=[],r=Array.from(this._tunnels.values());for(const c of r){const b=Array.from(c.values());for(const w of b){const _=await w.value;_&&t.push(_)}}return t}async dispose(){for(const t of this._tunnels.values()){for(const{value:r}of t.values())await r.then(c=>c?.dispose());t.clear()}this._tunnels.clear()}setEnvironmentTunnel(t,r,c,b,w){this.addTunnelToMap(t,r,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:r,localAddress:c,privacy:b,protocol:w,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,r){(y(t)||R(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const c=this.getTunnelFromMap(t,r);if(c)return++c.refcount,c.value}openTunnel(t,r,c,b,w,_=!1,i,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${c} on local port ${w}.`),!t)return;if(r||(r="localhost"),b||(b=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(c)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.retainOrCreateTunnel(t,r,c,b,w,_,i,u);return n?n.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(r,c);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.makeTunnel(s);return(s.tunnelRemoteHost!==r||s.tunnelRemotePort!==c)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),i&&s.privacy!==i&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(v),v}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const r=this._tunnels.get(t.tunnelRemoteHost);if(r){const c=r.get(t.tunnelRemotePort);c&&(c.refcount--,await this.tryDisposeTunnel(t.tunnelRemoteHost,t.tunnelRemotePort,c))}}}}async tryDisposeTunnel(t,r,c){if(c.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${r}.`);const b=c.value.then(async w=>{w&&(await w.dispose(!0),this._onTunnelClosed.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this._tunnels.has(t)&&this._tunnels.get(t).delete(r),b}}async closeTunnel(t,r){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${r} `);const c=this._tunnels.get(t);if(c&&c.has(r)){const b=c.get(r);b.refcount=0,await this.tryDisposeTunnel(t,r,b)}}addTunnelToMap(t,r,c){this._tunnels.has(t)||this._tunnels.set(t,new Map),this._tunnels.get(t).set(r,{refcount:1,value:c})}async removeEmptyTunnelFromMap(t,r){const c=this._tunnels.get(t);if(c){const b=c.get(r);(b?await b.value:void 0)||c.delete(r),c.size===0&&this._tunnels.delete(t)}}getTunnelFromMap(t,r){const c=[t];R(t)?(c.push(...e.LOCALHOST_ADDRESSES),c.push(...e.ALL_INTERFACES_ADDRESSES)):y(t)&&c.push(...e.ALL_INTERFACES_ADDRESSES);const b=c.map(w=>this._tunnels.get(w));for(const w of b){const _=w?.get(r);if(_)return _}}canTunnel(t){return!!g(t)}createWithProvider(t,r,c,b,w,_,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${c} on local port ${b}.`);const u=c;this._factoryInProgress.add(u);const n=b===void 0?c:b,s={elevationRequired:w?this.isPortPrivileged(n):!1},v={remoteAddress:{host:r,port:c},localAddressPort:b,privacy:_,public:_?_!==f.Private:void 0,protocol:i},I=t.forwardPort(v,s);return I?(this.addTunnelToMap(r,c,I),I.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),I}};e.AbstractTunnelService=p=Ve([He(0,M.ILogService),He(1,k.IConfigurationService)],p)}),define(Ae[184],Re([1,0,3]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,m.createDecorator)("editSessionIdentityService");var k;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(k||(e.EditSessionIdentityMatch=k={}))}),define(Ae[185],Re([1,0,14]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function k(D){return D.scheme!==m.Schemas.file&&D.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=k;function C(D){if(D.folders.length)return D.folders.every(g=>k(g.uri))?D.folders[0].uri:void 0;if(D.configuration&&k(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=C;function M(D){return C(D)?.scheme}e.getVirtualWorkspaceScheme=M;function F(D){return C(D)?.authority}e.getVirtualWorkspaceAuthority=F;function f(D){return C(D)!==void 0}e.isVirtualWorkspace=f}),define(Ae[53],Re([1,0,145,19,48,20,2,3,14]),function(te,e,m,k,C,M,F,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,f.createDecorator)("contextService");function g(s){const v=s;return typeof v?.id=="string"&&F.URI.isUri(v.uri)}e.isSingleFolderWorkspaceIdentifier=g;function R(s){return typeof s?.id=="string"&&!g(s)&&!d(s)}e.isEmptyWorkspaceIdentifier=R,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(s,v){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,k.basename)(s)}:v?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const I=s;return I.configuration?{id:I.id,configPath:I.configuration}:I.folders.length===1?{id:I.id,uri:I.folders[0].uri}:{id:I.id}}e.toWorkspaceIdentifier=y;function d(s){const v=s;return typeof v?.id=="string"&&F.URI.isUri(v.configPath)}e.isWorkspaceIdentifier=d;function E(s){const v=s;if(v?.uri)return{id:v.id,uri:F.URI.revive(v.uri)};const I=s;if(I?.configPath)return{id:I.id,configPath:F.URI.revive(I.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=E;var p;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function l(s){const v=s;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.isWorkspace=l;function t(s){const v=s;return!!(v&&typeof v=="object"&&F.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.isWorkspaceFolder=t;class r{constructor(v,I,h,T,S){this._id=v,this._transient=h,this._configuration=T,this._ignorePathCasing=S,this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=I}update(v){this._id=v.id,this._configuration=v.configuration,this._transient=v.transient,this._ignorePathCasing=v._ignorePathCasing,this.folders=v.folders}get folders(){return this._folders}set folders(v){this._folders=v,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(v){this._configuration=v}getFolder(v){return v&&this._foldersMap.findSubstr(v)||null}updateFoldersMap(){this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const v of this.folders)this._foldersMap.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=r;class c{constructor(v,I){this.raw=I,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,M.joinPath)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=c;function b(s){return new c({uri:s,index:0,name:(0,M.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,m.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(s,v){return M.extUriBiasedIgnorePathCase.isEqualOrParent(s,v.untitledWorkspacesHome)}e.isUntitledWorkspace=w;function _(s){let v;return F.URI.isUri(s)?v=s:v=s.configuration,v?.scheme===D.Schemas.tmp}e.isTemporaryWorkspace=_,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function u(s,v){return!w(s,v)&&!_(s)}e.isSavedWorkspace=u;function n(s){return(typeof s=="string"?(0,k.extname)(s):(0,M.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(Ae[54],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const M=this._idPool++;return this._data.set(M,C),this.logDebugInfo(),M}get(C,M){return this._data.has(C)?this._data.get(C)[M]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){m.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(Ae[39],Re([1,0,14,20,3]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map,this.extUri=new k.ExtUri(f=>{const D=this._providerInfo.get(f.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(f,D){D===null?this._providerInfo.delete(f.scheme):this._providerInfo.set(f.scheme,D)}isFreeScheme(f){return!this._providerInfo.has(f)&&!this._systemSchemes.has(f)}getCapabilities(f){return this._providerInfo.get(f)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,C.createDecorator)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,3]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(Ae[186],Re([1,0,150,15,172,27]),function(te,e,m,k,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=e.ExtHostLogService=class extends C.LogService{constructor(D,g,R){const y=R.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",d=R.remote.isRemote?(0,m.localize)(0,null):D?(0,m.localize)(1,null):(0,m.localize)(2,null);super(g.createLogger(y,{name:d}))}};e.ExtHostLogService=F=Ve([He(1,k.ILoggerService),He(2,M.IExtHostInitDataService)],F)}),define(Ae[187],Re([1,0,16]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class k{constructor(F,f,D){this._deferredPromises=new Map,this._id=F,this._shared=f,this._storage=D,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(g=>(this._value=g,this)),this._storageListener=this._storage.onDidChangeStorage(g=>{g.shared===this._shared&&g.key===this._id&&(this._value=g.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const g=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of g.values())R.complete()}catch(R){for(const y of g.values())y.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,F])=>F!==void 0).map(([F])=>F)}get whenReady(){return this._init}get(F,f){let D=this._value[F];return typeof D>"u"&&(D=f),D}update(F,f){this._value[F]=f;const D=this._deferredPromises.get(F);if(D!==void 0)return D.p;const g=new m.DeferredPromise;return this._deferredPromises.set(F,g),this._scheduler.isScheduled()||this._scheduler.schedule(),g.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=k;class C extends k{setKeysForSync(F){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},F)}constructor(F,f){super(F.identifier.value,!0,f),this._extension=F}}e.ExtensionGlobalMemento=C}),define(Ae[188],Re([1,0,5,2]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class C{constructor(F){this._notebooksAndEditors=F,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new m.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(F,f,D,g){const y=this._notebooksAndEditors.getNotebookDocument(k.URI.revive(F)).acceptModelChanged(f.value,D,g);this._onDidChangeNotebookDocument.fire(y)}$acceptDirtyStateChanged(F,f){this._notebooksAndEditors.getNotebookDocument(k.URI.revive(F)).acceptDirty(f)}$acceptModelSaved(F){const f=this._notebooksAndEditors.getNotebookDocument(k.URI.revive(F));this._onDidSaveNotebookDocument.fire(f.apiNotebook)}}e.ExtHostNotebookDocuments=C}),define(Ae[17],Re([1,0,3]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class k{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=k});var Xe=this&&this.__classPrivateFieldSet||function(te,e,m,k,C){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?C.call(te,m):C?C.value=m:e.set(te,m),m},Fe=this&&this.__classPrivateFieldGet||function(te,e,m,k){if(m==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?k:m==="a"?k.call(te):k?k.value:e.get(te)};define(Ae[189],Re([1,0,24,5]),function(te,e,m,k){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(f,D){C.set(this,void 0),this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(f.identifier),Xe(this,C,D,"f"),Fe(this,C,"f").onDidChangePassword(g=>{g.extensionId===this._id&&this._onDidChange.fire({key:g.key})})}get(f){return Fe(this,C,"f").get(this._id,f)}store(f,D){return Fe(this,C,"f").store(this._id,f,D)}delete(f){return Fe(this,C,"f").delete(this._id,f)}}e.ExtensionSecrets=M,C=new WeakMap}),define(Ae[75],Re([1,0,3,183,5,17]),function(te,e,m,k,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var F;(function(D){function g(y){return{remoteAddress:y.remoteAddress,localAddress:y.localAddress,public:!!y.public,privacy:y.privacy??(y.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:y.protocol}}D.fromApiTunnel=g;function R(y){return{remoteAddress:{host:y.tunnelRemoteHost,port:y.tunnelRemotePort},localAddress:y.localAddress,public:y.privacy!==k.TunnelPrivacyId.ConstantPrivate&&y.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:y.privacy,protocol:y.protocol}}D.fromServiceTunnel=R})(F||(e.TunnelDtoConverter=F={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let f=e.ExtHostTunnelService=class{constructor(g){this.onDidChangeTunnels=new C.Emitter().event}async $applyCandidateFilter(g){return g}async openTunnel(g,R){}async getTunnels(){return[]}async setTunnelFactory(g){return{dispose:()=>{}}}registerPortsAttributesProvider(g,R){return{dispose:()=>{}}}async $providePortAttributes(g,R,y,d,E){return[]}async $forwardPort(g,R){}async $closeTunnel(g){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};e.ExtHostTunnelService=f=Ve([He(0,M.IExtHostRpcService)],f)}),define(Ae[55],Re([1,0,3]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class k{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=F=>F,this.transformOutgoing=F=>F,this.transformOutgoingURI=F=>F,this.transformOutgoingScheme=F=>F)}}e.URITransformerService=k}),define(Ae[190],Re([1,0,25]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(D){let g=this.buffers.indexOf(D);return g<0&&(g=this.buffers.length,this.buffers.push(D)),g}}function C(f,D){if(D.serializeBuffersForPostMessage){const g=new k,y=JSON.stringify(f,(E,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(p)};if(ArrayBuffer.isView(p)){const l=M(p);if(l)return{$$vscode_array_buffer_reference$$:!0,index:g.add(p.buffer),view:{type:l,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),d=g.buffers.map(E=>{const p=new Uint8Array(E);return m.VSBuffer.wrap(p)});return{message:y,buffers:d}}else return{message:JSON.stringify(f),buffers:[]}}e.serializeWebviewMessage=C;function M(f){switch(f.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function F(f,D){const g=D.map(d=>{const E=new ArrayBuffer(d.byteLength);return new Uint8Array(E).set(d.buffer),E}),R=D.length?(d,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const p=E,{index:l}=p,t=g[l];if(p.view)switch(p.view.type){case 1:return new Int8Array(t,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return E}:void 0;return{message:JSON.parse(f,R),arrayBuffers:g}}e.deserializeWebviewMessage=F}),define(Ae[99],Re([1,0,157,10,2,6,3,30,38,14,41,127,29]),function(te,e,m,k,C,M,F,f,D,g,R,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var E;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var p;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function l(X){const ce=X;return!!ce&&typeof ce.getSelection=="function"&&!!ce.onDidChangeSelection}e.isEditorPaneWithSelection=l;function t(X,ce,De){for(const ke of De.visibleEditorPanes)if(ke.group.id===ce&&X.matches(ke.input))return ke.getViewState()}e.findViewStateForEditor=t;function r(X){if(I(X))return!1;const ce=X;return C.URI.isUri(ce?.resource)}e.isResourceEditorInput=r;function c(X){if(I(X))return!1;const ce=X;return ce?.original!==void 0&&ce.modified!==void 0}e.isResourceDiffEditorInput=c;function b(X){if(I(X)||c(X))return!1;const ce=X;return ce?.primary!==void 0&&ce.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function w(X){if(I(X))return!1;const ce=X;return ce?ce.resource===void 0||ce.resource.scheme===g.Schemas.untitled||ce.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=w;function _(X){if(I(X))return!1;const ce=X;return C.URI.isUri(ce?.base?.resource)&&C.URI.isUri(ce?.input1?.resource)&&C.URI.isUri(ce?.input2?.resource)&&C.URI.isUri(ce?.result?.resource)}e.isResourceMergeEditorInput=_;var i;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(i||(e.Verbosity=i={}));var u;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class n{constructor(){this.mapIdToSaveSource=new Map}registerSource(ce,De){let ke=this.mapIdToSaveSource.get(ce);return ke||(ke={source:ce,label:De},this.mapIdToSaveSource.set(ce,ke)),ke.source}getSourceLabel(ce){return this.mapIdToSaveSource.get(ce)?.label??ce}}e.SaveSourceRegistry=new n;var s;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors",X[X.Scratchpad=512]="Scratchpad"})(s||(e.EditorInputCapabilities=s={}));class v extends M.Disposable{}e.AbstractEditorInput=v;function I(X){return X instanceof v}e.isEditorInput=I;function h(X){const ce=X;return C.URI.isUri(ce?.preferredResource)}function T(X){const ce=X;return I(ce?.primary)&&I(ce?.secondary)}e.isSideBySideEditorInput=T;function S(X){const ce=X;return I(ce?.modified)&&I(ce?.original)}e.isDiffEditorInput=S;function a(X,ce,De,ke,ge){return J(ke,[(0,y.toAction)({id:"workbench.action.openLargeFile",label:(0,m.localize)(2,null),run:()=>{const A={...De,limits:{size:Number.MAX_VALUE}};X.openEditor(ce,A)}}),(0,y.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,m.localize)(3,null),run:()=>ge.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:d.default.Warning})}e.createTooLargeFileError=a;function o(X){return I(X?.editor)}e.isEditorInputWithOptions=o;function O(X){const ce=X;return o(X)&&ce?.group!==void 0}e.isEditorInputWithOptionsAndGroup=O;function $(X){const ce=X;return typeof ce?.groupId=="number"&&I(ce.editor)}e.isEditorIdentifier=$;var K;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(K||(e.EditorCloseContext=K={}));var V;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LOCKED=2]="GROUP_LOCKED",X[X.EDITOR_OPEN=3]="EDITOR_OPEN",X[X.EDITOR_CLOSE=4]="EDITOR_CLOSE",X[X.EDITOR_MOVE=5]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=7]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=9]="EDITOR_PIN",X[X.EDITOR_STICKY=10]="EDITOR_STICKY",X[X.EDITOR_DIRTY=11]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(V||(e.GroupModelChangeKind=V={}));var z;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class N{getOriginalUri(ce,De){if(!ce)return;if(_(ce))return e.EditorResourceAccessor.getOriginalUri(ce.result,De);if(De?.supportSideBySide){const{primary:ge,secondary:A}=this.getSideEditors(ce);if(ge&&A){if(De?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(ge,{filterByScheme:De.filterByScheme}),secondary:this.getOriginalUri(A,{filterByScheme:De.filterByScheme})};if(De?.supportSideBySide===z.ANY)return this.getOriginalUri(ge,{filterByScheme:De.filterByScheme})??this.getOriginalUri(A,{filterByScheme:De.filterByScheme});ce=De.supportSideBySide===z.PRIMARY?ge:A}}if(c(ce)||b(ce)||_(ce))return;const ke=h(ce)?ce.preferredResource:ce.resource;return!ke||!De||!De.filterByScheme?ke:this.filterUri(ke,De.filterByScheme)}getSideEditors(ce){return T(ce)||b(ce)?{primary:ce.primary,secondary:ce.secondary}:S(ce)||c(ce)?{primary:ce.modified,secondary:ce.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ce,De){if(!ce)return;if(_(ce))return e.EditorResourceAccessor.getCanonicalUri(ce.result,De);if(De?.supportSideBySide){const{primary:ge,secondary:A}=this.getSideEditors(ce);if(ge&&A){if(De?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(ge,{filterByScheme:De.filterByScheme}),secondary:this.getCanonicalUri(A,{filterByScheme:De.filterByScheme})};if(De?.supportSideBySide===z.ANY)return this.getCanonicalUri(ge,{filterByScheme:De.filterByScheme})??this.getCanonicalUri(A,{filterByScheme:De.filterByScheme});ce=De.supportSideBySide===z.PRIMARY?ge:A}}if(c(ce)||b(ce)||_(ce))return;const ke=ce.resource;return!ke||!De||!De.filterByScheme?ke:this.filterUri(ke,De.filterByScheme)}filterUri(ce,De){if(Array.isArray(De)){if(De.some(ke=>ce.scheme===ke))return ce}else if(De===ce.scheme)return ce}}e.EditorResourceAccessor=new N;var q;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(q||(e.CloseDirection=q={}));class B{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(ce){const De=this.instantiationService=ce.get(F.IInstantiationService);for(const[ke,ge]of this.editorSerializerConstructors)this.createEditorSerializer(ke,ge,De);this.editorSerializerConstructors.clear()}createEditorSerializer(ce,De,ke){const ge=ke.createInstance(De);this.editorSerializerInstances.set(ce,ge)}registerFileEditorFactory(ce){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=ce}getFileEditorFactory(){return(0,k.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(ce,De){if(this.editorSerializerConstructors.has(ce)||this.editorSerializerInstances.has(ce))throw new Error(`A editor serializer with type ID '${ce}' was already registered.`);return this.instantiationService?this.createEditorSerializer(ce,De,this.instantiationService):this.editorSerializerConstructors.set(ce,De),(0,M.toDisposable)(()=>{this.editorSerializerConstructors.delete(ce),this.editorSerializerInstances.delete(ce)})}getEditorSerializer(ce){return this.editorSerializerInstances.get(typeof ce=="string"?ce:ce.typeId)}}f.Registry.add(e.EditorExtensions.EditorFactory,new B);async function U(X,ce,De){return!X||!X.length?[]:await Promise.all(X.map(async ke=>{const ge=C.URI.revive(ke.fileUri);if(!ge){De.info("Cannot resolve the path because it is not valid.",ke);return}if(!await ce.canHandleResource(ge)){De.info("Cannot resolve the path because it cannot be handled",ke);return}let G=ke.exists,de=ke.type;if(typeof G!="boolean"||typeof de!="number")try{de=(await ce.stat(ge)).isDirectory?D.FileType.Directory:D.FileType.Unknown,G=!0}catch(_e){De.error(_e),G=!1}if(!G&&ke.openOnlyIfExists){De.info("Cannot resolve the path because it does not exist",ke);return}if(de===D.FileType.Directory){De.info("Cannot resolve the path because it is a directory",ke);return}const ye={...ke.options,pinned:!0};return G?{resource:ge,options:ye}:{resource:ge,options:ye,forceUntitled:!0}}))}e.pathsToEditors=U;var le;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(le||(e.EditorsOrder=le={}));function ve(X){const ce=X;if(!ce)return!1;const De=ce;if(De.modified)return ve(De.modified);const ke=ce;return!!(ke.contributionsState&&ke.viewState&&Array.isArray(ke.cursorState))}e.isTextEditorViewState=ve;function Pe(X){return(0,R.isErrorWithActions)(X)}e.isEditorOpenError=Pe;function J(X,ce,De){const ke=(0,R.createErrorWithActions)(X,ce);return ke.forceMessage=De?.forceMessage,ke.forceSeverity=De?.forceSeverity,ke.allowDialog=De?.allowDialog,ke}e.createEditorOpenError=J}),define(Ae[191],Re([1,0,5,158,3,6,28,30,18,64,23,89,182]),function(te,e,m,k,C,M,F,f,D,g,R,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,d.registerIcon)("default-view-icon",y.Codicon.window,(0,k.localize)(0,null));var E;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(E||(e.Extensions=E={}));var p;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.ViewContainerLocations=[0,1,2];function l(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=l;class t extends M.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new m.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new m.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,D.flatten)([...this.viewContainers.values()])}registerViewContainer(s,v,I){const h=this.get(s.id);if(h)return h;const T=s;return T.openCommandActionDescriptor=I?.doNotRegisterOpenCommand?void 0:T.openCommandActionDescriptor??{id:T.id},(0,F.getOrSet)(this.viewContainers,v,[]).push(T),I?.isDefault&&this.defaultViewContainers.push(T),this._onDidRegister.fire({viewContainer:T,viewContainerLocation:v}),T}deregisterViewContainer(s){for(const v of this.viewContainers.keys()){const I=this.viewContainers.get(v),h=I?.indexOf(s);if(h!==-1){I?.splice(h,1),I.length===0&&this.viewContainers.delete(v),this._onDidDeregister.fire({viewContainer:s,viewContainerLocation:v});return}}}get(s){return this.all.filter(v=>v.id===s)[0]}getViewContainers(s){return[...this.viewContainers.get(s)||[]]}getViewContainerLocation(s){return[...this.viewContainers.keys()].filter(v=>this.getViewContainers(v).filter(I=>I?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.defaultViewContainers.find(v=>this.getViewContainerLocation(v)===s)}}f.Registry.add(E.ViewContainersRegistry,new t);var r;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(r||(e.ViewContentGroups=r={}));function c(n,s){const v=n.group??r.More,I=s.group??r.More;return v!==I?v.localeCompare(I):(n.order??5)-(s.order??5)}class b extends M.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new m.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new m.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new m.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new m.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new g.SetMap}registerViews(s,v){this.registerViews2([{views:s,viewContainer:v}])}registerViews2(s){s.forEach(({views:v,viewContainer:I})=>this.addViews(v,I)),this._onViewsRegistered.fire(s)}deregisterViews(s,v){const I=this.removeViews(s,v);I.length&&this._onViewsDeregistered.fire({views:I,viewContainer:v})}moveViews(s,v){for(const I of this._views.keys())if(I!==v){const h=this.removeViews(s,I);h.length&&(this.addViews(h,v),this._onDidChangeContainer.fire({views:h,from:I,to:v}))}}getViews(s){return this._views.get(s)||[]}getView(s){for(const v of this._viewContainers){const I=(this._views.get(v)||[]).filter(h=>h.id===s)[0];if(I)return I}return null}getViewContainer(s){for(const v of this._viewContainers)if((this._views.get(v)||[]).filter(h=>h.id===s)[0])return v;return null}registerViewWelcomeContent(s,v){return this._viewWelcomeContents.add(s,v),this._onDidChangeViewWelcomeContent.fire(s),(0,M.toDisposable)(()=>{this._viewWelcomeContents.delete(s,v),this._onDidChangeViewWelcomeContent.fire(s)})}registerViewWelcomeContent2(s,v){const I=new Map;for(const[h,T]of v)this._viewWelcomeContents.add(s,T),I.set(h,(0,M.toDisposable)(()=>{this._viewWelcomeContents.delete(s,T),this._onDidChangeViewWelcomeContent.fire(s)}));return this._onDidChangeViewWelcomeContent.fire(s),I}getViewWelcomeContent(s){const v=[];return this._viewWelcomeContents.forEach(s,I=>v.push(I)),v.sort(c)}addViews(s,v){let I=this._views.get(v);I||(I=[],this._views.set(v,I),this._viewContainers.push(v));for(const h of s){if(this.getView(h.id)!==null)throw new Error((0,k.localize)(1,null,h.id));I.push(h)}}removeViews(s,v){const I=this._views.get(v);if(!I)return[];const h=[],T=[];for(const S of I)s.includes(S)?h.push(S):T.push(S);return h.length&&(T.length?this._views.set(v,T):(this._views.delete(v),this._viewContainers.splice(this._viewContainers.indexOf(v),1))),h}}f.Registry.add(E.ViewsRegistry,new b),e.IViewsService=(0,C.createDecorator)("viewsService"),e.IViewDescriptorService=(0,C.createDecorator)("viewDescriptorService");var w;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(w||(e.ViewVisibilityState=w={}));var _;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(_||(e.TreeItemCollapsibleState=_={}));class i{constructor(s,v){this.resolved=!1,this._hasResolve=!1,(0,R.mixin)(this,s),this._hasResolve=!!v,this.resolve=async I=>{if(v&&!this.resolved){const h=await v(I);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}I.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class u extends Error{constructor(s){super((0,k.localize)(2,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.NoTreeViewError=u}),define(Ae[192],Re([1,0,5,16,159]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(f){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=f}onEvent(f){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=f}onRequest(f){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=f}sendResponse(f){f.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${f.command}`)):this.internalSend("response",f)}sendRequest(f,D,g,R){const y={command:f};if(D&&Object.keys(D).length>0&&(y.arguments=D),this.internalSend("request",y),typeof R=="number"){const d=setTimeout(()=>{clearTimeout(d);const E=this.pendingRequests.get(y.seq);if(E){this.pendingRequests.delete(y.seq);const p={type:"response",seq:0,request_seq:y.seq,success:!1,command:f,message:(0,C.localize)(0,null,R,f)};E(p)}},R)}return g&&this.pendingRequests.set(y.seq,g),y.seq}acceptMessage(f){this.messageCallback?this.messageCallback(f):(this.queue.push(f),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(f,D){return f.type!=="event"||D.type!=="event"}async processQueue(){let f;for(;this.queue.length;){if((!f||this.needsTaskBoundaryBetween(this.queue[0],f))&&await(0,k.timeout)(0),f=this.queue.shift(),!f)return;switch(f.type){case"event":this.eventCallback?.(f);break;case"request":this.requestCallback?.(f);break;case"response":{const D=f,g=this.pendingRequests.get(D.request_seq);g&&(this.pendingRequests.delete(D.request_seq),g(D));break}}}}internalSend(f,D){D.type=f,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const f=new Map;this.pendingRequests.forEach((D,g)=>f.set(g,D)),await(0,k.timeout)(500),f.forEach((D,g)=>{D({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(g)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=M}),define(Ae[193],Re([1,0,160,31,3]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new k.RawContextKey("debugType",void 0,{type:"string",description:m.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new k.RawContextKey("debugConfigurationType",void 0,{type:"string",description:m.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new k.RawContextKey("debugState","inactive",{type:"string",description:m.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new k.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:m.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new k.RawContextKey("hasDebugged",!1,{type:"boolean",description:m.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new k.RawContextKey("inDebugMode",!1,{type:"boolean",description:m.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new k.RawContextKey("inDebugRepl",!1,{type:"boolean",description:m.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new k.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:m.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new k.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:m.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new k.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:m.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new k.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:m.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new k.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:m.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new k.RawContextKey("variablesFocused",!0,{type:"boolean",description:m.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new k.RawContextKey("expressionSelected",!1,{type:"boolean",description:m.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new k.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:m.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new k.RawContextKey("callStackItemType",void 0,{type:"string",description:m.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new k.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:m.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new k.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:m.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new k.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:m.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new k.RawContextKey("watchItemType",void 0,{type:"string",description:m.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new k.RawContextKey("canViewMemory",void 0,{type:"boolean",description:m.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new k.RawContextKey("breakpointItemType",void 0,{type:"string",description:m.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new k.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:m.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new k.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:m.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new k.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:m.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new k.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:m.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new k.RawContextKey("stepBackSupported",!1,{type:"boolean",description:m.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new k.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:m.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new k.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:m.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new k.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:m.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new k.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:m.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new k.RawContextKey("breakpointsExist",!1,{type:"boolean",description:m.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new k.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:m.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new k.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:m.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new k.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:m.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new k.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:m.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new k.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:m.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new k.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:m.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new k.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:m.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new k.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:m.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new k.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:m.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new k.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:m.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new k.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:m.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new k.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:m.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new k.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:m.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new k.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:m.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new k.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:m.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new k.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:m.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new k.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:m.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new k.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:m.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new k.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:m.localize(50,null)});const M=d=>m.localize(51,null,d);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:m.localize(52,null)};var F;(function(d){d[d.Inactive=0]="Inactive",d[d.Initializing=1]="Initializing",d[d.Stopped=2]="Stopped",d[d.Running=3]="Running"})(F||(e.State=F={}));function f(d){switch(d){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=f;var D;(function(d){d[d.Valid=0]="Valid",d[d.Unreadable=1]="Unreadable",d[d.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var g;(function(d){d[d.Initial=1]="Initial",d[d.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var R;(function(d){d.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.IDebugService=(0,C.createDecorator)("debugService");var y;(function(d){d[d.CONDITION=0]="CONDITION",d[d.HIT_COUNT=1]="HIT_COUNT",d[d.LOG_MESSAGE=2]="LOG_MESSAGE"})(y||(e.BreakpointWidgetContext=y={}))}),define(Ae[194],Re([1,0,13,2,19,23,14,44,22,18]),function(te,e,m,k,C,M,F,f,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function y(h,T,S){return h.replace(R,function(a,o){return T&&o.length>0&&o[0]!=="_"?a:S&&S.hasOwnProperty(o)?S[o]:a})}e.formatPII=y;function d(h){const T={};for(const S of Object.keys(h))S.startsWith("!")||(T[S]=h[S]);return T}e.filterExceptionsFromTelemetry=d;function E(h){return h.configuration.request==="attach"&&!p(h)&&(!h.parentSession||E(h.parentSession))}e.isSessionAttach=E;function p(h){let T=h.configuration.type;if(T)return T==="vslsShare"&&(T=h.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(T,"extensionhost")||(0,m.equalsIgnoreCase)(T,"pwa-extensionhost")?h:h.parentSession?p(h.parentSession):void 0}e.getExtensionHostDebugSession=p;function l(h){return h.type&&(h.label||h.program||h.runtime)}e.isDebuggerMainContribution=l;function t(h,T,S){let a,o=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let $=null;for(;$=O.exec(h);){const K=$.index+1,V=K+$[0].length;if(K<=T&&V>=S){a=$[0],o=K;break}}if(a){const K=/\w+/g;let V=null;for(;(V=K.exec(a))&&!(V.index+1+o+V[0].length>=S););V&&(a=a.substring(0,K.lastIndex))}return a?{start:o,end:o+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=t;async function r(h,T,S,a){if(h.evaluatableExpressionProvider.has(T)){const o=h.evaluatableExpressionProvider.ordered(T),O=(0,g.coalesce)(await Promise.all(o.map(async $=>{try{return await $.provideEvaluatableExpression(T,S,a??D.CancellationToken.None)}catch{return}})));if(O.length>0){let $=O[0].expression;const K=O[0].range;return $||($=T.getLineContent(S.lineNumber).substring(K.startColumn-1,K.endColumn-1)),{range:K,matchingExpression:$}}}else{const o=T.getLineContent(S.lineNumber),{start:O,end:$}=t(o,S.column,S.column),K=o.substring(O-1,$);return{matchingExpression:K,range:new f.Range(S.lineNumber,O,S.lineNumber,O+K.length)}}return null}e.getEvaluatableExpressionAtPosition=r;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(h){return!!(h&&h.match(c))}e.isUri=b;function w(h){if(typeof h.path=="string"&&!(typeof h.sourceReference=="number"&&h.sourceReference>0)){if(b(h.path))return k.URI.parse(h.path);if((0,C.isAbsolute)(h.path))return k.URI.file(h.path)}return h.path}function _(h){if(typeof h.path=="object"){const T=k.URI.revive(h.path);if(T)return T.scheme===F.Schemas.file?T.fsPath:T.toString()}return h.path}function i(h,T){const S=T?w:_,a=(0,M.deepClone)(h);return n(a,(o,O)=>{o&&O&&(O.path=S(O))}),a}e.convertToDAPaths=i;function u(h,T){const S=T?w:_,a=(0,M.deepClone)(h);return n(a,(o,O)=>{!o&&O&&(O.path=S(O))}),a}e.convertToVSCPaths=u;function n(h,T){switch(h.type){case"event":{const S=h;switch(S.event){case"output":T(!1,S.body.source);break;case"loadedSource":T(!1,S.body.source);break;case"breakpoint":T(!1,S.body.breakpoint.source);break;default:break}break}case"request":{const S=h;switch(S.command){case"setBreakpoints":T(!0,S.arguments.source);break;case"breakpointLocations":T(!0,S.arguments.source);break;case"source":T(!0,S.arguments.source);break;case"gotoTargets":T(!0,S.arguments.source);break;case"launchVSCode":S.arguments.args.forEach(a=>T(!1,a));break;default:break}break}case"response":{const S=h;if(S.success&&S.body)switch(S.command){case"stackTrace":S.body.stackFrames.forEach(a=>T(!1,a.source));break;case"loadedSources":S.body.sources.forEach(a=>T(!1,a));break;case"scopes":S.body.scopes.forEach(a=>T(!1,a.source));break;case"setFunctionBreakpoints":S.body.breakpoints.forEach(a=>T(!1,a.source));break;case"setBreakpoints":S.body.breakpoints.forEach(a=>T(!1,a.source));break;case"disassemble":S.body?.instructions.forEach(o=>T(!1,o.location));break;default:break}break}}}function s(h){return h.filter(T=>!T.presentation?.hidden).sort((T,S)=>T.presentation?S.presentation?T.presentation.group?S.presentation.group?T.presentation.group!==S.presentation.group?T.presentation.group.localeCompare(S.presentation.group):v(T.presentation.order,S.presentation.order):-1:S.presentation.group?1:v(T.presentation.order,S.presentation.order):-1:S.presentation?1:0)}e.getVisibleAndSorted=s;function v(h,T){return typeof h!="number"?typeof T!="number"?0:1:typeof T!="number"?-1:h-T}async function I(h,T){const S=h.getValue("debug.saveBeforeStart",{overrideIdentifier:T.activeTextEditorLanguageId});if(S!=="none"&&(await T.saveAll(),S==="allEditorsInActiveGroup")){const a=T.activeEditorPane;a&&a.input.resource?.scheme===F.Schemas.untitled&&await T.save({editor:a.input,groupId:a.group.id})}await h.reloadConfiguration()}e.saveAllBeforeDebugStart=I}),define(Ae[76],Re([1,0,25,37,67,68,14,19,21,31]),function(te,e,m,k,C,M,F,f,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var R;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(R||(e.CellKind=R={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(y||(e.NotebookRunState=y={}));var d;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(d||(e.NotebookCellExecutionState=d={}));var E;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(E||(e.NotebookExecutionState=E={}));var p;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var l;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(l||(e.RendererMessagingSpec=l={}));var t;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var r;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(r||(e.SelectionStateType=r={}));var c;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var b;(function(B){B.scheme=F.Schemas.vscodeNotebookCell;const U=["W","X","Y","Z","a","b","c","d","e","f"],le=new RegExp(`^[${U.join("")}]+`),ve=7;function Pe(ge,A){const G=A.toString(ve),ye=`${G.length<U.length?U[G.length-1]:"z"}${G}s${(0,m.encodeBase64)(m.VSBuffer.fromString(ge.scheme),!0,!0)}`;return ge.with({scheme:B.scheme,fragment:ye})}B.generate=Pe;function J(ge){if(ge.scheme!==B.scheme)return;const A=ge.fragment.indexOf("s");if(A<0)return;const G=parseInt(ge.fragment.substring(0,A).replace(le,""),ve),de=(0,m.decodeBase64)(ge.fragment.substring(A+1)).toString();if(!isNaN(G))return{handle:G,notebook:ge.with({scheme:de,fragment:null})}}B.parse=J;function X(ge,A){return ge.with({scheme:F.Schemas.vscodeNotebookCellOutput,fragment:`op${A??""},${ge.scheme!==F.Schemas.file?ge.scheme:""}`})}B.generateCellOutputUri=X;function ce(ge){if(ge.scheme!==F.Schemas.vscodeNotebookCellOutput)return;const A=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ge.fragment);if(!A)return;const G=A[1]&&A[1]!==""?A[1]:void 0,de=A[2];return{outputId:G,notebook:ge.with({scheme:de||F.Schemas.file,fragment:null})}}B.parseCellOutputUri=ce;function De(ge,A,G){return B.generate(ge,A).with({scheme:G})}B.generateCellPropertyUri=De;function ke(ge,A){if(ge.scheme===A)return B.parse(ge.with({scheme:B.scheme}))}B.parseCellPropertyUri=ke})(b||(e.CellUri=b={}));const w=B=>D.isWindows?B.replace(/\//g,"\\"):B;class _{constructor(U=[],le=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=le,this.order=[...new Set(U)].map(ve=>({pattern:ve,matches:k.parse(w(ve))}))}sort(U){const le=new Map(C.Iterable.map(U,Pe=>[Pe,w(Pe)]));let ve=[];for(const{matches:Pe}of this.order)for(const[J,X]of le)if(Pe(X)){ve.push(J),le.delete(J);break}return le.size&&(ve=ve.concat([...le.keys()].sort((Pe,J)=>this.defaultOrder.indexOf(Pe)-this.defaultOrder.indexOf(J)))),ve}prioritize(U,le){const ve=this.findIndex(U);if(ve===-1){this.order.unshift({pattern:U,matches:k.parse(w(U))});return}const Pe=new Set(le.map(X=>this.findIndex(X,ve)));Pe.delete(-1);const J=Array.from(Pe).sort();this.order.splice(ve+1,0,...J.map(X=>this.order[X]));for(let X=J.length-1;X>=0;X--)this.order.splice(J[X],1)}toArray(){return this.order.map(U=>U.pattern)}findIndex(U,le=this.order.length){const ve=w(U);for(let Pe=0;Pe<le;Pe++)if(this.order[Pe].matches(ve))return Pe;return-1}}e.MimeTypeDisplayOrder=_;function i(B,U,le,ve=(Pe,J)=>Pe===J){const Pe=[];function J(De,ke,ge){if(ke===0&&ge.length===0)return;const A=Pe[Pe.length-1];A&&A.start+A.deleteCount===De?(A.deleteCount+=ke,A.toInsert.push(...ge)):Pe.push({start:De,deleteCount:ke,toInsert:ge})}let X=0,ce=0;for(;;){if(X===B.length){J(X,0,U.slice(ce));break}if(ce===U.length){J(X,B.length-X,[]);break}const De=B[X],ke=U[ce];if(ve(De,ke)){X+=1,ce+=1;continue}le(ke)?(J(X,1,[]),X+=1):(J(X,0,[ke]),ce+=1)}return Pe}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new g.RawContextKey("notebookEditorCursorAtBoundary","none");var u;(function(B){B.default="default",B.option="option"})(u||(e.NotebookEditorPriority=u={}));function n(B){const U=B;return!!((typeof U.include=="string"||k.isRelativePattern(U.include))&&(typeof U.exclude=="string"||k.isRelativePattern(U.exclude)))}e.isDocumentExcludePattern=n;function s(B,U,le){if(Array.isArray(B.viewType)&&B.viewType.indexOf(U)>=0||B.viewType===U)return!0;if(B.filenamePattern){const ve=n(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,Pe=n(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(k.match(ve,(0,f.basename)(le.fsPath).toLowerCase()))return!(Pe&&k.match(Pe,(0,f.basename)(le.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell"};var v;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(v||(e.CellStatusbarAlignment=v={}));class I{static create(U){return`${I._prefix}${U}`}static parse(U){if(U.startsWith(I._prefix))return U.substring(I._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=I,I._prefix="notebook/";function h(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=h;const T=new TextDecoder;function S(B){const U=[];let le=!1;for(const ve of B)(U.length===0||le)&&(U.push(ve),le=!0);return $(U),q(m.VSBuffer.concat(U.map(ve=>m.VSBuffer.wrap(ve))))}e.compressOutputItemStreams=S;const a=`${String.fromCharCode(27)}[A`,o=a.split("").map(B=>B.charCodeAt(0)),O=10;function $(B){B.forEach((U,le)=>{if(le===0||U.length<a.length)return;const ve=B[le-1],Pe=U.subarray(0,a.length);if(Pe[0]===o[0]&&Pe[1]===o[1]&&Pe[2]===o[2]){const J=ve.lastIndexOf(O);if(J===-1)return;B[le-1]=ve.subarray(0,J),B[le]=U.subarray(a.length)}})}function K(B){let U=B;do B=U,U=B.replace(/[^\n]\x08/gm,"");while(U.length<B.length);return B}function V(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const U=B.match(/^(.*)\r+/m)[1];let le=B.match(/\r+(.*)$/m)[1];le=le+U.slice(le.length,U.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,le)}return B}const z="\b".charCodeAt(0),N="\r".charCodeAt(0);function q(B){return!B.buffer.includes(z)&&!B.buffer.includes(N)?B:m.VSBuffer.fromString(V(K(T.decode(B.buffer))))}});var Xe=this&&this.__classPrivateFieldSet||function(te,e,m,k,C){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?C.call(te,m):C?C.value=m:e.set(te,m),m},Fe=this&&this.__classPrivateFieldGet||function(te,e,m,k){if(m==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?k:m==="a"?k.call(te):k?k.value:e.get(te)};define(Ae[7],Re([1,0,18,9,70,28,68,13,10,2,36,24,38,97,76]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p){"use strict";var l,t,r,c,b,w,_,i,u,n,s,v,I,h,T,S,a,o,O,$,K,V,z,N,q,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.NotebookCodeActionKind=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function U(x){return Object.assign(x,{apply:function(){const oe=arguments.length===1?[]:arguments[1];return Reflect.construct(x,oe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(x,[]);{const[oe,...Ie]=arguments;return Reflect.construct(x,Ie,oe.constructor)}}})}var le;(function(x){x[x.Top=0]="Top",x[x.Bottom=1]="Bottom"})(le||(e.TerminalOutputAnchor=le={}));var ve;(function(x){x[x.Command=0]="Command",x[x.Opener=1]="Opener"})(ve||(e.TerminalQuickFixType=ve={}));let Pe=e.Disposable=u=class{static from(...L){let oe=L;return new u(function(){if(oe){for(const Ie of oe)Ie&&typeof Ie.dispose=="function"&&Ie.dispose();oe=void 0}})}constructor(L){l.set(this,void 0),Xe(this,l,L,"f")}dispose(){typeof Fe(this,l,"f")=="function"&&(Fe(this,l,"f").call(this),Xe(this,l,void 0,"f"))}};l=new WeakMap,e.Disposable=Pe=u=Ve([U],Pe);let J=e.Position=n=class{static Min(...L){if(L.length===0)throw new TypeError;let oe=L[0];for(let Ie=1;Ie<L.length;Ie++){const je=L[Ie];je.isBefore(oe)&&(oe=je)}return oe}static Max(...L){if(L.length===0)throw new TypeError;let oe=L[0];for(let Ie=1;Ie<L.length;Ie++){const je=L[Ie];je.isAfter(oe)&&(oe=je)}return oe}static isPosition(L){if(!L)return!1;if(L instanceof n)return!0;const{line:oe,character:Ie}=L;return typeof oe=="number"&&typeof Ie=="number"}static of(L){if(L instanceof n)return L;if(this.isPosition(L))return new n(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(L,oe){if(L<0)throw(0,k.illegalArgument)("line must be non-negative");if(oe<0)throw(0,k.illegalArgument)("character must be non-negative");this._line=L,this._character=oe}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,oe=0){if(L===null||oe===null)throw(0,k.illegalArgument)();let Ie;return typeof L>"u"?Ie=0:typeof L=="number"?Ie=L:(Ie=typeof L.lineDelta=="number"?L.lineDelta:0,oe=typeof L.characterDelta=="number"?L.characterDelta:0),Ie===0&&oe===0?this:new n(this.line+Ie,this.character+oe)}with(L,oe=this.character){if(L===null||oe===null)throw(0,k.illegalArgument)();let Ie;return typeof L>"u"?Ie=this.line:typeof L=="number"?Ie=L:(Ie=typeof L.line=="number"?L.line:this.line,oe=typeof L.character=="number"?L.character:this.character),Ie===this.line&&oe===this.character?this:new n(Ie,oe)}toJSON(){return{line:this.line,character:this.character}}};e.Position=J=n=Ve([U],J);let X=e.Range=s=class{static isRange(L){return L instanceof s?!0:L?J.isPosition(L.start)&&J.isPosition(L.end):!1}static of(L){if(L instanceof s)return L;if(this.isRange(L))return new s(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(L,oe,Ie,je){let Ye,ot;if(typeof L=="number"&&typeof oe=="number"&&typeof Ie=="number"&&typeof je=="number"?(Ye=new J(L,oe),ot=new J(Ie,je)):J.isPosition(L)&&J.isPosition(oe)&&(Ye=J.of(L),ot=J.of(oe)),!Ye||!ot)throw new Error("Invalid arguments");Ye.isBefore(ot)?(this._start=Ye,this._end=ot):(this._start=ot,this._end=Ye)}contains(L){return s.isRange(L)?this.contains(L.start)&&this.contains(L.end):J.isPosition(L)?!(J.of(L).isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const oe=J.Max(L.start,this._start),Ie=J.Min(L.end,this._end);if(!oe.isAfter(Ie))return new s(oe,Ie)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const oe=J.Min(L.start,this._start),Ie=J.Max(L.end,this.end);return new s(oe,Ie)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,oe=this.end){if(L===null||oe===null)throw(0,k.illegalArgument)();let Ie;return L?J.isPosition(L)?Ie=L:(Ie=L.start||this.start,oe=L.end||this.end):Ie=this.start,Ie.isEqual(this._start)&&oe.isEqual(this.end)?this:new s(Ie,oe)}toJSON(){return[this.start,this.end]}};e.Range=X=s=Ve([U],X);let ce=e.Selection=v=class extends X{static isSelection(L){return L instanceof v?!0:L?X.isRange(L)&&J.isPosition(L.anchor)&&J.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(L,oe,Ie,je){let Ye,ot;if(typeof L=="number"&&typeof oe=="number"&&typeof Ie=="number"&&typeof je=="number"?(Ye=new J(L,oe),ot=new J(Ie,je)):J.isPosition(L)&&J.isPosition(oe)&&(Ye=J.of(L),ot=J.of(oe)),!Ye||!ot)throw new Error("Invalid arguments");super(Ye,ot),this._anchor=Ye,this._active=ot}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=ce=v=Ve([U],ce);const De=x=>{if(typeof x!="string"||x.length===0||!/^[0-9A-Za-z_\-]+$/.test(x))throw(0,k.illegalArgument)("connectionToken")};class ke{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,oe,Ie){if(typeof L!="string"||L.length===0)throw(0,k.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,k.illegalArgument)("port");typeof Ie<"u"&&De(Ie),this.host=L,this.port=Math.round(oe),this.connectionToken=Ie}}e.ResolvedAuthority=ke;class ge{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,oe){this.makeConnection=L,this.connectionToken=oe,typeof oe<"u"&&De(oe)}}e.ManagedResolvedAuthority=ge;class A extends Error{static NotAvailable(L,oe){return new A(L,E.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(L){return new A(L,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,oe=E.RemoteAuthorityResolverErrorCode.Unknown,Ie){super(L),this._message=L,this._code=oe,this._detail=Ie,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A;var G;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(G||(e.EndOfLine=G={}));var de;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(de||(e.EnvironmentVariableMutatorType=de={}));let ye=e.TextEdit=I=class{static isTextEdit(L){return L instanceof I?!0:L?X.isRange(L)&&typeof L.newText=="string":!1}static replace(L,oe){return new I(L,oe)}static insert(L,oe){return I.replace(new X(L,L),oe)}static delete(L){return I.replace(L,"")}static setEndOfLine(L){const oe=new I(new X(new J(0,0),new J(0,0)),"");return oe.newEol=L,oe}get range(){return this._range}set range(L){if(L&&!X.isRange(L))throw(0,k.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,k.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,k.illegalArgument)("newEol");this._newEol=L}constructor(L,oe){this._range=L,this._newText=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=ye=I=Ve([U],ye);let _e=e.NotebookEdit=h=class{static isNotebookCellEdit(L){return L instanceof h?!0:L?Jt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,oe){return new h(L,oe)}static insertCells(L,oe){return new h(new Jt(L,L),oe)}static deleteCells(L){return new h(L,[])}static updateCellMetadata(L,oe){const Ie=new h(new Jt(L,L),[]);return Ie.newCellMetadata=oe,Ie}static updateNotebookMetadata(L){const oe=new h(new Jt(0,0),[]);return oe.newNotebookMetadata=L,oe}constructor(L,oe){this.range=L,this.newCells=oe}};e.NotebookEdit=_e=h=Ve([U],_e);class pe{static isSnippetTextEdit(L){return L instanceof pe?!0:L?X.isRange(L.range)&&ue.isSnippetString(L.snippet):!1}static replace(L,oe){return new pe(L,oe)}static insert(L,oe){return pe.replace(new X(L,L),oe)}constructor(L,oe){this.range=L,this.snippet=oe}}e.SnippetTextEdit=pe;var Ce;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(Ce||(e.FileEditType=Ce={}));let ae=e.WorkspaceEdit=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,oe,Ie,je){this._edits.push({_type:1,from:L,to:oe,options:Ie,metadata:je})}createFile(L,oe,Ie){this._edits.push({_type:1,from:void 0,to:L,options:oe,metadata:Ie})}deleteFile(L,oe,Ie){this._edits.push({_type:1,from:L,to:void 0,options:oe,metadata:Ie})}replaceNotebookMetadata(L,oe,Ie){this._edits.push({_type:3,metadata:Ie,uri:L,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells(L,oe,Ie,je){const Ye=oe.start,ot=oe.end;(Ye!==ot||Ie.length>0)&&this._edits.push({_type:5,uri:L,index:Ye,count:ot-Ye,cells:Ie,metadata:je})}replaceNotebookCellMetadata(L,oe,Ie,je){this._edits.push({_type:3,metadata:je,uri:L,edit:{editType:3,index:oe,metadata:Ie}})}replace(L,oe,Ie,je){this._edits.push({_type:2,uri:L,edit:new ye(oe,Ie),metadata:je})}insert(L,oe,Ie,je){this.replace(L,new X(oe,oe),Ie,je)}delete(L,oe,Ie){this.replace(L,oe,"",Ie)}has(L){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===L.toString())}set(L,oe){if(oe)for(const Ie of oe){if(!Ie)continue;let je,Ye;Array.isArray(Ie)?(je=Ie[0],Ye=Ie[1]):je=Ie,_e.isNotebookCellEdit(je)?je.newCellMetadata?this.replaceNotebookCellMetadata(L,je.range.start,je.newCellMetadata,Ye):je.newNotebookMetadata?this.replaceNotebookMetadata(L,je.newNotebookMetadata,Ye):this.replaceNotebookCells(L,je.range,je.newCells,Ye):pe.isSnippetTextEdit(je)?this._edits.push({_type:6,uri:L,range:je.range,edit:je.snippet,metadata:Ye}):this._edits.push({_type:2,uri:L,edit:je,metadata:Ye})}else{for(let Ie=0;Ie<this._edits.length;Ie++){const je=this._edits[Ie];switch(je._type){case 2:case 6:case 3:case 5:je.uri.toString()===L.toString()&&(this._edits[Ie]=void 0);break}}(0,m.coalesceInPlace)(this._edits)}}get(L){const oe=[];for(const Ie of this._edits)Ie._type===2&&Ie.uri.toString()===L.toString()&&oe.push(Ie.edit);return oe}entries(){const L=new M.ResourceMap;for(const oe of this._edits)if(oe._type===2){let Ie=L.get(oe.uri);Ie||(Ie=[oe.uri,[]],L.set(oe.uri,Ie)),Ie[1].push(oe.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=ae=Ve([U],ae);let ue=e.SnippetString=T=class{static isSnippetString(L){return L instanceof T?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this._tabstop=1,this.value=L||""}appendText(L){return this.value+=T._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,oe=this._tabstop++){if(typeof L=="function"){const Ie=new T;Ie._tabstop=this._tabstop,L(Ie),this._tabstop=Ie._tabstop,L=Ie.value}else L=T._escape(L);return this.value+="${",this.value+=oe,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,oe=this._tabstop++){const Ie=L.map(je=>je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=Ie,this.value+="|}",this}appendVariable(L,oe){if(typeof oe=="function"){const Ie=new T;Ie._tabstop=this._tabstop,oe(Ie),this._tabstop=Ie._tabstop,oe=Ie.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.SnippetString=ue=T=Ve([U],ue);var ne;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(ne||(e.DiagnosticTag=ne={}));var ee;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(ee||(e.DiagnosticSeverity=ee={}));let P=e.Location=S=class{static isLocation(L){return L instanceof S?!0:L?X.isRange(L.range)&&g.URI.isUri(L.uri):!1}constructor(L,oe){if(this.uri=L,oe)if(X.isRange(oe))this.range=X.of(oe);else if(J.isPosition(oe))this.range=new X(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=P=S=Ve([U],P);let W=e.DiagnosticRelatedInformation=class{static is(L){return L?typeof L.message=="string"&&L.location&&X.isRange(L.location.range)&&g.URI.isUri(L.location.uri):!1}constructor(L,oe){this.location=L,this.message=oe}static isEqual(L,oe){return L===oe?!0:!L||!oe?!1:L.message===oe.message&&L.location.range.isEqual(oe.location.range)&&L.location.uri.toString()===oe.location.uri.toString()}};e.DiagnosticRelatedInformation=W=Ve([U],W);let H=e.Diagnostic=class{constructor(L,oe,Ie=ee.Error){if(!X.isRange(L))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=L,this.message=oe,this.severity=Ie}toJSON(){return{severity:ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,oe){return L===oe?!0:!L||!oe?!1:L.message===oe.message&&L.severity===oe.severity&&L.code===oe.code&&L.severity===oe.severity&&L.source===oe.source&&L.range.isEqual(oe.range)&&(0,m.equals)(L.tags,oe.tags)&&(0,m.equals)(L.relatedInformation,oe.relatedInformation,W.isEqual)}};e.Diagnostic=H=Ve([U],H);let j=e.Hover=class{constructor(L,oe){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=oe}};e.Hover=j=Ve([U],j);var re;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let he=e.DocumentHighlight=class{constructor(L,oe=re.Text){this.range=L,this.kind=oe}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.DocumentHighlight=he=Ve([U],he);var ie;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(ie||(e.SymbolKind=ie={}));var we;(function(x){x[x.Deprecated=1]="Deprecated"})(we||(e.SymbolTag=we={}));let Se=e.SymbolInformation=a=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,oe,Ie,je,Ye){this.name=L,this.kind=oe,this.containerName=Ye,typeof Ie=="string"&&(this.containerName=Ie),je instanceof P?this.location=je:Ie instanceof X&&(this.location=new P(je,Ie)),a.validate(this)}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Se=a=Ve([U],Se);let $e=e.DocumentSymbol=o=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(o.validate)}constructor(L,oe,Ie,je,Ye){this.name=L,this.detail=oe,this.kind=Ie,this.range=je,this.selectionRange=Ye,this.children=[],o.validate(this)}};e.DocumentSymbol=$e=o=Ve([U],$e);var ze;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(ze||(e.CodeActionTriggerKind=ze={}));let Je=e.CodeAction=class{constructor(L,oe){this.title=L,this.kind=oe}};e.CodeAction=Je=Ve([U],Je);let qe=e.CodeActionKind=O=class{constructor(L){this.value=L}append(L){return new O(this.value?this.value+O.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+O.sep)}};qe.sep=".",e.CodeActionKind=qe=O=Ve([U],qe);class Ge extends qe{constructor(L){super(L),this.value=L}}e.NotebookCodeActionKind=Ge,qe.Empty=new qe(""),qe.QuickFix=qe.Empty.append("quickfix"),qe.Refactor=qe.Empty.append("refactor"),qe.RefactorExtract=qe.Refactor.append("extract"),qe.RefactorInline=qe.Refactor.append("inline"),qe.RefactorMove=qe.Refactor.append("move"),qe.RefactorRewrite=qe.Refactor.append("rewrite"),qe.Source=qe.Empty.append("source"),qe.SourceOrganizeImports=qe.Source.append("organizeImports"),qe.SourceFixAll=qe.Source.append("fixAll"),qe.Notebook=qe.Empty.append("notebook");let it=e.SelectionRange=class{constructor(L,oe){if(this.range=L,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=it=Ve([U],it);class ct{constructor(L,oe,Ie,je,Ye,ot){this.kind=L,this.name=oe,this.detail=Ie,this.uri=je,this.range=Ye,this.selectionRange=ot}}e.CallHierarchyItem=ct;class et{constructor(L,oe){this.fromRanges=oe,this.from=L}}e.CallHierarchyIncomingCall=et;class rt{constructor(L,oe){this.fromRanges=oe,this.to=L}}e.CallHierarchyOutgoingCall=rt;var Ue;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Ue||(e.LanguageStatusSeverity=Ue={}));let st=e.CodeLens=class{constructor(L,oe){this.range=L,this.command=oe}get isResolved(){return!!this.command}};e.CodeLens=st=Ve([U],st);let Z=e.MarkdownString=$=class{static isMarkdownString(L){return L instanceof $?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,oe=!1){t.set(this,void 0),Xe(this,t,new C.MarkdownString(L,{supportThemeIcons:oe}),"f")}get value(){return Fe(this,t,"f").value}set value(L){Fe(this,t,"f").value=L}get isTrusted(){return Fe(this,t,"f").isTrusted}set isTrusted(L){Fe(this,t,"f").isTrusted=L}get supportThemeIcons(){return Fe(this,t,"f").supportThemeIcons}set supportThemeIcons(L){Fe(this,t,"f").supportThemeIcons=L}get supportHtml(){return Fe(this,t,"f").supportHtml}set supportHtml(L){Fe(this,t,"f").supportHtml=L}get baseUri(){return Fe(this,t,"f").baseUri}set baseUri(L){Fe(this,t,"f").baseUri=L}appendText(L){return Fe(this,t,"f").appendText(L),this}appendMarkdown(L){return Fe(this,t,"f").appendMarkdown(L),this}appendCodeblock(L,oe){return Fe(this,t,"f").appendCodeblock(oe??"",L),this}};t=new WeakMap,e.MarkdownString=Z=$=Ve([U],Z);let Y=e.ParameterInformation=class{constructor(L,oe){this.label=L,this.documentation=oe}};e.ParameterInformation=Y=Ve([U],Y);let me=e.SignatureInformation=class{constructor(L,oe){this.label=L,this.documentation=oe,this.parameters=[]}};e.SignatureInformation=me=Ve([U],me);let Be=e.SignatureHelp=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=Be=Ve([U],Be);var Ne;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(Ne||(e.SignatureHelpTriggerKind=Ne={}));var Qe;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Qe||(e.InlayHintKind=Qe={}));let tt=e.InlayHintLabelPart=class{constructor(L){this.value=L}};e.InlayHintLabelPart=tt=Ve([U],tt);let pt=e.InlayHint=class{constructor(L,oe,Ie){this.position=L,this.label=oe,this.kind=Ie}};e.InlayHint=pt=Ve([U],pt);var bt;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(bt||(e.CompletionTriggerKind=bt={}));var Ot;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Ot||(e.CompletionItemKind=Ot={}));var Kt;(function(x){x[x.Deprecated=1]="Deprecated"})(Kt||(e.CompletionItemTag=Kt={}));let zt=e.CompletionItem=class{constructor(L,oe){this.label=L,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&Ot[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=zt=Ve([U],zt);let _t=e.CompletionList=class{constructor(L=[],oe=!1){this.items=L,this.isIncomplete=oe}};e.CompletionList=_t=Ve([U],_t);let xt=e.InlineSuggestion=class{constructor(L,oe,Ie){this.insertText=L,this.range=oe,this.command=Ie}};e.InlineSuggestion=xt=Ve([U],xt);let Lt=e.InlineSuggestionList=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.InlineSuggestionList=Lt=Ve([U],Lt);var Nt;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Nt||(e.ViewColumn=Nt={}));var Wt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Wt||(e.StatusBarAlignment=Wt={}));function Ht(x,L){return`${y.ExtensionIdentifier.toKey(x)}.${L}`}e.asStatusBarItemIdentifier=Ht;var at;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(at||(e.TextEditorLineNumbersStyle=at={}));var ft;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(ft||(e.TextDocumentSaveReason=ft={}));var Bt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Bt||(e.TextEditorRevealType=Bt={}));var At;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(At||(e.TextEditorSelectionChangeKind=At={}));var Ct;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(Ct||(e.TextDocumentChangeReason=Ct={}));var lt;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(lt||(e.DecorationRangeBehavior=lt={})),function(x){function L(oe){switch(oe){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=L}(At||(e.TextEditorSelectionChangeKind=At={}));let kt=e.DocumentLink=class{constructor(L,oe){if(oe&&!g.URI.isUri(oe))throw(0,k.illegalArgument)("target");if(!X.isRange(L)||L.isEmpty)throw(0,k.illegalArgument)("range");this.range=L,this.target=oe}};e.DocumentLink=kt=Ve([U],kt);let Ft=e.Color=class{constructor(L,oe,Ie,je){this.red=L,this.green=oe,this.blue=Ie,this.alpha=je}};e.Color=Ft=Ve([U],Ft);let Te=e.ColorInformation=class{constructor(L,oe){if(oe&&!(oe instanceof Ft))throw(0,k.illegalArgument)("color");if(!X.isRange(L)||L.isEmpty)throw(0,k.illegalArgument)("range");this.range=L,this.color=oe}};e.ColorInformation=Te=Ve([U],Te);let be=e.ColorPresentation=class{constructor(L){if(!L||typeof L!="string")throw(0,k.illegalArgument)("label");this.label=L}};e.ColorPresentation=be=Ve([U],be);var Ee;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Ee||(e.ColorFormat=Ee={}));var Q;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(Q||(e.SourceControlInputBoxValidationType=Q={}));var Oe;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(Oe||(e.TerminalExitReason=Oe={}));class xe{constructor(L,oe,Ie){if(this.startIndex=L,this.length=oe,this.tooltip=Ie,typeof L!="number"||L<0)throw(0,k.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,k.illegalArgument)("length");if(Ie!==void 0&&typeof Ie!="string")throw(0,k.illegalArgument)("tooltip")}}e.TerminalLink=xe;class Ke{constructor(L){this.uri=L}}e.TerminalQuickFixOpener=Ke;class We{constructor(L){this.terminalCommand=L}}e.TerminalQuickFixCommand=We;var Ze;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(Ze||(e.TerminalLocation=Ze={}));class St{constructor(L){if(this.options=L,typeof L!="object")throw(0,k.illegalArgument)("options")}}e.TerminalProfile=St;var It;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(It||(e.TaskRevealKind=It={}));var Pt;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Pt||(e.TaskPanelKind=Pt={}));let gt=e.TaskGroup=K=class{static from(L){switch(L){case"clean":return K.Clean;case"build":return K.Build;case"rebuild":return K.Rebuild;case"test":return K.Test;default:return}}constructor(L,oe){if(this.label=oe,typeof L!="string"||typeof oe!="string")throw(0,k.illegalArgument)("name");this._id=L}get id(){return this._id}};gt.Clean=new K("clean","Clean"),gt.Build=new K("build","Build"),gt.Rebuild=new K("rebuild","Rebuild"),gt.Test=new K("test","Test"),e.TaskGroup=gt=K=Ve([U],gt);function vt(x){let L="";for(let oe=0;oe<x.length;oe++)L+=x[oe].replace(/,/g,",,")+",";return L}let ht=e.ProcessExecution=class{constructor(L,oe,Ie){if(typeof L!="string")throw(0,k.illegalArgument)("process");this._args=[],this._process=L,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=Ie):this._options=oe)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,k.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(const oe of this._args)L.push(oe);return vt(L)}};e.ProcessExecution=ht=Ve([U],ht);let wt=e.ShellExecution=class{constructor(L,oe,Ie){if(this._args=[],Array.isArray(oe)){if(!L)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,k.illegalArgument)("command");this._command=L,this._args=oe,this._options=Ie}else{if(typeof L!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=L,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,k.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const oe of this._args)L.push(typeof oe=="string"?oe:oe.value);return vt(L)}};e.ShellExecution=wt=Ve([U],wt);var Et;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(Et||(e.ShellQuoting=Et={}));var Qt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(Qt||(e.TaskScope=Qt={}));class $t{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=$t;let ni=e.Task=V=class{constructor(L,oe,Ie,je,Ye,ot){this.__deprecated=!1,this._definition=this.definition=L;let dt;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=Ie,this.execution=je,dt=Ye,this.__deprecated=!0):oe===Qt.Global||oe===Qt.Workspace?(this.target=oe,this._name=this.name=Ie,this._source=this.source=je,this.execution=Ye,dt=ot):(this.target=oe,this._name=this.name=Ie,this._source=this.source=je,this.execution=Ye,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ht?this._definition={type:V.ProcessType,id:this._execution.computeId()}:this._execution instanceof wt?this._definition={type:V.ShellType,id:this._execution.computeId()}:this._execution instanceof $t?this._definition={type:V.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:V.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,k.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const oe=this._definition.type;(V.EmptyType===oe||V.ProcessType===oe||V.ShellType===oe||V.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};ni.ExtensionCallbackType="customExecution",ni.ProcessType="process",ni.ShellType="shell",ni.EmptyType="$empty",e.Task=ni=V=Ve([U],ni);var ai;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(ai||(e.ProgressLocation=ai={}));var _i;(function(x){function L(oe){const Ie=oe;return(0,D.isNumber)(Ie.value)?Ie.tooltip&&!(0,D.isString)(Ie.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ie.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ie.value),!1)}x.isViewBadge=L})(_i||(e.ViewBadge=_i={}));let Tt=e.TreeItem=z=class{static isTreeItem(L,oe){const Ie=L;if(Ie.checkboxState!==void 0){const je=(0,D.isNumber)(Ie.checkboxState)?Ie.checkboxState:(0,D.isObject)(Ie.checkboxState)&&(0,D.isNumber)(Ie.checkboxState.state)?Ie.checkboxState.state:void 0,Ye=!(0,D.isNumber)(Ie.checkboxState)&&(0,D.isObject)(Ie.checkboxState)?Ie.checkboxState.tooltip:void 0;if(je===void 0||je!==fi.Checked&&je!==fi.Unchecked||Ye!==void 0&&!(0,D.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Ie.checkboxState),!1}if(L instanceof z)return!0;if(Ie.label!==void 0&&!(0,D.isString)(Ie.label)&&!Ie.label?.label)return console.log("INVALID tree item, invalid label",Ie.label),!1;if(Ie.id!==void 0&&!(0,D.isString)(Ie.id))return console.log("INVALID tree item, invalid id",Ie.id),!1;if(Ie.iconPath!==void 0&&!(0,D.isString)(Ie.iconPath)&&!g.URI.isUri(Ie.iconPath)&&(!Ie.iconPath||!(0,D.isString)(Ie.iconPath.id))){const je=Ie.iconPath;if(!je||!(0,D.isString)(je.light)&&!g.URI.isUri(je.light)&&!(0,D.isString)(je.dark)&&!g.URI.isUri(je.dark))return console.log("INVALID tree item, invalid iconPath",Ie.iconPath),!1}return Ie.description!==void 0&&!(0,D.isString)(Ie.description)&&typeof Ie.description!="boolean"?(console.log("INVALID tree item, invalid description",Ie.description),!1):Ie.resourceUri!==void 0&&!g.URI.isUri(Ie.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ie.resourceUri),!1):Ie.tooltip!==void 0&&!(0,D.isString)(Ie.tooltip)&&!(Ie.tooltip instanceof Z)?(console.log("INVALID tree item, invalid tooltip",Ie.tooltip),!1):Ie.command!==void 0&&!Ie.command.command?(console.log("INVALID tree item, invalid command",Ie.command),!1):Ie.collapsibleState!==void 0&&Ie.collapsibleState<ci.None&&Ie.collapsibleState>ci.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ie.collapsibleState),!1):Ie.contextValue!==void 0&&!(0,D.isString)(Ie.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ie.contextValue),!1):Ie.accessibilityInformation!==void 0&&!Ie.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ie.accessibilityInformation),!1):!0}constructor(L,oe=ci.None){this.collapsibleState=oe,g.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.TreeItem=Tt=z=Ve([U],Tt);var ci;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(ci||(e.TreeItemCollapsibleState=ci={}));var fi;(function(x){x[x.Unchecked=0]="Unchecked",x[x.Checked=1]="Checked"})(fi||(e.TreeItemCheckboxState=fi={}));let Dt=e.DataTransferItem=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.DataTransferItem=Dt=Ve([U],Dt);class Si extends Dt{}e.InternalDataTransferItem=Si;class Fi extends Si{constructor(L){super(""),r.set(this,void 0),Xe(this,r,L,"f")}asFile(){return Fe(this,r,"f")}}e.InternalFileDataTransferItem=Fi,r=new WeakMap;class mi{constructor(L,oe,Ie,je){this.name=L,this.uri=oe,this._itemId=Ie,this._getData=je}data(){return this._getData()}}e.DataTransferFile=mi;let Oi=e.DataTransfer=class{constructor(L){c.add(this),b.set(this,new Map);for(const[oe,Ie]of L??[]){const je=Fe(this,b,"f").get(Fe(this,c,"m",w).call(this,oe));je?je.push(Ie):Fe(this,b,"f").set(Fe(this,c,"m",w).call(this,oe),[Ie])}}get(L){return Fe(this,b,"f").get(Fe(this,c,"m",w).call(this,L))?.[0]}set(L,oe){Fe(this,b,"f").set(Fe(this,c,"m",w).call(this,L),[oe])}forEach(L,oe){for(const[Ie,je]of Fe(this,b,"f"))for(const Ye of je)L.call(oe,Ye,Ie,this)}*[(b=new WeakMap,c=new WeakSet,Symbol.iterator)](){for(const[L,oe]of Fe(this,b,"f"))for(const Ie of oe)yield[L,Ie]}};w=function(L){return L.toLowerCase()},e.DataTransfer=Oi=Ve([U],Oi);let Li=e.DocumentDropEdit=class{constructor(L){this.insertText=L}};e.DocumentDropEdit=Li=Ve([U],Li);let Mt=e.DocumentPasteEdit=class{constructor(L,oe,Ie){this.id=oe,this.label=Ie,this.insertText=L}};e.DocumentPasteEdit=Mt=Ve([U],Mt);let Gt=e.ThemeIcon=class{constructor(L,oe){this.id=L,this.color=oe}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.ThemeIcon=Gt=Ve([U],Gt),Gt.File=new Gt("file"),Gt.Folder=new Gt("folder");let Mi=e.ThemeColor=class{constructor(L){this.id=L}};e.ThemeColor=Mi=Ve([U],Mi);var li;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(li||(e.ConfigurationTarget=li={}));let ui=e.RelativePattern=class{get base(){return this._base}set base(L){this._base=L,this._baseUri=g.URI.file(L)}get baseUri(){return this._baseUri}set baseUri(L){this._baseUri=L,this._base=L.fsPath}constructor(L,oe){if(typeof L!="string"&&(!L||!g.URI.isUri(L)&&!g.URI.isUri(L.uri)))throw(0,k.illegalArgument)("base");if(typeof oe!="string")throw(0,k.illegalArgument)("pattern");typeof L=="string"?this.baseUri=g.URI.file(L):g.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=ui=Ve([U],ui);const ut=new WeakMap;function an(x,L){ut.set(x,L)}e.setBreakpointId=an;let Vt=e.Breakpoint=class{constructor(L,oe,Ie,je){this.enabled=typeof L=="boolean"?L:!0,typeof oe=="string"&&(this.condition=oe),typeof Ie=="string"&&(this.hitCondition=Ie),typeof je=="string"&&(this.logMessage=je)}get id(){return this._id||(this._id=ut.get(this)??(0,R.generateUuid)()),this._id}};e.Breakpoint=Vt=Ve([U],Vt);let ri=e.SourceBreakpoint=class extends Vt{constructor(L,oe,Ie,je,Ye){if(super(oe,Ie,je,Ye),L===null)throw(0,k.illegalArgument)("location");this.location=L}};e.SourceBreakpoint=ri=Ve([U],ri);let yi=e.FunctionBreakpoint=class extends Vt{constructor(L,oe,Ie,je,Ye){super(oe,Ie,je,Ye),this.functionName=L}};e.FunctionBreakpoint=yi=Ve([U],yi);let Ni=e.DataBreakpoint=class extends Vt{constructor(L,oe,Ie,je,Ye,ot,dt){if(super(je,Ye,ot,dt),!oe)throw(0,k.illegalArgument)("dataId");this.label=L,this.dataId=oe,this.canPersist=Ie}};e.DataBreakpoint=Ni=Ve([U],Ni);let Ui=e.DebugAdapterExecutable=class{constructor(L,oe,Ie){this.command=L,this.args=oe||[],this.options=Ie}};e.DebugAdapterExecutable=Ui=Ve([U],Ui);let xi=e.DebugAdapterServer=class{constructor(L,oe){this.port=L,this.host=oe}};e.DebugAdapterServer=xi=Ve([U],xi);let Di=e.DebugAdapterNamedPipeServer=class{constructor(L){this.path=L}};e.DebugAdapterNamedPipeServer=Di=Ve([U],Di);let Bi=e.DebugAdapterInlineImplementation=class{constructor(L){this.implementation=L}};e.DebugAdapterInlineImplementation=Bi=Ve([U],Bi);let Ci=e.StackFrameFocus=class{constructor(L,oe,Ie){this.session=L,this.threadId=oe,this.frameId=Ie}};e.StackFrameFocus=Ci=Ve([U],Ci);let si=e.ThreadFocus=class{constructor(L,oe){this.session=L,this.threadId=oe}};e.ThreadFocus=si=Ve([U],si);let $i=e.EvaluatableExpression=class{constructor(L,oe){this.range=L,this.expression=oe}};e.EvaluatableExpression=$i=Ve([U],$i);var gi;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(gi||(e.InlineCompletionTriggerKind=gi={}));let pi=e.InlineValueText=class{constructor(L,oe){this.range=L,this.text=oe}};e.InlineValueText=pi=Ve([U],pi);let zi=e.InlineValueVariableLookup=class{constructor(L,oe,Ie=!0){this.range=L,this.variableName=oe,this.caseSensitiveLookup=Ie}};e.InlineValueVariableLookup=zi=Ve([U],zi);let Wi=e.InlineValueEvaluatableExpression=class{constructor(L,oe){this.range=L,this.expression=oe}};e.InlineValueEvaluatableExpression=Wi=Ve([U],Wi);let oi=e.InlineValueContext=class{constructor(L,oe){this.frameId=L,this.stoppedLocation=oe}};e.InlineValueContext=oi=Ve([U],oi);var Hi;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Hi||(e.FileChangeType=Hi={}));let Vi=e.FileSystemError=N=class extends Error{static FileExists(L){return new N(L,d.FileSystemProviderErrorCode.FileExists,N.FileExists)}static FileNotFound(L){return new N(L,d.FileSystemProviderErrorCode.FileNotFound,N.FileNotFound)}static FileNotADirectory(L){return new N(L,d.FileSystemProviderErrorCode.FileNotADirectory,N.FileNotADirectory)}static FileIsADirectory(L){return new N(L,d.FileSystemProviderErrorCode.FileIsADirectory,N.FileIsADirectory)}static NoPermissions(L){return new N(L,d.FileSystemProviderErrorCode.NoPermissions,N.NoPermissions)}static Unavailable(L){return new N(L,d.FileSystemProviderErrorCode.Unavailable,N.Unavailable)}constructor(L,oe=d.FileSystemProviderErrorCode.Unknown,Ie){super(g.URI.isUri(L)?L.toString(!0):L),this.code=Ie?.name??"Unknown",(0,d.markAsFileSystemProviderError)(this,oe),Object.setPrototypeOf(this,N.prototype),typeof Error.captureStackTrace=="function"&&typeof Ie=="function"&&Error.captureStackTrace(this,Ie)}};e.FileSystemError=Vi=N=Ve([U],Vi);let ji=e.FoldingRange=class{constructor(L,oe,Ie){this.start=L,this.end=oe,this.kind=Ie}};e.FoldingRange=ji=Ve([U],ji);var ei;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(ei||(e.FoldingRangeKind=ei={}));var qi;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(qi||(e.CommentThreadCollapsibleState=qi={}));var Ki;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Ki||(e.CommentMode=Ki={}));var Ii;(function(x){x[x.Published=0]="Published",x[x.Draft=1]="Draft"})(Ii||(e.CommentState=Ii={}));var Gi;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Gi||(e.CommentThreadState=Gi={}));class cn{constructor(L,oe=[]){this.tokenTypes=L,this.tokenModifiers=oe}}e.SemanticTokensLegend=cn;function ln(x){return typeof x>"u"||(0,D.isStringArray)(x)}class di{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let oe=0,Ie=L.tokenTypes.length;oe<Ie;oe++)this._tokenTypeStrToInt.set(L.tokenTypes[oe],oe);for(let oe=0,Ie=L.tokenModifiers.length;oe<Ie;oe++)this._tokenModifierStrToInt.set(L.tokenModifiers[oe],oe)}}push(L,oe,Ie,je,Ye){if(typeof L=="number"&&typeof oe=="number"&&typeof Ie=="number"&&typeof je=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this._pushEncoded(L,oe,Ie,je,Ye);if(X.isRange(L)&&typeof oe=="string"&&ln(Ie))return this._push(L,oe,Ie);throw(0,k.illegalArgument)()}_push(L,oe,Ie){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const je=L.start.line,Ye=L.start.character,ot=L.end.character-L.start.character,dt=this._tokenTypeStrToInt.get(oe);let Ut=0;if(Ie)for(const qt of Ie){if(!this._tokenModifierStrToInt.has(qt))throw new Error("`tokenModifier` is not in the provided legend");const Xt=this._tokenModifierStrToInt.get(qt);Ut|=1<<Xt>>>0}this._pushEncoded(je,Ye,ot,dt,Ut)}_pushEncoded(L,oe,Ie,je,Ye){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ut=this._data.length/5|0;let qt=0,Xt=0;for(let Zt=0;Zt<Ut;Zt++){let ti=this._data[5*Zt],Ai=this._data[5*Zt+1];ti===0?(ti=qt,Ai+=Xt):ti+=qt,this._data[5*Zt]=ti,this._data[5*Zt+1]=Ai,qt=ti,Xt=Ai}}let ot=L,dt=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Ie,this._data[this._dataLen++]=je,this._data[this._dataLen++]=Ye,this._prevLine=L,this._prevChar=oe}static _sortAndDeltaEncode(L){const oe=[],Ie=L.length/5|0;for(let dt=0;dt<Ie;dt++)oe[dt]=dt;oe.sort((dt,Ut)=>{const qt=L[5*dt],Xt=L[5*Ut];if(qt===Xt){const Zt=L[5*dt+1],ti=L[5*Ut+1];return Zt-ti}return qt-Xt});const je=new Uint32Array(L.length);let Ye=0,ot=0;for(let dt=0;dt<Ie;dt++){const Ut=5*oe[dt],qt=L[Ut+0],Xt=L[Ut+1],Zt=L[Ut+2],ti=L[Ut+3],Ai=L[Ut+4],Tn=qt-Ye,qn=Tn===0?Xt-ot:Xt,Ri=5*dt;je[Ri+0]=Tn,je[Ri+1]=qn,je[Ri+2]=Zt,je[Ri+3]=ti,je[Ri+4]=Ai,Ye=qt,ot=Xt}return je}build(L){return this._dataIsSortedAndDeltaEncoded?new vi(new Uint32Array(this._data),L):new vi(di._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=di;class vi{constructor(L,oe){this.resultId=oe,this.data=L}}e.SemanticTokens=vi;class Me{constructor(L,oe,Ie){this.start=L,this.deleteCount=oe,this.data=Ie}}e.SemanticTokensEdit=Me;class Yt{constructor(L,oe){this.resultId=oe,this.edits=L}}e.SemanticTokensEdits=Yt;var ki;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(ki||(e.DebugConsoleMode=ki={}));let mt=e.QuickInputButtons=class{constructor(){}};mt.Back={iconPath:new Gt("arrow-left")},e.QuickInputButtons=mt=Ve([U],mt);var Xi;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(Xi||(e.QuickPickItemKind=Xi={}));var Qi;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Qi||(e.InputBoxValidationSeverity=Qi={}));var Pi;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Pi||(e.ExtensionKind=Pi={}));class un{static validate(L){if(typeof L.badge=="string"){let oe=(0,f.nextCharLength)(L.badge,0);if(oe<L.badge.length&&(oe+=(0,f.nextCharLength)(L.badge,oe)),L.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!Gt.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,oe,Ie){this.badge=L,this.tooltip=oe,this.color=Ie}}e.FileDecoration=un;let hi=e.ColorTheme=class{constructor(L){this.kind=L}};e.ColorTheme=hi=Ve([U],hi);var Yi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(Yi||(e.ColorThemeKind=Yi={}));class Jt{static isNotebookRange(L){return L instanceof Jt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(L,oe){if(L<0)throw(0,k.illegalArgument)("start must be positive");if(oe<0)throw(0,k.illegalArgument)("end must be positive");L<=oe?(this._start=L,this._end=oe):(this._start=oe,this._end=L)}with(L){let oe=this._start,Ie=this._end;return L.start!==void 0&&(oe=L.start),L.end!==void 0&&(Ie=L.end),oe===this._start&&Ie===this._end?this:new Jt(oe,Ie)}}e.NotebookRange=Jt;class Ei{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(oe=>Ei.isNotebookCellData(oe))}static isNotebookCellData(L){return!0}constructor(L,oe,Ie,je,Ye,ot,dt){this.kind=L,this.value=oe,this.languageId=Ie,this.mime=je,this.outputs=Ye??[],this.metadata=ot,this.executionSummary=dt,Ei.validate(this)}}e.NotebookCellData=Ei;class Ji{constructor(L){this.cells=L}}e.NotebookData=Ji;class jt{static isNotebookCellOutputItem(L){return L instanceof jt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const oe={name:L.name,message:L.message,stack:L.stack};return jt.json(oe,"application/vnd.code.notebook.error")}static stdout(L){return jt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return jt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,oe="application/octet-stream"){return new jt(L,oe)}static text(L,oe=F.Mimes.text){const Ie=Fe(jt,_,"f",i).encode(String(L));return new jt(Ie,oe)}static json(L,oe="text/x-json"){const Ie=JSON.stringify(L,void 0,"	");return jt.text(Ie,oe)}constructor(L,oe){this.data=L,this.mime=oe;const Ie=(0,F.normalizeMimeType)(oe,!0);if(!Ie)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ie}}e.NotebookCellOutputItem=jt,_=jt,i={value:new TextEncoder};class wi{static isNotebookCellOutput(L){return L instanceof wi?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,oe=!1){const Ie=new Set,je=new Set;for(let Ye=0;Ye<L.length;Ye++){const ot=L[Ye],dt=(0,F.normalizeMimeType)(ot.mime);if(!Ie.has(dt)||(0,p.isTextStreamMime)(dt)){Ie.add(dt);continue}je.add(Ye),oe&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return je.size===0?L:L.filter((Ye,ot)=>!je.has(ot))}constructor(L,oe,Ie){this.items=wi.ensureUniqueMimeTypes(L,!0),typeof oe=="string"?(this.id=oe,this.metadata=Ie):(this.id=(0,R.generateUuid)(),this.metadata=oe??Ie)}}e.NotebookCellOutput=wi;var Zi;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Zi||(e.NotebookCellKind=Zi={}));var en;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(en||(e.NotebookCellExecutionState=en={}));var tn;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(tn||(e.NotebookCellStatusBarAlignment=tn={}));var nn;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(nn||(e.NotebookEditorRevealType=nn={}));class dn{constructor(L,oe){this.text=L,this.alignment=oe}}e.NotebookCellStatusBarItem=dn;var rn;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(rn||(e.NotebookControllerAffinity=rn={}));var sn;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred",x[x.Hidden=-1]="Hidden"})(sn||(e.NotebookControllerAffinity2=sn={}));class se{constructor(L,oe=[]){this.uri=L,this.provides=(0,m.asArray)(oe)}}e.NotebookRendererScript=se;class fe{constructor(L){this.label=L}}e.NotebookKernelSourceAction=fe;let Le=e.TimelineItem=class{constructor(L,oe){this.label=L,this.timestamp=oe}};e.TimelineItem=Le=Ve([U],Le);var nt;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(nt||(e.ExtensionMode=nt={}));var yt;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(yt||(e.ExtensionRuntime=yt={}));var Rt;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(Rt||(e.StandardTokenType=Rt={}));class Ln{constructor(L,oe){this.ranges=L,this.wordPattern=oe}}e.LinkedEditingRanges=Ln;class Mn{constructor(L){this._autoForwardAction=L}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mn;var mn;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(mn||(e.TestResultState=mn={}));var gn;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(gn||(e.TestRunProfileKind=gn={}));let hn=e.TestRunRequest=class{constructor(L=void 0,oe=void 0,Ie=void 0,je=!1){this.include=L,this.exclude=oe,this.profile=Ie,this.continuous=je}};e.TestRunRequest=hn=Ve([U],hn);let pn=e.TestRunRequest2=class extends hn{};e.TestRunRequest2=pn=Ve([U],pn);let vn=e.TestMessage=q=class{static diff(L,oe,Ie){const je=new q(L);return je.expectedOutput=oe,je.actualOutput=Ie,je}constructor(L){this.message=L}};e.TestMessage=vn=q=Ve([U],vn);let En=e.TestTag=class{constructor(L){this.id=L}};e.TestTag=En=Ve([U],En);let Ti=e.CoveredCount=class{constructor(L,oe){this.covered=L,this.total=oe}};e.CoveredCount=Ti=Ve([U],Ti);let wn=e.FileCoverage=B=class{static fromDetails(L,oe){const Ie=new Ti(0,0),je=new Ti(0,0),Ye=new Ti(0,0);for(const dt of oe)if("branches"in dt){Ie.total+=1,Ie.covered+=dt.executionCount>0?1:0;for(const Ut of dt.branches)je.total+=1,je.covered+=Ut.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const ot=new B(L,Ie,je.total>0?je:void 0,Ye.total>0?Ye:void 0);return ot.detailedCoverage=oe,ot}constructor(L,oe,Ie,je){this.uri=L,this.statementCoverage=oe,this.branchCoverage=Ie,this.functionCoverage=je}};e.FileCoverage=wn=B=Ve([U],wn);let bn=e.StatementCoverage=class{constructor(L,oe,Ie=[]){this.executionCount=L,this.location=oe,this.branches=Ie}};e.StatementCoverage=bn=Ve([U],bn);let _n=e.BranchCoverage=class{constructor(L,oe){this.executionCount=L,this.location=oe}};e.BranchCoverage=_n=Ve([U],_n);let Sn=e.FunctionCoverage=class{constructor(L,oe){this.executionCount=L,this.location=oe}};e.FunctionCoverage=Sn=Ve([U],Sn);var yn;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(yn||(e.ExternalUriOpenerPriority=yn={}));var Dn;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(Dn||(e.WorkspaceTrustState=Dn={}));var Cn;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(Cn||(e.PortAutoForwardAction=Cn={}));class Nn{constructor(L,oe,Ie,je,Ye,ot){this.kind=L,this.name=oe,this.detail=Ie,this.uri=je,this.range=Ye,this.selectionRange=ot}}e.TypeHierarchyItem=Nn;class Un{constructor(L){this.uri=L}}e.TextTabInput=Un;class xn{constructor(L,oe){this.original=L,this.modified=oe}}e.TextDiffTabInput=xn;class Bn{constructor(L,oe,Ie,je){this.base=L,this.input1=oe,this.input2=Ie,this.result=je}}e.TextMergeTabInput=Bn;class $n{constructor(L,oe){this.uri=L,this.viewType=oe}}e.CustomEditorTabInput=$n;class zn{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=zn;class Wn{constructor(L,oe){this.uri=L,this.notebookType=oe}}e.NotebookEditorTabInput=Wn;class Hn{constructor(L,oe,Ie){this.original=L,this.modified=oe,this.notebookType=Ie}}e.NotebookDiffEditorTabInput=Hn;class Vn{constructor(){}}e.TerminalEditorTabInput=Vn;class jn{constructor(L,oe){this.uri=L,this.inputBoxUri=oe}}e.InteractiveWindowInput=jn;var In;(function(x){x[x.Up=1]="Up",x[x.Down=2]="Down"})(In||(e.InteractiveSessionVoteDirection=In={}));var kn;(function(x){x[x.Action=1]="Action",x[x.Toolbar=2]="Toolbar"})(kn||(e.InteractiveSessionCopyKind=kn={}));var Pn;(function(x){x[x.Unhelpful=0]="Unhelpful",x[x.Helpful=1]="Helpful",x[x.Undone=2]="Undone"})(Pn||(e.InteractiveEditorResponseFeedbackKind=Pn={}))}),define(Ae[100],Re([1,0,49,14,13,271,136,7,18]),function(te,e,m,k,C,M,F,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const g=new Map;function R(p,l){l?g.set(p,l):g.delete(p)}e.setWordDefinitionFor=R;function y(p){return g.get(p)}class d extends M.MirrorTextModel{constructor(l,t,r,c,b,w,_,i){super(t,r,c,b),this._proxy=l,this._languageId=w,this._isDirty=_,this.notebook=i,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return(0,D.equals)(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===k.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},save(){return l._save()},getText(t){return t?l._getTextInRange(t):l.getText()},get eol(){return l._eol===`
`?f.EndOfLine.LF:f.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(t){return l._lineAt(t)},offsetAt(t){return l._offsetAt(t)},positionAt(t){return l._positionAt(t)},validateRange(t){return l._validateRange(t)},validatePosition(t){return l._validatePosition(t)},getWordRangeAtPosition(t,r){return l._getWordRangeAtPosition(t,r)}}}return Object.freeze(this._document)}_acceptLanguageId(l){(0,m.ok)(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){(0,m.ok)(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const t=this._validateRange(l);if(t.isEmpty)return"";if(t.isSingleLine)return this._lines[t.start.line].substring(t.start.character,t.end.character);const r=this._eol,c=t.start.line,b=t.end.line,w=[];w.push(this._lines[c].substring(t.start.character));for(let _=c+1;_<b;_++)w.push(this._lines[_]);return w.push(this._lines[b].substring(0,t.end.character)),w.join(r)}_lineAt(l){let t;if(l instanceof f.Position?t=l.line:typeof l=="number"&&(t=l),typeof t!="number"||t<0||t>=this._lines.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new E(t,this._lines[t],t===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getPrefixSum(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const t=this._lineStarts.getIndexOf(l),r=this._lines[t.index].length;return new f.Position(t.index,Math.min(t.remainder,r))}_validateRange(l){if(!(l instanceof f.Range))throw new Error("Invalid argument");const t=this._validatePosition(l.start),r=this._validatePosition(l.end);return t===l.start&&r===l.end?l:new f.Range(t.line,t.character,r.line,r.character)}_validatePosition(l){if(!(l instanceof f.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:t,character:r}=l,c=!1;if(t<0)t=0,r=0,c=!0;else if(t>=this._lines.length)t=this._lines.length-1,r=this._lines[t].length,c=!0;else{const b=this._lines[t].length;r<0?(r=0,c=!0):r>b&&(r=b,c=!0)}return c?new f.Position(t,r):l}_getWordRangeAtPosition(l,t){const r=this._validatePosition(l);if(!t)t=y(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const c=(0,F.getWordAtText)(r.character+1,(0,F.ensureValidWordDefinition)(t),this._lines[r.line],0);if(c)return new f.Range(r.line,c.startColumn-1,r.line,c.endColumn-1)}}e.ExtHostDocumentData=d;class E{constructor(l,t,r){this._line=l,this._text=t,this._isLastLine=r}get lineNumber(){return this._line}get text(){return this._text}get range(){return new f.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new f.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(Ae[195],Re([1,0,7,17,5]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=e.ExtHostTheming=class{constructor(f){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(f){let D;switch(f){case"light":D=m.ColorThemeKind.Light;break;case"hcDark":D=m.ColorThemeKind.HighContrast;break;case"hcLight":D=m.ColorThemeKind.HighContrastLight;break;default:D=m.ColorThemeKind.Dark}this._actual=new m.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=M=Ve([He(0,k.IExtHostRpcService)],M)}),define(Ae[196],Re([1,0,3]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var k;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(k||(e.CellExecutionUpdateType=k={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(Ae[45],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(M){M.Delimiter="\0"})(m||(e.TestIdPathParts=m={}));var k;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(k||(e.TestPosition=k={}));class C{static fromExtHostTestItem(F,f,D=F.parent){if(F._isRoot)return new C([f]);const g=[F.id];for(let R=D;R&&R.id!==f;R=R.parent)g.push(R.id);return g.push(f),new C(g.reverse())}static isRoot(F){return!F.includes("\0")}static root(F){const f=F.indexOf("\0");return f===-1?F:F.slice(0,f)}static fromString(F){return new C(F.split("\0"))}static join(F,f){return new C([...F.path,f])}static joinToString(F,f){return F.toString()+"\0"+f}static parentId(F){const f=F.lastIndexOf("\0");return f===-1?void 0:F.slice(0,f)}static localId(F){const f=F.lastIndexOf("\0");return f===-1?F:F.slice(f+1)}static isChild(F,f){return f.startsWith(F)&&f[F.length]==="\0"}static compare(F,f){return F===f?0:C.isChild(F,f)?2:C.isChild(f,F)?3:1}constructor(F,f=F.length){if(this.path=F,this.viewEnd=f,F.length===0||f<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new C(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let F=1;F<=this.viewEnd;F++)yield new C(this.path,F)}*idsToRoot(){for(let F=this.viewEnd;F>0;F--)yield new C(this.path,F)}compare(F){if(typeof F=="string")return C.compare(this.toString(),F);for(let f=0;f<F.viewEnd&&f<this.viewEnd;f++)if(F.path[f]!==this.path[f])return 1;return F.viewEnd>this.viewEnd?2:F.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let F=1;F<this.viewEnd;F++)this.stringifed+="\0",this.stringifed+=this.path[F]}return this.stringifed}}e.TestId=C}),define(Ae[56],Re([1,0,2,44,45]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(T){T[T.Unset=0]="Unset",T[T.Queued=1]="Queued",T[T.Running=2]="Running",T[T.Passed=3]="Passed",T[T.Failed=4]="Failed",T[T.Skipped=5]="Skipped",T[T.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var F;(function(T){T[T.Run=1]="Run",T[T.Debug=2]="Debug",T[T.Coverage=3]="Coverage"})(F||(e.ExtTestRunProfileKind=F={}));var f;(function(T){T[T.Run=2]="Run",T[T.Debug=4]="Debug",T[T.Coverage=8]="Coverage",T[T.HasNonDefaultProfile=16]="HasNonDefaultProfile",T[T.HasConfigurable=32]="HasConfigurable",T[T.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const D=T=>"runId"in T;e.isStartControllerTests=D;var g;(function(T){T.serialize=S=>({range:S.range.toJSON(),uri:S.uri.toJSON()}),T.deserialize=S=>({range:k.Range.lift(S.range),uri:m.URI.revive(S.uri)})})(g||(e.IRichLocation=g={}));var R;(function(T){T[T.Error=0]="Error",T[T.Output=1]="Output"})(R||(e.TestMessageType=R={}));var y;(function(T){T.serialize=S=>({message:S.message,type:0,expected:S.expected,actual:S.actual,location:S.location&&g.serialize(S.location)}),T.deserialize=S=>({message:S.message,type:0,expected:S.expected,actual:S.actual,location:S.location&&g.deserialize(S.location)})})(y||(e.ITestErrorMessage=y={}));const d=(T,S)=>`${S?"s":"e"}${T}`;e.getMarkId=d;var E;(function(T){T.serialize=S=>({message:S.message,type:1,offset:S.offset,length:S.length,location:S.location&&g.serialize(S.location)}),T.deserialize=S=>({message:S.message,type:1,offset:S.offset,length:S.length,location:S.location&&g.deserialize(S.location)})})(E||(e.ITestOutputMessage=E={}));var p;(function(T){T.serialize=S=>S.type===0?y.serialize(S):E.serialize(S),T.deserialize=S=>S.type===0?y.deserialize(S):E.deserialize(S)})(p||(e.ITestMessage=p={}));var l;(function(T){T.serializeWithoutMessages=S=>({state:S.state,duration:S.duration,messages:[]}),T.serialize=S=>({state:S.state,duration:S.duration,messages:S.messages.map(p.serialize)}),T.deserialize=S=>({state:S.state,duration:S.duration,messages:S.messages.map(p.deserialize)})})(l||(e.ITestTaskState=l={}));const t="\0",r=(T,S)=>T+t+S;e.namespaceTestTag=r;const c=T=>{const S=T.indexOf(t);return{ctrlId:T.slice(0,S),tagId:T.slice(S+1)}};e.denamespaceTestTag=c;var b;(function(T){T.serialize=S=>({extId:S.extId,label:S.label,tags:S.tags,busy:S.busy,children:void 0,uri:S.uri?.toJSON(),range:S.range?.toJSON()||null,description:S.description,error:S.error,sortText:S.sortText}),T.deserialize=S=>({extId:S.extId,label:S.label,tags:S.tags,busy:S.busy,children:void 0,uri:S.uri?m.URI.revive(S.uri):void 0,range:S.range?k.Range.lift(S.range):null,description:S.description,error:S.error,sortText:S.sortText})})(b||(e.ITestItem=b={}));var w;(function(T){T[T.NotExpandable=0]="NotExpandable",T[T.Expandable=1]="Expandable",T[T.BusyExpanding=2]="BusyExpanding",T[T.Expanded=3]="Expanded"})(w||(e.TestItemExpandState=w={}));var _;(function(T){T.serialize=S=>({expand:S.expand,item:b.serialize(S.item)}),T.deserialize=S=>({controllerId:C.TestId.root(S.item.extId),expand:S.expand,item:b.deserialize(S.item)})})(_||(e.InternalTestItem=_={}));var i;(function(T){T.serialize=S=>{let a;return S.item&&(a={},S.item.label!==void 0&&(a.label=S.item.label),S.item.tags!==void 0&&(a.tags=S.item.tags),S.item.busy!==void 0&&(a.busy=S.item.busy),S.item.uri!==void 0&&(a.uri=S.item.uri?.toJSON()),S.item.range!==void 0&&(a.range=S.item.range?.toJSON()),S.item.description!==void 0&&(a.description=S.item.description),S.item.error!==void 0&&(a.error=S.item.error),S.item.sortText!==void 0&&(a.sortText=S.item.sortText)),{extId:S.extId,expand:S.expand,item:a}},T.deserialize=S=>{let a;return S.item&&(a={},S.item.label!==void 0&&(a.label=S.item.label),S.item.tags!==void 0&&(a.tags=S.item.tags),S.item.busy!==void 0&&(a.busy=S.item.busy),S.item.range!==void 0&&(a.range=S.item.range?k.Range.lift(S.item.range):null),S.item.description!==void 0&&(a.description=S.item.description),S.item.error!==void 0&&(a.error=S.item.error),S.item.sortText!==void 0&&(a.sortText=S.item.sortText)),{extId:S.extId,expand:S.expand,item:a}}})(i||(e.ITestItemUpdate=i={}));const u=(T,S)=>{S.expand!==void 0&&(T.expand=S.expand),S.item!==void 0&&(T.item=T.item?Object.assign(T.item,S.item):S.item)};e.applyTestItemUpdate=u;var n;(function(T){T.serializeWithoutMessages=S=>({..._.serialize(S),ownComputedState:S.ownComputedState,computedState:S.computedState,tasks:S.tasks.map(l.serializeWithoutMessages)}),T.serialize=S=>({..._.serialize(S),ownComputedState:S.ownComputedState,computedState:S.computedState,tasks:S.tasks.map(l.serialize)}),T.deserialize=S=>({..._.deserialize(S),ownComputedState:S.ownComputedState,computedState:S.computedState,tasks:S.tasks.map(l.deserialize),retired:!0})})(n||(e.TestResultItem=n={}));var s;(function(T){T[T.Function=0]="Function",T[T.Statement=1]="Statement"})(s||(e.DetailType=s={}));var v;(function(T){T[T.Add=0]="Add",T[T.Update=1]="Update",T[T.DocumentSynced=2]="DocumentSynced",T[T.Remove=3]="Remove",T[T.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",T[T.Retire=5]="Retire",T[T.AddTag=6]="AddTag",T[T.RemoveTag=7]="RemoveTag"})(v||(e.TestDiffOpType=v={}));var I;(function(T){T.deserialize=S=>S.op===0?{op:S.op,item:_.deserialize(S.item)}:S.op===1?{op:S.op,item:i.deserialize(S.item)}:S.op===2?{op:S.op,uri:m.URI.revive(S.uri),docv:S.docv}:S,T.serialize=S=>S.op===0?{op:S.op,item:_.serialize(S.item)}:S.op===1?{op:S.op,item:i.serialize(S.item)}:S})(I||(e.TestsDiffOp=I={}));class h{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(S){const a=this.createChangeCollector();for(const o of S)switch(o.op){case 0:this.add(_.deserialize(o.item),a);break;case 1:this.update(i.deserialize(o.item),a);break;case 3:this.remove(o.itemId,a);break;case 5:this.retireTest(o.itemId);break;case 4:this.updatePendingRoots(o.amount);break;case 6:this._tags.set(o.tag.id,o.tag);break;case 7:this._tags.delete(o.id);break}a.complete?.()}add(S,a){const o=C.TestId.parentId(S.item.extId)?.toString();let O;if(!o)O=this.createItem(S),this.roots.add(O),this.items.set(S.item.extId,O);else if(this.items.has(o)){const $=this.items.get(o);$.children.add(S.item.extId),O=this.createItem(S,$),this.items.set(S.item.extId,O)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(S)}`);return}return a.add?.(O),S.expand===2&&this.busyControllerCount++,O}update(S,a){const o=this.items.get(S.extId);if(o)return S.expand!==void 0&&(o.expand===2&&this.busyControllerCount--,S.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(o,S),a.update?.(o),o}remove(S,a){const o=this.items.get(S);if(!o)return;const O=C.TestId.parentId(o.item.extId)?.toString();O?this.items.get(O).children.delete(o.item.extId):this.roots.delete(o);const $=[[S]];for(;$.length;)for(const K of $.pop()){const V=this.items.get(K);V&&($.push(V.children),this.items.delete(K),a.remove?.(V,V!==o),V.expand===2&&this.busyControllerCount--)}}retireTest(S){}updatePendingRoots(S){this.pendingRootCount+=S}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=h}),define(Ae[77],Re([1,0,16,5,6,49,56,45]),function(te,e,m,k,C,M,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var D;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(D||(e.TestItemEventOp=D={}));const g=(c,b)=>c===b,y=Object.entries({range:(c,b)=>c===b?!0:!c||!b?!1:c.equalsRange(b),busy:g,label:g,description:g,error:g,sortText:g,tags:(c,b)=>!(c.length!==b.length||c.some(w=>!b.includes(w)))}),d=(c,b)=>{let w;for(const[_,i]of y)i(c[_],b[_])||(w?w[_]=b[_]:w={[_]:b[_]});return w};class E extends C.Disposable{get root(){return this.options.root}constructor(b){super(),this.options=b,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new k.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(b){this._resolveHandler=b;for(const w of this.tree.values())this.updateExpandability(w)}get resolveHandler(){return this._resolveHandler}collectDiff(){const b=this.diff;return this.diff=[],b}pushDiff(b){switch(b.op){case 2:{for(const w of this.diff)if(w.op===2&&w.uri===b.uri){w.docv=b.docv;return}break}case 1:{const w=this.diff[this.diff.length-1];if(w){if(w.op===1&&w.item.extId===b.item.extId){(0,F.applyTestItemUpdate)(w.item,b.item);return}if(w.op===0&&w.item.item.extId===b.item.extId){(0,F.applyTestItemUpdate)(w.item,b.item);return}}break}}this.diff.push(b),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(b,w){const _=this.tree.get(b);if(_){if((_.expandLevels===void 0||w>_.expandLevels)&&(_.expandLevels=w),_.expand===1){const i=this.resolveChildren(_);return i.isOpen()?this.expandChildren(_,w-1):i.wait().then(()=>this.expandChildren(_,w-1))}else if(_.expand===3)return _.resolveBarrier?.isOpen()===!1?_.resolveBarrier.wait().then(()=>this.expandChildren(_,w-1)):this.expandChildren(_,w-1)}}dispose(){for(const b of this.tree.values())this.options.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(b,w){switch(w.op){case 3:this.removeItem(f.TestId.joinToString(b.fullId,w.id));break;case 0:this.upsertItem(w.item,b);break;case 5:for(const _ of w.ops)this.onTestItemEvent(b,_);break;case 1:this.diffTagRefs(w.new,w.old,b.fullId.toString());break;case 2:this.updateExpandability(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:w.update}});break;case 6:this.documentSynced(b.actual.uri);break;default:(0,M.assertNever)(w)}}documentSynced(b){b&&this.pushDiff({op:2,uri:b,docv:this.options.getDocumentVersion(b)})}upsertItem(b,w){const _=f.TestId.fromExtHostTestItem(b,this.root.id,w?.actual),i=this.options.getApiFor(b);i.parent&&i.parent!==w?.actual&&this.options.getChildren(i.parent).delete(b.id);let u=this.tree.get(_.toString());if(!u){u={fullId:_,actual:b,expandLevels:w?.expandLevels?w.expandLevels-1:void 0,expand:0},b.tags.forEach(this.incrementTagRefs,this),this.tree.set(u.fullId.toString(),u),this.setItemParent(b,w),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:u.expand,item:this.options.toITestItem(b)}}),this.connectItemAndChildren(b,u,w);return}if(u.actual===b){this.connectItem(b,u,w);return}if(u.actual.uri?.toString()!==b.uri?.toString())return this.removeItem(_.toString()),this.upsertItem(b,w);const n=this.options.getChildren(u.actual),s=u.actual,v=d(this.options.toITestItem(s),this.options.toITestItem(b));this.options.getApiFor(s).listener=void 0,u.actual=b,u.expand=0,v&&(v.hasOwnProperty("tags")&&(this.diffTagRefs(b.tags,s.tags,_.toString()),delete v.tags),this.onTestItemEvent(u,{op:4,update:v})),this.connectItemAndChildren(b,u,w);for(const[I,h]of n)this.options.getChildren(b).get(h.id)||this.removeItem(f.TestId.joinToString(_,h.id));this.documentSynced(u.actual.uri)}diffTagRefs(b,w,_){const i=new Set(w.map(u=>u.id));for(const u of b)i.delete(u.id)||this.incrementTagRefs(u);this.pushDiff({op:1,item:{extId:_,item:{tags:b.map(u=>(0,F.namespaceTestTag)(this.options.controllerId,u.id))}}}),i.forEach(this.decrementTagRefs,this)}incrementTagRefs(b){const w=this.tags.get(b.id);w?w.refCount++:(this.tags.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,F.namespaceTestTag)(this.options.controllerId,b.id)}}))}decrementTagRefs(b){const w=this.tags.get(b);w&&!--w.refCount&&(this.tags.delete(b),this.pushDiff({op:7,id:(0,F.namespaceTestTag)(this.options.controllerId,b)}))}setItemParent(b,w){this.options.getApiFor(b).parent=w&&w.actual!==this.root?w.actual:void 0}connectItem(b,w,_){this.setItemParent(b,_);const i=this.options.getApiFor(b);i.parent=_?.actual,i.listener=u=>this.onTestItemEvent(w,u),this.updateExpandability(w)}connectItemAndChildren(b,w,_){this.connectItem(b,w,_);for(const[i,u]of this.options.getChildren(b))this.upsertItem(u,w)}updateExpandability(b){let w;this._resolveHandler?b.resolveBarrier?w=b.resolveBarrier.isOpen()?3:2:w=b.actual.canResolveChildren?1:0:w=0,w!==b.expand&&(b.expand=w,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:w}}),w===1&&b.expandLevels!==void 0&&this.resolveChildren(b))}expandChildren(b,w){if(w<0)return;const _=[];for(const[i,u]of this.options.getChildren(b.actual)){const n=this.expand(f.TestId.joinToString(b.fullId,u.id),w);(0,m.isThenable)(n)&&_.push(n)}if(_.length)return Promise.all(_).then(()=>{})}resolveChildren(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this._resolveHandler){const u=new m.Barrier;return u.open(),u}b.expand=2,this.pushExpandStateUpdate(b);const w=b.resolveBarrier=new m.Barrier,_=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,u)};let i;try{i=this._resolveHandler(b.actual===this.root?void 0:b.actual)}catch(u){_(u)}return(0,m.isThenable)(i)?i.catch(_).then(()=>{w.open(),this.updateExpandability(b)}):(w.open(),this.updateExpandability(b)),b.resolveBarrier}pushExpandStateUpdate(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}removeItem(b){const w=this.tree.get(b);if(!w)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const _=[w];for(;_.length;){const i=_.pop();if(i){this.options.getApiFor(i.actual).listener=void 0;for(const u of i.actual.tags)this.decrementTagRefs(u.id);this.tree.delete(i.fullId.toString());for(const[u,n]of this.options.getChildren(i.actual))_.push(this.tree.get(f.TestId.joinToString(i.fullId,n.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.diffOpEmitter.fire(b)}}e.TestItemCollection=E;class p extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=p;class l extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=l;class t extends Error{constructor(b,w,_){super(`TestItem with ID "${b}" is from controller "${w}" and cannot be added as a child of an item from controller "${_}".`)}}e.MixedTestItemController=t;const r=(c,b,w)=>{let _=new Map;return{get size(){return _.size},forEach(i,u){for(const n of _.values())i.call(u,n,this)},[Symbol.iterator](){return _.entries()},replace(i){const u=new Map,n=new Set(_.keys()),s={op:5,ops:[]};for(const v of i){if(!(v instanceof w))throw new l(v.id);const I=b(v).controllerId;if(I!==c.controllerId)throw new t(v.id,I,c.controllerId);if(u.has(v.id))throw new p(v.id);u.set(v.id,v),n.delete(v.id),s.ops.push({op:0,item:v})}for(const v of n.keys())s.ops.push({op:3,id:v});c.listener?.(s),_=u},add(i){if(!(i instanceof w))throw new l(i.id);_.set(i.id,i),c.listener?.({op:0,item:i})},delete(i){_.delete(i)&&c.listener?.({op:3,id:i})},get(i){return _.get(i)},toJSON(){return Array.from(_.values())}}};e.createTestItemChildren=r}),define(Ae[101],Re([1,0,77]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const k=new WeakMap,C=(F,f)=>{const D={controllerId:f};return k.set(F,D),D};e.createPrivateApiFor=C;const M=F=>{const f=k.get(F);if(!f)throw new m.InvalidTestItemError(F?.id||"<unknown>");return f};e.getPrivateApiFor=M}),define(Ae[78],Re([1,0,14,2]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function C(f,D){return f.scheme===m.Schemas.http||f.scheme===m.Schemas.https?f:(D&&D.authority&&D.isRemote&&f.scheme===m.Schemas.file&&(f=k.URI.from({scheme:m.Schemas.vscodeRemote,authority:D.authority,path:f.path})),k.URI.from({scheme:m.Schemas.https,authority:`${f.scheme}+${M(f.authority)}.${e.webviewRootResourceAuthority}`,path:f.path,fragment:f.fragment,query:f.query}))}e.asWebviewUri=C;function M(f){return f.replace(/./g,D=>{const g=D.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?D:"-"+g.toString(16).padStart(4,"0")})}function F(f){return f.replace(/-([0-9a-f]{4})/g,(D,g)=>String.fromCharCode(parseInt(g,16)))}e.decodeAuthority=F}),define(Ae[197],Re([1,0,5,6,78]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(f,D,g){this._proxy=f,this._editors=D,this._remoteInfo=g,this._handlePool=0,this._disposables=new k.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const R=D.getVisibleTextEditors();for(const y of this._insets.values())R.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(f=>f.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(f,D,g,R,y){let d;for(const b of this._editors.getVisibleTextEditors(!0))if(b.value===f){d=b;break}if(!d)throw new Error("not a visible editor");const E=this,p=this._handlePool++,l=new m.Emitter,t=new m.Emitter,r=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(b){return(0,C.asWebviewUri)(b,E._remoteInfo)}get cspSource(){return C.webviewGenericCspSource}set options(b){this._options=b,E._proxy.$setOptions(p,b)}get options(){return this._options}set html(b){this._html=b,E._proxy.$setHtml(p,b)}get html(){return this._html}get onDidReceiveMessage(){return l.event}postMessage(b){return E._proxy.$postMessage(p,b)}},c=new class{constructor(){this.editor=f,this.line=D,this.height=g,this.webview=r,this.onDidDispose=t.event}dispose(){E._insets.has(p)&&(E._insets.delete(p),E._proxy.$disposeEditorInset(p),t.fire(),t.dispose(),l.dispose())}};return this._proxy.$createEditorInset(p,d.id,d.value.document.uri,D+1,g,R||{},y.identifier,y.extensionLocation),this._insets.set(p,{editor:f,inset:c,onDidReceiveMessage:l}),c}$onDidDispose(f){const D=this._insets.get(f);D&&D.inset.dispose()}$onDidReceiveMessage(f,D){this._insets.get(f)?.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=M}),define(Ae[198],Re([1,0,3]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,m.createDecorator)("configurationResolverService");var k;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(k||(e.VariableKind=k={}));class C extends Error{constructor(F,f){super(f),this.variable=F}}e.VariableError=C}),define(Ae[199],Re([1,0,19,51,10,23,21,90,163,198,13]),function(te,e,m,k,C,M,F,f,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class y{constructor(E,p,l,t){this._contributedVariables=new Map,this._context=E,this._labelService=p,this._userHomePromise=l,t&&(this._envVariablesPromise=t.then(r=>this.prepareEnv(r)))}prepareEnv(E){if(F.isWindows){const p=Object.create(null);return Object.keys(E).forEach(l=>{p[l.toLowerCase()]=E[l]}),p}return E}resolveWithEnvironment(E,p,l){return this.recursiveResolve({env:this.prepareEnv(E),userHome:void 0},p?p.uri:void 0,l)}async resolveAsync(E,p){const l={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(l,E?E.uri:void 0,p)}async resolveAnyBase(E,p,l,t){const r=M.deepClone(p);F.isWindows&&r.windows?Object.keys(r.windows).forEach(b=>r[b]=r.windows[b]):F.isMacintosh&&r.osx?Object.keys(r.osx).forEach(b=>r[b]=r.osx[b]):F.isLinux&&r.linux&&Object.keys(r.linux).forEach(b=>r[b]=r.linux[b]),delete r.windows,delete r.osx,delete r.linux;const c={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(c,E?E.uri:void 0,r,l,t)}async resolveAnyAsync(E,p,l){return this.resolveAnyBase(E,p,l)}async resolveAnyMap(E,p,l){const t=new Map;return{newConfig:await this.resolveAnyBase(E,p,l,t),resolvedVariables:t}}resolveWithInteractionReplace(E,p,l,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,p,l,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,p){if(this._contributedVariables.has(E))throw new Error("Variable "+E+" is contributed twice.");this._contributedVariables.set(E,p)}async recursiveResolve(E,p,l,t,r){if(C.isString(l))return this.resolveString(E,p,l,t,r);if(Array.isArray(l))return Promise.all(l.map(c=>this.recursiveResolve(E,p,c,t,r)));if(C.isObject(l)){const c=Object.create(null),b=await Promise.all(Object.keys(l).map(async w=>[await this.resolveString(E,p,w,t,r),await this.recursiveResolve(E,p,l[w],t,r)]));for(const[w,_]of b)c[w]=_;return c}return l}resolveString(E,p,l,t,r){return(0,R.replaceAsync)(l,y.VARIABLE_REGEXP,async(c,b)=>{if(b.includes(y.VARIABLE_LHS))return c;let w=await this.evaluateSingleVariable(E,c,b,p,t);return r?.set(b,w),w!==c&&C.isString(w)&&w.match(y.VARIABLE_REGEXP)&&(w=await this.resolveString(E,p,w,t,r)),w})}fsPath(E){return this._labelService?this._labelService.getUriLabel(E,{noPrefix:!0}):E.fsPath}async evaluateSingleVariable(E,p,l,t,r){let c;const b=l.split(":");b.length>1&&(l=b[0],c=b[1]);const w=u=>{const n=this._context.getFilePath();if(n)return(0,f.normalizeDriveLetter)(n);throw new g.VariableError(u,(0,D.localize)(0,null,p))},_=u=>{const n=w(u);if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return(0,f.normalizeDriveLetter)(s)}throw new g.VariableError(u,(0,D.localize)(1,null,p,m.basename(n)))},i=u=>{if(c){const n=this._context.getFolderUri(c);if(n)return n;throw new g.VariableError(u,(0,D.localize)(2,null,p,c))}if(t)return t;throw this._context.getWorkspaceFolderCount()>1?new g.VariableError(u,(0,D.localize)(3,null,p)):new g.VariableError(u,(0,D.localize)(4,null,p))};switch(l){case"env":if(c){if(E.env){const u=E.env[F.isWindows?c.toLowerCase():c];if(C.isString(u))return u}return""}throw new g.VariableError(g.VariableKind.Env,(0,D.localize)(5,null,p));case"config":if(c){const u=this._context.getConfigurationValue(t,c);if(C.isUndefinedOrNull(u))throw new g.VariableError(g.VariableKind.Config,(0,D.localize)(6,null,p,c));if(C.isObject(u))throw new g.VariableError(g.VariableKind.Config,(0,D.localize)(7,null,p,c));return u}throw new g.VariableError(g.VariableKind.Config,(0,D.localize)(8,null,p));case"command":return this.resolveFromMap(g.VariableKind.Command,p,c,r,"command");case"input":return this.resolveFromMap(g.VariableKind.Input,p,c,r,"input");case"extensionInstallFolder":if(c){const u=await this._context.getExtension(c);if(!u)throw new g.VariableError(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,p,c));return this.fsPath(u.extensionLocation)}throw new g.VariableError(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,p));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,f.normalizeDriveLetter)(this.fsPath(i(g.VariableKind.WorkspaceFolder)));case"cwd":return t||c?(0,f.normalizeDriveLetter)(this.fsPath(i(g.VariableKind.Cwd))):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,f.normalizeDriveLetter)(m.basename(this.fsPath(i(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new g.VariableError(g.VariableKind.UserHome,(0,D.localize)(11,null,p))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new g.VariableError(g.VariableKind.LineNumber,(0,D.localize)(12,null,p))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new g.VariableError(g.VariableKind.SelectedText,(0,D.localize)(13,null,p))}case"file":return w(g.VariableKind.File);case"fileWorkspaceFolder":return _(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||c?m.relative(this.fsPath(i(g.VariableKind.RelativeFile)),w(g.VariableKind.RelativeFile)):w(g.VariableKind.RelativeFile);case"relativeFileDirname":{const u=m.dirname(w(g.VariableKind.RelativeFileDirname));if(t||c){const n=m.relative(this.fsPath(i(g.VariableKind.RelativeFileDirname)),u);return n.length===0?".":n}return u}case"fileDirname":return m.dirname(w(g.VariableKind.FileDirname));case"fileExtname":return m.extname(w(g.VariableKind.FileExtname));case"fileBasename":return m.basename(w(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=m.basename(w(g.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-m.extname(u).length)}case"fileDirnameBasename":return m.basename(m.dirname(w(g.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||p}case"execInstallFolder":{const u=this._context.getAppRoot();return u||p}case"pathSeparator":return m.sep;default:try{const u=c?`${l}:${c}`:l;return this.resolveFromMap(g.VariableKind.Unknown,p,u,r,void 0)}catch{return p}}}}resolveFromMap(E,p,l,t,r){if(l&&t){const c=r===void 0?t[l]:t[r+":"+l];if(typeof c=="string")return c;throw new g.VariableError(E,(0,D.localize)(14,null,p))}return p}}e.AbstractVariableResolverService=y,y.VARIABLE_LHS="${",y.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ae[102],Re([1,0,3,99]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var C;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var M;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var F;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(F||(e.GroupLocation=F={}));var f;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(f||(e.GroupsArrangement=f={}));var D;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(D||(e.MergeGroupMode=D={}));function g(p){const l=p;return(0,k.isEditorInput)(l?.editor)&&(0,k.isEditorInput)(l?.replacement)}e.isEditorReplacement=g;var R;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var y;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function d(p){const l=p;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}e.isEditorGroup=d;function E(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(Ae[200],Re([1,0,3,102]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function C(M){const F=M;return typeof M=="number"||(0,k.isEditorGroup)(F)}e.isPreferredGroup=C}),define(Ae[8],Re([1,0,18,25,122,201,70,28,116,69,68,23,10,2,44,79,94,101,99,76,45,56,200,7]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l,t,r,c,b,w,_,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Te){function be(Q){const{selectionStartLineNumber:Oe,selectionStartColumn:xe,positionLineNumber:Ke,positionColumn:We}=Q,Ze=new u.Position(Oe-1,xe-1),St=new u.Position(Ke-1,We-1);return new u.Selection(Ze,St)}Te.to=be;function Ee(Q){const{anchor:Oe,active:xe}=Q;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:xe.line+1,positionColumn:xe.character+1}}Te.from=Ee})(n||(e.Selection=n={}));var s;(function(Te){function be(Q){if(!Q)return;const{start:Oe,end:xe}=Q;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:xe.line+1,endColumn:xe.character+1}}Te.from=be;function Ee(Q){if(!Q)return;const{startLineNumber:Oe,startColumn:xe,endLineNumber:Ke,endColumn:We}=Q;return new u.Range(Oe-1,xe-1,Ke-1,We-1)}Te.to=Ee})(s||(e.Range=s={}));var v;(function(Te){function be(Ee){switch(Ee){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 3:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}Te.to=be})(v||(e.TokenType=v={}));var I;(function(Te){function be(Q){return new u.Position(Q.lineNumber-1,Q.column-1)}Te.to=be;function Ee(Q){return{lineNumber:Q.line+1,column:Q.character+1}}Te.from=Ee})(I||(e.Position=I={}));var h;(function(Te){function be(Oe,xe,Ke){return(0,m.coalesce)((0,m.asArray)(Oe).map(We=>Ee(We,xe,Ke)))}Te.from=be;function Ee(Oe,xe,Ke){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:Ke?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:Q(Oe.scheme,xe),pattern:st.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:Ke?.isBuiltin}}function Q(Oe,xe){return xe&&typeof Oe=="string"?xe.transformOutgoingScheme(Oe):Oe}})(h||(e.DocumentSelector=h={}));var T;(function(Te){function be(Q){switch(Q){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}Te.from=be;function Ee(Q){switch(Q){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}Te.to=Ee})(T||(e.DiagnosticTag=T={}));var S;(function(Te){function be(Q){let Oe;return Q.code&&((0,d.isString)(Q.code)||(0,d.isNumber)(Q.code)?Oe=String(Q.code):Oe={value:String(Q.code.value),target:Q.code.target}),{...s.from(Q.range),message:Q.message,source:Q.source,code:Oe,severity:o.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(a.from),tags:Array.isArray(Q.tags)?(0,m.coalesce)(Q.tags.map(T.from)):void 0}}Te.from=be;function Ee(Q){const Oe=new u.Diagnostic(s.to(Q),Q.message,o.to(Q.severity));return Oe.source=Q.source,Oe.code=(0,d.isString)(Q.code)?Q.code:Q.code?.value,Oe.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(a.to),Oe.tags=Q.tags&&(0,m.coalesce)(Q.tags.map(T.to)),Oe}Te.to=Ee})(S||(e.Diagnostic=S={}));var a;(function(Te){function be(Q){return{...s.from(Q.location.range),message:Q.message,resource:Q.location.uri}}Te.from=be;function Ee(Q){return new u.DiagnosticRelatedInformation(new u.Location(Q.resource,s.to(Q)),Q.message)}Te.to=Ee})(a||(e.DiagnosticRelatedInformation=a={}));var o;(function(Te){function be(Q){switch(Q){case u.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Te.from=be;function Ee(Q){switch(Q){case t.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}Te.to=Ee})(o||(e.DiagnosticSeverity=o={}));var O;(function(Te){function be(Q){return typeof Q=="number"&&Q>=u.ViewColumn.One?Q-1:Q===u.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Te.from=be;function Ee(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}Te.to=Ee})(O||(e.ViewColumn=O={}));function $(Te){return typeof Te.range<"u"}function K(Te){return Te.length===0?!0:!!$(Te[0])}e.isDecorationOptionsArr=K;var V;(function(Te){function be(We){return We.map(Te.from)}Te.fromMany=be;function Ee(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function Q(We){let Ze;if(Ee(We)){const{language:gt,value:vt}=We;Ze={value:"```"+gt+`
`+vt+"\n```\n"}}else u.MarkdownString.isMarkdownString(We)?Ze={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?Ze={value:We}:Ze={value:""};const St=Object.create(null);Ze.uris=St;const It=gt=>{try{let vt=E.URI.parse(gt,!0);vt=vt.with({query:Oe(vt.query,St)}),St[gt]=vt}catch{}return""},Pt=new D.marked.Renderer;return Pt.link=It,Pt.image=gt=>typeof gt=="string"?It(F.parseHrefAndDimensions(gt).href):"",(0,D.marked)(Ze.value,{renderer:Pt}),Ze}Te.from=Q;function Oe(We,Ze){if(!We)return We;let St;try{St=(0,g.parse)(We)}catch{}if(!St)return We;let It=!1;return St=(0,y.cloneAndChange)(St,Pt=>{if(E.URI.isUri(Pt)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[gt]=Pt,It=!0,gt}else return}),It?JSON.stringify(St):We}function xe(We){const Ze=new u.MarkdownString(We.value,We.supportThemeIcons);return Ze.isTrusted=We.isTrusted,Ze.supportHtml=We.supportHtml,Ze.baseUri=We.baseUri?E.URI.from(We.baseUri):void 0,Ze}Te.to=xe;function Ke(We){if(We)return typeof We=="string"?We:Te.from(We)}Te.fromStrict=Ke})(V||(e.MarkdownString=V={}));function z(Te){return K(Te)?Te.map(be=>({range:s.from(be.range),hoverMessage:Array.isArray(be.hoverMessage)?V.fromMany(be.hoverMessage):be.hoverMessage?V.from(be.hoverMessage):void 0,renderOptions:be.renderOptions})):Te.map(be=>({range:s.from(be)}))}e.fromRangeOrRangeWithMessage=z;function N(Te){return typeof Te>"u"?Te:typeof Te=="string"?E.URI.file(Te):Te}e.pathOrURIToURI=N;var q;(function(Te){function be(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?N(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Te.from=be})(q||(e.ThemableDecorationAttachmentRenderOptions=q={}));var B;(function(Te){function be(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?N(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?q.from(Ee.before):void 0,after:Ee.after?q.from(Ee.after):void 0}}Te.from=be})(B||(e.ThemableDecorationRenderOptions=B={}));var U;(function(Te){function be(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}Te.from=be})(U||(e.DecorationRangeBehavior=U={}));var le;(function(Te){function be(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?U.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?B.from(Ee.light):void 0,dark:Ee.dark?B.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?N(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?q.from(Ee.before):void 0,after:Ee.after?q.from(Ee.after):void 0}}Te.from=be})(le||(e.DecorationRenderOptions=le={}));var ve;(function(Te){function be(Q){return{text:Q.newText,eol:Q.newEol&&it.from(Q.newEol),range:s.from(Q.range)}}Te.from=be;function Ee(Q){const Oe=new u.TextEdit(s.to(Q.range),Q.text);return Oe.newEol=typeof Q.eol>"u"?void 0:it.to(Q.eol),Oe}Te.to=Ee})(ve||(e.TextEdit=ve={}));var Pe;(function(Te){function be(Q,Oe){const xe={edits:[]};if(Q instanceof u.WorkspaceEdit){const Ke=new f.ResourceSet;for(const We of Q._allEntries())We._type===1&&E.URI.isUri(We.to)&&We.from===void 0&&Ke.add(We.to);for(const We of Q._allEntries())if(We._type===1){let Ze;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?Ze={type:"base64",value:(0,k.encodeBase64)(k.VSBuffer.wrap(We.options.contents))}:Ze={type:"dataTransferItem",id:We.options.contents._itemId}),xe.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:Ze},metadata:We.metadata})}else We._type===2?xe.edits.push({resource:We.uri,textEdit:ve.from(We.edit),versionId:Ke.has(We.uri)?void 0:Oe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?xe.edits.push({resource:We.uri,textEdit:{range:s.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ke.has(We.uri)?void 0:Oe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?xe.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(We.uri)}):We._type===5&&xe.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(tt.from)}})}return xe}Te.from=be;function Ee(Q){const Oe=new u.WorkspaceEdit,xe=new f.ResourceMap;for(const Ke of Q.edits)if(Ke.textEdit){const We=Ke,Ze=E.URI.revive(We.resource),St=s.to(We.textEdit.range),It=We.textEdit.text,Pt=We.textEdit.insertAsSnippet;let gt;Pt?gt=u.SnippetTextEdit.replace(St,new u.SnippetString(It)):gt=u.TextEdit.replace(St,It);const vt=xe.get(Ze);vt?vt.push(gt):xe.set(Ze,[gt])}else Oe.renameFile(E.URI.revive(Ke.oldResource),E.URI.revive(Ke.newResource),Ke.options);for(const[Ke,We]of xe)Oe.set(Ke,We);return Oe}Te.to=Ee})(Pe||(e.WorkspaceEdit=Pe={}));var J;(function(Te){const be=Object.create(null);be[u.SymbolKind.File]=0,be[u.SymbolKind.Module]=1,be[u.SymbolKind.Namespace]=2,be[u.SymbolKind.Package]=3,be[u.SymbolKind.Class]=4,be[u.SymbolKind.Method]=5,be[u.SymbolKind.Property]=6,be[u.SymbolKind.Field]=7,be[u.SymbolKind.Constructor]=8,be[u.SymbolKind.Enum]=9,be[u.SymbolKind.Interface]=10,be[u.SymbolKind.Function]=11,be[u.SymbolKind.Variable]=12,be[u.SymbolKind.Constant]=13,be[u.SymbolKind.String]=14,be[u.SymbolKind.Number]=15,be[u.SymbolKind.Boolean]=16,be[u.SymbolKind.Array]=17,be[u.SymbolKind.Object]=18,be[u.SymbolKind.Key]=19,be[u.SymbolKind.Null]=20,be[u.SymbolKind.EnumMember]=21,be[u.SymbolKind.Struct]=22,be[u.SymbolKind.Event]=23,be[u.SymbolKind.Operator]=24,be[u.SymbolKind.TypeParameter]=25;function Ee(Oe){return typeof be[Oe]=="number"?be[Oe]:6}Te.from=Ee;function Q(Oe){for(const xe in be)if(be[xe]===Oe)return Number(xe);return u.SymbolKind.Property}Te.to=Q})(J||(e.SymbolKind=J={}));var X;(function(Te){function be(Q){switch(Q){case u.SymbolTag.Deprecated:return 1}}Te.from=be;function Ee(Q){switch(Q){case 1:return u.SymbolTag.Deprecated}}Te.to=Ee})(X||(e.SymbolTag=X={}));var ce;(function(Te){function be(Q){return{name:Q.name,kind:J.from(Q.kind),tags:Q.tags&&Q.tags.map(X.from),containerName:Q.containerName,location:G.from(Q.location)}}Te.from=be;function Ee(Q){const Oe=new u.SymbolInformation(Q.name,J.to(Q.kind),Q.containerName,G.to(Q.location));return Oe.tags=Q.tags&&Q.tags.map(X.to),Oe}Te.to=Ee})(ce||(e.WorkspaceSymbol=ce={}));var De;(function(Te){function be(Q){const Oe={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:s.from(Q.range),selectionRange:s.from(Q.selectionRange),kind:J.from(Q.kind),tags:Q.tags?.map(X.from)??[]};return Q.children&&(Oe.children=Q.children.map(be)),Oe}Te.from=be;function Ee(Q){const Oe=new u.DocumentSymbol(Q.name,Q.detail,J.to(Q.kind),s.to(Q.range),s.to(Q.selectionRange));return(0,m.isNonEmptyArray)(Q.tags)&&(Oe.tags=Q.tags.map(X.to)),Q.children&&(Oe.children=Q.children.map(Ee)),Oe}Te.to=Ee})(De||(e.DocumentSymbol=De={}));var ke;(function(Te){function be(Q){const Oe=new u.CallHierarchyItem(J.to(Q.kind),Q.name,Q.detail||"",E.URI.revive(Q.uri),s.to(Q.range),s.to(Q.selectionRange));return Oe._sessionId=Q._sessionId,Oe._itemId=Q._itemId,Oe}Te.to=be;function Ee(Q,Oe,xe){if(Oe=Oe??Q._sessionId,xe=xe??Q._itemId,Oe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:xe,name:Q.name,detail:Q.detail,kind:J.from(Q.kind),uri:Q.uri,range:s.from(Q.range),selectionRange:s.from(Q.selectionRange),tags:Q.tags?.map(X.from)}}Te.from=Ee})(ke||(e.CallHierarchyItem=ke={}));var ge;(function(Te){function be(Ee){return new u.CallHierarchyIncomingCall(ke.to(Ee.from),Ee.fromRanges.map(Q=>s.to(Q)))}Te.to=be})(ge||(e.CallHierarchyIncomingCall=ge={}));var A;(function(Te){function be(Ee){return new u.CallHierarchyOutgoingCall(ke.to(Ee.to),Ee.fromRanges.map(Q=>s.to(Q)))}Te.to=be})(A||(e.CallHierarchyOutgoingCall=A={}));var G;(function(Te){function be(Q){return{range:Q.range&&s.from(Q.range),uri:Q.uri}}Te.from=be;function Ee(Q){return new u.Location(E.URI.revive(Q.uri),s.to(Q.range))}Te.to=Ee})(G||(e.location=G={}));var de;(function(Te){function be(Q){const Oe=Q,xe=Q;return{originSelectionRange:Oe.originSelectionRange?s.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:xe.uri,range:s.from(Oe.targetRange?Oe.targetRange:xe.range),targetSelectionRange:Oe.targetSelectionRange?s.from(Oe.targetSelectionRange):void 0}}Te.from=be;function Ee(Q){return{targetUri:E.URI.revive(Q.uri),targetRange:s.to(Q.range),targetSelectionRange:Q.targetSelectionRange?s.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?s.to(Q.originSelectionRange):void 0}}Te.to=Ee})(de||(e.DefinitionLink=de={}));var ye;(function(Te){function be(Q){return{range:s.from(Q.range),contents:V.fromMany(Q.contents)}}Te.from=be;function Ee(Q){return new u.Hover(Q.contents.map(V.to),s.to(Q.range))}Te.to=Ee})(ye||(e.Hover=ye={}));var _e;(function(Te){function be(Q){return{range:s.from(Q.range),expression:Q.expression}}Te.from=be;function Ee(Q){return new u.EvaluatableExpression(s.to(Q.range),Q.expression)}Te.to=Ee})(_e||(e.EvaluatableExpression=_e={}));var pe;(function(Te){function be(Q){if(Q instanceof u.InlineValueText)return{type:"text",range:s.from(Q.range),text:Q.text};if(Q instanceof u.InlineValueVariableLookup)return{type:"variable",range:s.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof u.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}Te.from=be;function Ee(Q){switch(Q.type){case"text":return{range:s.to(Q.range),text:Q.text};case"variable":return{range:s.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:s.to(Q.range),expression:Q.expression}}}Te.to=Ee})(pe||(e.InlineValue=pe={}));var Ce;(function(Te){function be(Q){return{frameId:Q.frameId,stoppedLocation:s.from(Q.stoppedLocation)}}Te.from=be;function Ee(Q){return new u.InlineValueContext(Q.frameId,s.to(Q.stoppedLocation))}Te.to=Ee})(Ce||(e.InlineValueContext=Ce={}));var ae;(function(Te){function be(Q){return{range:s.from(Q.range),kind:Q.kind}}Te.from=be;function Ee(Q){return new u.DocumentHighlight(s.to(Q.range),Q.kind)}Te.to=Ee})(ae||(e.DocumentHighlight=ae={}));var ue;(function(Te){function be(Ee){switch(Ee){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}Te.to=be})(ue||(e.CompletionTriggerKind=ue={}));var ne;(function(Te){function be(Ee){return{triggerKind:ue.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Te.to=be})(ne||(e.CompletionContext=ne={}));var ee;(function(Te){function be(Q){switch(Q){case u.CompletionItemTag.Deprecated:return 1}}Te.from=be;function Ee(Q){switch(Q){case 1:return u.CompletionItemTag.Deprecated}}Te.to=Ee})(ee||(e.CompletionItemTag=ee={}));var P;(function(Te){const be=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function Ee(xe){return be.get(xe)??9}Te.from=Ee;const Q=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Oe(xe){return Q.get(xe)??u.CompletionItemKind.Property}Te.to=Oe})(P||(e.CompletionItemKind=P={}));var W;(function(Te){function be(Ee,Q){const Oe=new u.CompletionItem(Ee.label);return Oe.insertText=Ee.insertText,Oe.kind=P.to(Ee.kind),Oe.tags=Ee.tags?.map(ee.to),Oe.detail=Ee.detail,Oe.documentation=F.isMarkdownString(Ee.documentation)?V.to(Ee.documentation):Ee.documentation,Oe.sortText=Ee.sortText,Oe.filterText=Ee.filterText,Oe.preselect=Ee.preselect,Oe.commitCharacters=Ee.commitCharacters,p.Range.isIRange(Ee.range)?Oe.range=s.to(Ee.range):typeof Ee.range=="object"&&(Oe.range={inserting:s.to(Ee.range.insert),replacing:s.to(Ee.range.replace)}),Oe.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:!!(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?Oe.insertText=new u.SnippetString(Ee.insertText):(Oe.insertText=Ee.insertText,Oe.textEdit=Oe.range instanceof u.Range?new u.TextEdit(Oe.range,Oe.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Oe.additionalTextEdits=Ee.additionalTextEdits.map(xe=>ve.to(xe))),Oe.command=Q&&Ee.command?Q.fromInternal(Ee.command):void 0,Oe}Te.to=be})(W||(e.CompletionItem=W={}));var H;(function(Te){function be(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:V.fromStrict(Q.documentation)}}Te.from=be;function Ee(Q){return{label:Q.label,documentation:F.isMarkdownString(Q.documentation)?V.to(Q.documentation):Q.documentation}}Te.to=Ee})(H||(e.ParameterInformation=H={}));var j;(function(Te){function be(Q){return{label:Q.label,documentation:V.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(H.from):[],activeParameter:Q.activeParameter}}Te.from=be;function Ee(Q){return{label:Q.label,documentation:F.isMarkdownString(Q.documentation)?V.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(H.to):[],activeParameter:Q.activeParameter}}Te.to=Ee})(j||(e.SignatureInformation=j={}));var re;(function(Te){function be(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(j.from):[]}}Te.from=be;function Ee(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(j.to):[]}}Te.to=Ee})(re||(e.SignatureHelp=re={}));var he;(function(Te){function be(Ee,Q){const Oe=new u.InlayHint(I.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(ie.to.bind(void 0,Ee)),Q.kind&&we.to(Q.kind));return Oe.textEdits=Q.textEdits&&Q.textEdits.map(ve.to),Oe.tooltip=F.isMarkdownString(Q.tooltip)?V.to(Q.tooltip):Q.tooltip,Oe.paddingLeft=Q.paddingLeft,Oe.paddingRight=Q.paddingRight,Oe}Te.to=be})(he||(e.InlayHint=he={}));var ie;(function(Te){function be(Ee,Q){const Oe=new u.InlayHintLabelPart(Q.label);return Oe.tooltip=F.isMarkdownString(Q.tooltip)?V.to(Q.tooltip):Q.tooltip,l.Command.is(Q.command)&&(Oe.command=Ee.fromInternal(Q.command)),Q.location&&(Oe.location=G.to(Q.location)),Oe}Te.to=be})(ie||(e.InlayHintLabelPart=ie={}));var we;(function(Te){function be(Q){return Q}Te.from=be;function Ee(Q){return Q}Te.to=Ee})(we||(e.InlayHintKind=we={}));var Se;(function(Te){function be(Q){return{range:s.from(Q.range),url:Q.target,tooltip:Q.tooltip}}Te.from=be;function Ee(Q){let Oe;if(Q.url)try{Oe=typeof Q.url=="string"?E.URI.parse(Q.url,!0):E.URI.revive(Q.url)}catch{}return new u.DocumentLink(s.to(Q.range),Oe)}Te.to=Ee})(Se||(e.DocumentLink=Se={}));var $e;(function(Te){function be(Q){const Oe=new u.ColorPresentation(Q.label);return Q.textEdit&&(Oe.textEdit=ve.to(Q.textEdit)),Q.additionalTextEdits&&(Oe.additionalTextEdits=Q.additionalTextEdits.map(xe=>ve.to(xe))),Oe}Te.to=be;function Ee(Q){return{label:Q.label,textEdit:Q.textEdit?ve.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Oe=>ve.from(Oe)):void 0}}Te.from=Ee})($e||(e.ColorPresentation=$e={}));var ze;(function(Te){function be(Q){return new u.Color(Q[0],Q[1],Q[2],Q[3])}Te.to=be;function Ee(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}Te.from=Ee})(ze||(e.Color=ze={}));var Je;(function(Te){function be(Q){return{range:s.from(Q.range)}}Te.from=be;function Ee(Q){return new u.SelectionRange(s.to(Q.range))}Te.to=Ee})(Je||(e.SelectionRange=Je={}));var qe;(function(Te){function be(Ee){switch(Ee){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}Te.to=be})(qe||(e.TextDocumentSaveReason=qe={}));var Ge;(function(Te){function be(Q){switch(Q){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.On:default:return 1}}Te.from=be;function Ee(Q){switch(Q){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 1:default:return u.TextEditorLineNumbersStyle.On}}Te.to=Ee})(Ge||(e.TextEditorLineNumbersStyle=Ge={}));var it;(function(Te){function be(Q){if(Q===u.EndOfLine.CRLF)return 1;if(Q===u.EndOfLine.LF)return 0}Te.from=be;function Ee(Q){if(Q===1)return u.EndOfLine.CRLF;if(Q===0)return u.EndOfLine.LF}Te.to=Ee})(it||(e.EndOfLine=it={}));var ct;(function(Te){function be(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Te.from=be})(ct||(e.ProgressLocation=ct={}));var et;(function(Te){function be(Q){const Oe={start:Q.start+1,end:Q.end+1};return Q.kind&&(Oe.kind=rt.from(Q.kind)),Oe}Te.from=be;function Ee(Q){const Oe={start:Q.start-1,end:Q.end-1};return Q.kind&&(Oe.kind=rt.to(Q.kind)),Oe}Te.to=Ee})(et||(e.FoldingRange=et={}));var rt;(function(Te){function be(Q){if(Q)switch(Q){case u.FoldingRangeKind.Comment:return l.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports:return l.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region:return l.FoldingRangeKind.Region}}Te.from=be;function Ee(Q){if(Q)switch(Q.value){case l.FoldingRangeKind.Comment.value:return u.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports.value:return u.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region.value:return u.FoldingRangeKind.Region}}Te.to=Ee})(rt||(e.FoldingRangeKind=rt={}));var Ue;(function(Te){function be(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?s.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?c.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Te.from=be})(Ue||(e.TextEditorOpenOptions=Ue={}));var st;(function(Te){function be(xe){return xe instanceof u.RelativePattern?xe.toJSON():typeof xe=="string"?xe:Ee(xe)||Q(xe)?new u.RelativePattern(xe.baseUri??xe.base,xe.pattern).toJSON():xe}Te.from=be;function Ee(xe){const Ke=xe;return Ke?E.URI.isUri(Ke.baseUri)&&typeof Ke.pattern=="string":!1}function Q(xe){const Ke=xe;return Ke?typeof Ke.base=="string"&&typeof Ke.pattern=="string":!1}function Oe(xe){return typeof xe=="string"?xe:new u.RelativePattern(E.URI.revive(xe.baseUri),xe.pattern)}Te.to=Oe})(st||(e.GlobPattern=st={}));var Z;(function(Te){function be(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(be);if(typeof Ee=="string")return Ee;{const Q=Ee;return{language:Q.language,scheme:Q.scheme,pattern:st.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}Te.from=be})(Z||(e.LanguageSelector=Z={}));var Y;(function(Te){function be(Q){return{start:Q.start,end:Q.end}}Te.from=be;function Ee(Q){return new u.NotebookRange(Q.start,Q.end)}Te.to=Ee})(Y||(e.NotebookRange=Y={}));var me;(function(Te){function be(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}Te.to=be;function Ee(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}Te.from=Ee})(me||(e.NotebookCellExecutionSummary=me={}));var Be;(function(Te){function be(Ee){if(Ee===b.NotebookCellExecutionState.Unconfirmed)return u.NotebookCellExecutionState.Pending;if(Ee===b.NotebookCellExecutionState.Pending)return;if(Ee===b.NotebookCellExecutionState.Executing)return u.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Te.to=be})(Be||(e.NotebookCellExecutionState=Be={}));var Ne;(function(Te){function be(Q){switch(Q){case u.NotebookCellKind.Markup:return b.CellKind.Markup;case u.NotebookCellKind.Code:default:return b.CellKind.Code}}Te.from=be;function Ee(Q){switch(Q){case b.CellKind.Markup:return u.NotebookCellKind.Markup;case b.CellKind.Code:default:return u.NotebookCellKind.Code}}Te.to=Ee})(Ne||(e.NotebookCellKind=Ne={}));var Qe;(function(Te){function be(Q){const Oe={metadata:Q.metadata??Object.create(null),cells:[]};for(const xe of Q.cells)u.NotebookCellData.validate(xe),Oe.cells.push(tt.from(xe));return Oe}Te.from=be;function Ee(Q){const Oe=new u.NotebookData(Q.cells.map(tt.to));return(0,d.isEmptyObject)(Q.metadata)||(Oe.metadata=Q.metadata),Oe}Te.to=Ee})(Qe||(e.NotebookData=Qe={}));var tt;(function(Te){function be(Q){return{cellKind:Ne.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:me.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(bt.from):[]}}Te.from=be;function Ee(Q){return new u.NotebookCellData(Ne.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(bt.to):void 0,Q.metadata,Q.internalMetadata?me.to(Q.internalMetadata):void 0)}Te.to=Ee})(tt||(e.NotebookCellData=tt={}));var pt;(function(Te){function be(Q){return{mime:Q.mime,valueBytes:k.VSBuffer.wrap(Q.data)}}Te.from=be;function Ee(Q){return new u.NotebookCellOutputItem(Q.valueBytes.buffer,Q.mime)}Te.to=Ee})(pt||(e.NotebookCellOutputItem=pt={}));var bt;(function(Te){function be(Q){return{outputId:Q.id,items:Q.items.map(pt.from),metadata:Q.metadata}}Te.from=be;function Ee(Q){const Oe=Q.items.map(pt.to);return new u.NotebookCellOutput(Oe,Q.outputId,Q.metadata)}Te.to=Ee})(bt||(e.NotebookCellOutput=bt={}));var Ot;(function(Te){function be(Oe){return Q(Oe)?{include:(0,d.withNullAsUndefined)(st.from(Oe.include)),exclude:(0,d.withNullAsUndefined)(st.from(Oe.exclude))}:(0,d.withNullAsUndefined)(st.from(Oe))}Te.from=be;function Ee(Oe){return Q(Oe)?{include:st.to(Oe.include),exclude:st.to(Oe.exclude)}:st.to(Oe)}Te.to=Ee;function Q(Oe){const xe=Oe;return xe?!(0,d.isUndefinedOrNull)(xe.include)&&!(0,d.isUndefinedOrNull)(xe.exclude):!1}})(Ot||(e.NotebookExclusiveDocumentPattern=Ot={}));var Kt;(function(Te){function be(Ee,Q,Oe){const xe=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(xe,Oe),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Te.from=be})(Kt||(e.NotebookStatusBarItem=Kt={}));var zt;(function(Te){function be(Ee,Q,Oe){const xe=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:Q.toInternal(xe,Oe),label:Ee.label,description:Ee.description,detail:Ee.detail,documentation:Ee.documentation}}Te.from=be})(zt||(e.NotebookKernelSourceAction=zt={}));var _t;(function(Te){function be(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Te.from=be})(_t||(e.NotebookDocumentContentOptions=_t={}));var xt;(function(Te){function be(Q){return{uri:Q.uri,provides:Q.provides}}Te.from=be;function Ee(Q){return new u.NotebookRendererScript(E.URI.revive(Q.uri),Q.provides)}Te.to=Ee})(xt||(e.NotebookRendererScript=xt={}));var Lt;(function(Te){function be(Q){return{message:V.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,location:Q.location&&{range:s.from(Q.location.range),uri:Q.location.uri}}}Te.from=be;function Ee(Q){const Oe=new u.TestMessage(typeof Q.message=="string"?Q.message:V.to(Q.message));return Oe.actualOutput=Q.actual,Oe.expectedOutput=Q.expected,Oe.location=Q.location?G.to(Q.location):void 0,Oe}Te.to=Ee})(Lt||(e.TestMessage=Lt={}));var Nt;(function(Te){Te.namespace=_.namespaceTestTag,Te.denamespace=_.denamespaceTestTag})(Nt||(e.TestTag=Nt={}));var Wt;(function(Te){function be(Q){const Oe=(0,r.getPrivateApiFor)(Q).controllerId;return{extId:w.TestId.fromExtHostTestItem(Q,Oe).toString(),label:Q.label,uri:E.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(xe=>Nt.namespace(Oe,xe.id)),range:p.Range.lift(s.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&V.fromStrict(Q.error)||null}}Te.from=be;function Ee(Q){return{parent:void 0,error:void 0,id:w.TestId.fromString(Q.extId).localId,label:Q.label,uri:E.URI.revive(Q.uri),tags:(Q.tags||[]).map(Oe=>{const{tagId:xe}=Nt.denamespace(Oe);return new u.TestTag(xe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:s.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}Te.toPlain=Ee})(Wt||(e.TestItem=Wt={})),function(Te){function be(Q){return{id:Q.id}}Te.from=be;function Ee(Q){return new u.TestTag(Q.id)}Te.to=Ee}(Nt||(e.TestTag=Nt={}));var Ht;(function(Te){const be=(Q,Oe)=>{const xe=[];for(const[We,Ze]of Oe)w.TestId.compare(Ze.item.extId,We)===2&&(Oe.delete(We),xe.push(Ze));const Ke={...Wt.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(Ze=>Ze.type===0).map(Lt.to)})),children:xe.map(We=>be(We,Oe))};for(const We of Ke.children)We.parent=Ke;return Ke};function Ee(Q){const Oe=[],xe=new Map;for(const Ke of Q.items){xe.set(Ke.item.extId,Ke);const We=w.TestId.root(Ke.item.extId);Q.request.targets.some(Ze=>Ze.controllerId===We&&Ze.testIds.includes(Ke.item.extId))&&Oe.push(Ke)}return{completedAt:Q.completedAt,results:Oe.map(Ke=>be(Ke,xe))}}Te.to=Ee})(Ht||(e.TestResults=Ht={}));var at;(function(Te){function be(xe){return{covered:xe.covered,total:xe.covered}}function Ee(xe){return"line"in xe?I.from(xe):s.from(xe)}function Q(xe){return"branches"in xe?{count:xe.executionCount,location:Ee(xe.location),type:1,branches:xe.branches.length?xe.branches.map(Ke=>({count:Ke.executionCount,location:Ke.location&&Ee(Ke.location)})):void 0}:{type:0,count:xe.executionCount,location:Ee(xe.location)}}Te.fromDetailed=Q;function Oe(xe){return{uri:xe.uri,statement:be(xe.statementCoverage),branch:xe.branchCoverage&&be(xe.branchCoverage),function:xe.functionCoverage&&be(xe.functionCoverage),details:xe.detailedCoverage?.map(Q)}}Te.fromFile=Oe})(at||(e.TestCoverage=at={}));var ft;(function(Te){function be(Ee){switch(Ee){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}Te.to=be})(ft||(e.CodeActionTriggerKind=ft={}));var Bt;(function(Te){function be(Q){const Oe=new u.TypeHierarchyItem(J.to(Q.kind),Q.name,Q.detail||"",E.URI.revive(Q.uri),s.to(Q.range),s.to(Q.selectionRange));return Oe._sessionId=Q._sessionId,Oe._itemId=Q._itemId,Oe}Te.to=be;function Ee(Q,Oe,xe){if(Oe=Oe??Q._sessionId,xe=xe??Q._itemId,Oe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:xe,kind:J.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:s.from(Q.range),selectionRange:s.from(Q.selectionRange),tags:Q.tags?.map(X.from)}}Te.from=Ee})(Bt||(e.TypeHierarchyItem=Bt={}));var At;(function(Te){function be(Ee){if(Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Te.from=be})(At||(e.ViewBadge=At={}));var Ct;(function(Te){function be(xe,Ke,We){const Ze=Ke.fileData;return Ze?new u.InternalFileDataTransferItem(new u.DataTransferFile(Ze.name,E.URI.revive(Ze.uri),Ze.id,(0,M.once)(()=>We(Ze.id)))):xe===R.Mimes.uriList&&Ke.uriListData?new u.InternalDataTransferItem(Oe(Ke.uriListData)):new u.InternalDataTransferItem(Ke.asString)}Te.to=be;async function Ee(xe,Ke){const We=await Ke.asString();if(xe===R.Mimes.uriList)return{asString:We,fileData:void 0,uriListData:Q(We)};const Ze=Ke.asFile();return{asString:We,fileData:Ze?{name:Ze.name,uri:Ze.uri,id:Ze._itemId??Ze.id}:void 0}}Te.from=Ee;function Q(xe){return C.UriList.split(xe).map(Ke=>{if(Ke.startsWith("#"))return Ke;try{return E.URI.parse(Ke)}catch{}return Ke})}function Oe(xe){return C.UriList.create(xe.map(Ke=>typeof Ke=="string"?Ke:E.URI.revive(Ke)))}})(Ct||(e.DataTransferItem=Ct={}));var lt;(function(Te){function be(Q,Oe){const xe=Q.items.map(([Ke,We])=>[Ke,Ct.to(Ke,We,Oe)]);return new u.DataTransfer(xe)}Te.toDataTransfer=be;async function Ee(Q){const Oe={items:[]},xe=[];for(const[Ke,We]of Q)xe.push((async()=>{Oe.items.push([Ke,await Ct.from(Ke,We)])})());return await Promise.all(xe),Oe}Te.from=Ee})(lt||(e.DataTransfer=lt={}));var kt;(function(Te){function be(Q){return{message:Q.message,metadata:Q.metadata,title:Q.title,tooltip:Q.tooltip}}Te.to=be;function Ee(Q){return{kind:"reply",message:Q.message,metadata:Q.metadata,title:Q.title,tooltip:Q.tooltip}}Te.from=Ee})(kt||(e.ChatReplyFollowup=kt={}));var Ft;(function(Te){function be(Ee){return typeof Ee=="string"?{title:Ee,message:Ee,kind:"reply"}:"commandId"in Ee?{kind:"command",title:Ee.title??"",commandId:Ee.commandId??"",args:Ee.args}:kt.from(Ee)}Te.from=be})(Ft||(e.ChatFollowup=Ft={}))}),define(Ae[202],Re([1,0,2,9,7,8,171]),function(te,e,m,k,C,M,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class f{constructor(g,R,y,d={timeout:1500,errors:3}){this._logService=g,this._documents=R,this._mainThreadBulkEdits=y,this._thresholds=d,this._callbacks=new F.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(g){return(R,y,d)=>{const p={dispose:this._callbacks.push([R,y,g])};return Array.isArray(d)&&d.push(p),p}}async $participateInSave(g,R){const y=m.URI.revive(g);let d=!1;const E=setTimeout(()=>d=!0,this._thresholds.timeout),p=[];try{for(const l of[...this._callbacks]){if(d)break;const t=this._documents.getDocument(y),r=await this._deliverEventAsyncAndBlameBadListeners(l,{document:t,reason:M.TextDocumentSaveReason.to(R)});p.push(r)}}finally{clearTimeout(E)}return p}_deliverEventAsyncAndBlameBadListeners([g,R,y],d){const E=this._badListeners.get(g);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,g,R,d).then(()=>!0,p=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const l=this._badListeners.get(g);this._badListeners.set(g,l?l+1:1),typeof l=="number"&&l>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(g,R,y,d){const E=[],p=Date.now(),{document:l,reason:t}=d,{version:r}=l,c=Object.freeze({document:l,reason:t,waitUntil(b){if(Object.isFrozen(E))throw(0,k.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(b))}});try{R.apply(y,[c])}catch(b){return Promise.reject(b)}return Object.freeze(E),new Promise((b,w)=>{const _=setTimeout(()=>w(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(_),b(i)}).catch(i=>{clearTimeout(_),w(i)})}).then(b=>{const w={edits:[]};for(const _ of b)if(Array.isArray(_)&&_.every(i=>i instanceof C.TextEdit))for(const{newText:i,newEol:u,range:n}of _)w.edits.push({resource:l.uri,versionId:void 0,textEdit:{range:n&&M.Range.from(n),text:i,eol:u&&M.EndOfLine.from(u)}});if(w.edits.length!==0)return r===l.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(w):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=f}),define(Ae[203],Re([1,0,14,2,8,7,76]),function(te,e,m,k,C,M,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class f{constructor(y,d,E,p){this.start=y,this.deletedCount=d,this.deletedItems=E,this.items=p}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(y,d){return{EOL:d.eol,lines:d.source,languageId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:y}}constructor(y,d,E){this.notebook=y,this._extHostDocument=d,this._cellData=E,this.handle=E.handle,this.uri=k.URI.revive(E.uri),this.cellKind=E.cellKind,this._outputs=E.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=E.internalMetadata??{},this._metadata=Object.freeze(E.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const y=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get mime(){return y._mime},set mime(p){y._mime=p},get outputs(){return y._outputs.slice(0)},get metadata(){return y._metadata},get executionSummary(){return y._previousResult}};this._apiCell=Object.freeze(E)}return this._apiCell}setOutputs(y){this._outputs=y.map(C.NotebookCellOutput.to)}setOutputItems(y,d,E){const p=E.map(C.NotebookCellOutputItem.to),l=this._outputs.find(t=>t.id===y);if(l&&(d||(l.items.length=0),l.items.push(...p),l.items.length>1&&l.items.every(t=>F.isTextStreamMime(t.mime)))){const t=new Map,r=[];l.items.forEach(c=>{let b;t.has(c.mime)?b=t.get(c.mime):(b=[],t.set(c.mime,b),r.push(c.mime)),b.push(c.data)}),l.items.length=0,r.forEach(c=>{const b=F.compressOutputItemStreams(t.get(c));l.items.push({mime:c,data:b.buffer})})}}setMetadata(y){this._metadata=Object.freeze(y)}setInternalMetadata(y){this._internalMetadata=y,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.ExtHostCell=D;class g{constructor(y,d,E,p,l){this._proxy=y,this._textDocumentsAndEditors=d,this._textDocuments=E,this.uri=p,this.handle=g._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=l.viewType,this._metadata=Object.freeze(l.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,l.cells]],!0,void 0),this._versionId=l.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const y=this,d={get uri(){return y.uri},get version(){return y._versionId},get notebookType(){return y._notebookType},get isDirty(){return y._isDirty},get isUntitled(){return y.uri.scheme===m.Schemas.untitled},get isClosed(){return y._disposed},get metadata(){return y._metadata},get cellCount(){return y._cells.length},cellAt(E){return E=y._validateIndex(E),y._cells[E].apiCell},getCells(E){return(E?y._getCells(E):y._cells).map(l=>l.apiCell)},save(){return y._save()}};this._notebook=Object.freeze(d)}return this._notebook}acceptDocumentPropertiesChanged(y){y.metadata&&(this._metadata=Object.freeze({...this._metadata,...y.metadata}))}acceptDirty(y){this._isDirty=y}acceptModelChanged(y,d,E){this._versionId=y.versionId,this._isDirty=d,this.acceptDocumentPropertiesChanged({metadata:E});const p={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},l=[];for(const r of y.rawEvents)r.kind===F.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1,p.contentChanges):r.kind===F.NotebookCellsChangeType.Move?this._moveCells(r.index,r.length,r.newIdx,p.contentChanges):r.kind===F.NotebookCellsChangeType.Output?(this._setCellOutputs(r.index,r.outputs),l.push({cell:this._cells[r.index].apiCell,outputs:this._cells[r.index].apiCell.outputs})):r.kind===F.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems),l.push({cell:this._cells[r.index].apiCell,outputs:this._cells[r.index].apiCell.outputs})):r.kind===F.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(r.index,r.language),l.push({cell:this._cells[r.index].apiCell,document:this._cells[r.index].apiCell.document})):r.kind===F.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this._cells[r.index].apiCell,document:this._cells[r.index].apiCell.document}):r.kind===F.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(r.index,r.mime):r.kind===F.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(r.index,r.metadata),l.push({cell:this._cells[r.index].apiCell,metadata:this._cells[r.index].apiCell.metadata})):r.kind===F.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(r.index,r.internalMetadata),l.push({cell:this._cells[r.index].apiCell,executionSummary:this._cells[r.index].apiCell.executionSummary}));const t=new Map;for(let r=0;r<l.length;r++){const c=l[r],b=t.get(c.cell);if(b===void 0){const w=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});t.set(c.cell,w-1)}else p.cellChanges[b]={...p.cellChanges[b],...c}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}_validateIndex(y){return y=y|0,y<0?0:y>=this._cells.length?this._cells.length-1:y}_validateRange(y){let d=y.start|0,E=y.end|0;return d<0&&(d=0),E>this._cells.length&&(E=this._cells.length),y.with({start:d,end:E})}_getCells(y){y=this._validateRange(y);const d=[];for(let E=y.start;E<y.end;E++)d.push(this._cells[E]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(y,d,E){if(this._disposed)return;const p=[],l=[],t=[];if(y.reverse().forEach(r=>{const b=r[2].map(i=>{const u=new D(this,this._textDocumentsAndEditors,i);return d||l.push(D.asModelAddData(this.apiNotebook,i)),u}),w=new f(r[0],r[1],[],b),_=this._cells.splice(r[0],r[1],...b);for(const i of _)t.push(i.uri),w.deletedItems.push(i.apiCell);p.push(w)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:t}),E)for(const r of p)E.push(r.asApiEvent())}_moveCells(y,d,E,p){const l=this._cells.splice(y,d);this._cells.splice(E,0,...l);const t=[new f(y,d,l.map(r=>r.apiCell),[]),new f(E,0,[],l)];for(const r of t)p.push(r.asApiEvent())}_setCellOutputs(y,d){this._cells[y].setOutputs(d)}_setCellOutputItems(y,d,E,p){this._cells[y].setOutputItems(d,E,p)}_changeCellLanguage(y,d){const E=this._cells[y];E.apiCell.document.languageId!==d&&this._textDocuments.$acceptModelLanguageChanged(E.uri,d)}_changeCellMime(y,d){const E=this._cells[y];E.apiCell.mime=d}_changeCellMetadata(y,d){this._cells[y].setMetadata(d)}_changeCellInternalMetadata(y,d){this._cells[y].setInternalMetadata(d)}getCellFromApiCell(y){return this._cells.find(d=>d.apiCell===y)}getCellFromIndex(y){return this._cells[y]}getCell(y){return this._cells.find(d=>d.handle===y)}getCellIndex(y){return this._cells.indexOf(y)}}e.ExtHostNotebookDocument=g,g._handlePool=0}),define(Ae[204],Re([1,0,5,2,8,7]),function(te,e,m,k,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class F{constructor(D,g,R,y={timeout:1500,errors:3}){this._logService=D,this._notebooksAndEditors=g,this._mainThreadBulkEdits=R,this._thresholds=y,this._onWillSaveNotebookDocumentEvent=new m.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(g,R,y)=>{const d=function(p){g.call(R,p)};return d.extension=D,this._onWillSaveNotebookDocumentEvent.event(d,void 0,y)}}async $participateInSave(D,g,R){const y=k.URI.revive(D),d=this._notebooksAndEditors.getNotebookDocument(y);if(!d)throw new Error("Unable to resolve notebook document");const E=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:d.apiNotebook,reason:C.TextDocumentSaveReason.to(g)},R,async(l,t)=>{const r=Date.now(),c=await await Promise.resolve(l);Date.now()-r>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!R.isCancellationRequested&&c&&(c instanceof M.WorkspaceEdit?E.push(c):this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(E.length===0)return!0;const p={edits:[]};for(const l of E){const{edits:t}=C.WorkspaceEdit.from(l);p.edits=p.edits.concat(t)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p)}}e.ExtHostNotebookDocumentSaveParticipant=F}),define(Ae[103],Re([1,0,9,8,7]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(f,D,g,R,y,d){this.id=f,this._proxy=D,this.notebookData=g,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=y,this._visibleRanges=R,this._viewColumn=d}get apiEditor(){if(!this._editor){const f=this;this._editor={get notebook(){return f.notebookData.apiNotebook},get selection(){return f._selections[0]},set selection(D){this.selections=[D]},get selections(){return f._selections},set selections(D){if(!Array.isArray(D)||!D.every(C.NotebookRange.isNotebookRange))throw(0,m.illegalArgument)("selections");f._selections=D,f._trySetSelections(D)},get visibleRanges(){return f._visibleRanges},revealRange(D,g){f._proxy.$tryRevealRange(f.id,k.NotebookRange.from(D),g??C.NotebookEditorRevealType.Default)},get viewColumn(){return f._viewColumn}},M.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(f){this._visible=f}_acceptVisibleRanges(f){this._visibleRanges=f}_acceptSelections(f){this._selections=f}_trySetSelections(f){this._proxy.$trySetSelections(this.id,f.map(k.NotebookRange.from))}_acceptViewColumn(f){this._viewColumn=f}}e.ExtHostNotebookEditor=M,M.apiEditorsToExtHost=new WeakMap}),define(Ae[205],Re([1,0,9,5,15,8]),function(te,e,m,k,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let F=e.ExtHostNotebookEditors=class{constructor(D,g){this._logService=D,this._notebooksAndEditors=g,this._onDidChangeNotebookEditorSelection=new k.Emitter({onListenerError:m.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new k.Emitter({onListenerError:m.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(D,g){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,g);const R=this._notebooksAndEditors.getEditorById(D);g.visibleRanges&&R._acceptVisibleRanges(g.visibleRanges.ranges.map(M.NotebookRange.to)),g.selections&&R._acceptSelections(g.selections.selections.map(M.NotebookRange.to)),g.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),g.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const g in D)this._notebooksAndEditors.getEditorById(g)._acceptViewColumn(M.ViewColumn.to(D[g]))}};e.ExtHostNotebookEditors=F=Ve([He(0,C.ILogService)],F)}),define(Ae[206],Re([1,0,8,175,151,22,65,9]),function(te,e,m,k,C,M,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(d){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=d}async withProgress(d,E,p){const l=this._handles++,{title:t,location:r,cancellable:c}=E,b={label:(0,C.localize)(0,null,d.displayName||d.name),id:d.identifier.value};return this._proxy.$startProgress(l,{location:m.ProgressLocation.from(r),title:t,source:b,cancellable:c},d.isUnderDevelopment?void 0:d.identifier.value).catch(f.onUnexpectedExternalError),this._withProgress(l,p,!!c)}_withProgress(d,E,p){let l;p&&(l=new M.CancellationTokenSource,this._mapHandleToCancellationSource.set(d,l));const t=c=>{this._proxy.$progressEnd(c),this._mapHandleToCancellationSource.delete(c),l?.dispose()};let r;try{r=E(new R(this._proxy,d),p&&l?l.token:M.CancellationToken.None)}catch(c){throw t(d),c}return r.then(c=>t(d),c=>t(d)),r}$acceptProgressCanceled(d){const E=this._mapHandleToCancellationSource.get(d);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(d))}}e.ExtHostProgress=D;function g(y,d){return y.message=d.message,typeof d.increment=="number"&&(typeof y.increment=="number"?y.increment+=d.increment:y.increment=d.increment),y}class R extends k.Progress{constructor(d,E){super(p=>this.throttledReport(p)),this._proxy=d,this._handle=E}throttledReport(d){this._proxy.$progressReport(this._handle,d)}}Ve([(0,F.throttle)(100,(y,d)=>g(y,d),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ae[104],Re([1,0,44,101,45,77,56,8,2]),function(te,e,m,k,C,M,F,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const g=(b,w,_,i)=>{let u=w;return{enumerable:!0,configurable:!1,get(){return u},set(n){if(!_(u,n)){const s=u;u=n,b.listener?.(i(n,s))}}}},R=(b,w)=>b===w,y={range:(b,w)=>b===w?!0:!b||!w?!1:b.isEqual(w),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(b,w)=>!(b.length!==w.length||b.some(_=>!w.find(i=>_.id===i.id)))},d=b=>w=>({op:4,update:b(w)}),E=(b,w)=>({range:(()=>{let _;const i=d(u=>({range:m.Range.lift(f.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return _},set(u){b.listener?.({op:6}),y.range(_,u)||(_=u,b.listener?.(i(u)))}}})(),label:g(b,w,y.label,d(_=>({label:_}))),description:g(b,void 0,y.description,d(_=>({description:_}))),sortText:g(b,void 0,y.sortText,d(_=>({sortText:_}))),canResolveChildren:g(b,!1,y.canResolveChildren,_=>({op:2,state:_})),busy:g(b,!1,y.busy,d(_=>({busy:_}))),error:g(b,void 0,y.error,d(_=>({error:f.MarkdownString.fromStrict(_)||null}))),tags:g(b,[],y.tags,(_,i)=>({op:1,new:_.map(f.TestTag.from),old:i.map(f.TestTag.from)}))}),p=b=>{const w=C.TestId.fromString(b.extId),_=new t(w.controllerId,w.localId,b.label,D.URI.revive(b.uri)||void 0);return _.range=f.Range.to(b.range||void 0),_.description=b.description||void 0,_.sortText=b.sortText||void 0,_.tags=b.tags.map(i=>f.TestTag.to({id:(0,F.denamespaceTestTag)(i).tagId})),_},l=b=>{let w;for(const _ of b.tests){const i=p(_.item);(0,k.getPrivateApiFor)(i).parent=w,w=i}return w};e.toItemFromContext=l;class t{constructor(w,_,i,u){if(_.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(_)} symbol`);const n=(0,k.createPrivateApiFor)(this,w);Object.defineProperties(this,{id:{value:_,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof r?void 0:n.parent}},children:{value:(0,M.createTestItemChildren)(n,k.getPrivateApiFor,t),enumerable:!0,writable:!1},...E(n,i)})}}e.TestItemImpl=t;class r extends t{constructor(w,_){super(w,w,_,void 0),this._isRoot=!0}}e.TestItemRootImpl=r;class c extends M.TestItemCollection{constructor(w,_,i){super({controllerId:w,getDocumentVersion:u=>u&&i.getDocument(u)?.version,getApiFor:k.getPrivateApiFor,getChildren:u=>u.children,root:new r(w,_),toITestItem:f.TestItem.from})}}e.ExtHostTestItemCollection=c}),define(Ae[105],Re([1,0,49,9,88,8,7]),function(te,e,m,k,C,M,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class f{constructor(d,E,p){const l=f._Keys.nextId();d.$registerTextEditorDecorationType(E.identifier,l,M.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:l,dispose(){d.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=f,f._Keys=new C.IdGenerator("TextEditorDecorationType");class D{constructor(d,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,E){this._throwIfFinalized();let p=null;if(d instanceof F.Position)p=new F.Range(d,d);else if(d instanceof F.Range)p=d;else throw new Error("Unrecognized location");this._pushEdit(p,E,!1)}insert(d,E){this._throwIfFinalized(),this._pushEdit(new F.Range(d,d),E,!0)}delete(d){this._throwIfFinalized();let E=null;if(d instanceof F.Range)E=d;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(d,E,p){const l=this._document.validateRange(d);this._collectedEdits.push({range:l,text:E,forceMoveMarkers:p})}setEndOfLine(d){if(this._throwIfFinalized(),d!==F.EndOfLine.LF&&d!==F.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this._setEndOfLine=d}}class g{constructor(d,E,p,l){this._proxy=d,this._id=E,this._accept(p),this._logService=l;const t=this;this.value={get tabSize(){return t._tabSize},set tabSize(r){t._setTabSize(r)},get indentSize(){return t._indentSize},set indentSize(r){t._setIndentSize(r)},get insertSpaces(){return t._insertSpaces},set insertSpaces(r){t._setInsertSpaces(r)},get cursorStyle(){return t._cursorStyle},set cursorStyle(r){t._setCursorStyle(r)},get lineNumbers(){return t._lineNumbers},set lineNumbers(r){t._setLineNumbers(r)}}}_accept(d){this._tabSize=d.tabSize,this._indentSize=d.indentSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=M.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const E=Math.floor(d);return E>0?E:null}if(typeof d=="string"){const E=parseInt(d,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(d){const E=this._validateTabSize(d);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateIndentSize(d){if(d==="tabSize")return"tabSize";if(typeof d=="number"){const E=Math.floor(d);return E>0?E:null}if(typeof d=="string"){const E=parseInt(d,10);return isNaN(E)?null:E>0?E:null}return null}_setIndentSize(d){const E=this._validateIndentSize(d);if(E!==null){if(typeof E=="number"){if(this._indentSize===E)return;this._indentSize=E}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:E}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:!!d}_setInsertSpaces(d){const E=this._validateInsertSpaces(d);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:M.TextEditorLineNumbersStyle.from(d)})))}assign(d){const E={};let p=!1;if(typeof d.tabSize<"u"){const l=this._validateTabSize(d.tabSize);l==="auto"?(p=!0,E.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,p=!0,E.tabSize=l)}if(typeof d.indentSize<"u"){const l=this._validateIndentSize(d.indentSize);l==="tabSize"?(p=!0,E.indentSize=l):typeof l=="number"&&this._indentSize!==l&&(this._indentSize=l,p=!0,E.indentSize=l)}if(typeof d.insertSpaces<"u"){const l=this._validateInsertSpaces(d.insertSpaces);l==="auto"?(p=!0,E.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,p=!0,E.insertSpaces=l)}typeof d.cursorStyle<"u"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,p=!0,E.cursorStyle=d.cursorStyle),typeof d.lineNumbers<"u"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,p=!0,E.lineNumbers=M.TextEditorLineNumbersStyle.from(d.lineNumbers)),p&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(d,E){E.catch(p=>{this._logService.warn(`ExtHostTextEditorOptions '${d}' failed:'`),this._logService.warn(p)})}}e.ExtHostTextEditorOptions=g;class R{constructor(d,E,p,l,t,r,c,b){this.id=d,this._proxy=E,this._logService=p,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=t,this._options=new g(this._proxy,this.id,r,p),this._visibleRanges=c,this._viewColumn=b;const w=this;this.value=Object.freeze({get document(){return l.value},set document(_){throw(0,k.readonly)("document")},get selection(){return w._selections&&w._selections[0]},set selection(_){if(!(_ instanceof F.Selection))throw(0,k.illegalArgument)("selection");w._selections=[_],w._trySetSelection()},get selections(){return w._selections},set selections(_){if(!Array.isArray(_)||_.some(i=>!(i instanceof F.Selection)))throw(0,k.illegalArgument)("selections");w._selections=_,w._trySetSelection()},get visibleRanges(){return w._visibleRanges},set visibleRanges(_){throw(0,k.readonly)("visibleRanges")},get options(){return w._options.value},set options(_){w._disposed||w._options.assign(_)},get viewColumn(){return w._viewColumn},set viewColumn(_){throw(0,k.readonly)("viewColumn")},edit(_,i={undoStopBefore:!0,undoStopAfter:!0}){if(w._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new D(l.value,i);return _(u),w._applyEdit(u)},insertSnippet(_,i,u={undoStopBefore:!0,undoStopAfter:!0}){if(w._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!i||Array.isArray(i)&&i.length===0)n=w._selections.map(s=>M.Range.from(s));else if(i instanceof F.Position){const{lineNumber:s,column:v}=M.Position.from(i);n=[{startLineNumber:s,startColumn:v,endLineNumber:s,endColumn:v}]}else if(i instanceof F.Range)n=[M.Range.from(i)];else{n=[];for(const s of i)if(s instanceof F.Range)n.push(M.Range.from(s));else{const{lineNumber:v,column:I}=M.Position.from(s);n.push({startLineNumber:v,startColumn:I,endLineNumber:v,endColumn:I})}}return E.$tryInsertSnippet(d,l.value.version,_.value,n,u)},setDecorations(_,i){const u=i.length===0;u&&!w._hasDecorationsForKey.has(_.key)||(u?w._hasDecorationsForKey.delete(_.key):w._hasDecorationsForKey.add(_.key),w._runOnProxy(()=>{if(M.isDecorationOptionsArr(i))return E.$trySetDecorations(d,_.key,M.fromRangeOrRangeWithMessage(i));{const n=new Array(4*i.length);for(let s=0,v=i.length;s<v;s++){const I=i[s];n[4*s]=I.start.line+1,n[4*s+1]=I.start.character+1,n[4*s+2]=I.end.line+1,n[4*s+3]=I.end.character+1}return E.$trySetDecorationsFast(d,_.key,n)}}))},revealRange(_,i){w._runOnProxy(()=>E.$tryRevealRange(d,M.Range.from(_),i||F.TextEditorRevealType.Default))},show(_){E.$tryShowEditor(d,M.ViewColumn.from(_))},hide(){E.$tryHideEditor(d)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,m.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,m.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,m.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,m.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(M.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const E=d.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const p=E.edits.map(t=>t.range);p.sort((t,r)=>t.end.line===r.end.line?t.end.character===r.end.character?t.start.line===r.start.line?t.start.character-r.start.character:t.start.line-r.start.line:t.end.character-r.end.character:t.end.line-r.end.line);for(let t=0,r=p.length-1;t<r;t++){const c=p[t].end;if(p[t+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=E.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,l,{setEndOfLine:typeof E.setEndOfLine=="number"?M.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=R}),define(Ae[207],Re([1,0,155,7,20,2,5,6,191,16,7,10,18,8,22,125]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function t(b,w){if((0,y.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let _;return Array.isArray(b.highlights)&&(_=b.highlights.filter(i=>i.length===2&&typeof i[0]=="number"&&typeof i[1]=="number"),_=_.length?_:void 0),{label:b.label,highlights:_}}}class r{constructor(w,_,i){this._proxy=w,this.commands=_,this.logService=i,this.treeViews=new Map,this.treeDragAndDropService=new l.TreeViewsDnDService;function u(n){return n&&n.$treeViewId&&(n.$treeItemHandle||n.$selectedTreeItems||n.$focusedTreeItem)}_.registerArgumentProcessor({processArgument:n=>u(n)?this.convertArgument(n):Array.isArray(n)&&n.length>0?n.map(s=>u(s)?this.convertArgument(s):s):n})}registerTreeDataProvider(w,_,i){const u=this.createTreeView(w,{treeDataProvider:_},i);return{dispose:()=>u.dispose()}}createTreeView(w,_,i){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=_.dragAndDropController?.dropMimeTypes??[],n=_.dragAndDropController?.dragMimeTypes??[],s=!!_.dragAndDropController?.handleDrag,v=!!_.dragAndDropController?.handleDrop,I=this.createExtHostTreeView(w,_,i),h={showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany,dropMimeTypes:u,dragMimeTypes:n,hasHandleDrag:s,hasHandleDrop:v,manuallyManageCheckboxes:!!_.manageCheckboxStateManually},T=this._proxy.$registerTreeViewDataProvider(w,h);return{get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(S){I.message=S},get title(){return I.title},set title(S){I.title=S},get description(){return I.description},set description(S){I.description=S},get badge(){return I.badge},set badge(S){S!==void 0&&R.ViewBadge.isViewBadge(S)?I.badge={value:Math.floor(Math.abs(S.value)),tooltip:S.tooltip}:S===void 0&&(I.badge=void 0)},reveal:(S,a)=>I.reveal(S,a),dispose:async()=>{await T,this.treeViews.delete(w),I.dispose()}}}$getChildren(w,_){const i=this.treeViews.get(w);return i?i.getChildren(_):Promise.reject(new D.NoTreeViewError(w))}async $handleDrop(w,_,i,u,n,s,v,I){const h=this.treeViews.get(w);if(!h)return Promise.reject(new D.NoTreeViewError(w));const T=E.DataTransfer.toDataTransfer(i,async S=>(await this._proxy.$resolveDropFileData(w,_,S)).buffer);return v===w&&I&&await this.addAdditionalTransferItems(T,h,I,n,s),h.onDrop(T,u,n)}async addAdditionalTransferItems(w,_,i,u,n){const s=this.treeDragAndDropService.removeDragOperationTransfer(n);if(s)(await s)?.forEach((v,I)=>{v&&w.set(I,v)});else if(n&&_.handleDrag){const v=_.handleDrag(i,w,u);this.treeDragAndDropService.addDragOperationTransfer(n,v),await v}return w}async $handleDrag(w,_,i,u){const n=this.treeViews.get(w);if(!n)return Promise.reject(new D.NoTreeViewError(w));const s=await this.addAdditionalTransferItems(new k.DataTransfer,n,_,u,i);if(!(!s||u.isCancellationRequested))return E.DataTransfer.from(s)}async $hasResolve(w){const _=this.treeViews.get(w);if(!_)throw new D.NoTreeViewError(w);return _.hasResolve}$resolve(w,_,i){const u=this.treeViews.get(w);if(!u)throw new D.NoTreeViewError(w);return u.resolveTreeItem(_,i)}$setExpanded(w,_,i){const u=this.treeViews.get(w);if(!u)throw new D.NoTreeViewError(w);u.setExpanded(_,i)}$setSelection(w,_){const i=this.treeViews.get(w);if(!i)throw new D.NoTreeViewError(w);i.setSelection(_)}$setFocus(w,_){const i=this.treeViews.get(w);if(!i)throw new D.NoTreeViewError(w);i.setFocus(_)}$setVisible(w,_){const i=this.treeViews.get(w);if(!i)throw new D.NoTreeViewError(w);i.setVisible(_)}$changeCheckboxState(w,_){const i=this.treeViews.get(w);if(!i)throw new D.NoTreeViewError(w);i.setCheckboxState(_)}createExtHostTreeView(w,_,i){const u=new c(w,_,this._proxy,this.commands.converter,this.logService,i);return this.treeViews.set(w,u),u}convertArgument(w){const _=this.treeViews.get(w.$treeViewId);return _&&"$treeItemHandle"in w?_.getExtensionElement(w.$treeItemHandle):_&&"$focusedTreeItem"in w&&w.$focusedTreeItem?_.focusedElement:null}}e.ExtHostTreeViews=r;class c extends f.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,y.isUndefinedOrNull)(w))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(w,_,i,u,n,s){if(super(),this.viewId=w,this.proxy=i,this.commands=u,this.logService=n,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new F.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new F.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new F.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new F.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new F.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new F.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new p.CancellationTokenSource,s.contributes&&s.contributes.views)for(const h in s.contributes.views)for(const T of s.contributes.views[h])T.id===w&&(this._title=T.name);this.dataProvider=_.treeDataProvider,this.dndController=_.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(h=>this._onDidChangeData.fire({message:!1,element:h})));let v,I;this._register(F.Event.debounce(this._onDidChangeData.event,(h,T)=>(h||(h={message:!1,elements:[]}),T.element!==!1&&(v||(v=new Promise(S=>I=S),this.refreshPromise=this.refreshPromise.then(()=>v)),Array.isArray(T.element)?h.elements.push(...T.element):h.elements.push(T.element)),T.message&&(h.message=!0),h),200,!0)(({message:h,elements:T})=>{T.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const S=I;return v=null,this.refresh(T).then(()=>S())})),h&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(w){const _=w?this.getExtensionElement(w):void 0;if(w&&!_)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);let i=this.getChildrenNodes(w);return i||(i=await this.fetchChildrenNodes(_)),i?i.map(u=>u.item):void 0}getExtensionElement(w){return this.elements.get(w)}reveal(w,_){_=_||{select:!0,focus:!1};const i=(0,y.isUndefinedOrNull)(_.select)?!0:_.select,u=(0,y.isUndefinedOrNull)(_.focus)?!1:_.focus,n=(0,y.isUndefinedOrNull)(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(s=>this.resolveTreeNode(w,s[s.length-1]).then(v=>this.proxy.$reveal(this.viewId,{item:v.item,parentChain:s.map(I=>I.item)},{select:i,focus:u,expand:n})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:i,focus:u,expand:n})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}get badge(){return this._badge}set badge(w){this._badge?.value===w?.value&&this._badge?.tooltip===w?.tooltip||(this._badge=E.ViewBadge.from(w),this.proxy.$setBadge(this.viewId,w))}setExpanded(w,_){const i=this.getExtensionElement(w);i&&(_?this._onDidExpandElement.fire(Object.freeze({element:i})):this._onDidCollapseElement.fire(Object.freeze({element:i})))}setSelection(w){(0,d.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(w){this._focusedHandle=w}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(w){const _=(await Promise.all(w.map(async i=>{const u=this.getExtensionElement(i.treeItemHandle);return u?{extensionItem:u,treeItem:await this.dataProvider.getTreeItem(u),newState:i.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(i=>i!==void 0);_.forEach(i=>{i.treeItem.checkboxState=i.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:_.map(i=>[i.extensionItem,i.newState])})}async handleDrag(w,_,i){const u=[];for(const n of w){const s=this.getExtensionElement(n);s&&u.push(s)}if(!(!this.dndController?.handleDrag||u.length===0))return await this.dndController.handleDrag(u,_,i),_}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(w,_,i){const u=_?this.getExtensionElement(_):void 0;if(!(!u&&_||!this.dndController?.handleDrop))return(0,g.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(u,w,i):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,_){if(!this.dataProvider.resolveTreeItem)return;const i=this.elements.get(w);if(i){const u=this.nodes.get(i);if(u){const n=await this.dataProvider.resolveTreeItem(u.extensionItem,i,_)??u.extensionItem;return this.validateTreeItem(n),u.item.tooltip=this.getTooltip(n.tooltip),u.item.command=this.getCommand(u.disposableStore,n.command),u.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(_=>_?this.resolveUnknownParentChain(_).then(i=>this.resolveTreeNode(_,i[i.length-1]).then(u=>(i.push(u),i))):Promise.resolve([]))}resolveParent(w){const _=this.nodes.get(w);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):(0,g.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,_){const i=this.nodes.get(w);return i?Promise.resolve(i):(0,g.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(u=>this.createHandle(w,u,_,!0)).then(u=>this.getChildren(_?_.item.handle:void 0).then(()=>{const n=this.getExtensionElement(u);if(n){const s=this.nodes.get(n);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(w){if(w){let _;if(typeof w=="string"){const i=this.getExtensionElement(w);_=i?this.nodes.get(i):void 0}else _=w;return _&&_.children||void 0}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const _=new p.CancellationTokenSource(this._refreshCancellationSource.token);try{const i=w?this.nodes.get(w):void 0,u=await this.dataProvider.getChildren(w);if(_.token.isCancellationRequested)return;const n=await Promise.all((0,d.coalesce)(u||[]).map(async s=>{const v=await this.dataProvider.getTreeItem(s);return v&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(s,v,i):null}));return _.token.isCancellationRequested?void 0:(0,d.coalesce)(n)}finally{_.dispose()}}refresh(w){if(w.some(i=>!i))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new p.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const i=this.getHandlesToRefresh(w);if(i.length)return this.refreshHandles(i)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const _=new Set,i=w.map(n=>this.nodes.get(n));for(const n of i)if(n&&!_.has(n.item.handle)){let s=n;for(;s&&s.parent&&i.findIndex(v=>s&&s.parent&&v&&v.item.handle===s.parent.item.handle)===-1;){const v=this.elements.get(s.parent.item.handle);s=v?this.nodes.get(v):void 0}s&&!s.parent&&_.add(n.item.handle)}const u=[];return _.forEach(n=>{const s=this.elements.get(n);if(s){const v=this.nodes.get(s);v&&(!v.parent||!_.has(v.parent.item.handle))&&u.push(n)}}),u}refreshHandles(w){const _={};return Promise.all(w.map(i=>this.refreshNode(i).then(u=>{u&&(_[i]=u.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(w){const _=this.getExtensionElement(w);if(_){const i=this.nodes.get(_);if(i)return this.clearChildren(_),(0,g.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(u=>{if(u){const n=this.createTreeNode(_,u,i.parent);return this.updateNodeCache(_,n,i,i.parent),i.dispose(),n}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,_,i){const u=this.createTreeNode(w,_,i);if(_.id&&this.elements.has(u.item.handle))throw new Error((0,m.localize)(0,null,_.id));return this.addNodeToCache(w,u),this.addNodeToParentCache(u,i),u}getTooltip(w){return R.MarkdownString.isMarkdownString(w)?E.MarkdownString.from(w):w}getCommand(w,_){return _?{...this.commands.toInternal(_,w),originalId:_.command}:void 0}getCheckbox(w){if(w.checkboxState===void 0)return;let _,i,u;return typeof w.checkboxState=="number"?_=w.checkboxState:(_=w.checkboxState.state,i=w.checkboxState.tooltip,u=w.checkboxState.accessibilityInformation),{isChecked:_===R.TreeItemCheckboxState.Checked,tooltip:i,accessibilityInformation:u}}validateTreeItem(w){if(!R.TreeItem.isTreeItem(w,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(w,_,i){this.validateTreeItem(_);const u=new f.DisposableStore,n=this.createHandle(w,_,i),s=this.getLightIconPath(_);return{item:{handle:n,parentHandle:i?i.item.handle:void 0,label:t(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(u,_.command),contextValue:_.contextValue,icon:s,iconDark:this.getDarkIconPath(_)||s,themeIcon:this.getThemeIcon(_),collapsibleState:(0,y.isUndefinedOrNull)(_.collapsibleState)?R.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation,checkbox:this.getCheckbox(_)},extensionItem:_,parent:i,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(w){return w.iconPath instanceof R.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:_,label:i,resourceUri:u},n,s){if(_)return`${c.ID_HANDLE_PREFIX}/${_}`;const v=t(i,this.extension),I=n?n.item.handle:c.LABEL_HANDLE_PREFIX;let h=v?v.label:u?(0,C.basename)(u):"";h=h.indexOf("/")!==-1?h.replace("/","//"):h;const T=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,S=this.getChildrenNodes(n)||[];let a,o=0;do{if(a=`${I}/${o}:${h}`,s||!this.elements.has(a)||T===a)break;o++}while(o<=S.length);return a}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof R.ThemeIcon))return typeof w.iconPath=="string"||M.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof R.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return M.URI.isUri(w)?w:M.URI.file(w)}addNodeToCache(w,_){this.elements.set(_.item.handle,w),this.nodes.set(w,_)}updateNodeCache(w,_,i,u){this.elements.delete(_.item.handle),this.nodes.delete(w),_.item.handle!==i.item.handle&&this.elements.delete(i.item.handle),this.addNodeToCache(w,_);const n=this.getChildrenNodes(u)||[],s=n.filter(v=>v.item.handle===i.item.handle)[0];s&&n.splice(n.indexOf(s),1,_)}addNodeToParentCache(w,_){_?(_.children||(_.children=[]),_.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const _=this.nodes.get(w);if(_){if(_.children)for(const i of _.children){const u=this.elements.get(i.item.handle);u&&this.clear(u)}_.children=void 0}}else this.clearAll()}clear(w){const _=this.nodes.get(w);if(_){if(_.children)for(const i of _.children){const u=this.elements.get(i.item.handle);u&&this.clear(u)}this.nodes.delete(w),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}c.LABEL_HANDLE_PREFIX="0",c.ID_HANDLE_PREFIX="1"}),define(Ae[208],Re([1,0,3,169]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(k.IEnvironmentService)}),define(Ae[106],Re([1,0,24,5,19,6]),function(te,e,m,k,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class F{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=F;class f{static isHostExtension(t,r,c){if(r.getExtensionDescription(t))return!1;const b=c.getExtensionDescription(t);return b?!!((b.main||b.browser)&&b.api==="none"):!1}constructor(t,r){this._activationEventsReader=t,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=r,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new m.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this._extensionsMap.set(t.identifier,t),this._extensionsArr.push(t);const r=this._activationEventsReader.readActivationEvents(t);if(Array.isArray(r))for(let c of r)c==="onUri"&&(c=`onUri:${m.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(c)||this._activationMap.set(c,[]),this._activationMap.get(c).push(t)}}set(t){this._extensionDescriptions=t,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,r){this._extensionDescriptions=p(this._extensionDescriptions,r),this._extensionDescriptions=this._extensionDescriptions.concat(t);const c=f._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=p(this._extensionDescriptions,c.map(b=>b.identifier)),this._initialize(),this._onDidChange.fire(void 0),new F(c)}static _findLoopingExtensions(t){const r=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(i){this._nodesSet.has(i)||(this._nodesSet.add(i),this._nodesArr.push(i))}addArc(i,u){this.addNode(i),this.addNode(u),this._arcs.has(i)?this._arcs.get(i).push(u):this._arcs.set(i,[u])}getArcs(i){return this._arcs.has(i)?this._arcs.get(i):[]}hasOnlyGoodArcs(i,u){const n=r.getArcs(i);for(let s=0;s<n.length;s++)if(!u.has(n[s]))return!1;return!0}getNodes(){return this._nodesArr}},c=new m.ExtensionIdentifierMap;for(const i of t)if(c.set(i.identifier,i),i.extensionDependencies)for(const u of i.extensionDependencies)r.addArc(m.ExtensionIdentifier.toKey(i.identifier),m.ExtensionIdentifier.toKey(u));const b=new Set;r.getNodes().filter(i=>r.getArcs(i).length===0).forEach(i=>b.add(i));const w=r.getNodes().filter(i=>!b.has(i));let _;do{_=!1;for(let i=0;i<w.length;i++){const u=w[i];r.hasOnlyGoodArcs(u,b)&&(w.splice(i,1),i--,b.add(u),_=!0)}}while(_);return w.map(i=>c.get(i))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(t)}getExtensionDescriptionsForActivationEvent(t){const r=this._activationMap.get(t);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const r=this._extensionsMap.get(t);return r||void 0}getExtensionDescriptionByUUID(t){for(const r of this._extensionsArr)if(r.uuid===t)return r}getExtensionDescriptionByIdOrUUID(t,r){return this.getExtensionDescription(t)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.ExtensionDescriptionRegistry=f,e.basicActivationEventsReader={readActivationEvents:l=>l.activationEvents};class D{constructor(t){this._lock=new y,this._actual=new f(t,[])}async acquireLock(t){const r=await this._lock.acquire(t);return new g(this,r)}deltaExtensions(t,r,c){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(r,c)}containsActivationEvent(t){return this._actual.containsActivationEvent(t)}containsExtension(t){return this._actual.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this._actual.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getExtensionDescription(t){return this._actual.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this._actual.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,r){return this._actual.getExtensionDescriptionByIdOrUUID(t,r)}}e.LockableExtensionDescriptionRegistry=D;class g extends M.Disposable{constructor(t,r){super(),this._registry=t,this._isDisposed=!1,this._register(r)}isAcquiredFor(t){return!this._isDisposed&&this._registry===t}}e.ExtensionDescriptionRegistryLock=g;class R{constructor(t){this.name=t,this.promise=new Promise((r,c)=>{this._resolve=r})}resolve(t){this._resolve(t)}}class y{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(t){const r=new R(t);return this._pendingCustomers.push(r),this._advance(),r.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const t=this._pendingCustomers.shift();this._isLocked=!0;let r=!0;const c=setTimeout(()=>{r&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),b=()=>{r&&(clearTimeout(c),r=!1,this._isLocked=!1,this._advance())};t.resolve((0,M.toDisposable)(b))}}var d;(function(l){l[l.Builtin=0]="Builtin",l[l.User=1]="User",l[l.Dev=2]="Dev"})(d||(d={}));function E(l,t){const r=l.isBuiltin?0:l.isUnderDevelopment?2:1,c=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(r!==c)return r-c;const b=C.posix.basename(l.extensionLocation.path),w=C.posix.basename(t.extensionLocation.path);return b<w?-1:b>w?1:0}function p(l,t){const r=new m.ExtensionIdentifierSet(t);return l.filter(c=>!r.has(c.identifier))}}),define(Ae[80],Re([1,0,25]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var k;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(k||(e.UIKind=k={}));var C;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var M;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function F(g){const R=m.VSBuffer.alloc(1);switch(g){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=F;function f(g,R){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=f;var D;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(D||(e.NativeLogMarkers=D={}))}),define(Ae[57],Re([1,0,3,5,15,27,80,50,52,23,2,6,153]),function(te,e,m,k,C,M,F,f,D,g,R,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let E=e.ExtHostTelemetry=class extends y.Disposable{constructor(r,c){super(),this.initData=r,this.loggerService=c,this._onDidChangeTelemetryEnabled=this._register(new k.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new k.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=R.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=c.createLogger(this.extHostTelemetryLogFile,{id:D.extensionTelemetryLogChannelId,name:(0,d.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(c.onDidChangeLogLevel(b=>{(0,C.isLogLevel)(b)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(r,c,b){const w=this.getTelemetryDetails(),_=new p(c,b,r,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(r),{isUsageEnabled:w.isUsageEnabled,isErrorsEnabled:w.isErrorsEnabled}),i=this._telemetryLoggers.get(r.identifier.value)??[];return this._telemetryLoggers.set(r.identifier.value,[...i,_]),_.apiTelemetryLogger}$initializeTelemetryLevel(r,c,b){this._level=r,this._telemetryIsSupported=c,this._productConfig=b??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(r){const c=Object.create(null);switch(c["common.extname"]=`${r.publisher}.${r.name}`,c["common.extversion"]=r.version,c["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,c["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,c["common.vscodeversion"]=this.initData.version,c["common.isnewappinstall"]=l(this.initData.telemetryInfo.firstSessionDate),c["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case F.UIKind.Web:c["common.uikind"]="web";break;case F.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,f.getRemoteName)((0,D.cleanRemoteAuthority)(this.initData.remote.authority)),c}$onDidChangeTelemetryLevel(r){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=r;const c=this.getTelemetryDetails();this._telemetryLoggers.forEach((b,w)=>{const _=b.filter(i=>!i.isDisposed);_.length===0?this._telemetryLoggers.delete(w):this._telemetryLoggers.set(w,_)}),this._telemetryLoggers.forEach(b=>{for(const w of b)w.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(r,c){const w=this._telemetryLoggers.get(r.value)?.filter(i=>!i.isDisposed);if(!w)return this._telemetryLoggers.delete(r.value),!1;let _=!1;for(const i of w)i.ignoreUnhandledExtHostErrors||(i.logError(c),_=!0);return _}};e.ExtHostTelemetry=E=Ve([He(0,M.IExtHostInitDataService),He(1,C.ILoggerService)],E);class p{static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,c,b,w,_,i,u){this._extension=b,this._logger=w,this._inLoggingOnlyMode=_,this._commonProperties=i,this._onDidChangeEnableStates=new k.Emitter,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=c?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=c?.additionalCommonProperties,this._sender=r,this._telemetryEnablements={isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}}updateTelemetryEnablements(r,c){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:r,isErrorsEnabled:c},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(r){let c="properties"in r?r.properties??{}:r;return c=(0,D.cleanData)(c,[]),this._additionalCommonProperties&&(c=(0,g.mixin)(c,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(c=(0,g.mixin)(c,this._commonProperties)),"properties"in r?r.properties=c:r=c,r}logEvent(r,c){this._sender&&(this._extension.publisher==="vscode"?r=this._extension.name+"/"+r:r=this._extension.identifier.value+"/"+r,c=this.mixInCommonPropsAndCleanData(c||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(r,c),this._logger.trace(r,c))}logUsage(r,c){this._telemetryEnablements.isUsageEnabled&&this.logEvent(r,c)}logError(r,c){!this._telemetryEnablements.isErrorsEnabled||!this._sender||(typeof r=="string"?this.logEvent(r,c):this._sender.sendErrorData(r,c))}get apiTelemetryLogger(){if(!this._apiObject){const r=this,c={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return r._telemetryEnablements.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r._onDidChangeEnableStates.event.bind(r)};this._apiObject=Object.freeze(c)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let r=this._sender;this._sender=void 0,Promise.resolve(r.flush()).then(r=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=p;function l(t){const r=Date.now()-new Date(t).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.isNewAppInstall=l,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(Ae[26],Re([1,0,5,2,179,98,24,3]),function(te,e,m,k,C,M,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new F.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,f.createDecorator)("extensionService");class D{constructor(_){this.dependency=_}}e.MissingExtensionDependency=D;var g;(function(w){w[w.EagerAutoStart=1]="EagerAutoStart",w[w.EagerManualStart=2]="EagerManualStart",w[w.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class R{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,addActivationEvents:M.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions),myToRemove:[],myToAdd:this._myExtensions}}set(_,i){const u=[],n=[],s=[],v=[],I=y(this._allExtensions),h=y(_),T=($,K)=>$.extensionLocation.toString()===K.extensionLocation.toString()||$.isBuiltin===K.isBuiltin||$.isUserBuiltin===K.isUserBuiltin||$.isUnderDevelopment===K.isUnderDevelopment;for(const $ of this._allExtensions){const K=h.get($.identifier);if(!K){u.push($.identifier),I.delete($.identifier);continue}if(!T($,K)){u.push($.identifier),I.delete($.identifier);continue}}for(const $ of _){const K=I.get($.identifier);if(!K){n.push($);continue}if(!T(K,$)){u.push(K.identifier),I.delete(K.identifier);continue}}const S=new F.ExtensionIdentifierSet(this._myExtensions),a=new F.ExtensionIdentifierSet(i);for(const $ of this._myExtensions)a.has($)||s.push($);for(const $ of i)S.has($)||v.push($);const o=M.ImplicitActivationEvents.createActivationEventsMap(n),O={toRemove:u,toAdd:n,addActivationEvents:o,myToRemove:s,myToAdd:v};return this.delta(O),O}delta(_){const{toRemove:i,toAdd:u,myToRemove:n,myToAdd:s}=_,v=new F.ExtensionIdentifierSet(i),I=new F.ExtensionIdentifierSet(n);for(let h=0;h<this._allExtensions.length;h++)v.has(this._allExtensions[h].identifier)&&(this._allExtensions.splice(h,1),h--);for(let h=0;h<this._myExtensions.length;h++)I.has(this._myExtensions[h])&&(this._myExtensions.splice(h,1),h--);for(const h of u)this._allExtensions.push(h);for(const h of s)this._myExtensions.push(h)}containsExtension(_){for(const i of this._myExtensions)if(F.ExtensionIdentifier.equals(i,_))return!0;return!1}}e.ExtensionHostExtensions=R;function y(w){const _=new F.ExtensionIdentifierMap;for(const i of w)_.set(i.identifier,i);return _}function d(w,_){return w.enabledApiProposals?w.enabledApiProposals.includes(_):!1}e.isProposedApiEnabled=d;function E(w,_){if(!d(w,_))throw new Error(`Extension '${w.identifier.value}' CANNOT use API proposal: ${_}.
Its package.json#enabledApiProposals-property declares: ${w.enabledApiProposals?.join(", ")??"[]"} but NOT ${_}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.checkProposedApiEnabled=E;class p{constructor(_,i,u,n){this.codeLoadingTime=_,this.activateCallTime=i,this.activateResolvedTime=u,this.activationReason=n}}e.ActivationTimes=p;class l{constructor(_,i){this.description=_,this.value=i}}e.ExtensionPointContribution=l;var t;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function r(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation,targetPlatform:w.targetPlatform,validations:[],isValid:!0}}e.toExtension=r;function c(w,_){return{identifier:new F.ExtensionIdentifier((0,C.getExtensionId)(w.manifest.publisher,w.manifest.name)),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!_,extensionLocation:w.location,...w.manifest,uuid:w.identifier.uuid,targetPlatform:w.targetPlatform}}e.toExtensionDescription=c;class b{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None,this.onWillStop=m.Event.None,this.extensions=[]}activateByEvent(_){return Promise.resolve(void 0)}activationEventIsDone(_){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(_){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(_,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(_){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=b}),define(Ae[209],Re([1,0,9,106,24,26,15,16]),function(te,e,m,k,C,M,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class D{constructor(r,c,b,w){this.startup=r,this.codeLoadingTime=c,this.activateCallTime=b,this.activateResolvedTime=w}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class g{constructor(r){this._startup=r,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(r,c){return r===-1||c===-1?-1:c-r}build(){return new D(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=g;class R{constructor(r,c,b,w,_,i){this.activationFailed=r,this.activationFailedError=c,this.activationTimes=b,this.module=w,this.exports=_,this.subscriptions=i}}e.ActivatedExtension=R;class y extends R{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=y;class d extends R{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=d;class E extends R{constructor(r){super(!0,r,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=e.ExtensionsActivator=class{constructor(r,c,b,w){this._logService=w,this._registry=r,this._globalRegistry=c,this._host=b,this._operations=new C.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[r,c]of this._operations)c.dispose()}async waitForActivatingExtensions(){const r=[];for(const[c,b]of this._operations)r.push(b.wait());await Promise.all(r)}isActivated(r){const c=this._operations.get(r);return!!(c&&c.value)}getActivatedExtension(r){const c=this._operations.get(r);if(!c||!c.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return c.value}async activateByEvent(r,c){if(this._alreadyActivatedEvents[r])return;const b=this._registry.getExtensionDescriptionsForActivationEvent(r);await this._activateExtensions(b.map(w=>({id:w.identifier,reason:{startup:c,extensionId:w.identifier,activationEvent:r}}))),this._alreadyActivatedEvents[r]=!0}activateById(r,c){const b=this._registry.getExtensionDescription(r);if(!b)throw new Error(`Extension '${r}' is not known`);return this._activateExtensions([{id:b.identifier,reason:c}])}async _activateExtensions(r){const c=r.filter(b=>!this.isActivated(b.id)).map(b=>this._handleActivationRequest(b));await Promise.all(c.map(b=>b.wait()))}_handleActivationRequest(r){if(this._operations.has(r.id))return this._operations.get(r.id);if(this._isHostExtension(r.id))return this._createAndSaveOperation(r,null,[],null);const c=this._registry.getExtensionDescription(r.id);if(!c){const _=new Error(`Cannot activate unknown extension '${r.id.value}'`),i=this._createAndSaveOperation(r,null,[],new E(_));return this._host.onExtensionActivationError(r.id,_,new M.MissingExtensionDependency(r.id.value)),i}const b=[],w=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const _ of w){if(this._isResolvedExtension(_))continue;const i=this._operations.get(_);if(i){b.push(i);continue}if(this._isHostExtension(_)){b.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(_).identifier,reason:r.reason}));continue}const u=this._registry.getExtensionDescription(_);if(u){if(!u.main&&!u.browser)continue;b.push(this._handleActivationRequest({id:u.identifier,reason:r.reason}));continue}const n=c.displayName||c.identifier.value,s=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${_}'`),v=this._createAndSaveOperation(r,c.displayName,[],new E(s));return this._host.onExtensionActivationError(c.identifier,s,new M.MissingExtensionDependency(_)),v}return this._createAndSaveOperation(r,c.displayName,b,null)}_createAndSaveOperation(r,c,b,w){const _=new l(r.id,c,r.reason,b,w,this._host,this._logService);return this._operations.set(r.id,_),_}_isHostExtension(r){return k.ExtensionDescriptionRegistry.isHostExtension(r,this._registry,this._globalRegistry)}_isResolvedExtension(r){const c=this._globalRegistry.getExtensionDescription(r);return c?!c.main&&!c.browser:!1}};e.ExtensionsActivator=p=Ve([He(3,F.ILogService)],p);let l=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(r,c,b,w,_,i,u){this._id=r,this._displayName=c,this._reason=b,this._deps=w,this._value=_,this._host=i,this._logService=u,this._barrier=new f.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let r=0;r<this._deps.length;r++){const c=this._deps[r];if(c.value&&!c.value.activationFailed){this._deps.splice(r,1),r--;continue}if(c.value&&c.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);b.detail=c.value.activationFailedError,this._value=new E(b),this._host.onExtensionActivationError(this._id,b,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(r=>r.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(r){const c=new Error;if(r&&r.name&&(c.name=r.name),r&&r.message?c.message=`Activating extension '${this._id.value}' failed: ${r.message}.`:c.message=`Activating extension '${this._id.value}' failed: ${r}.`,r&&r.stack&&(c.stack=r.stack),this._value=new E(c),this._isDisposed&&m.isCancellationError(r))return;this._host.onExtensionActivationError(this._id,c,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(r)}}};l=Ve([He(6,F.ILogService)],l)}),define(Ae[210],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionOptions.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveSlashCommands.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemIcon:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemIcon.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testInvalidateResults:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testInvalidateResults.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[211],Re([1,0,164,9,29,92,74,30,24,210,174,98]),function(te,e,m,k,C,M,F,f,D,g,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const d=f.Registry.as(F.Extensions.JSONContribution);class E{constructor(_,i,u){this._messageHandler=_,this._extension=i,this._extensionPointId=u}_msg(_,i){this._messageHandler({type:_,message:i,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(_){this._msg(C.default.Error,_)}warn(_){this._msg(C.default.Warning,_)}info(_){this._msg(C.default.Info,_)}}e.ExtensionMessageCollector=E;class p{static _toSet(_){const i=new D.ExtensionIdentifierSet;for(let u=0,n=_.length;u<n;u++)i.add(_[u].description.identifier);return i}static compute(_,i){if(!_||!_.length)return new p(i,[]);if(!i||!i.length)return new p([],_);const u=this._toSet(_),n=this._toSet(i),s=i.filter(I=>!u.has(I.description.identifier)),v=_.filter(I=>!n.has(I.description.identifier));return new p(s,v)}constructor(_,i){this.added=_,this.removed=i}}e.ExtensionPointUserDelta=p;class l{constructor(_,i){this.name=_,this.defaultExtensionKind=i,this._handler=null,this._users=null,this._delta=null}setHandler(_){if(this._handler!==null)throw new Error("Handler already set!");this._handler=_,this._handle()}acceptUsers(_){this._delta=p.compute(this._users,_),this._users=_,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(_){(0,k.onUnexpectedError)(_)}}}e.ExtensionPoint=l;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[m.localize(0,null),m.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:m.localize(2,null),properties:{vscode:{type:"string",description:m.localize(3,null),default:"^1.22.0"}}},publisher:{description:m.localize(4,null),type:"string"},displayName:{description:m.localize(5,null),type:"string"},categories:{description:m.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:m.localize(7,null)}]}},galleryBanner:{type:"object",description:m.localize(8,null),properties:{color:{description:m.localize(9,null),type:"string"},theme:{description:m.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:m.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:m.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:m.localize(13,null)},enabledApiProposals:{markdownDescription:m.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:m.localize(15,null),type:"string",enum:["none"],enumDescriptions:[m.localize(16,null)]},activationEvents:{description:m.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:m.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:m.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:m.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:m.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:m.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:m.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:m.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:m.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:m.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:m.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:m.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:m.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:m.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:m.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:m.localize(32,null)},{label:"onUri",body:"onUri",description:m.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:m.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:m.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:m.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:m.localize(37,null)},{label:"onRenderer",description:m.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:m.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:m.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:m.localize(41,null)},{label:"*",description:m.localize(42,null),body:"*"}]}},badges:{type:"array",description:m.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:m.localize(44,null)},href:{type:"string",description:m.localize(45,null)},description:{type:"string",description:m.localize(46,null)}}}},markdown:{type:"string",description:m.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:m.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:m.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:m.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:m.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:m.localize(52,null)},{body:["workspace"],description:m.localize(53,null)},{body:["ui","workspace"],description:m.localize(54,null)},{body:["workspace","ui"],description:m.localize(55,null)},{body:[],description:m.localize(56,null)}]},capabilities:{description:m.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:m.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:m.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[m.localize(60,null),m.localize(61,null),m.localize(62,null)]},description:{type:"string",markdownDescription:m.localize(63,null)}}},untrustedWorkspaces:{description:m.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:m.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null)]},restrictedConfigurations:{description:m.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:m.localize(70,null)}}}}},sponsor:{description:m.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:m.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:m.localize(73,null),type:"string"},"vscode:uninstall":{description:m.localize(74,null),type:"string"}}},icon:{type:"string",description:m.localize(75,null)},l10n:{type:"string",description:m.localize(76,null)}}};class c{constructor(){this._extensionPoints=new Map}registerExtensionPoint(_){if(this._extensionPoints.has(_.extensionPoint))throw new Error("Duplicate extension point: "+_.extensionPoint);const i=new l(_.extensionPoint,_.defaultExtensionKind);return this._extensionPoints.set(_.extensionPoint,i),_.activationEventsGenerator&&y.ImplicitActivationEvents.register(_.extensionPoint,_.activationEventsGenerator),e.schema.properties.contributes.properties[_.extensionPoint]=_.jsonSchema,d.registerSchema(r,e.schema),i}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=c;const b={ExtensionsRegistry:"ExtensionsRegistry"};f.Registry.add(b.ExtensionsRegistry,new c),e.ExtensionsRegistry=f.Registry.as(b.ExtensionsRegistry),d.registerSchema(r,e.schema),d.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:m.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(Ae[212],Re([1,0,161,10,23,211,31,5]),function(te,e,m,k,C,M,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:m.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:m.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:m.localize(2,null),default:""}}};var g;(function(d){function E(p,l,t){if(!p)return;const r=k.isString(p.type)?p.type:void 0;if(!r||r.length===0){t.error(m.localize(3,null));return}const c=[];if(Array.isArray(p.required))for(const b of p.required)k.isString(b)&&c.push(b);return{extensionId:l.value,taskType:r,required:c,properties:p.properties?C.deepClone(p.properties):{},when:p.when?F.ContextKeyExpr.deserialize(p.when):void 0}}d.from=E})(g||(g={}));const R=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(d,E)=>{for(const p of d)p.type&&E.push(`onTaskType:${p.type}`)},jsonSchema:{description:m.localize(4,null),type:"array",items:D}});class y{constructor(){this._onDefinitionsChanged=new f.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((E,p)=>{R.setHandler((l,t)=>{this._schema=void 0;try{for(const r of t.removed){const c=r.value;for(const b of c)this.taskTypes&&b.type&&this.taskTypes[b.type]&&delete this.taskTypes[b.type]}for(const r of t.added){const c=r.value;for(const b of c){const w=g.from(b,r.description.identifier,r.collector);w&&(this.taskTypes[w.taskType]=w)}}(t.removed.length>0||t.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}E(void 0)})})}onReady(){return this.readyPromise}get(E){return this.taskTypes[E]}all(){return Object.keys(this.taskTypes).map(E=>this.taskTypes[E])}getJsonSchema(){if(this._schema===void 0){const E=[];for(const p of this.all()){const l={type:"object",additionalProperties:!1};p.required.length>0&&(l.required=p.required.slice(0)),p.properties!==void 0?l.properties=C.deepClone(p.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[p.taskType]},E.push(l)}this._schema={oneOf:E}}return this._schema}}e.TaskDefinitionRegistry=new y}),define(Ae[213],Re([1,0,162,10,20,23,31,212]),function(te,e,m,k,C,M,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new F.RawContextKey("taskRunning",!1,m.localize(0,null)),e.TASKS_CATEGORY={value:m.localize(1,null),original:"Tasks"};var D;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(D||(e.ShellQuoting=D={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function q(B){if(!B)return N.Strong;switch(B.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=q}(D||(e.ShellQuoting=D={}));var g;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var R;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(R||(e.RevealKind=R={})),function(N){function q(B){switch(B.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=q}(R||(e.RevealKind=R={}));var y;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(y||(e.RevealProblemKind=y={})),function(N){function q(B){switch(B.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=q}(y||(e.RevealProblemKind=y={}));var d;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(d||(e.PanelKind=d={})),function(N){function q(B){switch(B.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=q}(d||(e.PanelKind=d={}));var E;(function(N){N.defaults={echo:!0,reveal:R.Always,revealProblems:y.Never,focus:!1,panel:d.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var p;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(N){function q(U){switch(U.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=q;function B(U){switch(U){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=B}(p||(e.RuntimeType=p={}));var l;(function(N){function q(B){return k.isString(B)?B:B.value}N.value=q})(l||(e.CommandString=l={}));var t;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function q(U){return U===N.Clean._id||U===N.Build._id||U===N.Rebuild._id||U===N.Test._id}N.is=q;function B(U){if(U!==void 0)return k.isString(U)?q(U)?{_id:U,isDefault:!1}:void 0:U}N.from=B})(t||(e.TaskGroup=t={}));var r;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var c;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function q(B){switch(B){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=q})(c||(e.TaskSourceKind=c={}));var b;(function(N){N.parallel="parallel",N.sequence="sequence"})(b||(e.DependsOrder=b={}));var w;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(w||(e.RunOnOptions=w={}));var _;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:w.default,instanceLimit:1}})(_||(e.RunOptions=_={}));class i{constructor(q,B,U,le,ve,Pe){this._label="",this._id=q,B&&(this._label=B),U&&(this.type=U),this.runOptions=le,this.configurationProperties=ve,this._source=Pe}getDefinition(q){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const q={folder:this.getFolderId(),id:this._id};return JSON.stringify(q)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(q,B=!1){if(q===void 0)return!1;if(k.isString(q))return q===this._label||q===this.configurationProperties.identifier||B&&q===this._id;const U=this.getDefinition(!0);return U!==void 0&&U._key===q._key}getQualifiedLabel(){const q=this.getWorkspaceFolder();return q?`${this._label} (${q.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(q){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),q&&(this._taskLoadMessages=this._taskLoadMessages.concat(q))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=i;class u extends i{constructor(q,B,U,le,ve,Pe,J,X){super(q,U,void 0,J,X,B),this.command={},this._source=B,this.hasDefinedMatchers=Pe,ve&&(this.command=ve)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(q=!1){if(q&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case p.Shell:B="shell";break;case p.Process:B="process";break;case p.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(q){return q instanceof u}getMapKey(){const q=this._source.config.workspaceFolder;return q?`${q.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===c.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const q=this.getFolderId();if(!q)return;let B=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(B+=this._source.kind);const U={type:e.CUSTOMIZED_TASK_TYPE,folder:q,id:B};return JSON.stringify(U)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(q){return new u(q._id,q._source,q._label,q.type,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.CustomTask=u;class n extends i{constructor(q,B,U,le,ve,Pe,J){super(q,U,le,Pe,J,B),this._source=B,this.configures=ve}static is(q){return q instanceof n}fromObject(q){return q}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===c.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const q=this.getFolderId();if(!q)return;let B=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(B+=this._source.kind);const U={type:e.CUSTOMIZED_TASK_TYPE,folder:q,id:B};return JSON.stringify(U)}}e.ConfiguringTask=n;class s extends i{constructor(q,B,U,le,ve,Pe,J,X,ce){super(q,U,le,X,ce,B),this.defines=ve,this.hasDefinedMatchers=J,this.command=Pe,this.icon=ce.icon,this.hide=ce.hide}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(q){return q instanceof s}getMapKey(){const q=this._source.workspaceFolder;return q?`${this._source.scope.toString()}|${q.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const q={type:"contributed",scope:this._source.scope,id:this._id};return q.folder=this.getFolderId(),JSON.stringify(q)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(q){return new s(q._id,q._source,q._label,q.type,q.defines,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.ContributedTask=s;class v extends i{constructor(q,B,U,le,ve,Pe){super(q,U,le,ve,Pe,B),this._source=B}clone(){return new v(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(q){return q instanceof v}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(q){return new v(q._id,q._source,q._label,q.type,q.runOptions,q.configurationProperties)}}e.InMemoryTask=v;var I;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(I||(e.ExecutionEngine=I={})),function(N){N._default=N.Terminal}(I||(e.ExecutionEngine=I={}));var h;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(h||(e.JsonSchemaVersion=h={}));class T{constructor(q){this._order=new Map;for(let B=0;B<q.length;B++)this._order.set(q[B].uri.toString(),B)}compare(q,B){const U=q.getWorkspaceFolder(),le=B.getWorkspaceFolder();if(U&&le){let ve=this._order.get(U.uri.toString());ve=ve===void 0?0:ve+1;let Pe=this._order.get(le.uri.toString());return Pe=Pe===void 0?0:Pe+1,ve===Pe?q._label.localeCompare(B._label):ve-Pe}else return!U&&le?-1:U&&!le?1:0}}e.TaskSorter=T;var S;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(S||(e.TaskEventKind=S={}));var a;(function(N){N.SingleRun="singleRun",N.Background="background"})(a||(e.TaskRunType=a={}));var o;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(o||(e.TaskRunSource=o={}));var O;(function(N){function q(B,U,le,ve){if(U){const Pe={kind:B,taskId:U._id,taskName:U.configurationProperties.name,runType:U.configurationProperties.isBackground?"background":"singleRun",group:U.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:le,__task:U};return B==="start"?Pe.resolvedVariables=ve:B==="processStarted"?Pe.processId=ve:B==="processEnded"&&(Pe.exitCode=ve),Object.freeze(Pe)}else return Object.freeze({kind:"changed"})}N.create=q})(O||(e.TaskEvent=O={}));var $;(function(N){function q(U){const le=Object.keys(U).sort();let ve="";for(const Pe of le){let J=U[Pe];J instanceof Object?J=q(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),ve+=Pe+","+J+","}return ve}function B(U){const ve={_key:q(U),type:U.taskType};return Object.assign(ve,U),ve}N.create=B})($||(e.KeyedTaskIdentifier=$={}));var K;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(K||(e.TaskSettingId=K={}));var V;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var z;(function(N){function q(B,U){const le=f.TaskDefinitionRegistry.get(B.type);if(le===void 0){const X=M.deepClone(B);return delete X._key,$.create(X)}const ve=Object.create(null);ve.type=le.taskType;const Pe=new Set;le.required.forEach(X=>Pe.add(X));const J=le.properties;for(const X of Object.keys(J)){const ce=B[X];if(ce!=null)ve[X]=ce;else if(Pe.has(X)){const De=J[X];if(De.default!==void 0)ve[X]=M.deepClone(De.default);else switch(De.type){case"boolean":ve[X]=!1;break;case"number":case"integer":ve[X]=0;break;case"string":ve[X]="";break;default:U.error(m.localize(2,null,JSON.stringify(B,void 0,0),X));return}}}return $.create(ve)}N.createTaskIdentifier=q})(z||(e.TaskDefinition=z={}))}),define(Ae[214],Re([1,0,9]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class k{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((F,f)=>{this._actualOk=F,this._actualErr=f,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(F){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=F,this._actual&&this._actualOk(F))}resolveErr(F){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=F,this._actual?this._actualErr(F):(0,m.onUnexpectedError)(F))}then(F,f){return this._ensureActual().then(F,f)}catch(F){return this._ensureActual().then(void 0,F)}finally(F){return this._ensureActual().finally(F)}}e.LazyPromise=k;class C extends k{constructor(){super(),this._hasErr=!0,this._err=new m.CancellationError}}e.CanceledLazyPromise=C}),define(Ae[46],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const k=[];function C(f){const D=new m(f);return k[D.nid]=D,D}e.createProxyIdentifier=C;function M(f){return k[f].sid}e.getStringIdentifierForProxy=M;class F{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=F}),define(Ae[4],Re([1,0,46]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var k;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(k||(e.TextEditorRevealType=k={}));var C;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var M;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var F;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(F||(e.WebviewEditorCapabilities=F={}));var f;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(f||(e.WebviewMessageArrayBufferViewType=f={}));var D;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(D||(e.CellOutputKind=D={}));var g;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var R;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class y{static mixin(t){return t._id=y._n++,t}}e.IdObject=y,y._n=0;var d;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.kindModifier="m",l.commandIdent="n",l.commandId="o",l.commandArguments="p"})(d||(e.ISuggestDataDtoField=d={}));var E;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var p;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.MainContext={MainThreadAuthentication:(0,m.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,m.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,m.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,m.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,m.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,m.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,m.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,m.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,m.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,m.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,m.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,m.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,m.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,m.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,m.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,m.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,m.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,m.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,m.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,m.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,m.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,m.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,m.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,m.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,m.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,m.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,m.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,m.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,m.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,m.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,m.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,m.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,m.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,m.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,m.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,m.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,m.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,m.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,m.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,m.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,m.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,m.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,m.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,m.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,m.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,m.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,m.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,m.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,m.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,m.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,m.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,m.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,m.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,m.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,m.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,m.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,m.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,m.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,m.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,m.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,m.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,m.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,m.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,m.createProxyIdentifier)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,m.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,m.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,m.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,m.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,m.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,m.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,m.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,m.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,m.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,m.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,m.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,m.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,m.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,m.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,m.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,m.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,m.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,m.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,m.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,m.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,m.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,m.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,m.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,m.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,m.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,m.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,m.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,m.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,m.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,m.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,m.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,m.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,m.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,m.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,m.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,m.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,m.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,m.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,m.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,m.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,m.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,m.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,m.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,m.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,m.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,m.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,m.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,m.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,m.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,m.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,m.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,m.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,m.createProxyIdentifier)("ExtHostChat"),ExtHostSemanticSimilarity:(0,m.createProxyIdentifier)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,m.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,m.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,m.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,m.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,m.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,m.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,m.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,m.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,m.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Ae[81],Re([1,0,3,15,4,17]),function(te,e,m,k,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let F=e.ExtHostApiDeprecationService=class{constructor(D,g){this._extHostLogService=g,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(C.MainContext.MainThreadTelemetry)}report(D,g,R){const y=this.getUsageKey(D,g);this._reportedUsages.has(y)||(this._reportedUsages.add(y),g.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:D}))}getUsageKey(D,g){return`${D}-${g.identifier.value}`}};e.ExtHostApiDeprecationService=F=Ve([He(0,M.IExtHostRpcService),He(1,k.ILogService)],F),e.NullApiDeprecationService=Object.freeze(new class{report(f,D,g){}})}),define(Ae[215],Re([1,0,5,4,7,24]),function(te,e,m,k,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class F{constructor(g){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new f,this._getSessionsTaskSingler=new f,this._proxy=g.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(g){return this._providers=g,Promise.resolve()}async getSession(g,R,y,d={}){const E=M.ExtensionIdentifier.toKey(g.identifier),p=[...y].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${E} ${R} ${p}`,async()=>{await this._proxy.$ensureProvider(R);const l=g.displayName||g.name;return this._proxy.$getSession(R,y,E,l,d)})}async getSessions(g,R,y){const d=M.ExtensionIdentifier.toKey(g.identifier),E=[...y].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${d} ${E}`,async()=>{await this._proxy.$ensureProvider(R);const p=g.displayName||g.name;return this._proxy.$getSessions(R,y,d,p)})}async removeSession(g,R){const y=this._authenticationProviders.get(g);return y?y.provider.removeSession(R):this._proxy.$removeSession(g,R)}registerAuthenticationProvider(g,R,y,d){if(this._authenticationProviders.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this._authenticationProviders.set(g,{label:R,provider:y,options:d??{supportsMultipleAccounts:!1}}),this._providers.find(p=>p.id===g)||this._providers.push({id:g,label:R});const E=y.onDidChangeSessions(p=>{this._proxy.$sendDidChangeSessions(g,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this._proxy.$registerAuthenticationProvider(g,R,d?.supportsMultipleAccounts??!1),new C.Disposable(()=>{E.dispose(),this._authenticationProviders.delete(g);const p=this._providers.findIndex(l=>l.id===g);p>-1&&this._providers.splice(p),this._proxy.$unregisterAuthenticationProvider(g)})}$createSession(g,R,y){const d=this._authenticationProviders.get(g);if(d)return Promise.resolve(d.provider.createSession(R,y));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,R){const y=this._authenticationProviders.get(g);if(y)return Promise.resolve(y.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,R){const y=this._authenticationProviders.get(g);if(y)return Promise.resolve(y.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,R){return this._onDidChangeSessions.fire({provider:{id:g,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=F;class f{constructor(){this._inFlightPromises=new Map}getOrCreate(g,R){const y=this._inFlightPromises.get(g);if(y)return y;const d=R().finally(()=>this._inFlightPromises.delete(g));return this._inFlightPromises.set(g,d),d}}}),define(Ae[216],Re([1,0,4,17,8]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=e.ExtHostBulkEdits=class{constructor(f,D){this._proxy=f.getProxy(m.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:g=>D.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(f,D,g){const R=C.WorkspaceEdit.from(f,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(R,void 0,g?.isRefactoring??!1)}};e.ExtHostBulkEdits=M=Ve([He(0,k.IExtHostRpcService)],M)}),define(Ae[217],Re([1,0,5,67,6,58,10,146,4,8]),function(te,e,m,k,C,M,F,f,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class R{constructor(E,p){this.extension=E,this.provider=p,this.handle=R._pool++}}R._pool=0;class y{constructor(E,p){this.logService=p,this._chatProvider=new Map,this._slashCommandProvider=new Map,this._chatSessions=new Map,this._onDidPerformUserAction=new m.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=E.getProxy(D.MainContext.MainThreadChat)}registerChatProvider(E,p,l){const t=new R(E,l);return this._chatProvider.set(t.handle,t),this._proxy.$registerChatProvider(t.handle,p),(0,C.toDisposable)(()=>{this._proxy.$unregisterChatProvider(t.handle),this._chatProvider.delete(t.handle)})}transferChatSession(E,p){const l=k.Iterable.find(this._chatSessions.keys(),t=>this._chatSessions.get(t)===E)??0;typeof l=="number"&&this._proxy.$transferChatSession(l,p)}addChatRequest(E){this._proxy.$addRequest(E)}sendInteractiveRequestToProvider(E,p){this._proxy.$sendRequestToProvider(E,p)}async $prepareChat(E,p,l){const t=this._chatProvider.get(E);if(!t)return;const r=await t.provider.prepareSession(p,l);if(!r)return;const c=y._nextId++;return this._chatSessions.set(c,r),{id:c,requesterUsername:r.requester?.name,requesterAvatarIconUri:r.requester?.icon,responderUsername:r.responder?.name,responderAvatarIconUri:r.responder?.icon,inputPlaceholder:r.inputPlaceholder}}async $resolveRequest(E,p,l,t){const r=this._chatProvider.get(E);if(!r)return;const c=this._chatSessions.get(p);if(!c||!r.provider.resolveRequest)return;const b=await r.provider.resolveRequest(c,l,t);if(b)return{message:typeof b.message=="string"?b.message:g.ChatReplyFollowup.from(b.message)}}async $provideWelcomeMessage(E,p){const l=this._chatProvider.get(E);if(!l||!l.provider.provideWelcomeMessage)return;const t=await l.provider.provideWelcomeMessage(p);if(t)return t.map(r=>typeof r=="string"?r:r.map(c=>g.ChatReplyFollowup.from(c)))}async $provideFollowups(E,p,l){const t=this._chatProvider.get(E);if(!t)return;const r=this._chatSessions.get(p);return!r||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(r,l))?.map(b=>g.ChatFollowup.from(b))}$removeRequest(E,p,l){const t=this._chatProvider.get(E);if(!t)return;const r=this._chatSessions.get(p);r&&t.provider.removeRequest&&t.provider.removeRequest(r,l)}async $provideReply(E,p,l,t){const r=this._chatProvider.get(E);if(!r)return;const c=this._chatSessions.get(p);if(!c)return;const b={session:c,message:typeof l.message=="string"?l.message:g.ChatReplyFollowup.to(l.message)},w=M.StopWatch.create(!1);let _;const i={report:s=>{if(t.isCancellationRequested)return;typeof _>"u"&&(_=w.elapsed());const v="responseId"in s?{requestId:s.responseId}:s;this._proxy.$acceptResponseProgress(E,p,v)}};let u;try{u=await r.provider.provideResponseWithProgress(b,i,t),u||(u={errorDetails:{message:(0,f.localize)(0,null)}})}catch(s){u={errorDetails:{message:(0,f.localize)(1,null,s.message),responseIsIncomplete:!0}},this.logService.error(s)}try{if(c.saveState&&this._chatSessions.has(p)){const s=c.saveState();this._proxy.$acceptChatState(p,s)}}catch(s){this.logService.warn(s)}const n={firstProgress:_??0,totalElapsed:w.elapsed()};return{errorDetails:u.errorDetails,timings:n}}async $provideSlashCommands(E,p,l){const t=this._chatProvider.get(E);if(!t)return;const r=this._chatSessions.get(p);return!r||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(r,l))?.map(b=>({...b,kind:g.CompletionItemKind.from(b.kind)}))}$releaseSession(E){this._chatSessions.delete(E)}async $onDidPerformUserAction(E){this._onDidPerformUserAction.fire(E)}registerSlashCommandProvider(E,p,l){const t=new R(E,l);return this._slashCommandProvider.set(t.handle,t),this._proxy.$registerSlashCommandProvider(t.handle,p),(0,C.toDisposable)(()=>{this._proxy.$unregisterSlashCommandProvider(t.handle),this._slashCommandProvider.delete(t.handle)})}async $provideProviderSlashCommands(E,p){const l=this._slashCommandProvider.get(E);return l?(await l.provider.provideSlashCommands(p))?.map(r=>({...r,kind:g.CompletionItemKind.from(r.kind)})):void 0}async $resolveSlashCommand(E,p,l){const t=this._slashCommandProvider.get(E);if(!t)return;const r=await t.provider.resolveSlashCommand(p,l);return(0,F.withNullAsUndefined)(r)}}e.ExtHostChat=y,y._nextId=0}),define(Ae[218],Re([1,0,4]),function(te,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(M){const F=M.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return F.$readText()},writeText(f){return F.$writeText(f)}})}}e.ExtHostClipboard=k});var Xe=this&&this.__classPrivateFieldSet||function(te,e,m,k,C){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?C.call(te,m):C?C.value=m:e.set(te,m),m},Fe=this&&this.__classPrivateFieldGet||function(te,e,m,k){if(m==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?k:m==="a"?k.call(te):k?k.value:e.get(te)};define(Ae[32],Re([1,0,10,7,8,23,4,18,15,69,44,272,2,6,3,17,104,25,46,41,58,52,57]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l,t,r,c,b,w,_,i){"use strict";var u,n,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let v=e.ExtHostCommands=class{constructor(o,O,$){u.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,n.set(this,void 0),s.set(this,void 0),Xe(this,u,o.getProxy(F.MainContext.MainThreadCommands),"f"),this._logService=O,Xe(this,s,$,"f"),Xe(this,n,o.getProxy(F.MainContext.MainThreadTelemetry),"f"),this.converter=new I(this,K=>{const V=this._apiCommands.get(K);return V?.result===T.Void?V:void 0},O),this._argumentProcessors=[{processArgument(K){return(0,g.revive)(K)}},{processArgument(K){return(0,M.cloneAndChange)(K,function(V){if(R.Range.isIRange(V))return C.Range.to(V);if(y.Position.isIPosition(V))return C.Position.to(V);if(R.Range.isIRange(V.range)&&d.URI.isUri(V.uri))return C.location.to(V);if(V instanceof r.VSBuffer)return V.buffer.buffer;if(!Array.isArray(V))return V})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const O=this.registerCommand(!1,o.id,async(...$)=>{const K=o.args.map((z,N)=>{if(!z.validate($[N]))throw new Error(`Invalid argument '${z.name}' when running '${o.id}', received: ${$[N]}`);return z.convert($[N])}),V=await this.executeCommand(o.internalId,...K);return o.result.convert(V,$,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new k.Disposable(()=>{O.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,O,$,K,V,z){if(this._logService.trace("ExtHostCommands#registerCommand",O),!O.trim().length)throw new Error("invalid id");if(this._commands.has(O))throw new Error(`command '${O}' already exists`);return this._commands.set(O,{callback:$,thisArg:K,description:V,extension:z}),o&&Fe(this,u,"f").$registerCommand(O),new k.Disposable(()=>{this._commands.delete(O)&&o&&Fe(this,u,"f").$unregisterCommand(O)})}executeCommand(o,...O){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,O,!0)}async _doExecuteCommand(o,O,$){if(this._commands.has(o))return Fe(this,u,"f").$fireCommandActivationEvent(o),this._executeContributedCommand(o,O,!1);{let K=!1;const V=(0,M.cloneAndChange)(O,function(z){if(z instanceof k.Position)return C.Position.from(z);if(z instanceof k.Range)return C.Range.from(z);if(z instanceof k.Location)return C.location.from(z);if(k.NotebookRange.isNotebookRange(z))return C.NotebookRange.from(z);if(z instanceof ArrayBuffer)return K=!0,r.VSBuffer.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return K=!0,r.VSBuffer.wrap(z);if(z instanceof r.VSBuffer)return K=!0,z;if(!Array.isArray(z))return z});try{const z=await Fe(this,u,"f").$executeCommand(o,K?new c.SerializableObjectWithBuffers(V):V,$);return(0,g.revive)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this._doExecuteCommand(o,O,!1);throw z}}}async _executeContributedCommand(o,O,$){const K=this._commands.get(o);if(!K)throw new Error("Unknown command");const{callback:V,thisArg:z,description:N}=K;if(N)for(let B=0;B<N.args.length;B++)try{(0,m.validateConstraint)(O[B],N.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${N.args[B].name}' - ${N.args[B].description}`)}const q=w.StopWatch.create();try{return await V.apply(z,O)}catch(B){if(o===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...O);U&&(o=U.command)}if(this._logService.error(B,o,K.extension?.identifier),!$)throw B;if(K.extension?.identifier){const U=Fe(this,s,"f").onExtensionError(K.extension.identifier,B);this._logService.trace("forwarded error to extension?",U,K.extension?.identifier)}throw new class extends Error{constructor(){super((0,b.toErrorMessage)(B)),this.id=o,this.source=K.extension?.displayName??K.extension?.name}}}finally{this._reportTelemetry(K,o,q.elapsed())}}_reportTelemetry(o,O,$){o.extension&&Fe(this,n,"f").$publicLog2("Extension:ActionExecuted",{extensionId:o.extension.identifier.value,id:new _.TelemetryTrustedValue(O),duration:$})}$executeContributedCommand(o,...O){this._logService.trace("ExtHostCommands#$executeContributedCommand",o);const $=this._commands.get(o);return $?(O=O.map(K=>this._argumentProcessors.reduce((V,z)=>z.processArgument(V,$.extension?.identifier),K)),this._executeContributedCommand(o,O,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),Fe(this,u,"f").$getCommands().then(O=>(o&&(O=O.filter($=>$[0]!=="_")),O))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(const[O,$]of this._commands){const{description:K}=$;K&&(o[O]=K)}return Promise.resolve(o)}};u=new WeakMap,n=new WeakMap,s=new WeakMap,e.ExtHostCommands=v=Ve([He(0,l.IExtHostRpcService),He(1,D.ILogService),He(2,i.IExtHostTelemetry)],v),e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class I{constructor(o,O,$){this._commands=o,this._lookupApiCommand=O,this._logService=$,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,O){if(!o)return;const $={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return $;const K=this._lookupApiCommand(o.command);if(K)$.id=K.internalId,$.arguments=K.args.map((V,z)=>V.convert(o.arguments&&o.arguments[z]));else if((0,f.isNonEmptyArray)(o.arguments)){const V=`${o.command}/${++this._cachIdPool}`;this._cache.set(V,o),O.add((0,E.toDisposable)(()=>{this._cache.delete(V),this._logService.trace("CommandsConverter#DISPOSE",V)})),$.$ident=V,$.id=this.delegatingCommandId,$.arguments=[V],this._logService.trace("CommandsConverter#CREATE",o.command,V)}return $}fromInternal(o){return typeof o.$ident=="string"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const O=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],O?O.command:"MISSING"),O?this._commands.executeCommand(O.command,...O.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${o[0]}`)}}e.CommandsConverter=I;class h{constructor(o,O,$,K){this.name=o,this.description=O,this.validate=$,this.convert=K}optional(){return new h(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,O){return new h(o??this.name,O??this.description,this.validate,this.convert)}}e.ApiCommandArgument=h,h.Uri=new h("uri","Uri of a text document",a=>d.URI.isUri(a),a=>a),h.Position=new h("position","A position in a text document",a=>k.Position.isPosition(a),C.Position.from),h.Range=new h("range","A range in a text document",a=>k.Range.isRange(a),C.Range.from),h.Selection=new h("selection","A selection in a text document",a=>k.Selection.isSelection(a),C.Selection.from),h.Number=new h("number","",a=>typeof a=="number",a=>a),h.String=new h("string","",a=>typeof a=="string",a=>a),h.CallHierarchyItem=new h("item","A call hierarchy item",a=>a instanceof k.CallHierarchyItem,C.CallHierarchyItem.from),h.TypeHierarchyItem=new h("item","A type hierarchy item",a=>a instanceof k.TypeHierarchyItem,C.TypeHierarchyItem.from),h.TestItem=new h("testItem","A VSCodium TestItem",a=>a instanceof t.TestItemImpl,C.TestItem.from);class T{constructor(o,O){this.description=o,this.convert=O}}e.ApiCommandResult=T,T.Void=new T("no result",a=>a);class S{constructor(o,O,$,K,V){this.id=o,this.internalId=O,this.description=$,this.args=K,this.result=V}}e.ApiCommand=S}),define(Ae[219],Re([1,0,18,14,2,79,91,31,95,32,8,7]),function(te,e,m,k,C,M,F,f,D,g,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const d=[new g.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",p(R.DocumentHighlight.to))),new g.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,r)=>{if((0,m.isFalsyOrEmpty)(t))return;class c extends y.SymbolInformation{static to(w){const _=new c(w.name,R.SymbolKind.to(w.kind),w.containerName||"",new y.Location(r[0],R.Range.to(w.range)));return _.detail=w.detail,_.range=_.location.range,_.selectionRange=R.Range.to(w.selectionRange),_.children=w.children?w.children.map(c.to):[],_}}return t.map(c.to)})),new g.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(R.TextEdit.to))),new g.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range,new g.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(R.TextEdit.to))),new g.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,new g.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new g.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(R.TextEdit.to))),new g.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new g.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new g.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new g.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new g.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location-instances.",p(R.location.to))),new g.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Hover-instances.",p(R.Hover.to))),new g.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(r=>y.Position.isPosition(r)),t=>t.map(R.Position.from))],new g.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(r=>{let c;for(const b of r.reverse())c=new y.SelectionRange(R.Range.to(b),c);return c}))),new g.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.ApiCommandArgument.String.with("query","Search string")],new g.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(R.WorkspaceSymbol.to))),new g.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(R.CallHierarchyItem.to))),new g.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.ApiCommandArgument.CallHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(R.CallHierarchyIncomingCall.to))),new g.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.ApiCommandArgument.CallHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(R.CallHierarchyOutgoingCall.to))),new g.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:R.Range.to(t.range),placeholder:t.text}})),new g.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("newName","The new symbol name")],new g.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return R.WorkspaceEdit.to(t)}})),new g.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(R.DocumentLink.to))),new g.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new y.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new g.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const r=(0,F.decodeSemanticTokensDto)(t);if(r.type==="full")return new y.SemanticTokens(r.data,void 0)})),new g.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range.optional()],new g.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new y.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new g.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const r=(0,F.decodeSemanticTokensDto)(t);if(r.type==="full")return new y.SemanticTokens(r.data,void 0)})),new g.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,r,c)=>{if(!t)return new y.CompletionList([]);const b=t.suggestions.map(w=>R.CompletionItem.to(w,c));return new y.CompletionList(b,t.incomplete)})),new g.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return R.SignatureHelp.to(t)})),new g.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,r,c)=>p(b=>new y.CodeLens(R.Range.to(b.range),b.command&&c.fromInternal(b.command)))(t))),new g.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>y.Range.isRange(t),t=>y.Selection.isSelection(t)?R.Selection.from(t):R.Range.from(t)),g.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),g.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,r,c)=>p(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(b.command)}else{const w=new y.CodeAction(b.title,b.kind?new y.CodeActionKind(b.kind):void 0);return b.edit&&(w.edit=R.WorkspaceEdit.to(b.edit)),b.command&&(w.command=c.fromInternal(b.command)),w.isPreferred=b.isPreferred,w}})(t))),new g.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(r=>new y.ColorInformation(R.Range.to(r.range),R.Color.to(r.color))):[])),new g.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.ApiCommandArgument("color","The color to show and insert",t=>t instanceof y.Color,R.Color.from),new g.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:R.Range.from(t.range)}))],new g.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(R.ColorPresentation.to):[])),new g.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,r,c)=>t.map(R.InlayHint.to.bind(void 0,c)))),new g.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(t,r)=>{if(t)return t.map(R.FoldingRange.to)})),new g.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(r=>R.NotebookExclusiveDocumentPattern.to(r))})))),new g.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(R.InlineValue.to))),new g.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,D.matchesSomeScheme)(t,k.Schemas.http,k.Schemas.https),t=>t),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional(),g.ApiCommandArgument.String.with("label","").optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.ApiCommandArgument.Uri.with("resource","Resource to open"),g.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VSCodium's default editor"),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),g.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),g.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)]).optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new g.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.ApiCommandArgument.TypeHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new g.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.ApiCommandArgument.TypeHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new g.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.ApiCommandArgument.TestItem],g.ApiCommandResult.Void),new g.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.ApiCommandResult.Void),new g.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.ApiCommandArgument.String.with("name","The context key name"),new g.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],g.ApiCommandResult.Void)];class E{static register(r){d.forEach(r.registerApiCommand,r),this._registerValidateWhenClausesCommand(r)}static _registerValidateWhenClausesCommand(r){r.registerCommand(!1,"_validateWhenClauses",f.validateWhenClauses)}}e.ExtHostApiCommands=E;function p(t){return r=>{if(Array.isArray(r))return r.map(t)}}function l(t){if(!Array.isArray(t))return;const r=[];for(const c of t)M.isLocationLink(c)?r.push(R.DefinitionLink.to(c)):r.push(R.location.to(c));return r}}),define(Ae[220],Re([1,0,16,65,5,6,2,79,24,8,7,4,26,10]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function p(l,t,r){const c=l.getProxy(y.MainContext.MainThreadComments);class b{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new D.ExtensionIdentifierMap,t.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const T=this._commentControllers.get(h.handle);return T?T.value:h}else if(h&&h.$mid===7){const T=this._commentControllers.get(h.commentControlHandle);if(!T)return h;const S=T.getCommentThread(h.commentThreadHandle);return S?S.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const T=this._commentControllers.get(h.thread.commentControlHandle);if(!T)return h;const S=T.getCommentThread(h.thread.commentThreadHandle);return S?h.$mid===8?S.value:{thread:S.value,text:h.text}:h}else if(h&&h.$mid===10){const T=this._commentControllers.get(h.thread.commentControlHandle);if(!T)return h;const S=T.getCommentThread(h.thread.commentThreadHandle);if(!S)return h;const a=h.commentUniqueId,o=S.getCommentByUniqueId(a);return o||h}else if(h&&h.$mid===11){const T=this._commentControllers.get(h.thread.commentControlHandle);if(!T)return h;const S=T.getCommentThread(h.thread.commentThreadHandle);if(!S)return h;const a=h.text,o=h.commentUniqueId,O=S.getCommentByUniqueId(o);return O?(typeof O.body=="string"?O.body=a:O.body=new R.MarkdownString(a),O):h}return h}})}createCommentController(h,T,S){const a=b.handlePool++,o=new _(h,a,T,S);this._commentControllers.set(o.handle,o);const O=this._commentControllersByExtension.get(h.identifier)||[];return O.push(o),this._commentControllersByExtension.set(h.identifier,O),o.value}$createCommentThreadTemplate(h,T,S){const a=this._commentControllers.get(h);a&&a.$createCommentThreadTemplate(T,S)}async $updateCommentThreadTemplate(h,T,S){const a=this._commentControllers.get(h);a&&a.$updateCommentThreadTemplate(T,S)}$deleteCommentThread(h,T){this._commentControllers.get(h)?.$deleteCommentThread(T)}$provideCommentingRanges(h,T,S){const a=this._commentControllers.get(h);if(!a||!a.commentingRangeProvider)return Promise.resolve(void 0);const o=r.getDocument(F.URI.revive(T));return(0,m.asPromise)(async()=>{const O=await a.commentingRangeProvider.provideCommentingRanges(o,S);let $;return Array.isArray(O)?$={ranges:O,fileComments:!1}:O?$={ranges:O.ranges||[],fileComments:O.fileComments||!1}:$=(0,E.withNullAsUndefined)(O),$}).then(O=>{let $;return O&&($={ranges:O.ranges.map(K=>g.Range.from(K)),fileComments:O.fileComments}),$})}$toggleReaction(h,T,S,a,o){const O=this._commentControllers.get(h);return!O||!O.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const $=O.getCommentThread(T);if($){const K=$.getCommentByUniqueId(a.uniqueIdInThread);if(O!==void 0&&K&&O.reactionHandler)return O.reactionHandler(K,n(o))}return Promise.resolve(void 0)})}}b.handlePool=0;class w{set threadId(h){this._id=h}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(h){(h===void 0!=(this._range===void 0)||!h||!this._range||!h.isEqual(this._range))&&(this._range=h,this.modifications.range=h,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(h){this._canReply!==h&&(this._canReply=h,this.modifications.canReply=h,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(h){this._label=h,this.modifications.label=h,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(h){this._contextValue=h,this.modifications.contextValue=h,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(h){this._comments=h,this.modifications.comments=h,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(h){this._collapseState=h,this.modifications.collapsibleState=h,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(h){this._state=h,this.modifications.state=h,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(h,T,S,a,o,O,$,K){this._commentControllerHandle=T,this._id=S,this._uri=a,this._range=o,this._comments=O,this.extensionDescription=$,this._isTemplate=K,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputDisposables.value=new M.DisposableStore,this._id===void 0&&(this._id=`${h}.${this.handle}`),c.$createCommentThread(T,this.handle,this._id,this._uri,g.Range.from(this._range),$.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=O,this._localDisposables.push({dispose:()=>{c.$deleteCommentThread(T,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(z){V.range=z},get comments(){return V.comments},set comments(z){V.comments=z},get collapsibleState(){return V.collapsibleState},set collapsibleState(z){V.collapsibleState=z},get canReply(){return V.canReply},set canReply(z){V.canReply=z},get contextValue(){return V.contextValue},set contextValue(z){V.contextValue=z},get label(){return V.label},set label(z){V.label=z},get state(){return V.state},set state(z){V.state=z},dispose:()=>{V.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new M.DisposableStore);const h=S=>Object.prototype.hasOwnProperty.call(this.modifications,S),T={};h("range")&&(T.range=g.Range.from(this._range)),h("label")&&(T.label=this.label),h("contextValue")&&(T.contextValue=this.contextValue??null),h("comments")&&(T.comments=this._comments.map(S=>i(this,S,this._commentsMap,this.extensionDescription))),h("collapsibleState")&&(T.collapseState=s(this._collapseState)),h("canReply")&&(T.canReply=this.canReply),h("state")&&(T.state=v(this._state)),h("isTemplate")&&(T.isTemplate=this._isTemplate),this.modifications={},c.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,T)}getCommentByUniqueId(h){for(const T of this._commentsMap){const S=T[0],a=T[1];if(h===a)return S}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(h=>h.dispose())}}w._handlePool=0,Ve([(0,k.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class _{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(h){this._commentingRangeProvider=h,c.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(h){this._reactionHandler=h,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this._options}set options(h){this._options=h,c.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(h,T,S,a){this._extension=h,this._handle=T,this._id=S,this._label=a,this._threads=new Map,c.$registerCommentController(this.handle,S,a);const o=this;this.value=Object.freeze({id:o.id,label:o.label,get options(){return o.options},set options(O){o.options=O},get commentingRangeProvider(){return o.commentingRangeProvider},set commentingRangeProvider(O){o.commentingRangeProvider=O},get reactionHandler(){return o.reactionHandler},set reactionHandler(O){o.reactionHandler=O},createCommentThread(O,$,K){return o.createCommentThread(O,$,K).value},dispose:()=>{o.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(h,T,S){T===void 0&&(0,d.checkProposedApiEnabled)(this._extension,"fileComments");const a=new w(this.id,this.handle,void 0,h,T,S,this._extension,!1);return this._threads.set(a.handle,a),a}$createCommentThreadTemplate(h,T){const S=new w(this.id,this.handle,void 0,F.URI.revive(h),g.Range.to(T),[],this._extension,!0);return S.collapsibleState=f.CommentThreadCollapsibleState.Expanded,this._threads.set(S.handle,S),S}$updateCommentThreadTemplate(h,T){const S=this._threads.get(h);S&&(S.range=g.Range.to(T))}$deleteCommentThread(h){this._threads.get(h)?.dispose(),this._threads.delete(h)}getCommentThread(h){return this._threads.get(h)}dispose(){this._threads.forEach(h=>{h.dispose()}),this._localDisposables.forEach(h=>h.dispose())}}function i(I,h,T,S){let a=T.get(h);return a||(a=++I.commentHandle,T.set(h,a)),h.state!==void 0&&(0,d.checkProposedApiEnabled)(S,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:a,body:typeof h.body=="string"?h.body:g.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(o=>u(o)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function u(I){return{label:I.label,iconPath:I.iconPath?g.pathOrURIToURI(I.iconPath):void 0,count:I.count,hasReacted:I.authorHasReacted}}function n(I){return{label:I.label||"",count:I.count||0,iconPath:I.iconPath?F.URI.revive(I.iconPath):"",authorHasReacted:I.hasReacted||!1}}function s(I){if(I!==void 0)switch(I){case R.CommentThreadCollapsibleState.Expanded:return f.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return f.CommentThreadCollapsibleState.Collapsed}return f.CommentThreadCollapsibleState.Collapsed}function v(I){if(I!==void 0)switch(I){case R.CommentThreadState.Unresolved:return f.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return f.CommentThreadState.Resolved}return f.CommentThreadState.Unresolved}return new b}e.createExtHostComments=p}),define(Ae[221],Re([1,0,23,4,27,17]),function(te,e,m,k,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let F=e.AbstractExtHostConsoleForwarder=class{constructor(R,y){this._mainThreadConsole=R.getProxy(k.MainContext.MainThreadConsole),this._includeStack=y.consoleForward.includeStack,this._logNative=y.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,y){const d=this,E=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){d._handleConsoleCall(R,y,E,arguments)}})}_handleConsoleCall(R,y,d,E){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:y,arguments:D(E,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,d,E)}};e.AbstractExtHostConsoleForwarder=F=Ve([He(0,M.IExtHostRpcService),He(1,C.IExtHostInitDataService)],F);const f=1e5;function D(g,R){const y=[];if(g.length)for(let d=0;d<g.length;d++){let E=g[d];if(typeof E>"u")E="undefined";else if(E instanceof Error){const p=E;p.stack?E=p.stack:E=p.toString()}y.push(E)}if(R){const d=new Error().stack;d&&y.push({__$stack:d.split(`
`).slice(3).join(`
`)})}try{const d=(0,m.safeStringify)(y);return d.length>f?"Output omitted for a large object that exceeds the limits":d}catch(d){return`Output omitted for an object that cannot be inspected ('${d.toString()}')`}}}),define(Ae[107],Re([1,0,2,4,7,3,17,15,18,13,19,26]),function(te,e,m,k,C,M,F,f,D,g,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let d=e.ExtHostDecorations=class on{constructor(p,l){this._logService=l,this._provider=new Map,this._proxy=p.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,l){const t=on._handlePool++;this._provider.set(t,{provider:p,extensionDescription:l}),this._proxy.$registerDecorationProvider(t,l.identifier.value);const r=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(c=>{if(!c){this._proxy.$onDidChange(t,null);return}const b=(0,D.asArray)(c);if(b.length<=on._maxEventSize){this._proxy.$onDidChange(t,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.identifier.value,b.length);const w=b.map(u=>({uri:u,rank:(0,g.count)(u.path,"/")})),_=(0,D.groupBy)(w,(u,n)=>u.rank-n.rank||(0,g.compare)(u.uri.path,n.uri.path)),i=[];e:for(const u of _){let n;for(const s of u){const v=(0,R.dirname)(s.uri.path);if(n!==v&&(n=v,i.push(s.uri)>=on._maxEventSize))break e}}this._proxy.$onDidChange(t,i)});return new C.Disposable(()=>{r?.dispose(),this._proxy.$unregisterDecorationProvider(t),this._provider.delete(t)})}async $provideDecorations(p,l,t){if(!this._provider.has(p))return Object.create(null);const r=Object.create(null),{provider:c,extensionDescription:b}=this._provider.get(p);return await Promise.all(l.map(async w=>{try{const{uri:_,id:i}=w,u=await Promise.resolve(c.provideFileDecoration(m.URI.revive(_),t));if(!u)return;try{C.FileDecoration.validate(u),u.badge&&typeof u.badge!="string"&&(0,y.checkProposedApiEnabled)(b,"codiconDecoration"),r[i]=[u.propagate,u.tooltip,u.badge,u.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${b}': ${n}`)}}catch(_){this._logService.error(_)}})),r}};d._handlePool=0,d._maxEventSize=250,e.ExtHostDecorations=d=Ve([He(0,F.IExtHostRpcService),He(1,f.ILogService)],d),e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Xe=this&&this.__classPrivateFieldSet||function(te,e,m,k,C){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?C.call(te,m):C?C.value=m:e.set(te,m),m},Fe=this&&this.__classPrivateFieldGet||function(te,e,m,k){if(m==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?k:m==="a"?k.call(te):k?k.value:e.get(te)};define(Ae[222],Re([1,0,147,94,2,4,7,8,5,15,28,39]),function(te,e,m,k,C,M,F,f,D,g,R,y){"use strict";var d,E,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class l{constructor(c,b,w,_,i,u,n){this._name=c,this._owner=b,this._maxDiagnosticsPerFile=w,this._modelVersionIdProvider=_,d.set(this,void 0),E.set(this,void 0),p.set(this,void 0),this._isDisposed=!1,Xe(this,p,new R.ResourceMap(s=>i.getComparisonKey(s)),"f"),Xe(this,d,u,"f"),Xe(this,E,n,"f")}dispose(){this._isDisposed||(Fe(this,E,"f").fire([...Fe(this,p,"f").keys()]),Fe(this,d,"f")?.$clear(this._owner),Fe(this,p,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,b){if(!c){this.clear();return}this._checkDisposed();let w=[];if(C.URI.isUri(c)){if(!b){this.delete(c);return}Fe(this,p,"f").set(c,b.slice()),w=[c]}else if(Array.isArray(c)){w=[];let i;c=[...c].sort(l._compareIndexedTuplesByUri);for(const u of c){const[n,s]=u;if((!i||n.toString()!==i.toString())&&(i&&Fe(this,p,"f").get(i).length===0&&Fe(this,p,"f").delete(i),i=n,w.push(n),Fe(this,p,"f").set(n,[])),s)Fe(this,p,"f").get(n)?.push(...s);else{const v=Fe(this,p,"f").get(n);v&&(v.length=0)}}}if(Fe(this,E,"f").fire(w),!Fe(this,d,"f"))return;const _=[];for(const i of w){let u=[];const n=Fe(this,p,"f").get(i);if(n)if(n.length>this._maxDiagnosticsPerFile){u=[];const s=[F.DiagnosticSeverity.Error,F.DiagnosticSeverity.Warning,F.DiagnosticSeverity.Information,F.DiagnosticSeverity.Hint];e:for(let v=0;v<4;v++)for(const I of n)if(I.severity===s[v]&&u.push({...f.Diagnostic.from(I),modelVersionId:this._modelVersionIdProvider(i)})===this._maxDiagnosticsPerFile)break e;u.push({severity:k.MarkerSeverity.Info,message:(0,m.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=n.map(s=>({...f.Diagnostic.from(s),modelVersionId:this._modelVersionIdProvider(i)}));_.push([i,u])}Fe(this,d,"f").$changeMany(this._owner,_)}delete(c){this._checkDisposed(),Fe(this,E,"f").fire([c]),Fe(this,p,"f").delete(c),Fe(this,d,"f")?.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),Fe(this,E,"f").fire([...Fe(this,p,"f").keys()]),Fe(this,p,"f").clear(),Fe(this,d,"f")?.$clear(this._owner)}forEach(c,b){this._checkDisposed();for(const[w,_]of this)c.call(b,w,_,this)}*[(d=new WeakMap,E=new WeakMap,p=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const c of Fe(this,p,"f").keys())yield[c,this.get(c)]}get(c){this._checkDisposed();const b=Fe(this,p,"f").get(c);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(Fe(this,p,"f").get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,b){return c[0].toString()<b[0].toString()?-1:c[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=l;let t=e.ExtHostDiagnostics=class bi{static _mapper(c){const b=new R.ResourceMap;for(const w of c)b.set(w,w);return{uris:Object.freeze(Array.from(b.values()))}}constructor(c,b,w,_){this._logService=b,this._fileSystemInfoService=w,this._extHostDocumentsAndEditors=_,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,bi._mapper),this._proxy=c.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(c,b){const{_collections:w,_proxy:_,_onDidChangeDiagnostics:i,_logService:u,_fileSystemInfoService:n,_extHostDocumentsAndEditors:s}=this,v=new class{$changeMany(T,S){_.$changeMany(T,S),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,T,S.length===0?"CLEARING":S)}$clear(T){_.$clear(T),u.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,T)}dispose(){_.dispose()}};let I;if(!b)b="_generated_diagnostic_collection_name_#"+bi._idPool++,I=b;else if(!w.has(b))I=b;else{this._logService.warn(`DiagnosticCollection with name '${b}' does already exist.`);do I=b+bi._idPool++;while(w.has(I))}return new class extends l{constructor(){super(b,I,bi._maxDiagnosticsPerFile,T=>s.getDocument(T)?.version,n.extUri,v,i),w.set(I,this)}dispose(){super.dispose(),w.delete(I)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const b=new Map,w=[];for(const _ of this._collections.values())_.forEach((i,u)=>{let n=b.get(i.toString());typeof n>"u"&&(n=w.length,b.set(i.toString(),n),w.push([i,[]])),w[n][1]=w[n][1].concat(...u)});return w}}_getDiagnostics(c){let b=[];for(const w of this._collections.values())w.has(c)&&(b=b.concat(w.get(c)));return b}$acceptMarkersChange(c){if(!this._mirrorCollection){const b="_generated_mirror",w=new l(b,b,bi._maxDiagnosticsPerFile,_=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(b,w),this._mirrorCollection=w}for(const[b,w]of c)this._mirrorCollection.set(C.URI.revive(b),w.map(f.Diagnostic.to))}};t._idPool=0,t._maxDiagnosticsPerFile=1e3,e.ExtHostDiagnostics=t=Ve([He(1,g.ILogService),He(2,y.IExtHostFileSystemInfo)],t)}),define(Ae[223],Re([1,0,2,4,26]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class M{constructor(f){this._proxy=f.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(f,D){return D?.allowUIResources&&(0,C.checkProposedApiEnabled)(f,"showLocal"),this._proxy.$showOpenDialog(D).then(g=>g?g.map(R=>m.URI.revive(R)):void 0)}showSaveDialog(f){return this._proxy.$showSaveDialog(f).then(D=>D?m.URI.revive(D):void 0)}}e.ExtHostDialogs=M}),define(Ae[224],Re([1,0,9,2,7,4,14,22,13]),function(te,e,m,k,C,M,F,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class g{constructor(y,d,E){this._documentsAndEditors=d,this._logService=E,this._documentContentProviders=new Map,this._proxy=y.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,d){if(Object.keys(F.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const E=g._handlePool++;this._documentContentProviders.set(E,d),this._proxy.$registerTextContentProvider(E,y);let p;return typeof d.onDidChange=="function"&&(p=d.onDidChange(l=>{if(l.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(l)&&this.$provideTextDocumentContent(E,l).then(t=>{if(!t&&typeof t!="string")return;const r=this._documentsAndEditors.getDocument(l);if(!r)return;const c=(0,D.splitLines)(t);if(!r.equalLines(c))return this._proxy.$onVirtualDocumentChange(l,t)},m.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(y,d){const E=this._documentContentProviders.get(y);return E?Promise.resolve(E.provideTextDocumentContent(k.URI.revive(d),f.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=g,g._handlePool=0}),define(Ae[225],Re([1,0,5,6,2,4,100,8,10,23,7,9]),function(te,e,m,k,C,M,F,f,D,g,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class d{constructor(p,l){this._onDidAddDocument=new m.Emitter({onListenerError:y.onUnexpectedExternalError}),this._onDidRemoveDocument=new m.Emitter({onListenerError:y.onUnexpectedExternalError}),this._onDidChangeDocument=new m.Emitter({onListenerError:y.onUnexpectedExternalError}),this._onDidSaveDocument=new m.Emitter({onListenerError:y.onUnexpectedExternalError}),this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new k.DisposableStore,this._documentLoader=new Map,this._proxy=p.getProxy(M.MainContext.MainThreadDocuments),this._documentsAndEditors=l,this._documentsAndEditors.onDidRemoveDocuments(t=>{for(const r of t)this._onDidRemoveDocument.fire(r.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(t=>{for(const r of t)this._onDidAddDocument.fire(r.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(p){if(!p)return;const l=this._documentsAndEditors.getDocument(p);if(l)return l}getDocument(p){const l=this.getDocumentData(p);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return l.document}ensureDocumentData(p){const l=this._documentsAndEditors.getDocument(p);if(l)return Promise.resolve(l);let t=this._documentLoader.get(p.toString());return t||(t=this._proxy.$tryOpenDocument(p).then(r=>{this._documentLoader.delete(p.toString());const c=C.URI.revive(r);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(c))},r=>(this._documentLoader.delete(p.toString()),Promise.reject(r))),this._documentLoader.set(p.toString(),t)),t}createDocumentData(p){return this._proxy.$tryCreateDocument(p).then(l=>C.URI.revive(l))}$acceptModelLanguageChanged(p,l){const t=C.URI.revive(p),r=this._documentsAndEditors.getDocument(t);if(!r)throw new Error("unknown document");this._onDidRemoveDocument.fire(r.document),r._acceptLanguageId(l),this._onDidAddDocument.fire(r.document)}$acceptModelSaved(p){const l=C.URI.revive(p),t=this._documentsAndEditors.getDocument(l);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this._onDidSaveDocument.fire(t.document)}$acceptDirtyStateChanged(p,l){const t=C.URI.revive(p),r=this._documentsAndEditors.getDocument(t);if(!r)throw new Error("unknown document");r._acceptIsDirty(l),this._onDidChangeDocument.fire({document:r.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,l,t){const r=C.URI.revive(p),c=this._documentsAndEditors.getDocument(r);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(l);let b;l.isUndoing?b=R.TextDocumentChangeReason.Undo:l.isRedoing&&(b=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,g.deepFreeze)({document:c.document,contentChanges:l.changes.map(w=>({range:f.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text})),reason:b}))}setWordDefinitionFor(p,l){(0,F.setWordDefinitionFor)(p,l)}}e.ExtHostDocuments=d}),define(Ae[59],Re([1,0,49,5,6,2,3,4,100,17,105,8,15,28,14,67,66]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class r{constructor(w){this.value=w,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let c=e.ExtHostDocumentsAndEditors=class{constructor(w,_){this._extHostRpc=w,this._logService=_,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new k.Emitter,this._onDidRemoveDocuments=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(w){this.acceptDocumentsAndEditorsDelta(w)}acceptDocumentsAndEditorsDelta(w){const _=[],i=[],u=[];if(w.removedDocuments)for(const n of w.removedDocuments){const s=M.URI.revive(n),v=this._documents.get(s);v?.unref()&&(this._documents.delete(s),_.push(v.value))}if(w.addedDocuments)for(const n of w.addedDocuments){const s=M.URI.revive(n.uri);let v=this._documents.get(s);if(v&&s.scheme!==p.Schemas.vscodeNotebookCell&&s.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);v||(v=new r(new D.ExtHostDocumentData(this._extHostRpc.getProxy(f.MainContext.MainThreadDocuments),s,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(s,v),i.push(v.value)),v.ref()}if(w.removedEditors)for(const n of w.removedEditors){const s=this._editors.get(n);this._editors.delete(n),s&&u.push(s)}if(w.addedEditors)for(const n of w.addedEditors){const s=M.URI.revive(n.documentUri);m.ok(this._documents.has(s),`document '${s}' does not exist`),m.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const v=this._documents.get(s).value,I=new R.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(f.MainContext.MainThreadTextEditors),this._logService,new t.Lazy(()=>v.document),n.selections.map(y.Selection.to),n.options,n.visibleRanges.map(h=>y.Range.to(h)),typeof n.editorPosition=="number"?y.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,I)}w.newActiveEditor!==void 0&&(m.ok(w.newActiveEditor===null||this._editors.has(w.newActiveEditor),`active editor '${w.newActiveEditor}' does not exist`),this._activeEditorId=w.newActiveEditor),(0,C.dispose)(_),(0,C.dispose)(u),w.removedDocuments&&this._onDidRemoveDocuments.fire(_),w.addedDocuments&&this._onDidAddDocuments.fire(i),(w.removedEditors||w.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),w.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(w){return this._documents.get(w)?.value}allDocuments(){return l.Iterable.map(this._documents.values(),w=>w.value)}getEditor(w){return this._editors.get(w)}activeEditor(w){if(!this._activeEditorId)return;const _=this._editors.get(this._activeEditorId);return w?_:_?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=c=Ve([He(0,g.IExtHostRpcService),He(1,d.ILogService)],c),e.IExtHostDocumentsAndEditors=(0,F.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ae[60],Re([1,0,8,4,2,5,3,7,17,10,64]),function(te,e,m,k,C,M,F,f,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,F.createDecorator)("IExtHostEditorTabs");class y{constructor(t,r,c){this._activeTabIdGetter=c,this._parentGroup=r,this.acceptDtoUpdate(t)}get apiObject(){if(!this._apiObject){const t=this,r={get isActive(){return t._dto.id===t._activeTabIdGetter()},get label(){return t._dto.label},get input(){return t._input},get isDirty(){return t._dto.isDirty},get isPinned(){return t._dto.isPinned},get isPreview(){return t._dto.isPreview},get group(){return t._parentGroup.apiObject}};this._apiObject=Object.freeze(r)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(t){this._dto=t,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new f.TextTabInput(C.URI.revive(this._dto.input.uri));case 2:return new f.TextDiffTabInput(C.URI.revive(this._dto.input.original),C.URI.revive(this._dto.input.modified));case 3:return new f.TextMergeTabInput(C.URI.revive(this._dto.input.base),C.URI.revive(this._dto.input.input1),C.URI.revive(this._dto.input.input2),C.URI.revive(this._dto.input.result));case 6:return new f.CustomEditorTabInput(C.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new f.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new f.NotebookEditorTabInput(C.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new f.NotebookDiffEditorTabInput(C.URI.revive(this._dto.input.original),C.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new f.TerminalEditorTabInput;case 9:return new f.InteractiveWindowInput(C.URI.revive(this._dto.input.uri),C.URI.revive(this._dto.input.inputBoxUri));default:return}}}class d{constructor(t,r){this._tabs=[],this._activeTabId="",this._dto=t,this._activeGroupIdGetter=r;for(const c of t.tabs)c.isActive&&(this._activeTabId=c.id),this._tabs.push(new y(c,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const t=this,r={get isActive(){return t._dto.groupId===t._activeGroupIdGetter()},get viewColumn(){return m.ViewColumn.to(t._dto.viewColumn)},get activeTab(){return t._tabs.find(c=>c.tabId===t._activeTabId)?.apiObject},get tabs(){return Object.freeze(t._tabs.map(c=>c.apiObject))}};this._apiObject=Object.freeze(r)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(t){this._dto=t}acceptTabOperation(t){if(t.kind===0){const c=new y(t.tabDto,this,()=>this.activeTabId());return this._tabs.splice(t.index,0,c),t.tabDto.isActive&&(this._activeTabId=c.tabId),c}else if(t.kind===1){const c=this._tabs.splice(t.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return c.tabId===this._activeTabId&&(this._activeTabId=""),c}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this._tabs.splice(t.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this._tabs.splice(t.index,0,c),c}const r=this._tabs.find(c=>c.tabId===t.tabDto.id);if(!r)throw new Error("INVALID tab");return t.tabDto.isActive?this._activeTabId=t.tabDto.id:this._activeTabId===t.tabDto.id&&!t.tabDto.isActive&&(this._activeTabId=""),r.acceptDtoUpdate(t.tabDto),r}activeTabId(){return this._activeTabId}}let E=e.ExtHostEditorTabs=class{constructor(t){this._onDidChangeTabs=new M.Emitter,this._onDidChangeTabGroups=new M.Emitter,this._extHostTabGroups=[],this._proxy=t.getProxy(k.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const t=this,r={onDidChangeTabGroups:t._onDidChangeTabGroups.event,onDidChangeTabs:t._onDidChangeTabs.event,get all(){return Object.freeze(t._extHostTabGroups.map(c=>c.apiObject))},get activeTabGroup(){const c=t._activeGroupId;return(0,g.assertIsDefined)(t._extHostTabGroups.find(w=>w.groupId===c)?.apiObject)},close:async(c,b)=>{const w=Array.isArray(c)?c:[c];return w.length?p(w[0])?this._closeGroups(w,b):this._closeTabs(w,b):!0}};this._apiObject=Object.freeze(r)}return this._apiObject}$acceptEditorTabModel(t){const r=new Set(this._extHostTabGroups.map(n=>n.groupId)),c=new Set(t.map(n=>n.groupId)),b=(0,R.diffSets)(r,c),w=this._extHostTabGroups.filter(n=>b.removed.includes(n.groupId)).map(n=>n.apiObject),_=[],i=[];this._extHostTabGroups=t.map(n=>{const s=new d(n,()=>this._activeGroupId);return b.added.includes(s.groupId)?_.push(s.apiObject):i.push(s.apiObject),s});const u=(0,g.assertIsDefined)(t.find(n=>n.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:_,closed:w,changed:i}))}$acceptTabGroupUpdate(t){const r=this._extHostTabGroups.find(c=>c.groupId===t.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(t),t.isActive&&(this._activeGroupId=t.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const r=this._extHostTabGroups.find(b=>b.groupId===t.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const c=r.acceptTabOperation(t);switch(t.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}_findExtHostTabFromApi(t){for(const r of this._extHostTabGroups)for(const c of r.tabs)if(c.apiObject===t)return c}_findExtHostTabGroupFromApi(t){return this._extHostTabGroups.find(r=>r.apiObject===t)}async _closeTabs(t,r){const c=[];for(const b of t){const w=this._findExtHostTabFromApi(b);if(!w)throw new Error("Tab close: Invalid tab not found!");c.push(w.tabId)}return this._proxy.$closeTab(c,r)}async _closeGroups(t,r){const c=[];for(const b of t){const w=this._findExtHostTabGroupFromApi(b);if(!w)throw new Error("Group close: Invalid group not found!");c.push(w.groupId)}return this._proxy.$closeGroup(c,r)}};e.ExtHostEditorTabs=E=Ve([He(0,D.IExtHostRpcService)],E);function p(l){return l.tabs!==void 0}}),define(Ae[226],Re([1,0,2,4,6,7,8,273,13,25,26,70]),function(te,e,m,k,C,M,F,f,D,g,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class d{constructor(){this._schemes=[]}add(l){this._stateMachine=void 0,this._schemes.push(l)}delete(l){const t=this._schemes.indexOf(l);t>=0&&(this._schemes.splice(t,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const l=this._schemes.sort(),t=[];let r,c,b=14,w=14;for(const _ of l){let i=r?(0,D.commonPrefixLength)(r,_):0;for(i===0?c=1:c=w;i<_.length;i++)i+1===_.length?(b=w,w=9):w+=1,t.push([c,_.toUpperCase().charCodeAt(i),w]),t.push([c,_.toLowerCase().charCodeAt(i),w]),c=w;r=_,w=b}t.push([9,58,10]),t.push([10,47,12]),this._stateMachine=new f.StateMachine(t)}}provideDocumentLinks(l){this._initStateMachine();const t=[],r=f.LinkComputer.computeLinks({getLineContent(c){return l.lineAt(c-1).text},getLineCount(){return l.lineCount}},this._stateMachine);for(const c of r){const b=F.DocumentLink.to(c);b.target&&t.push(b)}return t}}class E{constructor(l,t){this._extHostLanguageFeatures=t,this._linkProvider=new d,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=l.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(l,t,r,c={}){if(E._validateFileSystemProvider(r),this._registeredSchemes.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(l,"*",this._linkProvider));const b=this._handlePool++;this._linkProvider.add(t),this._registeredSchemes.add(t),this._fsProvider.set(b,r);let w=2;c.isCaseSensitive&&(w+=1024),c.isReadonly&&(w+=2048),typeof r.copy=="function"&&(w+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,R.checkProposedApiEnabled)(l,"fsChunks"),w+=4);let _;c.isReadonly&&(0,y.isMarkdownString)(c.isReadonly)&&((0,R.checkProposedApiEnabled)(l,"readonlyMessage"),_={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this._proxy.$registerFileSystemProvider(b,t,w,_).catch(u=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${t}`),console.error(u)});const i=r.onDidChangeFile(u=>{const n=[];for(const s of u){const{uri:v,type:I}=s;if(v.scheme!==t)continue;let h;switch(I){case M.FileChangeType.Changed:h=0;break;case M.FileChangeType.Created:h=1;break;case M.FileChangeType.Deleted:h=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:v,type:h})}this._proxy.$onFileSystemChange(b,n)});return(0,C.toDisposable)(()=>{i.dispose(),this._linkProvider.delete(t),this._registeredSchemes.delete(t),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _validateFileSystemProvider(l){if(!l)throw new Error("MISSING provider");if(typeof l.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof l.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof l.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof l.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof l.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof l.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof l.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof l.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(l){const{type:t,ctime:r,mtime:c,size:b,permissions:w}=l;return{type:t,ctime:r,mtime:c,size:b,permissions:w}}$stat(l,t){return Promise.resolve(this._getFsProvider(l).stat(m.URI.revive(t))).then(r=>E._asIStat(r))}$readdir(l,t){return Promise.resolve(this._getFsProvider(l).readDirectory(m.URI.revive(t)))}$readFile(l,t){return Promise.resolve(this._getFsProvider(l).readFile(m.URI.revive(t))).then(r=>g.VSBuffer.wrap(r))}$writeFile(l,t,r,c){return Promise.resolve(this._getFsProvider(l).writeFile(m.URI.revive(t),r.buffer,c))}$delete(l,t,r){return Promise.resolve(this._getFsProvider(l).delete(m.URI.revive(t),r))}$rename(l,t,r,c){return Promise.resolve(this._getFsProvider(l).rename(m.URI.revive(t),m.URI.revive(r),c))}$copy(l,t,r,c){const b=this._getFsProvider(l);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(m.URI.revive(t),m.URI.revive(r),c))}$mkdir(l,t){return Promise.resolve(this._getFsProvider(l).createDirectory(m.URI.revive(t)))}$watch(l,t,r,c){const b=this._getFsProvider(l).watch(m.URI.revive(r),c);this._watches.set(t,b)}$unwatch(l,t){const r=this._watches.get(t);r&&(r.dispose(),this._watches.delete(t))}$open(l,t,r){const c=this._getFsProvider(l);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(m.URI.revive(t),r))}$close(l,t){const r=this._getFsProvider(l);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(t))}$read(l,t,r,c){const b=this._getFsProvider(l);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const w=g.VSBuffer.alloc(c);return Promise.resolve(b.read(t,r,w.buffer,0,c)).then(_=>w.slice(0,_))}$write(l,t,r,c){const b=this._getFsProvider(l);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(t,r,c.buffer,0,c.byteLength))}_getFsProvider(l){const t=this._fsProvider.get(l);if(!t){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return t}}e.ExtHostFileSystem=E}),define(Ae[61],Re([1,0,4,38,7,25,3,17,39,6,16,20,14]),function(te,e,m,k,C,M,F,f,D,g,R,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let E=e.ExtHostConsumerFileSystem=class ii{constructor(l,t){this._fileSystemProvider=new Map,this._writeQueue=new R.ResourceQueue,this._proxy=l.getProxy(m.MainContext.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(c){try{let b;const w=r._fileSystemProvider.get(c.scheme);return w?(await r._proxy.$ensureActivation(c.scheme),b=await w.impl.stat(c)):b=await r._proxy.$stat(c),{type:b.type,ctime:b.ctime,mtime:b.mtime,size:b.size,permissions:b.permissions===k.FilePermission.Readonly?1:void 0}}catch(b){ii._handleError(b)}},async readDirectory(c){try{const b=r._fileSystemProvider.get(c.scheme);return b?(await r._proxy.$ensureActivation(c.scheme),(await b.impl.readDirectory(c)).slice()):await r._proxy.$readdir(c)}catch(b){return ii._handleError(b)}},async createDirectory(c){try{const b=r._fileSystemProvider.get(c.scheme);return b&&!b.isReadonly?(await r._proxy.$ensureActivation(c.scheme),await r.mkdirp(b.impl,b.extUri,c)):await r._proxy.$mkdir(c)}catch(b){return ii._handleError(b)}},async readFile(c){try{const b=r._fileSystemProvider.get(c.scheme);return b?(await r._proxy.$ensureActivation(c.scheme),(await b.impl.readFile(c)).slice()):(await r._proxy.$readFile(c)).buffer}catch(b){return ii._handleError(b)}},async writeFile(c,b){try{const w=r._fileSystemProvider.get(c.scheme);return w&&!w.isReadonly?(await r._proxy.$ensureActivation(c.scheme),await r.mkdirp(w.impl,w.extUri,w.extUri.dirname(c)),await r._writeQueue.queueFor(c).queue(()=>Promise.resolve(w.impl.writeFile(c,b,{create:!0,overwrite:!0})))):await r._proxy.$writeFile(c,M.VSBuffer.wrap(b))}catch(w){return ii._handleError(w)}},async delete(c,b){try{const w=r._fileSystemProvider.get(c.scheme);return w&&!w.isReadonly?(await r._proxy.$ensureActivation(c.scheme),await w.impl.delete(c,{recursive:!1,...b})):await r._proxy.$delete(c,{recursive:!1,useTrash:!1,atomic:!1,...b})}catch(w){return ii._handleError(w)}},async rename(c,b,w){try{return await r._proxy.$rename(c,b,{overwrite:!1,...w})}catch(_){return ii._handleError(_)}},async copy(c,b,w){try{return await r._proxy.$copy(c,b,{overwrite:!1,...w})}catch(_){return ii._handleError(_)}},isWritableFileSystem(c){const b=t.getCapabilities(c);if(typeof b=="number")return!(b&2048)}})}async mkdirp(l,t,r){const c=[];for(;!t.isEqual(r,t.dirname(r));)try{if(!((await l.stat(r)).type&k.FileType.Directory))throw C.FileSystemError.FileExists(`Unable to create folder '${r.scheme===d.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(b){if(k.toFileSystemProviderErrorCode(b)!==k.FileSystemProviderErrorCode.FileNotFound)throw b;c.push(t.basename(r)),r=t.dirname(r)}for(let b=c.length-1;b>=0;b--){r=t.joinPath(r,c[b]);try{await l.createDirectory(r)}catch(w){if(k.toFileSystemProviderErrorCode(w)!==k.FileSystemProviderErrorCode.FileExists)throw w}}}static _handleError(l){if(l instanceof C.FileSystemError)throw l;if(l instanceof k.FileSystemProviderError)switch(l.code){case k.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(l.message);case k.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(l.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(l.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(l.message);case k.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(l.message);case k.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(l.message);default:throw new C.FileSystemError(l.message,l.name)}if(!(l instanceof Error))throw new C.FileSystemError(String(l));if(l.name==="ENOPRO"||l.message.includes("ENOPRO"))throw C.FileSystemError.Unavailable(l.message);switch(l.name){case k.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(l.message);case k.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(l.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(l.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(l.message);case k.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(l.message);case k.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(l.message);default:throw new C.FileSystemError(l.message,l.name)}}addFileSystemProvider(l,t,r){return this._fileSystemProvider.set(l,{impl:t,extUri:r?.isCaseSensitive?y.extUri:y.extUriIgnorePathCase,isReadonly:!!r?.isReadonly}),(0,g.toDisposable)(()=>this._fileSystemProvider.delete(l))}};e.ExtHostConsumerFileSystem=E=Ve([He(0,f.IExtHostRpcService),He(1,D.IExtHostFileSystemInfo)],E),e.IExtHostConsumerFileSystem=(0,F.createDecorator)("IExtHostConsumerFileSystem")}),define(Ae[227],Re([1,0,5,37,2,4,8,7]),function(te,e,m,k,C,M,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(y,d,E,p,l,t,r,c){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter;const b=this.ensureWatching(y,E,l);this._config=0,t&&(this._config+=1),r&&(this._config+=2),c&&(this._config+=4);const w=(0,k.parse)(l),_=typeof l=="string",i=p(u=>{if(!t)for(const n of u.created){const s=C.URI.revive(n);w(s.fsPath)&&(!_||d.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!r)for(const n of u.changed){const s=C.URI.revive(n);w(s.fsPath)&&(!_||d.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!c)for(const n of u.deleted){const s=C.URI.revive(n);w(s.fsPath)&&(!_||d.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=f.Disposable.from(b,this._onDidCreate,this._onDidChange,this._onDidDelete,i)}ensureWatching(y,d,E){const p=f.Disposable.from();if(typeof E=="string")return p;const l=y.getProxy(M.MainContext.MainThreadFileSystem);let t=!1;(E.pattern.includes(k.GLOBSTAR)||E.pattern.includes(k.GLOB_SPLIT))&&(t=!0);const r=Math.random();return l.$watch(d.identifier.value,r,E.baseUri,{recursive:t,excludes:[]}),f.Disposable.from({dispose:()=>l.$unwatch(r)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class g{constructor(y,d,E){this._mainContext=y,this._logService=d,this._extHostDocumentsAndEditors=E,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(y,d,E,p,l,t){return new D(this._mainContext,y,d,this._onFileSystemEvent.event,F.GlobPattern.from(E),p,l,t)}$onFileEvent(y){this._onFileSystemEvent.fire(y)}$onDidRunFileOperation(y,d){switch(y){case 2:this._onDidRenameFile.fire(Object.freeze({files:d.map(E=>({oldUri:C.URI.revive(E.source),newUri:C.URI.revive(E.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:d.map(E=>C.URI.revive(E.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:d.map(E=>C.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(y){return this._createWillExecuteEvent(y,this._onWillRenameFile)}getOnWillCreateFileEvent(y){return this._createWillExecuteEvent(y,this._onWillCreateFile)}getOnWillDeleteFileEvent(y){return this._createWillExecuteEvent(y,this._onWillDeleteFile)}_createWillExecuteEvent(y,d){return(E,p,l)=>{const t=function(c){E.call(p,c)};return t.extension=y,d.event(t,void 0,l)}}async $onWillRunFileOperation(y,d,E,p){switch(y){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:d.map(l=>({oldUri:C.URI.revive(l.source),newUri:C.URI.revive(l.target)}))},E,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:d.map(l=>C.URI.revive(l.target))},E,p);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:d.map(l=>C.URI.revive(l.target))},E,p)}}async _fireWillEvent(y,d,E,p){const l=new Set,t=[];if(await y.fireAsync(d,p,async(c,b)=>{const w=Date.now(),_=await Promise.resolve(c);_ instanceof f.WorkspaceEdit&&(t.push([b.extension,_]),l.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-w>E&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),p.isCancellationRequested||t.length===0)return;const r={edits:[]};for(const[,c]of t){const{edits:b}=F.WorkspaceEdit.from(c,{getTextDocumentVersion:w=>this._extHostDocumentsAndEditors.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(b)}return{edit:r,extensionNames:Array.from(l)}}}e.ExtHostFileSystemEventService=g}),define(Ae[228],Re([1,0,6,2,4,8,7,32]),function(te,e,m,k,C,M,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class D{constructor(d,E){this.extension=d,this.provider=E,this.handle=D._pool++}}D._pool=0;class g{constructor(d){this.session=d,this.responses=[]}}class R{constructor(d,E,p,l){this._documents=p,this._logService=l,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=d.getProxy(C.MainContext.MainThreadInlineChat),E.registerApiCommand(new f.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new f.ApiCommandArgument("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?M.Range.from(t.initialRange):void 0,message:t.message,autoSend:t.autoSend}})],f.ApiCommandResult.Void))}registerProvider(d,E){const p=new D(d,E);return this._inputProvider.set(p.handle,p),this._proxy.$registerInteractiveEditorProvider(p.handle,d.identifier.value,typeof E.handleInteractiveEditorResponseFeedback=="function"),(0,m.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(p.handle),this._inputProvider.delete(p.handle)})}async $prepareSession(d,E,p,l){const t=this._inputProvider.get(d);if(!t){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this._documents.getDocument(k.URI.revive(E)),c=M.Selection.to(p),b=await t.provider.prepareInteractiveEditorSession({document:r,selection:c},l);if(!b)return;if(b.wholeRange&&!b.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const w=R._nextId++;return this._inputSessions.set(w,new g(b)),{id:w,placeholder:b.placeholder,slashCommands:b.slashCommands?.map(_=>({command:_.command,detail:_.detail,refer:_.refer})),wholeRange:M.Range.from(b.wholeRange),message:b.message}}async $provideResponse(d,E,p,l){const t=this._inputProvider.get(d);if(!t)return;const r=this._inputSessions.get(E.id);if(!r)return;const c=await t.provider.provideInteractiveEditorResponse({session:r.session,prompt:p.prompt,selection:M.Selection.to(p.selection),wholeRange:M.Range.to(p.wholeRange),attempt:p.attempt},l);if(c){const b=r.responses.push(c)-1,w={wholeRange:M.Range.from(c.wholeRange),placeholder:c.placeholder};if(R._isMessageResponse(c))return{...w,id:b,type:"message",message:M.MarkdownString.from(c.contents)};const{edits:_}=c;if(_ instanceof F.WorkspaceEdit)return{...w,id:b,type:"bulkEdit",edits:M.WorkspaceEdit.from(_)};if(Array.isArray(_))return{...w,id:b,type:"editorEdit",edits:_.map(M.TextEdit.from)}}}$handleFeedback(d,E,p,l){const t=this._inputProvider.get(d),r=this._inputSessions.get(E),c=r?.responses[p];if(t&&c){let b;switch(l){case 1:b=F.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:b=F.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:b=F.InteractiveEditorResponseFeedbackKind.Undone;break}t.provider.handleInteractiveEditorResponseFeedback?.(r.session,c,b)}}$releaseSession(d,E){const p=this._inputSessions.get(E),l=this._inputProvider.get(d);p&&l&&l.provider.releaseInteractiveEditorSession?.(p.session),this._inputSessions.delete(E)}static _isMessageResponse(d){return typeof d=="object"&&typeof d.contents=="object"}}e.ExtHostInteractiveEditor=R,R._nextId=0}),define(Ae[229],Re([1,0,2,32]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class C{constructor(F,f,D,g,R){this._extHostNotebooks=f,this._textDocumentsAndEditors=D,this._commands=g;const y=new k.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new k.ApiCommandArgument("showOptions","Show Options",d=>!0,d=>d),new k.ApiCommandArgument("resource","Interactive resource Uri",d=>!0,d=>d),new k.ApiCommandArgument("controllerId","Notebook controller Id",d=>!0,d=>d),new k.ApiCommandArgument("title","Interactive editor title",d=>!0,d=>d)],new k.ApiCommandResult("Notebook and input URI",d=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",d.notebookEditorId),d.notebookEditorId!==void 0){const E=this._extHostNotebooks.getEditorById(d.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:m.URI.revive(d.notebookUri),inputUri:m.URI.revive(d.inputUri),notebookEditor:E.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",d.notebookUri,d.inputUri),{notebookUri:m.URI.revive(d.notebookUri),inputUri:m.URI.revive(d.inputUri)}}));this._commands.registerApiCommand(y)}$willAddInteractiveDocument(F,f,D,g){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:f,lines:[""],languageId:D,uri:F,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(F,f){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[F]})}}e.ExtHostInteractive=C}),define(Ae[230],Re([1,0,4,7]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class C{constructor(F){this._IssueUriRequestHandlers=new Map,this._proxy=F.getProxy(m.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(F,f){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const D=this._IssueUriRequestHandlers.get(F);if(!D)throw new Error("Issue request handler not found");const g=await D.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}registerIssueUriRequestHandler(F,f){const D=F.identifier.value;return this._IssueUriRequestHandlers.set(D,f),this._proxy.$registerIssueUriRequestHandler(D),new k.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(D),this._IssueUriRequestHandlers.delete(D)})}}e.ExtHostIssueReporter=C}),define(Ae[231],Re([1,0,6,4]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(F){this._handlePool=0,this._proxy=F.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(F){const f=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(f,F),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(f)})}}e.ExtHostLabelService=C}),define(Ae[232],Re([1,0,2,23,8,7,79,4,13,44,18,10,274,22,6,91,88,54,58,9,16,26,149]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l,t,r,c,b,w,_,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class u{constructor(P,W){this._documents=P,this._provider=W}async provideDocumentSymbols(P,W){const H=this._documents.getDocument(P),j=await this._provider.provideDocumentSymbols(H,W);if(!(0,R.isFalsyOrEmpty)(j))return j[0]instanceof M.DocumentSymbol?j.map(C.DocumentSymbol.from):u._asDocumentSymbolTree(j)}static _asDocumentSymbolTree(P){P=P.slice(0).sort((j,re)=>{let he=j.location.range.start.compareTo(re.location.range.start);return he===0&&(he=re.location.range.end.compareTo(j.location.range.end)),he});const W=[],H=[];for(const j of P){const re={name:j.name||"!!MISSING: name!!",kind:C.SymbolKind.from(j.kind),tags:j.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:C.Range.from(j.location.range),selectionRange:C.Range.from(j.location.range),children:[]};for(;;){if(H.length===0){H.push(re),W.push(re);break}const he=H[H.length-1];if(g.Range.containsRange(he.range,re.range)&&!g.Range.equalsRange(he.range,re.range)){he.children?.push(re),H.push(re);break}H.pop()}}return W}}class n{constructor(P,W,H){this._documents=P,this._commands=W,this._provider=H,this._cache=new r.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(P,W){const H=this._documents.getDocument(P),j=await this._provider.provideCodeLenses(H,W);if(!j||W.isCancellationRequested)return;const re=this._cache.add(j),he=new p.DisposableStore;this._disposables.set(re,he);const ie={cacheId:re,lenses:[]};for(let we=0;we<j.length;we++)ie.lenses.push({cacheId:[re,we],range:C.Range.from(j[we].range),command:this._commands.toInternal(j[we].command,he)});return ie}async resolveCodeLens(P,W){const H=P.cacheId&&this._cache.get(...P.cacheId);if(!H)return;let j;if(typeof this._provider.resolveCodeLens!="function"||H.isResolved?j=H:j=await this._provider.resolveCodeLens(H,W),j||(j=H),W.isCancellationRequested)return;const re=P.cacheId&&this._disposables.get(P.cacheId[0]);if(re)return P.command=this._commands.toInternal(j.command??n._badCmd,re),P}releaseCodeLenses(P){this._disposables.get(P)?.dispose(),this._disposables.delete(P),this._cache.delete(P)}}n._badCmd={command:"missing",title:"!!MISSING: command!!"};function s(ee){return Array.isArray(ee)?ee.map(C.DefinitionLink.from):ee?[C.DefinitionLink.from(ee)]:[]}class v{constructor(P,W){this._documents=P,this._provider=W}async provideDefinition(P,W,H){const j=this._documents.getDocument(P),re=C.Position.to(W),he=await this._provider.provideDefinition(j,re,H);return s(he)}}class I{constructor(P,W){this._documents=P,this._provider=W}async provideDeclaration(P,W,H){const j=this._documents.getDocument(P),re=C.Position.to(W),he=await this._provider.provideDeclaration(j,re,H);return s(he)}}class h{constructor(P,W){this._documents=P,this._provider=W}async provideImplementation(P,W,H){const j=this._documents.getDocument(P),re=C.Position.to(W),he=await this._provider.provideImplementation(j,re,H);return s(he)}}class T{constructor(P,W){this._documents=P,this._provider=W}async provideTypeDefinition(P,W,H){const j=this._documents.getDocument(P),re=C.Position.to(W),he=await this._provider.provideTypeDefinition(j,re,H);return s(he)}}class S{constructor(P,W){this._documents=P,this._provider=W}async provideHover(P,W,H){const j=this._documents.getDocument(P),re=C.Position.to(W),he=await this._provider.provideHover(j,re,H);if(!(!he||(0,R.isFalsyOrEmpty)(he.contents)))return he.range||(he.range=j.getWordRangeAtPosition(re)),he.range||(he.range=new M.Range(re,re)),C.Hover.from(he)}}class a{constructor(P,W){this._documents=P,this._provider=W}async provideEvaluatableExpression(P,W,H){const j=this._documents.getDocument(P),re=C.Position.to(W),he=await this._provider.provideEvaluatableExpression(j,re,H);if(he)return C.EvaluatableExpression.from(he)}}class o{constructor(P,W){this._documents=P,this._provider=W}async provideInlineValues(P,W,H,j){const re=this._documents.getDocument(P),he=await this._provider.provideInlineValues(re,C.Range.to(W),C.InlineValueContext.to(H),j);if(Array.isArray(he))return he.map(ie=>C.InlineValue.from(ie))}}class O{constructor(P,W){this._documents=P,this._provider=W}async provideDocumentHighlights(P,W,H){const j=this._documents.getDocument(P),re=C.Position.to(W),he=await this._provider.provideDocumentHighlights(j,re,H);if(Array.isArray(he))return he.map(C.DocumentHighlight.from)}}class ${constructor(P,W){this._documents=P,this._provider=W}async provideLinkedEditingRanges(P,W,H){const j=this._documents.getDocument(P),re=C.Position.to(W),he=await this._provider.provideLinkedEditingRanges(j,re,H);if(he&&Array.isArray(he.ranges))return{ranges:(0,R.coalesce)(he.ranges.map(C.Range.from)),wordPattern:he.wordPattern}}}class K{constructor(P,W){this._documents=P,this._provider=W}async provideReferences(P,W,H,j){const re=this._documents.getDocument(P),he=C.Position.to(W),ie=await this._provider.provideReferences(re,he,H,j);if(Array.isArray(ie))return ie.map(C.location.from)}}class V{constructor(P,W,H,j,re,he,ie){this._documents=P,this._commands=W,this._diagnostics=H,this._provider=j,this._logService=re,this._extension=he,this._apiDeprecation=ie,this._cache=new r.Cache("CodeAction"),this._disposables=new Map,this.nbKind=new M.CodeActionKind("notebook")}async provideCodeActions(P,W,H,j){const re=this._documents.getDocument(P),he=d.Selection.isISelection(W)?C.Selection.to(W):C.Range.to(W),ie=[];for(const qe of this._diagnostics.getDiagnostics(P))if(he.intersection(qe.range)&&ie.push(qe)>V._maxCodeActionsPerFile)break;const we={diagnostics:ie,only:H.only?new M.CodeActionKind(H.only):void 0,triggerKind:C.CodeActionTriggerKind.to(H.trigger)},Se=await this._provider.provideCodeActions(re,he,we,j);if(!(0,R.isNonEmptyArray)(Se)||j.isCancellationRequested)return;const $e=this._cache.add(Se),ze=new p.DisposableStore;this._disposables.set($e,ze);const Je=[];for(let qe=0;qe<Se.length;qe++){const Ge=Se[qe];if(Ge)if(V._isCommand(Ge))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Je.push({_isSynthetic:!0,title:Ge.title,command:this._commands.toInternal(Ge,ze)});else{if(we.triggerKind!==M.CodeActionTriggerKind.Invoke&&Ge.kind&&this.nbKind.contains(Ge.kind))continue;we.only&&(Ge.kind?we.only.contains(Ge.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action is of kind '${Ge.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Je.push({cacheId:[$e,qe],title:Ge.title,command:Ge.command&&this._commands.toInternal(Ge.command,ze),diagnostics:Ge.diagnostics&&Ge.diagnostics.map(C.Diagnostic.from),edit:Ge.edit&&C.WorkspaceEdit.from(Ge.edit,void 0),kind:Ge.kind&&Ge.kind.value,isPreferred:Ge.isPreferred,disabled:Ge.disabled?.reason})}}return{cacheId:$e,actions:Je}}async resolveCodeAction(P,W){const[H,j]=P,re=this._cache.get(H,j);if(!re||V._isCommand(re))return{};if(!this._provider.resolveCodeAction)return{};const he=await this._provider.resolveCodeAction(re,W)??re;let ie;he.edit&&(ie=C.WorkspaceEdit.from(he.edit,void 0));let we;if(he.command){const Se=this._disposables.get(H);Se&&(we=this._commands.toInternal(he.command,Se))}return{edit:ie,command:we}}releaseCodeActions(P){this._disposables.get(P)?.dispose(),this._disposables.delete(P),this._cache.delete(P)}static _isCommand(P){return typeof P.command=="string"&&typeof P.title=="string"}}V._maxCodeActionsPerFile=1e3;class z{constructor(P,W,H,j,re){this._proxy=P,this._documents=W,this._provider=H,this._handle=j,this._extension=re}async prepareDocumentPaste(P,W,H,j){if(!this._provider.prepareDocumentPaste)return;const re=this._documents.getDocument(P),he=W.map(Se=>C.Range.to(Se)),ie=C.DataTransfer.toDataTransfer(H,()=>{throw new b.NotImplementedError});if(await this._provider.prepareDocumentPaste(re,he,ie,j),j.isCancellationRequested)return;const we=Array.from(ie).filter(([,Se])=>!(Se instanceof M.InternalDataTransferItem));return C.DataTransfer.from(we)}async providePasteEdits(P,W,H,j,re){if(!this._provider.provideDocumentPasteEdits)return;const he=this._documents.getDocument(W),ie=H.map($e=>C.Range.to($e)),we=C.DataTransfer.toDataTransfer(j,async $e=>(await this._proxy.$resolvePasteFileData(this._handle,P,$e)).buffer),Se=await this._provider.provideDocumentPasteEdits(he,ie,we,re);if(Se)return{id:Se.id?this._extension.identifier.value+"."+Se.id:this._extension.identifier.value,label:Se.label??(0,i.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,priority:Se.priority??0,insertText:typeof Se.insertText=="string"?Se.insertText:{snippet:Se.insertText.value},additionalEdit:Se.additionalEdit?C.WorkspaceEdit.from(Se.additionalEdit,void 0):void 0}}}class N{constructor(P,W){this._documents=P,this._provider=W}async provideDocumentFormattingEdits(P,W,H){const j=this._documents.getDocument(P),re=await this._provider.provideDocumentFormattingEdits(j,W,H);if(Array.isArray(re))return re.map(C.TextEdit.from)}}class q{constructor(P,W){this._documents=P,this._provider=W}async provideDocumentRangeFormattingEdits(P,W,H,j){const re=this._documents.getDocument(P),he=C.Range.to(W),ie=await this._provider.provideDocumentRangeFormattingEdits(re,he,H,j);if(Array.isArray(ie))return ie.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(P,W,H,j){(0,y.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const re=this._documents.getDocument(P),he=W.map(C.Range.to),ie=await this._provider.provideDocumentRangesFormattingEdits(re,he,H,j);if(Array.isArray(ie))return ie.map(C.TextEdit.from)}}class B{constructor(P,W){this._documents=P,this._provider=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(P,W,H,j,re){const he=this._documents.getDocument(P),ie=C.Position.to(W),we=await this._provider.provideOnTypeFormattingEdits(he,ie,H,j,re);if(Array.isArray(we))return we.map(C.TextEdit.from)}}class U{constructor(P,W){this._provider=P,this._logService=W,this._cache=new r.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(P,W){const H=await this._provider.provideWorkspaceSymbols(P,W);if(!(0,R.isNonEmptyArray)(H))return{symbols:[]};const j=this._cache.add(H),re={cacheId:j,symbols:[]};for(let he=0;he<H.length;he++){const ie=H[he];if(!ie||!ie.name){this._logService.warn("INVALID SymbolInformation",ie);continue}re.symbols.push({...C.WorkspaceSymbol.from(ie),cacheId:[j,he]})}return re}async resolveWorkspaceSymbol(P,W){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!P.cacheId)return P;const H=this._cache.get(...P.cacheId);if(H){const j=await this._provider.resolveWorkspaceSymbol(H,W);return j&&(0,k.mixin)(P,C.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(P){this._cache.delete(P)}}class le{static supportsResolving(P){return typeof P.prepareRename=="function"}constructor(P,W,H){this._documents=P,this._provider=W,this._logService=H}async provideRenameEdits(P,W,H,j){const re=this._documents.getDocument(P),he=C.Position.to(W);try{const ie=await this._provider.provideRenameEdits(re,he,H,j);return ie?C.WorkspaceEdit.from(ie):void 0}catch(ie){const we=le._asMessage(ie);return we?{rejectReason:we,edits:void 0}:Promise.reject(ie)}}async resolveRenameLocation(P,W,H){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const j=this._documents.getDocument(P),re=C.Position.to(W);try{const he=await this._provider.prepareRename(j,re,H);let ie,we;if(M.Range.isRange(he)?(ie=he,we=j.getText(he)):(0,y.isObject)(he)&&(ie=he.range,we=he.placeholder),!ie||!we)return;if(ie.start.line>re.line||ie.end.line<re.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ie),text:we}}catch(he){const ie=le._asMessage(he);return ie?{rejectReason:ie,range:void 0,text:void 0}:Promise.reject(he)}}static _asMessage(P){return typeof P=="string"?P:P instanceof Error&&typeof P.message=="string"?P.message:void 0}}class ve{constructor(P,W){this.resultId=P,this.tokens=W}}class Pe{constructor(P,W){this._documents=P,this._provider=W,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(P,W,H){const j=this._documents.getDocument(P),re=W!==0?this._previousResults.get(W):null;let he=typeof re?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(j,re.resultId,H):await this._provider.provideDocumentSemanticTokens(j,H);return re&&this._previousResults.delete(W),he?(he=Pe._fixProvidedSemanticTokens(he),this._send(Pe._convertToEdits(re,he),he)):null}async releaseDocumentSemanticColoring(P){this._previousResults.delete(P)}static _fixProvidedSemanticTokens(P){return Pe._isSemanticTokens(P)?Pe._isCorrectSemanticTokens(P)?P:new M.SemanticTokens(new Uint32Array(P.data),P.resultId):Pe._isSemanticTokensEdits(P)?Pe._isCorrectSemanticTokensEdits(P)?P:new M.SemanticTokensEdits(P.edits.map(W=>new M.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),P.resultId):P}static _isSemanticTokens(P){return P&&!!P.data}static _isCorrectSemanticTokens(P){return P.data instanceof Uint32Array}static _isSemanticTokensEdits(P){return P&&Array.isArray(P.edits)}static _isCorrectSemanticTokensEdits(P){for(const W of P.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(P,W){if(!Pe._isSemanticTokens(W)||!P||!P.tokens)return W;const H=P.tokens,j=H.length,re=W.data,he=re.length;let ie=0;const we=Math.min(j,he);for(;ie<we&&H[ie]===re[ie];)ie++;if(ie===j&&ie===he)return new M.SemanticTokensEdits([],W.resultId);let Se=0;const $e=we-ie;for(;Se<$e&&H[j-Se-1]===re[he-Se-1];)Se++;return new M.SemanticTokensEdits([{start:ie,deleteCount:j-ie-Se,data:re.subarray(ie,he-Se)}],W.resultId)}_send(P,W){if(Pe._isSemanticTokens(P)){const H=this._nextResultId++;return this._previousResults.set(H,new ve(P.resultId,P.data)),(0,l.encodeSemanticTokensDto)({id:H,type:"full",data:P.data})}if(Pe._isSemanticTokensEdits(P)){const H=this._nextResultId++;return Pe._isSemanticTokens(W)?this._previousResults.set(H,new ve(W.resultId,W.data)):this._previousResults.set(H,new ve(P.resultId)),(0,l.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(P.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}class J{constructor(P,W){this._documents=P,this._provider=W}async provideDocumentRangeSemanticTokens(P,W,H){const j=this._documents.getDocument(P),re=await this._provider.provideDocumentRangeSemanticTokens(j,C.Range.to(W),H);return re?this._send(re):null}_send(P){return(0,l.encodeSemanticTokensDto)({id:0,type:"full",data:P.data})}}class X{static supportsResolving(P){return typeof P.resolveCompletionItem=="function"}constructor(P,W,H,j,re){this._documents=P,this._commands=W,this._provider=H,this._apiDeprecation=j,this._extension=re,this._cache=new r.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(P,W,H,j){const re=this._documents.getDocument(P),he=C.Position.to(W),ie=re.getWordRangeAtPosition(he)||new M.Range(he,he),we=ie.with({end:he}),Se=new c.StopWatch,$e=await this._provider.provideCompletionItems(re,he,j,C.CompletionContext.to(H));if(!$e||j.isCancellationRequested)return;const ze=Array.isArray($e)?new M.CompletionList($e):$e,Je=X.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),qe=new p.DisposableStore;this._disposables.set(Je,qe);const Ge=[],it={x:Je,b:Ge,a:{replace:C.Range.from(ie),insert:C.Range.from(we)},c:ze.isIncomplete||void 0,d:Se.elapsed()};for(let ct=0;ct<ze.items.length;ct++){const et=ze.items[ct],rt=this._convertCompletionItem(et,[Je,ct],we,ie);Ge.push(rt)}return it}async resolveCompletionItem(P,W){if(typeof this._provider.resolveCompletionItem!="function")return;const H=this._cache.get(...P);if(!H)return;const j=this._convertCompletionItem(H,P),re=await this._provider.resolveCompletionItem(H,W);if(!re)return;const he=this._convertCompletionItem(re,P);return(j.h!==he.h||j.i!==he.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(j.n!==he.n||j.o!==he.o||!(0,k.equals)(j.p,he.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...j,d:he.d,c:he.c,l:he.l,h:he.h,i:he.i,n:he.n,o:he.o,p:he.p}}releaseCompletionItems(P){this._disposables.get(P)?.dispose(),this._disposables.delete(P),this._cache.delete(P)}_convertCompletionItem(P,W,H,j){const re=this._disposables.get(W[0]);if(!re)throw Error("DisposableStore is missing...");const he=this._commands.toInternal(P.command,re),ie={x:W,a:P.label,b:P.kind!==void 0?C.CompletionItemKind.from(P.kind):void 0,m:P.tags&&P.tags.map(C.CompletionItemTag.from),c:P.detail,d:typeof P.documentation>"u"?void 0:C.MarkdownString.fromStrict(P.documentation),e:P.sortText!==P.label?P.sortText:void 0,f:P.filterText!==P.label?P.filterText:void 0,g:P.preselect||void 0,i:P.keepWhitespace?1:0,k:P.commitCharacters?.join(""),l:P.additionalTextEdits&&P.additionalTextEdits.map(C.TextEdit.from),n:he?.$ident,o:he?.id,p:he?.$ident?void 0:he?.arguments};P.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ie.h=P.textEdit.newText):typeof P.insertText=="string"?ie.h=P.insertText:P.insertText instanceof M.SnippetString&&(ie.h=P.insertText.value,ie.i|=4);let we;return P.textEdit?we=P.textEdit.range:P.range&&(we=P.range),M.Range.isRange(we)?ie.j=C.Range.from(we):we&&(!H?.isEqual(we.inserting)||!j?.isEqual(we.replacing))&&(ie.j={insert:C.Range.from(we.inserting),replace:C.Range.from(we.replacing)}),ie}}class ce{async provideInlineCompletions(P,W,H,j){}disposeCompletions(P){}handleDidShowCompletionItem(P,W,H){}handlePartialAccept(P,W,H){}}class De extends ce{constructor(P,W,H,j){super(),this._extension=P,this._documents=W,this._provider=H,this._commands=j,this._references=new ke,this._isAdditionsProposedApiEnabled=(0,_.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[F.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[F.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,_.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(P,W,H,j){const re=this._documents.getDocument(P),he=C.Position.to(W),ie=await this._provider.provideInlineCompletionItems(re,he,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:C.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},j);if(!ie||j.isCancellationRequested)return;const we=Array.isArray(ie)?ie:ie.items,Se=this._isAdditionsProposedApiEnabled?Array.isArray(ie)?[]:ie.commands||[]:[],$e=this._isAdditionsProposedApiEnabled&&!Array.isArray(ie)?ie.suppressSuggestions:void 0,ze=this._isAdditionsProposedApiEnabled&&!Array.isArray(ie)?ie.enableForwardStability:void 0;let Je;return{pid:this._references.createReferenceId({dispose(){Je?.dispose()},items:we}),items:we.map((Ge,it)=>{let ct;Ge.command&&(Je||(Je=new p.DisposableStore),ct=this._commands.toInternal(Ge.command,Je));const et=Ge.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:Ge.filterText,range:Ge.range?C.Range.from(Ge.range):void 0,command:ct,idx:it,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ge.completeBracketPairs:!1}}),commands:Se.map(Ge=>(Je||(Je=new p.DisposableStore),this._commands.toInternal(Ge,Je))),suppressSuggestions:$e,enableForwardStability:ze}}disposeCompletions(P){this._references.disposeReferenceId(P)?.dispose()}handleDidShowCompletionItem(P,W,H){const j=this._references.get(P)?.items[W];j&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(j,H)}handlePartialAccept(P,W,H){const j=this._references.get(P)?.items[W];j&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(j,H)}}class ke{constructor(){this._references=new Map,this._idPool=1}createReferenceId(P){const W=this._idPool++;return this._references.set(W,P),W}disposeReferenceId(P){const W=this._references.get(P);return this._references.delete(P),W}get(P){return this._references.get(P)}}class ge{constructor(P,W){this._documents=P,this._provider=W,this._cache=new r.Cache("SignatureHelp")}async provideSignatureHelp(P,W,H,j){const re=this._documents.getDocument(P),he=C.Position.to(W),ie=this.reviveContext(H),we=await this._provider.provideSignatureHelp(re,he,j,ie);if(we){const Se=this._cache.add([we]);return{...C.SignatureHelp.from(we),id:Se}}}reviveContext(P){let W;if(P.activeSignatureHelp){const H=C.SignatureHelp.to(P.activeSignatureHelp),j=this._cache.get(P.activeSignatureHelp.id,0);j?(W=j,W.activeSignature=H.activeSignature,W.activeParameter=H.activeParameter):W=H}return{...P,activeSignatureHelp:W}}releaseSignatureHelp(P){this._cache.delete(P)}}class A{constructor(P,W,H,j,re){this._documents=P,this._commands=W,this._provider=H,this._logService=j,this._extension=re,this._cache=new r.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(P,W,H){const j=this._documents.getDocument(P),re=C.Range.to(W),he=await this._provider.provideInlayHints(j,re,H);if(!Array.isArray(he)||he.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${W}`);return}if(H.isCancellationRequested)return;const ie=this._cache.add(he);this._disposables.set(ie,new p.DisposableStore);const we={hints:[],cacheId:ie};for(let Se=0;Se<he.length;Se++)this._isValidInlayHint(he[Se],re)&&we.hints.push(this._convertInlayHint(he[Se],[ie,Se]));return this._logService.trace(`[InlayHints] ${we.hints.length} inlay hints from '${this._extension.identifier.value}' for ${W}`),we}async resolveInlayHint(P,W){if(typeof this._provider.resolveInlayHint!="function")return;const H=this._cache.get(...P);if(!H)return;const j=await this._provider.resolveInlayHint(H,W);if(j&&this._isValidInlayHint(j))return this._convertInlayHint(j,P)}releaseHints(P){this._disposables.get(P)?.dispose(),this._disposables.delete(P),this._cache.delete(P)}_isValidInlayHint(P,W){return P.label.length===0||Array.isArray(P.label)&&P.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",P),!1):!(W&&!W.contains(P.position))}_convertInlayHint(P,W){const H=this._disposables.get(W[0]);if(!H)throw Error("DisposableStore is missing...");const j={label:"",cacheId:W,tooltip:C.MarkdownString.fromStrict(P.tooltip),position:C.Position.from(P.position),textEdits:P.textEdits&&P.textEdits.map(C.TextEdit.from),kind:P.kind&&C.InlayHintKind.from(P.kind),paddingLeft:P.paddingLeft,paddingRight:P.paddingRight};return typeof P.label=="string"?j.label=P.label:j.label=P.label.map(re=>{const he={label:re.value};return he.tooltip=C.MarkdownString.fromStrict(re.tooltip),M.Location.isLocation(re.location)&&(he.location=C.location.from(re.location)),re.command&&(he.command=this._commands.toInternal(re.command,H)),he}),j}}class G{constructor(P,W){this._documents=P,this._provider=W,this._cache=new r.Cache("DocumentLink")}async provideLinks(P,W){const H=this._documents.getDocument(P),j=await this._provider.provideDocumentLinks(H,W);if(!(!Array.isArray(j)||j.length===0)&&!W.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:j.filter(G._validateLink).map(C.DocumentLink.from)};{const re=this._cache.add(j),he={links:[],cacheId:re};for(let ie=0;ie<j.length;ie++){if(!G._validateLink(j[ie]))continue;const we=C.DocumentLink.from(j[ie]);we.cacheId=[re,ie],he.links.push(we)}return he}}}static _validateLink(P){return P.target&&P.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(P,W){if(typeof this._provider.resolveDocumentLink!="function")return;const H=this._cache.get(...P);if(!H)return;const j=await this._provider.resolveDocumentLink(H,W);if(!(!j||!G._validateLink(j)))return C.DocumentLink.from(j)}releaseLinks(P){this._cache.delete(P)}}class de{constructor(P,W){this._documents=P,this._provider=W}async provideColors(P,W){const H=this._documents.getDocument(P),j=await this._provider.provideDocumentColors(H,W);return Array.isArray(j)?j.map(he=>({color:C.Color.from(he.color),range:C.Range.from(he.range)})):[]}async provideColorPresentations(P,W,H){const j=this._documents.getDocument(P),re=C.Range.to(W.range),he=C.Color.to(W.color),ie=await this._provider.provideColorPresentations(he,{document:j,range:re},H);if(Array.isArray(ie))return ie.map(C.ColorPresentation.from)}}class ye{constructor(P,W){this._documents=P,this._provider=W}async provideFoldingRanges(P,W,H){const j=this._documents.getDocument(P),re=await this._provider.provideFoldingRanges(j,W,H);if(Array.isArray(re))return re.map(C.FoldingRange.from)}}class _e{constructor(P,W,H){this._documents=P,this._provider=W,this._logService=H}async provideSelectionRanges(P,W,H){const j=this._documents.getDocument(P),re=W.map(C.Position.to),he=await this._provider.provideSelectionRanges(j,re,H);if(!(0,R.isNonEmptyArray)(he))return[];if(he.length!==re.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ie=[];for(let we=0;we<re.length;we++){const Se=[];ie.push(Se);let $e=re[we],ze=he[we];for(;;){if(!ze.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(Se.push(C.SelectionRange.from(ze)),!ze.parent)break;$e=ze.range,ze=ze.parent}}return ie}}class pe{constructor(P,W){this._documents=P,this._provider=W,this._idPool=new t.IdGenerator(""),this._cache=new Map}async prepareSession(P,W,H){const j=this._documents.getDocument(P),re=C.Position.to(W),he=await this._provider.prepareCallHierarchy(j,re,H);if(!he)return;const ie=this._idPool.nextId();return this._cache.set(ie,new Map),Array.isArray(he)?he.map(we=>this._cacheAndConvertItem(ie,we)):[this._cacheAndConvertItem(ie,he)]}async provideCallsTo(P,W,H){const j=this._itemFromCache(P,W);if(!j)throw new Error("missing call hierarchy item");const re=await this._provider.provideCallHierarchyIncomingCalls(j,H);if(re)return re.map(he=>({from:this._cacheAndConvertItem(P,he.from),fromRanges:he.fromRanges.map(ie=>C.Range.from(ie))}))}async provideCallsFrom(P,W,H){const j=this._itemFromCache(P,W);if(!j)throw new Error("missing call hierarchy item");const re=await this._provider.provideCallHierarchyOutgoingCalls(j,H);if(re)return re.map(he=>({to:this._cacheAndConvertItem(P,he.to),fromRanges:he.fromRanges.map(ie=>C.Range.from(ie))}))}releaseSession(P){this._cache.delete(P)}_cacheAndConvertItem(P,W){const H=this._cache.get(P),j=C.CallHierarchyItem.from(W,P,H.size.toString(36));return H.set(j._itemId,W),j}_itemFromCache(P,W){return this._cache.get(P)?.get(W)}}class Ce{constructor(P,W){this._documents=P,this._provider=W,this._idPool=new t.IdGenerator(""),this._cache=new Map}async prepareSession(P,W,H){const j=this._documents.getDocument(P),re=C.Position.to(W),he=await this._provider.prepareTypeHierarchy(j,re,H);if(!he)return;const ie=this._idPool.nextId();return this._cache.set(ie,new Map),Array.isArray(he)?he.map(we=>this._cacheAndConvertItem(ie,we)):[this._cacheAndConvertItem(ie,he)]}async provideSupertypes(P,W,H){const j=this._itemFromCache(P,W);if(!j)throw new Error("missing type hierarchy item");const re=await this._provider.provideTypeHierarchySupertypes(j,H);if(re)return re.map(he=>this._cacheAndConvertItem(P,he))}async provideSubtypes(P,W,H){const j=this._itemFromCache(P,W);if(!j)throw new Error("missing type hierarchy item");const re=await this._provider.provideTypeHierarchySubtypes(j,H);if(re)return re.map(he=>this._cacheAndConvertItem(P,he))}releaseSession(P){this._cache.delete(P)}_cacheAndConvertItem(P,W){const H=this._cache.get(P),j=C.TypeHierarchyItem.from(W,P,H.size.toString(36));return H.set(j._itemId,W),j}_itemFromCache(P,W){return this._cache.get(P)?.get(W)}}class ae{constructor(P,W,H,j,re){this._proxy=P,this._documents=W,this._provider=H,this._handle=j,this._extension=re}async provideDocumentOnDropEdits(P,W,H,j,re){const he=this._documents.getDocument(W),ie=C.Position.to(H),we=C.DataTransfer.toDataTransfer(j,async $e=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,P,$e)).buffer),Se=await this._provider.provideDocumentDropEdits(he,ie,we,re);if(Se)return{id:Se.id?this._extension.identifier.value+"."+Se.id:this._extension.identifier.value,label:Se.label??(0,i.localize)(1,null,this._extension.displayName||this._extension.name),priority:Se.priority??0,insertText:typeof Se.insertText=="string"?Se.insertText:{snippet:Se.insertText.value},additionalEdit:Se.additionalEdit?C.WorkspaceEdit.from(Se.additionalEdit,void 0):void 0}}}class ue{constructor(P,W){this.adapter=P,this.extension=W}}class ne{constructor(P,W,H,j,re,he,ie,we){this._uriTransformer=W,this._documents=H,this._commands=j,this._diagnostics=re,this._logService=he,this._apiDeprecation=ie,this._extensionTelemetry=we,this._adapter=new Map,this._proxy=P.getProxy(f.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(P,W){return C.DocumentSelector.from(P,this._uriTransformer,W)}_createDisposable(P){return new M.Disposable(()=>{this._adapter.delete(P),this._proxy.$unregister(P)})}_nextHandle(){return ne._handlePool++}async _withAdapter(P,W,H,j,re,he=!1){const ie=this._adapter.get(P);if(!ie||!(ie.adapter instanceof W))return j;const we=Date.now();he||this._logService.trace(`[${ie.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Se=H(ie.adapter,ie.extension);return Promise.resolve(Se).catch($e=>{(0,b.isCancellationError)($e)||(this._logService.error(`[${ie.extension.identifier.value}] provider FAILED`),this._logService.error($e),this._extensionTelemetry.onExtensionError(ie.extension.identifier,$e))}).finally(()=>{he||this._logService.trace(`[${ie.extension.identifier.value}] provider DONE after ${Date.now()-we}ms`)}),E.CancellationToken.isCancellationToken(re)?(0,w.raceCancellationError)(Se,re):Se}_addNewAdapter(P,W){const H=this._nextHandle();return this._adapter.set(H,new ue(P,W)),H}static _extLabel(P){return P.displayName||P.name}registerDocumentSymbolProvider(P,W,H,j){const re=this._addNewAdapter(new u(this._documents,H),P),he=j&&j.label||ne._extLabel(P);return this._proxy.$registerDocumentSymbolProvider(re,this._transformDocumentSelector(W,P),he),this._createDisposable(re)}$provideDocumentSymbols(P,W,H){return this._withAdapter(P,u,j=>j.provideDocumentSymbols(m.URI.revive(W),H),void 0,H)}registerCodeLensProvider(P,W,H){const j=this._nextHandle(),re=typeof H.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(j,new ue(new n(this._documents,this._commands.converter,H),P)),this._proxy.$registerCodeLensSupport(j,this._transformDocumentSelector(W,P),re);let he=this._createDisposable(j);if(re!==void 0){const ie=H.onDidChangeCodeLenses(we=>this._proxy.$emitCodeLensEvent(re));he=M.Disposable.from(he,ie)}return he}$provideCodeLenses(P,W,H){return this._withAdapter(P,n,j=>j.provideCodeLenses(m.URI.revive(W),H),void 0,H)}$resolveCodeLens(P,W,H){return this._withAdapter(P,n,j=>j.resolveCodeLens(W,H),void 0,void 0)}$releaseCodeLenses(P,W){this._withAdapter(P,n,H=>Promise.resolve(H.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(P,W,H){const j=this._addNewAdapter(new v(this._documents,H),P);return this._proxy.$registerDefinitionSupport(j,this._transformDocumentSelector(W,P)),this._createDisposable(j)}$provideDefinition(P,W,H,j){return this._withAdapter(P,v,re=>re.provideDefinition(m.URI.revive(W),H,j),[],j)}registerDeclarationProvider(P,W,H){const j=this._addNewAdapter(new I(this._documents,H),P);return this._proxy.$registerDeclarationSupport(j,this._transformDocumentSelector(W,P)),this._createDisposable(j)}$provideDeclaration(P,W,H,j){return this._withAdapter(P,I,re=>re.provideDeclaration(m.URI.revive(W),H,j),[],j)}registerImplementationProvider(P,W,H){const j=this._addNewAdapter(new h(this._documents,H),P);return this._proxy.$registerImplementationSupport(j,this._transformDocumentSelector(W,P)),this._createDisposable(j)}$provideImplementation(P,W,H,j){return this._withAdapter(P,h,re=>re.provideImplementation(m.URI.revive(W),H,j),[],j)}registerTypeDefinitionProvider(P,W,H){const j=this._addNewAdapter(new T(this._documents,H),P);return this._proxy.$registerTypeDefinitionSupport(j,this._transformDocumentSelector(W,P)),this._createDisposable(j)}$provideTypeDefinition(P,W,H,j){return this._withAdapter(P,T,re=>re.provideTypeDefinition(m.URI.revive(W),H,j),[],j)}registerHoverProvider(P,W,H,j){const re=this._addNewAdapter(new S(this._documents,H),P);return this._proxy.$registerHoverProvider(re,this._transformDocumentSelector(W,P)),this._createDisposable(re)}$provideHover(P,W,H,j){return this._withAdapter(P,S,re=>re.provideHover(m.URI.revive(W),H,j),void 0,j)}registerEvaluatableExpressionProvider(P,W,H,j){const re=this._addNewAdapter(new a(this._documents,H),P);return this._proxy.$registerEvaluatableExpressionProvider(re,this._transformDocumentSelector(W,P)),this._createDisposable(re)}$provideEvaluatableExpression(P,W,H,j){return this._withAdapter(P,a,re=>re.provideEvaluatableExpression(m.URI.revive(W),H,j),void 0,j)}registerInlineValuesProvider(P,W,H,j){const re=typeof H.onDidChangeInlineValues=="function"?this._nextHandle():void 0,he=this._addNewAdapter(new o(this._documents,H),P);this._proxy.$registerInlineValuesProvider(he,this._transformDocumentSelector(W,P),re);let ie=this._createDisposable(he);if(re!==void 0){const we=H.onDidChangeInlineValues(Se=>this._proxy.$emitInlineValuesEvent(re));ie=M.Disposable.from(ie,we)}return ie}$provideInlineValues(P,W,H,j,re){return this._withAdapter(P,o,he=>he.provideInlineValues(m.URI.revive(W),H,j,re),void 0,re)}registerDocumentHighlightProvider(P,W,H){const j=this._addNewAdapter(new O(this._documents,H),P);return this._proxy.$registerDocumentHighlightProvider(j,this._transformDocumentSelector(W,P)),this._createDisposable(j)}$provideDocumentHighlights(P,W,H,j){return this._withAdapter(P,O,re=>re.provideDocumentHighlights(m.URI.revive(W),H,j),void 0,j)}registerLinkedEditingRangeProvider(P,W,H){const j=this._addNewAdapter(new $(this._documents,H),P);return this._proxy.$registerLinkedEditingRangeProvider(j,this._transformDocumentSelector(W,P)),this._createDisposable(j)}$provideLinkedEditingRanges(P,W,H,j){return this._withAdapter(P,$,async re=>{const he=await re.provideLinkedEditingRanges(m.URI.revive(W),H,j);if(he)return{ranges:he.ranges,wordPattern:he.wordPattern?ne._serializeRegExp(he.wordPattern):void 0}},void 0,j)}registerReferenceProvider(P,W,H){const j=this._addNewAdapter(new K(this._documents,H),P);return this._proxy.$registerReferenceSupport(j,this._transformDocumentSelector(W,P)),this._createDisposable(j)}$provideReferences(P,W,H,j,re){return this._withAdapter(P,K,he=>he.provideReferences(m.URI.revive(W),H,j,re),void 0,re)}registerCodeActionProvider(P,W,H,j){const re=new p.DisposableStore,he=this._addNewAdapter(new V(this._documents,this._commands.converter,this._diagnostics,H,this._logService,P,this._apiDeprecation),P);return this._proxy.$registerQuickFixSupport(he,this._transformDocumentSelector(W,P),{providedKinds:j?.providedCodeActionKinds?.map(ie=>ie.value),documentation:j?.documentation?.map(ie=>({kind:ie.kind.value,command:this._commands.converter.toInternal(ie.command,re)}))},ne._extLabel(P),!!H.resolveCodeAction),re.add(this._createDisposable(he)),re}$provideCodeActions(P,W,H,j,re){return this._withAdapter(P,V,he=>he.provideCodeActions(m.URI.revive(W),H,j,re),void 0,re)}$resolveCodeAction(P,W,H){return this._withAdapter(P,V,j=>j.resolveCodeAction(W,H),{},void 0)}$releaseCodeActions(P,W){this._withAdapter(P,V,H=>Promise.resolve(H.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(P,W,H){const j=this._addNewAdapter(new N(this._documents,H),P);return this._proxy.$registerDocumentFormattingSupport(j,this._transformDocumentSelector(W,P),P.identifier,P.displayName||P.name),this._createDisposable(j)}$provideDocumentFormattingEdits(P,W,H,j){return this._withAdapter(P,N,re=>re.provideDocumentFormattingEdits(m.URI.revive(W),H,j),void 0,j)}registerDocumentRangeFormattingEditProvider(P,W,H){const j=typeof H.provideDocumentRangesFormattingEdits=="function";j&&(0,_.checkProposedApiEnabled)(P,"formatMultipleRanges");const re=this._addNewAdapter(new q(this._documents,H),P);return this._proxy.$registerRangeFormattingSupport(re,this._transformDocumentSelector(W,P),P.identifier,P.displayName||P.name,j),this._createDisposable(re)}$provideDocumentRangeFormattingEdits(P,W,H,j,re){return this._withAdapter(P,q,he=>he.provideDocumentRangeFormattingEdits(m.URI.revive(W),H,j,re),void 0,re)}$provideDocumentRangesFormattingEdits(P,W,H,j,re){return this._withAdapter(P,q,he=>he.provideDocumentRangesFormattingEdits(m.URI.revive(W),H,j,re),void 0,re)}registerOnTypeFormattingEditProvider(P,W,H,j){const re=this._addNewAdapter(new B(this._documents,H),P);return this._proxy.$registerOnTypeFormattingSupport(re,this._transformDocumentSelector(W,P),j,P.identifier),this._createDisposable(re)}$provideOnTypeFormattingEdits(P,W,H,j,re,he){return this._withAdapter(P,B,ie=>ie.provideOnTypeFormattingEdits(m.URI.revive(W),H,j,re,he),void 0,he)}registerWorkspaceSymbolProvider(P,W){const H=this._addNewAdapter(new U(W,this._logService),P);return this._proxy.$registerNavigateTypeSupport(H,typeof W.resolveWorkspaceSymbol=="function"),this._createDisposable(H)}$provideWorkspaceSymbols(P,W,H){return this._withAdapter(P,U,j=>j.provideWorkspaceSymbols(W,H),{symbols:[]},H)}$resolveWorkspaceSymbol(P,W,H){return this._withAdapter(P,U,j=>j.resolveWorkspaceSymbol(W,H),void 0,void 0)}$releaseWorkspaceSymbols(P,W){this._withAdapter(P,U,H=>H.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(P,W,H){const j=this._addNewAdapter(new le(this._documents,H,this._logService),P);return this._proxy.$registerRenameSupport(j,this._transformDocumentSelector(W,P),le.supportsResolving(H)),this._createDisposable(j)}$provideRenameEdits(P,W,H,j,re){return this._withAdapter(P,le,he=>he.provideRenameEdits(m.URI.revive(W),H,j,re),void 0,re)}$resolveRenameLocation(P,W,H,j){return this._withAdapter(P,le,re=>re.resolveRenameLocation(m.URI.revive(W),H,j),void 0,j)}registerDocumentSemanticTokensProvider(P,W,H,j){const re=this._addNewAdapter(new Pe(this._documents,H),P),he=typeof H.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(re,this._transformDocumentSelector(W,P),j,he);let ie=this._createDisposable(re);if(he){const we=H.onDidChangeSemanticTokens(Se=>this._proxy.$emitDocumentSemanticTokensEvent(he));ie=M.Disposable.from(ie,we)}return ie}$provideDocumentSemanticTokens(P,W,H,j){return this._withAdapter(P,Pe,re=>re.provideDocumentSemanticTokens(m.URI.revive(W),H,j),null,j)}$releaseDocumentSemanticTokens(P,W){this._withAdapter(P,Pe,H=>H.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(P,W,H,j){const re=this._addNewAdapter(new J(this._documents,H),P);return this._proxy.$registerDocumentRangeSemanticTokensProvider(re,this._transformDocumentSelector(W,P),j),this._createDisposable(re)}$provideDocumentRangeSemanticTokens(P,W,H,j){return this._withAdapter(P,J,re=>re.provideDocumentRangeSemanticTokens(m.URI.revive(W),H,j),null,j)}registerCompletionItemProvider(P,W,H,j){const re=this._addNewAdapter(new X(this._documents,this._commands.converter,H,this._apiDeprecation,P),P);return this._proxy.$registerCompletionsProvider(re,this._transformDocumentSelector(W,P),j,X.supportsResolving(H),P.identifier),this._createDisposable(re)}$provideCompletionItems(P,W,H,j,re){return this._withAdapter(P,X,he=>he.provideCompletionItems(m.URI.revive(W),H,j,re),void 0,re)}$resolveCompletionItem(P,W,H){return this._withAdapter(P,X,j=>j.resolveCompletionItem(W,H),void 0,H)}$releaseCompletionItems(P,W){this._withAdapter(P,X,H=>H.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(P,W,H){const j=new De(P,this._documents,H,this._commands.converter),re=this._addNewAdapter(j,P);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(W,P),j.supportsHandleEvents),this._createDisposable(re)}$provideInlineCompletions(P,W,H,j,re){return this._withAdapter(P,ce,he=>he.provideInlineCompletions(m.URI.revive(W),H,j,re),void 0,re)}$handleInlineCompletionDidShow(P,W,H,j){this._withAdapter(P,ce,async re=>{re.handleDidShowCompletionItem(W,H,j)},void 0,void 0)}$handleInlineCompletionPartialAccept(P,W,H,j){this._withAdapter(P,ce,async re=>{re.handlePartialAccept(W,H,j)},void 0,void 0)}$freeInlineCompletionsList(P,W){this._withAdapter(P,ce,async H=>{H.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(P,W,H,j){const re=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,he=this._addNewAdapter(new ge(this._documents,H),P);return this._proxy.$registerSignatureHelpProvider(he,this._transformDocumentSelector(W,P),re),this._createDisposable(he)}$provideSignatureHelp(P,W,H,j,re){return this._withAdapter(P,ge,he=>he.provideSignatureHelp(m.URI.revive(W),H,j,re),void 0,re)}$releaseSignatureHelp(P,W){this._withAdapter(P,ge,H=>H.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(P,W,H){const j=typeof H.onDidChangeInlayHints=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new A(this._documents,this._commands.converter,H,this._logService,P),P);this._proxy.$registerInlayHintsProvider(re,this._transformDocumentSelector(W,P),typeof H.resolveInlayHint=="function",j,ne._extLabel(P));let he=this._createDisposable(re);if(j!==void 0){const ie=H.onDidChangeInlayHints(we=>this._proxy.$emitInlayHintsEvent(j));he=M.Disposable.from(he,ie)}return he}$provideInlayHints(P,W,H,j){return this._withAdapter(P,A,re=>re.provideInlayHints(m.URI.revive(W),H,j),void 0,j)}$resolveInlayHint(P,W,H){return this._withAdapter(P,A,j=>j.resolveInlayHint(W,H),void 0,H)}$releaseInlayHints(P,W){this._withAdapter(P,A,H=>H.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(P,W,H){const j=this._addNewAdapter(new G(this._documents,H),P);return this._proxy.$registerDocumentLinkProvider(j,this._transformDocumentSelector(W,P),typeof H.resolveDocumentLink=="function"),this._createDisposable(j)}$provideDocumentLinks(P,W,H){return this._withAdapter(P,G,j=>j.provideLinks(m.URI.revive(W),H),void 0,H,W.scheme==="output")}$resolveDocumentLink(P,W,H){return this._withAdapter(P,G,j=>j.resolveLink(W,H),void 0,void 0,!0)}$releaseDocumentLinks(P,W){this._withAdapter(P,G,H=>H.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(P,W,H){const j=this._addNewAdapter(new de(this._documents,H),P);return this._proxy.$registerDocumentColorProvider(j,this._transformDocumentSelector(W,P)),this._createDisposable(j)}$provideDocumentColors(P,W,H){return this._withAdapter(P,de,j=>j.provideColors(m.URI.revive(W),H),[],H)}$provideColorPresentations(P,W,H,j){return this._withAdapter(P,de,re=>re.provideColorPresentations(m.URI.revive(W),H,j),void 0,j)}registerFoldingRangeProvider(P,W,H){const j=this._nextHandle(),re=typeof H.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(j,new ue(new ye(this._documents,H),P)),this._proxy.$registerFoldingRangeProvider(j,this._transformDocumentSelector(W,P),P.identifier,re);let he=this._createDisposable(j);if(re!==void 0){const ie=H.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(re));he=M.Disposable.from(he,ie)}return he}$provideFoldingRanges(P,W,H,j){return this._withAdapter(P,ye,re=>re.provideFoldingRanges(m.URI.revive(W),H,j),void 0,j)}registerSelectionRangeProvider(P,W,H){const j=this._addNewAdapter(new _e(this._documents,H,this._logService),P);return this._proxy.$registerSelectionRangeProvider(j,this._transformDocumentSelector(W,P)),this._createDisposable(j)}$provideSelectionRanges(P,W,H,j){return this._withAdapter(P,_e,re=>re.provideSelectionRanges(m.URI.revive(W),H,j),[],j)}registerCallHierarchyProvider(P,W,H){const j=this._addNewAdapter(new pe(this._documents,H),P);return this._proxy.$registerCallHierarchyProvider(j,this._transformDocumentSelector(W,P)),this._createDisposable(j)}$prepareCallHierarchy(P,W,H,j){return this._withAdapter(P,pe,re=>Promise.resolve(re.prepareSession(m.URI.revive(W),H,j)),void 0,j)}$provideCallHierarchyIncomingCalls(P,W,H,j){return this._withAdapter(P,pe,re=>re.provideCallsTo(W,H,j),void 0,j)}$provideCallHierarchyOutgoingCalls(P,W,H,j){return this._withAdapter(P,pe,re=>re.provideCallsFrom(W,H,j),void 0,j)}$releaseCallHierarchy(P,W){this._withAdapter(P,pe,H=>Promise.resolve(H.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(P,W,H){const j=this._addNewAdapter(new Ce(this._documents,H),P);return this._proxy.$registerTypeHierarchyProvider(j,this._transformDocumentSelector(W,P)),this._createDisposable(j)}$prepareTypeHierarchy(P,W,H,j){return this._withAdapter(P,Ce,re=>Promise.resolve(re.prepareSession(m.URI.revive(W),H,j)),void 0,j)}$provideTypeHierarchySupertypes(P,W,H,j){return this._withAdapter(P,Ce,re=>re.provideSupertypes(W,H,j),void 0,j)}$provideTypeHierarchySubtypes(P,W,H,j){return this._withAdapter(P,Ce,re=>re.provideSubtypes(W,H,j),void 0,j)}$releaseTypeHierarchy(P,W){this._withAdapter(P,Ce,H=>Promise.resolve(H.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(P,W,H,j){const re=this._nextHandle();return this._adapter.set(re,new ue(new ae(this._proxy,this._documents,H,re,P),P)),this._proxy.$registerDocumentOnDropEditProvider(re,this._transformDocumentSelector(W,P),(0,_.isProposedApiEnabled)(P,"dropMetadata")?j:void 0),this._createDisposable(re)}$provideDocumentOnDropEdits(P,W,H,j,re,he){return this._withAdapter(P,ae,ie=>Promise.resolve(ie.provideDocumentOnDropEdits(W,m.URI.revive(H),j,re,he)),void 0,void 0)}registerDocumentPasteEditProvider(P,W,H,j){const re=this._nextHandle();return this._adapter.set(re,new ue(new z(this._proxy,this._documents,H,re,P),P)),this._proxy.$registerPasteEditProvider(re,this._transformDocumentSelector(W,P),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,copyMimeTypes:j.copyMimeTypes,pasteMimeTypes:j.pasteMimeTypes}),this._createDisposable(re)}$prepareDocumentPaste(P,W,H,j,re){return this._withAdapter(P,z,he=>he.prepareDocumentPaste(m.URI.revive(W),H,j,re),void 0,re)}$providePasteEdits(P,W,H,j,re,he){return this._withAdapter(P,z,ie=>ie.providePasteEdits(W,m.URI.revive(H),j,re,he),void 0,he)}static _serializeRegExp(P){return{pattern:P.source,flags:(0,D.regExpFlags)(P)}}static _serializeIndentationRule(P){return{decreaseIndentPattern:ne._serializeRegExp(P.decreaseIndentPattern),increaseIndentPattern:ne._serializeRegExp(P.increaseIndentPattern),indentNextLinePattern:P.indentNextLinePattern?ne._serializeRegExp(P.indentNextLinePattern):void 0,unIndentedLinePattern:P.unIndentedLinePattern?ne._serializeRegExp(P.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(P){return{beforeText:ne._serializeRegExp(P.beforeText),afterText:P.afterText?ne._serializeRegExp(P.afterText):void 0,previousLineText:P.previousLineText?ne._serializeRegExp(P.previousLineText):void 0,action:P.action}}static _serializeOnEnterRules(P){return P.map(ne._serializeOnEnterRule)}setLanguageConfiguration(P,W,H){const{wordPattern:j}=H;if(j&&(0,D.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this._documents.setWordDefinitionFor(W,j):this._documents.setWordDefinitionFor(W,void 0),H.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",P,"Do not use."),H.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",P,"Do not use.");const re=this._nextHandle(),he={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?ne._serializeRegExp(H.wordPattern):void 0,indentationRules:H.indentationRules?ne._serializeIndentationRule(H.indentationRules):void 0,onEnterRules:H.onEnterRules?ne._serializeOnEnterRules(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this._proxy.$setLanguageConfiguration(re,W,he),this._createDisposable(re)}$setWordDefinitions(P){for(const W of P)this._documents.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.ExtHostLanguageFeatures=ne,ne._handlePool=0}),define(Ae[233],Re([1,0,4,8,7,29,16,6]),function(te,e,m,k,C,M,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(R,y,d,E){this._documents=y,this._commands=d,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(m.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,y){await this._proxy.$changeLanguage(R,y);const d=this._documents.getDocumentData(R);if(!d)throw new Error(`document '${R.toString()}' NOT found`);return d.document}async tokenAtPosition(R,y){const d=R.version,E=k.Position.from(y),p=await this._proxy.$tokensAtPosition(R.uri,E),l={type:C.StandardTokenType.Other,range:R.getWordRangeAtPosition(y)??new C.Range(y.line,y.character,y.line,y.character)};if(!p)return l;const t={range:k.Range.to(p.range),type:k.TokenType.to(p.type)};return!t.range.contains(y)||d!==R.version?l:t}createLanguageStatusItem(R,y,d){const E=this._handlePool++,p=this._proxy,l=this._ids,t=`${R.identifier.value}/${y}`;if(l.has(t))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);l.add(t);const r={selector:d,id:y,name:R.displayName??R.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const b=new f.DisposableStore,w=()=>{c?.dispose(),c=(0,F.disposableTimeout)(()=>{b.clear(),this._proxy.$setLanguageStatus(E,{id:t,name:r.name??R.displayName??R.name,source:R.displayName??R.name,selector:k.DocumentSelector.from(r.selector,this._uriTransformer),label:r.text,detail:r.detail??"",severity:r.severity===C.LanguageStatusSeverity.Error?M.default.Error:r.severity===C.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:r.command&&this._commands.toInternal(r.command,b),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},_={dispose(){b.dispose(),c?.dispose(),p.$removeLanguageStatus(E),l.delete(t)},get id(){return r.id},get name(){return r.name},set name(i){r.name=i,w()},get selector(){return r.selector},set selector(i){r.selector=i,w()},get text(){return r.text},set text(i){r.text=i,w()},get detail(){return r.detail},set detail(i){r.detail=i,w()},get severity(){return r.severity},set severity(i){r.severity=i,w()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(i){r.accessibilityInformation=i,w()},get command(){return r.command},set command(i){r.command=i,w()},get busy(){return r.busy},set busy(i){r.busy=i,w()}};return w(),_}}e.ExtHostLanguages=D}),define(Ae[82],Re([1,0,21,13,2,3,15,4,27,17]),function(te,e,m,k,C,M,F,f,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=e.ExtHostLocalizationService=class{constructor(d,E,p){this.logService=p,this.bundleCache=new Map,this._proxy=E.getProxy(f.MainContext.MainThreadLocalization),this.currentLanguage=d.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===m.LANGUAGE_DEFAULT}getMessage(d,E){const{message:p,args:l,comment:t}=E;if(this.isDefaultLanguage)return(0,k.format2)(p,l??{});let r=p;t&&t.length>0&&(r+=`/${Array.isArray(t)?t.join(""):t}`);const c=this.bundleCache.get(d)?.contents[r];return c||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,k.format2)(c??p,l??{})}getBundle(d){return this.bundleCache.get(d)?.contents}getBundleUri(d){return this.bundleCache.get(d)?.uri}async initializeLocalizedMessages(d){if(this.isDefaultLanguage||!d.l10n&&!d.isBuiltin||this.bundleCache.has(d.identifier.value))return;let E;const p=await this.getBundleLocation(d);if(!p){this.logService.error(`No bundle location found for extension ${d.identifier.value}`);return}try{const l=await this._proxy.$fetchBundleContents(p),t=JSON.parse(l);E=d.isBuiltin?t.contents?.bundle:t}catch(l){this.logService.error(`Failed to load translations for ${d.identifier.value} from ${p}: ${l.message}`);return}E&&this.bundleCache.set(d.identifier.value,{contents:E,uri:p})}async getBundleLocation(d){if(d.isBuiltin){const E=await this._proxy.$fetchBuiltInBundleUri(d.identifier.value,this.currentLanguage);return C.URI.revive(E)}return d.l10n?C.URI.joinPath(d.extensionLocation,d.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=R=Ve([He(0,D.IExtHostInitDataService),He(1,g.IExtHostRpcService),He(2,F.ILogService)],R),e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(Ae[234],Re([1,0,15,4,27,17,2,69]),function(te,e,m,k,C,M,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=e.ExtHostLoggerService=class extends m.AbstractLoggerService{constructor(y,d){super(d.logLevel,d.logsLocation,d.loggers.map(E=>(0,f.revive)(E))),this._proxy=y.getProxy(k.MainContext.MainThreadLogger)}$setLogLevel(y,d){d?this.setLogLevel(F.URI.revive(d),y):this.setLogLevel(y)}setVisibility(y,d){super.setVisibility(y,d),this._proxy.$setVisibility(y,d)}doCreateLogger(y,d,E){return new g(this._proxy,y,d,E)}};e.ExtHostLoggerService=D=Ve([He(0,M.IExtHostRpcService),He(1,C.IExtHostInitDataService)],D);class g extends m.AbstractMessageLogger{constructor(y,d,E,p){super(p?.logLevel==="always"),this.proxy=y,this.file=d,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(E),this.proxy.$createLogger(d,p).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,d){const E=[[y,d]];this.isLoggerCreated?this.doLog(E):this.buffer.push(...E)}doLog(y){this.proxy.$log(this.file,y)}flush(){this.proxy.$flush(this.file)}}}),define(Ae[83],Re([1,0,4,3,6,17,25]),function(te,e,m,k,C,M,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,k.createDecorator)("IExtHostManagedSockets");let f=e.ExtHostManagedSockets=class{constructor(y){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=y.getProxy(m.MainContext.MainThreadManagedSockets)}setFactory(y,d){for(const E of this._managedRemoteSockets.values())E.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new D(y,d),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(y){if(!this._factory||this._factory.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const d=++this._remoteSocketIdCounter,E=await this._factory.makeConnection(),p=new C.DisposableStore;return this._managedRemoteSockets.set(d,new g(d,E,p)),p.add((0,C.toDisposable)(()=>this._managedRemoteSockets.delete(d))),p.add(E.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(d),p.dispose()})),p.add(E.onDidClose(l=>{this._proxy.$onDidManagedSocketClose(d,l?.stack??l?.message),p.dispose()})),p.add(E.onDidReceiveMessage(l=>this._proxy.$onDidManagedSocketHaveData(d,F.VSBuffer.wrap(l)))),d}$remoteSocketWrite(y,d){this._managedRemoteSockets.get(y)?.actual.send(d.buffer)}$remoteSocketEnd(y){const d=this._managedRemoteSockets.get(y);d&&(d.actual.end(),d.dispose())}async $remoteSocketDrain(y){await this._managedRemoteSockets.get(y)?.actual.drain?.()}};e.ExtHostManagedSockets=f=Ve([He(0,M.IExtHostRpcService)],f);class D{constructor(y,d){this.socketFactoryId=y,this.makeConnection=d}}class g extends C.Disposable{constructor(y,d,E){super(),this.socketId=y,this.actual=d,this._register(E)}}}),define(Ae[235],Re([1,0,4,15,26]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(f){return f&&f.title}let F=e.ExtHostMessageService=class{constructor(D,g){this._logService=g,this._proxy=D.getProxy(m.MainContext.MainThreadMessageService)}showMessage(D,g,R,y,d){const E={source:{identifier:D.identifier,label:D.displayName||D.name}};let p;typeof y=="string"||M(y)?p=[y,...d]:(E.modal=y?.modal,E.useCustom=y?.useCustom,E.detail=y?.detail,p=d),E.useCustom&&(0,C.checkProposedApiEnabled)(D,"resolvers");const l=[];for(let t=0;t<p.length;t++){const r=p[t];if(typeof r=="string")l.push({title:r,handle:t,isCloseAffordance:!1});else if(typeof r=="object"){const{title:c,isCloseAffordance:b}=r;l.push({title:c,isCloseAffordance:!!b,handle:t})}else this._logService.warn("Invalid message item:",r)}return this._proxy.$showMessage(g,R,E,l).then(t=>{if(typeof t=="number")return p[t]})}};e.ExtHostMessageService=F=Ve([He(1,k.ILogService)],F)}),define(Ae[236],Re([1,0,25,5,6,28,13,10,2,38,54,4,32,8,7,46,203,103,9,20,23]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l,t,r,c,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class _{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(u=>u.apiEditor)}constructor(u,n,s,v,I){this._textDocumentsAndEditors=s,this._textDocuments=v,this._extHostFileSystem=I,this._notebookStatusBarItemProviders=new Map,this._documents=new M.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new k.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new k.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new k.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new k.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=u.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=u.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=u.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=n.converter,n.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===13){const T=h.notebookEditor?.notebookUri,S=h.cell.handle,o=this._documents.get(T)?.getCell(S);if(o)return o.apiCell}if(h&&h.$mid===14){const T=h.uri,S=this._documents.get(T);if(S)return S.apiNotebook}return h}}),_._registerApiCommands(n)}getEditorById(u){const n=this._editors.get(u);if(!n)throw new Error(`unknown text editor: ${u}. known editors: ${[...this._editors.keys()]} `);return n}getIdByEditor(u){for(const[n,s]of this._editors)if(s.apiEditor===u)return n}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(u,n){const s=this._documents.get(u);if(!s&&!n)throw new Error(`NO notebook document for '${u}'`);return s}static _convertNotebookRegistrationData(u,n){if(!n)return;const s=n.filenamePattern.map(v=>E.NotebookExclusiveDocumentPattern.from(v)).filter(v=>v!==void 0);if(n.filenamePattern&&!s){console.warn(`Notebook content provider view options file name pattern is invalid ${n.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:n.displayName,filenamePattern:s,exclusive:n.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,n,s){const v=_._notebookStatusBarItemProviderHandlePool++,I=typeof s.onDidChangeCellStatusBarItems=="function"?_._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(v,s),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(v,I,n);let h;return I!==void 0&&(h=s.onDidChangeCellStatusBarItems(T=>this._notebookProxy.$emitCellStatusBarEvent(I))),new p.Disposable(()=>{this._notebookStatusBarItemProviders.delete(v),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(v,I),h?.dispose()})}async createNotebookDocument(u){const n=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:u.viewType,content:u.content&&E.NotebookData.from(u.content)});return D.URI.revive(n)}async openNotebookDocument(u){const n=this._documents.get(u);if(n)return n.apiNotebook;const s=await this._notebookDocumentsProxy.$tryOpenNotebook(u),v=this._documents.get(D.URI.revive(s));return(0,f.assertIsDefined)(v?.apiNotebook)}async showNotebookDocument(u,n){D.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let s;typeof n=="object"?s={position:E.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus,selections:n.selections&&n.selections.map(E.NotebookRange.from),pinned:typeof n.preview=="boolean"?!n.preview:void 0}:s={preserveFocus:!1};const v=await this._notebookEditorsProxy.$tryShowNotebookDocument(u.uri,u.notebookType,s),I=v&&this._editors.get(v)?.apiEditor;if(I)return I;throw v?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,n,s,v){const I=this._notebookStatusBarItemProviders.get(u),h=D.URI.revive(n),T=this._documents.get(h);if(!T||!I)return;const S=T.getCellFromIndex(s);if(!S)return;const a=await I.provideCellStatusBarItems(S.apiCell,v);if(!a)return;const o=new C.DisposableStore,O=this._statusBarCache.add([o]),K=(Array.isArray(a)?a:[a]).map(V=>E.NotebookStatusBarItem.from(V,this._commandsConverter,o));return{cacheId:O,items:K}}$releaseNotebookCellStatusBarItems(u){this._statusBarCache.delete(u)}registerNotebookSerializer(u,n,s,v,I){if((0,F.isFalsyOrWhitespace)(n))throw new Error("viewType cannot be empty or just whitespace");const h=this._handlePool++;return this._notebookSerializer.set(h,{viewType:n,serializer:s,options:v}),this._notebookProxy.$registerNotebookSerializer(h,{id:u.identifier,location:u.extensionLocation},n,E.NotebookDocumentContentOptions.from(v),_._convertNotebookRegistrationData(u,I)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(h)})}async $dataToNotebook(u,n,s){const v=this._notebookSerializer.get(u);if(!v)throw new Error("NO serializer found");const I=await v.serializer.deserializeNotebook(n.buffer,s);return new l.SerializableObjectWithBuffers(E.NotebookData.from(I))}async $notebookToData(u,n,s){const v=this._notebookSerializer.get(u);if(!v)throw new Error("NO serializer found");const I=await v.serializer.serializeNotebook(E.NotebookData.to(n.value),s);return m.VSBuffer.wrap(I)}async $saveNotebook(u,n,s,v,I){const h=D.URI.revive(n),T=this._notebookSerializer.get(u);if(!T)throw new Error("NO serializer found");const S=this._documents.get(h);if(!S)throw new Error("Document NOT found");if(S.versionId!==s)throw new Error("Document version mismatch");const a={metadata:(0,w.filter)(S.apiNotebook.metadata,K=>!(T.options?.transientDocumentMetadata??{})[K]),cells:[]};for(const K of S.apiNotebook.getCells()){const V=new p.NotebookCellData(K.kind,K.document.getText(),K.document.languageId,K.mime,T.options?.transientOutputs?[]:[...K.outputs],K.metadata,K.executionSummary);V.metadata=(0,w.filter)(K.metadata,z=>!(T.options?.transientCellMetadata??{})[z]),a.cells.push(V)}const o=await T.serializer.serializeNotebook(a,I);await this._extHostFileSystem.value.writeFile(h,o);const O=await this._extHostFileSystem.value.stat(h);return{name:(0,b.basename)(h),isFile:(O.type&g.FileType.File)!==0,isDirectory:(O.type&g.FileType.Directory)!==0,isSymbolicLink:(O.type&g.FileType.SymbolicLink)!==0,mtime:O.mtime,ctime:O.ctime,size:O.size,readonly:!!((O.permissions??0)&g.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(h.scheme),locked:!!((O.permissions??0)&g.FilePermission.Locked),etag:g.etag({mtime:O.mtime,size:O.size}),children:void 0}}_createExtHostEditor(u,n,s){if(this._editors.has(n))throw new Error(`editor with id ALREADY EXSIST: ${n}`);const v=new r.ExtHostNotebookEditor(n,this._notebookEditorsProxy,u,s.visibleRanges.map(E.NotebookRange.to),s.selections.map(E.NotebookRange.to),typeof s.viewColumn=="number"?E.ViewColumn.to(s.viewColumn):void 0);this._editors.set(n,v)}$acceptDocumentAndEditorsDelta(u){if(u.value.removedDocuments)for(const s of u.value.removedDocuments){const v=D.URI.revive(s),I=this._documents.get(v);I&&(I.dispose(),this._documents.delete(v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(h=>h.document.uri)}),this._onDidCloseNotebookDocument.fire(I.apiNotebook));for(const h of this._editors.values())h.notebookData.uri.toString()===v.toString()&&this._editors.delete(h.id)}if(u.value.addedDocuments){const s=[];for(const v of u.value.addedDocuments){const I=D.URI.revive(v.uri);if(this._documents.has(I))throw new Error(`adding EXISTING notebook ${I} `);const h=new t.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,I,v);s.push(...v.cells.map(T=>t.ExtHostCell.asModelAddData(h.apiNotebook,T))),this._documents.get(I)?.dispose(),this._documents.set(I,h),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:s}),this._onDidOpenNotebookDocument.fire(h.apiNotebook)}}if(u.value.addedEditors)for(const s of u.value.addedEditors){if(this._editors.has(s.id))return;const v=D.URI.revive(s.documentUri),I=this._documents.get(v);I&&this._createExtHostEditor(I,s.id,s)}const n=[];if(u.value.removedEditors)for(const s of u.value.removedEditors){const v=this._editors.get(s);v&&(this._editors.delete(s),this._activeNotebookEditor?.id===v.id&&(this._activeNotebookEditor=void 0),n.push(v))}if(u.value.visibleEditors){this._visibleNotebookEditors=u.value.visibleEditors.map(v=>this._editors.get(v)).filter(v=>!!v);const s=new Set;this._visibleNotebookEditors.forEach(v=>s.add(v.id));for(const v of this._editors.values()){const I=s.has(v.id);v._acceptVisibility(I)}this._visibleNotebookEditors=[...this._editors.values()].map(v=>v).filter(v=>v.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}u.value.newActiveEditor===null?this._activeNotebookEditor=void 0:u.value.newActiveEditor&&(this._editors.get(u.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${u.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(u.value.newActiveEditor)),u.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(u){const n=d.ApiCommandArgument.String.with("notebookType","A notebook type"),s=new d.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[n,new d.ApiCommandArgument("data","Bytes to convert to data",I=>I instanceof Uint8Array,I=>m.VSBuffer.wrap(I))],new d.ApiCommandResult("Notebook Data",I=>E.NotebookData.to(I.value))),v=new d.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[n,new d.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",I=>!0,I=>new l.SerializableObjectWithBuffers(E.NotebookData.from(I)))],new d.ApiCommandResult("Bytes",I=>I.buffer));u.registerApiCommand(s),u.registerApiCommand(v)}}e.ExtHostNotebookController=_,_._notebookStatusBarItemProviderHandlePool=0}),define(Ae[237],Re([1,0,18,16,22,5,6,28,2,24,15,54,4,32,8,7,78,196,26,46]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l,t,r,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let w=e.ExtHostNotebookKernels=class{constructor(h,T,S,a,o){this._initData=T,this._extHostNotebook=S,this._commands=a,this._logService=o,this._activeExecutions=new f.ResourceMap,this._activeNotebookExecutions=new f.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new y.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=h.getProxy(d.MainContext.MainThreadNotebookKernels);const O=new E.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new E.ApiCommandArgument("options","Select kernel options",$=>!0,$=>{if($&&"notebookEditor"in $&&"id"in $){const K=this._extHostNotebook.getIdByEditor($.notebookEditor);return{id:$.id,extension:$.extension,notebookEditorId:K}}else if($&&"notebookEditor"in $){const K=this._extHostNotebook.getIdByEditor($.notebookEditor);if(K===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${$.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:K}}return $})],E.ApiCommandResult.Void);this._commands.registerApiCommand(O)}createNotebookController(h,T,S,a,o,O){for(const De of this._kernelData.values())if(De.controller.id===T&&g.ExtensionIdentifier.equals(h.identifier,De.extensionId))throw new Error(`notebook controller with id '${T}' ALREADY exist`);const $=this._handlePool++,K=this;this._logService.trace(`NotebookController[${$}], CREATED by ${h.identifier.value}, ${T}`);const V=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${h.identifier}'`);let z=!1;const N=new F.DisposableStore,q=new M.Emitter,B=new M.Emitter,U={id:v(h.identifier,T),notebookType:S,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:a||h.identifier.value,preloads:O?O.map(p.NotebookRendererScript.from):[]};let le=o??V,ve;this._proxy.$addKernel($,U).catch(De=>{console.log(De),z=!0});let Pe=0;const J=()=>{if(z)return;const De=++Pe;Promise.resolve().then(()=>{De===Pe&&this._proxy.$updateKernel($,U)})},X=new f.ResourceMap,ce={get id(){return T},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:q.event,get label(){return U.label},set label(De){U.label=De??h.displayName??h.name,J()},get detail(){return U.detail??""},set detail(De){U.detail=De,J()},get description(){return U.description??""},set description(De){U.description=De,J()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(De){U.supportedLanguages=De,J()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(De){U.supportsExecutionOrder=De,J()},get rendererScripts(){return U.preloads?U.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return le},set executeHandler(De){le=De??V},get interruptHandler(){return ve},set interruptHandler(De){ve=De,U.supportsInterrupt=!!De,J()},createNotebookCellExecution(De){if(z)throw new Error("notebook controller is DISPOSED");if(!X.has(De.notebook.uri))throw K._logService.trace(`NotebookController[${$}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(ke=>ke.toString())),new Error(`notebook controller is NOT associated to notebook: ${De.notebook.uri.toString()}`);return K._createNotebookCellExecution(De,v(h.identifier,this.id))},createNotebookExecution(De){if((0,c.checkProposedApiEnabled)(h,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!X.has(De.uri))throw K._logService.trace(`NotebookController[${$}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(ke=>ke.toString())),new Error(`notebook controller is NOT associated to notebook: ${De.uri.toString()}`);return K._createNotebookExecution(De,v(h.identifier,this.id))},dispose:()=>{z||(this._logService.trace(`NotebookController[${$}], DISPOSED`),z=!0,this._kernelData.delete($),N.dispose(),q.dispose(),B.dispose(),this._proxy.$removeKernel($))},updateNotebookAffinity(De,ke){ke===l.NotebookControllerAffinity2.Hidden&&(0,c.checkProposedApiEnabled)(h,"notebookControllerAffinityHidden"),K._proxy.$updateNotebookPriority($,De.uri,ke)},onDidReceiveMessage:B.event,postMessage(De,ke){return(0,c.checkProposedApiEnabled)(h,"notebookMessaging"),K._proxy.$postMessage($,ke&&K._extHostNotebook.getIdByEditor(ke),De)},asWebviewUri(De){return(0,c.checkProposedApiEnabled)(h,"notebookMessaging"),(0,t.asWebviewUri)(De,K._initData.remote)}};return this._kernelData.set($,{extensionId:h.identifier,controller:ce,onDidReceiveMessage:B,onDidChangeSelection:q,associatedNotebooks:X}),ce}getIdByController(h){for(const[T,S]of this._kernelData)if(S.controller===h)return v(S.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,T){const S=this._kernelDetectionTaskHandlePool++,a=this;this._logService.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${h.identifier.value}`),this._proxy.$addKernelDetectionTask(S,T);const o={dispose:()=>{this._kernelDetectionTask.delete(S),a._proxy.$removeKernelDetectionTask(S)}};return this._kernelDetectionTask.set(S,o),o}registerKernelSourceActionProvider(h,T,S){const a=this._kernelSourceActionProviderHandlePool++,o=typeof S.onDidChangeNotebookKernelSourceActions=="function"?a:void 0,O=this;this._kernelSourceActionProviders.set(a,S),this._logService.trace(`NotebookKernelSourceActionProvider[${a}], CREATED by ${h.identifier.value}`),this._proxy.$addKernelSourceActionProvider(a,a,T);let $;return o!==void 0&&($=S.onDidChangeNotebookKernelSourceActions(K=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(o))),{dispose:()=>{this._kernelSourceActionProviders.delete(a),O._proxy.$removeKernelSourceActionProvider(a,a),$?.dispose()}}}async $provideKernelSourceActions(h,T){const S=this._kernelSourceActionProviders.get(h);if(S){const a=new F.DisposableStore;return this._kernelSourceActionProviderCache.add([a]),(await S.provideNotebookKernelSourceActions(T)??[]).map(O=>p.NotebookKernelSourceAction.from(O,this._commands.converter,a))}return[]}$acceptNotebookAssociation(h,T,S){const a=this._kernelData.get(h);if(a){const o=this._extHostNotebook.getNotebookDocument(D.URI.revive(T));S?a.associatedNotebooks.set(o.uri,!0):a.associatedNotebooks.delete(o.uri),this._logService.trace(`NotebookController[${h}] ASSOCIATE notebook`,o.uri.toString(),S),a.onDidChangeSelection.fire({selected:S,notebook:o.apiNotebook})}}async $executeCells(h,T,S){const a=this._kernelData.get(h);if(!a)return;const o=this._extHostNotebook.getNotebookDocument(D.URI.revive(T)),O=[];for(const $ of S){const K=o.getCell($);K&&O.push(K.apiCell)}try{this._logService.trace(`NotebookController[${h}] EXECUTE cells`,o.uri.toString(),O.length),await a.controller.executeHandler.call(a.controller,O,o.apiNotebook,a.controller)}catch($){this._logService.error(`NotebookController[${h}] execute cells FAILED`,$),console.error($)}}async $cancelCells(h,T,S){const a=this._kernelData.get(h);if(!a)return;const o=this._extHostNotebook.getNotebookDocument(D.URI.revive(T));if(a.controller.interruptHandler)await a.controller.interruptHandler.call(a.controller,o.apiNotebook);else for(const O of S){const $=o.getCell(O);$&&this._activeExecutions.get($.uri)?.cancel()}if(a.controller.interruptHandler){const O=this._activeNotebookExecutions.get(o.uri);S.length&&Array.isArray(O)&&O.length&&O.forEach($=>$.dispose())}}$acceptKernelMessageFromRenderer(h,T,S){const a=this._kernelData.get(h);if(!a)return;const o=this._extHostNotebook.getEditorById(T);a.onDidReceiveMessage.fire(Object.freeze({editor:o.apiEditor,message:S}))}$cellExecutionChanged(h,T,S){const o=this._extHostNotebook.getNotebookDocument(D.URI.revive(h)).getCell(T);if(o){const O=S?p.NotebookCellExecutionState.to(S):l.NotebookCellExecutionState.Idle;O!==void 0&&this._onDidChangeCellExecutionState.fire({cell:o.apiCell,state:O})}}_createNotebookCellExecution(h,T){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const a=this._extHostNotebook.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!a)throw new Error("invalid cell");if(this._activeExecutions.has(a.uri))throw new Error(`duplicate execution for ${a.uri}`);const o=new i(T,a,this._proxy);this._activeExecutions.set(a.uri,o);const O=o.onDidChangeState(()=>{o.state===_.Resolved&&(o.dispose(),O.dispose(),this._activeExecutions.delete(a.uri))});return o.asApiObject()}_createNotebookExecution(h,T){const S=this._extHostNotebook.getNotebookDocument(h.uri),a=h.getCells().find($=>{const K=S.getCellFromApiCell($);return K&&this._activeExecutions.has(K.uri)});if(a)throw new Error(`duplicate cell execution for ${a.document.uri}`);if(this._activeNotebookExecutions.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const o=new n(T,S,this._proxy),O=o.onDidChangeState(()=>{o.state===u.Resolved&&(o.dispose(),O.dispose(),this._activeNotebookExecutions.delete(S.uri))});return this._activeNotebookExecutions.set(S.uri,[o,O]),o.asApiObject()}};e.ExtHostNotebookKernels=w=Ve([He(4,R.ILogService)],w);var _;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(_||(_={}));class i extends F.Disposable{get state(){return this._state}constructor(h,T,S){super(),this._cell=T,this._proxy=S,this._handle=i.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=_.Init,this._tokenSource=this._register(new C.CancellationTokenSource),this._collector=new s(10,a=>this.update(a)),this._executionOrder=T.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,h,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(h){await this._collector.addItem(h)}async update(h){const T=Array.isArray(h)?h:[h];return this._proxy.$updateExecution(this._handle,new b.SerializableObjectWithBuffers(T))}verifyStateForOutput(){if(this._state===_.Init)throw new Error("Must call start before modifying cell output");if(this._state===_.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(h){let T=this._cell;if(h&&(T=this._cell.notebook.getCellFromApiCell(h)),!T)throw new Error("INVALID cell");return T.handle}validateAndConvertOutputs(h){return h.map(T=>{const S=l.NotebookCellOutput.ensureUniqueMimeTypes(T.items,!0);return S===T.items?p.NotebookCellOutput.from(T):p.NotebookCellOutput.from({items:S,id:T.id,metadata:T.metadata})})}async updateOutputs(h,T,S){const a=this.cellIndexToHandle(T),o=this.validateAndConvertOutputs((0,m.asArray)(h));return this.updateSoon({editType:r.CellExecutionUpdateType.Output,cellHandle:a,append:S,outputs:o})}async updateOutputItems(h,T,S){return h=l.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(h),!0),this.updateSoon({editType:r.CellExecutionUpdateType.OutputItems,items:h.map(p.NotebookCellOutputItem.from),outputId:T.id,append:S})}asApiObject(){const h=this;return Object.freeze({get token(){return h._tokenSource.token},get cell(){return h._cell.apiCell},get executionOrder(){return h._executionOrder},set executionOrder(S){h._executionOrder=S,h.update([{editType:r.CellExecutionUpdateType.ExecutionState,executionOrder:h._executionOrder}])},start(S){if(h._state===_.Resolved||h._state===_.Started)throw new Error("Cannot call start again");h._state=_.Started,h._onDidChangeState.fire(),h.update({editType:r.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,a){if(h._state===_.Resolved)throw new Error("Cannot call resolve twice");h._state=_.Resolved,h._onDidChangeState.fire(),h._collector.flush(),h._proxy.$completeExecution(h._handle,new b.SerializableObjectWithBuffers({runEndTime:a,lastRunSuccess:S}))},clearOutput(S){return h.verifyStateForOutput(),h.updateOutputs([],S,!1)},appendOutput(S,a){return h.verifyStateForOutput(),h.updateOutputs(S,a,!0)},replaceOutput(S,a){return h.verifyStateForOutput(),h.updateOutputs(S,a,!1)},appendOutputItems(S,a){return h.verifyStateForOutput(),h.updateOutputItems(S,a,!0)},replaceOutputItems(S,a){return h.verifyStateForOutput(),h.updateOutputItems(S,a,!1)}})}}i.HANDLE=0;var u;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(u||(u={}));class n extends F.Disposable{get state(){return this._state}constructor(h,T,S){super(),this._notebook=T,this._proxy=S,this._handle=n.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=u.Init,this._tokenSource=this._register(new C.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,h,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===u.Resolved||this._state===u.Started)throw new Error("Cannot call start again");this._state=u.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===u.Resolved)throw new Error("Cannot call resolve twice");this._state=u.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}n.HANDLE=0;class s{constructor(h,T){this.delay=h,this.callback=T,this.batch=[],this.startedTimer=Date.now()}addItem(h){return this.batch.push(h),this.currentDeferred||(this.currentDeferred=new k.DeferredPromise,this.startedTimer=Date.now(),(0,k.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const h=this.currentDeferred;this.currentDeferred=void 0;const T=this.batch;return this.batch=[],this.callback(T).finally(()=>h.complete())}}function v(I,h){return`${I.value}/${h}`}e.createKernelId=v}),define(Ae[238],Re([1,0,5,4,103]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(f,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=f.getProxy(k.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(f,D,g){const R=this._extHostNotebook.getEditorById(f);this._rendererMessageEmitters.get(D)?.fire({editor:R.apiEditor,message:g})}createRendererMessaging(f,D){if(!f.contributes?.notebookRenderer?.some(R=>R.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(R,y,d)=>this.getOrCreateEmitterFor(D).event(R,y,d),postMessage:(R,y)=>{C.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,y]=[y,R]);const d=y&&C.ExtHostNotebookEditor.apiEditorsToExtHost.get(y);return this.proxy.$postMessage(d?.id,D,R)}}}getOrCreateEmitterFor(f){let D=this._rendererMessageEmitters.get(f);return D||(D=new m.Emitter({onDidRemoveLastListener:()=>{D?.dispose(),this._rendererMessageEmitters.delete(f)}}),this._rendererMessageEmitters.set(f,D),D)}}e.ExtHostNotebookRenderers=M}),define(Ae[239],Re([1,0,6,10,2,26,4]),function(te,e,m,k,C,M,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class f{constructor(g){this.handlers=new Map,this.proxy=g.getProxy(F.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,R,y){if((0,M.checkProposedApiEnabled)(g,"profileContentHandlers"),this.handlers.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.handlers.set(R,y),this.proxy.$registerProfileContentHandler(R,y.name,y.description,g.identifier.value),(0,m.toDisposable)(()=>{this.handlers.delete(R),this.proxy.$unregisterProfileContentHandler(R)})}async $saveProfile(g,R,y,d){const E=this.handlers.get(g);if(!E)throw new Error(`Unknown handler with id: ${g}`);return E.saveProfile(R,y,d)}async $readProfile(g,R,y){const d=this.handlers.get(g);if(!d)throw new Error(`Unknown handler with id: ${g}`);return d.readProfile((0,k.isString)(R)?R:C.URI.revive(R),y)}}e.ExtHostProfileContentHandlers=f}),define(Ae[240],Re([1,0,2,4,16,8]),function(te,e,m,k,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class F{constructor(D,g){this.uriTransformer=g,this.providers=new Map,this.proxy=D.getProxy(k.MainContext.MainThreadQuickDiff)}$provideOriginalResource(D,g,R){const y=m.URI.revive(g),d=this.providers.get(D);return d?(0,C.asPromise)(()=>d.provideOriginalResource(y,R)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(D,g,R,y){const d=F.handlePool++;return this.providers.set(d,g),this.proxy.$registerQuickDiffProvider(d,M.DocumentSelector.from(D,this.uriTransformer),R,y),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(d),this.providers.delete(d)}}}}e.ExtHostQuickDiff=F,F.handlePool=0}),define(Ae[241],Re([1,0,22,5,6,4,2,7,9,18,29,40,26,8]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(l,t,r){const c=l.getProxy(M.MainContext.MainThreadQuickOpen);class b{constructor(h,T){this._sessions=new Map,this._instances=0,this._workspace=h,this._commands=T}showQuickPick(h,T,S,a=m.CancellationToken.None){this._onDidSelectItem=void 0;const o=Promise.resolve(T),O=++this._instances,$=c.$show(O,{title:S?.title,placeHolder:S?.placeHolder,matchOnDescription:S?.matchOnDescription,matchOnDetail:S?.matchOnDetail,ignoreFocusLost:S?.ignoreFocusOut,canPickMany:S?.canPickMany},a),K={},V=$.then(()=>K);return Promise.race([V,o]).then(z=>{if(z===K)return;const N=(0,d.isProposedApiEnabled)(h,"quickPickItemTooltip"),q=(0,d.isProposedApiEnabled)(h,"quickPickItemIcon");return o.then(B=>{const U=[];for(let le=0;le<B.length;le++){const ve=B[le];if(typeof ve=="string")U.push({label:ve,handle:le});else if(ve.kind===f.QuickPickItemKind.Separator)U.push({type:"separator",label:ve.label});else{ve.tooltip&&!N&&console.warn(`Extension '${h.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${h.identifier.value}`),ve.iconPath&&!q&&console.warn(`Extension '${h.identifier.value}' uses an icon which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${h.identifier.value}`);const Pe=ve.iconPath&&q?n(ve.iconPath):void 0;U.push({label:ve.label,iconPath:Pe?.iconPath,iconClass:Pe?.iconClass,description:ve.description,detail:ve.detail,picked:ve.picked,alwaysShow:ve.alwaysShow,tooltip:N?E.MarkdownString.fromStrict(ve.tooltip):void 0,handle:le})}}return S&&typeof S.onDidSelectItem=="function"&&(this._onDidSelectItem=le=>{S.onDidSelectItem(B[le])}),c.$setItems(O,U),$.then(le=>{if(typeof le=="number")return B[le];if(Array.isArray(le))return le.map(ve=>B[ve])})})}).then(void 0,z=>{if(!(0,D.isCancellationError)(z))return c.$setError(O,z),Promise.reject(z)})}$onItemSelected(h){this._onDidSelectItem?.(h)}showInput(h,T=m.CancellationToken.None){return this._validateInput=h?.validateInput,c.$input(h,typeof this._validateInput=="function",T).then(void 0,S=>{if(!(0,D.isCancellationError)(S))return Promise.reject(S)})}async $validateInput(h){if(!this._validateInput)return;const T=await this._validateInput(h);if(!T||typeof T=="string")return T;let S;switch(T.severity){case f.InputBoxValidationSeverity.Info:S=R.default.Info;break;case f.InputBoxValidationSeverity.Warning:S=R.default.Warning;break;case f.InputBoxValidationSeverity.Error:S=R.default.Error;break;default:S=T.message?R.default.Error:R.default.Ignore;break}return{content:T.message,severity:S}}async showWorkspaceFolderPick(h,T=m.CancellationToken.None){const S=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[h]);if(!S)return;const a=await this._workspace.getWorkspaceFolders2();if(a)return a.find(o=>o.uri.toString()===S.uri.toString())}createQuickPick(h){const T=new s(h,()=>this._sessions.delete(T._id));return this._sessions.set(T._id,T),T}createInputBox(h){const T=new v(h,()=>this._sessions.delete(T._id));return this._sessions.set(T._id,T),T}$onDidChangeValue(h,T){this._sessions.get(h)?._fireDidChangeValue(T)}$onDidAccept(h){this._sessions.get(h)?._fireDidAccept()}$onDidChangeActive(h,T){const S=this._sessions.get(h);S instanceof s&&S._fireDidChangeActive(T)}$onDidChangeSelection(h,T){const S=this._sessions.get(h);S instanceof s&&S._fireDidChangeSelection(T)}$onDidTriggerButton(h,T){this._sessions.get(h)?._fireDidTriggerButton(T)}$onDidTriggerItemButton(h,T,S){const a=this._sessions.get(h);a instanceof s&&a._fireDidTriggerItemButton(T,S)}$onDidHide(h){this._sessions.get(h)?._fireDidHide()}}class w{constructor(h,T){this._extensionId=h,this._onDidDispose=T,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(h){this._title=h,this.update({title:h})}get step(){return this._steps}set step(h){this._steps=h,this.update({step:h})}get totalSteps(){return this._totalSteps}set totalSteps(h){this._totalSteps=h,this.update({totalSteps:h})}get enabled(){return this._enabled}set enabled(h){this._enabled=h,this.update({enabled:h})}get busy(){return this._busy}set busy(h){this._busy=h,this.update({busy:h})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(h){this._ignoreFocusOut=h,this.update({ignoreFocusOut:h})}get value(){return this._value}set value(h){this._value=h,this.update({value:h})}get placeholder(){return this._placeholder}set placeholder(h){this._placeholder=h,this.update({placeholder:h})}get buttons(){return this._buttons}set buttons(h){this._buttons=h.slice(),this._handlesToButtons.clear(),h.forEach((T,S)=>{const a=T===f.QuickInputButtons.Back?-1:S;this._handlesToButtons.set(a,T)}),this.update({buttons:h.map((T,S)=>({...n(T.iconPath),tooltip:T.tooltip,handle:T===f.QuickInputButtons.Back?-1:S}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(h){this._value=h,this._onDidChangeValueEmitter.fire(h)}_fireDidTriggerButton(h){const T=this._handlesToButtons.get(h);T&&this._onDidTriggerButtonEmitter.fire(T)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),c.$dispose(this._id))}update(h){if(!this._disposed){for(const T of Object.keys(h)){const S=h[T];this._pendingUpdate[T]=S===void 0?null:S}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){c.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}w._nextId=1;function _(I){if(I instanceof f.ThemeIcon)return{id:I.id};const h=u(I),T=i(I);return{dark:typeof h=="string"?F.URI.file(h):h,light:typeof T=="string"?F.URI.file(T):T}}function i(I){return typeof I=="object"&&"light"in I?I.light:I}function u(I){return typeof I=="object"&&"dark"in I?I.dark:I}function n(I){const h=_(I);let T,S;return"id"in h?S=y.ThemeIcon.asClassName(h):T=h,{iconPath:T,iconClass:S}}class s extends w{constructor(h,T){super(h.identifier,T),this.extension=h,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this._onDidTriggerItemButtonEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(h){this._items=h.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),h.forEach((o,O)=>{this._handlesToItems.set(O,o),this._itemsToHandles.set(o,O)});const T=(0,d.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),S=(0,d.isProposedApiEnabled)(this.extension,"quickPickItemIcon"),a=[];for(let o=0;o<h.length;o++){const O=h[o];if(O.kind===f.QuickPickItemKind.Separator)a.push({type:"separator",label:O.label});else{O.tooltip&&!T&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`),O.iconPath&&!S&&console.warn(`Extension '${this.extension.identifier.value}' uses an icon which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const $=O.iconPath&&S?n(O.iconPath):void 0;a.push({handle:o,label:O.label,iconPath:$?.iconPath,iconClass:$?.iconClass,description:O.description,detail:O.detail,picked:O.picked,alwaysShow:O.alwaysShow,tooltip:T?E.MarkdownString.fromStrict(O.tooltip):void 0,buttons:O.buttons?.map((K,V)=>({...n(K.iconPath),tooltip:K.tooltip,handle:V}))})}}this.update({items:a})}get canSelectMany(){return this._canSelectMany}set canSelectMany(h){this._canSelectMany=h,this.update({canSelectMany:h})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(h){this._matchOnDescription=h,this.update({matchOnDescription:h})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(h){this._matchOnDetail=h,this.update({matchOnDetail:h})}get sortByLabel(){return this._sortByLabel}set sortByLabel(h){this._sortByLabel=h,this.update({sortByLabel:h})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(h){this._keepScrollPosition=h,this.update({keepScrollPosition:h})}get activeItems(){return this._activeItems}set activeItems(h){this._activeItems=h.filter(T=>this._itemsToHandles.has(T)),this.update({activeItems:this._activeItems.map(T=>this._itemsToHandles.get(T))})}get selectedItems(){return this._selectedItems}set selectedItems(h){this._selectedItems=h.filter(T=>this._itemsToHandles.has(T)),this.update({selectedItems:this._selectedItems.map(T=>this._itemsToHandles.get(T))})}_fireDidChangeActive(h){const T=(0,g.coalesce)(h.map(S=>this._handlesToItems.get(S)));this._activeItems=T,this._onDidChangeActiveEmitter.fire(T)}_fireDidChangeSelection(h){const T=(0,g.coalesce)(h.map(S=>this._handlesToItems.get(S)));this._selectedItems=T,this._onDidChangeSelectionEmitter.fire(T)}_fireDidTriggerItemButton(h,T){const S=this._handlesToItems.get(h);if(!S||!S.buttons||!S.buttons.length)return;const a=S.buttons[T];a&&this._onDidTriggerItemButtonEmitter.fire({button:a,item:S})}}class v extends w{constructor(h,T){super(h.identifier,T),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(h){this._password=h,this.update({password:h})}get prompt(){return this._prompt}set prompt(h){this._prompt=h,this.update({prompt:h})}get valueSelection(){return this._valueSelection}set valueSelection(h){this._valueSelection=h,this.update({valueSelection:h})}get validationMessage(){return this._validationMessage}set validationMessage(h){this._validationMessage=h,h?typeof h=="string"?this.update({validationMessage:h,severity:R.default.Error}):this.update({validationMessage:h.message,severity:h.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new b(t,r)}e.createExtHostQuickOpen=p});var Fe=this&&this.__classPrivateFieldGet||function(te,e,m,k){if(m==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?k:m==="a"?k.call(te):k?k.value:e.get(te)},Xe=this&&this.__classPrivateFieldSet||function(te,e,m,k,C){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?C.call(te,m):C?C.value=m:e.set(te,m),m};define(Ae[242],Re([1,0,2,5,65,6,16,4,18,131,15,24,40,8,26,14]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l){"use strict";var t,r,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function b(a){if(a)return typeof a.iconPath=="string"?m.URI.file(a.iconPath):m.URI.isUri(a.iconPath)||d.ThemeIcon.isThemeIcon(a.iconPath)?a.iconPath:void 0}function w(a,o){if(!a.iconPath&&!o.iconPath)return 0;if(a.iconPath){if(!o.iconPath)return 1}else return-1;const O=typeof a.iconPath=="string"?a.iconPath:m.URI.isUri(a.iconPath)?a.iconPath.fsPath:a.iconPath.id,$=typeof o.iconPath=="string"?o.iconPath:m.URI.isUri(o.iconPath)?o.iconPath.fsPath:o.iconPath.id;return(0,g.comparePaths)(O,$)}function _(a,o){let O=0;if(a.strikeThrough!==o.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==o.faded)return a.faded?1:-1;if(a.tooltip!==o.tooltip)return(a.tooltip||"").localeCompare(o.tooltip||"");if(O=w(a,o),O!==0)return O;if(a.light&&o.light)O=w(a.light,o.light);else{if(a.light)return 1;if(o.light)return-1}if(O!==0)return O;if(a.dark&&o.dark)O=w(a.dark,o.dark);else{if(a.dark)return 1;if(o.dark)return-1}return O}function i(a,o){if(a.command!==o.command)return a.command<o.command?-1:1;if(a.title!==o.title)return a.title<o.title?-1:1;if(a.tooltip!==o.tooltip){if(a.tooltip!==void 0&&o.tooltip!==void 0)return a.tooltip<o.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(a.arguments===o.arguments)return 0;if(a.arguments)if(o.arguments){if(a.arguments.length!==o.arguments.length)return a.arguments.length-o.arguments.length}else return 1;else return-1;for(let O=0;O<a.arguments.length;O++){const $=a.arguments[O],K=o.arguments[O];if($!==K)return $<K?-1:1}return 0}function u(a,o){let O=(0,g.comparePaths)(a.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(O!==0)return O;if(a.command&&o.command)O=i(a.command,o.command);else{if(a.command)return 1;if(o.command)return-1}if(O!==0)return O;if(a.decorations&&o.decorations)O=_(a.decorations,o.decorations);else{if(a.decorations)return 1;if(o.decorations)return-1}return O}function n(a,o){for(let O=0;O<a.length;O++)if(a[O]!==o[O])return!1;return!0}function s(a,o){return a.command===o.command&&a.title===o.title&&a.tooltip===o.tooltip&&(a.arguments&&o.arguments?n(a.arguments,o.arguments):a.arguments===o.arguments)}function v(a,o){return(0,D.equals)(a,o,s)}class I{get value(){return this._value}set value(o){o=o??"",Fe(this,t,"f").$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){Fe(this,t,"f").$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(o){if((0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,Fe(this,t,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get enabled(){return this._enabled}set enabled(o){o=!!o,this._enabled!==o&&(this._enabled=o,Fe(this,t,"f").$setInputBoxEnablement(this._sourceControlHandle,o))}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,Fe(this,t,"f").$setInputBoxVisibility(this._sourceControlHandle,o))}get document(){return(0,p.checkProposedApiEnabled)(this._extension,"scmTextDocument"),Fe(this,r,"f").getDocument(this._documentUri)}constructor(o,O,$,K,V){this._extension=o,this._sourceControlHandle=K,this._documentUri=V,t.set(this,void 0),r.set(this,void 0),this._value="",this._onDidChange=new k.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Xe(this,r,O,"f"),Xe(this,t,$,"f")}showValidationMessage(o,O){(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),Fe(this,t,"f").$showValidationMessage(this._sourceControlHandle,o,O)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=I,t=new WeakMap,r=new WeakMap;class h{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}constructor(o,O,$,K,V){this._proxy=o,this._commands=O,this._sourceControlHandle=$,this._id=K,this._label=V,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new k.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=h._handlePool++}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,O){const $=this._resourceStatesCommandsMap.get(o);return $?(0,F.asPromise)(()=>this._commands.executeCommand($.command,...$.arguments||[],O)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const o=[...this._resourceStates].sort(u),$=(0,D.sortedDiff)(this._resourceSnapshot,o,u).map(z=>{const N=z.toInsert.map(q=>{const B=this._resourceHandlePool++;this._resourceStatesMap.set(B,q);const U=q.resourceUri;let le;if(q.command)if(q.command.command==="vscode.open"||q.command.command==="vscode.diff"){const G=new M.DisposableStore;le=this._commands.converter.toInternal(q.command,G),this._resourceStatesDisposablesMap.set(B,G)}else this._resourceStatesCommandsMap.set(B,q.command);const ve=b(q.decorations),Pe=q.decorations&&b(q.decorations.light)||ve,J=q.decorations&&b(q.decorations.dark)||ve,X=[Pe,J],ce=q.decorations&&q.decorations.tooltip||"",De=q.decorations&&!!q.decorations.strikeThrough,ke=q.decorations&&!!q.decorations.faded,ge=q.contextValue||"";return{rawResource:[B,U,X,ce,De,ke,ge,le],handle:B}});return{start:z.start,deleteCount:z.deleteCount,toInsert:N}}),K=$.map(({start:z,deleteCount:N,toInsert:q})=>[z,N,q.map(B=>B.rawResource)]),V=$.reverse();for(const{start:z,deleteCount:N,toInsert:q}of V){const B=q.map(le=>le.handle),U=this._handlesSnapshot.splice(z,N,...B);for(const le of U)this._resourceStatesMap.delete(le),this._resourceStatesCommandsMap.delete(le),this._resourceStatesDisposablesMap.get(le)?.dispose(),this._resourceStatesDisposablesMap.delete(le)}return this._resourceSnapshot=o,K}dispose(){this._disposed=!0,this._onDidDispose.fire()}}h._handlePool=0;class T{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,Fe(this,c,"f").$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o;let O;(0,p.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(O=o?.label),Fe(this,c,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o,quickDiffLabel:O})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,Fe(this,c,"f").$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new M.DisposableStore,this._acceptInputCommand=o;const O=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);Fe(this,c,"f").$updateSourceControl(this.handle,{acceptInputCommand:O})}get actionButton(){return(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(o){(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new M.DisposableStore,this._actionButton=o;const O=o!==void 0?{command:this._commands.converter.toInternal(o.command,this._actionButtonDisposables.value),secondaryCommands:o.secondaryCommands?.map($=>$.map(K=>this._commands.converter.toInternal(K,this._actionButtonDisposables.value))),description:o.description,enabled:o.enabled}:void 0;Fe(this,c,"f").$updateSourceControl(this.handle,{actionButton:O??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&v(this._statusBarCommands,o))return;this._statusBarDisposables.value=new M.DisposableStore,this._statusBarCommands=o;const O=(o||[]).map($=>this._commands.converter.toInternal($,this._statusBarDisposables.value));Fe(this,c,"f").$updateSourceControl(this.handle,{statusBarCommands:O})}get selected(){return this._selected}constructor(o,O,$,K,V,z,N){this._extension=o,this._commands=K,this._id=V,this._label=z,this._rootUri=N,c.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new M.MutableDisposable,this._statusBarDisposables=new M.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new k.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=T._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Xe(this,c,$,"f");const q=m.URI.from({scheme:l.Schemas.vscodeSourceControl,path:`${V}/scm${this.handle}/input`,query:N?`rootUri=${encodeURIComponent(N.toString())}`:void 0});this._inputBox=new I(o,O,Fe(this,c,"f"),this.handle,q),Fe(this,c,"f").$registerSourceControl(this.handle,V,z,N,q)}createResourceGroup(o,O){const $=new h(Fe(this,c,"f"),this._commands,this.handle,o,O),K=k.Event.once($.onDidDispose)(()=>this.createdResourceGroups.delete($));return this.createdResourceGroups.set($,K),this.eventuallyAddResourceGroups(),$}eventuallyAddResourceGroups(){const o=[],O=[];for(const[$,K]of this.createdResourceGroups){K.dispose();const V=$.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add($),this.eventuallyUpdateResourceStates()});k.Event.once($.onDidDispose)(()=>{this.updatedResourceGroups.delete($),V.dispose(),this._groups.delete($.handle),Fe(this,c,"f").$unregisterGroup(this.handle,$.handle)}),o.push([$.handle,$.id,$.label,$.features]);const z=$._takeResourceStateSnapshot();z.length>0&&O.push([$.handle,z]),this._groups.set($.handle,$)}Fe(this,c,"f").$registerGroups(this.handle,o,O),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(O=>{const $=O._takeResourceStateSnapshot();$.length!==0&&o.push([O.handle,$])}),o.length>0&&Fe(this,c,"f").$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),Fe(this,c,"f").$unregisterSourceControl(this.handle)}}c=new WeakMap,T._handlePool=0,Ve([(0,C.debounce)(100)],T.prototype,"eventuallyAddResourceGroups",null),Ve([(0,C.debounce)(100)],T.prototype,"eventuallyUpdateResourceStates",null);let S=e.ExtHostSCM=class An{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(o,O,$,K){this._commands=O,this._extHostDocuments=$,this.logService=K,this._sourceControls=new Map,this._sourceControlsByExtension=new y.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new k.Emitter,this._proxy=o.getProxy(f.MainContext.MainThreadSCM),this._telemetry=o.getProxy(f.MainContext.MainThreadTelemetry),O.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===3){const z=this._sourceControls.get(V.sourceControlHandle);if(!z)return V;const N=z.getResourceGroup(V.groupHandle);return N?N.getResourceState(V.handle):V}else if(V&&V.$mid===4){const z=this._sourceControls.get(V.sourceControlHandle);return z?z.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===5){const z=this._sourceControls.get(V.handle);return z||V}return V}})}createSourceControl(o,O,$,K){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,O,$,K),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const V=An._handlePool++,z=new T(o,this._extHostDocuments,this._proxy,this._commands,O,$,K);this._sourceControls.set(V,z);const N=this._sourceControlsByExtension.get(o.identifier)||[];return N.push(z),this._sourceControlsByExtension.set(o.identifier,N),z}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const O=this._sourceControlsByExtension.get(o.identifier),$=O&&O[O.length-1];return $&&$.inputBox}$provideOriginalResource(o,O,$){const K=m.URI.revive(O);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,K.toString());const V=this._sourceControls.get(o);return!V||!V.quickDiffProvider||!V.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,F.asPromise)(()=>V.quickDiffProvider.provideOriginalResource(K,$)).then(z=>z||null)}$onInputBoxValueChange(o,O){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const $=this._sourceControls.get(o);return $&&$.inputBox.$onInputBoxValueChange(O),Promise.resolve(void 0)}$executeResourceCommand(o,O,$,K){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,O,$);const V=this._sourceControls.get(o);if(!V)return Promise.resolve(void 0);const z=V.getResourceGroup(O);return z?z.$executeResourceCommand($,K):Promise.resolve(void 0)}$validateInput(o,O,$){this.logService.trace("ExtHostSCM#$validateInput",o);const K=this._sourceControls.get(o);return!K||!K.inputBox.validateInput?Promise.resolve(void 0):(0,F.asPromise)(()=>K.inputBox.validateInput(O,$)).then(V=>{if(!V)return Promise.resolve(void 0);const z=E.MarkdownString.fromStrict(V.message);return z?Promise.resolve([z,V.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(o){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&this._sourceControls.get(o)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};S._handlePool=0,e.ExtHostSCM=S=Ve([He(3,R.ILogService)],S)}),define(Ae[84],Re([1,0,4,5,3]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(f){this._onDidChangePassword=new k.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=f.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(f){this._onDidChangePassword.fire(f)}get(f,D){return this._proxy.$getPassword(f,D)}store(f,D,g){return this._proxy.$setPassword(f,D,g)}delete(f,D){return this._proxy.$deletePassword(f,D)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")}),define(Ae[243],Re([1,0,4,7]),function(te,e,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSemanticSimilarity=void 0;class C{constructor(F){this._semanticSimilarityProviders=new Map,this._nextHandle=0,this._proxy=F.getProxy(m.MainContext.MainThreadSemanticSimilarity)}async $provideSimilarityScore(F,f,D,g){if(this._semanticSimilarityProviders.size===0)throw new Error("No semantic similarity providers registered");const R=this._semanticSimilarityProviders.get(F);if(!R)throw new Error("Semantic similarity provider not found");return await R.provideSimilarityScore(f,D,g)}registerSemanticSimilarityProvider(F,f){const D=this._nextHandle;return this._nextHandle++,this._semanticSimilarityProviders.set(D,f),this._proxy.$registerSemanticSimilarityProvider(D),new k.Disposable(()=>{this._proxy.$unregisterSemanticSimilarityProvider(D),this._semanticSimilarityProviders.delete(D)})}}e.ExtHostSemanticSimilarity=C}),define(Ae[244],Re([1,0,4,8,2]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class M{constructor(f,D){this.uriTransformer=D,this.providers=new Map,this.proxy=f.getProxy(m.MainContext.MainThreadShare)}async $provideShare(f,D,g){return await this.providers.get(f)?.provideShare({selection:k.Range.to(D.selection),resourceUri:C.URI.revive(D.resourceUri)},g)??void 0}registerShareProvider(f,D){const g=M.handlePool++;return this.providers.set(g,D),this.proxy.$registerShareProvider(g,k.DocumentSelector.from(f,this.uriTransformer),D.id,D.label,D.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(g),this.providers.delete(g)}}}}e.ExtHostShare=M,M.handlePool=0});var Xe=this&&this.__classPrivateFieldSet||function(te,e,m,k,C){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?C.call(te,m):C?C.value=m:e.set(te,m),m},Fe=this&&this.__classPrivateFieldGet||function(te,e,m,k){if(m==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?k:m==="a"?k.call(te):k?k.value:e.get(te)};define(Ae[245],Re([1,0,7,4,152,6,8,10]),function(te,e,m,k,C,M,F,f){"use strict";var D,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(p,l,t,r,c,b=m.StatusBarAlignment.Left,w){if(D.set(this,void 0),g.set(this,void 0),this._disposed=!1,this._text="",this._staleCommandRegistrations=new M.DisposableStore,Xe(this,D,p,"f"),Xe(this,g,l,"f"),c&&r){this._entryId=(0,m.asStatusBarItemIdentifier)(r.identifier,c);const _=t.get(this._entryId);_&&(b=_.alignLeft?m.StatusBarAlignment.Left:m.StatusBarAlignment.Right,w=_.priority,this._visible=!0,this.name=_.name,this.text=_.text,this.tooltip=_.tooltip,this.command=_.command,this.accessibilityInformation=_.accessibilityInformation)}else this._entryId=String(R.ID_GEN++);this._extension=r,this._id=c,this._alignment=b,this._priority=this.validatePriority(w)}validatePriority(p){if((0,f.isNumber)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(p){this._text=p,this.update()}set name(p){this._name=p,this.update()}set tooltip(p){this._tooltip=p,this.update()}set color(p){this._color=p,this.update()}set backgroundColor(p){p&&!R.ALLOWED_BACKGROUND_COLORS.has(p.id)&&(p=void 0),this._backgroundColor=p,this.update()}set command(p){this._command?.fromApi!==p&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new M.DisposableStore,typeof p=="string"?this._command={fromApi:p,internal:Fe(this,g,"f").toInternal({title:"",command:p},this._latestCommandRegistration)}:p?this._command={fromApi:p,internal:Fe(this,g,"f").toInternal(p,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Fe(this,D,"f").$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let l;this._name?l=this._name:l=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let t=this._color;this._backgroundColor&&(t=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const r=F.MarkdownString.fromStrict(this._tooltip);Fe(this,D,"f").$setEntry(this._entryId,p,this._extension?.identifier.value,l,this._text,r,this._command?.internal,t,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,D=new WeakMap,g=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class y{constructor(p){this._messages=[],this._item=p.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(p){const l={message:p};return this._messages.unshift(l),this._update(),new m.Disposable(()=>{const t=this._messages.indexOf(l);t>=0&&(this._messages.splice(t,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class d{constructor(p,l){this._existingItems=new Map,this._proxy=p.getProxy(k.MainContext.MainThreadStatusBar),this._commands=l,this._statusMessage=new y(this)}$acceptStaticEntries(p){for(const l of p)this._existingItems.set(l.entryId,l)}createStatusBarEntry(p,l,t,r){return new R(this._proxy,this._commands,this._existingItems,p,l,t,r)}setStatusBarMessage(p,l){const t=this._statusMessage.setMessage(p);let r;return typeof l=="number"?r=setTimeout(()=>t.dispose(),l):typeof l<"u"&&l.then(()=>t.dispose(),()=>t.dispose()),new m.Disposable(()=>{t.dispose(),clearTimeout(r)})}}e.ExtHostStatusBar=d}),define(Ae[85],Re([1,0,4,5,3]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(f,D){this._logService=D,this._onDidChangeStorage=new k.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=f.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(f,D){this._proxy.$registerExtensionStorageKeysToSync(f,D)}async initializeExtensionStorage(f,D,g){const R=await this._proxy.$initializeExtensionStorage(f,D);let y;return R&&(y=this.safeParseValue(f,D,R)),y||g}setValue(f,D,g){return this._proxy.$setValue(f,D,g)}$acceptValue(f,D,g){const R=this.safeParseValue(f,D,g);R&&this._onDidChangeStorage.fire({shared:f,key:D,value:R})}safeParseValue(f,D,g){try{return JSON.parse(g)}catch(R){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${f}): ${R}`)}}}e.ExtHostStorage=M,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(Ae[86],Re([1,0,3,27,15,61,2]),function(te,e,m,k,C,M,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let f=e.ExtensionStoragePaths=class{constructor(g,R,y){this._logService=R,this._extHostFileSystem=y,this._workspace=g.workspace??void 0,this._environment=g.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(d=>this._value=d)}async _getWorkspaceStorageURI(g){return F.URI.joinPath(this._environment.workspaceStorageHome,g)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const g=this._workspace.id,R=await this._getWorkspaceStorageURI(g);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(F.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:F.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(g){if(this._value)return F.URI.joinPath(this._value,g.identifier.value)}globalValue(g){return F.URI.joinPath(this._environment.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=f=Ve([He(0,k.IExtHostInitDataService),He(1,C.ILogService),He(2,M.IExtHostConsumerFileSystem)],f)}),define(Ae[62],Re([1,0,5,4,3,2,17,6,7,154,9,180,22,36,181,40,10,16,8,26]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l,t,r,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class w{constructor(a,o,O,$){this._proxy=a,this._id=o,this._creationOptions=O,this._name=$,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(V=>this._pidPromiseComplete=V);const K=this;this.value={get name(){return K._name||""},get processId(){return K._pidPromise},get creationOptions(){return K._creationOptions},get exitStatus(){return K._exitStatus},get state(){return K._state},sendText(V,z=!0){K._checkDisposed(),K._proxy.$sendText(K._id,V,z)},show(V){K._checkDisposed(),K._proxy.$show(K._id,V)},hide(){K._checkDisposed(),K._proxy.$hide(K._id)},dispose(){K._disposed||(K._disposed=!0,K._proxy.$dispose(K._id))},get dimensions(){if(!(K._cols===void 0||K._rows===void 0))return{columns:K._cols,rows:K._rows}}}}async create(a,o){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:a.name,shellPath:(0,t.withNullAsUndefined)(a.shellPath),shellArgs:(0,t.withNullAsUndefined)(a.shellArgs),cwd:(0,t.withNullAsUndefined)(a.cwd),env:(0,t.withNullAsUndefined)(a.env),icon:(0,t.withNullAsUndefined)(I(a.iconPath)),color:l.ThemeColor.isThemeColor(a.color)?a.color.id:void 0,initialText:(0,t.withNullAsUndefined)(a.message),strictEnv:(0,t.withNullAsUndefined)(a.strictEnv),hideFromUser:(0,t.withNullAsUndefined)(a.hideFromUser),isFeatureTerminal:(0,t.withNullAsUndefined)(o?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,t.withNullAsUndefined)(o?.useShellEnvironment),location:o?.location||this._serializeParentTerminal(a.location,o?.resolvedExtHostIdentifier),isTransient:(0,t.withNullAsUndefined)(a.isTransient)})}async createExtensionTerminal(a,o,O,$){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:O,color:l.ThemeColor.isThemeColor($)?$.id:void 0,location:this._serializeParentTerminal(a,o),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(a,o){return typeof a=="object"?"parentTerminal"in a&&a.parentTerminal&&o?{parentTerminal:o}:"viewColumn"in a?{viewColumn:c.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus}:void 0:a}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(a){this._name=a}setExitStatus(a,o){this._exitStatus=Object.freeze({code:a,reason:o})}setDimensions(a,o){return a===this._cols&&o===this._rows||a===0||o===0?!1:(this._cols=a,this._rows=o,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(a){this._pidPromiseComplete?(this._pidPromiseComplete(a),this._pidPromiseComplete=void 0):this._pidPromise.then(o=>{o!==a&&(this._pidPromise=Promise.resolve(a))})}}e.ExtHostTerminal=w;class _{get onProcessReady(){return this._onProcessReady.event}constructor(a){this._pty=a,this.id=0,this.shouldPersist=!1,this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new m.Emitter,this._onDidChangeProperty=new m.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(a){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${a}`)}updateProperty(a,o){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${a}, value: ${o}`)}async start(){}shutdown(){this._pty.close()}input(a){this._pty.handleInput?.(a)}resize(a,o){this._pty.setDimensions?.({columns:a,rows:o})}clearBuffer(){}async processBinary(a){}acknowledgeDataEvent(a){}async setUnicodeVersion(a){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(a){this._pty.onDidWrite(o=>this._onProcessData.fire(o)),this._pty.onDidClose?.((o=void 0)=>{this._onProcessExit.fire(o===void 0?void 0:o)}),this._pty.onDidOverrideDimensions?.(o=>{o&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:o.columns,rows:o.rows}})}),this._pty.onDidChangeName?.(o=>{this._onDidChangeProperty.fire({type:"title",value:o})}),this._pty.open(a||void 0),a&&this._pty.setDimensions?.(a),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let i=1,u=e.BaseExtHostTerminalService=class extends f.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(a=>a.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(a,o){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new m.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=o.getProxy(k.MainContext.MainThreadTerminalService),this._bufferer=new p.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(a),this._register({dispose:()=>{for(const[O,$]of this._terminalProcesses)$.shutdown(!0)}})}getDefaultShell(a){return(a?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(a){return(a?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(a,o){const O=new w(this._proxy,(0,E.generateUuid)(),a,a.name),$=new _(a.pty);return O.createExtensionTerminal(a.location,this._serializeParentTerminal(a,o).resolvedExtHostIdentifier,I(a.iconPath),h(a.color)).then(K=>{const V=this._setupExtHostProcessListeners(K,$);this._terminalProcessDisposables[K]=V}),this._terminals.push(O),O.value}_serializeParentTerminal(a,o){if(o=o||{},a.location&&typeof a.location=="object"&&"parentTerminal"in a.location){const O=a.location.parentTerminal;if(O){const $=this._terminals.find(K=>K.value===O);$&&(o.resolvedExtHostIdentifier=$._id)}}else a.location&&typeof a.location!="object"?o.location=a.location:o.location&&typeof o.location=="object"&&"splitActiveTerminal"in o.location&&(o.location={splitActiveTerminal:!0});return o}attachPtyToTerminal(a,o){if(!this._getTerminalById(a))throw new Error(`Cannot resolve terminal with id ${a} for virtual process`);const $=new _(o),K=this._setupExtHostProcessListeners(a,$);this._terminalProcessDisposables[a]=K}async $acceptActiveTerminalChanged(a){const o=this._activeTerminal;if(a===null){this._activeTerminal=void 0,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const O=this._getTerminalById(a);O&&(this._activeTerminal=O,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(a,o){const O=this._getTerminalById(a);O&&this._onDidWriteTerminalData.fire({terminal:O.value,data:o})}async $acceptTerminalDimensions(a,o,O){const $=this._getTerminalById(a);$&&$.setDimensions(o,O)&&this._onDidChangeTerminalDimensions.fire({terminal:$.value,dimensions:$.value.dimensions})}async $acceptTerminalMaximumDimensions(a,o,O){this._terminalProcesses.get(a)?.resize(o,O)}async $acceptTerminalTitleChange(a,o){const O=this._getTerminalById(a);O&&(O.name=o)}async $acceptTerminalClosed(a,o,O){const $=this._getTerminalObjectIndexById(this._terminals,a);if($!==null){const K=this._terminals.splice($,1)[0];K.setExitStatus(o,O),this._onDidCloseTerminal.fire(K.value)}}$acceptTerminalOpened(a,o,O,$){if(o){const z=this._getTerminalObjectIndexById(this._terminals,o);if(z!==null){this._terminals[z]._id=a,this._onDidOpenTerminal.fire(this.terminals[z]),this._terminals[z].isOpen=!0;return}}const K={name:$.name,shellPath:$.executable,shellArgs:$.args,cwd:typeof $.cwd=="string"?$.cwd:M.URI.revive($.cwd),env:$.env,hideFromUser:$.hideFromUser},V=new w(this._proxy,a,K,O);this._terminals.push(V),this._onDidOpenTerminal.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(a,o){this._getTerminalById(a)?._setProcessId(o)}async $startExtensionTerminal(a,o){const O=this._getTerminalById(a);if(!O)return{message:(0,g.localize)(0,null,a)};O.isOpen||await new Promise(K=>{const V=this.onDidOpenTerminal(async z=>{z===O.value&&(V.dispose(),K())})});const $=this._terminalProcesses.get(a);$?$.startSendingEvents(o):this._extensionTerminalAwaitingStart[a]={initialDimensions:o}}_setupExtHostProcessListeners(a,o){const O=new f.DisposableStore;O.add(o.onProcessReady(K=>this._proxy.$sendProcessReady(a,K.pid,K.cwd,K.windowsPty))),O.add(o.onDidChangeProperty(K=>this._proxy.$sendProcessProperty(a,K))),this._bufferer.startBuffering(a,o.onProcessData),O.add(o.onProcessExit(K=>this._onProcessExit(a,K))),this._terminalProcesses.set(a,o);const $=this._extensionTerminalAwaitingStart[a];return $&&o instanceof _&&(o.startSendingEvents($.initialDimensions),delete this._extensionTerminalAwaitingStart[a]),O}$acceptProcessAckDataEvent(a,o){this._terminalProcesses.get(a)?.acknowledgeDataEvent(o)}$acceptProcessInput(a,o){this._terminalProcesses.get(a)?.input(o)}$acceptTerminalInteraction(a){const o=this._getTerminalById(a);o?.setInteractedWith()&&this._onDidChangeTerminalState.fire(o.value)}$acceptProcessResize(a,o,O){try{this._terminalProcesses.get(a)?.resize(o,O)}catch($){if($.code!=="EPIPE"&&$.code!=="ERR_IPC_CHANNEL_CLOSED")throw $}}$acceptProcessShutdown(a,o){this._terminalProcesses.get(a)?.shutdown(o)}$acceptProcessRequestInitialCwd(a){this._terminalProcesses.get(a)?.getInitialCwd().then(o=>this._proxy.$sendProcessProperty(a,{type:"initialCwd",value:o}))}$acceptProcessRequestCwd(a){this._terminalProcesses.get(a)?.getCwd().then(o=>this._proxy.$sendProcessProperty(a,{type:"cwd",value:o}))}$acceptProcessRequestLatency(a){return Promise.resolve(a)}registerLinkProvider(a){return this._linkProviders.add(a),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(a),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(a,o,O){if(this._profileProviders.has(o))throw new Error(`Terminal profile provider "${o}" already registered`);return this._profileProviders.set(o,O),this._proxy.$registerProfileProvider(o,a.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(o),this._proxy.$unregisterProfileProvider(o)})}registerTerminalQuickFixProvider(a,o,O){if(this._quickFixProviders.has(a))throw new Error(`Terminal quick fix provider "${a}" is already registered`);return this._quickFixProviders.set(a,O),this._proxy.$registerQuickFixProvider(a,o),new D.Disposable(()=>{this._quickFixProviders.delete(a),this._proxy.$unregisterQuickFixProvider(a)})}async $provideTerminalQuickFixes(a,o){const O=new d.CancellationTokenSource().token;if(O.isCancellationRequested)return;const $=this._quickFixProviders.get(a);if(!$)return;const K=await $.provideTerminalQuickFixes(o,O);if(K!==null)return K}async $createContributedProfileTerminal(a,o){const O=new d.CancellationTokenSource().token;let $=await this._profileProviders.get(a)?.provideTerminalProfile(O);if(!O.isCancellationRequested){if($&&!("options"in $)&&($={options:$}),!$||!("options"in $))throw new Error(`No terminal profile options provided for id "${a}"`);if("pty"in $.options){this.createExtensionTerminal($.options,o);return}this.createTerminalFromOptions($.options,o)}}async $provideLinks(a,o){const O=this._getTerminalById(a);if(!O)return[];this._terminalLinkCache.delete(a),this._terminalLinkCancellationSource.get(a)?.dispose(!0);const K=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(a,K);const V=[],z={terminal:O.value,line:o},N=[];for(const U of this._linkProviders)N.push(r.Promises.withAsyncBody(async le=>{K.token.onCancellationRequested(()=>le({provider:U,links:[]}));const ve=await U.provideTerminalLinks(z,K.token)||[];K.token.isCancellationRequested||le({provider:U,links:ve})}));const q=await Promise.all(N);if(K.token.isCancellationRequested)return[];const B=new Map;for(const U of q)U&&U.links.length>0&&V.push(...U.links.map(le=>{const ve={id:i++,startIndex:le.startIndex,length:le.length,label:le.tooltip};return B.set(ve.id,{provider:U.provider,link:le}),ve}));return this._terminalLinkCache.set(a,B),V}$activateLink(a,o){const O=this._terminalLinkCache.get(a)?.get(o);O&&O.provider.handleTerminalLink(O.link)}_onProcessExit(a,o){this._bufferer.stopBuffering(a),this._terminalProcesses.delete(a),delete this._extensionTerminalAwaitingStart[a];const O=this._terminalProcessDisposables[a];O&&(O.dispose(),delete this._terminalProcessDisposables[a]),this._proxy.$sendProcessExit(a,o)}_getTerminalById(a){return this._getTerminalObjectById(this._terminals,a)}_getTerminalObjectById(a,o){const O=this._getTerminalObjectIndexById(a,o);return O!==null?a[O]:null}_getTerminalObjectIndexById(a,o){const O=a.findIndex($=>$._id===o);return O===-1?null:O}getEnvironmentVariableCollection(a){let o=this._environmentVariableCollections.get(a.identifier.value);return o||(o=new n(a),this._setEnvironmentVariableCollection(a.identifier.value,o)),o.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(a,o){const O=(0,y.serializeEnvironmentVariableCollection)(o.map),$=(0,y.serializeEnvironmentDescriptionMap)(o.descriptionMap);this._proxy.$setEnvironmentVariableCollection(a,o.persistent,O.length===0?void 0:O,$)}$initEnvironmentVariableCollections(a){a.forEach(o=>{const O=o[0],$=new n(void 0,o[1]);this._setEnvironmentVariableCollection(O,$)})}$acceptDefaultProfile(a,o){const O=this._defaultProfile;this._defaultProfile=a,this._defaultAutomationProfile=o,O?.path!==a.path&&this._onDidChangeShell.fire(a.path)}_setEnvironmentVariableCollection(a,o){this._environmentVariableCollections.set(a,o),o.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(a,o)})}};e.BaseExtHostTerminalService=u=Ve([He(1,F.IExtHostRpcService)],u);class n{get persistent(){return this._persistent}set persistent(a){this._persistent=a,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(a,o){this._extension=a,this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(o)}getScopedEnvironmentVariableCollection(a){this._extension&&a&&(0,b.checkProposedApiEnabled)(this._extension,"envCollectionWorkspace");const o=this.getScopeKey(a);let O=this.scopedCollections.get(o);return O||(O=new s(this,a),this.scopedCollections.set(o,O),O.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),O}replace(a,o,O,$){this._extension&&O&&(0,b.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(a,{value:o,type:D.EnvironmentVariableMutatorType.Replace,options:O??{},scope:$})}append(a,o,O,$){this._extension&&O&&(0,b.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(a,{value:o,type:D.EnvironmentVariableMutatorType.Append,options:O??{},scope:$})}prepend(a,o,O,$){this._extension&&O&&(0,b.checkProposedApiEnabled)(this._extension,"envCollectionOptions"),this._setIfDiffers(a,{value:o,type:D.EnvironmentVariableMutatorType.Prepend,options:O??{},scope:$})}_setIfDiffers(a,o){if(o.options&&o.options.applyAtProcessCreation===!1&&!o.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const O=this.getKey(a,o.scope),$=this.map.get(O);if(!$||$.value!==o.value||$.type!==o.type||$.options?.applyAtProcessCreation!==(o.options.applyAtProcessCreation??!0)||$.options?.applyAtShellIntegration!==(o.options.applyAtShellIntegration??!1)||$.scope?.workspaceFolder?.index!==o.scope?.workspaceFolder?.index){const K=this.getKey(a,o.scope),V={variable:a,...o,options:{applyAtProcessCreation:o.options.applyAtProcessCreation??!0,applyAtShellIntegration:o.options.applyAtShellIntegration??!1}};this.map.set(K,V),this._onDidChangeCollection.fire()}}get(a,o){const O=this.getKey(a,o),$=this.map.get(O);return $?T($):void 0}getKey(a,o){const O=this.getScopeKey(o);return O.length?`${a}:::${O}`:a}getScopeKey(a){return this.getWorkspaceKey(a?.workspaceFolder)??""}getWorkspaceKey(a){return a?a.uri.toString():void 0}getVariableMap(a){const o=new Map;for(const[O,$]of this.map)this.getScopeKey($.scope)===this.getScopeKey(a)&&o.set(O,T($));return o}delete(a,o){const O=this.getKey(a,o);this.map.delete(O),this._onDidChangeCollection.fire()}clear(a){if(a?.workspaceFolder){for(const[o,O]of this.map)O.scope?.workspaceFolder?.index===a.workspaceFolder.index&&this.map.delete(o);this.clearDescription(a)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(a,o){const O=this.getScopeKey(o),$=this.descriptionMap.get(O);if(!$||$.description!==a){let K;typeof a=="string"?K=a:K=a?.value.split(`

`)[0];const V={description:K,scope:o};this.descriptionMap.set(O,V),this._onDidChangeCollection.fire()}}getDescription(a){const o=this.getScopeKey(a);return this.descriptionMap.get(o)?.description}clearDescription(a){const o=this.getScopeKey(a);this.descriptionMap.delete(o)}}class s{get persistent(){return this.collection.persistent}set persistent(a){this.collection.persistent=a}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(a,o){this.collection=a,this.scope=o,this._onDidChangeCollection=new m.Emitter}getScopedEnvironmentVariableCollection(a){return this.collection.getScopedEnvironmentVariableCollection(a)}replace(a,o,O){this.collection.replace(a,o,O,this.scope)}append(a,o,O){this.collection.append(a,o,O,this.scope)}prepend(a,o,O){this.collection.prepend(a,o,O,this.scope)}get(a){return this.collection.get(a,this.scope)}forEach(a,o){this.collection.getVariableMap(this.scope).forEach((O,$)=>a.call(o,$,O,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(a){this.collection.delete(a,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(a){this.collection.setDescription(a,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let v=e.WorkerExtHostTerminalService=class extends u{constructor(a){super(!1,a)}createTerminal(a,o,O){throw new R.NotSupportedError}createTerminalFromOptions(a,o){throw new R.NotSupportedError}};e.WorkerExtHostTerminalService=v=Ve([He(0,F.IExtHostRpcService)],v);function I(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function h(S){return l.ThemeColor.isThemeColor(S)?S:void 0}function T(S){const a={...S};return delete a.scope,a.options=a.options??void 0,delete a.variable,a}});var Fe=this&&this.__classPrivateFieldGet||function(te,e,m,k){if(m==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?k:m==="a"?k.call(te):k?k.value:e.get(te)},Xe=this&&this.__classPrivateFieldSet||function(te,e,m,k,C){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?C.call(te,m):C?C.value=m:e.set(te,m),m};define(Ae[246],Re([1,0,18,16,25,22,5,201,93,6,23,10,36,4,17,104,8,7,45,77,56,26]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l,t,r,c,b,w,_){"use strict";var i,u;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let n=e.ExtHostTesting=class{constructor(N,q,B){this.editors=B,this.resultsChangedEmitter=new F.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=N.getProxy(E.MainContext.MainThreadTesting),this.observer=new $(this.proxy),this.runTracker=new h(this.proxy),q.registerArgumentProcessor({processArgument:U=>{if(U?.$mid!==15)return U;const le=U,ve=le.tests[le.tests.length-1].item.extId;return this.controllers.get(c.TestId.root(ve))?.collection.tree.get(ve)?.actual??(0,l.toItemFromContext)(U)}}),q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const U=await q.executeCommand("_testing.getExplorerSelection"),le=ve=>{const Pe=this.controllers.get(c.TestId.root(ve));if(Pe)return c.TestId.isRoot(ve)?Pe.controller:Pe.collection.tree.get(ve)?.actual};return{include:U?.include.map(le).filter(y.isDefined)||[],exclude:U?.exclude.map(le).filter(y.isDefined)||[]}})}createTestController(N,q,B,U){if(this.controllers.has(q))throw new Error(`Attempt to insert a duplicate controller with ID "${q}"`);const le=new g.DisposableStore,ve=le.add(new l.ExtHostTestItemCollection(q,B,this.editors));ve.root.label=B;const Pe=new Map,J=this.proxy,X={items:ve.root.children,get label(){return B},set label(De){B=De,ve.root.label=De,J.$updateController(q,{label:B})},get refreshHandler(){return U},set refreshHandler(De){U=De,J.$updateController(q,{canRefresh:!!De})},get id(){return q},createRunProfile:(De,ke,ge,A,G,de)=>{let ye=(0,D.hash)(De);for(;Pe.has(ye);)ye++;return new K(this.proxy,Pe,q,ye,De,ke,ge,A,G,de)},createTestItem(De,ke,ge){return new l.TestItemImpl(q,De,ke,ge)},createTestRun:(De,ke,ge=!0)=>this.runTracker.createTestRun(q,ve,De,ke,ge),invalidateTestResults:De=>{(0,_.checkProposedApiEnabled)(N,"testInvalidateResults");for(const ke of De instanceof Array?De:[De]){const ge=ke?c.TestId.fromExtHostTestItem(ke,q).toString():q;this.proxy.$markTestRetired(ge)}},set resolveHandler(De){ve.resolveHandler=De},get resolveHandler(){return ve.resolveHandler},dispose:()=>{le.dispose()}};J.$registerTestController(q,B,!!U),le.add((0,g.toDisposable)(()=>J.$unregisterTestController(q)));const ce={controller:X,collection:ve,profiles:Pe};return this.controllers.set(q,ce),le.add((0,g.toDisposable)(()=>this.controllers.delete(q))),le.add(ve.onDidGenerateDiff(De=>J.$publishDiff(q,De.map(w.TestsDiffOp.serialize)))),X}createTestObserver(){return this.observer.checkout()}async runTests(N,q=M.CancellationToken.None){const B=T(N);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.controllers.get(B.controllerId);if(!U)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(le=>c.TestId.fromExtHostTestItem(le,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:V[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:N.exclude?.map(le=>le.id)},q)}$syncTests(){for(const{collection:N}of this.controllers.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,q,B){return(0,m.mapFind)(this.runTracker.trackers,le=>le.id===N?le.getCoverage(q):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(N,q,B,U){return(0,m.mapFind)(this.runTracker.trackers,ve=>ve.id===N?ve.getCoverage(q):void 0)?.resolveFileCoverage(B,U)??Promise.resolve([])}$configureRunProfile(N,q){this.controllers.get(N)?.profiles.get(q)?.configureHandler?.()}async $refreshTests(N,q){await this.controllers.get(N)?.controller.refreshHandler?.(q)}$publishTestResults(N){this.results=Object.freeze(N.map(q=>(0,R.deepFreeze)(t.TestResults.to(q))).concat(this.results).sort((q,B)=>B.completedAt-q.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(N,q){const B=this.controllers.get(c.TestId.fromString(N).controllerId)?.collection;B&&(await B.expand(N,q<0?1/0:q),B.flushDiff())}$acceptDiff(N){this.observer.applyDiff(N.map(w.TestsDiffOp.deserialize))}async $runControllerTests(N,q){return Promise.all(N.map(B=>this.runControllerTestRequest(B,!1,q)))}async $startContinuousRun(N,q){const B=new M.CancellationTokenSource(q),U=await Promise.all(N.map(le=>this.runControllerTestRequest(le,!0,B.token)));return!q.isCancellationRequested&&!U.some(le=>le.error)&&await new Promise(le=>q.onCancellationRequested(le)),B.dispose(!0),U}async runControllerTestRequest(N,q,B){const U=this.controllers.get(N.controllerId);if(!U)return{};const{collection:le,profiles:ve}=U,Pe=ve.get(N.profileId);if(!Pe)return{};const J=N.testIds.map(ke=>le.tree.get(ke)).filter(y.isDefined),X=N.excludeExtIds.map(ke=>U.collection.tree.get(ke)).filter(y.isDefined).filter(ke=>J.some(ge=>ge.fullId.compare(ke.fullId)===2));if(!J.length)return{};const ce=new r.TestRunRequest(J.some(ke=>ke.actual instanceof l.TestItemRootImpl)?void 0:J.map(ke=>ke.actual),X.map(ke=>ke.actual),Pe,q),De=(0,w.isStartControllerTests)(N)&&this.runTracker.prepareForMainThreadTestRun(ce,S.fromInternal(N,U.collection),B);try{return await Pe.runHandler(ce,B),{}}catch(ke){return{error:String(ke)}}finally{De&&(De.hasRunningTasks&&!B.isCancellationRequested&&await F.Event.toPromise(De.onEnd),De.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(N)}};e.ExtHostTesting=n=Ve([He(0,p.IExtHostRpcService)],n);const s=1e4;var v;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(v||(v={}));class I extends g.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(N,q,B){super(),this.dto=N,this.proxy=q,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new F.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new M.CancellationTokenSource(B));const U=this._register(new k.RunOnceScheduler(()=>this.forciblyEndTasks(),s));this._register(this.cts.token.onCancellationRequested(()=>U.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(N){return this.tasks.get(N)?.coverage}createRun(N){const q=this.dto.id,B=this.dto.controllerId,U=(0,d.generateUuid)(),le=new a(this.proxy,q,U),ve=ce=>(De,...ke)=>{if(J){console.warn(`Setting the state of test "${De.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(De)&&(this.ensureTestIsKnown(De),ce(De,...ke))},Pe=(ce,De)=>{const ke=De instanceof Array?De.map(t.TestMessage.from):[t.TestMessage.from(De)];if(ce.uri&&ce.range){const ge={range:t.Range.from(ce.range),uri:ce.uri};for(const A of ke)A.location=A.location||ge}this.proxy.$appendTestMessagesInRun(q,U,c.TestId.fromExtHostTestItem(ce,B).toString(),ke)};let J=!1;const X={isPersisted:this.dto.isPersisted,token:this.cts.token,name:N,get coverageProvider(){return le.coverageProvider},set coverageProvider(ce){le.coverageProvider=ce},enqueued:ve(ce=>{this.proxy.$updateTestStateInRun(q,U,c.TestId.fromExtHostTestItem(ce,B).toString(),1)}),skipped:ve(ce=>{this.proxy.$updateTestStateInRun(q,U,c.TestId.fromExtHostTestItem(ce,B).toString(),5)}),started:ve(ce=>{this.proxy.$updateTestStateInRun(q,U,c.TestId.fromExtHostTestItem(ce,B).toString(),2)}),errored:ve((ce,De,ke)=>{Pe(ce,De),this.proxy.$updateTestStateInRun(q,U,c.TestId.fromExtHostTestItem(ce,B).toString(),6,ke)}),failed:ve((ce,De,ke)=>{Pe(ce,De),this.proxy.$updateTestStateInRun(q,U,c.TestId.fromExtHostTestItem(ce,B).toString(),4,ke)}),passed:ve((ce,De)=>{this.proxy.$updateTestStateInRun(q,U,c.TestId.fromExtHostTestItem(ce,this.dto.controllerId).toString(),3,De)}),appendOutput:(ce,De,ke)=>{J||(ke&&(this.dto.isIncluded(ke)?this.ensureTestIsKnown(ke):ke=void 0),this.proxy.$appendOutputToRun(q,U,C.VSBuffer.fromString(ce),De&&t.location.from(De),ke&&c.TestId.fromExtHostTestItem(ke,B).toString()))},end:()=>{J||(J=!0,this.proxy.$finishedTestRunTask(q,U),this.tasks.delete(U),this.tasks.size||this.markEnded())}};return this.tasks.set(U,{run:X,coverage:le}),this.proxy.$startedTestRunTask(q,{id:U,name:N,running:!0}),X}forciblyEndTasks(){for(const{run:N}of this.tasks.values())N.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(N){if(!(N instanceof l.TestItemImpl))throw new b.InvalidTestItemError(N.id);if(this.sharedTestIds.has(c.TestId.fromExtHostTestItem(N,this.dto.controllerId).toString()))return;const q=[],B=this.dto.colllection.root;for(;;){const U=t.TestItem.from(N);if(q.unshift(U),this.sharedTestIds.has(U.extId)||(this.sharedTestIds.add(U.extId),N===B))break;N=N.parent||B}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,q)}}class h{get trackers(){return this.tracked.values()}constructor(N){this.proxy=N,this.tracked=new Map}prepareForMainThreadTestRun(N,q,B){return this.getTracker(N,q,B)}cancelRunById(N){for(const q of this.tracked.values())if(q.id===N){q.cancel();return}}cancelAllRuns(){for(const N of this.tracked.values())N.cancel()}createTestRun(N,q,B,U,le){const ve=this.tracked.get(B);if(ve)return ve.createRun(U);const Pe=S.fromPublic(N,q,B,le),J=T(B);this.proxy.$startedExtensionTestRun({controllerId:N,continuous:!!B.continuous,profile:J&&{group:V[J.kind],id:J.profileId},exclude:B.exclude?.map(ce=>c.TestId.fromExtHostTestItem(ce,q.root.id).toString())??[],id:Pe.id,include:B.include?.map(ce=>c.TestId.fromExtHostTestItem(ce,q.root.id).toString())??[q.root.id],persist:le});const X=this.getTracker(B,Pe);return X.onEnd(()=>{this.proxy.$finishedExtensionTestRun(Pe.id),X.dispose()}),X.createRun(U)}getTracker(N,q,B){const U=new I(q,this.proxy,B);return this.tracked.set(N,U),U.onEnd(()=>this.tracked.delete(N)),U}}e.TestRunCoordinator=h;const T=z=>{if(z.profile){if(!(z.profile instanceof K))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class S{static fromPublic(N,q,B,U){return new S(N,(0,d.generateUuid)(),B.include?.map(le=>c.TestId.fromExtHostTestItem(le,N).toString())??[N],B.exclude?.map(le=>c.TestId.fromExtHostTestItem(le,N).toString())??[],U,q)}static fromInternal(N,q){return new S(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,q)}constructor(N,q,B,U,le,ve){this.controllerId=N,this.id=q,this.isPersisted=le,this.colllection=ve,this.includePrefix=B.map(Pe=>Pe+"\0"),this.excludePrefix=U.map(Pe=>Pe+"\0")}isIncluded(N){const q=c.TestId.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const B of this.excludePrefix)if(q===B||q.startsWith(B))return!1;for(const B of this.includePrefix)if(q===B||q.startsWith(B))return!0;return!1}}e.TestRunDto=S;class a{set coverageProvider(N){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");N&&(this._coverageProvider=N,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(N,q,B){this.proxy=N,this.runId=q,this.taskId=B}async provideFileCoverage(N){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(N))());try{return(await this.fileCoverage)?.map(t.TestCoverage.fromFile)??[]}catch(q){throw this.fileCoverage=void 0,q}}async resolveFileCoverage(N,q){const B=await this.fileCoverage;let U=B?.[N];return!this._coverageProvider||!B||!U?[]:(U.detailedCoverage||(U=B[N]=await this._coverageProvider.resolveFileCoverage?.(U,q)??U),U.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class o{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(N){this.emitter=N,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(N){this.added.add(N)}update(N){Object.assign(N.revived,t.TestItem.toPlain(N.item)),this.added.has(N)||this.updated.add(N)}remove(N){if(this.added.has(N)){this.added.delete(N);return}this.updated.delete(N);const q=c.TestId.parentId(N.item.extId);if(q&&this.alreadyRemoved.has(q.toString())){this.alreadyRemoved.add(N.item.extId);return}this.removed.add(N)}getChangeEvent(){const{added:N,updated:q,removed:B}=this;return{get added(){return[...N].map(U=>U.revived)},get updated(){return[...q].map(U=>U.revived)},get removed(){return[...B].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class O extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new F.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(N){return this.items.get(N)}getMirroredTestDataByReference(N){return this.items.get(N.id)}createItem(N,q){return{...N,revived:t.TestItem.toPlain(N.item),depth:q?q.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}class ${constructor(N){this.proxy=N}checkout(){this.current||(this.current=this.createObserverData());const N=this.current;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(q=>q.revived)},dispose:(0,f.once)(()=>{--N.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(N){return this.current?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.current?.tests.apply(N)}createObserverData(){const N=new O;return this.proxy.$subscribeToDiffs(),{observers:0,tests:N}}}class K{get label(){return this._label}set label(N){N!==this._label&&(this._label=N,Fe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(N){N!==this._supportsContinuousRun&&(this._supportsContinuousRun=N,Fe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this._isDefault}set isDefault(N){N!==this._isDefault&&(this._isDefault=N,Fe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,Fe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?t.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(N){N!==this._configureHandler&&(this._configureHandler=N,Fe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}constructor(N,q,B,U,le,ve,Pe,J=!1,X=void 0,ce=!1){this.controllerId=B,this.profileId=U,this._label=le,this.kind=ve,this.runHandler=Pe,this._isDefault=J,this._tag=X,this._supportsContinuousRun=ce,i.set(this,void 0),u.set(this,void 0),Xe(this,i,N,"f"),Xe(this,u,q,"f"),q.set(U,this);const De=V[ve];if(typeof De!="number")throw new Error(`Unknown TestRunProfile.group ${ve}`);Fe(this,i,"f").$publishTestRunProfile({profileId:U,controllerId:B,tag:X?t.TestTag.namespace(this.controllerId,X.id):null,label:le,group:De,isDefault:J,hasConfigurationHandler:!1,supportsContinuousRun:ce})}dispose(){Fe(this,u,"f")?.delete(this.profileId)&&(Xe(this,u,void 0,"f"),Fe(this,i,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=K,i=new WeakMap,u=new WeakMap;const V={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(Ae[247],Re([1,0,18,9,5,4,105,8,7]),function(te,e,m,k,C,M,F,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class g{constructor(y,d){this._extHostDocumentsAndEditors=d,this._onDidChangeTextEditorSelection=new C.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new C.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new C.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new C.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new C.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new C.Emitter({onListenerError:k.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=y.getProxy(M.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(E=>this._onDidChangeVisibleTextEditors.fire(E)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(E=>this._onDidChangeActiveTextEditor.fire(E))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(y){const d=this._extHostDocumentsAndEditors.allEditors();return y?d:d.map(E=>E.value)}async showTextDocument(y,d,E){let p;typeof d=="number"?p={position:f.ViewColumn.from(d),preserveFocus:E}:typeof d=="object"?p={position:f.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selection:typeof d.selection=="object"?f.Range.from(d.selection):void 0,pinned:typeof d.preview=="boolean"?!d.preview:void 0}:p={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(y.uri,p),t=l&&this._extHostDocumentsAndEditors.getEditor(l);if(t)return t.value;throw l?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,d){return new F.TextEditorDecorationType(this._proxy,y,d).value}$acceptEditorPropertiesChanged(y,d){const E=this._extHostDocumentsAndEditors.getEditor(y);if(!E)throw new Error("unknown text editor");if(d.options&&E._acceptOptions(d.options),d.selections){const p=d.selections.selections.map(f.Selection.to);E._acceptSelections(p)}if(d.visibleRanges){const p=m.coalesce(d.visibleRanges.map(f.Range.to));E._acceptVisibleRanges(p)}if(d.options&&this._onDidChangeTextEditorOptions.fire({textEditor:E.value,options:{...d.options,lineNumbers:f.TextEditorLineNumbersStyle.to(d.options.lineNumbers)}}),d.selections){const p=D.TextEditorSelectionChangeKind.fromValue(d.selections.source),l=d.selections.selections.map(f.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:E.value,selections:l,kind:p})}if(d.visibleRanges){const p=m.coalesce(d.visibleRanges.map(f.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:E.value,visibleRanges:p})}}$acceptEditorPositionData(y){for(const d in y){const E=this._extHostDocumentsAndEditors.getEditor(d);if(!E)throw new Error("Unknown text editor");const p=f.ViewColumn.to(y[d]);E.value.viewColumn!==p&&(E._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:E.value,viewColumn:p}))}}getDiffInformation(y){return Promise.resolve(this._proxy.$getDiffInformation(y))}}e.ExtHostEditors=g}),define(Ae[248],Re([1,0,2,3,4,6,7,8,24,10]),function(te,e,m,k,C,M,F,f,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class R{constructor(E,p){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=E.getProxy(C.MainContext.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(l,t)=>{if(l&&l.$mid===12)if(this._providers.get(l.source)&&D.ExtensionIdentifier.equals(t,this._providers.get(l.source)?.extension)){const r=l.uri===void 0?void 0:m.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(y(r))?.get(l.handle)}else return;return l}})}async $getTimeline(E,p,l,t){return this._providers.get(E)?.provider.provideTimeline(m.URI.revive(p),l,t)}registerTimelineProvider(E,p,l,t){const r=new M.DisposableStore,c=this.convertTimelineItem(p.id,t,r).bind(this);let b;p.onDidChange&&(b=p.onDidChange(_=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,..._,id:p.id}),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...p,scheme:E,onDidChange:void 0,async provideTimeline(_,i,u){i?.resetCache&&(r.clear(),w.get(p.id)?.clear());const n=await p.provideTimeline(_,i,u);if(n==null)return;const s=c(_,i);return{...n,source:p.id,items:n.items.map(s)}},dispose(){for(const _ of w.values())_.get(p.id)?.clear();b?.dispose(),r.dispose()}},l)}convertTimelineItem(E,p,l){return(t,r)=>{let c;if(r?.cacheResults){let b=this._itemsBySourceAndUriMap.get(E);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(E,b));const w=y(t);c=b.get(w),c===void 0&&(c=new Map,b.set(w,c))}return b=>{const{iconPath:w,..._}=b,i=`${E}|${b.id??b.timestamp}`;c?.set(i,b);let u,n,s;b.iconPath&&(w instanceof F.ThemeIcon?s={id:w.id,color:w.color}:m.URI.isUri(w)?(u=w,n=w):{light:u,dark:n}=w);let v;return F.MarkdownString.isMarkdownString(_.tooltip)?v=f.MarkdownString.from(_.tooltip):(0,g.isString)(_.tooltip)?v=_.tooltip:F.MarkdownString.isMarkdownString(_.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=f.MarkdownString.from(_.detail)):(0,g.isString)(_.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=_.detail),{..._,id:_.id??void 0,handle:i,source:E,command:b.command?p.toInternal(b.command,l):void 0,icon:u,iconDark:n,themeIcon:s,tooltip:v,accessibilityInformation:b.accessibilityInformation}}}}registerTimelineProviderCore(E,p){if(this._providers.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this._proxy.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this._providers.set(E.id,{provider:E,extension:p}),(0,M.toDisposable)(()=>{for(const t of this._itemsBySourceAndUriMap.values())t.get(E.id)?.clear();this._providers.delete(E.id),this._proxy.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=R;function y(d){return d?.toString()}}),define(Ae[249],Re([1,0,6,14,2,4]),function(te,e,m,k,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class F{constructor(D){this._openers=new Map,this._proxy=D.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,g,R,y){if(this._openers.has(g))throw new Error(`Opener with id '${g}' already registered`);const d=y.schemes.find(E=>!F.supportedSchemes.has(E));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(g,R),this._proxy.$registerUriOpener(g,y.schemes,D,y.label),(0,m.toDisposable)(()=>{this._openers.delete(g),this._proxy.$unregisterUriOpener(g)})}async $canOpenUri(D,g,R){const y=this._openers.get(D);if(!y)throw new Error(`Unknown opener with id: ${D}`);const d=C.URI.revive(g);return y.canOpenExternalUri(d,R)}async $openUri(D,g,R){const y=this._openers.get(D);if(!y)throw new Error(`Unknown opener id: '${D}'`);return y.openExternalUri(C.URI.revive(g.resolvedUri),{sourceUri:C.URI.revive(g.sourceUri)},R)}}e.ExtHostUriOpeners=F,F.supportedSchemes=new Set([k.Schemas.http,k.Schemas.https])}),define(Ae[250],Re([1,0,4,2,6,9,24]),function(te,e,m,k,C,M,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class f{constructor(g){this.handles=new F.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=g.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(g,R){const y=g.identifier;if(this.handles.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const d=f.HandlePool++;return this.handles.add(y),this.handlers.set(d,R),this._proxy.$registerUriHandler(d,y,g.displayName||g.name),(0,C.toDisposable)(()=>{this.handles.delete(y),this.handlers.delete(d),this._proxy.$unregisterUriHandler(d)})}$handleExternalUri(g,R){const y=this.handlers.get(g);if(!y)return Promise.resolve(void 0);try{y.handleUri(k.URI.revive(R))}catch(d){(0,M.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(g){return k.URI.revive(await this._proxy.$createAppUri(g))}}e.ExtHostUrls=f,f.HandlePool=0});var Xe=this&&this.__classPrivateFieldSet||function(te,e,m,k,C){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?C.call(te,m):C?C.value=m:e.set(te,m),m},Fe=this&&this.__classPrivateFieldGet||function(te,e,m,k){if(m==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?k:m==="a"?k.call(te):k?k.value:e.get(te)};define(Ae[63],Re([1,0,5,14,23,2,167,190,78,4]),function(te,e,m,k,C,M,F,f,D,g){"use strict";var R,y,d,E,p,l,t,r,c,b,w,_,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(o,O,$,K,V,z,N){R.set(this,void 0),y.set(this,void 0),d.set(this,void 0),E.set(this,void 0),p.set(this,void 0),l.set(this,void 0),t.set(this,""),r.set(this,void 0),c.set(this,!1),b.set(this,!1),w.set(this,void 0),_.set(this,void 0),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new m.Emitter),this._onDidDispose=Fe(this,i,"f").event,Xe(this,R,o,"f"),Xe(this,y,O,"f"),Xe(this,r,$,"f"),Xe(this,E,K,"f"),Xe(this,p,V,"f"),Xe(this,l,z,"f"),Xe(this,w,n(z),"f"),Xe(this,_,s(z),"f"),Xe(this,d,N,"f")}dispose(){Xe(this,c,!0,"f"),Fe(this,i,"f").fire(),Fe(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return Xe(this,b,!0,"f"),(0,D.asWebviewUri)(o,Fe(this,E,"f"))}get cspSource(){const o=Fe(this,l,"f").extensionLocation;if(o.scheme===k.Schemas.https||o.scheme===k.Schemas.http){let O=o.toString();return O.endsWith("/")||(O+="/"),O+" "+D.webviewGenericCspSource}return D.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Fe(this,t,"f")}set html(o){this.assertNotDisposed(),Fe(this,t,"f")!==o&&(Xe(this,t,o,"f"),Fe(this,_,"f")&&!Fe(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(Xe(this,b,!0,"f"),Fe(this,d,"f").report("Webview vscode-resource: uris",Fe(this,l,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Fe(this,y,"f").$setHtml(Fe(this,R,"f"),this.rewriteOldResourceUrlsIfNeeded(o)))}get options(){return this.assertNotDisposed(),Fe(this,r,"f")}set options(o){this.assertNotDisposed(),C.equals(Fe(this,r,"f"),o)||Fe(this,y,"f").$setOptions(Fe(this,R,"f"),h(Fe(this,l,"f"),Fe(this,p,"f"),o)),Xe(this,r,o,"f")}async postMessage(o){if(Fe(this,c,"f"))return!1;const O=(0,f.serializeWebviewMessage)(o,{serializeBuffersForPostMessage:Fe(this,w,"f")});return Fe(this,y,"f").$postMessage(Fe(this,R,"f"),O.message,...O.buffers)}assertNotDisposed(){if(Fe(this,c,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(o){if(!Fe(this,_,"f"))return o;const O=Fe(this,l,"f").extensionLocation?.scheme===k.Schemas.vscodeRemote,$=Fe(this,l,"f").extensionLocation.scheme===k.Schemas.vscodeRemote?Fe(this,l,"f").extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(K,V,z,N,q,B)=>{const U=M.URI.from({scheme:N||"file",path:decodeURIComponent(q)}),le=(0,D.asWebviewUri)(U,{isRemote:O,authority:$}).toString();return`${V}${le}${B}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(K,V,z,N,q,B)=>{const U=M.URI.from({scheme:N||"file",path:decodeURIComponent(q)}),le=(0,D.asWebviewUri)(U,{isRemote:O,authority:$}).toString();return`${V}${le}${B}`})}}e.ExtHostWebview=u,R=new WeakMap,y=new WeakMap,d=new WeakMap,E=new WeakMap,p=new WeakMap,l=new WeakMap,t=new WeakMap,r=new WeakMap,c=new WeakMap,b=new WeakMap,w=new WeakMap,_=new WeakMap,i=new WeakMap;function n(a){try{const o=(0,F.normalizeVersion)((0,F.parseVersion)(a.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=n;function s(a){try{const o=(0,F.normalizeVersion)((0,F.parseVersion)(a.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class v{constructor(o,O,$,K,V){this.remoteInfo=O,this.workspace=$,this._logService=K,this._deprecationService=V,this._webviews=new Map,this._webviewProxy=o.getProxy(g.MainContext.MainThreadWebviews)}$onMessage(o,O,$){const K=this.getWebview(o);if(K){const{message:V}=(0,f.deserializeWebviewMessage)(O,$.value);K._onMessageEmitter.fire(V)}}$onMissingCsp(o,O){this._logService.warn(`${O} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,O,$){const K=new u(o,this._webviewProxy,T(O),this.remoteInfo,this.workspace,$,this._deprecationService);return this._webviews.set(o,K),K._onDidDispose(()=>{this._webviews.delete(o)}),K}deleteWebview(o){this._webviews.delete(o)}getWebview(o){return this._webviews.get(o)}}e.ExtHostWebviews=v;function I(a){return{id:a.identifier,location:a.extensionLocation}}e.toExtensionData=I;function h(a,o,O){return{enableCommandUris:O.enableCommandUris,enableScripts:O.enableScripts,enableForms:O.enableForms,portMapping:O.portMapping,localResourceRoots:O.localResourceRoots||S(a,o)}}e.serializeWebviewOptions=h;function T(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(o=>M.URI.from(o))}}function S(a,o){return[...(o?.getWorkspaceFolders()||[]).map(O=>O.uri),a.extensionLocation]}}),define(Ae[251],Re([1,0,22,93,6,14,20,2,8,63,54,4,7]),function(te,e,m,k,C,M,F,f,D,g,R,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(u,n){this.document=u,this._storagePath=n,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(u){return this._edits.add([u])}async undo(u,n){await this.getEdit(u).undo(),n||this.disposeBackup()}async redo(u,n){await this.getEdit(u).redo(),n||this.disposeBackup()}disposeEdits(u){for(const n of u)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const u=_(this.document.uri)+this._backupCounter++;return(0,F.joinPath)(this._storagePath,u)}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(u){const n=this._edits.get(u,0);if(!n)throw new Error("No edit found");return n}}class p{constructor(){this._documents=new Map}get(u,n){return this._documents.get(this.key(u,n))}add(u,n,s){const v=this.key(u,n.uri);if(this._documents.has(v))throw new Error(`Document already exists for viewType:${u} resource:${n.uri}`);const I=new E(n,s);return this._documents.set(v,I),I}delete(u,n){const s=this.key(u,n.uri);this._documents.delete(s)}key(u,n){return`${u}@@@${n}`}}var l;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(l||(l={}));class t{constructor(){this._providers=new Map}addTextProvider(u,n,s){return this.add(0,u,n,s)}addCustomProvider(u,n,s){return this.add(1,u,n,s)}get(u){return this._providers.get(u)}add(u,n,s,v){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:u,extension:s,provider:v}),new d.Disposable(()=>this._providers.delete(n))}}class r{constructor(u,n,s,v,I){this._extHostDocuments=n,this._extensionStoragePaths=s,this._extHostWebview=v,this._extHostWebviewPanels=I,this._editorProviders=new t,this._documents=new p,this._proxy=u.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(u,n,s,v){const I=new C.DisposableStore;return b(s)?(I.add(this._editorProviders.addTextProvider(n,u,s)),this._proxy.$registerTextEditorProvider((0,g.toExtensionData)(u),n,v.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,g.shouldSerializeBuffersForPostMessage)(u))):(I.add(this._editorProviders.addCustomProvider(n,u,s)),c(s)&&I.add(s.onDidChangeCustomDocument(h=>{const T=this.getCustomDocumentEntry(n,h.document.uri);if(w(h)){const S=T.addEdit(h);this._proxy.$onDidEdit(h.document.uri,n,S,h.label)}else this._proxy.$onContentChange(h.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,g.toExtensionData)(u),n,v.webviewOptions||{},!!v.supportsMultipleEditorsPerDocument,(0,g.shouldSerializeBuffersForPostMessage)(u))),d.Disposable.from(I,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(u,n,s,v,I){const h=this._editorProviders.get(n);if(!h)throw new Error(`No provider found for '${n}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${n}'`);const T=f.URI.revive(u),S=await h.provider.openCustomDocument(T,{backupId:s,untitledDocumentData:v?.buffer},I);let a;return c(h.provider)&&this._extensionStoragePaths&&(a=this._extensionStoragePaths.workspaceValue(h.extension)??this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(n,S,a),{editable:c(h.provider)}}async $disposeCustomDocument(u,n){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const v=f.URI.revive(u),{document:I}=this.getCustomDocumentEntry(n,v);this._documents.delete(n,I),I.dispose()}async $resolveCustomEditor(u,n,s,v,I,h){const T=this._editorProviders.get(s);if(!T)throw new Error(`No provider found for '${s}'`);const S=D.ViewColumn.to(I),a=this._extHostWebview.createNewWebview(n,v.contentOptions,T.extension),o=this._extHostWebviewPanels.createNewWebviewPanel(n,s,v.title,S,v.options,a,v.active),O=f.URI.revive(u);switch(T.type){case 1:{const{document:$}=this.getCustomDocumentEntry(s,O);return T.provider.resolveCustomEditor($,o,h)}case 0:{const $=this._extHostDocuments.getDocument(O);return T.provider.resolveCustomTextEditor($,o,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,n,s){this.getCustomDocumentEntry(n,u).disposeEdits(s)}async $onMoveCustomEditor(u,n,s){const v=this._editorProviders.get(s);if(!v)throw new Error(`No provider found for '${s}'`);if(!v.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const I=this._extHostWebviewPanels.getWebviewPanel(u);if(!I)throw new Error("No webview found");const h=f.URI.revive(n),T=this._extHostDocuments.getDocument(h);await v.provider.moveCustomTextEditor(T,I,m.CancellationToken.None)}async $undo(u,n,s,v){return this.getCustomDocumentEntry(n,u).undo(s,v)}async $redo(u,n,s,v){return this.getCustomDocumentEntry(n,u).redo(s,v)}async $revert(u,n,s){const v=this.getCustomDocumentEntry(n,u);await this.getCustomEditorProvider(n).revertCustomDocument(v.document,s),v.disposeBackup()}async $onSave(u,n,s){const v=this.getCustomDocumentEntry(n,u);await this.getCustomEditorProvider(n).saveCustomDocument(v.document,s),v.disposeBackup()}async $onSaveAs(u,n,s,v){const I=this.getCustomDocumentEntry(n,u);return this.getCustomEditorProvider(n).saveCustomDocumentAs(I.document,f.URI.revive(s),v)}async $backup(u,n,s){const v=this.getCustomDocumentEntry(n,u),h=await this.getCustomEditorProvider(n).backupCustomDocument(v.document,{destination:v.getNewBackupUri()},s);return v.updateBackup(h),h.id}getCustomDocumentEntry(u,n){const s=this._documents.get(u,f.URI.revive(n));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(u){const s=this._editorProviders.get(u)?.provider;if(!s||!c(s))throw new Error("Custom document is not editable");return s}}e.ExtHostCustomEditors=r;function c(i){return!!i.onDidChangeCustomDocument}function b(i){return typeof i.resolveCustomTextEditor=="function"}function w(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function _(i){const u=i.scheme===M.Schemas.file||i.scheme===M.Schemas.untitled?i.fsPath:i.toString();return(0,k.hash)(u)+""}});var Xe=this&&this.__classPrivateFieldSet||function(te,e,m,k,C){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?C.call(te,m):C?C.value=m:e.set(te,m),m},Fe=this&&this.__classPrivateFieldGet||function(te,e,m,k){if(m==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?k:m==="a"?k.call(te):k?k.value:e.get(te)};define(Ae[252],Re([1,0,5,6,2,36,8,63,4,7]),function(te,e,m,k,C,M,F,f,D,g){"use strict";var R,y,d,E,p,l,t,r,c,b,w,_,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends k.Disposable{constructor(I,h,T,S){super(),R.set(this,void 0),y.set(this,void 0),d.set(this,void 0),E.set(this,void 0),p.set(this,void 0),l.set(this,void 0),t.set(this,void 0),r.set(this,void 0),c.set(this,!0),b.set(this,void 0),w.set(this,!1),_.set(this,this._register(new m.Emitter)),this.onDidDispose=Fe(this,_,"f").event,i.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Fe(this,i,"f").event,Xe(this,R,I,"f"),Xe(this,y,h,"f"),Xe(this,E,T,"f"),Xe(this,d,S.viewType,"f"),Xe(this,p,S.panelOptions,"f"),Xe(this,r,S.viewColumn,"f"),Xe(this,l,S.title,"f"),Xe(this,b,S.active,"f")}dispose(){Fe(this,w,"f")||(Xe(this,w,!0,"f"),Fe(this,_,"f").fire(),Fe(this,y,"f").$disposeWebview(Fe(this,R,"f")),Fe(this,E,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Fe(this,E,"f")}get viewType(){return this.assertNotDisposed(),Fe(this,d,"f")}get title(){return this.assertNotDisposed(),Fe(this,l,"f")}set title(I){this.assertNotDisposed(),Fe(this,l,"f")!==I&&(Xe(this,l,I,"f"),Fe(this,y,"f").$setTitle(Fe(this,R,"f"),I))}get iconPath(){return this.assertNotDisposed(),Fe(this,t,"f")}set iconPath(I){this.assertNotDisposed(),Fe(this,t,"f")!==I&&(Xe(this,t,I,"f"),Fe(this,y,"f").$setIconPath(Fe(this,R,"f"),C.URI.isUri(I)?{light:I,dark:I}:I))}get options(){return Fe(this,p,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Fe(this,r,"f")=="number"&&Fe(this,r,"f")<0))return Fe(this,r,"f")}get active(){return this.assertNotDisposed(),Fe(this,b,"f")}get visible(){return this.assertNotDisposed(),Fe(this,c,"f")}_updateViewState(I){Fe(this,w,"f")||(this.active!==I.active||this.visible!==I.visible||this.viewColumn!==I.viewColumn)&&(Xe(this,b,I.active,"f"),Xe(this,c,I.visible,"f"),Xe(this,r,I.viewColumn,"f"),Fe(this,i,"f").fire({webviewPanel:this}))}reveal(I,h){this.assertNotDisposed(),Fe(this,y,"f").$reveal(Fe(this,R,"f"),{viewColumn:typeof I>"u"?void 0:F.ViewColumn.from(I),preserveFocus:!!h})}assertNotDisposed(){if(Fe(this,w,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,y=new WeakMap,d=new WeakMap,E=new WeakMap,p=new WeakMap,l=new WeakMap,t=new WeakMap,r=new WeakMap,c=new WeakMap,b=new WeakMap,w=new WeakMap,_=new WeakMap,i=new WeakMap;class n{static newHandle(){return(0,M.generateUuid)()}constructor(I,h,T){this.webviews=h,this.workspace=T,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=I.getProxy(D.MainContext.MainThreadWebviewPanels)}createWebviewPanel(I,h,T,S,a={}){const o=typeof S=="object"?S.viewColumn:S,O={viewColumn:F.ViewColumn.from(o),preserveFocus:typeof S=="object"&&!!S.preserveFocus},$=(0,f.shouldSerializeBuffersForPostMessage)(I),K=n.newHandle();this._proxy.$createWebviewPanel((0,f.toExtensionData)(I),K,h,{title:T,panelOptions:s(a),webviewOptions:(0,f.serializeWebviewOptions)(I,this.workspace,a),serializeBuffersForPostMessage:$},O);const V=this.webviews.createNewWebview(K,a,I);return this.createNewWebviewPanel(K,h,T,o,a,V,!0)}$onDidChangeWebviewPanelViewStates(I){const h=Object.keys(I);h.sort((T,S)=>{const a=I[T],o=I[S];return a.active?1:o.active?-1:+a.visible-+o.visible});for(const T of h){const S=this.getWebviewPanel(T);if(!S)continue;const a=I[T];S._updateViewState({active:a.active,visible:a.visible,viewColumn:F.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(I){this.getWebviewPanel(I)?.dispose(),this._webviewPanels.delete(I),this.webviews.deleteWebview(I)}registerWebviewPanelSerializer(I,h,T){if(this._serializers.has(h))throw new Error(`Serializer for '${h}' already registered`);return this._serializers.set(h,{serializer:T,extension:I}),this._proxy.$registerSerializer(h,{serializeBuffersForPostMessage:(0,f.shouldSerializeBuffersForPostMessage)(I)}),new g.Disposable(()=>{this._serializers.delete(h),this._proxy.$unregisterSerializer(h)})}async $deserializeWebviewPanel(I,h,T,S){const a=this._serializers.get(h);if(!a)throw new Error(`No serializer found for '${h}'`);const{serializer:o,extension:O}=a,$=this.webviews.createNewWebview(I,T.webviewOptions,O),K=this.createNewWebviewPanel(I,h,T.title,S,T.panelOptions,$,T.active);await o.deserializeWebviewPanel(K,T.state)}createNewWebviewPanel(I,h,T,S,a,o,O){const $=new u(I,this._proxy,o,{viewType:h,title:T,viewColumn:S,panelOptions:a,active:O});return this._webviewPanels.set(I,$),$}getWebviewPanel(I){return this._webviewPanels.get(I)}}e.ExtHostWebviewPanels=n;function s(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}});var Xe=this&&this.__classPrivateFieldSet||function(te,e,m,k,C){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?C.call(te,m):C?C.value=m:e.set(te,m),m},Fe=this&&this.__classPrivateFieldGet||function(te,e,m,k){if(m==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?k:m==="a"?k.call(te):k?k.value:e.get(te)};define(Ae[253],Re([1,0,5,6,63,8,4,7]),function(te,e,m,k,C,M,F,f){"use strict";var D,g,R,y,d,E,p,l,t,r,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends k.Disposable{constructor(i,u,n,s,v,I){super(),D.set(this,void 0),g.set(this,void 0),R.set(this,void 0),y.set(this,void 0),d.set(this,!1),E.set(this,void 0),p.set(this,void 0),l.set(this,void 0),t.set(this,void 0),r.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Fe(this,r,"f").event,c.set(this,this._register(new m.Emitter)),this.onDidDispose=Fe(this,c,"f").event,Xe(this,R,n,"f"),Xe(this,p,s,"f"),Xe(this,D,i,"f"),Xe(this,g,u,"f"),Xe(this,y,v,"f"),Xe(this,E,I,"f")}dispose(){Fe(this,d,"f")||(Xe(this,d,!0,"f"),Fe(this,c,"f").fire(),Fe(this,y,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Fe(this,p,"f")}set title(i){this.assertNotDisposed(),Fe(this,p,"f")!==i&&(Xe(this,p,i,"f"),Fe(this,g,"f").$setWebviewViewTitle(Fe(this,D,"f"),i))}get description(){return this.assertNotDisposed(),Fe(this,l,"f")}set description(i){this.assertNotDisposed(),Fe(this,l,"f")!==i&&(Xe(this,l,i,"f"),Fe(this,g,"f").$setWebviewViewDescription(Fe(this,D,"f"),i))}get visible(){return Fe(this,E,"f")}get webview(){return Fe(this,y,"f")}get viewType(){return Fe(this,R,"f")}_setVisible(i){i===Fe(this,E,"f")||Fe(this,d,"f")||(Xe(this,E,i,"f"),Fe(this,r,"f").fire())}get badge(){return this.assertNotDisposed(),Fe(this,t,"f")}set badge(i){this.assertNotDisposed(),!(i?.value===Fe(this,t,"f")?.value&&i?.tooltip===Fe(this,t,"f")?.tooltip)&&(Xe(this,t,M.ViewBadge.from(i),"f"),Fe(this,g,"f").$setWebviewViewBadge(Fe(this,D,"f"),i))}show(i){this.assertNotDisposed(),Fe(this,g,"f").$show(Fe(this,D,"f"),!!i)}assertNotDisposed(){if(Fe(this,d,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,g=new WeakMap,R=new WeakMap,y=new WeakMap,d=new WeakMap,E=new WeakMap,p=new WeakMap,l=new WeakMap,t=new WeakMap,r=new WeakMap,c=new WeakMap;class w{constructor(i,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=i.getProxy(F.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,u,n,s){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:n,extension:i}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(i),u,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(i)}),new f.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(i,u,n,s,v){const I=this._viewProviders.get(u);if(!I)throw new Error(`No view provider found for '${u}'`);const{provider:h,extension:T}=I,S=this._extHostWebview.createNewWebview(i,{},T),a=new b(i,this._proxy,u,n,S,!0);this._webviewViews.set(i,a),await h.resolveWebviewView(a,{state:s},v)}async $onDidChangeWebviewViewVisibility(i,u){this.getWebviewView(i)._setVisible(u)}async $disposeWebviewView(i){const u=this.getWebviewView(i);this._webviewViews.delete(i),u.dispose(),this._extHostWebview.deleteWebview(i)}getWebviewView(i){const u=this._webviewViews.get(i);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=w}),define(Ae[108],Re([1,0,5,4,2,14,13,3,17,26]),function(te,e,m,k,C,M,F,f,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let R=e.ExtHostWindow=class Rn{getState(d){const E=this._state;return{get focused(){return E.focused},get active(){return(0,g.checkProposedApiEnabled)(d,"windowActivity"),E.active}}}constructor(d){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Rn.InitialState,this._proxy=d.getProxy(k.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:E,isActive:p})=>{this.onDidChangeWindowProperty("focused",E),this.onDidChangeWindowProperty("active",p)})}$onDidChangeWindowFocus(d){this.onDidChangeWindowProperty("focused",d)}$onDidChangeWindowActive(d){this.onDidChangeWindowProperty("active",d)}onDidChangeWindowProperty(d,E){E!==this._state[d]&&(this._state={...this._state,[d]:E},this._onDidChangeWindowState.fire(this._state))}openUri(d,E){let p;if(typeof d=="string"){p=d;try{d=C.URI.parse(d)}catch{return Promise.reject(`Invalid uri - '${d}'`)}}return(0,F.isFalsyOrWhitespace)(d.scheme)?Promise.reject("Invalid scheme - cannot be empty"):d.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${d.scheme}'`):this._proxy.$openUri(d,p,E)}async asExternalUri(d,E){if((0,F.isFalsyOrWhitespace)(d.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this._proxy.$asExternalUri(d,E);return C.URI.from(p)}};R.InitialState={focused:!0,active:!0},e.ExtHostWindow=R=Ve([He(0,D.IExtHostRpcService)],R),e.IExtHostWindow=(0,f.createDecorator)("IExtHostWindow")}),define(Ae[254],Re([1,0,221,27,17]),function(te,e,m,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=e.ExtHostConsoleForwarder=class extends m.AbstractExtHostConsoleForwarder{constructor(f,D){super(f,D)}_nativeConsoleLogMessage(f,D,g){D.apply(console,g)}};e.ExtHostConsoleForwarder=M=Ve([He(0,C.IExtHostRpcService),He(1,k.IExtHostInitDataService)],M)}),define(Ae[255],Re([1,0,16,25,22,9,5,6,132,214,46]),function(te,e,m,k,C,M,F,f,D,g,R){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function d(a,o){try{return JSON.stringify(a,o)}catch{return"null"}}const E="$$ref$$",p={[E]:-1};class l{constructor(o,O){this.jsonString=o,this.referencedBuffers=O}}function t(a,o=null,O=!1){const $=[];return{jsonString:(O?d:JSON.stringify)(a,(V,z)=>{if(typeof z>"u")return p;if(typeof z=="object"){if(z instanceof k.VSBuffer){const N=$.push(z)-1;return{[E]:N}}if(o)return o(V,z)}return z}),referencedBuffers:$}}e.stringifyJsonWithBufferRefs=t;function r(a,o,O){return JSON.parse(a,($,K)=>{if(K){const V=K[E];if(typeof V=="number")return o[V];if(O&&K.$mid===1)return O.transformIncoming(K)}return K})}e.parseJsonAndRestoreBufferRefs=r;function c(a,o){return JSON.stringify(a,o)}function b(a){return a?(o,O)=>O&&O.$mid===1?a.transformOutgoing(O):O:null}var w;(function(a){a[a.LocalSide=0]="LocalSide",a[a.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));var _;(function(a){a[a.Responsive=0]="Responsive",a[a.Unresponsive=1]="Unresponsive"})(_||(e.ResponsiveState=_={}));const i=()=>{},u=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class s extends f.Disposable{constructor(o,O=null,$=null){super(),this[y]=!0,this._onDidChangeResponsiveState=this._register(new F.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=o,this._logger=O,this._uriTransformer=$,this._uriReplacer=b(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let K=0,V=R.ProxyIdentifier.count;K<V;K++)this._locals[K]=null,this._proxies[K]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(K=>this._receiveOneMessage(K))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(o=>{this._pendingRPCReplies[o].resolveErr(M.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(o){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(o){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(o){this._responsiveState!==o&&(this._responsiveState=o,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(o){return this._uriTransformer?(0,D.transformIncomingURIs)(o,this._uriTransformer):o}getProxy(o){const{nid:O,sid:$}=o;return this._proxies[O]||(this._proxies[O]=this._createProxy(O,$)),this._proxies[O]}_createProxy(o,O){const $={get:(K,V)=>(typeof V=="string"&&!K[V]&&V.charCodeAt(0)===36&&(K[V]=(...z)=>this._remoteCall(o,V,z)),V===n?O:K[V])};return new Proxy(Object.create(null),$)}set(o,O){return this._locals[o.nid]=O,O}assertRegistered(o){for(let O=0,$=o.length;O<$;O++){const K=o[O];if(!this._locals[K.nid])throw new Error(`Missing proxy instance ${K.sid}`)}}_receiveOneMessage(o){if(this._isDisposed)return;const O=o.byteLength,$=v.read(o,0),K=$.readUInt8(),V=$.readUInt32();switch(K){case 1:case 2:{let{rpcId:z,method:N,args:q}=h.deserializeRequestJSONArgs($);this._uriTransformer&&(q=(0,D.transformIncomingURIs)(q,this._uriTransformer)),this._receiveRequest(O,V,z,N,q,K===2);break}case 3:case 4:{let{rpcId:z,method:N,args:q}=h.deserializeRequestMixedArgs($);this._uriTransformer&&(q=(0,D.transformIncomingURIs)(q,this._uriTransformer)),this._receiveRequest(O,V,z,N,q,K===4);break}case 5:{this._logger?.logIncoming(O,V,0,"ack"),this._onDidReceiveAcknowledge(V);break}case 6:{this._receiveCancel(O,V);break}case 7:{this._receiveReply(O,V,void 0);break}case 9:{let z=h.deserializeReplyOKJSON($);this._uriTransformer&&(z=(0,D.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReply(O,V,z);break}case 10:{const z=h.deserializeReplyOKJSONWithBuffers($,this._uriTransformer);this._receiveReply(O,V,z);break}case 8:{const z=h.deserializeReplyOKVSBuffer($);this._receiveReply(O,V,z);break}case 11:{let z=h.deserializeReplyErrError($);this._uriTransformer&&(z=(0,D.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReplyErr(O,V,z);break}case 12:{this._receiveReplyErr(O,V,void 0);break}default:console.error("received unexpected message"),console.error(o)}}_receiveRequest(o,O,$,K,V,z){this._logger?.logIncoming(o,O,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)($)}.${K}(`,V);const N=String(O);let q,B;if(z){const le=new C.CancellationTokenSource;V.push(le.token),q=this._invokeHandler($,K,V),B=()=>le.cancel()}else q=this._invokeHandler($,K,V),B=i;this._cancelInvokedHandlers[N]=B;const U=h.serializeAcknowledged(O);this._logger?.logOutgoing(U.byteLength,O,1,"ack"),this._protocol.send(U),q.then(le=>{delete this._cancelInvokedHandlers[N];const ve=h.serializeReplyOK(O,le,this._uriReplacer);this._logger?.logOutgoing(ve.byteLength,O,1,"reply:",le),this._protocol.send(ve)},le=>{delete this._cancelInvokedHandlers[N];const ve=h.serializeReplyErr(O,le);this._logger?.logOutgoing(ve.byteLength,O,1,"replyErr:",le),this._protocol.send(ve)})}_receiveCancel(o,O){this._logger?.logIncoming(o,O,1,"receiveCancel");const $=String(O);this._cancelInvokedHandlers[$]?.()}_receiveReply(o,O,$){this._logger?.logIncoming(o,O,0,"receiveReply:",$);const K=String(O);if(!this._pendingRPCReplies.hasOwnProperty(K))return;const V=this._pendingRPCReplies[K];delete this._pendingRPCReplies[K],V.resolveOk($)}_receiveReplyErr(o,O,$){this._logger?.logIncoming(o,O,0,"receiveReplyErr:",$);const K=String(O);if(!this._pendingRPCReplies.hasOwnProperty(K))return;const V=this._pendingRPCReplies[K];delete this._pendingRPCReplies[K];let z;$&&($.$isError?(z=new Error,z.name=$.name,z.message=$.message,z.stack=$.stack):z=$),V.resolveErr(z)}_invokeHandler(o,O,$){try{return Promise.resolve(this._doInvokeHandler(o,O,$))}catch(K){return Promise.reject(K)}}_doInvokeHandler(o,O,$){const K=this._locals[o];if(!K)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(o));const V=K[O];if(typeof V!="function")throw new Error("Unknown method "+O+" on actor "+(0,R.getStringIdentifierForProxy)(o));return V.apply(K,$)}_remoteCall(o,O,$){if(this._isDisposed)return new g.CanceledLazyPromise;let K=null;if($.length>0&&C.CancellationToken.isCancellationToken($[$.length-1])&&(K=$.pop()),K&&K.isCancellationRequested)return Promise.reject(M.canceled());const V=h.serializeRequestArguments($,this._uriReplacer),z=++this._lastMessageId,N=String(z),q=new g.LazyPromise;K&&K.onCancellationRequested(()=>{const U=h.serializeCancel(z);this._logger?.logOutgoing(U.byteLength,z,0,"cancel"),this._protocol.send(h.serializeCancel(z))}),this._pendingRPCReplies[N]=q,this._onWillSendRequest(z);const B=h.serializeRequest(z,o,O,V,!!K);return this._logger?.logOutgoing(B.byteLength,z,0,`request: ${(0,R.getStringIdentifierForProxy)(o)}.${O}(`,$),this._protocol.send(B),q}}e.RPCProtocol=s,y=u,s.UNRESPONSIVE_TIME=3*1e3;class v{static alloc(o,O,$){const K=new v(k.VSBuffer.alloc($+1+4),0);return K.writeUInt8(o),K.writeUInt32(O),K}static read(o,O){return new v(o,O)}get buffer(){return this._buff}constructor(o,O){this._buff=o,this._offset=O}static sizeUInt8(){return 1}writeUInt8(o){this._buff.writeUInt8(o,this._offset),this._offset+=1}readUInt8(){const o=this._buff.readUInt8(this._offset);return this._offset+=1,o}writeUInt32(o){this._buff.writeUInt32BE(o,this._offset),this._offset+=4}readUInt32(){const o=this._buff.readUInt32BE(this._offset);return this._offset+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this._buff.writeUInt8(o.byteLength,this._offset),this._offset+=1,this._buff.set(o,this._offset),this._offset+=o.byteLength}readShortString(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const $=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,$}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readLongString(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const $=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,$}writeBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readVSBuffer(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+o);return this._offset+=o,O}static sizeMixedArray(o){let O=0;O+=1;for(let $=0,K=o.length;$<K;$++){const V=o[$];switch(O+=1,V.type){case 1:O+=this.sizeLongString(V.value);break;case 2:O+=this.sizeVSBuffer(V.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(V.value);for(let z=0;z<V.buffers.length;++z)O+=this.sizeVSBuffer(V.buffers[z]);break;case 4:break}}return O}writeMixedArray(o){this._buff.writeUInt8(o.length,this._offset),this._offset+=1;for(let O=0,$=o.length;O<$;O++){const K=o[O];switch(K.type){case 1:this.writeUInt8(1),this.writeLongString(K.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(K.value);break;case 3:this.writeUInt8(3),this.writeUInt32(K.buffers.length),this.writeLongString(K.value);for(let V=0;V<K.buffers.length;++V)this.writeBuffer(K.buffers[V]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const O=new Array(o);for(let $=0;$<o;$++)switch(this.readUInt8()){case 1:O[$]=this.readLongString();break;case 2:O[$]=this.readVSBuffer();break;case 3:{const V=this.readUInt32(),z=this.readLongString(),N=[];for(let q=0;q<V;++q)N.push(this.readVSBuffer());O[$]=new R.SerializableObjectWithBuffers(r(z,N,null));break}case 4:O[$]=void 0;break}return O}}v.sizeUInt32=4;var I;(function(a){a[a.Simple=0]="Simple",a[a.Mixed=1]="Mixed"})(I||(I={}));class h{static _useMixedArgSerialization(o){for(let O=0,$=o.length;O<$;O++)if(o[O]instanceof k.VSBuffer||o[O]instanceof R.SerializableObjectWithBuffers||typeof o[O]>"u")return!0;return!1}static serializeRequestArguments(o,O){if(this._useMixedArgSerialization(o)){const $=[];for(let K=0,V=o.length;K<V;K++){const z=o[K];if(z instanceof k.VSBuffer)$[K]={type:2,value:z};else if(typeof z>"u")$[K]={type:4};else if(z instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:q}=t(z.value,O);$[K]={type:3,value:k.VSBuffer.fromString(N),buffers:q}}else $[K]={type:1,value:k.VSBuffer.fromString(c(z,O))}}return{type:1,args:$}}return{type:0,args:c(o,O)}}static serializeRequest(o,O,$,K,V){switch(K.type){case 0:return this._requestJSONArgs(o,O,$,K.args,V);case 1:return this._requestMixedArgs(o,O,$,K.args,V)}}static _requestJSONArgs(o,O,$,K,V){const z=k.VSBuffer.fromString($),N=k.VSBuffer.fromString(K);let q=0;q+=v.sizeUInt8(),q+=v.sizeShortString(z),q+=v.sizeLongString(N);const B=v.alloc(V?2:1,o,q);return B.writeUInt8(O),B.writeShortString(z),B.writeLongString(N),B.buffer}static deserializeRequestJSONArgs(o){const O=o.readUInt8(),$=o.readShortString(),K=o.readLongString();return{rpcId:O,method:$,args:JSON.parse(K)}}static _requestMixedArgs(o,O,$,K,V){const z=k.VSBuffer.fromString($);let N=0;N+=v.sizeUInt8(),N+=v.sizeShortString(z),N+=v.sizeMixedArray(K);const q=v.alloc(V?4:3,o,N);return q.writeUInt8(O),q.writeShortString(z),q.writeMixedArray(K),q.buffer}static deserializeRequestMixedArgs(o){const O=o.readUInt8(),$=o.readShortString(),K=o.readMixedArray(),V=new Array(K.length);for(let z=0,N=K.length;z<N;z++){const q=K[z];typeof q=="string"?V[z]=JSON.parse(q):V[z]=q}return{rpcId:O,method:$,args:V}}static serializeAcknowledged(o){return v.alloc(5,o,0).buffer}static serializeCancel(o){return v.alloc(6,o,0).buffer}static serializeReplyOK(o,O,$){if(typeof O>"u")return this._serializeReplyOKEmpty(o);if(O instanceof k.VSBuffer)return this._serializeReplyOKVSBuffer(o,O);if(O instanceof R.SerializableObjectWithBuffers){const{jsonString:K,referencedBuffers:V}=t(O.value,$,!0);return this._serializeReplyOKJSONWithBuffers(o,K,V)}else return this._serializeReplyOKJSON(o,d(O,$))}static _serializeReplyOKEmpty(o){return v.alloc(7,o,0).buffer}static _serializeReplyOKVSBuffer(o,O){let $=0;$+=v.sizeVSBuffer(O);const K=v.alloc(8,o,$);return K.writeVSBuffer(O),K.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static _serializeReplyOKJSON(o,O){const $=k.VSBuffer.fromString(O);let K=0;K+=v.sizeLongString($);const V=v.alloc(9,o,K);return V.writeLongString($),V.buffer}static _serializeReplyOKJSONWithBuffers(o,O,$){const K=k.VSBuffer.fromString(O);let V=0;V+=v.sizeUInt32,V+=v.sizeLongString(K);for(const N of $)V+=v.sizeVSBuffer(N);const z=v.alloc(10,o,V);z.writeUInt32($.length),z.writeLongString(K);for(const N of $)z.writeBuffer(N);return z.buffer}static deserializeReplyOKJSON(o){const O=o.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(o,O){const $=o.readUInt32(),K=o.readLongString(),V=[];for(let z=0;z<$;++z)V.push(o.readVSBuffer());return new R.SerializableObjectWithBuffers(r(K,V,O))}static serializeReplyErr(o,O){const $=O?d(M.transformErrorForSerialization(O),null):void 0;if(typeof $!="string")return this._serializeReplyErrEmpty(o);const K=k.VSBuffer.fromString($);let V=0;V+=v.sizeLongString(K);const z=v.alloc(11,o,V);return z.writeLongString(K),z.buffer}static deserializeReplyErrError(o){const O=o.readLongString();return JSON.parse(O)}static _serializeReplyErrEmpty(o){return v.alloc(12,o,0).buffer}}var T;(function(a){a[a.RequestJSONArgs=1]="RequestJSONArgs",a[a.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",a[a.RequestMixedArgs=3]="RequestMixedArgs",a[a.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",a[a.Acknowledged=5]="Acknowledged",a[a.Cancel=6]="Cancel",a[a.ReplyOKEmpty=7]="ReplyOKEmpty",a[a.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",a[a.ReplyOKJSON=9]="ReplyOKJSON",a[a.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",a[a.ReplyErrError=11]="ReplyErrError",a[a.ReplyErrEmpty=12]="ReplyErrEmpty"})(T||(T={}));var S;(function(a){a[a.String=1]="String",a[a.VSBuffer=2]="VSBuffer",a[a.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",a[a.Undefined=4]="Undefined"})(S||(S={}))}),define(Ae[256],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const m=function(M){const F=f=>{globalThis.removeEventListener("message",F);const D=f.data;Object.defineProperties(globalThis,{postMessage:{value(g,R){D.postMessage(g,R)}},onmessage:{get(){return D.onmessage},set(g){D.onmessage=g}}}),D.addEventListener("message",g=>{globalThis.dispatchEvent(new MessageEvent("message",{data:g.data,ports:g.ports?[...g.ports]:void 0}))}),D.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",F)}.toString();class k extends EventTarget{constructor(M,F,f){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${m})('${F}'))`,g=new Blob([D],{type:"application/javascript"}),R=URL.createObjectURL(g),y=new MessageChannel,d=R,E={type:"_newWorker",id:d,port:y.port2,url:R,options:f};M(E,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{M({type:"_terminateWorker",id:d}),URL.revokeObjectURL(R),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(p){y.port1.onmessage=p}},onmessageerror:{get(){return y.port1.onmessageerror},set(p){y.port1.onmessageerror=p}}}),y.port1.addEventListener("messageerror",p=>{const l=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(l)}),y.port1.addEventListener("message",p=>{const l=new MessageEvent("message",{data:p.data});this.dispatchEvent(l)}),y.port1.start()}}e.NestedWorker=k}),define(Ae[257],Re([1,0,5,30,31,3]),function(te,e,m,k,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new C.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new C.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new C.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)("outputService");var F;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(F||(e.OutputChannelUpdateMode=F={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class f{constructor(){this.channels=new Map,this._onDidRegisterChannel=new m.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new m.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(g){this.channels.has(g.id)||(this.channels.set(g.id,g),this._onDidRegisterChannel.fire(g.id))}getChannels(){const g=[];return this.channels.forEach(R=>g.push(R)),g}getChannel(g){return this.channels.get(g)}removeChannel(g){this.channels.delete(g),this._onDidRemoveChannel.fire(g)}}k.Registry.add(e.Extensions.OutputChannels,new f),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new C.RawContextKey("activeOutputChannel","")}),define(Ae[109],Re([1,0,4,3,17,24,15,257,61,27,39,129,25,10,38,5,6]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class r extends F.AbstractMessageLogger{get disposed(){return this._disposed}constructor(_,i,u,n,s){super(),this.id=_,this.name=i,this.logger=u,this.proxy=n,this.extension=s,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(u.getLevel()),this._register(u.onDidChangeLogLevel(v=>this.setLevel(v)))}get logLevel(){return this.getLevel()}appendLine(_){this.append(_+`
`)}append(_){this.info(_)}clear(){const _=this.offset;this.logger.flush(),this.proxy.$update(this.id,f.OutputChannelUpdateMode.Clear,_)}replace(_){const i=this.offset;this.info(_),this.proxy.$update(this.id,f.OutputChannelUpdateMode.Replace,i),this.visible&&this.logger.flush()}show(_,i){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof _=="boolean"?_:i))}hide(){this.proxy.$close(this.id)}log(_,i){this.offset+=d.VSBuffer.fromString(i).byteLength,(0,F.log)(this.logger,_,i),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,f.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class c extends r{appendLine(_){this.append(_)}}let b=e.ExtHostOutputService=class{constructor(_,i,u,n,s,v){this.initData=i,this.extHostFileSystem=u,this.extHostFileSystemInfo=n,this.loggerService=s,this.logService=v,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=_.getProxy(m.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(i.logsLocation,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(_){this.visibleChannelId=_;for(const[i,u]of this.channels)u.visible=i===this.visibleChannelId}createOutputChannel(_,i,u){if(_=_.trim(),!_)throw new Error("illegal argument `name`. must not be falsy");const n=typeof i=="object"&&i.log,s=(0,E.isString)(i)?i:void 0;if((0,E.isString)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");let v;const I=this.initData.environment.extensionLogLevel?.find(([T])=>M.ExtensionIdentifier.equals(u.identifier,T))?.[1];I&&(v=(0,F.parseLogLevel)(I));const h=n?this.doCreateLogOutputChannel(_,v,u):this.doCreateOutputChannel(_,s,u);return h.then(T=>{this.channels.set(T.id,T),T.visible=T.id===this.visibleChannelId}),n?this.createExtHostLogOutputChannel(_,v??this.logService.getLevel(),h):this.createExtHostOutputChannel(_,h)}async doCreateOutputChannel(_,i,u){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const n=await this.outputDirectoryPromise,s=this.extHostFileSystemInfo.extUri.joinPath(n,`${this.namePool++}-${_.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.loggerService.createLogger(s,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),I=await this.proxy.$register(_,s,i,u.identifier.value);return new r(I,_,v,this.proxy,u)}async doCreateLogOutputChannel(_,i,u){const n=await this.createExtensionLogDirectory(u),s=_.replace(/[\\/:\*\?"<>\|]/g,""),v=this.extHostFileSystemInfo.extUri.joinPath(n,`${s}.log`),I=`${u.identifier.value}.${s}`,h=this.loggerService.createLogger(v,{id:I,name:_,logLevel:i,extensionId:u.identifier.value});return new c(I,_,h,this.proxy,u)}createExtensionLogDirectory(_){let i=this.extensionLogDirectoryPromise.get(_.identifier.value);if(!i){const u=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,_.identifier.value);this.extensionLogDirectoryPromise.set(_.identifier.value,i=(async()=>{try{await this.extHostFileSystem.value.createDirectory(u)}catch(n){if((0,p.toFileSystemProviderErrorCode)(n)!==p.FileSystemProviderErrorCode.FileExists)throw n}return u})())}return i}createExtHostOutputChannel(_,i){let u=!1;const n=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return _},append(s){n(),i.then(v=>v.append(s))},appendLine(s){n(),i.then(v=>v.appendLine(s))},clear(){n(),i.then(s=>s.clear())},replace(s){n(),i.then(v=>v.replace(s))},show(s,v){n(),i.then(I=>I.show(s,v))},hide(){n(),i.then(s=>s.hide())},dispose(){u=!0,i.then(s=>s.dispose())}}}createExtHostLogOutputChannel(_,i,u){const n=new t.DisposableStore,s=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},v=n.add(new l.Emitter);function I(h){i=h,v.fire(h)}return u.then(h=>{n.add(h),h.logLevel!==i&&I(h.logLevel),n.add(h.onDidChangeLogLevel(T=>I(T)))}),{...this.createExtHostOutputChannel(_,u),get logLevel(){return i},onDidChangeLogLevel:v.event,trace(h,...T){s(),u.then(S=>S.trace(h,...T))},debug(h,...T){s(),u.then(S=>S.debug(h,...T))},info(h,...T){s(),u.then(S=>S.info(h,...T))},warn(h,...T){s(),u.then(S=>S.warn(h,...T))},error(h,...T){s(),u.then(S=>S.error(h,...T))},dispose(){n.dispose()}}}};e.ExtHostOutputService=b=Ve([He(0,C.IExtHostRpcService),He(1,g.IExtHostInitDataService),He(2,D.IExtHostConsumerFileSystem),He(3,R.IExtHostFileSystemInfo),He(4,F.ILoggerService),He(5,F.ILogService)],b),e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")});var Fe=this&&this.__classPrivateFieldGet||function(te,e,m,k){if(m==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?k:m==="a"?k.call(te):k?k.value:e.get(te)},Xe=this&&this.__classPrivateFieldSet||function(te,e,m,k,C){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?C.call(te,m):C?C.value=m:e.set(te,m),m};define(Ae[258],Re([1,0,3,16]),function(te,e,m,k){"use strict";var C,M,F,f,D,g,R,y,d,E,p;Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new(p=class{constructor(){C.set(this,5),M.set(this,2e3),F.set(this,[]),f.set(this,3),D.set(this,[]),g.set(this,100),R.set(this,2),y.set(this,500),d.set(this,1500),E.set(this,void 0)}get latency(){return Fe(this,E,"f")}async measure(l){let t=1/0;for(let c=0;c<Fe(this,C,"f");c++){const b=await l.getRoundTripTime();if(b===void 0)return;t=Math.min(t,b/2),await(0,k.timeout)(Fe(this,M,"f"))}Fe(this,D,"f").push(t),Fe(this,D,"f").length>Fe(this,g,"f")&&Fe(this,D,"f").shift();let r;return Fe(this,F,"f").length<Fe(this,f,"f")?Fe(this,F,"f").push(t):r=Fe(this,F,"f").reduce((c,b)=>c+b,0)/Fe(this,F,"f").length,Xe(this,E,{initial:r,current:t,average:Fe(this,D,"f").reduce((c,b)=>c+b,0)/Fe(this,D,"f").length,high:(()=>typeof r>"u"?!1:t>Fe(this,d,"f")||t>Fe(this,y,"f")&&t>r*Fe(this,R,"f"))()},"f"),Fe(this,E,"f")}},C=new WeakMap,M=new WeakMap,F=new WeakMap,f=new WeakMap,D=new WeakMap,g=new WeakMap,R=new WeakMap,y=new WeakMap,d=new WeakMap,E=new WeakMap,p)}),define(Ae[259],Re([1,0,42,14,19,21,20,2,3,185,53,208,258]),function(te,e,m,k,C,M,F,f,D,g,R,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let E=e.AbstractPathService=class Fn{constructor(l,t,r,c){this.localUserHome=l,this.remoteAgentService=t,this.environmentService=r,this.contextService=c,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||M.OS)(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=b?.userHome??l})()}hasValidBasename(l,t,r){return typeof t=="string"||typeof t>"u"?this.resolveOS.then(c=>this.doHasValidBasename(l,c,t)):this.doHasValidBasename(l,t,r)}doHasValidBasename(l,t,r){return l.scheme===k.Schemas.file||l.scheme===k.Schemas.vscodeRemote?(0,m.isValidBasename)(r??(0,F.basename)(l),t===1):!0}get defaultUriScheme(){return Fn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(l,t){if(l.remoteAuthority)return k.Schemas.vscodeRemote;const r=(0,g.getVirtualWorkspaceScheme)(t.getWorkspace());if(r)return r;const c=t.getWorkspace().folders[0];if(c)return c.uri.scheme;const b=t.getWorkspace().configuration;return b?b.scheme:k.Schemas.file}userHome(l){return l?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(l=>l===1?C.win32:C.posix)}async fileURI(l){let t="";if(await this.resolveOS===1&&(l=l.replace(/\\/g,"/")),l[0]==="/"&&l[1]==="/"){const c=l.indexOf("/",2);c===-1?(t=l.substring(2),l="/"):(t=l.substring(2,c),l=l.substring(c)||"/")}return f.URI.from({scheme:k.Schemas.file,authority:t,path:l,query:"",fragment:""})}};e.AbstractPathService=E=Ve([He(1,d.IRemoteAgentService),He(2,y.IWorkbenchEnvironmentService),He(3,R.IWorkspaceContextService)],E)}),define(Ae[110],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(F,f){this.line=F,this.character=f}isBefore(F){return!1}isBeforeOrEqual(F){return!1}isAfter(F){return!1}isAfterOrEqual(F){return!1}isEqual(F){return!1}compareTo(F){return 0}translate(F,f){return new m(0,0)}with(F){return new m(0,0)}}e.Position=m;class k{constructor(F,f,D,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(F,f),this.end=new m(D,g)}contains(F){return!1}isEqual(F){return!1}intersection(F){}union(F){return new k(0,0,0,0)}with(F){return new k(0,0,0,0)}}e.Range=k;var C;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ae[47],Re([1,0,18,37,23,42,13,3,19,9,110,16]),function(te,e,m,k,C,M,F,f,D,g,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const d="\u27EA ",E=" characters skipped \u27EB",p=(d.length+E.length+5)*2;e.ISearchService=(0,f.createDecorator)("searchService");var l;(function(J){J[J.file=0]="file",J[J.text=1]="text"})(l||(e.SearchProviderType=l={}));var t;(function(J){J[J.File=1]="File",J[J.Text=2]="Text"})(t||(e.QueryType=t={}));function r(J){return!!J.preview}e.resultIsMatch=r;function c(J){return!!J.resource}e.isFileMatch=c;function b(J){return!!J.message}e.isProgressMessage=b;var w;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(w||(e.SearchCompletionExitCode=w={}));class _{constructor(X){this.resource=X,this.results=[]}}e.FileMatch=_;class i{constructor(X,ce,De,ke){this.ranges=ce,this.webviewIndex=ke;const ge=Array.isArray(ce)?ce:[ce];if(De&&De.matchLines===1&&u(ge)){X=(0,F.getNLines)(X,De.matchLines);let A="",G=0,de=0;const ye=Math.floor(De.charsPerLine/5),_e=[];for(const pe of ge){const Ce=Math.max(pe.startColumn-ye,0),ae=pe.startColumn+De.charsPerLine;if(Ce>de+ye+p){const ue=d+(Ce-de)+E;A+=ue+X.slice(Ce,ae),G+=Ce-(de+ue.length)}else A+=X.slice(de,ae);_e.push(new s(0,pe.startColumn-G,pe.endColumn-G)),de=ae}this.preview={text:A,matches:Array.isArray(this.ranges)?_e:_e[0]}}else{const A=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:X,matches:(0,m.mapArrayOrNot)(ce,G=>new n(G.startLineNumber-A,G.startColumn,G.endLineNumber-A,G.endColumn))}}}}e.TextSearchMatch=i;function u(J){const X=J[0].startLineNumber;for(const ce of J)if(ce.startLineNumber!==X||ce.endLineNumber!==X)return!1;return!0}class n{constructor(X,ce,De,ke){this.startLineNumber=X,this.startColumn=ce,this.endLineNumber=De,this.endColumn=ke}}e.SearchRange=n;class s extends n{constructor(X,ce,De){super(X,ce,X,De)}}e.OneLineRange=s;var v;(function(J){J.List="list",J.Tree="tree"})(v||(e.ViewMode=v={}));var I;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(I||(e.SearchSortOrder=I={}));function h(J,X=!0){const ce=J&&J.files&&J.files.exclude,De=X&&J&&J.search&&J.search.exclude;if(!ce&&!De)return;if(!ce||!De)return ce||De;let ke=Object.create(null);return ke=C.mixin(ke,C.deepClone(ce)),ke=C.mixin(ke,C.deepClone(De),!0),ke}e.getExcludes=h;function T(J,X){return J.excludePattern&&k.match(J.excludePattern,X)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&k.match(J.includePattern,X)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(ce=>{const De=ce.folder.fsPath;if(M.isEqualOrParent(X,De)){const ke=D.relative(De,X);return!ce.includePattern||!!k.match(ce.includePattern,ke)}else return!1}):!1:!0}e.pathIncludedInQuery=T;var S;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(S||(e.SearchErrorCode=S={}));class a extends Error{constructor(X,ce){super(X),this.code=ce}}e.SearchError=a;function o(J){const X=J.message;if((0,g.isCancellationError)(J))return new a(X,S.canceled);try{const ce=JSON.parse(X);return new a(ce.message,ce.code)}catch{return new a(X,S.other)}}e.deserializeSearchError=o;function O(J){const X={message:J.message,code:J.code};return new Error(JSON.stringify(X))}e.serializeSearchError=O;function $(J){return J.type==="error"?!0:J.type==="success"}e.isSerializedSearchComplete=$;function K(J){return J.type==="success"}e.isSerializedSearchSuccess=K;function V(J){return!!J.path}e.isSerializedFileMatch=V;function z(J,X){const ce=J.searchPath?J.searchPath:J.relativePath;return(0,F.fuzzyContains)(ce,X)}e.isFilePatternMatch=z;class N{constructor(X){this.path=X,this.results=[]}addMatch(X){this.results.push(X)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function q(J,X){const ce={...J||{},...X||{}};return Object.keys(ce).filter(De=>{const ke=ce[De];return typeof ke=="boolean"&&ke})}e.resolvePatternsForProvider=q;class B{constructor(X,ce){this._parsedIncludeExpression=null,this._excludeExpression={...X.excludePattern||{},...ce.excludePattern||{}},this._parsedExcludeExpression=k.parse(this._excludeExpression);let De=X.includePattern;ce.includePattern&&(De?De={...De,...ce.includePattern}:De=ce.includePattern),De&&(this._parsedIncludeExpression=k.parse(De))}matchesExcludesSync(X,ce,De){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(X,ce,De))}includedInQuerySync(X,ce,De){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(X,ce,De)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(X,ce,De))}includedInQuery(X,ce,De){const ke=this._parsedExcludeExpression(X,ce,De),ge=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(X,ce,De):!0;return(0,y.isThenable)(ke)?ke.then(A=>A?!1:ge()):ge()}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=B;function U(J){for(const X in J)if(typeof J[X]!="boolean")return!0;return!1}function le(J){if(!J)return;let X;return ce=>(X||(X=(J()||Promise.resolve([])).then(De=>De?Pe(De):{})),X.then(De=>!!De[ce]))}e.hasSiblingPromiseFn=le;function ve(J){if(!J)return;let X;return ce=>{if(!X){const De=J();X=De?Pe(De):{}}return!!X[ce]}}e.hasSiblingFn=ve;function Pe(J){const X={};for(const ce of J)X[ce]=!0;return X}}),define(Ae[33],Re([1,0,18,16,22,5,6,48,14,117,20,13,10,2,156,3,15,173,53,39,27,17,8,7,55,47,4]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l,t,r,c,b,w,_,i,u,n,s,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function I(K,V,z){return new R.ExtUri(N=>a(N,z)).isEqual(K,V)}function h(K,V,z){return I(K.uri,V.uri,z)?0:(0,y.compare)(K.uri.toString(),V.uri.toString())}function T(K,V,z){return K.index!==V.index?K.index<V.index?-1:1:I(K.uri,V.uri,z)?(0,y.compare)(K.name,V.name):(0,y.compare)(K.uri.toString(),V.uri.toString())}function S(K,V,z,N){const q=K.slice(0).sort((U,le)=>z(U,le,N)),B=V.slice(0).sort((U,le)=>z(U,le,N));return(0,m.delta)(q,B,(U,le)=>z(U,le,N))}function a(K,V){const z=V.getCapabilities(K.scheme);return!(z&&z&1024)}class o extends c.Workspace{static toExtHostWorkspace(V,z,N,q){if(!V)return{workspace:null,added:[],removed:[]};const{id:B,name:U,folders:le,configuration:ve,transient:Pe,isUntitled:J}=V,X=[],ce=z;z?le.forEach((A,G)=>{const de=E.URI.revive(A.uri),ye=o._findFolder(N||z,de,q);ye?(ye.name=A.name,ye.index=A.index,X.push(ye)):X.push({uri:de,name:A.name,index:G})}):X.push(...le.map(({uri:A,name:G,index:de})=>({uri:E.URI.revive(A),name:G,index:de}))),X.sort((A,G)=>A.index<G.index?-1:1);const De=new o(B,U,X,!!Pe,ve?E.URI.revive(ve):null,!!J,A=>a(A,q)),{added:ke,removed:ge}=S(ce?ce.workspaceFolders:[],De.workspaceFolders,h,q);return{workspace:De,added:ke,removed:ge}}static _findFolder(V,z,N){for(let q=0;q<V.folders.length;q++){const B=V.workspaceFolders[q];if(I(B.uri,z,N))return B}}constructor(V,z,N,q,B,U,le){super(V,N.map(ve=>new c.WorkspaceFolder(ve)),q,B,le),this._name=z,this._isUntitled=U,this._workspaceFolders=[],this._structure=f.TernarySearchTree.forUris(le),N.forEach(ve=>{this._workspaceFolders.push(ve),this._structure.set(ve.uri,ve)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(V,z){return z&&this._structure.get(V)&&(V=(0,R.dirname)(V)),this._structure.findSubstr(V)}resolveWorkspaceFolder(V){return this._structure.get(V)}}let O=e.ExtHostWorkspace=class{constructor(V,z,N,q,B){this._onDidChangeWorkspace=new M.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new M.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new M.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=q,this._extHostFileSystemInfo=N,this._uriTransformerService=B,this._requestIdProvider=new g.Counter,this._barrier=new k.Barrier,this._proxy=V.getProxy(v.MainContext.MainThreadWorkspace),this._messageService=V.getProxy(v.MainContext.MainThreadMessageService);const U=z.workspace;this._confirmedWorkspace=U?new o(U.id,U.name,[],!!U.transient,U.configuration?E.URI.revive(U.configuration):null,!!U.isUntitled,le=>a(le,N)):void 0}$initializeWorkspace(V,z){this._trusted=z,this.$acceptWorkspaceData(V),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?E.URI.from({scheme:D.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(V,z,N,...q){const B=[];if(Array.isArray(q)&&q.forEach(J=>{E.URI.isUri(J.uri)&&!B.some(X=>I(X.uri,J.uri,this._extHostFileSystemInfo))&&B.push({uri:J.uri,name:J.name||(0,R.basenameOrAuthority)(J.uri)})}),this._unconfirmedWorkspace||[z,N].some(J=>typeof J!="number"||J<0)||N===0&&B.length===0)return!1;const U=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(z+N>U.length)return!1;const le=U.slice(0);le.splice(z,N,...B.map(J=>({uri:J.uri,name:J.name||(0,R.basenameOrAuthority)(J.uri),index:void 0})));for(let J=0;J<le.length;J++){const X=le[J];if(le.some((ce,De)=>De!==J&&I(X.uri,ce.uri,this._extHostFileSystemInfo)))return!1}le.forEach((J,X)=>J.index=X);const{added:ve,removed:Pe}=S(U,le,T,this._extHostFileSystemInfo);if(ve.length===0&&Pe.length===0)return!1;if(this._proxy){const J=V.displayName||V.name;this._proxy.$updateWorkspaceFolders(J,z,N,B).then(void 0,X=>{this._unconfirmedWorkspace=void 0;const ce={source:{identifier:V.identifier,label:V.displayName||V.name}};this._messageService.$showMessage(r.Severity.Error,(0,p.localize)(0,null,J,X.toString()),ce,[])})}return this.trySetWorkspaceFolders(le),!0}getWorkspaceFolder(V,z){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(V,z)}async getWorkspaceFolder2(V,z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(V,z)}async resolveWorkspaceFolder(V){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(V)}getPath(){if(!this._actualWorkspace)return;const{folders:V}=this._actualWorkspace;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,z){let N,q="";if(typeof V=="string"?(N=E.URI.file(V),q=V):typeof V<"u"&&(N=V,q=V.fsPath),!N)return q;const B=this.getWorkspaceFolder(N,!0);if(!B)return q;typeof z>"u"&&this._actualWorkspace&&(z=this._actualWorkspace.folders.length>1);let U=(0,R.relativePath)(B.uri,N);return z&&B.name&&(U=`${B.name}/${U}`),U}trySetWorkspaceFolders(V){this._actualWorkspace&&(this._unconfirmedWorkspace=o.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:V,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:z,added:N,removed:q}=o.toExtHostWorkspace(V,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=z||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:q}))}findFiles(V,z,N,q,B=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${q.value}, entryPoint: findFiles`);let U;if(z===null?U=!1:z&&(typeof z=="string"?U=z:U=z.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:ve}=$(i.GlobPattern.from(V));return this._proxy.$startFileSearch((0,d.withUndefinedAsNull)(le),(0,d.withUndefinedAsNull)(ve),(0,d.withUndefinedAsNull)(U),(0,d.withUndefinedAsNull)(N),B).then(Pe=>Array.isArray(Pe)?Pe.map(J=>E.URI.revive(J)):[])}async findTextInFiles(V,z,N,q,B=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${q.value}, entryPoint: findTextInFiles`);const U=this._requestIdProvider.getNext(),le=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:ve,folder:Pe}=$(i.GlobPattern.from(z.include)),J=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,X={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:le,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:ve,excludePattern:J},ce=!1;if(this._activeSearchCallbacks[U]=De=>{if(ce)return;const ke=E.URI.revive(De.resource);De.results.forEach(ge=>{(0,s.resultIsMatch)(ge)?N({uri:ke,preview:{text:ge.preview.text,matches:(0,m.mapArrayOrNot)(ge.preview.matches,A=>new u.Range(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn))},ranges:(0,m.mapArrayOrNot)(ge.ranges,A=>new u.Range(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn))}):N({uri:ke,text:ge.text,lineNumber:ge.lineNumber})})},B.isCancellationRequested)return{};try{const De=await this._proxy.$startTextSearch(V,(0,d.withUndefinedAsNull)(Pe),X,U,B);return delete this._activeSearchCallbacks[U],De||{}}catch(De){throw delete this._activeSearchCallbacks[U],De}}$handleTextSearchResult(V,z){this._activeSearchCallbacks[z]?.(V)}async save(V){const z=await this._proxy.$save(V,{saveAs:!1});return E.URI.revive(z)}async saveAs(V){const z=await this._proxy.$save(V,{saveAs:!0});return E.URI.revive(z)}saveAll(V){return this._proxy.$saveAll(V)}resolveProxy(V){return this._proxy.$resolveProxy(V)}get trusted(){return this._trusted}requestWorkspaceTrust(V){return this._proxy.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(V,z){if(this._editSessionIdentityProviders.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this._editSessionIdentityProviders.set(V,z);const N=this._uriTransformerService.transformOutgoingScheme(V),q=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(q,N),(0,F.toDisposable)(()=>{this._editSessionIdentityProviders.delete(V),this._proxy.$unregisterEditSessionIdentityProvider(q)})}async $getEditSessionIdentifier(V,z){this._logService.info("Getting edit session identifier for workspaceFolder",V);const N=await this.resolveWorkspaceFolder(E.URI.revive(V));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const q=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!q),!q)return;const B=await q.provideEditSessionIdentity(N,z);if(this._logService.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(V,z,N,q){this._logService.info("Getting edit session identifier for workspaceFolder",V);const B=await this.resolveWorkspaceFolder(E.URI.revive(V));if(!B){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const U=this._editSessionIdentityProviders.get(B.uri.scheme);if(this._logService.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!U),!U)return;const le=await U.provideEditSessionIdentityMatch?.(z,N,q);if(this._logService.info("Provider returned edit session identifier match result: ",le),!!le)return le}getOnWillCreateEditSessionIdentityEvent(V){return(z,N,q)=>{const B=function(le){z.call(N,le)};return B.extension=V,this._onWillCreateEditSessionIdentityEvent.event(B,void 0,q)}}async $onWillCreateEditSessionIdentity(V,z,N){const q=await this.resolveWorkspaceFolder(E.URI.revive(V));if(q===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:q},z,async(B,U)=>{const le=Date.now();await Promise.resolve(B),Date.now()-le>N&&this._logService.warn("SLOW edit session create-participant",U.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(V,z){if(this._canonicalUriProviders.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this._canonicalUriProviders.set(V,z);const N=this._uriTransformerService.transformOutgoingScheme(V),q=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(q,N),(0,F.toDisposable)(()=>{this._canonicalUriProviders.delete(V),this._proxy.$unregisterCanonicalUriProvider(q)})}async provideCanonicalUri(V,z,N){const q=this._canonicalUriProviders.get(V.scheme);if(!q)return;const B=await q.provideCanonicalUri?.(E.URI.revive(V),z,N);if(B)return B}async $provideCanonicalUri(V,z,N){return this.provideCanonicalUri(E.URI.revive(V),{targetScheme:z},N)}};e.ExtHostWorkspace=O=Ve([He(0,_.IExtHostRpcService),He(1,w.IExtHostInitDataService),He(2,b.IExtHostFileSystemInfo),He(3,t.ILogService),He(4,n.IURITransformerService)],O),e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function $(K){let V,z;return K&&(typeof K=="string"?V=K:(V=K.pattern,z=E.URI.revive(K.baseUri))),{includePattern:V,folder:z}}}),define(Ae[34],Re([1,0,23,5,33,4,7,176,96,10,16,3,17,15,2]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(u,n){if(n){const s=n.split(".");let v=u;for(let I=0;v&&I<s.length;I++)v=v[s[I]];return v}}function t(u){return u instanceof p.URI}function r(u){return u&&u.uri instanceof p.URI&&u.languageId&&typeof u.languageId=="string"}function c(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function b(u){return u&&u.uri instanceof p.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function w(u){if(t(u))return{resource:u};if(r(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(c(u))return{overrideIdentifier:u.languageId};if(b(u))return{resource:u.uri};if(u===null)return{resource:null}}let _=e.ExtHostConfiguration=class{constructor(n,s,v){this._proxy=n.getProxy(M.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=v,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new i(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,s){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(n,s))}};e.ExtHostConfiguration=_=Ve([He(0,d.IExtHostRpcService),He(1,C.IExtHostWorkspace),He(2,E.ILogService)],_);class i{constructor(n,s,v,I){this._onDidChangeConfiguration=new k.Emitter,this._proxy=n,this._logService=I,this._extHostWorkspace=s,this._configuration=f.Configuration.parse(v),this._configurationScopes=this._toMap(v.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,s){const v={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=f.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,v))}getConfiguration(n,s,v){const I=w(s)||{},h=this._toReadonlyValue(n?l(this._configuration.getValue(void 0,I,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,I,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,I,v?.identifier);function T(a){if(a==null)return null;if(typeof a=="boolean")return a?2:5;switch(a){case F.ConfigurationTarget.Global:return 2;case F.ConfigurationTarget.Workspace:return 5;case F.ConfigurationTarget.WorkspaceFolder:return 6}}const S={has(a){return typeof l(h,a)<"u"},get:(a,o)=>{this._validateConfigurationAccess(n?`${n}.${a}`:a,I,v?.identifier);let O=l(h,a);if(typeof O>"u")O=o;else{let $;const K=(V,z)=>{if((0,g.isObject)(V)){let N;const q=()=>{$=$||(0,m.deepClone)(h),N=N||l($,z)};return new Proxy(V,{get:(B,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return q(),()=>N;if($)return N=N||l($,z),N[U];const le=B[U];return typeof U=="string"?K(le,`${z}.${U}`):le},set:(B,U,le)=>(q(),N&&(N[U]=le),!0),deleteProperty:(B,U)=>(q(),N&&delete N[U],!0),defineProperty:(B,U,le)=>(q(),N&&Object.defineProperty(N,U,le),!0)})}return Array.isArray(V)?(0,m.deepClone)(V):V};O=K(O,a)}return O},update:(a,o,O,$)=>{a=n?`${n}.${a}`:a;const K=T(O);return o!==void 0?this._proxy.$updateConfigurationOption(K,a,o,I,$):this._proxy.$removeConfigurationOption(K,a,I,$)},inspect:a=>{a=n?`${n}.${a}`:a;const o=this._configuration.inspect(a,I,this._extHostWorkspace.workspace);if(o)return{key:a,defaultValue:(0,m.deepClone)(o.policy?.value??o.default?.value),globalValue:(0,m.deepClone)(o.user?.value??o.application?.value),workspaceValue:(0,m.deepClone)(o.workspace?.value),workspaceFolderValue:(0,m.deepClone)(o.workspaceFolder?.value),defaultLanguageValue:(0,m.deepClone)(o.default?.override),globalLanguageValue:(0,m.deepClone)(o.user?.override??o.application?.override),workspaceLanguageValue:(0,m.deepClone)(o.workspace?.override),workspaceFolderLanguageValue:(0,m.deepClone)(o.workspaceFolder?.override),languageIds:(0,m.deepClone)(o.overrideIdentifiers)}}};return typeof h=="object"&&(0,m.mixin)(S,h,!1),Object.freeze(S)}_toReadonlyValue(n){const s=v=>(0,g.isObject)(v)?new Proxy(v,{get:(I,h)=>s(I[h]),set:(I,h,T)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(h)}' of object`)},deleteProperty:(I,h)=>{throw new Error(`TypeError: Cannot delete read only property '${String(h)}' of object`)},defineProperty:(I,h)=>{throw new Error(`TypeError: Cannot define property '${String(h)}' for a readonly object`)},setPrototypeOf:I=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return s(n)}_validateConfigurationAccess(n,s,v){const I=D.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),h=v?`[${v.value}] `:"";if(I===4){typeof s?.resource>"u"&&this._logService.warn(`${h}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(I===3){s?.resource&&this._logService.warn(`${h}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,s){const v=new f.ConfigurationChangeEvent(n,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(I,h)=>v.affectsConfiguration(I,w(h))})}_toMap(n){return n.reduce((s,v)=>(s.set(v[0],v[1]),s),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var Xe=this&&this.__classPrivateFieldSet||function(te,e,m,k,C){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?C.call(te,m):C?C.value=m:e.set(te,m),m},Fe=this&&this.__classPrivateFieldGet||function(te,e,m,k){if(m==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?k:m==="a"?k.call(te):k?k.value:e.get(te)};define(Ae[111],Re([1,0,2,16,5,4,7,33,59,34,22,62,17,27,3,14,21,15,81,213,9]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l,t,r,c,b,w){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(V){function z(q){if(q!=null)return q}V.from=z;function N(q){if(q!=null)return q}V.to=N})(i||(i={}));var u;(function(V){function z(q){if(q!=null)return q}V.from=z;function N(q){if(q!=null)return q}V.to=N})(u||(u={}));var n;(function(V){function z(q){if(q!=null)return q}V.from=z;function N(q){if(q!=null)return q}V.to=N})(n||(n={}));var s;(function(V){function z(B){if(B){const U=B;return U&&!!U.process}else return!1}V.is=z;function N(B){if(B==null)return;const U={process:B.process,args:B.args};return B.options&&(U.options=n.from(B.options)),U}V.from=N;function q(B){if(B!=null)return new F.ProcessExecution(B.process,B.args,B.options)}V.to=q})(s||(s={}));var v;(function(V){function z(q){if(q!=null)return q}V.from=z;function N(q){if(q!=null)return q}V.to=N})(v||(v={}));var I;(function(V){function z(B){if(B){const U=B;return U&&(!!U.commandLine||!!U.command)}else return!1}V.is=z;function N(B){if(B==null)return;const U={};return B.commandLine!==void 0?U.commandLine=B.commandLine:(U.command=B.command,U.args=B.args),B.options&&(U.options=v.from(B.options)),U}V.from=N;function q(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new F.ShellExecution(B.commandLine,B.options):new F.ShellExecution(B.command,B.args?B.args:[],B.options)}V.to=q})(I||(I={}));var h;(function(V){function z(B){if(B){const U=B;return U&&U.customExecution==="customExecution"}else return!1}V.is=z;function N(B){return{customExecution:"customExecution"}}V.from=N;function q(B,U){return U.get(B)}V.to=q})(h||(e.CustomExecutionDTO=h={}));var T;(function(V){function z(N,q){let B;return N.scope!==void 0&&typeof N.scope!="number"?B=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===F.TaskScope.Workspace&&q&&q.workspaceFile?B=q.workspaceFile:B=b.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:B}}V.from=z})(T||(e.TaskHandleDTO=T={}));var S;(function(V){function z(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}V.from=z})(S||(S={}));var a;(function(V){function z(B,U){if(B==null)return[];const le=[];for(const ve of B){const Pe=N(ve,U);Pe&&le.push(Pe)}return le}V.fromMany=z;function N(B,U){if(B==null)return;let le;B.execution instanceof F.ProcessExecution?le=s.from(B.execution):B.execution instanceof F.ShellExecution?le=I.from(B.execution):B.execution&&B.execution instanceof F.CustomExecution&&(le=h.from(B.execution));const ve=i.from(B.definition);let Pe;return B.scope?typeof B.scope=="number"?Pe=B.scope:Pe=B.scope.uri:Pe=F.TaskScope.Workspace,!ve||!Pe?void 0:{_id:B._id,definition:ve,name:B.name,source:{extensionId:U.identifier.value,label:B.source,scope:Pe},execution:le,isBackground:B.isBackground,group:S.from(B.group),presentationOptions:u.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}V.from=N;async function q(B,U,le){if(B==null)return;let ve;s.is(B.execution)?ve=s.to(B.execution):I.is(B.execution)?ve=I.to(B.execution):h.is(B.execution)&&(ve=h.to(B._id,le));const Pe=i.to(B.definition);let J;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?J=B.source.scope:J=await U.resolveWorkspaceFolder(m.URI.revive(B.source.scope)):J=F.TaskScope.Workspace),!Pe||!J)return;const X=new F.Task(Pe,J,B.name,B.source.label,ve,B.problemMatchers);return B.isBackground!==void 0&&(X.isBackground=B.isBackground),B.group!==void 0&&(X.group=F.TaskGroup.from(B.group._id),X.group&&B.group.isDefault&&(X.group=new F.TaskGroup(X.group.id,X.group.label),B.group.isDefault===!0&&(X.group.isDefault=B.group.isDefault))),B.presentationOptions&&(X.presentationOptions=u.to(B.presentationOptions)),B._id&&(X._id=B._id),B.detail&&(X.detail=B.detail),X}V.to=q})(a||(e.TaskDTO=a={}));var o;(function(V){function z(q){return q}V.from=z;function N(q){if(q)return Object.assign(Object.create(null),q)}V.to=N})(o||(o={}));class O{constructor(z,N,q){this._id=N,this._task=q,_.set(this,void 0),Xe(this,_,z,"f")}get task(){return this._task}terminate(){Fe(this,_,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}_=new WeakMap;let $=e.ExtHostTaskBase=class{constructor(z,N,q,B,U,le,ve,Pe){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=z.getProxy(M.MainContext.MainThreadTask),this._workspaceProvider=q,this._editorService=B,this._configurationService=U,this._terminalService=le,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ve,this._deprecationService=Pe,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,N,q){if(!q)return new F.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:N,provider:q,extension:z}),this._proxy.$registerTaskProvider(B,N),new F.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(z,N){this._proxy.$registerTaskSystem(z,N)}fetchTasks(z){return this._proxy.$fetchTasks(o.from(z)).then(async N=>{const q=[];for(const B of N){const U=await a.to(B,this._workspaceProvider,this._providedCustomExecutions2);U&&q.push(U)}return q})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(N=>z.push(N)),z}terminateTask(z){if(!(z instanceof O))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,N,q){const B=this._providedCustomExecutions2.get(z.id);B&&(this._activeCustomExecutions2.set(z.id,B),this._terminalService.attachPtyToTerminal(N,await B.callback(q))),this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const N=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:N})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const N=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:N,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const N=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:N,exitCode:z.exitCode})}$provideTasks(z,N){const q=this._handlers.get(z);if(!q)return Promise.reject(new Error("no handler found"));const B=[],U=(0,k.asPromise)(()=>q.provider.provideTasks(R.CancellationToken.None)).then(le=>this.provideTasksInternal(N,B,q,le));return new Promise(le=>{U.then(ve=>{Promise.all(B).then(()=>{le(ve)})})})}async $resolveTask(z,N){const q=this._handlers.get(z);if(!q)return Promise.reject(new Error("no handler found"));if(N.definition.type!==q.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${q.type}].`);const B=await a.to(N,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const U=await q.provider.resolveTask(B,R.CancellationToken.None);if(!U)return;this.checkDeprecation(U,q);const le=a.from(U,q.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(le.execution)&&await this.addCustomExecution(le,U,!0),await this.resolveTaskInternal(le)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,N,q){const B=await this._proxy.$createTaskId(z);!q&&!this._providedCustomExecutions2.has(B)&&(this._notProvidedCustomExecutions.add(B),this._activeCustomExecutions2.set(B,N.execution)),this._providedCustomExecutions2.set(B,N.execution)}async getTaskExecution(z,N){if(typeof z=="string"){const U=this._taskExecutionPromises.get(z);if(!U)throw new w.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return U}const q=this._taskExecutionPromises.get(z.id);if(q)return q;const B=new Promise((U,le)=>{function ve(Pe,J,X){X?U(new O(Pe,J.id,X)):le("Unexpected: Task does not exist.")}N?ve(this,z,N):a.to(z.task,this._workspaceProvider,this._providedCustomExecutions2).then(Pe=>ve(this,z,Pe))});return this._taskExecutionPromises.set(z.id,B),B.then(U=>(this._taskExecutions.set(z.id,U),U),U=>Promise.reject(U))}checkDeprecation(z,N){z._deprecated&&this._deprecationService.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));const q=this._notProvidedCustomExecutions.values();let B=q.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=q.next()}};e.ExtHostTaskBase=$=Ve([He(0,d.IExtHostRpcService),He(1,E.IExtHostInitDataService),He(2,f.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,g.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,r.ILogService),He(7,c.IExtHostApiDeprecationService)],$);let K=e.WorkerExtHostTask=class extends ${constructor(z,N,q,B,U,le,ve,Pe){super(z,N,q,B,U,le,ve,Pe),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:t.PlatformToString(0)})}async executeTask(z,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const q=a.from(N,z);if(q===void 0)throw new Error("Task is not valid");if(h.is(q.execution))await this.addCustomExecution(q,N,!1);else throw new w.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution(q),N);return this._proxy.$executeTask(q).catch(U=>{throw new Error(U)}),B}provideTasksInternal(z,N,q,B){const U=[];if(B)for(const le of B){this.checkDeprecation(le,q),(!le.definition||!z[le.definition.type])&&this._logService.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const ve=a.from(le,q.extension);ve&&h.is(ve.execution)?(U.push(ve),N.push(this.addCustomExecution(ve,le,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:U,extension:q.extension}}async resolveTaskInternal(z){if(h.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,N,q){}};e.WorkerExtHostTask=K=Ve([He(0,d.IExtHostRpcService),He(1,E.IExtHostInitDataService),He(2,f.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,g.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,r.ILogService),He(7,c.IExtHostApiDeprecationService)],K),e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(Ae[260],Re([1,0,19,22,41,37,20,58,47]),function(te,e,m,k,C,M,F,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class g{constructor(d,E,p){this.config=d,this.provider=E,this.sessionToken=p,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&M.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&M.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const E=this.config.folderQueries||[];return new Promise((p,l)=>{const t=r=>{this.resultCount++,d(r)};if(this.isCanceled)return p({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(r=>{const c=r.toString(),b=m.basename(c);this.globalExcludePattern&&this.globalExcludePattern(c,b)||this.matchFile(t,{base:r,basename:b})}),Promise.all(E.map(r=>this.searchInFolder(r,t))).then(r=>{p({limitHit:this.isLimitHit,stats:r[0]||void 0})},r=>{l(new Error((0,C.toErrorMessage)(r)))})})}async searchInFolder(d,E){const p=new k.CancellationTokenSource,l=this.getSearchOptionsForFolder(d),t=this.initDirectoryTree(),r=new D.QueryGlobTester(this.config,d),c=!r.hasSiblingExcludeClauses();let b;try{this.activeCancellationTokens.add(p),b=f.StopWatch.create();const w=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,p.token),_=b.elapsed(),i=f.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(w&&w.forEach(u=>{const n=m.posix.relative(d.folder.path,u.path);if(c){const s=m.basename(u.path);this.matchFile(E,{base:d.folder,relativePath:n,basename:s});return}this.addDirectoryEntries(t,d.folder,n,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(t,r,E),{providerTime:_,postProcessTime:i.elapsed()})}finally{p.dispose(),this.activeCancellationTokens.delete(p)}}getSearchOptionsForFolder(d){const E=(0,D.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),p=(0,D.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:p,includes:E,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},E,p,l){if(p===this.filePattern){const r=m.basename(this.filePattern);this.matchFile(l,{base:E,relativePath:this.filePattern,basename:r})}function t(r){const c=m.basename(r),b=m.dirname(r);let w=d[b];w||(w=d[b]=[],t(b)),w.push({base:E,relativePath:r,basename:c})}t(p)}matchDirectoryTree({rootEntries:d,pathToEntries:E},p,l){const t=this,r=this.filePattern;function c(b){const w=(0,D.hasSiblingFn)(()=>b.map(_=>_.basename));for(let _=0,i=b.length;_<i;_++){const u=b[_],{relativePath:n,basename:s}=u;if(p.matchesExcludesSync(n,s,r!==s?w:void 0))continue;const v=E[n];if(v)c(v);else{if(n===r)continue;t.matchFile(l,u)}if(t.isLimitHit)break}}c(d)}matchFile(d,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(E))}}class R{constructor(){this.sessions=new Map}fileSearch(d,E,p,l){const t=this.getSessionTokenSource(d.cacheKey),r=new g(d,E,t&&t.token);let c=0;const b=w=>{c+=w.length,p(w.map(_=>this.rawMatchToSearchItem(_)))};return this.doSearch(r,R.BATCH_SIZE,b,l).then(w=>({limitHit:w.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:w.stats}}))}clearCache(d){this.getSessionTokenSource(d)?.cancel()}getSessionTokenSource(d){if(d)return this.sessions.has(d)||this.sessions.set(d,new k.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:F.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,E,p,l){l.onCancellationRequested(()=>{d.cancel()});const t=c=>{c&&(r.push(c),E>0&&r.length>=E&&(p(r),r=[]))};let r=[];return d.search(t).then(c=>(r.length&&p(r),c),c=>(r.length&&p(r),Promise.reject(c)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(Ae[261],Re([1,0,18,64,37,90,28,14,19,20,13,10,2,275,165,43,15,53,102,259,47]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l,t,r,c,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let _=e.QueryBuilder=class{constructor(a,o,O,$,K){this.configurationService=a,this.workspaceContextService=o,this.editorGroupsService=O,this.logService=$,this.pathService=K}text(a,o,O={}){a=this.getContentPattern(a,O);const $=this.configurationService.getValue(),K=o&&o.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep);return{...this.commonQuery(o?.map(r.toWorkspaceFolder),O),type:2,contentPattern:a,previewOptions:O.previewOptions,maxFileSize:O.maxFileSize,usePCRE2:$.search.usePCRE2||K||!1,beforeContext:O.beforeContext,afterContext:O.afterContext,userDisabledExcludesAndIgnoreFiles:O.disregardExcludeSettings&&O.disregardIgnoreFiles}}getContentPattern(a,o){const O=this.configurationService.getValue();a.isRegExp&&(a.pattern=a.pattern.replace(/\r?\n/g,"\\n"));const $={...a,wordSeparators:O.editor.wordSeparators};return this.isCaseSensitive(a,o)&&($.isCaseSensitive=!0),this.isMultiline(a)&&($.isMultiline=!0),o.notebookSearchConfig?.includeMarkupInput&&($.notebookInfo||($.notebookInfo={}),$.notebookInfo.isInNotebookMarkdownInput=o.notebookSearchConfig.includeMarkupInput),o.notebookSearchConfig?.includeMarkupPreview&&($.notebookInfo||($.notebookInfo={}),$.notebookInfo.isInNotebookMarkdownPreview=o.notebookSearchConfig.includeMarkupPreview),o.notebookSearchConfig?.includeCodeInput&&($.notebookInfo||($.notebookInfo={}),$.notebookInfo.isInNotebookCellInput=o.notebookSearchConfig.includeCodeInput),o.notebookSearchConfig?.includeOutput&&($.notebookInfo||($.notebookInfo={}),$.notebookInfo.isInNotebookCellOutput=o.notebookSearchConfig.includeOutput),$}file(a,o={}){return{...this.commonQuery(a,o),type:1,filePattern:o.filePattern?o.filePattern.trim():o.filePattern,exists:o.exists,sortByScore:o.sortByScore,cacheKey:o.cacheKey}}handleIncludeExclude(a,o){return a?(a=Array.isArray(a)?a.map(v):v(a),o?this.parseSearchPaths(a):{pattern:u(...Array.isArray(a)?a:[a])}):{}}commonQuery(a=[],o={}){const O=this.handleIncludeExclude(o.includePattern,o.expandPatterns),$=this.handleIncludeExclude(o.excludePattern,o.expandPatterns),K=a.length>1,V=(O.searchPaths&&O.searchPaths.length?O.searchPaths.map(q=>this.getFolderQueryForSearchPath(q,o,$)):a.map(q=>this.getFolderQueryForRoot(q,o,$,K))).filter(q=>!!q),z={_reason:o._reason,folderQueries:V,usingSearchPaths:!!(O.searchPaths&&O.searchPaths.length),extraFileResources:o.extraFileResources,excludePattern:$.pattern,includePattern:O.pattern,onlyOpenEditors:o.onlyOpenEditors,maxResults:o.maxResults};if(o.onlyOpenEditors){const q=m.coalesce(m.flatten(this.editorGroupsService.groups.map(le=>le.editors.map(ve=>ve.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(q));const B=q.filter(le=>(0,w.pathIncludedInQuery)(z,le.fsPath)),U=this.commonQueryFromFileList(B);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(U)),{...z,...U}}const N=o.extraFileResources&&o.extraFileResources.filter(q=>(0,w.pathIncludedInQuery)(z,q.fsPath));return z.extraFileResources=N&&N.length?N:void 0,z}commonQueryFromFileList(a){const o=[],O=new F.ResourceMap,$={};let K=!1;return a.forEach(V=>{if(V.scheme===f.Schemas.walkThrough)return;if((0,g.isAbsolutePath)(V)){const N=this.workspaceContextService.getWorkspaceFolder(V)?.uri??V.with({path:D.dirname(V.fsPath)});let q=O.get(N);q||(K=!0,q={folder:N,includePattern:{}},o.push(q),O.set(N,q));const B=D.relative(N.fsPath,V.fsPath);(0,y.assertIsDefined)(q.includePattern)[B.replace(/\\/g,"/")]=!0}else V.fsPath&&(K=!0,$[V.fsPath]=!0)}),{folderQueries:o,includePattern:$,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}isCaseSensitive(a,o){if(o.isSmartCase){if(a.isRegExp){if(R.containsUppercaseCharacter(a.pattern,!0))return!0}else if(R.containsUppercaseCharacter(a.pattern))return!0}return!!a.isCaseSensitive}isMultiline(a){return a.isMultiline||a.isRegExp&&(0,E.isMultilineRegexSource)(a.pattern)||a.pattern.indexOf(`
`)>=0?!0:!!a.isMultiline}parseSearchPaths(a){const o=U=>D.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),$=(Array.isArray(a)?a:n(a)).map(U=>{const le=this.pathService.resolvedUserHome;return le?(0,M.untildify)(U,le.scheme===f.Schemas.file?le.fsPath:le.path):U}),K=k.groupBy($,U=>o(U)?"searchPaths":"exprSegments"),V=(K.exprSegments||[]).map(U=>R.rtrim(U,"/")).map(U=>R.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),s(U))),z={},N=this.expandSearchPathPatterns(K.searchPaths||[]);N&&N.length&&(z.searchPaths=N);const q=m.flatten(V),B=u(...q);return B&&(z.pattern=B),z}getExcludesForFolder(a,o){return o.disregardExcludeSettings?void 0:(0,w.getExcludes)(a,!o.disregardSearchExcludeSettings)}expandSearchPathPatterns(a){if(!a||!a.length)return[];const o=a.flatMap($=>{let{pathPortion:K,globPortion:V}=i($);return V&&(V=I(V)),this.expandOneSearchPath(K).flatMap(N=>this.resolveOneSearchPathPattern(N,V))}),O=new Map;return o.forEach($=>{const K=$.searchPath.toString(),V=O.get(K);V?$.pattern&&(V.pattern=V.pattern||{},V.pattern[$.pattern]=!0):O.set(K,{searchPath:$.searchPath,pattern:$.pattern?u($.pattern):void 0})}),Array.from(O.values())}expandOneSearchPath(a){if(D.isAbsolute(a)){const o=this.workspaceContextService.getWorkspace().folders;return o[0]&&o[0].uri.scheme!==f.Schemas.file?[{searchPath:o[0].uri.with({path:a})}]:[{searchPath:d.URI.file(D.normalize(a))}]}if(this.workspaceContextService.getWorkbenchState()===2){const o=this.workspaceContextService.getWorkspace().folders[0].uri;if(a=v(a),a.startsWith("../")||a===".."){const $=D.posix.resolve(o.path,a);return[{searchPath:o.with({path:$})}]}const O=I(a);return[{searchPath:o,pattern:O}]}else{if(a==="./"||a===".\\")return[];{const o=a.replace(/^\.[\/\\]/,""),$=this.workspaceContextService.getWorkspace().folders.map(K=>{const V=o.match(new RegExp(`^${R.escapeRegExpCharacters(K.name)}(?:/(.*)|$)`));return V?{match:V,folder:K}:null}).filter(y.isDefined);if($.length)return $.map(K=>{const V=K.match[1];return{searchPath:K.folder.uri,pattern:V&&I(V)}});{const K=a.match(/\.[\/\\](.+)[\/\\]?/),V=K?K[1]:a,z=p.localize(0,null,V);throw new Error(z)}}}}resolveOneSearchPathPattern(a,o){const O=a.pattern&&o?`${a.pattern}/${o}`:a.pattern||o,$=[{searchPath:a.searchPath,pattern:O}];return O&&!O.endsWith("**")&&$.push({searchPath:a.searchPath,pattern:O+"/**"}),$}getFolderQueryForSearchPath(a,o,O){const $=this.getFolderQueryForRoot((0,r.toWorkspaceFolder)(a.searchPath),o,O,!1);return $?{...$,includePattern:a.pattern}:null}getFolderQueryForRoot(a,o,O,$){let K;const V=d.URI.isUri(a)?a:a.uri;if(O.searchPaths){const U=O.searchPaths.filter(le=>(0,g.isEqual)(le.searchPath,V))[0];if(U&&!U.pattern)return null;U&&(K=U.pattern)}const z=this.configurationService.getValue({resource:V}),q={...this.getExcludesForFolder(z,o)||{},...K||{}},B=d.URI.isUri(a)?(0,g.basename)(a):a.name;return{folder:V,folderName:$?B:void 0,excludePattern:Object.keys(q).length>0?q:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof o.disregardIgnoreFiles=="boolean"?o.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof o.disregardGlobalIgnoreFiles=="boolean"?o.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof o.disregardParentIgnoreFiles=="boolean"?o.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof o.ignoreSymlinks=="boolean"?o.ignoreSymlinks:!z.search.followSymlinks}}};e.QueryBuilder=_=Ve([He(0,l.IConfigurationService),He(1,r.IWorkspaceContextService),He(2,c.IEditorGroupsService),He(3,t.ILogService),He(4,b.IPathService)],_);function i(S){const a=S.match(/[\*\{\}\(\)\[\]\?]/);if(a){const o=a.index,O=S.substr(0,o).match(/[/|\\][^/\\]*$/);if(O){let $=S.substr(0,O.index);return $.match(/[/\\]/)||($+="/"),{pathPortion:$,globPortion:S.substr((O.index||0)+1)}}}return{pathPortion:S}}function u(...S){return S.length?S.reduce((a,o)=>(a[o]=!0,a),Object.create(null)):void 0}function n(S){return C.splitGlobAware(S,",").map(a=>a.trim()).filter(a=>!!a.length)}function s(S){return[`**/${S}/**`,`**/${S}`].map(o=>o.replace(/\*\*\/\*\*/g,"**"))}function v(S){return S.replace(/\\/g,"/")}function I(S){return v(S).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(S){return S.replace(/([?*[\]])/g,"[$1]")}function T(S,a){S=m.distinct(S,$=>$.toString());const o=[],O=a.getWorkspace();return S&&S.forEach($=>{let K;if(a.getWorkbenchState()===2)K=(0,g.relativePath)(O.folders[0].uri,$),K&&K!=="."&&(K="./"+K);else{const V=a.getWorkspaceFolder($);if(V){const z=V.name;if(O.folders.filter(q=>q.name===z).length===1){const q=(0,g.relativePath)(V.uri,$);q===""?K=`./${V.name}`:K=`./${V.name}/${q}`}else K=$.fsPath}}K&&o.push(h(K))}),o}e.resolveResourcesForSearchIncludes=T}),define(Ae[262],Re([1,0,20,2,22,9,3,261,47,53]),function(te,e,m,k,C,M,F,f,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function y(l,t){const r=t.activationEvents;if(!r)return Promise.resolve(void 0);const c=[],b=[];for(const s of r)if(/^workspaceContains:/.test(s)){const v=s.substr(18);v.indexOf("*")>=0||v.indexOf("?")>=0||l.forceUsingSearch?b.push(v):c.push(v)}if(c.length===0&&b.length===0)return Promise.resolve(void 0);let w;const _=new Promise((s,v)=>{w=s}),i=s=>w({activationEvent:s}),u=Promise.all(c.map(s=>d(l,s,i))).then(()=>{}),n=E(l,t.identifier,b,i);return Promise.all([u,n]).then(()=>{w(void 0)}),_}e.checkActivateWorkspaceContainsExtension=y;async function d(l,t,r){for(const c of l.folders)if(await l.exists(m.joinPath(k.URI.revive(c),t))){r(`workspaceContains:${t}`);return}}async function E(l,t,r,c){if(r.length===0)return Promise.resolve(void 0);const b=new C.CancellationTokenSource,w=l.checkExists(l.folders,r,b.token),_=setTimeout(async()=>{b.cancel(),l.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${r.join(",")}`)},R);let i=!1;try{i=await w}catch(u){M.isCancellationError(u)||M.onUnexpectedError(u)}b.dispose(),clearTimeout(_),i&&c(`workspaceContains:${r.join(",")}`)}function p(l,t,r,c){const b=l.get(F.IInstantiationService),w=l.get(D.ISearchService),i=b.createInstance(f.QueryBuilder).file(t.map(u=>(0,g.toWorkspaceFolder)(k.URI.revive(u))),{_reason:"checkExists",includePattern:r,exists:!0});return w.fileSearch(i,c).then(u=>!!u.limitHit,u=>M.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=p});var Xe=this&&this.__classPrivateFieldSet||function(te,e,m,k,C){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?C.call(te,m):C?C.value=m:e.set(te,m),m},Fe=this&&this.__classPrivateFieldGet||function(te,e,m,k){if(m==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?k:m==="a"?k.call(te):k?k.value:e.get(te)};define(Ae[35],Re([1,0,148,19,87,20,16,6,48,2,15,4,34,209,85,33,26,106,9,24,25,187,7,97,3,27,86,17,73,75,62,5,262,84,189,14,82,58,21,83]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l,t,r,c,b,w,_,i,u,n,s,v,I,h,T,S,a,o,O,$,K,V,z,N,q){"use strict";var B,U,le;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let ve=e.AbstractExtHostExtensionService=class On extends f.Disposable{constructor(A,G,de,ye,_e,pe,Ce,ae,ue,ne,ee,P){super(),this._extHostManagedSockets=P,this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=G,this._extHostContext=de,this._initData=Ce,this._extHostWorkspace=ye,this._extHostConfiguration=_e,this._logService=pe,this._extHostTunnelService=ue,this._extHostTerminalService=ne,this._extHostLocalizationService=ee,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new F.Barrier,this._readyToStartExtensionHost=new F.Barrier,this._readyToRunExtensions=new F.Barrier,this._eagerExtensionsActivated=new F.Barrier,this._activationEventsReader=new ke(this._initData.activationEvents),this._globalRegistry=new r.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.allExtensions);const W=new b.ExtensionIdentifierSet(this._initData.myExtensions);this._myRegistry=new r.ExtensionDescriptionRegistry(this._activationEventsReader,ce(this._globalRegistry,W)),this._storage=new p.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=ae,this._instaService=A.createChild(new h.ServiceCollection([p.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState])),this._activator=this._register(new E.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(H,j,re)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(H,c.transformErrorForSerialization(j),re)},actualActivateExtension:async(H,j)=>{if(r.ExtensionDescriptionRegistry.isHostExtension(H,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(H,j),new E.HostExtension;const re=this._myRegistry.getExtensionDescription(H);return this._activateExtension(re,j)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(A){c.onUnexpectedError(A)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let A=[];try{A=this._myRegistry.getAllExtensionDescriptions().map(_e=>_e.identifier).filter(_e=>this.isActivated(_e)).map(_e=>this._deactivate(_e))}catch{}await Promise.all(A)}terminate(A,G=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${A}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),c.setUnexpectedErrorHandler(ye=>{this._logService.error(ye)}),this._extHostContext.dispose();const de=this._deactivateAll();Promise.race([(0,F.timeout)(5e3),de]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${G}`):this._logService.info(`Extension host exiting with code ${G}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(G)})}isActivated(A){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(A):!1}async getExtension(A){const G=await this._mainThreadExtensionsProxy.$getExtension(A);return G&&{...G,identifier:new b.ExtensionIdentifier(G.identifier.value),extensionLocation:g.URI.revive(G.extensionLocation)}}_activateByEvent(A,G){return this._activator.activateByEvent(A,G)}_activateById(A,G){return this._activator.activateById(A,G)}activateByIdWithErrors(A,G){return this._activateById(A,G).then(()=>{const de=this._activator.getActivatedExtension(A);if(de.activationFailed)return Promise.reject(de.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(A=>this._myRegistry)}getExtensionExports(A){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(A).exports;try{return this._activator.getActivatedExtension(A).exports}catch{return null}}async _realPathExtensionUri(A){if(A.scheme!==K.Schemas.file)return A;const G=await this._hostUtils.realpath(A.fsPath);return g.URI.file(G)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(A=>new De(A))),this._extensionPathIndex}async _createExtensionPathIndex(A){const G=D.TernarySearchTree.forUris(de=>M.extUriBiasedIgnorePathCase.ignorePathCasing(de));return await Promise.all(A.map(async de=>{if(this._getEntryPoint(de)){const ye=await this._realPathExtensionUri(de.extensionLocation);G.set(ye,de)}})),G}_deactivate(A){let G=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(A))return G;const de=this._activator.getActivatedExtension(A);if(!de)return G;try{typeof de.module.deactivate=="function"&&(G=Promise.resolve(de.module.deactivate()).then(void 0,ye=>(this._logService.error(ye),Promise.resolve(void 0))))}catch(ye){this._logService.error(`An error occurred when deactivating the extension '${A.value}':`),this._logService.error(ye)}try{(0,f.dispose)(de.subscriptions)}catch(ye){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${A.value}':`),this._logService.error(ye)}return G}async _activateExtension(A,G){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(A.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(A.identifier),this._doActivateExtension(A,G).then(de=>{const ye=de.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(A.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,G),this._logExtensionActivationTimes(A,G,"success",ye),de},de=>{throw this._logExtensionActivationTimes(A,G,"failure"),de})}_logExtensionActivationTimes(A,G,de,ye){const _e=J(A,G);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{..._e,...ye||{},outcome:de})}_doActivateExtension(A,G){const de=J(A,G);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",de);const ye=this._getEntryPoint(A);if(!ye)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${A.identifier.value}, startup: ${G.startup}, activationEvent: '${G.activationEvent}'${A.identifier.value!==G.extensionId.value?`, root cause: ${G.extensionId.value}`:""}`),this._logService.flush();const _e=new E.ExtensionActivationTimesBuilder(G.startup);return Promise.all([this._loadCommonJSModule(A,(0,M.joinPath)(A.extensionLocation,ye),_e),this._loadExtensionContext(A)]).then(pe=>(C.mark(`code/extHost/willActivateExtension/${A.identifier.value}`),On._callActivate(this._logService,A.identifier,pe[0],pe[1],_e))).then(pe=>(C.mark(`code/extHost/didActivateExtension/${A.identifier.value}`),pe))}_loadExtensionContext(A){const G=new _.ExtensionGlobalMemento(A,this._storage),de=new _.ExtensionMemento(A.identifier.value,!1,this._storage),ye=new $.ExtensionSecrets(A,this._secretState),_e=A.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,pe=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${A.identifier.value}`),Promise.all([G.whenReady,de.whenReady,this._storagePath.whenReady]).then(()=>{const Ce=this;let ae,ue;const ne=(0,t.isProposedApiEnabled)(A,"ipc")?this._initData.messagePorts?.get(b.ExtensionIdentifier.toKey(A.identifier)):void 0;return Object.freeze({globalState:G,workspaceState:de,secrets:ye,subscriptions:[],get extensionUri(){return A.extensionLocation},get extensionPath(){return A.extensionLocation.fsPath},asAbsolutePath(ee){return k.join(A.extensionLocation.fsPath,ee)},get storagePath(){return Ce._storagePath.workspaceValue(A)?.fsPath},get globalStoragePath(){return Ce._storagePath.globalValue(A).fsPath},get logPath(){return k.join(Ce._initData.logsLocation.fsPath,A.identifier.value)},get logUri(){return g.URI.joinPath(Ce._initData.logsLocation,A.identifier.value)},get storageUri(){return Ce._storagePath.workspaceValue(A)},get globalStorageUri(){return Ce._storagePath.globalValue(A)},get extensionMode(){return _e},get extension(){return ae===void 0&&(ae=new X(Ce,A.identifier,A,pe,!1)),ae},get extensionRuntime(){return(0,t.checkProposedApiEnabled)(A,"extensionRuntime"),Ce.extensionRuntime},get environmentVariableCollection(){return Ce._extHostTerminalService.getEnvironmentVariableCollection(A)},get messagePassingProtocol(){if(!ue){if(!ne)return;const ee=a.Event.buffer(a.Event.fromDOMEventEmitter(ne,"message",P=>P.data));ne.start(),ue={onDidReceiveMessage:ee,postMessage:ne.postMessage.bind(ne)}}return ue}})})}static _callActivate(A,G,de,ye,_e){return de=de||{activate:void 0,deactivate:void 0},this._callActivateOptional(A,G,de,ye,_e).then(pe=>new E.ActivatedExtension(!1,null,_e.build(),de,pe,ye.subscriptions))}static _callActivateOptional(A,G,de,ye,_e){if(typeof de.activate=="function")try{_e.activateCallStart(),A.trace(`ExtensionService#_callActivateOptional ${G.value}`);const pe=typeof global=="object"?global:self,Ce=de.activate.apply(pe,[ye]);return _e.activateCallStop(),_e.activateResolveStart(),Promise.resolve(Ce).then(ae=>(_e.activateResolveStop(),ae))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(de)}_activateOneStartupFinished(A,G){this._activateById(A.identifier,{startup:!1,extensionId:A.identifier,activationEvent:G}).then(void 0,de=>{this._logService.error(de)})}_activateAllStartupFinishedDeferred(A,G=0){const ye=Date.now();(0,N.setTimeout0)(()=>{for(let _e=G;_e<A.length;_e+=1){const pe=A[_e];for(const Ce of pe.activationEvents??[])if(Ce==="onStartupFinished")if(Date.now()-ye>50){this._activateAllStartupFinishedDeferred(A,_e);break}else this._activateOneStartupFinished(pe,Ce)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks()),this._extHostConfiguration.getConfigProvider().then(A=>{const G=A.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),de=this._myRegistry.getAllExtensionDescriptions();if(G)this._activateAllStartupFinishedDeferred(de);else for(const ye of de)if(ye.activationEvents)for(const _e of ye.activationEvents)_e==="onStartupFinished"&&this._activateOneStartupFinished(ye,_e)})}_handleEagerExtensions(){const A=this._activateByEvent("*",!0).then(void 0,pe=>{this._logService.error(pe)});this._register(this._extHostWorkspace.onDidChangeWorkspace(pe=>this._handleWorkspaceContainsEagerExtensions(pe.added)));const G=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],de=this._handleWorkspaceContainsEagerExtensions(G),ye=this._handleRemoteResolverEagerExtensions(),_e=Promise.all([ye,A,de]).then(()=>{});return Promise.race([_e,(0,F.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),_e}_handleWorkspaceContainsEagerExtensions(A){return A.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(G=>this._handleWorkspaceContainsEagerExtension(A,G))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(A,G){if(this.isActivated(G.identifier))return;const de=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ye={logService:this._logService,folders:A.map(pe=>pe.uri),forceUsingSearch:de,exists:pe=>this._hostUtils.exists(pe.fsPath),checkExists:(pe,Ce,ae)=>this._mainThreadWorkspaceProxy.$checkExists(pe,Ce,ae)},_e=await(0,o.checkActivateWorkspaceContainsExtension)(ye,G);if(_e)return this._activateById(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:_e.activationEvent}).then(void 0,pe=>this._logService.error(pe))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(A){throw console.error(A),A}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:A,extensionTestsLocationURI:G}=this._initData.environment;if(!A||!G)throw new Error(m.localize(0,null));const de=await this._loadCommonJSModule(null,G,new E.ExtensionActivationTimesBuilder(!1));if(!de||typeof de.run!="function")throw new Error(m.localize(1,null,G.toString()));return new Promise((ye,_e)=>{const pe=(ue,ne)=>{ue?_e(ue):ye(typeof ne=="number"&&ne>0?1:0)},Ce=(0,M.originalFSPath)(G),ae=de.run(Ce,pe);ae&&ae.then&&ae.then(()=>{ye(0)}).catch(ue=>{_e(ue instanceof Error&&ue.stack?ue.stack:String(ue))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,F.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(A,G){return this._resolvers[A]=G,(0,f.toDisposable)(()=>{delete this._resolvers[A]})}async getRemoteExecServer(A){const{resolver:G}=await this._activateAndGetResolver(A);return G?.resolveExecServer?.(A,{resolveAttempt:0})}async _activateAndGetResolver(A){const G=A.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const de=A.substr(0,G);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${de}`,!1),{authorityPrefix:de,resolver:this._resolvers[de]}}async $resolveAuthority(A,G){const de=z.StopWatch.create(!1),ye=()=>`[resolveAuthority(${(0,u.getRemoteAuthorityPrefix)(A)},${G})][${de.elapsed()}ms] `,_e=re=>this._logService.info(`${ye()}${re}`),pe=(re,he=void 0)=>this._logService.error(`${ye()}${re}`,he),Ce=re=>{if(re instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:re._code,message:re._message,detail:re._detail}};throw re},ae=A.split(/@|%40/g).reverse();_e(`activating remote resolvers ${ae.join(" -> ")}`);let ue;try{ue=await Promise.all(ae.map(async re=>{_e("activating resolver...");const{resolver:he,authorityPrefix:ie}=await this._activateAndGetResolver(re);if(!he)throw pe("no resolver"),new i.RemoteAuthorityResolverError(`No remote extension installed to resolve ${ie}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:he,authorityPrefix:ie,remoteAuthority:re}}))}catch(re){return Ce(re)}const ne=new F.IntervalTimer;ne.cancelAndSet(()=>_e("waiting..."),1e3);let ee,P;for(const[re,{authorityPrefix:he,resolver:ie,remoteAuthority:we}]of ue.entries())try{if(re===ue.length-1)_e("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${he}`),ee=await ie.resolve(we,{resolveAttempt:G,execServer:P}),C.mark(`code/extHost/didResolveAuthorityOK/${he}`),_e("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(ie));else{if(_e(`invoking resolveExecServer() for ${we}`),C.mark(`code/extHost/willResolveExecServer/${he}`),P=await ie.resolveExecServer?.(we,{resolveAttempt:G,execServer:P}),!P)throw new i.RemoteAuthorityResolverError(`Exec server was not available for ${we}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${he}`)}}catch(Se){return C.mark(`code/extHost/didResolveAuthorityError/${he}`),pe("returned an error",Se),ne.dispose(),Ce(Se)}ne.dispose();const W={environmentTunnels:ee.environmentTunnels,features:ee.tunnelFeatures},H={extensionHostEnv:ee.extensionHostEnv,isTrusted:ee.isTrusted,authenticationSession:ee.authenticationSessionForInitializingExtensions?{id:ee.authenticationSessionForInitializingExtensions.id,providerId:ee.authenticationSessionForInitializingExtensions.providerId}:void 0};_e(`returned ${i.ManagedResolvedAuthority.isManagedResolvedAuthority(ee)?"managed authority":`${ee.host}:${ee.port}`}`);let j;if(i.ManagedResolvedAuthority.isManagedResolvedAuthority(ee)){const re=G;this._extHostManagedSockets.setFactory(re,ee.makeConnection),j={authority:A,connectTo:new u.ManagedRemoteConnection(re),connectionToken:ee.connectionToken}}else j={authority:A,connectTo:new u.WebSocketRemoteConnection(ee.host,ee.port),connectionToken:ee.connectionToken};return{type:"ok",value:{authority:j,options:H,tunnelInformation:W}}}async $getCanonicalURI(A,G){this._logService.info(`$getCanonicalURI invoked for authority (${(0,u.getRemoteAuthorityPrefix)(A)})`);const{resolver:de}=await this._activateAndGetResolver(A);if(!de)return null;const ye=g.URI.revive(G);if(typeof de.getCanonicalURI>"u")return ye;const _e=await(0,F.asPromise)(()=>de.getCanonicalURI(ye));return _e||ye}$startExtensionHost(A){A.toAdd.forEach(ye=>ye.extensionLocation=g.URI.revive(ye.extensionLocation));const{globalRegistry:G,myExtensions:de}=Pe(this._activationEventsReader,this._globalRegistry,this._myRegistry,A);return this._globalRegistry.set(G.getAllExtensionDescriptions()),this._myRegistry.set(de),this._startExtensionHost()}$activateByEvent(A,G){return G===1?this._activateByEvent(A,!1):this._readyToRunExtensions.wait().then(de=>this._activateByEvent(A,!1))}async $activate(A,G){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(A)?(await this._activateById(A,G),!0):!1}async $deltaExtensions(A){A.toAdd.forEach(pe=>pe.extensionLocation=g.URI.revive(pe.extensionLocation));const{globalRegistry:G,myExtensions:de}=Pe(this._activationEventsReader,this._globalRegistry,this._myRegistry,A),ye=await this._createExtensionPathIndex(de);return(await this.getExtensionPathIndex()).setSearchTree(ye),this._globalRegistry.set(G.getAllExtensionDescriptions()),this._myRegistry.set(de),Promise.resolve(void 0)}async $test_latency(A){return A}async $test_up(A){return A.byteLength}async $test_down(A){const G=w.VSBuffer.alloc(A),de=Math.random()%256;for(let ye=0;ye<A;ye++)G.writeUInt8(de,ye);return G}async $updateRemoteConnectionData(A){this._remoteConnectionData=A,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=ve=Ve([He(0,n.IInstantiationService),He(1,e.IHostUtils),He(2,I.IExtHostRpcService),He(3,l.IExtHostWorkspace),He(4,d.IExtHostConfiguration),He(5,R.ILogService),He(6,s.IExtHostInitDataService),He(7,v.IExtensionStoragePaths),He(8,T.IExtHostTunnelService),He(9,S.IExtHostTerminalService),He(10,V.IExtHostLocalizationService),He(11,q.IExtHostManagedSockets)],ve);function Pe(ge,A,G,de){ge.addActivationEvents(de.addActivationEvents);const ye=new r.ExtensionDescriptionRegistry(ge,A.getAllExtensionDescriptions());ye.deltaExtensions(de.toAdd,de.toRemove);const _e=new b.ExtensionIdentifierSet(G.getAllExtensionDescriptions().map(Ce=>Ce.identifier));for(const Ce of de.myToRemove)_e.delete(Ce);for(const Ce of de.myToAdd)_e.add(Ce);const pe=ce(ye,_e);return{globalRegistry:ye,myExtensions:pe}}function J(ge,A){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:A.activationEvent,reasonId:A.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class X{constructor(A,G,de,ye,_e){B.set(this,void 0),U.set(this,void 0),le.set(this,void 0),Xe(this,B,A,"f"),Xe(this,U,G,"f"),Xe(this,le,de.identifier,"f"),this.id=de.identifier.value,this.extensionUri=de.extensionLocation,this.extensionPath=k.normalize((0,M.originalFSPath)(de.extensionLocation)),this.packageJSON=de,this.extensionKind=ye,this.isFromDifferentExtensionHost=_e}get isActive(){return Fe(this,B,"f").isActivated(Fe(this,le,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Fe(this,B,"f").getExtensionExports(Fe(this,le,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Fe(this,B,"f").activateByIdWithErrors(Fe(this,le,"f"),{startup:!1,extensionId:Fe(this,U,"f"),activationEvent:"api"}),this.exports}}e.Extension=X,B=new WeakMap,U=new WeakMap,le=new WeakMap;function ce(ge,A){return ge.getAllExtensionDescriptions().filter(G=>A.has(G.identifier))}class De{constructor(A){this._searchTree=A}setSearchTree(A){this._searchTree=A}findSubstr(A){return this._searchTree.findSubstr(A)}forEach(A){return this._searchTree.forEach(A)}}e.ExtensionPaths=De;class ke{constructor(A){this._map=new b.ExtensionIdentifierMap,this.addActivationEvents(A)}readActivationEvents(A){return this._map.get(A.identifier)}addActivationEvents(A){for(const G of Object.keys(A))this._map.set(G,A[G])}}}),define(Ae[263],Re([1,0,87,2,4,34,26,24,17,27,3,35,51,15,13]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=e.RequireInterceptor=class{constructor(_,i,u,n,s,v,I){this._apiFactory=_,this._extensionRegistry=i,this._instaService=u,this._extHostConfiguration=n,this._extHostExtensionService=s,this._initData=v,this._logService=I,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const _=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const i=await this._extHostExtensionService.getExtensionPathIndex();this.register(new r(this._apiFactory,i,this._extensionRegistry,_,this._logService)),this.register(this._instaService.createInstance(c,i)),this.register(this._instaService.createInstance(t)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,i,this._initData.environment.appUriScheme))}register(_){if("nodeModuleName"in _)if(Array.isArray(_.nodeModuleName))for(const i of _.nodeModuleName)this._factories.set(i,_);else this._factories.set(_.nodeModuleName,_);typeof _.alternativeModuleName=="function"&&this._alternatives.push(i=>_.alternativeModuleName(i))}};e.RequireInterceptor=l=Ve([He(2,R.IInstantiationService),He(3,M.IExtHostConfiguration),He(4,y.IExtHostExtensionService),He(5,g.IExtHostInitDataService),He(6,E.ILogService)],l);let t=class fn{constructor(_){if(_.environment.appRoot&&fn.aliased.size){const i=(0,p.escapeRegExpCharacters)(this.forceForwardSlashes(_.environment.appRoot.fsPath)),u="[a-z0-9_.-]",n=`@${u}+\\/${u}+|${u}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${i}/${s}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(_){if(!this.re)return;const i=this.re.exec(this.forceForwardSlashes(_));if(!i)return;const[,u,n,s]=i,v=fn.aliased.get(n);if(v!==void 0)return console.warn(`${n} as been renamed to ${v}, please update your imports`),u+v+s}forceForwardSlashes(_){return _.replace(/\\/g,"/")}};t.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),t=Ve([He(0,g.IExtHostInitDataService)],t);class r{constructor(_,i,u,n,s){this._apiFactory=_,this._extensionPaths=i,this._extensionRegistry=u,this._configProvider=n,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new f.ExtensionIdentifierMap}load(_,i){const u=this._extensionPaths.findSubstr(i);if(u){let n=this._extApiImpl.get(u.identifier);return n||(n=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(u.identifier,n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((s,v)=>n+=`	${v} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(F.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let c=class{constructor(_,i,u){this._extensionPaths=_,this.nodeModuleName="keytar",this._mainThreadTelemetry=i.getProxy(C.MainContext.MainThreadTelemetry);const{environment:n}=u,s=i.getProxy(C.MainContext.MainThreadKeytar);if(n.appRoot){let v=n.appRoot.fsPath;d.platform==="win32"&&(v=v.replace(/\\/g,"/")),v[v.length-1]==="/"&&(v=v.substr(0,v.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${v}/node_modules.asar/keytar`),this.alternativeNames.add(`${v}/node_modules/keytar`)}this._impl={getPassword:(v,I)=>s.$getPassword(v,I),setPassword:(v,I,h)=>s.$setPassword(v,I,h),deletePassword:(v,I)=>s.$deletePassword(v,I),findPassword:v=>s.$findPassword(v),findCredentials(v){return s.$findCredentials(v)}}}load(_,i){const u=this._extensionPaths.findSubstr(i);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(_){const i=_.length;if(i<=7||!this.alternativeNames)return;const u=i-7;if((_.charAt(u)==="/"||_.charAt(u)==="\\")&&_.endsWith("keytar")&&(_=_.replace(/\\/g,"/"),this.alternativeNames.has(_)))return"keytar"}};c=Ve([He(1,D.IExtHostRpcService),He(2,g.IExtHostInitDataService)],c);let b=class{constructor(_,i,u){this._extensionPaths=_,this._appUriScheme=i,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(C.MainContext.MainThreadTelemetry);const n=u.getProxy(C.MainContext.MainThreadWindow);this._impl=(s,v)=>{const I=k.URI.parse(s);return v?this.callOriginal(s,v):I.scheme==="http"||I.scheme==="https"?n.$openUri(I,s,{allowTunneling:!0}):I.scheme==="mailto"||I.scheme===this._appUriScheme?n.$openUri(I,s,{}):this.callOriginal(s,v)}}load(_,i,u){const n=this._extensionPaths.findSubstr(i);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=u(_),this._impl}callOriginal(_,i){return this.sendNoForwardTelemetry(),this._original(_,i)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=Ve([He(2,D.IExtHostRpcService)],b)}),define(Ae[112],Re([1,0,66,6,19,51,3,59,60,35,7,33,199,34]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,F.createDecorator)("IExtHostVariableResolverProvider");class p extends d.AbstractVariableResolverService{constructor(r,c,b,w,_,i,u){function n(){if(b){const s=b.activeEditor();if(s)return s.document.uri;const v=w.tabGroups.all.find(I=>I.isActive)?.activeTab;if(v!==void 0){if(v.input instanceof R.TextDiffTabInput||v.input instanceof R.NotebookDiffEditorTabInput)return v.input.modified;if(v.input instanceof R.TextTabInput||v.input instanceof R.NotebookEditorTabInput||v.input instanceof R.CustomEditorTabInput)return v.input.uri}}}super({getFolderUri:s=>{const v=i.folders.filter(I=>I.name===s);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(s,v)=>_.getConfiguration(void 0,s).get(v),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=n();if(s)return C.normalize(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const s=n();if(s){const v=c.getWorkspaceFolder(s);if(v)return C.normalize(v.uri.fsPath)}}},getSelectedText:()=>{if(b){const s=b.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(b){const s=b.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>r.getExtension(s)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(M.env))}}let l=e.ExtHostVariableResolverProviderService=class extends k.Disposable{constructor(r,c,b,w,_){super(),this.extensionService=r,this.workspaceService=c,this.editorService=b,this.configurationService=w,this.editorTabs=_,this._resolver=new m.Lazy(async()=>{const i=await this.configurationService.getConfigProvider(),n={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async s=>{n.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new p(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,i,n,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=l=Ve([He(0,g.IExtHostExtensionService),He(1,y.IExtHostWorkspace),He(2,f.IExtHostDocumentsAndEditors),He(3,E.IExtHostConfiguration),He(4,D.IExtHostEditorTabs)],l)}),define(Ae[113],Re([1,0,16,5,10,2,3,4,60,35,17,7,33,192,194,34,112]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,F.createDecorator)("IExtHostDebugService");let r=e.ExtHostDebugServiceBase=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(n,s,v,I,h,T){this._workspaceService=s,this._extensionService=v,this._configurationService=I,this._editorTabs=h,this._variableResolver=T,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=n.getProxy(f.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onWillAddFirstListener:()=>{this.startBreakpoints()}}),this._onDidChangeStackFrameFocus=new k.Emitter,this._activeDebugConsole=new b(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(S=>{S.onDidChange(a=>{this.registerAllDebugTypes(S)}),this.registerAllDebugTypes(S)})}asDebugSourceUri(n,s){const v=n;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let I=`debug:${encodeURIComponent(v.path||"")}`,h="?";return s&&(I+=`${h}session=${encodeURIComponent(s.id)}`,h="&"),I+=`${h}ref=${v.sourceReference}`,M.URI.parse(I)}else{if(v.path)return M.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const s=[];for(const v of n.getAllExtensionDescriptions())if(v.contributes){const I=v.contributes.debuggers;if(I&&I.length>0)for(const h of I)(0,p.isDebuggerMainContribution)(h)&&s.push(h.type)}this._debugServiceProxy.$registerDebugTypes(s)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const n=[];return this._breakpoints.forEach(s=>n.push(s)),n}addBreakpoints(n){this.startBreakpoints();const s=n.filter(h=>{const T=h.id;return this._breakpoints.has(T)?!1:(this._breakpoints.set(T,h),!0)});this.fireBreakpointChanges(s,[],[]);const v=[],I=new Map;for(const h of s)if(h instanceof y.SourceBreakpoint){let T=I.get(h.location.uri.toString());T||(T={type:"sourceMulti",uri:h.location.uri,lines:[]},I.set(h.location.uri.toString(),T),v.push(T)),T.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof y.FunctionBreakpoint&&v.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this._debugServiceProxy.$registerBreakpoints(v)}removeBreakpoints(n){this.startBreakpoints();const s=n.filter(T=>this._breakpoints.delete(T.id));this.fireBreakpointChanges([],s,[]);const v=s.filter(T=>T instanceof y.SourceBreakpoint).map(T=>T.id),I=s.filter(T=>T instanceof y.FunctionBreakpoint).map(T=>T.id),h=s.filter(T=>T instanceof y.DataBreakpoint).map(T=>T.id);return this._debugServiceProxy.$unregisterBreakpoints(v,I,h)}startDebugging(n,s,v){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,s,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,s,v){if(!s)return new y.Disposable(()=>{});const I=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:I,provider:s}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,v,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,I),new y.Disposable(()=>{this._configProviders=this._configProviders.filter(h=>h.provider!==s),this._debugServiceProxy.$unregisterDebugConfigurationProvider(I)})}registerDebugAdapterDescriptorFactory(n,s,v){if(!v)return new y.Disposable(()=>{});if(!this.definesDebugType(n,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.getAdapterDescriptorFactoryByType(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const I=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:s,handle:I,factory:v}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(s,I),new y.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(h=>h.factory!==v),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(I)})}registerDebugAdapterTrackerFactory(n,s){if(!s)return new y.Disposable(()=>{});const v=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:v,factory:s}),new y.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(I=>I.factory!==s)})}async $runInTerminal(n,s){return Promise.resolve(void 0)}async $substituteVariables(n,s){let v;const I=await this.getFolder(n);return I&&(v={uri:I.uri,name:I.name,index:I.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(v,s)}createDebugAdapter(n,s){if(n.type==="implementation")return new _(n.implementation)}createSignService(){}async $startDASession(n,s){const v=this,I=await this.getSession(s);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(I.type),I).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}' (extension might have failed to activate)`);const T=this.convertToDto(h),S=this.createDebugAdapter(T,I);if(!S)throw new Error(`Couldn't create a debug adapter for type '${I.type}'.`);const a=S;return this._debugAdapters.set(n,a),this.getDebugAdapterTrackers(I).then(o=>(o&&this._debugAdaptersTrackers.set(n,o),a.onMessage(async O=>{if(O.type==="request"&&O.command==="handshake"){const $=O,K={type:"response",seq:0,command:$.command,request_seq:$.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const V=await this._signService.sign($.arguments.value);K.body={signature:V},a.sendResponse(K)}else throw new Error("no signer")}catch(V){K.success=!1,K.message=V.message,a.sendResponse(K)}}else o&&o.onDidSendMessage&&o.onDidSendMessage(O),O=(0,p.convertToVSCPaths)(O,!0),v._debugServiceProxy.$acceptDAMessage(n,O)}),a.onError(O=>{o&&o.onError&&o.onError(O),this._debugServiceProxy.$acceptDAError(n,O.name,O.message,O.stack)}),a.onExit(O=>{o&&o.onExit&&o.onExit((0,C.withNullAsUndefined)(O),void 0),this._debugServiceProxy.$acceptDAExit(n,(0,C.withNullAsUndefined)(O),void 0)}),o&&o.onWillStartSession&&o.onWillStartSession(),a.startSession()))})}$sendDAMessage(n,s){s=(0,p.convertToDAPaths)(s,!1);const v=this._debugAdaptersTrackers.get(n);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(s),this._debugAdapters.get(n)?.sendMessage(s)}$stopDASession(n){const s=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),s&&s.onWillStopSession&&s.onWillStopSession();const v=this._debugAdapters.get(n);return this._debugAdapters.delete(n),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const s=[],v=[],I=[];if(n.added)for(const h of n.added){const T=h.id;if(T&&!this._breakpoints.has(T)){let S;if(h.type==="function")S=new y.FunctionBreakpoint(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")S=new y.DataBreakpoint(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const a=M.URI.revive(h.uri);S=new y.SourceBreakpoint(new y.Location(a,new y.Position(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,y.setBreakpointId)(S,T),this._breakpoints.set(T,S),s.push(S)}}if(n.removed)for(const h of n.removed){const T=this._breakpoints.get(h);T&&(this._breakpoints.delete(h),v.push(T))}if(n.changed){for(const h of n.changed)if(h.id){const T=this._breakpoints.get(h.id);if(T){if(T instanceof y.FunctionBreakpoint&&h.type==="function"){const S=T;S.enabled=h.enabled,S.condition=h.condition,S.hitCondition=h.hitCondition,S.logMessage=h.logMessage,S.functionName=h.functionName}else if(T instanceof y.SourceBreakpoint&&h.type==="source"){const S=T;S.enabled=h.enabled,S.condition=h.condition,S.hitCondition=h.hitCondition,S.logMessage=h.logMessage,S.location=new y.Location(M.URI.revive(h.uri),new y.Position(h.line,h.character))}I.push(T)}}}this.fireBreakpointChanges(s,v,I)}async $acceptStackFrameFocus(n){let s;const v=n.sessionId?await this.getSession(n.sessionId):void 0;if(!v)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?s=new y.ThreadFocus(v,n.threadId):s=new y.StackFrameFocus(v,n.threadId,n.frameId),this._stackFrameFocus=s,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(n,s,v){return(0,m.asPromise)(async()=>{const I=this.getConfigProviderByHandle(n);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.getFolder(s);return I.provideDebugConfigurations(h,v)}).then(I=>{if(!I)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return I})}$resolveDebugConfiguration(n,s,v,I){return(0,m.asPromise)(async()=>{const h=this.getConfigProviderByHandle(n);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const T=await this.getFolder(s);return h.resolveDebugConfiguration(T,v,I)})}$resolveDebugConfigurationWithSubstitutedVariables(n,s,v,I){return(0,m.asPromise)(async()=>{const h=this.getConfigProviderByHandle(n);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const T=await this.getFolder(s);return h.resolveDebugConfigurationWithSubstitutedVariables(T,v,I)})}async $provideDebugAdapter(n,s){const v=this.getAdapterDescriptorFactoryByHandle(n);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const I=await this.getSession(s);return this.getAdapterDescriptor(v,I).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}'`);return this.convertToDto(h)})}async $acceptDebugSessionStarted(n){const s=await this.getSession(n);this._onDidStartDebugSession.fire(s)}async $acceptDebugSessionTerminated(n){const s=await this.getSession(n);s&&(this._onDidTerminateDebugSession.fire(s),this._debugSessions.delete(s.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,s){(await this.getSession(n))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(n,s){const I={session:await this.getSession(n),event:s.event,body:s.body};this._onDidReceiveDebugSessionCustomEvent.fire(I)}convertToDto(n){if(n instanceof y.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof y.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const s=this._adapterFactories.filter(v=>v.type===n);if(s.length>0)return s[0].factory}getAdapterDescriptorFactoryByHandle(n){const s=this._adapterFactories.filter(v=>v.handle===n);if(s.length>0)return s[0].factory}getConfigProviderByHandle(n){const s=this._configProviders.filter(v=>v.handle===n);if(s.length>0)return s[0].provider}definesDebugType(n,s){if(n.contributes){const v=n.contributes.debuggers;if(v&&v.length>0){for(const I of v)if(I.label&&I.type&&I.type===s)return!0}}return!1}getDebugAdapterTrackers(n){const v=n.configuration.type,I=this._trackerFactories.filter(h=>h.type===v||h.type==="*").map(h=>(0,m.asPromise)(()=>h.factory.createDebugAdapterTracker(n)).then(T=>T,T=>null));return Promise.race([Promise.all(I).then(h=>{const T=h.filter(S=>!!S);if(T.length>0)return new w(T)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async getAdapterDescriptor(n,s){const v=s.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new y.DebugAdapterServer(v));if(n){const h=await this._extensionService.getExtensionRegistry();return(0,m.asPromise)(()=>n.createDebugAdapterDescriptor(s,this.daExecutableFromPackage(s,h))).then(T=>{if(T)return T})}const I=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(s,I))}daExecutableFromPackage(n,s){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(n,s,v){(n.length>0||s.length>0||v.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:s,changed:v}))}async getSession(n){if(n)if(typeof n=="string"){const s=this._debugSessions.get(n);if(s)return s}else{let s=this._debugSessions.get(n.id);if(!s){const v=await this.getFolder(n.folderUri),I=n.parent?this._debugSessions.get(n.parent):void 0;s=new c(this._debugServiceProxy,n.id,n.type,n.name,v,n.configuration,I),this._debugSessions.set(s.id,s),this._debugServiceProxy.$sessionCached(s.id)}return s}throw new Error("cannot find session")}getFolder(n){if(n){const s=M.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=r=Ve([He(0,R.IExtHostRpcService),He(1,d.IExtHostWorkspace),He(2,g.IExtHostExtensionService),He(3,l.IExtHostConfiguration),He(4,D.IExtHostEditorTabs),He(5,t.IExtHostVariableResolverProvider)],r);class c{constructor(n,s,v,I,h,T,S){this._debugServiceProxy=n,this._id=s,this._type=v,this._name=I,this._workspaceFolder=h,this._configuration=T,this._parentSession=S}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}get parentSession(){return this._parentSession}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,s){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,s)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=c;class b{constructor(n){this.value=Object.freeze({append(s){n.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=b;class w{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(s=>s.onError?s.onError(n):void 0)}onExit(n,s){this.trackers.forEach(v=>v.onExit?v.onExit(n,s):void 0)}}class _ extends E.AbstractDebugAdapter{constructor(n){super(),this.implementation=n,n.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let i=e.WorkerExtHostDebugService=class extends r{constructor(n,s,v,I,h,T){super(n,s,v,I,h,T)}};e.WorkerExtHostDebugService=i=Ve([He(0,R.IExtHostRpcService),He(1,d.IExtHostWorkspace),He(2,g.IExtHostExtensionService),He(3,l.IExtHostConfiguration),He(4,D.IExtHostEditorTabs),He(5,t.IExtHostVariableResolverProvider)],i)}),define(Ae[264],Re([1,0,9,87,2,4,255,15,72,73,27,170,17,55,35,57]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class t{static async installEarlyHandler(b){const w=b.get(f.ILogService),i=b.get(d.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);m.setUnexpectedErrorHandler(u=>{w.error(u);const n=m.transformErrorForSerialization(u);i.$onUnexpectedError(n)})}static async installFullHandler(b){const w=b.get(f.ILogService),_=b.get(d.IExtHostRpcService),i=b.get(p.IExtHostExtensionService),u=b.get(l.IExtHostTelemetry),n=_.getProxy(M.MainContext.MainThreadExtensionService),s=_.getProxy(M.MainContext.MainThreadErrors),v=await i.getExtensionPathIndex(),I=new WeakMap;function h(a,o){if(I.has(a))return I.get(a).stack;let O="",$,K;for(const z of o)O+=`
	at ${z.toString()}`,K=z.getFileName(),!$&&K&&($=v.findSubstr(C.URI.file(K)));const V=`${a.name||"Error"}: ${a.message||""}${O}`;return I.set(a,{extensionIdentifier:$?.identifier,stack:V}),V}const T=Symbol("prepareStackTrace wrapped");let S=h;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return S},set(a){if(a===h||a[T]){S=a;return}S=function(o,O){return h(o,O),a.call(Error,o,O)},Object.assign(S,{[T]:!0})}}),m.setUnexpectedErrorHandler(a=>{w.error(a);const o=m.transformErrorForSerialization(a),O=I.get(a);if(!O?.extensionIdentifier){s.$onUnexpectedError(o);return}n.$onExtensionRuntimeError(O.extensionIdentifier,o);const $=u.onExtensionError(O.extensionIdentifier,a);w.trace("forwarded error to extension?",$,O)})}}e.ErrorHandler=t,Error.stackTraceLimit=100;class r{constructor(b,w,_,i,u){this._hostUtils=_,this._rpcProtocol=new F.RPCProtocol(b,null,i),w=r._transform(w,this._rpcProtocol);const n=new g.ServiceCollection(...(0,D.getSingletonServiceDescriptors)());n.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...w,messagePorts:u}),n.set(d.IExtHostRpcService,new d.ExtHostRpcService(this._rpcProtocol)),n.set(E.IURITransformerService,new E.URITransformerService(i)),n.set(p.IHostUtils,_);const s=new y.InstantiationService(n,!0);s.invokeFunction(t.installEarlyHandler),this._logService=s.invokeFunction(v=>v.get(f.ILogService)),k.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",w),this._extensionService=s.invokeFunction(v=>v.get(p.IExtHostExtensionService)),this._extensionService.initialize(),s.invokeFunction(t.installFullHandler)}async asBrowserUri(b){const w=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService);return C.URI.revive(await w.$asBrowserUri(b))}terminate(b){this._extensionService.terminate(b)}static _transform(b,w){b.allExtensions.forEach(i=>{i.extensionLocation=C.URI.revive(w.transformIncomingURIs(i.extensionLocation))}),b.environment.appRoot=C.URI.revive(w.transformIncomingURIs(b.environment.appRoot));const _=b.environment.extensionDevelopmentLocationURI;return _&&(b.environment.extensionDevelopmentLocationURI=_.map(i=>C.URI.revive(w.transformIncomingURIs(i)))),b.environment.extensionTestsLocationURI=C.URI.revive(w.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=C.URI.revive(w.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=C.URI.revive(w.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=C.URI.revive(w.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=C.URI.revive(w.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=C.URI.revive(w.transformIncomingURIs(b.logsLocation)),b.workspace=w.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=r}),define(Ae[265],Re([1,0,18,16,22,41,14,19,20,2,47]),function(te,e,m,k,C,M,F,f,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class y{constructor(c,b,w,_){this.query=c,this.provider=b,this.fileUtils=w,this.processType=_,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,b){const w=this.query.folderQueries||[],_=new C.CancellationTokenSource;return b.onCancellationRequested(()=>_.cancel()),new Promise((i,u)=>{this.collector=new E(c);let n=!1;const s=(v,I)=>{if(!n&&!this.isLimitHit){const h=this.resultSize(v);l(v)&&typeof this.query.maxResults=="number"&&this.resultCount+h>this.query.maxResults&&(this.isLimitHit=!0,n=!0,_.cancel(),v=this.trimResultToSize(v,this.query.maxResults-this.resultCount));const T=this.resultSize(v);this.resultCount+=T,(T>0||!l(v))&&this.collector.add(v,I)}};Promise.all(w.map((v,I)=>this.searchInFolder(v,h=>s(h,I),_.token))).then(v=>{_.dispose(),this.collector.flush();const I=v.some(h=>!!h&&!!h.limitHit);i({limitHit:this.isLimitHit||I,messages:(0,m.flatten)(v.map(h=>h?.message?Array.isArray(h.message)?h.message:[h.message]:[])),stats:{type:this.processType}})},v=>{_.dispose();const I=(0,M.toErrorMessage)(v);u(new Error(I))})})}resultSize(c){return l(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,b){const w=Array.isArray(c.ranges)?c.ranges:[c.ranges],_=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:w.slice(0,b),preview:{matches:_.slice(0,b),text:c.preview.text},uri:c.uri}}async searchInFolder(c,b,w){const _=new R.QueryGlobTester(this.query,c),i=[],u={report:v=>{if(!this.validateProviderResult(v))return;const I=c.folder.scheme===F.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(D.dirname(v.uri))):void 0,h=D.relativePath(c.folder,v.uri);if(h){const T=_.includedInQuery(h,f.basename(h),I);(0,k.isThenable)(T)?i.push(T.then(S=>{S&&b(v)})):T&&b(v)}}},n=this.getSearchOptionsForFolder(c),s=await this.provider.provideTextSearchResults(d(this.query.contentPattern),n,u,w);return i.length&&await Promise.all(i),s}validateProviderResult(c){if(l(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const b=(0,R.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),w=(0,R.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),_={folder:g.URI.from(c.folder),excludes:w,includes:b,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return _.usePCRE2=this.query.usePCRE2,_}}e.TextSearchManager=y;function d(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class E{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new t(512,b=>this.sendItems(b))}add(c,b){this._currentFileMatch&&(this._currentFolderIdx!==b||!D.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=b,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(p(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=E;function p(r){return l(r)?{preview:{matches:(0,m.mapArrayOrNot)(r.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:r.preview.text},ranges:(0,m.mapArrayOrNot)(r.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function l(r){return!!r.preview}e.extensionResultIsMatch=l;class t{constructor(c,b){this.maxBatchSize=c,this.cb=b,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,b){c&&this.addItemToBatch(c,b)}addItems(c,b){c&&this.addItemsToBatch(c,b)}addItemToBatch(c,b){this.batch.push(c),this.batchSize+=b,this.onUpdate()}addItemsToBatch(c,b){this.batch=this.batch.concat(c),this.batchSize+=b,this.onUpdate()}onUpdate(){this.totalNumberCompleted<t.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},t.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=t,t.TIMEOUT=4e3,t.START_BATCH_AFTER_COUNT=50}),define(Ae[114],Re([1,0,6,4,3,260,17,55,15,2,265]),function(te,e,m,k,C,M,F,f,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let y=e.ExtHostSearch=class{constructor(l,t,r){this.extHostRpc=l,this._uriTransformer=t,this._logService=r,this._proxy=this.extHostRpc.getProxy(k.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new M.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,t){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const r=this._handlePool++;return this._textSearchProvider.set(r,t),this._proxy.$registerTextSearchProvider(r,this._transformScheme(l)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(r),this._proxy.$unregisterProvider(r)})}registerFileSearchProvider(l,t){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const r=this._handlePool++;return this._fileSearchProvider.set(r,t),this._proxy.$registerFileSearchProvider(r,this._transformScheme(l)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(r),this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(l,t,r,c){const b=d(r),w=this._fileSearchProvider.get(l);if(w)return this._fileSearchManager.fileSearch(b,w,_=>{this._proxy.$handleFileMatch(l,t,_.map(i=>i.resource))},c);throw new Error("unknown provider: "+l)}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,t,r,c){const b=this._textSearchProvider.get(l);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const w=d(r);return this.createTextSearchManager(w,b).search(i=>this._proxy.$handleTextMatch(l,t,i),c)}$enableExtensionHostSearch(){}createTextSearchManager(l,t){return new R.TextSearchManager(l,t,{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}};e.ExtHostSearch=y=Ve([He(0,F.IExtHostRpcService),He(1,f.IURITransformerService),He(2,D.ILogService)],y);function d(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(E),extraFileResources:p.extraFileResources&&p.extraFileResources.map(l=>g.URI.revive(l))}}e.reviveQuery=d;function E(p){return{...p,folder:g.URI.revive(p.folder)}}}),define(Ae[266],Re([1,0,22,9,5,29,2,135,276,124,133,38,4,80,219,218,32,220,34,222,223,224,202,225,59,35,226,227,232,233,235,109,206,241,242,245,85,62,247,207,8,7,52,250,63,108,33,24,197,231,50,107,111,113,114,15,55,17,27,236,195,75,81,215,248,86,61,253,251,252,216,39,246,249,84,60,57,237,110,238,14,95,205,188,229,6,26,193,82,184,239,240,217,228,204,243,230,83,244]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l,t,r,c,b,w,_,i,u,n,s,v,I,h,T,S,a,o,O,$,K,V,z,N,q,B,U,le,ve,Pe,J,X,ce,De,ke,ge,A,G,de,ye,_e,pe,Ce,ae,ue,ne,ee,P,W,H,j,re,he,ie,we,Se,$e,ze,Je,qe,Ge,it,ct,et,rt,Ue,st,Z,Y,me,Be,Ne,Qe,tt,pt,bt,Ot,Kt,zt,_t,xt,Lt,Nt,Wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ht(at){const ft=at.get(ae.IExtHostInitDataService),Bt=at.get($e.IExtHostFileSystemInfo),At=at.get(re.IExtHostConsumerFileSystem),Ct=at.get(s.IExtHostExtensionService),lt=at.get(X.IExtHostWorkspace),kt=at.get(it.IExtHostTelemetry),Ft=at.get(c.IExtHostConfiguration),Te=at.get(pe.IURITransformerService),be=at.get(Ce.IExtHostRpcService),Ee=at.get(V.IExtHostStorage),Q=at.get(j.IExtensionStoragePaths),Oe=at.get(_e.ILoggerService),xe=at.get(_e.ILogService),Ke=at.get(ee.IExtHostTunnelService),We=at.get(P.IExtHostApiDeprecationService),Ze=at.get(J.IExtHostWindow),St=at.get(qe.IExtHostSecretState),It=at.get(Ge.IExtHostEditorTabs),Pt=at.get(Nt.IExtHostManagedSockets);be.set(d.ExtHostContext.ExtHostFileSystemInfo,Bt),be.set(d.ExtHostContext.ExtHostLogLevelServiceShape,Oe),be.set(d.ExtHostContext.ExtHostWorkspace,lt),be.set(d.ExtHostContext.ExtHostConfiguration,Ft),be.set(d.ExtHostContext.ExtHostExtensionService,Ct),be.set(d.ExtHostContext.ExtHostStorage,Ee),be.set(d.ExtHostContext.ExtHostTunnelService,Ke),be.set(d.ExtHostContext.ExtHostWindow,Ze),be.set(d.ExtHostContext.ExtHostSecretState,St),be.set(d.ExtHostContext.ExtHostTelemetry,kt),be.set(d.ExtHostContext.ExtHostEditorTabs,It),be.set(d.ExtHostContext.ExtHostManagedSockets,Pt);const gt=be.set(d.ExtHostContext.ExtHostDecorations,at.get(A.IExtHostDecorations)),vt=be.set(d.ExtHostContext.ExtHostDocumentsAndEditors,at.get(n.IExtHostDocumentsAndEditors)),ht=be.set(d.ExtHostContext.ExtHostCommands,at.get(t.IExtHostCommands)),wt=be.set(d.ExtHostContext.ExtHostTerminalService,at.get(z.IExtHostTerminalService)),Et=be.set(d.ExtHostContext.ExtHostDebugService,at.get(de.IExtHostDebugService)),Qt=be.set(d.ExtHostContext.ExtHostSearch,at.get(ye.IExtHostSearch)),$t=be.set(d.ExtHostContext.ExtHostTask,at.get(G.IExtHostTask)),ni=be.set(d.ExtHostContext.ExtHostOutputService,at.get(a.IExtHostOutputService)),ai=be.set(d.ExtHostContext.ExtHostLocalization,at.get(tt.IExtHostLocalizationService)),_i=be.set(d.ExtHostContext.ExtHostUrls,new ve.ExtHostUrls(be)),Tt=be.set(d.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(be,vt)),ci=be.set(d.ExtHostContext.ExtHostDocumentContentProviders,new _.ExtHostDocumentContentProvider(be,vt,xe)),fi=be.set(d.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(xe,Tt,be.getProxy(d.MainContext.MainThreadBulkEdits))),Dt=be.set(d.ExtHostContext.ExtHostNotebook,new ue.ExtHostNotebookController(be,ht,vt,Tt,At)),Si=be.set(d.ExtHostContext.ExtHostNotebookDocuments,new Y.ExtHostNotebookDocuments(Dt)),Fi=be.set(d.ExtHostContext.ExtHostNotebookEditors,new Z.ExtHostNotebookEditors(xe,Dt)),mi=be.set(d.ExtHostContext.ExtHostNotebookKernels,new ct.ExtHostNotebookKernels(be,ft,Dt,ht,xe)),Oi=be.set(d.ExtHostContext.ExtHostNotebookRenderers,new rt.ExtHostNotebookRenderers(be,Dt)),Li=be.set(d.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new _t.ExtHostNotebookDocumentSaveParticipant(xe,Dt,be.getProxy(d.MainContext.MainThreadBulkEdits))),Mt=be.set(d.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(be,vt)),Gt=be.set(d.ExtHostContext.ExtHostTreeViews,new q.ExtHostTreeViews(be.getProxy(d.MainContext.MainThreadTreeViews),ht,xe)),Mi=be.set(d.ExtHostContext.ExtHostEditorInsets,new De.ExtHostEditorInsets(be.getProxy(d.MainContext.MainThreadEditorInsets),Mt,ft.remote)),li=be.set(d.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(be,xe,Bt,vt)),ui=be.set(d.ExtHostContext.ExtHostLanguages,new T.ExtHostLanguages(be,Tt,ht.converter,Te)),ut=be.set(d.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(be,Te,Tt,ht,li,xe,We,kt)),an=be.set(d.ExtHostContext.ExtHostFileSystem,new v.ExtHostFileSystem(be,ut)),Vt=be.set(d.ExtHostContext.ExtHostFileSystemEventService,new I.ExtHostFileSystemEventService(be,xe,vt)),ri=be.set(d.ExtHostContext.ExtHostQuickOpen,(0,O.createExtHostQuickOpen)(be,lt,ht)),yi=be.set(d.ExtHostContext.ExtHostSCM,new $.ExtHostSCM(be,ht,Tt,xe)),Ni=be.set(d.ExtHostContext.ExtHostQuickDiff,new Ot.ExtHostQuickDiff(be,Te)),Ui=be.set(d.ExtHostContext.ExtHostShare,new Wt.ExtHostShare(be,Te)),xi=be.set(d.ExtHostContext.ExtHostComments,(0,r.createExtHostComments)(be,ht,Tt)),Di=be.set(d.ExtHostContext.ExtHostProgress,new o.ExtHostProgress(be.getProxy(d.MainContext.MainThreadProgress))),Bi=be.set(d.ExtHostContext.ExtHosLabelService,new ke.ExtHostLabelService(be)),Ci=be.set(d.ExtHostContext.ExtHostTheming,new ne.ExtHostTheming(be)),si=be.set(d.ExtHostContext.ExtHostAuthentication,new W.ExtHostAuthentication(be)),$i=be.set(d.ExtHostContext.ExtHostTimeline,new H.ExtHostTimeline(be,ht)),gi=be.set(d.ExtHostContext.ExtHostWebviews,new Pe.ExtHostWebviews(be,ft.remote,lt,xe,We)),pi=be.set(d.ExtHostContext.ExtHostWebviewPanels,new we.ExtHostWebviewPanels(be,gi,lt)),zi=be.set(d.ExtHostContext.ExtHostCustomEditors,new ie.ExtHostCustomEditors(be,Tt,Q,gi,pi)),Wi=be.set(d.ExtHostContext.ExtHostWebviewViews,new he.ExtHostWebviewViews(be,gi)),oi=be.set(d.ExtHostContext.ExtHostTesting,new ze.ExtHostTesting(be,ht,vt)),Hi=be.set(d.ExtHostContext.ExtHostUriOpeners,new Je.ExtHostUriOpeners(be)),Vi=be.set(d.ExtHostContext.ExtHostProfileContentHandlers,new bt.ExtHostProfileContentHandlers(be));be.set(d.ExtHostContext.ExtHostInteractive,new me.ExtHostInteractive(be,Dt,vt,ht,xe));const ji=be.set(d.ExtHostContext.ExtHostInlineChat,new zt.ExtHostInteractiveEditor(be,ht,Tt,xe)),ei=be.set(d.ExtHostContext.ExtHostChat,new Kt.ExtHostChat(be,xe)),qi=be.set(d.ExtHostContext.ExtHostSemanticSimilarity,new xt.ExtHostSemanticSimilarity(be)),Ki=be.set(d.ExtHostContext.ExtHostIssueReporter,new Lt.ExtHostIssueReporter(be)),Ii=be.set(d.ExtHostContext.ExtHostStatusBar,new K.ExtHostStatusBar(be,ht.converter)),Gi=Object.values(d.ExtHostContext);be.assertRegistered(Gi);const cn=new Se.ExtHostBulkEdits(be,vt),ln=new l.ExtHostClipboard(be),di=new S.ExtHostMessageService(be,xe),vi=new w.ExtHostDialogs(be);return p.ExtHostApiCommands.register(ht),function(Me,Yt,ki){const mt=function(){let se=!Me.isUnderDevelopment;function fe(){se||(xe.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Le(nt){if(Array.isArray(nt))nt.forEach(Le);else if(typeof nt=="string")fe();else{const yt=nt;typeof yt.scheme>"u"&&fe(),typeof yt.exclusive=="boolean"&&(0,Ne.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return nt}}(),Xi={getSession(se,fe,Le){return si.getSession(Me,se,fe,Le)},getSessions(se,fe){return(0,Ne.checkProposedApiEnabled)(Me,"authGetSessions"),si.getSessions(Me,se,fe)},async hasSession(se,fe){return(0,Ne.checkProposedApiEnabled)(Me,"authSession"),!!await si.getSession(Me,se,fe,{silent:!0})},get onDidChangeSessions(){return si.onDidChangeSessions},registerAuthenticationProvider(se,fe,Le,nt){return si.registerAuthenticationProvider(se,fe,Le,nt)}},Qi={registerCommand(se,fe,Le){return ht.registerCommand(!0,se,fe,Le,void 0,Me)},registerTextEditorCommand(se,fe,Le){return ht.registerCommand(!0,se,(...nt)=>{const yt=Mt.getActiveTextEditor();if(!yt){xe.warn("Cannot execute "+se+" because there is no active text editor.");return}return yt.edit(Rt=>{fe.apply(Le,[yt,Rt,...nt])}).then(Rt=>{Rt||xe.warn("Edits from command "+se+" were not applied.")},Rt=>{xe.warn("An error occurred while running command "+se,Rt)})},void 0,void 0,Me)},registerDiffInformationCommand:(se,fe,Le)=>((0,Ne.checkProposedApiEnabled)(Me,"diffCommand"),ht.registerCommand(!0,se,async(...nt)=>{const yt=vt.activeEditor(!0);if(!yt){xe.warn("Cannot execute "+se+" because there is no active text editor.");return}const Rt=await Mt.getDiffInformation(yt.id);fe.apply(Le,[Rt,...nt])},void 0,void 0,Me)),executeCommand(se,...fe){return ht.executeCommand(se,...fe)},getCommands(se=!1){return ht.getCommands(se)}},Pi={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return wt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ne.checkProposedApiEnabled)(Me,"envShellEvent"),wt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.checkProposedApiEnabled)(Me,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.checkProposedApiEnabled)(Me,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,it.isNewAppInstall)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(se,fe){return it.ExtHostTelemetryLogger.validateSender(se),kt.instantiateLogger(Me,se,fe)},openExternal(se,fe){return Ze.openUri(se,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===ft.environment.appUriScheme)return _i.createAppUri(se);try{return await Ze.asExternalUri(se,{allowTunneling:!!ft.remote.authority})}catch(fe){if((0,st.matchesScheme)(se,Ue.Schemas.http)||(0,st.matchesScheme)(se,Ue.Schemas.https))return se;throw fe}},get remoteName(){return(0,ge.getRemoteName)(ft.remote.authority)},get remoteAuthority(){return(0,Ne.checkProposedApiEnabled)(Me,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return xe.getLevel()},get onDidChangeLogLevel(){return xe.onDidChangeLogLevel},registerIssueUriRequestHandler(se){return(0,Ne.checkProposedApiEnabled)(Me,"handleIssueUri"),Ki.registerIssueUriRequestHandler(Me,se)},get appQuality(){return(0,Ne.checkProposedApiEnabled)(Me,"resolvers"),ft.quality},get appCommit(){return(0,Ne.checkProposedApiEnabled)(Me,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(Pi);const un={createTestController(se,fe,Le){return oi.createTestController(Me,se,fe,Le)},createTestObserver(){return(0,Ne.checkProposedApiEnabled)(Me,"testObserver"),oi.createTestObserver()},runTests(se){return(0,Ne.checkProposedApiEnabled)(Me,"testObserver"),oi.runTests(se)},get onDidChangeTestResults(){return(0,Ne.checkProposedApiEnabled)(Me,"testObserver"),oi.onResultsChanged},get testResults(){return(0,Ne.checkProposedApiEnabled)(Me,"testObserver"),oi.results}},hi=ft.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Yi={getExtension(se,fe){(0,Ne.isProposedApiEnabled)(Me,"extensionsAny")||(fe=!1);const Le=Yt.mine.getExtensionDescription(se);if(Le)return new s.Extension(Ct,Me.identifier,Le,hi,!1);if(fe){const nt=Yt.all.getExtensionDescription(se);if(nt)return new s.Extension(Ct,Me.identifier,nt,hi,!0)}},get all(){const se=[];for(const fe of Yt.mine.getAllExtensionDescriptions())se.push(new s.Extension(Ct,Me.identifier,fe,hi,!1));return se},get allAcrossExtensionHosts(){(0,Ne.checkProposedApiEnabled)(Me,"extensionsAny");const se=new ce.ExtensionIdentifierSet(Yt.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),fe=[];for(const Le of Yt.all.getAllExtensionDescriptions()){const nt=!se.has(Le.identifier);fe.push(new s.Extension(Ct,Me.identifier,Le,hi,nt))}return fe},get onDidChange(){return(0,Ne.isProposedApiEnabled)(Me,"extensionsAny")?C.Event.any(Yt.mine.onDidChange,Yt.all.onDidChange):Yt.mine.onDidChange}},Jt={createDiagnosticCollection(se){return li.createDiagnosticCollection(Me.identifier,se)},get onDidChangeDiagnostics(){return li.onDidChangeDiagnostics},getDiagnostics:se=>li.getDiagnostics(se),getLanguages(){return ui.getLanguages()},setTextDocumentLanguage(se,fe){return ui.changeLanguage(se.uri,fe)},match(se,fe){const Le=Tt.getDocumentData(fe.uri)?.notebook;return(0,R.score)(B.LanguageSelector.from(se),fe.uri,fe.languageId,!0,Le?.uri,Le?.notebookType)},registerCodeActionsProvider(se,fe,Le){return ut.registerCodeActionProvider(Me,mt(se),fe,Le)},registerDocumentPasteEditProvider(se,fe,Le){return(0,Ne.checkProposedApiEnabled)(Me,"documentPaste"),ut.registerDocumentPasteEditProvider(Me,mt(se),fe,Le)},registerCodeLensProvider(se,fe){return ut.registerCodeLensProvider(Me,mt(se),fe)},registerDefinitionProvider(se,fe){return ut.registerDefinitionProvider(Me,mt(se),fe)},registerDeclarationProvider(se,fe){return ut.registerDeclarationProvider(Me,mt(se),fe)},registerImplementationProvider(se,fe){return ut.registerImplementationProvider(Me,mt(se),fe)},registerTypeDefinitionProvider(se,fe){return ut.registerTypeDefinitionProvider(Me,mt(se),fe)},registerHoverProvider(se,fe){return ut.registerHoverProvider(Me,mt(se),fe,Me.identifier)},registerEvaluatableExpressionProvider(se,fe){return ut.registerEvaluatableExpressionProvider(Me,mt(se),fe,Me.identifier)},registerInlineValuesProvider(se,fe){return ut.registerInlineValuesProvider(Me,mt(se),fe,Me.identifier)},registerDocumentHighlightProvider(se,fe){return ut.registerDocumentHighlightProvider(Me,mt(se),fe)},registerLinkedEditingRangeProvider(se,fe){return ut.registerLinkedEditingRangeProvider(Me,mt(se),fe)},registerReferenceProvider(se,fe){return ut.registerReferenceProvider(Me,mt(se),fe)},registerRenameProvider(se,fe){return ut.registerRenameProvider(Me,mt(se),fe)},registerDocumentSymbolProvider(se,fe,Le){return ut.registerDocumentSymbolProvider(Me,mt(se),fe,Le)},registerWorkspaceSymbolProvider(se){return ut.registerWorkspaceSymbolProvider(Me,se)},registerDocumentFormattingEditProvider(se,fe){return ut.registerDocumentFormattingEditProvider(Me,mt(se),fe)},registerDocumentRangeFormattingEditProvider(se,fe){return ut.registerDocumentRangeFormattingEditProvider(Me,mt(se),fe)},registerOnTypeFormattingEditProvider(se,fe,Le,...nt){return ut.registerOnTypeFormattingEditProvider(Me,mt(se),fe,[Le].concat(nt))},registerDocumentSemanticTokensProvider(se,fe,Le){return ut.registerDocumentSemanticTokensProvider(Me,mt(se),fe,Le)},registerDocumentRangeSemanticTokensProvider(se,fe,Le){return ut.registerDocumentRangeSemanticTokensProvider(Me,mt(se),fe,Le)},registerSignatureHelpProvider(se,fe,Le,...nt){return typeof Le=="object"?ut.registerSignatureHelpProvider(Me,mt(se),fe,Le):ut.registerSignatureHelpProvider(Me,mt(se),fe,typeof Le>"u"?[]:[Le,...nt])},registerCompletionItemProvider(se,fe,...Le){return ut.registerCompletionItemProvider(Me,mt(se),fe,Le)},registerInlineCompletionItemProvider(se,fe){return fe.handleDidShowCompletionItem&&(0,Ne.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Ne.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Me,mt(se),fe)},registerDocumentLinkProvider(se,fe){return ut.registerDocumentLinkProvider(Me,mt(se),fe)},registerColorProvider(se,fe){return ut.registerColorProvider(Me,mt(se),fe)},registerFoldingRangeProvider(se,fe){return ut.registerFoldingRangeProvider(Me,mt(se),fe)},registerSelectionRangeProvider(se,fe){return ut.registerSelectionRangeProvider(Me,se,fe)},registerCallHierarchyProvider(se,fe){return ut.registerCallHierarchyProvider(Me,se,fe)},registerTypeHierarchyProvider(se,fe){return ut.registerTypeHierarchyProvider(Me,se,fe)},setLanguageConfiguration:(se,fe)=>ut.setLanguageConfiguration(Me,se,fe),getTokenInformationAtPosition(se,fe){return(0,Ne.checkProposedApiEnabled)(Me,"tokenInformation"),ui.tokenAtPosition(se,fe)},registerInlayHintsProvider(se,fe){return ut.registerInlayHintsProvider(Me,se,fe)},createLanguageStatusItem(se,fe){return ui.createLanguageStatusItem(Me,se,fe)},registerDocumentDropEditProvider(se,fe,Le){return ut.registerDocumentOnDropEditProvider(Me,se,fe,(0,Ne.isProposedApiEnabled)(Me,"dropMetadata")?Le:void 0)}},Ei={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(se,fe,Le){const nt=await(F.URI.isUri(se)?Promise.resolve(Ji.openTextDocument(se)):Promise.resolve(se));return Mt.showTextDocument(nt,fe,Le)},createTextEditorDecorationType(se){return Mt.createTextEditorDecorationType(Me,se)},onDidChangeActiveTextEditor(se,fe,Le){return Mt.onDidChangeActiveTextEditor(se,fe,Le)},onDidChangeVisibleTextEditors(se,fe,Le){return Mt.onDidChangeVisibleTextEditors(se,fe,Le)},onDidChangeTextEditorSelection(se,fe,Le){return Mt.onDidChangeTextEditorSelection(se,fe,Le)},onDidChangeTextEditorOptions(se,fe,Le){return Mt.onDidChangeTextEditorOptions(se,fe,Le)},onDidChangeTextEditorVisibleRanges(se,fe,Le){return Mt.onDidChangeTextEditorVisibleRanges(se,fe,Le)},onDidChangeTextEditorViewColumn(se,fe,Le){return Mt.onDidChangeTextEditorViewColumn(se,fe,Le)},onDidCloseTerminal(se,fe,Le){return wt.onDidCloseTerminal(se,fe,Le)},onDidOpenTerminal(se,fe,Le){return wt.onDidOpenTerminal(se,fe,Le)},onDidChangeActiveTerminal(se,fe,Le){return wt.onDidChangeActiveTerminal(se,fe,Le)},onDidChangeTerminalDimensions(se,fe,Le){return(0,Ne.checkProposedApiEnabled)(Me,"terminalDimensions"),wt.onDidChangeTerminalDimensions(se,fe,Le)},onDidChangeTerminalState(se,fe,Le){return wt.onDidChangeTerminalState(se,fe,Le)},onDidWriteTerminalData(se,fe,Le){return(0,Ne.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),wt.onDidWriteTerminalData(se,fe,Le)},get state(){return Ze.getState(Me)},onDidChangeWindowState(se,fe,Le){return Ze.onDidChangeWindowState(se,fe,Le)},showInformationMessage(se,...fe){return di.showMessage(Me,M.default.Info,se,fe[0],fe.slice(1))},showWarningMessage(se,...fe){return di.showMessage(Me,M.default.Warning,se,fe[0],fe.slice(1))},showErrorMessage(se,...fe){return di.showMessage(Me,M.default.Error,se,fe[0],fe.slice(1))},showQuickPick(se,fe,Le){return ri.showQuickPick(Me,se,fe,Le)},showWorkspaceFolderPick(se){return ri.showWorkspaceFolderPick(se)},showInputBox(se,fe){return ri.showInput(se,fe)},showOpenDialog(se){return vi.showOpenDialog(Me,se)},showSaveDialog(se){return vi.showSaveDialog(se)},createStatusBarItem(se,fe,Le){let nt,yt,Rt;return typeof se=="string"?(nt=se,yt=fe,Rt=Le):(yt=se,Rt=fe),Ii.createStatusBarEntry(Me,nt,yt,Rt)},setStatusBarMessage(se,fe){return Ii.setStatusBarMessage(se,fe)},withScmProgress(se){return We.report("window.withScmProgress",Me,"Use 'withProgress' instead."),Di.withProgress(Me,{location:U.ProgressLocation.SourceControl},(fe,Le)=>se({report(nt){}}))},withProgress(se,fe){return Di.withProgress(Me,se,fe)},createOutputChannel(se,fe){return ni.createOutputChannel(se,fe,Me)},createWebviewPanel(se,fe,Le,nt){return pi.createWebviewPanel(Me,se,fe,Le,nt)},createWebviewTextEditorInset(se,fe,Le,nt){return(0,Ne.checkProposedApiEnabled)(Me,"editorInsets"),Mi.createWebviewEditorInset(se,fe,Le,nt,Me)},createTerminal(se,fe,Le){return typeof se=="object"?"pty"in se?wt.createExtensionTerminal(se):wt.createTerminalFromOptions(se):wt.createTerminal(se,fe,Le)},registerTerminalLinkProvider(se){return wt.registerLinkProvider(se)},registerTerminalProfileProvider(se,fe){return wt.registerProfileProvider(Me,se,fe)},registerTerminalQuickFixProvider(se,fe){return(0,Ne.checkProposedApiEnabled)(Me,"terminalQuickFixProvider"),wt.registerTerminalQuickFixProvider(se,Me.identifier.value,fe)},registerTreeDataProvider(se,fe){return Gt.registerTreeDataProvider(se,fe,Me)},createTreeView(se,fe){return Gt.createTreeView(se,fe,Me)},registerWebviewPanelSerializer:(se,fe)=>pi.registerWebviewPanelSerializer(Me,se,fe),registerCustomEditorProvider:(se,fe,Le={})=>zi.registerCustomEditorProvider(Me,se,fe,Le),registerFileDecorationProvider(se){return gt.registerFileDecorationProvider(se,Me)},registerUriHandler(se){return _i.registerUriHandler(Me,se)},createQuickPick(){return ri.createQuickPick(Me)},createInputBox(){return ri.createInputBox(Me)},get activeColorTheme(){return Ci.activeColorTheme},onDidChangeActiveColorTheme(se,fe,Le){return Ci.onDidChangeActiveColorTheme(se,fe,Le)},registerWebviewViewProvider(se,fe,Le){return Wi.registerWebviewViewProvider(Me,se,fe,Le?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,fe,Le){return Dt.onDidChangeActiveNotebookEditor(se,fe,Le)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,fe,Le){return Fi.onDidChangeNotebookEditorSelection(se,fe,Le)},onDidChangeNotebookEditorVisibleRanges(se,fe,Le){return Fi.onDidChangeNotebookEditorVisibleRanges(se,fe,Le)},showNotebookDocument(se,fe){return Dt.showNotebookDocument(se,fe)},registerExternalUriOpener(se,fe,Le){return(0,Ne.checkProposedApiEnabled)(Me,"externalUriOpener"),Hi.registerExternalUriOpener(Me.identifier,se,fe,Le)},registerProfileContentHandler(se,fe){return(0,Ne.checkProposedApiEnabled)(Me,"profileContentHandlers"),Vi.registrProfileContentHandler(Me,se,fe)},registerQuickDiffProvider(se,fe,Le,nt){return(0,Ne.checkProposedApiEnabled)(Me,"quickDiffProvider"),Ni.registerQuickDiffProvider(mt(se),fe,Le,nt)},get tabGroups(){return It.tabGroups},registerShareProvider(se,fe){return(0,Ne.checkProposedApiEnabled)(Me,"shareProvider"),Ui.registerShareProvider(mt(se),fe)}},Ji={get rootPath(){return We.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),lt.getPath()},set rootPath(se){throw k.readonly()},getWorkspaceFolder(se){return lt.getWorkspaceFolder(se)},get workspaceFolders(){return lt.getWorkspaceFolders()},get name(){return lt.name},set name(se){throw k.readonly()},get workspaceFile(){return lt.workspaceFile},set workspaceFile(se){throw k.readonly()},updateWorkspaceFolders:(se,fe,...Le)=>lt.updateWorkspaceFolders(Me,se,fe||0,...Le),onDidChangeWorkspaceFolders:function(se,fe,Le){return lt.onDidChangeWorkspace(se,fe,Le)},asRelativePath:(se,fe)=>lt.getRelativePath(se,fe),findFiles:(se,fe,Le,nt)=>lt.findFiles(se,fe,Le,Me.identifier,nt),findTextInFiles:(se,fe,Le,nt)=>{(0,Ne.checkProposedApiEnabled)(Me,"findTextInFiles");let yt,Rt;return typeof fe=="object"?(yt=fe,Rt=Le):(yt={},Rt=fe,nt=Le),lt.findTextInFiles(se,yt||{},Rt,Me.identifier,nt)},save:se=>((0,Ne.checkProposedApiEnabled)(Me,"saveEditor"),lt.save(se)),saveAs:se=>((0,Ne.checkProposedApiEnabled)(Me,"saveEditor"),lt.saveAs(se)),saveAll:se=>lt.saveAll(se),applyEdit(se,fe){return cn.applyWorkspaceEdit(se,Me,fe)},createFileSystemWatcher:(se,fe,Le,nt)=>Vt.createFileSystemWatcher(lt,Me,se,fe,Le,nt),get textDocuments(){return Tt.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw k.readonly()},openTextDocument(se){let fe;const Le=se;if(typeof se=="string")fe=Promise.resolve(F.URI.file(se));else if(F.URI.isUri(se))fe=Promise.resolve(se);else if(!Le||typeof Le=="object")fe=Tt.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(nt=>Tt.ensureDocumentData(nt).then(yt=>yt.document))},onDidOpenTextDocument:(se,fe,Le)=>Tt.onDidAddDocument(se,fe,Le),onDidCloseTextDocument:(se,fe,Le)=>Tt.onDidRemoveDocument(se,fe,Le),onDidChangeTextDocument:(se,fe,Le)=>Tt.onDidChangeDocument(se,fe,Le),onDidSaveTextDocument:(se,fe,Le)=>Tt.onDidSaveDocument(se,fe,Le),onWillSaveTextDocument:(se,fe,Le)=>fi.getOnWillSaveTextDocumentEvent(Me)(se,fe,Le),get notebookDocuments(){return Dt.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,fe){let Le;if(F.URI.isUri(se))Le=se,await Dt.openNotebookDocument(se);else if(typeof se=="string")Le=F.URI.revive(await Dt.createNotebookDocument({viewType:se,content:fe}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(se,fe,Le){return Si.onDidSaveNotebookDocument(se,fe,Le)},onDidChangeNotebookDocument(se,fe,Le){return Si.onDidChangeNotebookDocument(se,fe,Le)},onWillSaveNotebookDocument(se,fe,Le){return Li.getOnWillSaveNotebookDocumentEvent(Me)(se,fe,Le)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer(se,fe,Le,nt){return Dt.registerNotebookSerializer(Me,se,fe,Le,(0,Ne.isProposedApiEnabled)(Me,"notebookLiveShare")?nt:void 0)},onDidChangeConfiguration:(se,fe,Le)=>ki.onDidChangeConfiguration(se,fe,Le),getConfiguration(se,fe){return fe=arguments.length===1?void 0:fe,ki.getConfiguration(se,fe,Me)},registerTextDocumentContentProvider(se,fe){return ci.registerTextDocumentContentProvider(se,fe)},registerTaskProvider:(se,fe)=>(We.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),$t.registerTaskProvider(Me,se,fe)),registerFileSystemProvider(se,fe,Le){return(0,Be.combinedDisposable)(an.registerFileSystemProvider(Me,se,fe,Le),At.addFileSystemProvider(se,fe,Le))},get fs(){return At.value},registerFileSearchProvider:(se,fe)=>((0,Ne.checkProposedApiEnabled)(Me,"fileSearchProvider"),Qt.registerFileSearchProvider(se,fe)),registerTextSearchProvider:(se,fe)=>((0,Ne.checkProposedApiEnabled)(Me,"textSearchProvider"),Qt.registerTextSearchProvider(se,fe)),registerRemoteAuthorityResolver:(se,fe)=>((0,Ne.checkProposedApiEnabled)(Me,"resolvers"),Ct.registerRemoteAuthorityResolver(se,fe)),registerResourceLabelFormatter:se=>((0,Ne.checkProposedApiEnabled)(Me,"resolvers"),Bi.$registerResourceLabelFormatter(se)),getRemoteExecServer:se=>((0,Ne.checkProposedApiEnabled)(Me,"resolvers"),Ct.getRemoteExecServer(se)),onDidCreateFiles:(se,fe,Le)=>Vt.onDidCreateFile(se,fe,Le),onDidDeleteFiles:(se,fe,Le)=>Vt.onDidDeleteFile(se,fe,Le),onDidRenameFiles:(se,fe,Le)=>Vt.onDidRenameFile(se,fe,Le),onWillCreateFiles:(se,fe,Le)=>Vt.getOnWillCreateFileEvent(Me)(se,fe,Le),onWillDeleteFiles:(se,fe,Le)=>Vt.getOnWillDeleteFileEvent(Me)(se,fe,Le),onWillRenameFiles:(se,fe,Le)=>Vt.getOnWillRenameFileEvent(Me)(se,fe,Le),openTunnel:se=>((0,Ne.checkProposedApiEnabled)(Me,"tunnels"),Ke.openTunnel(Me,se).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Ne.checkProposedApiEnabled)(Me,"tunnels"),Ke.getTunnels()},onDidChangeTunnels:(se,fe,Le)=>((0,Ne.checkProposedApiEnabled)(Me,"tunnels"),Ke.onDidChangeTunnels(se,fe,Le)),registerPortAttributesProvider:(se,fe)=>((0,Ne.checkProposedApiEnabled)(Me,"portsAttributes"),Ke.registerPortsAttributesProvider(se,fe)),registerTimelineProvider:(se,fe)=>((0,Ne.checkProposedApiEnabled)(Me,"timeline"),$i.registerTimelineProvider(se,fe,Me.identifier,ht.converter)),get isTrusted(){return lt.trusted},requestWorkspaceTrust:se=>((0,Ne.checkProposedApiEnabled)(Me,"workspaceTrust"),lt.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,fe,Le)=>lt.onDidGrantWorkspaceTrust(se,fe,Le),registerEditSessionIdentityProvider:(se,fe)=>((0,Ne.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),lt.registerEditSessionIdentityProvider(se,fe)),onWillCreateEditSessionIdentity:(se,fe,Le)=>((0,Ne.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),lt.getOnWillCreateEditSessionIdentityEvent(Me)(se,fe,Le)),registerCanonicalUriProvider:(se,fe)=>((0,Ne.checkProposedApiEnabled)(Me,"canonicalUriProvider"),lt.registerCanonicalUriProvider(se,fe)),getCanonicalUri:(se,fe,Le)=>((0,Ne.checkProposedApiEnabled)(Me,"canonicalUriProvider"),lt.provideCanonicalUri(se,fe,Le))},jt={get inputBox(){return We.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),yi.getLastInputBox(Me)},createSourceControl(se,fe,Le){return yi.createSourceControl(Me,se,fe,Le)}},wi={createCommentController(se,fe){return xi.createCommentController(Me,se,fe)}},Zi={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get stackFrameFocus(){return Et.stackFrameFocus},onDidStartDebugSession(se,fe,Le){return Et.onDidStartDebugSession(se,fe,Le)},onDidTerminateDebugSession(se,fe,Le){return Et.onDidTerminateDebugSession(se,fe,Le)},onDidChangeActiveDebugSession(se,fe,Le){return Et.onDidChangeActiveDebugSession(se,fe,Le)},onDidReceiveDebugSessionCustomEvent(se,fe,Le){return Et.onDidReceiveDebugSessionCustomEvent(se,fe,Le)},onDidChangeBreakpoints(se,fe,Le){return Et.onDidChangeBreakpoints(se,fe,Le)},onDidChangeStackFrameFocus(se,fe,Le){return(0,Ne.checkProposedApiEnabled)(Me,"debugFocus"),Et.onDidChangeStackFrameFocus(se,fe,Le)},registerDebugConfigurationProvider(se,fe,Le){return Et.registerDebugConfigurationProvider(se,fe,Le||Qe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,fe){return Et.registerDebugAdapterDescriptorFactory(Me,se,fe)},registerDebugAdapterTrackerFactory(se,fe){return Et.registerDebugAdapterTrackerFactory(se,fe)},startDebugging(se,fe,Le){return!Le||typeof Le=="object"&&"configuration"in Le?Et.startDebugging(se,fe,{parentSession:Le}):Et.startDebugging(se,fe,Le||{})},stopDebugging(se){return Et.stopDebugging(se)},addBreakpoints(se){return Et.addBreakpoints(se)},removeBreakpoints(se){return Et.removeBreakpoints(se)},asDebugSourceUri(se,fe){return Et.asDebugSourceUri(se,fe)}},en={registerTaskProvider:(se,fe)=>$t.registerTaskProvider(Me,se,fe),fetchTasks:se=>$t.fetchTasks(se),executeTask:se=>$t.executeTask(Me,se),get taskExecutions(){return $t.taskExecutions},onDidStartTask:(se,fe,Le)=>$t.onDidStartTask(se,fe,Le),onDidEndTask:(se,fe,Le)=>$t.onDidEndTask(se,fe,Le),onDidStartTaskProcess:(se,fe,Le)=>$t.onDidStartTaskProcess(se,fe,Le),onDidEndTaskProcess:(se,fe,Le)=>$t.onDidEndTaskProcess(se,fe,Le)},tn={createNotebookController(se,fe,Le,nt,yt){return mi.createNotebookController(Me,se,fe,Le,nt,(0,Ne.isProposedApiEnabled)(Me,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(se,fe)=>Dt.registerNotebookCellStatusBarItemProvider(Me,se,fe),createRendererMessaging(se){return Oi.createRendererMessaging(Me,se)},createNotebookControllerDetectionTask(se){return(0,Ne.checkProposedApiEnabled)(Me,"notebookKernelSource"),mi.createNotebookControllerDetectionTask(Me,se)},registerKernelSourceActionProvider(se,fe){return(0,Ne.checkProposedApiEnabled)(Me,"notebookKernelSource"),mi.registerKernelSourceActionProvider(Me,se,fe)},onDidChangeNotebookCellExecutionState(se,fe,Le){return(0,Ne.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),mi.onDidChangeNotebookCellExecutionState(se,fe,Le)}},nn={t(...se){if(typeof se[0]=="string"){const fe=se.shift(),Le=!se||typeof se[0]!="object"?se:se[0];return ai.getMessage(Me.identifier.value,{message:fe,args:Le})}return ai.getMessage(Me.identifier.value,se[0])},get bundle(){return ai.getBundle(Me.identifier.value)},get uri(){return ai.getBundleUri(Me.identifier.value)}},dn={_version:1,registerInteractiveEditorSessionProvider(se){return(0,Ne.checkProposedApiEnabled)(Me,"interactive"),ji.registerProvider(Me,se)},registerInteractiveSessionProvider(se,fe){return(0,Ne.checkProposedApiEnabled)(Me,"interactive"),ei.registerChatProvider(Me,se,fe)},addInteractiveRequest(se){return(0,Ne.checkProposedApiEnabled)(Me,"interactive"),ei.addChatRequest(se)},sendInteractiveRequestToProvider(se,fe){return(0,Ne.checkProposedApiEnabled)(Me,"interactive"),ei.sendInteractiveRequestToProvider(se,fe)},get onDidPerformUserAction(){return(0,Ne.checkProposedApiEnabled)(Me,"interactiveUserActions"),ei.onDidPerformUserAction},transferChatSession(se,fe){return(0,Ne.checkProposedApiEnabled)(Me,"interactive"),ei.transferChatSession(se,fe)}},rn={registerSlashCommandProvider(se,fe){return(0,Ne.checkProposedApiEnabled)(Me,"interactiveSlashCommands"),ei.registerSlashCommandProvider(Me,se,fe)}},sn={registerSemanticSimilarityProvider(se){return(0,Ne.checkProposedApiEnabled)(Me,"semanticSimilarity"),qi.registerSemanticSimilarityProvider(Me,se)}};return{version:ft.version,ai:sn,authentication:Xi,commands:Qi,comments:wi,debug:Zi,env:Pi,extensions:Yi,interactive:dn,interactiveSlashCommands:rn,l10n:nn,languages:Jt,notebooks:tn,scm:jt,tasks:en,tests:un,window:Ei,workspace:Ji,Breakpoint:U.Breakpoint,TerminalOutputAnchor:U.TerminalOutputAnchor,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:k.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:d.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentState:U.CommentState,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CommentThreadState:U.CommentThreadState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Qe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileDecoration2:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionList:U.InlineSuggestionList,Hover:U.Hover,IndentAction:g.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalQuickFixCommand:U.TerminalQuickFixCommand,TerminalQuickFixOpener:U.TerminalQuickFixOpener,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TerminalExitReason:U.TerminalExitReason,TerminalQuickFixType:U.TerminalQuickFixType,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,SnippetTextEdit:U.SnippetTextEdit,TextEditorCursorStyle:f.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCheckboxState:U.TreeItemCheckboxState,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:E.UIKind,Uri:F.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,DocumentDropEdit:U.DocumentDropEdit,DocumentPasteEdit:U.DocumentPasteEdit,InlayHint:U.InlayHint,InlayHintLabelPart:U.InlayHintLabelPart,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,ManagedResolvedAuthority:U.ManagedResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,NotebookControllerAffinity2:U.NotebookControllerAffinity2,NotebookEdit:U.NotebookEdit,NotebookKernelSourceAction:U.NotebookKernelSourceAction,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestRunRequest2:U.TestRunRequest2,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:et.TextSearchCompleteMessageType,DataTransfer:U.DataTransfer,DataTransferItem:U.DataTransferItem,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity,QuickPickItemKind:U.QuickPickItemKind,InputBoxValidationSeverity:U.InputBoxValidationSeverity,TabInputText:U.TextTabInput,TabInputTextDiff:U.TextDiffTabInput,TabInputTextMerge:U.TextMergeTabInput,TabInputCustom:U.CustomEditorTabInput,TabInputNotebook:U.NotebookEditorTabInput,TabInputNotebookDiff:U.NotebookDiffEditorTabInput,TabInputWebview:U.WebviewEditorTabInput,TabInputTerminal:U.TerminalEditorTabInput,TabInputInteractiveWindow:U.InteractiveWindowInput,TelemetryTrustedValue:le.TelemetryTrustedValue,LogLevel:_e.LogLevel,EditSessionIdentityMatch:pt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:U.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:U.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:U.InteractiveEditorResponseFeedbackKind,StackFrameFocus:U.StackFrameFocus,ThreadFocus:U.ThreadFocus,NotebookCodeActionKind:U.NotebookCodeActionKind}}}e.createApiFactoryAndRegisterActors=Ht}),define(Ae[267],Re([1,0,72,109,33,107,34,32,59,62,111,113,114,85,75,81,108,61,39,84,57,60,234,15,112,82,83]),function(te,e,m,k,C,M,F,f,D,g,R,y,d,E,p,l,t,r,c,b,w,_,i,u,n,s,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(s.IExtHostLocalizationService,s.ExtHostLocalizationService,1),(0,m.registerSingleton)(u.ILoggerService,i.ExtHostLoggerService,1),(0,m.registerSingleton)(l.IExtHostApiDeprecationService,l.ExtHostApiDeprecationService,1),(0,m.registerSingleton)(f.IExtHostCommands,f.ExtHostCommands,0),(0,m.registerSingleton)(F.IExtHostConfiguration,F.ExtHostConfiguration,0),(0,m.registerSingleton)(r.IExtHostConsumerFileSystem,r.ExtHostConsumerFileSystem,0),(0,m.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService,0),(0,m.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,m.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors,0),(0,m.registerSingleton)(v.IExtHostManagedSockets,v.ExtHostManagedSockets,0),(0,m.registerSingleton)(c.IExtHostFileSystemInfo,c.ExtHostFileSystemInfo,0),(0,m.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService,1),(0,m.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch,0),(0,m.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage,0),(0,m.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,0),(0,m.registerSingleton)(g.IExtHostTerminalService,g.WorkerExtHostTerminalService,0),(0,m.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService,0),(0,m.registerSingleton)(t.IExtHostWindow,t.ExtHostWindow,0),(0,m.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace,0),(0,m.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,m.registerSingleton)(w.IExtHostTelemetry,w.ExtHostTelemetry,0),(0,m.registerSingleton)(_.IExtHostEditorTabs,_.ExtHostEditorTabs,0),(0,m.registerSingleton)(n.IExtHostVariableResolverProvider,n.ExtHostVariableResolverProviderService,0)}),define(Ae[268],Re([1,0,266,35,2,263,7,16,254]),function(te,e,m,k,C,M,F,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class g extends M.RequireInterceptor{_installInterceptor(){}getModule(E,p){for(const l of this._alternatives){const t=l(E);if(t){E=t;break}}if(this._factories.has(E))return this._factories.get(E).load(E,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends k.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=F.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(D.ExtHostConsoleForwarder);const E=this._instaService.invokeFunction(m.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(g,E,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(E){return E.browser}async _loadCommonJSModule(E,p,l){p=p.with({path:y(p.path,".js")});const t=E?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const r=C.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(p)),c=await fetch(r.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),c.status!==200)throw new Error(c.statusText);const b=await c.text(),w=`${p.toString(!0)}#vscode-extension`,_=`${b}
//# sourceURL=${w}`;let i;try{i=new Function("module","exports","require",_)}catch(v){throw console.error(t?`Loading code for extension ${t} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${p.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}E&&await this._extHostLocalizationService.initializeLocalizedMessages(E);const u={},n={exports:u},s=v=>{const I=this._fakeModules.getModule(v,p);if(I===void 0)throw new Error(`Cannot load module '${v}'`);return I};try{return l.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),i(n,u,s),n.exports!==u?n.exports:u}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),l.codeLoadingStop()}}async $setRemoteEnvironment(E){}async _waitForDebuggerAttachment(E=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+E;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,f.timeout)(10)}}e.ExtHostExtensionService=R;function y(d,E){return d.endsWith(E)?d:d+E}}),define(Ae[269],Re([1,0,71,72,15,35,186,86,268]),function(te,e,m,k,C,M,F,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,k.registerSingleton)(C.ILogService,new m.SyncDescriptor(F.ExtHostLogService,[!0],!0)),(0,k.registerSingleton)(M.IExtHostExtensionService,D.ExtHostExtensionService,0),(0,k.registerSingleton)(f.IExtensionStoragePaths,f.ExtensionStoragePaths,0)}),define(Ae[277],Re([1,0,25,5,80,264,256,19,87,14,2,267,269]),function(te,e,m,k,C,M,F,f,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const d=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(i){return/^(file|vscode-remote):/i.test(i)}const p=fetch.bind(self);function l(i){self.fetch=async function(u,n){return u instanceof Request||E(String(u))&&(u=(await i(R.URI.parse(String(u)))).toString(!0)),p(u,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,n,s,v,I){(async()=>(E(n.toString())&&(n=(await i(R.URI.parse(n.toString()))).toString(!0)),super.open(u,n,s??!0,v,I)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(u,n){if(/^file:/i.test(u.toString()))u=g.FileAccess.uriToBrowserUri(R.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const v=`(${function(S){function a($){return typeof $=="string"||$ instanceof URL?String($).replace(/^file:\/\//i,"vscode-file://vscode-app"):$}const o=fetch.bind(self);self.fetch=function($,K){return $ instanceof Request?o($,K):o(a($),K)},self.XMLHttpRequest=class extends XMLHttpRequest{open($,K,V,z,N){return super.open($,a(K),V??!0,z,N)}};const O=importScripts.bind(self);self.importScripts=(...$)=>{O(...$.map(a))},O(S)}.toString()}('${u}'))`;n=n||{},n.name=n.name||f.basename(u.toString());const I=new Blob([v],{type:"application/javascript"}),h=URL.createObjectURL(I);return new i(h,n)}}else self.Worker=class extends F.NestedWorker{constructor(i,u){super(d,i,{name:f.basename(i.toString()),...u})}};const t=new class{constructor(){this.pid=void 0}exit(i){y()}async exists(i){return!0}async realpath(i){return i}};class r{constructor(){const u=new MessageChannel,n=new k.Emitter;let s=!1;d(u.port2,[u.port2]),u.port1.onmessage=v=>{const{data:I}=v;if(!(I instanceof ArrayBuffer)){console.warn("UNKNOWN data received",I);return}const h=m.VSBuffer.wrap(new Uint8Array(I,0,I.byteLength));if((0,C.isMessageOfType)(h,2)){s=!0,b("received terminate message from renderer");return}n.fire(h)},this.protocol={onMessage:n.event,send:v=>{if(!s){const I=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);u.port1.postMessage(I,[I])}}}}}function c(i){return new Promise(u=>{const n=i.onMessage(s=>{n.dispose();const v=JSON.parse(s.toString());i.send((0,C.createMessageOfType)(0)),u({protocol:i,initData:v})});i.send((0,C.createMessageOfType)(1))})}let b=i=>y();function w(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function _(){D.mark("code/extHost/willConnectToRenderer");const i=new r;return{onmessage(u){w(u)&&c(i.protocol).then(n=>{D.mark("code/extHost/didWaitForInitData");const s=new M.ExtensionHostMain(n.protocol,n.initData,t,null,u.data);l(v=>s.asBrowserUri(v)),b=v=>s.terminate(v)})}}}e.create=_})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9d3b0fa210fb4535589e8296483a5b43fe5e660a/core/vs/workbench/api/worker/extensionHostWorker.js.map
