/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var q=["require","exports","vs/base/common/lifecycle","vs/base/common/observableImpl/logging","vs/base/common/errors","vs/base/common/platform","vs/base/common/observableImpl/base","vs/editor/common/tokens/lineTokens","vs/base/common/observableImpl/autorun","vs/base/common/observableImpl/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/uri","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/observableImpl/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/workbench/services/textMate/browser/worker/textMateWorkerModel","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vscode-textmate","vs/workbench/services/textMate/browser/worker/textMate.worker"],K=function(U){for(var e=[],w=0,S=U.length;w<S;w++)e[w]=q[U[w]];return e};define(q[3],K([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=e.getLogger=e.setLogger=void 0;let w;function S(s){w=s}e.setLogger=S;function k(){return w}e.getLogger=k;class C{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(o){return n([h(g("|  ",this.indentation)),o])}formatInfo(o){return o.didChange?[h(" "),r(u(o.oldValue,70),{color:"red",strikeThrough:!0}),h(" "),r(u(o.newValue,60),{color:"green"})]:[h(" (unchanged)")]}handleObservableChanged(o,_){console.log(...this.textToConsoleArgs([t("observable value changed"),r(o.debugName,{color:"BlueViolet"}),...this.formatInfo(_)]))}formatChanges(o){if(o.size!==0)return r(" (changed deps: "+[...o].map(_=>_.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const _=o.handleChange;this.changedObservablesSets.set(o,new Set),o.handleChange=(P,z)=>(this.changedObservablesSets.get(o).add(P),_.apply(o,[P,z]))}handleDerivedRecomputed(o,_){const P=this.changedObservablesSets.get(o);console.log(...this.textToConsoleArgs([t("derived recomputed"),r(o.debugName,{color:"BlueViolet"}),...this.formatInfo(_),this.formatChanges(P)])),P.clear()}handleFromEventObservableTriggered(o,_){console.log(...this.textToConsoleArgs([t("observable from event triggered"),r(o.debugName,{color:"BlueViolet"}),...this.formatInfo(_)]))}handleAutorunCreated(o){const _=o.handleChange;this.changedObservablesSets.set(o,new Set),o.handleChange=(P,z)=>(this.changedObservablesSets.get(o).add(P),_.apply(o,[P,z]))}handleAutorunTriggered(o){const _=this.changedObservablesSets.get(o);console.log(...this.textToConsoleArgs([t("autorun"),r(o.debugName,{color:"BlueViolet"}),this.formatChanges(_)])),_.clear()}handleBeginTransaction(o){let _=o.getDebugName();_===void 0&&(_=""),console.log(...this.textToConsoleArgs([t("transaction"),r(_,{color:"BlueViolet"})])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=C;function n(s){const o=new Array,P={};let z="";function N(f){if("length"in f)for(const b of f)b&&N(b);else"text"in f?(z+=`%c${f.text}`,o.push(f.style),f.data&&Object.assign(P,f.data)):"data"in f&&Object.assign(P,f.data)}N(s);const E=[z,...o];return Object.keys(P).length>0&&E.push(P),E}function h(s){return r(s,{color:"black"})}function t(s){return r(i(`${s}: `,10),{color:"black",bold:!0})}function r(s,o={color:"black"}){function _(z){return Object.entries(z).reduce((N,[E,f])=>`${N}${E}:${f};`,"")}const P={color:o.color};return o.strikeThrough&&(P["text-decoration"]="line-through"),o.bold&&(P["font-weight"]="bold"),{text:s,style:_(P)}}function u(s,o){switch(typeof s){case"number":return""+s;case"string":return s.length+2<=o?`"${s}"`:`"${s.substr(0,o-7)}"+...`;case"boolean":return s?"true":"false";case"undefined":return"undefined";case"object":return s===null?"null":Array.isArray(s)?a(s,o):d(s,o);case"symbol":return s.toString();case"function":return`[[Function${s.name?" "+s.name:""}]]`;default:return""+s}}function a(s,o){let _="[ ",P=!0;for(const z of s){if(P||(_+=", "),_.length-5>o){_+="...";break}P=!1,_+=`${u(z,o-_.length)}`}return _+=" ]",_}function d(s,o){let _="{ ",P=!0;for(const[z,N]of Object.entries(s)){if(P||(_+=", "),_.length-5>o){_+="...";break}P=!1,_+=`${z}: ${u(N,o-_.length)}`}return _+=" }",_}function g(s,o){let _="";for(let P=1;P<=o;P++)_+=s;return _}function i(s,o){for(;s.length<o;)s+=" ";return s}}),define(q[8],K([0,1,40,2,3]),function(U,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunDelta=e.AutorunObserver=e.autorunWithStore=e.autorunWithStoreHandleChanges=e.autorunWithStore2=e.autorunHandleChanges=e.autorun=void 0;function C(g,i){return new a(g,i,void 0,void 0)}e.autorun=C;function n(g,i,s){return new a(g,s,i.createEmptyChangeSummary,i.handleChange)}e.autorunHandleChanges=n;function h(g,i){return r(i,g)}e.autorunWithStore2=h;function t(g,i,s){const o=new S.DisposableStore,_=n(g,{createEmptyChangeSummary:i.createEmptyChangeSummary,handleChange:i.handleChange},(P,z)=>{o.clear(),s(P,z,o)});return(0,S.toDisposable)(()=>{_.dispose(),o.dispose()})}e.autorunWithStoreHandleChanges=t;function r(g,i){const s=new S.DisposableStore,o=C(i,_=>{s.clear(),g(_,s)});return(0,S.toDisposable)(()=>{o.dispose(),s.dispose()})}e.autorunWithStore=r;var u;(function(g){g[g.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",g[g.stale=2]="stale",g[g.upToDate=3]="upToDate"})(u||(u={}));class a{constructor(i,s,o,_){this.debugName=i,this.runFn=s,this.createChangeSummary=o,this._handleChange=_,this.state=2,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=this.createChangeSummary?.(),(0,k.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded()}dispose(){this.disposed=!0;for(const i of this.dependencies)i.removeObserver(this);this.dependencies.clear()}_runIfNeeded(){if(this.state===3)return;const i=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=i,this.state=3,(0,k.getLogger)()?.handleAutorunTriggered(this);try{const s=this.changeSummary;this.changeSummary=this.createChangeSummary?.(),this.runFn(this,s)}finally{for(const s of this.dependenciesToBeRemoved)s.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===3&&(this.state=1),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===1){this.state=3;for(const i of this.dependencies)if(i.reportChanges(),this.state===2)break}this._runIfNeeded()}while(this.state!==3);this.updateCount--,(0,w.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(i){this.state===3&&this.dependencies.has(i)&&!this.dependenciesToBeRemoved.has(i)&&(this.state=1)}handleChange(i,s){this.dependencies.has(i)&&!this.dependenciesToBeRemoved.has(i)&&(!this._handleChange||this._handleChange({changedObservable:i,change:s,didChange:_=>_===i},this.changeSummary))&&(this.state=2)}readObservable(i){if(this.disposed)return i.get();i.addObserver(this);const s=i.get();return this.dependencies.add(i),this.dependenciesToBeRemoved.delete(i),s}}e.AutorunObserver=a,function(g){g.Observer=a}(C||(e.autorun=C={}));function d(g,i,s){let o;return C(g,_=>{const P=i.read(_),z=o;o=P,s({lastValue:z,newValue:P})})}e.autorunDelta=d}),define(q[6],K([0,1,3]),function(U,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.disposableObservableValue=e.ObservableValue=e.observableValue=e.getFunctionName=e.TransactionImpl=e.subtransaction=e.transaction=e.BaseObservable=e.ConvenientObservable=e._setDerived=void 0;let S;function k(s){S=s}e._setDerived=k;class C{get TChange(){return null}reportChanges(){this.get()}read(o){return o?o.readObservable(this):this.get()}map(o){return S(()=>{const _=u(o);return _!==void 0?_:`${this.debugName} (mapped)`},_=>o(this.read(_),_))}}e.ConvenientObservable=C;class n extends C{constructor(){super(...arguments),this.observers=new Set}addObserver(o){const _=this.observers.size;this.observers.add(o),_===0&&this.onFirstObserverAdded()}removeObserver(o){this.observers.delete(o)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=n;function h(s,o){const _=new r(s,o);try{(0,w.getLogger)()?.handleBeginTransaction(_),s(_)}finally{_.finish(),(0,w.getLogger)()?.handleEndTransaction()}}e.transaction=h;function t(s,o,_){s?o(s):h(o,_)}e.subtransaction=t;class r{constructor(o,_){this.fn=o,this._getDebugName=_,this.updatingObservers=[]}getDebugName(){return this._getDebugName?this._getDebugName():u(this.fn)}updateObserver(o,_){this.updatingObservers.push({observer:o,observable:_}),o.beginUpdate(_)}finish(){const o=this.updatingObservers;this.updatingObservers=null;for(const{observer:_,observable:P}of o)_.endUpdate(P)}}e.TransactionImpl=r;function u(s){const o=s.toString(),P=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(o);return(P?P[1]:void 0)?.trim()}e.getFunctionName=u;function a(s,o){return new d(s,o)}e.observableValue=a;class d extends n{constructor(o,_){super(),this.debugName=o,this._value=_}get(){return this._value}set(o,_,P){if(this._value===o)return;let z;_||(_=z=new r(()=>{},()=>`Setting ${this.debugName}`));try{const N=this._value;this._setValue(o),(0,w.getLogger)()?.handleObservableChanged(this,{oldValue:N,newValue:o,change:P,didChange:!0});for(const E of this.observers)_.updateObserver(E,this),E.handleChange(this,P)}finally{z&&z.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(o){this._value=o}}e.ObservableValue=d;function g(s,o){return new i(s,o)}e.disposableObservableValue=g;class i extends d{_setValue(o){this._value!==o&&(this._value&&this._value.dispose(),this._value=o)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=i}),define(q[9],K([0,1,4,2,6,3]),function(U,e,w,S,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Derived=e.derivedWithStore=e.derivedHandleChanges=e.derived=void 0;function n(a,d){return new u(a,d,void 0,void 0,void 0)}e.derived=n;function h(a,d,g){return new u(a,g,d.createEmptyChangeSummary,d.handleChange,void 0)}e.derivedHandleChanges=h;function t(a,d){const g=new S.DisposableStore;return new u(a,i=>(g.clear(),d(i,g)),void 0,void 0,()=>g.dispose())}e.derivedWithStore=t,(0,k._setDerived)(n);var r;(function(a){a[a.initial=0]="initial",a[a.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",a[a.stale=2]="stale",a[a.upToDate=3]="upToDate"})(r||(r={}));class u extends k.BaseObservable{get debugName(){return typeof this._debugName=="function"?this._debugName():this._debugName}constructor(d,g,i,s,o=void 0){super(),this._debugName=d,this.computeFn=g,this.createChangeSummary=i,this._handleChange=s,this._handleLastObserverRemoved=o,this.state=0,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=void 0,this.changeSummary=this.createChangeSummary?.(),(0,C.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=0,this.value=void 0;for(const d of this.dependencies)d.removeObserver(this);this.dependencies.clear(),this._handleLastObserverRemoved?.()}get(){if(this.observers.size===0){const d=this.computeFn(this,this.createChangeSummary?.());return this.onLastObserverRemoved(),d}else{do{if(this.state===1){this.state=3;for(const d of this.dependencies)if(d.reportChanges(),this.state===2)break}this._recomputeIfNeeded()}while(this.state!==3);return this.value}}_recomputeIfNeeded(){if(this.state===3)return;const d=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=d;const g=this.state!==0,i=this.value;this.state=3;const s=this.changeSummary;this.changeSummary=this.createChangeSummary?.();try{this.value=this.computeFn(this,s)}finally{for(const _ of this.dependenciesToBeRemoved)_.removeObserver(this);this.dependenciesToBeRemoved.clear()}const o=g&&i!==this.value;if((0,C.getLogger)()?.handleDerivedRecomputed(this,{oldValue:i,newValue:this.value,change:void 0,didChange:o}),o)for(const _ of this.observers)_.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(d){this.updateCount++;const g=this.updateCount===1;if(this.state===3&&(this.state=1,!g))for(const i of this.observers)i.handlePossibleChange(this);if(g)for(const i of this.observers)i.beginUpdate(this)}endUpdate(d){if(this.updateCount--,this.updateCount===0){const g=[...this.observers];for(const i of g)i.endUpdate(this)}if(this.updateCount<0)throw new w.BugIndicatingError}handlePossibleChange(d){if(this.state===3&&this.dependencies.has(d)&&!this.dependenciesToBeRemoved.has(d)){this.state=1;for(const g of this.observers)g.handlePossibleChange(this)}}handleChange(d,g){if(this.dependencies.has(d)&&!this.dependenciesToBeRemoved.has(d)){const i=this._handleChange?this._handleChange({changedObservable:d,change:g,didChange:o=>o===d},this.changeSummary):!0,s=this.state===3;if(i&&(this.state===1||s)&&(this.state=2,s))for(const o of this.observers)o.handlePossibleChange(this)}}readObservable(d){d.addObserver(this);const g=d.get();return this.dependencies.add(d),this.dependenciesToBeRemoved.delete(d),g}addObserver(d){const g=!this.observers.has(d)&&this.updateCount>0;super.addObserver(d),g&&d.beginUpdate(this)}removeObserver(d){const g=this.observers.has(d)&&this.updateCount>0;super.removeObserver(d),g&&d.endUpdate(this)}}e.Derived=u}),define(q[20],K([0,1,2,8,6,9,3]),function(U,e,w,S,k,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.keepAlive=e.wasEventTriggeredRecently=e.debouncedObservable=e.observableSignal=e.observableSignalFromEvent=e.FromEventObservable=e.observableFromEvent=e.waitForState=e.observableFromPromise=e.constObservable=void 0;function h(b){return new t(b)}e.constObservable=h;class t extends k.ConvenientObservable{constructor(v){super(),this.value=v}get debugName(){return this.toString()}get(){return this.value}addObserver(v){}removeObserver(v){}toString(){return`Const: ${this.value}`}}function r(b){const v=(0,k.observableValue)("promiseValue",{});return b.then(I=>{v.set({value:I},void 0)}),v}e.observableFromPromise=r;function u(b,v){return new Promise(I=>{let D=!1,c=!1;const O=(0,S.autorun)("waitForState",M=>{const y=b.read(M);v(y)&&(D?O.dispose():c=!0,I(y))});D=!0,c&&O.dispose()})}e.waitForState=u;function a(b,v){return new d(b,v)}e.observableFromEvent=a;class d extends k.BaseObservable{constructor(v,I){super(),this.event=v,this.getValue=I,this.hasValue=!1,this.handleEvent=D=>{const c=this.getValue(D),O=!this.hasValue||this.value!==c;(0,n.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:this.value,newValue:c,change:void 0,didChange:O}),O&&(this.value=c,this.hasValue&&(0,k.transaction)(M=>{for(const y of this.observers)M.updateObserver(y,this),y.handleChange(this,void 0)},()=>{const M=this.getDebugName();return"Event fired"+(M?`: ${M}`:"")}),this.hasValue=!0)}}getDebugName(){return(0,k.getFunctionName)(this.getValue)}get debugName(){const v=this.getDebugName();return"From Event"+(v?`: ${v}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this.getValue(void 0)}}e.FromEventObservable=d,function(b){b.Observer=d}(a||(e.observableFromEvent=a={}));function g(b,v){return new i(b,v)}e.observableSignalFromEvent=g;class i extends k.BaseObservable{constructor(v,I){super(),this.debugName=v,this.event=I,this.handleEvent=()=>{(0,k.transaction)(D=>{for(const c of this.observers)D.updateObserver(c,this),c.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function s(b){return new o(b)}e.observableSignal=s;class o extends k.BaseObservable{constructor(v){super(),this.debugName=v}trigger(v,I){if(!v){(0,k.transaction)(D=>{this.trigger(D,I)},()=>`Trigger signal ${this.debugName}`);return}for(const D of this.observers)v.updateObserver(D,this),D.handleChange(this,I)}get(){}}function _(b,v,I){const D=(0,k.observableValue)("debounced",void 0);let c;return I.add((0,S.autorun)("debounce",O=>{const M=b.read(O);c&&clearTimeout(c),c=setTimeout(()=>{(0,k.transaction)(y=>{D.set(M,y)})},v)})),D}e.debouncedObservable=_;function P(b,v,I){const D=(0,k.observableValue)("triggeredRecently",!1);let c;return I.add(b(()=>{D.set(!0,void 0),c&&clearTimeout(c),c=setTimeout(()=>{D.set(!1,void 0)},v)})),D}e.wasEventTriggeredRecently=P;function z(b,v){const I=new N(v??!1);return b.addObserver(I),v&&b.reportChanges(),(0,w.toDisposable)(()=>{b.removeObserver(I)})}e.keepAlive=z;class N{constructor(v){this.forceRecompute=v,this.counter=0}beginUpdate(v){this.counter++}endUpdate(v){this.counter--,this.counter===0&&this.forceRecompute&&v.reportChanges()}handlePossibleChange(v){}handleChange(v,I){}}function E(b,v){let I;return(0,C.derived)(b,c=>(I=v(c,I),I))}e.derivedObservableWithCache=E;function f(b,v){let I;const D=(0,k.observableValue)("derivedObservableWithWritableCache.counter",0),c=(0,C.derived)(b,O=>(D.read(O),I=v(O,I),I));return Object.assign(c,{clearCache:O=>{I=void 0,D.set(D.get()+1,O)}})}e.derivedObservableWithWritableCache=f});var re=this&&this.__createBinding||(Object.create?function(U,e,w,S){S===void 0&&(S=w);var k=Object.getOwnPropertyDescriptor(e,w);(!k||("get"in k?!e.__esModule:k.writable||k.configurable))&&(k={enumerable:!0,get:function(){return e[w]}}),Object.defineProperty(U,S,k)}:function(U,e,w,S){S===void 0&&(S=w),U[S]=e[w]}),se=this&&this.__exportStar||function(U,e){for(var w in U)w!=="default"&&!Object.prototype.hasOwnProperty.call(e,w)&&re(e,U,w)};define(q[10],K([0,1,6,9,8,20,3]),function(U,e,w,S,k,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derived=e.transaction=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return w.observableValue}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return w.transaction}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return S.derived}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return k.autorun}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return k.autorunDelta}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return k.autorunHandleChanges}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return k.autorunWithStore}}),se(C,e),!1&&(0,n.setLogger)(new n.ConsoleObservableLogger)}),define(q[21],K([0,1,4,2]),function(U,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(N){const E=N;return E?typeof E.read=="function":!1}e.isReadable=k;function C(N){const E=N;return E?[E.on,E.pause,E.resume,E.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=C;function n(N){const E=N;return E?C(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.isReadableBufferedStream=n;function h(N,E){return new t(N,E)}e.newWriteableStream=h;class t{constructor(E,f){this.reducer=E,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(E){if(!this.state.destroyed){if(this.state.flowing)this.emitData(E);else if(this.buffer.data.push(E),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(f=>this.pendingWritePromises.push(f))}}error(E){this.state.destroyed||(this.state.flowing?this.emitError(E):this.buffer.error.push(E))}end(E){this.state.destroyed||(typeof E<"u"&&this.write(E),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(E){this.listeners.data.slice(0).forEach(f=>f(E))}emitError(E){this.listeners.error.length===0?(0,w.onUnexpectedError)(E):this.listeners.error.slice(0).forEach(f=>f(E))}emitEnd(){this.listeners.end.slice(0).forEach(E=>E())}on(E,f){if(!this.state.destroyed)switch(E){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(E,f){if(this.state.destroyed)return;let b;switch(E){case"data":b=this.listeners.data;break;case"end":b=this.listeners.end;break;case"error":b=this.listeners.error;break}if(b){const v=b.indexOf(f);v>=0&&b.splice(v,1)}}flowData(){if(this.buffer.data.length>0){const E=this.reducer(this.buffer.data);this.emitData(E),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(b=>b())}}flowErrors(){if(this.listeners.error.length>0){for(const E of this.buffer.error)this.emitError(E);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function r(N,E){const f=[];let b;for(;(b=N.read())!==null;)f.push(b);return E(f)}e.consumeReadable=r;function u(N,E,f){const b=[];let v;for(;(v=N.read())!==null&&b.length<f;)b.push(v);return v===null&&b.length>0?E(b):{read:()=>{if(b.length>0)return b.shift();if(typeof v<"u"){const I=v;return v=void 0,I}return N.read()}}}e.peekReadable=u;function a(N,E){return new Promise((f,b)=>{const v=[];d(N,{onData:I=>{E&&v.push(I)},onError:I=>{E?b(I):f(void 0)},onEnd:()=>{f(E?E(v):void 0)}})})}e.consumeStream=a;function d(N,E){let f=!1;return N.on("error",b=>{f||E.onError(b)}),N.on("end",()=>{f||E.onEnd()}),N.on("data",b=>{f||E.onData(b)}),(0,S.toDisposable)(()=>f=!0)}e.listenStream=d;function g(N,E){return new Promise((f,b)=>{const v=new S.DisposableStore,I=[],D=M=>{if(I.push(M),I.length>E)return v.dispose(),N.pause(),f({stream:N,buffer:I,ended:!1})},c=M=>b(M),O=()=>f({stream:N,buffer:I,ended:!0});v.add((0,S.toDisposable)(()=>N.removeListener("error",c))),N.on("error",c),v.add((0,S.toDisposable)(()=>N.removeListener("end",O))),N.on("end",O),v.add((0,S.toDisposable)(()=>N.removeListener("data",D))),N.on("data",D)})}e.peekStream=g;function i(N,E){const f=h(E);return f.end(N),f}e.toStream=i;function s(){const N=h(()=>{throw new Error("not supported")});return N.end(),N}e.emptyStream=s;function o(N){let E=!1;return{read:()=>E?null:(E=!0,N)}}e.toReadable=o;function _(N,E,f){const b=h(f);return d(N,{onData:v=>b.write(E.data(v)),onError:v=>b.error(E.error?E.error(v):v),onEnd:()=>b.end()}),b}e.transform=_;function P(N,E,f){let b=!1;return{read:()=>{const v=E.read();return b?v:(b=!0,v!==null?f([N,v]):N)}}}e.prefixedReadable=P;function z(N,E,f){let b=!1;const v=h(f);return d(E,{onData:I=>b?v.write(I):(b=!0,v.write(f([N,I]))),onError:I=>v.error(I),onEnd:()=>{b||(b=!0,v.write(N)),v.end()}}),v}e.prefixedStream=z}),define(q[11],K([0,1,41,21]),function(U,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer<"u",C=new w.Lazy(()=>new Uint8Array(256));let n,h;class t{static alloc(m){return k?new t(Buffer.allocUnsafe(m)):new t(new Uint8Array(m))}static wrap(m){return k&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new t(m)}static fromString(m,R){return!(R?.dontUseNodeBuffer||!1)&&k?new t(Buffer.from(m)):(n||(n=new TextEncoder),new t(n.encode(m)))}static fromByteArray(m){const R=t.alloc(m.length);for(let B=0,j=m.length;B<j;B++)R.buffer[B]=m[B];return R}static concat(m,R){if(typeof R>"u"){R=0;for(let G=0,$=m.length;G<$;G++)R+=m[G].byteLength}const B=t.alloc(R);let j=0;for(let G=0,$=m.length;G<$;G++){const W=m[G];B.set(W,j),j+=W.byteLength}return B}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=t.alloc(this.byteLength);return m.set(this),m}toString(){return k?this.buffer.toString():(h||(h=new TextDecoder),h.decode(this.buffer))}slice(m,R){return new t(this.buffer.subarray(m,R))}set(m,R){if(m instanceof t)this.buffer.set(m.buffer,R);else if(m instanceof Uint8Array)this.buffer.set(m,R);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),R);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return a(this.buffer,m)}writeUInt32BE(m,R){d(this.buffer,m,R)}readUInt32LE(m){return g(this.buffer,m)}writeUInt32LE(m,R){i(this.buffer,m,R)}readUInt8(m){return s(this.buffer,m)}writeUInt8(m,R){o(this.buffer,m,R)}indexOf(m){const R=m instanceof t?m.buffer:m,B=R.byteLength,j=this.buffer,G=j.byteLength;if(B===0)return 0;if(B===1)return j.indexOf(R[0]);if(B>G)return-1;const $=C.value;$.fill(R.length);for(let J=0;J<R.length;J++)$[R[J]]=R.length-J-1;let W=R.length-1,V=W,Z=-1;for(;W<G;)if(j[W]===R[V]){if(V===0){Z=W;break}W--,V--}else W+=Math.max(R.length-V,$[j[W]]),V=R.length-1;return Z}}e.VSBuffer=t;function r(y,m){return y[m+0]<<0>>>0|y[m+1]<<8>>>0}e.readUInt16LE=r;function u(y,m,R){y[R+0]=m&255,m=m>>>8,y[R+1]=m&255}e.writeUInt16LE=u;function a(y,m){return y[m]*2**24+y[m+1]*2**16+y[m+2]*2**8+y[m+3]}e.readUInt32BE=a;function d(y,m,R){y[R+3]=m,m=m>>>8,y[R+2]=m,m=m>>>8,y[R+1]=m,m=m>>>8,y[R]=m}e.writeUInt32BE=d;function g(y,m){return y[m+0]<<0>>>0|y[m+1]<<8>>>0|y[m+2]<<16>>>0|y[m+3]<<24>>>0}e.readUInt32LE=g;function i(y,m,R){y[R+0]=m&255,m=m>>>8,y[R+1]=m&255,m=m>>>8,y[R+2]=m&255,m=m>>>8,y[R+3]=m&255}e.writeUInt32LE=i;function s(y,m){return y[m]}e.readUInt8=s;function o(y,m,R){y[R]=m}e.writeUInt8=o;function _(y){return S.consumeReadable(y,m=>t.concat(m))}e.readableToBuffer=_;function P(y){return S.toReadable(y)}e.bufferToReadable=P;function z(y){return S.consumeStream(y,m=>t.concat(m))}e.streamToBuffer=z;async function N(y){return y.ended?t.concat(y.buffer):t.concat([...y.buffer,await z(y.stream)])}e.bufferedStreamToBuffer=N;function E(y){return S.toStream(y,m=>t.concat(m))}e.bufferToStream=E;function f(y){return S.transform(y,{data:m=>typeof m=="string"?t.fromString(m):t.wrap(m)},m=>t.concat(m))}e.streamToBufferReadableStream=f;function b(y){return S.newWriteableStream(m=>t.concat(m),y)}e.newWriteableBufferStream=b;function v(y,m){return S.prefixedReadable(y,m,R=>t.concat(R))}e.prefixedBufferReadable=v;function I(y,m){return S.prefixedStream(y,m,R=>t.concat(R))}e.prefixedBufferStream=I;function D(y){let m=0,R=0,B=0;const j=new Uint8Array(Math.floor(y.length/4*3)),G=W=>{switch(R){case 3:j[B++]=m|W,R=0;break;case 2:j[B++]=m|W>>>2,m=W<<6,R=3;break;case 1:j[B++]=m|W>>>4,m=W<<4,R=2;break;default:m=W<<2,R=1}};for(let W=0;W<y.length;W++){const V=y.charCodeAt(W);if(V>=65&&V<=90)G(V-65);else if(V>=97&&V<=122)G(V-97+26);else if(V>=48&&V<=57)G(V-48+52);else if(V===43||V===45)G(62);else if(V===47||V===95)G(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${y[W]}`)}}const $=B;for(;R>0;)G(0);return t.wrap(j).slice(0,$)}e.decodeBase64=D;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function M({buffer:y},m=!0,R=!1){const B=R?O:c;let j="";const G=y.byteLength%3;let $=0;for(;$<y.byteLength-G;$+=3){const W=y[$+0],V=y[$+1],Z=y[$+2];j+=B[W>>>2],j+=B[(W<<4|V>>>4)&63],j+=B[(V<<2|Z>>>6)&63],j+=B[Z&63]}if(G===1){const W=y[$+0];j+=B[W>>>2],j+=B[W<<4&63],m&&(j+="==")}else if(G===2){const W=y[$+0],V=y[$+1];j+=B[W>>>2],j+=B[(W<<4|V>>>4)&63],j+=B[V<<2&63],m&&(j+="=")}return j}e.encodeBase64=M}),define(q[22],K([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(q[12],K([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var w;(function(k){k[k.Unknown=0]="Unknown",k[k.Invalid=3]="Invalid",k[k.LF=1]="LF",k[k.CRLF=2]="CRLF"})(w||(e.StringEOL=w={}));function S(k){let C=0,n=0,h=0,t=0;for(let r=0,u=k.length;r<u;r++){const a=k.charCodeAt(r);a===13?(C===0&&(n=r),C++,r+1<u&&k.charCodeAt(r+1)===10?(t|=2,r++):t|=3,h=r+1):a===10&&(t|=1,C===0&&(n=r),C++,h=r+1)}return C===0&&(n=k.length),[C,n,k.length-h,t]}e.countEOL=S}),define(q[13],K([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var w;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(w||(e.LanguageId=w={}));var S;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(S||(e.FontStyle=S={}));var k;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(k||(e.ColorId=k={}));var C;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(C||(e.StandardTokenType=C={}));var n;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(n||(e.MetadataConsts=n={}));class h{static getLanguageId(r){return(r&255)>>>0}static getTokenType(r){return(r&768)>>>8}static containsBalancedBrackets(r){return(r&1024)!==0}static getFontStyle(r){return(r&30720)>>>11}static getForeground(r){return(r&16744448)>>>15}static getBackground(r){return(r&4278190080)>>>24}static getClassNameFromMetadata(r){let a="mtk"+this.getForeground(r);const d=this.getFontStyle(r);return d&1&&(a+=" mtki"),d&2&&(a+=" mtkb"),d&4&&(a+=" mtku"),d&8&&(a+=" mtks"),a}static getInlineStyleFromMetadata(r,u){const a=this.getForeground(r),d=this.getFontStyle(r);let g=`color: ${u[a]};`;d&1&&(g+="font-style: italic;"),d&2&&(g+="font-weight: bold;");let i="";return d&4&&(i+=" underline"),d&8&&(i+=" line-through"),i&&(g+=`text-decoration:${i};`),g}static getPresentationFromMetadata(r){const u=this.getForeground(r),a=this.getFontStyle(r);return{foreground:u,italic:!!(a&1),bold:!!(a&2),underline:!!(a&4),strikethrough:!!(a&8)}}}e.TokenMetadata=h}),define(q[23],K([0,1,24]),function(U,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FixedArray=void 0;class S{constructor(n){this._default=n,this._store=[]}get(n){return n<this._store.length?this._store[n]:this._default}set(n,h){for(;n>=this._store.length;)this._store[this._store.length]=this._default;this._store[n]=h}replace(n,h,t){if(n>=this._store.length)return;if(h===0){this.insert(n,t);return}else if(t===0){this.delete(n,h);return}const r=this._store.slice(0,n),u=this._store.slice(n+h),a=k(t,this._default);this._store=r.concat(a,u)}delete(n,h){h===0||n>=this._store.length||this._store.splice(n,h)}insert(n,h){if(h===0||n>=this._store.length)return;const t=[];for(let r=0;r<h;r++)t[r]=this._default;this._store=(0,w.arrayInsert)(this._store,n,t)}}e.FixedArray=S;function k(C,n){const h=[];for(let t=0;t<C;t++)h[t]=n;return h}}),define(q[7],K([0,1,13]),function(U,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class S{static createEmpty(n,h){const t=S.defaultTokenMetadata,r=new Uint32Array(2);return r[0]=n.length,r[1]=t,new S(r,n,h)}constructor(n,h,t){this._lineTokensBrand=void 0,this._tokens=n,this._tokensCount=this._tokens.length>>>1,this._text=h,this._languageIdCodec=t}equals(n){return n instanceof S?this.slicedEquals(n,0,this._tokensCount):!1}slicedEquals(n,h,t){if(this._text!==n._text||this._tokensCount!==n._tokensCount)return!1;const r=h<<1,u=r+(t<<1);for(let a=r;a<u;a++)if(this._tokens[a]!==n._tokens[a])return!1;return!0}getLineContent(){return this._text}getCount(){return this._tokensCount}getStartOffset(n){return n>0?this._tokens[n-1<<1]:0}getMetadata(n){return this._tokens[(n<<1)+1]}getLanguageId(n){const h=this._tokens[(n<<1)+1],t=w.TokenMetadata.getLanguageId(h);return this._languageIdCodec.decodeLanguageId(t)}getStandardTokenType(n){const h=this._tokens[(n<<1)+1];return w.TokenMetadata.getTokenType(h)}getForeground(n){const h=this._tokens[(n<<1)+1];return w.TokenMetadata.getForeground(h)}getClassName(n){const h=this._tokens[(n<<1)+1];return w.TokenMetadata.getClassNameFromMetadata(h)}getInlineStyle(n,h){const t=this._tokens[(n<<1)+1];return w.TokenMetadata.getInlineStyleFromMetadata(t,h)}getPresentation(n){const h=this._tokens[(n<<1)+1];return w.TokenMetadata.getPresentationFromMetadata(h)}getEndOffset(n){return this._tokens[n<<1]}findTokenIndexAtOffset(n){return S.findIndexInTokensArray(this._tokens,n)}inflate(){return this}sliceAndInflate(n,h,t){return new k(this,n,h,t)}static convertToEndOffset(n,h){const r=(n.length>>>1)-1;for(let u=0;u<r;u++)n[u<<1]=n[u+1<<1];n[r<<1]=h}static findIndexInTokensArray(n,h){if(n.length<=2)return 0;let t=0,r=(n.length>>>1)-1;for(;t<r;){const u=t+Math.floor((r-t)/2),a=n[u<<1];if(a===h)return u+1;a<h?t=u+1:a>h&&(r=u)}return t}withInserted(n){if(n.length===0)return this;let h=0,t=0,r="";const u=new Array;let a=0;for(;;){const d=h<this._tokensCount?this._tokens[h<<1]:-1,g=t<n.length?n[t]:null;if(d!==-1&&(g===null||d<=g.offset)){r+=this._text.substring(a,d);const i=this._tokens[(h<<1)+1];u.push(r.length,i),h++,a=d}else if(g){if(g.offset>a){r+=this._text.substring(a,g.offset);const i=this._tokens[(h<<1)+1];u.push(r.length,i),a=g.offset}r+=g.text,u.push(r.length,g.tokenMetadata),t++}else break}return new S(new Uint32Array(u),r,this._languageIdCodec)}}e.LineTokens=S,S.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0;class k{constructor(n,h,t,r){this._source=n,this._startOffset=h,this._endOffset=t,this._deltaOffset=r,this._firstTokenIndex=n.findTokenIndexAtOffset(h),this._tokensCount=0;for(let u=this._firstTokenIndex,a=n.getCount();u<a&&!(n.getStartOffset(u)>=t);u++)this._tokensCount++}getMetadata(n){return this._source.getMetadata(this._firstTokenIndex+n)}getLanguageId(n){return this._source.getLanguageId(this._firstTokenIndex+n)}getLineContent(){return this._source.getLineContent().substring(this._startOffset,this._endOffset)}equals(n){return n instanceof k?this._startOffset===n._startOffset&&this._endOffset===n._endOffset&&this._deltaOffset===n._deltaOffset&&this._source.slicedEquals(n._source,this._firstTokenIndex,this._tokensCount):!1}getCount(){return this._tokensCount}getForeground(n){return this._source.getForeground(this._firstTokenIndex+n)}getEndOffset(n){const h=this._source.getEndOffset(this._firstTokenIndex+n);return Math.min(this._endOffset,h)-this._startOffset+this._deltaOffset}getClassName(n){return this._source.getClassName(this._firstTokenIndex+n)}getInlineStyle(n,h){return this._source.getInlineStyle(this._firstTokenIndex+n,h)}getPresentation(n){return this._source.getPresentation(this._firstTokenIndex+n)}findTokenIndexAtOffset(n){return this._source.findTokenIndexAtOffset(n+this._startOffset-this._deltaOffset)-this._firstTokenIndex}}}),define(q[25],K([0,1,7]),function(U,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32Array=e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class S{static deleteBeginning(n,h){return n===null||n===e.EMPTY_LINE_TOKENS?n:S.delete(n,0,h)}static deleteEnding(n,h){if(n===null||n===e.EMPTY_LINE_TOKENS)return n;const t=k(n),r=t[t.length-2];return S.delete(n,h,r)}static delete(n,h,t){if(n===null||n===e.EMPTY_LINE_TOKENS||h===t)return n;const r=k(n),u=r.length>>>1;if(h===0&&r[r.length-2]===t)return e.EMPTY_LINE_TOKENS;const a=w.LineTokens.findIndexInTokensArray(r,h),d=a>0?r[a-1<<1]:0,g=r[a<<1];if(t<g){const P=t-h;for(let z=a;z<u;z++)r[z<<1]-=P;return n}let i,s;d!==h?(r[a<<1]=h,i=a+1<<1,s=h):(i=a<<1,s=d);const o=t-h;for(let P=a+1;P<u;P++){const z=r[P<<1]-o;z>s&&(r[i++]=z,r[i++]=r[(P<<1)+1],s=z)}if(i===r.length)return n;const _=new Uint32Array(i);return _.set(r.subarray(0,i),0),_.buffer}static append(n,h){if(h===e.EMPTY_LINE_TOKENS)return n;if(n===e.EMPTY_LINE_TOKENS)return h;if(n===null)return n;if(h===null)return null;const t=k(n),r=k(h),u=r.length>>>1,a=new Uint32Array(t.length+r.length);a.set(t,0);let d=t.length;const g=t[t.length-2];for(let i=0;i<u;i++)a[d++]=r[i<<1]+g,a[d++]=r[(i<<1)+1];return a.buffer}static insert(n,h,t){if(n===null||n===e.EMPTY_LINE_TOKENS)return n;const r=k(n),u=r.length>>>1;let a=w.LineTokens.findIndexInTokensArray(r,h);a>0&&r[a-1<<1]===h&&a--;for(let d=a;d<u;d++)r[d<<1]+=t;return n}}e.ContiguousTokensEditing=S;function k(C){return C instanceof Uint32Array?C:new Uint32Array(C)}e.toUint32Array=k}),define(q[26],K([0,1,24,11,42,12,25,14]),function(U,e,w,S,k,C,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class t{static deserialize(u,a,d){const g=new Uint32Array(u.buffer),i=(0,S.readUInt32BE)(u,a);a+=4;const s=(0,S.readUInt32BE)(u,a);a+=4;const o=[];for(let _=0;_<s;_++){const P=(0,S.readUInt32BE)(u,a);a+=4,o.push(g.subarray(a/4,a/4+P/4)),a+=P}return d.push(new t(i,o)),a}get startLineNumber(){return this._startLineNumber}get endLineNumber(){return this._startLineNumber+this._tokens.length-1}constructor(u,a){this._startLineNumber=u,this._tokens=a}getLineRange(){return new h.LineRange(this._startLineNumber,this._startLineNumber+this._tokens.length)}getLineTokens(u){return this._tokens[u-this._startLineNumber]}appendLineTokens(u){this._tokens.push(u)}serializeSize(){let u=0;u+=4,u+=4;for(let a=0;a<this._tokens.length;a++){const d=this._tokens[a];if(!(d instanceof Uint32Array))throw new Error("Not supported!");u+=4,u+=d.byteLength}return u}serialize(u,a){(0,S.writeUInt32BE)(u,this._startLineNumber,a),a+=4,(0,S.writeUInt32BE)(u,this._tokens.length,a),a+=4;for(let d=0;d<this._tokens.length;d++){const g=this._tokens[d];if(!(g instanceof Uint32Array))throw new Error("Not supported!");(0,S.writeUInt32BE)(u,g.byteLength,a),a+=4,u.set(new Uint8Array(g.buffer),a),a+=g.byteLength}return a}applyEdit(u,a){const[d,g]=(0,C.countEOL)(a);this._acceptDeleteRange(u),this._acceptInsertText(new k.Position(u.startLineNumber,u.startColumn),d,g)}_acceptDeleteRange(u){if(u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn)return;const a=u.startLineNumber-this._startLineNumber,d=u.endLineNumber-this._startLineNumber;if(d<0){const g=d-a;this._startLineNumber-=g;return}if(!(a>=this._tokens.length)){if(a<0&&d>=this._tokens.length){this._startLineNumber=0,this._tokens=[];return}if(a===d){this._tokens[a]=n.ContiguousTokensEditing.delete(this._tokens[a],u.startColumn-1,u.endColumn-1);return}if(a>=0)if(this._tokens[a]=n.ContiguousTokensEditing.deleteEnding(this._tokens[a],u.startColumn-1),d<this._tokens.length){const g=n.ContiguousTokensEditing.deleteBeginning(this._tokens[d],u.endColumn-1);this._tokens[a]=n.ContiguousTokensEditing.append(this._tokens[a],g),this._tokens.splice(a+1,d-a)}else this._tokens[a]=n.ContiguousTokensEditing.append(this._tokens[a],null),this._tokens=this._tokens.slice(0,a+1);else{const g=-a;this._startLineNumber-=g,this._tokens[d]=n.ContiguousTokensEditing.deleteBeginning(this._tokens[d],u.endColumn-1),this._tokens=this._tokens.slice(d)}}}_acceptInsertText(u,a,d){if(a===0&&d===0)return;const g=u.lineNumber-this._startLineNumber;if(g<0){this._startLineNumber+=a;return}if(!(g>=this._tokens.length)){if(a===0){this._tokens[g]=n.ContiguousTokensEditing.insert(this._tokens[g],u.column-1,d);return}this._tokens[g]=n.ContiguousTokensEditing.deleteEnding(this._tokens[g],u.column-1),this._tokens[g]=n.ContiguousTokensEditing.insert(this._tokens[g],u.column-1,d),this._insertLines(u.lineNumber,a)}}_insertLines(u,a){if(a===0)return;const d=[];for(let g=0;g<a;g++)d[g]=null;this._tokens=w.arrayInsert(this._tokens,u,d)}}e.ContiguousMultilineTokens=t}),define(q[15],K([0,1,11,26]),function(U,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class k{static deserialize(n){let h=0;const t=(0,w.readUInt32BE)(n,h);h+=4;const r=[];for(let u=0;u<t;u++)h=S.ContiguousMultilineTokens.deserialize(n,h,r);return r}constructor(){this._tokens=[]}add(n,h){if(this._tokens.length>0){const t=this._tokens[this._tokens.length-1];if(t.endLineNumber+1===n){t.appendLineTokens(h);return}}this._tokens.push(new S.ContiguousMultilineTokens(n,[h]))}finalize(){return this._tokens}serialize(){const n=this._serializeSize(),h=new Uint8Array(n);return this._serialize(h),h}_serializeSize(){let n=0;n+=4;for(let h=0;h<this._tokens.length;h++)n+=this._tokens[h].serializeSize();return n}_serialize(n){let h=0;(0,w.writeUInt32BE)(n,this._tokens.length,h),h+=4;for(let t=0;t<this._tokens.length;t++)h=this._tokens[t].serialize(n,h)}}e.ContiguousMultilineTokensBuilder=k}),define(q[27],K([0,1,28,5,29,43]),function(U,e,w,S,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function n(c){return c===47||c===92}e.isPathSeparator=n;function h(c){return c.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=h;function t(c){return c.indexOf("/")===-1&&(c=h(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=t;function r(c,O=w.posix.sep){if(!c)return"";const M=c.length,y=c.charCodeAt(0);if(n(y)){if(n(c.charCodeAt(1))&&!n(c.charCodeAt(2))){let R=3;const B=R;for(;R<M&&!n(c.charCodeAt(R));R++);if(B!==R&&!n(c.charCodeAt(R+1))){for(R+=1;R<M;R++)if(n(c.charCodeAt(R)))return c.slice(0,R+1).replace(/[\\/]/g,O)}}return O}else if(_(y)&&c.charCodeAt(1)===58)return n(c.charCodeAt(2))?c.slice(0,2)+O:c.slice(0,2);let m=c.indexOf("://");if(m!==-1){for(m+=3;m<M;m++)if(n(c.charCodeAt(m)))return c.slice(0,m+1)}return""}e.getRoot=r;function u(c){if(!S.isWindows||!c||c.length<5)return!1;let O=c.charCodeAt(0);if(O!==92||(O=c.charCodeAt(1),O!==92))return!1;let M=2;const y=M;for(;M<c.length&&(O=c.charCodeAt(M),O!==92);M++);return!(y===M||(O=c.charCodeAt(M+1),isNaN(O)||O===92))}e.isUNC=u;const a=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function i(c,O=S.isWindows){const M=O?a:d;return!(!c||c.length===0||/^\s+$/.test(c)||(M.lastIndex=0,M.test(c))||O&&g.test(c)||c==="."||c===".."||O&&c[c.length-1]==="."||O&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=i;function s(c,O,M){const y=c===O;return!M||y?y:!c||!O?!1:(0,k.equalsIgnoreCase)(c,O)}e.isEqual=s;function o(c,O,M,y=w.sep){if(c===O)return!0;if(!c||!O||O.length>c.length)return!1;if(M){if(!(0,k.startsWithIgnoreCase)(c,O))return!1;if(O.length===c.length)return!0;let R=O.length;return O.charAt(O.length-1)===y&&R--,c.charAt(R)===y}return O.charAt(O.length-1)!==y&&(O+=y),c.indexOf(O)===0}e.isEqualOrParent=o;function _(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=_;function P(c,O){return S.isWindows&&c.endsWith(":")&&(c+=w.sep),(0,w.isAbsolute)(c)||(c=(0,w.join)(O,c)),c=(0,w.normalize)(c),S.isWindows?(c=(0,k.rtrim)(c,w.sep),c.endsWith(":")&&(c+=w.sep)):(c=(0,k.rtrim)(c,w.sep),c||(c=w.sep)),c}e.sanitizeFilePath=P;function z(c){const O=(0,w.normalize)(c);return S.isWindows?c.length>3?!1:N(O)&&(c.length===2||O.charCodeAt(2)===92):O===w.posix.sep}e.isRootOrDriveLetter=z;function N(c,O=S.isWindows){return O?_(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=N;function E(c,O=S.isWindows){return N(c,O)?c[0]:void 0}e.getDriveLetter=E;function f(c,O,M){return O.length>c.length?-1:c===O?0:(M&&(c=c.toLowerCase(),O=O.toLowerCase()),c.indexOf(O))}e.indexOfPath=f;function b(c){const O=c.split(":");let M,y,m;for(const R of O){const B=Number(R);(0,C.isNumber)(B)?y===void 0?y=B:m===void 0&&(m=B):M=M?[M,R].join(":"):R}if(!M)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:M,line:y!==void 0?y:void 0,column:m!==void 0?m:y!==void 0?1:void 0}}e.parseLineAndColumnAware=b;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(c,O,M=8){let y="";for(let R=0;R<M;R++){let B;R===0&&S.isWindows&&!O&&(M===3||M===4)?B=I:B=v,y+=B.charAt(Math.floor(Math.random()*B.length))}let m;return O?m=`${O}-${y}`:m=y,c?(0,w.join)(c,m):m}e.randomPath=D}),define(q[30],K([0,1,4,5,16]),function(U,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var C;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.vscodeManagedRemoteResource="vscode-managed-remote-resource",r.vscodeUserData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeInteractiveInput="vscode-interactive-input",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.vscodeChatSesssion="vscode-chat-editor",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp",r.vsls="vsls",r.vscodeSourceControl="vscode-scm"})(C||(e.Schemas=C={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class n{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(u){this._preferredWebSchema=u}setDelegate(u){this._delegate=u}setServerRootPath(u){this._remoteResourcesPath=`${u}/${C.vscodeRemoteResource}`}set(u,a,d){this._hosts[u]=a,this._ports[u]=d}setConnectionToken(u,a){this._connectionTokens[u]=a}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(u){if(this._delegate)try{return this._delegate(u)}catch(o){return w.onUnexpectedError(o),u}const a=u.authority;let d=this._hosts[a];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const g=this._ports[a],i=this._connectionTokens[a];let s=`path=${encodeURIComponent(u.path)}`;return typeof i=="string"&&(s+=`&${e.connectionTokenQueryName}=${encodeURIComponent(i)}`),k.URI.from({scheme:S.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${d}:${g}`,path:this._remoteResourcesPath,query:s})}}e.RemoteAuthorities=new n,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class h{asBrowserUri(u){const a=this.toUri(u,U);return this.uriToBrowserUri(a)}uriToBrowserUri(u){return u.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(u):u.scheme===C.file&&(S.isNative||S.isWebWorker&&S.globals.origin===`${C.vscodeFileResource}://${h.FALLBACK_AUTHORITY}`)?u.with({scheme:C.vscodeFileResource,authority:u.authority||h.FALLBACK_AUTHORITY,query:null,fragment:null}):u}asFileUri(u){const a=this.toUri(u,U);return this.uriToFileUri(a)}uriToFileUri(u){return u.scheme===C.vscodeFileResource?u.with({scheme:C.file,authority:u.authority!==h.FALLBACK_AUTHORITY?u.authority:null,query:null,fragment:null}):u}toUri(u,a){return k.URI.isUri(u)?u:k.URI.parse(a.toUrl(u))}}h.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new h;var t;(function(r){const u=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);r.CoopAndCoep=Object.freeze(u.get("3"));const a="vscode-coi";function d(i){let s;typeof i=="string"?s=new URL(i).searchParams:i instanceof URL?s=i.searchParams:k.URI.isUri(i)&&(s=new URL(i.toString(!0)).searchParams);const o=s?.get(a);if(o)return u.get(o)}r.getHeadersFromQuery=d;function g(i,s,o){if(!globalThis.crossOriginIsolated)return;const _=s&&o?"3":o?"2":"1";i instanceof URLSearchParams?i.set(a,_):i[a]=_}r.addSearchParam=g})(t||(e.COI=t={}))}),define(q[17],K([0,1,27,30,28,5,29,16]),function(U,e,w,S,k,C,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function t(g){return(0,h.uriToFsPath)(g,!0)}e.originalFSPath=t;class r{constructor(i){this._ignorePathCasing=i}compare(i,s,o=!1){return i===s?0:(0,n.compare)(this.getComparisonKey(i,o),this.getComparisonKey(s,o))}isEqual(i,s,o=!1){return i===s?!0:!i||!s?!1:this.getComparisonKey(i,o)===this.getComparisonKey(s,o)}getComparisonKey(i,s=!1){return i.with({path:this._ignorePathCasing(i)?i.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(i){return this._ignorePathCasing(i)}isEqualOrParent(i,s,o=!1){if(i.scheme===s.scheme){if(i.scheme===S.Schemas.file)return w.isEqualOrParent(t(i),t(s),this._ignorePathCasing(i))&&i.query===s.query&&(o||i.fragment===s.fragment);if((0,e.isEqualAuthority)(i.authority,s.authority))return w.isEqualOrParent(i.path,s.path,this._ignorePathCasing(i),"/")&&i.query===s.query&&(o||i.fragment===s.fragment)}return!1}joinPath(i,...s){return h.URI.joinPath(i,...s)}basenameOrAuthority(i){return(0,e.basename)(i)||i.authority}basename(i){return k.posix.basename(i.path)}extname(i){return k.posix.extname(i.path)}dirname(i){if(i.path.length===0)return i;let s;return i.scheme===S.Schemas.file?s=h.URI.file(k.dirname(t(i))).path:(s=k.posix.dirname(i.path),i.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),s="/")),i.with({path:s})}normalizePath(i){if(!i.path.length)return i;let s;return i.scheme===S.Schemas.file?s=h.URI.file(k.normalize(t(i))).path:s=k.posix.normalize(i.path),i.with({path:s})}relativePath(i,s){if(i.scheme!==s.scheme||!(0,e.isEqualAuthority)(i.authority,s.authority))return;if(i.scheme===S.Schemas.file){const P=k.relative(t(i),t(s));return C.isWindows?w.toSlashes(P):P}let o=i.path||"/";const _=s.path||"/";if(this._ignorePathCasing(i)){let P=0;for(const z=Math.min(o.length,_.length);P<z&&!(o.charCodeAt(P)!==_.charCodeAt(P)&&o.charAt(P).toLowerCase()!==_.charAt(P).toLowerCase());P++);o=_.substr(0,P)+o.substr(P)}return k.posix.relative(o,_)}resolvePath(i,s){if(i.scheme===S.Schemas.file){const o=h.URI.file(k.resolve(t(i),s));return i.with({authority:o.authority,path:o.path})}return s=w.toPosixPath(s),i.with({path:k.posix.resolve(i.path,s)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,s){return i===s||i!==void 0&&s!==void 0&&(0,n.equalsIgnoreCase)(i,s)}hasTrailingPathSeparator(i,s=k.sep){if(i.scheme===S.Schemas.file){const o=t(i);return o.length>w.getRoot(o).length&&o[o.length-1]===s}else{const o=i.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,s=k.sep){return(0,e.hasTrailingPathSeparator)(i,s)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,s=k.sep){let o=!1;if(i.scheme===S.Schemas.file){const _=t(i);o=_!==void 0&&_.length===w.getRoot(_).length&&_[_.length-1]===s}else{s="/";const _=i.path;o=_.length===1&&_.charCodeAt(_.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(i,s)?i.with({path:i.path+"/"}):i}}e.ExtUri=r,e.extUri=new r(()=>!1),e.extUriBiasedIgnorePathCase=new r(g=>g.scheme===S.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new r(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function u(g,i){const s=[];for(let o=0;o<g.length;o++){const _=i(g[o]);g.some((P,z)=>z===o?!1:(0,e.isEqualOrParent)(_,i(P)))||s.push(g[o])}return s}e.distinctParents=u;var a;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function i(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(z=>{const[N,E]=z.split(":");N&&E&&o.set(N,E)});const P=s.path.substring(0,s.path.indexOf(";"));return P&&o.set(g.META_DATA_MIME,P),o}g.parseMetaData=i})(a||(e.DataUri=a={}));function d(g,i,s){if(i){let o=g.path;return o&&o[0]!==k.posix.sep&&(o=k.posix.sep+o),g.with({scheme:s,authority:i,path:o})}return g.with({scheme:s})}e.toLocalResource=d}),define(q[18],K([0,1,44,4,31,2,17,5,22]),function(U,e,w,S,k,C,n,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function r(p){return!!p&&typeof p.then=="function"}e.isThenable=r;function u(p){const l=new w.CancellationTokenSource,T=p(l.token),L=new Promise((A,F)=>{const H=l.token.onCancellationRequested(()=>{H.dispose(),l.dispose(),F(new S.CancellationError)});Promise.resolve(T).then(Q=>{H.dispose(),l.dispose(),A(Q)},Q=>{H.dispose(),l.dispose(),F(Q)})});return new class{cancel(){l.cancel()}then(A,F){return L.then(A,F)}catch(A){return this.then(void 0,A)}finally(A){return L.finally(A)}}}e.createCancelablePromise=u;function a(p,l,T){return new Promise((L,A)=>{const F=l.onCancellationRequested(()=>{F.dispose(),L(T)});p.then(L,A).finally(()=>F.dispose())})}e.raceCancellation=a;function d(p,l){return new Promise((T,L)=>{const A=l.onCancellationRequested(()=>{A.dispose(),L(new S.CancellationError)});p.then(T,L).finally(()=>A.dispose())})}e.raceCancellationError=d;async function g(p){let l=-1;const T=p.map((L,A)=>L.then(F=>(l=A,F)));try{return await Promise.race(T)}finally{p.forEach((L,A)=>{A!==l&&L.cancel()})}}e.raceCancellablePromises=g;function i(p,l,T){let L;const A=setTimeout(()=>{L?.(void 0),T?.()},l);return Promise.race([p.finally(()=>clearTimeout(A)),new Promise(F=>L=F)])}e.raceTimeout=i;function s(p){return new Promise((l,T)=>{const L=p();r(L)?L.then(l,T):l(L)})}e.asPromise=s;class o{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(l){if(this.isDisposed)throw new Error("Throttler is disposed");if(this.activePromise){if(this.queuedPromiseFactory=l,!this.queuedPromise){const T=()=>{if(this.queuedPromise=null,this.isDisposed)return;const L=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,L};this.queuedPromise=new Promise(L=>{this.activePromise.then(T,T).then(L)})}return new Promise((T,L)=>{this.queuedPromise.then(T,L)})}return this.activePromise=l(),new Promise((T,L)=>{this.activePromise.then(A=>{this.activePromise=null,T(A)},A=>{this.activePromise=null,L(A)})})}dispose(){this.isDisposed=!0}}e.Throttler=o;class _{constructor(){this.current=Promise.resolve(null)}queue(l){return this.current=this.current.then(()=>l(),()=>l())}}e.Sequencer=_;class P{constructor(){this.promiseMap=new Map}queue(l,T){const A=(this.promiseMap.get(l)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(l)===A&&this.promiseMap.delete(l)});return this.promiseMap.set(l,A),A}}e.SequencerByKey=P;const z=(p,l)=>{let T=!0;const L=setTimeout(()=>{T=!1,l()},p);return{isTriggered:()=>T,dispose:()=>{clearTimeout(L),T=!1}}},N=p=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,p())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class E{constructor(l){this.defaultDelay=l,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(l,T=this.defaultDelay){this.task=l,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((A,F)=>{this.doResolve=A,this.doReject=F}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const A=this.task;return this.task=null,A()}}));const L=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=T===t.MicrotaskDelay?N(L):z(T,L),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new S.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=E;class f{constructor(l){this.delayer=new E(l),this.throttler=new o}trigger(l,T){return this.delayer.trigger(()=>this.throttler.queue(l),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=f;class b{constructor(){this._isOpen=!1,this._promise=new Promise((l,T)=>{this._completePromise=l})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class v extends b{constructor(l){super(),this._timeout=setTimeout(()=>this.open(),l)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=v;function I(p,l){return l?new Promise((T,L)=>{const A=setTimeout(()=>{F.dispose(),T()},p),F=l.onCancellationRequested(()=>{clearTimeout(A),F.dispose(),L(new S.CancellationError)})}):u(T=>I(p,T))}e.timeout=I;function D(p,l=0){const T=setTimeout(p,l);return(0,C.toDisposable)(()=>clearTimeout(T))}e.disposableTimeout=D;function c(p){const l=[];let T=0;const L=p.length;function A(){return T<L?p[T++]():null}function F(H){H!=null&&l.push(H);const Q=A();return Q?Q.then(F):Promise.resolve(l)}return Promise.resolve(null).then(F)}e.sequence=c;function O(p,l=L=>!!L,T=null){let L=0;const A=p.length,F=()=>{if(L>=A)return Promise.resolve(T);const H=p[L++];return Promise.resolve(H()).then(X=>l(X)?Promise.resolve(X):F())};return F()}e.first=O;function M(p,l=L=>!!L,T=null){if(p.length===0)return Promise.resolve(T);let L=p.length;const A=()=>{L=-1;for(const F of p)F.cancel?.()};return new Promise((F,H)=>{for(const Q of p)Q.then(X=>{--L>=0&&l(X)?(A(),F(X)):L===0&&F(T)}).catch(X=>{--L>=0&&(A(),H(X))})})}e.firstParallel=M;class y{constructor(l){this._size=0,this.maxDegreeOfParalellism=l,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(l){return this._size++,new Promise((T,L)=>{this.outstandingPromises.push({factory:l,c:T,e:L}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const l=this.outstandingPromises.shift();this.runningPromises++;const T=l.factory();T.then(l.c,l.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=y;class m extends y{constructor(){super(1)}}e.Queue=m;class R{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const l=new ee;return this.drainers.add(l),l.p}isDrained(){for(const[,l]of this.queues)if(l.size>0)return!1;return!0}queueFor(l,T=n.extUri){const L=T.getComparisonKey(l);let A=this.queues.get(L);return A||(A=new m,k.Event.once(A.onDrained)(()=>{A?.dispose(),this.queues.delete(L),this.onDidQueueDrain()}),this.queues.set(L,A)),A}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const l of this.drainers)l.complete();this.drainers.clear()}dispose(){for(const[,l]of this.queues)l.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=R;class B{constructor(l,T){this._token=-1,typeof l=="function"&&typeof T=="number"&&this.setIfNotSet(l,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(l,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,l()},T)}setIfNotSet(l,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,l()},T))}}e.TimeoutTimer=B;class j{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(l,T){this.cancel(),this._token=setInterval(()=>{l()},T)}}e.IntervalTimer=j;class G{constructor(l,T){this.timeoutToken=-1,this.runner=l,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(l=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,l)}get delay(){return this.timeout}set delay(l){this.timeout=l}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=G;class ${constructor(l,T){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.runner=l,this.timeout=T,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(l=this.timeout){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(l/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=$;class W extends G{constructor(l,T){super(l,T),this.units=[]}work(l){this.units.push(l),this.isScheduled()||this.schedule()}doRun(){const l=this.units;this.units=[],this.runner?.(l)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=W;class V extends C.Disposable{constructor(l,T){super(),this.options=l,this.handler=T,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(l){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+l.length>this.options.maxBufferedWork)return!1}else if(this.pending+l.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const T of l)this.pendingWork.push(T);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new G(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=V,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=p=>{(0,h.setTimeout0)(()=>{if(l)return;const T=Date.now()+15;p(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,T-Date.now())}}))});let l=!1;return{dispose(){l||(l=!0)}}}:e.runWhenIdle=(p,l)=>{const T=requestIdleCallback(p,typeof l=="number"?{timeout:l}:void 0);let L=!1;return{dispose(){L||(L=!0,cancelIdleCallback(T))}}}}();class Z{constructor(l){this._didRun=!1,this._executor=()=>{try{this._value=l()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=Z;async function J(p,l,T){let L;for(let A=0;A<T;A++)try{return await p()}catch(F){L=F,await I(l)}throw L}e.retry=J;class oe{hasPending(l){return this._pending?typeof l=="number"?this._pending.taskId===l:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(l,T,L){return this._pending={taskId:l,cancel:()=>L?.(),promise:T},T.then(()=>this.donePending(l),()=>this.donePending(l)),T}donePending(l){this._pending&&l===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const l=this._next;this._next=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}setNext(l){if(this._next)this._next.run=l;else{let T,L;const A=new Promise((F,H)=>{T=F,L=H});this._next={run:l,promise:A,promiseResolve:T,promiseReject:L}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=oe;class ae{constructor(l,T=()=>Date.now()){this.interval=l,this.nowFn=T,this.lastIncrementTime=0,this.value=0}increment(){const l=this.nowFn();return l-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=l,this.value=0),this.value++,this.value}}e.IntervalCounter=ae;var x;(function(p){p[p.Resolved=0]="Resolved",p[p.Rejected=1]="Rejected"})(x||(x={}));class ee{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((l,T)=>{this.completeCallback=l,this.errorCallback=T})}complete(l){return new Promise(T=>{this.completeCallback(l),this.outcome={outcome:0,value:l},T()})}error(l){return new Promise(T=>{this.errorCallback(l),this.outcome={outcome:1,value:l},T()})}cancel(){return this.error(new S.CancellationError)}}e.DeferredPromise=ee;var te;(function(p){async function l(L){let A;const F=await Promise.all(L.map(H=>H.then(Q=>Q,Q=>{A||(A=Q)})));if(typeof A<"u")throw A;return F}p.settled=l;function T(L){return new Promise(async(A,F)=>{try{await L(A,F)}catch(H){F(H)}})}p.withAsyncBody=T})(te||(e.Promises=te={}));var ne;(function(p){p[p.Initial=0]="Initial",p[p.DoneOK=1]="DoneOK",p[p.DoneError=2]="DoneError"})(ne||(ne={}));class Y{static fromArray(l){return new Y(T=>{T.emitMany(l)})}static fromPromise(l){return new Y(async T=>{T.emitMany(await l)})}static fromPromises(l){return new Y(async T=>{await Promise.all(l.map(async L=>T.emitOne(await L)))})}static merge(l){return new Y(async T=>{await Promise.all(l.map(async L=>{for await(const A of L)T.emitOne(A)}))})}constructor(l){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const T={emitOne:L=>this.emitOne(L),emitMany:L=>this.emitMany(L),reject:L=>this.reject(L)};try{await Promise.resolve(l(T)),this.resolve()}catch(L){this.reject(L)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(l<this._results.length)return{done:!1,value:this._results[l++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(l,T){return new Y(async L=>{for await(const A of l)L.emitOne(T(A))})}map(l){return Y.map(this,l)}static filter(l,T){return new Y(async L=>{for await(const A of l)T(A)&&L.emitOne(A)})}filter(l){return Y.filter(this,l)}static coalesce(l){return Y.filter(l,T=>!!T)}coalesce(){return Y.coalesce(this)}static async toPromise(l){const T=[];for await(const L of l)T.push(L);return T}toPromise(){return Y.toPromise(this)}emitOne(l){this._state===0&&(this._results.push(l),this._onStateChanged.fire())}emitMany(l){this._state===0&&(this._results=this._results.concat(l),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(l){this._state===0&&(this._state=2,this._error=l,this._onStateChanged.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class ie extends Y{constructor(l,T){super(T),this._source=l}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ie;function ue(p){const l=new w.CancellationTokenSource,T=p(l.token);return new ie(l,async L=>{const A=l.token.onCancellationRequested(()=>{A.dispose(),l.dispose(),L.reject(new S.CancellationError)});try{for await(const F of T){if(l.token.isCancellationRequested)return;L.emitOne(F)}A.dispose(),l.dispose()}catch(F){A.dispose(),l.dispose(),L.reject(F)}})}e.createCancelableAsyncIterable=ue}),define(q[19],K([0,1,32]),function(U,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nullTokenizeEncoded=e.nullTokenize=e.NullState=void 0,e.NullState=new class{clone(){return this}equals(C){return this===C}};function S(C,n){return new w.TokenizationResult([new w.Token(0,"",C)],n)}e.nullTokenize=S;function k(C,n){const h=new Uint32Array(2);return h[0]=0,h[1]=(C<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new w.EncodedTokenizationResult(h,n===null?e.NullState:n)}e.nullTokenizeEncoded=k}),define(q[33],K([0,1,18,4,5,34,12,14,45,19,23,15,7]),function(U,e,w,S,k,C,n,h,t,r,u,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultBackgroundTokenizer=e.RangePriorityQueueImpl=e.TokenizationStateStore=e.TrackingTokenizationStateStore=e.TokenizerWithStateStoreAndTextModel=e.TokenizerWithStateStore=void 0;var g;(function(E){E[E.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(g||(g={}));class i{constructor(f,b){this.tokenizationSupport=b,this.initialState=this.tokenizationSupport.getInitialState(),this.store=new o(f)}getStartState(f){return f===1?this.initialState:this.store.getEndState(f-1)}}e.TokenizerWithStateStore=i;class s extends i{constructor(f,b,v,I){super(f,b),this._textModel=v,this._languageIdCodec=I}updateTokensUntilLine(f,b){const v=this._textModel.getLanguageId();for(;;){const I=this.store.getFirstInvalidEndStateLineNumber();if(!I||I>b)break;const D=this._textModel.getLineContent(I),c=this.getStartState(I),O=z(this._languageIdCodec,v,this.tokenizationSupport,D,!0,c);f.add(I,O.tokens),this.store.setEndState(I,O.endState)}}getTokenTypeIfInsertingCharacter(f,b){const v=this.getStartState(f.lineNumber);if(!v)return 0;const I=this._textModel.getLanguageId(),D=this._textModel.getLineContent(f.lineNumber),c=D.substring(0,f.column-1)+b+D.substring(f.column-1),O=z(this._languageIdCodec,I,this.tokenizationSupport,c,!0,v),M=new d.LineTokens(O.tokens,c,this._languageIdCodec);if(M.getCount()===0)return 0;const y=M.findTokenIndexAtOffset(f.column-1);return M.getStandardTokenType(y)}tokenizeLineWithEdit(f,b,v){const I=f.lineNumber,D=f.column,c=this.getStartState(I);if(!c)return null;const O=this._textModel.getLineContent(I),M=O.substring(0,D-1)+v+O.substring(D-1+b),y=this._textModel.getLanguageIdAtPosition(I,0),m=z(this._languageIdCodec,y,this.tokenizationSupport,M,!0,c);return new d.LineTokens(m.tokens,M,this._languageIdCodec)}isCheapToTokenize(f){const b=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<b||f===b&&this._textModel.getLineLength(f)<2048}tokenizeHeuristically(f,b,v){if(v<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(b<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(f,v),{heuristicTokens:!1};let I=this.guessStartState(b);const D=this._textModel.getLanguageId();for(let c=b;c<=v;c++){const O=this._textModel.getLineContent(c),M=z(this._languageIdCodec,D,this.tokenizationSupport,O,!0,I);f.add(c,M.tokens),I=M.endState}return{heuristicTokens:!0}}guessStartState(f){let b=this._textModel.getLineFirstNonWhitespaceColumn(f);const v=[];let I=null;for(let O=f-1;b>1&&O>=1;O--){const M=this._textModel.getLineFirstNonWhitespaceColumn(O);if(M!==0&&M<b&&(v.push(this._textModel.getLineContent(O)),b=M,I=this.getStartState(O),I))break}I||(I=this.tokenizationSupport.getInitialState()),v.reverse();const D=this._textModel.getLanguageId();let c=I;for(const O of v)c=z(this._languageIdCodec,D,this.tokenizationSupport,O,!1,c).endState;return c}}e.TokenizerWithStateStoreAndTextModel=s;class o{constructor(f){this.lineCount=f,this.tokenizationStateStore=new _,this._invalidEndStatesLineNumbers=new P,this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(1,f+1))}getEndState(f){return this.tokenizationStateStore.getEndState(f)}setEndState(f,b){for(;;){const I=this._invalidEndStatesLineNumbers.min;if(I!==null&&I<=f)this._invalidEndStatesLineNumbers.removeMin();else break}const v=this.tokenizationStateStore.setEndState(f,b);return v&&f<this.lineCount&&this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(f+1,f+2)),v}acceptChange(f,b){this.lineCount+=b-f.length,this.tokenizationStateStore.acceptChange(f,b),this._invalidEndStatesLineNumbers.addRangeAndResize(new t.OffsetRange(f.startLineNumber,f.endLineNumberExclusive),b)}acceptChanges(f){for(const b of f){const[v]=(0,n.countEOL)(b.text);this.acceptChange(new h.LineRange(b.range.startLineNumber,b.range.endLineNumber+1),v+1)}}invalidateEndStateRange(f){this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(f.startLineNumber,f.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this._invalidEndStatesLineNumbers.min}getFirstInvalidEndStateLineNumberOrMax(){return this._invalidEndStatesLineNumbers.min||Number.MAX_SAFE_INTEGER}isTokenizationComplete(){return this._invalidEndStatesLineNumbers.min===null}}e.TrackingTokenizationStateStore=o;class _{constructor(){this._lineEndStates=new u.FixedArray(null)}getEndState(f){return this._lineEndStates.get(f)}setEndState(f,b){const v=this._lineEndStates.get(f);return v&&v.equals(b)?!1:(this._lineEndStates.set(f,b),!0)}acceptChange(f,b){let v=f.length;b>0&&v>0&&(v--,b--),this._lineEndStates.replace(f.startLineNumber,v,b)}acceptChanges(f){for(const b of f){const[v]=(0,n.countEOL)(b.text);this.acceptChange(new h.LineRange(b.range.startLineNumber,b.range.endLineNumber+1),v+1)}}}e.TokenizationStateStore=_;class P{constructor(){this._ranges=[]}getRanges(){return this._ranges}get min(){return this._ranges.length===0?null:this._ranges[0].start}removeMin(){if(this._ranges.length===0)return null;const f=this._ranges[0];return f.start+1===f.endExclusive?this._ranges.shift():this._ranges[0]=new t.OffsetRange(f.start+1,f.endExclusive),f.start}addRange(f){t.OffsetRange.addRange(f,this._ranges)}addRangeAndResize(f,b){let v=0;for(;!(v>=this._ranges.length||f.start<=this._ranges[v].endExclusive);)v++;let I=v;for(;!(I>=this._ranges.length||f.endExclusive<this._ranges[I].start);)I++;const D=b-f.length;for(let c=I;c<this._ranges.length;c++)this._ranges[c]=this._ranges[c].delta(D);if(v===I){const c=new t.OffsetRange(f.start,f.start+b);c.isEmpty||this._ranges.splice(v,0,c)}else{const c=Math.min(f.start,this._ranges[v].start),O=Math.max(f.endExclusive,this._ranges[I-1].endExclusive),M=new t.OffsetRange(c,O+D);M.isEmpty?this._ranges.splice(v,I-v):this._ranges.splice(v,I-v,M)}}toString(){return this._ranges.map(f=>f.toString()).join(" + ")}}e.RangePriorityQueueImpl=P;function z(E,f,b,v,I,D){let c=null;if(b)try{c=b.tokenizeEncoded(v,I,D.clone())}catch(O){(0,S.onUnexpectedError)(O)}return c||(c=(0,r.nullTokenizeEncoded)(E.encodeLanguageId(f),D)),d.LineTokens.convertToEndOffset(c.tokens,v.length),c}class N{constructor(f,b){this._tokenizerWithStateStore=f,this._backgroundTokenStore=b,this._isDisposed=!1,this._isScheduled=!1}dispose(){this._isDisposed=!0}handleChanges(){this._beginBackgroundTokenization()}_beginBackgroundTokenization(){this._isScheduled||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._isScheduled=!0,(0,w.runWhenIdle)(f=>{this._isScheduled=!1,this._backgroundTokenizeWithDeadline(f)}))}_backgroundTokenizeWithDeadline(f){const b=Date.now()+f.timeRemaining(),v=()=>{this._isDisposed||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._backgroundTokenizeForAtLeast1ms(),Date.now()<b?(0,k.setTimeout0)(v):this._beginBackgroundTokenization())};v()}_backgroundTokenizeForAtLeast1ms(){const f=this._tokenizerWithStateStore._textModel.getLineCount(),b=new a.ContiguousMultilineTokensBuilder,v=C.StopWatch.create(!1);do if(v.elapsed()>1||this._tokenizeOneInvalidLine(b)>=f)break;while(this._hasLinesToTokenize());this._backgroundTokenStore.setTokens(b.finalize()),this.checkFinished()}_hasLinesToTokenize(){return this._tokenizerWithStateStore?!this._tokenizerWithStateStore.store.isTokenizationComplete():!1}_tokenizeOneInvalidLine(f){if(!this._tokenizerWithStateStore||!this._hasLinesToTokenize())return this._tokenizerWithStateStore._textModel.getLineCount()+1;const b=this._tokenizerWithStateStore.store.getFirstInvalidEndStateLineNumber();return this._tokenizerWithStateStore.updateTokensUntilLine(f,b),b}checkFinished(){this._isDisposed||this._tokenizerWithStateStore.store.isTokenizationComplete()&&this._backgroundTokenStore.backgroundTokenizationFinished()}requestTokens(f,b){this._tokenizerWithStateStore.store.invalidateEndStateRange(new h.LineRange(f,b))}}e.DefaultBackgroundTokenizer=N}),define(q[35],K([0,1,31,2,34,13,32]),function(U,e,w,S,k,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class h extends S.Disposable{constructor(r,u,a,d,g=()=>!1,i){super(),this._grammar=r,this._initialState=u,this._containsEmbeddedLanguages=a,this._createBackgroundTokenizer=d,this._backgroundTokenizerShouldOnlyVerifyTokens=g,this._reportTokenizationTime=i,this._seenLanguages=[],this._onDidEncounterLanguage=this._register(new w.Emitter),this.onDidEncounterLanguage=this._onDidEncounterLanguage.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this._backgroundTokenizerShouldOnlyVerifyTokens()}getInitialState(){return this._initialState}tokenize(r,u,a){throw new Error("Not supported!")}createBackgroundTokenizer(r,u){if(this._createBackgroundTokenizer)return this._createBackgroundTokenizer(r,u)}tokenizeEncoded(r,u,a){const d=this._reportTokenizationTime&&Math.random()*1e4<1,g=d?new k.StopWatch(!0):void 0,i=this._grammar.tokenizeLine2(r,a,500);if(d){const o=g.elapsed();this._reportTokenizationTime(o,r.length)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${r.substring(0,100)}`),new n.EncodedTokenizationResult(i.tokens,a);if(this._containsEmbeddedLanguages){const o=this._seenLanguages,_=i.tokens;for(let P=0,z=_.length>>>1;P<z;P++){const N=_[(P<<1)+1],E=C.TokenMetadata.getLanguageId(N);o[E]||(o[E]=!0,this._onDidEncounterLanguage.fire(E))}}let s;return a.equals(i.ruleStack)?s=a:s=i.ruleStack,new n.EncodedTokenizationResult(i.tokens,s)}}e.TextMateTokenizationSupport=h}),define(q[36],K([0,1,19,2,10]),function(U,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationSupportWithLineLimit=void 0;class C extends S.Disposable{get backgroundTokenizerShouldOnlyVerifyTokens(){return this._actual.backgroundTokenizerShouldOnlyVerifyTokens}constructor(h,t,r){super(),this._encodedLanguageId=h,this._actual=t,this._maxTokenizationLineLength=r,this._register((0,k.keepAlive)(this._maxTokenizationLineLength))}getInitialState(){return this._actual.getInitialState()}tokenize(h,t,r){throw new Error("Not supported!")}tokenizeEncoded(h,t,r){return h.length>=this._maxTokenizationLineLength.get()?(0,w.nullTokenizeEncoded)(this._encodedLanguageId,r):this._actual.tokenizeEncoded(h,t,r)}createBackgroundTokenizer(h,t){if(this._actual.createBackgroundTokenizer)return this._actual.createBackgroundTokenizer(h,t)}}e.TokenizationSupportWithLineLimit=C}),define(q[37],K([0,1,17]),function(U,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class S{constructor(){this._scopeNameToLanguageRegistration=Object.create(null)}reset(){this._scopeNameToLanguageRegistration=Object.create(null)}register(C){if(this._scopeNameToLanguageRegistration[C.scopeName]){const n=this._scopeNameToLanguageRegistration[C.scopeName];w.isEqual(n.location,C.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${C.scopeName}.
Old grammar file: ${n.location.toString()}.
New grammar file: ${C.location.toString()}`)}this._scopeNameToLanguageRegistration[C.scopeName]=C}getGrammarDefinition(C){return this._scopeNameToLanguageRegistration[C]||null}}e.TMScopeRegistry=S}),define(q[38],K([0,1,2,37]),function(U,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class k extends w.Disposable{constructor(n,h,t,r){super(),this._host=n,this._initialState=t.INITIAL,this._scopeRegistry=new S.TMScopeRegistry,this._injections={},this._injectedEmbeddedLanguages={},this._languageToScope=new Map,this._grammarRegistry=this._register(new t.Registry({onigLib:r,loadGrammar:async u=>{const a=this._scopeRegistry.getGrammarDefinition(u);if(!a)return this._host.logTrace(`No grammar found for scope ${u}`),null;const d=a.location;try{const g=await this._host.readFile(d);return t.parseRawGrammar(g,d.path)}catch(g){return this._host.logError(`Unable to load and parse grammar for scope ${u} from ${d}`,g),null}},getInjections:u=>{const a=u.split(".");let d=[];for(let g=1;g<=a.length;g++){const i=a.slice(0,g).join(".");d=[...d,...this._injections[i]||[]]}return d}}));for(const u of h){if(this._scopeRegistry.register(u),u.injectTo){for(const a of u.injectTo){let d=this._injections[a];d||(this._injections[a]=d=[]),d.push(u.scopeName)}if(u.embeddedLanguages)for(const a of u.injectTo){let d=this._injectedEmbeddedLanguages[a];d||(this._injectedEmbeddedLanguages[a]=d=[]),d.push(u.embeddedLanguages)}}u.language&&this._languageToScope.set(u.language,u.scopeName)}}has(n){return this._languageToScope.has(n)}setTheme(n,h){this._grammarRegistry.setTheme(n,h)}getColorMap(){return this._grammarRegistry.getColorMap()}async createGrammar(n,h){const t=this._languageToScope.get(n);if(typeof t!="string")throw new Error(e.missingTMGrammarErrorMessage);const r=this._scopeRegistry.getGrammarDefinition(t);if(!r)throw new Error(e.missingTMGrammarErrorMessage);const u=r.embeddedLanguages;if(this._injectedEmbeddedLanguages[t]){const g=this._injectedEmbeddedLanguages[t];for(const i of g)for(const s of Object.keys(i))u[s]=i[s]}const a=Object.keys(u).length>0;let d;try{d=await this._grammarRegistry.loadGrammarWithConfiguration(t,h,{embeddedLanguages:u,tokenTypes:r.tokenTypes,balancedBracketSelectors:r.balancedBracketSelectors,unbalancedBracketSelectors:r.unbalancedBracketSelectors})}catch(g){throw g.message&&g.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):g}return{languageId:n,grammar:d,initialState:this._initialState,containsEmbeddedLanguages:a,sourceExtensionId:r.sourceExtensionId}}}e.TMGrammarFactory=k}),define(q[39],K([0,1,18,10,14,46,33,15,7,35,36,47]),function(U,e,w,S,k,C,n,h,t,r,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerModel=void 0;class d extends C.MirrorTextModel{constructor(s,o,_,P,z,N,E,f){super(s,o,_,P),this._worker=z,this._languageId=N,this._encodedLanguageId=E,this._tokenizationStateStore=null,this._isDisposed=!1,this._maxTokenizationLineLength=(0,S.observableValue)("_maxTokenizationLineLength",-1),this.tokenizeDebouncer=new w.RunOnceScheduler(()=>this._tokenize(),10),this._maxTokenizationLineLength.set(f,void 0),this._resetTokenization()}dispose(){this._isDisposed=!0,super.dispose()}onLanguageId(s,o){this._languageId=s,this._encodedLanguageId=o,this._resetTokenization()}onEvents(s){super.onEvents(s),this._tokenizationStateStore&&this._tokenizationStateStore.store.acceptChanges(s.changes),this.tokenizeDebouncer.schedule()}acceptMaxTokenizationLineLength(s){this._maxTokenizationLineLength.set(s,void 0)}retokenize(s,o){this._tokenizationStateStore&&(this._tokenizationStateStore.store.invalidateEndStateRange(new k.LineRange(s,o)),this.tokenizeDebouncer.schedule())}_resetTokenization(){this._tokenizationStateStore=null;const s=this._languageId,o=this._encodedLanguageId;this._worker.getOrCreateGrammar(s,o).then(_=>{if(!(this._isDisposed||s!==this._languageId||o!==this._encodedLanguageId||!_)){if(_.grammar){const P=new u.TokenizationSupportWithLineLimit(this._encodedLanguageId,new r.TextMateTokenizationSupport(_.grammar,_.initialState,!1,void 0,void 0,(z,N)=>{this._worker.reportTokenizationTime(z,s,_.sourceExtensionId,N)}),this._maxTokenizationLineLength);this._tokenizationStateStore=new n.TokenizerWithStateStore(this._lines.length,P)}else this._tokenizationStateStore=null;this._tokenize()}})}_tokenize(){if(this._isDisposed||!this._tokenizationStateStore)return;const s=new Date().getTime();for(;;){let o=0;const _=new h.ContiguousMultilineTokensBuilder,P=new g;for(;;){const E=this._tokenizationStateStore.store.getFirstInvalidEndStateLineNumber();if(E===null||o>200)break;o++;const f=this._lines[E-1],b=this._tokenizationStateStore.getStartState(E),v=this._tokenizationStateStore.tokenizationSupport.tokenizeEncoded(f,!0,b);if(this._tokenizationStateStore.store.setEndState(E,v.endState)){const D=(0,a.diffStateStacksRefEq)(b,v.endState);P.setState(E,D)}else P.setState(E,null);if(t.LineTokens.convertToEndOffset(v.tokens,f.length),_.add(E,v.tokens),new Date().getTime()-s>20)break}if(o===0)break;const z=P.getStateDeltas();if(this._worker.setTokensAndStates(this._uri,this._versionId,_.serialize(),z),new Date().getTime()-s>20){setTimeout(()=>this._tokenize(),3);return}}}}e.TextMateWorkerModel=d;class g{constructor(){this._lastStartLineNumber=-1,this._stateDeltas=[]}setState(s,o){s===this._lastStartLineNumber+1?this._stateDeltas[this._stateDeltas.length-1].stateDeltas.push(o):this._stateDeltas.push({startLineNumber:s,stateDeltas:[o]}),this._lastStartLineNumber=s}getStateDeltas(){return this._stateDeltas}}}),define(q[48],K([0,1,16,38,39]),function(U,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.TextMateTokenizationWorker=void 0;class C{constructor(t,r){this.createData=r,this._models=Object.create(null),this._grammarCache=[],this._host=t.host;const u=r.grammarDefinitions.map(a=>({location:w.URI.revive(a.location),language:a.language,scopeName:a.scopeName,embeddedLanguages:a.embeddedLanguages,tokenTypes:a.tokenTypes,injectTo:a.injectTo,balancedBracketSelectors:a.balancedBracketSelectors,unbalancedBracketSelectors:a.unbalancedBracketSelectors,sourceExtensionId:a.sourceExtensionId}));this._grammarFactory=this._loadTMGrammarFactory(u)}async _loadTMGrammarFactory(t){const r=this.createData.textmateMainUri,u=await new Promise((s,o)=>{U([r],s,o)}),a=await new Promise((s,o)=>{U([this.createData.onigurumaMainUri],s,o)}),g=await(await fetch(this.createData.onigurumaWASMUri)).arrayBuffer();await a.loadWASM(g);const i=Promise.resolve({createOnigScanner:s=>a.createOnigScanner(s),createOnigString:s=>a.createOnigString(s)});return new S.TMGrammarFactory({logTrace:s=>{},logError:(s,o)=>console.error(s,o),readFile:s=>this._host.readFile(s)},t,u,i)}acceptNewModel(t){const r=w.URI.revive(t.uri),u=r.toString();this._models[u]=new k.TextMateWorkerModel(r,t.lines,t.EOL,t.versionId,this,t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength)}acceptModelChanged(t,r){this._models[t].onEvents(r)}retokenize(t,r,u){this._models[t].retokenize(r,u)}acceptModelLanguageChanged(t,r,u){this._models[t].onLanguageId(r,u)}acceptRemovedModel(t){this._models[t]&&(this._models[t].dispose(),delete this._models[t])}async acceptTheme(t,r){(await this._grammarFactory)?.setTheme(t,r)}acceptMaxTokenizationLineLength(t,r){this._models[t].acceptMaxTokenizationLineLength(r)}async getOrCreateGrammar(t,r){const u=await this._grammarFactory;return u?(this._grammarCache[r]||(this._grammarCache[r]=u.createGrammar(t,r)),this._grammarCache[r]):Promise.resolve(null)}setTokensAndStates(t,r,u,a){this._host.setTokensAndStates(t,r,u,a)}reportTokenizationTime(t,r,u,a){this._host.reportTokenizationTime(t,r,u,a)}}e.TextMateTokenizationWorker=C;function n(h,t){return new C(h,t)}e.create=n})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9d3b0fa210fb4535589e8296483a5b43fe5e660a/core/vs/workbench/services/textMate/browser/worker/textMate.worker.js.map
